# tune.awk
# adds some special compiling rules to the 'Makefile' generated 
# by the 'Configure' script

BEGIN { FS="\n"; RS=""; 
HIGHOPT = "-Chopt";
INL0 = "-pi"; 
INL1 = "-pi exp=dcopy,zcopy expin=util.f,blas_tuned_NECSX.f";
INL2 = "-pi exp=dscal,dcopy,zcopy expin=blas_tuned_NECSX.f";
INL3 = "-pi exp=ylmr,dscal,curv2,zcopy expin=ylmr.f,blas_tuned_NECSX.f,fitpack.f";
INL4 = "-pi exp=dcopy,zcopy expin=blas_tuned_NECSX.f";
INL5 = "-pi nest=3 exp=snhcsh";
INL6 = "-pi noauto exp=ddot,zdscal,drot expin=blas_tuned_NECSX.f";
INL7 = "-pi exp=calc_angle,xyrot,rmrot";
INL8 = "-pi rexp=xc expin=functionals.f";
INL9 = "-pi rexp=gcxc,gc_lsd expin=functionals.f,lsd_func.f";
INLA = "-pi rexp=curv2,curvd expin=fitpack.f"
}

$2 ~ /^atomwf.o:/ { rule = "$(FC) $(FFLAGS) " INL1 " $<";
                    depfile = "$(SRC)/blas_tuned_NECSX.f $(SRC)/util.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$1 ~ /^blas_tuned_NECSX.f:/ {
		    next
	          }
$2 ~ /^cofor.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^copot.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^dqvan2.o:/  { rule = "$(FC) $(FFLAGS) " INLA " $<";
                    depfile = "$(SRC)/fitpack.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^dynamical_mat_p.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^eind_loc.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^ffsum.o:/  { rule = "$(FC) $(FFLAGS) " INLA " " HIGHOPT " $<";
                    depfile = "$(SRC)/fitpack.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^fft.o:/  { rule = "$(FC) $(FFLAGS) " INL1 " $<";
                    depfile = "$(SRC)/blas_tuned_NECSX.f $(SRC)/util.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^ffts.o:/  { rule = "$(FC) $(FFLAGS) " INL1 " $<";
                    depfile = "$(SRC)/blas_tuned_NECSX.f $(SRC)/util.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^fftsg.o:/  { rule = "$(FC) $(FFLAGS) " INL1 " $<";
                    depfile = "$(SRC)/blas_tuned_NECSX.f $(SRC)/util.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^fitpack.o:/  { rule = "$(FC) $(FFLAGS) " INL5 " $<";
                    depfile = ""
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^gcener.o:/  { rule = "$(FC) $(FFLAGS) " INL9 " $<";
                    depfile = "$(SRC)/functionals.f $(SRC)/lsd_func.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^genxc.o:/  { rule = "$(FC) $(FFLAGS) " INL8 " $<";
                    depfile = "$(SRC)/functionals.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^htrstr.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^jrotation.o:/  { rule = "$(FC) $(FFLAGS) " INL7 " $<";
                    depfile = ""
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^mltfft.o:/  { rule = "$(FC) $(FFLAGS) " INL2 " $<";
                     depfile = "$(SRC)/blas_tuned_NECSX.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^opeigr.o:/  { rule = "$(FC) $(FFLAGS) " INL4 " $<";
                    depfile = "$(SRC)/blas_tuned_NECSX.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^potfor.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^prowfn.o:/  { rule = "$(FC) $(FFLAGS) " INL6 " $<";
                    depfile = "$(SRC)/blas_tuned_NECSX.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^rhov.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^rnlfor.o:/  { rule = "$(FC) $(FFLAGS) " INL6 " $<";
                    depfile = "$(SRC)/blas_tuned_NECSX.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^sd_loc2.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^setbasis.o:/  { rule = "$(FC) $(FFLAGS) " INL3 " $<";
                    depfile = "$(SRC)/blas_tuned_NECSX.f $(SRC)/fitpack.f $(SRC)/ylmr.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^td_force.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^vofrhot.o:/  { rule = "$(FC) $(FFLAGS) " HIGHOPT " $<";
                    printf "%s\n\t\t\t%s\n",$0,rule;
		    next
	          }
$2 ~ /^vpsi.o:/  { rule = "$(FC) $(FFLAGS) " INL4 " $<";
                    depfile = "$(SRC)/blas_tuned_NECSX.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^xcener.o:/  { rule = "$(FC) $(FFLAGS) " INL8 " $<";
                    depfile = "$(SRC)/functionals.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }
$2 ~ /^xcstr.o:/  { rule = "$(FC) $(FFLAGS) " INL8 " $<";
                     depfile = "$(SRC)/functionals.f"
                    printf "%s %s\n\t\t\t%s\n",$0,depfile,rule;
		    next
	          }

{ print $0 }

END { printf"blas_tuned_NECSX.f:   $(SRC)/blas_tuned_NECSX.F\n"; 
      printf"\t\trm -f $@\n";
      printf"\t\t$(CPP) $(CPPFLAGS) $(SRC)/$(@:.f=.F) $(DEST)/$@\n"
    }
