C     ==================================================================
      SUBROUTINE AAINIT(LLi)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'aavan.inc'
      INCLUDE 'cnst.inc'
C     ==--------------------------------------------------------------==
C     NLX= COMBINED ANGULAR MOMENTUM FOR LLi
C     (FOR S,P AND D STATES NLX=9)
C     LX = MAX 2*LLi-1
C     25 = COMBINED ANGULAR MOMENTUM FOR 2*LLi-1 (FOR S,P AND D STATES)
C     LiX= MAX LLi
C     ==--------------------------------------------------------------==
C     Arguments
      INTEGER    LLi
C     Variables
      REAL*8     CC(LiX,MiX,LiX,MiX,LX),
     &           Y,F,T,S,FS,SS,FTS,TS
      COMPLEX*16 AA(LX,MX,LiX,MiX,LiX,MiX),U(LX,MX,MX),SUM
      INTEGER    P,LL,L,Li,Mi,Lj,Mj,LP,M,K,N,NP,MP,IK,IL,II,
     &           MPP,ILP,LENGTH
C     ==--------------------------------------------------------------==
C     ARRAY AA
C     
C     CC = < LM | LiMi | LjMj > = sqrt(2L+1/4pi) (-1)^Mj c^L(Li-Mi,LjMj)
C     
C     COEFF. c^L FROM WEISSBLUTH 'ATOMS AND MOLEC..'  PAGE 246
C     CC(Li,Mi,Lj,Mj,L)  L  IS FREE INDEX, M=Mj+Mj   (INPUT LiMi LjMj)
C     ==--------------------------------------------------------------==
      LL=2*LLi-1
      IF(LLi.GT.LiX) CALL STOPGM(' AAINIT ',' LLi .GT. LiX ')
C     ==--------------------------------------------------------------==
      LENGTH=LiX*MiX*LiX*MiX*LX
      CALL AZZERO(CC,LENGTH)
                                !  LiMi  LjMj   -   LM
      CC(1,1,1,1,1)= 1.D0       !   s     s     -   s
      
      IF(LLi.GT.1) THEN
        CC(1,1,2,1,2)= 1.D0     !   s    p_-1   -  p_-1
        CC(1,1,2,2,2)= 1.D0     !   s    p_0    -  p_0
        CC(1,1,2,3,2)= 1.D0     !   s    p_1    -  p_1
        
        CC(2,1,2,1,3)= DSQRT(6.D0/5.D0) !  p_-1  p_-1   -  d_-2
        CC(2,1,2,2,3)= DSQRT(3.D0/5.D0) !  p_-1  p_0    -  d_-1
        CC(2,1,2,3,1)=-1.D0        !  p_-1  p_1    -   s
        CC(2,1,2,3,3)= DSQRT(1.D0/5.D0) !  p_-1  p_1    -  d_0
        CC(2,2,2,2,1)= 1.D0        !  p_0   p_0    -   s
        CC(2,2,2,2,3)= DSQRT(4.D0/5.D0) !  p_0   p_0    -  d_0
        CC(2,2,2,3,3)= DSQRT(3.D0/5.D0) !  p_0   p_1    -  d_1
        CC(2,3,2,3,3)= DSQRT(6.D0/5.D0) !  p_1   p_1    -  d_2
      ENDIF
      
      IF(LLi.GT.2) THEN
        CC(1,1,3,1,3)= 1.D0     !   s    d_-2   -  d_-2
        CC(1,1,3,2,3)= 1.D0     !   s    d_-1   -  d_-1
        CC(1,1,3,3,3)= 1.D0     !   s    d_0    -  d_0
        CC(1,1,3,4,3)= 1.D0     !   s    d_1    -  d_1
        CC(1,1,3,5,3)= 1.D0     !   s    d_2    -  d_2
        
        CC(2,1,3,1,4)= DSQRT(45.D0/35.D0) !  p_-1  d_-2  -  f_-3
        CC(2,1,3,2,4)= DSQRT(30.D0/35.D0) !  p_-1  d_-1  -  f_-2
        CC(2,1,3,3,2)=-DSQRT( 1.D0/ 5.D0) !  p_-1  d_0   -  p_-1
        CC(2,1,3,3,4)= DSQRT(18.D0/35.D0) !  p_-1  d_0   -  f_-1
        CC(2,1,3,4,2)=-DSQRT( 3.D0/ 5.D0) !  p_-1  d_1   -  p_0
        CC(2,1,3,4,4)= DSQRT( 9.D0/35.D0) !  p_-1  d_1   -  f_0
        CC(2,1,3,5,2)=-DSQRT( 6.D0/ 5.D0) !  p_-1  d_2   -  p_1
        CC(2,1,3,5,4)= DSQRT( 3.D0/35.D0) !  p_-1  d_2   -  f_1
        CC(2,2,3,1,4)= DSQRT(15.D0/35.D0) !  p_0   d_-2  -  f_-2
        CC(2,2,3,2,2)= DSQRT( 3.D0/ 5.D0) !  p_0   d_-1  -  p_-1
        CC(2,2,3,2,4)= DSQRT(24.D0/35.D0) !  p_0   d_-1  -  f_-1
        CC(2,2,3,3,2)= DSQRT( 4.D0/ 5.D0) !  p_0   d_0   -  p_0
        CC(2,2,3,3,4)= DSQRT(27.D0/35.D0) !  p_0   d_0   -  f_0
        CC(2,2,3,4,2)= DSQRT( 3.D0/ 5.D0) !  p_0   d_1   -  p_1
        CC(2,2,3,4,4)= DSQRT(24.D0/35.D0) !  p_0   d_1   -  f_1
        CC(2,2,3,5,4)= DSQRT(15.D0/35.D0) !  p_0   d_2   -  f_2
        CC(2,3,3,1,2)=-DSQRT( 6.D0/ 5.D0) !  p_1   d_-2  -  p_-1
        CC(2,3,3,1,4)= DSQRT( 3.D0/35.D0) !  p_1   d_-2  -  f_-1
        CC(2,3,3,2,2)=-DSQRT( 3.D0/ 5.D0) !  p_1   d_-1  -  p_0
        CC(2,3,3,2,4)= DSQRT( 9.D0/35.D0) !  p_1   d_-1  -  f_0
        CC(2,3,3,3,2)=-DSQRT( 1.D0/ 5.D0) !  p_1   d_0   -  p_1
        CC(2,3,3,3,4)= DSQRT(18.D0/35.D0) !  p_1   d_0   -  f_1
        CC(2,3,3,4,4)= DSQRT(30.D0/35.D0) !  p_1   d_1   -  f_2
        CC(2,3,3,5,4)= DSQRT(45.D0/35.D0) !  p_1   d_2   -  f_3
        
        CC(3,1,3,1,5)= DSQRT(70.D0/49.D0) !  d_-2  d_-2  -  g_-4
        CC(3,1,3,2,5)= DSQRT(35.D0/49.D0) !  d_-2  d_-1  -  g_-3
        CC(3,1,3,3,3)=-DSQRT(20.D0/49.D0) !  d_-2  d_0   -  d_-2
        CC(3,1,3,3,5)= DSQRT(15.D0/49.D0) !  d_-2  d_0   -  g_-2
        CC(3,1,3,4,3)=-DSQRT(30.D0/49.D0) !  d_-2  d_1   -  d_1
        CC(3,1,3,4,5)= DSQRT( 5.D0/49.D0) !  d_-2  d_1   -  g_1
        CC(3,1,3,5,1)= 1.D0               !  d_-2  d_2   -  s
        CC(3,1,3,5,3)=-DSQRT(20.D0/49.D0) !  d_-2  d_2   -  d_0
        CC(3,1,3,5,5)= DSQRT( 1.D0/49.D0) !  d_-2  d_2   -  g_0
        
        CC(3,2,3,2,3)= DSQRT(30.D0/49.D0) !  d_-1  d_-1  -  d_-2
        CC(3,2,3,2,5)= DSQRT(40.D0/49.D0) !  d_-1  d_-1  -  g_-2
        CC(3,2,3,3,3)= DSQRT( 5.D0/49.D0) !  d_-1  d_0   -  d_-1
        CC(3,2,3,3,5)= DSQRT(30.D0/49.D0) !  d_-1  d_0   -  g_-1
        CC(3,2,3,4,1)=-1.D0               !  d_-1  d_1   -  s
        CC(3,2,3,4,3)=-DSQRT( 5.D0/49.D0) !  d_-1  d_1   -  d_0
        CC(3,2,3,4,5)= DSQRT(16.D0/49.D0) !  d_-1  d_1   -  g_0
        CC(3,2,3,5,3)=-DSQRT(30.D0/49.D0) !  d_-1  d_2   -  d_1
        CC(3,2,3,5,5)= DSQRT( 5.D0/49.D0) !  d_-1  d_2   -  g_1
        
        CC(3,3,3,3,1)= 1.D0               !  d_0   d_0   -  s
        CC(3,3,3,3,3)= DSQRT(20.D0/49.D0) !  d_0   d_0   -  d_0
        CC(3,3,3,3,5)= DSQRT(36.D0/49.D0) !  d_0   d_0   -  g_0
        CC(3,3,3,4,3)= DSQRT( 5.D0/49.D0) !  d_0   d_1   -  d_1
        CC(3,3,3,4,5)= DSQRT(30.D0/49.D0) !  d_0   d_1   -  g_1
        CC(3,3,3,5,3)=-DSQRT(20.D0/49.D0) !  d_0   d_2   -  d_2
        CC(3,3,3,5,5)= DSQRT(15.D0/49.D0) !  d_0   d_2   -  g_2
        
        CC(3,4,3,4,3)= DSQRT(30.D0/49.D0) !  d_1   d_1   -  d_2
        CC(3,4,3,4,5)= DSQRT(40.D0/49.D0) !  d_1   d_1   -  g_2
        CC(3,4,3,5,5)= DSQRT(35.D0/49.D0) !  d_1   d_2   -  g_3
        
        CC(3,5,3,5,5)= DSQRT(70.D0/49.D0) !  d_2   d_2   -  g_4
      ENDIF
C     ==--------------------------------------------------------------==
      DO L=1,LL
        DO Li=1,LLi
          DO Mi=1,2*Li-1     !  SYMMETRY   LiMi  <-> LjMj
            DO Lj=1,Li-1
              DO Mj=1,2*Lj-1
                CC(Li,Mi,Lj,Mj,L)=CC(Lj,Mj,Li,Mi,L)
              ENDDO
            ENDDO
            DO Mj=1,Mi-1
              CC(Li,Mi,Li,Mj,L)=CC(Li,Mj,Li,Mi,L) ! Li = Lj
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      CALL DSCAL(LENGTH,SQRT(1.D0/FPI),CC,1)
C     ==--------------------------------------------------------------==
C     TRANSFORM BETWEEN REAL SPHERICAL HARMONICS AND THE ORIGINAL ONES
C     (  Y^R_lm = Sum_n U(l,m,n) Y_ln )
C     
C     U(l,m,n)  see  Weissbluth  pages 128 - 130
C     errors of Weissbluth have been corrected:
C     1.)   i/2 has been changed to i/4 for u(4,6,*)
C     2.)  -i/4 has been changed to i/4 for u(5,8,*)
C     ==--------------------------------------------------------------==
#ifdef _BGL 
      CALL AZZERO(U,2*LX*MX*MX)
#else
      CALL ZAZZERO(U,LX*MX*MX)
#endif
      U(1,1,1)=DCMPLX(1.D0,0.D0) ! L = 0
      
      IF(LLI.GT.1) THEN
        Y=1.D0/SQRT(2.D0)
        U(2,1,1)=DCMPLX(Y,0.D0)    ! L = 1    ORDERING   X   Z   Y
        U(2,1,3)=DCMPLX(-Y,0.D0)   !              M     -1   0   1
        U(2,2,2)=DCMPLX(1.D0,0.D0) !              M      1   2   3
        U(2,3,1)=DCMPLX(0.D0,Y)
        U(2,3,3)=DCMPLX(0.D0,Y)
        
        U(3,1,1)=DCMPLX(0.D0,Y)   ! L = 2
        U(3,1,5)=DCMPLX(0.D0,-Y)  ! ORDERING  XY   XZ  Z^2  YZ  X^2-Y^2
        U(3,2,2)=DCMPLX(Y,0.D0)   !    M      -2   -1   0    1     2
        U(3,2,4)=DCMPLX(-Y,0.D0)  !    M       1    2   3    4     5
        U(3,3,3)=DCMPLX(1.D0,0.D0)
        U(3,4,2)=DCMPLX(0.D0,Y)
        U(3,4,4)=DCMPLX(0.D0,Y)
        U(3,5,1)=DCMPLX(Y,0.D0)
        U(3,5,5)=DCMPLX(Y,0.D0)
      ENDIF
      
      IF(LLI.GT.2) THEN
        F=SQRT(5.D0)/4.D0
        T=SQRT(3.D0)/4.D0
        U(4,1,1)=DCMPLX(F,0.D0)  ! L = 3
        U(4,1,3)=DCMPLX(-T,0.D0) ! ORDER
        U(4,1,5)=DCMPLX(T,0.D0)  ! X  Y  XYZ  Z  Z(X^2-Y^2) Y(Z^2-X^2) X(Y^2-Z^2)
        U(4,1,7)=DCMPLX(-F,0.D0) ! 1  2   3   4       5          6          7
        U(4,2,1)=DCMPLX(0.D0,-F)
        U(4,2,3)=DCMPLX(0.D0,-T)
        U(4,2,5)=DCMPLX(0.D0,-T)
        U(4,2,7)=DCMPLX(0.D0,-F)
        U(4,3,2)=DCMPLX(0.D0, Y)
        U(4,3,6)=DCMPLX(0.D0,-Y)
        U(4,4,4)=DCMPLX(1.D0,0.D0)
        U(4,5,2)=DCMPLX(Y,0.D0)
        U(4,5,6)=DCMPLX(Y,0.D0)
        U(4,6,1)=DCMPLX(0.D0,-T) !MISSPRINT IN WEISSBLUTH (PAGE 129)
        U(4,6,3)=DCMPLX(0.D0, F) !MISSPRINT IN WEISSBLUTH (PAGE 129)
        U(4,6,5)=DCMPLX(0.D0, F) !MISSPRINT IN WEISSBLUTH (PAGE 129)
        U(4,6,7)=DCMPLX(0.D0,-T) !MISSPRINT IN WEISSBLUTH (PAGE 129)
        U(4,7,1)=DCMPLX(-T,0.D0)
        U(4,7,3)=DCMPLX(-F,0.D0)
        U(4,7,5)=DCMPLX( F,0.D0)
        U(4,7,7)=DCMPLX( T,0.D0)
        
        S  =SQRT( 7.D0     )/4.0D0
        FS =SQRT( 5.D0/6.D0)/2.0D0
        SS =SQRT( 7.D0/6.D0)/2.0D0
        FTS=SQRT(14.D0/6.D0)/2.0D0
        TS =SQRT(10.D0/6.D0)/2.0D0
        U(5,1,1)=DCMPLX(FS,0.D0) ! L = 4
        U(5,1,5)=DCMPLX(FTS,0.D0)
        U(5,1,9)=DCMPLX(FS,0.D0)
        U(5,2,2)=DCMPLX(0.D0,-0.25D0)
        U(5,2,4)=DCMPLX(0.D0,-S)
        U(5,2,6)=DCMPLX(0.D0,-S)
        U(5,2,8)=DCMPLX(0.D0,-0.25D0)
        U(5,3,2)=DCMPLX(-0.25D0,0.D0)
        U(5,3,4)=DCMPLX( S,0.D0)
        U(5,3,6)=DCMPLX(-S,0.D0)
        U(5,3,8)=DCMPLX( 0.25D0,0.D0)
        U(5,4,3)=DCMPLX(-Y,0.D0)
        U(5,4,7)=DCMPLX(-Y,0.D0)
        U(5,5,1)=DCMPLX(0.D0, Y)
        U(5,5,9)=DCMPLX(0.D0,-Y)
        U(5,6,3)=DCMPLX(0.D0, Y)
        U(5,6,7)=DCMPLX(0.D0,-Y)
        U(5,7,2)=DCMPLX(-S,0.D0)
        U(5,7,4)=DCMPLX(-0.25D0,0.D0)
        U(5,7,6)=DCMPLX( 0.25D0,0.D0)
        U(5,7,8)=DCMPLX( S,0.D0)
        U(5,8,2)=DCMPLX(0.D0, S)      !MISSPRINT IN WEISSBLUTH (PAGE 129)
        U(5,8,4)=DCMPLX(0.D0,-0.25D0) !MISSPRINT IN WEISSBLUTH (PAGE 129)
        U(5,8,6)=DCMPLX(0.D0,-0.25D0) !MISSPRINT IN WEISSBLUTH (PAGE 129)
        U(5,8,8)=DCMPLX(0.D0, S)      !MISSPRINT IN WEISSBLUTH (PAGE 129)
        U(5,9,1)=DCMPLX(-SS,0.D0)
        U(5,9,5)=DCMPLX( TS,0.D0)
        U(5,9,9)=DCMPLX(-SS,0.D0)
      ENDIF
C     ==--------------------------------------------------------------==
#ifdef _BGL 
      CALL AZZERO(AA,2*LIX*MIX*LIX*MIX*LX*MX)
#else
      CALL ZAZZERO(AA,LIX*MIX*LIX*MIX*LX*MX)
#endif
      DO LP=1,LL
        DO L=1,LLI
          DO M=1,(2*L-1)
            DO K=1,LLI
              DO N=1,(2*K-1)
                DO NP=1,(2*K-1)
                  DO P=1,(2*L-1)
                    MP=(P-L)+(NP-K)+LP !  M' = P + N'
                    IF((MP.GE.1).AND.(MP.LE.(2*LP-1))) THEN
                      AA(LP,MP,L,M,K,N)=AA(LP,MP,L,M,K,N)+
     +                     U(L,M,P)*U(K,N,NP)*CC(L,P,K,NP,LP)
                    ENDIF
                  ENDDO
                ENDDO
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      DO IK=1,NLX
        DO IL=1,NLX
          DO II=1,MX
            LPL(IL,IK,II)=0
          ENDDO
          LPX(IL,IK)=0
        ENDDO
      ENDDO
      DO LP=1,LL
        DO MP=1,(2*LP-1)
          DO L=1,LLI
            DO M=1,(2*L-1)        
              DO K=1,LLI
                DO N=1,(2*K-1)
                  SUM=DCMPLX(0.D0,0.D0)
                  DO MPP=1,(2*LP-1)
                    SUM = SUM + DCONJG(U(LP,MP,MPP))*AA(LP,MPP,L,M,K,N)
                  ENDDO
                  IF(ABS(SUM).GT.0.001D0) THEN
                    IL =(L-1)*(L-1)+M
                    IK =(K-1)*(K-1)+N
                    ILP=(LP-1)*(LP-1)+MP
                    IF(ABS(DIMAG(SUM)).GT.0.001D0) THEN
                      WRITE(6,'(A,2F8.5,1X,3I3)')
     &                     ' !!!  ERROR  !!!   AP(ILP,IL,IK) =  ',
     &                     SUM,ILP,IL,IK
                      CALL STOPGM('AAINIT',' ')
                    ENDIF
                    AP(ILP,IL,IK)=DREAL(SUM)
                    LPX(IL,IK)=LPX(IL,IK)+1
                    LPL(IL,IK,LPX(IL,IK))=ILP
                  ENDIF
                ENDDO
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
