C     ==================================================================
      SUBROUTINE AINITWF(C0,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == ATOMIC WAVEFUNCTIONS AS INITIAL GUESS FOR ADDITIONAL STATES  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'atwf.inc'        !CATOM ZXMAT XXMAT
      INCLUDE 'spin.inc'        !NLSD NLSX
      INCLUDE 'kpts.inc'        !TKPNT
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGWK,*),PSI(*)
      REAL*8     RHOE(NNR1,*),SCR(*),TAU0(*),FION(*)
C     Variables
      COMPLEX*16 CX(NGWK,*)
      POINTER    (IP_CX,CX)
      DIMENSION  CATOM(NGWK,*)
      REAL*8     XMATAT(NATTOT,*),EIVAT(*),
     &           WORKAT(*)
      POINTER    (IP_XMATAT,XMATAT),(IP_EIVAT,EIVAT),
     &           (IP_WORKAT,WORKAT)
      INTEGER    ISUB,MSGLEN,I,II,IOPT
      LOGICAL    HASRANDS,QUERYRANDS,DEBUG,TLSD2
      COMPLEX*16 CSCR(*)
      POINTER    (IP_CSCR,CSCR)
C     ==--------------------------------------------------------------==
      TLSD2 = TLSD
      IF(NSTATE.EQ.0) RETURN
      IF(TKPNT) RETURN
      IF(TIVAN) RETURN
      IF(TTAU) RETURN
      IF(TLSE) RETURN
      IF(.NOT.HASRANDS()) RETURN
      CALL TISET('   AINITWF',ISUB)
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
C     Phase factors
      CALL PHFAC(TAU0)
C     Set up catom
      CALL MEMORY(IP_CATOM,2*NGWK*MAX(NSTATE,NATTOT),'CATOM')
      CALL ATRHO(RHOE,PSI,SCR,LSCR,NSTATE)
C     Orthogonalize atomic wavefunctions
      IF (TDMAL) THEN
         IF (TKPNT) CALL STOPGM('AINITWF','DISTRIBUTED INITIALIZATION '
     &                          // 'NOT AVAILABLE WITH K-POINTS')
         CALL MEMORY(IP_CSCR,2*NGWK*MAX(NSTATE,NATTOT),'CSCR')
         CALL ZAZZERO(CSCR,MAX(NATTOT,NSTATE)*NGWK)
         CALL ORTHO(NATTOT, CATOM(1,1), CSCR(1), SCR, LSCR)
         CALL FREEM(IP_CSCR)
      ENDIF
C     local potential
      CALL RSCPOT(C0,TAU0,FION,RHOE,PSI,SCR,LSCR,.FALSE.,.FALSE.,
     &            NSTATE,1)
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_CX,2*NGWK*NUMAORMAX,'CX')
      IF (.NOT.TDMAL) THEN
         CALL MEMORY(IP_XXMAT,NATTOT*NATTOT,'XXMAT')
         CALL MEMORY(IP_XSMAT,NATTOT*NATTOT,'XSMAT')
      ENDIF
C     ==--------------------------------------------------------------==
      IF (TDMAL) THEN
         CALL DIST_KSMAT(CX,RHOE,PSI,SCR,LSCR,NSTATE,1,C0,
     &              MIN(NSTATE,NATTOT),TLSD2,.TRUE.)
         GOTO 100
      ENDIF
      IF(TLSD) THEN
        TLSD=.FALSE.
C       alpha spin
        CALL KSMAT(CX,RHOE(1,1),PSI,SCR,LSCR,NSUP,1)
        CALL OVLAP(NATTOT,XSMAT,CATOM,CATOM)
        CALL SUMMAT(XXMAT,NATTOT,SCR,LSCR)
        CALL SUMMAT(XSMAT,NATTOT,SCR,LSCR)
        CALL SCRSET(SCR,LSCR,DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_XMATAT,NATTOT*NATTOT,'XMATAT',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_WORKAT,10*NATTOT,'WORKAT',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_EIVAT,NATTOT,'EIVAT',DEBUG)
        IF(PARENT) THEN
          IOPT=1
          CALL DSYGVX(IOPT,XXMAT,NATTOT,XSMAT,NATTOT,EIVAT,
     &                XMATAT,NATTOT,NATTOT,WORKAT,10*NATTOT)
        ENDIF
        MSGLEN = NATTOT*NATTOT * 8
        CALL MY_BCAST(XMATAT,MSGLEN,SOURCE,ALLGRP)
        DO I=1,NSUP
          IF(QUERYRANDS(I)) THEN
            IF(NGWK.GT.0) THEN
              CALL DGEMV('N',2*NGWK,NATTOT,1.0D0,CATOM(1,1),
     *               2*NGWK,XMATAT(1,I),1,0.0D0,C0(1,I),1)
            ENDIF
            CALL GS_ORTHO(C0(1,1),I-1,C0(1,I),1,WORKAT,EIVAT)
          ENDIF
        ENDDO
        CALL SCRREL(SCR,LSCR,DEBUG)
C       beta spin
        CALL KSMAT(CX,RHOE(1,2),PSI,SCR,LSCR,NSTATE,1)
        CALL OVLAP(NATTOT,XSMAT,CATOM,CATOM)
        CALL SUMMAT(XXMAT,NATTOT,SCR,LSCR)
        CALL SUMMAT(XSMAT,NATTOT,SCR,LSCR)
        CALL SCRSET(SCR,LSCR,DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_XMATAT,NATTOT*NATTOT,'XMATAT',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_WORKAT,10*NATTOT,'WORKAT',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_EIVAT,NATTOT,'EIVAT',DEBUG)
        IF(PARENT) THEN
          IOPT=1
          CALL DSYGVX(IOPT,XXMAT,NATTOT,XSMAT,NATTOT,EIVAT,
     &                XMATAT,NATTOT,NATTOT,WORKAT,10*NATTOT)
        ENDIF
        MSGLEN = NATTOT*NATTOT * 8
        CALL MY_BCAST(XMATAT,MSGLEN,SOURCE,ALLGRP)
        DO I=NSUP+1,NSTATE
          IF(QUERYRANDS(I)) THEN
            II=I-NSUP
            IF(NGWK.GT.0) THEN
              CALL DGEMV('N',2*NGWK,NATTOT,1.0D0,CATOM(1,1),
     *               2*NGWK,XMATAT(1,II),1,0.0D0,C0(1,I),1)
            ENDIF
            CALL GS_ORTHO(C0(1,NSUP+1),II-1,C0(1,I),1,WORKAT,EIVAT)
          ENDIF
        ENDDO
        CALL SCRREL(SCR,LSCR,DEBUG)
        TLSD=.TRUE.
      ELSE
        CALL KSMAT(CX,RHOE,PSI,SCR,LSCR,NSTATE,1)
        CALL OVLAP(NATTOT,XSMAT,CATOM,CATOM)
        CALL SUMMAT(XXMAT,NATTOT,SCR,LSCR)
        CALL SUMMAT(XSMAT,NATTOT,SCR,LSCR)
        CALL SCRSET(SCR,LSCR,DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_XMATAT,NATTOT*NATTOT,'XMATAT',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_WORKAT,10*NATTOT,'WORKAT',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_EIVAT,NATTOT,'EIVAT',DEBUG)
        IF(PARENT) THEN
          IOPT=1
          CALL DSYGVX(IOPT,XXMAT,NATTOT,XSMAT,NATTOT,EIVAT,
     &                XMATAT,NATTOT,NATTOT,WORKAT,10*NATTOT)
        ENDIF
        MSGLEN = NATTOT*NATTOT * 8
        CALL MY_BCAST(XMATAT,MSGLEN,SOURCE,ALLGRP)
        DO I=1,NSTATE
          IF(QUERYRANDS(I)) THEN
            CALL DGEMV('N',2*NGWK,NATTOT,1.0D0,CATOM(1,1),
     *             2*NGWK,XMATAT(1,I),1,0.0D0,C0(1,I),1)
            CALL GS_ORTHO(C0(1,1),I-1,C0(1,I),1,WORKAT,EIVAT)
          ENDIF
        ENDDO
        CALL SCRREL(SCR,LSCR,DEBUG)
      ENDIF
100   CONTINUE
C     ==--------------------------------------------------------------==
      IF (.NOT.TDMAL) THEN
        CALL FREEM(IP_XSMAT)
        CALL FREEM(IP_XXMAT)
      ENDIF
      CALL FREEM(IP_CATOM)
      CALL FREEM(IP_CX)
C     ==--------------------------------------------------------------==
      CALL TIHALT('   AINITWF',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_AINITWF(LAINITWF,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atwf.inc'
C     Arguments
      INTEGER   LAINITWF,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LRSCPOT,LKSMAT,LSUMMAT,LATRHO
C     ==--------------------------------------------------------------==
      LAINITWF=NATTOT*NATTOT+3*NATTOT+NATTOT
      CALL GIVE_SCR_ATRHO(LATRHO,TAG)
      CALL GIVE_SCR_RSCPOT(LRSCPOT,TAG,.FALSE.)
      CALL GIVE_SCR_KSMAT(LKSMAT,TAG)
      CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NATTOT)
      LAINITWF=MAX(LAINITWF,LRSCPOT,LKSMAT,LSUMMAT,LATRHO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
