C     ==================================================================
      SUBROUTINE ANDERSON(XMIX,IT,RHOINM,RHOUTM,RHOIN0,RHOUT0,RHOINP,
     &                    NNR1,THL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER IT,NNR1
      REAL*8  XMIX,THL,CTHL,CXMIX,
     &        RHOINM(NNR1),RHOUTM(NNR1),RHOIN0(NNR1),
     &        RHOUT0(NNR1),RHOINP(NNR1)
C     Variables
      REAL*8  SN,SD,RL,RL1,DR
      INTEGER I
C     ==--------------------------------------------------------------==
C     == GENERATE NEXT ITERATION USING D. G. ANDERSONS METHOD         ==
C     == (FROM HAMANN)                                                ==
C     ==--------------------------------------------------------------==
      THL=0.D0
      IF(IT .GT. 1) THEN
        SN=0.D0
        SD=0.D0
!$OMP parallel do private(I,RL,RL1,DR)
!$OMP+ reduction(+:SN,SD)
        DO I=1,NNR1
          RL=RHOUT0(I)-RHOIN0(I)
          RL1=RHOUTM(I)-RHOINM(I)
          DR=RL-RL1
          SN=SN + RL*DR
          SD=SD + DR*DR
        ENDDO
#ifdef PARALLEL
        CALL GLOSUM(1,SN)
        CALL GLOSUM(1,SD)
#endif
        THL=SN/SD
        IF(DABS(SD).LT.0.5D0*DABS(SN)) THEN ! Troubles if |THL| > 2 !
          THL=0.D0 ! use simple mixing due to serious convergence probems
        ENDIF
      ENDIF
      CTHL =1.0D0-THL
      CXMIX=1.0D0-XMIX
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I) shared(XMIX,CXMIX,THL,CTHL)
      DO I=1,NNR1
            RHOINP(I)=CXMIX*(CTHL*RHOIN0(I)  +
     &                        THL*RHOINM(I)) +
     &                 XMIX*(CTHL*RHOUT0(I)  +
     &                        THL*RHOUTM(I))
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CHANGE_XMIX(XMIX,DRHOMAX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'andr.inc'
C     Arguments
      REAL*8 XMIX,DRHOMAX
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
      IF(NTABMIX.EQ.1) RETURN
      XMIX=ANDMIX(1)
      DO I=1,NTABMIX
        IF(DRHOMAX.LT.DENSMIX(I)) THEN
          XMIX=ANDMIX(I)
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
