C     ==================================================================
      SUBROUTINE ATOMC(RHOE,PSI,TAU0,ACHRG)
C     ==--------------------------------------------------------------==
C     == COMPUTES ATOMIC CHARGES BY INTEGRATION WITH WEIGHT FUNCTIONS ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'qspl.inc'
C     Arguments
      REAL*8    RHOE(NNR1),PSI(NNR1),TAU0(3,NAX,NSX),ACHRG(NAT)
C     Variables
      DIMENSION ATRG(MMAXX,*)
      REAL*8    DATOM(NSPLPO,2),ARHO(MMAXX),WORK(MMAXX)
      POINTER   (IP_DATOM,DATOM),(IP_ARHO,ARHO),(IP_WORK,WORK)
      INTEGER   ISUB,IS,ISH,L,MMAX,IA,IAT,
     &          IFIRST
      REAL*8    RCUT,CHRG
      SAVE      IFIRST,IP_DATOM
      DATA      IFIRST /0/
C     ==--------------------------------------------------------------==
      CALL TISET('     ATOMC',ISUB)
C..initialization
      IF(IFIRST.EQ.0) THEN
        NATTOT=0
        DO IS=1,NSP
          NUMAOR(IS)=0
          DO ISH=1,NSHELL(IS)
            L=LSHELL(ISH,IS)
            NATTOT=NATTOT+NA(IS)*(2*L+1)
            NUMAOR(IS)=NUMAOR(IS)+(2*L+1)
          ENDDO
        ENDDO
        CALL MEMORY(IP_DATOM,2*NSPLPO,'DATOM')
        IFIRST=1
      ENDIF
C     ==--------------------------------------------------------------==
C     Allocation of local variables
      CALL MEMORY(IP_ARHO,MMAXX,'ARHO')
      CALL MEMORY(IP_WORK,MMAXX,'WORK')
C     ==--------------------------------------------------------------==
      CALL AZZERO(PSI,NNR1)
c..sum all partition functions in psi
      DO IS=1,NSP
        CALL ATDENS_NEW(IS,DATOM,MMAX,RCUT,ARHO,WORK)
        DO IA=1,NA(IS)
          CALL PUTRHO(PSI,TAU0(1,IA,IS),ATRG(1,IS),DATOM,
     *                MMAX,RCUT,1.D0)
        ENDDO
      ENDDO
c..charge integration
      IAT=0
      DO IS=1,NSP
        CALL ATDENS_NEW(IS,DATOM,MMAX,RCUT,ARHO,WORK)
        DO IA=1,NA(IS)
          IAT=IAT+1
          CALL GETCHG(RHOE,PSI,TAU0(1,IA,IS),ATRG(1,IS),DATOM,
     *                MMAX,RCUT,CHRG)
          ACHRG(IAT)=CHRG
        ENDDO
      ENDDO
      CALL GLOSUM(NAT,ACHRG)
      IAT=0
      CHRG=OMEGA/DBLE(NR1S*NR2S*NR3S)
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          ACHRG(IAT)=ZV(IS)-ACHRG(IAT)*CHRG
        ENDDO
      ENDDO
      CALL TIHALT('     ATOMC',ISUB)
C     ==--------------------------------------------------------------==
C     Deallocation of local variables
      CALL FREEM(IP_WORK)
      CALL FREEM(IP_ARHO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ATDENS_NEW(IS,DATOM,MMAX,RCUT,ARHO,WORK)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'cdft.inc'
C     Arguments
      INTEGER   IS,MMAX
      REAL*8    DATOM(NSPLPO,2),ARHO(MMAXX),WORK(MMAXX),RCUT
C     Variables
      DIMENSION ATRG(MMAXX,*),ATWFR(MMAXX,M1SHLX,*)
      INTEGER   ISH,IR,IERR
C     ==--------------------------------------------------------------==
      CALL AZZERO(ARHO,MMAXX)
      MMAX=MESHAT(IS)
C..Sum density

      DO ISH=1,NSHELL(IS)
        DO IR=1,MMAX
          ARHO(IR)=ARHO(IR)+
     *             OC(ISH,IS) * (ATWFR(IR,ISH,IS)/ATRG(IR,IS))**2
        ENDDO
      ENDDO
      MMAX=MIN(MMAX,NSPLPO)
!$OMP parallel do private(IR)
      DO IR=1,MMAX
        DATOM(IR,1)=ARHO(IR)/FPI
      ENDDO
      CALL CURV1(MMAX,ATRG(1,IS),DATOM(1,1),0.D0,0.D0,3,DATOM(1,2),
     *           WORK,0.D0,IERR)
      DO IR=1,MMAX
        IF(DATOM(IR,1).LT.1.D-6.AND.ATRG(IR,IS).GT.1.D0) THEN
!         IF(DATOM(IR,1).LT.1.D-14.AND.ATRG(IR,IS).GT.1.D0) THEN
          RCUT=ATRG(IR,IS)
          RHOCUT(IS)=DATOM(IR,1)
          GOTO 100
        ENDIF
      ENDDO
      RCUT=ATRG(MMAX,IS)
  100 CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PUTRHO(RHOE,TAU,RG,DATOM,MMAX,RCUT,CXSCAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'qspl.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'isos.inc'
C     Arguments
      INTEGER MMAX
      REAL*8  RHOE(KR1,KR2,*),TAU(*),RG(*),DATOM(NSPLPO,2),RCUT,CXSCAL
C     Variables
      REAL*8  SC1(3),SC2(3),XPTAU(3),DA1(3,3),
     &        X1,Y1,Z1,X,Y,Z,R,CURV2
      INTEGER NPTAU(3),MR(3),I,IORGX,IORGY,IORGZ,IGRID,IX,II,I1,J,JJ,
     &        J1,K,KK,K1
C     ==--------------------------------------------------------------==
C..Atom position
      X1=TAU(1)
      Y1=TAU(2)
      Z1=TAU(3)
      CALL PBC(X1,Y1,Z1,SC1(1),SC1(2),SC1(3),1,APBC,IBRAV)
      CALL DGEMV('T',3,3,1.D0,HTM1,3,SC1,1,0.D0,SC2,1)
      IF(SC2(1).LT.0.D0) SC2(1)=SC2(1)+1.0D0
      IF(SC2(2).LT.0.D0) SC2(2)=SC2(2)+1.0D0
      IF(SC2(3).LT.0.D0) SC2(3)=SC2(3)+1.0D0
      NPTAU(1)=NINT(SC2(1)*NR1S)+1
      NPTAU(2)=NINT(SC2(2)*NR2S)+1
      NPTAU(3)=NINT(SC2(3)*NR3S)+1
      SC1(1)=SC2(1)-DBLE(NPTAU(1)-1)/DBLE(NR1S)
      SC1(2)=SC2(2)-DBLE(NPTAU(2)-1)/DBLE(NR2S)
      SC1(3)=SC2(3)-DBLE(NPTAU(3)-1)/DBLE(NR3S)
      IF(NPTAU(1).GT.NR1S) NPTAU(1)=1
      IF(NPTAU(2).GT.NR2S) NPTAU(2)=1
      IF(NPTAU(3).GT.NR3S) NPTAU(3)=1
      CALL DGEMV('T',3,3,1.D0,HT,3,SC1,1,0.D0,XPTAU,1)
      DO I=1,3
        DA1(I,1)=A1(I)/DBLE(NR1S)
        DA1(I,2)=A2(I)/DBLE(NR2S)
        DA1(I,3)=A3(I)/DBLE(NR3S)
      ENDDO
C..Interaction region
      SC1(1)=RCUT
      SC1(2)=RCUT
      SC1(3)=RCUT
      CALL DGEMV('T',3,3,1.D0,HTM1,3,SC1,1,0.D0,SC2,1)
      MR(1)=NINT(SC2(1)*NR1S)+1
      MR(2)=NINT(SC2(2)*NR2S)+1
      MR(3)=NINT(SC2(3)*NR3S)+1
      MR(1)=MIN(MR(1),NR1S/2-1)
      MR(2)=MIN(MR(2),NR2S/2-1)
      MR(3)=MIN(MR(3),NR3S/2-1)

C..Origin of density grid
      IORGX=NPTAU(1)-MR(1)
      IORGY=NPTAU(2)-MR(2)
      IORGZ=NPTAU(3)-MR(3)
      IF(IORGX.LT.1) IORGX=IORGX+NR1S
      IF(IORGY.LT.1) IORGY=IORGY+NR2S
      IF(IORGZ.LT.1) IORGZ=IORGZ+NR3S
C..loop over all grid points
      IGRID=0
      DO I=0,2*MR(1)
        IX=IORGX+I
        IF(IX.GT.NR1S) IX=IX-NR1S
        IF(IX.GE.NRXPL(MEPOS,1).AND.IX.LE.NRXPL(MEPOS,2)) THEN
          II=IX-NRXPL(MEPOS,1)+1
          I1=MR(1)-I
          DO J=0,2*MR(2)
            JJ=IORGY+J
            IF(JJ.GT.NR2S) JJ=JJ-NR2S
            J1=MR(2)-J
            DO K=0,2*MR(3)
              KK=IORGZ+K
              IF(KK.GT.NR3S) KK=KK-NR3S
              K1=MR(3)-K
              CALL POSITX(X,Y,Z,I1,J1,K1,DA1,XPTAU(1))
              IF(TCLUST)THEN
                IF(X1-X.LT.A1(1).AND.Y1-Y.LT.A2(2).AND.Z1-Z.LT.A3(3)
     *           .AND.X1-X.GT.0.AND.Y1-Y.GT.0.AND.Z1-Z.GT.0)THEN
                R=DSQRT(X*X+Y*Y+Z*Z)
                IF(R.LT.RCUT) THEN
C..Add density to grid
                  IGRID=IGRID+1
                  RHOE(II,JJ,KK)=RHOE(II,JJ,KK)+
     *              CXSCAL*CURV2(R,MMAX,RG,DATOM(1,1),DATOM(1,2),0.D0)
                ENDIF
                ENDIF
              ELSE
                R=DSQRT(X*X+Y*Y+Z*Z)
                IF(R.LT.RCUT) THEN
C..Add density to grid
                  IGRID=IGRID+1
                  RHOE(II,JJ,KK)=RHOE(II,JJ,KK)+
     *              CXSCAL*CURV2(R,MMAX,RG,DATOM(1,1),DATOM(1,2),0.D0)
                ENDIF
              ENDIF
            ENDDO
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE POSITX(X,Y,Z,I,J,K,DA,XP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER I,J,K
      REAL*8  DA(3,3),XP(3),X,Y,Z
C     ==--------------------------------------------------------------==
      X=I*DA(1,1)+J*DA(1,2)+K*DA(1,3)+XP(1)
      Y=I*DA(2,1)+J*DA(2,2)+K*DA(2,3)+XP(2)
      Z=I*DA(3,1)+J*DA(3,2)+K*DA(3,3)+XP(3)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETCHG(RHOE,PSI,TAU,RG,DATOM,MMAX,RCUT,CHG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'qspl.inc'
      INCLUDE 'metr.inc'
C     Arguments
      INTEGER   MMAX
      REAL*8    RHOE(KR1,KR2,*),PSI(KR1,KR2,*),TAU(3),RG(*),
     &          DATOM(NSPLPO,2)
C     Variables
      REAL*8    SC1(3),SC2(3),DA1(3,3),XPTAU(3),X1,Y1,Z1,X,Y,Z,
     &          R,RCUT,CHG,CURV2
      INTEGER   NPTAU(3),MR(3),I,IORGX,IORGY,IORGZ,IGRID,IX,II,I1,J,JJ,
     &          J1,K,KK,K1
C     ==--------------------------------------------------------------==
C..Atom position
      X1=TAU(1)
      Y1=TAU(2)
      Z1=TAU(3)
      CALL PBC(X1,Y1,Z1,SC1(1),SC1(2),SC1(3),1,APBC,IBRAV)
      CALL DGEMV('T',3,3,1.D0,HTM1,3,SC1,1,0.D0,SC2,1)
      IF(SC2(1).LT.0.D0) SC2(1)=SC2(1)+1.0D0
      IF(SC2(2).LT.0.D0) SC2(2)=SC2(2)+1.0D0
      IF(SC2(3).LT.0.D0) SC2(3)=SC2(3)+1.0D0
      NPTAU(1)=NINT(SC2(1)*NR1S)+1
      NPTAU(2)=NINT(SC2(2)*NR2S)+1
      NPTAU(3)=NINT(SC2(3)*NR3S)+1
      SC1(1)=SC2(1)-DBLE(NPTAU(1)-1)/DBLE(NR1S)
      SC1(2)=SC2(2)-DBLE(NPTAU(2)-1)/DBLE(NR2S)
      SC1(3)=SC2(3)-DBLE(NPTAU(3)-1)/DBLE(NR3S)
      IF(NPTAU(1).GT.NR1S) NPTAU(1)=1
      IF(NPTAU(2).GT.NR2S) NPTAU(2)=1
      IF(NPTAU(3).GT.NR3S) NPTAU(3)=1
      CALL DGEMV('T',3,3,1.D0,HT,3,SC1,1,0.D0,XPTAU,1)
      DO I=1,3
        DA1(I,1)=A1(I)/DBLE(NR1S)
        DA1(I,2)=A2(I)/DBLE(NR2S)
        DA1(I,3)=A3(I)/DBLE(NR3S)
      ENDDO
C..Interaction region
      SC1(1)=RCUT
      SC1(2)=RCUT
      SC1(3)=RCUT
      CALL DGEMV('T',3,3,1.D0,HTM1,3,SC1,1,0.D0,SC2,1)
      MR(1)=NINT(SC2(1)*NR1S)+1
      MR(2)=NINT(SC2(2)*NR2S)+1
      MR(3)=NINT(SC2(3)*NR3S)+1
      MR(1)=MIN(MR(1),NR1S/2-1)
      MR(2)=MIN(MR(2),NR2S/2-1)
      MR(3)=MIN(MR(3),NR3S/2-1)
C..Origin of density grid
      IORGX=NPTAU(1)-MR(1)
      IORGY=NPTAU(2)-MR(2)
      IORGZ=NPTAU(3)-MR(3)
      IF(IORGX.LT.1) IORGX=IORGX+NR1S
      IF(IORGY.LT.1) IORGY=IORGY+NR2S
      IF(IORGZ.LT.1) IORGZ=IORGZ+NR3S
C..loop over all grid points
      CHG=0.0D0
      IGRID=0
      DO I=0,2*MR(1)
        IX=IORGX+I
        IF(IX.GT.NR1S) IX=IX-NR1S
        IF(IX.GE.NRXPL(MEPOS,1).AND.IX.LE.NRXPL(MEPOS,2)) THEN
          II=IX-NRXPL(MEPOS,1)+1
          I1=MR(1)-I
          DO J=0,2*MR(2)
            JJ=IORGY+J
            IF(JJ.GT.NR2S) JJ=JJ-NR2S
            J1=MR(2)-J
            DO K=0,2*MR(3)
              KK=IORGZ+K
              IF(KK.GT.NR3S) KK=KK-NR3S
              K1=MR(3)-K
              CALL POSITX(X,Y,Z,I1,J1,K1,DA1,XPTAU(1))
              R=DSQRT(X*X+Y*Y+Z*Z)
              IF(R.LT.RCUT.AND.PSI(II,JJ,KK).NE.0.0D0) THEN
                IGRID=IGRID+1
                CHG=CHG+RHOE(II,JJ,KK)/PSI(II,JJ,KK)*
     *                  CURV2(R,MMAX,RG,DATOM(1,1),DATOM(1,2),0.D0)
              ENDIF
            ENDDO
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
