C     ==================================================================
      SUBROUTINE ATRHO(RHOE,PSI,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE NORMALIZED ELECTRON DENSITY RHOE IN REAL SPACE          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'spin.inc'        !NLSD
      INCLUDE 'elct.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      INTEGER    LSCR,NSTATE
      COMPLEX*16 PSI(*)
      REAL*8     RHOE(*),SCR(*)
C     Variables
      DIMENSION  GGNH(NSPLPO),CATOM(NGW,NATTOT)
      COMPLEX*16 RHOG(NHG)
      REAL*8     DATOM(NSPLPO,2),ARHO(MMAXX),WORK(NSPLPO)
      POINTER    (IP_RHOG,RHOG),
     &           (IP_DATOM,DATOM),(IP_ARHO,ARHO),(IP_WORK,WORK)
      CHARACTER  TAG*30,FORM*8
      COMPLEX*16 TSFAC
      REAL*8     FNL(*),DFNL(*)
      REAL*8     FOC(20),VOL,AR,CURV2,RSUM,SFC,RSUM1,RDUM
      INTEGER    ISUB,IS,ISA0,IG,IA,ISA,IR,IAORB,IAT,IXX,IFORM,
     &           NATST,LATRHO,IL_RHOG,IL_DATOM
      REAL*8     DOTP
      EXTERNAL   DOTP
      LOGICAL    DEBUG
C     ==--------------------------------------------------------------==
      CALL TISET('     ATRHO',ISUB)
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
C     SCR partition
      CALL GIVE_SCR_ATRHO(LATRHO,TAG)
      CALL TEST_SCR('ATRHO',TAG,LSCR,LATRHO)
      CALL SCRSET(SCR,LSCR,DEBUG)
      IL_RHOG =2*NHG
      IL_DATOM=2*NSPLPO
      CALL SCRPTR(SCR,LSCR,IP_RHOG,IL_RHOG,'RHOG',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_DATOM,IL_DATOM,'DATOM',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_ARHO,MMAXX,'ARHO',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_WORK,NSPLPO,'WORK',DEBUG)
C     ==--------------------------------------------------------------==
C     ==  INITIALIZE                                                  ==
C     ==--------------------------------------------------------------==
      VOL=1.D0/OMEGA
#ifdef _BGL  
      CALL AZZERO(RHOG,2*NHG)
#else
      CALL ZAZZERO(RHOG,NHG)
#endif
      ISA0=0
      NATSAVE=0
      DO IS=1,NSP
        CALL ATDENS(IS,DATOM,ARHO,WORK)
#if defined(__VECTOR)
!$OMP parallel do private(IG,IA,ISA,TSFAC,AR) shared(NSPLPO)
#else
!$OMP parallel do private(IG,IA,ISA,TSFAC,AR) shared(NSPLPO) 
!$OMP+ schedule(static)
#endif
#ifdef __SR8000
*poption parallel, tlocal(IG,IA,ISA,TSFAC,AR)
#endif 
#ifdef CRAYX1
!dir$ preferstream
!dir$ nointerchange
#endif

        DO IG=1,NHG
          TSFAC=DCMPLX(0.D0,0.D0)
#ifdef CRAYX1
!dir$ prefervector
#endif
          DO IA=1,NA(IS)
            ISA=ISA0+IA
            TSFAC=TSFAC+EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *              EI3(ISA,INYH(3,IG))
          ENDDO
          AR=CURV2(HG(IG),NSPLPO,GGNH(1),DATOM(1,1),DATOM(1,2),0.D0)
          RHOG(IG)=RHOG(IG) + AR*VOL*TSFAC
        ENDDO
        ISA0=ISA0+NA(IS)
      ENDDO
#ifdef _BGL  
      CALL AZZERO(PSI,2*MAXFFT)
#else
      CALL ZAZZERO(PSI,MAXFFT)
#endif
!CDIR NODEP
#if defined(__VECTOR)
!$OMP parallel do private(IG)
#else
!$OMP parallel do private(IG) schedule(static)
#endif
#ifdef __SR8000
*poption parallel, tlocal(IG)
#endif 
#ifdef CRAYX1
!DIR$ CONCURRENT
#endif
#ifdef _BGL  
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
      DO IG=1,NHG
        PSI(INDZ(IG)) = DCONJG(RHOG(IG))
        PSI(NZH(IG))  = RHOG(IG)
      ENDDO
      IF(GEQ0) PSI(NZH(1)) = RHOG(1)
      RSUM = 0.0D0
      IF(GEQ0) RSUM        = DREAL(RHOG(1))
      CALL INVFFT(PSI)
C     ==--------------------------------------------------------------==
C     COMPUTE THE INTEGRAL OF THE CHARGE DENSITY IN REAL SPACE
      RSUM1=0.D0
#ifdef _BGL  
      CALL ALIGNX(16,RHOE(1))
!IBM* INDEPENDENT ,  REDUCTION(RSUM1)
#endif
#if defined(__VECTOR)
C$OMP parallel do private(IR,RDUM) reduction(+:RSUM1)
#else
C$OMP parallel do private(IR,RDUM) reduction(+:RSUM1) schedule(static)
#endif
      DO IR=1,NNR1
        RDUM = DREAL(PSI(IR))
        RHOE(IR)= RDUM
        RSUM1   = RSUM1 + RDUM
      ENDDO
      RSUM1=RSUM1*OMEGA/DBLE(NR1S*NR2S*NR3S)
C     ==--------------------------------------------------------------==
      IAORB=1
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          CALL LOADC(CATOM(1,IAORB),FOC,NGW,NGW,NATTOT-IAORB+1,
     *               IS,IAT,NATST)
          DO IXX=IAORB,IAORB+NATST-1
            SFC=DOTP(NGW,CATOM(1,IXX),CATOM(1,IXX))
            CALL GLOSUM(1,SFC)
            IF(SFC.EQ.0.D0) THEN
              WRITE(6,'(A,A,I5,A)') ' ATRHO|',
     &             ' THE NORM OF ATOMIC ORBITAL (',IXX,') IS NULL'
              CALL STOPGM('ATRHO','WRONG ATOMIC ORBITAL')
            ELSE
              SFC=1.D0/SQRT(SFC)
            ENDIF
            CALL DSCAL(2*NGW,SFC,CATOM(1,IXX),1)
          ENDDO
          IAORB=IAORB+NATST
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
C     COMPUTE THE INTEGRAL OF THE CHARGE DENSITY IN G-SPACE and R-SPACE
C     ACROSS ALL PROCESSORS
      RSUM = 0.0D0
      IF(GEQ0) RSUM = DREAL(RHOG(1)*OMEGA)
      CALL GLOSUM(1,RSUM)
      CALL GLOSUM(1,RSUM1)
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        IF((NATTOT*NLSD).LT.NSTATE) THEN
          IFORM=INT(LOG10(DBLE(MAX(NATTOT*NLSD,1))))+1
          WRITE(FORM,'("(A,I",I1,",A)")') IFORM
          WRITE(6,FORM)
     &       ' ATRHO| WARNING! THE NUMBER OF GENERATED ATOMIC STATE ('
     &       ,NATTOT*NLSD,')'
          IFORM=INT(LOG10(DBLE(MAX(NSTATE,1))))+1
          WRITE(FORM,'("(A,I",I1,",A)")') IFORM
          WRITE(6,FORM)
     &         ' ATRHO| WARNING! IS LESS THAN THE NUMBER OF STATE (',
     &       NSTATE,')'
          WRITE(6,'(A,I5,A)') '  ATRHO| WARNING! ',
     &         NSTATE-NATTOT*NLSD,' STATES ARE EQUAL TO ZERO'
          WRITE(6,'(A,I5,A)')
     &         ' ATRHO| USE SECTION BASIS TO SPECIFY ATOMIC BASIS'
        ENDIF
        WRITE(6,'(A,F12.6,A,F12.6)')
     &       ' ATRHO| CHARGE(R-SPACE):',RSUM1,'      (G-SPACE):',RSUM
      ENDIF
C
      CALL SCRREL(SCR,LSCR,DEBUG)
      CALL TIHALT('     ATRHO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ATDENS(IS,DATOM,ARHO,WORK)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'qspl.inc'
C     Arguments
      INTEGER   IS
      REAL*8    DATOM(NSPLPO,*),ARHO(*),WORK(*)
C     Variables
      DIMENSION ATRG(MMAXX,*),ATWFR(MMAXX,M1SHLX,*),GGNH(*),
     *          ATCHG(*)
      REAL*8    XG,TMP,FAC,OCCU,CURRCHARGE
      INTEGER   MMAX,MUSED,ISH,IR,IL,IERR
C     ==--------------------------------------------------------------==
      CALL AZZERO(ARHO,MMAXX)
      MMAX=MESHAT(IS)
C     Sum density
      CURRCHARGE=ATCHG(IS)
      DO ISH=NSHELL(IS),1,-1
        IF(CURRCHARGE.GT.OC(ISH,IS)) THEN
          OCCU=0
          CURRCHARGE=CURRCHARGE-OC(ISH,IS)
        ELSE
          OCCU=OC(ISH,IS)-CURRCHARGE
          CURRCHARGE=0
        ENDIF
#if defined(__VECTOR)
!$OMP parallel do private(IR)
#else
!$OMP parallel do private(IR) schedule(static)
#endif
#ifdef __SR8000
*poption parallel, tlocal(IR)
#endif 
        DO IR=1,MMAX
          ARHO(IR)=ARHO(IR)+
     *             OCCU * (ATWFR(IR,ISH,IS)/ATRG(IR,IS))**2
        ENDDO
      ENDDO
      XG=0.D0
      DO IR=MMAX,1,-1
        XG=XG+ABS(ARHO(IR))
        IF(XG.GT.1.D-8) THEN
          MUSED = IR
          GOTO 100
        ENDIF
      ENDDO
      MUSED=MMAX
 100  CONTINUE
C     FFT
      CALL AZZERO(DATOM,NSPLPO)
!$OMP parallel do private(IL,XG,TMP) shared(MUSED)
#ifdef __SR8000
*poption parallel, tlocal(IL,XG,TMP)
#endif 
      DO IL=NSPLPA,NSPLPE
        XG=SQRT(GGNH(IL))*TPIBA
        CALL BESSOV(ATRG(1,IS),CLOGAT(IS),MUSED,ARHO,0,XG,
     *                  ATRG(MUSED,IS),TMP)
        DATOM(IL,1)=TMP
      ENDDO
      CALL GLOSUM(NSPLPO,DATOM)
      CALL BESSOV(ATRG(1,IS),CLOGAT(IS),MUSED,ARHO,0,0.0D0,
     *                  ATRG(MUSED,IS),TMP)
      IF(TMP.LT.1.D-3) THEN
        FAC=0.D0
      ELSE
        FAC=(ZV(IS)-ATCHG(IS))/TMP
      ENDIF
      CALL DSCAL(NSPLPO,FAC,DATOM(1,1),1)
C     Spline
      CALL CURV1(NSPLPO,GGNH,DATOM(1,1),0.D0,0.D0,3,DATOM(1,2),
     *           WORK,0.D0,IERR)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_ATRHO(LATRHO,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG MMAXX
      INCLUDE 'qspl.inc'        !NSPLPO
C     Arguments
      INTEGER   LATRHO
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LATRHO=2*NHG+2*NSPLPO+MMAXX+NSPLPO+100 !RHOG DATOM ARHO WORK 
      TAG  ='2*NHG+3*NSPLPO+2*MMAXX'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
