C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == INCLUDE FILE FOR GENERATION OF INITIAL ATOMIC WAVEFUNCTION   ==
C     == (ATOMWF,ATRHO,SETBASIS,...)                                  ==
C     ==--------------------------------------------------------------==
C     == NSHELL(MAXSP)         Number of shell n per species          ==
C     == LSHELL(M1SHLX,MAXSP)  Number of orbital per species          ==
C     == NUMAOR(MAXSP)         Number of  orbitals per species        ==
C     == NBCUT                 0:WFN cutoff  1:DENSITY cutoff         ==
C     ==================================================================
      INTEGER     M1SHLX,M1SPLI
      PARAMETER   (M1SHLX=20,M1SPLI=256)
C     ==--------------------------------------------------------------==
C     == M1SHL                                                        ==
C     == NATTOT                Total number of  orbitals              ==
C     == NUMAORMAX             Maximum of NUMAOR(MAXSP)               ==
C     ==--------------------------------------------------------------==
      INTEGER     M1SHL,NATTOT,NUMAORMAX
      COMMON/ATWP/M1SHL,NATTOT,NUMAORMAX
C     ==--------------------------------------------------------------==
C     == OC(M1SHLX,MAXSP)                                             ==
C     == STOEXP(M1SHLX,MAXSP)                                         ==
C     == NQSTO(M1SHLX,MAXSP)                                          ==
C     == LSHELL(M1SHLX,MAXSP)                                         ==
C     == NUMAOR(MAXSP)                                                ==
C     == NDSHELL(MAXSP)                                               ==
C     == NBCUT                                                        ==
C     ==--------------------------------------------------------------==
      REAL*8      OC(M1SHLX,MAXSP),STOEXP(M1SHLX,MAXSP)
      INTEGER     NQSTO(M1SHLX,MAXSP),
     &            NSHELL(MAXSP),LSHELL(M1SHLX,MAXSP),
     &            NUMAOR(MAXSP),NDSHELL(MAXSP),NBCUT
      COMMON/ATWF/OC,STOEXP,
     &            NQSTO,NSHELL,LSHELL,NUMAOR,NDSHELL,NBCUT
C     ==--------------------------------------------------------------==
C     == CAT                                                          ==
C     == XXMAT(NATTOT,NATTOT)                                         ==
C     == XSMAT(NATTOT,NATTOT)                                         ==
C     == DBAS                                                         ==
C     == CATOM                                                        ==
C     == ZXMAT(NATTOT,NATTOT)                                         ==
C     == ZSMAT(NATTOT,NATTOT)                                         ==
C     ==--------------------------------------------------------------==
      REAL*8      CAT,XXMAT(NATTOT,*),XSMAT(NATTOT,*),DBAS
      POINTER     (IP_CAT,CAT),
     &            (IP_XXMAT,XXMAT),(IP_XSMAT,XSMAT),(IP_DBAS,DBAS)
      COMPLEX*16  CATOM,ZXMAT(NATTOT,*),ZSMAT(NATTOT,*)
      POINTER     (IP_CATOM,CATOM),
     &            (IP_ZXMAT,ZXMAT),(IP_ZSMAT,ZSMAT)
      COMMON/ATWF_IP/IP_CAT,IP_XXMAT,IP_XSMAT,IP_DBAS,
     &            IP_CATOM,IP_ZXMAT,IP_ZSMAT
C     ==--------------------------------------------------------------==
C     == MESHAT                                                       ==
C     == CLOGAT                                                       ==
C     == ATRG                                                         ==
C     == ATWFR                                                        ==
C     == ATCHG(NSX) Atomic charge                                     ==
C     ==--------------------------------------------------------------==
      INTEGER     MESHAT(MAXSP),MESH_EPR(MAXSP)
      REAL*8      CLOGAT(MAXSP),ATRG,ATWFR,ATCHG,ATRG_EPR,ATWFR_EPR
      POINTER     (IP_ATRG,ATRG),(IP_ATWFR,ATWFR),(IP_ATCHG,ATCHG),
     &            (IP_ATRG_EPR,ATRG_EPR), (IP_ATWFR_EPR,ATWFR_EPR)
      COMMON/ATWR/MESHAT,MESH_EPR,CLOGAT,IP_ATRG_EPR,IP_ATWFR_EPR
      COMMON/ATWR_IP/IP_ATRG,IP_ATWFR,IP_ATCHG
C     ==--------------------------------------------------------------==
C     == DMOVRMIX Parameter for MOVERHO (mixing when density moves)   ==
C     == TMOVR    .TRUE. uses MOVERHO to move density when moving     ==
C     ==          atoms (projects density to atomic orbital basis set)==
C     ==--------------------------------------------------------------==
      REAL*8      DMOVRMIX
      LOGICAL     TMOVR
      COMMON/MOVR/DMOVRMIX,TMOVR 
C     ==--------------------------------------------------------------==
C     == QMMM
C     ==--------------------------------------------------------------==
!      real*8,pointer :: ARHO_save(:,:)
C     real*8 ARHO_save
!      common/c_atrho/ARHO_save
!      real*8 dr_RHO
!      common/c_atrho_r/dr_RHO
!      integer NGR_RHO
!      common/c_atrho_i/NGR_RHO
C     ==================================================================
C      CDFT
C     ------------------------------------------------------------------
      REAL*8      OCUN(M1SHLX,MAXSP),OC2(M1SHLX,MAXSP)
      LOGICAL     OCSET
      COMMON/CDFTOC/OCUN,OC2
      COMMON/CDFTOCL/OCSET
C     == CATORD(M1SHLX,NAX)  Order of atomic orbital shells in CAT ==
      INTEGER CATORD(M1SHLX,NAX)
      INTEGER    NATSAVE
      POINTER (IP_CATORD,CATORD)
      COMMON/PRIMAOCOM/IP_CATORD,NATSAVE
C     ==================================================================
