#if defined(__SR11000)
*option OPT(O(ss))
#endif
C     ==================================================================
C     AZZERO(A,N) -> A(I)=0 I=1..N for AC     
C     ==================================================================
#if defined(__HP) || defined(CRAYX1)
C     ==--------------------------------------------------------------==
C     do nothing, special routine in sysdepend.c
C     CRAY : do nothing, special routine in azzero_mod.F
C     ==--------------------------------------------------------------==
#elif defined(__IBMNEW)
C     ==--------------------------------------------------------------==
      subroutine azzero(zero,n)
C     ==--------------------------------------------------------------==
      real*8 zero(n)
      integer i,j,ii
      integer lzero,l1reste,lend
C     ==--------------------------------------------------------------==
      l1zero=loc(zero(1))
      if(n.lt.32) then
        do i=1,n
        zero(i)=0.d0
        enddo
        return
      endif
      if(mod(l1zero,8).ne.0) call stopgm('AZZERO','NOT 8-BYTE ALIGNED')
      l1reste=(128-mod(l1zero,128))/8
      lend=n-mod(n-l1reste,16)
      do i=1,l1reste
       zero(i)=0.d0
      enddo
      do i=1+l1reste,lend,16
!ibm* cache_zero(zero(i))
      enddo
      do i=1+lend,n
        zero(i)=0.d0
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==--------------------------------------------------------------==
#elif defined(_BGL)  && !(defined(_BGP))
C     ==--------------------------------------------------------------==
      subroutine azzero(zero,n)
C     ==--------------------------------------------------------------==
      real*8 zero(n)
      integer i,j,ii
      integer lzero,l1reste,lend
C     ==--------------------------------------------------------------==
      l1zero=loc(zero(1))
      if(n.lt.32) then
        do i=1,n
        zero(i)=0.d0
        enddo
        return
      endif
      if (mod(l1zero,8).ne.0) stop 'AZZERO - WRONG ALIGNEMENT'
      l1reste=(32-mod(l1zero,32))/8
      lend=n-mod(n-l1reste,4)
      do i=1,l1reste
       zero(i)=0.d0
      enddo
      do i=1+l1reste,lend,4
!ibm* cache_zero(zero(i))
      enddo
      do i=1+lend,n
      zero(i)=0.d0
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==--------------------------------------------------------------==
#elif defined(__VECTOR)
C     ==--------------------------------------------------------------==
      SUBROUTINE AZZERO(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      REAL*8 A(N)
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
!$OMP parallel do private (I)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
      DO I=1,N
        A(I)=0.0D0
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
#else
C     ==--------------------------------------------------------------==
      SUBROUTINE AZZERO(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      REAL*8 A(N)
C     Variables
      INTEGER I,II
C     ==--------------------------------------------------------------==
      II=MOD(N,4)
!$OMP parallel do private(I)
      DO I=1,II
        A(I)=0.0D0
      ENDDO
!$OMP parallel do private(I)
      DO I=1+II,N,4
        A(I)  =0.0D0
        A(I+1)=0.0D0
        A(I+2)=0.0D0
        A(I+3)=0.0D0
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
#endif
C     ==================================================================
C     ZAZZERO(A,N) -> A(I)=0 I=1..N for A complex*16
C     ==================================================================
#if defined(__HP) || defined(CRAYX1)
C     ==--------------------------------------------------------------==
C     do nothing, special routine in sysdepend.c
C     CRAY : do nothing, special routine in azzero_mod.F
C     ==--------------------------------------------------------------==
#elif defined(__VECTOR)
      SUBROUTINE ZAZZERO(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      COMPLEX*16 A(N)
C     Variables
      INTEGER I
      COMPLEX*16 ZZERO
      PARAMETER  (ZZERO=(0.D0,0.D0))
C     ==--------------------------------------------------------------==
!$OMP parallel do private (I)
      DO I=1,N
        A(I)=ZZERO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
#elif defined(__IBMNEW)
      SUBROUTINE ZAZZERO(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      COMPLEX*16 A(N)
C     Variables
      INTEGER NN
C     ==--------------------------------------------------------------==
      NN=2*N
      CALL AZZERO(A,NN)
      RETURN
      END
#else
      SUBROUTINE ZAZZERO(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      COMPLEX*16 A(N)
C     Variables
      INTEGER I,II
      COMPLEX*16 ZZERO
      PARAMETER  (ZZERO=(0.D0,0.D0))
C     ==--------------------------------------------------------------==
      II=MOD(N,4)
      DO I=1,II
        A(I)=ZZERO
      ENDDO
!$OMP parallel do private(I)
      DO I=1+II,N,4
        A(I)  =ZZERO
        A(I+1)=ZZERO
        A(I+2)=ZZERO
        A(I+3)=ZZERO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
#endif
C     ==================================================================
C     IAZZERO(IA,N) -> IA(I)=0 I=1..N for IA default integer
C     ==================================================================
#if defined(CRAYX1)
C     ==--------------------------------------------------------------==
C     CRAY : do nothing, special routine in azzero_mod.F
C     ==--------------------------------------------------------------==
#else
C     ==--------------------------------------------------------------==
      SUBROUTINE IAZZERO(IA,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      INTEGER IA(N)
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I)
      DO I=1,N
        IA(I)=0
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
#if ! defined(__NOINT8)
C     ==================================================================
C     I8AZZERO(IA,N) -> IA(I)=0 I=1..N for IA integer*8
C     ==================================================================
      SUBROUTINE I8AZZERO(IA,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      INTEGER*8 IA(N)
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I)
      DO I=1,N
        IA(I)=0
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
#else
C     ==================================================================
C     I8AZZERO(IA,N) -> IA(I)=0 I=1..N for IA integer*8 for __NOINT8
C     ==================================================================
      SUBROUTINE I8AZZERO(IA,N)
      IMPLICIT NONE
C     Arguments
      INTEGER N,I
      INTEGER IA(2*N)
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I)
      DO I=1,2*N
        IA(I)=0
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
#endif
#endif
      SUBROUTINE Idonotdoanything
      implicit none
      print *,"I'm only used to keep the fortran file from being empty"
      END
