C     ================================================================
      SUBROUTINE BOGOL(C0,C2,SC0,WE,FOCC,
     &     RHOE,PSI,SCR,LSCR,NSTATE,BOGO)
C     ==------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'tauf.inc'
      INCLUDE 'spin.inc'        !NLSD
C     Arguments
      INTEGER    LSCR,NSTATE
      COMPLEX*16 C0(NGWK,NSTATE,*),C2(NGWK,*),SC0(*),PSI(*)
      REAL*8     WE(NSTATE,*),FOCC(NSTATE,*),RHOE(NNR1,*),SCR(*),BOGO
C     Variables
      DIMENSION  WK(*)
      CHARACTER  TAG*30
      REAL*8     TAU(*),VTAU(*)
      INTEGER    KBEG,KEND,KINC,IKPT,NKPOINT,IKK,IKIND,I,LBOGOL,IB
      REAL*8     DOTP,DDOT
      EXTERNAL   DOTP,DDOT
C     ==------------------------------------------------------------==
      CALL GIVE_SCR_BOGOL(LBOGOL,TAG,NSTATE)
      CALL TEST_SCR('BOGOL',TAG,LSCR,LBOGOL)
      BOGO = 0.D0
      CALL INQ_SWAP(KBEG,KEND,KINC)
      DO IKPT=KBEG,KEND,KINC
        NKPOINT=NKPBL(IKPT)
        IF(TKBLOCK)CALL RKPT_SWAP(C0,NSTATE,IKPT,
     &       'HGKP HGKM MASKGW EIGKR TWNL C0')
        DO IKIND=1,NKPOINT
          IKK=KPBEG(IKPT)+IKIND
          IF(TLSD) THEN
C.. alpha spin
            CALL HPSI(C0(1,1,IKIND),C2,SC0,
     &           RHOE(1,1),PSI,SCR,LSCR,NSUP,IKIND,1)
            DO I=1,NSUP
              IF(TKPNT) THEN
                SCR(I)=-DDOT(2*NGWK,C0(1,I,IKIND),1,C2(1,I),1)
              ELSE
                SCR(I)=-DOTP(NGW,C0(1,I,IKIND),C2(1,I))
              ENDIF
            ENDDO
#ifdef PARALLEL
            CALL GLOSUM(NSUP,SCR)
#endif
            DO I=1,NSUP
              BOGO=BOGO+WK(IKK)*FOCC(I,IKK)*(SCR(I)-WE(I,IKK))
            ENDDO
C.. beta spin
C           use correct tau-potential
            ITAUR=2
            IB=NSUP
            CALL HPSI(C0(1,IB+1,IKIND),C2(1,IB+1),SC0,
     &           RHOE(1,2),PSI,SCR,LSCR,NSDOWN,IKIND,1)
            ITAUR=1
            DO I=1,NSDOWN
              IF(TKPNT) THEN
                SCR(I)=-DDOT(2*NGWK,C0(1,IB+I,IKIND),1,C2(1,IB+I),1)
              ELSE
                SCR(I)=-DOTP(NGW,C0(1,IB+I,IKIND),C2(1,IB+I))
              ENDIF
            ENDDO
#ifdef PARALLEL
            CALL GLOSUM(NSDOWN,SCR)
#endif
            DO I=1,NSDOWN
              BOGO=BOGO+WK(IKK)*FOCC(IB+I,IKK)*(SCR(I)-WE(IB+I,IKK))
            ENDDO
          ELSE
            CALL HPSI(C0(1,1,IKIND),C2,SC0,
     &         RHOE,PSI,SCR,LSCR,NSTATE,IKIND,NLSD)
            DO I=1,NSTATE
              IF(TKPNT) THEN
                SCR(I)=-DDOT(2*NGWK,C0(1,I,IKIND),1,C2(1,I),1)
              ELSE
                SCR(I)=-DOTP(NGW,C0(1,I,IKIND),C2(1,I))
              ENDIF
            ENDDO
#ifdef PARALLEL
            CALL GLOSUM(NSTATE,SCR)
#endif    
            DO I=1,NSTATE
              BOGO=BOGO+WK(IKK)*FOCC(I,IKK)*(SCR(I)-WE(I,IKK))
            ENDDO
          ENDIF
        ENDDO
      ENDDO
C     ==------------------------------------------------------------==
      RETURN
      END
C     ================================================================
      SUBROUTINE GIVE_SCR_BOGOL(LBOGOL,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   LBOGOL,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LHPSI
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_HPSI(LHPSI,TAG,NSTATE)
      LBOGOL=MAX(NSTATE,LHPSI)
      TAG='MAX(NSTATE,'//TAG(1:19)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
