C     ==================================================================
      SUBROUTINE BS_WFO(C0,C2,SC0,PME,GDE,VPP,EIGV)
C CB: Manages wf optimization with BROKEN SYMMETRY option      
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'bsym.inc'
      INCLUDE 'bsympnt.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'store.inc'
C     QMMM
      INCLUDE 'mm_dim.inc'
C     Arguments
      COMPLEX*16 C0(NGW,N,*),C2(NGW,*),SC0(*),PME(*),GDE(*)
      REAL*8     VPP(*),EIGV(N,*)
C     Variables
      REAL*8     ETOTBS,ETOTHS,ETOTLS,COUPLJ,JWN
      INTEGER    BSNMR,IREC(100)
      LOGICAL    BSCONV,HSCONV,BSCYCLE
      LOGICAL    STATUSDUMMY,oldstatus
C     ==--------------------------------------------------------------==
C     Format for for BS messages
111   FORMAT (/,T2,A,/)
!     If QMMM, change to MM dimensions
      call mm_dim(mm_go_mm,oldstatus)
!
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_FNBS,3*NAX*NSX,'FNBS')
      CALL AZZERO(TAUP,3*NAX*NSX)
      CALL AZZERO(VELP,3*NAX*NSX)
      CALL AZZERO(FNBS,3*NAX*NSX)
C     ==--------------------------------------------------------------==
      CALL WRITE_IREC(IREC)
      BSNMR=NOMORE
C CB: RWFOPT returns for every writing of RESTART
      NOMORE=MIN(ISTORE-1,BSNMR-1)
      BSNFI=0
C     ==--------------------------------------------------------------==
      RESTBS=.TRUE.
      IF(PARENT) WRITE(6,111)
     &     ' BS_WFO| CALCULATING BROKEN SYMMETRY STATE'
      CALL RWFOPT(C0,C2,SC0,PME,GDE,VPP,EIGV)
      BSNFI=BSNFI+NFI
      ETOTBS=ETOT
!
      IF(PARENT)CALL DCOPY(3*NAX*NSX,FION,1,FNBS,1)
      BSCONV=CONVWF
      IF (.NOT.BSCONV.AND.PARENT) THEN
        WRITE(6,111)'BS_WFO| UNCONVERGED BROKEN SYMMETRY STATE:'
        CALL FINALP(TAU0,FION,TAU0,EIGV)
      ENDIF
C     ==--------------------------------------------------------------==
      IF(RESTBS) RWF=.FALSE.
C CB: Second wave function (HS)
      BSCLCS=2
C CB: Setup occupation for HS state
      CALL SETBSSTATE
      IF(.NOT.EXSOFT) THEN
        NOMORE=MIN(ISTORE,BSNMR)-BSNFI
      else
        NOMORE=1
        IF(PARENT)
     &    WRITE(6,111)'BS_WFO| EXIT AFTER ONE MORE CYCLE'
      ENDIF
      IF(PARENT)WRITE(6,111)'BS_WFO| SWITCHING TO HIGH SPIN STATE'
      CALL RWFOPT(C0(1,1,2),C2,SC0,PME,GDE,VPP,EIGV(1,2))
      NOMORE=MIN(ISTORE,BSNMR)
      BSNFI=BSNFI+NFI
      ETOTHS=ETOT
      HSCONV=CONVWF
      IF (.NOT.HSCONV.AND.PARENT) THEN
        WRITE(6,111)'BS_WFO| UNCONVERGED HIGH SPIN STATE'
        CALL FINALP(TAU0,FION,TAU0,EIGV)
      ENDIF
C     ==--------------------------------------------------------------==
      IF(EXSOFT) THEN
        BSCONV=.TRUE.
        HSCONV=.TRUE.
      ENDIF
      CALL ZHWWF(2,IREC,C0,C2,N,EIGV,TAU0,VELP,TAUP,BSNFI)
      RESTART=.TRUE.
      RLATE=.TRUE.
      RWF=.TRUE.
C     ==--------------------------------------------------------------==
C CB: First wave function (HS)
      BSCLCS=1
C CB: Setup occupation for BS state
      CALL SETBSSTATE
      CONVWF=BSCONV
      BSCYCLE=.NOT.CONVWF.AND.(BSNFI.LT.BSNMR)
      DO WHILE(.NOT.CONVWF.AND.(BSNFI.LT.BSNMR))
        IF(PARENT)
     &    WRITE(6,111)'BS_WFO| REINITIALIZING BROKEN SYMMETRY STATE'

        CALL RWFOPT(C0,C2,SC0,PME,GDE,VPP,EIGV)
        BSNFI=BSNFI+NFI
        CALL ZHWWF(2,IREC,C0,C2,N,EIGV,TAU0,VELP,TAUP,BSNFI)
      END DO
      BSCONV=CONVWF
      IF(BSCYCLE) THEN
        ETOTBS=ETOT
        CALL DCOPY(3*NAX*NSX,FION,1,FNBS,1)
        IF(.NOT.BSCONV.AND.PARENT) THEN
          WRITE(6,111)'BS_WFO| UNCONVERGED BROKEN SYMMETRY STATE:'
          CALL FINALP(TAU0,FION,TAU0,EIGV)
        ENDIF
      ENDIF
      IF(EXSOFT) HSCONV=.TRUE.
C     ==--------------------------------------------------------------==
C CB: Second wave function (HS)
      BSCLCS=2
C CB: Setup occupation for HS state
      CALL SETBSSTATE
      CONVWF=HSCONV
      BSCYCLE=.NOT.CONVWF.AND.(BSNFI.LT.BSNMR)
      DO WHILE(.NOT.CONVWF.AND.(BSNFI.LT.BSNMR))
        IF(PARENT)
     &    WRITE(6,111)'BS_WFO| REINITIALZING HIGH SPIN STATE'
        CALL RWFOPT(C0(1,1,2),C2,SC0,PME,GDE,VPP,EIGV(1,2))
        BSNFI=BSNFI+NFI
        CALL ZHWWF(2,IREC,C0,C2,N,EIGV,TAU0,VELP,TAUP,BSNFI)
      END DO
      HSCONV=CONVWF
      IF(BSCYCLE) THEN
        ETOTHS=ETOT
        IF(.NOT.HSCONV.AND.PARENT) THEN
          WRITE(6,111)'BS_WFO| UNCONVERGED HIGH SPIN STATE:'
          CALL FINALP(TAU0,FION,TAU0,EIGV)
        ENDIF
      ENDIF
      IF(EXSOFT) BSCONV=.TRUE.
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        IF(.NOT.BSCONV)
     &    WRITE(6,111)'BS_WFO| BROKEN SYMMETRY STATE NOT CONVERGED!!'
        IF(.NOT.HSCONV)
     &    WRITE(6,111)'BS_WFO| HIGH SPIN STATE NOT CONVERGED!!'
        IF(BSCONV.AND.HSCONV) THEN
          ETOTLS = (1.0D0 + CNSTWGT) * ETOTBS - CNSTWGT * ETOTHS
          COUPLJ = (ETOTHS - ETOTBS) * RTSASB
          JWN=COUPLJ*AUTOCM
          CALL LSFORCE(FNBS,FION)
          CALL GSIZE(FION,GNMAX,GNORM)
          WRITE(6,'(/,T2,A)') 'BROKEN SYMMETRY CALCULATIONS CONVERGED:'
          WRITE(6,'(T2,A47,F17.8,A7)')
     &          'THE PROJECTED ENERGY OF THE LOW SPIN STATE IS:',
     &          ETOTLS, 'a.u.'
          WRITE(6,'(T2,A47,F17.8,A7)')
     &          'THE COUPLING CONSTANT J IS                   :',
     &          COUPLJ, 'a.u.'
          WRITE(6,'(T2,A47,F17.3,A7)') '~', JWN, 'cm^-1.'
          WRITE(6,'(/,T2,A)') 'BS_WFO| PROJECTED ATOMIC FORCES:'
          CALL GEOFILE(TAU0,FION,'WRITE')
          CALL WRGEOF(TAU0,FION)
          WRITE(6,'(A)') ' NUCLEAR GRADIENT: '
          WRITE(6,'(2(A,1PE15.5))') '    MAX. COMPONENT =',
     &         GNMAX,'         NORM =',GNORM
        ENDIF
      ENDIF        
      CALL FREEM(IP_TAUP)
      CALL FREEM(IP_FION)
      CALL FREEM(IP_FNBS)
C     ==--------------------------------------------------------------==
      END 
