C     ==================================================================
      SUBROUTINE CALC_ALM(SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==  CALCULATES OVERLAP MATRIX BETWEEN NON-LOCAL PSEUDOPOTENTIAL ==
C     ==  PROJECTORS                                                  ==
C     ==  K POINTS VERSION (ALM BECOMES COMPLEX -- IMAGP=2)           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'geq0.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
C     Arguments
      INTEGER    LSCR
      COMPLEX*16 SCR(NGWK,NLM)
C     Variables
      DIMENSION  TWNL(NGWK,NHXS,NSX,NKPNT),
     &           NLPTR(3,NLM),
     &           EIGR(NGW,NAT),EIGKR(NGWK,NAT,NKPNT),CNL(NGWK,NLM)
      COMPLEX*16 CP1
      CHARACTER  TAG*30
      LOGICAL    TLSDTRUE
      REAL*8     FNL,DFNL
      INTEGER    ISUB,NLMX2,NCNL,NNL,NNI,NLI,ISA,IS,IA,IV,I1,I2,
     &           KBEG,KEND,KINC,IKPT,NLM1,IS1,IA1,NKPOINT,ISA1,IG,
     &           IK,LCALC_ALM,
     &           IFIRST
      DATA       IFIRST/0/
      SAVE       IFIRST
C     ==--------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN
C       Allocate Array ALM and CNL
        IFIRST=1
C       NLM is initialized in SETSYS. 
        NLMX2=MAX(1,IMAGP*NLM*NLM*NKPTALL)
        NCNL=MAX(1,2*NGWK*NLM)
        NNL=MAX(1,3*NLM)
        NNI=MAX(1,N*NLM*IMAGP)
        CALL MEMORY(IP_ALM,NLMX2,'ALM')
        CALL MEMORY(IP_CNL,NCNL,'CNL')
        CALL MEMORY(IP_NLPTR,NNL,'NLPTR')
        CALL MEMORY(IP_AFNL,NNI,'AFNL')
        CALL MEMORY(IP_BILN,NNI,'BILN')
        IF(PARENT.AND.NLM.GT.0) CALL PRMEM('  CALC_ALM')
        NLI=0
        ISA=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            ISA=ISA+1
            DO IV=1,NGH(IS)
              NLI=NLI+1
              NLPTR(1,NLI)=IS
              NLPTR(2,NLI)=ISA
              NLPTR(3,NLI)=IV
            ENDDO
          ENDDO
        ENDDO
      ENDIF
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('  CALC_ALM',ISUB)
      CALL GIVE_SCR_CALC_ALM(LCALC_ALM,TAG)
      CALL TEST_SCR('CALC_ALM',TAG,LSCR,LCALC_ALM)
C     ==--------------------------------------------------------------==
C     Calculate overlap
      CALL INQ_SWAP(KBEG,KEND,KINC)
      DO IKPT=KBEG,KEND,KINC
        NKPOINT=NKPBL(IKPT)
        IF(TKBLOCK) CALL RKPT_SWAP(SCR,1,IKPT,'EIGKR TWNL')
        DO IK=1,NKPOINT
          ISA1=0
          NLM1=0
          DO IS1=1,NSP
            DO IA1=1,NA(IS1)
              ISA1=ISA1+1
              DO IV=1,NGH(IS1)
                CP1=(0.0D0,-1.0D0)**NGHTOL(IV,IS1)
                NLM1=NLM1+1
C               CNL is temporarily used as scr space
                DO IG=1,NGWK
                  CNL(IG,NLM1)=CP1*TWNL(IG,IV,IS1,IK)*EIGKR(IG,ISA1,IK)
                ENDDO
              ENDDO
            ENDDO
          ENDDO
C         Check (always true except when debugging)
          IF(NLM1.NE.NLM) THEN
            WRITE(6,*) 'NLM1=',NLM1,'NLM=',NLM
            CALL STOPGM('CALC_ALM','WRONG NON-LOCAL NUMBER')
          ENDIF
C..aa
          IF(TLSD) THEN 
            TLSDTRUE=.TRUE.
            TLSD=.FALSE.
          ELSE
            TLSDTRUE=.FALSE.
          ENDIF
          IF(TKPNT) THEN
            IF(GEQ0) CALL ZCLEAN_K(CNL,NLM,NGW)
            CALL OVLAP_H(NLM,ALM(1,1,1,IK),CNL,CNL)
          ELSE
            CALL OVLAP  (NLM,ALM(1,1,1,IK),CNL,CNL)
          ENDIF
C..aa
          IF(TLSDTRUE) TLSD=.TRUE. 
C         ALM is symmetric or hermitian.
          DO I1=1,NLM
            DO I2=I1+1,NLM
              ALM(1,I1,I2,IK)=ALM(1,I2,I1,IK)
            ENDDO
          ENDDO
          IF(TKPNT) THEN
            DO I1=1,NLM
              DO I2=I1+1,NLM
                ALM(2,I1,I2,IK)=-ALM(2,I2,I1,IK)
              ENDDO
            ENDDO
          ELSE
          ENDIF
#ifdef PARALLEL
          IF(TKPNT) THEN
            CALL SUMHMAT(ALM(1,1,1,IK),NLM,SCR,LSCR)
          ELSE
            CALL SUMMAT (ALM(1,1,1,IK),NLM,SCR,LSCR)
          ENDIF
#endif
        ENDDO
        IF(TKBLOCK) CALL WKPT_SWAP(SCR,1,IKPT,'ALM')
      ENDDO
      CALL TIHALT('  CALC_ALM',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CALC_K_ALM(IKPT)
C     ==--------------------------------------------------------------==
C     == CALCULATE ALM FOR ONE SET OF KPOINTS                         ==
C     == USED WITH TKBLOCK                                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NKPNT NKPBL NGWK
      INCLUDE 'kpts.inc'        !TKPNT
      INCLUDE 'geq0.inc'        !GEQ0
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'        !ALM AFNL BILN
      INCLUDE 'ions.inc'        !NAT NSP NA
      INCLUDE 'kpnt.inc'        !for EIGKR
      INCLUDE 'cppt.inc'        !for TWNL
C     Arguments
      INTEGER IKPT
C     Variables
      DIMENSION  TWNL(NGWK,NHXS,NSX,NKPNT),
     &           EIGKR(NGWK,NAT,NKPNT),CNL(NGWK,NLM)
      REAL*8     SCRALM(*)
      POINTER    (IP_SCRALM,SCRALM)
      CHARACTER  TAG*30
      LOGICAl    TLSDTRUE
      COMPLEX*16 CP1
      INTEGER    LSCRALM,ISUB,IK,I1,I2,IG,IV,IA1,IS1,NLM1,ISA1
C     ==--------------------------------------------------------------==
      CALL TISET('CALC_K_ALM',ISUB)
      CALL GIVE_SCR_CALC_ALM(LSCRALM,TAG)
      CALL MEMORY(IP_SCRALM,LSCRALM,'SCRALM')
C     ==--------------------------------------------------------------==
      DO IK=1,NKPBL(IKPT)
        ISA1=0
        NLM1=0
        DO IS1=1,NSP
          DO IA1=1,NA(IS1)
            ISA1=ISA1+1
            DO IV=1,NGH(IS1)
              CP1=(0.0D0,-1.0D0)**NGHTOL(IV,IS1)
              NLM1=NLM1+1
C             CNL is temporarily used as scr space
              DO IG=1,NGWK
                CNL(IG,NLM1)=CP1*TWNL(IG,IV,IS1,IK)*EIGKR(IG,ISA1,IK)
              ENDDO
            ENDDO
          ENDDO
        ENDDO
C       Check (always true except when debugging)
        IF(NLM1.NE.NLM) THEN
          WRITE(6,*) 'NLM1=',NLM1,'NLM=',NLM
          CALL STOPGM('CALC_ALM','WRONG NON-LOCAL NUMBER')
        ENDIF
C..     aa
        IF(TLSD) THEN 
          TLSDTRUE=.TRUE.
          TLSD=.FALSE.
        ELSE
          TLSDTRUE=.FALSE.
        ENDIF
        IF(TKPNT) THEN
          IF(GEQ0) CALL ZCLEAN_K(CNL,NLM,NGW)
          CALL OVLAP_H(NLM,ALM(1,1,1,IK),CNL,CNL)
        ELSE
          CALL OVLAP  (NLM,ALM(1,1,1,IK),CNL,CNL)
        ENDIF
C..     aa
        IF(TLSDTRUE) TLSD=.TRUE. 
C       ALM is symmetric or hermitian.
        DO I1=1,NLM
          DO I2=I1+1,NLM
            ALM(1,I1,I2,IK)=ALM(1,I2,I1,IK)
          ENDDO
        ENDDO
        IF(TKPNT) THEN
          DO I1=1,NLM
            DO I2=I1+1,NLM
              ALM(2,I1,I2,IK)=-ALM(2,I2,I1,IK)
            ENDDO
          ENDDO
        ELSE
        ENDIF
#ifdef PARALLEL
        IF(TKPNT) THEN
          CALL SUMHMAT(ALM(1,1,1,IK),NLM,SCRALM,LSCRALM)
        ELSE
          CALL SUMMAT (ALM(1,1,1,IK),NLM,SCRALM,LSCRALM)
        ENDIF
#endif
      ENDDO
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_SCRALM)
      CALL TIHALT('CALC_K_ALM',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_CALC_ALM(LCALC_ALM,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGWK NAX
      INCLUDE 'nlps.inc'        !NLM IMAGP
C     Arguments
      INTEGER   LCALC_ALM
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LCALC_ALM=IMAGP*NLM*(NLM+1)/2
      TAG='IMAGP*NLM*(NLM+1)/2'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
