C     ==================================================================
      SUBROUTINE CALC_PIJ(C0,C1,CPX,CPY,CPZ,IKIND)
C     ==--------------------------------------------------------------==
C     == GIVEN C0 AND C1 IN THE PLANE WAVE REPRESENTATION, THIS       ==
C     == ROUTINE RETURNS  <C0|P|C1>                                   ==
C     == IN UNITS OF 2 PI/A                                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc' 
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
C     Arguments
      COMPLEX*16 C0(NGWK),C1(NGWK),CPX,CPY,CPZ
      INTEGER    IKIND
C     Variables
      DIMENSION  RK(3,NKPTS)
      COMPLEX*16 ZZERO
      PARAMETER  (ZZERO=(0.D0,0.D0))
      COMPLEX*16 CAUX,CAUX2
      REAL*8     PX,PY,PZ
      INTEGER    IG 
C     ==--------------------------------------------------------------==
      IF(TKPNT) THEN
        CPX = ZZERO
        CPY = ZZERO
        CPZ = ZZERO
        DO IG=1,NGW
          CAUX=C1(IG)*DCONJG(C0(IG))
          CAUX2=C1(IG+NGW)*DCONJG(C0(IG+NGW))
          CPX=CPX+RK(1,IKIND)*(CAUX+CAUX2)
     .           +GK(1,IG)*(CAUX-CAUX2)
          CPY=CPY+RK(2,IKIND)*(CAUX+CAUX2)
     .           +GK(2,IG)*(CAUX-CAUX2)
          CPZ=CPZ+RK(3,IKIND)*(CAUX+CAUX2)
     .           +GK(3,IG)*(CAUX-CAUX2)
        ENDDO
      ELSE
        PX = 0.D0
        PY = 0.D0
        PZ = 0.D0
        DO IG=1,NGW
          CAUX=DCONJG(C0(IG))*C1(IG)
          PX=PX+GK(1,IG)*DIMAG(CAUX)
          PY=PY+GK(2,IG)*DIMAG(CAUX)
          PZ=PZ+GK(3,IG)*DIMAG(CAUX)
        ENDDO
        CPX=DCMPLX(PX*2.D0,0.D0)
        CPY=DCMPLX(PY*2.D0,0.D0)
        CPZ=DCMPLX(PZ*2.D0,0.D0)
      ENDIF
      RETURN
      END 
C     ==================================================================
      SUBROUTINE CALC_PI(C0,C1,J,IKIND)
C     ==--------------------------------------------------------------==
C     == GIVEN C0 IN THE PLANE WAVE REPRESENTATION, THIS              ==
C     == ROUTINE RETURNS  C1=P_J.C0=-id/dx C0                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc' 
      INCLUDE 'cnst.inc' 
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'geq0.inc' 
C     ==--------------------------------------------------------------==
C     Arguments
      INTEGER    J,IKIND
      COMPLEX*16 C0(NGWK),C1(NGWK)
C     Variables
      DIMENSION RK(3,*)
      INTEGER   IG
C     ==--------------------------------------------------------------==
      IF(TKPNT) THEN
        DO IG=1,NGW
          C1(IG)    =(RK(J,IKIND)+GK(J,IG))*C0(IG)*TPIBA
          C1(IG+NGW)=(RK(J,IKIND)-GK(J,IG))*C0(IG+NGW)*TPIBA
        ENDDO
        IF(GEQ0)C1(1+NGW)=DCMPLX(0.D0,0.D0)
      ELSE
        DO IG=2,NGW
          C1(IG)=GK(J,IG)*C0(IG)*TPIBA
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END 
C     ==================================================================
