C     ==================================================================
      SUBROUTINE CANON(C0,C2,F,NSTATE,EIGV,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGW,NSTATE),C2(NGW,NSTATE)
      REAL*8     EIGV(NSTATE),SCR(LSCR),F(NSTATE)
C     Variables
      POINTER    (IP_HMAT,HMAT),(IP_AUX,AUX)
      REAL*8     HMAT(NSTATE,NSTATE),AUX(*)
      INTEGER    INFO,NAUX,LCANON,MSGLEN,IS
      LOGICAL    DEBUG
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
      CALL GIVE_SCR_CANON(LCANON,TAG,NSTATE)
      CALL TEST_SCR('CANON',TAG,LSCR,LCANON)
      IF(TLSE) CALL STOPGM('CANON','TLSE NOT IMPLEMENTED')
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_HMAT,NSTATE*NSTATE,'HMAT',DEBUG)
      NAUX=MAX(NSTATE*NSTATE,25*NSTATE)
      CALL SCRPTR(SCR,LSCR,IP_AUX,NAUX,'AUX',DEBUG)
      CALL OVLAP(NSTATE,HMAT,C0,C2)
      CALL SUMMAT(HMAT,NSTATE,AUX,NAUX)
      CALL DSCAL(NSTATE*NSTATE,-1.D0,HMAT,1)
      IF(PARENT) THEN
        IF(TLSD) THEN
          INFO=0
          CALL DSYEV('V','U',NSUP,HMAT(1,1),NSTATE,
     &             EIGV(1),AUX,NAUX,INFO)
          IF(INFO.NE.0) CALL STOPGM('CANON','DSYEV:UP:INFO')
          INFO=0
          CALL DSYEV('V','U',NSDOWN,HMAT(NSUP+1,NSUP+1),NSTATE,
     &             EIGV(NSUP+1),AUX,NAUX,INFO)
          IF(INFO.NE.0) CALL STOPGM('CANON','DSYEV:DOWN:INFO')
        ELSE
          INFO=0
          CALL DSYEV('V','U',NSTATE,HMAT,NSTATE,EIGV,AUX,NAUX,INFO)
          IF(INFO.NE.0) CALL STOPGM('CANON','DSYEV:INFO')
        ENDIF
      ENDIF
#ifdef PARALLEL
      MSGLEN = NSTATE*NSTATE * 8
      CALL MY_BCAST(HMAT,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = NSTATE * 8
      CALL MY_BCAST(EIGV,MSGLEN,SOURCE,ALLGRP)
#endif
      DO IS=1,NSTATE
        IF(F(IS).GT.1.D-6) EIGV(IS)=EIGV(IS)/F(IS)
      ENDDO
      CALL ROTATE(1.D0,C0,0.D0,C2,HMAT,NSTATE,2*NGW,TLSD,NSUP,NSDOWN)
      CALL DCOPY(2*NGW*NSTATE,C2,1,C0,1)
      CALL SCRREL(SCR,LSCR,DEBUG)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_CANON(LCANON,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
C     Arguments
      INTEGER      LCANON,NSTATE
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      LCANON=0
      LCANON=NSTATE*NSTATE+MAX(NSTATE*NSTATE,25*NSTATE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

