C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     CDFT main include file containing important CDFT variables
C     H. Oberhofer (ho246@cam.ac.uk) 2009
C     ==================================================================

C     ==================================================================
      INTEGER     CDFT_MAT      ! Maximum CDFT Donor/Acceptor group size
      PARAMETER   (CDFT_MAT=50) 
      INTEGER     MAXSAVEV      ! Maximum order of V predictor in MD
      PARAMETER   (MAXSAVEV=50)
C     ------------------------------------------------------------------
      INTEGER     CDFT_A(CDFT_MAT),CDFT_D(CDFT_MAT),SPA(CDFT_MAT),
     *                SPD(CDFT_MAT),SNA(CDFT_MAT),SND(CDFT_MAT),
     *                MMX_A,MMX_D,NDON,NACCR
      COMMON/CDFTPI/CDFT_A,CDFT_D,SPA,SPD,SNA,SND,MMX_A,MMX_D,
     *                NDON,NACCR !Parameter Integers
C     ------------------------------------------------------------------
      INTEGER     CDFT_END,WSTEP
      COMMON/CDFTCI/CDFT_END,WSTEP !Control Integers
C     ------------------------------------------------------------------
      LOGICAL     RECW ! Recalculate the weights?
      LOGICAL     NEWGRAD,DEKK ! Optimisation options
      LOGICAL     TCZONES ! Convergence zones
      LOGICAL     RESWF ! Reset Wavefunction after each CDFT step
      LOGICAL     CCOR  ! Cutoff Correction in MD
      LOGICAL     RCDFT ! try to load initial V from CDFT_RESTART file
      LOGICAL     THDA  ! Calculate the transition matrix
      LOGICAL     THDAPROJ! Calculate the transition matrix
      LOGICAL     TAUTO ! Automatically choose NC from initial guess
      LOGICAL     TPRED ! Try to predict next V in an MD simulation
      LOGICAL     TPHIO ! Write out the overlap matrices
      LOGICAL     TSPINC! Constrain the spin density
      COMMON/CDFTLOG/RECW,NEWGRAD,DEKK,TCZONES,RESWF,CCOR,RCDFT,THDA,
     *               THDAPROJ,TAUTO,TPRED,TPHIO,TSPINC
C     ------------------------------------------------------------------
      LOGICAL     RECONVV ! for MD shows if GRAD is still lower than upper limit
      COMMON/CDFTRUN/RECONVV
C     ------------------------------------------------------------------
      REAL*8      CDFT_NC,CDFT_V,NOTHER,VCCON,VCCONU,VGRADO,
     &            VGRADA,OLDV,OLDVA,WSLICE,RC_A,RC_D,VGRAD
      COMMON/CDFTCOM/CDFT_NC,CDFT_V,NOTHER,VCCON,VCCONU,VGRADO,
     &            VGRADA,OLDV,OLDVA,WSLICE,RC_A,RC_D,VGRAD
      REAL*8      VGSTEP,MAXVMOV
      COMMON/CDFTVGRS/VGSTEP,MAXVMOV
      REAL*8      WCUT
      COMMON/WCFIX/WCUT
C     ------------------------------------------------------------------
      REAL*8      WA(NNR1),WD(NNR1),WDIFF(NNR1),RHOL(NNR1)
      REAL*8      CZONES(3,2),FINALCHRG(2)
      POINTER     (IP_WA,WA),(IP_WD,WD),(IP_WDIFF,WDIFF)
      POINTER     (IP_RHOL,RHOL)
      COMMON/CDFTLCO/IP_WA,IP_WD,IP_WDIFF,IP_RHOL,CZONES,FINALCHRG
C     ------------------------------------------------------------------
      REAL*8      WDER,CDFT_RC(MAXSP),RHOCUT(MAXSP),CDFT_SHELL
      INTEGER     CDFT_MMAX(MAXSP)
      POINTER     (IP_WDER,WDER)
      COMMON/CDFTMD/CDFT_RC,RHOCUT,CDFT_SHELL,IP_WDER,CDFT_MMAX
C     ------------------------------------------------------------------
      REAL*8      VPREDBUF(MAXSAVEV)
      INTEGER     PREDORD          ! Order of the extrapolation scheme
      COMMON/CDFTPRED/VPREDBUF,PREDORD
C     ------------------------------------------------------------------
      LOGICAL    HDAFIRST,HDARESB
      REAL*8     VBUFF
      COMMON/CDFTHDA/HDAFIRST,HDARESB,VBUFF
C     ------------------------------------------------------------------
      INTEGER    N_S0,N_S1,N_S0UP,N_S1UP
      COMMON/SCCOMM/N_S0,N_S1,N_S0UP,N_S1UP
      LOGICAL    PROJNOW
      COMMON/PROJLOG/PROJNOW
C     ------------------------------------------------------------------
      LOGICAL     TWGAUSS! Construct the weight from Gaussians
      LOGICAL     THDAS  ! HDA calculation with Single Acceptor and no Donor
      COMMON/WGAUSSL/TWGAUSS,THDAS
      INTEGER    WG_N
      REAL*8     WG_SIGMA(MAXSP)
      COMMON/WGAUSS/WG_SIGMA,WG_N
C     ==================================================================
