C     ==================================================================
cmdebug      SUBROUTINE CLAS_FORCE(ENERGY,UPDATE)
      SUBROUTINE CLAS_FORCE(ENERGY,UPDATE,EINT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'irat.inc'
C     Arguments
      REAL*8  ENERGY,EINT
      LOGICAL UPDATE
C     Variables
      INTEGER   MAXNAB
      PARAMETER (MAXNAB=100)
      INTEGER   LIST(*),LIST2(*),POINT(*)
      POINTER   (IP_LIST,LIST),(IP_LIST2,LIST2),(IP_POINT,POINT)
      INTEGER   CDIMR12(3),CELLR12(3,*)
      POINTER   (IP_CELLR12,CELLR12)
      REAL*8    SIGMASQ,SR2,SR12,VIJ,WIJ,FX,FY,FZ,RCUTSQ,RLISTSQ,
     &          SRC12,RCUT,RIJ,RXIA1, RYIA1, RZIA1,
     &          X1, Y1, Z1, X2, Y2, Z2, RIJSQ 
      LOGICAL   CHECK_CELL
      INTEGER   IS1,IS2,IA1,IA2,JBEG,JEND,JNAB,NLIST,ISUB,
     &          IFIRST,LISTLEN
      DATA      IFIRST /0/
      SAVE      IFIRST,LISTLEN,
     &          IP_LIST,IP_POINT,IP_CELLR12,CDIMR12
C     ==--------------------------------------------------------------==
      CALL TISET('CLAS_FORCE',ISUB)
      IF(IFIRST.EQ.0) THEN
        CALL MEMORY(IP_POINT,NCLATOM/IRAT+1,'POINT')
        LISTLEN=MAXNAB*(MYCLAT2-MYCLAT1+1)
        CALL MEMORY(IP_LIST,LISTLEN/IRAT+1,'LIST')
        CALL IAZZERO(POINT,NCLATOM)
        CALL IAZZERO(LIST,LISTLEN)
        IF(T_R12) THEN
          CALL MEMORY(IP_CELLR12,(3*NCLATOM)/IRAT+1,'CELLR12')
          CALL IAZZERO(CELLR12,3*NCLATOM)
        ENDIF
        IFIRST=1
      ENDIF

C     PARAMETER RLRC is the difference R_list - R_cutoff
C     it has the same value for all pairs of particle types
      RLRC=2.0d0

      ENERGY = 0.D0
      EINT=0.D0
      CALL AZZERO(CLASPRES,9)
      CALL AZZERO(CLASF,3*NCLATOM)
C     ==--------------------------------------------------------------==

      IF(T_R12) THEN

        IF(UPDATE) THEN
c        Verlet list has to be updated

          CALL SAVE0
          NLIST = 0
          CALL CELL_LISTR12(CDIMR12,CELLR12)

          DO IA1=MYCLAT1,MYCLAT2
            IS1=CLTYP(IA1)

            POINT(IA1)=NLIST+1

            RXIA1 = CLASC(1,IA1)
            RYIA1 = CLASC(2,IA1)
            RZIA1 = CLASC(3,IA1)

            DO IA2 = IA1+1,NCLATOM
              IS2=CLTYP(IA2)

              IF(IS_QM(IS1)*IS_QM(IS2).EQ.0) THEN
                IF(CHECK_CELL(CELLR12(1,IA1),
     *                        CELLR12(1,IA2),CDIMR12)) THEN
                  SIGMASQ = PR12(IS1,IS2)*PR12(IS1,IS2)
                  RCUTSQ = RCR12(IS1,IS2)**2
                  RCUT=RCR12(IS1,IS2)
                  RLISTSQ = (RCR12(IS1,IS2)+RLRC)**2

                  X1 = RXIA1 - CLASC(1,IA2)
                  Y1 = RYIA1 - CLASC(2,IA2)
                  Z1 = RZIA1 - CLASC(3,IA2)

                  CALL PBC_CLAS(X1,Y1,Z1,X2,Y2,Z2)

                  RIJSQ = X2**2 + Y2**2 + Z2**2
                  RIJ=SQRT(RIJSQ)

                  IF(RIJSQ.LT.RLISTSQ) THEN
                    NLIST=NLIST+1
                    IF(NLIST.EQ.LISTLEN) THEN
                      CALL MEMORY(IP_LIST2,LISTLEN/IRAT+1,'LIST2')
                      CALL ICOPY(NLIST,LIST,1,LIST2,1)
                      CALL FREEM(IP_LIST)
                      LISTLEN=3*LISTLEN/2
                      CALL MEMORY(IP_LIST,LISTLEN/IRAT+1,'LIST')
                      CALL ICOPY(NLIST,LIST2,1,LIST,1)
                      CALL FREEM(IP_LIST2)
                    ENDIF
                    LIST(NLIST)=IA2
                    IF(RIJSQ.LT.RCUTSQ) THEN

                      SR2   = SIGMASQ/RIJSQ
                      SR12  = SR2**6
                      SRC12= (SIGMASQ/RCUTSQ)**6
cm                           VIJ   = SR12
                VIJ   = SR12 
     *         +SRC12*(12.D0*RIJ-13.D0*RCUT)/RCUT
                      WIJ   = 12.0D0 * SR12 / RIJSQ
     *           -12.D0*SRC12/RIJ/RCUT
                      FX = WIJ * X2
                      FY = WIJ * Y2
                      FZ = WIJ * Z2

                      CLASF(1,IA1) = CLASF(1,IA1) + FX
                      CLASF(2,IA1) = CLASF(2,IA1) + FY
                      CLASF(3,IA1) = CLASF(3,IA1) + FZ

                      CLASF(1,IA2) = CLASF(1,IA2) - FX
                      CLASF(2,IA2) = CLASF(2,IA2) - FY
                      CLASF(3,IA2) = CLASF(3,IA2) - FZ

                      ENERGY = ENERGY + VIJ
                      IF((IS_QM(IS1)+IS_QM(IS2)).NE.0)
     *                EINT=EINT+VIJ

                      CLASPRES(1,1) = CLASPRES(1,1) + FX * X2
                      CLASPRES(2,2) = CLASPRES(2,2) + FY * Y2
                      CLASPRES(3,3) = CLASPRES(3,3) + FZ * Z2
                      CLASPRES(1,2) = CLASPRES(1,2) + FX * Y2
                      CLASPRES(1,3) = CLASPRES(1,3) + FX * Z2
                      CLASPRES(2,3) = CLASPRES(2,3) + FY * Z2
                      CLASPRES(2,1) = CLASPRES(1,2)
                      CLASPRES(3,1) = CLASPRES(1,3)
                      CLASPRES(3,2) = CLASPRES(2,3)

                    ENDIF
                  ENDIF
                ENDIF
              ENDIF

            ENDDO
          ENDDO
          IF(MYCLAT2.LT.NCLATOM) POINT(MYCLAT2+1)=NLIST+1

        ELSE
c        we use the list to find the neighbours

          DO IA1=MYCLAT1,MYCLAT2
            IF(IA1.LT.NCLATOM) THEN
              IS1=CLTYP(IA1)

              JBEG=POINT(IA1)
              JEND=POINT(IA1+1)-1 
        
              IF(JBEG.LE.JEND) THEN
        
                RXIA1 = CLASC(1,IA1)
                RYIA1 = CLASC(2,IA1)
                RZIA1 = CLASC(3,IA1)

                DO JNAB=JBEG,JEND
                  IA2=LIST(JNAB)
                  IS2=CLTYP(IA2)

                  SIGMASQ = PR12(IS1,IS2)*PR12(IS1,IS2)
                  RCUTSQ = RCR12(IS1,IS2)**2
                  RCUT=RCR12(IS1,IS2)
                  X1 = RXIA1 - CLASC(1,IA2)
                  Y1 = RYIA1 - CLASC(2,IA2)
                  Z1 = RZIA1 - CLASC(3,IA2)

                  CALL PBC_CLAS(X1,Y1,Z1,X2,Y2,Z2)

                  RIJSQ = X2**2 + Y2**2 + Z2**2
                  RIJ=SQRT(RIJSQ)

                  IF(RIJSQ.LT.RCUTSQ) THEN

                    SR2   = SIGMASQ/RIJSQ
                    SR12  = SR2**6
                    SRC12 = (SIGMASQ/RCUTSQ)**6
                VIJ   = SR12
     *         +SRC12*(12.D0*RIJ-13.D0*RCUT)/RCUT
                      WIJ   = 12.0D0 * SR12 / RIJSQ
     *           -12.D0*SRC12/RIJ/RCUT
c                   VIJ   = SR12
c                   WIJ   = 12.0 * SR12 / RIJSQ
c
                    FX = WIJ * X2
                    FY = WIJ * Y2
                    FZ = WIJ * Z2

                    CLASF(1,IA1) = CLASF(1,IA1) + FX
                    CLASF(2,IA1) = CLASF(2,IA1) + FY
                    CLASF(3,IA1) = CLASF(3,IA1) + FZ

                    CLASF(1,IA2) = CLASF(1,IA2) - FX
                    CLASF(2,IA2) = CLASF(2,IA2) - FY
                    CLASF(3,IA2) = CLASF(3,IA2) - FZ

                    ENERGY = ENERGY + VIJ
                    IF( (IS_QM(IS1)*IS_QM(IS2).EQ.0)  .AND.    
     *              ( (IS_QM(IS1)+IS_QM(IS2)).NE.0 ) )
     *              EINT=EINT+VIJ
  
                    CLASPRES(1,1) = CLASPRES(1,1) + FX * X2
                    CLASPRES(2,2) = CLASPRES(2,2) + FY * Y2
                    CLASPRES(3,3) = CLASPRES(3,3) + FZ * Z2
                    CLASPRES(1,2) = CLASPRES(1,2) + FX * Y2
                    CLASPRES(1,3) = CLASPRES(1,3) + FX * Z2
                    CLASPRES(2,3) = CLASPRES(2,3) + FY * Z2
                    CLASPRES(2,1) = CLASPRES(1,2)
                    CLASPRES(3,1) = CLASPRES(1,3)
                    CLASPRES(3,2) = CLASPRES(2,3)

                  ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDDO

        ENDIF

      ELSE
        CALL STOPGM('CLAS_FORCE','UNDEFINED FORCE FIELD')
      ENDIF
#ifdef PARALLEL
      CALL MY_SYNC(ALLGRP)
      CALL GLOSUM(1,ENERGY)
      CALL GLOSUM(1,EINT)
      CALL GLOSUM(9,CLASPRES)
      CALL GLOSUM(3*NCLATOM,CLASF)
#endif
      CALL MEMORY_CHECK
      CALL TIHALT('CLAS_FORCE',ISUB)
      RETURN
      END


      SUBROUTINE CHECK ( UPDATE )

      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'

C    *******************************************************************
C    ** DECIDES WHETHER THE LIST NEEDS TO BE RECONSTRUCTED.           **
C    **                                                               **
C    ** PRINCIPAL VARIABLES:                                          **
C    **                                                               **
C    ** CLASC(J,IA)                    ATOM POSITIONS                 **
C    ** CLASC0(J,IA)                   COORDINATES AT LAST UPDATE     **
C    ** REAL     RLIST                 RADIUS OF VERLET LIST          **
C    ** REAL     RCUT                  CUTOFF DISTANCE FOR FORCES     **
C    ** REAL     DISPMX                LARGEST DISPLACEMENT           **
C    ** LOGICAL  UPDATE                IF TRUE THE LIST IS UPDATED    **
C    **                                                               **
C    ** USAGE:                                                        **
C    **                                                               **
C    ** CHECK IS CALLED TO SET UPDATE BEFORE EVERY CALL TO FORCE.     **
C    *******************************************************************

      LOGICAL     UPDATE

      REAL*8      DISPMX
      INTEGER     IA

C    *******************************************************************

C    ** CALCULATE MAXIMUM DISPLACEMENT SINCE LAST UPDATE **

      DISPMX = 0.0D0

      DO IA=MYCLAT1,MYCLAT2
        DISPMX = MAX ( ABS ( CLASC0(1,IA)-CLASC(1,IA) ), DISPMX )
        DISPMX = MAX ( ABS ( CLASC0(2,IA)-CLASC(2,IA) ), DISPMX )
        DISPMX = MAX ( ABS ( CLASC0(3,IA)-CLASC(3,IA) ), DISPMX )
      ENDDO
#ifdef PARALLEL
      CALL GLOMAX(1,DISPMX)
#endif
C    ** A CONSERVATIVE TEST OF THE LIST SKIN CROSSING **
      DISPMX = 2.0D0 * DSQRT  ( 3.0D0 * DISPMX * DISPMX )

      UPDATE = DISPMX.GT.RLRC

      RETURN
      END


      SUBROUTINE SAVE0

      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'

C    *******************************************************************
C    ** SAVES CURRENT CONFIGURATION FOR FUTURE CHECKING.              **
C    **                                                               **
C    ** PRINCIPAL VARIABLES:                                          **
C    **                                                               **
C    ** CLASC(J,IA)                    ATOM POSITIONS                 **
C    ** CLASC0(J,IA)                   STORAGE LOCATIONS FOR SAVE     **
C    **                                                               **
C    ** SAVE IS CALLED WHENEVER THE NEW VERLET LIST IS CONSTRUCTED.   **
C    *******************************************************************

      INTEGER IA

C    *******************************************************************

      DO IA=1,NCLATOM
        CLASC0(1,IA)=CLASC(1,IA)
        CLASC0(2,IA)=CLASC(2,IA)
        CLASC0(3,IA)=CLASC(3,IA)
      ENDDO

      RETURN
      END

C    *******************************************************************
      SUBROUTINE CELL_LISTR12(CDIMR12,CELLR12)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'
      INTEGER CDIMR12(3),CELLR12(3,*)
      REAL*8 CELLM,XDIM,YDIM,ZDIM,DX,DY,DZ
      REAL*8 XP,YP,ZP
      INTEGER IS1,IS2,IMX,IMY,IMZ,IA

      CELLM =0.D0
      DO IS1=1,NCLTYP
        DO IS2=IS1,NCLTYP
          CELLM = MAX(CELLM,(RCR12(IS1,IS2)+RLRC)**2)
        ENDDO
      ENDDO
      CELLM=SQRT(CELLM)
    
      XDIM=CELLCL(1)
      YDIM=CELLCL(2)*CELLCL(1)
      ZDIM=CELLCL(3)*CELLCL(1)
      IMX=MAX(INT(XDIM/CELLM),1)
      IMY=MAX(INT(YDIM/CELLM),1)
      IMZ=MAX(INT(ZDIM/CELLM),1)
      DX=XDIM/DBLE(IMX)
      DY=XDIM/DBLE(IMY)
      DZ=XDIM/DBLE(IMZ)
      CDIMR12(1)=IMX
      CDIMR12(2)=IMY
      CDIMR12(3)=IMZ

      DX=1.D0/DX
      DY=1.D0/DY
      DZ=1.D0/DZ
      DO IA=1,NCLATOM
        CALL PBC_CLAS(CLASC(1,IA),CLASC(2,IA),CLASC(3,IA),XP,YP,ZP)
        CELLR12(1,IA)=INT((XP+XDIM*0.5D0)*DX)+1
        CELLR12(2,IA)=INT((YP+YDIM*0.5D0)*DY)+1
        CELLR12(3,IA)=INT((ZP+ZDIM*0.5D0)*DZ)+1
        IF(CELLR12(1,IA).LT.1.OR.CELLR12(1,IA).GT.CDIMR12(1)) 
     *       CALL STOPGM('CELL_LISTR12','CELL NUMBER 1')
        IF(CELLR12(2,IA).LT.1.OR.CELLR12(2,IA).GT.CDIMR12(2)) 
     *       CALL STOPGM('CELL_LISTR12','CELL NUMBER 2')
        IF(CELLR12(3,IA).LT.1.OR.CELLR12(3,IA).GT.CDIMR12(3)) 
     *       CALL STOPGM('CELL_LISTR12','CELL NUMBER 3')
      ENDDO

      RETURN
      END

      FUNCTION CHECK_CELL(C1,C2,CM)
      IMPLICIT NONE
      LOGICAL CHECK_CELL
      INTEGER C1(3),C2(3),CM(3)
      INTEGER I,IMA(3),DC
      DO I=1,3
        IMA(I)=0
        DC=ABS(C1(I)-C2(I))
        IF(DC.LE.1) IMA(I)=1
        IF(DC.GE.CM(I)-1) IMA(I)=1
      ENDDO
      CHECK_CELL=IMA(1)*IMA(2)*IMA(3).EQ.1

      RETURN
      END
