C     ==================================================================
      SUBROUTINE CMAOS(D,S,NUMIN,UNAC,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == CALCULATE MODIFIED ATOMIC ORBITALS                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'prop.inc'
C     Arguments
      INTEGER   NUMIN,LSCR
      REAL*8    D(NATTOT,*),S(NATTOT,*),SCR(LSCR),UNAC
C     Variables
      REAL*8    COLL(NATTOT,NUMIN),T1(*),T2(*),T3(*),T4(*)
      POINTER   (IP_COLL,COLL),(IP_T1,T1),(IP_T2,T2),
     *          (IP_T3,T3),(IP_T4,T4)
      INTEGER   NAMAX,IT1,IT2,IT3,IT4,IT5,ITM,IAT,NX,IS,IA,NN,K,J,I,IJ,
     &          NO,II,I1,INFO,
     &          IDAMAX
      REAL*8    BL0,BL1,BBB
C     ==--------------------------------------------------------------==
      NAMAX=MAX(5,NUMAORMAX)
#ifdef _BGL  
      IT1 = 1
      IT2 = IT1 + MAX(NATTOT*NUMIN,1000)+MOD(MAX(NATTOT*NUMIN,1000),2)
      IT3 = IT2 + MAX(NAMAX*NAMAX,1000)+MOD( MAX(NAMAX*NAMAX,1000),2)
      IT4 = IT3 + NAMAX*NAMAX+MOD(NAMAX*NAMAX,2)
      IT5 = IT4 + NAMAX*NAMAX+MOD(NAMAX*NAMAX,2)
      ITM = IT5 + NAMAX*NAMAX+MOD(NAMAX*NAMAX,2)
      ITM = MAX(ITM,IT1+NATTOT*NUMIN+NATTOT*NATTOT) - 1
#else
      IT1 = 1
      IT2 = IT1 + MAX(NATTOT*NUMIN,1000)
      IT3 = IT2 + MAX(NAMAX*NAMAX,1000)
      IT4 = IT3 + NAMAX*NAMAX
      IT5 = IT4 + NAMAX*NAMAX
      ITM = IT5 + NAMAX*NAMAX
      ITM = MAX(ITM,IT1+NATTOT*NUMIN+NATTOT*NATTOT) - 1
#endif
      CALL TEST_SCR('CMAOS','ITM',LSCR,ITM)
      CALL GET_ADDR(IP_COLL,SCR(IT1))
      CALL GET_ADDR(IP_T1,SCR(IT2))
      CALL GET_ADDR(IP_T2,SCR(IT3))
      CALL GET_ADDR(IP_T3,SCR(IT4))
      CALL GET_ADDR(IP_T4,SCR(IT5))
C     ==--------------------------------------------------------------==
      WRITE(6,'(A)') '*** MODIFIED ATOMIC ORBITALS ***'
      WRITE(6,'(A)') ' ATOM  OCCUPATION NUMBERS       '
      CALL AZZERO(COLL,NATTOT*NUMIN)
      IAT=0
      NO=1
      NX=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          NN=NUMAOR(IS)
          CALL DGEMM('N','N',NN,NN,NN,1.D0,D(NO,NO),NATTOT,S(NO,NO),
     *               NATTOT,0.D0,T1(1),NN)
          K=0
          DO J=1,NN
            DO I=J,NN
              IJ=(J-1)*NN+I
              K=K+1
              T2(K)=T1(IJ)
            ENDDO
          ENDDO
          CALL DSPEVY(1,T2,T3,T1,NN,NN,T4,3*NN)
          WRITE(6,'(I4,5X,9(F7.2),/,9X,9(F7.2))') 
     *                            IAT,(T3(I),I=NN,NN-MAOS(IS)+1,-1)
          BL0=T3(NN-MAOS(IS)+1)
          BL1=T3(IDAMAX(NN-MAOS(IS),T3(1),1))
          BBB=ABS(BL1)/ABS(BL0)
          IF(BBB.GT.0.2D0) THEN
            WRITE(6,'(A,10(F7.2),/,9X,10(F7.2))')
     *                   'WARNING :',(T3(I),I=NN-MAOS(IS),1,-1)
          ENDIF
          DO I=1,MAOS(IS)
            II=NN-I+1
            I1=(II-1)*NN+1
            CALL DCOPY(NN,T1(I1),1,COLL(NO,NX+I),1)
          ENDDO
          NO=NO+NN
          NX=NX+MAOS(IS)
        ENDDO
      ENDDO
C     Calculate N=SDS
      CALL DGEMM('N','N',NATTOT,NATTOT,NATTOT,1.D0,D(1,1),NATTOT,
     &           S(1,1),NATTOT,0.D0,T1(1),NATTOT)
      CALL DGEMM('N','N',NATTOT,NATTOT,NATTOT,1.D0,S(1,1),NATTOT,
     &           T1(1),NATTOT,0.D0,D(1,1),NATTOT)
C     Calculate unassigned charge : N - TR(DP)
      CALL DGEMM('N','N',NATTOT,NUMIN,NATTOT,1.D0,S(1,1),NATTOT,
     *           COLL(1,1),NATTOT,0.D0,T1(1),NATTOT)
      CALL DGEMM('T','N',NUMIN,NUMIN,NATTOT,1.D0,COLL(1,1),NATTOT,
     *           T1(1),NATTOT,0.D0,S(1,1),NUMIN)
      CALL INVMAT(NUMIN,S,T1,INFO)
      CALL DGEMM('N','N',NATTOT,NUMIN,NUMIN,1.D0,COLL(1,1),NATTOT,
     *           S(1,1),NUMIN,0.D0,T1(1),NATTOT)
      CALL DGEMM('N','T',NATTOT,NATTOT,NUMIN,1.D0,T1(1),NATTOT,
     *           COLL(1,1),NATTOT,0.D0,S(1,1),NATTOT)
      DO I=1,NATTOT
        DO J=1,NATTOT
          UNAC=UNAC+D(I,J)*S(I,J)
        ENDDO
      ENDDO
      DO IS=1,NSP
        UNAC=UNAC-ZV(IS)*NA(IS)
      ENDDO
      UNAC=-UNAC
      WRITE(6,'(/,A,F8.3,/)') 
     *   ' Modified Atomic Orbitals: Unassigned Charge ',UNAC
      CALL DCOPY(NATTOT*NUMIN,COLL(1,1),1,S(1,1),1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SATCH(D,S,CA,NUMIN,SAC,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == CALCULATE 2-CENTER SHARED ATOMIC CHARGES                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'prop.inc'
C     Arguments
      INTEGER   NUMIN,LSCR
      REAL*8    D(NATTOT,*),S(NATTOT,*),CA(NATTOT,*),SAC(NAT,NAT),
     &          SCR(LSCR)
C     Variables
      INTEGER   LISTM
      PARAMETER (LISTM=100)
      INTEGER   LIST(LISTM)
      REAL*8    T1(NATTOT,NUMIN),T2(NATTOT*NUMIN),T3(NATTOT,NATTOT)
      POINTER   (IP_T1,T1),(IP_T2,T2),(IP_T3,T3)
      INTEGER   IT1,IT2,IT3,ITM,IAT1,NO1,IS1,IA1,IAT2,NO2,IS2,IA2,IL,
     &          IM1,IM2,I,J
C     ==--------------------------------------------------------------==
      IT1 = 1
      IT2 = IT1 + NATTOT*NUMIN
      IT3 = IT2 + NATTOT*NUMIN
      ITM = IT3 + NATTOT*NATTOT - 1
      CALL TEST_SCR('SATCH','2*NATTOT*NUMIN+NATTOT*NATTOT',
     &              LSCR,ITM)
      CALL GET_ADDR(IP_T1,SCR(IT1))
      CALL GET_ADDR(IP_T2,SCR(IT2))
      CALL GET_ADDR(IP_T3,SCR(IT3))
C     ==--------------------------------------------------------------==
      CALL AZZERO(SAC,NAT*NAT)
      IAT1=0
      NO1=1
      DO IS1=1,NSP
        DO IA1=1,NA(IS1)
          IAT1=IAT1+1
          IAT2=0
          NO2=1
          DO IS2=1,NSP
            DO IA2=1,NA(IS2)
              IAT2=IAT2+1
              IF(IAT2.GE.IAT1) THEN
                IL=0
                DO IM1=NO1,NO1+MAOS(IS1)-1
                  IL=IL+1
                  LIST(IL)=IM1
                ENDDO
                IF(IAT1.NE.IAT2) THEN
                  DO IM2=NO2,NO2+MAOS(IS2)-1
                    IL=IL+1
                    LIST(IL)=IM2
                  ENDDO
                ENDIF
                IF(IL.GT.LISTM) CALL STOPGM('SATCH','LISTM')
                DO I=1,IL
                  CALL DCOPY(NATTOT,CA(1,LIST(I)),1,T1(1,I),1)
                ENDDO
                CALL TRACEDP(NATTOT,IL,SAC(IAT1,IAT2),D,S,T1,T2,T3)
              ENDIF
              NO2=NO2+MAOS(IS2)
            ENDDO
          ENDDO
          NO1=NO1+MAOS(IS1)
        ENDDO
      ENDDO
      DO I=1,NAT
        DO J=1,I
          SAC(I,J)=SAC(J,I)
        ENDDO
      ENDDO
      DO I=1,NAT
        DO J=1,NAT
          SAC(I,J)=SAC(I,I)+SAC(J,J)-SAC(I,J)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SATCH3(D,S,CA,NUMIN,SAC,SAC3,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == CALCULATE 3-CENTER SHARED ATOMIC CHARGES                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'prop.inc'
C     Arguments
      INTEGER   NUMIN,LSCR
      REAL*8    D(NATTOT,*),S(NATTOT,*),CA(NATTOT,*),SAC(NAT,NAT),
     *          SAC3(NAT*NAT*NAT/6 + 1),
     &          SCR(LSCR)
C     Variables
      INTEGER   LISTM
      PARAMETER (LISTM=100)
      INTEGER   LIST(LISTM)
      REAL*8    T1(NATTOT,NUMIN),T2(NATTOT*NUMIN),T3(NATTOT,NATTOT)
      POINTER  (IP_T1,T1),(IP_T2,T2),(IP_T3,T3)
      INTEGER  IT1,IT2,IT3,ITM,N3,IA123,IAT1,NO1,IS1,IA1,IAT2,NO2,IS2,
     &         IA2,IAT3,NO3,IS3,IA3,IL,IM1,IM2,IM3,I,J,K
C     ==--------------------------------------------------------------==
      IT1 = 1
      IT2 = IT1 + NATTOT*NUMIN
      IT3 = IT2 + NATTOT*NUMIN
      ITM = IT3 + NATTOT*NATTOT - 1
      CALL TEST_SCR('SATCH3','2*NATTOT*NUMIN+NATTOT*NATTOT',
     &              LSCR,ITM)
      CALL GET_ADDR(IP_T1,SCR(IT1))
      CALL GET_ADDR(IP_T2,SCR(IT2))
      CALL GET_ADDR(IP_T3,SCR(IT3))
C     ==--------------------------------------------------------------==
      N3=NAT*NAT*NAT/6 + 1
      CALL AZZERO(SAC3,N3)
      IA123=0
      IAT1=0
      NO1=1
      DO IS1=1,NSP
        DO IA1=1,NA(IS1)
          IAT1=IAT1+1
          IAT2=0
          NO2=1
          DO IS2=1,NSP
            DO IA2=1,NA(IS2)
              IAT2=IAT2+1
              IAT3=0
              NO3=1
              DO IS3=1,NSP
                DO IA3=1,NA(IS3)
                  IAT3=IAT3+1
                  IF((IAT3.GT.IAT2).AND.(IAT2.GT.IAT1)) THEN
                    IL=0
                    DO IM1=NO1,NO1+MAOS(IS1)-1
                      IL=IL+1
                      LIST(IL)=IM1
                    ENDDO
                    DO IM2=NO2,NO2+MAOS(IS2)-1
                      IL=IL+1
                      LIST(IL)=IM2
                    ENDDO
                    DO IM3=NO3,NO3+MAOS(IS3)-1
                      IL=IL+1
                      LIST(IL)=IM3
                    ENDDO
                    IF(IL.GT.LISTM) CALL STOPGM('SATCH3','LISTM')
                    DO I=1,IL
                      CALL DCOPY(NATTOT,CA(1,LIST(I)),1,T1(1,I),1)
                    ENDDO
                    IA123=IA123+1
                    CALL TRACEDP(NATTOT,IL,SAC3(IA123),D,S,T1,T2,T3)
                  ENDIF
                  NO3=NO3+MAOS(IS3)
                ENDDO
              ENDDO
              NO2=NO2+MAOS(IS2)
            ENDDO
          ENDDO
          NO1=NO1+MAOS(IS1)
        ENDDO
      ENDDO
      IA123=0
      DO I=1,NAT
        DO J=I+1,NAT
          DO K=J+1,NAT
            IA123=IA123+1
            SAC3(IA123)=SAC3(IA123)+SAC(I,J)+SAC(I,K)+SAC(J,K)-
     *                  SAC(I,I)-SAC(J,J)-SAC(K,K)
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SATCH4(D,S,CA,NUMIN,SAC,SAC3,SAC4,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == CALCULATE 4-CENTER SHARED ATOMIC CHARGES                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'prop.inc'
C     Arguments
      INTEGER   NUMIN,LSCR
      REAL*8    D(NATTOT,*),S(NATTOT,*),CA(NATTOT,*),SAC(NAT,NAT),
     *          SAC3(NAT*NAT*NAT/6 + 1),SAC4(NAT*NAT*NAT*NAT/24 + 1),
     &          SCR(LSCR)
C     Variables
      INTEGER   LISTM
      PARAMETER (LISTM=100)
      INTEGER   LIST(LISTM)
      REAL*8    T1(NATTOT,NUMIN),T2(NATTOT*NUMIN),T3(NATTOT,NATTOT)
      POINTER   (IP_T1,T1),(IP_T2,T2),(IP_T3,T3)
      INTEGER   IT1,IT2,IT3,ITM,N4,IA1234,IAT1,NO1,IS1,IA1,IAT2,
     &          NO2,IS2,IA2,IAT3,NO3,IS3,IA3,IAT4,NO4,IS4,IA4,
     &          IL,IM1,IM2,IM3,IM4,I,J,K,L,IX,I1,I2,I3
C     ==--------------------------------------------------------------==
      IT1 = 1
      IT2 = IT1 + NATTOT*NUMIN
      IT3 = IT2 + NATTOT*NUMIN
      ITM = IT3 + NATTOT*NATTOT - 1
      CALL TEST_SCR('SATCH3','2*NATTOT*NUMIN+NATTOT*NATTOT',
     &              LSCR,ITM)
      CALL GET_ADDR(IP_T1,SCR(IT1))
      CALL GET_ADDR(IP_T2,SCR(IT2))
      CALL GET_ADDR(IP_T3,SCR(IT3))
C     ==--------------------------------------------------------------==
      N4=NAT*NAT*NAT*NAT/24 + 1
      CALL AZZERO(SAC4,N4)
      IA1234=0
      IAT1=0
      NO1=1
      DO IS1=1,NSP
        DO IA1=1,NA(IS1)
          IAT1=IAT1+1
          IAT2=0
          NO2=1
          DO IS2=1,NSP
            DO IA2=1,NA(IS2)
              IAT2=IAT2+1
              IAT3=0
              NO3=1
              DO IS3=1,NSP
                DO IA3=1,NA(IS3)
                  IAT3=IAT3+1
                  IAT4=0
                  NO4=1
                  DO IS4=1,NSP
                    DO IA4=1,NA(IS4)
                      IAT4=IAT4+1
                      IF((IAT4.GT.IAT3).AND.(IAT3.GT.IAT2).AND.
     *                                      (IAT2.GT.IAT1)) THEN
                        IL=0
                        DO IM1=NO1,NO1+MAOS(IS1)-1
                          IL=IL+1
                          LIST(IL)=IM1
                        ENDDO
                        DO IM2=NO2,NO2+MAOS(IS2)-1
                          IL=IL+1
                          LIST(IL)=IM2
                        ENDDO
                        DO IM3=NO3,NO3+MAOS(IS3)-1
                          IL=IL+1
                          LIST(IL)=IM3
                        ENDDO
                        DO IM4=NO4,NO4+MAOS(IS4)-1
                          IL=IL+1
                          LIST(IL)=IM4
                        ENDDO
                        IA1234=IA1234+1
                        DO I=1,IL
                          CALL DCOPY(NATTOT,CA(1,LIST(I)),1,T1(1,I),1)
                        ENDDO
                        CALL TRACEDP(NATTOT,IL,SAC4(IA1234),
     *                                              D,S,T1,T2,T3)
                      ENDIF
                      NO4=NO4+MAOS(IS4)
                    ENDDO
                  ENDDO
                  NO3=NO3+MAOS(IS3)
                ENDDO
              ENDDO
              NO2=NO2+MAOS(IS2)
            ENDDO
          ENDDO
          NO1=NO1+MAOS(IS1)
        ENDDO
      ENDDO
      IA1234=0
      DO I=1,NAT
        DO J=I+1,NAT
          DO K=J+1,NAT
            DO L=K+1,NAT
              IA1234=IA1234+1
              SAC4(IA1234)=-SAC4(IA1234)
     *         +SAC(I,I)+SAC(J,J)+SAC(K,K)+SAC(L,L)
     *         -SAC(I,J)-SAC(I,K)-SAC(I,L)-SAC(J,K)-SAC(J,L)-SAC(K,l)
              IX=0
              DO I1=1,NAT
                DO I2=I1+1,NAT
                  DO I3=I2+1,NAT
                    IX=IX+1
                    IF(I1.EQ.I) THEN
                      IF(I2.EQ.J) THEN
                        IF(I3.EQ.K) SAC4(IA1234)=SAC4(IA1234)+SAC3(IX)
                        IF(I3.EQ.L) SAC4(IA1234)=SAC4(IA1234)+SAC3(IX)
                      ELSEIF(I2.EQ.K.AND.I3.EQ.L) THEN
                        SAC4(IA1234)=SAC4(IA1234)+SAC3(IX)
                      ENDIF
                    ELSEIF(I1.EQ.J) THEN
                      IF(I2.EQ.K.AND.I3.EQ.L) 
     *                       SAC4(IA1234)=SAC4(IA1234)+SAC3(IX)
                    ENDIF
                  ENDDO
                ENDDO
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TRACEDP(N,M,SAC,D,S,C,T2,T3)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N,M
      REAL*8  D(N,N),S(N,N),C(N,M),T2(N*N),T3(N,N), SAC
C     Variables
      INTEGER I,J,INFO
C     ==--------------------------------------------------------------==
      CALL DGEMM('N','N',N,M,N,1.D0,S(1,1),N,C(1,1) ,N,0.D0,T2(1)  ,N)
      CALL DGEMM('T','N',M,M,N,1.D0,C(1,1),N,T2(1)  ,N,0.D0,T3(1,1),M)
      CALL INVMAT(M,T3,T2,INFO)
      CALL DGEMM('N','N',N,M,M,1.D0,C(1,1),N,T3(1,1),M,0.D0,T2(1)  ,N)
      CALL DGEMM('N','T',N,N,M,1.D0,T2(1) ,N,C(1,1) ,N,0.D0,T3(1,1),N)
      DO J=1,N
        DO I=1,N
          SAC=SAC+D(I,J)*T3(I,J)
        ENDDO
      ENDDO
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_CMAOS(LCMAOS,TAG,NUMIN)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !atwf.inc
      INCLUDE 'ions.inc'        !NSP
      INCLUDE 'atwf.inc'        !NATTOT NUMAOR
C     Arguments
      INTEGER LCMAOS,NUMIN
      CHARACTER*30 TAG
C     Variables
      INTEGER NAMAX,IT1,IT2,IT3,IT4,IT5,ITM,IN
C     ==--------------------------------------------------------------==
      NAMAX=5
      DO IN=1,NSP
        NAMAX=MAX(NAMAX,NUMAOR(IN))
      ENDDO
      IT1 = 1
      IT2 = IT1 + MAX(NATTOT*NUMIN,1000)
      IT3 = IT2 + MAX(NAMAX*NAMAX,1000)
      IT4 = IT3 + NAMAX*NAMAX
      IT5 = IT4 + NAMAX*NAMAX
      ITM = IT5 + NAMAX*NAMAX
      LCMAOS=MAX(ITM,IT1+NATTOT*NUMIN+NATTOT*NATTOT) - 1
      TAG  ='MAX(ITM,IT1+NATTOT*NUMIN+...)'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_SATCH(LSATCH,TAG,NUMIN)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !atwf.inc
      INCLUDE 'ions.inc'        !atwf.inc
      INCLUDE 'atwf.inc'        !NATTOT
C     Arguments
      INTEGER LSATCH,NUMIN
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      LSATCH=2*NATTOT*NUMIN+NATTOT*NATTOT
      TAG  ='2*NATTOT*NUMIN+NATTOT*NATTOT'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
