C     ==================================================================
      SUBROUTINE CNSTFC(TAU0,TSCR,DXPAR,CNMAX,LAGRA)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ener.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,*),TSCR(3,*),DXPAR(*),CNMAX
      LOGICAL LAGRA
C     Variables
      INTEGER ISUB,IA,IB,IC,ID,ITYP,I,J,K,N,KMAX,IX,IDAMAX,DUM(1)
      REAL*8  X1(3),X2(3),X3(3),X4(3),DX(12),CVAL,SIGN0,R0_SHIFT
C     ==--------------------------------------------------------------==
      CNMAX=0.0D0
      ECNSTR=0.0D0
      IF(MCNSTR.EQ.0) RETURN
      CALL TISET('    CNSTFC',ISUB)
C     No constraints -> return.

      CALL DUM2(TAU0,TSCR)
      CALL AZZERO(ANORM,MCNSTR*NODIM)
      DO I=1,MCNSTR
        CVAL=CNSVAL(I)
        ITYP=NTCNST(1,I)
        IA=NTCNST(2,I)
        IB=NTCNST(3,I)
        IC=NTCNST(4,I)
        ID=NTCNST(5,I)
        IF(ITYP.EQ.1) THEN
C..stretch
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FUNCR(FC(I),FV(I),CVAL,X1,X2)
          CALL DIFFR(DX,X1,X2)
          KMAX=6
C..angle
        ELSEIF(ITYP.EQ.2) THEN
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FILLC(IC,TSCR,X3)
          CALL FUNCT(FC(I),FV(I),CVAL,X1,X2,X3)
          CALL DIFFT(DX,X1,X2,X3)
          KMAX=9
        ELSEIF(ITYP.EQ.3) THEN
C..dihedral angle
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FILLC(IC,TSCR,X3)
          CALL FILLC(ID,TSCR,X4)
          CALL FUNCO(FC(I),FV(I),CVAL,X1,X2,X3,X4,SIGN0)
          CALL DIFFO(DX,X1,X2,X3,X4,SIGN0)
          KMAX=12
        ELSEIF(ITYP.EQ.4) THEN
C..distance
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FUNCD(FC(I),FV(I),CVAL,X1,X2)
          CALL DIFFD(DX,X1,X2)
          KMAX=6
        ELSEIF(ITYP.EQ.5) THEN
C..out of plane
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FILLC(IC,TSCR,X3)
          CALL FILLC(ID,TSCR,X4)
          CALL FUNCP(FC(I),FV(I),CVAL,X1,X2,X3,X4,DX)
          KMAX=12
        ELSEIF(ITYP.EQ.6) THEN
C..coordination number
          C_KAPPA = CNPAR(1,I)
          C_RC    = CNPAR(2,I)
          CALL COORNUM(IA,C_KAPPA,C_RC,TSCR,NAT,ANORM(1,I),LSKPTR,
     *                 FC(I),FV(I),CVAL)
          KMAX=0
        ELSEIF(ITYP.EQ.7) THEN
C..difference between distances- 3 atoms
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FILLC(IC,TSCR,X3)
          CALL FUNCDD(FC(I),FV(I),CVAL,X1,X2,X3)
          CALL DIFFDD(DX,X1,X2,X3)
          KMAX=9
        ELSEIF(ITYP.EQ.8) THEN
C..species dependent coordination number with Fermi function
          C_KAPPA = CNPAR(1,I) 
          C_RC    = CNPAR(2,I)
          CALL COORNUMSP(IA,IB,C_KAPPA,C_RC,TSCR,ANORM(1,I),
     *                 LSKPTR,FC(I),FV(I),CVAL)
          KMAX=0
        ELSEIF(ITYP.EQ.9) THEN
C..species dependent coordination number with rational function
          C_RC    = CNPAR(1,I)
          R0_SHIFT  = CNPAR(2,I)
          CALL COORN_RF(IA,IB,IC,ID,C_RC,R0_SHIFT,TSCR,ANORM(1,I),
     *                 FC(I),FV(I),CVAL,1,DUM)
          KMAX=0
        ELSEIF(ITYP.EQ.10) THEN
C..bond switch with rational function
          C_RC    = CNPAR(1,I)
          CALL BNDSWITCH(IA,IB,IC,ID,C_RC,TSCR,ANORM(1,I),
     *                 FC(I),FV(I),CVAL)
          KMAX=0
        ELSEIF(ITYP.EQ.11) THEN
C..total species dependent coordination number with rational function
          C_RC    = CNPAR(1,I)
          R0_SHIFT  = CNPAR(2,I)
          CALL COORNTOT_RF(IA,IB,IC,ID,C_RC,R0_SHIFT,
     *           TSCR,ANORM(1,I),FC(I),FV(I),CVAL,1,DUM)
          KMAX=0
        ELSEIF(ITYP.EQ.12) THEN
C..distance between two atoms along a selected direction
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          DO K=1,3
            IF(K.NE.IC) THEN
              X1(K)=0.0D0
              X2(K)=0.0D0
            ENDIF
          ENDDO
          CALL FUNCD(FC(I),FV(I),CVAL,X1,X2)
          CALL DIFFD(DX,X1,X2)
          KMAX=6
        ELSE
          WRITE(6,*) ' CNSTFC! I=',I,' TYPE=',ITYP
          CALL STOPGM('CNSTFC','UNKNOWN TYPE OF CONSTRAINT')
        END IF

        DO K=1,KMAX
          DO N=1,NODIM
            ANORM(N,I)=ANORM(N,I)+DX(K)*ASKEL(N,I,K)
          ENDDO
        ENDDO
      ENDDO
      CALL AZZERO(FCSTR,NODIM)
      DO I=1,MCNSTR
        DO J=1,NODIM
          IF(LAGRA) THEN
            FCSTR(J)=FCSTR(J)+XLAGR(I)*ANORM(J,I)
          ELSE
            FCSTR(J)=FCSTR(J)+CSIGM(I)*ANORM(J,I)*FC(I)
          ENDIF
        ENDDO
        IF(.NOT.LAGRA) ECNSTR=ECNSTR+0.5D0*CSIGM(I)*FC(I)*FC(I)
      ENDDO
      IX=IDAMAX(NODIM,FCSTR(1),1)
      CNMAX=ABS(FCSTR(IX))
      CALL DAXPY(NODIM,1.0D0,FCSTR(1),1,DXPAR(1),1)
      CALL TIHALT('    CNSTFC',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FILLC(IAT,TAU,X)
C     ==--------------------------------------------------------------==
C     == Extract the coordinates X(1:3) of IAT index in TAU (TSCR)    ==
C     == Works also if dummy atoms                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER IAT
      REAL*8 TAU(3,NAX*NSX),X(3)
C     Local
      INTEGER ID,NAA,ITYP
C     ==--------------------------------------------------------------==
      IF(IAT.LE.0) THEN
C       Do nothing
        RETURN
      ELSEIF(IAT.LE.NAT) THEN
C       Real atoms
        X(1)=TAU(1,IAT)
        X(2)=TAU(2,IAT)
        X(3)=TAU(3,IAT)
      ELSEIF(IAT.LE.NAT+NDAT) THEN
C       Dummy atoms (type 1-3).
        NAA=IAT-NAT
        ITYP=LISTDA(NAA,1)
        ID=LISTDA(NAA,2)
        IF(ITYP.EQ.3) THEN
          X(1)=DUMMY3(1,ID)
          X(2)=DUMMY3(2,ID)
          X(3)=DUMMY3(3,ID)
        ELSEIF(ITYP.EQ.2) THEN
          X(1)=DUMMY2(1,ID)
          X(2)=DUMMY2(2,ID)
          X(3)=DUMMY2(3,ID)
        ELSEIF(ITYP.EQ.1) THEN
          X(1)=DUMMY1(1,ID)
          X(2)=DUMMY1(2,ID)
          X(3)=DUMMY1(3,ID)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE COORNUM(IA,C1_KAPPA,C1_RC,TSCR,NAT,AN,LSK,FCI,FVI,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C     Arguments
      INTEGER IA,NAT,LSK(3,NAT)
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_KAPPA,C1_RC,XX(3)
C     Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,DF,FFF
      INTEGER IAT,K,L1,L2,L3
      INTEGER IB,NAA, ITYP, JJ,KX,JX,JY,JZ,J
C     ==--------------------------------------------------------------==
      IF(IA.LE.NAT) THEN
        L1 = LSK(1,IA)
        L2 = LSK(2,IA)
        L3 = LSK(3,IA)
      ENDIF
      CALL FILLC(IA,TSCR,XX)
      X0 = XX(1)
      Y0 = XX(2)
      Z0 = XX(3)
      FVI = 0.D0
      DO IAT=1,NAT
        DX=TSCR(1,IAT)-X0
        DY=TSCR(2,IAT)-Y0
        DZ=TSCR(3,IAT)-Z0
        IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
        DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
C..exclude self interaction
        IF(DD.GT.1.D-2) THEN
          DF=C1_KAPPA*(DD-C1_RC)
          FVI=FVI+1.D0/(DEXP(DF)+1.D0)
          FF=-0.5D0*C1_KAPPA/(COSH(DF)+1.D0)/DD
          IF(LSK(1,IAT).NE.0) THEN
            K=LSK(1,IAT)
            AN(K)=AN(K)+FF*DX
          ENDIF
          IF(LSK(2,IAT).NE.0) THEN
            K=LSK(2,IAT)
            AN(K)=AN(K)+FF*DY
          ENDIF
          IF(LSK(3,IAT).NE.0) THEN
            K=LSK(3,IAT)
            AN(K)=AN(K)+FF*DZ
          ENDIF
          IF(IA.LE.NAT) THEN
            IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
            IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
            IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
          ELSEIF(IA.LE.NAT+NDAT) THEN
            NAA=IA-NAT
            ITYP=LISTDA(NAA,1)
            IF(ITYP.EQ.1) THEN
              GOTO 110
            ELSEIF(ITYP.EQ.2) THEN
              KX=LISTDA(NAA,2)
              JJ=LISTD2(1,KX)
              FFF=1.0D0/DBLE(JJ)
              DO J=1,JJ
                IB=LISTD2(J+1,KX)
                JX=LSKPTR(1,IB)
                JY=LSKPTR(2,IB)
                JZ=LSKPTR(3,IB)
                IF(JX.NE.0) AN(JX)=AN(JX)-FF*DX*FFF
                IF(JY.NE.0) AN(JY)=AN(JY)-FF*DY*FFF
                IF(JZ.NE.0) AN(JZ)=AN(JZ)-FF*DZ*FFF
              ENDDO
            ENDIF
          ENDIF
 110      CONTINUE
        ENDIF
      ENDDO
      FCI=FVI-CVAL
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE COORNUMSP(IA,ISP,C1_KAPPA,C1_RC,TSCR,AN,LSK,
     &                   FCI,FVI,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C     Arguments
      INTEGER IA,ISP,LSK(3,NAT)
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_KAPPA,C1_RC
C     Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,DF,XX(3),FFF
      INTEGER IAT,K,L1,L2,L3,IS,IINI,IEND
      INTEGER IB,NAA,ITYP,KX,JJ,JX,JY,JZ,J
C     ==--------------------------------------------------------------==
      IF(IA.LE.NAT) THEN
        L1 = LSK(1,IA)
        L2 = LSK(2,IA)
        L3 = LSK(3,IA)
      ENDIF
      CALL FILLC(IA,TSCR,XX)
      X0 = XX(1)
      Y0 = XX(2)
      Z0 = XX(3)

      FVI = 0.D0
      IINI = 1
      DO IS = 1,ISP-1
        IINI=IINI+NA(IS)
      ENDDO
      IEND = IINI + NA(ISP) -1
      DO IAT=IINI,IEND
        DX=TSCR(1,IAT)-X0
        DY=TSCR(2,IAT)-Y0
        DZ=TSCR(3,IAT)-Z0
        IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
        DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
C..exclude self interaction
        IF(DD.GT.1.D-2) THEN
          DF=C1_KAPPA*(DD-C1_RC)
          FVI=FVI+1.D0/(DEXP(DF)+1.D0)
          FF=-0.5D0*C1_KAPPA/(COSH(DF)+1.D0)/DD
          IF(LSK(1,IAT).NE.0) THEN
            K=LSK(1,IAT)
            AN(K)=AN(K)+FF*DX
          ENDIF
          IF(LSK(2,IAT).NE.0) THEN
            K=LSK(2,IAT)
            AN(K)=AN(K)+FF*DY
          ENDIF
          IF(LSK(3,IAT).NE.0) THEN
            K=LSK(3,IAT)
            AN(K)=AN(K)+FF*DZ
          ENDIF
          IF(IA.LE.NAT) THEN
            IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
            IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
            IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
          ELSEIF(IA.LE.NAT+NDAT) THEN
            NAA=IA-NAT
            ITYP=LISTDA(NAA,1)
            IF(ITYP.EQ.1) THEN
              GOTO 110
            ELSEIF(ITYP.EQ.2) THEN
              KX=LISTDA(NAA,2)
              JJ=LISTD2(1,KX)
              FFF=1.0D0/DBLE(JJ)
              DO J=1,JJ
                IB=LISTD2(J+1,KX)
                JX=LSKPTR(1,IB)
                JY=LSKPTR(2,IB)
                JZ=LSKPTR(3,IB)
                IF(JX.NE.0) AN(JX)=AN(JX)-FF*DX*FFF
                IF(JY.NE.0) AN(JY)=AN(JY)-FF*DY*FFF
                IF(JZ.NE.0) AN(JZ)=AN(JZ)-FF*DZ*FFF
              ENDDO
            ENDIF
          ENDIF
 110      CONTINUE
        ENDIF
      ENDDO
      FCI=FVI-CVAL
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE COORNUMGRP(NA_GRP,MAXNB_GRP,NB_GRP,
     C           IA,IB,C1_KAPPA,C1_RC_A,TSCR,AN,LSK,FCI,FVI,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C     Arguments
      INTEGER NA_GRP,MAXNB_GRP
      INTEGER NB_GRP(NA_GRP),IA(NA_GRP),IB(NA_GRP*MAXNB_GRP),
     c        LSK(3,NAT)
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL
      REAL*8  C1_KAPPA,C1_RC_A(NA_GRP)
C     Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,DF,XX(3),FFF
      INTEGER K,L1,L2,L3
      INTEGER IBB,NAA,ITYP,KX,JJ,JX,JY,JZ,J
      INTEGER IATMA,IATMB,ATMA,ATMB,IPGRPB
C     ==--------------------------------------------------------------==
      FVI = 0.D0
      IPGRPB=0
      DO IATMA=1,NA_GRP
         ATMA=IA(IATMA)
         IF(ATMA.LE.NAT) THEN
           L1 = LSK(1,ATMA) !IAx
           L2 = LSK(2,ATMA) !IAy
           L3 = LSK(3,ATMA) !IAz
         ENDIF      
         CALL FILLC(ATMA,TSCR,XX)
         X0 = XX(1)
         Y0 = XX(2)
         Z0 = XX(3)
         DO IATMB=1,NB_GRP(IATMA)
            IPGRPB=IPGRPB+1
            ATMB=IB(IPGRPB)
           DX=TSCR(1,ATMB)-X0
           DY=TSCR(2,ATMB)-Y0
           DZ=TSCR(3,ATMB)-Z0
           IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
           DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
C..exclude self interaction
           IF(DD.GT.1.D-2) THEN
             DF=C1_KAPPA*(DD-C1_RC_A(IATMA))
             FVI=FVI+1.D0/(DEXP(DF)+1.D0)
             FF=-0.5D0*C1_KAPPA/(COSH(DF)+1.D0)/DD
             IF(LSK(1,ATMB).NE.0) THEN
               K=LSK(1,ATMB)
               AN(K)=AN(K)+FF*DX
             ENDIF
             IF(LSK(2,ATMB).NE.0) THEN
               K=LSK(2,ATMB)
               AN(K)=AN(K)+FF*DY
             ENDIF
             IF(LSK(3,ATMB).NE.0) THEN
               K=LSK(3,ATMB)
               AN(K)=AN(K)+FF*DZ
             ENDIF
             IF(ATMA.LE.NAT) THEN
               IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
               IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
               IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
             ELSEIF(ATMA.LE.NAT+NDAT) THEN
               NAA=ATMA-NAT
               ITYP=LISTDA(NAA,1)
               IF(ITYP.EQ.1) THEN
                 GOTO 130
               ELSEIF(ITYP.EQ.2) THEN
                 KX=LISTDA(NAA,2)
                 JJ=LISTD2(1,KX)
                 FFF=1.0D0/DBLE(JJ)
                 DO J=1,JJ
                   IBB=LISTD2(J+1,KX)
                   JX=LSKPTR(1,IBB)
                   JY=LSKPTR(2,IBB)
                   JZ=LSKPTR(3,IBB)
                   IF(JX.NE.0) AN(JX)=AN(JX)-FF*DX*FFF
                   IF(JY.NE.0) AN(JY)=AN(JY)-FF*DY*FFF
                   IF(JZ.NE.0) AN(JZ)=AN(JZ)-FF*DZ*FFF
                 ENDDO
               ENDIF
             ENDIF
130          CONTINUE
           ENDIF
         END DO
      END DO
      FCI=FVI-CVAL
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE COORN_RF(IA,ISP,NEXP,MEXP,C1_RC,R0_SHIFT,TSCR,AN,
     &                    FCI,FVI,CVAL,SPvsAT,IATOM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C     Arguments
      INTEGER IA,ISP,NEXP,MEXP, IATOM(*),SPvsAT
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_RC,R0_SHIFT
C     Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,RNUM,RDEN,FNUM,FDEN,FFF,XX(3)
      INTEGER IAT,IIAT,K,L1,L2,L3,IS,IINI,IEND
      INTEGER IB,NAA,ITYP,KX,JJ,JX,JY,JZ,J
C     ==--------------------------------------------------------------==
CAK  debug:      call mm_dim_query('enter coorn_rf')
      IF(IA.LE.NAT) THEN
        L1 = LSKPTR(1,IA)
        L2 = LSKPTR(2,IA)
        L3 = LSKPTR(3,IA)
      ENDIF
      CALL FILLC(IA,TSCR,XX)
      X0 = XX(1)
      Y0 = XX(2)
      Z0 = XX(3)

      FVI = 0.D0
      IINI = 1
      IF(SPvsAT .EQ. 1) THEN
        DO IS = 1,ISP-1
          IINI=IINI+NA(IS)
        ENDDO
        IEND = IINI + NA(ISP) -1
      ELSE
        IINI = 1
        IEND = ISP
      ENDIF

      DO IIAT=IINI,IEND
        IF(SPvsAT .EQ. 1) THEN
          IAT = IIAT
        ELSE
          IAT = IATOM(IIAT)
        ENDIF
        DX=TSCR(1,IAT)-X0
        DY=TSCR(2,IAT)-Y0
        DZ=TSCR(3,IAT)-Z0
        IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
        DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
C..exclude self interaction
        IF(DD.GT.1.D-2) THEN
          RNUM = ((DD-R0_SHIFT)/C1_RC)**NEXP
          RDEN = ((DD-R0_SHIFT)/C1_RC)**(NEXP+MEXP)
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) THEN
            FVI = FVI + DBLE(NEXP)/DBLE(NEXP+MEXP)
            FF  = -0.5D0*DBLE(NEXP*MEXP)/DBLE(NEXP+MEXP)/(C1_RC*DD)
          ELSE
            FVI  = FVI + FNUM/FDEN
            FF   = -(RNUM*DBLE(NEXP)-FNUM*RDEN*DBLE(NEXP+MEXP)/
     &               FDEN)/(FDEN*(DD-R0_SHIFT)*DD)
          ENDIF
          IF(LSKPTR(1,IAT).NE.0) THEN
            K=LSKPTR(1,IAT)
            AN(K)=AN(K)+FF*DX
          ENDIF
          IF(LSKPTR(2,IAT).NE.0) THEN
            K=LSKPTR(2,IAT)
            AN(K)=AN(K)+FF*DY
          ENDIF
          IF(LSKPTR(3,IAT).NE.0) THEN
            K=LSKPTR(3,IAT)
            AN(K)=AN(K)+FF*DZ
          ENDIF

          IF(IA.LE.NAT) THEN
            IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
            IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
            IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
          ELSEIF(IA.LE.NAT+NDAT) THEN
            NAA=IA-NAT
            ITYP=LISTDA(NAA,1)
            IF(ITYP.EQ.1) THEN
              GOTO 110
            ELSEIF(ITYP.EQ.2) THEN
              KX=LISTDA(NAA,2)
              JJ=LISTD2(1,KX)
              FFF=1.0D0/DBLE(JJ)
              DO J=1,JJ
                IB=LISTD2(J+1,KX)
                JX=LSKPTR(1,IB)
                JY=LSKPTR(2,IB)
                JZ=LSKPTR(3,IB)
                IF(JX.NE.0) AN(JX)=AN(JX)-FF*DX*FFF
                IF(JY.NE.0) AN(JY)=AN(JY)-FF*DY*FFF
                IF(JZ.NE.0) AN(JZ)=AN(JZ)-FF*DZ*FFF
              ENDDO
            ENDIF
          ENDIF
 110      CONTINUE
        ENDIF
      ENDDO
      FCI=FVI-CVAL
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE  BNDSWITCH(IA,IB,NEXP,MEXP,C1_RC,TSCR,AN,
     &                      FCI,FVI,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C     Arguments
      INTEGER IA,IB,NEXP,MEXP
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_RC
C     Variables
      REAL*8  XA,YA,ZA,XB,YB,ZB
      REAL*8  DX,DY,DZ,DD,FF,RNUM,RDEN,FNUM,FDEN,FFF,XX(3)
      INTEGER LA1,LA2,LA3,LB1,LB2,LB3
      INTEGER IC,NAA,ITYP,JJ,KX,JX,JY,JZ,J
C     ==--------------------------------------------------------------==

      IF(IA.LE.NAT) THEN
        LA1 = LSKPTR(1,IA)
        LA2 = LSKPTR(2,IA)
        LA3 = LSKPTR(3,IA)
      ENDIF
      CALL FILLC(IA,TSCR,XX)
      XA = XX(1)
      YA = XX(2)
      ZA = XX(3)
      IF(IA.LE.NAT) THEN
        LB1 = LSKPTR(1,IB)
        LB2 = LSKPTR(2,IB)
        LB3 = LSKPTR(3,IB)
      ENDIF
      CALL FILLC(IB,TSCR,XX)
      XB = XX(1)
      YB = XX(2)
      ZB = XX(3)

      FVI = 0.D0
      DX= XB - XA
      DY= YB - YA
      DZ= ZB - ZA
      IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
      DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
      IF(DD.GT.1.D-2) THEN
        RNUM = (DD/C1_RC)**NEXP
        RDEN = (DD/C1_RC)**(NEXP+MEXP)
        FNUM = 1-RNUM
        FDEN = 1-RDEN
        IF(DABS(FDEN) .LT. 1.D-10) THEN
          FVI = FVI + DBLE(NEXP)/DBLE(NEXP+MEXP)
          FF  = -0.5D0*DBLE(NEXP*MEXP)/DBLE(NEXP+MEXP)/(C1_RC*DD)
        ELSE
          FVI  = FVI + FNUM/FDEN
          FF   = -(RNUM*DBLE(NEXP)-FNUM*RDEN*DBLE(NEXP+MEXP)/FDEN)/
     &            (FDEN*DD*DD)
        ENDIF
        IF(IB .LE. NAT) THEN
          IF(LB1.NE.0) AN(LB1)=AN(LA1)+FF*DX
          IF(LB2.NE.0) AN(LB2)=AN(LA2)+FF*DY
          IF(LB3.NE.0) AN(LB3)=AN(LA3)+FF*DZ
        ELSEIF(IB.LE.NAT+NDAT) THEN
          NAA=IB-NAT
          ITYP=LISTDA(NAA,1)
          IF(ITYP.EQ.1) THEN
            GOTO 110
          ELSEIF(ITYP.EQ.2) THEN
            KX=LISTDA(NAA,2)
            JJ=LISTD2(1,KX)
            FFF=1.0D0/DBLE(JJ)
            DO J=1,JJ
              IC=LISTD2(J+1,KX)
              JX=LSKPTR(1,IC)
              JY=LSKPTR(2,IC)
              JZ=LSKPTR(3,IC)
              IF(JX.NE.0) AN(JX)=AN(JX)+FF*DX*FFF
              IF(JY.NE.0) AN(JY)=AN(JY)+FF*DY*FFF
              IF(JZ.NE.0) AN(JZ)=AN(JZ)+FF*DZ*FFF
            ENDDO
          ENDIF
        ENDIF
 110    CONTINUE

        IF(IA .LE. NAT) THEN
          IF(LA1.NE.0) AN(LA1)=AN(LA1)-FF*DX
          IF(LA2.NE.0) AN(LA2)=AN(LA2)-FF*DY
          IF(LA3.NE.0) AN(LA3)=AN(LA3)-FF*DZ
        ELSEIF(IA.LE.NAT+NDAT) THEN
          NAA=IA-NAT
          ITYP=LISTDA(NAA,1)
          IF(ITYP.EQ.1) THEN
            GOTO 120
          ELSEIF(ITYP.EQ.2) THEN
            KX=LISTDA(NAA,2)
            JJ=LISTD2(1,KX)
            FFF=1.0D0/DBLE(JJ)
            DO J=1,JJ
              IC=LISTD2(J+1,KX)
              JX=LSKPTR(1,IC)
              JY=LSKPTR(2,IC)
              JZ=LSKPTR(3,IC)
              IF(JX.NE.0) AN(JX)=AN(JX)-FF*DX*FFF
              IF(JY.NE.0) AN(JY)=AN(JY)-FF*DY*FFF
              IF(JZ.NE.0) AN(JZ)=AN(JZ)-FF*DZ*FFF
            ENDDO
          ENDIF
        ENDIF
 120    CONTINUE
      ENDIF
      FCI=FVI-CVAL
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE RESTFC(TAU0,TSCR,FION)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ener.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,*),TSCR(3,*),FION(3,NAX,*)
C     Variables
      INTEGER ISUB,IA,IB,IC,ID,ITYP,I,J,K,N,KMAX,DUM(1)
      REAL*8  X1(3),X2(3),X3(3),X4(3),DX(12),CVAL,SIGN0,SCAL,R0_SHIFT
C     ==--------------------------------------------------------------==
      ERESTR=0.0d0
      IF(MRESTR.EQ.0) RETURN
      CALL TISET('    RESTFC',ISUB)

      CALL DUM2(TAU0,TSCR)
      CALL AZZERO(ANORM,MRESTR*NODIM)
      DO I=1,MRESTR
        CVAL=RESVAL(I)
        ITYP=NTREST(1,I)
        IA=NTREST(2,I)
        IB=NTREST(3,I)
        IC=NTREST(4,I)
        ID=NTREST(5,I)
        IF(ITYP.EQ.1) THEN
C..stretch
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FUNCR(RESC(I),RESV(I),CVAL,X1,X2)
          CALL DIFFR(DX,X1,X2)
          KMAX=6
C..angle
        ELSEIF(ITYP.EQ.2) THEN
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FILLC(IC,TSCR,X3)
          CALL FUNCT(RESC(I),RESV(I),CVAL,X1,X2,X3)
          CALL DIFFT(DX,X1,X2,X3)
          KMAX=9
        ELSEIF(ITYP.EQ.3) THEN
C..dihedral angle
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FILLC(IC,TSCR,X3)
          CALL FILLC(ID,TSCR,X4)
          CALL FUNCO(RESC(I),RESV(I),CVAL,X1,X2,X3,X4,SIGN0)
          CALL DIFFO(DX,X1,X2,X3,X4,SIGN0)
          KMAX=12
        ELSEIF(ITYP.EQ.4) THEN
C..distance
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FUNCD(RESC(I),RESV(I),CVAL,X1,X2)
          CALL DIFFD(DX,X1,X2)
          KMAX=6
        ELSEIF(ITYP.EQ.5) THEN
C..out of plane
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FILLC(IC,TSCR,X3)
          CALL FILLC(ID,TSCR,X4)
          CALL FUNCP(RESC(I),RESV(I),CVAL,X1,X2,X3,X4,DX)
          KMAX=12
        ELSEIF(ITYP.EQ.7) THEN
C..difference between distances- 3 atoms
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          CALL FILLC(IC,TSCR,X3)
          CALL FUNCDD(RESC(I),RESV(I),CVAL,X1,X2,X3)
          CALL DIFFDD(DX,X1,X2,X3)
          KMAX=9
        ELSEIF(ITYP.EQ.9) THEN
C..species dependent coordination number with rational function
          C_RC    = RESPAR(1,I)
          R0_SHIFT  = RESPAR(2,I)
          CALL COORN_RF(IA,IB,IC,ID,C_RC,R0_SHIFT,TSCR,ANORM(1,I),
     *                 RESC(I),RESV(I),CVAL,1,DUM)
          KMAX=0
        ELSEIF(ITYP.EQ.12) THEN
C..distance between two atoms along a selected direction
          CALL FILLC(IA,TSCR,X1)
          CALL FILLC(IB,TSCR,X2)
          DO K=1,3
            IF(K.NE.IC) THEN
              X1(K)=0.0D0
              X2(K)=0.0D0
            ENDIF
          ENDDO
          CALL FUNCD(RESC(I),RESV(I),CVAL,X1,X2)
          CALL DIFFD(DX,X1,X2)
          KMAX=6
        ELSEIF(ITYP.EQ.13) THEN ! cmb-kk
C..restraint positional
          CALL FILLC(IA,TSCR,X1)
          DO K=1,3
            X2(K)=RESPOS(K,I)
          ENDDO
          CALL FUNCD(RESC(I),RESV(I),CVAL,X1,X2)
          CALL DIFFD(DX,X1,X2)
          KMAX=3
        ELSE
          WRITE(6,*) ' RESTFC! I=',I,' TYPE=',ITYP
          CALL STOPGM('RESTFC','UNKNOWN TYPE OF RESTRAINT')
        END IF

        DO K=1,KMAX
          DO N=1,NODIM
            ANORM(N,I)=ANORM(N,I)+DX(K)*RSKEL(N,I,K)
          ENDDO
        ENDDO
      ENDDO

      CALL AZZERO(FCSTR,NODIM)
      CALL AZZERO(RESFDIFF,MRESTR)
      CALL AZZERO(RESM,MRESTR*MRESTR)

      IF(.NOT.LHYPERPLANE) THEN
        DO I=1,MRESTR
          DO J=1,NODIM
            FCSTR(J)=FCSTR(J)+RESFOR(I)*ANORM(J,I)*RESC(I)
          ENDDO
          RESFDIFF(I)=RESFOR(I)*RESC(I)
          CALL AZZERO(RESM(1,I),MRESTR)
          DO J=1,MRESTR
            DO K=1,NODIM
              RESM(J,I)=RESM(J,I)+ANORM(K,I)*ANORM(K,J)/RSMASS(K)
            ENDDO
          ENDDO
          ERESTR=ERESTR+0.5D0*RESFOR(I)*RESC(I)*RESC(I)
        ENDDO
      ELSE
        SCAL=0.0D0
        DO I=1,MRESTR
          RESFDIFF(I)=RESFOR(I)*RESC(I)
          SCAL=SCAL+RESFDIFF(I)
        ENDDO
        DO I=1,MRESTR
          DO J=1,NODIM
            FCSTR(J)=FCSTR(J)+RESFOR(I)*ANORM(J,I)*SCAL
          ENDDO
          CALL AZZERO(RESM(1,I),MRESTR)
          DO J=1,MRESTR
            DO K=1,NODIM
              RESM(J,I)=RESM(J,I)+ANORM(K,I)*ANORM(K,J)
            ENDDO
          ENDDO
          ERESTR=ERESTR+0.5D0*RESFOR(I)*RESC(I)*SCAL
        ENDDO
      ENDIF

      CALL GETTAU(TSCR,FCSTR)
      CALL DAXPY(3*NAX*NSX,-1.D0,TSCR,1,FION,1)
      CALL TIHALT('    RESTFC',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
