C     ==================================================================
      SUBROUTINE CNSTPR
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cotr.inc'
      INCLUDE 'mm_dim.inc'  ! NAT_grm
C     Variables
      CHARACTER STYP(13)*10
      DATA      STYP /'   STRETCH','      BEND','   TORSION',
     .                '  DISTANCE','      OUTP','COORDINAT.',
     .                'DIFFERENCE','    COORSP','   COOR_RF',
     .                'BN. SWITCH','  TOT_COOR','   DISAXIS',
     .                '    RESPOS'/
      CHARACTER LTYP(-1:1)*10
      DATA      LTYP /'     MINUS','     FIXED','      PLUS'/
      REAL*8    CVAL,FVAL
      INTEGER   I,ITYP,IA1,IA2,IA3,IA4
      LOGICAL   STATUS
C     ==--------------------------------------------------------------==
C     ==  PRINT SOME INFO                                             ==
C     ==--------------------------------------------------------------==

      IF(MCNSTR.EQ.0.AND.MRESTR.EQ.0) RETURN
      call mm_dim(mm_go_mm,status)
      IF(LSHOVE) THEN
        IF(MCNSTR.GT.0) THEN
           WRITE(6,'(/,20X,A)') ' <<<<< CONSTRAINTS >>>>>'
           WRITE(6,'(A)') ' FIXED STRUCTURE ELEMENTS'
           WRITE(6,'(A,A)') '      TYPE     ATOM ATOM ATOM ATOM',
     *                 '       VALUE       DIRECTION'
        ENDIF
        DO I=1,MCNSTR
          CVAL=CNSVAL(I)
          FVAL=FV(I)
          ITYP=NTCNST(1,I)
          IA1=NAT_grm(NTCNST(2,I))
          IA2=NAT_grm(NTCNST(3,I))
          IA3=NAT_grm(NTCNST(4,I))
          IA4=NAT_grm(NTCNST(5,I))
          IF(ITYP.EQ.2.OR.ITYP.EQ.3.OR.ITYP.EQ.5) THEN
            CALL RADDEG(CVAL,1)
            CALL RADDEG(FVAL,1)
          ENDIF
          WRITE(6,'(A,4X,4I5,F12.5,6X,A10)') STYP(ITYP),IA1,IA2,IA3,IA4,
     *             FVAL,LTYP(NTCNST(6,I))
        ENDDO
        WRITE(6,*)
      ELSE
        IF(MCNSTR.GT.0) THEN
           WRITE(6,'(/,20X,A)') ' <<<<< CONSTRAINTS >>>>>'
           WRITE(6,'(A)') ' FIXED STRUCTURE ELEMENTS'
           WRITE(6,'(A,7x,A)') '      TYPE     ATOM ATOM ATOM ATOM',
     *                 '         VALUE      DIFFERENCE'
        ENDIF
        DO I=1,MCNSTR
          CVAL=CNSVAL(I)
          FVAL=FV(I)
          ITYP=NTCNST(1,I)
          IA1=NAT_grm(NTCNST(2,I))
          IA2=NAT_grm(NTCNST(3,I))
          IA3=NAT_grm(NTCNST(4,I))
          IA4=NAT_grm(NTCNST(5,I))
          IF(ITYP.EQ.2.OR.ITYP.EQ.3.OR.ITYP.EQ.5) THEN
            CALL RADDEG(CVAL,1)
            CALL RADDEG(FVAL,1)
          ENDIF
          IF(ITYP.EQ.6) THEN
            WRITE(6,'(A,3X,I5,5X,3F10.5,1PE16.6)') STYP(ITYP),
     *         IA1,CNPAR(1,I),CNPAR(2,I),FVAL,FVAL-CVAL
          ELSEIF(ITYP.EQ.8) THEN
            WRITE(6,'(A,3X,2I5,3F10.5,1PE16.6)') STYP(ITYP),IA1,IA2,
     *         CNPAR(1,I),CNPAR(2,I),FVAL,FVAL-CVAL
          ELSEIF(ITYP.EQ.9 .OR. ITYP.EQ. 11) THEN
            WRITE(6,'(A,3X,4I5,2X,2F10.5,1PE16.6)') STYP(ITYP),
     *         IA1,IA2,IA3,IA4,CNPAR(1,I),FVAL,FVAL-CVAL
          ELSE
            WRITE(6,'(A,3X,4I5,10X,0PF12.5,1PE16.6)') STYP(ITYP),
     *         IA1,IA2,IA3,IA4,FVAL,FVAL-CVAL
          ENDIF
        ENDDO
        DO I=1,MCNSTR
          IF(DABS(GRATE(I)).GT.1.D-10) THEN
            ITYP=NTCNST(1,I)
            CVAL=CNSVAL_DEST(I)
            WRITE(6,'(A,10X,T22,A,10X,0PF18.5,A)') STYP(ITYP),
     *         " Growth Rate: ",GRATE(I),"/at.unit"
            IF(CVAL.NE.-999.D0) THEN
              IF(ITYP.EQ.2.OR.ITYP.EQ.3.OR.ITYP.EQ.5) THEN
                CALL RADDEG(CVAL,1)
              ENDIF
              WRITE(6,'(A,10X,T22,A,10X,0PF18.5)') STYP(ITYP),
     *           " Destination: ",CVAL
            ENDIF
          ENDIF
        ENDDO
        WRITE(6,*)
        IF(MRESTR.GT.0) THEN
           WRITE(6,'(/,20X,A)') ' <<<<< RESTRAINTS >>>>> '
           WRITE(6,'(A)') ' RESTRAINED STRUCTURE ELEMENTS'
           WRITE(6,'(A,A)') '      TYPE      ATOM  ATOM  ATOM  ATOM',
     *                 '     VALUE   FORCE CONSTANT'
        ENDIF
        DO I=1,MRESTR
          CVAL=RESVAL(I)
          ITYP=NTREST(1,I)
          IF(ITYP.EQ.13) THEN ! cmb-kk
            WRITE(6,'(A,4X,I6,3F6.2,F10.5,2X,G15.4)') STYP(ITYP),
     *            NTREST(2,I),RESPOS(1,I),RESPOS(2,I),RESPOS(3,I),
     *            CVAL,RESFOR(I)
          ELSEIF(ITYP.EQ.9.OR.ITYP.EQ.11) THEN
            WRITE(6,'(A,3X,4I5,2X,2F10.5,G15.4)') STYP(ITYP),
     *            NTREST(2,I),NTREST(3,I),NTREST(4,I),NTREST(5,I),
     *            RESPAR(1,I),CVAL,RESFOR(I)
          ELSE
            IF(ITYP.EQ.2.OR.ITYP.EQ.3.OR.ITYP.EQ.5) CALL RADDEG(CVAL,1)
            WRITE(6,'(A,4X,4I6,F10.5,2X,G15.4)') STYP(ITYP),NTREST(2,I),
     *            NTREST(3,I),NTREST(4,I),NTREST(5,I),CVAL,RESFOR(I)
          ENDIF
        ENDDO
        DO I=1,MRESTR
          IF(DABS(GSRATE(I)).GT.1.D-10) THEN
            ITYP=NTREST(1,I)
            CVAL=RESVAL_DEST(I)
            WRITE(6,'(A,10X,T22,A,10X,0PF18.5,A)') STYP(ITYP),
     *         " Growth Rate: ",GSRATE(I),"/at.unit"
            IF(CVAL.NE.-999.D0) THEN
              IF(ITYP.EQ.2.OR.ITYP.EQ.3.OR.ITYP.EQ.5) THEN
                CALL RADDEG(CVAL,1)
              ENDIF
              WRITE(6,'(A,10X,T22,A,10X,0PF18.5)') STYP(ITYP),
     *           " Destination: ",CVAL
            ENDIF
          ENDIF
        ENDDO
        WRITE(6,*)
      ENDIF
C     ==--------------------------------------------------------------==
      call mm_dim(mm_revert,status)
      RETURN
      END
C     ==================================================================
