C     ==================================================================
      SUBROUTINE COFOR(FION,VPOT)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == FORCES ON IONS DUE TO CORE CHARGES                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'nlcc.inc'
C     Arguments
      REAL*8     FION(3,NAX,*)
      COMPLEX*16 VPOT(NHG,*)
C     Variables
      DIMENSION  RHOC(NHG,*),VNLCC(NHG,*),EIGRB(NHG,*)
      COMPLEX*16 VXC,EI123
      REAL*8     FNL(*),DFNL(*)
      REAL*8     OMTP,VCGS
      INTEGER    ISA,IS,IA,IG
C     ==--------------------------------------------------------------==
      OMTP=2.D0*OMEGA*TPIBA
C$OMP parallel do private(ISA,IA,IS,IG,EI123,VXC,VCGS) shared(OMTP)
      DO ISA=1,NAT
        IA=IATPT(1,ISA)
        IS=IATPT(2,ISA)
        IF(TNLCC(IS)) THEN
          DO IG=1,NHG
            IF(BIGMEM) THEN
              EI123=EIGRB(IG,ISA)
            ELSE
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *            EI3(ISA,INYH(3,IG))
            ENDIF
            VXC=VPOT(IG,1)-VNLT(IG)-VNLCC(IG,1)
            IF(TLSD) VXC=0.5D0*(VXC+VPOT(IG,2)-VNLT(IG)-VNLCC(IG,2))
            VCGS=-DIMAG(DCONJG(VXC)*EI123*RHOC(IG,IS))
            FION(1,IA,IS)=FION(1,IA,IS)+GK(1,IG)*VCGS*OMTP
            FION(2,IA,IS)=FION(2,IA,IS)+GK(2,IG)*VCGS*OMTP
            FION(3,IA,IS)=FION(3,IA,IS)+GK(3,IG)*VCGS*OMTP
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
