C     ==================================================================
      SUBROUTINE CONTROL_BCAST
C     ==--------------------------------------------------------------==
C     ==  BROADCAST THE VARIABLES SET IN CONTROL                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'struc.inc'
      INCLUDE 'prden.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'benc.inc'
      INCLUDE 'nort.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'andr.inc'
      INCLUDE 'broy.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'store.inc'
      INCLUDE 'wann.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'xinr.inc'
      INCLUDE 'g_loc.inc'
      INCLUDE 'comvel.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'vdwc.inc'
      INCLUDE 'shop.inc'
      INCLUDE 'shop_rest.inc'
      INCLUDE 'merge.inc'
      INCLUDE 'cdft.inc'
      INCLUDE 'prng.inc'
      INCLUDE 'gle.inc'
C     Variables
      INTEGER   MSGLEN
C     ==--------------------------------------------------------------==
C     CNTL
      MSGLEN = MLOGO * 8/IRAT
      CALL MY_BCAST(CNTL1,MSGLEN,SOURCE,ALLGRP)
C     CNTI
      MSGLEN = MINTE * 8/IRAT
      CALL MY_BCAST(CNTI1,MSGLEN,SOURCE,ALLGRP)
C     CNTR
      MSGLEN = MREAL * 8
      CALL MY_BCAST(CNTR1,MSGLEN,SOURCE,ALLGRP)
C     RESTART
      MSGLEN = MRESTART * 8/IRAT
      CALL MY_BCAST(RESTART,MSGLEN,SOURCE,ALLGRP)
C     ROUT
      MSGLEN = MROUT * 8/IRAT
      CALL MY_BCAST(ROUT,MSGLEN,SOURCE,ALLGRP)
C     TRAJSMALL, TRAJSMALLN
      MSGLEN = 1* 8/IRAT
      CALL MY_BCAST(TRAJSMALL,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1* 8/IRAT
      CALL MY_BCAST(TRAJSMALLN,MSGLEN,SOURCE,ALLGRP)
C     ISTORE
      MSGLEN = MSTORE * 8/IRAT
      CALL MY_BCAST(ISTORE,MSGLEN,SOURCE,ALLGRP)
C     QSPL
      MSGLEN = 2 * 8/IRAT
      CALL MY_BCAST(QSPLINE,MSGLEN,SOURCE,ALLGRP)
C     BENC
      MSGLEN = NBENTR * 8/IRAT
      CALL MY_BCAST(IBENCH,MSGLEN,SOURCE,ALLGRP)
C     PRDEN
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NUMPR,MSGLEN,SOURCE,ALLGRP)
      IF(NUMPR.NE.0)  THEN
        IF(.NOT.PARENT) CALL MEMORY(IP_MWFN,NUMPR,'MWFN')
        MSGLEN = NUMPR * 8/IRAT
        CALL MY_BCAST(MWFN,MSGLEN,SOURCE,ALLGRP)
      ENDIF
C     ANDR
      MSGLEN = (3 + MAXMIX*2 + 2) * 8
      CALL MY_BCAST(ANDRMIX,MSGLEN,SOURCE,ALLGRP)
C     DENSNRDIIS
      MSGLEN = (4 + MAXMIX*3) * 8/IRAT
      CALL MY_BCAST(DENSNRDIIS,MSGLEN,SOURCE,ALLGRP)
C     BROY
      MSGLEN = 4 * 8 + 6 * 8/IRAT
      CALL MY_BCAST(BROYMIX,MSGLEN,SOURCE,ALLGRP)
C     SPIN (NLSD NLSX)
      MSGLEN = 2 * 8/IRAT
      CALL MY_BCAST(NLSD,MSGLEN,SOURCE,ALLGRP)
C     ROKS
      MSGLEN = 10 * 8/IRAT
      CALL MY_BCAST(TLSE,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 12 * 8
      CALL MY_BCAST(MGAB,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(LSEA,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(LSEB,MSGLEN,SOURCE,ALLGRP)
C     NOGRP
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NOGRP,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(QSRANG,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT + 2 * 8
      CALL MY_BCAST(ELFCUT,MSGLEN,SOURCE,ALLGRP)
C     CPRINT
      MSGLEN = (6+IPRINT_MAX) * 8/IRAT
      CALL MY_BCAST(TPRINT,MSGLEN,SOURCE,ALLGRP)
C     WANNIER FUNCTION INFORMATION
      MSGLEN = NWANNL * 8/IRAT
      CALL MY_BCAST(TWANN,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = NWANNI * 8/IRAT
      CALL MY_BCAST(W_MAXS,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = NWANNR * 8
      CALL MY_BCAST(W_STEP,MSGLEN,SOURCE,ALLGRP)
      IF(SW_ORB.GT.0) THEN
        IF(.NOT.PARENT) THEN
          CALL MEMORY(IP_SW_LIST,SW_ORB/IRAT+1,'SW_LIST')
        ENDIF
        MSGLEN = SW_ORB * 8/IRAT
        CALL MY_BCAST(SW_LIST,MSGLEN,SOURCE,ALLGRP)
      ENDIF

C     PRNG SEED
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IPRNG,MSGLEN,SOURCE,ALLGRP)
C     GLE
      MSGLEN = 1* 8/IRAT
      CALL MY_BCAST(GLE_COM,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1* 8/IRAT
      CALL MY_BCAST(GLE_MODE,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1* 8/IRAT
      CALL MY_BCAST(GLE_NS,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1* 8
      CALL MY_BCAST(GLE_OMEGA,MSGLEN,SOURCE,ALLGRP)


C     RESTF
      MSGLEN = MAXRF * 8/IRAT
      CALL MY_BCAST(NSTEPWR,MSGLEN,SOURCE,ALLGRP)
C     SDPL
      MSGLEN = 2 * 8/IRAT
      CALL MY_BCAST(TSDPLINE,MSGLEN,SOURCE,ALLGRP)
C     CAFES
      MSGLEN = 1 * 8 / IRAT
      CALL MY_BCAST(TCAFES,MSGLEN,SOURCE,ALLGRP)
      IF (TCAFES) THEN
        MSGLEN = 1 * 8 / IRAT
        CALL MY_BCAST(NCAFESGRP,MSGLEN,SOURCE,ALLGRP)
        IF (.not. PARENT) THEN
           CALL MEMORY(IP_CAFESINI,2/IRAT*NCAFESGRP,'CAFESINI')
           CALL MEMORY(IP_CAFESINR,2*NCAFESGRP,'CAFESINR')
        ENDIF
        MSGLEN = NCAFESGRP * 8 / IRAT
        CALL MY_BCAST(CAFESINI,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = NCAFESGRP * 8 
        CALL MY_BCAST(CAFESINR,MSGLEN,SOURCE,ALLGRP)
      ENDIF
C     LOCAL TEMPERATURE
      MSGLEN = 1 * 8 / IRAT
      CALL MY_BCAST(TLOCT,MSGLEN,SOURCE,ALLGRP)
      IF (TLOCT) THEN
        MSGLEN = 1 * 8 / IRAT
        CALL MY_BCAST(NLOCT,MSGLEN,SOURCE,ALLGRP)
        CALL MY_BCAST(NLOCRNG,MSGLEN,SOURCE,ALLGRP)
        IF (.not. PARENT) THEN
           CALL MEMORY(IP_LOCTPIN,2*NLOCT,'LOCTPIN')
           CALL MEMORY(IP_LCTRNG,(3*NLOCRNG+1)/IRAT,'LCTRNG')
        ENDIF
        MSGLEN = 2 * NLOCT * 8 
        CALL MY_BCAST(LOCTPIN,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 3 * NLOCRNG * 8 / IRAT
        CALL MY_BCAST(LCTRNG,MSGLEN,SOURCE,ALLGRP)
      ENDIF
C     SURFACE HOPPING  
      IF (TSHOP) THEN
        MSGLEN = 1 * 8 / IRAT
        CALL MY_BCAST(TSHOPOLD,MSGLEN,SOURCE,ALLGRP)
        CALL MY_BCAST(TSHOPRES,MSGLEN,SOURCE,ALLGRP)
      ENDIF
C     CLASSICAL
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(CLASSICAL,MSGLEN,SOURCE,ALLGRP)
C     TURBOCICCO GEOMETRY OPTIMIZATION
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TMIXSD,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TMIXGDIIS,MSGLEN,SOURCE,ALLGRP)      
      CALL MY_BCAST(INR_PREC,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(INR_CONT,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(RMIXSD,MSGLEN,SOURCE,ALLGRP)
C     FDIFF
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TREF_FDIFF,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 4 * 8
      CALL MY_BCAST(COORD_FDIFF,MSGLEN,SOURCE,ALLGRP)
C     G_LOCALIZATION OF FUNCTION INFORMATION
      MSGLEN = LGLOCLOG * 8/IRAT
      CALL MY_BCAST(TGLOC,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 11 * 8/IRAT
      CALL MY_BCAST(GLOC_MAXS,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = LGLOCPAR * 8
      CALL MY_BCAST(GLOC_STEP,MSGLEN,SOURCE,ALLGRP)
      IF(GLOC_ORB.GT.0) THEN
        IF(.NOT.PARENT) 
     &     CALL MEMORY(IP_GLOCLIST,GLOC_ORB/IRAT+1,'GLOC_LIST')
        MSGLEN = GLOC_ORB * 8/IRAT
        CALL MY_BCAST(GLOC_LIST,MSGLEN,SOURCE,ALLGRP)
      ENDIF
C     QMMM (FPATH AND RELATED STUFF)
      MSGLEN = 1 * 8 /IRAT
      CALL MY_BCAST(IAPATH,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(IEPATH,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(FO_TDEBUG,MSGLEN,SOURCE,ALLGRP)
      CALL SENDCHAR(FPATH,FO_FPATH_MAX,SOURCE,ALLGRP)
C     INTERFACE TO OTHER PW CODES
      MSGLEN = 2 * 8 /IRAT
      CALL MY_BCAST(INTREAD,MSGLEN,SOURCE,ALLGRP)
C     COM/ROT SUBTRACTION
      MSGLEN = 6 * 8 /IRAT
      CALL MY_BCAST(TSUBCOM,MSGLEN,SOURCE,ALLGRP)
C     SLIMIT
      MSGLEN = 1 * 8
      CALL MY_BCAST(SLIMIT,MSGLEN,SOURCE,ALLGRP)
C     CDFT
      MSGLEN= 13*8/IRAT
      CALL MY_BCAST(RECW,MSGLEN,SOURCE,ALLGRP)
      MSGLEN= 2*8/IRAT
      CALL MY_BCAST(CDFT_END,MSGLEN,SOURCE,ALLGRP)
      MSGLEN= 6*8
      CALL MY_BCAST(CZONES,MSGLEN,SOURCE,ALLGRP)
      MSGLEN= 1*8
      CALL MY_BCAST(CDFT_NC,MSGLEN,SOURCE,ALLGRP)
      MSGLEN= 1*8
      CALL MY_BCAST(CDFT_V,MSGLEN,SOURCE,ALLGRP)
      MSGLEN= 1*8
      CALL MY_BCAST(NOTHER,MSGLEN,SOURCE,ALLGRP)
C     SYSCOMB
      MSGLEN= 4*8/IRAT
      CALL MY_BCAST(N_S0,MSGLEN,SOURCE,ALLGRP)
C     VDW CORRECTION
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(VDWC,MSGLEN,SOURCE,ALLGRP)
C     FILE MERGE
      MSGLEN = 20
      CALL MY_BCAST(MFILN1,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 20
      CALL MY_BCAST(MFILN2,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(MNST1,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(MNST2,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(MORTHO,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 3 * 8
      CALL MY_BCAST(MSHIFT,MSGLEN,SOURCE,ALLGRP)
Cmb-kk -Printing local potential
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TLPOT,MSGLEN,SOURCE,ALLGRP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
