C     ==================================================================
      SUBROUTINE CONTROL_DEF
C     ==--------------------------------------------------------------==
C     ==  THIS ROUTINE SETS THE DEFAULT FOR VARIABLES IN CONTROL      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'struc.inc'
      INCLUDE 'prden.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'benc.inc'
      INCLUDE 'nort.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'andr.inc'
      INCLUDE 'broy.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'store.inc'       !IPRINT
      INCLUDE 'wann.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'kpts.inc'        !TKNOSWAP
      INCLUDE 'prop.inc'
      INCLUDE 'conv.inc'
      INCLUDE 'xinr.inc'
      INCLUDE 'g_loc.inc'
      INCLUDE 'comvel.inc'      !TSUBCOM
      INCLUDE 'time.inc'        !TDEBUG
      INCLUDE 'memc.inc'        !MEMDEB
      INCLUDE 'cnst_dyn.inc'    !LSADPNT
      INCLUDE 'vdwc.inc'        !VDWC
      INCLUDE 'read.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'cdft.inc'
      INCLUDE 'prng.inc'
      INCLUDE 'gle.inc'
C     Variables
#if defined(POINTER8)
      INTEGER*8 I_AD1,I_AD2     !in memc.inc (not used here)
#else
      INTEGER   I_AD1,I_AD2     !in memc.inc (not used here)
#endif
      INTEGER I
C     ==--------------------------------------------------------------==
C     ==  DEFAULTS                                                    ==
C     ==--------------------------------------------------------------==
      MD=.FALSE.
      TMDBO=.FALSE.
      TMDFILE=.FALSE.
      TPRCP=.FALSE.
      GEOPT=.FALSE.
      WFOPT=.FALSE.
      KSENER=.FALSE.
      VIBRAT=.FALSE.
      TSDAN=.FALSE.
      TSPEC=.FALSE.
      TSHOP=.FALSE.
      TQMMM=.FALSE.
      TQMMECH=.FALSE.
      TSAMPL=.FALSE.
      PROPER=.FALSE.
      RESTART=.FALSE.
      CNSTMD=.TRUE.
      GAUDYN=.FALSE.
      ORBROT=.FALSE.
      NONORT=.FALSE.
      TLSD=.FALSE.
      BSYMM=.FALSE.
      NLSD=1
      NLSX=1
      THARM=.FALSE.
      TMASS=.FALSE.
      TREVERS=.FALSE.
      FMATCH=.FALSE.
C     CDFT OPTIONS
      CDFT=.FALSE.
      NEWGRAD=.FALSE.
      DEKK=.FALSE.
      TSYSCOMB=.FALSE.
      TKSHAM=.FALSE.
      TSCOMBM=.FALSE.
      TSCORTHO=.TRUE.
      CDFT_V=0.0D0
      VGSTEP=10.0D0
      MAXVMOV=0.1D0
      NOTHER=0.0D0
      TCZONES=.FALSE.
      GLE_MODE=0              !GLE
      GLE_OMEGA=0.0d0
      GLE_NS=0
      GLE_COM=1
      IPRNG=123456
      CZONES(1,1)=10.0d0
      CZONES(1,2)=1.0d-3 !outmost zone sloppy convergence
      CZONES(2,1)=0.3d0
      CZONES(2,2)=1.0d-4 !medium zone average convergence
      CZONES(3,1)=0.1d0  
      CZONES(3,2)=1.0d-5 !innermost zone good convergence
      CDFT_WEIGHT=.FALSE.
      WSLICE=0.5d0
      WSTEP=1
      RESWF=.FALSE.
      THDA=.FALSE.
      THDAPROJ=.FALSE.
      CCOR=.TRUE. !cutoff correction per default on
      VCCON=1.0d-5
      VCCONU=1.0d-5
      TPRED=.FALSE.
      PREDORD=5
      TPHIO=.FALSE.
      TSPINC=.FALSE.
      PROJNOW=.FALSE.
      RECW=.TRUE. !cdft recalculate weights
      TIPAO=.FALSE.
C     Restart options
      RWF=.FALSE.
      RCO=.FALSE.
      RCELL=.FALSE.
      RAC=.FALSE.
      RHE=.FALSE.
      RNOE=.FALSE.
      RNOP=.FALSE.
      RNOC=.FALSE.
      RVEL=.FALSE.
      RGEO=.FALSE.
      RLATE=.FALSE.
      RVIB=.FALSE.
      RPOT=.FALSE.
      RRHO =.FALSE.
      RKPT =.FALSE.
      RLR=.FALSE.
      RPHES=.FALSE.
      RLSCL=.FALSE.
      RDTL =.FALSE.
      RCON =.FALSE.
      RNON =.FALSE.
      RXTP =.FALSE.
      RPRNG =.FALSE.
      RGLE =.FALSE.
C     Store options
      SWF=.TRUE.
      SRHO=.TRUE.
      SPOT=.FALSE.
C     Store options in another files
      RHOOUT=.FALSE.
      NRHOOUT=0
      ROUT=.TRUE.
      TEBAND=.FALSE.
      TLOWD=.FALSE.
      QUENCHP=.FALSE.
      QUENCHE=.FALSE.
      QUENCHC=.FALSE.
      QUENCHB=.FALSE.
      TBERP=.FALSE.
      TBERE=.FALSE.
      TBERC=.FALSE.
      TRANE=.FALSE.
      TRANP=.FALSE.
      TRANC=.FALSE.
      THEAD=.TRUE.
      TC=.FALSE.
      TCP=.FALSE.
      ANNEI=.FALSE.
      ANNEE=.FALSE.
      ANNEC=.FALSE.
      DAMPI=.FALSE.
      DAMPE=.FALSE.
      DAMPC=.FALSE.
      STOPOT=.FALSE.
      TCHNGW=.FALSE.
      TCHNGR=.FALSE.
      TSDE=.FALSE.
      TSDP=.FALSE.
      TCGP=.FALSE.
      TSDPLINE=.FALSE.
      TSDC=.FALSE.
      DIIS=.FALSE.
      PCG=.FALSE.
      PCGMIN=.FALSE.
      GDIIS=.FALSE.
      BFGS=.FALSE.
      LBFGS=.FALSE.
      PRFO=.FALSE.
      RFO=.FALSE.
      CALDIP=.FALSE.
      TNOSEE=.FALSE.
      TNOSEP=.FALSE.
      TCAFES=.FALSE.
      TULTRA=.FALSE.
      TLOCT=.FALSE.
      TMNOSE=.FALSE.
      TNOSEC=.FALSE.
      TIMING=.TRUE.
      RCOMP=.FALSE.
      WCOMP=.FALSE.
#if defined (__NEC) || defined (CRAY)
      BIGMEM=.TRUE.
#else
      BIGMEM=.FALSE.
#endif
      FCNSTR=.FALSE.
      KRWFN=.FALSE.
      POSVER=.FALSE.
      INITCM=.FALSE.
      FINALCM=.FALSE.
      BOND=.FALSE.
      ANGLE=.FALSE.
      DIHEDRAL=.FALSE.
      TPRES=.FALSE.
      TISOS=.FALSE.
      TCENT=.TRUE. 
      QSPLINE=.FALSE. 
      INITSPL=.TRUE.  
      SIMUL=.FALSE. 
      TMEMCHK=.FALSE.
      TPENN=.FALSE.
      TDIAG=.FALSE.
      TDIAGOPT=.FALSE.
      TFINT=.FALSE.
      TBOGO=.FALSE.
      TFRAL=.FALSE.
      TRAND=.FALSE.
      TDAVI=.FALSE.
      TLANC=.FALSE.
      TFRHO_UPW=.FALSE.
      TTROT=.FALSE.
      TMOVR=.FALSE.
      TEXTRAP=.FALSE.
      TSTRXTP=.FALSE.
      TASPC=.TRUE.
      TDIPD=.FALSE.
      TINTER=.FALSE.
      TELF=.FALSE.
      TEPOT=.FALSE.
      TCC=.FALSE.
      TEXPOT=.FALSE.
      TEXADD=.FALSE.
      TPATH=.FALSE.
      TPIMD=.FALSE.
      TPMIN=.FALSE.
      TRESCALE=.FALSE.
      TSUBCOM=.FALSE.
      TSUBROT=.FALSE.
      TFRSBLK=.FALSE.
      TGMIX=.FALSE.
      TGBROY=.FALSE.
      TADBROY=.FALSE.
      TPREC=.FALSE.
      TWANN=.FALSE.
      TWPRI=.FALSE.
      TWDOS=.FALSE.
      TWMOL=.FALSE.
      TSDENS=.FALSE.
      TFDIST=.FALSE.
      TSYMRHO=.TRUE.
      TRESPONSE=.FALSE.
      THARD=.FALSE.
      TFUSI=.FALSE.
      TMERGE=.FALSE.
      TNACVS=.FALSE.
      TLPOT=.FALSE.
      VOUT=.FALSE.
      ACOUT=.FALSE.
      XTIN=.FALSE.
      XTOUT=.FALSE.
      XGOUT=.FALSE.
      DCOUT=.FALSE.
      TWRITEBINTRAJECTORY=.FALSE.
      MINWRITEATOM=1
      MAXWRITEATOM=1000000
      TWRITEFORCETRAJECTORY=.FALSE.
C     Debugging
      TDEBUG=.FALSE.
      TDEBFOR=.FALSE.
      MEMDEB=.FALSE.
      TDEBIO=.FALSE.
      TDEBACC=.FALSE.
C     Time-Dependent DFT
      TDDFT=.FALSE.
      TNOGEOCHECK=.FALSE.
      TSSEL=.FALSE.
CEHR[
      CMPLX_WF=.FALSE.    
      TMDEH=.FALSE.
      TPSPEC=.FALSE.
      TPDIST=.FALSE.
      TGAUGEP=.FALSE.
      TGAUGEF=.FALSE.
      CHEBY=.FALSE.
      CAYLEY=.FALSE.
      RUKU=.FALSE.
CEHR]     
C     ROKS
      TLSE=.FALSE.
      TROKS=.FALSE.
      TROS=.FALSE.
      LSEA=2.D0
      LSEB=-1.D0
      MGAB(1)=0.5D0
      MGAB(2)=0.5D0
      MGAB(3)=0.5D0
      MGAB(4)=0.5D0
      MGAB(5)=0.5D0
      MGAB(6)=0.5D0
      MGAB(7)=0.5D0
      MGAB(8)=0.5D0
      MGAB(9)=1.5D0
      MGAB(10)=-0.5D0
      MGAB(11)=0.5D0
      MGAB(12)=0.5D0
C     Wfn Localization in G space
      TGLOC=.FALSE.
      TGLOCPRINT=.FALSE.
      TG_KICK = .FALSE.
      TG_COMPLEX = .TRUE.
      TG_REAL = .FALSE.
      TG_TUNE_ST = .FALSE.
      TG_ANTISYMM = .FALSE.
      TG_PENALTY = .FALSE.
      TG_LINESEARCH = .FALSE.
      TG_READ_MATRIX = .FALSE.
      TGLOCREALP = .FALSE.
      TGWANNIER = .FALSE.
      TORBDIST  = .FALSE.
      TTAU      = .FALSE.
      TPOTENTIAL= .FALSE.
      TR4A2A = .FALSE.
C     Initialised here because Kohn-Sham energies used it.
      TKNOSWAP=.FALSE.
      TMIXSD=.FALSE.
      TMIXGDIIS=.false.
      TINR=.FALSE.
      INR_PREC=.FALSE.
      INR_STEP=.FALSE.
      INR_VERBOSE=.FALSE.
      INR_CONT=.FALSE.
      TWSERIAL=.FALSE.
      LSADPNT=.FALSE.   ! cmbike
      TDMAL=.FALSE.
      TEPREFG = .FALSE.
      TEFG = .FALSE.
      TPCGFI = .FALSE.
      TPCGFIC = .FALSE.
      GSHELLOUT = .FALSE.
      VDWC = .FALSE.
      TCART=.FALSE.
      TSHOCK = .FALSE.
      TSIC=.FALSE.      ! cmb_ssic
      TFFTWSDM=.FALSE.  ! loading fftw "wisdom"
C     ==--------------------------------------------------------------==
      FPATH=' '
      CALL MY_GETENV('CPMD_FILEPATH',FPATH)
      IF((INDEX(FPATH,' ')-1).EQ.0) FPATH='./'
C     ==--------------------------------------------------------------==
      NOMORE=10000
      NOMORE_ITER=10000
      NPS=1
      TPRINT=.FALSE.
      IPRINT_STEP=0
      DO I=1,IPRINT_MAX
        IPRINT(I)=0
      ENDDO
      ISTORE=0
      ISCTORE=0
      NTGAUS=1
      NCOMV=10
      NROTV=10
C     Timesteps for electrons and ions
      DELT_IONS=5.D0
      DELT_ELEC=5.D0
      EMASS=400.D0
      CMASS=-1.0D0
      HTHRS=0.5D0
      TOLOG=0.D0
      TOLAD=0.D0
      TOLENE=0.D0
      TOLFOR=3.D0
      TOLRHOFIX=0.0D0
      TOLDETOT=0.D0
      NSTCNV=0
      TOLNG=5.D-4
      TEMPW=0.0D0
      TRAMPT=0.0D0
      TRAMPR=0.0D0
      MAXIT=30
      MDIIS=10
      MAXLDIIS=0
      MINLDIIS=0
      MDIIS_FR=4
      MGDIIS=5
      NRESET=0
      EPSOG=1.D-6
      AMPRC=0.001D0
      AMPRE=0.005D0
      AMPRP=0.05D0
      AMPRD=0.001D0
      INSYS=5
      NPARA=0
      NCHP=3
      NCHS=3
      NCHB=3
      NCALLS0=7
      NIT0=1
      NEDOF0=6.D0
      NKSSTA=0
      NDAVV=0
      IMOVIE=0
      MOUT=.FALSE.
      IPROJ=2
      EPSDAV=1.D-5
      IVDBRD=0
      IVDBWR=0
C     Finite Difference options
      FDIFF=1.D-2
      TREF_FDIFF=.FALSE.
      COORD_FDIFF(1) = 0.D0
      COORD_FDIFF(2) = 0.D0
      COORD_FDIFF(3) = 0.D0
      R_FDIFF = 0.D0
      MEMSIZE=-1.D0
      INWFUN=2
      NRESTF=1
      NTRANS=1
      NUMPR=0
      NTRAJ=1
      NGXYZ=1
      NVIB=1
      NPRES=1
      NOGRP=1
      NSPLP=5000
      NSORDER=0
      WCOMPB=1
      RCOMPB=1
      NACC=NACX
      CALL AZZERO(ACC,NACX)
      CALL IAZZERO(IBENCH,NBENTR)
      NTABMIX=1
      ANDRMIX=0.2D0
      BROYMIX=0.15D0
      W02BROY=0.01D0
      ECUTBROY=-1.D0
      KERMIX=0.0D0
      ALXMIX=0.9D0
      BETAEL=-1.D0
      BETAP=0.D0
      B2LIMIT=1.D-18
      N_FRIES=-1
      NKRY_MAX=6
      NKRY_BLOCK=-1
      NTABTROT=10
      NSSEL=0
      NSKIP=0
      NSAMPLE=1
      MEXTRA=-1
      NASPC=-1
      NSTBLK=0
C.. 
      SLIMIT=0.D0
      DENSTROT(1) = 1.D0
      B2TROT(1) = 1.D-7
      DENSTROT(2) = 0.1D0 
      B2TROT(2) = 1.D-8
      DENSTROT(3) = 0.07D0
      B2TROT(3) = 1.D-10
      DENSTROT(4) = 0.05D0
      B2TROT(4) = 1.D-11
      DENSTROT(5) = 0.02D0
      B2TROT(5) = 1.D-12
      DENSTROT(6) = 0.01D0
      B2TROT(6) = 1.D-13
      DENSTROT(7) = 0.007D0
      B2TROT(7) = 1.D-14
      DENSTROT(8) = 0.004D0
      B2TROT(8) = 1.D-15
      DENSTROT(9) = 0.002D0
      B2TROT(9) = 1.D-16
      DENSTROT(10) = 0.0012D0
      B2TROT(10) = 1.D-17
C..
      DSHIFT=0.D0
      NTABBETAP=1
      NRDIIS=0
      NRDIISMAX=0
      NTABNRDIIS=1
      DMOVRMIX=0.5D0
      TOLCG=1.D0
      NPDIP=1
      IFTYPE=0
      ELFCUT=0.001D0
      ELFEPS=2.87D-5
      TOLC=0.D0
      EKINHR=0.D0
      TAUBP=1.d0
      TAUBE=1.d0
      TAUBC=1.d0
      QSRANG=1.D0
      ICMET=3
      NFRBROY=0
      IBRESET=8
      NGBROY=0 
      W_MAXS=2000
      W_TYPE=1
      W_OPT=2
      NS_WANN=1
      SW_ORB=0
      SW_FIRST=-1
      SW_LAST=-1
      SW_ALL=0
      SW_SPREAD=0.0d0
      W_STEP=0.1D0
      W_EPS=1.D-8
      W_RAN=0.0D0
      W_REF(1)=-1000000.0D0
      W_REF(2)=-1000000.0D0
      W_REF(3)=-1000000.0D0
      CALL IAZZERO(NSTEPWR,MAXRF)
      NSTEPWR(1)=-1
      NRCOPY=0
      ANNERI=1.D0
      ANNERE=1.D0
      ANNERC=1.D0
      DAMPGI=0.D0
      DAMPGE=0.D0
      DAMPGC=0.D0
      RMIXSD=5.d-3
      NREG=5
      GNX_INR(1)=5.D-3
      GNX_INR(2)=1.D-3
      GNX_INR(3)=5.D-4
      GNX_INR(4)=1.D-4
      GNX_INR(5)=5.D-5
      TOLX_INR(1)=5.D-3
      TOLX_INR(2)=1.D-3
      TOLX_INR(3)=5.D-4
      TOLX_INR(4)=1.D-4
      TOLX_INR(5)=5.D-5
      TOL_INR=TOLX_INR(1)
      GLOC_MAXS=20000
      GLOC_TYPE=2
      GLOC_OPT=2
      GLOC_CONST = 1
      GLOC_ORB=0
      GLOC_FIRST=-1
      GLOC_LAST=-1
      GLOC_ALL=0
      GLOC_STEP=0.1D0
      GLOC_EPS=1.D-12
      GLOC_RAN=0.0D0
      GLOC_INIT = 0
      GLOC_MAXIT=20
      GEPSLAG   = 0.000001D0
      WAN_WEIGHT  = 0.0D0
      G2G_WEIGHT  = 1.0D0
cmb_ssic... SIC defaults
      asic=0.2D0
      bsic=0.0D0
C     IPRINT
      CALL IAZZERO(IPRINT,IPRINT_MAX)
C
      NAC=-1
      NBC=-1
C     ==--------------------------------------------------------------==
      NWANOPT=0
C     ==--------------------------------------------------------------==
      ISRLENGTH = 0
C     ==--------------------------------------------------------------==
      INTREAD = .FALSE.
      INTWRITE = .FALSE.
      INTFN = "interface.bin"
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
