C     ==================================================================
      SUBROUTINE CONTROL_PRI(UNKNOWN,IUNK,FFORMAT)
C     ==--------------------------------------------------------------==
C     ==  Prints info on variables of control file                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'struc.inc'
      INCLUDE 'prden.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'benc.inc'
      INCLUDE 'nort.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'andr.inc'
      INCLUDE 'broy.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'store.inc'
      INCLUDE 'wann.inc'
      INCLUDE 'envj.inc'        !TJLIMIT
      INCLUDE 'cotr.inc'
      INCLUDE 'kpts.inc'        !TKNOSWAP
      INCLUDE 'shop.inc'
      INCLUDE 'xinr.inc'
      INCLUDE 'lscal.inc'       !MODE
      INCLUDE 'comvel.inc'      !TSUBCOM
      INCLUDE 'memc.inc'        !MEMDEB
      INCLUDE 'time.inc'        !TDEBUG
      INCLUDE 'fileopen.inc'
      INCLUDE 'adat.inc'        !for EL
      INCLUDE 'vdwc.inc'        !VDWC
      INCLUDE 'prng.inc'        !PRNG
      INCLUDE 'gle.inc'         !GLE
C     INPUT
      CHARACTER  UNKNOWN(30)*60,FFORMAT*30
      INTEGER    IUNK
C     Variables
#if defined(POINTER8)
      INTEGER*8 I_AD1,I_AD2     !in memc.inc (not used here)
#else
      INTEGER   I_AD1,I_AD2     !in memc.inc (not used here)
#endif
       INTEGER  I,IA,IE,IT
C     ==--------------------------------------------------------------==
C     ==  WRITE INFO TO OUTPUT                                        ==
C     ==--------------------------------------------------------------==
C     Debug options
      IF(TDEBFOR.OR.TDEBUG.OR.MEMDEB.OR.TDEBIO) THEN
        WRITE(6,'(/,A)') ' DEBUG OPTIONS:'
        IF(TDEBFOR) THEN
          WRITE(6,'(4X,A)') 'DEBUG FORCES'
        ENDIF
        IF(TDEBUG) THEN
          WRITE(6,'(4X,A)') 'DEBUG CODE (TRACE MAIN CALLS)'
        ENDIF
        IF(MEMDEB) THEN
          WRITE(6,'(4X,A)') 'DEBUG MEMORY (TRACE ALLOCATIONS)'
        ENDIF
        IF(TDEBIO) THEN
          WRITE(6,'(4X,A)') 'DEBUG RESTART (READ AND WRITE)'
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TPATH) THEN
        IF(TPIMD) THEN
          WRITE(6,'(/,A,/)') ' PATH INTEGRAL CALCULATION '
        ELSEIF(TPMIN) THEN
          WRITE(6,'(/,A,/)') ' PATH MINIMISATION CALCULATION '
        ENDIF
      ENDIF
      IF(MD) THEN
        IF(TPRCP) THEN
          IF(TMDBO) THEN
            WRITE(6,'(/,A,A,/)') ' PARRINELLO-RAHMAN VARIABLE CELL',
     *          ' BORN-OPPENHEIMER MOLECULAR DYNAMICS '
          ELSE
            WRITE(6,'(/,A,A,/)') ' PARRINELLO-RAHMAN VARIABLE CELL',
     *          ' CAR-PARRINELLO MOLECULAR DYNAMICS '
          ENDIF
          IF(TPENN)  WRITE(6,'(A,/)') 
     *                       ' GENERATE NPT-ENSEMBLE (PENN VERSION)'
          IF(TSHOCK)  WRITE(6,'(A,/)') 
     *                       ' SHOCK WAVE SIMULATION'
        ELSEIF(TMDBO) THEN
          WRITE(6,'(/,A,/)') ' BORN-OPPENHEIMER MOLECULAR DYNAMICS'
        ELSEIF(TMDFILE) THEN
          WRITE(6,'(/,A,T56,A)') 
     *       ' MOLECULAR DYNAMICS FROM FILE',' TRAJSAVED'
          WRITE(6,'(T30,A,T61,I5)')   '       NSKIP   = ',NSKIP
          WRITE(6,'(T30,A,T61,I5,/)') '       NSAMPLE = ',NSAMPLE
        ELSEIF(TSHOP) THEN
          WRITE(6,'(/,A,/)') ' SURFACE HOPPING MOLECULAR DYNAMICS'
        ELSE
          WRITE(6,'(/,A,/)') ' CAR-PARRINELLO MOLECULAR DYNAMICS'
        ENDIF
      ELSEIF(GEOPT) THEN
        WRITE(6,'(/,A,/)') ' OPTIMIZATION OF IONIC POSITIONS'
      ELSEIF(WFOPT) THEN
        WRITE(6,'(/,A,/)') ' SINGLE POINT DENSITY OPTIMIZATION'
        IF (TRESPONSE)
     &      WRITE(6,'(A,/)') ' WITH LINEAR RESPONSE CALCULATION '

      ELSEIF(TINTER) THEN
        WRITE(6,'(/,A,/)') ' INTERFACE TO CLASSICAL MD PROGRAM'
      ELSEIF(TSAMPL) THEN
        WRITE(6,'(/,A,/)') ' REACTION PATH SAMPLING PROGRAM'
      ENDIF
      IF(KSENER) THEN
        WRITE(6,'(/,A)') 
     *       ' EXACT DIAGONALIZATION OF KOHN-SHAM MATRIX '
        IF(TKNOSWAP) THEN 
          WRITE(6,'(T28,A,/,T37,A)')
     &       '[ONLY EIGENVALUES VALUES ARE RELEVANT]',
     &       '[WAVEFUNCTIONS ARE NOT SAVED]'
        ENDIF
        WRITE(6,*)
      ENDIF
      IF(VIBRAT.AND.TSDIN) THEN
        WRITE(6,'(/,A)') 
     *       ' PERFORM A VIBRATIONAL ANALYSIS FROM A GIVEN HESSIAN'
        IF(MODE.NE.0) THEN
          WRITE(6,'(A,T63,I3,/)') ' PRINT HESSIAN EIGENMODE ', MODE
        ELSE
          WRITE(6,'(/)')
        ENDIF
      ELSEIF(VIBRAT.AND..NOT.TSDAN) THEN
        WRITE(6,'(/,A,/)') 
     *       ' PERFORM A VIBRATIONAL ANALYSIS BY FINITE DIFFERENCES'
      ELSEIF(VIBRAT.AND.TSDAN) THEN
        WRITE(6,'(/,A,/)') 
     *       ' PERFORM A VIBRATIONAL ANALYSIS BY LINEAR RESPONSE'
      ENDIF
      IF(PROPER) THEN
        WRITE(6,'(/,A,/)') ' CALCULATE SOME PROPERTIES'
      ENDIF
      IF(THARD) THEN
        WRITE(6,'(/,A)') ' CALCULATE ORBITAL HARDNESS MATRIX '
        IF(TSDAN) THEN
          WRITE(6,'(A)') ' BY LINEAR RESPONSE ALGORITHM'
        ELSE
          WRITE(6,'(A)') ' BY FINITE DIFFERENCES '
        ENDIF
      ENDIF
      IF(TSPEC) THEN
        WRITE(6,'(/,A)') ' CALCULATE ELECTRONIC SPECTRA '
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TFINT) THEN
        WRITE(6,'(/,A,$)') ' FREE ENERGY FUNCTIONAL'
        IF(TTROT) THEN
          IF(TBOGO) THEN
            WRITE(6,'(/,T14,A,$)')
     &         'WITH TROTTER FACTORISATION AND BOGOLIUBOV CORRECTION'
          ELSE
            WRITE(6,'(A,$)') ' WITH TROTTER FACTORISATION'
          ENDIF
        ENDIF
        WRITE(6,'(/,1X,A,A,/)')
     &       'A.ALAVI, J.KOHANOFF, M.PARRINELLO, D.FRENKEL',
     &       '  PRL 73 2599 (1994)'
      ENDIF
      IF(TLSD) THEN
        WRITE(6,'(/,A)') ' LOCAL SPIN DENSITY APPROXIMATION'
      ENDIF
      IF(TDDFT) THEN
        WRITE(6,'(/,A)') ' LINEAR RESPONSE TO TIME-DEPENDENT DFT'
      ENDIF
      IF(NONORT) THEN
        WRITE(6,'(/,A,A)') ' USE NONORTHOGONAL ORBITALS WITH',
     *                       ' NORM CONSTRAINTS'
        WRITE(6,'(A,1PE14.8,/)') ' OVERLAP MATRIX LIMIT: ',SLIMIT
      ENDIF
      IF(THARM) THEN
        WRITE(6,'(A)') ' HARMONIC REFERENCE SYSTEM INTEGRATION'
      ENDIF
      IF(TRAJSMALL) THEN
        WRITE(6,*) ' WRITING ONLY A small TRAJECTORY'
        WRITE(6,*) ' meaning only ',TRAJSMALLN,' atoms per frame'
      ENDIF
      IF (IPRNG.gt.0) THEN
        WRITE(6,*) 'USING SEED ', IPRNG, 
     *             'TO INIT. PSEUDO RANDOM NUMBER GEN.'
      END IF
      IF (GLE_MODE.gt.0) THEN
        WRITE(6,*) 'GENERALIZED LANGEVIN THERMOSTAT LOADED. '
        IF (GLE_MODE.NE.GLE_CUST) THEN
          IF (GLE_OMEGA .EQ. 0.0d0) THEN
            WRITE(6,*) '  USING DEFAULT OMEGA0 ', GLE_OMEGA_DEF,
     *                ' CM^-1'
            GLE_OMEGA=GLE_OMEGA_DEF
          ELSE
            WRITE(6,*) '  OMEGA0 SET TO', GLE_OMEGA, ' CM^-1'
          END IF
        END IF

        IF (GLE_MODE .EQ. GLE_WHITE) THEN
            WRITE(6,*) '  USING WHITE NOISE'
        ELSEIF (GLE_MODE .EQ. GLE_OPT) THEN
            WRITE(6,*) '  USING OPTIMAL SAMPLING, omega_min=',
     *          0.0001*GLE_OMEGA, "CM^-1; omega_max=", 
     *          1.0*GLE_OMEGA, "CM^-1"
        ELSEIF(GLE_MODE .EQ. GLE_CPMD)  THEN
            WRITE(6,*) '  USING STOCHASTIC CPMD VERSION omega_cut=',
     *          GLE_OMEGA, "CM^-1"
        ELSEIF(GLE_MODE .EQ. GLE_CUST) THEN 
            WRITE(6,*) '  USING CUSTOM MATRIX WITH ns=', GLE_NS
            WRITE(6,*) 
     *     '  PARAMETERS WILL BE READ FROM ./GLE-A, [./GLE-C]'
        END IF
      END IF
      IF(TMASS) THEN
        WRITE(6,'(A)') ' SCALED ELECTRON MASSES'
      ENDIF
      WRITE(FFORMAT,'(A,I2,A)') '(A,T',MAX(29,65-(IEPATH-IAPATH)),',A)'
      WRITE(6,FFORMAT) ' PATH TO THE RESTART FILES: ',
     *      FPATH(IAPATH:IEPATH)
      IF(RESTART) THEN
        IF(RWF)   WRITE(6,'(A)') ' RESTART WITH OLD ORBITALS'
        IF(RRHO)  WRITE(6,'(A)') ' RESTART WITH OLD DENSITY'
        IF(ROCC)  WRITE(6,'(A)') ' RESTART WITH OLD OCCUPATION NUMBERS'
        IF(RKPT)  WRITE(6,'(A)') ' RESTART WITH OLD KPOINTS'
        IF(RCO)   WRITE(6,'(A)') ' RESTART WITH OLD ION POSITIONS'
        IF(RVEL)  WRITE(6,'(A)') ' RESTART WITH OLD VELOCITIES'
        IF(RAC)   WRITE(6,'(A)') ' RESTART WITH OLD ACCUMULATORS'
        IF(RNOE)  WRITE(6,'(A)') 
     *           ' RESTART WITH OLD ELECTRON THERMOSTAT'
        IF(RNOP)  WRITE(6,'(A)') ' RESTART WITH OLD ION THERMOSTAT'
        IF(RNOC)  WRITE(6,'(A)') ' RESTART WITH OLD CELL THERMOSTAT'
        IF(RGEO)  WRITE(6,'(A)') ' RESTART FROM FILE GEOMETRY'
        IF(RLATE) WRITE(6,'(A)') ' RESTART WITH LATEST RESTART FILE'
        IF(RVIB)  WRITE(6,'(A)') 
     *           ' RESTART FINITE DIFFERENCE CALCULATION'
        IF(RCELL) WRITE(6,'(A)') ' RESTART WITH OLD MD CELL'
        IF(RPOT)  WRITE(6,'(A)') ' RESTART WITH OLD POTENTIAL'
        IF(ROH)   WRITE(6,'(A)') ' RESTART ORBITAL HARDNESS CALCULATION'
        IF(RLR)   WRITE(6,'(A)') 
     *           ' RESTART WITH OLD LINEAR RESPONSE VECTORS'
        IF(RPHES) WRITE(6,'(A)') ' RESTART WITH OLD PARTIAL HESSIAN'
        IF(RLSCL) WRITE(6,'(A)')
     *           ' RESTART LINEAR SCALING OPTIMIZERS FROM OLD STATUS'
        IF(RDTL)  WRITE(6,'(A)')
     *           ' RESTART WITH OLD CONVERGENCE CRITERIA'
        IF(RCON)  WRITE(6,'(A)') ' RESTART WITH OLD CONSTRAINT VALUES'
        IF(RXTP)  WRITE(6,'(A)') ' RESTART WITH WAVEFUNCTION HISTORY'
        IF(RPRNG)  WRITE(6,'(A)') 
     *           ' RESTART WITH PSEUDO RANDOM NUMBER GENERATOR'
        IF(RGLE)  WRITE(6,'(A)') 
     *           ' RESTART WITH GENERALIZED LANGEVIN MOMENTA'
      ENDIF
      IF(TMDBO.OR.TMDFILE.OR.(.NOT.MD)) THEN
        IF(TLOWD) THEN  
          WRITE(6,'(A)') ' LOWDIN (SYMMETRIC) ORTHOGONALIZATION'
        ELSE
          WRITE(6,'(A)') ' GRAM-SCHMIDT ORTHOGONALIZATION'
        ENDIF
      ELSE
        IF(.NOT.NONORT) THEN
          IF(CNSTMD) THEN
            WRITE(6,'(A,/,A,T61,I5,/,A,T54,1PE12.2)') 
     &           ' ITERATIVE ORTHOGONALIZATION',
     &           '    MAXIT:',MAXIT,
     &           '    EPS:',EPSOG
          ENDIF
        ENDIF
      ENDIF
      IF(TJLIMIT.GT.0.D0) THEN
        WRITE(6,'(A,T54,F12.2)') ' MAXIMUM CPU TIME: ',TJLIMIT
      ENDIF
      WRITE(6,'(A,T50,I10,A6)')
     &     ' MAXIMUM NUMBER OF STEPS: ',NOMORE,' STEPS'
      WRITE(6,'(A,T50,I10,A6)') ' MAXIMUM NUMBER OF ITERATIONS FOR SC:',
     &       NOMORE_ITER,' STEPS'
      IF(VIBRAT) THEN
        WRITE(6,'(A,1PE12.4)')
     *     ' STEP SIZE FOR FINITE DIFFERENCES (BOHR):',FDIFF
      ENDIF
        IF(KRWFN) THEN
          WRITE(6,'(A)')
     *     ' STORE REAL SPACE REPRESENTATION OF WAVEFUNCTIONS'
        ENDIF
      IF(WCOMP) THEN
         WRITE(6,'(A)')
     *     ' WRITE WAVEFUNCTIONS IN COMPRESSED FORM TO FILE'
         IF(WCOMPB.LT.0) THEN
           WRITE(6,'(A)') '   USE ATOMIC ORBITAL PROJECTION '
         ELSE
           WRITE(6,'(A,I3)') '   COMPRESSION FACTOR IS ',WCOMPB
         ENDIF
      ENDIF
      WRITE(6,'(A,T50,I10,A6)') 
     *     ' PRINT INTERMEDIATE RESULTS EVERY ',IPRINT_STEP,' STEPS'
      WRITE(6,'(A,T50,I10,A6)')
     *     ' STORE INTERMEDIATE RESULTS EVERY ',ISTORE,' STEPS'
      IF(MD.OR.TPRCP.OR.GEOPT) THEN
        WRITE(6,'(A,T38,I6,A22)')
     *       ' STORE INTERMEDIATE RESULTS EVERY ',ISCTORE,
     &       ' SELF-CONSISTENT STEPS'
      ENDIF
      IF(.NOT.SWF) THEN
        WRITE(6,'(A)')
     &     ' DO NOT STORE WAVEFUNCTIONS IN RESTART FILE'
      ENDIF
      IF(SRHO) THEN
        WRITE(6,'(A)')
     &     ' STORE ELECTRONIC DENSITY IN RESTART FILE'
      ENDIF
      WRITE(6,'(A,T56,I10)')
     *     ' NUMBER OF DISTINCT RESTART FILES:',NRESTF
      IF(NSTEPWR(1).GE.0) THEN
        WRITE(6,'(A)') '   RESTART FILES WRITTEN AT STEPS '
        WRITE(6,'(10(8X,8I8))') (NSTEPWR(I),I=1,NRESTF)
      ENDIF
      IF(MD.AND.TPRES) THEN
        WRITE(6,'(A,I3,A)')
     *     ' EVALUATE THE STRESS TENSOR OF THE SYSTEM EVERY ',
     *     NPRES,' STEPS'
      ENDIF
      IF(MD.AND.TPREC) THEN
        WRITE(6,'(A,I3,A)')
     *     ' EVALUATE THE CLASSICAL STRESS TENSOR OF SYSTEM EVERY   ',
     *     NPREC,' STEPS'
      ENDIF
      IF(TISOS) THEN
        WRITE(6,'(A)')
     *  ' TEMPERATURE IS CALCULATED ASSUMING AN ISOLATED MOLECULE '
      ELSE
        WRITE(6,'(A)')
     *  ' TEMPERATURE IS CALCULATED ASSUMING EXTENDED BULK BEHAVIOR '
      ENDIF
      IF(RHOOUT) THEN
        IF(NRHOOUT.GT.0)
     *  WRITE(6,'(A,I6,A)') ' STORE ELECTRON DENSITY EVERY ',
     *     NRHOOUT,' STEPS DURING THE RUN'
        WRITE(6,'(A)')
     *     ' STORE ELECTRON DENSITY AT THE END OF THE RUN'
      ENDIF
      IF(TEPOT) THEN
        WRITE(6,'(A)') ' PRINT ELECTROSTATIC POTENTIAL '
      ENDIF
      IF(TSIC) THEN  ! cmb_ssic
        WRITE(6,'(/,A)') ' SELF INTERACTION CORRECTION AFTER'
        WRITE(6,'(A)')
     .  '   J. VANDEVONDELE AND M. SPRIK, PCCP 7, 1363 (2005)'
        WRITE(6,'(A,T54,F12.4)')'   ALPHA =',asic
        WRITE(6,'(A,T54,F12.4,/)')'   BETA  =',bsic
      ENDIF          ! cmb_ssic
      IF(.NOT.TDIAG) THEN
        WRITE(6,'(A,T54,F12.4)')
     &     ' FICTITIOUS ELECTRON MASS: ',EMASS
      ENDIF
      IF(TSDC.OR.TPRCP) THEN
        IF(CMASS.LE.0.0) THEN
          WRITE(6,'(A,T57,A)') ' FICTITIOUS MD CELL MASS: ','AUTOMATIC'
        ELSE
          WRITE(6,'(A,T54,F12.4)') ' FICTITIOUS MD CELL MASS: ',CMASS
        ENDIF
      ENDIF
C     Time step for ions and electrons
      WRITE(6,'(A,T54,F12.4)') ' TIME STEP FOR ELECTRONS: ',DELT_ELEC
      WRITE(6,'(A,T54,F12.4)') ' TIME STEP FOR IONS: ',DELT_IONS
      IF(TRANE) THEN
        WRITE(6,'(A,T54,F12.4)')
     *     ' RANDOMIZE INITIAL WAVEFUNCTION,  AMPLITUDE=',AMPRE
      ENDIF
      IF(TRANP) THEN
        WRITE(6,'(A,T54,F12.4)')
     *     ' RANDOMIZE INITIAL IONIC POSITIONS,  AMPLITUDE=',AMPRP
      ENDIF
      IF(TRANC) THEN
        WRITE(6,'(A,T54,F12.4)')
     *     ' RANDOMIZE INITIAL CELL PARAMETERS,  AMPLITUDE=',AMPRC
      ENDIF
      IF(TRAND) THEN
        WRITE(6,'(A,T54,F12.4)')
     *     ' RANDOMIZE INITIAL DENSITY,  AMPLITUDE=',AMPRD
      ENDIF
      IF(NOGRP.NE.1) THEN
        WRITE(6,'(A,T62,I4)')
     &     ' NUMBER OF TASKGROUPS:',NOGRP
        IF(TCART)  THEN
          WRITE(6,'(A)') ' USING CARTESIAN COMMUNICATORS ' 
        ENDIF
      ENDIF
      IF(ACOUT) THEN
          WRITE(6,'(A,/,A)') 
     *      ' VIBRATIONAL FREQUENCIES AND EIGENVECTORS ARE',
     *      '  SAVED IN a-CLIMAX FORMATTED FILE VIB.aclimax'
      ENDIF
      IF(VOUT) THEN
        IF(NVIB.EQ.2) THEN
          WRITE(6,'(A,/,A)') 
     *      ' ALL VIBRATIONAL FREQUENCIES AND EIGENVECTORS ARE',
     *      '  SAVED IN GAUSSIAN-STYLE FORMATTED FILES'
        ELSE
          WRITE(6,'(A,/,A)') 
     *      ' VIBRATIONAL FREQUENCIES AND EIGENVECTORS ARE',
     *      '  SAVED IN THE GAUSSIAN-STYLE FORMATTED FILE VIB1.log'
        ENDIF
      ENDIF
      IF(MD) THEN
        IF(TSHOP.AND.TFUSI) THEN
          WRITE(6,'(A)')
     *     ' COMBINE RESTART FILES FOR S0 AND S1 STATES ' 
          CALL XSTRING(S0_FILN,IA,IE)
          WRITE(6,'(A,T20,A)') '     S0 STATE:',S0_FILN(IA:IE)
          CALL XSTRING(S1_FILN,IA,IE)
          WRITE(6,'(A,T20,A)') '     S1 STATE:',S1_FILN(IA:IE)
        ENDIF
        IF(TSHOP.AND.TSEP) THEN
          WRITE(6,'(A)')
     *     ' SEPARATE RESTART FILE FOR S0 AND S1 STATES ' 
          CALL XSTRING(S0_FILN,IA,IE)
          WRITE(6,'(A,T20,A)') '     S0 STATE:',S0_FILN(IA:IE)
          CALL XSTRING(S1_FILN,IA,IE)
          WRITE(6,'(A,T20,A)') '     S1 STATE:',S1_FILN(IA:IE)
        ENDIF
        IF(TDIAG) THEN
          WRITE(6,'(A,T60,F6.2)')
     &       ' ALEXANDER MIXING PARAMETER:',
     &     ALXMIX
        ENDIF
        IF(QUENCHP) THEN
          WRITE(6,'(A)')
     *      ' RESET INITIAL VELOCITIES OF THE IONS TO ZERO'
        ENDIF
        IF(QUENCHE) THEN
          WRITE(6,'(A)')
     *      ' RESET INITIAL VELOCITIES OF THE ELECTRONS TO ZERO'
        ENDIF
        IF(QUENCHB) THEN
          WRITE(6,'(A)')
     *      ' QUENCH SYSTEM TO THE BORN-OPPENHEIMER SURFACE'
        ENDIF
        IF(QUENCHC) THEN
          WRITE(6,'(A)')
     *      ' QUENCH INITIAL VELOCITIES OF THE CELL TO ZERO'
        ENDIF
        IF(TREVERS) THEN
          WRITE(6,'(A)')
     *      ' IONIC AND ELECTRONIC VELOCITIES HAVE BEEN INVERTED'
        ENDIF
        IF(ROUT) THEN
          IF(NTRAJ.EQ.1) THEN
            WRITE(6,'(A)') ' TRAJECTORIES ARE SAVED ON FILE'
          ELSE
            WRITE(6,'(A,T56,I4,A6)') 
     *        ' TRAJECTORIES ARE SAVED ON FILE EVERY',NTRAJ,' STEPS'
          ENDIF
        ENDIF
        IF(XTOUT) THEN
          IF(NTRAJ.EQ.1) THEN
            WRITE(6,'(A)') ' TRAJEC.xyz IS SAVED ON FILE'
          ELSE
            WRITE(6,'(A,T56,I4,A6)') 
     *        ' TRAJEC.xyz IS SAVED ON FILE EVERY',NTRAJ,' STEPS'
          ENDIF
        ENDIF
        IF(DCOUT) THEN
          IF(NTRAJ.EQ.1) THEN
            WRITE(6,'(A)') ' TRAJEC.dcd IS SAVED ON FILE'
          ELSE
            WRITE(6,'(A,T56,I4,A6)') 
     *        ' TRAJEC.dcd IS SAVED ON FILE EVERY',NTRAJ,' STEPS'
          ENDIF
        ENDIF
        IF(MOUT) THEN
          WRITE(6,'(A,A,I4,A)') ' TRAJECTORIES ARE SAVED ',
     *       'EVERY ',IMOVIE,' STEPS IN MOVIE FORMAT'
        ENDIF
        IF(ANNEI) THEN
          WRITE(6,'(A,T46,A8,F12.6)') 
     *      ' SIMULATED ANNEALING OF IONS WITH ','ANNERI =',ANNERI
        ENDIF
        IF(ANNEE) THEN
          WRITE(6,'(A,T46,A8,F12.6)') 
     *      ' SIMULATED ANNEALING OF ELECTRONS WITH ','ANNERE =',ANNERE
        ENDIF
        IF(ANNEC) THEN
          WRITE(6,'(A,T46,A8,F12.6)') 
     *      ' SIMULATED ANNEALING OF CELL WITH ','ANNERC =',ANNERC
        ENDIF
        IF(DAMPI) THEN
          WRITE(6,'(A,T46,A8,F12.6)') 
     *      ' DAMPED DYNAMICS OF IONS WITH ','DAMPGI =',DAMPGI
        ENDIF
        IF(DAMPE) THEN
          WRITE(6,'(A,T46,A8,F12.6)') 
     *      ' DAMPED DYNAMICS OF ELECTRONS WITH ','DAMPGE =',DAMPGE
        ENDIF
        IF(DAMPC) THEN
          WRITE(6,'(A,T46,A8,F12.6)') 
     *      ' DAMPED DYNAMICS OF CELL WITH ','DAMPGC =',DAMPGC
        ENDIF
        IF(TR4A2A) THEN
          WRITE(6,'(A)') 
     *      ' SINGLE PRECISION IS USED IN SOME ALLTOALL COMMUNICATION '
        ENDIF
        IF(TC) THEN
          WRITE(6,'(A,/,A,T54,1PE12.6,/,A,T54,1PE12.6)')
     *         ' ELECTRON DYNAMICS WITH RESCALING OF VELOCITIES',
     *         '    AVERAGE KINETIK ENERGY(A.U.)',EKINW,
     *         '    TOLERANCE',TOLL
          IF(TRESCALE) THEN
            WRITE(6,'(A)')
     *      '   ***** BUT RESCALE THEM ONLY AFTER THE RESTART TO'
            WRITE(6,'(A,T47,F12.2,A)')
     *      '   ***** SPECIFIED TEMPERATURE: ',TEMPW,' KELVIN'
          ENDIF
          IF(TBERE) THEN
            WRITE(6,'(A,/,A,T54,1PE12.6,/,A,T54,1PE12.6)')
     *          ' ELECTRONS DYNAMICS WITH BERENDSEN-STYLE THERMOSTAT',
     *          '    AVERAGE KINETIK ENERGY(A.U.)',EKINW,
     *          '    CHARACTERISTIC TIME(A.U.):',TAUBE
          ENDIF
          IF(TPRCP.AND.TCC) THEN
            WRITE(6,'(A,/,A,T54,1PE12.6,A,/,A,T54,1PE12.6)')
     *        ' CELL DYNAMICS WITH RESCALING OF VELOCITIES',
     *        '    EKINH =',EKINHR,' AU',
     *        '    TOLERANCE=',TOLC
          ENDIF
        ELSEIF(TNOSEE) THEN
          WRITE(6,'(A,T21,A)') ' ELECTRON DYNAMICS:',
     &         'TEMPERATURE CONTROL (NOSE-HOOVER THERMOSTATS)'
          WRITE(6,'(A,T54,1PE12.6,/,A,T54,0PF12.2)')
     *      '    TARGET KINETIK ENERGY(A.U.):',EKINW,
     *      '    CHARACTERISTIC FREQUENCY(CM**-1):',WNOSE0
        ELSEIF(TBERE) THEN
          WRITE(6,'(A,/,A,T54,1PE12.6,/,A,T54,1PE12.6)')
     *        ' ELECTRONS DYNAMICS WITH BERENDSEN-STYLE THERMOSTAT',
     *        '    AVERAGE KINETIK ENERGY(A.U.)',EKINW,
     *        '    CHARACTERISTIC TIME(A.U.):',TAUBE
        ELSE
          WRITE(6,'(A,T21,A)')' ELECTRON DYNAMICS:',
     &         'THE TEMPERATURE IS NOT CONTROLLED'
        ENDIF
        IF(TCP) THEN
          WRITE(6,'(A,/,A,T54,1PE12.6,/,A,T54,1PE12.6)')
     *      ' ION DYNAMICS WITH RESCALING OF VELOCITIES',
     *      '    TEMPERATURE(KELVIN):',TEMPW,
     *      '    TOLERANCE:',TOLP
          IF(TBERP) THEN
            WRITE(6,'(A,/,A,T54,1PE12.6,/,A,T54,1PE12.6)')
     *      ' ION DYNAMICS WITH BERENDSEN-STYLE THERMOSTAT',
     *      '    TEMPERATURE(KELVIN):',TEMPW,
     *      '    CHARACTERISTIC TIME(A.U.):',TAUBP
          ENDIF
        ELSEIF(TNOSEP) THEN
          IF (TCAFES) THEN
                WRITE(6,*) '********** CAFES *************'
                WRITE(6,*) 'CANONICAL, ADIABATIC FREE ENERGY SAMPLING'
          ELSE
                WRITE(6,'(A,T21,A)')' ION DYNAMICS:',
     &             'TEMPERATURE CONTROL (NOSE-HOOVER THERMOSTATS)'
          ENDIF
          IF(TULTRA) THEN
            WRITE(6,'(A)') ' ONE THERMOSTAT CHAIN PER SPECIES'
          ENDIF
          IF(TMNOSE) THEN
            WRITE(6,'(A)') ' ONE THERMOSTAT CHAIN PER DEGREE OF FREEDOM'
          ENDIF
          IF (TCAFES) THEN
            WRITE(6,*) 'TEMPERATURES FOR THE IONS TO BE DEFINED...'
            WRITE(6,*) 'FREQUENCIES OF THE THERMOSTATS TOO...'
          ELSEIF(TLOCT) THEN
            WRITE(6,'(A)') ' THERMOSTAT FOR SUBGROUPS'
            do i=1,nloct
               WRITE(6,'(1X,I5,'':  '',A,T54,1PE12.6,/,
     .                   1X,I5,'':  '',A,T54,0PF12.2)')
     .            i,'    TARGET TEMPERATURE(KELVIN):',LOCTPIN(1,i),
     .            i,'    CHARACTERISTIC FREQUENCY(CM**-1):',LOCTPIN(2,i)
            enddo
            WRITE(6,'(/,A,F10.3,/)')
     .                  ' WARNING: INITIAL TEMPERATURE TAKEN AS ',TEMPW

          ELSE
            WRITE(6,'(A,T54,1PE12.6,/,A,T54,0PF12.2)')
     *         '    TARGET TEMPERATURE(KELVIN):',TEMPW,
     *         '    CHARACTERISTIC FREQUENCY(CM**-1):',WNOSP0
          ENDIF
        ELSEIF(TBERP) THEN
          WRITE(6,'(A,/,A,T54,1PE12.6,/,A,T54,1PE12.6)')
     *      ' ION DYNAMICS WITH BERENDSEN-STYLE THERMOSTAT',
     *      '    TEMPERATURE(KELVIN):',TEMPW,
     *      '    CHARACTERISTIC TIME(A.U.):',TAUBP
        ELSE
          WRITE(6,'(A,T21,A)')' ION DYNAMICS:',
     &         'THE TEMPERATURE IS NOT CONTROLLED'
        ENDIF
        IF(TNOSEC.AND.TPRCP) THEN
          WRITE(6,'(A,T21,A)') ' CELL DYNAMICS:',
     &         'TEMPERATURE CONTROL (NOSE-HOOVER THERMOSTATS)'
          WRITE(6,'(A,T54,1PE12.6,/,A,T54,0PF12.2)')
     *      '    TARGET CELL TEMPERATURE(KELVIN):',TEMPC,
     *      '    CHARACTERISTIC FREQUENCY(CM**-1):',WNOSC0
        ELSEIF(TBERC.AND.TPRCP) THEN
          WRITE(6,'(A,/,A,T54,1PE12.6,/,A,T54,1PE12.6)')
     *        ' CELL DYNAMICS WITH BERENDSEN-STYLE THERMOSTAT',
     *        '    AVERAGE KINETIK ENERGY(A.U.)',EKINHR,
     *        '    CHARACTERISTIC TIME(A.U.):',TAUBC
        ELSEIF(TPRCP) THEN
          WRITE(6,'(A,T21,A)') ' CELL DYNAMICS:',
     *      'THE TEMPERATURE IS NOT CONTROLLED'
        ENDIF
        IF(TNOSEE.OR.TNOSEP.OR.TNOSEC) THEN
          WRITE(6,'(A)') ' NOSE PARAMETERS '
          WRITE(6,'(A,T63,I3)') 
     *      '    NUMBER OF THERMOSTATS (IONS)      :',NCHP
          WRITE(6,'(A,T63,I3)')                    
     *      '    NUMBER OF THERMOSTATS (ELECTRONS) :',NCHS
          WRITE(6,'(A,T63,I3)')                    
     *      '    NUMBER OF THERMOSTATS (CELL)      :',NCHB
          WRITE(6,'(A,T60,F6.2)')                    
     *      '    SCALING FOR ELEC. DOF             :',NEDOF0
          WRITE(6,'(A,T63,I3)')                    
     *      '    NUMBER OF YOSHIDA-SUZUKI STEPS    :',NCALLS0
          WRITE(6,'(A,T63,I3)')                    
     *      '    NUMBER OF INTEGRATION CYCLES (NIT):',NIT0
        ENDIF
        IF((TCP.OR.TNOSEP.OR.TBERP).AND.(TRAMPR.GT.0.0d0)) THEN
          WRITE(6,'(A,/,A,T54,1PE12.6,/,A,T54,1PE12.6)')
     *          ' USING LINEAR TEMPERATURE RAMP ',
     *          '    TARGET REFERENCE TEMPERATURE (KELVIN)',TRAMPT,
     *          '    RAMPING RATE (KELVIN/A.U.):',TRAMPR
          ENDIF
        IF(TSUBCOM) THEN
          WRITE(6,'(A,T50,I10,A6)')
     *      ' SUBTRACT CENTER OF MASS VELOCITY EVERY ',NCOMV,' STEPS'
        ENDIF
        IF(TSUBROT) THEN
          WRITE(6,'(A,A,T50,I10,A6)') ' SUBTRACT ROTATION AROUND',
     &         ' CENTER OF MASS EVERY ',NROTV,' STEPS'
        ENDIF
        IF(TDIPD) THEN
          WRITE(6,'(A)') ' DIPOLE MOMENT CALCULATION '
          WRITE(6,'(A,T50,I10,A6)')
     *     '     STORE DIPOLE MOMENTS EVERY ',NPDIP,' STEPS'
          IF(TWANN) THEN
            WRITE(6,'(A)') '     WANNIER FUNCTION DYNAMICS '
            IF(W_TYPE.EQ.1) 
     *          WRITE(6,'(A)')   '         FUNCTIONAL: VANDERBILT |M|^2'
            IF(W_TYPE.EQ.2) 
     *          WRITE(6,'(A)')   '         FUNCTIONAL: RESTA Log|M|^2'
            IF(W_OPT.EQ.1) 
     *          WRITE(6,'(A)') '         OPTIMISATION: STEEPEST DESCENT'
            IF(W_OPT.EQ.2) 
     *          WRITE(6,'(A)') '         OPTIMISATION: JACOBI ROTATION'
            WRITE(6,'(A,T56,1PE10.4)') 
     *          '         CONVERGENCE CRITERIA:',W_EPS
            WRITE(6,'(A,T56,I10)')
     *          '         MAXIMUM # ITERATIONS:',W_MAXS
            WRITE(6,'(A,T56,1PE10.4)')
     *          '         OPTIMISATION STEP   :',W_STEP 
            IF(W_REF(1).lt.-999999.9d0) THEN
              WRITE(6,'(A)') '         REF POINT: AUTOMATIC'
            ELSE
              WRITE(6,'(A,3F11.5)')
     *            '         REF POINT[input units]:',(W_REF(i),i=1,3)
            ENDIF
            IF(TWSERIAL) THEN
              WRITE(6,'(A,3F11.5)')
     *            '         CALCULATE WANNIER CENTERS USING SERIAL CODE'
            ENDIF
            IF(TWPRI) THEN
              WRITE(6,'(A,T56,I4,A)') 
     *        '     PRINT WANNIER FUNCTIONS EVERY ',
     *            NS_WANN*NPDIP,' STEPS'
              IF(SW_ALL.EQ.1) THEN
                WRITE(6,'(T20,A)') 'PRINT ALL WANNIER FUNCTIONS'
              ENDIF
              IF(ABS(SW_SPREAD).GT.0.001d0) THEN
                IF(SW_SPREAD.LT.0.0d0) THEN
                  WRITE(6,'(T20,A,A,F6.2)') 'PRINT WANNIER FUNCTIONS ',
     &                'WITH A SPREAD SMALLER THAN ', -SW_SPREAD
                ELSE
                  WRITE(6,'(T20,A,A,F6.2)') 'PRINT WANNIER FUNCTIONS ',
     &                'WITH A SPREAD LARGER THAN ', SW_SPREAD
                ENDIF
              ENDIF
              IF(SW_FIRST.GT.0) THEN
                WRITE(6,'(T20,A,I4,A,I4)') 'PRINT WANNIER FUNCTIONS ',
     &              SW_FIRST,' TROUGH ',SW_LAST
              ENDIF
              IF(SW_ORB.GT.0) THEN
                WRITE(6,'(T20,10I5)') (SW_LIST(I),I=1,SW_ORB)
              ENDIF
            ENDIF
          ENDIF
        ENDIF
      ELSE
        WRITE(6,'(A,T54,1PE12.4)') 
     *      ' CONVERGENCE CRITERIA FOR WAVEFUNCTION OPTIMIZATION: ',
     *      TOLOG
        IF (TOLDETOT.GT.0.D0) THEN
          WRITE(6,'(A,T54,1PE12.4)')
     *      '    TOTAL ENERGY DIFFERENCE: ', TOLDETOT
        ENDIF
        IF (TOLAD.GT.0.D0) THEN
          WRITE(6,'(A,/,A,T54,1PE12.4)')
     *      ' CONVERGENCE CRITERIA FOR WAVEFUNCTION RELATIVE TO ',
     *      ' GRADIENT ON IONS: ', TOLAD
        ENDIF
        IF (TOLENE.GT.0.D0) THEN
          WRITE(6,'(A,/,A,T54,1PE12.4)')
     *      ' CONVERGENCE CRITERIA FOR RELAVTIVE WAVEFUNCTION ',
     *      ' ENERGY CHANGE: ', TOLENE
        ENDIF
        IF (TOLFOR.NE.3.D0) THEN
          WRITE(6,'(A,/,A,T54,1PE12.4)')
     *      ' FORCE ON IONS CALCULATED IF CONVERGENCE IS REACHED ',
     *      ' RELAXED BY: ', TOLFOR
        ENDIF
        IF (NSTCNV.NE.0) THEN
          WRITE(6,'(A,/,A,T63,1I3)')
     *      ' NUMBER OF STEPS UNTIL ELECTRONIC CONVERGENCE CRITERIA ',
     *      ' ARE RELAXED: ', NSTCNV
        ENDIF
        IF(DIIS) THEN
          IF(PREC) THEN 
            WRITE(6,'(A,/,A,T58,F8.4)')
     *      ' WAVEFUNCTION OPTIMIZATION BY PRECONDITIONED DIIS',
     *      ' THRESHOLD FOR THE WF-HESSIAN IS ',HTHRS
          ELSE
            WRITE(6,'(A)')
     *      ' WAVEFUNCTION OPTIMIZATION BY DIIS'
          ENDIF
          WRITE(6,'(A,A,T63,I3)') ' MAXIMUM NUMBER OF VECTORS',
     *      ' RETAINED FOR DIIS: ',MDIIS
          WRITE(6,'(A,A,T63,I3)') ' STEPS UNTIL DIIS RESET ON POOR',
     *      ' PROGRESS: ', NRESET
        ENDIF
        IF(PCG) THEN
          IF(PREC) THEN 
            WRITE(6,'(A,/,A,T58,F8.4)')
     *      ' WAVEFUNCTION OPTIMIZATION BY PRECONDITIONED CG',
     *      ' THRESHOLD FOR THE HESSIAN IS ',HTHRS
          ELSE
            WRITE(6,'(A)')
     *      ' WAVEFUNCTION OPTIMIZATION BY CG'
          ENDIF
          IF(PCGMIN) WRITE(6,'(A)') ' PERFORM QUADRATIC LINE SEARCH'
        ENDIF
        IF(TSDE) THEN
          WRITE(6,'(A)')
     *      ' WAVEFUNCTION OPTIMIZATION BY STEEPEST DESCENT'
          IF(PREC) THEN 
            WRITE(6,'(A,/,A,T58,F8.4)')
     *      '           USING PRECONDITIONED MASSES',
     *      ' THRESHOLD FOR THE WF-HESSIAN IS ',HTHRS
          ENDIF
        ENDIF
        IF(TSDC) THEN
          WRITE(6,'(A)')
     *      ' CELL OPTIMIZATION BY STEEPEST DESCENT'
        ENDIF
        IF(.NOT.TDIAG) THEN
          IF(IPROJ.EQ.0) WRITE(6,'(A)')
     *         ' RAW ELECTRONIC GRADIENT (=H*PSI) IS USED'
          IF(IPROJ.EQ.1) WRITE(6,'(A)')
     *         ' DIAGONALLY PROJECTED ELECTRONIC GRADIENT IS USED'
          IF(IPROJ.EQ.2) WRITE(6,'(A)')
     *         ' FULL ELECTRONIC GRADIENT IS USED '
        ENDIF
      ENDIF
      IF(TDIAGOPT) THEN
        WRITE(6,'(A)')' DIAGONALIZE OPTIMIZED WAVEFUNCTION'
        IF(NPERID.GT.0) WRITE(6,'(A,T63,I3)')
     *       ' STEPS UNTIL WF DIAGONALIZATION: ',NPERID
        IF(NRPERI.GT.0) WRITE(6,'(A,T63,I3)')
     *       ' DIIS RESETS UNTIL WF DIAGONALIZATION: ',NRPERI
      ENDIF
      IF(TDIAG.OR.TDIAGOPT) THEN
        IF(TLANC) THEN
           WRITE(6,'(A)')
     *      ' LANCZOS DIAGONALIZATION (KRYLOV SUBSPACE)'
          WRITE(6,'(2(A,T63,I3,/),$)')
     *    '    MAX. FRIESNER ITERATIONS ',N_FRIES,
     *    '    MAX. KRYLOV SUBSPACE     ',NKRY_MAX
          IF(NKRY_BLOCK.LE.0) THEN
            WRITE(6,'(A,T34,A32)') 
     *           '    MAX. KRYLOV BLOCK SIZE',
     &           'FIXED LATER (WAITING FOR NSTATE)'
          ELSE
            WRITE(6,'(A,T63,I3)') 
     *           '    MAX. KRYLOV BLOCK SIZE',NKRY_BLOCK
          ENDIF
          WRITE(6,'(A,T54,1PE12.4)')
     *    '    MAX. BETA^2              ',B2LIMIT
          IF(NTABTROT.NE.1) THEN
            WRITE(6,'(A,T64,I2)')
     *           '    MAX. BETA^2 CHOICE NUMBER:',NTABTROT
            DO I=2,NTABTROT
              WRITE(6,'(A,1PE12.4,T42,A12,1PE12.4)')
     *           '    BELOW DRHOMAX=',DENSTROT(I),
     &             'MAX. BETA^2=',B2TROT(I)
            ENDDO
          ENDIF
        ELSEIF(TDAVI) THEN
          WRITE(6,'(A)') ' DAVIDSON DIAGONALIZATION '
          WRITE(6,'(A,T63,I3,/,A,T54,1PE12.4)')
     *    '    MAX. DAVIDSON ITERATIONS ',N_FRIES,
     *    '    CONVERGENCE CRITERIA     ',EPSDAV
        ELSEIF(TFRHO_UPW) THEN
          IF(DIIS) THEN
            WRITE(6,'(A)') ' WFN OPT. WITH DIIS AT FIXED RHO '
            WRITE(6,'(10x,A,I5)') '   MAX # of DIIS Cycles = ',MAXLDIIS
            WRITE(6,'(10x,A)')
     *             '  Density Updated after every DIIS loop'
          ELSE IF(PCG) THEN
            WRITE(6,'(A)') ' WFN OPT. WITH PCG AT FIXED RHO '
            WRITE(6,'(10x,A,I5)') '   MAX # of PCG Cycles = ',MAXLDIIS
            WRITE(6,'(10x,A)')
     *             '  Density Updated after every PCG loop'
          ENDIF
        ENDIF
        IF(MD.OR.GEOPT.OR.WFOPT.OR.TDEBFOR) THEN
          IF(NRDIISMAX.NE.0) THEN
            WRITE(6,'(A,T62,I4)')
     *         ' DIIS ON DENSITIES: MAX. SIZE',NRDIISMAX
          ENDIF
          IF(NTABNRDIIS.NE.1) THEN
            WRITE(6,'(A,T64,I2)')
     *           ' DIIS MIXING NUMBER:',TABNRDIIS(1)
            DO I=2,NTABNRDIIS
              WRITE(6,'(4X,A,1PE12.4,T52,A10,I4)')
     *           'BELOW DRHOMAX=',DENSNRDIIS(I),
     &           'MAX. SIZE=',TABNRDIIS(I)
            ENDDO
          ENDIF
          WRITE(6,'(A,T54,1PE12.4)')
     *         ' ANDERSON MIXING PARAMETER:',ANDRMIX
          IF(NTABMIX.NE.1) THEN
            WRITE(6,'(A,T64,I2)')
     *           ' ANDERSON MIXING NUMBER:',NTABMIX
            DO I=2,NTABMIX
              WRITE(6,'(4X,A,D12.4,T47,A7,1PE12.4)')
     *           'BELOW DRHOMAX=',DENSMIX(I),'MIXING=',ANDMIX(I)
            ENDDO
          ENDIF
          IF(TGMIX) THEN
            WRITE(6,'(A)')' G-SPACE ANDERSON MIXING'
          ENDIF
          IF(TGBROY) THEN 
            WRITE(6,'(A,T54,1PE12.4)')
     &         ' BROYDEN MIXING PARAMETER [BROYMIX]',BROYMIX
            IF(ECUTBROY.LE.0.D0) THEN
              WRITE(6,'(A,T39,A27)')
     &             ' BROYDEN CUTOFF [ECUTBROY]',
     &             'EQUAL TO THE DENSITY CUTOFF'
            ELSE
              WRITE(6,'(A,T54,1PE12.4)')
     &             ' BROYDEN CUTOFF [ECUTBROY]',ECUTBROY
            ENDIF
            WRITE(6,'(A,T57,I3,A)')
     &         ' BROYDEN MIXING STARTS [NFRBROY] AFTER ',
     &           NFRBROY, ' STEPS'
            WRITE(6,'(A,T57,I3,A)')
     &         ' BROYDEN MIXING RESET [IBRESET] AFTER ',
     &           IBRESET, ' STEPS'
            WRITE(6,'(A,T54,1PE12.4)')
     &         ' BROYDEN MIXING W02',W02BROY
            WRITE(6,'(A,T54,1PE12.4)') 
     &         ' KERKER MIXING PARAMETER [KERMIX]',KERMIX
          ENDIF
          IF(TMOVR) THEN 
            WRITE(6,'(A,T54,F12.4)')
     *         ' MOVE DENSITY WITH ATOMIC MOTION, MIXING PARAMETER',
     &           DMOVRMIX
          ELSE
            WRITE(6,'(A,T54,F12.4)')
     *         ' ALEXANDER MIXING:',ALXMIX
          ENDIF
        ENDIF
      ENDIF
      IF((TMDBO.OR.TMDFILE).AND.TEXTRAP) THEN
        IF(TASPC) THEN
          WRITE(6,'(A,T60,I6)') ' ASPC WAVEFUNCTION '
     &        // 'EXTRAPOLATION (MAX. HISTORY)',MEXTRA
          IF(NASPC.GT.0) WRITE(6,'(A,T60,I6)')
     *        ' NUMBER OF ASPC CORRECTOR STEPS: ',NASPC
        ELSE 
          WRITE(6,'(A,T60,I6)') ' POLYNOMIAL WAVEFUNCTION '
     &        // 'EXTRAPOLATION (MAX. HISTORY)',MEXTRA
        ENDIF
      ENDIF
      IF(GEOPT) THEN
        WRITE(6,'(A,T54,1PE12.6)') 
     *      ' CONVERGENCE CRITERIA FOR GEOMETRY OPTIMIZATION:',
     *      TOLNG
        IF(TSDP) THEN
          IF(TCGP) THEN
            WRITE(6,'(A)')
     *           ' GEOMETRY OPTIMIZATION BY CONJUGATE GRADIENT'
          ELSE
            WRITE(6,'(A)')
     *           ' GEOMETRY OPTIMIZATION BY STEEPEST DESCENT'
            IF(TSDPLINE) WRITE(6,'(A)')
     &           ' WITH MINIMISATION ALONG LINES'
          ENDIF
        ELSEIF(BFGS) THEN
          WRITE(6,'(A)')
     *    ' GEOMETRY OPTIMIZATION BY QUASI-NEWTON UPDATE'
        ELSEIF(LBFGS) THEN
          WRITE(6,'(A)')
     *    ' GEOMETRY OPTIMIZATION BY LOW-MEMORY BFGS'
        ELSEIF(PRFO) THEN
          WRITE(6,'(A)')
     *    ' TRANSITION STATE SEARCH BY PARTITIONED RFO'
          IF(NSVIB.GT.0) WRITE(6,'(A,T53,I7,A6)')
     *    ' VIBRATIONAL ANALYSIS EVERY ', NSVIB, ' STEPS'
          IF(NSVIB.EQ.-1) WRITE(6,'(A)')
     *    ' VIBRATIONAL ANALYSIS DONE AT END ONLY'
        ELSEIF(RFO) THEN
          WRITE(6,'(A)')
     *    ' GEOMETRY OPTIMIZATION BY RATIONAL FUNCTION OPTIMIZATION'
          IF(NSORDER.NE.0) THEN
            WRITE(6,'(A,T62,I4)')
     *    '     SADDLE POINT ORDER:',NSORDER
          ENDIF
        ELSEIF(GDIIS) THEN
          WRITE(6,'(A,/,A,T62,I4)')
     *    ' GEOMETRY OPTIMIZATION BY GDIIS/BFGS      ',
     *    '   SIZE OF GDIIS MATRIX: ',MGDIIS
        ELSEIF(TINR) THEN
          WRITE(6,'(A)')
     *        ' GEOMETRY OPTIMIZATION BY IMPLICIT NEWTON-RAPHSON '
     *        //' (USES DFPT) '
          IF (INR_PREC) THEN
             WRITE(6,'(A,I4)')
     *            ' PRECONDITIONED --  MAXIMUM NUMBER OF INTERNAL '//
     *            'INR ITERATIONS', itmax_inr
          ELSE
             WRITE(6,'(A,19X,I4)')
     *            ' MAXIMUM NUMBER OF INTERNAL INR ITERATIONS', 
     *            itmax_inr
          ENDIF
          WRITE(6,'(a,35x,i4)') ' NUMBER OF GRADIENT ZONES ',NREG
          DO I=1,NREG
             WRITE(6,'(A,E10.4,3X,A,E10.4)') ' FOR GNMAX BIGGER THAN ', 
     *            gnx_inr(i),' RESIDUAL CONV. AT ',tolx_inr(i)
          ENDDO
          IF(TMIXSD) THEN
             WRITE(6,'(x,a)') 'INITIAL OPTIMIZATION WITH IONIC STEEPEST'
     *            //' DESCENT'
             WRITE(6,'(A,T54,E12.6)')
     *            ' INR STARTING AFTER GNMAX = ',rmixsd
          ELSEIF(TMIXGDIIS) THEN
             WRITE(6,'(X,A)') 'INITIAL OPTIMIZATION WITH GDIIS'
             WRITE(6,'(A,T54,E12.6)')
     *            ' INR STARTING AFTER GNMAX = ',rmixsd
          ENDIF
        ENDIF
        IF(TSDC) THEN
          WRITE(6,'(A)')
     *      ' CELL OPTIMIZATION BY STEEPEST DESCENT'
        ENDIF
        IF(SIMUL) THEN
          WRITE(6,'(A)')
     *    ' COMBINED GEOMETRY/WAVEFUNCTION SCHEME '
        ENDIF
        IF(XGOUT) THEN
          IF(NGXYZ.EQ.1) THEN
            WRITE(6,'(A,A)') 'GEOMETRY OPTIMIZATION IS SAVED ON FILE ',
     *                     'GEO_OPT.xyz'
          ELSE
            WRITE(6,'(A,T56,I4,A6)') 
     *    ' GEOMETRY OPTIMIZATION IS SAVED ON FILE EVERY',NGXYZ,' STEPS'
          ENDIF
        ENDIF
      ENDIF
      IF(GEOPT.OR.(VIBRAT.AND.TSDIN)) THEN
        IF(RHE) THEN
          WRITE(6,'(A)') ' RESTART WITH OLD HESSIAN '
        ELSE
          IF(NPARA.EQ.-1) THEN
            WRITE(6,'(A)') 
     *    ' INITIAL HESSIAN IS UNIT MATRIX '
          ELSEIF(NPARA.EQ.0) THEN
            WRITE(6,'(A)') 
     *    ' EMPIRICAL INITIAL HESSIAN (DISCO PARAMETRISATION) '
          ELSEIF(NPARA.EQ.1) THEN
            WRITE(6,'(A)') 
     *    ' EMPIRICAL INITIAL HESSIAN (SCHLEGEL PARAMETRISATION) '
          ELSEIF(NPARA.EQ.2) THEN
            WRITE(6,'(A)') 
     *    ' INITIAL HESSIAN FROM UNIT AND TS SEARCH PARTIAL HESSIAN'
          ELSEIF(NPARA.EQ.3) THEN
            WRITE(6,'(A)') 
     *    ' INITIAL HESSIAN FROM DISCO AND TS SEARCH PARTIAL HESSIAN'
          ELSEIF(NPARA.EQ.4) THEN
            WRITE(6,'(A)') 
     *    ' INITIAL HESSIAN FROM SCHLEGEL AND TS SEARCH PARTIAL HESSIAN'
          ENDIF
        ENDIF
      ENDIF
      IF(VDWC) THEN
         WRITE(6,'(A)') ' USE EMPIRICAL VAN DER WAALS CORRECTION'
      ENDIF
      IF(TDMAL) THEN
         WRITE(6,'(A)') ' USE PARALLEL MATRIX ALGEBRA CODE'
      ENDIF
      IF(INITSPL) THEN
        WRITE(6,'(A,A)') 
     *       ' SPLINE INTERPOLATION IN G-SPACE ',
     *       'FOR PSEUDOPOTENTIAL FUNCTIONS'
      ENDIF
      IF(QSPLINE) THEN
        WRITE(6,'(A)') 
     *       ' SPLINE INTERPOLATION OF Q-FUNCTIONS '
      ENDIF
      IF(INITSPL.OR.QSPLINE) THEN
        WRITE(6,'(A,T56,I10)') 
     *       '    NUMBER OF SPLINE POINTS: ',NSPLP
      ENDIF
      IF(TFDIST) THEN
        WRITE(6,'(A)') 
     *       ' FNL ARRAY DISTRIBUTED OVER PROCESSORS'
      ENDIF
      IF(INTREAD) THEN
        WRITE(6,'(A)') 
     *       ' READ INFORMATION FROM INTERFACE FILE '
      ENDIF
      IF(INTWRITE) THEN
        WRITE(6,'(A)') 
     *       ' WRITE INFORMATION TO INTERFACE FILE '
      ENDIF
      IF(INTWRITE.OR.INTREAD) THEN
        WRITE(6,'(A,/,A)') 
     *       ' INTERFACE FILE NAME ',INTFN
      ENDIF
      IF(IUNK.NE.0) THEN
        WRITE(6,'(/,1X,64("="))')
        WRITE(6,'(1X,A,14X,A,14X,A)') '= ',
     &    'UNKNOWN KEYWORDS IN SECTION &CPMD','='
        DO I=1,IUNK
          WRITE(6,'(1X,A,A,A)') '= ',UNKNOWN(I),' ='
        ENDDO
      WRITE(6,'(1X,64("="),/)')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
