C     ==================================================================
      SUBROUTINE COPOT(RHOE,V,SCR,LSCR,TSTRESS)
C     ==--------------------------------------------------------------==
C     ==  COMPUTES THE POTENTIAL AND ENERGIES FOR EXCHANGE AND        ==
C     ==  CORRELATION FOR THE CORE CHARGES                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'strs.inc'
C     Arguments
      INTEGER    LSCR
      COMPLEX*16 V(MAXFFT,*)
      REAL*8     RHOE(NNR1,*),SCR(*)
      LOGICAL    TSTRESS
C     Variables
      DIMENSION  VNLCC(NHG,*),DRHOC(NHG,NSX,*)
      COMPLEX*16 VTEMP(NHG,NLSD)
      REAL*8     GRAD(NNR1,NLSD*4),VTMP(*),FNL(*),DFNL(*)
      POINTER    (IP_VTEMP,VTEMP),(IP_GRAD,GRAD),(IP_VTMP,VTMP)
      REAL*8     SXC,VXC,SGCX,SGCC
      REAL*8     DOTP
      EXTERNAL   DOTP
      CHARACTER  TAG*30
      LOGICAL    DEBUG
      INTEGER    ISUB,IR,LCOPOT,IL_VTEMP,
     &           IL_GRAD,IL_VTMP,
     &           IFIRST,KK
      SAVE       IFIRST
      DATA       IFIRST /0/
C     ==--------------------------------------------------------------==
      CALL TISET('     COPOT',ISUB)
C     ==--------------------------------------------------------------==
      IF(TTAU) THEN
        CALL STOPGM('COPOT','META FUNCTIONALS NOT IMPLENTED')
      ENDIF
      IF(IFIRST.EQ.0) THEN
        CALL MEMORY(IP_VNLCC,NHG*2*NLSD,'VNLCC')
        CALL MEMORY(IP_VNLT,NHG*2,'VNLT')
        IFIRST=1
      ENDIF
C     SCR partition
      DEBUG=.FALSE.
      CALL GIVE_SCR_COPOT(LCOPOT,TAG)
      CALL TEST_SCR('COPOT',TAG,LSCR,LCOPOT)
      IL_VTEMP=2*NHG*NLSD
      IL_GRAD =NNR1*NLSD*4      !GRADEN
      IL_VTMP =MAX(2*NHG,NNR1*NLSX) !COREC, GRADEN, GCLSD
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_VTEMP,IL_VTEMP,'VTEMP',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_GRAD,IL_GRAD,'GRAD',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_VTMP,IL_VTMP,'VTMP',DEBUG)
      CALL AZZERO(VTMP,IL_VTMP)
C     ==--------------------------------------------------------------==
C     == ADD CORE CHARGE TO RHOE                                      ==
C     ==--------------------------------------------------------------==
      CALL AZZERO(RHOE,NNR1*NLSD)
      CALL COREC(RHOE,VTMP,V)
C     ==--------------------------------------------------------------==
C     == COMPUTE EXCHANGE AND CORRELATION ENERGY (EXC)                ==
C     ==--------------------------------------------------------------==
#ifdef  _BGL 
      CALL ZAZZERO(V,NNR1)
#else
      CALL AZZERO(V,2*NNR1)
#endif
      CALL XCENER(SXC,VXC,RHOE,RHOE,V)
      SGCX = 0.0D0
      SGCC = 0.0D0
      IF(TGC) THEN
C     ==--------------------------------------------------------------==
C     == CALCULATE THE GRADIENT OF THE DENSITY                        ==
C     ==--------------------------------------------------------------==
        IF(TLSD) THEN
          CALL FWFFT(V(1,1))
          CALL ZGTHR(NHG,V(1,1),VTEMP(1,1),NZH)
          CALL FWFFT(V(1,2))
          CALL ZGTHR(NHG,V(1,2),VTEMP(1,2),NZH)
          DO IR=1,NNR1
            RHOE(IR,1)=RHOE(IR,1)-RHOE(IR,2)
          ENDDO
          CALL GRADEN(RHOE(1,1),V,GRAD(1,1),VTMP)
          CALL GRADEN(RHOE(1,2),V,GRAD(1,5),VTMP)
        ELSE
          CALL FWFFT(V)
          CALL ZGTHR(NHG,V,VTEMP,NZH)
          CALL GRADEN(RHOE,V,GRAD,VTMP)
        ENDIF
C     ==--------------------------------------------------------------==
C     == GRADIENT CORRECTION TO THE EXCHANGE ENERGY (EGCX)            ==
C     ==--------------------------------------------------------------==
        IF(TLSD) THEN
          CALL GCLSD(SGCX,SGCC,RHOE,V,VTEMP,VTMP,GRAD,.FALSE.)
        ELSE
          CALL GCENER(SGCX,SGCC,RHOE,V,VTEMP,VTMP,GRAD,.FALSE.)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     == TRANSF. CORE  POTENTIAL IN G-SPACE                           ==
C     == PUT THE CORE  POTENTIAL IN G-SPACE INTO VNLCC                ==
C     ==--------------------------------------------------------------==
      CALL FWFFT(V)
      CALL ZGTHR(NHG,V,VNLCC,NZH)
      IF(TLSD) THEN
        CALL FWFFT(V(1,2))
        CALL ZGTHR(NHG,V(1,2),VNLCC(1,2),NZH)
      ENDIF
C     ==--------------------------------------------------------------==
      EXCCO=SXC
      EGCXCO=SGCX
      EGCCCO=SGCC
      IF(TSTRESS) THEN
        DO KK=1,6
          CALL DRHOCORE(VTEMP,DRHOC(1,1,KK),EIGRB,EI1,EI2,EI3,
     *                  INYH)
          DECC(KK)=-DOTP(NHG,VTEMP,VNLCC)
        ENDDO
      ENDIF
      CALL SCRREL(SCR,LSCR,DEBUG)
      CALL TIHALT('     COPOT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_COPOT(LCOPOT,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !TCOPOT
      INCLUDE 'spin.inc'        !NLSD NLSX
C     Arguments
      INTEGER   LCOPOT
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LCOPOT=2*NHG*NLSD+NNR1*NLSD*4+MAX(2*NHG,NNR1*NLSX)
     &     +20                  !Overhead for SCRPTR.
      TAG='2*NHG*NLSD+NNR1*NLSD*4+...'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DRHOCORE(DCO,DRHOC,EIGRB,EI1,EI2,EI3,INYH)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'ions.inc'
C     Arguments
      COMPLEX*16 DCO(*),EIGRB(NHG,NAT),EI1(NAT,(2*NR1S-1)),
     &           EI2(NAT,(2*NR2S-1)),EI3(NAT,(2*NR3S-1))
      REAL*8     DRHOC(NHG,NSP)
      INTEGER    INYH(3,NHG)
C     Variables
      REAL*8     ER,EI
      INTEGER    ISA,IS,IA,IG
      COMPLEX*16 EI123
C     ==--------------------------------------------------------------==
      CALL AZZERO(DCO,2*NHG)
      IF(BIGMEM) THEN
C$OMP parallel do private(ISA,IA,IS,IG,ER,EI)
        DO IG=1,NHG 
          DO ISA=1,NAT
            IA=IATPT(1,ISA)
            IS=IATPT(2,ISA)
            ER=DREAL(EIGRB(IG,ISA))
            EI=DIMAG(EIGRB(IG,ISA))
            DCO(IG)=DCO(IG)+DCMPLX(ER*DRHOC(IG,IS),EI*DRHOC(IG,IS))
          ENDDO
        ENDDO
      ELSE
C$OMP parallel do private(IG,ISA,IA,IS,ER,EI,EI123)
        DO IG=1,NHG
          DO ISA=1,NAT
            IA=IATPT(1,ISA)
            IS=IATPT(2,ISA)
            EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *          EI3(ISA,INYH(3,IG))
            ER=DREAL(EI123)
            EI=DIMAG(EI123)
            DCO(IG)=DCO(IG)+DCMPLX(ER*DRHOC(IG,IS),EI*DRHOC(IG,IS))
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

