C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == CONSTRAINTS OF GEOMETRY FOR NUCLEAR POSITION                 ==
C     ==--------------------------------------------------------------==
C     == DMAX   Maximum sum of total possible displacements           ==
C     == MAXDUM Maximum dummy atoms                                   ==
C     == MAXLI  Maximum number of atoms given the coordinates of      ==
C     ==        dummy atom type 2.                                    ==
C     ==--------------------------------------------------------------==
      REAL*8    DMAX
      PARAMETER (DMAX=0.3D0)
      INTEGER   MAXDUM,MAXLI
      PARAMETER (MAXDUM=50,MAXLI=20)
C     ==--------------------------------------------------------------==
C     == LFCOM  .TRUE. if fix the center of mass                      ==
C     == LSHOVE .TRUE. if SHOVE option                                ==
C     == NODIM  Number of freedom degres                              ==
C     == NBOAD  Number of bonds which has to be changed               ==
C     ==        (added or deleted from the empirical hessian          ==
C     == MCNSTR Number of constraints                                 ==
C     == BOAD(3,NBOAD) BOAD(1,I) and BOAD(2,I) indicate the bond      ==
C     ==        between atoms. BOAD(3,I)<0 deleted, >0 added          ==
C     == LSKCOR(3,NAT) 0 if the atomic coordinate is fixed            ==
C     == NTCNST(6,MCNSTR) NTCNST(1,:) gives the type                  ==
C     ==                    1 STRETCH                                 ==
C     ==                    2 BEND                                    ==
C     ==                    3 TORSION                                 ==
C     ==                    4 DISTance           between atoms        ==
C     ==                      NTCNST(2,:) and NTCNST(3,:)             ==
C     ==                    5 OUTP                                    ==
C     ==                    6 COORD                                   ==
C     ==                    7 DIFFER                                  ==
C     ==                    8 COORSP                                  ==
C     ==                    9 COOR_RF                                 ==
C     ==                   10 BNSWT                                   ==
C     ==                   11 TOT_COOR                                ==
C     ==                   12 DISAXIS                                 ==
C     ==                   13 RESPOS                                  ==
C     ==                  101 MMFIELD                                 ==
C     ==                  NTCNST(2:5,:) gives the indexes of atoms    ==
C     ==                  if needed otherwise = 0                     ==
C     ==                  NTCNST(6,:) used if LSHOVE                  ==
C     ==                                                              ==
C     == LSKPTR(3,NAT)  0 if the atomic coordinate is fixed           ==
C     ==                  otherwise index between 1 and NODIM         ==
C     ==--------------------------------------------------------------==
C     == HESS(NODIM,NODIM) Hessian matrix (second derivatives)        ==
C     == DTM(NODIM)        Step for steepest descent                  ==
C     == PMALL(NODIM)      Atomic masses if not fixed otherwise 0.    ==
C     == KSHOVE(MCNSTR)                                               ==
C     == GRATE(MCNSTR)     Growth rate for constraint                 ==
C     == CNSVAL(MCNSTR)    Value of constraint                        ==
C     == CNPAR(2,MCNSTR)   Parameters for coord. num or bond switch   ==
C     == ANORM(NODIM,MCNSTR)                                          ==
C     == ASKEL(NODIM,MCNSTR,12)                                       ==
C     == mm_ASKEL(MCNSTR,12)                                    ==
C     == FCSTR(NODIM)      Force ConSTRaint                           ==
C     == FC(NODIM)                                                    ==
C     == FV(NODIM)                                                    ==
C     == CSIGM(MCNSTR) The weight factor for penalty function         ==
C     == XLAGR(MCNSTR)                                                ==
C     == YLAGR(MCNSTR)                                                ==
C     ==--------------------------------------------------------------==
      LOGICAL     LFCOM,LSHOVE
      INTEGER     NODIM,NBOAD,MCNSTR,NCTIM,
     &            BOAD(3,*),LSKCOR(3,*),NTCNST(6,*),LSKPTR(3,*),
     &            mm_ASKEL(MCNSTR,*)
      REAL*8      HESS(NODIM,*),DTM(*),PMALL(*),KSHOVE(*),
     &            CNSVAL(*),CNPAR(2,*),ANORM(NODIM,*),
     &            ASKEL(NODIM,MCNSTR,*),GRATE(*),CNSVAL_DEST(*),
     &            FCSTR(*),FC(*),FV(*),CSIGM(*),XLAGR(*),YLAGR(*)
      POINTER     (IP_BOAD,BOAD),
     &            (IP_HESS,HESS),(IP_DTM,DTM),(IP_PMALL,PMALL),
     *            (IP_LSKCOR,LSKCOR),(IP_NTCNST,NTCNST),
     *            (IP_LSKPTR,LSKPTR),(IP_CNSVAL,CNSVAL),
     *            (IP_CNPAR,CNPAR),(IP_GRATE,GRATE),
     *            (IP_CNSVAL_DEST,CNSVAL_DEST),
     *            (IP_ANORM,ANORM),(IP_ASKEL,ASKEL),(IP_FCSTR,FCSTR),
     *            (IP_FC,FC),(IP_FV,FV),(IP_CSIGM,CSIGM),
     *            (IP_XLAGR,XLAGR),(IP_YLAGR,YLAGR),
     *            (IP_KSHOVE,KSHOVE),
     *            (IP_mm_ASKEL,mm_ASKEL)
      COMMON/COTC0/LFCOM,LSHOVE,NODIM,NBOAD,MCNSTR,NCTIM
      COMMON/COTC0_IP/IP_BOAD,IP_HESS,IP_DTM,IP_PMALL,IP_LSKCOR,
     *            IP_LSKPTR,IP_NTCNST,IP_CNSVAL,IP_CNPAR,IP_ANORM,
     *            IP_ASKEL,IP_FCSTR,IP_GRATE,IP_CNSVAL_DEST,
     *            IP_FC,IP_FV,IP_CSIGM,IP_XLAGR,IP_YLAGR,IP_KSHOVE,
     *            IP_mm_ASKEL
C     ==--------------------------------------------------------------==
C     == RESTRAINTS                                                   ==
C     ==--------------------------------------------------------------==
      INTEGER     MRESTR,NTREST(6,*)
      LOGICAL     LHYPERPLANE
      REAL*8      RESVAL(*),RESFOR(*),GSRATE(*),RESVAL_DEST(*),
     *            RSKEL(NODIM,MRESTR,*),
     *            RESC(*),RESV(*),RESPOS(3,MRESTR),RESFDIFF(*),
     *            RESM(MRESTR,*),RSMASS(NODIM),
     *            RESPAR(2,MRESTR)
cmb   == RESPOS(3,MRESTR) contains the cartesian coordinates of the   ==
cmb   ==                  restraint position                          ==
      POINTER     (IP_NTREST,NTREST),(IP_RESVAL,RESVAL),
     *            (IP_RESFOR,RESFOR),(IP_GSRATE,GSRATE),
     *            (IP_RESVAL_DEST,RESVAL_DEST),
     *            (IP_RSKEL,RSKEL),(IP_RESC,RESC),(IP_RESV,RESV),
     *            (IP_RESPOS,RESPOS),
     *            (IP_RESFDIFF,RESFDIFF),(IP_RESM,RESM),
     *            (IP_RSMASS,RSMASS),
     *            (IP_RESPAR,RESPAR)
      COMMON/COTR/MRESTR,LHYPERPLANE
      COMMON/COTR_IP/IP_NTREST,IP_RESVAL,IP_RESFOR,IP_GSRATE,
     *            IP_RESVAL_DEST,IP_RSKEL,IP_RESC,IP_RESV,IP_RESPOS,
     *            IP_RESFDIFF,IP_RESM,IP_RSMASS,IP_RESPAR
C     ==--------------------------------------------------------------==
C     == PATOT    Total atomic masses if not fixed (SUM of PMALL(I))  ==
C     == The weight factors for the penalty function for:             ==
C     == DSIGMA    stretchs,                                          ==
C     == BSIGMA    bends,                                             ==
C     == TSIGMA    torsions.                                          ==
C     ==--------------------------------------------------------------==
      REAL*8      PATOT,DSIGMA,BSIGMA,TSIGMA
      COMMON/COTX/PATOT,DSIGMA,BSIGMA,TSIGMA
C     ==--------------------------------------------------------------==
C     == COORDINATION NUMBER CONSTRAINTS                              ==
C     == C_KAPPA : width of Fermi function                            ==
C     == C_RC    : radius of Fermi function                           ==
C     ==--------------------------------------------------------------==
      REAL*8      C_KAPPA,C_RC               
      COMMON/COTC/C_KAPPA,C_RC
C     ==--------------------------------------------------------------==
C     == DUMMY ATOMS : 3 types                                        ==
C     ==   Type 1 is fixed in place                                   ==
C     ==   Type 2 lies at the arithmetic mean of the coordinates of   ==
C     ==          real atoms.                                         ==
C     ==   Type 3 lies at the center of mass of the coordinates of    ==
C     ==          real atoms.                                         ==
C     == DUMMY1(3,MAXDUM) coordinates of type 1 dummy atoms           ==
C     == DUMMY2(3,MAXDUM) coordinates of type 2 dummy atoms           ==
C     == DUMMY3(3,MAXDUM) coordinates of type 3 dummy atoms           ==
C     == LISTDA(MAXDUM,1) Type of the dummy atom                      ==
C     == LISTDA(MAXDUM,2) Index of the dummy atom                     ==
C     == LISTD2(MAXLI,MAXDUM) For each dummy atom type 2, give the    ==
C     ==        indexes of atoms (type 2 = arithmetic mean of coord.) ==
C     == LISTD3(MAXLI,MAXDUM) For each dummy atom type 3, give the    ==
C     ==        indexes of atoms (type 3 = center of mass of coord.)  ==
C     == NDAT   Total number of dummy atoms                           ==
C     == NDAT1  Number of dummy atoms type 1                          ==
C     == NDAT2  Number of dummy atoms type 2                          ==
C     == NDAT3  Number of dummy atoms type 3                          ==
C     ==--------------------------------------------------------------==
      REAL*8      DUMMY1(3,MAXDUM),DUMMY2(3,MAXDUM),DUMMY3(3,MAXDUM)
      INTEGER     LISTDA(MAXDUM,2),LISTD2(MAXLI,MAXDUM),
     &     LISTD3(MAXLI,MAXDUM),NDAT,NDAT1,NDAT2,NDAT3
      COMMON/DUAT/DUMMY1,DUMMY2,DUMMY3,
     &            LISTDA,LISTD2,LISTD3,NDAT,NDAT1,NDAT2,NDAT3
C     ==--------------------------------------------------------------==
C     == TSDPLINE Minimization along the line of steepest descent     ==
C     ==          if TSDP=.TRUE.                                      ==
C     == TINVBFGS Use inverse matrix hessian for BFGS                 ==
C     == TCGP     .TRUE. Conjugate gradient scheme                    ==
C     == PXPAR(NODIM) Direction along the minimization                ==
C     ==--------------------------------------------------------------==
      LOGICAL     TSDPLINE,TCGP,TINVBFGS
      REAL*8      PXPAR(*)
      POINTER     (IP_PXPAR,PXPAR)
      COMMON/SDPL/TSDPLINE,TCGP,TINVBFGS
      COMMON/SDPL_IP/IP_PXPAR
C     ==================================================================
