C     ==================================================================
      SUBROUTINE CPLNGS (C0, C2, CF, C0INI, CR, SC0, CSCR, VPP, EIGV,
     $                  RHOE, RHOINI, PSI, SCR, LSCR,
     $                  TAU0, FION, IFCALC, IREC, TINFO, TFOR,
     $                  CPLVEC, CPLCONF, NSTATE)
C     ==--------------------------------------------------------------==
C     ==      DRIVER FOR CALCULATION OF INTERSURFACE COUPLINGS        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cplngs.inc'
C     Arguments
      LOGICAL    TINFO, TFOR
      INTEGER    NSTATE, IFCALC, IREC(100), LSCR
      COMPLEX*16 C0(*), C2(*), CF(*), CR(*), SC0(*), CSCR(*), PSI(*),
     $           C0INI(*)
      REAL*8     EIGV(*), TAU0(*), FION(*), VPP(*),
     $           RHOE(*), SCR(LSCR), RHOINI(*), CPLVEC(*),
     $           CPLCONF(*)
C     Variables
      INTEGER    ISUB
C     ==--------------------------------------------------------------==
      IF (.NOT.TCPL) RETURN
      CALL TISET('    CPLNGS',ISUB)
      IF (TCPLFD) THEN
         CALL CPLFD (C0, C2, CF, C0INI, CR, SC0, CSCR, VPP, EIGV,
     $               RHOE, RHOINI, PSI, SCR, LSCR,
     $               TAU0, FION, IFCALC, IREC, TINFO, TFOR,
     $               CPLVEC, NSTATE)
      ELSE
         CALL CPLANA (C0, CF, C2, CR, SC0, CSCR, VPP, RHOINI, CPLVEC,
     $               CPLCONF, NSTATE, RHOE, PSI, EIGV, SCR, LSCR)
      END IF
      CALL CPLCONFIG (CPLVEC, CPLCONF)
      CALL TIHALT('    CPLNGS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CPLFD (C0, C2, CF, C0INI, CR, SC0, CSCR, VPP, EIGV,
     $                  RHOE, RHOINI, PSI, SCR, LSCR,
     $                  TAU0, FION, IFCALC, IREC, TINFO, TFOR,
     $                  CPLVEC, NSTATE)
C     ==--------------------------------------------------------------==
C     ==   FINITE DIFFERENCE CALCULATION OF INTERSURFACE COUPLINGS    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'spin.inc'  ! NLSD
      INCLUDE 'ener.inc'  ! ETOT
      INCLUDE 'kpts.inc'  ! TKPNT
      INCLUDE 'andp.inc'  ! RIN0
      INCLUDE 'lscal.inc' ! stack operations
      INCLUDE 'cplngs.inc'
C     Arguments
      LOGICAL    TINFO, TFOR
      INTEGER    NSTATE, IFCALC, IREC(*), LSCR
      COMPLEX*16 C0(NGWK,NSTATE,*), C2(NGWK,*),
     $           CF(NGWK,NSTATE,*), C0INI(NGWK,NSTATE,*),
     $           CR(*), SC0(*), CSCR(*), PSI(*)
      REAL*8     EIGV(*), TAU0(3,NAX,*), FION(3,NAX,*), VPP(*),
     $           RHOE(*), SCR(*), RHOINI(NNR1,*),
     $           CPLVEC(3,NAX,NSX,*)
C     Variables
      LOGICAL    LPRINT
      INTEGER    IA, IACT, IC, IDF, IK, IS1, IS2, ISA, ISP,
     $           JA, JACT, JDF, JK, JSA, JSP, K, NC0, NRHO
      REAL*8     EPS_C2N, ETOTF, FCOMP, R02, R1M2, R1P2, R2M2, R2P2,
     $           R10, R11, R12, R22
      COMMON     /CPLSCR/ R02, R1M2, R1P2, R2M2, R2P2, R10, R11, R12,
     $           R22
      COMPLEX*16 Z12
      REAL*8     OLDF(3,NAX,NSX)
      POINTER    (IP_OLDF,OLDF)
C     Externals
      REAL*8     DOTP
      COMPLEX*16 ZDOTC
      EXTERNAL   DOTP, ZDOTC
C     ==--------------------------------------------------------------==
      LPRINT  = .TRUE.
      CALL FORCES_DIAG (NSTATE, C0, C2, CR, SC0, CSCR, VPP, EIGV,
     $                 RHOE, PSI, SCR, LSCR,
     $                 TAU0, TAU0, TAU0, FION, IFCALC,
     $                 IREC, TFOR, TINFO)
      IF (PARENT.AND.LPRINT) THEN
         WRITE(6,*)
     $     'FINITE-DIFFERENCE COUPLING VECTOR, INITIAL STATE'
         CALL CPL_WREIGEN (EIGV, NSTATE)
         WRITE(6,'(A,F12.5)') ' INITIAL POINT, ENERGY: ', ETOT
      END IF
      IF (TDIAG.AND.TDAVI) THEN
         NC0     = 2*NGWK*NDAVV*NKPNT + 8
      ELSE
         NC0     = 2*NGWK*NSTATE*NKPNT + 8
      END IF
      NRHO    = NNR1*NLSD
      EPS_C2N = 1.0D0 / (2.0D0 * EPS_C)
C
C     ==  Save the initial converged wavefuntion and density          ==
C
      CALL DCOPY (NC0, C0, 1, C0INI, 1)
      IF (TDIAG) CALL DCOPY (NRHO, RIN0, 1, RHOINI, 1)
      IF (PARENT) THEN
         IF (TFOR) THEN
            IF (TALLAT) THEN
               NVAR = 3*NAT
            ELSE
               NVAR = 3*NATFD
            END IF
            CALL MEMORY (IP_HESSCR, NVAR*NVAR, 'HESSCR')
            CALL MEMORY (IP_OLDF, 3*NAX*NSX, 'OLDF')
            CALL AZZERO (HESSCR, NVAR*NVAR)
            WRITE(6,'(A,A,I3,A)') ' CALCULATING FINITE DIFFERENCE ',
     $           'HESSIAN FOR ', NVAR, ' DOF'
         END IF
      END IF
C
C     ==  Product (constant) density if EPS_C<0                       ==
C
      IF (EPS_C.LT.0.0D0) THEN
         EPS_C = -EPS_C
         EPS_C2N = -EPS_C2N
         NOMORE = 0
      END IF
C
C     ==  Main finite difference loop over the dimensions             ==
C
      ISA = 0
      IDF = 0
      IACT = 1
      DO ISP = 1,NSP
        DO IA = 1,NA(ISP)
          ISA = ISA + 1
          IF (TALLAT.OR.ISA.EQ.IATFD(IACT)) THEN
             IACT = IACT + 1
          ELSE
             GOTO 9
          END IF
          DO K = 1,3
            IDF = IDF + 1
            IF (PARENT) THEN
               IF (LPRINT) WRITE(6,'(A,3I3)')
     $            ' TYPE, ATOM, DIMENSION: ', ISP, IA, K
            END IF
C
C     ==  Finite difference step backward                              ==
C
            TAU0(K,IA,ISP) = TAU0(K,IA,ISP) - EPS_C
            CALL PHFAC (TAU0)
            CALL DCOPY (NC0, C0INI, 1, CF, 1)
            IF (TDIAG) CALL DCOPY (NRHO, RHOINI, 1, RIN0, 1)
            CALL FORCES_DIAG (NSTATE, CF, C2, CR, SC0, CSCR, VPP, EIGV,
     $                        RHOE, PSI, SCR, LSCR,
     $                        TAU0, TAU0, TAU0, FION, IFCALC,
     $                        IREC, TFOR, TINFO)
            ETOTF = ETOT
            IF (PARENT) THEN
               IF (TFOR) CALL DCOPY (3*NSX*NAX, FION, 1, OLDF, 1)
               IF (LPRINT) WRITE(6,'(A,F12.5)')
     $           ' DONE BACKWARD, ENERGY: ', ETOT
            END IF
C
C     ==  Two finite difference steps forward                        ==
C
            TAU0(K,IA,ISP) = TAU0(K,IA,ISP) + 2.0D0*EPS_C
            CALL PHFAC (TAU0)
            CALL DCOPY (NC0, C0INI, 1, C0, 1)
            IF (TDIAG) CALL DCOPY (NRHO, RHOINI, 1, RIN0, 1)
            CALL FORCES_DIAG (NSTATE, C0, C2, CR, SC0, CSCR, VPP, EIGV,
     $                        RHOE, PSI, SCR, LSCR,
     $                        TAU0, TAU0, TAU0, FION, IFCALC,
     $                        IREC, TFOR, TINFO)
            IF (PARENT) THEN
              IF (TFOR) THEN
                CALL DAXPY (3*NAX*NSX, -1.0D0, FION, 1, OLDF, 1)
                CALL DSCAL (3*NAX*NSX, 0.5D0*EPS_C2N, OLDF, 1)
                JSA = 0
                JDF = 0
                JACT = 1
                DO JSP = 1,NSP
                  DO JA = 1,NA(JSP)
                    JSA = JSA + 1
                    IF (TALLAT.OR.JSA.EQ.IATFD(JACT)) THEN
                      JACT = JACT + 1
                      DO JK = 1,3
                        JDF = JDF + 1
                        HESSCR(IDF+NVAR*(JDF-1),1) =
     $                      HESSCR(IDF+NVAR*(JDF-1),1) + OLDF(JK,JA,JSP)
                        HESSCR(JDF+NVAR*(IDF-1),1) =
     $                      HESSCR(JDF+NVAR*(IDF-1),1) + OLDF(JK,JA,JSP)
                      END DO
                    END IF
                  END DO
                END DO
              END IF
              IF (LPRINT) WRITE(6,'(A,F12.5)')
     $             ' DONE FORWARD, ENERGY: ', ETOT
            END IF
C
            DO IC = 1,NSURF
              IS1 = ISURF(1,IC)
              IS2 = ISURF(2,IC)
              IF (TKPNT) THEN
                 DO IK = 1,NKPNT
                    Z12 = ZDOTC (NGWK, C0(1,IS1,IK), 1, CF(1,IS2,IK), 1)
#ifdef PARALLEL
                    CALL GLOSUM (2, Z12)
#endif
                 END DO
              ELSE
                 R02 = DOTP (NGW, C0INI(1,IS2,1), CF(1,IS2,1))
                 R10 = DOTP (NGW, C0(1,IS1,1), C0INI(1,IS1,1))
                 R11 = DOTP (NGW, C0(1,IS1,1), CF(1,IS1,1))
                 R12 = DOTP (NGW, C0(1,IS1,1), CF(1,IS2,1))
                 R22 = DOTP (NGW, C0(1,IS2,1), CF(1,IS2,1))
                 R1P2 = DOTP (NGW, C0INI(1,IS1,1), CF(1,IS2,1))
                 R2P2 = DOTP (NGW, C0INI(1,IS2,1), CF(1,IS2,1))
                 R1M2 = DOTP (NGW, C0INI(1,IS1,1), C0(1,IS2,1))
                 R2M2 = DOTP (NGW, C0INI(1,IS2,1), C0(1,IS2,1))
#ifdef PARALLEL
                 CALL GLOSUM (9, R02)
#endif
                 IF (R2P2.LT.0.0D0) R1P2 = -R1P2
                 IF (R2M2.LT.0.0D0) R1M2 = -R1M2
                 IF (PARENT.AND.LPRINT) THEN
                    WRITE(6,'(A,I3,A,I3,A)')
     $                   ' DOT-PRODUCTS FOR STATES a = ', IS1,
     $                   ' AND b = ', IS2, ':'
                    WRITE(6,'(2(A,F12.8,A,F12.8,/),A,F12.8)')
     $                   '   <a|a''> = ', R11, '   <b|b''>  = ', R22,
     $                   '   <a|a0> = ', R10, '   <b0|b''> = ', R02,
     $                   '   <a|b''> = ', R12
                    WRITE(6,'(A,F12.8,A,F12.8)')
     $                   '   <a0|b> = ', R1M2, '   <a0|b''> = ', R1P2
                 END IF
                 R12 = R12 * EPS_C2N
                 IF (R11*R22.LT.0.0D0) R12 = -R12
                 FCOMP = -(ETOTF-ETOT)*EPS_C2N
                 CPLVEC(K,IA,ISP,IC) = (R1P2 - R1M2)* EPS_C2N
                 IF (PARENT) THEN
                    IF (LPRINT) THEN
                       WRITE(6,'(A,1PE12.5)')
     $                   ' COUPLING (SCALED):     ', CPLVEC(K,IA,ISP,IC)
                       WRITE(6,'(A,1PE12.5)')
     $                   ' COUPLING FROM <a|b''>:  ', R12
                       WRITE(6,'(A,1PE12.5)')
     $                   ' F/D FORCE COMPONENT:   ', FCOMP
                    END IF
                 END IF
                 IF (.NOT.TFOR) FION(K,IA,ISP) = FCOMP
              END IF
            END DO              ! IC = 1,NSURF
C
C     ==  Undo finite difference step                                 ==
C
            TAU0(K,IA,ISP) = TAU0(K,IA,ISP) - EPS_C
          END DO                ! K = 1,3
 9        CONTINUE              ! jump here if atom is not interesting
        END DO                  ! IA = 1,NA(ISP)
      END DO                    ! ISP = 1,NSP
      IF (TFOR) THEN
         LVLHES = .TRUE.
         IF (PARENT) CALL FREEM (IP_OLDF)
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CPLANA (C0, C1, C2, CR, SC0, CSCR, VPP, RHOINI, CPLVEC,
     $                  CPLCONF, NSTATE, RHOE, PSI, EIGV, SCR, LSCR)
C     ==--------------------------------------------------------------==
C     ==        ANALYTIC CALCULATION OF INTERSURFACE COUPLINGS        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'coor.inc' ! TAU0
      INCLUDE 'cppt.inc' ! NZH
      INCLUDE 'ropt.inc' ! SPCG,IESR
      INCLUDE 'sfac.inc' ! DDFNL
      INCLUDE 'nlps.inc' ! NDFNL
      INCLUDE 'spin.inc' ! NLSD,NSUP
      INCLUDE 'elct.inc' ! F
      INCLUDE 'poin.inc' ! RHOO, POTR
      INCLUDE 'irat.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'cplngs.inc'
      include 'ener.inc'
C     Arguments
      INTEGER    NSTATE, LSCR
      REAL*8     CPLVEC(3,NAX,NSX,*), CPLCONF(3,NAX,*),
     $           RHOE(*), EIGV(*), SCR(*), RHOINI(*),
     $           VPP(*)
      COMPLEX*16 C0(NGWK,*), C1(NGWK,*), C2(NGWK,*),
     $           CR(*), SC0(*), CSCR(*), PSI(*)
C     Variables
      CHARACTER  TAG*30, TYPE*10, ORBTYP*5
      LOGICAL    DEBUG, LCONV, LPRINT, LPRINT2, TFDENS, TKSMAT
      INTEGER    I, IA, IACT, IAT, IC, IG, IMAX, IR, IS1, IS2, ISP,
     $           ISUB, IV, IVV, K, KMAX,
     $           LCPLNGS, LDDXC, LDFNL, LDONE, LEIVPS, LEIROP, LH1NL,
     $           LPSI, LRHOE, LSCR2, LVECT, NATOMS, N3
      INTEGER    IDONE(*)
      REAL*8     C, DEINV, DEINVV(*), E2(5), EEXC, EGND,
     $           EIND, FC, FCOMP, FCOMP2, FCSUM, RLEN, RMAX,
     $           TOL_LR_BAK, TRACE, VP
      REAL*8     DDXC(*), DFNL(*), DRHOE(NNR1,NLSD),
     $           FCSRF(NSURF), FNL(*), RHOOV(*),
     $           SCR2(*), V(3), VC(3), VECT(3,NAT,NVECT)
      DIMENSION  F(NSTATE)
      COMPLEX*16 EIVPS(NHG), EIROP(NHG), EIVPS1(NHG), EIROP1(NHG),
     $           H1NL(*)
      POINTER    (IP_EIVPS,EIVPS), (IP_EIROP,EIROP), (IP_IDONE,IDONE),
     $           (IP_EIVPS1,EIVPS1), (IP_EIROP1,EIROP1),
     $           (IP_H1NL,H1NL), (IP_DDXC,DDXC), (IP_DEINVV,DEINVV),
     $           (IP_RHOOV,RHOOV), (IP_DRHOE,DRHOE), (IP_VECT,VECT),
     $           (IP_FCSRF,FCSRF), (IP_SCR2,SCR2)
      REAL*8     DOTP,DDOT,DASUM
      EXTERNAL   DOTP,DDOT,DASUM
C     ==--------------------------------------------------------------==
      LPRINT  = .TRUE.          ! Progress report
      LPRINT2 = .FALSE.         ! Diagnostics
      LPRINT  = (LPRINT  .AND. PARENT)
      LPRINT2 = (LPRINT2 .AND. PARENT)
      CALL TISET ('    CPLANA', ISUB)
C     SCR partition - space for subroutines called by CPLANA
      CALL GIVE_SCR_CPLNGS (LCPLNGS, TAG)
      CALL TEST_SCR ('CPLANA', TAG, LSCR, LCPLNGS)
C     For linear response - space for locally stored arrays
      IF (TCPLLR) THEN
         LEIVPS = 2*NHG
         LEIROP = 2*NHG
         LDFNL  = 6*NAT*NHXS*NDFNL
         LH1NL  = 2*NGWK*NSTATE
         IF (TXC_ANALYTIC) THEN
            LDDXC = NNR1*(2*NLSD-1)
         ELSEIF (LOPTI.EQ.0 .OR. LOPTI.EQ.2) THEN
            LDDXC = NNR1*(2*NLSD-1)
         ELSE
            LDDXC = 1
         END IF
         CALL RHOE_PSI_SIZE (LRHOE, LPSI)
         IF (TALLDOF) THEN
           LVECT = 3*NAT
         ELSE
           LVECT = 3*NAT*NVECT
         END IF
         LDONE = 3*NAT/IRAT+1
C
         DEBUG = .FALSE.
         CALL SCRSET (SCR, LSCR, DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_EIVPS,  LEIVPS, 'EIVPS',  DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_EIROP,  LEIROP, 'EIROP',  DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_EIVPS1, LEIVPS, 'EIVPS1', DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_EIROP1, LEIROP, 'EIROP1', DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_DDFNL,  LDFNL,  'DDFNL',  DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_H1NL,   LH1NL,  'H1NL',   DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_POTR,   LRHOE,  'POTR',   DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_RHOOV,  LRHOE,  'RHOOV',  DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_DDXC,   LDDXC,  'DDXC',   DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_DEINVV, NSURF,  'DEINVV', DEBUG)
         CALL SCRPTR (SCR, LSCR, IP_VECT,   LVECT,  'VECT',   DEBUG)
         IF (.NOT.TALLDOF) THEN
           CALL SCRPTR (SCR, LSCR, IP_IDONE,  LDONE,  'IDONE',  DEBUG)
           CALL SCRPTR (SCR, LSCR, IP_FCSRF,  NSURF,  'FCSRF',  DEBUG)
         END IF
         CALL SCRGET (SCR, LSCR, IP_SCR2,   LSCR2,  'SCR2',   DEBUG)
         CALL GET_ADDR (IP_RHOO, RHOINI(1))
         CALL GET_ADDR (IP_DRHOE, RHOE(1))
      ELSE
         CALL GET_ADDR (IP_RHOOV, RHOE(1))
         CALL GET_ADDR (IP_SCR2, SCR(1))
         LSCR2    = LSCR
      END IF
      IF (TSPECV) CALL CPLRDVEC (VECT, NAT, NVECT, TFDENS)
C     ==--------------------------------------------------------------==
C     ==  Terms at constant density                                   ==
C     ==--------------------------------------------------------------==
      CALL AZZERO (CPLVEC, 3*NAX*NSX*NSURF)
      TKSMAT = TLSE
      IF (TKSMAT) THEN
C        Excitation between lowest two singlet states
         IF (TLSE) THEN
            CALL SWITCH_ST ('SET', F, NSTATE, TLSE, TLSETS)
            CALL SWITCH_ST ('GND', F, NSTATE, TLSE, TLSETS)
            CALL FORCEDR (C0, C2, SC0, RHOE, PSI, TAU0, FION, EIGV,
     $           SCR2, LSCR2, NSTATE, 1, .FALSE., .FALSE.)
            EGND = ETOT
            IF (LPRINT) WRITE (6,110) 'ENERGY OF STATE S0:', EGND
            CALL SWITCH_ST ('EXC', F, NSTATE, TLSE, TLSETS)
            CALL FORCEDR (C0, C2, SC0, RHOE, PSI, TAU0, FION, EIGV,
     $           SCR2, LSCR2, NSTATE, 1, .FALSE., .FALSE.)
            EEXC = ETOT
            IF (LPRINT) WRITE (6,110) 'ENERGY OF STATE S1:', EEXC
            CALL SWITCH_ST ('DEF', F, NSTATE, TLSE, TLSETS)
            IF (LPRINT) WRITE (6,110)
     $           'EXCITATION ENERGY FROM S0 TO S1:', EEXC-EGND
         END IF
C        Diagonal KS matrix elements, swapped states
         DO I = 1,NSTATE-2
            CALL DCOPY (NGW, C0(1,I), 1, C1(1,I), 1)
         END DO
         CALL DCOPY (NGW, C0(1,NSTATE-1), 1, C1(1,NSTATE), 1)
         CALL DCOPY (NGW, C0(1,NSTATE), 1, C1(1,NSTATE-1), 1)
         CALL FORCEDR (C1, C2, SC0, RHOE, PSI, TAU0, FION, EIGV,
     $                 SCR2, LSCR2, NSTATE, 1, .FALSE., .FALSE.)
         IF (LPRINT) WRITE (6,110)
     $        'ENERGY OF STATE TS (SWAPPED ORBITALS):', ETOT
         CALL HPSI (C1, C2, SC0, RHOE, PSI, SCR2, LSCR2, NSTATE,
     $              1, NLSD)
         CALL OVLAP (NSTATE, EIGV, C1, C2)
         CALL SUMMAT (EIGV, NSTATE, SCR2, LSCR2)
         IF(.FALSE..AND.PARENT) THEN
            PRINT *,'KS MATRIX (SWAPPED ORBITALS)'
            DO I = 1,NSTATE
               PRINT '(10F12.8)', (EIGV(K+(I-1)*NSTATE), K=1,NSTATE)
            END DO
         END IF
         DO IC = 1,NSURF
            IS1 = ISURF(1,IC)
            IS2 = ISURF(2,IC)
            EEXC = EIGV(IS2+(IS2-1)*NSTATE)
            EGND = EIGV(IS1+(IS1-1)*NSTATE)
            DEINVV(IC) = EEXC-EGND
            IF (LPRINT) WRITE (6,110)
     $           'EXCITATION ENERGY (SWAPPED ORBITALS):', EEXC-EGND
         END DO
C        Diagonal KS matrix elements, right order
         CALL FORCEDR (C0, C2, SC0, RHOE, PSI, TAU0, FION, EIGV,
     $                 SCR2, LSCR2, NSTATE, 1, .FALSE., .FALSE.)
         IF (LPRINT) WRITE (6,110) 'ENERGY OF STATE TS:', ETOT

         CALL HPSI (C0, C2, SC0, RHOE, PSI, SCR2, LSCR2, NSTATE,
     $              1, NLSD)
         CALL OVLAP (NSTATE, EIGV, C0, C2)
         CALL SUMMAT (EIGV, NSTATE, SCR2, LSCR2)
         DO IC = 1,NSURF
            IS1 = ISURF(1,IC)
            IS2 = ISURF(2,IC)
            EEXC = EIGV(IS1+(IS1-1)*NSTATE)
            EGND = EIGV(IS2+(IS2-1)*NSTATE)
            DEINVV(IC) = 0.5D0 * (DEINVV(IC) + EEXC-EGND)
            IF (LPRINT) WRITE (6,110)
     $           'EXCITATION ENERGY FROM KS ORBITALS:', EEXC-EGND
         END DO
         IF(.FALSE..AND.PARENT) THEN
            PRINT *,'KS MATRIX'
            DO I = 1,NSTATE
               PRINT '(10F12.8)', (EIGV(K+(I-1)*NSTATE), K=1,NSTATE)
            END DO
         END IF
         ORBTYP="GENER"
      ELSE
C        Other excitations
         CALL FORCEDR (C0, C2, SC0, RHOE, PSI, TAU0, FION, EIGV,
     $                 SCR2, LSCR2, NSTATE, 1, .FALSE., .FALSE.)
         CALL CANON (C0, C2, F, N, EIGV, SCR, LSCR)
         ORBTYP="CANON"
      END IF
C     Overlap density and local forces
      DO IC = 1,NSURF
         IS1 = ISURF(1,IC)
         IS2 = ISURF(2,IC)
         CALL AZZERO (RHOOV, NNR1)
         CALL RHOABOFR (1, C0(1,IS1), C0(1,IS2), RHOOV, PSI)
C        Transform density to G space
         DO IR = 1,NNR1
            PSI(IR) = DCMPLX(RHOOV(IR),0.D0)
         END DO
         CALL FWFFT (PSI)
         CALL TDRHOF_DIS (CPLVEC(1,1,1,IC), RHOOV, PSI)
      END DO
C     Forces due to nonlocal PP
      CALL RNLSM1 (C0, NSTATE, SCR2, LSCR2, 1)
      CALL RNLSM2 (C0, SCR2, LSCR2, NSTATE, 1, 1)
      CALL RNLCPL (CPLVEC)
      CALL GLOSUM (3*NAX*NSX*NSURF, CPLVEC)
      DO IC = 1,NSURF
         IS1 = ISURF(1,IC)
         IS2 = ISURF(2,IC)
         IF (TKSMAT) THEN
            DEINV = 1.0D0 / DEINVV(IC)
            IF (LPRINT) WRITE (6,110)
     $           'EIGENVALUE DIFFERENCE: ', DEINVV(IC)
         ELSE
            DEINV = 1.0D0 / (EIGV(IS2)-EIGV(IS1))
            IF (LPRINT) WRITE (6,120) 'EXCITATION ENERGY (STATES ',
     $           IS1, ' - ', IS2, '):', EIGV(IS2)-EIGV(IS1)
         END IF
         IF (TCPLLR) DEINVV(IC) = DEINV
         CALL DSCAL (3*NAX*NSX, -DEINV, CPLVEC(1,1,1,IC), 1)
         IF(TSYMRHO.AND.PARENT)
     $        CALL SYMVEC (CPLVEC(1,1,1,IC), SCR2, LSCR2)
      END DO
C     ==--------------------------------------------------------------==
C     ==  Linear response for dependence of KS operator on density    ==
C     ==--------------------------------------------------------------==
      IF (.NOT.TCPLLR) THEN
         CALL TIHALT ('    CPLANA', ISUB)
         RETURN
      END IF
      IF (LPRINT) THEN
         WRITE(6,'(A)') ' COUPLINGS AT CONSTANT DENSITY'
         CALL PRCPLNGS (CPLVEC, CPLCONF, .FALSE.)
      END IF
C     Recalculate density, but re-use POTR, FNL, DFNL, EIVPS, and EIROP
      CALL DCOPY (NNR1*NLSD, RHOE, 1, POTR, 1)
      CALL RHOOFR (C0, RHOE, PSI, SCR2, LSCR2, NSTATE)
      CALL DCOPY (NNR1*NLSD, RHOE, 1, RHOO, 1)
C     Non-local pseudopotential, calculate DDFNL - allocated above
      CALL RNLSM_2D (C0, SCR2, LSCR2, NSTATE)
C     Save FNL
      CALL FNL_SET ("SAVE")
      CALL FNLALLOC (NSTATE, .TRUE., .FALSE.)
C     Local pseudopotential, use structure factors calculated before
      CALL EICALC (EIVPS, EIROP)
C     Calculate and store analytic dmu/dn
      CALL LR_XCPOT (DDXC, RHOO, SCR, LSCR, .FALSE.)
C     Preconditioning for LR optimization - cf. SDLINRES
      PREC = .TRUE.
      CALL KSDIAG (VPP)
      IF (TKSMAT) THEN
        TRACE = DASUM (NSTATE, EIGV, NSTATE+1) / DBLE(NSTATE)
      ELSE
        TRACE = DASUM (NSTATE, EIGV, 1) / DBLE(NSTATE)
      END IF
      DO IG = 1,NGW
        VP = VPP(IG) + TRACE
        VPP(IG) = ABS(VP/(VP**2+LR_HTHRS**2))
      END DO
C     ==--------------------------------------------------------------==
C     ==  Unit vector along constant density coupling vector          ==
C     ==--------------------------------------------------------------==
      CALL CPLCONFIG (CPLVEC, CPLCONF)
      RLEN = 0.0D0
      IAT = 0
      DO ISP = 1,NSP
        DO IA = 1,NA(ISP)
          IAT = IAT + 1
          IF (TFDENS.OR..NOT.TSPECV) THEN
            DO K = 1,3
              VECT(K,IAT,1) = CPLCONF(K,IA,ISP)
              RLEN = RLEN + VECT(K,IAT,1)**2
            END DO
          END IF
        END DO              ! IA = 1,NA(ISP)
      END DO                ! ISP = 1,NSP
      NATOMS = IAT
      N3     = 3*NATOMS
      IF (TFDENS.OR..NOT.TSPECV) THEN
        RLEN = 1.0D0 / SQRT(RLEN)
        DO IAT = 1,NATOMS
          DO K = 1,3
            VECT(K,IAT,1) = RLEN*VECT(K,IAT,1)
          END DO
        END DO
      END IF
C     ==--------------------------------------------------------------==
C     ==  Brute-force loop over all DOF of ions                       ==
C     ==--------------------------------------------------------------==
      IF (TALLDOF) THEN
C
C     ==  Main finite difference loop over the dimensions             ==
C
        IAT = 0
        IACT = 1
        DO ISP = 1,NSP
          DO IA = 1,NA(ISP)
            IAT = IAT + 1
            IF (TALLAT.OR.IAT.EQ.IATFD(IACT)) THEN
              IACT = IACT + 1
            ELSE
              DO IC = 1,NSURF
                CPLVEC(K,IA,ISP,IC) = 0.0D0
              END DO
              GOTO 9
            END IF
            DO K = 1,3
              IF (LPRINT) WRITE(6,'(A,3I3)')
     $                ' TYPE, ATOM, DIMENSION: ', ISP, IA, K
C
C     ==  Linear response of nuclear displacement                     ==
C
C             The following lines stem from SDLINRES
              EIND = 0.0D0
              CALL EIND_II (TAU0, ISP, IA, K, EIND, IESR)
              CALL EIND_LOC (EIND, ISP, IAT, K, RHOO, PSI, EIROP)
C             Calculate constant force from NL-PP
              CALL FNL_SET ("SWITCH")
              CALL NL_RES (ISP, IAT, K, H1NL, NSTATE, SCR2, LSCR2)
              CALL EIND_NL (EIND, ISP, IAT, K, NSTATE)
              CALL FNL_SET ("SWITCH")
C             Calculate the constant part of the local potential
              CALL EICALC1 (K, ISP, IAT, EIVPS1, EIROP1)
C             Calculate first-order wavefunction
              SDIIS = .TRUE.
              SPCG  = .TRUE.
              CALL OPT_LR (C0, C1, C2, SC0, EIND, EIGV, DRHOE,
     $                     H1NL, EIVPS1, EIROP1, DDXC, VPP, CSCR, CR,
     $                     PSI, SCR2, LSCR2, NSTATE, "PHONON", ORBTYP)
C             End SDLINRES - calculate first order density
              CALL RHO1OFR (C0, C1, F, DRHOE, PSI, NSTATE)
C             Hartree and XC first-order terms
              CALL V1OFRHO1 (E2, DRHOE, DDXC, PSI, SCR2, LSCR2)
C             Coupling component for each pair of surfaces
              DO IC = 1,NSURF
                IS1 = ISURF(1,IC)
                IS2 = ISURF(2,IC)
                IF (IC.GT.1) THEN
                  CALL AZZERO (RHOOV, NNR1)
                  CALL RHOABOFR (1, C0(1,IS1), C0(1,IS2), RHOOV, PSI)
                  DEINV = DEINVV(IC)
                END IF
                IF (TLSE) THEN
                  FCOMP = 0.5D0 * (
     $                    DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1) +
     $                    DDOT (NNR1, RHOOV, 1, DRHOE(1,3), 1))
                ELSE IF (TLSD.AND.IS2.GT.NSUP) THEN
                  FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1)
                ELSE
                  FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,1), 1)
                END IF
                FCOMP = FCOMP * OMEGA/(NR1S*NR2S*NR3S) * DEINV
                CALL GLOSUM (1, FCOMP)
                IF (LPRINT) THEN
                 WRITE(6,'(A,2F12.5)') ' FIXED DENSITY AND RESPONSE: ',
     $                 CPLVEC(K,IA,ISP,IC), FCOMP
                 WRITE(6,'(A,F12.5)') ' TOTAL COUPLING:             ',
     $                 CPLVEC(K,IA,ISP,IC) + FCOMP
                END IF
                CPLVEC(K,IA,ISP,IC) = CPLVEC(K,IA,ISP,IC) + FCOMP
C
                FCOMP  = DOTP (NGW, C0(1,IS1), C1(1,IS2))
                FCOMP2 = DOTP (NGW, C0(1,IS2), C1(1,IS1))
                CALL GLOSUM (1, FCOMP)
                CALL GLOSUM (1, FCOMP2)
                IF (LPRINT) WRITE(6,'(A,2F12.5)')
     $               'COUPLINGS FROM OVERLAP: ', FCOMP, FCOMP
              END DO              ! IC = 1,NSURF
              if (.false.) then
              do i = 1,nstate
                 call azzero (rhoov, nnr1)
                 call rhoabofr (1, c0(1,i), c0(1,i), rhoov, psi)
                 fcomp = DDOT (NNR1, RHOOV, 1, DRHOE(1,1), 1)
                 call glosum (1, fcomp)
                 fcomp = fcomp * OMEGA/(NR1S*NR2S*NR3S)
                 if (parent) print *,'State ', i, ': ', fcomp
              end do
              end if
            END DO                ! K = 1,3
 9          CONTINUE              ! jump here if atom is not interesting
          END DO                  ! IA = 1,NA(ISP)
        END DO                    ! ISP = 1,NSP
C     ==--------------------------------------------------------------==
C     ==  Iterative scheme for contributions of response of density   ==
C     ==--------------------------------------------------------------==
      ELSE                      ! IF (TALLDOF)
C
C     ==  Response of density along the direction at constant density ==
C
        IF (LPRINT) WRITE(6,'(A,A)') ' LINEAR RESPONSE ALONG ',
     $        'CONSTANT DENSITY COUPLING VECTOR'
        IV = 1
C       Clear history of searched components
        DO K = 1,3*NAT
          IDONE(K) = 0
        END DO
C
C     ==  Iterative search of the direction                           ==
C
 10     CONTINUE             ! DO ... UNTIL (IV.GE.NVECT .OR. LCONV)
          IF (LPRINT) THEN
            WRITE(6,'(A,I3,A)') ' VECTOR ', IV, ':'
            WRITE(6,'(2(2X,3F8.4))')
     $           ((VECT(K,IAT,IV), K=1,3), IAT=1,NATOMS)
          END IF
C         Calculate constant part of local and non-local interactions
          CALL GET_EIND (VECT(1,1,IV), EIND, EIVPS1, EIROP1, H1NL,
     $                TAU0, IESR, RHOO, PSI, NSTATE, EIROP, SCR2, LSCR2)
C         Calculate first-order wavefunction
          SDIIS = .TRUE.
          SPCG  = .TRUE.
          CALL OPT_LR (C0, C1, C2, SC0, EIND, EIGV, DRHOE,
     $                 H1NL, EIVPS1, EIROP1, DDXC, VPP, CSCR, CR,
     $                 PSI, SCR2, LSCR2, NSTATE, "PHONON", ORBTYP)
C         Calculate first order density
          CALL RHO1OFR (C0, C1, F, DRHOE, PSI, NSTATE)
C         Hartree and XC first-order terms
          CALL V1OFRHO1 (E2, DRHOE, DDXC, PSI, SCR2, LSCR2)
C         Coupling component for each pair of surfaces
          FCSUM = 0.0D0
          DO IC = 1,NSURF
            IS1 = ISURF(1,IC)
            IS2 = ISURF(2,IC)
            IF (IC.GT.1) THEN
              CALL AZZERO (RHOOV, NNR1)
              CALL RHOABOFR (1, C0(1,IS1), C0(1,IS2), RHOOV, PSI)
              DEINV = DEINVV(IC)
            END IF
            IF (TLSE) THEN
              FCOMP = 0.5D0 * (
     $              DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1) +
     $              DDOT (NNR1, RHOOV, 1, DRHOE(1,3), 1))
            ELSE IF (TLSD.AND.IS2.GT.NSUP) THEN
              FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1)
            ELSE
              FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,1), 1)
            END IF
            FCOMP = FCOMP * OMEGA/(NR1S*NR2S*NR3S) * DEINV
            CALL GLOSUM (1, FCOMP)
            FCSRF(IC) = FCOMP
            FCSUM = FCSUM + CSURF(IC)*FCOMP
            IF (LPRINT) WRITE(6,'(A,I3,A,F12.5)')
     $           ' RESPONSE ALONG VECTOR ', IV, ': ', FCOMP
          END DO                ! IC = 1,NSURF
C
C     ==  Response along search vector large, increase accuracy       ==
C
          IF (IV.EQ.1 .OR. ABS(FCSUM).GT.FC_LOW) THEN
            TYPE = "NOINIT"
            TOL_LR_BAK = TOL_LR
            IF (IV.EQ.1 .OR. ABS(FCSUM).GT.FC_HIGH) THEN
              TOL_LR = TOL_LR / F_HIGH
            ELSE IF (ABS(FCSUM).GT.FC_MED) THEN
              TOL_LR = TOL_LR / F_MED
            ELSE
              TOL_LR = TOL_LR / F_LOW
            END IF
            IF (LPRINT) WRITE(6,'(A,F12.5)')
     $           ' INCREASED ACCURACY: ', TOL_LR
            CALL OPT_LR (C0, C1, C2, SC0, EIND, EIGV, DRHOE,
     $                   H1NL, EIVPS1, EIROP1, DDXC, VPP, CSCR, CR,
     $                   PSI, SCR2, LSCR2, NSTATE, TYPE, ORBTYP)
            CALL RHO1OFR (C0, C1, F, DRHOE, PSI, NSTATE)
C           Hartree and XC first-order terms
            CALL V1OFRHO1 (E2, DRHOE, DDXC, PSI, SCR2, LSCR2)
C           Coupling component for each pair of surfaces
            DO IC = 1,NSURF
              IS1 = ISURF(1,IC)
              IS2 = ISURF(2,IC)
              IF (IC.GT.1) THEN
                CALL AZZERO (RHOOV, NNR1)
                CALL RHOABOFR (1, C0(1,IS1), C0(1,IS2), RHOOV, PSI)
                DEINV = DEINVV(IC)
              END IF
              IF (TLSE) THEN
                FCOMP = 0.5D0 * (
     $                DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1) +
     $                DDOT (NNR1, RHOOV, 1, DRHOE(1,3), 1))
              ELSE IF (TLSD.AND.IS2.GT.NSUP) THEN
                FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1)
              ELSE
                FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,1), 1)
              END IF
              FCOMP = FCOMP * OMEGA/(NR1S*NR2S*NR3S) * DEINV
              CALL GLOSUM (1, FCOMP)
              FCSRF(IC) = FCOMP
              IF (LPRINT) WRITE(6,'(A,F12.5)')
     $             ' MORE ACCURATE RESPONSE: ', FCOMP
            END DO              ! IC = 1,NSURF
            TOL_LR = TOL_LR_BAK
          END IF                ! IF (IV.EQ.1 .OR. FCSUM.GT.FC_LOW)
C
C     ==  Store response                                              ==
C
          DO IC = 1,NSURF
            IAT = 0
            DO ISP = 1,NSP
              DO IA = 1,NA(ISP)
                IAT = IAT + 1
                DO K = 1,3
                  FC = FCSRF(IC) * VECT(K,IAT,IV)
                  CPLVEC(K,IA,ISP,IC) = CPLVEC(K,IA,ISP,IC) + FC
                END DO
              END DO
            END DO
          END DO
C
C     ==  Not converged, find new search direction                    ==
C
          LCONV = (ABS(FCOMP).LT.TOLCPL)
          IF (IV.LT.NVECT .AND. .NOT.LCONV) THEN
            IF (LPRINT) THEN
              WRITE(6,'(A,I3)') ' COUPLINGS, ITERATION: ', IV
              CALL PRCPLNGS (CPLVEC, CPLCONF, .FALSE.)
            END IF
            IV = IV + 1
C           Skip generation of new vector if specified
            IF (.NOT.TSPECV) THEN
C             Look for maximum component not yet searched
              RMAX = 0.0D0
              IMAX = 0
              KMAX = 0
              CALL AZZERO (VECT(1,1,IV), N3)
              DO IAT = 1,NATOMS
                DO K = 1,3
                  IF (IDONE(K+3*(IAT-1)).EQ.0) THEN
                    IF (ABS(VECT(K,IAT,IV-1)).GT.RMAX) THEN
                      RMAX = ABS(VECT(K,IAT,IV-1))
                      IMAX = IAT
                      KMAX = K
                    END IF
                  END IF
                END DO
              END DO
              IF (LPRINT) WRITE(6,*) 'COMPONENT: ', IMAX, KMAX
C             Select and mark new component as searched
              IDONE(KMAX+3*(IMAX-1)) = IV
              VECT(KMAX,IMAX,IV) = 1.0D0
            END IF              ! (.NOT.TSPECV)
C           Orthogonalize new vector with respect to all previous ones
            RLEN = SQRT(DDOT(N3, VECT(1,1,IV), 1, VECT(1,1,IV), 1))
            CALL DSCAL (N3, 1.0D0/RLEN, VECT(1,1,IV), 1)
            DO IVV = 1,IV-1
              RLEN = DDOT (N3, VECT(1,1,IVV), 1, VECT(1,1,IV), 1)
              CALL DAXPY (N3, -RLEN, VECT(1,1,IVV), 1, VECT(1,1,IV), 1)
              RLEN = SQRT(DDOT(N3, VECT(1,1,IV), 1, VECT(1,1,IV), 1))
              CALL DSCAL (N3, 1.0D0/RLEN, VECT(1,1,IV), 1)
            END DO
C           Report singular transformation
            DO IVV = 1,IV-1
              RLEN = DDOT (N3, VECT(1,1,IVV), 1, VECT(1,1,IV), 1)
              IF (LPRINT2) WRITE(6,'(A,I3,A,F10.6)')
     $             ' OVERLAP WITH VECTOR ', IVV, ': ', RLEN
              IF (PARENT .AND. ABS(RLEN).GT.1.0D-6) THEN
                 WRITE(6,'(A,I3,A,I3,A,E10.4)')
     $                ' WARNING: OVERLAP BETWEEN VECTOR ', IVV, ' AND ',
     $                IV, ': ', RLEN
              END IF
            END DO
            GOTO 10
C
C     ==  Done with iterative scheme for one or the other reason      ==
C
          ELSE IF (LCONV) THEN
            IF (LPRINT) WRITE(6,'(A,A,I3,A)') ' ITERATIVE SCHEME FOR ',
     $            'COUPLINGS CONVERGED IN ', IV, ' CYCLES'
          ELSE IF (IV.GE.NVECT .AND. TOLCPL.GT.0.0D0) THEN
            IF (LPRINT) WRITE(6,'(A)')
     $          ' WARNING: ITERATIVE SCHEME FOR COUPLINGS NOT CONVERGED'
          ELSE IF (IV.GE.NVECT) THEN
            IF (LPRINT.AND.TOLCPL.GT.0.0D0) WRITE(6,'(A,I3)')
     $          ' ITERATIVE SCHEME FOR COUPLINGS DONE, CYCLE ', IV
          END IF
        CONTINUE             ! END DO ... UNTIL (IV.GE.NVECT .OR. LCONV)
      END IF                 ! IF (TALLDOF) ... ELSE ...
C     ==--------------------------------------------------------------==
C     ==  Brute force and iterative scheme: translational invariance  ==
C     ==--------------------------------------------------------------==
      IF (.TRUE.) THEN
        CALL CPLCONFIG (CPLVEC, CPLCONF)
        IF (LPRINT) THEN
          WRITE(6,*) 'COUPLINGS, NOT CORRECTED FOR TRANSLATIONAL ',
     $          'INVARIANCE:'
          CALL PRCPLNGS (CPLVEC, CPLCONF, .FALSE.)
        END IF
C
C     ==  Analytically minimize deviation from invariance (for C)     ==
C
        DO K = 1,3
          V(K) = 0.0D0
          VC(K) = 0.0D0
        END DO
        IAT = 0
        DO ISP = 1,NSP
          DO IA = 1,NA(ISP)
            IAT = IAT + 1
            DO K = 1,3
              V(K) = V(K) + CPLCONF(K,IA,ISP)
              VC(K) = VC(K) + VECT(K,IAT,1)
            END DO
          END DO
        END DO
        C = -DDOT (3, VC, 1, V, 1) / DDOT (3, VC, 1, VC, 1)
        IF (LPRINT) WRITE(6,'(A,F9.6)')
     $       ' COEFFICIENT ENSURING TRANSLATIONAL INVARIANCE: ', C
C
C     ==  Apply correction                                            ==
C
        DO IC = 1,NSURF
          IAT = 0
          DO ISP = 1,NSP
            DO IA = 1,NA(ISP)
              IAT = IAT + 1
              DO K = 1,3
                CPLVEC(K,IA,ISP,IC) = CPLVEC(K,IA,ISP,IC) +
     $                C*VECT(K,IAT,1)
              END DO
            END DO
          END DO
        END DO
        IF (LPRINT) THEN
          WRITE(6,*) 'COUPLINGS, CORRECTED ALONG CONSTANT DENSITY ',
     $          'TERM:'
          CALL PRCPLNGS (CPLVEC, CPLCONF, .FALSE.)
        END IF
C
C     ==  Undo correction                                             ==
C
        DO IC = 1,NSURF
          IAT = 0
          DO ISP = 1,NSP
            DO IA = 1,NA(ISP)
              IAT = IAT + 1
              DO K = 1,3
                CPLVEC(K,IA,ISP,IC) = CPLVEC(K,IA,ISP,IC) -
     $                C*VECT(K,IAT,1)
              END DO
            END DO
          END DO
        END DO
      END IF
C     ==--------------------------------------------------------------==
      CALL SCRREL (SCR, LSCR, DEBUG)
      IP_POTR=0
      CALL TIHALT ('    CPLANA', ISUB)
C     ==--------------------------------------------------------------==
 110  FORMAT (1X,A,T41,F20.8,' A.U.')
 120  FORMAT (1X,A,I3,A,I3,A,T41,F20.8, ' A.U.')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GET_EIND (VECT, EIND, EIVPS1, EIROP1, H1NL,
     $                     TAU0, IESR, RHOO, PSI, NSTATE, EIROP,
     $                     SCR, LSCR)
C     ==--------------------------------------------------------------==
C     ==  Linear response along unit vector VECT                      ==
C     ==  Input:  VECT                                                ==
C     ==  Output: EIND, EIVPS1, EIROP1, H1NL                          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
C     Arguments
      INTEGER      IESR, NSTATE, LSCR
      REAL*8       VECT(3,NAT), EIND, TAU0(*), RHOO(*), SCR(LSCR)
      COMPLEX*16   EIVPS1(NHG), EIROP1(NHG), H1NL(NGWK*NSTATE), PSI(*),
     $             EIROP(NHG)
C     Local variables
      CHARACTER*30 TAG
      LOGICAL      DEBUG
      INTEGER      IA, IAT, ISP, ISUB, K, LGET_EIND, LSCR3
      REAL*8       COMP_K, EIND_K, SCR3(*)
      COMPLEX*16   EIVPS1_K(NHG), EIROP1_K(NHG), H1NL_K(NGWK*NSTATE)
      POINTER      (IP_EIVPS1_K,EIVPS1_K), (IP_EIROP1_K,EIROP1_K),
     $             (IP_H1NL_K,H1NL_K), (IP_SCR3,SCR3)
C     ==--------------------------------------------------------------==
      DEBUG = .FALSE.
      CALL TISET ('  GET_EIND', ISUB)
      CALL GIVE_SCR_GET_EIND (LGET_EIND, TAG)
      CALL TEST_SCR ('GET_EIND', TAG, LSCR, LGET_EIND)
C     ==--------------------------------------------------------------==
      CALL SCRSET (SCR, LSCR, DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_EIVPS1_K, 2*NHG, 'EIVPS1_K', DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_EIROP1_K, 2*NHG, 'EIROP1_K', DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_H1NL_K, 2*NGWK*NSTATE, 'H1NL_K', DEBUG)
      CALL SCRGET (SCR, LSCR, IP_SCR3, LSCR3, 'SCR3', DEBUG)
C     ==--------------------------------------------------------------==
      EIND = 0.0D0
      CALL AZZERO (EIVPS1, 2*NHG)
      CALL AZZERO (EIROP1, 2*NHG)
      CALL AZZERO (H1NL, 2*NGWK*NSTATE)
      IAT = 0
      DO ISP = 1,NSP
         DO IA = 1,NA(ISP)
            IAT = IAT + 1
            DO K = 1,3
               EIND_K = 0.0D0
               CALL EIND_II (TAU0, ISP, IA, K, EIND_K, IESR)
               CALL EIND_LOC (EIND_K, ISP, IAT, K, RHOO, PSI, EIROP)
C
               CALL FNL_SET ("SWITCH")
               CALL NL_RES (ISP, IAT, K, H1NL_K, NSTATE, SCR3, LSCR3)
               CALL EIND_NL (EIND, ISP, IAT, K, NSTATE)
               CALL FNL_SET ("SWITCH")
C
               CALL EICALC1 (K, ISP, IAT, EIVPS1_K, EIROP1_K)
C
               COMP_K = VECT(K,IAT)
               EIND = EIND + COMP_K*EIND_K
               CALL DAXPY (2*NHG, COMP_K, EIVPS1_K, 1, EIVPS1, 1)
               CALL DAXPY (2*NHG, COMP_K, EIROP1_K, 1, EIROP1, 1)
               CALL DAXPY (2*NGWK*NSTATE, COMP_K, H1NL_K, 1, H1NL, 1)
            END DO
         END DO
      END DO
C     ==--------------------------------------------------------------==
      CALL SCRREL (SCR, LSCR, DEBUG)
      CALL TIHALT ('  GET_EIND', ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CPLCONFIG (CPLVEC, CPLCONF)
C     ==--------------------------------------------------------------==
C     ==        ANALYTIC CALCULATION OF INTERSURFACE COUPLINGS        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cplngs.inc'
C     Arguments
      REAL*8     CPLVEC(3,NAX,NSX,NSURF), CPLCONF(3,NAX,NSX)
C     Variables
      INTEGER    IA, IC, ISP, K
      REAL*8     R
C     ==--------------------------------------------------------------==
      DO ISP = 1,NSP
         DO IA = 1,NA(ISP)
            DO K = 1,3
               R = 0.0D0
               DO IC = 1,NSURF
                  R = R + CSURF(IC)*CPLVEC(K,IA,ISP,IC)
               END DO
               CPLCONF(K,IA,ISP) = R
            END DO
         END DO
      END DO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PRCPLNGS (CPLVEC, CPLCONF, TTRANS)
C     ==--------------------------------------------------------------==
C     ==        PRINT NON-ADIABATIC COUPLING VECTOR TO STDOUT         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cplngs.inc'
C     Arguments
      LOGICAL    TTRANS
      REAL*8     CPLVEC(3,NAX,NSX,NSURF), CPLCONF(3,NAX,NSX)
C     Variables
      LOGICAL    TFOR
      PARAMETER  (TFOR = .TRUE.)
      INTEGER    I, IA, IAT, IC, ISP, K
      REAL*8     CPLWRK(3,NAX,NSX,NSURF), V(3)
C     ==--------------------------------------------------------------==
      IF (.NOT. TCPL) RETURN
      IF (.NOT. PARENT) RETURN
C
C     ==  Copy to CPLWRK applying or not applying uniform correction  ==
C
      DO IC = 1,NSURF
        DO K = 1,3
          V(K) = 0.0D0
        END DO
        IF (TTRANS) THEN        ! Uniform correction for translation
          IAT = 0
          DO ISP = 1,NSP
            DO IA = 1,NA(ISP)
              IAT = IAT + 1
              DO K = 1,3
                V(K) = V(K) + CPLVEC(K,IA,ISP,IC)
              END DO
            END DO
          END DO
          DO K = 1,3
            V(K) = V(K) / IAT
          END DO
        END IF                  ! IF (TTRANS)
        DO ISP = 1,NSP
          DO IA = 1,NA(ISP)
            DO K = 1,3
              CPLWRK(K,IA,ISP,IC) = CPLVEC(K,IA,ISP,IC) - V(K)
            END DO
          END DO
        END DO
      END DO
C
      CALL CPLCONFIG (CPLWRK, CPLCONF)
C
      IF (TTRANS) WRITE(6,*) 'PRINTING COUPLINGS APPLYING ',
     $     'TRANSLATIONAL INVARIANCE USING CONSTANT SHIFT'
      DO IC = 1,NSURF
         IF (NSURF.GT.1) WRITE(6,*) 'PAIR ', IC
         WRITE(6,*) 'COUPLING BETWEEN KS STATES ',
     $        ISURF(1,IC), ' AND ', ISURF(2,IC)
         I = 0
         DO ISP = 1,NSP
            DO IA = 1,NA(ISP)
               I = I + 1
               WRITE(6,'(T3,I4,3F12.6)')
     $              I,(CPLWRK(K,IA,ISP,IC), K=1,3)
            END DO
         END DO
      END DO
      IF (NSURF.GT.1) THEN
         WRITE(6,*) 'COUPLING BETWEEN CONFIGURATIONS'
         I = 0
         DO ISP = 1,NSP
            DO IA = 1,NA(ISP)
               I = I + 1
               WRITE(6,'(T3,I4,3F12.6)')
     $              I,(CPLCONF(K,IA,ISP), K=1,3)
            END DO
         END DO
      END IF
C
      CALL CPLCONFIG (CPLVEC, CPLCONF)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CPL_WREIGEN (EIGV, NSTATE)
C     ==--------------------------------------------------------------==
C     ==       PRINT ADIABATIC KS ENERGIES FROM DIAGONALIZATION       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'cplngs.inc'
C     Arguments
      INTEGER NSTATE
      REAL*8  EIGV(NSTATE,NKPNT)
C     Variables
      INTEGER I, IS1, IS2
C     ==--------------------------------------------------------------==
      IF (.NOT.PARENT) RETURN
      IF (TCPL) THEN
         WRITE(6,'(A,A)') ' ENERGIES OF KS STATES RELEVANT FOR ',
     $        'COUPLING VECTOR GIVEN IN AU'
         DO I = 1,NSURF
            IS1 = ISURF(1,I)
            IS2 = ISURF(2,I)
            WRITE(6,FMT=10) IS1, EIGV(IS1,1)
            WRITE(6,FMT=10) IS2, EIGV(IS2,1)
         END DO
      ELSE
         WRITE(6,'(A)') ' ENERGIES OF ALL KS STATES GIVEN IN AU'
         DO IS1 = 1,N
            WRITE(6,FMT=10) IS1, EIGV(IS1,1)
         END DO
      END IF
C     ==--------------------------------------------------------------==
 10   FORMAT (3X,'KS ENERGY OF STATE ', I3, ': ', F12.7)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CPLNGS_INIT
C     ==--------------------------------------------------------------==
C     == Block data: init variables for couplings                     ==
C     ==--------------------------------------------------------------==
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cplngs.inc'
C     ==--------------------------------------------------------------==
      TCPL       = .FALSE.  ! Don't calculate couplings by default
      TCPLFD     = .FALSE.  ! Analytic instead of finite diff.
      TALLAT     = .TRUE.   ! Do FD couplings with all atoms
      TCPLLR     = .FALSE.  ! Don't use linear response for cpl.
      TALLDOF    = .FALSE.  ! Don't do brute force LR over all DOF
      TSPECV     = .FALSE.  ! Don't specify vectors for LR
      NSURF      = 0        ! Coupling between no KS orbitals
      NATFD      = 0        ! Not required if (TALLAT)
      NVECT      = 5        ! Maximum number of vectors
      EPS_C      = 5.0D-3   ! Finite difference displacement
      TOLCPL     = 0.0D0    ! Tolerance for iterative LR couplings
      FC_LOW     = 0.05D0   ! Threshold for increased LR accuracy
      FC_MED     = 0.1D0    ! Threshold for increased LR accuracy
      FC_HIGH    = 0.5D0    ! Threshold for increased LR accuracy
      F_LOW      = 2.0D0    ! Increased LR accuracy
      F_MED      = 4.0D0    ! Increased LR accuracy
      F_HIGH     = 8.0D0    ! Increased LR accuracy
C     ==--------------------------------------------------------------==
      END
C     ==================================================================
      SUBROUTINE CPL_PARA
C     ==--------------------------------------------------------------==
C     ==  SETUP AND DISTRIBUTION OF PARAMETERS FOR COUPLING (SYSIN)   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'        ! N=NSTATE
      INCLUDE 'spin.inc'        ! TLSD,NSUP
      INCLUDE 'cplngs.inc'
C     Variables
      INTEGER MSGLEN,I
      REAL*8  C
C     ==--------------------------------------------------------------==
C
C     == Distribution of parameters for non-adiabatic couplings       ==
C
      MSGLEN = 2 * 8/IRAT
      CALL MY_BCAST (TCPL, MSGLEN, SOURCE, ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST (NSURF, MSGLEN, SOURCE, ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST (EPS_C, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (TOLCPL, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (FC_LOW, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (FC_MED, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (FC_HIGH, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (F_LOW, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (F_MED, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (F_HIGH, MSGLEN, SOURCE, ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST (TCPLFD, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (TALLAT, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (TCPLLR, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (TALLDOF, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (TSPECV, MSGLEN, SOURCE, ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST (NATFD, MSGLEN, SOURCE, ALLGRP)
      CALL MY_BCAST (NVECT, MSGLEN, SOURCE, ALLGRP)
      IF (TCPL) THEN
        IF (PARENT) THEN
           IF (TCPLFD) THEN
             WRITE(6,'(A)') ' CALCULATE NON-ADIABATIC COUPLINGS'
             WRITE(6,'(A,T56,1PE10.4)')
     $           ' FINITE-DIFFERENCE DISPLACEMENT', ABS(EPS_C)
             IF (EPS_C.LT.0.0D0) WRITE(6,'(A)')
     $           ' PRODUCT ANSATZ FOR FINITE-DIFFERENCE COUPLINGS'
             IF (.NOT.TALLAT) THEN
               WRITE(6,'(A,A,T63,I3)') ' FINITE-DIFFERENCE ONLY ',
     $             ' FOR A SUBSET OF ATOMS: ', NATFD
               WRITE(6,'(2X,16I4)') (IATFD(I), I=1,NATFD)
             END IF
           ELSE
             WRITE(6,'(A)')
     $           ' CALCULATE ANALYTIC NON-ADIABATIC COUPLINGS'
             IF (TCPLLR) THEN
               WRITE(6,'(A,A)') ' USING LINEAR RESPONSE FOR ',
     $             'DENSITY DEPENDENCE OF KS-OPERATOR'
               IF (TALLDOF) THEN
                 WRITE(6,'(A,A)') ' LINEAR RESPONSE ALONG CARTESIAN ',
     $               'COORDINATES'
                 IF (.NOT.TALLAT) THEN
                   WRITE(6,'(A,A,T63,I3)') ' FINITE-DIFFERENCE ONLY ',
     $                 ' FOR A SUBSET OF ATOMS: ', NATFD
                   WRITE(6,'(2X,16I4)') (IATFD(I), I=1,NATFD)
                 END IF
               ELSE
                 WRITE(6,'(A)') ' ITERATIVE LINEAR-RESPONSE SCHEME'
                 WRITE(6,'(A,T62,I4)') ' MAXIMUM NUMBER OF VECTORS: ',
     $                NVECT
                 IF (TSPECV) WRITE(6,'(A)') ' VECTORS ARE SPECIFIED'
                 WRITE(6,'(A,T59,F7.5)') ' TOLERANCE FOR COUPLINGS: ',
     $                TOLCPL
                 IF (FC_HIGH.NE.0.5D0 .AND. F_HIGH.NE.8.0D0) THEN
                   WRITE(6,'(A,F7.5,A,F7.4)')
     $                   ' LR TOLERANCE DIVIDED BY ', F_LOW,
     $                   ' IF COMPONENT EXCEEDS ', FC_LOW
                   WRITE(6,'(A,F7.5,A,F7.4)')
     $                   ' LR TOLERANCE DIVIDED BY ', F_MED,
     $                   ' IF COMPONENT EXCEEDS ', FC_MED
                   WRITE(6,'(A,F7.5,A,F7.4)')
     $                   ' LR TOLERANCE DIVIDED BY ', F_HIGH,
     $                   ' IF COMPONENT EXCEEDS ', FC_HIGH
                 END IF
               END IF
             ELSE
               WRITE(6,'(A)') ' NEGLECTING RESPONSE OF DENSITY'
             END IF
           END IF
           WRITE(6,'(A,I1,A)') ' CONTRIBUTIONS FROM ', NSURF,
     $         ' PAIRS OF KS STATES'
           C = 0.0D0
           DO I = 1,NSURF
             C = C + CSURF(I)
             WRITE(6,'(A,I3,A,I3,A,T59,F7.5)') ' STATES ',
     $           ISURF(1,I), ' - ', ISURF(2,I), ': ', CSURF(I)
           END DO
           WRITE(6,'(A,T59,F7.5)') ' SUM OF COEFFICIENTS: ', C
           WRITE(6,*)
        ELSE
           CALL MEMORY (IP_ISURF, 2*NSURF/IRAT, 'ISURF')
           CALL MEMORY (IP_CSURF, NSURF, 'ISURF')
           IF (.NOT.TALLAT) CALL MEMORY (IP_IATFD, NATFD, 'IATFD')
        END IF
        MSGLEN = 2*NSURF * 8/IRAT
        CALL MY_BCAST (ISURF, MSGLEN, SOURCE, ALLGRP)
        MSGLEN = NSURF * 8
        CALL MY_BCAST (CSURF, MSGLEN, SOURCE, ALLGRP)
        MSGLEN = NATFD * 8/IRAT
        CALL MY_BCAST (IATFD, MSGLEN, SOURCE, ALLGRP)
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RNLCPL(CPLVEC)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE NON-LOCAL POTENTIAL CONTRIBUTION TO THE FORCE ON THE    ==
C     ==  IONIC DEGREES OF FREEDOM                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'        !NLM
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cplngs.inc'
C     Arguments
      REAL*8  CPLVEC(3,NAX,NSX,*)
C     Variables
      REAL*8  DFNL(NAT,NHXS,3,*),FNL(LDF1,NHXS,*),TT
      INTEGER ISUB,ISA0,IS,IV,JV,II,ISA,L,KI,LI,L2,LJ,KJ,
     &        K,IA,IATL,IC,IS1,IS2
      REAL*8  DFAB(NAT,NHXS,2)
      POINTER (IP_DFAB,DFAB)
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('    RNLCPL',ISUB)
      CALL MEMORY(IP_DFAB,2*NAT*NHXS,"DFAB")
      DO IC=1,NSURF
        IS1=ISURF(1,IC)
        IS2=ISURF(2,IC)
        DO K=1,3
          CALL AZZERO(DFAB,2*NAT*NHXS)
          IF(IS1.GE.NST12(MEPOS,1).AND.
     &       IS1.LE.NST12(MEPOS,2) ) THEN
            II=IS1-NST12(MEPOS,1)+1
            CALL DCOPY(NHXS*NAT,DFNL(1,1,K,II),1,DFAB(1,1,1),1)
          ENDIF
          IF(IS2.GE.NST12(MEPOS,1).AND.
     &       IS2.LE.NST12(MEPOS,2) ) THEN
            II=IS2-NST12(MEPOS,1)+1
            CALL DCOPY(NHXS*NAT,DFNL(1,1,K,II),1,DFAB(1,1,2),1)
          ENDIF
          CALL GLOSUM(2*NAT*NHXS,DFAB)
          ISA0=0
          DO IS=1,NSP
            IF(TVAN(IS)) THEN
C             Vanderbild pp
              CALL STOPGM("RNLCPL","VDB NOT IMPLEMENTED")
            ELSEIF(TSGP(IS)) THEN
C             Stefan Goedecker pp
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    TT=HLSG(KI,KJ,L,IS)
                    DO IA=1,NA(IS)
                      ISA=ISA0+IA
                      IF(TFDIST) THEN
                        IATL=ISA-IPEPT(1,MEPOS)+1
                        CPLVEC(K,IA,IS,IC)=CPLVEC(K,IA,IS,IC)-0.5D0*TT*(
     &                    DFAB(ISA,IV,1)*FNL(IATL,JV,IS2)
     &                   +DFAB(ISA,IV,2)*FNL(IATL,JV,IS1)
     &                   +DFAB(ISA,JV,1)*FNL(IATL,IV,IS2)
     &                   +DFAB(ISA,JV,2)*FNL(IATL,IV,IS1))
                      ELSE
                        CPLVEC(K,IA,IS,IC)=CPLVEC(K,IA,IS,IC)-TT*(
     &                    DFAB(ISA,IV,1)*FNL(ISA,JV,IS2)
     &                   +DFAB(ISA,IV,2)*FNL(ISA,JV,IS1)
     &                   +DFAB(ISA,JV,1)*FNL(ISA,IV,IS2)
     &                   +DFAB(ISA,JV,2)*FNL(ISA,IV,IS1))
                      ENDIF
                    ENDDO
                  ENDIF
                ENDDO
              ENDDO
            ELSE
C             Other pp (numeric)
              DO IV=1,NGH(IS)
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
                  IF(ISA.GE.IPEPT(1,MEPOS).AND.
     &               ISA.LE.IPEPT(2,MEPOS)) THEN
                    IF(TFDIST) THEN
                      IATL=ISA-IPEPT(1,MEPOS)+1
                      CPLVEC(K,IA,IS,IC)=CPLVEC(K,IA,IS,IC)-WSG(IS,IV)*
     &                    (DFAB(ISA,IV,1)*FNL(IATL,IV,IS2)
     &                    +FNL(IATL,IV,IS1)*DFAB(ISA,IV,2))
                    ELSE
                      CPLVEC(K,IA,IS,IC)=CPLVEC(K,IA,IS,IC)-WSG(IS,IV)*
     &                    (DFAB(ISA,IV,1)*FNL(ISA,IV,IS2)
     &                    +FNL(ISA,IV,IS1)*DFAB(ISA,IV,2))
                    ENDIF
                  ENDIF
                ENDDO
              ENDDO
            ENDIF
            ISA0 = ISA0 + NA(IS)
          ENDDO
        ENDDO
      ENDDO
      CALL FREEM(IP_DFAB)
      CALL TIHALT('    RNLCPL',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_CPLNGS (LCPLNGS, TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG
      INCLUDE 'elct.inc'        !N
      INCLUDE 'spin.inc'        !NLSD
      INCLUDE 'cplngs.inc'      !TCPLFD,TCPLLR,TALLDOF,NSURF
      INCLUDE 'ions.inc'        !NAT
      INCLUDE 'nlps.inc'        !NDFNL
      INCLUDE 'linres.inc'      !TXC_ANALYTIC,LOPTI
      INCLUDE 'irat.inc'        !IRAT
C     Arguments
      INTEGER   LCPLNGS, LCPLSUB, LDDXC, LDFNL, LDONE, LEIROP, LEIVPS,
     $          LFCSRF, LH1NL, LPSI, LRHOE, LVECT
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      IF (TCPLFD.OR..NOT.TCPLLR) THEN
         TAG     ='1'    ! All subroutines are called by RWFOPT too
         LCPLNGS = 1
      ELSE
         TAG     = 'CPLNGS'
         LEIVPS = 2*NHG
         LEIROP = 2*NHG
         LDFNL  = 6*NAT*NHXS*NDFNL
         LH1NL  = 2*NGWK*N
         IF (TXC_ANALYTIC) THEN
            LDDXC = NNR1*(2*NLSD-1)
         ELSEIF (LOPTI.EQ.0 .OR. LOPTI.EQ.2) THEN
            LDDXC = NNR1*(2*NLSD-1)
         ELSE
            LDDXC = 1
         END IF
         CALL RHOE_PSI_SIZE (LRHOE, LPSI)
         IF (TALLDOF) THEN
           LVECT = 3*NAT
         ELSE
           LVECT = 3*NAT*NVECT
         END IF
         LDONE = 3*NAT/IRAT
C
         LCPLNGS = 2*LEIVPS + 2*LEIROP + LDFNL + LH1NL + 2*LRHOE +
     $             LDDXC + NSURF + LVECT
         IF (.NOT.TALLDOF) LCPLNGS = LCPLNGS + LDONE + NSURF
C
         CALL GIVE_SCR_CPLSUB (LCPLSUB, TAG)
         LCPLNGS = LCPLNGS + LCPLSUB + 100
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_CPLSUB (LCPLSUB, TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'cplngs.inc'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER   LCPLSUB
      CHARACTER TAG*30
C     Local variables
      INTEGER LFORCEDR, LGET_EIND, LRNLSM, LSYMVEC, LRHOOFR,
     $         LRNLSM_2D, LNL_RES, LOPT_LR, LSUMMAT, LV1OFRHO1, NSTATE
C     ==--------------------------------------------------------------==
      NSTATE = N
      IF (TCPLFD.OR..NOT.TCPLLR) THEN
         LCPLSUB = 0            ! CPLFD: same scratch space as RWFOPT
      ELSE
         CALL GIVE_SCR_FORCEDR (LFORCEDR,TAG,NSTATE,.FALSE.)
         CALL GIVE_SCR_RNLSM (LRNLSM, TAG, NSTATE, .TRUE.)
         CALL GIVE_SCR_SYMVEC (LSYMVEC, TAG)
         LCPLSUB = MAX (LFORCEDR, LRNLSM, LSYMVEC)
         CALL GIVE_SCR_RHOOFR (LRHOOFR, TAG)
         CALL GIVE_SCR_V1OFRHO1 (LV1OFRHO1,TAG)
         CALL GIVE_SCR_RNLSM_2D (LRNLSM_2D, TAG, NSTATE)
         CALL GIVE_SCR_NL_RES (LNL_RES, NSTATE, TAG)
         CALL GIVE_SCR_OPT_LR (LOPT_LR, "PHONON", TAG)
         IF (TALLDOF) THEN
            LGET_EIND = 0
         ELSE
            CALL GIVE_SCR_GET_EIND (LGET_EIND, TAG)
         END IF
         IF (TLSE) THEN
            CALL GIVE_SCR_SUMMAT (LSUMMAT, TAG, NSTATE)
         ELSE
            LSUMMAT = 0
         END IF
         LCPLSUB = MAX (LCPLSUB, LRHOOFR, LRNLSM_2D, LNL_RES, LOPT_LR,
     $                  LGET_EIND, LSUMMAT, LV1OFRHO1)
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_GET_EIND (LGET_EIND, TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'cplngs.inc'
C     Arguments and local variables
      INTEGER      LGET_EIND, LNL_RES
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_NL_RES (LNL_RES, N, TAG)
      LGET_EIND = 4*NHG + 2*NGWK*N + 100
      TAG = '4*NHG+2*NGWK*N+100+LNL_RES'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SWITCH_ST (STATE, F, NSTATE, TLSE, TLSETS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER*3 STATE
      LOGICAL TLSE, TLSETS
      INTEGER NSTATE
      REAL*8  F(NSTATE)
C     Local variables
      LOGICAL TLSE_DEF, TLSETS_DEF
      REAL*8  F_DEF(2)
      SAVE    F_DEF, TLSE_DEF, TLSETS_DEF
C     ==--------------------------------------------------------------==
      IF (STATE.EQ.'SET') THEN
         TLSE_DEF = TLSE
         TLSETS_DEF = TLSETS
         F_DEF(NSTATE-1) = F(NSTATE-1)
         F_DEF(NSTATE) = F(NSTATE)
      ELSE IF (STATE.EQ.'DEF') THEN
         TLSE = TLSE_DEF
         TLSETS = TLSETS_DEF
         F(NSTATE-1) = F_DEF(NSTATE-1)
         F(NSTATE) = F_DEF(NSTATE)
      ELSE IF (STATE.EQ.'GND') THEN
         TLSE = .FALSE.
         TLSETS = .FALSE.
         F(NSTATE-1) = 2.0D0
         F(NSTATE) = 0.0D0
      ELSE IF (STATE.EQ.'EXC') THEN
         TLSE = .TRUE.
         TLSETS = .FALSE.
         F(NSTATE-1) = 1.0D0
         F(NSTATE) = 1.0D0
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TDRHOF_DIS(FION,RHO,PSI)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'isos.inc'
C     Arguments
      REAL*8     FION(3,NAX,NSX),RHO(*)
      COMPLEX*16 PSI(*)
C     Variables
C     DIMENSION  EI1(NATX,(2*NR1S-1)),EI2(NATX,(2*NR2S-1)),
C    &           EI3(NATX,(2*NR3S-1))
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 RHETS,GX,GY,GZ,VCGS,TXX,TYY,TZZ,EI123
      REAL*8     FNL(*),DFNL(*),
     &           OMTP
      INTEGER    IG1,IG,ISA,IS,IA,IR
C     ==--------------------------------------------------------------==
      DO IR=1,NNR1
        PSI(IR)=DCMPLX(RHO(IR),0.D0)
      ENDDO
      CALL FWFFT(PSI)
C
      OMTP=2.D0*OMEGA*TPIBA
      IG1=1
      IF(GEQ0) IG1=2
      DO IG=IG1,NHG
        RHETS=DCONJG(PSI(NZH(IG)))
        GX=DCMPLX(0.D0,GK(1,IG))
        GY=DCMPLX(0.D0,GK(2,IG))
        GZ=DCMPLX(0.D0,GK(3,IG))
        VCGS=SCG(IG)*RHETS
        ISA=0
        DO IS=1,NSP
          TXX=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GX
          TYY=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GY
          TZZ=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GZ
          DO IA=1,NA(IS)
            ISA=ISA+1
            IF(BIGMEM) THEN
              EI123=EIGRB(IG,ISA)
            ELSE
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                  EI3(ISA,INYH(3,IG))
            ENDIF
            FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*TXX)*OMTP
            FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*TYY)*OMTP
            FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*TZZ)*OMTP
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CPLRDVEC (VECT, NAT, NVEC, TFDENS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'cplngs.inc'
C     Arguments
      LOGICAL TFDENS
      INTEGER NAT, NVEC
      REAL*8  VECT(3,NAT,NVEC)
C     Local variables
      CHARACTER LINE*80
      INTEGER IAT, IERR, IFIRST, INSCAN, IUNIT, IVECT, K, MSGLEN
      REAL*8  RLEN
C     ==--------------------------------------------------------------==
      IUNIT = 5
      IF (PARENT) THEN
         IERR = INSCAN (IUNIT,'&VECTORS')
         IVECT = 0
         READ (IUNIT,*,END=99) LINE
         TFDENS = (INDEX(LINE,'FIXED').NE.0)
         IFIRST = 1
         IF (TFDENS) IFIRST = 2
         DO IVECT = IFIRST,NVEC
            READ (IUNIT,*,END=99,ERR=98)
     $           ((VECT(K,IAT,IVECT), K=1,3), IAT=1,NAT)
            RLEN = 0.0D0
            DO IAT = 1,NAT
               DO K = 1,3
                  RLEN = RLEN + VECT(K,IAT,IVECT)**2
               END DO
            END DO
            RLEN = 1.0D0 / SQRT(RLEN)
            DO IAT = 1,NAT
               DO K = 1,3
                  VECT(K,IAT,IVECT) = VECT(K,IAT,IVECT)*RLEN
               END DO
            END DO
         END DO
      END IF
#ifdef PARALLEL
      MSGLEN = 8*3*NAT*NVEC
      CALL MY_BCAST (VECT, MSGLEN, SOURCE, ALLGRP)
      MSGLEN = 8/IRAT
      CALL MY_BCAST (TFDENS, MSGLEN, SOURCE, ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
 98   WRITE(6,*) 'ERROR READING RESPONSE VECTOR ', IVECT
      CALL STOPGM ('CPLRDVEC', 'ERROR IN INPUT')
 99   WRITE(6,*) 'END OF FILE REACHED READING RESPONSE VECTOR ', IVECT
      CALL STOPGM ('CPLRDVEC', 'END OF FILE')
      END
C     ==================================================================
