C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == INPUT PARAMETERS FOR NONADIABATIC COUPLINGS                  ==
C     ==--------------------------------------------------------------==
C     == TCPL     Calculate couplings between surfaces                ==
C     == TCPLFD   Use finite difference for couplings                 ==
C     == TALLAT   Do FD couplings with all atoms                      ==
C     == TCPLLR   Use linear response for analytic couplings          ==
C     == TALLDOF  Brute force instead of iterative response density   ==
C     == TSPECV   Specify vectors                                     ==
C     == NSURF    Number of KS orbital pairs for couplings            ==
C     == ISURF    KS orbital numbers (below)                          ==
C     == NATFD    Number of atoms involved in FD couplings            ==
C     == NVECT    Maximum number of vectors for iterative LR scheme   ==
C     == IATFD    Atoms involved in FD couplings                      ==
C     == EPS_C    Finite difference displacement                      ==
C     == TOLCPL   Tolerance for iterative LR scheme of couplings      ==
C     == FC_LOW   Threshold increased LR accuracy (FC_MED, FC_HIGH)   ==
C     == F_LOW    Factor for increased LR accuracy (F_MED, F_HIGH)    ==
C     ==--------------------------------------------------------------==
      LOGICAL         TCPL, TCPLFD, TALLAT, TCPLLR, TALLDOF,
     $                TSPECV
      COMMON /CPLNGL/ TCPL, TCPLFD, TALLAT, TCPLLR, TALLDOF,
     $                TSPECV
      INTEGER         NSURF, NATFD, NVECT
      COMMON /CPLNGI/ NSURF, NATFD, NVECT
      REAL*8          EPS_C, TOLCPL,
     $                FC_LOW, FC_MED, FC_HIGH, F_LOW, F_MED, F_HIGH
      COMMON /CPLNGR/ EPS_C, TOLCPL,
     $                FC_LOW, FC_MED, FC_HIGH, F_LOW, F_MED, F_HIGH
C     ==================================================================
C     == DYNAMIC ALLOCATION OF ARRAYS RELATED TO COUPLINGS            ==
C     ==--------------------------------------------------------------==
C     == ISURF    (see above, also CSURF)                             ==
C     == IATFD    (see above)                                         ==
C     == CPLION   Non-adiabatic coupling vector between KS states     ==
C     == CPLCFG   Non-adiabatic coupling vector between configs       ==
C     ==--------------------------------------------------------------==
      INTEGER         ISURF(2,NSURF), IATFD(NATFD)
      REAL*8          CSURF(NSURF), CPLION(3,NAX,NSX,NSURF),
     $                CPLCFG(3,NAX,NSX)
      POINTER         (IP_ISURF,ISURF), (IP_CSURF,CSURF),
     $                (IP_CPLION,CPLION),
     $                (IP_CPLCFG,CPLCFG), (IP_IATFD,IATFD)
      COMMON /CPLNGP/ IP_ISURF, IP_CPLION, IP_CPLCFG,
     $                IP_CSURF, IP_IATFD
C     ==================================================================
