C     ==================================================================
      PROGRAM CPMD_STUTTGART
#ifdef CRAYX1
      include 'mpif.h'
      REAL*8   rate
      integer (kind=8) :: irtc
      common/x1_time/rate
#endif

#ifdef CRAY_HPM_COUNTER_SOME
      integer*8 iunit, hpmloop, myhpm
      character*20 text_mw(100)
      common /my_hpm_hpm/ myhpm
#endif

#ifdef CRAYX1
      data rate /0.0/
      rate = 1.0 / float( irtc_rate() )
#endif

#ifdef CRAY_HPM_COUNTER_SOME
       iunit =1
       call hpm_start(iunit)
#endif

C     to get reasonable performance on the XT3
C     we need to allocate and activate larger 
C     I/O buffers for stdout and stderr. 
C     AK+STB: 10/2005
#if defined(CRAY_XT3)
       CALL USETLBUF
#endif

C try to increase stack size for the intel compilers > 8.0
C this is due to a 'feature' of the old DEC frontend, but
C should not do any harm on older compilers...
#ifdef LINUX_IFC
       CALL libc_ulimit_linux_hack
#endif

      CALL CPMD

#ifdef CRAY_HPM_COUNTER_SOME
       iunit=1
       call hpm_stop(iunit)
       text_mw(1) = 'LeftOver'
       text_mw(2) = 'S_INVFFT'
       text_mw(3) = 'VPSI    '
       text_mw(4) = 'FFT-G/S '
       text_mw(5) = 'S_FWFFT '
       text_mw(6) = 'RHOOFR  '
       text_mw(7) = 'OVLAP   '
       text_mw(8) = 'FNONLOC '
       text_mw(9) = 'RPIIINT '
       text_mw(10)= 'RGS     '
       text_mw(11)= 'OPEIGR  '
       text_mw(12)= 'ATRHO   '
       text_mw(13)= 'ODIIS   '
       text_mw(14)= 'LOADC   '
       text_mw(15)= 'EICALC  '
       do hpmloop = 1,15
         call hpm_text(hpmloop,text_mw(hpmloop))
       enddo
       if (myhpm.eq.0) call hpm_print(1_8,6_8)
#endif

      STOP  ! for F_trace option
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE CPMD
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'soft.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'poin.inc' ! AK: need to initialize IP_POTR
      INCLUDE 'pimd.inc' ! AK: for SUPERGROUP
      INCLUDE 'fileopen.inc'
      INCLUDE 'mw.inc'
      INCLUDE 'gle.inc'

#if defined(__ES)
      INCLUDE 'time.inc'
      REAL*8 TIME1
#endif
      CHARACTER DATX*26
      REAL*8    TIME1,TIMEC,WCLK1,TIMEF,TIME2,TCPU,WCLK2,TWCK
      EXTERNAL  SOFTEX,TIMEC,TIMEF
      LOGICAL   TINFO
#if defined(__HP)
      INTEGER   ICHECK
      INTEGER   SIGNAL
#endif
#ifdef CRAY_HPM_COUNTER_SOME
      integer*8 myhpm
      common /my_hpm_hpm/ myhpm
#endif
#ifdef CRAY_HPM_COUNTER_ALL
      INTEGER ISUB
#endif

C     ==--------------------------------------------------------------==
C AK: forcibly initialize pointers that are tested with PTR_ALLOCATED()
C     since not all compilers always set variables to zero.
      IP_POTR=0
C     ==--------------------------------------------------------------==
#ifndef PARALLEL
#if defined(__SGI) || defined(__alpha) || defined(__SUN) || defined(__OSX_IFC) || (defined(__Linux) && !defined(__GNU))
      CALL SIGNAL(24,SOFTEX,-1)
      CALL SIGNAL(30,SOFTEX,-1)
#elif defined(__HP)
      ICHECK=SIGNAL(24,SOFTEX,-1)
      ICHECK=SIGNAL(30,SOFTEX,-1)
#else /* !defined(CRAYX1) */
      CALL SIGNAL(30,SOFTEX)
      CALL SIGNAL(24,SOFTEX)
#endif
#else
#if defined(__Linux)
#if defined(__GNU)
      CALL SIGNAL(24,SOFTEX)
      CALL SIGNAL(30,SOFTEX)
      CALL SIGNAL(1,SOFTEX)      ! SIGHUP(1), SIGUSR1 (10) and SIGUSR(12) can also
      CALL SIGNAL(10,SOFTEX)     ! be caught. VERY useful for queuing systems...
      CALL SIGNAL(12,SOFTEX)
#else
C     Daniel.
      CALL SIGNAL(24,SOFTEX,-1)
      CALL SIGNAL(30,SOFTEX,-1)
      CALL SIGNAL(1,SOFTEX,-1)      ! SIGHUP(1), SIGUSR1 (10) and SIGUSR(12) can also 
      CALL SIGNAL(10,SOFTEX,-1)     ! be caught. VERY useful for queuing systems...
      CALL SIGNAL(12,SOFTEX,-1)
C     Daniel.
#endif
#endif
#endif
#if defined(__ES)
      CALL TISTART(TIME1)
      CALL INIT_FILEOPEN  ! initialize here to avoid Bus Error
#endif
      CALL STARTPA
#ifdef CRAY_HPM_COUNTER_SOME
        if (PARENT) then 
         myhpm=0
        else
         myhpm=1
        endif
#endif
#ifndef __ES
      CALL TISTART(TIME1)
#endif
#ifdef CRAY_HPM_COUNTER_ALL
      call TISET("  LeftOver", ISUB)
#endif
      WCLK1 = TIMEF()
      TINFO=.TRUE.
      CALL DATUM (DATX)
      IF(PARENT) THEN
        WRITE(6,'(A,A)') ' PROGRAM CPMD STARTED AT: ',DATX
      ENDIF
C     ==--------------------------------------------------------------==
#ifndef __ES
      CALL INIT_FILEOPEN  ! initialize here outside ES 
#endif
      CALL ENVIR
      CALL SETCNST
C     READ CONTROL PARAMETERS
      CALL CONTROL
C     READ INFORMATION ON XC FUNCTIONAL
      CALL DFTIN

C     READ UNIT CELL DEFINITIONS
      CALL SYSIN

C     SET UP SUPERCELL
      CALL SETSC

C     READ ATOMS, PSEUDOPOTENTIALS, COORDINATES
      CALL DETSP                ! detect number of species.
      CALL mm_init              ! set up some QM/MM stuff
                                ! also needed for non-qmmm runs, so we can 
                                ! reduce use of #if defined(__GROMOS)/#endif 
CEHR[
      IF (CMPLX_WF) THEN
       CALL READ_PROP
      ENDIF
CEHR]
      IF ( QMNODE ) THEN
C       READ ATOMIC INPUT
        CALL RATOM
C       READ VDW PARAMETERS
        CALL VDWIN
C       READ PROPERTIES
        CALL PROPIN(TINFO)

C       linear response or implicit newton raphson (docs?).
        IF (TRESPONSE.OR.TINR) CALL RESPIN_P  

C       SET UP SYSTEM
        CALL SETSYS
C       GENERATE EXCHANGE AND CORRELATION TABULATION VS. DENSITY
        CALL GENXC
C       CALCULATE NUMBER OF PW
        CALL NUMPW

        IF(TPATH) THEN
          IF(TPIMD) THEN
C           PATH INTEGRAL INPUT
            CALL PI_CNTL
            CALL PI_INIT
          ELSEIF(TPMIN) THEN
C           PATH MINIMISATION INPUT
            CALL PM_CNTL
            CALL PM_INIT
          ENDIF
        ENDIF
C       MULTIPLE WALKER METADYNAMICS INITIALIZATION
        IF(TMW)CALL MW_INIT

        IF(TRESPONSE) THEN
          CALL NMR_PARA_P
        ENDIF

C       INITIALIZE G-VECTORS AND POINTERS
        CALL RINIT
C       FORM FACTORS
        CALL RINFORCE

C       INITIALIZE FFT PARAMETERS
        CALL FFTPRP
C       CLUSTER BOUNDARY CONDITIONS 
        CALL INITCLUST
C       INITIALIZE FFT DATA FOR THE DOUBLEGRID
        CALL DG_INIT
C       NOSE ARRAYS
        CALL NOSALLOC
C       EXTERNAL POTENTIAL
        CALL EXTERP
C       SET ATOMIC BASIS (READ BASIS SECTION)
        CALL SETBASIS
C       ALLOCATE DQG ARRAY
        CALL DQGALLOC
C	PRNG
	    CALL PRNGINIT
C	GLE
	    CALL GLE_ALLOC
      ENDIF
      
      WCLK2 = TIMEF()
      TCPU  = (WCLK2 - WCLK1)*1.D-3
      IF(PARENT) THEN
        WRITE(6,'(/,A,T46,F12.2,A8,/)')
     &     ' INITIALIZATION TIME:',TCPU,' SECONDS'
      ENDIF

      IF(TPATH) THEN
        IF(TPIMD) THEN
C         ==----------------------------------------------------------==
C         ==  PATH INTEGRAL (REPLICA)                                 ==
C         ==----------------------------------------------------------==
          IF(WFOPT) THEN
C           ==--------------------------------------------------------==
C           ==  SINGLE POINT WAVEFUNCTION OPTIMIZATION                ==
C           ==--------------------------------------------------------==
            CALL PI_WF
          ELSEIF(MD) THEN
C           ==--------------------------------------------------------==
C           ==  MOLECULAR DYNAMICS                                    ==
C           ==--------------------------------------------------------==
            CALL PI_MDPT
          ENDIF
        ELSEIF(TPMIN) THEN
C         ==----------------------------------------------------------==
C         ==  PATH MINIMISATION (REPLICA)                             ==
C         ==----------------------------------------------------------==
          IF(WFOPT) THEN
C           ==--------------------------------------------------------==
C           ==  SINGLE POINT WAVEFUNCTION OPTIMIZATION                ==
C           ==--------------------------------------------------------==
            CALL PM_WF
          ELSEIF(GEOPT) THEN
C           ==--------------------------------------------------------==
C           ==  GEOMETRY OPTIMIZATION                                 ==
C           ==--------------------------------------------------------==
            CALL PM_GMOPTS
          ELSEIF(MD) THEN
C           ==--------------------------------------------------------==
C           ==  MOLECULAR DYNAMICS                                    ==
C           ==--------------------------------------------------------==
            CALL PM_MDPT
          ENDIF
        ENDIF
      ELSE
C       ==------------------------------------------------------------==
C       ==  NO REPLICA                                                ==
C       ==------------------------------------------------------------==
        IF(MD) THEN
C         ==----------------------------------------------------------==
C         ==  MOLECULAR DYNAMICS                                      ==
C         ==----------------------------------------------------------==
          IF(TPRCP) THEN
            CALL PRPT
          ELSE
            CALL MDPT
          ENDIF
        ELSEIF(GEOPT.OR.TDEBFOR) THEN
C         ==----------------------------------------------------------==
C         ==  GEOMETRY OPTIMIZATION OR FORCE DEBUGGING                ==
C         ==----------------------------------------------------------==
          CALL GMOPTS
CEHR[
        ELSEIF(TPSPEC.OR.TPDIST) THEN
C         ==----------------------------------------------------------==
C         ==  ELECTRONIC SPECTRA COMPUTED WITH TD-KS EQUATIONS        ==
C         ==  PROPAGATION OF A DENSITY PERTURBATION                   ==
C         ==----------------------------------------------------------==
          CALL WFOPTS
CEHR]
        ELSEIF(WFOPT) THEN
C         ==----------------------------------------------------------==
C         ==  SINGLE POINT WAVEFUNCTION OPTIMIZATION OR               ==
C         ==  DIAGONALIZATION OF KOHN-SHAM MATRIX                     ==
C         ==----------------------------------------------------------==
          CALL WFOPTS
        ELSEIF(TINTER) THEN
C         ==----------------------------------------------------------==
C         ==  INTERFACE TO CLASSICAL MD CODE                          ==
C         ==----------------------------------------------------------==
          CALL INTERPT
        ELSEIF(VIBRAT) THEN
C         ==----------------------------------------------------------==
C         ==  VIBRATIONAL ANALYSIS                                    ==
C         ==----------------------------------------------------------==
          CALL SECDPT
        ELSEIF(PROPER) THEN
C         ==----------------------------------------------------------==
C         ==  CALCULATE SOME PROPERTIES                               ==
C         ==----------------------------------------------------------==
          CALL PROPPT
        ELSEIF(THARD) THEN
C         ==----------------------------------------------------------==
C         ==  ORBITAL HARDNESS                                        ==
C         ==----------------------------------------------------------==
          CALL ORBHARD
        ELSEIF(TSPEC) THEN
C         ==----------------------------------------------------------==
C         ==  ELECTRONIC SPECTRA (TDDFT)                              ==
C         ==----------------------------------------------------------==
          CALL SPECPT 
        ELSEIF (TRESPONSE) THEN
C         ==----------------------------------------------------------==
C         ==  CALCULATE SOME OTHER PROPERTIES                         ==
C         ==----------------------------------------------------------==
          CALL RESPONSE_P
C         ==----------------------------------------------------------==
C         ==  TOPOLOGY UPDATE VIA FORCE MATCHING                      ==
C         ==----------------------------------------------------------==
        ELSEIF (FMATCH) THEN
          CALL PREP_FORCEMATCH
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
C     ==--------------------------------------------------------------==
C     ==  TRY SAVING FFTW wisdom, if requested                        ==
C     ==--------------------------------------------------------------==
      IF (PARENT.AND.TFFTWSDM)
     &    CALL fftw_f77_export_wisdom_to_file(FPATH(IAPATH:IEPATH)//
     &                                        'FFTW_WISDOM')
#endif
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        CALL END_SWAP
        CALL PMAXMEM
#ifdef CRAY_HPM_COUNTER_ALL
      call TIHALT("  LeftOver", ISUB)
#endif
        CALL TIPRI
        TIME2 = TIMEC()
        TCPU  = (TIME2 - TIME1)*1.D-3
        WCLK2 = TIMEF()
        TWCK  = (WCLK2 - WCLK1)*1.D-3
        CALL TTIMP(TCPU,TWCK)
        CALL DATUM (DATX)
        CALL PRMEM('      CPMD')
        WRITE(6,'(/,A,A)') ' PROGRAM CPMD ENDED AT:   ',DATX
      ENDIF
      IF(PARENT) THEN
C       Print some messages if CPU limit time exceeded of Soft Exit.
        CALL TILIMEX
!        IF(EXSOFT) THEN
!          CALL SOFTEX
!        ENDIF
      ENDIF

C     Restore original group settings for the final checks.
      IF(TQMMM) ALLGRP=QMMMGRP
      IF(TPATH.OR.TMW) ALLGRP=SUPERGROUP
      CALL MEMORY_CHECK
#ifdef PARALLEL
      CALL MY_END
#endif
C     ==--------------------------------------------------------------==
      END
C     ==================================================================
