C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     ==           DYNAMIC ALLOCATION OF PERMANENT ARRAYS             ==
C     ==================================================================
C     == TSHELS = FALSE if all TSHEL(IS) false                        ==
C     ==--------------------------------------------------------------==
      LOGICAL       TSHELS,TSHEL(MAXSP)
      COMMON/CPPSW/ TSHELS,TSHEL
C     ==================================================================
C     == INYH(3,NHG) coordinates +NHI (I=1,2,3) for G-vectors         ==
C     == IGL(NHG)    the index of the shell for each G-vector         ==
C     == NZH(NHG)    index in PSI or RHO array (IG1>=0)               ==
C     == INDZ(NHG)   index in PSI or RHO array (IG1<=0)               ==
C     == ISPTR(NHGL+1) last index IG for the shell                    ==
C     == INDZS(NGW)  index for G-compon. of wavefunction in PSI (I1<0)==
C     == NZH(NGW)    index for G-compon. of wavefunction in PSI (I1>0)==
C     ==--------------------------------------------------------------==
      INTEGER       INYH(3,NHG),IGL(NHG),NZH(NHG),INDZ(NHG),
     &              ISPTR(*),INDZS(NGW),NZHS(NGW)
      POINTER       (IP_INYH,INYH),
     &              (IP_IGL,IGL),
     &              (IP_NZH,NZH),
     &              (IP_INDZ,INDZ),
     &              (IP_ISPTR,ISPTR),
     &              (IP_INDZS,INDZS),
     &              (IP_NZHS,NZHS)
      COMMON/CPPTI/ IP_INYH,IP_IGL,IP_NZH,IP_INDZ,IP_ISPTR,IP_INDZS,
     &              IP_NZHS
C     ==================================================================
C     == HG(1:NHG) Square norm of G-vectors                           ==
C     == GK(1:3,1:NHG) Components of G-vectors                        ==
C     == GL(1:NHGL) Square norm of G-vectors for each shell           ==
C     == VPS(1:NSP,1:NHG) Local pseudopotential per species in G space==
C     == RHOPS: smeared ionic charge density in G space               ==
C     ==        ionic point charges replaced by Gaussian charge       ==
C     ==        distributions (see ener.inc) calculated in PUTPS      ==
C     == TWNL(1:NGW,1:NGH(IS),1:NSP) Non-Local projectors array       ==
C     ==        for each G-components (Kleinman-Bylander form)        ==
C     == USED BY VANDERBILT PSEUDOPOTENTIALS                          ==
C     == QRAD                                                         ==
C     == YLMB(NHGK,LPMAX,NKPNT) Initialized in PUTWNL                 ==
C     ==--------------------------------------------------------------==
      REAL*8        HG(NHG),GK(3,NHG),GL(*),
     &              VPS(NSX,NHG),RHOPS(NSX,NHG),
     &              TWNL,QRAD,TWNLS,YLMB
      POINTER       (IP_HG,HG),
     &              (IP_GK,GK),
     &              (IP_GL,GL),
     &              (IP_VPS,VPS),
     &              (IP_RHOPS,RHOPS),
     &              (IP_TWNL,TWNL),
     &              (IP_QRAD,QRAD),
     &              (IP_TWNLS,TWNLS),
     &              (IP_YLMB,YLMB)
      COMMON/CPPTR/ IP_HG,IP_GK,IP_GL,IP_VPS,IP_RHOPS,
     &              IP_TWNL,IP_TWNLS,IP_QRAD,IP_YLMB
C     ==================================================================
C     == Dimension of HGPOT (for isolated system -- HIP)              ==
C     ==--------------------------------------------------------------==
      INTEGER       NR1H,NR2H,NR3H,NR3PL
      COMMON/ISOSI/ NR1H,NR2H,NR3H,NR3PL
C     ==================================================================
      REAL*8        HGPOT(NR1S+1,NR2S+1,NR3PL),HIPZ(NHG)
      COMPLEX*16    SCG(NHG),SCGX(NHG)
      POINTER       (IP_HGPOT,HGPOT),(IP_HIPZ,HIPZ)
      POINTER       (IP_SCG,SCG),(IP_SCGX,SCGX)
      COMMON/ISOSP/ IP_HGPOT,IP_HIPZ,IP_SCG,IP_SCGX
C     ==================================================================
