C     ==================================================================
C     == FOR TKPNT=.TRUE. FNL IS COMPLEX -- CSMAT_C WILL BE WRITTEN   ==
C     ==================================================================
      SUBROUTINE CSMAT(A,C0,FNL,NSTATE,IKIND)
C     ==--------------------------------------------------------------==
C     ==         COMPUTES THE OVERLAP MATRIX A = < C0 |S| C0 >        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'nort.inc'
      INCLUDE 'nlps.inc'
C     Arguments
      INTEGER    NSTATE,IKIND
      COMPLEX*16 C0(NGW,*)
      REAL*8     A(NSTATE,*),FNL(NAT,NHXS,NSTATE,*)
C     Variables
      INTEGER    ISUB,I,J,JMAX,ISA0,IS,IV,JV,IA,ISA,NSTX
      REAL*8     SELEM,AIJ
C     ==--------------------------------------------------------------==
      CALL TISET('     CSMAT',ISUB)
      IF(TFDIST) CALL STOPGM('CSMAT','TFDIST NOT IMPLEMENTED')
      CALL OVLAP(NSTATE,A,C0,C0)
      CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
      IF(TIVAN) THEN
        DO I=NWA12(MEPOS,1),NWA12(MEPOS,2)
          JMAX=NSTATE
          IF(TLSD.AND.I.LE.NSUP) JMAX=NSUP
          DO J=I,JMAX
            ISA0=0
            AIJ=0.0D0
            DO IS=1,NSP
              IF(TVAN(IS)) THEN
                DO IV=1,NGH(IS)
                  DO JV=1,NGH(IS)
                    IF(ABS(QQ(IV,JV,IS)).GT.1.D-5) THEN
                      DO IA=1,NA(IS)
                        ISA=ISA0+IA
                        AIJ=AIJ+QQ(IV,JV,IS)*
     *                     FNL(ISA,IV,I,IKIND)*FNL(ISA,JV,J,IKIND)
                      ENDDO
                    ENDIF
                  ENDDO
                ENDDO
              ENDIF
              ISA0=ISA0+NA(IS)
            ENDDO
            A(I,J)=A(I,J)+AIJ
            IF(I.NE.J) A(J,I)=A(J,I)+AIJ
          ENDDO
        ENDDO
      ENDIF
      CALL GLOSUM(NSTATE*NSTATE,A)
      SCOND=0.0D0
      DO I=1,NSTATE
        DO J=1,NSTATE
          SELEM=ABS(A(I,J))
          IF(I.EQ.J) SELEM=ABS(A(I,J)-1.0D0)
          IF(SCOND.LT.SELEM) SCOND=SELEM
        ENDDO
      ENDDO
      CALL TIHALT('     CSMAT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
