c     ==================================================================
      subroutine d_mat_diag_loc(sder,rho0G,
     &  eirop,eirop1,v1_loc,k2) 
c     ==--------------------------------------------------------------==
c     ==                        computes                              ==
c     == the part of the dynamical matrix related to the local part   ==
c     == of the pseudopotential 
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'cnst.inc'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'sfac.inc'
C     Arguments
      real*8     sder
      complex*16 rho0G(*),eirop(*),eirop1(*),v1_loc(*)
      integer    k2
C     Variables
      complex*16 rhogs,txx,gk2
      real*8     FNL(*),DFNL(*),omtp,factor
      integer    ig1,ig
c     ==--------------------------------------------------------------==
      omtp=2.d0*omega*tpiba
      ig1=1
      if(geq0) ig1=2
      do ig=ig1,nhg
         factor = dreal(scg(ig))
         rhogs=factor * dconjg(rho0G(ig)+eirop(ig))

         gk2=dcmplx(0.d0,-gk(k2,ig))

         txx = eirop1(ig)*rhogs + v1_loc(ig)*dconjg(rho0G(ig))
         txx = txx * gk2
         sder=sder + dreal(txx)*omtp
      enddo
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
      subroutine d_mat_diag_nonloc(sder,ddfnl00,fnl00,dfnl00,
     &   f,wk,isp,k,k2,iat,nstate,nkpoint)
c     ==--------------------------------------------------------------==
c     ==                        computes                              ==
c     ==  the non-local potential contribution to the diagonal        ==
c     ==  part of the dynamical matrix                                ==
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'nlps.inc'
      include 'ions.inc'
      include 'pslo.inc'
      include 'cvan.inc'
      include 'cppt.inc'
      include 'spin.inc'
      include 'sgpp.inc'
      integer isp,k,k2,iat,nstate,nkpoint
      real*8  sder,
     &     dfnl00(imagp,nat,nhxs,3,ndfnl,nkpoint),
     &     fnl00(imagp,nat,nhxs,nstate,nkpoint),
     &     ddfnl00(imagp,nat,nhxs,3,3,ndfnl,nkpoint),
     &     weight,sum,energy_value
      real*8  F(nstate,nkpoint),WK(nkpoint)
      integer iv,jv,istate,is12,ik
      logical nonzero_overlap
c     ==--------------------------------------------------------------==
      if(tvan(isp)) then
         call stopgm('d_mat_diag_nonloc',
     &        'vanderbilt not implemented')
      elseif(tsgp(isp)) then
        do ik=1,nkpoint
          do iv=1,ngh(isp)
            do jv=1,ngh(isp)
              nonzero_overlap = (NGHtoL(iv,isp) .EQ. NGHtoL(jv,isp))
     &            .AND. (LpVal(iv,isp) .EQ. LpVal(jv,isp))
              if (nonzero_overlap) then
                sum = 0d0
                do istate = nst12(mepos,1),nst12(mepos,2)
                  is12 = istate - nst12(mepos,1)+1

                  sum  = sum + 2d0*f(istate,ik) *
     &                ( ddfnl00 (1,iat,iv,k,k2,is12,ik)
     &                * fnl00   (1,iat,jv,istate,ik)
     &                + dfnl00  (1,iat,iv,k,is12,ik)
     &                * dfnl00  (1,iat,jv,k2,is12,ik))

                enddo
                energy_value  = hlsg(LfVal(iv,isp),LfVal(jv,isp),
     &              NGHtoL(iv,isp)+1,isp)

                sder = sder + sum * energy_value
              endif             ! IF overlap between Proj[iv] and Proj[jv]
            enddo               ! jv
          enddo                 ! iv
        enddo                   ! k-points
      else                      ! BHS and related.
        do ik=1,nkpoint
          do iv=1,ngh(isp)
            do istate=nst12(mepos,1),nst12(mepos,2)
              weight=wk(ik)*f(istate,ik)*2.d0*wsg(isp,iv)
              is12=istate-nst12(mepos,1)+1
              sder=sder + weight*
     &            (ddfnl00   (1,iat,iv,k,k2,is12,ik)
     &            *   fnl00  (1,iat,iv,istate,ik)
     &            + dfnl00   (1,iat,iv,k,is12,ik)
     &            *   dfnl00 (1,iat,iv,k2,is12,ik))
            enddo
          enddo
        enddo
      endif

c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
      subroutine d_mat_nonloc(sder,fnl,dfnl,fnl00,dfnl00,
     &   f,wk,isp,k,k2,iat,nstate,nkpoint)
c     ==---------------------------------------------------------------==
c     ==                        computes                               ==
c     ==  the non-local potential contribution to the dynamical matrix ==
c     ==---------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'nlps.inc'
      include 'ions.inc'
      include 'pslo.inc'
      include 'cvan.inc'
      include 'cppt.inc'
      include 'spin.inc'
      include 'sgpp.inc'
c     arguments
      integer isp,k,k2,iat,nstate,nkpoint
      real*8  f(nstate,nkpoint),wk(nkpoint),sder
c     variables
      real*8  dfnl00(imagp,nat,nhxs,3,ndfnl,nkpoint),
     &        dfnl  (imagp,nat,nhxs,3,ndfnl,nkpoint),
     &        fnl00 (imagp,nat,nhxs,nstate,nkpoint),
     &        fnl   (imagp,nat,nhxs,nstate,nkpoint),
     &        weight,sum,energy_value
      integer iv,jv,istate,is12,ik
      logical nonzero_overlap
c     ==--------------------------------------------------------------==
      if(tvan(isp)) then
            call stopgm('d_mat_diag_nonloc',
     &           'vanderbilt not implemented')
      elseif(tsgp(isp)) then
        do ik=1,nkpoint
          do iv=1,ngh(isp)
            do jv=1,ngh(isp)
              nonzero_overlap = (NGHtoL(iv,isp) .EQ. NGHtoL(jv,isp))
     &            .AND. (LpVal(iv,isp) .EQ. LpVal(jv,isp))
              if (nonzero_overlap) then
                sum = 0d0
                do istate = nst12(mepos,1),nst12(mepos,2)
                  is12 = istate - nst12(mepos,1)+1

                  sum  = sum + 2d0*f(istate,ik) *
     &                ( dfnl00  (1,iat,iv,k2,is12,ik)
     &                * fnl     (1,iat,jv,istate,ik)
     &                + dfnl    (1,iat,iv,k2,is12,ik)
     &                * fnl00   (1,iat,jv,istate,ik))

                enddo
                energy_value  = hlsg(LfVal(iv,isp),LfVal(jv,isp),
     &              NGHtoL(iv,isp)+1,isp)
                sder = sder + sum * energy_value
              endif             ! IF overlap between Proj[iv] and Proj[jv]
            enddo               ! jv
          enddo                 ! iv
        enddo                   ! k-points
      else                      ! BHS and related.
        do ik=1,nkpoint
          do iv=1,ngh(isp)
            do istate=nst12(mepos,1),nst12(mepos,2)
              weight=wk(ik)*f(istate,ik)*2.d0*wsg(isp,iv)
              is12=istate-nst12(mepos,1)+1
              sder = sder + weight*
     &            (dfnl00    (1,iat,iv,k2,is12,ik)
     &            *   fnl    (1,iat,iv,istate,ik)
     &            + dfnl     (1,iat,iv,k2,is12,ik)
     &            *   fnl00  (1,iat,iv,istate,ik))
            enddo
          enddo
        enddo
      endif
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
      subroutine d_mat_diag_real(sder,is,ia,k,k2,tau0) 
c     ==--------------------------------------------------------------==
c     ==                        computes                              ==
c     == the residual part of the ion-ion interaction (esr)           ==
c     == due to the overlap of the smeared ionic charge densities     ==
c     == (ionic point charges replaced by gaussian charge distrib.)   ==
c     == corresponding to different atoms.                            ==
c     == esr depends only on tau0 (raggio and valence charges)        ==
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'cnst.inc'
      include 'ragg.inc'
      include 'isos.inc'
      include 'metr.inc'
      real*8  tau0(3,nax,nsp),rxlm(3),sder,derre,derre2,
     &        zv2,rckj,ylm,zlm,erre2,rlm,arg,
     &        repand,xlm,xderfcdx,derfcdx2
      integer k,j,m,k2,ia,is
      logical tzero
#ifdef __DERF
      real*8    DERFC
      external  DERFC
#endif
      if(parent) then
         do j=1,nsp
            zv2=zv(is)*zv(j)
            rckj=dsqrt(raggio(is)*raggio(is)+raggio(j)*raggio(j))
            do m=1,na(j)
               if((is.eq.j).and.(ia.eq.m)) then
                  tzero=.true.
               else
                  tzero=.false.
                  xlm=tau0(1,ia,is)-tau0(1,m,j)
                  ylm=tau0(2,ia,is)-tau0(2,m,j)
                  zlm=tau0(3,ia,is)-tau0(3,m,j)
                  call pbc(xlm,ylm,zlm,xlm,ylm,zlm,1,apbc,ibrav)
                  
               endif
               if(.not.tzero) then
                  rxlm(1)=xlm
                  rxlm(2)=ylm
                  rxlm(3)=zlm
                  erre2=rxlm(1)**2+rxlm(2)**2+rxlm(3)**2
                  rlm=dsqrt(erre2)
                  arg=rlm/rckj
                  xderfcdx=-zv2*DERFC(arg)/rlm-(2.d0*zv2/dsqrt(pi))*
     *                 dexp(-arg*arg)/rckj
                  derfcdx2=-(2.d0/erre2)*xderfcdx+
     *                 (4.d0/rckj**3)*zv2*dexp(-arg*arg)/dsqrt(pi)

                  derre=rxlm(k)
                  derre2=rxlm(k2)
                  repand=xderfcdx/erre2
                  
                  sder = sder
     *                 +repand*(-derre*derre2/erre2)
                  if(k.eq.k2)  sder = sder + repand
                  sder = sder + derfcdx2*(derre*derre2/erre2)
               endif
            enddo
         enddo
      endif
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
      subroutine d_mat_real(sder,is,ia,k,k2,is2,ia2,tau0) 
c     ==--------------------------------------------------------------==
c     ==                        computes                              ==
c     == the residual part of the ion-ion interaction (esr)           ==
c     == due to the overlap of the smeared ionic charge densities     ==
c     == (ionic point charges replaced by gaussian charge distrib.)   ==
c     == corresponding to different atoms.                            ==
c     == esr depends only on tau0 (raggio and valence charges)        ==
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'cnst.inc'
      include 'ragg.inc'
      include 'isos.inc'
      include 'metr.inc'
      real*8  tau0(3,nax,nsp),rxlm(3),sder,derre,derre2,
     &        zv2,rckj,ylm,zlm,erre2,rlm,arg,
     &        repand,xlm,xderfcdx,derfcdx2
      integer k,is2,k2,ia,is,ia2
      logical tzero
#ifdef __DERF
      real*8   DERFC
      external DERFC
#endif
      if(parent) then
         zv2=zv(is)*zv(is2)
         rckj=dsqrt(raggio(is)*raggio(is)+raggio(is2)*raggio(is2))
         if(is.eq.is2.and.ia.eq.ia2) then
            tzero=.true.
         else
            tzero=.false.
            xlm=tau0(1,ia,is)-tau0(1,ia2,is2)
            ylm=tau0(2,ia,is)-tau0(2,ia2,is2)
            zlm=tau0(3,ia,is)-tau0(3,ia2,is2)
            call pbc(xlm,ylm,zlm,xlm,ylm,zlm,1,apbc,ibrav)
         endif
         if(.not.tzero) then
            rxlm(1)=xlm
            rxlm(2)=ylm
            rxlm(3)=zlm
            erre2=rxlm(1)**2+rxlm(2)**2+rxlm(3)**2
            rlm=dsqrt(erre2)
            arg=rlm/rckj
            xderfcdx=-zv2*DERFC(arg)/rlm-(2.d0*zv2/dsqrt(pi))*
     *           dexp(-arg*arg)/rckj
            derfcdx2=-(2.d0/erre2)*xderfcdx
     *           +(4.d0/rckj**3)*zv2*dexp(-arg*arg)/dsqrt(pi)

            derre=rxlm(k)
            derre2=rxlm(k2)
            
            repand=xderfcdx/erre2
            sder = sder + repand*(derre*derre2/erre2)
            if(k.eq.k2)  sder = sder - repand 
            sder = sder - derfcdx2*(derre*derre2/erre2)
         endif
      endif
c     ==================================================================
      return
      end
c     ==================================================================
      subroutine d_mat_loc0(sder,eirop1,iat,k2,is) 
c     ==--------------------------------------------------------------==
c     ==                        computes                              ==
c     == local potential  contribution to the dynamical matrix        ==
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'cnst.inc'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'sfac.inc'
      complex*16 eirop1(nhg),vcgs,txx,ei123
      dimension  EIGRB(nhg,nat)
      real*8     FNL(*),DFNL(*)
      real*8     omtp,sder
      integer    ig1,ig,is,iat,k2
c     ==--------------------------------------------------------------==
      omtp=2.d0*omega*tpiba
      ig1=1
      if(geq0) ig1=2
      do ig=ig1,nhg
         vcgs = scg(ig) * dconjg(eirop1(ig))
         txx  = rhops(is,ig) * vcgs * DCMPLX(0.d0,-gk(k2,ig))
         if(bigmem) then
            ei123=eigrb(ig,iat)
         else
            ei123=ei1(iat,inyh(1,ig))*ei2(iat,inyh(2,ig))*
     *           ei3(iat,inyh(3,ig))
         endif
         sder = sder + DREAL( ei123*txx ) * omtp
      enddo
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
      subroutine d_mat_locps(sder,drhoe,iat,k2,is)
c     ==--------------------------------------------------------------==
c     ==                        computes                              ==
c     == local potential  contribution to the dynamical matrix        ==
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'cnst.inc'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'sfac.inc'
      complex*16 drhoe(nhg),txx,ei123
      dimension  EIGRB(nhg,nat)
      real*8     FNL(*),DFNL(*)
      real*8     omtp,sder
      integer    ig1,ig,is,iat,k2
c     ==--------------------------------------------------------------==
      omtp=2.d0*omega*tpiba
      ig1=1
      if(geq0) ig1=2
      do ig=ig1,nhg
         txx = rhops(is,ig) * scg(ig) + vps(is,ig)
         txx = txx * DCONJG(drhoe(ig)) * DCMPLX(0.d0,-gk(k2,ig))
         if(bigmem) then
            ei123=eigrb(ig,iat)
         else
            ei123=ei1(iat,inyh(1,ig))*ei2(iat,inyh(2,ig))*
     *           ei3(iat,inyh(3,ig))
         endif
         sder = sder + dreal(ei123*txx) * omtp
      enddo
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
