C In order to inline DCOPY I create this module
C The problem with inlining dcopy is that it's called with real
C and complex variables, so no inlining possible. 
C This module allows inlining without any direct code changes.
C The CRAY X1 compiler can use the -A compiler to have an
C implicit USE COPY in each routine
      MODULE MODCOPY

      INTERFACE DCOPY_X
       module procedure dcopy8, zcopy16
      END INTERFACE DCOPY_X

      CONTAINS

c----------------------------------------------------------------------
      subroutine  dcopy8(n,dx,incx,dy,incy)
!DIR$ ignore_tkr (r) dx, (r) dy
c----------------------------------------------------------------------
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dy(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
        if(incx.ne.1.or.incy.ne.1) then
c
c        code for unequal increments or equal increments
c          not equal to 1
c
           ix = 1
           iy = 1
           if(incx.lt.0)ix = (-n+1)*incx + 1
           if(incy.lt.0)iy = (-n+1)*incy + 1
           do i = 1,n
             dy(iy) = dx(ix)
             ix = ix + incx
             iy = iy + incy
           end do
         else
c
c        code for both increments equal to 1
c
            do i = 1,n
              dy(i) = dx(i)
            end do
        end if
      return
      end subroutine dcopy8

c----------------------------------------------------------------------
      subroutine  zcopy16(nn,dx,incx,dy,incy)
!DIR$ ignore_tkr (r) dx, (r) dy
c----------------------------------------------------------------------
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      complex*16 dx(*),dy(*)
      integer i,incx,incy,ix,iy,m,mp1,n, nn 
c
      n=nn/2
        if(incx.ne.1.or.incy.ne.1) then
c
c        code for unequal increments or equal increments
c          not equal to 1
c
           ix = 1
           iy = 1
           if(incx.lt.0)ix = (-n+1)*incx + 1
           if(incy.lt.0)iy = (-n+1)*incy + 1
           do i = 1,n
             dy(iy) = dx(ix)
             ix = ix + incx
             iy = iy + incy
           end do
         else
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
            do i = 1,n
              dy(i) = dx(i)
            end do
        end if
      return
      end subroutine zcopy16

      END MODULE MODCOPY

c----------------------------------------------------------------------
      subroutine  xdcopy(n,dx,incx,dy,incy)
c----------------------------------------------------------------------
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dy(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
        if(incx.ne.1.or.incy.ne.1) then
c
c        code for unequal increments or equal increments
c          not equal to 1
c
           ix = 1
           iy = 1
           if(incx.lt.0)ix = (-n+1)*incx + 1
           if(incy.lt.0)iy = (-n+1)*incy + 1
           do i = 1,n
             dy(iy) = dx(ix)
             ix = ix + incx
             iy = iy + incy
           end do
         else
c
c        code for both increments equal to 1
c
            do i = 1,n
              dy(i) = dx(i)
            end do
        end if
      return
      end subroutine xdcopy

c----------------------------------------------------------------------
      subroutine  zcopy(n,dx,incx,dy,incy)
c----------------------------------------------------------------------
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      complex*16 dx(*),dy(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
        if(incx.ne.1.or.incy.ne.1) then
c
c        code for unequal increments or equal increments
c          not equal to 1
c
           ix = 1
           iy = 1
           if(incx.lt.0)ix = (-n+1)*incx + 1
           if(incy.lt.0)iy = (-n+1)*incy + 1
           do i = 1,n
             dy(iy) = dx(ix)
             ix = ix + incx
             iy = iy + incy
           end do
         else
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
            do i = 1,n
              dy(i) = dx(i)
            end do
        end if
      return
      end subroutine zcopy


