c     ==================================================================
      Subroutine B88_x(dens,degrad,dfdn,dfdg,d2fdn2,d2fdndg,d2fdg2,LDA)
c     ==--------------------------------------------------------------==
      Implicit none
c     Arguments
      Real*8 dens,degrad,dfdn,dfdg,d2fdn2,d2fdndg,d2fdg2,LDA
c     Local variables
      Real*8 t1,t2,t3,t4,t5,t53,spp,n1,n2,n_13,n_23,n_43,n_53,n_73,n_83,
     &     n_103,f3,sgrad,x,x2,xs,xp,xsp,xss,s,ss,sp,sp3,sss,ssp,D1,D12,
     &     D13,D1s,D1p,D1pp,D1ss,D1sp,A,beta,beta6,denso,degrado
      Parameter (beta=0.0042D0)
      Parameter (A=-0.930525736349100025002010218071667D0)

c     ==--------------------------------------------------------------==
      denso=dmax1(dens,1.D-24)
      degrado=dmax1(degrad,1.D-49)

      n2=denso*denso
      n_13=denso**(1.D0/3.D0)
      n_23=n_13**2
      n_43=n_13*denso
      n_53=n_23*denso
      n_73=n_43*denso
      n_83=n_53*denso
      n_103=n_73*denso
      n1=1.D0/denso
      n_73=1.D0/n_73
      f3=4.D0/3.D0
      beta6=6.D0*beta

      sgrad=dsqrt(degrado)
      x=sgrad/n_43
      x2=x*x
      t1=dsqrt(x2+1.D0)
      t5=1.D0/t1
      t53=t5**3
      s=dlog(x+t1)
      t2=1.D0+beta6*x*s
      D1=1.D0/t2
      D12=D1*D1
      D13=D12*D1
      xs=-f3*sgrad*n_73
      xp=1.D0/n_43
      sp=1.D0/dsqrt(n_83+degrado)
      sp3=sp**3
      ss=t5*xs
      D1s=-D12*beta6*(xs*s+x*ss)
      D1p=-D12*beta6*(xp*s+x*sp)
      dfdn=-beta*sgrad*(D1*(f3*n1*x+2.D0*xs)+x*D1s)      
      dfdg=-beta*(D1*x*2.D0+n_43*x2*D1p)

      xss=28.D0/9.D0*sgrad/n_103
      t3=beta6*(xs*s+x*ss)
      sss=-t53*x*xs**2+t5*xss
      D1ss=-2.D0*D1*D1s*t3-D12*beta6*(xss*s+2.D0*xs*ss+x*sss)
      d2fdn2=-beta*sgrad*(xs*(f3*n1*D1+3.D0*D1s)+x*(-f3/n2*D1+f3*n1
     &     *D1s+D1ss)+2.D0*xss*D1)
      
      xsp=-f3*n_73
      ssp=-sp3*f3*n_53
      D1sp=-2.D0*D1*D1p*t3-D12*beta6*(xsp*s+xs*sp+xp*ss+x*ssp)
      d2fdndg=dfdn/sgrad-beta*sgrad*((xp*D1+x*D1p)*f3*n1
     &     +2.D0*xsp*D1+2.D0*xs*D1p+xp*D1s+x*D1sp)
      
      spp=-sp3*sgrad
      t4=beta6*(xp*s+x*sp)
      D1pp=-2.D0*D1*D1p*t4-D12*beta6*(2.D0*xp*sp+x*spp)
      d2fdg2=-beta*(D1p*2.D0*x+D1*2.D0*xp+n_43
     &     *(2.D0*x*xp*D1p+x2*D1pp))

      LDA=f3/3.D0*A/n_23
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
      Subroutine lyp88_c(densa,densb,grada,gradax,graday,gradaz,gradb,
     &    gradbx,gradby,gradbz,dfdga,nana,nanb,naga,granb,gagb,nagb,
     &     nagrb,ganb)
c     ==--------------------------------------------------------------==
      Implicit none
c     Arguments
      Real*8 densa,densb,grada,gradax,graday,gradaz,gradb,gradbx,gradby,
     $     gradbz,dfdga,nana,naga,nanb,granb,gagb,ganb,nagb,nagrb
c     Local variables
      Real*8 t1,t2,t3,t4,t5,t6,t7,t1s,t2s,t3s,t4s,t5s,t6s,t7s,n2,n3,n_13
     $     ,n_43,n_73,n_143,n_173,n43,n113,n143,dens,ddens,dn2,grad,dens
     $     a2,densb2,na_23,na_53,na_83,nb_23,nb_83,a,b,c,d,Cf,o9,o18,e,f
     $     3,skalar,t6ss,t7ss,t5ss,t4ss,t5sp,t12,t7sp,t7p,t2st,t5p,t3ss,
     $     n_113,t2ss,t4p,t1ss,s18,es,ess,o3,e3,tw3,t2sst,t5sst,t4st,t5p
     $     st,nb_53,D1,t5st,t7st,t4sst,t7sst,db,t5k,t5sk,t4sp,c13,d13,br
     $     ,kl,ab,t8,t91,t92,densao,densbo,gradao,gradbo,densao2,densbo2
      Parameter (a=0.04918D0)
      Parameter (b=0.132D0)
      Parameter (c=0.2533D0)
      Parameter (d=0.349D0)
      Parameter (Cf=36.462398978764777098305310076D0)
c     ==--------------------------------------------------------------==
      densao=dmax1(densa,1.D-24)
      densbo=dmax1(densb,1.D-24)      
      gradao=dmax1(grada,1.D-48)
      gradbo=dmax1(gradb,1.D-48)
      dens=densao+densbo
      skalar=gradax*gradbx+graday*gradby+gradaz*gradbz
      grad=gradao+gradbo+2*skalar
      n2=dens*dens
      n3=1.D0/n2/dens
      densao2=densao*densao
      densbo2=densbo*densbo
      o3=1.D0/3.D0
      tw3=o3+o3
      f3=tw3+tw3
      e3=1.D0+f3+f3
      o9=o3*o3
      o18=o9/2.D0
      s18=o3+o18
      n_13=dens**o3
      n_43=n_13*dens
      n_73=1.D0/n_43/dens
      n_113=n_43*n_43*dens
      n_143=n_113*dens
      n_173=n_143*dens
      n43=1.D0/n_43
      n113=1.D0/n_113
      n143=1.D0/n_143
      na_23=densao**tw3
      na_53=na_23*densao
      na_83=na_53*densao
      nb_53=densbo**(5.D0/3.D0)
      nb_83=nb_53*densbo
      c13=c/n_13
      e=exp(-c13)
      d13=d/n_13
      t1=1.D0/(1.D0+d13)
      t12=t1*t1
      ab=densao*densbo
      ddens=1.D0/dens
      t2=ab*ddens
      t3=a*b*e*t1*n113
      t7=(densao*gradao+densbo*gradbo)*ddens
      t6=c13+d13*t1
      br=o9*(t6-11.D0)
      kl=(47.D0*o18-s18*t6)
      t5=Cf*(na_83+nb_83)+kl*grad-(2.5D0-o18*t6)*(gradao+gradbo)-br*t7
      t4=ab*t5+tw3*n2*(gradao+gradbo-grad)-densao2*gradbo-densbo2*gradao
      es=c*e*o3*n43
      t1s=o3*d*t12*n43
      dn2=1.D0/n2
      t2s=densbo2*dn2
      t2st=densao2*dn2
      t3s=a*b*(t1s*e*n113+t1*es*n113-t1*e*e3*n143)
      t7s=densbo*dn2*(gradao-gradbo)
      t7st=densao*dn2*(gradbo-gradao)
      t6s=-o3*n43*(c+d*t1)+d13*t1s
      t91=-s18*grad*t6s-o9*t6s*t7+o18*t6s*(gradao+gradbo)
      t5s=Cf*8.D0*o3*na_53-br*t7s+t91
      t5st=Cf*8.D0*o3*nb_53-br*t7st+t91
      t4s=densbo*t5+ab*t5s+(f3*dens-2.D0*densao)*gradbo
     &     +f3*dens*(gradao-grad)
      t4st=densao*t5+ab*t5st+(f3*dens-2.D0*densbo)
     &     *gradao+f3*dens*(gradbo-grad)
      D1=-4.D0*a*(t1s*t2+t1*t2s)-t3s*t4-t3*t4s
      t7p=densao*ddens
      t5p=o9-o3*t6-br*t7p
      t5k=o9-o3*t6-br*densbo*ddens
      t5sp=-o3*t6s*(1+o3*t7p)-br*densbo*dn2
      t5sk=-o3*t6s*(1+o3*densbo*ddens)+br*densbo*dn2
      t4p=ab*t5p-densbo2
      t4sp=densbo*t5p+ab*t5sp
      dfdga=-t3*t4p
      naga=-t3s*t4p-t3*t4sp
      ess=c*o9*e*n_73*(c13-4.D0)
      t1ss=o3*d*(2.D0*t1*t1s*n43-f3*n_73*t12)
      t2ss=-2.D0*densbo2*n3
      t2sst=2.D0*ab*n3
      t3ss=a*b*((t1ss*e+2.D0*t1s*es+t1*ess)*n113-2.D0*e3*(t1s*e
     &     *n143+t1*es*n143-7.D0*o3*t1*e/n_173))
      t7ss=-2.D0*densbo*n3*(gradao-gradbo)
      t7sst=(densao-densbo)*n3*(gradao-gradbo)
      t6ss=4.D0*o9*n_73*(c+d*t1)-tw3*d*n43*t1s+d13*t1ss
      t92=t6ss*(o18*(gradao+gradbo)-o9*t7-s18*grad)
      t5ss=Cf*o9*40.D0*na_23-2.D0*o9*t6s*t7s-br*t7ss+t92
      t5sst=-o9*t6s/n2*(gradao-gradbo)*(densbo-densao)-br*t7sst+t92
      t4ss=2.D0*densbo*t5s+ab*t5ss-f3*(grad+0.5D0*gradbo-gradao)
      t4sst=densbo*t5st+t5+densao*t5s+ab*t5sst+f3*(-grad+gradbo+gradao)
      nana=-4.D0*a*(t1ss*t2+2.D0*t1s*t2s+t1*t2ss)-t3ss*t4
     &     -2.D0*t3s*t4s-t3*t4ss
      t5pst=-o3*t6s-densao*(o9*t6s*ddens-br*dn2)
      granb=-t3s*t4p-t3*(densao*t5p+ab*t5pst-2.D0*densbo)
      nanb=-4.D0*a*(t1ss*t2+t1s*t2st+t1s*t2s+t1*t2sst)
     &     -t3ss*t4-t3s*t4st-t3s*t4s-t3*t4sst
      gagb=-t3*(ab*2.D0*kl-f3*n2)
      ganb=2.D0*(-t3s*(ab*kl-tw3*n2)-t3*(densao*kl-ab*s18*t6s-f3*dens))
      nagrb=-t3s*(ab*t5k-densao2)-t3*(densbo*t5k+ab*t5sk-2.D0*densao)
      nagb=2.D0*(-t3s*(ab*kl-tw3*n2)-t3*(-f3*dens+densbo*kl-ab*s18*t6s))

c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
      Subroutine lyp88_c_loc(densa,densb,loca,locb)
c     ==--------------------------------------------------------------==
      Implicit none
c     Arguments
      Real*8 densa,densb,loca,locb
c     Local Variables
      Real*8 o3,d13,c13,dens,n_13,na_53,na_83,na_113,e,t1,t12,ab,ddens,
     &     t2,t3,t1s,t2s,t3s,t1ss,t2ss,t3ss,n43,dn2,es,ess,n3,n2,e3,
     &     n_73,o9,densa2,n_173,n_43,Cf,a,b,c,d,densb2,n113,
     &     nb_113,n_113,n_143,nb_83,f3,n143,t2st,t2sst,balpha,na_23
     &     ,densao,densbo,densao2,densbo2
      Parameter (a=0.04918D0)
      Parameter (b=0.132D0)
      Parameter (c=0.2533D0)
      Parameter (d=0.349D0)
      Parameter (Cf=36.462398978764777098305310076D0)
      Parameter (balpha=-0.930525736349100025002010218071667D0)
c     ==--------------------------------------------------------------==
      densao=dmax1(densa,1.D-24)
      densbo=dmax1(densb,1.D-24)      
      o3=1.D0/3.D0
      o9=o3*o3
      f3=4.D0*o3
      e3=11.D0*o3
      dens=densao+densbo
      n2=dens*dens
      n3=n2*dens
      densao2=densao*densao
      densbo2=densbo*densbo
      n_13=dens**o3
      n_43=n_13*dens
      n_73=1.D0/n_43/dens
      n_113=n_43*n_43*dens
      n_143=n_113*dens
      n_173=n_143*dens
      n43=1.D0/n_43     
      n113=1.D0/n_113
      n143=1.D0/n_143
      na_23=densao**(2.D0*o3)
      na_53=na_23*densao
      na_83=na_53*densao
      na_113=na_83*densao
      nb_83=densbo**(8.D0*o3)
      nb_113=nb_83*densbo
      c13=c/n_13
      e=exp(-c13)
      d13=d/n_13
      t1=1.D0/(1.D0+d13)
      t12=t1*t1
      ab=densao*densbo
      ddens=1.D0/dens
      t2=ab*ddens
      t3=a*b*e*t1*n113
      es=c*e*o3*n43
      t1s=o3*d*t12*n43
      dn2=1.D0/n2
      t2s=densbo2*dn2
      t2st=densao2*dn2
      t3s=a*b*(t1s*e*n113+t1*es*n113-t1*e*e3*n143)
      ess=c*o9*e*n_73*(c13-4.D0)
      t1ss=o3*d*(2.D0*t1*t1s*n43-f3*n_73*t12)
      t2ss=-2.D0*densbo2/n3
      t2sst=2.D0*ab/n3
      t3ss=a*b*((t1ss*e+2.D0*t1s*es+t1*ess)*n113-2.D0*e3*(t1s*e
     &     *n143+t1*es*n143-7.D0*o3*t1*e/n_173))

      loca=-4.D0*a*(t1ss*t2+2.D0*t1s*t2s+t1*t2ss)-Cf*t3ss*(na_113*densbo
     &     +densao*nb_113)-2.D0*Cf*t3s*(11.D0/3.D0*na_83*densbo+nb_113)
     &     -Cf*t3*88.D0/9.D0*na_53*densbo
      locb=-4.D0*a*(t1ss*t2+t1s*t2st+t1s*t2s+t1*t2sst)
     &     -Cf*t3ss*(na_113*densbo+densao*nb_113)-Cf*t3s*(na_113+nb_113
     &     +e3*(densao*nb_83+densbo*na_83))-Cf*t3*e3*(na_83+nb_83)

      loca=loca+4.D0*o9*balpha/na_23
c     ==--------------------------------------------------------------==
      Return
      END
c     ==================================================================
      Subroutine SLATER_X(dens,LDA)
c     ==--------------------------------------------------------------==
      Implicit none
c     Arguments
      Real*8 dens,LDA
c     Local Variables
      Real*8 rho,A
      Parameter (A=-0.930525736349100025002010218071667D0)
c     ==--------------------------------------------------------------==
      rho=dmax1(dens,1.D-24)
      rho=rho**(2.D0/3.D0)
      LDA=4.D0/9.D0*A/rho
c     ==--------------------------------------------------------------==
      Return
      END
c     ==================================================================
      Subroutine P86_c(densa,densb,grada,gradax,graday,gradaz,gradb,
     $     gradbx,gradby,gradbz,nana,naga,gaga,nask,gask,sk,ga,sksk,gagb
     $     ,nagb,skgb,sknb,ganb,nanb)
c     ==--------------------------------------------------------------==
      Implicit none
c     Arguments
      Real*8 densa,densb,grada,gradax,graday,gradaz,gradb,gradbx,gradby,
     $     gradbz,nana,naga,gaga,nask,gask,sk,ga,sksk,gagb,nagb,skgb,
     $     sknb,ganb,nanb
c     Local Variables
      Real*8 zeta,zetas,zetass,zp13,zm13,zp23,zm23,zp43,zm43,zp53,zm53,
     $     Z,Zs,Zsb,Zss,Zssb,rs,rs2,rs3,rsss,rss,rsq,f,fs,fsb,fss,fssb,
     $     epsp,epsf,epsps,epsfs,epspss,epsfss,t1,t12,t2,t3,t4,t5,t5s,
     $     t5sb,t6p,t6f,C,C2,Cs,Cs2,Css,d,d2,ds,dsb,dss,dssb,sgrad,Phi,
     $     e,zetas2,Phis,Phip,Phiss,Phisp,Phipp,Phisch,Phissch,Phipsch,
     $     Phischsch,n2,n_13,n_43,n_73,n_103,n_76,n_136,n_196,skalar,
     $     densao,densbo,gradao,gradbo,sgrada,sgradb,n3,zp,o3,f3,P1,P2,
     $     P3,P4,Ap,Af,Bp,Bf,Cp,Cf,Dp,Df,fakt,fakt2,fakt3,P0,P5,d3,ds2,
     $     C3,dens,grad,k,Phipb,Phippb,b1,zetassb,zetasb,B1p,B1f,B2p,B2f
     $     ,gp,gf
      Parameter (o3=1.D0/3.D0,f3=4.D0/3.D0)
      Parameter (fakt=.6203504908994000D0)
      Parameter (fakt2=.519842099789746D0)
      Parameter (fakt3=.629960524947436D0)
      Parameter (k=8.1290825D-4)
      Parameter (Ap=0.0311D0,Af=0.01555D0,Bp=-0.048D0,Bf=-0.0269D0,
     $     Cp=0.002D0,Cf=0.0007D0,Dp=-0.0116D0,Df=-.0048D0)
      Parameter (P0=0.002568D0,P1=0.023266D0,P2=7.389D-6,P3=8.723D0,
     $     P4=0.472D0,P5=7.389D-2)
      Parameter (gp=-0.1423D0,gf=-0.0843D0,B1p=1.0529D0,B1f=1.3981D0,
     $     B2p=0.3334D0,B2f=0.2611D0)
c     ==--------------------------------------------------------------==
      densao=dmax1(densa,1.D-24)
      densbo=dmax1(densb,1.D-24)      
      gradao=dmax1(grada,1.D-48)
      gradbo=dmax1(gradb,1.D-48)

      dens=densao+densbo
      n2=dens*dens
      n3=n2*dens
      n_13=dens**o3
      n_43=n_13*dens
      n_73=n_43*dens
      n_103=n_73*dens
      n_76=dsqrt(n_73)
      n_136=n_76*dens
      n_196=n_136*dens
      skalar=gradax*gradbx+graday*gradby+gradaz*gradbz
      grad=gradao+gradbo+2.D0*skalar

      zeta=(densao-densbo)/dens
      zp13=(1.D0+zeta)**o3
      zm13=(1.D0-zeta)**o3
      zp23=zp13*zp13
      zm23=zm13*zm13
      zp43=zp23*zp23
      zm43=zm23*zm23
      zp53=zp43*zp13
      zm53=zm43*zm13
      rs=fakt/n_13
      rs2=rs*rs
      rs3=rs2*rs
      rss=-o3*fakt/n_43
      rsss=4.D0/9.D0*fakt/n_73
      f=(zp43+zm43-2.D0)/fakt2
      
      if(.true.) then
c     ==------------------------------------------------------------==
c     Discerns between high- and low-density (as in subroutine LSD_PZ)
c     ==------------------------------------------------------------==
c     Low-density formula
         if(rs.ge.1.D0) then
            rsq=dsqrt(rs)      
            epsp=gp/(1.D0+B1p*rsq+B2p*rs)
            epsf=gf/(1.D0+B1f*rsq+B2f*rs)
            t6p=B1p/(2.D0*rsq)
            t6f=B1f/(2.D0*rsq)
            epsps=-epsp**2/gp*(t6p+B2p)*rss
            epsfs=-epsf**2/gf*(t6f+B2f)*rss
            epspss=-1.D0/gp*epsp*(2.D0*epsps*(t6p+B2p)*rss+epsp*(-t6p/
     $           (2.D0*rs)*rss+(t6p+B2p)*rsss))
            epsfss=-1.D0/gf*epsf*(2.D0*epsfs*(t6f+B2f)*rss+epsf*(-t6f/
     $           (2.D0*rs)*rss+(t6f+B2f)*rsss))
c     High-density formula
         else
            epsp=Ap*dlog(rs)+Bp+Cp*rs*dlog(rs)+Dp*rs
            epsf=Af*dlog(rs)+Bf+Cf*rs*dlog(rs)+Df*rs
            epsps=(Ap/rs+Cp*(dlog(rs)+1.D0)+Dp)*rss
            epsfs=(Af/rs+Cf*(dlog(rs)+1.D0)+Df)*rss
            epspss=(-Ap/rs2+Cp/rs)*rss*rss+epsps/rss*rsss
            epsfss=(-Af/rs2+Cf/rs)*rss*rss+epsfs/rss*rsss
         endif
      else
c     ==------------------------------------------------------------==
c     High-density formula only (as in subroutine GCSXP86)
c     ==------------------------------------------------------------==
            epsp=Ap*dlog(rs)+Bp+Cp*rs*dlog(rs)+Dp*rs
            epsf=Af*dlog(rs)+Bf+Cf*rs*dlog(rs)+Df*rs
            epsps=(Ap/rs+Cp*(dlog(rs)+1.D0)+Dp)*rss
            epsfs=(Af/rs+Cf*(dlog(rs)+1.D0)+Df)*rss
            epspss=(-Ap/rs2+Cp/rs)*rss*rss+epsps/rss*rsss
            epsfss=(-Af/rs2+Cf/rs)*rss*rss+epsfs/rss*rsss
      endif
      Z=epsp+f*(epsf-epsp)
      t1=1.D0+P3*rs+P4*rs2+P5*rs3
      t12=t1*t1
      t2=P0+P1*rs+P2*rs2
      C=0.001667D0+t2/t1
      C2=C*C
      C3=C2*C
      d=2.D0*fakt3*dsqrt(0.5D0*fakt3*(zp53+zm53))
      d2=d*d
      d3=d2*d
      sgrada=dsqrt(gradao)
      sgradb=dsqrt(gradbo)
      sgrad=dsqrt(grad)
      Phi=k*sgrad/n_76/C
      e=exp(-Phi)

      zetas=2.D0*densbo/n2
      zetas2=zetas*zetas
      zetasb=-zetas*densao/densbo

      fs=f3*zetas*(zp13-zm13)/fakt2
      fsb=-fs*densao/densbo
      Zs=epsps+fs*(epsf-epsp)+f*(epsfs-epsps)
      Zsb=epsps+fsb*(epsf-epsp)+f*(epsfs-epsps)
      Cs=(P1+2.D0*P2*rs)/t1-t2*(P3+2.D0*P4*rs+3*P5*rs2)
     $     /t12
      Cs=Cs*rss
      Cs2=Cs*Cs
      ds=1.D0/(d*2.D0)*5.D0/6.D0*zetas*(zp23-zm23)
      ds2=ds*ds

      dsb=-ds*densao/densbo
      Phis=-k*sgrad*(7.D0/6.D0/(C*n_136)+Cs/(C2*n_76))
      
      Phip=k/(n_76*C*sgrad)*sgrada
      Phipb=k/(n_76*C*sgrad)*sgradb
      t4=e*(-Phip*grad+2.D0*sgrada)
      ga=C/d/n_43*t4

      zetass=-4.D0*densbo/n3
      zetassb=2.D0*(densao-densbo)/n3

      fss=f3/fakt2*(o3/zp23*zetas2+zp13*zetass+o3/zm23*zetas2-
     $     zm13*zetass)
      fssb=f3/fakt2*(zetassb*(zp13-zm13)+o3*zetas*zetasb*
     $     (1.D0/zp23+1.D0/zm23))

      Zss=epspss+fss*(epsf-epsp)+2.D0*fs*(epsfs-epsps)+f*(epsfss-epspss)
      t3=P3+2.D0*P4*rs+3.D0*P5*rs2
      Zssb=epspss+fssb*(epsf-epsp)+fs*(epsfs-epsps)*(1.D0-densao/densbo)
     $     +f*(epsfss-epspss)
      Css=(2*P2/t1-(2.D0*(P1+2.D0*P2*rs)*t3+t2*(2.D0*P4+6.D0*P5*rs))
     $     /t12+1/(t12*t1)*2.D0*t2*t3*t3)*rss*rss+Cs/rss*rsss
      dss=-ds**2/d+0.5D0/(fakt3*d)*5.D0/3.D0*(2.D0*fakt3*o3/2.D0*
     $     zetas**2*(1.D0/zp13+1.D0/zm13)+fakt3*(zp23-zm23)*zetass/2.D0)
      dssb=5.D0/12.D0*(zetas/d*(zp23-zm23)*(-dsb/d+zetassb/zetas)+
     $     zetas/d*2.D0*o3*zetasb*(1.D0/zp13+1.D0/zm13))
      Phiss=k*sgrad*(91.D0/36.D0/n_196/C+7.D0*o3/n_136/C2*Cs+
     $     2.D0/C3*Cs2/n_76-Css/C2/n_76)
      t5=1.D0/d*(-Phis*C+Cs-C*(ds/d+f3/dens))
      t5s=-ds/d2*(-Phis*C+Cs-C/d*ds-f3*C/dens)+(-Phiss*C-Phis*Cs+Css-Cs*
     $     (ds/d+f3/dens)-C*(-ds2/d2+dss/d-f3/n2))/d
      nana=2.D0*Zs+dens*Zss+grad*e*(-Phis/n_43*t5-f3/n_73*t5+t5s/n_43)
      t5sb=-dsb/d2*(-Phis*C+Cs-C/d*ds-f3*C/dens)+(-Phiss*C-Phis*Cs+Css-
     $     Cs*(ds/d+f3/dens)-C*(-ds*dsb/d2+dssb/d-f3/n2))/d

      nanb=Zsb+Zs+dens*Zssb+grad*e*(-Phis/n_43*t5-f3/n_73*t5+t5sb/n_43)

      Phisp=k*(-7.D0/6.D0/n_136/C-Cs/C2/n_76)/sgrad*sgrada
      naga=1.D0/(n_43*d)*(Cs*t4+C*e*(Phis*Phip*grad-Phisp*grad-
     $     Phis*2.D0*sgrada))+C*t4*(-f3/n_73/d-ds/d2/n_43)

      ganb=1.D0/(n_43*d)*(Cs*t4+C*e*(Phis*Phip*grad-Phisp*grad-
     $     Phis*2.D0*sgrada))+C*t4*(-f3/n_73/d-dsb/d2/n_43)

      nagb=naga*sgradb/sgrada

      Phipp=k/(n_76*C)*(1.D0/sgrad-sgrada**2/(grad*sgrad))
      gaga=C/(n_43*d)*e*((Phip**2-Phipp)*grad-Phip*2.D0*sgrada+2.D0-
     $     2.D0*sgrada*Phip)

      Phippb=k/(n_76*C)*(-sgrada*sgradb/(grad*sgrad))
      gagb=C/(n_43*d)*e*((Phipb*Phip-Phippb)*grad-Phip*2.D0*sgradb
     $     -Phipb*2.D0*sgrada)

      Phisch=k/(C*n_76*sgrad)
      sk=ga/sgrada

      Phissch=k*(-7.D0/6.D0/n_136/C-Cs/C2/n_76)/sgrad
      nask=nagb/sgradb

      sknb=1.D0/(n_43*d)*e*(-Phisch*grad+2.D0)*(Cs-f3*C/dens-C/d*dsb
     $     -C*Phis)-C/(n_43*d)*e*Phissch*grad

      Phischsch=-k/(n_76*C)/(grad*sgrad)
      sksk=C/(n_43*d)*e*(Phisch**2*grad-Phischsch*grad-4.D0*Phisch)

      gask=gagb/sgradb

      skgb=sksk*sgradb
c     ==--------------------------------------------------------------==
      Return
      End
c     ==================================================================
      Subroutine P86_c_loc(densa,densb,p86a,p86b)
c     ==================================================================
      Implicit none
c     Arguments
      Real*8 densa,densb,p86a,p86b
c     Local Variables
      Real*8 f,fs,fsb,fss,fssb,Zs,Zsb,Zss,Zssb,dens,zeta,zetas,zetas2,
     $     zetasb,zetass,zetassb,fakt2,densao,densbo,epsf,epsp,epsfs,
     $     epsps,epsfss,epspss,o3,Ap,Af,Bp,Bf,Cp,Cf,Dp,Df,P0,P1,P2,P3,P4
     $     ,P5,gp,gf,B1p,B1f,B2p,B2f,rs,rs2,rss,rsss,zm13,zp13,zm23,zp23
     $     ,n_13,n_43,n_73,n2,n3,fakt,f3,zp43,zm43,rsq,t6p,t6f
      Parameter (o3=1.D0/3.D0,f3=4.D0/3.D0)
      Parameter (fakt=.6203504908994000D0)
      Parameter (fakt2=.519842099789746D0)
      Parameter (Ap=0.0311D0,Af=0.01555D0,Bp=-0.048D0,Bf=-0.0269D0,
     $     Cp=0.002D0,Cf=0.0007D0,Dp=-0.0116D0,Df=-.0048D0)
      Parameter (P0=0.002568D0,P1=0.023266D0,P2=7.389D-6,P3=8.723D0,
     $     P4=0.472D0,P5=7.389D-2)
      Parameter (gp=-0.1423D0,gf=-0.0843D0,B1p=1.0529D0,B1f=1.3981D0,
     $     B2p=0.3334D0,B2f=0.2611D0)
c     ==--------------------------------------------------------------==
      densao=dmax1(densa,1.D-24)
      densbo=dmax1(densb,1.D-24)      
      dens=densao+densbo
      n2=dens*dens
      n3=n2*dens
      n_13=dens**o3
      n_43=n_13*dens
      n_73=n_43*dens
      rs=fakt/n_13
      rs2=rs*rs
      rss=-o3*fakt/n_43
      rsss=4.D0/9.D0*fakt/n_73
      zeta=(densao-densbo)/dens
      zetas=2.D0*densbo/n2
      zetas2=zetas*zetas
      zetasb=-zetas*densao/densbo
      zp13=(1.D0+zeta)**o3
      zm13=(1.D0-zeta)**o3
      zp23=zp13*zp13
      zm23=zm13*zm13
      zp43=zp23*zp23
      zm43=zm23*zm23
      f=(zp43+zm43-2.D0)/fakt2
      fs=f3*zetas*(zp13-zm13)/fakt2
      fsb=-fs*densao/densbo
      rsq=dsqrt(rs)      
      epsp=gp/(1.D0+B1p*rsq+B2p*rs)
      epsf=gf/(1.D0+B1f*rsq+B2f*rs)
      t6p=B1p/(2.D0*rsq)
      t6f=B1f/(2.D0*rsq)
      epsps=-epsp**2/gp*(t6p+B2p)*rss
      epsfs=-epsf**2/gf*(t6f+B2f)*rss
      epspss=-1.D0/gp*epsp*(2.D0*epsps*(t6p+B2p)*rss+epsp*(-t6p/
     $     (2.D0*rs)*rss+(t6p+B2p)*rsss))
      epsfss=-1.D0/gf*epsf*(2.D0*epsfs*(t6f+B2f)*rss+epsf*(-t6f/
     $     (2.D0*rs)*rss+(t6f+B2f)*rsss))

      Zs=epsps+fs*(epsf-epsp)+f*(epsfs-epsps)
      Zsb=epsps+fsb*(epsf-epsp)+f*(epsfs-epsps)

      zetass=-4.D0*densbo/n3
      zetassb=2.D0*(densao-densbo)/n3

      fss=f3/fakt2*(o3/zp23*zetas2+zp13*zetass+o3/zm23*zetas2-
     $     zm13*zetass)
      fssb=f3/fakt2*(zetassb*(zp13-zm13)+o3*zetas*zetasb*
     $     (1.D0/zp23+1.D0/zm23))

      Zss=epspss+fss*(epsf-epsp)+2.D0*fs*(epsfs-epsps)+f*(epsfss-epspss)
      Zssb=epspss+fssb*(epsf-epsp)+fs*(epsfs-epsps)*(1.D0-densao/densbo)
     $     +f*(epsfss-epspss)

      p86a=2.D0*Zs+dens*Zss
      p86b=Zsb+Zs+dens*Zssb
c     ==--------------------------------------------------------------==
      Return
      End
c     ==================================================================
      Subroutine pbe96_c(densa,densb,grada,gradax,graday,gradaz,gradb,
     $     gradbx,gradby,gradbz,nana,naga,gaga,nask,gask,sk,ga,sksk,gagb
     $     ,nagb,skgb,sknb,ganb,nanb)
c     ==================================================================
      Implicit none
c     Arguments
      Real*8 densa,densb,grada,gradax,graday,gradaz,gradb,gradbx,gradby,
     $     gradbz,nana,naga,gaga,nask,gask,sk,ga,sksk,gagb,nagb,skgb,
     $     sknb,ganb,nanb
c     Local variables
      Real*8 sgrad,o3,n_13,n_43,n_73,n_23,n_103,dens,T1,T2,T3,U1,U2
     $     ,U3,V1,V2,V3,W1,W2,W3,X1,X2,X3,Y1,Y2,Y3,Kaa,epsa,epsaa,omea,
     $     zeta,zeta3,zeta4,o,rs,rs2,rs3,rsa,rsaa,fakt,rs12,f1,f12,g1,
     $     f2,f22,g2,f3,f32,g3,f1a,f2a,f3a,e1a,e2a,e3a,c,na_13,nb_13,e1,
     $     e3,skalar,ome,zetaa,t,tt,kl1,kl2,kl1a,kl2a,omeaa,zetaaa,
     $     n2,n3,e1aa,e2aa,e3aa,omeb,zeta2,zetab,f1aa,f2aa,f3aa,kab,
     $     epsab,na_23,epsb,ttb,kl1b,kl2b,zetaab,omeab,nb_23,e2,zm13

      Real*8 zp13,zm23,zp23,zm53,zp53,u,ua,La,Ja,Jaa,Laa,B,Ba,iota,
     $     zm43,zp43,eps,d4,A2,A,d2,uh2,uh3,Xi,phi,Lg,Y,Z,d,n_76,k1,L,
     $     ne1,Aa,d3,ne12,ex,da,uh4,n_136,J,ex2,Phig,ne2,phia,ne22,ex2a,
     $     uaa,ze1,ze1a,ne1a,ne1aa,ze1aa,Aaa,Baa,daa,n_196,exa,exaa,uh5,
     $     B2,ze2,ze2a,ze2aa,ne2a,ne2aa,phiaa,ex2aa,uab,dab,ub,Aab,exb,
     $     exab,Bab,ze1b,ze1ab,ne1b,ne1ab,Ab,db,Lab,Bb,Jab,ex2b,ex2ab,Jb
     $     ,Lb,Lga,Bga,Jga,lambda,ex2ga,k2,k3,ny,k4,ze1ga,ne1ga,Lgaga,
     $     Jgaga,Bgaga,ne1gaga,ze1gaga,grad2,Lnaga,Jnaga,Bnaga,Bganb,
     $     ze1naga,ne1naga,ze1ganb,ne1ganb,Lganb,Jganb,grad,ex2naga,
     $     ex2ganb,gradao,gradbo,densao,densbo

      Parameter (c=1.709921D0, T1=0.031091D0, T2=0.015545D0,
     $     T3=0.016887D0, U1=0.2137D0, U2=0.20548D0, U3=0.11125D0,
     $     V1=7.5957D0, V2=14.1189D0, V3=10.357D0, W1=3.5876D0,
     $     W2=6.1977D0, W3=3.6231D0, X1=1.6382D0, X2=3.3662D0,
     $     X3=0.88026D0, Y1=0.49294D0, Y2=0.62517D0, Y3=0.49671D0,
     $     o=6.46309613581743018602522D0,fakt=.6203504908994000D0,
     $     o3=0.3333333333333333333333D0,k2=.031090690869654895D0)
      Parameter (lambda=.06672455060314922D0, Z=-0.001667D0,
     $     Xi=23.266D0, Phig=0.007389D0, Lg=8.723D0, Y=0.472D0,
     $     iota=.071599657785951923081D0,k1=1.0077158813689795508D0,
     $     k3=-41.156312099041145348D0,ny=15.755501913376439197D0,
     $     k4=2.1461263399673646085D0)
c     ==--------------------------------------------------------------==
      densao=dmax1(densa,1.D-24)
      densbo=dmax1(densb,1.D-24)      
      gradao=dmax1(grada,1.D-48)
      gradbo=dmax1(gradb,1.D-48)

      dens=densao+densbo
      n2=dens*dens
      n3=n2*dens
      n_13=dens**o3
      n_43=n_13*dens
      n_73=n_43*dens
      n_76=dsqrt(n_73)
      n_136=n_76*dens
      n_196=n_136*dens
      n_103=n_73*dens
      na_13=densao**o3
      na_23=na_13*na_13
      nb_13=densbo**o3
      nb_23=nb_13*nb_13
      skalar=gradax*gradbx+graday*gradby+gradaz*gradbz
      grad=gradao+gradbo+2.D0*skalar
      grad2=grad*grad
      sgrad=dsqrt(grad)

      rs=fakt/n_13
      rs2=rs*rs
      rs3=rs2*rs
      rs12=dsqrt(rs)
      rsa=-o3*fakt/n_43
      rsaa=4.D0/9.D0*fakt/n_73
      zeta=(densao-densbo)/dens
      zeta2=zeta*zeta
      zeta3=zeta2*zeta
      zeta4=zeta3*zeta
      zetaa=2.D0*densbo/n2
      zp13=(1.D0+zeta)**o3
      zm13=(1.D0-zeta)**o3
      zp23=zp13*zp13
      zm23=zm13*zm13
      zp43=zp23*zp23
      zm43=zm23*zm23
      zp53=zp43*zp13
      zm53=zm43*zm13
      ome=(zp43+zm43-2.D0)/(2.D0**(4.D0/3.D0)-2.D0)
      omea=o*densbo*(na_13-nb_13)/n_73

      f1=2.D0*T1*(V1*rs12+W1*rs+X1*rs*rs12+Y1*rs2)
      f12=f1*f1
      g1=1.D0+1.D0/f1
      f1a=2.D0*T1*(0.5D0*V1/rs12+W1+3.D0/2.D0*X1*rs12+2.D0*Y1*rs)*rsa
      e1=-2.D0*T1*(1.D0+U1*rs)*dlog(g1)
      e1a=-2.D0*T1*(U1*rsa*dlog(g1)-(1.D0+U1*rs)/g1/f12*f1a)

      f2=2.D0*T2*(V2*rs12+W2*rs+X2*rs*rs12+Y2*rs2)
      f22=f2*f2
      g2=(f2+1.D0)/f2
      f2a=2.D0*T2*(0.5D0*V2/rs12+W2+3.D0/2.D0*X2*rs12+2.D0*Y2*rs)*rsa
      e2=-2.D0*T2*(1.D0+U2*rs)*dlog(g2)
      e2a=-2.D0*T2*(U2*rsa*dlog(g2)-(1.D0+U2*rs)/g2/f22*f2a)

      f3=2.D0*T3*(V3*rs12+W3*rs+X3*rs*rs12+Y3*rs2)
      f32=f3*f3
      g3=(f3+1.D0)/f3
      f3a=2.D0*T3*(0.5D0*V3/rs12+W3+3.D0/2.D0*X3*rs12+2.D0*Y3*rs)*rsa
      e3=-2.D0*T3*(1.D0+U3*rs)*dlog(g3)
      e3a=-2.D0*T3*(U3*rsa*dlog(g3)-(1.D0+U3*rs)/g3/f32*f3a)

      zetaaa=-4.D0*densbo/n3
      zetaab=2.D0*zeta/n2
      omeaa=o*densbo*(o3/na_23/n_73-(na_13-nb_13)*7.D0/3.D0/n_103)
      omeab=o*((na_13-nb_13)/n_73+densbo*(-o3/nb_23/n_73-(na_13-nb_13)
     $     *7.D0/3.D0/n_103))
      t=(1.D0-zeta4)/c
      tt=4.D0*zeta3*zetaa

      eps=e1-e3*ome*t+(e2-e1)*ome*zeta4

      kl1=omea*t-ome*tt/c
      kl2=omea*zeta4+ome*tt

      epsa=e1a-e3a*ome*t-e3*kl1+(e2a-e1a)*ome*zeta4+(e2-e1)*kl2
      
      f1aa=2.D0*T1*((-1.D0/4.D0*V1/rs/rs12+3.D0/4.D0*X1/rs12+2.D0*Y1)
     $     *rsa**2+f1a/(2.D0*T1*rsa)*rsaa)
      e1aa=-2.D0*T1*(U1*rsaa*dlog(g1)-2.D0*U1*rsa/g1/f12*f1a-(1.D0+U1*rs
     $     )*((f1a/f12/g1)**2+1.D0/g1*(-2.D0/f1/f12*f1a**2+f1aa/f12)))

      f2aa=2.D0*T2*((-1.D0/4.D0*V2/rs/rs12+3.D0/4.D0*X2/rs12+2.D0*Y2)
     $     *rsa**2+f2a/(2.D0*T2*rsa)*rsaa)
      e2aa=-2.D0*T2*(U2*rsaa*dlog(g2)-2.D0*U2*rsa/g2/f22*f2a-(1.D0+U2*rs
     $     )*((f2a/f22/g2)**2+(-2.D0/g2/f2/f22*f2a**2+f2aa/g2/f22)))

      f3aa=2.D0*T3*((-1.D0/4.D0*V3/rs/rs12+3.D0/4.D0*X3/rs12+2.D0*Y3)
     $     *rsa**2+f3a/(2.D0*T3*rsa)*rsaa)
      e3aa=-2.D0*T3*(U3*rsaa*dlog(g3)-2.D0*U3*rsa/g3/f32*f3a-(1.D0+U3*rs
     $     )*((f3a/f32/g3)**2+(-2.D0/g3/f3/f32*f3a**2+f3aa/g3/f32)))

      kl1a=omeaa*t-2.D0*omea*tt/c-ome/c*(12.D0*zeta2*zetaa**2+4.D0*zeta3
     $     *zetaaa)
      kl2a=omeaa*zeta4+2.D0*omea*tt+ome*(12.D0*zeta2*zetaa**2+4.D0*zeta3
     $     *zetaaa)
      epsaa=e1aa-e3aa*ome*t-e3a*(omea*t-ome*tt/c)-e3a*kl1
     $     -e3*kl1a+(e2aa-e1aa)*ome*zeta4+(e2a-e1a)*(omea*zeta4+ome*tt)
     $     +(e2a-e1a)*kl2+(e2-e1)*kl2a

      nana=2.D0*epsa+dens*epsaa

      zetab=-densao/densbo*zetaa
      omeb=-densao/densbo*omea
      epsb=e1a-e3a*ome*(1-zeta4)/c-e3*(omeb*(1-zeta4)/c-ome*4.D0*zeta3*
     $     zetab/c)+(e2a-e1a)*ome*zeta4+(e2-e1)*
     $     (omeb*zeta4+ome*4.D0*zeta3*zetab)

      ttb=4.D0*zeta3*zetab
      kl1b=omeab*t-omea*ttb/c-omeb*tt/c-ome/c*(12.D0*zeta2*zetaa*zetab+
     $     4.D0*zeta3*zetaab)
      kl2b=omeab*zeta4+omea*ttb+omeb*tt+ome*(12.D0*zeta2*zetaa*zetab+
     $     4.D0*zeta3*zetaab)
      epsab=e1aa-e3aa*ome*t-e3a*(omeb*t-ome*ttb/c)-e3a*kl1
     $     -e3*kl1b+(e2aa-e1aa)*ome*zeta4+(e2a-e1a)*(omeb*zeta4+ome*ttb)
     $     +(e2a-e1a)*kl2+(e2-e1)*kl2b

      nanb=epsa+epsb+dens*epsab

c     -----------------------------------
c     non local part
c     -----------------------------------

      u=0.5D0*(zp23+zm23)
      uh2=u*u
      uh3=uh2*u
      uh4=uh3*u
      uh5=uh3*uh2
      ua=(o3/zp13-o3/zm13)*zetaa
      ub=(o3/zp13-o3/zm13)*zetab
      d=sgrad/(4.D0*u)*k1/n_76
      d2=d*d
      d3=d2*d
      d4=d2*d2
      da=sgrad/4.D0*k1*(-1.D0/uh2*ua/n_76-7.D0/6.D0/u/n_136)
      db=sgrad/4.D0*k1*(-1.D0/uh2*ub/n_76-7.D0/6.D0/u/n_136)

      ex=exp(-2.D0*iota*eps/uh3/lambda**2)
      exa=-1.D0/k2*(epsa/uh3-eps*3.D0*ua/uh4)
      exb=-1.D0/k2*(epsb/uh3-eps*3.D0*ub/uh4)
      A=k4/(ex-1.D0)
      A2=A*A
      Aa=-k4*1.D0/(ex-1.D0)**2*ex*exa
      Ab=-k4*1.D0/(ex-1.D0)**2*ex*exb

      ze1=d2+A*d4
      ze1a=2.D0*d*da+Aa*d4+A*4.D0*d3*da
      ze1b=2.D0*d*db+Ab*d4+A*4.D0*d3*db
      ne1=1.D0+A*d2+A2*d4
      ne1a=Aa*d2+A*2.D0*d*da+2.D0*A*Aa*d4+A2*4.D0*d3*da
      ne1b=Ab*d2+A*2.D0*d*db+2.D0*A*Ab*d4+A2*4.D0*d3*db
      ne12=ne1*ne1
      B=1.D0+k4*ze1/ne1
      B2=B*B
      Ba=k4*(ze1a/ne1-ze1*ne1a/ne12)
      Bb=k4*(ze1b/ne1-ze1*ne1b/ne12)

      L=uh3*k2*dlog(B)
      La=k2*(3.D0*uh2*ua*dlog(B)+uh3/B*Ba)
      Lb=k2*(3.D0*uh2*ub*dlog(B)+uh3/B*Bb)

      uaa=zetaaa*ua/zetaa+0.5D0*zetaa**2*
     $     (-2.D0/9.D0/zp43-2.D0/9.D0/zm43)
      uab=zetaab*ua/zetaa+0.5D0*zetaa*zetab*
     $     (-2.D0/9.D0/zp43-2.D0/9.D0/zm43)

      daa=sgrad/4.D0*k1*(2.D0/uh3*ua**2/n_76-1.D0/uh2*(uaa/n_76-
     $     7.D0/6.D0*ua/n_136)-7.D0/6.D0*(-1.D0/uh2*ua/n_136-13.D0/
     $     6.D0/u/n_196))
      dab=sgrad/4.D0*k1*(2.D0/uh3*ua*ub/n_76-1.D0/uh2*(uab/n_76-
     $     7.D0/6.D0*ua/n_136)-7.D0/6.D0*(-1.D0/uh2*ub/n_136-13.D0/
     $     6.D0/u/n_196))

      exaa=-1.D0/k2*(epsaa/uh3-epsa*6.D0*ua/uh4-
     $     3.D0*eps*(uaa/uh4-ua**2*4.D0/uh5))
      exab=-1.D0/k2*(epsab/uh3-epsa*3.D0*ub/uh4-
     $     epsb*3.D0*ua/uh4-3.D0*eps*(uab/uh4-ua*ub*4.D0/uh5))

      Aaa=-k4*(-2.D0/(ex-1.D0)**3*ex**2*exa**2+
     $     1.D0/(ex-1.D0)**2*(ex*exa**2+ex*exaa))
      Aab=-k4*(-2.D0/(ex-1.D0)**3*ex**2*exa*exb+
     $     1.D0/(ex-1.D0)**2*(ex*exa*exb+ex*exab))

      ze1aa=2.D0*(da**2+d*daa)+Aaa*d4+Aa*8.D0*d3*da+
     $     4.D0*A*(3.D0*d2*da**2+d3*daa)

      ze1ab=2.D0*(db*da+d*dab)+Aab*d4+Aa*4.D0*d3*db+4.D0*Ab*d3*da+
     $     4.D0*A*(3.D0*d2*db*da+d3*dab)

      ne1aa=Aaa*d2+Aa*2.D0*d*da+2.D0*Aa*d*da+2.D0*A*(da**2+d*daa)+
     $     2.D0*Aa*Aa*d4+2.D0*A*(Aaa*d4+Aa*4.D0*d3*da)
     $     +8.D0*A*Aa*d3*da+4.D0*A2*(3.D0*d2*da**2+d3*daa)

      ne1ab=Aab*d2+Aa*2.D0*d*db+2.D0*Ab*d*da+2.D0*A*(db*da+d*dab)+
     $     2.D0*Ab*Aa*d4+2.D0*A*(Aab*d4+Aa*4.D0*d3*db)
     $     +8.D0*A*Ab*d3*da+4.D0*A2*(3.D0*d2*db*da+d3*dab)

      Baa=k4*(ze1aa/ne1-ze1a*ne1a/ne12-(ze1a*ne1a+ze1*
     $     ne1aa)/ne12+ze1*ne1a**2*2.D0*ne1/ne12/ne12)

      Bab=k4*(ze1ab/ne1-ze1a*ne1b/ne12-(ze1b*ne1a+ze1*
     $     ne1ab)/ne12+ze1*ne1a*ne1b*2.D0*ne1/ne12/ne12)

      Laa=k2*(6.D0*uh2*ua/B*Ba+dlog(B)*(6.D0*u*ua**2+
     $     3.D0*uh2*uaa)+uh3*(-Ba**2/B2+Baa/B))

      Lab=k2*(3.D0*uh2*ua/B*Bb+dlog(B)*(6.D0*u*ub*ua+
     $     3.D0*uh2*uab)+3.D0*uh2*ub/B*Ba+uh3*(-Ba/B2*Bb+Bab/B))

      ze1ga=(d2+A*2.D0*d4)/grad

      ne1ga=(A*d2+A2*2.D0*d4)/grad
      Bga=k4*(ze1ga/ne1-ze1*ne1ga/ne12)


      Lga=k2*uh3*Bga/B
      
      ze1gaga=A*2.D0*d4/grad2
      ne1gaga=A2*2.D0*d4/grad2

      Bgaga=k4*(ze1gaga/ne1-ze1ga*ne1ga/ne12-(ze1ga*ne1ga+ze1*
     $     ne1gaga)/ne12+ze1*ne1ga**2*2.D0*ne1/ne12/ne12)

      Lgaga=k2*uh3*(-Bga**2/B2+Bgaga/B)
      
      ze1naga=(2.D0*d*da+Aa*2.D0*d4+8.D0*A*d3*da)/grad
      ze1ganb=(2.D0*d*db+Ab*2.D0*d4+8.D0*A*d3*db)/grad      
      ne1naga=(Aa*d2+A*2.D0*d*da+4.D0*A*Aa*d4+8.D0*A2*d3*da)/grad
      ne1ganb=(Ab*d2+A*2.D0*d*db+4.D0*A*Ab*d4+8.D0*A2*d3*db)/grad

      Bnaga=k4*(ze1naga/ne1-ze1ga*ne1a/ne12-(ze1a*ne1ga+ze1*
     $     ne1naga)/ne12+ze1*ne1ga*ne1a*2.D0*ne1/ne12/ne12)
      Bganb=k4*(ze1ganb/ne1-ze1ga*ne1b/ne12-(ze1b*ne1ga+ze1*
     $     ne1ganb)/ne12+ze1*ne1ga*ne1b*2.D0*ne1/ne12/ne12)

      Lnaga=k2*(3.D0*uh2*ua*Bga/B+uh3*(-Bga/B2*Ba+Bnaga/B))
      Lganb=k2*(3.D0*uh2*ub*Bga/B+uh3*(-Bga/B2*Bb+Bganb/B))

      Ja=0.D0
      Jaa=Ja
      Jab=Ja
      Jga=Ja
      Jnaga=Ja
      Jganb=Ja
      Jgaga=Ja
      Jb=Ja

      nana=nana+2.D0*(La+Ja)+dens*(Laa+Jaa)
      nanb=nanb+Lb+Jb+Ja+La+dens*(Lab+Jab)
      ga=dens*(Lga+Jga)
      gaga=dens*(Lgaga+Jgaga)
      naga=Lga+Jga+dens*(Lnaga+Jnaga)
      ganb=Lga+Jga+dens*(Lganb+Jganb)

      nask=2.D0*naga
      gask=2.D0*gaga
      sk=2.D0*ga
      sksk=4.D0*gaga
      gagb=gaga
      nagb=naga
      skgb=2.D0*gaga
      sknb=2.D0*ganb
c     ==--------------------------------------------------------------==
      Return
      END
c     ==================================================================
      Subroutine pbe96_c_loc(densa,densb,nana,nanb)
c     ==================================================================
      Implicit none
c     Arguments
      Real*8 densa,densb,nana,nanb
c     Local variables
      Real*8 sgrad,o3,n_13,n_43,n_73,n_23,n_103,dens,grad,T1,T2,T3,U1,U2
     $     ,U3,V1,V2,V3,W1,W2,W3,X1,X2,X3,Y1,Y2,Y3,epsa,epsaa,omea,
     $     zeta,zeta3,zeta4,o,rs,rs2,rs3,rsa,rsaa,fakt,rs12,f1,f12,g1,
     $     f2,f22,g2,f3,f32,g3,f1a,f2a,f3a,e1a,e2a,e3a,c,na_13,nb_13,e1,
     $     e3,skalar,ome,zetaa,t,tt,kl1,kl2,kl1a,kl2a,omeaa,zetaaa,faa,
     $     n2,n3,e1aa,e2aa,e3aa,omeb,zeta2,zetab,f1aa,f2aa,f3aa,fa,
     $     epsab,na_23,epsb,ttb,densao,densbo,zm43,zp43,e2,eps,kl1b,kl2b
     $     ,nb_23,omeab,zetaab

      Parameter (c=1.709921D0, T1=0.031091D0, T2=0.015545D0,
     $     T3=0.016887D0, U1=0.2137D0, U2=0.20548D0, U3=0.11125D0,
     $     V1=7.5957D0, V2=14.1189D0, V3=10.357D0, W1=3.5876D0,
     $     W2=6.1977D0, W3=3.6231D0, X1=1.6382D0, X2=3.3662D0,
     $     X3=0.88026D0, Y1=0.49294D0, Y2=0.62517D0, Y3=0.49671D0,
     $     o=6.46309613581743018602522D0,fakt=.6203504908994000D0,
     $     o3=0.3333333333333333333333D0)
c     ==--------------------------------------------------------------==
      densao=dmax1(densa,1.D-24)
      densbo=dmax1(densb,1.D-24)      

      dens=densao+densbo
      n2=dens*dens
      n3=n2*dens
      n_13=dens**o3
      n_43=n_13*dens
      n_73=n_43*dens
      n_103=n_73*dens
      na_13=densao**o3
      na_23=na_13*na_13
      nb_13=densbo**o3
      nb_23=nb_13*nb_13

      rs=fakt/n_13
      rs2=rs*rs
      rs3=rs2*rs
      rs12=dsqrt(rs)
      rsa=-o3*fakt/n_43
      rsaa=4.D0/9.D0*fakt/n_73
      zeta=(densao-densbo)/dens
      zeta2=zeta*zeta
      zeta3=zeta2*zeta
      zeta4=zeta3*zeta
      zetaa=2.D0*densbo/n2
      zp43=(1.D0+zeta)**(4.D0/3.D0)
      zm43=(1.D0-zeta)**(4.D0/3.D0)
      ome=(zp43+zm43-2.D0)/(2.D0**(4.D0/3.D0)-2.D0)
      omea=o*densbo*(na_13-nb_13)/n_73

      f1=2.D0*T1*(V1*rs12+W1*rs+X1*rs*rs12+Y1*rs2)
      f12=f1*f1
      g1=(f1+1.D0)/f1
      f1a=2.D0*T1*(0.5D0*V1/rs12+W1+3.D0/2.D0*X1*rs12+2.D0*Y1*rs)*rsa
      e1=-2.D0*T1*(1.D0+U1*rs)*dlog(g1)
      e1a=-2.D0*T1*(U1*rsa*dlog(g1)-(1.D0+U1*rs)/g1/f12*f1a)

      f2=2.D0*T2*(V2*rs12+W2*rs+X2*rs*rs12+Y2*rs2)
      f22=f2*f2
      g2=(f2+1.D0)/f2
      f2a=2.D0*T2*(0.5D0*V2/rs12+W2+3.D0/2.D0*X2*rs12+2.D0*Y2*rs)*rsa
      e2=-2.D0*T2*(1.D0+U2*rs)*dlog(g2)
      e2a=-2.D0*T2*(U2*rsa*dlog(g2)-(1.D0+U2*rs)/g2/f22*f2a)

      f3=2.D0*T3*(V3*rs12+W3*rs+X3*rs*rs12+Y3*rs2)
      f32=f3*f3
      g3=(f3+1.D0)/f3
      f3a=2.D0*T3*(0.5D0*V3/rs12+W3+3.D0/2.D0*X3*rs12+2.D0*Y3*rs)*rsa
      e3=-2.D0*T3*(1.D0+U3*rs)*dlog(g3)
      e3a=-2.D0*T3*(U3*rsa*dlog(g3)-(1.D0+U3*rs)/g3/f32*f3a)

      zetaaa=-4.D0*densbo/n3
      zetaab=2.D0*zeta/n2
      omeaa=o*densbo*(o3/na_23/n_73-(na_13-nb_13)*7.D0/3.D0/n_103)
      omeab=o*((na_13-nb_13)/n_73+densbo*(-o3/nb_23/n_73-(na_13-nb_13)
     $     *7.D0/3.D0/n_103))
      t=(1.D0-zeta4)/c
      tt=4.D0*zeta3*zetaa

      eps=e1-e3*ome*t+(e2-e1)*ome*zeta4

      kl1=omea*t-ome*tt/c
      kl2=omea*zeta4+ome*tt

      epsa=e1a-e3a*ome*t-e3*kl1+(e2a-e1a)*ome*zeta4+(e2-e1)*kl2
      
      f1aa=2.D0*T1*((-1.D0/4.D0*V1/rs/rs12+3.D0/4.D0*X1/rs12+2.D0*Y1)
     $     *rsa**2+f1a/(2.D0*T1*rsa)*rsaa)
      e1aa=-2.D0*T1*(U1*rsaa*dlog(g1)-2.D0*U1*rsa/g1/f12*f1a-(1.D0+U1*rs
     $     )*((f1a/f12/g1)**2+1.D0/g1*(-2.D0/f1/f12*f1a**2+f1aa/f12)))

      f2aa=2.D0*T2*((-1.D0/4.D0*V2/rs/rs12+3.D0/4.D0*X2/rs12+2.D0*Y2)
     $     *rsa**2+f2a/(2.D0*T2*rsa)*rsaa)
      e2aa=-2.D0*T2*(U2*rsaa*dlog(g2)-2.D0*U2*rsa/g2/f22*f2a-(1.D0+U2*rs
     $     )*((f2a/f22/g2)**2+(-2.D0/g2/f2/f22*f2a**2+f2aa/g2/f22)))

      f3aa=2.D0*T3*((-1.D0/4.D0*V3/rs/rs12+3.D0/4.D0*X3/rs12+2.D0*Y3)
     $     *rsa**2+f3a/(2.D0*T3*rsa)*rsaa)
      e3aa=-2.D0*T3*(U3*rsaa*dlog(g3)-2.D0*U3*rsa/g3/f32*f3a-(1.D0+U3*rs
     $     )*((f3a/f32/g3)**2+(-2.D0/g3/f3/f32*f3a**2+f3aa/g3/f32)))

      kl1a=omeaa*t-2.D0*omea*tt/c-ome/c*(12.D0*zeta2*zetaa**2+4.D0*zeta3
     $     *zetaaa)
      kl2a=omeaa*zeta4+2.D0*omea*tt+ome*(12.D0*zeta2*zetaa**2+4.D0*zeta3
     $     *zetaaa)
      epsaa=e1aa-e3aa*ome*t-e3a*(omea*t-ome*tt/c)-e3a*kl1
     $     -e3*kl1a+(e2aa-e1aa)*ome*zeta4+(e2a-e1a)*(omea*zeta4+ome*tt)
     $     +(e2a-e1a)*kl2+(e2-e1)*kl2a

      nana=2.D0*epsa+dens*epsaa

      zetab=-densao/densbo*zetaa
      omeb=-densao/densbo*omea
      epsb=e1a-e3a*ome*(1-zeta4)/c-e3*(omeb*(1-zeta4)/c-ome*4.D0*zeta3*
     $     zetab/c)+(e2a-e1a)*ome*zeta4+(e2-e1)*
     $     (omeb*zeta4+ome*4.D0*zeta3*zetab)

      ttb=4.D0*zeta3*zetab
      kl1b=omeab*t-omea*ttb/c-omeb*tt/c-ome/c*(12.D0*zeta2*zetaa*zetab+
     $     4.D0*zeta3*zetaab)
      kl2b=omeab*zeta4+omea*ttb+omeb*tt+ome*(12.D0*zeta2*zetaa*zetab+
     $     4.D0*zeta3*zetaab)
      epsab=e1aa-e3aa*ome*t-e3a*(omeb*t-ome*ttb/c)-e3a*kl1
     $     -e3*kl1b+(e2aa-e1aa)*ome*zeta4+(e2a-e1a)*(omeb*zeta4+ome*ttb)
     $     +(e2a-e1a)*kl2+(e2-e1)*kl2b

      nanb=epsa+epsb+dens*epsab
c     ==--------------------------------------------------------------==
      Return
      END
c     ==================================================================
      Subroutine pbe96_x(dens,grad,dfdg,d2fdn2,d2fdndg,d2fdg2)
c     ==================================================================
      Implicit none
c     Arguments
      Real*8 dens,grad,d2fdn2,d2fdndg,dfdg,d2fdg2
c     Local variables
      Real*8 sgrad,o3,n_13,n_43,n_73,n_23,n_103,X,S,F,Xs,Fs,Ss,Xss,Sss
     $     ,Fss,S2,kl,kl2,kl3,R,m,a,b,Fng,Sng,Fg,Sg,dens0,grad0,n_83,
     $     a2,Fgg
      Parameter (R=0.804D0, m=.2195164512208958179D0,
     $     a=.16162045967399548133D0, b=.98474502184269654115D0)
c     ==--------------------------------------------------------------==
      dens0=2.D0*dmax1(dens,1.D-24) !!!E(2n)
      grad0=4.D0*dmax1(grad,1.D-48)
      sgrad=dsqrt(grad0)

      a2=a*a
      o3=1.D0/3.D0
      n_13=dens0**o3
      n_23=n_13*n_13
      n_43=n_13*dens0
      n_73=n_43*dens0
      n_83=n_73*n_13
      n_103=n_73*dens0

      X=sgrad/n_43
      S=X*a

      S2=S*S
      kl=1.D0+m*S2/R
      kl2=kl*kl
      kl3=kl2*kl
      F=1.D0+R-R/kl

      Xs=-4.D0/3.D0*sgrad/n_73
      Ss=a*Xs
      Fs=2.D0/kl2*m*S*Ss

      Xss=28.D0/9.D0*sgrad/n_103
      Sss=a*Xss
      Fss=-m*(8.D0/R*m/kl3*S2*Ss**2-2.D0/kl2*(Ss**2+S*Sss))
      d2fdn2=2.D0*b*(-o3/n_23*F-2.D0*n_13*Fs-3.D0/4.D0*n_43*Fss) 

      Fg=m/kl2*a2/n_83
      Fgg=-m**2*a2**2/n_83*2.D0/kl3/R/n_83
      Fng=m/grad0*(2.D0*S*Ss/kl2-S2*4.D0*m/R*S*Ss/kl3)

      d2fdndg=4.D0*(-b*n_13*Fg-3.D0/4.D0*b*n_43*Fng)         

      dfdg=-3.D0/2.D0*b*n_43*Fg
      d2fdg2=-6.D0*b*n_43*Fgg
c     ==--------------------------------------------------------------==
      Return
      END
c     ==================================================================




