C     ==================================================================
      SUBROUTINE DEBFOR(C0,C1,C2,CG0,SC0,PME,GDE,VPP,EIGV)
C     ==--------------------------------------------------------------==
C     == DEBUG FORCES                                                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'symm.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'andr.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'store.inc'
      INCLUDE 'linres.inc'
C     Arguments
      COMPLEX*16 C0(*),C1(*),C2(*),CG0(*),SC0(*),PME(*),GDE(*)
      REAL*8     VPP(*),EIGV(*)
C     Variables
      INTEGER    NSTATE
      DIMENSION  RIN0(*),RHOO(*)
      REAL*8     TSCR(3,NAX,NSX),FDIS(3,NAX,NSX,2)
      POINTER    (IP_TSCR,TSCR),(IP_FDIS,FDIS)
      COMPLEX*16 PSI(NNR1,NLSD)
      REAL*8     RHOE(NNR1,NLSD),SCR(*),RINB(NNR1,NLSD)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
      POINTER    (IP_RINB,RINB)
      REAL*8     FNL(*),DFNL(*)
      INTEGER    IREC(100),IR
      CHARACTER  TAG*30,
     &           CDIR(3)*1
      DATA       CDIR /'X','Y','Z'/
      LOGICAL    TINFO
      INTEGER    NNX,NHPSI,NSYM,IAT,IS,IA,IDELT,K,ISYMUAT,ID,NMM,
     &           LSCR,IL_RHOE,IL_PSI
      REAL*8     TIME1,EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,ETOTO,TIME2,TCPU,
     &           THL,XLM,YLM,ZLM,DIST,TIMEF,EKINH1,EKINH2,EA,ER
      EXTERNAL   TIMEF
C     ==================================================================
      TIME1 = TIMEF()
      NSTATE=N
      TINFO=.FALSE.
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TSCR,3*NAX*NSX,'TSCR')
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_FDIS,6*NAX*NSX,'FDIS')
      IF(TDIAG) THEN
        NNX=NNR1*NLSD
        CALL MEMORY(IP_RINB,NNX,'RIN0')
        CALL MEMORY(IP_RIN0,NNX,'RIN0')
        CALL MEMORY(IP_ROUT0,NNX,'ROUT0')
        CALL MEMORY(IP_RMIX,NNX,'RMIX')
        CALL GET_ADDR(IP_RHOO,RIN0(1))
      ENDIF
      CALL AZZERO(TSCR,3*NAX*NSX)
      NACC = 7
      ECNSTR = 0.0D0
      ERESTR = 0.0D0
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL GIVE_SCR_DEBFOR(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      NMM=1
      IF(TDDFT) THEN
        CALL MEMORY(IP_RHOO,IL_RHOE,'RHOO')
        CALL MEMORY(IP_POTR,IL_RHOE,'POTR')
        IF(NS_TRI.GT.0) NMM=2
      ENDIF
      NMM=NMM*IL_PSI
      CALL MEMORY(IP_PSI,NMM,'PSI')
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
C     ==--------------------------------------------------------------==
      CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
      CALL WRITE_IREC(IREC)
C     END INITIALIZATION
C..Make sure TKFULL=.TRUE
      IF(TKPNT.AND.(.NOT.TKFULL)) THEN
        WRITE(6,*)
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        WRITE(6,*)
     & ' WARNING!  USE KPOINTS FULL  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        WRITE(6,*)
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
      ENDIF
C..
      ETOTO=0.D0
      EBOGO=0.D0
      IF(PARENT) CALL DETDOF(TAU0,TSCR)
      NPARA=-1
      IF(PARENT) THEN
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,F8.2,A)') ' TIME FOR INITIALIZATION',
     &       TCPU,' SECONDS'
      ENDIF
C     ==--------------------------------------------------------------==
C     ==      OPTIMIZATION OF WAVEFUNCTION                            ==
C     ==--------------------------------------------------------------==
      IF(PARENT)
     *  WRITE(6,'(/," ",20("*"),A,21("*"),/)') ' OPTIMIZE WAVEFUNCTION '
      CONVWF=.FALSE.
      SDIIS=.TRUE.
      SPCG=.TRUE.
      TIME1=TIMEF()
      DO INFW=1,NOMORE
        IF(TDIAG) THEN
          CALL UPDRHO(C0,C2,GDE,SC0,PME,VPP,TAU0,TSCR,EIGV,
     &                RHOE,PSI,SCR,LSCR,
     &                NSTATE,.FALSE.,.TRUE.,.FALSE.,INFW,THL,NHPSI)
C..store initial density
          CALL DCOPY(NNX,RIN0,1,RINB,1)
        ELSE
C         UPDATE THE WAVEFUNCTIONS
          CALL UPDWF(C0,C2,SC0,TAU0,TSCR,PME,GDE,VPP,EIGV,
     *               RHOE,PSI,SCR,LSCR,NSTATE,.FALSE.,.TRUE.)
        ENDIF
C       PRINTOUT THE EVOLUTION OF THE ITERATIVE OPTIMIZATION
        IF(PARENT) THEN
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
          CALL WRPRINT_WFOPT(EIGV,F,AMU,NSTATE,ETOT,ETOTO,
     &         TCPU,GEMAX,CNORM,THL,ENGPRI,INFW,INFW)
          ETOTO=ETOT
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(CONVWF.OR.EXSOFT) GOTO 100
      ENDDO
      IF(PARENT) THEN
        WRITE(6,*) ' NO CONVERGENCE IN ',INFW,' STEPS '
      ENDIF
      CALL ZHWWF(2,IREC,C0,C0,NSTATE,EIGV,TAU0,TAU0,TAU0,NFI)
      CALL STOPGM('DEBFOR',' ')
C     ==--------------------------------------------------------------==
  100 CONTINUE
C     NUCLEAR GRADIENT
      IF(TDDFT) THEN
        CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               NSTATE,1,.TRUE.,.TRUE.)
        CALL LR_TDDFT(C0,C1,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,
     *                SCR,LSCR,NSTATE,.TRUE.,IOUTPUT)
      ELSEIF(TDIAG) THEN
        CALL AZZERO(FION,3*NAX*NSX)
        CALL UPDRHO(C0,C2,GDE,SC0,PME,VPP,TAU0,FION,EIGV,
     *              RHOE,PSI,SCR,LSCR,
     *              NSTATE,.TRUE.,.TRUE.,TPRES,INFI,THL,NHPSI)
      ELSE
        CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               NSTATE,1,.TRUE.,.TRUE.)
      ENDIF
      CALL DSCAL(3*NAX*NSX,-1.0D0,FION(1,1,1),1)
      TIME2=TIMEF()
      TCPU=(TIME2-TIME1)*0.001D0
      IF(PARENT) THEN
         WRITE(6,'(A,F12.3,A)') ' TIME FOR ANALYTIC GRADIENT :',
     *               TCPU,' SECONDS'
        CALL WRENER
        CALL WRGEOF(TAU0,FION)
      ENDIF
      CALL ZHWWF(2,IREC,C0,C0,NSTATE,EIGV,TAU0,TAU0,TAU0,NFI)
      CALL DCOPY(2*NGWK*NSTATE,C0(1),1,CG0(1),1)
      CALL DCOPY(3*NAX*NSP,TAU0(1,1,1),1,TAUP(1,1,1),1)
      IF(PARENT) THEN
        WRITE(6,'(/," ",22("*"),A,22("*"),/)') ' FINITE DIFFERENCES '
        IF(TREF_FDIFF) THEN
          WRITE(6,'(A,T30,3(F12.3))') 'REFERENCE:',COORD_FDIFF
          WRITE(6,'(A,T54,F12.3)') 'RADIUS OF THE SPHERE:',R_FDIFF
          WRITE(6,'(A)')
     &         'WE COMPUTE ONLY THE FINITE DIFFERENCES FOR ATOMS'
          WRITE(6,'(A)')
     &         'INSIDE THIS SPHERE.'
        ENDIF
      ENDIF
C     No symmetrization of gradients in this part!
      NSYM=NROT
      NROT=1
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          IF (TREF_FDIFF) THEN
            XLM=TAU0(1,IA,IS)-COORD_FDIFF(1)
            YLM=TAU0(2,IA,IS)-COORD_FDIFF(2)
            ZLM=TAU0(3,IA,IS)-COORD_FDIFF(3)
            CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
            DIST = SQRT(XLM*XLM+YLM*YLM+ZLM*ZLM)
            IF(DIST.GT.R_FDIFF) THEN
              GOTO 31416
            ELSE
              WRITE(6,'(A,I7,4X,A4,4X,A,T54,1PE12.5)')
     &             " **** ATOM=",IAT,EL(IATYP(IS)),"DISTANCE=",DIST
            ENDIF
          ENDIF
          DO K=1,3
            DO IDELT=-1,1,2
              TIME1=TIMEF()
              IF(PARENT)
     *           WRITE(6,
     &             '(" **** ATOM=",I7,4X,A4,4X,A4,4X,A,T54,1PE12.5)')
     *          IAT,EL(IATYP(IS)),CDIR(K),'DISPLACEMENT=',FDIFF*IDELT
C             NEW GEOMETRY
              ISYMUAT=0
              IF(INDPG.NE.0) THEN
                IF(ISYMU(IAT).EQ.0) THEN
                  ISYMUAT=1
                ENDIF
              ENDIF
              IF(ISYMUAT.EQ.0.AND.LSKCOR(K,IAT).NE.0) THEN
                CALL DCOPY(3*NAX*NSP,TAUP(1,1,1),1,TAU0(1,1,1),1)
                TAU0(K,IA,IS)=TAU0(K,IA,IS)+IDELT*FDIFF
                CALL DCOPY(2*NGWK*NSTATE,CG0(1),1,C0(1),1)
                IF(TRANE) THEN
                  CALL RRANE(C0,C2,NSTATE)
                ENDIF
                CALL PHFAC(TAU0)
                IF(TINLC) THEN
                  CALL COPOT(RHOE,PSI,SCR,LSCR,.FALSE.)
                ENDIF
                IF(TIVAN) THEN
                  CALL RNLSM(C0,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
                ENDIF
                CALL ORTHO(NSTATE,C0,C2,SCR,LSCR)
                CONVWF=.FALSE.
                SDIIS=.TRUE.
                SPCG=.TRUE.
C               NL-Projector Overlap Matrix
                IF(TDIAG.AND.TTROT) THEN
                  CALL CALC_ALM(SCR,LSCR)
                ENDIF
                IF(TLANC) THEN 
                  CALL SET_B2L()
                ENDIF
                DO INFW=1,NOMORE
                  IF(TDIAG) THEN
                    CALL UPDRHO(C0,C2,GDE,SC0,PME,VPP,TAU0,TSCR,EIGV,
     &                          RHOE,PSI,SCR,LSCR,
     &                          NSTATE,.FALSE.,TINFO,.FALSE.,
     &                          INFW,THL,NHPSI)
                  ELSE
C                   UPDATE THE WAVEFUNCTIONS
                    CALL UPDWF(C0,C2,SC0,TAU0,TSCR,PME,GDE,VPP,EIGV,
     &                         RHOE,PSI,SCR,LSCR,NSTATE,.FALSE.,.TRUE.)
                  ENDIF
                  ETOTO=ETOT
                  IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
                  IF(EXSOFT) GOTO 200
                  IF(CONVWF) GOTO 101
                ENDDO
  101           CONTINUE
C               TDDFT
                IF(TDDFT) THEN
                  CALL LR_TDDFT(C0,C1,C2,SC0,RHOE,PSI,TAU0,TSCR,EIGV,
     &                          SCR,LSCR,NSTATE,.FALSE.,IOUTPUT)
                ENDIF
              ENDIF
              ID=(IDELT+1)/2 + 1
              FDIS(K,IA,IS,ID)=ETOT
              IF(PARENT) THEN
                TIME2=TIMEF()
                TCPU=(TIME2-TIME1)*0.001D0
                WRITE(6,'(A,I6,T15,A,T24,F20.10,T51,A,0PF9.2)')
     &               " ITER=",INFW,"ENERGY=",ETOT," TCPU=",TCPU
              ENDIF
              IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
              IF(EXSOFT) GOTO 200
            ENDDO
          ENDDO
31416     CONTINUE
        ENDDO
      ENDDO
      NROT=NSYM
      DO IS=1,NSP
        DO IA=1,NA(IS)
          DO K=1,3
            FDIS(K,IA,IS,1)=(FDIS(K,IA,IS,2)-FDIS(K,IA,IS,1))
     *                      /(2.D0*FDIFF)
          ENDDO
        ENDDO
      ENDDO
      CALL SYMVEC(FDIS,SCR,LSCR)
      IF(PARENT) CALL WRGEOF(TAUP,FDIS)
      CALL DCOPY(3*NAX*NSP,FDIS,1,FDIS(1,1,1,2),1)
      CALL DAXPY(3*NAX*NSP,-1.D0,FION,1,FDIS(1,1,1,2),1)
      IF(PARENT) THEN
        WRITE(6,'(/,T10,A,T18,A,T30,A,T49,A)') "ATOM","COMP",
     *           "ABSOLUTE ERROR","RELATIVE ERROR[%]"
        IAT=0
        IR=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            EA=0.D0
            DO K=1,3
              FDIS(K,IA,IS,2)=ABS(FDIS(K,IA,IS,2))
              IF(EA.LT.FDIS(K,IA,IS,2)) THEN
                IR=K
                EA=FDIS(K,IA,IS,2)
                ER=ABS(EA/(FION(K,IA,IS)+1.D-20))*100.D0
              ENDIF
            ENDDO
            IAT=IAT+1
            WRITE(6,'(I5,T10,A,T18,I4,T30,F14.8,T52,F14.6)') 
     *            IAT,EL(IATYP(IS)),IR,EA,ER
          ENDDO
        ENDDO
      ENDIF
  200 CONTINUE
      CALL FREEM(IP_FION)
      CALL FREEM(IP_TSCR)
      CALL FREEM(IP_TAUP)
      CALL FREEM(IP_FDIS)
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
      IF(TDIAG) THEN
        CALL FREEM(IP_RINB)
        CALL FREEM(IP_RIN0)
        CALL FREEM(IP_ROUT0)
        CALL FREEM(IP_RMIX)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_DEBFOR(LDEBFOR,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !TDIAG NONORT TPRES
      INCLUDE 'elct.inc'        !N
      INCLUDE 'ions.inc'        !NAT
      INCLUDE 'store.inc'       !RESTART RVIB
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'        !TTROT
      INCLUDE 'symm.inc'        !INDPG ROT
C     Arguments
      INTEGER LDEBFOR
      CHARACTER*30 TAG
C     Variables
      INTEGER NSTATE,LINITRUN,LCOPOT,LORTHO,LRNLSM,LRHOOFR,LCALC_ALM,
     &        LUPDATE,LFORCES,LSYMMAT,LTDDFT
C     ==--------------------------------------------------------------==
      NSTATE=N
      LCOPOT=0
      LORTHO=0
      LRNLSM=0
      LRHOOFR=0
      LCALC_ALM=0
      LFORCES=0
      LSYMMAT=0
      CALL GIVE_SCR_INITRUN(LINITRUN,TAG)
      IF(RESTART)THEN
        IF(TINLC) CALL GIVE_SCR_COPOT(LCOPOT,TAG)
        CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      ENDIF
      IF(TDDFT) CALL GIVE_SCR_LR_TDDFT(LTDDFT,.TRUE.,TAG)
      IF(TDIAG) THEN
        IF(TIVAN) CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
        CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
        IF(TTROT) CALL GIVE_SCR_CALC_ALM(LCALC_ALM,TAG)
        CALL GIVE_SCR_UPDRHO(LUPDATE,TAG,NSTATE,.TRUE.,TPRES)
      ELSE
        CALL GIVE_SCR_UPDWF(LUPDATE,TAG,NSTATE,.FALSE.)
        CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.TRUE.,.TRUE.)
      ENDIF
      IF(.NOT.RVIB) CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      IF(.NOT.(INDPG.EQ.0.OR.NROT.EQ.1))
     &     CALL GIVE_SCR_SYMMAT(LSYMMAT,TAG)
      LDEBFOR=MAX(9*NAT*NAT+9*NAT,
     &            LINITRUN,LCOPOT,LORTHO,LRNLSM,LRHOOFR,LCALC_ALM,
     &            LUPDATE,LFORCES,LSYMMAT,LTDDFT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
