#ifdef  BIG_STO
C     ==================================================================
      SUBROUTINE DENSTO(RG,TAU0,FILIN)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cell.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'mm_dim.inc'    ! for mm_c_trans()
      COMPLEX*16 RG(NHG)
      REAL*8     TAU0(3,NAX,NSX)
      CHARACTER  FILIN*(*)
C     Variables
      INTEGER    LEN,IG,IS,IA
      LOGICAL    FERROR
#if defined(CRAY) || defined(__NEC)
      COMPLEX*16 RGSX(*),RG2(*)
#else
      COMPLEX*8  RGSX(*),RG2(*)
#endif
      POINTER    (IP_RGSX,RGSX),(IP_RG2,RG2)
#if defined(PARALLEL)
      INTEGER    MAPW(*)
      POINTER    (IP_MAPW,MAPW)
      REAL*8     X1
      INTEGER    N1,NHGX,IPP,IP,MSGID,MSGLEN,NBYTES,IPW
#endif
C     ==--------------------------------------------------------------==
C     ==  STORE THE DENSITY ON FILE                                   ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        LEN=2*NHGS/IRAT
      ELSE
        LEN=2*NHG/IRAT
      ENDIF
      IF (.NOT.PARENT) CALL MEMORY(IP_RGSX,LEN,'RGSX')
#ifdef PARALLEL
      IF(PARENT) THEN
        X1=DBLE(NHGS)/DBLE(NPROC)*1.4d0
        N1=MIN(NHGS,NINT(X1))*2/IRAT
        CALL MEMORY(IP_RG2,N1,'RG2')
        NHGX=NINT(DBLE(NHG)*1.4d0)
        NHGX=MIN(NHGS,NHGX)
        NHGX=NHGX/IRAT + 1
        CALL MEMORY(IP_MAPW,NHGX,'MAPW')
        CALL FILEOPEN(12,FILIN,FO_DEF+FO_UFO,FERROR)
        CALL FILEOPEN(15,"MAP",FO_DEF+FO_UFO,FERROR)
        IF(FERROR) GOTO 30
        WRITE(12,ERR=30) IBRAV
        WRITE(12,ERR=30) CELLDM
        WRITE(12,ERR=30) NR1S,NR2S,NR3S
        WRITE(12,ERR=30) GCUT,NHGS,GCUTW
        WRITE(12,ERR=30) NSP
        WRITE(12,ERR=30) (NA(IS),IS=1,NSP)
C      For Anatoles reference density: the number of atoms in the
C      reference molecule may be different
        IF(.not.TDUMMYATOM_REF) THEN
         DO IS=1,NSP
           DO IA=1,NA(IS)
             WRITE(12,ERR=30) TAU0(1,IA,IS)-MM_C_TRANS(1),
     *         TAU0(2,IA,IS)-MM_C_TRANS(2),
     *         TAU0(3,IA,IS)-MM_C_TRANS(3),IATYP(IS)
           ENDDO
         ENDDO
        ENDIF
      ENDIF
      DO IPP=1,NPROC
        IP=PGROUP(IPP)
        MSGID = IP
        IF(PARENT) THEN
          IF(IP.EQ.ME) THEN
            DO IG=1,NHG
              RG2(IG)=RG(IG)
              MAPW(IG)=MAPGP(IG)
            ENDDO
          ELSE
            MSGID=1
            MSGLEN = SPARM(1,IPP-1) * 8
            CALL MY_BRECV(RG2,MSGLEN,IP,MSGID,NBYTES)
            MSGID=2
            MSGLEN = SPARM(1,IPP-1) * 8/IRAT
            CALL MY_BRECV(MAPW,MSGLEN,IP,MSGID,NBYTES)
          ENDIF
          DO IPW=1,SPARM(1,IPP-1)
             WRITE(12,ERR=30) RG2(IPW)  
             WRITE(15,ERR=30) MAPW(IPW)
          ENDDO
        ELSE
          IF(IP.EQ.ME) THEN
            DO IG=1,NHG
              RGSX(IG)=RG(IG)
            ENDDO
            MSGID=1
            MSGLEN = NHG * 8
            CALL MY_BSEND(RGSX,MSGLEN,PGROUP(1),MSGID)
            MSGID=2
            MSGLEN = NHG * 8/IRAT
            CALL MY_BSEND(MAPGP,MSGLEN,PGROUP(1),MSGID)
          ENDIF
        ENDIF
      ENDDO
#else
      DO IG=1,NHG
        RGSX(IG)=RG(IG)
      ENDDO
#endif
      IF(PARENT) THEN
        WRITE(12,ERR=30) (MM_C_TRANS(IG),IG=1,3)   ! origin of density block
        CALL FILECLOSE(12)
        CALL FILECLOSE(15) 
        WRITE(6,'(A,A)') ' DENSITY WRITTEN TO FILE ',FILIN
#ifdef PARALLEL
        CALL FREEM(IP_RG2)
        CALL FREEM(IP_MAPW)
#endif
      ENDIF
      IF (.NOT.PARENT) CALL FREEM(IP_RGSX)
      RETURN
C     ==--------------------------------------------------------------==
 30   CONTINUE
      CALL STOPGM('DENSTO','WRITE ERROR')
      END
C     ==================================================================
#else
C     ==================================================================
      SUBROUTINE DENSTO(RG,TAU0,FILIN)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cell.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'mm_dim.inc'    ! for mm_c_trans()

      COMPLEX*16 RG(NHG)
      REAL*8     TAU0(3,NAX,NSX)
      CHARACTER  FILIN*(*)
C     Variables
      INTEGER    LEN,IG,IS,IA
      LOGICAL    FERROR
#if defined(CRAY) || defined(__NEC)
      COMPLEX*16 RGSX(*),RG2(*)
#else
      COMPLEX*8  RGSX(*),RG2(*)
#endif
      POINTER    (IP_RGSX,RGSX),(IP_RG2,RG2)
#if defined(PARALLEL)
      INTEGER    MAPW(*)
      POINTER    (IP_MAPW,MAPW)
      REAL*8     X1
      INTEGER    N1,NHGX,IPP,IP,MSGID,MSGLEN,NBYTES,IPW
#endif
C     ==--------------------------------------------------------------==
C     ==  STORE THE DENSITY ON FILE                                   ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        LEN=2*NHGS/IRAT
      ELSE
        LEN=2*NHG/IRAT
      ENDIF
      CALL MEMORY(IP_RGSX,LEN,'RGSX')
#ifdef PARALLEL
      IF(PARENT) THEN
        X1=DBLE(NHGS)/DBLE(NPROC)*1.4d0
        N1=MIN(NHGS,NINT(X1))*2/IRAT
        CALL MEMORY(IP_RG2,N1,'RG2')
        NHGX=NINT(DBLE(NHG)*1.4d0)
        NHGX=MIN(NHGS,NHGX)
        NHGX=NHGX/IRAT + 1
        CALL MEMORY(IP_MAPW,NHGX,'MAPW')
      ENDIF
      DO IPP=1,NPROC
        IP=PGROUP(IPP)
        MSGID = IP
        IF(PARENT) THEN
          IF(IP.EQ.ME) THEN
            DO IG=1,NHG
              RG2(IG)=RG(IG)
              MAPW(IG)=MAPGP(IG)
            ENDDO
          ELSE
            MSGID=1
            MSGLEN = SPARM(1,IPP-1) * 8
            CALL MY_BRECV(RG2,MSGLEN,IP,MSGID,NBYTES)
            MSGID=2
            MSGLEN = SPARM(1,IPP-1) * 8/IRAT
            CALL MY_BRECV(MAPW,MSGLEN,IP,MSGID,NBYTES)
          ENDIF
          DO IPW=1,SPARM(1,IPP-1)
            RGSX(MAPW(IPW))=RG2(IPW)
          ENDDO
        ELSE
          IF(IP.EQ.ME) THEN
            DO IG=1,NHG
              RGSX(IG)=RG(IG)
            ENDDO
            MSGID=1
            MSGLEN = NHG * 8
            CALL MY_BSEND(RGSX,MSGLEN,PGROUP(1),MSGID)
            MSGID=2
            MSGLEN = NHG * 8/IRAT
            CALL MY_BSEND(MAPGP,MSGLEN,PGROUP(1),MSGID)
          ENDIF
        ENDIF
      ENDDO
#else
      DO IG=1,NHG
        RGSX(IG)=RG(IG)
      ENDDO
#endif
      IF(PARENT) THEN
        CALL FILEOPEN(12,FILIN,FO_DEF+FO_UFO,FERROR)
        IF(FERROR) GOTO 30
        WRITE(12,ERR=30) IBRAV
        WRITE(12,ERR=30) CELLDM
        WRITE(12,ERR=30) NR1S,NR2S,NR3S
        WRITE(12,ERR=30) GCUT,NHGS,GCUTW
        WRITE(12,ERR=30) NSP
        WRITE(12,ERR=30) (NA(IS),IS=1,NSP)

C      For Anatoles reference density: the number of atoms in the
C      reference molecule may be different
        IF(.NOT.TDUMMYATOM_REF) THEN
        DO IS=1,NSP
          DO IA=1,NA(IS)
            WRITE(12,ERR=30) TAU0(1,IA,IS)-MM_C_TRANS(1),
     *        TAU0(2,IA,IS)-MM_C_TRANS(2),
     *        TAU0(3,IA,IS)-MM_C_TRANS(3),IATYP(IS)
          ENDDO
        ENDDO
        END IF

        WRITE(12,ERR=30) (RGSX(IG),IG=1,NHGS)
        WRITE(12,ERR=30) (MM_C_TRANS(IG),IG=1,3)   ! origin of density block
        CALL FILECLOSE(12)
        WRITE(6,'(A,A)') ' DENSITY WRITTEN TO FILE ',FILIN
#ifdef PARALLEL
        CALL FREEM(IP_RG2)
        CALL FREEM(IP_MAPW)
#endif
      ENDIF
      CALL FREEM(IP_RGSX)
      RETURN
C     ==--------------------------------------------------------------==
 30   CONTINUE
      CALL STOPGM('DENSTO','WRITE ERROR')
      END
C     ==================================================================
#endif
