C     ==================================================================
      SUBROUTINE DEORT(NGW,NSTATE,RMAT,REIG,C0,SC0,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==    DEORTHOGONALIZE WAVEFUNCTIONS FOR VANDERBILT PP           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    NGW,NSTATE,LSCR
      COMPLEX*16 C0(NGW,*),SC0(NGW,*)
      REAL*8     RMAT(*),REIG(*),SCR(*)
C     Variables
      CHARACTER  TAG*30
      REAL*8     SERR
      REAL*8     DOTP
      EXTERNAL   DOTP
      INTEGER    ISUB,K,I,J,IT,IOPT,IJ,LDEORT
C     ==--------------------------------------------------------------==
      CALL TISET('     DEORT',ISUB)
      CALL GIVE_SCR_DEORT(LDEORT,TAG,NSTATE)
      CALL TEST_SCR('DEORT',TAG,LSCR,LDEORT)
      SERR=0.0D0
      K=0
      DO I=1,NSTATE
        DO J=I,NSTATE
          K=K+1
          RMAT(K)=DOTP(NGW,C0(1,I),C0(1,J))
        ENDDO
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(K,RMAT)
#endif
      DO I=1,K
        SERR=SERR+RMAT(I)
      ENDDO
      SERR=SERR-DBLE(NSTATE)
      IF(ABS(SERR).GT.1.D-8) THEN
        IT=NSTATE*NSTATE+1
        IOPT=1
        CALL DSPEVY(IOPT,RMAT,REIG,SCR,NSTATE,NSTATE,SCR(IT),3*NSTATE)
        DO I=1,NSTATE
          REIG(I)=1.0D0/DSQRT(REIG(I))
        ENDDO
        IJ=0
        DO I=1,NSTATE
          DO J=1,NSTATE
            SCR(IT+IJ)=REIG(I)*SCR(IJ+1)
            IJ=IJ+1
          ENDDO
        ENDDO
        CALL DGEMM('N','T',NSTATE,NSTATE,NSTATE,1.0D0,SCR(IT),NSTATE,
     *             SCR(1),NSTATE,0.0D0,RMAT(1),NSTATE)
        CALL DGEMM('N','N',2*NGW,NSTATE,NSTATE,1.0D0,C0(1,1),2*NGW,
     &             RMAT(1),NSTATE,0.0D0,SC0(1,1),2*NGW)
        CALL DCOPY(2*NGW*NSTATE,SC0(1,1),1,C0(1,1),1)
      ENDIF
      CALL TIHALT('     DEORT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_DEORT(LDEORT,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   LDEORT,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LDEORT=NSTATE*NSTATE+3*NSTATE
      TAG  ='NSTATE*NSTATE+3*NSTATE'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
