C     ==================================================================
      SUBROUTINE DETDOF(TAU0,TSCR)
C     ==--------------------------------------------------------------==
C     == DETermination of Degrees Of Freedom                          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      REAL*8    TAU0(3,NAX,*),TSCR(*)
C     Variables
      REAL*8    DXPAR(*)
      POINTER   (IP_DXPAR,DXPAR)
      CHARACTER INFOUT(0:1)*5
      DATA      INFOUT /'  FIX','  VAR'/
      REAL*8    DUMMY,CVAL
      INTEGER   I,K,IAT,L,IS,IA,IFIX,ITYP,IB,IC,ID,IIF,L1,L2,L3,NFIX
      INTEGER   IFIRST
      SAVE      IFIRST
      DATA      IFIRST /0/
C     ==--------------------------------------------------------------==
C     Only call this routine once
      IF (IFIRST.NE.0) RETURN
      IFIRST=1
C     ==--------------------------------------------------------------==
C     ==  GET TOTAL NUMBER OF PARAMETERS TO BE OPTIMIZED              ==
C     ==--------------------------------------------------------------==
      NODIM = 0
      IS = 0
      DO I=1,NAT
        DO K=1,3
          IF(LSKCOR(K,I).NE.0) THEN
            NODIM=NODIM+1
            LSKPTR(K,I)=NODIM
          ELSE
            IF(I.GT.NRPT) IS=IS+1
            LSKPTR(K,I)=0
          ENDIF
        ENDDO
      ENDDO
      IF(NODIM.NE.3*NAT) THEN
        GLIB=DBLE(NODIM)
      ELSEIF(TULTRA.OR.TMNOSE.OR.TCAFES.OR.TLOCT) THEN
        GLIB=DBLE(NODIM)
      ELSE
        GLIB=DBLE(NODIM)-3.D0
        IF(TISOS.AND..NOT.QMMM) THEN
          IF(NAT.EQ.1) THEN
            GLIB=GLIB
          ELSEIF(NAT.EQ.2) THEN
            GLIB=GLIB-2.D0
          ELSE
            GLIB=GLIB-3.D0
          ENDIF
        ENDIF
      ENDIF
      GLIB=GLIB-MCNSTR
      if(qmmm) GLIB=GLIB - INT(DBLE(3*NSOLV-IS)/3.0d0
     &                         /DBLE(NRAM_gr)*DBLE(NCONS_gr))
C     T.D. 7/10/1998. CHANGED TEST TO MD. AK, 2005/07/31.
      IF(MD) THEN
        IF(GLIB.LT.1.D0) THEN
          WRITE(6,'(A)')
     *       '  !! WARNING FROM DETDOF: WHY IS GLIB LESS THAN UNITY !!'
          GLIB=1.D0
          WRITE(6,'(A)')
     *       '  !! WARNING FROM DETDOF: NOW IT IS SET EQUAL TO UNITY !!'
        ENDIF
        WRITE(6,'(/,A,T58,I8)')
     &       ' DEGREES OF FREEDOM FOR SYSTEM:',NINT(GLIB)
      ELSE
CAK   force DOF to be >=1 for all non-md job types, but don't fuss about it.
        IF(GLIB.LT.1.D0) THEN
          GLIB=1.D0
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  STEEPEST DESCENT SCALING PARAMETERS                         ==
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_DTM,NODIM,'DTM')
      IAT=0
      L=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO K=1,3
            IF(LSKCOR(K,IAT).NE.0) THEN
              L=L+1
              DTM(L)=DT2BYM(IS)*LSKCOR(K,IAT)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  MASSES                                                      ==
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_PMALL,NAX*NSX,'PMALL')
      PATOT=0.0D0
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          IFIX=LSKCOR(1,IAT)+LSKCOR(1,IAT)+LSKCOR(1,IAT)
          IF(IFIX.NE.3) THEN
            PMALL(IAT)=0.0D0
          ELSE
            PMALL(IAT)=PMA0(IS)
          ENDIF
          PATOT=PATOT+PMALL(IAT)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  CONSTRAINTS                                                 ==
C     ==--------------------------------------------------------------==
      CALL DUM2(TAU0,TSCR)
      IF(MCNSTR.GT.0 .OR. MRESTR.GT.0) THEN
        L=MAX(MCNSTR,MRESTR)
        CALL MEMORY(IP_ANORM,NODIM*L,'ANORM')
        CALL MEMORY(IP_FCSTR,NODIM,'FCSTR')
      ENDIF
      IF(MCNSTR.GT.0) THEN
        CALL MEMORY(IP_ASKEL,12*NODIM*MCNSTR,'ASKEL')

        CALL MEMORY(IP_mm_ASKEL,12*MCNSTR,'mm_ASKEL')

        CALL MEMORY(IP_FC,NODIM,'FC')
        CALL MEMORY(IP_FV,NODIM,'FV')
        CALL MEMORY(IP_CSIGM,NODIM,'CSIGM')
        CALL MEMORY(IP_XLAGR,NODIM,'XLAGR')
        CALL MEMORY(IP_YLAGR,NODIM,'YLAGR')
        CALL AZZERO(ASKEL,12*NODIM*MCNSTR)

        CALL IAZZERO(mm_ASKEL,12*MCNSTR)

        CALL AZZERO(XLAGR,MCNSTR)
        CALL AZZERO(YLAGR,MCNSTR)
        DO I=1,MCNSTR
          ITYP=NTCNST(1,I)
          IF(ITYP.EQ.1) THEN
            CSIGM(I)=DSIGMA
          ELSEIF(ITYP.EQ.2) THEN
            CSIGM(I)=BSIGMA
          ELSEIF(ITYP.EQ.3) THEN
            CSIGM(I)=TSIGMA
          ELSEIF(ITYP.EQ.4 .OR. ITYP.EQ.10 .OR. ITYP.EQ.7) THEN
            CSIGM(I)=DSIGMA
          ELSEIF(ITYP.EQ.5 .OR. ITYP.EQ.6 .OR. ITYP.EQ.8 
     &                  .OR. ITYP.EQ.9) THEN
            CSIGM(I)=TSIGMA
          ENDIF
          IF(ITYP .NE. 6 .AND. ITYP .NE. 8 .AND. 
     &             ITYP .NE. 9 .AND. ITYP .NE. 10) THEN
            IA=NTCNST(2,I)
            IB=NTCNST(3,I)
            IC=NTCNST(4,I)
            ID=NTCNST(5,I)
            CALL BUILDA(IA,I,1)
            CALL BUILDA(IB,I,2)
            CALL BUILDA(IC,I,3)
            CALL BUILDA(ID,I,4)
          ENDIF
        ENDDO
      ENDIF
      IF(MRESTR.GT.0) THEN
        CALL MEMORY(IP_RSKEL,12*NODIM*MRESTR,'RSKEL')
        CALL AZZERO(RSKEL,12*NODIM*MRESTR)
        CALL MEMORY(IP_RESC,NODIM,'RESC')
        CALL MEMORY(IP_RESV,NODIM,'RESV')
        CALL MEMORY(IP_RESM,MRESTR*MRESTR,'RESM')
        CALL MEMORY(IP_RESFDIFF,MRESTR,'RESFDIFF')
        CALL MEMORY(IP_RSMASS,NODIM,'RSMASS')
        CALL AZZERO(RSMASS,NODIM)
        DO I=1,MRESTR
          IA=NTREST(2,I)
          IB=NTREST(3,I)
          IC=NTREST(4,I)
          ID=NTREST(5,I)
          CALL BUILDR(IA,I,1)
          CALL BUILDR(IB,I,2)
          CALL BUILDR(IC,I,3)
          CALL BUILDR(ID,I,4)
        ENDDO
        IAT=0
        L=0
        DO IS=1,NSP
           DO IA=1,NA(IS)
              IAT=IAT+1
              DO K=1,3
                 IF(LSKCOR(K,IAT).NE.0) THEN
                    L=L+1
                    RSMASS(L)=PMA0(IS)
                 ENDIF
              ENDDO
           ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  PRINT SOME INFO                                             ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        CALL DUMPR
      ENDIF
C fix COM does only work for (some) geometry optimizations. AK 2004-11-07    
      IF (LFCOM.AND.(LBFGS.OR.MD)) THEN
        WRITE(6,'(A)') ' WARNING: FIX COM has no effect. see manual.'
      ENDIF
      IAT=0
      NFIX=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          L1=LSKCOR(1,IAT)
          L2=LSKCOR(2,IAT)
          L3=LSKCOR(3,IAT)
          IFIX=L1+L2+L3
          IF(IFIX.NE.3) THEN
             NFIX=NFIX+1
          ENDIF
        ENDDO
      ENDDO
      if(NFIX.lt.500)then
        IIF=0
        IAT=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IAT=IAT+1
            L1=LSKCOR(1,IAT)
            L2=LSKCOR(2,IAT)
            L3=LSKCOR(3,IAT)
            IFIX=L1+L2+L3
            IF(IFIX.NE.3) THEN
              IF(IIF.EQ.0) WRITE(6,'(A,/,A)') 
     *               ' FIXED COORDINATES ',
     *               '   NR   TYPE         X       Y       Z'
              IIF=1
              WRITE(6,'(I5,5X,A,5X,3(A,3X))') NAT_grm(IAT),
     &              EL(IATYP(IS)),INFOUT(L1),INFOUT(L2),INFOUT(L3)
            ENDIF
          ENDDO
        ENDDO
      else
        write(6,*)'THERE ARE QUITE A LOT OF FIXED ATOMS'
      endif
      IF(MCNSTR.GT.0.OR.MRESTR.GT.0) THEN
        CALL MEMORY(IP_DXPAR,3*NAX*NSX,'DXPAR')
        CALL AZZERO(DXPAR,3*NAX*NSX)
        IF(MCNSTR.GT.0) THEN
          CALL CNSTFC(TAU0,TSCR,DXPAR,DUMMY,.TRUE.)
          DO I=1,MCNSTR
            CVAL=CNSVAL(I)
            IF(CVAL.EQ.-999.D0) THEN
              CNSVAL(I)=FV(I)
              FC(I)=0.0D0
            ENDIF
          ENDDO
        ENDIF
        CALL RESTFC(TAU0,TSCR,DXPAR)
        IF(MRESTR.GT.0) THEN
          DO I=1,MRESTR
            CVAL=RESVAL(I)
            IF(CVAL.EQ.-999.D0) THEN
              RESVAL(I)=RESV(I)
            ENDIF
          ENDDO
        ENDIF
        CALL CNSTPR
        CALL FREEM(IP_DXPAR)
      ENDIF
      WRITE(6,*) 
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE BUILDA(IA,I,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER IA,I,N
C     Variables
      REAL*8  FF
      INTEGER NN,JX,JY,JZ,NAA,ITYP,KX,JJ,J,IB
C     ==--------------------------------------------------------------==
      IF(IA.EQ.0) RETURN
      NN=(N-1)*3
      IF(IA.LT.0) THEN
        WRITE(6,'(1X,A,I5,A,I5,A,I1)') 'BUILDA! IA=',IA,' I=',I,' N=',N
        CALL STOPGM('BUILDA','IA IS LESS THAN ZERO')
      ELSEIF(IA.LE.NAT) THEN
        JX=LSKPTR(1,IA)
        JY=LSKPTR(2,IA)
        JZ=LSKPTR(3,IA)
        IF(JX.NE.0) ASKEL(JX,I,NN+1)=1.0D0
        IF(JY.NE.0) ASKEL(JY,I,NN+2)=1.0D0
        IF(JZ.NE.0) ASKEL(JZ,I,NN+3)=1.0D0

        IF(JX.NE.0) mm_ASKEL(I,NN+1)=JX
        IF(JY.NE.0) mm_ASKEL(I,NN+2)=JY
        IF(JZ.NE.0) mm_ASKEL(I,NN+3)=JZ
      ELSEIF(IA.LE.NAT+NDAT) THEN
        NAA=IA-NAT
        ITYP=LISTDA(NAA,1)
        IF(ITYP.EQ.1) THEN
          RETURN
        ELSEIF(ITYP.EQ.2) THEN
          KX=LISTDA(NAA,2)
          JJ=LISTD2(1,KX)
          FF=1.0D0/DBLE(JJ)
          DO J=1,JJ
            IB=LISTD2(J+1,KX)
            JX=LSKPTR(1,IB)
            JY=LSKPTR(2,IB)
            JZ=LSKPTR(3,IB)
            IF(JX.NE.0) ASKEL(JX,I,NN+1)=FF
            IF(JY.NE.0) ASKEL(JY,I,NN+2)=FF
            IF(JZ.NE.0) ASKEL(JZ,I,NN+3)=FF

            IF(JX.NE.0) mm_ASKEL(I,NN+1)=JX
            IF(JY.NE.0) mm_ASKEL(I,NN+2)=JY
            IF(JZ.NE.0) mm_ASKEL(I,NN+3)=JZ
          ENDDO
        ENDIF
      ELSE
        WRITE(6,'(1X,A,I5,A,I5,A,I1)') 'BUILDA! IA=',IA,' I=',I,' N=',N
        CALL STOPGM('BUILDA','INCORRECT VALUE FOR IA')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE BUILDR(IA,I,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER IA,I,N
C     Variables
      REAL*8  FF
      INTEGER NN,JX,JY,JZ,NAA,ITYP,KX,JJ,J,IB
C     ==--------------------------------------------------------------==
      IF(IA.EQ.0) RETURN
      NN=(N-1)*3
      IF(IA.LT.0) THEN
        WRITE(6,'(1X,A,I5,A,I5,A,I1)') 'BUILDR! IA=',IA,' I=',I,' N=',N
        CALL STOPGM('BUILDR','IA IS LESS THAN ZERO')
      ELSEIF(IA.LE.NAT) THEN
        JX=LSKPTR(1,IA)
        JY=LSKPTR(2,IA)
        JZ=LSKPTR(3,IA)
        IF(JX.NE.0) RSKEL(JX,I,NN+1)=1.0D0
        IF(JY.NE.0) RSKEL(JY,I,NN+2)=1.0D0
        IF(JZ.NE.0) RSKEL(JZ,I,NN+3)=1.0D0
      ELSEIF(IA.LE.NAT+NDAT) THEN
        NAA=IA-NAT
        ITYP=LISTDA(NAA,1)
        IF(ITYP.EQ.1) THEN
          RETURN
        ELSEIF(ITYP.EQ.2) THEN
          KX=LISTDA(NAA,2)
          JJ=LISTD2(1,KX)
          FF=1.0D0/DBLE(JJ)
          DO J=1,JJ
            IB=LISTD2(J+1,KX)
            JX=LSKPTR(1,IB)
            JY=LSKPTR(2,IB)
            JZ=LSKPTR(3,IB)
            IF(JX.NE.0) RSKEL(JX,I,NN+1)=FF
            IF(JY.NE.0) RSKEL(JY,I,NN+2)=FF
            IF(JZ.NE.0) RSKEL(JZ,I,NN+3)=FF
          ENDDO
        ENDIF
      ELSE
        WRITE(6,'(1X,A,I5,A,I5,A,I1)') 'BUILDR! IA=',IA,' I=',I,' N=',N
        CALL STOPGM('BUILDR','INCORRECT VALUE FOR IA')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE QMDOF
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'isos.inc'
      INTEGER I,K
C     ==--------------------------------------------------------------==
C..Do not change classical GLIB in test case
      IF(TESTPI) RETURN
C..NOTE: GLIB is the number of degrees of freedom for the first
C..      (staging) bead, whereas all other beads have always 3*NAT
C..      degrees of freedom each in the path integral case
C..      (the latter case is handled via GLIB_S=3.D0*NAT)
C..      For Centroid MD: TCENTRO=.TRUE.
C..                       first bead is NOT thermostatted in any case,
C..                       which means that GLIB has to be calculated
C..                       as for a classical simulation
C..      MCNSTR is the number of internal constraints
C..             using FIX STRUCTURE
C..      NODIM is the number of non-fixed cartesian coordinates
C..            using FIX ATOM or FIX COORDINATES
      NODIM = 0
      DO I=1,NAT
        DO K=1,3
          IF(LSKCOR(K,I).NE.0) THEN
            NODIM=NODIM+1
            LSKPTR(K,I)=NODIM
          ELSE
            LSKPTR(K,I)=0
          ENDIF
        ENDDO
      ENDDO
      IF(.NOT.TCENTRO) THEN
        GLIB=DBLE(NODIM)
      ELSE
        IF(NODIM.NE.3*NAT) THEN
          GLIB=DBLE(NODIM)
        ELSE
          GLIB=DBLE(NODIM)-3.D0
          IF(TISOS) THEN
            IF(NAT.EQ.1) THEN
              GLIB=GLIB
            ELSEIF(NAT.EQ.2) THEN
              GLIB=GLIB-2.D0
            ELSE
              GLIB=GLIB-3.D0
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      GLIB=GLIB-MCNSTR
      IF(GLIB.LT.1.0D0) THEN
        WRITE(6,'(A)')
     *  '  !! WARNING FROM DETDOF: WHY IS GLIB LESS THAN UNITY !!'
        GLIB=1.d0
        WRITE(6,'(A)')
     *  '  !! WARNING FROM QMDOF: NOW IT IS SET EQUAL TO UNITY !!'
      ENDIF
      WRITE(6,'(A,I8)')
     *  '  QMDOF| NUMBER OF QUANTUM DEGREES OF FREEDOM FOR IP=1 :'
     *  ,NINT(GLIB)
      WRITE(6,'(A,I8)')
     *  '  QMDOF| NUMBER OF QUANTUM DEGREES OF FREEDOM FOR IP>1 :'
     *  ,3*NAT
      IF(.NOT.(TPINM.OR.TSTAGE)) THEN
        IF(MCNSTR.NE.0.OR.NODIM.NE.3*NAT) THEN
          IF(PARENT) WRITE(6,*) ' ANY TYPE OF GEOMETRY CONSTRAINTS ',
     *       'ONLY ALLOWED WITH STAGING OR NORMAL MODE REPRESENTATION'
          CALL STOPGM('QMDOF','CONSTRAINTS')
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


