#ifdef __SR8000
*option MP(P(0)), LANGLVL(SAVE(0))
#endif
C     ==================================================================
      SUBROUTINE DETSP
C     ==--------------------------------------------------------------==
C     ==  DETERMINES THE NUMBER OF SPECIES                            ==
C     ==  AND THE MAXIMUM NUMBER OF ATOMS PER SPECIES                 ==
C     ==  DOES DYNAMIC ALLOCATION RELATED TO THESE QUANTITIES         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'coor.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'atom.inc'
      INCLUDE 'vdbt.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'cotr.inc'
#if defined(__GROMOS)
      INCLUDE 'geq0.inc'
#endif
      DIMENSION LVELINI(*)
      INTEGER   IUNIT,IERR,INSCAN,NASP,IS,IIS,IA,IE,I
      CHARACTER LINE*127
      INTEGER   MSGLEN
#if defined (__GROMOS)
c     Qmmm
      INTEGER IP,IPP,ic
C     ==--------------------------------------------------------------==
      integer qmlabel
      integer mmlabel
      parameter (mmlabel=8989 )
      parameter (qmlabel=9898 )
      integer grouplist(MAXCPU)
      integer iw
C     ==--------------------------------------------------------------==
      qmmm=.false.
      if(tqmmm)call mm_read_qmmm_input
      CALL iazzero(gr_atom(1,1),MAXSPQ*MAXNAX)
      CALL iazzero(gr_nasp(1),MAXSPQ)
#else
      qmmm=.false.
      if(TQMMM) CALL STOPGM('DETSP','GROMOS QM/MM CODE IS MISSING')
#endif
C     Number of DUMMY ATOMS to zero
      NDAT=0 
      IF(PARENT) THEN  
        IUNIT = 5
        IERR=INSCAN(IUNIT,'&ATOMS')
        IF(IERR.NE.0) THEN
          WRITE(6,'(1X,2A,I3)') 'DETSP: COULD NOT FIND SECTION &ATOMS',
     *         ' ON UNIT',IUNIT
          CALL STOPGM('DETSP','INPUT FILE PROBLEM')
        ENDIF
        NSX=0
        NAX=0
        NCLATOM=0
        NCLTYP=0
 10     CONTINUE
        READ(IUNIT,END=20,ERR=20,FMT='(A)') LINE
        IF(INDEX(LINE,'&END').NE.0) GOTO 30
C       Get the number of DUMMY ATOMS defined ATOMS section (if any)
        IF(INDEX(LINE,'DUMMY').NE.0 .AND.
     &     INDEX(LINE,'ATOMS').NE.0)CALL GETDAN(IUNIT)
        IF(LINE(1:1).NE.'*') GOTO 10

C..   NEW SPECIES FOUND, now we need to disregard
C     the file name when testing for additional flags
        CALL XSTRING(LINE,IA,IE)
        IA=IE+1
        IE=LEN(LINE)
        IF(IE.LT.IA) IE=IA

        IF(INDEX(LINE(IA:IE),'CLASSIC').NE.0) THEN
          NCLTYP=NCLTYP+1
          READ(IUNIT,END=20,ERR=20,FMT=*) NASP
          NCLATOM=NCLATOM+NASP
        ELSE
#if defined(__GROMOS)
          NSX=NSX+1
          READ(IUNIT,END=20,ERR=20,FMT=*)
          IF(INDEX(LINE(IA:IE),'ADD_H').NE.0) THEN
            READ(IUNIT,END=20,ERR=20,FMT=*) NASP
            if(qmmm)then
              n_added_H = NASP
              is_dummy(NSX)=.false.
            end if
            sp_H_added=NSX
            gr_NASP(NSX)=NASP
            NA(NSX)=NASP
            NAX=MAX(NASP,NAX)
            NCLATOM=NCLATOM+NASP  
          ELSE
            READ(IUNIT,END=20,ERR=20,FMT=*) NASP
            if(qmmm)then
              is_dummy(NSX)=.false.
              read(IUNIT,END=20,ERR=20,FMT=*)
     c             (gr_atom(NSX,i),i=1,NASP)
              if(INDEX(LINE(IA:IE),'DUM').NE.0)
     &             is_dummy(NSX)=.true.
            endif
            gr_NASP(NSX)=NASP
            NA(NSX)=NASP
            NAX=MAX(NASP,NAX)
            NCLATOM=NCLATOM+NASP
          END IF
          IF(NAX.GT.MAXNAX) THEN
            CALL STOPGM('DETSP','TOO MANY ATOMS PER ATOMIC SPECIES!')
          ENDIF
#else
          NSX=NSX+1
          READ(IUNIT,END=20,ERR=20,FMT=*)
          READ(IUNIT,END=20,ERR=20,FMT=*) NASP
          NA(NSX)=NASP
          NAX=MAX(NASP,NAX)
          NCLATOM=NCLATOM+NASP
#endif
        ENDIF
        GOTO 10
 20     CONTINUE
        WRITE(6,*) ' DETSP: ERROR WHILE READING ON UNIT ',IUNIT
        CALL STOPGM('DETSP','PARSER ERROR')
 30     CONTINUE
        IF(NSX.GT.MAXSP) THEN
          CALL STOPGM('DETSP','TOO MANY ATOMIC SPECIES SPECIFIED')
        ENDIF
        NCORX = (NSX*(NSX+1))/2
      ENDIF
#if defined(__GROMOS)
C     ==---------------- qmmm broadcast of data ----------------------==
      if(qmmm)then
        MSGLEN = MAXSP * 8 / IRAT
        CALL MY_BCAST(gr_nasp,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MAXSP * 8 / IRAT
        CALL MY_BCAST(is_dummy,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MAXSP * MAXNAX * 8 /IRAT
        CALL MY_BCAST(gr_atom,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 8 /IRAT
        CALL MY_BCAST(n_added_H,MSGLEN,SOURCE,ALLGRP)
        CALL MY_BCAST(sp_H_added,MSGLEN,SOURCE,ALLGRP)
      endif

      qmnode=.true.
      mmnode=.false.
      
#ifdef  PARALLEL
      DO IP=1,MAXCPU
        grouplist(IP)=0
      ENDDO

      QMMMNPROC=NPROC
      QMMMSOURCE=SOURCE
      QMMMGRP=ALLGRP
      MMNPROC=1                 ! only 1 is implemented / do not try with more

      qmnode=.false.
      IF (NPROC.GT.1 .and. mm_split) then
        NPROC=QMMMNPROC-1
        MMSOURCE=QMMMNPROC-1
                                ! those are the procs in the qm group
        DO IP=1,NPROC
          if (ME.eq.(IP-1)) qmnode=.true.
          grouplist(IP)=IP-1
        ENDDO
        CALL MY_GROUP(NPROC,grouplist,qmlabel,ALLGRP,QMMMGRP)
                                ! those are the procs in the mm group
        DO IP=NPROC+1,NPROC+MMNPROC
          if (ME.eq.(IP-1)) mmnode=.true.
          grouplist(IP-NPROC)=IP-1
        ENDDO
        CALL MY_GROUP(MMNPROC,grouplist,mmlabel,MMGRP,QMMMGRP)
      ELSE
        NPROC=QMMMNPROC
        MMSOURCE=SOURCE
        ALLGRP=QMMMGRP
        qmnode=.true.
                                ! those are the procs in the mm group
        grouplist(1)=MMSOURCE
        if (me.eq.MMSOURCE) mmnode=.true.
        CALL MY_GROUP(MMNPROC,grouplist,mmlabel,MMGRP,QMMMGRP)
      ENDIF

      MMPARENT   = ME.EQ.MMSOURCE
      QMMMPARENT = ME.EQ.QMMMSOURCE

      IF (QMMMNPROC.GT.1 .and. mm_split) then
C     make sure that all mm input files are available
C     on the mmnode(s).
        CALL MY_SYNCFILE(fileconf,QMMMSOURCE,MMSOURCE,QMMMGRP)
        CALL MY_SYNCFILE(filetopo,QMMMSOURCE,MMSOURCE,QMMMGRP)
        CALL MY_SYNCFILE(filegrin,QMMMSOURCE,MMSOURCE,QMMMGRP)
      ENDIF

      DO IP=1,NPROC
        PGROUP(IP) = IP-1
      ENDDO
      GEQ0=.TRUE.
      CALL MY_SYNC(QMMMGRP)
      CALL IAZZERO(NLINK,MAXCPU)
      DO IP=1,NPROC
        IPP=PGROUP(IP)
        NLINK(IPP)=IP-1
      ENDDO
#else 
      QMMMPARENT=.TRUE.
      QMMMSOURCE=0
      QMMMNPROC=1
      if (qmmm) then
        MMPARENT=.TRUE.
        MMSOURCE=0
        MMNPROC=1
        mmnode=.true.
      endif 
#endif  
#else
C     for compatibility with QM/MM
      QMMMGRP=ALLGRP
#endif
C     ==--------------------------------------------------------------==
C     NSX,NAX,NSAX,NCORX,NHXS,LPMAX,MMAXX
      MSGLEN = 7 * 8/IRAT
      CALL MY_BCAST(NSX,MSGLEN,SOURCE,QMMMGRP)
      MSGLEN = 2 * 8/IRAT
      CALL MY_BCAST(NCLATOM,MSGLEN,SOURCE,QMMMGRP)
C     NDAT (number of DUMMY ATOMS) 
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NDAT,MSGLEN,SOURCE,QMMMGRP)
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_TAU0,3*NAX*NSX,'TAU0')
C     To avoid floating invalid when dived by SCSALE
      CALL AZZERO(TAU0,3*NAX*NSX)
C     Velocities
      CALL MEMORY(IP_VELP,3*NAX*NSX,'VELP')
      CALL AZZERO(VELP,3*NAX*NSX)
      CALL MEMORY(IP_LVELINI,(NAX+1)*NSX,'LVELINI')
!$OMP parallel do private(IS,IA,IIS)
      DO IS=1,NSX
        IIS=(IS-1)*(NAX+1)
        DO IA=1,NAX+1
          LVELINI(IIS+IA)=.FALSE.
        ENDDO
      ENDDO

#if defined(__GROMOS)
C     if doing only the mm calculation nothing here is needed.
      if (.not.qmnode) return
#endif

C     Analytic PP
      CALL MEMORY(IP_AL,NSX*LMAXX*MAXGAU,'AL')
      CALL MEMORY(IP_BL,NSX*LMAXX*MAXGAU,'BL')
      CALL MEMORY(IP_RCL,NSX*LMAXX*MAXGAU,'RCL')
C     Gauss-Hermit integration
      CALL MEMORY(IP_WSG,NSX*NHX,'WSG')
      CALL MEMORY(IP_RGH,NSX*NHX,'RGH')
      CALL MEMORY(IP_WGH,NSX*NHX,'WGH')
C     Mapping function to l-value
      CALL MEMORY(IP_NGHTOL,NSX*NHX,'NGHTOL')
      CALL MEMORY(IP_NGHCOM,NSX*NHX,'NGHCOM')
C     Real space function and grids for Kleinman-Bylander + Potentials
      CALL MEMORY(IP_GNL,MPRO*MMAXX*NSX*LMAXX,'GNL')
      CALL MEMORY(IP_RPS,MMAXX*NSX*LMAXX,'RPS')
      CALL MEMORY(IP_RW,MMAXX*NSX,'RW')
      CALL MEMORY(IP_RV,MMAXX*NSX,'RV')
      CALL MEMORY(IP_VR,MMAXX*NSX*LMAXX,'VR')
C     Non Linear Core Correction
      CALL MEMORY(IP_RCGRID,MMAXX*NSX,'RCGRID')
      CALL MEMORY(IP_CORECG,MMAXX*NSX,'CORECG')
      CALL AZZERO(RCGRID,MMAXX*NSX)
      CALL AZZERO(CORECG,MMAXX*NSX)
!$OMP parallel do private(IS)
      DO IS=1,MAXSP
        ANLCC(IS)=0.0D0
        BNLCC(IS)=0.0D0
        ENLCC(IS)=0.0D0
        CLOGCC(IS)=0.0D0
        NLCCT(IS)=0
        MESHCC(IS)=0
      ENDDO
C     Classical atoms
      IF(NCLTYP.GT.0) THEN
        TCLAS=.TRUE.
        NCLTYP=NCLTYP+NSX
        CALL MEMORY(IP_CLASC,3*NCLATOM,'CLASC')
        CALL MEMORY(IP_CLASV,3*NCLATOM,'CLASV')
        CALL MEMORY(IP_CLASF,3*NCLATOM,'CLASF')
        CALL MEMORY(IP_CLASC0,3*NCLATOM,'CLASC0')
        CALL MEMORY(IP_CLASFOLD,3*NCLATOM,'CLASFOLD')
        CALL MEMORY(IP_DELCLASC,3*NCLATOM,'DELCLASC')
        CALL AZZERO(CLASC,3*NCLATOM)
        CALL AZZERO(CLASV,3*NCLATOM)
        CALL AZZERO(CLASF,3*NCLATOM)
        CALL AZZERO(CLASC0,3*NCLATOM)
        CALL AZZERO(DELCLASC,3*NCLATOM)
        CALL AZZERO(CLASFOLD,3*NCLATOM)
        CALL MEMORY(IP_CLTYP,(3*NCLATOM)/IRAT+1,'CLTYP')
        IF(NCLTYP.GT.MAXCLT) CALL STOPGM('DETSP',
     *       'PARAMETER MAXCLT TOO SMALL')
        DO I=1,MAXCLT
          IS_QM(I)=0
          CLAB(I)='    '
          CLMAS(I)=0.D0
          NCRANG(1,I)=0
          NCRANG(2,I)=0
        ENDDO
      ELSE
        TCLAS=.FALSE.
      ENDIF
      IF(PARENT) CALL PRMEM('     DETSP')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE  SENDCHAR(ARRAY,N,SOURCE,GID)
C     based on stuff by carlo to bypass problems on the cray
      IMPLICIT NONE
      INCLUDE 'irat.inc' 
      CHARACTER ARRAY(*)
      INTEGER N,I,NTMP
      INTEGER SOURCE,GID
      CHARACTER TMP(256)
      INTEGER   TMP_CLINK((256*IRAT)/8)
      EQUIVALENCE (TMP,TMP_CLINK)
      IF (N.GT.256) CALL STOPGM('SENDCHAR','n to large')
      DO I=1,N
        TMP(I) = ARRAY(I)
      END DO
      NTMP = (N*IRAT)/8
      IF(MOD(N,8/IRAT).GT.0) THEN
         NTMP = NTMP + 1
      END IF
      CALL MY_BCAST(TMP_CLINK,NTMP*8/IRAT,SOURCE,GID)
      DO I=1,N
        ARRAY(I)=TMP(I)
      END DO
      RETURN
      END 
C     ==================================================================
      SUBROUTINE GETDAN(IUNIT)
C     Reading the number of DUMMY ATOMS from &ATOMS section.
C     The size of the dummy atoms is necessary for allocating their
C     indices with NAT_cpmd array. But type of DUMMY ATOMS is read later.
      IMPLICIT NONE
      INTEGER IUNIT
      INCLUDE 'system.h'
      INCLUDE 'cotr.inc'
C     Reading the next line after DUMMY ATOMS (number of dummies)
      READ(IUNIT,END=21,ERR=21,FMT=*)NDAT  
      RETURN
21    CONTINUE
      CALL STOPGM('DETSP','ERROR READING DUMMY ATOMS')
      END

C     ==================================================================
      SUBROUTINE MY_SYNCFILE(FNAME,FROMNODE,TONODE,COMM)
C     transfer the text file 'fname' to all nodes that done have
C     it locally. e.g. required in the NEC-SX.
C     ==================================================================
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'fileopen.inc'
      ! ARGS
      CHARACTER*(*) FNAME
      INTEGER FROMNODE,TONODE,COMM
#ifdef PARALLEL
      ! LOCALS
      INTEGER MAXLINE
      PARAMETER (MAXLINE=120)
      CHARACTER*(MAXLINE) LINE
      LOGICAL FEXISTS,FERR
      INTEGER INMSG,IA,IE,MSGLEN,ITYPE,IUNIT
      PARAMETER (IUNIT=72)

C try to figure out whether we have to receive the file.
      IF(FROMNODE.EQ.TONODE) RETURN

      CALL MY_SYNC(COMM)
      FEXISTS=.FALSE.
      INMSG=0
      MSGLEN=8/IRAT
      CALL XSTRING(FNAME,IA,IE)
      INQUIRE(FILE=FNAME(IA:IE),EXIST=FEXISTS)
      IF(FEXISTS) INMSG=1
      CALL MY_BCAST(INMSG,MSGLEN,TONODE,COMM)
      IF(INMSG.EQ.1) THEN
        IF(PARENT) WRITE(6,*) 'FILE ',FNAME(IA:IE),' AVAILABLE'
        RETURN
      ELSE
        IF(PARENT) WRITE(6,*) 'SYNCING FILE ', FNAME(IA:IE),
     &      ' FROM NODE',FROMNODE,' TO NODE', TONODE
      ENDIF


C send file       
      IF(ME.EQ.FROMNODE) THEN
        FERR=.FALSE.
        CALL FILEOPEN(IUNIT,FNAME(IA:IE),FO_OLD,FERR)
        IF(FERR) GOTO 200
 100    CONTINUE
        READ(IUNIT,FMT='(A)',ERR=200,END=200) LINE
        INMSG=1
        CALL MY_ISEND(INMSG,MSGLEN,TONODE,0,COMM)
        CALL MY_ISEND(LINE,MAXLINE,TONODE,1,COMM)
        GOTO 100
 200    CONTINUE
        INMSG=0
        CALL MY_ISEND(INMSG,MSGLEN,TONODE,0,COMM)
        CALL FILECLOSE(IUNIT)
        RETURN
      ENDIF
      IF(ME.EQ.TONODE) THEN
        CALL FILEOPEN(IUNIT,FNAME(IA:IE),FO_NEW,FERR)
 300    CONTINUE
        INMSG=0
        CALL MY_IRECV(INMSG,MSGLEN,FROMNODE,0,0,COMM)
        IF(INMSG.EQ.0) THEN
          CALL FILECLOSE(IUNIT)
          RETURN
        ENDIF
        CALL MY_IRECV(LINE,MAXLINE,FROMNODE,1,0,COMM)
        CALL XSTRING(LINE,IA,IE)
        WRITE(IUNIT,'(A)') LINE(1:IE)
        GOTO 300
      ENDIF
#endif
      RETURN
      END
C     ==================================================================
