C     ==================================================================
      SUBROUTINE DIST_PROWFN(C0,TAU0,NSTATE)
C     ==--------------------------------------------------------------==
C     == PROJECT WAVEFUNCTIONS ON PSEUDO ATOMIC ORBITALS              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'prden.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,*)
      REAL*8     TAU0(*)
C     Variables
      DIMENSION  FNL2(NAT,NHXS,*),F(*),CATOM(NGW,*)
      REAL*8     FNL(NAT,NHXS,*),DFNL(*)
      COMPLEX*16 CSCR(NGW,*),PSI(*)
      REAL*8     CSCR1(2*NGW,*)
      POINTER    (IP_CSCR,CSCR),(IP_PSI,PSI), (IP_CSCR1, CSCR1)
      REAL*8     COMP(NUMORB),
     &           BAB(NAT,*),QA(NAT,5),
     &           XTMAT(NATTOT,*),SMAT(NATTOT,NATTOT),
     &           SCR(*),RHOE(*),
     &           ABC(*),ABCD(*)
      POINTER    (IP_COMP,COMP),
     &           (IP_BAB,BAB),(IP_QA,QA),
     &           (IP_XTMAT,XTMAT),(IP_SMAT,SMAT),
     &           (IP_SCR,SCR),(IP_RHOE,RHOE),
     &           (IP_ABC,ABC),(IP_ABCD,ABCD)

      CHARACTER  LABEL(1000)*15,TAG*30
      LOGICAL    TLSD2,FERROR
      REAL*8     FOC(20),SFC,FAC,RLEN,QM,QL,UNAC,ABCM
      REAL*8     DOTP,DDOT
      EXTERNAL   DOTP,DDOT
      INTEGER    MY_MAXVAL
      EXTERNAL   MY_MAXVAL
      INTEGER    ISUB,NOMAX,N3,N4,LSCR,IAORB,IAT,IS,IA,NATST,IXX,N2,
     &           LMAX,K,J,I,IZERO,IAO,NAO,IAT1,IAO1,IS1,NAO1,IA1,I1,
     &           IAT2,IAO2,IS2,NAO2,IA2,I2,MSWEEP,ISW,II,NUMIN,IAT3,
     &           IAT4,IB,IC,ID,I3MAX,IAT3M,IJK,L,I4MAX,NL,NLOC,
     &           IST,IDO,IDO2,ISTB,IAT4M,KI,KL,IL_RHOE,IL_PSI

      LOGICAL  DEBUG, FLG 
      REAL*8   TMAT(*),RMAT(*)
      POINTER  (IP_TMAT,TMAT),(IP_RMAT,RMAT)
      INTEGER  NORB,NORBX,MMX,MSGLEN,IP, NX, MMX1, STR1, NBYTES
C     LANCZOS BASIS AND VARIABLES
      REAL*8       LANV(*), W(*), PW(*), LOCAL_PW(*), V_PREV(*)
      REAL*8       VCUR(*), V0(*), BETA, Z(NATTOT,*)
      REAL*8       E(NATTOT), D(NATTOT), SM, SM_OLD
      REAL*8       CONV_TOL, SMALL_XSMAT(*), SMALL_XSMAT1(*)
      LOGICAL      CONV_FLAG
      POINTER      (IP_LANV, LANV), (IP_W, W), (IP_PW, PW) 
      POINTER      (IP_LOCAL_PW, LOCAL_PW), (IP_V_PREV, V_PREV)
      POINTER      (IP_VCUR,VCUR), (IP_V0,V0), (IP_Z,Z)
      POINTER      (IP_SMALL_XSMAT, SMALL_XSMAT) 
      POINTER      (IP_SMALL_XSMAT1, SMALL_XSMAT1)
      REAL*8       NRM, DNRM2, LOCAL_ALPHA, ALPHA, LOCAL_BETA
      REAL*8       SCAL
      INTEGER      INDEX1, INDEX2, CHUNK, CHUNK_NEW, CHUNK_E
      INTEGER      INDEX3, START, START_COL, INT_SM
      INTEGER      CHUNK_BEGIN, CHUNK_END, INDEX4, LAN_MAX
      INTEGER      CHUNK_BEGIN_E, CHUNK_END_E
      INTEGER      CHUNK_NEW_E, STR, STRC
      INTEGER      NDD(0:NPROC-1,2)
C     MPI_PARAMETERS
      INTEGER      RANK, SZ, SZ_OLD, IERR, OLD_ALLGRP
      INTEGER      SEND_CNT(NPROC), SEND_DISPL(NPROC)
      INTEGER      WORLD, NEWGROUP, LANGRP, NOLAN, LANLIST(NPROC)
      INTEGER      NOEIG, LANGRP1
      INTEGER      SEND_CNT_E(NPROC), SEND_DISPL_E(NPROC)
      INTEGER      OLD_SEND_CNT_E(NPROC)
C     VARIABLES FOR THE CALCULATION OF EIGENVALUES
C     LAPACK ROUTINE: DSTEVX
      INTEGER            IL, IU, LDZ, NFOUND, NUM_EIG
      REAL*8             ABTOL, VL, VU, DASUM
      INTEGER            IFAIL(NATTOT), IWORK(5*NATTOT)
      REAL*8             LD(NATTOT), LE(NATTOT), EIG(NATTOT)
      REAL*8             TEIG(NATTOT)
      REAL*8             WORK(5*NATTOT)
      REAL*8             E_TEMP
      POINTER            (IP_E_TEMP, E_TEMP)
      DIMENSION          E_TEMP(*)
      REAL*8             Z_TEMP
      POINTER            (IP_Z_TEMP, Z_TEMP)
      DIMENSION          Z_TEMP(*)
      REAL*8             EIG_VEC, TEIG_VEC
      POINTER            (IP_EIG_VEC, EIG_VEC), (IP_TEIG_VEC, TEIG_VEC) 
      DIMENSION          EIG_VEC(*), TEIG_VEC(*)
C     ==================================================================
C     ==--------------------------------------------------------------==
      CALL TISET('    DIST_PROWFN',ISUB)
#ifdef PARALLEL
      NOMAX = MAX(NUMORB,NATTOT)
      CALL MEMORY(IP_COMP,NUMORB,'COMP')
      CALL MEMORY(IP_CATOM,2*NGW*NATTOT,'CATOM')
      CALL MEMORY(IP_QA,5*NAT,'QA')
      CALL AZZERO(QA,5*NAT)
      IF(DPAN) THEN
        CALL MEMORY(IP_SMAT,NATTOT*NATTOT,'SMAT')
      ENDIF
      N3=NAT*NAT*NAT/6 + 1
      IF(DPAN.AND.NCEN.GE.3) THEN
        CALL MEMORY(IP_ABC,N3,'ABC')
      ENDIF
      N4=NAT*NAT*NAT*NAT/24 + 1
      IF(DPAN.AND.NCEN.GE.4) THEN
        CALL MEMORY(IP_ABCD,N4,'ABCD')
      ENDIF
C     Allocation of RHOE and PSI
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      IF(LOCL.AND.(NUMPR.NE.0)) THEN
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
        CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      ELSEIF(TIVAN) THEN
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      ENDIF
      DEBUG=.FALSE.
      IF(NATTOT.LE.0) RETURN
      CALL MY_SET_ORBDIST(NATTOT,NSTBLK,NORBX)
      NORB=NWA12(MEPOS,2)-NWA12(MEPOS,1)+1
      NORB=MAX(0,NORB)
      SZ = NPROC
      CALL MEMORY(IP_CSCR,2*NGW*NATTOT,'CSCR')
      CALL MEMORY(IP_CSCR1, 2*NGW*NATTOT,'CSCR1')
      CALL MEMORY(IP_XXMAT,NATTOT*NORBX,'XXMAT')
C     =================================================================
C     CREATE LANCZOS GROUP
C     =================================================================
      IF (PARENT) THEN
         DO INDEX4=1,SZ
            LANLIST(INDEX4) = 0
         ENDDO
         NOLAN = 0
         DO INDEX4=1, SZ
            IF((NWA12(INDEX4-1,2)-NWA12(INDEX4-1,1)+1).NE.0) THEN
               LANLIST(INDEX4) = INDEX4-1
               NOLAN = NOLAN + 1
            ENDIF
         ENDDO
      ENDIF
      MSGLEN=SZ*8/IRAT
      CALL MY_BCAST(LANLIST, MSGLEN, SOURCE, ALLGRP)
      MSGLEN=8/IRAT
      CALL MY_BCAST(NOLAN, MSGLEN, SOURCE, ALLGRP)
      CALL MY_GROUP(NOLAN,LANLIST,LABEL,LANGRP,ALLGRP)
C     =================================================================
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL GIVE_SCR_DIST_PROWFN(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      IF(PARENT) CALL PRMEM('    DIST_PROWFN')
C     ==--------------------------------------------------------------==
C     Load AO in PW basis
      IAORB=1
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          CALL LOADC(CATOM(1,IAORB),FOC,NGW,NGW,NATTOT,IS,IAT,NATST)
          DO IXX=IAORB,IAORB+NATST-1
            SFC=DOTP(NGW,CATOM(1,IXX),CATOM(1,IXX))
            CALL GLOSUM(1,SFC)
            SFC=1.D0/SQRT(SFC)
            CALL ZDSCAL(NGW,SFC,CATOM(1,IXX),1)
          ENDDO
          IAORB=IAORB+NATST
        ENDDO
      ENDDO
C..overlap matrix
      IF(PARENT) THEN
       CALL FILEOPEN(41,'OVERLAP',FO_DEF+FO_UFO,FERROR)
      ENDIF
#ifdef  _BGL
      MMX=MAX(NATTOT*NORBX,NORBX*NORBX)
      MMX1=NATTOT*NORBX
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_RMAT,MMX,'RMAT',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_TMAT,MMX1,'TMAT',DEBUG)
      CALL AZZERO(TMAT,NATTOT*NORB)
      CALL AZZERO(RMAT,NATTOT*NORB)
      CALL MEMORY(IP_XSMAT,NATTOT*NORBX,'XSMAT')
      CALL MEMORY(IP_XTMAT,NATTOT*NORBX,'XTMAT')
#else
      MMX=MAX(NATTOT*NORBX,NORBX*NORBX*NPROC)
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_RMAT,MMX,'RMAT',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_TMAT,MMX,'TMAT',DEBUG)
      CALL AZZERO(RMAT,NATTOT*NORB)
      CALL MEMORY(IP_XSMAT,NATTOT*NORBX,'XSMAT')
      CALL MEMORY(IP_XTMAT,NATTOT*NORBX,'XTMAT')
      CALL AZZERO(XSMAT,NATTOT*NORBX)
#endif
      MSGLEN=NATTOT*NORBX*8
      DO IP=0,NPROC-1
         NX=NWA12(IP,2)-NWA12(IP,1)+1
         CALL AZZERO(TMAT,NATTOT*NORBX)
         IF(NX.GT.0) THEN
           CALL OVLAP2(NGW,NATTOT,NX,TMAT,CATOM,CATOM(1,NWA12(IP,1)))
           CALL MY_COMBINE(TMAT,RMAT,MSGLEN,1,ALLGRP)
           IF(ME.EQ.IP) THEN
             CALL DCOPY(NATTOT*NORBX,RMAT(1),1,XSMAT(1,1),1)
           ENDIF
           IF(PARENT) THEN
C             WRITE THE CURRENT COLUMNS CHUNK TO FILE
              DO KI=1, NX
                DO KL=1, NATTOT
                  WRITE(41)  RMAT(KL+(KI-1)*NATTOT)
                ENDDO
              ENDDO
           ENDIF
         ENDIF
      ENDDO
      IF(PARENT) THEN
       CALL FILECLOSE(41)
      ENDIF
      CALL DCOPY(NATTOT*NORBX,XSMAT(1,1),1,XTMAT(1,1),1)
C====================================================
C LANCZOS ITERATION TO DIAGONALIZE THE OVERLAP MATRIX
C====================================================
C     ==================================================================
C     ONLY PROCESSORS THAT HAVE A NON-ZERO CHUNK OF THE RESTRICTED
C     HAMILTONIAN PARTICIPATE IN LANCZOS
C     ==================================================================
      IF ((NWA12(ME,2)-NWA12(ME,1)+1).NE.0) THEN
C     ==================================================================
C     START THE LANCZOS ITERATION WITH FULL GRAM-SCHIDT REORTH.
C     ==================================================================
C     --------------------------------------
C     MEMORY ALLOCATIONS AND INITIALIZATIONS
C     --------------------------------------
C     EACH PROCESSOR ALLOCATES MEMORY FOR ROW-WISE DISTRIBUTED LANCZOS
C     BASIS
      SZ = 0
      CHUNK_NEW = NWA12(ME,2)-NWA12(ME,1)+1
      DO IP=0, NPROC-1
         IF ((NWA12(IP,2)-NWA12(IP,1)+1).NE.0) SZ = SZ+1 
      ENDDO 
      NOLAN = SZ
      LAN_MAX = NATTOT+1
      CALL MEMORY(IP_VCUR,NATTOT,'VCUR')
      CALL MEMORY(IP_V0,NATTOT,'V0')
      CALL MEMORY(IP_LANV, CHUNK_NEW*LAN_MAX, 'LANV')
      CALL MEMORY(IP_W,CHUNK_NEW, 'W')
      CALL MEMORY(IP_PW, LAN_MAX, 'PW')
      CALL MEMORY(IP_LOCAL_PW, LAN_MAX, 'LOCAL_PW')
      CALL MEMORY(IP_V_PREV, CHUNK_NEW, 'V_PREV')
      CALL AZZERO(PW(1),LAN_MAX)
      CALL AZZERO(LANV(1),CHUNK_NEW*LAN_MAX)
      CALL AZZERO(W(1),CHUNK_NEW)  
C     DETERMINE SEND AND RECEIVE BUFFERS
      MSGLEN=8/IRAT
      CALL MY_CONCAT(CHUNK_NEW, SEND_CNT(1), MSGLEN, LANGRP)
      SEND_DISPL(1) = 0
      DO INDEX4=2, SZ
         SEND_DISPL(INDEX4) = SEND_DISPL(INDEX4-1) + SEND_CNT(INDEX4-1)
      ENDDO
C     DETERMINE A UNIT NORM INITIAL VECTOR V0
      IF (PARENT) THEN
         CALL DURAND(12344.0D0,NATTOT,V0) 
         NRM = DNRM2(NATTOT, V0(1), 1)
         NRM = 1/NRM
         CALL DSCAL(NATTOT, NRM, V0(1), 1)
      ENDIF
C     BROADCAST INITIAL VECTOR TO ALL PROCESSORS
      CALL MY_BCAST(V0(1), 8*NATTOT, SOURCE, LANGRP)
      CALL DCOPY(NATTOT, V0(1), 1, VCUR(1), 1)
C     INITIALIZE V_PREV and BETA
      DO IS=1, CHUNK_NEW
         V_PREV(IS) = 0D0
         W(IS)=0D0
      ENDDO
      BETA = 0D0
      CHUNK_BEGIN = NWA12(ME,1)
      CHUNK_END   = NWA12(ME,2)
C     INITIALIZE FIRST LANCZOS VECTOR
      CALL DCOPY(CHUNK_NEW, VCUR(CHUNK_BEGIN), 1, LANV(1), 1)
C     INITIALIZE INITIAL SUM OF WANTED EIGENVALUES
      SM_OLD = 0D0
C     INITIALIZE CONVERGENCE TOLERANCE
      CONV_TOL = 1D-8
C     ==================================================================
C     LANCZOS LOOP
C     ==================================================================
      NUM_EIG = NATTOT
      DO INDEX4 = 1, LAN_MAX-1
C       DISTRIBUTED MATRIX-VECTOR PRODUCT
C       W: Holds the result
        CALL DGEMV("T", NATTOT,CHUNK_NEW,1D0,XTMAT(1,1),NATTOT,
     &             VCUR(1), 1, 0D0, W(1), 1)

C       DAXPY: W = W - BETA*V_(J-1)
        CALL DAXPY(CHUNK_NEW, -BETA, V_PREV(1), 1, W(1), 1)
C       CALCULATE ALPHA: INNER PRODUCT WITH CURRENT LANCZOS VECTOR
        LOCAL_ALPHA = DDOT(CHUNK_NEW,W(1),1,
     &                     LANV((INDEX4-1)*CHUNK_NEW+1), 1)
        CALL MY_COMBINE(LOCAL_ALPHA, ALPHA, 8, 1, LANGRP)
C       DAXPY: W = W - ALPHA*V_J
        CALL DAXPY(CHUNK_NEW,-ALPHA,LANV((INDEX4-1)*CHUNK_NEW+1),1,
     &             W(1),1)
C     ==================================================================
C     REORTHOGONALIZE AGAINST ALL PREVIOUS BASIS VECTORS
C     ==================================================================
         DO INDEX1=1,INDEX4
           LOCAL_PW(INDEX1)=DDOT(CHUNK_NEW,LANV((INDEX1-1)*CHUNK_NEW+1),
     &                           1, W(1), 1)
         ENDDO
         CALL MY_COMBINE(LOCAL_PW(1), PW(1), INDEX4*8, 1, LANGRP)
         DO INDEX1=1, INDEX4
            CALL DAXPY(CHUNK_NEW, -PW(INDEX1),
     &                 LANV((INDEX1-1)*CHUNK_NEW+1), 1, W(1), 1)
         ENDDO
C     ==================================================================
C       CALCULATE BETA: NORM OF VECTOR W
        LOCAL_BETA = DDOT(CHUNK_NEW, W(1), 1, W(1), 1)
        CALL MY_COMBINE(LOCAL_BETA, BETA, 8, 1, LANGRP)
        BETA = DSQRT(BETA)
C       NORMALIZE NEXT LANCZOS VECTOR
        CALL DSCAL(CHUNK_NEW, 1/BETA, W(1), 1)
        CALL DCOPY(CHUNK_NEW, W(1), 1, LANV(INDEX4*CHUNK_NEW+1), 1)
C       UPDATE TRIDIAGONAL MATRIX T (DIAGONAL AND SUP_DIAGONAL ENTRIES)
        D(INDEX4) = ALPHA
        E(INDEX4) = BETA
C       UPDATE AUXILIARY VECTORS
        CALL MY_CONCATV(LANV((INDEX4)*CHUNK_NEW+1),VCUR(1),CHUNK_NEW,
     &                  SEND_CNT(1),SEND_DISPL(1),LANGRP)
        CALL DCOPY(CHUNK_NEW,LANV((INDEX4-1)*CHUNK_NEW+1),1,V_PREV(1),1)
C       CHECK CONVERGENCE FOR EIGENVALUES
        CALL DCOPY(INDEX4, D(1), 1, LD(1), 1)
        CALL DCOPY(INDEX4-1, E(1), 1, LE(1), 1)
        ABTOL = -1
C       ================================================================
C       THIS TEST IS PRACTICALLY NEVER DONE: FOR FUTURE USE
        IF (INDEX4.GT.NUM_EIG*2) THEN
          CALL  DSTEVX('N', 'I', INDEX4, LD(1), LE(1), VL,
     &                 VU, 1, NUM_EIG, ABTOL,
     &                 NFOUND, EIG(1), Z(1,1), 1, WORK(1), IWORK(1),
     &                 IFAIL(1), IERR)
          SM = DASUM(INDEX4, EIG(1), 1)
          IF  ( (ABS(SM-SM_OLD)/SM_OLD).LE.CONV_TOL ) THEN
             CONV_FLAG=.TRUE.
             GOTO 666
          ENDIF
          SM_OLD = SM
        ENDIF
C       ================================================================
      ENDDO
 666  CONTINUE
C     ===================
C     END OF LANCZOS LOOP
C     ===================
      IF (.NOT.CONV_FLAG) INDEX4 = INDEX4-1
      CHUNK_BEGIN_E = NWA12(MEPOS,1)
      CHUNK_END_E   = NWA12(MEPOS,2)
      CHUNK_NEW_E   = CHUNK_END_E - CHUNK_BEGIN_E +1
C     ==================================================================
C     DETERMINE SEND  BUFFERS
C     ==================================================================
      MSGLEN=8/IRAT
      CALL MY_CONCAT(CHUNK_NEW_E, SEND_CNT(1), MSGLEN, LANGRP)
      SEND_DISPL(1) = 0
      DO INDEX1=2, SZ
         SEND_DISPL(INDEX1) = SEND_DISPL(INDEX1-1) + SEND_CNT(INDEX1-1)
      ENDDO
C     ALLOCATE MEMORY FOR EIGENVECTORS
      CALL MEMORY(IP_Z, INDEX4*(CHUNK_END_E-CHUNK_BEGIN_E+1), 'Z')
      CALL  DSTEVX('V','I',INDEX4,D(1),E(1),VL,VU,CHUNK_BEGIN_E,
     &             CHUNK_END_E,
     &             ABTOL, NFOUND, TEIG(1), Z(1,1), INDEX4, WORK(1),
     &             IWORK(1), IFAIL(1), IERR)
      DO INDEX1=1, CHUNK_NEW_E
         TEIG(INDEX1) = 1/SQRT(TEIG(INDEX1))
      ENDDO
C     ==================================================================
C     ALL PROCESSORS GET ALL (SQUARED-RECIPROCAL) EIGENVALUES
C     ==================================================================
      CALL MY_CONCATV(TEIG(1),EIG(1),CHUNK_NEW,
     &                  SEND_CNT(1),SEND_DISPL(1),LANGRP)
C     ==================================================================
C     CALCULATION OF APPROXIMATE EIGENVECTORS
C     EACH PROCESSOR WILL STORE COMPLETE EIGENVECTORS
C     EIGENVECTORS ARE DISTRIBUTED ACROSS PROCESSORS
C     ==================================================================
      CALL MEMORY(IP_Z_TEMP, MY_MAXVAL(SEND_CNT(1),SZ)*NATTOT,
     &            'Z_TEMP')
C     ALLOCATION OF MEMORY FOR APPROXIMATE EIGENVECTORS
      CALL MEMORY(IP_EIG_VEC, NATTOT*NORBX, 'EIG_VEC')
      CALL MEMORY(IP_TEIG_VEC, NATTOT*NORBX, 'TEIG_VEC')
C     ALLOCATE ADDITIONAL MEMORY FOR BOOK KEEPING
      MSGLEN=8/IRAT
      CALL MY_CONCAT(CHUNK_NEW, OLD_SEND_CNT_E(1), MSGLEN, LANGRP)
      CALL MEMORY(IP_E_TEMP, 2*OLD_SEND_CNT_E(ME+1)*
     &            MAX(CHUNK_NEW_E,SEND_CNT(1)),
     &            'E_TEMP')
      STRC = 1
      DO INDEX1=1, NOLAN
         IF (ME.EQ.(INDEX1-1) ) THEN
            CALL DCOPY(NATTOT*CHUNK_NEW_E, Z(1,1), 1, Z_TEMP(1), 1)
            DO INDEX2 = 1, SZ
               SEND_CNT_E(INDEX2) = OLD_SEND_CNT_E(INDEX2) *
     &                              SEND_CNT(ME+1)
            ENDDO
            SEND_DISPL_E(1) = 0
            DO INDEX2=2, SZ
               SEND_DISPL_E(INDEX2) = SEND_DISPL_E(INDEX2-1) +
     &                       SEND_CNT_E(INDEX2-1)
            ENDDO
         ENDIF
C        BROADCAST COUNTS AND DISPL. DATA FOR ALLGATHER
         MSGLEN=SZ*8/IRAT
         CALL MY_BCAST(SEND_CNT_E(1), MSGLEN, INDEX1-1, LANGRP)
         CALL MY_BCAST(SEND_DISPL_E(1), MSGLEN, INDEX1-1, LANGRP)
C        BROADCAST MY EIGENVECTORS OF THE TRIDIAGONAL MATRIX
         CALL MY_BCAST(Z_TEMP(1), SEND_CNT(INDEX1)*NATTOT*8, INDEX1-1,
     &                   LANGRP)
C        MULTIPLY RECEIVED EIGENVECTORS WITH MY PART OF THE LANCZOS
C        BASIS
         CALL DGEMM("N","N",CHUNK_NEW,SEND_CNT(INDEX1),NATTOT,1D0,
     &              LANV(1),CHUNK_NEW,Z_TEMP(1),NATTOT,
     &              0D0, EIG_VEC(STRC), CHUNK_NEW)
C        NORMALIZE EIGENVECTORS TO UNITY
         DO INDEX4 = 1, SEND_CNT(INDEX1) 
            ALPHA =DDOT(CHUNK_NEW, EIG_VEC(STRC+(INDEX4-1)*CHUNK_NEW),
     &                  1, EIG_VEC(STRC+(INDEX4-1)*CHUNK_NEW), 1)
            CALL MY_COMBINE(ALPHA, SCAL, 8, 1, LANGRP)
            SCAL = 1/sqrt(SCAL)
            CALL DSCAL(CHUNK_NEW, SCAL, 
     &                 EIG_VEC(STRC+(INDEX4-1)*CHUNK_NEW),1)
         ENDDO
         STRC = STRC + CHUNK_NEW*SEND_CNT(INDEX1)  
      ENDDO
C     ==================================================================
      CALL MEMORY(IP_SMALL_XSMAT, NORBX*NORBX, "SMALL_XSMAT")
      STR = 1
      DO INDEX1 = 1, NOLAN
C        ==========
C        LOCAL COPY
C        ==========
         IF (ME.EQ.(INDEX1-1) ) THEN
            CALL DCOPY(NATTOT*CHUNK_NEW, EIG_VEC(1), 1, Z_TEMP(1), 1)
C           ===========================
C           SCALE WITH RECIPROCAL SQRTs
C           ===========================
            DO INDEX4=1, NATTOT
               CALL DSCAL(CHUNK_NEW, EIG(INDEX4), 
     &                    Z_TEMP((INDEX4-1)*CHUNK_NEW+1), 1)
            ENDDO
            DO INDEX2 = 1, NOLAN
               SEND_CNT_E(INDEX2) = OLD_SEND_CNT_E(INDEX2)*CHUNK_NEW
            ENDDO
            SEND_DISPL_E(1) = 0
            DO INDEX2=2, SZ
               SEND_DISPL_E(INDEX2) = SEND_DISPL_E(INDEX2-1) +
     &                       SEND_CNT_E(INDEX2-1)
            ENDDO
         ENDIF
C        =================
C        ARRAYS FOR GATHER
C        =================
         MSGLEN=NOLAN*8/IRAT
         CALL MY_BCAST(SEND_CNT_E(1), MSGLEN, INDEX1-1, LANGRP)
         CALL MY_BCAST(SEND_DISPL_E(1), MSGLEN, INDEX1-1, LANGRP)
C        =====================
C        BROADCAST  LOCAL COPY
C        =====================
         CALL MY_BCAST(Z_TEMP(1), 8*NATTOT*SEND_CNT(INDEX1), 
     &                 INDEX1-1, LANGRP)
C        ===============================================
C        MULTIPLY WITH LOCAL PART OF EIGENVECTORS MATRIX
C        ===============================================
         CALL DGEMM("N","T", SEND_CNT(INDEX1), CHUNK_NEW, 
     &              NATTOT, 1D0, Z_TEMP(1),
     &              SEND_CNT(INDEX1), EIG_VEC(1), CHUNK_NEW,
     &              0D0, SMALL_XSMAT(1),
     &              SEND_CNT(INDEX1) )
C        ===============================
C        GATHER BACK LOCAL PART OF XSMAT 
C        ===============================
         CALL MY_SOURCE_CONCATV(SMALL_XSMAT(1),TEIG_VEC(1),
     &                          CHUNK_NEW*SEND_CNT(INDEX1),
     &                          SEND_CNT_E(1), SEND_DISPL_E(1),
     &                          INDEX1-1, LANGRP)
      ENDDO
      DO INDEX1=1, NATTOT
         CALL DCOPY(CHUNK_NEW, TEIG_VEC((INDEX1-1)*CHUNK_NEW+1), 
     &              1, XSMAT(INDEX1,1), NATTOT)
      ENDDO
      ENDIF
C     =================================================================  
C     All processors work here since all of them
C     hold a pice of the atomic orbitals
C     =================================================================
      CALL MY_SYNC(ALLGRP)
C     Make sure that every processor knows SEND_CNT 
      MSGLEN=NPROC*8/IRAT
      CALL MY_BCAST(SEND_CNT(1), MSGLEN, SOURCE, ALLGRP)
C     Allocate memory Z_TEMP if not allocated so far
      IF ((ME+1).GT.NOLAN) THEN 
         CALL MEMORY(IP_Z_TEMP, NATTOT*NORBX, 'Z_TEMP')
      ENDIF
C     Orthonormalize atomic orbitals
      CALL ZAZZERO(CSCR, NATTOT*NGW)
      STRC = 1 
      DO INDEX1=1, NOLAN
         IF ((ME+1).EQ.INDEX1) THEN
            CALL DCOPY(NATTOT*CHUNK_NEW, XSMAT(1,1), 1, Z_TEMP(1), 1)
         ENDIF
         CALL MY_BCAST(Z_TEMP(1), 8*NATTOT*SEND_CNT(INDEX1),
     &                 INDEX1-1, ALLGRP)
         CALL DGEMM('N','N',2*NGW,SEND_CNT(INDEX1),NATTOT,1.0D0,
     &              CATOM(1,1),2*NGW, Z_TEMP(1), NATTOT,
     &              0.0D0,CSCR(1,STRC),2*NGW)
         STRC = STRC + SEND_CNT(INDEX1)
      ENDDO  
      CALL DCOPY(2*NATTOT*NGW,CSCR(1,1),1,CATOM(1,1),1)
C     =================================================================
C     Overlap AO with wavefunctions
C     =================================================================
      MSGLEN=NUMORB*NORBX*8
      DO IP=0,NPROC-1
         NX=NWA12(IP,2)-NWA12(IP,1)+1
         CALL AZZERO(Z_TEMP,NATTOT*NORBX)
         IF(NX.GT.0) THEN
           CALL OVLAP2(NGW,NX,NUMORB,Z_TEMP,CATOM(1,NWA12(IP,1)),C0)
           CALL MY_COMBINE(Z_TEMP,RMAT,MSGLEN,1,ALLGRP)
           IF (ME.EQ.IP) THEN
              DO INDEX1=1, NX
                 CALL DCOPY(NUMORB,RMAT(INDEX1),NX,
     &                      XXMAT(1,INDEX1),1)
              ENDDO
           ENDIF
         ENDIF
      ENDDO
      CALL MY_SYNC(ALLGRP)
C     =================================================================
C     =================================================================
C     VANDERBILD CASE NOT IMPLEMENTED YET
C     =================================================================
      IF(TIVAN) CALL STOPGM('DIST_PROWFN','VANDERBILD NOT IMPLEMENTED')
      IF(TIVAN) THEN
C       Calculate augmentation charges
        CALL AUGCHG(FNL,F,QA(1,4),NUMORB)
        CALL MEMORY(IP_FNL2,NAT*NUMORB*NHXS,'FNL2')
        CALL FREEM(IP_FNL)
        CALL MEMORY(IP_FNL,NAT*NATTOT*NHXS,'FNL')
        CALL RNLSM(CATOM,NATTOT,PSI,SCR,LSCR,1,1,.FALSE.)
        CALL AZZERO(FNL2,NAT*NHXS*NUMORB)
        DO I=1,NUMORB
          DO J=1,NATTOT
            CALL DAXPY(NAT*NHXS,XXMAT(J,I),FNL(1,1,J),1,FNL2(1,1,I),1)
          ENDDO
        ENDDO
        CALL AUGCHG(FNL2,F,QA(1,5),NUMORB)
      ENDIF
C     =================================================================
      DO I=1,NUMORB
        Z_TEMP(1)=DOTP(NGW,C0(1,I),C0(1,I))
        CALL MY_COMBINE(Z_TEMP(1),RLEN, 8, 1, ALLGRP)
C       ===============================================================
C       COMP IS CALCULATED IN PARALLEL SINCE XXMAT IS DISTRIBUTED
C       ROW-WISE TO ALL PROCESSORS THAT TAKE PART IN LANGRP
C       ===============================================================
        IF (CHUNK_NEW.NE.0) THEN
         TMAT(1)=DDOT(CHUNK_NEW, XXMAT(I,1), NATTOT, XXMAT(I,1), NATTOT)
          CALL MY_COMBINE(TMAT(1), COMP(I), 8, 1, LANGRP)
          COMP(I)=COMP(I)/RLEN
        ENDIF   
      ENDDO
C     ================================================================= 
C     THE NEXT CHUNK OF THE CODE IS SUPPOSED TO BE EXECUTED ONLY BY
C     THE PARENT PROCESS. BUT XXMAT IS DISTRIBUTED ROW-WISE NOW. SO ALL
C     PROCESSORS INVOLVED IN THE LANGRP GROUP TAKE PART
C     =================================================================
      IF (CHUNK_NEW.NE.0) THEN
         CALL AZZERO(Z_TEMP, NORBX*NATTOT)
         DO INDEX1=1, CHUNK_NEW
            DO INDEX4=1, NSTATE
               Z_TEMP(INDEX1) = Z_TEMP(INDEX1) + 
     &                          F(INDEX4)*XXMAT(INDEX4,INDEX1)**2
            ENDDO
         ENDDO
C        PARENT GETS ARRAY Z_TEMP 
         CALL MY_CONCATV(Z_TEMP(1),Z_TEMP(NATTOT+1),CHUNK_NEW,
     &                  SEND_CNT(1),SEND_DISPL(1), LANGRP)
         IF(PARENT) THEN
C           Lowdin Population Analysis
            IAT=0
            IAO=0
            DO IS=1,NSP
               NAO=NUMAOR(IS)
               DO IA=1,NA(IS)
                  IAT=IAT+1
C                 QA(.,4) is the true augmentation charge!
                  QA(IAT,2)=ZV(IS)-QA(IAT,4)
                  DO I=IAO+1,IAO+NAO
                     QA(IAT,2)=QA(IAT,2)-Z_TEMP(NATTOT+I)
                  ENDDO
                  IAO=IAO+NAO
               ENDDO
            ENDDO
         ENDIF
      ENDIF
C     =================================================================
C     Rotate back to AO basis:
C     RESULT IS OF SIZE (NATTOT x NUMORB). SO WE DISTRIBUTE IT 
C     ROW-WISE
C     =================================================================
      IF (CHUNK_NEW.NE.0) THEN
         STRC=1
         DO INDEX1=1, NSTATE
            CALL DGEMV('N',NATTOT,CHUNK_NEW,1D0,XSMAT(1,1),NATTOT,
     &                 XXMAT(INDEX1,1),NATTOT,0D0,SCR(1),1)
            CALL MY_COMBINE(SCR(1),EIG_VEC(1),8*NATTOT,1,LANGRP)
            CALL DCOPY(CHUNK_NEW, EIG_VEC(NWA12(ME,1)), 
     &                 1, XXMAT(INDEX1,1), NATTOT)
         ENDDO
      ENDIF
      CALL MY_SYNC(ALLGRP)
C     ===============================================================
C     MOVE OUTPUT TO FILE HERE: IMPORTANT FOR I/O
C     ===============================================================
      IF (PARENT) THEN
         CALL FILEOPEN(41,'WFNCOEF',FO_DEF+FO_UFO,FERROR)
         WRITE(41) NATTOT,NSP,(ZV(IS),NA(IS),NUMAOR(IS),IS=1,NSP)
      ENDIF
      IF (CHUNK_NEW.NE.0) THEN
         DO INDEX1=1, NOLAN
            IF ((ME+1).EQ.INDEX1) THEN
               DO INDEX4=1, NUMORB
                  CALL DCOPY(CHUNK_NEW,XXMAT(INDEX4,1),NATTOT,
     &                       Z_TEMP((INDEX4-1)*CHUNK_NEW+1),1)
               ENDDO
            ENDIF
            CALL MY_BCAST(Z_TEMP(1), 8*NUMORB*SEND_CNT(INDEX1),
     &                    INDEX1-1, LANGRP)
            IF (PARENT) THEN
               DO KL=1, SEND_CNT(INDEX1)
                  DO KI=1, NUMORB
                     WRITE(41) Z_TEMP(KL+(KI-1)*SEND_CNT(INDEX1))
                  ENDDO
               ENDDO
            ENDIF   
         ENDDO
      ENDIF
      IF (PARENT) THEN  
         CALL FILECLOSE(41)
      ENDIF
      CALL MY_SYNC(ALLGRP)
C     ===============================================================
      IF (PARENT) THEN
C       Print the wavefunctions
        CALL MKLABEL(LABEL)
        IF(PRTO) THEN
          WRITE(6,'(/,A,/)') ' WAVEFUNCTIONS IN ATOMIC ORBITAL BASIS'
          IF(TLSD) THEN
            WRITE(6,'(21X,A)') ' ****** ALPHA SPIN ****** '
            CALL DIST_PRTMAT(XXMAT(1,1),NATTOT,NSUP,LABEL,COMP,F)
            WRITE(6,'(/,21X,A)') ' ****** BETA  SPIN ****** '
            CALL DIST_PRTMAT(XXMAT(1,NSUP+1),NATTOT,NSDOWN,LABEL,
     *                                    COMP(NSUP+1),F(NSUP+1))
          ELSE
            CALL DIST_PRTMAT(XXMAT,NATTOT,NUMORB,LABEL,COMP,F)
          ENDIF
        ENDIF
        IF(TIVAN) THEN
C       ===============================================================
C       THE TVAN CASE IS NOT IMPLEMENTED YET. THE CODE EXITS ABOVE
C       ===============================================================       
C         Print Augmentation Charges
          WRITE(6,'(/,A,/)') 
     *          ' VANDERBILT AUGMENTATION CHARGES '
          WRITE(6,'(A,A)') '       ATOM        FULL BASIS    ATOM BASIS'
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
              WRITE(6,'(I4,4X,A,9X,F10.3,4X,F10.3)') 
     *           IAT,EL(IATYP(IS)),QA(IAT,4),QA(IAT,5)
            ENDDO
          ENDDO
        ENDIF
      ENDIF 
C     =================================================================
      IF (MPAN.AND.(CHUNK_NEW.GT.0)) THEN
C        Mulliken Population Analysis
         STR = 1
         DO INDEX1 = 1, NOLAN
C           ==========
C           LOCAL COPY
C           ==========
            IF (ME.EQ.(INDEX1-1) ) THEN
               DO INDEX4=1, NSTATE
                  CALL DCOPY(CHUNK_NEW,XXMAT(INDEX4,1),NATTOT,
     &                       Z_TEMP((INDEX4-1)*CHUNK_NEW+1),1)
               ENDDO
C              =====================
C              SCALE WITH OCCUPATION
C              =====================
               DO INDEX4=1, NSTATE
                  CALL DSCAL(CHUNK_NEW, F(INDEX4),
     &                       Z_TEMP((INDEX4-1)*CHUNK_NEW+1), 1)
               ENDDO
               DO INDEX2 = 1, NOLAN
                  SEND_CNT_E(INDEX2) = OLD_SEND_CNT_E(INDEX2)*CHUNK_NEW
               ENDDO
               SEND_DISPL_E(1) = 0
               DO INDEX2=2, SZ
                  SEND_DISPL_E(INDEX2) = SEND_DISPL_E(INDEX2-1) +
     &                          SEND_CNT_E(INDEX2-1)
               ENDDO
            ENDIF
C           =================
C           ARRAYS FOR GATHER
C           =================
            MSGLEN=NOLAN*8/IRAT
            CALL MY_BCAST(SEND_CNT_E(1), MSGLEN, INDEX1-1, LANGRP)
            CALL MY_BCAST(SEND_DISPL_E(1), MSGLEN, INDEX1-1, LANGRP)

C           =====================
C           BROADCAST  LOCAL COPY
C           =====================
            CALL MY_BCAST(Z_TEMP(1), 8*NSTATE*SEND_CNT(INDEX1),
     &                    INDEX1-1, LANGRP)
C           ===============================================
C           MULTIPLY WITH LOCAL PART OF EIGENVECTORS MATRIX
C           ===============================================
            CALL DGEMM("N","N", SEND_CNT(INDEX1), CHUNK_NEW,
     &                 NSTATE, 1D0, Z_TEMP(1),
     &                 SEND_CNT(INDEX1), XXMAT(1,1), NATTOT,
     &                 0D0, SMALL_XSMAT(1),
     &                 SEND_CNT(INDEX1) )

C           ===============================
C           GATHER BACK LOCAL PART OF XSMAT
C           ===============================
            CALL MY_SOURCE_CONCATV(SMALL_XSMAT(1),TEIG_VEC(1),
     &                             CHUNK_NEW*SEND_CNT(INDEX1),
     &                             SEND_CNT_E(1), SEND_DISPL_E(1),
     &                             INDEX1-1, LANGRP)
         ENDDO
         DO INDEX1=1, NATTOT
            CALL DCOPY(CHUNK_NEW, TEIG_VEC((INDEX1-1)*CHUNK_NEW+1),
     &                 1, XSMAT(INDEX1,1), NATTOT)
         ENDDO
         CALL AZZERO(SCR,NATTOT)
         CALL AZZERO(Z_TEMP,NATTOT)
         DO J=1,CHUNK_NEW
           DO I=1,NATTOT
             Z_TEMP(I)=Z_TEMP(I)+XSMAT(I,J)*XTMAT(I,J)
           ENDDO
         ENDDO
         CALL MY_COMBINE(Z_TEMP(1), SCR(1), 8*NATTOT, 1, LANGRP)
C        ==============================================================        
         IF (PARENT) THEN  
            IAT=0
            IAO=0
            DO IS=1,NSP
               NAO=NUMAOR(IS)
               DO IA=1,NA(IS)
                  IAT=IAT+1
C                 QA(.,4) is the true augmentation charge!
                  QA(IAT,1)=ZV(IS)-QA(IAT,4)
                  DO I=IAO+1,IAO+NAO
                     QA(IAT,1)=QA(IAT,1)-SCR(I)
                  ENDDO
                  IAO=IAO+NAO
               ENDDO
            ENDDO
         ENDIF
C        ==============================================================
C        Bond Orders
         CALL DCOPY(NATTOT*NORBX,XXMAT(1,1),1,SCR(1),1)
C         CALL DGEMM('N','N',NATTOT,NATTOT,NATTOT,1.0D0,XSMAT(1,1),
C     &               NATTOT,XTMAT(1,1),NATTOT,0.0D0,XXMAT(1,1),NATTOT)

C        =================================================================
         STR = 1
         DO INDEX1 = 1, NOLAN
C           ==========
C           LOCAL COPY
C           ==========
            IF (ME.EQ.(INDEX1-1) ) THEN
               DO INDEX4=1, NATTOT
                  CALL DCOPY(CHUNK_NEW,XSMAT(INDEX4,1),NATTOT,
     &                    Z_TEMP((INDEX4-1)*CHUNK_NEW+1),1)
               ENDDO
               DO INDEX2 = 1, NOLAN
                  SEND_CNT_E(INDEX2) = OLD_SEND_CNT_E(INDEX2)*CHUNK_NEW
               ENDDO
               SEND_DISPL_E(1) = 0
               DO INDEX2=2, SZ
                  SEND_DISPL_E(INDEX2) = SEND_DISPL_E(INDEX2-1) +
     &                          SEND_CNT_E(INDEX2-1)
               ENDDO
            ENDIF
C           =================
C           ARRAYS FOR GATHER
C           =================
            MSGLEN=NOLAN*8/IRAT
            CALL MY_BCAST(SEND_CNT_E(1), MSGLEN, INDEX1-1, LANGRP)
            CALL MY_BCAST(SEND_DISPL_E(1), MSGLEN, INDEX1-1, LANGRP)
C           =====================
C           BROADCAST  LOCAL COPY
C           =====================
            CALL MY_BCAST(Z_TEMP(1), 8*NATTOT*SEND_CNT(INDEX1),
     &                    INDEX1-1, LANGRP)
C           ===============================================
C           MULTIPLY WITH LOCAL PART OF EIGENVECTORS MATRIX
C           ===============================================
            CALL DGEMM("N","N", SEND_CNT(INDEX1), CHUNK_NEW,
     &                 NATTOT, 1D0, Z_TEMP(1),
     &                 SEND_CNT(INDEX1), XTMAT(1,1), NATTOT,
     &                 0D0, SMALL_XSMAT(1),
     &                 SEND_CNT(INDEX1) )
C           ===============================
C           GATHER BACK LOCAL PART OF XSMAT
C           ===============================
            CALL MY_SOURCE_CONCATV(SMALL_XSMAT(1),TEIG_VEC(1),
     &                             CHUNK_NEW*SEND_CNT(INDEX1),
     &                             SEND_CNT_E(1), SEND_DISPL_E(1),
     &                             INDEX1-1, LANGRP)
         ENDDO
C        ===============================================================
C        XXMAT HOLDS A CHUNK OF THE ROWS OF THE RESULT:
C        1ST COLUMN XXMAT(:,1) HOLDS THE FIRST ROW ETC
C        =============================================================== 
         DO INDEX1=1, NATTOT
            CALL DCOPY(CHUNK_NEW, TEIG_VEC((INDEX1-1)*CHUNK_NEW+1),
     &                 1, XXMAT(INDEX1, 1), NATTOT)
         ENDDO
C        ===============================================================
C        ==============================================================
C        OBSERVE THAT IN REALITY ONLY THE SUMS OF THE  ENTRIES ALONG 
C        THE COLUMNS OF ARRAY BAB ARE NEEDED.
C        WE ONLY STORE THESE.
C        ==============================================================
         CALL AZZERO(Z_TEMP,NATTOT*NORBX)
C        ==============================================================
C        FIRST WE NEED TO CALCULATE THE HADAMARD (SCALAR-ELEMENTWISE)
C        PRODUCT OF XXMAT WITH ITS TRANSPOSE
C        ============================================================== 
         STRC = 0
         DO INDEX1 = 1, NOLAN
C           ==========
C           LOCAL COPY
C           ==========
            IF (ME.EQ.(INDEX1-1) ) THEN
               DO INDEX4=1, CHUNK_NEW
                  CALL DCOPY(NATTOT,XXMAT(1,INDEX4),1,
     &                    Z_TEMP((INDEX4-1)*NATTOT+1),1)
               ENDDO

               DO INDEX2 = 1, NOLAN
                  SEND_CNT_E(INDEX2) = OLD_SEND_CNT_E(INDEX2)*CHUNK_NEW
               ENDDO
               SEND_DISPL_E(1) = 0
               DO INDEX2=2, SZ
                  SEND_DISPL_E(INDEX2) = SEND_DISPL_E(INDEX2-1) +
     &                          SEND_CNT_E(INDEX2-1)
               ENDDO
            ENDIF
C           =================
C           ARRAYS FOR GATHER
C           =================
            MSGLEN=NOLAN*8/IRAT
            CALL MY_BCAST(SEND_CNT_E(1), MSGLEN, INDEX1-1, LANGRP)
            CALL MY_BCAST(SEND_DISPL_E(1), MSGLEN, INDEX1-1, LANGRP)
C           =====================
C           BROADCAST  LOCAL COPY
C           =====================
            CALL MY_BCAST(Z_TEMP(1), 8*NATTOT*SEND_CNT(INDEX1),
     &                    INDEX1-1, LANGRP)
C           ===========================
C           ELEMENT-WISE MULTIPLICATION
C           ===========================
            STR  = 1
            STR1 = 1
            DO INDEX2=(INDEX1-1)*CHUNK_NEW+1, INDEX1*CHUNK_NEW
               DO INDEX4=1, SEND_CNT(INDEX1)
                  TEIG_VEC(STR+STRC) = XXMAT(INDEX2,INDEX4) * 
     &                                 Z_TEMP((STR1-1)*NATTOT+INDEX4+
     &                                 NWA12(ME,1)-1 )
                  STR = STR+1              
               ENDDO
               STR1 = STR1 + 1 
            ENDDO              
          
            STRC = STRC + CHUNK_NEW * SEND_CNT(INDEX1) 
         ENDDO    
         CALL AZZERO(Z_TEMP,NATTOT*NORBX)
         CALL AZZERO(EIG_VEC,NATTOT)
C        DETERMINE DISTRIBUTION OF BAB
         CHUNK_NEW_E = NAT/NOLAN
         DO INDEX1=1, NOLAN-1
            NDD(INDEX1-1,1) = CHUNK_NEW_E*(INDEX1-1)+1
            NDD(INDEX1-1,2) = CHUNK_NEW_E*INDEX1
         ENDDO
         NDD(NOLAN-1,1) = CHUNK_NEW_E*(NOLAN-1)+1
         NDD(NOLAN-1,2) = NAT
         CHUNK_BEGIN_E = ME*CHUNK_NEW_E+1
         CHUNK_END_E   = (ME+1)*CHUNK_NEW_E
         IF (ME.EQ.(NOLAN-1)) CHUNK_END_E = NAT
         IF (ME.EQ.(NOLAN-1)) CHUNK_NEW_E = NAT-(NOLAN-1)*CHUNK_NEW_E
         INDEX2=0
         DO INDEX1=1, NOLAN
           INDEX2 = MAX(INDEX2,NDD(INDEX1-1,2)-NDD(INDEX1-1,1)+1)
         ENDDO
         NORBX = INDEX2
C        ALLOCATE MEMORY
         CALL MEMORY(IP_BAB,NAT*INDEX2,'BAB')
         CALL AZZERO(BAB(1,1),NAT*NORBX)
         IF (PARENT) THEN
            CALL FILEOPEN(41,'BAB_tmp',FO_DEF+FO_UFO,FERROR)
         ENDIF
         CALL AZZERO(EIG_VEC,NAT)
         FLG = .FALSE.
         STR = 1
         IAT1=0
         IAO1=0
         START = 1 
         DO IS1=1,NSP
           NAO1=NUMAOR(IS1)
           DO IA1=1,NA(IS1)
             IAT1=IAT1+1
             DO I1=IAO1+1,IAO1+NAO1
               IAT2=0
               IAO2=0
               DO IS2=1,NSP
                 NAO2=NUMAOR(IS2)
                 DO IA2=1,NA(IS2)
                   IAT2=IAT2+1
                   IF(IAT2.LT.IAT1) THEN
                     DO I2=IAO2+1,IAO2+NAO2
                        IF ((I1.GE.NWA12(ME,1)).AND.
     &                       (I1.LE.NWA12(ME,2))) THEN

                           EIG_VEC(IAT2) = EIG_VEC(IAT2) +
     &                                TEIG_VEC(CHUNK_NEW*(I2-1)+STR)

                           FLG = .TRUE.
                           EIG_VEC(IAT1) = EIG_VEC(IAT1) + 
     &                                TEIG_VEC(CHUNK_NEW*(I2-1)+STR)

                           Z_TEMP(IAT2) = Z_TEMP(IAT2) +
     &                                TEIG_VEC(CHUNK_NEW*(I2-1)+STR)

                        ENDIF
                     ENDDO
                   ENDIF
                   IAO2=IAO2+NAO2
                 ENDDO
               ENDDO
               IF ((FLG).OR.(ME.EQ.0)) THEN 
                  STR = STR+1 
               ENDIF 
             ENDDO
             IAO1=IAO1+NAO1
             CALL MY_COMBINE(Z_TEMP(1), Z_TEMP(NAT+1), 8*NAT, 1, LANGRP)
             IF ((IAT1.GE.CHUNK_BEGIN_E).AND.(IAT1.LE.CHUNK_END_E)) THEN
                CALL DCOPY(NAT, Z_TEMP(NAT+1), 1, BAB(1,START), 1)
                START = START + 1
             ENDIF 
             CALL AZZERO(Z_TEMP(1),2*NAT) 
             CALL MY_SYNC(LANGRP) 
           ENDDO
         ENDDO
         CALL MY_COMBINE(EIG_VEC(1), QA(1,3), 8*NAT, 1, LANGRP)
         CALL SYMM_DA(BAB,Z_TEMP(1),Z_TEMP(NORBX*NORBX+1),
     &                NAT,NDD(0,1),NDD(0,2),
     &                NORBX,ME,NOLAN,LANGRP)
         CALL DSCAL(NAT*NORBX, 2D0, BAB(1,1), 1)
         IF (ME.EQ.0) THEN
           DO INDEX1=1, CHUNK_NEW_E
             DO INDEX2=1, NAT
               WRITE(41) BAB(INDEX2,INDEX1)
             ENDDO
           ENDDO
         ENDIF  
         DO INDEX1=2, NOLAN
            IF (ME.EQ.(INDEX1-1)) THEN
              CALL MY_BSEND(BAB(1,1),8*NAT*NORBX,0,1)
            ELSEIF (ME.EQ.0) THEN
              CALL MY_BRECV(Z_TEMP(1),8*NAT*NORBX,INDEX1-1,1,NBYTES)
              DO INDEX2=1, NAT*(NDD(INDEX1-1,2)-NDD(INDEX1-1,1)+1)
                 WRITE(41) Z_TEMP(INDEX2) 
              ENDDO
            ENDIF
            CALL MY_SYNC(LANGRP) 
         ENDDO  
         IF (PARENT) CALL FILECLOSE(41)
C        ==============================================================
C        Print Population Analysis
         IF (PARENT) THEN
            WRITE(6,'(/,A,/)') 
     *            ' POPULATION ANALYSIS FROM PROJECTED WAVEFUNCTIONS'
            WRITE(6,'(A)') 
     *      '      ATOM          MULLIKEN        LOWDIN       VALENCE'
            IAT=0
            DO IS=1,NSP
              DO IA=1,NA(IS)
                IAT=IAT+1
                WRITE(6,'(I4,4X,A,9X,F10.3,4X,F10.3,4X,F10.3)') 
     *           IAT,EL(IATYP(IS)),QA(IAT,1),QA(IAT,2),QA(IAT,3)
              ENDDO
            ENDDO
            QM=0.0D0
            QL=0.0D0
            DO I=1,NAT
              QM=QM+QA(I,1)
              QL=QL+QA(I,2)
            ENDDO
            WRITE(6,'(A,F10.3,4X,F10.3)') '  UNASSIGNED CHARGE',QM,QL
C           Print Bond Orders
            WRITE(6,'(/,A)') 
     *        ' MAYER BOND ORDERS FROM PROJECTED WAVEFUNCTIONS'
            IAT=0
            DO IS=1,NSP
              DO IA=1,NA(IS)
                IAT=IAT+1
                WRITE(LABEL(IAT),'(I4,1X,A2)') IAT,EL(IATYP(IS))
              ENDDO
            ENDDO
C           ===========================================================
C           OPEN AUXILLIARY FILE BAB_tmp THAT HOLDS BAB
C           ===========================================================
            MSWEEP=NAT/8
            IF(MOD(NAT,8).NE.0) MSWEEP=MSWEEP+1
            DO ISW=1,MSWEEP
              CALL FILEOPEN(41,'BAB_tmp',FO_DEF+FO_UFO,FERROR)
              I1=(ISW-1)*8+1
              I2=MIN(8*ISW,NAT)
              WRITE(6,'(/,9(A8))') '        ',(LABEL(II),II=I1,I2)
                 DO IA=1,NAT
                    DO INDEX1=1, I1-1
                      READ(41) Z_TEMP(1)
                    ENDDO
                    DO II=I1, I2 
                       READ(41) BAB(II,1)
                    ENDDO
                    WRITE(6,'(A8,8(F7.3,1X))') 
     &              LABEL(IA),(BAB(II,1),II=I1,I2)
                    DO INDEX1=I2+1, NAT
                       READ(41) Z_TEMP(1)
                    ENDDO  
                 ENDDO
              CALL FILECLOSE(41) 
            ENDDO
            WRITE(6,*)

C            CALL FILECLOSE(41)
         ENDIF
C        ==============================================================
      ENDIF
C     ==================================================================
C     END MULLIKEN POPULATION ANALYSIS
C     ==================================================================
        IF(DPAN) THEN
          CALL STOPGM('DIST_PROWFN','DAVIDSON NOT IMPLEMENTED ')
C         Davidson Population Analysis
          NUMIN=0
          DO IS=1,NSP
            NUMIN=NUMIN+NA(IS)*MAOS(IS)
            IF(NUMAOR(IS).LT.MAOS(IS)) THEN
              WRITE(6,'(A,I4)') 
     *          ' INCONSISTENT ATOMIC BASIS FOR SPECIES ',IS
              CALL STOPGM('DIST_PROWFN',' ')
            ENDIF
          ENDDO
C         Density Matrix
          DO I=1,NATTOT
            DO J=1,NATTOT
              XSMAT(I,J)=0.0D0
              DO K=1,NSTATE
                XSMAT(I,J)=XSMAT(I,J)+F(K)*XXMAT(I,K)*XXMAT(J,K)
              ENDDO
            ENDDO
          ENDDO
          UNAC=0.D0
          DO IAT=1,NAT
            UNAC=UNAC+QA(IAT,4)
          ENDDO
C         Calculate modified atomic orbitals
          CALL DCOPY(NATTOT*NATTOT,XTMAT(1,1),1,SMAT(1,1),1)
          CALL CMAOS(XSMAT,SMAT,NUMIN,UNAC,SCR,LSCR)
          UNAC=UNAC/DBLE(NAT)
C         Calculate shared atomic charges
          CALL SATCH(XSMAT,XTMAT,SMAT,NUMIN,BAB,SCR,LSCR)
C         Calculate 3-center shared atomic charges
          IF(NCEN.GE.3) CALL SATCH3(XSMAT,XTMAT,SMAT,NUMIN,
     *                              BAB,ABC,SCR,LSCR)
C         Calculate 4-center shared atomic charges
          IF(NCEN.GE.4) CALL SATCH4(XSMAT,XTMAT,SMAT,NUMIN,
     *                              BAB,ABC,ABCD,SCR,LSCR)
          IF(NCEN.GE.5)
     &         WRITE(6,*) NCEN,' CENTER TERMS NOT IMPLEMENTED '
C         Charges
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
C             QA(.,4) is the true augmentation charge!
              QA(IAT,1)=ZV(IS)-QA(IAT,4)-UNAC
            ENDDO
          ENDDO
          IAT3=0
          IAT4=0
          DO IA=1,NAT
            QA(IA,1)=QA(IA,1)-BAB(IA,IA)
            DO IB=IA+1,NAT
              QA(IA,1)=QA(IA,1)+BAB(IA,IB)/2.D0
              QA(IB,1)=QA(IB,1)+BAB(IA,IB)/2.D0
              IF(NCEN.GE.3) THEN
                DO IC=IB+1,NAT
                  IAT3=IAT3+1
                  QA(IA,1)=QA(IA,1)-ABC(IAT3)/3.D0
                  QA(IB,1)=QA(IB,1)-ABC(IAT3)/3.D0
                  QA(IC,1)=QA(IC,1)-ABC(IAT3)/3.D0
                  IF(NCEN.GE.4) THEN
                    DO ID=IC+1,NAT
                      IAT4=IAT4+1
                      QA(IA,1)=QA(IA,1)+ABCD(IAT4)/4.D0
                      QA(IB,1)=QA(IB,1)+ABCD(IAT4)/4.D0
                      QA(IC,1)=QA(IC,1)+ABCD(IAT4)/4.D0
                      QA(ID,1)=QA(ID,1)+ABCD(IAT4)/4.D0
                    ENDDO
                  ENDIF
                ENDDO
              ENDIF
            ENDDO
          ENDDO
C         Print Population Analysis
          WRITE(6,'(/,A,/)') 
     *          ' POPULATION ANALYSIS FROM PROJECTED WAVEFUNCTIONS'
          WRITE(6,'(A)') 
     *'       ATOM          DAVIDSON        LOWDIN       '
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
              WRITE(6,'(I4,4X,A,9X,F10.3,4X,F10.3)') 
     *         IAT,EL(IATYP(IS)),QA(IAT,1),QA(IAT,2)
            ENDDO
          ENDDO
          QM=0.0D0
          QL=0.0D0
          DO I=1,NAT
            QM=QM+QA(I,1)
            QL=QL+QA(I,2)
          ENDDO
          WRITE(6,'(A,F10.3,4X,F10.3)') '  UNASSIGNED CHARGE',QM,QL
C         Print Shared Electron Numbers
          WRITE(6,'(/,A)') 
     *      ' SHARED ELECTRON NUMBERS FROM PROJECTED WAVEFUNCTIONS'
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
              WRITE(LABEL(IAT),'(I4,1X,A2)') IAT,EL(IATYP(IS))
            ENDDO
          ENDDO
          MSWEEP=NAT/8
          IF(MOD(NAT,8).NE.0) MSWEEP=MSWEEP+1
          DO ISW=1,MSWEEP
            I1=(ISW-1)*8+1
            I2=MIN(8*ISW,NAT)
            WRITE(6,'(/,9(A8))') '        ',(LABEL(II),II=I1,I2)
            DO IA=1,NAT
              WRITE(6,'(A8,8(F7.3,1X))') LABEL(IA),(BAB(IA,II),II=I1,I2)
            ENDDO
          ENDDO
          WRITE(6,*)
C         Print 3-Center Shared Electron Numbers
          IF(NCEN.GE.3) THEN
            WRITE(6,'(/,A)') 
     * ' 3-CENTER SHARED ELECTRON NUMBERS FROM PROJECTED WAVEFUNCTIONS'
            WRITE(6,'(A,F10.4)') ' CUTOFF FOR PRINTING IS :',CUT3O
            IP=0
            ABCM=0.0D0
            IAT3=0
            DO I=1,NAT
              DO J=I+1,NAT
                DO K=J+1,NAT
                  IAT3=IAT3+1
                  IF(ABS(ABC(IAT3)).GT.ABCM) THEN
                    I3MAX=I+(J-1)*NAT+(K-1)*NAT*NAT
                    IAT3M=IAT3
                    ABCM=ABS(ABC(IAT3))
                  ENDIF
                  IF(ABC(IAT3).GT.CUT3O) THEN
                    IP=IP+1
                    WRITE(6,'(3A8,F10.4)') 
     *              LABEL(I),LABEL(J),LABEL(K),ABC(IAT3)
                  ENDIF
                ENDDO
              ENDDO
            ENDDO
            IF(IP.EQ.0.AND.ABCM.GT.0.D0) THEN
              IJK=I3MAX
              I = MOD(IJK-1,NAT)+1
              K = IJK/(NAT*NAT)+1
              J = (IJK-(K-1)*NAT*NAT)/NAT+1
              WRITE(6,'(3A8,F10.4)') 
     *             LABEL(I),LABEL(J),LABEL(K),ABC(IAT3M)
            ENDIF
          ENDIF
C         Print 4-Center Shared Electron Numbers
          IF(NCEN.GE.4) THEN
            WRITE(6,'(/,A)') 
     * ' 4-CENTER SHARED ELECTRON NUMBERS FROM PROJECTED WAVEFUNCTIONS'
            WRITE(6,'(A,F10.4)') ' CUTOFF FOR PRINTING IS :',CUT4O
            IP=0
            ABCM=0.0D0
            IAT4=0
            DO I=1,NAT
              DO J=I+1,NAT
                DO K=J+1,NAT
                  DO L=K+1,NAT
                    IAT4=IAT4+1
                    IF(ABS(ABCD(IAT4)).GT.ABCM) THEN
                      I4MAX=I+(J-1)*NAT+(K-1)*NAT*NAT+(L-1)*NAT*NAT*NAT
                      IAT4M=IAT4
                      ABCM=ABS(ABCD(IAT4))
                    ENDIF
                    IF(ABCD(IAT4).GT.CUT4O) THEN
                      IP=IP+1
                      WRITE(6,'(4A8,F10.4)') 
     *                LABEL(I),LABEL(J),LABEL(K),LABEL(L),ABCD(IAT4)
                    ENDIF
                  ENDDO
                ENDDO
              ENDDO
            ENDDO
            IF(IP.EQ.0.AND.ABCM.GT.0.0D0) THEN
              IJK=I4MAX
              I = MOD(IJK-1,NAT)+1
              K = IJK/(NAT*NAT)+1
              J = (IJK-(K-1)*NAT*NAT)/NAT+1
              L = (IJK-(K-1)*NAT*NAT-(J-1)*NAT*NAT*NAT)/NAT+1
              WRITE(6,'(4A8,F10.4)') 
     *             LABEL(I),LABEL(J),LABEL(K),LABEL(L),ABCD(IAT4M)
            ENDIF
          ENDIF
        ENDIF
C      ENDIF
3000  CONTINUE
C     Clean up the memory
      CALL FREEM(IP_COMP)
      CALL FREEM(IP_CATOM)
      CALL FREEM(IP_CSCR)
      CALL FREEM(IP_XSMAT)
      CALL FREEM(IP_XXMAT)
      CALL FREEM(IP_XTMAT)
      IF (CHUNK_NEW.NE.0) THEN
        CALL FREEM(IP_BAB)
      ENDIF
      CALL FREEM(IP_QA)
      CALL FREEM(IP_SCR)
      IF(TIVAN) THEN
        CALL FREEM(IP_FNL2)
      ENDIF
#endif
      CALL TIHALT('    DIST_PROWFN',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DIST_PRTMAT(XXMAT,NATTOT,NUMORB,LABEL,COMP,F)
C     CHANGED TO READ XXMAT DATA FROM FILE
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'fileopen.inc'
      INCLUDE 'ions.inc'
C     Arguments
      INTEGER   NATTOT,NUMORB
      REAL*8    XXMAT(NATTOT,*),COMP(*),F(*)
      CHARACTER LABEL(NATTOT)*15
C     Variables
      INTEGER MSWEEP,ISW,I1,I2,IA,II
C     NEW VARIABLES
      REAL*8  LXXMAT(NATTOT,*), TMP
      POINTER (IP_LXXMAT, LXXMAT)
      INTEGER LNATTOT, ferror, NUMAOR(NATTOT), IS, K, L
C     ==--------------------------------------------------------------==
#ifdef  PARALLEL 
      MSWEEP=NUMORB/8
      IF(MOD(NUMORB,8).NE.0) MSWEEP=MSWEEP+1
C     ALLOCATE LOCAL MEMORY
      CALL MEMORY(IP_LXXMAT,NATTOT*8,'LXXMAT')     
      DO ISW=1,MSWEEP
        CALL FILEOPEN(41,'WFNCOEF',FO_DEF+FO_UFO,FERROR)
        READ(41) LNATTOT,NSP,(ZV(IS),NA(IS),NUMAOR(IS),IS=1,NSP)
        I1=(ISW-1)*8+1
        I2=MIN(8*ISW,NUMORB)
C       LOAD XXMAT(*,I1:I2) PART FROM FILE TO LXXMAT
        DO K=1, NATTOT
           IS = 1 
           DO L=1, NUMORB
              READ(41) TMP
              IF ((L.GE.I1).AND.(L.LE.I2)) THEN 
                 LXXMAT(K,IS) = TMP
                 IS = IS +1
              ENDIF
           ENDDO
        ENDDO
        CALL FILECLOSE(41)
        WRITE(6,'(/,A,8(I5,3X))') '      ORBITAL  ',(II,II=I1,I2)
        WRITE(6,'(A,8(F7.3,1X))')
     *                     '  COMPLETNESS  ',(COMP(II),II=I1,I2)
        WRITE(6,'(A,8(F7.3,1X),/)')
     *                     '  OCCUPATION   ',(F(II),II=I1,I2)
C        DO IA=1,NATTOT
C          WRITE(6,'(A15,8(F7.3,1X))') LABEL(IA),
C     *                                   (XXMAT(IA,II),II=I1,I2)
        DO IA=1,NATTOT
          WRITE(6,'(A15,8(F7.3,1X))') LABEL(IA),
     *                                   (LXXMAT(IA,II),II=1,8)
        ENDDO
      ENDDO
C     FREE LOCAL MEMORY
      CALL FREEM(IP_LXXMAT)       
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
      SUBROUTINE GIVE_SCR_DIST_PROWFN(LPROWFN,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !pslo.inc
      INCLUDE 'ions.inc'        !NSP NA
      INCLUDE 'elct.inc'        !N number of states
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'atwf.inc'        !NATTOT
      INCLUDE 'prop.inc'        !DPAN NCEN MAOS
      INCLUDE 'prden.inc'       !NUMPR
C     Arguments
      INTEGER   LPROWFN
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LRNLSM,LSUMMAT,LCMAOS,LSATCH,LWFNRHO,
     &          NUMIN,IS
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      NSTATE=N
      LRNLSM=0
      LCMAOS=0
      LSATCH=0
      LWFNRHO=0
      LSUMMAT=0
C      CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NATTOT)
      IF(TIVAN) CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NATTOT,.FALSE.)
      IF(DPAN) THEN
       CALL STOPGM('DIST_PROWFN','DISTRIBUTED DAVIDSON NOT IMPLEMENTED')
C       Davidson Population Analysis
        NUMIN=0
        DO IS=1,NSP
          NUMIN=NUMIN+NA(IS)*MAOS(IS)
        ENDDO
        CALL GIVE_SCR_CMAOS(LCMAOS,TAG,NUMIN)
        CALL GIVE_SCR_SATCH(LSATCH,TAG,NUMIN)
      ENDIF
C     PROWFN
      LPROWFN=MAX(2*NATTOT+4*NATTOT,
     &            NATTOT*NUMORB,
     &            LRNLSM,LSUMMAT,LCMAOS,LSATCH,LWFNRHO)
C     ==--------------------------------------------------------------==
#endif
      RETURN
      END
C     ==================================================================
