C     =================================================================
      SUBROUTINE DQVAN2(IV,JV,IS,QRADA,YLM,GAGK,QG,DQG,SPLINE)
C     ==-------------------------------------------------------------==
C     ==  DERIVATIVE VERSION OF QVAN2                                ==
C     ==-------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'        !NAT
      INCLUDE 'nlps.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'aavan.inc'
C     Arguments
      INTEGER    IV,JV,IS
      REAL*8     QG(2,*),YLM(*),DQG(2,NHG,*),
     &           QRADA(NQDIM,NBRX,NBRX,LX,*),GAGK(NHG,*)
C     Variables
      DIMENSION  QRAD(NQDIM,NBRX,NBRX,LX,NSX),YLMB(NHG,LPMAX),
     &           GGNH(NSPLPO)
      REAL*8     SPLINE(*)
      COMPLEX*16 SIG
      REAL*8     VOL,SIGR,SIGI,CURV2,CURVD,SIGX
      INTEGER    ISUB,IVS,JVS,ISTEP,IVL,JVL,I,LP,L,IG,IS1,KK
C     ==-------------------------------------------------------------==
C     ==  IV  = 1..8    ! s_1 p_x1 p_z1 p_y1 s_2 p_x2 p_z2 p_y2      ==
C     ==  IVS = 1..4    ! s_1 s_2 p_1 p_2                            ==
C     ==  IVL = 1..4    ! s p_x p_z p_y                              ==
C     ==                                                             ==
C     == NOTE :   IV  = 1..8 (sppp sppp)                             ==
C     ==    IVS = 1..4 (sspp) OR 1..2 (sp)                           ==
C     ==    IVL = 1..4 (sppp)                                        ==
C     ==-------------------------------------------------------------==
      CALL TISET('    DQVAN2',ISUB)
C     ==-------------------------------------------------------------==
      VOL=1.D0/OMEGA
      IVS=INDV(IV,IS)
      JVS=INDV(JV,IS)
      ISTEP=NGH(IS)/NELEV(IS)
      IVL=1+MOD(IV-1,ISTEP)
      JVL=1+MOD(JV-1,ISTEP)
      IF(IVL.GT.NLX)  CALL STOPGM(' DQVAN2 ',' IVL.GT.NLX  ')
      IF(JVL.GT.NLX)  CALL STOPGM(' DQVAN2 ',' JVL.GT.NLX  ')
      IF(IVS.GT.NBRX) CALL STOPGM(' DQVAN2 ',' IVS.GT.NBRX ')
      IF(JVS.GT.NBRX) CALL STOPGM(' DQVAN2 ',' JVS.GT.NBRX ')
      CALL AZZERO(QG,2*NHG)
      CALL AZZERO(DQG,2*NHG*6)
      DO I=1,LPX(IVL,JVL)
        LP=LPL(IVL,JVL,I)
C     EXTRACTION OF ANGULAR MOMENTUM L FROM LP:
        IF (LP.GE.26) CALL STOPGM(' DQVAN2 ',' LP.GE.26 ')
        L=NINT(SQRT(DBLE(LP))+0.499999d0)
C         
        SIG=(0.D0,-1.D0)**(L-1)
        CALL YLMR2(LP,NHG,HG,GK,YLM)
        SIGR=DREAL(SIG)
        SIGI=DIMAG(SIG)
        IF(QSPLINE) THEN
!$OMP parallel do private(IG) shared(SPLINE)
          DO IG=1,NHG
            SPLINE(IG)=CURV2(HG(IG),NSPLPO,GGNH(1),
     *                       QRAD(1,IVS,JVS,L,IS),
     *                       QRAD(NSPLPO+1,IVS,JVS,L,IS),0.0d0)
          ENDDO
          IF(ABS(SIGR).GT.0.5D0) THEN
            SIGX=VOL*SIGR*AP(LP,IVL,JVL)
!$OMP parallel do private(IG) shared(QG)
            DO IG=1,NHG
              QG(1,IG)=QG(1,IG)+SIGX*YLMB(IG,LP)*SPLINE(IG)
            ENDDO
!$OMP parallel do private(IG) shared(SPLINE)
            DO IG=1,NHG
              SPLINE(IG)=-2.D0*HG(IG)*CURVD(HG(IG),NSPLPO,GGNH(1),
     *                         QRAD(1,IVS,JVS,L,IS),
     *                         QRAD(NSPLPO+1,IVS,JVS,L,IS),0.0d0)
            ENDDO
            IS1=1
            IF(GEQ0) IS1=2
!$OMP parallel do private(KK,IG) shared(DQG)
            DO KK=1,6
              DO IG=IS1,NHG
                DQG(1,IG,KK)=DQG(1,IG,KK)+SIGX*YLMB(IG,LP)*
     *            SPLINE(IG)*GAGK(IG,KK)/(HG(IG)*TPIBA2)
              ENDDO
            ENDDO         
          ELSE
            SIGX=VOL*SIGI*AP(LP,IVL,JVL)
!$OMP parallel do private(IG) shared(QG)
            DO IG=1,NHG
              QG(2,IG)=QG(2,IG)+SIGX*YLMB(IG,LP)*SPLINE(IG)
            ENDDO
!$OMP parallel do private(IG) shared(SPLINE)
            DO IG=1,NHG
              SPLINE(IG)=-2.D0*HG(IG)*CURVD(HG(IG),NSPLPO,GGNH(1),
     *                         QRAD(1,IVS,JVS,L,IS),
     *                         QRAD(NSPLPO+1,IVS,JVS,L,IS),0.0d0)
            ENDDO
            IS1=1
            IF(GEQ0) IS1=2
!$OMP parallel do private(KK,IG) shared(DQG)
            DO KK=1,6
              DO IG=IS1,NHG
                DQG(2,IG,KK)=DQG(2,IG,KK)+SIGX*YLMB(IG,LP)*
     *            SPLINE(IG)*GAGK(IG,KK)/(HG(IG)*TPIBA2)
              ENDDO
            ENDDO         
          ENDIF
!$OMP parallel do private(IG) shared(SPLINE)
          DO IG=1,NHG
            SPLINE(IG)=CURV2(HG(IG),NSPLPO,GGNH(1),
     *                       QRAD(1,IVS,JVS,L,IS),
     *                       QRAD(NSPLPO+1,IVS,JVS,L,IS),0.0d0)
          ENDDO
          IF(ABS(SIGR).GT.0.5D0) THEN
            SIGX=VOL*SIGR*AP(LP,IVL,JVL)
            DO KK=1,6
              CALL DYLMR(LP,GK,YLM,KK)
!$OMP parallel do private(IG) shared(DQG)
              DO IG=1,NHG
                DQG(1,IG,KK)=DQG(1,IG,KK)+SIGX*YLM(IG)*SPLINE(IG)
              ENDDO
            ENDDO         
          ELSE
            SIGX=VOL*SIGI*AP(LP,IVL,JVL)
            DO KK=1,6
              CALL DYLMR(LP,GK,YLM,KK)
!$OMP parallel do private(IG) shared(DQG)
              DO IG=1,NHG
                DQG(2,IG,KK)=DQG(2,IG,KK)+SIGX*YLM(IG)*SPLINE(IG)
              ENDDO
            ENDDO         
          ENDIF
        ELSE
          IF(ABS(SIGR).GT.0.5D0) THEN
            SIGX=VOL*SIGR*AP(LP,IVL,JVL)
!$OMP parallel do private(IG) shared(QG)
            DO IG=1,NHG
              QG(1,IG)=QG(1,IG)+SIGX*YLMB(IG,LP)*
     *                 QRAD(IGL(IG),IVS,JVS,L,IS)
            ENDDO
            IS1=1
            IF(GEQ0) IS1=2
!$OMP parallel do private(KK,IG) shared(DQG)
            DO KK=1,6
              DO IG=IS1,NHG
                DQG(1,IG,KK)=DQG(1,IG,KK)+SIGX*YLMB(IG,LP)*
     *            QRADA(IGL(IG),IVS,JVS,L,IS)*GAGK(IG,KK)/
     *                      (HG(IG)*TPIBA2)
              ENDDO
            ENDDO
          ELSE
            SIGX=VOL*SIGI*AP(LP,IVL,JVL)
!$OMP parallel do private(IG) shared(QG)
            DO IG=1,NHG
              QG(2,IG)=QG(2,IG)+SIGX*YLMB(IG,LP)*
     *                 QRAD(IGL(IG),IVS,JVS,L,IS)
            ENDDO
            IS1=1
            IF(GEQ0) IS1=2
!$OMP parallel do private(KK,IG) shared(DQG)
            DO KK=1,6
              DO IG=IS1,NHG
                DQG(2,IG,KK)=DQG(2,IG,KK)+SIGX*YLMB(IG,LP)*
     *            QRADA(IGL(IG),IVS,JVS,L,IS)*GAGK(IG,KK)/
     *                      (HG(IG)*TPIBA2)
              ENDDO
            ENDDO
          ENDIF
          IF(ABS(SIGR).GT.0.5D0) THEN
            SIGX=VOL*SIGR*AP(LP,IVL,JVL)
            DO KK=1,6
              CALL DYLMR(LP,GK,YLM,KK)
!$OMP parallel do private(IG) shared(DQG)
              DO IG=1,NHG
                DQG(1,IG,KK)=DQG(1,IG,KK)+SIGX*YLM(IG)*
     *                                    QRAD(IGL(IG),IVS,JVS,L,IS)
              ENDDO
            ENDDO
          ELSE
            SIGX=VOL*SIGI*AP(LP,IVL,JVL)
            DO KK=1,6
              CALL DYLMR(LP,GK,YLM,KK)
!$OMP parallel do private(IG) shared(DQG)
              DO IG=1,NHG
                DQG(2,IG,KK)=DQG(2,IG,KK)+SIGX*YLM(IG)*
     *                                    QRAD(IGL(IG),IVS,JVS,L,IS)
              ENDDO
            ENDDO
          ENDIF
        ENDIF
      ENDDO
      CALL TIHALT('    DQVAN2',ISUB)
C     ==-------------------------------------------------------------==
      RETURN
      END
C     =================================================================
