C     ==================================================================
C     == FOR TKPNT=.TRUE. FNL IS COMPLEX -- DRHOV_C WILL BE WRITTEN   ==
C     == NO CALL TO THIS ROUTINE                                      ==
C     ==================================================================
      SUBROUTINE DRHOV(NSTATE,QG,CTMP)
C     ==--------------------------------------------------------------==
C     ==    THIS ROUTINE CALCULATES THE DERIVATIVE VANDERBILT DENSITY ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'str2.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 QG(NHG),CTMP(NHG)
C     Variables
      DIMENSION  BECS(NAT,NHXS,6,*),
     &           QRADA(NQDIM,NBRX,NBRX,LX,NSP),
     *           F(NSTATE),DQG(NHG,6),
     &           EIGRB(NHG,NAT)
      REAL*8     SPLINE(*)
      POINTER    (IP_SPLINE,SPLINE)
      REAL*8     FNL(NAT,NHXS,NSTATE),DFNL(*)
      REAL*8     SUM,DSUM
      INTEGER    ISUB,ISA0,IS,IV,JV,IA,ISA,I,KK,IG,II,
     &           IFIRST
      SAVE       IFIRST,IP_SPLINE
      DATA       IFIRST /0/
C     ==--------------------------------------------------------------==
      CALL TISET('     DRHOV',ISUB)
C     ==--------------------------------------------------------------==
      IF(TFDIST) CALL STOPGM('DRHOV','TFDIST NOT IMPLEMENTED')
C     ==-------------------------------------------------------------==
C     ==  ALLOCATE MEMORY                                            ==
C     ==-------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN
        IFIRST=1
        CALL MEMORY(IP_SPLINE,NHG,'SPLINE')
        IF(PARENT) CALL PRMEM('     DRHOV')
      ENDIF
C     ==--------------------------------------------------------------==
#ifdef  _BGL 
      CALL AZZERO(DRHOVG,2*NHG*6)
#else
      CALL ZAZZERO(DRHOVG,NHG*6)
#endif
      ISA0=0
      DO IS=1,NSP
        IF(TVAN(IS)) THEN 
          DO IV=1,NGH(IS)
            DO JV=IV,NGH(IS)
              CALL DQVAN2(IV,JV,IS,QRADA,CTMP,GAGK,QG,DQG,SPLINE)
              IF(BIGMEM) THEN
                CALL ZAZZERO(CTMP,NHG)
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
                  SUM=0.0D0
                  DO I=1,NSTATE
                    SUM = SUM + F(I)*FNL(ISA,IV,I)*FNL(ISA,JV,I)
                  ENDDO
                  IF(IV.NE.JV) SUM=2.D0*SUM 
                  CALL DAXPY(2*NHG,SUM,EIGRB(1,ISA),1,CTMP(1),1)
                ENDDO
!$OMP parallel do private(KK,IG)
                DO KK=1,6
                  DO IG=1,NHG
                    DRHOVG(IG,KK)=DRHOVG(IG,KK)+DQG(IG,KK)*CTMP(IG)
                  ENDDO
                ENDDO
              ELSE
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
!$OMP parallel do private(IG)
#ifdef __SR8000
*poption parallel
#endif
                  DO IG=1,NHG
                    CTMP(IG)=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                      EI3(ISA,INYH(3,IG))
                  ENDDO
                  SUM=0.0D0
                  DO I=1,NSTATE
                    SUM = SUM + F(I)*FNL(ISA,IV,I)*FNL(ISA,JV,I)
                  ENDDO
                  IF(IV.NE.JV) SUM=2.D0*SUM 
!$OMP parallel do private(KK,IG)
                  DO KK=1,6
                    DO IG=1,NHG
                      DRHOVG(IG,KK)=DRHOVG(IG,KK)+QG(IG)*SUM*CTMP(IG)
                    ENDDO
                  ENDDO
                ENDDO
              ENDIF
              IF(BIGMEM) THEN
                DO KK=1,6
                  CALL ZAZZERO(CTMP,NHG)
                  DO IA=1,NA(IS)
                    ISA=ISA0+IA
                    DSUM=0.0D0
                    DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                      II=I-NST12(MEPOS,1)+1
                      DSUM=DSUM+F(I)*FNL(ISA,IV,I)*BECS(ISA,JV,KK,II)
     *                         +F(I)*BECS(ISA,IV,KK,II)*FNL(ISA,JV,I)
                    ENDDO
#ifdef PARALLEL
                    CALL GLOSUM(1,DSUM)
#endif
                    IF(IV.NE.JV) DSUM=2.D0*DSUM 
                    CALL DAXPY(2*NHG,DSUM,EIGRB(1,ISA),1,CTMP(1),1)
                  ENDDO
                  DO IG=1,NHG
                    DRHOVG(IG,KK)=DRHOVG(IG,KK)+QG(IG)*CTMP(IG)
                  ENDDO
                ENDDO
              ELSE
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
!$OMP parallel do private(IG)
#ifdef __SR8000
*poption parallel
#endif
                  DO IG=1,NHG
                    CTMP(IG)=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                      EI3(ISA,INYH(3,IG))
                  ENDDO
                  DO KK=1,6
                    DSUM=0.0D0
                    DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                      II=I-NST12(MEPOS,1)+1
                      DSUM=DSUM+F(I)*FNL(ISA,IV,I)*BECS(ISA,JV,KK,II)
     *                         +F(I)*BECS(ISA,IV,KK,II)*FNL(ISA,JV,I)
                    ENDDO
                    CALL GLOSUM(1,DSUM)
                    IF(IV.NE.JV) DSUM=2.D0*DSUM 
                    DO IG=1,NHG
                      DRHOVG(IG,KK)=DRHOVG(IG,KK)+QG(IG)*DSUM*CTMP(IG)
                    ENDDO
                  ENDDO
                ENDDO
              ENDIF
            ENDDO
          ENDDO
        ENDIF
        ISA0=ISA0+NA(IS)
      ENDDO
      CALL TIHALT('     DRHOV',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
