C     ==================================================================
      SUBROUTINE DUM2(TAU0,TSCR)
C     ==--------------------------------------------------------------==
C     == Put TAU0(3,NAX,NSX) coordinates of atoms into                ==
C     ==     TSCR(3,NAX*NSX)                                          ==
C     == Calculates Dummy atoms of type 2 and type 3                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSX),TSCR(3,NAX*NSX)
C     Variables
      REAL*8  X,Y,Z,CMX,CMY,CMZ,CMTOT
      INTEGER IAT,IS,IA,I,ID,ND,N,IMATM
      LOGICAL TMATCH
C     ==--------------------------------------------------------------==
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          TSCR(1,IAT)=TAU0(1,IA,IS)
          TSCR(2,IAT)=TAU0(2,IA,IS)
          TSCR(3,IAT)=TAU0(3,IA,IS)
        ENDDO
      ENDDO
      IF((NDAT2.GT.0).OR.(NDAT3.GT.0)) THEN
        DO I=1,NDAT
C     calculate dummy atoms of type 2
          IF(LISTDA(I,1).EQ.2) THEN
            ID=LISTDA(I,2)
            ND=LISTD2(1,ID)
            X=0.0D0
            Y=0.0D0
            Z=0.0D0
            IF (ND.LT.0) THEN
C     ND < 0 means all atoms (=IAT)
              ND=IAT
              DO N=1,ND
                X=X+TSCR(1,N)
                Y=Y+TSCR(2,N)
                Z=Z+TSCR(3,N)
              ENDDO
            ELSE
              DO N=1,ND
                X=X+TSCR(1,LISTD2(N+1,ID))
                Y=Y+TSCR(2,LISTD2(N+1,ID))
                Z=Z+TSCR(3,LISTD2(N+1,ID))
              ENDDO
            ENDIF
            DUMMY2(1,ID)=X/DBLE(ND)
            DUMMY2(2,ID)=Y/DBLE(ND)
            DUMMY2(3,ID)=Z/DBLE(ND)
C     calculate dummy atoms of type 3
          ELSE IF(LISTDA(I,1).EQ.3) THEN
            ID=LISTDA(I,2)
            ND=LISTD3(1,ID)
            X=0.0D0
            Y=0.0D0
            Z=0.0D0
            CMX=0.0D0
            CMY=0.0D0
            CMZ=0.0D0
            CMTOT=0.0D0
            IMATM=0
            DO IS=1,NSP
              DO IA=1,NA(IS)
                IMATM=IMATM+1
                TMATCH=.FALSE.
C     ND < 0 means all atoms (=IAT)
                IF(ND.LT.0) TMATCH=.TRUE.
                DO N=1,ND
                  IF(LISTD3(N+1,ID).EQ.IMATM) TMATCH=.TRUE.
                ENDDO
                IF(TMATCH) THEN
                  CMX=CMX+TAU0(1,IA,IS)*PMA0(IS)
                  CMY=CMY+TAU0(2,IA,IS)*PMA0(IS)
                  CMZ=CMZ+TAU0(3,IA,IS)*PMA0(IS)
                  CMTOT=CMTOT+PMA0(IS)
                ENDIF
              ENDDO
            ENDDO
            DUMMY3(1,ID)=CMX/CMTOT
            DUMMY3(2,ID)=CMY/CMTOT
            DUMMY3(3,ID)=CMZ/CMTOT
          ENDIF
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DUMPR
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cotr.inc'
      INCLUDE 'mm_dim.inc'
C     Variables
      INTEGER I,ITYP,ID,K
C     ==--------------------------------------------------------------==
      IF(NDAT.EQ.0) RETURN
      WRITE(6,'(/,25X,A)')' DUMMY ATOMS '
      WRITE(6,'(A)')' #DUM   INDEX                      POSITION (a.u.)'
      DO I=1,NDAT
        ITYP=LISTDA(I,1)
        ID=LISTDA(I,2)
        IF(ITYP.EQ.1) WRITE(6,'(I5,I8,A,3F15.5)') 
     *        I,NAT_grm(NATm+I),'  TYPE1',(DUMMY1(K,ID),K=1,3)
        IF(ITYP.EQ.2) WRITE(6,'(I5,I8,A,3F15.5)') 
     *        I,NAT_grm(NATm+I),'  TYPE2',(DUMMY2(K,ID),K=1,3)
        IF(ITYP.EQ.3) WRITE(6,'(I5,I8,A,3F15.5)') 
     *        I,NAT_grm(NATm+I),'  TYPE3',(DUMMY3(K,ID),K=1,3)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
