#ifdef __SR8000
*option MP(P(0)), LANGLVL(SAVE(0))
#endif
C     ==================================================================
      SUBROUTINE DYLMR(L,GK,DYLM,KK)
C     ==--------------------------------------------------------------==
C     REAL SPHERICAL HARMONICS,  L IS COMBINED INDEX FOR LM  (L=1,2...9)
C     ORDER:  S, P_X, P_Z, P_Y, D_XY, D_XZ, D_Z^2, D_YZ, D_X^2-Y^2
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'ions.inc'        !NSP
      INCLUDE 'strs.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER   L,KK
      REAL*8    GK(3,NHG),DYLM(NHG)
C     Variables
      REAL*8    X(3),
     &          HGG,R,R2,DIVCUT
      INTEGER   IS1,IG
      PARAMETER (DIVCUT = 1.0D-6)
      LOGICAL TWARNC
      SAVE TWARNC
      DATA TWARNC /.TRUE./
C     ==--------------------------------------------------------------==
      IS1=1
      IF(GEQ0.AND.L.GT.1) THEN
        HGG = SQRT(GK(1,1)*GK(1,1)+GK(2,1)*GK(2,1)+GK(3,1)*GK(3,1))
        IF(HGG.LT.DIVCUT) THEN
          IS1=2 
          DYLM(1)=0.0D0
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(L.EQ.1) THEN
        DO IG=1,NHG
          DYLM(IG) = 0.D0
        ENDDO
      ELSE IF(L.EQ.2) THEN
!$OMP parallel do private(IG,X,R,R2) shared(DYLM)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(X,R,R2)
!IBM*   ASSERT(ITERCNT(10000))
#endif
        DO IG=IS1,NHG
          X(1) = GK(1,IG)
          X(2) = GK(2,IG)
          X(3) = GK(3,IG)
          R = DMAX1(SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3)),DIVCUT)
          R2 = R*R*TPIBA2
          X(1) = X(1)/R                            
          X(2) = X(2)/R                            
          X(3) = X(3)/R                            
          DYLM(IG) = DSQRT(3.D0/FPI)*( X(1)*GAGK(IG,KK)/R2 - 
     -          X(ALPHA(KK))*DELTA(1,BETA(KK)) )
        ENDDO
      ELSE IF(L.EQ.3) THEN
!$OMP parallel do private(IG,X,R,R2) shared(DYLM)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(X,R,R2)
!IBM*   ASSERT(ITERCNT(10000))
#endif
        DO IG=IS1,NHG
          X(1) = GK(1,IG)
          X(2) = GK(2,IG)
          X(3) = GK(3,IG)
          R = DMAX1(SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3)),DIVCUT)
          R2 = R*R*TPIBA2
          X(1) = X(1)/R                            
          X(2) = X(2)/R                            
          X(3) = X(3)/R                            
          DYLM(IG) = DSQRT(3.D0/FPI)*( X(3)*GAGK(IG,KK)/R2 - 
     -          X(ALPHA(KK))*DELTA(3,BETA(KK)) )
        ENDDO
      ELSE IF(L.EQ.4) THEN
!$OMP parallel do private(IG,X,R,R2) shared(DYLM) 
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(X,R,R2)
!IBM*   ASSERT(ITERCNT(10000))
#endif
        DO IG=IS1,NHG
          X(1) = GK(1,IG)
          X(2) = GK(2,IG)
          X(3) = GK(3,IG)
          R = DMAX1(SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3)),DIVCUT)
          R2 = R*R*TPIBA2
          X(1) = X(1)/R                            
          X(2) = X(2)/R                            
          X(3) = X(3)/R                            
          DYLM(IG) = DSQRT(3.D0/FPI)*( X(2)*GAGK(IG,KK)/R2 - 
     -          X(ALPHA(KK))*DELTA(2,BETA(KK)) )
        ENDDO
      ELSE IF(L.EQ.5) THEN
!$OMP parallel do private(IG,X,R,R2) shared(DYLM)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(X,R,R2)
!IBM*   ASSERT(ITERCNT(10000))
#endif
        DO IG=IS1,NHG
          X(1) = GK(1,IG)
          X(2) = GK(2,IG)
          X(3) = GK(3,IG)
          R = DMAX1(SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3)),DIVCUT)
          R2 = R*R*TPIBA2
          X(1) = X(1)/R                            
          X(2) = X(2)/R                            
          X(3) = X(3)/R                            
          DYLM(IG) = DSQRT(15.D0/FPI)*( 2.D0*X(1)*X(2)*GAGK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(2)*DELTA(1,BETA(KK)) -
     -          X(ALPHA(KK))*X(1)*DELTA(2,BETA(KK)) )
        ENDDO
      ELSE IF(L.EQ.6) THEN
!$OMP parallel do private(IG,X,R,R2) shared(DYLM)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(X,R,R2)
!IBM*   ASSERT(ITERCNT(10000))
#endif
        DO IG=IS1,NHG
          X(1) = GK(1,IG)
          X(2) = GK(2,IG)
          X(3) = GK(3,IG)
          R = DMAX1(SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3)),DIVCUT)
          R2 = R*R*TPIBA2
          X(1) = X(1)/R                            
          X(2) = X(2)/R                            
          X(3) = X(3)/R                            
          DYLM(IG) = DSQRT(15.D0/FPI)*( 2.D0*X(1)*X(3)*GAGK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(3)*DELTA(1,BETA(KK)) -
     -          X(ALPHA(KK))*X(1)*DELTA(3,BETA(KK)) )
        ENDDO
      ELSE IF(L.EQ.7) THEN
!$OMP parallel do private(IG,X,R,R2) shared(DYLM)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(X,R,R2)
!IBM*   ASSERT(ITERCNT(10000))
#endif
        DO IG=IS1,NHG
          X(1) = GK(1,IG)
          X(2) = GK(2,IG)
          X(3) = GK(3,IG)
          R = DMAX1(SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3)),DIVCUT)
          R2 = R*R*TPIBA2
          X(1) = X(1)/R                            
          X(2) = X(2)/R                            
          X(3) = X(3)/R                            
          DYLM(IG) = 6.D0*DSQRT(5.D0/FPI/4.D0)*( X(3)*X(3)*
     -          GAGK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(3)*DELTA(3,BETA(KK)) )
        ENDDO
      ELSE IF(L.EQ.8) THEN
!$OMP parallel do private(IG,X,R,R2) shared(DYLM)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(X,R,R2)
!IBM*   ASSERT(ITERCNT(10000))
#endif
        DO IG=IS1,NHG
          X(1) = GK(1,IG)
          X(2) = GK(2,IG)
          X(3) = GK(3,IG)
          R = DMAX1(SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3)),DIVCUT)
          R2 = R*R*TPIBA2
          X(1) = X(1)/R                            
          X(2) = X(2)/R                            
          X(3) = X(3)/R                            
          DYLM(IG) = DSQRT(15.D0/FPI)*(2.D0*X(2)*X(3)*GAGK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(3)*DELTA(2,BETA(KK)) -
     -          X(ALPHA(KK))*X(2)*DELTA(3,BETA(KK)) )
        ENDDO
      ELSE IF(L.EQ.9) THEN
!$OMP parallel do private(IG,X,R,R2) shared(DYLM)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(X,R,R2)
!IBM*   ASSERT(ITERCNT(10000))
#endif
        DO IG=IS1,NHG
          X(1) = GK(1,IG)
          X(2) = GK(2,IG)
          X(3) = GK(3,IG)
          R = DMAX1(SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3)),DIVCUT)
          R2 = R*R*TPIBA2
          X(1) = X(1)/R                            
          X(2) = X(2)/R                            
          X(3) = X(3)/R                            
          DYLM(IG) = 2.D0*DSQRT(15.D0/FPI/4.D0)*( (X(1)*X(1)-X(2)*X(2))*
     *          GAGK(IG,KK)/R2 - X(ALPHA(KK))*X(1)*DELTA(1,BETA(KK)) +
     +                           X(ALPHA(KK))*X(2)*DELTA(2,BETA(KK)) )
        ENDDO
C
C     FIXME:
C     higher L values are not (yet) programmed. we try to work around it
C     by setting DYLM in those cases to zero. since this subroutine is 
C     only used for calculating the vanderbilt augmentation charge 
C     contribution to the stress tensor, it might be good enough to do
C     an approximate cell relaxation (the bulk of the contributions
C     will be from the lower L cases anyway).
C
C     <axel.kohlmeyer@theochem.ruhr-uni-bochum.de>, 12/2003
C
      ELSE
         IF (PARENT.AND.TWARNC) THEN
            TWARNC = .FALSE.
            WRITE(6,'(A,I2,A)') ' DYLMR| BIG FAT WARNING: L=',L,
     $           ' IS NOT SUPPORTED (MAX 9)'
            WRITE(6,'(A,A)') ' DYLMR| TRYING TO CONTINUE BY',
     $           ' SETTING DYLM() TO 0.0 FOR L>9'
            WRITE(6,'(A)') ' DYLMR| STRESS TENSOR WILL NOT BE ACCURATE'
         ENDIF
         DO IG=IS1,NHG
            DYLM(IG) = 0.0d0
         ENDDO
      END IF

      RETURN
      END
C     ==================================================================
      SUBROUTINE DBESS(XG,L,MMAX,R,DJL)
C     ==--------------------------------------------------------------==
C     CALCULATES DERIVATIVES OF SPHERICAL BESSEL FUNCTIONS  j_l(Gr)
C     WITH RESPECT TO h_alpha,beta (WITHOUT THE FACTOR GAGK(KK,IG)*HTM1)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   L,MMAX
      REAL*8    XG,R(*),DJL(*)
C     Variables
      REAL*8    EPS
      PARAMETER (EPS=1.D-8)
      REAL*8    XRG
      INTEGER   IR
C     ==--------------------------------------------------------------==
      IF(L.EQ.1) THEN                      !   S  PART
        IF(DABS(XG).LT.EPS) THEN
          CALL AZZERO(DJL,MMAX)
        ELSE
          DJL(1) = 0.D0
!$OMP parallel do private(IR,XRG) shared(DJL)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(XRG)
!IBM*   ASSERT(ITERCNT(10000))
#endif
          DO IR=2,MMAX
            XRG=R(IR)*XG
            DJL(IR) = DSIN(XRG)/XRG-DCOS(XRG)
          END DO
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(L.EQ.2) THEN                      !   P  PART
        IF(DABS(XG).LT.EPS) THEN
          CALL AZZERO(DJL,MMAX)
        ELSE
          DJL(1) = 0.D0
!$OMP parallel do private(IR,XRG) shared(DJL)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(XRG)
!IBM*   ASSERT(ITERCNT(10000))
#endif
          DO IR=2,MMAX
            XRG=R(IR)*XG
            DJL(IR) = 2.D0*(DSIN(XRG)/XRG-DCOS(XRG))/XRG - DSIN(XRG)
          END DO
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(L.EQ.3) THEN                      !   D  PART
        IF(DABS(XG).LT.EPS) THEN
          CALL AZZERO(DJL,MMAX)
        ELSE
          DJL(1) = 0.D0
!$OMP parallel do private(IR,XRG) shared(DJL)
#ifdef  _BGL 
!IBM*   INDEPENDENT, NEW(XRG)
!IBM*   ASSERT(ITERCNT(10000))
#endif
          DO IR=2,MMAX
            XRG=R(IR)*XG
            DJL(IR) = ( SIN(XRG)*(9.D0/(XRG*XRG)-4.D0) -
     -                9.D0*COS(XRG)/XRG ) /XRG + COS(XRG)
          END DO
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(L.LE.0 .OR. L.GE.4) THEN
        CALL STOPGM('DBESS',' L NOT PROGRAMMED  ')
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION DYLMRX(L,IG,GK,KK)
C     ==--------------------------------------------------------------==
C     REAL SPHERICAL HARMONICS,  L IS COMBINED INDEX FOR LM  (L=1,2...9)
C     ORDER:  S, P_X, P_Z, P_Y, D_XY, D_XZ, D_Z^2, D_YZ, D_X^2-Y^2
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG
      INCLUDE 'cnst.inc'
      INCLUDE 'ions.inc'        !NSP
      INCLUDE 'strs.inc'
      INCLUDE 'str2.inc'
C     Arguments
      INTEGER   L,IG,KK
      REAL*8    GK(3,NHG)
      REAL*8    DYLMRX
C     Variables
      REAL*8    X(3),R,R2
C     ==--------------------------------------------------------------==
      IF(L.GE.10) THEN
        CALL STOPGM('DYLMR',' L NOT PROGRAMMED  ')
      END IF
C     ==--------------------------------------------------------------==
      X(1) = GK(1,IG)
      X(2) = GK(2,IG)
      X(3) = GK(3,IG)
      R = SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3))
      IF(R.LT.1.D-6) THEN
         DYLMRX=0.0D0
         RETURN
      ENDIF
      R2 = R*R*TPIBA2
      X(1) = X(1)/R                            
      X(2) = X(2)/R                            
      X(3) = X(3)/R                            
C     ==--------------------------------------------------------------==
      IF(L.EQ.1) THEN
        DYLMRX = 0.D0
      ELSE IF(L.EQ.2) THEN
        DYLMRX = DSQRT(3.D0/FPI)*( X(1)*GAGK(IG,KK)/R2 - 
     -          X(ALPHA(KK))*DELTA(1,BETA(KK)) )
      ELSE IF(L.EQ.3) THEN
        DYLMRX = DSQRT(3.D0/FPI)*( X(3)*GAGK(IG,KK)/R2 - 
     -          X(ALPHA(KK))*DELTA(3,BETA(KK)) )
      ELSE IF(L.EQ.4) THEN
        DYLMRX = DSQRT(3.D0/FPI)*( X(2)*GAGK(IG,KK)/R2 - 
     -          X(ALPHA(KK))*DELTA(2,BETA(KK)) )
      ELSE IF(L.EQ.5) THEN
        DYLMRX = DSQRT(15.D0/FPI)*( 2.D0*X(1)*X(2)*GAGK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(2)*DELTA(1,BETA(KK)) -
     -          X(ALPHA(KK))*X(1)*DELTA(2,BETA(KK)) )
      ELSE IF(L.EQ.6) THEN
        DYLMRX = DSQRT(15.D0/FPI)*( 2.D0*X(1)*X(3)*GAGK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(3)*DELTA(1,BETA(KK)) -
     -          X(ALPHA(KK))*X(1)*DELTA(3,BETA(KK)) )
      ELSE IF(L.EQ.7) THEN
        DYLMRX = 6.D0*DSQRT(5.D0/FPI/4.D0)*( X(3)*X(3)*GAGK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(3)*DELTA(3,BETA(KK)) )
      ELSE IF(L.EQ.8) THEN
        DYLMRX = DSQRT(15.D0/FPI)*(2.D0*X(2)*X(3)*GAGK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(3)*DELTA(2,BETA(KK)) -
     -          X(ALPHA(KK))*X(2)*DELTA(3,BETA(KK)) )
      ELSE IF(L.EQ.9) THEN
        DYLMRX = 2.D0*DSQRT(15.D0/FPI/4.D0)*( (X(1)*X(1)-X(2)*X(2))*
     *          GAGK(IG,KK)/R2 - X(ALPHA(KK))*X(1)*DELTA(1,BETA(KK)) +
     +                           X(ALPHA(KK))*X(2)*DELTA(2,BETA(KK)) )
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION DYLMRKX(L,IG,GK,RK,GAGKK,KK,IPLUS)
C     ==--------------------------------------------------------------==
C     == REAL SPHERICAL HARMONICS,  L IS COMBINED INDEX FOR LM        ==
C     == (L=1,2...9) ORDER:                                           ==
C     == S, P_X, P_Z, P_Y, D_XY, D_XZ, D_Z^2, D_YZ, D_X^2-Y^2         ==
C     ==--------------------------------------------------------------==
C     == IG: components number in GK and GAGK array                   ==
C     == RK: k points components                                      ==
C     == KK: from 1 to 6                                              ==
C     == IPLUS: -1 or 1 (RK+GK) or (RK-GK)                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NKPTS
      INCLUDE 'cnst.inc'
      INCLUDE 'strs.inc'
C     Arguments
      INTEGER L,IG,KK,IPLUS
      REAL*8  GK(3,NGW),X(3),GAGKK(NGW,6),RK(3)
      REAL*8  DYLMRKX
C     Variables
      REAL*8 R,R2
C     ==--------------------------------------------------------------==
      IF(L.GE.10) THEN
        CALL STOPGM('DYLMKRX',' L NOT PROGRAMMED  ')
      END IF
      IF(IPLUS.EQ.1) THEN 
        X(1) = RK(1)+GK(1,IG)
        X(2) = RK(2)+GK(2,IG)
        X(3) = RK(3)+GK(3,IG)
      ELSEIF(IPLUS.EQ.-1) THEN 
        X(1) = RK(1)-GK(1,IG)
        X(2) = RK(2)-GK(2,IG)
        X(3) = RK(3)-GK(3,IG)
      ELSE
        CALL STOPGM(' DYLMRKX','IPLUS WRONG')
      ENDIF
      R = SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3))
      IF(R.LT.1.D-6) THEN
         DYLMRKX=0.0D0
         RETURN
      ENDIF
      R2 = R*R*TPIBA2
      X(1) = X(1)/R                            
      X(2) = X(2)/R                            
      X(3) = X(3)/R                            

      IF(L.EQ.1) THEN
        DYLMRKX = 0.D0
      ELSE IF(L.EQ.2) THEN
        DYLMRKX = DSQRT(3.D0/FPI)*( X(1)*GAGKK(IG,KK)/R2 - 
     -          X(ALPHA(KK))*DELTA(1,BETA(KK)) )
      ELSE IF(L.EQ.3) THEN
        DYLMRKX = DSQRT(3.D0/FPI)*( X(3)*GAGKK(IG,KK)/R2 - 
     -          X(ALPHA(KK))*DELTA(3,BETA(KK)) )
      ELSE IF(L.EQ.4) THEN
        DYLMRKX = DSQRT(3.D0/FPI)*( X(2)*GAGKK(IG,KK)/R2 - 
     -          X(ALPHA(KK))*DELTA(2,BETA(KK)) )
      ELSE IF(L.EQ.5) THEN
        DYLMRKX = DSQRT(15.D0/FPI)*( 2.D0*X(1)*X(2)*GAGKK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(2)*DELTA(1,BETA(KK)) -
     -          X(ALPHA(KK))*X(1)*DELTA(2,BETA(KK)) )
      ELSE IF(L.EQ.6) THEN
        DYLMRKX = DSQRT(15.D0/FPI)*( 2.D0*X(1)*X(3)*GAGKK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(3)*DELTA(1,BETA(KK)) -
     -          X(ALPHA(KK))*X(1)*DELTA(3,BETA(KK)) )
      ELSE IF(L.EQ.7) THEN
        DYLMRKX = 6.D0*DSQRT(5.D0/FPI/4.D0)*( X(3)*X(3)*GAGKK(IG,KK)/R2 
     -          - X(ALPHA(KK))*X(3)*DELTA(3,BETA(KK)) )
      ELSE IF(L.EQ.8) THEN
        DYLMRKX = DSQRT(15.D0/FPI)*(2.D0*X(2)*X(3)*GAGKK(IG,KK)/R2 -
     -          X(ALPHA(KK))*X(3)*DELTA(2,BETA(KK)) -
     -          X(ALPHA(KK))*X(2)*DELTA(3,BETA(KK)) )
      ELSE IF(L.EQ.9) THEN
        DYLMRKX = 2.D0*DSQRT(15.D0/FPI/4.D0)*( (X(1)*X(1)-X(2)*X(2))*
     *          GAGKK(IG,KK)/R2 - X(ALPHA(KK))*X(1)*DELTA(1,BETA(KK)) +
     +                           X(ALPHA(KK))*X(2)*DELTA(2,BETA(KK)) )
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==

