C     ==================================================================
      SUBROUTINE DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
C     ==--------------------------------------------------------------==
C     == INITIALIZATION OF STEPS FOR GEOMETRY OPTIMIZATION OR         ==
C     == MOLECULAR DYNAMICS (quantities inside tpar.inc)              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'clas.inc'
C     Arguments
      REAL*8  EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2
C     Variables
      INTEGER IS
C     ==================================================================
C     ==  BOUNDS FOR ELECTRONIC AND IONIC DYNAMICS                    ==
C     ==--------------------------------------------------------------==
      EKINCP=0.D0
      EKIN1=EKINW+TOLL
      EKIN2=EKINW-TOLL
      TEMP1=TEMPW+TOLP
      TEMP2=TEMPW-TOLP
      EKINH1=EKINHR+TOLC
      EKINH2=EKINHR-TOLC
C     ==================================================================
C     ==  TIME STEP FUNCTIONS                                         ==
C     ==--------------------------------------------------------------==
C     For electrons
      DT_ELEC=DELT_ELEC
      DT2_ELEC=DELT_ELEC*DELT_ELEC
      DT2BYE=DT2_ELEC/EMASS
      DT2HBE=0.5D0*DT2_ELEC/EMASS
      DTB2ME=DELT_ELEC/(2.0D0*EMASS)
C     For ions
      DT_IONS=DELT_IONS
      DT2_IONS=DELT_IONS*DELT_IONS
      DO IS=1,NSP
        DT2BYM(IS)=DT2_IONS/PMA(IS)
      ENDDO
      DO IS=1,NSP
        DTB2MI(IS)=DELT_IONS/(2.0D0*PMA(IS))
      ENDDO
C     ==--------------------------------------------------------------==
      IF(TCLAS) THEN
        DO IS=1,NCLTYP
          CSTEP(IS)=DELT_IONS/(2.0D0*CLMAS(IS)*SCMASS)
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
