C     ==================================================================
      subroutine ehrenfest(c0,c2,rhoe,psi,sc0,eigv,scr,lscr)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'elct.inc'
      include 'td_input.inc'
      include 'spin.inc'
      include 'efld.inc'
C     Arguments
      complex*16 c0(*),c2(*),psi(*),sc0(*),scr(*)
      real*8     rhoe(*),eigv(*)
      integer    lscr
C     Variables
      real*8     extf(*),effpot(*),mem_tintrvll
      integer    nstate,nzeros1,mem_nzeros,ispin,msglen
      logical    do_dipole,fexist
      pointer    (ip_effpot,effpot)
      integer    ifirst
      data       ifirst /0/
      save       ifirst
C     ==--------------------------------------------------------------==
      mem_tintrvll=tintrvll
      tt2=tintrvll/2.D0
      tt=tintrvll
C
      nstate=n
      ispin=nlsd
      call memory(ip_effpot,nnr1*ispin,'effpot')
      call azzero(effpot,nnr1*ispin)
      if (td_extpot) then
       if ((ifirst.eq.0).and.parent) then
        inquire(file='abstime.dat',exist=fexist)
        if (.not.fexist) then
         open(99,file='abstime.dat',status='unknown')
         if (parent) write(6,*) 'WARNING: time resetted to zero'
         ttime=0.0
        else
         open(99,file='abstime.dat',STATUS='OLD')
         read(99,*) ttime
        endif
        close(99)
        ifirst=1
       endif
       msglen = 1 * 8
       call my_bcast(ttime,msglen,source,allgrp)
      else
       ttime=0.D0
      endif
C 
      if (.not.ruku) then
        if (cheby) then
c        if (tpspec) then
c          do_dipole=.true.
c          call td_cheby(c0,c2,rhoe,psi,sc0,scr,lscr,
c    &          effpot,nstate,eigv,.false.,do_dipole)
c        elseif (tpdist) then
c          do_dipole=.false.
c          call td_cheby(c0,c2,rhoe,psi,sc0,scr,lscr,
c    &          effpot,nstate,eigv,.false.,do_dipole)
c        else
c          do_dipole=.false.
c          call td_cheby(c0,c2,rhoe,psi,sc0,scr,lscr,
c    &          effpot,nstate,eigv,.false.,do_dipole)
c        endif
        elseif (cayley) then
         if (tpspec) then
           do_dipole=.true.
           call td_cayley(c0,c2,rhoe,psi,sc0,scr,lscr,
     &          effpot,nstate,eigv,.false.,do_dipole)
         elseif (tpdist) then
           do_dipole=.false.
           call td_cayley(c0,c2,rhoe,psi,sc0,scr,lscr,
     &          effpot,nstate,eigv,.false.,do_dipole)
         else
           do_dipole=.false.
           call td_cayley(c0,c2,rhoe,psi,sc0,scr,lscr,
     &          effpot,nstate,eigv,.false.,do_dipole)
         endif
        else
         if (parent) write(6,*) 'choose an integration method'
         stop
        endif
      else
        if (cheby) then
c        call dcopy(2*ngwk*nstate,c0(1),1,c2,1) 
c        if (parent) write(6,'(/,1X,A)') 'FIRST RUNGE-KUTTA STEP'
c        n_cycles=1
c        tintrvll=tt2
c        if (tpspec) then
c          do_dipole=.true.
c          call td_cheby(c0,c2,rhoe,psi,sc0,scr,lscr,
c    &          effpot,nstate,eigv,.true.,do_dipole)
c        elseif (tpdist) then
c          do_dipole=.false.
c          call td_cheby(c0,c2,rhoe,psi,sc0,scr,lscr,
c    &          effpot,nstate,eigv,.true.,do_dipole)
c        else
c          do_dipole=.false.
c          call td_cheby(c0,c2,rhoe,psi,sc0,scr,lscr,
c    &          effpot,nstate,eigv,.true.,do_dipole)
c        endif
c        call dcopy(2*ngwk*nstate,c2(1),1,c0(1),1)
c        n_cycles=1
c        nzeros=2*nzeros
c        if (parent) write(6,'(/,1X,A)') 'SECOND RUNGE-KUTTA STEP'
c        tintrvll=tt
c        if (tpspec) then
c          do_dipole=.true.
c          call td_cheby(c0,c2,rhoe,psi,sc0,scr,lscr,
c    &          effpot,nstate,eigv,.false.,do_dipole)
c        elseif (tpdist) then
c          do_dipole=.false.
c          call td_cheby(c0,c2,rhoe,psi,sc0,scr,lscr,
c    &          effpot,nstate,eigv,.false.,do_dipole)
c        else
c          do_dipole=.false.
c          call td_cheby(c0,c2,rhoe,psi,sc0,scr,lscr,
c    &          effpot,nstate,eigv,.false.,do_dipole)
c        endif
c        if (parent.and.td_extpot) write(6,'(A,F10.3)')
c    &   ' New total propagation time ',ttime
c        nzeros=nzeros/2
        elseif (cayley) then
         tintrvll=tt2
         call dcopy(2*ngwk*nstate,c0(1),1,c2,1)
         if (parent) write(6,'(/,A)') ' FIRST RUNGE_KUTTA STEP'
         n_cycles=1
         do_dipole=.true.
         call td_cayley(c0,c2,rhoe,psi,sc0,scr,lscr,
     &        effpot,nstate,eigv,.true.,do_dipole)
         call dcopy(2*ngwk*nstate,c2(1),1,c0(1),1)
         tintrvll=tt
         if (parent) write(6,'(/,A)') ' SECOND RUNGE_KUTTA STEP'
         n_cycles=1
         do_dipole=.true.
         call td_cayley(c0,c2,rhoe,psi,sc0,scr,lscr,
     &        effpot,nstate,eigv,.false.,do_dipole)
         if (parent.and.td_extpot) write(6,'(A,F10.3)')
     &   ' New total propagation time ',ttime
        else
         if (parent) write(6,*) 'choose an integration method'
         stop
        endif
      endif
C
C     ttime=ttime+tt
      tintrvll=mem_tintrvll
      if (parent.and.td_extpot) then
        open(99,file='abstime.dat',STATUS='OLD')
        rewind(99)
        write(99,*) ttime
      endif
C
      call freem(ip_effpot)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================

