C     ==================================================================
      SUBROUTINE EICALC(EIVPS,EIROP)
C     ==--------------------------------------------------------------==
C     == EIVPS : phase factor times local pseudopotential  (VPS)      ==
C     == EIROP : phase factor times Gaussian charge distributions     ==
C     ==         which replaced ionic point charges (RHOPS)           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'sfac.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cppt.inc'
C     Arguments
      COMPLEX*16 EIVPS(NHG),EIROP(NHG)
C     Variables
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 EI123
      REAL*8     FNL(*),DFNL(*)
      REAL*8     ER,EI
      INTEGER    ISUB,IG,ISA,IS,IA
C     ==--------------------------------------------------------------==
      CALL TISET('    EICALC',ISUB)
#if defined(__VECTOR) || defined(__SR11KIBM)
#ifdef __CRAYX1
      CALL ZAZZERO(EIVPS,NHG)
      CALL ZAZZERO(EIROP,NHG)
      IF(BIGMEM) THEN
!$OMP parallel do private(IG,ISA,IS)
        DO IG=1,NHG
          DO ISA = 1, NAT
            IS=IATPT(2,ISA)
            EIVPS(IG)=EIVPS(IG)+VPS(IS,IG)*EIGRB(IG,ISA)
            EIROP(IG)=EIROP(IG)+RHOPS(IS,IG)*EIGRB(IG,ISA)
          ENDDO
        ENDDO
      ELSE
!$OMP parallel do private(IG,ISA,IS,EI123,ER,EI)
!dir$ preferstream
!dir$ nointerchange 
        DO IG=1,NHG
!dir$ prefervector
          DO ISA = 1, NAT
            IS=IATPT(2,ISA)
            EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *            EI3(ISA,INYH(3,IG))
            ER=DREAL(EI123)
            EI=DIMAG(EI123)
            EIVPS(IG)=EIVPS(IG)+DCMPLX(ER*VPS(IS,IG),EI*VPS(IS,IG))
            EIROP(IG)=EIROP(IG)+
     *                DCMPLX(ER*RHOPS(IS,IG),EI*RHOPS(IS,IG))
          ENDDO
        ENDDO
      ENDIF
#elif defined __NEC
      CALL ZAZZERO(EIVPS,NHG)
      CALL ZAZZERO(EIROP,NHG)
      IF(BIGMEM) THEN
!$OMP parallel do private(IG,ISA,IS)
        DO IG=1,NHG
          DO ISA = 1, NAT
            IS=IATPT(2,ISA)
            EIVPS(IG)=EIVPS(IG)+VPS(IS,IG)*EIGRB(IG,ISA)
            EIROP(IG)=EIROP(IG)+RHOPS(IS,IG)*EIGRB(IG,ISA)
          ENDDO
        ENDDO
      ELSE
!$OMP parallel do private(IG,ISA,IS,EI123,ER,EI)
        DO IG=1,NHG
          DO ISA = 1, NAT
            IS=IATPT(2,ISA)
            EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *            EI3(ISA,INYH(3,IG))
            ER=DREAL(EI123)
            EI=DIMAG(EI123)
            EIVPS(IG)=EIVPS(IG)+DCMPLX(ER*VPS(IS,IG),EI*VPS(IS,IG))
            EIROP(IG)=EIROP(IG)+
     *                DCMPLX(ER*RHOPS(IS,IG),EI*RHOPS(IS,IG))
          ENDDO
        ENDDO
      ENDIF
#elif defined(_vpp_)
      CALL ZAZZERO(EIVPS,NHG)
      CALL ZAZZERO(EIROP,NHG)
      IF(BIGMEM) THEN
        DO IG=1,NHG
          DO ISA=1,NAT
            IS=IATPT(2,ISA)
            EIVPS(IG)=EIVPS(IG)+VPS(IS,IG)*EIGRB(IG,ISA)
            EIROP(IG)=EIROP(IG)+RHOPS(IS,IG)*EIGRB(IG,ISA)
          ENDDO
        ENDDO
      ELSE
        DO IG=1,NHG
          DO ISA=1,NAT
            IS=IATPT(2,ISA)
            EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *            EI3(ISA,INYH(3,IG))
            EIVPS(IG)=EIVPS(IG)+VPS(IS,IG)*EI123
            EIROP(IG)=EIROP(IG)+RHOPS(IS,IG)*EI123
          ENDDO
        ENDDO
      ENDIF
#else
      CALL ZAZZERO(EIVPS,NHG)
      CALL ZAZZERO(EIROP,NHG)
      IF(BIGMEM) THEN
!$OMP parallel do private(IG,IS,IA,ISA)
#ifdef __SR8000
*poption parallel
*voption indep(RHOPS,EIGRB,VPS,EIROP,EIVPS)
#endif
        DO IG=1,NHG
          DO ISA=1,NAT
            IA=IATPT(1,ISA)
            IS=IATPT(2,ISA)
            EIVPS(IG)=EIVPS(IG)+VPS(IS,IG)*EIGRB(IG,ISA)
            EIROP(IG)=EIROP(IG)+RHOPS(IS,IG)*EIGRB(IG,ISA)
          ENDDO
        ENDDO
      ELSE
!$OMP parallel do private(IG,IS,IA,ISA,EI123,ER,EI)
#ifdef __SR8000
*poption parallel
*voption indep(EI3,EI2,EI1,INYH,RHOPS,VPS,EIROP,EIVPS)
#endif
        DO IG=1,NHG
          DO ISA=1,NAT
            IA=IATPT(1,ISA)
            IS=IATPT(2,ISA)
            EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *          EI3(ISA,INYH(3,IG))
            ER=DREAL(EI123)
            EI=DIMAG(EI123)
            EIVPS(IG)=EIVPS(IG)+DCMPLX(ER*VPS(IS,IG),EI*VPS(IS,IG))
            EIROP(IG)=EIROP(IG)+
     *          DCMPLX(ER*RHOPS(IS,IG),EI*RHOPS(IS,IG))
          ENDDO
        ENDDO
      ENDIF
#endif
#else
#ifdef  _BGL 
      CALL AZZERO(EIVPS,2*NHG)
      CALL AZZERO(EIROP,2*NHG)
#else
      CALL ZAZZERO(EIVPS,NHG)
      CALL ZAZZERO(EIROP,NHG)
#endif
      IF(BIGMEM) THEN
C$OMP parallel do private(IG,IS,IA,ISA) shared(EIVPS,EIROP)
#ifdef  _BGL 
!IBM*  ASSERT (ITERCNT(10000))
!IBM*  INDEPENDENT
#endif
        DO IG=1,NHG
          DO ISA=1,NAT
            IA=IATPT(1,ISA)
            IS=IATPT(2,ISA)
            EIVPS(IG)=EIVPS(IG)+VPS(IS,IG)*EIGRB(IG,ISA)
            EIROP(IG)=EIROP(IG)+RHOPS(IS,IG)*EIGRB(IG,ISA)
          ENDDO
        ENDDO
      ELSE
C$OMP parallel do private(IG,ISA,IA,IS,ER,EI,EI123) shared(EIVPS,EIROP)
#ifdef  _BGL 
!IBM*  ASSERT (ITERCNT(10000))
!IBM*  INDEPENDENT
#endif
        DO IG=1,NHG
          DO ISA=1,NAT
            IA=IATPT(1,ISA)
            IS=IATPT(2,ISA)
            EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *          EI3(ISA,INYH(3,IG))
            ER=DREAL(EI123)
            EI=DIMAG(EI123)
            EIVPS(IG)=EIVPS(IG)+DCMPLX(ER*VPS(IS,IG),EI*VPS(IS,IG))
            EIROP(IG)=EIROP(IG)+
     *                  DCMPLX(ER*RHOPS(IS,IG),EI*RHOPS(IS,IG))
          ENDDO
        ENDDO
      ENDIF
#endif
      CALL TIHALT('    EICALC',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE EICALC1(K,IS,ISA,EIVPS1,EIROP1)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'sfac.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cppt.inc'
C     Arguments
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 EI123
      REAL*8     FNL(*),DFNL(*)
      REAL*8     ER,EI
      INTEGER    ISA,IS,IA

      COMPLEX*16 EIVPS1(NHG),EIROP1(NHG)
C     Variables
      COMPLEX*16 G
      INTEGER    IG,ISUB,K
C     ==--------------------------------------------------------------==
      CALL TISET('   EICALC1',ISUB)
      IF(BIGMEM) THEN
!$OMP parallel do private(IG,G)
#ifdef  _BGL 
!IBM*  ASSERT (ITERCNT(10000))
!IBM*  INDEPENDENT, NEW(G)
#endif
        DO IG=1,NHG
          G=DCMPLX(0.D0,-GK(K,IG))*TPIBA*EIGRB(IG,ISA)
          EIVPS1(IG)=VPS(IS,IG)*G
          EIROP1(IG)=RHOPS(IS,IG)*G
        ENDDO
      ELSE
!$OMP parallel do private(IG,G,EI123,ER,EI)
#ifdef  _BGL 
!IBM*  ASSERT (ITERCNT(10000))
!IBM*  INDEPENDENT, NEW(G,EI123,ER,EI)
#endif
        DO IG=1,NHG
          G=DCMPLX(0.D0,-GK(K,IG))*TPIBA
          EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *          EI3(ISA,INYH(3,IG))
          ER=DREAL(EI123)
          EI=DIMAG(EI123)
          EIVPS1(IG)=DCMPLX(ER*VPS(IS,IG),EI*VPS(IS,IG))*G
          EIROP1(IG)=DCMPLX(ER*RHOPS(IS,IG),EI*RHOPS(IS,IG))*G
        ENDDO
      ENDIF
      CALL TIHALT('   EICALC1',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
