C     ==================================================================
      SUBROUTINE EIND_II(TAU0,IS,IA,KA,EIND,IESR)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == CONTRIBUTION OF ESR TO THE SECOND ORDER ENERGY               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'metr.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSP),EIND
      INTEGER IESR,IS,IA,KA
C     Variables
      REAL*8    ARGMAX          !DERFC(ARG) and DEXP(-ARG*ARG) underflow
      PARAMETER (ARGMAX=20.D0)
      LOGICAL TZERO
      REAL*8  RXLM(3),EARG,AARG,DSPI,
     &        ZV2,RCKJ,YLM,ZLM,ERRE2,RLM,ARG,ESRTZERO,XLM,DFD,DSD
      INTEGER ISUB,K,J,L,M,IX,IY,IZ,ISHFT
#ifdef __DERF
      REAL*8    DERFC
      EXTERNAL  DERFC
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   EIND_II',ISUB)
      DSPI=DSQRT(PI)
      IF(PARENT) THEN
        K=IS
        DO J=1,NSP
          ZV2=ZV(K)*ZV(J)
          RCKJ=DSQRT(RAGGIO(K)*RAGGIO(K)+RAGGIO(J)*RAGGIO(J))
          L=IA
          DO M=1,NA(J)
            IF(L.EQ.M.AND.K.EQ.J) THEN
              XLM=0.D0
              YLM=0.D0
              ZLM=0.D0
              TZERO=.TRUE.
            ELSE
              TZERO=.FALSE.
              XLM=TAU0(1,L,K)-TAU0(1,M,J)
              YLM=TAU0(2,L,K)-TAU0(2,M,J)
              ZLM=TAU0(3,L,K)-TAU0(3,M,J)
              CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
            ENDIF
            DO IX=-IESR,IESR
              DO IY=-IESR,IESR
                DO IZ=-IESR,IESR
                  ISHFT=IX*IX+IY*IY+IZ*IZ
                  IF(.NOT.(TZERO.AND.ISHFT.EQ.0)) THEN
                   RXLM(1)=XLM+IX*HT(1,1)+IY*HT(2,1)+IZ*HT(3,1)
                   RXLM(2)=YLM+IX*HT(1,2)+IY*HT(2,2)+IZ*HT(3,2)
                   RXLM(3)=ZLM+IX*HT(1,3)+IY*HT(2,3)+IZ*HT(3,3)
                   ERRE2=RXLM(1)**2+RXLM(2)**2+RXLM(3)**2
                   RLM=DSQRT(ERRE2)
                   ARG=RLM/RCKJ
                   IF(ARG.LE.ARGMAX) THEN !ADDESR,ADDPRE /= 0
                     IF(TZERO) THEN
                       ESRTZERO=0.5D0*2.D0*ZV2/ERRE2
                     ELSE
                       ESRTZERO=1.D0*2.D0*ZV2/ERRE2
                     END IF
                     EARG=DERFC(ARG)/(2.D0*RLM)
                     AARG=DEXP(-ARG*ARG)/(DSPI*RCKJ)
                     DFD=-ESRTZERO*(EARG + AARG)
                     DSD=ESRTZERO*2.D0*(3.D0*EARG/(2.D0*ERRE2)+
     *                       AARG*(1.5D0/ERRE2+1.D0/(RCKJ*RCKJ)))
                     EIND=EIND+DFD+DSD*RXLM(KA)*RXLM(KA)
                   ENDIF
                 ENDIF
                 ENDDO  !ixc
               ENDDO    !iyc
            ENDDO       !izc
          ENDDO
        ENDDO
      ENDIF
      CALL TIHALT('   EIND_II',ISUB)
C     ==================================================================
      RETURN
      END
C     ==================================================================
