C     ==================================================================
      SUBROUTINE EIND_LOC(EIND,IS,ISA,KA,RHOO,V,EIROP)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == LOCAL CONTRIBUTION TO THE SECOND ORDER ENERGY (CONSTANT PART)==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      REAL*8     EIND,RHOO(NNR1)
      COMPLEX*16 V(*),EIROP(NHG)
      INTEGER    IS,ISA,KA
C     Variables
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 RHET,RHETS,VCGS,EI123,TTT
      REAL*8     FNL(*),DFNL(*),GKA,TA,OMTP
      INTEGER    IG1,IG,IR
C     ==--------------------------------------------------------------==
C     TRANSFORM THE DENSITY TO G SPACE
!$OMP parallel do private(IR)
      DO IR=1,NNR1
        V(IR)=DCMPLX(RHOO(IR),0.D0)
      ENDDO
      CALL FWFFT(V)
C
      OMTP=2.D0*OMEGA*TPIBA2
      IG1=1
      IF(GEQ0) IG1=2
      IF(BIGMEM) THEN  ! do not break the loop for good vectorzation 
        DO IG=IG1,NHG
          RHET=V(NZH(IG))
          RHETS=DCONJG(RHET)
          GKA=GK(KA,IG)
          EI123=EIGRB(IG,ISA)
          VCGS=SCG(IG)*DCONJG(RHET+EIROP(IG)+RHOPS(IS,IG)*EI123)
          TTT=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)
          TA=-DREAL(EI123*TTT)*OMTP
          EIND=EIND+TA*GKA*GKA
        ENDDO
      ELSE
        DO IG=IG1,NHG
          RHET=V(NZH(IG))
          RHETS=DCONJG(RHET)
          GKA=GK(KA,IG)
          EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *              EI3(ISA,INYH(3,IG))
          VCGS=SCG(IG)*DCONJG(RHET+EIROP(IG)+RHOPS(IS,IG)*EI123)
          TTT=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)
          TA=-DREAL(EI123*TTT)*OMTP
          EIND=EIND+TA*GKA*GKA
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
