C     ==================================================================
      SUBROUTINE EIND_NL(EIND,IS,ISA,KA,NSTATE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == THE NON-LOCAL POTENTIAL CONTRIBUTION TO THE DYNAMICAL MATRIX ==
C     == THERE ARE ONLY DIAGONAL CONTRIBUTIONS                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'        !NLM
      INCLUDE 'elct.inc'        !NLM
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      INTEGER NSTATE,IS,ISA,KA
      REAL*8  EIND
C     Variables
      DIMENSION FNL2(NAT,NHXS,LDF2),F(NSTATE),DDFNL(NAT,NHXS,6,NDFNL)
      REAL*8  DFNL(NAT,NHXS,3,NDFNL),FNL(LDF1,NHXS,NSTATE),
     &        WEIGHT,TEMP,TT
      INTEGER IV,JV,I,II,L,KI,LI,L2,LJ,KJ,J,KK
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      IF (KA.EQ.1) THEN
        KK = 1
      ELSEIF (KA.EQ.2) THEN
        KK = 4
      ELSE
        KK = 6
      ENDIF
      IF(TVAN(IS)) THEN
C..Vanderbild pp
        CALL STOPGM('SD_NL2','VDB PP NOT IMPLEMENTED')
      ELSEIF(TSGP(IS)) THEN
C..Stefan Goedecker pp
        DO IV=1,NGH(IS)
          L=NGHTOL(IV,IS)+1
          KI=LFVAL(IV,IS)
          LI=LPVAL(IV,IS)
          DO JV=1,NGH(IS)
            L2=NGHTOL(JV,IS)+1
            LJ=LPVAL(JV,IS)
            IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
              KJ=LFVAL(JV,IS)
              DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                TT=2.0D0*F(I)*HLSG(KI,KJ,L,IS)
                II=I-NST12(MEPOS,1)+1
                IF(TFDIST) THEN
                  J=II
                ELSE
                  J=I
                ENDIF
                EIND=EIND+TT*
     &               (DDFNL(ISA,IV,KK,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,KA,II)*DFNL(ISA,JV,KA,II))
              ENDDO
            ENDIF
          ENDDO
        ENDDO
      ELSE
C..Other pp (numeric)
        DO IV=1,NGH(IS)
          TEMP=2.D0*WSG(IS,IV)
          DO I=NST12(MEPOS,1),NST12(MEPOS,2)
            WEIGHT=F(I)*TEMP
            II=I-NST12(MEPOS,1)+1
            IF(TFDIST) THEN
              J=II
            ELSE
              J=I
            ENDIF
            EIND=EIND+WEIGHT*
     &           (DDFNL(ISA,IV,KK,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,KA,II)*DFNL(ISA,IV,KA,II))
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
