C     ==================================================================
      SUBROUTINE ELEC_DISP(C0,C2,SC0,NSTATE)
C     ==--------------------------------------------------------------==
C     == CALCULATES THE DIPOLE MOMENT                                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'geq0.inc'
      include 'ions.inc'
      include 'cnst.inc'
      include 'ddip.inc'
      include 'gvec.inc'
      include 'irat.inc'
      include 'rmas.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,*),C2(*),SC0(NGW*NSTATE)
C     Variables
      INTEGER    ISCR(NGWS),MAPFUL(2*NGWS),MAPCOL(*)
      POINTER    (IP_MAPFUL,MAPFUL),(IP_MAPCOL,MAPCOL),(IP_ISCR,ISCR)
      REAL*8     SCR(*),EDISP(NSTATE)
      COMPLEX*16 DDMAT(NSTATE,NSTATE)
      POINTER    (IP_DDMAT,DDMAT),(IP_SCR,SCR),(IP_EDISP,EDISP)
      COMPLEX*16 DD
      INTEGER    ISUB,N1,I,NMCOL,LSCR
C     ==--------------------------------------------------------------==
      CALL TISET(' ELEC_DISP',ISUB)
      N1=0
      DO I=0,NPROC-1
        N1=MAX(N1,SPARM(3,I))
      ENDDO
      NGWMAX=N1
      CALL MEMORY(IP_ISCR,NGWS/IRAT+1,'ISCR')
      CALL MEMORY(IP_MAPFUL,2*(NGWS/IRAT+1),'MAPFUL')
#ifdef PARALLEL
      NMCOL=(NPROC*NGWMAX)/IRAT+1
#else
      NMCOL=1
#endif
      CALL MEMORY(IP_MAPCOL,NMCOL,'MAPCOL')
      CALL SETDIP(MAPFUL,MAPCOL,ISCR,NGWS)
      CALL FREEM(IP_ISCR)
      CALL MEMORY(IP_DDMAT,2*NSTATE*NSTATE,'DDMAT')
      LSCR=MAX(2*NGG1*NGG2*NGG3,2*NSTATE*NSTATE)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      CALL MEMORY(IP_EDISP,NSTATE,'EDISP')
      CALL AZZERO(EDISP,NSTATE)
      CALL AZZERO(SC0,2*NGW*NSTATE)
C..electronic contribution
      CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,DDMAT,
     *            SCR,LSCR,1,0,DD)
      DO I=1,NSTATE
        EDISP(I)=EDISP(I)+LOG(DDMAT(I,I)*DCONJG(DDMAT(I,I)))
      ENDDO
      CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,DDMAT,
     *            SCR,LSCR,2,0,DD)
      DO I=1,NSTATE
        EDISP(I)=EDISP(I)+LOG(DDMAT(I,I)*DCONJG(DDMAT(I,I)))
      ENDDO
      CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,DDMAT,
     *            SCR,LSCR,3,0,DD)
      DO I=1,NSTATE
        EDISP(I)=EDISP(I)+LOG(DDMAT(I,I)*DCONJG(DDMAT(I,I)))
      ENDDO
      IF(PARENT) THEN
        WRITE(6,'(A)') 
        WRITE(6,'(A)') ' ELECTRONIC STATE DISPERSION SIZE'
        WRITE(6,'(A)') ' STATE              <X^2> - <X>^2 '
        DO I=1,NSTATE
          WRITE(6,'(I6,15X,F12.4)') I,-EDISP(I)/TPIBA2
        ENDDO
      ENDIF
      CALL FREEM(IP_DDMAT)
      CALL FREEM(IP_MAPFUL)
      CALL FREEM(IP_MAPCOL)
      CALL FREEM(IP_SCR)
      CALL FREEM(IP_EDISP)
      CALL TIHALT(' ELEC_DISP',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
