C     ==================================================================
      SUBROUTINE ELSTPO(RHOG,EIROP,EIVPS,VSCR,QPHI,TAU0)
C     ==--------------------------------------------------------------==
C     ==            COMPUTES ELECTROSTATIC POTENTIAL                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'fft.inc'
C     Arguments
      COMPLEX*16 RHOG(NHG),EIROP(NHG),EIVPS(NHG),VSCR(MAXFFT),QPHI(*)
      REAL*8     TAU0(*)
C     Variables
      COMPLEX*16 RTOT
      INTEGER IG1,IG
C     ==--------------------------------------------------------------==
      IF(TCLUST) THEN
        IF(PS_TYPE.EQ.1) THEN
C..Hockney method
          CALL ZAZZERO(VSCR,MAXFFT)
          IG1=1
          IF(GEQ0) IG1=2
!CDIR NODEP
!$OMP parallel do private(IG,RTOT)
          DO IG=IG1,NHG
            RTOT=RHOG(IG)+EIROP(IG)
            VSCR(NZH(IG))=RTOT
            VSCR(INDZ(IG))=DCONJG(RTOT)
          ENDDO
          IF(GEQ0) VSCR(NZH(1))=RHOG(1)+EIROP(1)
          CALL INVFFT(VSCR)
          CALL HIP(VSCR,QPHI)
          CALL FWFFT(VSCR)
!$OMP parallel do private(IG)
          DO IG=1,NHG
            EIVPS(IG)=EIVPS(IG)+VSCR(NZH(IG))  ! bugfix
          ENDDO
!$OMP parallel do private(IG,RTOT)
          DO IG=1,NHG
            RTOT=RHOG(IG)+EIROP(IG)
            VSCR(IG)=HIPZ(IG)*RTOT+EIVPS(IG) ! Be consistent with VOFRHOH
          ENDDO
        ELSEIF(PS_TYPE.EQ.2.OR.PS_TYPE.EQ.3) THEN
C..Martyna & Tuckerman method
          IF(GEQ0) THEN
!!!         VSCR(1)=EIVPS(1)
            RTOT=RHOG(1)+EIROP(1)
            VSCR(1)=RTOT*SCG(1)  ! Be consistent with VOFRHOT
            IG1=2
          ELSE
            IG1=1
          ENDIF
!$OMP parallel do private(IG,RTOT)
          DO IG=IG1,NHG
            RTOT=RHOG(IG)+EIROP(IG)
            VSCR(IG)=RTOT*SCG(IG)+EIVPS(IG)  ! bugfix
          ENDDO
        ELSE
          CALL STOPGM('ELSTPO','PS_TYPE not implemented')
        ENDIF
      ELSE
        IF(GEQ0) THEN
!!!       VSCR(1)=EIVPS(1)
          RTOT=RHOG(1)+EIROP(1)
          VSCR(1)=RTOT*SCG(1)  ! Be consistent with VOFRHOA
          IG1=2
        ELSE
          IG1=1
        ENDIF
!$OMP parallel do private(IG,RTOT)
        DO IG=IG1,NHG
          RTOT=RHOG(IG)+EIROP(IG)
          VSCR(IG)=RTOT*SCG(IG)+EIVPS(IG)  ! bugfix
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
