C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == ENERGY AND CHARGE QUANTITIES                                 ==
C     ==================================================================
C     == ETOT:  Total energy                                          ==
C     == EKIN:  Kinetic energy                                        ==
C     == EHT:   Electrostatic energy                                  ==
C     ==  If TDIAG EHII-EHEE+ESR-ESELF   (ELEC2)                      ==
C     ==  else     EHEP+ESR-ESELF        (ELEC1)                      ==
C     == EHEP   (e- pseudocharge) density Hartree energy              ==
C     == EHEE   electron-electron Hartree energy                      ==
C     == EHII   ion-ion energy                                        ==
C     == EPSEU: Contribution of local pseudopotential part            ==
C     == ENL:   Non-local part contribution of pseudopotential        ==
C     == EEIG:  Band energy (free energy functional)                  ==
C     == EBAND: band energy (sum of eigen. x occup. numbers)          ==
C     == ENTROPY: KT*Entropy                                          ==
C     == AMU:   Chemical potential (i.e. Fermi energy)                ==
C     == EBOGO: Bogoliubov correction energy (free energy)            ==
C     == EXC:   Exchange-correlation energy                           ==
C     == VXC:   Contribution of exchange-correlation potential (-)    ==
C     == EGC:   Gradient correction energy                            ==
C     == EEXT:  Energy of external potential(for interface calc.)     ==
C     == ETDDFT:Excitation energy from TDDFT theory                   ==
C     == EHSIC: Self interaction energy (Hartree term only)           ==
C     ==--------------------------------------------------------------==
C     == ION-ION INTERACTION:                                         ==
C     == The ion-ion interaction energy, the Hartree and the local    ==
C     == pseudo potential energy are diverging due to the presence of ==
C     == slowly decaying Coulomb forces                               ==
C     == To calculate ion-ion interaction, we replace ionic point     ==
C     == charges by Gaussian charge distributions determined by raggio==
C     == (in RHOPS in G space)                                        ==
C     == E_{Ion-Ion} = Hartree term due to RHOPS -ESELF - ESR         ==
C     == ESELF: Self-energy (Sum_i Zv(i)^2 /Raggio(i) )               ==
C     ==        calculated in RINFORCE once                           ==
C     == ESR:   Residual part of the ion-ion interaction              ==
C     ==        (nearest neighbor energy)                             ==
C     ==--------------------------------------------------------------==
C     == Global summation:                                            ==
C     == ETOT,EKIN,EPSEU,ENL,EHT,EHEP,EHEE,EHII,EXC,VXC,EGC,ESR       ==
C     ==--------------------------------------------------------------==
      REAL*8       ETOT,EKIN,EPSEU,ENL,EHT,EHEP,EHEE,EHII,
     &             EXC,VXC,EGC,ESR,EEIG,EBAND,ENTROPY,
     &             ESELF,ECNSTR,AMU,EBOGO,EEXT,ETDDFT,EHSIC,ERESTR,
     &             EEFIELD
      COMMON/ENER/ ETOT,EKIN,EPSEU,ENL,EHT,EHEP,EHEE,EHII,
     &             EXC,VXC,EGC,ESR,EEIG,EBAND,ENTROPY,
     &             ESELF,ECNSTR,AMU,EBOGO,EEXT,ETDDFT,EHSIC,ERESTR,
     &             EEFIELD
C     ==--------------------------------------------------------------==
C     == CAS22 Energies                                               ==
C     ==--------------------------------------------------------------==
      REAL*8         ETOT_A,EKIN_A,EPSEU_A,ENL_A,EHT_A,EXC_A,EEXT_A,
     &               ETOT_2,EKIN_2,EPSEU_2,ENL_2,EHT_2,EXC_2,EEXT_2,
     &               ETOT_AB,EKIN_AB,EPSEU_AB,ENL_AB,EHT_AB,EXC_AB,
     &               EEXT_AB
      COMMON/ENER_C/ ETOT_A,EKIN_A,EPSEU_A,ENL_A,EHT_A,EXC_A,EEXT_A,
     &               ETOT_2,EKIN_2,EPSEU_2,ENL_2,EHT_2,EXC_2,EEXT_2,
     &               ETOT_AB,EKIN_AB,EPSEU_AB,ENL_AB,EHT_AB,EXC_AB,
     &               EEXT_AB
      REAL*8         ETOT_B,ECAS,ETOT_T,CASANG
      COMMON/ENER_D/ ETOT_B,ECAS,ETOT_T,CASANG
C     ==--------------------------------------------------------------==
C     == HFX G=0 ENERGIES                                             ==
C     ==--------------------------------------------------------------==
      REAL*8         EG0HFX
      COMMON/ENER_X/ EG0HFX
C     ==--------------------------------------------------------------==
C     == CSUMG: Total sum in reciprocal space                         ==
C     == CSUMR: Total sum in real space                               ==
C     == CSUMS: Integral of spin polarized density                    ==
C     == CSUMSABS: Integral of abs value of spin polarized density    ==
C     ==--------------------------------------------------------------==
      REAL*8       CSUMG,CSUMR,CSUMS,CSUMSABS,VDBCHG(MAXSP)
      COMMON/CHRG/ CSUMG,CSUMR,CSUMS,CSUMSABS,VDBCHG
C     ==--------------------------------------------------------------==
C     == TENERGY_OK                                                   ==
C     ==--------------------------------------------------------------==
      LOGICAL        TENERGY_OK
      COMMON/ENER_Y/ TENERGY_OK
C     ==================================================================
