C     ==================================================================
      SUBROUTINE ENOSMOVE(EKINC,STEP,SCTOT,IP)     
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'nose.inc'
C     Arguments
      INTEGER IP
      REAL*8  EKINC,STEP,SCTOT
C     Variables
      REAL*8  FETA(NCHX+1),CKEWANT,CKINE,AA,F1,F2
      INTEGER L
C     ==--------------------------------------------------------------==
C     ==  COMPUTE ALL THE THERMOSTAT FORCES                           ==
C     ==--------------------------------------------------------------==
      CKEWANT = EKINW/DBLE(NEDOF)
      FETA(1) = 2.D0*(EKINC - EKINW)
      DO L=2,NCHE+1
        CKINE = 0.5D0*QNOSEE(L-1)*ETADOT(L-1,IP)*ETADOT(L-1,IP)
        FETA(L) = 2.D0*(CKINE - CKEWANT)
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  ETADOT(NCHE) IS TREATED SEPARATELY                          ==
C     ==--------------------------------------------------------------==
      AA = EXP(-0.125D0*STEP*ETADOT(NCHE-1,IP))
      ETADOT(NCHE,IP) = ETADOT(NCHE,IP)*AA*AA + 
     C               0.25D0*STEP*FETA(NCHE)*AA/QNOSEE(NCHE)
      CKINE = 0.5D0*QNOSEE(NCHE)*ETADOT(NCHE,IP)*ETADOT(NCHE,IP)
      FETA(NCHE+1) = 2.D0*(CKINE - CKEWANT)
      F1 = FETA(NCHE-1)
      F2 = FETA(NCHE+1)
      FETA(NCHE-1) = F1 + F2
C     ==--------------------------------------------------------------==
C     ==  LOOP BACKWARDS OVER CHAIN                                   ==
C     ==--------------------------------------------------------------==
      DO L=1,NCHE-1
       AA = EXP(-0.125D0*STEP*ETADOT(NCHE+1-L,IP))
       ETADOT(NCHE-L,IP) = ETADOT(NCHE-L,IP)*AA*AA +
     C                  0.25D0*STEP*FETA(NCHE-L)*AA/QNOSEE(NCHE-L)
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  CALCULATE SCALING FACTOR AND APPLY TO ELECTRON KE           ==
C     ==  AND ACCUMULATE TOTAL SCALING FACTOR IN SCTOT                ==
C     ==--------------------------------------------------------------==
      AA = EXP(-0.5D0*STEP*ETADOT(1,IP))
      SCTOT = SCTOT*AA
      EKINC = EKINC*AA*AA
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE THERMOSTAT POSITIONS                              ==
C     ==--------------------------------------------------------------==
      DO L=1,NCHE
       ETA(L,IP) = ETA(L,IP) + 0.5D0*STEP*ETADOT(L,IP)
       FETA(L) = 0.D0
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  COMPUTE THERMOSTAT FORCES FOR 1 AND NCHE-1                  ==
C     ==  (THE REST ARE COMPUTED IN THE PROPAGATION LOOP)             ==
C     ==--------------------------------------------------------------==
      FETA(1) = 2.D0*(EKINC - EKINW)
      CKINE = 0.5D0*QNOSEE(NCHE)*ETADOT(NCHE,IP)*ETADOT(NCHE,IP)
      FETA(NCHE-1) = 2.D0*(CKINE - CKEWANT)
C     ==--------------------------------------------------------------==
C     ==  LOOP FORWARDS OVER CHAIN                                    ==
C     ==--------------------------------------------------------------==
      DO L=1,NCHE-1
        AA = EXP(-0.125D0*STEP*ETADOT(L+1,IP))
        ETADOT(L,IP) = ETADOT(L,IP)*AA*AA + 
     C                                 0.25D0*STEP*FETA(L)*AA/QNOSEE(L)
        CKINE = 0.5D0*QNOSEE(L)*ETADOT(L,IP)*ETADOT(L,IP)
        FETA(L+1) = FETA(L+1) + 2.D0*(CKINE - CKEWANT)
      ENDDO
      AA = EXP(-0.125D0*STEP*ETADOT(NCHE-1,IP))
      ETADOT(NCHE,IP) = ETADOT(NCHE,IP)*AA*AA +
     C               0.25D0*STEP*FETA(NCHE)*AA/QNOSEE(NCHE)
C     ==-------------------------------------------------------------==
      RETURN
      END
C     =================================================================


