C     ==================================================================
      SUBROUTINE EPR_CURRENT(c0,c1,c1b,c1t,nstate,Bind,j_a,j_b,psi,
     &        scr1,scr2,scr,lscr,epr_chi)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'response_p.inc'
C     ==--------------------------------------------------------------==
C     Subroutine adapted from nmr_current_p
C     ==--------------------------------------------------------------==
C     Parameters
      INTEGER    nstate,lscr
      COMPLEX*16 c0(ngw,nstate),psi(*),c1(ngw,nstate,3),
     &           c1b(ngw,nstate,3),c1t(ngw,nstate,1)
      REAL*8     scr(nnr1,*),scr1(nnr1),scr2(nnr1),Bind(nnr1,9),
     &           j_a(nnr1,9),j_b(nnr1,9),epr_chi(3,3)
C     Local Variables
      COMPLEX*16 Bindt(nhg,3)
      REAL*8     j(nnr1,3),
     &           psi0 (nnr1),gpsi0 (nnr1,3),
     &           psi1p(nnr1,3),psi1L(nnr1),gpsi1L(nnr1,3)
      POINTER    (IP_j,j),(ip_psi1L,psi1L),(ip_gpsi1L,gpsi1L),
     &           (IP_psi0,psi0),(ip_gpsi0,gpsi0),
     &           (IP_psi1p,psi1p),(ip_Bindt,Bindt)
      INTEGER    is,iB,iBB,iBBB,ir,ip,nattot,
     &           iat,isp,isub,il_psi,il_rho,il_scr
      REAL*8     center(3),j2
      CHARACTER*30 tag
C     ==--------------------------------------------------------------==
      CALL tiset('   CURRENT',isub)
      CALL rhoe_psi_size(il_rho,il_psi)
      IF (il_rho .LT. kr1*kr2*kr3)
     &     call STOPGM('EPR_CURRENT','il_rho .lt. kr1*kr2*kr3')
      IF (nnr1 .NE. kr1*kr2*kr3) 
     &     call STOPGM('EPR_CURRENT','nnr1 .ne. kr1*kr2*kr3')
      
      CALL give_scr_epr_current(il_scr,tag)
      call test_scr('EPR_CURRENT',tag,lscr,il_scr)
      CALL GET_ADDR(IP_psi0,scr1) ! size 1
      CALL GET_ADDR(IP_gpsi0,scr(1,1)) ! size 3
      CALL GET_ADDR(IP_psi1L,scr2) ! size 1
      CALL GET_ADDR(IP_psi1p,scr(1,4)) ! size 3
      CALL GET_ADDR(IP_gpsi1L,scr(1,4)) ! size 3
      CALL GET_ADDR(IP_Bindt,scr(1,4)) ! size 3
      CALL GET_ADDR(IP_j,scr(1,7)) ! size 3
C     ==--------------------------------------------------------------==
      CALL azzero(      psi,     il_psi)
      CALL azzero(     psi0,     il_rho)
      CALL azzero(    gpsi0,   3*il_rho)
      CALL azzero(    psi1L,     il_rho)
      CALL azzero(   gpsi1L,   3*il_rho)
      CALL azzero(    psi1p,   3*il_rho)
      CALL azzero(        j,   3*il_rho)
      IF (parent) CALL prmem('EPR (current)   ')
C     ==--------------------------------------------------------------==
C     Find the center of the molecule, used for the .xyz file
      nattot=0
      DO isp=1,nsp
         nattot=nattot+na(isp)
      ENDDO
      DO ir=1,3
         center(ir) = 0.d0
         DO isp=1,nsp
            DO iat=1,na(isp)
               center(ir) = center(ir) + tau0(ir,iat,isp)
            ENDDO
         ENDDO
         center(ir) = center(ir)/DBLE(nattot)
      ENDDO
C     ==--------------------------------------------------------------==
      DO iB=1,3
         CALL make_123(iB,iBB,iBBB)
         CALL azzero(j,3*il_rho)

         DO ip=1,3
            epr_chi(iB,ip)=0.d0
         ENDDO

C     alfa current
         DO is=1,nsup
            CALL set_origin(is)
            CALL fft2TOr(c0(1,is),psi0,c1b(1,is,iB),psi1L, 
     &           psi,ngw,.TRUE.)
            DO ip=1,3
               CALL apply_op_p(c0(1,is),gpsi0(1,ip),ip,ngw)
               CALL apply_op_p(c1b(1,is,iB),gpsi1L(1,ip),ip,ngw)
               CALL fft2TOr(gpsi0(1,ip),gpsi0(1,ip),
     &              gpsi1L(1,ip),gpsi1L(1,ip),psi,ngw,.TRUE.)
            ENDDO

            DO ir=1,nnr1
               DO ip=1,3
                  j_a(ir,(iB-1)*3+ip) = j_a(ir,(iB-1)*3+ip)
     &                       + gpsi0(ir,ip)*psi1L(ir)
     &                       - psi0(ir)*gpsi1L(ir,ip)
               ENDDO
            ENDDO

            CALL fft2TOr(c1(1,is,iBB),psi1p(1,1),
     &           c1(1,is,iBBB),psi1p(1,2),psi,ngw,.true.)
            CALL apply_op_rx(psi1p(1,1),1.d0,psi1p(1,1),0.d0,iBBB)
            CALL apply_op_rx(psi1p(1,2),-1.d0,psi1p(1,1),1.d0,iBB)

            DO ir=1,nnr1
               DO ip=1,3
                  j_a(ir,(iB-1)*3+ip) = j_a(ir,(iB-1)*3+ip) 
     &                       + gpsi0(ir,ip) * psi1p(ir,1)
               ENDDO
            ENDDO

            DO ip=1,3
               CALL apply_op_p(c1(1,is,iBB),psi1p(1,1),ip,ngw)
               CALL apply_op_p(c1(1,is,iBBB),psi1p(1,2),ip,ngw)
               CALL fft2TOr(psi1p(1,1),psi1p(1,1),
     &              psi1p(1,2),psi1p(1,2),psi,ngw,.true.)
               CALL apply_op_rx(psi1p(1,1),1.d0,psi1p(1,1),0.d0,iBBB)
               CALL apply_op_rx(psi1p(1,2),-1.d0,psi1p(1,1),1.d0,iBB)
               DO ir=1,nnr1
                  j_a(ir,(iB-1)*3+ip) = j_a(ir,(iB-1)*3+ip)
     &                       - psi0(ir)*psi1p(ir,1)
               ENDDO
            ENDDO
C Recover current density for last state
            DO ir=1,nnr1
               DO ip=1,3
                  j(ir,ip)=j_a(ir,(iB-1)*3+ip)-j(ir,ip)
               ENDDO
            ENDDO
            CALL apply_op_rx(j(1,3),1.d0,gpsi0(1,1),0.d0,2)
            CALL apply_op_rx(j(1,2),-1.d0,gpsi1L(1,1),0.d0,3)
 
            CALL apply_op_rx(j(1,1),1.d0,gpsi0(1,2),0.d0,3)
            CALL apply_op_rx(j(1,3),-1.d0,gpsi1L(1,2),0.d0,1)
 
            CALL apply_op_rx(j(1,2),1.d0,gpsi0(1,3),0.d0,1)
            CALL apply_op_rx(j(1,1),-1.d0,gpsi1L(1,3),0.d0,2)
        
            DO ir=1,nnr1
               DO ip=1,3
                  epr_chi(iB,ip)=epr_chi(iB,ip)+
     &                       2.d0*(gpsi0(ir,ip)+gpsi1L(ir,ip))
               ENDDO
            ENDDO
         ENDDO                  ! is (alfa states)

         DO is=nsup+1,nstate
            CALL set_origin(is)
            CALL fft2TOr(c0(1,is), psi0, c1b(1,is,iB), psi1L, 
     &           psi,ngw,.TRUE.)
            DO ip=1,3
               CALL apply_op_p(c0(1,is),gpsi0(1,ip),ip,ngw)
               CALL apply_op_p(c1b(1,is,iB),gpsi1L(1,ip),ip,ngw)
               CALL fft2TOr(gpsi0(1,ip),gpsi0(1,ip),
     &              gpsi1L(1,ip),gpsi1L(1,ip),psi,ngw,.TRUE.)
            ENDDO

            DO ir=1,nnr1
               DO ip=1,3
                  j_b(ir,(iB-1)*3+ip) = j_b(ir,(iB-1)*3+ip)
     &                       + gpsi0(ir,ip)*psi1L(ir)
     &                       - psi0(ir)*gpsi1L(ir,ip)
               ENDDO
            ENDDO

            CALL fft2TOr(c1(1,is,iBB),psi1p(1,1),
     &           c1(1,is,iBBB),psi1p(1,2),psi,ngw,.TRUE.)
            CALL apply_op_rx(psi1p(1,1),1.d0,psi1p(1,1),0.d0,iBBB)
            CALL apply_op_rx(psi1p(1,2),-1.d0,psi1p(1,1),1.d0,iBB)

            DO ir=1,nnr1
               DO ip=1,3
                  j_b(ir,(iB-1)*3+ip) = j_b(ir,(iB-1)*3+ip) 
     &                       + gpsi0(ir,ip)*psi1p(ir,1)
               ENDDO
            ENDDO

            DO ip=1,3
               CALL apply_op_p(c1(1,is,iBB),psi1p(1,1),ip,ngw)
               CALL apply_op_p(c1(1,is,iBBB),psi1p(1,2),ip,ngw)
               CALL fft2TOr(psi1p(1,1),psi1p(1,1),
     &              psi1p(1,2),psi1p(1,2),psi,ngw,.true.)
               CALL apply_op_rx(psi1p(1,1),1.d0,psi1p(1,1),0.d0,iBBB)
               CALL apply_op_rx(psi1p(1,2),-1.d0,psi1p(1,1),1.d0,iBB)
               DO ir=1,nnr1
                  j_b(ir,(iB-1)*3+ip) = j_b(ir,(iB-1)*3+ip)
     &                       - psi0(ir)*psi1p(ir,1)
               ENDDO
            ENDDO
         ENDDO                  ! is (beta states)

C j = alfa-current + beta-current
C  - (beta-current - alfa-current) = 2*alfa-current

         DO ir=1,nnr1
            DO ip=1,3
               j(ir,ip) = 2.0D0*j_a(ir,(iB-1)*3+ip)
            ENDDO
         ENDDO

C     Current density in G space
         CALL fft2TOg(j(1,1),j(1,1),
     &        j(1,2),j(1,2),psi,nhg,.TRUE.)
         CALL fftTOg(j(1,3),j(1,3),psi,nhg,.TRUE.)

C     INDUCED FIELD:
C     B_ind = Oz:
         CALL apply_op_p(j(1,1),gpsi0(1,1),2,nhg)
         CALL apply_op_p(j(1,2),Bindt(1,3),1,nhg)
         CALl daxpy(2*nhg,-1.d0,gpsi0(1,1),1,Bindt(1,3),1)
C     B_ind = Oy:
         CALL apply_op_p(j(1,3),gpsi0(1,1),1,nhg)
         CALL apply_op_p(j(1,1),Bindt(1,2),3,nhg)
         CALL daxpy(2*nhg,-1.d0,gpsi0(1,1),1,Bindt(1,2),1)
C     B_ind = Ox:
         CALL apply_op_p(j(1,2),gpsi0(1,1),3,nhg)
         CALL apply_op_p(j(1,3),Bindt(1,1),2,nhg)
         CALL daxpy(2*nhg,-1.d0,gpsi0(1,1),1,Bindt(1,1),1)

         CALL nmr_interaction3(Bindt(1,1),Bindt(1,2),Bindt(1,3))
C Remove G=0 value
         IF (geq0) THEN
              Bindt(1,1)=0
              Bindt(1,2)=0
              Bindt(1,3)=0
         ENDIF

         CALL fft2TOr(Bindt(1,1),Bind(1,(iB-1)*3+1),
     &        Bindt(1,2),Bind(1,(iB-1)*3+2),psi,nhg,.true.)
         CALL fftTOr(Bindt(1,3),Bind(1,(iB-1)*3+3),psi,nhg,.true.)
C * FPI/(fine structure constant)^2
         CALL dscal(nnr1,.0006691760526D0,Bind(1,(iB-1)*3+1),1)
         CALL dscal(nnr1,.0006691760526D0,Bind(1,(iB-1)*3+2),1)
         CALL dscal(nnr1,.0006691760526D0,Bind(1,(iB-1)*3+3),1)

C         CALL cubefile('Bindx_B'//label//'.cube ',
C     &                 Bind(1,(iB-1)*3+1),center,psi,.FALSE.)
C         CALL cubefile('Bindy_B'//label//'.cube ',
C     &                 Bind(1,(iB-1)*3+2),center,psi,.FALSE.)
C         CALL cubefile('Bindz_B'//label//'.cube ',
C     &                 Bind(1,(iB-1)*3+3),center,psi,.FALSE.)

      ENDDO                     ! IB

C     ==--------------------------------------------------------------==
      CALL TIHALT('   CURRENT',ISUB)
      RETURN
      END
C     ==================================================================


C     ==================================================================
      SUBROUTINE give_scr_epr_current(lscr,tag)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'wann.inc'
      INTEGER   lscr
      CHARACTER tag*30
      lscr = 1
      IF (.NOT. tepr) RETURN
      lscr = 12*nnr1
      tag  = 'epr-response          '
      RETURN
      END
C     ==================================================================


