C     ==================================================================
      SUBROUTINE EPR_HYP(c0,rhoes,psi,nstate,scr,lscr)
C     ==--------------------------------------------------------------==
C     == Computes hyperfine parameters (VERY rough method!!!)         ==
C     == with the method of C.G. Van de Walle and P.E. Blochl         ==
C     ==                    Phys. Rev. B 47, 4244 (1993)              ==
C     == how to use this routine                                      ==
C     == 1) use TM PSP's                                              ==
C     == 2) force CPMD to read in the atomic pseudo wavefunctions     ==
C     ==    by putting the following in your input file:              ==
C     ==         &BASIS                                               ==
C     ==             PSEUDO AO [NUM]                                  ==
C     ==             0 1 2 ... [NUM-1]                                ==
C     ==             ... ! and this for all elements                  ==
C     ==         &END                                                 ==
C     == 3) for every element, place a [elementsname].ae in the       ==
C     ==    same directory where your input file is located           ==
C     ==    These .ae files must be in the same format as the         ==
C     ==    USPP pseudopotential generation program of D. Vanderbilt  ==
C     == 4) run the EPR routine with the option HYP                   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'response_p.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'pslo.inc'
C     ==--------------------------------------------------------------==
C     Arguments & common variables
      COMPLEX*16 c0(NGW,*)
      INTEGER    nstate,lscr
      REAL*8     rhoes(nnr1),psi(*),scr(*) ! rhoes = spin density
      REAL*8     FNL(*),DFNL(*)
C     ==--------------------------------------------------------------==
C     Local variables
      DIMENSION  atrg_epr(mmaxx,nsx),atwfr_epr(mmaxx,m1shlx,nsx)
      INTEGER    iat,is,ia,io,nlm(26,nsp),ierr,kkk,i,k
      POINTER    (ip_nlm,nlm)
      REAL*8     rtemp,ahyp(NAT),dens_rad_2,int_1(6,NAT),
     &           int_2(6,NAT),int_3(NAT),int_4(NAT),int_5(NAT),
     &           int_6(NAT),GYROM(99,4),tot(6),eigr_dot
      POINTER    (ip_int_1,int_1),(ip_int_2,int_2),(ip_int_3,int_3),
     &           (ip_int_4,int_4),(ip_int_5,int_5),(ip_int_6,int_6),
     &           (ip_ahyp,ahyp)
      COMPLEX*16 rhoesgtemp(nnr1),rhoesg(nhg)
      POINTER    (ip_rhoesgtemp,rhoesgtemp),(ip_rhoesg,rhoesg)
      LOGICAL    dos,dop
      REAL*8     cte(1000),temp(1000),gridft(1000,6),curvi,gridt(1000)
C     Local variables for reading AE orbitals
      REAL*8     aasf(nsp),bbsf(nsp),rmax(nsp) ! r(i)=1/z*[e^...
      REAL*8     exfact(nsp),z(nsp),xion(nsp) ! xion=atomcharge ...
      REAL*8     wwnl(26,nsp) ! # e- in orbital
      REAL*8     ee(26,nsp) ! orbital energy
      REAL*8     ruae(1000,nsp) ! potential
      REAL*8     snl(1000,26,nsp)
      INTEGER    nnlz(26,nsp),nkkk(26,nsp),ncspvs(nsp),mesh(nsp), 
     &           irel(nsp) 
      POINTER    (ip_aasf,aasf),(ip_bbsf,bbsf),(ip_rmax,rmax),
     &           (ip_exfact,exfact),(ip_z,z),(ip_xion,xion),
     &           (ip_wwnl,wwnl),(ip_ee,ee),(ip_ruae,ruae),
     &           (ip_snl,snl),(ip_nnlz,nnlz),(ip_nkkk,nkkk),
     &           (ip_ncspvs,ncspvs),(ip_mesh,mesh),(ip_irel,irel)
C                nnlz=quantum numbers nlm
C                nkkk=real-space cutoff index
C                ncspvs= # orbitals (nl)
C                mesh=#radial points
C                irel=non relativ./dirac/koelling-harmon
#ifdef PARALLEL
      INTEGER MSGLEN
#endif


C     ==--------------------------------------------------------------==
C     Gyromagnetic Data (not complete)
      DATA (gyrom(i,1),i=1,99)
     &   / 42.576D0,-32.433D0, 62.653D0,  5.983D0,  4.574D0,
     &     10.705D0,  3.077D0, -5.772D0, 40.054D0, -3.361D0,
     &     11.262D0,  2.606D0, 11.094D0, -8.458D0, 17.235D0,
     &      3.268D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0,
     &      1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0,
     &      1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0,
     &      1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0,
     &      1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0,
     &      1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0,
     &      1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0,
     &      1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0, 1D0,
     &      1D0, 1D0, 1D0, 1D0, 1D0 /

      CALL memory(ip_aasf,nsp,'aasf')
      CALL azzero(   aasf,nsp)
      CALL memory(ip_bbsf,nsp,'bbsf')
      CALL azzero(   bbsf,nsp)
      CALL memory(ip_rmax,nsp,'rmax')
      CALL azzero(   rmax,nsp)
      CALL memory(ip_exfact,nsp,'exfact')
      CALL azzero(   exfact,nsp)
      CALL memory(ip_z,nsp,'z')
      CALL azzero(   z,nsp)
      CALL memory(ip_xion,nsp,'xion')
      CALL azzero(   xion,nsp)
      CALL memory(ip_wwnl,26*nsp,'wwnl')
      CALL azzero(   wwnl,26*nsp)
      CALL memory(ip_ee,26*nsp,'ee')
      CALL azzero(   ee,26*nsp)
      CALL memory(ip_ruae,1000*nsp,'ruae')
      CALL azzero(   ruae,1000*nsp)
      CALL memory(ip_snl,1000*26*nsp,'snl')
      CALL azzero(   snl,1000*26*nsp)
      CALL memory(ip_nnlz,26*nsp,'nnlz')
      CALL azzero(   nnlz,26*nsp)
      CALL memory(ip_nkkk,26*nsp,'nkkk')
      CALL azzero(   nkkk,26*nsp)
      CALL memory(ip_ncspvs,nsp,'ncspvs')
      CALL azzero(   ncspvs,nsp)
      CALL memory(ip_mesh,nsp,'mesh')
      CALL azzero(   mesh,nsp)
      CALL memory(ip_irel,nsp,'irel')
      CALL azzero(   irel,nsp)
      CALL memory(ip_nlm,13*nsp,'nlm')
      CALL azzero(   nlm,13*nsp)
      CALL memory(ip_int_1,6*NAT,'int_1')
      CALL azzero(   int_1,6*NAT)
      CALL memory(ip_int_2,6*NAT,'int_2')
      CALL azzero(   int_2,6*NAT)
      CALL memory(ip_int_3,NAT,'int_3')
      CALL azzero(   int_3,NAT)
      CALL memory(ip_int_4,NAT,'int_4')
      CALL azzero(   int_4,NAT)
      CALL memory(ip_int_5,NAT,'int_5')
      CALL azzero(   int_5,NAT)
      CALL memory(ip_int_6,NAT,'int_6')
      CALL azzero(   int_6,NAT)
      CALL memory(ip_ahyp,NAT,'ahyp')
      CALL azzero(   ahyp,NAT)
      CALL memory(ip_rhoesgtemp,nnr1*2,'rhoesgtemp')
      CALL azzero(   rhoesgtemp,nnr1*2)
      CALL memory(ip_rhoesg,nhg*2,'rhoesg')
      CALL azzero(   rhoesg,nhg*2)

C     Preventing division by zero
!$OMP parallel do private(i)
#ifdef __SR8000
*poption parallel
#endif
      DO i=1,NAT
         int_3(i)=1.D0
      ENDDO

      IF(PARENT)
     &  WRITE(6,'(/,A,A)') ' ********************** DEBUG INFORMATION',
     &                   ' ***********************'
C     ==--------------------------------------------------------------==
C     Conversion of spin density to reciprocal space
C     ==--------------------------------------------------------------==
!$OMP parallel do private(i)
#ifdef __SR8000
*poption parallel
#endif
      DO i=1,nnr1
         rhoesgtemp(i)=DCMPLX(rhoes(i),0.D0)
      ENDDO
      CALL fwfft(rhoesgtemp)

      DO i=1,nhg
         rhoesg(i)=rhoesgtemp(nzh(i))
      ENDDO

C     ==--------------------------------------------------------------==
C     Mark PSEUDO AO orbitals + Check norm
C     ==--------------------------------------------------------------==

C     Assign a number NLM to the orbitals
      DO is=1,nsp
        IF (.NOT.tvan(is)) THEN
         DO i=1, nshell(is)
            nlm(i,is) = nqsto(i,is)*100 + lshell(i,is)*10
            DO k=1,mesh_epr(is)
               gridft(k,1)=atwfr_epr(k,i,is)**2*fpi
               gridt(k)=atrg_epr(k,is)
            ENDDO
            CALL curv1(mesh_epr(is),gridt,gridft(1,1),
     &         0.0D0,0.0D0,0,cte,temp,0.0D0,ierr)
            IF(PARENT) THEN
              WRITE(6,'(A,11X,T54,F12.5)')
     &         ' NORM PSEUDO ATOMIC ORBITALS:',
     &         curvi(atrg_epr(1,is),atrg_epr(mesh_epr(is),is),
     &         mesh_epr(is),gridt,gridft(1,1),cte,0.0D0)
              WRITE(6,'(A,T27,3(8X,I5))') ' IDENTIFICATION ORBTIAL: ',
     &         is,i,nlm(i,is)
            ENDIF
         ENDDO
        ENDIF
      ENDDO

C     ==--------------------------------------------------------------==
C     Read All Electron AO orbitals + Check norm
C     ==--------------------------------------------------------------==

      IF(PARENT) THEN
      DO is=1,NSP
        IF (.NOT.tvan(is)) THEN
         OPEN( unit = 10 , file = EL(IATYP(IS))//'.ae', status = 'old' ,
     &            form = 'unformatted' )
         READ (10) z(is),xion(is),exfact(is),mesh(is),irel(is),
     &            aasf(is),bbsf(is),rmax(is)
         READ (10) ncspvs(is)
         DO k=1,ncspvs(is)
            READ (10) nnlz(k,is),wwnl(k,is),ee(k,is)
         ENDDO
         READ (10) (ruae(i,is),i=1,mesh(is))
         DO k=1,ncspvs(is)
            READ (10) kkk,(snl(i,k,is),i=1,kkk)
            nkkk(k,is)=kkk
            DO i=1,kkk
               snl(i,k,is)=snl(i,k,is)/DSQRT(fpi)
               gridt(i) = 1/z(is)*(DEXP(-aasf(is)+
     &            (i-1)/bbsf(is))-DEXP(-aasf(is)))
               gridft(i,1)=snl(i,k,is)**2*fpi
            ENDDO
            CALL curv1(kkk,gridt,gridft(1,1),0.0D0,0.0D0,0,cte,temp,
     &                 0.0D0,ierr)
            WRITE(6,'(A,11X,T54,F12.5)')
     &         ' NORM ALL ELECTRON ATOMIC ORBITALS:',
     &         curvi(gridt(1),gridt(kkk),kkk,gridt,gridft(1,1),
     &         cte,0.0D0)
         ENDDO
         CLOSE (10)
        ENDIF
      ENDDO
      ENDIF

C     brodacast all data
#ifdef PARALLEL
      MSGLEN = nsp * 8
      CALL MY_BCAST(aasf,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(bbsf,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(rmax,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(exfact,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(z,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(xion,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(wwnl,26*MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(ee,26*MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(ruae,1000*MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(snl,26000*MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(nnlz,26*MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(nkkk,26*MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(ncspvs,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(mesh,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(irel,MSGLEN,SOURCE,ALLGRP)
#endif

C     ==--------------------------------------------------------------==
C     Compute Hyperfine Coupling Tensor
C     ==--------------------------------------------------------------==

      CALL MY_SYNC(ALLGRP)
C     Initialize
      iat=0 ! index atoms
      DO is = 1,nsp
        IF (.NOT.tvan(is)) THEN
         DO ia = 1,na(is)
         dos=.TRUE. ! do s-part?
         dop=.TRUE. ! do p-part?
         iat=iat+1
         IF(PARENT)
     &     WRITE(6,'(A,T32,I4)') ' STARTING CALCULATION OF ATOM ',iat
         DO io = 1,nshell(is)
             IF ((dos.OR.dop).AND.PARENT) 
     &       WRITE(6,'(A,T63,I3)') '  NOW CHECKING ORBITAL:',nlm(io,is)
             IF (MOD(nlm(io,is),100) .EQ. 0) THEN
                DO k=1,ncspvs(is)
                   IF ((nlm(io,is).EQ.nnlz(k,is)).AND.(dos)) THEN
                    IF(PARENT)
     &                WRITE(6,*) '   -- TAKING THIS ONE FOR S-PART'
                    rtemp=1/z(is)*(DEXP(-aasf(is)+
     &                 DBLE(2-1)/bbsf(is))-DEXP(-aasf(is)))
                    ahyp(iat)=-104.98d0*GYROM(IATYP(IS),1)
     &                   *dens_rad_2(iat,rhoesg(1),0.0D0,0,0)
     &                   *(snl(2,k,is)/rtemp)**2/
     &                   (atwfr_epr(1,io,is)/atrg_epr(1,is))**2
                    dos = .FALSE.
                   ENDIF
                ENDDO
             ELSEIF (MOD(nlm(io,is),100) .EQ. 10) THEN
                DO k=1,ncspvs(is)
                   IF ((nlm(io,is).EQ.nnlz(k,is)).AND.(dop)) THEN
                    IF(PARENT)
     &                WRITE(6,*) '   -- TAKING THIS ONE FOR P-PART'
C INT1  
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*(-1.D0)*
     &                   (gk(1,i)*gk(1,i)-hg(i)/3D0)
                     ENDDO
                     int_1(1,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*(-1.D0)*
     &                   (gk(1,i)*gk(2,i))
                     ENDDO
                     int_1(2,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*(-1.D0)*
     &                   (gk(1,i)*gk(3,i))
                     ENDDO
                     int_1(3,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*(-1.D0)*
     &                   (gk(2,i)*gk(2,i)-hg(i)/3.D0)
                     ENDDO
                     int_1(4,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*(-1.D0)*
     &                   (gk(2,i)*gk(3,i))
                     ENDDO
                     int_1(5,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*(-1.D0)*
     &                   (gk(3,i)*gk(3,i)-hg(i)/3.D0)
                     ENDDO
                     int_1(6,iat)=eigr_dot(iat,rhoesgtemp(1))
C /INT1
C INT2
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*
     &                   (gk(1,i)*gk(1,i)-hg(i)/3.D0)
     &                   *(DCOS(covrad(iatyp(is))*FBOHR
     &                   *tpiba*DSQRT(HG(i)))-1.D0)
                     ENDDO
                     int_2(1,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*
     &                   (gk(1,i)*gk(2,i))
     &                   *(DCOS(covrad(iatyp(is))*FBOHR
     &                   *tpiba*DSQRT(HG(i)))-1.D0)
                     ENDDO
                     int_2(2,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*
     &                   (gk(1,i)*gk(3,i))
     &                   *(DCOS(covrad(iatyp(is))*FBOHR
     &                   *tpiba*DSQRT(HG(i)))-1.D0)
                     ENDDO
                     int_2(3,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*
     &                   (gk(2,i)*gk(2,i)-hg(i)/3.D0)
     &                   *(DCOS(covrad(iatyp(is))*FBOHR
     &                   *tpiba*DSQRT(HG(i)))-1.D0)
                     ENDDO
                     int_2(4,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*
     &                   (gk(2,i)*gk(3,i))
     &                   *(DCOS(covrad(iatyp(is))*FBOHR
     &                   *tpiba*DSQRT(HG(i)))-1.D0)
                     ENDDO
                     int_2(5,iat)=eigr_dot(iat,rhoesgtemp(1))
                     DO i=1,nhg
                       rhoesgtemp(i)=rhoesg(i)/hg(i)*fpi*
     &                   (gk(3,i)*gk(3,i)-hg(i)/3.D0)
     &                   *(DCOS(covrad(iatyp(is))*FBOHR
     &                   *tpiba*DSQRT(HG(i)))-1.D0)
                     ENDDO
                     int_2(6,iat)=eigr_dot(iat,rhoesgtemp(1))
C /INT2
C INT3,INT5
                     DO i=1,mesh_epr(is)
                        gridt(i) = atrg_epr(i,is)
                     ENDDO
                     DO i=1,mesh_epr(is)
                        gridft(i,1)=atwfr_epr(i,io,is)**2
     &                            /(gridt(i)**3)*fpi
                     ENDDO
                     CALL curv1(mesh_epr(is),gridt,gridft(1,1),0.0D0,
     &                      0.0D0,2,cte,temp,0.0D0,ierr)
                     int_3(iat)=curvi(0.0D0,covrad(iatyp(is))*FBOHR,
     &                      mesh_epr(is),gridt,gridft(1,1),cte,0.0D0)
                     int_5(iat)=curvi(0.0D0,gridt(mesh_epr(is)),
     &                      mesh_epr(is),gridt,gridft(1,1),cte,0.0D0)
C /INT3,/INT5
C INT4
                     DO i=1,nkkk(k,is)-1
                        gridt(i) = 1/z(is)*(DEXP(-aasf(is)+
     &                  DBLE(i)/bbsf(is))-DEXP(-aasf(is)))
                     ENDDO
                     DO i=1,nkkk(k,is)-1
                        gridft(i,1)=snl(i+1,k,is)**2/(gridt(i)**3)*fpi
                     ENDDO
                     CALL curv1(nkkk(k,is)-1,gridt,gridft(1,1),0.0D0,
     &                  0.0D0,2,cte,temp,0.0D0,ierr)
                     int_4(iat)=curvi(0.0D0,gridt(nkkk(k,is)-1),
     &                  nkkk(k,is)-1,gridt,gridft(1,1),cte,0.0D0)
C /INT4
                     dop=.false.           
c                    WRITE(6,'(A,T12,6(F9.4))')'  6 INT1: ',
c    &                    (int_1(i,iat),i=1,6)
c                    WRITE(6,'(A,T12,6(F9.4))')'  6 INT2: ',
c    &                    (int_2(i,iat),i=1,6)
c                    WRITE(6,'(A,T12,1(F9.4))')'  1 INT3: ',
c    &                    int_3(iat)
c                    WRITE(6,'(A,T12,1(F9.4))')'  1 INT4: ',
c    &                    int_4(iat)
c                    WRITE(6,'(A,T12,1(F9.4))')'  1 INT5: ',
c    &                    int_5(iat)
c                    WRITE(6,*)
                   ENDIF
                ENDDO                
             ENDIF
           ENDDO ! io
         ENDDO ! ia
        ELSE
         DO ia = 1,na(is)
           iat=iat+1
C Not yet implemented (RDeclerck)
C
C          CALL EPR_HYP_VAN(c0,rhoes(1),rhoesg(1),is,iat,nstate,
C    &        ahyp(iat),int_1(1,iat),int_2(1,iat),scr,lscr,psi)
C          ahyp(iat)=-104.98*GYROM(IATYP(IS),1)*ahyp(iat)
           int_3(iat)=1D0
           int_4(iat)=1D0
           int_5(iat)=0D0
         ENDDO
        ENDIF
      ENDDO ! is

      IF(PARENT) THEN
        WRITE(6,*) ' *** CALCULATION COMPLETED. '
        WRITE(6,'(1X,64("*"))')
        WRITE(6,*)
        WRITE(6,'(/,A,A)') ' ************************ FINAL RESULTS',
     &                     ' *************************'
      ENDIF

      CALL GLOSUM(NAT,ahyp)

      iat=0 ! index atoms
      DO is = 1,nsp
         DO ia = 1,na(is)
            iat=iat+1

            DO i=1,6
               tot(i)=-12.531d0*GYROM(IATYP(IS),1)*(int_1(i,iat)
     &           +int_2(i,iat)/int_3(iat)*(int_4(iat)-int_5(iat)))
            ENDDO
            CALL GLOSUM(6,tot)
            IF(PARENT) THEN
              WRITE(6,*)
              WRITE(6,'(A,T7,I4,A,A,A)') ' ATOM ',iat,', symbol',
     &             EL(IATYP(IS)),'         HYPERFINE TENSOR (Mhz)'
              WRITE(6,'(T18,A,3(1X,F12.6),T64,A)') '[   ',
     &             ahyp(iat)+tot(1),tot(2),tot(3),' ]'
              WRITE(6,'(T18,A,3(1X,F12.6),T64,A)') '[   ',
     &             tot(2),tot(4)+ahyp(iat),tot(5),' ]'
              WRITE(6,'(T18,A,3(1X,F12.6),T64,A)') '[   ', 
     &             tot(3),tot(5),tot(6)+ahyp(iat),' ]'
              WRITE(6,'(A,T36,F9.2)')
     &             ' ISOTROPIC INTERACTION TERM (Mhz):', ahyp(iat)
           ENDIF
         ENDDO
      ENDDO
      IF(PARENT) THEN
        WRITE(6,'(1X,64("*"))')
        WRITE(6,*)
      ENDIF

      CALL freem(ip_int_1)
      CALL freem(ip_int_2)
      CALL freem(ip_int_3)
      CALL freem(ip_int_4)
      CALL freem(ip_int_5)
      CALL freem(ip_int_6)
      CALL freem(ip_ahyp)
      RETURN
      END

C     ==================================================================
      REAL*8 FUNCTION DENS_RAD_2(isa,func,crad,cazi,cpol)
C     ==--------------------------------------------------------------==
C     INPUT:   One function f(G), packed storage, dim=NHG
C     \        Species/Atom index ISA.
C     OUTPUT:  function value returns
C     \        Sum_G  exp(i G R_ion[isa])  f(G)
C     \        i.e. the Fourier transform of f(G) at the position of
C     \        the nucleus ISA.
C     \        ATTENTION: The G=0 component of func is set to zero!!
C     NOT PARALLEL -- corresponds to a DOTP-call
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cnst.inc'
C     ==--------------------------------------------------------------==
      REAL*8      func(2,*),crad
      INTEGER     isa,cazi,cpol
      INTEGER     ig,ig1
      COMPLEX*16  expigr
      REAL*8      fnl,dfnl,dot,xx1,yy1,zz1,result
      DIMENSION   eigrb(nhg,nat)
C     ==--------------------------------------------------------------==
C     CALL TISET('DENS_RAD       ',isub)

      xx1=crad*DCOS(cazi/20D0*pi)*DSIN(cpol/20D0*pi)
      yy1=crad*DSIN(cazi/20D0*pi)*DSIN(cpol/20D0*pi)
      zz1=crad*DCOS(cpol/20D0*pi)
      
      result = 0D0
      ig1=1
      IF (geq0) THEN
        ig1=2
        expigr = EI1(isa,INYH(1,1))
     &       * EI2(isa,INYH(2,1))
     &       * EI3(isa,INYH(3,1))
     &       * DCMPLX(DCOS(tpiba*(xx1*GK(1,1)+yy1*GK(2,1)+
     &         zz1*GK(3,1))),DSIN(tpiba*(xx1*GK(1,1)+yy1*GK(2,1)+
     &         zz1*GK(3,1))))
        dot    = DREAL(expigr)*func(1,1)
     &         + DIMAG(expigr)*func(2,1)
        result = 0.5D0 * dot
      ENDIF

!$OMP parallel do private(ig,expigr,dot) reduction(+:result)
      DO ig=ig1,nhg
         expigr = EI1(isa,INYH(1,ig))
     &        * EI2(isa,INYH(2,ig))
     &        * EI3(isa,INYH(3,ig))
     &        * DCMPLX(DCOS(tpiba*(xx1*GK(1,ig)+yy1*GK(2,ig)+
     &          zz1*GK(3,ig))),DSIN(tpiba*(xx1*GK(1,ig)+yy1*GK(2,ig)+
     &          zz1*GK(3,ig))))
         dot    = DREAL(expigr)*func(1,ig)
     &          + DIMAG(expigr)*func(2,ig)
         result = result + dot
      ENDDO
      dens_rad_2 = 2.d0 * result
C     CALL TIHALT('DENS_RAD       ',isub)
      RETURN
      END
c     ==================================================================
