C     ==================================================================
      SUBROUTINE EPR_P(c0,h1psi0,psi,rhoe,scr,lscr,
     &        eirop,eivps,z11,nstate)
C     ==================================================================
C     PARALLEL
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'response_p.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'wann.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'store.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
C     ==--------------------------------------------------------------==
C     Arguments & common variables
      INTEGER    nstate, lscr
      COMPLEX*16 c0(ngw,nstate), h1psi0(ngw,nstate),
     &           psi(*),eirop(NHG),eivps(NHG)
      REAL*8     scr(2*maxfft,*),z11(nstate,nstate),
     &           rhoe(nnr1,2),fnl(*),dfnl(*)
C     ==--------------------------------------------------------------==
C     Local variables
      REAL*8     dg_rmc, kine_one, w_eps_save,
     &           dg_soo(3,3),dg_sootemp,j_a(nnr1,9),j_b(nnr1,9),
     &           diffv0a(nnr1,3),diffv0b(nnr1,3),dg_so(3,3),
     &           dg_sotemp,gtensor(3,3),rhoetmp(nnr1,2),geigvec(3,3),
     &           geigval(3),epr_chi(3,3),rootrho(nnr1),
     &           Bind(nnr1,9)
      POINTER    (ip_j_a,j_a),(ip_j_b,j_b),(ip_dg_so,dg_so),
     &           (ip_dg_soo,dg_soo),(ip_gtensor,gtensor),
     &           (ip_geigvec,geigvec),(ip_diffv0a,diffv0a),
     &           (ip_diffv0b,diffv0b),(ip_rhoetmp,rhoetmp),
     &           (ip_rootrho,rootrho),(ip_Bind,Bind)
      COMPLEX*16 c1(ngw,nstate,*),cs(*),sc0(*),vt(maxfft),vt2(nhg),
     &           c1b(ngw,nstate,*),c1t(ngw,nstate,*)
      POINTER    (ip_c1,c1),(ip_cs,cs),(ip_sc0,sc0),
     &           (ip_vt,vt),(ip_c1b,c1b),(ip_c1t,c1t),(ip_vt2,vt2)
      INTEGER    i1,l_c1,nc,i2,i3,dummy2
      INTEGER    iB,ii,iii,is,ik,isub,isub2,
     &           ip_start,ip_end,iL_start,iL_end,
     &           i_state,neighborlist(3,nstate),ier
      LOGICAL    dowfopt(3,nstate),doepr(nstate)
      POINTER    (ip_neighborlist,neighborlist),
     &           (ip_dowfopt,dowfopt),(ip_doepr,doepr)
#ifdef PARALLEL
      INTEGER    NXXFUN
      EXTERNAL   NXXFUN
#endif
      REAL*8     dummy,starttime

      LOGICAL    simple_done(9)
      CHARACTER  xyz(3),tag*10
      DATA       xyz /'x','y','z'/

      LOGICAL    full_optimization

C     Functions
      REAL*8     timef
      EXTERNAL   timef
 89   FORMAT ("*  FULL calculation: field in O",A1,32X,"*")
 96   FORMAT ("*  PERTURBATION: ",A1,"_",I1," |PSI>",38X,"*")
 99   FORMAT ("*  Calculation of responses DONE.",31X,"*")
 97   FORMAT ("*  TOTAL TIME: ",F7.1,42X,"*")
 98   FORMAT (52("*"),"EPR*RESPONSE*")
C     ==--------------------------------------------------------------==
      CALL tiset('       EPR',isub)
      timetag=' '
      IF (parent) CALL printtime
      starttime=timef()/1000.d0

      nris(1)   = nr1s
      nris(2)   = nr2s
      nris(3)   = nr3s
      pr_energy = teverbose !  these values are not sooo interesting
      full_optimization=.FALSE.
C     full_optimization=.TRUE.
C     IF (parent) print *,
C    &     'DEBUG DEBUG: >> full_optimization: ',full_optimization

C     ==--------------------------------------------------------------==
C     Some initialization 
C     ==--------------------------------------------------------------==
      l_c1 = 3*2*ngw*nstate ! 6: 2 x pert.param.for.3B-direct. 
      IF (tepr_full) l_c1 = 3*2*ngw*nstate
      ip_start=1
      ip_end  =3
      iL_start=1
      iL_end  =3
      
      CALL memory(ip_c1,l_c1,'C1')
      CALL azzero(   c1,l_c1)
      CALL memory(ip_c1b,l_c1,'C1b')
      CALL azzero(   c1b,l_c1)
      CALL memory(ip_c1t,2*ngw*nstate,'C1t')
      CALL azzero(   c1t,2*ngw*nstate)
      CALL memory(ip_j_a,nnr1*9,'Sup curr')
      CALL azzero(   j_a,nnr1*9)
      CALL memory(ip_j_b,nnr1*9,'Sdo curr')
      CALL azzero(   j_b,nnr1*9)
      CALL memory(ip_Bind,nnr1*9,'Induced Field')
      CALL azzero(   Bind,nnr1*9)
      CALL memory(ip_dg_so,3*3,'EPR-SO tensor')
      CALL azzero(   dg_so,3*3)
      CALL memory(ip_dg_soo,3*3,'EPR-SOO tensor')
      CALL azzero(   dg_soo,3*3)
      CALL memory(ip_gtensor,3*3,'EPR tensor')
      CALL azzero(   gtensor,3*3)
      CALL memory(ip_geigvec,3*3,'G eigvec')
      CALL azzero(   geigvec,3*3)
      CALL memory(ip_lower_left,3*nstate,'Lower Left')
      CALL azzero(   lower_left,3*nstate)
      CALL memory(ip_lower_left_value,3*nstate,'LLC-value')
      CALL azzero(   lower_left_value,3*nstate)
      CALL memory(ip_diffv0a,nnr1*3,'diffv0a')
      CALL azzero(   diffv0a,nnr1*3)
      CALL memory(ip_diffv0b,nnr1*3,'diffv0b')
      CALL azzero(   diffv0b,nnr1*3)
      CALL memory(ip_rhoetmp,2*nnr1,'rhoetmp')
      CALL azzero(   rhoetmp,2*nnr1)
      CALL memory(ip_vt,2*maxfft,'vt')
      CALL zazzero(  vt,maxfft)
      CALL memory(ip_vt2,2*nhg,'vt2')
      CALL zazzero(  vt2,nhg)
      CALL memory(ip_rootrho,nnr1,'rootrho')
      CALL azzero(   rootrho,nnr1)
      CALL memory(ip_doepr,nstate,'EPR:DOFULL')

      DO iB=1,3
         simple_done(iB)=.FALSE.
         simple_done(iB+3)=.FALSE.
         simple_done(iB+6)=.FALSE.
      ENDDO
      CALL MEMORY_CHECK
      IF (parent) THEN
         CALL MEMORY(ip_wanniercenters,4*nstate,'WANNIERCENT')
         CALL AZZERO(   wanniercenters,4*nstate)
      ENDIF

      if (parent) CALL PRMEM('EPR        ')
      firstshelldistance = 1.d0 ! in a.u.

      if (parent) WRITE(6,*)

C     ==--------------------------------------------------------------==
      IF (iepr_method.EQ.iepr_default) THEN
        iepr_method = iepr_csgt
        IF (tclust) THEN
           iepr_virtual = iepr_novirt
        ENDIF
      ENDIF
      IF (iepr_virtual.EQ.iepr_default) THEN
        iepr_virtual = iepr_llc
        if (iepr_method.EQ.iepr_iglo) iepr_virtual = iepr_wc
      ENDIF
      IF (iepr_virtual.EQ.iepr_novirt) telocalize = .FALSE.
      IF (T_RESTART_C1 .AND. WFOPT) then
         call stopgm('EPR/RESTART',
     &        'Use of NOOPT is compulsory for EPR RESTART')
      ENDIF
C     Synchronize NMR/EPR options
      inmr_virtual = iepr_virtual
      inmr_method = iepr_method

C     ==--------------------------------------------------------------==
C     Set aside NablaV 
C     2 options:
C       TEPROWNPOT = .FALSE. : use local potential from wfopt
C            Works fine with GO potentials
C            Works not so fine with TM potentials
C       TEPROWNPOT = .TRUE. : creates effective potential
C            V = -Z_val / r * erf( r / EPR_OWNPOT_VALUE )
C                + V_Hartree + V_xc
C
C            V differs for the 2 spin channels
C
C            NOT THOROUGHLY TESTED
C     ==--------------------------------------------------------------==

      IF (TEPR_OWNPOT) THEN
         IF (PARENT) THEN
            Write(6,'(A,T54,E12.3)')
     &      '* EPR|OWNPOT Creating eff. pot. with
     & smooth. value : ', 
     &      EPR_OWNPOT_VALUE
            Write(6,*)
         ENDIF
         CALL EPR_EFFPOT(rhoetmp(1,1),rhoe,vt,vt2)
C Calculate gradient
         CALL dv0(rhoetmp(1,1),vt,diffv0a(1,1),vt2)
         CALL dv0(rhoetmp(1,2),vt,diffv0b(1,1),vt2)
      ELSE
C Calculate gradient
         IF (PARENT) THEN
            Write(6,'(A)') '* EPR|Using local potential from
     & wavefunction optimization'
         ENDIF
         CALL dv0(vofrho0(1,1),vt,diffv0a(1,1),vt2)
         CALL dv0(vofrho0(1,2),vt,diffv0b(1,1),vt2)
      ENDIF

C     ==--------------------------------------------------------------==
C     Calculate root of norm of spin density
C     ==--------------------------------------------------------------==

      DO i1=1,nnr1
         rhoetmp(i1,1) = rhoe(i1,1) - 2.D0*rhoe(i1,2)
         rootrho(i1) = DSQRT(DABS(rhoetmp(i1,1)))
      ENDDO

C     ==--------------------------------------------------------------==
C     Calculate Hyperfine Coupling Tensors
C     ==--------------------------------------------------------------==

      IF (TEPR_HYP) CALL epr_hyp(c0,rhoetmp,psi,nstate,scr,lscr)

C     ==--------------------------------------------------------------==
C     Calculate deltaG-RMC contribution 
C     ==--------------------------------------------------------------==
      dg_rmc = 0.D0
      DO i1=1,nsup
         dg_rmc = dg_rmc + kine_one(c0(1,i1))
      ENDDO
      DO i1=nsup+1,nstate
         dg_rmc = dg_rmc - kine_one(c0(1,i1))
      ENDDO
C     zeeman + hyperfine^2 + units correction
         dg_rmc = 2.0023192778D0 * ( 1D0 / 137.03602D0 )**2 * 
     &            dg_rmc 

C     ==--------------------------------------------------------------==
C     Localize C0 
C     ==--------------------------------------------------------------==

      CALL phfac(tau0)
      CALL eicalc(eivps,eirop) ! calculate and store EIVPS and EIROP
      IF (telocalize) THEN
         twann=.TRUE.
         locl=.TRUE.
         numorb=MAX(numorb,nstate)
#ifdef PARALLEL
         LENBK=NXXFUN(N)
         nc=MAX(2*lenbk*nproc,2*ngwk*numorb)
#else
         nc=2*ngwk*numorb
#endif
C        Create memory associated with ip_sc0, ip_cs
         CALL memory(ip_sc0,nc,'SC0/tmp   ')
         CALL memory(ip_cs,nc,'CS/tmp   ')
C        Save/Set the convergence criteria
         w_eps_save = w_eps
         w_eps      = 1d-4
C        localize
         CALL localize(tau0,c0,cs,sc0,scr,lscr,nstate)
         w_eps      = w_eps_save
         swf        = .TRUE.
C        Free memory associated with ip_sc0, ip_cs
         CALL freem(IP_sc0)
         CALL freem(IP_cs)
      ENDIF
      timetag='localization.'
      if (parent) call printtime

C     ==--------------------------------------------------------------==
C     If FULL and SMART, leave out some calculations
C     ==--------------------------------------------------------------==

      DO i1=1,nstate
        doepr(i1)=.TRUE.
      ENDDO

      IF(TEPR_SMART .AND. TEPR_FULL) THEN
       dummy2=0
       DO i1=1,nstate
         call fftTOr(c0(1,i1),rhoe(1,1),psi,ngw,.false.)
         dummy=0.D0
         DO i2=1,nnr1
           dummy=DABS(rhoe(i2,1))*rootrho(i2)+dummy
         ENDDO
         CALL GLOSUM(1,dummy)
         IF (dummy*DSQRT(OMEGA)/DBLE(NR1S*NR2S*NR3S).LT.
     &   EPR_SMART_VALUE) THEN
           doepr(i1)=.FALSE.
           dummy2=dummy2+1
         ENDIF
       ENDDO
       dummy=0.D0
       IF (PARENT) THEN
          Write(6,'(A,T54,E12.3)')
     &    '* EPR|SMART Threshold value : ',
     &    EPR_SMART_VALUE
          Write(6,'(A,T62,I4)')
     &  '* EPR|SMART Orbitals left out of full calculation : ', 
     &    dummy2
          Write(6,*)
       ENDIF
      ENDIF

C     ==--------------------------------------------------------------==
C     Calculate C1 
C     ==--------------------------------------------------------------==

      CALL memory_check
      CALL lag_mult(c0,h1psi0,psi,scr,lscr,rhoe,z11,nstate)
      timetag='lagrange multipliers.'
      IF (parent) CALL printtime
C     ==--------------------------------------------------------------==
      IF (Tprintwfns) 
     &    CALL print_wavefunctions(c0,nstate,psi)
      IF (Tprintrho) 
     &    CALL print_orbital_densities(c0,nstate,psi,scr)
C     ==--------------------------------------------------------------==
      IF (iepr_virtual.EQ.iepr_llc) THEN
         IF (tepr_overlaps) THEN
            CALL calc_lower_left_optimize(c0,c1,nstate,scr,psi)
         ELSE
            CALL calc_lower_left_new(c0,nstate,scr,psi)
            IF (full_optimization) then
C     TESTING: LLC optimization...
               CALL memory(ip_neighborlist,3*nstate,'EPR:NLIST')
               CALL memory(ip_dowfopt,3*nstate,'EPR:CLIST')
               
               firstshelldistance= MIN(1.5D0, alat/20D0)
               IF (parent) THEN
                   PRINT *,'PROCEDURE:'
                   PRINT *,' new LLC opti / 1 x ',
     &                 firstshelldistance,' a.u.'
               ENDIF
 
               CALL optimize_llc_indep(neighborlist,dowfopt,nstate)
              
               firstshelldistance=0.1D0
               CALL make_listofstates(neighborlist,dowfopt,nstate)
 
               CALL freem(ip_neighborlist)
               CALL freem(ip_dowfopt)
            ENDIF               ! full_optimization
         ENDIF
      ELSEIF (iepr_virtual.EQ.iepr_novirt) THEN
        DO is=1,nstate          ! -> All wfns have same virtual box
          DO ik=1,3
            lower_left_value(ik,is) = -nris(ik)/2
            lower_left(ik,is) = 1
          ENDDO
        ENDDO
      ENDIF                     ! virtual orbitals
      CALL force_xyz(nstate)! if the corresponding options FORCE(x,...)
                                ! are switched on,
                                ! the X/Y/Z - LLCs are averaged.
      IF (parent) CALL print_LLC(nstate)

      timetag='LLC initialization.'
      IF (parent) CALL printtime
      CALL memory_check
C     ==--------------------------------------------------------------==
      if (T_RESTART_C1) call restart_epr(simple_done,
     &     nstate,RESPONSE_READ)

C     ==--------------------------------------------------------------==
      DO iB=iL_start,iL_end 
         IF (parent) WRITE (6,98)
         IF (parent) WRITE (6,96) 'L',iB

         tag = 'L_'//xyz(iB)
         IF (t_restart_c1 .AND. simple_done(iB)) 
     &        CALL restart_p(c1b(1,1,iB),tag,nstate,response_read)
         IF (.NOT. simple_done(iB)) THEN
            CALL make_123(iB,ii,iii)
            DO is=1,nstate      ! apply r_ii p_iii - r_iii p_ii:
               CALL set_origin (is)
               CALL apply_op_p(c0(1,is), scr(1,1), ii, ngw)
               CALL apply_op_p(c0(1,is), scr(1,2), iii, ngw)
               CALL fft2TOr(scr(1,1), scr(1,1),
     &              scr(1,2),scr(1,2), psi, ngw,.false.)
               CALL apply_op_rx(scr(1,1), -1d0, rhoe,  0d0, iii)
               CALL apply_op_rx(scr(1,2),  1d0, rhoe,  1d0,  ii)
               CALL fftTOg(rhoe, h1psi0(1,is), psi, ngw,.false.)
            ENDDO

            timetag='preparation.'
             IF (parent) CALL printtime
             IF (parent) WRITE (6,98)
            CALL tiset('PSI1-WF-OPT',isub2)
            CALL rwfopt_p(c0,c1b(1,1,iB),psi,rhoe,dummy,scr,lscr,
     &           eirop,eivps,dummy,h1psi0,
     &           z11,nstate,dummy)
            CALL tihalt('PSI1-WF-OPT',isub2)
            timetag='calculation of psi^1.'
            IF (parent) CALL printtime
            IF (exsoft) GOTO 441
            IF (parent) WRITE (6,98)

            tag = 'L_'//xyz(iB)
            CALL restart_p(c1b(1,1,iB),tag,nstate,RESPONSE_WRITE)
            simple_done(iB) = .true.
            CALL restart_epr(simple_done,
     &           nstate,response_write)
         ENDIF                  ! if simple calculation not already done
         CALL memory_check
      ENDDO                     ! iB
C     ==--------------------------------------------------------------==
      DO iB=ip_start,ip_end
         IF (parent) WRITE (6,98)
         IF (parent) WRITE (6,96) 'p',iB
         
         tag = 'p_'//xyz(iB)
         IF (t_restart_c1 .AND. simple_done(iB+3)) 
     &        CALL restart_p(c1(1,1,iB),tag,nstate,response_read)
         IF (.NOT. simple_done(iB+3)) THEN
            DO is=1,nstate
               call apply_op_p(c0(1,is), h1psi0(1,is), iB, ngw)
            ENDDO
            timetag='preparation.'
            IF (parent) CALL printtime
            IF (parent) WRITE (6,98)
            CALL tiset('PSI1-WF-OPT',isub2)
            CALL rwfopt_p(c0,c1(1,1,iB),psi,rhoe,dummy,scr,lscr,
     &           eirop,eivps,dummy,h1psi0,
     &           z11,nstate,dummy)
            CALL tihalt('PSI1-WF-OPT',isub2)
            IF (parent) WRITE (6,98)
            timetag='calculation of psi^1.'
            IF (parent) CALL printtime
            IF (exsoft) GOTO 441
            tag = 'p_'//xyz(iB)
            CALL restart_p(c1(1,1,iB),tag,nstate,RESPONSE_WRITE)
            simple_done(iB+3) = .TRUE.
            CALL restart_epr(simple_done,
     &           nstate,response_write)
         ENDIF                  ! if simple calculation not already done
         CALL memory_check
      ENDDO                     ! iB
 441  CONTINUE
C     ==--------------------------------------------------------------==
       IF (parent) THEN
          WRITE (6,99)
       ENDIF
C     ==--------------------------------------------------------------==
      IF (exsoft) GOTO 444
      IF (tepr_full) THEN
         IF (parent) WRITE(6,*) '*** STARTING FULL Calculation'
         CALL memory(ip_neighborlist,3*nstate,'EPR:NLIST')
         CALL memory(ip_dowfopt,3*nstate,'EPR:CLIST')
         CALL make_listofstates(neighborlist,dowfopt,nstate)
         CALL memory_check
C     neighborlist now contains the states in a reasonable 
C     proximity-determined order, and dowfopt indicates whether or not
C     rwfopt_p should be called for that state.
 
         IF (.NOT. full_optimization) THEN
            DO is=1,nstate
               DO iB=1,3
                  dowfopt(iB,is) = .TRUE. 
               ENDDO
            ENDDO
            IF (parent) THEN
               print *,'*** *** *** *** *** *** *** *** *** *** *** ***'
               print *,'*** *** UNCONDITIONAL  RWFOPT_P:    *** *** ***'
               print *,'*** *** *** *** *** *** *** *** *** *** *** ***'
            ENDIF
         ELSE
            IF (parent) THEN
               print *,'*** *** *** *** *** *** *** *** *** *** *** ***'
               print *,'*** *** ONLY SELECTIVE RWFOPT_P:    *** *** ***'
               print *,'*** *** *** *** *** *** *** *** *** *** *** ***'
            ENDIF
         ENDIF 
         DO is=1,nstate
            DO iB=1,3
               dowfopt(iB,is)=dowfopt(iB,is) .AND. doepr(is)
            ENDDO
         ENDDO
 
         tolog_p = tolog_p * 1d2
C     100 is a large number, but it seems to work...
         cg_analytic = 0 
 
         DO iB=1,3
           IF (.not. simple_done(iB+6)) THEN
            DO is=1,nstate      ! "is" is only an INDEX!!!
                                ! The state is i_state !
               i_state = neighborlist(iB,is)
               IF (doepr(i_state)) THEN
                 CALL epr_do_full(i_state,iB,
     &                 dowfopt(iB,i_state),
     &                 h1psi0,c0,c1,c1b,c1t,scr,psi,rhoe,
     &                 eirop,eivps,z11,nstate,lscr)
               ELSE
                 IF (PARENT) write(6,'(A,T29,I4,32X,"*")') '*  EPR|SMART
     & Omitting state ',i_state
               ENDIF
               IF (exsoft) GOTO 442
            ENDDO               ! i_state = 1,...,nstate.
            tag = 'L_'//xyz(iB)
            CALL restart_p(c1b(1,1,iB),tag,nstate,RESPONSE_WRITE)
            simple_done(iB+6) = .true.
            CALL restart_epr(simple_done,
     &           nstate,response_write)
           ELSE
            IF (PARENT) THEN
             write (6,98)
             write (6,89) xyz(iB)
             write (6,'(A)') 'RESPONSE wavefunction read
     & from RESTART file'
             write (6,98)
            ENDIF
           ENDIF 
         ENDDO                  ! iB = 1,2,3

 442  CALL freem(ip_neighborlist)
      CALL freem(ip_dowfopt)
      IF (PARENT) WRITE(6,*)

      ENDIF                     ! full calculation
C     ==--------------------------------------------------------------==

C     ==--------------------------------------------------------------==
C     Calc induced Current and Magnetic Field
C     ==--------------------------------------------------------------==
 
      CALL epr_current(c0,c1,c1b,c1t,nstate,Bind(1,1),j_a(1,1),j_b(1,1),
     &     psi,rhoe,vofrho0,scr,lscr,epr_chi(1,1))

C     ==--------------------------------------------------------------==
C     Printing output from earlier calculation
C     ==--------------------------------------------------------------==

#ifdef PARALLEL
      CALL glosum(1,dg_rmc)
#endif

      IF (PARENT) THEN
       WRITE(6,'(/,A,A)') ' ********************** DEBUG INFORMATION',
     &                   ' ***********************'

       WRITE(6,*) ' EPR deltaG-MATRIX RMC CORRECTION '
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &      dg_rmc,0.D0,0.D0,' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &      0.D0,dg_rmc,0.D0,' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ', 
     &      0.D0,0.D0,dg_rmc,' ]'
      ENDIF

C     ==--------------------------------------------------------------==
C     Calculate deltaG-SOO contribution          
C     ==--------------------------------------------------------------==

C     G eq 0. Assuming a spheric sample -> kappa = 2/3 (hard-coded)

      DO i1=1,3
        DO i2=1,3
           dg_sootemp = 0.D0
           DO i3=1,nnr1
              dg_sootemp = dg_sootemp - 2.D0/3.D0 * epr_chi(i1,i2)
     &                     *rhoetmp(i3,1)
           ENDDO
C          Perform the following:
C          * OMEGA/DBLE(nr1s*nr2s*nr3s) ! from int(r x j(r))
C          * FPI * alpha**2 / OMEGA
           dg_sootemp = dg_sootemp / DBLE(nr1s*nr2s*nr3s)* FPI *
     &                  (1.D0/137.03602D0)**2 / 2.D0
C          And now the SOO term, for G=0
           dg_soo(i1,i2) = dg_soo(i1,i2) +
     &                     2.D0*dg_sootemp*(1.D0/137.03602D0)/
     &                     DBLE(nr1s*nr2s*nr3s)
        ENDDO ! i2
      ENDDO ! i1

C     G neq 0
 
       DO i1=1,3
         DO i2=1,3
            dg_sootemp = 0.D0
            DO i3=1,nnr1
               dg_sootemp = dg_sootemp -  
     &             Bind(i3, (i1-1)*3 + i2) * rhoetmp(i3,1)
            ENDDO
            dg_soo(i1,i2) = dg_soo(i1,i2) + 
     &                      2.D0*dg_sootemp*(1.D0/137.03602D0)/
     &                      DBLE(nr1s*nr2s*nr3s)
         ENDDO ! i2
       ENDDO ! i1
 
#ifdef PARALLEL
      CALL glosum(3*3,dg_soo)
#endif
      IF (PARENT) THEN
       WRITE(6,*) ' EPR deltaG-MATRIX SOO CORRECTION '
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &   dg_soo(1,1),dg_soo(1,2),dg_soo(1,3),' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &   dg_soo(2,1),dg_soo(2,2),dg_soo(2,3),' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ', 
     &   dg_soo(3,1),dg_soo(3,2),dg_soo(3,3),' ]'
      ENDIF

C     ==--------------------------------------------------------------==
C     Calculate deltaG-SpinOrbit contribution 
C     ==--------------------------------------------------------------==

      DO i1=1,3
        dg_sotemp = 0.D0
        DO i3=1,nnr1
           dg_sotemp = dg_sotemp-(j_a(i3,(i1-1)*3+2)*
     &     diffv0a(i3,3)-j_a(i3,(i1-1)*3+3)*diffv0a(i3,2) -
     &     j_b(i3,(i1-1)*3+2)*diffv0b(i3,3) + 
     &     j_b(i3,(i1-1)*3+3)*diffv0b(i3,2))
        ENDDO
        dg_so(i1,1) = (1D0/137.03602D0)**2*2.0046385556D0/2.D0*
     &                dg_sotemp/DBLE(nr1s*nr2s*nr3s)

        dg_sotemp = 0.D0
        DO i3=1,nnr1
           dg_sotemp = dg_sotemp-(j_a(i3,(i1-1)*3+3)*
     &     diffv0a(i3,1)-j_a(i3,(i1-1)*3+1)*diffv0a(i3,3) -
     &     j_b(i3,(i1-1)*3+3)*diffv0b(i3,1) + 
     &     j_b(i3,(i1-1)*3+1)*diffv0b(i3,3))
        ENDDO
        dg_so(i1,2) = (1D0/137.03602D0)**2*2.0046385556D0/2.D0*
     &                 dg_sotemp/DBLE(nr1s*nr2s*nr3s)
 
        dg_sotemp = 0.D0
        DO i3=1,nnr1
           dg_sotemp = dg_sotemp-(j_a(i3,(i1-1)*3+1)*
     &     diffv0a(i3,2)-j_a(i3,(i1-1)*3+2)*diffv0a(i3,1) -
     &     j_b(i3,(i1-1)*3+1)*diffv0b(i3,2) + 
     &     j_b(i3,(i1-1)*3+2)*diffv0b(i3,1))
        ENDDO
        dg_so(i1,3) = (1D0/137.03602D0)**2*2.0046385556D0/2.D0*
     &                dg_sotemp/DBLE(nr1s*nr2s*nr3s)
       ENDDO ! i1

#ifdef PARALLEL
      CALL glosum(3*3,dg_so)
#endif
      IF (PARENT) THEN
       WRITE(6,*) ' EPR deltaG-MATRIX SO CORRECTION '
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &    dg_so(1,1),dg_so(1,2),dg_so(1,3),' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &    dg_so(2,1),dg_so(2,2),dg_so(2,3),' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ', 
     &    dg_so(3,1),dg_so(3,2),dg_so(3,3),' ]'
      ENDIF

C     ==--------------------------------------------------------------==
C     Print G-tensor 
C     ==--------------------------------------------------------------==

      IF (PARENT) THEN
       WRITE(6,'(1X,64("*"))')
       WRITE(6,*)
       WRITE(6,'(/,A,A)') ' ************************ FINAL RESULTS',
     &                   ' *************************'

       gtensor(1,1) = dg_rmc+dg_so(1,1)+dg_soo(1,1)+2.0023192778D0
       gtensor(1,2) = dg_so(1,2)+dg_soo(1,2)
       gtensor(1,3) = dg_so(1,3)+dg_soo(1,3)
       gtensor(2,1) = dg_so(2,1)+dg_soo(2,1)
       gtensor(2,2) = dg_rmc+dg_so(2,2)+dg_soo(2,2)+2.0023192778D0
       gtensor(2,3) = dg_so(2,3)+dg_soo(2,3)
       gtensor(3,1) = dg_so(3,1)+dg_soo(3,1)
       gtensor(3,2) = dg_so(3,2)+dg_soo(3,2)
       gtensor(3,3) = dg_so(3,3)+dg_soo(3,3)+dg_rmc+2.0023192778D0
 
       WRITE(6,*) ' EPR deltaG-MATRIX '
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &    gtensor(1,1)-2.0023192778D0,gtensor(1,2),gtensor(1,3),' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &    gtensor(2,1),gtensor(2,2)-2.0023192778D0,gtensor(2,3),' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ', 
     &   gtensor(3,1),gtensor(3,2),gtensor(3,3)-2.0023192778D0,' ]'

       WRITE(6,*) ' EPR G-MATRIX '
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &    gtensor(1,1),gtensor(1,2),gtensor(1,3),' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ',
     &    gtensor(2,1),gtensor(2,2),gtensor(2,3),' ]'
       WRITE(6,'(T15,A,3(1X,F13.11),T64,A)') '[   ', 
     &    gtensor(3,1),gtensor(3,2),gtensor(3,3),' ]'
      ENDIF

C     ==--------------------------------------------------------------==
C     Calculate eigenvalues (in ppm)
C     ==--------------------------------------------------------------==
      
      IF(PARENT) THEN
       WRITE(6,'(A,T32,A)') ' PRINCIPAL VALUES (ppm)',
     &   'PRINCIPAL DIRECTIONS (degrees)'
       CALL TRMM(gtensor,3)
       CALL DSYEV('V','U', 3, gtensor, 3, geigval(1), dg_so, 9, ier)
       IF (ier .NE. 0) THEN
              Write(6,*) 'ERROR IN DSYEV, code ', ier
       ELSE
         DO ii=1,3
            geigval(ii)=(DSQRT(geigval(ii))-2.0023192778D0)*1.D6
            IF (DASIN(geigvec(2,ii)).GE.0) THEN
               dg_sotemp=DACOS(gtensor(1,ii)/DSQRT(1-gtensor(3,ii)**2))
     &                   /pi*180D0 ! abuse of dg_sotemp
            ELSE
               dg_sotemp=360D0-DACOS(gtensor(1,ii)/DSQRT(1-
     &                   gtensor(3,ii)**2))/pi*180D0 ! abuse of dg_sotemp
            ENDIF
            WRITE(6,'(T5,F8.1,T36,A,F6.2,A,F6.2,A)') geigval(ii),
     &         'th = ',DACOS(gtensor(3,ii))/pi*180D0, '  phi = ',
     &         dg_sotemp, ' '
         ENDDO
       ENDIF
      ENDIF

C     ==--------------------------------------------------------------==
C     Some finalization 
C     ==--------------------------------------------------------------==

 444  IF (parent) CALL freem(ip_wanniercenters)
      CALL freem(ip_c1)
      CALL freem(ip_c1b)
      CALL freem(ip_c1t)
      CALL freem(ip_j_a)
      CALL freem(ip_j_b)
      CALL freem(ip_Bind)
      CALL freem(ip_dg_so)
      CALL freem(ip_dg_soo)
      CALL freem(ip_gtensor)
      CALL freem(ip_geigvec)
      CALL freem(ip_lower_left)
      CALL freem(ip_lower_left_value)
      CALL freem(ip_diffv0a)
      CALL freem(ip_diffv0b)
      CALL freem(ip_rhoetmp)
      CALL freem(ip_vt)
      CALL freem(ip_vt2)
      CALL freem(ip_rootrho)

      IF (parent) WRITE (6,'("@ TIME: ",F8.1," SEC FOR ",A40)')
     &     timef()/1000.d0 - starttime,
     &    'THE WHOLE CALCULATION.      '

C     ==--------------------------------------------------------------==
      CALL tihalt('       EPR',isub)
      RETURN
      END

C     ==================================================================
      REAL*8 FUNCTION KINE_ONE(src)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
C     Arguments:
      COMPLEX*16 src(ngw)
C     Local variables:
      INTEGER    ig,isub
      REAL*8     kine_one_temp
      kine_one_temp = 0.D0
      CALL tiset('KINE_ONE  ',isub)
      DO ig=1,ngw
         kine_one_temp = kine_one_temp +
     &       DREAL(DCONJG(src(ig))*src(ig)*hg(ig))
      ENDDO
      kine_one = kine_one_temp*tpiba2
      CALL tihalt('KINE_ONE  ',isub)
      RETURN
      END

C     ==================================================================
      SUBROUTINE GIVE_SCR_EPR(lscr,tag)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'wann.inc'
      INTEGER   lscr,l_current
      CHARACTER tag*30
      lscr = 1
      IF (.NOT. TEPR) RETURN
      CALL give_scr_epr_current(l_current,tag)
      IF (TLOCALIZE) THEN
         TWANN = .TRUE.
         LOCL  = .TRUE.
         CALL give_scr_ddipo(lscr,tag)
      ENDIF

      LSCR=MAX(lscr,2*nhg,
     &     2*ngw*n,             ! for pcgrad_nmr_p
     &     12*nnr1,             ! for calc_p and calc_L
     &     l_current,           ! for NMR_CURRENT
     &     2*maxfft)            ! for use as fft scratch

      tag  = 'epr-response          '
      RETURN
      END

C     ==================================================================
      SUBROUTINE TRMM(a,n)
C     ==--------------------------------------------------------------==
C     Computes Symmetrical Matrix: Transpose(A)*A
      IMPLICIT NONE
C     Arguments
      INTEGER n
      REAL*8  a(n,n)
C     Variables
      REAL*8  b(n,n)
      INTEGER i,j,k
C     ==--------------------------------------------------------------==
      DO i=1,n
         DO j=1,n
            b(i,j)=a(i,j)
            a(i,j)=0.D0
         ENDDO
      ENDDO
      DO i=1,n
         DO j=1,n
            DO k=1,n
               a(i,j)=a(i,j)+b(k,i)*b(k,j)
            ENDDO
         ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END

