#define warning_level 5d-3
C     ==================================================================
#define mindistroutine calc_min_dist_alat_smooth
Cdefine epr_mindistroutine epr_calc_min_dist_alat
C     ==================================================================
      SUBROUTINE EPR_DO_FULL(i_state,iB,dowfopt,h1psi0,c0,c1,c1b,c1t,
     &     scr,psi,rhoe,eirop,eivps,z11,nstate,lscr)
c     =----------------------------------------------------------------=
      IMPLICIT NONE
      include 'system.h'
      include 'soft.inc'
      include 'response_p.inc'
C     Arguments:
      integer     i_state,iB,nstate,lscr
      logical     dowfopt
      complex*16  h1psi0(ngw,nstate),c0(ngw,nstate),c1(ngw,nstate,3),
     &            c1b(ngw,nstate,3),c1t(ngw,nstate,1)
      real*8      scr,psi,rhoe,eirop,eivps,z11
C     Variables:
      real*8      dummy,dij(3)
      integer     is,ii,iii,i_c1,isub,
     &            i_state_previous(3)
      save        i_state_previous
      data        i_state_previous /3*0/
      character   xyz(3)
      data        xyz /'x','y','z'/

 89   FORMAT ("*  FULL calculation: state ",I4,
     &     ", field in O",A1,20X,"*")
 98   FORMAT (52("*"),"EPR*RESPONSE*")

      i_c1 = iB+6

C     Initialization / very first call:
      if (i_state_previous(iB) .eq. 0) then
         call azzero(c1t(1,1,1),2*ngw*nstate)
         T_INITIALGUESS_C1 = .false.
         i_state_previous(iB) = i_state
      else
         T_INITIALGUESS_C1 = .true.
      endif

C     Preparation of B_iB . (d_k - d_fix) x p |psi_0_k>:
      if (parent) then
         write (6,98)
         write (6,89) i_state,xyz(iB)
         write (6,98)
      endif
      call make_123(iB,ii,iii)
      if (dowfopt) then
         call azzero(h1psi0,2*ngw*nstate)
         do is=1,nstate         ! apply dd_ii p_iii - dd_iii p_ii:
                                ! with dd = d_is - d_istate
            call mindistroutine(is,i_state,dij)
            call apply_op_p (c0(1,is), scr, ii, ngw)
            call DAXPY(2*ngw, dij(iii),scr,1,h1psi0(1,is),1)
            call apply_op_p (c0(1,is), scr, iii, ngw)
            call DAXPY(2*ngw,-dij(ii),scr,1,h1psi0(1,is),1)
         enddo
         timetag='preparation.'
         if (parent) call printtime
         if (parent) write (6,98)
         if (exsoft) return
      endif

C     Prepare a good guess for C1 from the previous optimization:
C     this should be:
C     B  .  {d_k - d_i} x |psi1^p>
C     where k is the new and i is the old correction state.
C     B = B * O_beta
C     For an unknown reason, the convergence is better WITHOUT this
C     adjustment. Bill Gates alone may have an idea why.
      if (i_state .ne. i_state_previous(iB)) then
         call mindistroutine
     &        (i_state,i_state_previous(iB),dij)
         call DAXPY(2*nstate*ngw, dij(ii),c1(1,1,iii),1,
     &        c1t(1,1,1),1)
         call DAXPY(2*nstate*ngw,-dij(iii),c1(1,1,ii),1,
     &        c1t(1,1,1),1)
         call ortho_p(nstate,c0,c1t(1,1,1))
      endif
      if (dowfopt) then
         call tiset('PSI1-WF-OPT',isub)
         call rwfopt_p(c0,c1t(1,1,1),psi,rhoe,dummy,scr,lscr,
     &        eirop,eivps,dummy,h1psi0,
     &        z11,nstate,dummy)
         call tihalt('PSI1-WF-OPT',isub)
         timetag='calculation of psi^1.'
         if (parent) call printtime
      endif

      call DAXPY(2*ngw, 1.d0, c1t(1,i_state,1),1,
     &     c1b(1,i_state,i_c1-6),1)

      CALL MEMORY_CHECK

      i_state_previous(iB) = i_state
      return
      end
c     ==================================================================
c     ==================================================================
