C     ==================================================================
      SUBROUTINE SELECTP(ISEL,TAU0,IPPC)
C     ==--------------------------------------------------------------==
C     ==            SELECT POINTS IN REAL SPACE FOR FIT               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'cnst.inc'
C     Arguments
      INTEGER ISEL(KR1,KR2S,*),IPPC
      REAL*8  TAU0(3,NAX,*)
C     Variables
      REAL*8  DA(3,3),RVDW1,RVDW2,X1,Y1,Z1,X,Y,Z,X2,Y2,Z2,RR,RDP,XPP
      INTEGER I,I1,I2,I3,IS,IA,II,JJ,IPPCS,NTEST
C     ==--------------------------------------------------------------==
      DO I=1,3
        DA(I,1)=A1(I)/DBLE(NR1S)
        DA(I,2)=A2(I)/DBLE(NR2S)
        DA(I,3)=A3(I)/DBLE(NR3S)
      ENDDO
      CALL IAZZERO(ISEL,NNR1)
      DO I3=1,NR3S
        DO I2=1,NR2S
          DO I1=1,NR1
            ISEL(I1,I2,I3)=-1
          ENDDO
        ENDDO
      ENDDO
      DO IS=1,NSP
        RVDW1=(2.D0*COVRAD(IATYP(IS))*FBOHR)**2
        RVDW2=(4.D0*COVRAD(IATYP(IS))*FBOHR)**2
        DO IA=1,NA(IS)
          X1=TAU0(1,IA,IS)
          Y1=TAU0(2,IA,IS)
          Z1=TAU0(3,IA,IS)
C$OMP parallel do private(I1,I2,I3,II,X,Y,Z,X2,Y2,Z2,RR) shared(ISEL)
          DO I3=1,NR3S
            DO I2=1,NR2S
              DO II=1,NR1
                I1=NRXPL(MEPOS,1)+II-1
                X=I1*DA(1,1)+I2*DA(1,2)+I3*DA(1,3)-X1
                Y=I1*DA(2,1)+I2*DA(2,2)+I3*DA(2,3)-Y1
                Z=I1*DA(3,1)+I2*DA(3,2)+I3*DA(3,3)-Z1
                CALL PBC(X,Y,Z,X2,Y2,Z2,1,APBC,IBRAV)
                RR=X2*X2+Y2*Y2+Z2*Z2
                IF(RR.LE.RVDW1) ISEL(II,I2,I3)=0
                IF(RR.GT.RVDW1.AND.RR.LT.RVDW2 .AND.
     *             ISEL(II,I2,I3).NE.0) ISEL(II,I2,I3)=1
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO
C..density of points
      RDP=DBLE(NR1S*NR2S*NR3S)/OMEGA
      IF(RDP.GT.50.D0) THEN
C$OMP parallel do private(I1,I2,I3,II,NTEST)
        DO I3=1,NR3S
          DO I2=1,NR2S
            DO II=1,NR1
              I1=NRXPL(MEPOS,1)+II-1
              NTEST=MOD(I1,2)*MOD(I2,2)*MOD(I3,2)
              IF(NTEST.EQ.0) ISEL(II,I2,I3)=0
            ENDDO
          ENDDO
        ENDDO
      ENDIF
      XPP=0.D0
C$OMP parallel do private(I1,I2,I3) reduction(+:IPPC)
      DO I3=1,NR3S
        DO I2=1,NR2S
          DO I1=1,NR1
            IF(ISEL(I1,I2,I3).GT.0) THEN
              IPPC=IPPC+1
            ELSE
              ISEL(I1,I2,I3)=0
            ENDIF
          ENDDO
        ENDDO
      ENDDO
      XPP=DBLE(IPPC)
      CALL GLOSUM(1,XPP)
      IPPCS=ANINT(XPP)
      IF(PARENT) WRITE(6,'(A,T40,I10,F16.4)') 
     *       ' ESP CHARGES| NUMBER OF FITTING POINTS ',IPPCS, XPP
      IF(IPPCS.LT.4*NAT.AND.PARENT) THEN
        WRITE(6,*) 'ESP CHARGES| WARNING! NOT ENOUGH FITTING POINTS.'
        WRITE(6,*) 'ESP CHARGES| WARNING! BULK SYSTEMS NOT SUPPORTED.'
        WRITE(6,*) 'ESP CHARGES| ESP CHARGES DISABLED.'
        CALL IAZZERO(ISEL,NNR1)
        RETURN
      ENDIF
      II=0
      JJ=0
      DO I3=1,KR3S
        DO I2=1,KR2S
          DO I1=1,KR1
            JJ=JJ+1
            IF(ISEL(I1,I2,I3).GT.0) THEN
              II=II+1
              ISEL(II,1,1)=JJ
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PRINTCG(TAU0,ACHRG,ECHRG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'adat.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSX),ACHRG(NAT),ECHRG(NAT)
C     Variables
      INTEGER IAT,IS,IA,K
C     ==--------------------------------------------------------------==
      WRITE(6,'(/,1X,64("*"))')
      WRITE(6,'(A,10X,A,/,15X,A)')
     * '    ATOM  ','     COORDINATES                   CHARGES'
     *,'     X         Y         Z           INT       ESP'
      IAT=0
      OPEN(UNIT=49,FILE='CHOUT',STATUS='UNKNOWN')
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          WRITE(6,'(1X,I4,1X,A2,5X,3F10.4,2X,2F10.3)') 
     *     IAT,EL(IATYP(IS)),(TAU0(K,IA,IS),K=1,3),ACHRG(IAT),ECHRG(IAT)
          WRITE(49,'(F10.3)') echrg(iat)
        ENDDO
      ENDDO
      CLOSE(49)
      WRITE(6,'(/,1X,64("*"))')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ATFIELD(EFIELD,V,VTEMP,RHOCC,QPHI,ISEL,IPPC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'isos.inc'
C     Arguments
      INTEGER    ISEL(NNR1),IPPC
      COMPLEX*16 V(*),VTEMP(NHG),QPHI(*)
      REAL*8     EFIELD(IPPC,*),RHOCC(*)
C     Variables
      DIMENSION  EIGRB(NHG,NAT)
      REAL*8     FNL(*),DFNL(*)
      COMPLEX*16 EI123
      REAL*8     VOL,QMAX,R2MAX,ER,EI,TPIT,FPIBG
      INTEGER    ISA,IS,IA,IG,I,IG1
C     ==--------------------------------------------------------------==
      ISA=0
      VOL=1.D0/OMEGA
      DO IS=1,NSP
        R2MAX=(COVRAD(IATYP(IS))*FBOHR)**2
        DO IG=1,NHG
          QMAX=0.25D0*R2MAX*HG(IG)*TPIBA2
          RHOCC(IG)=-VOL*EXP(-QMAX)
        ENDDO
        DO IA=1,NA(IS)
          ISA=ISA+1
          CALL ZAZZERO(VTEMP,NHG)
          IF(BIGMEM) THEN
C$OMP parallel do private(IG)
            DO IG=1,NHG
              VTEMP(IG)=RHOCC(IG)*EIGRB(IG,ISA)
            ENDDO
          ELSE
C$OMP parallel do private(IG,EI123,ER,EI)
            DO IG=1,NHG
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *              EI3(ISA,INYH(3,IG))
              ER=DREAL(EI123)
              EI=DIMAG(EI123)
              VTEMP(IG)=DCMPLX(ER*RHOCC(IG),EI*RHOCC(IG))
            ENDDO
          ENDIF
          IF(TCLUST) THEN
            IF(PS_TYPE.EQ.1) THEN
              CALL ZAZZERO(V,MAXFFT)
C$OMP parallel do private(IG)
!CDIR NODEP
              DO IG=1,NHG
                V(INDZ(IG)) = DCONJG(HIPZ(IG)*VTEMP(IG))
                V(NZH(IG))  = HIPZ(IG)*VTEMP(IG)
              ENDDO
              IF(GEQ0) V(NZH(1)) = VTEMP(1)
              CALL INVFFT(V)
C$OMP parallel do private(I)
              DO I=1,IPPC
                EFIELD(I,ISA+1)=DREAL(V(ISEL(I)))
              ENDDO
              CALL ZAZZERO(V,MAXFFT)
C$OMP parallel do private(IG)
!CDIR NODEP
              DO IG=1,NHG
                V(INDZ(IG)) = DCONJG(VTEMP(IG))
                V(NZH(IG))  = VTEMP(IG)
              ENDDO
              IF(GEQ0) V(NZH(1)) = VTEMP(1)
              CALL INVFFT(V)
              CALL HIP(V,QPHI)
C$OMP parallel do private(I)
              DO I=1,IPPC
                EFIELD(I,ISA+1)=EFIELD(I,ISA+1)+DREAL(V(ISEL(I)))
              ENDDO
            ELSEIF(PS_TYPE.EQ.2.OR.PS_TYPE.EQ.3) THEN
              IF(GEQ0) THEN
                VTEMP(1)=DCMPLX(0.D0,0.D0)
                IG1=2
              ELSE
                IG1=1
              ENDIF
C$OMP parallel do private(IG)
              DO IG=IG1,NHG
                VTEMP(IG)=VTEMP(IG)*SCG(IG)
              ENDDO
              CALL ZAZZERO(V,MAXFFT)
C$OMP parallel do private(IG)
!CDIR NODEP
              DO IG=1,NHG
                V(INDZ(IG)) = DCONJG(VTEMP(IG))
                V(NZH(IG))  = VTEMP(IG)
              ENDDO
              IF(GEQ0) V(NZH(1)) = VTEMP(1)
              CALL INVFFT(V)
C$OMP parallel do private(I)
              DO I=1,IPPC
                EFIELD(I,ISA+1)=DREAL(V(ISEL(I)))
              ENDDO
            ELSE
              CALL STOPGM('ESPCHG','PS_TYPE not implemented')
            ENDIF
          ELSE
            IF(GEQ0) THEN
              VTEMP(1)=DCMPLX(0.D0,0.D0)
              IG1=2
            ELSE
              IG1=1
            ENDIF
            TPIT=FPI/TPIBA2
C$OMP parallel do private(IG,FPIBG)
            DO IG=IG1,NHG
              FPIBG=TPIT/HG(IG)
              VTEMP(IG)=DCMPLX(FPIBG)*VTEMP(IG)
            ENDDO
            CALL ZAZZERO(V,MAXFFT)
C$OMP parallel do private(IG,FPIBG)
!CDIR NODEP
            DO IG=1,NHG
              V(INDZ(IG)) = DCONJG(VTEMP(IG))
              V(NZH(IG))  = VTEMP(IG)
            ENDDO
            IF(GEQ0) V(NZH(1)) = VTEMP(1)
            CALL INVFFT(V)
C$OMP parallel do private(I)
            DO I=1,IPPC
              EFIELD(I,ISA+1)=DREAL(V(ISEL(I)))
            ENDDO
          ENDIF
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ESPSOLV(EFIELD,ECHRG,IPPC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'
      INTEGER IPPC, IPIV, INFO, I, IPPCS, IJ, KK, LEN
      REAL*8 EFIELD, ECHRG, CZERO, AMAT, C_ZERO, CHOLD, QPOT, XPP,
     *       RRMSO, DIFF, DEN, RRMS
      DIMENSION AMAT(NAT+1,NAT+1),EFIELD(IPPC,*),ECHRG(*),IPIV(*)
      DIMENSION CHOLD(NAT+1),CZERO(NAT+1),QPOT(IPPC)
      POINTER(IP_AMAT,AMAT),(IP_IPIV,IPIV),(IP_CZERO,C_ZERO)
      POINTER(IP_CHOLD,CHOLD),(IP_QPOT,QPOT)
      LOGICAL FEXIST
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_CZERO,NAT+1,'CZERO')
      CALL MEMORY(IP_CHOLD,NAT+1,'CHOLD')
      CALL MEMORY(IP_QPOT,IPPC,'QPOT')
      LEN=(NAT+1)**2
      CALL MEMORY(IP_AMAT,LEN,'AMAT')
      CALL MEMORY(IP_IPIV,NAT+1,'IPIV')
      CALL AZZERO(CHOLD,NAT+1)
      CALL AZZERO(CZERO,NAT+1)
      CALL AZZERO(AMAT,LEN)
      IF(IPPC.GT.0) THEN
         CALL DGEMV('T',IPPC,NAT,1.D0,EFIELD(1,2),IPPC,EFIELD,1,0.D0,
     *        ECHRG,1)
      ELSE
         CALL AZZERO(ECHRG,NAT+1)
      ENDIF
      CALL GLOSUM(NAT,ECHRG)
      IF(LFIT.EQ.0) THEN
         ECHRG(NAT+1)=CHARGE
         LEN=(NAT+1)**2
         CALL MEMORY(IP_AMAT,LEN,'AMAT')
         CALL MEMORY(IP_IPIV,NAT+1,'IPIV')
         CALL AZZERO(AMAT,LEN)
         IF(IPPC.GT.0)
     *        CALL DGEMM('T','N',NAT,NAT,IPPC,1.D0,EFIELD(1,2),IPPC,
     *        EFIELD(1,2),IPPC,0.D0,AMAT,NAT+1)
         CALL GLOSUM(LEN,AMAT)
         DO I=1,NAT
            AMAT(NAT+1,I)=1.D0
            AMAT(I,NAT+1)=1.D0
         ENDDO
         CALL DGESV(NAT+1,1,AMAT,NAT+1,IPIV,ECHRG,NAT+1,INFO)
         CALL FREEM(IP_AMAT)
         CALL FREEM(IP_IPIV)
         CALL FREEM(IP_CZERO)
         CALL FREEM(IP_CHOLD)
         CALL FREEM(IP_QPOT)
      ELSEIF(LFIT.EQ.1) THEN
         IF(PARENT) THEN
            INQUIRE(FILE='CZERO',EXIST=FEXIST)
            IF(FEXIST) THEN
               OPEN(UNIT=49,FILE='CZERO',STATUS='UNKNOWN')
               DO I=1,NAT
                  READ(49,*) CZERO(I)
               ENDDO
               CLOSE(49)
               WRITE(6,'(A)') ' REFERENCE CHARGES FROM CZERO '
            ELSE
               DO I=1,NAT
                  CZERO(I)=0.D0
               ENDDO
               WRITE(6,'(A)') ' REFERENCE CHARGES EQUAL ZERO '
            ENDIF
         ENDIF
         XPP=DBLE(IPPC)
         CALL GLOSUM(1,XPP)
         IPPCS=NINT(XPP)
         CALL ADD_REST1_P(ECHRG,CHOLD,CZERO,NAT,IPPCS)
         ECHRG(NAT+1)=CHARGE
         CALL AZZERO(AMAT,LEN)
         IF(IPPC.GT.0)
     *        CALL DGEMM('T','N',NAT,NAT,IPPC,1.D0,EFIELD(1,2),IPPC,
     *        EFIELD(1,2),IPPC,0.D0,AMAT,NAT+1)
         CALL GLOSUM(LEN,AMAT)
         CALL ADD_REST2_P(AMAT,CHOLD,CZERO,NAT,IPPCS)
         DO I=1,NAT
            AMAT(NAT+1,I)=1.D0
            AMAT(I,NAT+1)=1.D0
         ENDDO
         CALL DGESV(NAT+1,1,AMAT,NAT+1,IPIV,ECHRG,NAT+1,INFO)
         CALL DCOPY(NAT+1,ECHRG,1,CHOLD,1)
         IF(IPPC.GT.0)
     *       CALL DGEMV('N',IPPC,NAT,1.D0,EFIELD(1,2),IPPC,ECHRG,1,0.D0,
     *       QPOT,1)
         RRMSO=RRMS
         DIFF=0.D0
         DEN=0.D0
         DO IJ=1,IPPC
            DIFF=DIFF+(EFIELD(IJ,1)-QPOT(IJ))**2
            DEN=DEN+(EFIELD(IJ,1))**2
         ENDDO
         CALL GLOSUM(1,DIFF)
         CALL GLOSUM(1,DEN)
         RRMS=DIFF/DEN
         RRMS=DSQRT(RRMS)
         IF(PARENT) THEN
            WRITE(6,'(A,10X,1F12.8)')
     *           '      RRMS=    ',RRMS
         ENDIF
         CALL FREEM(IP_AMAT)
         CALL FREEM(IP_IPIV)
         CALL FREEM(IP_CZERO)
         CALL FREEM(IP_QPOT)
         CALL FREEM(IP_CHOLD)
      ELSEIF(LFIT.EQ.2) THEN
         XPP=DBLE(IPPC)
         CALL GLOSUM(1,XPP)
         IPPCS=NINT(XPP)
         kk=0
 111     CONTINUE
         kk=kk+1
         CALL ADD_REST1_H(ECHRG,CHOLD,CZERO,NAT,IPPCS)
         ECHRG(NAT+1)=CHARGE
         CALL AZZERO(AMAT,LEN)
         IF(IPPC.GT.0)
     *        CALL DGEMM('T','N',NAT,NAT,IPPC,1.D0,EFIELD(1,2),IPPC,
     *        EFIELD(1,2),IPPC,0.D0,AMAT,NAT+1)
         CALL GLOSUM(LEN,AMAT)
         CALL ADD_REST2_H(AMAT,CHOLD,CZERO,NAT,IPPCS)
         DO I=1,NAT
            AMAT(NAT+1,I)=1.D0
            AMAT(I,NAT+1)=1.D0
         ENDDO
         CALL DGESV(NAT+1,1,AMAT,NAT+1,IPIV,ECHRG,NAT+1,INFO)
         CALL DCOPY(NAT+1,ECHRG,1,CHOLD,1)
         IF(IPPC.GT.0)
     *       CALL DGEMV('N',IPPC,NAT,1.D0,EFIELD(1,2),IPPC,ECHRG,1,0.D0,
     *       QPOT,1)
         RRMSO=RRMS
         DIFF=0.D0
         DEN=0.D0
         DO IJ=1,IPPC
            DIFF=DIFF+(EFIELD(IJ,1)-QPOT(IJ))**2
            DEN=DEN+(EFIELD(IJ,1))**2
         ENDDO
         CALL GLOSUM(1,DIFF)
         CALL GLOSUM(1,DEN)
         RRMS=DIFF/DEN
         RRMS=DSQRT(RRMS)
         IF(PARENT) THEN
            WRITE(6,'(A,10X,1F12.8)')
     *           '      RRMS=    ',RRMS
         ENDIF
         IF(DABS(RRMS-RRMSO).GT.1.D-4.AND.kk.lt.5)  GOTO 111
         CALL FREEM(IP_AMAT)
         CALL FREEM(IP_IPIV)
         CALL FREEM(IP_CZERO)
         CALL FREEM(IP_QPOT)
         CALL FREEM(IP_CHOLD)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE  ADD_REST1_P(ECHRG,CHOLD,CZERO,NAT,IPPCS)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ECHRG(*),CHOLD(*),CZERO(*)
      RES=0.0000058*IPPCS
      DO I=1,NAT
        IF(CZERO(I).LT.100) THEN
          ECHRG(I)=ECHRG(I)+RES*CZERO(I)
        ENDIF
      ENDDO
      RETURN
      END
C     ==================================================================
      SUBROUTINE  ADD_REST2_P(AMAT,CHOLD,CZERO,NAT,IPPCS)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(NAT+1,NAT+1),CHOLD(*),CZERO(*)
      RES=0.0000058*IPPCS
      DO I=1,NAT
        IF(CZERO(I).LT.100) THEN
          AMAT(I,I)=AMAT(I,I)+RES
        ELSE
          AMAT(I,I)=AMAT(I,I)+1000.D0
        ENDIF
      ENDDO
      RETURN
      END
c     ==================================================================
      SUBROUTINE  ADD_REST1_H(ECHRG,CHOLD,CZERO,NAT,IPPCS)  
      IMPLICIT REAL*8 (A-H,O-Z)  
      DIMENSION ECHRG(*),CHOLD(*),CZERO(*)  
      RES1=0.0000058*IPPCS
      RES2=0.1   
      DO I=1,NAT  
        FACT=0.5D0/DSQRT(CHOLD(I)**2+RES2**2)  
        ECHRG(I)=ECHRG(I)-RES1*CHOLD(I)*FACT  
      ENDDO  
      RETURN  
      END  
c     ==================================================================
      SUBROUTINE  ADD_REST2_H(AMAT,CHOLD,CZERO,NAT,IPPCS)
      IMPLICIT REAL*8 (A-H,O-Z)  
      DIMENSION AMAT(NAT+1,NAT+1),CHOLD(*),CZERO(*)  
      RES1=0.0000058*IPPCS
      RES2=0.1  
      DO I=1,NAT  
        FACT=1.D0/DSQRT(CHOLD(I)**2+RES2**2)  
        AMAT(I,I)=AMAT(I,I)+RES1*CHOLD(I)*FACT  
      ENDDO  
      RETURN  
      END  
c     ==================================================================

