C     ==================================================================
      SUBROUTINE EVIRIAL(TAUP,EVIRI)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==                REAL IONIC KINETIC ENERGY                     ==
C     ==                WITH THE VIRIAL ESTIMATOR                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'cnst.inc'
C     Arguments
      REAL*8    TAUP(3,NAX,NSX,*),EVIRI
C     Variables
      REAL*8    RMEAN(3),RNP,XLM,YLM,ZLM,FGLIB
      INTEGER   IS,IA,K,IP
C     ==--------------------------------------------------------------==
      RNP=DBLE(NP_TOTAL)
      EVIRI=0.0D0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          DO K=1,3
            RMEAN(K)=0.0D0
            DO IP=1,NP_TOTAL
              RMEAN(K)=RMEAN(K)+TAUP(K,IA,IS,IP)
            ENDDO
            RMEAN(K)=RMEAN(K)/RNP
          ENDDO
          DO IP=1,NP_TOTAL
            XLM=TAUP(1,IA,IS,IP)-RMEAN(1)
            YLM=TAUP(2,IA,IS,IP)-RMEAN(2)
            ZLM=TAUP(3,IA,IS,IP)-RMEAN(3)
            CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
            EVIRI=EVIRI-XLM*FIONKS(1,IA,IS,IP)
     *                 -YLM*FIONKS(2,IA,IS,IP)
     *                 -ZLM*FIONKS(3,IA,IS,IP)
          ENDDO
        ENDDO
      ENDDO
C     note that FIONKS is already divided by NP
CGLIB ACCOUNT ONLY FOR DYNAMICAL DEGREES OF FREEDOM IF CONTRAINTS!
      FGLIB=(GLIB+3.0D0*NAT*(RNP-1))/RNP
      EVIRI=FGLIB*TEMPW/(2.0D0*FACTEM) + EVIRI/2.0D0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
