C     ==================================================================
      SUBROUTINE EXDIPO(IST,TAU0,V,EIROP)
C     ==--------------------------------------------------------------==
C     == CALCULATES EXCITED STATE DIPOLE MOMENT                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'dipo.inc'
      INCLUDE 'lodp.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'prop.inc'
C     Arguments
      INTEGER    IST
      COMPLEX*16 V(NNR1),EIROP(NHG)
      REAL*8     TAU0(3,NAX,NSP)
C     Variables
      INTEGER    ISUB,I
C     ==--------------------------------------------------------------==
      CALL TISET('    EXDIPO',ISUB)
      IF(LOCD) THEN
        CALL LODIPO(EIROP,V)
        DO I=1,NUMBLD
          EXD(1,I,IST)=DMOMLO(1,I)
          EXD(2,I,IST)=DMOMLO(2,I)
          EXD(3,I,IST)=DMOMLO(3,I)
        ENDDO
      ELSE
        CALL DIPO(TAU0,EIROP,V)
        EXD(1,1,IST)=DMOM(1)
        EXD(2,1,IST)=DMOM(2)
        EXD(3,1,IST)=DMOM(3)
      ENDIF
      CALL TIHALT('    EXDIPO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TRANSM(IST,TAU0,V,EIROP)
C     ==--------------------------------------------------------------==
C     == CALCULATES TRANSITION MOMENT                                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'dipo.inc'
      INCLUDE 'lodp.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'prop.inc'
C     Arguments
      INTEGER    IST
      COMPLEX*16 V(NNR1),EIROP(NHG)
      REAL*8     TAU0(3,NAX,NSP)
C     Variables
      INTEGER    ISUB,I
C     ==--------------------------------------------------------------==
      CALL TISET('    TRANSM',ISUB)
      IF(LOCD) THEN
        CALL LODIPO(EIROP,V)
        DO I=1,NUMBLD
          TRMOM(1,I,IST)=DMOMLO(1,I)
          TRMOM(2,I,IST)=DMOMLO(2,I)
          TRMOM(3,I,IST)=DMOMLO(3,I)
        ENDDO
      ELSE
        CALL DIPO(TAU0,EIROP,V)
        TRMOM(1,1,IST)=DMOM(1)
        TRMOM(2,1,IST)=DMOM(2)
        TRMOM(3,1,IST)=DMOM(3)
      ENDIF
      CALL TIHALT('    TRANSM',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

