C     ==================================================================
      SUBROUTINE EXTERP
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'extpot.inc'
      INCLUDE 'efld.inc'
C     Variables
      REAL*8  EXTPOT(KR1*KR2S*KR3S)
      REAL*8  EXTF(KR1*KR2S*KR3S)
      INTEGER NN
C     ==--------------------------------------------------------------==
      IF(TEXPOT) THEN
        NN=KR1*KR2S*KR3S
c        nn=nr1*nr2s*nr3s
        CALL MEMORY(IP_EXTPOT,NN,'EXTPOT')
        CALL READ_POT(EXTPOT)
        IF(TEXADD) IP_EXTF=IP_EXTPOT
        IF(PARENT) CALL PRMEM('    EXTERP')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE READ_POT(EXTPOT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'isos.inc'        ! TCLUST
C     Arguments
      REAL*8  EXTPOT(KR1,KR2S,KR3S)
C     Variables
      INTEGER KK,IR2,I
#ifdef PARALLEL
      REAL*8  PSCR(KR2S,*)
      POINTER (IP_PSCR,PSCR)
      INTEGER IR,IPP,IPX,IP,MSGID,MSGLEN,NBYTES,IRR
#else
      INTEGER IR1
#endif      
C     ==--------------------------------------------------------------==
      KK=KR2S*NR3S
c      if(parent) open(99,file='extpot.grid')
      if(parent) open(99,file='extpot.unfo.grid',form='unformatted')
      if(parent) write (6,'(A)')
     $   ' READING EXTERNAL POTENTIAL FROM extpot.unfo.grid'
      if(parent.and.texadd) write (6,'(A)')
     $   ' EXTERNAL POTENTIAL ADDED TO FORCES ACTING ON IONS'
      if(parent.and..not.tclust) write (6,'(A)')
     $   ' WARNING! APPLYING FIELD IN REAL-SPACE FOR A PERIODIC SYSTEM!'
      call azzero(extpot,kr1*kr2s*kr3s)
#ifdef PARALLEL
      CALL MEMORY(IP_PSCR,KK,'PSCR')
      DO IR=1,NR1S
        IF(PARENT) THEN
          call azzero(pscr,kk)
          do ir2=1,nr2s   ! read y
             read(99)(PSCR(IR2,I),I=1,nr3s)   ! read z
          enddo
C        READ(99) (PSCR(I),I=1,KK)
        ENDIF
        DO IPP=1,NPROC
          IF(IR.GE.NRXPL(IPP-1,1).AND.IR.LE.NRXPL(IPP-1,2)) THEN
            IPX=IPP
            GOTO 10
          ENDIF
        ENDDO
        CALL STOPGM('RD30POT','ERROR IN NRXPL')
   10   CONTINUE
        IP=PGROUP(IPX)
        CALL MY_SYNC(ALLGRP)
        IF(IP.NE.SOURCE) THEN
          IF(PARENT) THEN
            MSGID=1
            MSGLEN=KK * 8
            CALL MY_BSEND(PSCR,MSGLEN,IP,MSGID)
          ELSEIF(ME.EQ.IP) THEN
            MSGID=1
            MSGLEN=KK * 8
            CALL MY_BRECV(PSCR,MSGLEN,PGROUP(1),MSGID,NBYTES)
          ENDIF
          CALL MY_SYNC(ALLGRP)
        ENDIF
        IF(IP.EQ.ME) THEN
          IRR=IR-NRXPL(MEPOS,1)+1
          CALL DCOPY(KK,PSCR,1,EXTPOT(IRR,1,1),kr1)
        ENDIF
      ENDDO
      CALL FREEM(IP_PSCR)
#else
c     fixant que NR1=x ;  KK=y*z

      do ir1=1,nr1     ! read x      
         do ir2=1,nr2s   ! read y
c            read(99,*)(PSCR(I),I=1,nr3s)   ! read z
              read(99)(EXTPOT(IR1,IR2,I),I=1,nr3s)
c             read(99,*)(EXTPOT(IR1,IR2,I),I=1,nr3s)
c             do ir3=1,nr3s
c                EXTPOT(IR1,IR2,IR3)=10.0d0*EXTPOT(IR1,IR2,IR3)
c             enddo
         enddo
      enddo
#endif
      if(parent) close(99)
      RETURN
      END
C     ==================================================================
