C     ==================================================================
      SUBROUTINE FFSUM(DSUMPS)
C     ==--------------------------------------------------------------==
C     == Calculate DSUMPS(1:NHG)                                      ==
C     ==         = derivative of local pseudopotential part           ==
C     ==           * structure factor                                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      COMPLEX*16 DSUMPS(NHG)
C     Variables
      COMPLEX*16 SFACS
      REAL*8     CURVD,VOL,DSUML,FNL,DFNL
      INTEGER    ISA0,IS,IG,IA,ISA
      DIMENSION  GGNH(NSPLPO),VOO(NSPLPO,2,NSX),EIGRB(NHG,NAT)
C     ==--------------------------------------------------------------==
      VOL=1.D0/OMEGA
      IF(BIGMEM) THEN 
!$OMP parallel do private(IG,IS,IA,ISA0,ISA,SFACS,DSUML)
#ifdef __SR8000
*poption parallel, tlocal(IG,IS,IA,ISA0,ISA,SFACS,DSUML)
#endif 
        DO IG=1,NHG
          ISA0=0
          DO IS=1,NSP
            SFACS=(0.0D0,0.0D0)
            DSUML=-VOL*CURVD(HG(IG),NSPLPO,GGNH(1),VOO(1,1,IS),
     *                       VOO(1,2,IS),0.0D0)/TPIBA2*2.D0
            DO IA=1,NA(IS)
              ISA=ISA0+IA
              SFACS=SFACS+EIGRB(IG,ISA)
            ENDDO
            DSUMPS(IG) = DSUMPS(IG) + SFACS*DSUML
            ISA0=ISA0+NA(IS)
          ENDDO
        ENDDO
      ELSE 
!$OMP parallel do private(IG,IS,IA,ISA0,ISA,SFACS,DSUML)
#ifdef __SR8000
*poption parallel, tlocal(IG,IS,IA,ISA0,ISA,SFACS,DSUML)
#endif 
        DO IG=1,NHG
          ISA0=0
          DO IS=1,NSP
            SFACS=(0.0D0,0.0D0)
            DSUML=-VOL*CURVD(HG(IG),NSPLPO,GGNH(1),VOO(1,1,IS),
     *                       VOO(1,2,IS),0.0D0)/TPIBA2*2.D0
            DO IA=1,NA(IS)
              ISA=ISA0+IA
              SFACS=SFACS+EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *            EI3(ISA,INYH(3,IG))
            ENDDO
            DSUMPS(IG) = DSUMPS(IG) + SFACS*DSUML
            ISA0=ISA0+NA(IS)
          ENDDO
        ENDDO
      ENDIF 
      IF(GEQ0) DSUMPS(1)=0.D0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
