C     ==================================================================
      SUBROUTINE FFT3D(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    LDX,LDY,LDZ,NX,NY,NZ,ISIGN
      COMPLEX*16 X(*)
      REAL*8     SCALE
C     Variables
      DIMENSION XF(*),YF(*)
C     ==--------------------------------------------------------------==
#if defined(FFT_DEFAULT)
      CALL FFT3D_DEFAULT(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
#elif defined(FFT_ESSL)
      CALL FFT3D_ESSL(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
#elif defined(FFT_HPT)
      CALL FFT3D_HP(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
#elif defined(FFT_T3DT)
      CALL FFT3D_T3D(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
#elif defined(FFT_YMPT)
      CALL FFT3D_YMP(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
#elif defined(FFT_X1)
      CALL FFT3D_X1(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
#elif defined(FFT_SCSL) 
      CALL FFT3D_SCSL(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
#elif defined(FFT_FFTW)
      CALL FFT3D_FFTW(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
#else
      CALL STOPGM("FFT3D","FFT LIBRARY NOT AVAILABLE")
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FFT3D_DEFAULT(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    LDX,LDY,LDZ,NX,NY,NZ,ISIGN
      COMPLEX*16 X(*)
      REAL*8     SCALE
C     Variables
      DIMENSION XF(*),YF(*)
C     ==--------------------------------------------------------------==
      CALL MLTFFT_DEFAULT('N','T',X,LDX,LDY*LDZ,XF,LDY*LDZ,LDX,NX,
     *                    LDY*LDZ,ISIGN,1.D0)
      CALL MLTFFT_DEFAULT('N','T',XF,LDY,LDX*LDZ,YF,LDX*LDZ,LDY,NY,
     *                    LDX*LDZ,ISIGN,1.D0)
      CALL MLTFFT_DEFAULT('N','T',YF,LDZ,LDY*LDX,X,LDY*LDX,LDZ,NZ,
     *                    LDY*LDX,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FFT3D_T3D(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    LDX,LDY,LDZ,NX,NY,NZ,ISIGN
      COMPLEX*16 X(*)
      REAL*8     SCALE
C     Variables
      DIMENSION XF(*),YF(*)
C     ==--------------------------------------------------------------==
      CALL MLTFFT_CRAY('N','T',X,LDX,LDY*LDZ,XF,LDY*LDZ,LDX,NX,
     *                 LDY*LDZ,ISIGN,1.D0)
      CALL MLTFFT_CRAY('N','T',XF,LDY,LDX*LDZ,YF,LDX*LDZ,LDY,NY,
     *                 LDX*LDZ,ISIGN,1.D0)
      CALL MLTFFT_CRAY('N','T',YF,LDZ,LDY*LDX,X,LDY*LDX,LDZ,NZ,
     *                 LDY*LDX,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FFT3D_HP(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    LDX,LDY,LDZ,NX,NY,NZ,ISIGN
      COMPLEX*16 X(*)
      REAL*8     SCALE
C     Variables
      DIMENSION XF(*),YF(*)
C     ==--------------------------------------------------------------==
      CALL MLTFFT_HP('N','T',X,LDX,LDY*LDZ,XF,LDY*LDZ,LDX,NX,
     *               LDY*LDZ,ISIGN,1.D0)
      CALL MLTFFT_HP('N','T',XF,LDY,LDX*LDZ,YF,LDX*LDZ,LDY,NY,
     *               LDX*LDZ,ISIGN,1.D0)
      CALL MLTFFT_HP('N','T',YF,LDZ,LDY*LDX,X,LDY*LDX,LDZ,NZ,
     *               LDY*LDX,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FFT3D_ESSL(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    LDX,LDY,LDZ,NX,NY,NZ,ISIGN
      COMPLEX*16 X(*)
      REAL*8     SCALE
C     Variables
#if defined(FFT_ESSL)
      INTEGER   NAUX
      PARAMETER (NAUX=60000)
      REAL*8    AUX(NAUX)
C     ==--------------------------------------------------------------==
      CALL DCFT3(X,LDX,LDX*LDY,X,LDX,LDX*LDY,NX,NY,NZ,
     *           ISIGN,SCALE,AUX,NAUX)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FFT3D_YMP(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    LDX,LDY,LDZ,NX,NY,NZ,ISIGN
      COMPLEX*16 X(*)
      REAL*8     SCALE
C     Variables
#if defined(FFT_YMP)
      INTEGER   NAUX
      PARAMETER (NAUX=512*256)
      REAL*8    AUX(NAUX),TABLE(100+2*2048)
      INTEGER   ISIG
C     ==--------------------------------------------------------------==
      ISIG=-ISIGN
      CALL CCFFT3D(0,NX,NY,NZ,SCALE,X,LDX,LDY,X,LDX,LDY,TABLE,AUX,0)
      CALL CCFFT3D(ISIG,NX,NY,NZ,SCALE,X,LDX,LDY,X,LDX,LDY,TABLE,AUX,0)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FFT3D_X1(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    LDX,LDY,LDZ,NX,NY,NZ,ISIGN
      COMPLEX*16 X(*)
      REAL*8     SCALE
C     Variables
#if defined(FFT_X1)
      INTEGER   NAUX
      PARAMETER (NAUX=512*256)
      REAL*8    AUX(NAUX),TABLE(100+2*2048)
      INTEGER   ISIG
C     ==--------------------------------------------------------------==
      ISIG=-ISIGN
      CALL ZZFFT3D(0,NX,NY,NZ,SCALE,X,LDX,LDY,X,LDX,LDY,TABLE,AUX,0)
      CALL ZZFFT3D(ISIG,NX,NY,NZ,SCALE,X,LDX,LDY,X,LDX,LDY,TABLE,AUX,0)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FFT3D_SCSL(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments  
      INTEGER    LDX,LDY,LDZ,NX,NY,NZ,ISIGN
      COMPLEX*16 X(*)
      REAL*8     SCALE
C     Variables 
#if defined(FFT_SCSL)
      REAL*8    AUX(2*MAX0(NX,NY,NZ)) 
      REAL*8    TABLE((2*NX+256)+(2*NY+256)+(2*NZ+256))
      INTEGER   ISIG,ISYS(0:1)
C     ==--------------------------------------------------------------==
      ISIG=-ISIGN
      ISYS(0)=1
      CALL ZZFFT3D(0,NX,NY,NZ,SCALE,X,LDX,LDY,X,LDX,LDY,
     *             TABLE,AUX,ISYS)
      CALL ZZFFT3D(ISIG,NX,NY,NZ,SCALE,X,LDX,LDY,X,LDX,LDY,
     *             TABLE,AUX,ISYS)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FFT3D_FFTW(X,LDX,LDY,LDZ,NX,NY,NZ,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    LDX,LDY,LDZ,NX,NY,NZ,ISIGN
      COMPLEX*16 X(*)
      REAL*8     SCALE
C     Variables 
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3) 
      DIMENSION XF(*),YF(*)
C     ==--------------------------------------------------------------==
      CALL MLTFFT_FFTW('N','T',X,LDX,LDY*LDZ,XF,LDY*LDZ,LDX,NX,
     *               LDY*LDZ,ISIGN,1.D0,TFFTWSDM)
      CALL MLTFFT_FFTW('N','T',XF,LDY,LDX*LDZ,YF,LDX*LDZ,LDY,NY,
     *               LDX*LDZ,ISIGN,1.D0,TFFTWSDM)
      CALL MLTFFT_FFTW('N','T',YF,LDZ,LDY*LDX,X,LDY*LDX,LDZ,NZ,
     *               LDY*LDX,ISIGN,SCALE,TFFTWSDM)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

