C     ==================================================================
      SUBROUTINE FFTPRP_DEFAULT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'rswf.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'kpts.inc'
      INTEGER   MY(2*NR2S)
      POINTER   (IP_MY,MY)
      DIMENSION MG(KR2S,KR3S),MS(*),MZ(2*NR3S),MSP(*)
      INTEGER   LDIM,NH1,NH2,NH3,IG,NY2,INY2,NY3,INY3,I,
     &          NN2,NSTATE
      REAL*8    RMEM,RSTATE
#ifdef PARALLEL
      REAL*8    XMPENM,XMAXFFT
      INTEGER   J,IMG,NGRAY,JMG,NHRAY,IJ,LEN,IP,MXRP,IXF,JJ,
     &          NY1,INY1,IPP,NL1,NL2,NRX,NR3I,NCLU,
     &          MSGLEN
#else
      INTEGER   INDY1,INDY2,INDY3
#endif
C     ==--------------------------------------------------------------==
C     GATHER ARRAY FOR FFT ALONG X
C     SPARSITY FOR FFT ALONG Y
      CALL MEMORY(IP_MG,(KR2S*KR3S)/IRAT+1,'MG')
      CALL MEMORY(IP_MZ,(2*NR3S)/IRAT+1,'MZ')
      CALL MEMORY(IP_MY,(2*NR2S)/IRAT+1,'MY')
      CALL IAZZERO(MG,KR2S*KR3S)
      CALL IAZZERO(MZ,2*NR3S)
      CALL IAZZERO(MY,2*NR2S)
      NH1=NR1S/2+1
      NH2=NR2S/2+1
      NH3=NR3S/2+1
      DO IG=1,NGW
        NY2=INYH(2,IG)
        NY3=INYH(3,IG)
        INY2=-NY2+2*NH2
        INY3=-NY3+2*NH3
        MG(NY2,NY3)=MG(NY2,NY3)+1
        MG(INY2,INY3)=MG(INY2,INY3)+1
        MY(NY2)=MY(NY2)+1
        MY(INY2)=MY(INY2)+1
        MZ(NY3)=MZ(NY3)+1
        MZ(INY3)=MZ(INY3)+1
      ENDDO
#ifdef PARALLEL
      MSGLEN = NR2S * 8/IRAT
      CALL MY_COMBINE(MY,MY(NR2S+1),MSGLEN,2,ALLGRP)
      CALL ICOPY(NR2S,MY(NR2S+1),1,MY,1)
      MSGLEN = NR3S * 8/IRAT
      CALL MY_COMBINE(MZ,MZ(NR3S+1),MSGLEN,2,ALLGRP)
      CALL ICOPY(NR3S,MZ(NR3S+1),1,MZ,1)
#endif
      KR2MIN=1
      DO I=1,KR2S
        IF(MY(I).NE.0) THEN
          KR2MIN=I
          GOTO 50
        ENDIF
      ENDDO
   50 CONTINUE
      KR2MAX=KR2S
      DO I=KR2S,1,-1
        IF(MY(I).NE.0) THEN
          KR2MAX=I
          GOTO 51
        ENDIF
      ENDDO
   51 CONTINUE
      KR3MIN=1
      DO I=1,KR3
        IF(MZ(I).NE.0) THEN
          KR3MIN=I
          GOTO 52
        ENDIF
      ENDDO
   52 CONTINUE
      KR3MAX=KR3S
      DO I=KR3,1,-1
        IF(MZ(I).NE.0) THEN
          KR3MAX=I
          GOTO 53
        ENDIF
      ENDDO
   53 CONTINUE
      CALL MEMORY(IP_NZHS,NGW/IRAT+1,'NZHS')
      CALL MEMORY(IP_INDZS,NGW/IRAT+1,'INDZS')
#ifdef PARALLEL
C     MAXIMUM OF NR1, NGRAYS AND NHRAYS FOR MP_INDEX
      NR1M = 0
      NHRM = 0
      NGRM = 0
      DO I=0,NPROC-1
        NR1M = MAX(NR1M,SPARM(5,I))
        NHRM = MAX(NHRM,SPARM(8,I))
        NGRM = MAX(NGRM,SPARM(9,I))
      ENDDO
      KR1M=MAX(NR1M+MOD(NR1M+1,2),KR1)
      IMG=0
      DO J=1,KR3S
        DO I=1,KR2S
          IF(MG(I,J).NE.0) THEN
            IMG=IMG+1
            MG(I,J)=IMG
          ENDIF
        ENDDO
      ENDDO
      NGRAY=IMG
      DO IG=NGW+1,NHG
        NY2=INYH(2,IG)
        NY3=INYH(3,IG)
        INY2=-NY2+2*NH2
        INY3=-NY3+2*NH3
        JMG=MG(NY2,NY3)
        IF(JMG.EQ.0) MG(NY2,NY3)=-1
        JMG=MG(INY2,INY3)
        IF(JMG.EQ.0) MG(INY2,INY3)=-1
      ENDDO
      DO J=1,KR3S
        DO I=1,KR2S
          IF(MG(I,J).LT.0) THEN
            IMG=IMG+1
            MG(I,J)=IMG
          ENDIF
        ENDDO
      ENDDO
      NHRAY=IMG
C     SCATTER ARRAY FOR FFT ALONG X
      CALL MEMORY(IP_MS,NHRM*2/IRAT+1,'MS')
      CALL IAZZERO(MS,2*NHRM)
      DO I=1,KR2S
        DO J=1,KR3S
          IJ=MG(I,J)
          IF(IJ.GT.0) THEN
            MS(IJ)=I
            MS(NHRM+IJ)=J
          ENDIF
        ENDDO
      ENDDO
C     CONCATENATE GATHER/SCATTER ARRAYS
      CALL MEMORY(IP_MSP,(2*NHRM*NPROC)/IRAT+1,'MSP')
      LEN = 2*NHRM * 8/IRAT
      CALL MY_CONCAT(MS,MSP,LEN,ALLGRP)
C     TRANSLATE I,J TO A SINGLE G/S INDEX
      DO IP=0,NPROC-1
        MXRP=SPARM(8,IP)
        DO IXF=1,MXRP
          JJ=IXF+IP*2*NHRM
          I=MSP(JJ)
          J=MSP(JJ+NHRM)
          MSP(JJ)=I+(J-1)*KR2S
          IF(IXF.LE.SPARM(9,IP)) MSP(JJ+NHRM)=I+(J-KR3MIN)*KR2S
        ENDDO
      ENDDO
C     REDEFINE NZH AND INDZ FOR COMPRESSED STORAGE
      NN2=1
      DO IG=1,NHG
        NY1=INYH(1,IG)
        NY2=INYH(2,IG)
        NY3=INYH(3,IG)
        INY1=-NY1+2*NH1
        INY2=-NY2+2*NH2
        INY3=-NY3+2*NH3
        NZH(IG)=NY1 + (MG(NY2,NY3)-1)*KR1S
        INDZ(IG)=INY1 + (MG(INY2,INY3)-1)*KR1S
      ENDDO
!$OMP parallel do private(IG)
      DO IG=1,NGW
        NZHS(IG)=NZH(IG)
        INDZS(IG)=INDZ(IG)
      ENDDO
C     Some dimensions used for groups
      KRX=1
      IF(NOGRP.GT.1) THEN
        MPEN=0
        DO IP=1,NOGRP
          IPP=NLINK(NOLIST(IP))
          MPEN=MPEN+SPARM(9,IPP)
        ENDDO
        XMPENM=MPEN
        CALL GLOMAX(1,XMPENM)
        MPENM=NINT(XMPENM)
        NL1=NLINK(NOLIST(1))
        NL2=NLINK(NOLIST(NOGRP))
        NRX=NRXPL(NL1,2)-NRXPL(NL2,1)+1
        KRX=NRX+MOD(NRX+1,2)
        CALL GRPGS
      ELSE
        CALL FREEM(IP_MS)
      ENDIF
C     ARRAY SIZE TO DO A 3D-FFT
      MAXFFT = MAX(KR1M*KR2S*KR3S,NPROC*NR1M*NHRM)
      IF(NOGRP.GT.1) MAXFFT = MAX(KRX*KR2S*KR3S,MAXFFT)
      IF(TCLUST) THEN
        NR3M = 0
        DO I=0,NPROC-1
          NR3I = NRZPL(I,2)-NRZPL(I,1)+1
          NR3M = MAX(NR3M,NR3I)
        ENDDO
        NCLU = NPROC * NR1M*KR2S*NR3M
        MAXFFT = MAX(NCLU,MAXFFT)
      ENDIF
      CALL MEMORY(IP_XF,2*MAXFFT*NOGRP,'XF')
      CALL MEMORY(IP_YF,2*MAXFFT*NOGRP,'YF')
      CALL AZZERO(XF,2*MAXFFT*NOGRP)
      CALL AZZERO(YF,2*MAXFFT*NOGRP)
#else
C     Gather array for sparsity
      NH1=NR1S/2+1
      NH2=NR2S/2+1
      NH3=NR3S/2+1
      NN2=KR2MAX-KR2MIN+1
      DO IG=1,NGW
        INDY1=INYH(1,IG)
        INDY2=INYH(2,IG)-KR2MIN
        INDY3=INYH(3,IG)-KR3MIN
        NZHS(IG) = INDY1 + INDY2*KR1 + INDY3*KR1*NN2
        INDY1=-INYH(1,IG)+NH1*2
        INDY2=-INYH(2,IG)+NH2*2-KR2MIN
        INDY3=-INYH(3,IG)+NH3*2-KR3MIN
        INDZS(IG) = INDY1 + INDY2*KR1 + INDY3*KR1*NN2
      ENDDO
C     ARRAY SIZE TO DO A 3D-FFT
      MAXFFT = NNR1
      CALL MEMORY(IP_XF,2*MAXFFT,'XF')
      CALL MEMORY(IP_YF,2*MAXFFT,'YF')
      CALL AZZERO(XF,2*MAXFFT)
      CALL AZZERO(YF,2*MAXFFT)
#endif
C
      CALL FREEM(IP_MG)
      CALL FREEM(IP_MZ)
      CALL FREEM(IP_MY)
C
C     FFTNPOOLS
      FFTPOOL = 0
      LMSQMAX = NHRM
      LNZF    = NHG
      LNZS    = NGW
C     ==--------------------------------------------------------------==
C     ARRAY TO KEEP THE REAL SPACE WAVEFUNCTIONS
      RSACTIVE = .FALSE.
      IF(KRWFN) THEN
        IF(TKBLOCK) CALL STOPGM('FFTPRP',
     *    'Incompatible options TKBLOCK and KRWFN')
        IF(NOGRP.EQ.1) THEN
          LWDIM = NNR1
          NSTATE = N
          IF(TKPNT) NSTATE = N*NKPNT
        ELSE
          LWDIM = KRX*KR2S*KR3S
          NSTATE = (N+NOGRP-1)/NOGRP
          IF(TKPNT) NSTATE = NSTATE*NKPNT
        ENDIF
        IF(MEMSIZE.LT.0) THEN
          MAXSTATES = NSTATE
          RSTATE=1.D0
        ELSE
          RMEM = 0.125D0*MEMSIZE*1.D6/DBLE(LWDIM)
          MAXSTATES = ((INT(RMEM)+1)/2)*2
          MAXSTATES = MIN(NSTATE,MAXSTATES)
          RMEM = MAXSTATES
          CALL GLOMIN(1,RMEM)
          MAXSTATES = NINT(RMEM)
          RSTATE= DBLE(MAXSTATES)/DBLE(NSTATE)
        ENDIF
        LDIM  = (MAXSTATES+1)/2 * LWDIM
        IF(TKPNT) LDIM = LDIM*2
        CALL MEMORY(IP_RSWF,2*LDIM,'RSWF')
        RMEM = 16.D0*LDIM*1.D-6
        IF(PARENT) THEN
          IF(RSTATE.GT.0.99999999D0) THEN
            WRITE(6,'(A,T59,A)')
     *      ' FFTPRP| ORBITALS KEPT IN REAL SPACE ','    ALL'
          ELSE
            WRITE(6,'(A,T50,F8.1,A)')
     *        ' FFTPRP| ORBITALS KEPT IN REAL SPACE ',
     *        100*RSTATE,' PERCENT'
          ENDIF
          WRITE(6,'(A,T51,F8.3,A)')
     *    ' FFTPRP| WAVEFUNCTION TAKES IN REAL SPACE ',RMEM,' MBYTES'
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PARENT) CALL PRMEM('    FFTPRP')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GRPGS
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'fft.inc'
      DIMENSION MSP(NHRM,2,*),MS(*)
      INTEGER   IPRO,IP,MXRPT,IO,II
C     ==--------------------------------------------------------------==
      IPRO=0
      MAXRPT=0
      DO IP=1,NPGRP
        MXRPT=0
        DO IO=1,NOGRP
          MXRPT=MXRPT+SPARM(9,IPRO)
          IPRO=IPRO+1
        ENDDO
        MXY(IP)=MXRPT
        IF(MAXRPT.LT.MXRPT) MAXRPT=MXRPT
      ENDDO
      CALL FREEM(IP_MS)
      CALL MEMORY(IP_MS,((MAXRPT+1)*NPGRP)/IRAT+1,'MS')
      IPRO=0
      DO IP=1,NPGRP
        MXRPT=1
        DO IO=1,NOGRP
          II=(IP-1)*MAXRPT+MXRPT
          CALL ICOPY(SPARM(9,IPRO),MSP(1,2,IPRO+1),1,MS(II),1)
          MXRPT=MXRPT+SPARM(9,IPRO)
          IPRO=IPRO+1
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
