cmb-> all FFT Hitachi SR11000 related stuff is now embedded in fftutil.F
C     ==================================================================
      SUBROUTINE TY2X
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MSP(2*NHRM,*)
      INTEGER   BLKLEN,ISUB1,LDA,IP,MXRP,I,II,JJ,ISUB2,NRX,NRS,IPP
#if defined(__SR8000) 
      INTEGER   J
#elif defined(__ES) 
      INTEGER   MOD2,J,II1,II2,JJ1,JJ2
#elif defined(__CRAYX1)
      INTEGER   MOD2,J,II1,II2,JJ1,JJ2
#endif
C     ==--------------------------------------------------------------==
C..Pack the data for sending
      CALL TISET('   FFT-G/S',ISUB1)
      LDA=NHRM*NR1M
#if defined(__SR8000)
*poption parallel
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
!$OMP parallel do private(I,J,II,JJ)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
          DO J=1,MXRP
            XF(II+J-1)=YF(JJ+MSP(J,IP+1)-1)
          ENDDO
        ENDDO 
      ENDDO
#elif defined(__ES) 
!$OMP parallel do private(IP,MXRP,MOD2,I,J,II,JJ,II1,II2,JJ1,JJ2)
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
        MOD2=MOD(NR1,2) 
        DO I=1,MOD2
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
          DO J=1,MXRP
            XF(II+J-1)=YF(JJ+MSP(J,IP+1)-1)
          ENDDO
        ENDDO 
!CDIR NODEP 
        DO I=MOD2+1,NR1,2
          II1=IP*LDA+(I-1)*MXRP+1
          II2=IP*LDA+(I  )*MXRP+1
          JJ1=(I-1)*KR2S*KR3S+1
          JJ2=(I  )*KR2S*KR3S+1
!CDIR NODEP 
          DO J=1,MXRP
            XF(II1+J-1)=YF(JJ1+MSP(J,IP+1)-1)
            XF(II2+J-1)=YF(JJ2+MSP(J,IP+1)-1)
          ENDDO
        ENDDO 
      ENDDO
#elif defined(__CRAYX1)
!CSD$ parallel do private(IP,MXRP,MOD2,I,J,II,JJ,II1,II2,JJ1,JJ2)
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
        MOD2=MOD(NR1,2)
        DO I=1,MOD2
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
!dir$ ivdep
          DO J=1,MXRP
            XF(II+J-1)=YF(JJ+MSP(J,IP+1)-1)
          ENDDO
        ENDDO
        DO I=MOD2+1,NR1,2
          II1=IP*LDA+(I-1)*MXRP+1
          II2=IP*LDA+(I  )*MXRP+1
          JJ1=(I-1)*KR2S*KR3S+1
          JJ2=(I  )*KR2S*KR3S+1
!dir$ ivdep
          DO J=1,MXRP
            XF(II1+J-1)=YF(JJ1+MSP(J,IP+1)-1)
            XF(II2+J-1)=YF(JJ2+MSP(J,IP+1)-1)
          ENDDO
        ENDDO
      ENDDO
!CSD$ end parallel do
#else
!$OMP parallel do private(IP,MXRP,I,II,JJ)
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
        DO I=1,NR1 
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
          CALL ZGTHR(MXRP,YF(JJ),XF(II),MSP(1,IP+1))
        ENDDO 
      ENDDO
#endif
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 16
      CALL MY_TRANS(XF,YF,BLKLEN,1)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpack data
      CALL TISET('   FFT-G/S',ISUB1)
!CSD$ parallel do private (IP,IPP,NRX,NRS)
      DO IP=0,NPROC-1
        NRX = SPARM(5,IP)*NHRAYS
        NRS = (NRXPL(IP,1)-1)*NHRAYS+1
        IPP = 1+IP*LDA
        CALL DCOPY(2*NRX,YF(IPP),1,XF(NRS),1)
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TX2Y
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MSP(2*NHRM,*)
      INTEGER   BLKLEN,ISUB1,LDA,IP,MXRP,I,II,JJ,ISUB2,NRX,NRS,IPP
#if defined(__SR8000) 
      INTEGER   J
#elif defined(__ES) 
      INTEGER   MOD2,J,II1,II2,JJ1,JJ2
#elif defined(__CRAYX1)
      INTEGER   MOD2,J,II1,II2,JJ1,JJ2
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   FFT-G/S',ISUB1)
C..Prepare data for sending
      LDA=NHRM*NR1M
!CSD$ parallel do private (IP,IPP,NRX,NRS)
      DO IP=0,NPROC-1
        NRX = SPARM(5,IP)*NHRAYS
        NRS = (NRXPL(IP,1)-1)*NHRAYS+1
        IPP = 1+IP*LDA
        CALL DCOPY(2*NRX,XF(NRS),1,YF(IPP),1)
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 16
      CALL MY_TRANS(YF,XF,BLKLEN,1)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
      CALL ZAZZERO(YF,MAXFFT)
#if defined(__SR8000)
*poption parallel
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
!$OMP parallel do private (I,J,II,JJ)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
          DO J=1,MXRP
            YF(JJ+MSP(J,IP+1)-1)=XF(II+J-1)
          ENDDO
        ENDDO
      ENDDO
#elif defined(__ES) 
!$OMP parallel do private (IP,MXRP,MOD2,I,J,II,JJ,II1,II2,JJ1,JJ2)
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
        MOD2=MOD(NR1,2) 
        DO I=1,MOD2
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
          DO J=1,MXRP
            YF(JJ+MSP(J,IP+1)-1)=XF(II+J-1)
          ENDDO
        ENDDO 
!CDIR NODEP 
        DO I=MOD2+1,NR1,2
          II1=IP*LDA+(I-1)*MXRP+1
          II2=IP*LDA+(I  )*MXRP+1
          JJ1=(I-1)*KR2S*KR3S+1
          JJ2=(I  )*KR2S*KR3S+1
!CDIR NODEP 
          DO J=1,MXRP
            YF(JJ1+MSP(J,IP+1)-1)=XF(II1+J-1)
            YF(JJ2+MSP(J,IP+1)-1)=XF(II2+J-1)
          ENDDO
        ENDDO 
      ENDDO
#elif defined(__CRAYX1)
!CSD$ parallel do private (IP,MXRP,MOD2,I,J,II,JJ,II1,II2,JJ1,JJ2)
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
        MOD2=MOD(NR1,2)
        DO I=1,MOD2
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
!dir$ ivdep
          DO J=1,MXRP
            YF(JJ+MSP(J,IP+1)-1)=XF(II+J-1)
          ENDDO
        ENDDO
        DO I=MOD2+1,NR1,2
          II1=IP*LDA+(I-1)*MXRP+1
          II2=IP*LDA+(I  )*MXRP+1
          JJ1=(I-1)*KR2S*KR3S+1
          JJ2=(I  )*KR2S*KR3S+1
!dir$ ivdep
          DO J=1,MXRP
            YF(JJ1+MSP(J,IP+1)-1)=XF(II1+J-1)
            YF(JJ2+MSP(J,IP+1)-1)=XF(II2+J-1)
          ENDDO
        ENDDO
      ENDDO
!CSD$ end parallel do
#else
!$OMP parallel do private (IP,MXRP,I,II,JJ)
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
          CALL ZSCTR(MXRP,XF(II),MSP(1,IP+1),YF(JJ))
        ENDDO 
      ENDDO
#endif
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PHASE(F)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      COMPLEX*16 F(KR1,KR2S,KR3S)
C     Variables
      INTEGER    K,J,II,IJK,ISUB
      REAL*8     PF(2)
      DATA       PF/1.D0,-1.D0/
#ifdef PARALLEL
      INTEGER    IJK1,IJK2
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('     PHASE',ISUB)
#ifdef PARALLEL
      IJK2=NRXPL(MEPOS,2)-NRXPL(MEPOS,1)+1 ! jh-mb
!$OMP parallel do private (J,K,II,IJK1) shared(IJK2)
#ifdef __SR8000
*poption tlocal(K,J,II,IJK1)
#endif
      DO K=1,NR3S
        DO J=1,NR2S
          II=K+J+NRXPL(MEPOS,1)
          IJK1=MOD(II,2)+1
          DO II=IJK1,IJK2,2
            F(II,J,K)=-F(II,J,K)
          ENDDO
        ENDDO
      ENDDO
#else
#ifdef __SR8000
*poption tlocal(K,J,I,II,IJK)
#endif
!$OMP parallel do private (J,K,II,IJK)
      DO K=1,NR3S
        DO J=1,NR2S
          II=K+J+1
          IJK=MOD(II,2)+1
          DO II=IJK,NR1,2
            F(II,J,K)=-F(II,J,K)
          ENDDO
        ENDDO
      ENDDO
#endif
      CALL TIHALT('     PHASE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PUTZ(A,B,KRMIN,KRMAX,KR,M)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    KRMIN,KRMAX,KR,M
      COMPLEX*16 A(KRMAX-KRMIN+1,*),B(KR,M)
C     Variables
      INTEGER    ISUB,N
C     ==--------------------------------------------------------------==
      CALL TISET('   FFT-G/S',ISUB)
      N=KRMAX-KRMIN+1
#ifdef  _BGL 
      CALL AZZERO(B,2*M*KR)
#else
      CALL ZAZZERO(B,M*KR)
#endif
      CALL MATMOV(N,M,A,N,B(KRMIN,1),KR)
      CALL TIHALT('   FFT-G/S',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETZ(A,B,KRMIN,KRMAX,KR,M)
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(KR,*),B(KRMAX-KRMIN+1,*)
C     ==--------------------------------------------------------------==
      CALL TISET('   FFT-G/S',ISUB)
      N=KRMAX-KRMIN+1
      CALL MATMOV(N,M,A(KRMIN,1),KR,B,N)
      CALL TIHALT('   FFT-G/S',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TY2XS
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MSP(NHRM,2,*)
      INTEGER   BLKLEN,LDA,M,IP,MXRP,I,II,JJ,ISUB1,ISUB2,NRX,NRS,IPP
#if defined(__SR8000)
      INTEGER   J
#elif defined(__ES) 
      INTEGER   MOD2,J,II1,II2,JJ1,JJ2
#elif defined(__CRAYX1)
      INTEGER   MOD2,J,II1,II2,JJ1,JJ2
#endif
C     ==--------------------------------------------------------------==
C..Pack the data for sending
      CALL TISET('   FFT-G/S',ISUB1)
      LDA=NGRM*NR1M
      M=KR2S*(KR3MAX-KR3MIN+1)
#if defined(__SR8000)
*poption parallel
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
!$OMP parallel do private (I,J,II,JJ)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          DO J=1,MXRP
            XF(II+J-1)=YF(JJ+MSP(J,2,IP+1)-1)
          ENDDO
        ENDDO
      ENDDO
#elif defined(__ES) 
!$OMP parallel do private (IP,MXRP,MOD2,I,J,II,JJ,II1,II2,JJ1,JJ2)
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
        MOD2=MOD(NR1,2) 
        DO I=1,MOD2
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          DO J=1,MXRP
            XF(II+J-1)=YF(JJ+MSP(J,2,IP+1)-1)
          ENDDO
        ENDDO 
!CDIR NODEP 
        DO I=MOD2+1,NR1,2
          II1=IP*LDA+(I-1)*MXRP+1
          II2=IP*LDA+(I  )*MXRP+1
          JJ1=(I-1)*M+1
          JJ2=(I  )*M+1
!CDIR NODEP 
          DO J=1,MXRP
            XF(II1+J-1)=YF(JJ1+MSP(J,2,IP+1)-1)
            XF(II2+J-1)=YF(JJ2+MSP(J,2,IP+1)-1)
          ENDDO
        ENDDO 
      ENDDO
#elif defined(__CRAYX1)
!CSD$ parallel do private (IP,MXRP,MOD2,I,J,II,JJ,II1,II2,JJ1,JJ2)
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
        MOD2=MOD(NR1,2)
        DO I=1,MOD2
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
!dir$ ivdep
          DO J=1,MXRP
            XF(II+J-1)=YF(JJ+MSP(J,2,IP+1)-1)
          ENDDO
        ENDDO
        DO I=MOD2+1,NR1,2
          II1=IP*LDA+(I-1)*MXRP+1
          II2=IP*LDA+(I  )*MXRP+1
          JJ1=(I-1)*M+1
          JJ2=(I  )*M+1
!dir$ ivdep
         DO J=1,MXRP
            XF(II1+J-1)=YF(JJ1+MSP(J,2,IP+1)-1)
            XF(II2+J-1)=YF(JJ2+MSP(J,2,IP+1)-1)
          ENDDO
        ENDDO
      ENDDO
!CSD$ end parallel
#else
!$OMP parallel do private (IP,MXRP,I,II,JJ)
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          CALL ZGTHR(MXRP,YF(JJ),XF(II),MSP(1,2,IP+1))
        ENDDO
      ENDDO
#endif
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 16
      CALL MY_TRANS(XF,YF,BLKLEN,1)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpack data
      CALL TISET('   FFT-G/S',ISUB1)
!CSD$ parallel do  private (IP,IPP,NRX,NRS)
      DO IP=0,NPROC-1
        NRX = SPARM(5,IP)*NGRAYS
        NRS = (NRXPL(IP,1)-1)*NGRAYS+1
        IPP = 1+IP*LDA
        CALL DCOPY(2*NRX,YF(IPP),1,XF(NRS),1)
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TX2YS
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MSP(NHRM,2,*)
      INTEGER   BLKLEN,ISUB1,ISUB2,LDA,IP,NRX,NRS,IPP,M,I,II,JJ,MXRP
#if defined(__SR8000)
      INTEGER   J
#elif defined(__ES) 
      INTEGER   MOD2,J,II1,II2,JJ1,JJ2
#elif defined(__CRAYX1)
      INTEGER   MOD2,J,II1,II2,JJ1,JJ2
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   FFT-G/S',ISUB1)
C..Prepare data for sending
      LDA=NGRM*NR1M
!CSD$ parallel do  private (IP,IPP,NRX,NRS)
      DO IP=0,NPROC-1
        NRX = SPARM(5,IP)*NGRAYS
        NRS = (NRXPL(IP,1)-1)*NGRAYS+1
        IPP = 1+IP*LDA
        CALL DCOPY(2*NRX,XF(NRS),1,YF(IPP),1)
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 16
      CALL MY_TRANS(YF,XF,BLKLEN,1)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
      M=KR2S*(KR3MAX-KR3MIN+1)
#ifdef  _BGL 
      CALL ZAZZERO(YF,MAXFFT)
#else
      CALL AZZERO(YF,2*MAXFFT)
#endif
#if defined(__SR8000)
*poption parallel
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
!$OMP parallel do private (I,J,II,JJ)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          DO J=1,MXRP
            YF(JJ+MSP(J,2,IP+1)-1)=XF(II+J-1)
          ENDDO
        ENDDO
      ENDDO
#elif defined(__ES) 
!$OMP parallel do private (IP,MXRP,MOD2,I,J,II,JJ,II1,II2,JJ1,JJ2)
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
        MOD2=MOD(NR1,2) 
        DO I=1,MOD2
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          DO J=1,MXRP
            YF(JJ+MSP(J,2,IP+1)-1)=XF(II+J-1)
          ENDDO
        ENDDO 
!CDIR NODEP 
        DO I=MOD2+1,NR1,2
          II1=IP*LDA+(I-1)*MXRP+1
          II2=IP*LDA+(I  )*MXRP+1
          JJ1=(I-1)*M+1
          JJ2=(I  )*M+1
!CDIR NODEP 
          DO J=1,MXRP
            YF(JJ1+MSP(J,2,IP+1)-1)=XF(II1+J-1)
            YF(JJ2+MSP(J,2,IP+1)-1)=XF(II2+J-1)
          ENDDO
        ENDDO 
      ENDDO
#elif defined(__CRAYX1)
!CSD$ parallel do private (IP,MXRP,MOD2,I,J,II,JJ,II1,II2,JJ1,JJ2)
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
        MOD2=MOD(NR1,2)
        DO I=1,MOD2
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
!dir$ ivdep
          DO J=1,MXRP
            YF(JJ+MSP(J,2,IP+1)-1)=XF(II+J-1)
          ENDDO
        ENDDO
        DO I=MOD2+1,NR1,2
          II1=IP*LDA+(I-1)*MXRP+1
          II2=IP*LDA+(I  )*MXRP+1
          JJ1=(I-1)*M+1
          JJ2=(I  )*M+1
!dir$ ivdep
          DO J=1,MXRP
            YF(JJ1+MSP(J,2,IP+1)-1)=XF(II1+J-1)
            YF(JJ2+MSP(J,2,IP+1)-1)=XF(II2+J-1)
          ENDDO
        ENDDO
      ENDDO
!CSD$ end parallel do
#else
!$OMP parallel do private (IP,I,MXRP,II,JJ)
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          CALL ZSCTR(MXRP,XF(II),MSP(1,2,IP+1),YF(JJ))
        ENDDO
      ENDDO
#endif
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TX2YG
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MS(MAXRPT,*)
      INTEGER   BLKLEN,ISUB1,IP,IPROC1,IPROC2,NRX,IX1,IY1,LDA,ISUB2,M,
     &          NL1,NL2,I,JJ,II
#if defined(__SR8000)
      INTEGER   J
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   FFT-G/S',ISUB1)
C..Prepare data for sending
      LDA=NOGRP*KR1M*MPENM
      DO IP=1,NPGRP
        IPROC1=(IP-1)*NOGRP
        IPROC2=IP*NOGRP-1
        NRX=(NRXPL(IPROC1,2)-NRXPL(IPROC2,1)+1)*MPEN
        IX1=(NRXPL(IPROC2,1)-1)*MPEN+1
        IY1=(IP-1)*LDA+1
        CALL DCOPY(2*NRX,XF(IX1),1,YF(IY1),1)
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 16
      CALL MY_TRANS(YF,XF,BLKLEN,3)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
      M=KR2S*(KR3MAX-KR3MIN+1)
#ifdef  _BGL 
      CALL AZZERO(YF,2*KRX*M)
#else
      CALL ZAZZERO(YF,KRX*M)
#endif
      NL1=NLINK(NOLIST(1))
      NL2=NLINK(NOLIST(NOGRP))
      NRX=NRXPL(NL1,2)-NRXPL(NL2,1)+1
#ifdef __SR8000
*poption parallel
#endif
      DO IP=1,NPGRP  
        DO I=1,NRX
          JJ=(I-1)*M+1
          II=(IP-1)*LDA+(I-1)*MXY(IP)+1
#ifdef __SR8000
          DO J=1,MXY(IP)
            YF(JJ+MS(J,IP)-1)=XF(II+J-1)
          ENDDO
#else
          CALL ZSCTR(MXY(IP),XF(II),MS(1,IP),YF(JJ))
#endif
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TY2XG
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MS(MAXRPT,*)
      INTEGER   BLKLEN,ISUB1,IP,IPROC1,IPROC2,NRX,IX1,IY1,LDA,ISUB2,M,
     &          NL1,NL2,I,JJ,II
#ifdef __SR8000
      INTEGER   J
#endif
C     ==--------------------------------------------------------------==
C..Prepare data for sending
      CALL TISET('   FFT-G/S',ISUB1)
      NL1=NLINK(NOLIST(1))
      NL2=NLINK(NOLIST(NOGRP))
      NRX=NRXPL(NL1,2)-NRXPL(NL2,1)+1
      LDA=NOGRP*KR1M*MPENM
      M=KR2S*(KR3MAX-KR3MIN+1)
#ifdef __SR8000
*poption parallel
#endif
      DO IP=1,NPGRP
        DO I=1,NRX
          JJ=(I-1)*M+1
          II=(IP-1)*LDA+(I-1)*MXY(IP)+1
#ifdef __SR8000
          DO J=1,MXY(IP)
            XF(II+J-1)=YF(JJ+MS(J,IP)-1)
          ENDDO
#else
          CALL ZGTHR(MXY(IP),YF(JJ),XF(II),MS(1,IP))
#endif
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 16
      CALL MY_TRANS(XF,YF,BLKLEN,3)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
      DO IP=1,NPGRP
        IPROC1=(IP-1)*NOGRP
        IPROC2=IP*NOGRP-1
        NRX=(NRXPL(IPROC1,2)-NRXPL(IPROC2,1)+1)*MPEN
        IX1=(NRXPL(IPROC2,1)-1)*MPEN+1
        IY1=(IP-1)*LDA+1
        CALL DCOPY(2*NRX,YF(IY1),1,XF(IX1),1)
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     CODE FOR SINGLE PRECISION TRANSPOSE
C     ==================================================================
      SUBROUTINE TY2X4
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MSP(2*NHRM,*)
      INTEGER   BLKLEN,ISUB1,LDA,IP,MXRP,I,J,II,JJ,ISUB2,NRX,NRS,IPP
      COMPLEX*8 XF4(*),YF4(*)
      POINTER (IP_XF4,XF4),(IP_YF4,YF4)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_XF4,XF)
      CALL GET_ADDR(IP_YF4,YF)
C..Pack the data for sending
      CALL TISET('   FFT-G/S',ISUB1)
      LDA=NHRM*NR1M
!$OMP parallel do private(IP,MXRP,I,J,II,JJ)
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
          DO J=1,MXRP
            XF4(II+J-1)=YF(JJ+MSP(J,IP+1)-1)
          ENDDO
        ENDDO 
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 8
      CALL MY_TRANS(XF4,YF4,BLKLEN,1)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpack data
      CALL TISET('   FFT-G/S',ISUB1)
!$OMP parallel do private (IP,IPP,NRX,NRS)
      DO IP=0,NPROC-1
        NRX = SPARM(5,IP)*NHRAYS
        NRS = (NRXPL(IP,1)-1)*NHRAYS
        IPP = IP*LDA
        DO J=1,NRX
          XF(NRS+J)=YF4(IPP+J)
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TX2Y4
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MSP(2*NHRM,*)
      INTEGER   BLKLEN,ISUB1,LDA,IP,MXRP,I,J,II,JJ,ISUB2,NRX,NRS,IPP
      COMPLEX*8 XF4(*),YF4(*)
      POINTER (IP_XF4,XF4),(IP_YF4,YF4)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_XF4,XF)
      CALL GET_ADDR(IP_YF4,YF)
      CALL TISET('   FFT-G/S',ISUB1)
C..Prepare data for sending
      LDA=NHRM*NR1M
!$OMP parallel do  private (IP,IPP,NRX,NRS)
      DO IP=0,NPROC-1
        NRX = SPARM(5,IP)*NHRAYS
        NRS = (NRXPL(IP,1)-1)*NHRAYS
        IPP = IP*LDA
        DO J=1,NRX
          YF4(IPP+J)=XF(NRS+J)
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 8
      CALL MY_TRANS(YF4,XF4,BLKLEN,1)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
#ifdef  _BGL 
      CALL AZZERO(YF,2*MAXFFT)
#else
      CALL ZAZZERO(YF,MAXFFT)
#endif
!$OMP parallel do private (IP,MXRP,I,J,II,JJ)
      DO IP=0,NPROC-1
        MXRP = SPARM(8,IP)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*KR2S*KR3S+1
          DO J=1,MXRP
            YF(JJ+MSP(J,IP+1)-1)=XF4(II+J-1)
          ENDDO
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TY2XS4
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MSP(NHRM,2,*)
      INTEGER   BLKLEN,LDA,M,IP,MXRP,I,J,II,JJ,ISUB1,ISUB2,NRX,NRS,IPP
      COMPLEX*8 XF4(*),YF4(*)
      POINTER (IP_XF4,XF4),(IP_YF4,YF4)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_XF4,XF)
      CALL GET_ADDR(IP_YF4,YF)
C..Pack the data for sending
      CALL TISET('   FFT-G/S',ISUB1)
      LDA=NGRM*NR1M
      M=KR2S*(KR3MAX-KR3MIN+1)
!$OMP parallel do private (IP,MXRP,I,J,II,JJ)
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          DO J=1,MXRP
            XF4(II+J-1)=YF(JJ+MSP(J,2,IP+1)-1)
          ENDDO
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 8
      CALL MY_TRANS(XF4,YF4,BLKLEN,1)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpack data
      CALL TISET('   FFT-G/S',ISUB1)
!$OMP parallel do  private (IP,IPP,NRX,NRS)
      DO IP=0,NPROC-1
        NRX = SPARM(5,IP)*NGRAYS
        NRS = (NRXPL(IP,1)-1)*NGRAYS
        IPP = IP*LDA
        DO J=1,NRX
          XF(NRS+J)=YF4(IPP+J)
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TX2YS4
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MSP(NHRM,2,*)
      INTEGER   BLKLEN,ISUB1,ISUB2,LDA,IP,NRX,NRS,IPP,M,I,J,II,JJ,MXRP
      COMPLEX*8 XF4(*),YF4(*)
      POINTER (IP_XF4,XF4),(IP_YF4,YF4)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_XF4,XF)
      CALL GET_ADDR(IP_YF4,YF)
      CALL TISET('   FFT-G/S',ISUB1)
C..Prepare data for sending
      LDA=NGRM*NR1M
!$OMP parallel do  private (IP,IPP,NRX,NRS)
      DO IP=0,NPROC-1
        NRX = SPARM(5,IP)*NGRAYS
        NRS = (NRXPL(IP,1)-1)*NGRAYS
        IPP = IP*LDA
        DO J=1,NRX
          YF4(IPP+J)=XF(NRS+J)
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 8
      CALL MY_TRANS(YF4,XF4,BLKLEN,1)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
      M=KR2S*(KR3MAX-KR3MIN+1)
#ifdef  _BGL 
      CALL AZZERO(YF,2*MAXFFT)
#else
      CALL ZAZZERO(YF,MAXFFT)
#endif
!$OMP parallel do private (IP,MXRP,I,J,II,JJ)
      DO IP=0,NPROC-1
        MXRP = SPARM(9,IP)
        DO I=1,NR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          DO J=1,MXRP
            YF(JJ+MSP(J,2,IP+1)-1)=XF4(II+J-1)
          ENDDO
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TX2YG4
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MS(MAXRPT,*)
      INTEGER   BLKLEN,ISUB1,IP,IPROC1,IPROC2,NRX,IX1,IY1,LDA,ISUB2,M,
     &          NL1,NL2,I,J,JJ,II
      COMPLEX*8 XF4(*),YF4(*)
      POINTER (IP_XF4,XF4),(IP_YF4,YF4)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_XF4,XF)
      CALL GET_ADDR(IP_YF4,YF)
      CALL TISET('   FFT-G/S',ISUB1)
C..Prepare data for sending
      LDA=NOGRP*KR1M*MPENM
      DO IP=1,NPGRP
        IPROC1=(IP-1)*NOGRP
        IPROC2=IP*NOGRP-1
        NRX=(NRXPL(IPROC1,2)-NRXPL(IPROC2,1)+1)*MPEN
        IX1=(NRXPL(IPROC2,1)-1)*MPEN+1
        IY1=(IP-1)*LDA+1
        DO J=1,NRX
          YF4(IY1+J-1)=XF(IX1+J-1)
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 8
      CALL MY_TRANS(YF4,XF4,BLKLEN,3)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
      M=KR2S*(KR3MAX-KR3MIN+1)
#ifdef  _BGL 
      CALL AZZERO(YF,2*KRX*M)
#else
      CALL ZAZZERO(YF,KRX*M)
#endif
      NL1=NLINK(NOLIST(1))
      NL2=NLINK(NOLIST(NOGRP))
      NRX=NRXPL(NL1,2)-NRXPL(NL2,1)+1
      DO IP=1,NPGRP  
        DO I=1,NRX
          JJ=(I-1)*M+1
          II=(IP-1)*LDA+(I-1)*MXY(IP)+1
          DO J=1,MXY(IP)
            YF(JJ+MS(J,IP)-1)=XF4(II+J-1)
          ENDDO
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TY2XG4
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
C     Variables
      DIMENSION XF(*),YF(*),MS(MAXRPT,*)
      INTEGER   BLKLEN,ISUB1,IP,IPROC1,IPROC2,NRX,IX1,IY1,LDA,ISUB2,M,
     &          NL1,NL2,I,J,JJ,II
      COMPLEX*8 XF4(*),YF4(*)
      POINTER (IP_XF4,XF4),(IP_YF4,YF4)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_XF4,XF)
      CALL GET_ADDR(IP_YF4,YF)
C..Prepare data for sending
      CALL TISET('   FFT-G/S',ISUB1)
      NL1=NLINK(NOLIST(1))
      NL2=NLINK(NOLIST(NOGRP))
      NRX=NRXPL(NL1,2)-NRXPL(NL2,1)+1
      LDA=NOGRP*KR1M*MPENM
      M=KR2S*(KR3MAX-KR3MIN+1)
      DO IP=1,NPGRP
        DO I=1,NRX
          JJ=(I-1)*M+1
          II=(IP-1)*LDA+(I-1)*MXY(IP)+1
          DO J=1,MXY(IP)
            XF4(II+J-1)=YF(JJ+MS(J,IP)-1)
          ENDDO
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('    FFTCOM',ISUB2)
      BLKLEN = LDA * 8
      CALL MY_TRANS(XF4,YF4,BLKLEN,3)
      CALL TIHALT('    FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
      DO IP=1,NPGRP
        IPROC1=(IP-1)*NOGRP
        IPROC2=IP*NOGRP-1
        NRX=(NRXPL(IPROC1,2)-NRXPL(IPROC2,1)+1)*MPEN
        IX1=(NRXPL(IPROC2,1)-1)*MPEN+1
        IY1=(IP-1)*LDA+1
        DO J=1,NRX
          XF(IX1+J-1)=YF4(IY1+J-1)
        ENDDO
      ENDDO
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     CODE FOR NEW FFT ROUTINES
C     ==================================================================
      SUBROUTINE TY2XN(XF,YF,M,NRAYS,LR1,LDA,MSP,LMSP,
     *                 JRXPL,SP5,SP8,MPROC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      COMPLEX*16 XF(*),YF(*)
      INTEGER M,NRAYS,MPROC,LDA,LMSP,LR1
      INTEGER MSP(LMSP,*),JRXPL(0:MPROC-1),SP5(0:MPROC-1),SP8(0:MPROC-1)
C     Variables
      INTEGER   BLKLEN,ISUB1,IP,MXRP,I,II,JJ,ISUB2,NRX,NRS,IPP
C     ==--------------------------------------------------------------==
C..Pack the data for sending
      CALL TISET('   FFT-G/S',ISUB1)
#if defined (__SR11000)
      DO IP=0,MPROC-1
        MXRP = SP8(IP)
!$OMP parallel do private(I,J,II,JJ)
        DO I=1,LR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          DO J=1,MXRP
            XF(II+J-1)=YF(JJ+MSP(J,IP+1)-1)
          ENDDO
        ENDDO
      ENDDO
#else
!CSD$ parallel do private(IP,MXRP,I,II,JJ)
      DO IP=0,MPROC-1
        MXRP = SP8(IP)
        DO I=1,LR1 
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          CALL ZGTHR(MXRP,YF(JJ),XF(II),MSP(1,IP+1))
        ENDDO 
      ENDDO
!CSD$ end parallel do
#endif
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('  N-FFTCOM',ISUB2)
      BLKLEN = LDA * 16
      CALL MY_TRANS(XF,YF,BLKLEN,1)
      CALL TIHALT('  N-FFTCOM',ISUB2)
C..Unpack data
      CALL TISET('   FFT-G/S',ISUB1)
!CSD$ parallel do private (IP,IPP,NRX,NRS)
      DO IP=0,MPROC-1
        NRX = SP5(IP)*NRAYS
        NRS = (JRXPL(IP)-1)*NRAYS+1
        IPP = 1+IP*LDA
        CALL DCOPY(2*NRX,YF(IPP),1,XF(NRS),1)
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TX2YN(XF,YF,M,NRAYS,LR1,LDA,MSP,LMSP,JRXPL,SP5,SP8,
     *                 MAXFFT,MPROC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      COMPLEX*16 XF(*),YF(*)
      INTEGER M,NRAYS,MAXFFT,MPROC,LDA,LMSP,LR1
      INTEGER MSP(LMSP,*),JRXPL(0:MPROC-1),SP5(0:MPROC-1),SP8(0:MPROC-1)
C     Variables
      INTEGER   BLKLEN,ISUB1,IP,MXRP,I,II,JJ,ISUB2,NRX,NRS,IPP
C     ==--------------------------------------------------------------==
      CALL TISET('   FFT-G/S',ISUB1)
C..Prepare data for sending
!CSD$ parallel do  private (IP,IPP,NRX,NRS)
      DO IP=0,MPROC-1
        NRX = SP5(IP)*NRAYS
        NRS = (JRXPL(IP)-1)*NRAYS+1
        IPP = 1+IP*LDA
        CALL DCOPY(2*NRX,XF(NRS),1,YF(IPP),1)
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('  N-FFTCOM',ISUB2)
      BLKLEN = LDA * 16
      CALL MY_TRANS(YF,XF,BLKLEN,1)
      CALL TIHALT('  N-FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
#ifdef  _BGL 
      CALL AZZERO(YF,2*MAXFFT)
#else
      CALL ZAZZERO(YF,MAXFFT)
#endif
#if defined (__SR11000)
      DO IP=0,MPROC-1
        MXRP = SP8(IP)
!$OMP parallel do private (I,J,II,JJ)
        DO I=1,LR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          DO J=1,MXRP
            YF(JJ+MSP(J,IP+1)-1)=XF(II+J-1)
          ENDDO
        ENDDO
      ENDDO
#else
!CSD$ parallel do private (IP,MXRP,I,II,JJ)
      DO IP=0,MPROC-1
        MXRP = SP8(IP)
        DO I=1,LR1
          II=IP*LDA+(I-1)*MXRP+1
          JJ=(I-1)*M+1
          CALL ZSCTR(MXRP,XF(II),MSP(1,IP+1),YF(JJ))
        ENDDO 
      ENDDO
!CSD$ end parallel do
#endif
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TY2XN4(XF,YF,M,NRAYS,LR1,LDA,MSP,LMSP,
     *                 JRXPL,SP5,SP8,MPROC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      COMPLEX*16 XF(*),YF(*)
      INTEGER M,NRAYS,MPROC,LDA,LMSP,LR1
      INTEGER MSP(LMSP,*),JRXPL(0:MPROC-1),SP5(0:MPROC-1),SP8(0:MPROC-1)
C     Variables
      INTEGER   BLKLEN,ISUB1,IP,MXRP,I,J,II,JJ,ISUB2,NRX,NRS,IPP
      COMPLEX*8 XF4(*),YF4(*)
      POINTER (IP_XF4,XF4),(IP_YF4,YF4)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_XF4,XF)
      CALL GET_ADDR(IP_YF4,YF)
C..Pack the data for sending
      CALL TISET('   FFT-G/S',ISUB1)
!CSD$ parallel do private(IP,MXRP,I,J,II,JJ)
      DO IP=0,MPROC-1
        MXRP = SP8(IP)
!$OMP parallel do private(I,J,II,JJ)
        DO I=1,LR1 
          II=IP*LDA+(I-1)*MXRP
          JJ=(I-1)*M
          DO J=1,MXRP
            XF4(II+J)=YF(JJ+MSP(J,IP+1))
          ENDDO
        ENDDO 
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('  N-FFTCOM',ISUB2)
      BLKLEN = LDA * 8
      CALL MY_TRANS(XF4,YF4,BLKLEN,1)
      CALL TIHALT('  N-FFTCOM',ISUB2)
C..Unpack data
      CALL TISET('   FFT-G/S',ISUB1)
!CSD$ parallel do private (IP,J,IPP,NRX,NRS)
      DO IP=0,MPROC-1
        NRX = SP5(IP)*NRAYS
        NRS = (JRXPL(IP)-1)*NRAYS
        IPP = IP*LDA
!$OMP parallel do private (J)
        DO J=1,NRX
          XF(NRS+J)=YF4(IPP+J)
        ENDDO
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TX2YN4(XF,YF,M,NRAYS,LR1,LDA,MSP,LMSP,JRXPL,SP5,SP8,
     *                 MAXFFT,MPROC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      COMPLEX*16 XF(*),YF(*)
      INTEGER M,NRAYS,MAXFFT,MPROC,LDA,LMSP,LR1
      INTEGER MSP(LMSP,*),JRXPL(0:MPROC-1),SP5(0:MPROC-1),SP8(0:MPROC-1)
C     Variables
      INTEGER   BLKLEN,ISUB1,IP,MXRP,I,J,II,JJ,ISUB2,NRX,NRS,IPP
      COMPLEX*8 XF4(*),YF4(*)
      POINTER (IP_XF4,XF4),(IP_YF4,YF4)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_XF4,XF)
      CALL GET_ADDR(IP_YF4,YF)
C     ==--------------------------------------------------------------==
      CALL TISET('   FFT-G/S',ISUB1)
C..Prepare data for sending
!CSD$ parallel do  private (IP,J,IPP,NRX,NRS)
      DO IP=0,MPROC-1
        NRX = SP5(IP)*NRAYS
        NRS = (JRXPL(IP)-1)*NRAYS
        IPP = IP*LDA
!$OMP parallel do  private (J)
        DO J=1,NRX
          YF4(IPP+J)=XF(NRS+J)
        ENDDO
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C..All to all communication
      CALL TISET('  N-FFTCOM',ISUB2)
      BLKLEN = LDA * 8
      CALL MY_TRANS(YF4,XF4,BLKLEN,1)
      CALL TIHALT('  N-FFTCOM',ISUB2)
C..Unpacking the data
      CALL TISET('   FFT-G/S',ISUB1)
#ifdef  _BGL 
      CALL AZZERO(YF,2*MAXFFT)
#else
      CALL ZAZZERO(YF,MAXFFT)
#endif
!CSD$ parallel do private (IP,MXRP,I,J,II,JJ)
      DO IP=0,MPROC-1
        MXRP = SP8(IP)
!$OMP parallel do private (I,J,II,JJ)
        DO I=1,LR1
          II=IP*LDA+(I-1)*MXRP
          JJ=(I-1)*M
          DO J=1,MXRP
            YF(JJ+MSP(J,IP+1))=XF4(II+J)
          ENDDO
        ENDDO 
      ENDDO
!CSD$ end parallel do
      CALL TIHALT('   FFT-G/S',ISUB1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PHASEN(F,KR1,KR2S,KR3S,N1U,N1O,NR2S,NR3S)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER KR1,KR2S,KR3S,N1U,N1O,NR2S,NR3S
      COMPLEX*16 F(KR1,KR2S,KR3S)
C     Variables
      INTEGER    K,J,I,II,IJK,ISUB
      REAL*8     PF(2)
      DATA       PF/1.D0,-1.D0/
C     ==--------------------------------------------------------------==
      CALL TISET('     PHASE',ISUB)
!$OMP parallel do private(K,J,I,II,IJK)
      DO K=1,NR3S
        DO J=1,NR2S
          DO I=N1U,N1O
            II=I-N1U+1
            IJK=MOD(K+J+I+1,2)+1
            F(II,J,K)=F(II,J,K)*PF(IJK)
          ENDDO
        ENDDO
      ENDDO
      CALL TIHALT('     PHASE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
