C     ==================================================================
      SUBROUTINE FFTWFFT(ISIGN,ITASK,F)
C     ==--------------------------------------------------------------==
C     == COMPUTES THE INVERSE FOURIER TRANSFORM OF A COMPLEX          ==
C     == FUNCTION F. THE FOURIER TRANSFORM IS                         ==
C     == RETURNED IN F (THE INPUT F IS OVERWRITTEN).                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    ISIGN,ITASK
      COMPLEX*16 F(*)
C     Variables
      DIMENSION  XF(*),YF(*)
      INTEGER    BLKLEN,ISUB1,ISUB2,LDA,IT1,IP,IP1,IPP,NDA,M
      REAL*8     SCALE
C     ==--------------------------------------------------------------==
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      IF(ITASK.EQ.0) THEN
        IF(ISIGN.EQ.-1) THEN
          SCALE=1.D0
#ifdef PARALLEL
C..FFT ALONG X DIRECTION
          CALL MLTFFT_FFTW('N','T',F,KR1S,NHRAYS,XF,
     *        NHRAYS,KR1S,NR1S,NHRAYS,ISIGN,SCALE,TFFTWSDM)
          IF(TR4A2A) THEN
            CALL TX2Y4
          ELSE
            CALL TX2Y
          ENDIF
C..FFT ALONG Y DIRECTION
          CALL MLTFFT_FFTW('N','T',YF,KR2S,KR1*KR3S,XF,KR1*KR3S,KR2S,
     *        NR2S,KR1*KR3S,ISIGN,SCALE,TFFTWSDM)
C..FFT ALONG Z DIRECTION
          CALL MLTFFT_FFTW('N','T',XF,KR3S,KR1*KR2S,F,KR1*KR2S,KR3S,
     *        NR3S,KR1*KR2S,ISIGN,SCALE,TFFTWSDM)
#else
          CALL FFT3D_FFTW(F,KR1,KR2S,KR3S,NR1,NR2S,NR3S,ISIGN,SCALE)
#endif
          CALL PHASE(F)
        ELSE
          CALL PHASE(F)
          SCALE=1.D0
#ifdef PARALLEL
C..FFT ALONG Z DIRECTION
          CALL MLTFFT_FFTW('T','N',F,KR1*KR2S,KR3S,XF,KR3S,KR1*KR2S,
     *        NR3S,KR1*KR2S,ISIGN,SCALE,TFFTWSDM)
C..FFT ALONG Y DIRECTION
          CALL MLTFFT_FFTW('T','N',XF,KR1*KR3S,KR2S,YF,KR2S,KR1*KR3S,
     *        NR2S,KR1*KR3S,ISIGN,SCALE,TFFTWSDM)
C..FFT ALONG X DIRECTION
          IF(TR4A2A) THEN
            CALL TY2X4
          ELSE
            CALL TY2X
          ENDIF
          SCALE=1.D0/DBLE(NR1S*NR2S*NR3S)
          CALL MLTFFT_FFTW('T','N',XF,NHRAYS,KR1S,F,KR1S,NHRAYS,NR1S,
     *        NHRAYS,ISIGN,SCALE,TFFTWSDM)
#else
          SCALE=1.D0/DBLE(NR1S*NR2S*NR3S)
          CALL FFT3D_FFTW(F,KR1,KR2S,KR3S,NR1,NR2S,NR3S,ISIGN,SCALE)
#endif
        ENDIF
      ELSEIF(ITASK.EQ.1) THEN
        IF(ISIGN.EQ.-1) THEN
          SCALE=1.D0
#ifdef PARALLEL
          CALL MLTFFT_FFTW('N','T',F,KR1S,NGRAYS,XF,NGRAYS,KR1S,
     *        NR1S,NGRAYS,ISIGN,SCALE,TFFTWSDM)
          M=(KR3MAX-KR3MIN+1)*KR1
         IF(TR4A2A) THEN
            CALL TX2YS4
          ELSE
            CALL TX2YS
          ENDIF
#else
          M=(KR2MAX-KR2MIN+1)*(KR3MAX-KR3MIN+1)
          CALL MLTFFT_FFTW('N','T',F,KR1S,M,XF,
     *        M,KR1S,NR1S,M,ISIGN,SCALE,TFFTWSDM)
          M=(KR3MAX-KR3MIN+1)*KR1
          CALL PUTZ(XF,YF,KR2MIN,KR2MAX,KR2S,M)
#endif
          CALL MLTFFT_FFTW('N','T',YF,KR2S,M,XF,
     *        M,KR2S,NR2S,M,ISIGN,SCALE,TFFTWSDM)
          M=KR1*KR2S
          CALL PUTZ(XF,YF,KR3MIN,KR3MAX,KR3S,M)
          CALL MLTFFT_FFTW('N','T',YF,KR3S,M,F,
     *        M,KR3S,NR3S,M,ISIGN,SCALE,TFFTWSDM)
        ELSE
          SCALE=1.D0
          M=KR1*KR2S
          CALL MLTFFT_FFTW('T','N',F,M,KR3S,XF,
     *        KR3S,M,NR3S,M,ISIGN,SCALE,TFFTWSDM)
          CALL GETZ(XF,F,KR3MIN,KR3MAX,KR3S,M)
          M=(KR3MAX-KR3MIN+1)*KR1
          CALL MLTFFT_FFTW('T','N',F,M,KR2S,YF,
     *        KR2S,M,NR2S,M,ISIGN,SCALE,TFFTWSDM)
          SCALE=1.D0/DBLE(NR1S*NR2S*NR3S)
#ifdef PARALLEL
          IF(TR4A2A) THEN
            CALL TY2XS4
          ELSE
            CALL TY2XS
          ENDIF
          CALL MLTFFT_FFTW('T','N',XF,NGRAYS,KR1S,F,KR1S,NGRAYS,
     *        NR1S,NGRAYS,ISIGN,SCALE,TFFTWSDM)
#else
          CALL GETZ(YF,XF,KR2MIN,KR2MAX,KR2S,M)
          M=(KR2MAX-KR2MIN+1)*(KR3MAX-KR3MIN+1)
          CALL MLTFFT_FFTW('T','N',XF,M,KR1S,F,
     *        KR1S,M,NR1S,M,ISIGN,SCALE,TFFTWSDM)
#endif
        ENDIF
      ELSEIF(ITASK.EQ.2) THEN
        IF(ISIGN.EQ.-1) THEN
          SCALE=1.D0
#ifdef PARALLEL
          CALL TISET('    FFTCOM',ISUB2)
          LDA = NGRM*KR1S
          BLKLEN = LDA * 16
          CALL MY_TRANS(F,XF,BLKLEN,2)
          CALL TIHALT('    FFTCOM',ISUB2)
          CALL TISET('    FFTG/S',ISUB1)
          IT1=1
          DO IP=1,NOGRP
            IP1=1+(IP-1)*KR1S*NGRM
            IPP=NLINK(NOLIST(IP))
            NDA=KR1S*SPARM(9,IPP)
            CALL DCOPY(2*NDA,XF(IP1),1,YF(IT1),1)
            IT1=IT1+NDA
          ENDDO
          CALL TIHALT('    FFTG/S',ISUB1)
C..FFT ALONG X DIRECTION
          CALL MLTFFT_FFTW('N','T',YF,KR1S,MPEN,XF,MPEN,KR1S,NR1S,MPEN,
     *                ISIGN,SCALE,TFFTWSDM)
          IF(TR4A2A) THEN
            CALL TX2YG4
          ELSE
            CALL TX2YG
          ENDIF
C..FFT ALONG Y DIRECTION
          M=(KR3MAX-KR3MIN+1)*KRX
          CALL MLTFFT_FFTW('N','T',YF,KR2S,M,XF,
     *        M,KR2S,NR2S,M,ISIGN,SCALE,TFFTWSDM)
C..FFT ALONG Z DIRECTION
          M=KRX*KR2S
          CALL PUTZ(XF,YF,KR3MIN,KR3MAX,KR3S,M)
          CALL MLTFFT_FFTW('N','T',YF,KR3S,M,F,
     *        M,KR3S,NR3S,M,ISIGN,SCALE,TFFTWSDM)
#endif
        ELSE
          SCALE=1.D0
#ifdef PARALLEL
C..FFT ALONG Z DIRECTION
          M=KRX*KR2S
          CALL MLTFFT_FFTW('T','N',F,M,KR3S,XF,
     *        KR3S,M,NR3S,M,ISIGN,SCALE,TFFTWSDM)
          CALL GETZ(XF,F,KR3MIN,KR3MAX,KR3S,M)
C..FFT ALONG Y DIRECTION
          M=(KR3MAX-KR3MIN+1)*KRX
          CALL MLTFFT_FFTW('T','N',F,M,KR2S,YF,
     *        KR2S,M,NR2S,M,ISIGN,SCALE,TFFTWSDM)
          IF(TR4A2A) THEN
            CALL TY2XG4
          ELSE
            CALL TY2XG
          ENDIF
C..FFT ALONG X DIRECTION
          SCALE=1.D0/DBLE(NR1S*NR2S*NR3S)
          CALL MLTFFT_FFTW('T','N',XF,MPEN,KR1S,YF,KR1S,MPEN,NR1S,MPEN,
     *        ISIGN,SCALE,TFFTWSDM)
          CALL TISET('    FFTG/S',ISUB1)
          IT1=1
          DO IP=1,NOGRP
            IP1=1+(IP-1)*KR1S*NGRM
            IPP=NLINK(NOLIST(IP))
            NDA=KR1S*SPARM(9,IPP)
            CALL DCOPY(2*NDA,YF(IT1),1,XF(IP1),1)
            IT1=IT1+NDA
          ENDDO
          CALL TIHALT('    FFTG/S',ISUB1)
          CALL TISET('    FFTCOM',ISUB2)
          LDA = NGRM*KR1S
          BLKLEN = LDA * 16
          CALL MY_TRANS(XF,F,BLKLEN,2)
          CALL TIHALT('    FFTCOM',ISUB2)
#endif
        ENDIF
      ENDIF
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

