C     ==================================================================
      SUBROUTINE FHARM(TAU0,FION,INP,TFORCE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==               THE HARMONIC SPRING ENERGY                     ==
C     ==               THE HARMONIC SPRING FORCES                     ==
C     ==                      OF THE IONS                             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'cnst.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSX,*),FION(3,NAX,*)
      INTEGER INP
      LOGICAL TFORCE
C     Variables
      REAL*8  RNP,FACF,FACE,XLM,YLM,ZLM,XLMP1,YLMP1,ZLMP1,
     &        XLMM1,YLMM1,ZLMM1
      INTEGER IS,IA
C     ==--------------------------------------------------------------==
      RNP=DBLE(NP_TOTAL)
      EHAR=0.0D0
      DO IS=1,NSP
        FACF = PMAR(IS)*RNP*(TEMPW/FACTEM)**2
        FACE = FACF/2.0D0
        DO IA=1,NA(IS)
          XLM=TAU0(1,IA,IS,INP)-TAU0(1,IA,IS,IPP1(INP))
          YLM=TAU0(2,IA,IS,INP)-TAU0(2,IA,IS,IPP1(INP))
          ZLM=TAU0(3,IA,IS,INP)-TAU0(3,IA,IS,IPP1(INP))
          CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
          XLMP1=XLM
          YLMP1=YLM
          ZLMP1=ZLM 
          IF(TFORCE) THEN
            XLM=TAU0(1,IA,IS,INP)-TAU0(1,IA,IS,IPM1(INP))
            YLM=TAU0(2,IA,IS,INP)-TAU0(2,IA,IS,IPM1(INP))
            ZLM=TAU0(3,IA,IS,INP)-TAU0(3,IA,IS,IPM1(INP))
            CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
            XLMM1=XLM
            YLMM1=YLM
            ZLMM1=ZLM
            FION(1,IA,IS) = FION(1,IA,IS) - FACF*(XLMM1+XLMP1) 
            FION(2,IA,IS) = FION(2,IA,IS) - FACF*(YLMM1+YLMP1) 
            FION(3,IA,IS) = FION(3,IA,IS) - FACF*(ZLMM1+ZLMP1) 
          ENDIF
          EHAR = EHAR+FACE*( XLMP1**2+YLMP1**2+ZLMP1**2 )
        ENDDO 
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
