C     ==================================================================
      SUBROUTINE FINALP(TAU0,FION,VELP,EIGV)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !CALDIP
      INCLUDE 'ions.inc'        !NSP NA
      INCLUDE 'adat.inc'
      INCLUDE 'cnst.inc'        !AU_KB AU_DEB
      INCLUDE 'dipo.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'strs.inc'        !PAIU
      INCLUDE 'prcp.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'rmas.inc'        !PMA
      INCLUDE 'ropt.inc'
      INCLUDE 'store.inc'
C     Arguments
      REAL*8    TAU0(3,NAX,NSP),FION(3,NAX,NSP),VELP(3,NAX,NSP),
     &          EIGV(N,NKPTS)
C     Variables
      DIMENSION RK(3,NKPTS),WK(NKPTS),F(N,NKPTS)
      REAL*8    D1,D2,D3,DD,FACT,OUT(3,3)
      INTEGER   I,J,K,L,IS,IA,NXST
C     ==--------------------------------------------------------------==
      WRITE(6,'(/,1X,64("*"))')
      WRITE(6,'(" *",62X,"*")')
      WRITE(6,'(" *",23X,A,24X,"*")') ' FINAL RESULTS '
      WRITE(6,'(" *",62X,"*")')
      WRITE(6,'(1X,64("*"))')
      CALL WRGEOF(TAU0,FION)
      IF(XGOUT) THEN
         IF(MOD(INFI,NGXYZ).NE.0) THEN
            NXST=NGXYZ
            NGXYZ=1
            CALL WRGEOX(TAU0)
            NGXYZ=NXST
         ENDIF
      ENDIF
      CALL DUMPR
      CALL CNSTPR
      IF(TDIAG) CALL WREIGEN(EIGV,F,AMU,N)
      WRITE(6,*)
C     ==--------------------------------------------------------------==
      IF(TPRCP) THEN
        WRITE(6,*) '  CELL PARAMETERS:'
        DO I=1,3
          WRITE(6,'(T21,3(F15.8))') (HT(I,J),J=1,3)
        ENDDO
        WRITE(6,'(/,1X,64("*"))')
        CALL DCOPY(9,PAIU,1,OUT,1)
        DO IS=1,NSP
          FACT=PMA(IS)
          DO IA=1,NA(IS)
            DO K=1,3
              DO L=1,3
                OUT(K,L)=OUT(K,L)+FACT*VELP(K,IA,IS)*VELP(L,IA,IS)
              ENDDO
            ENDDO
          ENDDO
        ENDDO
        WRITE(6,*) '  TOTAL STRESS (kB)'
        DO I=1,3
          WRITE(6,'(7X,3(F18.8))') ((OUT(I,J)/OMEGA)*AU_KB,J=1,3)
        ENDDO
      ENDIF
      WRITE(6,'(1X,64("*"),/)')
      WRITE(6,*)
C     ==--------------------------------------------------------------==
      IF(.NOT.TKNOSWAP) THEN
        WRITE(6,'(A)') ' ELECTRONIC GRADIENT:'
        WRITE(6,'(2(A,1PE15.5))') '    MAX. COMPONENT =',
     *       GEMAX,'         NORM =',CNORM
        IF(IPRINT(IPRINT_FORCE).GT.0) THEN
          WRITE(6,'(A)') ' NUCLEAR GRADIENT: '
          WRITE(6,'(2(A,1PE15.5))') '    MAX. COMPONENT =',
     *       GNMAX,'         NORM =',GNORM
          WRITE(6,*)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TKNOSWAP) THEN
C       Do not display energies.
      ELSE
C       Write energies
        CALL WRENER
      ENDIF
C     ==--------------------------------------------------------------==
      IF(CALDIP) THEN
        WRITE(6,'(A)') ' DIPOLE MOMENT '
        D1=DMOM(1)
        D2=DMOM(2)
        D3=DMOM(3)
        DD=SQRT(D1*D1+D2*D2+D3*D3)
        WRITE(6,'(3(10X,A),6X,A)') ' X',' Y',' Z',' TOTAL'      
        WRITE(6,'(4F12.5,A)') D1,D2,D3,DD,'   atomic units'
        WRITE(6,'(4F12.5,A)') AU_DEB*D1, AU_DEB*D2, AU_DEB*D3,
     &                        AU_DEB*DD,'   Debye'
        WRITE(6,*)
      ENDIF
      IF(TPRES) CALL WRSTRESS
      CALL PSTRUC(TAU0)
      WRITE(6,'(1X,64("*"),/)')
      IF(CDFT)CALL CDFT_FINALIZE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
