C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == FREE ENERGY INCLUDE FILE                                     ==
C     == FOR TROTTER APPROXIMATION                                    ==
C     ==================================================================
C     ==  BETAEL:  1/kT                                               ==
C     ==  BETAP:   TROTTER FACTOR                                     ==
C     ==  P:       BETAEL/BETAP                                       ==
C     ==  TBOGO:   TRUE FOR THE BOGOLIUBOV CORRECTION                 ==
C     ==  TTROT:   TRUE FOR THE TROTTER APPROXIMATION                 ==
C     ==  TFRAL:   TRUE, COMPUTES ALL WANTED EIGENVALUES WITH         ==
C     ==           THE REQUIRED ACCURACY                              ==
C     ==--------------------------------------------------------------==
      REAL*8       BETAEL,BETAP,P
      LOGICAL      TBOGO,TTROT,TFRAL
      COMMON/FINT1/BETAEL,BETAP,P,TBOGO,TTROT,TFRAL 
C     ==================================================================
C     ==  EMK2:    EXPONENTIATED KINETIC ENERGY IN G-SPACE            ==
C     ==  ALM(IMAGP,NLM,NLM,NKPNT)                                    ==
C     ==           OVERLAP MATRIX BETWEEN NL PP PROJECTORS            ==
C     ==           IF TKPNT, ALM IS COMPLEX (IMAGP = 2)               ==
C     ==  AFNL(IMAGP,NLM,2)                                           ==
C     ==           IF TKPNT, AFNL IS COMPLEX (IMAGP = 2)              ==
C     ==  BILN(IMAGP,NLM,2)                                           ==
C     ==           IF TKPNT, BILN IS COMPLEX (IMAGP = 2)              ==
C     ==  CNL:                                                        ==
C     ==  NLPTR:   INDEX ARRAY GIVING IS, ISA, AND IV FOR EACH NLM    ==
C     ==--------------------------------------------------------------==
      REAL*8       EMK2
      POINTER      (IP_EMK2,EMK2)
      POINTER      (IP_ALM,ALM),(IP_AFNL,AFNL),(IP_BILN,BILN)
      REAL*8       ALM(IMAGP,NLM,NLM,*),
     &             AFNL(IMAGP,NLM,*),BILN(IMAGP,NLM,*)
      INTEGER      NLPTR
      POINTER      (IP_NLPTR,NLPTR)
      COMPLEX*16   CNL
      POINTER      (IP_CNL,CNL)
      COMMON/FINT2/IP_EMK2,IP_AFNL,IP_BILN,IP_ALM,IP_NLPTR,IP_CNL
C     ==--------------------------------------------------------------==
C     == TO SAVE TIME WE CAN CHANGE THE VALUE OF B2LIMIT              ==
C     == WHICH CAN ONLY DECREASE                                      ==
C     ==--------------------------------------------------------------==
C     == MAXTROT: MAXIMAL NUMBER OF CHOICE FOR B2LIMIT                ==
C     == NTABTROT: NUMBER OF B2LIMIT CHOICE                           ==
C     == ITROT: CURRENT INDEX IN THE ARRAY B2TROT                     ==
C     == DENSTROT(MAXTROT): DENSITY THRESHOLD ARRAY                   ==
C     == B2TROT(MAXTROT):  B2LIMIT ARRAY                              ==
C     ==--------------------------------------------------------------==
      INTEGER MAXTROT
      PARAMETER (MAXTROT=10)
      INTEGER NTABTROT,ITROT
      REAL*8 DENSTROT(MAXTROT),B2TROT(MAXTROT)
      COMMON/FINT4/ DENSTROT,B2TROT,NTABTROT,ITROT                
C     ==--------------------------------------------------------------==
C     == TO SAVE TIME WE CAN CHANGE THE VALUE OF BETAP                ==
C     == WHICH CAN ONLY DECREASE                                      ==
C     ==--------------------------------------------------------------==
C     == MAXBETAP: MAXIMAL NUMBER OF CHOICE FOR BETAP                 ==
C     == NTABBETAP: NUMBER OF BETAP CHOICE                            ==
C     == IBETAP: CURRENT INDEX IN THE ARRAY TABBETAP                  ==
C     == DENSBETAP(MAXBETAP): DENSITY THRESHOLD ARRAY                 ==
C     == TABBETAP(MAXTROT):  TABBETAP ARRAY                           ==
C     ==--------------------------------------------------------------==
      INTEGER MAXBETAP
      PARAMETER (MAXBETAP=10)
      INTEGER NTABBETAP,IBETAP
      REAL*8 DENSBETAP(MAXBETAP),TABBETAP(MAXBETAP)
      COMMON/FINT5/ DENSBETAP,TABBETAP,NTABBETAP,IBETAP
C     ==================================================================

