C     ==================================================================
      SUBROUTINE FIXCOM(DISP)
C     ==--------------------------------------------------------------==
C     == FOR THE OPTION FIX COM (FIX THE CENTER OF MASS)              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      REAL*8  DISP(NODIM)
C     Variables
      REAL*8  CDMM(3)
      INTEGER K,IAT,IS,IA,L
C     ==--------------------------------------------------------------==
C     ==  COMPUTE AND CORRECT FOR DISPLACEMENT OF CENTER OF MASS      ==
C     ==--------------------------------------------------------------==
      IF(.NOT.LFCOM) RETURN
      CDMM(1)=0.D0
      CDMM(2)=0.D0
      CDMM(3)=0.D0
      K=0
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO L=1,3
            IF(LSKCOR(L,IAT).NE.0) THEN
              K=K+1
              CDMM(L)=CDMM(L)+DISP(K)*PMALL(IAT)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
      CDMM(1)=CDMM(1)/PATOT
      CDMM(2)=CDMM(2)/PATOT
      CDMM(3)=CDMM(3)/PATOT
      K=0
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO L=1,3
            IF(LSKCOR(L,IAT).NE.0) THEN
              K=K+1
              DISP(K)=DISP(K)-CDMM(L)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
