C     ==================================================================
      SUBROUTINE FNLALLOC(NSTATE,TFOR,TSTRESS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'sfac.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'shop.inc'
      INTEGER NSTATE,LDFNL,LFNL
      LOGICAL TFOR,TSTRESS
      REAL*8  FNL(*),DFNL(*)
      DIMENSION FNL2(*)
C     ==--------------------------------------------------------------==
C     FNL
      IF(TFDIST) THEN
        TFNL2=.TRUE. 
        LFNL=MAX(1,IMAGP*NSTATE*NATPE*NHXS*NKPNT)
        CALL MEMORY(IP_FNL,LFNL,'FNL')
        CALL AZZERO(FNL,LFNL)
        LFNL=MAX(1,IMAGP*NORBPE*NAT*NHXS*NKPNT)
        CALL MEMORY(IP_FNL2,LFNL,'FNL2')
        CALL AZZERO(FNL2,LFNL)
        LDF1=NATPE
        LDF2=NORBPE
      ELSE
        TFNL2=.FALSE.
        LFNL=MAX(1,IMAGP*NSTATE*NAT*NHXS*NKPNT)
        CALL MEMORY(IP_FNL,LFNL,'FNL')
        CALL AZZERO(FNL,LFNL)
        CALL GET_ADDR(IP_FNL2,FNL)
        LDF1=NAT
        LDF2=NSTATE
      ENDIF
C     DFNL
#ifdef PARALLEL
      IF ( TSHOP ) THEN
         NDFNL=int(NSTATE/NPROC)+1
      ELSE 
         NDFNL=NST12(MEPOS,2)-NST12(MEPOS,1)+1
      ENDIF
#else
      NDFNL=NSTATE
#endif
      LDFNL=IMAGP*3*NAT*NHXS*NDFNL*NKPNT
      IF(LDFNL.LE.0) LDFNL=1
      CALL MEMORY(IP_DFNL,LDFNL,'DFNL')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FNLDEALLOC(TFOR,TSTRESS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'sfac.inc'
      LOGICAL TFOR,TSTRESS
      REAL*8  FNL(*),DFNL(*)
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_FNL)
      IF(TFNL2) CALL FREEM(IP_FNL2)
      CALL FREEM(IP_DFNL)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FNL_SET(TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'sfac.inc'
      INCLUDE 'nlps.inc'
C     C.BEKAS
      INCLUDE 'ions.inc'
      REAL*8  FNL(*),DFNL(*)
      CHARACTER*(*) TAG
      POINTER (IP_XFNL,XFNL),(IP_XDFNL,XDFNL),(IP_XDUM,XDUM)
      POINTER (IP_XFNL2,XFNL2)
      REAL*8  XFNL,XFNL2,XDFNL,XDUM
      INTEGER LDF1B,LDF2B,LDFD,NDFNLB
      LOGICAL TFNL2B,TFNL2D
      SAVE IP_XFNL,IP_XDFNL,IP_XFNL2,LDF1B,LDF2B,NDFNLB,TFNL2B
C     ==--------------------------------------------------------------==
C     C. Bekas:  IF(TFDIST) CALL STOPGM('FNL_SET','TFDIST NOT IMPLEMENTED')
      IF(INDEX(TAG,'SAVE').NE.0) THEN
        IP_XFNL=IP_FNL
        IP_XFNL2=IP_FNL2
        IP_XDFNL=IP_DFNL
        LDF1B=LDF1
        LDF2B=LDF2
        NDFNLB=NDFNL
        TFNL2B=TFNL2
      ELSEIF(INDEX(TAG,'RECV').NE.0) THEN
        IP_FNL=IP_XFNL
        IP_FNL2=IP_XFNL2
        IP_DFNL=IP_XDFNL
        LDF1=LDF1B
        LDF2=LDF2B
        NDFNL=NDFNLB
        TFNL2=TFNL2B
      ELSEIF(INDEX(TAG,'SWITCH').NE.0) THEN
        IP_XDUM=IP_FNL
        IP_FNL=IP_XFNL
        IP_XFNL=IP_XDUM
        IP_XDUM=IP_FNL2
        IP_FNL2=IP_XFNL2
        IP_XFNL2=IP_XDUM
        IP_XDUM=IP_DFNL
        IP_DFNL=IP_XDFNL
        IP_XDFNL=IP_XDUM
        LDFD=LDF1
        LDF1=LDF1B
        LDF1B=LDFD
        LDFD=LDF2
        LDF2=LDF2B
        LDF2B=LDFD
        LDFD=NDFNL
        NDFNL=NDFNLB
        NDFNLB=LDFD
        TFNL2D=TFNL2
        TFNL2=TFNL2B
        TFNL2B=TFNL2D
      ELSEIF(INDEX(TAG,'MIX').NE.0) THEN
        IP_XDUM=IP_DFNL
        IP_DFNL=IP_XDFNL
        IP_XDFNL=IP_XDUM
        LDFD=NDFNL
        NDFNL=NDFNLB
        NDFNLB=LDFD
      ELSE
        CALL STOPGM('FNL_SET','INVALID TAG')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
