C     ==================================================================
      SUBROUTINE FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *                   NSTATE,NKPOINT,LPROJ,TFOR)
C     ==--------------------------------------------------------------==
C     ==             DRIVER FOR FORCE CALCULATION                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'bsym.inc' 
      INCLUDE 'mm_dim.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,NKPOINT
      COMPLEX*16 C0(*),C2(*),SC0(*),PSI(*)
      REAL*8     TAU0(*),FION(*),SCR(*),EIGV(*),RHOE(NNR1,*)
      LOGICAL    LPROJ,TFOR,oldstatus,statusdummy
C     Variables
      CHARACTER*30 TAG
      REAL*8  XMAT1(NSTATE*NSTATE,*),XMAT2(*)
      POINTER (IP_XMAT1,XMAT1),(IP_XMAT2,XMAT2)
      INTEGER ISUB,NUMX,I,IPX,LFORCEDR,MSGLEN,
     &        ICON
      DATA    ICON /0/
      SAVE    ICON,IP_XMAT1,IP_XMAT2
C     ==--------------------------------------------------------------==
      CALL TISET('   FORCEDR',ISUB)
C     Test SCR
      
C     make sure scratch space is large enough and forces are properly zeroed
      call mm_dim(mm_go_mm,oldstatus)
      CALL GIVE_SCR_FORCEDR(LFORCEDR,TAG,NSTATE,LPROJ,TFOR)
      CALL TEST_SCR('FORCEDR',TAG,LSCR,LFORCEDR)
      CALL AZZERO(FION,3*NAX*NSX)
      call mm_dim(mm_go_qm,statusdummy)
      IF(ICON.EQ.0 .AND. NONORT .AND. PARENT) THEN
         IF(TPATH) THEN
            NUMX=NP_LOCAL
         ELSE
           NUMX=1
C          For BSYMM: we have two wavefunctions
           IF(BSYMM)NUMX=2 
         ENDIF
         CALL MEMORY(IP_XMAT1,NSTATE*NSTATE*NUMX,'XMAT1')
         CALL MEMORY(IP_XMAT2,NSTATE*NSTATE,'XMAT2')
         DO I=1,NUMX
           CALL UNITMX(XMAT1(1,I),NSTATE)
         ENDDO
         ICON=1
      ENDIF
      IF(NONORT) THEN
        IF(TPATH) THEN
          IPX=IPCURR-NP_LOW+1
C      For BSYMM: BSCLCS=1 for BS and BSCLCS==2 for HS
        ELSE IF(BSYMM) THEN
          IPX=BSCLCS
        ELSE
          IPX=1
        ENDIF
        CALL NOFORCE(C0,C2,SC0,TAU0,FION,EIGV,RHOE,PSI,
     *               XMAT1(1,IPX),XMAT2,SCR,LSCR,NSTATE,TFOR)
      ELSE
        CALL FORCES(C0,C2,TAU0,FION,RHOE,PSI,SCR,LSCR,
     *              NSTATE,NKPOINT,LPROJ,TFOR)
      ENDIF
C     Forces from restraints (may be in the MM part as well)
      IF ( TFOR ) THEN
         call mm_dim(mm_go_mm,statusdummy)
         IF(PARENT) THEN
           DO I=1,MRESTR
             RESVAL(I)=RESVAL(I)+GSRATE(I)*DT_IONS
             IF(RESVAL_DEST(I).NE.-999.D0) THEN
               IF(GSRATE(I).GT.0.D0.AND.RESVAL(I).GT.RESVAL_DEST(I))
     *           RESVAL(I)=RESVAL_DEST(I) ! increase
               IF(GSRATE(I).LT.0.D0.AND.RESVAL(I).LT.RESVAL_DEST(I))
     *           RESVAL(I)=RESVAL_DEST(I) ! decrease
             ENDIF
           ENDDO
           CALL RESTFC(TAU0,SCR,FION)
         ENDIF
         MSGLEN = 3*NAX*NSX * 8
         CALL MY_BCAST(FION,MSGLEN,SOURCE,ALLGRP)
      ENDIF
      call mm_dim(mm_revert,oldstatus)
      CALL TIHALT('   FORCEDR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_FORCEDR(LFORCEDR,TAG,NSTATE,LPROJ,TFOR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NONORT
      INCLUDE 'kpts.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      INTEGER   LFORCEDR,NSTATE,LTSCR,LSYMVEC,
     &    IL_GAM,IL_AUXC,IL_SMAT,IL_DDIA
      LOGICAL   LPROJ,TFOR,OLDSTATUS
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      call mm_dim(mm_go_mm,OLDSTATUS)
Civano 4/3/2011
      LFORCEDR=0
Civano 4/3/2011
      IF(NONORT) THEN
        CALL GIVE_SCR_NOFORCE(LFORCEDR,IL_GAM,IL_AUXC,IL_SMAT,IL_DDIA,
     &      TAG,NSTATE,TFOR)
      ELSE
CEHR[
        IF(TKPNT.AND.(.NOT.(TMDEH.OR.TPSPEC.OR.TPDIST))) THEN
          CALL GIVE_SCR_KFORCES(LFORCEDR,TAG,NSTATE,LPROJ,TFOR)
        ELSE
          CALL GIVE_SCR_FORCES(LFORCEDR,TAG,NSTATE,LPROJ,TFOR)
        ENDIF
      ENDIF
CEHR]
      LTSCR=3*NAX*NSX
      LSYMVEC=0
      CALL GIVE_SCR_SYMVEC(LSYMVEC,TAG)
      LFORCEDR=MAX(LFORCEDR,LTSCR,LSYMVEC)
      TAG='MAX(LFORCEDR,LTSCR,LSYMVEC)'
      call mm_dim(mm_revert,OLDSTATUS)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

