C hello emacs, this is -*- fortran -*-
C=======================================================================
C include file for forcematching
C
C=======================================================================
C logicals
C     copy of FMATCH in system.h for files which do not include system.h
      logical   fm_fmatch
C     compute a whole reference trajectory (i.e. do MD), not yet
C     implemented
      logical   fm_compute_traj
C     compute forces, fields, etc. via single points from a reference
C     TRAJECTORY
      logical   fm_compute_sp
C     read in forces from external file
      logical   fm_read_forces
C     read in covalent forces from external file
      logical   fm_read_covforces
C     equivalencies
      logical   fm_equivalence
C     fit charges
      logical   fm_fit_charges
C     fit charges only
      logical   fm_charges_only
C     fit force constants only (not equilibrium bond lengths/angles)
      logical   fm_fit_fc_only
C     fit parameters for bonds,angles,dihedrals,and improper dihedrals
      logical fm_fit_bonds,fm_fit_angles,fm_fit_diheds,fm_fit_improps
C     re-initialize the wavefunction for each step
      logical   fm_rinit_wf
C     restart of the single point calculations
C     restart from the last frame index written to the FM_REF files
      logical   fm_sp_restart      
C     compute RMS of total forces
      logical   fm_compute_rms

      common /fm_l/ fm_fmatch,
     $              fm_compute_traj, fm_compute_sp, fm_read_forces, 
     $              fm_read_covforces,
     $              fm_equivalence, fm_fit_charges, fm_charges_only,
     $              fm_fit_fc_only,fm_fit_bonds,fm_fit_angles,
     $              fm_fit_diheds,fm_fit_improps,fm_rinit_wf,
     $              fm_sp_restart,fm_compute_rms

C strings
C     filename with reference forces, etc.
      character*80      fm_reference_filename
C     filenames for qfit
C     Manuel: I renamed these variables
C      character*80      fm_qm_ref_filename, fm_nn_ref_filename
C     filename for the reference Hirschfeld charges      
      character*80      fm_chj_ref_filename
C     Manuel: filename for the reference pip file
      character*80      fm_pip_ref_filename
C     Manuel: filename for the reference forces
      character*80      fm_forces_ref_filename
C     Manuel: reference trajectory file name from which 
C     geos for single points are extracted
      character*80      fm_ref_traj_filename
C     file where covalent QM forces are written to (to fit force
C     constants, etc.)
      character*80      fm_covforces_ref_filename
C     name of optimized topology file
      character*80      fm_outtopo_filename

      common /fm_s/ fm_reference_filename,
     $              fm_chj_ref_filename,
     $              fm_ref_traj_filename, fm_outtopo_filename,
     $              fm_pip_ref_filename,fm_forces_ref_filename,
     $              fm_covforces_ref_filename

C integers
C   total nr. of frames (that are used for fitting)
      integer           fm_nframes
C   total nr. of QM atoms (that we fit on..)
      integer           fm_nrqm
C   stride to apply to reference trajectory when extracting
C   the geos for the single points
      integer            fm_ref_traj_stride
C   keep the nr. of frame (that is in TRAJECTORY_REF!) available for
C   consistent output
      integer           fm_iframe
C   equivalencies
C   NOTE: fm_equiv is read from input file and contains 
C   GROMOS atom numbers!
      integer           fm_maxeq
      parameter         (fm_maxeq = 1000)
      integer           fm_nreq
      integer           fm_equiv(2, fm_maxeq)
      integer, pointer  :: grm_equiv(:)
      integer, pointer  :: qm_equiv(:)
C     index  when extracting a frame from the TRAJECTORY_REF
C     file. this will be printed in the FM_REF_PIP, FM_REF_CHJ 
C     and the FM_REF_FORCES files.
      integer          fm_frame_indx
C     maximum number of allowed fixed charges
      integer          fm_max_q_fixers
      parameter        (fm_max_q_fixers = 1000)
      integer         fm_max_qw
      parameter        (fm_max_qw=1000)
C     cpmd atom indexes for which charges should stay fixed
      integer          fm_fixed_q_indx(fm_max_q_fixers)
      integer          fm_fixed_q_grm_indx(fm_max_q_fixers)
c     actual number of fixed charges
      integer          fm_n_fix_q
c     number of weights for the charge fitting given by user
      integer          fm_n_qw
c     index array for the weights on charges specified by the user      
      integer          fm_wq_indx(fm_max_qw)
      integer          fm_wq_grm_indx(fm_max_qw)


      common /fm_i/ fm_nframes, fm_nrqm,
     $              fm_ref_traj_stride, fm_nreq, fm_equiv, grm_equiv,
     $              qm_equiv,fm_frame_indx,
     $              fm_fixed_q_indx,fm_n_fix_q,fm_n_qw,fm_wq_indx
C=======================================================================
C specific for charge fitting
C logicals
C     Find optimal weights
      logical   fm_optimize_weights
C     MANUEL
C     fix some of the charges
      logical   fm_fix_q

      common /fm_qfit_l/ fm_optimize_weights,fm_fix_q

C integers
C     MM atoms excluded from charge-fitting
      integer   fm_max_nexclude
      parameter (fm_max_nexclude = 100)
      integer   fm_nexclude
      integer   fm_exclude(fm_max_nexclude)

      common /fm_qfit_i/ fm_nexclude, fm_exclude

C reals
C     weight for potential
      real*8	fm_wv
C     weight for field
      real*8    fm_wf
C     MANUEL (array) weights for individual charge restraints
      real*8    fm_wq(fm_max_qw)
      real*8    fm_wq_unique(fm_max_qw)
C     weight for the atoms for which no individual weight is
C     specified in the input
      real*8    fm_wq_general
C     weight for total charge
      real*8    fm_wtot
C     Manuel target value for the charges to be fixed
      real*8    fm_fixed_q_trgt(fm_max_q_fixers)

      common /fm_qfit_r/ fm_wv, fm_wf,fm_wq,fm_wq_unique, fm_wtot,
     $                   fm_fixed_q_trgt
C=======================================================================
C topology related stuff and stuff for fitting covalent forces
C logicals
C     amber or gromos functional form? (copy of qmmm_amber in
C     mm_input.inc)
      logical           :: fm_amber

      common /fm_topo_l/ fm_amber

C integers
C     save exclusion lists
      integer, pointer  :: fm_save_INE(:)
      integer, pointer  :: fm_save_KNE(:)
      integer, pointer  :: fm_save_JSNE(:)
      integer, pointer  :: fm_save_INE14(:)
      integer, pointer  :: fm_save_KNE14(:)
      integer, pointer  :: fm_save_JSNE14(:)
C     bond, etc. types to be optimized. fm_nbonopt is the number of bond
C     types to optimize. fm_bonopt(1:fm_nbonopt) contains the numbers of 
C     optimized bond types. Analogous for ang,imp,dih.
      integer           :: fm_nbonopt, fm_nangopt
      integer           :: fm_nimpopt, fm_ndihopt
      integer, pointer  :: fm_bonopt(:), fm_angopt(:)
      integer, pointer  :: fm_impopt(:), fm_dihopt(:)

C     number of individual bonds, etc. that are optimized
      integer           :: fm_nbon, fm_nang, fm_nimp, fm_ndih

C     individual bonds, etc. that belong to types that are optimized
C     fm_ib(:, :) will be dimensioned fm_ib(0:2, MAX_NR_OF_BONDS), and
C     for bond ib holds the type in fm_ib(0, ib), and the CPMD numbers
C     of the atoms forming the bond in fm_ib(1,ib) and fm_ib(2,ib)
C     analogous for the others, e.g. for dihedrals type is in
C     fm_ip(0,ip), and the 4 atoms in fm_ip(1:4,ip)
C     _ib, _it, _iq, _ip hold bonds, angles, impropers, dihedrals, resp.
      integer, pointer  :: fm_ib(:, :), fm_it(:, :)
      integer, pointer  :: fm_iq(:, :), fm_ip(:, :)

C     max nr. of iterations for Levenberg-Marquardt
      integer           :: fm_max_kfit_iterations

      common /fm_topo_i/  fm_save_INE, fm_save_KNE, fm_save_JSNE, 
     $                    fm_save_INE14, fm_save_KNE14, fm_save_JSNE14,
     $                    fm_nbonopt, fm_nangopt, fm_nimpopt,
     $                    fm_ndihopt, fm_bonopt, fm_angopt, fm_impopt,
     $                    fm_dihopt,
     $                    fm_nbon, fm_nang, fm_nimp, fm_ndih,
     $                    fm_ib, fm_it, fm_iq, fm_ip,
     $                    fm_max_kfit_iterations

C reals
C     coordinates of QM atoms (dimensions are 3, nrqm, nframes)
      real*8, pointer   :: fm_rqm(:, :, :)
C     reference forces
      real*8, pointer   :: fm_fqm_ref(:, :, :)
C     store force constants of QM bonds, etc. (they are set to 0 for
C     QM/MM, but we want to keep the original as an initial guess for
C     fitting
      real*8, pointer   :: fm_kbon(:), fm_kang(:)
      real*8, pointer   :: fm_kimp(:), fm_kdih(:)

C     force constants and equilibrium values for fitting (we use our own
C     arrays going from 1..NR_OF_OPTIMIZED_TYPES
      real*8, pointer   :: fm_kb(:), fm_b0(:)
      real*8, pointer   :: fm_kt(:), fm_t0(:)
      real*8, pointer   :: fm_kq(:), fm_q0(:)
      real*8, pointer   :: fm_kp(:), fm_p0(:), fm_pn(:)

      common /fm_topo_r/ fm_rqm, fm_fqm_ref,
     $                   fm_kbon, fm_kang, fm_kimp, fm_kdih,
     $                   fm_kb, fm_b0, fm_kt, fm_t0, fm_kq, fm_q0, 
     $                   fm_kp, fm_p0, fm_pn
C=======================================================================
C capping
C logicals
C     are there capping hydrogens?
      logical   fm_capping
      logical, pointer  :: fm_iscap(:)

      common /fm_cap_l/ fm_iscap, fm_capping
C integers
C     max. nr of capping hydrogens (this should be equal to 
C     the parameter npax which is defined in MM_Interface/mm_cap_H.F
      integer   fm_maxcap
      parameter(fm_maxcap = 200)
C     actual nr of capping hydrogens
      integer   fm_ncap
C     In array fm_cap, atom fm_cap(1, i) is the nr of the hydrogen atom
C     that caps atom fm_cap(2, i), initially with GROMOS numbers
      integer   fm_cap(2, fm_maxcap)

      common /fm_cap_i/ fm_ncap, fm_cap
C=======================================================================

