C     ==================================================================
      SUBROUTINE FORCES(C0,C2,TAU0,FION,RHOE,PSI,SCR,LSCR,
     &                  NSTATE,NKPOINT,LPROJ,TFOR)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==                     THE TOTAL ENERGY                         ==
C     ==                  THE ELECTRONIC FORCES                       ==
C     ==                  THE FORCES ON THE IONS                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'norm.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'rswf.inc'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    NSTATE,NKPOINT,LSCR
      COMPLEX*16 C0(NGWK,NSTATE,*),C2(NGWK,*),PSI(*)
      REAL*8     TAU0(*),FION(*),RHOE(*),SCR(*)
C     Variables
      DIMENSION  F(NSTATE,*)
      REAL*8     GAM(NSTATE,*),DDIA(*),FSC(*),SCRDIP(*)
      COMPLEX*16 AUXC(*),PSIAB(*)
      POINTER    (IP_GAM,GAM),(IP_AUXC,AUXC),(IP_DDIA,DDIA),(IP_FSC,FSC)
      POINTER    (IP_PSIAB,PSIAB)
      POINTER    (IP_SCRDIP,SCRDIP)
      REAL*8     A1MAT(NSTATE,*),A2MAT(NSTATE,*),A3MAT(*)
      POINTER    (IP_A1MAT,A1MAT),(IP_A2MAT,A2MAT),(IP_A3MAT,A3MAT)
      CHARACTER  TAG*30
      COMPLEX*16 ZEE
      REAL*8     EE,EHFX,VHFX,FI,FJ
      COMPLEX*16 ZDOTC
      REAL*8     DOTP,DASUM
      EXTERNAL   ZDOTC,DOTP,DASUM
      INTEGER    MSGLEN,IP,J,JJ,NX
      INTEGER    ISUB,IKIND,IK,I,NAA,LSUMMAT,IL_PSIAB,NSTX,
     &           IL_GAM,IL_AUXC,IL_DDIA,IL_FSC,IL_SCRDIP,LFORCES
      LOGICAL    LPROJ,TFOR,DEBUG
C     ==--------------------------------------------------------------==
      CALL TISET('    FORCES',ISUB)
      GNMAX=0.0D0
      GNORM=0.0D0
      EHFX =0.0D0
      VHFX =0.0D0
C     ==--------------------------------------------------------------==
C     SCR partition
      DEBUG=.FALSE.
      IF(TIVAN .AND. LPROJ .AND. IPROJ.NE.0) THEN
        CALL GIVE_SCR_NLFORCE(IL_GAM,IL_AUXC,IL_DDIA,NSTATE)
      ELSE
        CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NSTATE)
        IL_GAM = IMAGP*NSTATE*NSTATE
      ENDIF
      IF (TFIELD) CALL GIVE_SCR_OPEIGR(IL_SCRDIP,TAG,NSTATE)
      IF(TDMAL) THEN
        CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
        IL_GAM=1
      ELSE
        CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NSTATE)
        IL_AUXC=MAX(IL_AUXC,LSUMMAT)
        IL_AUXC=MAX(IL_AUXC,NSTATE*NSTATE)  ! AUXC space for OVLAP (Laio A.)
      ENDIF
      IL_FSC=NSTATE
      IL_PSIAB=2
      IF(TLSE) IL_PSIAB=2*MAXFFT
      CALL GIVE_SCR_FORCES(LFORCES,TAG,NSTATE,LPROJ,TFOR)
      CALL TEST_SCR('FORCES','LENGTH',LSCR,LFORCES)
C     ==--------------------------------------------------------------==
C     ==   CALCULATE THE POTENTIAL AND THE FORCE ON THE IONS          ==
C     ==--------------------------------------------------------------==
      DO IKIND=1,NKPOINT
        CALL RNLSM(C0(1,1,IKIND),NSTATE,PSI,SCR,LSCR,1,IKIND,TFOR)
      ENDDO
      RSACTIVE = KRWFN
      CALL RSCPOT(C0,TAU0,FION,RHOE,PSI,SCR,LSCR,
     &            TFOR,CALSTE,NSTATE,NKPOINT)
C     ==--------------------------------------------------------------==
C     ==   CALCULATE THE ELECTRONIC FORCE                             ==
C     ==--------------------------------------------------------------==
      IF(NSTATE.EQ.0) THEN
         GEMAX=0.D0
         CNORM=0.D0
         GOTO 2000
      ENDIF
      CALL ZAZZERO(C2,NGWK*NSTATE)
CEHR[
C     tmdeh only needs forces acting on the nuclei
C     skip calculation of C2 (forces on KS orbitals)
      IF (TMDEH) GOTO 2000
CEHR]
C     ==--------------------------------------------------------------==
C     == COMPUTE THE FORCE ON THE ELECTRONIC DEGREES OF FREEDOM DUE   ==
C     == TO THE LOCAL POTENTIAL (STORED IN RHOE)                      ==
C     ==--------------------------------------------------------------==
      CALL SCRSET(SCR,LSCR,DEBUG)
      IF(TDMAL) THEN
        CALL SCRPTR(SCR,LSCR,IP_A1MAT,NSTATE*NSTX,'A1MAT',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_A2MAT,NSTATE*NSTX,'A2MAT',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_A3MAT,NSTATE*NSTX,'A3MAT',DEBUG)
      ENDIF
      CALL SCRPTR(SCR,LSCR,IP_AUXC,IL_AUXC,'AUXC',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_GAM,IL_GAM,'GAM',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_DDIA,IL_DDIA,'DDIA',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_FSC,IL_FSC,'FSC',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_PSIAB,IL_PSIAB,'PSIAB',DEBUG)
      IF (TFIELD) CALL SCRPTR(SCR,LSCR,IP_SCRDIP,IL_SCRDIP,'DIP',DEBUG)
      DO IK=1,NKPOINT
        CALL VPSI(C0(1,1,IK),C2,F,RHOE,PSI,PSIAB,NSTATE,IK,NLSD)
        CALL HFX(C0,C2,F,PSI,NSTATE,EHFX,VHFX)
cMcB    IF (TFIELD) CALL EFIELD(TAU0,FION,C0,C2,SCRDIP,IL_SCRDIP,NSTATE)
        IF (TFIELD) 
     .           CALL EXTFIELD(TAU0,FION,C0,C2,SCRDIP,IL_SCRDIP,NSTATE)
        EXC=EXC+EHFX
        ETOT=ETOT+EHFX
        IF(TIVAN) THEN
          IF(TKPNT) CALL STOPGM('FORCES','K-POINTS NOT IMPLEMENTED')
          IF(LPROJ.AND.IPROJ.NE.0) THEN
            CALL OVLAP(NSTATE,GAM,C2,C0(1,1,IK))
            CALL HNLMAT(GAM,F,NSTATE)
            CALL GLOSUM(NSTATE*NSTATE,GAM)
            IF(TFOR) CALL RNLFL(FION,GAM,NSTATE,NKPOINT)
            IF(IPROJ.EQ.1) THEN
              DO I=1,NSTATE
                CALL DAXPY(2*NGWK,-GAM(I,I),C0(1,I,IK),1,C2(1,1),1)
              ENDDO
            ELSEIF(IPROJ.EQ.2) THEN
              CALL ROTATE(-1.0D0,C0(1,1,IK),1.0D0,C2,GAM,
     &             NSTATE,2*NGWK,TLSD,NSUP,NSDOWN)
            ENDIF
            CALL NLFORCE(C2,F,GAM,AUXC,DDIA,NSTATE)
          ELSE
            CALL FNONLOC(C2,F,NSTATE,AUXC,DDIA,IK,NLSD)
          ENDIF
        ELSEIF(TLSE) THEN
          CALL FNONLOC(C2,F,NSTATE,AUXC,DDIA,IK,NLSD)
          CALL OVLAP(NSTATE,AUXC,C0(1,1,IK),C2)
          IF (TROS) THEN
             CALL ADDUP2(NSTATE,GAM,AUXC)
          ELSE
             CALL ADDUP(NSTATE,GAM,AUXC)
          ENDIF
#ifdef PARALLEL
          IF(TMGOE.OR.TROS) THEN
            CALL GLOSUM(NSTATE*NSTATE,GAM)
          ELSE
            CALL SUMMAT(GAM,NSTATE,AUXC,IL_AUXC)
          ENDIF
#endif
          HABLSE=GAM(IALPHA,IBETA)
          HAOLSE=DASUM(IALPHA-1,GAM(1,IALPHA),1)
          HBOLSE=DASUM(IALPHA-1,GAM(1,IBETA),1)
          ROTAB=0.5D0*ATAN(2.D0*HABLSE/
     *            (GAM(IALPHA,IALPHA)-GAM(IBETA,IBETA)))
          IF(LPROJ)
     *    CALL ROTATE(-0.5D0,C0(1,1,IK),1.D0,C2,GAM,
     *         NSTATE,2*NGWK,.FALSE.,NSUP,NSDOWN)
        ELSE
          CALL FNONLOC(C2,F,NSTATE,AUXC,DDIA,IK,NLSD)
          IF(LPROJ) THEN
            DO I=1,NSTATE
              IF(F(I,IK).EQ.0.D0) THEN
                FSC(I)=0.D0
              ELSE
                FSC(I)=1.D0
              ENDIF
            ENDDO
            IF(IPROJ.EQ.0) THEN
            ELSEIF(IPROJ.EQ.1) THEN
              IF(TKPNT) THEN  
                IF(NGWK.GT.0) THEN
                  DO I=1,NSTATE
                    ZEE=FSC(I)*ZDOTC(NGWK,C0(1,I,IK),1,C2(1,1),1)
                    CALL GLOSUM(2,ZEE)
                    CALL ZAXPY(NGWK,-ZEE,C0(1,I,IK),1,C2(1,1),1)
                  ENDDO
                ENDIF
              ELSE
                IF(NGW.GT.0) THEN
                  DO I=1,NSTATE
                    EE=FSC(I)*DOTP(NGW,C0(1,I,IK),C2(1,1))
                    CALL GLOSUM(1,EE)
                    CALL DAXPY(2*NGW,-EE,C0(1,I,IK),1,C2(1,1),1)
                  ENDDO
                ENDIF
              ENDIF
            ELSEIF(IPROJ.EQ.2) THEN
              IF(TKPNT) THEN
                IF(TLSD) THEN
                  NAA=NSUP+1
                  CALL AZZERO(GAM,2*NSTATE*NSTATE)
                  CALL OVLAP_C(NSUP,GAM,C2,C0(1,1,IK))
                  CALL OVLAP_C(NSDOWN,GAM(2*NAA,NAA),
     &                 C2(1,NAA),C0(1,NAA,IK))
                ELSE
                  CALL OVLAP_C(NSTATE,GAM,C2,C0(1,1,IK))
                ENDIF
CAK FIXME: can this work? GAM is complex.
                CALL GLOSUM(2*NSTATE*NSTATE,GAM)
                CALL GSCAL_C(NSTATE,GAM,FSC)
                CALL ROTATE_C(DCMPLX(-1.0D0,0.D0),C0(1,1,IK),
     &                        DCMPLX( 1.0D0,0.D0),C2,GAM,NSTATE)
              ELSE
                IF(TDMAL) THEN
                  MSGLEN=NSTATE*NSTX * 8
                  CALL AZZERO(A1MAT,NSTATE*NSTX)
                  DO IP=0,NPROC-1
                    NX=NWA12(IP,2)-NWA12(IP,1)+1
                    CALL AZZERO(A2MAT,NSTATE*NSTX)
                    IF(NX.GT.0) THEN
                      CALL OVLAP2(NGW,NSTATE,NX,A2MAT,
     *                            C2,C0(1,NWA12(IP,1),IK))
                      CALL MY_COMBINE_SOURCE(A2MAT,A3MAT,MSGLEN,1,
     *                                       PGROUP(IP+1),ALLGRP)
                      IF(MEPOS.EQ.PGROUP(IP+1)) THEN
                        CALL DCOPY(NSTATE*NSTX,A3MAT,1,A1MAT,1)
                      ENDIF
                    ENDIF
                  ENDDO
                  DO I=1,NSTATE
                    FI= FSC(I)
                    DO J=NWA12(MEPOS,1),NWA12(MEPOS,2)
                      JJ=J-NWA12(MEPOS,1)+1
                      FJ= FSC(J)
                      A1MAT(I,JJ)=0.5D0*(FI+FJ)*A1MAT(I,JJ)
                    ENDDO
                  ENDDO
                  CALL ROTATE_DA(-1.D0,C0(1,1,IK),1.D0,C2(1,1),A1MAT,
     *                  A2MAT,2*NGW,NSTATE,NWA12(0,1),NWA12(0,2),
     *                  NSTX,MEPOS,PGROUP,NPROC,ALLGRP,
     *                  TLSD,NSUP,NSDOWN)
                ELSE
                  CALL OVLAP(NSTATE,GAM,C2,C0(1,1,IK))
                  CALL GLOSUM(NSTATE*NSTATE,GAM)
                  CALL GSCAL(NSTATE,GAM,FSC)
                  CALL ROTATE(-1.0D0,C0(1,1,IK),1.0D0,C2,GAM,
     &                 NSTATE,2*NGWK,TLSD,NSUP,NSDOWN)
                ENDIF
              ENDIF
            ENDIF
          ENDIF
        ENDIF
        IF(GEQ0) THEN
          IF(TKPNT) THEN
            CALL ZCLEAN_K(C2,NSTATE,NGW)
          ELSE
            CALL ZCLEAN(C2,NSTATE,NGW)
          ENDIF
        ENDIF
        CALL CSIZE(C2,NSTATE,GEMAX,CNORM)
      ENDDO
      CALL SCRREL(SCR,LSCR,DEBUG)
2000  CONTINUE
      RSACTIVE = .FALSE.
      IF(TFOR) THEN
        CALL GLOSUM(3*NAX*NSX,FION)
        IF(PARENT) THEN
          CALL SYMVEC(FION,SCR,LSCR)
          CALL TAUCL(FION)
          CALL GSIZE(FION,GNMAX,GNORM)
        ENDIF
      ENDIF
      CALL TIHALT('    FORCES',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ADDUP(NSTATE,A1,A2)
      IMPLICIT NONE
      INCLUDE 'spin.inc'
      INTEGER NSTATE,I,J
      REAL*8 A1(NSTATE,*),A2(NSTATE,*)
C     ==--------------------------------------------------------------==
      DO I=1,NSTATE
        DO J=I,NSTATE
          A1(I,J)=A2(I,J)+A2(J,I)
          A1(J,I)=A1(I,J)
        ENDDO
      ENDDO
      IF(TMGOE) THEN
        A1(IBETA,IALPHA) = 2.D0*((1.D0-MGMAB)*A2(IBETA,IALPHA)
     .                                +MGMAB *A2(IALPHA,IBETA))
        A1(IALPHA,IBETA) = 2.D0*((1.D0-MGMBA)*A2(IALPHA,IBETA)
     .                                +MGMBA *A2(IBETA,IALPHA))
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ADDUP2(NSTATE,A1,A2)
C     NEW VERSION: MODIFIED GOEDECKER
        IMPLICIT NONE
        INCLUDE 'spin.inc'
        INTEGER NSTATE,I,J
        REAL*8 A1(NSTATE,*),A2(NSTATE,*)
C     ==--------------------------------------------------------------==
        DO I=1,NSTATE-2
          A1(I,I) = 2.0D0 * A2(I,I)
          DO J=I+1,NSTATE-2
            A1(I,J) = A2(I,J) + A2(J,I)
            A1(J,I) = A2(J,I) + A2(I,J)
          ENDDO
          A1(NSTATE-1,I) = 2.0D0*(MGAB(1)*A2(NSTATE-1,I)
     .                           +MGAB(2)*A2(I,NSTATE-1))
          A1(NSTATE,I) = 2.0D0*(MGAB(3)*A2(NSTATE,I)
     .                         +MGAB(4)*A2(I,NSTATE))
          A1(I,NSTATE-1) = 2.0D0*(MGAB(5)*A2(I,NSTATE-1)
     .                           +MGAB(6)*A2(NSTATE-1,I))
          A1(I,NSTATE) = 2.0D0*(MGAB(7)*A2(I,NSTATE)
     .                         +MGAB(8)*A2(NSTATE,I))
        ENDDO
        A1(NSTATE,NSTATE-1) = 2.0D0*(MGAB(9)*A2(NSTATE,NSTATE-1)
     .                              +MGAB(10)*A2(NSTATE-1,NSTATE))
        A1(NSTATE-1,NSTATE) = 2.0D0*(MGAB(11)*A2(NSTATE-1,NSTATE)
     .                              +MGAB(12)*A2(NSTATE,NSTATE-1))
        A1(NSTATE-1,NSTATE-1) = 2.0D0 * A2(NSTATE-1,NSTATE-1)
        A1(NSTATE,NSTATE) = 2.0D0 * A2(NSTATE,NSTATE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GSCAL(NSTATE,GAM,F)
      IMPLICIT NONE
      INTEGER NSTATE,J,I
      REAL*8 GAM(NSTATE,NSTATE),F(NSTATE)
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I,J)
      DO J=1,NSTATE
        DO I=1,NSTATE
          GAM(I,J)=F(I)*F(J)*GAM(I,J)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GSCAL_C(NSTATE,GAM,F)
      IMPLICIT NONE
      INTEGER NSTATE,J,I
      COMPLEX*16 GAM(NSTATE,NSTATE)
      REAL*8 F(NSTATE)
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I,J)
      DO J=1,NSTATE
        DO I=1,NSTATE
          GAM(I,J)=F(I)*F(J)*GAM(I,J)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_FORCES(LFORCES,TAG,NSTATE,LPROJ,TFOR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !CALSTE
      INCLUDE 'ropt.inc'        !CALSTE
      INCLUDE 'spin.inc'        !TLSE  
      INCLUDE 'fft.inc'         !MAXFFT
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'nlps.inc'        !IMAGP
C     Arguments
      INTEGER   LFORCES,NSTATE
      CHARACTER TAG*30
      LOGICAL TFOR, LPROJ
C     Variables
      INTEGER   IL_GAM,IL_AUXC,IL_DDIA,LSUMMAT,LRNLSM,LRSCPOT,LSYMVEC,
     *          IL_FSC,IL_SCR,IL_PSIAB,IL_SCRDIP,NSTX,IL_AMAT
C     ==--------------------------------------------------------------==
      LSUMMAT=0
      LSYMVEC=0
      LRNLSM=0
      LRSCPOT=0
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,TFOR)
      IF(TFOR) THEN
        CALL GIVE_SCR_SYMVEC(LSYMVEC,TAG)
      ENDIF
      CALL GIVE_SCR_RSCPOT(LRSCPOT,TAG,CALSTE)
      IL_AUXC=0
      IF(TIVAN .AND. LPROJ .AND. IPROJ.NE.0) THEN
        CALL GIVE_SCR_NLFORCE(IL_GAM,IL_AUXC,IL_DDIA,NSTATE)
        CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NSTATE)
      ELSE
        CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NSTATE)
        IF(TDMAL) THEN
          IL_GAM = 1 
          LSUMMAT=0
        ELSE
          IL_GAM = IMAGP*NSTATE*NSTATE
          CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NSTATE)
        ENDIF
      ENDIF
      IL_SCRDIP=0
      IF(TFIELD) CALL GIVE_SCR_OPEIGR(IL_SCRDIP,TAG,NSTATE)
      IF(TDMAL) THEN
        CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
        IL_AMAT=3*NSTATE*NSTX
      ELSE
        IL_AMAT=0
        IL_AUXC=MAX(IL_AUXC,2*LSUMMAT)
        IL_AUXC=MAX(IL_AUXC,NSTATE**2)  ! AUXC space for OVLAP (Laio A.)
      ENDIF
      IL_FSC=NSTATE
      IL_PSIAB=2
      IF(TLSE) IL_PSIAB=2*MAXFFT
      IL_SCR=IL_GAM+IL_AUXC+IL_DDIA+IL_FSC+IL_PSIAB+IL_SCRDIP+100
      IL_SCR=IL_SCR+IL_AMAT
      LFORCES = MAX(LRNLSM,LRSCPOT,LSYMVEC,IL_SCR)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
