C     ==================================================================
      SUBROUTINE FORCES_PROP(NSTATE,C0,CT,C2,CR,SC0,CSCR,VPP,EIGV,
     &                       RHOE,PSI,SCR,LSCR,
     &                       TAU0,VELP,TAUI,FION,IFCALC,
     &                       IREC,TFOR,TINFO)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'        !NLSD
      INCLUDE 'elct.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'        !CALSTE
      INCLUDE 'andr.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'store.inc'
CEHR
      INCLUDE 'td_input.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'efld.inc'
C
C     Arguments
      INTEGER    NSTATE,IFCALC,IREC(100),LSCR
CEHR
      COMPLEX*16 C0(NGWK,NSTATE,1),C2(NGWK,NSTATE),
     &           CT(NGWK,*),CR(*),
     &           SC0(*),CSCR(*),PSI(NNR1)
      REAL*8     EIGV(NSTATE,1),TAU0(3,NAX,NSX),VELP(*),TAUI(*),
     &           FION(*),VPP(*),
     &           RHOE(NNR1,NLSD),SCR(LSCR),THL(2)
      LOGICAL    TFOR,TINFO
C     Variables
      CHARACTER TAG*30
      REAL*8    TIME1,TIMEC,ETOT0,DETOT,TIME2,TCPU
      INTEGER   I,INFR,NHPSI,LFORCES_PROP,MSGLEN
CEHR  Ehrenfest
      DIMENSION  F(NSTATE,1),F_PROP(NSTATE,1),F_DIAG(NSTATE,1)
      REAL*8     XMIN(10),XMAX(10)
      LOGICAL    UPDATE_POT,CALCRHO
      COMPLEX*16 GDE(*),POP_AMPL1,POP_AMPL2,
     &           INTEGR1(10),INTEGR2(10)
      INTEGER    J,K,NNEL,FREQ_DIAG,ICALL
      POINTER    (IP_GDE,GDE)
C     Rotation in KS states after wf optimization
      INTEGER    IK,IKK,IB,NLEFT,IL_AUXC,IL_DDIA,IL_GAM,LSUMMAT
      REAL*8     BOTTOM,ENBAND,DDIA(NAX),EXTF(*)
      DIMENSION  WK(NKPTS)
      COMPLEX*16 AUXC(*)
      pointer    (IP_AUXC,AUXC),(IP_DDIA,DDIA)

      DATA ICALL/-1/
      SAVE ICALL
      CALCRHO=.TRUE.
      FREQ_DIAG=1
      IK=1
C     ==--------------------------------------------------------------==
      TIME1 = TIMEC()
      CALL GIVE_SCR_FORCES_PROP(LFORCES_PROP,TAG,NSTATE,TFOR)
      CALL GIVE_SCR_NLFORCE(IL_GAM,IL_AUXC,IL_DDIA,NSTATE)
      CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NSTATE)
      IL_AUXC=MAX(IL_AUXC,LSUMMAT)
      IL_AUXC=MAX(IL_AUXC,NSTATE**2)
      CALL MEMORY(IP_AUXC,2*IL_AUXC,'AUXC')
      CALL MEMORY(IP_DDIA,2*IL_DDIA,'DDIA')
      CALL TEST_SCR('FORCES_PROP',TAG,LSCR,LFORCES_PROP)
C     ==--------------------------------------------------------------==
      ECNSTR=0.0D0
      CONVWF=.FALSE.
      ETOT0=0.0D0
      IF(TDIAG.AND.TLANC) THEN
        CALL SET_B2L()
      ENDIF
      if (tmdeh) call memory(ip_gde,((NGWK*NSTATE+8)*MDIIS)/4,'GDE')
C     ==--------------------------------------------------------------==
      IF(.NOT.TINFO.AND.PARENT) THEN
         WRITE(6,'(T9,A)')
     &     'INFR         GEMAX            ETOT         DETOT     TCPU'
      ENDIF
      SDIIS=.TRUE.
      SPCG=.TRUE.
C     CO propagated wavefunctions
C     CT copy of CO used to performed wavefunction optimization
C
C     if (tmdeh) then
C       if (start_real.and.(icall.eq.-1)) then
C        do i=1,nstate
C         if (f_diag(i,1).eq.0.0D0)
C    &      call dcopy(2*ngwk,C0(1,i,1),1,CT(1,i),1)
C        enddo
C       endif
C     endif
C
C     represtinate external field
      IF (STEXTPOT) TEXTFLD=.TRUE.
C    ==================================================================
C    ==                     EHRENFEST DYNAMICS                       ==
C    ==================================================================
C
      IF (TMDEH) THEN
        CALL DCOPY(NSTATE,F_PROP(1,IK),1,F(1,IK),1)
        IF (INFI.GT.0) THEN
         IF (PARENT.AND.ICALL.LT.0) THEN
          WRITE(*,'(/,1X,A)') 'OCCUPATION FOR PROP'
          WRITE(*,'(13F5.1,/)') (F(I,IK),I=1,NSTATE)
         ENDIF
         CALL EHRENFEST(C0,C2,RHOE,PSI,SC0,EIGV,SCR,LSCR)
        ENDIF
        ICALL=ICALL+1
      ENDIF
C
C     ==================================================================
C     ==                      END OF MAIN  LOOP                       ==
C     ==================================================================
      IF (PARENT.AND.ICALL.EQ.0) THEN
        WRITE(*,'(/,1X,A)') 'OCCUPATION FOR FORCES COMPUTATION'
        WRITE(*,'(13F5.1,/)') (F(I,IK),I=1,NSTATE)
      ENDIF
C
      IF(GEQ0) CALL ZCLEAN_K(C0,NSTATE,NGW)
C
      IF(TFOR) THEN
        IF(TDIAG) THEN
C         Diagonalization
          CALL AZZERO(FION,3*NAX*NSX)
          CALL UPDRHO(C0,C2,CR,SC0,CSCR,VPP,TAU0,FION,EIGV,
     &                RHOE,PSI,SCR,LSCR,
     &                NSTATE,.TRUE.,TINFO,CALSTE,INFR,THL,NHPSI)
        ELSE
          IF (.NOT.TKPNT) THEN
           CALL UPDWF(C0,C2,SC0,TAU0,FION,CR,CSCR,VPP,EIGV,
     &               RHOE,PSI,SCR,LSCR,NSTATE,.TRUE.,.TRUE.)
          ELSEIF (TKPNT.AND.(.NOT.TMDEH)) THEN
            CALL K_UPDWF(C0,C2,SC0,TAU0,FION,CR,GDE,VPP,EIGV,
     &                   RHOE,PSI,SCR,LSCR,NSTATE,.TRUE.,update_pot)
          ELSE
            CALL UPDWF(C0,C2,SC0,TAU0,FION,CR,CSCR,VPP,EIGV,
     &               RHOE,PSI,SCR,LSCR,NSTATE,.TRUE.,.TRUE.)
          ENDIF
C         Forces from geometrical restraints
          IF(PARENT) THEN
           DO I=1,MRESTR
             RESVAL(I)=RESVAL(I)+GSRATE(I)*DT_IONS
             IF(RESVAL_DEST(I).NE.-999.D0) THEN
               IF(GSRATE(I).GT.0.D0.AND.RESVAL(I).GT.RESVAL_DEST(I))
     *           RESVAL(I)=RESVAL_DEST(I) ! increase
               IF(GSRATE(I).LT.0.D0.AND.RESVAL(I).LT.RESVAL_DEST(I))
     *           RESVAL(I)=RESVAL_DEST(I) ! decrease
             ENDIF
           ENDDO
           CALL RESTFC(TAU0,SCR,FION)
          ENDIF
          MSGLEN = 3*NAX*NSX * 8
          CALL MY_BCAST(FION,MSGLEN,SOURCE,ALLGRP)
        ENDIF
      ENDIF
 200  CONTINUE
      IF (TMDEH) CALL FREEM(IP_GDE)
      CALL FREEM(IP_AUXC)
      CALL FREEM(IP_DDIA)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_FORCES_PROP(LFORCES_PROP,TAG,NSTATE,TFOR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !TPRES
      INCLUDE 'kpts.inc'
C     Arguments
      INTEGER   LFORCES_PROP,NSTATE,LTSCR
      LOGICAL   TFOR
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LFORCES_PROP=1
      CALL GIVE_SCR_UPDWF(LFORCES_PROP,TAG,NSTATE,TFOR)
      IF (TFOR) THEN
        LTSCR=3*NAX*NSX
      ELSE
        LTSCR=0
      ENDIF
      LFORCES_PROP=MAX(LFORCES_PROP,LTSCR)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
