C     ==================================================================
      SUBROUTINE FORMFN(IS,DFINT,FINT)
C     ==--------------------------------------------------------------==
C     ==  COMPUTES THE FORM FACTORS OF PSEUDOPOTENTIAL (VPS)          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'atom.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
C     Arguments
      INTEGER   IS
      REAL*8    FINT(*),DFINT(MMAXX,*)
C     Variables
      DIMENSION VOO(NSPLPO,2,*),GGNH(*)
      REAL*8    CHECK,XG,XRG,FLX,R2,RCPF,GG
      INTEGER   IR,IL,ISUB,IERR,MEPE
      LOGICAL   ZER
C$    INTEGER   OMP_GET_THREAD_NUM
C$    EXTERNAL  OMP_GET_THREAD_NUM
#ifdef __DERF
      REAL*8    DERF
      EXTERNAL  DERF
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('    FORMFN',ISUB)
      CALL AZZERO(FINT,MMAXX)
      DO IR=1,MESHVP(IS)
        FINT(IR)=(RV(IR,IS)*RV(IR,IS)*RV(IR,IS)*VR(IR,IS,LLOC(IS))+
     *       ZV(IS)*DERF(RV(IR,IS)/RAGGIO(IS))*RV(IR,IS)*RV(IR,IS))
        ZER = DABS(RV(IR,IS)).LT.1.D-8
        IF(.NOT.ZER) THEN
          CHECK = VR(IR,IS,LLOC(IS))+ZV(IS)*
     *            DERF(RV(IR,IS)/RAGGIO(IS))/RV(IR,IS)
        ELSE
          CHECK = VR(IR,IS,LLOC(IS))+2.D0*
     *            ZV(IS)/(DSQRT(PI)*RAGGIO(IS))
        ENDIF
        IF(DABS(CHECK).LT.1.D-8) FINT(IR)=0.D0
      ENDDO
      CALL AZZERO(VOO(1,1,IS),NSPLPO)
      MEPE=1
C$OMP parallel do private(IL,XG,MEPE,IR,XRG,FLX)
      DO IL=NSPLPA,NSPLPE
C$      MEPE=OMP_GET_THREAD_NUM()+1
        XG=SQRT(GGNH(IL))*TPIBA
        IF(XG.GT.1.D-6) THEN
          DO IR=1,MESHVP(IS)
            XRG = RV(IR,IS)*XG
            DFINT (IR,MEPE) = FINT(IR)* SIN(XRG)/XRG
          ENDDO
        ELSE
          CALL DCOPY(MESHVP(IS),FINT(1),1,DFINT(1,MEPE),1)
        ENDIF
        CALL SIMPSN (MESHVP(IS), DFINT(1,MEPE), FLX)
        VOO(IL,1,IS) = CLOGVP(IS)*FPI* FLX
      ENDDO
      IF(PCONF) THEN
        R2=PRC(IS)**2
        RCPF=SQRT(PI**3)*PRC(IS)**3*PALPHA(IS)
C$OMP parallel do private(IL,GG)
        DO IL=NSPLPA,NSPLPE
          GG=GGNH(IL)*TPIBA2
          IF(GG.GT.1.D-8) THEN
            VOO(IL,1,IS)=VOO(IL,1,IS)-RCPF*SQRT(GG)*EXP(-0.25D0*GG*R2)
          ENDIF
        ENDDO
      ENDIF
      CALL GLOSUM(NSPLPO,VOO(1,1,IS))
      CALL CURV1(NSPLPO,GGNH,VOO(1,1,IS),0.0d0,0.0d0,3,
     *           VOO(1,2,IS),FINT,0.0d0,IERR)
      CALL TIHALT('    FORMFN',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FORMSG(IS,RS1,RS2)
C     ==--------------------------------------------------------------==
C     ==  COMPUTES THE FORM FACTORS OF PSEUDOPOTENTIAL (VPS)          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'atom.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'sgpp.inc'
C     Arguments
      INTEGER   IS
      REAL*8    RS1(*),RS2(*)
C     Variables
      DIMENSION VOO(NSPLPO,2,*),GGNH(*)
      REAL*8    RCRC,R2,GG,RCPF,GGL
      INTEGER   ISUB,IL,IC,IERR
C     ==--------------------------------------------------------------==
      CALL TISET('    FORMSG',ISUB)
      RCRC=RCSG(IS)*RCSG(IS)
      R2=RAGGIO(IS)**2
      CALL AZZERO(VOO(1,1,IS),NSPLPO)
C$OMP parallel do private(IL,GG)
      DO IL=NSPLPA,NSPLPE
        GG=GGNH(IL)*TPIBA2
        IF(GG.LT.1.D-8) THEN
          VOO(IL,1,IS) = PI*ZV(IS)*(2.D0*RCRC-R2)
        ELSE
          VOO(IL,1,IS) = -FPI*ZV(IS)/GG*
     *                  (EXP(-0.5D0*GG*RCRC)-EXP(-0.25D0*GG*R2))
        ENDIF
      ENDDO
      RCPF=SQRT((2.D0*PI)**3)*RCSG(IS)**3
C$OMP parallel do private(IL,GG)
      DO IL=NSPLPA,NSPLPE
        GG=GGNH(IL)*TPIBA2
        RS1(IL) = RCPF*EXP(-0.5D0*GG*RCRC)
      ENDDO
      DO IC=1,NCLSG(IS)
        IF(IC.EQ.1) THEN
C$OMP parallel do private(IL,GGL)
          DO IL=NSPLPA,NSPLPE
            GGL=GGNH(IL)
            VOO(IL,1,IS) = VOO(IL,1,IS)+CLSG(1,IS)*RS1(IL)
          ENDDO
        ELSEIF(IC.EQ.2) THEN
C$OMP parallel do private(IL,GG,GGL)
          DO IL=NSPLPA,NSPLPE
            GGL=GGNH(IL)
            GG=GGL*TPIBA2
            VOO(IL,1,IS) = VOO(IL,1,IS)+
     *         CLSG(2,IS)*(3.D0-RCRC*GG)*RS1(IL)
          ENDDO
        ELSEIF(IC.EQ.3) THEN
C$OMP parallel do private(IL,GG,GGL)
          DO IL=NSPLPA,NSPLPE
            GGL=GGNH(IL)
            GG=GGL*TPIBA2
            VOO(IL,1,IS) = VOO(IL,1,IS)+
     *         CLSG(3,IS)*(15.D0-10.D0*RCRC*GG+RCRC*RCRC*GG*GG)*RS1(IL)
          ENDDO
        ELSEIF(IC.EQ.4) THEN
C$OMP parallel do private(IL,GG,GGL)
          DO IL=NSPLPA,NSPLPE
            GGL=GGNH(IL)
            GG=GGL*TPIBA2
            VOO(IL,1,IS) = VOO(IL,1,IS)+
     *         CLSG(4,IS)*(105.D0-105.D0*RCRC*GG+21.D0*RCRC*RCRC*GG*GG-
     *              RCRC*RCRC*RCRC*GG*GG*GG)*RS1(IL)
          ENDDO
        ELSE
          CALL STOPGM('FORMSG','NCLSG TOO BIG')
        ENDIF
      ENDDO
      IF(PCONF) THEN
        R2=PRC(IS)**2
        RCPF=SQRT(PI**3)*PRC(IS)**3*PALPHA(IS)
C$OMP parallel do private(IL,GG)
        DO IL=NSPLPA,NSPLPE
          GG=GGNH(IL)*TPIBA2
          IF(GG.GT.1.D-8) THEN
            VOO(IL,1,IS)=VOO(IL,1,IS)-RCPF*SQRT(GG)*EXP(-0.25D0*GG*R2)
          ENDIF
        ENDDO
      ENDIF
      CALL GLOSUM(NSPLPO,VOO(1,1,IS))
      CALL CURV1(NSPLPO,GGNH,VOO(1,1,IS),0.0d0,0.0d0,3,
     *           VOO(1,2,IS),RS1,0.0d0,IERR)
      CALL TIHALT('    FORMSG',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FORMFV(IS,FX,VSCR)
C     ==--------------------------------------------------------------==
C     ==  COMPUTES THE FORM FACTORS OF PSEUDOPOTENTIAL (VPS)          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
C     Arguments
      INTEGER   IS
      REAL*8    FX(MMAXX,*),VSCR(*)
C     Variables
      DIMENSION VOO(NSPLPO,2,*),GGNH(*)
      REAL*8    EPS
      PARAMETER (EPS=1.D-5)
      REAL*8    TEST,FINT,FIGLX,XG,R2,RCPF,GG
      INTEGER   ISUB,IZ,IR,INTX,IL,IERR,MEPE
C$    INTEGER   OMP_GET_THREAD_NUM
C$    EXTERNAL  OMP_GET_THREAD_NUM
#ifdef __DERF
      REAL*8    DERF
      EXTERNAL  DERF
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('    FORMFV',ISUB)
      TEST=0.D0
      IZ=1
      FX(1,1)=0.D0
      VSCR(1)=0.D0
      DO IR=2,MESHVA(IS)
        TEST=0.5D0*RUCORE(IR,1,IS)+ZV(IS)*DERF(R(IR,IS)/RAGGIO(IS))
        IF (ABS(TEST).LT.EPS) THEN
          VSCR(IR)=0.D0
        ELSE
          VSCR(IR)=TEST
          IZ=IR
        ENDIF
C       VSCR =   SCREENED PSEUDOPOTENTIAL
        FX(IR,1)=VSCR(IR)*R(IR,IS)
      ENDDO
      INTX=MIN0(40*(IZ/40+1)+1,MESHVA(IS))
      IF( TLOG(IS) ) THEN
        CALL RADLG(INTX,FX(1,1),RAB(1,IS),FINT)
      ELSE
        CALL RADIN(INTX,CMESH(IS),FX(1,1),FINT)
      ENDIF
      CALL AZZERO(VOO(1,1,IS),NSPLPO)
      MEPE=1
C$OMP parallel do private(IL,XG,IR,MEPE,FIGLX) shared(INTX)
      DO IL=NSPLPA,NSPLPE
C$      MEPE=OMP_GET_THREAD_NUM()+1
        XG=SQRT(GGNH(IL))*TPIBA
        IF(XG.GT.1.D-6) THEN
          DO IR=1,INTX
            FX(IR,MEPE)=VSCR(IR)*SIN(R(IR,IS)*XG)
          ENDDO
          IF( TLOG(IS) ) THEN
            CALL RADLG(INTX,FX(1,MEPE),RAB(1,IS),FIGLX)
          ELSE
            CALL RADIN(INTX,CMESH(IS),FX(1,MEPE),FIGLX)
          ENDIF
          VOO(IL,1,IS)=FPI*FIGLX/XG
        ELSE
          VOO(IL,1,IS)=FPI*FINT
        ENDIF
      ENDDO
      IF(PCONF) THEN
        R2=PRC(IS)**2
        RCPF=SQRT(PI**3)*PRC(IS)**3*PALPHA(IS)
C$OMP parallel do private(IL,GG)
        DO IL=NSPLPA,NSPLPE
          GG=GGNH(IL)*TPIBA2
          IF(GG.GT.1.D-8) THEN
            VOO(IL,1,IS)=VOO(IL,1,IS)-RCPF*SQRT(GG)*EXP(-0.25D0*GG*R2)
          ENDIF
        ENDDO
      ENDIF
      CALL GLOSUM(NSPLPO,VOO(1,1,IS))
      CALL CURV1(NSPLPO,GGNH,VOO(1,1,IS),0.0d0,0.0d0,3,
     *           VOO(1,2,IS),FX,0.0d0,IERR)
      CALL TIHALT('    FORMFV',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FORMUP(IS,DFINT,FINT)
C     ==--------------------------------------------------------------==
C     ==  COMPUTES THE FORM FACTORS OF PSEUDOPOTENTIAL (VPS)          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'atom.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
C     Arguments
      INTEGER   IS
      REAL*8    FINT(*),DFINT(MMAXX,*)
C     Variables
      DIMENSION VOO(NSPLPO,2,*),GGNH(*)
      REAL*8    XG,XRG,FLX,R2,RCPF,GG
      INTEGER   IR,IL,ISUB,IERR,MEPE
C$    INTEGER   OMP_GET_THREAD_NUM
C$    EXTERNAL  OMP_GET_THREAD_NUM
#ifdef __DERF
      REAL*8    DERF
      EXTERNAL  DERF
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('    FORMUP',ISUB)
      CALL AZZERO(FINT,MMAXX)
      DO IR=1,MESHVP(IS)
        FINT(IR)=RV(IR,IS)*RV(IR,IS)*VR(IR,IS,1)+
     *       ZV(IS)*DERF(RV(IR,IS)/RAGGIO(IS))*RV(IR,IS)
      ENDDO
      CALL AZZERO(VOO(1,1,IS),NSPLPO)
      MEPE=1
C$OMP parallel do private(IL,XG,MEPE,IR,XRG,FLX)
      DO IL=NSPLPA,NSPLPE
C$      MEPE=OMP_GET_THREAD_NUM()+1
        XG=SQRT(GGNH(IL))*TPIBA
        IF(XG.GT.1.D-6) THEN
          DO IR=1,MESHVP(IS)
            XRG = RV(IR,IS)*XG
            DFINT (IR,MEPE) = FINT(IR) * SIN(XRG)/XRG * RW(IR,IS)
          ENDDO
        ELSE
          DO IR=1,MESHVP(IS)
            DFINT (IR,MEPE) = FINT(IR) * RW(IR,IS)
          ENDDO
        ENDIF
        CALL SIMPSN (MESHVP(IS), DFINT(1,MEPE), FLX)
        VOO(IL,1,IS) = FPI* FLX
      ENDDO
      IF(PCONF) THEN
        R2=PRC(IS)**2
        RCPF=SQRT(PI**3)*PRC(IS)**3*PALPHA(IS)
C$OMP parallel do private(IL,GG)
        DO IL=NSPLPA,NSPLPE
          GG=GGNH(IL)*TPIBA2
          IF(GG.GT.1.D-8) THEN
            VOO(IL,1,IS)=VOO(IL,1,IS)-RCPF*SQRT(GG)*EXP(-0.25D0*GG*R2)
          ENDIF
        ENDDO
      ENDIF
      CALL GLOSUM(NSPLPO,VOO(1,1,IS))
      CALL CURV1(NSPLPO,GGNH,VOO(1,1,IS),0.0d0,0.0d0,3,
     *           VOO(1,2,IS),FINT,0.0d0,IERR)
      CALL TIHALT('    FORMUP',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
