#ifdef __SR8000
*OPTION OPT(O(3))
#endif
C     ==================================================================
      SUBROUTINE FREEM(IP_POINT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      REAL*8  POINTDUMMY
      POINTER (IP_POINT,POINTDUMMY)
#ifdef POINTER8
      INTEGER*8 I_AD1,I_AD2
#else
      INTEGER  I_AD1,I_AD2
#endif
      INCLUDE 'system.h'
      INCLUDE 'memc.inc'
      LOGICAL ERROR
      REAL*8  XM(0:*)
      POINTER (IP_XM,XM)
#ifdef CRAY
      INTEGER IERR
#endif
      INTEGER I,II,LENGTH
C     ==--------------------------------------------------------------==
C     ==  FREE MEMORY ASSOCIATED WITH POINTER IP_POINT                ==
C     ==--------------------------------------------------------------==
#if defined(CRAY64) || defined(__NEC)
C..For CRAY-X1 the code has to be compiled with -sword_pointer
      IP_XM=IP_POINT-1
#elif defined(CRAY32)
C..For CRAY-X1 the code has to be compiled with -sword_pointer
      IP_XM=IP_POINT-2
#else
      IP_XM=IP_POINT-16
#endif
C..Statistics and memory checks
      II=0
      DO I=1,I_BLOCK
        IF(IP_XM.EQ.I_AD1(I)) THEN
          II=I
          GOTO 100
        ENDIF
      ENDDO
      WRITE(6,*) ' FREEM | COULD NOT FIND POINTER ',IP_XM
      CALL PRINT_MEMORY
      CALL STOPGM('FREEM',' NO SUCH POINTER')
  100 CONTINUE
      LENGTH=I_LEN(II)
      ERROR=ZFIRST.NE.XM(0).OR.ZLAST.NE.XM(LENGTH+3)
      IF(ERROR) THEN
        CALL MEMORY_CHECK
      ENDIF
C..Debugging
      IF(MEMCHK) THEN
        CALL MEMORY_CHECK
      ENDIF
      IF(MEMDEB) THEN
        WRITE(6,'(A,I4,A,A10,A,I10,A,I16)')
     &       ' DEBUGMEM! DEALLOC[',I_BLOCK,']: ',I_TAG(II),
     &       ' LEN=',LENGTH,
     &       ' ADDR=',I_AD1(II)
      ENDIF
      DO I=II,I_BLOCK-1
        I_AD1(I)=I_AD1(I+1)
        I_AD2(I)=I_AD2(I+1)
        I_LEN(I)=I_LEN(I+1)
        I_TAG(I)=I_TAG(I+1)
      ENDDO
      I_BLOCK=I_BLOCK-1
      RMEMTOT=RMEMTOT-DBLE(LENGTH)
c..free memory
#ifdef CRAYX1
      CALL FREE(IP_XM) 
#elif CRAY
      CALL HPDEALLC(IP_XM,IERR,0)
      IF(IERR.NE.0) THEN
        WRITE(6,*) ' FREEM | ERROR IN DEALLOCATION OF MEMORY '
        CALL STOPGM('FREEM',' ')
      ENDIF
#elif defined(__IBM) || defined(__OSX) || defined(__SR2201) || defined(__SR8000)
      CALL FREE(%VAL(IP_XM))
#elif defined(__NEC)
      CALL FREEW(IP_XM)
#else
      CALL FREE(IP_XM)
#endif
      IP_XM=0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MEMORY_CHECK
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
#ifdef POINTER8
      INTEGER*8 I_AD1,I_AD2
#else
      INTEGER   I_AD1,I_AD2
#endif
      INCLUDE 'system.h'
      INCLUDE 'memc.inc'
      INCLUDE 'irat.inc'
      LOGICAL ERROR
      REAL*8  X1(*),X2(*)
      POINTER (IP_X1,X1),(IP_X2,X2)
      INTEGER I
C     ==--------------------------------------------------------------==
C     ==  CHECK BORDERS OF ALLOCATED BLOCKS OF MEMORY                 ==
C     ==  Each process is checking its own boundaries.. please do not ==
C     ==  insert any MPI statement in this function!                  ==
C     ==--------------------------------------------------------------==
      ERROR=.FALSE.
      DO I=1,I_BLOCK
        IP_X1=I_AD1(I)
        IP_X2=I_AD2(I)
        IF(ZFIRST.NE.X1(1).OR.ZLAST.NE.X2(1)) THEN
          ERROR=.TRUE.
        ENDIF
      ENDDO
      IF(.NOT.ERROR) THEN
        IF(PARENT.AND.MEMCHK) THEN
          WRITE(6,'(A)') ' MEMORY_CHECK| ALL ARRAY BOUNDARIES ARE OK '
        ENDIF
      ELSE
        CALL PRINT_MEMORY
        CALL STOPGM('MEMORY_CHECK',' CORRUPTED MEMORY')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PRINT_MEMORY
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
#ifdef POINTER8
      INTEGER*8 I_AD1,I_AD2
#else
      INTEGER   I_AD1,I_AD2
#endif
      INCLUDE 'system.h'
      INCLUDE 'memc.inc'
#ifdef POINTER8
      INTEGER*8 I_SORT(MEM_LEN)
#else
      INTEGER   I_SORT(MEM_LEN)
#endif      
      INTEGER   INDEX(MEM_LEN), I,II,IC1,IC2,IN
      REAL*8    X1(*),X2(*)
      POINTER   (IP_X1,X1),(IP_X2,X2)
      CHARACTER TTT(2)*9
#ifdef PARALLEL
      INTEGER   IFORM
      CHARACTER FORMFREEM*100
#endif
      DATA TTT /'OK       ','CORRUPTED'/
C     ==--------------------------------------------------------------==
#ifdef POINTER8
      CALL I8COPY(I_BLOCK,I_AD1,1,I_SORT,1)
      CALL SORT2I8(I_SORT,I_BLOCK,INDEX)
#else
      CALL ICOPY(I_BLOCK,I_AD1,1,I_SORT,1)
      CALL SORT2I(I_SORT,I_BLOCK,INDEX)
#endif
      CALL MY_FLUSH(6)
      DO IN=0,NPROC-1
        CALL MY_SYNC(ALLGRP)
        IF(IN.NE.ME) GOTO 99
#ifdef PARALLEL
        IFORM=INT(LOG10(DBLE(NPROC)))+1
        WRITE(FORMFREEM,'(A,I1,A,I1,A,I2,A)')
     &      '(//,1X,"==",I',IFORM,',":",I',IFORM,',',63-2*IFORM,'("="))'
        WRITE(6,FORMFREEM) ME,NPROC
#else
        WRITE(6,'(//,1x,66("="))')
#endif
        WRITE(6,'(A,A)') ' NAME       FIRST ADDRESS     ',
     &      '     LAST ADDRESS              LENGTH  '
        DO I=1,I_BLOCK
          II=INDEX(I)
          IP_X1=I_AD1(II)
          IP_X2=I_AD2(II)
          IF(ZFIRST.NE.X1(1)) THEN
            IC1=2
          ELSE
            IC1=1
          ENDIF
          IF(ZLAST.NE.X2(1)) THEN
            IC2=2
          ELSE
            IC2=1
          ENDIF
          WRITE(6,'(1X,A10,I12,1X,A9,I12,1X,A9,I12)') 
     *        I_TAG(II),I_AD1(II),TTT(IC1),I_AD2(II),TTT(IC2),I_LEN(II)
        ENDDO
        WRITE(6,'(1x,66("-"))')
        WRITE(6,'(1X,A12,I5,A1,6X,A12,3X,I11,A2,F7.1,A7)')
     &      '[PEAK NUMBER',NUMPEAK,']',
     &      'PEAK MEMORY',INT(RMEMPEAK),' =',RMEMPEAK*8.D-6,' MBytes'
        WRITE(6,'(1X,A12,I5,A1,6X,A12,3X,I11,A2,F7.1,A7)')
     &      '[ALL. NUMBER',I_BLOCK,']',
     &      'TOTAL MEMORY',INT(RMEMTOT),' =',RMEMTOT*8.D-6,' MBytes'
        WRITE(6,'(1x,66("="))')
        CALL MY_FLUSH(6)
 99     CONTINUE
      END DO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PMAXMEM
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
#ifdef POINTER8
      INTEGER*8 I_AD1,I_AD2
#else
      INTEGER   I_AD1,I_AD2
#endif
      INCLUDE 'system.h'
      INCLUDE 'memc.inc'
#ifdef POINTER8 
      INTEGER*8 I_SORT(MBM)
#else 
      INTEGER   I_SORT(MBM)
#endif 
      INTEGER   INDEX(MBM), I,I1,I2
C     ==--------------------------------------------------------------==
C     Debugging
      IF(MEMCHK.OR.MEMDEB) THEN
        CALL PRINT_MEMORY
      ENDIF
#ifdef POINTER8
      CALL I8COPY(MBM,I_LENB,1,I_SORT,1)
      CALL SORT2I8(I_SORT,MBM,INDEX)
#else
      CALL ICOPY(MBM,I_LENB,1,I_SORT,1)
      CALL SORT2I(I_SORT,MBM,INDEX)
#endif
      WRITE(6,'(/,1x,64("="))')
      WRITE(6,'(20X,A)') '  BIG MEMORY ALLOCATIONS '
      DO I=MBM,1,-2
        I1=INDEX(I)
        I2=INDEX(I-1)
        WRITE(6,'(1X,A10,4X,I10,16X,A10,4X,I10)') IB_TAG(I1),I_LENB(I1),
     *          IB_TAG(I2),I_LENB(I2)
      ENDDO
      WRITE(6,'(1x,64("-"))')
      WRITE(6,'(1X,A12,I5,A1,6X,A11,2X,I11,A2,F7.1,A7)')
     &     '[PEAK NUMBER',NUMPEAK,']',
     &     'PEAK MEMORY',INT(RMEMPEAK),' =',RMEMPEAK*8.D-6,' MBytes'
      WRITE(6,'(1x,64("="))')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE MEMORY_INFO(TAG,LENGTH)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
#ifdef POINTER8
      INTEGER*8 I_AD1,I_AD2
#else
      INTEGER   I_AD1,I_AD2
#endif
      INCLUDE 'system.h'
      INCLUDE 'memc.inc'
      CHARACTER TAG*(*)
      INTEGER I,LENGTH
C     ==--------------------------------------------------------------==
C     ==  SEARCH FOR MEMORY BLOCK WITH A MATCHING TAG                 ==
C     ==--------------------------------------------------------------==
      LENGTH=-1
      DO I=1,I_BLOCK
        IF(TAG.EQ.I_TAG(I)) THEN
          LENGTH=I_LEN(I)
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
