C     ==================================================================
      SUBROUTINE FREQS (NSTATE,TFULLH)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'harm.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'simul.inc'
C     Arguments
      INTEGER   NSTATE
      LOGICAL   TFULLH
C     Variables
      DIMENSION TWNL(NGW,NHXS,*),F(NSTATE)
      REAL*8    HAMD(*)
      POINTER   (IP_HAMD,HAMD)
      REAL*8    AR1(3),AR2(3),AR3(3),BR1(3),BR2(3),BR3(3),
     &          DD,GKR1,GKR2,GKR3,HGR
      INTEGER   IRI1,IG,NH1,NH2,NH3,IR,IV,LJ,KJ,L2,JV,LI,L,IA,ISA0,IS,
     &          KI,IRI2,IRI3
#ifdef PARALLEL
      INTEGER   MSGLEN
#endif
C     ==--------------------------------------------------------------==
C     ==  Calculate frequencies for harmonic reference system         ==
C     ==  Calculate scaled electron masses                            ==
C     ==--------------------------------------------------------------==
      IF(.NOT.(THARM.OR.TMASS)) RETURN
C     ==--------------------------------------------------------------==
      IF(THARM) THEN
        CALL MEMORY(IP_FREQ,NGW,'FREQ')
        CALL MEMORY(IP_DCGT,NGW,'DCGT')
        CALL MEMORY(IP_DSGTW,NGW,'DSGTW')
        CALL MEMORY(IP_WDSGT,NGW,'WDSGT')
        CALL MEMORY(IP_DTAN2W,NGW,'DTAN2W')
      ENDIF
      IF(TMASS) THEN
        CALL MEMORY(IP_XMU,NGW,'XMU')
      ENDIF
#ifdef PARALLEL
      MSGLEN = 1 * 8
      CALL MY_BCAST(VPLOC,MSGLEN,IGEQ0,ALLGRP)
#endif
      CALL MEMORY(IP_HAMD,NGW,'HAMD')
      NGHARM=0
      IF(TFULLH) THEN
        DO IG=1,NGW
          HAMD(IG) = 0.5D0*TPIBA2*HG(IG)+VPLOC
          ISA0=0
          DO IS=1,NSP
            IF(TVAN(IS)) THEN
              DO IV=1,NGH(IS)
                DO JV=1,NGH(IS)
                  DD=DVAN(IV,JV,IS)
                  DO IA=1,NA(IS)
                    DD=DD+DEEQ(ISA0+IA,IV,JV,1)
                  ENDDO
                  IF(TLSD) THEN
                    DO IA=1,NA(IS)
                      DD=DD+DEEQ(ISA0+IA,IV,JV,2)
                    ENDDO
                    DD=0.5D0*DD
                  ENDIF
                  HAMD(IG)=HAMD(IG)+
     *                         DD*TWNL(IG,IV,IS)*TWNL(IG,JV,IS)
                ENDDO
              ENDDO
            ELSEIF(TSGP(IS)) THEN
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L.EQ.L2.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    DD=HLSG(KI,KJ,L,IS)*NA(IS)
                    HAMD(IG)=HAMD(IG)+DD*TWNL(IG,IV,IS)*TWNL(IG,JV,IS)
                  ENDIF
                ENDDO
              ENDDO
            ELSE
              DO IV=1,NGH(IS)
                HAMD(IG)=HAMD(IG)+NA(IS)*WSG(IS,IV)
     *                      *TWNL(IG,IV,IS)*TWNL(IG,IV,IS)
              ENDDO
            ENDIF
            ISA0=ISA0+NA(IS)
          ENDDO
          IF(HAMD(IG).LT.HTHRS) NGHARM=NGHARM+1
        ENDDO
      ELSE
        DO IR=1,3
          AR1(IR) = HT0(1,IR)
          AR2(IR) = HT0(2,IR)
          AR3(IR) = HT0(3,IR)
        ENDDO
        CALL RECIPS(ALAT,AR1,AR2,AR3,BR1,BR2,BR3)
        NH1=NR1S/2+1
        NH2=NR2S/2+1
        NH3=NR3S/2+1
        DO IG=1,NGW
          IRI1=INYH(1,IG)-NH1
          IRI2=INYH(2,IG)-NH2
          IRI3=INYH(3,IG)-NH3
          GKR1=IRI1*BR1(1)+IRI2*BR2(1)+IRI3*BR3(1)
          GKR2=IRI1*BR1(2)+IRI2*BR2(2)+IRI3*BR3(2)
          GKR3=IRI1*BR1(3)+IRI2*BR2(3)+IRI3*BR3(3)
          HGR=GKR1**2+GKR2**2+GKR3**2
          HAMD(IG) = 0.5D0*TPIBA2*HGR
          IF(HAMD(IG).LT.HTHRS) NGHARM=NGHARM+1
        ENDDO
      ENDIF
      DO IG=1,NGHARM
        HAMD(IG)=HTHRS
      ENDDO
      IF(TMASS) THEN
        DO IG=1,NGW
          XMU(IG)=HAMD(IG)*EMASS/HTHRS
        ENDDO
        IF(PARENT) THEN
          WRITE(6,'(A)') ' FREQS| SHELL DEPENDENT ELECTRON MASSES '
          WRITE(6,'(A,F12.3)') ' FREQS| SHELL    1  ELECTRON MASS  ',
     *                           XMU(1)
          WRITE(6,'(A,I5,A,F12.3)') ' FREQS| SHELL',NGW,
     *                              '  ELECTRON MASS  ',XMU(NGW)
        ENDIF
      ENDIF
      IF(THARM) THEN
        DO IG=1,NGHARM
          FREQ(IG)    = 0.0D0
          DCGT(IG)    = 1.0D0
          DSGTW(IG)   = DELT_ELEC
          WDSGT(IG)   = 0.0D0
          DTAN2W(IG)  = DTB2ME
        ENDDO
        IF(TMASS) THEN
          DO IG=NGHARM+1,NGW
            FREQ(IG) = DSQRT(F(1)*HAMD(IG)/XMU(IG))
          ENDDO
          DO IG=NGHARM+1,NGW
            DCGT(IG)   = DCOS(FREQ(IG)*DELT_ELEC)
            DSGTW(IG)  = DSIN(FREQ(IG)*DELT_ELEC)/FREQ(IG)
            WDSGT(IG)  = DSIN(FREQ(IG)*DELT_ELEC)*FREQ(IG)
            DTAN2W(IG) = DTAN(0.5D0*FREQ(IG)*DELT_ELEC)/
     *                            (FREQ(IG)*XMU(IG))
          ENDDO
        ELSE
          DO IG=NGHARM+1,NGW
            FREQ(IG) = DSQRT(F(1)*HAMD(IG)/EMASS)
          ENDDO
          DO IG=NGHARM+1,NGW
            DCGT(IG)   = DCOS(FREQ(IG)*DELT_ELEC)
            DSGTW(IG)  = DSIN(FREQ(IG)*DELT_ELEC)/FREQ(IG)
            WDSGT(IG)  = DSIN(FREQ(IG)*DELT_ELEC)*FREQ(IG)
            DTAN2W(IG) = DTAN(0.5D0*FREQ(IG)*DELT_ELEC)/
     *                        (FREQ(IG)*EMASS)
          ENDDO
        ENDIF
      ENDIF
      IF(PARENT)
     *  WRITE(6,'(A,I5)') ' FREQS| SIZE OF HARMONIC REFERENCE SYSTEM:',
     *                     NGW-NGHARM
      CALL FREEM(IP_HAMD)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
