C     ==================================================================
      SUBROUTINE FRIE_C_p(NDIAG,NEL,NCONV,NHPSI,C0,CS,SC0,CSCR,
     &                    VPOT,PSI,EDAV,SCR,LSCR,
     &                    JSPIN,IKIND,IKK,TREFINE,TINFO)
C     ==--------------------------------------------------------------==
C     ==  Kohn-Sham Matrix Diagonalization by Krylov-Space Method     ==
C     ==  W.T. Pollard and R.A. Friesner                              ==
C     ==  J. Chem. Phys. 99, 6742 (1993)                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'irat.inc'
C     Arguments
      INTEGER    NDIAG,NCONV,NHPSI,LSCR,
     &           JSPIN,IKIND,IKK
      COMPLEX*16 C0(NGWK,NDIAG),CS(NGWK,NDIAG),SC0(NGWK,*),
     &           CSCR(NGWK,*),PSI(NNR1)
      REAL*8     VPOT(NNR1),EDAV(NDIAG),SCR(LSCR),NEL
      LOGICAL    TREFINE,TINFO
C     Variables
      INTEGER    ISPIN
      PARAMETER  (ISPIN=1)
      COMPLEX*16 ZZERO,ZONE
      PARAMETER  (ZZERO=(0.D0,0.D0),ZONE=(1.D0,0.D0))
      INTEGER    INDEX(NDIAG)
      COMPLEX*16 ADAV(NDIAG,NDIAG)
      POINTER    (IP_INDEX,INDEX),(IP_ADAV,ADAV)
      REAL*8     ALPHA0(NDIAG),BETA1(NDIAG),AUX
      POINTER    (IP_ALPHA0,ALPHA0),(IP_BETA1,BETA1)
      INTEGER    ISUB,NGWK2,IFORMLANC,IERR,I,J,
     &           NCURR,LFRIESNER,IAUX,LWORK,LSCR2,ISTATE
      LOGICAL    TLSD2
      CHARACTER  TAG*30,CHARSPIN*20,FORMLANC*100
C     ==--------------------------------------------------------------==
C     With LSD and 1 electron...
      IF(NDIAG.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('FRIE_C_mia',ISUB)
      CALL GIVE_SCR_FRIESNER(LFRIESNER,TAG,NDIAG)
      CALL TEST_SCR('FRIESNER_C',TAG,LSCR,LFRIESNER)
C     Allocation of SCR
      LSCR2=LSCR-(NDIAG/IRAT+1)
      CALL GET_ADDR(IP_INDEX,SCR(LSCR2+1))
      LSCR2=LSCR2-2*NDIAG*NDIAG
      CALL GET_ADDR(IP_ADAV,SCR(LSCR2+1))
      LSCR2=LSCR2-NDIAG
      CALL GET_ADDR(IP_ALPHA0,SCR(LSCR2+1))
      LSCR2=LSCR2-NDIAG
      CALL GET_ADDR(IP_BETA1,SCR(LSCR2+1))
C     ==--------------------------------------------------------------==
      TLSD2=TLSD
      TLSD=.FALSE.
      NGWK2=2*NGWK
      NCONV=0
      LWORK=(LSCR2-3*NDIAG)/2
      CALL IAZZERO(INDEX,NDIAG)
C     ==--------------------------------------------------------------==
      IF(PARENT.AND.TINFO) THEN
        IF(JSPIN.EQ.0) THEN
          CHARSPIN='<<<<<<<<<<<<<<<<<<<<'
        ELSEIF(JSPIN.EQ.1) THEN
          CHARSPIN='<<<<<<< ALPHA SPIN<<'
        ELSEIF(JSPIN.EQ.2) THEN
          CHARSPIN='<<<<<<<< BETA SPIN<<'
        ENDIF
        IFORMLANC=INT(LOG10(DBLE(NKPTS)))+1
        WRITE(FORMLANC,'(A,I1,A,I1,A,I2,A)')
     &       '(/,1X,"<<",I',IFORMLANC,',":",I',IFORMLANC,",",
     &       16-2*IFORMLANC,'("<")," LANCZOS DIAGONALIZATION ",A20)'
        WRITE(6,FORMLANC) IKK,NKPTS,CHARSPIN
      ENDIF
C     ==--------------------------------------------------------------==
C     Subspace Matrix
      IF(TTROT) THEN
        CALL EHPSI_C(C0,CS,VPOT,PSI,NDIAG,IKIND)
      ELSE
        CALL HPSI(C0,CS,SC0,VPOT,PSI,SCR,LSCR2,NDIAG,IKIND,ISPIN)
      ENDIF
      NHPSI=NDIAG
      CALL OVLAP_H(NDIAG,ADAV,C0,CS)
#ifdef PARALLEL
      CALL SUMHMAT(ADAV,NDIAG,SCR,LSCR2)
#endif

C     ==----------------------------------------------------------------==
C     ==                 TEST  HAMILTONIAN                              ==
C
      IF(parent) then
        write(6,'("HAMILTONIAN LEFT :"/)')
        J = 1
        DO ISTATE = 1,NDIAG
           write(6,'("HAM ",I5,I5,5(f11.6,f11.6))') 
     &          ISTATE,J,ADAV(ISTATE,J),ADAV(ISTATE,J+1),
     &          ADAV(ISTATE,J+2),ADAV(ISTATE,J+3),
     &          ADAV(ISTATE,J+4)
        ENDDO
        write(6,'(/"HAMILTONIAN RIGHT :"/)')
        J = NDIAG/2+1
        DO ISTATE = 1,NDIAG
          write(6,'("HAM ",I5,I5,5(f11.6,f11.6))') 
     &         ISTATE,J,ADAV(ISTATE,J),ADAV(ISTATE,J+1),
     &         ADAV(ISTATE,J+2),ADAV(ISTATE,J+3),
     &         ADAV(ISTATE,J+4)
        ENDDO

      ENDIF




      CALL ZHEEV('V','U',NDIAG,ADAV,NDIAG,EDAV,
     &          SCR(3*NDIAG-1),LWORK,SCR(1),IERR)
      IF(LWORK.LT.INT(SCR(1))) THEN 
        WRITE(6,*) ' WARNING| LWORK SUBOPTIMAL FOR ZHEEV'
        WRITE(6,*) '   LWORK:',LWORK
        WRITE(6,*) ' OPTIMAL:',INT(SCR(1))
      ENDIF
      CALL REORDER_C(NDIAG,NDIAG,EDAV,ADAV)
C     Rotate Orbitals
      CALL ZGEMM('N','N',NGWK,NDIAG,NDIAG,ZONE,C0(1,1),NGWK,
     *       ADAV(1,1),NDIAG,ZZERO,CSCR(1,1),NGWK)
      CALL DCOPY(NGWK2*NDIAG,CSCR(1,1),1,C0(1,1),1)
      NCURR = 1
      CALL GS_ORTHO_C(C0,NCURR-1,C0(1,NCURR),NDIAG-NCURR+1,ADAV,SCR)

C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
C     Order Roots with respect to energy
      CALL SORT2(EDAV,NDIAG,INDEX)
      CALL DCOPY(NGWK2*NDIAG,C0(1,1),1,CS(1,1),1)
      IF(.NOT.TTROT) CALL DSCAL(NDIAG,-1.D0,EDAV(1),1)
      DO I = 1 , NDIAG/2 
         AUX = EDAV(NDIAG-I+1)
         EDAV(NDIAG-I+1) = EDAV(I)
         EDAV(I) = AUX
         IAUX = INDEX(NDIAG-I+1)
         INDEX(NDIAG-I+1) = INDEX(I)
         INDEX(I) = IAUX
      ENDDO   
      DO I=1,NDIAG
        J=INDEX(I)
        CALL DCOPY(NGWK2,CS(1,J),1,C0(1,I),1)
      ENDDO
      TLSD=TLSD2
      CALL TIHALT('FRIE_C_mia',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

