C     ==================================================================
      SUBROUTINE FRSBLK(NDIAG,NEL,NCONV,NHPSI,C0,CS,SC0,CSCR,VPOT,PSI,
     *                  EDAV,SCR,LSCR,JSPIN,TREFINE,TINFO)
C     ==--------------------------------------------------------------==
C     ==  Kohn-Sham Matrix Diagonalization by Block Krylov-Space      == 
C     ==  Method                                                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'irat.inc' 
C     Arguments
      INTEGER    NDIAG,NCONV,NHPSI,LSCR,JSPIN
      COMPLEX*16 C0(NGW,*),CS(NGW,*),
     &           SC0(NGW,*),CSCR(NGW,*),PSI(*)
      REAL*8     VPOT(*),EDAV(*),SCR(*),NEL
      LOGICAL    TREFINE,TINFO
C     Variables
      REAL*8     EPS,EDAVMAX,EDAVMIN
      PARAMETER  (EPS=1.D-14,EDAVMAX=300D0,EDAVMIN=-300D0)
      INTEGER    ISPIN
      PARAMETER  (ISPIN=1)
      INTEGER    ISCR(6*NKRY_BLOCK*NKRY_MAX),INDEX(NDIAG)
      POINTER    (IP_ISCR,ISCR),(IP_INDEX,INDEX)
      REAL*8     TMAT(3*NKRY_BLOCK*NKRY_MAX*NKRY_BLOCK*NKRY_MAX),
     &           BETA(NKRY_BLOCK*NKRY_BLOCK*NKRY_MAX),
     &           ALPHA(NKRY_BLOCK*NKRY_BLOCK*(NKRY_MAX+1)),
     &           WT(NKRY_BLOCK*NKRY_MAX),ADAV(NDIAG,NDIAG)
      POINTER    (IP_TMAT,TMAT),(IP_ALPHA,ALPHA),(IP_BETA,BETA),
     &           (IP_WT,WT),(IP_ADAV,ADAV)
      REAL*8     TIM1,TIM2,TIM,TROTMIN,TROTMAX,B2MIN,B2MAX,
     &           B2,AUX,AMU
      REAL*8     DOTP,TIMEF
      EXTERNAL   DOTP,TIMEF
      INTEGER    ISUB,NGW2,NCONVOLD,NHPSIOLD,NTEST,I,J,
     &           LFRSBLK,NK,NBLEFF,NBLK,LISCR,
     &           IERR,ITEST,ICYCLE,NCURR,IG,NLEFT,LSCR2,LSCR3
      LOGICAL    TLSD2,TCONV,TCHECK,TTEST
      CHARACTER  TAG*30,CHARSPIN*20
C     ==--------------------------------------------------------------==
C     With LSD and 1 electron...
      IF(NDIAG.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('    FRSBLK',ISUB)
C     Test SCR
      CALL GIVE_SCR_FRSBLK(LFRSBLK,TAG,NDIAG)
      CALL TEST_SCR('  FRSBLK',TAG,LSCR,LFRSBLK)
      NK=NKRY_BLOCK*NKRY_MAX
      LISCR=6*NK
#ifdef _BGL 
      CALL GET_ADDR(IP_ADAV,SCR(1))
      LSCR2=1+NDIAG*NDIAG+MOD(NDIAG*NDIAG,2)
      CALL GET_ADDR(IP_BETA,SCR(LSCR2))
      LSCR2=LSCR2+(NKRY_BLOCK*NKRY_BLOCK*NKRY_MAX)
     *           +MOD(NKRY_BLOCK*NKRY_BLOCK*NKRY_MAX,2)     
      CALL GET_ADDR(IP_ALPHA,SCR(LSCR2))
      LSCR2=LSCR2+(NKRY_BLOCK*NKRY_BLOCK*(NKRY_MAX+1))
     *       +MOD(NKRY_BLOCK*NKRY_BLOCK*(NKRY_MAX+1),2)
      CALL GET_ADDR(IP_WT,SCR(LSCR2))
      LSCR2=LSCR2+NK+MOD(NK,2)
      CALL GET_ADDR(IP_TMAT,SCR(LSCR2))
      LSCR2=LSCR2+3*NK*NK+MOD(3*NK*NK,2)
      CALL GET_ADDR(IP_INDEX,SCR(LSCR2))
      LSCR2=LSCR+(NDIAG/IRAT+1)+MOD(NDIAG/IRAT+1,2)
      CALL GET_ADDR(IP_ISCR,SCR(LSCR2))
      LSCR2=LSCR2+(LISCR/IRAT+1)+MOD((LISCR/IRAT+1),2)
      LSCR3=LSCR-LSCR2
#else
      LSCR2=LSCR-(LISCR/IRAT+1)
      CALL GET_ADDR(IP_ISCR,SCR(LSCR2+1))
      LSCR2=LSCR-(NDIAG/IRAT+1)
      CALL GET_ADDR(IP_INDEX,SCR(LSCR2+1))
      LSCR2=LSCR2-3*NK*NK
      CALL GET_ADDR(IP_TMAT,SCR(LSCR2+1))
      LSCR2=LSCR2-NK
      CALL GET_ADDR(IP_WT,SCR(LSCR2+1))
      LSCR2=LSCR2-(NKRY_BLOCK*NKRY_BLOCK*(NKRY_MAX+1))
      CALL GET_ADDR(IP_ALPHA,SCR(LSCR2+1))
      LSCR2=LSCR2-(NKRY_BLOCK*NKRY_BLOCK*NKRY_MAX)
      CALL GET_ADDR(IP_BETA,SCR(LSCR2+1))
      LSCR2=LSCR2-NDIAG*NDIAG
      CALL GET_ADDR(IP_ADAV,SCR(LSCR2+1))
#endif
C     ==--------------------------------------------------------------==
      TIM1=TIMEF()
      TLSD2=TLSD
      TLSD=.FALSE.
      TCONV=.FALSE.
      NGW2=NGW*2
      NCONV=0
      NCONVOLD=0
      NHPSIOLD=0
      IF(TTROT) THEN
        TROTMIN=EXP(-EDAVMAX*BETAP)
        TROTMAX=EXP(-EDAVMIN*BETAP)
      ENDIF
      CALL IAZZERO(INDEX,NDIAG)
C     ==--------------------------------------------------------------==
      IF(PARENT.AND.TINFO) THEN
        IF(JSPIN.EQ.0) THEN
          CHARSPIN='<<<<<<<<<<<<<<<<<<<<'
        ELSEIF(JSPIN.EQ.1) THEN
          CHARSPIN='<<<<<<< ALPHA SPIN<<'
        ELSEIF(JSPIN.EQ.2) THEN
          CHARSPIN='<<<<<<<< BETA SPIN<<'
        ENDIF
        WRITE(6,'(/,1X,13("<"),A,A20)')
     &     ' BLOCK LANCZOS DIAGONALIZATION ',CHARSPIN
      ENDIF
C     Subspace Matrix
      TCHECK=.TRUE.
      NTEST=0
      DO WHILE(TCHECK)
        IF(TTROT) THEN
          CALL EHPSI(C0,CS,VPOT,PSI,NDIAG)
        ELSE
#ifdef   _BGL
          CALL HPSI(C0,CS,SC0,VPOT,PSI,SCR(LSCR2),LSCR3,NDIAG,1,ISPIN)
#else
          CALL HPSI(C0,CS,SC0,VPOT,PSI,SCR,LSCR2,NDIAG,1,ISPIN)
#endif
        ENDIF
        NHPSI=NDIAG
        CALL OVLAP2(NGW,NDIAG,NDIAG,ADAV,C0,CS)
#ifdef PARALLEL
#ifdef   _BGL
        CALL SUMMAT(ADAV,NDIAG,SCR(LSCR2),LSCR3)
#else
        CALL SUMMAT(ADAV,NDIAG,SCR,LSCR2)
#endif
#endif
#ifdef   _BGL
        CALL DSYEV('V','U',NDIAG,ADAV,NDIAG,EDAV,SCR(LSCR2),LSCR3,IERR)
#else
        CALL DSYEV('V','U',NDIAG,ADAV,NDIAG,EDAV,SCR,LSCR2,IERR)
#endif
        CALL REORDER(NDIAG,NDIAG,EDAV,ADAV)
C       Rotate Orbitals
        CALL DGEMM('N','N',NGW2,NDIAG,NDIAG,1.D0,C0(1,1),NGW2,
     *       ADAV(1,1),NDIAG,0.D0,CSCR(1,1),NGW2)
        CALL DCOPY(NGW2*NDIAG,CSCR(1,1),1,C0(1,1),1)
        CALL DGEMM('N','N',NGW2,NDIAG,NDIAG,1.D0,CS(1,1),NGW2,
     *       ADAV(1,1),NDIAG,0.D0,CSCR(1,1),NGW2)
        CALL DCOPY(NGW2*NDIAG,CSCR(1,1),1,CS(1,1),1)
C     Check if an eigenvalue is not equal to 0 (dim < NDIAG)
        TCHECK=.FALSE.
        DO I=1,NDIAG
          IF(TTROT) THEN
            TTEST = (EDAV(I).GT.TROTMAX).OR.(EDAV(I).LT.TROTMIN)
          ELSE
            TTEST = ABS(EDAV(I)).LT.EPS
          ENDIF
          IF(TTEST) THEN
            TCHECK=.TRUE.
            IF(PARENT)
     &           WRITE(6,*) 'FRSBLK| EIGENVECTOR',I,' IS VERY BAD!'
            CALL DURAND(1.234D0,NGW2,C0(1,I))
            IF(GEQ0) C0(1,I)=DCMPLX(DREAL(C0(1,I)),0.D0)
            ITEST=I
          ENDIF
        ENDDO
        IF(TCHECK) THEN
          NTEST=NTEST+1
          IF (NTEST.GT.10.AND.PARENT)
     &         CALL STOPGM(' FRSBLK', 'CAN''T FIND GUEST VECTORS')
          IF(ITEST.EQ.1.AND.NDIAG.NE.1)
     &         CALL DSWAP(NGW2,C0(1,1),1,C0(1,NDIAG),1)
#ifdef   _BGL
          CALL RGS(C0,NDIAG,ADAV,SCR(LSCR2))
#else
          CALL RGS(C0,NDIAG,ADAV,SCR)
#endif
        ENDIF
      ENDDO
      TIM2=TIMEF()
      TIM=(TIM2-TIM1)*0.001D0
      IF(PARENT.AND.TINFO) THEN
        WRITE(6,'(A,T58,F8.2)') 
     *    ' >> TIME FOR INITIAL SUBSPACE DIAGONALIZATION:  ',TIM
        WRITE(6,'(A,8X,A,8X,A)') ' >> CYCLE     NCONV',
     *    'B2MAX','B2MIN     #HPSI      TIME'
      ENDIF
      DO ICYCLE=1,N_FRIES
        TIM1=TIMEF()
        B2MAX=0.D0
        B2MIN=1.D30
C       We calculate again the residue for all vectors
        NCONV=0
        NCURR=NCONV+1
C       First Lanczos Step
        DO I=NCURR,NDIAG
          DO IG=1,NGW
            CSCR(IG,1)=CS(IG,I)-EDAV(I)*C0(IG,I)
          ENDDO
          B2=DOTP(NGW,CSCR,CSCR)
#ifdef PARALLEL
          CALL GLOSUM(1,B2)
#endif
          IF(B2.LT.B2LIMIT) THEN
            NCONV=NCONV+1
            INDEX(I)=NCONV
          ENDIF
          IF(B2.GT.B2MAX) B2MAX=B2
          IF(B2.LT.B2MIN) B2MIN=B2
        ENDDO
C       Order states: converged first
        DO I=NCURR,NDIAG
          J=INDEX(I)
          IF(J.NE.0.AND.J.NE.I) THEN
            CALL DSWAP(NGW2,C0(1,I),1,C0(1,J),1)
            CALL DSWAP(NGW2,CS(1,I),1,CS(1,J),1)
            INDEX(J)=J
            INDEX(I)=0
            AUX = EDAV(I)
            EDAV(I)=EDAV(J)
            EDAV(J)=AUX
          ENDIF
        ENDDO
        NCURR=NCONV+1
        NLEFT=NDIAG-NCONV
C       Lanczos Refinement
        IF(ICYCLE.EQ.1.AND.NCURR.GT.NDIAG) THEN
          TREFINE=.FALSE.
        ELSE
          TREFINE=.TRUE.
        ENDIF
C..New
        DO I=NCURR,NDIAG,NKRY_BLOCK
          NBLEFF=MIN(NKRY_BLOCK,NDIAG-I+1)
C         ==----------------------------------------------------------==
C         Preparation for refinement
C         ==----------------------------------------------------------==
#ifdef   _BGL
          CALL PRPKRV(NGW2,NBLEFF,NKRY_MAX,NCONV,C0(1,1),C0(1,I),
     &    CS(1,I),CSCR,ALPHA,BETA,EDAV(I),SCR(LSCR2),LSCR3,ISCR,LISCR,
     &         NHPSI,VPOT,PSI,SC0,TTROT)
#else
          CALL PRPKRV(NGW2,NBLEFF,NKRY_MAX,NCONV,C0(1,1),C0(1,I),
     &         CS(1,I),CSCR,ALPHA,BETA,EDAV(I),SCR,LSCR2,ISCR,LISCR,
     &         NHPSI,VPOT,PSI,SC0,TTROT)
#endif
C         ==----------------------------------------------------------==
C         Refinement Loop
C         ==----------------------------------------------------------==
          NBLK=NBLEFF*NKRY_MAX
#ifdef   _BGL
          CALL KRYREF(NGW2,NBLEFF,NKRY_MAX,NCONV,C0,EDAV,CSCR,ALPHA,
     &    BETA,TMAT,NBLK*NBLK,WT,NBLK,SCR(LSCR2),LSCR3,ISCR,LISCR,NHPSI,
     &         VPOT,PSI,SC0,TTROT)
#else
          CALL KRYREF(NGW2,NBLEFF,NKRY_MAX,NCONV,C0,EDAV,CSCR,ALPHA,
     &         BETA,TMAT,NBLK*NBLK,WT,NBLK,SCR,LSCR2,ISCR,LISCR,NHPSI,
     &         VPOT,PSI,SC0,TTROT)
#endif
C         ==----------------------------------------------------------==
C..V=[V_1 V_2.. V_L] Y
          CALL DGEMM('N','N',NGW2,NBLEFF,NBLK,1.D0,CSCR,NGW2,TMAT,
     &         NBLK,0.D0,C0(1,I),NGW2)
C         ==----------------------------------------------------------==
C         == End of refinement over states                            ==
C         ==----------------------------------------------------------==
        ENDDO
C..New
C       Reorthogonalize
        IF(NCURR.LE.NDIAG) THEN
#ifdef   _BGL
          CALL GS_ORTHO(C0,NCURR-1,C0(1,NCURR),NDIAG-NCURR+1,
     *                  ADAV,SCR(LSCR2))
#else
          CALL GS_ORTHO(C0,NCURR-1,C0(1,NCURR),NDIAG-NCURR+1,ADAV,SCR)
#endif
        ENDIF
C       Calculate new forces; only for states that entered Lanczos
        NLEFT=NDIAG-NCURR+1
        IF (NCURR.LE.NDIAG) THEN
          IF(TTROT) THEN
            CALL EHPSI(C0(1,NCURR),CS(1,NCURR),VPOT,PSI,NLEFT)
          ELSE
#ifdef   _BGL
            CALL HPSI(C0(1,NCURR),CS(1,NCURR),SC0(1,NCURR),
     &           VPOT,PSI,SCR(LSCR2),LSCR3,NLEFT,1,ISPIN)
#else
            CALL HPSI(C0(1,NCURR),CS(1,NCURR),SC0(1,NCURR),
     &           VPOT,PSI,SCR,LSCR2,NLEFT,1,ISPIN)
#endif
          ENDIF
          NHPSI=NHPSI+NLEFT
        ENDIF
C       Diagonalize Kohn-Sham Matrix
        CALL OVLAP2(NGW,NDIAG,NDIAG,ADAV,C0,CS)
#ifdef PARALLEL
#ifdef   _BGL
        CALL SUMMAT(ADAV,NDIAG,SCR(LSCR2),LSCR3)
#else
        CALL SUMMAT(ADAV,NDIAG,SCR,LSCR2)
#endif
#endif
#ifdef   _BGL
      CALL DSYEV('V','U',NDIAG,ADAV,NDIAG,EDAV,SCR(LSCR2),LSCR3,IERR)
#else
        CALL DSYEV('V','U',NDIAG,ADAV,NDIAG,EDAV,SCR,LSCR2,IERR)
#endif
        CALL REORDER(NDIAG,NDIAG,EDAV,ADAV)
        CALL DGEMM('N','N',NGW2,NDIAG,NDIAG,1.D0,C0(1,1),NGW2,
     *             ADAV(1,1),NDIAG,0.D0,CSCR(1,1),NGW2)
        CALL DCOPY(NGW2*NDIAG,CSCR(1,1),1,C0(1,1),1)
        CALL DGEMM('N','N',NGW2,NDIAG,NDIAG,1.D0,CS(1,1),NGW2,
     *             ADAV(1,1),NDIAG,0.D0,CSCR(1,1),NGW2)
        CALL DCOPY(NGW2*NDIAG,CSCR(1,1),1,CS(1,1),1)
C       If one eigenvalue is equal to zero (like friesner_c).
        NTRANS=NCONV
        DO I=1,NCONV
          IF(TTROT) THEN
            TTEST = (EDAV(I).GT.TROTMAX).OR.(EDAV(I).LT.TROTMIN)
          ELSE
            TTEST = ABS(EDAV(I)).LT.EPS
          ENDIF
          IF(TTEST) THEN
            NCONV=NCONV-1
            NTRANS=NTRANS+1
            IF(PARENT)
     &           WRITE(6,*) ' FRSBLK| ','VERY BAD EIGENVALUE !!'
            IF(NTRANS.GT.NDIAG) THEN
              CALL DURAND(1.234D0,NGW2,C0(1,I))
            ELSE
              CALL DSWAP(NGW2,C0(1,I),1,C0(1,NTRANS),1)
              CALL DSWAP(NGW2,CS(1,I),1,CS(1,NTRANS),1)
            ENDIF
          ENDIF
        ENDDO
        TIM2=TIMEF()
        TIM=(TIM2-TIM1)*0.001D0
        IF(PARENT.AND.TINFO) THEN
           WRITE(6,'(4X,I5,5X,I5,2(1PE13.3),0PF10.2,0PF10.2)')
     &          ICYCLE,NCONV,B2MAX,B2MIN,
     &          DBLE(NHPSI-NHPSIOLD)/DBLE(NDIAG),TIM
        ENDIF
        NHPSIOLD=NHPSI
C       Test if the number of eigenvalues is enough to stop.
        IF((.NOT.TFRAL).AND.TFINT.AND.
     &       (NCONV.NE.NCONVOLD).AND.
     &       (NCONV.NE.NDIAG)) THEN
C          Spin or not.
           IF(TLSD2.AND.(NCONV.GE.NEL).OR.
     &          (.NOT.TLSD2.AND.(NCONV.GE.(NEL+1)/2)) ) THEN
              TCONV=.TRUE.
              NCONVOLD=NCONV
#ifdef   _BGL
              CALL CONVFRIE(NDIAG,NCONV,NEL,EDAV,TLSD,
     &             AMU,SCR(LSCR2),SCR(LSCR2+NDIAG+MOD(NDIAG,2)),TCONV)
#else
              CALL CONVFRIE(NDIAG,NCONV,NEL,EDAV,TLSD,
     &             AMU,SCR(1),SCR(NDIAG+1),TCONV)
#endif
           ENDIF
        ENDIF
        IF(TCONV.OR.NCONV.EQ.NDIAG) THEN
           GOTO 200
        ENDIF
C       End of Krylov Space Cycles
      ENDDO
  200 CONTINUE
      IF(PARENT.AND.((.NOT.TCONV).AND.NCONV.NE.NDIAG)) THEN
        WRITE(6,'(1X,64("!"))')
        WRITE(6,'(" !!",A,T64,"!!")')
     &       ' FRSBLK| NOT ALL ROOTS ARE CONVERGED'
        WRITE(6,'(1X,64("!"))')
      ENDIF
      TLSD=TLSD2
      CALL TIHALT('    FRSBLK',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_FRSBLK(LFRSBLK,TAG,NDIAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        ! NKRY_BLOCK NKRY_MAX
      INCLUDE 'kpts.inc'        ! TKPNT
      INCLUDE 'irat.inc'
C     Arguments
      INTEGER   LFRSBLK,NDIAG
      CHARACTER TAG*30
C     Variables
      INTEGER   LHPSI,LSUMMAT,LSCR,NK,LSCRDIAG
C     ==--------------------------------------------------------------==
      LHPSI=0
      LSUMMAT=0
      LSCR=0
      LSCRDIAG=0
      CALL GIVE_SCR_HPSI(LHPSI,TAG,NDIAG)
      CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NDIAG)
      NK=NKRY_BLOCK*NKRY_MAX
      IF(TKPNT) THEN
        LSCRDIAG=(3*NDIAG-2) + 2*(2*NDIAG)
        LSCR=(6*NK/IRAT+1)+(NDIAG/IRAT+1)+           !ISCR INDEX
     &       6*NK*NK+NK+                             !TMAT WT
     &       2*(NKRY_BLOCK*NKRY_BLOCK*(NKRY_MAX+1))+ !ALPHA
     &       2*(NKRY_BLOCK*NKRY_BLOCK*NKRY_MAX)+     !BETA
     &       2*(NDIAG*NDIAG)                         !ADAV
      ELSE
        LSCRDIAG=8*NDIAG*NKRY_BLOCK
        LSCR=(6*NK/IRAT+1)+(NDIAG/IRAT+1)+           !ISCR INDEX
     &       3*NK*NK+NK+                             !TMAT WT
     &       (NKRY_BLOCK*NKRY_BLOCK*(NKRY_MAX+1))+   !ALPHA
     &       (NKRY_BLOCK*NKRY_BLOCK*NKRY_MAX)+       !BETA
     &       (NDIAG*NDIAG)                           !ADAV
      ENDIF
      LFRSBLK=LSCR+MAX(LHPSI,LSUMMAT,LSCRDIAG)+10
      TAG='LSCR+MAX(HPSI,SUMMAT,DIAG)'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MGS(A,N,R,ISCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    N,ISCR(N)
      REAL*8     A(*),R(N,*)
C     Variables
      INTEGER    ISUB,INFO
C     ==================================================================
      CALL TISET('        MGS',ISUB)
      CALL RGS(A,N,R,ISCR)
      CALL DTRTRI('U','N',N,R,N,INFO)
      CALL TIHALT('        MGS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN 
      END 
C     ==================================================================
      SUBROUTINE PUTTMAT(CHAR,T,M,N,A,MA,NA,IBEG,JBEG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    M,N,MA,NA,IBEG,JBEG
      REAL*8     T(M,N),A(MA,NA)
      CHARACTER  CHAR*1
C     Variables
      INTEGER    J,I
C     ==--------------------------------------------------------------==
      IF(MA*IBEG.GT.M) CALL STOPGM('PUTTMAT',' MA*IBEG.GT.M')
      IF(NA*JBEG.GT.N) CALL STOPGM('PUTTMAT',' NA*JBEG.GT.N')
      IF(CHAR.EQ.'N') THEN 
        DO J=1,NA
          DO I=1,MA 
            T(I+MA*(IBEG-1),J+NA*(JBEG-1))=A(I,J)
          ENDDO
        ENDDO
      ELSEIF(CHAR.EQ.'T') THEN 
        DO J=1,NA
          DO I=1,MA 
            T(I+MA*(IBEG-1),J+NA*(JBEG-1))=A(J,I)
          ENDDO
        ENDDO
      ELSE
        CALL STOPGM('PUTTMAT','ILLEGAL CHAR')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ================================================================
      SUBROUTINE GETMAT(CHAR,T,M,N,A,MA,NA,IBEG,JBEG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    M,N,MA,NA,IBEG,JBEG
      REAL*8     T(M,N),A(MA,NA)
      CHARACTER  CHAR*1
C     Variables
      INTEGER    J,I
C     ==--------------------------------------------------------------==
      IF(MA*IBEG.GT.M) CALL STOPGM('GETMAT',' MA*IBEG.GT.M')
      IF(NA*JBEG.GT.N) CALL STOPGM('GETMAT',' NA*JBEG.GT.N')
      IF(CHAR.EQ.'N') THEN 
        DO J=1,NA
          DO I=1,MA 
            A(I,J)=T(I+MA*(IBEG-1),J+NA*(JBEG-1))
          ENDDO
        ENDDO
      ELSEIF(CHAR.EQ.'T') THEN 
        DO J=1,NA
          DO I=1,MA 
            A(J,I)=T(I+MA*(IBEG-1),J+NA*(JBEG-1))
          ENDDO
        ENDDO
      ELSE
        CALL STOPGM('GETMAT','ILLEGAL CHAR')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     =================================================================
      SUBROUTINE REORDER(M,N,W,A)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    M,N
      REAL*8     A(M,N),W(N)
C     Variables
      INTEGER    J
      REAL*8     AUX
C     ==--------------------------------------------------------------==
      DO J=1,N/2
        CALL DSWAP(M,A(1,J),1,A(1,N-J+1),1)
        AUX=W(N-J+1)
        W(N-J+1)=W(J)
        W(J)=AUX
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN 
      END
C     ==================================================================
      SUBROUTINE KRYREF(M,N,NKRY,NCONV,V0,W,V,AM,BM,T,LDT,WT,LDWT,
     &     SCR,LSCR,ISCR,LISCR,NHPSI,VPOT,PSI,SC0,TTROT)
C     ==================================================================
      IMPLICIT NONE
C     Arguments
      INTEGER    M,N,NKRY,NCONV,LDT,LDWT,LSCR,LISCR,NHPSI,
     &           ISCR(LISCR)
      REAL*8     V0(M,*),V(M,N,NKRY+1),AM(N,N,NKRY+1),BM(N,N,NKRY),
     &           T(LDT,*),
     &           WT(LDWT),W(N),SCR(LSCR),VPOT(*)
      COMPLEX*16 SC0(*),PSI(*)
      LOGICAL    TTROT
C     Variables
      INTEGER    ISPIN
      PARAMETER  (ISPIN=1)
      INTEGER    I,ISUB,J
C     ==--------------------------------------------------------------==
      CALL TISET('    KRYREF',ISUB)
      DO I=3,NKRY
C..V_I = V_I - V_(I-1) A_(I-1) 
        CALL RSDBLK('N',M,N,V(1,1,I-1),AM(1,1,I-1),V(1,1,I))
C..V_I B_I = V_I
        CALL MGS(V(1,1,I),N,BM(1,1,I),ISCR)
C..HPSI:  H V_I
        IF(TTROT) THEN
          CALL EHPSI(V(1,1,I),V(1,1,I+1),VPOT,PSI,N)
        ELSE
          CALL HPSI(V(1,1,I),V(1,1,I+1),SC0,VPOT,PSI,SCR,LSCR,N,1,
     &         ISPIN)
        ENDIF
        NHPSI=NHPSI+N 
C.. project out converged states
        CALL PRJCNV(M,N,NCONV,V0,W,V(1,1,I+1),SCR)
C..V_(I+1) = H V_I - V_(I-1)B_I 
        CALL RSDBLK('T',M,N,V(1,1,I-1),BM(1,1,I),V(1,1,I+1))
C..Ovlap:  A_I=V_I^T V_(I+1)
        CALL OVLAP2(M/2,N,N,AM(1,1,I),V(1,1,I),V(1,1,I+1))
#ifdef PARALLEL
        CALL SUMMAT(AM(1,1,I),N,SCR,LSCR)
#endif
      ENDDO
C..Setup T-matrix. First diagonal terms      
      I=NKRY
      CALL AZZERO(T,I*N*I*N) 
      CALL PUTTMAT('N',T,I*N,I*N,AM(1,1,1),N,N,1,1)
      DO J=2,I
        CALL PUTTMAT('N',T,I*N,I*N,AM(1,1,J),N,N,J,J)
        CALL PUTTMAT('T',T,I*N,I*N,BM(1,1,J),N,N,J-1,J)
        CALL PUTTMAT('N',T,I*N,I*N,BM(1,1,J),N,N,J,J-1)
      ENDDO 
C..Full matrix diag. 
      CALL FMDIAG(I*N,N,T,WT,SCR,LSCR,ISCR,5*I*N,ISCR(5*I*N+1))
C..banded matrix diagonalisation. This seems to be slower than 
C..full diag.  
C     CALL BANDM(I*N,N,T,WT,SCR,LSCR,ISCR,5*I*N,ISCR(5*I*N+1))
C     ==--------------------------------------------------------------==
      CALL TIHALT('    KRYREF',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PRPKRV(M,N,NKRY,NCONV,VCONV,V0,VS,V,AM,BM,W,
     &     SCR,LSCR,ISCR,LISCR,NHPSI,VPOT,PSI,SC0,TTROT)
C     ==---------------------------------------------------------------==
C     == Returns A_1,A_2,B_2 and V in a form suitable for Krylov       ==
C     == refinement                                                    ==
C     ==---------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    M,N,NKRY,NCONV,LSCR,LISCR,NHPSI,
     &           ISCR(LISCR)
      REAL*8     SCR(LSCR),W(N),VPOT(*),
     &           VCONV(M,*),V0(M,N),VS(M,N),V(M,N,NKRY+1),
     &           AM(N,N,NKRY+1),BM(N,N,NKRY)
      COMPLEX*16 SC0(*),PSI(*)
      LOGICAL    TTROT
C     Variables
      INTEGER    ISPIN
      PARAMETER  (ISPIN=1)
      INTEGER    I,ISUB
C     ==---------------------------------------------------------------==
      CALL TISET('    PRPKRV',ISUB)
C     ==---------------------------------------------------------------==
      CALL DCOPY(M*N,V0,1,V(1,1,1),1)
      CALL DCOPY(M*N,VS,1,V(1,1,2),1)
C..Compute residual 
      DO I=1,N
        CALL DAXPY(M,-W(I),V(1,I,1),1,V(1,I,2),1)
      ENDDO
C..V2 B2=R  
      CALL AZZERO(BM,N*N*NKRY)
      CALL MGS(V(1,1,2),N,BM(1,1,2),ISCR)
C..   Setup A_1=diag(w)
      CALL AZZERO(AM,N*N)
      DO I=1,N 
        AM(I,I,1)=W(I)
      ENDDO
C..V_3=H.V2
      IF(TTROT) THEN
        CALL EHPSI(V(1,1,2),V(1,1,3),VPOT,PSI,N)
      ELSE
        CALL HPSI(V(1,1,2),V(1,1,3),SC0,VPOT,PSI,SCR,LSCR,
     &       N,1,ISPIN)
      ENDIF
      NHPSI=NHPSI+N 
C.. project out converged states
      CALL PRJCNV(M,N,NCONV,VCONV,W,V(1,1,3),SCR)
C..V_3=V_3-V_1 B_2^T
      CALL RSDBLK('T',M,N,V(1,1,1),BM(1,1,2),V(1,1,3))
C..Ovlap 
      CALL OVLAP2(M/2,N,N,AM(1,1,2),V(1,1,2),V(1,1,3))
#ifdef PARALLEL
      CALL SUMMAT(AM(1,1,2),N,SCR,LSCR)
#endif
C     ==--------------------------------------------------------------==
      CALL TIHALT('    PRPKRV',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PUTTAB(N,KD,A,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    N,KD,LSCR
      REAL*8     A(N,N),SCR(LSCR)
C     Variables
      INTEGER    J,IBEG,I
C     ==--------------------------------------------------------------==
      IF(LSCR.LT.N) THEN 
        WRITE(6,*) ' LSCR:',LSCR
        WRITE(6,*) 'N:',N
        CALL STOPGM('PUTTAB','LSCR LT N ')
      ENDIF
      CALL AZZERO(SCR,N)
      DO J=1,N
        CALL DCOPY(N,A(1,J),1,SCR,1)
        CALL AZZERO(A(1,J),N)
        IBEG=MAX(J-KD,1)
        DO I=IBEG,J
          A(1+KD+I-J,J)=SCR(I)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END 
C     ==================================================================
      SUBROUTINE RSDBLK(CHAR,M,N,V1,A,V2)
C     ==--------------------------------------------------------------==
C     == V_I = V_I - V_(I-1) A_(I-1)                                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    M,N
      REAL*8     A(N,N),V1(M,N),V2(M,N)
      CHARACTER  CHAR*1
C     Variables
      INTEGER    ISUB
C     ==--------------------------------------------------------------==
      CALL TISET('    RSDBLK',ISUB)
      IF(CHAR.EQ.'N') THEN 
        CALL DGEMM('N','N',M,N,N,-1.D0,V1,M,A,N,1.D0,V2,M)
      ELSEIF(CHAR.EQ.'T') THEN 
        CALL DGEMM('N','T',M,N,N,-1.D0,V1,M,A,N,1.D0,V2,M)
      ELSE
        CALL STOPGM('RSDBLK','ILLEGAL CHAR')
      ENDIF
      CALL TIHALT('    RSDBLK',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FMDIAG(M,N,T,WT,SCR,LSCR,ISCR,LISCR,IFAIL)
C     ==--------------------------------------------------------------==
C     Returns the n largest eigenvalues of MxM symtric matrix T       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   M,N,LSCR,LISCR,
     &          ISCR(LISCR),IFAIL(M)
      REAL*8    T(M,M,*),SCR(LSCR),WT(*)
C     Variables
      INTEGER   ISUB,INFO,MEVAL
C     ==--------------------------------------------------------------==
      CALL TISET('    FMDIAG',ISUB)
      IF(M.EQ.N) THEN 
        CALL DSYEV('V','U',N,T,N,WT,SCR,LSCR,INFO)
      ELSE
        CALL DSYEVX('V','I','U',M,T,M,1.D0,1.D0,M-N+1,M,0.D0,
     &       MEVAL,WT,T(1,1,2),M,SCR,LSCR,ISCR,IFAIL,INFO)
        IF(MEVAL.LT.N) THEN 
          WRITE(6,*) ' WARNING| DSYEVX RETURNED MEVAL < N',MEVAL,N
        ENDIF
        CALL DCOPY(M*N,T(1,1,2),1,T(1,1,1),1)
      ENDIF
      IF(INFO.NE.0) CALL STOPGM('FMDIAG','FMDIAG FAILED')
      CALL REORDER(M,N,WT,T)
      CALL TIHALT('    FMDIAG',ISUB)
C     ==--------------------------------------------------------------==
      RETURN 
      END 
C     ==================================================================
      SUBROUTINE BANDM(IN,N,T,WT,SCR,LSCR,ISCR,LISCR,IFAIL)
C     ==--------------------------------------------------------------==
C     == Returns the n largest eigenvalues                            ==
C     == of MxM symetric banded matrix T                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    IN,N,LSCR,LISCR,
     &           ISCR(LISCR),IFAIL(IN)
      REAL*8     T(IN,IN,3),SCR(LSCR),WT(IN)
C     Variables
      INTEGER    ISUB,MEVAL,INFO
C     ==--------------------------------------------------------------==
      CALL TISET('     BANDM',ISUB)
C..Put T is form suitable for banded matrix diagonalisation 
      CALL PUTTAB(IN,N,T,SCR,LSCR)
      IF(LSCR.LT.7*IN) THEN
        WRITE(6,*) ' 7*IN:',7*IN
        WRITE(6,*) 'LSCR:',LSCR
        CALL STOPGM('BANDM','LSCR TOO SMALL')
      ENDIF
      IF(LISCR.LT.5*IN) THEN
        WRITE(6,*) ' 5*IN:',5*IN
        WRITE(6,*) 'LISCR:',LISCR
        CALL STOPGM('BANDM','LISCR TOO SMALL')
      ENDIF
C        CALL DSBEV('V','U',IN,N,T,IN,WT,T(1,2),IN,SCR,INFO)
      CALL DSBEVX('V','I','U',IN,N,T,IN,T(1,1,2),IN,1.D0,1.D0,
     &     IN-N+1,IN,1.D-10,MEVAL,WT,T(1,1,3),IN,SCR,ISCR,IFAIL,INFO)
      IF(MEVAL.LT.N) THEN 
        WRITE(6,*) ' WARNING| DSBEVX RETURNED MEVAL < N',MEVAL,N
      ENDIF
      CALL DCOPY(IN*IN,T(1,1,3),1,T(1,1,1),1)
      CALL REORDER(IN,N,WT,T)
      CALL TIHALT('     BANDM',ISUB)
C     ==--------------------------------------------------------------==
      RETURN 
      END
C     ==================================================================
      SUBROUTINE PRJCNV(M,NP,N0,V0,W,V,SMAT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    M,NP,N0
      REAL*8     V(M,NP),V0(M,N0),SMAT(N0,NP),W(N0)
C     Variables
      INTEGER    ISUB
C     ==--------------------------------------------------------------==
      IF(N0.EQ.0) THEN
        RETURN
      ELSE
        RETURN 
      ENDIF
      CALL TISET('    PRJCNV',ISUB)
C..SMAT=V0^T.V 
      CALL OVLAP2(M/2,N0,NP,SMAT,V0,V)
      CALL GLOSUM(NP*N0,SMAT)
Cdeb      DO J=1,N0
Cdeb        CALL DSCAL(NP,W(J),SMAT(J,1),N0)
Cdeb      ENDDO
      CALL DGEMM('N','N',M,NP,N0,-1.D0,V0,M,SMAT,N0,1.D0,V,M)
      CALL TIHALT('    PRJCNV',ISUB)
C     ==--------------------------------------------------------------==
      RETURN 
      END 
C     ==================================================================
      SUBROUTINE WRITE_MATRIX(CHAR,M,N,A)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    M,N
      REAL*8     A(M,N)
      CHARACTER  CHAR*10
C     Variables
      INTEGER    I,J
C     ==--------------------------------------------------------------==
      WRITE(6,*) CHAR
      DO I=1,M
        WRITE(6,'(12(1PE15.6))') (A(I,J),J=1,N)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

