c     ==================================================================
      SUBROUTINE fukui_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &     eirop,eivps,z11,nstate)
c     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'irat.inc'
      include 'rmas.inc'
      include 'cnst.inc'
      include 'gvec.inc'  
      include 'geq0.inc'
      include 'prop.inc'
      include 'metr.inc'
      include 'cppt.inc'
      include 'spin.inc'
      INCLUDE 'response_p.inc'
c     nuclear fukui functions 
      include 'fft.inc'
      include 'ions.inc'
      include 'coor.inc'
      include 'adat.inc'
      include 'elct.inc'
      include 'kpnt.inc'
      include 'nlps.inc'
      include 'sfac.inc'
c     arguments
      integer    nstate,lscr
      complex*16 c0(ngw,nstate),c1(ngw,nstate)
      complex*16 psi(*)
      complex*16 eirop(nhg),eivps(nhg)
      real*8     drhoe(nnr1),z11(nstate,nstate)
      real*8     rhoe(*),scr(*)
c     variables
      integer    il_cf,il_rhof,il_psif
      complex*16 cf(ngw,numf+1),psif(maxfft),vtemp(nhg),vf(maxfft)
      real*8     rhof(nnr1),xcf(nnr1)
      pointer    (ip_cf,cf),(ip_rhof,rhof),(ip_psif,psif)
      pointer    (ip_vtemp,vtemp),(ip_xcf,xcf),(ip_vf,vf)
      CHARACTER*15 CFLBOD,CIPNUM
      CHARACTER  FILEN*30
      integer    i,ist,ig,ir,isub,i1,i2,n1,n2,k,iat,is
      real*8     scal,sumr,r1
      integer    nbeg,nend,nft
      complex*16 eirop1(nhg)
      pointer    (ip_eirop1,eirop1)
      integer    il_v1_loc
      complex*16 v1_nonloc,v1_loc(nhg)
      pointer    (ip_v1_loc,v1_loc)
      real*8     hardness,hard(nstate,nstate)
      pointer    (ip_hard,hard)
      real*8     fnl(imagp,nat,nhxs,nstate,nkpnt),
     &           dfnl(imagp,nat,nhxs,3,nstate,nkpnt)
      real*8     ffmat(3,nax,nsx),fion_p(3*nat)
      pointer    (ip_ffmat,ffmat),(ip_fion_p,fion_p)
      DIMENSION  ddfnl(imagp,nat,nhxs,3,3,nstate,nkpnt)
      DIMENSION  dfnl00(imagp,nat,nhxs,3,nstate,nkpnt),
     &           fnl00(imagp,nat,nhxs,nstate,nkpnt)
      integer    isa,isa0,iv,ia,icol
      real*8     ff(nstate)
      pointer    (ip_ff,ff)

c     ==--------------------------------------------------------------==
      CALL tiset('   fukui_p',isub)

      IL_CF=2*ngw*(numf+1)
      CALL memory(IP_CF,IL_CF,'CF')        ! first allocation
      CALL RHOE_PSI_SIZE(il_rhof,il_psif)
      CALL memory(ip_rhof,il_rhof,'rhof')
      CALL memory(ip_xcf,il_rhof,'xcf')
      CALL memory(ip_psif,il_psif,'psif')
      CALL memory(ip_vf,il_psif,'vf')
      CALL memory(ip_vtemp,2*nhg,'vtemp')
      CALL memory(ip_eirop1,2*nhg,'eirop1')
      CALL zazzero(vtemp,nhg)
      CALL zazzero(eirop1,nhg)
      il_v1_loc=2*nhg
      CALL memory(ip_v1_loc,il_v1_loc,'v1_loc')
      CALL memory(ip_hard,nstate*nstate,'hard')
      CALL memory(ip_fion_p,3*nat,'fion_p')
      CALL memory(ip_ffmat,3*nax*nsx,'ffmat')
      CALL memory(ip_ff,nstate,'ff')
      CALL azzero(ff,nstate)

c     ==--------------------------------------------------------------==
c     reads the wavefunction whose occupation number changes

      IF(TLSD) THEN   ! LSD
         DO I=1,NUMF
           IST=-NF(I)
           IF(IST.GT.NSUP) THEN 
             IST=IST-NSUP
             CFLBOD='WAVEFUNCTION.B'
           ELSE
             CFLBOD='WAVEFUNCTION.A'
           ENDIF 
           WRITE(CIPNUM,'(I4)') IST
           CALL XSTRING(CFLBOD,N1,N2)
           CALL XSTRING(CIPNUM,I1,I2)
           FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
           CALL DENSRD(VTEMP,FILEN)
!$OMP parallel do private(IG)
           DO IG=1,NGW
             CF(IG,I)=VTEMP(IG)
           ENDDO
         ENDDO
      ELSE
         DO I=1,NUMF  ! LDA
           IST=-NF(I)
           CFLBOD='WAVEFUNCTION.'
           WRITE(CIPNUM,'(I4)') IST
           CALL XSTRING(CFLBOD,N1,N2)
           CALL XSTRING(CIPNUM,I1,I2)
           FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
           CALL DENSRD(VTEMP,FILEN)
!$OMP parallel do private(IG)
           DO IG=1,NGW
             CF(IG,I)=VTEMP(IG)
           ENDDO
         ENDDO
      ENDIF

c     eventually compute linear combination

      IF (TWEIGHT) THEN
         NBEG=1
         NEND=NUMF
         NFT=NUMF
      ELSE
         SCAL=0.0D0
         DO I=1,NUMF
            SCAL=SCAL+WGHTF(I)*WGHTF(I)
         ENDDO
         SCAL=1.D0/DSQRT(SCAL)
         IF(parent) THEN
           WRITE(6,*) 'All coeffs are scaled by',SCAL
         ENDIF
         CALL DGEMM('N','N',2*ngw,1,numf,SCAL,cf(1,1),2*ngw,wghtf,
     &        numf+1,0.D0,cf(1,numf+1),2*ngw)
         NBEG=NUMF+1
         NEND=NUMF+1
         NFT=1
         WGHTF(NUMF+1)=1.0D0
      ENDIF

c    adds non-local contribution to the nuclear fukui functions
      CALL zazzero(c1,ngw*nstate)
      CALL DCOPY(2*ngw*nft,cf(1,nbeg),1,c1,1)
      CALL rnlsm(c1,nstate,psi,scr,lscr,1,1,.true.)
      CALL azzero(ffmat,3*nax*nsx)
      DO i=1,nft
         ff(i)=wghtf(nbeg+i-1)
      ENDDO
!$OMP parallel do private(i)
      DO i=nft+1,nstate
         ff(i)=0.0D0
      ENDDO
      CALL rnlfor(ffmat,ff,wk,nstate,1)
      CALL DSCAL(3*nax*nsx,-1.0D0,ffmat,1)
      
      CALL memory(ip_fnl00,imagp*nstate*nat*nhxs*nkpnt,'fnl00')
      CALL memory(ip_dfnl00,imagp*3*nat*nhxs*ndfnl*nkpnt,'dfnl00') ! last allocation
      
      CALL rnlsm(c0,nstate,psi,scr,lscr,1,1,.true.)

c     save  fnl and  dfnl in fnl00 and dfnl00      
      isa0=0
      DO is=1,nsp           ! parallel impossible
         DO iv=1,ngh(is)
            DO ia=1,na(is)  ! parallel possible
               isa=isa0+ia
               DO i=1,nstate
                  fnl00(1,isa,iv,i,1)=fnl(1,isa,iv,i,1)
               ENDDO
               DO i=1,nst12(mepos,2)-nst12(mepos,1)+1
                  dfnl00(1,isa,iv,1,i,1)=dfnl(1,isa,iv,1,i,1)
                  dfnl00(1,isa,iv,2,i,1)=dfnl(1,isa,iv,2,i,1)
                  dfnl00(1,isa,iv,3,i,1)=dfnl(1,isa,iv,3,i,1)
               ENDDO
            ENDDO
         ENDDO
         isa0=isa0+na(is)
      ENDDO

c     ==--------------------------------------------------------------==
c     calculates the perturbating density

      CALL AZZERO(RHOF,NNR1)
      DO I=NBEG,NEND
#ifdef _BGL
         CALL AZZERO(PSIF,2*MAXFFT)
#else
         CALL ZAZZERO(PSIF,MAXFFT)
#endif
#ifdef  _BGL
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(1000))
#endif
         DO IG=1,NGW
            PSIF(NZH(IG))=CF(IG,I)
            PSIF(INDZ(IG))=DCONJG(CF(IG,I))
         ENDDO
         IF(GEQ0) PSIF(NZH(1))=CF(1,I)
         CALL INVFFT(PSIF)
#ifdef  _BGL
!IBM* ASSERT (ITERCNT(10000))
#endif
!$OMP parallel do private(IR,R1)
         DO IR=1,NNR1
            R1=DREAL(PSIF(IR))
            RHOF(IR)=RHOF(IR)+R1*R1/OMEGA*WGHTF(I)
         ENDDO
      ENDDO
      
      SUMR=0.0D0
#ifdef  _BGL
!IBM* INDEPENDENT, REDUCTION(SUMR)
!IBM* ASSERT (ITERCNT(10000))
#endif
!$OMP parallel do private(IR) reduction(+:SUMR)
      DO IR=1,NNR1
         SUMR=SUMR+RHOF(IR)
      ENDDO
#ifdef PARALLEL
      call glosum(1,sumr)
#endif
      IF(parent) THEN
        WRITE(6,*) 'Norm of the perturbating density:',
     &     sumr*omega/DBLE(nr1s*nr2s*nr3s)
      ENDIF

c     ==--------------------------------------------------------------==
c     calculates the corresponding perturbating potential
#ifdef _BGL
      call azzero(vtemp,2*nhg)
#else
      call zazzero(vtemp,nhg)
#endif
      call v1ofrho_p(vtemp,eirop1,scr,lscr,rhof,rhoe,psif,.FALSE.)
#ifdef _BGL
      call azzero(vf,2*maxfft)
#else
      call zazzero(vf,maxfft)
#endif
#ifdef  _BGL
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(10000))
#endif
!$OMP parallel do private(ir)
      DO ir=1,nnr1
         vf(ir)=dcmplx(rhoe(ir),0.0d0)
      ENDDO
      call fwfft(vf)
#ifdef  _BGL
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(10000))
#endif
      DO ig=1,nhg
         v1_loc(ig)=vf(nzh(ig))
      ENDDO

      CALL rhoofr(c0,rhoe,psi,scr,lscr,nstate)
c     ==--------------------------------------------------------------==
c     ==         the basic loops for perturbations                    ==
c     ==--------------------------------------------------------------==
      IF(parent) THEN
        WRITE(6,'(/," ",22("*"),a,22("*"),/)')'   perturbations    '
      ENDIF
c...  optimization for c1
#ifdef _BGL  
      CALL azzero(c1,2*ngw*nstate)
#else
      CALL zazzero(c1,ngw*nstate)
#endif
c     ==--------------------------------------------------------------==
      CALL rwfopt_p(c0,c1,psi,rhoe,drhoe,scr,lscr,eirop,
     &     eivps,v1_loc,v1_nonloc,z11,nstate,eirop1)
c     ==--------------------------------------------------------------==
c     
c     ==--------------------------------------------------------------==
c     calculate the linear perturbation in the density 
c     \   drhoe=<c0|r><r|c1>+cc (from rwfopt_p) and rhof=rhof+drhoe
      CALL DCOPY(NNR1,drhoe,1,RHOF,1)
      DO I=NBEG,NEND
#ifdef _BGL
      CALL azzero(PSIF,2*MAXFFT)
#else
      CALL zazzero(PSIF,MAXFFT)
#endif
#ifdef  _BGL
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(1000))
#endif
         DO IG=1,NGW
            PSIF(NZH(IG))=CF(IG,I)
            PSIF(INDZ(IG))=DCONJG(CF(IG,I))
         ENDDO
         IF(GEQ0) PSIF(NZH(1))=CF(1,I)
         CALL INVFFT(PSIF)
#ifdef  _BGL
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(10000))
#endif
!$OMP parallel do private(IR,R1)
         DO IR=1,NNR1
            R1=DREAL(PSIF(IR))
            RHOF(IR)=RHOF(IR)+R1*R1/OMEGA*WGHTF(I)
         ENDDO
      ENDDO
      
c     ==--------------------------------------------------------------==
c     computes global hardness
c     ==--------------------------------------------------------------==
#ifdef _BGL  
      CALL azzero(PSIF,2*MAXFFT)
#else
      CALL zazzero(PSIF,MAXFFT)
#endif
      CALL invfft(vf)
      hardness=0.0d0
#ifdef  _BGL 
!IBM* ASSERT (ITERCNT(10000))
#endif
      DO ir=1,nnr1
         r1=dreal(vf(ir))
         hardness=hardness+rhof(ir)*r1
         psif(ir)=dcmplx(rhof(ir),0.0D0)
      ENDDO
#ifdef PARALLEL
      CALL glosum(1,hardness)
#endif
      hardness=hardness*omega/DBLE(nr1s*nr2s*nr3s)  
      IF(parent) THEN
         WRITE(6,*)
         WRITE(6,*) 'HARDNESS (eV/e) = deps_n/dn = ',2*RY*hardness
         WRITE(6,*)
      ENDIF

      CALL fwfft(psif)
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(10000))
#endif
      DO ig=1,nhg
         vtemp(ig)=psif(nzh(ig))
      ENDDO
      filen='FUKUI'
      CALL densto(vtemp,tau0,filen)
      
c     ==--------------------------------------------------------------==
c     computes nuclear Fukui functions

      CALL azzero(fion_p,3*nat)
      CALL rnlsm(c1,nstate,psi,scr,lscr,1,1,.true.)
      iat=0
      DO is=1,nsp
         DO ia=1,na(is)
            iat=iat+1
            DO k=1,3
               icol=3*(iat-1)+k
               CALL d_mat_locps(fion_p(icol),vtemp,
     &              iat,k,is)
               CALL d_mat_nonloc(fion_p(icol),fnl,dfnl,fnl00,dfnl00,
     &              f,wk,is,k,k,iat,nstate,1)
            ENDDO
         ENDDO
      ENDDO

      iat=0
      DO is=1,nsp
         DO ia=1,na(is)
            ffmat(1,ia,is)=ffmat(1,ia,is)+fion_p(3*iat+1)
            ffmat(2,ia,is)=ffmat(2,ia,is)+fion_p(3*iat+2)
            ffmat(3,ia,is)=ffmat(3,ia,is)+fion_p(3*iat+3)
            iat=iat+1
         ENDDO
      ENDDO

#ifdef PARALLEL
      CALL glosum(3*nax*nsx,ffmat)
#endif
      IF(parent) THEN
         WRITE(6,*) 'Nuclear Fukui functions:'
         CALL wrgeof(tau0,ffmat)
         WRITE(6,*) 
      ENDIF

c     ==--------------------------------------------------------------==
c     computes "per state" hardness
#ifdef _BGL
      CALL azzero(vtemp,2*nhg)
#else
      CALL zazzero(vtemp,nhg)
#endif
      CALL v1ofrho_p(vtemp,eirop1,scr,lscr,rhof,rhoe,psif,.false.)

c     potential * orbitals in c1
#ifdef _BGL
      CALL azzero(c1,2*nstate*ngw)
#else
      CALL zazzero(c1,nstate*ngw)
#endif
      CALL v1psi0_p(c0,c1,rhoe,psi,nstate)

c     overlap
      CALL ovlap(nstate,hard,c0,c1)
#ifdef PARALLEL
      CALL glosum(nstate*nstate,hard)
#endif
      IF(parent) THEN
         WRITE(6,*) 'Per state hardness (eV/e) '
         WRITE(6,*)
         WRITE(6,*) ' STATE     deps_i/dn'
         DO i=1,nstate
            WRITE(6,'(I4,2x,F15.6)') nstate+1-i,-1.0D0*ry*hard(i,i)
         ENDDO
         WRITE(6,*)
      ENDIF

      CALL freem(ip_dfnl00) ! start releasing memory from last location
      CALL freem(ip_fnl00)
      CALL freem(ip_ff)
      CALL freem(ip_ffmat)
      CALL freem(ip_fion_p)
      CALL freem(ip_hard)
      CALL freem(ip_v1_loc)
      CALL freem(ip_eirop1)
      CALL freem(ip_vtemp)
      CALL freem(ip_vf)
      CALL freem(ip_psif)
      CALL freem(ip_xcf)
      CALL freem(ip_rhof)
      CALL freem(IP_CF)    ! end with first allocation for fast access
      call tihalt('   fukui_p',isub)
c     ==--------------------------------------------------------------==
      RETURN
      END
