C     ==================================================================
      SUBROUTINE FUSION(C0,CM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'shop.inc'
      INCLUDE 'filn.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'store.inc'
      INCLUDE 'elct.inc'
      include 'mm_dim.inc'
C     Arguments
      COMPLEX*16 C0(NGW,*),CM(NGW,*)
C     Variables
      REAL*8  EIGV(1),TAUI(3,NAX,*)
      POINTER (IP_TAUI,TAUI)
      INTEGER NSTATE,NFI,IREC(100)
      CHARACTER*20 FILN_BACK
      logical    oldstatus,statusdummy
cMcB
      integer i,k
      character*10 prch
cMcB
C     ==================================================================

      if ( qmnode ) then

         IF ( PARENT ) THEN
            WRITE(6,'(/1X,''MERGING RESTART FILES FOR'',
     .                                           '' SURFACE HOPPING'')')
            IF ( .NOT.(RCO.AND.RWF) ) THEN
               WRITE(6,'(/1X,'' RESTART OPTION NOT ACTIVATED'')')
               CALL STOPGM('FUSION','        ')
            ENDIF 
         ENDIF

#if defined (__GROMOS)
         call mm_dim(mm_go_mm,oldstatus)
#endif
         CALL MEMORY(IP_TAUI,3*NAX*NSX,'TAUI')
         CALL AZZERO(TAUI,3*NAX*NSX)

         FILN_BACK = FILN
         CALL READ_IREC(IREC)

C...    read S0 state
         FILN = S0_FILN
         CALL ZHRWF(1,IREC,C0,CM,NST_S0,EIGV,TAU0,VELP,TAUI,NFI)
         IF ( PARENT ) THEN
            WRITE(6,'(/1X,''GROUND STATE: '',I5,'' -'',I5)') 1,NST_S0
         ENDIF

C...    read S1 state
         FILN = S1_FILN
         CALL ZHRWF(1,IREC,C0(1,NST_S0+1),CM(1,NST_S0+1),
     .              NST_S1,EIGV,TAU0,VELP,TAUI,NFI)
         IF ( PARENT ) THEN
            WRITE(6,'(/1X,''EXCITED STATE: '',I5,'' -'',I5)')
     .                                           NST_S0+1,NST_S0+NST_S1
         ENDIF

C...    write combined wfn
         CALL WRITE_IREC(IREC)
         FILN = FILN_BACK
         NSTATE = NST_S0 + NST_S1
         NFI = 1
cMcB... cf. elct.inc
         N = NSTATE
         CALL ZHWWF(2,IREC,C0,C0,NSTATE,EIGV,TAU0,VELP,TAUI,NFI)

#if defined (__GROMOS)
         call mm_dim(mm_revert,oldstatus)
#endif
      endif ! qmnode
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE SEPARATE(C0,CM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'shop.inc'
      INCLUDE 'filn.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'store.inc'
      INCLUDE 'elct.inc'
      include 'mm_dim.inc'
C     Arguments
      COMPLEX*16 C0(NGW,*),CM(NGW,*)
C     Variables
      REAL*8  EIGV(1),TAUI(3,NAX,*)
      POINTER (IP_TAUI,TAUI)
      INTEGER NSTATE,NFI,IREC(100),I
      INTEGER IA,IE
      CHARACTER*20 FILN_BACK
      logical    oldstatus,statusdummy
C     ==================================================================

      if ( qmnode ) then

#if defined (__GROMOS)
         call mm_dim(mm_go_mm,oldstatus)
#endif
         CALL MEMORY(IP_TAUI,3*NAX*NSX,'TAUI')
         CALL AZZERO(TAUI,3*NAX*NSX)

         FILN_BACK = FILBOD
         CALL READ_IREC(IREC)

C...    read fused restart state
         NSTATE = NST_S0 + NST_S1
         N = NSTATE
         NFI = 1
         CALL ZHRWF(1,IREC,C0,CM,NSTATE,EIGV,TAU0,VELP,TAUI,NFI)
         CALL WRITE_IREC(IREC)

c...    write S0 
         CALL XSTRING(S0_FILN,IA,IE)
         FILBOD = S0_FILN(IA:IE)//'.'
         IF ( PARENT ) THEN
            WRITE(6,'(/1X,''GROUND STATE: '',I5,'' -'',I5)') 1,NST_S0
         ENDIF
cMcB... cf. elct.inc
         N = NST_S0
         CALL ZHWWF(2,IREC,C0,CM,NST_S0,EIGV,TAU0,VELP,TAUI,NFI)

C...    write S1 
         CALL XSTRING(S1_FILN,IA,IE)
         FILBOD = S1_FILN(IA:IE)//'.'
         IF ( PARENT ) THEN
            WRITE(6,'(/1X,''EXCITED STATE: '',I5,'' -'',I5)')
     .                                           NST_S0+1,NST_S0+NST_S1
         ENDIF
cMcB... cf. elct.inc
         N = NST_S1
         CALL ZHWWF(2,IREC,C0(1,NST_S0+1),CM(1,NST_S0+1),
     .              NST_S1,EIGV,TAU0,VELP,TAUI,NFI)

         FILBOD = FILN_BACK

#if defined (__GROMOS)
         call mm_dim(mm_revert,oldstatus)
#endif
      endif ! qmnode

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
