C     ==================================================================
      SUBROUTINE G_LOC_DR_REAL(C0,C2,SCR,LSCR,NSTATE,EIGV,TAU0,TAUP,NFI)
C     ==--------------------------------------------------------------==
C     == PREPARE ENVIRONMENT FOR LOCALIZATION IN G SPACE              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'g_loc.inc'
      include 'spin.inc'
      include 'store.inc'
      include 'geq0.inc'
      include 'kpts.inc'
      include 'wann.inc'
      include 'fileopen.inc'
C     input
      INTEGER    LSCR,NSTATE
      REAL*8     SCR(LSCR)
      COMPLEX*16 C0(NGW,*),C2(2*NGW,NSTATE)
      REAL*8     EIGV(*),TAU0(*),TAUP(*)
      INTEGER    NFI
C     local
      COMPLEX*16 C1(2*NGW,NSTATE),PSI(*)
      POINTER    (IP_C1,C1),(IP_PSI,PSI)
      REAL*8     RE, IM,MOD,MOD2,OVER_SUP
      INTEGER    IS,IG,IL_PSI,IL_RHOE,IREC(100),IKIND
      CHARACTER  FILTR*15,NUMB*8,FILORB*15
      INTEGER    IA,IE,JS
C     TEST
      COMPLEX*16  XYZMAT(*),ROTMAT(NSTATE,NSTATE),ZONE,ZZERO
      REAL*8      CENR(3,NSTATE)
      POINTER     (IP_XYZMAT,XYZMAT),(IP_CENR,CENR),(IP_ROTMAT,ROTMAT)
      INTEGER     I, CONT1, CONT2
      LOGICAL     TEST,FERROR
C     ==--------------------------------------------------------------==

      TEST = .FALSE.
      IF(TKPNT)  
     &    CALL STOPGM('G_LOC_DR','KPOINT AND REAL WF INCONSISTENT')

      CALL MEMORY(IP_C1,2*2*NGW*NSTATE,'C1')
#ifdef _BGL 
      CALL AZZERO(C1,2*2*NGW*NSTATE)
#else
      CALL ZAZZERO(C1,2*NGW*NSTATE)
#endif

      DO IS = 1,NSTATE
        DO IG = 1,NGW
           RE  = DREAL(C0(IG,IS))
           IM  = DIMAG(C0(IG,IS))
           C1(IG    ,IS)  = DCMPLX(RE, IM)
           C1(IG+NGW,IS)  = DCMPLX(RE,-IM)
        ENDDO
      ENDDO

      if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)


      NGWK  = 2*NGW
      NGWKS = 2*NGWS

        IF(TEST) THEN
        DO IS = 1,NSTATE
          FILTR='ORB_in_'
          WRITE(NUMB,'(I8)') IS
          CALL XSTRING(NUMB,IA,IE)
          FILORB=FILTR(1:7)//NUMB(IA:IE)//'.dat'
          CALL FILEOPEN(17,FILORB,FO_DEF,FERROR)
           DO IG = NGWK,NGW,-1
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &        DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            IF(MOD .LT. 1.D-12) MOD = 1.D-12
            write(17,'(I8,2(2x,1PE12.5))') -IG+NGW,MOD,DLOG10(MOD)
           ENDDO
           DO IG = 1,NGW
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &        DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            IF(MOD .LT. 1.D-12) MOD = 1.D-12
            write(17,'(I8,2(2x,1PE12.5))') IG,MOD,DLOG10(MOD)
           ENDDO
           CALL FILECLOSE(17)
        ENDDO
        ENDIF

      IF(TGLOCPRINT) THEN 
C     print selected localized functions
        IL_PSI = KR1S*KR2S*KR3S
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
 
        CALL WFNZ_PRINT(1,1,C1,NSTATE,PSI,NSTATE)
        CALL FREEM(IP_PSI)
      ENDIF

      IF(TGLOCREALP) THEN 
C     print selected localized functions
        IL_PSI = 2*KR1*KR2S*KR3S
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
 
        CALL P_REAL_SPACE(1,1,C1,NSTATE,PSI,SCR,LSCR,NSTATE)
        CALL FREEM(IP_PSI)
      ENDIF


      IF(PARENT) THEN
         WRITE(6,'(/,1X,64(1H*))')
         WRITE(6,'(1X,A)') 
     &        'LOCALIZATION OF WAVEFUNCTION IN RECIPROCAL SPACE '
         IF(GLOC_TYPE .EQ. 1) THEN
           WRITE(6,'(A)')   
     &     '       FUNCTIONAL:  Sum_(n,i)[ <n|Gi^2|n> - <n|Gi|n>^2 ]'
         ELSEIF(GLOC_TYPE .EQ. 2) THEN
           WRITE(6,'(A)')   
     &     '       FUNCTIONAL:  Sum_(n,i)[1 - |<n| EXP(iGir_o) |n>|^2]'
         ENDIF
         IF(GLOC_OPT.EQ.1)
     *     WRITE(6,'(A)') 
     &     '       OPTIMISATION: U UPDATE BY STEEPEST DESCENT'
         IF(GLOC_OPT.EQ.2) 
     *        WRITE(6,'(A,/,A)') 
     &     '       OPTIMISATION: U NEAR TO 1, WFN UPDATE EACH STEP',
     &     '       SMALL ROTATIONS ASSUMED'
         IF(GLOC_CONST .EQ. 1) THEN
          WRITE(6,'(A,/,A,1PE10.3,A,I10)') 
     &      '       UNITARITY  BY LAGRANGIAN MULTIPLIERS',
     &      '       TOLERANCE = ',GEPSLAG,' MAX n ITERATION = ',
     &      GLOC_MAXIT
         ELSEIF(GLOC_CONST .EQ. 2) THEN
          WRITE(6,'(A)') 
     &      '       UNITARITY  BY ORTHOGONALIZATION [S^(-1/2)]'
         ELSEIF(GLOC_CONST .EQ. 3) THEN
          WRITE(6,'(A)') 
     &      '       UNITARITY  APPROXIMATION U = 1+iA (A HERMITIAN)'
         ENDIF
         IF(TG_LINESEARCH) THEN
            WRITE(6,'(/,A)') 
     &      '       TIME STEP TUNING BY SEARCH ALONG THE LINE'
         ENDIF 
         IF(TG_READ_MATRIX) THEN
            WRITE(6,'(/,A)') 
     &      '       FIRST UNITARY TRANSFORMATION READ FROM FILE'
         ENDIF
         IF(TGWANNIER) THEN
            WRITE(6,'(/A,A)') 
     &      '       THE SPREAD FUNCTIONAL IN REAL',
     &              ' SPACE IS ALSO CALCULATED'
            WRITE(6,'(A,f6.3/A,f6.3)') 
     &      '            optimization: W_GFUN = ',G2G_WEIGHT,
     &      '                        : W_RFUN = ',WAN_WEIGHT
           IF(GLOC_OPT.NE.1 .AND. GLOC_TYPE .NE. 2)
     *         CALL STOPGM('G_LOC_DR',
     &          'REAL SPACE LOC. ONLY WITH GLOC_OPT=1, GLOC_TYPE=2')
         ENDIF
         IF(TG_ANTISYMM) THEN
            WRITE(6,'(/,A,A)') 
     &      'PENALTY FUNCTION FOR SYMMETRIC WFN CALCULATED',
     &      '  FOR FIRST 100 STEPS'
           IF(TG_PENALTY) WRITE(6,'(A,/)') 
     &      '     PENALTY IMPOSED IN THE GRADIENT (ADDED TERM)'
         ENDIF
c         IF(TCGRAD) THEN
c            IF (GLOC_OPT.EQ.2) CALL STOPGM('G_LOC_DR_REAL',
c     &          'CONJUGATE GRADIENT and U ALMOST 1 NOT POSSIBLE')
c            WRITE(6,'(A)') '       CONJUGATE GRADIENT USED'
c         ENDIF

         WRITE(6,'(A,T56,1PE10.4)')
     *        '         CONVERGENCE CRITERIA:',GLOC_EPS
         WRITE(6,'(A,T56,I10)')
     *        '         MAXIMUM # OF STEPS:',GLOC_MAXS
         WRITE(6,'(A,T56,1PE10.4)')
     *        '         RANDOMIZATION AMPLITUDE:',GLOC_RAN
         WRITE(6,'(A,T56,1PE10.4)')
     *        '         STEP SIZE:',GLOC_STEP
         WRITE(6,'(A,T56,I10)')
     *        '         INITIAL STEP',GLOC_INIT+1
         IF(TGLOCPRINT) THEN
           WRITE(6,'(/,1x,A)') 
     &       'STARTING  AND OPTIMIZED WFN PRINTED IN SEPARETED FILES'
           IF(GLOC_ALL .EQ. 1) THEN
             WRITE(6,'(">>>>  all wfn printed  <<<")')
           ELSEIF(GLOC_FIRST .GT. 0) THEN
             WRITE(6,'(">>>> wfn from ",I5," to ",I6," printed  <<<<")')
           ELSE
             WRITE(6,'(">>>>  printed wfn list number = ",I6)') GLOC_ORB
           ENDIF
         ENDIF
      ENDIF

      GIFIRST = 1
      IKIND = 0
      WAN_MEM = WAN_WEIGHT
      G2G_MEM = G2G_WEIGHT

        FILTR='SPR_'
        WRITE(NUMB,'(I8)') IKIND
        CALL XSTRING(NUMB,IA,IE)
        FILSPR=FILTR(1:4)//NUMB(IA:IE)//'.dat'
        FILTR='CEN_'
        WRITE(NUMB,'(I8)') IKIND
        CALL XSTRING(NUMB,IA,IE)
        FILCEN=FILTR(1:4)//NUMB(IA:IE)//'.xyz'
        FILTR='PENALTY_'
        WRITE(NUMB,'(I8)') IKIND
        CALL XSTRING(NUMB,IA,IE)
        FILPEN=FILTR(1:8)//NUMB(IA:IE)//'.dat'
        FILTR='MATRIX_'
        WRITE(NUMB,'(I8)') IKIND
        CALL XSTRING(NUMB,IA,IE)
        FILMAT=FILTR(1:7)//NUMB(IA:IE)

        OVER_SUP = 0.0D0
        DO IS = 1,NSTATE
          DO IG = 1,NGWK
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &          DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            DO JS = IS+1,NSTATE
              MOD2= DREAL(C1(IG,JS))*DREAL(C1(IG,JS))+
     &          DIMAG(C1(IG,JS))*DIMAG(C1(IG,JS))
              OVER_SUP = OVER_SUP +  MOD*MOD2
            ENDDO
          ENDDO
        ENDDO
#ifdef PARALLEL
        CALL GLOSUM(1,OVER_SUP)
#endif
        IF(PARENT) 
     &  write(6,'(A,2(1PE12.4))') '   >>>>>>> INITIAL SUPPORT OVERLAP ',
     &        OVER_SUP,OVER_SUP*2.0D0/(NSTATE*(NSTATE-1))


        IF(TEST) THEN
C       TEST -----------------------
        CALL MEMORY(IP_ROTMAT,2*NSTATE*NSTATE,'ROTMAT')
        CALL R_MATRIX(ROTMAT,NSTATE)
        ZONE = DCMPLX(1.0D0,0.0D0)
        ZZERO = DCMPLX(0.0D0,0.0D0)
        CALL ROTATE_C(ZONE,C1,ZZERO,C2,ROTMAT,NSTATE)
        CALL DCOPY(2*2*NGW*NSTATE,C2,1,C1,1)
        if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)
        CALL SET_OPERATOR(.FALSE.)
        CALL MEMORY(IP_XYZMAT,2*NSTATE*NSTATE*NWANOPT,'XYZMAT')
        CALL MEMORY(IP_CENR,3*NSTATE,'CENR')
        CALL G_LOC_XYZMAT(C1,C2,XYZMAT,SCR,LSCR,NSTATE,TAU0)
        CALL WANNIER_CENTER(XYZMAT,NSTATE,NSTATE,SCR,TAU0)
        CONT1 = 1
        DO I = 1,NSTATE
          CENR(1,I) = SCR(CONT1)
          CENR(2,I) = SCR(CONT1+1)
          CENR(3,I) = SCR(CONT1+2)
          if(CENR(3,I) .LT. -0.5D0*A3(3)) CENR(3,I) = CENR(3,I) + A3(3)
          CONT1 = CONT1+4
c          write(6,'(I5,3(2x,f10.5))') I,CENR(1,I),CENR(2,I),CENR(3,I)
        ENDDO 
        CONT1 = 0
        CONT2 = 0
        DO I = 1,NSTATE
          IF(DABS(CENR(3,I)) .GT. 3.0D0) THEN
            CALL DCOPY(2*2*NGW,C1(1,I),1,C2(1,NSTATE-CONT2),1)
c            write(6,*) I , ' in ', NSTATE-CONT2,CENR(3,I)
            CONT2 = CONT2 + 1
          ELSE
            CONT1 = CONT1 + 1
            CALL DCOPY(2*2*NGW,C1(1,I),1,C2(1,CONT1),1)
c            write(6,*) I , ' in ', CONT1,CENR(3,I)
          ENDIF
        ENDDO
        write(6,*) CONT1,CONT2, CONT1+CONT2

        CALL AZZERO(C1,2*2*NGW*NSTATE)
        CALL DCOPY(2*2*NGW*NSTATE,C2(1,1),1,C1(1,1),1)
        CALL AZZERO(C2,2*2*NGW*NSTATE)


        CALL FREEM(IP_XYZMAT)
        CALL FREEM(IP_CENR)
        CALL FREEM(IP_ROTMAT)

c        STOP 'CENTERS'
        ENDIF
C       END TEST --------------------




      IF(GLOC_TYPE .EQ. 1)  THEN

        IF(GLOC_OPT .EQ. 1) THEN
          CALL G_LOC_SPREAD_SUM
     &                     (C1,C2,SCR,LSCR,NSTATE,NFI)
        ELSEIF(GLOC_OPT .EQ. 2) THEN
          CALL G_LOC_SPREAD_IDE
     &                     (C1,C2,SCR,LSCR,NSTATE,NFI)
        ELSE
          CALL STOPGM('G_OC_DR_REAL',
     &                     'OPTIMIZATION ALGORITHM NOT FOUND')
        ENDIF

      ELSEIF(GLOC_TYPE .EQ.2) THEN

        IF(GLOC_OPT .EQ. 1) THEN
         IF(TEST) THEN
           CALL G_LOC_EXP_SUM
     &                     (C1(1,1),C2,SCR,LSCR,NSTATE/2,NFI,TAU0)
         ELSE
           CALL G_LOC_EXP_SUM
     &                     (C1,C2,SCR,LSCR,NSTATE,NFI,TAU0)
         ENDIF
        ELSEIF(GLOC_OPT .EQ. 2) THEN
          CALL G_LOC_EXP_IDE
     &                     (C1,C2,SCR,LSCR,NSTATE,NFI)
        ELSE
          CALL STOPGM('G_OC_DR_REAL',
     &                     'OPTIMIZATION ALGORITHM NOT FOUND')
        ENDIF

      ENDIF

      IF(TGLOCPRINT) THEN 
C     print selected localized functions
        IL_PSI = KR1S*KR2S*KR3S
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
 
        CALL WFNZ_PRINT(2,1,C1,NSTATE,PSI,NSTATE)
        CALL FREEM(IP_PSI)
      ENDIF

      IF(TGLOCREALP) THEN 
C     print selected localized functions
        IL_PSI = 2*KR1*KR2S*KR3S
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
 
        CALL P_REAL_SPACE(2,1,C1,NSTATE,PSI,SCR,LSCR,NSTATE)
        CALL FREEM(IP_PSI)
      ENDIF

      IF(TEST) THEN
        DO IS = 1,NSTATE
          FILTR='ORB_fi_'
          WRITE(NUMB,'(I8)') IS
          CALL XSTRING(NUMB,IA,IE)
          FILORB=FILTR(1:7)//NUMB(IA:IE)//'.dat'
          CALL FILEOPEN(17,FILORB,FO_DEF,FERROR)
           DO IG = NGWK,NGW,-1
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &        DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            IF(MOD .LT. 1.D-12) MOD = 1.D-12
            write(17,'(I8,2(2x,1PE12.5))') -IG+NGW,MOD,DLOG10(MOD)
           ENDDO
           DO IG = 1,NGW
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &        DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            IF(MOD .LT. 1.D-12) MOD = 1.D-12
            write(17,'(I8,2(2x,1PE12.5))') IG,MOD,DLOG10(MOD)
           ENDDO
          CALL FILECLOSE(17)
        ENDDO

        OVER_SUP = 0.0D0
        DO IS = 1,NSTATE
          DO IG = 1,NGWK
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &          DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            DO JS = IS+1,NSTATE
              MOD2= DREAL(C1(IG,JS))*DREAL(C1(IG,JS))+
     &          DIMAG(C1(IG,JS))*DIMAG(C1(IG,JS))
              OVER_SUP = OVER_SUP +  MOD*MOD2
            ENDDO
          ENDDO
        ENDDO
#ifdef PARALLEL
        CALL GLOSUM(1,OVER_SUP)
#endif
        IF(PARENT)
     &   write(6,'(A,2(1PE12.4))') '   >>>>>>> FINAL SUPPORT OVERLAP ',
     &        OVER_SUP,OVER_SUP*2.0D0/(NSTATE*(NSTATE-1))
      ENDIF
c      stop
c      CALL WRITE_IREC(IREC)
c      IREC(10) = 0
c      CALL ZHWWF(2,IREC,C1,C2,NSTATE,EIGV,TAU0,TAUP,TAUP,NFI)

      CALL FREEM(IP_C1)

      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE G_LOC_DR_COMP(C0,C2,SCR,LSCR,NSTATE,EIGV,TAU0,TAUP,NFI)
C     ==--------------------------------------------------------------==
C     == PREPARE ENVIRONMENT FOR LOCALIZATION IN G SPACE              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'cnst.inc'
      include 'g_loc.inc'
      include 'spin.inc'
      include 'store.inc'
      include 'kpnt.inc'
      include 'kpts.inc'
      include 'cppt.inc'
      include 'irat.inc'
      include 'fileopen.inc'

C     input
      INTEGER    LSCR,NSTATE
      REAL*8     SCR(*)
      COMPLEX*16 C0(NGWK,NSTATE,NKPTS),C2(NGWK,NSTATE)
      REAL*8     EIGV(*),TAU0(*),TAUP(*),MOD,MOD2,OVER_SUP,FAC
      INTEGER    NFI
C     local
      COMPLEX*16 C1(2*NGW,NSTATE),PSI(*)
      POINTER    (IP_C1,C1),(IP_PSI,PSI)
      INTEGER    IS,IG,IL_PSI,IL_RHOE,IREC(100),IKIND
      INTEGER    MAPW(*),IP,NGWIP,MSGID,MSGLEN,IPW
      POINTER    (IP_MAPW,MAPW)
      CHARACTER  FILTR*15,NUMB*8,FILORB*15
      INTEGER    IA,IE,JS,NSTATE_LOC,ICONT,ISTATE,LEN1,NBYTES
      DIMENSION  RK(3,NKPTS),IND_ST(*),IST_LIST(NST_LIST)
      LOGICAL    TGRID,FERROR
C     ==--------------------------------------------------------------==

#ifdef PARALLEL
          LEN1=2*NGW/IRAT + 1
          CALL MEMORY(IP_MAPW,LEN1,'MAPW')
#else
C         Not used.
          IP_MAPW=0
#endif


      IF(STATE_ALL) THEN
        NSTATE_LOC = NSTATE
      ELSEIF(STATE_RANGE) THEN
        IF(IST_LAST .GT. NSTATE) CALL STOPGM('G_LOC_DR',
     &               'WRONG STATES  RANGE, IST_LAST > NSTATE')
        NSTATE_LOC = IST_LAST - IST_FIRST + 1
        CALL MEMORY(IP_IND_ST,NSTATE_LOC/IRAT+1,'IND_ST')
        ICONT = 0
        DO ISTATE =  IST_FIRST,IST_LAST
          ICONT = ICONT + 1
          IND_ST(ICONT) = ISTATE
        ENDDO
      ELSE
        NSTATE_LOC = NST_LIST
        IF(NST_LIST .GT. NSTATE) CALL STOPGM('G_LOC_DR',
     &               'TOO MANY STATES, NST_LIST > NSTATE')
        CALL MEMORY(IP_IND_ST,NSTATE_LOC/IRAT+1,'IND_ST')
        DO ISTATE =  1,NST_LIST
          IF(IST_LIST(ISTATE) .GT. NSTATE) CALL STOPGM('G_LOC_DR',
     &               'WRONG STATES INDEX IN THE LIST')
          IND_ST(ISTATE) = IST_LIST(ISTATE)
        ENDDO
      ENDIF

      CALL MEMORY(IP_C1,2*2*NGW*NSTATE_LOC,'C1')
      CALL AZZERO(C1,2*2*NGW*NSTATE_LOC)


      IF(PARENT) THEN
         WRITE(6,'(/,1X,64(1H*))')
         WRITE(6,'(1X,A)') 
     &        'LOCALIZATION OF WAVEFUNCTION IN RECIPROCAL SPACE '
         IF(GLOC_TYPE .EQ. 1) THEN
           WRITE(6,'(A)')   
     &     '       FUNCTIONAL:  Sum_(n,i)[ <n|Gi^2|n> - <n|Gi|n>^2 ]'
         ELSEIF(GLOC_TYPE .EQ. 2) THEN
           WRITE(6,'(A)')   
     &     '       FUNCTIONAL:  Sum_(n,i)[1 - |<n| EXP(iGir_o) |n>|^2]'
         ENDIF
         IF(GLOC_OPT.EQ.1)
     *     WRITE(6,'(A)') 
     &     '       OPTIMISATION: U UPDATE BY STEEPEST DESCENT'
         IF(GLOC_OPT.EQ.2) 
     *        WRITE(6,'(A,/,A)') 
     &     '       OPTIMISATION: U NEAR TO 1, WFN UPDATE EACH STEP',
     &     '       SMALL ROTATIONS ASSUMED'
         IF(GLOC_CONST .EQ. 1) THEN
          WRITE(6,'(A,/,A,1PE10.3,A,I10)') 
     &      '       UNITARITY  BY LAGRANGIAN MULTIPLIERS',
     &      '       TOLERANCE = ',GEPSLAG,' MAX n ITERATION = ',
     &      GLOC_MAXIT
         ELSEIF(GLOC_CONST .EQ. 2) THEN
          WRITE(6,'(A)') 
     &      '       UNITARITY  BY ORTHOGONALIZATION [S^(-1/2)]'
         ELSEIF(GLOC_CONST .EQ. 3) THEN
          WRITE(6,'(A)') 
     &      '       UNITARITY  APPROXIMATION U = 1+iA (A HERMITIAN)'
         ENDIF
         IF(TG_LINESEARCH) THEN
            WRITE(6,'(/,A)') 
     &      '       TIME STEP TUNING BY SEARCH ALONG THE LINE'
         ENDIF 
         IF(STATE_ALL) THEN
            WRITE(6,'(/,A,I8)') 
     &      '       ALL THE STATES ARE CONSIDERED, NSTATE = ',NSTATE
         ELSEIF(STATE_RANGE) THEN
            WRITE(6,'(/,A,I8,A,I8,A,I8)') 
     &      '      ONLY STATES BETWEEN ',IST_FIRST,' AND ',IST_LAST,
     &      ' ARE CONSIDERED, NSTATE = ',IST_LAST - IST_FIRST + 1
         ELSEIF(STATE_LIST) THEN
            WRITE(6,'(/A)') 
     &      '      ONLY THE FOLLOWING STATES ARE CONSIDERED: '
            WRITE(6,*) (IST_LIST(ISTATE),ISTATE = 1,NST_LIST)
         ENDIF

         IF(TG_READ_MATRIX) THEN
            WRITE(6,'(/,A)') 
     &      '       FIRST UNITARY TRANSFORMATION READ FROM FILE'
         ENDIF
         IF(TGWANNIER) THEN
            WRITE(6,'(/A,A)') 
     &      '       THE SPREAD FUNCTIONAL IN REAL',
     &              ' SPACE IS ALSO CALCULATED'
            WRITE(6,'(A,f6.3/A,f6.3)') 
     &      '            optimization: W_GFUN = ',G2G_WEIGHT,
     &      '                        : W_RFUN = ',WAN_WEIGHT
           IF(GLOC_OPT.NE.1 .AND. GLOC_TYPE .NE. 2)
     *         CALL STOPGM('G_LOC_DR',
     &          'REAL SPACE LOC. ONLY WITH GLOC_OPT=1, GLOC_TYPE=2')
         ENDIF
         IF(TG_ANTISYMM) THEN
            WRITE(6,'(/,A,A)') 
     &      'PENALTY FUNCTION FOR SYMMETRIC WFN CALCULATED',
     &      '  FOR FIRST 100 STEPS'
           IF(TG_PENALTY) WRITE(6,'(A,/)') 
     &      '     PENALTY IMPOSED IN THE GRADIENT (ADDED TERM)'
         ENDIF
c         IF(TCGRAD) THEN
c            IF (GLOC_OPT.EQ.2) CALL STOPGM('G_LOC_DR_REAL',
c     &          'CONJUGATE GRADIENT and U ALMOST 1 NOT POSSIBLE')
c            WRITE(6,'(A)') '       CONJUGATE GRADIENT USED'
c         ENDIF

         WRITE(6,'(A,T56,1PE10.4)')
     *        '         CONVERGENCE CRITERIA:',GLOC_EPS
         WRITE(6,'(A,T56,I10)')
     *        '         MAXIMUM # OF STEPS:',GLOC_MAXS
         WRITE(6,'(A,T56,1PE10.4)')
     *        '         RANDOMIZATION AMPLITUDE:',GLOC_RAN
         WRITE(6,'(A,T56,1PE10.4)')
     *        '         STEP SIZE:',GLOC_STEP
         WRITE(6,'(A,T56,I10)')
     *        '         INITIAL STEP',GLOC_INIT+1
         IF(TGLOCPRINT) THEN
           WRITE(6,'(/,1x,A)') 
     &       'STARTING  AND OPTIMIZED WFN PRINTED IN SEPARETED FILES'
           IF(GLOC_ALL .EQ. 1) THEN
             WRITE(6,'(">>>>  all wfn printed  <<<")')
           ELSEIF(GLOC_FIRST .GT. 0) THEN
             WRITE(6,'(">>>> wfn from ",I5," to ",I6," printed  <<<<")')
           ELSE
             WRITE(6,'(">>>>  printed wfn list number = ",I6)') GLOC_ORB
           ENDIF
         ENDIF
      ENDIF

      WAN_MEM = WAN_WEIGHT
      G2G_MEM = G2G_WEIGHT


c      NSTATE = NSTATE - 6
      
      DO IKIND = 1,NKPTS

        IF(TKPNT)THEN
          SHIFTKX = RK(1,IKIND)
          SHIFTKY = RK(1,IKIND)
          SHIFTKZ = RK(1,IKIND)
        ELSE
          SHIFTKX = 0.0D0
          SHIFTKY = 0.0D0
          SHIFTKZ = 0.0D0
        ENDIF

        IF(STATE_ALL) THEN
          CALL DCOPY(4*NGW*NSTATE_LOC,C0(1,1,IKIND),1,C1,1)
        ELSEIF(STATE_RANGE) THEN
          CALL DCOPY(4*NGW*NSTATE_LOC,C0(1,IST_FIRST,IKIND),1,C1,1)
        ELSE
          DO ISTATE = 1,NSTATE_LOC
            CALL DCOPY(4*NGW,C0(1,IND_ST(ISTATE),IKIND),1,
     &                 C1(1,ISTATE),1)
          ENDDO
        ENDIF

        GIFIRST = 1

        FILTR='SPR_K'
        WRITE(NUMB,'(I8)') IKIND
        CALL XSTRING(NUMB,IA,IE)
        FILSPR=FILTR(1:5)//NUMB(IA:IE)//'.dat'
        FILTR='CEN_K'
        WRITE(NUMB,'(I8)') IKIND
        CALL XSTRING(NUMB,IA,IE)
        FILCEN=FILTR(1:5)//NUMB(IA:IE)//'.xyz'
        FILTR='PENALTY_K'
        WRITE(NUMB,'(I8)') IKIND
        CALL XSTRING(NUMB,IA,IE)
        FILPEN=FILTR(1:9)//NUMB(IA:IE)//'.dat'
        FILTR='MATRIX_K'
        WRITE(NUMB,'(I8)') IKIND
        CALL XSTRING(NUMB,IA,IE)
        FILMAT=FILTR(1:8)//NUMB(IA:IE)

        IF(TGLOCPRINT) THEN 
C       print selected localized functions
          IL_PSI = KR1S*KR2S*KR3S
          CALL MEMORY(IP_PSI,IL_PSI,'PSI')
 
          CALL WFNZ_PRINT(1,IKIND,C0(1,1,IKIND),NSTATE,PSI,NSTATE_LOC)
          CALL FREEM(IP_PSI)
        ENDIF

        IF(TGLOCREALP) THEN 
C     print selected localized functions
          IL_PSI = 2*KR1*KR2S*KR3S
          CALL MEMORY(IP_PSI,IL_PSI,'PSI')
 
          CALL P_REAL_SPACE(1,IKIND,C0(1,1,IKIND),NSTATE,PSI,
     &                      SCR,LSCR,NSTATE_LOC)
          CALL FREEM(IP_PSI)
        ENDIF

        TORBDIST = .FALSE.
        TGRID    = .true. 

        IF(IKIND .EQ. 1 .AND. TORBDIST) THEN
        DO IS = 1,NSTATE_LOC
          FILTR='ORB_in_'
          WRITE(NUMB,'(I8)') IS
          CALL XSTRING(NUMB,IA,IE)
          FILORB=FILTR(1:7)//NUMB(IA:IE)//'.dat'
          IF(PARENT) CALL FILEOPEN(17,FILORB,FO_DEF,FERROR)
#ifdef  PARALLEL
          IL_PSI = 2*KR1*KR2S*KR3S
          CALL MEMORY(IP_PSI,IL_PSI,'PSI')
          DO IP=0,NPROC-1
            IF(PARENT) THEN
              IF(PGROUP(IP+1).EQ.ME) THEN
                DO IG=1,NGW
                  C2(IG,IS)=C1(IG,IS)
                  MAPW(IG)=MAPGP(IG)
                ENDDO
                DO IG=NGW+1,2*NGW
                  C2(IG,IS)=C1(IG,IS)
                ENDDO
              ELSE
                MSGID=1
                MSGLEN = 2 * 2 * SPARM(3,IP) * 8
                CALL MY_BRECV(C2(1,IS),MSGLEN,PGROUP(IP+1),MSGID,NBYTES)
                MSGID=2
                MSGLEN = SPARM(3,IP) * 8/IRAT
                CALL MY_BRECV(MAPW,MSGLEN,PGROUP(IP+1),MSGID,NBYTES)
              ENDIF
              DO IPW=1,SPARM(3,IP)
                PSI(MAPW(IPW))=C2(IPW,IS)
              ENDDO
              NGWIP=SPARM(3,IP)
              DO IPW=1,NGWIP
                PSI(MAPW(IPW)+NGWS)=C2(NGWIP+IPW,IS)
              ENDDO
            ELSE
              IF(PGROUP(IP+1).EQ.ME) THEN
                MSGID=1
                MSGLEN = 2 * 2 * NGW * 8
                CALL MY_BSEND(C1(1,IS),MSGLEN,PGROUP(1),MSGID)
                MSGID=2
                MSGLEN = NGW * 8/IRAT
                CALL MY_BSEND(MAPGP,MSGLEN,PGROUP(1),MSGID)
              ENDIF
            ENDIF
          ENDDO

          IF(PARENT) THEN
           DO IG = NGWKS,NGWS,-1
            MOD = DREAL(PSI(IG))*DREAL(PSI(IG))+
     &        DIMAG(PSI(IG))*DIMAG(PSI(IG))
            IF(MOD .LT. 1.D-12) MOD = 1.D-12
            write(17,'(I8,2(2x,1PE12.5))') -IG+NGWS,MOD,DLOG10(MOD)
           ENDDO
          ENDIF
          CALL FREEM(IP_PSI)
#else
           DO IG = NGWK,NGW,-1
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &        DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            IF(MOD .LT. 1.D-12) MOD = 1.D-12
            write(17,'(I8,2(2x,1PE12.5))') -IG+NGW,MOD,DLOG10(MOD)
           ENDDO
           DO IG = 1,NGW
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &        DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            IF(MOD .LT. 1.D-12) MOD = 1.D-12
            write(17,'(I8,2(2x,1PE12.5))') IG,MOD,DLOG10(MOD)
           ENDDO
#endif
          IF(PARENT) CALL FILECLOSE(17)
        ENDDO

        ENDIF

        OVER_SUP = 0.0D0
        DO IS = 1,NSTATE_LOC
          DO IG = 1,NGWK
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &          DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            DO JS = IS+1,NSTATE_LOC
              MOD2= DREAL(C1(IG,JS))*DREAL(C1(IG,JS))+
     &          DIMAG(C1(IG,JS))*DIMAG(C1(IG,JS))
              OVER_SUP = OVER_SUP +  MOD*MOD2
            ENDDO
          ENDDO
        ENDDO
#ifdef PARALLEL
        CALL GLOSUM(1,OVER_SUP)
#endif
        IF(PARENT) 
     &  write(6,'(A,2(1PE12.4))') '   >>>>>>> INITIAL SUPPORT OVERLAP ',
     &        OVER_SUP,OVER_SUP*2.0D0/(NSTATE_LOC*(NSTATE_LOC-1))




        IF(GLOC_TYPE .EQ. 1)  THEN

          IF(GLOC_OPT .EQ. 1) THEN
            CALL G_LOC_SPREAD_SUM
     &                     (C1,C2,SCR,LSCR,NSTATE_LOC,NFI)
          ELSEIF(GLOC_OPT .EQ. 2) THEN
            CALL G_LOC_SPREAD_IDE
     &                     (C1,C2,SCR,LSCR,NSTATE_LOC,NFI)
          ELSE
            CALL STOPGM('G_OC_DR_REAL',
     &                     'OPTIMIZATION ALGORITHM NOT FOUND')
          ENDIF

        ELSEIF(GLOC_TYPE .EQ.2) THEN

          IF(GLOC_OPT .EQ. 1) THEN
            CALL G_LOC_EXP_SUM
     &                     (C1,C2,SCR,LSCR,NSTATE_LOC,NFI,TAU0)
          ELSEIF(GLOC_OPT .EQ. 2) THEN
            CALL G_LOC_EXP_IDE
     &                     (C1,C2,SCR,LSCR,NSTATE_LOC,NFI)
          ELSE
            CALL STOPGM('G_OC_DR_REAL',
     &                     'OPTIMIZATION ALGORITHM NOT FOUND')
          ENDIF

        ENDIF

        IF(STATE_ALL) THEN
          CALL DCOPY(4*NGW*NSTATE_LOC,C1,1,C0(1,1,IKIND),1)
        ELSEIF(STATE_RANGE) THEN
          CALL DCOPY(4*NGW*NSTATE_LOC,C1,1,C0(1,IST_FIRST,IKIND),1)
        ELSE
          DO ISTATE = 1,NSTATE_LOC
            CALL DCOPY(4*NGW,C1(1,ISTATE),1,
     &                 C0(1,IND_ST(ISTATE),IKIND),1)
          ENDDO
        ENDIF


        IF(TGLOCPRINT) THEN 
C     print selected localized functions
          IL_PSI = KR1S*KR2S*KR3S
          CALL MEMORY(IP_PSI,IL_PSI,'PSI')
 
          CALL WFNZ_PRINT(2,IKIND,C0(1,1,IKIND),NSTATE,PSI,NSTATE_LOC)
          CALL FREEM(IP_PSI)
        ENDIF

        IF(TGLOCREALP) THEN 
C     print selected localized functions
          IL_PSI = 2*KR1*KR2S*KR3S
          CALL MEMORY(IP_PSI,IL_PSI,'PSI')
  
          CALL P_REAL_SPACE(2,IKIND,C0(1,1,IKIND),NSTATE,PSI,
     &                      SCR,LSCR,NSTATE_LOC)
          CALL FREEM(IP_PSI)
        ENDIF


        IF(IKIND .EQ. 1) THEN
        DO IS = 1,NSTATE_LOC

          TORBDIST = .false.
          IF( TORBDIST) THEN
          FILTR='ORB_fi_'
          WRITE(NUMB,'(I8)') IS
          CALL XSTRING(NUMB,IA,IE)
          FILORB=FILTR(1:7)//NUMB(IA:IE)//'.dat'
          IF(PARENT) CALL FILEOPEN(17,FILORB,FO_DEF,FERROR)
#ifdef  PARALLEL
          IL_PSI = 2*2*NGWS
          CALL MEMORY(IP_PSI,IL_PSI,'PSI')
          DO IP=0,NPROC-1
            IF(PARENT) THEN
              IF(PGROUP(IP+1).EQ.ME) THEN
                DO IG=1,NGW
                  C2(IG,IS)=C1(IG,IS)
                  MAPW(IG)=MAPGP(IG)
                ENDDO
                DO IG=NGW+1,NGWK
                  C2(IG,IS)=C1(IG,IS)
                ENDDO
              ELSE
                MSGID=1
                MSGLEN = 2 * 2 * SPARM(3,IP) * 8
                CALL MY_BRECV(C2(1,IS),MSGLEN,PGROUP(IP+1),MSGID,NBYTES)
                MSGID=2
                MSGLEN = SPARM(3,IP) * 8/IRAT
                CALL MY_BRECV(MAPW,MSGLEN,PGROUP(IP+1),MSGID,NBYTES)
              ENDIF
              DO IPW=1,SPARM(3,IP)
                PSI(MAPW(IPW))=C2(IPW,IS)
              ENDDO
              NGWIP=SPARM(3,IP)
              DO IPW=1,NGWIP
                PSI(MAPW(IPW)+NGWS)=C2(NGWIP+IPW,IS)
              ENDDO
            ELSE
              IF(PGROUP(IP+1).EQ.ME) THEN
                MSGID=1
                MSGLEN = 2 * 2 * NGW * 8
                CALL MY_BSEND(C1(1,IS),MSGLEN,PGROUP(1),MSGID)
                MSGID=2
                MSGLEN = NGW * 8/IRAT
                CALL MY_BSEND(MAPGP,MSGLEN,PGROUP(1),MSGID)
              ENDIF
            ENDIF
          ENDDO
          IF(PARENT) THEN
            DO IG = NGWKS,NGWS,-1
            MOD = DREAL(PSI(IG))*DREAL(PSI(IG))+
     &        DIMAG(PSI(IG))*DIMAG(PSI(IG))
              IF(MOD .LT. 1.D-12) MOD = 1.D-12
              write(17,'(I8,2(2x,1PE12.5))') -IG+NGWS,MOD,DLOG10(MOD)
            ENDDO
            DO IG = 1,NGWS
              MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &          DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
              IF(MOD .LT. 1.D-12) MOD = 1.D-12
              write(17,'(I8,2(2x,1PE12.5))') IG,MOD,DLOG10(MOD)
            ENDDO
          ENDIF
          CALL FREEM(IP_PSI)
#else

          DO IG = NGWK,NGW,-1
          MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &        DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
           IF(MOD .LT. 1.D-12) MOD = 1.D-12
           write(17,'(I8,2(2x,1PE12.5))') -IG+NGW,MOD,DLOG10(MOD)
          ENDDO
          DO IG = 1,NGW
           MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &        DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
           IF(MOD .LT. 1.D-12) MOD = 1.D-12
           write(17,'(I8,2(2x,1PE12.5))') IG,MOD,DLOG10(MOD)
          ENDDO
#endif
          IF(PARENT) CALL FILECLOSE(17)
          ENDIF             !TORBDIST

          IF(TGRID) THEN
          FILTR='GRID_fi_'
          WRITE(NUMB,'(I8)') IS
          CALL XSTRING(NUMB,IA,IE)
          FILORB=FILTR(1:8)//NUMB(IA:IE)//'.xyz'
          IF(PARENT) CALL FILEOPEN(17,FILORB,FO_DEF,FERROR)
          FAC = TPIBA * FBOHR
#ifdef  PARALLEL
          DO IP = 0,NPROC-1
            IF(PGROUP(IP+1).EQ.ME) THEN
              DO IG = NGWK,NGW,-1
                MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &            DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
                IF(MOD .GT. 0.5D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 
     &                   'N',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.1D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 
     &                   'O',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.01D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)')
     &                   'F',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.005D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 
     &                   'C',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.001D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)')
     &                   'P',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.0005D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 
     &                   'Fe',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.0001D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)')
     &                   'Ni',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
c                ELSEIF(MOD .GT. 0.00001D0) THEN
c                  write(17,'(A,3f12.5,I10,1PE12.5)')
c     &                   'Co',-GK(1,IG-NGW)*FAC,
c     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
c                ELSEIF(MOD .GT. 0.000001D0) THEN
c                  write(17,'(A,3f12.5,I10,1PE12.5)')
c     &                   'He',-GK(1,IG-NGW)*FAC,
c     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
                ENDIF
              ENDDO
              DO IG = 1,NGW
                MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &             DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
                IF(MOD .GT. 0.5D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 'N',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.1D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 'O',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.01D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 'F',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.005D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 'C',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.001D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 'P',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.0005D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 'Fe',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
                ELSEIF(MOD .GT. 0.0001D0) THEN
                  write(17,'(A,3f12.5,I10,1PE12.5)') 'Ni',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
c                ELSEIF(MOD .GT. 0.00001D0) THEN
c                  write(17,'(A,3f12.5,I10,1PE12.5)') 'Co',GK(1,IG)*FAC,
c     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
c                ELSEIF(MOD .GT. 0.000001D0) THEN
c                  write(17,'(A,3f12.5,I10,1PE12.5)') 'He',GK(1,IG)*FAC,
c     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
                ENDIF
              ENDDO
            ENDIF
            CALL MY_SYNC(ALLGRP)
          ENDDO
#else
          DO IG = NGWK,NGW,-1
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &            DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            IF(MOD .GT. 0.5D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)') 
     &                   'N',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.1D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)') 
     &                   'O',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.01D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)')
     &                   'F',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.005D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)')
     &                   'C',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.001D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)')
     &                   'P',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.0005D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)')
     &                   'Fe',-GK(1,IG-NGW)*FAC,
     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.0001D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)')
     &                  'Ni',-GK(1,IG-NGW)*FAC,
     &                -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
c            ELSEIF(MOD .GT. 0.00001D0) THEN
c              write(17,'(A,3f12.5,I10,1PE12.5)')
c     &                   'Co',-GK(1,IG-NGW)*FAC,
c     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
c            ELSEIF(MOD .GT. 0.000001D0) THEN
c              write(17,'(A,3f12.5,I10,1PE12.5)')
c     &                   'He',-GK(1,IG-NGW)*FAC,
c     &                 -GK(2,IG-NGW)*FAC,-GK(3,IG-NGW)*FAC,IG,MOD
            ENDIF
          ENDDO
          DO IG = 1,NGW
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &             DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            IF(MOD .GT. 0.5D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)') 'N',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.1D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)') 'O',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.01D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)') 'F',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.005D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)') 'C',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.001D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)') 'P',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.0005D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)') 'Fe',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
            ELSEIF(MOD .GT. 0.0001D0) THEN
              write(17,'(A,3f12.5,I10,1PE12.5)') 'Ni',GK(1,IG)*FAC,
     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
c            ELSEIF(MOD .GT. 0.00001D0) THEN
c              write(17,'(A,3f12.5,I10,1PE12.5)') 'Co',GK(1,IG)*FAC,
c     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
c            ELSEIF(MOD .GT. 0.000001D0) THEN
c               write(17,'(A,3f12.5,I10,1PE12.5)') 'He',GK(1,IG)*FAC,
c     &                              GK(2,IG)*FAC,GK(3,IG)*FAC,IG,MOD
            ENDIF
          ENDDO
#endif
          IF(PARENT) CALL FILECLOSE(17)
          ENDIF           !TGRID
         ENDDO
       ENDIF

        OVER_SUP = 0.0D0
        DO IS = 1,NSTATE_LOC
          DO IG = 1,NGWK
            MOD = DREAL(C1(IG,IS))*DREAL(C1(IG,IS))+
     &          DIMAG(C1(IG,IS))*DIMAG(C1(IG,IS))
            DO JS = IS+1,NSTATE_LOC
              MOD2= DREAL(C1(IG,JS))*DREAL(C1(IG,JS))+
     &          DIMAG(C1(IG,JS))*DIMAG(C1(IG,JS))
              OVER_SUP = OVER_SUP +  MOD*MOD2
            ENDDO
          ENDDO
        ENDDO
#ifdef PARALLEL
        CALL GLOSUM(1,OVER_SUP)
#endif
        IF(PARENT) 
     &  write(6,'(A,2(1PE12.4))') '   >>>>>>> FINAL SUPPORT OVERLAP ',
     &        OVER_SUP,OVER_SUP*2.0D0/(NSTATE_LOC*(NSTATE_LOC-1))


      ENDDO

      CALL WRITE_IREC(IREC)
      IREC(10) = 0
      CALL ZHWWF(2,IREC,C0,C2,NSTATE,EIGV,TAU0,TAUP,TAUP,NFI)

      CALL FREEM(IP_C1)

      RETURN
      END

C     ==================================================================
C     ==================================================================



