C     ==================================================================
      SUBROUTINE G_LOC_EXP_IDE(C1,C2,SCR,LSCR,NSTATE,NFI)
C     ==--------------------------------------------------------------==
C     == CALCULATES LOCALIZED FUNCTIONS IN G SPACE                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'geq0.inc'
      include 'ions.inc'
      include 'cnst.inc'
      include 'ddip.inc'
      include 'gvec.inc'
      include 'irat.inc'
      include 'rmas.inc'
      include 'g_loc.inc'
      include 'spin.inc'
      include 'cppt.inc'
      include 'fileopen.inc'

C     input
      INTEGER    LSCR,NSTATE,NFI
      REAL*8     SCR(*)
      COMPLEX*16 C1(NGWK,*),C2(NGWK,NSTATE)

C     local
      INTEGER      IP1,IP2,I,J,ISUB,LSCR2,LSCR3
      INTEGER      IX1,IX2,IXL,MSGLEN,LENGTH
      INTEGER      IREP,MAXREP
      CHARACTER*30 TAG
      REAL*8       FAC,XRANF
      EXTERNAL     XRANF
      COMPLEX*16   GMAT(NSTATE,NSTATE)
      POINTER      (IP_GMAT,GMAT)

C     ==--------------------------------------------------------------==
C..   Localized orbitals functions
      COMPLEX*16   Z_MAT(NSTATE,NSTATE,3),U_GRAD(NSTATE,NSTATE)
      COMPLEX*16   ROTMAT(NSTATE,NSTATE),ROTLSD(*)
      COMPLEX*16   XYZMAT(*)
      POINTER      (IP_Z_MAT,Z_MAT),(IP_ROTMAT,ROTMAT),
     &             (IP_ROTLSD,ROTLSD),(IP_U_GRAD,U_GRAD),
     &             (IP_XYZMAT,XYZMAT)
      SAVE         IP_Z_MAT,IP_ROTMAT,IP_ROTLSD
      INTEGER      L_LAG_MUL
      LOGICAL      EXSOFT,FERROR
C     ==--------------------------------------------------------------==

      L_LAG_MUL  = 2*NSTATE*NSTATE
      CALL MEMORY(IP_LAG_MUL,L_LAG_MUL,'LAG_MUL')
      CALL AZZERO(LAG_MUL,L_LAG_MUL)

      IF(TG_ANTISYMM)  THEN
        CALL MEMORY(IP_OMEGA_N,NSTATE,'OMEGA_N')
        CALL AZZERO(OMEGA_N,NSTATE)
      ENDIF

      CALL TISET('G_LOC_EX_I',ISUB)
      CALL GIVE_SCR_G_LOC_EXP(LENGTH,TAG,NSTATE)
      CALL TEST_SCR('G_LOC_EXP_IDE','LENGTH',LSCR,LENGTH)

      GMAX = 0.0D0

      MAXREP = GLOC_MAXS
      NSTEP  = GLOC_INIT

C..   initialization for localized function part

      CALL MEMORY(IP_Z_MAT,2*NSTATE*NSTATE*3,'Z_MAT')
      CALL MEMORY(IP_ROTMAT,2*NSTATE*NSTATE,'ROTMAT')
C WARNING this is just a guess
      CALL MEMORY(IP_XYZMAT,2*NSTATE*NSTATE*3,'XYZMAT')
CWARNING


       IF(PARENT) THEN
        CALL FILEOPEN(14,FILCEN,FO_DEF,FERROR)
        FAC = TPIBA * FBOHR
        DO i = 1,2*NSTATE
          write(14,'(A,3f12.5,I10)') 'H',GK(1,I)*FAC,GK(2,I)*FAC,
     &                              GK(3,I)*FAC,I
          write(14,'(A,3f12.5,I10)') 'H',-GK(1,I)*FAC,-GK(2,I)*FAC,
     &                              -GK(3,I)*FAC,I+NGW
        ENDDO
       ENDIF

      IF(TG_READ_MATRIX)  THEN
        IF(PARENT) CALL R_MATRIX(ROTMAT,NSTATE)
        MSGLEN=2*NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
C     rotate the wavefunctions to the localized representation

        CALL ROTATE_C((1.D0,0.0D0),C1,(0.D0,0.0D0),C2,ROTMAT,NSTATE)
        CALL DCOPY(2*2*NGW*NSTATE,C2,1,C1,1)
        if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)
      ENDIF

c     CALL PLANE_WAVES_SHELL(C1,NSTATE)

      IX1 = 1
      IX2 = IX1 + 6*NSTATE
      CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
      IF(PARENT) WRITE(6,
     *     ' (/,5x,A,/)')
     *     '_______CENTERS AND SPREAD BEFORE THE OPTIMIZATION_______'
      IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,0)


      IF(TG_KICK) THEN

        CALL UNITARY_TRANS(C1,C2,NSTATE,SCR,LSCR)
        IF(PARENT) WRITE(6,'(/,A)') '     FIRST RANDOM ROTATION    '
C     calculate the centers and spread of the wannier functions
        IX1 = 1
        IX2 = IX1 + 6*NSTATE
        CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
        IF(PARENT) WRITE(6,
     *     ' (/,5x,A,/)')
     *     '_____ CENTERS AND SPREAD AFTER FIRST RANDOM ROTATION _____'
        IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,0)
      ENDIF

      IX1 = 1
      IXL = 2*NSTATE*NSTATE 
      IX2 = IXL + 1
      CALL GET_ADDR(IP_U_GRAD,SCR(IX1))
      LSCR2 = LSCR - IXL

C     HERE THE LOOPS START:
C     at each step Z_MAT is calculated, then the functional is estimated
C
C     The ROTMAT matrix is assumed as the identical matrix 
C
C     The gradient of the functional U_GRAD is calculated assuming a small
C     perturbation of ROTMAT with respect to the identical matrix
C     U_GRADij = Z_MATij * DCONJG(Z_MATjj) + DCONJG(Z_MATij) * Z_MATjj 
C
C     the ROTMAT is updated mantaining the unitary condition 
C        - strict condition provided by Lagrange multipliers
C        - not so strict condition if ROTMAT = 1 + iA 
C          where A is the self adjoint matrix built in terms of U_GRAD
C      Aij =0.5(R(U_GRADij) + i I(U_GRADij) - R(U_GRADji) + i I(U_GRADji)) 


      IF(PARENT) THEN
         CALL FILEOPEN(10,FILSPR,FO_DEF,FERROR)
         CALL FILEOPEN(11,'umat.dat',FO_DEF,FERROR)
         IF(TG_ANTISYMM) CALL FILEOPEN(12,FILPEN,FO_DEF,FERROR)
c     initialize U = ROTMAT matrix
         CALL AZZERO(ROTMAT,2*NSTATE*NSTATE)
         DO I=1,NSTATE
            ROTMAT(I,I)=DCMPLX(1.D0,0.0D0)
         ENDDO
         CALL GET_ADDR(IP_GMAT,SCR(IX2))
         CALL AZZERO(GMAT,2*NSTATE*NSTATE)
         IF(GLOC_RAN.GT.0.D0) THEN
C..   randomly distort initial vectors
            DO I=1,NSTATE
               GMAT(I,I)=DCMPLX(1.0D0,0.D0)
               DO J=I+1,NSTATE
                  GMAT(I,J)=DCMPLX(XRANF()*GLOC_RAN,XRANF()*GLOC_RAN)
                  GMAT(J,I)=DCONJG(GMAT(I,J))
               ENDDO
            ENDDO
            CALL ZEXPONENTIATE(GMAT,ROTMAT,NSTATE,SCR(IX2),LSCR2)
            GLOC_RAN=0.D0
         ENDIF
      ENDIF
c     DO I = 1,NSTATE
c     write(6,'(I3,8(2f8.4))') I,(ROTMAT(I,J),J=1,8)
c     ENDDO

C..   calculation of 3 matrices :  <n |O_i| m>
C     where n and m address the electronic orbitals and i = x,y,z

      IP1=IX2
      IP2=IP1+2*NSTATE*NSTATE
      LSCR3=LSCR2-2*NSTATE*NSTATE
      IF(LSCR2.LT.1) 
     &        CALL STOPGM('G_LOC_EXP_IDE','NOT ENOUGH SCRATCH SPACE')
      CALL ZNUM_MAT(C1,C2,NSTATE,SCR(IP1),SCR(IP2),LSCR3,1)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,Z_MAT(1,1,1),1)

      CALL ZNUM_MAT(C1,C2,NSTATE,SCR(IP1),SCR(IP2),LSCR3,2)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,Z_MAT(1,1,2),1)

      CALL ZNUM_MAT(C1,C2,NSTATE,SCR(IP1),SCR(IP2),LSCR3,3)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,Z_MAT(1,1,3),1)
         
#ifdef PARALLEL
        CALL MY_SYNC(ALLGRP)
#endif

      IF(PARENT) THEN
        CALL GZFUNC(Z_MAT,NSTATE,NSTATE) 
        write(6,'(/,A,F12.6)') 'STARTING  FUNCTIONAL VALUE = ',OFUN
      ENDIF

      DO IREP = 1,MAXREP

        CALL AZZERO(U_GRAD,2*NSTATE*NSTATE)

        IF(TG_ANTISYMM .AND. IREP .LE. 100)  THEN
          CALL SIMM_OP(C1,OMEGA_N,OMEGA_TOT,NSTATE)
          IF(TG_PENALTY) 
     &       CALL OMEGA_GRAD(C1,U_GRAD,NSTATE,SCR(IX2),LSCR2)

#ifdef PARALLEL
          CALL GLOSUM(2*NSTATE*NSTATE,U_GRAD)
          CALL GLOSUM(NSTATE,OMEGA_N)
          CALL GLOSUM(1,OMEGA_TOT)

          CALL MY_SYNC(ALLGRP)
#endif
        ENDIF

        IF(PARENT) THEN

c     calculate the Functional  gradient
          CALL U_GRAD_EXP_IDE(ROTMAT,U_GRAD,Z_MAT,NSTATE)

c     update  of ROTMAT

          CALL U_UPD_EXP_IDE(ROTMAT,Z_MAT,XYZMAT,U_GRAD,SCR(IX2),
     &           LSCR2,NSTATE)

        ENDIF

#ifdef PARALLEL
        CALL MY_SYNC(ALLGRP)
        MSGLEN=2*NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
        MSGLEN= 8*LGLOCRE
        CALL MY_BCAST(OFUN,MSGLEN,SOURCE,ALLGRP)
#endif

C     rotate the wavefunctions to the localized representation
         
        CALL ROTATE_C((1.D0,0.0D0),C1,(0.D0,0.0D0),C2,ROTMAT,NSTATE)
        CALL DCOPY(2*2*NGW*NSTATE,C2,1,C1,1)
        if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)

        IF(PARENT) THEN
c     initialize U = ROTMAT matrix
          CALL ZAZZERO(ROTMAT,NSTATE*NSTATE)
          DO I=1,NSTATE
             ROTMAT(I,I)=DCMPLX(1.D0,0.0D0)
          ENDDO
        ENDIF


        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)

        IF(GMAX.LT.GLOC_EPS) THEN
          GOTO 400
        ELSEIF(DABS(DIF_FUN) .LT. 1.D-10) THEN
          IF(PARENT) THEN 
           WRITE(6,'(/,A,1PE12.6)') '     OFUN-OFUN0 = ',
     &        DIF_FUN
           WRITE(6,'(A,/)') '   G_LOC_UPDATE: CONVERGENCE'
          ENDIF
          GOTO 400
        ELSEIF(IREP .EQ. MAXREP .OR. EXSOFT) THEN
          GOTO 500
        ENDIF                  ! GMAX > EPS
      ENDDO                    ! IREP

 500  CONTINUE 
      IF(PARENT .AND. EXSOFT) WRITE(6,'(A,1E12.6)') 
     &        ' G_LOC_EXP_SUM|SOFTWERE EXIT (OFUNC)',OFUN
      IF(PARENT .AND. IREP .EQ. MAXREP) WRITE(6,'(A,I10)') 
     &        ' G_LOC_EXP_SUM| MAXREP REACHED ',MAXREP
 400  CONTINUE
      IF(PARENT) THEN
        CALL FILECLOSE(10)
        CALL FILECLOSE(11)
        IF(TG_ANTISYMM) CALL FILECLOSE(12)
      ENDIF

C     calculate the centers and spread of the wannier functions
      IX1 = 1
      IX2 = IX1 + 6*NSTATE
      CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
      IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,1)
      IF(PARENT) CALL FILECLOSE(14)

C     SAVE THE ROTATION MATRIX
      IF(PARENT) CALL W_MATRIX(ROTMAT,NSTATE)

      CALL FREEM(IP_LAG_MUL)
      IF(TG_ANTISYMM) CALL FREEM(IP_OMEGA_N)
      CALL FREEM(IP_Z_MAT)
      CALL FREEM(IP_XYZMAT)
      CALL FREEM(IP_ROTMAT)

      IF(TLSD) CALL FREEM(IP_ROTLSD)
      CALL TIHALT('G_LOC_EX_I',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE GIVE_SCR_G_LOC_EXP(LGLOC,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'g_loc.inc'
C     Arguments
      INTEGER   LGLOC,LGZLOC,NSTATE,L_FUNCT
      CHARACTER TAG*30
C     Variables
      LGZLOC = 1
      IF(GLOC_OPT .EQ. 1) THEN
        CALL GIVE_SCR_UPD_EXP_SUM(LGLOC,TAG,NSTATE)
        CALL GIVE_SCR_G_LOC_EXP_SUM(L_FUNCT,TAG,NSTATE)
        LGLOC = MAX(LGLOC,L_FUNCT)
        TAG='MAX(LZNUM,L_XYZMAT,LUGRAD+...)'
      ELSEIF(GLOC_OPT .EQ. 2) THEN
        CALL GIVE_SCR_UPD_EXP_IDE(LGLOC,TAG,NSTATE)
        TAG='MAX(LZNUM,LUGRAD+OPT_ARRAYS)'
      ENDIF
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE GZFUNC(Z_MAT,LDX,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'g_loc.inc'
C     Arguments
      INTEGER    LDX,NSTATE
      REAL*8     Z_MAT(2,LDX,LDX,3)
C     Variables
      INTEGER    I,K
C     ==--------------------------------------------------------------==
      OFUN=0.D0

C..Vanderbilt functional |M|^2
      DO I=1,NSTATE
         DO K=1,3
            OFUN=OFUN+(1.0D0-
     *           Z_MAT(1,I,I,K)*Z_MAT(1,I,I,K)-
     *           Z_MAT(2,I,I,K)*Z_MAT(2,I,I,K))
         ENDDO
      ENDDO

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE Z_UPDATE(RMAT,Z_MAT,SCR,LDX,NSTATE,NMAT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'g_loc.inc'
C     Arguments
      INTEGER LDX,NSTATE,NMAT
      COMPLEX*16  RMAT(NSTATE,NSTATE),Z_MAT(LDX,LDX,NMAT),
     &        SCR(NSTATE,NSTATE,2)
C     Variables
      INTEGER I,ISUB
C     ==--------------------------------------------------------------==
      CALL TISET('  Z_UPDATE',ISUB)
      DO I=1,NMAT
c        DO J=1,NSTATE
c          DO K=1,NSTATE
cc            SCR(J,K,1)=Z_MAT(J,K,I)
c          ENDDO
c        ENDDO
        CALL DCOPY(2*NSTATE*NSTATE,Z_MAT(1,1,I),1,SCR(1,1,1),1)
        CALL ZGEMM('C','N',NSTATE,NSTATE,NSTATE,
     &             (1.D0,0.0D0),RMAT,NSTATE,
     *             SCR(1,1,1),NSTATE,(0.D0,0.0D0),SCR(1,1,2),NSTATE)
        CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,
     &             (1.D0,0.0D0),SCR(1,1,2),NSTATE,
     *             RMAT,NSTATE,(0.D0,0.0D0),SCR(1,1,1),NSTATE)
        CALL DCOPY(2*NSTATE*NSTATE,SCR(1,1,1),1,Z_MAT(1,1,I),1)
c        DO J=1,NSTATE
c          DO K=1,NSTATE
c            Z_MAT(J,K,I)=SCR(J,K,1)
c          ENDDO
c        ENDDO
      ENDDO
      CALL TIHALT('  Z_UPDATE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
