C     ==================================================================
      SUBROUTINE G_LOC_EXP_SUM(C1,C2,SCR,LSCR,NSTATE,NFI,TAU0)
C     ==--------------------------------------------------------------==
C     == CALCULATES LOCALIZED FUNCTIONS IN G SPACE                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'geq0.inc'
      include 'ions.inc'
      include 'cnst.inc'
      include 'ddip.inc'
      include 'gvec.inc'
      include 'irat.inc'
      include 'rmas.inc'
      include 'g_loc.inc'
      include 'spin.inc'
      include 'cppt.inc'
      include 'wann.inc'
      include 'fileopen.inc'

C     input
      INTEGER    LSCR,NSTATE,NFI
      REAL*8     SCR(*),TAU0(*)
      COMPLEX*16 C1(NGWK,*),C2(NGWK,*)

C     local
      INTEGER      IP1,IP2,I,J,ISUB,LSCR2,LSCR3,ig
      INTEGER      IX1,IX2,IX3,IXL,MSGLEN,LENGTH
      INTEGER      IREP,MAXREP
      CHARACTER*30 TAG
      REAL*8       FAC,XRANF,GRMAX,GRMAX_R
      REAL*8       DDOT
      EXTERNAL     DDOT,XRANF
      COMPLEX*16   GMAT(NSTATE,NSTATE)
      POINTER      (IP_GMAT,GMAT)

C     ==--------------------------------------------------------------==
C..   Localized orbitals functions
      COMPLEX*16   Z_MAT(NSTATE,NSTATE,3),U_GRAD(NSTATE,NSTATE)
      COMPLEX*16   XYZMAT(*)
      COMPLEX*16   ROTMAT(NSTATE,NSTATE),ROTLSD(*),ZONE,ZZERO
      POINTER      (IP_Z_MAT,Z_MAT),(IP_ROTMAT,ROTMAT),
     &             (IP_ROTLSD,ROTLSD),(IP_U_GRAD,U_GRAD),
     &             (IP_XYZMAT,XYZMAT)
      SAVE         IP_Z_MAT,IP_ROTMAT,IP_ROTLSD,IP_XYZMAT
      INTEGER      L_LAG_MUL
      LOGICAL      EXSOFT,FERROR
      DIMENSION    LAG_MUL(NSTATE*NSTATE)
      REAL*8       GK_GLO(3,NGWS),GK_SCR(3,NGW)
      POINTER      (IP_GK_GLO,GK_GLO),(IP_GK_SCR,GK_SCR)
      INTEGER      MAPW(*),IP,MSGID,IPW,NBYTES,LEN,LEN1
      POINTER      (IP_MAPW,MAPW)

C     ==--------------------------------------------------------------==

#ifdef PARALLEL
          LEN  = 3*NGWS
          LEN1 = 2*NGW/IRAT + 1
          CALL MEMORY(IP_GK_GLO,LEN,'GK_GLO')
          CALL MEMORY(IP_MAPW,LEN1,'MAPW')
          CALL GET_ADDR(IP_GK_SCR,SCR(1))
#else
C         Not used.
          IP_GK_GLO = 0
          IP_MAPW   = 0
          IP_GK_SCR = 0
#endif

      IF(TG_ANTISYMM)  THEN
        CALL MEMORY(IP_OMEGA_N,NSTATE,'OMEGA_N')
        CALL AZZERO(OMEGA_N,NSTATE)
      ENDIF

      L_LAG_MUL = NSTATE*NSTATE
      CALL MEMORY(IP_LAG_MUL,L_LAG_MUL,'LAG_MUL')
#ifdef _BGL 
      CALL AZZERO(LAG_MUL,2*L_LAG_MUL)
#else
      CALL ZAZZERO(LAG_MUL,L_LAG_MUL)
#endif


      CALL TISET('G_LOC_EX_S',ISUB)
      CALL GIVE_SCR_G_LOC_EXP_SUM(LENGTH,TAG,NSTATE)
      CALL TEST_SCR('G_LOC_EXP_SUM','LENGTH',LSCR,LENGTH)

      GMAX   = 0.0D0
      MAXREP = GLOC_MAXS
      NSTEP  = GLOC_INIT
      ZONE   = dcmplx(1.0D0,0.0D0)
      ZZERO  = dcmplx(0.0D0,0.0D0)

C..   initialization for localized function part

      CALL MEMORY(IP_Z_MAT,2*NSTATE*NSTATE*3,'Z_MAT')
      CALL MEMORY(IP_ROTMAT,2*NSTATE*NSTATE,'ROTMAT')

      IF(PARENT) CALL FILEOPEN(14,FILCEN,FO_DEF,FERROR)
#ifdef PARALLEL
      DO IP=0,NPROC-1
        IF(PARENT) THEN
          IF(PGROUP(IP+1).EQ.ME) THEN
            DO IG=1,NGW
              GK_SCR(1,IG)=GK(1,IG)
              GK_SCR(2,IG)=GK(2,IG)
              GK_SCR(3,IG)=GK(3,IG)
              MAPW(IG)=MAPGP(IG)
            ENDDO
          ELSE
            MSGID=1
            MSGLEN = 3 * SPARM(3,IP) * 8
            CALL MY_BRECV(GK_SCR(1,1),MSGLEN,PGROUP(IP+1),MSGID,NBYTES)
            MSGID=2
            MSGLEN = SPARM(3,IP) * 8/IRAT
            CALL MY_BRECV(MAPW,MSGLEN,PGROUP(IP+1),MSGID,NBYTES)
          ENDIF
          DO IPW=1,SPARM(3,IP)
            GK_GLO(1,MAPW(IPW))=GK_SCR(1,IPW)
            GK_GLO(2,MAPW(IPW))=GK_SCR(2,IPW)
            GK_GLO(3,MAPW(IPW))=GK_SCR(3,IPW)
          ENDDO
        ELSE
          IF(PGROUP(IP+1).EQ.ME) THEN
            MSGID=1
            MSGLEN =  3 * NGW * 8
            CALL MY_BSEND(GK(1,1),MSGLEN,PGROUP(1),MSGID)
            MSGID=2
            MSGLEN = NGW * 8/IRAT
            CALL MY_BSEND(MAPGP,MSGLEN,PGROUP(1),MSGID)
          ENDIF
        ENDIF
      ENDDO
      IF(PARENT) THEN
      FAC = TPIBA * FBOHR
        DO IG = 1,NGWS/2
          write(14,'(A,3f12.5,I10)') 
     &                     'X',GK_GLO(1,IG)*FAC,GK_GLO(2,IG)*FAC,
     &                              GK_GLO(3,IG)*FAC,IG
          write(14,'(A,3f12.5,I10)') 
     &                     'X',-GK_GLO(1,IG)*FAC,-GK_GLO(2,IG)*FAC,
     &                              -GK_GLO(3,IG)*FAC,IG+NGWS
        ENDDO
      ENDIF
      CALL FREEM(IP_GK_GLO)
      CALL FREEM(IP_MAPW)
#else
      FAC = TPIBA * FBOHR
      DO i = 1,NGW/2 !2*NSTATE
        write(14,'(A,3f12.5,I10)') 'X',GK(1,I)*FAC,GK(2,I)*FAC,
     &                              GK(3,I)*FAC,I
        write(14,'(A,3f12.5,I10)') 'X',-GK(1,I)*FAC,-GK(2,I)*FAC,
     &                              -GK(3,I)*FAC,I+NGW
      ENDDO
#endif

      IF(TG_READ_MATRIX)  THEN
        IF(PARENT) CALL R_MATRIX(ROTMAT,NSTATE)
#ifdef PARALLEL
        MSGLEN=2*NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
#endif
C     rotate the wavefunctions to the localized representation

        CALL ROTATE_C(ZONE,C1,ZZERO,C2,ROTMAT,NSTATE)
        CALL DCOPY(2*2*NGW*NSTATE,C2,1,C1,1)
        if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)
      ENDIF


c      CALL PLANE_WAVES_SHELL(C1,NSTATE)

      IX1 = 1
      IX2 = IX1 + 6*NSTATE
      CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
      IF(PARENT) WRITE(6,
     *     ' (/,5x,A,/)')
     *     '_______CENTERS AND SPREAD BEFORE THE OPTIMIZATION_______'
      IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,0)

      IF(TG_KICK) THEN

        CALL UNITARY_TRANS(C1,C2,NSTATE,SCR,LSCR)
        IF(PARENT) WRITE(6,'(/,A)') '     FIRST RANDOM ROTATION    '
C     calculate the centers and spread of the wannier functions
        IX1 = 1
        IX2 = IX1 + 6*NSTATE
        CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
        IF(PARENT) WRITE(6,
     *     ' (/,5x,A,/)')
     *     '_______CENTERS AND SPREAD AFTER ROTATION_______'
        IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR(IX1),0)
 
      ENDIF

C..   calculation of 3 matrices :  <n |O_i| m>
C     where n and m address the electronic orbitals and i = x,y,z

      IF(PARENT) THEN
         CALL FILEOPEN(10,FILSPR,FO_DEF,FERROR)
         CALL FILEOPEN(11,'umat.dat',FO_DEF,FERROR)
         IF(TG_ANTISYMM) CALL FILEOPEN(12,FILPEN,FO_DEF,FERROR)
c     initialize U = ROTMAT matrix
#ifdef _BGL 
         CALL AZZERO(ROTMAT,2*NSTATE*NSTATE)
#else
         CALL ZAZZERO(ROTMAT,NSTATE*NSTATE)
#endif
         DO I=1,NSTATE
            ROTMAT(I,I)= ZONE
         ENDDO
         CALL GET_ADDR(IP_GMAT,SCR(1))
#ifdef _BGL 
         CALL AZZERO(GMAT,2*NSTATE*NSTATE)
#else
         CALL ZAZZERO(GMAT,NSTATE*NSTATE)
#endif
         IF(GLOC_RAN.GT.0.D0) THEN
C..   randomly distort initial vectors
            DO I=1,NSTATE
               GMAT(I,I)= ZONE
               DO J=I+1,NSTATE
                  GMAT(I,J)=DCMPLX(XRANF()*GLOC_RAN,XRANF()*GLOC_RAN)
                  GMAT(J,I)=DCONJG(GMAT(I,J))
               ENDDO
            ENDDO
            CALL ZEXPONENTIATE(GMAT,ROTMAT,NSTATE,SCR(1),LSCR)
            GLOC_RAN=0.D0
         ENDIF
      ENDIF

      IP1=1
      IP2=IP1+2*NSTATE*NSTATE
      LSCR2=LSCR-2*NSTATE*NSTATE
      IF(LSCR2.LT.1) 
     &     CALL STOPGM('G_LOC_EXP_SUM','NOT ENOUGH SCRATCH SPACE')
      CALL ZNUM_MAT(C1,C2,NSTATE,SCR(IP1),SCR(IP2),LSCR2,1)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,Z_MAT(1,1,1),1)

      CALL ZNUM_MAT(C1,C2,NSTATE,SCR(IP1),SCR(IP2),LSCR2,2)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,Z_MAT(1,1,2),1)

      CALL ZNUM_MAT(C1,C2,NSTATE,SCR(IP1),SCR(IP2),LSCR2,3)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,Z_MAT(1,1,3),1)

#ifdef PARALLEL
        CALL MY_SYNC(ALLGRP)
#endif

      IF(TGWANNIER) THEN
        CALL SET_OPERATOR(.FALSE.)
        CALL MEMORY(IP_XYZMAT,2*NSTATE*NSTATE*NWANOPT,'XYZMAT')
        CALL G_LOC_XYZMAT(C1,C2,XYZMAT,SCR,LSCR,NSTATE,TAU0)
         IF(PARENT)  THEN 
           CALL GXYZFUNC(XYZMAT,NSTATE)
           write(6,'(/,A,F12.6)') 
     &       'STARTING  REALSPCE FUNCTIONAL VALUE =  ',XYZFUN
         ENDIF
      ENDIF

      IF(PARENT) THEN
         CALL GZFUNC(Z_MAT,NSTATE,NSTATE) 
         write(6,'(/,A,F12.6)') 
     &                'STARTING  G FUNCTIONAL VALUE =  ',OFUN
      ENDIF


c     startoptimization of ROTMAT
      IX1 = 1
      IXL = 2*NSTATE*NSTATE 
      IX2 = IXL + 1
      CALL GET_ADDR(IP_U_GRAD,SCR(IX1))
      LSCR2 = LSCR - IXL
      IX3 = IX2+3*2*NSTATE*NSTATE
      LSCR3 = LSCR2 - 3*2*NSTATE*NSTATE

#ifdef _BGL 
      CALL AZZERO(U_GRAD,2*NSTATE*NSTATE)
#else
      CALL ZAZZERO(U_GRAD,NSTATE*NSTATE)
#endif

C     CALCULATE HE MASSES  RATIO
      MASS_R = 1.0D0
      MASS_G = 1.0D0

      
      IF(TGWANNIER .AND. WAN_WEIGHT .NE. 0.0D0 
     &             .AND. G2G_WEIGHT .NE. 0.0D0) THEN

         WAN_WEIGHT = 1.0D0
         G2G_WEIGHT = 1.0D0

        IX3 = IX2+NWANOPT*2*NSTATE*NSTATE
        LSCR3 = LSCR2 - NWANOPT*2*NSTATE*NSTATE
        IF(PARENT) THEN
          CALL CALC_U_WGRAD_SUM(ROTMAT,U_GRAD,XYZMAT,SCR(IX2),
     &            SCR(IX3),LSCR3,NSTATE)
          CALL ZGEMM('C','N',NSTATE,NSTATE,NSTATE,ZONE,U_GRAD,
     &                   NSTATE,ROTMAT,NSTATE,ZZERO,SCR(IX2),NSTATE)
          CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,-ZONE,ROTMAT,NSTATE,
     &                   SCR(IX2),NSTATE,ZONE,U_GRAD,NSTATE)
c          IGRMAX  = IZAMAX(NSTATE*NSTATE,U_GRAD,1)
c          GRMAX_R = CDABS(ZGIVE(U_GRAD,IGRMAX))
            GRMAX_R = 0.0D0
          DO I = 1,NSTATE
            GRMAX_R = GRMAX_R+DDOT(2*NSTATE,U_GRAD(1,I),1,U_GRAD(1,I),1)
          ENDDO
#ifdef _BGL 
          CALL AZZERO(U_GRAD,2*NSTATE*NSTATE)
#else
          CALL ZAZZERO(U_GRAD,NSTATE*NSTATE)
#endif
          CALL CALC_U_GRAD_SUM(ROTMAT,U_GRAD,Z_MAT,SCR(IX2),
     &              SCR(IX3),LSCR3,NSTATE,NSTATE)
c          IGRMAX = IZAMAX(NSTATE*NSTATE,U_GRAD,1)
c          GRMAX  = CDABS(ZGIVE(U_GRAD,IGRMAX))
            GRMAX = 0.0D0
          DO I = 1,NSTATE
            GRMAX = GRMAX+DDOT(2*NSTATE,U_GRAD(1,I),1,U_GRAD(1,I),1)
          ENDDO

           MASS_R = DSQRT(GRMAX_R)/DBLE(NSTATE)
           MASS_G = DSQRT(GRMAX)/DBLE(NSTATE)
           IF(PARENT) 
     &       write(6,'(/,A,2(1PE12.4))') 'masses(gnorm)',MASS_G,MASS_R
           FAC = MAX(MASS_R,MASS_G)
           MASS_R = MASS_R/FAC
           MASS_G = MASS_G/FAC
        ENDIF
        WAN_WEIGHT = WAN_MEM
        G2G_WEIGHT = G2G_MEM 
      ENDIF
      G2G_WEIGHT = G2G_WEIGHT/MASS_G
      WAN_WEIGHT = WAN_WEIGHT/MASS_R
      IF(PARENT)
     &  write(6,'(A,2(1PE12.4))') 'real weight',G2G_WEIGHT,WAN_WEIGHT
      IF (G2G_WEIGHT .GT. 1.D3) G2G_WEIGHT=G2G_WEIGHT / 10.D0
      IF (WAN_WEIGHT .GT. 1.D3) WAN_WEIGHT=WAN_WEIGHT / 10.D0
      IF(PARENT) WRITE(6,'(A,2(1PE12.4),/)')
     &     'final weight: ',G2G_WEIGHT,WAN_WEIGHT
      MASS_R = 1.0D0
      MASS_G = 1.0D0

      IF(TGWANNIER) THEN
        IX3 = IX2+NWANOPT*2*NSTATE*NSTATE
        LSCR3 = LSCR2 - NWANOPT*2*NSTATE*NSTATE
        IF(PARENT)
     &     CALL CALC_U_WGRAD_SUM(ROTMAT,U_GRAD,XYZMAT,SCR(IX2),
     &            SCR(IX3),LSCR3,NSTATE)
      ENDIF

      IF(PARENT)
     &   CALL CALC_U_GRAD_SUM(ROTMAT,U_GRAD,Z_MAT,SCR(IX2),
     &              SCR(IX3),LSCR3,NSTATE,NSTATE)


      DO IREP=1,MAXREP
c
        IF(TG_ANTISYMM)  THEN
          CALL SIMM_OP_SUM(C1,ROTMAT,OMEGA_N,OMEGA_TOT,NSTATE)
c
c     &    CALL OMEGA_GRAD(C1,ROTMAT,U_GRAD,NSTATE,SCR(IX2),LSCR2)


#ifdef PARALLEL
          CALL GLOSUM(2*NSTATE*NSTATE,U_GRAD)
          CALL GLOSUM(NSTATE,OMEGA_N)
          CALL GLOSUM(1,OMEGA_TOT)

          CALL MY_SYNC(ALLGRP)
#endif
        ENDIF


        IF(PARENT) THEN
c       calculate U_GRAD_new with the rotated U_MAT_new

          CALL U_UPD_EXP_SUM(ROTMAT,Z_MAT,XYZMAT,U_GRAD,SCR(IX2),
     &              LSCR2,NSTATE)

        ENDIF


#ifdef PARALLEL
        CALL MY_SYNC(ALLGRP)

        MSGLEN= 8*LGLOCRE
        CALL MY_BCAST(OFUN,MSGLEN,SOURCE,ALLGRP)
#endif

        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)

        IF(GMAX.LT.GLOC_EPS) THEN
          GOTO 400
        ELSEIF(DABS(DIF_FUN) .LT. 1.D-10) THEN
          IF(PARENT) THEN 
           WRITE(6,'(/,A,1PE12.6)') '     OFUN-OFUN0 = ',
     &           DIF_FUN
           WRITE(6,'(A,/)') '   G_LOC_UPDATE: CONVERGENCE'
        ENDIF
          GOTO 400
        ELSEIF(IREP .EQ. MAXREP .OR. EXSOFT) THEN
          GOTO 500
        ENDIF
      ENDDO

 500  CONTINUE 
      IF(PARENT .AND. EXSOFT) WRITE(6,'(A,1E12.6)') 
     &        ' G_LOC_EXP_SUM|SOFTWERE EXIT (OFUNC)',OFUN
      IF(PARENT .AND. IREP .EQ. MAXREP) WRITE(6,'(A,I10)') 
     &        ' G_LOC_EXP_SUM| MAXREP REACHED ',MAXREP
 400  CONTINUE
      IF(PARENT) THEN
        CALL FILECLOSE(10)
        CALL FILECLOSE(11)
        IF(TG_ANTISYMM) CALL FILECLOSE(12)
      ENDIF

#ifdef PARALLEL
      MSGLEN=2*NSTATE*NSTATE * 8
      CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
#endif

C     rotate the wavefunctions to the localized representation

      CALL ROTATE_C(ZONE,C1,ZZERO,C2,ROTMAT,NSTATE)
      CALL DCOPY(2*2*NGW*NSTATE,C2,1,C1,1)
      if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)

C  Final value of the spread
      IF(TGWANNIER) THEN
        IF(PARENT) THEN
          CALL Z_UPDATE(ROTMAT,XYZMAT,SCR(IX1),NSTATE,NSTATE,NWANOPT)
          WRITE(6,'(/,1X,64(1H*))')
          WRITE(6,'(" ****",6X,A,6X,"****",/)') 
     &        'CENTERS AND SPREAD AFTER THE OPTIMIZATION'
          W_TYPE = 1
        ENDIF
        CALL WANNIER_CENTER(XYZMAT,NSTATE,NSTATE,SCR(IX1),TAU0)
        IF(PARENT) CALL WC_PRINT(NSTATE,SCR(IX1))
      ENDIF

C     calculate the centers and spread of the wannier functions
      IX1 = 1
      IX2 = IX1 + 6*NSTATE
      CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))

      IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR(IX1),1)
      IF(PARENT) CALL FILECLOSE(14)

      IF(TG_READ_MATRIX)  THEN
        IF(PARENT) CALL R_MATRIX(LAG_MUL,NSTATE)

#ifdef PARALLEL
        MSGLEN=2*NSTATE*NSTATE * 8
        CALL MY_BCAST(LAG_MUL,MSGLEN,SOURCE,ALLGRP)
#endif
        CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,ZONE,LAG_MUL,
     &             NSTATE,ROTMAT,NSTATE,ZZERO,C2,NSTATE)
        CALL DCOPY(2*NSTATE*NSTATE,C2,1,ROTMAT,1)
      ENDIF

C     SAVE THE ROTATION MATRIX
      IF(PARENT) CALL W_MATRIX(ROTMAT,NSTATE)

      IF(TGWANNIER)   CALL FREEM(IP_XYZMAT)
      IF(TG_ANTISYMM) CALL FREEM(IP_OMEGA_N)

      CALL FREEM(IP_LAG_MUL)

      CALL FREEM(IP_Z_MAT)
      CALL FREEM(IP_ROTMAT)

      IF(TLSD) CALL FREEM(IP_ROTLSD)
      CALL TIHALT('G_LOC_EX_S',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE GIVE_SCR_G_LOC_EXP_SUM(LGLOC,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'g_loc.inc'
C     Arguments
      INTEGER   LGLOC,LZNUM,NSTATE,L_XYZMAT
      CHARACTER TAG*30
C     Variables

      CALL GIVE_SCR_ZNUM_MAT(LZNUM,TAG,NSTATE)
      CALL GIVE_SCR_UPD_EXP_SUM(LGLOC,TAG,NSTATE)
      IF(TGWANNIER) THEN
        CALL GIVE_SCR_XYZMAT(L_XYZMAT,TAG)
      ELSE
        L_XYZMAT =1
      ENDIF
      LGLOC=MAX(LGLOC,LZNUM,L_XYZMAT)
      TAG='MAX(LZNUM,LUGRAD+6*2*N2,...)'
c      write(6,*) 'LGLOC ' ,LGLOC,' LZNUM ' ,LZNUM
c      stop
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
