C     ==================================================================
      SUBROUTINE P_REAL_SPACE(INFI,IKIND,C0,NSTATE,PSI,
     &                 SCR,LSCR,NSTATE_LOC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'g_loc.inc'
      INCLUDE 'cell.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'fileopen.inc'

C     ==--------------------------------------------------------------==
      INTEGER    NSTATE,LSCR,INFI,IKIND,NSTATE_LOC
      COMPLEX*16 C0(NGW*2,NSTATE),PSI(*)
      REAL*8     SCR(LSCR)
      REAL*8     ARRAY(KR1*KR2S*KR3S),DEST(KR2S,KR3S)
      POINTER    (IP_ARRAY,ARRAY),(IP_DEST,DEST)
      INTEGER ISUB
      INTEGER    I,NO,ORBPRI(*),IA,IE,IR,IG
      POINTER    (IP_ORBPRI,ORBPRI)
      INTEGER    IFIRST,I1,ii1,I2,ii2,I3,ii3,ii3p,ISTATE,LENGTH
      SAVE       IFIRST,IP_ORBPRI
      DATA       IFIRST /0/
      LOGICAL    FERROR
      CHARACTER  FILEN*15,FILBOD*15,FILTR*15,NUMB*8
      REAL*8     CUBECENTER(3),lowerleft(3),XMIN,YMIN,ZMIN,
     &           rrx,rry,rrz,rrr
      REAL*8     R0(3,NAX,NSP),XMAX,YMAX,ZMAX,XL,YL,ZL,XS,YS,ZS
      POINTER    (IP_R0,R0)
      integer    iat,isp,msglen,nbytes,msgid,source_pe,ilowerleft(3),
     &           rgrid,ICONT
      DIMENSION  IND_ST(NSTATE_LOC)

      call tiset('  P_REAL_SPACE',isub)

      LENGTH = KR1*KR2S*KR3S + KR2S*KR3S
      CALL TEST_SCR('P_REL_SPACE','LENGTH',LSCR,LENGTH)

      CALL GET_ADDR(IP_ARRAY,SCR(1))
      CALL GET_ADDR(IP_DEST,SCR(1+kr1*kr2s*kr3s))



      IF(IFIRST.EQ.0) THEN
        NO=NSTATE/IRAT+1
        CALL MEMORY(IP_ORBPRI,NO,'ORBPRI')
        CALL IAZZERO(ORBPRI,NSTATE)
        IF(GLOC_ALL.NE.0) THEN
         DO I=1,NSTATE
           ORBPRI(I)=1
         ENDDO
        ELSEIF(GLOC_FIRST.GT.0) THEN
         DO I=GLOC_FIRST,GLOC_LAST
          ORBPRI(I)=1
         ENDDO
        ELSEIF(GLOC_ORB.GT.0) THEN
         DO I=1,GLOC_ORB
          ORBPRI(GLOC_LIST(I))=1
         ENDDO
        ENDIF
        IFIRST=1
      ENDIF

      CALL  MEMORY(IP_R0,3*NAX*NSP,'R0')
C    SHIFT THE CELL WHEN NECESSARY
      XMIN = TAU0(1,1,1)
      XMAX = TAU0(1,1,1)
      YMIN = TAU0(2,1,1)
      YMAX = TAU0(1,1,1)
      ZMIN = TAU0(3,1,1)
      ZMAX = TAU0(1,1,1)
      do isp=1,nsp
        do iat=1,na(isp)
          XMIN = MIN(XMIN,TAU0(1,IAT,ISP))
          XMAX = MAX(XMAX,TAU0(3,IAT,ISP)) ! ZMAX -> XMAX cmb-bugfix
          YMIN = MIN(YMIN,TAU0(2,IAT,ISP))
          YMAX = MAX(YMAX,TAU0(3,IAT,ISP))
          ZMIN = MIN(ZMIN,TAU0(3,IAT,ISP))
          ZMAX = MAX(ZMAX,TAU0(3,IAT,ISP))
         enddo
       enddo     
      do isp=1,nsp
        do iat=1,na(isp)
          R0(1,IAT,ISP) = TAU0(1,IAT,ISP) - XMIN 
          R0(2,IAT,ISP) = TAU0(2,IAT,ISP) - YMIN 
          R0(3,IAT,ISP) = TAU0(3,IAT,ISP) - ZMIN 
         enddo
       enddo     

      XL = a1(1)+a2(1)+a3(1)
      YL = a1(2)+a2(2)+a3(2)
      ZL = a1(3)+a2(3)+a3(3)

      XS = (XL - (XMAX - XMIN))/(2.D0*XL) !(4.D0*XL)
      YS = (YL - (YMAX - YMIN))/(2.D0*YL) !(4.D0*YL)
      ZS = (ZL - (ZMAX - ZMIN))/(2.D0*ZL) !(4.D0*ZL)

c       write(6,*) XMAX - XMIN,YMAX - YMIN,ZMAX - ZMIN
c       write(6,*) XL,YL,ZL,XS,YS,ZS


      CUBECENTER(1) =  (0.5d0-XS)*(a1(1)+a2(1)+a3(1))
      CUBECENTER(2) =  (0.5d0-YS)*(a1(2)+a2(2)+a3(2))
      CUBECENTER(3) =  (0.5d0-ZS)*(a1(3)+a2(3)+a3(3))
c       write(6,*) CUBECENTER(1),CUBECENTER(2),CUBECENTER(3) 
c      do ir=1,3
c        LOWERLEFT(ir) = CUBECENTER(ir) 
c     &        - 0.5d0*(a1(ir)+a2(ir)+a3(ir))
c      enddo
        LOWERLEFT(1) = CUBECENTER(1) 
     &        - (0.5d0-XS)*(a1(1)+a2(1)+a3(1))
        LOWERLEFT(2) = CUBECENTER(2) 
     &        - (0.5d0-YS)*(a1(2)+a2(2)+a3(2))
        LOWERLEFT(3) = CUBECENTER(3) 
     &        - (0.5d0-ZS)*(a1(3)+a2(3)+a3(3))

      DO IR = 1,3
        ILOWERLEFT(IR) = RGRID(LOWERLEFT,IR)
      ENDDO
c       write(6,*) ILOWERLEFT(1),ILOWERLEFT(2),ILOWERLEFT(3)
      call putongrid(lowerleft)
c       write(6,*) LOWERLEFT(1),LOWERLEFT(2),LOWERLEFT(3)
c       stop
      IF(PARENT) THEN
        FILTR='RWFN_'
        WRITE(NUMB,'(I8)') INFI
        CALL XSTRING(NUMB,IA,IE)
        FILBOD=FILTR(1:5)//NUMB(IA:IE)
        IF(TG_COMPLEX) THEN
          CALL XSTRING(FILBOD,I1,I2)
          FILTR = FILBOD(I1:I2)
          WRITE(NUMB,'(I8)') IKIND
          CALL XSTRING(NUMB,IA,IE)
          CALL XSTRING(FILTR,I1,I2)
          FILBOD=FILTR(I1:I2)//'_k'//NUMB(IA:IE)
        ENDIF
      ENDIF
      
      DO ISTATE=1,NSTATE
        IF(ORBPRI(ISTATE).NE.0) THEN
          IF(PARENT) THEN

            WRITE(NUMB,'(I8)') ISTATE
            CALL XSTRING(NUMB,IA,IE)
            CALL XSTRING(FILBOD,I1,I2)
            FILEN=FILBOD(I1:I2)//'.'//NUMB(IA:IE)

C AK 2005/04/08. FIXME: this may be offloaded to the cubefile routine
C                       in util_p.F
            CALL FILEOPEN(2604,FILEN,FO_DEF,FERROR)

            write (2604,*) 'CPMD CUBE FILE.'
            write (2604,*) 'OUTER : X, MIDDLE : Y, INNER : Z'

            write (2604,200) nat, (LOWERLEFT(ir),ir=1,3)
            write (2604,200) nr1s,
     &                    (a1(ir)/DBLE(NR1S),ir=1,3)
            write (2604,200) nr2s,
     &                    (a2(ir)/DBLE(NR2S),ir=1,3)
            write (2604,200) nr3s,
     &                    (a3(ir)/DBLE(NR3S),ir=1,3)

            do isp=1,nsp
             do iat=1,na(isp)
               write (2604,201) IATYP(ISP),0.0d0,
     &              (R0(IR,IAT,ISP),ir=1,3)
             enddo
            enddo

          ENDIF

          call azzero(psi,2*maxfft)

          do ig=1,NGW
            psi(nzhs(ig))  = C0(ig,ISTATE)
            psi(indzs(ig)) = C0(ig+NGW,ISTATE)
          enddo
          call s_invfft(psi)
          call phase(psi)

          do ir=1,NNR1
            ARRAY(ir)  = DREAL(PSI(ir))*DREAL(PSI(ir))+
     &              DIMAG(PSI(ir))*DIMAG(PSI(ir))
            ARRAY(ir)  = DSQRT(ARRAY(IR))
          enddo

          do i1=ilowerleft(1),nr1s+ilowerleft(1)-1
#ifdef PARALLEL
            call my_sync(allgrp) ! to avoid long transfer queues
#endif
             ii1 = i1
             if(ii1 .gt. nr1s) ii1 = ii1 - nr1s
C     find the PE who has the plane i1:
            source_pe = 0
            do while (.NOT. 
     &           (ii1.ge.NRXPL(source_pe,1) .AND.
     &           ii1.le.NRXPL(source_pe,2)))
               source_pe = source_pe + 1
            enddo
            source_pe = PGROUP(source_pe+1)
            
            if (MEPOS .EQ. source_pe) then
c     &              ARRAY(ii1-NRXPL(MEPOS,1)+1,1,1),KR1,
               call DCOPY(kr2s*kr3s, 
     &              ARRAY(ii1-NRXPL(MEPOS,1)+1),KR1,
     &              DEST,1)
               if (.NOT. parent) then
                  msglen = 8*kr2s*kr3s ! one X-plane.
                  msgid = 2     ! MPI message tag.
                  call MY_BSEND(DEST,msglen,pgroup(1),msgid)
               endif
            elseif (parent) then
               msglen = 8*kr2s*kr3s ! one X-plane.
               msgid = 2        ! MPI message tag.
               call MY_BRECV(DEST,msglen,source_pe,msgid,nbytes)
            endif
            
            
C     Now, the parent should have the plane in PSI.
            if (parent) then
               do i2=ilowerleft(2),nr2s+ilowerleft(2) - 1
                  ii2 = i2
                  if(ii2 .GT. nr2s) ii2 = ii2 -nr2s
                 do i3=ilowerleft(3),nr3s+ilowerleft(3) - 1 -1,2 
                  ii3  = i3
                  ii3p = i3 + 1
                  if(ii3 .GT. nr3s) ii3 = ii3 -nr3s
                  if(ii3p .GT. nr3s) ii3p = ii3p -nr3s
                  write (2604,202) DEST(ii2,ii3),DEST(ii2,ii3p)
                 enddo
               enddo
            endif
          ENDDO
          IF(PARENT) CALL FILECLOSE(2604)
        ENDIF
      enddo


C ************************************************************************

c      CUBECENTER(1) =  (0.5d0-XS)*(a1(1)+a2(1)+a3(1))
c      CUBECENTER(2) =  (0.5d0-YS)*(a1(2)+a2(2)+a3(2))
c      CUBECENTER(3) =  (0.5d0-ZS)*(a1(3)+a2(3)+a3(3))


      CUBECENTER(1) = 0.0D0 !(0.5d0-XS)*(a1(1)+a2(1)+a3(1))
      CUBECENTER(2) = 0.0D0 !(0.5d0-YS)*(a1(2)+a2(2)+a3(2))
      CUBECENTER(3) = 0.0D0 !

        LOWERLEFT(1) = CUBECENTER(1) 
     &        - (0.5d0-XS)*(a1(1)+a2(1)+a3(1))
        LOWERLEFT(2) = CUBECENTER(2) 
     &        - (0.5d0-YS)*(a1(2)+a2(2)+a3(2))
        LOWERLEFT(3) = CUBECENTER(3) 
     &        - (0.5d0-ZS)*(a1(3)+a2(3)+a3(3))

      DO IR = 1,3
        ILOWERLEFT(IR) = RGRID(LOWERLEFT,IR)
      ENDDO

      call putongrid(lowerleft)

      IF(INFI .NE. 1) THEN
      IF(PARENT) THEN

        WRITE(NUMB,'(A3)') 'TOT'
        CALL XSTRING(NUMB,IA,IE)
        CALL XSTRING(FILBOD,I1,I2)
        FILEN=FILBOD(I1:I2)//'.'//NUMB(IA:IE)

        CALL FILEOPEN(2604,FILEN,FO_DEF,FERROR)
        write (2604,*) 'CPMD CUBE FILE.'
        write (2604,*) 'OUTER : X, MIDDLE : Y, INNER : Z'

        write (2604,200) nat, (LOWERLEFT(ir),ir=1,3)
        write (2604,200) nr1s,
     &                    (a1(ir)/DBLE(NR1S),ir=1,3)
        write (2604,200) nr2s,
     &                    (a2(ir)/DBLE(NR2S),ir=1,3)
        write (2604,200) nr3s,
     &                    (a3(ir)/DBLE(NR3S),ir=1,3)

        do isp=1,nsp
          do iat=1,na(isp)
            write (2604,201) IATYP(ISP),0.0d0,
     &              (R0(IR,IAT,ISP),ir=1,3)
          enddo
        enddo

      ENDIF

      call azzero(psi,2*maxfft)

      DO ICONT = 1,NSTATE_LOC

        IF(STATE_ALL) THEN
          ISTATE = ICONT
        ELSE
          ISTATE = IND_ST(ICONT)
        ENDIF

        do ig=1,NGW
c          psi(nzhs(ig))  = psi(nzhs(ig))  + C0(ig,ISTATE)
c          psi(indzs(ig)) = psi(indzs(ig)) + C0(ig+NGW,ISTATE)
          psi(nzhs(ig))  = psi(nzhs(ig))  + 
     &      DSQRT(DREAL(C0(ig,ISTATE))*DREAL(C0(ig,ISTATE))+
     &          DIMAG(C0(IG,ISTATE))*DIMAG(C0(IG,ISTATE)))
          psi(indzs(ig)) = psi(indzs(ig)) +
     &      DSQRT(DREAL(C0(ig+NGW,ISTATE))*DREAL(C0(ig+NGW,ISTATE))+
     &          DIMAG(C0(IG+NGW,ISTATE))*DIMAG(C0(IG+NGW,ISTATE)))
        ENDDO
      enddo
      call s_invfft(psi)
      call phase(psi)

      do ir=1,NNR1
        ARRAY(ir)  = DREAL(PSI(ir))*DREAL(PSI(ir))+
     &              DIMAG(PSI(ir))*DIMAG(PSI(ir))
        ARRAY(ir)  = DSQRT(ARRAY(IR))
      enddo

C     PLOT DECAY FROM (000) --->  (1/2 1/2 1/2)

      CALL FILEOPEN(1215,'tot_wan_decay_111.dat',FO_DEF,FERROR)
      DO i1 = 1,NR1S/2+1
        i2 = i1
        i3 = i1
        rrx = a1(1)*i1/DBLE(NR1S)+ a2(1)*i2/DBLE(NR2S) +
     &        a3(1)*i3/DBLE(NR3S)    
        rry = a1(2)*i1/DBLE(NR1S)+ a2(2)*i2/DBLE(NR2S) +
     &        a3(2)*i3/DBLE(NR3S)    
        rrz = a1(3)*i1/DBLE(NR1S)+ a2(3)*i2/DBLE(NR2S) +
     &        a3(3)*i3/DBLE(NR3S)    
 
        rrr = DSQRT(rrx*rrx+rry*rry+rrz*rrz)

        write(1215,'(2(1PE12.6))') 
     &               rrr,ARRAY(i1+(i2-1)*NR1S+(i3-1)*NR1S*NR2S)
      ENDDO
      CALL FILECLOSE(1215)


      do i1=ilowerleft(1),nr1s+ilowerleft(1)-1
#ifdef PARALLEL
        call my_sync(allgrp) ! to avoid long transfer queues
#endif
        ii1 = i1
        if(ii1 .gt. nr1s) ii1 = ii1 - nr1s
C     find the PE who has the plane i1:
        source_pe = 0
        do while (.NOT. 
     &           (ii1.ge.NRXPL(source_pe,1) .AND.
     &           ii1.le.NRXPL(source_pe,2)))
         source_pe = source_pe + 1
        enddo
        source_pe = PGROUP(source_pe+1)
            
        if (MEPOS .EQ. source_pe) then
c     &              ARRAY(ii1-NRXPL(MEPOS,1)+1,1,1),KR1,
          call DCOPY(kr2s*kr3s, 
     &              ARRAY(ii1-NRXPL(MEPOS,1)+1),KR1,
     &              DEST,1)
          if (.NOT. parent) then
            msglen = 8*kr2s*kr3s ! one X-plane.
            msgid = 2     ! MPI message tag.
            call MY_BSEND(DEST,msglen,pgroup(1),msgid)
          endif
        elseif (parent) then
          msglen = 8*kr2s*kr3s ! one X-plane.
          msgid = 2        ! MPI message tag.
          call MY_BRECV(DEST,msglen,source_pe,msgid,nbytes)
        endif
            
            
C     Now, the parent should have the plane in PSI.
        if (parent) then
          do i2=ilowerleft(2),nr2s+ilowerleft(2) - 1
            ii2 = i2
            if(ii2 .GT. nr2s) ii2 = ii2 -nr2s
            do i3=ilowerleft(3),nr3s+ilowerleft(3) - 1 -1,2 
              ii3  = i3
              ii3p = i3 + 1
              if(ii3 .GT. nr3s) ii3 = ii3 -nr3s
              if(ii3p .GT. nr3s) ii3p = ii3p -nr3s
              write (2604,202) DEST(ii2,ii3),DEST(ii2,ii3p)
            enddo
          enddo
        endif
      ENDDO
      IF(PARENT) CALL FILECLOSE(2604)
      ENDIF


 200  FORMAT (5X,I4,6X,3F13.5)
 201  FORMAT (5X,I4,F6.2,3F13.8)
 202  FORMAT (2X,2F9.5)

      CALL FREEM(IP_R0)
      RETURN
      END

c     ==================================================================

