C     ==================================================================
      SUBROUTINE G_LOC_SPREAD_IDE(C1,C2,SCR,LSCR,NSTATE,NFI)
C     ==--------------------------------------------------------------==
C     == CALCULATES LOCALIZED FUNCTIONS IN G SPACE                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'geq0.inc'
      include 'ions.inc'
      include 'cnst.inc'
      include 'ddip.inc'
      include 'gvec.inc'
      include 'irat.inc'
      include 'rmas.inc'
      include 'g_loc.inc'
      include 'spin.inc'
      include 'cppt.inc'
      include 'fileopen.inc'

c      include 'store.inc'
C     input
      INTEGER    LSCR,NSTATE
      REAL*8     SCR(*)
      COMPLEX*16 C1(NGWK,*),C2(NGWK,NSTATE)
      INTEGER    NFI
C     local
      INTEGER      I,J,ISUB,LSCR2,IX1,IX2,IXL
      INTEGER      IREP,MAXREP,MSGLEN,LENGTH
      CHARACTER*30 TAG
      REAL*8       FAC,XRANF
      EXTERNAL     XRANF
      COMPLEX*16   GMAT(NSTATE,NSTATE)
      POINTER      (IP_GMAT,GMAT)

C     ==--------------------------------------------------------------==
C..   Localized orbitals functions
      COMPLEX*16   Z1_MAT(NSTATE,NSTATE,3),Z2_MAT(NSTATE,NSTATE,3)
      COMPLEX*16   ROTMAT(NSTATE,NSTATE),ROTLSD(*),
     &             U_GRAD(NSTATE,NSTATE)
      POINTER      (IP_Z1_MAT,Z1_MAT),(IP_Z2_MAT,Z2_MAT),
     &             (IP_ROTMAT,ROTMAT),(IP_ROTLSD,ROTLSD),
     &             (IP_U_GRAD,U_GRAD)
      SAVE         IP_Z1_MAT,IP_Z2_MAT,IP_ROTMAT,IP_ROTLSD
      INTEGER      L_LAG_MUL
      LOGICAL      EXSOFT,FERROR
C     ==--------------------------------------------------------------==

      L_LAG_MUL  = 2*NSTATE*NSTATE
      CALL MEMORY(IP_LAG_MUL,L_LAG_MUL,'LAG_MUL')
      CALL AZZERO(LAG_MUL,L_LAG_MUL)

      IF(TG_ANTISYMM)  THEN
        CALL MEMORY(IP_OMEGA_N,NSTATE,'OMEGA_N')
        CALL AZZERO(OMEGA_N,NSTATE)
      ENDIF

      CALL TISET('G_LOC_SP_I',ISUB)
      CALL GIVE_SCR_G_LOC_SPREAD(LENGTH,TAG,NSTATE)
      CALL TEST_SCR('GLOC_SPREAD_IDE','LENGTH',LSCR,LENGTH)

      GMAX = 0.0D0

      MAXREP = GLOC_MAXS
      NSTEP  = GLOC_INIT


C..   initialization for localized function part

      CALL MEMORY(IP_Z1_MAT,2*NSTATE*NSTATE*3,'Z1_MAT')
      CALL MEMORY(IP_Z2_MAT,2*NSTATE*NSTATE*3,'Z2_MAT')
      CALL MEMORY(IP_ROTMAT,2*NSTATE*NSTATE,'ROTMAT')


       IF(PARENT) THEN
        CALL FILEOPEN(14,FILCEN,FO_DEF,FERROR)
        FAC = TPIBA * FBOHR
        DO i = 1,2*NSTATE
          write(14,'(A,3f12.5,I10)') 'H',GK(1,I)*FAC,GK(2,I)*FAC,
     &                              GK(3,I)*FAC,I
          write(14,'(A,3f12.5,I10)') 'H',-GK(1,I)*FAC,-GK(2,I)*FAC,
     &                              -GK(3,I)*FAC,I+NGW
        ENDDO
       ENDIF

      IF(TG_READ_MATRIX)  THEN
        IF(PARENT) CALL R_MATRIX(ROTMAT,NSTATE)
        MSGLEN=2*NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
C     rotate the wavefunctions to the localized representation

        CALL ROTATE_C((1.D0,0.0D0),C1,(0.D0,0.0D0),C2,ROTMAT,NSTATE)
        CALL DCOPY(2*2*NGW*NSTATE,C2,1,C1,1)
        if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)
      ENDIF

c      CALL PLANE_WAVES_SHELL(C1,NSTATE)
c      stop

C     calculate the centers and spread of the wannier functions
      IX1 = 1
      IX2 = IX1 + 6*NSTATE
      CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
      IF(PARENT) WRITE(6,
     *     ' (/,5x,A,/)')
     *     '_______CENTERS AND SPREAD BEFORE THE OPTIMIZATION_______'
      IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,0)

C..   calculation of 3 matrices :  <n |O_i| m>
C     where n and m address the electronic orbitals and i = x,y,z

      IF(TG_KICK) THEN

      CALL UNITARY_TRANS(C1,C2,NSTATE,SCR,LSCR)
        IF(PARENT) WRITE(6,'(/,A)') '     FIRST RANDOM ROTATION    '
C     calculate the centers and spread of the wannier functions
        IX1 = 1
        IX2 = IX1 + 6*NSTATE
        CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
        IF(PARENT) WRITE(6,
     *     ' (/,5x,A,/)')
     *     '_____ CENTERS AND SPREAD AFTER FIRST RANDOM ROTATION _____'
        IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,0)
      ENDIF


C     HERE THE LOOPS START:
C     at each step Z_MAT is calculated, then the functional is estimated
C
C     The ROTMAT matrix is assumed as the identical matrix 
C
C     The gradient of the functional U_GRAD is calculated assuming a small
C     perturbation of ROTMAT with respect to the identical matrix
C     U_GRADij = Z_MATij * DCONJG(Z_MATjj) + DCONJG(Z_MATij) * Z_MATjj 
C
C     the ROTMAT is updated mantaining the unitary condition

      CALL G2_MAT(C1,C2,NSTATE,SCR,1)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z2_MAT(1,1,1),1)

      CALL G2_MAT(C1,C2,NSTATE,SCR,2)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z2_MAT(1,1,2),1)

      CALL G2_MAT(C1,C2,NSTATE,SCR,3)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z2_MAT(1,1,3),1)

      CALL G1_MAT(C1,C2,NSTATE,SCR,1)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z1_MAT(1,1,1),1)

      CALL G1_MAT(C1,C2,NSTATE,SCR,2)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z1_MAT(1,1,2),1)

      CALL G1_MAT(C1,C2,NSTATE,SCR,3)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z1_MAT(1,1,3),1)

#ifdef PARALLEL
      CALL GLOSUM(3*2*NSTATE*NSTATE,Z1_MAT)
      CALL GLOSUM(3*2*NSTATE*NSTATE,Z2_MAT)
        CALL MY_SYNC(ALLGRP)
#endif
 


      IF(PARENT) THEN
        CALL SPREADFUNC(Z1_MAT,Z2_MAT,NSTATE,NSTATE)
        write(6,'(/,A,F12.6)') 'STARTING FUNCTIONAL VALUE= ',OFUN
      ENDIF

      IX1 = 1
      IXL = 2*NSTATE*NSTATE 
      IX2 = IXL + 1
      CALL GET_ADDR(IP_U_GRAD,SCR(IX1))
      LSCR2 = LSCR - IXL

      IF(PARENT) THEN
         CALL FILEOPEN(10,FILSPR,FO_DEF,FERROR)
         CALL FILEOPEN(11,'umat.dat',FO_DEF,FERROR)
        IF(TG_ANTISYMM) CALL FILEOPEN(12,FILPEN,FO_DEF,FERROR)
c     initialize U = ROTMAT matrix
         CALL AZZERO(ROTMAT,2*NSTATE*NSTATE)
         DO I=1,NSTATE
            ROTMAT(I,I)=DCMPLX(1.D0,0.0D0)
         ENDDO
         CALL GET_ADDR(IP_GMAT,SCR(IX2))
         CALL AZZERO(GMAT,2*NSTATE*NSTATE)
         IF(GLOC_RAN.GT.0.D0) THEN
C..   randomly distort initial vectors
            DO I=1,NSTATE
               GMAT(I,I)=DCMPLX(1.0D0,0.D0)
               DO J=I+1,NSTATE
                  GMAT(I,J)=DCMPLX(XRANF()*GLOC_RAN,XRANF()*GLOC_RAN)
                  GMAT(J,I)=DCONJG(GMAT(I,J))
               ENDDO
            ENDDO
            CALL ZEXPONENTIATE(GMAT,ROTMAT,NSTATE,SCR(IX2),LSCR2)
            GLOC_RAN=0.D0
         ENDIF
      ENDIF

c      stop      
      DO IREP = 1,MAXREP
         

        CALL AZZERO(U_GRAD,2*NSTATE*NSTATE)

        IF(TG_ANTISYMM .AND. IREP .LE. 100) THEN
        CALL SIMM_OP(C1,OMEGA_N,OMEGA_TOT,NSTATE)
        IF(TG_PENALTY)
     &     CALL OMEGA_GRAD(C1,U_GRAD,NSTATE,SCR(IX2),LSCR2)           

#ifdef PARALLEL
        CALL GLOSUM(2*NSTATE*NSTATE,U_GRAD)
        CALL GLOSUM(NSTATE,OMEGA_N)
        CALL GLOSUM(1,OMEGA_TOT)

          CALL MY_SYNC(ALLGRP)
#endif
        ENDIF
c     calculate the  gradient
        IF(PARENT) THEN
          CALL U_GRAD_SPREAD_IDE(ROTMAT,U_GRAD,Z1_MAT,NSTATE)

            
          CALL U_UPD_SPREAD_IDE(ROTMAT,Z1_MAT,Z2_MAT,U_GRAD,
     &                    SCR(IX2),LSCR2,NSTATE)
            
c          write(11,*) 'NSTEP = ',NSTEP
c          DO I = 1,NSTATE
c             write(11,'(I3,8(2f8.4))') I,(ROTMAT(I,J),J=1,8)
c          ENDDO
c          write(11,'(/,30A,/)') '**'
c         stop            
        ENDIF

#ifdef PARALLEL
        CALL MY_SYNC(ALLGRP)
        MSGLEN=2*NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
        MSGLEN= 8*LGLOCRE
        CALL MY_BCAST(OFUN,MSGLEN,SOURCE,ALLGRP)
#endif
C     rotate the wavefunctions to the localized representation
         
         CALL ROTATE_C((1.D0,0.0D0),C1,(0.D0,0.0D0),C2,ROTMAT,NSTATE)
         CALL DCOPY(2*2*NGW*NSTATE,C2,1,C1,1)
         if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)
         
         IF(PARENT) THEN
c     initialize U = ROTMAT matrix
            CALL ZAZZERO(ROTMAT,NSTATE*NSTATE)
            DO I=1,NSTATE
               ROTMAT(I,I)=DCMPLX(1.D0,0.0D0)
            ENDDO
         ENDIF
         
         IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
         IF(GMAX.LT.GLOC_EPS) THEN
            GOTO 400
        ELSEIF(DABS(DIF_FUN) .LT. 1.D-10) THEN
          IF(PARENT) THEN 
           WRITE(6,'(/,A,1PE12.6)') '     OFUN-OFUN0 = ',
     &        DIF_FUN
           WRITE(6,'(A,/)') '   G_LOC_UPDATE: CONVERGENCE'
          ENDIF
          GOTO 400
         ELSEIF(IREP .EQ. MAXREP .OR. EXSOFT) THEN
            GOTO 500
         ENDIF                  ! GMAX > EPS
      ENDDO                     ! IREP
      
 500  IF(EXSOFT) WRITE(6,'(A,1E12.6)') 
     &     ' G_LOC_SPREAD_IDE|SOFTWERE EXIT (OFUNC)',OFUN
      IF(IREP .EQ. MAXREP) WRITE(6,'(A,I10)') 
     &     ' G_LOC_SPREAD_IDE| MAXREP REACHED ',MAXREP
 400  CONTINUE
      IF(PARENT) THEN
        CALL FILECLOSE(10)
        CALL FILECLOSE(11)
        IF(TG_ANTISYMM) CALL FILECLOSE(12)
      ENDIF

C     calculate the centers and spread of the wannier functions
      IX1 = 1
      IX2 = IX1 + 6*NSTATE
      CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
      IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,1)
      IF(PARENT) CALL FILECLOSE(14)


C     SAVE THE ROTATION MATRIX
      IF(PARENT) CALL W_MATRIX(ROTMAT,NSTATE)

      CALL FREEM(IP_LAG_MUL)
      IF(TG_ANTISYMM) CALL FREEM(IP_OMEGA_N)
      CALL FREEM(IP_Z1_MAT)
      CALL FREEM(IP_Z2_MAT)
      CALL FREEM(IP_ROTMAT)
      IF(TLSD) CALL FREEM(IP_ROTLSD)
      CALL TIHALT('G_LOC_SP_I',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE GIVE_SCR_G_LOC_SPREAD(LGLOC,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'g_loc.inc'
C     Arguments
      INTEGER   LGLOC,LGZLOC,NSTATE
      CHARACTER TAG*30
C     Variables
      LGZLOC = 1
      IF(GLOC_OPT .EQ. 1) THEN
        CALL GIVE_SCR_UPD_SPREAD_SUM(LGLOC,TAG,NSTATE)
      ELSEIF(GLOC_OPT .EQ. 2) THEN
        CALL GIVE_SCR_UPD_SPREAD_IDE(LGLOC,TAG,NSTATE)
      ENDIF
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
C     ==================================================================
      SUBROUTINE SPREADFUNC(Z1_MAT,Z2_MAT,LDX,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'g_loc.inc'
C     Arguments
      INTEGER    LDX,NSTATE
      COMPLEX*16 Z1_MAT(LDX,LDX,3),Z2_MAT(LDX,LDX,3)
C     Variables
      INTEGER    I,K
C     ==--------------------------------------------------------------==
      OFUN=0.D0

      DO I=1,NSTATE
        DO K=1,3
          OFUN=OFUN+DREAL(Z2_MAT(I,I,K)-
     *            Z1_MAT(I,I,K)*Z1_MAT(I,I,K))
        ENDDO
      ENDDO

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE Z12_UPDATE(RMAT,Z1_MAT,Z2_MAT,SCR,LDX,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'g_loc.inc'
C     Arguments
      INTEGER LDX,NSTATE
      COMPLEX*16  RMAT(NSTATE,NSTATE),Z1_MAT(LDX,LDX,3),
     &        Z2_MAT(LDX,LDX,3),SCR(NSTATE,NSTATE,2)
C     Variables
      INTEGER I,J,K
C     ==--------------------------------------------------------------==
      DO I=1,3

c        CALL DCOPY(2*NSTATE*NSTATE,Z1_MAT(1,1,I),1,SCR(1,1,1),1)
        DO J=1,NSTATE
          DO K=1,NSTATE
            SCR(J,K,1)=Z1_MAT(J,K,I)
          ENDDO
        ENDDO
        CALL ZGEMM('C','N',NSTATE,NSTATE,NSTATE,
     &             (1.D0,0.0D0),RMAT,NSTATE,
     *             SCR(1,1,1),NSTATE,(0.D0,0.0D0),SCR(1,1,2),NSTATE)
        CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,
     &             (1.D0,0.0D0),SCR(1,1,2),NSTATE,
     *             RMAT,NSTATE,(0.D0,0.0D0),SCR(1,1,1),NSTATE)
        DO J=1,NSTATE
          DO K=1,NSTATE
            Z1_MAT(J,K,I)=SCR(J,K,1)
          ENDDO
        ENDDO

        DO J=1,NSTATE
          DO K=1,NSTATE
            SCR(J,K,1)=Z2_MAT(J,K,I)
          ENDDO
        ENDDO

        CALL ZGEMM('C','N',NSTATE,NSTATE,NSTATE,
     &             (1.D0,0.0D0),RMAT,NSTATE,
     *             SCR(1,1,1),NSTATE,(0.D0,0.0D0),SCR(1,1,2),NSTATE)
        CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,
     &             (1.D0,0.0D0),SCR(1,1,2),NSTATE,
     *             RMAT,NSTATE,(0.D0,0.0D0),SCR(1,1,1),NSTATE)
        DO J=1,NSTATE
          DO K=1,NSTATE
            Z2_MAT(J,K,I)=SCR(J,K,1)
          ENDDO
        ENDDO
c        CALL DCOPY(2*NSTATE*NSTATE,SCR(1,1,1),1,Z2_MAT(1,1,I),1)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE G2_MAT(C0,C2,NSTATE,DDMAT,INDEX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'cnst.inc'
      include 'g_loc.inc'
      include 'metr.inc'
C     Arguments
      INTEGER    NSTATE,INDEX
      COMPLEX*16 C0(2*NGW,*),C2(2*NGW,*),DDMAT(NSTATE,*)
      REAL*8     NUMSEC(3),FAC
      INTEGER    I,II,IG
C     ==--------------------------------------------------------------==

      CALL AZZERO(DDMAT,2*NSTATE*NSTATE)

      NUMSEC(1) = DBLE(NR1S)
      NUMSEC(2) = DBLE(NR2S)
      NUMSEC(3) = DBLE(NR3S)

      FAC = HT(INDEX,1)*HT(INDEX,1)+HT(INDEX,2)*HT(INDEX,2)+
     &      HT(INDEX,3)*HT(INDEX,3)
      FAC = 4.0D0*DACOS(-1.0D0)*DACOS(-1.0D0)/FAC
      FAC = NUMSEC(INDEX)*NUMSEC(INDEX)*FAC
      FAC = 1.0D0/FAC


      DO I= 1,NSTATE 

        II=I

        DO IG=1,NGW
          C2(IG,II)     = GK(INDEX,IG)*GK(INDEX,IG) * TPIBA2
     &                     * C0(IG,II)
          C2(IG+NGW,II) = GK(INDEX,IG)*GK(INDEX,IG) * TPIBA2
     &                     * C0(IG+NGW,II)
        ENDDO
        IF(GEQ0)
     &   C2(1+NGW,II)=DCMPLX(0.D0,0.D0)
      ENDDO

      CALL ZGEMM('C','N',NSTATE,NSTATE,2*NGW,DCMPLX(1.D0,0.D0),
     *          C0,2*NGW,C2,2*NGW,DCMPLX(0.D0,0.D0),DDMAT,NSTATE)

      CALL DSCAL(2*NSTATE*NSTATE,FAC,DDMAT,1)

#ifdef PARALLEL
      CALL GLOSUM(2*NSTATE*NSTATE,DDMAT)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE G1_MAT(C0,C2,NSTATE,DDMAT,INDEX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'cnst.inc'
      include 'g_loc.inc'
      include 'metr.inc'
C     Arguments
      INTEGER    NSTATE,INDEX
      COMPLEX*16 C0(2*NGW,*),C2(2*NGW,*),DDMAT(NSTATE,*)
      REAL*8     NUMSEC(3),FAC
      INTEGER    I,II,IG
C     ==--------------------------------------------------------------==

      CALL AZZERO(DDMAT,2*NSTATE*NSTATE)

      NUMSEC(1) = DBLE(NR1S)
      NUMSEC(2) = DBLE(NR2S)
      NUMSEC(3) = DBLE(NR3S)

      FAC = HT(INDEX,1)*HT(INDEX,1)+HT(INDEX,2)*HT(INDEX,2)+
     &      HT(INDEX,3)*HT(INDEX,3)
      FAC = 2.0D0*DACOS(-1.0D0)/DSQRT(FAC)
      FAC = NUMSEC(INDEX)*FAC
      FAC = 1.0D0/FAC


      DO I=1,NSTATE 

        II=I

        DO IG=1,NGW
          C2(IG,II)     = GK(INDEX,IG) * TPIBA
     &                     * C0(IG,II)
          C2(IG+NGW,II) = -GK(INDEX,IG) * TPIBA
     &                     * C0(IG+NGW,II)
        ENDDO
        IF(GEQ0)
     &   C2(1+NGW,II)=DCMPLX(0.D0,0.D0)
      ENDDO

      CALL ZGEMM('C','N',NSTATE,NSTATE,2*NGW,DCMPLX(1.D0,0.D0),
     *          C0,2*NGW,C2,2*NGW,DCMPLX(0.D0,0.D0),DDMAT,NSTATE)

      CALL DSCAL(2*NSTATE*NSTATE,FAC,DDMAT,1)

#ifdef PARALLEL
      CALL GLOSUM(2*NSTATE*NSTATE,DDMAT)
#endif

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
