C     ==================================================================
      SUBROUTINE G_LOC_SPREAD_SUM(C1,C2,SCR,LSCR,NSTATE,NFI)
C     ==--------------------------------------------------------------==
C     == CALCULATES LOCALIZED FUNCTIONS IN G SPACE                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'geq0.inc'
      include 'ions.inc'
      include 'cnst.inc'
      include 'ddip.inc'
      include 'gvec.inc'
      include 'irat.inc'
      include 'rmas.inc'
      include 'g_loc.inc'
      include 'spin.inc'
      include 'cppt.inc'
      include 'fileopen.inc'

C     input
      INTEGER    LSCR,NSTATE,NFI
      REAL*8     SCR(*)
      COMPLEX*16 C1(NGWK,*),C2(NGWK,NSTATE)
C     local

      INTEGER      I,J,ISUB,LSCR2,IX1,IX2,IX3,IX4,IXL
      INTEGER      IREP,MAXREP,MSGLEN,LENGTH,LSCR3
      CHARACTER*30 TAG
      REAL*8       XRANF,FAC
      EXTERNAL     XRANF
      COMPLEX*16   GMAT(NSTATE,NSTATE)
      POINTER      (IP_GMAT,GMAT)

C     ==--------------------------------------------------------------==
C..   Localized orbitals functions
      COMPLEX*16   Z1_MAT(NSTATE,NSTATE,3),Z2_MAT(NSTATE,NSTATE,3)
      COMPLEX*16   ROTMAT(NSTATE,NSTATE),ROTLSD(*),U_GRAD(NSTATE,NSTATE)
      COMPLEX*16   ZONE,ZZERO
      POINTER      (IP_Z1_MAT,Z1_MAT),(IP_Z2_MAT,Z2_MAT),
     &             (IP_ROTMAT,ROTMAT),(IP_ROTLSD,ROTLSD),
     &             (IP_U_GRAD,U_GRAD)
      SAVE         IP_Z1_MAT,IP_Z2_MAT,IP_ROTMAT,IP_ROTLSD
      INTEGER      L_LAG_MUL
      LOGICAL      EXSOFT,FERROR

C     ==--------------------------------------------------------------==

      L_LAG_MUL  = 2*NSTATE*NSTATE
      CALL MEMORY(IP_LAG_MUL,L_LAG_MUL,'LAG_MUL')
      CALL AZZERO(LAG_MUL,L_LAG_MUL)

      IF(TG_ANTISYMM)  THEN
        CALL MEMORY(IP_OMEGA_N,NSTATE,'OMEGA_N')
        CALL AZZERO(OMEGA_N,NSTATE)
      ENDIF


      CALL TISET('G_LOC_SP_S',ISUB)
      CALL GIVE_SCR_G_LOC_SPREAD(LENGTH,TAG,NSTATE)
      CALL TEST_SCR('GLOC_SPREAD_SUM','LENGTH',LSCR,LENGTH)

      GMAX = 0.0D0
      MAXREP = GLOC_MAXS
      NSTEP  = GLOC_INIT
      ZONE   = dcmplx(1.0D0,0.0D0)
      ZZERO  = dcmplx(0.0D0,0.0D0)

C..   initialization for localized function part

      CALL MEMORY(IP_Z1_MAT,2*NSTATE*NSTATE*3,'Z1_MAT')
      CALL MEMORY(IP_Z2_MAT,2*NSTATE*NSTATE*3,'Z2_MAT')
      CALL MEMORY(IP_ROTMAT,2*NSTATE*NSTATE,'ROTMAT')


c      CALL PLANE_WAVES_SHELL(C1,NSTATE)

      IF(PARENT) CALL FILEOPEN(14,FILCEN,FO_DEF,FERROR)
C AK 2005/04/08; FIXME, this looks suspicious. why only for serial runs?
#ifndef PARALLEL
      FAC = TPIBA * FBOHR
      DO i = 1,2*NSTATE
        write(14,'(A,3f12.5,I10)') 'H',GK(1,I)*FAC,GK(2,I)*FAC,
     &                              GK(3,I)*FAC,I
        write(14,'(A,3f12.5,I10)') 'H',-GK(1,I)*FAC,-GK(2,I)*FAC,
     &                              -GK(3,I)*FAC,I+NGW
      ENDDO
#endif

      IF(TG_READ_MATRIX)  THEN
        IF(PARENT) CALL R_MATRIX(ROTMAT,NSTATE)
#ifdef PARALLEL
        MSGLEN=2*NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
#endif
C     rotate the wavefunctions to the localized representation

        CALL ROTATE_C((1.D0,0.0D0),C1,(0.D0,0.0D0),C2,ROTMAT,NSTATE)
        CALL DCOPY(2*2*NGW*NSTATE,C2,1,C1,1)
        if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)
      ENDIF

C     calculate the centers and spread of the wannier functions
      IX1 = 1
      IX2 = IX1 + 6*NSTATE
      CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
      IF(PARENT) WRITE(6,
     *     ' (/,5x,A,/)')
     *     '_______CENTERS AND SPREAD BEFORE THE OPTIMIZATION_______'
      IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,0)


C..   calculation of 3 matrices :  <n |O_i| m>
C     where n and m address the electronic orbitals and i = x,y,z


      IF(TG_KICK) THEN

        CALL UNITARY_TRANS(C1,C2,NSTATE,SCR,LSCR)
        IF(PARENT) WRITE(6,'(/,A)') '     FIRST RANDOM ROTATION    '
C     calculate the centers and spread of the wannier functions
        IX1 = 1
        IX2 = IX1 + 6*NSTATE
        CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
        IF(PARENT) WRITE(6,
     *     ' (/,5x,A,/)')
     *     '_____ CENTERS AND SPREAD AFTER FIRST RANDOM ROTATION _____'
        IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,0)
      ENDIF


      CALL G2_MAT(C1,C2,NSTATE,SCR,1)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z2_MAT(1,1,1),1)

      CALL G2_MAT(C1,C2,NSTATE,SCR,2)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z2_MAT(1,1,2),1)

      CALL G2_MAT(C1,C2,NSTATE,SCR,3)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z2_MAT(1,1,3),1)

      CALL G1_MAT(C1,C2,NSTATE,SCR,1)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z1_MAT(1,1,1),1)

      CALL G1_MAT(C1,C2,NSTATE,SCR,2)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z1_MAT(1,1,2),1)

      CALL G1_MAT(C1,C2,NSTATE,SCR,3)
      CALL DCOPY(2*NSTATE*NSTATE,SCR,1,Z1_MAT(1,1,3),1)

#ifdef PARALLEL
      CALL MY_SYNC(ALLGRP)
#endif
 

      IF(PARENT) THEN
        CALL SPREADFUNC(Z1_MAT,Z2_MAT,NSTATE,NSTATE)
        write(6,'(A,F12.6)') 'AFTER FIRST ROTATION FUNC.= ',OFUN
      ENDIF

      IF(PARENT) THEN
        CALL FILEOPEN(10,FILSPR,FO_DEF,FERROR)
        CALL FILEOPEN(11,'umat.dat',FO_DEF,FERROR)

        IF(TG_ANTISYMM) CALL FILEOPEN(12,FILPEN,FO_DEF,FERROR)
c     initialize U = ROTMAT matrix
        CALL AZZERO(ROTMAT,2*NSTATE*NSTATE)
        DO I=1,NSTATE
          ROTMAT(I,I)=DCMPLX(1.D0,0.0D0)
        ENDDO
        CALL GET_ADDR(  IP_GMAT,SCR(1))
        CALL AZZERO(GMAT,2*NSTATE*NSTATE)
        IF(GLOC_RAN.GT.0.D0) THEN
C..   randomly distort initial vectors
          DO I=1,NSTATE
            GMAT(I,I)=DCMPLX(1.0D0,0.D0)
            DO J=I+1,NSTATE
              GMAT(I,J)=DCMPLX(XRANF()*GLOC_RAN,XRANF()*GLOC_RAN)
              GMAT(J,I)=DCONJG(GMAT(I,J))
            ENDDO
          ENDDO
          CALL ZEXPONENTIATE(GMAT,ROTMAT,NSTATE,SCR,LSCR)
          GLOC_RAN=0.D0
        ENDIF
      ENDIF

c     calculate the starting gradient
      IX1 = 1
      IXL = 2*NSTATE*NSTATE 
      IX2 = IXL + 1
      CALL GET_ADDR(IP_U_GRAD,SCR(IX1))
      LSCR2 = LSCR - IXL
      IX3 = IX2 + 3*2*NSTATE*NSTATE
      IX4 = IX3 + 3*2*NSTATE*NSTATE
      LSCR3 = LSCR2 - 2*3*2*NSTATE*NSTATE


      CALL ZAZZERO(U_GRAD,NSTATE*NSTATE)
      IF(PARENT)
     &   CALL U_GRAD_SPREAD_SUM(ROTMAT,U_GRAD,Z1_MAT,Z2_MAT,SCR(IX2),
     &       SCR(IX3),SCR(IX4),LSCR3,NSTATE,NSTATE)

c     startoptimization of ROTMAT

      DO IREP = 1,MAXREP

c
        IF(TG_ANTISYMM)  THEN
          CALL SIMM_OP_SUM(C1,ROTMAT,OMEGA_N,OMEGA_TOT,NSTATE)
c
c     &    CALL OMEGA_GRAD(C1,ROTMAT,U_GRAD,NSTATE,SCR(IX2),LSCR2)


#ifdef PARALLEL
          CALL GLOSUM(2*NSTATE*NSTATE,U_GRAD)
          CALL GLOSUM(NSTATE,OMEGA_N)
          CALL GLOSUM(1,OMEGA_TOT)

          CALL MY_SYNC(ALLGRP)
#endif
        ENDIF

        IF(PARENT) THEN

          CALL U_UPD_SPREAD_SUM(ROTMAT,Z1_MAT,Z2_MAT,U_GRAD,
     &           SCR(IX2),LSCR2,NSTATE)


        ENDIF
#ifdef PARALLEL
        CALL MY_SYNC(ALLGRP)

        MSGLEN= 8*LGLOCRE
        CALL MY_BCAST(OFUN,MSGLEN,SOURCE,ALLGRP)
#endif


        IF(GMAX.LT.GLOC_EPS) THEN
          GOTO 400
        ELSEIF(DABS(DIF_FUN) .LT. 1.D-10) THEN
          IF(PARENT) THEN 
            WRITE(6,'(/,A,1PE12.6)') '     OFUN-OFUN0 = ',
     &           DIF_FUN
            WRITE(6,'(A,/)') '   G_LOC_UPDATE: CONVERGENCE'
          ENDIF
          GOTO 400
        ELSEIF(IREP .EQ. MAXREP .OR. EXSOFT) THEN
          GOTO 500
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(EXSOFT) GOTO 500
      ENDDO

 500  IF(EXSOFT) WRITE(6,'(A,1E12.6)') 
     &            ' G_LOC_SPREAD_SUM|SOFTWERE EXIT (OFUNC)',OFUN
      IF(IREP .EQ. MAXREP) WRITE(6,'(A,I10)') 
     &            ' G_LOC_SPREAD_SUM| MAXREP REACHED ',MAXREP
 400  CONTINUE
c      stop '400'
      IF(PARENT) THEN
        CALL FILECLOSE(10)
        CALL FILECLOSE(11)
        IF(TG_ANTISYMM) CALL FILECLOSE(12)
      ENDIF


#ifdef PARALLEL
      MSGLEN=2*NSTATE*NSTATE * 8
      CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
#endif
C     rotate the wavefunctions to the localized representation
      CALL ROTATE_C((1.D0,0.0D0),C1,(0.D0,0.0D0),C2,ROTMAT,NSTATE)
      CALL DCOPY(2*2*NGW*NSTATE,C2,1,C1,1)
      if(GEQ0)   CALL ZCLEAN_K(C1,NSTATE,NGW)


C     calculate the centers and spread of the wannier functions
      IX1 = 1
      IX2 = IX1 + 6*NSTATE
      CALL GZLOC_CENTER(C1,NSTATE,SCR(IX1),SCR(IX2))
      IF(PARENT) CALL GLOC_PRINT(NSTATE,SCR,1)
      IF(PARENT) CALL FILECLOSE(14)

      IF(TG_READ_MATRIX)  THEN
        IF(PARENT) CALL R_MATRIX(LAG_MUL,NSTATE)

#ifdef PARALLEL
        MSGLEN=2*NSTATE*NSTATE * 8
        CALL MY_BCAST(LAG_MUL,MSGLEN,SOURCE,ALLGRP)
#endif
        CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,ZONE,LAG_MUL,
     &             NSTATE,ROTMAT,NSTATE,ZZERO,C2,NSTATE)
        CALL DCOPY(2*NSTATE*NSTATE,C2,1,ROTMAT,1)
      ENDIF

C     SAVE THE ROTATION MATRIX
      IF(PARENT) CALL W_MATRIX(ROTMAT,NSTATE)

      IF(TG_ANTISYMM) CALL FREEM(IP_OMEGA_N)
      CALL FREEM(IP_LAG_MUL)

      CALL FREEM(IP_Z1_MAT)
      CALL FREEM(IP_Z2_MAT)
      CALL FREEM(IP_ROTMAT)

      IF(TLSD) CALL FREEM(IP_ROTLSD)
      CALL TIHALT('G_LOC_SP_S',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================

