      SUBROUTINE G_LOC_XYZMAT(C0,C2,XYZMAT,SCR,LSCR,NSTATE,TAU0)
C     ==--------------------------------------------------------------==
C     == CALCULATES FUNCTIONAL FOR WFN LOCALIZATION IN DIRECT SPACE   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'geq0.inc'
c      include 'ions.inc'
      include 'cnst.inc'
      include 'ddip.inc'
      include 'gvec.inc'
      include 'irat.inc'
c      include 'rmas.inc'
      include 'wann.inc'
      include 'spin.inc'
      include 'elct.inc'

C input
      INTEGER     LSCR,NSTATE
      COMPLEX*16  C0(NGWK,*),C2(*)
      REAL*8      SCR(*),TAU0(*)
      COMPLEX*16  XYZMAT(NSTATE,NSTATE,*)
C local
      CHARACTER*30 TAG
      INTEGER      MAPFUL(*),MAPCOL(*)
      POINTER      (IP_MAPFUL,MAPFUL),(IP_MAPCOL,MAPCOL)
      SAVE         IP_MAPFUL,IP_MAPCOL
      INTEGER      ISUB,LENGTH,N1,IP1,IP2,I,nmcol,nxx,lscr2
#ifdef PARALLEL 
      INTEGER NXXFUN
      EXTERNAL NXXFUN
#endif

      COMPLEX*16   SC1(*)
      pointer      (IP_SC1,SC1)

C     ==--------------------------------------------------------------==
      CALL TISET(' G_LOC_XYZ' ,ISUB)
      CALL GIVE_SCR_XYZMAT(LENGTH,TAG)
      CALL TEST_SCR('G_LOC_XYZMAT','LENGTH',LSCR,LENGTH)

C..initialization
      N1=0
      DO I=0,NPROC-1
        N1=MAX(N1,SPARM(3,I))
      ENDDO
      NGWMAX=N1
      CALL MEMORY(IP_MAPFUL,2*(NGWS/IRAT+1),'MAPFUL')
#ifdef PARALLEL
      NMCOL=(NPROC*NGWMAX)/IRAT+1
#else
      NMCOL=1
#endif
      CALL MEMORY(IP_MAPCOL,NMCOL,'MAPCOL')
      CALL SETDIP(MAPFUL,MAPCOL,SCR,LSCR)

#ifdef PARALLEL
        LENBK=NXXFUN(NSTATE)
        NXX=MAX(2*2*LENBK*NPROC,2*NGWK*NSTATE)
#else
        NXX=2*NGWK*NSTATE
#endif
      CALL MEMORY(IP_SC1,NXX,'SC1')


C..initialization for Wannier function part
C..electronic contribution
      IP1=1
      IP2=1+2*NSTATE*NSTATE
      LSCR2=LSCR-IP2
      IF(LSCR2.LT.1) CALL STOPGM('DDIPO','NOT ENOUGH SCRATCH SPACE')
      CALL G_LOC_OPEIGR(C0,C2,SC1,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,1,0)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,1),1)
      CALL G_LOC_OPEIGR(C0,C2,SC1,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,2,0)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,2),1)
      CALL G_LOC_OPEIGR(C0,C2,SC1,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,3,0)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,3),1)
      DO I=4,NWANOPT
        CALL G_LOC_OPEIGR(C0,C2,SC1,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,IOW(1,I-3),IOW(2,I-3))
        CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,I),1)
      ENDDO

C  First check of the spread, before the minimization of the functional
      IF(PARENT) THEN
        WRITE(6,'(/,1X,64(1H*))')
        WRITE(6,'(" ****",6X,A,6X,"****",/)') 
     &        'CENTERS AND SPREAD BEFORE THE OPTIMIZATION'
        W_TYPE = 1
c        W_REF(1) = -0.0D0
c        W_REF(2) = -0.0D0
c        W_REF(3) = -0.0D0
      ENDIF
      CALL WANNIER_CENTER(XYZMAT,NSTATE,NSTATE,SCR,TAU0)
      IF(PARENT) CALL WC_PRINT(NSTATE,SCR)
      
      CALL FREEM(IP_SC1)
      CALL FREEM(IP_MAPFUL)
      CALL FREEM(IP_MAPCOL)

      CALL TIHALT(' G_LOC_XYZ' ,ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GXYZFUNC(XYZMAT,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'g_loc.inc'
      INCLUDE 'wann.inc'
C     Arguments
      INTEGER    NSTATE
      REAL*8 XYZMAT(2,NSTATE,NSTATE,NWANOPT)
C     Variables
      INTEGER    I,K
C     ==--------------------------------------------------------------==
      XYZFUN = 0.D0

      DO I=1,NSTATE
         DO K=1,NWANOPT
            XYZFUN=XYZFUN+WWEI(K)*(1.0D0-(
     *           XYZMAT(1,I,I,K)*XYZMAT(1,I,I,K)+
     *           XYZMAT(2,I,I,K)*XYZMAT(2,I,I,K)))
         ENDDO
      ENDDO
      XYZFUN=XYZFUN/ALAT**2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_XYZMAT(LDDIPO,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'wann.inc'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER   LDDIPO
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LSETDIP,LOPEIGR
C     ==--------------------------------------------------------------==
      NSTATE=N
c      NMAX=NSTATE
c      IF(TLSD) NMAX=MAX(NSUP,NSDOWN)
      CALL GIVE_SCR_OPEIGR(LOPEIGR,TAG,NSTATE)
      LOPEIGR = LOPEIGR + 2*NSTATE*NSTATE
      LSETDIP=NGWS/2+1
      LDDIPO=MAX(LSETDIP,LOPEIGR)+100
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
       SUBROUTINE CALC_U_WGRAD_SUM(U_MAT,U_GRAD,XYZMAT,XYZOLD,
     &            SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     ==          CALCULATES THE GRADIENT OF THE  FUNCTIONAL          ==
C     ==          WHICH DEFINES THE SPREAD IN  R SPACE                ==
C     ==  WITH RESPECT TO THE UNITARY MATRIX COEFFICIENTS             ==
C     ==  U_GRAD_ij = -d OFUNC / d U_ij                               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'g_loc.inc'
      include 'spin.inc'
      include 'wann.inc'
C input
      INTEGER    LSCR,NSTATE
      COMPLEX*16 U_MAT(NSTATE,NSTATE),U_GRAD(NSTATE,NSTATE),
     &           XYZMAT(NSTATE,NSTATE,NWANOPT),
     &           XYZOLD(NSTATE,NSTATE,NWANOPT)
      REAL*8     SCR(*)
C local
      INTEGER    LMAT,IX1,L_ZU,IX2,L_UZ,I,J,K,L,ISUB
      COMPLEX*16 ZU(NSTATE,NSTATE),UZ(NSTATE,NSTATE)
      pointer (IP_ZU,ZU),(IP_UZ,UZ)
C     ==--------------------------------------------------------------==
      CALL TISET(' WGRAD_SUM',ISUB)

      LMAT = 2*NSTATE*NSTATE

c      CALL TEST_SCR('CALC_U_GRAD','ZU and UZ',LSCR,IXL)
      CALL DCOPY(LMAT*NWANOPT,XYZMAT,1,XYZOLD,1)
      CALL Z_UPDATE(U_MAT,XYZMAT,SCR(1),NSTATE,NSTATE,NWANOPT)

      IF(WAN_WEIGHT .EQ. 0.0D0) THEN
        GOTO 100
      ELSE

        IX1  = 1
        L_ZU = 2*NSTATE*NSTATE
        IX2  = 1+L_ZU
        L_UZ = 2*NSTATE*NSTATE

        CALL GET_ADDR(IP_ZU,SCR(IX1))
        CALL GET_ADDR(IP_UZ,SCR(IX2))

        DO K = 1,NWANOPT
          CALL AZZERO(ZU,4*NSTATE*NSTATE)
c          CALL AZZERO(UZ,2*NSTATE*NSTATE)
 
          DO J = 1,NSTATE
            DO I = 1,NSTATE
              DO L = 1,NSTATE
               ZU(I,J) = ZU(I,J) + XYZOLD(I,L,K)*U_MAT(L,J)
              ENDDO
            ENDDO

            DO I = 1,NSTATE
              DO L = 1,NSTATE
               UZ(I,J) = UZ(I,J) + DCONJG(XYZOLD(L,I,K))*U_MAT(L,J)
              ENDDO
            ENDDO

            DO I = 1,NSTATE
              U_GRAD(I,J) = U_GRAD(I,J)+WAN_WEIGHT*(
     &                  ZU(I,J)*DCONJG(XYZMAT(J,J,K)) +
     &                  UZ(I,J)*XYZMAT(J,J,K))
            ENDDO
          ENDDO
        ENDDO
      ENDIF
 100  CONTINUE

      CALL GXYZFUNC(XYZMAT,NSTATE)
      CALL DCOPY(LMAT*NWANOPT,XYZOLD,1,XYZMAT,1)
      CALL TIHALT(' WGRAD_SUM',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==


