C     ==================================================================
      SUBROUTINE GEOFILE(TAU0,VELP,TAG)
C     ==--------------------------------------------------------------==
C     == READ AND WRITE THE GEOMETRY FILE                             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mw.inc'
C     Arguments
      REAL*8    TAU0(3,NAX,NSX),VELP(3,NAX,NSX)
      CHARACTER TAG*5
C     Variables
      REAL*8   GR_TAU(3,*),GR_VEL(3,*),TAUS(3,NAX,NSX)
      INTEGER  GR_IAT(*)
      POINTER  (IP_GR_TAU,GR_TAU),(IP_GR_VEL,GR_VEL),(IP_GR_IAT,GR_IAT)
      POINTER  (IP_TAUS,TAUS)
      CHARACTER*12 CFLBOD,CIPNUM
      INTEGER   IUNIT,I1,I2,N1,N2
      PARAMETER (IUNIT=12)
      INTEGER   IS,IA,K,I,IP
      CHARACTER FILEN*100,FILEN2*100,FILEN3*100
      LOGICAL   FERROR,STATUS
C     ==--------------------------------------------------------------==
      CALL mm_dim(mm_go_mm,status)
      CALL MEMORY(IP_GR_TAU,NAT*3,'GR_TAU')
      CALL MEMORY(IP_GR_VEL,NAT*3,'GR_VEL')
      CALL MEMORY(IP_GR_IAT,(NAT+1)/IRAT,'GR_IAT')
      IF(TPATH.OR.TMW) THEN
        IF(TPATH)IP=IPCURR
        IF(TMW)IP=WALKER_ID
        IF(IP.EQ.0) THEN
          FILEN='GEOMETRY'
          FILEN2='GEOMETRY.xyz'
          FILEN3='GEOMETRY.scale'
        ELSE
          CFLBOD='GEOMETRY_'
          CALL MW_FILENAME(CFLBOD,FILEN,IP)
          CALL XSTRING(FILEN,I1,I2)
          FILEN2=FILEN(I1:I2)//'.xyz'
          FILEN3=FILEN(I1:I2)//'.scale'
        ENDIF
      ELSE
        FILEN='GEOMETRY'
        FILEN2='GEOMETRY.xyz'
        FILEN3='GEOMETRY.scale'
      ENDIF
      IF(INDEX(TAG,'READ').NE.0) THEN
        CALL FILEOPEN(IUNIT,FILEN,FO_OLD+FO_NOFP,FERROR)
        IF(FERROR) THEN
          WRITE(6,'(A)') ' GEOFILE! FILE GEOMETRY DOES NOT EXIST!!'
          CALL STOPGM('GEOFILE','DO NOT READ OLD COORDINATES')
        ENDIF
        REWIND(IUNIT)
        IF(TQMMM)THEN
          DO I=1,NAT
            READ(IUNIT,ERR=998,FMT=*)
     *          (GR_TAU(K,I),K=1,3),(GR_VEL(K,I),K=1,3) 
            DO K=1,3
               TAU0(K,cpat(I),cpsp(I))=GR_TAU(K,I)+MM_C_TRANS(K)
               VELP(K,cpat(I),cpsp(I))=GR_VEL(K,I)
            END DO
          ENDDO
        ELSE
          DO IS=1,NSP
            DO IA=1,NA(IS)
              READ(IUNIT,ERR=998,FMT=*)
     *            (TAU0(K,IA,IS),K=1,3),(VELP(K,IA,IS),K=1,3)
            ENDDO
          ENDDO
        END IF
        WRITE(6,'(/,A,A,/)') ' ATOMIC COORDINATES AND VELOCITIES READ ',
     *     'FROM FILE GEOMETRY'
        IF(TPRCP) THEN
          DO I=1,3
            READ(IUNIT,ERR=999,FMT=*) HT(I,1),HT(I,2),HT(I,3),
     *                 HTVEL(I,1),HTVEL(I,2),HTVEL(I,3)
          ENDDO
          WRITE(6,'(A,A,/)') ' CELL PARAMETERS AND VELOCITIES READ ',
     *     'FROM FILE GEOMETRY'
        ENDIF
        CALL FILECLOSE(IUNIT)
      ELSEIF(INDEX(TAG,'WRITE').NE.0) THEN
        I=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            I=I+1
            GR_IAT(NAT_grm(I))=IATYP(IS)
            DO K=1,3
              GR_TAU(K,NAT_grm(I))=TAU0(K,IA,IS)+MM_C_TRANS(K)
              GR_VEL(K,NAT_grm(i))=VELP(K,IA,IS)
            ENDDO
          ENDDO
        ENDDO
        CALL FILEOPEN(IUNIT,FILEN,FO_DEF+FO_NOFP,FERROR)
        REWIND(IUNIT)
        DO I=1,NAT
            WRITE(IUNIT,'(3F20.12,8X,3F20.12)')
     &         (GR_TAU(K,I),K=1,3),(GR_VEL(K,I),K=1,3)
        ENDDO
        IF(TPRCP) THEN
          DO I=1,3
            WRITE(IUNIT,*) HT(I,1),HT(I,2),HT(I,3),
     *                 HTVEL(I,1),HTVEL(I,2),HTVEL(I,3)
          ENDDO
        ENDIF
        CALL FILECLOSE(IUNIT)

C       WRITE ALSO A GEOMETRY.xyz file:
        CALL FILEOPEN(IUNIT,FILEN2,FO_DEF+FO_NOFP,FERROR)
        REWIND(IUNIT)
        WRITE(IUNIT,'(I8)') NAT
        WRITE(IUNIT,'(A)') 'GEOMETRY FILE / created by CPMD'
        DO I=1,NAT
          WRITE(IUNIT,'(A3,3F20.12,8X,3F20.12)') EL(GR_IAT(I)),
     &         (GR_TAU(K,I)/FBOHR,K=1,3),(GR_VEL(K,I)/FBOHR,K=1,3)
        ENDDO
        CALL FILECLOSE(IUNIT)

        IF(TSCALE) THEN
C         WRITE ALSO A GEOMETRY.scale file:
          CALL FILEOPEN(IUNIT,FILEN3,FO_DEF+FO_NOFP,FERROR)
          REWIND(IUNIT)
          WRITE(IUNIT,'(A)') "CELL MATRIX (BOHR)"
          DO I=1,3
            WRITE(IUNIT,'(3F20.12)') HT(I,1),HT(I,2),HT(I,3)
          ENDDO
          WRITE(IUNIT,'(/,A)') "CELL MATRIX (ANGSTROM)"
          DO I=1,3
            WRITE(IUNIT,'(3F20.12)') 
     *        HT(I,1)/FBOHR,HT(I,2)/FBOHR,HT(I,3)/FBOHR
          ENDDO
          CALL MEMORY(IP_TAUS,3*NAX*NSP,'TAUS')
          CALL C_TO_S(TAU0,TAUS)
          WRITE(IUNIT,'(/,A)') "SCALED ATOMIC COORDINATES"
          DO IS=1,NSP
            DO IA=1,NA(IS)
              WRITE(IUNIT,'(3F20.12,8X,A3,I7)')
     *            (TAUS(K,IA,IS),K=1,3),EL(IATYP(IS)),IA
            ENDDO
          ENDDO
          CALL FREEM(IP_TAUS)
          CALL FILECLOSE(IUNIT)
        ENDIF

      ELSE
        WRITE(6,'(A,A)') ' GEOFILE| UNKNOWN TAG: ',TAG
      ENDIF
      CALL mm_dim(mm_revert,status)
      CALL FREEM(IP_GR_TAU)
      CALL FREEM(IP_GR_VEL)
      CALL FREEM(IP_GR_IAT)
C     ==--------------------------------------------------------------==
      RETURN
C     ==--------------------------------------------------------------==
C     Error reading TAU0
 998  CONTINUE
      WRITE(6,'(A)') ' GEOFILE ! ERROR WHILE READING COORDINATES'
      CALL STOPGM('GEOFILE','READ ERROR')
 999  CONTINUE
      WRITE(6,'(A)') ' GEOFILE ! ERROR WHILE READING VELOCITIES'
      CALL STOPGM('GEOFILE','READ ERROR')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
