C     ==================================================================
      SUBROUTINE GETCOR(TAUP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'pimd.inc'
C     Arguments
      REAL*8    TAUP(3,NAX,NSX,*)
C     Variables
      INTEGER   IP,IPP,IIPP,ITAU,IS,IA
      REAL*8    VAR,XLM,YLM,ZLM
C     ==--------------------------------------------------------------==
C     ==  CALCULATE IMAGINARY TIME CORRELATION OF POSITIONS           == 
C     ==--------------------------------------------------------------==
      CALL AZZERO(RCORR,NAX*NSX*NP_TOTAL)
      CALL IAZZERO(IRCORR,NAX*NSX*NP_TOTAL)
      DO IP=1,NP_TOTAL
        ITAU=0
        DO IPP=IP,IP+NP_TOTAL-1
          IIPP=IPP-NP_TOTAL*(IPP/(NP_TOTAL+1))
          ITAU=ITAU+1
          IF(ITAU.LE.NP_TOTAL/2+1) THEN
            DO IS=1,NSP
              DO IA=1,NA(IS)
                XLM=TAUP(1,IA,IS,IP)-TAUP(1,IA,IS,IIPP)
                YLM=TAUP(2,IA,IS,IP)-TAUP(2,IA,IS,IIPP)
                ZLM=TAUP(3,IA,IS,IP)-TAUP(3,IA,IS,IIPP)
                CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
                VAR=XLM**2+YLM**2+ZLM**2
                RCORR(IA,IS,ITAU)=RCORR(IA,IS,ITAU)+VAR
                IRCORR(IA,IS,ITAU)=IRCORR(IA,IS,ITAU)+1
              ENDDO
            ENDDO
          ENDIF
        ENDDO
      ENDDO  
C     ==--------------------------------------------------------------==
C     ==  CALCULATE IMAGINARY TIME CORRELATION OF KS-FORCES           ==
C     ==--------------------------------------------------------------==
      CALL AZZERO(FCORR,NAX*NSX*NP_TOTAL)
      CALL IAZZERO(IFCORR,NAX*NSX*NP_TOTAL)
      DO IP=1,NP_TOTAL
        ITAU=0
        DO IPP=IP,IP+NP_TOTAL-1
          IIPP=IPP-NP_TOTAL*(IPP/(NP_TOTAL+1))
          ITAU=ITAU+1
          IF(ITAU.LE.NP_TOTAL/2+1) THEN
            DO IS=1,NSP
              DO IA=1,NA(IS)
                XLM=FIONKS(1,IA,IS,IP)-FIONKS(1,IA,IS,IIPP)
                YLM=FIONKS(2,IA,IS,IP)-FIONKS(2,IA,IS,IIPP)
                ZLM=FIONKS(3,IA,IS,IP)-FIONKS(3,IA,IS,IIPP)
                VAR=XLM**2+YLM**2+ZLM**2
                FCORR(IA,IS,ITAU)=FCORR(IA,IS,ITAU)+VAR
                IFCORR(IA,IS,ITAU)=IFCORR(IA,IS,ITAU)+1
              ENDDO
            ENDDO
          ENDIF
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
