C     ==================================================================
      SUBROUTINE GETFNM(FION,FSTAGE,STAGE,IFLAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'cnst.inc'
C     Arguments
      INTEGER   IFLAG
      REAL*8    FION(3,NAX,NSX,*),FSTAGE(3,NAX,NSX,*),STAGE(3,NAX,NSX,*)
C     Variables
      INTEGER   NPX,IP,I,IS,IA,JP
      REAL*8    RNP,OMEGAP,OMP2,FH
C     ==--------------------------------------------------------------==
      NPX=NP_TOTAL
      RNP=DBLE(NPX)
      DO IP=1,NPX
        EHARV(IP) = 0.D0
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  PERFORM TRANSFORMATION FR --> FU                            ==
C     ==  FU_i = \sum_j FR_j*TNMI(j,i) (FR ASSUMED TO BE DIVIDED BY P)==
C     ==  IFLAG=1 : CALCULATE FSTAGE (INCLUDING HARMONIC FORCE)       ==
C     ==            AND HARMONIC ENERGY (IN EHARV(IP))                ==
C     ==        0   CALCULATE ONLY HARMONIC ENERGY (IN EHARV(IP))     ==
C     ==            WITHOUT CHANGING FSTAGE                           ==
C     ==--------------------------------------------------------------==
      OMEGAP = DSQRT(RNP)*TEMPW/FACTEM
      OMP2 = OMEGAP*OMEGAP
      IF(IFLAG.EQ.1) THEN
        CALL AZZERO(FSTAGE,3*NAX*NSX*NPX)
        DO I=1,3
          DO IS=1,NSP
            DO IA=1,NA(IS)
              DO IP=1,NPX
                DO JP=1,NPX
                  FSTAGE(I,IA,IS,IP) = FSTAGE(I,IA,IS,IP) +
     *                                 FION(I,IA,IS,JP)*TNMI(JP,IP)
                ENDDO
              ENDDO
              DO IP=2,NPX
                FH = -PMARS(IS,IP)*OMP2*STAGE(I,IA,IS,IP)
                FSTAGE(I,IA,IS,IP) = FSTAGE(I,IA,IS,IP) + FH
                EHARV(IP) = EHARV(IP) - 0.5D0*FH*STAGE(I,IA,IS,IP)
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ELSE
        DO I=1,3
          DO IS=1,NSP
            DO IA=1,NA(IS)
              DO IP=2,NPX
                FH = -PMARS(IS,IP)*OMP2*STAGE(I,IA,IS,IP)
                EHARV(IP) = EHARV(IP) - 0.5D0*FH*STAGE(I,IA,IS,IP)
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
