C     ==================================================================
      SUBROUTINE GETFU(FION,FSTAGE,STAGE,IFLAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'cnst.inc'
C     Arguments
      INTEGER IFLAG
      REAL*8  FION(3,NAX,NSX,*),FSTAGE(3,NAX,NSX,*),STAGE(3,NAX,NSX,*)
C     Variables
      INTEGER NPX,IP,I,IS,IA
      REAL*8  RNP,OMEGAP,OMP2,FBAR,FH
C     ==--------------------------------------------------------------==
      NPX=NP_TOTAL
      RNP=DBLE(NPX)
      DO IP=1,NPX
        EHARV(IP) = 0.D0
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  PERFORM TRANSFORMATION FR --> FU                            ==
C     ==  FU_1 = \sum_{s=1}^P FR_s (FR IS ASSUMED TO BE DIVIDED BY P) ==
C     ==  FU_s = [(s-2)/(s-1)]*FU_{s-1} + FR_s                        ==
C     ==  IFLAG=1 : CALCULATE FSTAGE (INCLUDING HARMONIC FORCE)       ==
C     ++            AND HARMONIC ENERGY (IN EHARV(IP))                ==
C     ==        0   CALCULATE ONLY HARMONIC ENERGY (IN EHARV(IP))     ==
C     ==            WITHOUT CHANGING FSTAGE                           ==
C     ==--------------------------------------------------------------==
      OMEGAP = DSQRT(RNP)*TEMPW/FACTEM
      OMP2 = OMEGAP*OMEGAP
      IF(IFLAG.EQ.1) THEN
        DO I=1,3
          DO IS=1,NSP
            DO IA=1,NA(IS)
              FBAR = 0.0D0
              DO IP=1,NPX
                FBAR = FBAR + FION(I,IA,IS,IP)
              ENDDO
              FSTAGE(I,IA,IS,1) = FBAR
              DO IP=2,NPX
                FSTAGE(I,IA,IS,IP) = DBLE(IP-2)*FSTAGE(I,IA,IS,IP-1)
     *                         /DBLE(IP-1)
     *                        + FION(I,IA,IS,IP)
              ENDDO
              DO IP=2,NPX
                FH = -PMARS(IS,IP)*OMP2*STAGE(I,IA,IS,IP)
                FSTAGE(I,IA,IS,IP) = FSTAGE(I,IA,IS,IP) + FH
                EHARV(IP) = EHARV(IP) - 0.5D0*FH*STAGE(I,IA,IS,IP)
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ELSE
        DO I=1,3
          DO IS=1,NSP
            DO IA=1,NA(IS)
              DO IP=2,NPX
                FH = -PMARS(IS,IP)*OMP2*STAGE(I,IA,IS,IP)
                EHARV(IP) = EHARV(IP) - 0.5D0*FH*STAGE(I,IA,IS,IP)
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
