C     ==================================================================
      SUBROUTINE GETTRANS(TRANSITION,C1,CVIR,SCR,LSCR,NSTATE,
     &                    NVIR,NAP,NBP,NLR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER NSTATE,NVIR,NLR,NAP,NBP,LSCR
      INTEGER TRANSITION(3,4,*)
      COMPLEX*16 C1(NGW,NSTATE,*),CVIR(NGW,*)
      REAL*8 SCR(NVIR,*)
C     Variables
      DIMENSION UROT(NSTATE,NUB,*)
      LOGICAL DEBUG,OSTDA
      INTEGER IS,I,J,IV,I1,I2,IZ,NZ,IDAMAX,LSC2
      REAL*8 VAL,VLAST
      REAL*8 DOTP
      EXTERNAL DOTP
      REAL*8 TRANS(NVIR,*),TROT(NVIR,*),SC2(*)
      REAL*8 UMAT(NUA,NSTATE),PMAT(NSTATE,NSTATE),PEIG(NSTATE)
      POINTER (IP_TRANS,TRANS),(IP_TROT,TROT),(IP_SC2,SC2)
      POINTER (IP_UMAT,UMAT),(IP_PMAT,PMAT),(IP_PEIG,PEIG)
C     ==================================================================
      OSTDA=(TDA.AND.MSUBTA.GT.0.AND..NOT.TDACANON)
      DEBUG=.FALSE.
      CALL SCRSET(SCR,LSCR,DEBUG)
      IF(OSTDA) THEN
        NZ=NUA
      ELSE
        NZ=NSTATE
      ENDIF
      CALL SCRPTR(SCR,LSCR,IP_TRANS,NVIR*NZ,'TRANS',DEBUG)
      CALL AZZERO(TRANS,NVIR*NZ)
      DO IS=1,NLR
        IF(TLSD) THEN
          DO IV=1,NAP
            DO J=1,NSUP
              TRANS(IV,J)=SQRT(2.D0)*DOTP(NGW,C1(1,J,IS),CVIR(1,IV))
            ENDDO
          ENDDO
          DO IV=NAP+1,NAP+NBP 
            DO J=NSUP+1,NSTATE
              TRANS(IV,J)=SQRT(2.D0)*DOTP(NGW,C1(1,J,IS),CVIR(1,IV))
            ENDDO
          ENDDO
        ELSE
          DO IV=1,NVIR
            DO J=1,NSTATE
              TRANS(IV,J)=DOTP(NGW,C1(1,J,IS),CVIR(1,IV))
            ENDDO
          ENDDO
        ENDIF
        CALL GLOSUM(NVIR*NSTATE,TRANS)
        IF(OSTDA) THEN
          CALL SCRPTR(SCR,LSCR,IP_TROT,NVIR*NZ,'TROT',DEBUG)
          CALL SCRPTR(SCR,LSCR,IP_UMAT,NUA*NUB,'UMAT',DEBUG)
          CALL SCRPTR(SCR,LSCR,IP_PMAT,NUB*NUB,'UMAT',DEBUG)
          CALL SCRPTR(SCR,LSCR,IP_PEIG,NUB,'PEIG',DEBUG)
          CALL SCRGET(SCR,LSCR,IP_SC2,LSC2,'SC2',DEBUG)
          CALL GET_U(UROT(1,1,IS),UMAT,PMAT,PEIG,NUA,NUB,SC2,LSC2)
          CALL DCOPY(NVIR*NZ,TRANS,1,TROT,1)
          CALL AZZERO(TRANS,NVIR*NSTATE)
          DO IV=1,NVIR
            DO IZ=1,NZ
              DO J=1,NSTATE
                TRANS(IV,J)=TRANS(IV,J)+UMAT(J,IZ)*TROT(IV,IZ)
              ENDDO
            ENDDO
          ENDDO
        ENDIF
        VLAST=0.D0
        DO IZ=1,4
          J=IDAMAX(NVIR*NZ,TRANS,1)
          I1=MOD(J-1,NVIR)+1
          I2=(J-1)/NVIR+1
          VAL=ABS(TRANS(I1,I2))
          IF (VAL.LT.0.2D0*VLAST ) GOTO 100
          IF (VAL.LT.0.1D0) GOTO 100
          TRANSITION(1,IZ,IS)=I2
          TRANSITION(2,IZ,IS)=I1
          TRANSITION(3,IZ,IS)=NINT(10000.D0*VAL)
          TRANS(I1,I2)=0.D0
          VLAST=VAL
        ENDDO
  100   CONTINUE
      ENDDO
      CALL SCRREL(SCR,LSCR,DEBUG)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PRINTTRANS(TRANSITION,EIGV,NSTATE,NVIR,NPA,NPB,NLR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER TRANSITION(3,4,20)
      REAL*8 EIGV(*)
      INTEGER NSTATE,NVIR,NLR,NPA,NPB
C     Variables
      INTEGER  IS,IT,I,IO,IV,ISTAT,NZ,IXST
      CHARACTER STATE(2)*5,STYPE(2)*7
      DATA STATE /"ALPHA","BETA "/
      DATA STYPE /"HOMO - ","TOP -  "/
      LOGICAL OSTDA
C     ==================================================================
      OSTDA=(TDA.AND.MSUBTA.GT.0.AND..NOT.TDACANON)
      IF(PARENT) THEN
        IF(TREORDER.OR.TDLOCAL) THEN
          IXST=2
        ELSE
          IXST=1
        ENDIF
        IF(OSTDA) THEN
          NZ=NUA
        ELSE
          NZ=NSTATE
        ENDIF
        DO IS=1,NLR
          IT=0
          DO I=1,4
            IF(TRANSITION(1,I,IS).EQ.0) GOTO 100
            IT=IT+1
          ENDDO
  100     CONTINUE
          WRITE(6,'(//,A,I3,T42,A,F10.3,A)') " STATE=",IS,
     *                  "EIGENVALUE=",2.D0*RY*EIGV(IS)," eV"
          IF (TLSD) THEN
            DO I=1,IT
              IO=TRANSITION(1,I,IS)
              IF(IO.GT.NSUP) THEN
                ISTAT=2
                IO=NSTATE-IO
              ELSE
                ISTAT=1
                IO=NSUP-IO
              ENDIF
              IV=TRANSITION(2,I,IS)
              IF(IV.GT.NPA) IV=IV-NPA
              WRITE(6,'(T3,A,2X,A,T24,F7.3,T41,A,I3,A,A,I3)') 
     *          " TRANSITION ",STATE(ISTAT),
     *          (DBLE(TRANSITION(3,I,IS))/10000.D0)**2,
     *          STYPE(IXST),IO," --> ","LUMO + ",IV-1
            ENDDO
          ELSE
            DO I=1,IT
              WRITE(6,'(T10,A,T24,F7.3,T41,A,I3,A,A,I3)') 
     *          " TRANSITION ",
     *          (DBLE(TRANSITION(3,I,IS))/10000.D0)**2,
     *          STYPE(IXST),NZ-TRANSITION(1,I,IS)," --> ",
     *          "LUMO + ",TRANSITION(2,I,IS)-1
            ENDDO
          ENDIF
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
