               subroutine ghermit(ngh,xgh,wgh)
               implicit real*8 (a-h,o-z)
               parameter (nmax=180)
               dimension a(0:nmax),da(0:nmax),ap(0:nmax)
               dimension root0(nmax),root(nmax)
               dimension xgh(*),wgh(*)
c   input
               n=2*ngh
c   compute rhe coefs.
               if (n.gt.nmax) 
     *           call stopgm('GHERMIT',' NUMBER OF GH-POINTS')
               nup=n/2
               do 99 i=0,n
               a(i)=0.0000000000000000000000000000000d0
               da(i)=0.0000000000000000000000000000000d0
               ap(i)=0.0000000000000000000000000000000d0
 99            continue
               fact=nup+1
               do 1 i=nup+2,n
               fact=fact*i
 1             continue
               a(0)=(-1.0000000000000000000000d0)**nup*fact
               fact=1.00000000000000000000000000000000d0
               r=0.00000000000000000000000000d0
               do 100 i=1,n
               r=r+1.00000000000000000000000d0
               fact=fact*sqrt(r)
 100           continue
               pi=acos(-1.0000000000000000d0)
               sqpi=sqrt(pi)
               sqpi=sqrt(sqpi)
               a(0)=a(0)/(2.000000000000d0**nup)/fact/sqpi
               do 2 i=nup-1,0,-1
               m=i+1
               index=n-2*i
               a(index)=-a(index-2)*4.0000000000000000000000000d0
     $                             *DBLE(m)/
     $          DBLE(n-m-m+2)/DBLE(n-m-m+1)
 2             continue
c derivative
               do 24 i=0,n-1
               da(i)=(i+1.0000000000000000000000d0)*a(i+1)
 24            continue
               np=n+1
               nup=np/2
               fact=nup+1
               do 11 i=nup+2,np
               fact=fact*i
 11             continue
               ap(1)=2.000000000000000000000d0*
     $             (-1.000000000000000000000d0)**nup*fact
               fact=1.0000000000000000000000d0
               r=0.00000000000000000000000000d0
               do 101 i=1,np
               r=r+1.00000000000000000000000d0
               fact=fact*sqrt(r)
 101           continue
               ap(1)=ap(1)/(2.000000000000d0**nup)/fact/sqpi
     $                                /sqrt(2.000000000000d0)
               do 12 i=nup-1,0,-1
               m=i+1
               index=np-2*i
               ap(index)=-ap(index-2)*4.000000000000000000d0
     $                               *DBLE(m)/
     $          DBLE(np-m-m+2)/DBLE(np-m-m+1)
 12             continue
c    first approximation to roots
               call eval(a,n,0.d0,y0)
               index=0
               do 10 i=1,5000
               x=0.00333d0*i
               call eval(a,n,x,y)
               if (y*y0.lt.0.d0) then
               index=index+1
               if(index.gt.nmax) call stopgm('GHERMIT','too many roots')
               root0(index)=x
               y0=y
               end if
 10            continue
c newton search for the roots
               do 16 i=1,index
               niter=0
 18            call eval(a,n,root0(i),y)
               if (dabs(y).gt.1.d-16) then
               niter=niter+1
               if (niter.gt.20)go to 19
               call eval(da,n-1,root0(i),yp)
               root0(i)=root0(i)-y/yp
               go to 18
               end if
 19            root(i)=root0(i)
               xgh(i)=root(i)
  16           continue
c weights
               rapp=-ap(n+1)/a(n)
               do 36 i=1,index
               call eval(ap,n+1,root(i),yp1)
               call eval(da,n-1,root(i),dy)
               w=rapp/yp1/dy
               wgh(i)=w
  36           continue
               return
               end
               subroutine eval(coef,n,x,y)
               implicit real*8(a-h,o-z)
               dimension coef(0:n)
               y=coef(n)
               do 1 i=n-1,0,-1
               y=coef(i)+x*y
 1             continue
               return
               end


