C     ==================================================================
      SUBROUTINE GMOPTS
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'atwf.inc'        !NUMAORMAX
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'coor.inc'        !VELP
      INCLUDE 'bsym.inc'        !BSFAC
#ifdef PARALLEL
      INCLUDE 'ddip.inc'        !LENBK
#endif

C     Variables
      DIMENSION  F(*)
      COMPLEX*16 C0(*),C2(*),C1(*)
      REAL*8     PME(*),GDE(*),VPP(*),EIGV(*),
     &           CM(*),SC0(*)
      POINTER    (IP_C0,C0), (IP_C1,C1), (IP_C2,C2), (IP_PME,PME),
     &           (IP_GDE,GDE), (IP_VPP,VPP), (IP_EIGV,EIGV),
     &           (IP_CM,CM),(IP_SC0,SC0)
      INTEGER    NSTATE,NC0,NEIGV,NC2,NCM
      INTEGER    NPME,NGDE,NSC0,MS,NACT,MM,NUS,NC1,I,NXX
#ifdef PARALLEL
      INTEGER    NXXFUN
      EXTERNAL   NXXFUN
#endif
C     ==--------------------------------------------------------------==
C     ==  MEMORY ALLOCATION                                           ==
C     ==--------------------------------------------------------------==
C     ==                      WAVEFUNCTIONS                           ==
C     ==  C0    : WAVEFUNCTIONS                                       ==
C     ==  C2    : GRADIENTS                                           ==
C     ==  CM    : VELOCITIES  OR BACKUP WAVEFUNCTION                  ==
C     ==  SC0   : S**(-1/2)*C0 (nonorthogonal orbitals)               ==
C     ==  PME   : DIIS WF             HNM1 (for CG)                   ==
C     ==  GDE   : DIIS GRADIENTS                                      ==
C     ==  VPP   : WF HESSIAN                                          ==
C     ==  EIGV  : ORBITAL ENERGIES                                    ==
C     ==--------------------------------------------------------------==
      IF(TDDFT) THEN
        CALL LR_IN
        CALL TDDFT_INPUT
       TSYMRHO=.FALSE.
      ENDIF
      NSTATE=N
      IF(TDIAG.AND.TDAVI) THEN
        IF(NDAVV.EQ.0) THEN
          NDAVV=2*NSTATE
        ELSE
          NDAVV=MIN(NDAVV+NSTATE,2*NSTATE)
        ENDIF
        NSTATE=NDAVV
      ENDIF
      NC0=(2*NGWK*NSTATE*NKPNT+8)*BSFAC
      NEIGV=NSTATE*NKPTS*BSFAC
      NC2=(2*NGWK*MAX(NUMAORMAX,NSTATE)+8)*BSFAC
      IF(TDIAG) THEN
        IF(TFRSBLK) THEN
          NCM=2*NGWK*MAX(NSTATE,(NKRY_MAX+1)*NKRY_BLOCK)+8
        ELSEIF(DIIS) THEN
          NCM=(NGWK*NSTATE+8)*MDIIS*NKPNT+
     &          ((NGWK*NSTATE+8)*MDIIS*NKPNT)/4
          NCM = NCM*2
        ELSE
           NCM=2*NGWK*MAX(NSTATE,NKRY_MAX*NKRY_BLOCK)+8
        ENDIF
      ELSE
        NCM = 1
        IF(SIMUL) THEN
          NCM=NC0
        ENDIF
      ENDIF
      IF(TIVAN.OR.NONORT.OR.(PCG.AND.PCGMIN)) THEN
        NSC0=max(2*NGWK*NSTATE*NKPNT,nc2)
      ELSEIF(TDIAG .AND.DIIS) THEN
        NSC0=NC2
      ELSE
        NSC0=1
      ENDIF
      IF(TDIPD) THEN
#ifdef PARALLEL
        LENBK=NXXFUN(NSTATE)
        NXX=MAX(2*LENBK*NPROC,NC2)
#else
        NXX=NC2
#endif
        NSC0=MAX(NXX,NSC0)
        NC2=MAX(NXX,NC2)
      ENDIF
      IF(TDEBFOR) THEN
        NCM = NC0
      ENDIF
      IF(TDDFT) THEN
        DO I=1,NSTATE
          IF(F(I).LT.1.D-6) THEN
            CALL STOPGM("TDDFT","ALL STATES HAVE TO BE OCCUPIED")
          ENDIF
        ENDDO
        MS=MAX(NS_MIX,NS_SIN,NS_TRI)
        IF(TDA.AND.LDIAG.EQ.1) THEN
          MM=1
        ELSE
          MM=2
        ENDIF
        IF(TDA.AND.MSUBTA.GT.0) THEN
          NACT=MSUBTA
        ELSE
          NACT=NSTATE
        ENDIF
        NOLR=NACT
        NC1=2*NGW*NACT*MS*MM
        NUA=NSTATE
        NUB=NACT
        NLINW=MS
        NLINR=0
        NUS=2*NUA*NUB
      ELSE
        NC1=1
        NUA=1
        NUB=1
        NLINW=0
        NLINR=0
        NUS=1
      ENDIF
      CALL MEMORY(IP_C0,NC0,'C0')
      CALL MEMORY(IP_C1,NC1,'C0')
      CALL MEMORY(IP_C2,NC2,'C2')
      CALL MEMORY(IP_CM,NCM,'CM')
      CALL MEMORY(IP_EIGV,NEIGV,'EIGV')
      CALL MEMORY(IP_SC0,NSC0*BSFAC,'SC0')
      CALL MEMORY(IP_VPP,NGWK,'VPP')
      CALL MEMORY(IP_UROT,NUS,'UROT')
      CALL AZZERO(UROT,NUS)
      CALL GET_ADDR(IP_CLRWF,C1)
      IF(TSDE) THEN
        NPME = 1
        NGDE = 1
      ELSE IF(DIIS .AND. .NOT. TDIAG) THEN
        NPME = (NGWK*NSTATE+8)*MDIIS*NKPNT
        NGDE = ((NGWK*NSTATE+8)*MDIIS*NKPNT)/4
      ELSE IF(PCG) THEN
        NPME = 2*NGWK*NSTATE*NKPNT
        NGDE = 1
      ELSE IF(TDIAG) THEN
        IF(TDAVI) THEN
          NPME = NC0
          NGDE = NC0
        ELSE
          NPME = 1
          NGDE = 1
        ENDIF
      ELSE
        IF(PARENT) THEN
          WRITE(6,*) ' WRONG OPTION FOR WAVEFUNCTION OPTIMIZATION'
        ENDIF
        CALL STOPGM('GMOPTS',' ')
      ENDIF
      CALL MEMORY(IP_PME,NPME,'PME')
      CALL MEMORY(IP_GDE,NGDE,'GDE')
C     ==--------------------------------------------------------------==
C     FNL and DFNL
      CALL FNLALLOC(NSTATE,.TRUE.,TPRES)
      IF(PARENT) THEN
        CALL PRMEM('    GMOPTS')
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TDEBFOR) THEN
        TSYMRHO=.FALSE.
        CALL DEBFOR(C0,C1,C2,CM,SC0,PME,GDE,VPP,EIGV)
      ELSE
        CALL RGMOPT(C0,C1,C2,CM,SC0,PME,GDE,VPP,EIGV)
      ENDIF
C     ==--------------------------------------------------------------==
C     Deallocations
      IF(TMEMCHK) THEN
        CALL PRINT_MEMORY
      ENDIF
      CALL FREEM(IP_C0)
      CALL FREEM(IP_C1)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_CM)
      CALL FREEM(IP_EIGV)
      CALL FREEM(IP_UROT)
      CALL FNLDEALLOC(.TRUE.,TPRES)
      CALL FREEM(IP_SC0)
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_PME)
      CALL FREEM(IP_GDE)
      CALL FREEM(IP_VELP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
