C     ==================================================================
      SUBROUTINE GROUPS
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
#ifdef PARALLEL
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
C     Variables
      INTEGER MSGLEN,I,N1,LABEL,IPOS
#if defined(T3D) || defined(T3E)
      REAL*8  DD
#endif
C     ==--------------------------------------------------------------==
C     ==  SUBDIVIDE THE PROCESSORS IN GROUPS                          ==
C     ==                                                              ==
C     ==  THE NUMBER OF GROUPS HAS TO BE A DIVISOR OF THE NUMBER      ==
C     ==  OF PROCESSORS                                               ==
C     ==--------------------------------------------------------------==
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NOGRP,MSGLEN,SOURCE,ALLGRP)
      IF(NOGRP.EQ.1) RETURN
      IF(NOGRP.GT.MAXGRP) THEN
        IF(PARENT) THEN
          WRITE(6,*) ' MAXIMUM NUMBER OF GROUPS IS ',MAXGRP
          WRITE(6,*) ' NUMBER OF GROUPS     :',NOGRP 
          CALL STOPGM('GROUPS',' ')
        ENDIF
      ENDIF
      IF(MOD(NPROC,NOGRP).NE.0) THEN
        IF(PARENT) THEN
          WRITE(6,*) ' THE NUMBER OF GROUPS HAS TO BE A',
     *               ' DIVISOR OF THE NUMBER OF PROCESSORS'
          WRITE(6,*) ' NUMBER OF PROCESSORS :',NPROC
          WRITE(6,*) ' NUMBER OF GROUPS     :',NOGRP 
          CALL STOPGM('GROUPS',' ')
        ENDIF
      ENDIF
      NPGRP=NPROC/NOGRP
      IF(NPGRP.GT.MAXGRP) THEN
        IF(PARENT) THEN
          WRITE(6,*) ' MINIMUM NUMBER OF GROUPS IS ',NPROC/MAXGRP
          WRITE(6,*) ' NUMBER OF GROUPS     :',NOGRP 
          CALL STOPGM('GROUPS',' ')
        ENDIF
      ENDIF
#if defined(T3D) || defined(T3E)
      DD = LOG(DBLE(NOGRP))/LOG(2.0d0)
      DD = DD - NINT(DD)
      IF(ABS(DD).GT.1.D-6) THEN
        IF(PARENT) THEN
          WRITE(6,*) ' NUMBER OF GROUPS MUST BE 2**N '
          WRITE(6,*) ' NUMBER OF GROUPS     :',NOGRP 
          CALL STOPGM('GROUPS',' ')
        ENDIF
      ENDIF
#endif
      IF(.NOT.TCART) THEN
C     LIST OF PROCESSORS IN MY ORBITAL GROUP
      N1 = (MEPOS/NOGRP)*NOGRP-1
      DO I=1,NOGRP
        NOLIST(I)=PGROUP(N1+I+1)
        IF(ME.EQ.NOLIST(I)) IPOS=I-1
      ENDDO
C     LIST OF PROCESSORS IN MY PLANE WAVE GROUP
      DO I=1,NPGRP
        NPLIST(I)=PGROUP(IPOS+(I-1)*NOGRP+1)
      ENDDO
C     write out the findings
      IF(PARENT) THEN
        WRITE(6,'(A)')    ' NOGRPNOGRPNOGRPNOGRPNOGRPNOGRPNOGRPNOGRP'
        WRITE(6,'(A,I8)') ' NUMBER OF PROCESSOR GROUPS    : ', NOGRP
        WRITE(6,'(A,I8)') ' NUMBER OF PROCESSORS PER GROUP: ', NPGRP
        WRITE(6,'(A)')    ' NOGRPNOGRPNOGRPNOGRPNOGRPNOGRPNOGRPNOGRP'
      ENDIF
C     SET UP THE GROUPS
      DO I=1,NPGRP
        IF(ME.EQ.NPLIST(I)) LABEL=I
      ENDDO
      CALL MY_GROUP(NOGRP,NOLIST,LABEL,MEOGRP,ALLGRP)
      DO I=1,NOGRP
        IF(ME.EQ.NOLIST(I)) LABEL=I+MAXCPU
      ENDDO
      CALL MY_GROUP(NPGRP,NPLIST,LABEL,MEPGRP,ALLGRP)
      ELSE
      CALL  MY_CART(NOGRP,NPGRP,NOLIST,NPLIST,MEOGRP,MEPGRP)
      ENDIF
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
