C     ==================================================================
      SUBROUTINE GS_DISORTHO(NSTATE,C0,CSCR)
C     ==--------------------------------------------------------------==
C     ==     ORTHOGONALIZE A SET OF WAVEFUNCTIONS C0                  ==
C     ==     USING A DISTRIBUTED OVERLAP MATRIX ALGORITHM             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'geq0.inc'
C
      LOGICAL DEBUG
      INTEGER NSTATE
      COMPLEX*16 C0(NGW,*),CSCR(NGW,*)
      INTEGER NORB,NORBX,MMX,MSGLEN,IP,NX,IPJ,NPJ,IPI,NPI
      INTEGER I,J,I1,J1,IJ,N1,N2,INFO,I2,MMX1
      INTEGER ISUB
C     ==--------------------------------------------------------------==
      INTEGER  IERR, INDEX1, INDEX0
      REAL*8   OPW(*), LOCAL_OPW(*), LOCAL_NRM, NRM
      POINTER  (IP_OPW, OPW), (IP_LOCAL_OPW, LOCAL_OPW)
      REAL*8   DDOT
      EXTERNAL DDOT
      CALL TISET('GSDISORTHO',ISUB)
C  
C     ==================================================================
      CALL MEMORY(IP_OPW, NSTATE, 'OPW')
      CALL MEMORY(IP_LOCAL_OPW, NSTATE, 'LOCAL_OPW')
C     NORMALIZE FIRST VECTOR
      LOCAL_NRM = 2 * DDOT(2*NGWK, C0(1,1), 1, C0(1,1), 1)
      IF (GEQ0) THEN
         LOCAL_NRM = LOCAL_NRM - REAL(C0(1,1))**2
      ENDIF
      MSGLEN=1*8
      CALL MY_COMBINE(LOCAL_NRM,NRM,MSGLEN,1,ALLGRP)
      NRM = DSQRT(NRM)
      CALL DSCAL(2*NGWK, 1/NRM, C0(1,1), 1 )
      DO INDEX0 = 2, NSTATE
         DO INDEX1=1,INDEX0-1
            LOCAL_OPW(INDEX1) = 2* DDOT(2*NGWK, C0(1,INDEX1),
     &                             1, C0(1,INDEX0), 1)
            IF (GEQ0) THEN
               LOCAL_OPW(INDEX1) = LOCAL_OPW(INDEX1) -
     &               REAL(C0(1,INDEX1)) * REAL(C0(1,INDEX0))
            ENDIF
         ENDDO
         MSGLEN=(INDEX0-1)*8
         CALL MY_COMBINE(LOCAL_OPW,OPW,MSGLEN,1,ALLGRP)
         DO INDEX1=1, INDEX0-1
            CALL DAXPY(2*NGWK, -OPW(INDEX1),
     &            C0(1,INDEX1), 1, C0(1,INDEX0), 1)
         ENDDO
C        NORMALIZE TO ONE
         LOCAL_NRM = 2 * DDOT(2*NGWK,C0(1,INDEX0),1,C0(1,INDEX0),1)
         IF (GEQ0) THEN
            LOCAL_NRM = LOCAL_NRM -REAL(C0(1,INDEX0))
     &                  * REAL(C0(1,INDEX0))
         ENDIF
         MSGLEN=1*8
         CALL MY_COMBINE(LOCAL_NRM,NRM,MSGLEN,1,ALLGRP)
         NRM = DSQRT(NRM)
         CALL DSCAL(2*NGWK, 1/NRM, C0(1,INDEX0), 1 )
      ENDDO
      CALL FREEM(IP_OPW)
      CALL FREEM(IP_LOCAL_OPW)
      CALL TIHALT('GSDISORTHO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
