C     ==================================================================
      SUBROUTINE GSIZE(FION,GNMAX,GNORM)
C     ==--------------------------------------------------------------==
C     == CALCULATE NORM OF GRADIENT (GNORM) AND                       ==
C     == MAXIMUM COMPONENT (GNMAX)                                    ==
C     == INPUT: FION(3,NAX,NSX) NUCLEAR GRADIENTS                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
C     Arguments
      REAL*8  FION(3,NAX,NSX),GNMAX,GNORM
C     Variables
      INTEGER NTOT,IS,IA,K
C     ==--------------------------------------------------------------==
      NTOT=0
      GNMAX=0.0D0
      GNORM=0.0D0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          DO K=1,3
            NTOT=NTOT+1
            IF(ABS(FION(K,IA,IS)).GT.GNMAX) GNMAX=ABS(FION(K,IA,IS))
            GNORM=GNORM+FION(K,IA,IS)*FION(K,IA,IS)
          ENDDO
        ENDDO
      ENDDO
      GNORM=SQRT(GNORM/DBLE(NTOT))
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GNODIM(DXPAR,NODIM,GNMAX,GNORM)
C     ==--------------------------------------------------------------==
C     == CALCULATE NORM OF GRADIENT (GNORM) AND                       ==
C     == MAXIMUM COMPONENT (GNMAX)                                    ==
C     == INPUT: DXPAR(NODIM) GRADIENTS OF FREEDOM DEGREES             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NODIM
      REAL*8  DXPAR(NODIM),GNMAX,GNORM
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
      GNMAX=0.0D0
      GNORM=0.0D0
      DO I=1,NODIM
        IF(ABS(DXPAR(I)).GT.GNMAX) GNMAX=ABS(DXPAR(I))
        GNORM=DXPAR(I)*DXPAR(I)+GNORM
      ENDDO
      GNORM=SQRT(GNORM/NODIM)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
