c     ==================================================================
      SUBROUTINE H0PSI1_P(c1,c0,drhoe,f,tau0,
     &    fion,psi,scr,lscr,nstate,c12)
c     ==================================================================
      implicit none
      include 'system.h'
      include 'spin.inc'
      include 'pslo.inc'
      include 'ropt.inc'
      include 'ener.inc'
      include 'response_p.inc'
      include 'sfac.inc'
      include 'ions.inc'
      include 'geq0.inc'
c     Arguments:
      integer    lscr,nstate
      complex*16 c1(ngwk,*),c0(ngwk,*),c12(ngwk,*),psi(*),drhoe
      real*8     f(nstate),tau0(3,nax,nsx),fion(3,nax,nsx),scr(*)
c     Local variables:
      real*8     FNL(1,nat,nhxs,nstate,nkpnt),DFNL(*)
      real*8     ddia(*),auxc(*)
      pointer    (ip_ddia,ddia),(ip_auxc,auxc)
      integer    lrscpot,ig,isub,il_auxc,il_ddia
      character*30 tag
      logical    tfor

      call tiset('h0psi1           ',isub)
      CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NSTATE)
      CALL GET_ADDR(IP_AUXC,SCR(1))
#ifdef _BGL 
      IL_AUXC=IL_AUXC+MOD(IL_AUXC,2)
#endif
      CALL GET_ADDR(IP_DDIA,SCR(1+IL_AUXC))
      call give_scr_rscpot(lrscpot,tag,calste)
      call test_scr('h0psi1','length',lscr,lrscpot)

c     calculate   fnl(g) = sum(l)      exp igR  *  i^l  proj[l]  c1(g)
c     and in the case of PHONON perturbation also
c                dfnl(g) = sum(l) ig * exp igR  *  i^l  proj[l]  c1(g):
      TFOR = (PHONON .or. TLANPHON .or. TEIGENS .or. TINR)
      if (cutoff_restr) call restrain_ngw_zero(c1,ngw_zero,ngw,nstate)
      call rnlsm(c1,nstate,psi,scr,lscr,1,1,TFOR)

c     c12(g)  =  <g|  v_Hxc(0)  |c1>; vpsi also initializes c12
      call v0psi1_p(c0,c1,c12,VofRho0,psi,drhoe,scr,lscr,nstate)
C     NB: V0PSI1_P also calculates the first order density response DRHOE

c     c12(g) +=  <g|  | fnl[c1] >
      call fnonloc(c12,f,nstate,auxc,ddia,1,nlsd)

      call tihalt('h0psi1          ',isub)
      return
      end
c     ==================================================================
      SUBROUTINE give_scr_h0psi1(l_h0psi1,tag,nstate)
      implicit none
      include 'system.h'
      include 'response_p.inc'
      include 'fft.inc'
      logical tfor
      integer nstate,l_h0psi1,l_rnlsm,l_auxc,l_ddia,lv0psi1
      character tag*30

      TFOR = (PHONON .or. TLANPHON .or. TEIGENS .or. TINR)

      call give_scr_rnlsm(l_rnlsm,tag,nstate,tfor)
      call give_scr_fnonloc(l_auxc,l_ddia,nstate)
      lv0psi1 = 2*maxfft

      l_h0psi1 = max(l_rnlsm,l_auxc+l_ddia,lv0psi1)
      return
      end
c     ==================================================================
