C     ==================================================================
      SUBROUTINE HEADER(FILENAME)
C     ==--------------------------------------------------------------==
C     ==  Writes a header to the standard output                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'envj.inc'
      CHARACTER FILENAME*(*), FFORMAT*9
      INTEGER I1,I2
C     ==--------------------------------------------------------------==
      WRITE(6,'(/)') 
      WRITE(6,'(12X,A)') '   ******  ******    ****  ****  ******   '
      WRITE(6,'(12X,A)') '  *******  *******   **********  *******  '
      WRITE(6,'(12X,A)') ' ***       **   ***  ** **** **  **   *** '
      WRITE(6,'(12X,A)') ' **        **   ***  **  **  **  **    ** '
      WRITE(6,'(12X,A)') ' **        *******   **      **  **    ** '
      WRITE(6,'(12X,A)') ' ***       ******    **      **  **   *** '
      WRITE(6,'(12X,A)') '  *******  **        **      **  *******  '
      WRITE(6,'(12X,A)') '   ******  **        **      **  ******   '
      WRITE(6,'(/,23X,A,/)') '   VERSION 3.15.3'
#if defined(__GROMOS)
      WRITE(6,'(/,16X,A,/)') 'COMPILED WITH GROMOS-AMBER QM/MM SUPPORT'
#endif
      WRITE(6,'(14X,A)') '              COPYRIGHT'
      WRITE(6,'(14X,A)') '        IBM RESEARCH DIVISION'
      WRITE(6,'(14X,A)') '  MPI FESTKOERPERFORSCHUNG STUTTGART'
      WRITE(6,'(/,14X,A)')  '         The CPMD consortium'
      WRITE(6,'(14X,A)') '    Home Page: http://www.cpmd.org'
      WRITE(6,'(14X,A)') ' Mailing List: cpmd-list@cpmd.org'
      WRITE(6,'(14X,A)') '       E-mail: cpmd@cpmd.org'
      WRITE(6,'(/)')
      CALL TIMETAG
C     ==--------------------------------------------------------------==
      CALL XSTRING(FILENAME,I1,I2)
      WRITE(FFORMAT,'(A,I2,A)') '(A,T',MAX(21,65-(I2-I1)),',A)'
      WRITE(6,FFORMAT)   ' THE INPUT FILE IS: ',FILENAME(I1:I2)
      CALL XSTRING(HNAME,I1,I2)
      WRITE(FFORMAT,'(A,I2,A)') '(A,T',MAX(20,65-(I2-I1)),',A)'
      WRITE(6,FFORMAT)   ' THIS JOB RUNS ON: ',HNAME(I1:I2)
      WRITE(6,'(A)')   ' THE CURRENT DIRECTORY IS: '
      CALL XSTRING(CURDIR,I1,I2)
      WRITE(FFORMAT,'(A,I2,A)') '(T',MAX(2,65-(I2-I1)),',A)'
      WRITE(6,FFORMAT)   CURDIR(I1:I2)
      WRITE(6,'(A)')   ' THE TEMPORARY DIRECTORY IS: '
      CALL XSTRING(TMPDIR,I1,I2)
      WRITE(FFORMAT,'(A,I2,A)') '(T',MAX(2,65-(I2-I1)),',A)'
      WRITE(6,FFORMAT)   TMPDIR(I1:I2)
      WRITE(6,'(A,T50,I16)')  ' THE PROCESS ID IS: ',MY_PID
      CALL XSTRING(USER,I1,I2)
      IF(I2.NE.0) THEN
        WRITE(FFORMAT,'(A,I2,A)') '(A,T',MAX(28,65-(I2-I1)),',A)'
        WRITE(6,FFORMAT) ' THE JOB WAS SUBMITTED BY: ',USER(I1:I2)
      ENDIF
      IF(TJLIMIT.NE.0.D0) THEN
        WRITE(6,'(A,T48,F10.0,A8)')
     &       ' THE JOB TIME LIMIT IS:',TJLIMIT,' SECONDS'
      ENDIF
      WRITE(6,*)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
