C     ==================================================================
      SUBROUTINE HESELE (SVAR2,VPP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'simul.inc'
C     Arguments
      REAL*8    SVAR2,VPP(NGW)
C     Variables
      DIMENSION TWNL(NGW,NHXS,NSP)
      REAL*8    DD,VP,FTPI,EMP
      INTEGER   IG,ISA0,IS,IV,JV,IA,L,KI,LI,L2,LJ,KJ,J
#ifdef PARALLEL
      INTEGER   MSGLEN
#endif
C     ==--------------------------------------------------------------==
C     ==  Calculate   H0 : The diagonal approximation to the          ==
C     ==                   2nd derivative matrix                      ==
C     ==--------------------------------------------------------------==
      IF(PREC) THEN
C     ==--------------------------------------------------------------==
C     ==  Local Potential                                             ==
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
        MSGLEN = 1 * 8
        CALL MY_BCAST(VPLOC,MSGLEN,IGEQ0,ALLGRP)
#endif
        VP=VPLOC
C     ==--------------------------------------------------------------==
C     ==  Nonlocal Potential                                          ==
C     ==--------------------------------------------------------------==
!$OMP parallel do private(IG,IS,IV,JV,IA,ISA0,DD,L,KI,LI,L2,LJ,KJ)
#if !defined(__VECTOR)
!$OMP+ schedule(static)
#endif
        DO IG=1,NGW
          VPP(IG)=VP
          ISA0=0
          DO IS=1,NSP
            IF(TVAN(IS)) THEN
              DO IV=1,NGH(IS)
                DO JV=1,NGH(IS)
                  DD=DVAN(IV,JV,IS)
                  DO IA=1,NA(IS)
                    DD=DD+DEEQ(ISA0+IA,IV,JV,1)
                  ENDDO
                  IF(TLSD) THEN
                    DO IA=1,NA(IS)
                      DD=DD+DEEQ(ISA0+IA,IV,JV,2)
                    ENDDO
                    DD=0.5D0*DD
                  ENDIF
                  VPP(IG)=VPP(IG)+DD*TWNL(IG,IV,IS)*TWNL(IG,JV,IS)
                ENDDO
              ENDDO
            ELSEIF(TSGP(IS)) THEN
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L.EQ.L2.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    DD=HLSG(KI,KJ,L,IS)*NA(IS)
                    VPP(IG)=VPP(IG)+DD*TWNL(IG,IV,IS)*TWNL(IG,JV,IS)
                  ENDIF
                ENDDO
              ENDDO
            ELSE
              DO IV=1,NGH(IS)
                VPP(IG)=VPP(IG)+NA(IS)*WSG(IS,IV)
     *                      *TWNL(IG,IV,IS)*TWNL(IG,IV,IS)
              ENDDO
            ENDIF
            ISA0=ISA0+NA(IS)
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  Kinetic Energy                                              ==
C     ==--------------------------------------------------------------==
        FTPI=0.5D0*TPIBA2
!$OMP parallel do private(J)
#if !defined(__VECTOR)
!$OMP+ schedule(static)
#endif
        DO J=1,NGW
          VPP(J)=FTPI*HG(J)+VPP(J)
          EMP=HTHRS
          IF(VPP(J).LT.EMP) VPP(J)=EMP
        ENDDO
!$OMP parallel do private(J)
#if !defined(__VECTOR)
!$OMP+ schedule(static)
#endif
        DO J=1,NGW
          VPP(J)=1.0D0/VPP(J)
        ENDDO
      ELSE
!$OMP parallel do private(J)
#if !defined(__VECTOR)
!$OMP+ schedule(static)
#endif
        DO J=1,NGW
          VPP(J)=SVAR2
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
