C     ==================================================================
      SUBROUTINE HESELE_P (SVAR2,Z11,nstate,VPP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'simul.inc'
      include 'elct.inc'
      include 'response_p.inc'
C     Arguments
      INTEGER   NSTATE
      REAL*8    SVAR2,VPP(NGW),Z11(NSTATE,NSTATE)
C     Variables
      DIMENSION TWNL(NGW,NHXS,NSP),F(NSTATE)
      REAL*8    DD,FTPI
      INTEGER   IG,ISA0,IS,IV,JV,IA,L,KI,LI,L2,LJ,KJ,J
C     ==--------------------------------------------------------------==
C     ==  Calculate   H0 : The diagonal approximation to the          ==
C     ==                   2nd derivative matrix                      ==
C     ==--------------------------------------------------------------==
      IF(PREC_P) THEN
C     ==--------------------------------------------------------------==
C     ==  Nonlocal Potential                                          ==
C     ==--------------------------------------------------------------==
        CALL AZZERO(VPP,NGW)
        DO IG=1,NGW
          VPP(IG)=0.0d0
          ISA0=0
          DO IS=1,NSP
            IF(TVAN(IS)) THEN
              DO IV=1,NGH(IS)
                DO JV=1,NGH(IS)
                  DD=DVAN(IV,JV,IS)
                  DO IA=1,NA(IS)
                    DD=DD+DEEQ(ISA0+IA,IV,JV,1)
                  ENDDO
                  IF(TLSD) THEN
                    DO IA=1,NA(IS)
                      DD=DD+DEEQ(ISA0+IA,IV,JV,2)
                    ENDDO
                    DD=0.5D0*DD
                  ENDIF
                  VPP(IG)=VPP(IG)+DD*TWNL(IG,IV,IS)*TWNL(IG,JV,IS)
                ENDDO
              ENDDO
            ELSEIF(TSGP(IS)) THEN
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L.EQ.L2.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    DD=HLSG(KI,KJ,L,IS)*NA(IS)
                    VPP(IG)=VPP(IG)+DD*TWNL(IG,IV,IS)*TWNL(IG,JV,IS)
                  ENDIF
                ENDDO
              ENDDO
            ELSE
              DO IV=1,NGH(IS)
                VPP(IG)=VPP(IG)+NA(IS)*WSG(IS,IV)
     *                      *TWNL(IG,IV,IS)*TWNL(IG,IV,IS)
              ENDDO
            ENDIF
            ISA0=ISA0+NA(IS)
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  Kinetic Energy and consolidation                            ==
C     ==--------------------------------------------------------------==
        FTPI=0.5D0*TPIBA2
!$OMP parallel do private(ig)
        DO ig=1,ngw
          vpp(ig)=vpp(ig)+ftpi*hg(ig)
        ENDDO

C     ==--------------------------------------------------------------==
      ELSE                      ! IF NO PRECONDITIONING then here:
C     ==--------------------------------------------------------------==
!$OMP parallel do private(J)
        DO J=1,NGW
          VPP(J)=SVAR2
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
