C     ==================================================================
      subroutine hess_eta_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &     eirop,eivps,z11,nstate,icol,iat,dd_fnl,dtmp)
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'irat.inc'
      include 'symm.inc'
      include 'rmas.inc'
      include 'cotr.inc'
      include 'adat.inc'
      include 'coor.inc'
      include 'soft.inc'
      include 'store.inc'
      include 'elct.inc'
      include 'spin.inc'
      include 'sfac.inc'
      include 'nlps.inc'
      include 'pslo.inc'
      include 'atwf.inc'
      include 'kpts.inc'
      include 'kpnt.inc'
      include 'fft.inc'
      include 'response_p.inc'
      include 'prop.inc'
cccc
      include 'implhv.inc'
cccc

c     arguments
      integer    nstate,lscr,iat,icol
      complex*16 c0(ngw,nstate),c1(ngw,nstate),psi(*)
      complex*16 eirop(nhg),eivps(nhg)
      real*8     rhoe(*),drhoe(*),scr(*),z11(nstate,nstate),dtmp(*)
      real*8     dd_fnl(imagp,nat,nhxs,3,3,nstate,nkpnt)

c     variables
      complex*16 eirop1(nhg),v1_loc(nhg),eirop2(nhg),v1_l(nhg)
      complex*16 v1(maxfft),ztmp
      complex*16 v1_nonloc(ngwk,*),v1_nl(ngwk,*)
      real*8     FNL(imagp,nat,nhxs,nstate,nkpnt)
      real*8     DFNL(imagp,nat,nhxs,3,nstate,nkpnt)
      integer    isub,k,k2,is2,ia2,iat2,il_v1_loc,il_v1_nonloc,il_eirop1
      integer    ix,ir
      
      pointer    (ip_v1,v1)      
      pointer    (ip_v1_loc,v1_loc),(ip_v1_nonloc,v1_nonloc)
      pointer    (ip_eirop1,eirop1),(ip_eirop2,eirop2)
      pointer    (ip_v1_nl,v1_nl),  (ip_v1_l,v1_l)

c     ==--------------------------------------------------------------==
      call tiset('    hess_eta_p',isub)
      il_v1_loc=2*nhg*nlsd
      il_v1_nonloc=2*ngwk*nstate*nkpnt
      il_eirop1=2*nhg

      call memory(ip_v1_loc,il_v1_loc,'v1_loc')
      call azzero(v1_loc,il_v1_loc)
      call memory(ip_v1_nonloc,il_v1_nonloc,'v1_nonloc')
      call azzero(v1_nonloc,il_v1_nonloc)
c     NB: In v1_nonloc, we store \op{v1} |psi0> whereas in
c     v1_loc, v1(g) is stored. Therefore the different dimensions.
      call memory(ip_v1_l,il_v1_loc,'v1_l')
      call azzero(v1_l,il_v1_loc)
      call memory(ip_v1_nl,il_v1_nonloc,'v1_nl')
      call azzero(v1_nl,il_v1_nonloc)


      call memory(ip_eirop1,il_eirop1,'eirop1')
      call azzero(eirop1,il_eirop1)
c     NB: This array is only needed for phonons! Otherwise, it should not
c     be touched (filled with 0)
      call memory(ip_eirop2,il_eirop1,'eirop2')
      call azzero(eirop2,il_eirop1)

      call memory (ip_v1,2*maxfft,'v1')


c
c     ==--------------------------------------------------------------==
c     ==         the basic loops for perturbations                    ==
c     ==--------------------------------------------------------------==
      if(parent)
     &     write(6,'(/," ",22("*"),a,22("*"),/)')
     &     '   perturbations    '
c     no symmetrization of gradients in this part!
      nrot=1
      iat2=0
      if (parent) then
         do is2=1,nsp
            do ia2=1,na(is2)
               iat2=iat2+1
               write(6,'(" **** atom=",i5,3x,a3,3x,3(f10.8,3x,2x))')
     &              iat2,el(iatyp(Is2)),(dtmp(3*(iat2-1)+k2),k2=1,3)
            enddo
         enddo
      end if

      iat2=0
      ix=0

      do is2=1,nsp
         do ia2=1,na(is2)
            iat2=iat2+1
            do k2=1,3
               ix=3*(iat2-1)+k2

               Ztmp=dcmplx(dtmp(ix),0.d0)

cccc  The local and nonlocal parts of the perturbation are calculated
cccc  coordinate per coordinate, and then accumulated in the arrays
cccc  v1_loc and v1_nonloc, multiplied by the displacements.

c.... calculate local part
               call azzero(v1_l,il_v1_loc)
               call azzero(eirop1,il_v1_loc)
               call eicalc1(k2,is2,iat2,v1_l,eirop1)
               call ZAXPY(nhg,ztmp,v1_l,1,v1_loc,1)
               if (tlsd) call DCOPY(2*nhg,v1_loc(1),1,v1_loc(nhg+1),1)
               call ZAXPY(nhg,ztmp,eirop1,1,eirop2,1)

c...  calculate the non-local part
cccc here we do not need to "azzero" v1_nl, because it is made in 
cccc the routine pert_nonloc
               call fnonloc_p(c0,psi,scr,lscr,
     &              v1_nl,f,nstate,k2,is2,iat2,1)
               call DAXPY(il_v1_nonloc,dtmp(ix),v1_nl,1,
     &              v1_nonloc,1)

            enddo
         enddo
      enddo

cccc ^^^^^^^^^
CCCC ATTENTION; THIS WAY OF IMPLEMENTING THE PERTURBATION AS A COLLECTIVE
CCCC MOTION IMPLIES THE ALLOCATION FOR TWICE THE V1_(NON)LOC VECTORS.
CCCC IT MAY BE TOO MEMORY DEMANDING!


c...  optimization for c1
c     ==--------------------------------------------------------------==
cccc  The calling to rwfopt_p is done with eirop2 instead of eirop1. 
cccc In this way all routines called by rwfopt_p will have eirop2, where
cccc they have eirop1. In this way there is no need to modify the code.
      
      call rwfopt_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &              eirop,eivps,v1_loc,v1_nonloc,
     &              z11,nstate,eirop2)
c     ==--------------------------------------------------------------==
c     update hessian
c     calculate the linear perturbation in the density 
c     \   drhoe=<c0|r><r|c1>+cc
      call rhoofr_p(c0,c1,drhoe,psi,scr,lscr,nstate)
c     transform drhoe in g space -> v1
      if (tlsd) then
         do ir=1,nnr1
            v1(ir)=dcmplx(drhoe(ir)+drhoe(ir+nnr1),0.d0)
         enddo
      else
         do ir=1,nnr1
            v1(ir)=dcmplx(drhoe(ir),0.d0)
         enddo
      endif
      call fwfft(v1)
      
      call rnlsm(c1,nstate,psi,scr,lscr,1,1,.true.)
      call rnlsm3(c0,scr,lscr,nstate,dd_fnl)
      
      call DGEMV('N',3*nat,3*nat,1.d0,sd0,3*nat,
     &     dtmp,1,0.d0,rs_v(1,icol+1),1)
      
      iat2=0
      do is2=1,nsp
         do ia2=1,na(is2)
            iat2=iat2+1
            
            do k2=1,3
               ix=3*(iat2-1)+k2
               
c...  local part of the hessian matrix       
               call d_mat_locps(rs_v(ix,icol+1),v1,iat2,k2,is2)
               call d_mat_nonloc(rs_v(ix,icol+1),fnl,dfnl,fnl00,dfnl00,
     &              f,wk,is2,k,k2,iat2,nstate,1)
               
            enddo
         enddo
      enddo
      
      if(tmemchk) call print_memory      
      call freem(ip_v1_loc)
      call freem(ip_v1_nonloc)
      call freem(ip_eirop1)
      call freem(ip_v1)
      call freem(ip_v1_l)
      call freem(ip_v1_nl)
      call freem(ip_eirop2)

      call tihalt('    hess_eta',isub)
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================







