C     ==================================================================
      SUBROUTINE HESSIN(TAU0,READHE)
C     ==--------------------------------------------------------------==
C     ==  Initialization of the nuclear hessian                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      REAL*8    TAU0(3,NAX,*)
      LOGICAL   READHE
C     Variables
      REAL*8    HSCR(2*3*NAT*3*NAT)
      POINTER   (IP_HSCR,HSCR)
      CHARACTER FFORMAT*20,FNAME*100
      LOGICAL   FERROR
      INTEGER   ISUB,IUNIT,LHSCR,I1,I2,I,J,NAT00,
     &          IFIRST
      DATA      IFIRST /0/
      SAVE      IFIRST
C     ==--------------------------------------------------------------==
      CALL TISET('    HESSIN',ISUB)
      FNAME='HESSIAN'
      IUNIT=21
      IF(IFIRST.EQ.0) THEN
C       For compatibility with secder (HESS(NODIM,NODIM)).
        CALL MEMORY(IP_HESS,9*NAT*NAT,'HESS')
        IFIRST=1
      ENDIF
      LHSCR=2*3*NAT*3*NAT+10
      CALL MEMORY(IP_HSCR,LHSCR,'HSCR')
C     ==--------------------------------------------------------------==
C     == CHECK IF FILE EXISTS                                         ==
C     ==--------------------------------------------------------------==
      IF(READHE) THEN
        CALL FILEOPEN(IUNIT,FNAME,FO_OLD,FERROR)
        IF(FERROR) THEN
          CALL XSTRING(FNAME,I1,I2)
          WRITE(6,*) 'HESSIN| HESSIAN FILE NOT FOUND:', FNAME(I1:I2)
          WRITE(6,*) 'HESSIN| INITIALIZE HESSIAN MATRIX'
          READHE=.FALSE.
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  READ OLD NUCLEAR HESSIAN FROM FILE                          ==
C     ==--------------------------------------------------------------==
      IF(READHE) THEN
        REWIND(IUNIT)
        READ(IUNIT,ERR=999,END=999,FMT=*) NAT00
        IF(NODIM.NE.NAT00) THEN
          WRITE(6,'(A,2I5)')
     &         ' HESSIN| NUMBER OF PARAMETERS NOT CONSISTENT ',
     &         NAT00,NODIM
          GOTO 999
        ENDIF
        DO I=1,NODIM
          READ(IUNIT,ERR=999,END=999,FMT=*) (HESS(I,J),J=1,NODIM)
        ENDDO
        CALL FILECLOSE(IUNIT)
        GOTO 2000
      ELSE
        GOTO 1000
      ENDIF
 999  CONTINUE
      CALL XSTRING(FNAME,I1,I2)
      WRITE(FFORMAT,'(A,I2,A)')
     &     '(A,T',MAX(33,65-(I2-I1)),',A)'
      WRITE(6,FFORMAT) ' HESSIN| BAD HESSIAN FILE:',FNAME
      WRITE(6,'(A)') ' HESSIN| INITIALIZE HESSIAN MATRIX'
      READHE=.FALSE.
      CALL FILECLOSE(IUNIT)
 1000 CONTINUE
C     ==--------------------------------------------------------------==
C     ==  INITIAL HESSIAN IS UNIT MATRIX                              ==
C     ==--------------------------------------------------------------==
      IF(NPARA.EQ.-1) THEN
        CALL UNITMX(HESS,NODIM)
      ELSEIF(NPARA.EQ.0 .OR. NPARA.EQ.1) THEN
C     ==--------------------------------------------------------------==
C     ==  EMPIRICAL INITIAL HESSIAN                                   ==
C     ==--------------------------------------------------------------==
        CALL EMPFOR(TAU0,HSCR)
        CALL GETHES(HSCR)
      ELSEIF(NPARA.GE.2) THEN
C     ==--------------------------------------------------------------==
C     ==  INITIAL HESSIAN FROM TRANSITION STATE SEARCH PARTIAL HESS.  ==
C     ==--------------------------------------------------------------==
        CALL PHESSCI(HESS,NODIM)
      ENDIF
 2000 CONTINUE
C     WE CANNOT SYMMETRIZE THE MATRIX IF THE DEGREES NUMBER IS 
C     SMALLER THAN 3 NAT.
      IF(NODIM.GE.3*NAT) THEN
        CALL SYMMAT(HESS,HSCR,LHSCR,0)
      ENDIF
C     We use inverse Hessian matrix.
      IF(TINVBFGS) THEN
        DO I=1,NODIM
          IF(HESS(I,I).NE.0.D0) THEN
            HESS(I,I)=1.D0/HESS(I,I)
          ENDIF
        ENDDO
      ENDIF
      CALL FREEM(IP_HSCR)
      CALL TIHALT('    HESSIN',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETHES(RHESS)
C     ==--------------------------------------------------------------==
C     == INITIALIZATION OF THE NUCLEAR HESSIAN                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      REAL*8  RHESS(3*NAT,3*NAT)
C     Variables
      INTEGER K1,I1,J1,L1,M1,K2,I2,J2,L2,M2
C     ==--------------------------------------------------------------==
      CALL UNITMX(HESS,NODIM)
      K1=0
      DO I1=1,NAT
        DO J1=1,3
          L1=LSKCOR(J1,I1)
          IF(L1.NE.0) THEN
            K1=K1+1
            M1=(I1-1)*3+J1
            K2=0
            DO I2=1,NAT
              DO J2=1,3
                L2=LSKCOR(J2,I2)
                IF(L2.NE.0) THEN
                  K2=K2+1
                  M2=(I2-1)*3+J2
                  HESS(K1,K2) = RHESS(M1,M2)
                ENDIF
              ENDDO
            ENDDO
          ENDIF
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
