C     ==================================================================
      SUBROUTINE HFX(C0,C2,F,PSIA,NSTATE,EHFX,VHFX)
C     ==================================================================
C     == HARTREE-FOCK EXCHANGE                                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'func.inc'
      INCLUDE 'rswf.inc'
      INCLUDE 'hfx.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,*),C2(NGW,*),PSIA(*)
      REAL*8     F(*),EHFX,VHFX
C     Variables
      REAL*8     PFX,PFL,FF,PFX1,PFX2
      REAL*8     COORDAB(3),DAB
      REAL*8     DOTP
      EXTERNAL   DOTP
      INTEGER    ISUB,IA,IB,IB1,IB2,IG,I,NUPPER,IR,IWF
      COMPLEX*16 PSIB(*),PSIC(*),VPOTG(*)
      REAL*8     VPOTR(*),PS1D,PS2D
      POINTER    (IP_PSIB,PSIB),(IP_PSIC,PSIC)
      POINTER    (IP_VPOTG,VPOTG),(IP_VPOTR,VPOTR)
      LOGICAL    LDBL
C     ==--------------------------------------------------------------==
      EHFX=0.D0
      VHFX=0.D0
      IF(MHFX.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('       HFX',ISUB)
      IF(TKPNT) CALL STOPGM('HFX','K-POINTS NOT IMPLEMENTED')
      IF(TLSE) CALL STOPGM('HFX','NO LSE POSSIBLE')
      IF(TIVAN) CALL STOPGM('HFX','NO VDB PP POSSIBLE')
      IF(NOGRP.GT.1) CALL STOPGM('HFX','TASK GROUPS NOT IMPLEMENTED')
C
      CALL SETFFTN(IPOOLHFX)
C
      IF(TLSD) THEN
        DO I=1,NSTATE
          FF=ABS(F(I)-1.D0)
          IF(FF.GT.0.D0 .AND. ABS(F(I)).GT.0.D0)
     &        CALL STOPGM('HFX','ONLY OCCUPATIONS (0,1) ALLOWED')
        ENDDO
      ELSE
        DO I=1,NSTATE
          FF=ABS(F(I)-2.D0)
          IF(FF.GT.0.D0 .AND. ABS(F(I)).GT.0.D0)
     &        CALL STOPGM('HFX','ONLY OCCUPATIONS (0,2) ALLOWED')
        ENDDO
      ENDIF
      PFL=0.25D0
      IF(TLSD) PFL=0.5D0
      IF(THYBRID) PFL=PFL*PHFX
      CALL MEMORY(IP_PSIC,2*MAXFFTN,'PSIC')
      CALL MEMORY(IP_VPOTG,4*JHG,'VPOTG')
      CALL MEMORY(IP_VPOTR,2*LLR1,'VPOTR')
      IF(MHFX.EQ.1) THEN
C       HARTREE-FOCK
        CALL MEMORY(IP_PSIB,2*MAXFFTN,'PSIB')
C
        IF(KRWFN) THEN
          IF(IPOOLHFX.NE.0 .OR. .NOT.RSACTIVE) THEN
            DO IA=1,NSTATE,2
              CALL ZAZZERO(PSIA,MAXFFTN)
              IF(IA.EQ.NSTATE) THEN
C$OMP parallel do private(IG)
                DO IG=1,JGW
                  PSIA(NZFS(IG))=C0(IG,IA)
                  PSIA(INZS(IG))=DCONJG(C0(IG,IA))
                ENDDO
                IF(GEQ0) PSIA(NZFS(1))=C0(1,IA)
              ELSE
C$OMP parallel do private(IG)
                DO IG=1,JGW
                  PSIA(NZFS(IG))=C0(IG,IA)+UIMAG*C0(IG,IA+1)
                  PSIA(INZS(IG))=DCONJG(C0(IG,IA))+
     *                       UIMAG*DCONJG(C0(IG,IA+1))
                ENDDO
                IF(GEQ0) PSIA(NZFS(1))=C0(1,IA)+UIMAG*C0(1,IA+1)
              ENDIF
              CALL INVFFTN(PSIA,.TRUE.)
              IF(IA.LE.MAXSTATESX) THEN
                IWF=IA/2+1
                CALL DCOPY(2*LLR1,PSIA(1),1,RSWFX(1,IWF),1)
              ENDIF
            ENDDO
          ENDIF
        ENDIF
C
        DO IA=1,NSTATE
          IF(F(IA).GT.1.D-6) THEN
            IF(KRWFN .AND. IA.LE.MAXSTATESX) THEN
              IF(MOD(IA,2).EQ.0) THEN
                IWF=IA/2
C$OMP parallel do private(IR)
                DO IR=1,LLR1
                  PSIA(IR)=DIMAG(RSWFX(IR,IWF))
                ENDDO
              ELSE
                IWF=IA/2+1
C$OMP parallel do private(IR)
                DO IR=1,LLR1
                  PSIA(IR)=DREAL(RSWFX(IR,IWF))
                ENDDO
              ENDIF
            ELSE
              CALL ZAZZERO(PSIA,MAXFFTN)
C$OMP parallel do private(IG)
              DO IG=1,JGW
                PSIA(NZFS(IG))=C0(IG,IA)
                PSIA(INZS(IG))=DCONJG(C0(IG,IA))
              ENDDO
              IF(GEQ0) PSIA(NZFS(1))=C0(1,IA)
C             Transform the wavefunction to real space
              CALL INVFFTN(PSIA,.TRUE.)
            ENDIF
C           Handle the diagonal terms
            PFX=PFL*F(IA)*F(IA)
            CALL HFXAA(EHFX,PFX,PSIA,VPOTG,VPOTR,PSIC,C2(1,IA))
            IF(.NOT.TCLUST.AND.PARENT) 
     *                  EHFX=EHFX-EG0HFX*F(IA)*F(IA)/OMEGA
            IF(TWSCR.AND.TDIAW) GOTO 101
C           Now for the other terms IA-IB
            IF(TLSD.AND.IA.LE.NSUP) THEN
              NUPPER=NSUP
            ELSE
              NUPPER=NSTATE
            ENDIF
            DO IB=IA+1,NUPPER,2
              IB1=IB
              IB2=IB+1
              IF(F(IB1).LT.1.D-6) IB1=0
              IF(IB2.GT.NUPPER) THEN
                IB2=0
              ELSEIF(F(IB2).LT.1.D-6) THEN
                IB2=0
              ENDIF
              IF(TWSCR.AND.TWFC) THEN
                IF(IB1.NE.0) THEN
                  COORDAB(1)=WCENTX(1,IB1)-WCENTX(1,IA)
                  COORDAB(2)=WCENTX(2,IB1)-WCENTX(2,IA)
                  COORDAB(3)=WCENTX(3,IB1)-WCENTX(3,IA)
                  CALL PBC(COORDAB(1),COORDAB(2),COORDAB(3),
     *              COORDAB(1),COORDAB(2),COORDAB(3),1,APBC,IBRAV)
                  DAB=DSQRT(COORDAB(1)**2+COORDAB(2)**2+COORDAB(3)**2)
                  IF(DAB.GT.DWFC) IB1=0
                ENDIF
                IF(IB2.NE.0) THEN
                  COORDAB(1)=WCENTX(1,IB2)-WCENTX(1,IA)
                  COORDAB(2)=WCENTX(2,IB2)-WCENTX(2,IA)
                  COORDAB(3)=WCENTX(3,IB2)-WCENTX(3,IA)
                  CALL PBC(COORDAB(1),COORDAB(2),COORDAB(3),
     *              COORDAB(1),COORDAB(2),COORDAB(3),1,APBC,IBRAV)
                  DAB=DSQRT(COORDAB(1)**2+COORDAB(2)**2+COORDAB(3)**2)
                  IF(DAB.GT.DWFC) IB2=0
                ENDIF
              ENDIF
              IF(IB1.NE.0 .OR. IB2.NE.0) THEN
                IF(KRWFN .AND. (IB1.LE.MAXSTATESX.OR.
     *                          IB2.LE.MAXSTATESX)) THEN
                  CALL ZAZZERO(PSIB,MAXFFTN)
                  IF(IB1.NE.0) THEN
                    IF(MOD(IB1,2).EQ.0) THEN
                      IWF=IB1/2
C$OMP parallel do private(IR)
                      DO IR=1,LLR1
                        PSIB(IR)=PSIB(IR)+DIMAG(RSWFX(IR,IWF))
                      ENDDO
                    ELSE
                      IWF=IB1/2+1
C$OMP parallel do private(IR)
                      DO IR=1,LLR1
                        PSIB(IR)=PSIB(IR)+DREAL(RSWFX(IR,IWF))
                      ENDDO
                    ENDIF
                  ENDIF
                  IF(IB2.NE.0) THEN
                    IF(MOD(IB2,2).EQ.0) THEN
                      IWF=IB2/2
C$OMP parallel do private(IR)
                      DO IR=1,LLR1
                        PSIB(IR)=PSIB(IR)+UIMAG*DIMAG(RSWFX(IR,IWF))
                      ENDDO
                    ELSE
                      IWF=IB2/2+1
C$OMP parallel do private(IR)
                      DO IR=1,LLR1
                        PSIB(IR)=PSIB(IR)+UIMAG*DREAL(RSWFX(IR,IWF))
                      ENDDO
                    ENDIF
                  ENDIF
                ELSE
                  IF(IB1.EQ.0) THEN
                    CALL ZAZZERO(PSIB,MAXFFTN)
C$OMP parallel do private(IG)
                    DO IG=1,JGW
                      PSIB(NZFS(IG))=UIMAG*C0(IG,IB2)
                      PSIB(INZS(IG))=UIMAG*DCONJG(C0(IG,IB2))
                    ENDDO
                    IF(GEQ0) PSIB(NZFS(1))=UIMAG*C0(1,IB2)
                  ELSEIF(IB2.EQ.0) THEN
                    CALL ZAZZERO(PSIB,MAXFFTN)
C$OMP parallel do private(IG)
                    DO IG=1,JGW
                      PSIB(NZFS(IG))=C0(IG,IB1)
                      PSIB(INZS(IG))=DCONJG(C0(IG,IB1))
                    ENDDO
                    IF(GEQ0) PSIB(NZFS(1))=C0(1,IB1)
                  ELSE
                    CALL ZAZZERO(PSIB,MAXFFTN)
C$OMP parallel do private(IG)
                    DO IG=1,JGW
                      PSIB(NZFS(IG))=C0(IG,IB1)+UIMAG*C0(IG,IB2)
                      PSIB(INZS(IG))=DCONJG(C0(IG,IB1))+
     *                              UIMAG*DCONJG(C0(IG,IB2))
                    ENDDO
                    IF(GEQ0) PSIB(NZFS(1))=C0(1,IB1)+UIMAG*C0(1,IB2)
                  ENDIF
C                 Transform the wavefunction to real space
                  CALL INVFFTN(PSIB,.TRUE.)
                ENDIF
C
                IF(TWSCR.AND.TDEN) THEN
                  IF(IB1.NE.0) THEN
                    PS1D=0.D0
C$OMP parallel do private(IR)
C$OMP+ reduction(+:PS1D)
                    DO IR=1,LLR1
                      PS1D=PS1D+(DREAL(PSIA(IR))**2 *DREAL(PSIB(IR))**2)
                    ENDDO
                    CALL GLOSUM(1,PS1D)
                    PS1D=PS1D*(1.D0/DBLE(NR1S*NR2S*NR3S))**2
                    IF(PS1D.LT.DWFMAX) IB1=0
                  ENDIF
                  IF(IB2.NE.0) THEN
                    PS2D=0.D0
C$OMP parallel do private(IR)
C$OMP+ reduction(+:PS2D)
                    DO IR=1,LLR1
                      PS2D=PS2D+(DREAL(PSIA(IR))**2 *DIMAG(PSIB(IR))**2)
                    ENDDO
                    CALL GLOSUM(1,PS2D)
                    PS2D=PS2D*(1.D0/DBLE(NR1S*NR2S*NR3S))**2
                    IF(PS2D.LT.DWFMAX) IB2=0
                  ENDIF
                ENDIF
C
                LDBL=.FALSE.
                IF(IB1.NE.0 .AND. IB2.NE.0) LDBL=.TRUE.
                IF(LDBL) THEN
                  PFX1=PFL*F(IA)*F(IB1)
                  PFX2=PFL*F(IA)*F(IB2)
                  CALL HFXAB2(EHFX,PFX1,PFX2,PSIA,PSIB,VPOTG,VPOTR,
     *                        PSIC,C2(1,IA),C2(1,IB1),C2(1,IB2))
                ELSE
C                 Terms IA*IB1
                  PFX=PFL*F(IA)*F(IB1)
                  IF(IB1.NE.0) THEN
                    CALL HFXAB(EHFX,PFX,PSIA,PSIB,1,
     *                     VPOTG,VPOTR,PSIC,C2(1,IA),C2(1,IB1))
                  ENDIF
C                 Terms IA*IB2
                  PFX=PFL*F(IA)*F(IB2)
                  IF(IB2.NE.0) THEN
                    CALL HFXAB(EHFX,PFX,PSIA,PSIB,2,
     *                       VPOTG,VPOTR,PSIC,C2(1,IA),C2(1,IB2))
                  ENDIF
                ENDIF
              ENDIF
            ENDDO
 101        CONTINUE
          ENDIF
        ENDDO 
        CALL FREEM(IP_PSIB)
      ELSE
C       HARTREE
        DO IA=1,NSTATE
          IF(F(IA).GT.1.D-6) THEN
            CALL ZAZZERO(PSIA,MAXFFTN)
            DO IG=1,JGW
              PSIA(NZFS(IG))=C0(IG,IA)
              PSIA(INZS(IG))=DCONJG(C0(IG,IA))
            ENDDO
            IF(GEQ0) PSIA(NZFS(1))=C0(1,IA)
C           Transform the wavefunction to real space
            CALL INVFFTN(PSIA,.TRUE.)
            PFX=PFL*F(IA)*F(IA)
            CALL HFXAA(EHFX,PFX,PSIA,VPOTG,VPOTR,PSIC,C2(1,IA))
            IF(.NOT.TCLUST.AND.PARENT) 
     *                 EHFX=EHFX-EG0HFX*F(IA)*F(IA)/OMEGA
          ENDIF
        ENDDO
      ENDIF
      EHFX=EHFX*OMEGA
      CALL GLOSUM(1,EHFX)
C     POTENTIAL
      DO IA=1,NSTATE
        VHFX=VHFX+DOTP(NGW,C0(1,IA),C2(1,IA))
      ENDDO
      CALL GLOSUM(1,VHFX)
      CALL FREEM(IP_PSIC)
      CALL FREEM(IP_VPOTG)
      CALL FREEM(IP_VPOTR)
      CALL TIHALT('       HFX',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HFXAB(EHFX,PF,PSIA,PSIB,IRAN,VPOTG,VPOTR,PSIC,C2A,C2B)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'func.inc'
C     Arguments
      REAL*8     EHFX,PF
      COMPLEX*16 C2A(JGW),C2B(JGW)
      COMPLEX*16 PSIA(LLR1),PSIB(LLR1),PSIC(LLR1),VPOTG(JHG)
      REAL*8     VPOTR(LLR1)
      INTEGER    IRAN
C     Variables
      INTEGER    IR,IG
      COMPLEX*16 FP,FM
C     ==--------------------------------------------------------------==
      IF(IRAN.EQ.1) THEN
C$OMP parallel do private(IR)
        DO IR=1,LLR1
          PSIC(IR)=DREAL(PSIA(IR))*DREAL(PSIB(IR))
        ENDDO
      ELSE
C$OMP parallel do private(IR)
        DO IR=1,LLR1
          PSIC(IR)=DREAL(PSIA(IR))*DIMAG(PSIB(IR))
        ENDDO
      ENDIF
      CALL DSCAL(2*LLR1,1.D0/OMEGA,PSIC,1)
      CALL FWFFTN(PSIC,.FALSE.)
      IF(MSELF.NE.0) THEN
C$OMP parallel do private(IG)
C$OMP+ reduction(+:EHFX)
        DO IG=1,JHG
          VPOTG(IG)=-PF*SCG(IG)*PSIC(NZFF(IG))
          EHFX=EHFX+DREAL(4.D0*VPOTG(IG)*DCONJG(PSIC(NZFF(IG))))
        ENDDO
      ELSE
C$OMP parallel do private(IG)
C$OMP+ reduction(+:EHFX)
        DO IG=1,JHG
          VPOTG(IG)=-PF*SCGX(IG)*PSIC(NZFF(IG))
          EHFX=EHFX+DREAL(4.D0*VPOTG(IG)*DCONJG(PSIC(NZFF(IG))))
        ENDDO
      ENDIF
      IF(GEQ0) EHFX=EHFX-DREAL(2.D0*VPOTG(1)*DCONJG(PSIC(NZFF(1))))
      CALL ZAZZERO(PSIC,MAXFFTN)
C$OMP parallel do private(IG)
      DO IG=1,JHG
        PSIC(NZFF(IG))=VPOTG(IG)
        PSIC(INZF(IG))=DCONJG(VPOTG(IG))
      ENDDO
      IF(GEQ0) PSIC(NZFF(1))=VPOTG(1)
      CALL INVFFTN(PSIC,.FALSE.)
C$OMP parallel do private(IR)
      DO IR=1,LLR1
        VPOTR(IR)=DREAL(PSIC(IR))
      ENDDO
      IF(IRAN.EQ.1) THEN
C$OMP parallel do private(IR)
        DO IR=1,LLR1
          PSIC(IR)=VPOTR(IR)*(DREAL(PSIA(IR))+UIMAG*DREAL(PSIB(IR)))
        ENDDO
      ELSE
C$OMP parallel do private(IR)
        DO IR=1,LLR1
          PSIC(IR)=VPOTR(IR)*(DREAL(PSIA(IR))+UIMAG*DIMAG(PSIB(IR)))
        ENDDO
      ENDIF
      CALL FWFFTN(PSIC,.TRUE.)
C$OMP parallel do private(IG,FP,FM)
      DO IG=1,JGW
        FP=PSIC(NZFS(IG))+PSIC(INZS(IG))
        FM=PSIC(NZFS(IG))-PSIC(INZS(IG))
        C2B(IG)=C2B(IG)-DCMPLX(DREAL(FP),DIMAG(FM))
        C2A(IG)=C2A(IG)-DCMPLX(DIMAG(FP),-DREAL(FM))
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HFXAB2(EHFX,PF1,PF2,PSIA,PSIB,VPOTG,VPOTR,PSIC,
     *                  C2A,C2B1,C2B2)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'func.inc'
C     Arguments
      REAL*8     EHFX,PF1,PF2
      COMPLEX*16 C2A(JGW),C2B1(JGW),C2B2(JGW)
      COMPLEX*16 PSIA(LLR1),PSIB(LLR1),PSIC(LLR1),VPOTG(JHG,2)
      REAL*8     VPOTR(LLR1,2)
C     Variables
      INTEGER    IR,IG
      COMPLEX*16 FP,FM
C     ==--------------------------------------------------------------==
      DO IR=1,LLR1
        PSIC(IR)=DREAL(PSIA(IR))*PSIB(IR)
      ENDDO
      CALL DSCAL(2*LLR1,1.D0/OMEGA,PSIC,1)
      CALL FWFFTN(PSIC,.FALSE.)
      IF(MSELF.NE.0) THEN
C$OMP parallel do private(IG,FP,FM)
C$OMP+ reduction(+:EHFX)
        DO IG=1,JHG
          FP=PSIC(NZFF(IG))+PSIC(INZF(IG))
          FM=PSIC(NZFF(IG))-PSIC(INZF(IG))
          VPOTG(IG,1)=-PF1*SCG(IG)*0.5D0*DCMPLX(DREAL(FP),DIMAG(FM))
          VPOTG(IG,2)=-PF2*SCG(IG)*0.5D0*DCMPLX(DIMAG(FP),-DREAL(FM))
          EHFX=EHFX+DREAL(2.D0*VPOTG(IG,1)*DCMPLX(DREAL(FP),-DIMAG(FM)))
          EHFX=EHFX+DREAL(2.D0*VPOTG(IG,2)*DCMPLX(DIMAG(FP),-DREAL(FM)))
        ENDDO
      ELSE
C$OMP parallel do private(IG,FP,FM)
C$OMP+ reduction(+:EHFX)
        DO IG=1,JHG
          FP=PSIC(NZFF(IG))+PSIC(INZF(IG))
          FM=PSIC(NZFF(IG))-PSIC(INZF(IG))
          VPOTG(IG,1)=-PF1*SCGX(IG)*0.5D0*DCMPLX(DREAL(FP),DIMAG(FM))
          VPOTG(IG,2)=-PF2*SCGX(IG)*0.5D0*DCMPLX(DIMAG(FP),-DREAL(FM))
          EHFX=EHFX+DREAL(2.D0*VPOTG(IG,1)*DCMPLX(DREAL(FP),-DIMAG(FM)))
          EHFX=EHFX+DREAL(2.D0*VPOTG(IG,2)*DCMPLX(DIMAG(FP),DREAL(FM)))
        ENDDO
      ENDIF
      IF(GEQ0) THEN
        FP=PSIC(NZFF(1))+PSIC(INZF(1))
        FM=PSIC(NZFF(1))-PSIC(INZF(1))
        EHFX=EHFX-DREAL(VPOTG(1,1)*DCMPLX(DREAL(FP),-DIMAG(FM)))
        EHFX=EHFX-DREAL(VPOTG(1,2)*DCMPLX(DIMAG(FP),DREAL(FM)))
      ENDIF
      CALL ZAZZERO(PSIC,MAXFFTN)
C$OMP parallel do private(IG)
      DO IG=1,JHG
        PSIC(NZFF(IG))=VPOTG(IG,1)+UIMAG*VPOTG(IG,2)
        PSIC(INZF(IG))=DCONJG(VPOTG(IG,1))+UIMAG*DCONJG(VPOTG(IG,2))
      ENDDO
      IF(GEQ0) PSIC(NZFF(1))=VPOTG(1,1)+UIMAG*VPOTG(1,2)
      CALL INVFFTN(PSIC,.FALSE.)
C$OMP parallel do private(IR)
      DO IR=1,LLR1
        VPOTR(IR,1)=DREAL(PSIC(IR))
        VPOTR(IR,2)=DIMAG(PSIC(IR))
      ENDDO
C$OMP parallel do private(IR)
      DO IR=1,LLR1
        PSIC(IR)=VPOTR(IR,1)*(DREAL(PSIA(IR))+UIMAG*DREAL(PSIB(IR)))
      ENDDO
      CALL FWFFTN(PSIC,.TRUE.)
C$OMP parallel do private(IG,FP,FM)
      DO IG=1,JGW
        FP=PSIC(NZFS(IG))+PSIC(INZS(IG))
        FM=PSIC(NZFS(IG))-PSIC(INZS(IG))
        C2B1(IG)=C2B1(IG)-DCMPLX(DREAL(FP),DIMAG(FM))
        C2A(IG)=C2A(IG)-DCMPLX(DIMAG(FP),-DREAL(FM))
      ENDDO
C$OMP parallel do private(IR)
      DO IR=1,LLR1
        PSIC(IR)=VPOTR(IR,2)*(DREAL(PSIA(IR))+UIMAG*DIMAG(PSIB(IR)))
      ENDDO
      CALL FWFFTN(PSIC,.TRUE.)
C$OMP parallel do private(IG,FP,FM)
      DO IG=1,JGW
        FP=PSIC(NZFS(IG))+PSIC(INZS(IG))
        FM=PSIC(NZFS(IG))-PSIC(INZS(IG))
        C2B2(IG)=C2B2(IG)-DCMPLX(DREAL(FP),DIMAG(FM))
        C2A(IG)=C2A(IG)-DCMPLX(DIMAG(FP),-DREAL(FM))
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HFXAA(EHFX,PF,PSIA,VPOTG,VPOTR,PSIC,C2A)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cnst.inc'
C     Arguments
      REAL*8     EHFX,PF
      COMPLEX*16 C2A(*)
      COMPLEX*16 PSIA(*),PSIC(*),VPOTG(*)
      REAL*8     VPOTR(*)
C     Variables
      INTEGER    IR,IG
      COMPLEX*16 FP,FM
C     ==--------------------------------------------------------------==
C$OMP parallel do private(IR)
      DO IR=1,LLR1
        PSIC(IR)=DREAL(PSIA(IR))*DREAL(PSIA(IR))
      ENDDO
      CALL DSCAL(2*LLR1,1.D0/OMEGA,PSIC,1)
      CALL FWFFTN(PSIC,.FALSE.)
C$OMP parallel do private(IG,FP)
C$OMP+ reduction(+:EHFX)
      DO IG=1,JHG
        FP=PSIC(NZFF(IG))
        VPOTG(IG)=-PF*SCGX(IG)*FP
        EHFX=EHFX+DREAL(2.D0*VPOTG(IG)*DCONJG(FP))
      ENDDO
      IF(GEQ0) EHFX=EHFX-DREAL(VPOTG(1)*DCONJG(PSIC(NZFF(1))))
      CALL ZAZZERO(PSIC,MAXFFTN)
C$OMP parallel do private(IG)
      DO IG=1,JHG
        PSIC(NZFF(IG))=VPOTG(IG)
        PSIC(INZF(IG))=DCONJG(VPOTG(IG))
      ENDDO
      IF(GEQ0) PSIC(NZFF(1))=VPOTG(1)
      CALL INVFFTN(PSIC,.FALSE.)
C$OMP parallel do private(IR)
      DO IR=1,LLR1
        VPOTR(IR)=DREAL(PSIC(IR))
      ENDDO
C$OMP parallel do private(IR)
      DO IR=1,LLR1
        PSIC(IR)=VPOTR(IR)*DREAL(PSIA(IR))
      ENDDO
      CALL FWFFTN(PSIC,.TRUE.)
C$OMP parallel do private(IG,FP,FM)
      DO IG=1,JGW
        FP=PSIC(NZFS(IG))+PSIC(INZS(IG))
        FM=PSIC(NZFS(IG))-PSIC(INZS(IG))
        C2A(IG)=C2A(IG)-DCMPLX(DREAL(FP),DIMAG(FM))
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HFXPSI(C0,CPSI,C2,F,SIGN,PSIA,NSTATE,NORB)
C     ==================================================================
C     == HARTREE-FOCK EXCHANGE                                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'func.inc'
      INCLUDE 'hfx.inc'
C     Arguments
      INTEGER    NSTATE,NORB
      COMPLEX*16 C0(NGW,NSTATE),CPSI(NGW,NORB),C2(NGW,NORB),
     &           PSIA(*)
      REAL*8     F(NSTATE),SIGN
C     Variables
      REAL*8     PFX,PFL
      INTEGER    ISUB,IA,IB,IB1,IB2,IG,I
      COMPLEX*16 PSIB(*),PSIC(*),VPOTG(*)
      REAL*8     VPOTR(*)
      POINTER    (IP_PSIB,PSIB),(IP_PSIC,PSIC)
      POINTER    (IP_VPOTG,VPOTG),(IP_VPOTR,VPOTR)
C     ==--------------------------------------------------------------==
      IF(MHFX.EQ.0) RETURN
      IF(MHFX.EQ.2) CALL STOPGM('HFXPSI','HARTREE METHOD NOT POSSIBLE')
C     ==--------------------------------------------------------------==
      CALL TISET('    HFXPSI',ISUB)
      IF(TKPNT) CALL STOPGM('HFXPSI','K-POINTS NOT IMPLEMENTED')
      IF(TLSE) CALL STOPGM('HFXPSI','NO LSE POSSIBLE')
      IF(TIVAN) CALL STOPGM('HFXPSI','NO VDB PP POSSIBLE')
      IF(NOGRP.GT.1) CALL STOPGM('HFXPSI','TASK GROUPS NOT IMPLEMENTED')
      DO I=1,NSTATE
        IF(F(1).NE.F(I).AND. F(I).GT.1.D-6) 
     &      CALL STOPGM('HFXPSI','OCCUPATION NUMBERS CHANGE')
      ENDDO
C
      CALL SETFFTN(IPOOLHFX)
C
      PFL=0.5D0
      IF(THYBRID) PFL=PFL*PHFX
      PFL=PFL*SIGN
      CALL MEMORY(IP_PSIC,2*MAXFFTN,'PSIC')
      CALL MEMORY(IP_VPOTG,2*JHG,'VPOTG')
      CALL MEMORY(IP_VPOTR,LLR1,'VPOTR')
C     HARTREE-FOCK
      CALL MEMORY(IP_PSIB,2*MAXFFTN,'PSIB')
      DO IA=1,NORB
        CALL ZAZZERO(PSIA,MAXFFTN)
        DO IG=1,JGW
          PSIA(NZFS(IG))=CPSI(IG,IA)
          PSIA(INZS(IG))=DCONJG(CPSI(IG,IA))
        ENDDO
        IF(GEQ0) PSIA(NZFS(1))=CPSI(1,IA)
C       Transform the wavefunction to real space
        CALL INVFFTN(PSIA,.TRUE.)
        DO IB=1,NSTATE,2
          IB1=IB
          IB2=IB+1
          IF(F(IB1).LT.1.D-6) IB1=0
          IF(IB2.GT.NSTATE) THEN
            IB2=0
          ELSEIF(F(IB2).LT.1.D-6) THEN
            IB2=0
          ENDIF
          IF(IB1.NE.0 .OR. IB2.NE.0) THEN
            IF(IB1.EQ.0) THEN
              CALL ZAZZERO(PSIB,MAXFFTN)
              DO IG=1,JGW
                PSIB(NZFS(IG))=UIMAG*C0(IG,IB2)
                PSIB(INZS(IG))=UIMAG*DCONJG(C0(IG,IB2))
              ENDDO
              IF(GEQ0) PSIB(NZFS(1))=UIMAG*C0(1,IB2)
            ELSEIF(IB2.EQ.0) THEN
              CALL ZAZZERO(PSIB,MAXFFTN)
              DO IG=1,JGW
                PSIB(NZFS(IG))=C0(IG,IB1)
                PSIB(INZS(IG))=DCONJG(C0(IG,IB1))
              ENDDO
              IF(GEQ0) PSIB(NZFS(1))=C0(1,IB1)
            ELSE
              CALL ZAZZERO(PSIB,MAXFFTN)
              DO IG=1,JGW
                PSIB(NZFS(IG))=C0(IG,IB1)+UIMAG*C0(IG,IB2)
                PSIB(INZS(IG))=DCONJG(C0(IG,IB1))+
     *                            UIMAG*DCONJG(C0(IG,IB2))
              ENDDO
              IF(GEQ0) PSIB(NZFS(1))=C0(1,IB1)+UIMAG*C0(1,IB2)
            ENDIF
C           Transform the wavefunction to real space
            CALL INVFFTN(PSIB,.TRUE.)
C           Terms IA*IB1
            PFX=PFL*F(IB1)
            IF(IB1.NE.0) THEN
              CALL HFXPB(PFX,PSIA,PSIB,1,VPOTG,VPOTR,PSIC,C2(1,IA))
            ENDIF
C           Terms IA*IB2
            PFX=PFL*F(IB2)
            IF(IB2.NE.0) THEN
              CALL HFXPB(PFX,PSIA,PSIB,2,VPOTG,VPOTR,PSIC,C2(1,IA))
            ENDIF
          ENDIF
        ENDDO
      ENDDO 
      CALL FREEM(IP_PSIB)
      CALL FREEM(IP_PSIC)
      CALL FREEM(IP_VPOTG)
      CALL FREEM(IP_VPOTR)
      CALL TIHALT('    HFXPSI',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HFXPB(PF,PSIA,PSIB,IRAN,VPOTG,VPOTR,PSIC,C2A)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'func.inc'
C     Arguments
      REAL*8     PF
      COMPLEX*16 C2A(JGW)
      COMPLEX*16 PSIA(LLR1),PSIB(LLR1),PSIC(LLR1),VPOTG(JHG)
      REAL*8     VPOTR(LLR1)
      INTEGER    IRAN
C     Variables
      INTEGER    IR,IG
      COMPLEX*16 FP,FM
C     ==--------------------------------------------------------------==
      IF(IRAN.EQ.1) THEN
        DO IR=1,LLR1
          PSIC(IR)=DREAL(PSIA(IR))*DREAL(PSIB(IR))
        ENDDO
      ELSE
        DO IR=1,LLR1
          PSIC(IR)=DREAL(PSIA(IR))*DIMAG(PSIB(IR))
        ENDDO
      ENDIF
      CALL DSCAL(2*LLR1,1.D0/OMEGA,PSIC,1)
      CALL FWFFTN(PSIC,.FALSE.)
      IF(MSELF.NE.0) THEN
        DO IG=1,JHG
          VPOTG(IG)=-PF*SCG(IG)*PSIC(NZFF(IG))
        ENDDO
      ELSE
        DO IG=1,JHG
          VPOTG(IG)=-PF*SCGX(IG)*PSIC(NZFF(IG))
        ENDDO
      ENDIF
      CALL ZAZZERO(PSIC,MAXFFTN)
      DO IG=1,JHG
        PSIC(NZFF(IG))=VPOTG(IG)
        PSIC(INZF(IG))=DCONJG(VPOTG(IG))
      ENDDO
      IF(GEQ0) PSIC(NZFF(1))=VPOTG(1)
      CALL INVFFTN(PSIC,.FALSE.)
      DO IR=1,LLR1
        VPOTR(IR)=DREAL(PSIC(IR))
      ENDDO
      IF(IRAN.EQ.1) THEN
        DO IR=1,LLR1
          PSIC(IR)=VPOTR(IR)*DREAL(PSIB(IR))
        ENDDO
      ELSE
        DO IR=1,LLR1
          PSIC(IR)=VPOTR(IR)*DIMAG(PSIB(IR))
        ENDDO
      ENDIF
      CALL FWFFTN(PSIC,.TRUE.)
      DO IG=1,JGW
        FP=PSIC(NZFS(IG))+PSIC(INZS(IG))
        FM=PSIC(NZFS(IG))-PSIC(INZS(IG))
        C2A(IG)=C2A(IG)+0.5D0*DCMPLX(DREAL(FP),DIMAG(FM))
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HFXRPA(C0,C1,C2,PSIA,NSTATE,TCIS)
C     ==================================================================
C     == HARTREE-FOCK EXCHANGE CONTRIBUTION TO RPA                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'func.inc'
      INCLUDE 'hfx.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,NSTATE),C1(NGW,NSTATE),C2(NGW,NSTATE),
     &           PSIA(*)
      LOGICAL    TCIS
C     Variables
      REAL*8     PFL
      INTEGER    ISUB,IA,IB,IB1,IB2,IG,NLOWER,NUPPER
      COMPLEX*16 PSIB(*),PSIC(*),VPOTG(NHG)
      REAL*8     VPOTR(*)
      POINTER    (IP_PSIB,PSIB),(IP_PSIC,PSIC)
      POINTER    (IP_VPOTG,VPOTG),(IP_VPOTR,VPOTR)
C     ==--------------------------------------------------------------==
      IF(MHFX.EQ.0) RETURN
      IF(MHFX.EQ.2) CALL STOPGM('HFXRPA','HARTREE METHOD NOT POSSIBLE')
C     ==--------------------------------------------------------------==
      CALL TISET('    HFXRPA',ISUB)
      IF(TKPNT) CALL STOPGM('HFXRPA','K-POINTS NOT IMPLEMENTED')
      IF(TLSE) CALL STOPGM('HFXRPA','NO LSE POSSIBLE')
      IF(TIVAN) CALL STOPGM('HFXRPA','NO VDB PP POSSIBLE')
      IF(NOGRP.GT.1) CALL STOPGM('HFXRPA','TASK GROUPS NOT IMPLEMENTED')
C
      CALL SETFFTN(IPOOLHFX)
C
      PFL=0.5D0
      IF(TLSD) PFL=1.0D0
      PFL=PFL*2.0D0
      IF(.NOT.TCIS) PFL=2.D0*PFL
      IF(THYBRID) PFL=PFL*PHFX
      CALL MEMORY(IP_PSIC,2*MAXFFTN,'PSIC')
      CALL MEMORY(IP_VPOTG,2*JHG,'VPOTG')
      CALL MEMORY(IP_VPOTR,LLR1,'VPOTR')
C     HARTREE-FOCK
      CALL MEMORY(IP_PSIB,2*MAXFFTN,'PSIB')
      DO IA=1,NSTATE
        CALL ZAZZERO(PSIA,MAXFFTN)
        DO IG=1,JGW
          PSIA(NZFS(IG))=C1(IG,IA)+UIMAG*C0(IG,IA)
          PSIA(INZS(IG))=DCONJG(C1(IG,IA))+
     *                     UIMAG*DCONJG(C0(IG,IA))
        ENDDO
        IF(GEQ0) PSIA(NZFS(1))=C1(1,IA)+UIMAG*C0(1,IA)
C       Transform the wavefunctions to real space
        CALL INVFFTN(PSIA,.TRUE.)
        IF(TLSD) THEN
          IF(IA.LE.NSUP) THEN
            NUPPER=NSUP
            NLOWER=1
          ELSE
            NUPPER=NSTATE
            NLOWER=NSUP+1
          ENDIF
        ELSE
          NUPPER=NSTATE
          NLOWER=1
        ENDIF
        DO IB=NLOWER,NUPPER,2
          CALL ZAZZERO(PSIB,MAXFFTN)
          IB1=IB
          IB2=IB+1
          IF(IB2.GT.NUPPER) IB2=0
          IF(IB2.EQ.0) THEN
            DO IG=1,JGW
              PSIB(NZFS(IG))=C0(IG,IB1)
              PSIB(INZS(IG))=DCONJG(C0(IG,IB1))
            ENDDO
            IF(GEQ0) PSIB(NZFS(1))=C0(1,IB1)
          ELSE
            DO IG=1,JGW
              PSIB(NZFS(IG))=C0(IG,IB1)+UIMAG*C0(IG,IB2)
              PSIB(INZS(IG))=DCONJG(C0(IG,IB1))+
     *                          UIMAG*DCONJG(C0(IG,IB2))
            ENDDO
            IF(GEQ0) PSIB(NZFS(1))=C0(1,IB1)+UIMAG*C0(1,IB2)
          ENDIF
C         Transform the wavefunction to real space
          CALL INVFFTN(PSIB,.TRUE.)
C
          CALL HFXRPAV(PFL,PSIA,PSIB,1,VPOTG,VPOTR,PSIC,C2(1,IB1))
C
          IF(IB2.NE.0) THEN
            CALL HFXRPAV(PFL,PSIA,PSIB,2,VPOTG,VPOTR,PSIC,C2(1,IB2))
          ENDIF
        ENDDO
      ENDDO 
      CALL FREEM(IP_PSIB)
      CALL FREEM(IP_PSIC)
      CALL FREEM(IP_VPOTG)
      CALL FREEM(IP_VPOTR)
      CALL TIHALT('    HFXRPA',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HFXRPAV(PF,PSIA,PSIB,IRAN,VPOTG,VPOTR,PSIC,C2A)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'func.inc'
C     Arguments
      REAL*8     PF
      COMPLEX*16 C2A(JGW)
      COMPLEX*16 PSIA(LLR1),PSIB(LLR1),PSIC(LLR1),VPOTG(JHG)
      REAL*8     VPOTR(LLR1)
      INTEGER    IRAN
C     Variables
      INTEGER    IR,IG
      COMPLEX*16 FP,FM
C     ==--------------------------------------------------------------==
      IF(IRAN.EQ.1) THEN
        DO IR=1,LLR1
          PSIC(IR)=DIMAG(PSIA(IR))*DREAL(PSIB(IR))
        ENDDO
      ELSE
        DO IR=1,LLR1
          PSIC(IR)=DIMAG(PSIA(IR))*DIMAG(PSIB(IR))
        ENDDO
      ENDIF
      CALL DSCAL(2*LLR1,1.D0/OMEGA,PSIC,1)
      CALL FWFFTN(PSIC,.FALSE.)
      IF(MSELF.NE.0) THEN
        DO IG=1,JHG
          VPOTG(IG)=-PF*SCG(IG)*PSIC(NZFF(IG))
        ENDDO
      ELSE
        DO IG=1,JHG
          VPOTG(IG)=-PF*SCGX(IG)*PSIC(NZFF(IG))
        ENDDO
      ENDIF
      CALL ZAZZERO(PSIC,MAXFFTN)
      DO IG=1,JHG
        PSIC(NZFF(IG))=VPOTG(IG)
        PSIC(INZF(IG))=DCONJG(VPOTG(IG))
      ENDDO
      IF(GEQ0) PSIC(NZFF(1))=VPOTG(1)
      CALL INVFFTN(PSIC,.FALSE.)
      DO IR=1,LLR1
        VPOTR(IR)=DREAL(PSIC(IR))
      ENDDO
      DO IR=1,LLR1
        PSIC(IR)=VPOTR(IR)*DREAL(PSIA(IR))
      ENDDO
      CALL FWFFTN(PSIC,.TRUE.)
      DO IG=1,JGW
        FP=PSIC(NZFS(IG))+PSIC(INZS(IG))
        FM=PSIC(NZFS(IG))-PSIC(INZS(IG))
        C2A(IG)=C2A(IG)-0.5D0*DCMPLX(DREAL(FP),DIMAG(FM))
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
