C     ==================================================================
      SUBROUTINE HIP(V,QPHI)
C     ==--------------------------------------------------------------==
C     == USED IN VOFRHOA IF TCLUST=.TRUE.                             ==
C     == HOCKNEY INTERACTION POTENTIAL                                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cppt.inc'        !HGPOT NR1H NR2H NR3H
C     Arguments
#ifdef PARALLEL
      COMPLEX*16 V(KR1,KR2S,*),QPHI(*)
C     Variables
      INTEGER    BLKLEN
      DIMENSION  XF(NR1M*NR2S*NR3M,*),YF(NR1M*NR2S*NR3M,*)
      REAL*8     SCALE,DVOL
      INTEGER    ISUB,IZ,IX,IY,ISIGN,I,IXYZ,IQPH,
     &           IZP,KX,KY,KZ,NR1HH,NR2HH,NR3HH
      INTEGER    nx,nxy ! cmb
#else
      COMPLEX*16 V(KR1,KR2S,*),QPHI(*)
C     Variables
      REAL*8     SCALE,DVOL
      INTEGER    ISUB,IX,KX,KY,IY,KZ,IZ,IXY,ISIGN,NR1HH,NR2HH,NR3HH
#endif
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      COMPLEX*16 VA(KR1,KR2S,*),QPHIA(*)
      POINTER(IP_VA,VA),(IP_QPHIA,QPHIA)
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('       HIP',ISUB)
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      CALL MEMORY(IP_VA,2*KR1*KR2S*NR3H,'VA')
      CALL MEMORY(IP_QPHIA,2*(NR1H+1)*NR2H*NR3PL,'QPHIA')
#endif
      NR1HH=NR1H/2
      NR2HH=NR2H/2
      NR3HH=NR3H/2
      DVOL = DBLE((NR1H/NR1S) * (NR2H/NR2S) * (NR3H/NR3S)) * OMEGA
#ifdef _BGL
      CALL AZZERO(V(1,1,NR3S+1),2*NNR1)
      CALL AZZERO(V,2*KR1*KR2S)
#else
      CALL ZAZZERO(V(1,1,NR3S+1),NNR1)
      CALL ZAZZERO(V,KR1*KR2S)
#endif
      IF(TTWOD) THEN
      ELSEIF(TONED) THEN
C$OMP parallel do private(IZ,IX) shared(V)
        DO IZ=1,NR3S
          DO IX=1,KR1
            V(IX,1,IZ)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ELSE
C$OMP parallel do private(IZ,IX,IY) shared(V)
        DO IZ=1,NR3S
          DO IX=1,KR1
            V(IX,1,IZ)=DCMPLX(0.0D0,0.0D0)
          ENDDO
#ifdef PARALLEL
          IF(NRXPL(MEPOS,1).EQ.1) THEN
            DO IY=1,KR2S
              V(1,IY,IZ)=DCMPLX(0.0D0,0.0D0)
            ENDDO
          ENDIF
#else
          DO IY=1,KR2S
            V(1,IY,IZ)=DCMPLX(0.0D0,0.0D0)
          ENDDO
#endif
        ENDDO
      ENDIF
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      CALL DCOPY(2*KR1*KR2S*NR3H,V(1,1,1),1,VA(1,1,1),1)
#endif
C     ==--------------------------------------------------------------==
C     ==  SOLVE THE POISSON EQUATION                                  ==
C     ==--------------------------------------------------------------==
C     FFT ALONG Z
      ISIGN=1
      SCALE=1.D0/DBLE(NR1H*NR2H*NR3H)
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      CALL MLTFFT('T','T',VA,KR1*KR2S,NR3H,V,KR1*KR2S,NR3H,
     *            NR3H,KR1*KR2S,ISIGN,SCALE)
#else
      CALL MLTFFT('T','T',V,KR1*KR2S,NR3H,V,KR1*KR2S,NR3H,
     *            NR3H,KR1*KR2S,ISIGN,SCALE)
#endif
#ifdef PARALLEL
C     Pack data for transpose
#ifdef _BGL
      CALL AZZERO(QPHI,2*(NR1H+1)*NR2H*NR3PL)
#else
      CALL ZAZZERO(QPHI,(NR1H+1)*NR2H*NR3PL)
#endif
      NX=NR1
      NXY=NX*NR2S 
!$OMP parallel do private(I,IZ,IY,IX,IXYZ)
      DO I=0,NPROC-1
#ifdef _vpp_
!OCL NOALIAS
#endif
        DO IZ=NRZPL(I,1),NRZPL(I,2)
          DO IY=1,NR2S
            DO IX=1,NR1
              IXYZ=IX+(IY-1)*NX+(IZ-NRZPL(I,1))*NXY
              XF(IXYZ,I+1)=V(IX,IY,IZ)
            ENDDO
          ENDDO
        ENDDO
      ENDDO
C     All to all communication
      BLKLEN=16*NR1M*NR2S*NR3M
      CALL MY_TRANS(XF,YF,BLKLEN,1)
C     Unpack data
!$OMP parallel do private(I,IZ,IY,IX,IXYZ,IQPH,nx,nxy)
      DO I=0,NPROC-1
        NX=1+NRXPL(I,2)-NRXPL(I,1)
        NXY=NX*NR2S
        DO IZ=1,NR3PL
          DO IY=1,NR2S
            DO IX=NRXPL(I,1),NRXPL(I,2)
              IXYZ=1+IX-NRXPL(I,1)+(IY-1)*NX+(IZ-1)*NXY
              IQPH=IX+(IY-1)*(NR1H+1)+(IZ-1)*(NR1H+1)*NR2H
              QPHI(IQPH)=YF(IXYZ,I+1)
            ENDDO
          ENDDO
        ENDDO
      ENDDO
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      CALL DCOPY(2*(NR1H+1)*NR2H*NR3PL,QPHI(1),1,QPHIA(1),1)
#endif
      DO IZ=1,NR3PL
        IZP=(IZ-1)*(NR1H+1)*NR2H + 1
C       FFT ALONG Y
        ISIGN=1
        SCALE=1.D0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL MLTFFT('T','T',QPHIA(IZP),NR1H+1,NR2H,QPHI(IZP),
     *              NR1H+1,NR2H,NR2H,NR1S,ISIGN,SCALE)
        CALL DCOPY(2*(NR1H+1)*NR2H,QPHI(IZP),1,QPHIA(IZP),1)
#else
        CALL MLTFFT('T','T',QPHI(IZP),NR1H+1,NR2H,QPHI(IZP),
     *              NR1H+1,NR2H,NR2H,NR1S,ISIGN,SCALE)
#endif
C       FFT ALONG X
        ISIGN=1
        SCALE=1.D0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL MLTFFT('N','N',QPHIA(IZP),NR1H+1,NR2H,QPHI(IZP),
     *              NR1H+1,NR2H,NR1H,NR2H,ISIGN,SCALE)
#else
        CALL MLTFFT('N','N',QPHI(IZP),NR1H+1,NR2H,QPHI(IZP),
     *              NR1H+1,NR2H,NR1H,NR2H,ISIGN,SCALE)
#endif
C       MULTIPLY BY INFLUENCE FUNCTION
        KZ=IZ-1
        IF(KZ.GT.NR3HH) KZ=NR3H-KZ
!$OMP parallel do private(IY,KY,IX,IXYZ,KX)
        DO IY=1,NR2H
          KY=IY-1
          IF(KY.GT.NR2S) KY=NR2H-KY ! important: not NR2HH
          DO IX=1,NR1H
            IXYZ=IZP+(IY-1)*(NR1H+1)+IX-1
            KX=IX-1
            IF(KX.GT.NR1S) KX=NR1H-KX ! important: not NR1HH
            QPHI(IXYZ)=QPHI(IXYZ)*HGPOT(KX+1,KY+1,KZ+1)*DVOL
          ENDDO
        ENDDO
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL DCOPY(2*(NR1H+1)*NR2H,QPHI(IZP),1,QPHIA(IZP),1)
#endif
C       INVFFT ALONG X
        ISIGN=-1
        SCALE=1.D0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL MLTFFT('N','N',QPHIA(IZP),NR1H+1,NR2H,QPHI(IZP),
     *              NR1H+1,NR2H,NR1H,NR2H,ISIGN,SCALE)
#else
        CALL MLTFFT('N','N',QPHI(IZP),NR1H+1,NR2H,QPHI(IZP),
     *              NR1H+1,NR2H,NR1H,NR2H,ISIGN,SCALE)
#endif
C       INVFFT ALONG Y
        ISIGN=-1
        SCALE=1.D0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL MLTFFT('T','T',QPHI(IZP),NR1H+1,NR2H,QPHIA(IZP),
     *              NR1H+1,NR2H,NR2H,NR1S,ISIGN,SCALE)
#else
        CALL MLTFFT('T','T',QPHI(IZP),NR1H+1,NR2H,QPHI(IZP),
     *              NR1H+1,NR2H,NR2H,NR1S,ISIGN,SCALE)
#endif
      ENDDO
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      CALL DCOPY(2*(NR1H+1)*NR2H*NR3PL,QPHIA(1),1,QPHI(1),1)
#endif
C     Pack data for transpose
!$OMP parallel do private(I,IZ,IY,IX,IXYZ,IQPH,NX,NXY)
      DO I=0,NPROC-1
        NX=1+NRXPL(I,2)-NRXPL(I,1)
        NXY=NX*NR2S
#ifdef _vpp_
!OCL NOALIAS
#endif
        DO IZ=1,NR3PL
          DO IY=1,NR2S
            DO IX=NRXPL(I,1),NRXPL(I,2)
              IXYZ=1+IX-NRXPL(I,1)+(IY-1)*NX+(IZ-1)*NXY
              IQPH=IX+(IY-1)*(NR1H+1)+(IZ-1)*(NR1H+1)*NR2H
              YF(IXYZ,I+1)=QPHI(IQPH)
            ENDDO
          ENDDO
        ENDDO
      ENDDO
C     All to all communication
      BLKLEN=16*NR1M*NR2S*NR3M
      CALL MY_TRANS(YF,XF,BLKLEN,1)
C     Unpack data
#ifdef _BGL
      CALL AZZERO(V,2*KR1*KR2S*NR3H)
#else
      CALL ZAZZERO(V,KR1*KR2S*NR3H)
#endif
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      CALL AZZERO(VA,2*KR1*KR2S*NR3H)
#endif
      nx=nr1
      nxy=nx*nr2s
!$OMP parallel do private(I,IZ,IY,IX,IXYZ)
      DO I=0,NPROC-1
        DO IZ=NRZPL(I,1),NRZPL(I,2)
          DO IY=1,NR2S
            DO IX=1,NR1
              IXYZ=IX+(IY-1)*NX+(IZ-NRZPL(I,1))*NXY
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
              VA(IX,IY,IZ)=XF(IXYZ,I+1)
#else
              V(IX,IY,IZ)=XF(IXYZ,I+1)
#endif
            ENDDO
          ENDDO
        ENDDO
      ENDDO
#else
      DO IZ=1,NR3H
C       COPY THE IZ PLANE TO QPHI
#ifdef _BGL
        CALL AZZERO(QPHI,2*(NR1H+1)*NR2H)
#else
        CALL ZAZZERO(QPHI,(NR1H+1)*NR2H)
#endif
C$OMP parallel do private(IY,IX,IXY)
        DO IY=1,NR2S
          DO IX=1,NR1S
            IXY=IX+(IY-1)*(NR1H+1)
            QPHI(IXY)=V(IX,IY,IZ)
          ENDDO
        ENDDO
C       FFT ALONG Y
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL DCOPY(2*(NR1H+1)*NR2H,QPHI(1),1,QPHIA(1),1)
#endif
        ISIGN=1
        SCALE=1.D0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL MLTFFT('T','T',QPHIA,NR1H+1,NR2H,QPHI,NR1H+1,NR2H,NR2H,
     *              NR1S,ISIGN,SCALE)
        CALL DCOPY(2*(NR1H+1)*NR2H,QPHI(1),1,QPHIA(1),1)
#else
        CALL MLTFFT('T','T',QPHI,NR1H+1,NR2H,QPHI,NR1H+1,NR2H,NR2H,
     *              NR1S,ISIGN,SCALE)
#endif
C       FFT ALONG X
        ISIGN=1
        SCALE=1.D0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL MLTFFT('N','N',QPHIA,NR1H+1,NR2H,QPHI,NR1H+1,NR2H,
     *              NR1H,NR2H,ISIGN,SCALE)
#else
        CALL MLTFFT('N','N',QPHI,NR1H+1,NR2H,QPHI,NR1H+1,NR2H,
     *              NR1H,NR2H,ISIGN,SCALE)
#endif
C       MULTIPLY BY INFLUENCE FUNCTION
        KZ=IZ-1
        IF(KZ.GT.NR3HH) KZ=NR3H-KZ
C$OMP parallel do private(IY,IX,IXY,KY,KX)
        DO IY=1,NR2H
          KY=IY-1
          IF(KY.GT.NR2S) KY=NR2H-KY ! important: not NR2HH
          DO IX=1,NR1H
            IXY=IX+(IY-1)*(NR1H+1)
            KX=IX-1
            IF(KX.GT.NR1S) KX=NR1H-KX ! important: not NR1HH
            QPHI(IXY)=QPHI(IXY)*HGPOT(KX+1,KY+1,KZ+1)*DVOL
          ENDDO
        ENDDO
C       INVFFT ALONG X
        ISIGN=-1
        SCALE=1.D0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL MLTFFT('N','N',QPHI,NR1H+1,NR2H,QPHIA,NR1H+1,NR2H,
     *              NR1H,NR2H,ISIGN,SCALE)
        CALL DCOPY(2*(NR1H+1)*NR2H,QPHIA(1),1,QPHI(1),1)
#else
        CALL MLTFFT('N','N',QPHI,NR1H+1,NR2H,QPHI,NR1H+1,NR2H,
     *              NR1H,NR2H,ISIGN,SCALE)
#endif
C       INVFFT ALONG Y
        ISIGN=-1
        SCALE=1.D0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
        CALL MLTFFT('T','T',QPHI,NR1H+1,NR2H,QPHIA,NR1H+1,NR2H,
     *              NR2H,NR1S,ISIGN,SCALE)
        CALL DCOPY(2*(NR1H+1)*NR2H,QPHIA(1),1,QPHI(1),1)
#else
        CALL MLTFFT('T','T',QPHI,NR1H+1,NR2H,QPHI,NR1H+1,NR2H,
     *              NR2H,NR1S,ISIGN,SCALE)
#endif
C       COPY THE IZ PLANE BACK TO V
C$OMP parallel do private(IY,IX,IXY)
        DO IY=1,NR2S
          DO IX=1,NR1S
            IXY=IX+(IY-1)*(NR1H+1)
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
            VA(IX,IY,IZ)=QPHI(IXY)
#else
            V(IX,IY,IZ)=QPHI(IXY)
#endif
          ENDDO
        ENDDO
      ENDDO
#endif
C     INVFFT ALONG Z
      ISIGN=-1
      SCALE=1.D0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      CALL MLTFFT('T','T',VA,KR1*KR2S,NR3H,V,KR1*KR2S,NR3H,NR3H,
     *          KR1*KR2S,ISIGN,SCALE)
      CALL FREEM(IP_VA)
      CALL FREEM(IP_QPHIA)
#else
      CALL MLTFFT('T','T',V,KR1*KR2S,NR3H,V,KR1*KR2S,NR3H,NR3H,KR1*KR2S,
     *          ISIGN,SCALE)
#endif
      CALL TIHALT('       HIP',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_QPHI(IL_QPHI)
C     ==--------------------------------------------------------------==
C     == GIVE THE SIZE OF QPHI                                        ==
C     == ARRAY used in HIP                                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NR1S NRZPL KR2S
      INCLUDE 'isos.inc'        !TCLUST PS_TYPE
      INCLUDE 'cppt.inc'        !NR3PL
C     Arguments
      INTEGER IL_QPHI
C     Variables
C     ==--------------------------------------------------------------==
      IF(TCLUST) THEN
        IF(PS_TYPE.EQ.1) THEN
#ifdef PARALLEL
          IL_QPHI   = 2*(2*NR1S+1)*2*KR2S*NR3PL
#else
          IL_QPHI   = 2*(2*NR1S+1)*2*KR2S
#endif
        ELSEIF(PS_TYPE.EQ.2) THEN
          IL_QPHI   = 2
        ELSEIF(PS_TYPE.EQ.3) THEN
          IL_QPHI   = 2
        ENDIF
      ELSE
        IL_QPHI = 0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
