C     ==================================================================
      SUBROUTINE HIPIN
C     ==--------------------------------------------------------------==
C     == HOCKNEY INTERACTION POTENTIAL: INITIALIZATION                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'isos.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
      REAL*8    SCR(*)
      POINTER   (IP_SCR,SCR)
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3)
      INTEGER   IHIP1,IHIP2,IHIP3,IHIP4,IHIP5,IHIP6,IHIPTOP
      INTEGER   IHIP7,IHIP8
#else
      INTEGER   IHIP1,IHIP2,IHIP3,IHIP4,IHIP5,IHIP6,IHIPTOP
#endif
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      NR3PL=NRZPL(MEPOS,2)-NRZPL(MEPOS,1)+1
C     IF(PARENT) NR3MX=NR3M+1
#else
      NR3PL=NR3S+1
#endif
      CALL MEMORY(IP_HGPOT,(NR1S+1)*(NR2S+1)*NR3PL,'HGPOT')
      CALL MEMORY(IP_HIPZ,NHG,'HIPZ')
C     Definition of NR1H, NR2H, NR3H (cppt.inc)
      NR1H = 2*NR1S
      NR2H = 2*NR2S
      NR3H = 2*NR3S
!!!   IF(TONED.OR.TTWOD) NR1H=NR1S
!!!   IF(TTWOD)          NR2H=NR2S
      IF(TONED) NR1H=NR1S
      IF(TTWOD) THEN
        IF(SNORMAL.EQ.1) THEN
          NR2H=NR2S
          NR3H=NR3S
        ELSE IF(SNORMAL.EQ.2) THEN
          NR1H=NR1S
          NR3H=NR3S
        ELSE IF(SNORMAL.EQ.3) THEN
          NR1H=NR1S
          NR2H=NR2S
        ENDIF
      ENDIF
C     ==------------------------------------------------------------==
C     == SCRATCH SPACE                                              ==
C     ==------------------------------------------------------------==
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3) 
      IHIP1 = 1
      IHIP2 = IHIP1 + NR1H+(MOD(NR1H,2))
      IHIP3 = IHIP2 + NR2H+(MOD(NR2H,2))
      IHIP4 = IHIP3 + NR3H+(MOD(NR3H,2))
      IHIP5 = IHIP4 + 2 * NR2H*NR3H
      IHIP6 = IHIP5 + 2 * NR1H*(NR2S+1)*NR3PL
      IHIP7 = IHIP6 + 2 * NR2H*NR3H
      IHIP8 = IHIP7 + 2 * NR1H*(NR2S+1)*NR3PL
      IHIPTOP = IHIP8
#else
      IHIP1 = 1
      IHIP2 = IHIP1 + NR1H
      IHIP3 = IHIP2 + NR2H
      IHIP4 = IHIP3 + NR3H
      IHIP5 = IHIP4 + 2 * NR2H*NR3H
      IHIP6 = IHIP5 + 2 * NR1H*(NR2S+1)*NR3PL
      IHIPTOP = IHIP6
#endif
      CALL MEMORY(IP_SCR,IHIPTOP,'SCR')
C     ==------------------------------------------------------------==
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3) 
      CALL HOCKNEY(SCR(IHIP1),SCR(IHIP2),SCR(IHIP3),
     *             SCR(IHIP4),SCR(IHIP5),SCR(IHIP6),SCR(IHIP7))
#else
      CALL HOCKNEY(SCR(IHIP1),SCR(IHIP2),SCR(IHIP3),
     *             SCR(IHIP4),SCR(IHIP5))
#endif
      CALL FREEM(IP_SCR)
      CALL ZHIP
      IF(PARENT) CALL PRMEM('   CLUSTER')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3) 
      SUBROUTINE HOCKNEY(R1,R2,R3,POTYZ,POTX,POTYZA,POTXA)
#else
      SUBROUTINE HOCKNEY(R1,R2,R3,POTYZ,POTX)
#endif
C     ==--------------------------------------------------------------==
C     ==  COMPUTES THE HOCKNEY INTERACTION POTENTIAL                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc'
      include 'gvec.inc' ! remove
C     Arguments
      REAL*8     R1(*),R2(*),R3(*)
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3) 
      COMPLEX*16 POTYZ(NR2H*NR3H),POTX(2 * NR1H*(NR2S+1)*NR3PL)
      COMPLEX*16 POTYZA(NR2H*NR3H),POTXA(2 * NR1H*(NR2S+1)*NR3PL)
#else
      COMPLEX*16 POTYZ(*),POTX(*)
#endif
C     Variables
      LOGICAL    TREALSP
      REAL*8     DR1,DR2,DR3,U0,RPOX,SPOT,SCALE,
     &           DX,DY,DZ
      REAL*8     G2,GXY2,GZ2,GXY,GZ,Z,DVOL,POTG,FR,FG
      INTEGER    ISUB,K,I,NR3IN,IX,IY,IZ,IYZ,KX,KY,KZ,
     &           IZ0,NNN,IXYZ,NR1HH,NR2HH,NR3HH
#ifdef __DERF
      REAL*8   DERF
      EXTERNAL DERF
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   HOCKNEY',ISUB)
      NR1HH=NR1H/2
      NR2HH=NR2H/2
      NR3HH=NR3H/2
      DVOL = DBLE((NR1H/NR1S) * (NR2H/NR2S) * (NR3H/NR3S)) * OMEGA
      TREALSP = (.NOT.(TTWOD.OR.TONED))
      DR1 = 1.0D0/DBLE(NR1S)
      DR2 = 1.0D0/DBLE(NR2S)
      DR3 = 1.0D0/DBLE(NR3S)
      U0 = 2.0D0 / (DSQRT(PI)*RCERF)
      DO I=1,NR1H
        K=I-1
        IF(K.GT.NR1HH) K=NR1H-K
        R1(I)=DR1*DBLE(K)
      ENDDO     
      DO I=1,NR2H
        K=I-1
        IF(K.GT.NR2HH) K=NR2H-K
        R2(I)=DR2*DBLE(K)
      ENDDO     
      DO I=1,NR3H
        K=I-1
        IF(K.GT.NR3HH) K=NR3H-K
        R3(I)=DR3*DBLE(K)
      ENDDO     
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      NR3IN=NRZPL(MEPOS,1)
#else
      NR3IN=1
#endif
      IF(TREALSP) THEN
        DO IX=1,NR1H
!$OMP parallel do private(IZ,IY,IYZ,DX,DY,DZ,RPOX,SPOT)
          DO IZ=1,NR3H
            DO IY=1,NR2H
              IYZ=IY+(IZ-1)*NR2H
              DX=A1(1)*R1(IX)+A2(1)*R2(IY)+A3(1)*R3(IZ)
              DY=A1(2)*R1(IX)+A2(2)*R2(IY)+A3(2)*R3(IZ)
              DZ=A1(3)*R1(IX)+A2(3)*R2(IY)+A3(3)*R3(IZ)
              RPOX=DSQRT(DX*DX+DY*DY+DZ*DZ) ! focus on small G vectors
              SPOT=DERF(RPOX/RCERF)
              IF(RPOX.GT.1.D-20) POTYZ(IYZ)=DCMPLX(SPOT/RPOX,0.0D0)
            ENDDO
          ENDDO
!$OMP end parallel do
          IF(IX.EQ.1) POTYZ(1)=U0
#if defined(FFT_FFTW) || defined(FFT_FFTW2) || defined(FFT_FFTW3) 
          CALL DCOPY(2*NR2H*NR3H,POTYZ(1),1,POTYZA(1),1)
          SCALE=1.0D0
          CALL MLTFFT('T','T',POTYZA,NR2H,NR3H,POTYZ,
     *                NR2H,NR3H,NR3H,NR2H,1,SCALE)
          IYZ=1+(NR3IN-1)*NR2H
          CALL DCOPY(2*NR2H*NR3PL,POTYZ(IYZ),1,POTYZA(IYZ),1)
          CALL MLTFFT('N','N',POTYZA(IYZ),NR2H,NR3PL,POTYZ(IYZ),
     *                NR2H,NR3PL,NR2H,NR3PL,1,SCALE)
!$OMP parallel do private(IZ,IZ0,IY,IXYZ,IYZ) default(shared)
          DO IZ=1,NR3PL
            IZ0=NR3IN-1+IZ
            DO IY=1,NR2S+1
              IXYZ=IX+(IY-1)*NR1H+(IZ-1)*NR1H*(NR2S+1)
              IYZ=IY+(IZ0-1)*NR2H
              POTX(IXYZ)=POTYZ(IYZ)
            ENDDO
          ENDDO
!$OMP end parallel do
        ENDDO
        SCALE=1.0D0/DBLE(NR1H*NR2H*NR3H)
        NNN=(NR2S+1)*NR3PL
        CALL DCOPY(2*NNN*NR1H,POTX(1),1,POTXA(1),1)
        CALL MLTFFT('N','N',POTXA,NR1H,NNN,POTX,NR1H,NNN,
     $              NR1H,NNN,1,SCALE)
      ENDIF
#else
          SCALE=1.0D0
          CALL MLTFFT('T','T',POTYZ,NR2H,NR3H,POTYZ,
     *                NR2H,NR3H,NR3H,NR2H,1,SCALE)
          IYZ=1+(NR3IN-1)*NR2H
          CALL MLTFFT('N','N',POTYZ(IYZ),NR2H,NR3PL,POTYZ(IYZ),
     *                NR2H,NR3PL,NR2H,NR3PL,1,SCALE)
!$OMP parallel do private(IZ,IZ0,IY,IXYZ,IYZ) default(shared)
          DO IZ=1,NR3PL
            IZ0=NR3IN-1+IZ
            DO IY=1,NR2S+1
              IXYZ=IX+(IY-1)*NR1H+(IZ-1)*NR1H*(NR2S+1)
              IYZ=IY+(IZ0-1)*NR2H
              POTX(IXYZ)=POTYZ(IYZ)
            ENDDO
          ENDDO
!$OMP end parallel do
        ENDDO
        SCALE=1.0D0/DBLE(NR1H*NR2H*NR3H)
        NNN=(NR2S+1)*NR3PL
        CALL MLTFFT('N','N',POTX,NR1H,NNN,POTX,NR1H,NNN,
     $              NR1H,NNN,1,SCALE)
      ENDIF
#endif
      DO IZ=1,NR3PL
        KZ = IZ-1 + NR3IN-1
        IF(KZ.GT.NR3HH) KZ=KZ-NR3H
        DO IY=1,NR2S+1
          KY = IY-1
          IF(KY.GT.NR2HH) KY=KY-NR2H
          DO IX=1,NR1S+1
            KX = IX-1
            IF(KX.GT.NR1HH) KX=KX-NR1H
            IXYZ=IX+(IY-1)*NR1H+(IZ-1)*NR1H*(NR2S+1)
            IF(TREALSP) THEN
              HGPOT(IX,IY,IZ)=DREAL(POTX(IXYZ))
            ELSE
              GXY2 = ((B1(1)*KX+B2(1)*KY)**2+
     $                (B2(2)*KY+B1(2)*KX)**2)*TPIBA2
              GZ = TPIBA*B3(3)*KZ*NR3S/NR3H
              GZ2 = GZ**2
              G2 = GXY2 + GZ2
              GXY = DSQRT(GXY2)
              Z = A3(3)*NR3H/NR3S
              IF(IX.NE.1.OR.IY.NE.1.OR.IZ.NE.1) THEN
                POTG = FPI/(G2*DVOL)*DEXP(-0.25D0*G2*RCERF*RCERF)
                IF(TTWOD) POTG = POTG *
     $               (1.0D0-DCOS(0.5D0*Z*GZ)*DEXP(-0.5D0*Z*GXY))
              ELSE
                G2 = 0.0D0
                POTG = 0.0D0
              END IF
              HGPOT(IX,IY,IZ)=POTG
            ENDIF
          ENDDO
        ENDDO
      ENDDO
      CALL TIHALT('   HOCKNEY',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ZHIP
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'isos.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'geq0.inc'
C     Variables
      REAL*8    G2,RC2
      INTEGER   IG,IG1
C     ==--------------------------------------------------------------==
      RC2=RCERF*RCERF
C     ==--------------------------------------------------------------==
      IG1=1
      IF(GEQ0) IG1=2
!$OMP parallel do private(IG,G2) shared(RC2)
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(10000))
!IBM* INDEPENDENT, NEW(G2) 
#endif
      DO IG=IG1,NHG
        G2=TPIBA2*HG(IG)
        HIPZ(IG)=FPI/G2*(1.d0-DEXP(-0.25D0*G2*RC2)) ! focus on large G v.
      ENDDO
!$OMP end parallel do
      IF(GEQ0) HIPZ(1)=PI*RC2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
