C     ==================================================================
      SUBROUTINE HNLMAT(HMAT,F,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'sgpp.inc'
C     Arguments
      INTEGER   NSTATE
      REAL*8    HMAT(NSTATE,NSTATE),F(NSTATE)
C     Variables
      REAL*8    FNL(NAT,NHXS,NSTATE),DFNL(*)
      REAL*8    FFI,DD,FDD
      INTEGER   ISUB,I,J,ISPIN,JMAX,IS,ISA0,IV,JV,IA,ISA,L,KI,LI,L2,LJ,
     &          KJ, MXRANK, MXMYPOS, IND, MYPOS, CHUNK, IND1 

C     ==--------------------------------------------------------------==
C     == Compute the non-local contribution to the Hamilton matrix    ==
C     ==--------------------------------------------------------------==
      CALL TISET('    HNLMAT',ISUB)
      IF(TFDIST) CALL STOPGM('HNLMAT','TFDIST NOT IMPLEMENTED')
      IF(IMAGP.EQ.2)CALL STOPGM('HNLMAT','K-POINT NOT IMPLEMENTED')
      DO I=1,NSTATE
        FFI=F(I)
        IF(FFI.LT.1.D-5) FFI=1.0D0
        DO J=1,NSTATE
          HMAT(I,J)=HMAT(I,J)/FFI
        ENDDO
      ENDDO

CAK   FIXME: 20080131 the HNLMAT() optimization does not work for LSD.
CAK   FIXME: we drop back to old algorithm.

      IF(TLSD) THEN
C     1 .. NSTATE for serial !
        DO I=NST12(MEPOS,1),NST12(MEPOS,2)
          ISPIN=1
          JMAX=NSTATE
          IF(TLSD.AND.I.LE.NSUP) JMAX=NSUP
          IF(TLSD.AND.I.GT.NSUP) ISPIN=2
          DO J=I,JMAX
            ISA0=0
            DO IS=1,NSP
              IF(TVAN(IS)) THEN
C     VANDERBILT PP
                DO IV=1,NGH(IS)
                  DO JV=1,NGH(IS)
                    DO IA=1,NA(IS)
                      ISA=ISA0+IA
                      DD=DEEQ(ISA,IV,JV,ISPIN)+DVAN(IV,JV,IS)
                      FDD=DD*FNL(ISA,IV,I)*FNL(ISA,JV,J)
                      HMAT(I,J)=HMAT(I,J)-FDD
                      IF(I.NE.J) HMAT(J,I)=HMAT(J,I)-FDD
                    ENDDO
                  ENDDO
                ENDDO
              ELSEIF(TSGP(IS)) THEN
C     Stefan Goedecker PP
                DO IV=1,NGH(IS)
                  L=NGHTOL(IV,IS)+1
                  KI=LFVAL(IV,IS)
                  LI=LPVAL(IV,IS)
                  DO JV=1,NGH(IS)
                    L2=NGHTOL(JV,IS)+1
                    LJ=LPVAL(JV,IS)
                    IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
                      KJ=LFVAL(JV,IS)
                      DO IA=1,NA(IS)
                        ISA=ISA0+IA
                        FDD=HLSG(KI,KJ,L,IS)*FNL(ISA,IV,I)*FNL(ISA,JV,J)
                        HMAT(I,J)=HMAT(I,J)-FDD
                        IF(I.NE.J) HMAT(J,I)=HMAT(J,I)-FDD
                      ENDDO
                    ENDIF
                  ENDDO
                ENDDO
              ELSE
C     BACHELET HAMANN SCHLUTER
                DO IV=1,NGH(IS)
                  DD=WSG(IS,IV)
                  DO IA=1,NA(IS)
                    ISA=ISA0+IA
                    FDD=DD*FNL(ISA,IV,I)*FNL(ISA,IV,J)
                    HMAT(I,J)=HMAT(I,J)-FDD
                    IF(I.NE.J) HMAT(J,I)=HMAT(J,I)-FDD
                  ENDDO
                ENDDO
C     ==-------------------------------------------------------==
              ENDIF
              ISA0=ISA0+NA(IS)
            ENDDO
          ENDDO
        ENDDO
      ELSE
        CHUNK = 0
        MXRANK = 0
        IF (NST12(MEPOS,1).LE.NST12(MEPOS,2)) THEN
          IND1 = 0
          DO I=0, NPROC-1
            IF (NST12(I,1).LE.NST12(I,2)) THEN
              IND1 = IND1 + 1
              IF (I.GT.MXRANK) MXRANK=I 
              IF(MEPOS.EQ.I) MXMYPOS = IND1
            ENDIF
          ENDDO

          CHUNK = (NSTATE*(NSTATE+1)/2) / IND1
          IF(MEPOS.EQ.MXRANK) CHUNK=(NSTATE*(NSTATE+1)/2)-(IND1-1)*CHUNK
          IND = 1
          MYPOS = (MXMYPOS-1)*CHUNK+1
          IF(MEPOS.EQ.MXRANK) THEN
            MYPOS=(IND1-1)*((NSTATE*(NSTATE+1)/2)/IND1)+1
          ENDIF
          DO I=1, NSTATE
            DO J=I, NSTATE
              IF (IND.EQ.MYPOS) GOTO 999
              IND = IND +1
            ENDDO
          ENDDO
 999      CONTINUE
        ENDIF

C     1 .. NSTATE for serial !
        ISA0 = 0
        DO IND = 1, CHUNK  

          ISPIN=1
          JMAX=NSTATE
          IF(TLSD.AND.I.LE.NSUP) JMAX=NSUP
          IF(TLSD.AND.I.GT.NSUP) ISPIN=2
          DO IS=1,NSP
            IF(TVAN(IS)) THEN
C     VANDERBILT PP
              DO IV=1,NGH(IS)
                DO JV=1,NGH(IS)
                  DO IA=1,NA(IS)
                    ISA=ISA0+IA
                    DD=DEEQ(ISA,IV,JV,ISPIN)+DVAN(IV,JV,IS)
                    FDD=DD*FNL(ISA,IV,I)*FNL(ISA,JV,J)
                    HMAT(I,J)=HMAT(I,J)-FDD
                    IF(I.NE.J) HMAT(J,I)=HMAT(J,I)-FDD
                  ENDDO
                ENDDO
              ENDDO
            ELSEIF(TSGP(IS)) THEN
C     Stefan Goedecker PP
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    DO IA=1,NA(IS)
                      ISA=ISA0+IA
                      FDD=HLSG(KI,KJ,L,IS)*FNL(ISA,IV,I)*FNL(ISA,JV,J)
                      HMAT(I,J)=HMAT(I,J)-FDD
                      IF(I.NE.J) HMAT(J,I)=HMAT(J,I)-FDD
                    ENDDO
                  ENDIF
                ENDDO
              ENDDO
            ELSE
C     BACHELET HAMANN SCHLUTER
              DO IV=1,NGH(IS)
                DD=WSG(IS,IV)
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
                  FDD=DD*FNL(ISA,IV,I)*FNL(ISA,IV,J)
                  HMAT(I,J)=HMAT(I,J)-FDD
                  IF(I.NE.J) HMAT(J,I)=HMAT(J,I)-FDD
                ENDDO
              ENDDO
C     ==-------------------------------------------------------==
            ENDIF
            ISA0=ISA0+NA(IS)
          ENDDO
          J = J+1
          ISA0 = 0
          IF (J.GT.NSTATE) THEN
            J = I+1
            I = I+1
            ISA0 = 0
          ENDIF
        ENDDO
CAK: end of .NOT.TLSD branch. FIXME.
      ENDIF

      DO I=1,NSTATE
        FFI=F(I)
        IF(FFI.LT.1.D-5) FFI=1.0D0
        DO J=1,NSTATE
          HMAT(I,J)=HMAT(I,J)*FFI
        ENDDO
      ENDDO
      CALL TIHALT('    HNLMAT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
