C     ==================================================================
      SUBROUTINE HTRSTR(EHT,V,EIROP)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == HARTREE ENERGY CONTRIBUTION TO THE STRESS TENSOR             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'ragg.inc'
C     Arguments
      REAL*8     EHT
      COMPLEX*16 V(NNR1),EIROP(NHG)
C     Variables
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 RHET,RHOG,RHOGS,CFPIBG,
     *           RHOPR,EI123,CHGM1
      REAL*8     FNL(*),DFNL(*)
      REAL*8     R2,ER,EI,ER2,FPIBG
      INTEGER    ISUB,IG1,IG,ISA,IA,KK,IS
#ifdef __VECTOR 
      COMPLEX*16 T1,T2,T3,T4,T5,T6,FAC1,FAC2
#endif 
C     ==--------------------------------------------------------------==
      CALL TISET('    HTRSTR',ISUB)
      IF(GEQ0) THEN
        IG1=2
      ELSE
        IG1=1
      ENDIF
#if defined(__VECTOR) && !(__SR8000)
      T1=(0.0D0,0.0D0)
      T2=(0.0D0,0.0D0)
      T3=(0.0D0,0.0D0)
      T4=(0.0D0,0.0D0)
      T5=(0.0D0,0.0D0)
      T6=(0.0D0,0.0D0)
      IF(BIGMEM) THEN
        IF(TIVAN) THEN 
!$OMP parallel do private(IG,ISA,IA,IS,R2,RHOPR,
!$OMP+ RHET,RHOG,RHOGS,FPIBG,CFPIBG,CHGM1,FAC1,FAC2)
!$OMP+ reduction(+:T1,T2,T3,T4,T5,T6)
          DO IG=IG1,NHG
            RHOPR=(0.0D0,0.0D0)
            DO ISA=1,NAT 
              IA=IATPT(1,ISA)
              IS=IATPT(2,ISA)
              R2=RAGGIO(IS)*RAGGIO(IS)
              RHOPR=RHOPR+RHOPS(IS,IG)*R2*0.5D0*EIGRB(IG,ISA)
            ENDDO
            RHET=V(NZH(IG))
            RHOG=RHET+EIROP(IG)
            RHOGS=DCONJG(RHOG)
            FPIBG=FPI/TPIBA2/HG(IG)
            CFPIBG=DCMPLX(FPIBG,0.D0)
            CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
            FAC1=CFPIBG*RHOGS
            FAC2=FAC1*(RHOG*CHGM1+RHOPR)
            T1=T1+(FAC2*GAGK(IG,1)+FAC1*DRHOVG(IG,1))
            T2=T2+(FAC2*GAGK(IG,2)+FAC1*DRHOVG(IG,2))
            T3=T3+(FAC2*GAGK(IG,3)+FAC1*DRHOVG(IG,3))
            T4=T4+(FAC2*GAGK(IG,4)+FAC1*DRHOVG(IG,4))
            T5=T5+(FAC2*GAGK(IG,5)+FAC1*DRHOVG(IG,5))
            T6=T6+(FAC2*GAGK(IG,6)+FAC1*DRHOVG(IG,6))
          ENDDO
          DEHC(1)=DEHC(1)+T1
          DEHC(2)=DEHC(2)+T2
          DEHC(3)=DEHC(3)+T3
          DEHC(4)=DEHC(4)+T4
          DEHC(5)=DEHC(5)+T5
          DEHC(6)=DEHC(6)+T6
        ELSE 
!$OMP parallel do private(IG,ISA,IA,IS,R2,RHOPR,
!$OMP+ RHET,RHOG,RHOGS,FPIBG,CFPIBG,CHGM1,FAC2)
!$OMP+ reduction(+:T1,T2,T3,T4,T5,T6)
          DO IG=IG1,NHG
            RHOPR=(0.0D0,0.0D0)
            DO ISA=1,NAT 
              IA=IATPT(1,ISA)
              IS=IATPT(2,ISA)
              R2=RAGGIO(IS)*RAGGIO(IS)
              RHOPR=RHOPR+RHOPS(IS,IG)*R2*0.5D0*EIGRB(IG,ISA)
            ENDDO
            RHET=V(NZH(IG))
            RHOG=RHET+EIROP(IG)
            RHOGS=DCONJG(RHOG)
            FPIBG=FPI/TPIBA2/HG(IG)
            CFPIBG=DCMPLX(FPIBG,0.D0)
            CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
            FAC2=CFPIBG*RHOGS*(RHOG*CHGM1+RHOPR)
            T1=T1+FAC2*GAGK(IG,1)
            T2=T2+FAC2*GAGK(IG,2)
            T3=T3+FAC2*GAGK(IG,3)
            T4=T4+FAC2*GAGK(IG,4)
            T5=T5+FAC2*GAGK(IG,5)
            T6=T6+FAC2*GAGK(IG,6)
          ENDDO
          DEHC(1)=DEHC(1)+T1
          DEHC(2)=DEHC(2)+T2
          DEHC(3)=DEHC(3)+T3
          DEHC(4)=DEHC(4)+T4
          DEHC(5)=DEHC(5)+T5
          DEHC(6)=DEHC(6)+T6
        ENDIF 
      ELSE 
        IF(TIVAN) THEN 
!$OMP parallel do private(IG,ISA,IA,IS,R2,EI123,ER,EI,ER2,RHOPR,
!$OMP+ RHET,RHOG,RHOGS,FPIBG,CFPIBG,CHGM1,FAC1,FAC2)
!$OMP+ reduction(+:T1,T2,T3,T4,T5,T6)
          DO IG=IG1,NHG
            RHOPR=(0.0D0,0.0D0)
            DO ISA=1,NAT
              IA=IATPT(1,ISA)
              IS=IATPT(2,ISA)
              R2=RAGGIO(IS)*RAGGIO(IS)
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *              EI3(ISA,INYH(3,IG))
              ER=DREAL(EI123)
              EI=DIMAG(EI123)
              ER2=0.5D0*R2*RHOPS(IS,IG)
              RHOPR=RHOPR+DCMPLX(ER*ER2,EI*ER2)
            ENDDO
            RHET=V(NZH(IG))
            RHOG=RHET+EIROP(IG)
            RHOGS=DCONJG(RHOG)
            FPIBG=FPI/TPIBA2/HG(IG)
            CFPIBG=DCMPLX(FPIBG,0.D0)
            CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
            FAC1=CFPIBG*RHOGS
            FAC2=FAC1*(RHOG*CHGM1+RHOPR)
            T1=T1+(FAC2*GAGK(IG,1)+FAC1*DRHOVG(IG,1))
            T2=T2+(FAC2*GAGK(IG,2)+FAC1*DRHOVG(IG,2))
            T3=T3+(FAC2*GAGK(IG,3)+FAC1*DRHOVG(IG,3))
            T4=T4+(FAC2*GAGK(IG,4)+FAC1*DRHOVG(IG,4))
            T5=T5+(FAC2*GAGK(IG,5)+FAC1*DRHOVG(IG,5))
            T6=T6+(FAC2*GAGK(IG,6)+FAC1*DRHOVG(IG,6))
          ENDDO
          DEHC(1)=DEHC(1)+T1
          DEHC(2)=DEHC(2)+T2
          DEHC(3)=DEHC(3)+T3
          DEHC(4)=DEHC(4)+T4
          DEHC(5)=DEHC(5)+T5
          DEHC(6)=DEHC(6)+T6
        ELSE 
!$OMP parallel do private(IG,ISA,IA,IS,R2,EI123,ER,EI,ER2,RHOPR,
!$OMP+ RHET,RHOG,RHOGS,FPIBG,CFPIBG,CHGM1,FAC2)
!$OMP+ reduction(+:T1,T2,T3,T4,T5,T6)
          DO IG=IG1,NHG
            RHOPR=(0.0D0,0.0D0)
            DO ISA=1,NAT
              IA=IATPT(1,ISA)
              IS=IATPT(2,ISA)
              R2=RAGGIO(IS)*RAGGIO(IS)
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *              EI3(ISA,INYH(3,IG))
              ER=DREAL(EI123)
              EI=DIMAG(EI123)
              ER2=0.5D0*R2*RHOPS(IS,IG)
              RHOPR=RHOPR+DCMPLX(ER*ER2,EI*ER2)
            ENDDO
            RHET=V(NZH(IG))
            RHOG=RHET+EIROP(IG)
            RHOGS=DCONJG(RHOG)
            FPIBG=FPI/TPIBA2/HG(IG)
            CFPIBG=DCMPLX(FPIBG,0.D0)
            CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
            FAC2=CFPIBG*RHOGS*(RHOG*CHGM1+RHOPR)
            T1=T1+FAC2*GAGK(IG,1)
            T2=T2+FAC2*GAGK(IG,2)
            T3=T3+FAC2*GAGK(IG,3)
            T4=T4+FAC2*GAGK(IG,4)
            T5=T5+FAC2*GAGK(IG,5)
            T6=T6+FAC2*GAGK(IG,6)
          ENDDO
          DEHC(1)=DEHC(1)+T1
          DEHC(2)=DEHC(2)+T2
          DEHC(3)=DEHC(3)+T3
          DEHC(4)=DEHC(4)+T4
          DEHC(5)=DEHC(5)+T5
          DEHC(6)=DEHC(6)+T6
        ENDIF 
      ENDIF 
#elif defined(__SR8000) 
      IF(BIGMEM) THEN
        IF(TIVAN) THEN 
*poption parallel
*poption tlocal(IG,ISA,RHOPR,IA,IS,R2)
*poption tlocal(RHET,RHOG,RHOGS,FPIBG,CFPIBG,CHGM1,FAC1,FAC2)
*poption psum(DEHC)
          DO IG=IG1,NHG
            RHOPR=(0.0D0,0.0D0)
            ISA=0
            DO IS=1,NSP 
              R2=RAGGIO(IS)*RAGGIO(IS)
              DO IA=1,NA(IS)
                ISA=ISA+1
                RHOPR=RHOPR+RHOPS(IS,IG)*R2*0.5D0*EIGRB(IG,ISA)
              ENDDO 
            ENDDO
            RHET=V(NZH(IG))
            RHOG=RHET+EIROP(IG)
            RHOGS=DCONJG(RHOG)
            FPIBG=FPI/TPIBA2/HG(IG)
            CFPIBG=DCMPLX(FPIBG,0.D0)
            CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
            FAC1=CFPIBG*RHOGS
            FAC2=FAC1*(RHOG*CHGM1+RHOPR)
            DEHC(1)=DEHC(1)+(FAC2*GAGK(IG,1)+FAC1*DRHOVG(IG,1))
            DEHC(2)=DEHC(2)+(FAC2*GAGK(IG,2)+FAC1*DRHOVG(IG,2))
            DEHC(3)=DEHC(3)+(FAC2*GAGK(IG,3)+FAC1*DRHOVG(IG,3))
            DEHC(4)=DEHC(4)+(FAC2*GAGK(IG,4)+FAC1*DRHOVG(IG,4))
            DEHC(5)=DEHC(5)+(FAC2*GAGK(IG,5)+FAC1*DRHOVG(IG,5))
            DEHC(6)=DEHC(6)+(FAC2*GAGK(IG,6)+FAC1*DRHOVG(IG,6))
          ENDDO
        ELSE 
*poption parallel
*poption tlocal(IG,ISA,RHOPR,IA,IS,R2)
*poption tlocal(RHET,RHOG,RHOGS,FPIBG,CFPIBG,CHGM1,FAC2)
*poption psum(DEHC)
          DO IG=IG1,NHG
            RHOPR=(0.0D0,0.0D0)
            ISA=0
            DO IS=1,NSP 
              R2=RAGGIO(IS)*RAGGIO(IS)
              DO IA=1,NA(IS)
                ISA=ISA+1
                RHOPR=RHOPR+RHOPS(IS,IG)*R2*0.5D0*EIGRB(IG,ISA)
              ENDDO 
            ENDDO
            RHET=V(NZH(IG))
            RHOG=RHET+EIROP(IG)
            RHOGS=DCONJG(RHOG)
            FPIBG=FPI/TPIBA2/HG(IG)
            CFPIBG=DCMPLX(FPIBG,0.D0)
            CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
            FAC2=CFPIBG*RHOGS*(RHOG*CHGM1+RHOPR)
            DEHC(1)=DEHC(1)+FAC2*GAGK(IG,1)
            DEHC(2)=DEHC(2)+FAC2*GAGK(IG,2)
            DEHC(3)=DEHC(3)+FAC2*GAGK(IG,3)
            DEHC(4)=DEHC(4)+FAC2*GAGK(IG,4)
            DEHC(5)=DEHC(5)+FAC2*GAGK(IG,5)
            DEHC(6)=DEHC(6)+FAC2*GAGK(IG,6)
          ENDDO
        ENDIF 
      ELSE 
        IF(TIVAN) THEN 
*poption parallel
*poption tlocal(IG,ISA,RHOPR,IA,IS,R2,EI123,ER,EI,ER2)
*poption tlocal(RHET,RHOG,RHOGS,FPIBG,CFPIBG,CHGM1,FAC1,FAC2)
*poption psum(DEHC)
          DO IG=IG1,NHG
            RHOPR=(0.0D0,0.0D0)
            ISA=0
            DO IS=1,NSP 
              R2=RAGGIO(IS)*RAGGIO(IS)
              DO IA=1,NA(IS)
                ISA=ISA+1
                EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                EI3(ISA,INYH(3,IG))
                ER=DREAL(EI123)
                EI=DIMAG(EI123)
                ER2=0.5D0*R2*RHOPS(IS,IG)
                RHOPR=RHOPR+DCMPLX(ER*ER2,EI*ER2)
              ENDDO 
            ENDDO
            RHET=V(NZH(IG))
            RHOG=RHET+EIROP(IG)
            RHOGS=DCONJG(RHOG)
            FPIBG=FPI/TPIBA2/HG(IG)
            CFPIBG=DCMPLX(FPIBG,0.D0)
            CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
            FAC1=CFPIBG*RHOGS
            FAC2=FAC1*(RHOG*CHGM1+RHOPR)
            DEHC(1)=DEHC(1)+(FAC2*GAGK(IG,1)+FAC1*DRHOVG(IG,1))
            DEHC(2)=DEHC(2)+(FAC2*GAGK(IG,2)+FAC1*DRHOVG(IG,2))
            DEHC(3)=DEHC(3)+(FAC2*GAGK(IG,3)+FAC1*DRHOVG(IG,3))
            DEHC(4)=DEHC(4)+(FAC2*GAGK(IG,4)+FAC1*DRHOVG(IG,4))
            DEHC(5)=DEHC(5)+(FAC2*GAGK(IG,5)+FAC1*DRHOVG(IG,5))
            DEHC(6)=DEHC(6)+(FAC2*GAGK(IG,6)+FAC1*DRHOVG(IG,6))
          ENDDO
        ELSE 
*poption parallel
*poption tlocal(IG,ISA,RHOPR,IA,IS,R2,EI123,ER,EI,ER2)
*poption tlocal(RHET,RHOG,RHOGS,FPIBG,CFPIBG,CHGM1,FAC2)
*poption psum(DEHC)
          DO IG=IG1,NHG
            RHOPR=(0.0D0,0.0D0)
            ISA=0
            DO IS=1,NSP 
              R2=RAGGIO(IS)*RAGGIO(IS)
              DO IA=1,NA(IS)
                ISA=ISA+1
                EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                EI3(ISA,INYH(3,IG))
                ER=DREAL(EI123)
                EI=DIMAG(EI123)
                ER2=0.5D0*R2*RHOPS(IS,IG)
                RHOPR=RHOPR+DCMPLX(ER*ER2,EI*ER2)
              ENDDO 
            ENDDO
            RHET=V(NZH(IG))
            RHOG=RHET+EIROP(IG)
            RHOGS=DCONJG(RHOG)
            FPIBG=FPI/TPIBA2/HG(IG)
            CFPIBG=DCMPLX(FPIBG,0.D0)
            CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
            FAC2=CFPIBG*RHOGS*(RHOG*CHGM1+RHOPR)
            DEHC(1)=DEHC(1)+FAC2*GAGK(IG,1)
            DEHC(2)=DEHC(2)+FAC2*GAGK(IG,2)
            DEHC(3)=DEHC(3)+FAC2*GAGK(IG,3)
            DEHC(4)=DEHC(4)+FAC2*GAGK(IG,4)
            DEHC(5)=DEHC(5)+FAC2*GAGK(IG,5)
            DEHC(6)=DEHC(6)+FAC2*GAGK(IG,6)
          ENDDO
        ENDIF 
      ENDIF 
#else 
      IF(BIGMEM) THEN
        DO IG=IG1,NHG
          RHOPR = (0.0D0,0.0D0)
          ISA=0
          DO IS=1,NSP
            R2 = RAGGIO(IS)*RAGGIO(IS)
            DO IA=1,NA(IS)
              ISA=ISA+1
              RHOPR = RHOPR + RHOPS(IS,IG)*R2*0.5D0*EIGRB(IG,ISA)
            ENDDO
          ENDDO
          RHET=V(NZH(IG))
          RHOG=RHET+EIROP(IG)
          RHOGS=DCONJG(RHOG)
          FPIBG=FPI/TPIBA2/HG(IG)
          CFPIBG=DCMPLX(FPIBG,0.D0)
          CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
          DO KK=1,6
            DEHC(KK) = DEHC(KK) + 
     *                 CFPIBG*RHOGS*(RHOG*CHGM1+RHOPR)*GAGK(IG,KK)
          ENDDO
          IF(TIVAN) THEN
            DO KK=1,6
              DEHC(KK) = DEHC(KK) + CFPIBG*RHOGS*DRHOVG(IG,KK)
            ENDDO
          ENDIF
        ENDDO
      ELSE 
        DO IG=IG1,NHG
          RHOPR = (0.0D0,0.0D0)
          ISA=0
          DO IS=1,NSP
            R2 = RAGGIO(IS)*RAGGIO(IS)
            DO IA=1,NA(IS)
              ISA=ISA+1
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *              EI3(ISA,INYH(3,IG))
              ER=DREAL(EI123)
              EI=DIMAG(EI123)
              ER2=0.5D0*R2*RHOPS(IS,IG)
              RHOPR = RHOPR + DCMPLX(ER*ER2,EI*ER2)
            ENDDO
          ENDDO
          RHET=V(NZH(IG))
          RHOG=RHET+EIROP(IG)
          RHOGS=DCONJG(RHOG)
          FPIBG=FPI/TPIBA2/HG(IG)
          CFPIBG=DCMPLX(FPIBG,0.D0)
          CHGM1=DCMPLX(1.D0/HG(IG)/TPIBA2,0.0D0)
          DO KK=1,6
            DEHC(KK) = DEHC(KK) + 
     *                 CFPIBG*RHOGS*(RHOG*CHGM1+RHOPR)*GAGK(IG,KK)
          ENDDO
          IF(TIVAN) THEN
            DO KK=1,6
              DEHC(KK) = DEHC(KK) + CFPIBG*RHOGS*DRHOVG(IG,KK)
            ENDDO
          ENDIF
        ENDDO
      ENDIF 
#endif 
      DO KK=1,6
        DEHT(KK) = -EHT*DELTA(ALPHA(KK),BETA(KK)) +
     *             2.0D0*OMEGA*DREAL(DEHC(KK))
      ENDDO
      CALL TIHALT('    HTRSTR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
