C     ==================================================================
      SUBROUTINE INITCLUST
C     ==--------------------------------------------------------------==
C     == INITIALIZATION ROUTINE FOR CLUSTER BOUNDARY CONDITIONS       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'isos.inc'
      INCLUDE 'cppt.inc'
C     ==--------------------------------------------------------------==
      IF(TCLUST) THEN
        IF(PS_TYPE.EQ.1) THEN
          CALL HIPIN
        ELSEIF(PS_TYPE.EQ.2) THEN
          CALL MTIN
        ELSEIF(PS_TYPE.EQ.3) THEN
          CALL MOIN
        ENDIF
      ELSE
        NR1H=1
        NR2H=1
        NR3H=1
        NR3PL=1
        CALL MEMORY(IP_SCG,2*NHG,'SCG')
        CALL GF_PERIODIC
      ENDIF
      CALL HF_INIT(.FALSE.)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GF_PERIODIC
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'isos.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INTEGER  IG1,IG
      REAL*8   G2
C     ==--------------------------------------------------------------==
      IG1=1
      IF(GEQ0) IG1=2
      DO IG=IG1,NHG
        G2=TPIBA2*HG(IG)
        SCG(IG)=DCMPLX(FPI/G2,0.D0)
      ENDDO
      IF(GEQ0) SCG(1)=0.0D0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HF_INIT(RESPONSE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'func.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'rswf.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'hfx.inc'
      LOGICAL RESPONSE
      INTEGER IG,IG1,LDIM,NSTATE
      REAL*8 G2,SRXA2,RSTATE,RMEM
      REAL*8 DIV, TMP_DIV, alpha, aa
      REAL*8 dq , qq, q
      INTEGER nqq, iq
      INTEGER IFIRST
      SAVE    IFIRST
      DATA    IFIRST /0/
C     ==--------------------------------------------------------------==
      IF(MHFX.NE.0 .AND. IFIRST.EQ.0) THEN
        IF(TKPNT) CALL STOPGM('HFX','K-POINTS NOT IMPLEMENTED')
        IF(TLSE) CALL STOPGM('HFX','NO LSE POSSIBLE')
        IF(TIVAN) CALL STOPGM('HFX','NO VDB PP POSSIBLE')
        IF(NOGRP.GT.1) CALL STOPGM('HFX','TASK GROUPS NOT IMPLEMENTED')

        CALL GET_ADDR(IP_SCGX,SCG(1))
        IF(MSRX.EQ.1) THEN
C..exp(-a*r)/r
          CALL MEMORY(IP_SCGX,2*NHG,'SCGX')
          SRXA2=SRXA*SRXA
C  PUB START
          alpha = 10*TPIBA2/ECUT
          DIV = 0
          DO IG =1, NHG
            if(HG(IG).gt.1e-8)then
               DIV= DIV + EXP(-alpha*HG(IG))/(HG(IG) + SRXA2/TPIBA2)
            else
               DIV = DIV - alpha
            endif
          ENDDO
          TMP_DIV = DIV
          CALL MY_COMBINE(TMP_DIV, DIV, 8, 1, ALLGRP)
          DIV = 2*DIV + alpha
          DIV = DIV * 2 * FPI / TPIBA2
          alpha = alpha/TPIBA2
          aa = 0
          nqq = 100000
          dq = 5.0/sqrt(alpha)/nqq
          do iq = 0,nqq
             q = dq * (iq+0.5d0)
             qq = q * q
             aa = aa - exp( -alpha * qq) * SRXA2/ (qq + SRXA2) * dq
          enddo
          aa = aa * 8.d0/FPI
          aa = aa + 1.d0/SQRT(alpha*0.25d0*FPI)
          DIV = DIV - 2*OMEGA * aa
C  PUB END
          IG1=1
          IF(GEQ0) IG1=2
          DO IG=1,NHG
            G2=TPIBA2*HG(IG) + SRXA2
            SCGX(IG)=DCMPLX(FPI/G2,0.D0)
          ENDDO
          IF(GEQ0) SCGX(1)= -DIV/2
          IF(GEQ0) WRITE(6,*) 'PUB Divergence', DREAL(SCGX(1))

        ELSEIF(MSRX.EQ.2) THEN
C..erfc(a*r)/r
          CALL MEMORY(IP_SCGX,2*NHG,'SCGX')
          SRXA2=1.D0/(4.D0*SRXA*SRXA)
C  PUB START
          alpha = 10*TPIBA2/ECUT
          DIV = 0
          DO IG =1, NHG
            if(HG(IG).gt.1e-8)then
              DIV= DIV + EXP(-alpha*HG(IG))/HG(IG)*
     &             (1-EXP(-HG(IG)*SRXA2*TPIBA2))
            else
              DIV = DIV - alpha
            endif
          ENDDO
          TMP_DIV = DIV
          CALL MY_COMBINE(TMP_DIV, DIV, 8, 1, ALLGRP)
          DIV = 2*DIV
          if(SRXA2.gt.1e-8) then
            DIV = DIV + alpha
          else
             DIV = DIV - TPIBA2/(-SRXA2)
          endif
          DIV = DIV * 2 * FPI / TPIBA2
          alpha = alpha/TPIBA2
          aa = 0
          nqq = 100000
          dq = 5.0/sqrt(alpha)/nqq
          do iq = 0,nqq
            q = dq * (iq+0.5d0)
            qq = q * q
            aa = aa-exp(-alpha*qq)*EXP(-qq*SRXA2)*dq
          enddo
          aa = aa * 8.d0/FPI
          aa = aa + 1.d0/SQRT(alpha*0.25d0*FPI)
          WRITE(6,*) 'PUB AA', alpha, SRXA2
          DIV = DIV - 2*OMEGA * aa
C   PUB END
          IG1=1
          IF(GEQ0) IG1=2
          DO IG=IG1,NHG
            G2=TPIBA2*HG(IG)
            SCGX(IG)=DCMPLX(FPI/G2,0.D0)*(1.D0-EXP(-G2*SRXA2))
          ENDDO
          IF(GEQ0) SCGX(1)= -DIV/2
          IF(GEQ0) WRITE(6,*) 'PUB Divergence SRXA2', SCGX(1)

        ELSEIF(RESPONSE) THEN
C..nothing to do
        ELSEIF(.NOT.TCLUST) THEN
C  PUB START
C  FULL PBE0 calculation
          CALL MEMORY(IP_SCGX,2*NHG,'SCGX')
          IG1=1
          IF(GEQ0) IG1=2
          DO IG=IG1,NHG
            G2=TPIBA2*HG(IG)
            SCGX(IG)=DCMPLX(FPI/G2,0.D0)
          ENDDO
          alpha = 10*TPIBA2/ECUT
          DIV = 0
          DO IG = 1, NHG
            IF(HG(IG).gt.1e-8) THEN
              DIV= DIV + EXP(-alpha*HG(IG))/HG(IG)
            ELSE
              DIV = DIV - alpha
            ENDIF
          ENDDO
          TMP_DIV = DIV
          CALL MY_COMBINE(TMP_DIV, DIV, 8, 1, ALLGRP)
          DIV = 2*DIV
          DIV = DIV + alpha
          alpha = alpha/TPIBA2
          DIV = DIV* 2 * FPI/TPIBA2
          aa = 1.d0/SQRT(alpha*0.25d0*FPI)
          DIV = DIV - 2*OMEGA * aa
          IF(GEQ0) SCGX(1)= -DIV/2
          IF(GEQ0) WRITE(6,*) 'PUB Divergence', DREAL(SCGX(1)), 'alpha',
     &        TPIBA2*alpha
C  REMOVE DOUBLE COUNTING IN TOTAL ENERGY
          EG0HFX=  0
C  PUB END

C          IF(IBRAV.EQ.1) THEN
C            EG0HFX=2.8373D0*0.5D0/ALAT
C          ELSE
C            CALL STOPGM("HF_INIT",
C     *                  "HFX not implemented for this symmetry")
C          ENDIF
C          CALL STOPGM("HF_INIT","Not implemented")

        ELSEIF(TCLUST .AND. PS_TYPE.EQ.1) THEN 
          CALL STOPGM("HF_INIT", "HFX not implemented for HOCKNEY.")
        ENDIF
        IF(HFXWFE.GT.0.D0 .AND. HFXDEE.GT.0.D0) THEN
          IF(PARENT) THEN
            WRITE(6,'(/,A,T56,F10.0)')
     &        ' Wavefunction Cutoff for HFX [Ry] ',HFXWFE
            WRITE(6,'(A,T56,F10.0)')
     &        ' Density Cutoff for HFX [Ry] ',HFXDEE
          ENDIF
          CALL ADDFFTNSET(HFXDEE,HFXWFE,IPOOLHFX)
        ELSE
          CALL ADDFFTNSET(-1.D0,-1.D0,IPOOLHFX)
          IPOOLHFX=0
        ENDIF
c       ARRAY TO KEEP THE REAL SPACE WAVEFUNCTIONS
        IF(KRWFN) THEN
          CALL SETFFTN(IPOOLHFX)
          LWDIMX = LLR1
          NSTATE = N
          IF(MEMSIZE.LT.0) THEN
            MAXSTATESX = NSTATE
            RSTATE=1.D0
          ELSE
            RMEM = 0.125D0*MEMSIZE*1.D6/DBLE(LWDIMX)
            MAXSTATESX = ((INT(RMEM)+1)/2)*2
            MAXSTATESX = MIN(NSTATE,MAXSTATESX)
            RMEM = MAXSTATESX
            CALL GLOMIN(1,RMEM)
            MAXSTATESX = NINT(RMEM)
            RSTATE= DBLE(MAXSTATESX)/DBLE(NSTATE)
          ENDIF
          IF(IPOOLHFX.EQ.0) THEN
            IP_RSWFX = IP_RSWF
          ELSE
            LDIM  = (MAXSTATESX+1)/2 * LWDIMX
            CALL MEMORY(IP_RSWFX,2*LDIM,'RSWFX')
            RMEM = 16.D0*LDIM*1.D-6
            IF(PARENT) THEN
              IF(RSTATE.GT.0.99999999D0) THEN
                  WRITE(6,'(A,T59,A)')
     *          ' HFX| ORBITALS KEPT IN REAL SPACE ','    ALL'
              ELSE
                WRITE(6,'(A,T50,F8.1,A)')
     *            ' HFX| ORBITALS KEPT IN REAL SPACE ',
     *            100*RSTATE,' PERCENT'
              ENDIF
              WRITE(6,'(A,T51,F8.3,A)')
     *        ' HFX| WAVEFUNCTION TAKES IN REAL SPACE ',RMEM,' MBYTES'
            ENDIF
          ENDIF
          CALL SETFFTN(0)
        ENDIF
      ENDIF
      IFIRST = 1
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
