C     ==================================================================
      SUBROUTINE INITRUN(IREC,C0,CM,SC0,RHOE,PSI,EIGV,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == Initialization of a run (read from RESTART file or not)      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'andr.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'shop.inc'
      INCLUDE 'store.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'bsym.inc'
c     Qmmm
      include 'mm_dim.inc'
      include 'mm_input.inc'
C     Arguments
      INTEGER    IREC(*),LSCR
      COMPLEX*16 C0(NGWK,N,*),CM(*),SC0(*),PSI(*)
      REAL*8     RHOE(NNR1,*),SCR(*),EIGV(*)
C     Variables
      CHARACTER TAG*30
      DIMENSION F(*)
      DIMENSION RIN0(NNR1,NLSD),ROUT0(NNR1,NLSD),RMIX(*)
      REAL*8    FNL(*),DFNL(*)
      INTEGER   MSGLEN,I,LINITRUN,NKPOINT,KBEG,KEND,KINC,IKIND,IKPT
      INTEGER   NSTATE
      logical   status,statusdummy
C     ==--------------------------------------------------------------==
      call mm_dim(mm_go_mm,status)

      CALL GIVE_SCR_INITRUN(LINITRUN,TAG)
      CALL TEST_SCR('INITRUN',TAG,LSCR,LINITRUN)
      CALL READ_IREC(IREC)
      IF(TSHOP) THEN
        NSTATE=NST_S0+NST_S1
      ELSE
        NSTATE=N
      ENDIF
      IF(TDDFT) THEN
        IF(.NOT.RESTART) CALL STOPGM('INITRUN','TDDFT NEEDS RESTART')
        IF(.NOT.RLR) CALL STOPGM('INITRUN','TDDFT NEEDS RESTART LINRES')
        LRACTIVE=.TRUE.
      ENDIF
      IF (.NOT.RESTART) THEN
        IF(BSCLCS.EQ.1) RESTHSWF = .TRUE.
#if defined (__GROMOS)
        if(tqmmm)then
          if(restart_traj) call mm_restart_traj(TAU0,VELP,IREC)
        endif
#endif
        IF(TSHOP) CALL STOPGM('INITRUN','NEED A RESTART FILE')
C       Randomize cell parameters
        IF(TRANC) CALL RANC(TAU0)
C       Randomization of the atomic coordinates.
        IF(TRANP.AND.PARENT) CALL RANP(TAU0)
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
C       INITIALIZATION OF WAVEFUNCTION
        call mm_dim(mm_go_qm,statusdummy)
        CALL RINITWF(C0,CM,SC0,NSTATE,TAU0,TAUP,RHOE,PSI,SCR,LSCR)
      ELSEIF(RESTART.AND.RNON) THEN
        IF(BSCLCS.EQ.1) RESTHSWF = .TRUE.
#if defined (__GROMOS)
        if(tqmmm)then
          if(restart_traj) call mm_restart_traj(TAU0,VELP,IREC)
        endif
#endif
        IF(RGEO.AND.PARENT) CALL GEOFILE(TAU0,VELP,'READ')
C       Randomize cell parameters
        IF(TRANC) CALL RANC(TAU0)
C       Randomization of the atomic coordinates.
        IF(TRANP.AND.PARENT) CALL RANP(TAU0)
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
C       INITIALIZATION OF WAVEFUNCTION
        call mm_dim(mm_go_qm,statusdummy)
        CALL RINITWF(C0,CM,SC0,NSTATE,TAU0,TAUP,RHOE,PSI,SCR,LSCR)
        IF(RGEO.AND.PARENT) CALL GEOFILE(TAU0,VELP,'READ')
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
      ELSEIF((RESTART.AND. .NOT.RNON).OR.TMERGE) THEN
        IF(BSCLCS.EQ.1) RESTHSWF = .FALSE.
C       READ RESTART FILE
        IF (TMERGE) THEN
           CALL MERGE(C0,CM,RHOE,PSI,SCR,LSCR)
        ELSE
           CALL ZHRWF(1,IREC,C0,CM,NSTATE,EIGV,TAU0,VELP,TAUP,NFI)
        ENDIF
        IF(RGEO.AND.PARENT) CALL GEOFILE(TAU0,VELP,'READ')
#if defined (__GROMOS)
        if(tqmmm)then
          if(restart_traj) call mm_restart_traj(TAU0,VELP,IREC)
        endif
#endif
        call mm_dim(mm_go_qm,statusdummy)
        CALL AINITWF(C0,NSTATE,TAU0,TAUP,RHOE,PSI,SCR,LSCR)
        call mm_dim(mm_go_mm,statusdummy)
C       Randomize cell parameters
        IF(TRANC) CALL RANC(TAU0)
C       Randomization of the atomic coordinates.
        IF(TRANP.AND.PARENT) CALL RANP(TAU0)
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
C       Update symmetry operation
        IF(IREC(IREC_CO).EQ.1) CALL UPDATSYM(TAU0)
C       INITIALIZE A NEW WAVEFUNCTION
        call mm_dim(mm_go_qm,statusdummy)
        IF(IREC(IREC_WF).EQ.0) THEN
          IF(TSHOP) CALL STOPGM('INITRUN','NEED WAVEFUNCTIONS')
          CALL RINITWF(C0,CM,SC0,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
        ENDIF
C       Randomize electronic wavefunctions around loaded ones
        IF(TRANE) CALL RRANE(C0,CM,NSTATE)
C       update cell
        IF(TPRCP.OR.TPRES.OR.RCELL) THEN
          IF(TCLUST) THEN
            WRITE(0,'(/,X,A,/,X,A,/,X,A,/)')
     &           'INITRUN| WARNING: READ CELL FROM RESTART UNSUPPORTED',
     &           'INITRUN| WARNING: FOR CLUSTER CALCULATIONS',
     &           'INITRUN| WARNING: USING PARAMETERS FROM INPUT FILE'
          ELSE
            MSGLEN = 9 * 8
            CALL MY_BCAST(HT,MSGLEN,SOURCE,ALLGRP)
            DO I=1,3
              A1(I) = HT(1,I)
              A2(I) = HT(2,I)
              A3(I) = HT(3,I)
            ENDDO
            CALL IHMAT(HT,HTM1,OMEGA)
            CALL NEWCELL(SCR,LSCR)
          ENDIF
        ENDIF

#if defined (__GROMOS)
C       (re-)check coordinates, e.g. needed when restarting from GEOMETRY file.
        IF(TQMMM.AND..NOT.QMMM_REFLEX) THEN
          CALL mm_translate_qmmm(TAU0,C0,CM,NSTATE)
        ENDIF
#endif

        CALL PHFAC(TAU0)
        IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,TPRCP)
C       Orthogonalize electronic wavefunctions
        IF(IREC(IREC_WF).EQ.0.OR.TRANE.OR.(TIVAN.AND..NOT.NONORT)) THEN
          CALL INQ_SWAP(KBEG,KEND,KINC)
          DO IKPT=KBEG,KEND,KINC
            NKPOINT=NKPBL(IKPT)
            IF(TKBLOCK) CALL RKPT_SWAP(C0,NSTATE,IKPT,'C0')
            DO IKIND=1,NKPOINT
              IF(TSHOP) THEN
                IF(TIVAN) CALL RNLSM(C0(1,1,IKIND),NST_S0,PSI,
     *                      SCR,LSCR,IKPT,IKIND,.FALSE.)
                CALL ORTHO(NST_S0,C0(1,1,IKIND),CM,SCR,LSCR)
                IF(TIVAN) CALL RNLSM(C0(1,NST_S0+1,IKIND),
     *                               NST_S1,PSI,SCR,LSCR,
     *                               IKPT,IKIND,.FALSE.)
                CALL ORTHO(NST_S1,C0(1,NST_S0+1,IKIND),CM,SCR,LSCR)
              ELSE
                IF(TIVAN) CALL RNLSM(C0(1,1,IKIND),NSTATE,PSI,
     *                      SCR,LSCR,IKPT,IKIND,.FALSE.)
                CALL ORTHO(NSTATE,C0(1,1,IKIND),CM,SCR,LSCR)
              ENDIF
            ENDDO
            IF(TKBLOCK) CALL WKPT_SWAP(C0,NSTATE,IKPT,'C0')
          ENDDO
        ENDIF
      END IF
      call mm_dim(mm_go_mm,statusdummy)
      IF(PARENT) THEN
        IF(.NOT.qmmm) THEN
C       we cannot do this since the gromos/cpmd translation
C       tables have not been set up yet.
CSI: To check, if forces are always available
          CALL WRGEOF(TAU0,FION)
          CALL GEOFILE(TAU0,VELP,'WRITE')
        ENDIF
      ENDIF
C     Initialization of density and potential
C     for diagonalization schemes
      call mm_dim(mm_go_qm,statusdummy)
      IF(TDIAG.AND..NOT.CLASSICAL) THEN
        IF(TSHOP) CALL STOPGM('INITRUN','TDIAG AND TSHOP NOT SUPPORTED')
        IF(IREC(IREC_RHO).EQ.0) THEN
          IF(TIVAN) THEN
            CALL RNLSM(C0,NSTATE,PSI,
     *                      SCR,LSCR,1,1,.FALSE.)
          ENDIF
          IF(TKPNT) THEN
            CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,NSTATE)
          ELSE
            CALL RHOOFR  (C0,RHOE,PSI,SCR,LSCR,NSTATE)
          ENDIF
          CALL DCOPY(NNR1*NLSD,RHOE,1,RIN0,1)
        ENDIF
        IF(TRAND) CALL RRANDD(RIN0,AMPRD)
        CALL AZZERO(ROUT0,NNR1*NLSD)
        CALL AZZERO(RMIX,NNR1*NLSD)
C       NL-Projector Overlap Matrix
        IF(TTROT) CALL CALC_ALM(SCR,LSCR)
      ELSEIF(TKPNT) THEN
          CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,NSTATE)
          CALL DCOPY(NNR1*NLSD,RHOE,1,RIN0,1)
      ENDIF
C     Init some DIIS counters
      NDISRS=0
      NDISTP=0
      call mm_dim(mm_revert,status)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_INITRUN(LINITRUN,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !TDIAG, TPRCP
      INCLUDE 'elct.inc'        !N
      INCLUDE 'store.inc'       !RESTART, RCELL
      INCLUDE 'nlcc.inc'        !TINLCC
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'        !TTROT
C     Arguments
      INTEGER   LINITRUN
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LRINITWF,LNEWCELL,LCOPOT,LORTHO,LRNLSM,LRHOOFR,
     &          LCALC_ALM,LAINITWF
C     ==--------------------------------------------------------------==
      NSTATE=N
      LNEWCELL=0
      LCOPOT=0
      LORTHO=0
      LRNLSM=0
      LRHOOFR=0
      LCALC_ALM=0
      LAINITWF=0
      LINITRUN=0
      LRINITWF=0
      CALL GIVE_SCR_RINITWF(LRINITWF,TAG,NSTATE)
      IF(RESTART) THEN
        IF(TPRCP.OR.TPRES.OR.RCELL) CALL GIVE_SCR_NEWCELL(LNEWCELL,TAG)
        IF(TINLC) CALL GIVE_SCR_COPOT(LCOPOT,TAG)
        CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
        IF(.NOT. RNON) CALL GIVE_SCR_AINITWF(LAINITWF,TAG,NSTATE)
        LORTHO=MAX(LORTHO,LAINITWF)
      ENDIF
      IF(TDIAG) THEN
        IF(TIVAN) CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
        CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
        IF(TTROT) CALL GIVE_SCR_CALC_ALM(LCALC_ALM,TAG)
      ENDIF
      LINITRUN=MAX(LRINITWF,LNEWCELL,LCOPOT,LORTHO,LRNLSM,LRHOOFR,
     &             LCALC_ALM)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
