C     ==================================================================
      SUBROUTINE interaction_manno_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &        eirop,eivps,z11,nstate)
c     ==================================================================
C     PARALLEL
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'response_p.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'wann.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'store.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'atwf.inc'        !CATOM ZXMAT XXMAT
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'kpnt.inc'        !WK
      INCLUDE 'tpar.inc'        !dt2bye
c     ==--------------------------------------------------------------==
c     Arguments
      integer    nstate,lscr
      complex*16 c0(ngw,nstate),psi(*),eirop(nhg),eivps(nhg)
      complex*16 c1(ngw,nstate)
      real*8     z11(nstate,nstate),scr(2*maxfft,*),
     &           rhoe(*),drhoe(*)
C     Common variables
      real*8     FNL(*),DFNL(*)
c     ==--------------------------------------------------------------==
c     Local variables
      complex*16 h1psi0(ngw,nstate)
      POINTER (IP_h1psi0,h1psi0)
      INTEGER isub,isub2,ISCF_step
#ifdef PARALLEL
      integer NXXFUN
      external NXXFUN
#endif
      real*8     dummy
C     vector containing the final result (C0+C1)
      complex*16 C0plusC1(NGW,NSTATE)
      POINTER (IP_C0plusC1,C0plusC1)
C     tmp C1 vector for cutoff changes...
      complex*16 tempC1(NGW,NSTATE)
      POINTER (IP_tempC1,tempC1)
C     Copy of the original C0 vector for SCF calculations
      complex*16 originalC0(NGW,NSTATE)
      POINTER (IP_originalC0,originalC0)
C     Accumulated C1 vector for SCF calc.
      complex*16 sumC1(NGW,NSTATE)
      POINTER (IP_sumC1,sumC1)
      integer i,j,istate
      real*8 E0,Efunct
      CHARACTER NAME*20
      REAL*8  Last_Etot
C     Scratch arrays for the localisation
      complex*16 cs(NGW,NSTATE)
      POINTER (IP_CS,CS)
      complex*16 SCT(NGW,NSTATE)
      POINTER (IP_SCT,SCT)
      INTEGER NC,irec(100)
C     variables for the articial cutoff reduction
      REAL*8  My_New_Gcut,MY_ECUT
      INTEGER New_NGW

      INTEGER get_new_NGW
      EXTERNAL get_new_NGW

C     Convergence variables for SCF calculations
      REAL*8  scf_gemax,scf_cnorm
      REAL*8  timef,time1,time2,tcpu
      EXTERNAL timef

C     temporary: atomic wf for orthogonalisation
      complex*16 CATTMP
      POINTER (IP_CATTMP,CATTMP)

C     temporary: non-orthogonal w0, overlap matrix
      REAL*8  W0_Sij(NSTATE,NSTATE)
      POINTER (ip_W0_Sij,W0_Sij)
      REAL*8  c0h0c0_ij(NSTATE,NSTATE)
      POINTER (ip_c0h0c0_ij,c0h0c0_ij)
      REAL*8  inverse_of_S(NSTATE,NSTATE)
      POINTER (ip_inverse_of_S,inverse_of_S)
      REAL*8  Emat(NSTATE,NSTATE)
      POINTER (ip_Emat,Emat)
      INTEGER IDELTA
      INTEGER k,F_tmp(NSTATE)
      DIMENSION  F(NSTATE,*)
      REAL*8  Z(NSTATE*(NSTATE+1)/2)
      REAL*8  eigenval(NSTATE)
      REAL*8  eigenvecs(NSTATE,NSTATE)
      REAL*8  work(3*NSTATE),E_total

C     Storage array for Wannier centres
      REAL*8  CENTRE(4,NSTATE)

 99   FORMAT ("*  Calculation of responses DONE.",31X,"*")
 98   FORMAT (47("*"),"PT-INTER*RESPONSE*")
c     ==--------------------------------------------------------------==
      call tiset('   PTINTER',isub)
      timetag=' '
      PR_ENERGY = .true. 

C     Allocating memory
      CALL MEMORY(IP_h1psi0,2*NGW*NSTATE,'h1psi0')
      CALL MEMORY(IP_C0plusC1,2*NGW*NSTATE,'C0plusC1')
      IF (CUTOFF_TRICK) THEN
         CALL MEMORY(IP_tempC1,2*NGW*NSTATE,'tempC1')
      ENDIF
      IF (BPTSCFIter.GT.1) THEN
C        SCF arrays...
         CALL MEMORY(IP_originalC0,2*NGW*NSTATE,'originalC0')
         CALL MEMORY(IP_sumC1,2*NGW*NSTATE,'sumC1')
      ENDIF
C     overlap matrix for non-orthog W0 and so on..
      IF (.NOT.TORTHOG_WANNIER) THEN
         CALL MEMORY(IP_W0_Sij,NSTATE*NSTATE,'W0_Sij')
         CALL MEMORY(IP_c0h0c0_ij,NSTATE*NSTATE,'c0h0c0_ij')
         CALL MEMORY(IP_inverse_of_S,NSTATE*NSTATE,'Sapprox')
         CALL MEMORY(IP_Emat,NSTATE*NSTATE,'Emat')
      ENDIF
c     ==--------------------------------------------------------------==
      if (parent) CALL PRMEM('  PT-INTER')
c     ==--------------------------------------------------------------==
C     If we use atomic wavefunction then ititialise it..
      if (TATOMICWAVEFUNCTION) then
         if (parent) 
     &      write(6,*) 'Initialising ATOMIC WAVEFUNCTION for W0'

         call ATOMWF(C0,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
         if (parent) 
     &      write(6,*) 'DONE...'
      endif
      
C     Localisation of the wavefunction if we re not loading from disk
      if (TLOCALIZE.AND..NOT.WANN_LOAD) then
        write(6,*) 'LOCALISING THE KS ORBITALS...'
        TWANN=.true.
        LOCL=.true.
        NUMORB=MAX(NUMORB,NSTATE)
        NC=2*NGWK*NUMORB
#ifdef PARALLEL
        LENBK=NXXFUN(NUMORB)
        NC=MAX(2*LENBK*NPROC,NC)
#endif
        CALL MEMORY(IP_SCT,NC,'SCT/tmp   ')
        CALL MEMORY(IP_CS,NC,'CS/tmp   ')
        CALL LOCALIZE(TAU0,C0,CS,SCT,SCR,LSCR,NSTATE)
        CALL EICALC(eivps,eirop)

C       save a RESTART file (disabled)
c       SWF     = .TRUE.
c       CALL WRITE_IREC(IREC)
c       CALL ZHWWF(2,IREC,C0,CS,NSTATE,scr,TAU0,VELP,TAUP,NFI)

C       freeing memory
        CALL FREEM(IP_CS)
        CALL FREEM(IP_SCT)
        write(6,*) 'Done'
      endif

C     End of localisation

      IF (CUTOFF_TRICK) THEN
         write(6,*) 'CUTOFF TRICK enabled...'
      ENDIF
C     Are we using a lower cutoff, if yes assign the variables...
      IF (CUTOFF_RESTR) THEN
         if (parent) then
            write(6,*) 'using a lower cutoff for the perturbation'
         endif
C        MY_ECUT=ECUT/2.D0
         MY_ECUT=40.D0
         NGW_ZERO=get_new_NGW(MY_ECUT)
      ENDIF
      IF (BPTSCFIter.GT.1 .AND. PARENT) THEN
         write(6,*) '---------- SELF-CONSISTENT PT ----------'
         write(6,*) '----- PERFORMING',BPTSCFIter,'SCF iterations -----'
         write(6,FMT='(1X,A,E8.3,A)') '----- SCF-PT CONVERGENCE: ',
     $                             SCF_TOL,' -----'
         write(6,*) '----------------------------------------'
      ENDIF
c     ==--------------------------------------------------------------==
C     If we are not using an atomic wavefuncttion then used wannier functions...
      if (.NOT.TATOMICWAVEFUNCTION) then
C        LOAD THE ORBITALS FROM DATABASE into c0
         IF (parent) THEN
           WRITE(6,*) 'Initialising the Wannier orbitals (W0)'
         ENDIF
         CALL RotateMyWannier_manno(NSTATE,C0,lscr,scr,psi)
         IF (parent) THEN
           WRITE(6,*) 'Wannier orbitals are now initialised'
         ENDIF
      ENDIF

C     Were we saving a WF? if yes then EXIT
      IF (WANN_SAVE) THEN
         write(6,*) 'WANNIER FUNCTION SAVING OPTION ENABLED'
         write(6,*) 'PROGRAM TERMINATES HERE....'
         call tihalt('   PTINTER',isub)

C        DE-allocating the arrays....
         IF (BPTSCFIter.GT.1) THEN
            CALL FREEM(IP_sumC1)      ! SCF array
            CALL FREEM(IP_originalC0) ! SCF array
         ENDIF
         IF (CUTOFF_TRICK) THEN
            CALL FREEM(IP_tempC1)
         ENDIF
         CALL FREEM(IP_C0plusC1)
         CALL FREEM(IP_h1psi0) 
         RETURN
      ENDIF 
      
C  ---saving the starting guess made of localised wf
      IF (SAVE_LOCALISED_W0) THEN
         write(6,*) 'SAVING RESTART FOR ORTHOGONALISED W0'
         SWF     = .TRUE.
         CALL WRITE_IREC(IREC)
         CALL ZHWWF(2,IREC,C0,h1psi0,NSTATE,scr,
     $              TAU0,VELP,TAUP,NFI)
         write(6,*) 'DONE'

C        OK, now we are done....
         write(6,*) 'PROGRAM TERMINATES HERE....'
         call tihalt('   PTINTER',isub)

C        DE-allocating the arrays....
         IF (BPTSCFIter.GT.1) THEN
            CALL FREEM(IP_sumC1)      ! SCF array
            CALL FREEM(IP_originalC0) ! SCF array
         ENDIF
         IF (CUTOFF_TRICK) THEN
            CALL FREEM(IP_tempC1)
         ENDIF
         CALL FREEM(IP_C0plusC1)
         CALL FREEM(IP_h1psi0)
         RETURN
      ENDIF
C  ---end of saving the starting guess made of localised wf


C     ==-START OF PT CALCULATION--------------------------------------==
C     initialise timer
      time1 = timef()

C     and don t forget to update the constant gnd-state density and
C     Coulomb-potential arrays:

      if (TATOMICRHO) THEN
C        Here we use the atomic density as constant gnd state density
         if (parent) 
     &      write(6,*) 'Using atomic RHO0 instead of W0^2'

C        just allocate memory for the atomic WF...
         CALL MEMORY(IP_CATOM,2*NGWK*NATTOT,'CATOM')
         CALL MEMORY(IP_CATTMP,2*NGWK*NATTOT,'CATTMP')

C        Use the full atomic WF routine (to fix later...)
         call ATOMWF(CATTMP,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
C        generate the atomic density from the KS-atomic wf... 
         call rhoofr(CATTMP,rho0,psi,scr,lscr,NSTATE)
         if(ttau) call stopgm("interaction_p","no tau functionals")

         call DCOPY(nnr1, rho0, 1, vofrho0, 1)
         call vofrho(tau0,fion,vofrho0,psi,scr,lscr,.false.,.false.)

C        Free the atomic WF..
         CALL FREEM(IP_CATTMP)

         if (parent) write(6,*) 'Done...'
      else
C        Here the constant gnd state density is computed exactly
         call rhoofr(c0,rho0,psi,scr,lscr,nstate)
         call DCOPY(nnr1, rho0, 1, vofrho0, 1)
         call vofrho(tau0,fion,vofrho0,psi,scr,lscr,.false.,.false.)
      endif

C     saving the total density to disk.... if we don t do SCF
      IF (BPTSCFIter.LE.1) THEN
         call fftTOg(rho0,scr,psi,nhg,.false.)
         name='total.dens'
         call densto(scr,tau0,name)
      ENDIF

C     Total energy of the starting Wannier orbitals (W0)
      IF (TORTHOG_WANNIER.AND..NOT.TSIMPLE_MODEL) THEN
c     IF (TORTHOG_WANNIER.OR.TSIMPLE_MODEL) THEN
         call forces(c0,h1psi0,tau0,FION,RHOE,PSI,SCR,LSCR,
     &                  NSTATE,1,.false.,.false.)
         if (parent) then
            write(6,*)
            print *,'***** ENERGY DECOMPOSITION *****'
            print *,'EKIN  (       W0)= ',EKIN,' A.U.'
            print *,'EHT   (       W0)= ',EHT,' A.U.'
            print *,'EPSEU (       W0)= ',EPSEU,' A.U.'
            print *,'ENL   (       W0)= ',ENL,' A.U.'
            print *,'EXC   (       W0)= ',EXC,' A.U.'
            print *,'------------------'
            print *,'ETOT  (       W0)= ',ETOT,' A.U.'
            write(6,*)
         endif

C        Calculate convergence criteria on W0
         CALL CSIZE(h1psi0,NSTATE,scf_gemax,scf_cnorm)
         if (parent) then
            write(6,'(a,E10.4,a,E10.4)') 
     $           'INITIAL GRADIENT OF W0: Gemax = ',scf_gemax,
     $           ' Cnorm = ',scf_cnorm
         endif
      ENDIF

C     simple interaction model 
      if (TSIMPLE_MODEL) THEN  
         CALL SIMPLE_MODEL_p(C0,c1,psi,rhoe,scr,lscr,nstate,eirop,eivps)
         return
      ENDIF

C     Storing the value of E(0)
      E0=ETOT

C     non orthogonal energy <c0|H0|c0>
      IF (.NOT.TORTHOG_WANNIER) THEN
C        copying F... (state occupation)
         call ICOPY(NSTATE*NKPNT, F, 1, F_tmp, 1)
         
C        change F to single occupation for all states
         DO i=1,NSTATE
            F(i,1)=1
         ENDDO

C        Total energy of the starting Wannier orbitals (W0)
         call forces(c0,h1psi0,tau0,FION,RHOE,PSI,SCR,LSCR,
     &                  NSTATE,1,.false.,.false.)

C        copying original F back to its normal location
         call ICOPY(NSTATE*NKPNT, F_tmp, 1, F, 1)
         
c        CALL MEMORY(IP_CS,NC,'CS/tmp   ')
c        call HPSI(c0,h1psi0,CS,vofrho0,PSI,SCR,LSCR,NSTATE,1,1)
c        CALL FREEM(IP_CS)

C        Use OVLAP to build hamiltonian matrix
         call ovlap(nstate,c0h0c0_ij,C0,h1psi0)

C        now printing...
         call print_matrix(c0h0c0_ij,NSTATE,NSTATE,'c0h0c0_ij ')
 
C        overlap matrix
         call ovlap(nstate,W0_Sij,C0,C0)

C        now printing...
         call print_matrix(W0_Sij,NSTATE,NSTATE,'W0_Sij    ')

C        calculating inverse_of_S...
!$OMP parallel do private(i,j)
         DO i=1,NSTATE
            DO j=1,NSTATE
            inverse_of_S(i,j)=DBLE(2*IDelta(i-j))-W0_Sij(i,j)
            ENDDO
         ENDDO

C        now printing...
         call print_matrix(inverse_of_S,NSTATE,NSTATE,'inv of S  ')

C        calculating energy...
         CALL DGEMM('N','N',NSTATE,NSTATE,NSTATE,1.D0,c0h0c0_ij,
     $           NSTATE,inverse_of_S,NSTATE,0.D0,Emat,NSTATE)
     
C        now printing...
         call print_matrix(Emat,NSTATE,NSTATE,'Emat      ')

C        filling up Z packed matrix for diagonalisation
         k=1
         DO i=1,NSTATE
            DO j=i,NSTATE
               Z(k)=Emat(i,j)
               k=k+1
            ENDDO
         ENDDO

C        Diagonalising Z matrix 
         CALL DSPEVY(1,Z,eigenval,eigenvecs,NSTATE,NSTATE,work,3*NSTATE)

         E_total=0
C        printing eigenval and eigenvecs
         write(6,*) 'Eigenvalues + eigenvecs'
         write(6,FMT='(A7,A10,10(1X,I12))') 'ISTATE',' EIGENVAL',
     $       (j,j=1,NSTATE)
         DO i=1,NSTATE
            write(6,FMT='(I7,F10.6,10(1X,F12.6))') i,
     $      eigenval(i),
     $      (eigenvecs(i,j),j=1,NSTATE)
         E_total=E_total-eigenval(i)
         enddo

         write(6,*) 'Total energy (band energy) =',E_total
      return
      ENDIF
c     ==--------------------------------------------------------------==

      CALL MEMORY_CHECK
      CALL LAG_MULT(c0,h1psi0,psi,scr,lscr,rhoe,z11,nstate)
c     if (parent) 
c    &    print *,'interact: <W0_i| H0 |W0_j> = ',
c    &    (z11(i,i),i=1,nstate)
c     ==--------------------------------------------------------------==
      if (parent) write (6,98)
      call tiset('PSI1-WF-OPT',isub2)
      call rwfopt_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &              eirop,eivps,dummy,h1psi0,z11,nstate,dummy)
      call tihalt('PSI1-WF-OPT',isub2)
      timetag='calculation of psi^1.'

c     ==-END OF PT CALCULATION----------------------------------------==
C     ETOT contains the perturbed energy from rwfopt_p

C     Calculating the total energy using the functional
      Efunct=E0+ETOT
      IF (BPTSCFIter.GT.1) then
         write(6,*) 'TOTAL ENERGY at step 1 (functional) =',Efunct
      else
         write(6,*) 'TOTAL ENERGY (functional) =',Efunct
      endif

C     NOW, c1 contains the response orbitals. ANALYSE THEM:

C     Saving the perturbed density, W0, and rho0 if we don t do SCF
      IF (BPTSCFIter.LE.1) THEN
         call print_orbital_resp_dens_manno(C0,C1,NSTATE,PSI,SCR)
      ENDIF

C     if there is no further work to do, add PT + calc energy
      IF (.NOT.CUTOFF_TRICK) THEN
         call DCOPY(2*ngw*nstate,C0,1,C0plusC1,1)
      
C        Now adding the perturbation (C1) to C0plusC1
         call DAXPY(2*ngw*nstate,1d0,C1,1,C0plusC1,1)

         IF (BPTSCFIter.LE.1) THEN
C           Total energy of the non-orthogonalised W0+W1 if we don t do SCF
            call forces(c0plusC1,h1psi0,tau0,FION,RHOE,PSI,
     $               SCR,LSCR,NSTATE,1,.false.,.false.)
            if (parent) then
              write(6,*)
              print *,'TOTAL   ENERGY of W0+W1: ',ETOT,' A.U.'
              write(6,*)
              print *,'***** ENERGY DECOMPOSITION *****'
              print *,'EKIN  (    W0+W1)= ',EKIN,' A.U.'
              print *,'EHT   (    W0+W1)= ',EHT,' A.U.'
              print *,'EPSEU (    W0+W1)= ',EPSEU,' A.U.'
              print *,'ENL   (    W0+W1)= ',ENL,' A.U.'
              print *,'EXC   (    W0+W1)= ',EXC,' A.U.'
              print *,'------------------'
              print *,'ETOT  (    W0+W1)= ',ETOT,' A.U.'
              write(6,*)
            endif
         ENDIF

C        orthogonalising the (w0+w1) states
         CALL Ortho_My_Wannier(NSTATE,C0plusC1)

C        Now calculating the total energy of the orthogonalised w0+w1

         call forces(c0plusC1,h1psi0,tau0,FION,RHOE,PSI,
     $               SCR,LSCR,NSTATE,1,.true.,.false.)
         if (parent) then
           write(6,*)
           IF (CUTOFF_RESTR) THEN
              WRITE(6,*) 'PT-CUTOFF = ',MY_ECUT
           ENDIF
           IF (BPTSCFIter.GT.1) THEN
              WRITE(6,*) '*-=> SCF-PT STEP 1 <=-*'
           ENDIF
           print *,'TOTAL   ENERGY of orthog. W0+W1: ',
     $         ETOT,' A.U.'
           write(6,*)
           write(6,*) 'Efunct-EKS =',Efunct-ETOT
           write(6,*)
           print *,'***** ENERGY DECOMPOSITION *****'
           print *,'EKIN  (ort.W0+W1)= ',EKIN,' A.U.'
           print *,'EHT   (ort.W0+W1)= ',EHT,' A.U.'
           print *,'EPSEU (ort.W0+W1)= ',EPSEU,' A.U.'
           print *,'ENL   (ort.W0+W1)= ',ENL,' A.U.'
           print *,'EXC   (ort.W0+W1)= ',EXC,' A.U.'
           print *,'------------------'
           print *,'ETOT  (ort.W0+W1)= ',ETOT,' A.U.'
           write(6,*)
         endif

C        Calculate convergence criteria
         CALL CSIZE(h1psi0,NSTATE,scf_gemax,scf_cnorm)
         if (parent) then
            time2 = timef()
            tcpu = (time2 - time1)*0.001d0
            write(6,'(a,E10.4,a,E10.4,a,f8.2,a)') 
     $           '  1: Gemax =',scf_gemax,
     $           ' Cnorm =',scf_cnorm,' Time: ',tcpu,' seconds'
         endif

C  ------temporary.... for charge calc..
c write(6,*) 'SAVING restart for orthog W0+W1'
c        SWF     = .TRUE.
c CALL WRITE_IREC(IREC)
c        CALL ZHWWF(2,IREC,C0plusC1,h1psi0,NSTATE,scr,
c    $              TAU0,VELP,TAUP,NFI)
c write(6,*) 'DONE'
C  ------temporary.... for charge calc..

C        Do we need SCF iterations?
         IF (BPTSCFIter.GT.1) THEN
C           saving the original C0
            call DCOPY(2*ngw*nstate,C0,1,originalC0,1)
C           copying C1 from the first cycle
c           call DCOPY(2*ngw*nstate,C1,1,sumC1,1)
C --------- START OF SCF cycles ------------------
            DO ISCF_step=2,BPTSCFIter
C              Are we converged ?
               if (scf_gemax.lt.SCF_TOL) then
               write(6,*) 'Tolerance reached...',scf_gemax
               goto 100
               endif

C              initialise timer
               time1 = timef()

C              storing the last Etot
               Last_Etot=ETOT
C              Storing the value of E(0)
               E0=ETOT

C              copying C0+C1 to C0...
               call DCOPY(2*ngw*nstate,C0plusC1,1,C0,1)

C   ---------- START OF PT CALC ------------------------------
C              initialisation
               call rhoofr(c0,rho0,psi,scr,lscr,nstate)
               call DCOPY(nnr1, rho0, 1, vofrho0, 1)
               call vofrho(tau0,fion,vofrho0,psi,scr,lscr,
     $                     .false.,.false.)

C              Lagrange multipliers
               CALL MEMORY_CHECK
               CALL LAG_MULT(c0,h1psi0,psi,scr,lscr,rhoe,z11,nstate)

C              Optimisation of W1
               if (parent) write (6,98)
               call tiset('PSI1-WF-OPT',isub2)
               call rwfopt_p(c0,c1,psi,rhoe,drhoe,scr,lscr,eirop,eivps,
     $                       dummy,h1psi0,z11,nstate,dummy)
               call tihalt('PSI1-WF-OPT',isub2)
               timetag='calculation of psi^1.'
C   ---------- END OF PT CALC ------------------------------

C              Is there no interaction force?
               if (TNORESPONSE) then
                  write(6,*) 'NEGLIGIBLE RESPONSE...'
                  goto 100
               endif

C              Calculating the total energy using the functional
               Efunct=E0+ETOT
               if (parent) then
                 write(6,*)
                 write(6,*) '*-=> SCF-PT STEP',ISCF_step,'<=-*'
                 write(6,*) 'TOTAL ENERGY at step',ISCF_step,
     $                    '(functional) =',Efunct
               endif

C              copying C0 to C0plusC1
               call DCOPY(2*ngw*nstate,C0,1,C0plusC1,1)

C              Now adding the perturbation (C1) to C0plusC1
               call DAXPY(2*ngw*nstate,1d0,C1,1,C0plusC1,1)

C              Adding the perturbation to the previous C1
c              call DAXPY(2*ngw*nstate,1d0,C1,1,sumC1,1)

C              orthogonalising c0+c1 (C1 here is a scratch)
               CALL LOWDIN(C0plusC1,C1,SCR,LSCR,NSTATE)

C              Now calculating the total energy of the orthogonalised w0+w1
               call forces(c0plusC1,h1psi0,tau0,FION,RHOE,PSI,
     $                     SCR,LSCR,NSTATE,1,.true.,.false.)
               if (parent) then
                 print *,'TOTAL ENERGY of orthog. W0+W1 at step',
     $                   ISCF_step,' : ',ETOT,' A.U.'
                 write(6,*) 'Ediff E(',ISCF_step,')-E(',ISCF_step-1,
     $                      '): ',ETOT-Last_Etot,' A.U.'
                 write(6,*) 'Efunct-EKS =',Efunct-ETOT
                 write(6,*)
               endif

C              Calculate convergence criteria
               CALL CSIZE(h1psi0,NSTATE,scf_gemax,scf_cnorm)
               if (parent) then
                  time2 = timef()
                  tcpu = (time2 - time1)*0.001d0
                  write(6,'(i3,a,E10.4,a,E10.4,a,f8.2,a)') ISCF_STEP,
     $                  ': Gemax =',scf_gemax,
     $                  ' Cnorm =',scf_cnorm,' Time: ',tcpu,' seconds'
                 write(6,*)
               endif
            ENDDO
C --------- END OF SCF cycles ------------------
C We have exhausted all the SCF cycles without convergence...
      if(parent.and.scf_gemax.gt.SCF_TOL) then
        write(6,'(1x,64("!"))')
        write(6,'(" !!",a,t64,"!!")')
     &       '   SCF-PT| the maximum number of SCF step is reached'
        write(6,'(" !!",a,f10.6,a,t64,"!!")')
     &       '         but no convergence (d E / d psi =',scf_gemax,')'
        write(6,'(1x,64("!"))')
      endif

C We are converged: save and finish
  100 continue

C     Saving the final perturbed density and the W0
c     call print_orbital_resp_dens_manno(originalC0,sumC1,NSTATE,
c    $                                  PSI,SCR)
CTESTTESTTEST
c              call DCOPY(2*ngw*nstate,originalC0,1,C0plusC1,1)
c              call DAXPY(2*ngw*nstate,1d0,sumC1,1,C0plusC1,1)
c              CALL Ortho_My_Wannier(NSTATE,C0plusC1)

c              call forces(c0plusC1,h1psi0,tau0,FION,RHOE,PSI,
c    $                     SCR,LSCR,NSTATE,1,.false.,.false.)
c              if (parent) then
c                write(6,*)
c                write(6,*) 'TEST....'
c                print *,'TOTAL   ENERGY of orthog. W0+W1: ',
c    $               ETOT,' A.U.'
c                write(6,*) 'Ediff: ',ETOT-Last_Etot,' A.U.'
c              endif
CTESTTESTTEST
         ENDIF 
      ELSE
C     ===== CUTOFF LOWERING EXPERIMENT !!! =====
C        copying C1 in a temporary location 
         call DCOPY(2*ngw*nstate,C1,1,tempC1,1)
         DO j=1,6
C           copying C0 to C0plusC1
            call DCOPY(2*ngw*nstate,C0,1,C0plusC1,1)
      
C           defining the new cutoff and finding the corresponding G vector
            My_New_Gcut = (ECUT-10.D0*DBLE(j-1))/TPIBA2
            DO i=1,NGW
               IF (HG(i).LE.My_New_Gcut) THEN
                  New_NGW=i
               ENDIF
            ENDDO
C           checking if G=0 is selected + correcting
            IF (New_NGW.EQ.1) THEN
               New_NGW=0
            ENDIF
 
            if (parent) then
              write(6,*) 'original ECUT = ',ECUT
              write(6,*) 'new_ECUT = ',ECUT-10.D0*DBLE(j-1)
              write(6,*) 'My_New_Cut = ',My_New_Gcut
              write(6,*) 'new NGW = ',New_NGW
            endif

C           Copying from tempC1 to C1....
            call DCOPY(2*ngw*nstate,tempC1,1,C1,1)
C           Zeroing the coefficients of C1 above the cutoff energy for each state
            DO istate=1,NSTATE
               DO i=New_NGW+1,NGW
                  C1(i,istate)=0.D0
               ENDDO
            ENDDO

C           Now adding the perturbation (C1) to C0plusC1
            call DAXPY(2*ngw*nstate,1d0,C1,1,C0plusC1,1)

C           Total energy of the non-orthogonalised W0+W1
            call forces(c0plusC1,h1psi0,tau0,FION,RHOE,PSI,
     $                  SCR,LSCR,NSTATE,1,.false.,.false.)
            if (parent)  then
              write(6,*)
              print *,'TOTAL   ENERGY of W0+W1: ',ETOT,' A.U.'
              print *,'KINETIC ENERGY of W0+W1: ',EKIN,' A.U.'
              print *,'HARTREE ENERGY of W0+W1: ',EHT,' A.U.'
              write(6,*)
            endif

C           orthogonalising the (w0+w1) states
            CALL Ortho_My_Wannier(NSTATE,C0plusC1)

C           Now calculating the total energy of w0+w1

            call forces(c0plusC1,h1psi0,tau0,FION,RHOE,PSI,
     $                  SCR,LSCR,NSTATE,1,.false.,.false.)
            if (parent) then
              write(6,*)
              print *,'TOTAL   ENERGY of orthog. W0+W1: ',
     $            ETOT,' A.U.'
              print *,'KINETIC ENERGY of orthog. W0+W1: ',
     $            EKIN,' A.U.'
              print *,'HARTREE ENERGY of orthog. W0+W1: ',
     $            EHT,' A.U.'
              write(6,*)

C           Printing a summary...
              write(6,*) 'SUM Ecut',ECUT-10.D0*DBLE(j-1),
     $            '-> Etot =',ETOT 
            endif

C        end of Cutoff loop...
         ENDDO
C     ===== END OF CUTOFF LOWERING EXPERIMENT !!! =====
      ENDIF 

C     Saving the necessary data for Aldo s program..
c     write(6,*) 'Saving the resulting orbitals ',
c    $ '(W0+W1) to disk'

c     CALL Save_Aldo_Wannier(C0plusC1,NSTATE)

c     write(6,*) 'Done!'
C     END of file saving part...

C     Calculating the WF profile
c     write(6,*) 'calculating+ saving total wf profile'
c     CALL PROFILE_WAN(C0plusC1,..,nstate)
c     write(6,*) 'done'

C     calculating the dipole moment+WC''s
      CALL calc_my_wannier_centre(C0plusC1,NSTATE,CENTRE)

c     ==--------------------------------------------------------------==

      if (parent) then
        write (6,98)
        write (6,99)
        write (6,98)
      endif

c     ==--------------------------------------------------------------==
      call tihalt('   PTINTER',isub)

C     DE-allocating the arrays....
      CALL FREEM(IP_h1psi0)
      CALL FREEM(IP_C0plusC1)
      IF (CUTOFF_TRICK) THEN
         CALL FREEM(IP_tempC1)
      ENDIF
      IF (BPTSCFIter.GT.1) THEN
C        SCF arrays...
         CALL FREEM(IP_originalC0)
         CALL FREEM(IP_sumC1)
      ENDIF
C     overlap matrix..
      IF (.NOT.TORTHOG_WANNIER) THEN
         CALL FREEM(IP_W0_Sij)
         CALL FREEM(IP_c0h0c0_ij)
         CALL FREEM(IP_Emat)
      ENDIF
      return
      end
c     ==================================================================
      subroutine print_orbital_resp_dens_manno(c0,c1,nstate,psi,scr)
C     ==--------------------------------------------------------------==`
C     Subroutine to save the perturbed DENSITY
C     (2 W0W1 -> rho1), the starting
C     orthogonalised wannier functions (W0 -> psi0)
C     and its corresponding density (rho0 = W0*W0)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cppt.inc'
      include 'coor.inc'
      include 'cnst.inc'
      include 'fft.inc'
      integer    is,ir,nstate,numstates
      complex*16 c0(ngw,nstate),c1(ngw,nstate)
      real*8     scr(nnr1,2),psi(nnr1,2)
      character*80  filename
      character*2  zahlenchars(99)
      REAL*8  sum_C0,sum_C0C1
      data zahlenchars /'01','02','03','04','05','06','07','08','09',
     &     '10','11','12','13','14','15','16','17','18','19',
     &     '20','21','22','23','24','25','26','27','28','29',
     &     '30','31','32','33','34','35','36','37','38','39',
     &     '40','41','42','43','44','45','46','47','48','49',
     &     '50','51','52','53','54','55','56','57','58','59',
     &     '60','61','62','63','64','65','66','67','68','69',
     &     '70','71','72','73','74','75','76','77','78','79',
     &     '80','81','82','83','84','85','86','87','88','89',
     &     '90','91','92','93','94','95','96','97','98','99' /

      numstates = nstate
      if (nstate .gt. 50) then
        if (parent) write (6,*) 
     &      ' PRINT RHO0: TOO MANY STATES. PRINTING ONLY 1..50.'
        numstates = 50
      endif

      do is=1,numstates
C       saving the perturbed density (2W0W1)
        call fft2TOr(c0(1,is),psi(1,1),
     &      c1(1,is),psi(1,2),scr,ngw,.false.)

        sum_C0=0.D0
        sum_C0C1=0.D0

        do ir=1,nnr1
          scr(ir,1)  =  psi(ir,1)*psi(ir,2)*2d0
          sum_C0=sum_C0+psi(ir,1)*psi(ir,1)
          IF(scr(ir,1).GT.0) sum_C0C1=sum_C0C1+scr(ir,1)
        enddo

C       write(6,*) 'sum_C0 =',sum_C0
C       write(6,*) 'sum_C0C1 =',sum_C0C1

        if (parent) 
     $      write(6,FMT='(1X,A,I3,A,F8.5,A)') 'STATE',is,' contributes',
     $      100*(sum_C0C1/DBLE(NSTATE*sum_C0)),
     $      '% of charge displacement'

            call fftTOg(scr(1,1),scr(1,1),psi,nhg,.true.)
C           Is the norm of the perturbed density equal to zero?
            IF (DABS(DBLE(scr(1,1))).GT.1.D-13) THEN
            if (parent) 
     $          write(6,*) 'WARNING: R-Norm of state',is,
     $                '[n1(g=0)] =',scr(1,1),'!= 0'
        ENDIF
        filename = 'rho1-'//zahlenchars(is)//'.dens'
        call densto(scr(1,1),tau0,filename)

C       saving the starting wannier orbitals (W0)
        call azzero(psi,2*maxfft)
        call DCOPY(2*ngw,c0(1,is),1,psi,1)
        filename = 'psi0-'//zahlenchars(is)//'.wf'
        call densto(psi,tau0,filename)

C       saving the starting wannier density (rho0)
C       G to R space
        call fftTOr(c0(1,is),psi(1,1),scr,ngw,.false.)

C       calculate the square
!$OMP parallel do private(ir)
        DO ir=1,nnr1
          scr(ir,1)=psi(ir,1)*psi(ir,1)
        ENDDO

C       R to G space
        call fftTOg(scr(1,1),scr(1,1),psi,nhg,.true.)

C       Save rho0
        filename = 'rho0-'//zahlenchars(is)//'.dens'
        call densto(scr(1,1),tau0,filename)
      enddo

      return
      END
C     ==================================================================
      SUBROUTINE Save_Aldo_Wannier(c0,NSTATE)
C     ==--------------------------------------------------------------==
C     Subroutine to save the resulting WF to use
C     with Aldo s program (Wannier profiles)
C     FORMAT: one file per state
C     NGW
C     C0(Gvec,state)
C     ==--------------------------------------------------------------==
      implicit none

C     Including the "essential" variables...
      include 'system.h'
      include 'cppt.inc'
      include 'fileopen.inc'

C     so from now on NGW is the number of plane waves, GK(3,NGW) is the array
C     of G vectors, HG(NGW) is the array containing the square of the norm of
C     each G vector. (according to Daniel...)

      INTEGER NSTATE
      COMPLEX*16 c0(ngw,nstate)

      INTEGER Gindx,istate,IA,IE
      LOGICAL FERROR
      CHARACTER NAME*20,number*8

#ifdef PARALLEL
      call stopgm('INTERACTION_P','SAVE-ALDO-WANNIER not parallel.')
#endif

C     main loop on the states...
      DO istate=1,NSTATE

C        First creating the file name for the state istate
         write(number,'(I8)')istate
C        removing the spaces before and after the number (CPMD routine)
         CALL XSTRING(number,IA,IE)

         NAME='WANNIER-'//number(IA:IE)
         write(6,*) 'opening file: ',name

C     opening the file to save to
         CALL FILEOPEN(500,NAME,FO_DEF,FERROR)
C     number of G vectors
         write(500,*) NGW

C     now writing the coefficients (c0) (g-space,ascii)
         DO Gindx=1,NGW
           write(500,*) C0(Gindx,istate)
         ENDDO

C     Closing the file...
         CALL FILECLOSE(500)
      ENDDO

      return
      END
C     ==================================================================
      SUBROUTINE Save_norm(c0,NSTATE)
C     ==--------------------------------------------------------------==
      implicit none

C     Including the "essential" variables...
      include 'system.h'
      include 'cppt.inc'
      include 'fileopen.inc'

C     so from now on NGW is the number of plane waves, GK(3,NGW) is the array
C     of G vectors, HG(NGW) is the array containing the square of the norm of
C     each G vector. (according to Daniel...)

      INTEGER NSTATE
      COMPLEX*16 c0(ngw,nstate)

      INTEGER Gindx,istate,IA,IE
      LOGICAL FERROR
      CHARACTER NAME*20,number*8

#ifdef PARALLEL
      call stopgm('INTERACTION_P','SAVE-NORM not parallel.')
#endif

C     main loop on the states...
      DO istate=1,NSTATE

C        First creating the file name for the state istate
         write(number,'(I8)')istate
C        removing the spaces before and after the number (CPMD routine)
         CALL XSTRING(number,IA,IE)

         NAME='norm-'//number(IA:IE)
         write(6,*) 'opening file: ',name

C     opening the file to save to
         CALL FILEOPEN(500,NAME,FO_DEF,FERROR)
         write(6,*) 'Saving data...'
   
C     now writing the coefficients (c0) (g-space,ascii)
         DO Gindx=1,NGW
           write(500,*) DREAL(C0(Gindx,istate)*DCONJG(C0(Gindx,istate)))
         ENDDO

C     Closing the file...
         CALL FILECLOSE(500)
      ENDDO

      return
      end
C     ==================================================================
      INTEGER FUNCTION get_new_NGW(MY_ECUT)
C     ==--------------------------------------------------------------==
C     This function returns the higest possible G vector index (<=NGW)
C     for a given cutoff energy in Rydberg (<=ECUT)
C     ==--------------------------------------------------------------==
      implicit none
      REAL*8  MY_ECUT

C     Including the "essential" variables...
      include 'system.h'
      include 'cppt.inc'
C     so from now on NGW is the number of plane waves, GK(3,NGW) is the array
C     of G vectors, HG(NGW) is the array containing the square of the norm of
C     each G vector. (according to Daniel...)

      INTEGER Gindx,New_NGW
      REAL*8  My_New_Gcut

C     Checking if the cutoff energy is valid
      if (MY_ECUT.GT.ECUT) THEN
         write(6,*) 'INVALID CUTOFF (>ECUT), returning NGW'
         get_new_NGW=NGW
         RETURN
      ENDIF

C     defining the new cutoff 
      My_New_Gcut = MY_ECUT/TPIBA2
      
C     finding the corresponding G vector
      DO Gindx=1,NGW
         IF (HG(Gindx).LE.My_New_Gcut) THEN
            New_NGW=Gindx
         ENDIF
      ENDDO

C     checking if G=0 is selected + correcting
      IF (New_NGW.EQ.1) THEN
         New_NGW=0
      ENDIF

C     Assigning the result + exiting..
      get_new_NGW=New_NGW

      RETURN
      END
c     ==================================================================
      SUBROUTINE calc_my_wannier_centre(C0,NSTATE,CENTRE)
C     ==--------------------------------------------------------------==
      implicit none

C     Including the "essential" variables...
      include 'system.h'
      include 'cppt.inc'
C     so from now on NGW is the number of plane waves, GK(3,NGW) is the array
C     of G vectors, HG(NGW) is the array containing the square of the norm of
C     each G vector. (according to Daniel...)

      include 'prop.inc'
      include 'cnst.inc'
      include 'ddip.inc'
      include 'isos.inc'
      include 'wann.inc'
      include 'coor.inc'
      include 'store.inc'
      include 'ropt.inc'
      INCLUDE 'elct.inc'
      include 'ener.inc'
      include 'fft.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'sfac.inc'
 
C     input
      INTEGER NSTATE
      complex*16 c0(ngw,nstate)
      REAL*8  CENTRE(4,nstate)

C     variables
      COMPLEX*16 XYZMAT(nstate,NSTATE,*)
      POINTER (IP_XYZMAT,XYZMAT)
      CHARACTER TAG*30      

      INTEGER    I,LSCR,LFORCES
      INTEGER    DD1,DD2,DD3,DDX,NMCOL,IP1,IP2,LSCR2

      INTEGER    MAPFUL(*),MAPCOL(*)
      POINTER    (IP_MAPFUL,MAPFUL),(IP_MAPCOL,MAPCOL)
      REAL*8     SCR(*),fnl,dfnl
      POINTER    (IP_SCR,SCR)

      COMPLEX*16 CS(NGW,*),SC0(NGWS,*)
      POINTER    (IP_CS,CS),(IP_SC0,SC0)
 

C     Wannier centre calculation from Aldo (orth_wannier.F)
      CALL MEMORY(IP_CS,2*NGW*nstate,'CS')

c     first the XYZMAT needs to be calculated
      CALL GIVE_SCR_DDIPO(LSCR2,TAG)
      CALL GIVE_SCR_FORCES(LFORCES,TAG,nstate,.FALSE.,.FALSE.)
      write(6,*) 'Dimensions = ',lscr2,lforces
      LSCR=MAX(LSCR2,LFORCES)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
#ifdef PARALLEL
      NMCOL=(nproc*ngwmax)/irat+1
#else
      NMCOL=1
#endif
      CALL MEMORY(IP_MAPFUL,2*(NGWS/IRAT+1),'MAPFUL')
      CALL MEMORY(IP_SC0,2*NGWS*nstate,'SC0')
      CALL MEMORY(IP_MAPCOL,NMCOL,'MAPCOL')
      CALL SETDIP(MAPFUL,MAPCOL,SCR,LSCR)
      CALL SET_OPERATOR(.TRUE.)
      CALL MEMORY(IP_XYZMAT,2*nstate*NSTATE*NWANOPT,'XYZMAT')

      IP1=1
      IP2=1+2*nstate*NSTATE
      LSCR2=LSCR-IP2

      write(6,*) 'ENTERING TO OPEIGR'
      CALL OPEIGR(C0,CS,SC0,nstate,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,1,0,DD1)

      write(6,*) 'ENTERING TO COPY'
      CALL DCOPY(2*nstate*NSTATE,SCR(IP1),1,XYZMAT(1,1,1),1)

      write(6,*) 'ENTERING TO OPEIGR'
      CALL OPEIGR(C0,CS,SC0,nstate,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,2,0,DD2)

      write(6,*) 'ENTERING TO COPY'
      CALL DCOPY(2*nstate*NSTATE,SCR(IP1),1,XYZMAT(1,1,2),1)

      write(6,*) 'ENTERING TO OPEIGR'
      CALL OPEIGR(C0,CS,SC0,nstate,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,3,0,DD3)

      write(6,*) 'ENTERING TO COPY'
      CALL DCOPY(2*nstate*NSTATE,SCR(IP1),1,XYZMAT(1,1,3),1)

      DO I=4,NWANOPT
         CALL OPEIGR(C0,CS,SC0,nstate,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,IOW(1,I-3),IOW(2,I-3),DDX)
         CALL DCOPY(2*nstate*NSTATE,SCR(IP1),1,XYZMAT(1,1,I),1)
      ENDDO

c     then WC''s are calculated
c     are you sure that TAU0 are the correct current coordinates?

      CALL WANNIER_CENTER(XYZMAT,nstate,NSTATE,CENTRE,TAU0)

      print*,'Wannier centers properly generated'

      return
      END
c     ==================================================================
      SUBROUTINE print_matrix(A,d1,d2,title)
C     ==--------------------------------------------------------------==
C     Prints out the matrix A(d1,d2) and its name (max 10 character!!)
      implicit none
C     Including the "essential" variables...
      include 'system.h'
      include 'cppt.inc'
C     so from now on NGW is the number of plane waves, GK(3,NGW) is the array
C     of G vectors, HG(NGW) is the array containing the square of the norm of
C     each G vector. (according to Daniel...)

      INTEGER d1,d2
      REAL*8  A(d1,d2)
      CHARACTER title*10    

      INTEGER i,j

      IF (PARENT) THEN
         write(6,*) 
         write(6,*) title
         write(6,FMT='(A7,11(1X,I12))') 'ISTATE',(j,j=1,d2)
         DO i=1,d1
            write(6,FMT='(I7,11(1X,F12.6))') i,(A(i,j),j=1,d2)
         enddo
         write(6,*) 
      ENDIF

      return
      END
c     ==================================================================
