C     ==================================================================
      subroutine interaction_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &        eirop,eivps,z11,nstate)
c     ==================================================================
C     PARALLEL
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'response_p.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'wann.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'store.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'atwf.inc'        !CATOM ZXMAT XXMAT
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'kpnt.inc'        !WK
      INCLUDE 'tpar.inc'        !dt2bye
c     ==--------------------------------------------------------------==
c     Arguments
      integer    nstate,lscr
      complex*16 c0(ngw,nstate),psi(*),eirop(nhg),eivps(nhg)
      complex*16 c1(ngw,nstate)
      real*8     z11(nstate,nstate),scr(2*maxfft,*),
     &           rhoe(*),drhoe(*)
C     Common variables
      real*8     FNL(*),DFNL(*)
c     ==--------------------------------------------------------------==
c     Local variables
      complex*16 h1psi0(ngw,nstate)
      POINTER (IP_h1psi0,h1psi0)
      integer    isub,isub2,is,msglen,ISCF_step
#ifdef PARALLEL
      integer NXXFUN
      external NXXFUN
#endif
      real*8     dummy
C     vector containing the final result (C0+C1)
      complex*16 C0plusC1(NGW,NSTATE)
      POINTER (IP_C0plusC1,C0plusC1)
C     tmp C1 vector for cutoff changes...
      complex*16 tempC1(NGW,NSTATE)
      POINTER (IP_tempC1,tempC1)
C     Copy of the original C0 vector for SCF calculations
      complex*16 originalC0(NGW,NSTATE)
      POINTER (IP_originalC0,originalC0)
C     Accumulated C1 vector for SCF calc.
      complex*16 sumC1(NGW,NSTATE)
      POINTER (IP_sumC1,sumC1)
      real*8 E0,Efunct,sum_mono
      CHARACTER NAME*20
      REAL*8  Last_Etot
C     Scratch arrays for the localisation
      complex*16 cs(NGW,NSTATE)
      POINTER (IP_CS,CS)
      complex*16 SCT(NGW,NSTATE)
      POINTER (IP_SCT,SCT)
      INTEGER NC,irec(100)

C     Convergence variables for SCF calculations
      REAL*8  scf_gemax,scf_cnorm
      REAL*8  timef,time1,time2,tcpu
      EXTERNAL timef

C     temporary: atomic wf for orthogonalisation
      complex*16 CATTMP
      POINTER (IP_CATTMP,CATTMP)

 99   FORMAT ("*  Calculation of responses DONE.",31X,"*")
 98   FORMAT (47("*"),"PT-INTER*RESPONSE*")
c     ==--------------------------------------------------------------==
      call tiset('   PTINTER',isub)
      timetag=' '
      PR_ENERGY = .true. 

C     Allocating memory
      CALL MEMORY(IP_h1psi0,2*NGW*NSTATE,'h1psi0')
      CALL MEMORY(IP_C0plusC1,2*NGW*NSTATE,'C0plusC1')
      CALL MEMORY(IP_EMONO,NMOL,'EMONO')

      IF (BPTSCFIter.GT.1) THEN
C        SCF arrays...
         CALL MEMORY(IP_originalC0,2*NGW*NSTATE,'originalC0')
         CALL MEMORY(IP_sumC1,2*NGW*NSTATE,'sumC1')
      ENDIF
c     ==--------------------------------------------------------------==
      if (parent) CALL PRMEM('  PT-INTER')
c     ==--------------------------------------------------------------==
C     If we use atomic wavefunction then ititialise it..
      if (TATOMICWAVEFUNCTION) then
         if (parent) 
     &      write(6,*) 'Initialising ATOMIC WAVEFUNCTION for W0'

         call ATOMWF(C0,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
         if (parent) 
     &      write(6,*) 'DONE...'
      endif
      
C     Localisation of the wavefunction if we re not loading from disk
      if (TLOCALIZE.AND..NOT.WANN_LOAD) then
        if(parent) write(6,*) 'LOCALISING THE KS ORBITALS...'
        TWANN=.true.
        LOCL=.true.
        NUMORB=MAX(NUMORB,NSTATE)
        NC=2*NGWK*NUMORB
#ifdef PARALLEL
        LENBK=NXXFUN(NUMORB)
        NC=MAX(2*LENBK*NPROC,NC)
#endif
        CALL MEMORY(IP_SCT,NC,'SCT/tmp   ')
        CALL MEMORY(IP_CS,NC,'CS/tmp   ')
        CALL LOCALIZE(TAU0,C0,CS,SCT,SCR,LSCR,NSTATE)
        CALL EICALC(eivps,eirop)

C       freeing memory
        CALL FREEM(IP_SCT)
        CALL FREEM(IP_CS)
        if(parent) write(6,*) 'Done'
      endif

C     End of localisation

      IF (BPTSCFIter.GT.1 .AND. PARENT) THEN
         write(6,*) '---------- SELF-CONSISTENT PT ----------'
         write(6,*) '----- PERFORMING',BPTSCFIter,'SCF iterations -----'
         write(6,FMT='(1X,A,E8.3,A)') '----- SCF-PT CONVERGENCE: ',
     $                             SCF_TOL,' -----'
         write(6,*) '----------------------------------------'
      ENDIF
c     ==--------------------------------------------------------------==
C     If we are not using an atomic wavefunction then use wannier functions...
      if (.NOT.TATOMICWAVEFUNCTION) then
C        LOAD THE ORBITALS FROM DATABASE into c0
         if (parent) 
     &      write(6,*) 'Initialising the Wannier orbitals (W0)'

C     Use the parallel version instead... has no rotations though
         call RotateMyWannier_para(NSTATE,C0,lscr,scr,psi)
      
         if (parent) 
     &      write(6,*) 'Wannier orbitals are now initialised'
      ENDIF

C     Were we saving a WF? if yes then EXIT
      IF (WANN_SAVE) THEN
         if (parent) then 
            write(6,*) 'WANNIER FUNCTION SAVING OPTION ENABLED'
            write(6,*) 'PROGRAM TERMINATES HERE....'
         endif
         call tihalt('   PTINTER',isub)

C        DE-allocating the arrays....
         CALL FREEM(IP_h1psi0)
         CALL FREEM(IP_C0plusC1)
         IF (CUTOFF_TRICK) THEN
            CALL FREEM(IP_tempC1)
         ENDIF
         IF (BPTSCFIter.GT.1) THEN
C           SCF arrays...
            CALL FREEM(IP_originalC0)
            CALL FREEM(IP_sumC1)
         ENDIF
         RETURN
      ENDIF 
      
C  ---saving the starting guess made of localised wf
      IF (SAVE_LOCALISED_W0) THEN
         if(parent) 
     &     write(6,*) 'SAVING RESTART FOR ORTHOGONALISED W0'
         SWF     = .TRUE.
         CALL WRITE_IREC(IREC)
         CALL ZHWWF(2,IREC,C0,h1psi0,NSTATE,scr,
     $              TAU0,VELP,TAUP,NFI)
         if(parent) write(6,*) 'DONE'

C        OK, now we are done....
         if (parent) write(6,*) 'PROGRAM TERMINATES HERE....'
         call tihalt('   PTINTER',isub)

C        DE-allocating the arrays....
         CALL FREEM(IP_h1psi0)
         CALL FREEM(IP_C0plusC1)
         IF (CUTOFF_TRICK) THEN
            CALL FREEM(IP_tempC1)
         ENDIF
         IF (BPTSCFIter.GT.1) THEN
C           SCF arrays...
           CALL FREEM(IP_originalC0)
           CALL FREEM(IP_sumC1)
         ENDIF
         RETURN
      ENDIF
C  ---end of saving the starting guess made of localised wf

C     Calculate the sum of monomer energies on parent
      if (parent) then
         sum_mono=0.D0
         do is=1,nmol
            sum_mono=sum_mono+EMONO(is)
         enddo
      endif
C     ==-START OF PT CALCULATION--------------------------------------==
C     initialise timer
      time1 = timef()

C     and don t forget to update the constant gnd-state density and
C     Coulomb-potential arrays:

      if (TATOMICRHO) THEN
C        Here we use the atomic density as constant gnd state density
         if (parent) 
     &      write(6,*) 'Using atomic RHO0 instead of W0^2'

C        just allocate memory for the atomic WF...
         CALL MEMORY(IP_CATOM,2*NGWK*NATTOT,'CATOM')
         CALL MEMORY(IP_CATTMP,2*NGWK*NATTOT,'CATTMP')

C        Use the full atomic WF routine (to fix later...)
         call ATOMWF(CATTMP,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
C        generate the atomic density from the KS-atomic wf... 
         call rhoofr(CATTMP,rho0,psi,scr,lscr,NSTATE)
         if(ttau) call stopgm("interaction_p","no tau functionals")

         call DCOPY(nnr1, rho0, 1, vofrho0, 1)
         call vofrho(tau0,fion,vofrho0,psi,scr,lscr,.false.,.false.)

C        Free the atomic WF..
         CALL FREEM(IP_CATTMP)

         if (parent) write(6,*) 'Done...'
      else
C        Here the constant gnd state density is computed exactly
         call rhoofr(c0,rho0,psi,scr,lscr,nstate)
         call DCOPY(nnr1, rho0, 1, vofrho0, 1)
         call vofrho(tau0,fion,vofrho0,psi,scr,lscr,.false.,.false.)
      endif

C     saving the total density to disk.... if we don t do SCF
      IF (BPTSCFIter.LE.1) THEN
         call fftTOg(rho0,scr,psi,nhg,.false.)
         name='total.dens'
         call densto(scr,tau0,name)
      ENDIF

C     Total energy of the starting Wannier orbitals (W0)
      IF (TORTHOG_WANNIER) THEN
         call forces(c0,h1psi0,tau0,FION,RHOE,PSI,SCR,LSCR,
     &                  NSTATE,1,.false.,.false.)
         if (parent) then
            write(6,*)
            print *,'***** ENERGY DECOMPOSITION *****'
            print *,'EKIN  (       W0)= ',EKIN,' A.U.'
            print *,'EHT   (       W0)= ',EHT,' A.U.'
            print *,'EPSEU (       W0)= ',EPSEU,' A.U.'
            print *,'ENL   (       W0)= ',ENL,' A.U.'
            print *,'EXC   (       W0)= ',EXC,' A.U.'
            print *,'------------------'
            print *,'ETOT  (       W0)= ',ETOT,' A.U.'
            write(6,*)
         endif

C        Calculate convergence criteria on W0
         CALL CSIZE(h1psi0,NSTATE,scf_gemax,scf_cnorm)
         if (parent) then
            write(6,'(a,E10.4,a,E10.4)') 
     $           'INITIAL GRADIENT OF W0: Gemax = ',scf_gemax,
     $           ' Cnorm = ',scf_cnorm
         endif
      ENDIF

C     Storing the value of E(0)
      E0=ETOT

c     ==--------------------------------------------------------------==
      CALL MEMORY_CHECK
      CALL LAG_MULT(c0,h1psi0,psi,scr,lscr,rhoe,z11,nstate)
c     ==--------------------------------------------------------------==
      if (parent) write (6,98)
      call tiset('PSI1-WF-OPT',isub2)
      call rwfopt_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &              eirop,eivps,dummy,h1psi0,z11,nstate,dummy)
      call tihalt('PSI1-WF-OPT',isub2)
      timetag='calculation of psi^1.'

c     ==-END OF PT CALCULATION----------------------------------------==
C     ETOT contains the perturbed energy from rwfopt_p

C     Calculating the total energy using the functional
      Efunct=E0+ETOT
      if (BPTSCFIter.GT.1) then
         if (parent)
     $   write(6,*) 'TOTAL ENERGY at step 1 (functional) =',Efunct
      else
        if (parent) then
            write(6,*) 'TOTAL ENERGY (functional) =',Efunct
            write(6,*) 'Functional INTERACTION Energy =',
     $                      (Efunct-sum_mono)*1000,'mH'
            write(6,*)
         endif
      endif

C     NOW, c1 contains the response orbitals. ANALYSE THEM:

C     Saving the perturbed density, W0, and rho0 if we don t do SCF
      IF (BPTSCFIter.LE.1) THEN
         call print_orbital_resp_densities(C0,C1,NSTATE,PSI,SCR)
      ENDIF

      call DCOPY(2*ngw*nstate,C0,1,C0plusC1,1)
      
C     Now adding the perturbation (C1) to C0plusC1
      call DAXPY(2*ngw*nstate,1d0,C1,1,C0plusC1,1)

      IF (BPTSCFIter.LE.1) THEN
C        Total energy of the non-orthogonalised W0+W1 if we don t do SCF
         call forces(c0plusC1,h1psi0,tau0,FION,RHOE,PSI,
     $               SCR,LSCR,NSTATE,1,.false.,.false.)
         if (parent) then
              write(6,*)
              print *,'TOTAL   ENERGY of W0+W1: ',ETOT,' A.U.'
              write(6,*)
              print *,'***** ENERGY DECOMPOSITION *****'
              print *,'EKIN  (    W0+W1)= ',EKIN,' A.U.'
              print *,'EHT   (    W0+W1)= ',EHT,' A.U.'
              print *,'EPSEU (    W0+W1)= ',EPSEU,' A.U.'
              print *,'ENL   (    W0+W1)= ',ENL,' A.U.'
              print *,'EXC   (    W0+W1)= ',EXC,' A.U.'
              print *,'------------------'
              print *,'ETOT  (    W0+W1)= ',ETOT,' A.U.'
              write(6,*)
          endif
      ENDIF

C     orthogonalising the (w0+w1) states
C     Allocating scratch array (CS)
      CALL MEMORY(IP_CS,2*NGW*NSTATE,'CS/tmp   ')
C     Parallel Lowdin
      CALL LOWDIN(C0plusC1,CS,SCR,LSCR,NSTATE)
C     de-alloc CS
      CALL FREEM(IP_CS)

C     Now calculating the total energy of the orthogonalised w0+w1

      call forces(c0plusC1,h1psi0,tau0,FION,RHOE,PSI,
     $               SCR,LSCR,NSTATE,1,.true.,.false.)
      if (parent) then
           write(6,*)
           IF (BPTSCFIter.GT.1) THEN
              WRITE(6,*) '*-=> SCF-PT STEP 1 <=-*'
           ENDIF
           print *,'TOTAL   ENERGY of orthog. W0+W1: ',
     $         ETOT,' A.U.'
           write(6,*) 'INTERACTION Energy =',
     $                (ETOT-sum_mono)*1000,'mH ',
     $                 '(from orthog. W0+W1)'
           write(6,*)
           write(6,*) 'Efunct-EKS(orth.) =',(Efunct-ETOT)*1000,'mH'
           write(6,*)
           print *,'***** ENERGY DECOMPOSITION *****'
           print *,'EKIN  (ort.W0+W1)= ',EKIN,' A.U.'
           print *,'EHT   (ort.W0+W1)= ',EHT,' A.U.'
           print *,'EPSEU (ort.W0+W1)= ',EPSEU,' A.U.'
           print *,'ENL   (ort.W0+W1)= ',ENL,' A.U.'
           print *,'EXC   (ort.W0+W1)= ',EXC,' A.U.'
           print *,'------------------'
           print *,'ETOT  (ort.W0+W1)= ',ETOT,' A.U.'
           write(6,*)
      endif

C     Calculate convergence criteria
      CALL CSIZE(h1psi0,NSTATE,scf_gemax,scf_cnorm)
      if (parent) then
         time2 = timef()
         tcpu = (time2 - time1)*0.001d0
         write(6,'(a,E10.4,a,E10.4,a,f8.2,a)') 
     $           '  1: Gemax =',scf_gemax,
     $           ' Cnorm =',scf_cnorm,' Time: ',tcpu,' seconds'
      endif

C     Do we need SCF iterations?
      IF (BPTSCFIter.GT.1) THEN
C           saving the original C0
            call DCOPY(2*ngw*nstate,C0,1,originalC0,1)
C --------- START OF SCF cycles ------------------
            DO ISCF_step=2,BPTSCFIter
C              Are we converged ?
               if (scf_gemax.lt.SCF_TOL) then
                  if (parent) 
     $               write(6,*) 'Tolerance reached...',scf_gemax
                  goto 100
               endif

C              initialise timer
               time1 = timef()

C              storing the last Etot
               Last_Etot=ETOT
C              Storing the value of E(0)
               E0=ETOT

C              copying C0+C1 to C0...
               call DCOPY(2*ngw*nstate,C0plusC1,1,C0,1)

C   ---------- START OF PT CALC ------------------------------
C              initialisation
               call rhoofr(c0,rho0,psi,scr,lscr,nstate)
               call DCOPY(nnr1, rho0, 1, vofrho0, 1)
               call vofrho(tau0,fion,vofrho0,psi,scr,lscr,
     $                     .false.,.false.)

C              Lagrange multipliers
               CALL MEMORY_CHECK
               CALL LAG_MULT(c0,h1psi0,psi,scr,lscr,rhoe,z11,nstate)

C              Optimisation of W1
               if (parent) write (6,98)
               call tiset('PSI1-WF-OPT',isub2)
               call rwfopt_p(c0,c1,psi,rhoe,drhoe,scr,lscr,eirop,eivps,
     $                       dummy,h1psi0,z11,nstate,dummy)
               call tihalt('PSI1-WF-OPT',isub2)
               timetag='calculation of psi^1.'
C   ---------- END OF PT CALC ------------------------------

C              Is there no interaction force?
               if (TNORESPONSE) then
                  if (parent) write(6,*) 'NEGLIGIBLE RESPONSE...'
                  goto 100
               endif

C              Calculating the total energy using the functional
               Efunct=E0+ETOT
               if (parent) then
                 write(6,*)
                 write(6,*) '*-=> SCF-PT STEP',ISCF_step,'<=-*'
                 write(6,*) 'TOTAL ENERGY at step',ISCF_step,
     $                    '(functional) =',Efunct
                 write(6,*) 'Functional INTERACTION Energy =',
     $                      (Efunct-sum_mono)*1000,'mH'
                 write(6,*)
               endif

C              copying C0 to C0plusC1
               call DCOPY(2*ngw*nstate,C0,1,C0plusC1,1)

C              Now adding the perturbation (C1) to C0plusC1
               call DAXPY(2*ngw*nstate,1d0,C1,1,C0plusC1,1)

C              Adding the perturbation to the previous C1
c              call DAXPY(2*ngw*nstate,1d0,C1,1,sumC1,1)

C              orthogonalising c0+c1 (C1 here is a scratch)
               CALL LOWDIN(C0plusC1,C1,SCR,LSCR,NSTATE)

C              Now calculating the total energy of the orthogonalised w0+w1
               call forces(c0plusC1,h1psi0,tau0,FION,RHOE,PSI,
     $                     SCR,LSCR,NSTATE,1,.true.,.false.)
               if (parent) then
                 print *,'TOTAL ENERGY of orthog. W0+W1 at step',
     $                   ISCF_step,' : ',ETOT,' A.U.'
                 write(6,*) 'Ediff E(',ISCF_step,')-E(',ISCF_step-1,
     $                      '): ',ETOT-Last_Etot,' A.U.'
                 write(6,*) 'Efunct-EKS =',(Efunct-ETOT)*1000,'mH'
                 write(6,*)
               endif

C              Calculate convergence criteria
               CALL CSIZE(h1psi0,NSTATE,scf_gemax,scf_cnorm)
               if (parent) then
                  time2 = timef()
                  tcpu = (time2 - time1)*0.001d0
                  write(6,'(i3,a,E10.4,a,E10.4,a,f8.2,a)') ISCF_STEP,
     $                  ': Gemax =',scf_gemax,
     $                  ' Cnorm =',scf_cnorm,' Time: ',tcpu,' seconds'
                 write(6,*)
               endif
            ENDDO
C --------- END OF SCF cycles ------------------
C We have exhausted all the SCF cycles without convergence...
        if(parent.and.scf_gemax.gt.SCF_TOL) then
           write(6,'(1x,64("!"))')
           write(6,'(" !!",a,t64,"!!")')
     &       '   SCF-PT| the maximum number of SCF step is reached'
           write(6,'(" !!",a,f10.6,a,t64,"!!")')
     &       '         but no convergence (d E / d psi =',scf_gemax,')'
           write(6,'(1x,64("!"))')
         endif

C We are converged: end of SCF...
  100 continue
      ENDIF 

c     ==--------------------------------------------------------------==

      if (parent) then
        write (6,98)
        write (6,99)
        write (6,98)
      endif

c     ==--------------------------------------------------------------==
      call tihalt('   PTINTER',isub)

C     DE-allocating the arrays....
      CALL FREEM(IP_h1psi0)
      CALL FREEM(IP_C0plusC1)
      IF (BPTSCFIter.GT.1) THEN
C        SCF arrays...
         CALL FREEM(IP_originalC0)
         CALL FREEM(IP_sumC1)
      ENDIF
      return
      end
c     ==================================================================

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                   C
C     Subroutine to save the perturbed DENSITY      C
C     (2 W0W1 -> rho1), the starting                C 
C     orthogonalised wannier functions (W0 -> psi0) C
C     and its corresponding density (rho0 = W0*W0)  C
C                                                   C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine print_orbital_resp_densities(c0,c1,nstate,psi,scr)
      implicit none
      include 'system.h'
      include 'cppt.inc'
      include 'coor.inc'
      include 'cnst.inc'
      include 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'irat.inc'
      include 'response_p.inc'

      integer    is,ir,nstate,ia,ie,curr_pos
      complex*16 c0(ngw,nstate),c1(ngw,nstate)
      real*8     scr(nnr1,2),psi(nnr1,2)
      character*80  filename
      character*8  numb
      REAL*8  sum_C0,sum_C0C1,charge_disp
C     Storage for the response density      
      REAL*8  rho1_tot(nnr1)
      POINTER (ip_rho1_tot,rho1_tot)
C     Storage for the most important charge displacements     
      REAL*8  charge_disp_val(10)
      POINTER (ip_charge_disp_val,charge_disp_val)
C     and their position
      integer  charge_disp_pos(10)
      POINTER (ip_charge_disp_pos,charge_disp_pos)
#ifdef PARALLEL
      INTEGER    MSGLEN
#endif


C ===== Allocate memory for rho1_tot and initialise ====================   
      CALL MEMORY(IP_rho1_tot,nnr1,'rho1_tot')
      CALL AZZERO(rho1_tot,nnr1)
      
C ===== Allocate memory for charge disp arrays =========================
      CALL MEMORY(ip_charge_disp_val,max_num_disp,'charge_disp_val')
      CALL MEMORY(ip_charge_disp_pos,max_num_disp,'charge_disp_pos')
      CALL AZZERO(charge_disp_val,max_num_disp)
      do is=1,max_num_disp
         charge_disp_pos(is)=-1
         charge_disp_val(is)=-max_num_disp+is
      enddo
     
C ===== First loop on all states and constructing rho1 ================= 
      do is=1,nstate
C       saving the perturbed density (2W0W1)
        call fft2TOr(c0(1,is),psi(1,1),
     &      c1(1,is),psi(1,2),scr,ngw,.false.)

        sum_C0=0.D0
        sum_C0C1=0.D0

        do ir=1,nnr1
          scr(ir,1)  =  psi(ir,1)*psi(ir,2) *2d0
          sum_C0=sum_C0+psi(ir,1)*psi(ir,1)
          IF(scr(ir,1).GT.0) sum_C0C1=sum_C0C1+scr(ir,1)
          rho1_tot(ir)=rho1_tot(ir)+scr(ir,1)
        enddo
        
#ifdef PARALLEL
        call glosum(1,sum_C0)
        call glosum(1,sum_C0C1)
c        call glosum(nnr1,rho1_tot)
C NOT NECESSARY FOR SOME REASONS...
#endif
        if (parent) then
C          calculate charge displacement on parent
           charge_disp=100*(sum_C0C1/DBLE(NSTATE*sum_C0))
C          if charge displacmeent is bigger than the last element
C           of the charge disp array, include it
           if(charge_disp.gt.charge_disp_val(max_num_disp)) then
              charge_disp_val(max_num_disp)=charge_disp
C             store position
              charge_disp_pos(max_num_disp)=is
C             re-sort both arrays
              call sort_array(charge_disp_val,charge_disp_pos,
     &                        max_num_disp)  
            endif
        endif
      enddo

C ===== All states have been done, saving rho1 =========================
C     rho1_tot back in G space
      call fftTOg(rho1_tot,scr(1,1),psi,nhg,.true.)

C     Now save the total rho1 density
      if(parent) then
        write(6,*) 'Saving total perturbation density (2W0W1)'
        filename = 'rho1.total'
      endif
      call densto(scr(1,1),tau0,filename)
      
C     Finally clearing rho1 from the memory
      CALL FREEM(IP_rho1_tot)

C ===== Now make sure all processor know the disp values and order =====
#ifdef PARALLEL
      msglen=max_num_disp*8/IRAT
      call my_bcast(charge_disp_pos,msglen,SOURCE,ALLGRP)
      msglen=max_num_disp*8
      call my_bcast(charge_disp_val,msglen,SOURCE,ALLGRP)
#endif

C ===== Now saving on the states with the largest charge disp ==========
      if (parent) then
         write(6,*) 'Saving the',max_num_disp,'states contributing the',
     $              ' largest charge displacements'
         write(6,*) '- (in decreasing order of importance) -'
      endif
      do curr_pos=1,max_num_disp
C        looking up state number
         is=charge_disp_pos(curr_pos)
         
         if (is.gt.0) then
C           saving the perturbed density (2W0W1)
            call fft2TOr(c0(1,is),psi(1,1),
     &           c1(1,is),psi(1,2),scr,ngw,.false.)

            do ir=1,nnr1
               scr(ir,1)  =  psi(ir,1)*psi(ir,2) *2d0
            enddo
        
            if (parent) 
     $      write(6,FMT='(1X,A,I3,A,F8.5,A)') 'STATE',is,
     $                ' contributes',charge_disp_val(curr_pos),
     $                '% of charge displacement'

C           rho1 (W0W1) back in G space
            call fftTOg(scr(1,1),scr(1,1),psi,nhg,.true.)
C           Is the norm of the perturbed density equal to zero?
            IF ((DABS(DBLE(scr(1,1))).GT.1.D-13).AND.(GEQ0)) THEN
               if (parent) 
     $            write(6,*) 'WARNING: R-Norm of state',is,
     $                '[n1(g=0)] =',scr(1,1),'!= 0'
            ENDIF
C           Convert the number of the state to chars (from wannier_print)
            IF (parent) then
               WRITE(NUMB,'(I8)') is
               CALL XSTRING(NUMB,IA,IE)
            endif
        
           if(parent)
     $       filename = 'rho1-'//NUMB(IA:IE)//'.dens'

            call densto(scr(1,1),tau0,filename)
 
C           saving the starting wannier orbitals (W0)
            call azzero(psi,2*maxfft)
            call DCOPY(2*ngw,c0(1,is),1,psi,1)
            if(parent)
     $        filename = 'psi0-'//NUMB(IA:IE)//'.wf'
            call densto(psi,tau0,filename)

C           saving the starting wannier density (rho0)
C           G to R space
            call fftTOr(c0(1,is),psi(1,1),scr,ngw,.false.)

C           calculate the square
            do ir=1,nnr1
               scr(ir,1)  =  psi(ir,1)*psi(ir,1)
            enddo

C           R to G space
            call fftTOg(scr(1,1),scr(1,1),psi,nhg,.true.)

C          Save rho0
             if(parent)
     $         filename = 'rho0-'//NUMB(IA:IE)//'.dens'
             call densto(scr(1,1),tau0,filename)
         endif
      enddo
            
      return
      end
c     ================================================================== 

c     ==================================================================
      subroutine give_scr_interaction(l_max,tag,nstate)
      implicit none
      include 'system.h'        !nhg tgc
      character*(*) tag
      integer l_max,NSTATE,latomwf,LSECDER   
c     ==--------------------------------------------------------------==
      l_max=2*nnr1               ! for the gaussian fitting routine

C     Atomic wf scratch...
      CALL GIVE_SCR_ATOMWF(LATOMWF,TAG,NSTATE)
C     simple model scratch
      CALL GIVE_SCR_SDLINRES(LSECDER,TAG)

      l_max=max(l_max,LATOMWF)
      l_max=max(l_max,LSECDER)

      l_max=max(l_max,4*ngw*nstate)  ! for fun. repeat if necessary.
      tag = '2*nnr1'
c     ==--------------------------------------------------------------==
      return
      end
c     ================================================================== 

c     ==================================================================
      subroutine sort_array(A,B,N)
c     ==================================================================
C     Sorts Array A using an index and arranges A,B according to it
      implicit none
C     Including the "essential" variables...
      include 'system.h'
      include 'cppt.inc'

      INTEGER N
      REAL*8  A(N)
      INTEGER B(N)
      integer index(N),I
      REAL*8   tempA(N)
      integer  tempB(N)

C     sorting array A
      CALL sort2(A,N,index)

C     sort B accordingly using index
      DO I = 1 , N
        tempB(I)=B(INDEX(I))
      ENDDO
      CALL ICOPY(N,tempB,1,B,1)
      
C     Arrange A and B in descending order
      DO I = 1 , N
        tempA(I)=A(N-I+1)
        tempB(I)=B(N-I+1)
      ENDDO
      CALL DCOPY(N,tempA,1,A,1)
      CALL ICOPY(N,tempB,1,B,1)
      return

      end
c     ==================================================================
