C     ==================================================================
      SUBROUTINE INTERP3D(GRID0,KX0,KY0,KZ0,GRID1,KX1,KY1,KZ1)
C     ==--------------------------------------------------------------==
C     == SIMPLE INTERPOLATION 3D. (not efficient - T. Deutsch)        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER KX0,KY0,KZ0,KX1,KY1,KZ1
      REAL*8 GRID0(KX0,KY0,*),GRID1(KX1,KY1,*)
      INTEGER IX1,IY1,IZ1,NX0,NY0,NZ0,NX1,NY1,NZ1,
     &     MINX1,MAXX1,MINY1,MAXY1,MINZ1,MAXZ1,NNR0,NNR1,
     &     INCX,INCY,INCZ
      REAL*8 RX01,RY01,RZ01,X1,Y1,Z1,VALUE,
     &     SUMGRID1,SUMGRID0, PX,PY,PZ
      REAL*8 DENSMAX,DASUM,TOLL
      PARAMETER (DENSMAX=1.D1,TOLL=-1.D-15)
      EXTERNAL DASUM
C     ==--------------------------------------------------------------==
      CALL AZZERO(GRID1,KX1*KY1*KZ1)
      NX0=KX0-MOD(KX0+1,2)
      NY0=KY0-MOD(KY0+1,2)
      NZ0=KZ0-MOD(KZ0+1,2)
      NX1=KX1-MOD(KX1+1,2)
      NY1=KY1-MOD(KY1+1,2)
      NZ1=KZ1-MOD(KZ1+1,2)
      NNR0=NX0*NY0*NZ0
      NNR1=NX1*NY1*NZ1
      RX01=DBLE(NX0)/DBLE(NX1)
      IF((NX1-NX0).EQ.0) THEN
        INCX=0
      ELSE
        INCX=1
      ENDIF
      RY01=DBLE(NY0)/DBLE(NY1)
      IF((NY1-NY0).EQ.0) THEN
        INCY=0
      ELSE
        INCY=1
      ENDIF
      RZ01=DBLE(NZ0)/DBLE(NZ1)
      IF((NZ1-NZ0).EQ.0) THEN
        INCZ=0
      ELSE
        INCZ=1
      ENDIF
      SUMGRID1=0.D0
      DO IZ1=1,NZ1
        Z1=RZ01*IZ1
        MINZ1=INT(Z1)
        MAXZ1=MINZ1+INCZ
        PZ=Z1-MINZ1
        IF(MINZ1.LT.1)   MINZ1=NZ0
        IF(MAXZ1.GT.NZ0) MAXZ1=1
        DO IY1=1,NY1
          Y1=RY01*IY1
          MINY1=INT(Y1)
          MAXY1=MINY1+INCY
          PY=Y1-MINY1
          IF(MINY1.LT.1)   MINY1=NY0
          IF(MAXY1.GT.NY0) MAXY1=1
          DO IX1=1,NX1
            X1=RX01*IX1
            MINX1=INT(X1)
            MAXX1=MINX1+INCX
            PX=X1-MINX1
            IF(MINX1.LT.1)   MINX1=NX0
            IF(MAXX1.GT.NX0) MAXX1=1
            VALUE=(1.D0-PX)*(1.D0-PY)*(1.D0-PZ)*GRID0(MINX1,MINY1,MINZ1)
     &           +(1.D0-PX)*      PY *(1.D0-PZ)*GRID0(MINX1,MAXY1,MINZ1)
     &           +(1.D0-PX)*(1.D0-PY)*      PZ *GRID0(MINX1,MINY1,MAXZ1)
     &           +(1.D0-PX)*      PY *      PZ *GRID0(MINX1,MAXY1,MAXZ1)
     &           +      PX *(1.D0-PY)*(1.D0-PZ)*GRID0(MAXX1,MINY1,MINZ1)
     &           +      PX *      PY *(1.D0-PZ)*GRID0(MAXX1,MAXY1,MINZ1)
     &           +      PX *(1.D0-PY)*      PZ *GRID0(MAXX1,MINY1,MAXZ1)
     &           +      PX *      PY *      PZ *GRID0(MAXX1,MAXY1,MAXZ1)
            IF(VALUE.LT.TOLL) THEN
              WRITE(6,*) ' INTERP3D!',IX1,IY1,IZ1, VALUE
              CALL STOPGM('INTERP3D','NEGATIVE DENSITY')
            ENDIF
            GRID1(IX1,IY1,IZ1)=VALUE
            SUMGRID1=SUMGRID1+VALUE
          ENDDO
        ENDDO
      ENDDO
      SUMGRID0=DASUM(NNR0,GRID0,1)
      SUMGRID0=SUMGRID0/DBLE(NNR0)
      SUMGRID1=SUMGRID1/DBLE(NNR1)
      IF(SUMGRID1.GT.DENSMAX*SUMGRID0) THEN
        WRITE(6,*) ' INTERP3D!','SUM OF INTERPOLATED MESH=',SUMGRID1
        CALL STOPGM('INTERP3D','WRONG INTERPOLATION')
      ENDIF
C     Renormalisation
      CALL DSCAL(NNR1,SUMGRID0/SUMGRID1,GRID1(1,1,1),1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
