C     ==================================================================
      SUBROUTINE INTERPT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ddip.inc'
C     Variables
      REAL*8  C0(*),C2(*),PME(*),GDE(*),VPP(*),EIGV(*),SC0(*)
      POINTER (IP_C0,C0), (IP_C2,C2), (IP_PME,PME)
      POINTER (IP_GDE,GDE), (IP_VPP,VPP), (IP_EIGV,EIGV)
      POINTER (IP_SC0,SC0)
      REAL*8  DUMMY
      INTEGER NC,NC2,NSC0,NXX,NXXFUN
      EXTERNAL NXXFUN
      LOGICAL WASDIIS
C     ==--------------------------------------------------------------==
C     ==  MEMORY ALLOCATION                                           ==
C     ==--------------------------------------------------------------==
C     ==  C0    : WAVEFUNCTIONS                                       ==
C     ==  C2    : GRADIENTS                                           ==
C     ==  SC0   : S**(-1/2)*C0 (nonorthogonal orbitals)               ==
C     ==  PME   : DIIS WF             HNM1 (for CG)                   ==
C     ==  GDE   : DIIS GRADIENTS                                      ==
C     ==  VPP   : WF HESSIAN                                          ==
C     ==  EIGV  : ORBITAL ENERGIES                                    ==
C     ==--------------------------------------------------------------==
      IF ( TQMMM ) CALL STOPGM("INTERPT","QMMM NOT IMPLEMENTED")
C     ==--------------------------------------------------------------==
      NC=2*NGW*N+8
      NC2=NC
      NSC0=1
      IF(TIVAN.OR.NONORT.OR.(PCG.AND.PCGMIN)) THEN
        NSC0=2*NGWK*N*NKPNT
      ENDIF
      IF(TDIPD) THEN
        IF(TDDFT) CALL STOPGM("INTERPT",
     &      "TDDFT AND DIPOLE DYNAMICS NOT POSSIBLE")
#ifdef PARALLEL
        LENBK=NXXFUN(N)
        NXX=MAX(2*LENBK*NPROC,NC2)
        NSC0=MAX(NXX,NSC0)
#else 
        NXX=NC2
#endif
        NC2=NXX
      ENDIF

      CALL MEMORY(IP_C0,NC,'C0')
      CALL MEMORY(IP_C2,NC2,'C2')
      CALL MEMORY(IP_EIGV,N,'EIGV')
      CALL MEMORY(IP_SC0,NSC0,'SC0')

      IF(TSDE) THEN
        CALL GET_ADDR(IP_PME,DUMMY)
        CALL GET_ADDR(IP_GDE,DUMMY)
        CALL MEMORY(IP_VPP,NGW,'VPP')
      ELSE IF (DIIS) THEN
        CALL MEMORY(IP_PME,(NGW*N+8)*MDIIS,'PME')
        CALL MEMORY(IP_GDE,((NGW*N+8)*MDIIS)/4,'GDE')
        CALL MEMORY(IP_VPP,NGW,'VPP')
      ELSE IF (PCG) THEN
        CALL MEMORY(IP_PME,2*NGW*N,'PME')
        CALL GET_ADDR(IP_GDE,DUMMY)
        CALL MEMORY(IP_VPP,NGW,'VPP')
      ENDIF
C     ==--------------------------------------------------------------==
C..FNL and DFNL
      CALL FNLALLOC(N,.TRUE.,.FALSE.)
      IF(PARENT) CALL PRMEM('   INTERPT')
C     ==--------------------------------------------------------------==
      IF (DIIS.AND.TPCGFI) THEN
        IF(PARENT) WRITE(6,*) 'INTERPT| SWITCHING TO PCG MINIMIZE'
        WASDIIS=.TRUE.
        DIIS=.FALSE.
        PCG=.TRUE.
        PCGMIN=.TRUE.
      ELSE
        WASDIIS=.FALSE.
      ENDIF
      CALL RWFOPT(C0,C2,SC0,PME,GDE,VPP,EIGV)
      IF (WASDIIS) THEN
        IF(PARENT) WRITE(6,*) 'INTERPT| SWITCHING BACK TO DIIS'
        DIIS=.TRUE.
        PCG=.FALSE.
        PCGMIN=.FALSE.
      ENDIF
      CLOSE(5)
C     ==--------------------------------------------------------------==
      CALL INTERFACE(C0,C2,SC0,PME,GDE,VPP,EIGV)
C     ==--------------------------------------------------------------==
      IF(TMEMCHK) CALL PRINT_MEMORY
      CALL FREEM(IP_C0)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_EIGV)
      CALL FNLDEALLOC(.TRUE.,.FALSE.)
      IF(NONORT.OR.TIVAN.OR.(PCG.AND.PCGMIN)) THEN
        CALL FREEM(IP_SC0)
      ENDIF
      IF(DIIS) THEN
        CALL FREEM(IP_PME)
        CALL FREEM(IP_GDE)
      ENDIF
      CALL FREEM(IP_VPP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
