C     ==================================================================
      SUBROUTINE JROTATION(ROTMAT,XYZMAT,LDX,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'wann.inc'
      INTEGER    LDX,NSTATE,LSCR
      REAL*8     ROTMAT(NSTATE,NSTATE)
      REAL*8     SCR(LSCR)
      COMPLEX*16 XYZMAT(LDX,LDX,*)
      INTEGER    MSGLEN,LWANN
      CHARACTER  TAG*30
C     ==--------------------------------------------------------------==
      INTEGER    ISUB,I,J,K,IMAX,IDAMAX,LEXP,LUPD,LSCR2
      LOGICAL    DEBUG
      REAL*8     GMAT(NSTATE,NSTATE),XRANF,GMAX,SCR2(*)
      EXTERNAL   XRANF
      POINTER    (IP_GMAT,GMAT),(IP_SCR2,SCR2)
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
      CALL TISET(' JROTATION',ISUB)
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_JROT(LWANN,TAG,NSTATE,TWSERIAL)
      CALL TEST_SCR('JROTATION',TAG,LSCR,LWANN)
C     ==--------------------------------------------------------------==
      IF(W_TYPE.EQ.2 .AND. PARENT) THEN
        WRITE(6,'(A,A)') ' LOCALIZATION| ORBITAL ROTATIONS ',
     *                   'WITH RESTA FUNCTIONAL NOT POSSIBLE '
        WRITE(6,'(A,A)') ' LOCALIZATION| USE VANDERBILT FUNCTIONAL '
        CALL STOPGM('JROTATION','WRONG FUNCTIONAL')
      ENDIF
C..initialise global rotation matrix
      CALL UNITMX(ROTMAT,NSTATE)
      IF(W_RAN.GT.0.D0) THEN
        IF(PARENT) THEN
          CALL GIVE_SCR_EXPONENTIATE(LEXP,TAG,NSTATE)
          LUPD=3*NSTATE*NSTATE
          LSCR2=MAX(LEXP,LUPD)
          CALL MEMORY(IP_SCR2,LSCR2,"SCR2")
          CALL MEMORY(IP_GMAT,NSTATE*NSTATE,"GMAT")
C..randomly distort initial vectors
          DO I=1,NSTATE
            GMAT(I,I)=0.D0
            DO J=I+1,NSTATE
              GMAT(I,J)=XRANF()*W_RAN
              GMAT(J,I)=-GMAT(I,J)
            ENDDO
          ENDDO
          CALL EXPONENTIATE(GMAT,ROTMAT,NSTATE,SCR2,LSCR2)
          CALL XYZ_UPDATE(ROTMAT,XYZMAT,SCR2,LDX,NSTATE)
          CALL FREEM(IP_SCR2)
          CALL FREEM(IP_GMAT)
        ENDIF
        MSGLEN=NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
        DO K=1,NWANOPT
          MSGLEN=2*(LDX*(NSTATE-1)+NSTATE) * 8
          CALL MY_BCAST(XYZMAT(1,1,K),MSGLEN,SOURCE,ALLGRP)
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NPROC.EQ.1 .OR. TWSERIAL) THEN
        IF(PARENT)
     *     CALL JROTATION1(ROTMAT,XYZMAT,LDX,NSTATE,SCR,LSCR)
        MSGLEN=NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
      ELSE
        CALL SET_ORBDIST(NSTATE,1,IMAX)
        CALL JROTATIONP(ROTMAT,XYZMAT,LDX,NSTATE,SCR,LSCR)
      ENDIF
C     ==--------------------------------------------------------------==
      CALL TIHALT(' JROTATION',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE SET_ORBDIST(NSTATE,NBLOCK,NBMAX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INTEGER   NSTATE,NBLOCK,NBMAX,NX
      REAL*8    XSTATES,XSNOW,XSAIM
      INTEGER   IP
C     ==--------------------------------------------------------------==
      NBMAX=0
      XSTATES=DBLE(NBLOCK)
      IF((XSTATES*NPROC).LT.NSTATE) THEN
       XSTATES=DBLE(NSTATE)/DBLE(NPROC)
      ENDIF
      XSNOW=0.0D0
      XSAIM=0.0D0
      DO IP=1,NPROC
        XSAIM = XSNOW + XSTATES
        NWA12(IP-1,1)=NINT(XSNOW)+1
        NWA12(IP-1,2)=NINT(XSAIM)
        IF(NINT(XSAIM).GT.NSTATE) THEN
           NWA12(IP-1,2)=NSTATE
        ENDIF
        IF(NINT(XSNOW).GT.NSTATE) THEN
           NWA12(IP-1,1)=NSTATE+1
        ENDIF
        XSNOW = XSAIM
      ENDDO
      DO IP=0,NPROC-1
       NX=NWA12(IP,2)-NWA12(IP,1)+1
       NBMAX=MAX(NBMAX,NX)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MY_SET_ORBDIST(NSTATE,NBLOCK,NBMAX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INTEGER   NSTATE,NBLOCK,NBMAX
      REAL*8    XSTATES,XSNOW,XSAIM
      INTEGER   IP
C     ==--------------------------------------------------------------==
      NBMAX=0
      XSTATES=DBLE(NSTATE)/DBLE(NPROC)
      IF(XSTATES.LT.DBLE(NBLOCK)) XSTATES=DBLE(NBLOCK)
      XSNOW=0.0D0
      DO IP=1,NPROC
        XSAIM = XSNOW + XSTATES
        NWA12(IP-1,1)=NINT(XSNOW)+1
        NWA12(IP-1,2)=NINT(XSAIM)
        IF(NINT(XSAIM).GT.NSTATE) NWA12(IP-1,2)=NSTATE
        IF(IP.EQ.NPROC) NWA12(IP-1,2)=NSTATE
        IF(NINT(XSNOW).GT.NSTATE) NWA12(IP-1,1)=NSTATE+1
        XSNOW = XSAIM
        NBMAX=MAX(NBMAX,NWA12(IP-1,2)-NWA12(IP-1,1)+1)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE JROTATION1(ROTMAT,XYZMAT,LDX,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'wann.inc'
      INTEGER    LDX,NSTATE,LSCR
      REAL*8     ROTMAT(NSTATE,NSTATE)
      REAL*8     SCR(LSCR)
      COMPLEX*16 XYZMAT(LDX,LDX,*)
      REAL*8     GMAT(NSTATE*NSTATE)
      POINTER    (IP_GMAT,GMAT)
C     ==--------------------------------------------------------------==
      LOGICAL    DEBUG
      INTEGER    IOPT,IMAX,IDAMAX
      REAL*8     GMAX
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_GMAT,NSTATE*NSTATE,'GMAT',DEBUG)
      GMAX=0.D0
C     ==--------------------------------------------------------------==
      DO IOPT=1,W_MAXS
C..do a Jacobi rotation for each pair of orbitals
        CALL JACOBIROT(ROTMAT,XYZMAT,LDX,NSTATE)
C..calculate the gradient
        CALL XGRADAT0(W_TYPE,GMAT,XYZMAT,LDX,NSTATE)
        IMAX=IDAMAX(NSTATE*NSTATE,GMAT,1)
        GMAX=ABS(GMAT(IMAX))/ALAT**2
        IF(GMAX.LT.W_EPS) GOTO 100
      ENDDO
      WRITE(6,'(A,G12.3)') ' WANNIER CODE| NO CONVERGENCE (GMAX) ',GMAX
  100 CONTINUE
      CALL SCRREL(SCR,LSCR,DEBUG)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE JROTATIONP(ROTMAT,XYZMAT,LDX,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'wann.inc'
      INTEGER    LDX,NSTATE,LSCR
      REAL*8     ROTMAT(NSTATE,NSTATE)
      REAL*8     SCR(LSCR)
      COMPLEX*16 XYZMAT(LDX,LDX,*)
C     ==--------------------------------------------------------------==
      LOGICAL    DEBUG
      INTEGER    IOPT,I,J,K
      REAL*8     GMAX,GCOMP,GMAT(*),RMAT(*)
      POINTER    (IP_GMAT,GMAT),(IP_RMAT,RMAT)
      INTEGER    IS,IP,NN,MSGLEN,II,KK,NIPO,KK2,MIA,MIB,MJA,MJB
      INTEGER    SCOUNT,RCOUNT,MEP,MRE,MIP,M,I1,I2
      INTEGER    NOME,NOMAX,NSWEEP,NPAIR,IPO,ITYPE
      INTEGER    LPPL(2,*)
      COMPLEX*16 XYZM(*),XYZC(*),XYZD(*),XA
      POINTER    (IP_XYZM,XYZM),(IP_XYZC,XYZC),(IP_XYZD,XYZD),
     *           (IP_LPPL,LPPL)
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
      GMAX=0.D0
C     ==--------------------------------------------------------------==
      NOME=NWA12(MEPOS,2)-NWA12(MEPOS,1)+1
      NOMAX=0
      DO IP=0,NPROC-1
        NN=NWA12(IP,2)-NWA12(IP,1)+1
        NOMAX=MAX(NOMAX,NN)
      ENDDO
      CALL SCRSET(SCR,LSCR,DEBUG)
      NN=MAX(8*NOMAX*NOMAX*NWANOPT,2*NOMAX*NSTATE*NWANOPT,
     *       2*NOMAX*NPROC*NWANOPT)
      CALL SCRPTR(SCR,LSCR,IP_XYZM,NN,'XYZM',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_XYZC,NN,'XYZC',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_XYZD,2*NOMAX*NSTATE*NWANOPT,'XYZD',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_RMAT,4*NOMAX*NOMAX,'RMAT',DEBUG)
      NN=MAX(4*NOMAX*NOMAX,NSTATE*NSTATE)
      CALL SCRPTR(SCR,LSCR,IP_GMAT,NN,'GMAT',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_LPPL,2*NPROC,'LPPL',DEBUG)
      CALL AZZERO(GMAT,NN)
      CALL IAZZERO(LPPL,2*NPROC)
C     ==--------------------------------------------------------------==
      DO IOPT=1,W_MAXS
        NSWEEP=NPROC-MOD(NPROC+1,2)
        NPAIR=(NPROC+1)/2
        DO IS=1,NSWEEP
          CALL EBERLEIN(IS,NPROC,LPPL)
c         look for my partner in this round
          IPO=-1
          DO IP=1,NPAIR
            IF(LPPL(1,IP).EQ.MEPOS+1) THEN
              IPO=LPPL(2,IP)-1
              GOTO 1000
            ELSEIF(LPPL(2,IP).EQ.MEPOS+1) THEN
              IPO=LPPL(1,IP)-1
              GOTO 1000
            ENDIF
          ENDDO
1000      CONTINUE
          IF(IPO.GE.0) THEN
            NIPO=NWA12(IPO,2)-NWA12(IPO,1)+1
          ELSE
            NIPO=0
          ENDIF
          IF(NIPO*NOME.GT.0) THEN
            NN=NIPO+NOME
            CALL UNITMX(RMAT,NN)
C           pack data to be send to partner
            DO K=1,NWANOPT
              KK=(K-1)*NOME*NSTATE
              CALL MATMOV(NSTATE,NOME,XYZMAT(1,NWA12(MEPOS,1),K),
     &                LDX,XYZC(KK+1),NSTATE)
            ENDDO
C           send/receive data
            SCOUNT=2*NWANOPT*NOME*NSTATE * 8
            RCOUNT=2*NWANOPT*NIPO*NSTATE * 8
            CALL MY_SENDRECV(XYZC,SCOUNT,IPO,XYZD,RCOUNT,IPO,ALLGRP)
C           build up local problem
            IF(NWA12(MEPOS,1).LT.NWA12(IPO,1)) THEN
              MIA=1
              MIB=NOME+1
              MJA=NOME*NN+NOME+1
              MJB=NOME*NN+1
            ELSE
              MIA=NIPO*NN+NIPO+1
              MIB=NIPO*NN+1
              MJA=1
              MJB=NIPO+1
            ENDIF
            DO K=1,NWANOPT
              KK=(K-1)*NOME*NSTATE
              KK2=(K-1)*NN*NN
              J=NWA12(MEPOS,1)
              CALL MATMOV(NOME,NOME,XYZC(J+KK),NSTATE,
     &                              XYZM(KK2+MIA),NN)
              J=NWA12(IPO,1)
              CALL MATMOV(NIPO,NOME,XYZC(J+KK),NSTATE,
     &                              XYZM(KK2+MIB),NN)
              KK=(K-1)*NIPO*NSTATE
              J=NWA12(IPO,1)
              CALL MATMOV(NIPO,NIPO,XYZD(J+KK),NSTATE,
     &                              XYZM(KK2+MJA),NN)
              J=NWA12(MEPOS,1)
              CALL MATMOV(NOME,NIPO,XYZD(J+KK),NSTATE,
     &                              XYZM(KK2+MJB),NN)
            ENDDO
C           solve local problem
            CALL JACOBIROT(RMAT,XYZM,NN,NN)
C           send/receive ROTMAT data
            SCOUNT=NOME*NSTATE * 8
            RCOUNT=NIPO*NSTATE * 8
            CALL MY_SENDRECV(ROTMAT(1,NWA12(MEPOS,1)),SCOUNT,IPO,
     &                       ROTMAT(1,NWA12(IPO,1)),RCOUNT,IPO,ALLGRP)
C           update ROTMAT
            CALL DGEMM("N","N",NSTATE,NOME,NIPO,1.D0,
     &                 ROTMAT(1,NWA12(IPO,1)),NSTATE,RMAT(MIB),NN,
     &                 0.D0,GMAT,NSTATE)
            CALL DGEMM("N","N",NSTATE,NOME,NOME,1.D0,
     &                 ROTMAT(1,NWA12(MEPOS,1)),NSTATE,RMAT(MIA),NN,
     &                 1.D0,GMAT,NSTATE)
            CALL DCOPY(NSTATE*NOME,GMAT,1,ROTMAT(1,NWA12(MEPOS,1)),1)
C           update XYZMAT (first part, multiplication from right)
            DO K=1,NWANOPT
              KK=(K-1)*NOME*NSTATE+1
              KK2=(K-1)*NIPO*NSTATE+1
              CALL XAPYB(NSTATE,XYZD(KK2),RMAT(MIB),NIPO,XYZC(KK),
     &                   RMAT(MIA),NOME,XYZM(KK),NN)
            ENDDO
          ELSEIF(NOME.GT.0) THEN
            DO K=1,NWANOPT
              KK=(K-1)*NOME*NSTATE
              CALL MATMOV(NSTATE,NOME,XYZMAT(1,NWA12(MEPOS,1),K),
     &                LDX,XYZM(KK+1),NSTATE)
            ENDDO
          ENDIF
C         distribute rotation matrices and update xyzmat (second part)
          IF(NOME.GT.0) THEN
            DO K=1,NWANOPT
              DO I=NWA12(MEPOS,1),NWA12(MEPOS,2)
                CALL ZAZZERO(XYZMAT(1,I,K),NSTATE)
              ENDDO
            ENDDO
          ENDIF
C         transpose rotation matrix and pack for distribution
          IF(NOME*NIPO.NE.0) THEN
            CALL RTRANS(RMAT,NN)
            CALL RMATMOV(NOME,NOME,RMAT(MIA),NN,GMAT(1),NOME)
            KK=NOMAX*NOMAX+1
            CALL RMATMOV(NOME,NIPO,RMAT(MJB),NN,GMAT(KK),NOME)
          ELSE
            CALL AZZERO(GMAT,2*NOMAX*NOMAX)
          ENDIF
          DO IP=0,NPROC-1
            K=2*NOMAX*NOMAX+1
            IF(IP.EQ.0) THEN
              CALL DCOPY(2*NOMAX*NOMAX,GMAT,1,GMAT(K),1)
              MEP = MEPOS
            ELSE
              MSGLEN=2*NOMAX*NOMAX * 8
              MEP=MOD(MEPOS-IP+NPROC,NPROC)
              MRE=MOD(MEPOS+IP+NPROC,NPROC)
              CALL MY_SENDRECV(GMAT,MSGLEN,MRE,GMAT(K),
     &                         MSGLEN,MEP,ALLGRP)
            ENDIF
            MRE=NWA12(MEP,2)-NWA12(MEP,1)+1
            IF(NOME.GT.0) THEN
              IF(MRE.GT.0) THEN
C               look for partner of mep
                MIP=-1
                DO I=1,NPAIR
                  IF(LPPL(1,I).EQ.MEP+1) THEN
                    MIP=LPPL(2,I)-1
                    GOTO 1001
                  ELSEIF(LPPL(2,I).EQ.MEP+1) THEN
                    MIP=LPPL(1,I)-1
                    GOTO 1001
                  ENDIF
                ENDDO
1001            CONTINUE
                IF(MIP.GE.0) THEN
                  M=NWA12(MIP,2)-NWA12(MIP,1)+1
                ELSE
                  M=0
                ENDIF
                IF(M.GT.0) THEN
                  J=NWA12(MEPOS,1)
                  I1=NWA12(MEP,1)
                  I2=NWA12(MIP,1)
                  K=2*NOMAX*NOMAX+1
                  KK=3*NOMAX*NOMAX+1
                  DO I=1,NWANOPT
                    II=(I-1)*NOME*NSTATE
                    CALL RMUPX(MRE,MRE,GMAT(K),XYZM(II+I1),NSTATE,NOME,
     &                         XYZMAT(I1,J,I),LDX)
                    CALL RMUPX(MRE,M,GMAT(KK),XYZM(II+I2),NSTATE,NOME,
     &                         XYZMAT(I1,J,I),LDX)
                  ENDDO
                ELSE
                  DO K=1,NWANOPT
                    J=NWA12(MEPOS,1)
                    I=NWA12(MEP,1)
                    KK=(K-1)*NOME*NSTATE+I
                    CALL MATMOV(MRE,NOME,XYZM(KK),NSTATE,
     &                          XYZMAT(I,J,K),LDX)
                  ENDDO
                ENDIF
              ENDIF
            ENDIF
          ENDDO
        ENDDO
C..calculate the max gradient
C       store the diagonal of xyzmat
        CALL ZAZZERO(XYZC,NWANOPT*NOMAX)
!$OMP parallel do private(K,I,KK,II)
        DO K=1,NWANOPT
          KK=(K-1)*NOMAX
          DO I=NWA12(MEPOS,1),NWA12(MEPOS,2)
            II=I-NWA12(MEPOS,1)+1
            XYZC(KK+II)=XYZMAT(I,I,K)
          ENDDO
        ENDDO
C       collect all the diagonal elements
        MSGLEN=2*NWANOPT*NOMAX * 8
        CALL MY_CONCAT(XYZC,XYZM,MSGLEN,ALLGRP)
        DO IP=0,NPROC-1
          J=IP*NWANOPT*NOMAX
!$OMP parallel do private(K,I,KK,I1,II)
          DO K=1,NWANOPT
            KK=(K-1)*NOMAX+J
            I1=(K-1)*NSTATE
            DO I=NWA12(IP,1),NWA12(IP,2)
              II=I-NWA12(IP,1)+1
              XYZC(I1+I)=XYZM(KK+II)
            ENDDO
          ENDDO
        ENDDO
C       calculate gradient
        GMAX=0.D0
        DO J=NWA12(MEPOS,1),NWA12(MEPOS,2)
          DO I=1,J-1
            GCOMP=0.D0
            DO K=1,NWANOPT
              I1=(K-1)*NSTATE
              XA=XYZC(I1+J)-XYZC(I1+I)
              GCOMP=GCOMP+WWEI(K)*
     *          DREAL(4.D0*DCONJG(XYZMAT(I,J,K))*XA)
            ENDDO
            GMAX=MAX(GMAX,ABS(GCOMP))
          ENDDO
        ENDDO
        CALL GLOMAX(1,GMAX)
        GMAX=GMAX/ALAT**2
        IF(PARENT) WRITE(6,*) GMAX
        IF(GMAX.LT.W_EPS) GOTO 100
      ENDDO
      IF(PARENT) WRITE(6,'(A,G12.3)') 
     &           ' WANNIER CODE| NO CONVERGENCE (GMAX) ',GMAX
  100 CONTINUE
C     update the full xyzmat and rotmat
      DO K=1,NWANOPT
        DO I=1,NWA12(MEPOS,1)-1
          CALL ZAZZERO(XYZMAT(1,I,K),NSTATE)
        ENDDO
        DO I=NWA12(MEPOS,2)+1,NSTATE
          CALL ZAZZERO(XYZMAT(1,I,K),NSTATE)
        ENDDO
        I=2*((NSTATE-1)*LDX+NSTATE)
        CALL GLOSUM(I,XYZMAT(1,1,K))
      ENDDO
      DO I=1,NWA12(MEPOS,1)-1
        CALL AZZERO(ROTMAT(1,I),NSTATE)
      ENDDO
      DO I=NWA12(MEPOS,2)+1,NSTATE
        CALL AZZERO(ROTMAT(1,I),NSTATE)
      ENDDO
      CALL GLOSUM(NSTATE*NSTATE,ROTMAT)
C     ==--------------------------------------------------------------==
      CALL SCRREL(SCR,LSCR,DEBUG)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE JACOBIROT(ROTMAT,XYZMAT,LDX,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
#ifdef __CRAYX1
c... following modification CRAYX1essary for inlining
c--      INCLUDE'wann.inc'
c++
C     ==--------------------------------------------------------------==
C     == NWANOPT : number of operators                                ==
C     == IOW     : operators 4-6                                      ==
C     == WWEI    : weights                                            ==
C     ==--------------------------------------------------------------==
      INTEGER       NWANOPT,IOW
      COMMON/WANO1/ NWANOPT,IOW(2,3)
      REAL*8        WWEI
      COMMON/WANO2/ WWEI(6)
c++
#endif
      INCLUDE 'system.h'
      INTEGER    LDX,NSTATE,LSCR
      REAL*8     ROTMAT(NSTATE,NSTATE)
      COMPLEX*16 XYZMAT(LDX,LDX,*)
C     ==--------------------------------------------------------------==
      INTEGER    I,J
      REAL*8     CG,SG,ALFA
C     ==--------------------------------------------------------------==
C..do a Jacobi rotation for each pair of orbitals
      DO I=1,NSTATE
        DO J=I+1,NSTATE
c..calculate optimal rotation angle
          CALL CALC_ANGLE(XYZMAT,LDX,I,J,ALFA)
          IF(ABS(ALFA).GT.1.D-12) THEN
            CG=COS(ALFA)
            SG=SIN(ALFA)
            CALL RMROT(NSTATE,ROTMAT,I,J,CG,SG)
            CALL XYROT(NSTATE,XYZMAT,LDX,I,J,CG,SG)
          ENDIF
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CALC_ANGLE(XYZMAT,LDX,I,J,ALFA)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
#ifdef __CRAYX1
c... following modification CRAYX1essary for inlining
c--      INCLUDE'wann.inc'
c++
C     ==--------------------------------------------------------------==
C     == NWANOPT : number of operators                                ==
C     == IOW     : operators 4-6                                      ==
C     == WWEI    : weights                                            ==
C     ==--------------------------------------------------------------==
      INTEGER       NWANOPT,IOW
      COMMON/WANO1/ NWANOPT,IOW(2,3)
      REAL*8        WWEI
      COMMON/WANO2/ WWEI(6)
c++
#else
      INCLUDE 'wann.inc'
#endif
      INCLUDE 'cnst.inc'
      INTEGER    LDX,I,J
      COMPLEX*16 XYZMAT(LDX,LDX,*)
      REAL*8 ALFA,A12,B12,MAB
      COMPLEX*16 YIIA,YIIB,YJJA,YJJB,YIJA,YIJB
      REAL*8 TAN4A,PI4,D2
      INTEGER IA,IB
      PARAMETER(PI4=0.25D0*PI)
C     ==--------------------------------------------------------------==
      A12=0.D0
      B12=0.D0
!CDIR NOVECTOR
      DO IA=1,NWANOPT
        YIIA=DCONJG(XYZMAT(I,I,IA))
        YJJA=DCONJG(XYZMAT(J,J,IA))
        YIJA=DCONJG(XYZMAT(I,J,IA))
        YIIB=XYZMAT(I,I,IA)
        YJJB=XYZMAT(J,J,IA)
        YIJB=XYZMAT(I,J,IA)
        A12=A12 + WWEI(IA)*DREAL(YIJA*(YIIB-YJJB))
        B12=B12 + WWEI(IA)*DREAL(YIJA*YIJB - 
     *              0.25D0*(YIIA-YJJA)*(YIIB-YJJB))
      ENDDO
      IF(DABS(B12).GT.1.D-10) THEN
        TAN4A=-A12/B12
        ALFA=0.25D0*DATAN(TAN4A)
      ELSEIF(DABS(A12).LT.1.D-10) THEN
        ALFA=0.D0
        B12=0.D0
      ELSE
        ALFA=PI4
      ENDIF
      D2=A12*DSIN(4.D0*ALFA)-B12*DCOS(4.D0*ALFA)
      IF(D2.LE.0.D0) ALFA=ALFA+PI4
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE XYROT(NSTATE,XYZMAT,LDX,I,J,CG,SG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
#ifdef __CRAYX1
c... following modification CRAYX1essary for inlining
c--      INCLUDE'wann.inc'
c++
C     ==--------------------------------------------------------------==
C     == NWANOPT : number of operators                                ==
C     == IOW     : operators 4-6                                      ==
C     == WWEI    : weights                                            ==
C     ==--------------------------------------------------------------==
      INTEGER       NWANOPT,IOW
      COMMON/WANO1/ NWANOPT,IOW(2,3)
      REAL*8        WWEI
      COMMON/WANO2/ WWEI(6)
c++
#else
      INCLUDE 'wann.inc'
#endif
      INTEGER    LDX,I,J,NSTATE
      COMPLEX*16 XYZMAT(LDX,LDX,*),ZI,ZJ
      REAL*8 CG,SG
      INTEGER K,L
C     ==--------------------------------------------------------------==
!$OMP parallel do private(K,L,ZI,ZJ)
      DO K=1,NWANOPT
        DO L=1,NSTATE
          ZI=CG*XYZMAT(L,I,K)+SG*XYZMAT(L,J,K)
          ZJ=-SG*XYZMAT(L,I,K)+CG*XYZMAT(L,J,K)
          XYZMAT(L,I,K)=ZI
          XYZMAT(L,J,K)=ZJ
        ENDDO
        DO L=1,NSTATE
          ZI=CG*XYZMAT(I,L,K)+SG*XYZMAT(J,L,K)
          ZJ=-SG*XYZMAT(I,L,K)+CG*XYZMAT(J,L,K)
          XYZMAT(I,L,K)=ZI
          XYZMAT(J,L,K)=ZJ
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RMROT(NSTATE,ROTMAT,I,J,CG,SG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER I,J,NSTATE
      REAL*8 ROTMAT(NSTATE,NSTATE),CG,SG,ZI,ZJ
      INTEGER L
C     ==--------------------------------------------------------------==
      DO L=1,NSTATE
        ZI=CG*ROTMAT(L,I)+SG*ROTMAT(L,J)
        ZJ=-SG*ROTMAT(L,I)+CG*ROTMAT(L,J)
        ROTMAT(L,I)=ZI
        ROTMAT(L,J)=ZJ
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE EBERLEIN(ITER,NLIST,LPPL)
      IMPLICIT NONE
      INTEGER ITER,NLIST,LPPL(2,*)
      INTEGER I,II,JJ,LL,NPAIR
C     ==--------------------------------------------------------------==
      IF(NLIST.LE.1) CALL STOPGM('EBERLEIN','NLIST TOO SMALL')
      NPAIR=(NLIST+1)/2
      IF(ITER.EQ.1) THEN
C..set up initial ordering
        DO I=1,NLIST
          II=(I+1)/2
          JJ=MOD(I+1,2)+1
          LPPL(JJ,II)=I
        ENDDO
        IF(MOD(NLIST,2).EQ.1) LPPL(2,NPAIR)=-1
      ELSEIF(MOD(ITER,2).EQ.0) THEN
C..a type shift
        LL=LPPL(1,NPAIR)
        DO I=NPAIR,3,-1
          LPPL(1,I)=LPPL(1,I-1)
        ENDDO
        LPPL(1,2)=LPPL(2,1)
        LPPL(2,1)=LL
      ELSE
C..b type shift
        LL=LPPL(2,1)
        DO I=1,NPAIR-1
          LPPL(2,I)=LPPL(2,I+1)
        ENDDO
        LPPL(2,NPAIR)=LL
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_JROT(LWANN,TAG,NSTATE,SERIAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'wann.inc'
C     Arguments
      INTEGER   LWANN,NSTATE
      CHARACTER TAG*30
      LOGICAL   SERIAL
C     Variables
      INTEGER   LGMAT,NN,IP,NOMAX
C     ==--------------------------------------------------------------==
      IF(SERIAL.OR.NPROC.EQ.1) THEN
        LGMAT=NSTATE*NSTATE
        LWANN=LGMAT+100
      ELSE
        CALL SET_ORBDIST(NSTATE,1,NOMAX)
        NN=MAX(8*NOMAX*NOMAX*NWANOPT,2*NOMAX*NSTATE*NWANOPT,
     *         2*NOMAX*NPROC*NWANOPT)
        LGMAT=2*NN+2*NOMAX*NSTATE*NWANOPT+4*NOMAX*NOMAX
        NN=MAX(4*NOMAX*NOMAX,NSTATE*NSTATE)
        LGMAT=LGMAT+NN+2*NPROC
        LWANN=LGMAT+100
      ENDIF
      TAG='LWANN'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE XAPYB(N,X,RA,NA,Y,RB,NB,Z,LR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER       N,NA,NB,LR
      COMPLEX*16    X(N,NA),Y(N,NB),Z(N,NB)
      REAL*8        RA(LR,NB),RB(LR,NB)
      INTEGER       I,J,K
C     ==--------------------------------------------------------------==
      CALL ZAZZERO(Z,N*NB)
#ifdef __ES 
!$OMP parallel do private(J,I,K)
      DO J=1,NB
        DO I=1,N
          DO K=1,NA
            Z(I,J)=Z(I,J)+X(I,K)*RA(K,J)
          ENDDO
        ENDDO
      ENDDO
!$OMP parallel do private(J,I,K)
      DO J=1,NB
        DO I=1,N
          DO K=1,NB
            Z(I,J)=Z(I,J)+Y(I,K)*RB(K,J)
          ENDDO
        ENDDO
      ENDDO
#else 
      DO K=1,NA
        DO J=1,NB
          DO I=1,N
            Z(I,J)=Z(I,J)+X(I,K)*RA(K,J)
          ENDDO
        ENDDO
      ENDDO
      DO K=1,NB
        DO J=1,NB
          DO I=1,N
            Z(I,J)=Z(I,J)+Y(I,K)*RB(K,J)
          ENDDO
        ENDDO
      ENDDO
#endif 
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RMUPX(N,M,RMAT,X,LDX,NX,Y,LDY)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER       N,M,LDX,NX,LDY
      COMPLEX*16    X(LDX,NX),Y(LDY,NX)
      REAL*8        RMAT(N,M)
      INTEGER       I,J,K
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I,J,K)
      DO I=1,N
        DO J=1,NX
          DO K=1,M
            Y(I,J)=Y(I,J)+RMAT(I,K)*X(K,J)
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
