C     ==================================================================
      SUBROUTINE K_DIIS_RHOFIX(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     &                 RHOE,PSI,SCR,LSCR,NSTATE,TFOR,TINFO,DDRHO)
C     ==--------------------------------------------------------------==
C     ==               UPDATES THE WAVEFUNCTIONS                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'norm.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'store.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGWk,NSTATE,NKPNT),C2(NGWk,NSTATE),SC0(NGWk,NSTATE),
     &           PME(*),GDE(*),PSI(NNR1)
      REAL*8     TAU0(3*NAX*NSX),FION(3*NAX*NSX),EIGV(NSTATE,NKPTS),
     &           RHOE(NNR1),SCR(LSCR),VPP(NGWK)
      LOGICAL TFOR,TINFO
C     Variables
      DIMENSION TWNL(*),KGEMAX(NKPNT),KCNORM(NKPNT)
      DIMENSION  F(NSTATE,*)
      CHARACTER TAG*30
      INTEGER   LUPDWF,I,NUMLDIIS,JNFI
      REAL*8  F_SAVE(NSTATE*NKPNT),TIME1,TIME2,TCPU,TIMEF
      EXTERNAL TIMEF
      REAL*8  ETOT0,THL(2),DDRHO,GGTOL_RHO

C     ==--------------------------------------------------------------==

C       Test SCR
      CALL GIVE_SCR_UPDRHO(LUPDWF,TAG,NSTATE,.TRUE.,TPRES)
      CALL TEST_SCR('K_RHOFIX',TAG,LSCR,LUPDWF)
      IF(NONORT .OR. TPATH) THEN
        CALL STOPGM('K_RHOFIX','NONORT,TPATH not implemented') 
      ENDIF

C     ==--------------------------------------------------------------==
C     ==  UPDATE THE WAVEFUNCTIONS                                    ==
C     ==--------------------------------------------------------------==
c  copy occupation numbers
      do i=1,NSTATE*NKPNT
        f_save(i)=F(i,1)
        F(i,1)=1.d0
      enddo
      NUMLDIIS = MAXLDIIS
      ETOT0 = 0.0D0
      TDIAG = .false.
      GGTOL_RHO=TOLRHOFIX
      IF(DDRHO.gt.10.0D0*TOLOG) THEN
         GGTOL_RHO=5.D+2*TOLRHOFIX
      ELSEIF(DDRHO.gt.5.0D0*TOLOG) THEN
         GGTOL_RHO=5.D+1*TOLRHOFIX
      ELSEIF(DDRHO.gt.2.0D0*TOLOG) THEN
         GGTOL_RHO=5.D0*TOLRHOFIX
      ENDIF
      IF(PARENT.AND.TINFO) WRITE(6,'(A,1PE14.6,A,1PE14.6)')
     &      'DDRHO ',DDRHO, '  TOL ',GGTOL_RHO

      DO JNFI=1,NUMLDIIS
        TIME1=TIMEF()
        CALL K_FORCES(C0,C2,SC0,TAU0,PME,GDE,VPP,EIGV,FION,RHOE,PSI,
     *                SCR,LSCR,f_save,NSTATE,NKPNT,
     *               .TRUE.,TFOR,KDRHO,KDRHON, .false.,JNFI)
        IF(.NOT.TFOR) CALL AZZERO(FION,3*NAX*NSX)

        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(GEMAX.LT.GGTOL_RHO.OR. EXSOFT) CONVWF=.TRUE.
        IF(JNFI.LT.MINLDIIS)CONVWF=.FALSE.
        IF(PARENT) THEN
          ENGPRI=MOD(JNFI-1,IPRINT_STEP).EQ.0
        ELSE
          ENGPRI=.FALSE.
        ENDIF
C       PRINTOUT THE EVOLUTION OF THE ITERATIVE OPTIMIZATION
        IF(PARENT) THEN
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
          CALL WRPRINT_WFOPT(EIGV,F,AMU,N,ETOT,ETOT0,TCPU,
     &                       GEMAX,CNORM,THL,CONVWF,JNFI,JNFI)
        ENDIF
        IF(CONVWF) GOTO 100
      ENDDO
      IF(PARENT.AND.TINFO) THEN
        WRITE(6,'(1X,64("!"))')
        WRITE(6,'(" !!",A,T64,"!!")')
     &       ' RWFOPT| THE MAXIMUM NUMBER OF STEP IS REACHED'
        WRITE(6,'(1X,64("!"))')
      ENDIF
      CONVWF=.true.
100   CONTINUE

      CALL K_FORCES(C0,C2,SC0,TAU0,PME,GDE,VPP,EIGV,FION,RHOE,PSI,
     *              SCR,LSCR,f_save,NSTATE,NKPNT,
     *              .TRUE.,TFOR,KDRHO,KDRHON,.false.,JNFI)
!$OMP parallel do private(i)
      DO i=1,NSTATE*NKPNT
        F(i,1)=f_save(i)
      ENDDO

      TDIAG = .true.
      CONVWF=.false.
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      RETURN
      END
