C     ==================================================================
      SUBROUTINE K_FORCES(C0,C2,SC0,TAU0,PME,GDE,VPP,EIGV,FION,RHOE,
     &               PSI,SCR,LSCR,F_SAVE,NSTATE,NKPOINT,LPROJ,TFOR,
     &               DRHOMAX,DRHONORM,CALCRHO,ISTEP)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==                     THE TOTAL ENERGY                         ==
C     ==                  THE ELECTRONIC FORCES                       ==
C     ==                  THE FORCES ON THE IONS                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'norm.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'sfac.inc' 
      INCLUDE 'ener.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'broy.inc'
      include 'time.inc'
      include 'envj.inc'
      include 'rswf.inc'
      include 'vdwc.inc'
C     Arguments
      INTEGER    NSTATE,NKPOINT,LSCR,ISTEP
      COMPLEX*16 C0(NGWK,NSTATE,*),C2(NGWK,*),
     &           PSI(MAXFFT,*),SC0(NGWK,*),PME(*),GDE(*)
      REAL*8     TAU0(*),FION(3,*),F_SAVE(*),
     &           RHOE(NNR1,*),SCR(*),VPP(*),EIGV(NSTATE,*),
     &           DRHOMAX,DRHONORM
C     Variables
      DIMENSION  F(NSTATE,NKPTS),RIN0(NNR1,NLSD),RMIX(NNR1,NLSD),
     &           WK(NKPTS),RK(3,NKPTS),KGEMAX(NKPNT),KCNORM(NKPNT)
      REAL*8     GAM(NSTATE,NSTATE),DDIA(NAX),FSC(NSTATE)
      COMPLEX*16 AUXC(*)
      POINTER    (IP_GAM,GAM),(IP_AUXC,AUXC),(IP_DDIA,DDIA),(IP_FSC,FSC)
      REAL*8     FNL(IMAGP,LDF1,NHXS,*),DFNL(*)
      CHARACTER  TAG*30
      COMPLEX*16 ZEE
      REAL*8     DGIVE,DASUM,DOTP,DDOT
      COMPLEX*16 ZDOTC
      EXTERNAL   DGIVE,DASUM,DOTP,DDOT,ZDOTC
      REAL*8     BOTTOM,ENBAND,EE
      INTEGER    ISUB,IK,I,J,LSUMMAT,NFTO,NNX,LFORCES,NLEFT,
     &           IL_GAM,IL_AUXC,IL_DDIA,IL_FSC,IDAMAX,IMAX,nnxs,IB
      LOGICAL    LPROJ,TFOR,DEBUG,CALCRHO
C     ==--------------------------------------------------------------==
      CALL TISET('  K_FORCES',ISUB)

      GNMAX=0.0D0
      GNORM=0.0D0
      AMU    = -2000.0D0
      BOTTOM = 2000.0D0
      IF(ISTEP.EQ.1) THEN
        SDIIS=.TRUE.
        SPCG=.TRUE.
      ENDIF
C     ==--------------------------------------------------------------==
C     SCR partition
      DEBUG=.FALSE.
      IF(TIVAN .AND. LPROJ .AND. IPROJ.NE.0) THEN
        CALL GIVE_SCR_NLFORCE(IL_GAM,IL_AUXC,IL_DDIA,NSTATE)
      ELSE
        CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NSTATE)
        IL_GAM = IMAGP*NSTATE*NSTATE
      ENDIF
      CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NSTATE)
      IL_AUXC=MAX(IL_AUXC,LSUMMAT)
      IL_AUXC=MAX(IL_AUXC,NSTATE**2)  ! AUXC space for OVLAP (Laio A.)
      IL_FSC=NSTATE
      CALL GIVE_SCR_KFORCES(LFORCES,TAG,NSTATE,LPROJ,TFOR)
      CALL TEST_SCR('FORCES','LENGTH',LSCR,LFORCES)
C     ==--------------------------------------------------------------==
C     ==   CALCULATE THE POTENTIAL AND THE FORCE ON THE IONS          ==
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
C     == Compute the residual part of the ion-ion interaction (ESR)   ==
C     == due to the overlap of the smeared ionic charge densities     ==
C     == corresponding to different atoms.                            ==
C     ==--------------------------------------------------------------==
      NFTO=3*NAX*NSX
      CALL AZZERO(FION,NFTO)
      CALL RPIIINT(ESR,TAU0,FION,IESR,TFOR)
C     ==--------------------------------------------------------------==
C     == Calculate the Stress Tensor                                  ==
C     ==--------------------------------------------------------------==
      IF(CALSTE) CALL STRESS(C0,TAU0,F,PSI,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     == Compute the LOCAL PARTS of the energy and the forces, which  ==
C     == depend exclusively on the electronic density.                ==
C     ==--------------------------------------------------------------==
      NNX=NNR1*NLSD
c
      IF(CALCRHO) THEN
        CALL DCOPY(NNX,RIN0(1,1),1,RHOE(1,1),1)
        CALL VOFRHO(TAU0,FION,RHOE,PSI,SCR,LSCR,TFOR,CALSTE)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==   CALCULATE THE ELECTRONIC FORCE                             ==
C     ==--------------------------------------------------------------==

      IF(.NOT. CONVWF) THEN
        GEMAX = 0.0D0
        CNORM = 0.0D0
        ETOT  = 0.0D0
      ENDIF

      DO IK=1,NKPOINT

        CALL RNLSM(C0(1,1,IK),NSTATE,PSI,SCR,LSCR,1,IK,TFOR)

        CALL SCRSET(SCR,LSCR,DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_GAM,IL_GAM,'GAM',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_AUXC,IL_AUXC,'AUXC',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_DDIA,IL_DDIA,'DDIA',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_FSC,IL_FSC,'FSC',DEBUG)
c        CALL SCRPTR(SCR,LSCR,IP_VTEMP,IL_VTEMP,'VTEMP',DEBUG)

        CALL ZAZZERO(C2,NGWK*NSTATE)
 
C     ==--------------------------------------------------------------==
C     == COMPUTE THE FORCE ON THE ELECTRONIC DEGREES OF FREEDOM DUE   ==
C     == TO THE LOCAL POTENTIAL (STORED IN RHOE)                      ==
C     ==--------------------------------------------------------------==

c        IF(TIVAN) THEN
c         CALL DCOPY(NNX,RHOE,1,PSI,1) 
C     ==--------------------------------------------------------------==
C     == TRANSF. TOTAL POTENTIAL IN G-SPACE                           ==
C     == PUT THE TOTAL POTENTIAL IN G-SPACE INTO VTEMP                ==
C     ==--------------------------------------------------------------==
c          CALL FWFFT(PSI)
c          CALL ZGTHR(NHG,PSI,VTEMP,NZH)
c          IF(TLSD) THEN
c            CALL FWFFT(PSI(1,2))
c            CALL ZGTHR(NHG,PSI(1,2),VTEMP(1,2),NZH)
c          ENDIF
C     ==--------------------------------------------------------------==
C     == CALCULATE DEEQ FOR VANDERBILT PP                             ==
C     == FORCE ON IONS DUE TO THE "VANDERBILT CHARGE"                 ==
C     ==--------------------------------------------------------------==
c          IF(TLSD) THEN
c            CALL NEWD(FNL(1,1,1,1),DEEQ(1,1,1,1),F(1,1),
c     *              VTEMP(1,1),FION,SCR,LSCR,NSUP,TFOR)
c            CALL NEWD(FNL(1,1,1,NSUP+1),DEEQ(1,1,1,2),F(NSUP+1,1),
c     &              VTEMP(1,2),FION,SCR,LSCR,NSDOWN,TFOR)
c          ELSE
c            CALL NEWD(FNL,DEEQ,F,VTEMP,FION,SCR,LSCR,N,TFOR)
c          ENDIF
c        ENDIF

        CALL VPSI(C0(1,1,IK),C2,F(1,IK),RHOE,PSI,SCR,NSTATE,IK,NLSD)
        RSACTIVE=.FALSE.

        IF(TIVAN) THEN
          IF(TKPNT)  CALL STOPGM('K_FORCES',
     &           'VANDERBILT AND K-POINTS NOT IMPLEMENTED')
          IF(CONVWF) THEN
            CALL FNONLOC(C2,F,NSTATE,AUXC,DDIA,IK,NLSD)

            IF(GEQ0) THEN
              CALL ZCLEAN(C2,NSTATE,NGW)
            ENDIF

            CALL SCRREL(SCR,LSCR,DEBUG) 

            IF(TLSD) THEN
              CALL EV_KSENER(C0(1,1,IK),C2,SC0,EIGV(1,IK),FNL,SCR,
     &                 LSCR,IK,NSUP,BOTTOM,AMU,CALCRHO)         
              IB = NSUP+1
              CALL EV_KSENER(C0(1,IB,IK),C2(1,IB),SC0,EIGV(IB,IK),FNL,
     &                 SCR,LSCR,IK,NSDOWN,BOTTOM,AMU,CALCRHO)
            ELSE
              CALL EV_KSENER(C0(1,1,IK),C2,SC0,EIGV(1,IK),FNL,SCR,
     &                 LSCR,IK,NSTATE,BOTTOM,AMU,CALCRHO)         
            ENDIF
            GOTO 100
          ENDIF

          IF(LPROJ.AND.IPROJ.NE.0) THEN
            CALL OVLAP(NSTATE,GAM,C2,C0(1,1,IK))
            CALL HNLMAT(GAM,F,NSTATE)
#ifdef PARALLEL
            CALL GLOSUM(NSTATE*NSTATE,GAM)
#endif

C          H TRACE
            EE  = 0.0D0
!$OMP parallel do private(I) reduction(+:EE)
            DO I=1,NSTATE
              EE=EE+(-GAM(I,I))
            ENDDO
            ETOT = ETOT + EE

            IF(TFOR .AND. CALCRHO) 
     &             CALL RNLFL(FION,GAM,NSTATE,NKPOINT)
            IF(IPROJ.EQ.1 .AND. .NOT. CONVWF) THEN
              DO I=1,NSTATE
                CALL DAXPY(2*NGWK,-GAM(I,I),C0(1,I,IK),1,C2(1,I),1)
              ENDDO
            ELSEIF(IPROJ.EQ.2 .AND. .NOT. CONVWF) THEN
              CALL ROTATE(-1.0D0,C0(1,1,IK),1.0D0,C2,GAM,
     &                 NSTATE,2*NGWK,TLSD,NSUP,NSDOWN)
            ENDIF
            CALL NLFORCE(C2,F,GAM,AUXC,DDIA,NSTATE)
          ELSE
            CALL FNONLOC(C2,F,NSTATE,AUXC,DDIA,IK,NLSD)
          ENDIF
        ELSE
          CALL FNONLOC(C2,F,NSTATE,AUXC,DDIA,IK,NLSD)
          IF(CONVWF) THEN 
            CALL SCRREL(SCR,LSCR,DEBUG)
            IF(GEQ0) THEN
              IF(TKPNT) THEN 
                CALL ZCLEAN_K(C2,NSTATE,NGW)
              ELSE 
                CALL ZCLEAN(C2,NSTATE,NGW)
              ENDIF
            ENDIF
            IF(TLSD) THEN
              IF(TKPNT)THEN
                CALL K_KSENER(C0(1,1,IK),C2,SC0,EIGV(1,IK),SCR,
     &                 LSCR,IK,NSUP,BOTTOM,AMU,CALCRHO)         
                IB = NSUP+1
                 CALL K_KSENER(C0(1,IB,IK),C2(1,IB),SC0,EIGV(IB,IK),
     &                    SCR,LSCR,IK,NSDOWN,BOTTOM,AMU,CALCRHO)
              ELSE
                CALL EV_KSENER(C0(1,1,IK),C2,SC0,EIGV(1,IK),FNL,SCR,
     &                 LSCR,IK,NSUP,BOTTOM,AMU,CALCRHO)         
                IB = NSUP+1
               CALL EV_KSENER(C0(1,IB,IK),C2(1,IB),SC0,EIGV(IB,IK),FNL,
     &                    SCR,LSCR,IK,NSDOWN,BOTTOM,AMU,CALCRHO)
              ENDIF
            ELSE
              IF(TKPNT)THEN
                CALL K_KSENER(C0(1,1,IK),C2,SC0,EIGV(1,IK),SCR,LSCR,
     &                 IK,NSTATE,BOTTOM,AMU,CALCRHO)         
              ELSE
                CALL EV_KSENER(C0(1,1,IK),C2,SC0,EIGV(1,IK),FNL,SCR,
     &                 LSCR,IK,NSTATE,BOTTOM,AMU,CALCRHO)         
              ENDIF
            ENDIF
            GOTO 100
          ENDIF

C  ETOT
          IF(.NOT. CALCRHO) THEN
          EE  = 0.0D0
          IF(TKPNT) THEN
            DO I=1,NSTATE
             EE=EE-DDOT(2*NGWK,C0(1,I,IK),1,C2(1,I),1)*WK(IK)
            ENDDO
#ifdef PARALLEL
            CALL GLOSUM(1,EE)
#endif
            ETOT = ETOT + EE
          ELSE
            DO I=1,NSTATE
              EE=EE-DOTP(NGW,C0(1,I,1),C2(1,I))
            ENDDO
#ifdef PARALLEL
            CALL GLOSUM(1,EE)
#endif
            ETOT = ETOT + EE
          ENDIF
          ENDIF
          IF(LPROJ) THEN
            DO I=1,NSTATE
              IF(F(I,IK).EQ.0.D0) THEN
                FSC(I)=0.D0
              ELSE
                FSC(I)=1.D0
              ENDIF
            ENDDO
            IF(IPROJ.EQ.0) THEN
            ELSEIF(IPROJ.EQ.1) THEN
              IF(TKPNT) THEN                  
                DO I=1,NSTATE
                  ZEE=FSC(I)*ZDOTC(NGWK,C0(1,I,IK),1,C2(1,I),1)
#ifdef PARALLEL
                  CALL GLOSUM(2,ZEE)
#endif
                  CALL ZAXPY(NGWK,-ZEE,C0(1,I,IK),1,C2(1,I),1)
                ENDDO
              ELSE
                DO I=1,NSTATE
                  EE=FSC(I)*DOTP(NGW,C0(1,I,IK),C2(1,1))
#ifdef PARALLEL
                  CALL GLOSUM(1,EE)
#endif
                  CALL DAXPY(2*NGW,-EE,C0(1,I,IK),1,C2(1,1),1)
                ENDDO
              ENDIF            
            ELSEIF(IPROJ.EQ.2) THEN
              IF(TKPNT) THEN    
                CALL OVLAP_C(NSTATE,GAM,C2,C0(1,1,IK))
#ifdef PARALLEL
                CALL GLOSUM(2*NSTATE*NSTATE,GAM)
#endif
                CALL GSCAL_C(NSTATE,GAM,FSC)
                CALL ROTATE_C(DCMPLX(-1.0D0,0.D0),C0(1,1,IK),
     &                  DCMPLX( 1.0D0,0.D0),C2,GAM,NSTATE)
              ELSE
                CALL OVLAP(NSTATE,GAM,C2,C0(1,1,IK))
#ifdef PARALLEL
                CALL GLOSUM(NSTATE*NSTATE,GAM)
#endif
                CALL GSCAL(NSTATE,GAM,FSC)
                CALL ROTATE(-1.0D0,C0(1,1,IK),1.0D0,C2,GAM,
     &               NSTATE,2*NGWK,TLSD,NSUP,NSDOWN)
              ENDIF
            ENDIF
          ENDIF
        ENDIF
        IF(GEQ0) THEN
          IF(TKPNT) THEN
            CALL ZCLEAN_K(C2,NSTATE,NGW)
          ELSE
            CALL ZCLEAN(C2,NSTATE,NGW)
          ENDIF
        ENDIF
         
        CALL SCRREL(SCR,LSCR,DEBUG)

        IF(TKPNT) THEN
          CALL CSIZE(C2,NSTATE,KGEMAX(IK),KCNORM(IK))
          GEMAX = MAX(GEMAX,KGEMAX(IK))
          CNORM = MAX(CNORM,KCNORM(IK))
        ELSE
          CALL CSIZE(C2,NSTATE,GEMAX,CNORM)
        ENDIF

        IF(TKPNT)THEN
          IF (DIIS) THEN
            CALL K_HESELE(DT2BYE,VPP,IK)
            CALL K_ODIIS(C0(1,1,IK),C2,VPP,IK,NSTATE,PME,GDE,
     &                      DT2BYE,SDIIS,CALCRHO)
          ELSE IF(PCG) THEN
            CALL K_HESELE(DT2BYE,VPP,IK)
            CALL K_PCGRAD(C0(1,1,IK),C2,SC0,VPP,PME,
     &           RHOE,PSI,SCR,LSCR,TAU0,NSTATE,SPCG,IK)
          ENDIF
        ELSE
          IF(DIIS) THEN
            IF(SDIIS) CALL HESELE(DT2BYE,VPP)
            CALL ODIIS(C0,C2,VPP,NSTATE,PME,GDE,DT2BYE,SDIIS)
          ELSE IF(PCG) THEN
            IF(SPCG) CALL HESELE(DT2BYE,VPP)
            CALL PCGRAD(C0,C2,SC0,VPP,PME,
     &           RHOE,PSI,SCR,LSCR,TAU0,NSTATE,SPCG)
          ENDIF
        ENDIF

C     ==--------------------------------------------------------------==
C     ==  ORTHOGONALIZATION                                           ==
C     ==--------------------------------------------------------------==
        IF(NONORT)  THEN 
          IF(GEQ0) CALL ZCLEAN(C0,NSTATE,NGW)
        ELSE
          CALL PREORTHO(C0(1,1,IK),NSTATE,SCR,LSCR)
          IF(TIVAN) CALL RNLSM(C0,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
          CALL ORTHO(NSTATE,C0(1,1,IK),C2,SCR,LSCR)
        ENDIF
 100    CONTINUE
      ENDDO    ! KPOINT LOOP
c      do i = 1,10
c       write(6,'(i3,10f12.6)') i,(dreal(c0(ig,i,1)),ig=1,10)
c      enddo
c      stop 'c0'
C     ==--------------------------------------------------------------==
C     == Calculate NON-LOCAL PARTS of the energy and forces, which    ==
C     == depend on the wavefunctions themselves, and not on the       ==
C     == electronic density.                                          ==
C     ==--------------------------------------------------------------==

      CALL RNLRH(ENL,NSTATE,NKPOINT)
      IF(TFOR .AND. CALCRHO) THEN
        CALL RNLFOR(FION,F,WK,NSTATE,NKPOINT)
      ENDIF

C     ==--------------------------------------------------------------==
C     == Energy and force on the ions from van der Waals interaction  ==
C     ==--------------------------------------------------------------==
      EVDW=0.D0
      IF(VDWC) CALL VDW(TAU0,NVDW,IDVDW,IVDW,JVDW,VDWST,VDWRM,VDWBE,
     &              VDWEPS,S6GRIM,NXVDW,NYVDW,NZVDW,EVDW,FION,DEVDW)

C     ==--------------------------------------------------------------==
C     == TOTAL ENERGY                                                 ==
C     ==--------------------------------------------------------------==
      IF(CALCRHO) THEN
        EEIG = 0.D0
        ETOT = EKIN + EHT + EPSEU + ENL + EXC + EVDW

#ifdef PARALLEL
C     Sum ETOT,EKIN,EPSEU,ENL,EHT,EHEP,EHEE,EHII,EXC,VXC,EGC
        CALL GLOSUM(11,ETOT)
#endif
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  BAND ENERGY (only at the end)                               ==
C     ==--------------------------------------------------------------==
      IF(CONVWF .AND. PARENT .AND. CALCRHO) THEN
        write(6,'("BOTTOM LEVEL",F14.7)') BOTTOM*2*Ry
        write(6,'("MINIMUM CB",F14.7)') AMU*2*Ry
        WRITE(6,'(/,A)') ' EIGENVALUES(EV) AND OCCUPATION:'
        ENBAND = 0.0D0
        IF (TLSD) THEN
          WRITE(6,'(/,A)') '_____ SPIN UP'
          DO IK=1,NKPTS
            WRITE(6,'(1X,A,I8,4F12.6)')
     &           'K POINT:',IK,(RK(I,IK),I=1,3),WK(IK)
            DO I=1,NSUP,2
              NLEFT=MIN(NSUP-I,1)
              WRITE(6,'(3X,2(I3,F15.7,4X,F6.3,6X))') 
     *              (I+J,EIGV(I+J,IK)*(2*RY),
     *              F(I+J,IK),J=0,NLEFT)
                ENBAND = ENBAND +  EIGV(I,IK)*F(I,IK)*WK(IK)
              IF(I+1 .LE. NSTATE) 
     *          ENBAND = ENBAND +  EIGV(I+1,IK)*F(I+1,IK)*WK(IK)
            ENDDO
          ENDDO
          WRITE(6,'(/,A)') '_____ SPIN DOWN'
          IB = NSUP
          DO IK=1,NKPTS
            WRITE(6,'(1X,A,I8,4F12.6)')
     &           'K POINT:',IK,(RK(I,IK),I=1,3),WK(IK)
            DO I=1,NSDOWN,2
              NLEFT=MIN(NSDOWN-I,1)
              WRITE(6,'(3X,2(I3,F15.7,4X,F6.3,6X))') 
     *              (I+J,EIGV(IB+I+J,IK)*(2*RY),
     *              F(IB+I+J,IK),J=0,NLEFT)
                ENBAND = ENBAND +  EIGV(IB+I,IK)*F(IB+I,IK)*WK(IK)
              IF(I+1 .LE. NSTATE) 
     *          ENBAND = ENBAND +  EIGV(IB+I+1,IK)*F(IB+I+1,IK)*WK(IK)
            ENDDO
          ENDDO
        ELSE
          DO IK=1,NKPTS
            WRITE(6,'(1X,A,I8,4F12.6)')
     &           'K POINT:',IK,(RK(I,IK),I=1,3),WK(IK)
            DO I=1,NSTATE,2
              NLEFT=MIN(NSTATE-I,1)
              WRITE(6,'(3X,2(I3,F15.7,4X,F6.3,6X))') 
     *              (I+J,EIGV(I+J,IK)*(2*RY),
     *              F(I+J,IK),J=0,NLEFT)
              ENBAND = ENBAND +  EIGV(I,IK)*F(I,IK)*WK(IK)
              IF(I+1 .LE. NSTATE) 
     *          ENBAND = ENBAND +  EIGV(I+1,IK)*F(I+1,IK)*WK(IK)
            ENDDO
          ENDDO
        ENDIF
        write(6,'(" >>>>> BAND  ENERGY",F14.7)') ENBAND  
      ENDIF

      IF (CALCRHO) THEN
        RSACTIVE=KRWFN
        CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,NSTATE)
        CALL DCOPY(NNX,RHOE(1,1),1,RMIX(1,1),1)
        CALL DAXPY(NNX,-1.0D0,RIN0(1,1),1,RMIX(1,1),1)
        IMAX=IDAMAX(NNX,RMIX(1,1),1)
        DRHOMAX=DABS(DGIVE(RMIX(1,1),IMAX))
        DRHONORM=DASUM(NNX,RMIX(1,1),1)
#ifdef PARALLEL
        CALL GLOSUM(1,DRHONORM)
        CALL GLOMAX(1,DRHOMAX)
        NNXS=KR1S*KR2S*KR3S
#else
        NNXS=NNX
#endif
        DRHOMAX=DSQRT(OMEGA*DRHOMAX/DBLE(NNXS))
        DRHONORM=OMEGA*DRHONORM/DBLE(NNXS)
        CALL DCOPY(NNX,RHOE,1,RIN0,1)
      ENDIF

      IF(TFOR .AND. CALCRHO) THEN
#ifdef PARALLEL
        CALL GLOSUM(3*NAX*NSX,FION)
#endif
       IF(PARENT) THEN
          CALL SYMVEC(FION,SCR,LSCR)
          CALL TAUCL(FION)
          CALL GSIZE(FION,GNMAX,GNORM)
        ENDIF
      ENDIF
      CALL TIHALT('  K_FORCES',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE GIVE_SCR_KFORCES(LFORCES,TAG,NSTATE,LPROJ,TFOR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !CALSTE
      INCLUDE 'ropt.inc'        !CALSTE
      INCLUDE 'irat.inc'
      INCLUDE 'spin.inc'        !TLSE
      INCLUDE 'fft.inc'         !MAXFFT
      INCLUDE 'nlps.inc'        !IMAGP
      INCLUDE 'pslo.inc'
C     Arguments
      INTEGER   LFORCES,NSTATE
      CHARACTER TAG*30
      LOGICAL TFOR, LPROJ
C     Variables
      INTEGER   IL_GAM,IL_AUXC,IL_DDIA,LSUMMAT,LRNLSM,LRSCPOT,LSYMVEC,
     *          IL_FSC,IL_SCR,IL_KSENER,IL_PSIAB,LORTHO
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,TFOR)
      IF(TFOR) THEN
        CALL GIVE_SCR_SYMVEC(LSYMVEC,TAG)
      ELSE
        LSYMVEC=0
      ENDIF
      CALL GIVE_SCR_RSCPOT(LRSCPOT,TAG,CALSTE)
      IF(TIVAN .AND. LPROJ .AND. IPROJ.NE.0) THEN
        CALL GIVE_SCR_NLFORCE(IL_GAM,IL_AUXC,IL_DDIA,NSTATE)
      ELSE
        CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NSTATE)
        IL_GAM = IMAGP*NSTATE*NSTATE
      ENDIF
      CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NSTATE)
      IL_AUXC=MAX(IL_AUXC,2*LSUMMAT)
      IL_FSC=NSTATE
      IL_PSIAB=2
      IF(TLSE) IL_PSIAB=2*MAXFFT
      IL_SCR=IL_GAM+IL_AUXC+IL_DDIA+IL_FSC+IL_PSIAB+100
      IL_KSENER = 2*NSTATE*NSTATE + 3*2*NSTATE + NSTATE/IRAT +
     &             MAX(1,2*2*NSTATE-1)
      CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      LFORCES = MAX(LRNLSM,LRSCPOT,LSYMVEC,IL_SCR,IL_KSENER,LORTHO)
      TAG='LRNLSM,LRSCPOT,LSYMVEC,..'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ===================================================================
      SUBROUTINE EV_KSENER(C0,C2,SC0,EIGV,FNLA,SCR,LSCR,IK,NSTATE,
     &                BOTTOM,AMU,CALCRHO)
C     ==--------------------------------------------------------------==
C     ==                          CALCULATES:                         ==
C     ==       Eigenvalues and eigenvectors of the Hamiltonian        ==
C     ==  Rotates the optimized wfns in order to obtain the KS states ==
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'irat.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'sfac.inc'

C     Arguments:
      INTEGER        NSTATE,LSCR,IK
      COMPLEX*16     C0(NGWK,NSTATE),C2(NGWK,NSTATE),SC0(NGWK,NSTATE)
      REAL*8         EIGV(NSTATE),SCR(*),FNLA(LDF1,NHXS,*)

C     Variables
      REAL*8         HAMILT(NSTATE,NSTATE),WORK(*)
      pointer        (IP_HAMILT,HAMILT),(IP_WORK,WORK)
      REAL*8         AUX(3*2*NSTATE),BOTTOM,AMU,FNLB(LDF1,NHXS,NSTATE)
      pointer        (IP_AUX,AUX),(IP_FNLB,FNLB)
      REAL*8         FNL(*),DFNL(*)
      INTEGER        LENGTH,L_HAMILT,L_WORK,L_AUX,IERR,INDEX(NSTATE),
     &               L_INDEX,I,J,JJ
      pointer        (IP_INDEX,INDEX)
      LOGICAL        CALCRHO,TLSD_tmp

C     ==--------------------------------------------------------------==
#ifdef _BGL
      L_HAMILT = NSTATE*NSTATE+MOD(NSTATE*NSTATE,2)
      L_WORK   = MAX(1,2*2*NSTATE-1)+MOD(MAX(1,2*2*NSTATE-1),2)
      L_AUX    = 3*2*NSTATE
      L_INDEX  = NSTATE/IRAT+MOD(NSTATE/IRAT,2)
#else
      L_HAMILT = NSTATE*NSTATE
      L_WORK   = MAX(1,2*2*NSTATE-1)
      L_AUX    = 3*2*NSTATE
      L_INDEX  = NSTATE/IRAT
#endif

      LENGTH   = L_HAMILT + L_WORK + L_AUX + L_INDEX
      CALL  TEST_SCR('K_KSENER','L_ZHHEV',LSCR,LENGTH)

      CALL GET_ADDR(IP_HAMILT,SCR(1))
      CALL GET_ADDR(IP_AUX,SCR(1+L_HAMILT))
      CALL GET_ADDR(IP_WORK,SCR(1+L_HAMILT+L_AUX))
      CALL GET_ADDR(IP_INDEX,SCR(1+L_HAMILT+L_AUX+L_WORK))

      CALL IAZZERO(INDEX,NSTATE)
C     ==--------------------------------------------------------------==
      CALL AZZERO(HAMILT,NSTATE*NSTATE)

      TLSD_tmp = TLSD
      TLSD = .false.
      CALL OVLAP(NSTATE,HAMILT,C0,C2)
      TLSD = TLSD_tmp

#ifdef PARALLEL
      CALL GLOSUM(L_HAMILT,HAMILT)
#endif

      CALL DSYEV('V','U',NSTATE,HAMILT,NSTATE,EIGV,
     &                      WORK,L_WORK,IERR)
      IF(L_WORK.LT.INT(SCR(1))) THEN 
        WRITE(6,*) ' WARNING| LWORK SUBOPTIMAL FOR ZHEEV'
        WRITE(6,*) '   LWORK:',L_WORK
        WRITE(6,*) ' OPTIMAL:',INT(SCR(1))
      ENDIF
      CALL REORDER(NSTATE,NSTATE,EIGV,HAMILT)

      CALL DGEMM('N','N',2*NGWK,NSTATE,NSTATE,1.0D0,C0,2*NGWK,HAMILT,
     &                  NSTATE,0.0D0,SC0,2*NGWK)
      CALL DCOPY(2*NGWK*NSTATE,SC0,1,C0,1)
      CALL DGEMM('N','N',2*NGWK,NSTATE,NSTATE,1.0D0,C2,2*NGWK,HAMILT,
     &                  NSTATE,0.0D0,SC0,2*NGWK)
      CALL DCOPY(2*NGWK*NSTATE,SC0,1,C2,1)

      CALL SORT2(EIGV,NSTATE,INDEX)
      IF(CALCRHO) THEN 
        CALL DSCAL(NSTATE,-0.5D0,EIGV,1)
      ELSE
        CALL DSCAL(NSTATE,-1.0D0,EIGV,1)
      ENDIF
      DO I = 1 , NSTATE/2 
         AUX(1) = EIGV(NSTATE-I+1)
         EIGV(NSTATE-I+1) = EIGV(I)
         EIGV(I) = AUX(1)
         JJ = INDEX(NSTATE-I+1)
         INDEX(NSTATE-I+1) = INDEX(I)
         INDEX(I) = JJ
      ENDDO
      DO I=1,NSTATE
        J=INDEX(I)
        CALL DCOPY(2*NGWK,SC0(1,J),1,C2(1,I),1)
      ENDDO
      CALL  DCOPY(2*NGWK*NSTATE,C0,1,SC0,1)
      DO I=1,NSTATE
        J=INDEX(I)
        CALL DCOPY(2*NGWK,SC0(1,J),1,C0(1,I),1)
        AMU = MAX(AMU,EIGV(I))
        BOTTOM = MIN(BOTTOM,EIGV(I))
      ENDDO
      IF(TIVAN) THEN
        CALL GET_ADDR(IP_FNLB ,SC0(1,1))
        CALL DGEMM('N','N',LDF1*NHXS,NSTATE,NSTATE,1.0D0,FNLA,
     &            LDF1*NHXS,HAMILT,NSTATE,0.0D0,FNLB,LDF1*NHXS)
        DO I=1,NSTATE
          J=INDEX(I)
          CALL DCOPY(LDF1*NHXS,FNLB(1,1,J),1,FNLA(1,1,I),1)
        ENDDO
      ENDIF

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE K_KSENER(C0,C2,SC0,EIGV,SCR,LSCR,IK,NSTATE,BOTTOM,AMU,
     &                CALCRHO)
C     ==--------------------------------------------------------------==
C     ==                          CALCULATES:                         ==
C     ==       Eigenvalues and eigenvectors of the Hamiltonian        ==
C     ==  Rotates the optimized wfns in order to obtain the KS states ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'

C     Arguments:
      INTEGER        NSTATE,LSCR,IK
      COMPLEX*16     C0(NGWK,NSTATE),C2(NGWK,NSTATE),SC0(NGWK,NSTATE)
      REAL*8         EIGV(NSTATE),SCR(*)

C     Variables
      COMPLEX*16     HAMILT(NSTATE,NSTATE),WORK(*),ZZERO,ZONE
      POINTER        (IP_HAMILT,HAMILT),(IP_WORK,WORK)
      REAL*8         AUX(3*2*NSTATE),BOTTOM,AMU
      POINTER        (IP_AUX,AUX)
      INTEGER        LENGTH,L_HAMILT,L_WORK,L_AUX,IERR,INDEX(NSTATE),
     &               L_INDEX,I,J,JJ
      POINTER        (IP_INDEX,INDEX)
c      SAVE           BOTTOM,AMU
      LOGICAL        CALCRHO

C     ==--------------------------------------------------------------==

      L_HAMILT = 2*NSTATE*NSTATE
      L_WORK   = MAX(1,2*2*NSTATE-1)
      L_AUX    = 3*2*NSTATE
      L_INDEX  = NSTATE/IRAT

      LENGTH   = L_HAMILT + L_WORK + L_AUX + L_INDEX
      CALL  TEST_SCR('K_KSENER','L_ZHHEV',LSCR,LENGTH)

#ifdef _BGL
      CALL GET_ADDR(IP_HAMILT,SCR(1))
      CALL GET_ADDR(IP_AUX,SCR(1+L_HAMILT))
      CALL GET_ADDR(IP_WORK,SCR(1+L_HAMILT+L_AUX))
      CALL GET_ADDR(IP_INDEX,SCR(1+L_HAMILT+L_AUX+L_WORK+MOD(L_WORK,2)))
#else
      CALL GET_ADDR(IP_HAMILT,SCR(1))
      CALL GET_ADDR(IP_AUX,SCR(1+L_HAMILT))
      CALL GET_ADDR(IP_WORK,SCR(1+L_HAMILT+L_AUX))
      CALL GET_ADDR(IP_INDEX,SCR(1+L_HAMILT+L_AUX+L_WORK))
#endif

      ZZERO = DCMPLX(0.0D0,0.0D0)
      ZONE  = DCMPLX(1.0D0,0.0D0)

      CALL IAZZERO(INDEX,NSTATE)
C     ==--------------------------------------------------------------==

      CALL OVLAP_C(NSTATE,HAMILT,C0,C2)

#ifdef PARALLEL
      CALL GLOSUM(L_HAMILT,HAMILT)
#endif

      CALL ZHEEV('V','U',NSTATE,HAMILT,NSTATE,EIGV,
     &                      WORK,L_WORK,AUX,IERR)
      IF(L_WORK.LT.INT(SCR(1))) THEN 
        WRITE(6,*) ' WARNING| LWORK SUBOPTIMAL FOR ZHEEV'
        WRITE(6,*) '   LWORK:',L_WORK
        WRITE(6,*) ' OPTIMAL:',INT(AUX(1))
      ENDIF
      CALL REORDER_C(NSTATE,NSTATE,EIGV,HAMILT)
      CALL ZGEMM('N','N',NGWK,NSTATE,NSTATE,ZONE,C0,NGWK,HAMILT,
     &                  NSTATE,ZZERO,SC0,NGWK)
      CALL DCOPY(2*NGWK*NSTATE,SC0,1,C0,1)
      CALL ZGEMM('N','N',NGWK,NSTATE,NSTATE,ZONE,C2,NGWK,HAMILT,
     &                  NSTATE,ZZERO,SC0,NGWK)
      CALL DCOPY(2*NGWK*NSTATE,SC0,1,C2,1)

      CALL SORT2(EIGV,NSTATE,INDEX)
      IF(CALCRHO) THEN 
        CALL DSCAL(NSTATE,-0.5D0,EIGV,1)
      ELSE
        CALL DSCAL(NSTATE,-1.0D0,EIGV,1)
      ENDIF
      DO I = 1 , NSTATE/2 
         AUX(1) = EIGV(NSTATE-I+1)
         EIGV(NSTATE-I+1) = EIGV(I)
         EIGV(I) = AUX(1)
         JJ = INDEX(NSTATE-I+1)
         INDEX(NSTATE-I+1) = INDEX(I)
         INDEX(I) = JJ
      ENDDO
      DO I=1,NSTATE
        J=INDEX(I)
        CALL DCOPY(2*NGWK,SC0(1,J),1,C2(1,I),1)
      ENDDO
      CALL  DCOPY(2*NGWK*NSTATE,C0,1,SC0,1)
      DO I=1,NSTATE
        J=INDEX(I)
        CALL DCOPY(2*NGWK,SC0(1,J),1,C0(1,I),1)
        AMU = MAX(AMU,EIGV(I))
        BOTTOM = MIN(BOTTOM,EIGV(I))
      ENDDO

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
