C     ==================================================================
      SUBROUTINE K_HESELE (SVAR2,VPP,IK)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'simul.inc'
      INCLUDE 'kpnt.inc'
C     Arguments
      INTEGER   IK
      REAL*8    SVAR2,VPP(NGWK)
C     Variables
      DIMENSION TWNL(NGWK,NHXS,NSP,NKPNT),
     &          HGKP(NHG,NKPNT),HGKM(NHG,NKPNT)
      REAL*8    DD,VP,FTPI,EMP
      INTEGER   IG,ISA0,IS,IV,JV,L,KI,LI,L2,LJ,KJ,J
#ifdef PARALLEL
      INTEGER   MSGLEN
#endif
C     ==--------------------------------------------------------------==
C     ==  Calculate   H0 : The diagonal approximation to the          ==
C     ==                   2nd derivative matrix                      ==
C     ==--------------------------------------------------------------==
      IF(PREC) THEN
C     ==--------------------------------------------------------------==
C     ==  Local Potential                                             ==
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
        MSGLEN = 1 * 8
        CALL MY_BCAST(VPLOC,MSGLEN,IGEQ0,ALLGRP)
#endif
        VP=VPLOC
C     ==--------------------------------------------------------------==
C     ==  Nonlocal Potential                                          ==
C     ==--------------------------------------------------------------==
        DO IG=1,NGWK
          VPP(IG)=VP
          ISA0=0
          DO IS=1,NSP
            IF(TSGP(IS)) THEN
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L.EQ.L2.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    DD=HLSG(KI,KJ,L,IS)*NA(IS)
                    VPP(IG)=VPP(IG)+
     &                DD*TWNL(IG,IV,IS,IK)*TWNL(IG,JV,IS,IK)
                  ENDIF
                ENDDO
              ENDDO
            ELSE
              DO IV=1,NGH(IS)
                VPP(IG)=VPP(IG)+NA(IS)*WSG(IS,IV)
     *                  *TWNL(IG,IV,IS,IK)*TWNL(IG,IV,IS,IK)
              ENDDO
            ENDIF
            ISA0=ISA0+NA(IS)
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  Kinetic Energy                                              ==
C     ==--------------------------------------------------------------==
        FTPI=0.5D0*TPIBA2
        DO J=1,NGW
          VPP(J)=FTPI*HGKP(J,IK)+VPP(J)
          VPP(J+NGW)=FTPI*HGKM(J,IK)+VPP(J+NGW)
          EMP=HTHRS
          IF(VPP(J).LT.EMP) VPP(J)=EMP
          IF(VPP(J+NGW).LT.EMP) VPP(J+NGW)=EMP
        ENDDO
!$OMP parallel do private(J)
        DO J=1,NGWK
          VPP(J)=1.0D0/VPP(J)
        ENDDO
      ELSE
!$OMP parallel do private(J)
        DO J=1,NGWK
          VPP(J)=SVAR2
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
