C     ==================================================================
      SUBROUTINE K_ODIIS(C0,C2,VPP,IK,NSTATE,PME,GDE,SVAR2,
     &                     REINIT,CALCRHO)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'kpts.inc'
C     Arguments
      INTEGER    NSTATE,IK
      COMPLEX*16 C0(NGWK,*),C2(NGWK,*)
      REAL*8     VPP(*),PME(NGWK*NSTATE+8,MDIIS,*),
     &           GDE((NGWK*NSTATE+8)/4,MDIIS,*),
     &           SVAR2
      LOGICAL    REINIT,CALCRHO
C     Variables
      DIMENSION  F(NSTATE,NKPNT)     
      REAL*8     DIISM(MAXDIS,MAXDIS,NKPNT),GRMAX(MAXDIS,NKPNT),
     &           GIMAX(MAXDIS,NKPNT),GNORM(MAXDIS,NKPNT),
     &           EOLD,GAMMA(NKPNT)
      POINTER    (IP_DIISM,DIISM),(IP_GRMAX,GRMAX),(IP_GIMAX,GIMAX),
     &           (IP_GNORM,GNORM),(IP_GAMMA,GAMMA)
      INTEGER    NDIIS,NOWV,ISTATE
      REAL*8     BC(MAXDIS+1,MAXDIS+1),VC(MAXDIS+1),
     &           DE1,G1,G2,RATIO,RATION,RAIM,FF
      REAL*8     DDOT
      EXTERNAL   DDOT
      INTEGER    ISUB,I,NOWM,IG,K,J,NSIZE,IFIRST
#ifdef PARALLEL
      INTEGER    MSGLEN
#endif
      SAVE       IP_DIISM,IP_GRMAX,IP_GIMAX,IP_GNORM,EOLD,IP_GAMMA,
     &           NDIIS,NOWV,ISTATE,NSIZE
      DATA       ISTATE /0/
      DATA       IFIRST /0/
      SAVE       IFIRST
C     ==--------------------------------------------------------------==
      CALL TISET('     ODIIS',ISUB)

      IF(IFIRST .EQ. 0 ) THEN
        CALL MEMORY(IP_DIISM,MAXDIS*MAXDIS*NKPNT,'DIISM')
        CALL MEMORY(IP_GRMAX,MAXDIS*NKPNT,'GRMAX')
        CALL MEMORY(IP_GIMAX,MAXDIS*NKPNT,'GIMAX')
        CALL MEMORY(IP_GNORM,MAXDIS*NKPNT,'GNORM')
        CALL MEMORY(IP_GAMMA,NKPNT,'GAMMA')
        IFIRST = 1
        NOWV=0
      ENDIF
      IF(REINIT.OR.ISTATE.EQ.0 .AND. IK .EQ. 1 ) THEN
C       Reinitialization of diis procedure
        ISTATE=0
        EOLD=9999.D0
        CALL AZZERO(GAMMA,NKPNT)
        REINIT=.FALSE.
        NDIIS=0
      ENDIF
C     Empirical rules to assure convergence
      IF(ISTATE.NE.0) THEN
C       Check for an increase in energy

        DE1=ETOT-EOLD
        IF(CALCRHO) THEN
          IF(GEQ0) THEN
            IF(DE1.GT.0.0D0) THEN
              GAMMA(IK)=GAMMA(IK)+1.D0/VPP(1)
            ELSE
              GAMMA(IK)=0.75D0*GAMMA(IK)
            ENDIF
          ENDIF
        ENDIF
#ifdef PARALLEL
        MSGLEN= 1 * 8
        CALL MY_BCAST(GAMMA(IK),MSGLEN,IGEQ0,ALLGRP)
#endif
        REINIT=.FALSE.
        IF(NDIIS.GT.NRESET.AND.NRESET.GE.3) THEN
C..restart if there was no progress over the last steps 
          NOWM=NOWV+1
          IF(NOWV.EQ.MDIIS) NOWM=1
          G1=SQRT(GRMAX(NOWV,IK)**2 + GIMAX(NOWV,IK)**2)
          G2=SQRT(GRMAX(NOWM,IK)**2 + GIMAX(NOWM,IK)**2)
          RATIO=G1/G2
          RATION=GNORM(NOWV,IK)/GNORM(NOWM,IK)
          RAIM=1.0d0-DBLE(MDIIS)/100.d0
          IF(RATIO.GT.RAIM.AND.RATION.GT.RAIM .AND. G1.GT.1D-5)
     &        REINIT=.TRUE.
          IF(REINIT .AND. PARENT)
     &        WRITE(6,'(A,I8,A)') 
     &        ' ODIIS| Insufficient progress for K = ',IK,'; reset!'
          IF(REINIT) THEN
            ISTATE=0
            GAMMA(IK)=0.0D0
            REINIT=.FALSE.
          ENDIF
          IF(CALCRHO) THEN
            IF(DE1 .GE. 1.0D0 .AND. IK .EQ. 1) THEN
C         Reinitialization of diis procedure
              ISTATE=0
              EOLD=9999.D0
              CALL AZZERO(GAMMA,NKPNT)
              REINIT=.FALSE.
              NDIIS=0
            ELSEIF(DABS(DE1) .LE. 1.0D-8 .AND. IK .EQ. 1) THEN
              ISTATE=0
              EOLD=9999.D0
              CALL AZZERO(GAMMA,NKPNT)
              REINIT=.TRUE. 
              NDIIS=0
            ENDIF
            IF(REINIT .AND. PARENT)
     *          WRITE(6,'(A)')
     *        ' ODIIS| Insufficient progress; reset!'
          ENDIF
        ENDIF
      ENDIF

      IF(ISTATE.EQ.0 .AND. IK .EQ. 1) 
     &           CALL UPDIS(NDIIS,NOWV,NSIZE,MDIIS,0)
      IF(IK .EQ. 1)      ISTATE=2
C     Perform an electronic DIIS step
      IF(IK .EQ. 1) CALL UPDIS(NDIIS,NOWV,NSIZE,MDIIS,1)

      DO IG=1,NGWK
        VPP(IG)=VPP(IG)/(1.0D0+VPP(IG)*GAMMA(IK))
      ENDDO
C     Update DIIS buffers
      CALL DSCOPY(NGWK*NSTATE,C0,PME(1,NOWV,IK))
      CALL DSCAL(2*NGWK*NSTATE,-1.0D0,C2(1,1),1)
      CALL K_GRIMAX(C2,NSTATE,GRMAX(NOWV,IK),GIMAX(NOWV,IK),
     &         GNORM(NOWV,IK))
      CALL DICOPY(NGWK*NSTATE,C2,GDE(1,NOWV,IK),
     *              GRMAX(NOWV,IK),GIMAX(NOWV,IK))
C     Scale Gradient with Preconditioner(**2)
      DO K=1,NSTATE
        IF(PREC .AND. F(K,IK).GT.0.001D0) THEN
          FF=1.0D0/F(K,IK)
        ELSE
         FF=1.0D0
        ENDIF
!$OMP parallel do private(IG) shared(FF)
        DO IG=1,NGWK
          C2(IG,K)=C2(IG,K)*2.0D0*FF*FF*VPP(IG)*VPP(IG)
        ENDDO
      ENDDO
C     Update DIIS matrix
      DO I=1,NSIZE-1
        DIISM(I,NOWV,IK)=0.0D0
      ENDDO
      DO I=1,NSIZE-1
        CALL IDCOPY(NGWK*NSTATE,C0,GDE(1,I,IK),GRMAX(I,IK),GIMAX(I,IK))
        DO K=1,NSTATE
          DIISM(I,NOWV,IK)=DIISM(I,NOWV,IK)+
     &                      DDOT(2*NGWK,C0(1,K),1,C2(1,K),1)
        ENDDO
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(NSIZE-1,DIISM(1,NOWV,IK))
#endif
      DO I=1,NSIZE-1
        DIISM(NOWV,I,IK)=DIISM(I,NOWV,IK)
      ENDDO
C     Set up DIIS Matrix
      CALL AZZERO(BC,(MAXDIS+1)*(MAXDIS+1))
!$OMP parallel do private(I,J)
      DO I=1,NSIZE-1
        DO J=1,NSIZE-1
          BC(I,J)=DIISM(I,J,IK)
        ENDDO
      ENDDO
      DO I=1,NSIZE-1
        VC(I)=0.D0
        BC(I,NSIZE)=-1.D0
        BC(NSIZE,I)=-1.D0
      ENDDO
      VC(NSIZE)=-1.D0
      BC(NSIZE,NSIZE)=0.D0
C     Solve System of Linear Equations
      CALL SOLVE(BC,MAXDIS+1,NSIZE,VC)
#if defined(__VECTOR)
C     Compute Interpolated Coefficient Vectors
      CALL ZAZZERO(C0,NGWK*NSTATE)
      DO I=1,NSIZE-1
        CALL SDCOPY(NGWK*NSTATE,PME(1,I,IK),C2)
        CALL DAXPY(2*NGWK*NSTATE,VC(I),C2(1,1),1,C0(1,1),1)
      ENDDO
#else
C     do the above in one go and avoid having to use C2.
      CALL INTPCOEF(NGWK*NSTATE,NSIZE,NGWK*NSTATE+8,PME(1,1,IK),VC,C0)
#endif
C     Estimate New Parameter Vectors 
      DO I=1,NSIZE-1
        CALL IDCOPY(NGWK*NSTATE,C2,GDE(1,I,IK),GRMAX(I,IK),GIMAX(I,IK))
        FF=1.0D0
        DO K=1,NSTATE
          IF(PREC.AND.F(K,IK).GT.0.001D0) THEN
            FF=1.0D0/F(K,IK)
          ELSE
            FF=1.0D0
          ENDIF
!$OMP parallel do private(IG) shared(FF)
          DO IG=1,NGWK
            C0(IG,K)=C0(IG,K)-VC(I)*FF*VPP(IG)*C2(IG,K)
          ENDDO
        ENDDO
      ENDDO
      IF ( IK .EQ. NKPNT ) EOLD=ETOT
C      DO IG=1,NGWK
C        VPP(IG)=1.D0/(1.0D0/VPP(IG)-GAMMA)
C      ENDDO
      CALL TIHALT('     ODIIS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE K_GRIMAX(C2,N,GRMAX,GIMAX,GNORM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER N
      REAL*8  C2(2,NGWK*N),GRMAX,GIMAX,GNORM
C     Variables
      REAL*8  DDOT
      EXTERNAL DDOT
      INTEGER IR,II,I,
     &        IDAMAX
C     ==--------------------------------------------------------------==
      IR=IDAMAX(N*NGWK,C2(1,1),2)
      II=IDAMAX(N*NGWK,C2(2,1),2)
      GRMAX=C2(1,IR)
      GIMAX=C2(2,II)
      GNORM=0.0D0
      DO I=1,N
        II=(I-1)*NGWK+1
        GNORM=GNORM+DDOT(2*NGWK,C2(1,II),1,C2(1,II),1)
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(1,GNORM)
      CALL GLOMAX(1,GRMAX)
      CALL GLOMAX(1,GIMAX)
#endif
      GNORM=SQRT(GNORM/(N*NGWKS))
      RETURN
      END
C     ==================================================================
C     ==================================================================

