C     ==================================================================
      SUBROUTINE K_PCGRAD(C0,C2,SC0,VPP,HNM1,
     &                  RHOE,PSI,SCR,LSCR,TAU0,NSTATE,DINIT,IK)
C     ==--------------------------------------------------------------==
C     ==  PRECONDITIONED CONJUGATE GRADIENT OPTIMIZATION              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'nlps.inc'
      INCLUDE 'ropt.inc'        !MODENS
      INCLUDE 'kpnt.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'irat.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,IK
      COMPLEX*16 C0(NGWK,*),C2(NGWK,*),
     &           SC0(NGWK,*),HNM1(NGWK,NSTATE,*),PSI(*)
      REAL*8     VPP(*),RHOE(*),SCR(*),TAU0(*)
      LOGICAL    DINIT
C     Variables
      DIMENSION  F(NSTATE,NKPNT)
      REAL*8     TSCR(*)
      POINTER    (IP_TSCR,TSCR)
      CHARACTER  TAG*30
      REAL*8     DDOT
      EXTERNAL   DDOT
      REAL*8     GGNORM,DETOT,GAMMA,
     &           EHIST(10,NKPTS),GHIST(10,NKPTS),FHIST(10,NKPTS)
      pointer    (IP_EHIST,EHIST),(IP_GHIST,GHIST),(IP_FHIST,FHIST)
      SAVE       IP_EHIST,IP_GHIST,IP_FHIST
      INTEGER    ISUB,NOCC,I,IHIST,LSCR2,
     &           LPCGRAD,
     &           ISTEP(NKPTS),IFIRST
      POINTER    (IP_ISTEP,ISTEP)
      DATA       IFIRST / 0 /
      SAVE       IFIRST
c      DATA       ISTEP /NKPTS*0/
      SAVE       IP_ISTEP
C     ==--------------------------------------------------------------==
      CALL TISET('  K_PCGRAD',ISUB)
C     ==--------------------------------------------------------------==
C     Test SCR
      CALL GIVE_SCR_PCGRAD(LPCGRAD,TAG,NSTATE)
      CALL TEST_SCR('PCGRAD',TAG,LSCR,LPCGRAD)
      LSCR2=LSCR-3*NAX*NSX
      CALL GET_ADDR(IP_TSCR,SCR(LSCR2+1))
C     ==--------------------------------------------------------------==
C     Memory allocation
      IF(IFIRST .EQ. 0) THEN
        CALL MEMORY(IP_EHIST,10*NKPTS,'EHIST')
        CALL MEMORY(IP_GHIST,10*NKPTS,'GHIST')
        CALL MEMORY(IP_FHIST,10*NKPTS,'FHIST')
        CALL MEMORY(IP_ISTEP,NKPTS/IRAT+1,'ISTEP')
        CALL IAZZERO(ISTEP,NKPTS)
        IFIRST = 1
      ENDIF

      NOCC=0
      DO I=1,NSTATE
        IF(F(I,IK).GT.1.D-5) NOCC=NOCC+1
      ENDDO

      IF(DINIT) THEN 
        CALL IAZZERO(ISTEP,NKPTS)
        DINIT=.FALSE.
      ENDIF

      ISTEP(IK)=ISTEP(IK)+1
      IF(PREC) CALL PRECON(C2,VPP,F,NGWK,NSTATE,0)
      GGNORM=0.0D0
      DO I=1,NOCC
        GGNORM=GGNORM+DDOT(2*NGWK,C2(1,I),1,C2(1,I),1)
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(1,GGNORM)
#endif
      IF(ISTEP(IK).LE.1) THEN
C     ==--------------------------------------------------------------==
C     ==  INITIAL CALL                                                ==
C     ==--------------------------------------------------------------==
        EHIST(1,IK)=ETOT
        FHIST(1,IK)=DT2BYE
        GHIST(1,IK)=GGNORM
        IF(PCGMIN) CALL STOPGM('k_pcgrad',
     &                      'Line Search not implemented yet')
c        IF(PCGMIN) THEN
c          CALL DCOPY(2*NGW*NSTATE,C2(1,1),1,HNM1(1,1),1)
c          CALL DSCAL(2*NGW*NSTATE,FHIST(1),HNM1(1,1),1)
c          ALAM=1.0D0
c          IF(PARENT) CALL EBACK(0)
c          CALL LINESR(NSTATE,C0,HNM1,C2,SC0,TAU0,TSCR,
c     &                RHOE,PSI,SCR,LSCR2,
c     *                FHIST(1),DE,A,ALAM)
c          IF(PARENT) THEN
c            CALL EBACK(1)
c            WRITE(6,'(A,G8.3,A,T55,G15.8)') 
c     *        ' LINE SEARCH : LAMBDA=',ALAM*FHIST(1),
c     *        '       ENERGY =',DE
c          ENDIF
c        ELSE
          CALL DCOPY(2*NGWK*NSTATE,C2(1,1),1,HNM1(1,1,IK),1)
          CALL DAXPY(2*NGWK*NSTATE,FHIST(1,IK),C2(1,1),1,C0(1,1),1)
c        ENDIF
      ELSE
C     ==--------------------------------------------------------------==
C     ==  CONJUGATE GRADIENT                                          ==
C     ==--------------------------------------------------------------==
        IF(ISTEP(IK).GT.10) THEN
          IHIST=10
          DO I=1,9
            EHIST(I,IK)=EHIST(I+1,IK)
            FHIST(I,IK)=FHIST(I+1,IK)
            GHIST(I,IK)=GHIST(I+1,IK)
          ENDDO
        ELSE
          IHIST=ISTEP(IK)
        ENDIF
        EHIST(IHIST,IK)=ETOT
        GHIST(IHIST,IK)=GGNORM
        DETOT=EHIST(IHIST,IK)-EHIST(IHIST-1,IK)
        IF(DETOT.GT.0.D0) THEN
          FHIST(IHIST,IK)=0.75D0*FHIST(IHIST-1,IK)
        ELSE
          FHIST(IHIST,IK)=FHIST(IHIST-1,IK)
        ENDIF
        GAMMA=GHIST(IHIST,IK)/GHIST(IHIST-1,IK)
c        IF(PCGMIN) THEN
c          DO I=1,NSTATE
c            DO IG=1,NGW
c              HNM1(IG,I)=C2(IG,I)+HNM1(IG,I)*GAMMA
c            ENDDO
c          ENDDO
c          CALL LINESR(NSTATE,C0,HNM1,C2,SC0,TAU0,TSCR,
c     &                RHOE,PSI,SCR,LSCR2,
c     *                FHIST(IHIST),DE,A,ALAM)
c          IF(PARENT) THEN
c            WRITE(6,'(A,G8.3,A,T55,G15.8)') 
c     *        ' LINE SEARCH : LAMBDA=',ALAM*FHIST(IHIST),
c     *        '       ENERGY =',DE
c          ENDIF
c        ELSE
          CALL DAXPY(2*NGWK*NSTATE,GAMMA,HNM1(1,1,IK),1,C2(1,1),1)
          CALL DCOPY(2*NGWK*NSTATE,C2(1,1),1,HNM1(1,1,IK),1)
          CALL DAXPY(2*NGWK*NSTATE,FHIST(IHIST,IK),
     &                             HNM1(1,1,IK),1,C0(1,1),1)
c        ENDIF
      ENDIF
      CALL TIHALT('  K_PCGRAD',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE K_LINESR(NSTATE,X,P,CS,SC0,TAU0,TSCR,
     &                  RHOE,PSI,SCR,LSCR,FAC,DE,A,ALAM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'ions.inc'        !NAT
      INCLUDE 'nlps.inc'
      INCLUDE 'ropt.inc'        !MODENS
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 X(NGW,NSTATE),P(NGW,NSTATE),CS(NGW*NSTATE),
     &           SC0(NGW,NSTATE),PSI(NNR1)
      REAL*8     TAU0(3*NAX*NSX),TSCR(3*NAX*NSX),RHOE(NNR1),SCR(LSCR),
     &           FAC,DE,A,ALAM
C     Variables
      CHARACTER  TAG*30
      REAL*8     E0,DD,E1,E2,DX,X0,EE
      REAL*8     DOTP
      EXTERNAL   DOTP
      INTEGER    I,LLINESR
C     ==--------------------------------------------------------------==
C     Test SCR
      CALL GIVE_SCR_LINESR(LLINESR,TAG,NSTATE)
      CALL TEST_SCR('LINESR',TAG,LSCR,LLINESR)
C     ==--------------------------------------------------------------==
      IF(PARENT) CALL EBACK(0)
C   Here one should calculate the E0 relative to one single k_point
C   with the wavefunction in the array X
      E0=ETOT
      ALAM=1.0D0
      CALL DSCAL(2*NGW*NSTATE,FAC,P(1,1),1)
      DD=0.0D0
      DO I=1,NSTATE
        DD=DD+DOTP(NGW,P(1,I),P(1,I))
      ENDDO
      CALL GLOSUM(1,DD)
C     First point
      CALL DCOPY(2*NGW*NSTATE,X(1,1),1,CS(1),1)
      CALL DAXPY(2*NGW*NSTATE,ALAM,P(1,1),1,X(1,1),1)
      IF(NONORT) THEN
        CALL STOPGM('LINESR','NOT IMPLEMENTED')
      ELSE
        IF(TIVAN) CALL RNLSM(X,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
        CALL PREORTHO(X,NSTATE,SCR,LSCR)
        CALL ORTHO(NSTATE,X,SC0,SCR,LSCR)
        CALL RNLSM(X,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
C   Here one should calculate the energy relative to one single k_point
C   with the updated wavefunction copied in the array X
C          CALL RSCPOT(X,TAU0,TSCR,RHOE,PSI,SCR,LSCR,
C     &                .FALSE.,.FALSE.,NSTATE,1)
      ENDIF
      IF(ETOT.GT.E0) THEN
        E2=ETOT
        ALAM=0.5D0
      ELSE
        E1=ETOT
        ALAM=2.0D0
      ENDIF
C     Second point
      CALL DCOPY(2*NGW*NSTATE,CS(1),1,X(1,1),1)
      CALL DAXPY(2*NGW*NSTATE,ALAM,P(1,1),1,X(1,1),1)
      IF(NONORT) THEN
        CALL STOPGM('LINESR','NOT IMPLEMENTED')
      ELSE
        IF(TIVAN) CALL RNLSM(X,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
        CALL PREORTHO(X,NSTATE,SCR,LSCR)
        CALL ORTHO(NSTATE,X,SC0,SCR,LSCR)
        CALL RNLSM(X,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
C   Here one should calculate the energy relative to one single k_point
C   with the updated wavefunction copied in the array X
C        CALL RSCPOT(X,TAU0,TSCR,RHOE,PSI,SCR,LSCR,
C     &                .FALSE.,.FALSE.,NSTATE,1)
      ENDIF
      IF(ALAM.GT.1.D0) THEN
        E2=ETOT
        DX=1.0D0
      ELSE
        E1=ETOT
        DX=0.5D0
      ENDIF
C     Extrapolation
      IF((2*E0-4*E1+2*E2).EQ.0.D0) THEN
C       Very rare (T.D.)
        X0=DX
      ELSE
        X0=DX*(4*E1-E2-3*E0)/(2*E0-4*E1+2*E2)
      ENDIF
      A=(E1-E0)/DX/(2*X0+DX)
      EE=E0-A*X0*X0
      ALAM=-X0
      IF(ALAM.GT.0.D0) THEN
        IF(ALAM.GT.3.D0) ALAM=3.0D0
      ELSE
        IF(E2.LT.E0) THEN
          ALAM=2*DX
        ELSEIF(E1.LT.E0) THEN
          ALAM=DX
        ELSE
          ALAM=0.05D0
        ENDIF
      ENDIF
      DE=EE+A*(X0+ALAM)**2
      A=A/DD
      CALL DCOPY(2*NGW*NSTATE,CS(1),1,X(1,1),1)
      CALL DAXPY(2*NGW*NSTATE,ALAM,P(1,1),1,X(1,1),1)
      CALL DSCAL(2*NGW*NSTATE,1.D0/FAC,P(1,1),1)
      IF(ALAM.LT.0.1D0) THEN
        FAC=FAC*0.25D0
      ELSEIF(ALAM.GT.1.00D0) THEN
        FAC=FAC*1.50D0
      ELSEIF(ALAM.LT.0.20D0) THEN
        FAC=FAC*0.75D0
      ENDIF
      IF(PARENT) CALL EBACK(1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
