C     ==================================================================
      SUBROUTINE K_UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     &                 RHOE,PSI,SCR,LSCR,NSTATE,TFOR,ISTEP)
C     ==--------------------------------------------------------------==
C     ==               UPDATES THE WAVEFUNCTIONS                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'norm.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER    NSTATE,LSCR,ISTEP
      COMPLEX*16 C0(NGWk,NSTATE,NKPNT),C2(NGWk,NSTATE),SC0(NGWk,NSTATE),
     &           PME(*),GDE(*),PSI(NNR1)
      REAL*8     TAU0(3*NAX*NSX),FION(3*NAX*NSX),EIGV(NSTATE,NKPTS),
     &           RHOE(NNR1),SCR(LSCR),VPP(NGWK)
      LOGICAL TFOR,CALCRHO
C     Variables
      DIMENSION TWNL(*),KGEMAX(NKPNT),KCNORM(NKPNT)
      REAL*8  F_SAVE(NSTATE*NKPNT)
      CHARACTER TAG*30
      INTEGER   LUPDWF,I

C     ==--------------------------------------------------------------==

C       Test SCR
      CALL GIVE_SCR_KUPDWF(LUPDWF,TAG,NSTATE,TFOR)
      CALL TEST_SCR('UPDWF',TAG,LSCR,LUPDWF)
      IF(NONORT .OR. TPATH) THEN
        CALL STOPGM('K_UPDWF','NONORT,TPATH not implemented') 
      ENDIF
      IF(TLSD .AND. NSTATE .GT. INT(NEL)) THEN
        CALL STOPGM('K_UPDWF',
     &        'KPOINT+VIRTUAL STATES only with DIAGONALIZATION methods')
      ELSEIF(.NOT. TLSD .AND. NSTATE .GT. INT(NEL/2 + 1)) THEN
        CALL STOPGM('K_UPDWF',
     &        'KPOINT+VIRTUAL STATES only with DIAGONALIZATION methods')
      ENDIF

C     ==--------------------------------------------------------------==
C     ==  UPDATE THE WAVEFUNCTIONS                                    ==
C     ==--------------------------------------------------------------==
      CALCRHO = .TRUE.
      CALL K_FORCES(C0,C2,SC0,TAU0,PME,GDE,VPP,EIGV,FION,RHOE,PSI,
     *      SCR,LSCR,f_save,NSTATE,NKPNT,.TRUE.,TFOR,KDRHO,KDRHON,
     *      CALCRHO,ISTEP)
      IF(.NOT.TFOR) CALL AZZERO(FION,3*NAX*NSX)

      IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
      IF(GEMAX.LT.TOLOG .OR. EXSOFT) THEN 
        CONVWF=.TRUE.
      ELSEIF(KDRHO .LT. .05D0*TOLOG .AND.GEOPT ) THEN
          WRITE(6,'(" ==",60("-"),"==")')
          write(6,'(A,1PE12.4,A,1PE12.4)') 
     &         '  CONVERGENCE OF THE DENSITY, DRHOMAX = ',
     &         KDRHO,' DRHONORM = ', KDRHON   
          write(6,'(A)') '  WFNS NOT CONVERGED, MAX'
          DO I = 1,NKPNT
            write(6,'(A,I5,A,1PE12.4)') 'KPOINT NUM.', I,' KGEMAX = ',
     &       KGEMAX(I)
          ENDDO
          WRITE(6,'(" ==",60("-"),"==")')
          CONVWF=.TRUE.
      ENDIF

C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_KUPDWF(LUPDWF,TAG,NSTATE,TFOR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NONORT
C     Arguments
      INTEGER   LUPDWF,NSTATE
      LOGICAL   TFOR
      CHARACTER TAG*30
C     Variables
      INTEGER   LFORCES,LORTHO,LPCGRAD
C     ==--------------------------------------------------------------==
      LORTHO=0
      CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.TRUE.,TFOR)
      CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      IF(PCG) THEN
        CALL GIVE_SCR_PCGRAD(LPCGRAD,TAG,NSTATE)
      ELSE
        LPCGRAD=0
      ENDIF
      LUPDWF=MAX(LFORCES,LORTHO,LPCGRAD)+10
      TAG='MAX(LFORCES,LORTHO,LPCGRAD)'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
