C     ==================================================================
      SUBROUTINE KDDIPO(TAU0,C0,CM,C2,SC0,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     == CALCULATES THE BERRY PHASE POLAIZATION                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'kpnt.inc'
      include 'kpts.inc'
      include 'irat.inc'
      INCLUDE 'store.inc'
C input
      INTEGER LSCR,NSTATE
      REAL*8 TAU0(3,NAX,*),SCR(*)
      COMPLEX*16 C0(NGWK,NSTATE,NKPNT),C2(*),SC0(*),CM(*)
C local
      CHARACTER*30   TAG
      DIMENSION  RK(3,NKPTS)
      REAL*8 R1(3),R2(3),R3(3),delt,del1(3),del2(3),del3(3)
      REAL*8 B1(3),B2(3),B3(3)
      INTEGER        ISUB,LENGTH,KNN(NKPNT,3),I,J,K,L,NMCOL,N1
      COMPLEX*16 MKL(NSTATE,NSTATE,NKPNT,*),DD
      POINTER (IP_MKL,MKL),(IP_KNN,KNN)
      INTEGER MAPFUL(*),MAPCOL(*),NGWMAX
      POINTER (IP_MAPFUL,MAPFUL),(IP_MAPCOL,MAPCOL)
C     ==--------------------------------------------------------------==
      CALL TISET('    KDDIPO',ISUB)
      CALL GIVE_SCR_KDDIPO(LENGTH,NSTATE,TAG)
      CALL TEST_SCR('KDDIPO','LENGTH',LSCR,LENGTH)

      CALL MEMORY(IP_KNN,3*NKPNT,"KNN")
      CALL MEMORY(IP_MKL,NSTATE*NSTATE*NKPNT*3*2,"MKL")
      CALL MEMORY(IP_MAPFUL,2*(NGWKS/IRAT+1),'MAPFUL')
#ifdef PARALLEL
      N1=0
      DO I=0,NPROC-1
        N1=MAX(N1,SPARM(3,I))
      ENDDO
      NGWMAX=N1
      NMCOL=(NPROC*NGWMAX)/IRAT+1
#else
      NMCOL=1
      NGWMAX=NGW
#endif
      CALL MEMORY(IP_MAPCOL,NMCOL,'MAPCOL')
      CALL SETDIP(MAPFUL,MAPCOL,SCR,LSCR)


      Print*,'NK1=',NK1,'NK2=',NK2,'NK3=',NK3
      print*,'NGW=',NGW,'NGWK=',NGWK,'NGWMAX=',NGWMAX
      print*,'NGWS=',NGWS,'NGWKS=',NGWKS
      CALL RECIPS(ALAT,A1,A2,A3,B1,B2,B3)   
      delt=0.0000001d0

      DO J=1,3
        B1(J)=B1(J)/NK1 
        B2(J)=B2(J)/NK2 
        B3(J)=B3(J)/NK3 
c        print*,'B1=',J,B1(J)
c        print*,'B2=',J,B2(J)
c        print*,'B3=',J,B3(J)
      ENDDO

      DO I=1,NKPNT
       DO J=1,3
       KNN(I,J)=0
       ENDDO
      ENDDO

      DO I=1,NKPNT
c      print*,'--------------------------'
       DO J=1,3   
        R1(J)=RK(J,I)+B1(J) 
        R2(J)=RK(J,I)+B2(J)
        R3(J)=RK(J,I)+B3(J)
c        print*,'J=',J,'R1=',R1(J),'R2=',R2(J),'R3=',R3(J)
       ENDDO

       DO K=1,NKPNT
c      print*,'I=',I,'-------------------------------------'
c      print*,'K=',K,'RK=',RK(1,K),RK(2,K),RK(3,K)
c      print*,'K=',K,'R1=',R1(1),R1(2),R1(3)
c      print*,'K=',K,'R2=',R2(1),R2(2),R2(3)
c      print*,'K=',K,'R3=',R3(1),R3(2),R3(3)
         DO J=1,3 
       
         del1(J)=ABS(RK(J,K)-R1(J))
         del2(J)=ABS(RK(J,K)-R2(J))
         del3(J)=ABS(RK(J,K)-R3(J))

         ENDDO

       IF(del1(1).lt.delt.and.del1(2).lt.delt.
     * and.del1(3).lt.delt)then
       KNN(I,1)=K
       ENDIF
       IF(del2(1).lt.delt.and.del2(2).lt.delt.
     * and.del2(3).lt.delt)then
       KNN(I,2)=K
       ENDIF
       IF(del3(1).lt.delt.and.del3(2).lt.delt.
     * and.del3(3).lt.delt)then
       KNN(I,3)=K
       ENDIF

       ENDDO
      ENDDO

      print*,'kpoints'


      DO I=1,NKPNT
        print*,'I=',I,'KN1=',KNN(I,1)
        IF(KNN(I,1).EQ.0)THEN
         print*,'last point in B1 direction'
        ENDIF
         print*,'I=',I,'KN2=',KNN(I,2)
        IF(KNN(I,2).EQ.0)THEN
         print*,'last point in B2 direction'
        ENDIF
         print*,'I=',I,'KN3=',KNN(I,3)
        IF(KNN(I,3).EQ.0)THEN
         print*,'last point in B3 direction'
        ENDIF
      ENDDO

      DO I=1,NKPNT
       DO J=1,3
         L=KNN(I,J)
         IF(L.EQ.0) THEN
           CALL OPEIGR_C(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,
     *     MKL,SCR,LSCR,J,0,DD)
         ELSE
           CALL OVLAP_C(NSTATE,MKL,C0(1,1,I),C0(1,1,L))
         ENDIF
       ENDDO
      ENDDO

      print*,'overlap matrix'
      print*,'end kddipo'

      CALL FREEM(IP_MKL)
      CALL FREEM(IP_KNN)
      CALL FREEM(IP_MAPCOL)
      CALL FREEM(IP_MAPFUL)

      CALL TIHALT('    KDDIPO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END

C     ==================================================================
      SUBROUTINE GIVE_SCR_KDDIPO(LDDIPO,NSTATE,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        
      INTEGER   LDDIPO,LOPEIGR,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_OPEIGR(LOPEIGR,TAG,NSTATE)
      LDDIPO=MAX(LOPEIGR,10)+100
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
