      subroutine kdp_diag(nstate,pkdp,xlambda0,xkdp,nkdp,ekdp,akdp,
     s                    noccup,auxdiag,rauxdiag)
c
      implicit none
      include 'system.h'
      include 'cnst.inc'
      include 'elct.inc'
      include 'ropt.inc'

      integer    nstate,nkdp,noccup,info,isub
      complex*16 xlambda0(nstate,nstate)
      complex*16 akdp(nstate,nstate,nkdp)
      complex*16 auxdiag(2*nstate)
      real*8     rauxdiag(3*nstate)
      real*8     pkdp(3,nstate,nstate)
      real*8     ekdp(nstate,nkdp)
      real*8     xkdp(3,nkdp)
c
c Local variables
      complex*16 hkdp(nstate*(nstate+1)/2)
      complex*16 xlambda(nstate,nstate)
      complex*16 akdp2(nstate,nstate)
      pointer    (ip_hkdp,hkdp),(ip_xlambda,xlambda),
     &           (ip_akdp2,akdp2)
      real*8     x3kdp
      integer    ikdp,istat,jstat,kstat,icoor
c
c     ==================================================================
c     == Select diagonalization method, according to the relative     ==
c     == dimension of the occupied subspce with respect to the full   ==
c     == space.                                                       ==
c     ==--------------------------------------------------------------==
ctemp      if(nint(nel/2.d0)+5.lt.nint(0.3d0*nstate)) then
ctemp        noccup=nint(nel/2.d0)+5
ctemp      else
ctemp        noccup=nstate
ctemp      endif
C     ==--------------------------------------------------------------==
C     Allocation of memory.
      call memory(ip_hkdp,nstate*(nstate+1),'HDKP')
      call memory(ip_xlambda,2*nstate*nstate,'XLAMBDA')
      call memory(ip_akdp2,2*nstate*nstate,'AKDP2')
C     ==--------------------------------------------------------------==
      noccup=nstate
c
c      print *
c      print *,' Performing k.p diagonalization calculating:'
c      print *,' ',noccup,' out of ',nstate,' states.'
      if(nfi.eq.nomore) then
        write(44,*)'Eigenvalues'
        write(44,*)
        write(47,*)'Occupations'
        write(47,*)
      endif
c
      CALL TISET('  KDP_DIAG',ISUB)
c     ==================================================================
c     == Do-loop over k-points.                                       == 
c     ==--------------------------------------------------------------==
      do ikdp=1,nkdp
c
c     ==================================================================
c     == Construct k^2.                                               ==
c     ==--------------------------------------------------------------==
        x3kdp=0.d0
        do icoor=1,3
          x3kdp=x3kdp+0.5d0*xkdp(icoor,ikdp)**2
        enddo
c
c
c     ==================================================================
c     == Build k.p matrix at k-point ikdp, and store in array hkdp.   ==
c     ==--------------------------------------------------------------==
        do istat=1,nstate
          do jstat=1,nstate
            xlambda(istat,jstat)=(0.d0,0.d0)
c
c Nonlocal part (Not tested yet)
c            isa=0
c            do is=1,nspnl
c              do ia=1,na(is)
c                isa=isa+1
c                do igh=1,ngh
c                  xlambda(istat,jstat)= xlambda(istat,jstat) + 
c     &                                  wsg(is,igh) *
c     &            dconjg(fnlkdp(isa,istat,igh,ikdp))*
c     &                   fnlkdp(isa,jstat,igh,ikdp)
c                enddo
c              enddo
c            enddo
c
c local + kinetic parts
c
            xlambda(istat,jstat) = xlambda(istat,jstat) + 
     .                             xlambda0(istat,jstat)
          enddo
          xlambda(istat,istat) = xlambda(istat,istat) + x3kdp
        enddo
c
c k.p term
c
        do jstat=1,nstate
          do istat=1,nstate
            do icoor=1,3
              xlambda(istat,jstat)=xlambda(istat,jstat)+
     +          uimag*xkdp(icoor,ikdp)*pkdp(icoor,istat,jstat)
            enddo
          enddo
        enddo
c
cdeb        print *
cdeb        write(6,10)xkdp(1,ikdp),xkdp(2,ikdp),xkdp(3,ikdp)
cdeb        do jstat=1,nstate
cdeb          do istat=1,jstat
cdeb            xp=0.d0
cdeb            do icoor=1,3
cdeb              xp=xp+xkdp(icoor,ikdp)*pkdp(icoor,istat,jstat)
cdeb            enddo
cdeb            write(6,20)istat,jstat,pkdp(1,istat,jstat),
cdeb     .                 pkdp(2,istat,jstat),pkdp(3,istat,jstat),xp
cdeb          enddo
cdeb        enddo

c
c Upper diagonal form of the symmetric matrix xlambda, for fast diag.
c
        kstat=0
        do jstat=1,nstate
          do istat=jstat,nstate
            kstat=kstat+1
            hkdp(kstat)=xlambda(istat,jstat)
          end do
        end do
c
c     ==================================================================
c     == Diagonalize k.p matrix.                                      ==
c     ==--------------------------------------------------------------==
c ss+jk: Use zhpsv if the number of occupied states is small compared
c        to the total number of states (9/3/98).
c
        if(noccup.eq.nstate) then
          call ZHPEV('V','L',nstate,hkdp,ekdp(1,ikdp),akdp2,nstate,
     c               auxdiag,rauxdiag,info)
          if(info.gt.0)call stopgm('KDP_DIAG','DIAG FAILED TO CONVERGE')
          if(info.lt.0)call stopgm('KDP_DIAG','WRONG ARG TO ZHPEV')
cibm          call ZHPEV(1,hkdp,ekdp(1,ikdp),akdp2,nstate,nstate,
cibm     c               auxdiag,11*nstate)
        else
          call stopgm('KDP_DIAG','selected eigenvalues not programmed')
c          call ZHPEVx('V','I','L',nstate,hkdp,1.,1.,1,noccup,0.,moccup,
c     c                 ekdp(1,ikdp),akdp2,nstate,auxdiag,3*nstate,rwork
c     c                 iwork,ifail,info)
cibm          call zhpsv(1,hkdp,ekdp(1,ikdp),akdp2,nstate,nstate,noccup,
cibm     c               auxdiag,11*nstate)
        endif
c     ==================================================================
c     == Invert the transformation matrices: akdp.                    ==
c     ==--------------------------------------------------------------==
        do istat=1,nstate
          do jstat=1,nstate
            akdp(istat,jstat,ikdp)=akdp2(jstat,istat)
          enddo
        enddo
c
cdeb        print *,ikdp
cdeb        do istat=1,nstate
cdeb          print *,istat,ekdp(istat,ikdp)*2.d0*ry
cdeb        enddo
cdeb        print *
c
c     ==================================================================
c     == End loop over k-points.                                      == 
c     ==--------------------------------------------------------------==
      enddo
C     ==--------------------------------------------------------------==
C     Deallocation of memory.
      call freem(ip_hkdp)
      call freem(ip_xlambda)
      call freem(ip_akdp2)
C     ==--------------------------------------------------------------==
      CALL TIHALT('  KDP_DIAG',ISUB)
c
      return
      end
