C     ==================================================================
      subroutine kdp_prep(nkdp,c0,nstate,pkdp,xlambda0,ckdp,vpot,
     c                    psi,scr,lscr,betap,eigv)
C     ==--------------------------------------------------------------==
C     Compute < c_i | p | c_j > and <c_i| g^2 |c_j> matrix elements for
C     the k.p equations.
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cppt.inc'
      include 'spin.inc'
      include 'cnst.inc'

      integer nstate,istat,jstat,nkdp,lscr,ifirst
      complex*16 c0(ngwk,nstate,nkpnt)
      complex*16 ckdp(ngwk,nstate)
      complex*16 xlambda0(nstate,nstate)
      complex*16 psi(nnr1)
      complex*16 cpx,cpy,cpz
      real*8     pkdp(3,nstate,nstate)
      REAL*8     VPOT(NNR1,NLSD)
      real*8     scr(lscr)
      real*8     betap
      real*8     xlam(nstate,nstate)
      real*8     eigv(nstate)
      pointer(ip_xlam,xlam)
      save ip_xlam
      save ifirst
      data ifirst/0/

      if(ifirst.eq.0) then
        call memory(ip_xlam,nstate*nstate,'xlam')
        ifirst=1
      endif
c
c     ==================================================================
c     == Compute matrix elements < c_i | p | c_j > and store in pkdp. ==
c     ==--------------------------------------------------------------==
      do istat=1,nstate
        do jstat=1,nstate
          call calc_pij(c0(1,istat,1),c0(1,jstat,1),cpx,cpy,cpz,1)
#ifdef PARALLEL
          CALL GLOSUM(2,CPX)
          CALL GLOSUM(2,CPY)
          CALL GLOSUM(2,CPZ)
#endif 
          pkdp(1,jstat,istat)=dreal(cpx)*tpiba
          pkdp(2,jstat,istat)=dreal(cpy)*tpiba
          pkdp(3,jstat,istat)=dreal(cpz)*tpiba
        enddo
      enddo
c     ==================================================================
c     == Compute the hamiltonian matrix elements at Gamma.            ==
c     ==================================================================
c
ctest      call ehpsi(c0,ckdp,vpot,psi,nstate)
ctest      call ovlap(nstate,xlam,c0,ckdp)
      call azzero(xlambda0,2*nstate*nstate)
      do istat=1,nstate
        xlambda0(istat,istat)=dcmplx(-dlog(eigv(istat))/betap,0.d0)
ctest        xlambda0(istat,istat)=dcmplx(-dlog(xlam(istat,istat))/betap,
ctest     .                               0.d0)
cdeb        print *,istat,dreal(xlambda0(istat,istat))*2.d0*ry
      end do
c
      return
      end
