      subroutine kdp_rho(nkdp,c0,ckdp,rhoe,psi,scr,lscr,nstate,
     s                   akdp,noccup,bmix,fkdp,wkdp,bkdp)
c
      implicit none
      include 'system.h'
      include 'spin.inc'
      include 'fft.inc'
c     Arguments
      integer    nkdp,nstate,noccup,lscr
      complex*16 c0(ngwk,nstate,nkpnt)
      complex*16 ckdp(ngwk,nstate)
      complex*16 psi(maxfft*nogrp)
      complex*16 akdp(nstate,nstate,nkdp)
      complex*16 bkdp(nstate,nstate,nkdp)
      real*8     rhoe(nnr1,nlsd)
      real*8     scr(lscr)
      real*8     fkdp(nstate,nkdp)
      real*8     wkdp(nkdp)
      real*8     bmix
C     Variables
      integer    isub
      complex*16 brkdp(nstate,nstate)
      pointer    (ip_brkdp,brkdp)
c
c Local variables
      integer istat,jstat,lstat,ikdp
      CALL TISET('   KDP_RHO',ISUB)
c
c     ==================================================================
c     == Construct matrix bkdp (b_jl(k) in the paper):                ==
c     ==                                                              ==
c     ==   bkdp(i,j) = sum (fkdp(l,k)* akdp^*(l,i,k)*akdp(l,j,k))     ==
c     ==                                                              ==
c     ==--------------------------------------------------------------==
C     Allocation of brkdp
      call memory(ip_brkdp,2*nstate*nstate,'brkdp')
c     ==--------------------------------------------------------------==
      call azzero(bkdp,2*nstate*nstate*nkdp)
      do ikdp=1,nkdp
        do istat=1,nstate
          do jstat=1,nstate
            do lstat=1,noccup
              bkdp(istat,jstat,ikdp)=bkdp(istat,jstat,ikdp)+
     *                               fkdp(lstat,ikdp)*
     *                               dconjg(akdp(lstat,istat,ikdp))*
     *                               akdp(lstat,jstat,ikdp)
            enddo
          enddo
        enddo
      enddo
c
c     ==================================================================
c     == Construct the coefficients brkdp of the hybrid wavefunction  ==
c     == to be used in the construction of the density in real space  ==
c     == (beta_jl in the paper).                                      ==
c     ==--------------------------------------------------------------==
      call azzero(brkdp,2*nstate*nstate)
      do istat=1,nstate
        do jstat=1,nstate
          do ikdp=1,nkdp
            brkdp(istat,jstat)=brkdp(istat,jstat)+0.5d0*wkdp(ikdp)*
     *                         dcmplx(dreal(bkdp(istat,jstat,ikdp)+
     +                                bkdp(jstat,istat,ikdp)),0.d0)
          enddo
        enddo
cdeb        do jstat=1,nstate
cdeb          print *,istat,jstat,brkdp(istat,jstat)
cdeb        enddo
      enddo
cdeb      print *
c
c     ==================================================================
c     == construct the hybrid wavefunction (stored in ckdp)           ==
c     == ckdp = brkdp . c0 ( = Sum beta_jl . phi_l in the paper)      ==
c     ==--------------------------------------------------------------==
cibm        call zgemul(c0,ngwk,'N',brkdp,nstate,'T',ckdp,ngwk,ngw,nstate,
cibm     .              nstate)
      call ZGEMM('N','T',NGW,NSTATE,NSTATE,DCMPLX(1.D0,0.D0),
     &            C0,NGWK,brkdp,NSTATE,DCMPLX(0.D0,0.D0),CKDP,NGWK)
c
      CALL TIHALT('   KDP_RHO',ISUB)
c
c     ==================================================================
c     == compute the k-point weighted electronic density              ==
c     == rho(r) = Sum c0^*_j(r) . ckdp_j(r)                           ==
c     ==--------------------------------------------------------------==
      call rhoofr_kdp(c0,ckdp,rhoe,psi,scr,lscr,nstate)
c
c     ==--------------------------------------------------------------==
C     Deallocation of brkdp
      call freem(ip_brkdp)
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
