      subroutine kdp_stress_kin(nstate,c,gagk,wkdp,xkdp,pkdp,bkdp,nkdp)
      implicit none
      include 'system.h'
      include 'cnst.inc'
      include 'strs.inc'

      integer    nstate,nkdp
      complex*16 bkdp(nstate,nstate,nkdp)
      complex*16 c(ngwk,nstate)
      real*8     gagk(nhg,6)
      real*8     pkdp(3,nstate,nstate)
      real*8     xkdp(3,nkdp)
      real*8     wkdp(nkdp)
c
c Local variables
      integer    kk,ikdp,ic,i,j,ig,ifirst
      real*8     xkk(6,nkdp),cgcg,xkkk,aux
      complex*16 brsum(nstate,nstate),brsum3(nstate,nstate,3)
c
      pointer(ip_brsum,brsum)
      pointer(ip_brsum3,brsum3)
      pointer(ip_xkk,xkk)
      save ip_brsum
      save ip_brsum3
      save ip_xkk
c
      data ifirst/0/
      save ifirst
c
C     ==--------------------------------------------------------------==
C     == ALLOCATE ARRAYS FOR KDP ROUTINES                             ==
C     ==--------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN
        CALL MEMORY(IP_BRSUM,2*NSTATE*NSTATE,'BRSUM')
        CALL MEMORY(IP_BRSUM3,6*NSTATE*NSTATE,'BRSUM3')
        CALL MEMORY(IP_XKK,6*NKDP,'XKK')
        IFIRST=1
      ENDIF
c
c==  Initialization
c
      do kk=1,6
        do ikdp=1,nkdp
          xkk(kk,ikdp)=xkdp(alpha(kk),ikdp)*xkdp(beta(kk),ikdp)
        end do
        dekin(kk) = 0.d0
      end do
c
      call azzero(brsum,2*nstate*nstate)
      call azzero(brsum3,2*3*nstate*nstate)
      do i=1,nstate
        do j=1,i
          do ikdp=1,nkdp
            brsum(i,j)=brsum(i,j)+0.5d0*wkdp(ikdp)*
     *              (bkdp(i,j,ikdp)+bkdp(j,i,ikdp))
          enddo
          brsum(j,i)=brsum(i,j)
          do ic=1,3
            do ikdp=1,nkdp
              brsum3(i,j,ic)=brsum3(i,j,ic)+wkdp(ikdp)*xkdp(ic,ikdp)*
     *                       (bkdp(i,j,ikdp)-bkdp(j,i,ikdp))
            enddo
            brsum3(j,i,ic)=-brsum3(i,j,ic)
          enddo
        enddo
      enddo
c
c     Calculation of the kinetic energy contribution to the stress (k.p)
c
c==   1) g.g + k.k term

      do kk=1,6
c
c Off-diagonal contributions (different states), only g.g
        do i=1,nstate
          do j=1,i-1
            cgcg=0.d0
            do ig=1,ngw
              cgcg=cgcg+dreal(dconjg(c(ig,i))*c(ig,j))*gagk(ig,kk)
            enddo
            cgcg=4.d0*cgcg
            dekin(kk)=dekin(kk)+dreal(brsum(i,j)*cgcg)
          enddo
        enddo
c
c Diagonal contributions (same state)
        do i=1,nstate
c g.g
          cgcg=0.d0
          do ig=1,ngw
            cgcg = cgcg + dreal(dconjg(c(ig,i))*c(ig,i))*gagk(ig,kk)
          enddo
          cgcg=2.d0*cgcg
          dekin(kk)=dekin(kk)+dreal(brsum(i,i)*cgcg)
c k.k
          xkkk=0.d0
          do ikdp=1,nkdp
            xkkk=xkkk+wkdp(ikdp)*dreal(bkdp(i,i,ikdp))*xkk(kk,ikdp)
          enddo
#ifdef PARALLEL
          xkkk=xkkk/DBLE(nproc)
#endif
          dekin(kk)=dekin(kk)+xkkk
c
        enddo
c
      enddo
c
c==   2) g.k + k.g term
c
c Only off-diagonal contributions (different states).
      do kk=1,6
        aux=0.d0
        do i=1,nstate
          do j=1,i-1
            aux=aux-dimag(brsum3(i,j,alpha(kk)))*
     *                    pkdp(beta(kk),i,j)-
     -                    dimag(brsum3(i,j,beta(kk)))*
     *                    pkdp(alpha(kk),i,j)
          enddo
        enddo
#ifdef PARALLEL
        aux=aux/DBLE(nproc)
#endif
        dekin(kk)=dekin(kk)+aux
      enddo
c
      do kk=1,6
        dekin(kk) = - dekin(kk)
      end do
c
      return
      end
