C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == INFORMATION ABOUT K POINTS MESH (MONKHORST-PACK)             ==
C     ==   NK1,NK2,NK3 : DIMENSIONS OF MONKHORST-PACK MESH            ==
C     == LOGICAL FLAGS                                                ==
C     ==   TMONKP      : WE USE A MONKHORST-PACK MESH                 ==
C     ==   TKPNT       : K POINTS USED (COMPLEX WAVEFUNCTIONS)        ==
C     ==   TKSCALE     : EACH THREE COMPONENTS (INDEX I) ARE DIVIDED  ==
C     ==                 NOT BY 2PI/ALAT BUT 2PI/ALAT(I)              ==
C     ==   TSYMKP      : SYMMETRIZE SPECIAL K-POINTS                  ==
C     ==   TKFULL      : USE THE FULL MONKHORST-PACK MESH             ==
C     ==                 WITH ONLY INVERSION SYMMETRY                 ==
C     ==   TKBLOCK     : CALCULATE K-POINTS PER BLOCK (LOW MEMORY)    ==
C     ==   TKALL       : SWAP ALL ARRAYS DEPENDING ON NKPNT (BLOCK)   ==
C     ==   TKNOSWAP    : USE WITH OPTION TKBLOCK                      ==
C     ==                 USE TO CALCULATE K POINT PER K POINT         ==
C     ==                 C0 IS NOT SWAPPED                            ==
C     ==   TKBCALC     : USE WITH OPTION TKBLOCK                      ==
C     ==                 CALCULATE EACH TIME ALL ARRAYS DEPENDING ON  ==
C     ==                 K POINTS                                     ==
C     ==   NKPTALL = NKPTS IF NOT TKALL OTHERWISE NKPNT               ==
C     ==   TONLYDIAG   : ONLY ONE DIAGONALIZATION PER EACH K POINT    ==
C     ==                 WITHOUT SELF-CONSISTENCE CYCLE               ==
C     ==================================================================
      INTEGER       NK1,NK2,NK3,NKPTALL
      COMMON/KPTS/  NK1,NK2,NK3,NKPTALL
      LOGICAL       TKPNT,TKSCALE,TMONKP,TSYMKP,TKFULL,TKBLOCK,TKALL,
     &              TKNOSWAP,TKBCALC,TONLYDIAG
      COMMON/TKPTS/ TKPNT,TKSCALE,TMONKP,TSYMKP,TKFULL,TKBLOCK,TKALL,
     &              TKNOSWAP,TKBCALC,TONLYDIAG
C     ==--------------------------------------------------------------==
C     == WVK0(3) MAC DONALD SHIT FOR GENERATION OF MONKHORST-PACK MESH==
C     ==         SEE MACDONALD PRB (1978) 18, 5897-5899               ==
C     ==--------------------------------------------------------------==
      REAL*8        WVK0(3)
      COMMON/TKPTR/ WVK0
C     ==================================================================

