      subroutine  KS_ENER_P(CU1,Z11,NSTATE,SCR,LSCR)
C     ==-------------------------------------------------------------==

      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'cnst.inc'
      include 'coor.inc'
      include 'sfac.inc'
      include 'elct.inc'
      include 'kpts.inc'
      include 'kpnt.inc'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'response_p.inc'

C     ARGUMRNTS
      INTEGER    NSTATE,LSCR
      complex*16 CU1(ngw,nstate,3)
      real*8     Z11(NSTATE,NSTATE),SCR(*)

C     VARIABLE
      DIMENSION  WK(NKPTS),RK(3,NKPTS)
      DIMENSION  HAMILK(2*NSTATE,2*NSTATE),ekpert(2*NSTATE,NKPTS)
      DIMENSION  fkpert(2*NSTATE,NKPTS)
      DIMENSION  H1_00(NSTATE,NSTATE,3),H2_00(NSTATE,NSTATE,3,3)
      DIMENSION  H1_10(NSTATE,NSTATE,3,3),H0_11(NSTATE,NSTATE,3,3)

      INTEGER    IL_Z,IL_W,IL_A_TEMP,IL_AUX,IL_HH,IL_C1K
      INTEGER    IKK,ISTATE,LKS_ENER_P,N2,IG
      INTEGER    I,J,ISUB,NLEFT

      COMPLEX*16 C1K(NGW,NSTATE)
      pointer    (IP_C1K,C1K)

      REAL*8     S12(NSTATE,NSTATE)
      pointer    (IP_S12,S12)
      REAL*8     z(NSTATE,NSTATE),W(NSTATE),A_TEMP(NSTATE*NSTATE)
      REAL*8     AUX(3*2*NSTATE),HH(2*NSTATE*NSTATE)
      pointer    (IP_Z,Z),(IP_W,W),(IP_A_TEMP,A_TEMP)
      pointer    (IP_AUX,AUX),(IP_HH,HH)
      REAL*8     FNL(*),DFNL(*)
      REAL*8     KSQUARE,AMU,BOTTOM

C     Diagonalization
      INTEGER    LWORK,IERR
      COMPLEX*16 WORK(*)
      pointer    (IP_WORK,WORK)


      CALL TISET('   KS_ENER_P',ISUB)

      N2 = NSTATE*NSTATE
      AMU = 2000.0D0
      BOTTOM = 2000.0D0

      IL_C1K  = 2*NGW*NSTATE
      IL_Z = N2
      IL_W = NSTATE
      IL_A_TEMP = N2
      IL_AUX = 3*2*NSTATE
      LWORK = MAX(1,2*2*NSTATE-1)

      CALL GIVE_SCR_KS_ENER_P(LKS_ENER_P,N2,NSTATE)
      CALL TEST_SCR('KS_ENER_P','5*N2+10*NSTATE+2*NGW*NSTATE'
     &     ,LSCR,LKS_ENER_P)

C     ==-------------------------------------------------------------==
C     ==   Allocate Memory for the Hamiltonian and the KS energy     ==
C     ==   the KS H is complex and 2*NSTATE x 2*NSTATE --> HAMILK    ==
C     ==   The KS energy are 2*NSTATE*NKPTS           --> EKPERT     ==
C     ==   The occupation numbers                     --> FKPERT
C     ==-------------------------------------------------------------==

      CALL MEMORY(IP_HAMILK,2*2*NSTATE*2*NSTATE,'HAMILK')
      CALL MEMORY(IP_EKPERT,2*NSTATE*NKPTS,'EKPERT')
      CALL AZZERO(EKPERT,2*NSTATE*NKPTS)
      CALL MEMORY(IP_FKPERT,2*NSTATE*NKPTS,'FKPERT')
      CALL AZZERO(FKPERT,2*NSTATE*NKPTS)
      
C     == ovlap matrix to -1/2 (depending on k vector)
      CALL MEMORY(IP_S12,NSTATE*NSTATE,'S12')
C     == gregarian matrix
      IL_HH = 2*NSTATE*NSTATE
      CALL MEMORY(IP_HH,IL_HH,'HH')
      CALL AZZERO(HH,IL_HH)

      CALL GET_ADDR(IP_C1K,SCR(1))
      CALL GET_ADDR(IP_Z,SCR(1+IL_C1K))
      CALL GET_ADDR(IP_W,SCR(1+IL_C1K+IL_Z))
      CALL GET_ADDR(IP_A_TEMP,SCR(1+IL_C1K+IL_Z+IL_W))
      CALL GET_ADDR(IP_AUX,SCR(1+IL_C1K+IL_Z+IL_W+IL_A_TEMP))
      CALL GET_ADDR(IP_WORK,SCR(1+IL_C1K+IL_Z+IL_W+
     &     IL_A_TEMP+IL_AUX))

      do IKK=1,NKPTS
         if(parent) write(6,'("K VECTOR ",i10)') IKK

C     HAMILK = (.0,.0) S12 = (.0)
         CALL ZAZZERO(HAMILK,2*NSTATE*2*NSTATE)
         CALL AZZERO(S12,NSTATE*NSTATE)

C     ==-------------------------------------------------------------==
C     ==     Wavefunction not orthogonalized yet                     ==
C     ==-------------------------------------------------------------==
         DO ISTATE = 1,NSTATE
            DO IG = 1,NGW 
               C1K(IG,ISTATE)= (CU1(IG,ISTATE,1)*RK(1,IKK) +
     &           CU1(IG,ISTATE,2)*RK(2,IKK)  +
     &           CU1(IG,ISTATE,3)*RK(3,IKK) )*TPIBA
            ENDDO
         ENDDO
C     ==-------------------------------------------------------------==
C     ==     Compute the matrix S^(-1/2)[K]                          ==
C     ==-------------------------------------------------------------==

         CALL S12K_P(C1K,S12,A_TEMP,W,Z,AUX,NSTATE)

C     ==-------------------------------------------------------------==
C     ==     Compute     K^2                                         ==
C     ==-------------------------------------------------------------==

         KSQUARE = RK(1,IKK)*RK(1,IKK)+RK(2,IKK)*RK(2,IKK)+
     &        RK(3,IKK)*RK(3,IKK)
         
C     ==-------------------------------------------------------------==
C     ==        FINAL HAMILTONIAN MATRIX OF K                        ==
C     ==-------------------------------------------------------------==
         
         CALL  HAMOFK_P(Z11,S12,NSTATE,IKK,KSQUARE,Z,HH,IL_HH)
         
C     ==                     END LOOPS                                   ==
C     ==-----------------------------------------------------------------==
C     ==-----------------------------------------------------------------==
C     HAMILT IS HERMITIAN .....
         
         
C     DIAGONALIZATION
         CALL ZHEEV('V','U',2*NSTATE,HAMILK,2*NSTATE,EKPERT(1,IKK),
     &        WORK,LWORK,AUX,IERR)
         IF(LWORK.LT.INT(AUX(1))) THEN 
            WRITE(6,*) ' WARNING| LWORK SUBOPTIMAL FOR ZHEEV'
            WRITE(6,*) '   LWORK:',LWORK
            WRITE(6,*) ' OPTIMAL:',INT(AUX(1))
         ENDIF
         CALL REORDER_C(2*NSTATE,2*NSTATE,EKPERT(1,IKK),HAMILK)
         
C     Order Roots with respect to energy
         CALL DSCAL(2*NSTATE,-1.D0,EKPERT(1,IKK),1)
         DO I = 1 ,NSTATE
            FKPERT(I,IKK) = 2.0D0
            FKPERT(2*NSTATE-I+1,IKK) = 0.0D0
         ENDDO   
         DO I = NSTATE+1,2*NSTATE
            AMU = MIN(AMU,EKPERT(I,IKK))
         ENDDO
         DO I = 1,NSTATE
            BOTTOM = MIN(BOTTOM,EKPERT(I,IKK))
         ENDDO
      ENDDO
      IF(PARENT) write(6,'("BOTTOM LEVEL",F14.7)') BOTTOM*2*Ry
      IF(PARENT) write(6,'("MINIMUM CB",F14.7)') AMU*2*Ry
      
      IF(PARENT) THEN
         WRITE(6,'(/,A)') ' EIGENVALUES(EV) AND OCCUPATION:'
         DO IKK=1,NKPTS
            WRITE(6,'(1X,A,I8,4F12.6)')
     &           'K POINT:',IKK,(RK(I,IKK),I=1,3),WK(IKK)
            DO I=1,2*NSTATE,2
               NLEFT=MIN(2*NSTATE-I,1)
               WRITE(6,'(3X,2(I3,F15.7,4X,F6.3,6X))') 
     *              (I+J,EKPERT(I+J,IKK)*(2*RY),
     *              FKPERT(I+J,IKK),J=0,NLEFT)
            ENDDO
         ENDDO
      ENDIF

      CALL FREEM(IP_HAMILK)
      CALL FREEM(IP_EKPERT)
      CALL FREEM(IP_HH)
      CALL FREEM(IP_S12)

      RETURN
      END
C     ======================================================================
C     ======================================================================
      SUBROUTINE GIVE_SCR_KS_ENER_P(LKS_ENER_P,N2,NSTATE)
      implicit none
      include  'system.h'

      integer N2,NSTATE
      integer IL_C1K,IL_Z,IL_W,IL_A_TEMP,IL_AUX,LWORK
      integer LKS_ENER_P

      IL_C1K  = 2*NGW*NSTATE
      IL_Z = N2
      IL_W = NSTATE
      IL_A_TEMP = N2
      IL_AUX = 3*2*NSTATE
      LWORK = MAX(1,2*2*NSTATE-1)
      
      LKS_ENER_P = 
     &     IL_Z+IL_W+IL_A_TEMP+IL_AUX+IL_C1K+2*LWORK

      RETURN
      END
C     ======================================================================
C     ======================================================================
