C     ==================================================================
      SUBROUTINE KSDIAG(VPP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'simul.inc'
C     Arguments
      REAL*8    VPP(NGW)
C     VAriables
      DIMENSION TWNL(NGW,NHXS,*)
      REAL*8    VP,DD,FTPI
      INTEGER   IG,ISA0,IS,IV,JV,IA,ISA,L,LI,KI,L2,LJ,KJ,J
#ifdef PARALLEL
      INTEGER   MSGLEN
#endif
C     ==--------------------------------------------------------------==
C     ==  Calculate  VPP : The diagonal approximation to the KS Matrix==
C     ==--------------------------------------------------------------==
C     ==  Local Potential                                             ==
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      MSGLEN = 1 * 8
      CALL MY_BCAST(VPLOC,MSGLEN,IGEQ0,ALLGRP)
#endif
      VP=VPLOC
C     ==--------------------------------------------------------------==
C     ==  Nonlocal Potential                                          ==
C     ==--------------------------------------------------------------==
      DO IG=1,NGW
        VPP(IG)=VP
        ISA0=0
        DO IS=1,NSP
          IF(TVAN(IS)) THEN
            DO IV=1,NGH(IS)
              DO JV=1,NGH(IS)
                DD=DVAN(IV,JV,IS)
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
                  DD=DD+DEEQ(ISA,IV,JV,1)
                ENDDO
                IF(TLSD) THEN
                  DO IA=1,NA(IS)
                    DD=DD+DEEQ(ISA0+IA,IV,JV,2)
                  ENDDO
                  DD=0.5D0*DD
                ENDIF
                VPP(IG)=VPP(IG)+DD*TWNL(IG,IV,IS)*TWNL(IG,JV,IS)
              ENDDO
            ENDDO
          ELSEIF(TSGP(IS)) THEN
            DO IV=1,NGH(IS)
              L=NGHTOL(IV,IS)+1
              LI=LPVAL(IV,IS)
              KI=LFVAL(IV,IS)
              DO JV=1,NGH(IS)
                L2=NGHTOL(JV,IS)+1
                LJ=LPVAL(JV,IS)
                IF(L.EQ.L2.AND.LI.EQ.LJ) THEN
                  KJ=LFVAL(JV,IS)
                  DD=HLSG(KI,KJ,L,IS)*NA(IS)
                  VPP(IG)=VPP(IG)+DD*TWNL(IG,IV,IS)*TWNL(IG,JV,IS)
                ENDIF
              ENDDO
            ENDDO
          ELSE
            DO IV=1,NGH(IS)
              VPP(IG)=VPP(IG)+NA(IS)*WSG(IS,IV)
     *                      *TWNL(IG,IV,IS)*TWNL(IG,IV,IS)
            ENDDO
          ENDIF
          ISA0=ISA0+NA(IS)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  Kinetic Energy                                              ==
C     ==--------------------------------------------------------------==
      FTPI=0.5D0*TPIBA2
      DO J=1,NGW
        VPP(J)=FTPI*HG(J)+VPP(j)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
