C     ==================================================================
      SUBROUTINE KSMAT(C2,VPOT,PSI,SCR,LSCR,NSTATE,IKIND)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE KOHN-SHAM MATRIX IN THE ATOMIC WAVEFUNCTION BASIS       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'kpts.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,IKIND
      COMPLEX*16 C2(NGWK,*),PSI(*)
      REAL*8     VPOT(NNR1,*),SCR(*)
C     Variables
CAK 2005/07/24 PAB is only used for LSE. since this is not
CAK            allowed here, we can save some stack memory.
CAK      COMPLEX*16 PAB(NNR1)
      COMPLEX*16 PAB(1)
      LOGICAL    TFDIST2
      DIMENSION  CATOM(NGWK,NATTOT)
      INTEGER    ISUB,IST,IS,NATST,IA,LKSMAT
      INTEGER    IL_AUXC,IL_DDIA
      CHARACTER  TAG*30
      REAL*8     FOC(20)
      DATA       FOC /20*1.0D0/
C     ==--------------------------------------------------------------==
      IF(TLSE) CALL STOPGM('KSMAT','NO LSE ALLOWED HERE')
CAK      CALL ZAZZERO(PAB,NNR1)
      PAB(1)=0.0D0
C     SCR test.
      CALL GIVE_SCR_KSMAT(LKSMAT,TAG)
      CALL TEST_SCR('KSMAT',TAG,LSCR,LKSMAT)
      CALL TISET('     KSMAT',ISUB)
C     ==--------------------------------------------------------------==
      TFDIST2=TFDIST
      TFDIST=.FALSE.
      CALL FNL_SET('SAVE')
      CALL FNLALLOC(NUMAORMAX,.FALSE.,.FALSE.)
      CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NUMAORMAX)
      IST=1
      DO IS=1,NSP
        NATST=NUMAOR(IS)
        DO IA=1,NA(IS)
          CALL RNLSM(CATOM(1,IST),NATST,PSI,SCR,LSCR,1,IKIND,.FALSE.)
          CALL ZAZZERO(C2,NGWK*NATST)
          CALL VPSI(CATOM(1,IST),C2,FOC,VPOT,PSI,PAB,NATST,IKIND,1)
          CALL FNONLOC(C2,FOC,NATST,SCR,SCR(IL_AUXC+1),IKIND,1)
          IF(TKPNT) THEN
            CALL OVLAP2_C(NGWK,NATTOT,NATST,ZXMAT(1,IST),CATOM,C2)
          ELSE
            CALL OVLAP2(NGWK,NATTOT,NATST,XXMAT(1,IST),CATOM,C2)
          ENDIF
          IST=IST+NATST
        ENDDO
      ENDDO
      CALL FNLDEALLOC(.FALSE.,.FALSE.)
      CALL FNL_SET('RECV')
      TFDIST=TFDIST2
      IF(TKPNT) THEN
        CALL DSCAL(2*NATTOT*NATTOT,-1.D0,ZXMAT(1,1),1)
      ELSE
        CALL DSCAL(  NATTOT*NATTOT,-1.D0,XXMAT(1,1),1)
      ENDIF
      CALL TIHALT('     KSMAT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_KSMAT(LKSMAT,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGWK
      INCLUDE 'atwf.inc'        !NATTOT, NUMAORMAX
C     Arguments
      INTEGER   LKSMAT
      CHARACTER TAG*30
C     Variables
      INTEGER   LRNLSM, LFNONLOC
      INTEGER   IL_AUXC,IL_DDIA
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NATTOT,.FALSE.)
      CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NUMAORMAX)
      LFNONLOC = IL_AUXC + IL_DDIA
      LKSMAT=MAX(LFNONLOC,LRNLSM)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
