C     ==================================================================
      SUBROUTINE DIST_KSMAT(C2,VPOT,PSI,SCR,LSCR,NSTATE,IKIND,C0,NN,
     &                      TLSD2, AINITWFFLAG)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE KOHN-SHAM MATRIX IN THE ATOMIC WAVEFUNCTION BASIS       ==
C     ==  IT'S EIGENDECOMPOSITION AND THE APPROXIMATE INITIAL         ==
C     ==  WAVEFUNCTIONS                                               ==
C     ==  USES: DISTRIBUTED LANCZOS WITH GS REORTHOGONALIZATION       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'kpts.inc'      
      INCLUDE 'ksmat.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,IKIND
      COMPLEX*16 C2(NGWK,*),PSI(*)
      REAL*8     VPOT(NNR1,*),SCR(*)
      COMPLEX*16 C0(NGWK,NSTATE,*)
      INTEGER    NN 
      LOGICAL    TLSD2, AINITWFFLAG
C     Variables
CAK 2005/07/24 PAB is only used for LSE. since this is not
CAK            allowed here, we can save some stack memory.
CAK      COMPLEX*16 PAB(NNR1)
      COMPLEX*16 PAB(1)
      LOGICAL    TFDIST2, QUERYRANDS
      DIMENSION  CATOM(NGWK,NATTOT)
      INTEGER    ISUB,IST,IS,NATST,IA,LKSMAT,MSGLEN
      INTEGER    IL_AUXC,IL_DDIA
      CHARACTER  TAG*30
      REAL*8     FOC(20)
      DATA       FOC /20*1.0D0/
      INTEGER  CLOCK1, CLOCK2, CLOCK3, CLOCK4, TM1, TM2, TM3, TM4, TM5
C     ==================================================================
C     New Variables
      REAL*8       NRM, DNRM2, LOCAL_ALPHA, ALPHA, LOCAL_BETA
      REAL*8       DDOT
      EXTERNAL     DDOT
      INTEGER      INDEX1, INDEX2, CHUNK, CHUNK_NEW, CHUNK_E
      INTEGER      INDEX3, START, START_COL, INT_SM, START_SPU
      INTEGER      START_SPD 
      INTEGER      CHUNK_BEGIN, CHUNK_END, INDEX4, LAN_MAX
      INTEGER      CHUNK_BEGIN_E, CHUNK_END_E
      INTEGER      CHUNK_NEW_E
      INTEGER      LC_INDEX(NATTOT) 
C     STORAGE FOR LOCAL PART OF RESTRICTED HAMILTONIAN
      REAL*8       LOCAL_XXMAT, TST1(NSTATE), TST2(NSTATE)
      POINTER      (IP_LOCAL_XXMAT, LOCAL_XXMAT)
      DIMENSION    LOCAL_XXMAT(NATTOT,*)
      REAL*8       TEMP_XXMAT
      POINTER      (IP_TEMP_XXMAT, TEMP_XXMAT)
      DIMENSION    TEMP_XXMAT(NATTOT,*)
      REAL*8       TEMP1_XXMAT
      POINTER      (IP_TEMP1_XXMAT, TEMP1_XXMAT)
      DIMENSION    TEMP1_XXMAT(NATTOT,*)
C     LANCZOS BASIS AND VARIABLES
      REAL*8       LANV
      POINTER      (IP_LANV, LANV)
      DIMENSION    LANV(*)
      REAL*8       W
      POINTER      (IP_W, W)
      DIMENSION    W(*)
      REAL*8       PW
      POINTER      (IP_PW, PW)
      DIMENSION    PW(*)
      REAL*8       LOCAL_PW
      POINTER      (IP_LOCAL_PW, LOCAL_PW)
      DIMENSION    LOCAL_PW(*)
      REAL*8       V_PREV
      POINTER      (IP_V_PREV, V_PREV)
      DIMENSION    V_PREV(*)
      REAL*8       VCUR(*), V0(*), BETA
      POINTER      (IP_VCUR,VCUR), (IP_V0,V0)
      REAL*8       E(NATTOT), D(NATTOT), SM, SM_OLD
      REAL*8       CONV_TOL
      LOGICAL      CONV_FLAG
C     MPI_PARAMETERS
      INTEGER      RANK, SZ, SZ_OLD, IERR, OLD_ALLGRP
      INTEGER      SEND_CNT(NPROC), SEND_DISPL(NPROC)
      INTEGER      WORLD, NEWGROUP, LANGRP, NOLAN, LANLIST(NPROC)
      INTEGER      LABEL
      INTEGER      NOEIG
      INTEGER      SEND_CNT_E(NPROC), SEND_DISPL_E(NPROC)
      INTEGER      OLD_SEND_CNT_E(NPROC)
C     VARIABLES FOR THE CALCULATION OF EIGENVALUES
C     LAPACK ROUTINE: DSTEVX
      INTEGER            IL, IU, LDZ, NFOUND, NUM_EIG 
      REAL*8             ABTOL, VL, VU
      REAL*8             DASUM
      EXTERNAL           DASUM
      INTEGER    MY_MAXVAL
      EXTERNAL   MY_MAXVAL
      INTEGER            IFAIL(NATTOT), IWORK(5*NATTOT)
      REAL*8             LD(NATTOT), LE(NATTOT), EIG(NATTOT) 
      REAL*8             WORK(5*NATTOT) 
C     DISTRIBUTION OF STATES, SPINS
      INTEGER  NORB, NORBX, CHUNK_SPU, CHUNK_SPU_BEGIN, CHUNK_SPU_END
      INTEGER  CHUNK_SPD, CHUNK_SPD_BEGIN, CHUNK_SPD_END 
      LOGICAL  FLAG_SPU, FLAG_SPDOWN
C     ==================================================================
      CALL TISET('    DISTKS',ISUB)
#ifdef  PARALLEL
      TM1 = 0
      TM2 = 0
C     FIND OUT SIZE AND RANK
      RANK = ME
      SZ = NPROC 
      CONV_FLAG = .FALSE.
      SZ_OLD = SZ 
C     =================================================================
C     DETERMINE DISTRIBUTION OF ATOMIC STATES AND COLUMNS OF
C     RESTRICTED HAMILTONIAN
C     =================================================================
      CALL MY_SET_ORBDIST(NSTATE,NSTBLK,NORBX)
      NORB = 0 
      DO INDEX1=0, SZ-1
         IF ((NWA12(INDEX1,2)-NWA12(INDEX1,1)+1 ).GT.0) NORB=NORB+1
      ENDDO
      CHUNK_NEW = INT(DBLE(NATTOT)/DBLE(NORB))
      IF (RANK.LT.NORB-1) THEN
         CHUNK_BEGIN = RANK*CHUNK_NEW+1
         CHUNK_END = (RANK+1)*CHUNK_NEW
      ELSE IF (RANK.EQ.NORB-1) THEN
         CHUNK_END=NATTOT
         CHUNK_BEGIN = RANK*CHUNK_NEW+1
      ENDIF
      IF (RANK.GE.NORB) THEN
         CHUNK_BEGIN=NATTOT+1
         CHUNK_END=NATTOT
      ENDIF   
      CHUNK_NEW = CHUNK_END - CHUNK_BEGIN + 1
      MSGLEN=8/IRAT
      CALL MY_CONCAT(CHUNK_BEGIN, NWA12(0,1), MSGLEN, ALLGRP)
      CALL MY_CONCAT(CHUNK_END, NWA12(0,2), MSGLEN, ALLGRP)
C     ================================================================= 
C     CREATE LANCZOS GROUP
C     ================================================================= 
      IF (PARENT) THEN
         DO INDEX4=1,SZ
            LANLIST(INDEX4) = 0
         ENDDO 
         NOLAN = 0
         DO INDEX4=1, SZ
            IF((NWA12(INDEX4-1,2)-NWA12(INDEX4-1,1)+1).NE.0) THEN
               LANLIST(INDEX4) = INDEX4-1
               NOLAN = NOLAN + 1
            ENDIF
         ENDDO 
      ENDIF
      MSGLEN=SZ*8/IRAT
      CALL MY_BCAST(LANLIST, MSGLEN, SOURCE, ALLGRP)
      MSGLEN=8/IRAT
      CALL MY_BCAST(NOLAN, MSGLEN, SOURCE, ALLGRP)  
      CALL MY_GROUP(NOLAN,LANLIST,LABEL,LANGRP,ALLGRP)
C     ================================================================= 
C     ALLOCATE LOCAL_XXMAT AND TEMP_XXMAT, TEMP1_XXMAT
      CALL MEMORY(IP_LOCAL_XXMAT, NATTOT*CHUNK_NEW,
     &            'LOCAL_XXMAT')
      CALL MEMORY(IP_TEMP_XXMAT,NATTOT*NUMAORMAX,
     &            'TEMP_XXMAT')
      CALL MEMORY(IP_TEMP1_XXMAT,NATTOT*NUMAORMAX,
     &            'TEMP1_XXMAT')
      CALL AZZERO(LOCAL_XXMAT(1,1), NATTOT*CHUNK_NEW)
C     ==--------------------------------------------------------------==
      IF(TLSE) CALL STOPGM('KSMAT','NO LSE ALLOWED HERE')
CAK      CALL ZAZZERO(PAB,NNR1)
      PAB(1)=0.0D0
C     SCR test.
      CALL GIVE_SCR_DIST_KSMAT(LKSMAT,TAG)
      CALL TEST_SCR('DIST_KSMAT',TAG,LSCR,LKSMAT)
C     ==--------------------------------------------------------------==
      CALL FNL_SET('SAVE')
      CALL FNLALLOC(NUMAORMAX,.FALSE.,.FALSE.)
      CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NUMAORMAX)
      IST=1
      INDEX4 = 1
      DO IS=1,NSP
        NATST=NUMAOR(IS)
        DO IA=1,NA(IS)
          CALL RNLSM(CATOM(1,IST),NATST,PSI,SCR,LSCR,1,IKIND,.FALSE.)
          CALL ZAZZERO(C2,NGWK*NATST)
          CALL VPSI(CATOM(1,IST),C2,FOC,VPOT,PSI,PAB,NATST,IKIND,1)
          CALL FNONLOC(C2,FOC,NATST,SCR,SCR(IL_AUXC+1),IKIND,1)
          IF(TKPNT) THEN
            CALL OVLAP2_C(NGWK,NATTOT,NATST,ZXMAT(1,IST),CATOM,C2)
          ELSE
            CALL OVLAP2(NGWK,NATTOT,NATST,TEMP1_XXMAT(1,1),CATOM,
     &       C2)
C           SUMMATION ACROSS PROCESSORS
            CALL  MY_COMBINE(TEMP1_XXMAT(1,1), TEMP_XXMAT(1,1), 
     &                       8*NATTOT*NATST,1,ALLGRP)
C           INTIALIZE TO ZERO
            CALL AZZERO(TEMP1_XXMAT(1,1), NATTOT*NUMAORMAX)
            IF  (((IST.GE.CHUNK_BEGIN).AND.
     &              ((IST+NATST-1).LE.(CHUNK_END)))) THEN
               CALL DCOPY(NATTOT*NATST, TEMP_XXMAT(1,1), 1,
     &                    LOCAL_XXMAT(1,INDEX4), 1)
C               PRINT *, "V1", ME, INDEX4, NATST
               INDEX4 = INDEX4 + NATST
            ENDIF
            IF (((IST).LE.CHUNK_END).AND.
     &              ((IST+NATST-1).GT.CHUNK_END)) THEN
               CALL DCOPY(NATTOT*(CHUNK_END-IST+1), TEMP_XXMAT(1,1), 1,
     &                    LOCAL_XXMAT(1,INDEX4), 1)
C               PRINT *, "V2", ME, INDEX4,(CHUNK_END-IST+1) 
            ENDIF
            IF (((IST).LT.CHUNK_BEGIN).AND.
     &              ((IST+NATST-1).GE.CHUNK_BEGIN)) THEN
               CALL DCOPY(NATTOT*(IST+NATST-CHUNK_BEGIN),
     &                    TEMP_XXMAT(1, CHUNK_BEGIN-IST+1), 1,
     &                    LOCAL_XXMAT(1, INDEX4), 1)
C               PRINT *, "V3", ME, INDEX4,(IST+NATST-CHUNK_BEGIN)
               INDEX4 = INDEX4 + IST+NATST-CHUNK_BEGIN
            ENDIF
          ENDIF
          CALL AZZERO(TEMP_XXMAT(1,1), NATTOT*NUMAORMAX)
          CALL MY_SYNC(ALLGRP)  
          IST=IST+NATST
        ENDDO
      ENDDO
      CALL FNLDEALLOC(.FALSE.,.FALSE.)
      CALL FNL_SET('RECV')
      IF(TKPNT) THEN
        CALL DSCAL(2*NATTOT*NATTOT,-1.D0,ZXMAT(1,1),1)
      ELSE
        CALL DSCAL(NATTOT*CHUNK_NEW,-1.D0,LOCAL_XXMAT(1,1),1)
      ENDIF
C     ==================================================================
C     ONLY PROCESSORS THAT HAVE A NON-ZERO CHUNK OF THE RESTRICTED
C     HAMILTONIAN PARTICIPATE IN LANCZOS
C     ==================================================================   
      IF (CHUNK_NEW.NE.0) THEN
C     ==================================================================
C     START THE LANCZOS ITERATION WITH FULL GRAM-SCHIDT REORTH. 
C     ==================================================================
C     --------------------------------------
C     MEMORY ALLOCATIONS AND INITIALIZATIONS
C     --------------------------------------
C     EACH PROCESSOR ALLOCATES MEMORY FOR ROW-WISE DISTRUBUTED LANCZOS
C     BASIS
      SZ = NOLAN
      LAN_MAX = NATTOT+1
      CALL MEMORY(IP_VCUR,NATTOT,'VCUR')
      CALL MEMORY(IP_V0,NATTOT,'V0')
      CALL MEMORY(IP_LANV, CHUNK_NEW*LAN_MAX, 'LANV')     
      CALL MEMORY(IP_W,CHUNK_NEW, 'W')
      CALL MEMORY(IP_PW, LAN_MAX, 'PW')
      CALL MEMORY(IP_LOCAL_PW, LAN_MAX, 'LOCAL_PW')
      CALL MEMORY(IP_V_PREV, CHUNK_NEW, 'V_PREV')
      CALL AZZERO(PW(1),LAN_MAX)
      CALL AZZERO(LANV(1),CHUNK_NEW*LAN_MAX)
      CALL AZZERO(VCUR(1),NATTOT)
      CALL AZZERO(V0(1),NATTOT)
      CALL AZZERO(W(1),CHUNK_NEW)
      CALL AZZERO(LOCAL_PW(1),LAN_MAX)
      CALL AZZERO(V_PREV(1),CHUNK_NEW)  
C     DETERMINE SEND AND RECEIVE BUFFERS
      MSGLEN=8/IRAT
      CALL MY_CONCAT(CHUNK_NEW, SEND_CNT(1), MSGLEN, LANGRP)
      SEND_DISPL(1) = 0
      DO INDEX4=2, SZ
         SEND_DISPL(INDEX4) = SEND_DISPL(INDEX4-1) + SEND_CNT(INDEX4-1)
      ENDDO
C     DETERMINE A UNIT NORM INITIAL VECTOR V0 
      IF (PARENT) THEN
         CALL DURAND(12344.0D0,NATTOT,V0) 
         NRM = DNRM2(NATTOT, V0(1), 1)
         NRM = 1/NRM
         CALL DSCAL(NATTOT, NRM, V0(1), 1)
      ENDIF
C     BROADCAST INITIAL VECTOR TO ALL PROCESSORS
      CALL MY_BCAST(V0(1), 8*NATTOT, SOURCE, LANGRP)
      CALL DCOPY(NATTOT, V0(1), 1, VCUR(1), 1)
C     INITIALIZE V_PREV and BETA
      DO IS=1, CHUNK_NEW
         V_PREV(IS) = 0D0
         W(IS)=0D0
      ENDDO
      BETA = 0D0
C     INITIALIZE FIRST LANCZOS VECTOR
      CALL DCOPY(CHUNK_NEW, VCUR(CHUNK_BEGIN), 1, LANV(1), 1)
C     INITIALIZE INITIAL SUM OF WANTED EIGENVALUES
      SM_OLD = 0D0 
C     INITIALIZE CONVERGENCE TOLERANCE
      CONV_TOL = 1D-8
C     ==================================================================
C     LANCZOS LOOP
C     ==================================================================   
      NUM_EIG = NN
      DO INDEX4 = 1, LAN_MAX-1
C       DISTRIBUTED MATRIX-VECTOR PRODUCT
C       W: Holds the result
        CALL DGEMV("T", NATTOT,CHUNK_NEW,1D0,LOCAL_XXMAT(1,1),NATTOT,
     &             VCUR(1), 1, 0D0, W(1), 1)
C       DAXPY: W = W - BETA*V_(J-1)
        CALL DAXPY(CHUNK_NEW, -BETA, V_PREV(1), 1, W(1), 1)
C       CALCULATE ALPHA: INNER PRODUCT WITH CURRENT LANCZOS VECTOR
        LOCAL_ALPHA = DDOT(CHUNK_NEW,W(1),1,
     &                     LANV((INDEX4-1)*CHUNK_NEW+1), 1)
        CALL MY_COMBINE(LOCAL_ALPHA, ALPHA, 8, 1, LANGRP)
C       DAXPY: W = W - ALPHA*V_J
        CALL DAXPY(CHUNK_NEW,-ALPHA,LANV((INDEX4-1)*CHUNK_NEW+1),1,
     &             W(1),1) 
C     ================================================================== 
C     REORTHOGONALIZE AGAINST ALL PREVIOUS BASIS VECTORS
C     ==================================================================
C       CALL DGEMV("T",CHUNK_NEW,INDEX4,1D0,LANV(1),CHUNK_NEW, W(1), 1,
C    &              0D0, LOCAL_PW(1),1)
         DO INDEX1=1,INDEX4
           LOCAL_PW(INDEX1)=DDOT(CHUNK_NEW,LANV((INDEX1-1)*CHUNK_NEW+1),
     &                           1, W(1), 1)
         ENDDO
         CALL MY_COMBINE(LOCAL_PW(1), PW(1), INDEX4*8, 1, LANGRP)
         DO INDEX1=1, INDEX4
            CALL DAXPY(CHUNK_NEW, -PW(INDEX1), 
     &                 LANV((INDEX1-1)*CHUNK_NEW+1), 1, W(1), 1)
         ENDDO
C     ==================================================================  
C       CALCULATE BETA: NORM OF VECTOR W
        LOCAL_BETA = DDOT(CHUNK_NEW, W(1), 1, W(1), 1)
        CALL MY_COMBINE(LOCAL_BETA, BETA, 8, 1, LANGRP)
        BETA = DSQRT(BETA)
C       NORMALIZE NEXT LANCZOS VECTOR
        CALL DSCAL(CHUNK_NEW, 1/BETA, W(1), 1)
        CALL DCOPY(CHUNK_NEW, W(1), 1, LANV(INDEX4*CHUNK_NEW+1), 1)
C       UPDATE TRIDIAGONAL MATRIX T (DIAGONAL AND SUP_DIAGONAL ENTRIES) 
        D(INDEX4) = ALPHA
        E(INDEX4) = BETA
C       UPDATE AUXILIARY VECTORS
        CALL MY_CONCATV(LANV((INDEX4)*CHUNK_NEW+1),VCUR(1),CHUNK_NEW,
     &                  SEND_CNT(1),SEND_DISPL(1),LANGRP)
        CALL DCOPY(CHUNK_NEW,LANV((INDEX4-1)*CHUNK_NEW+1),1,V_PREV(1),1)
C       CHECK CONVERGENCE FOR EIGENVALUES
        CALL DCOPY(INDEX4, D(1), 1, LD(1), 1)
        CALL DCOPY(INDEX4-1, E(1), 1, LE(1), 1)
        ABTOL = -1
C        IF (PARENT) PRINT *, ALPHA, BETA
C       ================================================================
C       THIS TEST IS PRACTICALLY NEVER DONE: FOR FUTURE USE
        IF (INDEX4.GT.NUM_EIG*2) THEN
          CALL  DSTEVX('N', 'I', INDEX4, LD(1), LE(1), VL, 
     &                 VU, 1, NUM_EIG, ABTOL,
     &                 NFOUND, EIG(1), Z(1), 1, WORK(1), IWORK(1), 
     &                 IFAIL(1), IERR)
          SM = DASUM(INDEX4, EIG(1), 1)
          IF  ( (ABS(SM-SM_OLD)/SM_OLD).LE.CONV_TOL ) THEN
             CONV_FLAG=.TRUE. 
             GOTO 666
          ENDIF
          SM_OLD = SM  
        ENDIF 
C       ================================================================
      ENDDO
 666  CONTINUE
C     ===================
C     END OF LANCZOS LOOP
C     ===================
      IF (.NOT.CONV_FLAG) INDEX4 = INDEX4-1
C     ==================================================================
C     DETERMINE THE EIGENVECTORS THAT EACH PROCESSOR IS GOING TO COMPUTE
C     ==================================================================
      CALL MY_SET_ORBDIST(NSTATE,NSTBLK,NORBX)
      NORB=NWA12(MEPOS,2)-NWA12(MEPOS,1)+1
      NORB=MAX(0,NORB)
      CHUNK_BEGIN_E = NWA12(MEPOS,1)
      CHUNK_END_E   = NWA12(MEPOS,2)
      CHUNK_NEW_E   = CHUNK_END_E - CHUNK_BEGIN_E +1
C     ==================================================================
C     DETERMINE SEND  BUFFERS
C     ==================================================================
      MSGLEN=8/IRAT
      CALL MY_CONCAT(CHUNK_NEW_E, SEND_CNT(1), MSGLEN, LANGRP)
      SEND_DISPL(1) = 0
      DO INDEX1=2, SZ
         SEND_DISPL(INDEX1) = SEND_DISPL(INDEX1-1) + SEND_CNT(INDEX1-1)
      ENDDO
C     ALLOCATE MEMORY FOR EIGENVECTORS
      CALL MEMORY(IP_Z, INDEX4*(CHUNK_END_E-CHUNK_BEGIN_E+1), 'Z')    
      CALL  DSTEVX('V','I',INDEX4,D(1),E(1),VL,VU,CHUNK_BEGIN_E,
     &             CHUNK_END_E,
     &             ABTOL, NFOUND, EIG(1), Z(1), INDEX4, WORK(1), 
     &             IWORK(1), IFAIL(1), IERR)
C     ==================================================================
C     CALCULATION OF APPROXIMATE EIGENVECTORS
C     EACH PROCESSOR WILL STORE COMPLETE EIGENVECTORS 
C     EIGENVECTORS ARE DISTRIBUTED ACROSS PROCESSORS
C     ==================================================================
      CALL MEMORY(IP_Z_TEMP, MY_MAXVAL(SEND_CNT(1),SZ)*NATTOT,
     &            'Z_TEMP')
C     ALLOCATION OF MEMORY FOR APPROXIMATE EIGENVECTORS
      CALL MEMORY(IP_EIG_VEC, NATTOT*CHUNK_NEW_E, 'EIG_VEC')
C     ALLOCATE ADDITIONAL MEMORY FOR BOOK KEEPING
      MSGLEN=8/IRAT
      CALL MY_CONCAT(CHUNK_NEW, OLD_SEND_CNT_E(1), MSGLEN, LANGRP)
      CALL MEMORY(IP_E_TEMP, 2*OLD_SEND_CNT_E(ME+1)*
     &            MAX(CHUNK_NEW_E,SEND_CNT(1)),
     &            'E_TEMP')
      DO INDEX1=1, NOLAN
         IF (RANK.EQ.(INDEX1-1) ) THEN
            CALL DCOPY(INDEX4*CHUNK_NEW_E, Z(1), 1, Z_TEMP(1), 1)
            DO INDEX2 = 1, SZ
               SEND_CNT_E(INDEX2) = OLD_SEND_CNT_E(INDEX2) * 
     &                              SEND_CNT(RANK+1)
C               IF (SEND_CNT(INDEX2).EQ.0) SEND_CNT_E(INDEX2) = 0
            ENDDO
            SEND_DISPL_E(1) = 0
            DO INDEX2=2, SZ
               SEND_DISPL_E(INDEX2) = SEND_DISPL_E(INDEX2-1) +
     &                       SEND_CNT_E(INDEX2-1)
            ENDDO
         ENDIF
C        BROADCAST COUNTS AND DISPL. DATA FOR ALLGATHER
         MSGLEN=SZ*8/IRAT
         CALL MY_BCAST(SEND_CNT_E(1), MSGLEN, INDEX1-1, LANGRP)
         CALL MY_BCAST(SEND_DISPL_E(1), MSGLEN, INDEX1-1, LANGRP)
C        BROADCAST MY EIGENVECTORS OF THE TRIDIAGONAL MATRIX
         CALL MY_BCAST(Z_TEMP(1), SEND_CNT(INDEX1)*INDEX4*8, INDEX1-1,
     &                   LANGRP)
C        MULTIPLY RECEIVED EIGENVECTORS WITH MY PART OF THE LANCZOS
C        BASIS
         CALL DGEMM("N","N",CHUNK_NEW,SEND_CNT(INDEX1),INDEX4,1D0,
     &              LANV(1),CHUNK_NEW,Z_TEMP(1),INDEX4,
     &              0D0, E_TEMP(1), CHUNK_NEW)

C        BRING RESULTS BACK TO THE CORESSPONDING PROCESSOR 
         CALL MY_SOURCE_CONCATV(E_TEMP(1),EIG_VEC(1),
     &                          CHUNK_NEW*SEND_CNT(INDEX1),
     &                          SEND_CNT_E(1), SEND_DISPL_E(1),
     &                          INDEX1-1, LANGRP)

      ENDDO 
C     ==================================================================
      DO INDEX1 = 1, NATTOT
         LC_INDEX(INDEX1) = 0
      ENDDO
      START     = 1
      START_COL = 1
      DO INDEX1 = 1, SZ
         DO INDEX2 = 1, CHUNK_NEW_E 
            CALL DCOPY(OLD_SEND_CNT_E(INDEX1), EIG_VEC(START_COL), 1, 
     &                 Z_TEMP(START+LC_INDEX(1)), 1)
            START_COL = START_COL + OLD_SEND_CNT_E(INDEX1)
            START     = START + NATTOT  
         ENDDO
         LC_INDEX(1) = LC_INDEX(1) + OLD_SEND_CNT_E(INDEX1)
         START = 1 
      ENDDO
      CALL DCOPY(NATTOT*CHUNK_NEW_E, Z_TEMP(1), 1, EIG_VEC(1), 1)
C     ==================================================================
C     END LANCZOS ITERATION ON LANGRP
C     ==================================================================
      ELSE
C        PROCESSORS THAT DID NOT PARTICIPATE IN LANCZOS
C        WILL WAIT IN SUBSEQUENT COLLECTIVE 
      ENDIF  
C     SEND CHUNK INFORMATION TO ALL PROCESSORS
      MSGLEN=8/IRAT
      CALL MY_CONCAT(CHUNK_NEW_E, SEND_CNT(1), MSGLEN, ALLGRP)
C     FIND LARGEST NUMBER OF APPROX. EIGENVECTORS HELP BY PROCEESORS
      IF (CHUNK_NEW.EQ.0) THEN
         CHUNK_NEW_E = SEND_CNT(1)
         DO INDEX1=2,NOLAN
            IF (SEND_CNT(INDEX1).GT.CHUNK_NEW_E) 
     &                               CHUNK_NEW_E = SEND_CNT(INDEX1)
         ENDDO
         CALL MEMORY(IP_Z_TEMP, CHUNK_NEW_E*NATTOT, 'Z_TEMP')
      ENDIF
C     ==================================================================
C     COMPUTE APPROXIMATE "ATOMIC" WAVEFUNCTIONS
C     ==================================================================
      START_COL = 0
      START = 1
C     ===========================
C     NEEDED FOR LSD CALCULATIONS
      START_SPU = 1
      START_SPD = 1
      FLAG_SPU = .TRUE.
      FLAG_SPDOWN = .TRUE.
C     ===========================
      DO INDEX1=1, NOLAN
         IF (RANK.EQ.(INDEX1-1) ) THEN
C        INITIALIZE TEMP. SPACE TO ZERO
            CALL AZZERO(Z_TEMP(1), NATTOT*CHUNK_NEW_E)
            CALL DCOPY(NATTOT*CHUNK_NEW_E, EIG_VEC(1), 1, Z_TEMP(1), 1)
         ENDIF
C        CURRENT ROOT BROADCASTS ITS APPROX. EIGENVECTORS 
         CALL MY_BCAST(Z_TEMP(1), SEND_CNT(INDEX1)*NATTOT*8, INDEX1-1,
     &                 ALLGRP)
C        EACH PROCESSOR MULTIPLIES THE APPROXIMATE EIGVECS
C        RECEIVED AND STORES THEM AT THE APPROPRIATE POSITION
C        IN MATRIX C0
C        ==============================================================
C        HANDLE CASE FOR LOCAL SPIN DENSITY CALCULATION (LSD)
C        TLSD2 IS READ AS AN ARGUMENT
C        RESULT FOR SPIN-UP FIRST THEN FOR SPIN-DOWN
C        ==============================================================
         IF (TLSD2) THEN
C           SPIN UP
            IF (FLAG_SPU) THEN 
               IF ( (START_SPU+SEND_CNT(INDEX1)-1).LE.NSUP ) THEN
                  CALL DGEMM("N","N",2*NGWK,SEND_CNT(INDEX1),
     &                    NATTOT,1D0,
     &                    CATOM(1,1),2*NGWK,Z_TEMP(1),NATTOT,
     &                    0D0, C0(1,START_SPU,IKIND), 2*NGWK)
               ELSE
                  CALL DGEMM("N","N",2*NGWK,NSUP-START_SPU+1,
     &                    NATTOT,1D0,
     &                    CATOM(1,1),2*NGWK,Z_TEMP(1),NATTOT,
     &                    0D0, C0(1,START_SPU,IKIND), 2*NGWK)
                  FLAG_SPU = .FALSE.
               ENDIF
               START_SPU = START_SPU + SEND_CNT(INDEX1)
            ENDIF
C           SPIN DOWN 
            IF (FLAG_SPDOWN) THEN
               IF ( (START_SPD+SEND_CNT(INDEX1)-1).LE.NSDOWN ) THEN
                  CALL DGEMM("N","N",2*NGWK,SEND_CNT(INDEX1),
     &                    NATTOT,1D0,
     &                    CATOM(1,1),2*NGWK,Z_TEMP(1),NATTOT,
     &                    0D0, C0(1,NSUP+START_SPD,IKIND), 2*NGWK)
               ELSE
                  CALL DGEMM("N","N",2*NGWK,NSDOWN-START_SPD+1,
     &                    NATTOT,1D0,
     &                    CATOM(1,1),2*NGWK,Z_TEMP(1),NATTOT,
     &                    0D0, C0(1,NSUP+START_SPD,IKIND), 2*NGWK)
                  FLAG_SPDOWN = .FALSE.
               ENDIF
               START_SPD = START_SPD + SEND_CNT(INDEX1)
            ENDIF
         ELSE
C           ===================
C           HANDLE NON LSD CASE
C           ===================
            IF (.NOT.AINITWFFLAG) THEN
              CALL DGEMM("N","N",2*NGWK,SEND_CNT(INDEX1),NATTOT,1.D0,
     &              CATOM(1,1),2*NGWK,Z_TEMP(1),NATTOT,
     &              0.D0, C0(1,START,IKIND), 2*NGWK)
              START = START + SEND_CNT(INDEX1)
            ELSE
              DO INDEX2=1, SEND_CNT(INDEX1)
                IF (QUERYRANDS(START + INDEX2 -1)) THEN
                  CALL DGEMV("N",2*NGWK,NATTOT,1.D0,
     &              CATOM(1,1),2*NGWK,Z_TEMP((INDEX2-1)*NATTOT+1),1,
     &              0D0, C0(1,START+INDEX2-1,IKIND), 1)
                    CALL GS_ORTHO(C0(1,1,IKIND),START+INDEX2-2,
     &                   C0(1,START+INDEX2-1,IKIND),1,
     &                   TST1,TST2)
                ENDIF
              ENDDO  
              START = START + SEND_CNT(INDEX1)
            ENDIF 
         ENDIF
      ENDDO
C     ==================================================================
C     DEALLOCATIONS OF MEMORY
C     ==================================================================
      IF (CHUNK_NEW.NE.0) THEN
         CALL FREEM(IP_LANV)
         CALL FREEM(IP_W)
         CALL FREEM(IP_PW)
         CALL FREEM(IP_LOCAL_PW)
         CALL FREEM(IP_V_PREV)
         CALL FREEM(IP_Z)
         CALL FREEM(IP_Z_TEMP)
         CALL FREEM(IP_E_TEMP)
         CALL FREEM(IP_EIG_VEC)
         CALL FREEM(IP_VCUR)
         CALL FREEM(IP_V0)
      ELSE
         CALL FREEM(IP_Z_TEMP)
      ENDIF
C     GLOBAL DEALLOCATIONS
      CALL FREEM(IP_LOCAL_XXMAT)
      CALL FREEM(IP_TEMP_XXMAT)
      CALL FREEM(IP_TEMP1_XXMAT) 
#endif
C     =================================================================
      CALL TIHALT('    DISTKS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_DIST_KSMAT(LKSMAT,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGWK
      INCLUDE 'atwf.inc'        !NATTOT, NUMAORMAX
C     Arguments
      INTEGER   LKSMAT
      CHARACTER TAG*30
C     Variables
      INTEGER   LRNLSM, LFNONLOC
      INTEGER   IL_AUXC,IL_DDIA
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NATTOT,.FALSE.)
      CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NUMAORMAX)
      LFNONLOC = IL_AUXC + IL_DDIA
      LKSMAT=MAX(LFNONLOC,LRNLSM)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
