c     =================================================================
      subroutine lanc_phon_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &     eirop,eivps,
     &     z11,nstate)
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'irat.inc'
      include 'symm.inc'
      include 'rmas.inc'
      include 'cotr.inc'
      include 'adat.inc'
      include 'coor.inc'
      include 'soft.inc'
      include 'store.inc'
      include 'elct.inc'
      include 'spin.inc'
      include 'sfac.inc'
      include 'nlps.inc'
      include 'pslo.inc'
      include 'atwf.inc'
      include 'kpts.inc'
      include 'kpnt.inc'
      include 'fft.inc'
      include 'response_p.inc'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'prop.inc'
      include 'implhv.inc'
c     ==--------------------------------------------------------------==
c     Arguments
      integer    nstate,lscr
      complex*16 c0(ngw,nstate),c1(ngw,nstate)
      complex*16 psi(*)
      real*8     rhoe(*)
      real*8     drhoe(nnr1),z11(nstate,nstate)
      complex*16 eirop(nhg),eivps(nhg)
      real*8     scr(*)
c     ==--------------------------------------------------------------==
c     Local variables
      integer    isub,lda,i,j,k,is,ia,iat
      integer    ix,msglen,ie,lfnl,ldfnl,ii
#ifdef CRAY64
      REAL*8     SDOT
#else
      real*8     ddot
#endif
c     ==--------------------------------------------------------------==

      complex*16 eirop1(nhg),v1_loc(nhg)
      complex*16 v1(maxfft),pippo(nhg)
      real*8     FNL(imagp,nat,nhxs,nstate,nkpnt)
      real*8     DFNL(imagp,nat,nhxs,3,nstate,nkpnt)
c     ==--------------------------------------------------------------==
      real*8     xmass,vibe(*)
c     ==--------------------------------------------------------------==
      pointer    (ip_vibe,vibe),(ip_v1,v1)
      pointer    (ip_eirop1,eirop1),(ip_v1_loc,v1_loc)
      pointer    (ip_pippo,pippo)
c     ==--------------------------------------------------------------==
      integer    lastvalid,iii,info,iter,lastconverged,istate
      real*8     eigenvect(lanczos_dim,lanczos_dim)
      pointer    (ip_eigenvect, eigenvect)
c     Here, we store the eigensystem of the tridiagonal
c     Lanczos matrix. Thus the dimension is lanczos_dim x lanczos_dim.

      real*8     tras(3*nat,3),rot(3*nat,3)
      pointer    (ip_tras,tras),(ip_rot,rot)
      real*8     alpha(*),beta(*)
      pointer    (ip_alpha,alpha), (ip_beta, beta)
      real*8     diagonals(*),subdiagonals(*)
      pointer    (ip_diagonals,diagonals), 
     &     (ip_subdiagonals, subdiagonals)
      real*8     tmp(*),eig3n(3*nat,*)
      pointer    (ip_tmp, tmp),(ip_eig3n,eig3n)
      real*8     work,norm
      pointer    (ip_work, work)

c     ==--------------------------------------------------------------==
      integer lanczos_dim_old,nodim_old,iter_ini

      character  converged*30

c     ==--------------------------------------------------------------==
c     Start of executable statements  *******************************
c     ==--------------------------------------------------------------==
C     DFNL
#ifdef PARALLEL
      NDFNL=NST12(MEPOS,2)-NST12(MEPOS,1)+1
#else
      NDFNL=NSTATE
#endif
      LDFNL=IMAGP*3*NAT*NHXS*NDFNL*NKPNT
      IF(LDFNL.LE.0) LDFNL=1

      call tiset('    lanc_phon',isub)

      call memory(ip_rs_v, lanczos_dim*3*nat, 'response')
      call memory(ip_eigenvect, lanczos_dim*lanczos_dim, 'eigenvect')
      call memory(ip_work, lanczos_dim*lanczos_dim, 'work')
      call memory(ip_alpha,         lanczos_dim, 'lanczos_a')
      call memory(ip_beta,          lanczos_dim, 'lanczos_b')
      call memory(ip_diagonals,     lanczos_dim, 'lanczos_a2')
      call memory(ip_subdiagonals,  lanczos_dim, 'lanczos_b2')
      call memory(ip_tmp,           3*nat, 'Lanczos tmp')
      call memory(ip_xma,3*nat,'xma')

      call memory(ip_fnl00,imagp*nstate*nat*nhxs*nkpnt,'fnl00')
      call memory(ip_dfnl00,ldfnl,'dfnl00')
      call memory(ip_ddfnl,3*ldfnl,'ddfnl')
      call memory(ip_sd0,9*nat*nat,'sd0')
      call memory(ip_tras,9*nat,'tras')
      call memory(ip_rot,9*nat,'rot')
      call memory(ip_eig3n,3*nat*lanczos_dim,'eig3n')
      call memory(ip_pippo,2*maxfft,'pippo')
c ----------------------------------------------------------------------

      if(parent) then
c     mass weights for force constants
         ix=0
         do is=1,nsp
            xmass=sqrt(1.d0/pma0(is))
            do ia=1,na(is)
               do k=1,3
                  ix=ix+1
                  xma(ix)=xmass
               enddo
            enddo
         enddo

      endif

#ifdef PARALLEL

      msglen=3*nat*8
      call my_bcast(xma,msglen,source,allgrp)

#endif

c ... definition of the vectors describing ... 
c ... center of mass translation, tras(3*nat,3)
      call settras(tras)

c ... and elemental rotations of the molecule wrt the axes x,y,z
      call setrot(rot,tras)
      

c calculate the derivative of dfnl ddfnl     
      call rnlsm3(c0,scr,lscr,nstate,ddfnl)
      
c     ==--------------------------------------------------------------==
C     NB[dsebasti]: the unperturbed density is always already in
C     the common block variable "rho0"

C     FNL,DFNL,DDFNL...
      ndfnl=nst12(mepos,2)-nst12(mepos,1)+1
      ldfnl=imagp*3*nat*nhxs*ndfnl*nkpnt
      if(ldfnl.le.0) ldfnl=1
      lfnl = imagp*nstate*nat*nhxs*nkpnt

      call rnlsm(c0,nstate,psi,scr,lscr,1,1,.true.)
      call DCOPY(lfnl,   fnl,1,  fnl00,1)
      call DCOPY(ldfnl, dfnl,1, dfnl00,1)


c ... Part of the Hessian matrix depending *only* con c0
      call azzero(sd0,3*3*nat*nat)
      call setsd0(eirop,ddfnl,nstate,psi)

      call azzero(rs_v,lanczos_dim*3*nat)
      call azzero(beta,lanczos_dim)
      call azzero(alpha,lanczos_dim)

c     ==--------------------------------------------------------------==
c     Initialization: first run or continuation   ********************
c     ==--------------------------------------------------------------==
      if(parent) then
         write(6,'(2x,A,29x,i6)') 'LANCZOS DIMENSION ',LANCZOS_DIM-1
         write(6,'(2x,a,16x,i6)')'NUMBER OF REQUESTED ITERATIONS ',
     &        nlan_st
         write(6,'(2x,a,12x,e10.4)') 'CONVERGENCE THRESHOLD ON'//
     &    ' EIGENVECTORS ',conv_threshold
         if(lanczos_dim-1.lt.nlan_st) then
            write(6,'(2x,a)') '!!!!! ITERATIONS REQUESTED EXCEED '//
     &           'LANCZOS DIMENSION !!!!!'
            call stopgm('LANC_PHON','TOO MANY ITERATIONS')
         ENDIF
      endif
      if(tlanph_cont) then
         if (parent) then
            nodim_old=nodim
            call cont_lanczos(lanczos_dim_old,iter_ini,nodim_old,
     &           iat,rs_v,alpha,beta,'READ')
            write(6,'(/,2x,a,21x,i6)') 'RESTARTING WITH ITERATION ',
     &           ITER_INI
            if(lanczos_dim_old.ne.lanczos_dim) then
               write(6,'(2x,a,2i6)') 'WARNING LANCZOS DIMENSION CHANGED'
     &              ,lanczos_dim-1,lanczos_dim_old-1
            elseif(nodim_old.ne.nodim) then
               write(6,'(2x,a,2i6)')'WARNING DEG. OF FREEDOM CHANGED '
     &              ,nodim,nodim_old
            endif
            if(nlan_st+iter_ini.gt.lanczos_dim) then
               write(6,'(2x,a)') '******** WARNING *********'
               write(6,'(2x,a,15x,I6)')'THE REQUESTED LANCZOS '//
     &             'ITERATIONS'  ,NLAN_ST
               write(6,'(2X,A,15x,I6)')'EXCEED LANCZOS SPACE '//
     &              'DIMENSIONS ',LANCZOS_DIM-1
               NLAN_ST=LANCZOS_DIM-ITER_INI
               WRITE(6,'(2X,A,27x,I6)')'ITERATIONS RESET TO '
     &              ,NLAN_ST
            endif
         endif
#ifdef PARALLEL
         msglen = 1 * 8 /IRAT
         call my_bcast(iter_ini,msglen,source,allgrp)
         call my_bcast(iat,msglen,source,allgrp)
         call MY_BCAST(nlan_st,msglen,source,allgrp)
         msglen = nodim * iter_ini * 8
         call my_bcast(rs_v(1,1),msglen,source,allgrp)
#endif

c ... exit the cycle without overwriting VIBEIGVEC and LANCZOS_CONTINUE.1
         if(nlan_st.le.0) goto 558

      else
         iter_ini=1
         beta(1) = 0d0          ! for security (not really needed).
         iat=0
         
C ...  initialize the first response_vector randomly (unit norm)
      
         if(parent) then   
            CALL DURAND (9.d0,3*nat,rs_v(1,1)) 
         
c ... projecting out rotational and translational degrees of freedom  
            if(projout) call no_mode(tras,rs_v(1,1),nat)
            if(rotout)  call no_mode(rot, rs_v(1,1),nat)

            norm = dsqrt(DDOT(3*nat,rs_v(1,1),1,rs_v(1,1),1))
            call DSCAL(3*nat, 1d0/norm, rs_v(1,1),1)
         endif

#ifdef PARALLEL
         msglen=3*nat*8
         call my_bcast(rs_v(1,1),msglen,source,allgrp)
#endif
      endif
c     All other arrays are expected to be correctly initialized by the calling
c     (and allocating) routine, do_perturbation_p().

c      i = 1                     ! dummy. Serve per la rnlrh1.


c     Do the Lanczos steps.
c     ==--------------------------------------------------------------==
c     Start Lanczos cycle    *****************************************
c     ==--------------------------------------------------------------==
      do iter=iter_ini,iter_ini+nlan_st-1

c...  first normalization with the masses
         call azzero(tmp,3*nat)
c ........................rs_v(1,iter)|---> tmp
         call DCOPY(3*nat,rs_v(1,iter),1,tmp,1)
!$OMP parallel do private(j)
         do j=1,3*nat
            tmp(j)=tmp(j)*xma(j)
         enddo

c...  Routine hess_eta; calculates implicitly the matrix-vector product
c...  v2 = H v1
c...  Input;  rs_v(1,iter)   is v1.
c...  Output; rs_v(1,iter+1) is v2.
c...  The calling is made explicitly with all the matrix rs_v
         if (mod(iter,3).eq.1) iat=iat+1

c     ==--------------------------------------------------------------==
         call hess_eta_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &        eirop,eivps,z11,nstate,iter,iat,ddfnl,tmp)
c     ==--------------------------------------------------------------==

c...  second normalization by the masses
!$OMP parallel do private(j) shared(iter)
         do j=1,3*nat
            rs_v(j,iter+1)=rs_v(j,iter+1)*xma(j)
         enddo

#ifdef PARALLEL
         call glosum(3*nat,rs_v(1,iter+1))
#endif

         if(.not.exsoft) call testex(exsoft)
         if (exsoft) then
            if (parent) then 
               call cont_lanczos(lanczos_dim,iter,nodim,iat,rs_v,
     &              alpha,beta,'WRITE')
               call softex
            endif
            goto 558
         endif

         if(parent) then
            norm =dsqrt(DDOT(3*nat, rs_v(1,iter+1),1,rs_v(1,iter+1),1))
            write(6,*) ' '
            print *,'******************************',
     &           '**********************************'
            print *,' *+*   L2 norm[n[',iter+1,']]     = ', norm

c     ==--------------------------------------------------------------==
c     Proceed with the Lanczos algorithm:
c     A v1 (the answer) is in response(:,iter+1) == v2:
c     v2   = A v1
c     ==--------------------------------------------------------------==

            call azzero(tmp,3*nat)
            call DCOPY(3*nat, rs_v(1,iter+1),1,tmp,1)
c     tmp  = v2

            alpha(iter)=DDOT(3*nat,rs_v(1,iter),1,tmp,1)
c     a1   = v1 A v1
c     \    = v1 tmp
c     \    This is the projection of the input vector (iter)
c     \    onto the reponse vector (iter+1). -> Orthogonalization.

            call DAXPY(3*nat, - alpha(iter), rs_v(1,iter), 1,
     &           rs_v(1,iter+1), 1)
c     v2   = v2  -  a1 v1

            if (.not. (iter .eq. 1))
     &           call DAXPY(3*nat, - beta(iter),rs_v(1,iter-1), 1,
     &           rs_v(1,iter+1), 1)
c     v2   = v2  -  b1 v0

c ...  projecting out rotational and translational degrees of freedom
            if(projout) call no_mode(tras,rs_v(1,iter+1),nat)
            if(rotout) call no_mode(rot,rs_v(1,iter+1),nat)

c     *** Here, we do a complete orthogonalization of the new
c     \   vector (tmp=A v_i) wrt the old ones (v_j, j=1..i-1).
            if (iter .ge. 2) then
               do i=1,iter
                  norm=-DDOT(3*nat,rs_v(1,iter+1),1,rs_v(1,i),1)
                  call DAXPY(3*nat,norm,rs_v(1,i),1,rs_v(1,iter+1),1)
               enddo
            endif
        
            norm=dsqrt(DDOT(3*nat,rs_v(1,iter+1),1,rs_v(1,iter+1),1))
     
            beta(iter+1) = norm
         
c     b2   =  sqrt  v2 A v1  =  sqrt  v2 tmp

            call DSCAL(3*nat, 1d0/norm,rs_v(1,iter+1), 1)
c     v2 is normalized.
         endif

#ifdef PARALLEL

         msglen=3*nat*8
         call my_BCAST(rs_v(1,iter+1),MSGLEN,SOURCE,ALLGRP)
#endif

         if(parent) then
            print *,' *=*   overlap: alpha[',
     &           iter,'] = ',alpha(iter)
            print *,' *=*   off-diag: beta[',
     &           iter+1,'] = ',beta(iter+1)
            print *,' *=*   norm:               = ',norm
            
c     ==--------------------------------------------------------------==

            print *,'******************************',
     &           '**********************************'
            call DCOPY(iter, alpha, 1, diagonals, 1)
            call DCOPY(iter-1, beta(2), 1, subdiagonals, 1)

c     Now, the diagonal [alpha(*)] and the subdiagonal [beta(*)]
c     elements of the (tridiagonal) Lanczos matrix 
c     are calculated. This matrix is now diagonalized:

            call DSTEV('V', iter, diagonals, subdiagonals,
     &           eigenvect, lanczos_dim, work, info)
            if (info .ne. 0) print *,'DSTEV exit status: ', info
            
c     output of dstev:
c     \  alpha = eigenvalues,
c     \  eigenvect = corresponding eigenvectors.
            
            write(6,'(x,a,i3,a)') '*** SPECTRUM, cycle',iter,':'
            lastconverged = iter
            do i=iter,1,-1
               if ( abs(eigenvect(iter,i)) .lt. conv_threshold) then
                  converged = '       (converged: '
                  if ( lastconverged .eq. i+1)
     &                 lastconverged = i
               else
                  converged = '   (NOT converged: '
               endif
               call xstring(converged,ia,ie)
               print '(A,I3,A,F12.7,A,F8.6,A)',
     &              ' *** eigenvalue ',i,' = ',diagonals(i),
     &              converged(ia:ie),abs(eigenvect(iter,i)),').'
            enddo

            do i=1,iter
               diagonals(i)=sign(5140.487d0*
     &              dsqrt(abs(diagonals(i))),diagonals(i))
            enddo
            write(6,'(/," ",64("*"),/,a,/)')
     &           ' harmonic frequencies [cm**-1]:'

            write(6,'(4(f16.4))') (diagonals(i),i=1,iter)

            write(6,*) ' '
            print *,'******************************',
     &           '**********************************'
         endif
c ... writing on file the results of the job
         if (parent) then 
            call cont_lanczos(lanczos_dim,iter,nodim,iat,rs_v,
     &           alpha,beta,'WRITE')
         endif
         if(.not.exsoft) call testex(exsoft)
         if(exsoft) then
            call softex
            goto 558
         endif
      enddo


      if (parent) then
         call cont_lanczos(lanczos_dim,iter,nodim,iat,rs_v,alpha,
     &        beta,'WRITE')
      endif

      
c     ==--------------------------------------------------------------==
c     == END / Lanczos runs.
c     ==--------------------------------------------------------------==

      lastvalid = iter_ini+nlan_st-1
      
      if (parent) then
         do istate=lastvalid,1, -1
            call azzero(tmp,3*nat)
c     build the eigenvector of the linear answer machinery:
            if (3*nat.ge.lastvalid) then
               lda=3*nat
            else
               lda=lastvalid
            endif
            call DGEMV('N', 3*nat, lastvalid, 1d0, rs_v, lda,
     &           eigenvect(1,istate),1, 0d0, eig3n(1,istate), 1)
            
            
            if(details) then
               do i=1,lastvalid
                  print '(A,I2,A,I2,A,F15.11)',
     &                 '  \*  Lanczos(',i,'; ',istate,') = ',
     &                 eigenvect(i,istate)
               enddo
               write(6,*) ' '
               do i=1,3*nat
                  write(6,*) i,istate,eig3n(i,istate)
               enddo
               write(6,*) ' '
            endif
         enddo
         call VIBEIG_lan(diagonals,eig3n,3*nat,lanczos_dim)
      endif
      

c     ==--------------------------------------------------------------==
c     == END / Output of eigensolutions.
c     ==--------------------------------------------------------------==

c     ==--------------------------------------------------------------==
c     == CHECK whether the Lanczos and Ritz vectors are orthonormal:
c     ==--------------------------------------------------------------==

      if(parent.and.details) then
         do i=1,lastvalid
c     check orthonormality of Ritz i against Ritz i, i+1, i+2,...:
            do ii=i,lastvalid
               norm = 0d0
               do iii=1,lastvalid
                  norm = norm + eigenvect(iii,i)*eigenvect(iii,ii)
               enddo
               print '(A,I2,A,I2,A,F15.11)',
     &              ' *** Ritz(',i,') . Ritz(',ii,') =     ',norm
               
c     check orthonormality of Krylov i against Krylov i, i+1, i+2,...:
               norm = DDOT(3*nat,rs_v(1,i),1,rs_v(1,ii),1)
               print '(A,I2,A,I2,A,F15.11)',
     &              ' *** Krylov(',i,') . Krylov(',ii,') = ',norm
            enddo
         enddo
      endif

c     ==--------------------------------------------------------------==
c     ==--------------------------------------------------------------==

 558  continue

      call freem(ip_tmp)
      call freem(ip_rs_v)
      call freem(ip_eigenvect)
      call freem(ip_work)
      call freem(ip_alpha)
      call freem(ip_beta)
      call freem(ip_diagonals)
      call freem(ip_subdiagonals)
      call freem(ip_fnl00)
      call freem(ip_dfnl00)
      call freem(ip_ddfnl)

      call freem(ip_sd0)
      call freem(ip_xma)
      call freem(ip_tras)
      call freem(ip_rot)
      call freem(ip_eig3n)

      call freem(ip_pippo)      
      return
      end

c     ==--------------------------------------------------------------==
      subroutine no_mode(mode,epsilon,nat)
c     ==--------------------------------------------------------------==
      implicit none
      integer i,nat
      real*8 epsilon(*),mode(3*nat,3),alfa,DDOT

      do i=1,3
         alfa = - DDOT(3*nat,epsilon,1,mode(1,i),1)
         call DAXPY(3*nat,alfa,mode(1,i),1,epsilon,1)
      enddo

      return
      end

c     ==--------------------------------------------------------------==
      subroutine setsd0(eirop,ddfnl,nstate,psi)
c     ==--------------------------------------------------------------==
      implicit none

      include 'system.h'
      include 'ions.inc'
      include 'coor.inc'
      include 'nlps.inc'
      include 'kpnt.inc'
      include 'elct.inc'
      include 'fft.inc'
      include 'response_p.inc'
      include 'implhv.inc'
      
      integer iat,is,ia,k,icol,iat2,is2,ia2,k2,ix,nstate
      real*8     ddfnl(imagp,nat,nhxs,3,3,nstate,nkpnt)
      complex*16 eirop(nhg),eirop1(nhg),v1_loc(nhg),psi(*)
      dimension F(*)

      pointer    (ip_eirop1,eirop1),(ip_v1_loc,v1_loc)


      call memory(ip_eirop1,2*nhg,'eirop1')
      call memory(ip_v1_loc,2*nhg,'v1_loc')


c ... computation of the part of the Hessian matrix independent on the
c ... perturbed wavefunctions. Only rhoe0 enters here. Elements stored 
c ... in the matrix sd0(3*nat,3*nat).

      call ffttog(rho0,rho0,psi,nhg,.true.)
C     ...because d_mat_diag_loc wants rho^0 in G space!
      iat=0
      do is=1,nsp
         do ia=1,na(is)
            iat=iat+1
            do k=1,3

               call zazzero(v1_loc,nhg)
               call zazzero(eirop1,nhg)
c..   calculate the local perturbation wrt. to atom iat and coordinate k
               call eicalc1(k,is,iat,v1_loc,eirop1)
               
               icol=3*(iat-1)+k
               iat2=0
               do is2=1,nsp
                  do ia2=1,na(is2)
                     iat2=iat2+1
                     do k2=1,3
                        ix=3*(iat2-1)+k2
                        
                        if(iat.eq.iat2) then
c     local part, i=j (i,j=atoms)
                           call d_mat_diag_loc(sd0(ix,icol),rho0,
     &                          eirop,eirop1,v1_loc,k2,is) 
c     non-local part, i=j (i,j=atoms)
                           call d_mat_diag_nonloc(sd0(ix,icol),
     &                          ddfnl,fnl00,
     &                          dfnl00,f,wk,is,k,k2,iat,nstate,1)
c     real space term, i=j
                           call d_mat_diag_real(sd0(ix,icol),is,ia,k,k2,
     &                          tau0)
c     real space term, i <> j
                        else
                           call d_mat_real(sd0(ix,icol),is,ia,k,k2,
     &                          is2,ia2,tau0)
                        end if
                        
c     local part        
                        call d_mat_loc0(sd0(ix,icol),eirop1,
     &                       iat2,k2,is2)
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
      call ffttor(rho0,rho0,psi,nhg,.true.)

      call freem(ip_eirop1)
      call freem(ip_v1_loc)

      return
      end

C     ==================================================================
      SUBROUTINE VIBEIG_lan(VIBE,SDER,NDIM,lanczos_dim)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'fileopen.inc'
C     Arguments
      INTEGER   NDIM,lanczos_dim
      REAL*8    VIBE(lanczos_dim),SDER(NDIM,lanczos_dim)
C     Variables
      CHARACTER FILEN*100
      INTEGER   I,J,K,NN,NCOL
      LOGICAL   FERROR
C     ==--------------------------------------------------------------==
      NCOL=8
      FILEN='VIBEIGVEC'
      CALL FILEOPEN(21,FILEN,FO_DEF,FERROR)
      DO I=1,lanczos_dim-1,NCOL
        NN=MIN(NCOL,lanczos_dim-I)
        WRITE(21,'(14I12)') (J,J=I,I+NN-1)
        WRITE(21,'(14(F12.3))') (VIBE(J),J=I,I+NN-1)
        WRITE(21,*)
        DO K=1,NDIM
          WRITE(21,'(14F12.6)') (SDER(K,J),J=I,I+NN-1)
        ENDDO
      ENDDO
      CALL FILECLOSE(21)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


C     ==================================================================
      SUBROUTINE cont_lanczos(lanczos_dim,iter,ndim,iat,rs_v,
     &     alpha,beta,tag)
C     ==--------------------------------------------------------------==
      implicit none
      include 'fileopen.inc'
c     Arguments
      integer lanczos_dim,iter,ndim,iat
      real*8 rs_v(ndim,*),alpha(*),beta(*)
C     Variables
      CHARACTER FILEN*100,tag*5
      INTEGER   I,K,iunit
      LOGICAL   FERROR
C     ==--------------------------------------------------------------==
      iunit=21

      IF(INDEX(TAG,'READ').NE.0) THEN
         FILEN='LANCZOS_CONTINUE'
         CALL FILEOPEN(IUNIT,FILEN,FO_OLD,FERROR)
         IF(FERROR) THEN
            WRITE(6,'(A)') ' CONT_LANCZOS! FILE LANCZOS_CONTINUE DOES'//
     &           'NOT  EXIST'
            CALL STOPGM('CONT_LANCZOS','CANNOT READ OLD RESPONSE '//
     &           'VECTORS')
         ENDIF

         REWIND(IUNIT)
         read(iunit,'(4i12)') lanczos_dim,iter,ndim,iat

         DO I=1,iter
            DO K=1,NDIM
               read(iunit,*) rs_v(K,I)
            ENDDO
            read(iunit,*) alpha(i),beta(i)
         ENDDO
      ELSEIF(INDEX(TAG,'WRITE').NE.0) THEN
         FILEN='LANCZOS_CONTINUE.1'
         CALL FILEOPEN(IUNIT,FILEN,FO_DEF,FERROR)

         REWIND(IUNIT)
         write(iunit,'(4i12)') lanczos_dim,iter,ndim,iat
         DO I=1,iter
            DO K=1,NDIM
               WRITE(iunit,*) rs_v(K,I)
            ENDDO
            write(iunit,*) alpha(i),beta(i)
         ENDDO
      ELSE
        WRITE(6,'(A,A)') ' CONT_LANCZOS| UNKNOWN TAG: ',TAG
      ENDIF

      CALL FILECLOSE(IUNIT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
