C     ==================================================================
      SUBROUTINE LDOS(C0,PSI,WE,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  LAYER PROJECTED DENSITY OF STATES                           ==
C     ==--------------------------------------------------------------==
C     ==  WARNING: IF YOU USE SPECIAL K-POINTS FOR A SPECIAL STRUCTURE==
C     ==           YOU NEED TO SYMMETRIZE CHARGE DENSITY              ==
C     ==           FOR THAT -> SPECIFY THE POINT GROUP                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'ldos.inc' 
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGWK,NSTATE,NKPNT),PSI(MAXFFT*NOGRP)
      REAL*8     SCR(LSCR),WE(NSTATE,NKPNT)
C     Variables
      DIMENSION  F(NSTATE,NKPTS),WK(NKPTS),
     &           HGKP(NHG,NKPNT),HGKM(NHG,NKPNT)
      POINTER    (IP_DLDOS,DLDOS)
      REAL*8     FNL(*),DFNL(*),DLDOS(NLAYER,NSTATE,NKPNT)
      INTEGER    ISUB,LEAD,LEADX,NNRX,IFFT,I,L,IS1,II,IFIRST,
     &           IG,ID,NSTA,IB,IBB,LLDOS,IA,IC,I1,I2,I3, 
     &           KBEG,KEND,KINC,IKPT,NKPOINT,IKK,IKIND,IULDOS,IK
      REAL*8     COEF3,R1,R2
      CHARACTER  TAG*30,FILELDOS*100
      DATA IFIRST/1/
      LOGICAL    TFCAL,FERROR
C     ==--------------------------------------------------------------==
      CALL TISET('      LDOS',ISUB)
C     ==--------------------------------------------------------------==
C     Test on SCR dimension
      CALL GIVE_SCR_LDOS(LLDOS,TAG)
      CALL TEST_SCR('LDOS',TAG,LSCR,LLDOS)
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(1X,64("<")/20X,A16/1X,64(">"))') 
     &     'CALCULATING LDOS' 
      ENDIF
      IF(IFIRST.EQ.1) THEN 
        IFIRST=0
        CALL MEMORY(IP_DLDOS,NLAYER*NSTATE*NKPNT,'DLDOS') 
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NOGRP.GT.1) THEN
        CALL STOPGM(' LDOS',' DOESNT WORK FOR NOGRP GT 1')
      ENDIF
#ifdef PARALLEL
      IF(NOGRP.EQ.1) THEN
        LEAD  = KR1S*NGRAYS
        LEADX = NNR1
        IFFT=1
        NNRX=NNR1
      ELSE
        LEAD  = KR1S*NGRM
        LEADX = KRX*KR2S*KR3S
        IFFT=2
        NNRX=KRX*KR2S*KR3S
      ENDIF
#else
      LEAD  = NNR1
      LEADX = NNR1
      NNRX=NNR1
      IFFT=1
#endif
C     Initialize
      CALL AZZERO(DLDOS,NLAYER*NSTATE*NKPNT)
C     Accumulate the charge 
      CALL INQ_SWAP(KBEG,KEND,KINC)
      DO IKPT=KBEG,KEND,KINC
        NKPOINT=NKPBL(IKPT)
        IF(TKBLOCK) CALL RKPT_SWAP(C0,NSTATE,IKPT,'HGKP HGKM C0')
        DO IKIND = 1, NKPOINT
          IKK=KPBEG(IKPT)+IKIND
C         Loop over the electronic states
          DO ID=1,NSTATE,NOGRP
            NSTA=MIN((NSTATE-ID+1),NOGRP)
            TFCAL=.TRUE.
            DO I=ID,ID+(NSTA-1)
              TFCAL=TFCAL.AND.(F(I,IKK).NE.0.D0)
            ENDDO
            IF(TFCAL) THEN
              CALL ZAZZERO(PSI,MAXFFT*NOGRP)
              DO IB=1,NSTA
                IS1=ID+(IB-1)
                IBB=(IB-1)*LEAD
!CDIR NODEP
                DO IG=1,NGW
                  PSI(NZHS(IG)+IBB)=C0(IG,IS1,IKIND)
                  IF(TKPNT) THEN
                   PSI(INDZS(IG)+IBB)=C0(IG+NGW,IS1,IKIND)
                  ELSE
                   PSI(INDZS(IG)+IBB)=DCONJG(C0(IG,IS1,IKIND))
                  ENDIF
                ENDDO
                IF(GEQ0) PSI(NZHS(1)+IBB)=C0(1,IS1,IKIND)
              ENDDO
C             Fourier transform the wave functions to real space.
              IF(IFFT.EQ.1) THEN
                CALL S_INVFFT(PSI)
              ELSE
                CALL SG_INVFFT(PSI)
              ENDIF
C             Compute the charge density from the wave functions
C             in real space 
              IF(NOGRP.GT.1) THEN
                DO IB=1,NSTA
                  IF(NOLIST(IB).EQ.ME) THEN
                    IS1=ID+(IB-1)    
                  ENDIF
                ENDDO
              ELSE
                IS1=ID
              ENDIF
              COEF3=WK(IKK)*F(IS1,IKK)/DBLE(NR1S*NR2S*NR3S)
                IF(LDOSN.EQ.3) THEN
                  L=0
                  DO  I3=1,KR3S
                   DO I2=1,KR2S
                    DO I1=1,KR1
                       L=L+1
                       II=INT(I3*(NLAYER+1)/KR3S)
                       IF(II.LE.NLAYER) THEN
                         R1=DREAL(PSI(L))
                         R2=DIMAG(PSI(L))
                         DLDOS(II,IS1,IKK)= DLDOS(II,IS1,IKK)+
     &                                     COEF3*(R1*R1+R2*R2)
                       ENDIF
                    ENDDO 
                   ENDDO 
                  ENDDO 
                ELSEIF(LDOSN.EQ.2) THEN
                  L=0
                  DO  I3=1,KR3S
                   DO I2=1,KR2S
                    DO I1=1,KR1
                       L=L+1
                       II=INT(I2*(NLAYER+1)/KR2S)
                       IF(II.LE.NLAYER) THEN
                         R1=DREAL(PSI(L))
                         R2=DIMAG(PSI(L))
                         DLDOS(II,IS1,IKK)= DLDOS(II,IS1,IKK)+
     &                                     COEF3*(R1*R1+R2*R2)
                       ENDIF
                    ENDDO 
                   ENDDO 
                  ENDDO 
                ELSEIF(LDOSN.EQ.1) THEN
                  L=0
                  DO  I3=1,KR3S
                   DO I2=1,KR2S
                    DO I1=1,KR1
                       IA=NRXPL(ME,1)
                       IB=NRXPL(ME,2)
                       IC=IB-IA
                       L=L+1
                       II=INT((IA+I1-1)*(NLAYER+1)/KR1S)
                       IF(II.LE.NLAYER.AND.IC.GE.0) THEN
                         R1=DREAL(PSI(L))
                         R2=DIMAG(PSI(L))
                         DLDOS(II,IS1,IKK)= DLDOS(II,IS1,IKK)+
     &                                     COEF3*(R1*R1+R2*R2)
                       ENDIF
                    ENDDO 
                   ENDDO 
                  ENDDO 
                ENDIF
            ENDIF               !Endif for TFCAL
          ENDDO                 !End loop over electronic states
        ENDDO                   !End loop over k points (IKIND)
      ENDDO                     !End loop over IKPT
#ifdef  PARALLEL
      CALL GLOSUM(NLAYER*NSTATE*NKPNT,DLDOS)
#endif
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
      FILELDOS='LDOS'
      IULDOS=35 
      CALL FILEOPEN(IULDOS,FILELDOS,FO_APP+FO_VERB+FO_MARK,FERROR)
      WRITE(IULDOS,*) NLAYER,NSTATE,NKPNT 
      WRITE(IULDOS,'(A13,1X,F10.5)') 'FERMI ENERGY:',AMU*2.D0*RY 
      DO IK=1,NKPNT
        DO I=1,NSTATE 
          WRITE(IULDOS,'(I4,I4,1X,2F10.4,1X,F10.5)')   
     &         IK,I,WE(I,IK)*2.D0*RY,F(I,IK),WK(IK)
          WRITE(IULDOS,'(8E10.4)') (DLDOS(II,I,IK),II=1,NLAYER)
        ENDDO
      ENDDO
      DO I=1,NLAYER
      WRITE(57,*)  I,(DLDOS(I,II,1),II=1,NSTATE)
      ENDDO
      CALL FILECLOSE(IULDOS)
      ENDIF
C     ==--------------------------------------------------------------==
C     SYMMETRIZE DENSITY IF POINT GROUP SPECIFIED 
C     (NEED FOR SPECIAL K-POINTS.
Cdeb  IF(TLSD) THEN
Cdeb    CALL SYMRHO(RHOE(1,1),PSI)
Cdeb    CALL SYMRHO(RHOE(1,2),PSI)
Cdeb  ELSE
Cdeb    CALL SYMRHO(RHOE(1,1),PSI)
Cdeb  ENDIF
      CALL TIHALT('      LDOS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_LDOS(XXLDOS,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !PARENT NNR1
C     Arguments
      INTEGER   XXLDOS 
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      XXLDOS=1
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
