C     ==================================================================
      SUBROUTINE DMATMUL(TA,TB,AMAT,BMAT,CMAT,RMAT,LDR,NSTATE,NPROC,
     *                   MEPOS,NDD1,NDD2,GRP)
C     ==--------------------------------------------------------------==
C     ==  Calculate matrix multiplication for distributed matrices    ==
C     ==  Op(A) Op(B) = C                                             ==
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*1 TA,TB
      INTEGER GRP
      DIMENSION AMAT(NSTATE,*),BMAT(NSTATE,*),CMAT(NSTATE,*),RMAT(*),
     *          NDD1(0:*),NDD2(0:*)
C     ==--------------------------------------------------------------==
      NORB=NDD2(MEPOS)-NDD1(MEPOS)+1
      NORBX=0
      DO IP=0,NPROC-1
        N=NDD2(IP)-NDD1(IP)+1
        NORBX=MAX(NORBX,N)
      ENDDO
      IF(LDR.LT.NSTATE*NORBX) CALL STOPGM('DMATMUL','LDR TOO SMALL')
C     ==--------------------------------------------------------------==
      MSGLEN=NSTATE*NORBX * 8
      CALL AZZERO(CMAT,NSTATE*NORBX)
      IF(TA.EQ.'T'.or.TA.EQ.'t') THEN
        IF(TB.EQ.'T'.or.TB.EQ.'t') THEN
C..A(T)*B(T)
          CALL STOPGM('DMATMUL','NOT IMPLEMENTED')
        ELSE
C..A(T)*B
          DO IP=0,NPROC-1
            CALL MY_SHIFT(AMAT,RMAT,MSGLEN,MEPOS,-IP,GRP)
            IPP=MOD(MEPOS+IP,NPROC)
            N=NDD2(IPP)-NDD1(IPP)+1
            I1=NDD1(IPP)
            CALL DGEMM('T','N',N,NORB,NSTATE,1.D0,RMAT,NSTATE,
     *                 BMAT,NSTATE,1.D0,CMAT(I1,1),NSTATE)
          ENDDO
        ENDIF
      ELSE
        IF(TB.EQ.'T'.or.TB.EQ.'t') THEN
C..A*B(T)
          IF(LDR.LT.2*NSTATE*NORBX) 
     *        CALL STOPGM('DMATMUL','LDR TOO SMALL')
          IR2=NSTATE*NORBX+1
          DO IP=0,NPROC-1
            IPP=MOD(MEPOS+IP,NPROC)
            N=NDD2(IPP)-NDD1(IPP)+1
            I1=NDD1(IPP)
            CALL DGEMM('N','T',NSTATE,N,NORB,1.D0,AMAT,NSTATE,
     *                 BMAT(I1,1),NSTATE,0.D0,RMAT(IR2),NSTATE)
            CALL MY_SHIFT(RMAT(IR2),RMAT,MSGLEN,MEPOS,IP,GRP)
            CALL DAXPY(NSTATE*NORB,1.D0,RMAT,1,CMAT,1)
          ENDDO
        ELSE
C..A*B
          DO IP=0,NPROC-1
            CALL MY_SHIFT(AMAT,RMAT,MSGLEN,MEPOS,-IP,GRP)
            IPP=MOD(MEPOS+IP,NPROC)
            N=NDD2(IPP)-NDD1(IPP)+1
            I1=NDD1(IPP)
            CALL DGEMM('N','N',NSTATE,NORB,N,1.D0,RMAT,NSTATE,
     *                 BMAT(I1,1),NSTATE,1.D0,CMAT,NSTATE)
          ENDDO
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#ifdef _BGL 
C     ==================================================================
      SUBROUTINE TRANS_DA(TMAT,AMAT,BMAT,N,NDD1,NDD2,NX,MY,NPR,GRP)
      IMPLICIT REAL*8 (A-H,O-Z)
      include 'system.h'
      INTEGER GRP,MY,NPR
      DIMENSION TMAT(N,*),AMAT(NX,NX),BMAT(NX,NX),
     *          NDD1(0:*),NDD2(0:*)
C     ==--------------------------------------------------------------==
      CALL AZZERO(AMAT,NX*NX)
      NL=NDD2(MY)-NDD1(MY)+1
      LEN=8*NX*NX
      DO IP=0,NPR-1
        M=NDD2(IP)-NDD1(IP)+1
        DO I=1,NL
          DO J=0,M-1
            AMAT(J+1,I)=TMAT(NDD1(IP)+J,I)
          ENDDO
        ENDDO
        IF((NL.GT.0).OR.(M.GT.0)) THEN
          CALL MY_SENDRECV(AMAT(1,1),LEN,PGROUP(IP+1),BMAT(1,1),
     *                   LEN,PGROUP(IP+1),GRP)
        ENDIF
        M=NDD2(IP)-NDD1(IP)+1
        DO I=1,NL
          DO J=0,M-1
            TMAT(NDD1(IP)+J,I)=BMAT(I,J+1)
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#else
C     ==================================================================
      SUBROUTINE TRANS_DA(TMAT,AMAT,BMAT,N,NDD1,NDD2,NX,ME,NPROC,GRP)
      IMPLICIT NONE
      INTEGER N,NX,ME,NPROC,GRP
      REAL*8 TMAT(N,*),AMAT(NX,NX,*),BMAT(NX,NX,*)
      INTEGER  NDD1(0:*),NDD2(0:*)
      INTEGER  NL,IP,M,I,J,LEN
C     ==--------------------------------------------------------------==
      CALL AZZERO(AMAT,NX*NX*NPROC)
      NL=NDD2(ME)-NDD1(ME)+1
      DO IP=0,NPROC-1
        M=NDD2(IP)-NDD1(IP)+1
        DO I=1,NL
          DO J=0,M-1
            AMAT(J+1,I,IP+1)=TMAT(NDD1(IP)+J,I)
          ENDDO
        ENDDO
      ENDDO
      LEN=8*NX*NX
      CALL MY_TRANS(AMAT,BMAT,LEN,1)
      DO IP=0,NPROC-1
        M=NDD2(IP)-NDD1(IP)+1
        DO I=1,NL
          DO J=0,M-1
            TMAT(NDD1(IP)+J,I)=BMAT(I,J+1,IP+1)
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#endif
C     ==================================================================
      SUBROUTINE SYMM_DA(TMAT,AMAT,BMAT,N,NDD1,NDD2,NX,MY,NPR,GRP)
      IMPLICIT REAL*8 (A-H,O-Z)
      include 'system.h'
      INTEGER GRP,MY,NPR
      DIMENSION TMAT(N,*),AMAT(NX,NX),BMAT(NX,NX),
     *          NDD1(0:*),NDD2(0:*)
C     ==--------------------------------------------------------------==
      CALL AZZERO(AMAT,NX*NX)
      NL=NDD2(MY)-NDD1(MY)+1
      LEN=8*NX*NX
      DO IP=0,NPR-1
        M=NDD2(IP)-NDD1(IP)+1
        DO I=1,NL
          DO J=0,M-1
            AMAT(J+1,I)=TMAT(NDD1(IP)+J,I)
          ENDDO
        ENDDO
        IF((NL.GT.0).OR.(M.GT.0)) THEN
          CALL MY_SENDRECV(AMAT(1,1),LEN,PGROUP(IP+1),BMAT(1,1),
     *                   LEN,PGROUP(IP+1),GRP)
        ENDIF
        M=NDD2(IP)-NDD1(IP)+1
        DO I=1,NL
          DO J=0,M-1
            TMAT(NDD1(IP)+J,I)=0.5D0 *(TMAT(NDD1(IP)+J,I)+BMAT(I,J+1))
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
