C     ==================================================================
      SUBROUTINE LOADPA
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'sphe.inc'        !GCUTWMAX
      INCLUDE 'ions.inc'
      INCLUDE 'mm_dim.inc'
C     Variables
      INTEGER MGPA(KR2S,KR3S),IXRAY(KR2S,KR3S),IHRAY(KR2S,KR3S)
      POINTER (IP_MGPA,MGPA),(IP_IXRAY,IXRAY),(IP_IHRAY,IHRAY)
      REAL*8  FNL(*),DFNL(*)
      REAL*8     G2,GG2,XSTATES,XSNOW,XSAIM,XPLANES,XPNOW,XPAIM,
     &        ZPLANES,ZPNOW,ZPAIM,T,SIGN
      INTEGER ISUB,MSPACE,I,J,K,II,IP,IPP,IXRAYS,IHRAYS,NH1,NH2,NH3,IG,
     &        JMIN,JMAX,KMIN,KMAX,IR,IN1,IN2,IN3,ID1,ID2,ID3,ICPU,
     &        J1,J2,IMG,IPRO,MSGLEN,IORB,IZPL,I0,IAT,IA,IS
      LOGICAL oldstatus
C     ==--------------------------------------------------------------==
C     ==  DISTRIBUTION OF PARALLEL WORK                               ==
C     ==--------------------------------------------------------------==
      CALL TISET('    LOADPA',ISUB)
      IF(PARENT) THEN
         WRITE(6,'(/," ",16("PARA"))')
      ENDIF
      MSPACE = (KR2S*KR3S)/IRAT + 1
      CALL MEMORY(IP_IXRAY,MSPACE,'IXRAY')
      CALL MEMORY(IP_IHRAY,MSPACE,'IHRAY')
      CALL MEMORY(IP_MGPA,MSPACE,'MGPA')
      CALL MEMORY(IP_IATPE,NAT/IRAT+1,'IATPE')
      CALL MY_SYNC(ALLGRP)
C     ==--------------------------------------------------------------==
C     DISTRIBUTE ATOMS
C     ==--------------------------------------------------------------==
      XSTATES=DBLE(NAT)
      XSNOW=0.0D0
      DO I=NPROC,1,-1
        XSAIM = XSNOW + XSTATES/NPROC
        IPEPT(1,I-1)=NINT(XSNOW)+1
        IPEPT(2,I-1)=NINT(XSAIM)
        IF(NINT(XSAIM).GT.NAT) THEN
           IPEPT(2,I-1)=NAT
        ENDIF
        IF(I.EQ.1) THEN
           IPEPT(2,I-1)=NAT
        ENDIF
        XSNOW = XSAIM
      ENDDO

      call mm_dim(mm_go_mm,oldstatus)
      CALL MEMORY(IP_IATPT,(2*NAT)/IRAT+1,'IATPT')
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          IATPT(1,IAT)=IA
          IATPT(2,IAT)=IS
        ENDDO
      ENDDO
      call mm_dim(mm_revert,oldstatus)

      DO I=0,NPROC-1
        DO J=IPEPT(1,I),IPEPT(2,I)
          IATPE(J)=I
        ENDDO
      ENDDO
      NATPE=IPEPT(2,MEPOS)-IPEPT(1,MEPOS)+1
C     ==--------------------------------------------------------------==
C     DISTRIBUTE ORBITALS
C     ==--------------------------------------------------------------==
      XSTATES=DBLE(N)
      XSNOW=0.0D0
      DO I=NPROC,1,-1
        XSAIM = XSNOW + XSTATES/NPROC
        NST12(I-1,1)=NINT(XSNOW)+1
        NST12(I-1,2)=NINT(XSAIM)
        IF(NINT(XSAIM).GT.N) THEN
           NST12(I-1,2)=N
        ENDIF
        IF(I.EQ.1) THEN
           NST12(I-1,2)=N
        ENDIF
        XSNOW = XSAIM
      ENDDO
      NORBPE=NST12(MEPOS,2)-NST12(MEPOS,1)+1
C     ==--------------------------------------------------------------==
C     DISTRIBUTE REAL SPACE YZ-PLANES
C     ==--------------------------------------------------------------==
      CALL IAZZERO(NRXPL,2*(MAXCPU+1))
      XPLANES=DBLE(NR1S)
      XPNOW=0.0D0
      DO I=NPROC,1,-1
        XPAIM = XPNOW + XPLANES/NPROC
        NRXPL(I-1,1)=NINT(XPNOW)+1
        NRXPL(I-1,2)=NINT(XPAIM)
        IF(NINT(XPAIM).GT.NR1S) THEN
           NRXPL(I-1,2)=NR1S
        ENDIF
        IF(I.EQ.1) THEN
           NRXPL(I-1,2)=NR1S
        ENDIF
        XPNOW = XPAIM
      ENDDO
      CALL IAZZERO(NRZPL,2*(MAXCPU+1))
      IF(TCLUST.AND.PS_TYPE.EQ.1) THEN
C       DISTRIBUTE REAL SPACE XY-PLANES
        ZPLANES=DBLE(2*NR3S)
        ZPNOW=0.0D0
        DO I=NPROC,1,-1
          ZPAIM = ZPNOW + ZPLANES/NPROC
          NRZPL(I-1,1)=NINT(ZPNOW)+1
          NRZPL(I-1,2)=NINT(ZPAIM)
          IF(NINT(ZPAIM).GT.2*NR3S) THEN
             NRZPL(I-1,2)=2*NR3S
          ENDIF
          IF(I.EQ.1) THEN
             NRZPL(I-1,2)=2*NR3S
          ENDIF
          ZPNOW = ZPAIM
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     DISTRIBUTE G-VECTORS
C     ==--------------------------------------------------------------==
      CALL XFFT(IXRAY,GCUTWMAX)
      CALL XFFT(IHRAY,GCUT)
      IXRAYS = 0
      DO J=1,KR3S
        DO I=1,KR2S
          IF(IXRAY(I,J).NE.0) THEN
             IXRAYS=IXRAYS+1
          ENDIF
        ENDDO
      ENDDO
      IPP=0
      DO II=1,IXRAYS
        IPP=IPP+1
        IP=MOD(IPP,2*NPROC)
        IF(IP.EQ.0) THEN
           IP=2*NPROC
        ENDIF
        IF(IP.GT.NPROC) THEN
           IP=2*NPROC+1-IP
        ENDIF
        CALL IRAYMAX(KR2S,KR3S,IXRAY,I,J)
        IXRAY(I,J)=-IP
      ENDDO
C     ==--------------------------------------------------------------==
C     MARK ASSOCIATED RAYS   
C     ==--------------------------------------------------------------==
      CALL CXFFT(IXRAY,GCUTWMAX)
      IHRAYS=0
      DO J=1,KR3S
        DO I=1,KR2S
          IF(IXRAY(I,J).NE.0) THEN
             IHRAY(I,J)=IXRAY(I,J)
          ENDIF
          IF(IHRAY(I,J).GT.0) THEN
             IHRAYS=IHRAYS+1
          ENDIF
        ENDDO
      ENDDO
      DO II=1,IHRAYS
        IPP=IPP+1
        IP=MOD(IPP,2*NPROC)
        IF(IP.EQ.0) THEN
           IP=2*NPROC
        ENDIF
        IF(IP.GT.NPROC) THEN
           IP=2*NPROC+1-IP
        ENDIF
        CALL IRAYMAX(KR2S,KR3S,IHRAY,I,J)
        IHRAY(I,J)=-IP
      ENDDO
C     MARK ASSOCIATED RAYS   
      CALL CXFFT(IHRAY,GCUT)
C     ==--------------------------------------------------------------==
C     ALLOCATE THE GLOBAL DATA ARRAYS
C     ==--------------------------------------------------------------==
      NHG=INT(DBLE(NHGS)/DBLE(NPROC)*1.2d0)
      NHG=MIN(NHG,NHGS)
      NHG=MAX(NHG,100)
      NGW=INT(DBLE(NGWS)/DBLE(NPROC)*1.2d0)
      NGW=MIN(NGW,NGWS)
      NGW=MAX(NGW,100)
      CALL MEMORY(IP_HG,NHG,'HG')
      CALL MEMORY(IP_INYH,(3*NHG)/IRAT+1,'INYH')
      CALL MEMORY(IP_MAPGP,NHG/IRAT+1,'MAPGP')
      CALL AZZERO(HG,NHG)
      CALL IAZZERO(INYH,3*NHG)
      CALL IAZZERO(MAPGP,NHG)
C     ==--------------------------------------------------------------==
C     SYSTEM PARAMETER PER CPU
C     ==--------------------------------------------------------------==
      NH1=NR1/2+1
      NH2=NR2/2+1
      NH3=NR3/2+1
C     ==--------------------------------------------------------------==
C     TO GET UNIQUE ORDERING OF G-VECTORS, BREAK THE SYMMETRY
C     ==--------------------------------------------------------------==
C      EPSG=EPSGX * ACOS(-1.D0) *DBLE(NHGS)
C      EPSG=GCUT*EPSGX
      EPSG=DSQRT(DBLE(NHGS-1))*GCUT*EPSGX
      IG=0
      NGW=0
      NHG=0
      DO I=0,NR1-1
        JMIN=-NR2+1
        JMAX=NR2-1
        IF(I.EQ.0) THEN
           JMIN=0
        ENDIF
        DO J=JMIN,JMAX
          KMIN=-NR3+1
          KMAX=NR3-1
          IF(I.EQ.0.AND.J.EQ.0) THEN
             KMIN=0
          ENDIF
          DO K=KMIN,KMAX
            G2=0.D0
            DO IR=1,3
              T=DBLE(I)*B1(IR)+DBLE(J)*B2(IR)+DBLE(K)*B3(IR)
              G2=G2+T*T
            ENDDO
            IF(G2.LT.GCUT) THEN
              IG=IG+1
              IN1=NH1+I
              IN2=NH2+J
              IN3=NH3+K
              IF(G2.LT.GCUTWMAX) THEN
                ICPU=IXRAY(IN2,IN3)
                IF(-ICPU.EQ.MEPOS+1) THEN
                  NGW=NGW+1
                ENDIF
                SIGN=-1.D0
              ELSE
                SIGN=1.D0
              ENDIF
              ICPU=IHRAY(IN2,IN3)
              IF(-ICPU.EQ.MEPOS+1) THEN
                NHG=NHG+1
C               HG(NHG)=G2+DSQRT(DBLE(IG-1))*EPSG*SIGN
C               G2*EPSGX*SIGN is the epsilon added (>= epsilon(G2))
C               SQRT(FLOAT(IG-1)) is to break the symmetry
                HG(NHG)=G2*(1.D0+DSQRT(DBLE(IG-1))*EPSGX*SIGN)
                INYH(1,NHG)=IN1
                INYH(2,NHG)=IN2
                INYH(3,NHG)=IN3
              ENDIF         
            ENDIF           
          ENDDO
        ENDDO
      ENDDO
      NHRAYS=0
      NGRAYS=0
      CALL IAZZERO(MGPA,KR2S*KR3S)
      DO J1=1,KR3S
        DO J2=1,KR2S
          IF(IXRAY(J2,J1).EQ.-(MEPOS+1)) THEN
             NGRAYS=NGRAYS+1
          ENDIF
          IF(IHRAY(J2,J1).EQ.-(MEPOS+1)) THEN
             NHRAYS=NHRAYS+1
          ENDIF
          IF(IXRAY(J2,J1).EQ.-(MEPOS+1)) THEN
             MGPA(J2,J1)=NGRAYS 
          ENDIF
        ENDDO
      ENDDO
      IMG=NGRAYS
      DO J1=1,KR3S
        DO J2=1,KR2S
          IF(IHRAY(J2,J1).EQ.-(MEPOS+1).AND.MGPA(J2,J1).EQ.0) THEN
            IMG=IMG+1
            MGPA(J2,J1)=IMG
          ENDIF
        ENDDO
      ENDDO
      NHGL=NHGLS
      NGWL=NGWLS
      NR1 =NRXPL(MEPOS,2)-NRXPL(MEPOS,1)+1
      NR2 =NR2S
      NR3 =NR3S
      SPARM(1,MEPOS)=NHG
      SPARM(2,MEPOS)=NHGL
C     ==--------------------------------------------------------------==
C     IF K POINTS, WE NEED TO DOUBLE DIMENSIONS.
C     ==--------------------------------------------------------------==
      IF(TKPNT) THEN
        NGWK=NGW*2
        NHGK=NHG*2
      ELSE
        NGWK=NGW
        NHGK=NHG
      ENDIF
      SPARM(3,MEPOS)=NGW
      SPARM(4,MEPOS)=NGWL
      SPARM(5,MEPOS)=NR1
      SPARM(6,MEPOS)=NR2
      SPARM(7,MEPOS)=NR3
      SPARM(8,MEPOS)=NHRAYS
      SPARM(9,MEPOS)=NGRAYS
      CALL MY_SYNC(ALLGRP)
      DO I=0,NPROC-1
C       I--> REAL CPU OF I
        IPRO=I
        MSGLEN = 9 * 8/IRAT
        CALL MY_BCAST(SPARM(1,I),MSGLEN,IPRO,ALLGRP)
      ENDDO
      IF(PARENT) THEN
        WRITE(6,'(A,A)') '  NCPU     NGW',
     *       '     NHG  PLANES  GXRAYS  HXRAYS ORBITALS Z-PLANES'
        DO I=0,NPROC-1
          IORB=NST12(I,2)-NST12(I,1)+1
          IZPL=NRZPL(I,2)-NRZPL(I,1)+1
          WRITE(6,'(I6,7I8)') I,SPARM(3,I),SPARM(1,I),SPARM(5,I),
     *      SPARM(9,I),SPARM(8,I),IORB,IZPL
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     DEALLOCATE DATA ARRAYS
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_MGPA)
      CALL FREEM(IP_IXRAY)
      CALL FREEM(IP_IHRAY)
C     ==--------------------------------------------------------------==
C     SORTING OF G-VECTORS
C     ==--------------------------------------------------------------==
      CALL GSORT(HG,INYH,NHG)
      DO IG=1,NHG
        MAPGP(IG)=IG
      ENDDO
      CALL GORDER
C     ==--------------------------------------------------------------==
      GEQ0=.FALSE.
      I0=0
      DO IG=1,NGW
        IF(HG(IG).LT.1.D-5) THEN
          GEQ0=.TRUE.
          I0=MEPOS
        ENDIF
      ENDDO
      MSGLEN = 1 * 8/IRAT
      CALL MY_COMBINE(I0,IGEQ0,MSGLEN,2,ALLGRP)
      IF(PARENT) THEN
        WRITE(6,'(13X,A,I5)') '   G=0 COMPONENT ON PROCESSOR : ',IGEQ0
        WRITE(6,'(" ",16("PARA"),/)')
        CALL PRMEM('    LOADPA')
      ENDIF
C     ==--------------------------------------------------------------==
C     LEADING DIMENSIONS OF REAL SPACE ARRAYS
C     ==--------------------------------------------------------------==
      CALL LEADIM(NR1,NR2,NR3,KR1,KR2,KR3)
      NNR1=KR1*KR2S*KR3S
      CALL TIHALT('    LOADPA',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE IRAYMAX(N1,N2,IR,I1,I2)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N1,N2,IR(N1,N2)   !Input
      INTEGER I1,I2             !Output
C     Local variables
      INTEGER IM,J1,J2
C     ==--------------------------------------------------------------==
      IM=-2**30
      I1=0
      I2=0
      DO J2=1,N2
        DO J1=1,N1
          IF(IR(J1,J2).GE.IM) THEN
            IM=IR(J1,J2)
            I1=J1
            I2=J2
          ENDIF
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION IXYPR(NFULL,KR1,KR2,KR3)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NFULL,KR1,KR2,KR3
      INTEGER IXYPR
C     Local variables
      INTEGER I3,N2,I2
C     ==--------------------------------------------------------------==
      I3=NFULL/(KR1*KR2) + 1
      N2=NFULL - (I3-1)*KR1*KR2
      I2=N2/KR1 + 1
      IXYPR = (I3 - 1)*KR2 + I2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LEADIM(NR1,NR2,NR3,KR1,KR2,KR3)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER NR1,NR2,NR3,KR1,KR2,KR3
C     ==--------------------------------------------------------------==
      KR1=NR1+MOD(NR1+1,2)
      KR2=NR2+MOD(NR2+1,2)
      KR3=NR3+MOD(NR3+1,2)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE XFFT(IRAY,GVCUT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'gvec.inc'
C     Arguments
      INTEGER IRAY(KR2,*)
      REAL*8  GVCUT
C     Local variables
      INTEGER NH1,NH2,NH3,I,J,K,JMIN,JMAX,KMIN,KMAX,IR,IN1,IN2,IN3,
     &     ID1,ID2,ID3,IX1,IX2
      REAL*8  G2,T
C     ==--------------------------------------------------------------==
      CALL IAZZERO(IRAY,KR2*KR3)
      NH1=NR1/2+1
      NH2=NR2/2+1
      NH3=NR3/2+1
      DO I=0,NR1-1
        JMIN=-NR2+1
        JMAX=NR2-1
        IF(I.EQ.0) THEN
           JMIN=0
        ENDIF
        DO J=JMIN,JMAX
          KMIN=-NR3+1
          KMAX=NR3-1
          IF(I.EQ.0.AND.J.EQ.0) THEN
             KMIN=0
          ENDIF
          DO K=KMIN,KMAX
            G2=0.D0
            DO IR=1,3
              T=DBLE(I)*B1(IR)+DBLE(J)*B2(IR)+DBLE(K)*B3(IR)
              G2=G2+T*T
            ENDDO
            IF(G2.LT.GVCUT) THEN
              IN1=NH1+I
              IN2=NH2+J
              IN3=NH3+K
              ID1=2*NH1-IN1
              ID2=2*NH2-IN2
              ID3=2*NH3-IN3
              IX1=IRAY(IN2,IN3)
              IX2=IRAY(ID2,ID3)
              IF(IX1.GT.0) THEN
                IRAY(IN2,IN3)=IX1+1
                IF(IX2.GT.0) THEN
                  IF((IN2.NE.ID2).OR.(IN3.NE.ID3)) THEN
                    WRITE(6,*) ' INCONSISTENT MESH?'
                    CALL STOPGM('XFFT',' ')
                  ENDIF
                ENDIF
              ELSEIF(IX2.GT.0) THEN
                IRAY(ID2,ID3)=IX2+1
              ELSE
                IRAY(IN2,IN3)=1
              ENDIF
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CXFFT(IRAY,GVCUT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'gvec.inc'
C     Arguments
      INTEGER IRAY(KR2,*)
      REAL*8  GVCUT
C     Local variables
      INTEGER NH1,NH2,NH3,I,J,K,JMIN,JMAX,KMIN,KMAX,IR,IN1,IN2,IN3,
     &        ID1,ID2,ID3,ICPU1,ICPU2
      REAL*8  G2,T
C     ==--------------------------------------------------------------==
      NH1=NR1/2+1
      NH2=NR2/2+1
      NH3=NR3/2+1
      DO I=0,NR1-1
        JMIN=-NR2+1
        JMAX=NR2-1
        IF(I.EQ.0) THEN
           JMIN=0
        ENDIF
        DO J=JMIN,JMAX
          KMIN=-NR3+1
          KMAX=NR3-1
          IF(I.EQ.0.AND.J.EQ.0) THEN
             KMIN=0
          ENDIF
          DO K=KMIN,KMAX
            G2=0.D0
            DO IR=1,3
              T=DBLE(I)*B1(IR)+DBLE(J)*B2(IR)+DBLE(K)*B3(IR)
              G2=G2+T*T
            ENDDO
            IF(G2.LT.GVCUT) THEN
              IN1=NH1+I
              IN2=NH2+J
              IN3=NH3+K
              ID1=2*NH1-IN1
              ID2=2*NH2-IN2
              ID3=2*NH3-IN3
              ICPU1=IRAY(IN2,IN3)
              ICPU2=IRAY(ID2,ID3)
              IF(ICPU2.EQ.0) THEN
                IRAY(ID2,ID3)=ICPU1
              ELSEIF(ICPU1.EQ.0) THEN
                IRAY(IN2,IN3)=ICPU2
              ELSEIF(ICPU1.NE.ICPU2) THEN
                WRITE(6,*) ' INCONSISTENT XRAY FIELDS',ICPU1,ICPU2
                CALL STOPGM('CXFFT',' ')
              ENDIF
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GORDER
C     ==--------------------------------------------------------------==
C     == CHECK THE G ORDERING USING MAPGP(1:NHG)                      ==
C     == FOR A MONO-PROCESSOR, SUM_I^NHG = 1/2 * NHGS * (NHGS+1)      ==
C     == IN PARALLEL VERSION, WE DO THE SAME THINGS:                  ==
C     == FOR THE IP PROC, MAPGP(IG) = IG                              ==
C     == FOR EACH JP /= IP, WE ARE LOOKING FOR THE INDEX J:           ==
C     ==     HG_(in JP)(J) <= HG_(in IP)(IG) < HG_(in JP)(J)          ==
C     ==     and MAPGP(IG) = MAPGP(IG) + J                            ==
C     == IF WE SUM ALL MAPGP WE SHOULD HAVE 1/2 * NHGS* (NHGS+1)      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'irat.inc'
C     Local variables
      REAL*8  HX(*)
      POINTER (IP_HX,HX)
      REAL*8  HO(*)
      POINTER (IP_HO,HO)
      INTEGER NHGMAX,IP,MSG1,IPP,NHO,L,I,MHO,J,ISUB
      REAL*8  XM,XT
C     ==--------------------------------------------------------------==
      CALL TISET('    GORDER',ISUB)
      NHGMAX=0
      DO IP=0,NPROC-1
        NHGMAX=MAX(NHGMAX,SPARM(1,IP))
      ENDDO
      CALL MEMORY(IP_HO,NHGMAX,'HO')
      CALL MEMORY(IP_HX,NHGMAX,'HX')
      CALL AZZERO(HO,NHGMAX)
      CALL AZZERO(HX,NHGMAX)
      CALL DCOPY(NHG,HG,1,HX,1)
      MSG1 = NHGMAX * 8
      CALL MY_SYNC(ALLGRP)
      DO IP=1,NPROC-1
        IPP=MOD(MEPOS+IP,NPROC)
        CALL MY_SHIFT(HX,HO,MSG1,MEPOS,-IP,ALLGRP)
        NHO=SPARM(1,IPP)
        L=1
        DO I=1,NHG
          IF(HG(I).LT.HO(1)) THEN
            MHO=0
          ELSE
            DO J=L,NHO-1
              IF(HG(I).GE.HO(J).AND.HG(I).LT.HO(J+1)) THEN
                L=J
                MHO=J
                GOTO 100
              ENDIF
            ENDDO
            L=NHO
            MHO=NHO
  100       CONTINUE
          ENDIF
          MAPGP(I)=MAPGP(I)+MHO
        ENDDO
      ENDDO
C..check ordering
      XM=0.D0
      DO I=1,NGW
        XM=XM+MAPGP(I)
      ENDDO
      CALL GLOSUM(1,XM)
      XT=DBLE(NGWS)
      XT=0.5D0*XT*(XT+1.D0)-XM
c     IF(ABS(XT).GT.0.1D0.AND.PARENT) THEN
c       WRITE(6,*) ' GORDER| PROGRAMING ERROR. INFORM THE PROGRAMMER'
c       CALL STOPGM('GORDER','ERROR IN G-VEC ORDERING (NGW)')
c     ENDIF
      XM=0.D0
      DO I=1,NHG
        XM=XM+MAPGP(I)
      ENDDO
      CALL GLOSUM(1,XM)
      XT=DBLE(NHGS)
      XT=0.5D0*XT*(XT+1.D0)-XM
c     IF(ABS(XT).GT.0.1D0.AND.PARENT) THEN
c       WRITE(6,*) ' GORDER| PROGRAMING ERROR. INFORM THE PROGRAMMER'
c       CALL STOPGM('GORDER','ERROR IN G-VEC ORDERING (NHG)')
c     ENDIF
      CALL FREEM(IP_HO)
      CALL FREEM(IP_HX)
      CALL TIHALT('    GORDER',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
