C     ==================================================================
      SUBROUTINE LOADSE
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'gvec.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cell.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'sphe.inc'        !GCUTWMAX
      INCLUDE 'ions.inc'
      INCLUDE 'mm_dim.inc'
C     Variables
      INTEGER   NH1,NH2,NH3,IG,I,J,K,IR
      INTEGER   NHGY,NGWY,JMIN,JMAX,KMIN,KMAX,IA,IS,IAT
      REAL*8    G2,T,GVSIGN
      LOGICAL   oldstatus
C     ==--------------------------------------------------------------==
      NH1=NR1/2+1
      NH2=NR2/2+1
      NH3=NR3/2+1
      NRXPL(0,1)=1
      NRXPL(0,2)=NR1
C     ALLOCATE MEMORY FOR THE PERMANENT ARRAYS
      CALL MEMORY(IP_HG,NHG,'HG')
      CALL MEMORY(IP_INYH,(3*NHG)/IRAT+1,'INYH')
C     Set up the G-Vectors
      NHGY=NHG
      NGWY=NGW
C     To Get unique ordering of G-Vectors, break the symmetry
C      EPSG=EPSGX * ACOS(-1.D0) * DBLE(NHGS)
C      EPSG=GCUT*EPSGX
      EPSG=SQRT(DBLE(NHGS-1))*GCUT*EPSGX
C     Construction of g-vectors
      IG=0
      NGW=0
      NHG=0
      DO I=0,NR1-1
        JMIN=-NR2+1
        JMAX=NR2-1
        IF(I.EQ.0) THEN
           JMIN=0
        ENDIF
        DO J=JMIN,JMAX
          KMIN=-NR3+1
          KMAX=NR3-1
          IF(I.EQ.0.AND.J.EQ.0) THEN
             KMIN=0
          ENDIF
!CDIR NOVECTOR
          DO K=KMIN,KMAX
            G2=0.D0
            DO IR=1,3
              T=DBLE(I)*B1(IR)+DBLE(J)*B2(IR)+DBLE(K)*B3(IR)
              G2=G2+T*T
            ENDDO
            IF (G2.LT.GCUT) THEN
              IG=IG+1
              NHG=NHG+1
              IF (G2.LT.GCUTWMAX) THEN
                NGW=NGW+1
                GVSIGN=-1.D0
              ELSE
                GVSIGN=+1.D0
              ENDIF
C             HG(IG)=G2+SQRT(FLOAT(IG-1))*EPSG*GVSIGN
C             G2*EPSGX*GVSIGN is the epsilon added (>= epsilon(G2))
C             SQRT(FLOAT(IG-1)) is to break the symmetry
              HG(IG)=G2*(1.D0+SQRT(DBLE(IG-1))*EPSGX*GVSIGN)
              INYH(1,IG)=NH1+I
              INYH(2,IG)=NH2+J
              INYH(3,IG)=NH3+K
            ENDIF
          ENDDO
        ENDDO
      ENDDO
      IF(NHGY.NE.NHG) THEN
         CALL STOPGM('LOADSE','NHG.NE.NHGY')
      ENDIF
      IF(NGWY.NE.NGW) THEN
         CALL STOPGM('LOADSE','NGW.NE.NGWY')
      ENDIF
C     REORDER THE G S IN ORDER OF INCREASING MAGNITUDE
      CALL GSORT(HG,INYH,NHG)
      NST12(MEPOS,1)=1
      NST12(MEPOS,2)=N
C
      NORBPE=N
      NATPE=NAT
      IPEPT(1,MEPOS)=1
      IPEPT(2,MEPOS)=NAT
      CALL MEMORY(IP_IATPE,NAT/IRAT+1,'IATPE')
      DO J=1,NAT
        IATPE(J)=MEPOS
      ENDDO

      call mm_dim(mm_go_mm,oldstatus)
      CALL MEMORY(IP_IATPT,(2*NAT)/IRAT+1,'IATPT')
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          IATPT(1,IAT)=IA
          IATPT(2,IAT)=IS
        ENDDO
      ENDDO
      call mm_dim(mm_revert,oldstatus)

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
