C     ==================================================================
      SUBROUTINE LOCALIZE(TAU0,C0,C2,SC0,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     == CALCULATES LOCALIZED FUNCTIONS                               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'geq0.inc'
      include 'ions.inc'
      include 'cnst.inc'
      include 'ddip.inc'
      include 'gvec.inc'
      include 'irat.inc'
      include 'rmas.inc'
      include 'wann.inc'
      include 'spin.inc'
      include 'store.inc'
      include 'ropt.inc'
      include 'linres.inc'
C input
      REAL*8 TAU0(3,NAX,*),SCR(*)
      COMPLEX*16 C0(NGW,*),C2(*),SC0(*)
      INTEGER LSCR,NSTATE
C local
      COMPLEX*16 DD1,DD2,DD3
      INTEGER IP1,IP2,I,ISUB,LSCR2,NMCOL,N1
      INTEGER IX1,IX2,IXL,NXMAX,MSGLEN,LENGTH,IL_PSI,IL_RHOE
      CHARACTER*30 TAG
      INTEGER MAPFUL(*),MAPCOL(*)
      POINTER (IP_MAPFUL,MAPFUL),(IP_MAPCOL,MAPCOL)
      SAVE IP_MAPFUL,IP_MAPCOL
      REAl*8 RHOE(*),EIGV(*)
      COMPLEX*16 PSI(*)
      POINTER (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_EIGV,EIGV)
      real*8     FION(3,NAX,*)
      pointer    (ip_fion,fion)
C     ==--------------------------------------------------------------==
C..Wannier functions
      COMPLEX*16 XYZMAT(NSTATE,NSTATE,*)
      REAL*8     ROTMAT(NSTATE,NSTATE),ROTLSD(*)
      POINTER (IP_XYZMAT,XYZMAT),(IP_ROTMAT,ROTMAT),(IP_ROTLSD,ROTLSD)
      SAVE IP_XYZMAT,IP_ROTMAT,IP_ROTLSD
C     ==--------------------------------------------------------------==
      CALL TISET('  LOCALIZE',ISUB)
      CALL GIVE_SCR_DDIPO(LENGTH,TAG)
      CALL TEST_SCR('DDIPO','LENGTH',LSCR,LENGTH)
      IF(PARENT) THEN
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(1X,A)') 'LOCALIZATION OF WAVEFUNCTION '
        IF(W_TYPE.EQ.1)
     *        WRITE(6,'(A)')   '         FUNCTIONAL: VANDERBILT |M|^2'
        IF(W_TYPE.EQ.2)
     *        WRITE(6,'(A)')   '         FUNCTIONAL: RESTA Log|M|^2'
        IF(W_OPT.EQ.1)
     *        WRITE(6,'(A)') '         OPTIMISATION: STEEPEST DESCENT'
        IF(W_OPT.EQ.2)
     *        WRITE(6,'(A)') '         OPTIMISATION: JACOBI ROTATION'
        WRITE(6,'(A,T56,1PE10.4)')
     *            '         CONVERGENCE CRITERIA:',W_EPS
        WRITE(6,'(A,T56,I10)')
     *            '         MAXIMUM # OF STEPS:',W_MAXS
        WRITE(6,'(A,T56,1PE10.4)')
     *            '         RANDOMIZATION AMPLITUDE:',W_RAN
        WRITE(6,'(A,T56,1PE10.4)')
     *            '         STEP SIZE:',W_STEP
      ENDIF
C..initialization
      N1=0
      DO I=0,NPROC-1
        N1=MAX(N1,SPARM(3,I))
      ENDDO
      NGWMAX=N1
      CALL MEMORY(IP_MAPFUL,2*(NGWS/IRAT+1),'MAPFUL')
#ifdef PARALLEL
      NMCOL=(NPROC*NGWMAX)/IRAT+1
#else
      NMCOL=1
#endif
      CALL MEMORY(IP_MAPCOL,NMCOL,'MAPCOL')
      CALL SETDIP(MAPFUL,MAPCOL,SCR,LSCR)
C..initialization for Wannier function part
      CALL SET_OPERATOR(.TRUE.)
      CALL MEMORY(IP_XYZMAT,2*NSTATE*NSTATE*NWANOPT,'XYZMAT')
      CALL ZAZZERO(XYZMAT,NSTATE*NSTATE*NWANOPT)
      CALL MEMORY(IP_ROTMAT,NSTATE*NSTATE,'ROTMAT')
      IF(TLSD) THEN
        NXMAX=MAX(NSUP,NSDOWN)
        CALL MEMORY(IP_ROTLSD,NXMAX*NXMAX,'ROTLSD')
      ENDIF
C..electronic contribution
      IP1=1
      IP2=1+2*NSTATE*NSTATE
      LSCR2=LSCR-IP2
      IF(LSCR2.LT.1) CALL STOPGM('LOCALIZE','NOT ENOUGH SCRATCH SPACE')
      CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,1,0,DD1)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,1),1)
      CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,2,0,DD2)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,2),1)
      CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,3,0,DD3)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,3),1)
      DO I=4,NWANOPT
        CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,IOW(1,I-3),IOW(2,I-3),DD1)
        CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,I),1)
      ENDDO

C  Calculation of the spread BEFORE the actual localization
      IF (PARENT) THEN
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(" ****",6X,A,6X,"****",/)') 
     &        'CENTERS AND SPREAD BEFORE THE OPTIMIZATION'
      ENDIF
      CALL WANNIER_CENTER(XYZMAT,NSTATE,NSTATE,SCR,TAU0)
      IF (PARENT) CALL WC_PRINT(NSTATE,SCR)

C     Wannier function calculation
C     Optimisers
      IF(W_OPT.EQ.1) THEN
        IF(PARENT) THEN
C         steepest descent
          IF(TLSD) THEN
            CALL AZZERO(ROTMAT,NSTATE*NSTATE)
            NXMAX=MAX(NSUP,NSDOWN)
            IX1=1
            IX2=IX1+NXMAX*NXMAX
            IXL=IX2+NXMAX*NXMAX
            LSCR2=LSCR-IXL
            CALL SD_WANNIER(ROTLSD,XYZMAT(1,1,1),NSTATE,NSUP,
     *                      SCR(IX1),SCR(IX2),SCR(IXL),LSCR2)
            CALL RMATMOV(NSUP,NSUP,ROTLSD,NSUP,ROTMAT,NSTATE)
            CALL SD_WANNIER(ROTLSD,XYZMAT(NSUP+1,NSUP+1,1),
     *                      NSTATE,NSDOWN,
     *                      SCR(IX1),SCR(IX2),SCR(IXL),LSCR2)
            CALL RMATMOV(NSDOWN,NSDOWN,ROTLSD,NSDOWN,
     *                   ROTMAT(NSUP+1,NSUP+1),NSTATE)
          ELSE
            IX1=1
            IX2=IX1+NSTATE*NSTATE
            IXL=IX2+NSTATE*NSTATE
            LSCR2=LSCR-IXL
            CALL SD_WANNIER(ROTMAT,XYZMAT,NSTATE,NSTATE,
     *                      SCR(IX1),SCR(IX2),SCR(IXL),LSCR2)
          ENDIF
        ENDIF
        MSGLEN=NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
      ELSEIF(W_OPT.EQ.2) THEN
C       Jacobi rotations
        IF(TLSD) THEN
          CALL AZZERO(ROTMAT,NSTATE*NSTATE)
          NXMAX=MAX(NSUP,NSDOWN)
          CALL JROTATION(ROTLSD,XYZMAT(1,1,1),NSTATE,NSUP,SCR,LSCR)
          CALL RMATMOV(NSUP,NSUP,ROTLSD,NSUP,ROTMAT,NSTATE)
          CALL JROTATION(ROTLSD,XYZMAT(NSUP+1,NSUP+1,1),
     *                      NSTATE,NSDOWN,SCR,LSCR)
          CALL RMATMOV(NSDOWN,NSDOWN,ROTLSD,NSDOWN,
     *                 ROTMAT(NSUP+1,NSUP+1),NSTATE)
        ELSE
          CALL JROTATION(ROTMAT,XYZMAT,NSTATE,NSTATE,SCR,LSCR)
        ENDIF
      ELSE
        CALL STOPGM('LOCALIZE','not implemented')
      ENDIF
C     rotate the wavefunctions to the Wannier representation
      CALL ROTATE(1.D0,C0,0.D0,C2,ROTMAT,NSTATE,
     *              2*NGW,TLSD,NSUP,NSDOWN)
      CALL DCOPY(2*NGW*NSTATE,C2,1,C0,1)
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      call memory(ip_fion,3*nax*nsx,'fion')
      call azzero(fion,3*nax*nsx)
      IF (TWMOL.OR.TWDOS) THEN
         IF(NONORT)
     x        CALL MEMORY(IP_EIGV,NSTATE,'EIGV')
         CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *        NSTATE,1,.FALSE.,.TRUE.)
      ENDIF
C     calculate the centers and spread of the wannier functions
      CALL WANNIER_CENTER(XYZMAT,NSTATE,NSTATE,SCR,TAU0)
      IF(PARENT) CALL WC_PRINT(NSTATE,SCR)
      IF (TRESPONSE) CALL WANNIER_SAVE(NSTATE,SCR)
      IF (TDDFT.OR.TSPEC) THEN
        IF(TREORDER.OR.MOLSTAT) THEN
          CALL DCOPY(NSTATE,SCR(1),4,WCENT(1,1),3)
          CALL DCOPY(NSTATE,SCR(2),4,WCENT(2,1),3)
          CALL DCOPY(NSTATE,SCR(3),4,WCENT(3,1),3)
        ENDIF
      ENDIF
      IF (TWMOL) THEN
         CALL molorb(c0,c2,tau0,scr,lscr,nstate)
         CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *        NSTATE,1,.FALSE.,.TRUE.)
      ENDIF
      IF (TWDOS) CALL WC_DOS(C0,C2,SCR,LSCR,NSTATE)

C     print selected Wannier functions
      CALL WANNIER_PRINT(1,C0,TAU0,NSTATE,PSI,SCR,LSCR)

      CALL FREEM(IP_PSI)
      CALL FREEM(IP_MAPFUL)
      CALL FREEM(IP_MAPCOL)
      CALL FREEM(IP_XYZMAT)
      CALL FREEM(IP_ROTMAT)
      IF(TLSD) CALL FREEM(IP_ROTLSD)
      CALL TIHALT('  LOCALIZE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LOCALIZE2(TAU0,C0,C2,SC0,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     == CALCULATES LOCALIZED FUNCTIONS                               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'geq0.inc'
      include 'ions.inc'
      include 'cnst.inc'
      include 'ddip.inc'
      include 'gvec.inc'
      include 'irat.inc'
      include 'rmas.inc'
      include 'wann.inc'
      include 'spin.inc'
      include 'store.inc'
      include 'ropt.inc'
      include 'linres.inc'
C input
      REAL*8 TAU0(3,NAX,*),SCR(*)
      COMPLEX*16 C0(NGW,*),C2(*),SC0(*)
      INTEGER LSCR,NSTATE
C local
      COMPLEX*16 DET,DD1,DD2,DD3,DD
      INTEGER IP1,IP2,I,J,IJ,ISUB,LSCR2,IA,IS,K,NMCOL,N1
      INTEGER IX1,IX2,IXL,NXMAX,MSGLEN,LENGTH,IL_PSI,IL_RHOE
      CHARACTER*30 TAG
      REAL*8 OMEGON,PMATON,D1,D2,D3
      REAL*8 TPI,FAC,COST
      INTEGER MAPFUL(*),MAPCOL(*)
      POINTER (IP_MAPFUL,MAPFUL),(IP_MAPCOL,MAPCOL)
      SAVE IP_MAPFUL,IP_MAPCOL
      COMPLEX*16 PSI(*)
      POINTER (IP_PSI,PSI)
C
      INTEGER IFIRST
      DATA    IFIRST /0/
      SAVE    IFIRST
C     ==--------------------------------------------------------------==
C..Wannier functions
      COMPLEX*16 XYZMAT(NSTATE,NSTATE,*)
      REAL*8     ROTMAT(NSTATE,NSTATE),ROTLSD(*)
      POINTER (IP_XYZMAT,XYZMAT),(IP_ROTMAT,ROTMAT),(IP_ROTLSD,ROTLSD)
      SAVE IP_XYZMAT,IP_ROTMAT,IP_ROTLSD
C     ==--------------------------------------------------------------==
      CALL TISET('  LOCALIZE',ISUB)
      CALL GIVE_SCR_DDIPO(LENGTH,TAG)
      CALL TEST_SCR('DDIPO','LENGTH',LSCR,LENGTH)
      IF (IFIRST.EQ.0) THEN
        IFIRST=1
C..initialization
        N1=0
        DO I=0,NPROC-1
          N1=MAX(N1,SPARM(3,I))
        ENDDO
        NGWMAX=N1
        CALL MEMORY(IP_MAPFUL,2*(NGWS/IRAT+1),'MAPFUL')
#ifdef PARALLEL
        NMCOL=(NPROC*NGWMAX)/IRAT+1
#else
        NMCOL=1
#endif
        CALL MEMORY(IP_MAPCOL,NMCOL,'MAPCOL')
        CALL SETDIP(MAPFUL,MAPCOL,SCR,LSCR)
C..initialization for Wannier function part
        CALL SET_OPERATOR(.TRUE.)
        CALL MEMORY(IP_XYZMAT,2*NSTATE*NSTATE*NWANOPT,'XYZMAT')
        CALL MEMORY(IP_ROTMAT,NSTATE*NSTATE,'ROTMAT')
        IF(TLSD) THEN
          NXMAX=MAX(NSUP,NSDOWN)
          CALL MEMORY(IP_ROTLSD,NXMAX*NXMAX,'ROTLSD')
        ENDIF
      ENDIF
      CALL ZAZZERO(XYZMAT,NSTATE*NSTATE*NWANOPT)
      IF(TLSD) THEN
        FAC=1.D0
      ELSE
        FAC=2.D0
      ENDIF
      PMATON=1.0D0/PMAT0
      OMEGON=1.0D0/OMEGA
C..electronic contribution
      IP1=1
      IP2=1+2*NSTATE*NSTATE
      LSCR2=LSCR-IP2
      IF(LSCR2.LT.1) CALL STOPGM('DDIPO','NOT ENOUGH SCRATCH SPACE')
      CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,1,0,DD1)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,1),1)
      CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,2,0,DD2)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,2),1)
      CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,3,0,DD3)
      CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,3),1)
      DO I=4,NWANOPT
        CALL OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,SCR(IP1),
     *            SCR(IP2),LSCR2,IOW(1,I-3),IOW(2,I-3),DD1)
        CALL DCOPY(2*NSTATE*NSTATE,SCR(IP1),1,XYZMAT(1,1,I),1)
      ENDDO

C     Wannier function calculation
C     Optimisers
      IF(W_OPT.EQ.1) THEN
        IF(PARENT) THEN
C         steepest descent
          IF(TLSD) THEN
            CALL AZZERO(ROTMAT,NSTATE*NSTATE)
            NXMAX=MAX(NSUP,NSDOWN)
            IX1=1
            IX2=IX1+NXMAX*NXMAX
            IXL=IX2+NXMAX*NXMAX
            LSCR2=LSCR-IXL
            CALL SD_WANNIER(ROTLSD,XYZMAT(1,1,1),NSTATE,NSUP,
     *                      SCR(IX1),SCR(IX2),SCR(IXL),LSCR2)
            CALL RMATMOV(NSUP,NSUP,ROTLSD,NSUP,ROTMAT,NSTATE)
            CALL SD_WANNIER(ROTLSD,XYZMAT(NSUP+1,NSUP+1,1),
     *                      NSTATE,NSDOWN,
     *                      SCR(IX1),SCR(IX2),SCR(IXL),LSCR2)
            CALL RMATMOV(NSDOWN,NSDOWN,ROTLSD,NSDOWN,
     *                   ROTMAT(NSUP+1,NSUP+1),NSTATE)
          ELSE
            IX1=1
            IX2=IX1+NSTATE*NSTATE
            IXL=IX2+NSTATE*NSTATE
            LSCR2=LSCR-IXL
            CALL SD_WANNIER(ROTMAT,XYZMAT,NSTATE,NSTATE,
     *                      SCR(IX1),SCR(IX2),SCR(IXL),LSCR2)
          ENDIF
        ENDIF
        MSGLEN=NSTATE*NSTATE * 8
        CALL MY_BCAST(ROTMAT,MSGLEN,SOURCE,ALLGRP)
      ELSEIF(W_OPT.EQ.2) THEN
C       Jacobi rotations
        IF(TLSD) THEN
          CALL AZZERO(ROTMAT,NSTATE*NSTATE)
          NXMAX=MAX(NSUP,NSDOWN)
          CALL JROTATION(ROTLSD,XYZMAT(1,1,1),NSTATE,NSUP,SCR,LSCR)
          CALL RMATMOV(NSUP,NSUP,ROTLSD,NSUP,ROTMAT,NSTATE)
          CALL JROTATION(ROTLSD,XYZMAT(NSUP+1,NSUP+1,1),
     *                      NSTATE,NSDOWN,SCR,LSCR)
          CALL RMATMOV(NSDOWN,NSDOWN,ROTLSD,NSDOWN,
     *                 ROTMAT(NSUP+1,NSUP+1),NSTATE)
        ELSE
          CALL JROTATION(ROTMAT,XYZMAT,NSTATE,NSTATE,SCR,LSCR)
        ENDIF
      ELSE
        CALL STOPGM('LOCALIZE','not implemented')
      ENDIF
C     rotate the wavefunctions to the Wannier representation
      CALL ROTATE(1.D0,C0,0.D0,C2,ROTMAT,NSTATE,
     *              2*NGW,TLSD,NSUP,NSDOWN)
      CALL DCOPY(2*NGW*NSTATE,C2,1,C0,1)
C     calculate the centers and spread of the wannier functions
      CALL WANNIER_CENTER(XYZMAT,NSTATE,NSTATE,SCR,TAU0)
C
      CALL TIHALT('  LOCALIZE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WC_PRINT(NSTATE,CENTER)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER NSTATE
      REAL*8 CENTER(4,NSTATE),SUM
      INTEGER I
C     ==--------------------------------------------------------------==
      WRITE(6,'(/,1X,64("*"))')
      WRITE(6,'(" *",12X,A,18X,A,1X,"*")')
     * ' WANNIER CENTERS  ','<X^2> - <X>^2'
      WRITE(6,'(1X,64("*"))')
      SUM = 0.0D0
      DO I=1,NSTATE
        WRITE(6,'(3F12.4,17X,F12.4)')
     *     CENTER(1,I),CENTER(2,I),CENTER(3,I),CENTER(4,I)
            SUM = SUM+CENTER(4,I)
      ENDDO
      WRITE(6,'(/,1X,"  TOTAL SPREAD OF THE SYSTEM ",F12.4)') SUM
      WRITE(6,'(1X,64("*"),/)')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE WANNIER_SAVE(nstate,center)
c     saves the wannier centers for use in the NMR/EPR routines. ONLY
c     possible when called from NMR_P/EPR_P!!! 
c     (Needs memory to be allocated)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'response_p.inc'
      include 'gvec.inc'
      include 'irat.inc'
      integer nstate
      real*8  center(4,nstate)
      real*8  projection
      integer is,bound,msglen,center_coord
C     ==--------------------------------------------------------------==
      if (.not. (TNMR.or.TEPR)) return

      if (parent) then
        if (TNMR .OR. TEPR) then
         call DCOPY(4*nstate,center,1,wanniercenters,1)
         do is=1,nstate
C     FIRST DIMENSION (nr1s)
            projection = center(1,is) * b1(1)  +   center(2,is) * b1(2)
     &           + center(3,is) * b1(3)
            projection = projection / alat * DBLE(NR1S) + 1
            center_coord = bound( NINT(projection) ,NR1S)
            lower_left(1,is) = bound(center_coord - NR1S/2,NR1S)
            lower_left_value(1,is) = - NR1S/2
C     SECOND DIMENSION (nr2s)
            projection = center(1,is) * b2(1)  +   center(2,is) * b2(2)
     &           + center(3,is) * b2(3)
            projection = projection / alat * DBLE(NR2S) + 1
            center_coord = bound( NINT(projection) ,NR2S)
            lower_left(2,is) = bound(center_coord - NR2S/2,NR2S)
            lower_left_value(2,is) = - NR2S/2
C     THIRD DIMENSION (nr3s)
            projection = center(1,is) * b3(1)  +   center(2,is) * b3(2)
     &           + center(3,is) * b3(3)
            projection = projection / alat * DBLE(NR3S) + 1
            center_coord = bound( NINT(projection) ,NR3S)
            lower_left(3,is) = bound(center_coord - NR3S/2,NR3S)
            lower_left_value(3,is) = - NR3S/2
         enddo
        endif
      endif

#ifdef PARALLEL
      msglen=3* 8/IRAT *nstate
      call MY_BCAST(lower_left_value,MSGLEN,SOURCE,ALLGRP)
      call MY_BCAST(lower_left,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================

