CIF   * SUBROUTINE FOR CALCULATION OF LOCAL DIPOLE MOMENTS *
CIF   * (I. FRANK, OCT. 94)
C     ==================================================================
      SUBROUTINE LODIPO(EIROP,RHOG)
C     ==--------------------------------------------------------------==
C     == CALCULATES LOCAL DIPOLE MOMENTS;                             ==
C     == DOES THE INTEGRATION USING CARTESIAN COORDINATES;            ==
C     == FOR EXPLANATION OF SOME VARIABLES SEE proppt.f               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'lodp.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      COMPLEX*16 RHOG(NNR1),EIROP(NHG)
C     Variables
      COMPLEX*16 CONE
      PARAMETER  (CONE=(1.D0,0.D0))
      COMPLEX*16 GMIN(3),GMAX(3),EMIN(3),EMAX(3),DR(3),RDR(3),RSUM(3),
     &           SUM,CG,CG1,CG2,CG3
      REAL*8     RMIN(3),RMAX(3),G(3),G1,G2,G3
      INTEGER    ISUB,I,K,IG,IPM,J
C     ==--------------------------------------------------------------==
      CALL TISET('    LODIPO',ISUB)
C     Loop over the NUMBLD areas given in the input file
      DO I=1,NUMBLD
        RMIN(1)=XMINLD(I)
        RMAX(1)=XMAXLD(I)
        RMIN(2)=YMINLD(I)
        RMAX(2)=YMAXLD(I)
        RMIN(3)=ZMINLD(I)
        RMAX(3)=ZMAXLD(I)
C       RCC: coordinates of the center of charge
        DO K=1,3
          RCC(K,I)=(RMIN(K)+RMAX(K))/2
          RSUM(K)=DCMPLX(0.D0,0.D0)
        ENDDO
        SUM=DCMPLX(0.D0,0.D0)
C       Calculate the center of positive charge
C       sum over all components of the wave function
        DO IG=1,NHG
C         sum twice (for positive and negative g values)
          DO IPM=-1,1,2
C           do not sum twice if |g|=0
            IF(ABS(GK(1,IG)).GT.0.001D0
     *           .OR.ABS(GK(2,IG)).GT.0.001D0
     *           .OR.ABS(GK(3,IG)).GT.0.001D0
     *           .OR.IPM.GT.0) THEN
              CG=DCMPLX(DREAL(EIROP(IG)),
     *             DIMAG(EIROP(IG))*IPM)
              DO K=1,3
                G(K)=GK(K,IG)*TPIBA*IPM
                GMIN(K)=UIMAG*G(K)*RMIN(K)
                GMAX(K)=UIMAG*G(K)*RMAX(K)
                EMIN(K)=EXP(GMIN(K))
                EMAX(K)=EXP(GMAX(K))
                IF(ABS(GK(K,IG)).GT.0.001D0) THEN
                  RDR(K)=-((GMAX(K)-CONE)*EMAX(K)
     *                 -(GMIN(K)-CONE)*EMIN(K))
     *                 /G(K)/G(K)
                  DR(K)=-UIMAG*(EMAX(K)-EMIN(K))/G(K)
                ELSE
                  RDR(K)=(RMAX(K)*RMAX(K)
     *                 -RMIN(K)*RMIN(K))/2
                  DR(K)=RMAX(K)-RMIN(K)
                ENDIF
              ENDDO
              RSUM(1)=RSUM(1)-CG*RDR(1)*DR(2)*DR(3)
              RSUM(2)=RSUM(2)-CG*DR(1)*RDR(2)*DR(3)
              RSUM(3)=RSUM(3)-CG*DR(1)*DR(2)*RDR(3)
              SUM=SUM-CG*DR(1)*DR(2)*DR(3)
            ENDIF
          ENDDO
        ENDDO
        CALL GLOSUM(2,SUM)
        CALL GLOSUM(6,RSUM)
        IF(ABS(DREAL(SUM)).GT.0.001D0) THEN
          DO K=1,3
            RCC(K,I)=DREAL(RSUM(K))/DREAL(SUM)
          ENDDO
        ENDIF
        CHRLD(I)=0.D0
        DO IG=1,NHG
          G1=GK(1,IG)*TPIBA
          G2=GK(2,IG)*TPIBA
          G3=GK(3,IG)*TPIBA
          IF(ABS(G1).LT.0.001D0) THEN
            CG1=RMAX(1)-RMIN(1)
          ELSE
            CG1=-UIMAG/G1*(EXP(UIMAG*RMAX(1)*G1)-EXP(UIMAG*RMIN(1)*G1))
          ENDIF
          IF(ABS(G2).LT.0.001D0) THEN
            CG2=RMAX(2)-RMIN(2)
          ELSE
            CG2=-UIMAG/G2*(EXP(UIMAG*RMAX(2)*G2)-EXP(UIMAG*RMIN(2)*G2))
          ENDIF
          IF(ABS(G3).LT.0.001D0) THEN
            CG3=RMAX(3)-RMIN(3)
          ELSE
           CG3=-UIMAG/G3*(EXP(UIMAG*RMAX(3)*G3)-EXP(UIMAG*RMIN(3)*G3))
          ENDIF
         CHRLD(I)=CHRLD(I)+2.D0*DREAL(CG1*CG2*CG3*RHOG(NZH(IG)))
        ENDDO
        IF(GEQ0) THEN
          CHRLD(I)=CHRLD(I)-DREAL(RHOG(NZH(1)))*
     *      (RMAX(1)-RMIN(1))*(RMAX(2)-RMIN(2))*(RMAX(3)-RMIN(3))
        ENDIF
        CALL GLOSUM(1,CHRLD(I))
C       start calculating the dipole moment
C       DMOMLO(J,I): component J of the dipole moment for area I
        DO J=1,3
          DMOMLO(J,I)=0.D0
        ENDDO
C       calculate integration range relative to center of charge
C       sum over all components of the wave function
        DO IG=1,NHG
C         sum twice (for positive and negative g values)
          DO IPM=-1,1,2
C           do not sum twice if |g|=0
            IF(ABS(GK(1,IG)).GT.0.001D0
     *           .OR.ABS(GK(2,IG)).GT.0.001D0
     *           .OR.ABS(GK(3,IG)).GT.0.001D0
     *           .OR.IPM.GT.0) THEN
              CG=DCMPLX(DREAL(RHOG(NZH(IG))+EIROP(IG)),
     *             DIMAG(RHOG(NZH(IG))+EIROP(IG))*IPM)
              DO K=1,3
                G(K)=GK(K,IG)*TPIBA*IPM
                GMIN(K)=UIMAG*G(K)*RMIN(K)
                GMAX(K)=UIMAG*G(K)*RMAX(K)
                EMIN(K)=EXP(GMIN(K))
                EMAX(K)=EXP(GMAX(K))
                IF(ABS(GK(K,IG)).GT.0.001D0) THEN
                  RDR(K)=-((GMAX(K)-CONE)*EMAX(K)
     *                 -(GMIN(K)-CONE)*EMIN(K))
     *                 /G(K)/G(K)
                  DR(K)=-UIMAG*(EMAX(K)-EMIN(K))/G(K)
                ELSE
                  RDR(K)=(RMAX(K)*RMAX(K)
     *                 -RMIN(K)*RMIN(K))/2
                  DR(K)=RMAX(K)-RMIN(K)
                ENDIF
              ENDDO
              DMOMLO(1,I)=DMOMLO(1,I)
     *             -DREAL(CG*(RDR(1)-DR(1)*RCC(1,I))*DR(2)*DR(3))
              DMOMLO(2,I)=DMOMLO(2,I)
     *             -DREAL(CG*DR(1)*(RDR(2)-DR(2)*RCC(2,I))*DR(3))
              DMOMLO(3,I)=DMOMLO(3,I)
     *             -DREAL(CG*DR(1)*DR(2)*(RDR(3)-DR(3)*RCC(3,I)))
            ENDIF
          ENDDO
        ENDDO
        CALL GLOSUM(3,DMOMLO(1,I))
      ENDDO
      CALL TIHALT('    LODIPO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
