C     ==================================================================
      SUBROUTINE LOWDIN(CP,CN,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     ==  LOWDIN ORTHOGONALIZATION                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'sfac.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER    LSCR,NSTATE
      COMPLEX*16 CP(NGW,*),CN(NGW,*)
      REAL*8     SCR(*)
C     Variables
      REAL*8     FNL(*),DFNL(*)
      REAL*8     A(NSTATE*NSTATE),W(NSTATE),Z(NSTATE,NSTATE),
     &           AUX(3*NSTATE),Z2(NSTATE*NSTATE)
      POINTER    (IP_A,A),(IP_W,W),(IP_Z,Z),(IP_AUX,AUX),(IP_Z2,Z2)
      REAL*8     FAC
      INTEGER    ISUB,N2,K,J,I,IJ,KK,
     &           IL_A,IL_W,IL_Z,IL_AUX,LLOWDIN
C     ==--------------------------------------------------------------==
      CALL TISET('    LOWDIN',ISUB)
C     SCR partition
#ifdef _BGL 
      N2=NSTATE*NSTATE+MOD(NSTATE*NSTATE,2)
      IL_A  =N2+MOD(N2,2)
      IL_W  =NSTATE+MOD(NSTATE,2)
      IL_Z  =N2+MOD(N2,2)
      IL_AUX=3*NSTATE+MOD(3*NSTATE,2)
#else
      N2=NSTATE*NSTATE
      IL_A  =N2
      IL_W  =NSTATE
      IL_Z  =N2
      IL_AUX=3*NSTATE
#endif
      LLOWDIN=IL_A+IL_W+IL_Z+IL_AUX
      CALL TEST_SCR('LOWDIN','2*N2+4*NSTATE',LSCR,LLOWDIN)
      CALL GET_ADDR(IP_A,SCR(1))
      CALL GET_ADDR(IP_W,SCR(1+IL_A))
C     Z and Z2 use the same memory location.
      CALL GET_ADDR(IP_Z,SCR(1+IL_A+IL_W))
      CALL GET_ADDR(IP_Z2,SCR(1+IL_A+IL_W))
      CALL GET_ADDR(IP_AUX,SCR(1+IL_A+IL_W+IL_Z))
C     ==--------------------------------------------------------------==
      CALL CSMAT(Z,CP,FNL,NSTATE,1)
      IF(.NOT.TLSD) THEN
        K=0
        DO J=1,NSTATE
          DO I=J,NSTATE
            K=K+1
            A(K)=Z(I,J)
          ENDDO
        ENDDO
        CALL DSPEVY(1,A,W,Z,NSTATE,NSTATE,AUX,3*NSTATE)
        DO I=1,NSTATE
          W(I)=1.D0/SQRT(W(I))
        ENDDO
        CALL AZZERO(A,N2)
        DO K=1,NSTATE
          IJ=1
          DO J=1,NSTATE
            FAC=W(K)*Z(J,K)
            CALL DAXPY(NSTATE,FAC,Z(1,K),1,A(IJ),1)
            IJ=IJ+NSTATE
          ENDDO
        ENDDO
        IF(NGW.GT.0) THEN
          CALL DGEMM('N','N',2*NGW,NSTATE,NSTATE,1.0D0,CP(1,1),2*NGW,
     &               A(1),NSTATE,0.0D0,CN(1,1),2*NGW)
          CALL DCOPY(2*NSTATE*NGW,CN(1,1),1,CP(1,1),1)
          IF(GEQ0) THEN
            DO I=1,NSTATE
              CP(1,I)=DCMPLX(DREAL(CP(1,I)),0.0D0)
            ENDDO
          ENDIF
        ENDIF
      ELSE
C       ALPHA SPIN
        IF(NSUP.GT.0) THEN
          K=0
          DO J=1,NSUP
            DO I=J,NSUP
              IJ=(J-1)*NSTATE+I
              K=K+1
              A(K)=Z2(IJ)
            ENDDO
          ENDDO
          CALL DSPEVY(1,A,W,Z2,NSUP,NSUP,AUX,3*NSUP)
          DO I=1,NSUP
            W(I)=1.D0/SQRT(W(I))
          ENDDO
          CALL AZZERO(A,NSUP*NSUP)
          DO K=1,NSUP
            IJ=1
            DO J=1,NSUP
              KK=(K-1)*NSUP
              FAC=W(K)*Z2(KK+J)
              CALL DAXPY(NSUP,FAC,Z2(KK+1),1,A(IJ),1)
              IJ=IJ+NSUP
            ENDDO
          ENDDO
          IF(NGW.GT.0) THEN
            CALL DGEMM('N','N',2*NGW,NSUP,NSUP,1.0D0,CP(1,1),2*NGW,
     &               A(1),NSUP,0.0D0,CN(1,1),2*NGW)
            CALL DCOPY(2*NSUP*NGW,CN(1,1),1,CP(1,1),1)
          ENDIF
        ENDIF
C       BETA SPIN
        IF(NSDOWN.GT.0) THEN
          K=0
          DO J=1,NSDOWN
            DO I=J,NSDOWN
              IJ=NSUP*NSTATE+(J-1)*NSTATE+NSUP+I
              K=K+1
              A(K)=Z2(IJ)
            ENDDO
          ENDDO
          CALL DSPEVY(1,A,W,Z2,NSDOWN,NSDOWN,AUX,3*NSDOWN)
          DO I=1,NSDOWN
            W(I)=1.D0/SQRT(W(I))
          ENDDO
          CALL AZZERO(A,NSDOWN*NSDOWN)
          DO K=1,NSDOWN
            IJ=1
            DO J=1,NSDOWN
              KK=(K-1)*NSDOWN
              FAC=W(K)*Z2(KK+J)
              CALL DAXPY(NSDOWN,FAC,Z2(KK+1),1,A(IJ),1)
              IJ=IJ+NSDOWN
            ENDDO
          ENDDO
          IF(NGW.GT.0) THEN
            CALL DGEMM('N','N',2*NGW,NSDOWN,NSDOWN,1.0D0,CP(1,NSUP+1),
     *               2*NGW,A(1),NSDOWN,0.0D0,CN(1,1),2*NGW)
            CALL DCOPY(2*NSDOWN*NGW,CN(1,1),1,CP(1,NSUP+1),1)
          ENDIF
        ENDIF
      ENDIF
      CALL TIHALT('    LOWDIN',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_LOWDIN(LLOWDIN,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   LLOWDIN,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LLOWDIN=2*NSTATE*NSTATE+4*NSTATE+10
      TAG='2*NSTATE*NSTATE+4*NSTATE'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
