C     ==================================================================
      SUBROUTINE LR_DIAG(C0,C1,C2,SC0,EIGV,DDXC,DRHOE,PSI,
     &                   TEIG,SCR,LSCR,NSTATE,NROOT,ORBITAL,KPRINT)
C     ==--------------------------------------------------------------==
C     ==    Calls diagonalizers for TD-DFT                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,NROOT,KPRINT
      COMPLEX*16 C0(NGW,*),C1(NGW,NSTATE,*),C2(NGW,*),SC0(*)
      COMPLEX*16 PSI(*)
      REAL*8     EIGV(*),SCR(LSCR),DRHOE(*),DDXC(*),TEIG(*)
      CHARACTER*(*) ORBITAL
C     Variables
      CHARACTER*30 TAG
      INTEGER    LLR_DIAG
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_LR_DIAG(LLR_DIAG,TAG)
      CALL TEST_SCR('LR_DIAG',TAG,LSCR,LLR_DIAG)
C     ==--------------------------------------------------------------==
      IF(LDIAG.EQ.1) THEN
        IF(TDA.AND.MSUBTA.GT.0) THEN
          CALL TD_SUB(C0,C1,C2,SC0,DDXC,PSI,EIGV,DRHOE,
     &                TEIG,SCR,LSCR,MSUBTA,NSTATE,NROOT,ORBITAL,KPRINT)
        ELSE
          CALL TD_DAV(C0,C1,C2,SC0,DDXC,PSI,EIGV,DRHOE,
     &                TEIG,SCR,LSCR,NSTATE,NROOT,ORBITAL,KPRINT)
        ENDIF
      ELSEIF(LDIAG.EQ.2) THEN
        CALL TD_NHDAV(C0,C1,C2,SC0,DDXC,PSI,EIGV,DRHOE,
     &                TEIG,SCR,LSCR,NSTATE,NROOT,ORBITAL,KPRINT)
      ELSEIF(LDIAG.EQ.3) THEN
        CALL TD_PCG(C0,C1,C2,SC0,DDXC,PSI,EIGV,DRHOE,
     &              TEIG,SCR,LSCR,MSUBTA,NSTATE,NROOT,ORBITAL,KPRINT)
      ELSE
        CALL STOPGM('LR_DIAG','METHOD NOT IMPLEMENTED')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_LR_DIAG(LLR_DIAG,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER      LLR_DIAG
      CHARACTER*30 TAG
C     Variables
      INTEGER LTDDIAG
C     ==--------------------------------------------------------------==
      LTDDIAG=0
      IF(LDIAG.EQ.1) THEN
        CALL GIVE_SCR_TD_DAV(LTDDIAG,TAG)
      ELSEIF(LDIAG.EQ.2) THEN
        CALL GIVE_SCR_TD_NHDAV(LTDDIAG,TAG)
      ELSEIF(LDIAG.EQ.3) THEN
        CALL GIVE_SCR_TD_PCG(LTDDIAG,TAG)
      ENDIF
      LLR_DIAG=MAX(LTDDIAG,100)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
