C     ==================================================================
      SUBROUTINE LR_FORCE(C0,C1,C2,SC0,E2,DDXC,PSI,DRHOE,EIGV,
     &                    SCR,LSCR,NSTATE,TYPE,ORBITAL)
C     ==--------------------------------------------------------------==
C     computes E(2) the second order functional and the corresponding
C     electronic forces 
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'rswf.inc'
C     ARGUMENTS
      INTEGER    NSTATE,LSCR
      CHARACTER*(*) TYPE,ORBITAL
      COMPLEX*16 C0(NGWK,*),C1(NGWK,*),C2(NGWK,*),SC0(*)
      REAL*8     E2(3),PSI(*),SCR(*),EIGV(*),DRHOE(*)
      REAL*8     DDXC(*)
C     VARIABLES
      CHARACTER*30 TAG
      REAL*8     DOTP
      EXTERNAL   DOTP
      INTEGER    ISUB,I,K,LLR_FORCE,LSV2
      DIMENSION  F(*),POTR(*)
      POINTER    (IP_FOCC,FOCC),(IP_SV2,SV2)
      REAL*8     FOCC(*),SV2(*)
      LOGICAL    DEBUG,TCIS
C     ==--------------------------------------------------------------==
      CALL TISET('  LR_FORCE',ISUB)
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_LR_FORCE(LLR_FORCE,TYPE,TAG)
      CALL TEST_SCR('LR_FORCE',TAG,LSCR,LLR_FORCE)
      DEBUG=.FALSE.
C     ==--------------------------------------------------------------==
C     == C2 = f*(H-e)*C1  for canonical orbitals                      ==
C     == C2 = f*(H-F)*C1  else                                        ==
C     ==--------------------------------------------------------------==
      CALL HPSI(C1,C2,SC0,POTR,PSI,SCR,LSCR,NSTATE,1,NLSD)
      IF(TLSD) THEN
        CALL HFXPSI(C0(1,1),C1(1,1),C2(1,1),F(1),-1.D0,PSI,NUPEL,NUPEL)
        K=NUPEL+1
        CALL HFXPSI(C0(1,K),C1(1,K),C2(1,K),F(K),-1.D0,PSI,NDOEL,NDOEL)
      ELSE
        CALL HFXPSI(C0,C1,C2,F,-1.D0,PSI,NSTATE,NSTATE)
      ENDIF
      IF(INDEX(ORBITAL,"CANON").NE.0) THEN
        DO I=1,NSTATE
          CALL DAXPY(2*NGW,EIGV(I),C1(1,I),1,C2(1,I),1)
        ENDDO
      ELSE
        CALL ROTATE(-1.D0,C1,1.D0,C2,EIGV,NSTATE,2*NGW,
     &              TLSD,NSUP,NSDOWN)
      ENDIF
C     ==--  Phonon Code  ---------------------------------------------==
C     ==--  Orbital Hardness -----------------------------------------==
      IF(INDEX(TYPE,"PHONON").NE.0 .OR.
     *   INDEX(TYPE,"ORBHARD").NE.0) THEN 
        DO I=1,NSTATE
          CALL DSCAL(2*NGW,F(I),C2(1,I),1)
          E2(3)=E2(3)-DOTP(NGW,C2(1,I),C1(1,I))
        ENDDO
        CALL RHO1OFR(C0,C1,F,DRHOE,PSI,NSTATE)
        CALL V1OFRHO1(E2,DRHOE,DDXC,PSI,SCR,LSCR)
        CALL VPSIMT(C0,C2,F,DRHOE,PSI,NSTATE,NLSD,.TRUE.)
C     ==--  Time Dependent DFT ---------------------------------------==
      ELSEIF(INDEX(TYPE,"TDAMB").NE.0) THEN 
C       Nothing more to do
      ELSEIF((INDEX(TYPE,"TDA").NE.0) .OR.
     *       (INDEX(TYPE,"TDAPB").NE.0) )  THEN 
        CALL SCRSET(SCR,LSCR,DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_FOCC,NSTATE,'FOCC',DEBUG)
        CALL SCRGET(SCR,LSCR,IP_SV2,LSV2,'SV2',DEBUG)
!$OMP parallel do private(I)
        DO I=1,NSTATE
          FOCC(I)=1.D0
        ENDDO
        CALL RHO1OFR(C0,C1,FOCC,DRHOE,PSI,NSTATE)
        CALL VTDOFRHO1(E2,DRHOE,DDXC,PSI,SV2,LSV2,.TRUE.)
        CALL VPSIMT(C0,C2,FOCC,DRHOE,PSI,NSTATE,NLSD,.TRUE.)
        TCIS=INDEX(TYPE,"TDAPB").EQ.0
        CALL SWITCH_FUNCTIONALS
        CALL HFXRPA(C0,C1,C2,PSI,NSTATE,TCIS)
        CALL SWITCH_FUNCTIONALS
        CALL SCRREL(SCR,LSCR,DEBUG)
      ELSEIF(INDEX(TYPE,"ZFORCE").NE.0) THEN
        DO I=1,NSTATE
          CALL DSCAL(2*NGW,F(I),C2(1,I),1)
          E2(3)=E2(3)-DOTP(NGW,C2(1,I),C1(1,I))
        ENDDO
        CALL RHO1OFR(C0,C1,F,DRHOE,PSI,NSTATE)
        CALL V1OFRHO1(E2,DRHOE,DDXC,PSI,SCR,LSCR)
        CALL VPSIMT(C0,C2,F,DRHOE,PSI,NSTATE,NLSD,.TRUE.)
C     ==--------------------------------------------------------------==
      ELSE
        CALL STOPGM('LR_FORCE','NO OPTION DEFINED.')
      END IF 
C     ==--------------------------------------------------------------==
      CALL TIHALT('  LR_FORCE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_LR_FORCE(LLR_FORCE,TYPE,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
C     Arguments
      INTEGER LLR_FORCE
      CHARACTER*30 TAG
      CHARACTER*(*) TYPE
C     Variables
      INTEGER LHPSI,LV1OFRHO1,LFFF
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_HPSI(LHPSI,TAG,N)
      IF(INDEX(TYPE,"PHONON").NE.0 .OR.
     *   INDEX(TYPE,"ORBHARD").NE.0) THEN 
        CALL GIVE_SCR_V1OFRHO1(LV1OFRHO1,TAG)
        LLR_FORCE=N*N+100
        LFFF=0
      ELSEIF(INDEX(TYPE,"TDDFT").NE.0) THEN 
        CALL GIVE_SCR_VTDOFRHO1(LV1OFRHO1,TAG)
        LLR_FORCE=2*NGW*N+LHPSI
        LFFF=N+100
      ELSEIF(INDEX(TYPE,"TDA").NE.0 .OR. 
     *       INDEX(TYPE,"TDAPB").NE.0 .OR.
     *       INDEX(TYPE,"TDAMB").NE.0) THEN 
        CALL GIVE_SCR_VTDOFRHO1(LV1OFRHO1,TAG)
        LLR_FORCE=0
        LFFF=N+100
      ELSEIF(INDEX(TYPE,"ZFORCE").NE.0) THEN 
        CALL GIVE_SCR_V1OFRHO1(LV1OFRHO1,TAG)
        LLR_FORCE=0
        LFFF=N+100
      END IF 
      LLR_FORCE=MAX(LLR_FORCE,LHPSI,LV1OFRHO1+LFFF)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LR_FORCE_SUB(C0,C1,C2,SC0,E2,DDXC,PSI,DRHOE,EIGV,
     &                        SCR,LSCR,NSTATE,MSUB,TYPE,ORBITAL)
C     ==--------------------------------------------------------------==
C     C0 only span the relevant subspace!
C     EIGV is also only within the subspace
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'poin.inc'
C     ARGUMENTS
      CHARACTER*(*) TYPE,ORBITAL
      COMPLEX*16 C0(NGWK,*),C1(NGWK,*),C2(NGWK,*),SC0(*)
      REAL*8     E2(3),PSI(*),SCR(*),EIGV(*),DRHOE(*)
      REAL*8     DDXC(*)
      INTEGER    NSTATE,LSCR,MSUB
C     VARIABLES
      CHARACTER*30 TAG
      INTEGER    ISUB,I,LLR_FORCE,LSV2
      DIMENSION  F(*),POTR(*)
      POINTER    (IP_FOCC,FOCC),(IP_SV2,SV2)
      REAL*8     FOCC(*),SV2(*)
      LOGICAL    DEBUG
C     ==--------------------------------------------------------------==
      CALL TISET('  LR_FORCE',ISUB)
      IF(TLSD) CALL STOPGM('LR_FORCE_SUB','LSD NOT IMPLEMENTED')
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_LR_FORCE(LLR_FORCE,TYPE,TAG)
      CALL TEST_SCR('LR_FORCE',TAG,LSCR,LLR_FORCE)
      DEBUG=.FALSE.
C     ==--------------------------------------------------------------==
C     == C2 = f*(H-e)*C1  for canonical orbitals                      ==
C     == C2 = f*(H-F)*C1  else                                        ==
C     ==--------------------------------------------------------------==
      CALL HPSI(C1,C2,SC0,POTR,PSI,SCR,LSCR,MSUB,1,NLSD)
      IF(INDEX(ORBITAL,"CANON").NE.0) THEN
        DO I=1,MSUB
          CALL DAXPY(2*NGW,EIGV(I),C1(1,I),1,C2(1,I),1)
        ENDDO
      ELSE
        CALL ROTATE(-1.D0,C1,1.D0,C2,EIGV,MSUB,2*NGW,TLSD,MSUB,MSUB)
      ENDIF
      IF(INDEX(TYPE,"TDA").NE.0) THEN
        CALL SCRSET(SCR,LSCR,DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_FOCC,NSTATE,'FOCC',DEBUG)
        CALL SCRGET(SCR,LSCR,IP_SV2,LSV2,'SV2',DEBUG)
!$OMP parallel do private(I)
        DO I=1,NSTATE
          FOCC(I)=1.D0
        ENDDO
CWARNING
C
        IF(TLSD) CALL STOPGM("LR_FORCE_SUB","CORRECT THIS BUG")
C
C       RHO1OFR MAKES AN ASSUMPTION ON THE STATES IN LSD THAT
C       IS NOT CORRECT - I THINK WE SHOULD USE RHOABOFR HERE
C
CWARNING
        CALL RHO1OFR(C0,C1,FOCC,DRHOE,PSI,MSUB)
        CALL VTDOFRHO1(E2,DRHOE,DDXC,PSI,SV2,LSV2,.TRUE.)
        CALL VPSIMT(C0,C2,FOCC,DRHOE,PSI,MSUB,NLSD,.TRUE.)
        CALL SCRREL(SCR,LSCR,DEBUG)
      ELSE
        CALL STOPGM('LR_FORCE','NO OPTION DEFINED.')
      END IF 
C     ==--------------------------------------------------------------==
      CALL TIHALT('  LR_FORCE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LRU_FORCE(C0,C1,C2,CGRAD,PSI,DRHOE,UFMAT,
     *                     SCR,LSCR,NSTATE,MSUB)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'poin.inc'
C     ARGUMENTS
      INTEGER    NSTATE,LSCR,MSUB
      COMPLEX*16 C0(NGWK,*),C1(NGWK,*),C2(NGWK,*)
      REAL*8     PSI(*),SCR(*),DRHOE(*),UFMAT(MSUB,*),CGRAD(NSTATE,*)
C     VARIABLES
      CHARACTER*30 TAG
      REAL*8     DOTP
      INTEGER    ISUB,I,IS,LLR_FORCE
      DIMENSION  F(*),POTR(*)
      POINTER    (IP_FOCC,FOCC),(IP_XMAT,XMAT)
      REAL*8     FOCC(*),XMAT(*)
      LOGICAL    DEBUG
C     ==--------------------------------------------------------------==
      CALL TISET(' LRU_FORCE',ISUB)
      IF(TLSD) CALL STOPGM('LRU_FORCE','LSD NOT IMPLEMENTED')
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_LRU_FORCE(LLR_FORCE,MSUB,TAG)
      CALL TEST_SCR('LRU_FORCE',TAG,LSCR,LLR_FORCE)
      DEBUG=.FALSE.
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_FOCC,MSUB,'FOCC',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_XMAT,MSUB*MSUB,'XMAT',DEBUG)
!$OMP parallel do private(I)
      DO I=1,MSUB
        FOCC(I)=1.D0
      ENDDO
      CALL VPSIMT(C1,C2,FOCC,DRHOE,PSI,MSUB,NLSD,.TRUE.)
      CALL OVLAP2(NGW,NSTATE,MSUB,CGRAD,C0,C2)
      CALL OVLAP(MSUB,XMAT,C1,C1)
      CALL DGEMM('T','N',NSTATE,MSUB,MSUB,-1.D0,UFMAT,MSUB,XMAT,MSUB,
     &           1.0D0,CGRAD,NSTATE)
      CALL SCRREL(SCR,LSCR,DEBUG)
      CALL GLOSUM(NSTATE*MSUB,CGRAD)
      CALL DSCAL(NSTATE*MSUB,2.D0,CGRAD,1)
C     ==--------------------------------------------------------------==
      CALL TIHALT(' LRU_FORCE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_LRU_FORCE(LLR_FORCE,MSUB,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
C     Arguments
      INTEGER LLR_FORCE,MSUB
      CHARACTER*30 TAG
C     Variables
C     ==--------------------------------------------------------------==
      LLR_FORCE=MSUB+MSUB*MSUB+100
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
