C     ==================================================================
      SUBROUTINE LR_ORTHO(NSTATE,C0,C1,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'cppt.inc'
      include 'spin.inc'
      include 'geq0.inc'
C     Arguments
      INTEGER     NSTATE,LSCR
      COMPLEX*16  C0(*),C1(*)
      REAL*8      SCR(LSCR)
C     variables
      INTEGER     ISUB,LLR_ORTHO
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      CALL TISET('   LR_ORTHO',ISUB)
      CALL GIVE_SCR_LR_ORTHO(LLR_ORTHO,NSTATE,TAG)
      CALL TEST_SCR('LR_ORTHO',TAG,LSCR,LLR_ORTHO)
      CALL OVLAP(NSTATE,SCR,C0,C1)
      CALL GLOSUM(NSTATE*NSTATE,SCR)
      CALL LR_GAUGE(NSTATE,SCR)
      CALL ROTATE(-1.D0,C0,1.D0,C1,SCR,NSTATE,2*NGW,TLSD,NSUP,NSDOWN)
      IF(GEQ0) CALL ZCLEAN(C1,NSTATE,NGW)
      CALL TIHALT('   LR_ORTHO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LR_GAUGE(NSTATE,OVLP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER NSTATE
      REAL*8  OVLP(NSTATE,NSTATE)
C     Local variables
      INTEGER   I, J
      DIMENSION F(NSTATE)
      REAL*8    F_IJ, F_JI, W_IJ, W_JI
      PARAMETER (W_IJ=0.5D0, W_JI=0.5D0)
C     ==--------------------------------------------------------------==
      IF(TPARA_GAUGE) RETURN
      IF(TGAUGE_ALL.AND.TLSD) THEN
        DO I=1,NSUP-1
          DO J=I+1,NSUP
            F_IJ=OVLP(I,J)
            F_JI=OVLP(J,I)
            OVLP(I,J)=W_IJ*F_IJ + (1.0D0-W_JI)*F_JI
            OVLP(J,I)=W_JI*F_JI + (1.0D0-W_IJ)*F_IJ
          ENDDO
        ENDDO
        DO I=NSUP+1,NSTATE-1
          DO J=I+1,NSTATE
            F_IJ=OVLP(I,J)
            F_JI=OVLP(J,I)
            OVLP(I,J)=W_IJ*F_IJ + (1.0D0-W_JI)*F_JI
            OVLP(J,I)=W_JI*F_JI + (1.0D0-W_IJ)*F_IJ
          ENDDO
        ENDDO
      ELSE IF(TGAUGE_ALL) THEN
        DO I=1,NSTATE-1
          DO J=I+1,NSTATE
            F_IJ=OVLP(I,J)
            F_JI=OVLP(J,I)
            OVLP(I,J)=W_IJ*F_IJ + (1.0D0-W_JI)*F_JI
            OVLP(J,I)=W_JI*F_JI + (1.0D0-W_IJ)*F_IJ
          ENDDO
        ENDDO
      ELSE IF(TLSE) THEN
        DO I=1,NSTATE-2
          DO J=NSTATE-1,NSTATE
            F_IJ=OVLP(I,J)
            F_JI=OVLP(J,I)
            OVLP(I,J)=W_IJ*F_IJ + (1.0D0-W_JI)*F_JI
            OVLP(J,I)=W_JI*F_JI + (1.0D0-W_IJ)*F_IJ
          ENDDO
        ENDDO
        I=NSTATE-1
        J=NSTATE
        F_IJ=OVLP(I,J)
        F_JI=OVLP(J,I)
        OVLP(I,J)=W_IJ*F_IJ + (1.0D0-W_JI)*F_JI
        OVLP(J,I)=W_JI*F_JI + (1.0D0-W_IJ)*F_IJ
      ELSE IF(TLSD) THEN
        DO I=1,NSUP-1
          DO J=I+1,NSUP
            IF(F(I).NE.F(J)) THEN
              F_IJ=OVLP(I,J)
              F_JI=OVLP(J,I)
              OVLP(I,J)=W_IJ*F_IJ + (1.0D0-W_JI)*F_JI
              OVLP(J,I)=W_JI*F_JI + (1.0D0-W_IJ)*F_IJ
            ENDIF
          ENDDO
        ENDDO
        DO I=NSUP+1,NSTATE-1
          DO J=I+1,NSTATE
            IF(F(I).NE.F(J)) THEN
              F_IJ=OVLP(I,J)
              F_JI=OVLP(J,I)
              OVLP(I,J)=W_IJ*F_IJ + (1.0D0-W_JI)*F_JI
              OVLP(J,I)=W_JI*F_JI + (1.0D0-W_IJ)*F_IJ
            ENDIF
          ENDDO
        ENDDO
      ELSE
        DO I=1,NSTATE-1
          DO J=I+1,NSTATE
            IF(F(I).NE.F(J)) THEN
              F_IJ=OVLP(I,J)
              F_JI=OVLP(J,I)
              OVLP(I,J)=W_IJ*F_IJ + (1.0D0-W_JI)*F_JI
              OVLP(J,I)=W_JI*F_JI + (1.0D0-W_IJ)*F_IJ
            ENDIF
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LR_ORTHOS(NSTATE,N1,C0,C1,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'cppt.inc'
      include 'spin.inc'
      include 'geq0.inc'
C     Arguments
      INTEGER     NSTATE,LSCR,N1
      COMPLEX*16  C0(NGW,NSTATE),C1(NGW,N1)
      REAL*8      SCR(LSCR)
C     variables
      INTEGER     NS,ISUB,LLR_ORTHO
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      CALL TISET('  LR_ORTHOS',ISUB)
      CALL GIVE_SCR_LR_ORTHO(LLR_ORTHO,N1,TAG)
      CALL TEST_SCR('LR_ORTHO',TAG,LSCR,LLR_ORTHO)
      IF(TLSD) THEN
        NS=N1/2
        CALL OVLAP2(NGW,NSUP,NS,SCR,C0,C1)
        CALL GLOSUM(NSUP*NS,SCR)
        CALL DGEMM('N','N',2*NGW,NS,NSUP,-1.D0,C0,2*NGW,
     &             SCR,NSUP,1.D0,C1,2*NGW)
        CALL OVLAP2(NGW,NSDOWN,NS,SCR,C0(1,NSUP+1),C1(1,NS+1))
        CALL GLOSUM(NSDOWN*NS,SCR)
        CALL DGEMM('N','N',2*NGW,NS,NSDOWN,-1.D0,C0(1,NSUP+1),2*NGW,
     &             SCR,NSDOWN,1.D0,C1(1,NS+1),2*NGW)
      ELSE
        CALL OVLAP2(NGW,NSTATE,N1,SCR,C0,C1)
        CALL GLOSUM(NSTATE*N1,SCR)
        CALL DGEMM('N','N',2*NGW,N1,NSTATE,-1.D0,C0,2*NGW,
     &             SCR,NSTATE,1.D0,C1,2*NGW)
      ENDIF
      IF(GEQ0) CALL ZCLEAN(C1,N1,NGW)
      CALL TIHALT('  LR_ORTHOS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_LR_ORTHO(LLR_ORTHO,NSTATE,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INTEGER LLR_ORTHO,NSTATE
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      LLR_ORTHO=NSTATE*NSTATE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

