C     ==================================================================
      SUBROUTINE LR_PCG(C1,C2,VPP,HNM1,C0,DRHOE,DDXC,EIGV,SC0,PSI,
     &                  SCR,LSCR,NSTATE,DINIT)
C     ==--------------------------------------------------------------==
C     ==  PRECONDITIONED CONJUGATE GRADIENT OPTIMIZATION              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER    LSCR,NSTATE
      COMPLEX*16 C1(NGW,NSTATE),C2(NGW,NSTATE),
     &           HNM1(NGW,NSTATE),PSI(NNR1),C0(NGW,NSTATE),SC0(*)
      REAL*8     VPP(NGW),SCR(LSCR),EIGV(*),DRHOE(*),DDXC(*)
      LOGICAL    DINIT
C     Variables
      LOGICAL    QSEARCH
      CHARACTER  TAG*30
      REAL*8     GGNORM,A0,GAMMA,GHIST(2)
      REAL*8     DOTP
      EXTERNAL   DOTP
      SAVE       GHIST
      INTEGER    ISUB,I,IG,LLR_PCG
C     ==--------------------------------------------------------------==
      CALL TISET('    LR_PCG',ISUB)
C     ==--------------------------------------------------------------==
C     Test SCR
      CALL GIVE_SCR_LR_PCG(LLR_PCG,TAG,NSTATE)
      CALL TEST_SCR('LR_PCG',TAG,LSCR,LLR_PCG)
C     ==--------------------------------------------------------------==
C..preconditioning
      DO I=1,NSTATE
        DO IG=1,NGW
          C2(IG,I)=VPP(IG)*C2(IG,I)
        ENDDO
      ENDDO
C..norm
      GGNORM=0.0D0
      DO I=1,NSTATE
        GGNORM=GGNORM+DOTP(NGW,C2(1,I),C2(1,I))
      ENDDO
      CALL GLOSUM(1,GGNORM)
      QSEARCH=.TRUE.
      IF(GGNORM.LT.TOL_QS.AND..NOT.TXC_ANALYTIC) QSEARCH=.FALSE.
      IF(DINIT) THEN
C     ==--------------------------------------------------------------==
C     ==  INITIAL CALL                                                ==
C     ==--------------------------------------------------------------==
        GHIST(1)=GGNORM
        CALL DCOPY(2*NGW*NSTATE,C2,1,HNM1,1)
        CALL LR_ORTHO(NSTATE,C0,HNM1,SCR,LSCR)
        IF(QSEARCH) THEN
          CALL QUADSR(A0,C0,VPP,HNM1,C2,DRHOE,DDXC,EIGV,SC0,PSI,
     &                SCR,LSCR,NSTATE)
          CALL DAXPY(2*NGW*NSTATE,A0,HNM1,1,C1,1)
        ELSE
          CALL DAXPY(2*NGW*NSTATE,DLRS,HNM1,1,C1,1)
        ENDIF
      ELSE
C     ==--------------------------------------------------------------==
C     ==  CONJUGATE GRADIENT                                          ==
C     ==--------------------------------------------------------------==
        GHIST(2)=GGNORM
        GAMMA=GHIST(2)/GHIST(1)
        CALL DSCAL(2*NGW*NSTATE,GAMMA,HNM1,1)
        CALL DAXPY(2*NGW*NSTATE,1.D0,C2,1,HNM1,1)
        CALL LR_ORTHO(NSTATE,C0,HNM1,SCR,LSCR)
        IF(QSEARCH)THEN
          CALL QUADSR(A0,C0,VPP,HNM1,C2,DRHOE,DDXC,EIGV,SC0,PSI,
     &                SCR,LSCR,NSTATE)
          CALL DAXPY(2*NGW*NSTATE,A0,HNM1,1,C1,1)
        ELSE
          CALL DAXPY(2*NGW*NSTATE,DLRS,HNM1,1,C1,1)
        ENDIF
        GHIST(1)=GHIST(2)
      ENDIF
      DINIT=.FALSE.
      CALL TIHALT('    LR_PCG',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_LR_PCG(LLR_PCG,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INCLUDE 'system.h'        !NAX NSX
      INTEGER   LLR_PCG,NSTATE,LQUADSR,LLR_ORTHO
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_QUADSR(LQUADSR,TAG,NSTATE)
      CALL GIVE_SCR_LR_ORTHO(LLR_ORTHO,NSTATE,TAG)
      LLR_PCG=MAX(LQUADSR,LLR_ORTHO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE QUADSR(A0,C0,VPP,DC,C2,DRHOE,DDXC,EIGV,SC0,PSI,
     &                  SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     ==  Quadratic line search                                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'linres.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'poin.inc'
C     Arguments
      INTEGER    LSCR,NSTATE
      COMPLEX*16 C2(NGW,NSTATE),
     &           DC(NGW,NSTATE),PSI(NNR1),C0(NGW,NSTATE),SC0(*)
      REAL*8     A0,SCR(LSCR),EIGV(*),VPP(*),DRHOE(*),DDXC(*)
C     Variables
      CHARACTER  TAG*30
      INTEGER    LQUADSR,I,IG
      REAL*8     ZQUAD,ZLIN,DOTP,EQ(2)
      EXTERNAL   DOTP
      DIMENSION  F(*),POTR(*)
C     ==--------------------------------------------------------------==
C     Test SCR
      CALL GIVE_SCR_QUADSR(LQUADSR,TAG,NSTATE)
      CALL TEST_SCR('QUADSR',TAG,LSCR,LQUADSR)
C     ==--------------------------------------------------------------==
C..de_preconditioning
      DO I=1,NSTATE
        DO IG=1,NGW
          C2(IG,I)=C2(IG,I)/VPP(IG)
        ENDDO
      ENDDO
C..linear terms
      ZLIN=0.D0
      DO I=1,NSTATE
        ZLIN=ZLIN-DOTP(NGW,DC(1,I),C2(1,I))
      ENDDO
C..delta force
      CALL HPSI(DC,C2,SC0,POTR,PSI,SCR,LSCR,NSTATE,1,NLSD)
      DO I=1,NSTATE
        CALL DSCAL(2*NGW,F(I),C2(1,I),1)
      ENDDO
      DO I=1,NSTATE
        CALL DAXPY(2*NGW,EIGV(I),DC(1,I),1,C2(1,I),1)
      ENDDO
C..XC and Hartree kernel
      CALL RHO1OFR(C0,DC,F,DRHOE,PSI,NSTATE)
      CALL EDOFRHOD(EQ,DRHOE,DDXC,PSI)
C..quadratic terms
      ZQUAD=-EQ(1)-EQ(2)
      DO I=1,NSTATE
        ZQUAD=ZQUAD+DOTP(NGW,DC(1,I),C2(1,I))
      ENDDO
      CALL GLOSUM(1,ZQUAD)
      CALL GLOSUM(1,ZLIN)
      IF(ABS(ZQUAD).LT.1.D-12) THEN
        A0=DLRS
      ELSE
        A0=ZLIN/ZQUAD
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_QUADSR(LQUADSR,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INCLUDE 'system.h'
      INTEGER   LQUADSR,LHPSI,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_HPSI(LHPSI,TAG,NSTATE)
      LQUADSR=LHPSI
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE EDOFRHOD(E2,DRHOE,DDXC,PSI)
C     ==--------------------------------------------------------------==
C     calculate the quadratic contribution of the XC and Hartree Kernel
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'spin.inc'        !nlsd
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'isos.inc'
C
      COMPLEX*16 PSI(NNR1,*)
      REAL*8     E2(2),DRHOE(NNR1,NLSD),DDXC(NNR1,NLSD)
C
      INTEGER    IR,IG
      COMPLEX*16 V1
      REAL*8     EXC2,EHT2
C     ==--------------------------------------------------------------==
C..transform dn1 to g-space
      CALL AZZERO(PSI,2*MAXFFT)
!$OMP parallel do private(IR)
      DO IR=1,NNR1
        PSI(IR,1)=DCMPLX(DRHOE(IR,1),0.D0)
      ENDDO
      CALL FWFFT(PSI)
C     ==--------------------------------------------------------------==
C     == This is the Hartree Potential                                ==
C     ==--------------------------------------------------------------==
      EHT2=0.D0
      DO IG=1,NHG
        V1 = PSI(NZH(IG),1) * SCG(IG)
        EHT2 = EHT2 + DREAL(DCONJG(V1)*PSI(NZH(IG),1))
      ENDDO
      EHT2 = EHT2*OMEGA
C     ==--------------------------------------------------------------==
C     == XC contributions (we make a LDA approximation here)          ==
C     == DDXC holds at least a reasonable approximation to W(d)       ==
C     ==--------------------------------------------------------------==
      EXC2=0.D0
      DO IR=1,NNR1
        EXC2=EXC2+DDXC(IR,1)*DRHOE(IR,1)*DRHOE(IR,1)
      ENDDO
      IF(TLSD) THEN
        DO IR=1,NNR1
          EXC2=EXC2+DDXC(IR,2)*DRHOE(IR,2)*DRHOE(IR,2)
        ENDDO
      ENDIF
      EXC2=0.5D0*EXC2*OMEGA/DBLE(NR1S*NR2S*NR3S)
C     ==--------------------------------------------------------------==
      E2(1) = EHT2
      E2(2) = EXC2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
