C     ==================================================================
      SUBROUTINE LR_TDDFT(C0,C1,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,
     *                    SCR,LSCR,NSTATE,TFOR,KPRINT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'tpot.inc'
      INCLUDE 'tauf.inc'
      INCLUDE 'linres.inc'
C..TSH[
      INCLUDE 'irat.inc'
C..TSH]
C     Qmmm
      include 'efld.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      COMPLEX*16 C0(NGW,*),C1(*),C2(NGW,*),SC0(*)
      REAL*8     RHOE(*),PSI(*),TAU0(*),FION(*),EIGV(*),SCR(*)
      INTEGER    LSCR,NSTATE,KPRINT
      LOGICAL    TFOR
C     Variables
      REAL*8 EIGS(*),DDXC(*),EXTF(*),EIGM(*)
      REAL*8 TAU(*),VTAU(*)
      POINTER (IP_DDXC,DDXC)
      POINTER (IP_EIGS,EIGS)
      POINTER (IP_EIGM,EIGM)
      DIMENSION  RHOO(NNR1,*),POTR(NNR1,*),F(*)
      CHARACTER  TAG*30,ORBITAL*10
      INTEGER    LSPECTRA,MS,ID,LDDXC,MSGLEN,IS
C  QMMM
      LOGICAL    STATUSDUMMY
C
C  Landau Zener
      INTEGER    NACT,NROOT,NVIR,NTDDFT,NAP,NBP,NCSCR
      INTEGER    TRANSITION(3,4,20)
      REAL*8     EDAV(*)
      COMPLEX*16 CVIRT(NGW,*)
      POINTER    (IP_CVIRT,CVIRT),(IP_EDAV,EDAV)
      INTEGER    IFIRST
      SAVE       IFIRST
      DATA       IFIRST/0/
C..TSH[
      DIMENSION  CK(NGW,*),C1K(*),C_SH(2,*),V_SH(2,*)
      LOGICAL    FEXIST,INIT_C1K
      INTEGER    TEMP
      REAL*8     OPHASE,OVLAPM(NSHS,*),SHPROB(*)
      POINTER    (IP_OVLAPM,OVLAPM),(IP_SHPROB,SHPROB)
C..TSH]
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_LR_TDDFT(LSPECTRA,TFOR,TAG)
      CALL TEST_SCR('LR_TDDFT',TAG,LSCR,LSPECTRA)
C
      IF(TREORDER) THEN
        CALL STOPGM("LR_TDDFT","NO REORDER")
      ENDIF
C..TSH[
      INIT_C1K=.FALSE.
      NROOT=MAX(NS_MIX,NS_SIN,NS_TRI,2)
      IF (TDTULLY.AND.IFIRST.EQ.0) THEN
C      done during the initialization
       S0_SH=.FALSE.
       IF (FSTATE.EQ.0) S0_SH=.TRUE.
       TULLY_SH=.FALSE.
C      this is done during the initialization of the forces 
       IF (PARENT) THEN
         INQUIRE(FILE=SHFILEN2,EXIST=FEXIST)
       ENDIF
#ifdef PARALLEL
       MSGLEN=1 * 8/IRAT
       CALL MY_BCAST(FEXIST,4,SOURCE,ALLGRP)
#endif
       IF(.NOT.FEXIST) THEN
         INIT_C1K=.TRUE.
       ELSE
         CALL TMPRD(C1K,NSTATE,NROOT,TEMP,SHFILEN2)
       ENDIF
      ENDIF

      IF (TDTULLY.AND.IFIRST.EQ.1) THEN
C      done during the first MD step
       IF (SHSTEP.EQ.1) THEN
C        INITIALIZE_SH
         S0_SH=.FALSE.
         IF (FSTATE.EQ.0) S0_SH=.TRUE.
         TULLY_SH=.FALSE.
         CALL AZZERO (C_SH,2*2*(NROOT+1))
         CALL AZZERO (V_SH,2*(NROOT+1))
         CALL AZZERO (SHSIGMA,2*(NROOT+1)*(NROOT+1))
         C_SH(1,FSTATE+1)=(1.D0,0.D0)
         C_SH(2,FSTATE+1)=(1.D0,0.D0)
C        FSTATE from input file &TDDFT
       ELSE
         S0_SH=.FALSE.
         TULLY_SH=.FALSE.
         CALL READ_SHCOEFF
         SHSTEP=SHSTEP+1
       ENDIF
      ENDIF
C
      IF (TDLZ.OR.TDTULLY) THEN
       IF (qmnode) call mm_dim(mm_go_qm,statusdummy)
       NROOT=MAX(NS_MIX,NS_SIN,NS_TRI,2)
       NVIR=NROOT
       NCSCR=2*NGW*NVIR
       NTDDFT=NSTATE+NVIR
       TULLY_SH=.FALSE.
       CALL MEMORY(IP_CVIRT,NCSCR,'CVIRT')
       CALL MEMORY(IP_EDAV,NTDDFT,'EDAV')
       CALL MEMORY(IP_SHPROB,(NROOT+1)*(NROOT+1),'SHPROB')
       IF (SH_DIAG) THEN
        IF (IFIRST.EQ.0) THEN
          CALL RESIZE_F
        ENDIF
        CALL SETSPIN("S",C0,CVIRT,C2)
        CALL TD_SPECT(C0,C2,RHOE,NTDDFT,CVIRT,SC0,PSI,EDAV,LSCR,SCR)
        CALL SETSPIN("R",C0,CVIRT,C2)
        IF(TLSD) THEN
          NAP=NSUP-NUPEL
          NBP=NSDOWN-NDOEL
          CALL DCOPY(2*NGW*NAP,C0(1,NUPEL+1),1,CVIRT(1,1),1)
          CALL DCOPY(2*NGW*NBP,C0(1,NSUP+NDOEL+1),1,CVIRT(1,NAP+1),1)
        ELSE
           CALL DCOPY(2*NGW*NVIR,C0(1,N+1),1,CVIRT(1,1),1)
        ENDIF
       ENDIF
       CALL MEMORY(IP_OVLAPM,NSHS*NSHS,'OVLAPM')
C      IF (PARENT) THEN
C        write(6,'(A,3I7)') 'NSTATE,NROOT,NSHS',NSTATE,NROOT,NSHS
C      ENDIF
      ENDIF
C..TSH]
C     calculate Kohn-Sham matrix
      CALL MEMORY(IP_EIGM,NSTATE*NSTATE,'EIGM')
      IF ( qmmm ) THEN
        call mm_dim(mm_go_qm,statusdummy)
        if (tddft) then
          call td_mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU0,FION,
     *             EIGV,SCR,LSCR,NSTATE,1,.FALSE.,.TRUE.,.TRUE.)
        else
        call mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU0,FION,
     *               EIGV,SCR,LSCR,NSTATE,1,.FALSE.,.FALSE.,.TRUE.)
        endif
      ELSE
        CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               NSTATE,1,.FALSE.,TFOR)
      ENDIF
C     transform to canonical orbitals and get eigenvalues
      CALL CANON(C0,C2,F,NSTATE,EIGV,SCR,LSCR)
      IF(TD_METHOD.EQ.1) THEN
        ORBITAL="GENERAL"
        CALL TDM_FUN(TD_FUNCTIONAL,1)
        IF(TPOTENTIAL) THEN
C
          CALL GET_ADDR(IP_C0Y,C0(1,1))
          CALL MEMORY(IP_EIGVAL,NSTATE,"EIGVAL")
          CALL MEMORY(IP_EIGREF,NSTATE,"EIGREF")
          CALL MEMORY(IP_FOCCP,NSTATE,"FOCCP")
          CALL DCOPY(NSTATE,F,1,FOCCP,1)
          CALL DCOPY(NSTATE,EIGV,1,EIGVAL,1)
          MSTATE=NSTATE
          IF(MOLSTAT) THEN
            CALL STOPGM("LR_TDDFT","MOLSTAT NOT IMPLEMENTED")
          ENDIF
        ENDIF
        IF ( qmmm ) THEN
          call mm_dim(mm_go_qm,statusdummy)
          call mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU0,FION,
     *               EIGV,SCR,LSCR,NSTATE,1,.FALSE.,.FALSE.,.TRUE.)
        ELSE
          CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               NSTATE,1,.FALSE.,.FALSE.)
        ENDIF
        DO IS=1,NSTATE
          CALL DSCAL(2*NGW,1.D0/F(IS),C2(1,IS),1)
        ENDDO
        CALL OVLAP(NSTATE,EIGM,C0,C2)
        CALL GLOSUM(NSTATE*NSTATE,EIGM)
      ELSE
        ORBITAL="CANON"
        CALL DCOPY(NSTATE,EIGV,1,EIGM,1)
      ENDIF
C..TSH[
      IF (TDLZ.OR.TDTULLY) THEN
       IF(TLSD) THEN
        NAP=NSUP-NUPEL
        NBP=NSDOWN-NDOEL
        CALL DCOPY(2*NGW*NAP,C0(1,NUPEL+1),1,CVIRT(1,1),1)
        CALL DCOPY(2*NGW*NBP,C0(1,NSUP+NDOEL+1),1,CVIRT(1,NAP+1),1)
       ELSE
         CALL DCOPY(2*NGW*NVIR,C0(1,N+1),1,CVIRT(1,1),1)
       ENDIF
      ENDIF
C..TSH]
C     store potential and density
      CALL DCOPY(NNR1*NLSD,RHOE,1,POTR,1)
      CALL RHOOFR(C0,RHOE,PSI,SCR,LSCR,NSTATE)
      CALL DCOPY(NNR1*NLSD,RHOE,1,RHOO,1)
      IF(TINLC) THEN
        CALL MEMORY(IP_ROCT,NNR1*NLSD,"ROCT")
        CALL AZZERO(ROCT,NNR1*NLSD)
        CALL COREC(ROCT,SCR,PSI)
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PS_TYPE.EQ.1) CALL STOPGM('LR_TDDFT','HOCKNEY PS not impl.')
      MS=MAX(NS_MIX,NS_SIN,NS_TRI)
      CALL MEMORY(IP_EIGS,MS,'EIGS')
C     calculate and store analytic dmu/dn
      IF(TXC_ANALYTIC) THEN
        LDDXC=NNR1*(2*NLSD-1)
      ELSE
        LDDXC=1
      ENDIF
      IF(LOPTI.GE.0) LOPTI=LOPTI-10
      CALL MEMORY(IP_DDXC,LDDXC,'DDXC')
      CALL LR_XCPOT(DDXC,RHOO,SCR,LSCR,.TRUE.)
      IF(TLSD) THEN
        LRSYM=0
      ELSEIF(NS_SIN.NE.0) THEN
        LRSYM=1
      ELSEIF(NS_TRI.NE.0) THEN
        LRSYM=3
      ENDIF
      IF(TTAU) THEN
        CALL DCOPY(NNR1*NLSD,RTAU,1,TAU,1)
        CALL DCOPY(NNR1*NLSD,PTAU,1,VTAU,1)
      ENDIF
      CALL LR_DIAG(C0,C1,C2,SC0,EIGM,DDXC,RHOE,PSI,
     &             EIGS,SCR,LSCR,NSTATE,MS,ORBITAL,KPRINT)
      MSGLEN = MS * 8
      CALL MY_BCAST(EIGS,MSGLEN,SOURCE,ALLGRP)
C     ==--------------------------------------------------------------==
      CALL TD_OS(NSTATE,C0,MS,EIGS,C1,SCR,LSCR)
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_DDXC)
C     ==--------------------------------------------------------------==
      IF (FSTATE.GT.0) THEN
       ETDDFT=EIGS(FSTATE)
      ELSE
       ETDDFT=0.0
      ENDIF
C     ==--------------------------------------------------------------==
C..TSH[
      IF (TDLZ.OR.TDTULLY) THEN
       IF(TDA.AND.MSUBTA.GT.0) THEN
         NACT=MSUBTA
       ELSE
         IF(TLSD) THEN
           NACT=NUPEL+NDOEL
         ELSE
           NACT=N
         ENDIF
       ENDIF
       CALL IAZZERO(TRANSITION,3*4*20)
       CALL GETTRANS(TRANSITION,C1,CVIRT,SCR,LSCR,
     &                NACT,NVIR,NAP,NBP,NROOT)
       IF (TDTULLY) THEN
        IF (SHSTEP.EQ.0) CALL DCOPY(2*NGW*NSHS,C0(1,1),1,CK(1,1),1)
        IF (INIT_C1K) CALL DCOPY(2*NGW*NSTATE*NROOT,C1(1),1,C1K(1),1)
        DO IS=1,NROOT
          V_SH(1,IS+1)=EIGS(IS)
C         if(parent) write(6,*) 'energies',V_SH(1,IS+1)
        ENDDO
        V_SH(1,1)=0.D0
       ENDIF
       IF (IFIRST.GT.0) THEN
        IF (TDLZ) THEN
          CALL LZ_TRANS(TRANSITION,EIGS,NACT,NVIR,NAP,NBP,NROOT)
        ELSEIF (TDTULLY.AND.SHSTEP.GE.1) THEN
         CALL AZZERO(OVLAPM,NSHS*NSHS)
         CALL ADJUSTPHASE_LR(C1,C1K,NSTATE,NROOT,OVLAPM)
         CALL AZZERO(OVLAPM,NSHS*NSHS)
         CALL ADJUSTPHASE(C0,CK,NSHS,OVLAPM)
         CALL GETSIGMA(C0,C1,NSTATE,NROOT)
         IF (TDEXTPOT) CALL ECOUPL(NSTATE,C0,NROOT,C1,EIGS,SCR,LSCR)
         CALL PROPAGATE_C(NSTATE,NROOT+1,SHPROB)
         CALL DO_TULLYTEST(NROOT+1,SHPROB)
         CALL NORMALIZE_C_SH(NROOT)
         CALL WRITE_SHCOEFF(SHPROB,ETOT,NROOT)
         CALL TMPWR(C1,NSTATE,NROOT,SHSTEP,SHFILEN2)
C        NEWinOLD 
         CALL UPDATE_SH(NROOT)
         CALL DCOPY(2*NGW*NSTATE*NROOT,C1(1),1,C1K(1),1)
        ENDIF
       ENDIF
       IFIRST=IFIRST+1
      ENDIF
C..TSH]
C     ==--------------------------------------------------------------==
      IF(TFOR) THEN
        ETOT=ETOT+ETDDFT
C..TSH[
        IF (TDTULLY.AND.(S0_SH)) THEN
C         do nothing
        ELSE
          CALL TD_FORCE(C0,C1,C2,SC0,EIGM,RHOE,PSI,EIGS,
     &                NSTATE,MS,TAU0,FION,ORBITAL,KPRINT)
C         calculate relaxed density 
          CALL RELAX_RHO(C0,C1,C2,SC0,RHOO,RHOE,PSI,NSTATE,MS)
          CALL PRINT_EX_RHO(RHOE,PSI,TAU0)
        ENDIF
C..TSH]
C..TSH[
        IF (TDTULLY.AND.(S0_SH)) THEN
C        do nothing
        ELSE
         IF ( qmmm ) THEN
           CALL mm_rho_forcedr(RHOE,TAU0,FION,SCR,LSCR,NSTATE,.TRUE.,
     &                         .false.)
         ENDIF
        ENDIF
C..TSH]
      ENDIF
      if (qmmm .and. tddft .and. parent)
     &  write(41,'(3F15.9)') ETOT-ETDDFT,ETOT,ETDDFT
C     ==--------------------------------------------------------------==
      IF(TD_METHOD.EQ.1) THEN
        CALL TDM_FUN(KS_FUNCTIONAL,1)
        CALL FREEM(IP_EIGVAL)
        CALL FREEM(IP_EIGREF)
        CALL FREEM(IP_FOCCP)
      ENDIF
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_EIGS)
      CALL FREEM(IP_EIGM)
C..TSH[
      IF(TDLZ.OR.TDTULLY) THEN
       CALL FREEM(IP_CVIRT)
       CALL FREEM(IP_EDAV)
      ENDIF
      IF (TDTULLY) THEN
        CALL FREEM(IP_OVLAPM)
        CALL FREEM(IP_SHPROB)
      ENDIF
C..TSH]
      IF(TINLC) CALL FREEM(IP_ROCT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_LR_TDDFT(LSPECTRA,TFOR,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER   LSPECTRA
      LOGICAL   TFOR
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LRHOOFR,LFORCES,LCANON,LRNLSM,
     *          LLR_DIAG,L_DIAG,LORTHO,LLOCAL,L_FOR
C     ==--------------------------------------------------------------==
      L_DIAG=0
      NSTATE=N
      CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
      CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.FALSE.,TFOR)
      CALL GIVE_SCR_CANON(LCANON,TAG,NSTATE)
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
      CALL GIVE_SCR_LR_DIAG(LLR_DIAG,TAG)
      NSTATE=N+MAX(NS_TRI,NS_SIN,NS_MIX)
      CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      IF(TDLOCAL) THEN
        CALL GIVE_SCR_DDIPO(LLOCAL,TAG)
        LLOCAL=MAX(LLOCAL,2*NHG)
      ELSE
        LLOCAL=0
      ENDIF
      L_FOR=0
      IF(TFOR) THEN
        CALL GIVE_SCR_TD_FORCE(L_FOR,NSTATE,TAG)
      ENDIF
      IF(TINLC) THEN
        LLOCAL=MAX(LLOCAL,NHG)
      ENDIF
C
      LSPECTRA=MAX(LRHOOFR,LFORCES,LCANON,LRNLSM,
     *         LLR_DIAG,L_DIAG,LORTHO,LLOCAL)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RELAX_RHO(C0,C1,C2,SC0,RHOO,RHOE,PSI,NSTATE,NROOT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER    NSTATE,NROOT
      COMPLEX*16 C0(NGW,NSTATE),C1(NGW,NOLR,NROOT,NSTATE),C2(NGW,NSTATE)
      COMPLEX*16 SC0(*),PSI(*)
      REAL*8     RHOE(*),RHOO(*)
C     VARIABLES
      DIMENSION F(*)
      INTEGER  I
      REAL*8   R1MAT(*),RSUM0,RSUM1
      POINTER (IP_R1MAT,R1MAT)
C     ==--------------------------------------------------------------==
C     Check number of electrons
      RSUM0=0.D0
C$OMP parallel do private(I) shared(NNR1,RHOO)
C$OMP+ reduction(+:RSUM0)
      DO I=1,NNR1
        RSUM0=RSUM0+RHOO(I)
      ENDDO
      RSUM0=RSUM0*OMEGA/DBLE(NR1S*NR2S*NR3S)
C
      CALL MEMORY(IP_R1MAT,NSTATE*NSTATE,"R1MAT")
C     Z*C0
      CALL RHO1OFR(C0,C2,F,RHOE,PSI,NSTATE)
C     C0*C0
      CALL DAXPY(NNR1*NLSD,1.D0,RHOO,1,RHOE,1)
C     R1mat=x*x
      CALL OVLAP(NSTATE,R1MAT,C1(1,1,FSTATE,1),C1(1,1,FSTATE,1))
      IF(.NOT.TDA) THEN
        CALL OVLAP_ADD(NSTATE,R1MAT,C1(1,1,FSTATE,2),C1(1,1,FSTATE,2))
      ENDIF
      CALL GLOSUM(NSTATE*NSTATE,R1MAT)
C     c*R1mat
      CALL ROTATE(-1.D0,C0,0.D0,C2,R1MAT,NSTATE,2*NGW,TLSD,NSUP,NSDOWN)
      CALL FREEM(IP_R1MAT)
      IF(TLSD) THEN
        CALL DAXPY(NNR1,-1.D0,RHOE(NNR1+1),1,RHOE,1)
C       X*X alpha spin
        CALL RHOABOFR(NSUP,C1(1,1,FSTATE,1),C1(1,1,FSTATE,1),RHOE,PSI)
        IF(.NOT.TDA) THEN
          CALL RHOABOFR(NSUP,C1(1,1,FSTATE,2),
     &                       C1(1,1,FSTATE,2),RHOE,PSI)
        ENDIF
C       C-*C alpha spin
        CALL RHOABOFR(NSUP,C2(1,1),C0(1,1),RHOE,PSI)
C       X*X beta spin
        CALL RHOABOFR(NSDOWN,C1(1,NSUP+1,FSTATE,1),
     *                       C1(1,NSUP+1,FSTATE,1),RHOE(NNR1+1),PSI)
        IF(.NOT.TDA) THEN
          CALL RHOABOFR(NSDOWN,C1(1,NSUP+1,FSTATE,2),
     *                         C1(1,NSUP+1,FSTATE,2),RHOE(NNR1+1),PSI)
        ENDIF
C       C-*C beta spin
        CALL RHOABOFR(NSDOWN,C2(1,NSUP+1),C0(1,NSUP+1),RHOE(NNR1+1),PSI)
        CALL DAXPY(NNR1,1.D0,RHOE(NNR1+1),1,RHOE,1)
      ELSE
C       X*X
        CALL RHOABOFR(NSTATE,C1(1,1,FSTATE,1),C1(1,1,FSTATE,1),RHOE,PSI)
        IF(.NOT.TDA) THEN
          CALL RHOABOFR(NSTATE,C1(1,1,FSTATE,2),
     *                         C1(1,1,FSTATE,2),RHOE,PSI)
        ENDIF
C       C-*C
        CALL RHOABOFR(NSTATE,C2,C0,RHOE,PSI)
      ENDIF
C     Check number of electrons
      RSUM1=0.D0
C$OMP parallel do private(I) shared(NNR1,RHOE)
C$OMP+ reduction(+:RSUM1)
      DO I=1,NNR1
        RSUM1=RSUM1+RHOE(I)
      ENDDO
      RSUM1=RSUM1*OMEGA/DBLE(NR1S*NR2S*NR3S)
      CALL GLOSUM(1,RSUM0)
      CALL GLOSUM(1,RSUM1)
      IF (PARENT) THEN
         IF (ABS(RSUM0-RSUM1).GT.1.D-10) THEN
           WRITE(6,'(A)') 
     &      " WARNING : INTEGRAL OVER RELAXED DENSITY IS INCORRECT "
           WRITE(6,'(A,T46,F20.10)')
     &      " WARNING : GROUND STATE DENSITY",RSUM0
           WRITE(6,'(A,T46,F20.10)')
     &      " WARNING : RELAXED DENSITY",RSUM1
         ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PRINT_EX_RHO(RHOE,PSI,TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'pimd.inc'
C
C     Arguments
      REAL*8     RHOE(*),TAU0(*)
      COMPLEX*16 PSI(*)
C     Variables
      INTEGER    I,N1,N2,I1,I2
      COMPLEX*16 VTEMP(NHG)
      CHARACTER  FILEN*15
      CHARACTER*12 CFLBOD,CIPNUM
      POINTER    (IP_VTEMP,VTEMP)
C     ==--------------------------------------------------------------==
      call memory(ip_vtemp,2*NHG,'vtemp')
C
!$OMP parallel do private(I)
      DO I=1,NNR1
        PSI(I)=DCMPLX(RHOE(I),0.D0)
      ENDDO
      CALL FWFFT(PSI)
      DO I=1,NHG
        VTEMP(I) = PSI(NZH(I))
      ENDDO
      IF(TPATH) THEN
        IF(IPCURR.EQ.0) THEN
          FILEN='DENSITY_ES'
        ELSE
          CFLBOD='DENSITY_ES_'
          WRITE(CIPNUM,'(I4)') IPCURR
          CALL XSTRING(CFLBOD,N1,N2)
          CALL XSTRING(CIPNUM,I1,I2)
          FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
        ENDIF
      ELSE
        FILEN='DENSITY_ES'
      ENDIF
C
      call DENSTO(VTEMP,TAU0,FILEN)
C     ==--------------------------------------------------------------==
      CALL FREEM(ip_vtemp)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==========================================================
