C     ==================================================================
      SUBROUTINE LR_UPD(C0,C1,C2,SC0,E2,DDXC,PSI,EIGV,DRHOE,H1NL,
     &                  VPP,PME,GDE,SCR,LSCR,NSTATE,TYPE,ORBITAL,KNFI,
     &                  LDOFOR)
C     ==--------------------------------------------------------------==
C     ==               updates the wavefunctions                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'linres.inc'
C     ARGUMENTS
      COMPLEX*16 C0(NGWK,*),C1(NGWK,*),C2(NGWK,*),SC0(*)
      COMPLEX*16 H1NL(NGWK,*),PSI(*),PME(*),GDE(*)
      REAL*8     E2(5),EIGV(*),SCR(*),DRHOE(*),DDXC(*),VPP(*)
      INTEGER    LSCR,NSTATE,KNFI
      CHARACTER*(*) TYPE,ORBITAL
C     VARIABLES
      LOGICAL   LRESTA,LSAVE,FDIIS
      CHARACTER*30 TAG
      LOGICAL   LDOFOR
      REAL*8    DOTP
      EXTERNAL  DOTP
      INTEGER   I,IS,IG,LLR_UPD,ISHIST,ISM
      REAL*8    GEHIST(10),CNHIST(10),E4
      SAVE      GEHIST,CNHIST,ISHIST
      DATA      ISHIST /0/
      COMPLEX*16 CBACK(NGWK,*)
      POINTER   (IP_CBACK,CBACK)
      INTEGER   ISFIRST
      SAVE      ISFIRST,IP_CBACK,FDIIS
      DATA      ISFIRST /0/
C     ==--------------------------------------------------------------==
C     ==  calculate the force                                         ==
C     ==--------------------------------------------------------------==
      IF(ISFIRST.EQ.0) THEN
        CALL MEMORY(IP_CBACK,2*NGWK*NSTATE,'CBACK')
        ISFIRST=1
      ENDIF
      CALL GIVE_SCR_LR_UPD(LLR_UPD,TYPE,TAG)
      CALL TEST_SCR('LR_UPD',TAG,LSCR,LLR_UPD)
C     ==--------------------------------------------------------------==
      E4=E2(4)
 999  CONTINUE
      E2(4)=E4
      DO I=1,NSTATE
        E2(4)=E2(4)-2.0D0*DOTP(NGW,H1NL(1,I),C1(1,I))
      ENDDO
      IF(LDOFOR) THEN
        CALL LR_FORCE(C0,C1,C2,SC0,E2,DDXC,PSI,DRHOE,EIGV,
     &                SCR,LSCR,NSTATE,TYPE,ORBITAL)
        CALL GLOSUM(5,E2)
        CALL DAXPY(2*NGW*NSTATE,1.D0,H1NL,1,C2,1)
        IF(GEQ0) CALL ZCLEAN(C2,NSTATE,NGW)
        CALL LR_ORTHO(NSTATE,C0,C2,SCR,LSCR)
        CALL CSIZE(C2,NSTATE,GEMAX,CNORM)
        IF(GEMAX.LT.TOL_LR) CONVWF=.TRUE.
      ENDIF
C     ==--------------------------------------------------------------==
      ISHIST=ISHIST+1
      IS=MOD(ISHIST-1,10)+1
      GEHIST(IS)=GEMAX
      CNHIST(IS)=CNORM
      ISM=MOD(IS+10-2,10)+1
      LRESTA=.FALSE.
      IF(ISHIST.GT.1) THEN
        IF(10.D0*GEHIST(ISM).LT.GEMAX .AND.
     &     10.D0*CNHIST(ISM).LT.CNORM ) LRESTA=.TRUE.
      ENDIF
      ISM=MOD(IS+10-4,10)+1
      IF(ISHIST.GT.4) THEN
        IF(GEHIST(ISM).LT.GEMAX .AND.
     &     CNHIST(ISM).LT.CNORM ) LRESTA=.TRUE.
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  update the response functions                               ==
C     ==--------------------------------------------------------------==
      IF(LRESTA) THEN
        ISHIST=0
        CALL DCOPY(2*NGWK*NSTATE,CBACK,1,C1,1)
        SPCG=.TRUE.
        SDIIS=.TRUE.
        FDIIS=.TRUE.
        GOTO 999
      ELSEIF(.NOT.CONVWF) THEN
        IF(LOPTI.EQ.0) THEN
          IF(GEMAX.GT.THAUTO(1).OR.KNFI.GT.1) THEN
             CALL LR_PCG(C1,C2,VPP,PME,C0,DRHOE,DDXC,EIGV,SC0,PSI,
     &                   SCR,LSCR,NSTATE,SPCG)
             SDIIS=.TRUE.
             FDIIS=.TRUE.
          ELSEIF(GEMAX.GT.THAUTO(2)) THEN
             CALL ODIIS(C1,C2,VPP,NSTATE,PME,GDE,DLRS,SDIIS)
             SPCG=.TRUE.
             FDIIS=.TRUE.
          ELSE
             CALL ZDIIS(C1,C2,VPP,EIGV,NSTATE,PME,GDE,
     &                  DLRS,FDIIS,ORBITAL)
             SPCG=.TRUE.
             SDIIS=.TRUE.
          ENDIF
        ELSEIF(LOPTI.EQ.1) THEN
          DO IS=1,NSTATE
            DO IG=1,NGW
              C1(IG,IS)=C1(IG,IS)+DLRS*VPP(IG)*C2(IG,IS)
            ENDDO
          ENDDO
        ELSEIF(LOPTI.EQ.2) THEN
          CALL LR_PCG(C1,C2,VPP,PME,C0,DRHOE,DDXC,EIGV,SC0,PSI,
     &                SCR,LSCR,NSTATE,SPCG)
        ELSEIF(LOPTI.EQ.3) THEN
          CALL ODIIS(C1,C2,VPP,NSTATE,PME,GDE,DLRS,SDIIS)
        ENDIF
        CALL LR_ORTHO(NSTATE,C0,C1,SCR,LSCR)
      ELSE
        ISHIST=0
        FDIIS=.TRUE.
      ENDIF
      IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
      CONVWF= CONVWF .OR. EXSOFT
C     ==--------------------------------------------------------------==
      ISM=MIN(ISHIST,10)
      LSAVE=.TRUE.
      DO IS=1,ISM
        IF(CNHIST(IS).LT.CNORM*0.999D0) LSAVE=.FALSE.
      ENDDO
      IF(LSAVE) CALL DCOPY(2*NGWK*NSTATE,C1,1,CBACK,1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_LR_UPD(LLR_UPD,TYPE,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INTEGER LLR_UPD,LLR_FORCE,LLR_ORTHO
      CHARACTER*30 TAG
      CHARACTER*(*) TYPE
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_LR_FORCE(LLR_FORCE,TYPE,TAG)
      CALL GIVE_SCR_LR_ORTHO(LLR_ORTHO,N,TAG)
      LLR_UPD=MAX(LLR_FORCE,LLR_ORTHO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
