C     ==================================================================
      SUBROUTINE LR_XCPOT(DDXC,RHOE,SCR,LSCR,SWFUN)
C     ==--------------------------------------------------------------==
C     calculate the 2nd functional derivative of the exchange-
C     correlation potential used in perturbation theory
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'func.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'linres.inc'
C..arguments
      INTEGER LSCR
      REAL*8  RHOE(NNR1,NLSD),DDXC(NNR1,*),SCR(LSCR)
      LOGICAL SWFUN
C..variables
      INTEGER IR
      REAL*8 PADE_LDA
      REAL*8 SMALL,DENS
      PARAMETER (SMALL=1.D-14)
C     ==--------------------------------------------------------------==
      IF(TLSE.AND.TXC_ANALYTIC) THEN
        WRITE(6,*) 'LR_XCPOT: use XC_DD_ANALYTIC or numeric with LSE'
        CALL STOPGM('LR_XCPOT','ROKS not implemented')
      ENDIF
      IF(SWFUN) CALL SWITCH_FUNCTIONALS
      IF(TXC_ANALYTIC) THEN
        IF(MFXCC.EQ.0.AND.MFXCX.EQ.0.AND..NOT.TGC) THEN
          IF(TLSD) THEN
            CALL AZZERO(DDXC,3*NNR1)
          ELSE
            CALL AZZERO(DDXC,NNR1)
          ENDIF
        ELSEIF(MFXCC.EQ.9.AND.MFXCX.EQ.0.AND..NOT.TGC) THEN
          IF(TLSD) THEN
            CALL STOPGM('LR_XCPOT',
     *                'dmu/dn for this functional not available')
          ELSE
            DO IR=1,NNR1
              DENS=RHOE(IR,1)
              IF(TINLC) DENS=DENS+ROCT(IR)
              IF(DENS.LT.SMALL)THEN
                DDXC(IR,1)=0.D0
              ELSE
                DDXC(IR,1)=PADE_LDA(DENS,2)
              ENDIF
            ENDDO
          ENDIF
        ELSE
          CALL STOPGM('LR_XCPOT',
     *                'dmu/dn for this functional not available')
        END IF
      ELSEIF(LOPTI.EQ.0 .OR. LOPTI.EQ.2) THEN
C..this is needed for quadratic line search in PCG
        IF(TLSD) THEN
          CALL AZZERO(DDXC,3*NNR1)
        ELSE
          DO IR=1,NNR1
            DENS=RHOE(IR,1)
            IF(TINLC) DENS=DENS+ROCT(IR)
            IF(DENS.LT.SMALL)THEN
              DDXC(IR,1)=0.D0
            ELSE
              DDXC(IR,1)=PADE_LDA(DENS,2)
            ENDIF
          ENDDO
        ENDIF
      ENDIF
      IF(SWFUN) CALL SWITCH_FUNCTIONALS
C     ==--------------------------------------------------------------==
      RETURN
      END 
C     ==================================================================
      SUBROUTINE SWITCH_FUNCTIONALS
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tbxc.inc'
      INCLUDE 'func.inc'
      INCLUDE 'linres.inc'
      INTEGER IHOLD
      LOGICAL LHOLD
      REAL*8  RHOLD
C     ==--------------------------------------------------------------==
      IHOLD = TD_X
      TD_X  = MFXCX
      MFXCX = IHOLD
      IHOLD = TD_C
      TD_C  = MFXCC
      MFXCC = IHOLD
      IHOLD = TD_GX
      TD_GX = MGCX
      MGCX  = IHOLD
      IHOLD = TD_GC
      TD_GC = MGCC
      MGCC  = IHOLD
      IHOLD = TD_HF
      TD_HF = MHFX
      MHFX  = IHOLD
      IHOLD   = TD_MTAU
      TD_MTAU = MTAU
      MTAU    = IHOLD
      LHOLD   = TD_TGC
      TD_TGC  = TGC
      TGC     = LHOLD
      LHOLD   = TD_TGCX
      TD_TGCX = TGCX
      TGCX    = LHOLD
      LHOLD   = TD_TGCC
      TD_TGCC = TGCC
      TGCC    = LHOLD
      LHOLD   = TD_CODE
      TD_CODE = TOLDCODE
      TOLDCODE= LHOLD
      LHOLD   = TD_HYBRID
      TD_HYBRID  = THYBRID
      THYBRID = LHOLD
      RHOLD = TDPXLDA
      TDPXLDA = PXLDA
      PXLDA = RHOLD
      RHOLD = TDPCLDA
      TDPCLDA = PCLDA
      PCLDA = RHOLD
      RHOLD = TDPXGC
      TDPXGC = PXGC
      PXGC = RHOLD
      RHOLD = TDPCGC
      TDPCGC = PCGC
      PCGC = RHOLD
      RHOLD = TDPHFX
      TDPHFX = PHFX
      PHFX = RHOLD
      LHOLD   = TD_TTAU
      TD_TTAU = TTAU
      TTAU    = LHOLD
C     ==--------------------------------------------------------------==
      RETURN
      END 
C     ==================================================================
