C     ==================================================================
      SUBROUTINE MDCLAS(C0,CM,C2,SC0,GAMX,GAMY)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'store.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'temps.inc'
      INCLUDE 'comvel.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      COMPLEX*16 C0(NGW,*),CM(NGW,*),C2(NGW,*),SC0(NGW,*)
      REAL*8     GAMX(*),GAMY(*)
C     Variables
      DIMENSION  F(*)
      CHARACTER  FILEN*100
      LOGICAL    FERROR
      REAL*8     TAUI(3,NAX,NSX),TAUR(3,NAX,NSX),EIGV(*),EIGM(*)
      POINTER    (IP_TAUI,TAUI), (IP_TAUR,TAUR),
     *           (IP_EIGV,EIGV),(IP_EIGM,EIGM)
      COMPLEX*16 PSI(NNR1,NLSD)
      REAL*8     RHOE(NNR1,NLSD),SCR(*),TAUIO(3,*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR),
     &    (IP_TAUIO,TAUIO)
      CHARACTER  TAG*30
      REAL*8     TIME1,TIME2,TIMEF,TEMP1,TEMP2,TCPU,TEMPP,DUMMY,FF,
     &           EKIN1,EKIN2,EKINC,EKINP,EKINCP,DISA,ENOSE,ENOSP,
     &           ECONS,EHAM,EKINH1,EKINH2,EKINCM,EKINQM,
     &           EXTWORK,EINT,ALFAP,VCMIO(4),LMIO(3)
      EXTERNAL   TIMEF
      INTEGER    IREC(100),I,NSTATE,NC,NQ,IA,IS,IC,J,
     &           IL_RHOE,IL_PSI,LSCR,ITEMP
      LOGICAL    UPDATE
C     ==================================================================
      TIME1 = TIMEF()
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TAUI,3*NAX*NSX,'TAUI')
      CALL MEMORY(IP_TAUR,3*NAX*NSX,'TAUR')
      IF(TSUBROT) CALL MEMORY(IP_TAUIO,3*NAT,'TAUIO')
      NSTATE=N
      NACC = 22
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=TPRES
      CALSTC=TPREC
      IF(TIVAN.OR.NONORT) THEN
        CALL MEMORY(IP_EIGV,NSTATE,'EIGV')
        CALL MEMORY(IP_EIGM,NSTATE*NSTATE,'EIGM')
      ENDIF
      IF(THARM.AND.PARENT) THEN
        FF=F(1)
        DO I=1,NSTATE
          IF(FF.NE.F(I)) THEN
            WRITE(6,'(A,A)') ' HARMONIC REFERENCE SYSTEM INTEGRATION',
     *             ' ONLY POSSIBLE WITH EQUAL OCCUPATION NUMBERS'
            CALL STOPGM('MDCLAS',' ')
          ENDIF
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL GIVE_SCR_MDMAIN(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
C     PARAMETERS FOR THE NOSE-HOOVER THERMOSTATS
      IF((TNOSEE.OR.TNOSEP).AND.PARENT) CALL NOSEPA(1,1)
C     ==--------------------------------------------------------------==
C     == INITIALIZATION                                               ==
C     ==--------------------------------------------------------------==
      CALL INITRUN(IREC,C0,CM,SC0,RHOE,PSI,EIGV,SCR,LSCR)
      CALL Q_COOR('GET',TAU0,VELP)
C     ==--------------------------------------------------------------==
C     INITIALIZE VELOCITIES
      IF(PARENT) CALL DETDOF(TAU0,TAUR)
      IF(IREC(IREC_VEL).EQ.0.AND..NOT.RGEO) THEN
        CALL ZAZZERO(CM,NGW*NSTATE)
        ECNSTR = 0.0D0
        ERESTR = 0.0D0
        CALL INIT_VELOCITIES
        IF(MCNSTR.GT.0) THEN
          CALL Q_COOR('PUT',TAU0,VELP)
          IF(PARENT) CALL RATTLE(TAU0,VELP)
          CALL Q_COOR('GET',TAU0,VELP)
        ENDIF
      ENDIF
      IF(QUENCHP) THEN
        CALL AZZERO(VELP,3*NAX*NSX)
        CALL AZZERO(CLASV,3*NCLATOM)
      ENDIF
      IF(QUENCHE) CALL AZZERO(CM,2*NGW*NSTATE)
C     RESET ACCUMULATORS
      IF(PARENT.AND.IREC(IREC_AC).EQ.0) CALL RESETAC(TAU0,TAUI,NFI)
      IF(QUENCHB) THEN
        CALL QUENBO(C0,C2,SC0,TAUR,RHOE,PSI,SCR,LSCR)
        CALL ZHWWF(2,IREC,C0,CM,NSTATE,EIGV,TAU0,VELP,TAUI,NFI)
        QUENCHB=.FALSE.
      ENDIF
      IF(TIVAN) THEN
        IF(TLSD) THEN
          CALL DEORT(NGW,NSUP,EIGM,EIGV,C0(1,1),SC0(1,1),SCR,LSCR)
          CALL DEORT(NGW,NSDOWN,EIGM,EIGV,C0(1,NSUP+1),SC0(1,NSUP+1),
     *               SCR,LSCR)
        ELSE
          CALL DEORT(NGW,NSTATE,EIGM,EIGV,C0,SC0,SCR,LSCR)
        ENDIF
      ENDIF
C     INITIALIZE FORCES
      IF(TFREEZE) THEN
        CALL AZZERO(FION,3*NAX*NSX)
      ELSE
        CALL Q_COOR('PUT',TAU0,VELP)
        IF(GEQ0) CALL ZCLEAN(C0,NSTATE,NGW)
        CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               NSTATE,1,.FALSE.,.TRUE.)
        CALL FREQS(N,.TRUE.)
C     Check orthogonality condition for wavefunction velocities
        CALL RORTV(C0,CM,C2,SC0,GAMY,NSTATE,SCR,LSCR)
      ENDIF
      UPDATE=.TRUE.
      CALL CLAS_FORCE(EEXT,UPDATE,EINT)
c     rmdebug
c     we save the classical force on quantum atoms to CLASFOLD
      DO IC=1,NCLTYP
        IS=IS_QM(IC)
        IF(IS.GT.0) THEN
          J=NCRANG(1,IC)-1
          DO IA=1,NA(IS)
            CLASFOLD(1,J+IA)=CLASF(1,J+IA)
            CLASFOLD(2,J+IA)=CLASF(2,J+IA)
            CLASFOLD(3,J+IA)=CLASF(3,J+IA)
          ENDDO
        ENDIF
      ENDDO
c     rmdebug
      CALL ADD_QM_FORCE(FION)
C     Initialize thermostats
      IF(PARENT) THEN
        ITEMP=IREC(IREC_NOP1)+IREC(IREC_NOP2)+IREC(IREC_NOP3)
     *        +IREC(IREC_NOP4)
        IF(TNOSEP .AND. ITEMP.EQ.0) CALL NOSPINIT(1)
        IF(TNOSEE .AND. IREC(IREC_NOE) .EQ.0) CALL NOSEINIT(1)
        CALL WRGEOF(TAU0,FION)
        IF(TWCOOR.AND.PARENT) CALL WR_CLASSIC
        FILEN='ENERGIES'
        CALL FILEOPEN(3,FILEN,FO_APP+FO_VERB+FO_MARK,FERROR)
        FILEN='TEMPERATURES'
        CALL FILEOPEN(15,FILEN,FO_APP+FO_VERB+FO_MARK,FERROR)
      ENDIF
C     determine the number of classical and quantum atoms
      NC=0
      NQ=0
      DO IS=1,NCLTYP
        DO IA=NCRANG(1,IS),NCRANG(2,IS)
          IF(IS_QM(IS).EQ.0) THEN
            NC=NC+1
          ELSE
            NQ=NQ+1
          ENDIF
        ENDDO
      ENDDO
      IF((NC+NQ).NE.NCLATOM) CALL STOPGM('MDCLAS','(NC+NQ).NE.NCLATOM')
      CALL WRITE_IREC(IREC)
c     rmdebug
      EXTWORK=0.D0
c     rmdebug
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,T50,F8.2,A8)') ' TIME FOR INITIALIZATION:',
     *                        TCPU,' SECONDS'
      ENDIF
C     ==================================================================
C     ==          THE BASIC LOOP FOR MOLECULAR DYNAMICS               ==
C     ==                 USING VELOCITY VERLET                        ==
C     ==================================================================
      DO INFI=1,NOMORE
        CALL MY_SYNC(ALLGRP)
        TIME1=TIMEF()
        NFI=NFI+1
        PRTEIG=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
        CALDIP=TDIPD.AND.MOD(NFI-1,NPDIP).EQ.0
        SUBCOM=TSUBCOM.AND.MOD(NFI-1,NCOMV).EQ.0
        SUBROT=TSUBROT.AND.MOD(NFI-1,NROTV).EQ.0
        IF(.NOT.PARENT) PRTEIG=.FALSE.
        ENGPRI=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
C       UPDATE NOSE THERMOSTATS
        IF(.NOT.TFREEZE) THEN
          CALL Q_COOR('PUT',TAU0,VELP)
          CALL ANNEAL(VELP,CM,NSTATE,SCR)
          CALL BERENDSEN(VELP,CM,NSTATE,SCR,EKINC,0.0D0)
C     SUBTRACT CENTER OF MASS VELOCITY
          IF(SUBCOM) CALL COMVEL(VELP,VCMIO,.TRUE.)
C     SUBTRACT ROTATION AROUND CENTER OF MASS
          IF(SUBROT) CALL ROTVEL(TAU0,VELP,LMIO,TAUIO,.TRUE.)
C     UPDATE NOSE THERMOSTATS
          CALL NOSEUP(VELP,CM,NSTATE,1)
          IF(ANNEI) THEN
            ALFAP=ANNERI**(0.25D0)
            DO IS=1,NCLTYP
              DO IA=NCRANG(1,IS),NCRANG(2,IS)
                CLASV(1,IA)=ALFAP*CLASV(1,IA)
                CLASV(2,IA)=ALFAP*CLASV(2,IA)
                CLASV(3,IA)=ALFAP*CLASV(3,IA)
              ENDDO
            ENDDO
          ENDIF
          CALL Q_COOR('GET',TAU0,VELP)
        ENDIF
C       UPDATE VELOCITIES
        DO IS=1,NCLTYP
          IF(.NOT.TFREEZE.OR.IS_QM(IS).EQ.0) THEN
            DO IA=NCRANG(1,IS),NCRANG(2,IS)
               CLASV(1,IA)=CLASV(1,IA)+CSTEP(IS)*CLASF(1,IA)
               CLASV(2,IA)=CLASV(2,IA)+CSTEP(IS)*CLASF(2,IA)
               CLASV(3,IA)=CLASV(3,IA)+CSTEP(IS)*CLASF(3,IA)
            ENDDO
          ENDIF
        ENDDO
        IF(.NOT.TFREEZE) CALL VELUPA(C0,CM,C2,NSTATE,1)
C       UPDATE POSITIONS
        CALL Q_COOR('PUT',TAU0,VELP)
        ECNSTR = 0.0D0
        DO IS=1,NCLTYP
          IF(.NOT.TFREEZE.OR.IS_QM(IS).EQ.0) THEN
            DO IA=NCRANG(1,IS),NCRANG(2,IS)
              CLASC(1,IA)=CLASC(1,IA)+DT_IONS*CLASV(1,IA)
              CLASC(2,IA)=CLASC(2,IA)+DT_IONS*CLASV(2,IA)
              CLASC(3,IA)=CLASC(3,IA)+DT_IONS*CLASV(3,IA)
c  
              DELCLASC(1,IA)=DT_IONS*CLASV(1,IA)
              DELCLASC(2,IA)=DT_IONS*CLASV(2,IA)
              DELCLASC(3,IA)=DT_IONS*CLASV(3,IA)
c 
            ENDDO
          ENDIF
        ENDDO
        CALSTC=TPREC.AND.MOD(NFI-1,NPREC).EQ.0
        IF(TFREEZE) THEN
          CALL AZZERO(FION,3*NAX*NSX)
        ELSE
          CALL Q_COOR('PUT',TAUP,VELP)
          IF(MCNSTR.NE.0) THEN
            IF(PARENT) CALL CPMDSHAKE(TAU0,TAUP,VELP)
            CALL Q_COOR('GET',TAUP,VELP)
          ENDIF
          CALL PHFAC(TAUP)
          IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,CALSTE)
          CALL POSUPA(C0,CM,C2,GAMX,NSTATE,SCR,LSCR)
C..Dipole moment
          IF(CALDIP) THEN
            CALL DDIPO(TAUP,C0,CM,C2,SC0,SCR,LSCR,NSTATE)
            CALL WANNIER_PRINT(NFI,C0,TAUP,NSTATE,PSI,SCR,LSCR)
          ENDIF
C       CALCULATE THE FORCES
          CALSTE=TPRES.AND.MOD(NFI-1,NPRES).EQ.0
          CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAUP,FION,EIGV,SCR,LSCR,
     *                 NSTATE,1,.FALSE.,.TRUE.)
          IF(CALSTE) CALL TOTSTR
        ENDIF
C        we have to check whether the Verlet list need to be updated
        CALL CHECK(UPDATE)
c     
c     we calculate a contribution to external work on the cluster
      DO IC=1,NCLTYP
        IS=IS_QM(IC)
        IF(IS.GT.0) THEN
          J=NCRANG(1,IC)-1
          DO IA=1,NA(IS)
            EXTWORK=EXTWORK+CLASFOLD(1,J+IA)*DELCLASC(1,J+IA)/2.D0
            EXTWORK=EXTWORK+CLASFOLD(2,J+IA)*DELCLASC(2,J+IA)/2.D0
            EXTWORK=EXTWORK+CLASFOLD(3,J+IA)*DELCLASC(3,J+IA)/2.D0
          ENDDO
        ENDIF
      ENDDO
        CALL CLAS_FORCE(EEXT,UPDATE,EINT)
c  
c     we calculate a contribution to external work on the cluster
      DO IC=1,NCLTYP
        IS=IS_QM(IC)
        IF(IS.GT.0) THEN
          J=NCRANG(1,IC)-1
          DO IA=1,NA(IS)
            EXTWORK=EXTWORK+CLASF(1,J+IA)*DELCLASC(1,J+IA)/2.D0
            EXTWORK=EXTWORK+CLASF(2,J+IA)*DELCLASC(2,J+IA)/2.D0
            EXTWORK=EXTWORK+CLASF(3,J+IA)*DELCLASC(3,J+IA)/2.D0
          ENDDO
        ENDIF
      ENDDO
c     WRITE(17,*)EXTWORK
c     we save the classical force on quantum atoms to CLASFOLD
      DO IC=1,NCLTYP
        IS=IS_QM(IC)
        IF(IS.GT.0) THEN
          J=NCRANG(1,IC)-1
          DO IA=1,NA(IS)
            CLASFOLD(1,J+IA)=CLASF(1,J+IA)
            CLASFOLD(2,J+IA)=CLASF(2,J+IA)
            CLASFOLD(3,J+IA)=CLASF(3,J+IA)
          ENDDO
        ENDIF
      ENDDO
      CALL ADD_QM_FORCE(FION)
C     ==================================================================
C     Damped Dynamics
      CALL DAMPDYN(VELP,FION,CM,C2,NSTATE,SCR(1),SCR(10))
C     ==================================================================
C     FINAL UPDATE FOR VELOCITIES
      DO IS=1,NCLTYP
        IF(.NOT.TFREEZE.OR.IS_QM(IS).EQ.0) THEN
          DO IA=NCRANG(1,IS),NCRANG(2,IS)
             CLASV(1,IA)=CLASV(1,IA)+CSTEP(IS)*CLASF(1,IA)
             CLASV(2,IA)=CLASV(2,IA)+CSTEP(IS)*CLASF(2,IA)
             CLASV(3,IA)=CLASV(3,IA)+CSTEP(IS)*CLASF(3,IA)
          ENDDO
        ENDIF
      ENDDO
      IF(.NOT.TFREEZE) THEN
        CALL VELUPA(C0,CM,C2,NSTATE,1)
        CALL Q_COOR('PUT',TAU0,VELP)
        IF(MCNSTR.NE.0) THEN
          CALL RATTLE(TAU0,VELP)
          CALL Q_COOR('GET',TAU0,VELP)
        ENDIF
        CALL RORTV(C0,CM,C2,SC0,GAMY,NSTATE,SCR,LSCR)
      ENDIF
      IF(PARENT) CALL GEOFILE(TAU0,VELP,'WRITE')
C     COMPUTE THE IONIC TEMPERATURE TEMPP
      CALL EKINCL(EKINP,EKINCM,EKINQM)
      TEMPP=EKINP*FACTEM*2.D0/(3*NCLATOM-3)
C     IONIC TEMPERATURE CONTROL
      CALL TEMP_CONTROL(TEMP1,TEMP2,TEMPP)
      IF(TDEFO.AND.MOD(NFI,NDEFO).EQ.0) THEN 
        CALL DEFORMATION 
      ENDIF
C       UPDATE NOSE THERMOSTATS
        IF(TNOSEE.OR.TC) CALL REKINE(CM,NSTATE,EKINC)
        IF(.NOT.TFREEZE) THEN
          CALL Q_COOR('PUT',TAU0,VELP)
          CALL NOSEUP(VELP,CM,NSTATE,1)
C     SUBTRACT ROTATION AROUND CENTER OF MASS
          IF(SUBROT) CALL ROTVEL(TAU0,VELP,LMIO,TAUIO,.FALSE.)
C     SUBTRACT CENTER OF MASS VELOCITY
          IF(SUBCOM) CALL COMVEL(VELP,VCMIO,.FALSE.)
          CALL ANNEAL(VELP,CM,NSTATE,SCR)
          CALL BERENDSEN(VELP,CM,NSTATE,SCR,EKINC,0.0D0)
          IF(ANNEI) THEN
            ALFAP=ANNERI**(0.25D0)
            DO IS=1,NCLTYP
              DO IA=NCRANG(1,IS),NCRANG(2,IS)
                CLASV(1,IA)=ALFAP*CLASV(1,IA)
                CLASV(2,IA)=ALFAP*CLASV(2,IA)
                CLASV(3,IA)=ALFAP*CLASV(3,IA)
              ENDDO
            ENDDO
          ENDIF
          CALL Q_COOR('GET',TAU0,VELP)
          CALL EKINCL(EKINP,EKINCM,EKINQM)
          TEMPP=EKINP*FACTEM*2.D0/(3*NCLATOM-3)
          TEMPCM=EKINCM*FACTEM*2.D0/(3*NC)
          TEMPQM=EKINQM*FACTEM*2.D0/(3*NQ)
C       RESCALE ELECTRONIC VELOCITIES
          IF(TC) CALL RSCVE(EKIN1,EKIN2,EKINC,EKINW,CM,NSTATE,NGW)
C       KINETIC ENERGY OF THE ELECTRONS
          CALL REKINE(CM,NSTATE,EKINC)
C       ENERGY OF THE NOSE THERMOSTATS
          IF(PARENT) CALL NOSENG(NFI,VELP,ENOSE,ENOSP,DUMMY,1)
        ELSE
          ENOSE=0.D0
          ENOSP=0.D0
          EKINC=0.D0
          CALL EKINCL(EKINP,EKINCM,EKINQM)
          TEMPP=EKINP*FACTEM*2.D0/(3*NCLATOM-3)
          TEMPCM=EKINCM*FACTEM*2.D0/(3*NC)
          TEMPQM=EKINQM*FACTEM*2.D0/(3*NQ)
        ENDIF
C       MEAN SQUARE DISPLACEMENT OF DIFFERENT IONIC SPECIES
        IF(PARENT) CALL DISPP(TAU0,TAUI,DISA)
        IF(PARENT) THEN
          ECONS=EKINP+ETOT+ENOSE+ENOSP+ECNSTR+EEXT
          EHAM=ECONS+EKINC
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
C         PRINTOUT the evolution of the accumulators every time step
         WRITE(16,789)EKINQM,EKINQM+ETOT,EEXT
     *                          ,EINT,EXTWORK 
789       FORMAT(5(F12.6,2X))
          IF(TFREEZE) ENGPRI=.FALSE.
          CALL WRPRINT_MD(EIGV,F,AMU,NSTATE,TAU0,FION,
     &                    EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,
     &                    TCPU,.FALSE.,NFI,INFI)
C         UPDATE ACCUMULATORS
          CALL PACCA(EKINC,TEMPP,ETOT,ECONS,EHAM,ENOSE,ENOSP,ECNSTR,
     *               ERESTR,DISA,TCPU,NFI,1)
C         Store ionic coordinates and velocities for statistics
c         MOVIE=MOD(NFI-1,IMOVIE).EQ.0
          MOVIE=TMOVC.AND.MOD(NFI-1,IMOVC).EQ.0
          RPRINT=ROUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TXYZ=XTOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TDCD=DCOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          CALL PRINTP(TAUR,TAU0,VELP)
c
          CPRINT=TFTRA.AND.MOD(NFI-1,NTRAC).EQ.0
          IF(TFTRA.OR.TMOVC) CALL WR_CLTRA
c         IF(CPRINT)CALL WR_CLTRA
c
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(INFI.EQ.NOMORE) THEN
          EXSOFT=.TRUE.
          EXNOMORE=.TRUE.
        ENDIF
        IF(MOD(NFI,ISTORE).EQ.0.OR.INFI.EQ.NOMORE.OR.EXSOFT) 
     *    CALL ZHWWF(2,IREC,C0,CM,NSTATE,EIGV,TAU0,VELP,TAUI,NFI)
C     temperature ramping
        CALL TEMPRAMP(TEMP1,TEMP2)
C       STOP THE RUN IF THE USER HAS SET THE SIGNAL 30
        IF(EXSOFT) GOTO 100
C     ==================================================================
C     ==     END OF MAIN LOOP                                         ==
C     ==================================================================
      ENDDO
  100 CONTINUE
      IF(RHOOUT.AND. .NOT.TFREEZE) 
     *     CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPNT)
C     PRINT ACCUMULATOR
      IF(PARENT) CALL PACCA(EKINC,TEMPP,ETOT,ECONS,EHAM,ENOSE,ENOSP,
     &                      ECNSTR,ERESTR,DISA,TCPU,NFI,2)
      IF(.NOT.TFREEZE) THEN
        CALL PROJA(C0,C2,SC0,SCR,LSCR,NSTATE,IPROJ)
        CALL CSIZE(C2,N,GEMAX,CNORM)
      ENDIF
      IF(PARENT) CALL GSIZE(FION,GNMAX,GNORM)
      IF(PARENT) CALL FINALP(TAU0,FION,VELP,EIGV)
c
      IF(TWCOOR.AND.PARENT)CALL WR_CLASSIC
c
      IF(TIVAN.OR.NONORT) THEN
        CALL FREEM(IP_EIGV)
        CALL FREEM(IP_EIGM)
      ENDIF
      IF(PARENT) THEN 
        CALL FILECLOSE(3)
        CALL FILECLOSE(15)
      ENDIF
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
      IF(TSUBROT) CALL FREEM(IP_TAUIO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE Q_COOR(TAG,TAU0,VELP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'
      INCLUDE 'ions.inc'
C     Arguments
      CHARACTER TAG*3
      REAL*8    TAU0(3,NAX,NSX),VELP(3,NAX,NSX)
C     Variables
      INTEGER   IC,IS,J,IA
#ifdef PARALLEL
      INTEGER   MSGLEN
#endif
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      MSGLEN = 3*NAX*NSX * 8
      CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 3*NAX*NSX * 8
      CALL MY_BCAST(VELP,MSGLEN,SOURCE,ALLGRP)
#endif
      IF(TAG.EQ.'PUT') THEN
        DO IC=1,NCLTYP
          IS=IS_QM(IC)
          IF(IS.GT.0) THEN
            J=NCRANG(1,IC)-1
            DO IA=1,NA(IS)
              TAU0(1,IA,IS)=CLASC(1,J+IA)
              TAU0(2,IA,IS)=CLASC(2,J+IA)
              TAU0(3,IA,IS)=CLASC(3,J+IA)
              VELP(1,IA,IS)=CLASV(1,J+IA)
              VELP(2,IA,IS)=CLASV(2,J+IA)
              VELP(3,IA,IS)=CLASV(3,J+IA)
            ENDDO
          ENDIF
        ENDDO
      ELSEIF(TAG.EQ.'GET') THEN
        DO IC=1,NCLTYP
          IS=IS_QM(IC)
          IF(IS.GT.0) THEN
            J=NCRANG(1,IC)-1
            DO IA=1,NA(IS)
              CLASC(1,J+IA)=TAU0(1,IA,IS)
              CLASC(2,J+IA)=TAU0(2,IA,IS)
              CLASC(3,J+IA)=TAU0(3,IA,IS)
              CLASV(1,J+IA)=VELP(1,IA,IS)
              CLASV(2,J+IA)=VELP(2,IA,IS)
              CLASV(3,J+IA)=VELP(3,IA,IS)
            ENDDO
          ENDIF
        ENDDO
      ELSE
        CALL STOPGM('Q_COOR','WRONG TAG')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ADD_QM_FORCE(FION)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'
      INCLUDE 'ions.inc'
C     Arguments
      REAL*8  FION(3,NAX,NSX)
C     Variables
      INTEGER IC,IS,J,IA
#ifdef PARALLEL
      INTEGER MSGLEN
#endif
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      MSGLEN = 3*NAX*NSX * 8
      CALL MY_BCAST(FION,MSGLEN,SOURCE,ALLGRP)
#endif
      DO IC=1,NCLTYP
        IS=IS_QM(IC)
        IF(IS.GT.0) THEN
          J=NCRANG(1,IC)-1
          DO IA=1,NA(IS)
            CLASF(1,J+IA)=CLASF(1,J+IA)+FION(1,IA,IS)
            CLASF(2,J+IA)=CLASF(2,J+IA)+FION(2,IA,IS)
            CLASF(3,J+IA)=CLASF(3,J+IA)+FION(3,IA,IS)
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE INIT_VELOCITIES
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'metr.inc'
C     Variables
      INTEGER    IS,IA
      REAL*8     SEED,RNR(3),ALFA1,ALFA2,ALFA3,VCM(3),VSCALE,TSCAL,
     *           EKINP,TEMPP,SIGMA,PMA00,EKINCM,EKINQM
#ifdef PARALLEL
      INTEGER    MSGLEN
#endif
C     ==--------------------------------------------------------------==
C     Initialize Cell velocities
      CALL AZZERO(HTVEL,9)
C     MAXWELL DISTRIBUTION FOR THE IONS
      IF(PARENT) THEN
        SEED=135792468.0D0
        IF(TEMPW.LT.1.D-5) GOTO 100
        CALL DURAND(SEED,3,RNR)
        DO IS=1,NCLTYP
          SIGMA=DSQRT(TEMPW/(CLMAS(IS)*FACTEM*SCMASS))
          IF(.NOT.TFREEZE.OR.IS_QM(IS).EQ.0) THEN
            DO IA=NCRANG(1,IS),NCRANG(2,IS)
              CALL DURAND(SEED,3,RNR)
              ALFA1=2.0D0*PI*RNR(1)
              ALFA2=2.0D0*PI*RNR(2)
              ALFA3=2.0D0*PI*RNR(3)
              CALL DURAND(SEED,3,RNR)
              CLASV(1,IA)=SQRT(LOG(RNR(1))*(-2.0D0))*COS(ALFA1)*SIGMA
              CLASV(2,IA)=SQRT(LOG(RNR(2))*(-2.0D0))*COS(ALFA2)*SIGMA
              CLASV(3,IA)=SQRT(LOG(RNR(3))*(-2.0D0))*COS(ALFA3)*SIGMA
            ENDDO
          ENDIF
        ENDDO
C       SUBTRACT CENTER OF MASS VELOCITY
        VCM(1)=0.0D0
        VCM(2)=0.0D0
        VCM(3)=0.0D0
        PMA00=0.D0
        DO IS=1,NCLTYP
          IF(.NOT.TFREEZE.OR.IS_QM(IS).EQ.0) THEN
            DO IA=NCRANG(1,IS),NCRANG(2,IS)
              VCM(1)=VCM(1)+CLASV(1,IA)*CLMAS(IS)
              VCM(2)=VCM(2)+CLASV(2,IA)*CLMAS(IS)
              VCM(3)=VCM(3)+CLASV(3,IA)*CLMAS(IS)
              PMA00=PMA00+CLMAS(IS)
            ENDDO
          ENDIF
        ENDDO
        DO IS=1,NCLTYP
          IF(.NOT.TFREEZE.OR.IS_QM(IS).EQ.0) THEN
            DO IA=NCRANG(1,IS),NCRANG(2,IS)
              CLASV(1,IA)=CLASV(1,IA)-VCM(1)/PMA00
              CLASV(2,IA)=CLASV(2,IA)-VCM(2)/PMA00
              CLASV(3,IA)=CLASV(3,IA)-VCM(3)/PMA00
            ENDDO
          ENDIF
        ENDDO
C       RESCALE VELOCITIES
        CALL EKINCL(EKINP,EKINCM,EKINQM)
        TEMPP=EKINP*FACTEM*2.D0/DBLE(3*NCLATOM-3)
        IF(TEMPP.GT.1.D-5) THEN
          TSCAL=TEMPW/TEMPP
          VSCALE=DSQRT(TSCAL)
          DO IA=1,NCLATOM
            CLASV(1,IA)=CLASV(1,IA)*VSCALE
            CLASV(2,IA)=CLASV(2,IA)*VSCALE
            CLASV(3,IA)=CLASV(3,IA)*VSCALE
          ENDDO
        ENDIF
  100   CONTINUE
      ENDIF
#ifdef PARALLEL
      MSGLEN = 3*NCLATOM * 8
      CALL MY_BCAST(CLASV,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE EKINCL(EKINP,EKINCM,EKINQM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'clas.inc'
C     Arguments
      REAL*8  EKINP,EKINCM,EKINQM
C     Variables
      REAL*8  CONST,EKIN
      INTEGER IS,IA
C     ==--------------------------------------------------------------==
C     ==  CALCULATE KINETIC ENERGY OF THE IONS                        ==
C     ==--------------------------------------------------------------==
      EKINP=0.D0
      EKINCM=0.D0
      EKINQM=0.D0
      DO IS=1,NCLTYP
        CONST=0.5D0*CLMAS(IS)*SCMASS
        EKIN=0.D0
        DO IA=NCRANG(1,IS),NCRANG(2,IS)
          EKIN=EKIN+CONST*CLASV(1,IA)*CLASV(1,IA)
          EKIN=EKIN+CONST*CLASV(2,IA)*CLASV(2,IA)
          EKIN=EKIN+CONST*CLASV(3,IA)*CLASV(3,IA)
        ENDDO
        IF(IS_QM(IS).EQ.0) THEN
          EKINCM=EKINCM+EKIN
        ELSE
          EKINQM=EKINQM+EKIN
        ENDIF
      ENDDO
      EKINP=EKINCM+EKINQM
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DEFORMATION 
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'
      INCLUDE 'ions.inc'
C     Variables
      INTEGER IC,IS,J,IA
C     ==--------------------------------------------------------------==
      DO IC=1,NCLTYP
        IS=IS_QM(IC)
        IF(IS.GT.0) THEN
          J=NCRANG(1,IC)-1
          DO IA=1,NA(IS)
            CLASC(1,J+IA)=XCEN+EXPX*(CLASC(1,J+IA)-XCEN)
            CLASC(2,J+IA)=YCEN+EXPY*(CLASC(2,J+IA)-YCEN)
            CLASC(3,J+IA)=ZCEN+EXPZ*(CLASC(3,J+IA)-ZCEN)
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TEMP_CONTROL(TEMP1,TEMP2,TEMPP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'
C     Arguments
      REAL*8  TEMP1,TEMP2,TEMPP
C     Variables
      REAL*8  ALFAP
      INTEGER IS,IA
C     ==--------------------------------------------------------------==
C     ==  Dynamical rescaling factor (tempw/tempp), where tempp is    ==
C     ==  calculated every step                                       ==
C     ==--------------------------------------------------------------==
      IF(TCP) THEN
        IF(TEMPP.GT.TEMP1.OR.TEMPP.LT.TEMP2.AND.TEMPP.NE.0.D0) THEN
          ALFAP=DSQRT(TEMPW/TEMPP)
          DO IS=1,NCLTYP
            DO IA=NCRANG(1,IS),NCRANG(2,IS)
              CLASV(1,IA)=ALFAP*CLASV(1,IA)
              CLASV(2,IA)=ALFAP*CLASV(2,IA)
              CLASV(3,IA)=ALFAP*CLASV(3,IA)
            ENDDO
          ENDDO
        END IF
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WR_CLASSIC
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'
C     Variables
      INTEGER IS,IA,K
C     ==--------------------------------------------------------------==
      WRITE(6,'(/,1X,64("*"))')
      WRITE(6,'(22X,A)') ' ATOMIC COORDINATES'
      DO IS=1,NCLTYP
        DO IA=NCRANG(1,IS),NCRANG(2,IS)
          WRITE(6,'(I5,3X,A4,3X,I5,3F15.6)')
     *         IA,CLAB(IS),IS_QM(IS),(CLASC(K,IA),K=1,3)
        ENDDO
      ENDDO
      WRITE(6,'(1X,64("*"),/)')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WR_CLTRA
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ropt.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'movi.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'fileopen.inc'
      LOGICAL FERROR
      CHARACTER*100 FNTRJ,FNMOV
cmdebug
      real*4 ccx,ccy,ccz,vcx,vcy,vcz
cmdebug
      INTEGER IFIT,IFIM,IS,I,IA,IE,IZ0,IAT
      SAVE IFIT,IFIM
      DATA IFIT,IFIM /0,0/
C     ==--------------------------------------------------------------==
      FNTRJ='CLASSIC'
cmdebug classical trajectory written independently from 
cmdebug QM trajectory (===> better for freeze quantum cases) 
      IF(CPRINT) THEN
        IF(IFIT.EQ.0) THEN
          CALL FILEOPEN(4,FNTRJ,FO_APP+FO_UFO+FO_VERB,FERROR)
          IFIT=1
        ELSE
          CALL FILEOPEN(4,FNTRJ,FO_APP+FO_UFO,FERROR)
        ENDIF
        DO IS=1,NCLTYP
          DO IA=NCRANG(1,IS),NCRANG(2,IS)
cmdebug            WRITE(4,'(I7,6(2X,F14.6))')
            ccx=CLASC(1,IA)
            ccy=CLASC(2,IA)
            ccz=CLASC(3,IA)
            vcx=CLASV(1,IA)
            vcy=CLASV(2,IA)
            vcz=CLASV(3,IA)
cmdebug     *                NFI,(CLASC(I,IA),I=1,3),(CLASV(I,IA),I=1,3)
            WRITE(4)
     *      ccx,ccy,ccz,vcx,vcy,vcz 
          ENDDO
        ENDDO
        CALL FILECLOSE(4)
cmdebug
      ENDIF
cmdebug
C
      FNMOV='CLASSIC_MOVIE'
      IF(MOVIE)THEN
        IF(IFIM.EQ.0) THEN
          CALL FILEOPEN(4,FNMOV,FO_APP+FO_VERB+FO_MARK,FERROR)
          IFIM=1
        ELSE
          CALL FILEOPEN(4,FNMOV,FO_APP,FERROR)
        ENDIF
        DO IS=1,NCLTYP
          IZ0=IMTYP(IS)
          IF(IATYP(IS).EQ.0) THEN
                IAT=6
          ELSE
               IAT=IATYP(IS)
          ENDIF
          DO IA=NCRANG(1,IS),NCRANG(2,IS)
cmdebug wrong movie format... 
c           WRITE(4,'(I7,6(2X,F14.6))')
cmdebug
            WRITE(4,'(3(2X,F12.4),2I4)')
     *      (CLASC(I,IA)/FBOHR,I=1,3),IAT,IZ0
          ENDDO
        ENDDO
        CALL FILECLOSE(4)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
