      subroutine mddiag_interaction_p(NSTATE,C0,C1,CR,SC0,CSCR,VPP,EIGV,
     &                       RHOE,PSI,cpmdSCR,cpmdLSCR,
     &                       TAU0,VELP,TAUI,FION,IFCALC,
     &                       IREC,TFOR,TINFO)
C     ==================================================================
C     ** THE FUNCTIONALITY OF THIS ROUTINE IS IDENTICAL TO THAT OF    **
C     ** FORCES_DIAG, except that the wfn optimization is done        **
C     ** in the perturbation theory framework.                        **
C     **                                                              **
C     ** This routine is in fact an interface between MD_DIAG         **
C     ** and INTERACTION_P. Most of the arguments are NOT USED        **
C     ** but kept for the sake of compatibility to FORCES_DIAG.       **
C     ==--------------------------------------------------------------==
C     == ENTER WITH THE IONIC POSITIONS IN TAU0 AND AN INPUT GUESS    ==
C     == FOR THE DENSITY IN RIN0, THIS ROUTINE RETURNS THE CONVERGED  ==
C     == DENSITY, WAVEFUNCTIONS AND IONIC FORCES.                     ==
C     ==--------------------------------------------------------------==
C     == TAU0: ATOMIC POSITION                                        ==
C     == VELP and TAUI are necessary for RESTART FILE                 ==
C     == FION: IONIC FORCES                                           ==
C     == IFCALC: total number of iterations                           ==
C     ** C0:   Initial guess for the wavefunction.                    **
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'        !NLSD
      INCLUDE 'elct.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'        !CALSTE
      INCLUDE 'andr.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'store.inc'
      include 'response_p.inc'
      include 'wann.inc'        !localisation include
      include 'prop.inc'        !localisation include
      include 'ddip.inc'        !localisation include
      include 'irat.inc'        !irat(parallel) include
C     Arguments
      INTEGER    NSTATE,IFCALC,IREC(100),cpmdLSCR
      COMPLEX*16 C0(*),C1(*),CR(*),SC0(*),CSCR(*),PSI(NNR1)
      REAL*8     EIGV(*),TAU0(*),VELP(*),TAUI(*),FION(*),VPP(*),
     &           RHOE(NNR1,NLSD),cpmdSCR(*),THL(2)
      LOGICAL    TFOR,TINFO
C     Variables
      CHARACTER TAG*30

C     PT variables:
C     potentials and related:
      complex*16 eirop(*),eivps(*),h1psi0(*)
      pointer    (ip_eirop,eirop),(ip_eivps,eivps),(ip_h1psi0,h1psi0)
      real*8 dummy
      real*8     drhoe(*)
      pointer    (ip_drhoe,drhoe)
C     others & scratch:
      real*8     z11(nstate,nstate),scr(*)
      pointer    (ip_z11,z11),(ip_scr,scr)

      integer    l_pert,il_rhoe,il_psi,lscr

C     Scratch arrays for the localisation
      complex*16 cs(NGW,NSTATE)
      POINTER (IP_CS,CS)
      complex*16 SCT(NGW,NSTATE)
      POINTER (IP_SCT,SCT)
      INTEGER NC
#ifdef PARALLEL
      INTEGER NXXFUN
      EXTERNAL NXXFUN
#endif

C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST
      INTEGER istate,MSGLEN
C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST

C DMB E2 calc
      REAL*8 E0,E2
C DMB E2 calc

C     ==--------------------------------------------------------------==
C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST
#ifdef PARALLEL
      IF (INTER_PT_FIRSTCALL) THEN
C        testing WCpredict and fastdex cflag
         write(6,*) 'PROC',ME,'WCPREDICT =',WCPREDICT
         write(6,*) 'PROC',ME,'FASTDEXC =',FASTDEXC
      ENDIF
#endif
C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST

      IF(PARENT) THEN
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(" *",19X,A,20X,"*")') ' RESPONSE CALCULATIONS '
        WRITE(6,'(1X,64("*"),/)')
C     Format: 65 Spalten
 81     FORMAT ("* RESPONSE TYPE:        ",A35,5X,"*")
 82     FORMAT ("* PRECONDITIONER TYPE:  ",A35,5X,"*")
 83     FORMAT ("* PRECONDITIONER CUTOFF:",F10.5,30X,"*")
 84     FORMAT ("* WFN CONVERGENCE:      ",E12.3,28X,"*")
 85     FORMAT ("* ALGORITHM:            ",A35,5X,"*")
 86     FORMAT ("* CG: ANALYTIC STEPS:   ",I4,36X,"*"
     &      /,  "* CG: LENGTH PREFACTOR: ",F10.5,30X,"*")
 89     FORMAT ("* ",22X,A35,5X,"*")
 90     FORMAT (56("*"),"RESPONSE*")

        TINTERACTION = .true.

C       print out information on first call
        IF (INTER_PT_FIRSTCALL) THEN
           write (6,*)
           write (6,90)
           write (6,81)'INTERACTION of Wannier orbitals '

           if (PRECONDITIONER_P.eq.1) then
             write (6,82) 'smooth (ds)                     '
           else if (PRECONDITIONER_P.EQ.2) then
             write (6,82) 'tight (ap)                      '
           else IF (PRECONDITIONER_P.EQ.3) THEN
             write  (6,82) 'State dependent + DS            '
           else IF (PRECONDITIONER_P.EQ.4) THEN
             write  (6,82) 'State dependent + AP            '
           endif
           write (6,83) hthrs_p
           write (6,84) tolog_p
           if (PCG_P) then
             if (PREC_P) then
               write (6,85) 'preconditioned conj gradient    '
             else
               write (6,85) 'bare conj gradient              '
             endif
             if (TPOLAK_P) then
               write (6,89) 'Polak-Ribiere variant           '
             else
               write (6,89) 'Fletcher-Reeves variant         '
             endif
             if (PCGMIN_P) then
               write (6,86) CG_ANALYTIC,CG_FACTOR
             else
               write (6,89) 'using FIXED STEP LENGTH         '
             endif
           elseif (TSDE_P) then
             if(PREC_P) then
               write (6,85) 'preconditioned steepest descent '
             else
               write (6,85) 'bare steepest descent           '
             endif
           endif
           if (WCPREDICT) then
              write (6,*) 'WC Pos prediction (reset every',
     $                     WC_PRED_STEP,'steps)'
           endif
 
           write (6,90)

C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST
           IF (WCPREDICT) THEN
C             Allocate the memory necessary for the WCs prediction
              CALL MEMORY(IP_WC_array1,3*NSTATE,'WC_array1')
              CALL MEMORY(IP_WC_array2,3*NSTATE,'WC_array2')
           ENDIF                ! WCPREDICT
C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST
         ENDIF                  ! firstcall
      ENDIF                     ! Parent.

C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST
      IF (WCPREDICT.AND.INTER_PT_FIRSTCALL) THEN
C        Allocate memory for WC velocities (parent and others)
         CALL MEMORY(IP_WC_velocity,3*NSTATE,'WC_veloc ')
      ENDIF           
C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST
C     ==--------------------------------------------------------------==
C     First, ALLOCATE MEMORY which is needed for any kind of perturbation.
C     Then, the specific perturbation subroutine is called.
C     might need to be separated and variable passed to the routine..
C     ==--------------------------------------------------------------==
C     Wavefunctions, densities and related:
      call memory(ip_h1psi0,2*ngw*nstate,'H1psi0')
      call azzero(h1psi0,2*ngw*nstate)
      call rhoe_psi_size(il_rhoe,il_psi)
      call azzero(psi,il_psi)
      call azzero(rhoe,il_rhoe)
      call memory(ip_rho0,il_rhoe,'rho0')
      call azzero(rho0,il_rhoe)
      call memory(ip_drhoe,il_rhoe,'drhoe')
      call azzero(drhoe,il_rhoe)

C     potentials and related:
      call memory(ip_vofrho0,il_rhoe,'v[n0]')
      call azzero(vofrho0,il_rhoe)
      call memory(ip_eirop,2*nhg,'eirop')
      call azzero(eirop,2*nhg)
      call memory(ip_eivps,2*nhg,'eivps')
      call azzero(eivps,2*nhg)

C     others & scratch:
      call memory(ip_z11,nstate*nstate,'z11')
      call azzero(z11,nstate*nstate)
      call azzero(fion,3*nax*nsx)

      CALL GIVE_SCR_perturbation(lscr,TAG,NSTATE)
      call memory(ip_scr,lscr,'scr/pt')
      call azzero(scr,lscr)
C     ==--------------------------------------------------------------==

      call phfac(tau0)
      call eicalc(eivps,eirop)
      if(tmemchk) call print_memory

C     Localising the orbitals
      if (TLOCALIZE) then
        if(parent) write(6,*) 'LOCALISING THE KS ORBITALS...'
        TWANN=.true.
        LOCL=.true.
        NUMORB=MAX(NUMORB,NSTATE)
        NC=2*NGWK*NUMORB
#ifdef PARALLEL
        LENBK=NXXFUN(NUMORB)
        NC=MAX(2*LENBK*NPROC,NC)
#endif
        CALL MEMORY(IP_SCT,NC,'SCT/tmp   ')
        CALL MEMORY(IP_CS,NC,'CS/tmp   ')
        CALL LOCALIZE(TAU0,C0,CS,SCT,SCR,LSCR,NSTATE)
        CALL EICALC(eivps,eirop)
        CALL FREEM(IP_SCT)
        CALL FREEM(IP_CS)
        if(parent) write(6,*) 'Done'

C      -TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST
C       only the parent knows the position of the WCs
        if (parent.AND.WCPREDICT) then
C          storing the first WCs (old)
           IF (WC_sample.EQ.1) then
              write(6,*) 'Storing 1st WCs'
C             SCR contains the coordinates of the wannier centres...
C             copying the WCs from the scratch to WC_array1
              CALL Store_WC(NSTATE,SCR,WC_array1)

C             little printout just for fun.... works OK
C             write(6,*) 'WC_array1'
C             DO istate=1,NSTATE
C                write(6,*) WC_array1(1,istate),
C     $                      WC_array1(2,istate),
C     $                      WC_array1(3,istate)
C              ENDDO

C             storage of array1 completed, next call will store array2
              WC_sample=2
C          storing the second WCs (new)
           ELSE IF (WC_sample.EQ.2) then
              write(6,*) 'Storing 2nd WCs'
C             SCR contains the coordinates of the wannier centres...
C             copying the WCs from the scratch to WC_array2
              CALL Store_WC(NSTATE,SCR,WC_array2)

C             little printout just for fun.... works OK
C              write(6,*) 'WC_array2'
C              DO istate=1,NSTATE
C                 write(6,*) WC_array2(1,istate),
C     $                      WC_array2(2,istate),
C     $                      WC_array2(3,istate)
C              ENDDO

C             Now we can calculate the velocity of the WCs.
              CALL Calculate_WC_Velocity(NSTATE,WC_array1,
     $                               WC_array2,WC_velocity)

C             little printout just for fun....
              write(6,*) 'velocities'
              DO istate=1,NSTATE
                 write(6,*) WC_velocity(1,istate),
     $                      WC_velocity(2,istate),
     $                      WC_velocity(3,istate)
              ENDDO

C             Storage + velocity calc completed, next call will predict
              WC_sample=0
C             here one should broadcast WC_velocity to all processors...
C             to be done by parent??
           ENDIF
        ENDIF

#ifdef PARALLEL
        if (WCPREDICT) then
C          Broadcast of switch?
           MSGLEN=1*8/IRAT
           CALL MY_BCAST(WC_sample,MSGLEN,SOURCE,ALLGRP)
C          here one should broadcast WC_velocity to all processors...
           MSGLEN = 3*NSTATE*8
           CALL MY_BCAST(WC_velocity,MSGLEN,SOURCE,ALLGRP)
           write(6,*) 'PROC:',ME,'WC_sample =',WC_sample
        endif
#endif 

C       De-allocating the memory for WC prediction
C       CALL FREEM(IP_WC_array1)
C       CALL FREEM(IP_WC_array2)
C       CALL FREEM(IP_WC_velocity)
C    -TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST
      endif
C     end of localisation

C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST
C     Now (if requested) predict the position of WCs
C     and orthogonalise

C     Predicting the position of the WCs 
      IF (WCPREDICT) then
C        check for prediction(0) and no localise
         IF (WC_sample.EQ.0) then
            IF (.NOT.TLOCALIZE) then
               write(6,*) 'PROC',ME,' moving WCs to predicted pos'
C              Shift each state in C0 by the constant vector ammount WC_velocity
               CALL Move_All_Wannier(NSTATE,C0,WC_velocity)
            ELSE
C              if we end up here, it means that we just calculated the 2nd point...
C              so disable the localisation, and next call will predict WC position
               TLOCALIZE=.FALSE.
            ENDIF
C           orthogonalising c0 (C1 here is a scratch)
            CALL LOWDIN(C0,C1,SCR,LSCR,NSTATE)
         ENDIF
      ENDIF

C     Synchronise the processors before the PT start
#ifdef PARALLEL
      call my_sync(allgrp)
      write(6,*) 'BPT:process',ME,' ready'
#endif
C TESTTESTTESTTESTTESTTESTTESTTESTTESTTESTTTEST

C PERTURBATION OPTIMISATION OF W1

      if(ttau) call stopgm("mddiag-inter","no tau functionals")
C     initialisation of the PT vectors (forces,densities)
      call rhoofr(c0,rho0,psi,scr,lscr,nstate)
      call DCOPY(nnr1, rho0, 1, vofrho0, 1)
      call vofrho(tau0,fion,vofrho0,psi,scr,lscr,.false.,.false.)

      if(parent) call prmem('  DO_PERTURBATION')

C     calculate the lagrange parameters z11 and the forces on the wfns:
      call lag_mult(c0,h1psi0,psi,scr,lscr,rhoe,z11,nstate)

C DMB E2 calc
      if(parent) write(6,*) 'ETOT(0) = ',ETOT
C     storing the starting energy
      E0=ETOT
C DMB E2 calc

C     ==--------------------------------------------------------------==
C     optimise the response wavefunction
      call rwfopt_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &     eirop,eivps,dummy,h1psi0,
     &     z11,nstate,dummy)

C END OF PERTURBATION OPTIMISATION OF W1

C DMB E2 calc
      if(parent) write(6,*) 'ETOT(2) = ',ETOT
C     storing the correction energy
      E2=ETOT
C DMB E2 calc

C     ==--------------------------------------------------------------==
C     DE-allocate memory
C     ==--------------------------------------------------------------==
      call freem(ip_h1psi0)
      call freem(ip_rho0)
      call freem(ip_drhoe)
      call freem(ip_vofrho0)
      call freem(ip_eirop)
      call freem(ip_eivps)
      call freem(ip_z11)
      CALL freem(ip_scr)
C     ==--------------------------------------------------------------==

      RESPONSE_RUNNING = .FALSE.

C     add C1 to C0
      call DAXPY(2*ngw*nstate,1d0,c1,1,c0,1)
 
C     orthogonalising c0+c1 (C1 here is a scratch)
      CALL LOWDIN(C0,C1,SCR,LSCR,NSTATE)

C     calculate the forces on the ions with the new C0
      call forces(c0,c1,tau0,fion,rhoe,psi,
     &     scr,lscr,nstate,1,.false.,.true.)

C DMB E2 calc
c     if(parent) write(6,*) 'ETOT= ',ETOT
c     if(parent) write(6,*) 'EPT = ',E0+E2
C     replacing etot by the second order functional energy
c     ETOT=E0+E2
C DMB E2 calc
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================

C     ==================================================================
      SUBROUTINE Store_WC(NSTATE,CENTER,WC_array)
C     ==--------------------------------------------------------------==
C     This routine stores the coordinates of the Wannier centres
C     into WC_array, just to get rid of using SCR as storage space..
      IMPLICIT NONE
      include 'system.h'
      INTEGER NSTATE
      REAL*8 CENTER(4,NSTATE)
      REAL*8 WC_array(3,NSTATE)
      INTEGER istate
C     ==--------------------------------------------------------------==
      if(parent) write(6,*) 'Storing wannier centres'
      DO istate=1,NSTATE
         WC_array(1,istate)=CENTER(1,istate)
         WC_array(2,istate)=CENTER(2,istate)
         WC_array(3,istate)=CENTER(3,istate)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


C     ==================================================================
      SUBROUTINE Calculate_WC_Velocity(NSTATE,WC_array1,WC_array2,
     $                                 WC_velocity)
C     ==--------------------------------------------------------------==
C     This routine calculates the velocity of the Wannier centres
C     using the positions contained in WC_array1(old) and WC_array2(new)
C     The method used is a simple crude finite difference and the result
C     is put in WC_velocity
      IMPLICIT NONE
      include 'system.h'
      INTEGER NSTATE
      REAL*8 WC_array1(3,NSTATE)
      REAL*8 WC_array2(3,NSTATE)
      REAL*8 WC_velocity(3,NSTATE)
      INTEGER istate
C     ==--------------------------------------------------------------==
      if(parent) write(6,*) 'Calculating velocity of wannier centres'
      DO istate=1,NSTATE
         WC_velocity(1,istate)=WC_array2(1,istate)-WC_array1(1,istate)
         WC_velocity(2,istate)=WC_array2(2,istate)-WC_array1(2,istate)
         WC_velocity(3,istate)=WC_array2(3,istate)-WC_array1(3,istate)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE Move_All_Wannier(NSTATE,C0,WC_velocity)
C     ==--------------------------------------------------------------==
C     This routine moves all the Wannier functions state-by-state
C     by a vector displacement given in WC_velocity for each state.
C     This constitutes a crude propagation scheme for localised functions

      IMPLICIT NONE

C     Including the "essential" variables...
      include 'system.h'
      include 'cppt.inc'
      INCLUDE 'cnst.inc'

C     so from now on NGW is the number of plane waves, GK(3,NGW) is the array
C     of G vectors, HG(NGW) is the array containing the square of the norm of
C     each G vector. (according to Daniel...)

      INTEGER NSTATE
      COMPLEX*16 C0(NGW,NSTATE)
      REAL*8 WC_velocity(3,NSTATE)

      INTEGER istate,Gindx
      COMPLEX*16 EXPiGR
      REAL*8 GbyR

C     Main loop on the states
      DO istate=1,NSTATE
C        Loop on the G vectors
         DO Gindx=1,NGW
C          Calculating the product G.r
           GbyR = GK(1,Gindx)*WC_velocity(1,istate)
     $           +GK(2,Gindx)*WC_velocity(2,istate)
     $           +GK(3,Gindx)*WC_velocity(3,istate)

C          Adjusting the units
           GbyR=-GbyR*TPIBA
   
C          Calculating E^i(G.r) using cos(x)+i*sin(x)
           EXPiGR=dcmplx(DCOS(GbyR),DSIN(GbyR))

C          multiplying the Wannier coeffs
           C0(Gindx,istate)=C0(Gindx,istate)*EXPiGR
         ENDDO
      ENDDO
      END
C     ==================================================================
