C     ==================================================================
      SUBROUTINE MDFILE(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'andr.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'store.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'comvel.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'mm_extrap.inc'
C     Arguments
      COMPLEX*16 C0(NGWK,N,*),C2(NGWK,*),C1(*),CM(*),SC0(NGW,*)
      REAL*8     VPP(*),GAMX(*),GAMY(*)
C     Variables
      DIMENSION  F(N,NKPTS),RIN0(*),RK(3,NKPTS),WK(NKPTS)
      REAL*8     TAUI(3,NAX,NSX),TAUR(3,NAX,NSX),EIGV(N,NKPTS),
     &           RM1(*),RINP(*),SAVE_FION(3,NAX,NSX)
      POINTER    (IP_TAUI,TAUI),(IP_TAUR,TAUR),(IP_EIGV,EIGV),
     &           (IP_RM1,RM1),(IP_RINP,RINP),(IP_SAVE_FION,SAVE_FION)
      COMPLEX*16 PSI(NNR1,NLSD)
      REAL*8     RHOE(NNR1,NLSD),SCR(*),TAUIO(3,*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR),
     &    (IP_TAUIO,TAUIO)
      CHARACTER  TAG*30
      REAL*8     TIMEF,TIME1,TIME2,DUMMY,RMEM,
     &           ECONS,EKINP,EKINCP,DISA,ENOSE,ENOSP,EKIN1,EKIN2,
     &           TEMP1,TEMP2,TEMPP,TCPU,EKINH1,EKINH2,VCMIO(4),LMIO(3)
      EXTERNAL   TIMEF
      INTEGER    IREC(100),IFCALC,NX,IK,NNX,NSTATE,
     &           LSCR,IL_RHOE,IL_PSI
      CHARACTER FILEN*100
      LOGICAL    FERROR,TESTSTORE
      INTEGER    MSGLEN,ITEMP,NMM,LENEXT
      INTEGER    SAVE_NFI
C     QM/MM
      LOGICAL qmmech
      REAL*8  MM_EKIN
      REAL*8  MM_TEMP
C     ==================================================================
      IF(TDDFT.AND.TRESPONSE) CALL STOPGM("MDFILE",
     &                        "TDDFT.AND.TRESPONSE NOT POSSIBLE")
C     ==--------------------------------------------------------------==
      TIME1 = TIMEF()
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TAUI,3*NAX*NSX,'TAUI')
      CALL MEMORY(IP_TAUR,3*NAX*NSX,'TAUR')
      CALL MEMORY(IP_SAVE_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TAUIO,NAT,'TAUIO')
C     Memory for densities
      NNX=NNR1*NLSD
      CALL MEMORY(IP_RIN0,NNX,'RIN0')
      CALL MEMORY(IP_ROUT0,NNX,'ROUT0')
      CALL MEMORY(IP_RMIX,NNX,'RMIX')
      CALL MEMORY(IP_RM1,NNX,'RM1')
      CALL MEMORY(IP_RINP,NNX,'RINP')
      IP_RHOO=IP_RIN0
      CALL AZZERO(RIN0,NNX)
      CALL AZZERO(ROUT0,NNX)
      CALL AZZERO(RMIX,NNX)
      NSTATE=N
      NACC = 22
      NFI  = 0
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=TPRES
      CALL MEMORY(IP_EIGV,NLSD*NSTATE*NKPTS,'EIGV')
C     ==--------------------------------------------------------------==
C     Extrapolation
      IF(TEXTRAP) THEN
        LENEXT=2*NGWK*NSTATE*NKPTS*MEXTRA
        RMEM = 16.D0*LENEXT*1.D-6
        CALL MEMORY(IP_COLD,LENEXT,'COLD')
        IF(PARENT) WRITE(6,'(A,T51,F8.3,A)') ' MDFILE| '
     *    // 'EXTRAPOLATION WAVEFUNCTION HISTORY TAKES ',RMEM,' MBYTES'
      ENDIF
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      NMM=1
      IF(TDDFT) THEN
        CALL MEMORY(IP_RHOO,IL_RHOE,'RHOO')
        CALL MEMORY(IP_POTR,IL_RHOE,'POTR')
        IF(NS_TRI.GT.0) NMM=2
      ENDIF
      NMM=NMM*IL_PSI
      CALL MEMORY(IP_PSI,NMM,'PSI')
      CALL GIVE_SCR_MDFILE(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
C     ==--------------------------------------------------------------==
99999 IF(TSAMPL) THEN
        CALL SAMPLE_WAIT
        IF(NOMORE.LT.0) GOTO 10000
      ENDIF
      NFNOW=1
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
C     PARAMETERS FOR THE NOSE-HOOVER THERMOSTATS
      IF(TNOSEP.AND.PARENT) CALL NOSEPA(1,1)
C     Dont symmetrize density 
      TSYMRHO=.FALSE.
C..Make sure TKFULL=.TRUE
      IF(TKPNT.AND.(.NOT.TKFULL)) THEN 
        WRITE(6,*) 
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        WRITE(6,*) 
     & ' WARNING!  USE KPOINTS FULL  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        WRITE(6,*) 
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
      ENDIF
C     ==--------------------------------------------------------------==
C     == INITIALISATION                                               ==
C     ==--------------------------------------------------------------==
      CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IF(IPRINT_STEP.EQ.0) IPRINT_STEP=NOMORE+1
C     ==--------------------------------------------------------------==
C     INITIALIZE VELOCITIES
      IF(PARENT) CALL DETDOF(TAU0,TAUR)
      IF(IREC(IREC_VEL).EQ.0.AND..NOT.RGEO) THEN
        ECNSTR = 0.0D0
        ERESTR = 0.0D0
        CALL RINVEL(VELP,C2,NSTATE)
        IF(PARENT) CALL TAUCL(VELP)
        IF(PARENT) CALL RATTLE(TAU0,VELP)
        CALL RVSCAL(VELP)
      ELSE
        IF(PARENT) CALL TAUCL(VELP)
        IF(PARENT)  CALL RATTLE(TAU0,VELP)
        IF(TRESCALE) CALL RVSCAL(VELP)
      ENDIF
      IF(QUENCHP) CALL AZZERO(VELP,3*NAX*NSX)
C     COMPUTE THE IONIC TEMPERATURE TEMPP
      IF(PARENT) THEN
        CALL EKINPP(EKINP,VELP)
        TEMPP=EKINP*FACTEM*2.D0/GLIB
      ENDIF
C     RESET ACCUMULATORS
      IF(PARENT.AND.IREC(IREC_AC).EQ.0)
     &     CALL RESETAC(TAU0,TAUI,NFI)
C
      CALL WRITE_IREC(IREC)
C..-------------------------------------------------
C..QM/MM coupling by Roethlisberger Group
C..Initailize Molecular Mechanics subsystem:
C..-------------------------------------------------
C..
#if defined (__QMECHCOUPL)
      IF (PARENT) THEN
C       ---------------------------------------------------------
C       CORE QM/MM initilization
C        Please note this is the same routine used to initialize
C        the QMMM functionality during a geometry optimization.
C        MD specific initialization is performed by the routine
C        'mm_cpmd_md_init'.
C       ---------------------------------------------------------
        CALL mm_cpmd_init (TQMMECH,TAU0,NA,NSP,NAX,NAT,RCO,RVEL,TEMPW)
C       -------------
C       set QMMM flag
C       -------------
        IF(TQMMECH) THEN
          CALL mm_run(qmmech)
        ELSE
          qmmech=.false.
        ENDIF
C       -----------------------------------
C       initialize QM/MM Molecular Dynamics
C       -----------------------------------
        if (qmmech) then
          MM_EKIN = 0.0d0
          MM_TEMP = 0.0d0
          CALL mm_cpmd_md_init
          call mm_cpmd_ext_pot_f77
          CALL mm_cpmd_update_links(TAU0, NA, NSP, NAX, NAT)
        end if
      END IF
#endif
C     INITIALIZE FORCES
      IF(TDIAG) THEN
        IF(TLANC) NX=1
        IF(TDAVI) NX=NGWK*NDAVV*NKPNT+1
        IF(DIIS)  NX=((NGWK*NSTATE+8)*MDIIS*NKPNT)/4
      ELSEIF(TSDE) THEN
          NX=1
      ELSEIF(DIIS) THEN
          NX=(NGWK*NSTATE+8)*MDIIS/2+4
      ELSEIF(PCG) THEN
          NX=1
      ENDIF
      IF(PARENT) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T25,A,T64,"==")')
     &       'FORCES INITIALIZATION'
        WRITE(6,'(1X,64("="))')
      ENDIF
      IFCALC=0
      CALL FORCES_DIAG(NSTATE,C0,C2,CM,SC0,CM(NX),VPP,EIGV,
     &                 RHOE,PSI,SCR,LSCR,
     &                 TAU0,VELP,TAUI,FION,IFCALC,
     &                 IREC,.TRUE.,.TRUE.)
C
      CALL DCOPY(NNX,RIN0(1),1,RM1(1),1)
C     INITIALIZE THERMOSTATS
      IF(PARENT) THEN
        ITEMP=IREC(IREC_NOP1)+IREC(IREC_NOP2)+IREC(IREC_NOP3)
     *        +IREC(IREC_NOP4)
        IF(TNOSEP .AND. ITEMP.EQ.0) CALL NOSPINIT(1)
        FILEN='ENERGIES'
        CALL FILEOPEN(3,FILEN,FO_APP+FO_VERB,FERROR)
      ENDIF
      IF(PARENT) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T20,A,T64,"==")')
     &       'END OF FORCES INITIALIZATION'
        WRITE(6,'(1X,64("="),/)')
      ENDIF
      CALL WRITE_IREC(IREC)
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
      IF(TESTSTORE(0).AND.TSAMPL)
     *    CALL ZHWWF(2,IREC,C0,C2,NSTATE,EIGV,TAU0,VELP,TAUI,NFI)
      IF(PARENT) THEN
C       MEAN SQUARE DISPLACEMENT OF DIFFERENT IONIC SPECIES
        IF(PARENT) CALL DISPP(TAU0,TAUI,DISA)
C       ENERGY OF THE NOSE THERMOSTATS
        CALL NOSENG(NFI,VELP,ENOSE,ENOSP,DUMMY,1)
        ECONS=EKINP+ETOT+ENOSE+ENOSP+ECNSTR+ERESTR
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,T50,F8.2,A8)') ' TIME FOR INITIALIZATION:',
     &       TCPU,' SECONDS'
        WRITE(6,'(//,1X,64("="))')
        WRITE(6,'(1X,"=",T20,A,T65,"=")')
     &       'MOLECULAR DYNAMICS SIMULATION'
        WRITE(6,'(1X,64("="))')
      ENDIF
C     ==================================================================
C     ==          THE BASIC LOOP FOR MOLECULAR DYNAMICS               ==
C     ==                 USING VELOCITY VERLET                        ==
C     ==================================================================
      DO INFI=1,NOMORE
        CALL MY_SYNC(ALLGRP)
        TIME1=TIMEF()
        NFI=NFI+1
        SUBCOM=TSUBCOM.AND.MOD(NFI-1,NCOMV).EQ.0
        SUBROT=TSUBROT.AND.MOD(NFI-1,NROTV).EQ.0
C       ANNEALING
        CALL ANNEAL(VELP,C2,NSTATE,SCR)
        CALL BERENDSEN(VELP,C2,NSTATE,SCR,0.0D0,0.0D0)
C       SUBTRACT CENTER OF MASS VELOCITY
        IF(PARENT.AND.SUBCOM) CALL COMVEL(VELP,VCMIO,.TRUE.)
C       SUBTRACT ROTATION AROUND CENTER OF MASS
        IF(PARENT.AND.SUBROT) CALL ROTVEL(TAU0,VELP,LMIO,TAUIO,.TRUE.)
C       UPDATE NOSE THERMOSTATS
        CALL NOSEUP(VELP,C2,NSTATE,1)
C       UPDATE VELOCITIES
        IF(PARENT) CALL VELUPIF(VELP,FION,1)
#if defined (__QMECHCOUPL)
        if (PARENT .and. qmmech) then
          CALL mm_cpmd_velup(DELT_IONS)
        end if
#endif
C       UPDATE POSITIONS
        ECNSTR = 0.0D0
        ERESTR = 0.0D0
        IF(PARENT) THEN
          CALL POSUPIF(TAU0,TAUP,VELP,FERROR)
          WRITE(6,'(1X,64("*"))')
          IF(XTIN) THEN
            WRITE(6,'(1X,"*",2X,A,I6,A,15X,"*")') 'CONFIGURATION ',
     &         NSKIP+NFI*NSAMPLE,
     &         ' READ FROM FILE TRAJSAVED.xyz'
          ELSE
            WRITE(6,'(1X,"*",2X,A,I6,A,15X,"*")') 'CONFIGURATION ',
     &         NSKIP+NFI*NSAMPLE,
     &         ' READ FROM FILE TRAJSAVED'
          ENDIF
          WRITE(6,'(1X,64("*"))')
          IF(MCNSTR.NE.0) CALL CPMDSHAKE(TAU0,TAUP,VELP)
#if defined (__QMECHCOUPL)
          if (qmmech) then
            CALL mm_cpmd_update_links(TAUP, NA, NSP, NAX, NAT)
            CALL mm_cpmd_posup(DELT_IONS)
          end if
#endif
        ENDIF
        CALL MY_BCAST(FERROR,1*8/IRAT,SOURCE,ALLGRP)
        IF(FERROR) THEN
          IF(PARENT) THEN
            WRITE(6,'(1X,64("!"))')
            WRITE(6,'(" !!",A,T64,"!!")')
     &        ' MDFILE| ENCOUNTERED END OF FILE '
            WRITE(6,'(" !!",A,I6,T64,"!!")')
     &        '         WHILE READING CONFIGURATION ',NSKIP+NFI*NSAMPLE
            WRITE(6,'(1X,64("!"))')
          ENDIF
          GOTO 100
        ENDIF
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAUP,MSGLEN,SOURCE,ALLGRP)
C       Reset swap file to update (option BLOCK and ALL)
        IF(TKBLOCK) CALL RESKPT_SWAP
        CALL PHFAC(TAUP)
        IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,CALSTE)
        IF(TMOVR) THEN
          CALL DCOPY(NNX,RIN0(1),1,RHOE(1,1),1)
          CALL MOVERHO(RHOE,PSI,SCR,LSCR)
          CALL DCOPY(NNX,RHOE(1,1),1,RIN0(1),1)
        ENDIF
        IF(TTROT) THEN
          CALL CALC_ALM(SCR,LSCR)
        ENDIF
C       CALCULATE THE FORCES
        CALSTE=TPRES.AND.MOD(NFI,NPRES).EQ.0
        IF(TEXTRAP) THEN
C         Extrapolate wavefunctions
          CALL EXTRAPWF(INFI,C0,SCR,COLD,NSTATE,MEXTRA)
        ENDIF
        IF(TLANC) NX=1
        IF(TDAVI) NX=NDAVV*NKPNT+1
C RESPONSE calculation
        CALL FORCES_DIAG(NSTATE,C0,C2,CM,SC0,CM(NX),VPP,EIGV,
     &       RHOE,PSI,SCR,LSCR,
     &       TAUP,VELP,TAUI,FION,IFCALC,
     &       IREC,.TRUE.,.FALSE.)
        IF(TDDFT) THEN
          CALL LR_TDDFT(C0,C1,C2,SC0,RHOE,PSI,TAUP,FION,EIGV,
     &              SCR,LSCR,NSTATE,.FALSE.,IOUTPUT)
        ENDIF
        IF(TRESPONSE) THEN
          CALL ERBACK(0)
          CALL DCOPY(3*NAX*NSX,FION,1,SAVE_FION,1)
          CALL DCOPY(3*NAX*NSX,TAU0(1,1,1),1,TAUR(1,1,1),1)
          CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,TAU0(1,1,1),1)
          CALL DO_PERTURBATION(C0,C2,NSTATE)
          CALL ERBACK(1)
          CALL DCOPY(3*NAX*NSX,SAVE_FION,1,FION,1)
          CALL DCOPY(3*NAX*NSX,TAUR(1,1,1),1,TAU0(1,1,1),1)
        ENDIF
        IF(CALSTE) CALL TOTSTR
#if defined (__QMECHCOUPL)
C       ----------------------------------------------
C       QMMM electrostatic coupling
C       ----------------------------------------------
        if (qmmech) then
          call mm_cpmd_ext_pot_f77
          call mm_cpmd_elstat(TAUP,NA,NSP,NAX,NAT,C0,SCR)
        end if
#endif
C     ==================================================================
C       Damped Dynamics
        CALL DAMPDYN(VELP,FION,CM,C2,NSTATE,SCR(1),SCR(10))
C     ==================================================================
C       FINAL UPDATE FOR VELOCITIES
        ECNSTR = 0.0D0
        ERESTR = 0.0D0
        IF(PARENT) THEN
          CALL VELUPIF(VELP,FION,1)
#if defined (__QMECHCOUPL)
          if (qmmech) then
            CALL mm_cpmd_velup(DELT_IONS)
          end if
#endif
          CALL RATTLE(TAUP,VELP)
        ENDIF
        IF(PARENT) CALL GEOFILE(TAUP,VELP,'WRITE')
C       COMPUTE THE IONIC TEMPERATURE TEMPP
        IF(PARENT) THEN
          CALL EKINPP(EKINP,VELP)
          TEMPP=EKINP*FACTEM*2.D0/GLIB
#if defined (__QMECHCOUPL)
C         -------------------------------------------------
C         TEMPERTURE and KINETIC ENERGY of the MM subsystem
C           MM_EKIN + EKINP = KE of whole QM/MM system
C         -------------------------------------------------
          if (qmmech) then
            CALL mm_cpmd_ekin(MM_EKIN,MM_TEMP)
          end if
#endif
        ENDIF
C       IONIC TEMPERATURE CONTROL
        IF(PARENT) CALL RSCVP(TEMP1,TEMP2,TEMPP,VELP)
#if defined (__QMECHCOUPL)
C       ---------------------------------------------------------------
C       MM Temperature control - annealing schedule not yet implemented
C       ---------------------------------------------------------------
        IF (PARENT .and. qmmech) THEN
          call mm_cpmd_temp_control(TEMP1,TEMP2,MM_TEMP,TCP)
          call mm_cpmd_ekin(MM_EKIN,MM_TEMP)
        END IF
#endif
C       SUBTRACT ROTATION AROUND CENTER OF MASS
        IF(PARENT.AND.SUBROT) CALL ROTVEL(TAU0,VELP,LMIO,TAUIO,.FALSE.)
C       SUBTRACT CENTER OF MASS VELOCITY
        IF(PARENT.AND.SUBCOM) CALL COMVEL(VELP,VCMIO,.FALSE.)
C       UPDATE NOSE THERMOSTATS
        CALL NOSEUP(VELP,C2,NSTATE,1)
        CALL BERENDSEN(VELP,C2,NSTATE,SCR,0.0D0,0.0D0)
C       ANNEALING
        CALL ANNEAL(VELP,C2,NSTATE,SCR)
        IF(PARENT) THEN
          CALL EKINPP(EKINP,VELP)
          TEMPP=EKINP*FACTEM*2.D0/GLIB
        ENDIF
C       MEAN SQUARE DISPLACEMENT OF DIFFERENT IONIC SPECIES
        IF(PARENT) CALL DISPP(TAUP,TAUI,DISA)
C       ENERGY OF THE NOSE THERMOSTATS
        IF(PARENT) CALL NOSENG(NFI,VELP,ENOSE,ENOSP,DUMMY,1)
C       CALCULATE PROPERTIES DURING SIMULATION.
        CALDIP=TDIPD
        CALL PROPCAL(C0,C2,CM,SC0,TAUP,EIGV,F,AMU,
     &               RHOE,PSI,SCR,LSCR,NSTATE,NKPNT,NFI,INFI)
C       PRINTOUT the evolution of the accumulators every time step
        IF(PARENT) THEN
          ECONS=EKINP+ETOT+ENOSE+ENOSP+ECNSTR+ERESTR
#if defined (__QMECHCOUPL)
          if (qmmech) then
            ECONS=ECONS + MM_EKIN
            write (6,'(50x, "TEMP: ",f10.0)') MM_TEMP
          end if
#endif
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
          CALL WRPRINT_MD(EIGV,F,AMU,NSTATE,TAUP,FION,
     &                    0.D0,TEMPP,ETOT,ECONS,0.D0,DISA,
     &                    TCPU,.FALSE.,NFI,INFI)
C         UPDATE ACCUMULATORS
          CALL PACCC(TEMPP,ETOT,ECONS,ENOSE,ENOSP,ECNSTR,ERESTR,
     *               EBOGO,DISA,TCPU,NFI,1)
C         STORE IONIC COORDINATES AND VELOCITIES FOR STATISTICS
          MOVIE=MOUT .AND. MOD(NFI-1,IMOVIE).EQ.0 
          RPRINT=ROUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TXYZ=XTOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TDCD=DCOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          CALL PRINTP(TAUR,TAUP,VELP)
          CALL PRINTFOR (TAUP,FION)
#if defined (__QMECHCOUPL)
C         --------------------------------------------------------
C..       Write to QMMM trajectory.  This trajectory file contains
C         the atoms that make up the "real" system. (no dummies)
C         --------------------------------------------------------
          if (qmmech) then
            if (ROUT .and. MOD(NFI-1,NTRAJ).EQ.0) then
              call mm_cpmd_write_trajectory(NFI)
            end if
          end if
#endif
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(INFI.EQ.NOMORE) EXSOFT=.TRUE.
C     periodic output of density/wavefunction etc.
        IF(RHOOUT.AND.(NRHOOUT.GT.0)) THEN
          IF (MOD(NFI-1,NRHOOUT).EQ.0) THEN
            CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPNT)
          ENDIF
        ENDIF
        IF(TESTSTORE(NFI).OR.EXSOFT) 
     &      CALL ZHWWF(2,IREC,C0,C2,NSTATE,EIGV,TAUP,VELP,TAUI,NFI)
#if defined (__QMECHCOUPL)
C       -----------------------
C       Write QMMM restart file
C       -----------------------
        if (PARENT.and.qmmech) then
          if(MOD(NFI,ISTORE).EQ.0.OR.INFI.EQ.NOMORE.OR.EXSOFT) THEN
            call mm_cpmd_write_restart
          end if
        end if
#endif
C     temperature ramping
        CALL TEMPRAMP(TEMP1,TEMP2)
C       STOP THE RUN IF THE USER HAS SET THE SIGNAL 30
        IF(EXSOFT) GOTO 100
C       UPDATE IONIC POSITIONS
        CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,TAU0(1,1,1),1)
C       UPDATE DENSITY
        CALL EXTRAP(NNX,ALXMIX,RM1,RIN0,RINP)
        CALL DCOPY(NNX,RIN0(1),1,RM1(1),1)
        CALL DCOPY(NNX,RINP(1),1,RIN0(1),1)
C     ==================================================================
C     ==     END OF MAIN LOOP                                         ==
C     ==================================================================
      ENDDO
      IF(PARENT) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"=",T17,A,T65,"=")')
     &       'END OF MOLECULAR DYNAMICS SIMULATION'
        WRITE(6,'(1X,64("="),/,/)')
      ENDIF
C     ==--------------------------------------------------------------==
  100 CONTINUE
      IF(RHOOUT.AND.(NRHOOUT.LE.0))
     &    CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPNT)
C     Print accumulators.
      IF(PARENT) CALL PACCC(TEMPP,ETOT,ECONS,ENOSE,ENOSP,ECNSTR,
     *                      ERESTR,EBOGO,DISA,TCPU,NFI,0)
      IF(PARENT) CALL GSIZE(FION,GNMAX,GNORM)
      IF(PARENT) CALL FINALP(TAU0,FION,VELP,EIGV)
      IF(TSAMPL) THEN
        CALL SAMPLE_GO
        GOTO 99999
      ENDIF
10000 CONTINUE
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_SCR)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_EIGV)
      CALL FREEM(IP_RINP)
      CALL FREEM(IP_RM1)
      CALL FREEM(IP_RMIX)
      CALL FREEM(IP_ROUT0)
      CALL FREEM(IP_RIN0)
      CALL FREEM(IP_TAUIO)
      CALL FREEM(IP_SAVE_FION)
      CALL FREEM(IP_TAUR)
      CALL FREEM(IP_TAUI)
      CALL FREEM(IP_FION)
      CALL FREEM(IP_TAUP)
      IF(PARENT) CALL FILECLOSE(3)
      IF(TEXTRAP) THEN
        CALL FREEM(IP_COLD)
      ENDIF
      IF(TDDFT) THEN
        CALL FREEM(IP_POTR)
        CALL FREEM(IP_RHOO)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_MDFILE(LMDDIAG,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !pslo.inc
      INCLUDE 'elct.inc'        !N number of states
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'store.inc'       !RHOOUT
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'        !TTROT
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'atwf.inc'        !TMOVR
C     Arguments
      INTEGER   LMDDIAG
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LRINITWF,LRNLSM,LRHOOFR,LCOPOT,LTDDFT,
     &          LFORCES_DIAG,LCALC_ALM,LRHOPRI,LPROPCAL,LMOVERHO
C     ==--------------------------------------------------------------==
      NSTATE=N
      LRNLSM=0
      LCALC_ALM=0
      LCOPOT=0
      LRHOPRI=0
      LMOVERHO=0
      LTDDFT=0
      CALL GIVE_SCR_RINITWF(LRINITWF,TAG,NSTATE)
      IF(TIVAN) CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
      CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
      IF(TTROT) CALL GIVE_SCR_CALC_ALM(LCALC_ALM,TAG)
      CALL GIVE_SCR_FORCES_DIAG(LFORCES_DIAG,TAG,NSTATE,.TRUE.)
      IF(TINLC) CALL GIVE_SCR_COPOT(LCOPOT,TAG)
      IF(RHOOUT) CALL GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
      CALL GIVE_SCR_PROPCAL(LPROPCAL,TAG,NSTATE)
      IF(TMOVR) CALL GIVE_SCR_MOVERHO(LMOVERHO,TAG)
      IF(TDDFT) CALL GIVE_SCR_LR_TDDFT(LTDDFT,.TRUE.,TAG)
      LMDDIAG=MAX(LRINITWF,LRNLSM,LRHOOFR,LFORCES_DIAG,LTDDFT,
     &            LCOPOT,LCALC_ALM,LRHOPRI,LPROPCAL,LMOVERHO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
c     ==================================================================
      SUBROUTINE ERBACK(MODE)
C     ==--------------------------------------------------------------==
C     == Save or restore values of energies                           ==
C     == Mode 0 -> SAVE                                               ==
C     ==      1 -> RESTORE                                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'ropt.inc'
C     Arguments
      INTEGER MODE
C     Variables
      INTEGER BNFI,BNOMORE
      REAL*8  BETOT,BEKIN,BEPSEU,BENL,BEHT,BEHEP,BEHEE,BEHII,
     &        BEXC,BVXC,BEGC,BESELF,BESR,
     &        BECNSTR,BERESTR,
     &        BCSUMG,BCSUMR,BECONS,BENOSE,BENOSP,
     &        BEHAM,BEKINC
      SAVE    BETOT,BEKIN,BEPSEU,BENL,BEHT,BEHEP,BEHEE,BEHII,
     &        BEXC,BVXC,BEGC,BESELF,BESR,
     &        BECNSTR,BERESTR,
     &        BCSUMG,BCSUMR,BECONS,BENOSE,BENOSP,
     &        BEHAM,BEKINC,BNFI,BNOMORE
C     ==--------------------------------------------------------------==
      IF(MODE.EQ.0) THEN
        BETOT=ETOT
        BEKIN=EKIN
        BEPSEU=EPSEU
        BENL=ENL
        BEHT=EHT
        BEHEP=EHEP
        BEHEE=EHEE
        BEHII=EHII
        BEXC=EXC
        BVXC=VXC
        BESELF=ESELF
        BESR=ESR
        BEGC=EGC
        BECNSTR=ECNSTR
        BERESTR=ERESTR
        BCSUMG=CSUMG
        BCSUMR=CSUMR
        BNFI=NFI
        BNOMORE=NOMORE
        NOMORE=NOMORE_ITER
c        BECONS=ECONS
c        BENOSE=ENOSE
c        BENOSP=ENOSP
c        BECNSTR=ECNSTR
c        BEHAM=EHAM
c        BEKINC=EKINC
      ELSE
        ETOT=BETOT
        EKIN=BEKIN
        EPSEU=BEPSEU
        ENL=BENL
        EHT=BEHT
        EHEP=BEHEP
        EHEE=BEHEE
        EHII=BEHII
        EXC=BEXC
        VXC=BVXC
        ESELF=BESELF
        ESR=BESR
        EGC=BEGC
        ECNSTR=BECNSTR
        ERESTR=BERESTR
        CSUMG=BCSUMG
        CSUMR=BCSUMR
        NFI=BNFI
        NOMORE=BNOMORE
c        ECONS=BECONS
c        ENOSE=BENOSE
c        ENOSP=BENOSP
c        ECNSTR=BECNSTR
c        EHAM=BEHAM
c        EKINC=BEKINC
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
