C     ==================================================================
      SUBROUTINE MDPT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'atwf.inc'        !NUMAORMAX
      INCLUDE 'kpts.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'bsym.inc'        !BSFAC
      INCLUDE 'shop.inc' 
      INCLUDE 'shop_rest.inc' 
      INCLUDE 'shop_rest_2.inc' 
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mw.inc'
C     Variables
      COMPLEX*16 C0(*),C1(*),CM(*),C2(*),SC0(*)
      REAL*8     GAMX(*),GAMY(*),VPP(*)
      POINTER    (IP_C0,C0), (IP_CM,CM), (IP_C2,C2),(IP_SC0,SC0),
     &           (IP_C1,C1), (IP_GAMX,GAMX), (IP_GAMY,GAMY),
     &           (IP_VPP,VPP)
      DIMENSION  F(*)
      INTEGER    NSTATE,NC0,NC1,NUS,NACT,NC2,NCM,NSC0,IUNIT,NXX,NMIN
      INTEGER    MS,MM,I,NSTX
      LOGICAL    statusdummy
#ifdef PARALLEL
      INTEGER    NXXFUN
      EXTERNAL   NXXFUN
#endif
C     ==--------------------------------------------------------------==
C     ==  MEMORY ALLOCATION                                           ==
C     ==--------------------------------------------------------------==
C     ==  C0         WF POSITIONS                                     ==
C     ==  CM         WF VELOCITIES                                    ==
C     ==  C2         WF FORCES                                        ==
C     ==  SC0        S*C0 (only Vanderbilt)                           ==
C     ==  GAMX       CONSTRAINT MATRIX POSITIONS                      ==
C     ==  GAMY       CONSTRAINT MATRIX VELOCITIES                     ==
C     ==--------------------------------------------------------------==
      IF ( QMNODE ) THEN
        IF(TDDFT) THEN
          CALL LR_IN
          CALL TDDFT_INPUT
          TSYMRHO=.FALSE.
        ENDIF
        NSTATE=N
cMcB
        IF ( TSHOP ) NSTATE=NST_S0+NST_S1
cMcB
        NC1=1
        NUA=1
        NUB=1
        NLINW=0
        NLINR=0
        NUS=1
        IF(TDIAG) THEN
          IF(TDDFT) CALL STOPGM('MDPT',
     &                   'TDDFT.AND.TDIAG NOT POSSIBLE')
          IF(TDAVI) THEN
            IF(NDAVV.EQ.0) THEN
              NDAVV=2*NSTATE
            ELSE
              NDAVV=MIN(NDAVV+NSTATE,2*NSTATE)
            ENDIF
            NSTATE=NDAVV
          ENDIF
          NC0=2*NGWK*NSTATE*NKPNT+8
          IF(TFRSBLK)THEN
            NCM=2*NGWK*MAX(NSTATE,(NKRY_MAX+1)*NKRY_BLOCK)+8
          ELSEIF(DIIS) THEN
            NCM=(NGWK*NSTATE+8)*MDIIS*NKPNT+
     &          ((NGWK*NSTATE+8)*MDIIS*NKPNT)/4
          ELSE
            NCM=2*NGWK*MAX(NSTATE,NKRY_MAX*NKRY_BLOCK)+8
          ENDIF
          NC2=2*NGWK*MAX(NUMAORMAX,NSTATE)+8
          IF(TDAVI)NCM=NCM*2
          CALL MEMORY(IP_VPP,NGWK,'VPP')
CEHR[
        ELSEIF(TMDBO.OR.TMDFILE.OR.TMDEH) THEN
CEHR]
          IF(TSDE) THEN
            NCM=8
          ELSE IF(DIIS) THEN
            NCM=(NGWK*NSTATE+8)*MDIIS*NKPNT+
     &      ((NGWK*NSTATE+8)*MDIIS*NKPNT)/4+100
          ELSE IF(PCG) THEN
            NCM=2*NGWK*NSTATE*NKPNT+8
          ELSEIF (TMDEH) THEN
            NCM=2*NGWK*NSTATE*NKPNT+8
          ENDIF
C CB: Need memory for two wf in BS case          
          NC0=(2*NGWK*NSTATE*NKPNT+8)*BSFAC
          NC2=(2*NGWK*NSTATE+8)*BSFAC
          CALL MEMORY(IP_VPP,NGWK,'VPP')
          IF(TDDFT) THEN
            DO I=1,NSTATE
              IF(F(I).LT.1.D-6) CALL STOPGM('TDDFT',
     *                            'ALL STATES HAVE TO BE OCCUPIED')
            ENDDO
            MS=MAX(NS_MIX,NS_SIN,NS_TRI)
            IF(TDA.AND.LDIAG.EQ.1) THEN
              MM=1
            ELSE
              MM=2
            ENDIF
            IF(TDA.AND.MSUBTA.GT.0) THEN
              NACT=MSUBTA
            ELSE
              NACT=NSTATE
            ENDIF
            NOLR=NACT
            NC1=2*NGW*NACT*MS*MM
            NUA=NSTATE
            NUB=NACT
            NLINW=MS
            NLINR=0
            NUS=2*NUA*NUB
C..TSH[
            IF (TDLZ.OR.TDTULLY) THEN
             NC0=2*NGWK*(2*(NSTATE+MS))*NKPNT+8
             NC2=2*NGWK*(2*(NSTATE+MS))*NKPNT+8
            ENDIF
C..TSH]
          ENDIF
        ELSE
          IF(TDDFT) CALL STOPGM('MDPT',
     &                   'TDDFT.AND.CP NOT POSSIBLE')
C     NN  For the BS-CPMD, HS & BS wavefunctions are propagated at the 
C     same time, thus the array sizes of C0,CM and C2 are multiplied by 2 
          NC0=(2*NGWK*NSTATE*NKPNT+8)*BSFAC
          NCM=(2*NGWK*NSTATE*NKPNT+8)*BSFAC
          NC2=(2*NGWK*NSTATE+8)*BSFAC
        ENDIF
        NSC0=1
        IF(TIVAN.OR.NONORT.OR.(QUENCHB.AND.PCG.AND.PCGMIN)) THEN
          NSC0=2*NGWK*NSTATE*NKPNT*BSFAC
        ENDIF
        IF(TDIPD) THEN
          IF(TDDFT) CALL STOPGM('MDPT',
     &        'TDDFT AND DIPOLE DYNAMICS NOT POSSIBLE')
#ifdef PARALLEL
          LENBK=NXXFUN(NSTATE)
          NXX=MAX(2*LENBK*NPROC,NC2)
          NSC0=MAX(NXX,NSC0)
#else
          NXX=NC2
#endif
          NC2=NXX
        ENDIF
        IF(TSHOP) THEN
          NC0=2*NC0
          NCM=2*NCM
          NC2=2*NC2
          CALL MEMORY(IP_C0OLD,NC0,'C0OLD')
          CALL MEMORY(IP_C0OLD2,NC0,'C0OLD2')
        ELSE
          NMIN=10
          CALL MEMORY(IP_C0OLD,NMIN,'C0OLD')
          CALL MEMORY(IP_C0OLD2,NMIN,'C0OLD2')
        ENDIF
        CALL MEMORY(IP_C0,NC0,'C0')
C..TSH[
        IF (TDTULLY) THEN
          CALL MEMORY(IP_CK,NC0,'CK')
          CALL MEMORY(IP_C1K,NC1,'C1K')
        ENDIF
C..TSH]
        CALL MEMORY(IP_CM,NCM,'CM')
        CALL MEMORY(IP_C1,NC1,'C1')
        CALL MEMORY(IP_C2,NC2,'C2')
        CALL MEMORY(IP_SC0,NSC0,'SC0')
        CALL MEMORY(IP_UROT,NUS,'UROT')
        CALL AZZERO(UROT,NUS)
        IP_CLRWF=IP_C1
        IF(TDMAL) THEN
          CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
          CALL MEMORY(IP_GAMX,NSTATE*NSTX*BSFAC,'GAMX') 
          CALL MEMORY(IP_GAMY,NSTATE*NSTX*BSFAC,'GAMY') 
        ELSE
          CALL MEMORY(IP_GAMX,NSTATE*NSTATE*BSFAC,'GAMX') 
          CALL MEMORY(IP_GAMY,NSTATE*NSTATE*BSFAC,'GAMY') 
        ENDIF
C     ==--------------------------------------------------------------==
C       FNL and DFNL
        call mm_dim(mm_go_qm,statusdummy)
C
        IF (SH_DIAG) THEN
         CALL FNLALLOC(NSTATE+MS+2,.TRUE.,TPRES)
        ELSE
         CALL FNLALLOC(NSTATE,.TRUE.,TPRES)
        ENDIF
        call mm_dim(mm_revert,statusdummy)
      ELSE
        NMIN = 10
        CALL MEMORY(IP_C0,NMIN,'C0')
        CALL MEMORY(IP_CM,NMIN,'CM')
        CALL MEMORY(IP_C1,NMIN,'C1')
        CALL MEMORY(IP_C2,NMIN,'C2')
        CALL MEMORY(IP_SC0,NMIN,'SC0')
        CALL MEMORY(IP_UROT,NMIN,'UROT')
        CALL MEMORY(IP_GAMX,NMIN,'GAMX')
        CALL MEMORY(IP_GAMY,NMIN,'GAMY')
        CALL MEMORY(IP_VPP,NMIN,'VPP')
c
        CALL MEMORY(IP_C0OLD,NMIN,'C0OLD')
        CALL MEMORY(IP_C0OLD2,NMIN,'C0OLD2')
c
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PARENT) CALL PRMEM('      MDPT')
C     ==--------------------------------------------------------------==

      IF ( TSHOP.AND.(TFUSI.OR.TSEP) ) THEN 
C        CALL STOPGM('MDPT','TSHOP.AND.(TFUSI.OR.TSEP) NOT POSSIBLE')
         IF (TFUSI) THEN
            CALL FUSION(C0,CM)
         ELSEIF (TSEP) THEN
            CALL SEPARATE(C0,CM)
         ENDIF
         GO TO 500
      ENDIF

      IF ( TDDFT.AND.TSHOP ) THEN
         CALL STOPGM('MDPT','TDDFT.AND.TSHOP NOT POSSIBLE')
      ENDIF

      IF ( BSYMM.AND.TSHOP ) THEN
         CALL STOPGM('MDPT','BROKEN SYMMETRY WITH SURFACE HOPPING '
     &                    // 'NOT POSSIBLE')
      ENDIF
C
      IF((TSHOP.OR.TQMMM.OR.TDDFT.OR.TMDFILE.OR.TMDBO.OR.TCLAS)
     &   .AND.TMW)CALL STOPGM('MDPT',' MULTIPLE WALKER IS NOT '
     &            //'IMPLEMENTED FOR THE REQUIRED MD TYPE')
C
      IF(TCLAS) THEN
        IF(TKPNT)CALL STOPGM('MDPT','K-POINTS NOT IMPLEMENTED')
        IF(TDDFT) CALL STOPGM('MDPT','TDDFT.AND.TCLAS NOT POSSIBLE')
        IUNIT=5
        CALL CL_INIT(IUNIT)
        CALL MDCLAS(C0,CM,C2,SC0,GAMX,GAMY)
CEHR[
      ELSEIF(TMDBO.OR.TMDEH) THEN
CEHR]
        IF ( TQMMM ) THEN
          IF ( TSHOP ) THEN
C             CALL STOPGM('MDPT','SURFACE HOPPING WITH BO-MD AND QM/MM '
C    .                    // 'NOT IMPLEMENTED')
             CALL MM_MDSHOP_BO(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
          ELSE
             CALL MM_MDDIAG(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
          ENDIF
        ELSE
          IF ( TSHOP ) THEN
C             CALL STOPGM('MDPT','TMDBO.AND.TSHOP NOT POSSIBLE')
             CALL MDSHOP_BO(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
          ELSE
             CALL MDDIAG(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
          ENDIF
        ENDIF
      ELSEIF(TMDFILE) THEN
         CALL MDFILE(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
      ELSE
        IF(TKPNT)CALL STOPGM('MDPT','K-POINTS NOT IMPLEMENTED')
        IF(TDDFT) CALL STOPGM('MDPT','TDDFT.AND.CP NOT POSSIBLE')
        IF ( TQMMM ) THEN
          IF ( TSHOP ) THEN
C            CALL STOPGM('MDPT','TQMMM.AND.TSHOP NOT POSSIBLE')
             CALL MM_MDSHOP_CP(C0,CM,C2,SC0,GAMX,GAMY)
          ELSE
             CALL MM_MDMAIN(C0,CM,C2,SC0,GAMX,GAMY)
          ENDIF
        ELSE
          IF ( TSHOP ) THEN
c            CALL STOPGM('MDPT','SURFACE HOPPING NOT POSSIBLE')
             CALL MDSHOP_CP(C0,CM,C2,SC0,GAMX,GAMY)
          ELSE
             CALL MDMAIN(C0,CM,C2,SC0,GAMX,GAMY)
          ENDIF
        ENDIF
      ENDIF
 500  CONTINUE
C     ==--------------------------------------------------------------==
      IF(TMEMCHK) CALL PRINT_MEMORY
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_C0)
      CALL FREEM(IP_CM)
      CALL FREEM(IP_C1)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_SC0)
      CALL FREEM(IP_UROT)
      CALL FREEM(IP_GAMX)
      CALL FREEM(IP_GAMY)
      IF (TSHOP) THEN
         CALL FREEM(IP_C0OLD)
         CALL FREEM(IP_C0OLD2)
      ENDIF
      IF ( QMNODE ) THEN
        CALL FNLDEALLOC(.TRUE.,TPRES)
      ELSE
        CALL FREEM(IP_VPP)
      ENDIF
C..TSH[
      IF (TDTULLY) THEN
        CALL FREEM(IP_CK)
        CALL FREEM(IP_C1K)
      ENDIF
C..TSH]
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
