C     ==================================================================
      SUBROUTINE CALC_AVER(TOLLM,I_CVST,I_TEMP,I_META,CV_STORE,CV_LAST,
     &                     CV_AVER,SCR,LSCR,HILL_ADD)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'

      INTEGER    I_CVST,I_TEMP,I_META,LSCR
      REAL*8     TOLLM,CV_AVER(NCOLVAR),CV_LAST(NCOLVAR),
     &           CV_STORE(INTER_HILL,NCOLVAR),SCR(LSCR)
      LOGICAL    HILL_ADD

      DIMENSION  CSCL_FAC(3,NCOLVAR)   
      INTEGER    II,IJ,ICV
      REAL*8     SUM,MIN_DISP,DIFF,AV_DISP


C     ==--------------------------------------------------------------==
C     Store CV values and Check averages

      IF(I_CVST .LT.  INTER_HILL ) THEN
        II = I_CVST
!$OMP parallel do private(ICV)
        DO ICV = 1,NCOLVAR
          CV_STORE(II,ICV) = CV_IST(ICV)
        ENDDO
      ELSEIF(I_CVST .EQ.  INTER_HILL ) THEN
        MIN_DISP = 100.0D0
        II = INTER_HILL

        AV_DISP  = 0.0D0
        DO ICV = 1,NCOLVAR
          SUM = 0.0D0
          DO IJ = 1,INTER_HILL-1
            SUM = SUM + CV_STORE(IJ,ICV)
          ENDDO
          CV_STORE(II,ICV) = CV_IST(ICV)
          SUM = SUM + CV_STORE(II,ICV)
          CV_AVER(ICV) = SUM/DBLE(INTER_HILL)
          DIFF = ((CV_AVER(ICV)-CV_LAST(ICV))/CSCL_FAC(1,ICV))**2.0D0

          AV_DISP = AV_DISP + DIFF
          MIN_DISP = MIN(DIFF,MIN_DISP)
        ENDDO
        AV_DISP = DSQRT(AV_DISP)
        IF(AV_DISP .GT. TOLLM .OR. I_META .EQ. 1) HILL_ADD = .TRUE.

        write(6,'(/10x,A,f10.6,A,f10.6,A,f10.6/)') 
     &      'MIN DISP. = ',DSQRT(MIN_DISP),'  ||DISP.tot|| = ', AV_DISP,
     &      '  Tolerance ',TOLLM
      ELSEIF(I_CVST .GT.  INTER_HILL ) THEN
 
        I_TEMP = I_TEMP + 1
        II = INTER_HILL
        MIN_DISP = 100.0D0
        DO ICV = 1,NCOLVAR
          SUM = 0.0D0
          DO IJ = 1,INTER_HILL-1
            CV_STORE(IJ,ICV) = CV_STORE(IJ+1,ICV)
            SUM = SUM + CV_STORE(IJ,ICV)
          ENDDO
          CV_STORE(II,ICV) = CV_IST(ICV)
          SUM = SUM + CV_STORE(II,ICV)
          CV_AVER(ICV) = SUM/DBLE(INTER_HILL)
          DIFF = ((CV_AVER(ICV)-CV_LAST(ICV))/CSCL_FAC(1,ICV))**2
          SCR(ICV) = DIFF
          MIN_DISP = MIN(DIFF,MIN_DISP)
        ENDDO
         IF(MOD(I_TEMP,ICHECK) .EQ. 0 ) THEN

          AV_DISP = 0.0D0 
          DO ICV = 1,NCOLVAR

            AV_DISP = AV_DISP+SCR(ICV)
          ENDDO
          AV_DISP = DSQRT(AV_DISP)
          write(6,'(/10x,A,f10.6,A,f10.6,A,f10.6/)') 
     &      'MIN DISP. = ',DSQRT(MIN_DISP),'  ||DISP.tot|| = ',AV_DISP,
     &       '  Tolerance ',TOLLM
           IF(AV_DISP .GT. TOLLM .OR. I_CVST .EQ. INTER_HILL_MAX) THEN 
            HILL_ADD = .TRUE.

          ENDIF
        ENDIF

      ENDIF   !I_CVST
C     ==--------------------------------------------------------------==

      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      SUBROUTINE  CV_WRITE_OUT(I_META,CV_LAST,CV_AVER,F1_CV,F2_CV,
     &           CVD_IST,CV_SCL,CVD_SCL,DISPLACEMENT,EKINC,EKINP)

      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'ener.inc'
      INCLUDE  'nose.inc'
      INCLUDE  'cnst.inc'
      INCLUDE  'ropt.inc'
      INCLUDE  'fileopen.inc'
C     ==--------------------------------------------------------------==

      INTEGER       I_META
      REAL*8        CV_AVER(NCOLVAR),CV_LAST(NCOLVAR),
     &              F1_CV(NCOLVAR),F2_CV(NCOLVAR),
     &              CVD_IST(NCOLVAR),CV_SCL(NCOLVAR),CVD_SCL(NCOLVAR),
     &              DISPLACEMENT,EKINC,EKINP

      DIMENSION     CSCL_FAC(3,NCOLVAR)

      REAL*8        T_ION
      CHARACTER*20  FILE1,FILE2,FILE3,FILE4,FILE5,FILE6
      DATA          FILE1,FILE2,FILE3,FILE4,FILE5,FILE6
     *     /'colvar_mtd','parvar_mtd','scavar_mtd','forfac_mtd',
     &      'disvar_mtd','enevar_mtd' /

      INTEGER       IFIRST
      DATA          IFIRST /FO_VERB/
      SAVE          IFIRST

      CHARACTER     TAG,LINEFORM*100,CHNUM*10
      LOGICAL       FERROR

      INTEGER       IA,IE,IAA,IEE,ICV


C     ==--------------------------------------------------------------==
C     Open output files
      CALL FILEOPEN(51,FILE1,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(52,FILE2,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(53,FILE3,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(54,FILE4,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(55,FILE5,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(56,FILE6,FO_APP+IFIRST,FERROR)
C     Verbose open only on the first run
      IFIRST=0
C     ==--------------------------------------------------------------==


C     Write output
      WRITE(CHNUM,'(I5)') NCOLVAR
      CALL XSTRING(CHNUM,IAA,IEE)
      LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E13.4)'
      WRITE(51,LINEFORM) NFI,(CV_LAST(ICV),ICV=1,NCOLVAR),
     &                     (CSCL_FAC(1,ICV),ICV=1,NCOLVAR)

      LINEFORM = 
     &     '(1X,I7,3F14.6)'
      WRITE(52,LINEFORM) NFI,
     &                DISPLACEMENT,HLLW,HLLH
C     Close files
      CALL FILECLOSE(51)
      CALL FILECLOSE(52)


      LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E14.6)'
      WRITE(53,LINEFORM) NFI,(CV_SCL(ICV),ICV=1,NCOLVAR),
     *              (CVD_SCL(ICV),ICV=1,NCOLVAR)
C     Close files
      CALL FILECLOSE(53)

C     Print force factors
      LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E14.6)'
      WRITE(54,LINEFORM) NFI,(F1_CV(ICV),ICV=1,NCOLVAR),
     *              (F2_CV(ICV),ICV=1,NCOLVAR)

C     Close files
      CALL FILECLOSE(54)

C     Print last displacements
      LINEFORM = 
     &     '(I6,'//CHNUM(IAA:IEE)//'f11.6,'//CHNUM(IAA:IEE)//
     &     'f10.6)'
      WRITE(55,LINEFORM) NFI,
     &      ((CV_AVER(ICV)-CV_LAST(ICV)),ICV=1,NCOLVAR),
     &                (CVD_IST(ICV),ICV=1,NCOLVAR)

      T_ION = EKINP*FACTEM*2.D0/GLIB
      LINEFORM = '(I6,5E14.5)'
      WRITE(56,LINEFORM) NFI,
     &                   T_ION,EKINC,GAUSSPOT,
     &                   ETOT,EHAM_HILL+GAUSSPOT
C     Close files
      CALL FILECLOSE(55)
      CALL FILECLOSE(56)

C     ==--------------------------------------------------------------==

      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      SUBROUTINE  CV_DIFFUSION(CV_LAST,CVD_IST,CVD_SCL,CV_SCL,
     &            I_META,SCR,LSCR,NTOT_ITER)

      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'

      INTEGER   I_META,LSCR
      REAL*8    CV_LAST(NCOLVAR),CVD_IST(NCOLVAR),CVD_SCL(NCOLVAR),
     &          CV_SCL(NCOLVAR),SCR(LSCR)
      CHARACTER*100 OUT1

      INTEGER   ICV,II,itt,NTOT_ITER
      REAL*8    DIFF

      DIMENSION     CV_PATH(NTOT_ITER,NCOLVAR),
     &              CSCL_VAL(NTOT_ITER,NCOLVAR),
     &              HLLW_VAL(NTOT_ITER),
     &              HLLH_VAL(NTOT_ITER),
     &              CSCL_FAC(3,NCOLVAR)
  
C     ==--------------------------------------------------------------==
C     Diffusion calculation


      CALL AZZERO(CVD_IST,NCOLVAR)
      CALL AZZERO(CVD_SCL,NCOLVAR)

      DO ICV = 1,NCOLVAR

        DO II = 1,I_META-1
          DIFF = DABS(CV_PATH(II,ICV)-CV_LAST(ICV))
          IF (IANGCV(ICV) .EQ. 1 .AND. DIFF .GT. PI) THEN
            DIFF = DIFF - 2.0D0*PI
          ENDIF
          CVD_IST(ICV) = CVD_IST(ICV) + 
     &                 DIFF/DBLE(I_META-II)
          CVD_SCL(ICV) = CVD_SCL(ICV) +
     &                 DIFF/DBLE(I_META-II)/CSCL_VAL(II,ICV)
        ENDDO
        CV_SCL(ICV) = CV_LAST(ICV) / CSCL_FAC(1,ICV)
      ENDDO
!$OMP parallel do private(ICV)
      DO ICV  = 1,NCOLVAR
        CV_PATH(I_META,ICV) =  CV_LAST(ICV)
        CSCL_VAL(I_META,ICV)=  CSCL_FAC(1,ICV)
      ENDDO
      HLLW_VAL(I_META)    =  HLLW
      HLLH_VAL(I_META)    =  HLLH

C     ==--------------------------------------------------------------==

      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
 
      SUBROUTINE CALC_POS(TOLLM,I_CVST,I_TEMP,I_META,CV_LAST,
     &                     CV_AVER,SCR,LSCR,HILL_ADD)

      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'

      INTEGER    I_CVST,I_TEMP,I_META,LSCR
      REAL*8     TOLLM,CV_AVER(NCOLVAR),CV_LAST(NCOLVAR),
     &           SCR(LSCR)
      LOGICAL    HILL_ADD

      DIMENSION  CSCL_FAC(3,NCOLVAR)   
      INTEGER    II,ICV
      REAL*8     MIN_DISP,DIFF,AV_DISP


C     ==--------------------------------------------------------------==
C     Store CV values and Check averages

      
      IF(I_CVST .EQ.  INTER_HILL ) THEN
        MIN_DISP = 100.0D0
        II = INTER_HILL
        AV_DISP  = 0.0D0
        DO ICV = 1,NCOLVAR
          CV_AVER(ICV) = CV_IST(ICV)
          DIFF = ((CV_IST(ICV)-CV_LAST(ICV))/CSCL_FAC(1,ICV))**2.0D0
          AV_DISP = AV_DISP + DIFF
          MIN_DISP = MIN(DIFF,MIN_DISP)
        ENDDO
        AV_DISP = DSQRT(AV_DISP)
        IF(AV_DISP .GT. TOLLM .OR. I_META .EQ. 1) HILL_ADD = .TRUE.

        write(6,'(/10x,A,f10.6,A,f10.6,A,f10.6/)') 
     &      'MIN DISP. = ',DSQRT(MIN_DISP),'  ||DISP.tot|| = ', AV_DISP,
     &      '  Tolerance ',TOLLM
      ELSEIF(I_CVST .GT.  INTER_HILL ) THEN
 
        I_TEMP = I_TEMP + 1
        II = INTER_HILL
        MIN_DISP = 100.0D0
        DO ICV = 1,NCOLVAR
          CV_AVER(ICV) = CV_IST(ICV)
          DIFF = ((CV_AVER(ICV)-CV_LAST(ICV))/CSCL_FAC(1,ICV))**2
          SCR(ICV) = DIFF
          MIN_DISP = MIN(DIFF,MIN_DISP)
        ENDDO
        IF(MOD(I_TEMP,ICHECK) .EQ. 0 ) THEN
          AV_DISP = 0.0D0 
          DO ICV = 1,NCOLVAR
            AV_DISP = AV_DISP+SCR(ICV)
          ENDDO
          AV_DISP = DSQRT(AV_DISP)
          write(6,'(/10x,A,f10.6,A,f10.6,A,f10.6/)') 
     &      'MIN DISP. = ',DSQRT(MIN_DISP),'  ||DISP.tot|| = ',AV_DISP,
     &       '  Tolerance ',TOLLM
           IF(AV_DISP .GT. TOLLM .OR. I_CVST .EQ. INTER_HILL_MAX) THEN 
            HILL_ADD = .TRUE.
          ENDIF
        ENDIF

      ENDIF   !I_CVST
C     ==--------------------------------------------------------------==

      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      SUBROUTINE TUNE_HEIGHT(F_AVER,VELP,FION,TSCR,SCR,LSCR)
      IMPLICIT NONE

      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cotr.inc'
      INCLUDE  'tpar.inc'
      INCLUDE  'ions.inc'

      INTEGER    LSCR
      REAL*8     VELP(3,NAX,NSX),FION(3,NAX,NSX),TSCR(3,NAX,NSX)
      REAL*8     F_AVER(NCOLVAR),SCR(LSCR)
      
      DIMENSION  DET_COLVAR(NODIM,NCOLVAR)
      REAL*8     DELTAR(NODIM),HINV(NCOLVAR,NODIM),
     &           TMAT(NCOLVAR,NCOLVAR),BMAT(NCOLVAR,NCOLVAR)
      pointer    (IP_DELTAR,DELTAR),(IP_TMAT,TMAT),(IP_BMAT,BMAT),
     &           (IP_HINV,HINV)
      INTEGER    IS,IA,K,JCV,ICV,IDOF,INFO
      INTEGER    L_DELTAR,L_TMAT,L_HINV,LENGTH
      REAL*8     FACT
      CHARACTER  TAG

C     ==--------------------------------------------------------------==
#ifdef _BGL 
      L_DELTAR = NODIM + MOD(NODIM,2)
      L_TMAT   = NCOLVAR*NCOLVAR + MOD(NCOLVAR*NCOLVAR,2)
      L_HINV   = NCOLVAR*NODIM + MOD(NCOLVAR*NODIM,2)
#else
      L_DELTAR = NODIM
      L_TMAT   = NCOLVAR*NCOLVAR
      L_HINV   = NCOLVAR*NODIM
#endif

      LENGTH   = L_DELTAR + 2 * L_TMAT  + L_HINV

      CALL TEST_SCR('TUNE_HEIGHT',TAG,LSCR,LENGTH)

      CALL GET_ADDR(IP_DELTAR,SCR(1))
      CALL GET_ADDR(IP_TMAT,SCR(1 + L_DELTAR))
      CALL GET_ADDR(IP_BMAT,SCR(1 + L_DELTAR + L_TMAT))
      CALL GET_ADDR(IP_HINV,SCR(1 + L_DELTAR + 2*L_TMAT))
C     ==--------------------------------------------------------------==
!$OMP parallel do private(IS,IA,FACT)
      DO IS=1,NSP
        FACT = 1.D0/(DT_IONS*DTB2MI(IS))
        DO IA=1,NA(IS)
          TSCR(1,IA,IS)  =
     &             FACT*(FION(1,IA,IS)*DTB2MI(IS)+VELP(1,IA,IS))
          TSCR(2,IA,IS)  =
     &             FACT*(FION(2,IA,IS)*DTB2MI(IS)+VELP(2,IA,IS))
          TSCR(3,IA,IS)  =
     &             FACT*(FION(3,IA,IS)*DTB2MI(IS)+VELP(3,IA,IS))
        ENDDO
      ENDDO
      CALL PUTTAU(TSCR,DELTAR)

      CALL AZZERO(TMAT,NCOLVAR*NCOLVAR)
!$OMP parallel do private(JCV,ICV,IDOF)
      DO JCV = 1,NCOLVAR
        DO ICV = 1,NCOLVAR
          DO IDOF = 1,NODIM
            TMAT(ICV,JCV) = TMAT(ICV,JCV) + 
     &              DET_COLVAR(IDOF,ICV)*DET_COLVAR(IDOF,JCV)
          ENDDO
        ENDDO
      ENDDO

      CALL INVMAT(NCOLVAR,TMAT,BMAT,INFO)

C     HINV(NCOLVAR,NODIM) is the inverse of DET_COLVAR(NDIM,NCOLVAR)
      CALL AZZERO(HINV,NODIM*NCOLVAR)
!$OMP parallel do private(IDOF,ICV,JCV)
      DO IDOF = 1,NODIM
        DO ICV = 1,NCOLVAR
          DO JCV = 1,NCOLVAR
            HINV(ICV,IDOF) = HINV(ICV,IDOF) + 
     &              TMAT(ICV,JCV)*DET_COLVAR(IDOF,JCV)
          ENDDO
        ENDDO
      ENDDO
!$OMP parallel do private(ICV,IDOF)
      DO ICV = 1,NCOLVAR
        DO IDOF = 1,NODIM
          F_AVER(ICV) = F_AVER(ICV) + HINV(ICV,IDOF)*DELTAR(IDOF)
        ENDDO
      ENDDO

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      SUBROUTINE CV_FORCES3(TAUP,TSCR,VELP,CV_F_NEW,SCR,LSCR)

      IMPLICIT  NONE      

      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cotr.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'

C     Arguments
      INTEGER       LSCR
      REAL*8        TAUP(3,NAX,NSX),TSCR(3,NAX,NSX),CV_F_NEW(NCOLVAR),
     *              VELP(3,NAX,NSX),SCR(LSCR)
C     Variables
      INTEGER       IFIRST
      DATA          IFIRST /0/
      SAVE          IFIRST
      DIMENSION     DET_COLVAR(NODIM,NCOLVAR)
      REAL*8        TOL_CV_F,TOL_CV_X
      PARAMETER     (TOL_CV_F=1.D-4,TOL_CV_X=1.D-5)
      INTEGER       MAXRAT,MRDIIS
      PARAMETER     (MAXRAT=10,MRDIIS=5)
      REAL*8        DX(*),ASL(NCOLVAR,NCOLVAR),XLO(NCOLVAR,*)
      POINTER       (IP_DX,DX),(IP_ASL,ASL),(IP_XLO,XLO)
      REAL*8        ERR(NCOLVAR,*),V(MRDIIS+1),DIISM(MRDIIS+1,MRDIIS+1)
      POINTER       (IP_ERR,ERR)
      REAL*8        FACT,FACT2,ERRF,ERRX,DASUM,DDOT,SUM
      EXTERNAL      DASUM,DDOT
      INTEGER       IPVT(*)
      POINTER       (IP_IPVT,IPVT)

      REAL*8        CV_STR(NCOLVAR),DCV_DR_STR(NODIM,NCOLVAR)
      POINTER   (IP_CV_STR,CV_STR),(IP_DCV_DR_STR,DCV_DR_STR)
      REAL*8        R_NEW(3,NAX,NSX),R_NNEW(3,NAX,NSX), R_OLD(3,NAX,NSX)
      POINTER   (IP_R_NEW,R_NEW),(IP_R_NNEW,R_NNEW),(IP_R_OLD,R_OLD)
      REAL*8        CV_NEW(NCOLVAR),CV_OLD(NCOLVAR)
      POINTER   (IP_CV_NEW,CV_NEW),(IP_CV_OLD,CV_OLD)
      REAL*8        DCV_DR_NEW(NODIM,NCOLVAR)
      POINTER   (IP_DCV_DR_NEW,DCV_DR_NEW)
      REAL*8        CV_F_OLD(NCOLVAR),CV_DIFF(NCOLVAR)
      POINTER       (IP_CV_F_OLD,CV_F_OLD),(IP_CV_DIFF,CV_DIFF)
 
      SAVE          IP_CV_F_OLD

      INTEGER       LENGTH,IDOF,ICV,JCV,I,J,K,INFO,IDIIS,M,IS,IA,ITER
      INTEGER       ICOUNT,JCOUNT,NACTIVE,IFLAG(NCOLVAR),IPOS(NCOLVAR)
      INTEGER       LI_COL,LI_AT
      POINTER       (IP_IFLAG,IFLAG),(IP_IPOS,IPOS)
      CHARACTER     TAG

C     ==--------------------------------------------------------------==
C     Memory Allocation at IFIRST=0
      IF(IFIRST .EQ. 0) THEN
        CALL MEMORY(IP_CV_F_OLD,NCOLVAR,'CV_F_OLD')
        CALL AZZERO(CV_F_OLD,NCOLVAR)

        CALL MEMORY(IP_DX,3*NODIM,'DX')
        CALL MEMORY(IP_ASL,NCOLVAR*NCOLVAR,'ASL')
        CALL MEMORY(IP_IPVT,NCOLVAR,'IPVT')
        CALL MEMORY(IP_XLO,NCOLVAR*MRDIIS,'XLO')
        CALL MEMORY(IP_ERR,NCOLVAR*MRDIIS,'ERR')
        CALL MEMORY(IP_IFLAG,NCOLVAR,'IFLAG')
        CALL MEMORY(IP_IPOS,NCOLVAR,'IPOS')
        IFIRST = 1
      ENDIF
      CALL AZZERO(ASL,NCOLVAR*NCOLVAR)
      CALL AZZERO(XLO,NCOLVAR*MRDIIS)
      CALL AZZERO(ERR,NCOLVAR*MRDIIS)
      CALL IAZZERO(IFLAG,NCOLVAR)
      CALL IAZZERO(IPOS,NCOLVAR)
C     ==--------------------------------------------------------------==

      LENGTH = 4*NCOLVAR + 3*3*NAX*NSX + 2*NODIM*NCOLVAR
      CALL TEST_SCR('CV_FORCES',TAG,LSCR,LENGTH)
#ifdef _BGL 
      LI_COL=NCOLVAR+MOD(NCOLVAR,2)
      LI_AT=3*NAX*NSX
      CALL GET_ADDR(IP_CV_STR,SCR(1))
      CALL AZZERO(CV_STR,NCOLVAR)
      CALL GET_ADDR(IP_CV_NEW,SCR(1+LI_COL))
      CALL AZZERO(CV_NEW,NCOLVAR)
      CALL GET_ADDR(IP_CV_OLD,SCR(1+2*LI_COL))
      CALL AZZERO(CV_OLD,NCOLVAR)
      CALL GET_ADDR(IP_CV_DIFF,SCR(1+3*LI_COL))
      CALL AZZERO(CV_DIFF,NCOLVAR)
      CALL GET_ADDR(IP_R_NEW,SCR(1+4*LI_COL))
      CALL AZZERO(R_NEW,3*NAX*NSX)
      CALL GET_ADDR(IP_R_NNEW,SCR(1+4*LI_COL+LI_AT))
      CALL AZZERO(R_NNEW,3*NAX*NSX)
      CALL GET_ADDR(IP_R_OLD,SCR(1+4*LI_COL+2*LI_AT))
      CALL AZZERO(R_OLD,3*NAX*NSX)
      CALL GET_ADDR(IP_DCV_DR_STR,SCR(1+4*LI_COL+3*LI_AT))
      CALL AZZERO(DCV_DR_STR,NODIM*NCOLVAR)
      CALL GET_ADDR(IP_DCV_DR_NEW,
     &              SCR(1+4*LI_COL+3*LI_AT+NODIM*NCOLVAR))
      CALL AZZERO(DCV_DR_NEW,NODIM*NCOLVAR)
#else
      CALL GET_ADDR(IP_CV_STR,SCR(1))
      CALL AZZERO(CV_STR,NCOLVAR)
      CALL GET_ADDR(IP_CV_NEW,SCR(1+NCOLVAR))
      CALL AZZERO(CV_NEW,NCOLVAR)
      CALL GET_ADDR(IP_CV_OLD,SCR(1+2*NCOLVAR))
      CALL AZZERO(CV_OLD,NCOLVAR)
      CALL GET_ADDR(IP_CV_DIFF,SCR(1+3*NCOLVAR))
      CALL AZZERO(CV_DIFF,NCOLVAR)
      CALL GET_ADDR(IP_R_NEW,SCR(1+4*NCOLVAR))
      CALL AZZERO(R_NEW,3*NAX*NSX)
      CALL GET_ADDR(IP_R_NNEW,SCR(1+4*NCOLVAR+3*NAX*NSX))
      CALL AZZERO(R_NNEW,3*NAX*NSX)
      CALL GET_ADDR(IP_R_OLD,SCR(1+4*NCOLVAR+2*3*NAX*NSX))
      CALL AZZERO(R_OLD,3*NAX*NSX)
      CALL GET_ADDR(IP_DCV_DR_STR,SCR(1+4*NCOLVAR+3*3*NAX*NSX))
      CALL AZZERO(DCV_DR_STR,NODIM*NCOLVAR)
      CALL GET_ADDR(IP_DCV_DR_NEW,
     &              SCR(1+4*NCOLVAR+3*3*NAX*NSX+NODIM*NCOLVAR))
      CALL AZZERO(DCV_DR_NEW,NODIM*NCOLVAR)
#endif

C     Store Values
      CALL DCOPY(NCOLVAR,CV_IST,1,CV_STR,1)
      CALL DCOPY(NCOLVAR*NODIM,DET_COLVAR,1,DCV_DR_STR,1)

C     Old Ions Positions aCV and DET_CV
!$OMP parallel do private(IS,IA)
      DO IS=1,NSP
        DO IA=1,NA(IS)
          R_OLD(1,IA,IS) = TAUP(1,IA,IS) - VELP(1,IA,IS)*DT_IONS
          R_OLD(2,IA,IS) = TAUP(2,IA,IS) - VELP(2,IA,IS)*DT_IONS
          R_OLD(3,IA,IS) = TAUP(3,IA,IS) - VELP(3,IA,IS)*DT_IONS
        ENDDO
      ENDDO
      CALL COLVAROFR(R_OLD,TSCR)
      CALL DCOPY(NCOLVAR, CV_IST,1,CV_OLD,1)

C     New Ions Positions aCV and DET_CV
!$OMP parallel do private(IS,IA,FACT)
      DO IS=1,NSP
        FACT=-DT_IONS*DTB2MI(IS)
        DO IA=1,NA(IS)
          R_NEW(1,IA,IS) =  R_OLD(1,IA,IS)+
     &                   (VELP(1,IA,IS)*DT_IONS
     &                     +FACT*FHILLS(1,IA,IS))
          R_NEW(2,IA,IS) =  R_OLD(2,IA,IS)+
     &                   (VELP(2,IA,IS)*DT_IONS
     &                     +FACT*FHILLS(2,IA,IS))
          R_NEW(3,IA,IS) =  R_OLD(3,IA,IS)+
     &                   (VELP(3,IA,IS)*DT_IONS
     &                     +FACT*FHILLS(3,IA,IS))
        ENDDO
      ENDDO
      CALL COLVAROFR(R_NEW,TSCR)
 
      CALL DCOPY(NCOLVAR, CV_IST,1,CV_NEW,1)
      CALL DCOPY(NCOLVAR*NODIM,DET_COLVAR,1,DCV_DR_NEW,1)
 
C     First Guess for the forces
      CALL AZZERO(DX,NODIM)
      DO ICV=1,NCOLVAR
!$OMP parallel do private(IDOF)
        DO IDOF=1,NODIM
          DX(IDOF)=DX(IDOF)+CV_F_OLD(ICV)*DCV_DR_NEW(IDOF,ICV)
        ENDDO
      ENDDO

C     Update the positions
      CALL AZZERO(TSCR,3*NAX*NSX)
      CALL GETTAU(TSCR,DX)
!$OMP parallel do private(IS,IA,FACT)
      DO IS=1,NSP
        FACT=-DT_IONS*DTB2MI(IS)
        DO IA=1,NA(IS)
          R_NNEW(1,IA,IS)=R_NEW(1,IA,IS)+FACT*TSCR(1,IA,IS)
          R_NNEW(2,IA,IS)=R_NEW(2,IA,IS)+FACT*TSCR(2,IA,IS)
          R_NNEW(3,IA,IS)=R_NEW(3,IA,IS)+FACT*TSCR(3,IA,IS)
        ENDDO
      ENDDO


      CALL DCOPY(NCOLVAR,CV_F_OLD,1,CV_F_NEW,1)

      
      ICOUNT = 0

      DO ICV = 1,NCOLVAR
        SUM = 0.0D0
        DO IDOF = 1,NODIM
          SUM = SUM + DET_COLVAR(IDOF,ICV)*DET_COLVAR(IDOF,ICV)
        ENDDO
        IF (SUM .LT. 1.D-2) THEN
          IFLAG(ICV) = 0
          CV_F_NEW(ICV) = 0.0D0
        ELSE
          IFLAG(ICV) = 1
          ICOUNT = ICOUNT + 1
          IPOS(ICOUNT) = ICV
        ENDIF
      ENDDO
      NACTIVE = ICOUNT

C     Iterativ calculation of lambda
      DO ITER=1,MAXRAT
C     Calculate Collective Variables values and differences
C     for the current value of lambda
        CALL AZZERO(DX,NODIM)
        CALL COLVAROFR(R_NNEW,TSCR)

        DO ICOUNT = 1,NACTIVE
          CV_DIFF(ICOUNT) = 
     &           -(CV_IST(IPOS(ICOUNT))-CV_OLD(IPOS(ICOUNT)))
        ENDDO
        ERRF=DASUM(NACTIVE,CV_DIFF(1),1)

        IF(ERRF .LT. TOL_CV_F) GOTO 100

C       Derivatives of sigma wrt lambda
        DO ICOUNT=1,NACTIVE
          DO JCOUNT=1,NACTIVE
            ASL(ICOUNT,JCOUNT)=0.0D0
            DO IDOF=1,NODIM
              ASL(ICOUNT,JCOUNT)=ASL(ICOUNT,JCOUNT)-
     &        DT_IONS*DTM(IDOF)*DET_COLVAR(IDOF,IPOS(ICOUNT))
     &                         *DCV_DR_NEW(IDOF,IPOS(JCOUNT))
            ENDDO
          ENDDO
        ENDDO

C       Solve for asl*cg=fc
C       LAPACK matrix solver
        CALL DGESV(NACTIVE,1,ASL,NCOLVAR,IPVT,CV_DIFF,NCOLVAR,INFO)
        IF (INFO.NE.0) CALL STOPGM(' CV_FORCES|','ERROR IN DGESV')
        ERRX=DASUM(NACTIVE,CV_DIFF(1),1)
C       DIIS!
        IDIIS=MOD(ITER-1,MRDIIS)+1
#ifndef __SR11000
!$OMP parallel do private(ICOUNT)
#endif
        DO ICOUNT = 1,NACTIVE
          XLO(ICOUNT,IDIIS) = CV_F_NEW(IPOS(ICOUNT))
        ENDDO
c        CALL DCOPY(NACTIVE,CV_F_NEW(1),1,XLO(1,IDIIS),1)
        CALL DCOPY(NACTIVE,CV_DIFF(1),1,ERR(1,IDIIS),1)
        IF(ITER.GT.MRDIIS) THEN
          M=MRDIIS+1
          CALL AZZERO(DIISM,M*M)
          CALL AZZERO(V,M)
          DO I=1,MRDIIS
            DO J=1,MRDIIS
              DIISM(I,J)=DDOT(NACTIVE,ERR(1,I),1,ERR(1,J),1)
            ENDDO
            DIISM(M,I)=1.0D0
            DIISM(I,M)=1.0D0
          ENDDO 
          V(M)=1.0D0
          CALL SOLVE(DIISM,M,M,V)
          CALL AZZERO(CV_DIFF,NACTIVE)
          CALL AZZERO(CV_F_NEW,NCOLVAR)
          DO I=1,MRDIIS
            DO JCOUNT=1,NACTIVE
              CV_DIFF(JCOUNT)=CV_DIFF(JCOUNT)+V(I)*ERR(JCOUNT,I)
              CV_F_NEW(IPOS(JCOUNT))=CV_F_NEW(IPOS(JCOUNT))+
     &                                   V(I)*XLO(JCOUNT,I)
            ENDDO
          ENDDO
        ENDIF
        DO  ICOUNT = 1,NACTIVE
          CV_F_NEW(IPOS(ICOUNT)) = CV_F_NEW(IPOS(ICOUNT))+
     &                            CV_DIFF(ICOUNT)
        ENDDO

        IF(ERRX .LT. TOL_CV_X) GOTO 100

C       Update forces
        CALL AZZERO(DX,NODIM)
        DO ICOUNT=1,NACTIVE
          FACT=CV_F_NEW(IPOS(ICOUNT))
          DO IDOF=1,NODIM
!!es        DX(IDOF)=DX(IDOF)+CV_F_NEW(IPOS(ICOUNT))*
!!es &                        DCV_DR_NEW(IDOF,IPOS(ICOUNT))
            DX(IDOF)=DX(IDOF)+FACT*DCV_DR_NEW(IDOF,IPOS(ICOUNT))
          ENDDO
        ENDDO
C       Update the positions
        CALL AZZERO(TSCR,3*NAX*NSX)
        CALL GETTAU(TSCR,DX)
#ifndef __SR11000
!$OMP parallel do private(IS,IA,FACT)
#endif
        DO IS=1,NSP
          FACT=-DT_IONS*DTB2MI(IS)
          DO IA=1,NA(IS)
            R_NNEW(1,IA,IS)=R_NEW(1,IA,IS)+
     &                           FACT*TSCR(1,IA,IS)
            R_NNEW(2,IA,IS)=R_NEW(2,IA,IS)+
     &                           FACT*TSCR(2,IA,IS)
            R_NNEW(3,IA,IS)=R_NEW(3,IA,IS)+
     &                           FACT*TSCR(3,IA,IS)
          ENDDO
        ENDDO

      ENDDO

      WRITE(6,'(/,A,I7,A)') ' CV_FORCES|  did not converge '
      DO ICOUNT=1,NACTIVE
        IF(DABS(CV_DIFF(ICOUNT)) .GT. TOL_CV_X ) THEN 
          CV_F_NEW(IPOS(ICOUNT)) = CV_F_OLD(IPOS(ICOUNT))/2.0D0
        ENDIF 
      ENDDO
  100 CONTINUE

      CALL DCOPY(NCOLVAR,CV_F_NEW,1,CV_F_OLD,1)

C     Recall CV and CV_DET Values
      CALL DCOPY(NCOLVAR,CV_STR,1,CV_IST,1)
      CALL DCOPY(NCOLVAR*NODIM,DCV_DR_STR,1,DET_COLVAR,1)

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==

C     ==--------------------------------------------------------------==
      SUBROUTINE FILLC2(IAT,TAU,X,D2_A,TRAN)
C     ==--------------------------------------------------------------==
C     == Extract the coordinates X(1:3) of IAT index in TAU (TSCR)    ==
C     == Works also if dummy atoms                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER IAT
      REAL*8 TAU(3,NAX*NSX),X(3),D2_A(3,NDAT),TRAN(3)
C     Local
      INTEGER ID,NAA,ITYP
C     ==--------------------------------------------------------------==
      IF(IAT.LE.0) THEN
C       Do nothing
        RETURN
      ELSEIF(IAT.LE.NAT) THEN
C       Real atoms
        X(1)=TAU(1,IAT)
        X(2)=TAU(2,IAT)
        X(3)=TAU(3,IAT)
      ELSEIF(IAT.LE.NAT+NDAT) THEN
C       Dummy atoms (type 2).
        NAA=IAT-NAT
        ITYP=LISTDA(NAA,1)
        ID=LISTDA(NAA,2)
        IF(ITYP.EQ.2) THEN
          X(1)=D2_A(1,ID)
          X(2)=D2_A(2,ID)
          X(3)=D2_A(3,ID)
        ELSEIF(ITYP.EQ.1) THEN
          X(1)=DUMMY1(1,ID) - TRAN(1)
          X(2)=DUMMY1(2,ID) - TRAN(2)
          X(3)=DUMMY1(3,ID) - TRAN(3)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
