C     ==================================================================
      SUBROUTINE COORN_RF_Q(IATIN,C1_RC,R0_SHIFT,TSCR,AN,
     &                    FCI,FVI,CVAL,SPvsAT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_input.inc'

!     Arguments
      INTEGER IATIN(15),SPvsAT
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_RC,R0_SHIFT
!     Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,RNUM,RDEN,FNUM,FDEN,FFF,XX(3)
      INTEGER IA,ISP,NEXP,MEXP
      INTEGER MY_NAT, IELEMENT, NAT_SOLU, NAT_QM
      INTEGER IAT,IIAT,K,L1,L2,L3,IS,IINI,IEND
      INTEGER IB,NAA,ITYP,KX,JJ,JX,JY,JZ,J
      LOGICAL status
C     ==--------------------------------------------------------------==
!    get total number of atoms and set indexing.
      if(qmmm) then
         call mm_dim(mm_go_mm,status)
         MY_NAT=NAT
         NAT_SOLU = NRPT
         NAT_QM = NATq
      else
         MY_NAT=NATm
         NAT_SOLU = MY_NAT
         NAT_QM = MY_NAT
      endif
       !dbg
       ! write(6,*) ' >>>> NATOMS', my_nat, nat_solu, nat_qm, spvsat
       !dbg
!     PARAMETERS
      IELEMENT = IATIN(2)
      NEXP = IATIN(3)
      MEXP = IATIN(4)
      
!     The first index has been already converted into cpmd order
      IA = IATIN(1)
      IF(IA.LE.MY_NAT) THEN
        L1 = LSKPTR(1,IA)
        L2 = LSKPTR(2,IA)
        L3 = LSKPTR(3,IA)
      ENDIF
      CALL FILLC(IA,TSCR,XX)
      X0 = XX(1)
      Y0 = XX(2)
      Z0 = XX(3)

      FVI = 0.D0
      IF(SPvsAT .EQ. -1) THEN
        IINI = 1
        IEND = NAT_SOLU
      ELSEIF(SPvsAT .EQ. -2) THEN
        IINI = NAT_SOLU + 1
        IEND = MY_NAT
      ELSEIF(SPvsAT .EQ. -3) THEN
        IINI = 1
        IEND = MY_NAT
      ELSE
        IINI = IATIN(5)
        IEND = IATIN(6)
      ENDIF

       !dbg
!        write(6,*) ' >>>> IND', IA, IINI, IEND , IELEMENT
       !dbg

      DO IIAT=IINI,IEND
!       Convert to CPMD order
        IAT = NAT_cpmd(IIAT)

        IF(SPvsAT .GE. -3 .OR. SPvsAT .LE. -6) THEN
            !dbg
        !  write(6,*) '>>>> ITYP ', IAT , IATYP(cpsp(IIAT))
            !dbg
          IF(IATYP(cpsp(IIAT)).NE. IELEMENT) GOTO 120
        END IF
        IF(SPvsAT .EQ. -4 .OR. SPvsAT .EQ. -6) THEN
          IF(IAT .LE. NAT_QM) GOTO 120
        END IF

       !dbg
        !write(6,*) ' >>>> LOOP', IIAT, IAT
       !dbg

        DX=TSCR(1,IAT)-X0
        DY=TSCR(2,IAT)-Y0
        DZ=TSCR(3,IAT)-Z0
        IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)

       !dbg
        !write(6,*) ' >>>> TISOS',  TISOS, TCLUST, TONED, TTWOD
       !dbg

        DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
!..exclude self interaction
        IF(DD.GT.1.D-2) THEN
          RNUM = ((DD-R0_SHIFT)/C1_RC)**NEXP
          RDEN = ((DD-R0_SHIFT)/C1_RC)**(NEXP+MEXP)
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT.  1.D-10) THEN
             FVI = FVI + DBLE(NEXP)/DBLE(NEXP+MEXP)
             FF = -0.5D0*DBLE(NEXP*MEXP)/DBLE(NEXP+MEXP)/(C1_RC*DD)
          ELSE
             FVI = FVI + FNUM/FDEN
             FF = -(RNUM*DBLE(NEXP)-FNUM*RDEN*DBLE(NEXP+MEXP)/
     &             FDEN)/(FDEN*(DD-R0_SHIFT)*DD)
          ENDIF
          IF(LSKPTR(1,IAT).NE.0) THEN
              K=LSKPTR(1,IAT)
              AN(K)=AN(K)+FF*DX 
          ENDIF
          IF(LSKPTR(2,IAT).NE.0) THEN
              K=LSKPTR(2,IAT)
              AN(K)=AN(K)+FF*DY
          ENDIF
          IF(LSKPTR(3,IAT).NE.0) THEN
              K=LSKPTR(3,IAT)
              AN(K)=AN(K)+FF*DZ
          ENDIF 

          IF(IA.LE.MY_NAT) THEN
            IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
            IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
            IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
          ELSEIF(IA.LE.MY_NAT+NDAT) THEN
            NAA=IA-MY_NAT
            ITYP=LISTDA(NAA,1)
            IF(ITYP.EQ.1) THEN
              GOTO 110
            ELSEIF(ITYP.EQ.2) THEN
              KX=LISTDA(NAA,2)
              JJ=LISTD2(1,KX)
              FFF=1.0D0/DBLE(JJ)
              DO J=1,JJ
                    IB=LISTD2(J+1,KX)
                    JX=LSKPTR(1,IB)
                    JY=LSKPTR(2,IB)
                    JZ=LSKPTR(3,IB)
                    IF(JX.NE.0) AN(JX)=AN(JX)-FF*DX*FFF
                    IF(JY.NE.0) AN(JY)=AN(JY)-FF*DY*FFF
                    IF(JZ.NE.0) AN(JZ)=AN(JZ)-FF*DZ*FFF
              ENDDO
            ENDIF
          ENDIF
 110      CONTINUE
        ENDIF
 120    CONTINUE
      ENDDO
      FCI=FVI-CVAL
       !dbg
      !  write(6,*) ' >>>> VAL', FVI
      !  STOP 'fin'
       !dbg
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE COORNTOT_RF_Q(IATIN,C1_RC,R0_SHIFT,TSCR,AN,
     &                         FCI,FVI,CVAL,SPvsAT)
C    ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_input.inc'

!    Arguments
      INTEGER IATIN(15),SPvsAT
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_RC,R0_SHIFT
!    Variables
      REAL*8  X0,Y0,Z0,XX(3),DX,DY,DZ,DD,FF,FFF,DF
      REAL*8  RNUM,RDEN,FNUM,FDEN,UNA1
      INTEGER MY_NAT, IELEMENT, NAT_SOLU, NAT_QM
      INTEGER ISP1,ISP2,NEXP,MEXP
      INTEGER IAT1,IAT2,IIAT2,K,L1,L2,L3,IS,IINI1,IINI2,IEND1,IEND2
      INTEGER IB,NAA,ITYP,KX,JJ,JX,JY,JZ,J
      LOGICAL  STATUS
C    ==--------------------------------------------------------------==
!    get total number of atoms and set indexing.
      if(qmmm) then
         call mm_dim(mm_go_mm,status)
         MY_NAT=NAT
         NAT_SOLU = NRPT
         NAT_QM = NATq
      else
         MY_NAT=NATm
         NAT_SOLU = MY_NAT
         NAT_QM = MY_NAT
      endif
       !dbg
!        write(6,*) ' >>>> NATOMS', my_nat, nat_solu, nat_qm, spvsat
       !dbg
!     PARAMETERS
      ISP1 = IATIN(1)
      IELEMENT = IATIN(2)
      NEXP = IATIN(3)
      MEXP = IATIN(4)

!     This variable is only meaningful if the first species is within QM
!     Species are defined only in cpmd order therefore the atom indexes
!     here are already in the cpmd order and do not need conversion
!     This inconsistency between first group and second group 
!     is rather awful, with QMMM better to use COOR_SEQ
      IINI1 = 1
      DO IS = 1,ISP1-1
        IINI1=IINI1+NA(IS)
      ENDDO
      IEND1 = IINI1 + NA(ISP1) -1
      UNA1 = 1.0D0/DBLE(NA(ISP1))
      IF (IEND1 .GT. NAT_QM) CALL STOPGM('META_CV_QMMM',
     &           'TOT_COOR first species should be QM')

      IF(SPvsAT .EQ. -1) THEN
        IINI2 = 1
        IEND2 = NAT_SOLU
      ELSEIF(SPvsAT .EQ. -2) THEN
        IINI2 = NAT_SOLU + 1
        IEND2 = MY_NAT
      ELSEIF(SPvsAT .EQ. -3) THEN
        IINI2 = 1
        IEND2 = MY_NAT
      ELSE
        IINI2 = IATIN(5)
        IEND2 = IATIN(6)
      ENDIF

       !dbg
!        write(6,*) ' >>>> IND', IINI1, IEND1, IINI2, IEND2
       !dbg

      FVI = 0.D0
      DO IAT1 = IINI1,IEND1
        L1 = LSKPTR(1,IAT1)
        L2 = LSKPTR(2,IAT1)
        L3 = LSKPTR(3,IAT1)
        X0 = TSCR(1,IAT1)
        Y0 = TSCR(2,IAT1)
        Z0 = TSCR(3,IAT1)

        DO IIAT2=IINI2,IEND2
!       Convert to CPMD order
          IAT2 = NAT_cpmd(IIAT2)

          IF(SPvsAT .GE. -3 .OR. SPvsAT .LE. -6) THEN
            IF(IATYP(cpsp(IIAT2)).NE. IELEMENT) GOTO 120
          END IF
          IF(SPvsAT .EQ. -4 .OR. SPvsAT .EQ. -6) THEN
            IF(IAT2 .LE. NAT_QM) GOTO 120
          END IF

         !dbg
!          write(6,*) ' >>>> LOOP',IAT1,IIAT2,IAT2,IATYP(cpsp(IIAT2))
         !dbg

          CALL FILLC(IAT2,TSCR,XX)
          DX=XX(1)-X0
          DY=XX(2)-Y0
          DZ=XX(3)-Z0
          IF(.NOT. TISOS) THEN
            CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          ENDIF
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
!..exclude self interaction
!       write(6,*) IAT1,IAT2,DD,DX,DY,DZ
          IF(DD.GT.1.D-2) THEN
            RNUM = ((DD-R0_SHIFT)/C1_RC)**NEXP
            RDEN = ((DD-R0_SHIFT)/C1_RC)**(NEXP+MEXP)
            FNUM = 1-RNUM
            FDEN = 1-RDEN
            IF(DABS(FDEN) .LT. 1.D-10) THEN 
              FVI = FVI + DBLE(NEXP)/DBLE(NEXP+MEXP)
              FF  = -0.5D0*DBLE(NEXP*MEXP)/DBLE(NEXP+MEXP)/
     &               (C1_RC*DD)
            ELSE
              FVI  = FVI + FNUM/FDEN
              FF   = -(RNUM*DBLE(NEXP)-FNUM*RDEN*DBLE(NEXP+MEXP)/
     &              FDEN)/(FDEN*(DD-R0_SHIFT)*DD)*UNA1
            ENDIF

            IF(IAT2.LE.MY_NAT) THEN
              IF(LSKPTR(1,IAT2).NE.0) THEN
                K=LSKPTR(1,IAT2)
                AN(K)=AN(K)+FF*DX
              ENDIF
              IF(LSKPTR(2,IAT2).NE.0) THEN
                K=LSKPTR(2,IAT2)
                AN(K)=AN(K)+FF*DY
              ENDIF
              IF(LSKPTR(3,IAT2).NE.0) THEN
                K=LSKPTR(3,IAT2)
                AN(K)=AN(K)+FF*DZ
              ENDIF
            ELSEIF(IAT2.LE.MY_NAT+NDAT) THEN
            ! I am not sure that dummy atoms can work 
            ! any way only if SEQUENCE and without specifying the element
              NAA=IAT2-MY_NAT
              ITYP=LISTDA(NAA,1)
              IF(ITYP.EQ.1) THEN
                GOTO 110
              ELSEIF(ITYP.EQ.2) THEN
                KX=LISTDA(NAA,2)
                JJ=LISTD2(1,KX)
                FFF=1.0D0/DBLE(JJ)
                DO J=1,JJ
                  IB=LISTD2(J+1,KX)
                  JX=LSKPTR(1,IB)
                  JY=LSKPTR(2,IB)
                  JZ=LSKPTR(3,IB)
                  IF(JX.NE.0) AN(JX)=AN(JX)+FF*DX*FFF
                  IF(JY.NE.0) AN(JY)=AN(JY)+FF*DY*FFF
                  IF(JZ.NE.0) AN(JZ)=AN(JZ)+FF*DZ*FFF
                ENDDO
              ENDIF
            ENDIF
 110        CONTINUE

            IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
            IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
            IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
          ENDIF
 120      CONTINUE
        ENDDO
      ENDDO
      FVI = FVI*UNA1
      FCI=FVI-CVAL
       !dbg
!        write(6,*) ' >>>> VAL', FVI
!        STOP 'fin'
       !dbg
C    ==--------------------------------------------------------------==
      RETURN
      END
C    ==================================================================
      SUBROUTINE COORNSEQ_RF(IATIN,C1_RC,R0_SHIFT,TSCR,AN,
     &                       FCI,FVI,CVAL,SPvsAT)
C    ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_input.inc'

!    Arguments
      INTEGER IATIN(15),SPvsAT
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_RC,R0_SHIFT
!    Variables
      REAL*8  X0,Y0,Z0,XX(3),DX,DY,DZ,DD,FF,FFF,DF
      REAL*8  RNUM,RDEN,FNUM,FDEN,UNA1
      INTEGER MY_NAT, IELEMENT1,IELEMENT2, NAT_SOLU, NAT_QM
      INTEGER NEXP,MEXP, ICOUNT1
      INTEGER IAT1,IAT2,IIAT1,IIAT2,K,L1,L2,L3,IS
      INTEGER IINI1,IINI2,IEND1,IEND2
      INTEGER IB,NAA,ITYP,KX,JJ,JX,JY,JZ,J
      LOGICAL  STATUS
C     ==--------------------------------------------------------------==
!    get total number of atoms and set indexing.
      if(qmmm) then
         call mm_dim(mm_go_mm,status)
         MY_NAT=NAT
         NAT_SOLU = NRPT
         NAT_QM = NATq
      else
         MY_NAT=NATm
         NAT_SOLU = MY_NAT
         NAT_QM = MY_NAT
      endif
       !dbg
        !write(6,*) ' >>>> NATOMS', my_nat, nat_solu, nat_qm, spvsat
       !dbg
!     PARAMETERS
      IELEMENT1 = IATIN(1)
      IELEMENT2 = IATIN(2)
      NEXP = IATIN(3)
      MEXP = IATIN(4)

! 1  SOLU - SOLU
! 2  SOLU - SOLV
! 3   SEQ - SOLV
! 4   SEQ - SEQ
! 5   SEQ - SEQMM
! 6 SEQQM - SEQMM
! 7 SEQMM - SEQMM
!
      IF(SPvsAT .LE. 2) THEN
         IINI1 = 1
         IEND1 = NAT_SOLU
      ELSE
         IINI1 = IATIN(5)
         IEND1 = IATIN(6)
      ENDIF

      IF(SPvsAT .EQ. 1 .OR. SPvsAT .EQ. 3) THEN
         IINI2 = NAT_SOLU + 1
         IEND2 = MY_NAT
      ELSEIF(SPvsAT .EQ. 2) THEN
         IINI2 = 1
         IEND2 = NAT_SOLU
      ELSE
         IINI2 = IATIN(7)
         IEND2 = IATIN(8)
      END IF

      !dbg
        !write(6,*) ' >>>> IND', IINI1, IEND1, IINI2, IEND2

        !write(6,*) ' >>>> ELE', IELEMENT1, IELEMENT2
       !dbg

      FVI = 0.D0

      ! Count the number of atoms in the first group
      ICOUNT1 = 0
      DO IIAT1 = IINI1,IEND1
!     Convert to CPMD order
        IAT1 = NAT_cpmd(IIAT1)
!     Check the other conditions
        IF(IELEMENT1 .NE. 0) THEN
          IF( IATYP(cpsp(IIAT1)) .NE. IELEMENT1 ) GOTO 110
        END IF 
        IF(SPvsAT .EQ. 6 .OR. SPvsAT .EQ. 8) THEN
          IF(IAT1 .GT. NAT_QM) GOTO 110
        ELSEIF(SPvsAT .EQ. 7) THEN
          IF(IAT1 .LE. NAT_QM) GOTO 110
        END IF
        ICOUNT1 = ICOUNT1 + 1
 110    CONTINUE
      END DO ! IAT1
      UNA1 =  1.0D0/DBLE(ICOUNT1)

        !dbg
!          write(6,*) ' >>>> NAT1', ICOUNT1
        !dbg
!       stop 'nat' 
      DO IIAT1 = IINI1,IEND1
!     Convert to CPMD order
        IAT1 = NAT_cpmd(IIAT1)
!     Check the other conditions
        IF(IELEMENT1 .NE. 0) THEN
          IF( IATYP(cpsp(IIAT1)) .NE. IELEMENT1 ) GOTO 120
        END IF 
        IF(SPvsAT .EQ. 6 .OR. SPvsAT .EQ. 8) THEN
          IF(IAT1 .GT. NAT_QM) GOTO 120
        ELSEIF(SPvsAT .EQ. 7) THEN
          IF(IAT1 .LE. NAT_QM) GOTO 120
        END IF
      
        !dbg
          !write(6,*) ' >>>> LOOP1',IIAT1,IAT1,IATYP(cpsp(IIAT1))
        !dbg
        
        L1 = LSKPTR(1,IAT1)
        L2 = LSKPTR(2,IAT1)
        L3 = LSKPTR(3,IAT1)
        X0 = TSCR(1,IAT1)
        Y0 = TSCR(2,IAT1)
        Z0 = TSCR(3,IAT1)
        ICOUNT1 = ICOUNT1 + 1

        DO IIAT2=IINI2,IEND2
!       Convert to CPMD order
          IAT2 = NAT_cpmd(IIAT2)

          IF(IELEMENT2 .NE. 0) THEN
            IF( IATYP(cpsp(IIAT2)) .NE. IELEMENT2 ) GOTO 130
          END IF 
          IF(SPvsAT .GE. 5 .AND. SPvsAT .LT. 8 ) THEN
            IF(IAT2 .LE. NAT_QM) GOTO 130
          END IF

          !dbg
           !write(6,*) ' >>>> LOOP2', IIAT2, IAT2,  IATYP(cpsp(IIAT2))
          !dbg

          CALL FILLC(IAT2,TSCR,XX)
          DX=XX(1)-X0
          DY=XX(2)-Y0
          DZ=XX(3)-Z0
          IF(.NOT. TISOS) THEN
            CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          ENDIF
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
 
!..exclude self interaction
!       write(6,*) IAT1,IAT2,DD,DX,DY,DZ
          IF(DD.GT.1.D-2) THEN
            RNUM = ((DD-R0_SHIFT)/C1_RC)**NEXP
            RDEN = ((DD-R0_SHIFT)/C1_RC)**(NEXP+MEXP)
            FNUM = 1-RNUM
            FDEN = 1-RDEN
            IF(DABS(FDEN) .LT. 1.D-10) THEN 
              FVI = FVI + DBLE(NEXP)/DBLE(NEXP+MEXP)
              FF  = -0.5D0*DBLE(NEXP*MEXP)/DBLE(NEXP+MEXP)/
     &             (C1_RC*DD)
            ELSE
              FVI  = FVI + FNUM/FDEN
              FF   = -(RNUM*DBLE(NEXP)-FNUM*RDEN*DBLE(NEXP+MEXP)/
     &             FDEN)/(FDEN*(DD-R0_SHIFT)*DD)*UNA1
            ENDIF

!.. the dummy atoms cannot be used here
            IF(IAT2.LE.MY_NAT) THEN
              IF(LSKPTR(1,IAT2).NE.0) THEN
                K=LSKPTR(1,IAT2)
                AN(K)=AN(K)+FF*DX
              ENDIF
              IF(LSKPTR(2,IAT2).NE.0) THEN
                K=LSKPTR(2,IAT2)
                AN(K)=AN(K)+FF*DY
              ENDIF
              IF(LSKPTR(3,IAT2).NE.0) THEN
                K=LSKPTR(3,IAT2)
                AN(K)=AN(K)+FF*DZ
              ENDIF
            END IF

            IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
            IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
            IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
          ENDIF 
 130      CONTINUE
        END DO                  ! IIAT2  
 120    CONTINUE
      END DO  ! IIAT1

      FVI = FVI*UNA1
      FCI=FVI-CVAL
      !dbg
       !write(6,*) '>>>> FVI ', FVI
       !STOP 'VAL'
      !dbg
C    ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RMSD_SEQ_A(INDEXSP,MAXRMSDAT,TSCR,AN,
     &                      FCI,FVI,CVAL,SPvsAT)
C    ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'fileopen.inc'

!    Arguments
      INTEGER INDEXSP(15),MAXRMSDAT,SPvsAT
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_RC,R0_SHIFT
!    Variables
      INTEGER   IFIRST
      DATA      IFIRST /0/
      SAVE      IFIRST

      INTEGER   MY_NAT,NAT_SOLU,NAT_QM,NUMELEMENTS,NAT_RMSD
      INTEGER   IELE(15)
      INTEGER   IAT, IIAT, IE, ICOUNT,IINI, IEND, L1,L2,L3
      INTEGER   IPOS_RMSD(*),I,ISP,IS,IA,LI_NAT
      POINTER   (IP_IPOS_RMSD,IPOS_RMSD)
      REAL*8    RMSD_SCR(*)
      POINTER   (IP_RMSD_SCR,RMSD_SCR)
      REAL*8    POS_0(3,*)
      POINTER   (IP_POS_0,POS_0)
      SAVE      IP_POS_0, IP_RMSD_SCR, IP_IPOS_RMSD
      REAL*8    R_ION(3,*),R0_ION(3,*)
      POINTER   (IP_R_ION,R_ION),(IP_R0_ION,R0_ION)
      REAL*8    DERR(3,*),R_CM(3,*),R0_CM(3,*)
      POINTER   (IP_DERR,DERR),(IP_R_CM,R_CM),(IP_R0_CM,R0_CM)
      REAL*8    RMSD_VAL
      CHARACTER FILEN*100
      INTEGER   IUNIT
      PARAMETER (IUNIT=58)
      LOGICAL   FERROR,FEXIST , status, TAKEIT
!    ==--------------------------------------------------------------==
!    get total number of atoms and set indexing.
      if(qmmm) then
         call mm_dim(mm_go_mm,status)
         MY_NAT=NAT
         NAT_SOLU = NRPT
         NAT_QM = NATq
      else
         MY_NAT=NATm
         NAT_SOLU = MY_NAT
         NAT_QM = MY_NAT
      endif
       !dbg
!          write(6,*) ' >>>> NATOMS', my_nat, nat_solu, nat_qm, spvsat
       !dbg
!     PARAMETERS
      NUMELEMENTS = INDEXSP(1)
      NAT_RMSD = INDEXSP(2)
       !dbg
          !write(6,*) '>>> MAXRMSDAT', MAXRMSDAT
          !write(6,*) ' >>>> ELE', NUMELEMENTS, NAT_RMSD
       !dbg
      CALL IAZZERO(IELE,15/IRAT+1)
!$OMP parallel do private(IE)
      DO IE = 1,NUMELEMENTS
        IELE(IE) = INDEXSP(IE+4)
       !dbg
          !write(6,*) '>> IELE ', IELE(IE)
       !dbg
      ENDDO 

      IF(SPvsAT .EQ. 2 ) THEN
         IINI = NAT_SOLU + 1
         IEND = MY_NAT
      ELSEIF(SPvsAT .EQ. 1) THEN
         IINI = 1
         IEND = NAT_SOLU
      ELSE
         IINI = INDEXSP(3)
         IEND = INDEXSP(4)
      END IF
      !dbg
        !write(6,*) ' >>>> IND', IINI, IEND
      !dbg

      IF(IFIRST.EQ.0) THEN
!    Allocate memory
        CALL MEMORY(IP_POS_0,3*MY_NAT,'POS_0')
        ! TO reduce the memory requirement, allocate MAXRMSDAT
        CALL MEMORY(IP_IPOS_RMSD,MAXRMSDAT/IRAT+1,'IPOS_RMSD')
        CALL MEMORY(IP_RMSD_SCR,6*3*MAXRMSDAT,'RMSD_SCR')

        FILEN='p0cp_rmsd_seq.dat'
        INQUIRE(FILE='p0cp_rmsd_seq.dat',EXIST=FEXIST)
        IF(FEXIST) THEN
          CALL FILEOPEN(IUNIT,FILEN,FO_OLD,FERROR)
          DO IIAT = 1,MY_NAT
             IAT = NAT_cpmd(IIAT)
             READ(IUNIT,'(I8,3f20.10)') I, 
     &             POS_0(1,IAT), POS_0(2,IAT), POS_0(3,IAT)
          END DO
        ELSE
          CALL FILEOPEN(IUNIT,FILEN,FO_NEW,FERROR)
          DO IIAT = 1,MY_NAT
             IAT = NAT_cpmd(IIAT)
             POS_0(1,IAT) =  TSCR(1,IAT)
             POS_0(2,IAT) =  TSCR(2,IAT)
             POS_0(3,IAT) =  TSCR(3,IAT)
             WRITE(IUNIT,'(I8,3f20.10)') IIAT, 
     &             POS_0(1,IAT), POS_0(2,IAT), POS_0(3,IAT)
          END DO
        END IF
         CALL FILECLOSE(IUNIT)
        IFIRST=1
      END IF

      CALL IAZZERO(IPOS_RMSD,NAT_RMSD)
      CALL AZZERO(RMSD_SCR,6*3*NAT_RMSD)

#ifdef _BGL 
      LI_NAT=3*NAT_RMSD+MOD(3*NAT_RMSD,2)
      CALL GET_ADDR(IP_R_ION,RMSD_SCR(1))
      CALL GET_ADDR(IP_R0_ION,RMSD_SCR(1+LI_NAT)) 
      CALL GET_ADDR(IP_DERR,RMSD_SCR(1+2*LI_NAT))
      CALL GET_ADDR(IP_R0_CM,RMSD_SCR(1+3*LI_NAT))
      CALL GET_ADDR(IP_R_CM,RMSD_SCR(1+4*LI_NAT))
#else
      CALL GET_ADDR(IP_R_ION,RMSD_SCR(1))
      CALL GET_ADDR(IP_R0_ION,RMSD_SCR(1+3*NAT_RMSD)) 
      CALL GET_ADDR(IP_DERR,RMSD_SCR(1+2*3*NAT_RMSD))
      CALL GET_ADDR(IP_R0_CM,RMSD_SCR(1+3*3*NAT_RMSD))
      CALL GET_ADDR(IP_R_CM,RMSD_SCR(1+4*3*NAT_RMSD))
#endif

      ICOUNT = 0
      DO IIAT = IINI, IEND
         IAT = NAT_cpmd(IIAT)
         TAKEIT = .FALSE.
         IF(NUMELEMENTS .NE. 0) THEN
           DO IE = 1,NUMELEMENTS
              IF(IATYP(cpsp(IIAT)) .EQ. IELE(IE))THEN
                TAKEIT = .TRUE.
              END IF
           END DO 
         ELSE
           TAKEIT = .TRUE.
         END IF
         IF(TAKEIT) THEN
           ICOUNT = ICOUNT + 1
           IPOS_RMSD(ICOUNT) = IAT
           R_ION(1,ICOUNT) = TSCR(1,IAT)
           R_ION(2,ICOUNT) = TSCR(2,IAT)
           R_ION(3,ICOUNT) = TSCR(3,IAT)
           R0_ION(1,ICOUNT) = POS_0(1,IAT) 
           R0_ION(2,ICOUNT) = POS_0(2,IAT) 
           R0_ION(3,ICOUNT) = POS_0(3,IAT) 
         END IF
      END DO ! IIAT   
      !dbg
          !write (6,*) ICOUNT
       !dbg

      IF(ICOUNT .GT. NAT_RMSD .OR. ICOUNT .GT. MAXRMSDAT) THEN
          CALL STOPGM('RMSD_SEQ','too many atoms counted')
      ENDIF
!      DO I = 1,ICOUNT
!          write(6,'(2I4,6f14.6)') I, 1, R_ION(1,I), R0_ION(1,I)
!          write(6,'(2I4,6f14.6)') I, 2, R_ION(2,I), R0_ION(2,I)
!          write(6,'(2I4,6f14.6)') I, 3, R_ION(3,I), R0_ION(3,I)
!      END DO 

!     Calculate RMSD_B and derivatives
      CALL VAL_RMSD(ICOUNT,R_ION,R0_ION,RMSD_VAL,DERR,R0_CM,R_CM)
      !dbg
!         write(6,*) '>>>> RMSD', RMSD_VAL 
      !dbg
!         stop 'val'
       FVI = RMSD_VAL 
       FCI = FVI-CVAL

      DO IAT = 1,ICOUNT
         L1=LSKPTR(1,IAT)
         L2=LSKPTR(2,IAT)
         L3=LSKPTR(3,IAT)
         IF(L1 .NE. 0) AN(L1) = AN(L1) + DERR(1,IPOS_RMSD(IAT)) 
         IF(L2 .NE. 0) AN(L2) = AN(L2) + DERR(2,IPOS_RMSD(IAT)) 
         IF(L3 .NE. 0) AN(L3) = AN(L3) + DERR(3,IPOS_RMSD(IAT)) 
      END DO  ! IAT  
C     ==--------------------------------------------------------------==      
      RETURN
      END
C     ================================================================== 
