      SUBROUTINE META_DYN_DEF
C     ==================================================================
C     ==      SETS DEFAULT FOR VARIABLES OF META DYNAMICS             ==
C     ==================================================================

      IMPLICIT  NONE

      INCLUDE  'system.h'
      INCLUDE  'mw.inc'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'store.inc'

      LCNSTDYN     = .FALSE.
      LCOLVARDYN   = .FALSE.
      LHILLS       = .TRUE.
      HLORE        = .FALSE.
      HSHIFT       = .FALSE.
      HRATIO       = .FALSE.
      SPHERE       = .FALSE.
      META_RESTART = .FALSE.
      LTUNE_CSCL   = .FALSE.
      LTUNE_HH     = .FALSE.
      THILLVOL     = .FALSE.
      TRESFILE     = .FALSE.
      QMMMORDER    = .TRUE.

      I_META_MAX   = 100
      I_META_RES   = 0
      ST_FREQ      = 50
      TR_FREQ      = 1
      QW_FREQ      = 10000

      FMTDRES      = 'MTD_RESTART'

      ICHECK       = 20
      HLLW         = 0.1D0
      HLLH         = 0.001D0
      HTOP         = 0.016D0
      HLOW         = 0.0001D0
      EXPUP        = 2.0D0
      EXPDOWN      = 16.D0
      RSHIFT       = 2.0D0
      FBOOST       = 1.0D0

      TOLKIN       = -1.0D0

C     Constraints only
      I_CNST_MIN   = 50
      I_CNST_MAX   = 400
      TOLL_FCNST   = 3.D-3
      NSTEP_RELAX  = 6
      DOUBLEQUENCH = .TRUE.

C     Collective Variables only
      INTER_HILL_MAX = 300
      NCOLVAR     = 0
      INTER_HILL  = 100
      TOLL_AVCV   = 0.001D0

C     Extended Lagrangean
      LEXTLAGRANGE=.FALSE.
      LCVTC=.FALSE.
      LTCGLOBAL=.FALSE.
      TCVSCALE=.FALSE.
      TCVLANGEVIN=.FALSE.
      LKFIX=.TRUE.
      CV_ASSOCIATED =.FALSE.
      CV_TEMP0=TEMPW
      CV_TEMP =0.0D0
      CV_LANGEVINTEMP=0.0D0
      CV_LANGAMMA=0.0D0
      EKINCV  =0.0D0
      VHARM   =0.0D0

C     Hydrogen Bond Chain
      Rcw     = 6.4D0
      Rch     = 3.0D0
      OPTDIST = 5.5D0
      BBETA   = 100.D0
      NSHORT  = 1
      NLONG   = 5
      LUPD    = 40

C     RMDS_SEQ
      MAXRMSDAT = 0

C     Cell Metadynamics
      LMETA_CELL = .FALSE.
      LMC_EXT    = .FALSE.
      LFULLC     = .TRUE.
      LISOC      = .FALSE.
      L2DC       = .FALSE.
      TVOLBOUND  = .FALSE.
      VBARRIER = 0.1D0

C     Multi-Metadynamics
      NSUBSYS = 1
      TMULTI  = .FALSE.

C     Spin Localization
      TLOCALIZESPIN=.FALSE.

C     Analysis
      TCVANALYSIS = .FALSE.

C     use trajectory interval from METASTORE (.true.) or &CPMD (.false.)
      TTRAJOVRR = .TRUE.

C     Monitor CV along MD trajectory
      TCVMONITOR = .FALSE.
      WCV_FREQ   = 50

C     Metadynamics with CV as HT functions
      TCVCELL = .FALSE.

C     Multiple walker metadynamics
      TMW=.FALSE.
      NWALK=1
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
