C     ================================================================== 
      SUBROUTINE CALC_POS_MDYN(TOLLM,I_CVST,I_TEMP,I_META,HC_LAST,
     &                     SCR,LSCR,HILL_ADD)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'

      INTEGER    I_CVST,I_TEMP,I_META,LSCR
      REAL*8     TOLLM,HC_LAST(NCOLVAR),
     &           SCR(LSCR)
      LOGICAL    HILL_ADD

      DIMENSION  CSCL_FAC(3,NCOLVAR)   
      INTEGER    II,IJ,ICV,IS,JCV,TESTC
      REAL*8     SUM,MIN_DISP,DIFF,AV_DISP


C     ==--------------------------------------------------------------==
C     Store CV values and Check averages

      
      IF(I_CVST .EQ.  INTER_HILL ) THEN
        JCV = 0
        TESTC = 0
        DO IS = 1,NSUBSYS
          MIN_DISP = 100.0D0
          AV_DISP  = 0.0D0
          DO ICV = 1,NCVSYS(IS)
            DIFF = (CV_DYN(JCV+ICV)-HC_LAST(JCV+ICV))
            IF (IANGCV(ICV) .EQ. 1 .AND. DIFF .GT. PI) THEN
              DIFF = DIFF -2.0D0*PI
            ELSEIF (IANGCV(JCV+ICV) .EQ. 1 .AND. DIFF .LT. -PI) THEN
              DIFF = DIFF +2.0D0*PI
            ENDIF
            DIFF = (DIFF/CSCL_FAC(1,JCV+ICV))**2.0D0
            AV_DISP = AV_DISP + DIFF
            MIN_DISP = MIN(DIFF,MIN_DISP)
          ENDDO
          AV_DISP = DSQRT(AV_DISP)
          IF(AV_DISP .GT. TOLLM .OR. I_META .EQ. 1) THEN
            TESTC = TESTC+1
          ENDIF

          write(6,'(4x,A,I4,A,f10.6,A,f10.6,A,f10.6/)') 
     &      'SYS ',IS,'MIN DISP. = ',DSQRT(MIN_DISP),
     &      '  ||DISP.tot|| = ', AV_DISP,
     &      '  Tolerance ',TOLLM
          JCV = JCV + NCVSYS(IS)
        ENDDO
        IF(TESTC .EQ. NSUBSYS) THEN
          HILL_ADD = .TRUE.
        ENDIF
      ELSEIF(I_CVST .GT.  INTER_HILL ) THEN
 
        I_TEMP = I_TEMP + 1
        TESTC = 0
        JCV = 0
        DO IS = 1,NSUBSYS
          MIN_DISP = 100.0D0
          DO ICV = 1,NCVSYS(IS)
            DIFF = (CV_DYN(JCV+ICV)-HC_LAST(JCV+ICV))
            IF (IANGCV(JCV+ICV) .EQ. 1 .AND. DIFF .GT. PI) THEN
              DIFF = DIFF -2.0D0*PI
            ELSEIF (IANGCV(JCV+ICV) .EQ. 1 .AND. DIFF .LT. -PI) THEN
              DIFF = DIFF +2.0D0*PI
            ENDIF
            DIFF = (DIFF/CSCL_FAC(1,JCV+ICV))**2.0D0
            SCR(JCV+ICV) = DIFF
            MIN_DISP = MIN(DIFF,MIN_DISP)
          ENDDO
          IF(MOD(I_TEMP,ICHECK) .EQ. 0 ) THEN
            AV_DISP = 0.0D0 
!$OMP parallel do private(ICV) reduction(+:AV_DISP)
            DO ICV = 1,NCVSYS(IS)
              AV_DISP = AV_DISP+SCR(JCV+ICV)
            ENDDO
            AV_DISP = DSQRT(AV_DISP)
            write(6,'(4x,A,I4,A,f10.6,A,f10.6,A,f10.6/)') 
     &        'SYS ',IS,'MIN DISP. = ',DSQRT(MIN_DISP),
     &        '  ||DISP.tot|| = ',AV_DISP,
     &        '  Tolerance ',TOLLM
            IF(AV_DISP .GT. TOLLM .OR. I_CVST .EQ. INTER_HILL_MAX) THEN 
             TESTC = TESTC + 1
            ENDIF
          ENDIF
          JCV = JCV + NCVSYS(IS)
        ENDDO
        IF(TESTC .EQ. NSUBSYS) THEN
          HILL_ADD = .TRUE.
        ENDIF
      ENDIF   !I_CVST
C     ==--------------------------------------------------------------==

      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      SUBROUTINE  CV_DIFF_MD(CV_LAST,CVD_IST,CVD_SCL,CV_SCL,
     &            I_META,SCR,LSCR,NTOT_ITER)

      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'

      INTEGER   I_META,LSCR
      REAL*8    CV_LAST(NCOLVAR),CVD_IST(NCOLVAR),CVD_SCL(NCOLVAR),
     &          CV_SCL(NCOLVAR),SCR(LSCR)

      INTEGER   ICV,II,itt,NTOT_ITER
      REAL*8    DIFF

      DIMENSION     CV_PATH(NTOT_ITER,NCOLVAR),
     &              CSCL_VAL(NTOT_ITER,NCOLVAR),
     &              HLLW_VAL(NTOT_ITER,NSUBSYS),
     &              HLLH_VAL(NTOT_ITER,NSUBSYS),
     &              CSCL_FAC(3,NCOLVAR)
  
C     ==--------------------------------------------------------------==
C     Diffusion calculation


      CALL AZZERO(CVD_IST,NCOLVAR)
      CALL AZZERO(CVD_SCL,NCOLVAR)

      DO ICV = 1,NCOLVAR

        DO II = 1,I_META-1
          DIFF = DABS(CV_PATH(II,ICV)-CV_LAST(ICV))
          IF (IANGCV(ICV) .EQ. 1 .AND. DIFF .GT. PI) THEN
            DIFF = DIFF - 2.0D0*PI
          ENDIF
          CVD_IST(ICV) = CVD_IST(ICV) + 
     &                 DIFF/DBLE(I_META-II)
          CVD_SCL(ICV) = CVD_SCL(ICV) +
     &                 DIFF/DBLE(I_META-II)/CSCL_VAL(II,ICV)
        ENDDO
        CV_SCL(ICV) = CV_LAST(ICV) / CSCL_FAC(1,ICV)
      ENDDO
!$OMP parallel do private(ICV)
      DO ICV  = 1,NCOLVAR
        CV_PATH(I_META,ICV) =  CV_LAST(ICV)
        CSCL_VAL(I_META,ICV)=  CSCL_FAC(1,ICV)
      ENDDO
!$OMP parallel do private(II)
      DO II = 1,NSUBSYS
        HLLW_VAL(I_META,II)    =  HWM(II)
        HLLH_VAL(I_META,II)    =  HHM(II)
      ENDDO

C     ==--------------------------------------------------------------==

      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==

      SUBROUTINE  CV_EXL_OUTM(I_META,HC_LAST,F_HARM,F_HILL,F_WALL,
     &           CVD_IST,DISP_SYS,EKINC,EKINP)

      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'ener.inc'
      INCLUDE  'nose.inc'
      INCLUDE  'cnst.inc'
      INCLUDE  'ropt.inc'
      INCLUDE  'fileopen.inc'

C     ==--------------------------------------------------------------==

      INTEGER       I_META
      REAL*8        HC_LAST(NCOLVAR),F_HARM(NCOLVAR),
     &              F_HILL(NCOLVAR),F_WALL(NCOLVAR),
     &              CVD_IST(NCOLVAR),
     &              DISP_SYS(NSUBSYS),EKINC,EKINP

      DIMENSION     CSCL_FAC(3,NCOLVAR)
      REAL*8        T_ION


      CHARACTER*100 OUTCOLVAR(10),OUTPARVAR(10),OUTISTCOLVAR(10),
     &              OUTFORFAC(10),OUTDISP(10),OUTVEL(10),OUTEN
      CHARACTER*10  FILE1,FILE2,FILE3,FILE4,FILE5,FILE6,FILE7
      DATA          FILE1,FILE2,FILE3,FILE4,FILE5,FILE6,FILE7
     *     /'colvar_mtd','parvar_mtd','istvar_mtd','forfac_mtd',
     &       'disvar_mtd', 'velvar_mtd','enevar_mtd' /

      INTEGER       IFIRST
      DATA          IFIRST /FO_VERB/
      SAVE          IFIRST

      CHARACTER     TAG,LINEFORM*100,CHNUM*10,FLAG*10
      LOGICAL       FERROR

      INTEGER       IA,IE,IAA,IEE,ICV,IS,JJ


C     ==--------------------------------------------------------------==
      JJ = 0
C     Path of output files
      DO IS = 1,NSUBSYS
        WRITE(FLAG,'(I5)') IS
        CALL XSTRING(FLAG,IA,IE)
        OUTCOLVAR(IS) = FILE1//'_S'//FLAG(IA:IE)
        OUTPARVAR(IS) = FILE2//'_S'//FLAG(IA:IE)
        OUTISTCOLVAR(IS)=FILE3//'_S'//FLAG(IA:IE)
        OUTFORFAC(IS) = FILE4//'_S'//FLAG(IA:IE)
        OUTDISP(IS)   = FILE5//'_S'//FLAG(IA:IE)
        OUTVEL(IS)    = FILE6//'_S'//FLAG(IA:IE)

C     ==--------------------------------------------------------------==
C     Open output files
        CALL FILEOPEN(51,OUTCOLVAR(IS),   FO_APP+IFIRST,FERROR)
        CALL FILEOPEN(52,OUTPARVAR(IS),   FO_APP+IFIRST,FERROR)
        CALL FILEOPEN(53,OUTISTCOLVAR(IS),FO_APP+IFIRST,FERROR)
        CALL FILEOPEN(54,OUTFORFAC(IS),   FO_APP+IFIRST,FERROR)
        CALL FILEOPEN(55,OUTDISP(IS),     FO_APP+IFIRST,FERROR)
        CALL FILEOPEN(56,OUTVEL(IS),      FO_APP+IFIRST,FERROR)
C     ==--------------------------------------------------------------==
C     Write output
        WRITE(CHNUM,'(I5)') NCVSYS(IS)
        CALL XSTRING(CHNUM,IAA,IEE)
        LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E13.4)'
        WRITE(51,LINEFORM) NFI,(HC_LAST(JJ+ICV),ICV=1,NCVSYS(IS)),
     &                     (CSCL_FAC(1,JJ+ICV),ICV=1,NCVSYS(IS))

        LINEFORM = 
     &     '(1X,I7,3F14.6)'
        WRITE(52,LINEFORM) NFI,
     &                DISP_SYS(IS),HWM(IS),HHM(IS)
C     Close files
        CALL FILECLOSE(51)
        CALL FILECLOSE(52)


        LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E14.6)'
        WRITE(53,LINEFORM) NFI,(CV_IST(JJ+ICV),ICV=1,NCVSYS(IS)),
     *              (CV_IST(JJ+ICV)-HC_LAST(JJ+ICV),ICV=1,NCVSYS(IS))
C     Close files
        CALL FILECLOSE(53)

C     Print force factors
        LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'
     &     //CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E16.4)'
        WRITE(54,LINEFORM) NFI,(F_HARM(JJ+ICV),ICV=1,NCVSYS(IS)),
     *                   (F_HILL(JJ+ICV),ICV=1,NCVSYS(IS)),
     &                   (F_WALL(JJ+ICV),ICV=1,NCVSYS(IS))

C     Close files
        CALL FILECLOSE(54)

C     Print last displacements
        LINEFORM = 
     &     '(I6,'//CHNUM(IAA:IEE)//'f11.6,'//CHNUM(IAA:IEE)//
     &     'f10.6,'//CHNUM(IAA:IEE)//'f10.6)'
        WRITE(55,LINEFORM) NFI,
     &      ((CV_DYN(JJ+ICV)-HC_LAST(JJ+ICV)),ICV=1,NCVSYS(IS)),
     &                (CVD_IST(JJ+ICV),ICV=1,NCVSYS(IS)),
     *                (KHARM(JJ+ICV),ICV=1,NCVSYS(IS))

C     Close files
        CALL FILECLOSE(55)

C     Print last velocities, temperature and kinetic energy
c      EHAM_HILL=EKINP+ETOT+ENOSE+ENOSP+ECNSTR+EKINC
        LINEFORM = 
     &     '(I6,'//CHNUM(IAA:IEE)//'f11.6)'
        WRITE(56,LINEFORM) NFI,(CV_VEL(JJ+ICV),ICV=1,NCVSYS(IS))

        CALL FILECLOSE(56)

        JJ = JJ + NCVSYS(IS)
      ENDDO

      CALL FILEOPEN(57,FILE7,FO_APP+IFIRST,FERROR)
      IFIRST=0

      T_ION = EKINP*FACTEM*2.D0/GLIB
      WRITE(57,'(I6,8E16.6)') NFI,T_ION,EKINC,
     &                   EKINCV,VHARM,GAUSSPOT,
     &                   ETOT,EHAM_HILL,EHAM_HILL+GAUSSPOT
      CALL FILECLOSE(57)
C     ==--------------------------------------------------------------==

      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==

      SUBROUTINE  CV_EXL_OUTM2(I_META,EKINC,EKINP)

      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'ener.inc'
      INCLUDE  'nose.inc'
      INCLUDE  'cnst.inc'
      INCLUDE  'ropt.inc'
      INCLUDE  'fileopen.inc'

C     ==--------------------------------------------------------------==

      INTEGER       I_META
      REAL*8        EKINC,EKINP

      REAL*8        T_ION


      CHARACTER*100 OUTISTCOLVAR(10),OUTEN
      CHARACTER*10  FILE3,FILE7
      DATA          FILE3,FILE7
     *     /'istvar_mtd','enevar_mtd' /

      CHARACTER     TAG,LINEFORM*100,CHNUM*10,FLAG*10
      LOGICAL       FERROR

      INTEGER       IA,IE,IAA,IEE,ICV,IS,JJ

      INTEGER       IFIRST,IT,n
      DATA          IFIRST/FO_VERB/
      SAVE          IFIRST
      REAL*8        AVCV(NCOLVAR) , dummy
      POINTER       (IP_AVCV,AVCV)
      SAVE          IP_AVCV

C     ==--------------------------------------------------------------==
      IF(IFIRST.NE.0) THEN
        CALL MEMORY(IP_AVCV,NCOLVAR,'AVCV')
        CALL AZZERO(AVCV,NCOLVAR)
      ENDIF

      JJ = 0
C     Path of output files
      DO IS = 1,NSUBSYS
        WRITE(FLAG,'(I5)') IS
        CALL XSTRING(FLAG,IA,IE)
        OUTISTCOLVAR(IS)=FILE3//'_S'//FLAG(IA:IE)

C     ==--------------------------------------------------------------==
C     Open output file
        IF(IFIRST.NE.0) THEN
          FERROR=.FALSE.
          CALL FILEOPEN(53,OUTISTCOLVAR(IS),FO_OLD,FERROR)
          IF(FERROR) THEN
            CALL FILEOPEN(53,OUTISTCOLVAR(IS),FO_NEW,FERROR)
          ELSE
            REWIND (53)
            DO IT = 1,I_META-1
              READ(53,*) n,(dummy,ICV=1,NCOLVAR),
     &                 (AVCV(JJ+ICV),ICV=1,NCVSYS(IS))
            ENDDO 
            DO ICV=1,NCVSYS(IS)
              AVCV(JJ+ICV) = AVCV(JJ+ICV)*DBLE(I_META-1)
            ENDDO
          ENDIF
        ELSE
          CALL FILEOPEN(53,OUTISTCOLVAR(IS),FO_APP,FERROR)
        ENDIF
C     ==--------------------------------------------------------------==

        DO ICV = 1,NCVSYS(IS)
          AVCV(JJ+ICV) = AVCV(JJ+ICV)+CV_IST(JJ+ICV)
        ENDDO

C     Write output
        WRITE(CHNUM,'(I5)') NCVSYS(IS)
        CALL XSTRING(CHNUM,IAA,IEE)

        LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E14.6)'
        WRITE(53,LINEFORM) NFI,(CV_IST(JJ+ICV),ICV=1,NCVSYS(IS)),
     *          (AVCV(JJ+ICV)/DBLE(I_META),ICV=1,NCVSYS(IS))
C     Close files
        CALL FILECLOSE(53)
        JJ = JJ + NCVSYS(IS)
      ENDDO

      CALL FILEOPEN(57,FILE7,FO_APP+IFIRST,FERROR)
      T_ION = EKINP*FACTEM*2.D0/GLIB
      WRITE(57,'(I6,8E16.6)') NFI,T_ION,EKINC,
     &                   EKINCV,VHARM,GAUSSPOT,
     &                   ETOT,EHAM_HILL,EHAM_HILL+GAUSSPOT
      CALL FILECLOSE(57)
      IFIRST=0
C     ==--------------------------------------------------------------==

      RETURN
      END
C     ==--------------------------------------------------------------==
      SUBROUTINE RMTDRESM(NR,CV_DISP,TFULL,NTOT_ITER)

      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      INTEGER  NR,NTOT_ITER
      REAL*8   CV_DISP(NCOLVAR)
      LOGICAL  TFULL

C     Variables
      INTEGER IA,IE,ICV,IS,IT,NC,NS
      CHARACTER FFORMAT*20
      LOGICAL  FERROR
      DIMENSION     CV_PATH(NTOT_ITER,NCOLVAR),
     &              CSCL_VAL(NTOT_ITER,NCOLVAR),
     &              HLLW_VAL(NTOT_ITER,NSUBSYS),
     &              HLLH_VAL(NTOT_ITER,NSUBSYS)

!     ==--------------------------------------------------------------==

C     Construct the filename
      IF(PARENT) THEN
        CALL XSTRING(FMTDRES,IA,IE)
        CALL FILEOPEN(NR,FMTDRES,FO_OLD+FO_UFO,FERROR)
        IF(FERROR) THEN
          WRITE(FFORMAT,'(A,I2,A)')
     &         '(/,A,T',MAX(36,65-(IE-IA)),',A)'
          WRITE(6,FFORMAT) 
     &         'RMTDRES| MTD RESTART FILE NOT FOUND:',FMTDRES(IA:IE)
          CALL STOPGM('RMTDRES',' FILE NOT FOUND ')
        ENDIF

        REWIND (NR)
        READ (NR) I_META_RES
        READ (NR) NC
        IF(NC .NE. NCOLVAR) THEN
          WRITE(6,'(A,I3,A,I3)') 'RMTDRES! DIFFERENT # of CV ',
     &                           NC,' vs',NCOLVAR
          CALL STOPGM('RMTDRES','USE SAME # of CV')
        ENDIF

        READ (NR) NS
        IF(NS .NE. NSUBSYS) THEN
          WRITE(6,'(A,I3,A,I3)') 
     &          'RMTDRES! DIFFERENT # of SUBSETS fur MULTI_MTD  ',
     &          NS,' vs', NSUBSYS
          CALL STOPGM('RMTDRES','USE SAME # of SETS') 
        ENDIF

        IF(TFULL) THEN
          DO ICV = 1,NCOLVAR
            READ (NR) (CV_PATH(IT,ICV),IT=1,I_META_RES)
            READ (NR) (CSCL_VAL(IT,ICV),IT=1,I_META_RES)
          ENDDO 

          IF(LEXTLAGRANGE) THEN

            READ (NR)(CV_DISP(ICV),ICV=1,NCOLVAR)
            READ (NR)(CV_VEL(ICV),ICV=1,NCOLVAR)

          ENDIF

          READ (NR) (NCVSYS(IS),IS=1,NSUBSYS)
          DO IS=1,NSUBSYS
            READ (NR) (HLLW_VAL(IT,IS),IT=1,I_META_RES)
            READ (NR) (HLLH_VAL(IT,IS),IT=1,I_META_RES)
          ENDDO

          WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(34,65-(IE-IA)),',A)'
          WRITE(6,FFORMAT)
     &       ' MTD RESTART INFO READ FROM FILE ',FMTDRES(IA:IE)
        ENDIF
        CALL FILECLOSE(NR)

      ENDIF  ! parent

      RETURN
      END

C     ==--------------------------------------------------------------==
      SUBROUTINE WMTDRESM(NW,NTOT_ITER,I_META)

      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      INTEGER NW,NTOT_ITER,I_META

C     Variables
      INTEGER IA,IE,I1,I2,ICV,IS,IT
      CHARACTER FFORMAT*20
      LOGICAL FERROR
      DIMENSION     CV_PATH(NTOT_ITER,NCOLVAR),
     &              CSCL_VAL(NTOT_ITER,NCOLVAR),
     &              HLLW_VAL(NTOT_ITER,NSUBSYS),
     &              HLLH_VAL(NTOT_ITER,NSUBSYS)
!     ==--------------------------------------------------------------==



C     Construct the filename
      IF(PARENT) THEN
        CALL XSTRING(FMTDRES,IA,IE)
        CALL FILEOPEN(NW,FMTDRES(IA:IE),FO_DEF+FO_UFO,FERROR)
        REWIND (NW)

        WRITE(NW) I_META-1
        WRITE(NW) NCOLVAR

        DO ICV = 1,NCOLVAR
          WRITE(NW) (CV_PATH(IT,ICV),IT=1,I_META-1)
          WRITE(NW) (CSCL_VAL(IT,ICV),IT=1,I_META-1)
        ENDDO 

        IF(LEXTLAGRANGE) THEN

          WRITE(NW)(CV_DYN(ICV)-CV_PATH(I_META-1,ICV),
     &                                  ICV=1,NCOLVAR)
          WRITE(NW)(CV_VEL(ICV),ICV=1,NCOLVAR)

        ENDIF

        WRITE(NW) NSUBSYS
        WRITE(NW) (NCVSYS(IS),IS=1,NSUBSYS)
        DO IS=1,NSUBSYS
          WRITE(NW) (HLLW_VAL(IT,IS),IT=1,I_META-1)
          WRITE(NW) (HLLH_VAL(IT,IS),IT=1,I_META-1)
        ENDDO

        CALL FILECLOSE(NW)
        WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(34,65-(IE-IA)),',A)'
        WRITE(6,FFORMAT)
     &       ' MTD RESTART INFO WRITTEN ON FILE ',FMTDRES(IA:IE)

      ENDIF  ! parent

      RETURN
      END

!     ==--------------------------------------------------------------==
      SUBROUTINE  CV_READ_OUTM(CV_DISP)

      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      REAL*8   CV_DISP(NCOLVAR)

C     Variables
      INTEGER   IJ, II, ICV, JJ, IS, IA,I,IE,IFILE
      CHARACTER*20  FLAG
      LOGICAL FERROR
 
      CHARACTER*100 OUTCOLVAR(10),OUTPARVAR(10),
     &              OUTDISP(10),OUTVEL(10)
      CHARACTER*10  FILE1,FILE2,FILE5,FILE6
      DATA          FILE1,FILE2,FILE5,FILE6
     *     /'colvar_mtd','parvar_mtd','disvar_mtd',
     *      'velvar_mtd' /

      REAL*8 DISPLACEMENT
      DIMENSION     CV_PATH(I_META_MAX+I_META_RES,NCOLVAR),
     &              CSCL_VAL(I_META_RES+I_META_MAX,NCOLVAR),
     &              HLLW_VAL(I_META_RES+I_META_MAX,NSUBSYS),
     &              HLLH_VAL(I_META_RES+I_META_MAX,NSUBSYS)


C     ==--------------------------------------------------------------==
C     Path of output files

      DO IS = 1,NSUBSYS
        WRITE(FLAG,'(I5)') IS
        CALL XSTRING(FLAG,IA,IE)
        OUTCOLVAR(IS)  = FILE1//'_S'//FLAG(IA:IE)
        OUTPARVAR(IS)  = FILE2//'_S'//FLAG(IA:IE)
        OUTDISP(IS)    = FILE5//'_S'//FLAG(IA:IE)
        OUTVEL(IS)     = FILE6//'_S'//FLAG(IA:IE)
      ENDDO

      FERROR=.FALSE.
      JJ = 0
      DO I = 1, NSUBSYS
        CALL FILEOPEN(51,OUTCOLVAR(I),FO_OLD,FERROR)
        IF(FERROR) GOTO 20
        CALL FILEOPEN(52,OUTPARVAR(I),FO_OLD,FERROR)
        IF(FERROR) GOTO 20
        CALL FILEOPEN(55,OUTDISP(I),  FO_OLD,FERROR)
        IF(FERROR) GOTO 20
        CALL FILEOPEN(56,OUTVEL(I),   FO_OLD,FERROR)
        IF(FERROR) GOTO 20
        REWIND (51)
        REWIND (52)
        REWIND (55)
        REWIND (56)
        DO II = 1,I_META_RES
          READ(51,ERR=20,END=20,FMT=*)  IJ, 
     &                    (CV_PATH(II,JJ+ICV),ICV=1,NCVSYS(I)),
     &                    (CSCL_VAL(II,JJ+ICV),ICV=1,NCVSYS(I))
C           from output forces and parameters
          READ(52,ERR=20,END=20,FMT=*) IJ, 
     &                 DISPLACEMENT,HLLW_VAL(II,I),HLLH_VAL(II,I)
          READ(55,ERR=20,END=20,FMT=*) IJ, 
     &                 (CV_DISP(JJ+ICV),ICV=1,NCVSYS(I))
          READ(56,ERR=20,END=20,FMT=*)  IJ, 
     &                 (CV_VEL(JJ+ICV),ICV=1,NCVSYS(I))
        ENDDO
        CALL FILECLOSE(51)
        CALL FILECLOSE(52)
        CALL FILECLOSE(55)
        CALL FILECLOSE(56)
        JJ = JJ+NCVSYS(I)

        GOTO 100
 20     CONTINUE
        WRITE(6,*) ' ERROR WHILE READING RESTART DATA '
            CALL STOPGM('META_EXTLAGR',' ')
 100    CONTINUE
      ENDDO

      RETURN
      END

C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==

