C     ================================================================== 
      SUBROUTINE CALC_POS_DYN(TOLLM,I_CVST,I_TEMP,I_META,HC_LAST,
     &                     SCR,LSCR,HILL_ADD)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'

      INTEGER    I_CVST,I_TEMP,I_META,LSCR
      REAL*8     TOLLM,HC_LAST(NCOLVAR),
     &           SCR(LSCR)
      LOGICAL    HILL_ADD

      DIMENSION  CSCL_FAC(3,NCOLVAR)   
      INTEGER    II,IJ,ICV
      REAL*8     SUM,MIN_DISP,DIFF,AV_DISP

C     ==--------------------------------------------------------------==
C     Store CV values and Check averages
      
      IF(I_CVST .EQ.  INTER_HILL ) THEN
        MIN_DISP = 100.0D0
        II = INTER_HILL
        AV_DISP  = 0.0D0
        DO ICV = 1,NCOLVAR
          DIFF = (CV_DYN(ICV)-HC_LAST(ICV))
          IF (IANGCV(ICV) .EQ. 1 .AND. DIFF .GT. PI) THEN
            DIFF = DIFF -2.0D0*PI
          ELSEIF (IANGCV(ICV) .EQ. 1 .AND. DIFF .LT. -PI) THEN
            DIFF = DIFF +2.0D0*PI
          ENDIF
          DIFF = (DIFF/CSCL_FAC(1,ICV))**2.0D0
          AV_DISP = AV_DISP + DIFF
          MIN_DISP = MIN(DIFF,MIN_DISP)
        ENDDO
        AV_DISP = DSQRT(AV_DISP)
        IF(AV_DISP .GE. TOLLM .OR. I_META .EQ. 1) HILL_ADD = .TRUE.

        write(6,'(10x,A,f10.6,A,f10.6,A,f10.6/)') 
     &      'MIN DISP. = ',DSQRT(MIN_DISP),'  ||DISP.tot|| = ', AV_DISP,
     &      '  Tolerance ',TOLLM
      ELSEIF(I_CVST .GT.  INTER_HILL ) THEN
 
        I_TEMP = I_TEMP + 1
        II = INTER_HILL
        MIN_DISP = 100.0D0
        DO ICV = 1,NCOLVAR
          DIFF = (CV_DYN(ICV)-HC_LAST(ICV))
          IF (IANGCV(ICV) .EQ. 1 .AND. DIFF .GT. PI) THEN
            DIFF = DIFF -2.0D0*PI
          ELSEIF (IANGCV(ICV) .EQ. 1 .AND. DIFF .LT. -PI) THEN
            DIFF = DIFF +2.0D0*PI
          ENDIF
          DIFF = (DIFF/CSCL_FAC(1,ICV))**2.0D0
          SCR(ICV) = DIFF
          MIN_DISP = MIN(DIFF,MIN_DISP)
        ENDDO
        IF(MOD(I_TEMP,ICHECK) .EQ. 0 ) THEN
          AV_DISP = 0.0D0 
          DO ICV = 1,NCOLVAR
            AV_DISP = AV_DISP+SCR(ICV)
          ENDDO
          AV_DISP = DSQRT(AV_DISP)
          write(6,'(10x,A,f10.6,A,f10.6,A,f10.6/)') 
     &      'MIN DISP. = ',DSQRT(MIN_DISP),'  ||DISP.tot|| = ',AV_DISP,
     &       '  Tolerance ',TOLLM
           IF(AV_DISP .GE. TOLLM .OR. I_CVST .GE. INTER_HILL_MAX) THEN 
            HILL_ADD = .TRUE.
          ENDIF
        ENDIF

      ENDIF   !I_CVST
C     ==--------------------------------------------------------------==

      RETURN
      END
C     ================================================================== 
      SUBROUTINE CALC_POS_DYN_MW(TOLLM,I_CVST_MW,I_TEMP_MW,
     &                     I_META,HC_LAST,
     &                     SCR,LSCR,HILL_ADD_MW)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'mw.inc'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'
c      INCLUDE 'pimd.inc'

      INTEGER    I_CVST_MW(NWALK),I_TEMP_MW(NWALK),I_META,LSCR
      REAL*8     TOLLM,HC_LAST(NCOLVAR*NWALK),
     &           SCR(LSCR)
      LOGICAL    HILL_ADD_MW(NWALK)

      DIMENSION  CSCL_FAC(3,NCOLVAR)   
      INTEGER    II,IJ,ICV,IPW,IWALK0,IWALK1,IPW0,IPW1,WALKNEAR,IU
      REAL*8     SUM,MIN_DISP,DIFF,AV_DISP,AV_DISP_REL(NWALK),DISP_TMP,
     &           CVDIST
      CHARACTER*50  DECMW(3)

C     ==--------------------------------------------------------------==
C     Store CV values and Check averages
      DECMW(1)=' MIN.MTD.STEP '
      DECMW(2)=' DISP.GT.TOL  '
      DECMW(3)=' MAX.MTD.STEP '

      DO IWALK0=1,NWALK
         !position of first cv of a walker
         IPW0=(IWALK0-1)*NCOLVAR 
         HILL_ADD_MW(IWALK0)=.FALSE.
!        check the inter meta step is >= minimum mtd step
         IF(I_CVST_MW(IWALK0).GE.INTER_HILL)THEN
!          Displacement of a walker is the minimum displacement from the
!          last hills put by all walkers             
           AV_DISP_REL(IWALK0)=99999.0 ! a big value
           WALKNEAR=0
           DO IWALK1=1,NWALK
             !position of first cv of a walker
             IPW1=(IWALK1-1)*NCOLVAR 
             AV_DISP=0.0D0
             DO ICV=1,NCOLVAR
               !displacement of a cv
               DIFF=(CV_DYN(ICV+IPW0)-HC_LAST(ICV+IPW1)) 
               IF (IANGCV(ICV) .EQ. 1 .AND. DIFF .GT. PI) THEN
                 DIFF = DIFF -2.0D0*PI
               ELSEIF (IANGCV(ICV) .EQ. 1 .AND. DIFF .LT. -PI) THEN
                 DIFF = DIFF +2.0D0*PI
               ENDIF
               DIFF=DIFF/CSCL_FAC(1,ICV)
               !displacement square
               AV_DISP=AV_DISP+DIFF*DIFF
             END DO
             !average displacement
             AV_DISP=DSQRT(AV_DISP)
             IF(AV_DISP.LT.AV_DISP_REL(IWALK0))THEN
                 AV_DISP_REL(IWALK0)=AV_DISP
                 WALKNEAR=IWALK1
             END IF
           END DO
           IF(WALKNEAR.EQ.0)CALL STOPGM('CALC_POS_DYN_MW',
     &                      'WALKNEAR.EQ.0') 
!          deciding if hill need to be added due to any conditions
           IU=0
!          (a) add hill for the first walker, if the first time 
!          minimum mtd step is reached
           IF((I_CVST_MW(IWALK0).EQ.INTER_HILL).AND. 
     *         (I_META.EQ.1).AND.
     *         ((IWALK0).EQ.1) )THEN
               HILL_ADD_MW(IWALK0)=.TRUE.
               IU=1
!          (b) if max mtd step reached
           ELSE IF(I_TEMP_MW(IWALK0).EQ.INTER_HILL_MAX)THEN
                HILL_ADD_MW(IWALK0)=.TRUE.
                IU=3
!          (c) if displacement need to be checked and displacement >= tolerance 
!              plus the constraint that distance between CVs at time t is also >=tolerance
           ELSE IF((MOD(I_TEMP_MW(IWALK0),ICHECK).EQ.0).AND.
     &                 (AV_DISP_REL(IWALK0).GE.TOLLM))THEN
                 HILL_ADD_MW(IWALK0)=.TRUE.
                 IU=2
                 IF(IWALK0.GT.1)THEN
                   DO IWALK1=1,IWALK0-1
                      IPW1=(IWALK1-1)*NCOLVAR
                      CVDIST=0.0D0
                      DO ICV=1,NCOLVAR
                         CVDIST=CVDIST+
     &                       (CV_DYN(ICV+IPW0)-CV_DYN(ICV+IPW1))**2
                      END DO
                      CVDIST=DSQRT(CVDIST)
                      IF(CVDIST.LE.TOLLM) THEN
                        HILL_ADD_MW(IWALK0)=.FALSE.
                        IU=0
                        WRITE(6,'(A,I8,A,I8,A,F16.6,A)')
     &                  '**Walker',IWALK0,' is close to',IWALK1,
     &                  ' Distance:',CVDIST,' **' 
                      ENDIF
                   END DO
                 ENDIF
           END IF
           IF(IU.GT.0)THEN
               WRITE(6,'(T2,A,I8,A,I8,A,F16.8,A,F16.8,A)') 
     &      ' WALKER:',IWALK0,
     &      ' NEIGHBOR:',WALKNEAR,
     &      ' ||DISP.tot|| = ', AV_DISP_REL(IWALK0),
     &      '  Tolerance ',TOLLM,
     &      DECMW(IU)
           END IF
         END IF
      END DO
      RETURN
      END
C     ==================================================================
      SUBROUTINE RINVELCV(VEL,MASS,CSCL_FAC,NVAR,TEMP,EKINCV)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE

      INCLUDE  'system.h'
      INCLUDE  'cnst.inc'
C     Arguments
      INTEGER   NVAR
      REAL*8    VEL(NVAR),MASS(NVAR),CSCL_FAC(3,NVAR),TEMP,EKINCV
C     Variables
      INTEGER   ICV
      REAL*8    SEED,RNR,SIGMA,ALFA,CONST,XRANF,TEMPP,TSCAL,VSCALE
      EXTERNAL  XRANF

C     MAXWELL DISTRIBUTION FOR THE IONS

      CALL AZZERO(VEL,NVAR)
      SEED=135792468.0D0
      IF(TEMP.LT.1.D-5) GOTO 100
      CALL DURAND(SEED,3,RNR)
      DO ICV=1,NVAR
        SIGMA=DSQRT(TEMP/(MASS(ICV)*FACTEM))
        CALL DURAND(SEED,1,RNR)
        ALFA=2.0D0*PI*RNR
        VEL(ICV)=
     &       DSQRT(DLOG(XRANF())*(-2.0D0))*DCOS(ALFA)*SIGMA
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  CALCULATE KINETIC ENERGY OF THE CV                          ==
C     ==--------------------------------------------------------------==
      EKINCV= 0.D0
      TEMPP = 0.D0
      DO ICV=1,NVAR
        CONST=0.5D0*MASS(ICV)*VEL(ICV)*VEL(ICV)
            EKINCV=EKINCV+CONST
            TEMPP = TEMPP + CONST/(CSCL_FAC(1,ICV)*CSCL_FAC(1,ICV))
c            TEMPP = TEMPP + CONST
      ENDDO
      TEMPP=TEMPP*FACTEM*2.0D0/DBLE(NVAR)   
      IF(TEMPP.GT.1.D-5) THEN
        TSCAL=TEMP/TEMPP
        VSCALE=DSQRT(TSCAL)
!$OMP parallel do private(ICV)
        DO ICV=1,NVAR
          VEL(ICV)=VEL(ICV)*VSCALE
        ENDDO
      ENDIF

  100 CONTINUE

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RINVELCV_MW(VEL,MASS,CSCL_FAC,NVAR,TEMP,EKINCV)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE

      INCLUDE  'system.h'
      INCLUDE  'cnst.inc'
C     Arguments
      INTEGER   NVAR
      REAL*8    VEL(NVAR),MASS(NVAR),CSCL_FAC(3,NVAR),TEMP,EKINCV
C     Variables
      INTEGER   ICV
      REAL*8    SEED,RNR,SIGMA,ALFA,CONST,XRANFSEED,TEMPP,TSCAL,VSCALE

      CALL AZZERO(VEL,NVAR)
      IF(TEMP.LT.1.D-5) GOTO 100
      DO ICV=1,NVAR
        SIGMA=DSQRT(TEMP/(MASS(ICV)*FACTEM))
        CALL DURANDSEED(1,RNR)
        ALFA=2.0D0*PI*RNR
        VEL(ICV)=
     &      DSQRT(DLOG(XRANFSEED())*(-2.0D0))*DCOS(ALFA)*SIGMA
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  CALCULATE KINETIC ENERGY OF THE CV                          ==
C     ==--------------------------------------------------------------==
      EKINCV= 0.D0
      TEMPP = 0.D0
      DO ICV=1,NVAR
        CONST=0.5D0*MASS(ICV)*VEL(ICV)*VEL(ICV)
            EKINCV=EKINCV+CONST
            TEMPP = TEMPP + CONST/(CSCL_FAC(1,ICV)*CSCL_FAC(1,ICV))
      ENDDO
      TEMPP=TEMPP*FACTEM*2.0D0/DBLE(NVAR)   
      IF(TEMPP.GT.1.D-5) THEN
        TSCAL=TEMP/TEMPP
        VSCALE=DSQRT(TSCAL)
!!$OMP parallel do private(ICV)
        DO ICV=1,NVAR
          VEL(ICV)=VEL(ICV)*VSCALE
        ENDDO
      ENDIF

  100 CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END

C     ==================================================================
      SUBROUTINE RSCVELCV(TEMP1,TEMP2,TEMPP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'mw.inc'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'cnst.inc'

      REAL*8   TEMP1,TEMP2,TEMPP
      DIMENSION CSCL_FAC(3,NCOLVAR)

      REAL*8   CONST,TSCAL,VSCALE,DIF_CV
      INTEGER  ICV,IWALK1,IPW

C     ==--------------------------------------------------------------==
C     ==  Dynamical rescaling factor (cv_temp0/temp_IST),             ==
C     ==  where tempp is calculated every step                        ==
C     ==--------------------------------------------------------------==

      EKINCV = 0.D0
      VHARM  = 0.0D0
      TEMPP  = 0.0D0

      IF(TCVANALYSIS) RETURN

       DO IWALK1=1,NWALK
          VHARM  = 0.0D0
          EKINCV = 0.D0
          TEMPP  = 0.0D0
          IPW=(IWALK1-1)*NCOLVAR
          DO ICV=1,NCOLVAR
            DIF_CV = CV_IST(ICV+IPW)-CV_DYN(ICV+IPW)
            IF (TYCVAR(ICV) .EQ. 3 .AND. DIF_CV .GT. PI) THEN
              DIF_CV = DIF_CV -2.0D0*PI
            ELSEIF (TYCVAR(ICV) .EQ. 3 .AND. DIF_CV .LT. -PI) THEN
              DIF_CV = DIF_CV +2.0D0*PI
            ENDIF
            CONST  = 0.5D0*CV_MASS(ICV)*CV_VEL(ICV+IPW)*CV_VEL(ICV+IPW)
            EKINCV = EKINCV + CONST

            VHARM  = VHARM  + KHARM(ICV)*DIF_CV* DIF_CV
            IF(TCVSCALE)THEN
              TEMPP = TEMPP + CONST/(CSCL_FAC(1,ICV)*CSCL_FAC(1,ICV))
            ELSE
              TEMPP = TEMPP + CONST
            ENDIF
          ENDDO
          TEMPP=TEMPP*FACTEM*2.0D0/DBLE(NCOLVAR)   

          IF(TLOCALIZESPIN) THEN
            DO ICV=1,NCOLVAR
              IF(ICV_SPIN(ICV).NE. 0) THEN
                DIF_CV = CV_IST(ICV+IPW)-CV_DYN(ICV+IPW)
cmb         VHARM  = VHARM  - KHARM(ICV)*DIF_CV* DIF_CV ! this is a bug !
                VHARM  = VHARM  + KHARM(ICV)*DIF_CV* DIF_CV ! cmb-spin
              ENDIF
            ENDDO
          ENDIF

        IF(LCVTC) THEN
          IF(TEMPP.GT.TEMP1.OR.TEMPP.LT.TEMP2.AND.TEMPP.NE.0.D0) THEN
            TSCAL=CV_TEMP/TEMPP
            VSCALE=DSQRT(TSCAL)
            EKINCV = 0.0D0
            TEMPP  = 0.0D0
!!$OMP parallel do private(ICV,CONST) reduction(+:EKINCV,TEMPP)
            DO ICV=1,NCOLVAR
              CV_VEL(ICV+IPW)=CV_VEL(ICV+IPW)*VSCALE
              CONST  = 0.5D0*CV_MASS(ICV)*
     &                 CV_VEL(ICV+IPW)*CV_VEL(ICV+IPW)
              EKINCV = EKINCV + CONST
              TEMPP  = TEMPP + CONST/(CSCL_FAC(1,ICV)*CSCL_FAC(1,ICV))
            ENDDO
            TEMPP=TEMPP*FACTEM*2.0D0/DBLE(NCOLVAR)
          ENDIF
        ENDIF
        IF(NWALK.GT.1)THEN
          EKINCV_WALK(IWALK1)=EKINCV
          VHARM_WALK(IWALK1)=VHARM
        END IF
       END DO !IWALK1
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE  EKINCV_GLOBAL(EK_CV)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'cnst.inc'

      REAL*8   EK_CV,CONST,TSCAL,VSCALE,DIF_CV
      INTEGER  ICV

C     ==--------------------------------------------------------------==
C     ==  Kinetic Energy of the Collective Variable for global rescaling
C     ==--------------------------------------------------------------==
      EK_CV = 0.D0

      IF(TCVANALYSIS) RETURN

      DO ICV=1,NCOLVAR
        DIF_CV = CV_IST(ICV)-CV_DYN(ICV)
        IF (TYCVAR(ICV) .EQ. 3 .AND. DIF_CV .GT. PI) THEN
          DIF_CV = DIF_CV -2.0D0*PI
        ELSEIF (TYCVAR(ICV) .EQ. 3 .AND. DIF_CV .LT. -PI) THEN
          DIF_CV = DIF_CV +2.0D0*PI
        ENDIF
        CONST  = 0.5D0*CV_MASS(ICV)*CV_VEL(ICV)*CV_VEL(ICV)
        EK_CV = EK_CV + CONST

      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE  CV_EXLAGR_OUT(I_META,HC_LAST,F_HARM,F_HILL,F_WALL,
     &           CVD_IST,DISPLACEMENT,EKINC,EKINP)
!     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'ener.inc'
      INCLUDE  'nose.inc'
      INCLUDE  'cnst.inc'
      INCLUDE  'ropt.inc'
      INCLUDE  'fileopen.inc'
C     ==--------------------------------------------------------------==
      INTEGER       I_META
      REAL*8        HC_LAST(NCOLVAR),F_HARM(NCOLVAR),
     &              F_HILL(NCOLVAR),F_WALL(NCOLVAR),
     &              CVD_IST(NCOLVAR),
     &              DISPLACEMENT,EKINC,EKINP

      DIMENSION     CSCL_FAC(3,NCOLVAR)
      REAL*8        T_ION

      CHARACTER*20  FILE1,FILE2,FILE3,FILE4,FILE5,FILE6,FILE7,FILE8
      DATA          FILE1,FILE2,FILE3,FILE4,FILE5,FILE6,FILE7,FILE8
     *     /'colvar_mtd','parvar_mtd','istvar_mtd','forfac_mtd',
     &       'disvar_mtd', 'velvar_mtd','enevar_mtd','spinpo_mtd' /

      INTEGER       IFIRST
      DATA          IFIRST /FO_VERB/
      SAVE          IFIRST

      CHARACTER     TAG,LINEFORM*100,CHNUM*10,FLAG*10
      LOGICAL       FERROR

      INTEGER       IA,IE,IAA,IEE,ICV,IS
C     ==--------------------------------------------------------------==
C     Open output files
      CALL FILEOPEN(51,FILE1,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(52,FILE2,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(53,FILE3,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(54,FILE4,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(55,FILE5,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(56,FILE6,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(57,FILE7,FO_APP+IFIRST,FERROR)
      IF(TLOCALIZESPIN) THEN
        CALL FILEOPEN(58,FILE8,FO_APP+IFIRST,FERROR)
      ENDIF
C     ==--------------------------------------------------------------==
C     Verbose open only on the first run
      IFIRST=0
C     ==--------------------------------------------------------------==
C     Write output
      WRITE(CHNUM,'(I5)') NCOLVAR
      CALL XSTRING(CHNUM,IAA,IEE)
      LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E13.3)'
      WRITE(51,LINEFORM) NFI,(HC_LAST(ICV),ICV=1,NCOLVAR),
     &                     (CSCL_FAC(1,ICV),ICV=1,NCOLVAR)

      LINEFORM = 
     &     '(1X,I7,3F14.6)'
      WRITE(52,LINEFORM) NFI,
     &                DISPLACEMENT,HLLW,HLLH
C     Close files
      CALL FILECLOSE(51)
      CALL FILECLOSE(52)

      LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E14.6)'
      WRITE(53,LINEFORM) NFI,(CV_IST(ICV),ICV=1,NCOLVAR),
     *              (CV_IST(ICV)-HC_LAST(ICV),ICV=1,NCOLVAR)
C     Close files
      CALL FILECLOSE(53)

C     Print force factors
      LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'
     &     //CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E16.4)'
      WRITE(54,LINEFORM) NFI,(F_HARM(ICV),ICV=1,NCOLVAR),
     *       (F_HILL(ICV),ICV=1,NCOLVAR),(F_WALL(ICV),ICV=1,NCOLVAR)

C     Close files
      CALL FILECLOSE(54)

C     Print last displacements
      LINEFORM = 
     &     '(I6,'//CHNUM(IAA:IEE)//'f11.6,'//CHNUM(IAA:IEE)//
     &     'f10.6,'//CHNUM(IAA:IEE)//'f10.6)'
      WRITE(55,LINEFORM) NFI,
     &      ((CV_DYN(ICV)-HC_LAST(ICV)),ICV=1,NCOLVAR),
     &                (CVD_IST(ICV),ICV=1,NCOLVAR),
     *      (KHARM(ICV),ICV=1,NCOLVAR)

C     Close files
      CALL FILECLOSE(55)

C     Print last velocities, temperature and kinetic energy
c     EHAM_HILL=EKINP+ETOT+ENOSE+ENOSP+ECNSTR+EKINC+VHARM+EKINC
      LINEFORM = 
     &     '(I6,'//CHNUM(IAA:IEE)//'f11.6,f15.6,6f16.8)'

      WRITE(56,LINEFORM) NFI,(CV_VEL(ICV),ICV=1,NCOLVAR)

      CALL FILECLOSE(56)

      T_ION = EKINP*FACTEM*2.D0/GLIB
      LINEFORM = '(I6,8E16.6)'
      WRITE(57,LINEFORM) NFI,
     &                   T_ION,EKINC,EKINCV,VHARM,GAUSSPOT,
     &                   ETOT,EHAM_HILL,EHAM_HILL+GAUSSPOT
      CALL FILECLOSE(57)

      IF(TLOCALIZESPIN) THEN
C     Print Position of the center of the spin density
        WRITE(58,'(I6,3f12.6)') NFI, RCC(1),RCC(2),RCC(3)
        CALL FILECLOSE(58)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE  CV_EXLAGR_OUT_MW(I_META,HC_LAST,F_HARM,F_HILL,F_WALL,
     &           CVD_IST,DISPLACEMENT,EKINC,EKINP,IWALK1)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'ener.inc'
      INCLUDE  'nose.inc'
      INCLUDE  'cnst.inc'
      INCLUDE  'ropt.inc'
      INCLUDE  'fileopen.inc'
C     ==--------------------------------------------------------------==
      INTEGER       I_META,IWALK1
      REAL*8        HC_LAST(NCOLVAR),F_HARM(NCOLVAR),
     &              F_HILL(NCOLVAR),F_WALL(NCOLVAR),
     &              CVD_IST(NCOLVAR),
     &              DISPLACEMENT,EKINC,EKINP

      DIMENSION     CSCL_FAC(3,NCOLVAR)
      REAL*8        T_ION

      CHARACTER*20  FILE1,FILE2,FILE3,FILE4,FILE5,FILE6,FILE7,FILE8
      DATA          FILE1,FILE2,FILE3,FILE4,FILE5,FILE6,FILE7,FILE8
     *     /'colvar_mtd','parvar_mtd','istvar_mtd','forfac_mtd',
     &       'disvar_mtd', 'velvar_mtd','enevar_mtd','spinpo_mtd' /

      INTEGER       IFIRST
      DATA          IFIRST /FO_VERB/
      SAVE          IFIRST

      CHARACTER     TAG,LINEFORM*100,CHNUM*10,FLAG*10
      LOGICAL       FERROR

      INTEGER       IA,IE,IAA,IEE,ICV,IS
C     ==--------------------------------------------------------------==
C     Open output files
      CALL FILEOPEN(51,FILE1,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(52,FILE2,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(53,FILE3,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(54,FILE4,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(55,FILE5,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(56,FILE6,FO_APP+IFIRST,FERROR)
      CALL FILEOPEN(57,FILE7,FO_APP+IFIRST,FERROR)
      IF(TLOCALIZESPIN) THEN
        CALL FILEOPEN(58,FILE8,FO_APP+IFIRST,FERROR)
      ENDIF
C     ==--------------------------------------------------------------==
C     Verbose open only on the first run
      IFIRST=0
C     ==--------------------------------------------------------------==

C     Write output
      WRITE(CHNUM,'(I5)') NCOLVAR
      CALL XSTRING(CHNUM,IAA,IEE)
      LINEFORM = 
     & '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E13.3,I8)'
      WRITE(51,LINEFORM) NFI,(HC_LAST(ICV),ICV=1,NCOLVAR),
     &                     (CSCL_FAC(1,ICV),ICV=1,NCOLVAR),IWALK1

      LINEFORM = 
     &     '(1X,I7,3F14.6,I8)'
      WRITE(52,LINEFORM) NFI,
     &                DISPLACEMENT,HLLW,HLLH,IWALK1
C     Close files
      CALL FILECLOSE(51)
      CALL FILECLOSE(52)

      LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E14.6)'
      WRITE(53,LINEFORM) NFI,(CV_IST(ICV),ICV=1,NCOLVAR),
     *              (CV_IST(ICV)-HC_LAST(ICV),ICV=1,NCOLVAR)
C     Close files
      CALL FILECLOSE(53)

C     Print force factors
      LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'
     &     //CHNUM(IAA:IEE)//'E14.6,'//CHNUM(IAA:IEE)//'E16.4)'
      WRITE(54,LINEFORM) NFI,(F_HARM(ICV),ICV=1,NCOLVAR),
     *       (F_HILL(ICV),ICV=1,NCOLVAR),(F_WALL(ICV),ICV=1,NCOLVAR)

C     Close files
      CALL FILECLOSE(54)

C     Print last displacements
      LINEFORM = 
     &     '(I6,'//CHNUM(IAA:IEE)//'f11.6,'//CHNUM(IAA:IEE)//
     &     'f10.6,'//CHNUM(IAA:IEE)//'f10.6)'
      WRITE(55,LINEFORM) NFI,
     &      ((CV_DYN(ICV)-HC_LAST(ICV)),ICV=1,NCOLVAR),
     &                (CVD_IST(ICV),ICV=1,NCOLVAR),
     *      (KHARM(ICV),ICV=1,NCOLVAR)

C     Close files
      CALL FILECLOSE(55)

C     Print last velocities, temperature and kinetic energy
c     EHAM_HILL=EKINP+ETOT+ENOSE+ENOSP+ECNSTR+EKINC+VHARM+EKINC
      LINEFORM = 
     &     '(I6,'//CHNUM(IAA:IEE)//'f11.6,f15.6,6f16.8)'

      WRITE(56,LINEFORM) NFI,(CV_VEL(ICV),ICV=1,NCOLVAR)

      CALL FILECLOSE(56)

      T_ION = EKINP*FACTEM*2.D0/GLIB
      LINEFORM = '(I6,8E16.6)'
      WRITE(57,LINEFORM) NFI,
     &                   T_ION,EKINC,EKINCV_WALK(IWALK1),
     &                   VHARM_WALK(IWALK1),GAUSSPOT,
     &                   ETOT,EHAM_HILL,EHAM_HILL+GAUSSPOT
      CALL FILECLOSE(57)

      IF(TLOCALIZESPIN) THEN
C     Print Position of the center of the spin density
        WRITE(58,'(I6,3f12.6)') NFI, RCC(1),RCC(2),RCC(3)
        CALL FILECLOSE(58)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE SCF_TUNE(I_META,HC_LAST)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'irat.inc'
      INCLUDE  'cnst_dyn.inc'

      INTEGER   I_META
      REAL*8    HC_LAST(NCOLVAR)

      INTEGER   IFIRST,I0
      DATA      IFIRST /0/
      SAVE      IFIRST,I0

      DIMENSION CSCL_FAC(3,*),tad_scf(*)
      INTEGER   ICV,IRESET(3,NCOLVAR)
      POINTER   (IP_IRESET,IRESET)
      REAL*8    CV_MAX(NCOLVAR),CV_MIN(NCOLVAR),CV_MED(NCOLVAR)
      POINTER   (IP_CV_MAX,CV_MAX),(IP_CV_MIN,CV_MIN),(IP_CV_MED,CV_MED)
      SAVE      IP_CV_MAX,IP_CV_MIN,IP_CV_MED,IP_IRESET
      REAL*8    DAMP,FACT,ELONG,HEL1,HEL2,SCF_NEW
      PARAMETER (DAMP = 0.750D0)
c      PARAMETER (DAMP = 1.40D0)
      INTEGER   NINTER,NEVENT
      PARAMETER (NEVENT=2)

      IF(IFIRST .EQ. 0) THEN
        I0 = I_META
        CALL MEMORY(IP_CV_MAX,NCOLVAR,'CV_MAX')
        CALL AZZERO(CV_MAX,NCOLVAR)
        CALL MEMORY(IP_CV_MIN,NCOLVAR,'CV_MIN')
        CALL AZZERO(CV_MIN,NCOLVAR)
        CALL MEMORY(IP_CV_MED,NCOLVAR,'CV_MED')
        CALL AZZERO(CV_MED,NCOLVAR)
        CALL MEMORY(IP_IRESET,3*NCOLVAR/IRAT+1,'IRESET')
        CALL IAZZERO(IRESET,3*NCOLVAR)
        IFIRST = 1
      ENDIF

      NINTER = 3000/INTER_HILL 
      DO ICV = 1,NCOLVAR
        IF(.NOT.TAD_SCF(ICV)) THEN
          GOTO 15
        ELSEIF(TAD_SCF(ICV) .AND. IRESET(1,ICV) .EQ. 0) THEN
          CV_MAX(ICV) = HC_LAST(ICV)
          CV_MIN(ICV) = HC_LAST(ICV)
          CV_MED(ICV) = HC_LAST(ICV)
          IRESET(1,ICV) = 1
        ELSE
          CV_MAX(ICV) = MAX(CV_MAX(ICV),HC_LAST(ICV))
          CV_MIN(ICV) = MIN(CV_MIN(ICV),HC_LAST(ICV))
          CV_MED(ICV) = CV_MED(ICV)+HC_LAST(ICV)
          IF(MOD(I_META-I0,NINTER).EQ. 0) THEN
            CV_MED(ICV) = CV_MED(ICV)/DBLE(NINTER)
            ELONG = DABS(CV_MAX(ICV)-CV_MIN(ICV))/2.0D0
            HEL1  = DABS(CV_MAX(ICV)-CV_MED(ICV))
            HEL2  = DABS(CV_MED(ICV)-CV_MIN(ICV))
            FACT = HLLW*CSCL_FAC(1,ICV)
            IF(1.2D0*DAMP*ELONG .LT.FACT) THEN
              IRESET(2,ICV) = IRESET(2,ICV) + 1
              IRESET(3,ICV) = 0
              WRITE(6,'(/10x,A,I3,A,I5,A)')
     &           '******** WARNING n^ ', IRESET(2,ICV),
     &           'for Scale Factor of CV n^ ',
     &            ICV ,' ********' 
              WRITE(6,'(10x,A,I5,A,f14.6/10x,A,f14.6/)')
     &           '    in the last ',NINTER,' mstep MAX-MIN = ',ELONG,
     &           '  whereas HLLW*SCF = ', FACT
            ELSEIF(0.8D0*DAMP*HEL1 .GT. FACT .AND. 
     &             0.8D0*DAMP*HEL2 .GT. FACT) THEN
              IRESET(3,ICV) = IRESET(3,ICV) + 1
              IRESET(2,ICV) = 0
              WRITE(6,'(/10x,A,I3,A,I5,A)')
     &           '******** WARNING n^ ', IRESET(3,ICV),
     &           'for Scale Factor of CV n^ ',
     &            ICV ,' ********' 
              WRITE(6,'(10x,A,I5,A,f14.6,A,f14.6/10x,A,f14.6/)')
     &           '    in the last ',NINTER,' mstep MAX-MED = ',HEL1,
     &           ', MED-MIN = ',HEL2,'  whereas HLLW*SCF = ', FACT
            ELSE
              IRESET(3,ICV) = 0
              IRESET(2,ICV) = 0
            ENDIF
            IF(IRESET(2,ICV) .GE. NEVENT) THEN
              SCF_NEW = 0.2D0*CSCL_FAC(1,ICV)+0.8D0*DAMP*ELONG/HLLW
              IF(SCF_NEW .GT. CSCL_FAC(2,ICV)) THEN
                CSCL_FAC(1,ICV) = SCF_NEW
                WRITE(6,'(20x,A,I5,A,f14.6)')
     &           'Scaling Factor of CV',ICV,
     &           ' reduced to ',CSCL_FAC(1,ICV)
                IRESET(2,ICV) = 0
                IRESET(3,ICV) = 0
              ENDIF
            ELSEIF(IRESET(3,ICV) .GE. NEVENT) THEN
              SCF_NEW = 0.2D0*CSCL_FAC(1,ICV)+
     &              0.8D0*(HEL1 + HEL2)/((2.0D0-DAMP)*HLLW)*0.5D0
              IF(SCF_NEW .LT. CSCL_FAC(3,ICV)) THEN
                IRESET(2,ICV) = 0
                IRESET(3,ICV) = 0
                CSCL_FAC(1,ICV) = SCF_NEW
                WRITE(6,'(20x,A,I5,A,f14.6)')
     &           'Scaling Factor of CV',ICV,' increased to ',
     &            CSCL_FAC(1,ICV)
              ENDIF
            ENDIF
            IRESET(1,ICV) = 0
          ENDIF
        ENDIF
 15     CONTINUE
      ENDDO
C     ==--------------------------------------------------------------==
      
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE META_STRESS(TAUP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'ions.inc'
      INCLUDE  'strs.inc'
      INCLUDE  'metr.inc'
      INCLUDE  'cnst_dyn.inc'

      REAL*8    TAUP(3,NAX,NSX)
      INTEGER   IS,IA,KK,I,J,I1,I2,J1,J2
      REAL*8    TEMP(3,3),F2,AA1(3),AA2(3),AA3(3),FV(3,3)

      CALL AZZERO(DSTRMETA,6)

      DO IS=1,NSP
        DO IA=1,NA(IS)
          DSTRMETA(1) = DSTRMETA(1) + 
     &             FHILLS(ALPHA(1),IA,IS)*TAUP(BETA(1),IA,IS)
          DSTRMETA(2) = DSTRMETA(2) + 
     &             FHILLS(ALPHA(2),IA,IS)*TAUP(BETA(2),IA,IS)
          DSTRMETA(3) = DSTRMETA(3) + 
     &             FHILLS(ALPHA(3),IA,IS)*TAUP(BETA(3),IA,IS)
          DSTRMETA(4) = DSTRMETA(4) + 
     &             FHILLS(ALPHA(4),IA,IS)*TAUP(BETA(4),IA,IS)
          DSTRMETA(5) = DSTRMETA(5) + 
     &             FHILLS(ALPHA(5),IA,IS)*TAUP(BETA(5),IA,IS)
          DSTRMETA(6) = DSTRMETA(6) + 
     &             FHILLS(ALPHA(6),IA,IS)*TAUP(BETA(6),IA,IS)
        ENDDO
      ENDDO

      CALL AZZERO(FVBOUND,6)
      CALL AZZERO(FV,6)
      IF(TVOLBOUND) THEN
        DO I = 1,3
          AA1(I) = HT(1,I)
          AA2(I) = HT(2,I)
          AA3(I) = HT(3,I)
        ENDDO
        CALL  OMEGAGEN(AA1,AA2,AA3,OMEGA)
        
        F2 = 0.0D0
        IF(OMEGA .LT. VOLMIN+VOLMIN/100.D0) THEN
          F2 = +4.0D0*VBARRIER*(VOLMIN*VOLMIN*VOLMIN*VOLMIN)/
     &         (OMEGA**(5.0D0))
          write(6,'(72A)') ('*',i = 1,72) 
          write(6,'(10x,A,f12.4,A,f12.4)') 
     &         'WARNING: Volume = ',OMEGA,' <= Volmin = ',VOLMIN
          write(6,'(72A)')  ('*',i = 1,72)
          write(6,'(10x,A,f14.6)') 'Force: ',F2
        ELSEIF(OMEGA .GT. VOLMAX-VOLMAX/100.D0) THEN
          F2 = -4.0D0*VBARRIER/(VOLMAX*VOLMAX*VOLMAX*VOLMAX)*
     &                       (OMEGA*OMEGA*OMEGA)
          write(6,'(72A)') ('*',i = 1,72) 
          write(6,'(10x,A,f12.4,A,f12.4)') 
     &         'WARNING: Volume = ',OMEGA,' >= Volmax = ',VOLMAX
          write(6,'(72A)')  ('*',i = 1,72)
          write(6,'(10x,A,2f14.6)') 'Force: ',F2,VBARRIER
        ENDIF

        I1 = 2
        I2 = 3 
        J1 = I1
        J2 = I2

        DO I = 1,3
          DO J = 1,3
            FV(I,J) = F2*(HT(I1,J1)*HT(I2,J2)-HT(I2,J1)*HT(I1,J2))
            J1 = J2
            J2 = J
          ENDDO
          J1 = 2
          J2 = 3
          I1 = I2
          I2 = I
        ENDDO 
        CALL DGEMM('T','N',3,3,3,1.D0,FV,3,HT,3,0.D0,TEMP,3)
        DO KK = 1,6
          FVBOUND(KK) =  FV(ALPHA(KK),BETA(KK))
        ENDDO

      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE  CV_EXLAGR_OUT2(I_META,EKINC,EKINP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'ener.inc'
      INCLUDE  'nose.inc'
      INCLUDE  'cnst.inc'
      INCLUDE  'ropt.inc'
      INCLUDE  'fileopen.inc'
C     ==--------------------------------------------------------------==
      INTEGER       I_META
      REAL*8        EKINC,EKINP

      REAL*8        T_ION

      CHARACTER*20  FILE3,FILE7,FILE8
      DATA          FILE3,FILE7,FILE8
     *     /'istvar_mtd','enevar_mtd','spinpo_mtd' /

      CHARACTER     TAG,LINEFORM*100,CHNUM*10,FLAG*10
      LOGICAL       FERROR

      INTEGER       IA,IE,IAA,IEE,ICV,IS

      INTEGER       IFIRST,IT,n
      DATA          IFIRST/FO_VERB/
      SAVE          IFIRST
      REAL*8        AVCV(NCOLVAR) , dummy(NCOLVAR)
      POINTER       (IP_AVCV,AVCV),(ip_dummy,dummy)
      SAVE          IP_AVCV
C     ==--------------------------------------------------------------==
      IF(IFIRST.GT.0) THEN
        CALL MEMORY(IP_AVCV,NCOLVAR,'AVCV')
        CALL AZZERO(AVCV,NCOLVAR)
C     ==--------------------------------------------------------------==
        FERROR=.FALSE.
        CALL FILEOPEN(53,FILE3,FO_OLD,FERROR)
        IF(FERROR) THEN
          CALL FILEOPEN(53,FILE3,FO_NEW,FERROR)
        ELSE
          REWIND (53)
          CALL MEMORY(ip_dummy,NCOLVAR,'dummy')
          DO IT = 1,I_META-1
            READ(53,*) n,(dummy(ICV),ICV=1,NCOLVAR),
     &                 (AVCV(ICV),ICV=1,NCOLVAR)
          ENDDO 
          CALL FREEM(ip_dummy)
          DO ICV=1,NCOLVAR
            AVCV(ICV) = AVCV(ICV)*DBLE(I_META-1)
          ENDDO
        ENDIF
      ELSE
        CALL FILEOPEN(53,FILE3,FO_APP,FERROR)
      ENDIF

      CALL FILEOPEN(57,FILE7,FO_APP+IFIRST,FERROR)
      IF(TLOCALIZESPIN) THEN
        CALL FILEOPEN(58,FILE8,FO_APP+IFIRST,FERROR)
      ENDIF

      IFIRST=0
C     ==--------------------------------------------------------------==
      DO ICV = 1,NCOLVAR
        AVCV(ICV) = AVCV(ICV)+CV_IST(ICV)
      ENDDO

!     Write output
      WRITE(CHNUM,'(I5)') NCOLVAR
      CALL XSTRING(CHNUM,IAA,IEE)

      LINEFORM = 
     &     '(1X,I7,'//CHNUM(IAA:IEE)//'E14.6,'//
     &                CHNUM(IAA:IEE)//'E14.6)'
      WRITE(53,LINEFORM) NFI,(CV_IST(ICV),ICV=1,NCOLVAR),
     &              (AVCV(ICV)/DBLE(I_META),ICV=1,NCOLVAR)

!     Close files
      CALL FILECLOSE(53)

      T_ION = EKINP*FACTEM*2.D0/GLIB
      LINEFORM = '(I6,8E16.6)'
      WRITE(57,LINEFORM) NFI,
     &                   T_ION,EKINC,EKINCV,VHARM,GAUSSPOT,
     &                   ETOT,EHAM_HILL,EHAM_HILL+GAUSSPOT
      CALL FILECLOSE(57)

      IF(TLOCALIZESPIN) THEN
!     Print Position of the center of the spin density
        WRITE(58,'(I6,3f12.6)') NFI, RCC(1),RCC(2),RCC(3)
        CALL FILECLOSE(58)
      ENDIF
!     ==--------------------------------------------------------------==
      RETURN
      END
!     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE WMTDRES(NW,NTOT_ITER,I_META)
!     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      INTEGER NW,NTOT_ITER,I_META

C     Variables
      INTEGER IA,IE,ICV,IS,IT
      CHARACTER FFORMAT*20
      DIMENSION     CV_PATH(NTOT_ITER,NCOLVAR),
     &              CSCL_VAL(NTOT_ITER,NCOLVAR),
     &              HLLW_VAL(NTOT_ITER),
     &              HLLH_VAL(NTOT_ITER)
      LOGICAL FERROR
!     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        CALL XSTRING(FMTDRES,IA,IE)
        CALL FILEOPEN(NW,FMTDRES(IA:IE),FO_DEF+FO_UFO,FERROR)
        REWIND (NW)

        WRITE(NW) I_META-1
        WRITE(NW) NCOLVAR

        DO ICV = 1,NCOLVAR
          WRITE(NW) (CV_PATH(IT,ICV),IT=1,I_META-1)
          WRITE(NW) (CSCL_VAL(IT,ICV),IT=1,I_META-1)
        ENDDO 

        IF(LEXTLAGRANGE) THEN

          WRITE(NW)(CV_DYN(ICV)-CV_PATH(I_META-1,ICV),
     &                                  ICV=1,NCOLVAR)
          WRITE(NW)(CV_VEL(ICV),ICV=1,NCOLVAR)

        ENDIF

        WRITE(NW) (HLLW_VAL(IT),IT=1,I_META-1)
        WRITE(NW) (HLLH_VAL(IT),IT=1,I_META-1)

        CALL FILECLOSE(NW)
        WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(34,65-(IE-IA)),',A)'
        WRITE(6,FFORMAT)
     &       ' MTD RESTART INFO WRITTEN ON FILE ',FMTDRES(IA:IE)

      ENDIF  ! parent
!     ==--------------------------------------------------------------==
      RETURN
      END
!     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE WMTDRES_MW(NW,NTOT_ITER,I_META,IWALK1)
!     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      INTEGER NW,NTOT_ITER,I_META,IWALK1

C     Variables
      INTEGER IA,IE,ICV,IS,IT,IPW
      CHARACTER FFORMAT*20
      DIMENSION     CV_PATH(NTOT_ITER,NCOLVAR),
     &              CSCL_VAL(NTOT_ITER,NCOLVAR),
     &              HLLW_VAL(NTOT_ITER),
     &              HLLH_VAL(NTOT_ITER)
      LOGICAL FERROR
!     ==--------------------------------------------------------------==
      IPW=(IWALK1-1)*NCOLVAR
      IF(PARENT) THEN
        CALL XSTRING(FMTDRES,IA,IE)
        CALL FILEOPEN(NW,FMTDRES(IA:IE),FO_DEF+FO_UFO,FERROR)
        REWIND (NW)

        WRITE(NW) I_META-1
        WRITE(NW) NCOLVAR

        DO ICV = 1,NCOLVAR
!full path of the cv and the scaling factors are written
          WRITE(NW) (CV_PATH(IT,ICV),IT=1,I_META-1)
          WRITE(NW) (CSCL_VAL(IT,ICV),IT=1,I_META-1)
        ENDDO

        IF(LEXTLAGRANGE) THEN
!each walker writes the difference of s(t) with the s(hill_last) written
          WRITE(NW)(CV_DYN(ICV+IPW)-CV_PATH(I_META-1,ICV),
     &                                  ICV=1,NCOLVAR)
!each walker writes its own velocity
          WRITE(NW)(CV_VEL(ICV+IPW),ICV=1,NCOLVAR)
        ENDIF

        WRITE(NW) (HLLW_VAL(IT),IT=1,I_META-1)
        WRITE(NW) (HLLH_VAL(IT),IT=1,I_META-1)

        CALL FILECLOSE(NW)
        WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(34,65-(IE-IA)),',A)'
        WRITE(6,FFORMAT)
     &       ' MTD RESTART INFO WRITTEN ON FILE ',FMTDRES(IA:IE)

      ENDIF  ! parent
!     ==--------------------------------------------------------------==
      RETURN
      END
!     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE RMTDRES(NR,CV_DISP,TFULL,NTOT_ITER)
!     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      INTEGER  NR,NTOT_ITER
      REAL*8   CV_DISP(NCOLVAR)
      LOGICAL  TFULL

C     Variables
      INTEGER IA,IE,ICV,IS,IT,NC,NS
      CHARACTER FFORMAT*20
      LOGICAL  FERROR
      DIMENSION     CV_PATH(NTOT_ITER,NCOLVAR),
     &              CSCL_VAL(NTOT_ITER,NCOLVAR),
     &              HLLW_VAL(NTOT_ITER),
     &              HLLH_VAL(NTOT_ITER)

!     ==--------------------------------------------------------------==

C     Construct the filename
      IF(PARENT) THEN
        CALL XSTRING(FMTDRES,IA,IE)
        FERROR=.FALSE.
        CALL FILEOPEN(NR,FMTDRES(IA:IE),FO_OLD+FO_UFO,FERROR)
        IF(FERROR) THEN
          WRITE(FFORMAT,'(A,I2,A)')
     &         '(/,A,T',MAX(36,65-(IE-IA)),',A)'
          WRITE(6,FFORMAT) 
     &         'RMTDRES| MTD RESTART FILE NOT FOUND:',FMTDRES(IA:IE)
          CALL STOPGM('RMTDRES',' FILE NOT FOUND ')
        ENDIF

        REWIND (NR)
        READ (NR) I_META_RES
        READ (NR) NC

        IF(NC .NE. NCOLVAR) THEN
          WRITE(6,'(A,I3,A,I3)') 'RMTDRES! DIFFERENT # of CV ',
     &                           NC,' vs',NCOLVAR
          CALL STOPGM('RMTDRES','USE SAME # of CV')
        ENDIF

        IF(TFULL) THEN

          DO ICV = 1,NCOLVAR
            READ (NR) (CV_PATH(IT,ICV),IT=1,I_META_RES)
            READ (NR) (CSCL_VAL(IT,ICV),IT=1,I_META_RES)
          ENDDO 

          IF(LEXTLAGRANGE) THEN
            READ (NR)(CV_DISP(ICV),ICV=1,NCOLVAR)
            READ (NR)(CV_VEL(ICV),ICV=1,NCOLVAR)
          ENDIF

          READ (NR) (HLLW_VAL(IT),IT=1,I_META_RES)
          READ (NR) (HLLH_VAL(IT),IT=1,I_META_RES)

          WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(34,65-(IE-IA)),',A)'
          WRITE(6,FFORMAT)
     &       ' MTD RESTART INFO READ FROM FILE ',FMTDRES(IA:IE)
        ENDIF
        CALL FILECLOSE(NR)

      ENDIF  ! parent
!     ==--------------------------------------------------------------==
      RETURN
      END
!     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE RMTDRES_MW(NR,CV_DISP,TFULL,NTOT_ITER,IWALK1)
!     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      INTEGER  NR,NTOT_ITER,IWALK1
      REAL*8   CV_DISP(NCOLVAR)
      LOGICAL  TFULL

C     Variables
      INTEGER IA,IE,ICV,IS,IT,NC,NS
      CHARACTER FFORMAT*20
      LOGICAL  FERROR
      DIMENSION     CV_PATH(NTOT_ITER,NCOLVAR),
     &              CSCL_VAL(NTOT_ITER,NCOLVAR),
     &              HLLW_VAL(NTOT_ITER),
     &              HLLH_VAL(NTOT_ITER)

!     ==--------------------------------------------------------------==

C     Construct the filename
      IF(PARENT) THEN
        CALL XSTRING(FMTDRES,IA,IE)
        FERROR=.FALSE.
        CALL FILEOPEN(NR,FMTDRES(IA:IE),FO_OLD+FO_UFO,FERROR)
        IF(FERROR) THEN
          WRITE(FFORMAT,'(A,I2,A)')
     &         '(/,A,T',MAX(36,65-(IE-IA)),',A)'
          WRITE(6,FFORMAT)
     &         'RMTDRES| MTD RESTART FILE NOT FOUND:',FMTDRES(IA:IE)
          CALL STOPGM('RMTDRES',' FILE NOT FOUND ')
        ENDIF

        REWIND (NR)
        READ (NR) I_META_RES
        READ (NR) NC

        IF(NC .NE. NCOLVAR) THEN
          WRITE(6,'(A,I3,A,I3)') 'RMTDRES! DIFFERENT # of CV ',
     &                           NC,' vs',NCOLVAR
          CALL STOPGM('RMTDRES','USE SAME # of CV')
        ENDIF

        IF(TFULL) THEN
          DO ICV = 1,NCOLVAR
CMW         each walker is reading the FULL hills; indivisual HC_LAST can be reconstructed from the diffusion
            READ (NR) (CV_PATH(IT,ICV),IT=1,I_META_RES)
CMW         each walker is reading the FULL scaling factors
            READ (NR) (CSCL_VAL(IT,ICV),IT=1,I_META_RES)
          ENDDO

          IF(LEXTLAGRANGE) THEN
CMW         each walker is reading his own part of the displacement
            READ (NR)(CV_DISP(ICV),ICV=1,NCOLVAR)
CMW         each walker is reading his own velocity part only
            READ (NR)(CV_VEL(ICV+(IWALK1-1)*NCOLVAR),ICV=1,NCOLVAR)
          ENDIF

          READ (NR) (HLLW_VAL(IT),IT=1,I_META_RES)
          READ (NR) (HLLH_VAL(IT),IT=1,I_META_RES)

          WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(34,65-(IE-IA)),',A)'
          WRITE(6,FFORMAT)
     &       ' MTD RESTART INFO READ FROM FILE ',FMTDRES(IA:IE)
        ENDIF
        CALL FILECLOSE(NR)

      ENDIF  ! parent
!     ==--------------------------------------------------------------==
      RETURN
      END
!     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE  CV_READ_OUT(CV_DISP)
!     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      REAL*8   CV_DISP(NCOLVAR)

C     Variables
      INTEGER   IJ, II, ICV 
      LOGICAL   FERROR
      CHARACTER*20  FILE1,FILE2,FILE5,FILE6
      DATA          FILE1,FILE2,FILE5,FILE6
     *     /'colvar_mtd','parvar_mtd','disvar_mtd',
     *      'velvar_mtd' /
      REAL*8 DISPLACEMENT
      DIMENSION     CV_PATH(I_META_MAX+I_META_RES,NCOLVAR),
     &              CSCL_VAL(I_META_RES+I_META_MAX,NCOLVAR),
     &              HLLW_VAL(I_META_RES+I_META_MAX),
     &              HLLH_VAL(I_META_RES+I_META_MAX)

C     ==--------------------------------------------------------------==
      FERROR=.FALSE.
      CALL FILEOPEN(51,FILE1,FO_OLD,FERROR)
      IF(FERROR) GOTO 20
      CALL FILEOPEN(52,FILE2,FO_OLD,FERROR)
      IF(FERROR) GOTO 20
      CALL FILEOPEN(55,FILE5,FO_OLD,FERROR)
      IF(FERROR) GOTO 20
      CALL FILEOPEN(56,FILE6,FO_OLD,FERROR)
      IF(FERROR) GOTO 20
      REWIND (51)
      REWIND (52)
      REWIND (55)
      REWIND (56)
      DO II = 1,I_META_RES
        READ(51,ERR=20,END=20,FMT=*)  IJ, 
     &            (CV_PATH(II,ICV),ICV=1,NCOLVAR),
     &            (CSCL_VAL(II,ICV),ICV=1,NCOLVAR)
C           from output forces and parameters
        READ(52,ERR=20,END=20,FMT=*) IJ, 
     &             DISPLACEMENT,HLLW_VAL(II),HLLH_VAL(II)
        READ(55,ERR=20,END=20,FMT=*) IJ, 
     &             (CV_DISP(ICV),ICV=1,NCOLVAR)
        READ(56,ERR=20,END=20,FMT=*)  IJ, 
     &             (CV_VEL(ICV),ICV=1,NCOLVAR)
      ENDDO
      CALL FILECLOSE(51)
      CALL FILECLOSE(52)
      CALL FILECLOSE(55)
      CALL FILECLOSE(56)

      GOTO 100
 20     CONTINUE
      WRITE(6,*) ' ERROR WHILE READING RESTART DATA '
            CALL STOPGM('META_EXTLAGR',' ')
 100    CONTINUE

      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE MW_FILENAME(FILENAMEIN,FILENAMEOUT,IPL)
C     ==--------------------------------------------------------------==
C     == Some multiple walker metadynamics output files have names    ==
C     == in the format NAME_#id(.EXTENTION)                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
C
      CHARACTER*(*) FILENAMEIN,FILENAMEOUT
      INTEGER IPL
C
      CHARACTER*50 CIPNUM
      INTEGER N1,N2,I1,I2
C     ==--------------------------------------------------------------==
      FILENAMEOUT=' ' 
      WRITE(CIPNUM,'(I4)') IPL
      CALL XSTRING(FILENAMEIN,N1,N2)
      CALL XSTRING(CIPNUM,I1,I2)
      FILENAMEOUT=FILENAMEIN(N1:N2)//CIPNUM(I1:I2)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE MW_ASSIGN_FILENAMES(IPCURR,FILEN,FILENBS)
C     ==--------------------------------------------------------------==
C     == Create filenames: RESTART_#ip.  RESTART_#ip 
C     ==                  ENERGIES_#ip  BS_ENERG_#ip 
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'filn.inc'
      INCLUDE 'mw.inc'
C
      INTEGER IPCURR
      CHARACTER*(*) FILEN,FILENBS
C
      INTEGER N1,N2
C     ==--------------------------------------------------------------==
      IF(.NOT.TMW)RETURN
      CALL MW_FILENAME('ENERGIES_',FILEN,IPCURR)
      CALL MW_FILENAME('BS_ENERG_',FILENBS,IPCURR)
      CALL MW_FILENAME('RESTART_',FILN,IPCURR)
      CALL XSTRING(FILN,N1,N2)
      FILBOD=FILN(N1:N2)//'.'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE MW_INIT
C     ==--------------------------------------------------------------==
C     ==    INITIALIZE MULTIPLE WALKER METADYNAMICS                   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'pimd.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'mw.inc'
      INCLUDE 'cotr.inc'
C     Variables
      REAL*8    RPROC
      INTEGER   IPATH(FO_FPATH_MAX),MSGLEN,I,NLOW,NHIGH,IP
      INTEGER   IPP,LABEL,METMP,COLOR,I1,I2
      CHARACTER FILEOUT*12,FILEON*12
C     ==--------------------------------------------------------------==
      IF(.NOT.TMW)RETURN
#ifndef PARALLEL
      CALL STOPGM('MW_INIT','MULTIPLE WALKER REUQIRES PARALLEL RUN')
#endif
      MSGLEN = 1 * 8
      CALL MY_BCAST(ECUT,MSGLEN,SOURCE,ALLGRP) !TODO is it needed?
C     ==--------------------------------------------------------------==
C  Reassigning PARENTS and SOURCE plus define GRANDPARENT and SUPERSOURCE
      GRANDPARENT=PARENT
      SUPERGROUP=ALLGRP
      SUPERSOURCE=SOURCE
      NPROC_TOT=NPROC 
C     ==--------------------------------------------------------------==
C  Generate processor groups
      CALL IAZZERO(PGROUP,MAXCPU)
      CALL IAZZERO(NLINK,MAXCPU)
C     Always 1 walker per processor groups
      PC_GROUPS=NWALK
C
      RPROC=DBLE(NPROC)/NWALK
      DO I=1,NWALK
        NLOW=NINT((I-1)*RPROC)
        PC_GRP(I)=NLOW
        NHIGH=NINT(I*RPROC)-1
        IF(ME.GE.NLOW .AND. ME.LE.NHIGH) THEN
          NPROC=NHIGH-NLOW+1 !number of processors in a group is redifined on all corresponding processors
          PARENT=NLOW.EQ.ME  !lowest rank of a group is the parent
          SOURCE=0           
          MEPOS=ME-NLOW      !mepos is redifined on all processors of a group
          PCG_POS=I
          WALKER_ID=I
          DO IP=1,NPROC
            PGROUP(IP)=NLOW+IP-1 
            IPP=PGROUP(IP)
            NLINK(IPP)=IP-1
          ENDDO
          LABEL=I
        ENDIF
      ENDDO
      COLOR=ME/NPROC
      CALL MY_SPLIT(SUPERGROUP,COLOR,ME,ALLGRP,METMP)
      IF(MEPOS.NE.METMP) THEN
        CALL STOPGM('MW_INIT','!MY_SPLIT RETURNED ERROR!')
      END IF
      CALL MY_SYNC(SUPERGROUP)
      LABEL=NWALK+1
      CALL MY_GROUP(NWALK,PC_GRP,LABEL,PARENTGROUP,SUPERGROUP)
C     ==--------------------------------------------------------------==
      IF(PARENT.AND..NOT.GRANDPARENT) THEN
        WRITE(FILEON,'(I3)') PCG_POS
        CALL XSTRING(FILEON,I1,I2)
        FILEOUT='OUTPUT_'//FILEON(I1:I2)
        CLOSE(6)
        OPEN(UNIT=6,FILE=FILEOUT)
#if defined(__Linux) || defined (ALPHALINUX)
C     avoid printmemsize messes
          CALL SILENTSTDOUT
#endif
      ENDIF
      IF(GRANDPARENT) THEN
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(1X,A4,A18,A38,A4)') '**  ','WALKERID', 'PROCESSORS', 
     &                                '**'
        WRITE(6,'(1X,64("-"))')
        DO I=1,NWALK
          NLOW=PC_GRP(I)
          IF(I.EQ.NWALK) THEN
            NHIGH=NPROC_TOT-1
          ELSE
            NHIGH=PC_GRP(I+1)-1
          ENDIF
          WRITE(6,'(1X,A4,I18,I17,A,I17,A4)') '**  ',I,
     *                      NLOW,' -> ',NHIGH, '**'
        ENDDO
        WRITE(6,'(1X,64("*"),/)')
      ENDIF
C     ==--------------------------------------------------------------==
C     FIXME: FPATH is distributed at the end of control_bcast.F
C            check whether this is still needed at all. AK 2005/04/04
      IF(PARENT) THEN
        MSGLEN = 2 * 8/IRAT
        CALL MY_BCAST(IAPATH,MSGLEN,SUPERSOURCE,PARENTGROUP)
        CALL IAZZERO(IPATH,FO_FPATH_MAX)
        IF(GRANDPARENT) THEN
          DO I=1,FO_FPATH_MAX
            IPATH(I)=ICHAR(FPATH(I:I))
          ENDDO
        ENDIF
        MSGLEN = FO_FPATH_MAX * 8/IRAT
        CALL MY_BCAST(IPATH,MSGLEN,SUPERSOURCE,PARENTGROUP)
        DO I=1,FO_FPATH_MAX
          FPATH(I:I)=CHAR(IPATH(I))
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     Broadcast constraint and/or restraint stuff if necessary
      IF(PARENT) THEN
        IF(MCNSTR.GT.0) THEN
          IF(.NOT.GRANDPARENT) THEN
            CALL MEMORY(IP_NTCNST,6*MCNSTR/IRAT,'NTCNST')
            CALL MEMORY(IP_CNSVAL,MCNSTR,'CNSVAL')
            CALL MEMORY(IP_CNPAR,2*MCNSTR,'CNPAR')
            CALL MEMORY(IP_GRATE,MCNSTR,'GRATE')
            CALL MEMORY(IP_CNSVAL_DEST,MCNSTR,'CNSVAL_DEST')
          ENDIF
          MSGLEN = 6*MCNSTR * 8/IRAT
          CALL MY_BCAST(NTCNST,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 1*MCNSTR * 8
          CALL MY_BCAST(CNSVAL,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 2*MCNSTR * 8
          CALL MY_BCAST(CNPAR,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 1*MCNSTR * 8
          CALL MY_BCAST(GRATE,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 1*MCNSTR * 8
          CALL MY_BCAST(CNSVAL_DEST,MSGLEN,SUPERSOURCE,PARENTGROUP)
        ENDIF
        IF(MRESTR.GT.0) THEN
          IF(.NOT.GRANDPARENT) THEN
            CALL MEMORY(IP_NTREST,6*MRESTR/IRAT,'NTREST')
            CALL MEMORY(IP_RESVAL,MRESTR,'RESVAL')
            CALL MEMORY(IP_RESFOR,MRESTR,'RESFOR')
            CALL MEMORY(IP_RESPAR,2*MRESTR,'RESPAR')
            CALL MEMORY(IP_GSRATE,MRESTR,'GSRATE')
            CALL MEMORY(IP_RESVAL_DEST,MRESTR,'RESVAL_DEST')
            CALL MEMORY(IP_RESPOS,3*MRESTR,'RESPOS')
          ENDIF
          MSGLEN = 6*MRESTR * 8/IRAT
          CALL MY_BCAST(NTREST,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 1*MRESTR * 8
          CALL MY_BCAST(RESVAL,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 1*MRESTR * 8
          CALL MY_BCAST(RESFOR,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 2*MRESTR * 8
          CALL MY_BCAST(RESPAR,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 1*MRESTR * 8
          CALL MY_BCAST(GSRATE,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 1*MRESTR * 8
          CALL MY_BCAST(RESVAL_DEST,MSGLEN,SUPERSOURCE,PARENTGROUP)
          MSGLEN = 3*MRESTR * 8
          CALL MY_BCAST(RESPOS,MSGLEN,SUPERSOURCE,PARENTGROUP)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
