C     ==================================================================
      SUBROUTINE  HILLS(CVAR,NVAR,I_META,NTOT,FORCE,SCR,LSCR,ISYS,IPOS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE

      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'

C     Arguments
      INTEGER       NVAR,I_META,LSCR,NTOT,ISYS,IPOS
      REAL*8        CVAR(NVAR),FORCE(NVAR),SCR(LSCR)

C     Variable
      DIMENSION     CNST_VAL(NTOT,NCOLVAR),
     &              CV_PATH(NTOT,NCOLVAR),
     &              CSCL_VAL(NTOT,NCOLVAR),
     &              HLLW_VAL(NTOT,NSUBSYS),HLLH_VAL(NTOT,NSUBSYS),
     &              HT_PATH(NTOT,NCOLVAR)
      INTEGER       IC,IT,LENGTH
      REAL*8        DIFFPOS(NVAR),EXPN,STEP_GAUSS
      REAL*8        C_HISTORY(NTOT,NVAR)
      pointer       (IP_DIFFPOS,DIFFPOS),(IP_C_HISTOTY,C_HISTORY)
      CHARACTER     TAG

C     ==--------------------------------------------------------------==

      LENGTH  = NVAR*4
      CALL TEST_SCR('HILLS',TAG,LSCR,LENGTH)
      CALL GET_ADDR(IP_DIFFPOS ,SCR(1))
      IF(LCNSTDYN) THEN
        CALL GET_ADDR(IP_C_HISTOTY,CNST_VAL(1,IPOS+1))
      ELSEIF(LCOLVARDYN)THEN
        CALL GET_ADDR(IP_C_HISTOTY ,CV_PATH(1,IPOS+1))
      ELSEIF(LMETA_CELL) THEN
         CALL GET_ADDR(IP_C_HISTOTY,HT_PATH(1,IPOS+1))
      ENDIF

!$OMP parallel do private(IC)
      DO IC=1,NVAR
        FORCE(IC)=0.D0
        DIFFPOS(IC)=0.0D0
      ENDDO

      GAUSSPOT=0.0D0

      DO IT=1,I_META-1
        EXPN = 0.0D0
        DO IC=1,NVAR
          DIFFPOS(IC) = (CVAR(IC)-C_HISTORY(IT,IC))
          IF (IANGCV(IC).EQ. 1) THEN  
            IF(DIFFPOS(IC) .GT. PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) - 2.0D0*PI
            ELSEIF (DIFFPOS(IC) .LT. -PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) + 2.0D0*PI
            ENDIF
          ENDIF
          DIFFPOS(IC) = DIFFPOS(IC) /CSCL_VAL(IT,IC)
          EXPN = EXPN+DIFFPOS(IC)**2.0D0
        ENDDO
        EXPN = DSQRT(EXPN)
        STEP_GAUSS = HLLH_VAL(IT,ISYS)*
     &                 DEXP(-0.5D0*(EXPN/HLLW_VAL(IT,ISYS))**2.0D0)
        GAUSSPOT = GAUSSPOT + STEP_GAUSS
!$OMP parallel do private(IC)
        DO IC=1,NVAR
          FORCE(IC) = FORCE(IC) + 
     &             (DIFFPOS(IC)/(HLLW_VAL(IT,ISYS))**2.0D0)*STEP_GAUSS
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
 
      SUBROUTINE SETWALL_OLD(CPOS,TYCV,VPARAM,FORCE)

C     VPARAM    : parameters for the definition of the constraining potential
C                 (real, dimension 4)
C                 vbar = VPARAM(1) in a.u.
C                 r_wall or cmin = VPARAM(2)
C                 r_init or ddist or cmax =  VPARAM(3)
C                 deps  =  VPARAM(4)
C                 for DIST or angles  wall V=vbar*(cpos/r_wall)**4
C                                   (for cpos>r_init V becomes active)
C                 for DIFFER  wall V=vbar*((|cpos|-r_wall)/ddist)**4
C                         (for (|cpos|-r_wall)<ddist V becomes active)
C                 for coordination numbers  and RMSD_AB
C                       wall min  : V=vbar(cmin/cpos)**10
C                                   if cmin=0  V=vbar(1-cpos)**10
C                         (for (cpos-deps)<cmin V becomes active)
C                       wall max  : V=vbar(cpos/cmax)**10
C                         (for (cpos+deps)>cmax V becomes active)

      IMPLICIT NONE

      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'

C     Arguments
      REAL*8      CPOS,VPARAM(4),FORCE
      INTEGER     TYCV,i
C     Variable   
      REAL*8      vbar,r_wall,r_init,factor,cc
      REAL*8      ddist,delta,cmin,cmax
      REAL*8      num,den,deps
C     ==--------------------------------------------------------------==

      IF(TYCV .EQ. 7) THEN
        vbar  = VPARAM(1)
        r_wall   = VPARAM(2)
        ddist    = VPARAM(3)
        delta     = DABS(CPOS)
        factor = vbar*4.D0/(r_wall)**4.0D0
        FORCE = 0.0D0
        IF(CPOS .GT. ddist) THEN
          FORCE = -factor*delta*delta*delta
        ELSEIF(CPOS .LT. -ddist) THEN
          FORCE =  factor*delta*delta*delta
        ENDIF
      ELSEIF((TYCV.GE.8 .AND. TYCV.LE.12) .OR. 
     &        TYCV.EQ.17 .OR. TYCV.EQ.18) THEN
        vbar= VPARAM(1)
        cmin    = VPARAM(2)
        cmax    = VPARAM(3)
        DEPS    = VPARAM(4)
        cc      = CPOS
        FORCE = 0.0D0
        IF(cmin .EQ. 0.0D0 .AND. cc-DEPS .LT. 0.0D0) THEN
           NUM = (1-cc)*(1-cc)*(1-cc)*(1-cc)*(1-cc)*(1-cc)*
     &           (1-cc)*(1-cc)*(1-cc)
           FORCE = vbar*10.D0*NUM
        ELSEIF(cmin .GT. 0.0D0 .AND. cc-DEPS .LT. cmin) THEN
c          FORCE = vbar*6.D0*(1.D0-cc)**5.D0/(1.D0-cmin)**6.D0
          NUM = cmin*cmin*cmin*cmin*cmin*cmin*cmin*cmin*cmin*cmin
          DEN =  cc*cc*cc*cc*cc*cc*cc*cc*cc*cc*cc
          FORCE = vbar*10.D0*NUM/DEN
        ELSEIF(cmin .LT. 0.0D0 .AND. cc-DEPS .LT. cmin) THEN
          DEN = cmin*cmin*cmin*cmin*cmin*cmin*cmin*cmin*cmin*cmin
          NUM =  cc*cc*cc*cc*cc*cc*cc*cc*cc
          FORCE = -vbar*10.D0*NUM/DEN
        ELSEIF(cmax .GT. 0.0D0 .AND. cc+DEPS .GT. cmax) THEN
          DEN = cmax*cmax*cmax*cmax*cmax*cmax*cmax*cmax*cmax
          NUM =  cc*cc*cc*cc*cc*cc*cc*cc*cc
          FORCE = -vbar*10.D0*NUM/DEN
        ENDIF
      ELSE
        vbar = VPARAM(1)
        r_wall   = VPARAM(2)
        r_init   = VPARAM(3)
        factor = vbar*4.D0/(r_wall)**4.0D0
        FORCE = 0.0D0
        cc    = DABS(CPOS)
        IF(cc .gt. r_init) then
          FORCE = - factor*cc*cc*cc
        ENDIF
      ENDIF

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================

      SUBROUTINE SETWALL(CPOS,VBOUND,FORCE)
      IMPLICIT NONE
      REAL*8      CPOS,VBOUND(4),FORCE
!
      REAL*8      vbarrier,cc,cpos_0

      FORCE = 0.0D0
      cpos_0   = VBOUND(1)
      vbarrier = VBOUND(2)
      if(vbarrier.gt.0.d0)then
        cc=cpos-cpos_0
        IF(cc.gt.0.D0)THEN
          FORCE = - vbarrier
        ENDIF
      endif
      cpos_0   = VBOUND(3)
      vbarrier = VBOUND(4)
      if(vbarrier.gt.0.d0)then
        cc=cpos-cpos_0
        IF(cc.lt.0.D0)THEN
          FORCE =   vbarrier
        ENDIF
      endif

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


      SUBROUTINE  HILLS_LOR(CVAR,NVAR,I_META,NTOT,FORCE,
     &                      SCR,LSCR,ISYS,IPOS)

      IMPLICIT NONE

      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'

C     Arguments
      INTEGER       NVAR,I_META,LSCR,NTOT,ISYS,IPOS
      REAL*8        CVAR(NVAR),FORCE(NVAR),SCR(LSCR)

C     Variable
      DIMENSION     CNST_VAL(NTOT,NCOLVAR),
     &              CV_PATH(NTOT,NCOLVAR),
     &              CSCL_VAL(NTOT,NCOLVAR),
     &              HLLW_VAL(NTOT,NSUBSYS),HLLH_VAL(NTOT,NSUBSYS),
     &              HT_PATH(NTOT,NCOLVAR)
      INTEGER       IC,IT,LENGTH
      REAL*8        DIFFPOS(NVAR),EXPN,STEP_GAUSS
      REAL*8        C_HISTORY(NTOT,NVAR)
      REAL*8        HW,DENOM
      pointer       (IP_DIFFPOS,DIFFPOS),(IP_C_HISTOTY,C_HISTORY)
      CHARACTER     TAG
C     ==--------------------------------------------------------------==

      LENGTH  = NVAR*4
      CALL TEST_SCR('HILLS_LOR',TAG,LSCR,LENGTH)
      CALL GET_ADDR( IP_DIFFPOS,SCR(1))
      IF(LCNSTDYN) THEN
        CALL GET_ADDR(IP_C_HISTOTY,CNST_VAL(1,IPOS+1))
      ELSEIF(LCOLVARDYN)THEN
        CALL GET_ADDR(IP_C_HISTOTY,CV_PATH(1,IPOS+1))
      ELSEIF(LMETA_CELL) THEN
         CALL GET_ADDR(IP_C_HISTOTY,HT_PATH(1,IPOS+1))
      ENDIF

!$OMP parallel do private(IC)
      DO IC=1,NVAR
        FORCE(IC)=0.D0
        DIFFPOS(IC)=0.0D0
      ENDDO

      DO IT=1,I_META-1
        EXPN = 0.0D0
        HW   =   HLLW_VAL(IT,ISYS) * DSQRT(3.0D0)
        DO IC=1,NVAR
          DIFFPOS(IC) = (CVAR(IC)-C_HISTORY(IT,IC))
          IF (IANGCV(IC).EQ. 1) THEN  
            IF(DIFFPOS(IC) .GT. PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) - 2.0D0*PI
            ELSEIF (DIFFPOS(IC) .LT. -PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) + 2.0D0*PI
            ENDIF
          ENDIF
          DIFFPOS(IC) = DIFFPOS(IC) /CSCL_VAL(IT,IC)
          EXPN = EXPN+DIFFPOS(IC)**2.0D0
        ENDDO
        EXPN       = DSQRT(EXPN)
        DENOM      = (EXPN/HW)**2.0D0+1.0D0
        STEP_GAUSS = HLLH_VAL(IT,ISYS)/DENOM

!$OMP parallel do private(IC)
        DO IC=1,NVAR
          FORCE(IC) = FORCE(IC) + 2.0D0*
     &          (DIFFPOS(IC)/(HW)**2.0D0)*STEP_GAUSS/DENOM
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE  HILLS_SALS(CVNOW,NVAR,I_META,NTOT,FORCE,CV_LAST,
     &                  SCR,LSCR,I_CVST,ISYS,IPOS)

      IMPLICIT NONE

      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'

C     Arguments
      INTEGER       NVAR,I_META,LSCR,NTOT,I_CVST,ISYS,IPOS
      REAL*8        CVNOW(NVAR),FORCE(NVAR),CV_LAST(NVAR),SCR(LSCR)
C     Variables
      DIMENSION     CNST_VAL(NTOT,NCOLVAR),
     &              CV_PATH(NTOT,NCOLVAR),
     &              CSCL_VAL(NTOT,NCOLVAR),
     &              HLLW_VAL(NTOT,NSUBSYS),HLLH_VAL(NTOT,NSUBSYS),
     &              HT_PATH(NTOT,NCOLVAR)
      INTEGER       IC,IT,LENGTH
      REAL*8        DIFFPOS(NVAR),EXPN,STEP_GAUSS
      REAL*8        C_HISTORY(NTOT,NVAR),DELTACV(NVAR)
      REAL*8        EXPN2,SIGMA2,FACT,HW2
      pointer       (IP_DIFFPOS,DIFFPOS),(IP_C_HISTOTY,C_HISTORY),
     &              (IP_DELTACV,DELTACV)
      CHARACTER     TAG
C     ==--------------------------------------------------------------==
      FACT = 1.0D0
      LENGTH  = NVAR*5
      CALL TEST_SCR('HILLS',TAG,LSCR,LENGTH)
      CALL GET_ADDR(IP_DIFFPOS,SCR(1))
      CALL GET_ADDR(IP_DELTACV,SCR(1+NVAR))
      IF(LCNSTDYN) THEN
        CALL GET_ADDR(IP_C_HISTOTY,CNST_VAL(1,IPOS+1))
      ELSEIF(LCOLVARDYN)THEN
        CALL GET_ADDR(IP_C_HISTOTY,CV_PATH(1,IPOS+1))
      ELSEIF(LMETA_CELL) THEN
         CALL GET_ADDR(IP_C_HISTOTY,HT_PATH(1,IPOS+1))
      ENDIF

!$OMP parallel do private(IC)
      DO IC=1,NVAR
        FORCE(IC)=0.D0
        DIFFPOS(IC)=0.0D0
        DELTACV(IC)=0.0D0
      ENDDO

      GAUSSPOT=0.0D0

      DO IT=1,I_META-2
        EXPN   = 0.0D0
        EXPN2  = 0.0D0
        SIGMA2 = 0.0D0
        DO IC=1,NVAR
          DIFFPOS(IC) = (CVNOW(IC)-C_HISTORY(IT,IC))
          DELTACV(IC) = (C_HISTORY(IT+1,IC)-C_HISTORY(IT,IC))
          IF (IANGCV(IC).EQ. 1) THEN  
            IF(DIFFPOS(IC) .GT. PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) - 2.0D0*PI
            ELSEIF (DIFFPOS(IC) .LT. -PI) THEN
             DIFFPOS(IC) = DIFFPOS(IC) + 2.0D0*PI
            ENDIF
            IF(DELTACV(IC) .GT. PI) THEN
              DELTACV(IC) = DELTACV(IC) - 2.0D0*PI
            ELSEIF (DELTACV(IC) .LT. -PI) THEN
              DELTACV(IC) = DELTACV(IC) + 2.0D0*PI
            ENDIF
          ENDIF
          DIFFPOS(IC) = DIFFPOS(IC)/CSCL_VAL(IT,IC)
          DELTACV(IC) = DELTACV(IC)/CSCL_VAL(IT,IC)

          EXPN   = EXPN   + DIFFPOS(IC)**2.0D0
          EXPN2  = EXPN2  + DIFFPOS(IC)*DELTACV(IC)
          SIGMA2 = SIGMA2 + DELTACV(IC)*DELTACV(IC)
        ENDDO
!        EXPN = DSQRT(EXPN)
        HW2 = HLLW_VAL(IT,ISYS)**2.0D0
        IF(SIGMA2 .GT. HW2) SIGMA2=HW2
        SIGMA2 = SIGMA2*SIGMA2
        IF(SIGMA2 .LT. 1.D-6)  SIGMA2 = 1.D-6
        STEP_GAUSS = HLLH_VAL(IT,ISYS)*
     &                 DEXP(-0.5D0*(EXPN/HW2))*
     &                 DEXP(-0.5D0*(EXPN2*EXPN2/SIGMA2))
!$OMP parallel do private(IC)
        DO IC=1,NVAR
          FORCE(IC) = FORCE(IC) + 
     &          (DIFFPOS(IC)/(HLLW_VAL(IT,ISYS))**2.0D0)*STEP_GAUSS+
     &            (EXPN2*DELTACV(IC)/SIGMA2)*STEP_GAUSS
        ENDDO
        GAUSSPOT = GAUSSPOT+STEP_GAUSS
      ENDDO

      IF(I_META .GT. 1) THEN
        EXPN   = 0.0D0
        EXPN2  = 0.0D0
        SIGMA2 = 0.0D0
        DO IC=1,NVAR
          DIFFPOS(IC) = (CVNOW(IC)-C_HISTORY(I_META-1,IC))
          DELTACV(IC) = (CV_LAST(IC)-C_HISTORY(I_META-1,IC))
          IF (IANGCV(IC).EQ. 1) THEN  
            IF(DIFFPOS(IC) .GT. PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) - 2.0D0*PI
            ELSEIF (DIFFPOS(IC) .LT. -PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) + 2.0D0*PI
            ENDIF
            IF(DELTACV(IC) .GT. PI) THEN
              DELTACV(IC) = DELTACV(IC) - 2.0D0*PI
            ELSEIF (DELTACV(IC) .LT. -PI) THEN
              DELTACV(IC) = DELTACV(IC) + 2.0D0*PI
            ENDIF
          ENDIF
          DIFFPOS(IC) = DIFFPOS(IC)/CSCL_VAL(I_META-1,IC)
          DELTACV(IC) = DELTACV(IC)/CSCL_VAL(I_META-1,IC)

          EXPN   = EXPN   + DIFFPOS(IC)**2.0D0
          EXPN2  = EXPN2  + DIFFPOS(IC)*DELTACV(IC)
          SIGMA2 = SIGMA2 + DELTACV(IC)*DELTACV(IC)
        ENDDO
!        EXPN = DSQRT(EXPN)
        HW2 = HLLW_VAL(I_META-1,ISYS)**2.0D0
        IF(SIGMA2 .GT. HW2) SIGMA2=HW2
        IF(SIGMA2 .LT. 1.D-6)  SIGMA2 = 1.D-6
        SIGMA2 = SIGMA2*SIGMA2
        STEP_GAUSS =FACT*HLLH_VAL(I_META-1,ISYS)*
     &            DEXP(-0.5D0*(EXPN/HW2))*
     &            DEXP(-0.5D0*(EXPN2*EXPN2/SIGMA2))
!$OMP parallel do private(IC)
        DO IC=1,NVAR
          FORCE(IC) = FORCE(IC) + 
     &       (DIFFPOS(IC)/(HLLW_VAL(I_META-1,ISYS))**2.0D0)*STEP_GAUSS+
     &        (EXPN2*DELTACV(IC)/SIGMA2)*STEP_GAUSS
        ENDDO
        GAUSSPOT = GAUSSPOT+STEP_GAUSS
      ENDIF

C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
C     ==================================================================
      SUBROUTINE  HILLS_RATIO(CVNOW,NVAR,I_META,NTOT,FORCE,CV_LAST,
     &                  SCR,LSCR,I_CVST,ISYS,IPOS)

      IMPLICIT NONE

      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'

C     Arguments
      INTEGER       NVAR,I_META,LSCR,NTOT,I_CVST,ISYS,IPOS
      REAL*8        CVNOW(NVAR),FORCE(NVAR),CV_LAST(NVAR),SCR(LSCR)
C     Variables
      DIMENSION     CNST_VAL(NTOT,NCOLVAR),
     &              CV_PATH(NTOT,NCOLVAR),
     &              CSCL_VAL(NTOT,NCOLVAR),
     &              HLLW_VAL(NTOT,NSUBSYS),HLLH_VAL(NTOT,NSUBSYS),
     &              HT_PATH(NTOT,NCOLVAR)
      INTEGER       IC,IT,LENGTH
      REAL*8        DIFFPOS(NVAR),EXPN,STEP_GAUSS
      REAL*8        C_HISTORY(NTOT,NVAR),DELTACV(NVAR)
      REAL*8        CC(NVAR),FCC(NVAR),CCSC(NVAR),HH,HW,DSTEP
      REAL*8        EXPN2,SIGMA2,FACT,LARGER,HW2
      REAL*8        ARG1,ARG2,SCALE_EXP,NUM,DEN,POW1,POW2
      pointer       (IP_DIFFPOS,DIFFPOS),(IP_C_HISTOTY,C_HISTORY),
     &              (IP_CC,CC),(IP_FCC,FCC),(IP_CCSC,CCSC),
     &              (IP_DELTACV,DELTACV)
      CHARACTER     TAG
C     ==--------------------------------------------------------------==
      FACT = 1.0D0
      LARGER = FBOOST*FBOOST
      LENGTH  = NVAR*5
      POW1 = EXPUP
      POW2 = EXPDOWN

      CALL TEST_SCR('HILLS',TAG,LSCR,LENGTH)
       CALL GET_ADDR(IP_DIFFPOS,SCR(1))
       CALL GET_ADDR(IP_DELTACV,SCR(1+NVAR))
       IF(LCNSTDYN) THEN
         CALL GET_ADDR(IP_C_HISTOTY,CNST_VAL(1,IPOS+1))
       ELSEIF(LCOLVARDYN )THEN
         CALL GET_ADDR(IP_C_HISTOTY,CV_PATH(1,IPOS+1))
       ELSEIF(LMETA_CELL) THEN
         CALL GET_ADDR(IP_C_HISTOTY,HT_PATH(1,IPOS+1))
      ENDIF

!$OMP parallel do private(IC)
      DO IC=1,NVAR
        FORCE(IC)=0.D0
        DIFFPOS(IC)=0.0D0
        DELTACV(IC)=0.0D0
      ENDDO

      GAUSSPOT=0.0D0

      DO IT=1,I_META-2
        EXPN   = 0.0D0
        EXPN2  = 0.0D0
        SIGMA2 = 0.0D0
        DO IC=1,NVAR
          DIFFPOS(IC) = (CVNOW(IC)-C_HISTORY(IT,IC))
          DELTACV(IC) = (C_HISTORY(IT+1,IC)-C_HISTORY(IT,IC))
          IF (IANGCV(IC).EQ. 1) THEN  
            IF(DIFFPOS(IC) .GT. PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) - 2.0D0*PI
            ELSEIF (DIFFPOS(IC) .LT. -PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) + 2.0D0*PI
            ENDIF
            IF(DELTACV(IC) .GT. PI) THEN
              DELTACV(IC) = DELTACV(IC) - 2.0D0*PI
            ELSEIF (DELTACV(IC) .LT. -PI) THEN
              DELTACV(IC) = DELTACV(IC) + 2.0D0*PI
            ENDIF
          ENDIF
          DIFFPOS(IC) = DIFFPOS(IC)/CSCL_VAL(IT,IC)
          DELTACV(IC) = DELTACV(IC)/CSCL_VAL(IT,IC)

          EXPN   = EXPN   + DIFFPOS(IC)**2.0D0
          EXPN2  = EXPN2  + DIFFPOS(IC)*DELTACV(IC)
          SIGMA2 = SIGMA2 + DELTACV(IC)*DELTACV(IC)
        ENDDO
        EXPN = DSQRT(EXPN)
        HW2=HLLW_VAL(IT,ISYS)**2.0D0
        IF(SIGMA2 .GT. HW2) SIGMA2=HW2
        IF(SIGMA2 .LT. 1.D-6)  SIGMA2 = 1.D-6
        SIGMA2 = 1.0D0/(SIGMA2*SIGMA2*LARGER)
        ARG1 = (EXPN/HLLW_VAL(IT,ISYS))**pow1
        ARG2 = (EXPN/HLLW_VAL(IT,ISYS))**pow2
        NUM  = 1.0D0 - ARG1
        DEN  = 1.0D0 - ARG2
        IF(DEN .EQ. 0.0D0) GOTO 11
        DEN  = 1.0D0/DEN
        SCALE_EXP = DEXP(-0.5D0*(EXPN2*EXPN2*SIGMA2))
        STEP_GAUSS = HLLH_VAL(IT,ISYS)*NUM*SCALE_EXP*DEN
!$OMP parallel do private(IC)
        DO IC=1,NVAR
          FORCE(IC) = FORCE(IC) + HLLH_VAL(IT,ISYS) * SCALE_EXP*DEN*
     &      ((POW1*ARG1 - NUM*POW2*ARG2*DEN)*DIFFPOS(IC)/(EXPN**2.0D0)+
     &        NUM*EXPN2*DELTACV(IC)*SIGMA2)
        ENDDO
        GAUSSPOT = GAUSSPOT+STEP_GAUSS
 11     CONTINUE
      ENDDO
      IF(I_CVST .LE. INTER_HILL ) 
     &        FACT = DBLE(I_CVST+1)/DBLE(INTER_HILL)
      IF(I_META .GT. 1) THEN
        EXPN   = 0.0D0
        EXPN2  = 0.0D0
        SIGMA2 = 0.0D0
        DO IC=1,NVAR
          DIFFPOS(IC) = (CVNOW(IC)-C_HISTORY(I_META-1,IC))
          DELTACV(IC) = (CV_LAST(IC)-C_HISTORY(I_META-1,IC))
          IF (IANGCV(IC).EQ. 1) THEN  
            IF(DIFFPOS(IC) .GT. PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) - 2.0D0*PI
            ELSEIF (DIFFPOS(IC) .LT. -PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) + 2.0D0*PI
            ENDIF
            IF(DELTACV(IC) .GT. PI) THEN
              DELTACV(IC) = DELTACV(IC) - 2.0D0*PI
            ELSEIF (DELTACV(IC) .LT. -PI) THEN
              DELTACV(IC) = DELTACV(IC) + 2.0D0*PI
            ENDIF
          ENDIF
          DIFFPOS(IC) = DIFFPOS(IC)/CSCL_VAL(I_META-1,IC)
          DELTACV(IC) = DELTACV(IC)/CSCL_VAL(I_META-1,IC)

          EXPN   = EXPN   + DIFFPOS(IC)**2.0D0
          EXPN2  = EXPN2  + DIFFPOS(IC)*DELTACV(IC)
          SIGMA2 = SIGMA2 + DELTACV(IC)*DELTACV(IC)
        ENDDO
        EXPN = DSQRT(EXPN)
        HW2=HLLW_VAL(I_META-1,ISYS)**2.0D0
        IF(SIGMA2 .GT. HW2) SIGMA2=HW2
        IF(SIGMA2 .LT. 1.D-6)  SIGMA2 = 1.D-6
        SIGMA2 = 1.0D0/(SIGMA2*SIGMA2*LARGER)
        ARG1 = (EXPN/HLLW_VAL(I_META-1,ISYS))**pow1
        ARG2 = (EXPN/HLLW_VAL(I_META-1,ISYS))**pow2
        NUM  = 1.0D0 - ARG1
        DEN  = 1.0D0 - ARG2
        IF(DEN .EQ. 0.0D0) GOTO 12
        DEN  = 1.0D0/DEN
        SCALE_EXP = DEXP(-0.5D0*(EXPN2*EXPN2*SIGMA2))
        STEP_GAUSS = FACT*HLLH_VAL(I_META-1,ISYS)*NUM*SCALE_EXP*DEN
!$OMP parallel do private(IC)
        DO IC=1,NVAR
          FORCE(IC) = FORCE(IC) + FACT*HLLH_VAL(I_META-1,ISYS) 
     &            * SCALE_EXP * DEN * ((POW1*ARG1 
     &            - NUM*POW2*ARG2*DEN)*DIFFPOS(IC)/(EXPN**2.0D0)
     &            + NUM*EXPN2*DELTACV(IC)*SIGMA2)
        ENDDO
        GAUSSPOT = GAUSSPOT+STEP_GAUSS
 12     CONTINUE
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE  HILLS_SALS_SHIFT(CVNOW,NVAR,I_META,NTOT,FORCE,CV_LAST,
     &                  SCR,LSCR,I_CVST,ISYS,IPOS)

      IMPLICIT NONE

      INCLUDE  'system.h'
      INCLUDE  'cnst_dyn.inc'
      INCLUDE  'cnst.inc'

C     Arguments
      INTEGER       NVAR,I_META,LSCR,NTOT,I_CVST,ISYS,IPOS
      REAL*8        CVNOW(NVAR),FORCE(NVAR),CV_LAST(NVAR),SCR(LSCR)

C     Variables
      DIMENSION     CNST_VAL(NTOT,NCOLVAR),
     &              CV_PATH(NTOT,NCOLVAR),
     &              CSCL_VAL(NTOT,NCOLVAR),
     &              HLLW_VAL(NTOT,NSUBSYS),HLLH_VAL(NTOT,NSUBSYS),
     &              HT_PATH(NTOT,NCOLVAR)
      INTEGER       IC,IT,LENGTH
      REAL*8        DIFFPOS(NVAR),EXPN,STEP_GAUSS
      REAL*8        STEP1,STEP2,STEP3
      REAL*8        C_HISTORY(NTOT,NVAR),DELTACV(NVAR)
      REAL*8        RCUT,FSIG
      REAL*8        EXPN2,SIGMA2,FACT,HW2

      pointer       (IP_DIFFPOS,DIFFPOS),(IP_C_HISTOTY,C_HISTORY),
     &              (IP_DELTACV,DELTACV)
      CHARACTER     TAG
C     ==--------------------------------------------------------------==
      FACT = 1.0D0
      RCUT = RSHIFT
      FSIG = FBOOST
      LENGTH  = NVAR*5
      CALL TEST_SCR('HILLS',TAG,LSCR,LENGTH)
      CALL GET_ADDR(IP_DIFFPOS,SCR(1))
      CALL GET_ADDR(IP_DELTACV,SCR(1+NVAR))
      IF(LCNSTDYN) THEN
        CALL GET_ADDR(IP_C_HISTOTY,CNST_VAL(1,IPOS+1))
      ELSEIF(LCOLVARDYN)THEN
        CALL GET_ADDR(IP_C_HISTOTY,CV_PATH(1,IPOS+1))
      ELSEIF(LMETA_CELL) THEN
         CALL GET_ADDR(IP_C_HISTOTY,HT_PATH(1,IPOS+1))
      ENDIF

!$OMP parallel do private(IC)
      DO IC=1,NVAR
        FORCE(IC)=0.D0
        DIFFPOS(IC)=0.0D0
        DELTACV(IC)=0.0D0
      ENDDO

      GAUSSPOT=0.0D0

      DO IT=1,I_META-2
        EXPN   = 0.0D0
        EXPN2  = 0.0D0
        SIGMA2 = 0.0D0
        DO IC=1,NVAR
          DIFFPOS(IC) = (CVNOW(IC)-C_HISTORY(IT,IC))
          DELTACV(IC) = (C_HISTORY(IT+1,IC)-C_HISTORY(IT,IC))
          IF (IANGCV(IC).EQ. 1) THEN  
            IF(DIFFPOS(IC) .GT. PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) - 2.0D0*PI
            ELSEIF (DIFFPOS(IC) .LT. -PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) + 2.0D0*PI
            ENDIF
            IF(DELTACV(IC) .GT. PI) THEN
              DELTACV(IC) = DELTACV(IC) - 2.0D0*PI
            ELSEIF (DELTACV(IC) .LT. -PI) THEN
              DELTACV(IC) = DELTACV(IC) + 2.0D0*PI
            ENDIF
          ENDIF
          DIFFPOS(IC) = DIFFPOS(IC)/CSCL_VAL(IT,IC)
          DELTACV(IC) = DELTACV(IC)/CSCL_VAL(IT,IC)

          EXPN   = EXPN   + DIFFPOS(IC)**2.0D0
          EXPN2  = EXPN2  + DIFFPOS(IC)*DELTACV(IC)
          SIGMA2 = SIGMA2 + DELTACV(IC)*DELTACV(IC)
        ENDDO
        EXPN = DSQRT(EXPN)
        HW2 = HLLW_VAL(IT,ISYS)**2.0D0
        IF(SIGMA2 .GT. HW2) SIGMA2 = HW2
        SIGMA2 = SIGMA2*SIGMA2*FSIG*FSIG
        IF(SIGMA2 .LT. 1.D-6)  SIGMA2 = 1.D-6

        IF(EXPN .LE. RCUT*HLLW_VAL(IT,ISYS)) THEN
          STEP1 = DEXP(-0.5D0*(EXPN*EXPN/HW2))
          STEP2 = DEXP(-0.5D0*(RCUT)**2.0D0)
          STEP3 = DEXP(-0.5D0*(EXPN2*EXPN2/SIGMA2))
          STEP_GAUSS = HLLH_VAL(IT,ISYS)*(
     &                (STEP1 - STEP2) * STEP3)
        ELSE
          STEP1 = 0.0D0
          STEP2 = 0.0D0
          STEP3 = 0.0D0
          STEP_GAUSS = 0.0D0
        ENDIF

!$OMP parallel do private(IC)
        DO IC=1,NVAR

          FORCE(IC) = FORCE(IC) +  HLLH_VAL(IT,ISYS)*
     &            (STEP1*STEP3*DIFFPOS(IC)/(HLLW_VAL(IT,ISYS))**2.0D0
     &           +(STEP1-STEP2)*STEP3*EXPN2*DELTACV(IC)/SIGMA2)
        ENDDO
        GAUSSPOT = GAUSSPOT+STEP_GAUSS
      ENDDO

      IF(I_CVST .LE. INTER_HILL ) 
     &        FACT = DBLE(I_CVST+1)/DBLE(INTER_HILL)

      IF(I_META .GT. 1) THEN
        EXPN   = 0.0D0
        EXPN2  = 0.0D0
        SIGMA2 = 0.0D0
        DO IC=1,NVAR
          DIFFPOS(IC) = (CVNOW(IC)-C_HISTORY(I_META-1,IC))
          DELTACV(IC) = (CV_LAST(IC)-C_HISTORY(I_META-1,IC))
          IF (IANGCV(IC).EQ. 1) THEN  
            IF(DIFFPOS(IC) .GT. PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) - 2.0D0*PI
            ELSEIF (DIFFPOS(IC) .LT. -PI) THEN
              DIFFPOS(IC) = DIFFPOS(IC) + 2.0D0*PI
            ENDIF
            IF(DELTACV(IC) .GT. PI) THEN
              DELTACV(IC) = DELTACV(IC) - 2.0D0*PI
            ELSEIF (DELTACV(IC) .LT. -PI) THEN
              DELTACV(IC) = DELTACV(IC) + 2.0D0*PI
            ENDIF
          ENDIF
          DIFFPOS(IC) = DIFFPOS(IC)/CSCL_VAL(I_META-1,IC)
          DELTACV(IC) = DELTACV(IC)/CSCL_VAL(I_META-1,IC)

          EXPN   = EXPN   + DIFFPOS(IC)**2.0D0
          EXPN2  = EXPN2  + DIFFPOS(IC)*DELTACV(IC)
          SIGMA2 = SIGMA2 + DELTACV(IC)*DELTACV(IC)
        ENDDO
        EXPN = DSQRT(EXPN)
        HW2 = HLLW_VAL(I_META-1,ISYS)**2.0D0
        IF(SIGMA2 .GT. HW2) SIGMA2 = HW2
        IF(SIGMA2 .LT. 1.D-6)  SIGMA2 = 1.D-6
        SIGMA2 = SIGMA2*SIGMA2*FSIG*FSIG

        IF(EXPN .LE. RCUT*HLLW_VAL(I_META-1,ISYS)) THEN
          STEP1 = DEXP(-0.5D0*(EXPN*EXPN/HW2))
          STEP2 = DEXP(-0.5D0*(RCUT)**2.0D0)
          STEP3 = DEXP(-0.5D0*(EXPN2*EXPN2/SIGMA2))
          STEP_GAUSS =FACT*HLLH_VAL(I_META-1,ISYS)*(
     &                (STEP1 - STEP2) * STEP3)
        ELSE
          STEP1 = 0.0D0
          STEP2 = 0.0D0
          STEP3 = 0.0D0
          STEP_GAUSS = 0.0D0
        ENDIF
!$OMP parallel do private(IC)
        DO IC=1,NVAR
          FORCE(IC) = FORCE(IC) +  FACT*HLLH_VAL(I_META-1,ISYS)*
     &            (STEP1*STEP3*DIFFPOS(IC)/
     &            (HLLW_VAL(I_META-1,ISYS))**2.0D0
     &           +(STEP1-STEP2)*STEP3*EXPN2*DELTACV(IC)/SIGMA2)
        ENDDO
        GAUSSPOT = GAUSSPOT+STEP_GAUSS
      ENDIF

C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
