C     ==================================================================
      SUBROUTINE LOCALIZESPIN(RHOE,V)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE

      INCLUDE 'system.h'
      INCLUDE 'gvec.inc'
      INCLUDE 'cell.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'ions.inc'

!..Arguments
      COMPLEX*16 V(MAXFFT,NLSD)
      REAL*8   RHOE(kr1,kr2s,kr3s,NLSD)

!..local variables and arrays
      INTEGER i,j,k,ir,nsri,nsrj,i3,icv
      REAL*8 omegan,dh,rhos,x1,x2,x3,ak,arw1,arw2,arw3
     .      ,drc(3),cc1(3),cc2(3),cc3(3),theta(3)
     .      ,ah(3,3),ahi(3,3),vvt,num(3),den(3),ss(3)
      COMPLEX*16 ci,zeta(3)
      REAL*8 vs,pi,pi2,oneby2pi,omenorm,tgbx,tgby,tgbz
      REAL*8 ZETARE(3),ZETAIM(3),DIST,DIST0,DIST1
      REAL*8 cubecenter(3),lowerleft(3)
      INTEGER nnat,ISP,IAT,irnew
      REAL*8 dnat,xx,yy,zz,DX,DY,DZ

      INTEGER IT
      DATA IT /0/
      SAVE IT

#ifdef __VECTOR
      INTEGER ijk,nr1ve,nr2ve,nr3ve
C     ==--------------------------------------------------------------==
      nr1ve=NR3
      nr2ve=nr1ve*NR2
      nr3ve=nr2ve*NR1
#endif

C     ==--------------------------------------------------------------==

      it=it+1

!..set up the constants
      pi=4.d0*DATAN(1.d0)
      pi2=2.0D0*pi
      oneby2pi=1.d0/pi2 ! 1/(2 pi)
      ci=(0.d0,1.d0)

!      if(it.eq.1)RETURN
      IF(.not. TLOCALIZESPIN .or. .not. TLSD) THEN
        RETURN
      ENDIF

!..construction of a(i) lattice vector and h(i,j) matrix
      IF(TPRCP.OR.TPRES) THEN ! variable cell case (OMEGA <> OMEGAN)
!.. are you sure about this?
        CALL LATGEN(IBRAV,CELLRF,cc1,cc2,cc3,OMEGAN)
      ELSE                    ! fixed cell case
        CALL LATGEN(IBRAV,CELLDM,cc1,cc2,cc3,OMEGA)
      ENDIF
      ah(1,1)=cc1(1)
      ah(2,1)=cc1(2)
      ah(3,1)=cc1(3)
      ah(1,2)=cc2(1)
      ah(2,2)=cc2(2)
      ah(3,2)=cc2(3)
      ah(1,3)=cc3(1)
      ah(2,3)=cc3(2)
      ah(3,3)=cc3(3)

      CALL MATINV3(ah,ahi,dh)
! Compute z(k)
      omenorm=OMEGA/DBLE(nr1s*nr2s*nr3s)
      nsri=NR1
      nsrj=NR2*nsri

      DO ir=1,3 ! zeroing
        zeta(ir)=(0.D0,0.D0) ! cmb - bugfix
        cubecenter(ir)=0.0D0
      ENDDO

!  Geometric Center of atomic coordinates
      do isp=1,nsp
        do iat=1,na(isp)
          cubecenter(1) = cubecenter(1) + tau0(1,iat,isp)
          cubecenter(2) = cubecenter(2) + tau0(2,iat,isp)
          cubecenter(3) = cubecenter(3) + tau0(3,iat,isp)
          nnat = nnat + 1
        enddo
      enddo
      dnat=1.d0/DBLE(nnat)
      cubecenter(1) =  dnat*cubecenter(1)
      cubecenter(2) =  dnat*cubecenter(2)
      cubecenter(3) =  dnat*cubecenter(3)

!     write(6,'(A,3f12.6)') 'center', cubecenter
!     Lower Left corner of the grid centered on the molecule
      do ir=1,3
         lowerleft(ir) = cubecenter(ir)
     &        - 0.5d0*(cc1(ir)+cc2(ir)+cc3(ir))
      enddo
!      write(6,'(A,3f12.6)') 'lowerleft',lowerleft

#ifdef __VECTOR
      DO ijk = 1,nr3ve
        k=1+MOD(ijk-1,nr1ve)
        j=1+INT(MOD(ijk-1,nr2ve)/nr1ve)
        i=1+INT((ijk-1)/nr2ve)

!        if (i.eq.NR1+1.OR.j.eq.NR2+1.OR.k.eq.NR3+1) CYCLE
!        rhos=dabs(RHOE(IR,1) - 2.0d0*RHOE(IR,2))    ! spindensity justincase
         rhos=DABS(RHOE(I,J,K,1) - 2.0d0*RHOE(I,J,K,2))  

#ifdef PARALLEL
        tgbx=pi2*DBLE(NRXPL(MEPOS,1)+I-1)/DBLE(nr1s)
#else
        tgbx=pi2*DBLE(i-1)/DBLE(nr1s)
#endif
        tgby=pi2*DBLE(j-1)/DBLE(nr2s)
        tgbz=pi2*DBLE(k-1)/DBLE(nr3s)

        zeta(1)=zeta(1)+rhos*(DCOS(tgbx)+ci*DSIN(tgbx))
        zeta(2)=zeta(2)+rhos*(DCOS(tgby)+ci*DSIN(tgby))
        zeta(3)=zeta(3)+rhos*(DCOS(tgbz)+ci*DSIN(tgbz))

      ENDDO
#else
      DO i = 1,NR1
        DO j = 1,NR2
        DO k = 1,NR3
!        if (i.eq.NR1+1.OR.j.eq.NR2+1.OR.k.eq.NR3+1) CYCLE
!        rhos=dabs(RHOE(IR,1) - 2.0d0*RHOE(IR,2))    ! spindensity justincase
         rhos=DABS(RHOE(I,J,K,1) - 2.0d0*RHOE(I,J,K,2))  
#ifdef PARALLEL
        tgbx=pi2*DBLE(NRXPL(MEPOS,1)+I-1)/DBLE(nr1s)
#else
        tgbx=pi2*DBLE(i-1)/DBLE(nr1s)
#endif
        tgby=pi2*DBLE(j-1)/DBLE(nr2s)
        tgbz=pi2*DBLE(k-1)/DBLE(nr3s)

        zeta(1)=zeta(1)+rhos*(DCOS(tgbx)+ci*DSIN(tgbx))
        zeta(2)=zeta(2)+rhos*(DCOS(tgby)+ci*DSIN(tgby))
        zeta(3)=zeta(3)+rhos*(DCOS(tgbz)+ci*DSIN(tgbz))
        ENDDO
        ENDDO
      ENDDO
#endif

      zeta(1)=zeta(1)*omenorm
      zeta(2)=zeta(2)*omenorm
      zeta(3)=zeta(3)*omenorm

!      write(6,'(A,I3,6f10.4)') 'zeta1 ',MEPOS,ZETA(1),ZETA(2),ZETA(3)

      CALL GLOSUM(2*3,zeta)

!      write(6,'(A,I3,6f10.4)') 'zeta2 ',MEPOS,ZETA(1),ZETA(2),ZETA(3)

!..now compute Im{ln z(i)}= DATAN[DIMAG{z(i)}/DREAL{z(i)}]
      ZETARE(1) = DREAL(zeta(1))
      ZETAIM(1) = DIMAG(zeta(1))
      theta(1)  = DATAN(ZETAIM(1)/ZETARE(1))
      IF(ZETARE(1).LT.0.D0) theta(1) = theta(1) + PI
      theta(1) = theta(1) * oneby2pi
      ZETARE(2) = DREAL(zeta(2))
      ZETAIM(2) = DIMAG(zeta(2))
      theta(2)  = DATAN(ZETAIM(2)/ZETARE(2))
      IF(ZETARE(2).LT.0.D0) theta(2) = theta(2) + PI
      theta(2)  = theta(2) * oneby2pi
      ZETARE(3) = DREAL(zeta(3))
      ZETAIM(3) = DIMAG(zeta(3))
      theta(3)  = DATAN(ZETAIM(3)/ZETARE(3))
      IF(ZETARE(3).LT.0.D0) theta(3) = theta(3) + PI
      theta(3)  = theta(3) * oneby2pi

c..and eventually r_i[spinden]
      rcc(1)= !lowerleft(1)+
     &       (ah(1,1)*theta(1)+ah(1,2)*theta(2)+ah(1,3)*theta(3))
      rcc(2)= !lowerleft(2)+
     &       (ah(2,1)*theta(1)+ah(2,2)*theta(2)+ah(2,3)*theta(3))
      rcc(3)= !lowerleft(3)+
     &       (ah(3,1)*theta(1)+ah(3,2)*theta(2)+ah(3,3)*theta(3))


      EN_HARM_LOCS = 0.0D0      
      if(.NOT. CV_ASSOCIATED) RETURN

      num(1)=ZETAIM(1)
      num(2)=ZETAIM(2)
      num(3)=ZETAIM(3)
      den(1)=ZETARE(1)
      den(2)=ZETARE(2)
      den(3)=ZETARE(3)
      ss(1)=num(1)/den(1)
      ss(2)=num(2)/den(2)
      ss(3)=num(3)/den(3)


      DO ICV = 1,NCOLVAR
        IF(ICV_SPIN(ICV) .NE. 0) THEN

          DIST0=CV_DYN(ICV)
          ak=KHARM(ICV)

c.. of the potential with respect to rcc

          DX = (rcc(1)-rcc0(1,ICV))
          DY = (rcc(2)-rcc0(2,ICV))
          DZ = (rcc(3)-rcc0(3,ICV))

cmb-ale Most likely the line below is a bug. We do not want PBC...
cmb-ale   CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          dist=DSQRT(DX*DX+DY*DY+DZ*DZ)

!   Energy contribution due to the metadynamic harmonic terms 
!   (only those related to the CV for the localization of the spin density)
!   This contribution should appear in the electronic energy 
          EN_HARM_LOCS = EN_HARM_LOCS+
     &                   ak*(dist -dist0)*(dist-dist0)

!          write(6,'(I3,3f12.6)') 
!     &          ICV,  dist0,  dist, ak*(dist -dist0)*(dist-dist0)

          dist1=(dist-dist0)/dist

          drc(1)=2.0D0*ak*DX*dist1
          drc(2)=2.0D0*ak*DY*dist1
          drc(3)=2.0D0*ak*DZ*dist1

c...electronic contribution d(vs)/d[rho(x)]
          DO 100 ir=1,nnr1
            i=1+MOD(ir-1,nsri)
            j=1+INT(MOD(ir-1,nsrj)/nsri)
            k=1+INT((ir-1)/nsrj)
            IF (i.eq.NR1+1.OR.j.eq.NR2+1.OR.k.eq.NR3+1) THEN
              GOTO 100
            ENDIF
#ifdef PARALLEL
            tgbx=pi2*DBLE(NRXPL(MEPOS,1)+I-1)/DBLE(nr1s)
#else
            tgbx=pi2*DBLE(i)/DBLE(nr1s)
#endif
            tgby=pi2*DBLE(j)/DBLE(nr2s)
            tgbz=pi2*DBLE(k)/DBLE(nr3s)

            arw1=1.0D0/(1.D0+ss(1)**2)/den(1)**2
     &            *(den(1)*DSIN(tgbx)-num(1)*DCOS(tgbx))*omenorm
            arw2=1.0D0/(1.D0+ss(2)**2)/den(2)**2
     &            *(den(2)*DSIN(tgby)-num(2)*DCOS(tgby))*omenorm
            arw3=1.0D0/(1.D0+ss(3)**2)/den(3)**2
     &            *(den(3)*DSIN(tgbz)-num(3)*DCOS(tgbz))*omenorm

            vvt=oneby2pi*(
     .         drc(1)*(ah(1,1)*arw1+ah(1,2)*arw2+ah(1,3)*arw3)
     .        +drc(2)*(ah(2,1)*arw1+ah(2,2)*arw2+ah(2,3)*arw3)
     .        +drc(3)*(ah(3,1)*arw1+ah(3,2)*arw2+ah(3,3)*arw3))
            V(ir,1)=V(ir,1)+vvt ! cmb - spin/charge sign checked
            V(ir,2)=V(ir,2)-vvt ! cmb - spin/charge sign checked
 100      CONTINUE
        ENDIF  ! ICV_SPIN
      ENDDO ! NCOLVAR
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MATINV3(AM,AI,DH)
C     ==--------------------------------------------------------------==
C     ==  3x3 real matrix inversion: AM = incoming matrix             ==
C     ==                             AI = inverted matrix             ==
C     ==                             DH = determinant                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      REAL*8 D11,D12,D13,D21,D22,D23,D31,D32,D33,DH
      REAL*8 AM(3,3),AI(3,3)
C     ==--------------------------------------------------------------==
      D11=AM(2,2)*AM(3,3)-AM(2,3)*AM(3,2)
      D12=AM(2,3)*AM(3,1)-AM(2,1)*AM(3,3)
      D13=AM(2,1)*AM(3,2)-AM(3,1)*AM(2,2)
      D21=AM(3,2)*AM(1,3)-AM(1,2)*AM(3,3)
      D22=AM(1,1)*AM(3,3)-AM(1,3)*AM(3,1)
      D23=AM(3,1)*AM(1,2)-AM(1,1)*AM(3,2)
      D31=AM(1,2)*AM(2,3)-AM(2,2)*AM(1,3)
      D32=AM(1,3)*AM(2,1)-AM(1,1)*AM(2,3)
      D33=AM(1,1)*AM(2,2)-AM(1,2)*AM(2,1)
C     ==--------------------------------------------------------------==
      DH=AM(1,1)*D11+AM(1,2)*D12+AM(1,3)*D13
cmb      IF(DH.eq.0.) THEN ! this part is now removed
cmb        WRITE(6,*)' Singular matrix with Det=0 in module MATINV'
cmb        STOP
cmb      ENDIF
C     ==--------------------------------------------------------------==
      AI(1,1)=D11/DH
      AI(2,2)=D22/DH
      AI(3,3)=D33/DH
      AI(1,2)=D21/DH
      AI(1,3)=D31/DH
      AI(2,1)=D12/DH
      AI(2,3)=D32/DH
      AI(3,1)=D13/DH
      AI(3,2)=D23/DH
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
