#ifdef __SR8000
*option MP(P(0)), LANGLVL(SAVE(0))
#endif
C     ==================================================================
      SUBROUTINE TAUFUN(RHO,GRHO,TAU,SX,SC,V1X,V2X,V1C,V2C,VTT)
C     ==--------------------------------------------------------------==
C     ==  META FUNCTIONALS                                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'func.inc'
      PARAMETER (SMALL=1.D-20)
C     ==--------------------------------------------------------------==
      IF ( MFXCX.NE.0 .OR. MFXCC.NE.0 .OR. MGCX.NE.0 .OR. MGCC.NE.0 )
     *   CALL STOPGM("TAUFUN","FUNCTIONALS DO NOT MATCH")
      IF(MTAU.EQ.1 .AND. RHO.GT.SMALL) THEN
        CALL TPSS(RHO,GRHO,TAU,SX,SC,V1X,V2X,V1C,V2C,VTT)
      ELSE
        SX=0.D0
        SC=0.D0
        V1X=0.D0
        V2X=0.D0
        V1C=0.D0
        V2C=0.D0
        VTT=0.D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TAUFUNS(RHOA,RHOB,GRHOAA,GRHOBB,GRHOAB,TAUA,TAUB,
     *                   SX,SC,V1XA,V2XA,V1XB,V2XB,V1CA,V2CA,
     *                   V1CB,V2CB,V2XAB,V2CAB,VTTA,VTTB)
C     ==--------------------------------------------------------------==
C     ==  META FUNCTIONALS                                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'func.inc'
      PARAMETER(SMALL=1.D-20)
C     ==--------------------------------------------------------------==
      IF ( MFXCX.NE.0 .OR. MFXCC.NE.0 .OR. MGCX.NE.0 .OR. MGCC.NE.0 )
     *   CALL STOPGM("TAUFUN","FUNCTIONALS DO NOT MATCH")
      IF(MTAU.EQ.1 .AND. (RHOA.GT.SMALL.OR.RHOB.GT.SMALL)) THEN
        CALL TPSS_LSD(RHOA,RHOB,GRHOAA,GRHOBB,GRHOAB,TAUA,TAUB,
     *                SX,SC,V1XA,V2XA,V1XB,V2XB,V1CA,V2CA,
     *                V1CB,V2CB,V2XAB,V2CAB,VTTA,VTTB)
      ELSE
        SX=0.D0
        SC=0.D0
        V1XA=0.D0
        V1XB=0.D0
        V2XA=0.D0
        V2XB=0.D0
        V1CA=0.D0
        V1CB=0.D0
        V2CA=0.D0
        V2CB=0.D0
        V2XAB=0.D0
        V2CAB=0.D0
        VTTA=0.D0
        VTTB=0.D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TPSS(RHO,GRHO,TAU,SX,SC,V1X,V2X,V1C,V2C,VTT)
C     ==--------------------------------------------------------------==
C     ==  TPSS FUNCTIONAL                                             ==
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
C     ==--------------------------------------------------------------==
C     Exchange part
      CALL TPSSX(RHO,GRHO,TAU,SX,V1X,V2X,VTT)
C     Correlation
      CALL TPSSC(RHO,GRHO,TAU,SC,V1C,V2C,VTT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TPSS_LSD(RHOA,RHOB,GRHOAA,GRHOBB,GRHOAB,TAUA,TAUB,
     *                    SX,SC,V1XA,V2XA,V1XB,V2XB,V1CA,V2CA,
     *                    V1CB,V2CB,V2XAB,V2CAB,VTTA,VTTB)
C     ==--------------------------------------------------------------==
C     ==  TPSS FUNCTIONAL  LSD Version                                ==
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER(SMALL=1.D-20)
C     ==--------------------------------------------------------------==
C     Exchange part
C     alpha spin
      RHO=2.D0*RHOA
      GRHO=4.D0*GRHOAA
      TAU=2.D0*TAUA
      IF(RHO.GT.SMALL) THEN
        CALL TPSSX(RHO,GRHO,TAU,SXX,V1X,V2X,VTT)
        SX=0.5D0*SXX
        V1XA=V1X
        V2XA=2.D0*V2X
        VTTA=VTT
      ELSE
        SX=0.D0
        V1XA=0.D0
        V2XA=0.D0
        VTTA=0.D0
      ENDIF
C     beta spin
      RHO=2.D0*RHOB
      GRHO=4.D0*GRHOBB
      TAU=2.D0*TAUB
      IF(RHO.GT.SMALL) THEN
        CALL TPSSX(RHO,GRHO,TAU,SXX,V1X,V2X,VTT)
        SX=SX + 0.5D0*SXX
        V1XB=V1X
        V2XB=2.D0*V2X
        VTTB=VTT
      ELSE
        V1XB=0.D0
        V2XB=0.D0
        VTTB=0.D0
      ENDIF
      V2XAB=0.D0
C     Correlation
      CALL TPSSC_LSD(RHOA,RHOB,GRHOAA,GRHOBB,GRHOAB,TAUA,TAUB,
     *               SC,V1CA,V2CA,V1CB,V2CB,V2CAB,VTTA,VTTB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TPSSX(RHO,GRHO,TAU,SX,V1X,V2X,VTT)
C     ==--------------------------------------------------------------==
C     ==  EXCHANGE PART OF TPSS FUNCTIONAL                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'cnst.inc'
      PARAMETER(SMALL=1.D-14)
      REAL*8 KAPPA,MU
      PARAMETER(KAPPA=0.804D0, C=1.59096D0, E=1.537D0, B=0.40D0)
      PARAMETER(MU=0.21951D0)
C     ==--------------------------------------------------------------==
      F13 = 1.D0/3.D0
      F23 = 2.D0*F13
      F83 = 8.D0*F13
      F1081 = 10.D0/81.D0
      SE = SQRT(E) 
C      PI  = ACOS(-1.D0)
C
      EXUNIF = -3.D0/(4.D0*PI) * (3.D0*PI*PI*RHO)**F13
      IF( ABS(TAU) .GT. SMALL .AND. GRHO .GT. SMALL ) THEN
        P=GRHO/(4.D0*(3.D0*PI*PI)**F23*RHO**F83)
        Z=0.125D0*GRHO/RHO/TAU
        ALPHA = 5.D0*F13*P * (1.D0/Z - 1.D0)
        QBT = 0.45D0*(ALPHA-1.D0)/SQRT(1.D0+B*ALPHA*(ALPHA-1.D0))+F23*P
        X = ( F1081 + C*Z*Z/(1.D0+Z*Z)**2 ) * P + 146.D0/2025.D0*QBT**2
     *      - 73.D0/405.D0 * QBT * SQRT ( 0.5D0*(0.6D0*Z)**2+0.5D0*P*P)
     *      + F1081**2*P*P/KAPPA+2.D0*SE*F1081*(0.6D0*Z)**2+E*MU*P**3
        X = X/(1.D0+SE*P)**2
        FX = 1.D0 + KAPPA - KAPPA/(1.D0 + X/KAPPA)
      ELSE
        FX = 1.D0
      ENDIF
      SX = RHO*EXUNIF*FX
C
      IF( ABS(TAU) .GT. SMALL .AND. GRHO .GT. SMALL ) THEN
        DFXDX  = 1.D0/(1.D0 + X/KAPPA)**2
        DQBTDA = 0.225D0*(2.D0 + B*ALPHA - B)/
     *                   (1.D0 + B*ALPHA*ALPHA - B*ALPHA)**1.5D0
        DQBTDP = DQBTDA*5.D0*F13*(1.D0/Z-1.D0) + F23
        DQBTDZ = DQBTDA*5.D0*F13*P*(-1.D0/(Z*Z))
        DXDQBT = (146.D0/2025.D0 * 2.D0*QBT - 
     *           73.D0/405.D0 * SQRT ( 0.5D0*(0.6D0*Z)**2+0.5D0*P*P ))/
     *           (1.D0+SE*P)**2
        DXDZ   = DXDQBT*DQBTDZ + ( C*P*(2.D0*Z/(1.D0+Z*Z)**2 -
     *           4.D0*Z**3/(1.D0+Z*Z)**3 ) - 73.D0/405.D0 * QBT*0.5D0 *
     *           0.36D0*Z / SQRT ( 0.5D0*(0.6D0*Z)**2 + 0.5D0*P*P ) +
     *           4.D0*SE*F1081*0.36D0*Z ) / (1.D0+SE*P)**2
        DXDP   = -2.D0*SE*X/(1.D0+SE*P) + DXDQBT*DQBTDP +
     *           ( ( F1081 + C*Z*Z/(1.D0+Z*Z)**2 ) - 73.D0/405.D0*QBT *
     *           0.5D0*P/SQRT ( 0.5D0*(0.6D0*Z)**2 + 0.5D0*P*P ) +
     *           2.D0*F1081**2*P/KAPPA + 3.D0*E*MU*P**2 )/(1.D0+SE*P)**2
        DPDR   = -F83*P/RHO
        DPDG   = 2.D0*P/SQRT(GRHO)
        DZDR   = -Z/RHO
        DZDG   = 2.D0*Z/SQRT(GRHO)
        DZDT   = -Z/TAU
        DFXDR  = DFXDX*(DXDP*DPDR + DXDZ*DZDR)
        DFXDG  = DFXDX*(DXDP*DPDG + DXDZ*DZDG)
        DFXDT  = DFXDX*DXDZ*DZDT
C
        V1X = EXUNIF*(FX + F13*FX + RHO*DFXDR)
        V2X = RHO*EXUNIF*DFXDG/SQRT(GRHO)
        VTT = RHO*EXUNIF*DFXDT
      ELSE
        V1X = EXUNIF + F13*SX/RHO
        V2X = 0.D0
        VTT = 0.D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TPSSC(RHO,GRHO,TAU,SC,V1C,V2C,VTT)
C     ==--------------------------------------------------------------==
C     ==  CORRELATION PART OF TPSS FUNCTIONAL                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'cnst.inc'
      PARAMETER(SMALL=1.D-14)
      PARAMETER(D=2.8D0)
C     ==--------------------------------------------------------------==
      IF( ABS(TAU) .GT. SMALL .AND. GRHO .GT. SMALL ) THEN
        Z    = 0.125D0*GRHO/RHO/TAU
        DZDR = -Z/RHO
        DZDG = 2.D0*Z/SQRT(GRHO)
        DZDT = -Z/TAU
        CALL REVPKZB(RHO,GRHO,Z,E,DEDR,DEDG,DEDZ)
        DEDT = DEDZ*DZDT
        EDRT = DEDR + DEDZ*DZDR
        EDGT = DEDG + DEDZ*DZDG
        OP  = 1.D0 + D * E * Z**3
        RO  = RHO * E * D * Z**2
        SC  = RHO * E * OP
        V1C = (E + RHO*EDRT)*OP + RO * (EDRT*Z+3.D0*E*DZDR)
        V2C = RHO*EDGT*OP + RO * (EDGT*Z+3.D0*E*DZDG)
        V2C = V2C/SQRT(GRHO)
        VTT = VTT  + RHO*DEDT*OP + RO * (DEDT*Z+3.D0*E*DZDT)
      ELSE
C        PI   = ACOS(-1.D0)
        RS   = (3.D0/(4.D0*PI*RHO))**(1.D0/3.D0)
        IFLG = 2
        IF(RS.LT.1.0D0) IFLG=1
        CALL PZ(RS,E,V1C,IFLG)
        SC   = RHO * E
        V2C  = 0.D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TPSSC_LSD(RHOA,RHOB,GRHOAA,GRHOBB,GRHOAB,TAUA,TAUB,
     *                     SC,V1CA,V2CA,V1CB,V2CB,V2CAB,VTTA,VTTB)
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'cnst.inc'
      PARAMETER(SMALL=1.D-14)
      PARAMETER(OB3=1.D0/3.D0)
      PARAMETER(D=2.8D0)
C     ==--------------------------------------------------------------==
      RHO = RHOA + RHOB
      GRHO = GRHOAA + 2.D0*GRHOAB + GRHOBB
      TAU = TAUA + TAUB
      IF( ABS(TAU) .GT. SMALL .AND. GRHO .GT. SMALL) THEN
        Z    = 0.125D0*GRHO/RHO/TAU
        DZDR = -Z/RHO
        RDZDT = -Z*RHO/TAU
        DZDG = Z/GRHO
        CALL REVPKZB_LSD(RHOA,RHOB,GRHOAA,GRHOBB,GRHOAB,Z,E,
     *                   DEDRA,DEDRB,DEDGA,DEDGB,DEDGAB,DEDZ)
        OP   = 1.D0 + D * E * Z**3
        SC   = RHO * E * OP
        EDAZ = DEDRA + DEDZ*DZDR
        V1CA = E*OP + RHO*EDAZ*OP + RHO*E*D*Z*Z*
     *         (EDAZ*Z+3.D0*E*DZDR)
        EDBZ = DEDRB + DEDZ*DZDR
        V1CB = E*OP + RHO*EDBZ*OP + RHO*E*D*Z*Z*
     *         (EDBZ*Z+3.D0*E*DZDR)
        RO   = E*D*E*3.D0*Z*Z
        TO   = RHO * ( 1.D0 + 2.D0*D*E*Z**3 )
        V2CA = 2.D0*RHO*RO*DZDG + 2.D0*TO*DEDZ*DZDG + TO*DEDGA
        V2CB = 2.D0*RHO*RO*DZDG + 2.D0*TO*DEDZ*DZDG + TO*DEDGB
        V2CAB= 2.D0*RHO*RO*DZDG + 2.D0*TO*DEDZ*DZDG + TO*DEDGAB
        VTTA = VTTA + DEDZ*RDZDT*OP + 
     *                E*D*DEDZ*RDZDT*Z**3 + RO*RDZDT
        VTTB = VTTB + DEDZ*RDZDT*OP + 
     *                E*D*DEDZ*RDZDT*Z**3 + RO*RDZDT
      ELSE
        ETA=(RHOA-RHOB)/RHO
        IF(ABS(ETA).GT.1.D0) ETA=SIGN(1.0D0,ETA)
        RS = (0.75D0/(PI*RHO))**OB3
        IFLG=2
        IF(RS.LT.1.0D0) IFLG=1
        CALL LSD_PZ(RS,ETA,EC,VCA,VCB,IFLG)
        SC   = RHO * EC
        V1CA = VCA
        V2CA = 0.D0
        V1CB = VCB
        V2CB = 0.D0
        V2CAB= 0.D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE REVPKZB(RHO,GRHO,Z,E,DEDR,DEDG,DEDZ)
C     ==--------------------------------------------------------------==
C     ==  REVISED PKZB TAU CORRELATION FUNCTIONAL                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA C00 /0.53D0/
      DATA C0P /1.53D0/
C     ==--------------------------------------------------------------==
      CALL TPBEC(RHO,GRHO,ECPBE,V1C,V2C)
      CALL TPBECA(0.5D0*RHO,0.25D0*GRHO,ECPBEA,V1CA,V2CA)
      IF ( ECPBEA .GT. ECPBE ) THEN
        TECPBE = ECPBEA
        TV1C   = 0.5D0*V1CA
        TV2C   = 0.5D0*V2CA
      ELSE
        TECPBE = ECPBE
        TV1C   = V1C
        TV2C   = V2C
      END IF
      Z2 = Z*Z
      T1 = 1.D0 + C00*Z2
      E    = ECPBE*T1 - C0P*Z2*TECPBE
      DEDR = V1C*T1 - C0P*Z2*TV1C
      DEDG = V2C*T1 - C0P*Z2*TV2C
      DEDZ = 2.D0*Z * (ECPBE*C00 - C0P*TECPBE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TPBEC(RHO,GRHO,SC,V1C,V2C)
C     ==--------------------------------------------------------------==
C PBE Correlation functional
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'cnst.inc'
      PARAMETER(BE=0.06672455060314922D0,GA=0.031090690869654895D0)
      PARAMETER(CX=-0.001667D0,CXC0=0.002568D0,CC0=-CX+CXC0)
      PARAMETER(OB3=1.D0/3.D0)
C     ==--------------------------------------------------------------==
      RS    = (3.D0/(4.D0*PI*RHO))**OB3
      IFLG  = 2
      IF(RS.LT.1.0D0) IFLG=1
      CALL PZ(RS,EC,VC,IFLG)
      DECDR = (VC-EC)/RHO
      AA    = GRHO
      A     = SQRT(AA)
      XKF   = (9.D0*PI/4.D0)**OB3/RS
      XKS   = SQRT(4.D0*XKF/PI)
      T     = A/(2.D0*XKS*RHO)
      EXPE  = EXP(-EC/GA)
      AF    = BE/GA * (1.D0/(EXPE-1.D0))
      Y     = AF*T*T
      XY    = (1.D0+Y)/(1.D0+Y+Y*Y)
      S1    = 1.D0+BE/GA*T*T*XY
      H0    = GA * LOG(S1)
      DTDR  = -T*7.D0/(6.D0*RHO)
      DADR  = AF*AF*EXPE/BE*DECDR
      DSDA  = -BE/GA * AF * T**6 * (2.D0+Y) / (1.D0+Y+Y*Y)**2
      DSDT  = 2.D0*BE/GA * T * (1.D0+2.D0*Y) / (1.D0+Y+Y*Y)**2
      DSDR  = DSDA*DADR + DSDT*DTDR
      DHDT  = GA/S1*DSDT
      DHDR  = GA/S1*DSDR
      SC    = EC + H0
      V1C   = DECDR + DHDR
      V2C   = DHDT*T/A
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TPBECA(RHOA,GRHOAA,SC,V1CA,V2CA)
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'cnst.inc'
      PARAMETER(SMALL=1.D-24)
      PARAMETER(BE=0.06672455060314922D0,GA=0.031090690869654895D0)
      PARAMETER(OB3=1.D0/3.D0)
C     ==--------------------------------------------------------------==
      RHO   = RHOA
      IF ( RHO .GT. SMALL ) THEN
        PHI   = 0.5D0*2.D0**(2.D0/3.D0)
        PHI3  = PHI*PHI*PHI
        GRHO  = GRHOAA
        RS    = (3.D0/(4.D0*PI*RHO))**OB3
        IFLG=2
        IF(RS.LT.1.0D0) IFLG=1
        CALL LSD_PZ(RS,1.D0,EC,VCA,VCB,IFLG)
c
        AA    = DMAX1(GRHO,SMALL)
        A     = SQRT(AA)
        XKF   = (9.D0*PI/4.D0)**OB3/RS
        XKS   = SQRT(4.D0*XKF/PI)
        T     = A/(2.D0*XKS*RHO*PHI)
        EXPE  = EXP(-EC/(PHI3*GA))
        AF    = BE/GA * (1.D0/(EXPE-1.D0))
        Y     = AF*T*T
        XY    = (1.D0+Y)/(1.D0+Y+Y*Y)
        S1    = 1.D0+BE/GA*T*T*XY
        H0    = GA*PHI3 * LOG(S1)
c
        DECDRA= (VCA-EC)/RHO
        DTDRA = -T*(7.D0/(6.D0*RHO))
        DADRA = AF*AF*EXPE/(-BE*PHI3)*(-DECDRA)
        DSDA  = -BE/GA * AF * T**6 * (2.D0+Y) / (1.D0+Y+Y*Y)**2
        DSDT  = 2.D0*BE/GA * T * (1.D0+2.D0*Y) / (1.D0+Y+Y*Y)**2
        DSDRA = DSDA*DADRA + DSDT*DTDRA
        DHDT  = GA*PHI3/S1*DSDT
        DHDRA = GA*PHI3/S1*DSDRA
c
        SC    = EC + H0
        V1CA  = DECDRA + DHDRA
        V2CA  = DHDT*T/A
      ELSE
        SC    = 0.D0
        V1CA  = 0.D0
        V2CA  = 0.D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CGEFUN(XSI,ETA2,CXE,DCDX,DCDE)
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER(SMALL=1.D-14)
C     ==--------------------------------------------------------------==
      IF(ABS(XSI).LT.SMALL.AND.ABS(ETA2).LT.SMALL*SMALL) THEN
        CXE  = 0.53D0
        DCDX = 0.D0
        DCDE = 0.D0
      ELSEIF(ABS(ABS(XSI)-1.D0).LT.SMALL.AND.
     *                                 ABS(ETA2).LT.SMALL*SMALL) THEN
        X2  = XSI*XSI
        CX0 = 0.53D0 + 0.87D0*X2 + 0.50D0 * X2*X2 + 2.26D0 * X2*X2*X2
        DX0 = 2.D0*XSI * ( 0.87D0 + X2 + 3.D0**2.26D0 * X2*X2 )
        CXE  = CX0
        DCDX = DX0
        DCDE = 0.D0
      ELSE
        F43 = -4.D0/3.D0
        F73 = -7.D0/3.D0
        X2  = XSI*XSI
        CX0 = 0.53D0 + 0.87D0*X2 + 0.50D0 * X2*X2 + 2.26D0 * X2*X2*X2
        DX0 = 2.D0*XSI * ( 0.87D0 + X2 + 3.D0**2.26D0 * X2*X2 )
        IF(ABS(ABS(XSI)-1.D0).LT.SMALL) THEN
          XX  = 2.D0**F43
          DXX = F43*2.D0**F73
          DXX = DXX*SIGN(1.D0,XSI)
        ELSE
          XX  = (1.D0 + XSI)**F43 + (1.D0 - XSI)**F43
          DXX = F43*(1.D0 + XSI)**F73 - F43*(1.D0 - XSI)**F73
        ENDIF
        DNO = (1.D0 + 0.5D0*ETA2*XX)
        CXE = CX0/DNO**4
        DCDX = DX0/DNO**4 - 4.D0*CXE*0.5D0*ETA2*DXX/DNO
        DCDE = -2.D0*CXE*XX/DNO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CCFUN(RHOA,RHOB,GRHOAA,GRHOBB,GRHOAB,CXE,DCDRA,DCDRB,
     *                 DCDGAA,DCDGBB,DCDGAB)
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER(SMALL=1.D-14)
      PARAMETER(F43=4.D0/3.D0)
      PARAMETER(OB23=2.D0/3.D0)
C     ==--------------------------------------------------------------==
      RHO    = RHOA + RHOB
      XSI    = ( RHOA - RHOB ) / RHO
      IF(ABS(XSI).GT.1.D0) XSI=SIGN(1.0D0,XSI)
cdeb
c     DXSI0  = (XSI-1.D0)**2 * GRHOAA + 2.D0*(XSI*XSI-1.D0)*GRHOAB
c    *           + (XSI+1.D0)**2 * GRHOBB
      DXSI0  = (XSI-1.D0)**2 * GRHOAA + (XSI+1.D0)**2 * GRHOBB
cdeb
      OO     = 0.25D0/(RHO*RHO)/(3.D0*PI*PI*RHO)**OB23
      ETA2   = DXSI0*OO
      CALL CGEFUN(XSI,ETA2,CNN,DCDX,DCDE)
      DXDRA  =  2.D0*RHOB/(RHO*RHO)
      DXDRB  = -2.D0*RHOA/(RHO*RHO)
      IF(DXSI0.LT.SMALL*SMALL) THEN
        DEDX   = 0.D0
        DEDGAA = 0.D0
        DEDGBB = 0.D0
        DEDGAB = 0.D0
      ELSE
cdeb    DEDX   = (2.D0*(XSI-1.D0) * GRHOAA + 4.D0*XSI*GRHOAB
cdeb *            + 2.D0*(XSI+1.D0) * GRHOBB)*OO
        DEDX   = (2.D0*(XSI-1.D0)*GRHOAA+2.D0*(XSI+1.D0)*GRHOBB) * OO
        DEDGAA = (XSI-1.D0)**2 * OO
        DEDGBB = (XSI+1.D0)**2 * OO
cdeb    DEDGAB = 2.D0*OO*(XSI*XSI-1.D0)
        DEDGAB = 0.D0
      ENDIF
      DEDRA  = DEDX*DXDRA - 2.D0*F43*ETA2/RHO
      DEDRB  = DEDX*DXDRB - 2.D0*F43*ETA2/RHO
c
      DCDRA  = DCDX*DXDRA + DCDE*DEDRA
      DCDRB  = DCDX*DXDRB + DCDE*DEDRB
      DCDGAA = DCDE*DEDGAA
      DCDGBB = DCDE*DEDGBB
      DCDGAB = DCDE*DEDGAB
      CXE    = CNN
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE REVPKZB_LSD(RHOA,RHOB,GRHOAA,GRHOBB,GRHOAB,Z,E,
     *                   DEDRA,DEDRB,DEDGA,DEDGB,DEDGAB,DEDZ)
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'cnst.inc'
      PARAMETER(SMALL=1.D-14)
      PARAMETER(C00=0.54D0)
      PARAMETER(OB3=1.D0/3.D0)
C     ==--------------------------------------------------------------==
      CALL TPBECS(RHOA,RHOB,GRHOAA,GRHOAB,GRHOBB,SC,
     *            V1CA,V2CA,V1CB,V2CB,V2CAB)
      CALL TPBECA(RHOA,GRHOAA,SCA,TV1CA,TV2CA)
      CALL TPBECA(RHOB,GRHOBB,SCB,TV1CB,TV2CB)
      IF(SCA.GT.SC) THEN
        ECA = SCA
        T1A = TV1CA
        IF(GRHOAA.GT.SMALL) THEN
           T2A = TV2CA/SQRT(GRHOAA)
        ELSE
           T2A = 0.D0
        ENDIF
        T2ABA = 0.D0
        TXABA = 0.D0
        TYABA = 0.D0
      ELSE
        ECA = SC
        T1A = V1CA
        T2A = V2CA
        T2ABA = V2CAB
        TXABA = V1CB
        TYABA = V2CB
      ENDIF
      IF(SCB.GT.SC) THEN
        ECB = SCB
        T1B = TV1CB
        IF(GRHOBB.GT.SMALL) THEN
           T2B = TV2CB/SQRT(GRHOBB)
        ELSE
           T2B = 0.D0
        ENDIF
        T2ABB = 0.D0
        TXABB = 0.D0
        TYABB = 0.D0
      ELSE
        ECB = SC
        T1B = V1CB
        T2B = V2CB
        T2ABB = V2CAB
        TXABB = V1CA
        TYABB = V2CA
      ENDIF
C
      CALL CCFUN(RHOA,RHOB,GRHOAA,GRHOBB,GRHOAB,CXE,DCDRA,DCDRB,
     *           DCDGAA,DCDGBB,DCDGAB)
C
      RHO    = RHOA + RHOB
      EF1    = 1.D0 + CXE * Z * Z
      EF2    = ( 1.D0 + CXE ) * Z * Z
      E2     = RHOA/RHO * ECA + RHOB/RHO * ECB
      E      = SC * EF1 - EF2 * E2
      DEDRA  = V1CA * EF1 - (-E2+ECA + RHOA*T1A + RHOB*TXABB)/RHO * EF2
     *         + DCDRA*Z*Z * ( SC - E2 )
      DEDRB  = V1CB * EF1 - (-E2+ECB + RHOB*T1B + RHOA*TXABA)/RHO * EF2
     *         + DCDRB*Z*Z * ( SC - E2 )
      DEDGA  = V2CA * EF1 - EF2 * ( RHOA/RHO*T2A + RHOB/RHO*TYABB )
     *         + 2.D0*DCDGAA*Z*Z * ( SC - E2 )
      DEDGB  = V2CB * EF1 - EF2 * ( RHOB/RHO*T2B + RHOA/RHO*TYABA )
     *         + 2.D0*DCDGBB*Z*Z * ( SC - E2 )
      DEDGAB = V2CAB * EF1 - EF2 * (RHOA/RHO*T2ABA + RHOB/RHO*T2ABB)
     *         + 2.D0*DCDGAB*Z*Z * ( SC - E2 )
      DEDZ   = 2.D0 * SC * CXE * Z - 2.D0 * ( 1.D0 + CXE ) * Z * E2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TPBECS(RHOA,RHOB,GRHOAA,GRHOAB,GRHOBB,SC,
     *                  V1CA,V2CA,V1CB,V2CB,V2CAB)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER(SMALL=1.D-24)
      PARAMETER(BE=0.06672455060314922D0,GA=0.031090690869654895D0)
      PARAMETER(OB3=1.D0/3.D0)
C     ==--------------------------------------------------------------==
      RHO=RHOA+RHOB
      ETA=(RHOA-RHOB)/RHO
      GRHO=GRHOAA+2.D0*GRHOAB+GRHOBB
      IF(ABS(ETA).GT.1.D0) ETA=SIGN(1.0D0,ETA)
      RS = (0.75D0/(PI*RHO))**OB3
      IFLG=2
      IF(RS.LT.1.0D0) IFLG=1
      CALL LSD_PZ(RS,ETA,EC,VCA,VCB,IFLG)
      DECDRA= (VCA-EC)/RHO
      DECDRB= (VCB-EC)/RHO
      PHI   = 0.5D0*((1.d0+ETA)**(2.D0/3.D0)+(1.d0-ETA)**(2.D0/3.D0))
      PHI3  = PHI*PHI*PHI
      AA    = DMAX1(GRHO,SMALL)
      A     = SQRT(AA)
      XKF   = (9.D0*PI/4.D0)**OB3/RS
      XKS   = SQRT(4.D0*XKF/PI)
      T     = A/(2.D0*XKS*RHO*PHI)
      EXPE  = EXP(-EC/(PHI3*GA))
      AF    = BE/GA * (1.D0/(EXPE-1.D0))
      Y     = AF*T*T
      XY    = (1.D0+Y)/(1.D0+Y+Y*Y)
      S1    = 1.D0+BE/GA*T*T*XY
      H0    = GA*PHI3 * LOG(S1)
      SC    = EC + H0
c..
      IF(ETA.LT.0.999999999999D0 .AND. ETA.GT.-0.999999999999D0) THEN
        DTDPHI= -T/PHI
        DPHIDE= 1.D0/(3.D0*(1.d0+ETA)**OB3)-1.D0/(3.D0*(1.d0-ETA)**OB3)
        DEDRA = 2.D0*RHOB/(RHO*RHO)
        DEDRB = -2.D0*RHOA/(RHO*RHO)
        DPHIDA= DPHIDE*DEDRA
        DPHIDB= DPHIDE*DEDRB
        DTDRA = -T*(DPHIDA/PHI+7.D0/(6.D0*RHO))
        DTDRB = -T*(DPHIDB/PHI+7.D0/(6.D0*RHO))
        DADRA = AF*AF*EXPE/(-BE*PHI3)*(3.D0*EC/PHI*DPHIDA-DECDRA)
        DADRB = AF*AF*EXPE/(-BE*PHI3)*(3.D0*EC/PHI*DPHIDB-DECDRB)
        DSDA  = -BE/GA * AF * T**6 * (2.D0+Y) / (1.D0+Y+Y*Y)**2
        DSDT  = 2.D0*BE/GA * T * (1.D0+2.D0*Y) / (1.D0+Y+Y*Y)**2
        DSDRA = DSDA*DADRA + DSDT*DTDRA
        DSDRB = DSDA*DADRB + DSDT*DTDRB
        DHDT  = GA*PHI3/S1*DSDT
        DHDRA = 3.D0*H0/PHI*DPHIDA + GA*PHI3/S1*DSDRA
        DHDRB = 3.D0*H0/PHI*DPHIDB + GA*PHI3/S1*DSDRB
      ELSE
        DTDRA = -T*(7.D0/(6.D0*RHO))
        DTDRB = -T*(7.D0/(6.D0*RHO))
        DADRA = AF*AF*EXPE/(-BE*PHI3)*(-DECDRA)
        DADRB = AF*AF*EXPE/(-BE*PHI3)*(-DECDRB)
        DSDA  = -BE/GA * AF * T**6 * (2.D0+Y) / (1.D0+Y+Y*Y)**2
        DSDT  = 2.D0*BE/GA * T * (1.D0+2.D0*Y) / (1.D0+Y+Y*Y)**2
        DSDRA = DSDA*DADRA + DSDT*DTDRA
        DSDRB = DSDA*DADRB + DSDT*DTDRB
        DHDT  = GA*PHI3/S1*DSDT
        DHDRA = GA*PHI3/S1*DSDRA
        DHDRB = GA*PHI3/S1*DSDRB
      ENDIF
c..
      V1CA  = DECDRA + DHDRA
      V2CA  = DHDT*T/AA
      V1CB  = DECDRB + DHDRB
      V2CB  = DHDT*T/AA
      V2CAB = DHDT*T/AA
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

