C     ==================================================================
      SUBROUTINE MIXING_G(NFR,GEMAX,RIN0,ROUT0,RMIX,V,SCR,LSCR,THL)
C     ==--------------------------------------------------------------==
C     == Routine to perform density mixing in g-space                 ==
C     == RIN0 is input density in real space                          ==
C     == ROUT0 is output density in real space                        ==
C     == RMIX is mixed density  in real space                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'andr.inc'
      INCLUDE 'broy.inc'
      INCLUDE 'spin.inc' 
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
C     Arguments 
      INTEGER   NFR,LSCR
      REAL*8    THL(2),GEMAX
      REAL*8    RIN0(NNR1,NLSD),ROUT0(NNR1,NLSD),RMIX(NNR1,NLSD),
     &          SCR(LSCR)
      COMPLEX*16 V(NNR1)
C     Variables
C     COMPLEX*16 RGITER(NRDIISMAX*NHG,NLSD),
C     &          DRGITER(NRDIISMAX*NHG,NLSD)
C     POINTER    (IP_RGITER,RGITER),(IP_DRGITER,DRGITER)
      COMPLEX*16 RGIN0(NHG,NLSD),RGOUT0(NHG,NLSD),
     &           RGINM1(NHG,NLSD),RGOUTM1(NHG,NLSD),RGMIX(NHG,NLSD)
      POINTER    (IP_RGIN0,RGIN0),(IP_RGOUT0,RGOUT0),
     &           (IP_RGINM1,RGINM1),(IP_RGOUTM1,RGOUTM1),
     &           (IP_RGMIX,RGMIX)
C      REAL*8     DMAT(NRDIISMAX*NRDIISMAX,NLSD)
C      POINTER    (IP_DMAT,DMAT)
      CHARACTER  TAG*30
      INTEGER    NNGX,IFIRST,ILSD,IR,IG,ITB,LSCR2,LMIXING
      DATA       IFIRST/0/
C     SAVE       IP_RGITER,IP_DRGITER,IP_DMAT
      SAVE       IP_RGINM1,IP_RGOUTM1,IP_RGMIX,
     &           IFIRST
C     ==--------------------------------------------------------------==
      IF(NRDIISMAX.GT.0) CALL STOPGM('MIXING_G',
     &     'DIIS MIXING NOT PROGRAMMED') 
      NNGX=NHG*NLSD
C     ==--------------------------------------------------------------==
C     Test SCR length
      CALL GIVE_SCR_MIXING(LMIXING,TAG)
      CALL TEST_SCR('MIXING_G',TAG,LSCR,LMIXING)
C     Allocation of SCR
      LSCR2=LSCR-2*NNGX
#ifdef _BGL 
      LSCR2=LSCR2-MOD(LSCR2,2)
#endif
      CALL GET_ADDR(IP_RGIN0,SCR(LSCR2+1))
      LSCR2=LSCR2-2*NNGX
#ifdef _BGL 
      LSCR2=LSCR2-MOD(LSCR2,2)
#endif
      CALL GET_ADDR(IP_RGOUT0,SCR(LSCR2+1))
C     ==--------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN 
        IFIRST=1 
        IF(NRDIISMAX.GT.0) THEN
C          CALL MEMORY(IP_RGITER, 2*NRDIISMAX*NNGX,'RGITER')
C          CALL MEMORY(IP_DRGITER,2*NRDIISMAX*NNGX,'DRGITER')
C         We can use Anderson mixing and after DIIS mixing.
C          IP_RGINM1=IP_RGITER
C          IP_RGOUTM1=IP_DRGITER
C          CALL MEMORY(IP_DMAT,NRDIISMAX*NRDIISMAX*NLSD)
        ELSE
          CALL MEMORY(IP_RGINM1,2*NNGX,'RGINM1')
          CALL MEMORY(IP_RGOUTM1,2*NNGX,'RGOUTM1')
          CALL MEMORY(IP_RGMIX,2*NNGX,'RGMIX')
        ENDIF
        CALL ZAZZERO(RGINM1,NNGX)
        CALL ZAZZERO(RGOUTM1,NNGX)
      ENDIF
C     =================================================================
C     Transform RIN0 and ROUT0 to g-space ( RGIN0 and RGOUT0)
      DO ILSD=1,NLSD
!$OMP parallel do private(IR)
        DO IR=1,NNR1
          V(IR)=DCMPLX(RIN0(IR,ILSD),0.D0)
        ENDDO
        CALL FWFFT(V)
!$OMP parallel do private(IG)
        DO IG=1,NHG
          RGIN0(IG,ILSD)=V(NZH(IG))
        ENDDO
!$OMP parallel do private(IR)
        DO IR=1,NNR1
          V(IR)=DCMPLX(ROUT0(IR,ILSD),0.D0)
        ENDDO
        CALL FWFFT(V)
!$OMP parallel do private(IG)
        DO IG=1,NHG
          RGOUT0(IG,ILSD)=V(NZH(IG))
        ENDDO
      ENDDO
C     Initialization for density mixing (needed in MD).
C      IF(NFR.EQ.1) THEN
C        IF(NRDIISMAX.GT.0) THEN
C          INRDIIS=1
C          CALL RHODIIS(0,RMIX(1,1),RIN0(1,1),ROUT0(1,1),RGITER(1,1),
C     &         DRGITER(1,1),ANDRMIX,DMAT(1,1),0,1,THL(1))
C          IF(TLSD) THEN
C            CALL RHODIIS(0,RMIX(1,2),RIN0(1,2),ROUT0(1,2),RGITER(1,2),
C     &           DRGITER(1,2),ANDRMIX,DMAT(1,1),0,2,THL(1))
C          ENDIF
C        ENDIF
C      ENDIF
C     Change parameter if needed.
      CALL CHANGE_XMIX(ANDRMIX,GEMAX)
      IF(NRDIISMAX.GT.0) CALL CHANGE_NRDIIS(GEMAX)
      IF(TLSD) THEN
        IF(NRDIIS.GT.0) THEN
C          CALL RHODIIS(NNR1,RMIX(1,1),RIN0(1,1),ROUT0(1,1),
C     *         RGITER(1,1),DRGITER(1,1),ANDRMIX,DMAT(1,1),
C     &         NRDIIS,1,THL(1))
C          CALL RHODIIS(NNR1,RMIX(1,2),RIN0(1,2),ROUT0(1,2),
C     *         RGITER(1,2),DRGITER(1,2),ANDRMIX,DMAT(1,2),
C     &         NRDIIS,2,THL(2))
        ELSE IF(TGBROY.AND.(NFR.GT.NFRBROY)) THEN
          ITB=NFR-NFRBROY
          ITB=MOD(ITB-1,IBRESET)+1
          CALL BROYDEN(BROYMIX,ITB,RGINM1(1,1),
     &         RGIN0(1,1),RGOUT0(1,1),RGMIX(1,1),NHG,NGBROY,1,HG,
     &         SCR,LSCR2)
          THL(1)=0.D0 
          CALL BROYDEN(BROYMIX,ITB,RGINM1(1,2),
     &         RGIN0(1,2),RGOUT0(1,2),RGMIX(1,2),NHG,NGBROY,2,HG,
     &         SCR,LSCR2)
          THL(2)=0.D0 
        ELSE IF(KERMIX.NE.0.D0) THEN
          CALL KERKER(BROYMIX,KERMIX,RGIN0(1,1),RGOUT0(1,1),
     &                RGMIX(1,1),NHG,HG)
          THL(1)=0.D0 
          CALL KERKER(BROYMIX,KERMIX,RGIN0(1,2),RGOUT0(1,2),
     &                RGMIX(1,2),NHG,HG)
          THL(2)=0.D0 
        ELSE
          CALL ANDERSON(ANDRMIX,NFR,RGINM1(1,1),RGOUTM1(1,1),RGIN0(1,1),
     *                  RGOUT0(1,1),RGMIX(1,1),2*NHG,THL(1))
          CALL ANDERSON(ANDRMIX,NFR,RGINM1(1,2),RGOUTM1(1,2),RGIN0(1,2),
     *                  RGOUT0(1,2),RGMIX(1,2),2*NHG,THL(2))
        ENDIF
        CALL DCOPY(2*NNGX,RGIN0(1,1),1,RGINM1(1,1),1)
        CALL DCOPY(2*NNGX,RGOUT0(1,1),1,RGOUTM1(1,1),1)
      ELSE
        IF(NRDIIS.GT.0) THEN
C          CALL RHODIIS(NNR1,RMIX,RIN0,ROUT0,RGITER,DRGITER,
C     *                 ANDRMIX,DMAT,NRDIIS,1,THL)
C          THL(1)=0.D0
        ELSE
          IF(TGBROY.AND.(NFR.GT.NFRBROY)) THEN
            ITB=NFR-NFRBROY
c            IF(ITB.GT.IBRESET)ITB=ITB-IBRESET
            ITB=MOD(ITB-1,IBRESET)+1
            CALL BROYDEN(BROYMIX,ITB,RGINM1,
     &           RGIN0,RGOUT0,RGMIX,NHG,NGBROY,1,HG,SCR,LSCR2)
            THL(1)=0.D0 
          ELSE IF(KERMIX.NE.0.D0) THEN
            CALL KERKER(BROYMIX,KERMIX,RGIN0,RGOUT0,RGMIX,NHG,HG)
            THL(1)=0.D0
          ELSE
            CALL ANDERSON(ANDRMIX,NFR,RGINM1,RGOUTM1,RGIN0,RGOUT0,
     &           RGMIX,2*NHG,THL)
          ENDIF
          CALL DCOPY(2*NNGX,RGIN0,1,RGINM1,1)
          CALL DCOPY(2*NNGX,RGOUT0,1,RGOUTM1,1)
        ENDIF
      ENDIF
C..Transform RGMIX to to real-space
      DO ILSD=1,NLSD
        CALL ZAZZERO(V,NNR1)
!$OMP parallel do private(IG)
!CDIR NODEP
        DO IG=1,NHG
          V(NZH(IG))=RGMIX(IG,ILSD)
          V(INDZ(IG))=DCONJG(RGMIX(IG,ILSD))
        ENDDO
        IF(GEQ0) V(NZH(1))=RGMIX(1,ILSD)
        CALL INVFFT(V)
!$OMP parallel do private(IR)
        DO IR=1,NNR1
          RMIX(IR,ILSD)=DREAL(V(IR))
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_MIXING(LMIXING,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG
      INCLUDE 'spin.inc'        !NLSD
      INCLUDE 'broy.inc'        !TGMIX
      INCLUDE 'andr.inc'        !NRDIISMAX
C     Arguments
      INTEGER   LMIXING,LBROYDEN
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      IF(TGMIX) THEN
C       Mixing in G-space
        IF(TGBROY) THEN
          CALL GIVE_SCR_BROYDEN(LBROYDEN,TAG,NHG)
        ELSE
          LBROYDEN=0
        ENDIF
        LMIXING=LBROYDEN+2*2*NHG*NLSD !RGIN0 RGOUT0
      ELSE
C       Mixing in R-space
        LMIXING=(NRDIISMAX+1)*(NRDIISMAX+1+1) !DM VB
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
