C     ==================================================================
      SUBROUTINE MIXING_R(NFR,GEMAX,RIN0,ROUT0,RMIX,SCR,LSCR,THL)
C     ==--------------------------------------------------------------==
C     == Routine to perform density mixing.                           ==
C     == RIN0 is input density in real space                          ==
C     == ROUT0 is output density in real space                        ==
C     == RMIX is mixed density  in real space                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NNR1
      INCLUDE 'andr.inc'        !NRDIISMAX
      INCLUDE 'spin.inc'        !NLSD
C     Arguments 
      INTEGER   NFR,LSCR
      REAL*8    THL(2),GEMAX
      REAL*8    RIN0(NNR1,NLSD),ROUT0(NNR1,NLSD),SCR(LSCR)
C     Variables
      REAL*8    RITER(NRDIISMAX*NNR1,NLSD),
     &          DRITER(NRDIISMAX*NNR1,NLSD),
     &          RINM1(NNR1,NLSD),ROUTM1(NNR1,NLSD),RMIX(NNR1,NLSD),
     &          DMAT(NRDIISMAX,NRDIISMAX,NLSD),
     &          DM(NRDIISMAX+1,NRDIISMAX+1),VB(NRDIISMAX+1)
      POINTER   (IP_RITER,RITER),(IP_DRITER,DRITER),
     &          (IP_RINM1,RINM1),(IP_ROUTM1,ROUTM1),(IP_DMAT,DMAT),
     &          (IP_DM,DM),(IP_VB,VB)
      CHARACTER TAG*30
      INTEGER   NNX,LMIXING,IFIRST
      DATA      IFIRST/0/
      SAVE      IP_RITER,IP_DRITER,IP_RINM1,IP_ROUTM1,IP_DMAT,
     &          IFIRST  
C     ==--------------------------------------------------------------==
C     Test SCR
      CALL GIVE_SCR_MIXING(LMIXING,TAG)
      CALL TEST_SCR('MIXING_R',TAG,LSCR,LMIXING)
      CALL GET_ADDR(IP_VB,SCR(1))
      CALL GET_ADDR(IP_DM,SCR(NRDIISMAX+1+1))
C     Allocation of SCR
C     ==--------------------------------------------------------------==
      NNX=NNR1*NLSD
      IF(IFIRST.EQ.0) THEN 
        IFIRST=1 
        IF(NRDIISMAX.GT.0) THEN
          CALL MEMORY(IP_RITER,NRDIISMAX*NNX,'RITER')
          CALL MEMORY(IP_DRITER,NRDIISMAX*NNX,'DRITER')
          CALL MEMORY(IP_DMAT,NRDIISMAX*NRDIISMAX*NLSD,'DMAT')
C         We can use Anderson mixing and after DIIS mixing.
          CALL GET_ADDR(IP_RINM1,RITER(1,1))
          CALL GET_ADDR(IP_ROUTM1,DRITER(1,1))
        ELSE
          CALL MEMORY(IP_RINM1,NNX,'RINM1')
          CALL MEMORY(IP_ROUTM1,NNX,'ROUTM1')
        ENDIF
        CALL AZZERO(RINM1,NNX)
        CALL AZZERO(ROUTM1,NNX)
      ENDIF
C     ==--------------------------------------------------------------==
C     Initialization for density mixing (needed in MD).
      IF(NFR.EQ.1) THEN
        IF(NRDIISMAX.GT.0) THEN
          INRDIIS=1
          CALL RHODIIS(0,RMIX(1,1),RIN0(1,1),ROUT0(1,1),RITER(1,1),
     &         DRITER(1,1),ANDRMIX,DMAT(1,1,1),DM,VB,
     &         NRDIISMAX,0,1,THL(1))
          IF(TLSD) THEN
            CALL RHODIIS(0,RMIX(1,2),RIN0(1,2),ROUT0(1,2),RITER(1,2),
     &           DRITER(1,2),ANDRMIX,DMAT(1,1,2),DM,VB,
     &           NRDIISMAX,0,2,THL(1))
          ENDIF
        ENDIF
      ENDIF
C     Change parameter if needed.
      CALL CHANGE_XMIX(ANDRMIX,GEMAX)
      IF(NRDIISMAX.GT.0) CALL CHANGE_NRDIIS(GEMAX)
      IF(TLSD) THEN
        IF(NRDIIS.GT.0) THEN
          CALL RHODIIS(NNR1,RMIX(1,1),RIN0(1,1),ROUT0(1,1),
     *                 RITER(1,1),DRITER(1,1),ANDRMIX,DMAT(1,1,1),DM,VB,
     &                 NRDIISMAX,NRDIIS,1,THL(1))
          CALL RHODIIS(NNR1,RMIX(1,2),RIN0(1,2),ROUT0(1,2),
     *                 RITER(1,2),DRITER(1,2),ANDRMIX,DMAT(1,1,2),DM,VB,
     &                 NRDIISMAX,NRDIIS,2,THL(2))
        ELSE
          CALL ANDERSON(ANDRMIX,NFR,RINM1(1,1),ROUTM1(1,1),RIN0(1,1),
     *                  ROUT0(1,1),RMIX(1,1),NNR1,THL(1))
          CALL ANDERSON(ANDRMIX,NFR,RINM1(1,2),ROUTM1(1,2),RIN0(1,2),
     *                  ROUT0(1,2),RMIX(1,2),NNR1,THL(2))
          CALL DCOPY(NNX,RIN0(1,1),1,RINM1(1,1),1)
          CALL DCOPY(NNX,ROUT0(1,1),1,ROUTM1(1,1),1)
        ENDIF
      ELSE
        IF(NRDIIS.GT.0) THEN
          CALL RHODIIS(NNR1,RMIX,RIN0,ROUT0,RITER,DRITER,
     *                 ANDRMIX,DMAT,DM,VB,
     &                 NRDIISMAX,NRDIIS,1,THL)
C          THL(1)=0.D0
        ELSE
          CALL ANDERSON(ANDRMIX,NFR,RINM1,ROUTM1,RIN0,ROUT0,RMIX,
     *                  NNR1,THL(1))
          CALL DCOPY(NNX,RIN0(1,1),1,RINM1(1,1),1)
          CALL DCOPY(NNX,ROUT0(1,1),1,ROUTM1(1,1),1)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

