C     ==================================================================
      SUBROUTINE MLTFFT_DEFAULT(TRANSA,TRANSB,A,LDAX,LDAY,
     *                          B,LDBX,LDBY,N,M,ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
#if (defined(__SR8000) || defined(_BGP)) && defined(FFT_DEFAULT)
      INCLUDE 'system.h'
#endif
C     Arguments
      CHARACTER  TRANSA*1,TRANSB*1
      INTEGER    LDAX,LDAY,LDBX,LDBY,N,M,ISIGN
      COMPLEX*16 A(LDAX,LDAY),B(LDBX,LDBY)
      REAL*8     SCALE
C     Variables
      INTEGER    NCACHE
#if defined(T3D)
      PARAMETER(NCACHE=1024*2)
#elif defined(T3E)
      PARAMETER(NCACHE=1024*8)
#elif defined(__NEC)
      PARAMETER(NCACHE=1024*1024)
#elif defined(__VECTOR)
#ifdef __SR8000
      PARAMETER(NCACHE=1024*8)  ! cmb - for SR8K
#else
      PARAMETER(NCACHE=1024*128)
#endif
#elif defined(__alpha)
      PARAMETER(NCACHE=1024*8)
#elif defined(__SGI)
      PARAMETER(NCACHE=1024*4)
#elif defined(__IBM)
#ifdef __SR11KIBM
      PARAMETER(NCACHE=1024*32) ! cmb - for SR11K
#else
      PARAMETER(NCACHE=1024*10)
#endif
#elif defined(__OSX) || defined(__OSX_IFC)
      PARAMETER(NCACHE=1024*10)
#elif defined(__i386)
      PARAMETER(NCACHE=1024*10)
#elif defined(__x86_64)
#ifdef __PACS
      PARAMETER(NCACHE=1024*8)  ! cmb - for PACS-CS
#else
      PARAMETER(NCACHE=1024*6)
#endif
#elif defined(__HP)
      PARAMETER(NCACHE=1024*64)
#elif defined(__ALTIX)
      PARAMETER(NCACHE=1024*16) ! Altix3700/3900
#elif defined(_FFT_NCACHE)
      PARAMETER(NCACHE=_FFT_NCACHE) ! for convenient overrides in makefile
#else
      PARAMETER(NCACHE=1024*2)
#endif
      INTEGER    AFTER(20),NOW(20),BEFORE(20)
      REAL*8     TRIG(2,1024)
      LOGICAL    TSCAL
#if defined(__SR8000) || defined(__SR11000) 
      REAL*8     Z(2,NCACHE/4+1,2,MAXCPU/8)
      INTEGER   NCPUS,LENGTH,ISIG,IC,LOT,MM,ICPU,ML,MH,ITR,NFFT,
     &          I,INZEE,J,IL,IR,
     &          IFIRST
      SAVE      IFIRST
      DATA      IFIRST /0/
#elif defined(_BGP) && ( defined(FFT_DEFAULT) || defined (FFT_FFTW) )
      REAL*8     Z(2,NCACHE/4+1,2,*)
      POINTER   (IP_Z,Z)
      INTEGER   NCPUS,LENGTH,ISIG,IC,LOT,MM,ICPU,ML,MH,ITR,NFFT,
     &          I,INZEE,J,IL,IR,
     &          IFIRST
      SAVE      IFIRST,IP_Z
      DATA      IFIRST /0/
#else
      REAL*8     Z(2,NCACHE/4+1,2,*)
      POINTER   (IP_Z,Z)
      INTEGER   NCPUS,LENGTH,ISIG,IC,LOT,MM,ICPU,ML,MH,ITR,NFFT,
     &          I,INZEE,J,
     &          IFIRST
      SAVE      IFIRST,IP_Z
      DATA      IFIRST /0/
#endif
C     ==--------------------------------------------------------------==
      CALL NUMCPUS(NCPUS)
      IF(IFIRST.EQ.0) THEN
        IFIRST=1
        LENGTH=4*(NCACHE/4+1)*NCPUS
#if defined(__SR8000) || defined(__SR11000)
cmb     do not call MEMORY
#else
        CALL MEMORY(IP_Z,LENGTH,'CACHE')
#endif
      ENDIF
      ISIG=-ISIGN
      TSCAL=(DABS(SCALE-1.D0).GT.1.D-12)
      CALL CTRIG(N,TRIG,AFTER,BEFORE,NOW,ISIG,IC)
      LOT=NCACHE/(4*N)
      LOT=LOT-MOD(LOT+1,2)
      LOT=MAX(1,LOT)
      IF(4*N*LOT.GT.NCACHE) CALL STOPGM('MLFFT_DEFAULT',' NCACHE ')
      MM=MAX(M/NCPUS,1)
#if defined(__YMP)

#endif
#if defined(__SR11000) || defined(_BGP)
!$OMP parallel do private(nfft,icpu,ml,mh,itr,inzee,i,j,il,ir)
!$OMP+ shared(trig,now,after,before,tscal,scale,
!$OMP+        ldax,lday,ldbx,ldby,isig,n,a,b,lot,mm,m,ncpus,
!$OMP+        transa,transb,ic)
#else
!$OMP parallel do private(nfft,icpu,ml,mh,itr,inzee,i)
!$OMP+ shared(trig,now,after,before,tscal,scale,
!$OMP+        ldax,lday,ldbx,ldby,isig,n,a,b,lot,mm,m,ncpus,
!$OMP+        transa,transb,ic)
#endif
      DO ICPU=1,NCPUS
        ML=(ICPU-1)*MM+1
        MH=MIN(ICPU*MM,M)
        IF(ICPU.EQ.NCPUS) MH=M
#ifdef __SR8000
cmb-warning: something might be screwed up on SR11000-J1
*poption parallel
*poption tlocal(NFFT,Z)
#endif
        DO ITR=ML,MH,LOT
          NFFT=MIN(MH-ITR+1,LOT)
          IF(TRANSA.EQ.'N'.OR.TRANSA.EQ.'n') THEN
            CALL FFTPRE(NFFT,NFFT,LDAX,LOT,N,A(1,ITR),Z(1,1,1,ICPU),
     *                  TRIG,NOW(1),AFTER(1),BEFORE(1),ISIG)
          ELSE
            CALL FFTSTP(LDAX,NFFT,N,LOT,N,A(ITR,1),Z(1,1,1,ICPU),
     *                  TRIG,NOW(1),AFTER(1),BEFORE(1),ISIG)
          ENDIF
C          IF(TSCAL) CALL DSCAL(2*LOT*N,SCALE,Z(1,1,1,ICPU),1)
          IF(TSCAL) THEN
            IF(LOT.EQ.NFFT) THEN
#if defined(__SR8000) || defined(__SR11000) || defined(_BGP)
              DO J=1,LOT*N
                Z(1,J,1,ICPU)=SCALE*Z(1,J,1,ICPU)
                Z(2,J,1,ICPU)=SCALE*Z(2,J,1,ICPU)
              ENDDO
#else
              CALL DSCAL(2*LOT*N,SCALE,Z(1,1,1,ICPU),1)
#endif
            ELSE
#if defined(__SR8000) || defined(__SR11000) || defined(_BGP)
              DO I=1,N
                DO J=1,NFFT
                  IL=LOT*(I-1)+J
                  IR=IL
                  Z(1,IL,1,ICPU)=SCALE*Z(1,IR,1,ICPU)
                  Z(2,IL,1,ICPU)=SCALE*Z(2,IR,1,ICPU)
                ENDDO
              ENDDO
#else
              DO I=1,N
                CALL DSCAL(2*NFFT,SCALE,Z(1,LOT*(I-1)+1,1,ICPU),1)
              ENDDO
#endif
            ENDIF
          ENDIF
          IF(IC.EQ.1) THEN
            IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
#if defined(__EREG)
              CALL CMPLX_TRANSPOSE(NFFT,N,Z(1,1,1,ICPU),LOT,
     *                             B(ITR,1),LDBX)
#elif defined(__SR8000) || defined(__SR11000) || defined(_BGP)
              DO I=1,NFFT
                DO J=1,N
                  IL=LDBX*(I-1)+J
                  IR= LOT*(J-1)+I
                  B(IL,ITR)=DCMPLX(Z(1,IR,1,ICPU),Z(2,I,IR,ICPU))
                ENDDO
              ENDDO
#else
              CALL ZGETMO(Z(1,1,1,ICPU),LOT,NFFT,N,B(1,ITR),LDBX)
#endif
            ELSE
#if defined(__SR8000) || defined(__SR11000) || defined(_BGP)
              DO I=1,NFFT
                DO J=1,N
                  IL=LDBX*(I-1)+J
                  IR= LOT*(I-1)+J
                  B(ITR,IL)=DCMPLX(Z(1,IR,1,ICPU),Z(2,I,IR,ICPU))
                ENDDO
              ENDDO
#else
              CALL MATMOV(NFFT,N,Z(1,1,1,ICPU),LOT,B(ITR,1),LDBX)
#endif
            ENDIF
          ELSE
            INZEE=1
            DO I=2,IC-1
              CALL FFTSTP(LOT,NFFT,N,LOT,N,Z(1,1,INZEE,ICPU),
     *                    Z(1,1,3-INZEE,ICPU),TRIG,NOW(I),AFTER(I),
     *                    BEFORE(I),ISIG)
              INZEE=3-INZEE
            ENDDO
            IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
              CALL FFTROT(LOT,NFFT,N,NFFT,LDBX,Z(1,1,INZEE,ICPU),
     *              B(1,ITR),TRIG,NOW(IC),AFTER(IC),BEFORE(IC),ISIG)
            ELSE
              CALL FFTSTP(LOT,NFFT,N,LDBX,N,Z(1,1,INZEE,ICPU),
     *              B(ITR,1),TRIG,NOW(IC),AFTER(IC),BEFORE(IC),ISIG)
            ENDIF
          ENDIF
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
!$OMP parallel do private (I,J)
        DO J=M+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
!$OMP parallel do private (I,J)
        DO J=1,M
          DO I=N+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ELSE
!$OMP parallel do private (I,J)
        DO J=N+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
!$OMP parallel do private (I,J)
        DO J=1,N
          DO I=M+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MLTFFT_ESSL(TRANSA,TRANSB,A,LDAX,LDAY,B,LDBX,LDBY,N,M,
     *                       ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER  TRANSA*1,TRANSB*1
      INTEGER    LDAX,LDAY,LDBX,LDBY,N,M,ISIGN
      COMPLEX*16 A(LDAX,LDAY),B(LDBX,LDBY)
      REAL*8     SCALE
C     Variables
      INTEGER   I,J
#if defined(FFT_ESSL)
      INTEGER   NAUX1,NAUX2
      PARAMETER (NAUX1=100000,NAUX2=100000)
      REAL*8    AUX1(NAUX1),AUX2(NAUX2)
C     ==--------------------------------------------------------------==
      IF(TRANSA.EQ.'N'.OR.TRANSA.EQ.'n') THEN
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          CALL DCFT(1,A,1,LDAX,B,1,LDBX,N,M,ISIGN,SCALE,
     *            AUX1,NAUX1,AUX2,NAUX2)
          CALL DCFT(0,A,1,LDAX,B,1,LDBX,N,M,ISIGN,SCALE,
     *            AUX1,NAUX1,AUX2,NAUX2)
        ELSE
          CALL DCFT(1,A,1,LDAX,B,LDBX,1,N,M,ISIGN,SCALE,
     *            AUX1,NAUX1,AUX2,NAUX2)
          CALL DCFT(0,A,1,LDAX,B,LDBX,1,N,M,ISIGN,SCALE,
     *            AUX1,NAUX1,AUX2,NAUX2)
        ENDIF
      ELSE
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          CALL DCFT(1,A,LDAX,1,B,1,LDBX,N,M,ISIGN,SCALE,
     *            AUX1,NAUX1,AUX2,NAUX2)
          CALL DCFT(0,A,LDAX,1,B,1,LDBX,N,M,ISIGN,SCALE,
     *            AUX1,NAUX1,AUX2,NAUX2)
        ELSE
          CALL DCFT(1,A,LDAX,1,B,LDBX,1,N,M,ISIGN,SCALE,
     *            AUX1,NAUX1,AUX2,NAUX2)
          CALL DCFT(0,A,LDAX,1,B,LDBX,1,N,M,ISIGN,SCALE,
     *            AUX1,NAUX1,AUX2,NAUX2)
        ENDIF
      ENDIF
#endif
C     ==--------------------------------------------------------------==
      IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
        DO J=M+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
        DO J=1,M
          DO I=N+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ELSE
        DO J=N+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
        DO J=1,N
          DO I=M+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MLTFFT_CRAY(TRANSA,TRANSB,A,LDAX,LDAY,B,LDBX,LDBY,N,M,
     *                       ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER  TRANSA*1,TRANSB*1
      INTEGER    LDAX,LDAY,LDBX,LDBY,N,M,ISIGN
      COMPLEX*16 A(LDAX,LDAY),B(LDBX,LDBY)
      REAL*8     SCALE
C     Variables
      INTEGER    NTAB,NWORK,NCACHE
      PARAMETER  (NTAB=4096,NWORK=4096,NCACHE=2048)
      COMPLEX*16 CONE,CZERO,WORK(NWORK),C(NCACHE)
      REAL*8     TABLE(NTAB),AUX
      INTEGER    ISIG,I,II,NLOT,J,NOW
C     ==--------------------------------------------------------------==
#if defined(FFT_YMP)||(FFT_T3D)
      IF(2*N.GT.NTAB) CALL STOPGM('MLTFFT','TABLE TOO SMALL')
      CALL CCFFT(0,N,SCALE,A,B,TABLE,AUX,0)
      IF(4*N.GT.NWORK) CALL STOPGM('MLTFFT','NWORK TOO SMALL')
      CONE  = DCMPLX(1.0D0,0.0D0)
      CZERO = DCMPLX(0.0D0,0.0D0)
      ISIG=-ISIGN
      IF(TRANSA.EQ.'N'.OR.TRANSA.EQ.'n') THEN
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          DO I=1,M
            CALL CCFFT(ISIG,N,SCALE,A(1,I),B(1,I),TABLE,WORK,0)
          ENDDO
        ELSE
          DO I=1,M
            CALL CCFFT(ISIG,N,SCALE,A(1,I),A(1,I),TABLE,WORK,0)
          ENDDO
          CALL CGESUM('T',LDBX,LDBY,CONE,A,LDAX,CZERO,B,LDBX)
        ENDIF
      ELSE
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          CALL CGESUM('T',LDBX,LDBY,CONE,A,LDAX,CZERO,B,LDBX)
          DO I=1,M
            CALL CCFFT(ISIG,N,SCALE,B(1,I),B(1,I),TABLE,WORK,0)
          ENDDO
        ELSE
          NLOT=NCACHE/LDAY
          DO J=1,M,NLOT
            NOW=MIN(NLOT,M-J+1)
            CALL CGESUM('T',LDAY,NOW,CONE,A(J,1),LDAX,CZERO,C,LDAY)
            DO I=1,NOW
              II=(I-1)*LDAY+1
              CALL CCFFT(ISIG,N,SCALE,C(II),C(II),TABLE,WORK,0)
            ENDDO
            CALL CGESUM('T',NOW,LDAY,CONE,C,LDAY,CZERO,A(J,1),LDAX)
          ENDDO
        ENDIF
      ENDIF
#endif
C     ==--------------------------------------------------------------==
      IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
        DO J=M+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
        DO J=1,M
          DO I=N+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ELSE
        DO J=N+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
        DO J=1,N
          DO I=M+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MLTFFT_HP(TRANSA,TRANSB,A,LDAX,LDAY,B,LDBX,LDBY,N,M,
     *                     ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER  TRANSA*1,TRANSB*1
      INTEGER    LDAX,LDAY,LDBX,LDBY,N,M,ISIGN
      COMPLEX*16 A(LDAX,LDAY),B(LDBX,LDBY)
      REAL*8     SCALE
      COMPLEX*16  BTEMP(N)
      REAL*8      WORK(5*N/2)
      REAL*8      ASCALE
      INTEGER*4 IOPT, IER,I,J
C     ==--------------------------------------------------------------==
#if defined(FFT_HP)
      IF(TRANSA.EQ.'N'.OR.TRANSA.EQ.'n') THEN
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
c         CALL DCFT(1,A,1,LDAX,B,1,LDBX,N,M,ISIGN,SCALE,
c    *            AUX1,NAUX1,AUX2,NAUX2)
c         CALL DCFT(0,A,1,LDAX,B,1,LDBX,N,M,ISIGN,SCALE,
c    *            AUX1,NAUX1,AUX2,NAUX2)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
          CALL ZGECPY ('N', N, M, A, LDAX, B, LDBX)
          IF (ISIGN .GE. 0) THEN
             IOPT = -1
           ELSE
             IOPT = 1
          ENDIF
          CALL ZFFTS (B, N, 1, M, LDBX, IOPT, IER)
          IF (IER .NE. 0) THEN
            CALL STOPGM('MLFFT_HP','ERROR IN CALL TO ZFFTS')
          ENDIF
          IF (ISIGN .GE. 0) THEN
             ASCALE = SCALE*DREAL(N)
           ELSE
             ASCALE = SCALE
          ENDIF
          IF (ASCALE .NE. 1.0D0) THEN
             DO I = 1,M
                CALL ZDSCAL(N, ASCALE, B(1,I), 1)
             ENDDO
          ENDIF
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        ELSE
c         CALL DCFT(1,A,1,LDAX,B,LDBX,1,N,M,ISIGN,SCALE,
c    *            AUX1,NAUX1,AUX2,NAUX2)
c         CALL DCFT(0,A,1,LDAX,B,LDBX,1,N,M,ISIGN,SCALE,
c    *            AUX1,NAUX1,AUX2,NAUX2)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
          CALL ZGECPY ('T', N, M, A, LDAX, B, LDBX)
          IF (ISIGN .GE. 0) THEN
             IOPT = -1
           ELSE
             IOPT = 1
          ENDIF
          CALL ZFFTS (B, N, LDBX, M, 1, IOPT, IER)
          IF (IER .NE. 0) THEN
            CALL STOPGM('MLFFT_HP','ERROR IN CALL TO ZFFTS')
          ENDIF
          IF (ISIGN .GE. 0) THEN
             ASCALE = SCALE*DREAL(N)
           ELSE
             ASCALE = SCALE
          ENDIF
          IF (ASCALE .NE. 1.0D0) THEN
             DO I = 1,N
                CALL ZDSCAL(M, ASCALE, B(1,I), 1)
             ENDDO
          ENDIF
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        ENDIF
      ELSE
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
c         CALL DCFT(1,A,LDAX,1,B,1,LDBX,N,M,ISIGN,SCALE,
c    *            AUX1,NAUX1,AUX2,NAUX2)
c         CALL DCFT(0,A,LDAX,1,B,1,LDBX,N,M,ISIGN,SCALE,
c    *            AUX1,NAUX1,AUX2,NAUX2)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
          CALL ZGECPY ('T', M, N, A, LDAX, B, LDBX)
          IF (ISIGN .GE. 0) THEN
             IOPT = -1
           ELSE
             IOPT = 1
          ENDIF
          CALL ZFFTS (B, N, 1, M, LDBX, IOPT, IER)
          IF (IER .NE. 0) THEN
            CALL STOPGM('MLFFT_HP','ERROR IN CALL TO ZFFTS')
          ENDIF
          IF (ISIGN .GE. 0) THEN
             ASCALE = SCALE*DREAL(N)
           ELSE
             ASCALE = SCALE
          ENDIF
          IF (ASCALE .NE. 1.0D0) THEN
             DO I = 1,M
                CALL ZDSCAL(N, ASCALE, B(1,I), 1)
             ENDDO
          ENDIF
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        ELSE
c         CALL DCFT(1,A,LDAX,1,B,LDBX,1,N,M,ISIGN,SCALE,
c    *            AUX1,NAUX1,AUX2,NAUX2)
c         CALL DCFT(0,A,LDAX,1,B,LDBX,1,N,M,ISIGN,SCALE,
c    *            AUX1,NAUX1,AUX2,NAUX2)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
          CALL ZGECPY ('N', M, N, A, LDAX, B, LDBX)
          IF (ISIGN .GE. 0) THEN
             IOPT = -1
           ELSE
             IOPT = 1
          ENDIF
          CALL ZFFTS (B, N, LDBX, M, 1, IOPT, IER)
          IF (IER .NE. 0) THEN
            CALL STOPGM('MLFFT_HP','ERROR IN CALL TO ZFFTS')
          ENDIF
          IF (ISIGN .GE. 0) THEN
             ASCALE = SCALE*DREAL(N)
           ELSE
             ASCALE = SCALE
          ENDIF
          IF (ASCALE .NE. 1.0D0) THEN
             DO I = 1,N
                CALL ZDSCAL(M, ASCALE, B(1,I), 1)
             ENDDO
          ENDIF
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        ENDIF
      ENDIF
#endif
C     ==--------------------------------------------------------------==
      IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
        DO J=M+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
        DO J=1,M
          DO I=N+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ELSE
        DO J=N+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
        DO J=1,N
          DO I=M+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MLTFFT_X1(TRANSA,TRANSB,A,LDAX,LDAY,B,LDBX,LDBY,N,M,
     *                       ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER  TRANSA*1,TRANSB*1
      INTEGER    LDAX,LDAY,LDBX,LDBY,N,M,ISIGN
      COMPLEX*16 A(LDAX,LDAY),B(LDBX,LDBY)
      REAL*8     SCALE
C     Variables
      INTEGER    NMAX, MMAX
      PARAMETER (NMAX=100, MMAX=10000)
      INTEGER    NTAB,NWORK
      PARAMETER (NTAB=100+8*NMAX, NWORK=4*NMAX*MMAX)
      REAL*8     TABLE(NTAB), WORK(NWORK)
      INTEGER    ISIG,I,II,NLOT,J,NOW,JJ
      COMMON /X1FFTCOM/ TABLE, WORK
C     ==--------------------------------------------------------------==
#if defined(FFT_X1)
Cray  IF(2*N.GT.NTAB) CALL STOPGM('MLTFFT','TABLE TOO SMALL')
Cray  IF(4*N.GT.NWORK) CALL STOPGM('MLTFFT','NWORK TOO SMALL')
      ISIG=-ISIGN
      IF(TRANSA.EQ.'N'.OR.TRANSA.EQ.'n') THEN
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
Cray N-N
          CALL MZFFT
     &    (ISIG,N,M,SCALE,A,1,LDAX,B,1,LDBX,TABLE,NTAB,WORK,NWORK)
        ELSE
Cray N-T
          CALL MZFFT
     &    (ISIG,N,M,SCALE,A,1,LDAX,B,LDBX,1,TABLE,NTAB,WORK,NWORK)
        ENDIF
      ELSE
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
Cray T-N
          CALL MZFFT
     &    (ISIG,N,M,SCALE,A,LDAX,1,B,1,LDBX,TABLE,NTAB,WORK,NWORK)
        ELSE
Cray T-T
          CALL MZFFT
     &    (ISIG,N,M,SCALE,A,LDAX,1,B,LDBX,1,TABLE,NTAB,WORK,NWORK)
        ENDIF
      ENDIF
#endif
C     ==--------------------------------------------------------------==
      IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
        DO J=M+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
        DO J=1,M
          DO I=N+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ELSE
        DO J=N+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
        DO J=1,N
          DO I=M+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MLTFFT_SCSL(TRANSA,TRANSB,A,LDAX,LDAY,B,LDBX,LDBY,N,M,
     *                       ISIGN,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER  TRANSA*1,TRANSB*1
      INTEGER    LDAX,LDAY,LDBX,LDBY,N,M,ISIGN
      COMPLEX*16 A(LDAX,LDAY),B(LDBX,LDBY)
      REAL*8     SCALE
C     Variables
      INTEGER    ISYS(0:1)
      REAL*8     TABLE(2*N+256),WORK(2*N)
      COMPLEX*16 CONE,CZERO
      INTEGER    ISIG,I,J
C     ==--------------------------------------------------------------==
#if defined(FFT_SCSL)
      ISYS(0)=1
      CONE  = DCMPLX(1.0D0,0.0D0)
      CZERO = DCMPLX(0.0D0,0.0D0)
      ISIG=-ISIGN
      IF(TRANSA.EQ.'N'.OR.TRANSA.EQ.'n') THEN
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          CALL ZZFFTM(   0,N,M,SCALE,A,LDAX,B,LDBX,TABLE,WORK,ISYS)
          CALL ZZFFTM(ISIG,N,M,SCALE,A,LDAX,B,LDBX,TABLE,WORK,ISYS)
        ELSE
          CALL ZZFFTM(   0,N,M,SCALE,A,LDAX,A,LDAX,TABLE,WORK,ISYS)
          CALL ZZFFTM(ISIG,N,M,SCALE,A,LDAX,A,LDAX,TABLE,WORK,ISYS)
          CALL ZGESUM('T',M,N,CONE,A,LDAX,CZERO,B,LDBX)
        ENDIF
      ELSE
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          CALL ZGESUM('T',N,M,CONE,A,LDAX,CZERO,B,LDBX)
          CALL ZZFFTM(   0,N,M,SCALE,B,LDBX,B,LDBX,TABLE,WORK,ISYS)
          CALL ZZFFTM(ISIG,N,M,SCALE,B,LDBX,B,LDBX,TABLE,WORK,ISYS)
        ELSE
          CALL ZZFFTMR(   0,N,M,SCALE,A,LDAX,B,LDBX,TABLE,WORK,ISYS)
          CALL ZZFFTMR(ISIG,N,M,SCALE,A,LDAX,B,LDBX,TABLE,WORK,ISYS)
        ENDIF
      ENDIF
#endif
C     ==--------------------------------------------------------------==
      IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
!$OMP parallel do private (I,J)
        DO J=M+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
!$OMP parallel do private (I,J)
        DO J=1,M
          DO I=N+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ELSE
!$OMP parallel do private (I,J)
        DO J=N+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
!$OMP parallel do private (I,J)
        DO J=1,N
          DO I=M+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE MLTFFT_FFTW(TRANSA,TRANSB,A,LDAX,LDAY,B,LDBX,LDBY,N,M,
     *                       ISIGN,SCALE,USE_WISDOM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
C     Arguments
      CHARACTER  TRANSA*1,TRANSB*1
      INTEGER    LDAX,LDAY,LDBX,LDBY,N,M,ISIGN
      COMPLEX*16 A(LDAX,*),B(LDBX,*),ad(*),bd(*)
      pointer    (ip_a,ad), (ip_b,bd)
      REAL*8     SCALE
C     Variables
      LOGICAL   TSCAL,USE_WISDOM
      INTEGER   I,J
#ifdef POINTER8
      INTEGER*8   PLAN
#else
      INTEGER   PLAN
#endif
C     ==--------------------------------------------------------------==
#if defined(FFT_FFTW) || (FFT_FFTW2)
      integer FFTW_F,FFTW_B
      parameter (FFTW_F=-1,FFTW_B=1)
      integer FFTW_ES,FFTW_ME,FFTW_US
      parameter (FFTW_ES=0,FFTW_ME=1,FFTW_US=16)
      TSCAL=(ABS(SCALE-1.D0).GT.1.D-12)

      IF (USE_WISDOM) THEN
        IF (ISIGN.EQ.1) THEN
          CALL fftw_f77_create_plan(plan,n,FFTW_F,
     &        FFTW_ME+FFTW_US)
        ELSE
          CALL fftw_f77_create_plan(plan,n,FFTW_B,
     &        FFTW_ME+FFTW_US)
        ENDIF
      ELSE
        IF (ISIGN.EQ.1) THEN
          CALL fftw_f77_create_plan(plan,n,FFTW_F,FFTW_ES)
        ELSE
          CALL fftw_f77_create_plan(plan,n,FFTW_B,FFTW_ES)
        ENDIF
      ENDIF
      IF(TRANSA.EQ.'N'.OR.TRANSA.EQ.'n') THEN
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          CALL fftw_f77(plan,m,a,1,ldax,b,1,ldbx)
          IF(TSCAL) THEN
C$OMP parallel do private(I,J)
            DO I = 1,M
              DO J = 1,N
                B(J,I)=SCALE*B(J,I)
              ENDDO
            ENDDO
          ENDIF
        ELSE
          CALL fftw_f77(plan,m,a,1,ldax,b,ldbx,1)
          IF(TSCAL) THEN
C$OMP parallel do private(I,J)
            DO I = 1,N
              DO J = 1,M
                B(J,I)=SCALE*B(J,I)
              ENDDO
            ENDDO
          ENDIF
        ENDIF
      ELSE
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          CALL fftw_f77(plan,m,a,ldax,1,b,1,ldbx)
          IF(TSCAL) THEN
C$OMP parallel do private(I,J)
            DO I = 1,M
              DO J = 1,N
                B(J,I)=SCALE*B(J,I)
              ENDDO
            ENDDO
          ENDIF
        ELSE
          CALL fftw_f77(plan,m,a,ldax,1,b,ldbx,1)
          IF(TSCAL) THEN
C$OMP parallel do private(I,J)
            DO I = 1,N
              DO J = 1,M
                B(J,I)=SCALE*B(J,I)
              ENDDO
            ENDDO
          ENDIF
        ENDIF
      ENDIF
      CALL fftw_f77_destroy_plan(plan)

#elif defined(FFT_FFTW3)
      INTEGER FFTW_F,FFTW_B,FFTW_DIR,FFTW_FLAGS
      PARAMETER (FFTW_B=1,FFTW_F=-1)
      INTEGER FFTW_ES,FFTW_ME,FFTW_PA
      PARAMETER (FFTW_ES=64,FFTW_ME=0,FFTW_PA=32)
      TSCAL=(ABS(SCALE-1.D0).GT.1.D-12)
      IF (ISIGN.EQ.1) THEN
        FFTW_DIR=FFTW_F
      ELSE
        FFTW_DIR=FFTW_B
      ENDIF
      IF (USE_WISDOM) THEN
        FFTW_FLAGS=FFTW_ME
      ELSE
        FFTW_FLAGS=FFTW_ES
      ENDIF

      IF(TRANSA.EQ.'N'.OR.TRANSA.EQ.'n') THEN
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          CALL dfftw_plan_many_dft(plan,1,n,m,a,n,1,ldax,b,n,1,ldbx,
     &        FFTW_DIR,FFTW_FLAGS)
          CALL dfftw_execute(plan)
          IF(TSCAL) THEN
C$OMP parallel do private(I,J)
            DO I = 1,M
              DO J = 1,N
                B(J,I)=SCALE*B(J,I)
              ENDDO
            ENDDO
          ENDIF
        ELSE
          CALL dfftw_plan_many_dft(plan,1,n,m,a,n,1,ldax,b,n,ldbx,1,
     &        FFTW_DIR,FFTW_FLAGS)
          CALL dfftw_execute(plan)
          IF(TSCAL) THEN
C$OMP parallel do private(I,J)
            DO I = 1,N
              DO J = 1,M
                B(J,I)=SCALE*B(J,I)
              ENDDO
            ENDDO
          ENDIF
        ENDIF
      ELSE
        IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
          CALL dfftw_plan_many_dft(plan,1,n,m,a,n,ldax,1,b,n,1,ldbx,
     &        FFTW_DIR,FFTW_FLAGS)
          CALL dfftw_execute(plan)
          IF(TSCAL) THEN
C$OMP parallel do private(I,J)
            DO I = 1,M
              DO J = 1,N
                B(J,I)=SCALE*B(J,I)
              ENDDO
            ENDDO
          ENDIF
        ELSE
          CALL dfftw_plan_many_dft(plan,1,n,m,a,n,ldax,1,b,n,ldbx,1,
     &        FFTW_DIR,FFTW_FLAGS)
          CALL dfftw_execute(plan)
          IF(TSCAL) THEN
C$OMP parallel do private(I,J)
            DO I = 1,N
              DO J = 1,M
                B(J,I)=SCALE*B(J,I)
              ENDDO
            ENDDO
          ENDIF
        ENDIF
      ENDIF
      CALL dfftw_destroy_plan(plan)
#endif
      IF(TRANSB.EQ.'N'.OR.TRANSB.EQ.'n') THEN
!$OMP parallel do private (I,J)
        DO J=M+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
!$OMP parallel do private (I,J)
        DO J=1,M
          DO I=N+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ELSE
!$OMP parallel do private (I,J)
        DO J=N+1,LDBY
          DO I=1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
!$OMP parallel do private (I,J)
        DO J=1,N
          DO I=M+1,LDBX
            B(I,J)=DCMPLX(0.0D0,0.0D0)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
