C     ==================================================================
      SUBROUTINE mm_cpmd_esp_charges_f77 (TAU0,C0,
     *                                    ACHARGE,RHOE,V,SCR,LSCR)
C     This routine calculates the ESP charges from the current wavefunction
C
C     This is a butchered copy of INTERFACE_WRITE from EGO_INTERFACE
C
C     TAU0 - current atomic coordinates passed from CPMD
C     C0 - current wavefunction expansion coefficients pass from CPMD
C     SCR - scratch space          
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'epot.inc'
      INCLUDE 'efld.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'dipo.inc'
      INCLUDE 'lodp.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    LSCR
      REAL*8     TAU0(3,NAX,NSX),SCR(LSCR),ACHARGE(*),RHOE(*)
      COMPLEX*16 C0(*),V(*)
C     Variables
      INTEGER    ISEL(*)
      REAL*8     EFIELD(*),EXTF
      POINTER    (IP_ISEL,ISEL),(IP_EFIELD,EFIELD)
      COMPLEX*16 EIROP(NHG),EIVPS(NHG),VTEMP(NHG),QPHI(*)
      POINTER    (IP_EIROP,EIROP),(IP_EIVPS,EIVPS),(IP_VTEMP,VTEMP),
     &           (IP_QPHI,QPHI)
      INTEGER    I,IG,MLEN,IPPC
C     ==--------------------------------------------------------------==
      CALL AZZERO(ACHARGE,NAT)
C
C     SCR partition
      CALL GET_ADDR(IP_VTEMP,SCR(1))
      CALL GET_ADDR(IP_EIVPS,SCR(2*NHG+1))
      CALL GET_ADDR(IP_EIROP,SCR(4*NHG+1))
      CALL GET_ADDR(IP_QPHI,SCR(6*NHG+1))
C
      IF(TIVAN) CALL RNLSM(C0,N,V,SCR,LSCR,1,1,.FALSE.)
      CALL RHOOFR(C0,RHOE,V,SCR,LSCR,N)
      CALL EICALC(EIVPS,EIROP)
!$OMP parallel do private(I)
      DO I=1,NNR1
        V(I)=DCMPLX(RHOE(I),0.D0)
      ENDDO
      CALL FWFFT(V)
!$OMP parallel do private(IG)
      DO IG=1,NHG
        VTEMP(IG) = V(NZH(IG))
      ENDDO
      CALL ELSTPO(VTEMP,EIROP,EIVPS,V,QPHI,TAU0)
      CALL DCOPY(2*NHG,V,1,VTEMP,1)
      CALL AZZERO(V,2*MAXFFT)
      DO IG=1,NHG
        V(INDZ(IG)) = DCONJG(VTEMP(IG))
        V(NZH(IG))  = VTEMP(IG)
      ENDDO
      IF(GEQ0.AND.TCLUST) THEN
        V(NZH(1)) = VTEMP(1)
      ELSEIF(GEQ0) THEN
        V(NZH(1)) = DCMPLX(0.D0,0.D0)
      ENDIF
      CALL INVFFT(V)
!$OMP parallel do private(I)
      DO I=1,NNR1
        RHOE(I)=DREAL(V(I))
      ENDDO
      MLEN=NNR1/IRAT + 1
      IPPC=0
      CALL MEMORY(IP_ISEL,MLEN,'ISEL')
      CALL SELECTP(ISEL,TAU0,IPPC)
      MLEN=(NAT+1)*IPPC
      CALL MEMORY(IP_EFIELD,MLEN,'EFIELD')
!$OMP parallel do private(I)
      DO I=1,IPPC
        EFIELD(I)=RHOE(ISEL(I))
      ENDDO
      CALL ATFIELD(EFIELD,V,VTEMP,EIROP,QPHI,ISEL,IPPC)
      CALL ESPSOLV(EFIELD,ACHARGE,IPPC)
      CALL FREEM(IP_ISEL)
      CALL FREEM(IP_EFIELD)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
