C     ==================================================================
      SUBROUTINE mm_cpmd_ext_pot_f77 
C     ----------------------------------------------------------------== 
C     This routine adds an external potential due to the MM charges
C     on the real space grid of the QM box.
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'

      INCLUDE 'epot.inc'
      INCLUDE 'efld.inc'
      INCLUDE 'cell.inc'

      LOGICAL first_time
      SAVE first_time
      DATA first_time /.true./
      INTEGER IX,IX2,IY,IZ,icoupling_model
      REAL*8 XM,YM,ZM,DX,DY,DZ,R_POT
      REAL*8 EXTF(KR1,KR2S,KR3S)

C     ==--------------------------------------------------------------==
#if defined (__QMECHCOUPL)

      call mm_cpmd_elstat_get_setting(icoupling_model)

      if(icoupling_model .lt.2) return

      if (first_time) then
        first_time = .false.
        CALL MEMORY(IP_EXTF,KR1*KR2S*KR3S,'EXTF')
      end if
      CALL AZZERO(EXTF,KR1*KR2S*KR3S)

!     -------------------------------------------------
!     define the grid spacings for X,Y and Z directions
!     -------------------------------------------------
      DX=CELLDM(1)/DBLE(NR1S)
      DY=CELLDM(2)/DBLE(NR2S)*CELLDM(1)
      DZ=CELLDM(3)/DBLE(NR3S)*CELLDM(1)

!     ----------------------------------------------------------
!     ZM, YM, XM are the Cartesian coordinates of the grid point
!     in atomic units
!     ----------------------------------------------------------

      DO IZ=1,KR3S
        ZM=DBLE(IZ-1)*DZ
        DO IY=1,KR2S
          YM=DBLE(IY-1)*DY
          DO IX=NRXPL(MEPOS,1),NRXPL(MEPOS,2)
            XM=DBLE(IX-1)*DX
            IX2 = IX-NRXPL(MEPOS,1)+1
            call mm_cpmd_elstat_get_pot(XM,YM,ZM,R_POT)

            EXTF(IX2,IY,IZ)=R_POT

          ENDDO
        ENDDO
      ENDDO

#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C
