       subroutine mm_dim(ch,stat)

       implicit none
       INCLUDE 'system.h'
       INCLUDE 'tpar.inc'
       INCLUDE 'ions.inc'
       INCLUDE 'mm_dim.inc'
       INCLUDE 'mm_input.inc'

       character*9 mm_go_flag(3)
       data mm_go_flag /'mm_go_qm ','mm_go_mm ','mm_revert'/

C      this routine modifies NA(*) and NSP in ions.inc for QM and MM ordering
C      available options for 'ch': mm_go_qm, mm_go_mm, mm_revert
C      on exit 'stat' contains the previous state (= value of mm_stat)
C      mm_stat=.true. stands for QM, mm_stat=.false. for MM dimensions.
C      for mm_revert the value of 'stat' determines the action.

       integer is,ch,act
       logical stat

       if(qmmm_verbose.and.parent) then
         write(6,*) 'MM_DIM| called with: ', mm_go_flag(ch)
         if(mm_stat) then
           write(6,*) 'MM_DIM| old status : QM'
         else
           write(6,*) 'MM_DIM| old status : MM'
         endif
       endif

C      nothing to do unless we have a QM/MM calculation
       if(.not.tqmmm)return
       if(.not.qmmm)return

C      copy the action flag to a local variable in 
C      case ch points to a read-only location
       act=ch

C      revert to previous state
       if(act.eq.mm_revert) then
         if(stat) then
           act=mm_go_qm
         else
           act=mm_go_mm
         endif
       endif

C      record previous state
       stat=mm_stat

       if(act.eq.mm_go_qm)then
         mm_stat=.true.
         NSX=NSPq
         NSP=NSPq
         NAT=0
         do is=1,NSPq
           NA(is)=NAq(is)
           NAT=NAT+NA(is)
         enddo
         if (classical) then
           NSX=0
           NSP=0
           NAT=0
!$OMP parallel do private(is)
           do is=1,NSPq
             NA(is)=0
           enddo
         endif
       else if(act.eq.mm_go_mm) then
         mm_stat=.false.
         NSX=NSPm
         NSP=NSPm
         NAT=0
         do is=1,NSPm
           NA(is)=NAm(is)
           NAT=NAT+NA(is)
         enddo
       else
         if (parent) write(6,*) 'selector =', act
         call stopgm('MM_DIM','illegal flag in mm_dim')
       endif

       if(qmmm_verbose.and.parent) then
         if(mm_stat) then
           write(6,*) 'MM_DIM| new status : QM'
         else
           write(6,*) 'MM_DIM| new status : MM'
         endif
       endif

       return
       end

C write current state to output.
       subroutine mm_dim_query(tag)
       include 'system.h'
       include 'mm_dim.inc'

       character*(*) tag

       if(parent) then
         if(mm_stat) then
           write(6,*) 'MM_DIM| current status : QM| ', tag
         else
           write(6,*) 'MM_DIM| current status : MM| ', tag
         endif
       endif
       return
       end
