C     ==================================================================
      SUBROUTINE mm_forcematch(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'andr.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'store.inc'
      INCLUDE 'fileopen.inc'
c     Qmmm
      real*8 EXTF(*)
      include 'efld.inc'
      include 'mm_dim.inc'
      include 'mm_input.inc'
C_FM[
      include 'forcematch.inc'
C      INCLUDE 'mm_extrap.inc'
C_FM]
c     Qmmm locals
      real*8  VCM(3),PMA00
      integer im,is,ia,ix
      REAL*8  c_trans(3)
      INTEGER IN,OUT
      real*8  EHAM_0
      integer k

C     Arguments
      COMPLEX*16 C0(NGWK,N,*),C2(NGWK,*),C1(*),CM(*),SC0(NGW,*)
      REAL*8     VPP(*),GAMX(*),GAMY(*)
C     Variables
      DIMENSION  F(N,*),RIN0(*),RK(3,*),WK(*)
      REAL*8     TAUI(3,NAX,*),TAUR(3,NAX,*),EIGV(N,*),
     &           RM1(*),RINP(*)
      POINTER    (IP_TAUI,TAUI),(IP_TAUIO,TAUIO),(IP_TAUR,TAUR),
     &           (IP_EIGV,EIGV),(IP_RM1,RM1),(IP_RINP,RINP)
      COMPLEX*16 PSI(NNR1,*)
      REAL*8     RHOE(NNR1,*),SCR(*),TAUIO(3,*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
      CHARACTER  TAG*30
      REAL*8     TIMEF,TIME1,TIME2,DUMMY,LMIO(3),VCMIO(4),RMEM,
     &           ECONS,EKINP,EKINCP,DISA,ENOSE,ENOSP,EKIN1,EKIN2,
     &           TEMP1,TEMP2,TEMPP,TCPU,EKINH1,EKINH2,EKINC
      EXTERNAL   TIMEF
      INTEGER    IREC(100),IFCALC,NX,IK,NNX,NMIN,LENEXT,
     &           LSCR,IL_RHOE,IL_PSI
      CHARACTER FILEN*100
      LOGICAL    FERROR,TESTSTORE
      INTEGER    MSGLEN,ITEMP,NMM
      INTEGER    SAVE_NFI,LOOPNFI,NFIMIN,NFIMAX
      logical    oldstatus,statusdummy
      integer    nstate
      real*8     sk1
      character*10 prch
C_FM[
      logical status,ex
      character*500 dummyline
      integer   l,i,iqm
      integer   stride_indx,check_ref_traj_indx
      integer   skipped_frames_reftraj,nframes_ref_traj
      integer   iframe,nframes, nr_nn_max, nr_qm,nr_qm_prev
      integer   iats,no_frames_extract
      real*8    mm_epot
      integer,  allocatable ::  nr_nn(:), equiv(:), qm_indx(:)
      real*8,   allocatable ::  r_nn(:,:,:), v_nn(:,:),f_nn(:,:,:)
      real*8,   allocatable ::  r_qm(:,:,:), f_qm(:,:,:)
      real*8,   allocatable ::  f_qm_ref(:,:,:)
      real*8,   allocatable ::  q_hirshfeld(:), q_opt(:)
      real*8,   allocatable ::  mm_FION(:,:,:), f_fit_err(:,:,:)
      real*8    gr_tau(3,*)
      POINTER   (ip_gr_tau,gr_tau)
      real*8    rms, rms_rel
C parameters
      integer, parameter ::     fm_iou = 120
      integer, parameter ::     fm_cfu = 121


#if defined (__GROMOS)
      call mm_dim(mm_go_mm,status)
      call memory (ip_gr_tau,nat*3,'gr_tau')   
      ex=.false.
C_FM]
C check if we need to compute reference forces
      if (fm_compute_traj) then
        if (parent) then
          write(6,'(A)') '  fm  =============== ERROR ================='
          write(6,'(A)') '  fm  Computing a reference trajectory is '
          write(6,'(A)') '  fm  not implemented!'
          write(6,'(A)') '  fm  =============== ERROR ================='
          call STOPGM('mm_forcematch','Computing reference trajectory '
     $               // 'not yet implemented!')
        endif
      elseif (fm_read_forces) then
        goto 666
      elseif (fm_compute_sp) then
        continue
      else 
        call STOPGM('mm_forcematch', 'I do not know what to do')
      endif
C_FM]
C   
      TIME1 = TIMEF()
      call mm_dim(mm_go_mm,oldstatus)
C
      NSTATE=N
      IF (QMNODE) THEN
        if(TEXTFLD)then
          CALL MEMORY(IP_EXTF,KR1*KR2S*KR3S,'EXTF')
          CALL AZZERO(EXTF,KR1*KR2S*KR3S)
        endif
C       Memory for densities
        NNX=NNR1*NLSD
        CALL MEMORY(IP_RIN0,NNX,'RIN0')
        CALL MEMORY(IP_ROUT0,NNX,'ROUT0')
        CALL MEMORY(IP_RMIX,NNX,'RMIX')
        CALL MEMORY(IP_RM1,NNX,'RM1')
        CALL MEMORY(IP_RINP,NNX,'RINP')
        IP_RHOO=IP_RIN0
        CALL AZZERO(RIN0,NNX)
        CALL AZZERO(ROUT0,NNX)
        CALL AZZERO(RMIX,NNX)
        NACC = 22
        NFI  = 0
        MODENS=.FALSE.
        ENGPRI=.FALSE.
        CALSTE=TPRES
C
        IF(TQMMM.AND.TIVAN) THEN
         CALL STOPGM('MM_FORCEMATCH','QMMM WITH VANDERBILT UNSUPPORTED')
        ENDIF
        CALL MEMORY(IP_EIGV,NLSD*N*NKPTS,'EIGV')
C       SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
        CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
        CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
        NMM=1
        NMM=NMM*IL_PSI
        CALL MEMORY(IP_PSI,NMM,'PSI')
        if (qmmm) then
         CALL GIVE_SCR_MM_MDDIAG(LSCR,TAG)
        else
         CALL GIVE_SCR_MDDIAG(LSCR,TAG)
        endif
        CALL MEMORY(IP_SCR,LSCR,'SCR')
      ELSE
        NMIN=10
        CALL MEMORY(IP_EIGV,NMIN,'EIGV')
        CALL GIVE_SCR_MDDIAG(LSCR,TAG)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
      ENDIF ! qmnode
C     ==--------------------------------------------------------------==
      NFNOW=1
C     ==--------------------------------------------------------------==
      call mm_dim(mm_go_mm,statusdummy)
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TAUI,3*NAX*NSX,'TAUI')
      CALL MEMORY(IP_TAUR,3*NAX*NSX,'TAUR')
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_TAUIO,3*NAT,'TAUIO')

      call azzero(FION,3*NAX*NSX)
      call azzero(TAUI,3*NAX*NSX)
      call azzero(TAUP,3*NAX*NSX)
C     show sizes of the individual MPI-threads.
C     use barriers so that the output is not garbled.
      call my_sync(QMMMGRP)
      if(qmmm_verbose) then
        do k=0,nproc
          if(mmparent) then
            write(prch,'(a10)') ' MMPARENT '
          else 
            write(prch,'(a5,i5)')' QM-N',me
          endif
          if(k.eq.me) call prmem(prch)
          call my_sync(QMMMGRP)
        end do
      endif
      if (parent.and.n_cg.ge.1)
     &     CALL FILEOPEN(40,'restrain.out',FO_APP,FERROR)
C
C     ==--------------------------------------------------------------==
      call mm_dim(mm_go_mm,statusdummy)
      if (qmnode ) then
        IF(IPRINT_STEP.EQ.0) IPRINT_STEP=NOMORE+1
C       ==--------------------------------------------------------------==
C       Set IREC to restart file.
        CALL READ_IREC(IREC)
C       INITIALIZATION OF WAVEFUNCTION AND COORDINATES
        CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
cmb-bug
        IF(parent) CALL dcopy(3*nax*nsx,taup,1,taui,1)
cmb-bug
C     ==--------------------------------------------------------------==
C       Dont symmetrize density
        TSYMRHO=.FALSE.
C..Make sure TKFULL=.TRUE
        IF(TKPNT.AND.(.NOT.TKFULL)) THEN 
          WRITE(6,*) 
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
          WRITE(6,*) 
     & ' WARNING!  USE KPOINTS FULL  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
          WRITE(6,*) 
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        ENDIF

C     ==--------------------------------------------------------------==
C 28/3/03 added
        call mm_dim(mm_go_qm,statusdummy)
        call phfac(TAU0)
        if(tinlc) call copot(rhoe,psi,scr,lscr,calste)
        call mm_dim(mm_go_mm,statusdummy)
        CALL AZZERO(CM,2*NGW*NSTATE)
C 28/3/03
        IF(classical) CALL AZZERO(CM,2*NGW*NSTATE)
C       INITIALIZE FORCES
        call mm_dim(mm_go_qm,statusdummy)
        IF(TDIAG) THEN
          IF(TLANC) NX=1
          IF(TDAVI) NX=NGWK*NDAVV*NKPNT+1
          IF(DIIS)  NX=((NGWK*N+8)*MDIIS*NKPNT)/4
        ELSEIF(TSDE) THEN
            NX=1
        ELSEIF(DIIS) THEN
            NX=(NGWK*N+8)*MDIIS/2+4
        ELSEIF(PCG) THEN
            NX=1
        ENDIF
        IF(PARENT) THEN
          WRITE(6,'(1X,64("="))')
          WRITE(6,'(1X,"==",T25,A,T64,"==")')
     &         'FORCES INITIALIZATION'
          WRITE(6,'(1X,64("="))')
        ENDIF
        IFCALC=0
      endif ! (qmnode)

      CALL mm_dim(mm_go_mm,statusdummy)
      IF ( parent ) THEN
         CALL mm_write_gromos_coord('CRD_INI.g96',TAU0,VELP,NAX,NSX)
      ENDIF

      CALL MY_SYNC(QMMMGRP)
C
      if (qmnode) then
        call mm_dim(mm_go_mm,statusdummy)
        CALL DCOPY(NNX,RIN0(1),1,RM1(1),1)
        IF(PARENT) THEN
          WRITE(6,'(1X,64("="))')
          WRITE(6,'(1X,"==",T20,A,T64,"==")')
     &         'END OF FORCES INITIALIZATION'
          WRITE(6,'(1X,64("="),/)')
        ENDIF
        call mm_dim(mm_go_mm,statusdummy)
        IF(PARENT) THEN
C_FM[
          ECONS=ETOT
C_FM]
          TIME2 = TIMEF()
          TCPU = (TIME2 - TIME1)*0.001D0
          WRITE(6,'(A,T50,F8.2,A8)') ' TIME FOR INITIALIZATION:',
     &       TCPU,' SECONDS'
          WRITE(6,'(//,1X,64("="))')
        ENDIF
      endif ! (qmnode)
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
C_FM[ preparation for the SP
      IF(PARENT) THEN
          WRITE(6,'(A)')
     c'  fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm'
        write(6,'(A)') '  fm '
        WRITE(6,'(A,i8)') '  fm TOTAL NR OF ATOMS ',NATm
        WRITE(6,'(A,i8)') '  fm NR QM ATOMS ',NATq
      END IF

      IF(PARENT) THEN
        if (fm_ref_traj_stride.le.0) 
     $    call STOPGM('mm_forcematch', 'TRAJECTORY STRIDE IS <= 0!')
        call my_flush(6)
C       count number of frames in ref_traj file
        nframes_ref_traj=0        
        call count_nframes_ref_traj(NATm,nframes_ref_traj)
        write(6,'(A)') '  fm AFTER COUNTING FRAMES'
        write(6,'(A,i8)') '  fm no frames in traj ref file: ',
     &                    nframes_ref_traj
        write(6,'(A,i8)') '  fm applying stride: ',fm_ref_traj_stride
C        
C       for a fm restart: determine the frame index where to start
C       and calculate the number of frames to extract accordingly
C
        if (fm_sp_restart) then

           write(6,'(A)') '  fm '
           write(6,'(A)') '  fm restart of the SP calculations'
           write(6,'(A)') '  fm FM_REF* files will be appended'
           write(6,'(A)') '  fm '
C         this subroutine goes through all the frames already present in 
C         the ref_forces file
C         for each frame it tries to find the corresponding frame in the 
C         ref_traj file and counts the number of frames we can skip when
C         reading the ref_traj file before we can begin with the SP_RESART
C         run
           skipped_frames_reftraj=0
           call sp_rest_count_skip_ref_traj(NATq,NATm,
     &                                      skipped_frames_reftraj)
           no_frames_extract=
     &      INT((nframes_ref_traj-skipped_frames_reftraj)/
     &      fm_ref_traj_stride)           
        else
           no_frames_extract=INT(nframes_ref_traj/fm_ref_traj_stride)
        end if !fm_sp_restart
        write(6,'(A,i8)') 
     &        '  fm extracting total number of frames for SPs: ',
     &              no_frames_extract
        write(6,'(A)') '  fm '
        WRITE(6,'(A)')
     &'  fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm fm'
        if (no_frames_extract .le. 0) then
          write(6,'(A)') '  fm not sufficient frames to extract'
          goto 311
        end if  
      ENDIF !parent
C     check whether number of frames, number of lines and
C     number of atoms are consistent          
C     not implemented yet
      call my_flush(6) 
      CALL MY_SYNC(QMMMGRP)
      MSGLEN = 8 / IRAT
      CALL MY_BCAST(no_frames_extract,MSGLEN,SOURCE,ALLGRP)
      IF(PARENT) then
           call FILEOPEN(fm_iou,fm_ref_traj_filename,FO_OLD,ferror)
        if ( fm_sp_restart) THEN
C
C          go to the end of the last frame that had been written to 
C          the fm_ref_forces file
C
           do iframe=1,skipped_frames_reftraj
              do iats=1,NATm
                 read(fm_iou,'(A500)') dummyline
C
C                jump over "NEW DATA" marks
C
                 IF (INDEX(dummyline,'NEW DATA') .NE. 0) THEN
                    write(6,'(A,A,i8)') 
     &                     '  fm (reading skipped frames)',
     &                     ' NEW DATA mark after frame ',iframe-1
C                   actually, the NEW DATA mark should not be inside
C                   one frame
                    IF (iats .gt. 1) then
                       write(6,'(A)') 
     &                '  fm NEW DATA mark in the middle of frame'
                       goto 311
                    END IF   
C                   just read an additional line            
                    read(fm_iou,'(A500)',end=311,err=311) dummyline
                  END IF
              end do !NATm
           end do !skipped frames  
        end if !fm sp restart  
      END IF !parent
C     ==--------------------------------------------------------------==
C     == LOOP OVER THE FRAMES TO COMPUTE SPs                          ==
C     ==--------------------------------------------------------------==
C
C     this is going to hold the labels for the individual frames
C     extracted from the reference trajectory file
C     in principle only parent has to know about this
      fm_frame_indx = 0
      DO l=1,no_frames_extract
        IF (PARENT) THEN
C         jump over the stride        
         do stride_indx=1,fm_ref_traj_stride-1
           do iats=1,NATm
              read(fm_iou,'(A500)',end=311,err=311) dummyline
C
C          jump over "NEW DATA" marks
C
C           write(6,*) 'before NEW DATA check'
              IF (INDEX(dummyline,'NEW DATA') .NE. 0) THEN
                 write(6,'(A,i8)') 
     &           '  fm (reading stride) NEW DATA mark after frame ',l-1
                 write(6,'(A,i8)') '  fm stride index ',stride_indx
C                actually, the NEW DATA mark should not be inside
C                one frame
                 IF (iats .gt. 1) then
                    write(6,'(A)') 
     &            '  fm NEW DATA mark in the middle of frame'
                    goto 311
                 END IF   
C                just read an additional line            
                 read(fm_iou,'(A500)',end=311,err=311) dummyline
              END IF
            end do ! no of atoms
          end do !stride
C         now read the frame
          do iats=1,NATm
            read(fm_iou,'(A500)',end=311,err=311) dummyline
C
C          jump over "NEW DATA" marks
C
            IF (INDEX(dummyline,'NEW DATA') .NE. 0) THEN
              write(6,'(A,i8)') '  fm found NEW DATA mark in frame ',l
C             actually, the NEW DATA mark should not be inside
C             one frame
              IF (iats .gt. 1) then
                 write(6,'(A)') 
     &           '  fm NEW DATA mark in the middle of frame' 
                 goto 311
              END IF   
C             just read an additional line            
              read(fm_iou,'(A500)',end=311,err=311) dummyline
            END IF
            read(dummyline,*,err=311) fm_frame_indx,
     &                     (gr_tau(k,iats),k=1,3)
            if (iats .eq. 1) then 
             write(6,*)
             write(6,'(A)') '  fm '
             write(6,'(A,i8)') '  fm  frame number: ', l
             write(6,'(A,i8)') '  fm  frame index:  ', fm_frame_indx
             write(6,'(A)') '  fm '
            end if
C            write(6,*) (gr_tau(k,iats),k=1,3)             
          end do !loop over all the atoms in the current frame
C         read trajectory file as it's being written by printp
C         in gromos ordering
C         convert to cpmd ordering
          I=0
          DO IS=1,NSPm
           DO IA=1,NAm(IS)
             I=I+1
             DO K=1,3
               TAU0(K,IA,IS)=gr_tau(k,nat_grm(I))
             ENDDO
           ENDDO
          ENDDO
         END IF !PARENT     
         CALL mm_dim(mm_go_mm,statusdummy)
         CALL MY_SYNC(QMMMGRP)
C
c        compute reference forces
         if (parent) then
           write(6,*) 
           write(6,'(A)') '  fm '
           write(6,'(A)') '  fm  computing reference forces'
           write(6,'(A)') '  fm '
         end if   
         MSGLEN = 3*NAX*NSX * 8
         CALL MY_BCAST(TAU0,MSGLEN,SOURCE,QMMMGRP)
         CALL mm_translate_qmmm(TAU0,C0,CM,NSTATE)

         if(qmnode) then
         call mm_dim(mm_go_qm,statusdummy)
C We re-initialize the wavefunction, because atomic wavefunctions seem to
C provide a better initial guess than the wfn from the previous step
C (the timestep between frames might be very large)
C Let the user decide
         if (fm_rinit_wf) then
           if (parent) then
               write(6,*) 
               write(6,'(A)') '  fm '
               write(6, '(A)') 
     &                 '  fm  Re-initializing wavefunction'
               write(6,'(A)') '  fm '
               write(6,*) 
           end if
           CALL RINITWF(C0,CM,SC0,NSTATE,TAU0,TAUP,RHOE,PSI,SCR,LSCR)
         endif
         CALL PHFAC(TAU0)
c        no nonlinear core correction
         IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,CALSTE)
         call mm_dim(mm_go_mm,statusdummy)
        endif ! (qmnode)
        CALL MY_SYNC(QMMMGRP)
        if (parent) then
            write(6,*) 
            write(6,'(A)') '  fm '
            write(6, '(A)') '  fm  calling forces' 
            write(6,'(A)') '  fm '
            write(6,*)
        end if    
        CALL mm_forces_diag(N,C0,C1,C2,CM,SC0,CM(NX),VPP,EIGV,
     &                    RHOE,PSI,SCR,LSCR,
     &                    TAU0,VELP,TAU0,FION,IFCALC,
     &                    IREC,.TRUE.,.FALSE.)
        CALL mm_dim(mm_go_mm,statusdummy)
        if (parent) then
          CALL WRENER
          CALL WRGEOF(TAU0,FION)
          write(6,'(A)') '  fm  ----------------------------------'
          write(6,'(A, i8)') '  fm  Total nr. of iterations: ',
     $                       IFCALC
          write(6,'(A)') '  fm  ----------------------------------'
          write(6,*)
C
C       here append the forces of the new frame to the output file
C       append NN atoms
C        CALL mm_dim(mm_go_mm,statusdummy)
          call fileopen(63,fm_forces_ref_filename,FO_APP,FERROR)
          write(63,'(5X,I9,1x,I9)') fm_frame_indx,NATq
          I=0
          DO IS=1,NSPq
             DO IA=1,NAq(IS)
                I=I+1
                WRITE(63,'(1X,I3,1X,3(E16.8),1X,3(E16.8))')
     &            I,
     &           (TAU0(K,IA,IS),K=1,3),(FION(K,IA,IS),K=1,3)
             ENDDO
           ENDDO
           call fileclose(63)
         end if ! parent 
C        
C        append NN atoms: this is done by mm_elstat!
C
      ENDDO !loop over reference frames 
      if (parent) call FILECLOSE(fm_iou)
      CALL MY_SYNC(ALLGRP)
C     ==--------------------------------------------------------------==
C     == END LOOP OVER THE FRAMES                                     ==
C     ==--------------------------------------------------------------==
C
666   continue
C_FM[
C FORCE MATCHING -------------------------------------------
      if (parent) then
        if (fm_read_forces.or.fm_compute_sp) then     
C determine nr of frames, max nr of NN atoms and nr of QM atoms from
C TRAJECTORY_PIP
          if (fm_fit_charges) then 
            write(6, '(A)') 
     &             '  fm fm fm fm fm fm fm fm fm fm fm fm fm fm'
            write(6, '(A)') '  fm  Reading values for charge fitting '
     $                      // 'from file'
            call fm_get_size_of_qfit_arrays(nframes, nr_nn_max, nr_qm)  
          else
           write(6, *)
           write(6,'(A)') '  fm Reading NR QM atoms, frames from file'
C determine nr of frames and nr of QM atoms from FM_REF_FORCES
           CALL FILEOPEN(63,fm_forces_ref_filename,FO_OLD,FERROR)
           nframes=0
           nr_qm_prev=0
           do
              read(63,*,end=3192,err=318) fm_frame_indx,nr_qm
C              write(6,*) fm_frame_indx
              if ((nframes > 0) .and. (nr_qm /= nr_qm_prev)) then
                 call STOPGM('mm_forcematch', 'inconsistent nr of qm'
     &            //'atoms in FORCES FILE')
              end if   
              nr_qm_prev=nr_qm
              do iats=1,nr_qm
                   read(63,'(A500)',end=318,err=318) dummyline
              end do
              nframes=nframes+1
           end do   
3192           continue             
             nr_nn_max=1
             write(6,'(A,i8)') ' fm  nr of qm atoms: ',nr_qm
             write(6,'(A,i8)') ' fm  nr of frames: ',nframes
C             call fm_get_nframes_natoms(nframes,nr_qm)
          end if   
          allocate(nr_nn(nframes))
          allocate(r_qm(3, nr_qm, nframes))
          allocate(f_qm(3, nr_qm, nframes))
          allocate(f_qm_ref(3, nr_qm, nframes))
          allocate(r_nn(3, nr_nn_max, nframes))
          allocate(v_nn(nr_nn_max, nframes))
          allocate(f_nn(3, nr_nn_max, nframes))
          allocate(q_hirshfeld(nr_qm))
          allocate(q_opt(nr_qm))
          allocate(equiv(nr_qm))
          allocate(qm_indx(nr_qm))
C set up equivalencies in CPMD numbering
          call fm_setup_cpmd_equiv(nr_qm)
C now fill the arrays
          call fm_read_ref_forces(nframes, nr_nn_max, nr_nn, r_nn, 
     $                            v_nn, f_nn, nr_qm, r_qm, f_qm,
     $                            q_hirshfeld)
C fit charges if requested
          if (fm_fit_charges) then
            call qfit(nframes, nr_nn_max, nr_nn, r_nn, v_nn, f_nn, 
     $                nr_qm, r_qm, q_hirshfeld, equiv, q_opt)
          end if !fit charges
C for now assume all QM atoms are fitted
          do k = 1, nr_qm
            qm_indx(k) = k
          enddo
          if (fm_fit_charges) then 
             call fm_update_topo_charges(nr_qm, qm_indx, q_opt)
          end if
          if (fm_charges_only) then 
             call fm_writeout_topo('QFIT.top')
             CALL STOPGM('MM_FORCEMATCH','stop after charge fitting')
          end if   
        end if ! read forces/compute sp
      end if !parent
      if (parent .and. (.not. fm_fit_charges))  then 
         write(6,'(A)') ' fm  have just skipped the charge fitting'
      end if   
      CALL MY_SYNC(ALLGRP)

      if (classical) then
        write(6,*) 
     &   '  with classical forces doesnot make sense to continue'
         call STOPGM('mm_forcematch', 'no force matching in a classical'
     &    //' run')
      end if
C now loop over reference frames again to get forces resulting from
C QM-MM interactions and non-bonded QM-QM interactions
C We get these by computing the forces according to the classical
C force-field with optimized charges (remember that all force-constants
C for bonded QM-QM interaction have been set to zero!)
C
C First, we need to reset exclusions (QM/MM changes the topology such
C that all QM atoms are mutually excluded...)
      if ((.not.classical) .and. (parent.or.mmnode)) then 
        call fm_restore_exclusions
      end if
C
C We also combine forces on capping hydrogens with those on the capped atom
      call fm_combine_capping(nframes, nr_qm, f_qm)
C make a copy of reference forces to compute RMS of total force (we
C subtract non-bonded forces later)
      call DCOPY(3*nr_qm*nframes, f_qm, 1, f_qm_ref, 1)
C
      if (parent) then
        write(6,'(A)') 
        write(6,'(A)') '  fm  ========================================'
        write(6,'(A)') '  fm  Will now loop over reference frames again'
        write(6,'(A)') '  fm  to get non-bonded forces'
        write(6,'(A)') '  fm  ========================================'
      endif

C some preparation first
      CALL MY_SYNC(QMMMGRP)
      classical = .true.
      MSGLEN = 8 / IRAT
      CALL MY_BCAST(classical,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(nframes,MSGLEN,SOURCE,ALLGRP)

      IF(PARENT) THEN
        call FILEOPEN(fm_iou,fm_ref_traj_filename,FO_OLD,ferror)
        if (ferror) call STOPGM('mm_forcematch', 'Could not open file '
     &                   // fm_ref_traj_filename)
        call FILEOPEN(fm_cfu,fm_covforces_ref_filename,FO_APP,ferror)
      END IF !parent

      CALL mm_dim(mm_go_mm,statusdummy)
      fm_frame_indx = 0
      allocate(mm_FION(3, NAX, NSX))

C now loop over the frames
C FIXME: add a check that the frame nrs. (fm_frame_indx) are consistent
      DO iframe=1,nframes
        IF (PARENT) THEN
C         jump over the stride        
         do stride_indx=1,fm_ref_traj_stride-1
           do iats=1,NATm
              read(fm_iou,'(A500)',end=311,err=311) dummyline
C
C          jump over "NEW DATA" marks
C
              IF (INDEX(dummyline,'NEW DATA') .NE. 0) THEN
                 write(6,'(A,i8)') 
     &           '  fm (reading stride) NEW DATA mark after frame ',l-1
                 write(6,'(A,i8)') '  fm stride index ',stride_indx
C                actually, the NEW DATA mark should not be inside
C                one frame
                 IF (iats .gt. 1) then
                    write(6,'(A)') 
     &            '  fm NEW DATA mark in the middle of frame'
                    goto 311
                 END IF   
C                just read an additional line            
                 read(fm_iou,'(A500)',end=311,err=311) dummyline
              END IF
            end do ! no of atoms
          end do !stride
          do iats=1,NATm
            read(fm_iou,'(A500)',end=311,err=311) dummyline
C
C          jump over "NEW DATA" marks
C
            IF (INDEX(dummyline,'NEW DATA') .NE. 0) THEN
              write(6,'(A,i8)') 
     &        '  fm found NEW DATA mark in frame ',iframe
C             actually, the NEW DATA mark should not be inside
C             one frame
              IF (iats .gt. 1) then
                 write(6,'(A)') 
     &           '  fm NEW DATA mark in the middle of frame' 
                 goto 311
              END IF   
C             just read an additional line            
              read(fm_iou,'(A500)',end=311,err=311) dummyline
            END IF
            read(dummyline,*,err=311) fm_frame_indx,
     &                     (gr_tau(k,iats),k=1,3)
          if (iats .eq. 1) then 
            write(6,*)
            write(6,'(A)') '  fm '
            write(6,'(A,i9)') '  fm  frame number: ', iframe
            write(6,'(A,i9)') '  fm  frame index:  ', fm_frame_indx
            write(6,'(A)') '  fm '
          end if
         end do
C        convert to cpmd ordering
         I=0
         DO IS=1,NSPm
           DO IA=1,NAm(IS)
             I=I+1
             DO K=1,3
               TAU0(K,IA,IS)=gr_tau(K,NAT_grm(I))
             ENDDO
           ENDDO
         ENDDO
        END IF !PARENT     
        CALL MY_SYNC(QMMMGRP)
        CALL mm_dim(mm_go_mm,statusdummy)
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAU0,MSGLEN,SOURCE,QMMMGRP)
C mmnode computes the classical forces
        if(mmnode) then
          mm_epot = 0.d0
          call AZZERO(mm_FION,3*NAX*NSX)
          call mm_force(NAX,NSX,TAU0,mm_FION,mm_epot)
        endif
        MSGLEN = 8 * 3*NAX*NSX
        CALL MY_BCAST(mm_FION,MSGLEN,MMSOURCE,QMMMGRP)
        CALL MY_SYNC(QMMMGRP)

C subtract classical forces from f_qm, we do this on parent 
C mm_FION contains actually gradients, while we have forces in f_qm,
C therefore to subtract, we do: f_qm - (-mm_FION) = f_qm + mm_FION
        if (parent) then
          iqm = 0
          do is = 1, NSPq
            do ia = 1, NAq(is)
              iqm = iqm + 1
C              f_qm(:,iqm,iframe) = f_qm(:,iqm,iframe) + mm_FION(:,ia,is)
C I think mm_FION is actually really forces...
              f_qm(:,iqm,iframe) = f_qm(:,iqm,iframe) - mm_FION(:,ia,is)
            enddo
          enddo
          write(fm_cfu, *) fm_frame_indx
          do iqm = 1, nr_qm
            write(fm_cfu, '(1X,I3,1X,3(E16.8),1X,3(E16.8))')
     $            iqm, r_qm(:,iqm,iframe), f_qm(:,iqm,iframe)
          enddo
        endif !parent
      enddo ! loop over frames
      if (PARENT) then
        call FILECLOSE(fm_iou)
        call FILECLOSE(fm_cfu)
      endif
      if (PARENT) then
        write(6,'(A)') '  fm  ========================================'
        write(6,'(A)') '  fm   Done with classical loop!'
        write(6,'(A)') '  fm  ========================================'
      endif
C
C_DEBUG[
      if (parent) call fm_writeout_topo('afterclassical.top')
C_DEBUG]
C      
C now fit covalent parameters
      if (parent) call fm_fit_covalent(nframes, nr_qm, r_qm, f_qm)
C
C DONE FORCE MATCHING -------------------------------------------
C
C write out new topology
      if (parent) call fm_writeout_topo(fm_outtopo_filename)
C_FM]
C     
C loop again over frames to compute RMS of total forces, if requested
      call MY_SYNC(ALLGRP)
      if (fm_compute_rms) then
        IF(PARENT) THEN
          write(6,*) 
          write(6,'(A)') '  fm '
          write(6,'(A)') '  fm  Computing RMS of total force'
          write(6,'(A)') '  fm ' 
          call FILEOPEN(fm_iou,fm_ref_traj_filename,FO_OLD,ferror)
          if (ferror) then
            call STOPGM('mm_forcematch', 'Could not open file '
     &                   // fm_ref_traj_filename)
          endif
          allocate(f_fit_err(3, nr_qm, nframes))
        endif
        DO iframe=1,nframes
          IF (PARENT) THEN
         do stride_indx=1,fm_ref_traj_stride-1
           do iats=1,NATm
              read(fm_iou,'(A500)',end=311,err=311) dummyline
C
C          jump over "NEW DATA" marks
C
C           write(6,*) 'before NEW DATA check'
              IF (INDEX(dummyline,'NEW DATA') .NE. 0) THEN
                 write(6,'(A,i8)') 
     &           '  fm (reading stride) NEW DATA mark after frame ',l-1
                 write(6,'(A,i8)') '  fm stride index ',stride_indx
C                actually, the NEW DATA mark should not be inside
C                one frame
                 IF (iats .gt. 1) then
                    write(6,'(A)') 
     &            '  fm NEW DATA mark in the middle of frame'
                    goto 311
                 END IF   
C                just read an additional line            
                 read(fm_iou,'(A500)',end=311,err=311) dummyline
              END IF
            end do ! no of atoms
          end do !stride
C          write(6,*) 'have read the stride ',stride_indx
C         now read the frame
          do iats=1,NATm
            read(fm_iou,'(A500)',end=311,err=311) dummyline
C
C          jump over "NEW DATA" marks
C
            IF (INDEX(dummyline,'NEW DATA') .NE. 0) THEN
              write(6,'(A,i8)') 
     &        '  fm found NEW DATA mark in frame ',iframe
C             actually, the NEW DATA mark should not be inside
C             one frame
              IF (iats .gt. 1) then
                 write(6,'(A)') 
     &           '  fm NEW DATA mark in the middle of frame' 
                 goto 311
              END IF   
C             just read an additional line            
              read(fm_iou,'(A500)',end=311,err=311) dummyline
            END IF
            read(dummyline,*,err=311) fm_frame_indx,
     &                     (gr_tau(k,iats),k=1,3)
          if (iats .eq. 1) then 
            write(6,*)
            write(6,'(A)') '  fm '
            write(6,'(A,i9)') '  fm  frame number: ', iframe
            write(6,'(A,i9)') '  fm  frame index:  ', fm_frame_indx
            write(6,'(A)') '  fm '
          end if
        end do
C          convert to cpmd ordering
           I=0
           DO IS=1,NSPm
             DO IA=1,NAm(IS)
               I=I+1
               DO K=1,3
                 TAU0(K,IA,IS)=gr_tau(K,NAT_grm(I))
               ENDDO
             ENDDO
           ENDDO
          END IF !PARENT     
          CALL MY_SYNC(QMMMGRP)
          CALL mm_dim(mm_go_mm,statusdummy)
          MSGLEN = 3*NAX*NSX * 8
          CALL MY_BCAST(TAU0,MSGLEN,SOURCE,QMMMGRP)
C mmnode computes the classical forces
          if(mmnode) then
            mm_epot = 0.d0
            call AZZERO(mm_FION,3*NAX*NSX)
            call mm_force(NAX,NSX,TAU0,mm_FION,mm_epot)
          endif
C mmnode might not be parent, so broadcast mm_FION from mmnode
          CALL MY_SYNC(QMMMGRP)
          MSGLEN = 8 * 3*NAX*NSX
          CALL MY_BCAST(mm_FION,MSGLEN,MMSOURCE,QMMMGRP)
          CALL MY_SYNC(QMMMGRP)

          if (parent) then
            iqm = 0
            do is = 1, NSPq
              do ia = 1, NAq(is)
                iqm = iqm + 1
                f_fit_err(:,iqm,iframe) = mm_FION(:,ia,is) 
     $                                  - f_qm_ref(:,iqm, iframe)
              enddo
            enddo
          endif !parent
        enddo ! loop over frames
        if (parent) then
          call fm_kfit_compute_frms(rms, rms_rel, 3*nr_qm*nframes,
     $                              f_fit_err, f_qm_ref)
          write(6,'(A)') '  fm  Total force RMS (abs. and rel.):'
          write(6,'(A,f12.6,f12.6)') '  fm  ', rms, rms_rel
          call fm_kfit_rms_per_atom(nframes, nr_qm, f_fit_err, f_qm_ref)
        endif
      endif !parent
C
      deallocate(mm_FION)
      if (parent) then
        deallocate(nr_nn)
        deallocate(r_qm)
        deallocate(f_qm)
        deallocate(f_qm_ref)
        deallocate(r_nn)
        deallocate(v_nn)
        deallocate(f_nn)
        deallocate(q_hirshfeld)
        deallocate(q_opt)
        deallocate(equiv)
        deallocate(qm_indx)
      end if  !parent
C
C     call MY_SYNC(ALLGRP)
C
C     ==--------------------------------------------------------------==
      IF (QMNODE) THEN
       CALL FREEM(IP_RIN0)
       CALL FREEM(IP_ROUT0)
       CALL FREEM(IP_RMIX)
       CALL FREEM(IP_RM1)
       CALL FREEM(IP_RINP)
       CALL FREEM(IP_EIGV)
       CALL FREEM(IP_RHOE)
       CALL FREEM(IP_PSI)
       CALL FREEM(IP_SCR)
       CALL FREEM(IP_FION)
       CALL FREEM(IP_TAUI)
       CALL FREEM(IP_TAUR)
       CALL FREEM(IP_TAUP)
       CALL FREEM(IP_TAUIO)
       IF (TEXTFLD) CALL FREEM(IP_EXTF)
C     ==--------------------------------------------------------------==
      ELSE
       CALL FREEM(IP_EIGV)
      ENDIF ! (qmnode)a
      call freem(ip_gr_tau)
C     ==--------------------------------------------------------------==
      call mm_dim(mm_revert,oldstatus)
      if (parent.and.n_cg.gt.1) CALL FILECLOSE(40)
      if (parent) call FILECLOSE(fm_iou)
      CALL MY_SYNC(QMMMGRP)
#endif
      RETURN
C
C    ==--------------------------------------------------------------==
C    error while reading file fm_ref_traj_filename
 311  continue
      IF (PARENT) THEN
        call STOPGM('fm_forcematch',
     $      'error while reading ref traj file '
     $                    //fm_ref_traj_filename)
      ENDIF

 318  continue
      IF(PARENT) THEN
        CALL STOPGM('fm_forcematch',
     $    'error while reading ref forces file '
     $             //fm_forces_ref_filename)
      ENDIF
C     ==--------------------------------------------------------------==
C
      RETURN
      END
C     ==================================================================
