C    ==================================================================
      SUBROUTINE MM_FORCES_PROP(NSTATE,C0,C1,C2,CR,SC0,CSCR,VPP,EIGV,
     &                       RHOE,PSI,SCR,LSCR,
     &                       TAU0,VELP,TAUI,FION,IFCALC,
     &                       IREC,TFOR,TINFO)
C     ==--------------------------------------------------------------==
C     == ENTER WITH THE IONIC POSITIONS IN TAU0 AND AN INPUT GUESS    ==
C     == FOR THE DENSITY IN RIN0, THIS ROUTINE RETURNS THE CONVERGED  ==
C     == DENSITY, WAVEFUNCTIONS AND IONIC FORCES.                     ==
C     ==--------------------------------------------------------------==
C     == TAU0: ATOMIC POSITION                                        ==
C     == VELP and TAUI are necessary for RESTART FILE                 ==
C     == FION: IONIC FORCES                                           ==
C     == IFCALC: total number of iterations                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'        !NLSD
      INCLUDE 'elct.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'        !CALSTE
      INCLUDE 'andr.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'store.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'irat.inc'
CEHR
      INCLUDE 'td_input.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'mm_dim.inc'

C     Arguments
      INTEGER    NSTATE,IFCALC,IREC(100),LSCR
      COMPLEX*16 C0(ngwk,nstate,1),C2(*),C1(*),CR(*),SC0(*),CSCR(*),
     &           PSI(NNR1)
      REAL*8     EIGV(*),TAU0(*),VELP(*),TAUI(*),FION(*),VPP(*),
     &           RHOE(NNR1,NLSD),SCR(LSCR),THL(2)
      LOGICAL    TFOR,TINFO
C     Variables
      CHARACTER TAG*30
      REAL*8    TIME1,TIMEC,ETOT0,DETOT,TIME2,TTHL,TCPU
      INTEGER   INFR,NHPSI,LFORCES_DIAG
      logical   update_pot
CEHR  Ehrenfest
      dimension  f(nstate,1)
      COMPLEX*16 gde(*)
      integer    i,j,k,ik
      logical    statusdummy
      pointer    (ip_gde,gde)
      ik=1
C     ==--------------------------------------------------------------==
C  
      if(qmnode)then
        TIME1 = TIMEC()
C       CALL GIVE_SCR_FORCES_DIAG(LFORCES_DIAG,TAG,NSTATE,TFOR)
C       CALL TEST_SCR('FORCES_DIAG',TAG,LSCR,LFORCES_DIAG)
C     ==--------------------------------------------------------------==
        ECNSTR=0.0D0
        CONVWF=.FALSE.
        ETOT0=0.0D0
        IF(TDIAG.AND.TLANC) THEN
          CALL SET_B2L()
       ENDIF
CEHR
      if (tmdeh) call memory(ip_gde,((NGWK*NSTATE+8)*MDIIS)/4,'GDE')
C     ==--------------------------------------------------------------==
        IF(TDIAG) THEN
          IF(.NOT.TINFO.AND.PARENT) THEN
             WRITE(6,'(T9,A)')
     &       'INFR       DRHOMAX        ETOT       DETOT   HPSI    TCPU'
          ENDIF
        ELSE
          IF(.NOT.TINFO.AND.PARENT) THEN
             WRITE(6,'(T9,A)')
     &       'INFR         GEMAX            ETOT         DETOT     TCPU'
          ENDIF
          SDIIS=.TRUE.
          SPCG=.TRUE.
        ENDIF
      endif
C
CEHR
      update_pot=.true.
C    ==================================================================
C    ==                     EHRENFEST DYNAMICS                       ==
C    ==================================================================
C
      call mm_dim(mm_go_qm,statusdummy)
      if (tmdeh) then
        if (infi.gt.0) then
         if (parent) then
          write(*,'(/,1X,A)') 'occupation for prop'
          write(*,'(13F5.1)') (f(i,ik),i=1,nstate)
         endif
C        call my_flush(6)
C        write(*,*) 'me' , me
C        STOP
         call ehrenfest(c0,c2,rhoe,psi,sc0,eigv,scr,lscr)
        endif
      endif
      call mm_dim(mm_go_mm,statusdummy)
      if (tmdeh.and.parent) then
        write(*,'(/,1X,A)') 'occupation for forces computation'
        write(*,'(13F5.1)') (f(i,ik),i=1,nstate)
        call my_flush(6)
      endif
C
      IF(GEQ0) CALL ZCLEAN_K(C0,NSTATE,NGW)
C
      IF(TFOR) THEN
        IF(TDIAG) THEN
C         Diagonalization
          CALL AZZERO(FION,3*NAX*NSX)
          CALL STOPGM("mm_forces_diag","UPDRHO not compatible")
          CALL UPDRHO(C0,C2,CR,SC0,CSCR,VPP,TAU0,FION,EIGV,
     &                RHOE,PSI,SCR,LSCR,
     &                NSTATE,.TRUE.,TINFO,CALSTE,INFR,THL,NHPSI)
        ELSE
          IF (.not.TKPNT) THEN
           CALL UPDWF(C0,C2,SC0,TAU0,FION,CR,CSCR,VPP,EIGV,
     &               RHOE,PSI,SCR,LSCR,NSTATE,.TRUE.,.TRUE.)
          ELSEIF (TKPNT.and.(.not.tmdeh)) THEN
C           CALL K_UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
            CALL K_UPDWF(C0,C2,SC0,TAU0,FION,CR,GDE,VPP,EIGV,
     &                   RHOE,PSI,SCR,LSCR,NSTATE,.FALSE.,update_pot)
          ELSE
            CALL UPDWF(C0,C2,SC0,TAU0,FION,CR,CSCR,VPP,EIGV,
     &               RHOE,PSI,SCR,LSCR,NSTATE,.TRUE.,.TRUE.)
          ENDIF
        ENDIF
      ENDIF
      IF(TDDFT) THEN
         CALL LR_TDDFT(C0,C1,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,
     &                 SCR,LSCR,N,TFOR,IOUTPUT)
C        Now we are ready to calculate the QM/MM forces
C        The full TDDFT QM forces are already in FION
      ENDIF
 200  CONTINUE
      if (tmdeh) call freem(ip_gde)
      if(qmmm) call my_sync(qmmmgrp)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
