C     ==================================================================
      SUBROUTINE mm_qmmm_forcedr_bs(C0,C2,SC0,RHOE,PSI,TAU,FION,
     *             EIGV,SCR,LSCR,NSTATE,IL_RHOE,LPROJ,update_pot,
     *             SPD_BS,SPD_HS,SPDA_BS,SPDA_HS,ETOTHS,ETOTBS,
     *             update_files)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
!
      include 'system.h'
      include 'ener.inc'
      include 'elct.inc'
      include 'irat.inc'
      include 'ropt.inc'
      include 'bsym.inc'
C
      include 'mm_input.inc'
      include 'mm_dim.inc'

      REAL*8     TAU(3,NAX,*)
      REAL*8     FION(3,NAX,*)
      COMPLEX*16 C0(NGW,N,*),C2(NGW,N,*),SC0(NGW,N,*)
      REAL*8     RHOE(*),SCR(*),EIGV(N,*)
      COMPLEX*16 PSI(*) 
      INTEGER    LSCR,NSTATE,IL_RHOE
      logical    oldstatus,statusdummy,LPROJ,update_pot,
     &           update_files
C
      REAL*8     SPD_BS,SPD_HS,SPDA_BS,SPDA_HS,ETOTHS,ETOTBS
C
      REAL*8     FNBS(3,NAX,NSX)
      POINTER    (IP_FNBS,FNBS)
!
      REAL*8     SCALHS,SCALBS     
!
!     Setting the MM dimensions for BS Force allocation
      call mm_dim(mm_go_mm,oldstatus)
      IF(.NOT.BSYMM)RETURN
      IF(BSYMM)CALL STOPGM('MM_QMMM_FORCEDR_BS',
     &         'BROKENSYMMETRY-QMMM UNDER CONSTRUCTION')
!
      IF(PARENT)THEN
         CALL MEMORY(IP_FNBS,3*NAX*NSX,'FNBS')
         CALL AZZERO(FNBS,3*NAX*NSX)  ! Now they are zero
      END IF
!



!
!     Setting the BS electronic state
      BSCLCS =  1
      IF(qmnode)CALL SETBSSTATE
!
!     Calculate the Total Energy and Forces for the BS state
      CALL mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU,FION,
     *             EIGV,SCR,LSCR,NSTATE,IL_RHOE,LPROJ,update_pot,
     *             update_files)
!
!     Backup the Forces, Energies and Spin densities of BS state
      SPD_BS  = CSUMS
      SPDA_BS = CSUMSABS
      ETOTBS  = ETOT
      call mm_dim(mm_go_mm,statusdummy) ! In MM dimensions always
      IF(PARENT) CALL DCOPY(3*NAX*NSX,FION,1,FNBS,1) 
!
!     Setting the HS electronic state
      BSCLCS = 2
      IF(qmnode)CALL SETBSSTATE
!
!     Calculate the Total Energy and Forces for the HS state
      CALL mm_qmmm_forcedr(C0(1,1,2),C2(1,1,2),SC0(1,1,2),RHOE,
     *             PSI,TAU,FION,EIGV(1,2),SCR,LSCR,NSTATE,IL_RHOE,
     *             LPROJ,update_pot,update_files)
!      call my_sync(QMMMGRP)
!
!     Backup the Energies and Spin densities of HS state
      SPD_HS  = CSUMS
      SPDA_HS = CSUMSABS
      ETOTHS  = ETOT 
      ETOT    = SCALBS*ETOTBS+SCALHS*ETOTHS
!
      call mm_dim(mm_go_mm,statusdummy)  !In MM dimensions always

!
!     Now all processors know the modified FION
#ifdef PARALLEL
       CALL MY_BCAST(FION,3*NAX*NSX*8,QMMMSOURCE,QMMMGRP)
#endif
!
!     Free FNBS
      IF(PARENT)CALL FREEM(IP_FNBS)
!
      RETURN
      END
