C     ==================================================================
      SUBROUTINE mm_rho_forcedr(RHOE,TAU,FION,SCR,LSCR,NSTATE,
     *             update_files)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
!
      include 'system.h'
      include 'ener.inc'
      include 'irat.inc'
      include 'ropt.inc'
!
      include 'mm_input.inc'
      include 'mm_dim.inc'

      real*8     TAU(3,NAX,NSX)
      REAL*8     FION(3,NAX,NSX)
      REAL*8     RHOE(*),SCR(*),epot_mm,elstat_inten
      INTEGER    LSCR,NSTATE
      logical    status,update_files
!
      REAL*8     mm_FION(3,NAX,NSX)
      POINTER    (IP_mm_FION,mm_FION)
      integer    i,is,ig,ix,ia
      REAL*8     TIMEF1,TIMEF2,TIMEEI1,TIMEEI2
      REAL*8     TIMEG1,TIMEG2,TIMEF
      EXTERNAL   TIMEF
!
      elstat_inten=0.0d0
#if defined (__GROMOS)
      CALL my_sync(QMMMGRP)
      CALL mm_dim(mm_go_mm,status)
      CALL MEMORY(IP_mm_FION,3*NAX*NSX,'mm_FION')
      CALL my_bcast(TAU,3*NAX*NSX*8,QMMMSOURCE,QMMMGRP)
      CALL AZZERO(mm_FION,3*NAX*NSX)
      IF(coupl_model.ge.1)THEN
        if(qmnode) then 
! physical sign to RHOE
          call DSCAL(NNR1,-1.D0,RHOE,1)
        endif
      endif
      if(coupl_model.ge.1)then
        TIMEEI1=TIMEF()
        CALL mm_elstat(TAU,mm_FION,rhoe,SCR,LSCR,
     c                 elstat_inten,MAXNAT_el,update_files)
! mmnode adds the long range contribution to mm_fion
! parent has the short range  contribution
        TIMEEI2=TIMEF()
      else
        TIMEEI1=0.D0
        TIMEEI2=0.D0
      endif

      if(coupl_model.ge.1)then
        if(qmnode) then 
          CALL DSCAL(NNR1,-1.D0,RHOE,1)
        endif
      endif 

      IF(parent.and. .not.classical)THEN
!$OMP parallel do private(i)
        DO i=1,3*NAX*NSX
          mm_FION(i,1,1)=FION(i,1,1)+mm_FION(i,1,1)
        ENDDO
! parent has the short range  contribution + the QM forces; if parent.eq.mmnode, has also lr
      ENDIF  

      TIMEG1=0.D0
      TIMEG2=0.D0
      epot_mm=0.d0
      if(mmnode) then
        TIMEG1=TIMEF()
        CALL mm_force(NAX,NSX,TAU,mm_FION,epot_mm)
        TIMEG2=TIMEF()
      endif
      CALL my_bcast(TIMEG1,8,MMSOURCE,QMMMGRP)
      CALL my_bcast(TIMEG2,8,MMSOURCE,QMMMGRP)

      IF (PARENT.and.qmmm_time) then
        WRITE(6,'(A35,F8.4,A2)')
     &            'electrostatic interaction needed ',
     &                     (timeei2-timeei1)/1000,' s'
        WRITE(6,'(A35,F8.4,A2)')
     &       'MM forces needed ',(timeg2-timeg1)/1000,' s'
      ENDIF

! parent .ne. mmnode:    parent has QM, sr in mm_FION; mmnode has lr+MM in mm_FION  
! parent .eq. mmnode:    parent has QM + sr + lr + MM in mm_FION
! we combine mm_fion into fion
      CALL my_combine(mm_fion,fion,3*NAX*NSX*8,1,QMMMGRP)
      CALL my_bcast(epot_mm,8,MMSOURCE,QMMMGRP)

      IF(qmnode) THEN
          ETOT=ETOT+epot_mm
          if(coupl_model.ge.1) ETOT=ETOT+elstat_inten
      ENDIF

      if(parent) CALL TAUCL(FION)  

      CALL freem(IP_mm_fion)
      CALL mm_dim(mm_revert,status)
      CALL MY_SYNC(QMMMGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
