C     ==================================================================
      subroutine molorb(c0,c2,tau0,scr,lscr,nstate)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'ions.inc'
      include 'spin.inc'
      INCLUDE 'empf.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'wann.inc'
c     Arguments
      integer    lscr,nstate
      complex*16 c0(ngw,nstate),c2(ngw,nstate)
      real*8     scr(*),tau0(3,nax,nsx)
c     Variables
      real*8     centers(4,nstate)
      integer    wmol(nstate),nummol,nwann(nat,nlsd)
      integer    lwmol,lcenters,lnwann,msglen
      pointer    (ip_centers,centers),(ip_wmol,wmol),(ip_nwann,nwann)
      real*8     hmat(nstate,nstate),rotmat(nstate,nstate),w(nstate)
      real*8     hmat2(nstate,nstate)
      real*8     AUX(12*NSTATE)
      pointer    (ip_hmat,hmat),(ip_rotmat,rotmat),(ip_w,w),(ip_aux,aux)
      pointer    (ip_hmat2,hmat2)
      integer    lhmat,laux,info

      real*8     scr2(*)
      integer    lscr2
      pointer    (ip_scr2,scr2)
      INTEGER    IMOL(*)
      POINTER    (IP_IMOL,IMOL)
      INTEGER    NBONDS(*)
      REAL*8     MOLCHG(*)
      POINTER    (IP_NBONDS,NBONDS),(IP_MOLCHG,MOLCHG)
      REAL*8     RCOV(0:104),
     &           XMFAC
      INTEGER    NMA,NMPA1,K,I,J,NCC,MINAT,IAT,I1,I2,N1,N2,NST
      REAL*8     FAC
      REAL*8     D1,D2,D3,DIST,MINDIST
      LOGICAL    DEBUG

      debug=.false.

      lcenters=4*nstate
      call get_addr(ip_centers,scr(1))
      lwmol=nstate/irat+1
      call get_addr(ip_wmol,scr(lcenters+1))
      lnwann=(nat*nlsd)/irat+1
      call get_addr(ip_nwann,scr(lcenters+lwmol+1))

      lscr2=lscr-lcenters-lwmol-lnwann
      call get_addr(ip_scr2,scr(lcenters+lwmol+lnwann+1))

      IF (PARENT) THEN
         NMA=NAT
         NMPA1=(NAT*(NAT+1))/2
         CALL SCRSET(SCR2,LSCR2,DEBUG)
         
         CALL SCRPTR(SCR2,LSCR2,IP_ZAN,NAT,'ZAN',DEBUG)
         CALL SCRPTR(SCR2,LSCR2,IP_C,3*NAT,'C',DEBUG)
         CALL SCRPTR(SCR2,LSCR2,IP_IBIND,NMPA1/IRAT+1,'IBIND',DEBUG)
         CALL SCRPTR(SCR2,LSCR2,IP_NBONDS,NAT/IRAT+1,'NBONDS',DEBUG)
         CALL SCRPTR(SCR2,LSCR2,IP_IMOL,NAT/IRAT+1,'IMOL',DEBUG)
         CALL SCRPTR(SCR2,LSCR2,IP_MOLCHG,NAT,'MOLCHG',DEBUG)

         CALL IAZZERO(IMOL,NAT)
         CALL IAZZERO(IBIND,NMPA1)
         CALL IAZZERO(NBONDS,NAT)
         NATY=NAT
         K=0
         DO I=1,NSP
            DO J=1,NA(I)
               K=K+1
               ZAN(K)=DBLE(IATYP(I))
               C(1,K)=TAU0(1,J,I)-W_REF(1)
               C(2,K)=TAU0(2,J,I)-W_REF(2)
               C(3,K)=TAU0(3,J,I)-W_REF(3)
            ENDDO
         ENDDO
         DO I=1,99
            RCOV(I)=COVRAD(I)*FBOHR
         ENDDO
         NCC=3*NAT
         XMFAC=1.35D0
         CALL CPMDBONDS(RCOV,XMFAC,NBONDS)
         
C     Search for molecules
         CALL SMOLEC(IMOL,NUMMOL)
         
         DO I=1,NSTATE
            D1=CENTERS(1,I)-C(1,1)
            D2=CENTERS(2,I)-C(2,1)
            D3=CENTERS(3,I)-C(3,1)
            CALL PBC3(D1,D2,D3,D1,D2,D3,1,APBC,IBRAV)
            MINDIST = D1*D1 + D2*D2 + D3*D3
            MINAT=1
            DO J=2,NATY
               D1=CENTERS(1,I)-C(1,J)
               D2=CENTERS(2,I)-C(2,J)
               D3=CENTERS(3,I)-C(3,J)
               CALL PBC3(D1,D2,D3,D1,D2,D3,1,APBC,IBRAV)
               DIST = D1*D1 + D2*D2 + D3*D3
               IF (DIST.LT.MINDIST) THEN
                  MINAT=J
                  MINDIST=DIST
               ENDIF
            ENDDO
            WMOL(I)=IMOL(MINAT)
         ENDDO

         WRITE(6,*)
         WRITE(6,*) '          ORB.      MOLECULE '
         DO I=1,NSTATE
            WRITE(6,*) I,WMOL(I)
         ENDDO
            

         CALL IAZZERO(NWANN,NAT*NLSD)
         CALL AZZERO(MOLCHG,NAT)
         IF (TLSD) THEN
            FAC=1.0D0
            DO I=1,NSUP
               J=WMOL(I)
               NWANN(J,1)=NWANN(J,1)+1
               MOLCHG(J)=MOLCHG(J)-FAC
            ENDDO
            DO I=NSUP+1,NSTATE
               J=WMOL(I)
               NWANN(J,2)=NWANN(J,2)+1
               MOLCHG(J)=MOLCHG(J)-FAC
            ENDDO
         ELSE
            FAC=2.0D0
            DO I=1,NSTATE
               J=WMOL(I)
               NWANN(J,1)=NWANN(J,1)+1
               MOLCHG(J)=MOLCHG(J)-FAC
            ENDDO
         ENDIF

         IAT=0
         DO I=1,NSP
            DO J=1,NA(I)
               IAT=IAT+1
               K=IMOL(IAT)
               MOLCHG(K)=MOLCHG(K)+ZV(I)
            ENDDO
         ENDDO

         WRITE(6,*)
         WRITE(6,*) '       MOLECULE      CHARGE '
         DO I=1,NUMMOL
            WRITE(6,*) I,MOLCHG(I)
         ENDDO
         WRITE(6,*)

         CALL SCRREL(SCR2,LSCR2,DEBUG)


      ENDIF

#ifdef PARALLEL
      msglen=lcenters*8
      call my_bcast(centers,msglen,source,allgrp)
      msglen=lwmol*8
      call my_bcast(wmol,msglen,source,allgrp)
      call my_bcast(nwann,msglen,source,allgrp)
      msglen=8/irat
      call my_bcast(nummol,msglen,source,allgrp)
#endif


      CALL SCRSET(SCR2,LSCR2,DEBUG)

      LHMAT=NSTATE*NSTATE
      LAUX=12*NSTATE
      CALL SCRPTR(SCR2,LSCR2,IP_HMAT,LHMAT,'HMAT',DEBUG)
      CALL SCRPTR(SCR2,LSCR2,IP_HMAT2,LHMAT,'HMAT2',DEBUG)
      CALL SCRPTR(SCR2,LSCR2,IP_ROTMAT,LHMAT,'ROTMAT',DEBUG)
      CALL SCRPTR(SCR2,LSCR2,IP_AUX,LAUX,'AUX',DEBUG)
      CALL SCRPTR(SCR2,LSCR2,IP_W,NSTATE,'W',DEBUG)
      CALL OVLAP(NSTATE,HMAT,C0,C2)
#ifdef PARALLEL
      CALL GLOSUM(NSTATE*NSTATE,HMAT)
#endif

      CALL AZZERO(ROTMAT,NSTATE*NSTATE)
      IF (TLSD) THEN
         I1=1
         I2=NSUP+1
         DO I=1,NUMMOL
            DO J=1,NSUP
               IF (WMOL(J).EQ.I) THEN
                  ROTMAT(J,I1)=1.0D0
                  I1=I1+1
               ENDIF
            ENDDO
            DO J=NSUP+1,NSTATE
               IF (WMOL(J).EQ.I) THEN
                  ROTMAT(J,I2)=1.0D0
                  I2=I2+1
               ENDIF
            ENDDO
         ENDDO
      ELSE
         I1=1
         DO I=1,NUMMOL
            DO J=1,NSTATE
               IF (WMOL(J).EQ.I) THEN
                  ROTMAT(J,I1)=1.0D0
                  I1=I1+1
               ENDIF
            ENDDO
         ENDDO
      ENDIF

      CALL ROTATE(1.0D0,C0,0.0D0,C2,ROTMAT,NSTATE,
     x     2*NGW,TLSD,NSUP,NSDOWN)
cdebug      CALL DCOPY(2*NGW*NSTATE,C2,1,C0,1)

      IF (TLSD) THEN
         N2=NSUP+1
         CALL DGEMM('N','N',NSUP,NSUP,NSUP,1.0D0,HMAT,NSTATE,
     x        ROTMAT,NSTATE,0.0D0,HMAT2,NSTATE)
         CALL DGEMM('T','N',NSUP,NSUP,NSUP,1.0D0,ROTMAT,NSTATE,
     x        HMAT2,NSTATE,0.0D0,HMAT,NSTATE)

         CALL DGEMM('N','N',NSDOWN,NSDOWN,NSDOWN,1.0D0,HMAT(N2,N2),
     x        NSTATE,ROTMAT(N2,N2),NSTATE,0.0D0,HMAT2(N2,N2),NSTATE)
         CALL DGEMM('T','N',NSDOWN,NSDOWN,NSDOWN,1.0D0,ROTMAT(N2,N2),
     x        NSTATE,HMAT2(N2,N2),NSTATE,0.0D0,HMAT(N2,N2),NSTATE)
      ELSE
         CALL DGEMM('N','N',NSTATE,NSTATE,NSTATE,1.0D0,HMAT,NSTATE,
     x        ROTMAT,NSTATE,0.0D0,HMAT2,NSTATE)
         CALL DGEMM('T','N',NSTATE,NSTATE,NSTATE,1.0D0,ROTMAT,NSTATE,
     x        HMAT2,NSTATE,0.0D0,HMAT,NSTATE)
      ENDIF

      
      IF (TLSD) THEN
         N1=1
         N2=NSUP+1
         DO I=1,NUMMOL
            NST=NWANN(I,1)
            CALL DSYEV('V','U',NST,HMAT(N1,N1),NSTATE,W,AUX,LAUX,INFO)
            CALL DGEMM('N','N',2*NGW,NST,NST,1.0D0,C2(1,N1),2*NGW,
     x           HMAT(N1,N1),NSTATE,0.0D0,C0(1,N1),2*NGW)
            N1=N1+NST

            NST=NWANN(I,2)
            CALL DSYEV('V','U',NST,HMAT(N2,N2),NSTATE,W,AUX,LAUX,INFO)
            CALL DGEMM('N','N',2*NGW,NST,NST,1.0D0,C2(1,N2),2*NGW,
     x           HMAT(N2,N2),NSTATE,0.0D0,C0(1,N2),2*NGW)
            N2=N2+NST
         ENDDO
      ELSE
         N1=1
         DO I=1,NUMMOL
            NST=NWANN(I,1)
            CALL DSYEV('V','U',NST,HMAT(N1,N1),NSTATE,W,AUX,LAUX,INFO)
            CALL DGEMM('N','N',2*NGW,NST,NST,1.0D0,C2(1,N1),2*NGW,
     x           HMAT(N1,N1),NSTATE,0.0D0,C0(1,N1),2*NGW)
            N1=N1+NST
         ENDDO
      ENDIF

      CALL SCRREL(SCR2,LSCR2,DEBUG)
      

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
