c     ==================================================================
      SUBROUTINE MOLECULAR_STATES(C0,EIGV,NUMORB,TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ddip.inc'
      INCLUDE 'wann.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'mols.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'mm_input.inc'
C
      COMPLEX*16  C0(NGWK,*)
      REAL*8      EIGV(*),TAU0(3,NAX,*)
      INTEGER     NUMORB
C     Variables
      COMPLEX*16 CS(NGWK,*),SC0(NGWK,*),PSI(*)
      POINTER    (IP_CS,CS),(IP_SC0,SC0),(IP_PSI,PSI)
      REAL*8     SCR(*),HMAT(NUMORB,*),UMAT(*)
      POINTER    (IP_SCR,SCR),(IP_HMAT,HMAT), (IP_UMAT,UMAT)
      INTEGER    ORDER(2,*)
      POINTER    (IP_ORDER,ORDER)
      INTEGER    NXX,LSCR,IS,IA,IAT,I,J,K,LPSI,INFO
      REAL*8     D1,D2,D3,DIST,DM,DD
      CHARACTER  TAG*30
#ifdef PARALLEL
      INTEGER    MSGLEN,NXXFUN
      EXTERNAL   NXXFUN
#endif
C     ==--------------------------------------------------------------==
      IF(TLSD) CALL STOPGM('MOLSTATE','TLSD NOT IMPLEMENTED')
      IF(QMMM) CALL STOPGM('MOLSTATE','QMMM NOT IMPLEMENTED')
      TWANN=.TRUE.
      CALL GIVE_SCR_DDIPO(LSCR,TAG)
      LSCR=MAX(LSCR,2*NHG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
#ifdef PARALLEL
      LENBK=NXXFUN(NUMORB)
      NXX=MAX(2*LENBK*NPROC,2*NGWK*NUMORB)
#else
      NXX=2*NGWK*NUMORB
#endif
      CALL MEMORY(IP_SC0,NXX,'SC0')
      CALL MEMORY(IP_CS,NXX,'CS')
      CALL LOCALIZE(TAU0,C0,CS,SC0,SCR,LSCR,NUMORB)
      CALL FREEM(IP_SC0)
      CALL MEMORY(IP_ORDER,2*NUMORB,'ORDER')
      IF(PARENT) THEN
        DO I=1,NUMORB
          DM=1.D30
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
              D1=WCENT(1,I)-TAU0(1,IA,IS)
              D2=WCENT(2,I)-TAU0(2,IA,IS)
              D3=WCENT(3,I)-TAU0(3,IA,IS)
              CALL PBC3(D1,D2,D3,D1,D2,D3,1,APBC,IBRAV)
              DD=SQRT(D1*D1+D2*D2+D3*D3)
              IF(DD.LT.DM) THEN
                K=IAT
                DM=DD
              ENDIF
            ENDDO
          ENDDO
          ORDER(1,I)=MSNUM(K)
          WRITE(6,'(A,I7,A,I7,A,I7)') '  STATE:',I,
     *      '           ATOM:',K,'           MOLECULE:',MSNUM(K)
        ENDDO
        K=0
        DO I=1,NUMOL
          IS=0
          DO J=1,NUMORB
            IF(I.EQ.ORDER(1,J)) IS=IS+1
          ENDDO
          IF(IS.NE.MSTAT(I)) THEN
            WRITE(6,*) ' WARNING: NUMBER OF STATES IS INCONSISTENT'
            WRITE(6,*) ' EXPECTED:',MSTAT(I),'   FOUND:',IS
          ENDIF
          DO J=1,NUMORB
            IF(ORDER(1,J).EQ.I) THEN
              K=K+1
              ORDER(2,J)=K
            ENDIF
          ENDDO
        ENDDO
      ENDIF
#ifdef PARALLEL
      MSGLEN = 2*NUMORB * 8/IRAT
      CALL MY_BCAST(ORDER,MSGLEN,SOURCE,ALLGRP)
#endif
      DO I=1,NUMORB
        CALL DCOPY(2*NGW,C0(1,I),1,CS(1,ORDER(2,I)),1)
      ENDDO
C
      CALL FREEM(IP_SCR)
      CALL GIVE_SCR_HPSI(LSCR,TAG,NUMORB)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      CALL RHOE_PSI_SIZE(I,LPSI)
      CALL MEMORY(IP_PSI,LPSI,'PSI')
      CALL HPSI(CS,C0,SC0,POTR,PSI,SCR,LSCR,NUMORB,1,1)
      CALL FREEM(IP_PSI)
      CALL MEMORY(IP_HMAT,NUMORB*NUMORB,'HMAT')
      CALL MEMORY(IP_UMAT,NUMORB*NUMORB,'UMAT')
      CALL OVLAP(NUMORB,HMAT,C0,CS)
      CALL GLOSUM(NUMORB*NUMORB,HMAT)
      CALL DSCAL(NUMORB*NUMORB,-1.D0,HMAT,1)
      IF(PARENT) THEN
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(T30,A)') 'MOLECULAR STATES'
      ENDIF
      IS=1
      DO I=1,NUMOL
        IA=MSTAT(I)
        IF(PARENT) THEN
          CALL RMATMOV(IA,IA,HMAT(IS,IS),NUMORB,UMAT,IA)
          CALL DSYEV('V','U',IA,UMAT,IA,EIGV(IS),SCR,LSCR,INFO)
          IF(INFO.NE.0) CALL STOPGM('MOLSTAT','INFO != 0 AFTER DSYEV')
          WRITE(6,'(A,I6,A)') ' MOLECULE:',I,'    EIGENVALUES [eV]'
          WRITE(6,'(T16,4(F11.4,2X))') (EIGV(IS+J-1)*2.D0*RY,J=1,IA)
        ENDIF
#ifdef PARALLEL
        MSGLEN = IA*IA * 8
        CALL MY_BCAST(UMAT,MSGLEN,SOURCE,ALLGRP)
#endif
        CALL ROTATE(1.D0,CS(1,IS),0.D0,C0(1,IS),UMAT,IA,
     *              2*NGW,TLSD,NSUP,NSDOWN)
        IS=IS+MSTAT(I)
      ENDDO
      IF(PARENT) WRITE(6,'(1X,64("*"))')
#ifdef PARALLEL
      MSGLEN = NUMORB * 8
      CALL MY_BCAST(EIGV,MSGLEN,SOURCE,ALLGRP)
#endif
C
      CALL FREEM(IP_CS)
      CALL FREEM(IP_SCR)
      CALL FREEM(IP_HMAT)
      CALL FREEM(IP_UMAT)
      CALL FREEM(IP_ORDER)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
