C     ==================================================================
      SUBROUTINE MOLSYM(TAG,NAXIS,TAB,NOP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER TAG*3
      INTEGER   NAXIS,NOP
      REAL*8    TAB(3,3,*)
C     Variables
      INTEGER   NGEN,I,J,N1,K
      REAL*8    GEN(3,3,5),SOP(3,3),DSOP(3,3),
     &          PI,A,B,C,DD
      REAL*8    DASUM
      EXTERNAL  DASUM
C     ==--------------------------------------------------------------==
C     SET THE GENERATORS
      NGEN=0
      IF (INDEX(TAG(1:1),'C').NE.0) THEN
        IF (NAXIS.NE.1) THEN
          NGEN=NGEN+1
          CALL GENAX(GEN(1,1,NGEN),NAXIS,3)
        ENDIF
        IF (INDEX(TAG,'CNH').NE.0) THEN
          NGEN=NGEN+1
          CALL GENSI(GEN(1,1,NGEN),3)
        ELSEIF (INDEX(TAG,'CS').NE.0) THEN
          NGEN=NGEN+1
          CALL GENSI(GEN(1,1,NGEN),3)
        ELSEIF (INDEX(TAG,'CNV').NE.0) THEN
          NGEN=NGEN+1
          CALL GENSI(GEN(1,1,NGEN),1)
        ENDIF
      ELSEIF (INDEX(TAG(1:1),'S').NE.0) THEN
        NGEN=NGEN+1
        CALL GENSN(GEN(1,1,NGEN),NAXIS,3)
      ELSEIF (INDEX(TAG(1:1),'D').NE.0) THEN
        NGEN=NGEN+1
        CALL GENAX(GEN(1,1,NGEN),NAXIS,3)
        IF (INDEX(TAG,'DNH').NE.0) THEN
          NGEN=NGEN+1
          CALL GENAX(GEN(1,1,NGEN),2,1)
          NGEN=NGEN+1
          CALL GENSI(GEN(1,1,NGEN),3)
        ELSEIF (INDEX(TAG,'DND').NE.0) THEN
          NGEN=NGEN+1
          CALL GENAX(GEN(1,1,NGEN),2,1)
          NGEN=NGEN+1
          CALL GEND(GEN(1,1,NGEN),NAXIS,3)
        ELSEIF (INDEX(TAG,'DN').NE.0) THEN
          NGEN=NGEN+1
          CALL GENAX(GEN(1,1,NGEN),2,1)
        ENDIF
      ELSEIF (INDEX(TAG(1:1),'T').NE.0) THEN
        NGEN=NGEN+1
        CALL GENAX(GEN(1,1,NGEN),3,4)
        IF (INDEX(TAG,'TD').NE.0) THEN
          NGEN=NGEN+1
          CALL GENSN(GEN(1,1,NGEN),4,3)
        ELSE
          NGEN=NGEN+1
          CALL GENAX(GEN(1,1,NGEN),2,3)
          IF (INDEX(TAG,'TH').NE.0) THEN
            NGEN=NGEN+1
            CALL GENI(GEN(1,1,NGEN))
          ENDIF
        ENDIF
      ELSEIF (INDEX(TAG(1:1),'O').NE.0) THEN
        NGEN=NGEN+1
        CALL GENAX(GEN(1,1,NGEN),4,3)
        NGEN=NGEN+1
        CALL GENAX(GEN(1,1,NGEN),3,4)
        IF (INDEX(TAG,'OH').NE.0) THEN
          NGEN=NGEN+1
          CALL GENI(GEN(1,1,NGEN))
        ENDIF
      ELSEIF (INDEX(TAG(1:1),'I').NE.0) THEN
        PI=ACOS(-1.D0)
        A=0.5D0
        B=COS(0.2D0*PI)
        C=COS(0.4D0*PI)
        NGEN=NGEN+1
        GEN(1,1,NGEN)=B
        GEN(1,2,NGEN)=-C
        GEN(1,3,NGEN)=-A
        GEN(2,1,NGEN)=-C
        GEN(2,2,NGEN)=A
        GEN(2,3,NGEN)=-B
        GEN(3,1,NGEN)=A
        GEN(3,2,NGEN)=B
        GEN(3,3,NGEN)=C
        NGEN=NGEN+1
        GEN(1,1,NGEN)=C
        GEN(1,2,NGEN)=-A
        GEN(1,3,NGEN)=B
        GEN(2,1,NGEN)=-A
        GEN(2,2,NGEN)=-B
        GEN(2,3,NGEN)=-C
        GEN(3,1,NGEN)=B
        GEN(3,2,NGEN)=-C
        GEN(3,3,NGEN)=-A
        IF (INDEX(TAG,'IH').NE.0) THEN
          NGEN=NGEN+1
          CALL GENI(GEN(1,1,NGEN))
        ENDIF
      ENDIF
C     WRITE(6,*) ' POINT GROUP ',TAG,'   Naxis=',NAXIS
C     WRITE(6,*) ' Number of generators ',NGEN
C     SET UP SYMMETRY OPERATIONS
C     START WITH IDENTITY
      NOP=1
      DO I=1,3
        DO J=1,3
          TAB(I,J,NOP)=0.0D0
        ENDDO
        TAB(I,I,NOP)=1.0D0
      ENDDO
C     NOW THE GENERATORS
      DO I=NOP+1,NOP+NGEN
        CALL DCOPY(9,GEN(1,1,I-NOP),1,TAB(1,1,I),1)
      ENDDO
      NOP=NOP+NGEN
C     START THE GENERATION PROCESS
  200 CONTINUE
      N1=NOP
      DO I=1,N1
        DO J=1,N1
          CALL DGEMM('N','N',3,3,3,1.D0,TAB(1,1,I),3,
     *               TAB(1,1,J),3,0.D0,SOP(1,1),3)
          DO K=1,NOP
            CALL DCOPY(9,SOP(1,1),1,DSOP(1,1),1)
            CALL DAXPY(9,-1.D0,TAB(1,1,K),1,DSOP(1,1),1)
            DD=DASUM(9,DSOP(1,1),1)
            IF (DD.LT.1.D-10) GOTO 100
          ENDDO
          NOP=NOP+1
          CALL DCOPY(9,SOP(1,1),1,TAB(1,1,NOP),1)
  100     CONTINUE
        ENDDO
      ENDDO
      IF (N1.NE.NOP) GOTO 200
C     DO I=1,NOP
C       WRITE(6,*) ' Symmetry operation ',I
C       DO J=1,3
C         WRITE(6,'(3F10.4)') (TAB(J,K,I),K=1,3)
C       ENDDO
C     ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     GENERATORS
C     ==================================================================
      SUBROUTINE GENAX(TAB,N,K)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N,K
      REAL*8  TAB(3,3)
C     Variables
      INTEGER I,J
      REAL*8  ROT(2,2),S1(3,3),S2(3,3),S3(3,3),S4(3,3),
     &        TPI,ANG,SQ2,A1,CA,SA
C     ==--------------------------------------------------------------==
      TPI=4.D0*DACOS(0.D0)
      ANG=TPI/DBLE(N)
      DO I=1,3
        DO J=1,3
          TAB(I,J)=0.0D0
        ENDDO
        TAB(I,I)=1.0D0
      ENDDO
      ROT(1,1)=DCOS(ANG)
      ROT(2,2)=DCOS(ANG)
      ROT(1,2)=DSIN(ANG)
      ROT(2,1)=-DSIN(ANG)
      IF (K.EQ.1) THEN
        TAB(2,2)=ROT(1,1)
        TAB(2,3)=ROT(1,2)
        TAB(3,2)=ROT(2,1)
        TAB(3,3)=ROT(2,2)
      ELSEIF (K.EQ.2) THEN
        TAB(1,1)=ROT(1,1)
        TAB(1,3)=ROT(1,2)
        TAB(3,1)=ROT(2,1)
        TAB(3,3)=ROT(2,2)
      ELSEIF (K.EQ.3) THEN
        TAB(1,1)=ROT(1,1)
        TAB(1,2)=ROT(1,2)
        TAB(2,1)=ROT(2,1)
        TAB(2,2)=ROT(2,2)
      ELSEIF (K.EQ.4) THEN
        TAB(1,1)=ROT(1,1)
        TAB(1,2)=ROT(1,2)
        TAB(2,1)=ROT(2,1)
        TAB(2,2)=ROT(2,2)
        SQ2=SQRT(2.D0)*0.5D0
        A1=ATAN(SQRT(2.D0))
        S1(1,1)=SQ2
        S1(1,2)=-SQ2 
        S1(1,3)=0.D0
        S1(2,1)=SQ2 
        S1(2,2)=SQ2
        S1(2,3)=0.D0
        S1(3,1)=0.D0
        S1(3,2)=0.D0
        S1(3,3)=1.D0
        S2(1,1)=1.D0
        S2(1,2)=0.D0
        S2(1,3)=0.D0
        S2(2,1)=0.D0
        S2(2,2)=COS(A1)
        S2(2,3)=-SIN(A1)
        S2(3,1)=0.D0
        S2(3,2)=SIN(A1)
        S2(3,3)=COS(A1)
        CALL DGEMM('N','N',3,3,3,1.D0,S1,3,S2,3,0.D0,S3,3)
        CALL DGEMM('N','N',3,3,3,1.D0,TAB,3,S3,3,0.D0,S4,3)
        S1(1,2)=SQ2
        S1(2,1)=-SQ2
        S2(2,3)=SIN(A1)
        S2(3,2)=-SIN(A1)
        CALL DGEMM('N','N',3,3,3,1.D0,S1,3,S4,3,0.D0,S3,3)
        CALL DGEMM('N','N',3,3,3,1.D0,S2,3,S3,3,0.D0,TAB,3)
      ELSEIF (K.EQ.5) THEN
        TAB(1,1)=ROT(1,1)
        TAB(1,2)=ROT(1,2)
        TAB(2,1)=ROT(2,1)
        TAB(2,2)=ROT(2,2)
        CA=DSQRT(1.D0-8.D0/(3.D0*(5.D0+DSQRT(5.D0))))
        SA=4.D0/DSQRT(2.D0*(5.D0+DSQRT(5.D0)))
        S1(1,1)=1.D0
        S1(1,2)=0.D0 
        S1(1,3)=0.D0
        S1(2,1)=0.D0
        S1(2,2)=CA
        S1(2,3)=-SA
        S1(3,1)=0.D0
        S1(3,2)=SA
        S1(3,3)=CA
C       SOMETHING IS MISSING
        CALL DGEMM('N','N',3,3,3,1.D0,TAB,3,S1,3,0.D0,S2,3)
        S1(3,2)=-SA
        S1(2,3)=SA
        CALL DGEMM('N','N',3,3,3,1.D0,S1,3,S2,3,0.D0,TAB,3)
      ELSE
        CALL STOPGM('GENAX','K.GT.5')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GENSI(TAB,K)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      REAL*8 TAB(3,3)
      INTEGER K
C     Variables
      INTEGER I,J
C     ==--------------------------------------------------------------==
      DO I=1,3
        DO J=1,3
          TAB(I,J)=0.0D0
        ENDDO
        TAB(I,I)=1.0D0
      ENDDO
      TAB(K,K)=-1.0D0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GENSN(TAB,N,K)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      REAL*8 TAB(3,3)
      INTEGER N,K
C     ==--------------------------------------------------------------==
      CALL GENAX(TAB,N,K)
      TAB(K,K)=-1.0D0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GEND(TAB,N,K)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N,K
      REAL*8  TAB(3,3)
C     Variables
      INTEGER I,J
      REAL*8  ROT(3,3),SIG(3,3)
C     ==--------------------------------------------------------------==
      CALL GENAX(ROT,2*N,K)
      DO I=1,3
        DO J=1,3
          SIG(I,J)=0.0D0
        ENDDO
        SIG(I,I)=1.0D0
      ENDDO
      IF (K.EQ.1) SIG(2,2)=-1.0D0
      IF (K.EQ.2) SIG(3,3)=-1.0D0
      IF (K.EQ.3) SIG(1,1)=-1.0D0
      CALL DGEMM('N','N',3,3,3,1.D0,SIG,3,ROT,3,0.D0,TAB,3)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GENI(TAB)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      REAL*8  TAB(3,3)
C     Variables
      INTEGER I,J
C     ==--------------------------------------------------------------==
      DO I=1,3
        DO J=1,3
          TAB(I,J)=0.0D0
        ENDDO
        TAB(I,I)=-1.0D0
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
        


