C     ==================================================================
      SUBROUTINE MOVERHO(RHOE,PSI,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==  EXPANDS THE DENSITY IN AN ATOM CENTERED BASIS OF STO        ==
C     ==  MOVES THE EXPANDED DENSITY ACCORDING TO THE MOVEMENT        ==
C     ==  OF THE ATOMS                                                ==
C     ==  ROUTINE ASSUMES THAT SETBASIS HAS BEEN CALLED ONCE          ==
C     ==  AND PHFAC HAS BEEN CALLED FOR THE TAUP                      ==
C     ==  CONFIGURATION (AND STORED IN EI1(IA,IG) ETC).               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    LSCR
      REAL*8     RHOE(NNR1,*),SCR(*)
      COMPLEX*16 PSI(NNR1)
C     Variables
      DIMENSION  GGNH(*)
      REAL*8     FNL(*),DFNL(*)
      COMPLEX*16 ZONE,ZZERO
      PARAMETER  (ZZERO=(0.D0,0.D0),ZONE=(1.D0,0.D0))
      COMPLEX*16 EIG1(3,*),RHOG(*),TSFAC(*)
      REAL*8     DATOM(NSPLPO,2,*)
      POINTER    (IP_EIG1,EIG1),(IP_RHOG,RHOG),(IP_DATOM,DATOM),
     &           (IP_TSFAC,TSFAC)
      COMPLEX*16 CTEP1,CTEP2,CTEP3,CTEM1,CTEM2,CTEM3,
     &           EI10,EI20,EI30,SVTMPP,SVTMPM
      REAL*8     CURV2,VOL,SA1,SA2,SA3,RSUM,RSUM1,AR,RSTMP
      CHARACTER  TAG*30
      INTEGER    ISUB,NNX,NN,IS,NH1,NH2,NH3,IR,IG,ISA0,IA,ISA,I,J,K,
     &           LMOVERHO,IFIRST
      DATA       IFIRST /0/
      SAVE       IFIRST,IP_DATOM
C     ==--------------------------------------------------------------==
      CALL TISET('   MOVERHO',ISUB)
C     ==--------------------------------------------------------------==
C     TRANSFORM THE DENSITY TO G SPACE
      NNX=NNR1*NLSD
C     Test SCR
      CALL GIVE_SCR_MOVERHO(LMOVERHO,TAG)
      CALL TEST_SCR('MOVERHO',TAG,LSCR,LMOVERHO)
C     First call, allocate DATOM.
      IF(IFIRST.EQ.0) THEN
        IFIRST=1
        CALL MEMORY(IP_DATOM,2*NSPLPO*NSP,'DATOM')
        IF(PARENT) CALL PRMEM('   MOVERHO')
        DO IS=1,NSP
          CALL ATDENS(IS,DATOM(1,1,IS),SCR(1),SCR(MMAXX+1))
        ENDDO
      ENDIF
C     Allocation inside SCR
#ifdef _BGL 
      NN=MAX(NR1S,NR2S,NR3S)
      CALL GET_ADDR(IP_EIG1,SCR(1))
      LMOVERHO=1+ 2*3*(2*NN-1)
      CALL GET_ADDR(IP_TSFAC,SCR(LMOVERHO))
      LMOVERHO=LMOVERHO+2*NHG
      CALL GET_ADDR(IP_RHOG,SCR(LMOVERHO))
      LMOVERHO=LMOVERHO+2*NHG
#else
      NN=MAX(NR1S,NR2S,NR3S)
      LMOVERHO=LMOVERHO-2*NHG
      CALL GET_ADDR(IP_RHOG,SCR(LMOVERHO+1))
      LMOVERHO=LMOVERHO-2*NHG
      CALL GET_ADDR(IP_TSFAC,SCR(LMOVERHO+1))
      LMOVERHO=LMOVERHO- 2*3*(2*NN-1)
      CALL GET_ADDR(IP_EIG1,SCR(LMOVERHO+1))
#endif
C     ==--------------------------------------------------------------==
      VOL=1.D0/DSQRT(OMEGA)
      NH1=NR1S/2+1
      NH2=NR2S/2+1
      NH3=NR3S/2+1
      IF(.NOT.TLSD) THEN
C$OMP parallel do private(IR)
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(10000))
#endif
        DO IR=1,NNR1
          PSI(IR)=DCMPLX(RHOE(IR,1),0.D0)
        ENDDO
        CALL FWFFT(PSI)
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(10000))
#endif
C$OMP parallel do private(IG)
        DO IG=1,NHG
          RHOG(IG)=PSI(NZH(IG))
        ENDDO
        ISA0=0
        DO IS=1,NSP
#ifdef  _BGL 
          CALL AZZERO(TSFAC,2*NHG)
#else
          CALL ZAZZERO(TSFAC,NHG)
#endif
          DO IA=1,NA(IS)
C           Generate structure factor for TAU0 config.
            SA1=(B1(1)*TAU0(1,IA,IS)+B1(2)*TAU0(2,IA,IS)+
     *          B1(3)*TAU0(3,IA,IS))*TPIBA
            SA2=(B2(1)*TAU0(1,IA,IS)+B2(2)*TAU0(2,IA,IS)+
     *          B2(3)*TAU0(3,IA,IS))*TPIBA
            SA3=(B3(1)*TAU0(1,IA,IS)+B3(2)*TAU0(2,IA,IS)+
     *          B3(3)*TAU0(3,IA,IS))*TPIBA
            EIG1(1,1)=DCMPLX(1.D0,0.D0)
            EIG1(2,1)=DCMPLX(1.D0,0.D0)
            EIG1(3,1)=DCMPLX(1.D0,0.D0)
            CTEP1=DCMPLX(DCOS(SA1),-DSIN(SA1))
            CTEP2=DCMPLX(DCOS(SA2),-DSIN(SA2))
            CTEP3=DCMPLX(DCOS(SA3),-DSIN(SA3))
            CTEM1=DCONJG(CTEP1)
            CTEM2=DCONJG(CTEP2)
            CTEM3=DCONJG(CTEP3)

            SVTMPP=CTEP1
            SVTMPM=CTEM1
            DO I=2,NR1S
              EI1(ISA,I)=SVTMPP
              SVTMPP=SVTMPP*CTEP1
              EI1(ISA,NR1S+I-1)=SVTMPM
              SVTMPM=SVTMPM*CTEM1
            ENDDO

            SVTMPP=CTEP2
            SVTMPM=CTEM2
            DO J=2,NR2S
              EI2(ISA,J)=SVTMPP
              SVTMPP=SVTMPP*CTEP2
              EI2(ISA,NR2S+J-1)=SVTMPM
              SVTMPM=SVTMPM*CTEM2
            ENDDO

            SVTMPP=CTEP3
            SVTMPM=CTEM3
            DO K=2,NR3S
              EI3(ISA,K)=SVTMPP
              SVTMPP=SVTMPP*CTEP3
              EI3(ISA,NR3S+K-1)=SVTMPM
              SVTMPM=SVTMPM*CTEM3
            ENDDO

            EI10=DCONJG(EIG1(1,NH1))
            EI20=DCONJG(EIG1(2,NH2))
            EI30=DCONJG(EIG1(3,NH3))
C$OMP parallel do private(I)
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(1000))
#endif
#ifdef __SR8000
*poption parallel, tlocal(I)
#endif 
            DO I=1,2*NR1S-1
              EIG1(1,I)=EIG1(1,I)*EI10
            ENDDO
C$OMP parallel do private(J)
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(1000))
#endif
#ifdef __SR8000
*poption parallel, tlocal(J)
#endif 
            DO J=1,2*NR2S-1
              EIG1(2,J)=EIG1(2,J)*EI20
            ENDDO
C$OMP parallel do private(K)
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(1000))
#endif
#ifdef __SR8000
*poption parallel, tlocal(K)
#endif 
            DO K=1,2*NR3S-1
              EIG1(3,K)=EIG1(3,K)*EI30
            ENDDO
            ISA=ISA0+IA
C$OMP parallel do private(IG)
#ifdef  _BGL 
!IBM* ASSERT (ITERCNT(1000))
#endif
#ifdef __SR8000
*poption parallel, tlocal(IG)
#endif 
            DO IG=1,NHG
              TSFAC(IG)=TSFAC(IG)+
     &             EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *             EI3(ISA,INYH(3,IG))-
     &             EIG1(1,INYH(1,IG))*EIG1(2,INYH(2,IG))*
     &             EIG1(3,INYH(3,IG))
            ENDDO
          ENDDO                 ! End loop over IA
          ISA0=ISA0+NA(IS)
C         Construct difference in atomic densities arising
C         from motion of ions
C$OMP parallel do private(IG,AR)
#ifdef  _BGL 
!IBM* ASSERT (ITERCNT(1000))
#endif
          DO IG=1,NHG          
            AR=CURV2(HG(IG),NSPLPO,GGNH(1),DATOM(1,1,IS),DATOM(1,2,IS),
     &               0.d0)
            RHOG(IG)=RHOG(IG) + DMOVRMIX*AR*VOL*TSFAC(IG)
          ENDDO
        ENDDO                   ! End loop over IS
C       FFT to real space 
#ifdef  _BGL 
        CALL AZZERO(PSI,2*MAXFFT)
#else
        CALL ZAZZERO(PSI,MAXFFT)
#endif
C$OMP parallel do private(IG)
!CDIR NODEP
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(1000))
#endif
        DO IG=2,NHG
          PSI(NZH(IG))=RHOG(IG)
          PSI(INDZ(IG))=DCONJG(RHOG(IG))
        ENDDO
        IF(GEQ0) PSI(NZH(1))=RHOG(1)
        CALL INVFFT(PSI)
        RSUM1=0.D0
C$OMP parallel do private(IR,RSTMP) reduction(+:RSUM1)
#ifdef  _BGL 
!IBM* INDEPENDENT, REDUCTION(RSUM1), NEW(RSTMP)
!IBM* ASSERT (ITERCNT(10000))
#endif
        DO IR=1,NNR1
          RSTMP=DREAL(PSI(IR))
          RHOE(IR,1)=RSTMP
          RSUM1 = RSUM1 + RSTMP
        ENDDO      
        RSUM1=RSUM1*OMEGA/DBLE(NR1S*NR2S*NR3S)
        RSUM = 0.0D0
        IF(GEQ0) RSUM = DREAL(RHOG(1)*OMEGA)
      ELSE
      ENDIF
      CALL TIHALT('   MOVERHO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_MOVERHO(LMOVERHO,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG NR1S NR2S NR3S MMAXX
      INCLUDE 'atwf.inc'        !TMOVR
      INCLUDE 'ropt.inc'        !MODENS
C     Arguments
      INTEGER   LMOVERHO
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      IF(MODENS.OR.TMOVR) THEN
        LMOVERHO=2*NHG+         !RHOG
     &       2*NHG+             !TSFAC
     &       2*3*(2*MAX(NR1S,NR2S,NR3S)-1) !EIG1
        LMOVERHO=MAX(LMOVERHO,2*MMAXX)+10
        TAG='4*NHG+6*MAX(NR1S,NR2S,NR3S)'
      ELSE
        LMOVERHO=0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
