C     ==================================================================
      SUBROUTINE MULLIKEN(ITYP,C0,NSTATE,TAU0,ACHRG,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == PROJECT WAVEFUNCTIONS ON PSEUDO ATOMIC ORBITALS              ==
C     == AND CALCULATE MULLIKEN POPULATION ANALYSIS                   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'prop.inc'
C     Arguments
      INTEGER    ITYP,NSTATE,LSCR
      REAL*8     TAU0(*),ACHRG(NAT),SCR(LSCR)
      COMPLEX*16 C0(NGW,*)
C     Variables
      DIMENSION  CATOM(NGW,NATTOT),F(*)
      REAL*8     FNL(*),DFNL(*)
      COMPLEX*16 CSCR(NGW,NATTOT)
      REAL*8     COMP(NUMORB),A(NATTOT*NATTOT),W(NATTOT),
     &           Z(NATTOT,NATTOT),AUX(3*NATTOT),
     *           QA(NAT,3),XTMAT(NATTOT,*)
      POINTER    (IP_CSCR,CSCR),(IP_COMP,COMP)
      POINTER    (IP_QA,QA),(IP_XTMAT,XTMAT)
      POINTER    (IP_A,A),(IP_W,W),(IP_Z,Z),(IP_AUX,AUX)
      CHARACTER TAG*30
      LOGICAL   TLSD2
      INTEGER   IFIRST,IAO,NAO,I,IZERO,K,IA,IS,N2,ISUB,NATST,IAORB,
     *          LMULLIKEN,IXX,J,IAT,NOMAX
      REAL*8    FOC(20),FAC,RLEN,QM,QL,SFC
      REAL*8    DDOT,DOTP
      EXTERNAL  DDOT,DOTP
      SAVE      IFIRST,IP_COMP,IP_QA,IP_CSCR,IP_XTMAT
      DATA      IFIRST /0/
C     ==--------------------------------------------------------------==
      CALL TISET('  MULLIKEN',ISUB)
C..Scratch space
      CALL GIVE_SCR_MULLIKEN(LMULLIKEN,TAG,NSTATE)
      CALL TEST_SCR('MULLIKEN',TAG,LSCR,LMULLIKEN)
C     ==--------------------------------------------------------------==
      NOMAX = MAX(NSTATE,NATTOT)
      IF(IFIRST.EQ.0) THEN
        CALL MEMORY(IP_COMP,NUMORB,'COMP')
        CALL MEMORY(IP_XTMAT,NATTOT*NOMAX,'XTMAT')
        CALL MEMORY(IP_XSMAT,NATTOT*NOMAX,'XSMAT')
        CALL MEMORY(IP_XXMAT,NATTOT*NOMAX,'XXMAT')
        CALL MEMORY(IP_CATOM,2*NGW*NATTOT,'CATOM')
        CALL MEMORY(IP_CSCR,2*NGW*NATTOT,'CSCR')
        CALL MEMORY(IP_QA,3*NAT,'QA')
        IFIRST=1
      ENDIF
C     ==--------------------------------------------------------------==
      CALL AZZERO(QA,3*NAT)
C..Load AO in PW basis
      IAORB=1
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          CALL LOADC(CSCR,FOC,NGW,NGW,NATTOT,IS,IAT,NATST)
          DO IXX=1,NATST
            SFC=DOTP(NGW,CSCR(1,IXX),CSCR(1,IXX))
            CALL GLOSUM(1,SFC)
            SFC=1.D0/SQRT(SFC)
            CALL DSCAL(2*NGW,SFC,CSCR(1,IXX),1)
          ENDDO
          CALL DCOPY(2*NGW*NATST,CSCR,1,CATOM(1,IAORB),1)
          IAORB=IAORB+NATST
        ENDDO
      ENDDO
C..Overlap matrix
      TLSD2=TLSD
      TLSD=.FALSE.
      CALL OVLAP(NATTOT,XSMAT,CATOM,CATOM)
      TLSD=TLSD2
      CALL SUMMAT(XSMAT,NATTOT,SCR,LSCR)
      CALL DCOPY(NATTOT*NATTOT,XSMAT,1,XTMAT,1)
C..O**(-1/2)
#ifdef _BGL 
      N2=NATTOT*NATTOT+MOD(NATTOT*NATTOT,2)
      CALL GET_ADDR(IP_A,SCR(1))
      CALL GET_ADDR(IP_W,SCR(1+N2))
      CALL GET_ADDR(IP_Z,SCR(1+N2+NATTOT+MOD(NATTOT,2)))
      CALL GET_ADDR(IP_AUX,SCR(1+2*N2+NATTOT+MOD(NATTOT,2)))
#else
      N2=NATTOT*NATTOT
      CALL GET_ADDR(IP_A,SCR(1))
      CALL GET_ADDR(IP_W,SCR(1+N2))
      CALL GET_ADDR(IP_Z,SCR(1+N2+NATTOT))
      CALL GET_ADDR(IP_AUX,SCR(1+2*N2+NATTOT))
#endif
      K=0
      DO J=1,NATTOT
        DO I=J,NATTOT
          K=K+1
          A(K)=XSMAT(I,J)
        ENDDO
      ENDDO
      CALL DSPEVY(1,A,W,Z,NATTOT,NATTOT,AUX,3*NATTOT)
      IZERO=0
      DO I=1,NATTOT
        IF(ABS(W(I)).LT.1.D-5) THEN
          W(I)=1.0D30
          IZERO=IZERO+1
          DO J=1,NATTOT
            Z(J,I)=0.0D0
          ENDDO
        ENDIF
      ENDDO
      IF(IZERO.NE.0) WRITE(6,'(A,I3)') 
     *  ' NUMBER OF LINEARLY DEPENDENT ATOMIC BASIS FUNCTIONS :',IZERO
      DO I=1,NATTOT
        W(I)=1.D0/SQRT(W(I))
      ENDDO
      CALL AZZERO(XSMAT,NATTOT*NATTOT)
      DO K=1,NATTOT
        DO J=1,NATTOT
          FAC=W(K)*Z(J,K)
          CALL DAXPY(NATTOT,FAC,Z(1,K),1,XSMAT(1,J),1)
        ENDDO
      ENDDO
C..Orthonormalize atomic orbitals
      CALL DGEMM('N','N',2*NGW,NATTOT,NATTOT,1.0D0,CATOM,2*NGW,XSMAT,
     *           NATTOT,0.0D0,CSCR,2*NGW)
      CALL DCOPY(2*NATTOT*NGW,CSCR,1,CATOM,1)
C..Overlap AO with wavefunctions
      CALL OVLAP2(NGW,NATTOT,NUMORB,XXMAT,CATOM,C0)
      CALL GLOSUM(NATTOT*NUMORB,XXMAT)
      IF(TIVAN) THEN
C..Calculate augmentation charges
        CALL AUGCHG(FNL,F,QA(1,3),NUMORB)
      ENDIF
      DO I=1,NUMORB
        RLEN=DOTP(NGW,C0(1,I),C0(1,I))
        CALL GLOSUM(1,RLEN)
        COMP(I)=DDOT(NATTOT,XXMAT(1,I),1,XXMAT(1,I),1)/RLEN
      ENDDO
      IF(PARENT) THEN
C..Lowdin Population Analysis
        IAT=0
        IAO=0
        DO IS=1,NSP
          NAO=NUMAOR(IS)
          DO IA=1,NA(IS)
            IAT=IAT+1
C..QA(.,3) is the true augmentation charge!
            QA(IAT,2)=ZV(IS)-QA(IAT,3)
            DO I=IAO+1,IAO+NAO
              DO J=1,NSTATE
                QA(IAT,2)=QA(IAT,2)-F(J)*XXMAT(I,J)**2
              ENDDO
            ENDDO
            IAO=IAO+NAO
          ENDDO
        ENDDO
      ENDIF
C..Rotate back to AO basis
      CALL DGEMM('N','N',NATTOT,NUMORB,NATTOT,1.0D0,XSMAT,NATTOT,
     *             XXMAT,NATTOT,0.0D0,SCR,NATTOT)
      CALL DCOPY(NATTOT*NUMORB,SCR,1,XXMAT,1)
      IF(PARENT) THEN
C..Mulliken Population Analysis
        DO I=1,NATTOT
          DO J=1,NATTOT
            XSMAT(I,J)=0.0D0
            DO K=1,NSTATE
              XSMAT(I,J)=XSMAT(I,J)+F(K)*XXMAT(I,K)*XXMAT(J,K)
            ENDDO
          ENDDO
        ENDDO
        CALL AZZERO(SCR,NATTOT)
        DO J=1,NATTOT
          DO I=1,NATTOT
            SCR(I)=SCR(I)+XSMAT(I,J)*XTMAT(I,J)
          ENDDO
        ENDDO
        IAT=0
        IAO=0
        DO IS=1,NSP
          NAO=NUMAOR(IS)
          DO IA=1,NA(IS)
            IAT=IAT+1
C..QA(.,3) is the true augmentation charge!
            QA(IAT,1)=ZV(IS)-QA(IAT,3)
            DO I=IAO+1,IAO+NAO
              QA(IAT,1)=QA(IAT,1)-SCR(I)
            ENDDO
            IAO=IAO+NAO
          ENDDO
        ENDDO
      ENDIF
C..unassigned charge
      QM=-CHARGE
      QL=-CHARGE
      DO IAT=1,NAT
        QM=QM+QA(IAT,1)
        QL=QL+QA(IAT,2)
      ENDDO
      QM=QM/DBLE(NAT)
      QL=QL/DBLE(NAT)
C..add unassigned charge
      DO IAT=1,NAT
        QA(IAT,1)=QA(IAT,1)-QM
        QA(IAT,2)=QA(IAT,2)-QL
      ENDDO
C..ITYP=1 --> MULLIKEN
C..ITYP=2 --> LOWDIN
      CALL DCOPY(NAT,QA(1,ITYP),1,ACHRG,1)
      CALL TIHALT('  MULLIKEN',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_MULLIKEN(LMULLIKEN,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !MMAXX NAX NGW
      INCLUDE 'atwf.inc'        !NATTOT
      INCLUDE 'prop.inc'        !NUMORB
C     Arguments
      INTEGER   LMULLIKEN,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   N2,LMAX,LSUM
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_SUMMAT(LSUM,TAG,NSTATE)
      N2=NATTOT*NATTOT
      LMAX=2*N2+4*NATTOT
      LMULLIKEN=MAX(LSUM,LMAX,NATTOT*NUMORB)
      TAG = 'MAX(LSUM,LMAX,NATTOT*NUMORB)'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
