C     ==================================================================
C     forwarding subroutine, to be able to use cray pointers with OpenMP
C     the real stuff is in NEWD_WORKER.
C     ==================================================================
      SUBROUTINE NEWD(FNLA,DEEQ,F,VPOT,FION,SCR,LSCR,NSTATE,TFOR)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'sfac.inc'
      INCLUDE 'ions.inc'
C     Arguments
      INTEGER    LSCR,NSTATE
      REAL*8     FNLA(LDF1,NHXS,*),DEEQ(NAT,NHXS,*),
     &           F(NSTATE),FION(3,NAX,NSX),SCR(LSCR)
      COMPLEX*16 VPOT(NHG)
      LOGICAL    TFOR
      REAL*8     FNL(*),DFNL(*)
C     cray pointers
      COMPLEX*16 VTMP(NHG,3),QG(NHG,*)
      REAL*8     YLM(NAX,*)
      POINTER    (IP_VTMP,VTMP),(IP_QG,QG),(IP_YLM,YLM)
C    local variables
      INTEGER    IL_VTMP,IL_QG,IL_YLM,ISUB,NHH
      LOGICAL    DEBUG
C     ==--------------------------------------------------------------==
      CALL TISET('      NEWD',ISUB)
      DEBUG = .FALSE.
      CALL SCRSET(SCR,LSCR,DEBUG)
C     SCR partition
      IF(BIGMEM) THEN
        NHH = (NHXS*(NHXS+1))/2
        IL_VTMP=NHG*6
        IL_QG  =NHH*NHG*2
        IL_YLM =NAX*(4+NHH)
      ELSE
        IL_VTMP=NHG*2
        IL_QG  =NHG*2
        IL_YLM =NAX
      ENDIF
      CALL SCRPTR(SCR,LSCR,IP_VTMP,IL_VTMP,'VTMP',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_QG,IL_QG,'QG',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_YLM,IL_YLM,'YLM',DEBUG)
C     ==--------------------------------------------------------------==
      CALL NEWD_WORKER(FNLA,DEEQ,F,VPOT,FION,NSTATE,TFOR,VTMP,QG,YLM)
C     ==--------------------------------------------------------------==
      CALL SCRREL(SCR,LSCR,DEBUG)
      CALL TIHALT('      NEWD',ISUB)
      RETURN
      END
C     ==================================================================
      SUBROUTINE NEWD_WORKER(FNLA,DEEQ,F,VPOT,FION,NSTATE,TFOR,
     &           VTMP,QG,YLM)
C     ==--------------------------------------------------------------==
C     ==         THIS ROUTINE CALCULATES THE ARRAY DEEQ               ==
C     ==                                                              ==
C     ==  DEEQ_I,IJ = OMEGA( V(G=0) Q_I,IJ(G=0) +                     ==
C     ==       2 SUM_G> RE[ V*(G) Q_I,IJ(G) E^-IG.R_I ] )             ==
C     ==                                                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE
      REAL*8     FNLA(LDF1,NHXS,*),DEEQ(NAT,NHXS,*),
     &           F(*),FION(3,NAX,*),YLM(NAX,*)
      COMPLEX*16 VPOT(*),VTMP(NHG,*),QG(NHG,*)
      LOGICAL    TFOR
C     Variables
      DIMENSION  EIGRB(NHG,NAT)
      REAL*8     FNL(*),DFNL(*)
      REAL*8     TOM,RHOVAN,OTR,FTMP,YTMP
      REAL*8     DOTP
      EXTERNAL   DOTP
      INTEGER    ISA0,ISA,IS,IJV,JV,IG,K,I,IA,IV,II,NHH
C     ==--------------------------------------------------------------==
      IF(BIGMEM) THEN
        ISA0=0
        DO IS=1,NSP
          IF(TVAN(IS)) THEN 
            IJV=0
            DO IV=1,NGH(IS)
              DO JV=IV,NGH(IS)
                IJV=IJV+1
                CALL QVAN2(IV,JV,IS,QG(1,IJV))
#if defined(__VECTOR)
C$OMP parallel do private(IG)
#else
C$OMP parallel do private(IG) schedule(static)
#endif
                DO IG=1,NHG
                  QG(IG,IJV)=DCONJG(QG(IG,IJV))*VPOT(IG)
                ENDDO
              ENDDO
            ENDDO
            NHH=(NGH(IS)*(NGH(IS)+1))/2
            TOM=2.0D0*OMEGA
            CALL DGEMM('T','N',NA(IS),NHH,2*NHG,TOM,EIGRB(1,ISA0+1),
     *                 2*NHG,QG(1,1),2*NHG,0.0D0,YLM(1,5),NAX)
            IJV=0
            DO IV=1,NGH(IS)
              DO JV=IV,NGH(IS)
                IJV=IJV+1
C               TOM=2.0D0*OMEGA
C               CALL DGEMV('T',2*NHG,NA(IS),TOM,EIGRB(1,ISA0+1),2*NHG,
C    *                     QG(1,IJV),1,0.0D0,DEEQ(ISA0+1,IV,JV),1)
!$OMP parallel do private(IA,ISA) shared(DEEQ)
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
                  DEEQ(ISA,IV,JV)=YLM(IA,4+IJV)
                  IF(GEQ0) DEEQ(ISA,IV,JV)=DEEQ(ISA,IV,JV)-
     *                     OMEGA*DREAL(QG(1,IJV)*EIGRB(1,ISA))
                  DEEQ(ISA,JV,IV)=DEEQ(ISA,IV,JV)
                ENDDO
              ENDDO
            ENDDO
            IF(TFOR) THEN
              IJV=0
              DO IV=1,NGH(IS)
                DO JV=IV,NGH(IS)
                  IJV=IJV+1
                  CALL AZZERO(YLM,NAX)
                  IF(TFDIST) THEN
!$OMP parallel do private(IA,ISA,II,I) shared(YLM)
                    DO IA=1,NA(IS)
                      ISA=ISA0+IA
                      IF(IATPE(ISA).EQ.MEPOS) THEN
                        II=ISA-IPEPT(1,MEPOS)+1
                        DO I=1,NSTATE
                          YLM(IA,1)=YLM(IA,1)+
     *                        F(I)*FNLA(II,IV,I)*FNLA(II,JV,I)
                        ENDDO
                      ENDIF
                    ENDDO
                    CALL GLOSUM(NA(IS),YLM)
                  ELSE
!$OMP parallel do private(IA,ISA,II,I) shared(YLM)
                    DO IA=1,NA(IS)
                      ISA=ISA0+IA
                      DO I=1,NSTATE
                        YLM(IA,1)=YLM(IA,1)+
     *                      F(I)*FNLA(ISA,IV,I)*FNLA(ISA,JV,I)
                      ENDDO
                    ENDDO
                  ENDIF
#if defined(__VECTOR)
!$OMP parallel do private(IG) shared(QG)
#else
!$OMP parallel do private(IG) shared(QG) schedule(static)
#endif
                  DO IG=1,NHG
                    VTMP(IG,1)=QG(IG,IJV)*DCMPLX(0.0D0,-GK(1,IG))
                    VTMP(IG,2)=QG(IG,IJV)*DCMPLX(0.0D0,-GK(2,IG))
                    VTMP(IG,3)=QG(IG,IJV)*DCMPLX(0.0D0,-GK(3,IG))
                  ENDDO 
                  IF(NA(IS).GT.2) THEN
                    ISA=ISA0+1
                    CALL DGEMM('T','N',NA(IS),3,2*NHG,2.D0,EIGRB(1,ISA),
     &                         2*NHG,VTMP,2*NHG,0.0D0,YLM(1,2),NAX)
                    IF(GEQ0)
     &                CALL DGER(NA(IS),3,-1.0D0,EIGRB(1,ISA),2*NHG,
     &                          VTMP,2*NHG,YLM(1,2),NAX)
                  ELSE
                    DO IA=1,NA(IS)
                      ISA=ISA0+IA
                      YLM(IA,2)=DOTP(NHG,VTMP(1,1),EIGRB(1,ISA))
                      YLM(IA,3)=DOTP(NHG,VTMP(1,2),EIGRB(1,ISA))
                      YLM(IA,4)=DOTP(NHG,VTMP(1,3),EIGRB(1,ISA))
                    ENDDO
                  ENDIF
                  FTMP=1.0D0
                  IF(IV.NE.JV) FTMP=2.0D0
                  DO IA=1,NA(IS)
                    OTR=FTMP*OMEGA*TPIBA*YLM(IA,1)
                    FION(1,IA,IS)=FION(1,IA,IS)+OTR*YLM(IA,2)
                    FION(2,IA,IS)=FION(2,IA,IS)+OTR*YLM(IA,3)
                    FION(3,IA,IS)=FION(3,IA,IS)+OTR*YLM(IA,4)
                  ENDDO
                ENDDO
              ENDDO
            ENDIF
          ENDIF
          ISA0=ISA0+NA(IS)
        ENDDO
      ELSE
C     ==--------------------------------------------------------------==
        ISA0=0
        DO IS=1,NSP
          IF(TVAN(IS)) THEN 
            IJV=0
            DO IV=1,NGH(IS)
              DO JV=IV,NGH(IS)
                IJV=IJV+1
                CALL QVAN2(IV,JV,IS,QG)
#if defined(__VECTOR)
!$OMP parallel do private(IG) shared(QG)
#else
!$OMP parallel do private(IG) shared(QG) schedule(static)
#endif
                DO IG=1,NHG
                  QG(IG,1)=DCONJG(QG(IG,1))*VPOT(IG)
                ENDDO
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
#if defined(__VECTOR)
!$OMP parallel do private(IG) shared(VTMP)
#else
!$OMP parallel do private(IG) shared(VTMP) schedule(static)
#endif
                  DO IG=1,NHG
                    VTMP(IG,1)=EI1(ISA,INYH(1,IG))*
     *                   EI2(ISA,INYH(2,IG))*EI3(ISA,INYH(3,IG))
                  ENDDO
                  DEEQ(ISA,IV,JV)=OMEGA*DOTP(NHG,QG(1,1),VTMP(1,1))
                  DEEQ(ISA,JV,IV)=DEEQ(ISA,IV,JV)
                  IF(TFOR) THEN
                    RHOVAN=0.0D0
                    IF(TFDIST) THEN
                      IF(IATPE(ISA).EQ.MEPOS) THEN
                        II=ISA-IPEPT(1,MEPOS)+1
!$OMP parallel do private(I) reduction(+:RHOVAN)
                        DO I=1,NSTATE
                          RHOVAN=RHOVAN+
     *                        F(I)*FNLA(II,IV,I)*FNLA(II,JV,I)
                        ENDDO
                      ENDIF
                      CALL GLOSUM(1,RHOVAN)
                    ELSE
!$OMP parallel do private(I) reduction(+:RHOVAN)
                      DO I=1,NSTATE
                        RHOVAN=RHOVAN+
     *                      F(I)*FNLA(ISA,IV,I)*FNLA(ISA,JV,I)
                      ENDDO
                    ENDIF
                    OTR=OMEGA*TPIBA*RHOVAN
                    DO K=1,3
                      CALL CFTEMP(NHG,QG(1,1),VTMP(1,1),GK,K,FTMP)
                      IF(IV.NE.JV) FTMP=2.0D0*FTMP
                      FION(K,IA,IS)=FION(K,IA,IS)+FTMP*OTR
                    ENDDO
                  ENDIF
                ENDDO
              ENDDO
            ENDDO
          ENDIF
          ISA0=ISA0+NA(IS)
        ENDDO
      ENDIF
#ifdef PARALLEL
      CALL GLOSUM(NAT*NHXS*NHXS,DEEQ)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CFTEMP(NHG,QG,VTMP,GK,K,FTMP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NHG,K
      REAL*8  QG(2,NHG),VTMP(2,NHG),GK(3,NHG),FTMP
C     Variables
      INTEGER IG
C     ==--------------------------------------------------------------==
C     G=0 TERM IS ZERO !
      FTMP=0.0D0
#if defined(__VECTOR)
!$OMP parallel do private(IG) reduction(+:FTMP)
#else
!$OMP parallel do private(IG) reduction(+:FTMP) schedule(static)
#endif
      DO IG=1,NHG
        FTMP=FTMP+GK(K,IG)*(VTMP(1,IG)*QG(2,IG)-VTMP(2,IG)*QG(1,IG))
      ENDDO
      FTMP=2.0D0*FTMP
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_NEWD(LNEWD,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG TGC
C     Arguments
      INTEGER   LNEWD
      CHARACTER TAG*30
C     Variables
      INTEGER NHH
C     ==--------------------------------------------------------------==
      IF(BIGMEM) THEN
        NHH = (NHXS*(NHXS+1))/2
        LNEWD = 2*NHG*NHH + 6*NHG + NAX*(4+NHH) + 100
      ELSE
        LNEWD = 2*NHG + 6*NHG + NAX + 100
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

