C     ==================================================================
      SUBROUTINE NL_RES(IS,ISA,K,C2,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE,IS,ISA,K,LSCR
      COMPLEX*16 C2(NGW,NSTATE)
      REAL*8     SCR(LSCR)
C     Variables
      CHARACTER*30 TAG
      DIMENSION  F(NSTATE)
      DIMENSION  EIGR(NGW,NAT),TWNL(NGW,NHXS,NSX),
     &           FNL2(NAT,NHXS,LDF2)
      REAL*8     FNL(LDF1,NHXS,NSTATE),DFNL(NAT,NHXS,3,NDFNL)
      POINTER    (IP_FT,FT),(IP_DFT,DFT)
      REAL*8     FT(NHXS,NSTATE),DFT(NHXS,NSTATE),TFT,TDFT,T
      COMPLEX*16 CTM,G
      INTEGER    LNL_RES,I,IV,JV,IAA,L,KI,LI,L2,LJ,KJ,IG,II,ISUB
      LOGICAL    DEBUG
C     ==--------------------------------------------------------------==
      IF(NGW.EQ.0) RETURN
      CALL TISET('    NL_RES',ISUB)
      CALL GIVE_SCR_NL_RES(LNL_RES,NSTATE,TAG)
      CALL TEST_SCR('NL_RES',TAG,LSCR,LNL_RES)
C
      DEBUG=.FALSE.
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_FT,NHXS*NSTATE,'FT',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_DFT,NHXS*NSTATE,'DFT',DEBUG)
C..collect all the FNL and DFNL elements used
      CALL AZZERO(FT,NHXS*NSTATE)
      CALL AZZERO(DFT,NHXS*NSTATE)
      IF(TFDIST) THEN
        DO I=NST12(MEPOS,1),NST12(MEPOS,2)
          II=I-NST12(MEPOS,1)+1
          DO IV=1,NGH(IS)
            FT(IV,I)=FNL2(ISA,IV,II)
          END DO
        END DO
        CALL GLOSUM(NHXS*NSTATE,FT)
      ELSE
        DO I=1,NSTATE
          DO IV=1,NGH(IS)
            FT(IV,I)=FNL(ISA,IV,I)
          END DO
        ENDDO
      ENDIF
      DO I=NST12(MEPOS,1),NST12(MEPOS,2)
        II=I-NST12(MEPOS,1)+1
        DO IV=1,NGH(IS)
          DFT(IV,I)=DFNL(ISA,IV,K,II)
        END DO
      END DO
      CALL GLOSUM(NHXS*NSTATE,DFT)
C
      CALL AZZERO(C2,2*NGW*NSTATE)
C
      DO I=1,NSTATE
        IF(TVAN(IS)) THEN
          CALL STOPGM('FNONLOC_P','VDB not implemented')
        ELSEIF(TSGP(IS)) THEN
C     ==--------------------------------------------------------------==
C     ==  Stefan Goedeckers PP                                        ==
C     ==--------------------------------------------------------------==
          DO IV=1,NGH(IS)
            L=NGHTOL(IV,IS)+1
            KI=LFVAL(IV,IS)
            LI=LPVAL(IV,IS)
            TFT=0.D0
            TDFT=0.D0
            DO JV=1,NGH(IS)
              L2=NGHTOL(JV,IS)+1
              LJ=LPVAL(JV,IS)
              IF(L.EQ.L2.AND.LI.EQ.LJ) THEN
                KJ=LFVAL(JV,IS)
                TFT=TFT+FT(JV,I)*HLSG(KI,KJ,L,IS)
                TDFT=TDFT+DFT(JV,I)*HLSG(KI,KJ,L,IS)
              ENDIF
            ENDDO
            CTM=-F(I)*(0.0D0,-1.0D0)**NGHTOL(IV,IS)
            DO IG=1,NGW
              G=DCMPLX(0.D0,-GK(K,IG))*TPIBA
              C2(IG,I)=C2(IG,I)+CTM*EIGR(IG,ISA)*TWNL(IG,IV,IS)*
     &                 (TDFT+G*TFT)
            ENDDO
          ENDDO
        ELSE
C     ==--------------------------------------------------------------==
C     ==  BACHELET HAMANN SCHLUTER                                    ==
C     ==--------------------------------------------------------------==
          DO IV=1,NGH(IS)
            T=-F(I)*WSG(IS,IV)
            CTM=T*(0.0D0,-1.0D0)**NGHTOL(IV,IS)
            DO IG=1,NGW
              G=DCMPLX(0.D0,-GK(K,IG))*TPIBA
              C2(IG,I)=C2(IG,I)+CTM*EIGR(IG,ISA)*TWNL(IG,IV,IS)*
     &                 (DFT(IV,I)+G*FT(IV,I))
            ENDDO
          ENDDO
C     ==--------------------------------------------------------------==
        ENDIF
      ENDDO
      CALL SCRREL(SCR,LSCR,DEBUG)
      CALL TIHALT('    NL_RES',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_NL_RES(LNL_RES,NSTATE,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INTEGER LNL_RES,NSTATE
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      LNL_RES=NHXS*NSTATE*2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

