C     ==================================================================
      SUBROUTINE NLCCSET
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==           THE FORM FACTORS OF THE CORE CHARGES               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'vdbp.inc'
C     Variables
      DIMENSION RHOC(NHG,NSP),GGNH(NSPLPO)
      DIMENSION RHOCSPL(NSPLPO,2,NSP)
      REAL*8    WORK(MMAXX)
      POINTER   (IP_WORK,WORK)
      REAL*8    VOL,XG,CPI,ARG,TMP,
     &          CURV2
      INTEGER   ISUB,IS,IL,IG,IERR,M,IR
      INTEGER   IFIRST
      SAVE      IFIRST
      DATA      IFIRST /0/
C     ==--------------------------------------------------------------==
      CALL TISET('   NLCCSET',ISUB)
C     ==--------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN
        CALL MEMORY(IP_RHOCSPL,NSPLPO*2*NSP,'RHOCSPL')
        CALL AZZERO(RHOCSPL,NSPLPO*2*NSP)
        IFIRST=1
        CALL MEMORY(IP_WORK,MMAXX,'WORK')
C     ==--------------------------------------------------------------==
        DO IS=1,NSP
          IF(TNLCC(IS)) THEN
            IF(TVAN(IS)) THEN
C..VDBT
              WORK(1) = 0.D0
              DO IR=2,MESHVA(IS)
                WORK(IR)=RSCORE(IR,IS)
              ENDDO
              IF(TLOG(IS)) THEN
                CALL RADLG(MESHVA(IS),WORK,RAB(1,IS),TMP)
              ELSE
                CALL RADIN(MESHVA(IS),CMESH(IS),WORK,TMP)
              ENDIF
              DO IL=NSPLPA,NSPLPE
                IF(IL.NE.1) THEN
                  XG=SQRT(GGNH(IL))*TPIBA
                  WORK(1) = 0.D0
                  DO IR=2,MESHVA(IS)
                     WORK(IR)=RSCORE(IR,IS)*SIN(XG*R(IR,IS))/R(IR,IS)
                  ENDDO
                  IF(TLOG(IS)) THEN
                     CALL RADLG(MESHVA(IS),WORK,RAB(1,IS),TMP)
                  ELSE
                     CALL RADIN(MESHVA(IS),CMESH(IS),WORK,TMP)
                  ENDIF
                  RHOCSPL(IL,1,IS) = TMP/XG
                ELSE
                  RHOCSPL(1,1,IS) = TMP
                ENDIF
              ENDDO
              CALL GLOSUM(NSPLPO,RHOCSPL(1,1,IS))
              CALL CURV1(NSPLPO,GGNH(1),RHOCSPL(1,1,IS),
     *                   0.d0,0.d0,3,RHOCSPL(1,2,IS),WORK,0.d0,IERR)
            ELSEIF(NLCCT(IS).EQ.2) THEN
C             NUMERICAL FORM
              TMP = 0.D0
              DO IL = MESHCC(IS),1,-1
                TMP=TMP+ABS(CORECG(IL,IS))
                IF(TMP.GT.1.D-8) THEN
                  M = IL
                  GOTO 100
                ENDIF
              ENDDO
              M=MESHCC(IS)
  100         CONTINUE
              DO IL=NSPLPA,NSPLPE
                XG=SQRT(GGNH(IL))*TPIBA
                CALL BESSOV(RCGRID(1,IS),CLOGCC(IS),M,
     *                      CORECG(1,IS),0,XG,RCGRID(M,IS),TMP)
                RHOCSPL(IL,1,IS)=TMP*FPI
              ENDDO
              CALL GLOSUM(NSPLPO,RHOCSPL(1,1,IS))
              CALL CURV1(NSPLPO,GGNH(1),RHOCSPL(1,1,IS),
     *                   0.d0,0.d0,3,RHOCSPL(1,2,IS),WORK,0.d0,IERR)
            ELSEIF (NLCCT(IS).EQ.1) THEN
C             ANALYTICAL FORM
              CPI=(PI/ENLCC(IS))**1.5D0
C$OMP parallel do private(IG,ARG)
#ifdef __SR8000
*poption parallel, tlocal(IG,ARG)
#endif 
              DO IG=1,NSPLPO
                ARG=TPIBA2*GGNH(IG)/ENLCC(IS)/4.0D0
                RHOCSPL(IG,1,IS)=(ANLCC(IS)+
     *             BNLCC(IS)/ENLCC(IS)*(1.5D0-ARG))*DEXP(-ARG)*CPI
              ENDDO
            ELSE
              WRITE(6,*) ' UNKNOWN TYPE OF NLCC'
              CALL STOPGM('NLCCSET',' ')
            ENDIF
          ENDIF
        ENDDO
        CALL FREEM(IP_WORK)
      ENDIF
C     ==--------------------------------------------------------------==
      VOL=1.D0/OMEGA
      DO IS=1,NSP
        IF(TNLCC(IS)) THEN
C$OMP parallel do private(IG) shared(NSPLPO)
#ifdef __SR8000
*poption parallel, tlocal(IG)
#endif 
          DO IG=1,NHG
            RHOC(IG,IS)=VOL*CURV2(HG(IG),NSPLPO,GGNH(1),
     *                  RHOCSPL(1,1,IS),RHOCSPL(1,2,IS),0.d0)
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      CALL TIHALT('   NLCCSET',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
