C     ==================================================================
      SUBROUTINE NLCCSTR(V,VGC)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==           EXCHANGE AND CORRELATION ENERGY CONTRIBUTION       ==
C     ==                 OF CORE CHARGE TO STRESS TENSOR              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'spin.inc'
C     Arguments
      COMPLEX*16 V(NNR1,*),VGC(*)
C     Variables
      REAL*8     FNL(*),DFNL(*)
      DIMENSION  DRHOC(NHG,NSX,6),EIGRB(*)
      REAL*8     DOTP
      EXTERNAL   DOTP
      INTEGER    ISUB,KK
C     ==--------------------------------------------------------------==
      CALL TISET('   NLCCSTR',ISUB)
      IF(TLSD) THEN
        CALL FWFFT(V(1,1))
        CALL ZGTHR(NHG,V,VGC,NZH)
        CALL DCOPY(2*NHG,VGC,1,V(1,1),1)
        CALL FWFFT(V(1,2))
        CALL ZGTHR(NHG,V(1,2),VGC,NZH)
        CALL DCOPY(2*NHG,VGC,1,V(1,2),1)
      ELSE
        CALL FWFFT(V)
        CALL ZGTHR(NHG,V,VGC,NZH)
        CALL DCOPY(2*NHG,VGC,1,V,1)
      ENDIF
      DO KK=1,6
        CALL DRHOCORE(VGC,DRHOC(1,1,KK),EIGRB,EI1,EI2,EI3,INYH)
        IF(TLSD) THEN
          DECC(KK)=DECC(KK)+DOTP(NHG,VGC,V(1,1))
          DECC(KK)=DECC(KK)+DOTP(NHG,VGC,V(1,2))
        ELSE
          DECC(KK)=DECC(KK)+DOTP(NHG,VGC,V)
        ENDIF
      ENDDO
      CALL TIHALT('   NLCCSTR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
