C     ==================================================================
      SUBROUTINE NLFORCE(C2,F,GAM,AUXC,DDIA,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'tbxc.inc'   ! for TOLDCODE
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C2(NGW,*),AUXC(NGW,*)
      REAL*8     F(*),GAM(NSTATE,*),DDIA(NAX,*)
C     Variables
      DIMENSION  EIGR(NGW,*),TWNL(NGW,NHXS,*)
      COMPLEX*16 CTM,CT
      REAL*8     FNL(NAT,NHXS,*),DFNL(*)
      REAL*8     FFI,FAC,DD
      INTEGER    ISUB,I,ISPIN,ISA0,IS,IV,JV,IA,ISA,J,NMIN,NMAX,IG,L,
     &           KI,LI,L2,LJ,KJ
C     ==--------------------------------------------------------------==
C     == Compute the non-local contributions to the electron gradient ==
C     ==--------------------------------------------------------------==
      CALL TISET('   NLFORCE',ISUB)
      IF(IMAGP.EQ.2) CALL STOPGM('NLFORCE','K-POINT NOT IMPLEMENTED')
      IF(TFDIST) CALL STOPGM('NLFORCE','FNL DIST. NOT IMPLEMENTED')
C     ==--------------------------------------------------------------==
C     FIXME: AK 2008/02/14: this was broken by changes from 2006/05/12.
C                           not sure whether those were the real cause.
C                           undoing those changes does not make it work
C                           again. so we stop here until somebody fixes it
C     UPDATE AK 2008/05/24: it looks as if it can be worked around using 
C                           OLDCODE. it seems to be faster, too.
      IF(TIVAN.AND.TLSD) THEN
        IF(.NOT.TOLDCODE)
     &    CALL STOPGM('NLFORCE','VANDERBILT WITH LSD REQUIRES USE OF'
     &         // ' "OLDCODE" FLAG IN &DFT SECTION.')
      ENDIF
C     ==--------------------------------------------------------------==
      ISA0=0
      DO IS=1,NSP
        IF(TVAN(IS)) THEN
C         ==--------------------------------------------------------==
C         ==  VANDERBILT PP                                         ==
C         ==--------------------------------------------------------==
          DO IV=1,NGH(IS)
            CALL AZZERO(DDIA,NAX*NSTATE)
            DO I=NST12(MEPOS,1),NST12(MEPOS,2)
              FFI=F(I)
              IF(FFI.LT.1.D-5) FFI=1.0D0
              ISPIN=1
              IF(TLSD.AND.I.GT.NSUP) ISPIN=2
              DO JV=1,NGH(IS)
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
                  DDIA(IA,I)=DDIA(IA,I)-FFI*FNL(ISA,JV,I)*
     *                         (DEEQ(ISA,JV,IV,ISPIN)+DVAN(JV,IV,IS))
                ENDDO
                IF(ABS(QQ(JV,IV,IS)).GT.1.D-5) THEN
                  IF(IPROJ.EQ.1.AND.PARENT) THEN
                    FAC=-GAM(I,I)*QQ(JV,IV,IS)
                    CALL DAXPY(NA(IS),FAC,FNL(ISA0+1,JV,I),1,
     *                         DDIA(1,I),1)
                  ELSE
                    IF(TLSD) THEN
                      IF(I.LE.NSUP) THEN
                        NMIN=1
                        NMAX=NSUP
                      ELSE
                        NMIN=NSUP+1
                        NMAX=NSTATE
                      ENDIF
                    ELSE
                      NMIN=1
                      NMAX=NSTATE
                    ENDIF
                    DO J=NMIN,NMAX
                      FAC=-GAM(I,J)*QQ(JV,IV,IS)
                      CALL DAXPY(NA(IS),FAC,FNL(ISA0+1,JV,J),1,
     &                           DDIA(1,I),1)
                    ENDDO
                  ENDIF
                ENDIF
              ENDDO
            ENDDO
            CALL GLOSUM(NSTATE*NAX,DDIA)
            IF(NGW.GT.0)
     *      CALL DGEMM('N','N',2*NGW,NSTATE,NA(IS),1.0D0,
     *                 EIGR(1,ISA0+1),2*NGW,DDIA,NAX,0.0D0,AUXC,2*NGW)
            CTM=(0.0D0,-1.0D0)**NGHTOL(IV,IS)
C$OMP parallel do private(IG,I)
            DO I=1,NSTATE
#ifdef  _BGL
!IBM*   UNROLL(10)
!IBM*   ASSERT (ITERCNT(1000))
#endif
              DO IG=1,NGW
                AUXC(IG,I)=CTM*AUXC(IG,I)
                C2(IG,I)=C2(IG,I)+TWNL(IG,IV,IS)*AUXC(IG,I)
              ENDDO
            ENDDO
          ENDDO
        ELSEIF(TSGP(IS)) THEN
C         ==--------------------------------------------------------==
C         ==  Stefan Goedecker PP                                   ==
C         ==--------------------------------------------------------==
          DO IV=1,NGH(IS)
            CALL ZAZZERO(AUXC,NGW*NSTATE)
            CALL AZZERO(DDIA,NAX*NSTATE)
            DO I=NST12(MEPOS,1),NST12(MEPOS,2)
              FFI=F(I)
              IF(FFI.LT.1.D-5) FFI=1.0D0
              DO IA=1,NA(IS)
                ISA=ISA0+IA
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DD=0.0D0
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L.EQ.L2.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    DDIA(IA,I)=DDIA(IA,I)+
     &                      FNL(ISA,JV,I)*HLSG(KI,KJ,L,IS)
                  ENDIF
                ENDDO
              ENDDO
            ENDDO
            CALL GLOSUM(NSTATE*NAX,DDIA)
            IF(NGW.GT.0)
     *      CALL DGEMM("N","N",2*NGW,NSTATE,NA(IS),1.D0,
     *            EIGR(1,ISA0+1),2*NGW,DDIA(1,1),NAX,0.D0,AUXC,2*NGW)
            CT=(0.0D0,-1.0D0)**NGHTOL(IV,IS)
C$OMP parallel do private(IG,I,FFI,CTM)
            DO I=1,NSTATE
              FFI=F(I)
              IF(FFI.LT.1.D-5) FFI=1.0D0
              CTM=-FFI*CT
#ifdef  _BGL
!IBM*   UNROLL(10)
!IBM*   ASSERT (ITERCNT(1000))
#endif
              DO IG=1,NGW
                AUXC(IG,I)=CTM*AUXC(IG,I)
                C2(IG,I)=C2(IG,I)+TWNL(IG,IV,IS)*AUXC(IG,I)
              ENDDO
            ENDDO
          ENDDO
        ELSE
C         ==--------------------------------------------------------==
C         ==  BACHELET HAMANN SCHLUTER                              ==
C         ==--------------------------------------------------------==
          DO IV=1,NGH(IS)
            CALL AZZERO(DDIA,NAX*NSTATE)
            DO I=NST12(MEPOS,1),NST12(MEPOS,2)
              CALL DCOPY(NA(IS),FNL(ISA0+1,IV,I),1,DDIA(1,I),1)
            ENDDO
            CALL GLOSUM(NSTATE*NAX,DDIA)
            IF(NGW.GT.0)
     &      CALL DGEMM('N','N',2*NGW,NSTATE,NA(IS),1.D0,
     &                 EIGR(1,ISA0+1),2*NGW,DDIA,NAX,0.0D0,AUXC,2*NGW)
            CT=(0.0D0,-1.0D0)**NGHTOL(IV,IS)*WSG(IS,IV)
C$OMP parallel do private(IG,I,FFI,CTM)
            DO I=1,NSTATE
              FFI=F(I)
              IF(FFI.LT.1.D-5) FFI=1.0D0
              CTM=-FFI*CT
#ifdef  _BGL
!IBM*   UNROLL(10)
!IBM*   ASSERT (ITERCNT(1000))
#endif
              DO IG=1,NGW
                AUXC(IG,I)=CTM*AUXC(IG,I)
                C2(IG,I)=C2(IG,I)+TWNL(IG,IV,IS)*AUXC(IG,I)
              ENDDO
            ENDDO
          ENDDO
C     ==--------------------------------------------------------------==
        ENDIF
        ISA0=ISA0+NA(IS)
      ENDDO
      CALL TIHALT('   NLFORCE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_NLFORCE(IL_GAM,IL_AUXC,IL_DDIA,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGWK NAX
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'nlps.inc'        !IMAGP
C     Arguments
      INTEGER IL_GAM,IL_AUXC,IL_DDIA,NSTATE
C     ==--------------------------------------------------------------==
      IL_GAM =IMAGP*NSTATE*NSTATE
      IL_AUXC=2*NGWK*NSTATE+2
      IL_DDIA=2*NAX*NSTATE+2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      
