C     ==================================================================
      SUBROUTINE NLSL(GAMMA,NSTATE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==        THE STRESS TENSOR CONTRIBUTION DUE TO THE             ==
C     ==  ORTHOGONALITY CONSTRAINED IN VANDERBILT PSEUDO-POTENTIALS   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'str2.inc'
C     Arguments
      INTEGER   NSTATE
      REAL*8    GAMMA(NSTATE,*)
C     Variables
      DIMENSION BECS(NAT,NHXS,6,*)
      REAL*8    FNL(NAT,NHXS,*),DFNL(*)
      REAL*8     TEMP,TT,TK
      INTEGER   ISUB,KK,ISA0,IS,IV,JV,I,II,J,IA,ISA
C     ==--------------------------------------------------------------==
      CALL TISET('      NLSL',ISUB)
      IF(TFDIST) CALL STOPGM('NLSL','TFDIST NOT IMPLEMENTED')
      IF(IMAGP.EQ.2)CALL STOPGM('NLSL','K-POINT NOT IMPLEMENTED')
      DO KK=1,6
        TT=0.0D0
        ISA0=0
        DO IS=1,NSP
          IF(TVAN(IS)) THEN
            DO IV=1,NGH(IS)
              DO JV=IV,NGH(IS)
                TEMP=QQ(IV,JV,IS)
                IF(ABS(TEMP).GT.1.D-5) THEN
                  IF(IV.NE.JV) TEMP=2.0D0*TEMP
C                 This loops are split to get better cash usage
                  DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                    II=I-NST12(MEPOS,1)+1
                    DO J=I,NSTATE
                      TK=TEMP*GAMMA(I,J)
                      IF(I.EQ.J) TK=0.5D0*TK
                      DO IA=1,NA(IS)
                        ISA=ISA0+IA
                        TT=TT + TK * BECS(ISA,IV,KK,II)*FNL(ISA,JV,J)
                      ENDDO
                    ENDDO
                  ENDDO
                  DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                    II=I-NST12(MEPOS,1)+1
                    DO J=I,NSTATE
                      TK=TEMP*GAMMA(J,I)
                      IF(I.EQ.J) TK=0.5D0*TK
                      DO IA=1,NA(IS)
                        ISA=ISA0+IA
                        TT=TT + TK * BECS(ISA,JV,KK,II)*FNL(ISA,IV,J)
                      ENDDO
                    ENDDO
                  ENDDO
                  DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                    II=I-NST12(MEPOS,1)+1
                    DO J=I,NSTATE
                      TK=TEMP*GAMMA(I,J)
                      IF(I.EQ.J) TK=0.5D0*TK
                      DO IA=1,NA(IS)
                        ISA=ISA0+IA
                        TT=TT + TK * BECS(ISA,JV,KK,II)*FNL(ISA,IV,J)
                      ENDDO
                    ENDDO
                  ENDDO
                  DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                    II=I-NST12(MEPOS,1)+1
                    DO J=I,NSTATE
                      TK=TEMP*GAMMA(J,I)
                      IF(I.EQ.J) TK=0.5D0*TK
                      DO IA=1,NA(IS)
                        ISA=ISA0+IA
                        TT=TT + TK * BECS(ISA,IV,KK,II)*FNL(ISA,JV,J)
                      ENDDO
                    ENDDO
                  ENDDO
                ENDIF
              ENDDO
            ENDDO
          ENDIF
          ISA0=ISA0+NA(IS)
        ENDDO
        DLAM(KK) = -TT
      ENDDO
      CALL TIHALT('      NLSL',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
