C     ==================================================================
      SUBROUTINE NLSM1_S(C0,SCR,DAI,NSTATE,IKIND)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE ARRAY BECS (THE DERIVATIVE OF FNL WITH RESPECT TO H)    ==
C     ==  USE BETAA (DERIVATIVE OF TWNL) WHICH IS COMPUTED            ==
C     ==            IN THE SUBROUTINE PUTBET                          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h' 
      include 'nlps.inc'
      include 'ions.inc'
      include 'cppt.inc'
      include 'sfac.inc'
      include 'strs.inc'
      include 'str2.inc'
      include 'geq0.inc'
      include 'kpts.inc'
      include 'kpnt.inc' 
C     Arguments
      INTEGER    NSTATE,IKIND
      COMPLEX*16 C0(NGWK,NSTATE),SCR(NGWK,NAT)
      REAL*8     DAI(IMAGP,NAX,NSTATE)
C     Variables
      DIMENSION  BECS(IMAGP,NAT,NHXS,6,NDFNL,NKPNT),
     &           EIGKR(NGWK,NAT,NKPNT)
      COMPLEX*16 ZONE,ZZERO
      PARAMETER  (ZZERO=(0.D0,0.D0),ZONE=(1.D0,0.D0))
      REAL*8     FNL(*),DFNL(*)
      COMPLEX*16 CI
      REAL*8     CIR,CII,ER,EI,T
      INTEGER    ISUB,ISA0,IS,IA,KK,ISA,IG,II,I,IV
C     ==--------------------------------------------------------------==
      CALL TISET('   NLSM1_S',ISUB)
      ISA0=0
      DO IS=1,NSP
        DO IV=1,NGH(IS)
          CI=(0.0D0,-1.0D0)**NGHTOL(IV,IS)
          CIR=DREAL(CI)
          CII=DIMAG(CI)
          DO KK=1,6
C           MAKE USE OF THE SPECIAL STRUCTURE OF CI
            IF(ABS(CIR).GT.0.5D0) THEN
C             CI IS REAL
#ifdef __SR8000
*poption parallel, tlocal(IA,IG,ISA,ER,EI,T)
#endif 
!$OMP parallel do private(IA,IG,ISA,ER,EI,T)
              DO IA=1,NA(IS)
                ISA=ISA0+IA
                DO IG=1,NGWK
                  ER=DREAL(EIGKR(IG,ISA,IKIND))
                  EI=DIMAG(EIGKR(IG,ISA,IKIND))
                  T=BETAA(IG,IV,KK,IS,IKIND)*CIR
                  SCR(IG,IA)=DCMPLX(T*ER,T*EI)
                ENDDO
              ENDDO 
            ELSE
C             CI IS IMAGINARY
#ifdef __SR8000
*poption parallel, tlocal(IA,IG,ISA,ER,EI,T)
#endif 
!$OMP parallel do private(IA,IG,ISA,ER,EI,T)
              DO IA=1,NA(IS)
                ISA=ISA0+IA
                DO IG=1,NGWK
                  ER=DREAL(EIGKR(IG,ISA,IKIND))
                  EI=DIMAG(EIGKR(IG,ISA,IKIND))
                  T=BETAA(IG,IV,KK,IS,IKIND)*CII
                  SCR(IG,IA)=DCMPLX(-T*EI,T*ER)
                ENDDO
              ENDDO 
            ENDIF
            IF(GEQ0) THEN 
              IF(TKPNT) THEN
!$OMP parallel do private(IA)
                DO IA=1,NA(IS)
                  SCR(NGW+1,IA)=DCMPLX(0.D0,0.D0)
                ENDDO 
              ELSE
!$OMP parallel do private(IA)
                DO IA=1,NA(IS)
                  SCR(1,IA)=0.5D0*SCR(1,IA)
                ENDDO 
              ENDIF
            ENDIF
            IF(TKPNT) THEN
              CALL ZGEMM('C','N',NA(IS),NSTATE,NGWK,ZONE,SCR(1,1),
     &             NGWK,C0(1,1),NGWK,ZZERO,
     &             DAI(1,1,1),NAX)
            ELSE
              CALL DGEMM('T','N',NA(IS),NSTATE,2*NGW,2.0D0,SCR(1,1),
     &             2*NGW,C0(1,1),2*NGW,0.0D0,DAI(1,1,1),NAX)
            ENDIF
#ifdef PARALLEL
            CALL GLOSUM(IMAGP*NAX*NSTATE,DAI)
#endif
#ifdef __VECTOR 
            IF(IMAGP.EQ.1) THEN 
#ifdef __SR8000
*poption parallel, tlocal(I,IA,II)
#endif 
!$OMP parallel do private(I,IA,II)
              DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                II=I-NST12(MEPOS,1)+1
                DO IA=1,NA(IS)
                  BECS(1,ISA0+IA,IV,KK,II,IKIND)=DAI(1,IA,I)
                ENDDO 
              ENDDO 
            ELSE 
#ifdef __SR8000
*poption parallel, tlocal(I,IA,II)
#endif 
!$OMP parallel do private(I,IA,II)
              DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                II=I-NST12(MEPOS,1)+1
                DO IA=1,NA(IS)
                  BECS(1,ISA0+IA,IV,KK,II,IKIND)=DAI(1,IA,I)
                  BECS(2,ISA0+IA,IV,KK,II,IKIND)=DAI(2,IA,I)
                ENDDO 
              ENDDO 
            ENDIF 
#else 
            DO I=NST12(MEPOS,1),NST12(MEPOS,2)
              II=I-NST12(MEPOS,1)+1
              CALL DCOPY(IMAGP*NA(IS),DAI(1,1,I),1,
     &                   BECS(1,ISA0+1,IV,KK,II,IKIND),1)
            ENDDO
#endif 
          ENDDO
        ENDDO
        ISA0=ISA0+NA(IS)
      ENDDO
      CALL TIHALT('   NLSM1_S',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
