#define split_suscept_contribs 0
c     ==================================================================
      SUBROUTINE calc_chi_L(c0,c1,nstate,b,psi,scr)
      implicit none
      include    'system.h'
      include    'cppt.inc'
      include    'fft.inc'
      include    'response_p.inc'    ! chi(3,3,nstate)
      include    'elct.inc'
      complex*16 c0(ngw,*),c1(ngw,*),psi(*)
      real*8     scr(nnr1,3),contrib,DOTP,EPSI
      external   DOTP
      integer    a,b,is,nstate,isub,k,l,bb
      dimension  f(nstate)
      call tiset('chi-L     ',isub)
c     =----------------------------------------------------------------=
c     ==  x_ab = Int[ r x (phi1_b grad phi0 - phi0 grad phi1_b) ]_a   ==
c     ==  where phi1_a is the response to a perturbation L_a.         ==
c     ==  The two contributions are equal.                            ==
c     =----------------------------------------------------------------=
c     scr(*,k) = r_k psi1_b   (b=fix)
      call azzero(scr,3*nnr1)
      do is=1,nstate
        call set_origin(is)
        call fftTOr(c1(1,is),scr,psi,ngw,.false.)
        call apply_op_rx(scr,1d0,scr(1,3),0.d0,3)
        call apply_op_rx(scr,1d0,scr(1,2),0.d0,2)
        call apply_op_rx(scr,1d0,scr(1,1),0.d0,1)
        call fft2TOg(scr,scr,scr(1,2),scr(1,2),psi,ngw,.false.)
        call fftTOg  (scr(1,3),scr(1,3),psi,ngw,.false.)
        do l=1,3
          do k=1,3
            call apply_op_p(c0(1,is),psi,l,ngw)
            contrib = f(is)*dotp(ngw,psi,scr(1,k))
            do a=1,3
              chi(a,b) = chi(a,b) + 
     &           2.0d0*epsi(a,k,l)*chi_factor*contrib ! F(occ) included
!!   &            2*2* epsi(a,k,l)*chi_factor*contrib
c     Factor 2: the two terms (see above) are equal.
c     Factor 2: double-occupation of orbitals.
            enddo               ! a
          enddo                 ! k
        enddo                   ! l
      enddo                     ! is
      call tihalt('chi-L     ',isub)
      return
      end
c     ==================================================================
c     ==================================================================
      SUBROUTINE calc_chi_L_one(c0,c1,nstate,b,psi,scr,istate)
C     IDENTICAL to calc_chi_L, except that the stuff is only done for istate
      implicit none
      include    'system.h'
      include    'cppt.inc'
      include    'fft.inc'
      include    'response_p.inc'    ! chi(3,3,nstate)
      include    'elct.inc'
      complex*16 c0(ngw,*),c1(ngw,*),psi(*)
      real*8     scr(nnr1,3),contrib,DOTP,EPSI
      external   DOTP
      integer    a,b,nstate,isub,k,l,bb,istate
      dimension  f(nstate)
      call tiset('chi-L     ',isub)
c     =----------------------------------------------------------------=
c     ==  x_ab = Int[ r x (phi1_b grad phi0 - phi0 grad phi1_b) ]_a   ==
c     ==  where phi1_a is the response to a perturbation L_a.         ==
c     ==  The two contributions are equal.                            ==
c     =----------------------------------------------------------------=
c     scr(*,k) = r_k psi1_b   (b=fix)
      call azzero(scr,3*nnr1)
      call set_origin(istate)
      call fftTOr(c1(1,istate),scr,psi,ngw,.false.)
      call apply_op_rx(scr,1d0,scr(1,3),0.d0,3)
      call apply_op_rx(scr,1d0,scr(1,2),0.d0,2)
      call apply_op_rx(scr,1d0,scr(1,1),0.d0,1)
      call fft2TOg(scr,scr,scr(1,2),scr(1,2),psi,ngw,.false.)
      call fftTOg  (scr(1,3),scr(1,3),psi,ngw,.false.)
      do l=1,3
        do k=1,3
          call apply_op_p(c0(1,istate),psi,l,ngw)
          contrib = f(istate)*dotp(ngw,psi,scr(1,k))
          do a=1,3
            chi(a,b) = chi(a,b) + 
     &         2.0d0*epsi(a,k,l)*chi_factor*contrib  ! F(occ) included
!!   &          2*2* epsi(a,k,l) * chi_factor * contrib
c     Factor 2: the two terms (see above) are equal.
c     Factor 2: double-occupation of orbitals.
          enddo                 ! a
        enddo                   ! k
      enddo                     ! l
      call tihalt('chi-L     ',isub)
      return
      end
c     ==================================================================
c     ==================================================================
      SUBROUTINE calc_chi_p(c0,c1,nstate,j,psi,scr,gradpsi)
      implicit none
      include    'system.h'
      include    'cppt.inc'
      include    'fft.inc'
      include    'response_p.inc'    ! chi(3,3,nstate)
      include    'elct.inc'
      complex*16 c0(ngw,*),c1(ngw,*),psi(*),gradpsi(ngw,*)
      real*8     scr(nnr1,*),contrib,DOTP,EPSI,
     &    chi_tmp(3,3),chi_diff(3,3)
      external   DOTP
      integer    a,b,is,nstate,isub,k,l1,l2,j,i1,i2
      dimension  f(nstate)
      call tiset('chi-p     ',isub)
c     =----------------------------------------------------------------=
c     ==  x_ab = Int[ r x (phi1_b grad phi0 - phi0 grad phi1_b) ]_a   ==
c     ==  where phi1_a = [ r x phi1_p ]_a                             ==
c     ==  and phi1_p is the vector containing the three responses     ==
c     ==  to perturbations p_a.                                       ==
c     ==  The two contributions are NOT equal.                        ==
c     =----------------------------------------------------------------=
c     scr(1)     = c0 in R space
c     scr(2)     = r_i1 r_k c0 in R space
c     scr(3)     = r_i2 r_k c0 in R space
c     gradpsi(l) = grad_l psi1_p_j
c     (-> first term)
c     scr(4)     = c1 in R space
c     scr(2)     = r_i1 r_k c1 in R space
c     scr(3)     = r_i2 r_k c1 in R space
c     gradpsi(l) = grad_l psi0_p_j
c     (-> second term)
c     =----------------------------------------------------------------=
      call make_123(j,i1,i2)
      call azzero(chi_tmp,3*3)
      do is=1,nstate
        call set_origin(is)
        call fft2TOr(c0(1,is),scr,c1(1,is),scr(1,4),psi,ngw,.false.)
        do k=1,3
          call make_123(k,l1,l2)
c     ==  first term
          call apply_op_p(c1(1,is),gradpsi(1,1),l1,ngw)
          call apply_op_p(c1(1,is),gradpsi(1,2),l2,ngw)
          call apply_op_rx(scr(1,1),1d0,scr(1,2),0.d0, k)
          call apply_op_rx(scr(1,2),1d0,scr(1,3),0.d0,i2)
          call apply_op_rx(scr(1,2),1d0,scr(1,2),0.d0,i1)
          call fft2TOg(scr(1,2),scr(1,2),scr(1,3),scr(1,3),
     &        psi,ngw,.false.)
          do a=1,3
            do b=1,3
c     now, i1 means scr(2),     i2 means scr(3),
c     and  l1 means gradpsi(1), l2 means gradpsi(2):
              chi_tmp(a,b) = chi_tmp(a,b) +
!!   &            2 * epsi(a,k,l1) * epsi(b,i1,j) * chi_factor
     &         f(is)* epsi(a,k,l1) * epsi(b,i1,j) * chi_factor
     &            * dotp(ngw,scr(1,2),gradpsi(1,1))
              chi_tmp(a,b) = chi_tmp(a,b) +
!!   &            2 * epsi(a,k,l1) * epsi(b,i2,j) * chi_factor
     &         f(is)* epsi(a,k,l1) * epsi(b,i2,j) * chi_factor
     &            * dotp(ngw,scr(1,3),gradpsi(1,1))
              chi_tmp(a,b) = chi_tmp(a,b) +
!!   &            2 * epsi(a,k,l2) * epsi(b,i1,j) * chi_factor
     &         f(is)* epsi(a,k,l2) * epsi(b,i1,j) * chi_factor
     &            * dotp(ngw,scr(1,2),gradpsi(1,2))
              chi_tmp(a,b) = chi_tmp(a,b) +
!!   &            2 * epsi(a,k,l2) * epsi(b,i2,j) * chi_factor
     &         f(is)* epsi(a,k,l2) * epsi(b,i2,j) * chi_factor
     &            * dotp(ngw,scr(1,3),gradpsi(1,2))
            enddo               ! b
          enddo                 ! a
        enddo                   ! k

#if split_suscept_contribs
 88     FORMAT (3F15.7)
        write (6,'(A,I4)') 'CHI contrib 1 state ',is
        do a=1,3
          write (6,88) (chi_tmp(a,b),b=1,3)
        enddo
#endif
        call DAXPY(3*3,1d0,chi_tmp,1,chi,1)
        call azzero(chi_tmp,3*3)

        do k=1,3
          call make_123(k,l1,l2)

c     ==  second term
          call apply_op_p(c0(1,is),gradpsi(1,1),l1,ngw)
          call apply_op_p(c0(1,is),gradpsi(1,2),l2,ngw)
          call apply_op_rx(scr(1,4),1d0,scr(1,2),0d0,k)
          call apply_op_rx(scr(1,2),1d0,scr(1,3),0d0,i2)
          call apply_op_rx(scr(1,2),1d0,scr(1,2),0d0,i1)
          call fft2TOg(scr(1,2),scr(1,2),scr(1,3),scr(1,3),
     &        psi,ngw,.false.)
          do a=1,3
            do b=1,3
c     now, i1 means scr(2),     i2 means scr(3),
c     and  l1 means gradpsi(1), l2 means gradpsi(2):

              chi_tmp(a,b) = chi_tmp(a,b) -
!!   &            2 * epsi(a,k,l1) * epsi(b,i1,j) * chi_factor
     &         f(is)* epsi(a,k,l1) * epsi(b,i1,j) * chi_factor
     &            * dotp(ngw,scr(1,2),gradpsi(1,1))
              chi_tmp(a,b) = chi_tmp(a,b) -
!!   &            2 * epsi(a,k,l1) * epsi(b,i2,j) * chi_factor
     &         f(is)* epsi(a,k,l1) * epsi(b,i2,j) * chi_factor
     &            * dotp(ngw,scr(1,3),gradpsi(1,1))
              chi_tmp(a,b) = chi_tmp(a,b) -
!!   &            2 * epsi(a,k,l2) * epsi(b,i1,j) * chi_factor
     &         f(is)* epsi(a,k,l2) * epsi(b,i1,j) * chi_factor
     &            * dotp(ngw,scr(1,2),gradpsi(1,2))
              chi_tmp(a,b) = chi_tmp(a,b) -
!!   &            2 * epsi(a,k,l2) * epsi(b,i2,j) * chi_factor
     &         f(is)* epsi(a,k,l2) * epsi(b,i2,j) * chi_factor
     &            * dotp(ngw,scr(1,3),gradpsi(1,2))
            enddo               ! a
          enddo                 ! b
        enddo                   ! k


#if split_suscept_contribs
        write (6,'(A,I4)') 'CHI contrib 2 state ',is
        do a=1,3
          write (6,88) (chi_tmp(a,b),b=1,3)
        enddo
#endif

        call DAXPY(3*3,1d0,chi_tmp,1,chi,1)
        call azzero(chi_tmp,3*3)

#if split_suscept_contribs
C     NOW THE THEORETICAL DIFFERENCE BETWEEN THE FIRST TWO TERMS:
        call azzero(chi_diff,3*3)
        do k=1,3
          call apply_op_rx(scr(1,1),1d0,scr(1,2),0d0,k)
          call ffttog(scr(1,2),scr(1,2),psi,ngw,.false.)
          contrib=dotp(ngw,c1(1,is),scr(1,2)) * chi_factor
          
          do a=1,3
            do b=1,3
              do l1=1,3         ! corresponds to "beta"
                chi_diff(a,b)=chi_diff(a,b)+
!!   &              2* epsi(l1,b,k)*epsi(l1,j,a)*contrib
     &           f(is)*epsi(l1,b,k)*epsi(l1,j,a)*contrib
              enddo             ! l1
            enddo               ! a
          enddo                 ! b
        enddo                   ! k


        write (6,'(A,I4)') 'CHI DIFF      state ',is
        do a=1,3
          write (6,88) (chi_diff(a,b),b=1,3)
        enddo
C     END of differences...
#endif

      enddo                     ! is
c     Factor 2: double-occupation of orbitals.

      call tihalt('chi-p     ',isub)
      return
      end
c     ==================================================================
      SUBROUTINE print_chi_tensor
      implicit none
      include 'system.h'
      include 'response_p.inc'
      integer  a,b,info
      real*8   chi_matrix(3,3),eigenvalues(3),work(3*3),scr(3,3),
     &    aniso

      call DCOPY(3*3,chi,1,chi_matrix,1)
#ifdef PARALLEL
      call glosum(3*3,chi_matrix)
#endif

      if (.not. parent) return
      write (6,'(15("=")," MAGNETIC SUSCEPTIBILITY TENSOR ",18("="))')
      write (6, '(3(A,F15.5))')'  XX=',chi_matrix(1,1),
     &    '  XY=',chi_matrix(1,2),'  XZ=',chi_matrix(1,3)
      write (6, '(3(A,F15.5))')'  YX=',chi_matrix(2,1),
     &    '  YY=',chi_matrix(2,2),'  YZ=',chi_matrix(2,3)
      write (6, '(3(A,F15.5))')'  ZX=',chi_matrix(3,1),
     &    '  ZY=',chi_matrix(3,2),'  ZZ=',chi_matrix(3,3)

      do a=1,3
        do b=1,3
          scr(a,b) = (chi_matrix(a,b) + chi_matrix(b,a))/2.d0
        enddo                   ! b
      enddo                     ! a
      call DCOPY(3*3,scr,1,chi_matrix,1)

      call DSYEV('N','U', 3, chi_matrix, 3, eigenvalues, 
     &        work, 9, info)
      if (info .ne. 0) write (6, *)'ERROR IN DSYEV, code ',info
      chi_SI_iso = (eigenvalues(1)+ eigenvalues(2)+eigenvalues(3))/3.d0
      aniso      =  eigenvalues(3)-(eigenvalues(2)+eigenvalues(1))/2.d0
      write (6, '(3(A,F15.5))')' PV1=',eigenvalues(1),
     &    ' PV2=',eigenvalues(2),' PV3=',eigenvalues(3)
      write (6, '(3(A,F15.5))')' iso=',chi_SI_iso,
     &    '                   aniso=',aniso
      write (6, '(15("=")," (units = 10^-30 J/T^2) ",26("="))')

      call DSCAL(3*3,chi_SI_to_ppmcgs,scr,1)
      write (6, '(3(A,F15.5))')'  XX=',scr(1,1),
     &    '  XY=',scr(1,2),'  XZ=',scr(1,3)
      write (6, '(3(A,F15.5))')'  YX=',scr(2,1),
     &    '  YY=',scr(2,2),'  YZ=',scr(2,3)
      write (6, '(3(A,F15.5))')'  ZX=',scr(3,1),
     &    '  ZY=',scr(3,2),'  ZZ=',scr(3,3)
      write (6, '(3(A,F15.5))')
     &    ' PV1=',chi_SI_to_ppmcgs*eigenvalues(1),
     &    ' PV2=',chi_SI_to_ppmcgs*eigenvalues(2),
     &    ' PV3=',chi_SI_to_ppmcgs*eigenvalues(3)
      write (6, '(3(A,F15.5))')' iso=',chi_SI_to_ppmcgs*chi_SI_iso,
     &    '                   aniso=',chi_SI_to_ppmcgs*aniso
      write (6, '(15("=")," (units = ppm-cgs)      ",26("="))')


      return
      end
c     ==================================================================
