c     ==================================================================
      subroutine calc_current(c0,c1,nstate,psi,scr1,scr2,scr,lscr)
      implicit none
      include 'system.h'
      include 'cppt.inc'
      include 'coor.inc'
      include 'cnst.inc'
      include 'fft.inc'
      include 'ions.inc'
      include 'geq0.inc'
      include 'response_p.inc'
      include 'elct.inc'
c     ==--------------------------------------------------------------==
C     Parameters
      integer    nstate,lscr
      complex*16 c0(ngw,nstate),psi(*),c1(ngw,nstate,6)
      real*8     scr(nnr1,*),scr1(nnr1),scr2(nnr1)
C     Local Variables
      complex*16 Bind(nhg,3),GbyGG(3)
      real*8     j(nnr1,3),
     &    psi0 (nnr1),    gpsi0 (nnr1,3),
     &    psi1p(nnr1,3),
     &    psi1L(nnr1),    gpsi1L(nnr1,3)
      pointer    (ip_Bind,Bind),(ip_j,j),
     &     (ip_psi1L,psi1L),(ip_gpsi1L,gpsi1L),
     &     (ip_psi0,psi0),(ip_gpsi0,gpsi0),
     &     (ip_psi1p,psi1p)
      dimension  f(nstate)
      integer    is,iB,iBB,iBBB,ir,ip,nattot,ix,iy,iz,ig,
     &    iat,isp,isub,iatom,isa,il_psi,il_rho,il_scr,i_offs_for_psiL
      real*8       pipi,center(3),j2,eigr_dot,eigr_dot2,
     &     this_shift(3,3,*),
     &     chi_scr(3,3),chifactor
      pointer      (ip_this_shift,this_shift)
      character*30 tag
      character    label,labels(3)
      data         labels /'x','y','z'/
c     ==--------------------------------------------------------------==
      CALL TISET('   CURRENT',ISUB)
      call rhoe_psi_size(il_rho,il_psi)
      if (il_rho .lt. kr1*kr2*kr3)
     &     call STOPGM('NMR_CURRENT','il_rho .lt. kr1*kr2*kr3')
      if (nnr1 .ne. kr1*kr2*kr3) 
     &     call STOPGM('NMR_CURRENT','nnr1 .ne. kr1*kr2*kr3')
      
C     BUGFIX:
      i_offs_for_psiL = 3
      if (Tcurrent .AND. Tnmr_full) i_offs_for_psiL = 6
C     BUGFIX ends.

      call give_scr_nmr_current(il_scr,tag)
      call test_scr('NMR_CURRENT',tag,lscr,il_scr)
      CALL GET_ADDR(IP_psi0,scr1) ! size 1
      CALL GET_ADDR(IP_gpsi0,scr(1,1)) ! size 3
      CALL GET_ADDR(IP_psi1L,scr2) ! size 1
      CALL GET_ADDR(IP_psi1p,scr(1,4)) ! size 3
      CALL GET_ADDR(IP_gpsi1L,scr(1,4)) ! size 3
      CALL GET_ADDR(IP_Bind,scr(1,4)) ! size 3
      CALL GET_ADDR(IP_j,scr(1,7)) ! size 3

      call memory(ip_this_shift,3*3*nax*nsx,'this_shift')
      call azzero(   this_shift,3*3*nax*nsx)
c     ==--------------------------------------------------------------==
      call azzero(      psi,     il_psi)
      call azzero(     psi0,     il_rho)
      call azzero(    gpsi0,   3*il_rho)
      call azzero(    psi1L,     il_rho)
      call azzero(   gpsi1L,   3*il_rho)
      call azzero(    psi1p,   3*il_rho)
      call azzero(        j,   3*il_rho)
      if (parent) call prmem('NMR (current)   ')
c     ==--------------------------------------------------------------==
C     Find the center of the molecule, used for the .xyz file
      nattot=0
      do isp=1,nsp
         nattot=nattot+na(isp)
      enddo
      do ir=1,3
         center(ir) = 0.d0
         do isp=1,nsp
            do iat=1,na(isp)
               center(ir) = center(ir) + tau0(ir,iat,isp)
            enddo
         enddo
         center(ir) = center(ir)/DBLE(nattot)
      enddo
c     ==--------------------------------------------------------------==
      do iB=1,3
         label = labels(iB)
         call make_123(iB,iBB,iBBB)
         call azzero(j,3*il_rho)
         do is=1,nstate
            call set_origin(is)
            call fft2TOr(c0(1,is), psi0, c1(1,is,i_offs_for_psiL+iB),
     &           psi1L,psi,ngw,.true.)
            do ip=1,3
               call apply_op_p(c0(1,is),      gpsi0 (1,ip),ip, ngw)
               call apply_op_p(c1(1,is,iB+i_offs_for_psiL), 
     &                                        gpsi1L(1,ip),ip, ngw)
               call fft2TOr(gpsi0(1,ip),gpsi0(1,ip),
     &              gpsi1L(1,ip),gpsi1L(1,ip), psi, ngw,.true.)
            enddo



C     Magnetic field B in direction a
C     current components j_b
C     => j_ba = current component b for a field in direction a
C     TERM 1:    t1  =  (p_b psi0) (r) * psi1^(L_a) (r)
C     TERM 2:    t2  =  psi0(r) *  (p_b psi1^(L_a)) (r)

            do ir=1,nnr1
               do ip=1,3
                  j(ir,ip) = j(ir,ip)
!!   &                 + gpsi0(ir,ip) * psi1L(ir) ! t1
!!   &                 - psi0(ir) * gpsi1L(ir,ip) ! t2
     &                 + f(is)*( gpsi0(ir,ip) * psi1L(ir)   ! t1
     &                          -psi0(ir) * gpsi1L(ir,ip) ) ! t2
               enddo
            enddo
                                ! these two terms result in 
                                ! identical shift values, by the way.



C     TERM 3:   t3 = (p_b psi0) (ir)  *  ( (r-d)_mu  phi1^(p_nu) )(ir) 
C     \                               * eps_a_nu_mu
C     TERM 4:   t4 = phi0(ir) * ( p_b (r-d)_mu  psi1^(p_nu) ) (ir)
C     \                       * eps_a_nu_mu
C     \            = phi0(ir) * ( (r-d)_mu  p_b psi1^(p_nu) ) (ir)
C     \                       * eps_a_nu_my
C     BECAUSE the (r-d)_mu term is NOT an operator, it comes from
C     the CSGT-"r-prime". So it can only be an operator when next
C     to the   |r> <r|  of the current density operator, i.e. when
C     already having applied the p_b to psi1^(p_nu).


            call fft2TOr(c1(1,is,iBB), psi1p(1,1),
     &           c1(1,is,iBBB), psi1p(1,2),psi,ngw,.true.)
            call apply_op_rx(psi1p(1,1),1.d0,psi1p(1,1),0.d0,iBBB)
            call apply_op_rx(psi1p(1,2),-1.d0,psi1p(1,1),1.d0,iBB)
C     t3. In fact, we calculate (for iB=3, i.e. B || Oz)
C     psi1p(*,1) =  (r-d)_y psi1^px  -  (r-d)_x psi1^py


            do ir=1,nnr1
               do ip=1,3
                  j(ir,ip) = j(ir,ip) 
!!   &                 + gpsi0(ir,ip) * psi1p(ir,1) ! t3
     &                 + f(is)*gpsi0(ir,ip) * psi1p(ir,1) ! t3
               enddo
            enddo


C     t4.
C     \            = phi0(ir) * ( (r-d)_mu  p_b psi1^(p_nu) ) (ir)
C     \                       * eps_a_nu_my


            do ip=1,3
               call apply_op_p(c1(1,is,iBB),psi1p(1,1),ip,ngw)
               call apply_op_p(c1(1,is,iBBB),psi1p(1,2),ip,ngw)
               call fft2TOr(psi1p(1,1),psi1p(1,1),
     &              psi1p(1,2),psi1p(1,2),psi,ngw,.true.)
               call apply_op_rx(psi1p(1,1),1d0,psi1p(1,1),0d0,iBBB)
               call apply_op_rx(psi1p(1,2),-1d0,psi1p(1,1),1d0,iBB)
               do ir=1,nnr1
                  j(ir,ip) = j(ir,ip)
!!   &                 - psi0(ir) * psi1p(ir,1) ! t4
     &                 - f(is)*psi0(ir) * psi1p(ir,1) ! t4
               enddo
            enddo

         enddo                  ! is (states)



         call cubefile('jx_B'//label//'.cube ',
     &                 j(1,1),center,psi,.false.)
         call cubefile('jy_B'//label//'.cube ',
     &                 j(1,2),center,psi,.false.)
         call cubefile('jz_B'//label//'.cube ',
     &                 j(1,3),center,psi,.false.)

         do ir=1,nnr1
            j2 = j(ir,1)*j(ir,1) + j(ir,2)*j(ir,2) 
     &           + j(ir,3)*j(ir,3)
            psi1L(ir) = dsqrt(j2) ! abuse of psi1L
         enddo
         call cubefile('jabs_B'//label//'.cube     ',
     &                 psi1L,center,psi,.false.)


C     Current density in G space
         call fft2TOg(j(1,1),j(1,1),
     &        j(1,2),j(1,2),psi,nhg,.true.)
         call fftTOg(j(1,3),j(1,3),psi,nhg,.true.)


#if 0
C     DIVERGENCE of current density
         if (ib .eq.3) then
            call apply_op_p(j(1,1),gpsi0(1,1),1,nhg)
            call apply_op_p(j(1,2),gpsi0(1,2),2,nhg)
            call apply_op_p(j(1,3),gpsi0(1,3),3,nhg)

            call fft2TOr(gpsi0(1,1),gpsi0(1,1),
     &           gpsi0(1,2),gpsi0(1,2),psi,nhg,.true.)
            call fftTOr(gpsi0(1,3),gpsi0(1,3),psi,nhg,.true.)
 987        FORMAT ("div j(ir=",I7,")  =  ",F10.6," + ",
     &           F10.6," + ",F10.6," = ",F10.6)
            do ir=243550,243600
               write (6,987) 
     &              ir,gpsi0(ir,1),gpsi0(ir,2),gpsi0(ir,3),
     &              gpsi0(ir,1)+gpsi0(ir,2)+gpsi0(ir,3)
            enddo
         endif
#endif




C     INDUCED FIELD:
C     B_ind = Oz:
         call apply_op_p(j(1,1),gpsi0(1,1),2,nhg)
         call apply_op_p(j(1,2),Bind(1,3),1,nhg)
         call DAXPY(2*nhg,-1d0,gpsi0(1,1),1,Bind(1,3),1)
C     B_ind = Oy:
         call apply_op_p(j(1,3),gpsi0(1,1),1,nhg)
         call apply_op_p(j(1,1),Bind(1,2),3,nhg)
         call DAXPY(2*nhg,-1d0,gpsi0(1,1),1,Bind(1,2),1)
C     B_ind = Ox:
         call apply_op_p(j(1,2),gpsi0(1,1),3,nhg)
         call apply_op_p(j(1,3),Bind(1,1),2,nhg)
         call DAXPY(2*nhg,-1d0,gpsi0(1,1),1,Bind(1,1),1)

         call nmr_interaction3(Bind(1,1),Bind(1,2),Bind(1,3))


C     Add the susceptibility contribution to B(G=0)
         call DCOPY(9,chi,1,chi_scr,1)
#ifdef PARALLEL
         call glosum(3*3,chi_scr)
#endif
         if (geq0) then
            chifactor = - chi_SI_to_shift_ppm/shift_factor
            do ir=1,3
               Bind(1,ir) = chifactor * chi_scr(ir,iB)
            enddo
         endif

         call fft2TOr(Bind(1,1),j(1,1),Bind(1,2),j(1,2),
     &        psi,nhg,.true.)   ! abuse of j
         call fftTOr(Bind(1,3),j(1,3),psi,nhg,.true.)
         call DSCAL(nnr1,shift_factor,j(1,1),1)
         call DSCAL(nnr1,shift_factor,j(1,2),1)
         call DSCAL(nnr1,shift_factor,j(1,3),1)
         call cubefile('Bindx_B'//label//'.cube ',
     &                 j(1,1),center,psi,.false.)
         call cubefile('Bindy_B'//label//'.cube ',
     &                 j(1,2),center,psi,.false.)
         call cubefile('Bindz_B'//label//'.cube ',
     &                 j(1,3),center,psi,.false.)


C     SHIFTS:
         isa = 0
         do isp = 1,nsx
            do iat = 1, na(isp)
               isa = isa+1
               this_shift(1,iB,isa) = eigr_dot2(isa,Bind(1,1))
               this_shift(2,iB,isa) = eigr_dot2(isa,Bind(1,2))
               this_shift(3,iB,isa) = eigr_dot2(isa,Bind(1,3))
            enddo
         enddo
      enddo                     ! IB

#ifdef PARALLEL
      call glosum(3*3*isa,this_shift)
#endif

      if (parent) then
         isa = 0
         do isp = 1,nsx
            do iat = 1, na(isp)
               isa = isa+1
               do iB=1,3
                  write (6,'("SHIELDINGS B_ext=",I1,'//
     &                 '", atom ",I3," --> ",3F15.5)')
     &                 iB,isa,
     &                 (shift_factor * this_shift(ir,iB,isa),ir=1,3)
               enddo
            enddo
         enddo
      endif


c     ==--------------------------------------------------------------==
      CALL TIHALT('   CURRENT',ISUB)
      return
      end
c     ==================================================================





c     ==================================================================
      subroutine remove_divergence(j1,j2,iB)
c     expects INPUT: j1,j2 in G space (packed format)
c     where j1 = j_(iB+1), j2 = j_(iB+2).
      implicit none
      include 'system.h'
      include 'cppt.inc'
      include 'coor.inc'
      include 'fft.inc'
      include 'gvec.inc'
      include 'ions.inc'
      include 'response_p.inc'
      include 'prop.inc'
c     ==--------------------------------------------------------------==
      complex*16 j1(nhg),j2(nhg),jgrid(kr1,kr2,kr3,4),coeff
      pointer    (ip_jgrid,jgrid)
      real*8     G(3),normbefore(2),normafter(2),dotp
      external   DOTP
      integer    iB,ig, iBB, iBBB

      call stopgm('REMOVE_DIV','NO MORE SUPPORTED')

      if (.NOT. TFAST) then
        normbefore(1) = dotp(nhg,j1,j1)
        normbefore(2) = dotp(nhg,j2,j2)
#ifdef PARALLEL
        call glosum(2,normbefore)
#endif
        normbefore(1) = sqrt(normbefore(1))
        normbefore(2) = sqrt(normbefore(2))
      endif
      call make_123(iB,iBB,iBBB)


      do ig=1,nhg
        coeff = j1(ig) * GK(iBB,ig)
     &      + j2(ig) * GK(iBBB,ig)
        if (HG(ig) .GT. 1d-5) coeff = coeff / HG(ig)
        j1(ig) = j1(ig) - coeff * GK(iBB,ig)
        j2(ig) = j2(ig) - coeff * GK(iBBB,ig)
      enddo

      if (.NOT. TFAST) then
        normafter(1) = dotp(nhg,j1,j1)
        normafter(2) = dotp(nhg,j2,j2)
#ifdef PARALLEL
        call glosum(2,normafter)
#endif
        normafter(1) = sqrt(normafter(1))
        normafter(2) = sqrt(normafter(2))
        if (parent) then
          print *,'REMOVE DIV: Norm 1: ',
     &        normbefore(1),' -> ',normafter(1)
          print *,'REMOVE DIV: Norm 2: ',
     &        normbefore(2),' -> ',normafter(2)
        endif
      endif

      return
      end
c     ==================================================================

c     ==================================================================
      subroutine give_scr_nmr_current(lscr,tag)
c     ==--------------------------------------------------------------==
      implicit   none
      include    'system.h'
      include    'fft.inc'
      include    'response_p.inc'
      include    'prop.inc'
      include    'elct.inc'
      include    'wann.inc'
      integer    lscr
      character  tag*30
      lscr = 1
      if (.NOT. TNMR) return
      if (.NOT. TCURRENT) return
      lscr = 9*nnr1
      tag  = 'nmr-response          '
      return
      end
c     ==================================================================


