c     ==================================================================
      subroutine nmr_p(c0,h1psi0,psi,rhoe,scr,lscr,
     &        eirop,eivps,z11,nstate)
c     ==================================================================
C     PARALLEL
      implicit none
      include 'system.h'
      include 'response_p.inc'
      include 'prop.inc'
      include 'cnst.inc'
      include 'cppt.inc'
      include 'gvec.inc'
      include 'ddip.inc'
      include 'isos.inc'
      include 'wann.inc'
      include 'coor.inc'
      include 'store.inc'
      include 'soft.inc'
      include 'ropt.inc'
      include 'sfac.inc'
      include 'fft.inc'
      include 'elct.inc'
c     ==--------------------------------------------------------------==
c     Arguments & common variables
      integer    nstate,lscr
      complex*16 c0(ngw,nstate),h1psi0(ngw,nstate),
     &     psi(*),eirop(nhg),eivps(nhg)
      real*8     z11(nstate,nstate),scr(2*maxfft,*),
     &     RHOE(*),FNL(*),DFNL(*)
c     ==--------------------------------------------------------------==
c     Local variables
      integer    iB,ii,iii,is,isub,isub2,l_c1,i_c1,NC,
     &     ip_start,ip_end,iL_start,iL_end,irec(100),
     &     i_thread,ik,i_state,restored_i_state
#ifdef PARALLEL
      integer NXXFUN,msglen
      external NXXFUN
#endif
      integer    neighborlist(3,nstate)
      logical    dowfopt(3,nstate)
      pointer    (ip_neighborlist,neighborlist),
     &     (ip_dowfopt,dowfopt)
      complex*16 c1(ngw,nstate,*),cs(*),sc0(*)
      pointer    (ip_c1,c1),(ip_cs,cs),(ip_sc0,sc0)
      dimension  F(nstate)
      real*8     dummy,cgs_conv,starttime,usedtime(0:6),w_eps_save,
     &    shift_sumup(3,3,nax,nsx),chi_sumup(3,3),
     &    shift_saved(3,3,nax,nsx),chi_saved(3,3)
      pointer    (ip_shift_sumup,shift_sumup),(ip_chi_sumup,chi_sumup),
     &    (ip_shift_saved,shift_saved),(ip_chi_saved,chi_saved)
      logical    simple_done(6),full_done(3,nstate)
      pointer    (ip_full_done,full_done)
      character  xyz(3),tag*10
      data       xyz /'x','y','z'/

      logical    full_optimization

C     Functions
      integer    ISETONE
      real*8     timef,ddot,dotp
      external   ISETONE,timef,dotp,ddot

      integer il_rho,il_psi
 81   FORMAT ("*  TOTAL CORRECTION :     ",38X,"*")
 82   FORMAT ("*  RESULT OF FULL CALCULATION:   ",31X,"*")
 96   FORMAT ("*  PERTURBATION: ",A1,"_",I1," |PSI>",38X,"*")
 99   FORMAT ("*  Calculation of responses DONE.",31X,"*")
 97   FORMAT ("*  TOTAL TIME: ",F7.1,42X,"*")
 98   FORMAT (52("*"),"NMR*RESPONSE*")
c     ==--------------------------------------------------------------==
      call tiset('       NMR',isub)
      timetag=' '
      if (parent) call printtime
      starttime=timef()/1000.d0

      nris(1)   = nr1s
      nris(2)   = nr2s
      nris(3)   = nr3s
      PR_ENERGY = TVERBOSE      !  these values are not sooo interesting
      full_optimization=.false.
c      full_optimization=.true.
c      if (parent) print *,
c     &     'DEBUG DEBUG: >> full_optimization: ',full_optimization
c     ==--------------------------------------------------------------==
      if (nmr_threads .eq. 1) then
        ip_start=1
        ip_end  =3
        iL_start=1
        iL_end  =3
      elseif (nmr_threads .eq. 3) then
        ip_start=nmr_mygroup+1
        ip_end  =nmr_mygroup+1
        iL_start=nmr_mygroup+1
        iL_end  =nmr_mygroup+1
      elseif(nmr_threads .eq. 6) then
        ip_start=nmr_mygroup+1
        ip_end  =mod(nmr_mygroup,3)+1
        iL_start=mod(nmr_mygroup,3)+1
        iL_end  =nmr_mygroup-2
      else
        call stopgm('NMR_P','Bad number of threads! Must be 3 or 6')
      endif
c     ==--------------------------------------------------------------==
      l_c1 = 2*ngw*nstate
      if (Tcurrent)    l_c1 = 6 * 2*ngw*nstate
      if (TNMR_FULL)  l_c1 = 6 * 2*ngw*nstate
      if (Tcurrent .AND. TNMR_FULL) l_c1 = 9 * 2*ngw*nstate
      call memory(ip_shift_matrix,nax*nsx*3*3,'shifts')
      call azzero(   shift_matrix,nax*nsx*3*3)
      call memory(ip_chi,3*3,'suscept')
      call azzero(   chi,3*3)
      call memory(ip_c1,       l_c1,'C1')
      call azzero(   c1,       l_c1)
      call memory(ip_lower_left,3*nstate,'lower left')
      call iazzero(   lower_left,3*nstate)
      call memory(ip_lower_left_value,3*nstate,'llc-value')
      call iazzero(   lower_left_value,3*nstate)
      call memory(ip_shift_sumup,3*3*nax*nsx,'SHIFT/sumup')
      call azzero(   shift_sumup,3*3*nax*nsx)
      call memory(ip_shift_saved,3*3*nax*nsx,'SHIFT/saved')
      call azzero(   shift_saved,3*3*nax*nsx)
      call memory(ip_chi_sumup,3*3,'SUSC/sumup')
      call azzero(   chi_sumup,3*3)
      call memory(ip_chi_saved,3*3,'SUSC/saved')
      call azzero(   chi_saved,3*3)
      call memory(ip_full_done,3*nstate,'done-matrix')
      do iB=1,3
         simple_done(iB)=.false.
         simple_done(iB+3)=.false.
         do is=1,nstate
            full_done(iB,is) = .false.
         enddo
      enddo
      CALL MEMORY_CHECK
      if (parent) then
        call memory(ip_wanniercenters,4*nstate,'WANNIERCENT')
        call azzero(   wanniercenters,4*nstate)
      endif

      if (parent) CALL PRMEM('NMR        ')
c     ==--------------------------------------------------------------==
!!    shift_factor= - 2d0*( 1d0 / 137.03602d0 )**2   * 1d6 / omega
C     factor for the CHEMICAL SHIFTS: alpha^2 *  ppm.
c     2: double-occupation of the orbitals c0  
      shift_factor=- (1.0d0 / 137.03602d0 )**2  * 1.0d6 / omega
C     The orbital occupations are explicitly included

!!    chi_factor = 2d0 * 1.9727566d-29 / 1d-30 ! -> displayed in 10^-30 J/T^2
c     = (2:double occ) * 1/4 * e^2/m * a_0 ^2
      chi_factor = 1.9727566d-29 / 1d-30
C     The orbital occupations are explicitly included

      chi_SI_to_ppmcgs   = 6.022045d0 / 1d2 
c     converts 10^-30 J/T^2  into  ppm cgs = ppm cm^3/mol
c     = 10^-30  *  mu_0/4pi  *  N_A  *  10^6 * 10^6
c     [one 10^6 for ppm, one for m^3 -> cm^3]

      chi_SI_to_shift_ppm = 1.d-30 * 8.37758041d-7
     &    / (omega / (fbohr*fbohr*fbohr) *1.0d-30) * 1.0d6
c     10^-30  *  2/3  mu_0 / Omega  * 1/ppm
      firstshelldistance = 1.d0 ! in a.u.
c     ==--------------------------------------------------------------==
      if (INMR_METHOD.eq.INMR_DEFAULT) then
        INMR_METHOD = INMR_CSGT
        if (TCLUST) then
           INMR_VIRTUAL = INMR_NOVIRT
        endif
      endif
      if (INMR_VIRTUAL.eq.INMR_DEFAULT) then
        INMR_VIRTUAL = INMR_LLC
        if (INMR_METHOD.eq.INMR_IGLO) INMR_VIRTUAL = INMR_WC
      endif
      if (INMR_METHOD.eq.INMR_IGLO) then
         call stopgm('NMR','IGLO no longer supported')
      endif
      if (INMR_VIRTUAL.eq.INMR_NOVIRT) TLOCALIZE = .false.
      IF (T_RESTART_C1 .AND. WFOPT) then
         call stopgm('NMR/RESTART',
     &        'Use of NOOPT is compulsory for NMR RESTART')
      endif
      if (nmr_superparent) call print_configuration
c     ==--------------------------------------------------------------==
c     ==  LOCALIZATION/C0  -------------------------------------------==
      CALL PHFAC(TAU0)
      CALL EICALC(eivps,eirop)
      if (TLOCALIZE) then
        TWANN=.true.
        LOCL=.true.
        NUMORB=MAX(NUMORB,NSTATE)
        NC=2*NGWK*NUMORB
#ifdef PARALLEL
        LENBK=NXXFUN(NUMORB)
        NC=MAX(2*LENBK*NPROC,NC)
#endif
        IF (.NOT. T_RESTART_C1) then
           CALL MEMORY(IP_SC0,NC,'SC0/tmp   ')
           CALL MEMORY(IP_CS,NC,'CS/tmp   ')
           W_EPS_SAVE = W_EPS
           W_EPS      = 1d-4
           CALL LOCALIZE(TAU0,C0,CS,SC0,SCR,LSCR,NSTATE)
           W_EPS      = W_EPS_SAVE
           SWF        = .TRUE.
           CALL WRITE_IREC(IREC)
           IREC(IREC_PWV) = ISETONE(.FALSE.)
           CALL ZHWWF(49,IREC,C0,CS,NSTATE,scr,TAU0,VELP,TAUP,NFI)
           CALL FREEM(IP_SC0)
           CALL FREEM(IP_CS)
        endif
      endif
      timetag='localization.'
      if (parent) call printtime

c     ==--------------------------------------------------------------==
      CALL MEMORY_CHECK
      CALL LAG_MULT(c0,h1psi0,psi,scr,lscr,rhoe,z11,nstate)
      timetag='lagrange multipliers.'
      if (parent) call printtime
c     ==--------------------------------------------------------------==
      if (Tprintwfns) 
     &    call print_wavefunctions(c0,nstate,psi)
      if (Tprintrho) 
     &    call print_orbital_densities(c0,nstate,psi,scr)
c     ==--------------------------------------------------------------==
      IF (INMR_VIRTUAL.eq.INMR_LLC) THEN
         IF (TNMR_OVERLAPS) THEN
            call calc_lower_left_optimize(c0,c1,nstate,scr,psi)
         ELSE
            call calc_lower_left_new(c0,nstate,scr,psi)
            if (full_optimization) then
C     TESTING: LLC optimization...
               call memory(ip_neighborlist,3*nstate,'NMR:NLIST')
               call memory(ip_dowfopt,3*nstate,'NMR:CLIST')
               
               firstshelldistance= min (1.5d0, alat/20d0)
               if (parent) then
                  print *,'PROCEDURE:'
                  print *,' new LLC opti / 1 x ',
     &                 firstshelldistance,' a.u.'
               endif

               call optimize_llc_indep(neighborlist,dowfopt,nstate)
               
c            firstshelldistance=1.0d0
c            call make_listofstates(neighborlist,dowfopt,nstate)
c            call optimize_llc(neighborlist,dowfopt,nstate)
c            call make_listofstates(neighborlist,dowfopt,nstate)
c            call optimize_llc(neighborlist,dowfopt,nstate)
c            call make_listofstates(neighborlist,dowfopt,nstate)
c            call optimize_llc(neighborlist,dowfopt,nstate)

               firstshelldistance=0.1d0
               call make_listofstates(neighborlist,dowfopt,nstate)

               call freem(ip_neighborlist)
               call freem(ip_dowfopt)
            endif               ! full_optimization
         ENDIF
      elseif (INMR_VIRTUAL.eq.INMR_NOVIRT) then
        do is=1,nstate          ! -> All wfns have same virtual box
          do ik=1,3
            lower_left_value(ik,is) = -nris(ik)/2
            lower_left(ik,is) = 1
          enddo
        enddo
      endif                     ! virtual orbitals
      call force_xyz(nstate)    ! if the corresponding options FORCE(x,...)
                                ! are switched on,
                                ! the X/Y/Z - LLCs are averaged.
      if (parent) call print_LLC(nstate)

      timetag='LLC initialization.'
      if (parent) call printtime
      CALL MEMORY_CHECK
c     ==--------------------------------------------------------------==
      if (T_RESTART_C1) call restart_nmr(simple_done,full_done,
     &     shift_sumup,chi_sumup,
     &     shift_matrix,chi,nstate,RESPONSE_READ)
c     ==--------------------------------------------------------------==
      i_c1 = 1                  ! Index for the C1-array. Constant unless
      do iB=iL_start,iL_end     ! calculation of the CURRENT is desired.
         if (.not. simple_done(iB)) then
            if (Tcurrent) i_c1 = iB+3
            if (Tcurrent .AND. TNMR_FULL) i_c1 = iB+6
            if (parent) write (6,98)
            if (parent) write (6,96) 'L',iB
C     Preparation of L_i |psi_0>:
            call make_123(iB,ii,iii)
            do is=1,nstate      ! apply r_ii p_iii - r_iii p_ii:
               call set_origin (is)
               call apply_op_p (c0(1,is), scr(1,1), ii, ngw)
               call apply_op_p (c0(1,is), scr(1,2), iii, ngw)
               call fft2TOr    (scr(1,1), scr(1,1),
     &              scr(1,2),scr(1,2), psi, ngw,.false.)
               call apply_op_rx(scr(1,1), -1d0, rhoe,  0d0, iii)
               call apply_op_rx(scr(1,2),  1d0, rhoe,  1d0,  ii)
               call fftTOg     (rhoe, h1psi0(1,is), psi, ngw,.false.)
               call dscal(2*ngw,f(is),h1psi0(1,is),1)
            enddo


            timetag='preparation.'
            if (parent) call printtime
            if (parent) write (6,98)
            call tiset('PSI1-WF-OPT',isub2)
            call rwfopt_p(c0,c1(1,1,i_c1),psi,rhoe,dummy,scr,lscr,
     &           eirop,eivps,dummy,h1psi0,
     &           z11,nstate,dummy)
            call tihalt('PSI1-WF-OPT',isub2)
            timetag='calculation of psi^1.'
            if (parent) call printtime
            if (exsoft) goto 441
            if (parent) write (6,98)
            call calc_L(c0,c1(1,1,i_c1),nstate,iB,psi,scr,rhoe)
            timetag='shift contribution.'
            if (parent) call printtime
            if (TVERBOSE) call print_shift_matrix(nstate,.false.)
            call calc_chi_L(c0,c1(1,1,i_c1),nstate,iB,psi,scr)
            timetag='susceptibility contribution.'
            if (parent) call printtime

            simple_done(iB) = .true.
            call restart_nmr(simple_done,full_done,
     &           shift_sumup,chi_sumup,
     &           shift_matrix,chi,nstate,RESPONSE_WRITE)
            CALL MEMORY_CHECK
         endif                  ! if simple calculation not already done
      enddo                     ! iB
c     ==--------------------------------------------------------------==
      do iB=ip_start,ip_end
         if (Tcurrent) i_c1 = iB
         if (TNMR_FULL) i_c1 = iB
         if (parent) write (6,98)
         if (parent) write (6,96) 'p',iB
         
         tag = 'p_'//xyz(iB)
         if (T_RESTART_C1 .AND. TNMR_FULL .and. simple_done(iB+3)) 
     &        call restart_p(c1(1,1,i_c1),tag,nstate,RESPONSE_READ)
         if (.not. simple_done(iB+3)) then
            do is=1,nstate
               call apply_op_p(c0(1,is), h1psi0(1,is), iB, ngw)
               call dscal(2*ngw,f(is),h1psi0(1,is),1)
            enddo
            timetag='preparation.'
            if (parent) call printtime
            if (parent) write (6,98)
            call tiset('PSI1-WF-OPT',isub2)
            call rwfopt_p(c0,c1(1,1,i_c1),psi,rhoe,dummy,scr,lscr,
     &           eirop,eivps,dummy,h1psi0,
     &           z11,nstate,dummy)
            call tihalt('PSI1-WF-OPT',isub2)
            if (parent) write (6,98)
            timetag='calculation of psi^1.'
            if (parent) call printtime
            if (exsoft) goto 441
            call calc_p(c0,c1(1,1,i_c1),nstate,iB,psi,scr,lscr)
            timetag='shift contribution.'
            call printtime
            call calc_chi_p(c0,c1(1,1,i_c1),nstate,iB,psi,scr,rhoe)
            timetag='susceptibility contribution.'
            call printtime

            tag = 'p_'//xyz(iB)
            call restart_p(c1(1,1,i_c1),tag,nstate,RESPONSE_WRITE)
            simple_done(iB+3) = .true.
            call restart_nmr(simple_done,full_done,
     &           shift_sumup,chi_sumup,
     &           shift_matrix,chi,nstate,RESPONSE_WRITE)
         endif                  ! if simple calculation not already done
         if (TVERBOSE) call print_shift_matrix(nstate,.false.)
         CALL MEMORY_CHECK
      enddo                     ! iB
 441  CONTINUE

      call azzero(usedtime(0),6)
      usedtime(nmr_mygroup) = timef()/1000.d0 - starttime
c     ==--------------------------------------------------------------==
C     SUPERPARALLEL stuff.
#ifdef PARALLEL
      if(nmr_threads .ne. 1) then
        call REWRITE_OUTPUT     ! closes, prints & deletes the files out_?

        if (nmr_superparent) write (6,98)
        do i_thread=1,nmr_threads
          call my_sync(nmr_supergroup)
          if (ME.eq.parents(i_thread)) then
            write (6,'("@ TIME: ",F8.1,'//
     &          '" sec times ",I3," procs (grp ",I1,") = ",'//
     &          'I7," CPU-SEC.")')
     &          usedtime(i_thread-1),nproc,i_thread-1,
     &          NINT(usedtime(i_thread-1)*nproc)
          endif
        enddo

        allgrp = nmr_supergroup
        parent = nmr_superparent
        nproc  = nmr_total_nproc
        source = nmr_supersource
      endif
      call my_sync(allgrp)
#endif
c     ==--------------------------------------------------------------==
      if (parent) then
        write (6,98)
        write (6,98)
        write (6,99)
        write (6,97) usedtime(nmr_mygroup)
        write (6,98)
        write (6,98)
      endif
c     ==--------------------------------------------------------------==
      call print_chi_tensor     ! calculates also the suscept correction,
                                ! chi_SI_iso
      call print_shift_matrix(nstate,.true.)
c     ==--------------------------------------------------------------==
      if (exsoft) goto 444
      IF (TNMR_FULL) THEN
         if (INMR_METHOD .ne. INMR_CSGT) call stopgm('NMR_P',
     &        'Cannot use FULL option in IGLO calculation.')
         if (nmr_threads .ne. 1) call stopgm('NMR_P',
     &        'Cannot use superparallel option in FULL calculation.')
         call DCOPY(3*3*nax*nsx,shift_matrix,1,shift_saved,1)
         call DCOPY(3*3,chi,1,chi_saved,1)
         call azzero(   shift_matrix,3*3*nax*nsx)
         call azzero(   chi,          3*3)

         call memory(ip_neighborlist,3*nstate,'NMR:NLIST')
         call memory(ip_dowfopt,3*nstate,'NMR:CLIST')
         call make_listofstates(neighborlist,dowfopt,nstate)
         CALL MEMORY_CHECK
C     neighborlist now contains the states in a reasonable 
C     proximity-determined order, and dowfopt indicates whether or not
C     rwfopt_p should be called for that state.

         if (.not. full_optimization) then
            do is=1,NSTATE
               do iB=1,3
                  dowfopt(iB,is) = .true.
               enddo
            enddo
            if (parent) then
               print *,'*** *** *** *** *** *** *** *** *** *** *** ***'
               print *,'*** *** UNCONDITIONAL  RWFOPT_P:    *** *** ***'
               print *,'*** *** *** *** *** *** *** *** *** *** *** ***'
            endif
         else
            if (parent) then
               print *,'*** *** *** *** *** *** *** *** *** *** *** ***'
               print *,'*** *** ONLY SELECTIVE RWFOPT_P:    *** *** ***'
               print *,'*** *** *** *** *** *** *** *** *** *** *** ***'
            endif
         endif

         tolog_p = tolog_p * 1d2
C     100 is a large number, but it seems to work...
         CG_ANALYTIC = 0

         do iB=1,3
            do is=1,NSTATE      ! "is" is only an INDEX!!!
                                ! The state is i_state !
               i_state = neighborlist(iB,is)
               if (.not. full_done(iB,i_state)) then
                  call do_full(i_state,iB,
     &                 dowfopt(iB,i_state),
     &                 h1psi0,c0,c1,scr,psi,rhoe,
     &                 eirop,eivps,z11,nstate,lscr)
                  if (exsoft) goto 442

                  call DAXPY(3*3,1d0,chi,1,chi_sumup,1)
                  call azzero(chi,3*3)
                  call DAXPY(3*3*nax*nsx, 1d0,
     &                 shift_matrix,1,shift_sumup,1)
                  call azzero(shift_matrix,3*3*nax*nsx)

                  full_done(iB,i_state) = .true.
                  call restart_nmr(simple_done,full_done,
     &                 shift_sumup,chi_sumup,
     &                 shift_saved,chi_saved,nstate,RESPONSE_WRITE)
               endif
            enddo               ! i_state = 1,...,nstate.
         enddo                  ! iB = 1,2,3
         if (parent) then
            write (6,98)
            write (6,99)
            write (6,98)
            write (6,*)
         endif

 442    call DCOPY(3*3,chi_sumup,1,chi,1)
c        call print_chi_tensor   ! calculates also chi_SI_iso
        call DCOPY(3*3*nax*nsx,shift_sumup,1,shift_matrix,1)
c        call print_shift_matrix(nstate,.false.)

        if (parent) then
           write (6,*)
           write (6,98)
           write (6,82)
           write (6,98)
        endif
        call DCOPY(3*3,    chi_sumup,1,chi,1)
        call DAXPY(3*3,1d0,chi_saved,1,chi,1)
        call DCOPY(3*3*nax*nsx,    shift_sumup,1,shift_matrix,1)
        call DAXPY(3*3*nax*nsx,1d0,shift_saved,1,shift_matrix,1)
        call print_chi_tensor   ! calculates also chi_SI_iso
        call print_shift_matrix(nstate,.true.)


        call freem(ip_neighborlist)
        call freem(ip_dowfopt)
        call freem(ip_shift_sumup)
        call freem(ip_shift_saved)
        call freem(ip_chi_sumup)
        call freem(ip_chi_saved)

      ENDIF                     ! full calculation
c     ==--------------------------------------------------------------==
      if (Tcurrent) then
        if (nmr_threads.ne.1)
     &     call stopgm('NMR_P:','CURRENT NOT SUPERPARALLEL')
        call calc_current(c0,c1,nstate,psi,rhoe,vofrho0,scr,lscr)
        timetag='current density calculation.   '
        if (parent) call printtime
      endif


 444  call freem(ip_shift_matrix)
      call freem(ip_chi)
      call freem(ip_lower_left_value)
      call freem(ip_lower_left)
      call freem(ip_c1)
      if (parent) call freem(ip_wanniercenters)


      if (parent) write (6,'("@ TIME: ",F8.1," sec for ",A40)')
     &     timef()/1000.d0 - starttime,
     &    'the whole calculation.      '

c     ==--------------------------------------------------------------==
      call tihalt('       NMR',isub)
      return
      end
c     ==================================================================
      subroutine give_scr_nmr(lscr,tag)
c     ==--------------------------------------------------------------==
      implicit   none
      include    'system.h'
      include    'fft.inc'
      include    'response_p.inc'
      include    'prop.inc'
      include    'elct.inc'
      include    'wann.inc'
      integer    lscr,l_current
      character  tag*30
      lscr = 1
      if (.NOT. TNMR) return
      call give_scr_nmr_current(l_current,tag)
      if (TLOCALIZE) then
        TWANN = .true.
        LOCL  = .true.
        CALL GIVE_SCR_DDIPO(LSCR,TAG)
      endif
      LSCR=MAX(LSCR,2*NHG,
     &     2*ngw*n,             ! for pcgrad_nmr_p
     &     12*nnr1,             ! for calc_p and calc_L
     &     l_current,           ! for NMR_CURRENT
     &     2*maxfft)            ! for use as fft scratch

      tag  = 'nmr-response          '
      return
      end
c     ==================================================================

