C     ==================================================================
      SUBROUTINE NMR_PARA_P
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'irat.inc'
      INCLUDE 'filn.inc'
      include 'response_p.inc'

      character*1 zahlenchars(0:5)
      data zahlenchars/'0','1','2','3','4','5'/

      integer myfirst


      integer  i,proc_index,proc_index2,itest,
     &    nproc_L,nproc_p


c     SAVE OLD VALUES:
      nmr_superparent   = parent
      nmr_supergroup    = allgrp
      nmr_total_nproc   = nproc
      nmr_supersource   = source

#ifdef PARALLEL

      if (nproc/DBLE(nmr_threads) .lt. 2.99D0)
     &    nmr_threads = 1


      if (parent) write (6,
     &    '("RESPONSE SUPERPARALLEL: Initializing ",I1,'//
     &    '" parallel threads.")') nmr_threads

c     It is problematic if a groundstate-wf-optimization AND a NMR 
c     perturbation run is desired. Then only one thread is possible.
c     The thread business only works well if nothing (except a response) is
c     calculated.
c     ==--------------------------------------------------------------==
      if (nmr_threads.eq.6) then
C     initialization
        do i=0,nmr_total_nproc
          PGROUP(i) = -1
          NLINK(i)  = -1
        enddo
        do i=0,6
          parents(i)=-1
        enddo

c     repartitioning of processors. The p-tasks get 20%-30% more
c     cpus than the L-tasks.
        nproc_L = INT( nmr_total_nproc / 6.6D0 )
        nproc_p = INT((nmr_total_nproc - 3 * nproc_L)/3.0D0)

        parents(1) = 0
        parents(2) =   nproc_p
        parents(3) = 2*nproc_p
        parents(4) = 3*nproc_p
        parents(5) = 3*nproc_p +   nproc_L
        parents(6) = 3*nproc_p + 2*nproc_L
        parents(7) = nmr_total_nproc
        nproc = 0
        do i=1,nmr_threads
          if (parents(i).eq.ME) parent = .true.
          if (parents(i).le.ME .AND. parents(i+1).gt.ME) then
            nmr_mygroup = i-1   ! groups go from 0 to 5
            myfirst     = parents(i)
            if (nproc .NE. 0) call stopgm('NMR_PARA',
     &          'FATAL: Belonging to two threads.')
            nproc       = parents(i+1)-parents(i)
          endif
        enddo
        if (nproc .eq. 0) call stopgm('NMR_PARA',
     &      'FATAL: Belonging to NO thread at all.')
        do i=1,nproc
          PGROUP(i) = myfirst + i-1
          NLINK(myfirst + i-1) = i-1
        enddo
        mepos = me - myfirst
        source = 0
        call my_group(nproc,PGROUP(1),nmr_mygroup,allgrp,nmr_supergroup)
c     ==--------------------------------------------------------------==
      elseif (nmr_threads.eq.3) then
C     initialization
        do i=0,nmr_total_nproc
          PGROUP(i) = -1
          NLINK(i)  = -1
        enddo
        do i=0,6
          parents(i)=-1
        enddo

        nproc_L = INT( nmr_total_nproc / 3.0D0 )

        parents(1) = 0
        parents(2) =   nproc_L
        parents(3) = 2*nproc_L
        parents(4) = nmr_total_nproc

        nproc = 0
        do i=1,nmr_threads
          if (parents(i).eq.ME) parent = .true.
          if (parents(i).le.ME .AND. parents(i+1).gt.ME) then
            nmr_mygroup = i-1   ! groups go from 0 to 2
            myfirst     = parents(i)
            if (nproc .NE. 0) call stopgm('NMR_PARA',
     &          'FATAL: Belonging to two threads.')
            nproc       = parents(i+1)-parents(i)
          endif
        enddo
        if (nproc .eq. 0) call stopgm('NMR_PARA',
     &      'FATAL: Belonging to NO thread at all.')
        do i=1,nproc
          PGROUP(i) = myfirst + i-1
          NLINK(myfirst + i-1) = i-1
        enddo
        mepos = me - myfirst
        source = 0
        call my_group(nproc,PGROUP(1),nmr_mygroup,allgrp,nmr_supergroup)
c     ==--------------------------------------------------------------==
      elseif(nmr_threads.eq.1) then
c     nothing to do. Except:
        nmr_mygroup = 0
        parents(1)  = 0
      else
        call stopgm('NMR_PARA','INVALID NUMBER OF THREADS.')
      endif
c     ==--------------------------------------------------------------==

c     Informative output:
      do i=1,nmr_threads
        if (ME.eq.parents(i)) then
          if (nmr_superparent) then
            write (6,'(A,I3,A,I1,A,I3,A)')
     &          "PROCESSOR ",ME," (GROUP ",nmr_mygroup,
     &          " with ",nproc," procs): I am the superparent. "
          else
            write (6,'(A,I3,A,I1,A,I3,A,A5,A)')
     &          "PROCESSOR ",ME," (GROUP ",nmr_mygroup,
     &          " with ",nproc," procs): Output --> out_",
     &          zahlenchars(nmr_mygroup),"."

            close(6)
            open(unit=6,file='out_'//zahlenchars(nmr_mygroup))
          endif
        endif
        call my_sync(nmr_supergroup)
      enddo

#else
      nmr_threads=1
      nmr_mygroup = 0
      parents(1)  = 0
#endif

      RETURN
      END
C     ==================================================================
      SUBROUTINE REWRITE_OUTPUT
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'response_p.inc'
      character*1 zahlenchars(0:5)
      data zahlenchars/'0','1','2','3','4','5'/
      character*128 transfer
      integer i,ia,ie
 97   FORMAT (10("="),10(" "),A15,I1,10(" "),20("="))
 98   FORMAT (66("="))

      if (parent .AND. .not. nmr_superparent)
     &    close(6)
      call my_sync(nmr_supergroup)

      if (nmr_superparent) then
        do i=1,nmr_threads-1
          write (6,98)
          write (6,97) 'OUTPUT GROUP ',i
          write (6,98)
          open(unit=9,file='out_'//zahlenchars(i))

 20       read (unit=9,fmt='(A128)',end=29) transfer
          write (6,'(A)') transfer(1:66)
          goto 20


 29       close(unit=9)

C     Delete files:
          open(unit=9,file='out_'//zahlenchars(i))
          close(unit=9,status='DELETE')

        enddo
      endif

      return
      end
C     ==================================================================

