C     ==================================================================
      SUBROUTINE NOFORCE(C0,C2,SC0,TAU0,FION,EIGV,
     &                   RHOE,PSI,XMAT1,XMAT2,SCR,LSCR,NSTATE,TFOR)
C     ==--------------------------------------------------------------==
C     ==          COMPUTES FOR  A SET OF NONORTHOGONAL ORBITALS       ==
C     ==                     THE TOTAL ENERGY                         ==
C     ==                  THE ELECTRONIC FORCES                       ==
C     ==                  THE FORCES ON THE IONS                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nort.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGW,*),C2(NGW,*),SC0(NGW,*),PSI(*)
      REAL*8     TAU0(*),FION(*),EIGV(*),RHOE(*),SCR(*)
      LOGICAL    TFOR
      REAL*8  XMAT1(NSTATE,*),XMAT2(NSTATE,*)
C     Variables
      COMPLEX*16 PAB
      REAL*8     GAM(NSTATE,*),AUXC(*),SMAT(NSTATE,*)
      REAL*8     DDIA(*)
      POINTER    (IP_GAM,GAM),(IP_AUXC,AUXC),(IP_SMAT,SMAT)
      POINTER    (IP_DDIA,DDIA)
      DIMENSION  F(NSTATE)
      CHARACTER  TAG*30
      REAL*8     FNL(NAT,NHXS,*),DFNL(*)
      REAL*8     DOTP
      INTEGER    IZAMAX
      EXTERNAL   DOTP,IZAMAX
      LOGICAL    DEBUG
      INTEGER    ISUB,I,IABSL,
     &           IL_GAM,IL_AUXC,IL_SMAT,IL_DDIA,LNOFORCE,
     &           ICON
      DATA       ICON /0/
      SAVE       ICON
#ifdef PARALLEL
      INTEGER    MSGLEN
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   NOFORCE',ISUB)
      DEBUG=.FALSE.
      IF(TLSE) CALL STOPGM('NOFORCE','NO LSE ALLOWED HERE')
      PAB = 0.D0
      IF(IMAGP.EQ.2) CALL STOPGM('NOFORCE','K-POINT NOT IMPLEMENTED')
C     ==--------------------------------------------------------------==
C     SCR partition
      CALL GIVE_SCR_NOFORCE(LNOFORCE,IL_GAM,IL_AUXC,IL_SMAT,IL_DDIA,
     &    TAG,NSTATE,TFOR)
      CALL TEST_SCR('NOFORCE','LENGTH',LSCR,LNOFORCE)
C     ==--------------------------------------------------------------==
      IF(GEQ0) CALL ZCLEAN(C0,NSTATE,NGW)
      GNMAX=0.0D0
      GNORM=0.0D0
      IF(TIVAN) CALL RNLSM(C0,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
C     ==--------------------------------------------------------------==
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_GAM,IL_GAM,'GAM',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_AUXC,IL_AUXC,'AUXC',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_DDIA,IL_DDIA,'DDIA',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_SMAT,IL_SMAT,'SMAT',DEBUG)
C     ==--------------------------------------------------------------==
C     ==   OVERLAP MATRIX                                             ==
C     ==--------------------------------------------------------------==
      CALL CSMAT(GAM,C0,FNL,NSTATE,1)
C     ==--------------------------------------------------------------==
C     ==   CALCULATE INVERSE CHOLESKY DECOMPOSITION                   ==
C     ==   SCHMIDT ORTHOGONALIZATION    SC0 = U**(-1)*C0              ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        CALL DCOPY(NSTATE*NSTATE,GAM(1,1),1,SMAT(1,1),1)
        IF(TLSD) THEN
          CALL UINV('U',SMAT(1,1),NSTATE,NSUP)
          CALL UINV('U',SMAT(NSUP+1,NSUP+1),NSTATE,NSDOWN)
        ELSE
          CALL UINV('U',SMAT,NSTATE,NSTATE)
        ENDIF
        CALL DCOPY(NSTATE*NSTATE,SMAT(1,1),1,XMAT2(1,1),1)
      ENDIF
#ifdef PARALLEL
      MSGLEN = NSTATE*NSTATE * 8
      CALL MY_BCAST(SMAT,MSGLEN,SOURCE,ALLGRP)
#endif
      CALL DCOPY(2*NGW*NSTATE,C0,1,SC0,1)
      CALL ROTTR(1.D0,SC0,SMAT,"N",NSTATE,2*NGW,TLSD,NSUP,NSDOWN)
      IF(GEQ0) CALL ZCLEAN(SC0,NSTATE,NGW)
      CALL SCRREL(SCR,LSCR,DEBUG)
C     ==--------------------------------------------------------------==
C     ==   CALCULATE THE POTENTIAL AND THE FORCE ON THE IONS          ==
C     ==--------------------------------------------------------------==
      CALL RNLSM(SC0,NSTATE,PSI,SCR,LSCR,1,1,TFOR)
      CALL RSCPOT(SC0,TAU0,FION,RHOE,PSI,SCR,LSCR,
     &            TFOR,CALSTE,NSTATE,1)
C     ==--------------------------------------------------------------==
C     ==   CALCULATE THE ELECTRONIC FORCE                             ==
C     ==--------------------------------------------------------------==
      CALL AZZERO(C2,2*NGW*NSTATE)
C     ==--------------------------------------------------------------==
C     == Compute the force on the electronic degrees of freedom due   ==
C     == to the local potential (stored in RHOE)                      ==
C     ==--------------------------------------------------------------==
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_GAM,IL_GAM,'GAM',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_AUXC,IL_AUXC,'AUXC',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_DDIA,IL_DDIA,'DDIA',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_SMAT,IL_SMAT,'SMAT',DEBUG)
C
      CALL VPSI(SC0,C2,F,RHOE,PSI,PAB,NSTATE,1,NLSD)
      IF(TIVAN) THEN
        CALL OVLAP(NSTATE,GAM,C2,SC0)
        CALL HNLMAT(GAM,F,NSTATE)
#ifdef PARALLEL
        CALL SUMMAT(GAM,NSTATE,AUXC,IL_AUXC)
#endif
        CALL ROTATE(-1.0D0,SC0,1.0D0,C2,GAM,NSTATE,2*NGW,
     *              TLSD,NSUP,NSDOWN)
        IF(TFOR) CALL RNLFL(FION,GAM,NSTATE,1)
        IF(CALSTE) CALL NLSL(GAM,NSTATE)
        CALL NLFORCE(C2,F,GAM,AUXC,DDIA,NSTATE)
      ELSE
C     ==--------------------------------------------------------------==
C     == Compute the force on the electronic degrees of freedom due   ==
C     == to the non-local part of the potential, and add it to the    ==
C     == other piece, coming from the local contribution.             ==
C     ==--------------------------------------------------------------==
        CALL FNONLOC(C2,F,NSTATE,AUXC,DDIA,1,NLSD)
        CALL OVLAP(NSTATE,GAM,C2,SC0)
#ifdef PARALLEL
        CALL SUMMAT(GAM,NSTATE,AUXC,IL_AUXC)
#endif
C     ==--------------------------------------------------------------==
C     ==   C2(I) = C2(I) - SUM(J) <SC(I) | H | SC(J)> SC(J)           ==
C     ==--------------------------------------------------------------==
        CALL ROTATE(-1.0D0,SC0,1.0D0,C2,GAM,NSTATE,2*NGW,
     *              TLSD,NSUP,NSDOWN)
      ENDIF
      IF(PRTEIG.AND.PARENT) THEN
        CALL DSCAL(NSTATE*NSTATE,-1.0D0,GAM(1,1),1)
        CALL REIGS(NSTATE,GAM,F,AUXC,EIGV,AUXC(3*N+1))
        CALL DSCAL(NSTATE*NSTATE,-1.0D0,GAM(1,1),1)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==   ROTATE ELECTRONIC FORCE BACK INTO NONORTHOGONAL BASIS      ==
C     ==--------------------------------------------------------------==
      IF(PARENT) CALL DCOPY(NSTATE*NSTATE,XMAT2(1,1),1,SMAT(1,1),1)
#ifdef PARALLEL
      MSGLEN = NSTATE*NSTATE * 8
      CALL MY_BCAST(SMAT,MSGLEN,SOURCE,ALLGRP)
#endif
      CALL ROTTR(1.D0,C2,SMAT,"T",NSTATE,2*NGW,TLSD,NSUP,NSDOWN)
      IF(GEQ0) CALL ZCLEAN(C2,NSTATE,NGW)
C     ==--------------------------------------------------------------==
      GEMAX=0.0D0
      CNORM=0.0D0
      DO I=1,NSTATE
        IABSL=IZAMAX(NGW,C2(1,I),1)
        GEMAX=DMAX1(F(I)*CDABS(C2(IABSL,I)),GEMAX)
        CNORM=CNORM+F(I)*DOTP(NGW,C2(1,I),C2(1,I))
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(1,CNORM)
      CALL GLOMAX(1,GEMAX)
#endif
      CNORM=DSQRT(CNORM/(NSTATE*NGWS))
C     ==--------------------------------------------------------------==
      IF(TFOR) THEN
#ifdef PARALLEL
        CALL GLOSUM(3*NAX*NSX,FION)
#endif
        IF(PARENT) THEN
          CALL SYMVEC(FION,SMAT,IL_SMAT)
          CALL TAUCL(FION)
          CALL GSIZE(FION,GNMAX,GNORM)
        ENDIF
      ENDIF
      CALL SCRREL(SCR,LSCR,DEBUG)
      CALL TIHALT('   NOFORCE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_NOFORCE(LNOFORCE,IL_GAM,IL_AUXC,IL_SMAT,
     &                            IL_DDIA,TAG,NSTATE,TFOR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !PARENT
      INCLUDE 'ropt.inc'        !PRTEIG
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'nlps.inc'        !IMAGP
C     Arguments
      INTEGER   LNOFORCE,NSTATE
      CHARACTER TAG*30
      LOGICAL   TFOR
C     Variables
      INTEGER   IL_GAM,IL_AUXC,IL_SMAT,IL_DDIA,LRNLSM,LRSCPOT
C     ==--------------------------------------------------------------==
      IL_SMAT=0
      IF(TIVAN) THEN
        CALL GIVE_SCR_NLFORCE(IL_GAM,IL_AUXC,IL_DDIA,NSTATE)
      ELSE
        CALL GIVE_SCR_FNONLOC(IL_AUXC,IL_DDIA,NSTATE)
        IL_GAM=IMAGP*NSTATE*NSTATE
      ENDIF
      IF(PRTEIG.AND.PARENT) THEN
        IL_AUXC=MAX(IL_AUXC,NSTATE*(NSTATE+1)/2+3*NSTATE) !REIGS
      ENDIF
      IL_AUXC=MAX(IL_AUXC,NSTATE*NSTATE)
      IL_SMAT=MAX(IL_SMAT,NSTATE*NSTATE)
      IL_DDIA=MAX(IL_DDIA,2*NAX*NSTATE)
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,TFOR)
      CALL GIVE_SCR_RSCPOT(LRSCPOT,TAG,CALSTE)
      LNOFORCE=IL_GAM+IL_AUXC+IL_SMAT+IL_DDIA+100
      LNOFORCE=MAX(LNOFORCE,LRNLSM,LRSCPOT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
