C     ==================================================================
      SUBROUTINE NOSALLOC
C     ==--------------------------------------------------------------==
C     ==  ALLOCATE NOSE ARRAYS                                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'bsym.inc'
      INCLUDE 'mw.inc'
C     Variables
      INTEGER NREPL,MSGLEN,NR,NN,I,K
      LOGICAL IONODE
      INTEGER IA,IS
      logical oldstatus,FERROR
C     ==--------------------------------------------------------------==
C     initialize oldstatus to keep overly eager compilers to optimize it away.
      oldstatus=.false.
      if(qmmm)call mm_dim(mm_go_mm,oldstatus)

      IF(TPATH.OR.TMW) THEN
        IONODE=GRANDPARENT
        IF(TPATH)NREPL=NP_TOTAL
        IF(TMW)NREPL=NWALK
        MSGLEN = 2 * 8/IRAT
        CALL MY_BCAST(TULTRA,MSGLEN,SUPERSOURCE,SUPERGROUP)
      ELSE
        IONODE=PARENT
        NREPL=1
        MSGLEN = 2 * 8/IRAT
        CALL MY_BCAST(TULTRA,MSGLEN,SOURCE,ALLGRP)
      ENDIF
      IF(TNOSEE) THEN
C     NN: Two thermostats for HS & BS wavefunction
        CALL MEMORY(IP_ETA,NCHX*NREPL*BSFAC,'ETA')
        CALL MEMORY(IP_ETADOT,NCHX*NREPL*BSFAC,'ETADOT')
      ENDIF
      IF(TNOSEP) THEN
        IF(TULTRA) THEN
          CALL MEMORY(IP_GKT,2*NSX,'GKT')
          CALL MEMORY(IP_ETAP,NSX*NCHX*NREPL,'ETAP')
          CALL MEMORY(IP_ETAPDOT,NSX*NCHX*NREPL,'ETAPDOT')
          CALL MEMORY(IP_QNOSP,NSX*NCHX*NREPL,'QNOSP')
C (GM) MAXIMUM NUMBER OF LOCAL THERMOSTATS == NAX*NSX
        ELSEIF(TLOCT) THEN
          CALL MEMORY(IP_GKT,2*NAX*NSX,'GKT')
          CALL MEMORY(IP_ETAP,NAX*NSX*NCHX*NREPL,'ETAP')
          CALL MEMORY(IP_ETAPDOT,NAX*NSX*NCHX*NREPL,'ETAPDOT')
          CALL MEMORY(IP_QNOSP,NAX*NSX*NCHX*NREPL,'QNOSP')
          CALL MEMORY(IP_LCTTAB,NAX*NSX/IRAT+1,'LCTTAB')
          CALL MEMORY(IP_LCTMEMB,2*NAX*NSX*NLOCT/IRAT+1,'LCTMEMB')
          CALL MEMORY(IP_NLCTMBM,NLOCT/IRAT+1,'NLCTMBM')
          CALL MEMORY(IP_DOFSL,NLOCT,'DOFSL')
        ELSEIF(TMNOSE) THEN
          CALL MEMORY(IP_GKT,2*3*NAX*NSX,'GKT')
          CALL MEMORY(IP_ETAPM,3*NAX*NSX*NCHX*NREPL,'ETAPM')
          CALL MEMORY(IP_ETAPMDOT,3*NAX*NSX*NCHX*NREPL,'ETAPMDOT')
          CALL MEMORY(IP_QNOSPM,3*NAX*NSX*NCHX*NREPL,'QNOSPM')
          NR=MIN(NREPL,2)
          NN=(3*NAX*NSX*NCHX*NR)/IRAT+1
          CALL MEMORY(IP_NDFNT,NN,'NDFNT')
          CALL MEMORY(IP_MAPDOF,3*NN,'MAPDOF')
          IF (TCAFES) THEN
            CALL MEMORY(IP_TEMPWR,3*NAX*NSX,'TEMPWR')
            CALL MEMORY(IP_WNOSEPR,3*NAX*NSX,'WNOSEPR')
            CALL MEMORY(IP_WNOSEP2R,3*NAX*NSX,'WNOSEP2R')
            CALL MEMORY(IP_CHAINER,3*NAX*NSX,'CHAINER')
            CALL MEMORY(IP_CAFESCL,NAX*NSX,'CAFESCL')
            CALL MEMORY(IP_CAFESTMP,NCAFESGRP,'CAFESTMP')
            CALL MEMORY(IP_CAFESNSE,NCAFESGRP,'CAFESNSE')
C -----------------------------------------------------------------    
            IF (PARENT) THEN
              CALL FILEOPEN(177,'CAFES_IN',FO_OLD,FERROR)
C     CAFES_IN not present use values from input
              IF(FERROR) GOTO 113
              WRITE(6,'(/,1X,A,/,1X,A,I4)')
     &             'USING CAFES GROUP DEFINITIONS FROM CAFES_IN FILE:',
     &             'NUMBER OF CAFES GROUPS:',NCAFESGRP
              DO IS=1,NSP
                DO IA=1,NA(IS)
                  READ(177,ERR=112,END=112,FMT=*) TEMPWR(1,IA,IS),
     *                 WNOSEPR(1,IA,IS), CAFESCL(IA,IS)
                  TEMPWR(2,IA,IS)=TEMPWR(1,IA,IS)
                  TEMPWR(3,IA,IS)=TEMPWR(1,IA,IS)
                  WNOSEPR(2,IA,IS)=WNOSEPR(1,IA,IS)
                  WNOSEPR(3,IA,IS)=WNOSEPR(1,IA,IS)
                  IF(CAFESCL(IA,IS).GT.NCAFESGRP) THEN
                    CALL STOPGM('NOSALLOC','INCONSISTENT CAFES GROUPS')
                  ENDIF
                ENDDO
              ENDDO
              CALL FILECLOSE(177)
              GOTO 114
 112          CALL STOPGM('NOSALLOC','PROBLEMS READING CAFES_IN')
 113          CONTINUE
              K=0
              WRITE(6,'(/,1X,A,/,1X,A,I4)')
     &             'USING CAFES PARAMETERS FROM THE INPUT FILE',
     &             'NUMBER OF CAFES GROUPS:',NCAFESGRP
              WRITE(6,122) 'GROUP', '1ST', 'LAST', 'TEMP', 'FREQ'
              DO I=1,NCAFESGRP
                WRITE(6,121) I,CAFESINI(1,I),CAFESINI(2,I),
     *               CAFESINR(1,I),CAFESINR(2,I)
              ENDDO
              DO IS=1,NSP
                DO IA=1,NA(IS)
                  K=K+1
                  DO I=1,NCAFESGRP
                    IF ((CAFESINI(1,I).le.K)
     *                   .and. (CAFESINI(2,I).ge.K)) THEN
                      CAFESCL(IA,IS)=I
                      TEMPWR(1,IA,IS)=CAFESINR(1,I)
                      WNOSEPR(1,IA,IS)=CAFESINR(2,I)    
                    ENDIF
                  ENDDO
                  TEMPWR(2,IA,IS)=TEMPWR(1,IA,IS)
                  TEMPWR(3,IA,IS)=TEMPWR(1,IA,IS)
                  WNOSEPR(2,IA,IS)=WNOSEPR(1,IA,IS)
                  WNOSEPR(3,IA,IS)=WNOSEPR(1,IA,IS)     
                ENDDO
              ENDDO     
 114          CONTINUE
            ENDIF
            CALL MY_BCAST(CAFESCL,8*NAX*NSX,SOURCE,ALLGRP)
            CALL MY_BCAST(TEMPWR,8*NAX*NSX*3,SOURCE,ALLGRP)
            CALL MY_BCAST(WNOSEPR,8*NAX*NSX*3,SOURCE,ALLGRP)
          ENDIF
        ELSE 
          CALL MEMORY(IP_GKT,2*NSX,'GKT')
          CALL MEMORY(IP_ETAP1,NCHX*NREPL,'ETAP1')
          CALL MEMORY(IP_ETAP1DOT,NCHX*NREPL,'ETAP1DOT')
          CALL MEMORY(IP_QNOSPC,NCHX*NREPL,'QNOSPC')
        ENDIF
      ENDIF
      IF(TNOSEC) THEN
        CALL MEMORY(IP_ETC,NCHX*NREPL,'ETC')
        CALL MEMORY(IP_ETCDOT,NCHX*NREPL,'ETCDOT')
      ENDIF
      IF(TNOSEP.OR.TNOSEE.OR.TNOSEC) THEN
        IF(IONODE) CALL PRMEM('  NOSALLOC')
      ENDIF

      IF(TCAFES.AND.PARENT) THEN
        CALL FILEOPEN(171,'CAFES',FO_APP+FO_VERB,FERROR)
      ENDIF

      if(qmmm)call mm_dim(mm_revert,oldstatus)

 120  FORMAT(I12,I12,F12.2,F12.2,F12.4 )
 121  FORMAT(I12,I12,I12,F12.2,F12.2) 
 122  FORMAT(A12,A12,A12,A12,A12)   
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
