C     ==================================================================
      SUBROUTINE NOSEPA(NP1,NP2)
C     ==--------------------------------------------------------------==
C     == WARNING: USE DELT_ELEC FOR TIMESTEP                          ==
C     ==          SO WE ASSUME THAT DELT_ELEC == DELT_IONS FOR TNOSEP ==
C     ==          (CHECK IN CONTROL_TEST)                             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      INTEGER NP1,NP2
C     Variables
      REAL*8    WNTAU, WDUM, GRSCNST
      PARAMETER (WNTAU=7.26D-7)
      REAL*8    PSUZ(MSUZX,5),
     &          WNOSEE2,DDOF,DRNP,WNOSEP2,WNOSEC2,XNT,PYOSH,
     &          W_YOSH6_0,W_YOSH6_1,W_YOSH6_2,W_YOSH6_3,
     &          W_YOSH7_1,W_YOSH7_2,W_YOSH7_3,W_YOSH7_4,
     &          W_YOSH7_0,
     &          W_YOSH8_0,W_YOSH8_1,W_YOSH8_2,W_YOSH8_3,
     &          W_YOSH8_4,W_YOSH8_5,W_YOSH8_6,W_YOSH8_7
      INTEGER   N1,NC,NTRUE,I,IAT,IS,IA,K,IP,IPP,L,J,M,IMATCH,NO,INTT
C     ==--------------------------------------------------------------==
C     ==  SET THE PARAMETERS OF THE NOSE-HOOVER THERMOSTATS           ==
C     ==--------------------------------------------------------------==
      WNOSEE=WNOSE0*WNTAU 
      WNOSEP=WNOSP0*WNTAU 
      WNOSEC=WNOSC0*WNTAU 
C  constraint contribution for each DOF of the gromos solvent molecules
      GRSCNST=0.0d0
      IF(qmmm.AND.(NRAM_gr.GT.0)) THEN
        GRSCNST=DBLE(NCONS_gr)/DBLE(NRAM_gr)/3.0d0
      ENDIF
C    set parameters for all CAFES chains.
      IF(TLOCT) THEN
         CALL ILCTTAB
         CALL ILCTMEMB
         CALL AZZERO(DOFSL,NLOCT)
      ENDIF
      IF (TCAFES) THEN
         DO IS=1,NSP
          DO IA=1,NA(IS)
           DO K=1,3
            WNOSEPR(K,IA,IS)=WNOSEPR(K,IA,IS)*WNTAU
           ENDDO
          ENDDO
         ENDDO
      ENDIF
      NIT=NIT0
      NCHAIN=NCHP
      NCHE=NCHS
      NCHC=NCHB
      NCALLS=NCALLS0
C..ELECTRON NOSE PARAMETERS
      IF(TNOSEE) THEN
        N1=N*(2*NGWS-1)
        NC=N*N
        IF(NONORT) NC=N
        NTRUE=(N1-NC)
C       if NEDOF<0 use true number of DOFs
        IF( NEDOF0.LE.0.D0 ) THEN
           NEDOF=NINT(NTRUE*ABS(NEDOF0))
        ELSE
           NEDOF=NINT(N*NEDOF0)
        END IF
        WNOSEE2 = WNOSEE*WNOSEE
        QNOSEE(1) = 2.0D0*EKINW/WNOSEE2
        DO I=2,NCHE
          QNOSEE(I) = 2.D0*EKINW/WNOSEE2/DBLE(NEDOF)
        ENDDO
        WRITE(6,'(A,T56,I10)') 
     *   ' NOSEPA| TOTAL # OF ELECTRONIC DEGREES OF FREEDOM: ',NTRUE
        WRITE(6,'(A,T56,I10)') 
     *   ' NOSEPA| USED # OF ELECTRONIC DEGREES OF FREEDOM : ',NEDOF
      ENDIF
C..DEGREES OF FREEDOM
      DOFST=0.0D0
      CALL AZZERO(DOFSU,MAXSP)
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO K=1,3
            IF(LSKCOR(K,IAT).NE.0) THEN
              DOFST=DOFST+1.D0
              DOFSU(IS)=DOFSU(IS)+1.D0
C.. subtract lost DOFs due to gromos solvent constraints 
CES this we should do at a later stage, otherwise
CES the if block after 'DDOF=DABS(3.D0*DBLE(NAT)-DOFST)'
CES will not work
              IF(qmmm) THEN
                IF(IAT.GT.NRPT) THEN
CES                  DOFST=DOFST-GRSCNST
                  DOFSU(IS)=DOFSU(IS)-GRSCNST
                ENDIF
              ENDIF
              IF(TLOCT) THEN
                 IF(LCTTAB(IS,IA).GT.0)  THEN
                    DOFSL(LCTTAB(IS,IA))=DOFSL(LCTTAB(IS,IA))+1.D0
                 ENDIF
              ENDIF
            ENDIF
          ENDDO
        ENDDO
      ENDDO
      IF(TULTRA) CALL NOSCNST
      IF(TLOCT)  CALL LOCCNST
      DDOF=DABS(3.D0*DBLE(NAT)-DOFST)
      IF(.NOT.(TPATH.AND.TPIMD)) THEN
        IF(DDOF.LT.1.D-2) THEN
          DOFST=DOFST-3.D0
          IF(TISOS.AND..NOT.QMMM) THEN
            IF(NAT.EQ.1) THEN
              DOFST=DOFST
            ELSEIF(NAT.EQ.2) THEN
              DOFST=DOFST-2.D0
            ELSE
              DOFST=DOFST-3.D0
            ENDIF
          ENDIF
        ENDIF
      ELSE 
C..Momenta are not conserved in path integral runs
C  No DOFST-3.0
        DRNP=DSQRT(DBLE(NP_TOTAL))
CDM1
C..Classical test
      IF(TESTPI) THEN
        IF(DDOF.LT.1.D-2) THEN
          DOFST=DOFST-3.D0
CDM1        IF(TISOS) DOFST=DOFST-3.D0
          IF(TISOS) THEN
            IF(NAT.EQ.1) THEN
              DOFST=DOFST
            ELSEIF(NAT.EQ.2) THEN
              DOFST=DOFST-2.D0
            ELSE
              DOFST=DOFST-3.D0
            ENDIF
          ENDIF
CDM2
        ENDIF
      ENDIF
CDM2
      ENDIF

C     consider (CPMD) constraints.
      DOFST=DOFST-DBLE(MCNSTR)

      IF(QMMM.AND.(TULTRA.OR.(TMNOSE.AND..NOT.TCAFES))
     +     .AND.(NSOLV*NCONS_gr.NE.0)) THEN
        CALL STOPGM('NOSEPA',
     +       'NO SOLVENT CONSTRAINTS WITH NOSE ULTRA/MASSIVE')
      ELSE
C     consider (classical) solvent constraints.
C     these are already handled in Gromos and thus not in MCNSTR.
         IF(qmmm.and.(NRAM_gr*NCONS_gr.gt.0)) THEN
            DOFST=DOFST-DBLE(NSOLV/NRAM_gr*NCONS_gr)
            IF(TLOCT) CALL LOCGRCNS
      ENDIF
      ENDIF
      WRITE(6,'(A,T56,I10)')
     *   ' NOSEPA| USED # OF NUCLEAR DEGREES OF FREEDOM :    ',
     *                                                   INT(DOFST)
C
C..ION NOSE PARAMETERS
      DO IP=NP1,NP2
        IF(TNOSEP) THEN
          IF(TPATH.AND.TPIMD) THEN
            WNOSEP2 = (DRNP*TEMPW/FACTEM)**2
            IF((TPINM.OR.TSTAGE).AND.IP.EQ.1) WNOSEP2 = WNOSEP*WNOSEP
            IPP=MIN(IP,2)
CDM1
C..Classical test
          IF(TESTPI) THEN
            WNOSEP2 = WNOSEP*WNOSEP
            IPP=1
          ENDIF
          ELSE
            WNOSEP2 = WNOSEP*WNOSEP
            IPP=1
          ENDIF
          IF(TULTRA) THEN
C..EACH ATOM TYPE HAS A SEPERATE CHAIN
            IF(IPP.GT.1) THEN
              DO IS=1,NSP
                GKT(IPP,IS) = 3.D0*NA(IS)*TEMPW/FACTEM
                QNOSP(IS,1,IP) = GKT(IPP,IS)/WNOSEP2
                DO L=2,NCHAIN
                  QNOSP(IS,L,IP) = GKT(IPP,IS)/WNOSEP2/(3.D0*NA(IS))
                ENDDO
              ENDDO
            ELSE
              DO IS=1,NSP
                GKT(IPP,IS) = DOFSU(IS)*TEMPW/FACTEM
                QNOSP(IS,1,IP) = GKT(IPP,IS)/WNOSEP2
                DO L=2,NCHAIN
                  QNOSP(IS,L,IP) = GKT(IPP,IS)/WNOSEP2/DOFSU(IS)
                ENDDO
              ENDDO
            ENDIF
          ELSEIF(TLOCT) THEN
            IF(IPP.GT.1) THEN
              DO IS=1,NLOCT
                WNOSEP=LOCTPIN(2,IS)*WNTAU
                WNOSEP2=WNOSEP*WNOSEP
                GKT(IPP,IS) = 3.D0*NLCTMBM(IS)*LOCTPIN(1,IS)/FACTEM
                QNOSP(IS,1,IP) = GKT(IPP,IS)/WNOSEP2
                DO L=2,NCHAIN
                  QNOSP(IS,L,IP) = GKT(IPP,IS)/WNOSEP2/
     *                  (3.D0*NLCTMBM(IS))
                ENDDO
              ENDDO
            ELSE 
              DO IS=1,NLOCT
                IF(DOFSL(IS).LE.1.0E-6) THEN
                   CALL STOPGM('NOSEPARA','LOCAL DOF NOT GT THAN 0')
                ENDIF
                WNOSEP=LOCTPIN(2,IS)*WNTAU
                WNOSEP2=WNOSEP*WNOSEP
                GKT(IPP,IS) = DOFSL(IS)*LOCTPIN(1,IS)/FACTEM
                QNOSP(IS,1,IP) = GKT(IPP,IS)/WNOSEP2
                DO L=2,NCHAIN
                  QNOSP(IS,L,IP) = GKT(IPP,IS)/WNOSEP2/DOFSL(IS)
                ENDDO
              ENDDO
            ENDIF
          ELSEIF(TMNOSE) THEN
            IF(TCAFES) THEN
              NTHERM(IPP)=3*NAT
              INTT=0
              DO IS=1,NSP
                DO IA=1,NA(IS)
                  DO K=1,3
                    WNOSEP2R(K,IA,IS)=WNOSEPR(K,IA,IS)**2
                    INTT=INTT+1
                    NDFNT(INTT,IPP)=1
                    MAPDOF(1,INTT,IPP)=K
                    MAPDOF(2,INTT,IPP)=IA
                    MAPDOF(3,INTT,IPP)=IS
                    GKT(IPP,INTT) = TEMPWR(K,IA,IS)/FACTEM
                    QNOSPM(INTT,1,IP) = GKT(IPP,INTT)/WNOSEP2R(K,IA,IS)
                    DO L=2,NCHAIN
                     QNOSPM(INTT,L,IP) = GKT(IPP,INTT)/WNOSEP2R(K,IA,IS)
                    ENDDO
                  ENDDO
                ENDDO
              ENDDO
            ELSE
              CALL MASSCNST(IP,IPP,WNOSEP2)
            ENDIF
          ELSE
            IF(IPP.GT.1) THEN
              GKT(IPP,1) = 3.D0*NAT*TEMPW/FACTEM
              QNOSPC(1,IP) = GKT(IPP,1)/WNOSEP2
              DO L=2,NCHAIN
                QNOSPC(L,IP) = GKT(IPP,1)/WNOSEP2/(3.D0*NAT)
              ENDDO
            ELSE
              GKT(IPP,1) = DOFST*TEMPW/FACTEM
              QNOSPC(1,IP) = GKT(IPP,1)/WNOSEP2
              DO L=2,NCHAIN
                QNOSPC(L,IP) = GKT(IPP,1)/WNOSEP2/DOFST
              ENDDO
            ENDIF
          ENDIF
        ENDIF
      ENDDO
      IF(TNOSEC) THEN
        NCDOF = 9
        IF(TISOT) NCDOF = 1
        IF(TZFLEX) NCDOF = 1
        GCKT = DBLE(NCDOF)*TEMPC/FACTEM
        WNOSEC2 = WNOSEC*WNOSEC
        QNOSCC(1) = DBLE(NCDOF)*TEMPC/(FACTEM*WNOSEC2)
        DO L=2,NCHC
          QNOSCC(L) = TEMPC/(FACTEM*WNOSEC2)
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TPATH.AND.TPIMD) THEN
        IF(GRANDPARENT) THEN
          WRITE(6,*)
          WRITE(6,'(A,A)') ' *********************************',
     *                     '*******************************'
          WRITE(6,'(A,A)') ' THERMOSTATS: CHANGE IONIC NOSE',
     *                     ' FREQUENCIES IN PATH INTEGRAL CASE'
          IF(TPINM.OR.TSTAGE) THEN
            IF(TCENTRO) THEN
              IF(.NOT.TMNOSE)
     *          WRITE(6,'(/,A,A,/)')
     *        ' WARNING FROM NOSEPA: YOU SHOULD USE MASSIVE',
     *        ' THERMOSTATTING FOR CENTROID PIMD !!'

              WRITE(6,'(A,A)') ' FOR STAGING OR NORMAL MODE PROPAGATOR',
     *                         ' WITH CENTROID DYNAMICS'
              WRITE(6,'(A,A)')
     *        '    NO THERMOSTAT ON FIRST BEAD  IP=1 '
              WDUM=(DRNP*TEMPW/FACTEM)/WNTAU
              WRITE(6,'(A,F12.2,A)')
     *        '    CHARACTERISTIC FREQUENCY FOR IP>1 :',WDUM,' CM**-1 '
            ELSE
              WRITE(6,'(A)') ' FOR STAGING OR NORMAL MODE PROPAGATOR'
              WDUM=WNOSEP/WNTAU
              WRITE(6,'(A,F12.2,A)')
     *        '    CHARACTERISTIC FREQUENCY FOR IP=1 :',WDUM,' CM**-1 '
              WDUM=(DRNP*TEMPW/FACTEM)/WNTAU
              WRITE(6,'(A,F12.2,A)')
     *        '    CHARACTERISTIC FREQUENCY FOR IP>1 :',WDUM,' CM**-1 '
            ENDIF
          ELSE
            WRITE(6,'(A)') ' FOR PRIMITIVE PROPAGATOR'
            WDUM=(DRNP*TEMPW/FACTEM)/WNTAU
            WRITE(6,'(A,F12.2,A)')
     *      '    CHARACTERISTIC FREQUENCY FOR IP=1 :',WDUM,' CM**-1 '
            WDUM=(DRNP*TEMPW/FACTEM)/WNTAU
            WRITE(6,'(A,F12.2,A)')
     *      '    CHARACTERISTIC FREQUENCY FOR IP>1 :',WDUM,' CM**-1 '
          ENDIF
          WRITE(6,'(A,A)') ' *********************************',
     *                     '*******************************'
          WRITE(6,*)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NCHAIN.GT.NCHX) THEN
        WRITE(6,*) ' NOSE-HOOVER CHAIN TOO LONG (IONS) ',NCHAIN,NCHX
        CALL STOPGM('NOSEPA',' ')
      ENDIF
      IF(NCHE.GT.NCHX) THEN
        WRITE(6,*) ' NOSE-HOOVER CHAIN TOO LONG (ELECTRONS) ',NCHE,NCHX
        CALL STOPGM('NOSEPA',' ')
      ENDIF
C..THE FOLLOWING IS RELATED TO SUZUKI-NOSE INTEGRATION
      DO NO = 2,MSUZX
        XNT = 1.D0/(2.D0*DBLE(NO) - 1.d0)
        DO I = 1,5
          PSUZ(NO,I) = 1.D0/(4.D0 - 4.D0**XNT)
          IF(MOD(I,3).EQ.0)
     *      PSUZ(NO,I) = 1.D0 - 4.D0/(4.D0 - 4.D0**XNT)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
C..MATCH FLAG FOR NUMBER OF TIME STEPS
      IMATCH=-1
C     ==--------------------------------------------------------------==
      IF(NCALLS.EQ.3) THEN
        PYOSH = 1.0D0/(2.0D0 - 2.0D0**(1.D0/3.D0))
        DTSUZ(1) = PYOSH*DELT_ELEC/DBLE(NIT)
        DTSUZ(2) = -(2.D0**(1.D0/3.D0))*PYOSH*DELT_ELEC/DBLE(NIT)
        DTSUZ(3) = PYOSH*DELT_ELEC/DBLE(NIT)
        NCALLS = 3
        IMATCH=1
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NCALLS.EQ.5) THEN
        K=0
        DO I=1,5
          K=K+1
          DTSUZ(K) = PSUZ(2,I)*DELT_ELEC/DBLE(NIT)
        ENDDO
        IMATCH=1
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NCALLS.EQ.7) THEN
       W_YOSH6_1 =  0.784513610477560D0
       W_YOSH6_2 =  0.235573213359357D0
       W_YOSH6_3 = -0.117767998417887D1
       W_YOSH6_0 = 1.0D0 - 2.0D0*(W_YOSH6_1+W_YOSH6_2+W_YOSH6_3)
       DTSUZ(1) = W_YOSH6_3*DELT_ELEC/DBLE(NIT)
       DTSUZ(2) = W_YOSH6_2*DELT_ELEC/DBLE(NIT)
       DTSUZ(3) = W_YOSH6_1*DELT_ELEC/DBLE(NIT)
       DTSUZ(4) = W_YOSH6_0*DELT_ELEC/DBLE(NIT)
       DTSUZ(5) = W_YOSH6_1*DELT_ELEC/DBLE(NIT)
       DTSUZ(6) = W_YOSH6_2*DELT_ELEC/DBLE(NIT)
       DTSUZ(7) = W_YOSH6_3*DELT_ELEC/DBLE(NIT)
       IMATCH=1
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NCALLS.EQ.9) THEN
       W_YOSH7_1 = 0.192D0 
       W_YOSH7_2 =  0.554910818409783619692725006662999D0 
       W_YOSH7_3 =  0.124659619941888644216504240951585D0
       W_YOSH7_4 =  -0.843182063596933505315033808282941D0
       W_YOSH7_0 = 1.0D0 - 2.0D0*(W_YOSH7_1+W_YOSH7_2+
     *             W_YOSH7_3+W_YOSH7_4)
       DTSUZ(1) = W_YOSH7_4*DELT_ELEC/DBLE(NIT)
       DTSUZ(2) = W_YOSH7_3*DELT_ELEC/DBLE(NIT)
       DTSUZ(3) = W_YOSH7_2*DELT_ELEC/DBLE(NIT)
       DTSUZ(4) = W_YOSH7_1*DELT_ELEC/DBLE(NIT)
       DTSUZ(5) = W_YOSH7_0*DELT_ELEC/DBLE(NIT)
       DTSUZ(6) = W_YOSH7_1*DELT_ELEC/DBLE(NIT)
       DTSUZ(7) = W_YOSH7_2*DELT_ELEC/DBLE(NIT)
       DTSUZ(8) = W_YOSH7_3*DELT_ELEC/DBLE(NIT)
       DTSUZ(9) = W_YOSH7_4*DELT_ELEC/DBLE(NIT)
       IMATCH=1
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NCALLS.EQ.15) THEN
       W_YOSH8_1 =  0.102799849391985D0
       W_YOSH8_2 = -0.196061023297549D1
       W_YOSH8_3 =  0.193813913762276D1
       W_YOSH8_4 = -0.158240635368243D0
       W_YOSH8_5 = -0.144485223686048D1
       W_YOSH8_6 =  0.253693336566229D0
       W_YOSH8_7 =  0.914844246229740D0
       W_YOSH8_0 = 1.0D0 - 2.0D0*(W_YOSH8_1+W_YOSH8_2+W_YOSH8_3
     *                      +W_YOSH8_4+W_YOSH8_5+W_YOSH8_6
     *                      +W_YOSH8_7)
       DTSUZ(1) = W_YOSH8_7*DELT_ELEC/DBLE(NIT)
       DTSUZ(2) = W_YOSH8_6*DELT_ELEC/DBLE(NIT)
       DTSUZ(3) = W_YOSH8_5*DELT_ELEC/DBLE(NIT)
       DTSUZ(4) = W_YOSH8_4*DELT_ELEC/DBLE(NIT)
       DTSUZ(5) = W_YOSH8_3*DELT_ELEC/DBLE(NIT)
       DTSUZ(6) = W_YOSH8_2*DELT_ELEC/DBLE(NIT)
       DTSUZ(7) = W_YOSH8_1*DELT_ELEC/DBLE(NIT)
       DTSUZ(8) = W_YOSH8_0*DELT_ELEC/DBLE(NIT)
       DTSUZ(9) = W_YOSH8_1*DELT_ELEC/DBLE(NIT)
       DTSUZ(10) = W_YOSH8_2*DELT_ELEC/DBLE(NIT)
       DTSUZ(11) = W_YOSH8_3*DELT_ELEC/DBLE(NIT)
       DTSUZ(12) = W_YOSH8_4*DELT_ELEC/DBLE(NIT)
       DTSUZ(13) = W_YOSH8_5*DELT_ELEC/DBLE(NIT)
       DTSUZ(14) = W_YOSH8_6*DELT_ELEC/DBLE(NIT)
       DTSUZ(15) = W_YOSH8_7*DELT_ELEC/DBLE(NIT)
       IMATCH=1
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NCALLS.EQ.25) THEN
        K=0
        DO J=1,5
          DO I=1,5
            K=K+1
            DTSUZ(K) = PSUZ(2,I)*PSUZ(3,J)*DELT_ELEC/DBLE(NIT)
          ENDDO
        ENDDO
        IMATCH=1
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NCALLS.EQ.125) THEN
        K=0
        DO L=1,5
          DO J=1,5
            DO I=1,5
              K=K+1
              DTSUZ(K) = PSUZ(2,I)*PSUZ(3,J)*PSUZ(4,L)*
     &             DELT_ELEC/DBLE(NIT)
            ENDDO
          ENDDO
        ENDDO
        IMATCH=1
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NCALLS.EQ.625) THEN
        K=0
        DO M=1,5
         DO L=1,5
           DO J=1,5
             DO I=1,5
               K=K+1
               DTSUZ(K) = PSUZ(2,I)*PSUZ(3,J)*PSUZ(4,L)*PSUZ(5,M)*
     *                    DELT_ELEC/DBLE(NIT)
            ENDDO
          ENDDO
         ENDDO
        ENDDO
        IMATCH=1
      ENDIF
C     ==--------------------------------------------------------------==
      IF(IMATCH.LT.0) THEN
       WRITE(6,*) NCALLS,' SUZUKI/YOSHIDA STEPS NOT PROGRAMMED.'
       WRITE(6,*) 'SORRY, DUDE'
       WRITE(6,*) 'POSSIBLE CHOICES FOR NCALLS ARE '
       WRITE(6,*) '3 5 7 9 15 25 125 625'
       CALL STOPGM('NOSEPA',' ')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE NOSCNST
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
C     Variables
      INTEGER   N1(*)
      POINTER   (IP_N1,N1)
      REAL*8    DDC(MAXSP)
      INTEGER   IAT,IS,IA,I,IS1,IS2,IS3,IS4
C     ==--------------------------------------------------------------==
      IF(MCNSTR.EQ.0) RETURN
      CALL MEMORY(IP_N1,3*NAX*NSP+1,'N1')
      IAT=0
      N1(1)=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          N1(IAT+1)=IS
        ENDDO
        DDC(IS)=0.D0
      ENDDO
      DO I=1,MCNSTR
        IS1=N1(NTCNST(2,I)+1)
        DDC(IS1)=DDC(IS1)+1.D0
        IS2=N1(NTCNST(3,I)+1)
        IS3=N1(NTCNST(4,I)+1)
        IS4=N1(NTCNST(5,I)+1)
        IF(IS1.NE.IS2.AND.IS2.NE.0) GOTO 100
        IF(IS1.NE.IS3.AND.IS3.NE.0) GOTO 100
        IF(IS1.NE.IS4.AND.IS4.NE.0) GOTO 100
      ENDDO
      DO IS=1,NSP
        DOFSU(IS)=DOFSU(IS)-DDC(IS)
      ENDDO
      CALL FREEM(IP_N1)
C     ==--------------------------------------------------------------==
      RETURN
  100 CONTINUE
      WRITE(6,*) ' CONSTRAINTS ONLY ON EQUAL ATOM TYPES ALLOWED '
      WRITE(6,*) ' WITH THIS TYPE OF NOSE THERMOSTATS  '
      CALL STOPGM('NOSCNST','NOSE + CONSTRAINTS')
      END
C     ==================================================================
      SUBROUTINE MASSCNST(IP,IPP,WNOSEP2)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'irat.inc'
C     Arguments
      INTEGER  IP,IPP
      REAL*8   WNOSEP2
C     Variables
      INTEGER   NXX(*)
      POINTER  (IP_NXX,NXX)
      INTEGER  INTT,IS,IA,L,K,I,NT,ID,IAT,IPN
C     ==--------------------------------------------------------------==
      IF(MCNSTR.EQ.0.OR.IPP.GT.1) THEN
        NTHERM(IPP)=3*NAT
        INTT=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            DO K=1,3
              INTT=INTT+1
              NDFNT(INTT,IPP)=1
              MAPDOF(1,INTT,IPP)=K
              MAPDOF(2,INTT,IPP)=IA
              MAPDOF(3,INTT,IPP)=IS
              GKT(IPP,INTT) = TEMPW/FACTEM
              QNOSPM(INTT,1,IP) = GKT(IPP,INTT)/WNOSEP2
              DO L=2,NCHAIN
                QNOSPM(INTT,L,IP) = GKT(IPP,INTT)/WNOSEP2
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ELSE
        CALL MEMORY(IP_NXX,(3*NAX*NSX+1)/IRAT+1,'NXX')
        CALL IAZZERO(NXX,3*NAX*NSX)
C..mark all atoms involved in constraints
        DO I=1,MCNSTR
          IF(NTCNST(2,I).NE.0) NXX(NTCNST(2,I))=1
          IF(NTCNST(3,I).NE.0) NXX(NTCNST(3,I))=1
          IF(NTCNST(4,I).NE.0) NXX(NTCNST(4,I))=1
          IF(NTCNST(5,I).NE.0) NXX(NTCNST(5,I))=1
        ENDDO

        NT=0
        DO IA=1,NAT
          NT=NT+NXX(IA)
        ENDDO
C..assume that atoms involved in constraints have no fixed coordinates
        NDFNT(1,IPP)=3*NT
        GKT(IPP,1)=(3*NT-MCNSTR)*TEMPW/FACTEM
        QNOSPM(1,1,IP) = GKT(IPP,1)/WNOSEP2
        DO L=2,NCHAIN
          QNOSPM(1,L,IP) = GKT(IPP,1)/WNOSEP2/(3*NT-MCNSTR)
        ENDDO
C..other degrees of freedom
        NTHERM(IPP)=1
        ID=0
        IAT=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IAT=IAT+1
            IF(NXX(IAT).EQ.0) THEN
              DO K=1,3
                NTHERM(IPP)=NTHERM(IPP)+1
                IPN=NTHERM(IPP)
                NDFNT(IPN,IPP)=1
                INTT=IPN+NDFNT(1,IPP)-1
                MAPDOF(1,INTT,IPP)=K
                MAPDOF(2,INTT,IPP)=IA
                MAPDOF(3,INTT,IPP)=IS
                GKT(IPP,IPN) = TEMPW/FACTEM
                QNOSPM(IPN,1,IP) = GKT(IPP,IPN)/WNOSEP2
                DO L=2,NCHAIN
                  QNOSPM(IPN,L,IP) = GKT(IPP,IPN)/WNOSEP2
                ENDDO
              ENDDO
            ELSE
              DO K=1,3
                ID=ID+1
                MAPDOF(1,ID,IPP)=K
                MAPDOF(2,ID,IPP)=IA
                MAPDOF(3,ID,IPP)=IS
              ENDDO
            ENDIF
          ENDDO
        ENDDO
        CALL FREEM(IP_NXX)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE ILCTTAB
C     ==--------------------------------------------------------------==
C     == BUILD MAP CPMD NO -> LOCAL THERMOSTAT NO.                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'mm_dim.inc'
C     Variables
      INTEGER IA,ICA,ISP,IAS,ILE,IDXLCT,ISTART,ISTOP
C     ==--------------------------------------------------------------==

      CALL IAZZERO(LCTTAB,NSX*NAX)
      DO ILE=1,NLOCRNG
         IDXLCT=LCTRNG(1,ILE)
         ISTART=LCTRNG(2,ILE)
         ISTOP= LCTRNG(3,ILE)
         IF(ISTART.GT.ISTOP) CALL STOPGM('LOCAL THERMOSTATS',
     *      'RANGE START GREATER THAN RANGE STOP')
         DO IA=ISTART,ISTOP
            ICA=NAT_cpmd(IA)
            ISP=CPSP(IA)
            IAS=CPAT(IA)
            IF(LCTTAB(ISP,IAS).NE.0) THEN
               IF(LCTTAB(ISP,IAS).EQ.IDXLCT) THEN
                  WRITE(6,'(1X,A,I6,1X,A)')
     &             'LOCAL TEMPERATURE WARNING: ATOM',IA,
     &             'BELONGS TO MORE THAN ONE THERMOSTAT RANGE'
               ELSE
                  CALL STOPGM('LOCAL TEMPERATURE',
     &                 'FOUND ATOM BELONGING TO TWO THERMOSTATS')
               ENDIF
            ELSE
               LCTTAB(ISP,IAS)=IDXLCT
            ENDIF

         ENDDO
         
      ENDDO
C      DO ISP=1,NSP
C         DO IAS=1,NA(ISP)
C            PRINT *, 'LCTTAB(',ISP,',',IAS,') GR_no',
C     *           gratom((ISP-1)*NAX+IAS),' LOCTST', LCTTAB(ISP,IAS)
C         ENDDO
C      ENDDO
 
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================

C     ==================================================================
      SUBROUTINE ILCTMEMB
C     ==--------------------------------------------------------------==
C     == LIST ATOMS BELONGING TO THERMOSTAT NO.                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'mm_dim.inc'
C     Variables
      INTEGER IA,IS,IAG,IDXLCT,K
C     ==--------------------------------------------------------------==
      CALL IAZZERO(LCTMEMB,2*NSX*NAX*NLOCT)
      CALL IAZZERO(NLCTMBM,NLOCT)

      DO IS=1,NSP
         DO IA=1,NA(IS)
             IDXLCT=LCTTAB(IS,IA)
             IF(IDXLCT.GT.0) THEN
                NLCTMBM(IDXLCT)=NLCTMBM(IDXLCT)+1
                LCTMEMB(1,NLCTMBM(IDXLCT),IDXLCT)=IS
                LCTMEMB(2,NLCTMBM(IDXLCT),IDXLCT)=IA
             ENDIF
         ENDDO
      ENDDO
C  DEBUG 
       DO IDXLCT=1,NLOCT
C         PRINT *,PARENT,'ATOMS IN THERMOSTATNO.',IDXLCT,NLCTMBM(IDXLCT)
          DO K=1,NLCTMBM(IDXLCT)
             IS=LCTMEMB(1,K,IDXLCT)
             IA=LCTMEMB(2,K,IDXLCT)
             IAG=gratom((IS-1)*NAX+IA)
C             WRITE(6,'(I5)') IAG
          ENDDO
C         PRINT *
       ENDDO 

 
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE LOCCNST
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'mm_dim.inc'
C     Variables
      INTEGER   N1(*)
      POINTER   (IP_N1,N1)
      REAL*8    DDC(NLOCT)
      INTEGER   IAT,IS,IA,I,IL1,IL2,IL3,IL4
C     ==--------------------------------------------------------------==
      IF(MCNSTR.EQ.0) RETURN
      CALL MEMORY(IP_N1,3*NAX*NSPm+1,'N1')
      CALL AZZERO(DDC,NLOCT)
      IAT=0
      N1(1)=0
      DO IS=1,NSPm
        DO IA=1,NAm(IS)
          IAT=IAT+1
          N1(IAT+1)=LCTTAB(IS,IA)
        ENDDO
      ENDDO
      DO I=1,MCNSTR
        IL1=N1(NTCNST(2,I)+1)
        DDC(IL1)=DDC(IL1)+1.D0
        IL2=N1(NTCNST(3,I)+1)
        IL3=N1(NTCNST(4,I)+1)
        IL4=N1(NTCNST(5,I)+1)
        IF(IL1.NE.IL2.AND.IL2.NE.0) GOTO 200
        IF(IL1.NE.IL3.AND.IL3.NE.0) GOTO 200
        IF(IL1.NE.IL4.AND.IL4.NE.0) GOTO 200
      ENDDO
      DO I=1,NLOCT
        WRITE(6,'(1X,A,F8.1,1X,A,I4)') 'FOUND ',DDC(I)
     *        ,'CPMD CONSTRAINTS FOR THERMOSTAT',I
        DOFSL(I)=DOFSL(I)-DDC(I)
      ENDDO
      CALL FREEM(IP_N1)
C     ==--------------------------------------------------------------==
      RETURN
  200 CONTINUE
      WRITE(6,*) ' CONSTRAINTS ONLY ON EQUAL LOCAL THERMOSTATS ALLOWED '
      WRITE(6,*) ' WITH THIS TYPE OF NOSE THERMOSTATS  '
      CALL STOPGM('NOSCNST','NOSE + CONSTRAINTS')
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE LOCGRCNS
C     ==--------------------------------------------------------------==
C     CORRECT LOCAL DOF FOR SOLVENT CONSTRAINTS
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'mm_dim.inc'
      
C     Variables
      INTEGER   N1(*)
      POINTER   (IP_N1,N1)
      REAL*8    DDC(NLOCT)
      INTEGER   ISL,IS,IA,IAT,I,IDXLCT,LASTIDX
C     ==--------------------------------------------------------------==


      CALL MEMORY(IP_N1,NAX*NSPm+1,'N1')
      CALL AZZERO(DDC,NLOCT)

      IAT=0
      N1(1)=0
      DO IS=1,NSPm
        DO IA=1,NAm(IS)
          IAT=IAT+1
          N1(IAT)=LCTTAB(IS,IA)
C         print *,is,ia,iat,n1(iat)
        ENDDO
      ENDDO
      
      DO ISL=0,NSOLV/NRAM_gr-1
         LASTIDX=0
         DO I=1,NRAM_gr
            IAT=NAT_cpmd(NRPT+ISL*NRAM_gr+I)
            IDXLCT=N1(IAT)
C           print *,isl,i,NRPT+ISL*NRAM_gr+I,iat,idxlct
            IF(I.GT.1.AND.LASTIDX.NE.IDXLCT) THEN
C             ATOMS OF THE SOLVENT DO NOT BELONG TO THE SAME THERMOSTAT
               GOTO 201
            ENDIF
            LASTIDX=IDXLCT
         ENDDO
         DDC(IDXLCT)= DDC(IDXLCT)+DBLE(NCONS_gr)
      ENDDO

      DO I=1,NLOCT
        WRITE(6,'(1X,A,F8.1,1X,A,I4)') 'FOUND ',DDC(I),
     *        'SOLVENT CONSTRAINTS FOR THERMOSTAT',I
        DOFSL(I)=DOFSL(I)-DDC(I)
      ENDDO
      CALL FREEM(IP_N1)
C     ==--------------------------------------------------------------==
      RETURN
 201  CONTINUE
      print *,nrpt,isl,i,iat,NRPT+ISL*NRAM_gr+I,IDXLCT,LASTIDX
      WRITE(6,*) ' SOLVENT MOLECULES ONLY IN  EQUAL LOCAL THERMOSTATS '
      WRITE(6,*) ' ALLOWED. CHECK YOUR INPUT'
      CALL STOPGM('NOSCNST','NOSE + SOLVENT CONSTRAINTS')
      END
C     ==================================================================
