C     ==================================================================
      SUBROUTINE NOSEUP(VELP,CM,NSTATE,IP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'bsym.inc'
C     Arguments
      INTEGER    NSTATE,IP
      REAL*8     VELP(*)
      COMPLEX*16 CM(*)
C     Variables
      REAL*8     EKINC,SCTOT
      INTEGER    ISUB,I,J,MSGLEN
C     ==--------------------------------------------------------------==
      CALL TISET('    NOSEUP',ISUB)
      IF(TNOSEE) THEN
        CALL REKINE(CM,NSTATE,EKINC)
        IF(PARENT) THEN
          SCTOT=1.0D0
          DO I=1,NIT
            DO J=1,NCALLS
              CALL ENOSMOVE(EKINC,DTSUZ(J),SCTOT,IP)
            ENDDO
          ENDDO
        ENDIF
        MSGLEN = 1 * 8
        CALL MY_BCAST(SCTOT,MSGLEN,SOURCE,ALLGRP)
        CALL DSCAL(2*NGW*NSTATE,SCTOT,CM,1)
      ENDIF
C     FOR BS_CPMD: IF WF IS HS, SKIP THE REST
      IF(BSYMM.AND.(BSCLCS.EQ.2))THEN
        CALL TIHALT('    NOSEUP',ISUB)
        RETURN
      END IF
C
      IF(TNOSEP.AND.PARENT.AND..NOT.TNOSEC) THEN
        DO I=1,NIT
          DO J=1,NCALLS
            IF(TPATH.AND.TPIMD) THEN
              IF(.NOT.(TCENTRO.AND.IP.EQ.1)) THEN
                IF(TPINM.OR.TSTAGE) THEN
                  CALL PNOSMOVE(VELP,DTSUZ(J),PMA0S(1,IP),IP)
                ELSE
                  CALL PNOSMOVE(VELP,DTSUZ(J),PMA,IP)
                ENDIF
              ENDIF
            ELSE
              CALL PNOSMOVE(VELP,DTSUZ(J),PMA,IP)
            ENDIF
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     AK: FIXME  
      IF(TPRCP.AND.PARENT.AND.TZFLEX) THEN
        CALL STOPGM('NOSEUP','NO NOSE THERMOSTAT FOR ZFLEXIBLE CELL')
      ENDIF
C
      IF(TPRCP.AND.PARENT.AND.TISOT) THEN
       IF(TNOSEP.AND..NOT.TNOSEC) THEN
        DO I=1,NIT
          DO J=1,NCALLS
            CALL PRPNOSMOVE_ISO(VELP,DTSUZ(J),IP)
          ENDDO
        ENDDO
       ELSEIF(.NOT.TNOSEP.AND.TNOSEC) THEN
        DO I=1,NIT
          DO J=1,NCALLS
            CALL PRCNOSMOVE_ISO(VELP,DTSUZ(J),IP)
          ENDDO
        ENDDO
       ELSEIF(TNOSEP.AND.TNOSEC) THEN
        DO I=1,NIT
          DO J=1,NCALLS
            CALL PRPCNOSMOVE_ISO(VELP,DTSUZ(J),IP)
          ENDDO
        ENDDO
       ELSE
        DO I=1,NIT
          DO J=1,NCALLS
            CALL PRPCMOVE_ISO(VELP,DTSUZ(J))
          ENDDO
        ENDDO
       ENDIF
C     ==--------------------------------------------------------------==
      ELSEIF(TPRCP.AND.PARENT.AND..NOT.TISOT.AND..NOT.TSHOCK) THEN
C     ==--------------------------------------------------------------==
       IF(TNOSEP.AND..NOT.TNOSEC) THEN
        DO I=1,NIT
          DO J=1,NCALLS
            CALL PRPNOSMOVE(VELP,DTSUZ(J),IP)
          ENDDO
        ENDDO
       ELSEIF(.NOT.TNOSEP.AND.TNOSEC) THEN
        DO I=1,NIT
          DO J=1,NCALLS
            CALL PRCNOSMOVE(VELP,DTSUZ(J),IP)
          ENDDO
        ENDDO
       ELSEIF(TNOSEP.AND.TNOSEC) THEN
        DO I=1,NIT
          DO J=1,NCALLS
            CALL PRPCNOSMOVE(VELP,DTSUZ(J),IP)
          ENDDO
        ENDDO
       ELSE
        DO I=1,NIT
          DO J=1,NCALLS
            CALL PRPCMOVE(VELP,DTSUZ(J))
          ENDDO
        ENDDO
       ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      CALL TIHALT('    NOSEUP',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


