C     ==================================================================
      SUBROUTINE NOSPINIT(IP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'pimd.inc'
C     Arguments
      INTEGER IP
C     Variables
      REAL*8  RNR(3),SEED,SIGMA,ALFA1,XRANF,ALFA
      EXTERNAL XRANF
      INTEGER IPP,IS,L,K
      INTEGER ATK, ATIA,ATIS
C     ==--------------------------------------------------------------==
C     ==  ION NOSE PARAMETERS                                         ==
C     ==  MAXWELL-BOLTZMANN SAMPLING FOR NOSE VELOCITIES              ==
C     ==--------------------------------------------------------------==
      IF(TPATH.AND.TPIMD) THEN
        IF(TCENTRO.AND.IP.EQ.1) RETURN
      ENDIF
      IPP=1
      IF(TPATH.AND.TPIMD) IPP=MIN(IP,2)
      IF(PARENT) THEN
         WRITE(6,*) 'NOSPINIT| INITIALIZATION OF NOSE VELOCITIES'
      ENDIF
      SEED=135792468D0
      CALL MPRAND(SEED,3,RNR)
      IF(TULTRA) THEN
C..EACH ATOM TYPE HAS A SEPERATE CHAIN
        DO IS=1,NSP
          DO L=1,NCHAIN
            ETAP(IS,L,IP) = 0.0D0
            SIGMA=DSQRT(NOSPT0/QNOSP(IS,L,IP)/FACTEM)
            CALL MPRAND(SEED,3,RNR)
            ALFA1=2.0D0*PI*RNR(1)
            ETAPDOT(IS,L,IP)=SQRT(LOG(XRANF())*(-2.0D0))*
     *                               COS(ALFA1)*SIGMA
          ENDDO
        ENDDO
      ELSEIF(TLOCT) THEN
        DO IS=1,NLOCT
           DO L=1,NCHAIN
             ETAP(IS,L,IP) = 0.0D0
C FIXME TLOCT: CHECK QNOSP
             SIGMA=DSQRT(LOCTT0(IS)/QNOSP(IS,L,IP)/FACTEM)
             CALL MPRAND(SEED,3,RNR)
             ALFA1=2.0D0*PI*RNR(1)
             ETAPDOT(IS,L,IP)=SQRT(LOG(XRANF())*(-2.0D0))*
     *            COS(ALFA1)*SIGMA
          ENDDO
        ENDDO
      ELSEIF(TMNOSE) THEN
C..EACH DEGREE OF FREEDOM HAS A SEPERATE CHAIN
        CALL AZZERO(ETAPM(1,1,IP),3*NAX*NSX*NCHX)
        CALL AZZERO(ETAPMDOT(1,1,IP),3*NAX*NSX*NCHX)
        DO K=1,NTHERM(IPP)
          DO L=1,NCHAIN
            CALL MPRAND(SEED,3,RNR)
            IF (TCAFES) THEN
                ATK=MAPDOF(1,K,IPP)
                ATIA=MAPDOF(2,K,IPP)
                ATIS=MAPDOF(3,K,IPP)
               SIGMA=DSQRT(TEMPWR(ATK,ATIA,ATIS)/QNOSPM(K,L,IP)/FACTEM)
            ELSE
                SIGMA=DSQRT(NOSPT0/QNOSPM(K,L,IP)/FACTEM)
            ENDIF
            ALFA=2.0D0*PI*RNR(1)
            ETAPMDOT(K,L,IP)=SQRT(LOG(XRANF())*(-2.D0))*COS(ALFA)*SIGMA
          ENDDO
        ENDDO
      ELSE 
        DO L=1,NCHAIN
          ETAP1(L,IP) = 0.0D0
          SIGMA=DSQRT(NOSPT0/QNOSPC(L,IP)/FACTEM)
          CALL MPRAND(SEED,3,RNR)
          ALFA1=2.0D0*PI*RNR(1)
          ETAP1DOT(L,IP)=SQRT(LOG(XRANF())*(-2.0D0))*
     *                               COS(ALFA1)*SIGMA
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


