C     ==================================================================
      SUBROUTINE NPT_CPMD(C0,CM,C2,SC0,GAMX,GAMY)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc' 
      INCLUDE 'ener.inc' 
      INCLUDE 'elct.inc' 
      INCLUDE 'tpar.inc' 
      INCLUDE 'pslo.inc' 
      INCLUDE 'ions.inc' 
      INCLUDE 'soft.inc' 
      INCLUDE 'nose.inc' 
      INCLUDE 'norm.inc' 
      INCLUDE 'ropt.inc' 
      INCLUDE 'cppt.inc' 
      INCLUDE 'coor.inc' 
      INCLUDE 'geq0.inc' 
      INCLUDE 'spin.inc' 
      INCLUDE 'irat.inc' 
      INCLUDE 'nlcc.inc' 
      INCLUDE 'strs.inc' 
      INCLUDE 'str2.inc' 
      INCLUDE 'metr.inc' 
      INCLUDE 'cotr.inc' 
      INCLUDE 'prcp.inc'
      INCLUDE 'store.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'shock.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'comvel.inc'
C     Arguments
      COMPLEX*16 C0(NGW,*),CM(NGW,*),C2(NGW,*),SC0(NGW,*)
      REAL*8     GAMX(*),GAMY(*)
C     Variables
      DIMENSION  F(*)
      REAL*8     TAUI(3,NAX,*),TAUR(3,NAX,*),EIGV(*),EIGM(*)
      POINTER    (IP_TAUI,TAUI),(IP_TAUR,TAUR),
     *           (IP_EIGV,EIGV),(IP_EIGM,EIGM)
      COMPLEX*16 PSI(NNR1,NLSD)
      REAL*8     RHOE(NNR1,NLSD),SCR(*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
      CHARACTER  FILEN*100,TAG*30
      LOGICAL    FERROR,TESTSTORE
      INTEGER    IREC(100)
      REAL*8     TIME1,TIME2,TCPU,FF,EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,
     &           EKINP,TEMPP,EKINC,DISA,EKINH,TEMPH,ENOSE,ENOSP,ENOSC,
     &           ECONS,EHAM,EKINH1,EKINH2,VCMIO(4),
     &           TIMEF,DDOT
      EXTERNAL   TIMEF,DDOT
      INTEGER    I,J,NSTATE,
     &           LSCR,IL_RHOE,IL_PSI
      INTEGER    MSGLEN,ITEMP
C     ==--------------------------------------------------------------==
      TIME1 = TIMEF()
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TAUI,3*NAX*NSX,'TAUI')
      CALL MEMORY(IP_TAUR,3*NAX*NSX,'TAUR')
      NACC = 22
      NSTATE=N
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.TRUE.
C     ==--------------------------------------------------------------==
C     06/2008 AK
C     NPT FLEXIBLE CELL DOES NOT WORK WITH VANDERBILT PSEUDOPOTENTIALS.
C     FOR STARTERS THE STRESS TENSOR IS BROKEN.
C     IT WORKS IN QUANTUM ESPRESSO...
      IF(TIVAN) THEN
         CALL STOPGM('NPT_CPMD','NPT MD IS BROKEN FOR VANDERBILT USPPs')
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TIVAN.OR.NONORT) THEN
        CALL MEMORY(IP_EIGV,NSTATE,'EIGV')
        CALL MEMORY(IP_EIGM,NSTATE*NSTATE,'EIGM')
      ENDIF
      IF(THARM.AND.PARENT) THEN
        FF=F(1)
        DO I=1,NSTATE
          IF(FF.NE.F(I)) THEN
            WRITE(6,'(A,A)') ' HARMONIC REFERENCE SYSTEM INTEGRATION',
     *             ' ONLY POSSIBLE WITH EQUAL OCCUPATION NUMBERS'
            CALL STOPGM('NPT_CPMD',' ')
          ENDIF
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     == INITIALIZATION                                               ==
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL GIVE_SCR_NPT_MD(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      NFNOW=1
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
C     PARAMETERS FOR THE NOSE-HOOVER THERMOSTATS
      CALL INITRUN(IREC,C0,CM,SC0,RHOE,PSI,EIGV,SCR,LSCR)
      CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,TAUI(1,1,1),1)
      NCDOF = 1
      IF((TNOSEP.OR.TNOSEE.OR.TNOSEC).AND.PARENT) CALL NOSEPA(1,1)
C     INITIALIZE VELOCITIES
      IF(PARENT) CALL DETDOF(TAU0,TAUR)
      IF(IREC(IREC_VEL).EQ.0.AND..NOT.RGEO) THEN
        ECNSTR = 0.0D0
        ERESTR = 0.0D0
        CALL RINVEL(VELP,CM,NSTATE)
        IF(PARENT) CALL TAUCL(VELP)
        IF(PARENT) CALL RATTLE(TAU0,VELP)
        CALL RVSCAL(VELP)
      ELSE
        IF(PARENT) CALL TAUCL(VELP)
        IF(PARENT) CALL RATTLE(TAU0,VELP)
        IF(TRESCALE) CALL RVSCAL(VELP)
      ENDIF
      IF(QUENCHP) THEN
        CALL AZZERO(VELP,3*NAX*NSX)
      ENDIF
      IF(QUENCHE) CALL AZZERO(CM,2*NGW*NSTATE)
      IF(QUENCHC) CALL AZZERO(HTVEL,9)
C     RESET ACCUMULATORS
      IF(PARENT.AND.IREC(IREC_AC).EQ.0)
     &     CALL RESETAC(TAU0,TAUI,NFI)
C
      IF(QUENCHB) THEN
        CALL QUENBO(C0,C2,SC0,TAUR,RHOE,PSI,SCR,LSCR)
        CALL ZHWWF(2,IREC,C0,CM,NSTATE,EIGV,TAU0,VELP,TAUI,NFI)
        QUENCHB=.FALSE.
      ENDIF
C
C     INITIALIZE FORCES
      IF(TKPNT) THEN
        IF(GEQ0) CALL ZCLEAN_K(C0,NSTATE,NGW)
      ELSE
        IF(GEQ0) CALL ZCLEAN(C0,NSTATE,NGW)
      ENDIF
      CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *             NSTATE,1,.FALSE.,.TRUE.)
      CALL TOTSTR
      CALL FREQS(NSTATE,.FALSE.)
C     Check orthogonality condition for wavefunction velocities
      CALL RORTV(C0,CM,C2,SC0,GAMY,NSTATE,SCR,LSCR)
C     Initialize Barostat
      VOL0 = OMEGA0
      IF(TZFLEX) THEN
       EPS = DLOG(OMEGA/OMEGA0)/3.D0
       VEPS = HTVEL(3,3)
      ELSE IF(TISOT) THEN
       EPS = DLOG(OMEGA/OMEGA0)/3.D0
       VEPS = (HTVEL(1,1)+HTVEL(2,2)+HTVEL(3,3))/3.D0
      ELSE IF(TSHOCK) THEN
       VEPS = HTVEL(1,1)
      ENDIF
C     Initialize thermostats
      IF(PARENT) THEN
        ITEMP=IREC(IREC_NOP1)+IREC(IREC_NOP2)+IREC(IREC_NOP3)
        IF(TNOSEP .AND. ITEMP.EQ.0) CALL NOSPINIT(1)
        IF(TNOSEE .AND. IREC(IREC_NOE ).EQ.0) CALL NOSEINIT(1)
        IF(TNOSEC .AND. IREC(IREC_NOC ).EQ.0) CALL NOSCINIT(1)
        CALL WRGEOF(TAU0,FION)
        FILEN='ENERGIES'
        CALL FILEOPEN(3,FILEN,FO_APP+FO_VERB+FO_MARK,FERROR)

        WRITE(6,'(/,A)') '  CELL PARAMETERS '
        DO I=1,3
          WRITE(6,'(3(1X,F12.8))') (HT(I,J),J=1,3)
        ENDDO
        WRITE(6,'(/,A)') '  CELL VELOCITY '
        DO I=1,3
          WRITE(6,'(3(1X,F12.8))') (HTVEL(I,J),J=1,3)
        ENDDO
        WRITE(6,'(/,A)') '  CELL FORCES '
        DO I=1,3
          WRITE(6,'(3(1X,F12.8))') (HTFOR(I,J),J=1,3)
        ENDDO
      ENDIF
      CALL WRITE_IREC(IREC)
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,F8.2,A)') ' TIME FOR INITIALIZATION',
     *                        TCPU,' SECONDS'
      ENDIF
C     ==================================================================
C     ==          THE BASIC LOOP FOR MOLECULAR DYNAMICS               ==
C     ==                 USING VELOCITY VERLET                        ==
C     ==================================================================
      DO INFI=1,NOMORE
        TIME1=TIMEF()
        NFI=NFI+1
        PRTEIG=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
        IF(.NOT.PARENT) PRTEIG=.FALSE.
        ENGPRI=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
        SUBCOM=TSUBCOM.AND.MOD(NFI-1,NCOMV).EQ.0
C       ANNEALING
        IF(.NOT.TSHOCK) THEN
          CALL ANNEAL(VELP,CM,NSTATE,HTVEL)
          CALL BERENDSEN(VELP,CM,NSTATE,HTVEL,EKINC,EKINH)
C     SUBTRACT CENTER OF MASS VELOCITY
          IF(PARENT.AND.SUBCOM) CALL COMVEL(VELP,VCMIO,.TRUE.)
        ENDIF
C       UPDATE NOSE THERMOSTATS
        CALL NOSEUP(VELP,CM,NSTATE,1)
C       UPDATE VELOCITIES
        IF(PARENT) THEN
          IF(TSHOCK) THEN
C           FOR SHOCKS, APPLY DAMPING TO ION VELOCITIES
            CALL VELUPIDAMP(VELP,1)
C           FOR SHOCKS, APPLY DAMPING TO BAROSTAT VELOCITIES
            CALL VEPSUPDAMP 
C           FOR SHOCKS, UPDATE BAROSTAT AND PARTICLE VELOCITIES
            CALL VEPSUP(VELP)
C           FOR SHOCKS, APPLY DAMPING TO BAROSTAT VELOCITIES
            CALL VEPSUPDAMP 
C           FOR SHOCKS, UPDATE VELOCITIES
            CALL VELUPISHOCK(VELP,FION,1)
          ELSE
C     IONS and CELL
            CALL VELUPI(VELP,FION,1)
            CALL VELUPC(1)
          ENDIF
        ENDIF
        CALL VELUPA(C0,CM,C2,NSTATE,1)
C       UPDATE POSITIONS
        IF(TZFLEX) THEN
C     AK: FIXME
          CALL STOPGM('NPT_CPMD','NO NPT MD FOR Z-FLEXIBLE CELL')
C         CALL POSUPIH_ZSC(TAU0,TAUP,VELP)
        ELSE IF(TISOT) THEN
          CALL POSUPIH_ISO(TAU0,TAUP,VELP)
        ELSE IF(TSHOCK) THEN
          CALL POSUPIHSHOCK(TAU0,TAUP,VELP)
        ELSE
          CALL POSUPIH(TAU0,TAUP,VELP)
        ENDIF
        MSGLEN = 9 * 8
        CALL MY_BCAST(HT,MSGLEN,SOURCE,ALLGRP)
        DO I=1,3
          A1(I) = HT(1,I)
          A2(I) = HT(2,I)
          A3(I) = HT(3,I)
        ENDDO
        CALL IHMAT(HT,HTM1,OMEGA)
        IF(PARENT) THEN
          CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,TAU0(1,1,1),1)
        ENDIF
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAUP,MSGLEN,SOURCE,ALLGRP)
        CALL NEWCELL(SCR,LSCR)
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAUP,MSGLEN,SOURCE,ALLGRP)
        CALL PHFAC(TAUP)
        IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,.TRUE.)
        CALL POSUPA(C0,CM,C2,GAMX,NSTATE,SCR,LSCR)
C       CALCULATE THE FORCES
        CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAUP,FION,EIGV,SCR,LSCR,
     *               NSTATE,1,.FALSE.,.TRUE.)
        CALL TOTSTR
C     ==================================================================
C       Damped Dynamics
        CALL DAMPDYN(VELP,FION,CM,C2,NSTATE,HTVEL,HTFOR)
C     ==================================================================
C       FINAL UPDATE FOR VELOCITIES
        IF(PARENT) THEN
          IF(TSHOCK) THEN
            CALL VELUPISHOCK(VELP,FION,1)
          ELSE
            CALL VELUPI(VELP,FION,1)
          ENDIF
        ENDIF
        CALL VELUPA(C0,CM,C2,NSTATE,1)
        CALL RORTV(C0,CM,C2,SC0,GAMY,NSTATE,SCR,LSCR)
        IF(PARENT) THEN
          CALL GEOFILE(TAUP,VELP,'WRITE')
C       COMPUTE THE IONIC TEMPERATURE TEMPP
          CALL EKINPP(EKINP,VELP)
          TEMPP=EKINP*FACTEM*2.D0/GLIB
C       IONIC TEMPERATURE CONTROL
          CALL RSCVP(TEMP1,TEMP2,TEMPP,VELP)
        ENDIF
C       UPDATE NOSE THERMOSTATS
        IF(TNOSEE.OR.TC) CALL REKINE(CM,NSTATE,EKINC)
        IF(PARENT) THEN
          IF(TSHOCK) THEN
C     FOR SHOCKS, APPLY DAMPING TO BAROSTAT VELOCITIES
            CALL VEPSUPDAMP 
C     FOR SHOCKS, UPDATE BAROSTAT VELOCITIES
            CALL VEPSUP(VELP)
C     FOR SHOCKS, APPLY DAMPING TO BAROSTAT VELOCITIES
            CALL VEPSUPDAMP 
C     FOR SHOCKS, APPLY DAMPING TO ION VELOCITIES
            CALL VELUPIDAMP(VELP,1)
          ELSE
C     IONS and CELL
            CALL VELUPI(VELP,FION,1)
            CALL VELUPC(1)
          ENDIF
        ENDIF 
C THERMOSTAT UPDATE
        CALL NOSEUP(VELP,CM,NSTATE,1)
        IF(TSHOCK) THEN
          HTVEL(1,1) = VEPS
          HTVEL(2,2) = 0.D0
          HTVEL(3,3) = 0.D0
        ELSE
C     SUBTRACT CENTER OF MASS VELOCITY
          IF(PARENT.AND.SUBCOM) CALL COMVEL(VELP,VCMIO,.FALSE.)
          CALL BERENDSEN(VELP,CM,NSTATE,HTVEL,EKINC,EKINH)
C       ANNEALING
          CALL ANNEAL(VELP,CM,NSTATE,HTVEL)
        ENDIF
        IF(PARENT) THEN
          CALL EKINPP(EKINP,VELP)
          TEMPP=EKINP*FACTEM*2.D0/GLIB
        ENDIF
C       RESCALE ELECTRONIC VELOCITIES
        IF(TC) CALL RSCVE(EKIN1,EKIN2,EKINC,EKINW,CM,NSTATE,NGW)
C       MEAN SQUARE DISPLACEMENT OF DIFFERENT IONIC SPECIES
        IF(PARENT) CALL DISPP(TAUP,TAUI,DISA)
C       KINETIC ENERGY OF THE ELECTRONS
        CALL REKINE(CM,NSTATE,EKINC)
C       KINETIC ENERGY OF THE CELL
        EKINH=0.5D0*CMASS*DDOT(9,HTVEL,1,HTVEL,1)
        IF(TSHOCK) EKINH=0.5D0*CMASS*VEPS*VEPS
C       TEMPERATURE OF THE CELL
        TEMPH = 2.D0*EKINH*FACTEM/DBLE(NCDOF)
C       ENERGY OF THE NOSE THERMOSTATS
        IF(PARENT) CALL NOSENG(NFI,VELP,ENOSE,ENOSP,ENOSC,1)
        IF(PARENT) THEN
          IF(.NOT.TSHOCK) THEN
C Conserved quantity for NPT ensembles
            ECONS=EKINP+ETOT+ENOSE+ENOSP+ENOSC+ECNSTR+ERESTR+DRUCK*OMEGA
            EHAM=ECONS+EKINC+EKINH
          ELSE
C Conserved quantity (HUGONIOT) for NPH-SHOCK ensemble
            ESHOCK=-0.5D0*VSHOCK*VSHOCK*(1.0D0-OMEGA/VOL0)
     *             *(1.0D0-OMEGA/VOL0)-PSHOCK*(VOL0-OMEGA)
            ECONS=EKINP+ETOT+ENOSE+ECNSTR+ERESTR+ESHOCK
            EHAM=ECONS+EKINC+EKINH
          ENDIF
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
C         PRINTOUT the evolution of the accumulators every time step
          CALL WRPRINT_PR(EKINC,EKINH,TEMPP,ETOT,ECONS,EHAM,
     *                    DISA,TAUP,FION,TCPU,NFI,INFI)
C         UPDATE ACCUMULATORS
          CALL PACCB(EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU,TEMPH,
     *               OMEGA,ENOSE,ENOSP,NFI,1)
C         Store ionic coordinates and velocities for statistics
          MOVIE=MOUT .AND. MOD(NFI-1,IMOVIE).EQ.0
          RPRINT=ROUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TXYZ=XTOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TDCD=DCOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          CALL PRINTP(TAUR,TAUP,VELP)
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(INFI.EQ.NOMORE) THEN
          EXSOFT=.TRUE.
          EXNOMORE=.TRUE.
        ENDIF
C periodic output of density/wavefunction etc.
        IF(RHOOUT.AND.(NRHOOUT.GT.0)) THEN
          IF (MOD(NFI-1,NRHOOUT).EQ.0) THEN
            CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPNT)
          ENDIF
        ENDIF
        IF(TESTSTORE(NFI).OR.EXSOFT) 
     *    CALL ZHWWF(2,IREC,C0,CM,NSTATE,EIGV,TAUP,VELP,TAUI,NFI)
C     temperature ramping
        CALL TEMPRAMP(TEMP1,TEMP2)
C       STOP THE RUN IF THE USER HAS SET THE SIGNAL 30
        IF(EXSOFT) GOTO 100
C       UPDATE IONIC POSITIONS
        CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,TAU0(1,1,1),1)
C     ==================================================================
C     ==     END OF MAIN LOOP                                         ==
C     ==================================================================
      ENDDO
  100 CONTINUE
      IF(RHOOUT.AND.(NRHOOUT.LE.0))
     &    CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPNT)
C     Print accumulators.
      IF(PARENT) CALL PACCB(EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU,TEMPH,
     *                      OMEGA,ENOSE,ENOSP,NFI,2)
      CALL PROJA(C0,C2,SC0,SCR,LSCR,NSTATE,IPROJ)
      CALL CSIZE(C2,NSTATE,GEMAX,CNORM)
      IF(PARENT) CALL GSIZE(FION,GNMAX,GNORM)
      IF(PARENT) CALL FINALP(TAU0,FION,VELP,EIGV)
      IF(TIVAN.OR.NONORT) THEN
        CALL FREEM(IP_EIGV)
        CALL FREEM(IP_EIGM)
      ENDIF
      CALL FREEM(IP_TAUP)
      CALL FREEM(IP_FION)
      CALL FREEM(IP_VELP)
      CALL FREEM(IP_TAUI)
      CALL FREEM(IP_TAUR)
      IF(PARENT) CALL FILECLOSE(3)
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_NPT_MD(LNPT_MD,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !nlcc.inc TRANE QUENCHB
      INCLUDE 'elct.inc'        !N number of states
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'store.inc'       !RHOOUT
      INCLUDE 'pslo.inc'        !TIVAN
C     Arguments
      INTEGER   LNPT_MD
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LCOPOT,LORTHO,LQUENBO,LDEORT,LFORCEDR,
     &          LRORTV,LPOSUPA,LRHOPRI,LNEWCELL,LINITRUN
C     ==--------------------------------------------------------------==
      NSTATE=N
      LCOPOT=0
      LORTHO=0
      LQUENBO=0
      LDEORT=0
      LRHOPRI=0
      LINITRUN=0
      CALL GIVE_SCR_INITRUN(LINITRUN,TAG)
      IF(TINLC) CALL GIVE_SCR_COPOT(LCOPOT,TAG)
      IF(TRANE) CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      IF(QUENCHB) CALL GIVE_SCR_QUENBO(LQUENBO,TAG)
      IF(TIVAN) CALL GIVE_SCR_DEORT(LDEORT,TAG,NSTATE)
      CALL GIVE_SCR_FORCEDR(LFORCEDR,TAG,NSTATE,.FALSE.,.TRUE.)
      CALL GIVE_SCR_RORTV(LRORTV,TAG,NSTATE)
      CALL GIVE_SCR_NEWCELL(LNEWCELL,TAG)
      CALL GIVE_SCR_POSUPA(LPOSUPA,TAG,NSTATE)
      IF(RHOOUT) CALL GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
      LNPT_MD=MAX(LCOPOT,LORTHO,LQUENBO,LDEORT,LFORCEDR,
     &            LRORTV,LPOSUPA,LRHOPRI,LINITRUN,
     &            LNEWCELL)
      LNPT_MD=LNPT_MD+10000
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
C     ==================================================================
      SUBROUTINE NPT_BOMD(C0,CM,C2,SC0,VPP,GAMX,GAMY)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc' 
      INCLUDE 'ener.inc' 
      INCLUDE 'elct.inc' 
      INCLUDE 'tpar.inc' 
      INCLUDE 'pslo.inc' 
      INCLUDE 'ions.inc' 
      INCLUDE 'soft.inc' 
      INCLUDE 'nose.inc' 
      INCLUDE 'norm.inc' 
      INCLUDE 'ropt.inc' 
      INCLUDE 'cppt.inc' 
      INCLUDE 'coor.inc' 
      INCLUDE 'geq0.inc' 
      INCLUDE 'spin.inc' 
      INCLUDE 'irat.inc' 
      INCLUDE 'nlcc.inc' 
      INCLUDE 'strs.inc' 
      INCLUDE 'str2.inc' 
      INCLUDE 'metr.inc' 
      INCLUDE 'cotr.inc' 
      INCLUDE 'andr.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'store.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'comvel.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'shock.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'mm_extrap.inc'

C     Arguments
      COMPLEX*16 C0(NGW,*),CM(NGW,*),C2(NGW,*),SC0(NGW,*),VPP(*)
      REAL*8     GAMX(*),GAMY(*)
C     Variables
      DIMENSION  F(*),RIN0(*)
      REAL*8     TAUI(3,NAX,*),TAUR(3,NAX,*),EIGV(*),EIGM(*)
      POINTER    (IP_TAUI,TAUI),(IP_TAUR,TAUR),
     *           (IP_EIGV,EIGV),(IP_EIGM,EIGM)
      COMPLEX*16 PSI(NNR1,NLSD)
      REAL*8     RHOE(NNR1,NLSD),SCR(*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
      CHARACTER  FILEN*100,TAG*30
      LOGICAL    FERROR,TESTSTORE
      INTEGER    IREC(100)
      REAL*8     TIME1,TIME2,TCPU,FF,EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,
     &           EKINP,TEMPP,EKINC,DISA,EKINH,TEMPH,ENOSE,ENOSP,ENOSC,
     &           ECONS,EHAM,EKINH1,EKINH2,VCMIO(4),
     &           TIMEF,DDOT
      EXTERNAL   TIMEF,DDOT
      INTEGER    I,J,NX,IFCALC,NNX,NSTATE,
     &           LSCR,IL_RHOE,IL_PSI
      INTEGER    MSGLEN,ITEMP
      INTEGER    LOOPNFI,NFIMIN,NFIMAX
      REAL*8     RM1(*),RINP(*)
      POINTER    (IP_RM1,RM1),(IP_RINP,RINP)
C     ==--------------------------------------------------------------==
      TIME1 = TIMEF()
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TAUI,3*NAX*NSX,'TAUI')
      CALL MEMORY(IP_TAUR,3*NAX*NSX,'TAUR')
C     ==--------------------------------------------------------------==
      NNX=NNR1*NLSD
      CALL MEMORY(IP_RIN0,NNX,'RIN0')
      CALL MEMORY(IP_ROUT0,NNX,'ROUT0')
      CALL MEMORY(IP_RMIX,NNX,'RMIX')
      CALL MEMORY(IP_RM1,NNX,'RM1')
      CALL MEMORY(IP_RINP,NNX,'RINP')
      IP_RHOO=IP_RIN0
      CALL AZZERO(RIN0,NNX)
      CALL AZZERO(ROUT0,NNX)
      CALL AZZERO(RMIX,NNX)
C     ==--------------------------------------------------------------==
      NSTATE=N
      NACC = 22
      NFI  = 0
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.TRUE.
C     ==--------------------------------------------------------------==
C     06/2008 AK
C     NPT FLEXIBLE CELL DOES NOT WORK WITH VANDERBILT PSEUDOPOTENTIALS.
C     FOR STARTERS THE STRESS TENSOR IS BROKEN.
C     IT WORKS IN QUANTUM ESPRESSO...
      IF(TIVAN) THEN
         CALL STOPGM('NPT_BOMD','NPT MD IS BROKEN FOR VANDERBILT USPPs')
      ENDIF
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_EIGV,NLSD*NSTATE,'EIGV')
C     ==--------------------------------------------------------------==
C     Extrapolation
      IF(TEXTRAP) THEN
        CALL MEMORY(IP_COLD,2*NGWK*NSTATE*NKPTS*MEXTRA,'COLD')
      ENDIF
C     ==--------------------------------------------------------------==
C     == INITIALIZATION                                               ==
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL GIVE_SCR_NPT_MD(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      NFNOW=1
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
C
      CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
      CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,TAUI(1,1,1),1)
      NCDOF = 1
      IF((TNOSEP.OR.TNOSEE.OR.TNOSEC).AND.PARENT) CALL NOSEPA(1,1)
C     INITIALIZE VELOCITIES
      IF(PARENT) CALL DETDOF(TAU0,TAUR)
      IF(IREC(IREC_VEL).EQ.0.AND..NOT.RGEO) THEN
        ECNSTR = 0.0D0
        ERESTR = 0.0D0
        CALL RINVEL(VELP,CM,NSTATE)
        IF(PARENT) CALL TAUCL(VELP)
        IF(PARENT) CALL RATTLE(TAU0,VELP)
        CALL RVSCAL(VELP)
      ELSE
        IF(PARENT) CALL TAUCL(VELP)
        IF(PARENT) CALL RATTLE(TAU0,VELP)
        IF(TRESCALE) CALL RVSCAL(VELP)
      ENDIF
      IF(QUENCHP) CALL AZZERO(VELP,3*NAX*NSX)
      IF(QUENCHC) CALL AZZERO(HTVEL,9)
      IF(TREVERS) THEN
C       invert ionic velocities (useful for path sampling)
        CALL DSCAL(3*NAX*NSX,-1.D0,VELP,1)
      ENDIF
C     COMPUTE THE IONIC TEMPERATURE TEMPP
      IF(PARENT) THEN
        CALL EKINPP(EKINP,VELP)
        TEMPP=EKINP*FACTEM*2.D0/GLIB
      ENDIF
C     RESET ACCUMULATORS
      IF(PARENT.AND.IREC(IREC_AC).EQ.0)
     &    CALL RESETAC(TAU0,TAUI,NFI)
C     INITIALIZE FORCES
      IF(TDIAG) THEN
        IF(TLANC) NX=1
        IF(TDAVI) NX=NGWK*NDAVV*NKPNT+1
        IF(DIIS)  NX=((NGWK*NSTATE+8)*MDIIS*NKPNT)/4
      ELSEIF(TSDE) THEN
        NX=1
      ELSEIF(DIIS) THEN
        NX=(NGWK*NSTATE+8)*MDIIS*NKPNT/2+4
      ELSEIF(PCG) THEN
        NX=1
      ENDIF
      IF(PARENT) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T25,A,T64,"==")')
     &       'FORCES INITIALIZATION'
        WRITE(6,'(1X,64("="))')
      ENDIF
      IFCALC=0
      CALL FORCES_DIAG(NSTATE,C0,C2,CM,SC0,CM(NX,1),VPP,EIGV,
     &                 RHOE,PSI,SCR,LSCR,
     &                 TAU0,VELP,TAUI,FION,IFCALC,
     &                 IREC,.TRUE.,.TRUE.)
      CALL TOTSTR
C     Initialize Barostat
      VOL0 = OMEGA0
      IF(TZFLEX) THEN
       EPS = DLOG(OMEGA/OMEGA0)/3.D0
       VEPS = HTVEL(3,3)
      ELSE IF(TISOT) THEN
       EPS = DLOG(OMEGA/OMEGA0)/3.D0
       VEPS = (HTVEL(1,1)+HTVEL(2,2)+HTVEL(3,3))/3.D0
      ELSE IF(TSHOCK) THEN
       VOL0 = OMEGA0
      ENDIF
C     Initialize thermostats
      IF(PARENT) THEN
        ITEMP=IREC(IREC_NOP1)+IREC(IREC_NOP2)+IREC(IREC_NOP3)
        IF(TNOSEP .AND. ITEMP.EQ.0) CALL NOSPINIT(1)
        IF(TNOSEC .AND. IREC(IREC_NOC ).EQ.0) CALL NOSCINIT(1)
        CALL WRGEOF(TAU0,FION)
        FILEN='ENERGIES'
        CALL FILEOPEN(3,FILEN,FO_APP+FO_VERB,FERROR)
      ENDIF
      CALL WRITE_IREC(IREC)
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,F8.2,A)') ' TIME FOR INITIALIZATION',
     *                        TCPU,' SECONDS'
        WRITE(6,'(/,A)') '  CELL PARAMETERS '
        DO I=1,3
          WRITE(6,'(3(1X,F12.8))') (HT(I,J),J=1,3)
        ENDDO
        WRITE(6,'(/,A)') '  CELL VELOCITY '
        DO I=1,3
          WRITE(6,'(3(1X,F12.8))') (HTVEL(I,J),J=1,3)
        ENDDO
        WRITE(6,'(/,A)') '  CELL FORCES '
        DO I=1,3
          WRITE(6,'(3(1X,F12.8))') (HTFOR(I,J),J=1,3)
        ENDDO
      ENDIF
C     ==================================================================
C     ==          THE BASIC LOOP FOR MOLECULAR DYNAMICS               ==
C     ==                 USING VELOCITY VERLET                        ==
C     ==================================================================
      INFI=0
      NFIMIN=NFI+1
      NFIMAX=NFI+NOMORE
      DO LOOPNFI=NFIMIN,NFIMAX
        TIME1=TIMEF()
        INFI=INFI+1
        NFI=LOOPNFI
        SUBCOM=TSUBCOM.AND.MOD(NFI-1,NCOMV).EQ.0
        PRTEIG=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
        IF(.NOT.PARENT) PRTEIG=.FALSE.
        ENGPRI=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
C       ANNEALING
        IF(.NOT.TSHOCK) THEN
          CALL ANNEAL(VELP,CM,NSTATE,HTVEL)
          CALL BERENDSEN(VELP,CM,NSTATE,HTVEL,EKINC,EKINH)
C     SUBTRACT CENTER OF MASS VELOCITY
          IF(PARENT.AND.SUBCOM) CALL COMVEL(VELP,VCMIO,.TRUE.)
        ENDIF
C       UPDATE NOSE THERMOSTATS
        CALL NOSEUP(VELP,CM,NSTATE,1)
        IF(PARENT) THEN
          IF(TSHOCK) THEN
C     FOR SHOCKS, APPLY DAMPING TO ION VELOCITIES
            CALL VELUPIDAMP(VELP,1)
C     FOR SHOCKS, APPLY DAMPING TO BAROSTAT VELOCITIES
            CALL VEPSUPDAMP 
C     FOR SHOCKS, UPDATE BAROSTAT AND PARTICLE VELOCITIES
            CALL VEPSUP(VELP)
C     FOR SHOCKS, APPLY DAMPING TO BAROSTAT VELOCITIES
            CALL VEPSUPDAMP 
C     FOR SHOCKS, UPDATE VELOCITIES
            CALL VELUPISHOCK(VELP,FION,1)
          ELSE
C     IONS and CELL
            CALL VELUPI(VELP,FION,1)
            CALL VELUPC(1)
          ENDIF
        ENDIF
C       UPDATE POSITIONS
        IF(TZFLEX) THEN
C     AK: FIXME
          CALL STOPGM('NPT_BOMD','NO NPT MD FOR Z-FLEXIBLE CELL')
C         CALL POSUPIH_ZSC(TAU0,TAUP,VELP)
C     UPDATE CELL
        ELSE IF(TISOT) THEN
          CALL POSUPIH_ISO(TAU0,TAUP,VELP)
        ELSE IF(TSHOCK) THEN
          CALL POSUPIHSHOCK(TAU0,TAUP,VELP)
        ELSE
          CALL POSUPIH(TAU0,TAUP,VELP)
        ENDIF
        MSGLEN = 9 * 8
        CALL MY_BCAST(HT,MSGLEN,SOURCE,ALLGRP)
        DO I=1,3
          A1(I) = HT(1,I)
          A2(I) = HT(2,I)
          A3(I) = HT(3,I)
        ENDDO
        CALL IHMAT(HT,HTM1,OMEGA)
        IF(PARENT) THEN
          CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,TAU0(1,1,1),1)
        ENDIF
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAUP,MSGLEN,SOURCE,ALLGRP)
        CALL NEWCELL(SCR,LSCR)
        CALL PHFAC(TAUP)
        IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,.TRUE.)
C       CALCULATE THE FORCES
        IF(TEXTRAP) THEN
C         Extrapolate wavefunctions
          CALL EXTRAPWF(INFI,C0,SCR,COLD,NSTATE,MEXTRA)
        ENDIF
        IFCALC=0
        CALL FORCES_DIAG(NSTATE,C0,C2,CM,SC0,CM(NX,1),VPP,EIGV,
     &                   RHOE,PSI,SCR,LSCR,
     &                   TAUP,VELP,TAUI,FION,IFCALC,
     &                   IREC,.TRUE.,.FALSE.)
        CALL TOTSTR
C     ==================================================================
C       Damped Dynamics
        CALL DAMPDYN(VELP,FION,CM,C2,NSTATE,HTVEL,HTFOR)
C     ==================================================================
C       FINAL UPDATE FOR VELOCITIES
        IF(PARENT) THEN
          IF(TSHOCK) THEN
            CALL VELUPISHOCK(VELP,FION,1)
          ELSE
            CALL VELUPI(VELP,FION,1)
          ENDIF
          CALL GEOFILE(TAUP,VELP,'WRITE')
C     COMPUTE THE IONIC TEMPERATURE TEMPP
          CALL EKINPP(EKINP,VELP)
          TEMPP=EKINP*FACTEM*2.D0/GLIB
C     IONIC TEMPERATURE CONTROL
          CALL RSCVP(TEMP1,TEMP2,TEMPP,VELP)        
          IF(TSHOCK) THEN
C     FOR SHOCKS, APPLY DAMPING TO BAROSTAT VELOCITIES
            CALL VEPSUPDAMP 
C     FOR SHOCKS, UPDATE BAROSTAT VELOCITIES
            CALL VEPSUP(VELP)
C     FOR SHOCKS, APPLY DAMPING TO BAROSTAT VELOCITIES
            CALL VEPSUPDAMP 
C     FOR SHOCKS, APPLY DAMPING TO ION VELOCITIES
            CALL VELUPIDAMP(VELP,1)
          ELSE
C     IONS and CELL
            CALL VELUPI(VELP,FION,1)
            CALL VELUPC(1)
          ENDIF
        ENDIF 
C THERMOSTAT UPDATE
        CALL NOSEUP(VELP,CM,NSTATE,1)
        IF(TSHOCK) THEN
          HTVEL(1,1) = VEPS
          HTVEL(2,2) = 0.D0
          HTVEL(3,3) = 0.D0
        ELSE
C     SUBTRACT CENTER OF MASS VELOCITY
          IF(PARENT.AND.SUBCOM) CALL COMVEL(VELP,VCMIO,.FALSE.)
          CALL BERENDSEN(VELP,CM,NSTATE,HTVEL,0.0D0,EKINH)
C       ANNEALING
          CALL ANNEAL(VELP,CM,NSTATE,HTVEL)
        ENDIF
        IF(PARENT) THEN
          CALL EKINPP(EKINP,VELP)
          TEMPP=EKINP*FACTEM*2.D0/GLIB
        ENDIF
C       MEAN SQUARE DISPLACEMENT OF DIFFERENT IONIC SPECIES
        IF(PARENT) CALL DISPP(TAUP,TAUI,DISA)
C       KINETIC ENERGY OF THE CELL
        EKINH=0.5D0*CMASS*DDOT(9,HTVEL,1,HTVEL,1)
        IF(TSHOCK) EKINH=0.5D0*CMASS*VEPS*VEPS
C       TEMPERATURE OF THE CELL
        TEMPH = 2.D0*EKINH*FACTEM/DBLE(NCDOF)
C       ENERGY OF THE NOSE THERMOSTATS
        IF(PARENT) CALL NOSENG(NFI,VELP,ENOSE,ENOSP,ENOSC,1)
        IF(PARENT) THEN
          IF(TSHOCK) THEN
C Conserved quantity (HUGONIOT) for NPH-SHOCK ensemble
            ESHOCK=-0.5D0*VSHOCK*VSHOCK*(1.0D0-OMEGA/VOL0)
     *          *(1.0D0-OMEGA/VOL0)-PSHOCK*(VOL0-OMEGA)
            ECONS=EKINP+ETOT+ECNSTR+ERESTR+ESHOCK
          ELSE
            EHAM=ECONS+EKINH
C Conserved quantity for regular NPT ensembles
            ECONS=EKINP+ETOT+ENOSC+ENOSP+ECNSTR+ERESTR+DRUCK*OMEGA
            EHAM=ECONS+EKINH
          ENDIF
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
C         PRINTOUT the evolution of the accumulators every time step
          CALL WRPRINT_PR(EKINC,EKINH,TEMPP,ETOT,ECONS,EHAM,
     *                    DISA,TAUP,FION,TCPU,NFI,INFI)
C         UPDATE ACCUMULATORS
          CALL PACCB(EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU,TEMPH,
     *               OMEGA,0.D0,ENOSP,NFI,1)
C         Store ionic coordinates and velocities for statistics
          MOVIE=MOUT .AND. MOD(NFI-1,IMOVIE).EQ.0
          RPRINT=ROUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TXYZ=XTOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TDCD=DCOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          CALL PRINTP(TAUR,TAUP,VELP)
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(NFI.EQ.NFIMAX) THEN
          EXSOFT=.TRUE.
          EXNOMORE=.TRUE.
        ENDIF
C periodic output of density/wavefunction etc.
        IF(RHOOUT.AND.(NRHOOUT.GT.0)) THEN
          IF (MOD(NFI-1,NRHOOUT).EQ.0) THEN
            CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPNT)
          ENDIF
        ENDIF
        IF(TESTSTORE(NFI).OR.EXSOFT) 
     *    CALL ZHWWF(2,IREC,C0,CM,NSTATE,EIGV,TAUP,VELP,TAUI,NFI)
C     temperature ramping
        CALL TEMPRAMP(TEMP1,TEMP2)
C       STOP THE RUN IF THE USER HAS SET THE SIGNAL 30
        IF(EXSOFT) GOTO 100
C       UPDATE IONIC POSITIONS
        CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,TAU0(1,1,1),1)
C       UPDATE DENSITY
        IF(.NOT.BSYMM) THEN
          CALL EXTRAP(NNX,ALXMIX,RM1,RIN0,RINP)
          CALL DCOPY(NNX,RIN0(1),1,RM1(1),1)
          CALL DCOPY(NNX,RINP(1),1,RIN0(1),1)
        ENDIF
C     ==================================================================
C     ==     END OF MAIN LOOP                                         ==
C     ==================================================================
      ENDDO
  100 CONTINUE
      IF(RHOOUT.AND.(NRHOOUT.LE.0))
     &    CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPNT)
C     Print accumulators.
      IF(PARENT) CALL PACCB(EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU,TEMPH,
     *                      OMEGA,ENOSE,ENOSP,NFI,2)
      CALL PROJA(C0,C2,SC0,SCR,LSCR,NSTATE,IPROJ)
      CALL CSIZE(C2,NSTATE,GEMAX,CNORM)
      IF(PARENT) CALL GSIZE(FION,GNMAX,GNORM)
      IF(PARENT) CALL FINALP(TAU0,FION,VELP,EIGV)
      CALL FREEM(IP_TAUP)
      CALL FREEM(IP_FION)
      CALL FREEM(IP_VELP)
      CALL FREEM(IP_TAUI)
      CALL FREEM(IP_TAUR)
      IF(PARENT) CALL FILECLOSE(3)
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
      CALL FREEM(IP_EIGV)
      IF(TEXTRAP) CALL FREEM(IP_COLD)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
