C=======================================================================
      SUBROUTINE NUCLEAR_P(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &     eirop,eivps,z11,nstate)
C=======================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cell.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'epot.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'dipo.inc'
      INCLUDE 'lodp.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'rswf.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'symm.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'gvec.inc'  
      INCLUDE 'metr.inc'
      INCLUDE 'store.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'atom.inc'
      INCLUDE 'mm_input.inc'
c     arguments
      INTEGER    nstate,lscr
      COMPLEX*16 c0(ngw,*),c1(ngw,*),psi(*),eirop(nhg)
      COMPLEX*16 eivps(*),eirop1(nhg),v1_loc(nhg)
      REAL*8     rhoe(*),drhoe(*),scr(*),z11(nstate,*)
c     variables for updwf
      REAL*8     sc0(*),vpp(*),eigv(*),cr,cscr
      COMPLEX*16 pme(ngwk,*),gde(ngwk,*)
      POINTER    (ip_pme,pme),(ip_gde,gde),(ip_sc0,sc0),(ip_vpp,vpp)
      POINTER    (ip_eigv,eigv)
c     variables
      LOGICAL    vol
      INTEGER    i,i1,i2,i3,iii,iat
      INTEGER    isp,spec,step ! species, species, optimization step
      REAL*8     crit_tmp,tp,tp1,dist
      REAL*8     rho_ref(nnr1),rho_tmp(nnr1) ! reference, temporary rho
      POINTER    (ip_rho_ref,rho_ref),(ip_rho_tmp,rho_tmp) 
      COMPLEX*16 vtemp(nhg)    ! for densities
      POINTER    (ip_vtemp,vtemp)
      CHARACTER*20 filename
      LOGICAL    status
C     ==--------------------------------------------------------------==
      call MEMORY(ip_pme,(ngwk*nstate+8)*mdiis,'pme')
      call MEMORY(ip_gde,((ngwk*nstate+8)*mdiis)/4,'gde')
      call MEMORY(ip_eigv,(N*NKPTS),'eigv')
      call MEMORY(ip_vpp,ngwk,'vpp')
      call MEMORY(ip_sc0,ngwk*nstate,'sc0')
      call MEMORY(ip_vtemp,2*nhg,'vtemp')
      call MEMORY(ip_rho_ref,nnr1,'rho_ref')
      call MEMORY(ip_rho_tmp,nnr1,'rho_tmp')
C     ==--------------------------------------------------------------==

      IF(parent)THEN
       WRITE(6,'(/,1X,16("OACP"))')
       WRITE(6,'(1X,"OACP",56X,"OACP")')
       WRITE(6,'(" OACP",5X,A,11X,"OACP")')
     &          'OPTIMIZATION of ATOM CENTERED POTENTIALS'
       WRITE(6,'(" OACP",7X,A,17X,"OACP")')
     &          'J. Chem. Phys. 122, 14113 (2005)'
       WRITE(6,'(1X,"OACP",56X,"OACP")')
       IF (TDUMMYATOM_REF)
     &     WRITE(6,'(" OACP",5X,A,19X,"OACP")')
     &          'Calculation of reference density'
       IF (TDUMMYATOM)
     &     WRITE(6,'(" OACP",5X,A,27X,"OACP")')
     &          'Density Optimization Run'
       IF (TOACP4F)
     &     WRITE(6,'(" OACP",5X,A,29X,"OACP")')
     &          'Force Optimization Run'
       WRITE(6,'(1X,"OACP",56X,"OACP")')
       WRITE(6,'(1X,16("OACP"),/)')
      ENDIF

      crit_tmp = 100.0D0 ! temporary convergence criterium
      step=0

C     ==--------------------------------------------------------------==
      IF (TDUMMYATOM_REF) 
     & call DUMMY_REFCALC(c0,psi,scr,lscr,nstate,rhoe)
C     ==--------------------------------------------------------------==
      IF (TDUMMYATOM_TEC) THEN
C     change to QMMM-dimensions
       call mm_dim('MM',status)
       RPRINT = .true.
C     write out TRAJECTORY
       IF(parent) CALL PRINTP(TAU0,TAU0,TAU0)
C     change back to QM-dimensions
       call mm_dim('QM',status)
      ENDIF
C     ==--------------------------------------------------------------==
      IF (TOACP4F) THEN

       CALL OACP4FORCES(c0,c1,sc0,pme,gde,vpp,eigv,
     &            rhoe,psi,scr,lscr,nstate)

C      converged
       IF(PARENT)THEN
        write(6,'(/,1X,16("OACP"))')
        write(6,'(" OACP",5X,A,11X,"OACP")')
     &          'OPTIMIZATION of ATOM CENTERED POTENTIALS'
        write(6,*) 'OACP    - is converged'
        write(6,'(1X,16("OACP"),/)')
       ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF (TDUMMYATOM) THEN
        step = 1

C     read in reference density into rho_ref 
        CALL DENSRD(vtemp,'rhoofr_ref.dat')
        CALL FFTTOR(vtemp,rho_ref,scr,nhg,.true.)

C     get the electrondensity from c0 in rho_tmp
        CALL RHOOFR(c0,rho_tmp,psi,scr,lscr,nstate)

C     compute the penalty value by integration over volume, 
*     tP = \int dr^3 |rho_ref - rho_tmp|^2
        CALL DENSITYPENALTY(rho_ref,rho_tmp,tP1,.true.)
        CALL DENSITYPENALTY(rho_ref,rho_tmp,tP,.false.)
        IF(parent) THEN
          WRITE(6,*)
          WRITE(6,*) 'OACP density penalty for reference vol. :',tP1
          WRITE(6,*) 'OACP density penalty for full vol.      :',tP
        ENDIF

C     loop to minimize density penalty tP
        DO WHILE ((dumcrit.lt.crit_tmp).and..not.EXSOFT)
          step=step+1

C     compute all penalty derivatives, change all parameters 
C     accordingly, optimize new wavefunction
          CALL DUMMY_OPTCALC(c0,c1,psi,scr,lscr,nstate,rhoe,drhoe,
     &        eirop,eirop1,eivps,z11,rho_ref,rho_tmp,vtemp,crit_tmp,
     &        pme,gde,sc0,vpp,eigv)

C     print out old penalty
          IF(PARENT) THEN
            WRITE(6,'(/,1X,16("OACP"))')
            WRITE(6,*)'OAPC intermediate results for step:',step
            WRITE(6,*)'OACP temporary convergence criterium:',crit_tmp
            WRITE(6,*)'OACP old density penalty for full vol.     :',tP
            WRITE(6,*)'OACP new density penalty for reference vol.:',tP1
          ENDIF

C     get the new electrondensity from c0 into rho_tmp
          CALL RHOOFR(c0,rho_tmp,psi,scr,lscr,nstate)

C     compute the penalty value by integration over volume, 
*     tP = \int dr^3 |rho_ref - rho_tmp|^2
          CALL DENSITYPENALTY(rho_ref,rho_tmp,tP1,.true.)
          CALL DENSITYPENALTY(rho_ref,rho_tmp,tP,.false.)
          IF(parent) THEN
            WRITE(6,*)'OACP new density penalty for full vol.     :',tP
            WRITE(6,*)'OACP new density penalty for reference vol.:',tP1
            WRITE(6,'(1X,16("OACP"),/)')
          ENDIF

          IF(step.ge.NOMORE) EXSOFT=.TRUE.
          IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
          
        END DO                  ! convergence loop

C      converged
        IF(PARENT)THEN
          IF(EXSOFT) THEN
            write(6,'(/,1X,16("OACP"))')
            write(6,'(" OACP",5X,A,11X,"OACP")')
     &          'OPTIMIZATION of ATOM CENTERED POTENTIALS'
            write(6,*) 'OACP   WARNING!WARNING!WARNING!WARNING!WARNING!'
            write(6,*) 'OACP    - is NOT converged'
            write(6,*) 'OACP   WARNING!WARNING!WARNING!WARNING!WARNING!'
            write(6,'(1X,16("OACP"),/)')
          ELSE
            write(6,'(/,1X,16("OACP"))')
            write(6,'(" OACP",5X,A,11X,"OACP")')
     &          'OPTIMIZATION of ATOM CENTERED POTENTIALS'
            write(6,*) 'OACP    - is converged'
            write(6,'(1X,16("OACP"),/)')
          ENDIF
        ENDIF
      ENDIF                     ! that TDUMMYATOM

C     ==--------------------------------------------------------------==
      call FREEM(ip_eigv)
      call FREEM(ip_vpp)
      call FREEM(ip_sc0)
      call FREEM(ip_pme)
      call FREEM(ip_gde)
C     ==--------------------------------------------------------------==
      call FREEM(ip_rho_ref)
      call FREEM(ip_rho_tmp)
      call FREEM(ip_vtemp)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE OACP4FORCES(c0,c1,sc0,pme,gde,vpp,eigv,
     &            rhoe,psi,scr,lscr,nstate)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'coor.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'sgpp.inc'
c     arguments
      INTEGER    nstate,lscr
      COMPLEX*16 c0(ngw,nstate),c1(ngw,nstate),psi(*)
c     variables for updwf
      REAL*8     sc0(*),vpp(*),eigv(*),scr(*),rhoe(*)
      COMPLEX*16 pme(ngwk,*),gde(ngwk,*)
c     variables
      INTEGER    isp,iat,i,k,sig
      REAL*8     tP(2,tdumnum),tPold(2,tdumnum),initd,delta_p(2,tdumnum)
      REAL*8     deriv(2,tdumnum),parm(2,tdumnum),parmold(2,tdumnum)
      REAL*8     crittie
      CHARACTER*20 ecpname
      CHARACTER*2  numb
C     ==--------------------------------------------------------------==
C     Initializiation
      initd = 0.01D0
      k  = 1
      call RWFOPT_NUC(c0,c1,sc0,pme,gde,vpp,eigv,nstate,scr,psi,rhoe)
      crittie = 0.0D0
      DO isp = 2,tdumnum
       parm(1,isp)=rcnl(ANG_MOM,isp)
       parm(2,isp)=hlsg(1,1,ANG_MOM,isp) 
      DO sig = 1,2
       call FORCEPENALTY(tP(sig,isp))
       IF(tP(sig,isp).gt.crittie) crittie = tP(sig,isp)
      ENDDO
      ENDDO

      DO WHILE (DUMCRIT.lt.crittie)
       crittie = 0.0D0
       DO isp = 1,tdumnum
        DO sig = 1,2

C     get finite difference derivative
         IF(k.eq.1) THEN
          deriv(sig,isp) = initd
         ELSE
          deriv(sig,isp) = 
     &     (tPold(sig,isp)-tP(sig,isp))/(parmold(sig,isp)-parm(sig,isp))
         ENDIF
         tPold(sig,isp) = tP(sig,isp)
         parmold(sig,isp) = parm(sig,isp)

C     change parameters
         IF(parent)THEN
          IF(sig.eq.1)THEN
           call STEEPESTDESCENT(rcnl(ANG_MOM,isp),
     &          dumstep4,deriv(sig,isp))
           parm(sig,isp) = rcnl(ANG_MOM,isp)
          ELSEIF(sig.eq.2) THEN
         call STEEPESTDESCENT(hlsg(1,1,ANG_MOM,isp),
     &        dumstep5,deriv(sig,isp))
           parm(sig,isp) = hlsg(1,1,ANG_MOM,isp)
          ENDIF
         write (numb,'(I2.2)') isp
         ecpname = 'DUMMY_'//numb
         call write_pp(isp,ecpname)
         write(6,*) ' OACP psedopotential written to: ',ecpname
         call RECPNEW(isp,ecpname)
          write(6,'(/,1X,16("OACP"))')
          write(6,'(" OACP",16X,A,18X,"OACP")') '    new parameters    '
          print*,'param',isp,sig,parm(sig,isp)
          write(6,'(1X,16("OACP")/)')
         ENDIF
         call RINFORCE_NUC(tdumnum)
         call RWFOPT_NUC(c0,c1,sc0,pme,gde,vpp,eigv,nstate,scr,psi,rhoe)
         call FORCEPENALTY(tP(sig,isp))
         IF(tP(sig,isp).gt.crittie) crittie = tP(sig,isp)
         IF(parent)THEN
          write(6,'(/,1X,16("OACP"))')
          write(6,'(" OACP",16X,A,18X,"OACP")') '  FORCE OPTIMIZATION  '
          IF(k.eq.1) write(6,*) k,'st OACP-results for ACP',isp
          IF(k.eq.2) write(6,*) k,'nd OACP-results for ACP',isp
          IF(k.eq.3) write(6,*) k,'rd OACP-results for ACP',isp
          IF(k.gt.3) write(6,*) k,'th OACP-results for ACP',isp
          write(6,*) '                   parameter                  pen'
          print*,'penalty',sig,parm(sig,isp),tP(sig,isp)
          write(6,'(1X,16("OACP")/)')
         ENDIF

        ENDDO
       ENDDO
       k = k + 1
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE FORCEPENALTY(tPtmp)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'coor.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'sgpp.inc'
c     arguments
      REAL*8   tPtmp
c     variables
      INTEGER  isp,iat,i
C     ==--------------------------------------------------------------==
      tPtmp = 0.0D0
      DO isp = 1,maxsp
       DO iat = 1,na(isp)
        IF(TFDIMEN.eq.0)THEN ! choose dimensionality
         DO i = 1,3
          tPtmp = tPtmp + DABS(fion(i,iat,isp))
         ENDDO
        ELSEIF(TFDIMEN.eq.1)THEN
         tPtmp = tPtmp + DABS(fion(1,iat,isp))
        ELSEIF(TFDIMEN.eq.2)THEN
         tPtmp = tPtmp + DABS(fion(2,iat,isp))
        ELSEIF(TFDIMEN.eq.3)THEN
         tPtmp = tPtmp + DABS(fion(3,iat,isp))
        ENDIF 
       ENDDO
      ENDDO
      call GLOSUM(1,tPtmp)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      
C     ==================================================================
      SUBROUTINE DENSITYPENALTY(rho_ref,rho_tmp,tP,refvol)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'coor.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'sgpp.inc'
c     arguments
      REAL*8   rho_ref(*),rho_tmp(*),tP
      LOGICAL  refvol
c     variables
      INTEGER  i1,i2,i3,iii,spec,iat
      REAL*8   dist,omevol
      LOGICAL  vol
C     ==--------------------------------------------------------------==
      tP = 0.0D0
      omevol=omega/DBLE(NR1S*NR2S*NR3S)
      IF (refvol) THEN
        DO i3 = 1,kr3s
          DO i2 = 1,kr2s
            iii = 0
            DO i1 = nrxpl(mepos,1),nrxpl(mepos,2)
              iii = iii + 1
              vol = .false.
              DO spec = 1,tdumnum ! loop1 to check if u r outside RAD_DUM
                CALL DISTANCE(1,spec,i1,i2,i3,dist)
                IF (dist.lt.rad_dum) vol = .true.
              ENDDO
              DO spec = tdumnum+1,maxsp ! loop2 to check if u r outside RAD_NORM
                DO iat = 1,na(spec)
                  CALL DISTANCE(iat,spec,i1,i2,i3,dist)
                  IF (dist.lt.rad_norm) vol = .true.
                ENDDO
              ENDDO
              IF (vol) tP = tP
     $            + ((rho_ref(iii+(i2-1)*kr1+(i3-1)*kr1*kr2s)
     &            - rho_tmp(iii+(i2-1)*kr1+(i3-1)*kr1*kr2s))**2) *omevol
            ENDDO
          ENDDO
        ENDDO
        CALL GLOSUM(1,tP)
      ELSE
        DO i1=1,NNR1
          tP = tP + ((rho_ref(i1)-rho_tmp(i1))**2)*omevol
        ENDDO
        CALL GLOSUM(1,tP)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE DUMMY_OPTCALC(c0,c1,psi,scr,lscr,nstate,rhoe,drhoe,
     & eirop,eirop1,eivps,z11,rho_ref,rho_tmp,vtemp,crit_tmp,
     &    pme,gde,sc0,vpp,eigv)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'coor.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'sgpp.inc'
c     arguments
      CHARACTER*20 filename,num
      INTEGER    nstate,lscr
      COMPLEX*16 c0(ngw,nstate),c1(ngw,nstate),psi(*),eirop(nhg)
      COMPLEX*16 eirop1(nhg),vtemp(*),eivps(*)
      REAL*8     rhoe(nnr1),scr(*),drhoe(nnr1),z11(nstate,nstate)
      REAL*8     rho_ref(*),rho_tmp(*) ! reference and temporary rho
      REAL*8     crit_tmp ! temporary convergence criterium value
c     variables for rwfopt_nuc
      REAL*8     sc0(*),vpp(*),eigv(*)
      COMPLEX*16 pme(ngwk,*),gde(ngwk,*)
c     variables
      CHARACTER*2 numb
      CHARACTER*20 ecpname
      LOGICAL    vol
      INTEGER    i1,i2,i3,iii
      INTEGER    isp,iat,spec ! species, atom,species
      INTEGER    numofs,sig ! total number of parameters, parameter
      REAL*8     dist
      REAL*8     rho1(nnr1,5,*) ! perturbed rho
      REAL*8     tP,omevol,dP(5,tdumnum) ! 5 is the number of sigma
      COMPLEX*16 temp_p(ngw,*) ! for wavefunctions
      COMPLEX*16 pertXphi(ngw,nstate,5,*) ! for perturbation Hamiltonian, 5 is the number of sigma
      POINTER    (ip_temp_p,temp_p)
      POINTER    (ip_pertXphi,pertXphi),(ip_rho1,rho1)
C     ==--------------------------------------------------------------==
      call MEMORY(ip_temp_p,2*ngw*nstate,'temp_p')
      call MEMORY(ip_rho1,nnr1*5*tdumnum,'rho1') ! 5 is the number parameters
      call 
     &   MEMORY(ip_pertXphi,2*ngw*nstate*5*tdumnum,'pertXphi')!5 is the number of parameters
C     ==--------------------------------------------------------------==
      iat = 1

C     get perturbation Hamiltonian into pertXphi for x, state is, parameter sig, species isp 
      numofs = 5 ! = number of sig's of dummy isp
      DO isp = 1,tdumnum
       call PERT4NUC(isp,iat,scr,c0,rhoe,nstate,numofs,pertXphi)
      ENDDO

C     call linear response to get perturbed density rho1 from pertXphi for sig and isp
      DO isp = 1,tdumnum
       DO sig = 1,numofs
        IF(parent)THEN
         write(6,'(/,1X,16("OACP"))')
         write(6,'(" OACP",16X,A,17X,"OACP")') ' RESPONSE CALCULATION  '
         write(6,'(" OACP",14X,A,I4,A,I4,14X,"OACP")')
     $       'for parameter',sig,' of ACP',isp
         write(6,'(1X,16("OACP")/)')
        ENDIF
        call DCOPY(2*ngw*nstate,pertXphi(1,1,sig,isp),1,temp_p(1,1),1)
        call RWFOPT_P(c0(1,1),c1(1,1),psi,rhoe,drhoe,scr,lscr,eirop,
     &                eivps,vtemp(1),temp_p(1,1),z11,nstate,eirop1)
        call RHOOFR_P(c0,c1,drhoe,psi,scr,lscr,nstate)

        DO i3 = 1,kr3s
         DO i2 = 1,kr2s
          iii = 0
          DO i1 = nrxpl(mepos,1),nrxpl(mepos,2)
           iii = iii + 1
            rho1(iii+(i2-1)*kr1+(i3-1)*kr1*kr2s,sig,isp) = 0.0D0
            vol = .false.
            DO spec = 1,tdumnum ! loop1 to check if u r outside RAD_DUM
             call DISTANCE(1,spec,i1,i2,i3,dist)
             IF (dist.lt.rad_dum) vol = .true.
            ENDDO
            DO spec = tdumnum+1,maxsp ! loop2 to check if u r outside RAD_NORM
             DO iat = 1,na(spec)
              call DISTANCE(iat,spec,i1,i2,i3,dist)
              IF (dist.lt.rad_norm) vol = .true.
             ENDDO
            ENDDO
            IF (vol) rho1(iii+(i2-1)*kr1+(i3-1)*kr1*kr2s,sig,isp)
     &      = - 2 * drhoe(iii+(i2-1)*kr1+(i3-1)*kr1*kr2s) ! missing factor from Daniel's routine
          ENDDO
         ENDDO
        ENDDO

       ENDDO
      ENDDO

C     compute the penalty derivative wrt 5 parameters sig for all species isp,
***** dP = 2*dSIG* \int dr^3 rho1 * (rho_tmp-rho_ref)  
      omevol=omega/DBLE(NR1S*NR2S*NR3S)
      DO isp = 1,tdumnum
       DO sig = 1,numofs
        dP(sig,isp) = 0.0D0
        DO iii = 1,NNR1
         dP(sig,isp) = dP(sig,isp) + rho1(iii,sig,isp) * 2 
     &      * (rho_tmp(iii)-rho_ref(iii)) * omevol
        ENDDO
        call GLOSUM(1,dP(sig,isp))
       ENDDO
      ENDDO

C     update all sig for all species and PP-file
      DO isp = 1, tdumnum 
       IF(parent)THEN
        call STEEPESTDESCENT(rcsg(isp),dumstep1,dP(1,isp))
        call STEEPESTDESCENT(clsg(1,isp),dumstep2,dP(2,isp))
        call STEEPESTDESCENT(clsg(2,isp),dumstep3,dP(3,isp))
        call STEEPESTDESCENT(rcnl(1,isp),dumstep4,dP(4,isp))
        call STEEPESTDESCENT(hlsg(1,1,1,isp),dumstep5,dP(5,isp))
        write (numb,'(I2.2)') isp
        ecpname = 'DUMMY_'//numb
        call write_pp(isp,ecpname)
        write (6,*)' OACP psedopotential written to: ',ecpname
        call recpnew(isp,ecpname)
       ENDIF
      ENDDO        

C     update the wavefunction
      RESPONSE_RUNNING=.FALSE.
      call RINFORCE_NUC(tdumnum)
      call RWFOPT_NUC(c0,c1,sc0,pme,gde,vpp,eigv,nstate,scr,psi,rhoe)
      RESPONSE_RUNNING=.TRUE.

C     print out penalty derivatives
      IF(parent) THEN
       write(6,'(/,1X,64("*"))')
       write(6,'(" *",19X,A,20X,"*")') ' RESPONSE RESULTS      '
       write(6,*) '*   ACP  PARAM  PENALTY GRADIENT:'
      ENDIF
      crit_tmp = 0.0D0
      DO isp = 1,tdumnum
       DO sig = 1,numofs
        IF(parent) write(6,'(" *",I5,2X,I5,F16.8)')isp,sig,dP(sig,isp)
        IF (crit_tmp.lt.DABS(dP(sig,isp))) crit_tmp=DABS(dP(sig,isp))
       ENDDO
      ENDDO
      IF(parent) write(6,'(1X,64("*"),/)')

C     ==--------------------------------------------------------------==
      call FREEM(ip_temp_p)
      call FREEM(ip_rho1)
      call FREEM(ip_pertXphi)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE STEEPESTDESCENT(sig,delta,dP)
      REAL*8     sig, delta, dP
C     ==--------------------------------------------------------------==
      sig = sig - delta * DABS(sig) * dP
      RETURN
      END 
C     ==================================================================

C     ==================================================================
      SUBROUTINE PERT4NUC(isp,iat,scr,c0,rhoe,nstate,numofs,pertXphi)
C     ==================================================================
C     computes the real space perturbational Hamiltonian for atom (isp,iat),
C     i.e. the derivative wrt all parameters, of the 1996 SG PP in
C     real space for l = s (hence, there are only 5 sigma parameters).
C     The perturbing potential needs to be applied to every orbital and
C     is fftransformed and copied into pertXphi
C     J. Chem. Phys. 122, 14113 (2005).
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'coor.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'cnst.inc'
C     arguments
      INTEGER isp,iat,numofs,nstate
      REAL*8  scr(*),rhoe(nnr1)
      COMPLEX*16 c0(ngw,nstate)
      COMPLEX*16 pertXphi(ngw,nstate,numofs,*)
C     variables
      CHARACTER*20 filename,num
      INTEGER is,i1,i2,i3,iii,x,sig
      REAL*8  dist,rhoxyz(kr1,kr2s,kr3s),cutof
      REAL*8  deltaV(kr1,kr2s,kr3s,numofs) !numofs = number of sigmas
      REAL*8  omevol,term(4)
      REAL*8  totxyz(kr1,kr2s,kr3s,numofs)
      COMPLEX*16 temp(ngw,nstate) 
      PARAMETER  (cutof=1.D-10)
      POINTER (ip_deltaV,deltaV),(ip_rhoxyz,rhoxyz),(ip_totxyz,totxyz)
      POINTER (ip_temp,temp)
C     ==--------------------------------------------------------------==
      call MEMORY(ip_deltaV,numofs*kr1*kr2s*kr3s,'deltaV')
      call MEMORY(ip_rhoxyz,kr1*kr2s*kr3s,'rhoxyz')
      call MEMORY(ip_totxyz,numofs*kr1*kr2s*kr3s,'totxyz')
      call MEMORY(ip_temp,2*ngw*nstate,'temp') 
C     ==--------------------------------------------------------------==

C     ==--------------------------------------------------------------==
C     Compute local parts of h'
      DO i3 = 1,kr3s
       DO i2 = 1,kr2s
        iii = 0
        DO i1 = nrxpl(mepos,1),nrxpl(mepos,2)       
         iii  = iii + 1
         call DISTANCE(iat,isp,i1,i2,i3,dist)
          deltaV(iii,i2,i3,1) = dexp(-0.5D0*(dist**2)/(rcsg(isp)**2))
     &     * ( (clsg(1,isp)-2*clsg(2,isp))*(dist**2)/(rcsg(isp)**3)
     &        +                clsg(2,isp)*(dist**4)/(rcsg(isp)**5)
     &        +       zv(isp)*(2**0.5D0)/((pi**(0.5D0))*(rcsg(isp)**2)))

         deltaV(iii,i2,i3,2) = dexp(-0.5D0*(dist**2)/(rcsg(isp)**2))
         deltaV(iii,i2,i3,3) = deltaV(iii,i2,i3,2)*(dist/rcsg(isp))**2
         IF(DABS(deltaV(iii,i2,i3,1)).lt.cutof) deltaV(iii,i2,i3,1) = 0.0D0
         IF(DABS(deltaV(iii,i2,i3,2)).lt.cutof) deltaV(iii,i2,i3,2) = 0.0D0
         IF(DABS(deltaV(iii,i2,i3,3)).lt.cutof) deltaV(iii,i2,i3,3) = 0.0D0
        ENDDO
       ENDDO
      ENDDO
C     ==--------------------------------------------------------------==

C     ==--------------------------------------------------------------==
C     Compute nonlocal parts of h' and apply to orbital rhoe: h'|phi> 
      omevol=omega/DBLE(NR1S*NR2S*NR3S)
      DO is = 1,nstate
       call ffttor(c0(1,is),rhoe,scr,ngw,.true.)

C     Compute the first separable part
       call azzero(term(1),4)
       DO i3 = 1,kr3s
        DO i2 = 1,kr2s
         iii = 0
         DO i1 = nrxpl(mepos,1),nrxpl(mepos,2)
          iii = iii + 1
          call DISTANCE(iat,isp,i1,i2,i3,dist)
           term(1) = rhoe(iii+(i2-1)*kr1+(i3-1)*kr1*kr2s) *
     &     dexp(-(dist**2)/(2*rcnl(1,isp)**2))*omevol
           term(2) = term(2) + term(1)
           term(3) = term(3) + term(1) * dist**2
           IF(DABS(term(1)).lt.cutof) term(1) = 0.0D0
           IF(DABS(term(2)).lt.cutof) term(2) = 0.0D0
           IF(DABS(term(3)).lt.cutof) term(3) = 0.0D0
         ENDDO
        ENDDO
       ENDDO
       call glosum(1,term(2))
       call glosum(1,term(3))

C     Compute the other part and apply also the local part to rhoe
       call azzero(rhoxyz(1,1,1),kr1*kr2s*kr3s)
       DO i3 = 1,kr3s
        DO i2 = 1,kr2s
         iii = 0
         DO i1 = nrxpl(mepos,1),nrxpl(mepos,2)
          iii = iii + 1
          call DISTANCE(iat,isp,i1,i2,i3,dist)
          term(4) = dexp(-(dist**2)/(2*rcnl(1,isp)**2))
          IF(DABS(term(4)).lt.cutof) term(4) = 0.0D0
          deltaV(iii,i2,i3,4) = term(4) * ( term(2) 
     &       * ((dist**2)*hlsg(1,1,1,isp)/((pi**1.5D0)*rcnl(1,isp)**6)-
     &               3*hlsg(1,1,1,isp)/((pi**1.5D0)*rcnl(1,isp)**4))
     &       + term(3)*hlsg(1,1,1,isp)/((pi**1.5D0)*rcnl(1,isp)**6))
          deltaV(iii,i2,i3,5) = term(2)*term(4)/
     &                             ((pi**1.5D0)*(rcnl(1,isp)**3))
          IF(DABS(deltaV(iii,i2,i3,4)).lt.cutof)
     &           deltaV(iii,i2,i3,4) = 0.0D0
          IF(DABS(deltaV(iii,i2,i3,5)).lt.cutof)
     &          deltaV(iii,i2,i3,5) = 0.0D0
          DO sig = 1,numofs
                totxyz(iii,i2,i3,sig) = deltaV(iii,i2,i3,sig)*
     &          rhoe(iii+(i2-1)*kr1+(i3-1)*kr1*kr2s)
           IF (sig.ge.4) totxyz(iii,i2,i3,sig) = deltaV(iii,i2,i3,sig)!the nonlocal parts are already multiplied with rhoe
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C      fft of h'|phi> for every state (is), sigma (xx), and species (isp)
       DO sig = 1,numofs
        call FFTTOG(totxyz(1,1,1,sig),temp(1,is),scr,ngw,.true.)
        call DCOPY(2*ngw,temp(1,is),1,pertXphi(1,is,sig,isp),1)
       ENDDO

      ENDDO ! over nstate
C     ==--------------------------------------------------------------==

C     ==--------------------------------------------------------------==
      call FREEM(ip_deltaV)
      call FREEM(ip_rhoxyz)
      call FREEM(ip_totxyz)
      call FREEM(ip_temp)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE DUMMY_REFCALC(c0,psi,scr,lscr,nstate,rhoe)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'coor.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'ropt.inc'
c     arguments
      CHARACTER*20 filename
      INTEGER    nstate,lscr 
      COMPLEX*16 c0(ngw,nstate),psi(*)
      REAL*8     rhoe(nnr1),scr(*)
C     ==--------------------------------------------------------------==
      IF(parent) print*,'DUMMY_REFCALC'
      call my_flush(6)
C     ==--------------------------------------------------------------==

      IF (TDUMMYATOM_REF) THEN
C     get the electrondensity from c0 in rho0
       call RHOOFR(c0,rho0,psi,scr,lscr,nstate)

C     write out rhoofr_ref.dat for reference density
       call rhopri(c0,tau0,rho0,psi,scr,lscr,nstate,1)
       filename = 'rhoofr_ref.cube'
       call CUBEFILE(filename,rho0,tau0,scr,.false.)
      ENDIF

      RETURN 
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE DISTANCE(iat,isp,i1,i2,i3,dist) ! get distance to an atom
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'coor.inc'
      INTEGER iat,isp,i1,i2,i3
      REAL*8  dist
C     ==--------------------------------------------------------------==
         dist =  dsqrt((tau0(1,iat,isp)-(i1-1)*a1(1)/nr1s)**2
     &               +(tau0(2,iat,isp)-(i2-1)*a2(2)/nr2s)**2
     &               +(tau0(3,iat,isp)-(i3-1)*a3(3)/nr3s)**2)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
