C     ==================================================================
      SUBROUTINE ODIIS(C0,C2,VPP,NSTATE,PME,GDE,SVAR2,REINIT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,*),C2(NGW,*)
      REAL*8     VPP(*),PME(NGW*NSTATE+8,*),GDE((NGW*NSTATE+8)/4,*),
     &           SVAR2
      LOGICAL    REINIT
C     Variables
      DIMENSION  F(NSTATE)     
      REAL*8     DIISM(MAXDIS,MAXDIS),GRMAX(MAXDIS),GIMAX(MAXDIS),
     *           GNORM(MAXDIS),
     &           EOLD,GAMMA
      INTEGER    NDIIS,NOWV,ISTATE,NOCC
      LOGICAL    EINC1
      REAL*8     BC(MAXDIS+1,MAXDIS+1),VC(MAXDIS+1),
     &           E1THR,DE1,G1,G2,RATIO,RATION,RAIM,FF,VTMP
      REAL*8     DOTP
      EXTERNAL   DOTP
      INTEGER    ISUB,I,NOWM,IG,K,J,NEMPTY,NSIZE
#ifdef PARALLEL
      INTEGER    MSGLEN
#endif
      SAVE       DIISM,GRMAX,GIMAX,GNORM,EOLD,GAMMA,
     &           NDIIS,NOWV,NOCC,ISTATE
      DATA       ISTATE /0/
C     ==--------------------------------------------------------------==
      CALL TISET('     ODIIS',ISUB)
      IF(REINIT.OR.ISTATE.EQ.0) THEN
C       Reinitialization of diis procedure
        ISTATE=0
        EOLD=9999.D0
        GAMMA=0.D0
        REINIT=.FALSE.
        NOCC=0
        NDIIS=0
        DO I=1,NSTATE
          IF(F(I).GT.1.D-5) THEN
            NOCC=NOCC+1
          ENDIF
        ENDDO
      ENDIF
C     Empirical rules to assure convergence
      IF(ISTATE.NE.0) THEN
C     Check for an increase in energy
        E1THR=1.0D0
        DE1=ETOT-EOLD
        EINC1=.FALSE.
        IF(DE1.GT.E1THR) EINC1=.TRUE.
        IF(.NOT. TFRHO_UPW) THEN
C     Trust region parameter
          IF(GEQ0) THEN
            IF(DE1.GT.0.0D0) THEN
              GAMMA=GAMMA+1.D0/VPP(1)
            ELSE
              GAMMA=0.75D0*GAMMA
            ENDIF
          ENDIF
        ENDIF
#ifdef PARALLEL
        MSGLEN= 1 * 8
        CALL MY_BCAST(GAMMA,MSGLEN,IGEQ0,ALLGRP)
#endif
        REINIT=.FALSE.
        IF(NDIIS.GT.NRESET.AND.NRESET.GE.3) THEN
C..restart if there was no progress over the last steps 
          NOWM=NOWV+1
          IF(NOWV.EQ.MDIIS) NOWM=1
          G1=DSQRT(GRMAX(NOWV)**2 + GIMAX(NOWV)**2)
          G2=DSQRT(GRMAX(NOWM)**2 + GIMAX(NOWM)**2)
          RATIO=G1/G2
          RATION=GNORM(NOWV)/GNORM(NOWM)
          RAIM=1.0D0-DBLE(MDIIS)/100.D0
          IF(RATIO.GT.RAIM.AND.RATION.GT.RAIM) REINIT=.TRUE.
          IF(REINIT .AND. PARENT)
     *        WRITE(6,'(A)') ' ODIIS| Insufficient progress; reset!'
          IF(REINIT) THEN
            ISTATE=0
            GAMMA=0.0D0
C           REINIT=.FALSE. ! we need this info in UPDWF, reset there
          ENDIF
        ENDIF
      ENDIF
      IF(ISTATE.EQ.0) CALL UPDIS(NDIIS,NOWV,NSIZE,MDIIS,0)
      ISTATE=2
C     Perform an electronic DIIS step
      CALL UPDIS(NDIIS,NOWV,NSIZE,MDIIS,1)
#ifdef _BGL 
      CALL ALIGNX(16,VPP(1))
!IBM* ASSERT (ITERCNT(1000))
!IBM* INDEPENDENT
#endif
#if defined(__VECTOR)
C$OMP parallel do private(ig)
#else
C$OMP parallel do private(ig) schedule(static)
#endif
      DO IG=1,NGW
        VPP(IG)=VPP(IG)/(1.0D0+VPP(IG)*GAMMA)
      ENDDO
C     Update DIIS buffers
      CALL DSCOPY(NGW*NOCC,C0,PME(1,NOWV))
      CALL DSCAL(2*NGW*NOCC,-1.0D0,C2(1,1),1)
      CALL GRIMAX(C2,NOCC,GRMAX(NOWV),GIMAX(NOWV),GNORM(NOWV))
      CALL DICOPY(NGW*NOCC,C2,GDE(1,NOWV),
     *              GRMAX(NOWV),GIMAX(NOWV))

#if defined(__VECTOR)
C     Scale Gradient with Preconditioner(**2)
!$OMP parallel do private(K,FF,IG)
#ifdef __SR8000
*poption parallel, tlocal(K,FF,IG)
#endif
      DO K=1,NOCC
        IF(PREC.AND.F(K).GT.0.1D0) THEN
          FF=1.0D0/F(K)
        ELSE
          FF=1.0D0
        ENDIF
#ifdef _BGL 
      CALL ALIGNX(16,VPP(1))
!IBM* ASSERT (ITERCNT(1000))
!IBM* INDEPENDENT
#endif
        DO IG=1,NGW
          C2(IG,K)=C2(IG,K)*2.0D0*FF*FF*VPP(IG)*VPP(IG)
        ENDDO
      ENDDO
#else
C     Scale Gradient with Preconditioner(**2)
#ifdef __SR8000
*poption parallel, tlocal(K,FF,IG,VTMP)
#endif
#ifdef _BGL 
      CALL ALIGNX(16,VPP(1))
!IBM* ASSERT (ITERCNT(1000))
!IBM* INDEPENDENT
#endif
!$OMP parallel do private(K,FF,IG,VTMP) schedule(static)
      DO IG=1,NGW
        VTMP=2.0D0*VPP(IG)*VPP(IG)
        DO K=1,NOCC
          IF(PREC.AND.F(K).GT.0.1D0) THEN
            FF=1.0D0/F(K)
          ELSE
            FF=1.0D0
          ENDIF
          C2(IG,K)=C2(IG,K)*FF*FF*VTMP
        ENDDO
      ENDDO
#endif
C     Update DIIS matrix
!$OMP parallel do private(I)
      DO I=1,NSIZE-1
        DIISM(I,NOWV)=0.0D0
      ENDDO
      DO I=1,NSIZE-1
        CALL IDCOPY(NGW*NOCC,C0,GDE(1,I),GRMAX(I),GIMAX(I))
        DO K=1,NOCC
          DIISM(I,NOWV)=DIISM(I,NOWV)+DOTP(NGW,C0(1,K),C2(1,K))
        ENDDO
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(NSIZE-1,DIISM(1,NOWV))
#endif
C$OMP parallel do private(I)
      DO I=1,NSIZE-1
        DIISM(NOWV,I)=DIISM(I,NOWV)
      ENDDO
C     Set up DIIS Matrix
      CALL AZZERO(BC,(MAXDIS+1)*(MAXDIS+1))
C$OMP parallel do private(I,J)
      DO I=1,NSIZE-1
        DO J=1,NSIZE-1
          BC(I,J)=DIISM(I,J)
        ENDDO
      ENDDO
C$OMP parallel do private(I)
      DO I=1,NSIZE-1
        VC(I)=0.D0
        BC(I,NSIZE)=-1.D0
        BC(NSIZE,I)=-1.D0
      ENDDO
      VC(NSIZE)=-1.D0
      BC(NSIZE,NSIZE)=0.D0
C     Solve System of Linear Equations
      CALL SOLVE(BC,MAXDIS+1,NSIZE,VC)
C     Compute Interpolated Coefficient Vectors
#if defined(__VECTOR)
#ifdef _BGL 
      CALL AZZERO(C0,2*NGW*NOCC)
#else
      CALL ZAZZERO(C0,NGW*NOCC)
#endif
      DO I=1,NSIZE-1
        CALL SDCOPY(NGW*NOCC,PME(1,I),C2)
        CALL DAXPY(2*NGW*NOCC,VC(I),C2(1,1),1,C0(1,1),1)
      ENDDO
#else
C     do the above in one go and avoid having to use C2.
      CALL INTPCOEF(NGW*NOCC,NSIZE,NGW*NSTATE+8,PME,VC,C0)
#endif
C     Estimate New Parameter Vectors 
      DO I=1,NSIZE-1
        CALL IDCOPY(NGW*NOCC,C2,GDE(1,I),GRMAX(I),GIMAX(I))
        FF=1.0D0
!$OMP parallel do private(K,FF,IG)
#ifdef __SR8000
*poption parallel, tlocal(K,FF,IG)
#endif 
        DO K=1,NOCC
          IF(PREC.AND.F(K).GT.0.1D0) THEN
            FF=1.0D0/F(K)
          ELSE
            FF=1.0D0
          ENDIF
#ifdef _BGL 
      CALL ALIGNX(16,VPP(1))
      CALL ALIGNX(16,VC(1))
!IBM* ASSERT (ITERCNT(1000))
!IBM* INDEPENDENT
#endif
          DO IG=1,NGW
            C0(IG,K)=C0(IG,K)-VC(I)*FF*VPP(IG)*C2(IG,K)
          ENDDO
        ENDDO
      ENDDO
      IF(NOCC.LT.NSTATE) THEN
C       Use steepest descent for empty states
        NEMPTY=NSTATE-NOCC
        CALL DAXPY(2*NGW*NEMPTY,SVAR2,C2(1,NOCC+1),1,C0(1,NOCC+1),1)
      ENDIF
      EOLD=ETOT
#ifdef _BGL 
      CALL ALIGNX(16,VPP(1))
!IBM* ASSERT (ITERCNT(1000))
!IBM* INDEPENDENT
#endif
#if defined(__VECTOR)
!$OMP parallel do private(ig)
#else
!$OMP parallel do private(ig) schedule(static)
#endif
      DO IG=1,NGW
        VPP(IG)=1.D0/(1.0D0/VPP(IG)-GAMMA)
      ENDDO
      CALL TIHALT('     ODIIS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE UPDIS(NDIIS,NOWV,NSIZE,MDIIS,IACT)
C     ==--------------------------------------------------------------==
C     == Update variables for DIIS if IACT=1                          ==
C     == Set to 0                  if IACT/=1                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NDIIS,NOWV,NSIZE,MDIIS,IACT
C     ==--------------------------------------------------------------==
      IF(IACT.EQ.1) THEN
        NOWV=MOD(NDIIS,MDIIS)+1
        NDIIS=NDIIS+1
        NSIZE=NDIIS+1
        IF(NSIZE.GT.MDIIS) NSIZE=MDIIS+1
      ELSE
        NDIIS=0
        NOWV=0
        NSIZE=0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SOLVE(B,LDB,NDIM,V)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER LDB,NDIM, INFO
      REAL*8  B(LDB,*),V(*)
#if defined(T3D) || defined(T3E)
C     Variables
      INTEGER IPIV(NDIM)
C     ==--------------------------------------------------------------==
C     To be used on the T3D
      CALL SGESV(NDIM,1,B,LDB,IPIV,V,LDB,INFO)
#else
C     Variables
      INTEGER NR,LW
      REAL*8  TOLEIG
      REAL*8  SCR1(MAXDIS+1,MAXDIS+1),SCR2(MAXDIS+1,MAXDIS+1)
C     ==--------------------------------------------------------------==
      IF(NDIM.GT.MAXDIS+1) THEN
        WRITE(6,*) 'SOLVE! NDIM=',NDIM,' MAXDIS+1=',MAXDIS+1
        CALL STOPGM('SOLVE','MDIM GREATER THAN MAXDIS+1')
      ENDIF
      TOLEIG=0.2D-15
      LW=(MAXDIS+1)*(MAXDIS+1)
      CALL DGELSS(NDIM,NDIM,1,B,LDB,V,LDB,SCR1,TOLEIG,NR,SCR2,LW,INFO)
      IF(INFO.NE.0) THEN
        WRITE(6,*) 'SOLVE! INFO=',INFO
        CALL STOPGM('SOLVE','COULD NOT SOLVE DIIS EQUATION')
      ENDIF
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GRIMAX(C2,N,GRMAX,GIMAX,GNORM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER N
      REAL*8  C2(2,NGW*N),GRMAX,GIMAX,GNORM
C     Variables
      REAL*8  DOTP
      EXTERNAL   DOTP
      INTEGER IR,II,I,
     &        IDAMAX
C     ==--------------------------------------------------------------==
      IR=IDAMAX(N*NGW,C2(1,1),2)
      II=IDAMAX(N*NGW,C2(2,1),2)
      GRMAX=C2(1,IR)
      GIMAX=C2(2,II)
      GNORM=0.0D0
      DO I=1,N
        II=(I-1)*NGW+1
        GNORM=GNORM+DOTP(NGW,C2(1,II),C2(1,II))
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(1,GNORM)
      CALL GLOMAX(1,GRMAX)
      CALL GLOMAX(1,GIMAX)
#endif
      GNORM=DSQRT(GNORM/DBLE(N*NGWS))
      RETURN
      END
C     ==================================================================
      SUBROUTINE DICOPY(N,C,X,GRMAX,GIMAX)
C     ==--------------------------------------------------------------==
C     == PACK N COMPLEX*16 NUMBERS TO TWO 1 BYTE INTEGERS             ==
C     ==--------------------------------------------------------------==
#if defined(CRAY64) || defined (__NEC) 
C     INTEGER = INTEGER*8
      IMPLICIT NONE
C     Arguments
      INTEGER N,X(N/4+3)
      REAL*8  C(2,N),GRMAX,GIMAX
C     Variables
      REAL*8  FR,FI
      INTEGER I,J,I11,I21,I12,I22,I13,I23,I14,I24,NREST
C     ==--------------------------------------------------------------==
      FR=127.D0/GRMAX
      FI=127.D0/GIMAX
      DO I=1,N/4
        J=(I-1)*4
        I11=NINT(C(1,J+1)*FR)+128
        I21=NINT(C(2,J+1)*FI)+128
        I12=NINT(C(1,J+2)*FR)+128
        I22=NINT(C(2,J+2)*FI)+128
        I13=NINT(C(1,J+3)*FR)+128
        I23=NINT(C(2,J+3)*FI)+128
        I14=NINT(C(1,J+4)*FR)+128
        I24=NINT(C(2,J+4)*FI)+128
        X(I)=ISHFT(I11,56)+ISHFT(I21,48)+ISHFT(I12,40)+
     *         ISHFT(I22,32)+ISHFT(I13,24)+ISHFT(I23,16)+
     *         ISHFT(I14,8)+I24
      ENDDO
      NREST=MOD(N,4)
      IF(NREST.EQ.1) THEN
        I11=NINT(C(1,N)*FR)+128
        I21=NINT(C(2,N)*FI)+128
        X(N/4+1)=ISHFT(I11,56)+ISHFT(I21,48)
      ELSEIF(NREST.EQ.2) THEN
        I11=NINT(C(1,N-1)*FR)+128
        I21=NINT(C(2,N-1)*FI)+128
        I12=NINT(C(1,N)*FR)+128
        I22=NINT(C(2,N)*FI)+128
        X(N/4+1)=ISHFT(I11,56)+ISHFT(I21,48)+ISHFT(I12,40)+
     *         ISHFT(I22,32)
      ELSEIF(NREST.EQ.3) THEN
        I11=NINT(C(1,N-2)*FR)+128
        I21=NINT(C(2,N-2)*FI)+128
        I12=NINT(C(1,N-1)*FR)+128
        I22=NINT(C(2,N-1)*FI)+128
        I13=NINT(C(1,N)*FR)+128
        I23=NINT(C(2,N)*FI)+128
        X(N/4+1)=ISHFT(I11,56)+ISHFT(I21,48)+ISHFT(I12,40)+
     *         ISHFT(I22,32)+ISHFT(I13,24)+ISHFT(I23,16)
      ENDIF
#elif defined(__SUN) || defined(__SR2201) || defined(__SR8000) || defined(__Linux) || defined(_vpp_) || defined(CRAY32) || defined(__WINNT)
C     INTEGER = INTEGER*4
      IMPLICIT NONE
      INTEGER*4 N
      REAL*8    C(2,N),GRMAX,GIMAX, FR,FI
      INTEGER*4 X(*), I,J,NREST,I11,I21,I12,I22
C     ==--------------------------------------------------------------==
      FR=127.D0/GRMAX
      FI=127.D0/GIMAX
#ifdef __SR11000
!$OMP parallel do private(I,J,I11,I21,I12,I22)
#endif 
      DO I=1,N/2
        J=(I-1)*2
        I11=NINT(C(1,J+1)*FR)+128
        I21=NINT(C(2,J+1)*FI)+128
        I12=NINT(C(1,J+2)*FR)+128
        I22=NINT(C(2,J+2)*FI)+128
        X(I)=ISHFT(I11,24)+ISHFT(I21,16)+
     *       ISHFT(I12,8) +I22
      ENDDO
      NREST=MOD(N,2)
      IF(NREST.EQ.1) THEN
        I11=NINT(C(1,N)*FR)+128
        I21=NINT(C(2,N)*FI)+128
        X(N/2+1)=ISHFT(I11,24)+ISHFT(I21,16)
      ENDIF
#else
      IMPLICIT NONE
      INTEGER N, I
      REAL*8 C(2,N), GRMAX,GIMAX, FR,FI
      INTEGER*1 X(2,N)
C     ==--------------------------------------------------------------==
      FR=127.D0/GRMAX
      FI=127.D0/GIMAX
!$OMP parallel do private(i)
      DO I=1,N
        X(1,I)=C(1,I)*FR
        X(2,I)=C(2,I)*FI
      ENDDO
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE IDCOPY(N,C,X,GRMAX,GIMAX)
C     ==--------------------------------------------------------------==
C     == UNPACK N COMPLEX*16 NUMBERS FROM TWO 1 BYTE INTEGERS         ==
C     ==--------------------------------------------------------------==
#if defined (CRAY64) || defined (__NEC)
C     INTEGER = INTEGER*8
      IMPLICIT NONE
C     Arguments
      INTEGER N,X(N/4+3)
      REAL*8  C(2,N),GRMAX,GIMAX
C     Variables
      REAL*8  FR,FI
      INTEGER I,J,NREST
C     ==--------------------------------------------------------------==
      FR=GRMAX/127.D0
      FI=GIMAX/127.D0
!$OMP parallel do private(I,J)
      DO I=1,N/4
        J=(I-1)*4
        C(1,J+1)=ISHFT(X(I),-56)
        C(2,J+1)=ISHFT(ISHFT(X(I), 8),-56)
        C(1,J+2)=ISHFT(ISHFT(X(I),16),-56)
        C(2,J+2)=ISHFT(ISHFT(X(I),24),-56)
        C(1,J+3)=ISHFT(ISHFT(X(I),32),-56)
        C(2,J+3)=ISHFT(ISHFT(X(I),40),-56)
        C(1,J+4)=ISHFT(ISHFT(X(I),48),-56)
        C(2,J+4)=ISHFT(ISHFT(X(I),56),-56)
      ENDDO
      NREST=MOD(N,4)
      IF(NREST.EQ.1) THEN
        C(1,N)=ISHFT(X(N/4+1),-56)
        C(2,N)=ISHFT(ISHFT(X(N/4+1), 8),-56)
      ELSEIF(NREST.EQ.2) THEN
        C(1,N-1)=ISHFT(X(N/4+1),-56)
        C(2,N-1)=ISHFT(ISHFT(X(N/4+1), 8),-56)
        C(1,N)=ISHFT(ISHFT(X(N/4+1),16),-56)
        C(2,N)=ISHFT(ISHFT(X(N/4+1),24),-56)
      ELSEIF(NREST.EQ.3) THEN
        C(1,N-2)=ISHFT(X(N/4+1),-56)
        C(2,N-2)=ISHFT(ISHFT(X(N/4+1), 8),-56)
        C(1,N-1)=ISHFT(ISHFT(X(N/4+1),16),-56)
        C(2,N-1)=ISHFT(ISHFT(X(N/4+1),24),-56)
        C(1,N)=ISHFT(ISHFT(X(N/4+1),32),-56)
        C(2,N)=ISHFT(ISHFT(X(N/4+1),40),-56)
      ENDIF
!$OMP parallel do private(I)
      DO I=1,N
        C(1,I)=(C(1,I)-128.D0)*FR
        C(2,I)=(C(2,I)-128.D0)*FI
      ENDDO
#elif defined(__SUN) || defined(__SR2201) || defined(__SR8000) || defined(__Linux) || defined(_vpp_) || defined(CRAY32) || defined(__WINNT)
C     INTEGER = INTEGER*4
      IMPLICIT NONE
      INTEGER*4 N
      REAL*8 C(2,N), GRMAX,GIMAX, FR,FI
      INTEGER*4 X(*), I,J,NREST
C     ==--------------------------------------------------------------==
      FR=GRMAX/127.D0
      FI=GIMAX/127.D0
#ifdef __SR11000
!$OMP parallel do private(I,J)
#endif 
      DO I=1,N/2
        J=(I-1)*2
        C(1,J+1)=ISHFT(X(I),-24)
        C(2,J+1)=ISHFT(ISHFT(X(I), 8),-24)
        C(1,J+2)=ISHFT(ISHFT(X(I),16),-24)
        C(2,J+2)=ISHFT(ISHFT(X(I),24),-24)
      ENDDO
      NREST=MOD(N,2)
      IF(NREST.EQ.1) THEN
        C(1,N)=ISHFT(X(N/2+1),-24)
        C(2,N)=ISHFT(ISHFT(X(N/2+1), 8),-24)
      ENDIF
!$OMP parallel do private(I)
      DO I=1,N
        C(1,I)=(C(1,I)-128.D0)*FR
        C(2,I)=(C(2,I)-128.D0)*FI
      ENDDO
#else
      IMPLICIT NONE
      INTEGER N, I
      REAL*8 C(2,N), GRMAX,GIMAX,FR,FI
      INTEGER*1 X(2,N)
C     ==--------------------------------------------------------------==
      FR=GRMAX/127.D0
      FI=GIMAX/127.D0
!$OMP parallel do private(i)
      DO I=1,N
        C(1,I)=X(1,I)*FR
        C(2,I)=X(2,I)*FI
      ENDDO
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SDCOPY(N,X,Y)
C     ==--------------------------------------------------------------==
C     == UNPACK N COMPLEX*16 NUMBERS FROM HALF PRECISION              ==
C     ==--------------------------------------------------------------==
#if defined (CRAY64) || defined (__NEC)
      IMPLICIT NONE
C     Arguments
      INTEGER   N,X(*)
      REAL      Y(*)
C     Variables
      INTEGER   NBIG
      PARAMETER (NBIG=10**9)
      INTEGER   I,I1,I2
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I,I1,I2)
      DO I=1,N
        I1=2*I-1
        I2=I1+1
        Y(I1)=ISHFT(X(I),-32)
        Y(I2)=ISHFT(ISHFT(X(I),32),-32)
      ENDDO
!$OMP parallel do private(I)
      DO I=1,2*N
        Y(I)=(Y(I)-NBIG)*1.D-8
      ENDDO
#else
      IMPLICIT NONE
      INTEGER N, I
      COMPLEX*8 X(N)
      COMPLEX*16 Y(N)
C     ==--------------------------------------------------------------==
!$OMP parallel do private(i)
      DO I=1,N
        Y(I)=X(I)
      ENDDO
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DSCOPY(N,X,Y)
C     ==--------------------------------------------------------------==
C     == PACK N COMPLEX*16 NUMBERS IN HALF PRECISION                  ==
C     ==--------------------------------------------------------------==
#if defined (CRAY64) || defined (__NEC)
      IMPLICIT NONE
C     Arguments
      INTEGER   N,Y(N)
      REAL      X(2*N)
C     Variables
      INTEGER   NBIG
      PARAMETER (NBIG=10**9)
      INTEGER   I,I1,I2,IX1,IX2
C     ==--------------------------------------------------------------==
      DO I=1,N
        I1=2*I-1
        I2=I1+1
        IX1=NINT(X(I1)*1.D8)+NBIG
        IX2=NINT(X(I2)*1.D8)+NBIG
        Y(I)=ISHFT(IX1,32)+IX2
      ENDDO
#else
      IMPLICIT NONE
      INTEGER N, I
      COMPLEX*16 X(N)
      COMPLEX*8 Y(N)
C     ==--------------------------------------------------------------==
!$OMP parallel do private(i)
      DO I=1,N
        Y(I)=X(I)
      ENDDO
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#if defined(__ES)
cmb   Please, do NOT remove the part here below: It is vital for ES !
C     ==================================================================
      SUBROUTINE DAXPY(N,DA,DX,INCX,DY,INCY)
C     ==--------------------------------------------------------------==
c     constant times a vector plus a vector.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
cmb   Updated 7/2/2004 for ES
C     ==--------------------------------------------------------------==
      DOUBLE PRECISION dx(*),dy(*),da
      INTEGER i,incx,incy,ix,iy,m,mp1,n
C     ==--------------------------------------------------------------==
      IF(n.le.0) RETURN
      IF(da .eq. 0.0d0) RETURN
      IF(incx.eq.1.and.incy.eq.1) GOTO 20
c
c     code for unequal increments or equal increments
c     not equal to 1
c
      ix = 1
      iy = 1
      IF(incx.lt.0) ix = (-n+1)*incx + 1
      IF(incy.lt.0) iy = (-n+1)*incy + 1
      DO i = 1,n
        dy(iy) = dy(iy) + da*dx(ix)
        ix = ix + incx
        iy = iy + incy
      ENDDO
      RETURN
c
c     code for both increments equal to 1
   20 CONTINUE
!$OMP parallel do private(i)
      DO i = 1,n
        dy(i) = dy(i) + da*dx(i)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DSCAL(n,da,dx,incx)
C     ==--------------------------------------------------------------==
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
cmb   Updated 7/2/2004 for ES
C     ==--------------------------------------------------------------==
      DOUBLE PRECISION da,dx(*)
      INTEGER i,incx,m,mp1,n,nincx
C     ==--------------------------------------------------------------==
      IF(incx.eq.1) THEN
c
c     code for increment equal to 1
!$OMP parallel do private(i)
         DO i = 1,n
           dx(i) = da*dx(i)
         ENDDO
      ELSE
c
c     code for increment not equal to 1
c
         nincx = n*incx
         DO i = 1,nincx,incx
           dx(i) = da*dx(i)
         ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#endif

      SUBROUTINE INTPCOEF(NUM,NSIZE,LDPME,PME,VC,C0)
      INTEGER NUM,NSIZE,LDPME
      COMPLEX*8 PME(LDPME,*)
      COMPLEX*16 C0(*),CTMP
      REAL*8 VC(*)
      INTEGER I,J

#ifdef _BGL 
      CALL ALIGNX(16,VC(1))
!IBM* ASSERT (ITERCNT(1000))
!IBM* INDEPENDENT
#endif
C$OMP parallel do private(I,J,CTMP) schedule(static)
      DO I=1,NUM
        CTMP=DCMPLX(0.0d0,0.0d0)
        DO J=1,NSIZE-1
          CTMP=CTMP+VC(J)*DCMPLX(PME(I,J))
        ENDDO
        C0(I)=CTMP
      ENDDO
      RETURN
      END
C     ==================================================================
