C     ==================================================================
      SUBROUTINE ODIIS_P(C0,C2,VPP,Z11,NSTATE,PME,GDE,SVAR2,REINIT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'response_p.inc'    !PREC_P
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,NSTATE),C2(NGW,NSTATE)
      REAL*8     VPP(NGW),z11(nstate,nstate),
     &          PME(NGW*NSTATE+8,*),GDE((NGW*NSTATE+8)/4,*),
     &           SVAR2
      LOGICAL    REINIT
C     Variables
      DIMENSION  F(NSTATE)     
      REAL*8     DIISM(MAXDIS,MAXDIS),GRMAX(MAXDIS),GIMAX(MAXDIS),
     *           GNORM(MAXDIS),
     &           EOLD
      INTEGER    NDIIS,NOWV,ISTATE
      LOGICAL    EINC1
      REAL*8     BC(MAXDIS+1,MAXDIS+1),VC(MAXDIS+1),
     &           E1THR,DE1,G1,G2,RATIO,RATION,RAIM,FF,
     &           DOTP,VPREC,VPREC1,VPREC2,VPREC3,VPREC4,
     &           VPREC5,VPREC6
      EXTERNAL   DOTP
      INTEGER    ISUB,I,NOWM,IG,K,J,NEMPTY,NSIZE,IS
#ifdef PARALLEL
      INTEGER    MSGLEN
#endif
      SAVE       DIISM,GRMAX,GIMAX,GNORM,EOLD,
     &           NDIIS,NOWV,ISTATE
      DATA       ISTATE /0/
C     ==--------------------------------------------------------------==
      CALL TISET('   ODIIS_P',ISUB)
      DE1 = 0.d0
      IF(ISTATE.NE.0) THEN
C       Check for an increase in energy
        DE1=ETOT-EOLD
      ENDIF

      IF(REINIT.OR.ISTATE.EQ.0 .or. de1 .ge. 1.d0) THEN
C       Reinitialization of diis procedure
        ISTATE=0
        EOLD=9999.D0
        REINIT=.FALSE.
        NDIIS=0
      ENDIF

      IF(ISTATE.EQ.0) CALL UPDIS_P(NDIIS,NOWV,NSIZE,MDIIS,0)
      ISTATE=2
C     Perform an electronic DIIS step
      CALL UPDIS_P(NDIIS,NOWV,NSIZE,MDIIS,1)

C     Update DIIS buffers
      CALL DSCOPY(NGW*NSTATE,C0,PME(1,NOWV))
      CALL DSCAL(2*NGW*NSTATE,-1.0D0,C2(1,1),1)
      CALL GRIMAX(C2,NSTATE,GRMAX(NOWV),GIMAX(NOWV),GNORM(NOWV))
      CALL DICOPY(NGW*NSTATE,C2,GDE(1,NOWV),
     *              GRMAX(NOWV),GIMAX(NOWV))



      call precon_p(c2,c2,vpp,nstate,z11,1)
      call precon_p(c2,c2,vpp,nstate,z11,1)




C     Update DIIS matrix
      DO I=1,NSIZE-1
        DIISM(I,NOWV)=0.0D0
      ENDDO
      DO I=1,NSIZE-1
        CALL IDCOPY(NGW*NSTATE,C0,GDE(1,I),GRMAX(I),GIMAX(I))
        DO K=1,NSTATE  
          DIISM(I,NOWV)=DIISM(I,NOWV)+DOTP(NGW,C0(1,K),C2(1,K))
        ENDDO
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(NSIZE-1,DIISM(1,NOWV))
#endif

      DO I=1,NSIZE-1
        DIISM(NOWV,I)=DIISM(I,NOWV)
      ENDDO
C     Set up DIIS Matrix
      CALL AZZERO(BC,(MAXDIS+1)*(MAXDIS+1))
      DO I=1,NSIZE-1
        DO J=1,NSIZE-1
          BC(I,J)=DIISM(I,J)
        ENDDO
      ENDDO
      DO I=1,NSIZE-1
        VC(I)=0.D0
        BC(I,NSIZE)=-1.D0
        BC(NSIZE,I)=-1.D0
      ENDDO
      VC(NSIZE)=-1.D0
      BC(NSIZE,NSIZE)=0.D0

C     Solve System of Linear Equations
      CALL SOLVE(BC,MAXDIS+1,NSIZE,VC)
C     Compute Interpolated Coefficient Vectors
      CALL AZZERO(C0,2*NGW*NSTATE)
      DO I=1,NSIZE-1
        CALL SDCOPY(NGW*NSTATE,PME(1,I),C2)
        CALL DAXPY(2*NGW*NSTATE,VC(I),C2(1,1),1,C0(1,1),1)
      ENDDO
C     Estimate New Parameter Vectors 


      DO I=1,NSIZE-1
         CALL IDCOPY(NGW*NSTATE,C2,GDE(1,I),GRMAX(I),GIMAX(I))
         call precon_p(c2,c2,vpp,nstate,z11,1)
         call DAXPY(2*nstate*ngw,-vc(i),c2,1,c0,1)
      ENDDO
      EOLD=ETOT

      CALL TIHALT('   ODIIS_P',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE UPDIS_P(NDIIS,NOWV,NSIZE,MDIIS,IACT)
C     ==--------------------------------------------------------------==
C     == Update variables for DIIS if IACT=1                          ==
C     == Set to 0                  if IACT/=1                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NDIIS,NOWV,NSIZE,MDIIS,IACT
C     ==--------------------------------------------------------------==
      IF(IACT.EQ.1) THEN
        NOWV=MOD(NDIIS,MDIIS)+1
        NDIIS=NDIIS+1
        NSIZE=NDIIS+1
        IF(NSIZE.GT.MDIIS) NSIZE=MDIIS+1
      ELSE
        NDIIS=0
        NOWV=0
        NSIZE=0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
