C     ==================================================================
      SUBROUTINE OHFD(C0,CM,CN,C2,SC0,VPP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'soft.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'store.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'andp.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      COMPLEX*16 C0(NGW,N),C2(NGW,N),CM(*),CN(*),SC0(NGW,*)
      REAL*8     VPP(*)
C     Variables
      DIMENSION  F(N),RIN0(*)
      REAL*8     EIGV(N),EIGP(N),EIGM(N),RHOP(*),RHOM(*)
      POINTER    (IP_EIGV,EIGV),(IP_RHOP,RHOP)
      POINTER    (IP_EIGM,EIGM),(IP_EIGP,EIGP),(IP_RHOM,RHOM)
      COMPLEX*16 PSI(*),CREF(*)
      REAL*8     RHOE(*),SCR(*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
      CHARACTER  TAG*30,FILEN*100
      REAL*8     EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2
      INTEGER    IREC(100),LSCR,IL_RHOE,IL_PSI,IFCALC,KNFI,MSGLEN,NNX
      INTEGER    J,I,II,III
      LOGICAL    FERROR
      REAL*8     HMAT(N,N)
      POINTER    (IP_HMAT,HMAT),(IP_CREF,CREF)
C     ==================================================================
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
C     Memory for densities
      NNX=NNR1*NLSD
      CALL MEMORY(IP_RIN0,NNX,'RIN0')
      CALL MEMORY(IP_ROUT0,NNX,'ROUT0')
      CALL MEMORY(IP_RMIX,NNX,'RMIX')
      CALL GET_ADDR(IP_RHOO,RIN0(1))
      CALL AZZERO(RIN0,NNX)
      CALL AZZERO(ROUT0,NNX)
      CALL AZZERO(RMIX,NNX)
      CALL MEMORY(IP_RHOP,NNX,'RHOP')
      CALL MEMORY(IP_RHOM,NNX,'RHOM')
      CALL MEMORY(IP_CREF,2*NGW*N,'CREF')
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
      CALL MEMORY(IP_EIGV,N,'EIGV')
      CALL MEMORY(IP_EIGP,N,'EIGP')
      CALL MEMORY(IP_EIGM,N,'EIGM')
      CALL MEMORY(IP_HMAT,N*N,'HMAT')
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL GIVE_SCR_OHFD(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
C     ==--------------------------------------------------------------==
C     == INITIALISATION                                               ==
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
C     Set IREC to restart file.
      CALL READ_IREC(IREC)
C     INITIALIZATION OF WAVEFUNCTION AND COORDINATES
      CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
      CALL WRITE_IREC(IREC)
C     ==--------------------------------------------------------------==
      CALL PHFAC(TAU0)
      IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,CALSTE)
      IF(TIVAN) THEN
        CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.FALSE.)
      ENDIF
      IF(IREC(IREC_RHO).EQ.0) THEN
        CALL RHOOFR(C0,RHOE,PSI,SCR,LSCR,N)
        CALL DCOPY(NNX,RHOE,1,RIN0,1)
      ENDIF
      IF(PARENT) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T25,A,T64,"==")')
     &       '   REFERENCE POINT'
        WRITE(6,'(1X,64("="))')
      ENDIF
      IFCALC=0
      CALL FORCES_DIAG(N,C0,C2,CM,SC0,CN,VPP,EIGV,
     &                 RHOE,PSI,SCR,LSCR,
     &                 TAU0,VELP,TAUP,FION,IFCALC,
     &                 IREC,.FALSE.,.TRUE.)
      CALL DCOPY(2*NGW*N,C0,1,CREF,1)
      CALL ZHWWF(2,IREC,C0,C2,N,EIGV,TAU0,TAU0,TAU0,NFI)
C..transform to canonical orbitals and get eigenvalues
      CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *             N,1,.FALSE.,.FALSE.)
      CALL CANON(C0,C2,F,N,EIGV,SCR,LSCR)
      IF(PARENT) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T20,A,T64,"==")')
     &       'END OF REFERENCE CALCULATION'
        WRITE(6,'(1X,64("="),/)')
      ENDIF
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
C     Open the FINDIF file
      FILEN='FINDIF'
      CALL FILEOPEN(24,FILEN,FO_DEF,FERROR)
      IF(ROH) REWIND(24)
C     ==================================================================
C     ==   LOOP OVER ORBITAL OCCUPATIONS                              ==
C     ==================================================================
      IF(PARENT) THEN
        WRITE(6,'(/," ",22("*"),A,22("*"),/)') ' FINITE DIFFERENCES '
      ENDIF
      DO KNFI=1,N
        CALL MY_SYNC(ALLGRP)
        IF(PARENT) WRITE(6,
     &    '(" **** STATE=",I7,T24,A,F12.6,T54,A,F7.5)')
     &      KNFI,'EIGVAL(a.u.)=',EIGV(KNFI),'DISP=',FDIFF
        IF(ROH.AND.PARENT) THEN
          READ(24,FMT=*,END=300)
          READ(24,*) (HMAT(I,KNFI),I=1,N)
          GOTO 301
  300     CONTINUE
          ROH=.FALSE.
        ENDIF
  301   CONTINUE
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(ROH,MSGLEN,SOURCE,ALLGRP)
        IF(.NOT.ROH) THEN
          F(KNFI)=F(KNFI)+FDIFF
          IFCALC=0
          CALL DCOPY(NNX,RHOE,1,RHOP,1)
          CALL DCOPY(2*NGW*N,CREF,1,C0,1)
          CALL FORCES_DIAG(N,C0,C2,CM,SC0,CN,VPP,EIGP,
     &                     RHOP,PSI,SCR,LSCR,
     &                     TAU0,VELP,TAUP,FION,IFCALC,
     &                     IREC,.FALSE.,.FALSE.)
          CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGP,SCR,LSCR,
     &                 N,1,.FALSE.,.FALSE.)
          CALL CANON(C0,C2,F,N,EIGP,SCR,LSCR)
          IF(EXSOFT) GOTO 100
          IF(PARENT) WRITE(6,
     &      '(" **** STATE=",I7,T24,A,F12.6,T54,A,F7.5)')
     &        KNFI,'EIGVAL(a.u.)=',EIGV(KNFI),'DISP=',-FDIFF
          F(KNFI)=F(KNFI)-2.D0*FDIFF
          IFCALC=0
          CALL DCOPY(NNX,RHOE,1,RHOM,1)
          CALL DCOPY(2*NGW*N,CREF,1,C0,1)
          CALL FORCES_DIAG(N,C0,C2,CM,SC0,CN,VPP,EIGM,
     &                     RHOM,PSI,SCR,LSCR,
     &                     TAU0,VELP,TAUP,FION,IFCALC,
     &                     IREC,.FALSE.,.FALSE.)
          CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGM,SCR,LSCR,
     &                 N,1,.FALSE.,.FALSE.)
          CALL CANON(C0,C2,F,N,EIGM,SCR,LSCR)
          F(KNFI)=F(KNFI)+FDIFF
          DO I=1,N
            HMAT(I,KNFI)=0.5D0*(EIGP(I)-EIGM(I))/(2.D0*FDIFF)
          ENDDO
          IF(PARENT) THEN
            WRITE(24,'(I10,1PE20.10)') KNFI,FDIFF
            WRITE(24,*) (HMAT(I,KNFI),I=1,N)
            CALL MY_FLUSH(24)
          ENDIF
        ENDIF
        IF(EXSOFT) GOTO 100
C     ==================================================================
C     ==     END OF MAIN LOOP                                         ==
C     ==================================================================
      ENDDO
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(/,A,A)')
     *     ' *********************** ORBITAL HARDNESS',
     *     ' ***********************'
        WRITE(6,*)
        DO I=1,N,8
          II=MIN(8,N-I+1)
          WRITE(6,'(6X,8I8)') (III,III=I,I+II-1)
          DO J=1,N
            WRITE(6,'(I6,8F8.3)') J,(HMAT(J,III),III=I,I+II-1)
          ENDDO
        ENDDO
        WRITE(6,'(A,A)')
     *     ' ****************************************',
     *     '************************'
        WRITE(6,*)
        CALL FILEOPEN(20,'HARDNESS',FO_DEF,FERROR)
        DO I=1,N
          WRITE(20,*) (HMAT(I,J),J=1,N)
        ENDDO
        CALL FILECLOSE(20)
      ENDIF
C     ==--------------------------------------------------------------==
  100 CONTINUE
      IF(PARENT) CALL FILECLOSE(24)
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_TAUP)
      CALL FREEM(IP_FION)
      CALL FREEM(IP_RIN0)
      CALL FREEM(IP_ROUT0)
      CALL FREEM(IP_RMIX)
      CALL FREEM(IP_CREF)
      CALL FREEM(IP_RHOP)
      CALL FREEM(IP_RHOM)
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
      CALL FREEM(IP_HMAT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_OHFD(LOHFD,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !pslo.inc
      INCLUDE 'elct.inc'        !N number of states
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'pslo.inc'        !TIVAN
C     Arguments
      INTEGER   LOHFD
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LRINITWF,LRNLSM,LRHOOFR,LCOPOT,LFORCES_DIAG,
     *          LCANON
C     ==--------------------------------------------------------------==
      NSTATE=N
      LRNLSM=0
      LCOPOT=0
      CALL GIVE_SCR_RINITWF(LRINITWF,TAG,NSTATE)
      IF(TIVAN) CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
      CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
      CALL GIVE_SCR_FORCES_DIAG(LFORCES_DIAG,TAG,NSTATE,.TRUE.)
      CALL GIVE_SCR_CANON(LCANON,TAG,NSTATE)
      IF(TINLC) CALL GIVE_SCR_COPOT(LCOPOT,TAG)
      LOHFD=MAX(LRINITWF,LRNLSM,LRHOOFR,LFORCES_DIAG,LCOPOT,LCANON)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
