C     ==================================================================
      SUBROUTINE OHLR(C0,C1,C2,SC0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'soft.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'store.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      COMPLEX*16 C0(NGW,*),C2(NGW,*),C1(NGW,*),SC0(*)
C     Variables
      DIMENSION  F(N)
      REAL*8     EIGV(*),RHO1(*)
      POINTER    (IP_EIGV,EIGV),(IP_RHO1,RHO1)
      COMPLEX*16 PSI(*),FHK(*)
      REAL*8     RHOE(*),SCR(*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR),(IP_FHK,FHK)
      CHARACTER  TAG*30,FILEN*100
      INTEGER    IREC(100),LSCR,MSGLEN
      INTEGER    IL_RHOE,IL_PSI,LIST(2,*),LISTST(*)
      REAL*8     HMAT(N,N),HNSC(N,N),HMATE(N,N,N,N),HNSCE(N,N,N,N)
      REAL*8     TVEC(N),TVECE(N,N)
      REAL*8     CENTER(*)
      POINTER    (IP_LIST,LIST),(IP_CENTER,CENTER)
      POINTER    (IP_HMAT,HMAT),(IP_HNSC,HNSC)
      POINTER    (IP_TVEC,TVEC),(IP_TVECE,TVECE)
      POINTER    (IP_HMATE,HMATE),(IP_HNSCE,HNSCE)
      POINTER    (IP_VPP,VPP),(IP_GDE,GDE),(IP_PME,PME)
      POINTER    (IP_DDXC,DDXC),(IP_FONE,FONE)
      POINTER    (IP_H1NL,H1NL),(IP_LISTST,LISTST)
      REAL*8     VPP(*),GDE(*),PME(*),DDXC(*),FONE(*)
      COMPLEX*16 H1NL(NGW,*)
      INTEGER    NVPP,NGDE,NPME,KNFW,I,J,II,III,LDDXC,IG,IG1,IS,IK,K,L
      INTEGER    KST,KK,JJ,IDAMIN
      LOGICAL    FERROR
      REAL*8     TCPU,TIME1,TIME2,DETOT,TIMEF,ETOTO,THL(2),G2,E2(2)
      REAL*8     EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2
      REAL*8     EIND,TRACE,VP,DASUM,DOTP,EDUMMY,CD(3),CREF(3)
      DIMENSION  RHOO(*),POTR(*)
      EXTERNAL   DOTP,DASUM,TIMEF
C     ==================================================================
      TSYMRHO=.FALSE.
      EDUMMY=0.D0
C..input for linear response
      CALL LR_IN
C
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
C     Memory for densities
      CALL MEMORY(IP_RHO1,NNR1,'RHO1')
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
      CALL MEMORY(IP_LISTST,N,'LISTST')
      IF(LOCAL_ORB) THEN
        CALL MEMORY(IP_EIGV,N*N,'EIGV')
      ELSE
        CALL MEMORY(IP_EIGV,N,'EIGV')
      ENDIF
      CALL MEMORY(IP_FONE,N,'FONE')
      CALL MEMORY(IP_FHK,NNR1*NLSD,'FONE')
      IF(DIAGONAL) THEN
        CALL MEMORY(IP_HMAT,N*N,'HMAT')
        CALL MEMORY(IP_HNSC,N*N,'HNSC')
        CALL MEMORY(IP_TVEC,N,'TVEC')
        CALL AZZERO(HMAT,N*N)
        CALL AZZERO(HNSC,N*N)
        CALL AZZERO(TVEC,N)
      ELSE
        CALL MEMORY(IP_LIST,2*N*N,'LIST')
        CALL MEMORY(IP_HMATE,N*N*N*N,'HMATE')
        CALL MEMORY(IP_HNSCE,N*N*N*N,'HNSCE')
        CALL MEMORY(IP_TVECE,N*N,'TVECE')
        CALL AZZERO(HMATE,N*N*N*N)
        CALL AZZERO(HNSCE,N*N*N*N)
        CALL AZZERO(TVECE,N*N)
        II=0
        DO I=1,N
          DO J=I,N
            II=II+1
            LIST(1,II)=I
            LIST(2,II)=J
          ENDDO
        ENDDO
      ENDIF
      DO I=1,N
        FONE(I)=1.D0
      ENDDO
C     ==--------------------------------------------------------------==
      IF(TLSD.AND.PARENT) CALL STOPGM('OHLR','LSD not implemented')
      CALL MEMORY(IP_H1NL,2*NGWK*N,'H1NL')
      IF(TXC_ANALYTIC) THEN
        LDDXC=NNR1*(2*NLSD-1)
      ELSEIF(LOPTI.EQ.0.OR.LOPTI.EQ.2) THEN
        LDDXC=NNR1*(2*NLSD-1)
      ELSE
        LDDXC=1
      ENDIF
      CALL MEMORY(IP_DDXC,LDDXC,'DDXC')
      IF(PS_TYPE.EQ.1) CALL STOPGM('OHLR','HOCKNEY PS not impl.')
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL GIVE_SCR_OHLR(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
C
      CALL MEMORY(IP_RHOO,IL_RHOE,'RHOO')
      CALL MEMORY(IP_POTR,IL_RHOE,'POTR')
C     ==--------------------------------------------------------------==
C     == INITIALISATION                                               ==
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
C     Set IREC to restart file.
      CALL READ_IREC(IREC)
      CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
      CALL WRITE_IREC(IREC)
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T25,A,T64,"==")')
     &       '   REFERENCE POINT'
        WRITE(6,'(1X,64("="))')
      ENDIF
      CONVWF=.FALSE.
      SDIIS=.TRUE.
      SPCG=.TRUE.
      TIME1=TIMEF()
C..allocate additional memory for optimisers
      IF(TSDE) THEN
        NPME = 1
        NGDE = 1
        NVPP = 1
      ELSE IF(DIIS) THEN
        NPME = (NGW*N+8)*MDIIS
        NGDE = ((NGW*N+8)*MDIIS)/4
        NVPP = NGW
      ELSE IF(PCG) THEN
        NPME = 2*NGW*N
        NGDE = 1
        NVPP = NGW
      ELSEIF(PARENT) THEN
        WRITE(6,*) ' WRONG OPTION FOR WAVEFUNCTION OPTIMIZATION'
        CALL STOPGM('OHLR',' ')
      ENDIF
      CALL MEMORY(IP_PME,NPME,'PME')
      CALL MEMORY(IP_GDE,NGDE,'GDE')
      CALL MEMORY(IP_VPP,NVPP,'VPP')
      ETOTO=0.D0
      DO KNFW=1,NOMORE
C..UPDATE THE WAVEFUNCTIONS
        CALL UPDWF(C0,C2,SC0,TAU0,TAUP,PME,GDE,VPP,EIGV,
     *               RHOE,PSI,SCR,LSCR,N,.FALSE.,.TRUE.)
C..PRINTOUT THE EVOLUTION OF THE ITERATIVE OPTIMIZATION
        IF(PARENT) THEN
          DETOT=ETOT-ETOTO
          IF(KNFW.EQ.1) DETOT=0.0D0
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
          CALL WRPRINT_WFOPT(EIGV,F,AMU,N,ETOT,ETOTO,
     &         TCPU,GEMAX,CNORM,THL,ENGPRI,KNFW,KNFW)
          ETOTO=ETOT
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(CONVWF.OR.EXSOFT) GOTO 200
      ENDDO
      IF(PARENT) WRITE(6,*) ' NO CONVERGENCE IN ',KNFW,' STEPS '
      CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,KNFW)
      CALL STOPGM('OHLR',' ')
C     ==--------------------------------------------------------------==
  200 CONTINUE
C..release memory for ground state optimiser
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_PME)
      CALL FREEM(IP_GDE)
C..localise orbitals
      IF(LOCAL_ORB) CALL LOCALIZE(TAU0,C0,C2,SC0,SCR,LSCR,N)
C..calculate KS-Matrix 
      CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               N,1,.FALSE.,.FALSE.)
      TIME2=TIMEF()
      TCPU=(TIME2-TIME1)*0.001D0
      IF(PARENT) THEN
         WRITE(6,'(/,A,T46,F12.3,A)') ' TIME FOR MINIMUM STRUCTURE :',
     *               TCPU,' SECONDS'
        CALL WRENER
      ENDIF
      CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,NFI)
      IF(LOCAL_ORB) THEN
        CALL OVLAP(N,EIGV,C0,C2)
        CALL GLOSUM(N*N,EIGV)
      ELSE
C..transform to canonical orbitals and get eigenvalues
        CALL CANON(C0,C2,F,N,EIGV,SCR,LSCR)
C..recalculate FNL for transformed orbitals
C..we could also rotate the old ones, but this is easier
        CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.FALSE.)
      ENDIF
C..store potential and density
      CALL DCOPY(NNR1*NLSD,RHOE,1,POTR,1)
      CALL RHOOFR(C0,RHOE,PSI,SCR,LSCR,N)
      CALL DCOPY(NNR1*NLSD,RHOE,1,RHOO,1)
C..NLCC
      IF(TINLC) THEN
         CALL STOPGM("OHLR","NLCC not implemented")
      ENDIF
C..HK Potential estimate
      CALL VHK(RHOE,FHK,SCR,LSCR)
C..save FNL
      CALL FNL_SET("SAVE")
      CALL FNLALLOC(N,.FALSE.,.FALSE.)
C..calculate and store analytic dmu/dn
      CALL LR_XCPOT(DDXC,RHOO,SCR,LSCR,.FALSE.)
C     ==--------------------------------------------------------------==
C..define reference orbitals
      IF(NUMO.LT.0) THEN
C..all orbitals
        NUMO=N
        DO I=1,NUMO
          LISTST(I)=I
        ENDDO
      ELSE
        IF(REFAT.LT.0 .OR. .NOT.LOCAL_ORB) THEN
C..last numo orbitals in the list
          DO I=1,NUMO
            LISTST(I)=N-NUMO+I
          ENDDO
        ELSE
C..local orbitals
          CALL FILEOPEN(30,'WANNIER_CENTER',FO_OLD,FERROR)
          IF(FERROR) CALL STOPGM('OHLR','COULD NOT OPEN WANNIER_CENTER')
          REWIND(30)
          CALL MEMORY(IP_CENTER,N,'CENTER')
          CALL GETATM(REFAT,TAU0,CREF)
          DO I=1,N
            READ(30,*) J,CD(1),CD(2),CD(3)
            CD(1)=CD(1)-CREF(1)
            CD(2)=CD(2)-CREF(2)
            CD(3)=CD(3)-CREF(3)
            CALL PBC(CD(1),CD(2),CD(3),CD(1),CD(2),CD(3),1,APBC,IBRAV)
            CENTER(I)=CD(1)**2 + CD(2)**2 + CD(3)**2
          ENDDO
          DO I=1,NUMO
            J=IDAMIN(N,CENTER,1)
            LISTST(I)=J
            CENTER(J)=1.D30
          ENDDO
          CALL FILECLOSE(30)
          CALL FREEM(IP_CENTER)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T20,A,T64,"==")')
     &       'END OF REFERENCE CALCULATION'
        WRITE(6,'(1X,64("="),/)')
      ENDIF
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
C..get basis for density expansions
      CALL RHOBAS("INIT",RHOO,PSI)
      CALL RHOBAS("EXPAND",RHOO,PSI)
C..additional memory for optimisers
      NVPP = NGW
      IF(LOPTI.EQ.0) THEN
        NPME = MAX((NGW*N+8)*MDIIS,2*NGW*N)
        NPME = MAX(2*NGW*N*MLDIIS,NPME)
        NGDE = MAX(((NGW*N+8)*MDIIS)/4,1)
        NGDE = MAX(2*NGW*N*MLDIIS,NGDE)
      ELSE IF(LOPTI.EQ.1) THEN
        NPME = 1
        NGDE = 1
      ELSE IF(LOPTI.EQ.2) THEN
        NPME = 2*NGW*N
        NGDE = 1
      ELSE IF(LOPTI.EQ.3) THEN
        NPME = (NGW*N+8)*MDIIS
        NGDE = ((NGW*N+8)*MDIIS)/4
      ELSE
        IF(PARENT)
     *  WRITE(6,*) ' WRONG OPTION FOR LINEAR RESPONSE OPTIMIZATION'
        CALL STOPGM('OHLR',' ')
      ENDIF
      CALL MEMORY(IP_PME,NPME,'PME')
      CALL MEMORY(IP_GDE,NGDE,'GDE')
      CALL MEMORY(IP_VPP,NVPP,'VPP')
C..always use preconditioner
      PREC=.TRUE.
      CALL KSDIAG(VPP)
      TRACE=DASUM(N,EIGV,1)/DBLE(N)
      DO IG=1,NGW
        VP=VPP(IG)+TRACE
        VPP(IG)=ABS(VP/(VP**2+LR_HTHRS**2))
      ENDDO
C     Open the FINDIF file
      FILEN='FINDIF'
      IF(PARENT) CALL FILEOPEN(24,FILEN,FO_DEF,FERROR)
      IF(ROH) REWIND(24)
C..start linear response calculation
      IF(PARENT) THEN
        WRITE(6,'(/," ",23("*"),A,24("*"),/)') ' LINEAR RESPONSE '
      ENDIF
      IF(DIAGONAL) THEN
C..diagonal orbital hardness
        DO KST=1,NUMO
          IS=LISTST(KST)
          CALL MY_SYNC(ALLGRP)
          IF(PARENT) WRITE(6,'(" **** STATE=",I7)') IS
          IF(ROH.AND.PARENT) THEN
            READ(24,FMT=*,END=300)
            READ(24,*) TVEC(IS)
            READ(24,*) (HMAT(I,IS),I=1,N)
            GOTO 301
  300       CONTINUE
            ROH=.FALSE.
          ENDIF
  301     CONTINUE
          MSGLEN = 1 * 8/IRAT
          CALL MY_BCAST(ROH,MSGLEN,SOURCE,ALLGRP)
          IF(.NOT.ROH) THEN
C..linear response
C..calculate rho(i)
            CALL RHOSOFR(C0(1,IS),RHO1,PSI)
C..calculate EH(2) + EXC(2) for the state density
C..on output RHO1 is the associated potential
            CALL V1OFRHO1(E2,RHO1,DDXC,PSI,SCR,LSCR)
            EIND=E2(1)+E2(2)
C..apply this potential to the ground state functions
            CALL ZAZZERO(H1NL,NGW*N)
            CALL VPSIMT(C0,H1NL,F,RHO1,PSI,N,NLSD,.FALSE.)
C..calculate first order wavefunction
            SDIIS=.TRUE.
            SPCG=.TRUE.
            IF(LOCAL_ORB) THEN
              CALL OPT_LR(C0,C1,C2,SC0,EIND,EIGV,RHOE,
     &                  H1NL,EDUMMY,EDUMMY,DDXC,VPP,PME,GDE,
     &                  PSI,SCR,LSCR,N,"ORBHARD","LOCAL")
            ELSE
              CALL OPT_LR(C0,C1,C2,SC0,EIND,EIGV,RHOE,
     &                  H1NL,EDUMMY,EDUMMY,DDXC,VPP,PME,GDE,
     &                  PSI,SCR,LSCR,N,"ORBHARD","CANON")
            ENDIF
C..calculate first order density
            CALL RHO1OFR(C0,C1,F,RHOE,PSI,N)
            CALL TSUMHK(FHK,RHOE,TVEC(IS))
            CALL RHOBAS("EXPAND",RHOE,PSI)
            CALL V1OFRHO1(E2,RHOE,DDXC,PSI,SCR,LSCR)
            CALL ZAZZERO(C2,NGW*N)
            CALL VPSIMT(C0,C2,FONE,RHOE,PSI,N,NLSD,.FALSE.)
            DO J=1,NUMO
              I=LISTST(J)
              HNSC(I,IS)=-0.5D0*DOTP(NGW,C0(1,I),H1NL(1,I))/F(I)
              HMAT(I,IS)=-0.5D0*DOTP(NGW,C0(1,I),C2(1,I))
              HMAT(I,IS)=HMAT(I,IS)+HNSC(I,IS)
            ENDDO
            CALL GLOSUM(N,HNSC(1,IS))
            CALL GLOSUM(N,HMAT(1,IS))
C..end of the response part
            IF(PARENT) THEN
              WRITE(24,'(I10)') IS
              WRITE(24,*) TVEC(IS)
              WRITE(24,*) (HMAT(I,IS),I=1,N)
              CALL MY_FLUSH(24)
            ENDIF
          ENDIF
          IF(EXSOFT) GOTO 100
        ENDDO
      ELSE
C..extended orbital hardness
        DO KST=1,NUMO
          DO KK=KST,NUMO
            IS=LISTST(KST)
            IK=LISTST(KK)
            CALL MY_SYNC(ALLGRP)
            IF(PARENT) WRITE(6,'(" **** STATES=",I7,I7)') IS,IK
            IF(ROH.AND.PARENT) THEN
              READ(24,FMT=*,END=500)
              READ(24,*) TVECE(IS,IK)
              READ(24,*) ((HMATE(I,J,IS,IK),I=1,N),J=1,N)
              GOTO 501
  500         CONTINUE
              ROH=.FALSE.
            ENDIF
  501       CONTINUE
            MSGLEN = 1 * 8/IRAT
            CALL MY_BCAST(ROH,MSGLEN,SOURCE,ALLGRP)
            IF(.NOT.ROH) THEN
C..linear response
C..calculate rho(i)
              CALL AZZERO(RHO1,NNR1)
              CALL RHOABOFR(1,C0(1,IS),C0(1,IK),RHO1,PSI)
C..calculate EH(2) + EXC(2) for the state density
C..on output RHO1 is the associated potential
              CALL V1OFRHO1(E2,RHO1,DDXC,PSI,SCR,LSCR)
              EIND=E2(1)+E2(2)
C..apply this potential to the ground state functions
              CALL ZAZZERO(H1NL,NGW*N)
              CALL VPSIMT(C0,H1NL,F,RHO1,PSI,N,NLSD,.FALSE.)
C..calculate first order wavefunction
              SDIIS=.TRUE.
              SPCG=.TRUE.
              IF(LOCAL_ORB) THEN
                CALL OPT_LR(C0,C1,C2,SC0,EIND,EIGV,RHOE,
     &                    H1NL,EDUMMY,EDUMMY,DDXC,VPP,PME,GDE,
     &                    PSI,SCR,LSCR,N,"ORBHARD","LOCAL")
              ELSE
                CALL OPT_LR(C0,C1,C2,SC0,EIND,EIGV,RHOE,
     &                    H1NL,EDUMMY,EDUMMY,DDXC,VPP,PME,GDE,
     &                    PSI,SCR,LSCR,N,"ORBHARD","CANON")
              ENDIF
C..calculate first order density
              CALL RHO1OFR(C0,C1,F,RHOE,PSI,N)
              CALL TSUMHK(FHK,RHOE,TVECE(IS,IK))
              CALL RHOBAS("EXPAND",RHOE,PSI)
              CALL V1OFRHO1(E2,RHOE,DDXC,PSI,SCR,LSCR)
              CALL ZAZZERO(C2,NGW*N)
              CALL VPSIMT(C0,C2,FONE,RHOE,PSI,N,NLSD,.FALSE.)
              DO II=1,NUMO
                DO JJ=II,NUMO
                  I=LISTST(II)
                  J=LISTST(JJ)
                  HNSCE(I,J,IS,IK)=-0.5D0*DOTP(NGW,C0(1,J),
     &                             H1NL(1,I))/F(I)
                  HMATE(I,J,IS,IK)=-0.5D0*DOTP(NGW,C0(1,J),C2(1,I))
                  HMATE(I,J,IS,IK)=HMATE(I,J,IS,IK)+HNSCE(I,J,IS,IK)
                ENDDO
              ENDDO
              CALL GLOSUM(N*N,HNSCE(1,1,IS,IK))
              CALL GLOSUM(N*N,HMATE(1,1,IS,IK))
C..end of the response part
              IF(PARENT) THEN
                WRITE(24,'(2I10)') IS,IK
                WRITE(24,*) TVECE(IS,IK)
                WRITE(24,*) ((HMATE(I,J,IS,IK),I=1,N),J=1,N)
                CALL MY_FLUSH(24)
              ENDIF
            ENDIF
            IF(EXSOFT) GOTO 100
          ENDDO
        ENDDO
      ENDIF
      CALL RHOBAS("FREE",RHOO,PSI)
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(/,A,A)')
     *     ' *********************** ORBITAL HARDNESS',
     *     ' ***********************'
        IF(DIAGONAL) THEN
          WRITE(6,*)
          DO I=1,NUMO,8
            II=MIN(8,NUMO-I+1)
            WRITE(6,'(6X,8I8)') (LISTST(III),III=I,I+II-1)
            DO J=1,NUMO
              WRITE(6,'(I6,8F8.3)') LISTST(J),
     *          (HMAT(LISTST(J),LISTST(III)),III=I,I+II-1)
            ENDDO
          ENDDO
        ELSE
          WRITE(6,*)
          DO K=1,(NUMO*(NUMO+1))/2,8
            L=MIN(8,(NUMO*(NUMO+1))/2-K+1)
            WRITE(6,'(9X,8(I4,I3))') 
     *           (LISTST(LIST(1,II)),LISTST(LIST(2,II)),II=K,K+L-1)
            DO I=1,NUMO
              DO J=I,NUMO
                WRITE(6,'(1X,2I4,8F7.3)') 
     *             LISTST(I),LISTST(J),
     *             (HMATE(LISTST(I),LISTST(J),
     *              LISTST(LIST(1,II)),LISTST(LIST(2,II))),II=K,K+L-1)
              ENDDO
            ENDDO
          ENDDO
        ENDIF
        WRITE(6,'(A,A)')
     *     ' ****************************************',
     *     '************************'
        IF(DIAGONAL) THEN
          WRITE(6,*)
          CALL FILEOPEN(20,'HARDNESS',FO_DEF,FERROR)
          DO I=1,NUMO
            WRITE(20,*) (HMAT(LISTST(I),LISTST(J)),J=1,NUMO)
          ENDDO
          CALL FILECLOSE(20)
          WRITE(6,'(A)')' Hardness in frozen wavefunction approximation'
          DO I=1,NUMO,8
            II=MIN(8,NUMO-I+1)
            WRITE(6,'(6X,8I8)') (LISTST(III),III=I,I+II-1)
            DO J=1,NUMO
              WRITE(6,'(I6,8F8.3)') LISTST(J),
     *          (HNSC(LISTST(J),LISTST(III)),III=I,I+II-1)
            ENDDO
          ENDDO
        ELSE
          WRITE(6,*)
          CALL FILEOPEN(20,'HARDNESS',FO_DEF,FERROR)
          DO I=1,NUMO
            DO J=I,NUMO
              WRITE(20,*) (HNSCE(LISTST(I),LISTST(J),
     *          LISTST(LIST(1,K)),LISTST(LIST(2,K))),
     *          K=1,(NUMO*(NUMO+1))/2)
            ENDDO
          ENDDO
          CALL FILECLOSE(20)
          DO K=1,(NUMO*(NUMO+1))/2,8
            L=MIN(8,(NUMO*(NUMO+1))/2-K+1)
            WRITE(6,'(9X,8(I4,I3))') 
     *           (LISTST(LIST(1,II)),LISTST(LIST(2,II)),II=K,K+L-1)
            DO I=1,NUMO
              DO J=I,NUMO
                WRITE(6,'(1X,2I4,8F7.3)') LISTST(I),LISTST(J),
     *            (HNSCE(LISTST(I),LISTST(J),
     *             LISTST(LIST(1,II)),LISTST(LIST(2,II))),II=K,K+L-1)
              ENDDO
            ENDDO
          ENDDO
        ENDIF
        WRITE(6,'(A,A)')
     *     ' ****************************************',
     *     '************************'
        IF(DIAGONAL) THEN
          WRITE(6,*) ' Hohenberg-Kohn Term '
          DO I=1,NUMO
            WRITE(6,'(I6,10X,F8.3)') LISTST(I),TVEC(LISTST(I))
          ENDDO
        ELSE
          WRITE(6,*) ' Hohenberg-Kohn Term '
          DO I=1,NUMO
            DO J=1,NUMO
              WRITE(6,'(2I6,10X,F8.3)') LISTST(I),LISTST(J),
     *                                  TVECE(LISTST(I),LISTST(J))
            ENDDO
          ENDDO
        ENDIF
        WRITE(6,'(A,A)')
     *     ' ****************************************',
     *     '************************'
      ENDIF
C     ==--------------------------------------------------------------==
  100 CONTINUE
      IF(PARENT) CALL FILECLOSE(24)
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_TAUP)
      CALL FREEM(IP_FION)
      CALL FREEM(IP_LISTST)
      CALL FREEM(IP_RHO1)
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
      CALL FREEM(IP_FHK)
      IF(DIAGONAL) THEN
        CALL FREEM(IP_HMAT)
        CALL FREEM(IP_HNSC)
        CALL FREEM(IP_TVEC)
      ELSE
        CALL FREEM(IP_LIST)
        CALL FREEM(IP_HMATE)
        CALL FREEM(IP_HNSCE)
        CALL FREEM(IP_TVECE)
      ENDIF
      CALL FREEM(IP_H1NL)
      CALL FREEM(IP_FONE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_OHLR(LOHLR,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        
      INCLUDE 'elct.inc'        !N number of states
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER   LOHLR
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LINITRUN,LUPDWF,LRHOOFR,LFORCES,LCANON,LRNLSM,
     *          LV1OFRHO1,LOPT_LR,LDDIPO,LVHK
C     ==--------------------------------------------------------------==
      NSTATE=N
      CALL GIVE_SCR_INITRUN(LINITRUN,TAG)
      CALL GIVE_SCR_UPDWF(LUPDWF,TAG,NSTATE,.FALSE.)
      CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
      CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.FALSE.,.FALSE.)
      CALL GIVE_SCR_CANON(LCANON,TAG,NSTATE)
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
      CALL GIVE_SCR_V1OFRHO1(LV1OFRHO1,TAG)
      CALL GIVE_SCR_OPT_LR(LOPT_LR,"ORBHARD",TAG)
      CALL GIVE_SCR_VHK(LVHK,TAG)
      IF(LOCAL_ORB)  THEN
        CALL GIVE_SCR_DDIPO(LDDIPO,TAG)
        LDDIPO=MAX(2*NHG,LDDIPO)
      ELSE
        LDDIPO=0
      ENDIF
C
      LOHLR=MAX(LINITRUN,LUPDWF,LRHOOFR,LFORCES,LCANON,LRNLSM,
     *          LV1OFRHO1,LOPT_LR,LDDIPO,LVHK)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RHOBAS(TAG,RHOE,PSI)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        
      INCLUDE 'elct.inc'
      INCLUDE 'atom.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      CHARACTER*(*) TAG
      COMPLEX*16 PSI(*)
      REAL*8     RHOE(*)
C     Variables
      REAL*8 FOC(20),SDTOT
      COMPLEX*16 RHO1G(*)
      INTEGER IS,IA,IAT,IAORB,NATST,I,INFO,IR,IG,NNRS,J,IPIV(*)
      LOGICAL FERROR
      DIMENSION  CATOM(NHG,NATTOT),F(*)
      REAL*8     FNL(*),DFNL(*),SDC(*),DOTP,RHOVAL,FXMAT(NATTOT+1,*)
      POINTER (IP_SDC,SDC),(IP_RHO1G,RHO1G),(IP_FXMAT,FXMAT)
      POINTER (IP_IPIV,IPIV)
      SAVE IP_SDC,IP_RHO1G,IP_FXMAT,IP_IPIV
      EXTERNAL   DOTP
C     ==--------------------------------------------------------------==
      IF(INDEX(TAG,"INIT").NE.0) THEN
        CALL RTOG(1)
        CALL MEMORY(IP_XSMAT,NATTOT*NATTOT,'XSMAT')
        CALL MEMORY(IP_FXMAT,(NATTOT+1)*(NATTOT+1),'XXMAT')
        CALL MEMORY(IP_CATOM,2*NHG*NATTOT,'CATOM')
        CALL MEMORY(IP_RHO1G,2*NHG,'RHO1G')
        CALL MEMORY(IP_SDC,NATTOT+1,'SDC')
        CALL MEMORY(IP_IPIV,NATTOT+1,'IPIV')
C..Load AO in PW basis
        IAORB=1
        IAT=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IAT=IAT+1
            CALL LOADC(CATOM(1,IAORB),FOC,NHG,NHG,NATTOT,IS,IAT,NATST)
            IAORB=IAORB+NATST
          ENDDO
        ENDDO
C..Overlap matrix
        CALL DSYRK('U','T',NATTOT,2*NHG,2.D0,CATOM,2*NHG,
     *             0.D0,XSMAT,NATTOT)
        CALL DMATC('U',NATTOT,XSMAT,NATTOT)
        IF(GEQ0)
     *    CALL DGER(NATTOT,NATTOT,-1.0D0,CATOM,2*NHG,CATOM,2*NHG,
     *              XSMAT,NATTOT)
        CALL GLOSUM(NATTOT*NATTOT,XSMAT)
        IF(PARENT) CALL FILEOPEN(22,'DENRHO',FO_DEF,FERROR)
      ELSEIF(INDEX(TAG,"EXPAND").NE.0) THEN
        CALL AZZERO(FXMAT,(NATTOT+1)*(NATTOT+1))
        CALL AZZERO(SDC,NATTOT+1)
        DO I=1,NATTOT
          CALL DCOPY(NATTOT,XSMAT(1,I),1,FXMAT(1,I),1)
          IF(GEQ0) SDC(I)=SQRT(OMEGA)*DREAL(CATOM(1,I))
        ENDDO
        CALL GLOSUM(NATTOT,SDC)
        SDTOT=0.D0
        DO I=1,NATTOT
          FXMAT(I,NATTOT+1)=SDC(I)
          FXMAT(NATTOT+1,I)=SDC(I)
          SDTOT=SDTOT+ABS(SDC(I))
        ENDDO
        CALL ZAZZERO(PSI,MAXFFT)
        RHOVAL=0.D0
        DO IR=1,NNR1
          PSI(IR)=DCMPLX(RHOE(IR),0.D0)
          RHOVAL=RHOVAL+RHOE(IR)
        ENDDO
        CALL GLOSUM(1,RHOVAL)
        NNRS=NR1S*NR2S*NR3S
        RHOVAL=RHOVAL*OMEGA/DBLE(NNRS)
        CALL FWFFT(PSI)
        DO IG=1,NHG
          RHO1G(IG) = PSI(NZH(IG))
        ENDDO
        DO I=1,NATTOT
          SDC(I)=SQRT(OMEGA)*DOTP(NHG,CATOM(1,I),RHO1G)
        ENDDO
        SDC(NATTOT+1)=RHOVAL
        CALL GLOSUM(NATTOT,SDC)
        IF(PARENT) THEN
          IF(SDTOT.LT.1.D-10) THEN
            IF(RHOVAL.GT.1.D-6) THEN
              WRITE(6,*) 
     *          ' WARNING| BASIS FN INTEGRAL IS ZERO, CHARGE NOT'
              CALL AZZERO(SDC,NATTOT+1)
            ELSE
              CALL DGESV(NATTOT,1,FXMAT,NATTOT+1,IPIV,SDC,NATTOT+1,INFO)
              IF(INFO.NE.0) CALL STOPGM('RHOBAS','INFO 1 /= DGESV')
            ENDIF
          ELSE
            CALL DGESV(NATTOT+1,1,FXMAT,NATTOT+1,IPIV,SDC,NATTOT+1,INFO)
            IF(INFO.NE.0) CALL STOPGM('RHOBAS','INFO 2 /= DGESV')
          ENDIF
          WRITE(22,*) (SDC(I),I=1,NATTOT)
        ENDIF
      ELSEIF(INDEX(TAG,"FREE").NE.0) THEN
        CALL FREEM(IP_XSMAT)
        CALL FREEM(IP_FXMAT)
        CALL FREEM(IP_CATOM)
        CALL FREEM(IP_RHO1G)
        CALL FREEM(IP_SDC)
        CALL FREEM(IP_IPIV)
        CALL FILECLOSE(22)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TSUMHK(FHK,RHOE,TVEC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        
      INCLUDE 'spin.inc'
      REAL*8 FHK(NNR1,*),RHOE(NNR1,*),TVEC
      INTEGER IR
C     ==--------------------------------------------------------------==
      TVEC=0.D0
      DO IR=1,NNR1
        TVEC=TVEC+FHK(IR,1)*RHOE(IR,1)
      ENDDO
      IF(TLSD) THEN
        DO IR=1,NNR1
          TVEC=TVEC+FHK(IR,2)*RHOE(IR,2)
        ENDDO
      ENDIF
      CALL GLOSUM(1,TVEC)
      TVEC=TVEC*OMEGA/DBLE(NNR1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
