C     ==================================================================
      SUBROUTINE OPEIGR(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,DDMAT,
     *                  SCR,LSCR,NOP1,NOP2,DD)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'spin.inc'
      include 'ddip.inc'
C     Arguments
      INTEGER    NSTATE,MAPFUL(*),MAPCOL(*),LSCR,NOP1,NOP2
      COMPLEX*16 C0(*),C2(*),SC0(*),SCR(*),DDMAT(*),DD
C     Variables
      COMPLEX*16 DDS
      INTEGER    ISUB,LENGTH
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      CALL TISET('    OPEIGR',ISUB)
      CALL GIVE_SCR_OPEIGR(LENGTH,TAG,NSTATE)
      CALL TEST_SCR('OPEIGR','LENGTH',LSCR,LENGTH)
      CALL ZAZZERO(DDMAT,NSTATE*NSTATE)
#ifdef PARALLEL
      IF(LENBK.LE.0) CALL STOPGM('OPEIGR','PARALLEL DIPOLE DYNAMICS '
     &    // 'NOT CORRECTLY PROGRAMMED FOR THIS JOB TYPE.')
      CALL OPEIGR_PARA(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,DDMAT,
     *                 SCR,NOP1,NOP2)
#else
      CALL OPEIGR_SERI(C0,C2,NSTATE,MAPFUL,DDMAT,SCR,NOP1,NOP2)
#endif
      IF(NOP2.EQ.0) THEN
        CALL DCOPY(2*NSTATE*NSTATE,DDMAT,1,SCR,1)
        CALL DETERM(SCR,NSTATE,NSTATE,C2,NGW*NSTATE,DD)
        IF(TLSE) THEN
          CALL DCOPY(2*NSTATE*NSTATE,DDMAT,1,SCR,1)
          CALL DETERM(SCR,NSTATE,NSTATE-2,C2,NGW*NSTATE,DDS)
          DD=DD*DDS
        ENDIF
      ELSE
        DD=DCMPLX(0.0D0,0.0D0)
      ENDIF
      CALL TIHALT('    OPEIGR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE OPEIGR_SERI(C0,C2,NSTATE,MAPFUL,DDMAT,SCR,NOP1,NOP2)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'spin.inc'
      include 'ddip.inc'
C     Arguments
      INTEGER    NSTATE,MAPFUL(2,*),NOP1,NOP2
      COMPLEX*16 C0(NGW,*),C2(NGW,*),SCR(*),DDMAT(NSTATE,*)
C     Variables
      INTEGER    I,IG
C     ==--------------------------------------------------------------==
      DO I=1,NSTATE
        CALL ZAZZERO(SCR,NGG1*NGG2*NGG3)
!$OMP parallel do private(IG)
        DO IG=1,NGWS
          SCR(MAPFUL(1,IG))=C0(IG,I)
          SCR(MAPFUL(2,IG))=DCONJG(C0(IG,I))
        ENDDO
        CALL OPAPP(SCR,NGG1,NGG2,NGG3,NOP1)
        CALL OPAPP(SCR,NGG1,NGG2,NGG3,NOP2)
!$OMP parallel do private(IG)
        DO IG=1,NGWS
          C2(IG,I)=SCR(MAPFUL(1,IG))
        ENDDO
      ENDDO
      IF(TLSD) THEN
        CALL ZGEMM('C','N',NSUP,NSUP,NGW,DCMPLX(1.D0,0.D0),C0,NGW,
     *             C2,NGW,DCMPLX(0.D0,0.D0),DDMAT,NSTATE)
        CALL ZGEMM('C','N',NSDOWN,NSDOWN,NGW,DCMPLX(1.D0,0.D0),
     *             C0(1,NSUP+1),NGW,C2(1,NSUP+1),NGW,
     *             DCMPLX(0.D0,0.D0),DDMAT(NSUP+1,NSUP+1),NSTATE)
      ELSE
        CALL ZGEMM('C','N',NSTATE,NSTATE,NGW,DCMPLX(1.D0,0.D0),C0,NGW,
     *             C2,NGW,DCMPLX(0.D0,0.D0),DDMAT,NSTATE)
      ENDIF
C
      DO I=1,NSTATE
        CALL ZAZZERO(SCR,NGG1*NGG2*NGG3)
!$OMP parallel do private(IG)
        DO IG=1,NGWS
          SCR(MAPFUL(1,IG))=C0(IG,I)
          SCR(MAPFUL(2,IG))=DCONJG(C0(IG,I))
        ENDDO
        CALL OPAPP(SCR,NGG1,NGG2,NGG3,NOP1)
        CALL OPAPP(SCR,NGG1,NGG2,NGG3,NOP2)
!$OMP parallel do private(IG)
        DO IG=1,NGWS
          C2(IG,I)=SCR(MAPFUL(2,IG))
        ENDDO
        C2(1,I)=DCMPLX(0.D0,0.D0)
      ENDDO
      IF(TLSD) THEN
        CALL ZGEMM('T','N',NSUP,NSUP,NGW,DCMPLX(1.D0,0.D0),C0,NGW,
     *             C2,NGW,DCMPLX(1.D0,0.D0),DDMAT,NSTATE)
        CALL ZGEMM('T','N',NSDOWN,NSDOWN,NGW,DCMPLX(1.D0,0.D0),
     *             C0(1,NSUP+1),NGW,C2(1,NSUP+1),NGW,
     *             DCMPLX(1.D0,0.D0),DDMAT(NSUP+1,NSUP+1),NSTATE)
      ELSE
        CALL ZGEMM('T','N',NSTATE,NSTATE,NGW,DCMPLX(1.D0,0.D0),C0,NGW,
     *             C2,NGW,DCMPLX(1.D0,0.D0),DDMAT,NSTATE)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE OPEIGR_PARA(C0,C2,SC0,NSTATE,MAPFUL,MAPCOL,DDMAT,
     *                       SCR,NOP1,NOP2)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'spin.inc'
      include 'ddip.inc'
C     Arguments
      INTEGER    NSTATE,MAPFUL(2,*),MAPCOL(NGWMAX,*),NOP1,NOP2
      COMPLEX*16 C0(NGW,*),C2(NGW,*),SC0(LENBK,*),SCR(*),
     *           DDMAT(NSTATE,*)
C     Variables
#ifdef PARALLEL
      COMPLEX*16 C2S(LENBK,*),C2F(NGWS,*),CTR(NGWS,*)
      POINTER    (IP_C2S,C2S),(IP_C2F,C2F),(IP_CTR,CTR)
      INTEGER    I,II,IG,IP,NN,N1,NGGP,IGII,NNST
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_C2F,C2)
      CALL GET_ADDR(IP_C2S,C2)
      NNST=NST12(MEPOS,2)-NST12(MEPOS,1)+1
      CALL MEMORY(IP_CTR,2*NGWS*NNST*2,"CTR")
C
      DO IP=1,NPROC
        NN=NST12(IP-1,2)-NST12(IP-1,1)+1
        N1=NST12(IP-1,1)
        CALL DCOPY(2*NGW*NN,C0(1,N1),1,C2S(1,IP),1)
      ENDDO
      CALL MY_TRANS(C2S,SC0,16*LENBK,1)
      DO IP=1,NPROC
        NGGP=SPARM(3,IP-1)
#ifdef __VECTOR 
!$OMP parallel do private(IGII,II,IG)
#ifdef CRAYX1
!dir$ concurrent
#endif
        DO IGII=1,NNST*NGGP
          II=1+(IGII-1)/NGGP
          IG=1+MOD(IGII-1,NGGP)
          C2F(MAPCOL(IG,IP),II)=SC0(IGII,IP)
        ENDDO 
#else 
        IGII=0
        DO II=1,NNST
          DO IG=1,NGGP
            IGII=IGII+1
            C2F(MAPCOL(IG,IP),II)=SC0(IGII,IP)
          ENDDO
        ENDDO
#endif 
      ENDDO
      DO I=NST12(MEPOS,1),NST12(MEPOS,2)
        II=I-NST12(MEPOS,1)+1
        CALL ZAZZERO(SCR,NGG1*NGG2*NGG3)
#ifdef __NEC 
!CDIR NODEP
#endif
#if defined (CRAYX1)
!DIR$ CONCURRENT
#endif
!$OMP parallel do private(IG)
        DO IG=1,NGWS
          SCR(MAPFUL(1,IG))=C2F(IG,II)
          SCR(MAPFUL(2,IG))=DCONJG(C2F(IG,II))
        ENDDO
        CALL OPAPP(SCR,NGG1,NGG2,NGG3,NOP1)
        CALL OPAPP(SCR,NGG1,NGG2,NGG3,NOP2)
!$OMP parallel do private(IG)
        DO IG=1,NGWS
          CTR(IG,II)=SCR(MAPFUL(1,IG))
          CTR(IG,NNST+II)=SCR(MAPFUL(2,IG))
        ENDDO
        CTR(1,NNST+II)=DCMPLX(0.D0,0.D0)
      ENDDO
      DO IP=1,NPROC
        NGGP=SPARM(3,IP-1)
#ifdef __VECTOR 
!$OMP parallel do private(IGII,II,IG)
        DO IGII=1,NNST*NGGP
          II=1+(IGII-1)/NGGP
          IG=1+MOD(IGII-1,NGGP)
          C2S(IGII,IP)=CTR(MAPCOL(IG,IP),II)
        ENDDO 
#else 
        IGII=0
        DO II=1,NNST
          DO IG=1,NGGP
            IGII=IGII+1
            C2S(IGII,IP)=CTR(MAPCOL(IG,IP),II)
          ENDDO
        ENDDO
#endif 
      ENDDO
      CALL MY_TRANS(C2S,SC0,16*LENBK,1)
      DO IP=1,NPROC
        NN=NST12(IP-1,2)-NST12(IP-1,1)+1
        N1=NST12(IP-1,1)
        CALL DCOPY(2*NGW*NN,SC0(1,IP),1,C2(1,N1),1)
      ENDDO
      IF(TLSD) THEN
        CALL ZGEMM('C','N',NSUP,NSUP,NGW,DCMPLX(1.D0,0.D0),C0,NGW,
     *             C2,NGW,DCMPLX(0.D0,0.D0),DDMAT,NSTATE)
        CALL ZGEMM('C','N',NSDOWN,NSDOWN,NGW,DCMPLX(1.D0,0.D0),
     *             C0(1,NSUP+1),NGW,C2(1,NSUP+1),NGW,
     *             DCMPLX(0.D0,0.D0),DDMAT(NSUP+1,NSUP+1),NSTATE)
      ELSE
        CALL ZGEMM('C','N',NSTATE,NSTATE,NGW,DCMPLX(1.D0,0.D0),C0,NGW,
     *             C2,NGW,DCMPLX(0.D0,0.D0),DDMAT,NSTATE)
      ENDIF
C
      DO IP=1,NPROC
        NGGP=SPARM(3,IP-1)
#ifdef __VECTOR 
!$OMP parallel do private(IGII,II,IG)
        DO IGII=1,NNST*NGGP 
          II=1+(IGII-1)/NGGP
          IG=1+MOD(IGII-1,NGGP)
          C2S(IGII,IP)=CTR(MAPCOL(IG,IP),NNST+II)
        ENDDO 
#else 
        IGII=0
        DO II=1,NNST
          DO IG=1,NGGP
            IGII=IGII+1
            C2S(IGII,IP)=CTR(MAPCOL(IG,IP),NNST+II)
          ENDDO
        ENDDO
#endif 
      ENDDO
      CALL MY_TRANS(C2S,SC0,16*LENBK,1)
      DO IP=1,NPROC
        NN=NST12(IP-1,2)-NST12(IP-1,1)+1
        N1=NST12(IP-1,1)
        CALL DCOPY(2*NGW*NN,SC0(1,IP),1,C2(1,N1),1)
      ENDDO
      IF(TLSD) THEN
        CALL ZGEMM('T','N',NSUP,NSUP,NGW,DCMPLX(1.D0,0.D0),C0,NGW,
     *             C2,NGW,DCMPLX(1.D0,0.D0),DDMAT,NSTATE)
        CALL ZGEMM('T','N',NSDOWN,NSDOWN,NGW,DCMPLX(1.D0,0.D0),
     *             C0(1,NSUP+1),NGW,C2(1,NSUP+1),NGW,
     *             DCMPLX(1.D0,0.D0),DDMAT(NSUP+1,NSUP+1),NSTATE)
      ELSE
        CALL ZGEMM('T','N',NSTATE,NSTATE,NGW,DCMPLX(1.D0,0.D0),C0,NGW,
     *             C2,NGW,DCMPLX(1.D0,0.D0),DDMAT,NSTATE)
      ENDIF
      CALL GLOSUM(2*NSTATE*NSTATE,DDMAT)
      CALL FREEM(IP_CTR)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE OPAPP(SCR,NGG1,NGG2,NGG3,NOP)
C     ==--------------------------------------------------------------==
C     == Performs some operation of translation in function of NOP    ==
C     == NOP == 1 -> SCR(x-1,:,:) = SCR(x,:,:)                        ==
C     == NOP == 2 -> SCR(:,y-1,:) = SCR(:,y,:)                        ==
C     == NOP == 3 -> SCR(:,:,z-1) = SCR(:,:,z)                        ==
C     == NOP == -1 or -2 or -3 are the inverse operations             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    NGG1,NGG2,NGG3,NOP
      COMPLEX*16 SCR(NGG1,NGG2,NGG3)
C     Variables
      INTEGER    IX,IZ,IY
C     ==--------------------------------------------------------------==
      IF(NOP.EQ.1) THEN
#ifndef CRAYX1
        DO IX=2,NGG1
          CALL ZCOPY(NGG2*NGG3,SCR(IX,1,1),NGG1,SCR(IX-1,1,1),NGG1)
        ENDDO
#else
        DO IX=2,NGG1
        DO IY=1,NGG2*NGG3,NGG1
        SCR(IX-1,IY,1)=SCR(IX,IY,1)
        ENDDO
        ENDDO
#endif
      ELSEIF(NOP.EQ.2) THEN
#ifndef CRAYX1
        DO IZ=1,NGG3
          DO IY=2,NGG2
            CALL ZCOPY(NGG1,SCR(1,IY,IZ),1,SCR(1,IY-1,IZ),1)
          ENDDO
        ENDDO
#else
        DO IZ=1,NGG3
        DO IY=2,NGG2
        DO IX=1,NGG1
        SCR(IX,IY-1,IZ)=SCR(IX,IY,IZ)
        END DO
        ENDDO
        ENDDO
#endif
      ELSEIF(NOP.EQ.3) THEN
#ifndef CRAYX1
        DO IZ=2,NGG3
          CALL ZCOPY(NGG1*NGG2,SCR(1,1,IZ),1,SCR(1,1,IZ-1),1)
        ENDDO
#else
        DO IX=1,NGG1
        DO IY=1,NGG2
        DO IZ=2,NGG3
        SCR(IX,1,IZ-1)=SCR(IX,1,IZ)
        ENDDO
        ENDDO
        ENDDO
#endif
      ELSEIF(NOP.EQ.(-1)) THEN
#ifndef CRAYX1
        DO IX=NGG1,2,-1
          CALL ZCOPY(NGG2*NGG3,SCR(IX-1,1,1),NGG1,SCR(IX,1,1),NGG1)
        ENDDO
#else
        DO IX=NGG1,2,-1
        DO IZ=1,NGG2*NGG3,NGG1
        SCR(IX,IZ,1)=SCR(IX-1,IZ,1)
        ENDDO
        ENDDO
#endif
      ELSEIF(NOP.EQ.(-2)) THEN
#ifndef CRAYX1
        DO IZ=1,NGG3
          DO IY=NGG2,2,-1
            CALL ZCOPY(NGG1,SCR(1,IY-1,IZ),1,SCR(1,IY,IZ),1)
          ENDDO
        ENDDO
#else
        DO IZ=1,NGG3
        DO IY=NGG2,2,-1
        DO IX=1,NGG1
        SCR(IX,IY,IZ)=SCR(IX,IY-1,IZ)
        END DO
        ENDDO
        ENDDO
#endif
      ELSEIF(NOP.EQ.(-3)) THEN
#ifndef CRAYX1
        DO IZ=NGG3,2,-1
          CALL ZCOPY(NGG1*NGG2,SCR(1,1,IZ-1),1,SCR(1,1,IZ),1)
        ENDDO
#else
        DO IX=1,NGG1
        DO IY=1,NGG2
        DO IZ=NGG3,2,-1
        SCR(IX,IY,IZ)=SCR(IX,IY,IZ-1)
        ENDDO
        ENDDO
        ENDDO
#endif
      ELSEIF(NOP.EQ.0) THEN
      ELSE
        CALL STOPGM('OPAPP','WRONG NOP')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_OPEIGR(LOPEIGR,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ddip.inc'
C     Arguments
      INTEGER   LOPEIGR,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   L1,L2,L3,NXG1,NXG2,NXG3
C     ==--------------------------------------------------------------==
      L1=2*NSTATE*NSTATE
      L2=0
      CALL GETNGG(L2)
      LOPEIGR=MAX(L1,L2,2*NGG1*NGG2*NGG3)
      TAG='MAX(2*NSTATE**2,2*NGG1*NGG2*NGG3)'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETNGG(L2)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'gvec.inc'         
      INCLUDE 'irat.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'sphe.inc'
C input
      INTEGER NX1,NX2,NX3,L2
C local
      REAL*8 G2,T1,T2,T3,GKPWF
      INTEGER I,J,K,KMIN,KMAX
C     ==--------------------------------------------------------------==
      NX1=0
      NX2=0
      NX3=0
C     Maximum K point amplitude (Kmax) in Brillouin zone.
      GCUTKA=GKPWF(B1,B2,B3,TKPNT.AND.TSPHERE)
      IF(GCUTKA.EQ.0.D0) THEN
        GCUTWMIN=GCUTW
        GCUTWMAX=GCUTW
      ELSE
C       For each k and each G, |k+G|^2 < GCUTW
C       so we define GCUTWMIN and GCUTWMAX as:
C       GCUTWMIN < |G|^2 < GCUTWMAX we have to apply a mask.
        GCUTWMIN = MAX(0.D0,SQRT(GCUTW)-SQRT(GCUTKA))**2
        GCUTWMAX = (SQRT(GCUTW)+SQRT(GCUTKA))**2
      ENDIF
C..construction of g-vectors
!!    IG=0
Cmb...I=0
!$OMP parallel do private(J,K,KMIN,KMAX,T1,T2,T3,G2) 
!$OMP+ reduction(max:NX2,NX3)
      DO J=0,NR2S-1
        KMIN=-NR3S+1
        KMAX=NR3S-1
        IF(J.EQ.0) KMIN=0
        DO K=KMIN,KMAX
          T1=DBLE(J)*B2(1)+DBLE(K)*B3(1)
          T2=DBLE(J)*B2(2)+DBLE(K)*B3(2)
          T3=DBLE(J)*B2(3)+DBLE(K)*B3(3)
          G2=T1*T1+T2*T2+T3*T3
          IF(G2.LT.GCUTWMAX) THEN
!!          IG=IG+1
!!          NX1=MAX(0,NX1)
            NX2=MAX(ABS(J),NX2)
            NX3=MAX(ABS(K),NX3)
          ENDIF
        ENDDO
      ENDDO
Cmb...I<>0
!$OMP parallel do private(I,J,K,T1,T2,T3,G2) 
!$OMP+ reduction(max:NX1,NX2,NX3)
      DO I=1,NR1S-1
        DO J=-NR2S+1,NR2S-1
          DO K=-NR3S+1,NR3S-1
            T1=DBLE(I)*B1(1)+DBLE(J)*B2(1)+DBLE(K)*B3(1)
            T2=DBLE(I)*B1(2)+DBLE(J)*B2(2)+DBLE(K)*B3(2)
            T3=DBLE(I)*B1(3)+DBLE(J)*B2(3)+DBLE(K)*B3(3)
            G2=T1*T1+T2*T2+T3*T3
            IF(G2.LT.GCUTWMAX) THEN
!!            IG=IG+1
              NX1=MAX(ABS(I),NX1)
              NX2=MAX(ABS(J),NX2)
              NX3=MAX(ABS(K),NX3)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
Cmb
      NX1=2*(NX1+1)+1
      NX2=2*(NX2+1)+1
      NX3=2*(NX3+1)+1
      L2=NX1*NX2*NX3*2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
