C     ==================================================================
      SUBROUTINE OPT_LR(C0,C1,C2,SC0,EIND,EIGV,DRHOE,H1NL,EIVPS1,EIROP1,
     &           DDXC,VPP,PME,GDE,PSI,SCR,LSCR,NSTATE,TYPE,ORBITAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'linres.inc'
C     ARGUMENTS
      INTEGER    LSCR,NSTATE
      COMPLEX*16 C0(NGWK,NSTATE),C1(NGWK,NSTATE),C2(NGWK,NSTATE)
      COMPLEX*16 SC0(NGWK,NSTATE)
      COMPLEX*16 H1NL(NGWK,*),EIVPS1(*),EIROP1(*),PSI(*)
      REAL*8     EIND,EIGV(*),SCR(LSCR),DRHOE(*),DDXC(*)
      REAL*8     VPP(*),GDE(*),PME(*)
      CHARACTER*(*) TYPE,ORBITAL
C     VARIABLES
      POINTER    (IP_V1,V1),(IP_VPOT,VPOT)
      COMPLEX*16 V1(*)
      REAL*8     VPOT(NNR1,*),E2(5)
      REAL*8     TIMEF,TIME1,TIME2,TCPU,ETOT0,ETOT2,DETOT,FI
      EXTERNAL   TIMEF
      DIMENSION  F(*)
      INTEGER    I,KNFI,IR,IG,IS,LOPT_LR
      CHARACTER  TAG*30
      LOGICAL    DEBUG
C     ==--------------------------------------------------------------==
      TIME1 = TIMEF()
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_OPT_LR(LOPT_LR,TYPE,TAG)
      CALL TEST_SCR('OPT_LR',TAG,LSCR,LOPT_LR)
C
      DEBUG=.FALSE.
      ETOT2 = 0.D0
C     ==--------------------------------------------------------------==
C     == CONTINUATION: STEP USING PREVIOUS FORCES INSTEAD OF INIT     ==
C     ==--------------------------------------------------------------==
      IF(INDEX(TYPE,"NOINIT").NE.0) THEN
        TYPE="PHONON"
        CALL GIVE_SCR_OPT_LR(LOPT_LR,TYPE,TAG)
        CALL TEST_SCR('OPT_LR',TAG,LSCR,LOPT_LR)
C
        CONVWF=.FALSE.
        CALL LR_UPD(C0,C1,C2,SC0,E2,DDXC,PSI,EIGV,DRHOE,
     &              H1NL,VPP,PME,GDE,SCR,LSCR,NSTATE,TYPE,ORBITAL,0,
     &              .FALSE.)
        GOTO 50
      ENDIF
C     ==--------------------------------------------------------------==
C     == INITIALIZATION                                               ==
C     ==--------------------------------------------------------------==
      IF(INDEX(TYPE,"PHONON").NE.0) THEN
        CALL SCRSET(SCR,LSCR,DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_V1,2*NHG,'V1',DEBUG)
#ifdef PARALLEL 
        CALL SCRPTR(SCR,LSCR,IP_VPOT, 
     .       MAX(KRX,KR1M*NOGRP)*KR2S*KR3S*NLSD,'VPOT',DEBUG)
#else
        CALL SCRPTR(SCR,LSCR,IP_VPOT,NNR1*NLSD,'VPOT',DEBUG)
#endif
        DO IG=1,NHG
          V1(IG)   = EIVPS1(IG) + SCG(IG) * EIROP1(IG)
        ENDDO
        CALL AZZERO(PSI,2*MAXFFT)
        DO IG=1,NHG
          PSI(INDZ(IG)) = DCONJG(V1(IG))
          PSI(NZH(IG))  = V1(IG)
        ENDDO
        IF(GEQ0) PSI(NZH(1)) = V1(1)
        CALL INVFFT(PSI)
        DO IR=1,NNR1
          VPOT(IR,1)=DREAL(PSI(IR))
        ENDDO
        IF(TLSD.OR.TLSE) CALL DCOPY(NNR1,VPOT(1,1),1,VPOT(1,2),1)
        IF(TLSE) CALL DCOPY(NNR1,VPOT(1,1),1,VPOT(1,3),1)
        CALL VPSIMT(C0,H1NL,F,VPOT,PSI,NSTATE,NLSD,.FALSE.)
C..H1NL now contains the total constant part of the gradient
C..H1NL = dVPS + dVNL + dVH
        CALL SCRREL(SCR,LSCR,DEBUG)
      ENDIF
C..initialize C1
      DO IS=1,NSTATE
        IF (F(IS).EQ.0.0D0) THEN
          FI = 1.0D0
        ELSE
          FI = 1.0D0/F(IS)
        END IF
        DO IG=1,NGW
          C1(IG,IS)=DT2BYE*VPP(IG)*H1NL(IG,IS)*FI
        ENDDO
      ENDDO
      IF(GEQ0) CALL ZCLEAN(C1,NSTATE,NGW)
      CALL LR_ORTHO(NSTATE,C0,C1,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
      ETOT0=0.D0
      IF(PARENT) THEN
         TIME2 = TIMEF()
         TCPU = (TIME2 - TIME1)*0.001D0
         WRITE(6,'(A,T50,F8.2,A8)')
     &        ' TIME FOR INITIALIZATION OF LINEAR RESPONSE:',
     &        TCPU,' SECONDS'
      ENDIF
C     ==--------------------------------------------------------------==
C     ==      THE BASIC LOOP FOR WAVEFUNCTION OPTIMIZATION            ==
C     ==--------------------------------------------------------------==
 50   CONVWF=.FALSE.
      DO KNFI=1,NMAXLR
        TIME1=TIMEF()
        CALL AZZERO(E2,5)
        E2(5)=EIND
        CALL LR_UPD(C0,C1,C2,SC0,E2,DDXC,PSI,EIGV,DRHOE,
     &              H1NL,VPP,PME,GDE,SCR,LSCR,NSTATE,TYPE,ORBITAL,
     &              KNFI,.TRUE.)
        ETOT2=E2(1)+E2(2)+E2(3)+E2(4)+E2(5)
        IF(KNFI.EQ.1) THEN
          DETOT=0.D0
        ELSE
          DETOT=ETOT2-ETOT0
        ENDIF
        IF(PARENT) THEN
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
        ENDIF
        ETOT0 = ETOT2
        IF(PARENT) CALL LR_PRINT(KNFI,ETOT2,DETOT,TCPU)
        IF(CONVWF) GOTO 100
      ENDDO
C     ==--------------------------------------------------------------==
C     ==     end of main loop                                         ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(1X,64("!"))')
        WRITE(6,'(" !!",A,T64,"!!")')
     &       ' OPT_SDWFN1| the maximum number of steps is reached'
        WRITE(6,'(" !!",A,F10.6,A,T64,"!!")')
     &       '         but no convergence (d E / d phi_1 =',GEMAX,')'
        WRITE(6,'(1X,64("!"))')
      ENDIF
  100 CONTINUE
      IF(PARENT) CALL LR_FPRI(E2,ETOT2)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_OPT_LR(LOPT_LR,TYPE,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'fft.inc'         !MAXFFT
      INTEGER LOPT_LR,LLR_UPD,LLR_ORTHO
      CHARACTER*30 TAG
      CHARACTER*(*) TYPE
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      LOPT_LR=2*NHG + MAX(KRX,KR1M*NOGRP)*KR2S*KR3S * NLSD +100
#else
      LOPT_LR=2*NHG + NNR1 * NLSD +100
#endif
      CALL GIVE_SCR_LR_UPD(LLR_UPD,TYPE,TAG)
      CALL GIVE_SCR_LR_ORTHO(LLR_ORTHO,N,TAG)
      LOPT_LR=MAX(LOPT_LR,LLR_UPD,LLR_ORTHO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LR_PRINT(KNFI,ETOT2,DETOT,TCPU)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'norm.inc'
      INTEGER KNFI
      REAL*8  ETOT2,DETOT,TCPU
C     ==--------------------------------------------------------------==
      IF(KNFI.EQ.1) WRITE(6,'(A,A)')
     *               '   NFI      GEMAX     CNORM',
     *               '         ETOT(2)        DETOT     TCPU'
      WRITE(6,'(I6,F11.6,F10.6,F16.8,G13.4,F9.3)') 
     *    KNFI,GEMAX,CNORM,ETOT2,DETOT,TCPU
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LR_FPRI(E2,ETOT2)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      REAL*8  E2(5),ETOT2
C     ==--------------------------------------------------------------==
      WRITE(6,'(/)')
      WRITE(6,'(A,T40,F16.8,A)')
     * ' ======== 2nd Order Perturbation Energy =',ETOT2,' ========='
      WRITE(6,'(A,T40,F16.8,A)')
     * ' ========              Equad(2) Hartree =',E2(1),' ========='
      WRITE(6,'(A,T40,F16.8,A)')
     * ' ========              Equad(2)      XC =',E2(2),' ========='
      WRITE(6,'(A,T40,F16.8,A)')
     * ' ========              Equad(2)   (H-e) =',E2(3),' ========='
      WRITE(6,'(A,T40,F16.8,A)')
     * ' ========              Elin(2)          =',E2(4),' ========='
      WRITE(6,'(A,T40,F16.8,A)')
     * ' ========              Eind(2)          =',E2(5),' ========='
      WRITE(6,'(/)')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
