C     ==================================================================
      SUBROUTINE GET_U(UROT,UMAT,PMAT,PEIG,NSTATE,MSUB,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER  NSTATE,MSUB,LSCR
      REAL*8   UROT(NSTATE,MSUB),UMAT(NSTATE,MSUB),PMAT(MSUB,MSUB)
      REAL*8   PEIG(*),SCR(LSCR)
C     Variables
      INTEGER  MM,INFO,MSGLEN,I,J,K,IJ
      REAL*8   FEK,FFK,SQE,SBES0,UU

C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        MM = NSTATE - MSUB
        CALL DGEMM('T','N',MSUB,MSUB,MM,1.D0,UROT,NSTATE,UROT,NSTATE,
     *             0.D0,PMAT,MSUB)
        CALL DSYEV('V','L',MSUB,PMAT,MSUB,PEIG,SCR,LSCR,INFO)
        IF(INFO.NE.0) CALL STOPGM('GET_U','INFO !=0 AFTER DSYEV')
        CALL AZZERO(UMAT,MSUB*NSTATE)
        CALL AZZERO(SCR,MSUB*MSUB)
        DO K=1,MSUB
          SQE=DSQRT(PEIG(K))
          FEK=COS(SQE)
          FFK=SBES0(SQE)
          DO I=1,MSUB
            DO J=1,MSUB
              IJ=J+(I-1)*MSUB
              UMAT(J,I)=UMAT(J,I)+PMAT(I,K)*PMAT(J,K)*FEK
              SCR(IJ)=SCR(IJ)+PMAT(I,K)*PMAT(J,K)*FFK
            ENDDO
          ENDDO
        ENDDO
        CALL DGEMM('N','N',MM,MSUB,MSUB,-1.D0,UROT,NSTATE,SCR,MSUB,
     *             0.D0,UMAT(MSUB+1,1),NSTATE)
        DO K=1,MSUB
          DO I=1,NSTATE/2
            J=NSTATE-I+1
            UU=UMAT(I,K)
            UMAT(I,K)=UMAT(J,K)
            UMAT(J,K)=UU
          ENDDO
        ENDDO
      ENDIF
#ifdef PARALLEL
      MSGLEN = NSTATE*MSUB * 8
      CALL MY_BCAST(UMAT,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE XGRAD(X0,X2,C2,RMAT,REIG,NSTATE,MSUB,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER NSTATE,MSUB,LSCR
      REAL*8 C2(NSTATE,MSUB),RMAT(MSUB,MSUB),REIG(MSUB),SCR(*)
      REAL*8 X0(NSTATE,MSUB),X2(NSTATE,MSUB)
C     Variables
      LOGICAL DEBUG
      REAL*8 S1(*),S2(*),S3(*),S4(*),S5(*)
      POINTER (IP_S1,S1),(IP_S2,S2),(IP_S3,S3),(IP_S4,S4),(IP_S5,S5)
      INTEGER I,J,IJ,JI,NLDX,K,L,MSGLEN,ISUB
      REAL*8 F1,F2,A,B,AmB,ApB,SBES0,FC4
C     ==--------------------------------------------------------------==
C     ==  CALCULATE THE GRADIENT OF THE ENERGY WITH RESPECT TO        ==
C     ==  ORBITAL ROTATIONS                                           ==
C     ==                                                              ==
C     ==  INPUT  : C2     ; GRADIENT WRT COEFFICIENTS                 ==
C     ==         : RMAT*REIG*RMAT(T) = X*X(T)                         ==
C     ==         : X0     ; CURRENT VALUE OF X                        ==
C     ==  OUTPUT : X2     ; GRADIENT WRT ROTATIONS                    ==
C     ==--------------------------------------------------------------==
      CALL TISET('     XGRAD',ISUB)
      IF(PARENT) THEN
        DEBUG=.FALSE.
        NLDX=NSTATE-MSUB
        CALL SCRSET(SCR,LSCR,DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_S1,MSUB*MSUB,'S1',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_S2,NSTATE*MSUB,'S1',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_S3,MSUB*MSUB,'S3',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_S4,MSUB*MSUB,'S4',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_S5,MSUB*MSUB,'S5',DEBUG)
C     ==--------------------------------------------------------------==
C     ==  DECOMPOSE THE GRADIENT                                      ==
C     ==--------------------------------------------------------------==
        DO K=1,MSUB
          DO I=1,NSTATE/2
            J=NSTATE-I+1
            A=C2(I,K)
            C2(I,K)=C2(J,K)
            C2(J,K)=A
          ENDDO
        ENDDO
        L=0
        K=0
        DO J=1,MSUB
          DO I=1,MSUB
            K=K+1
            S1(K)=C2(I,J)
          ENDDO
          DO I=MSUB+1,NSTATE
            L=L+1
            S2(L)=C2(I,J)
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  F2=R*X*G2*R(T)                                              ==
C     ==--------------------------------------------------------------==
        CALL DGEMM('T','N',MSUB,MSUB,NLDX,1.0D0,X0,NSTATE,S2,
     *       NLDX,0.0D0,S3,MSUB)
        CALL DGEMM('T','N',MSUB,MSUB,MSUB,1.0D0,RMAT,MSUB,
     *       S3,MSUB,0.0D0,S4,MSUB)
        CALL DGEMM('N','N',MSUB,MSUB,MSUB,1.0D0,S4,MSUB,
     *       RMAT,MSUB,0.0D0,S3,MSUB)
C     ==--------------------------------------------------------------==
C     ==  F1=R*G1*R(T)                                                ==
C     ==--------------------------------------------------------------==
        CALL DGEMM('T','N',MSUB,MSUB,MSUB,1.0D0,RMAT,MSUB,
     *       S1,MSUB,0.0D0,S4,MSUB)
        CALL DGEMM('N','N',MSUB,MSUB,MSUB,1.0D0,S4,MSUB,
     *       RMAT,MSUB,0.0D0,S1,MSUB)
C     ==--------------------------------------------------------------==
C     ==  F1+F1(T) ; F2+F2(T)                                         ==
C     ==--------------------------------------------------------------==
        DO I=1,MSUB
          DO J=I,MSUB
            IJ=(I-1)*MSUB+J
            JI=(J-1)*MSUB+I
            F1=S1(IJ)+S1(JI)
            F2=S3(IJ)+S3(JI)
            S1(IJ)=F1
            S1(JI)=F1
            S3(IJ)=F2
            S3(JI)=F2
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  C1; C2                                                      ==
C     ==--------------------------------------------------------------==
        K=0
        DO I=1,MSUB
          DO J=1,MSUB
            K=K+1
            A=DSQRT(REIG(I))
            B=DSQRT(REIG(J))
            ApB=0.5D0*(A+B)
            AmB=0.5D0*(A-B)
            S4(K)=0.5D0*SBES0(ApB)*SBES0(AmB)
            S5(K)=FC4(A,B)
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  FC = - F1 x C1 - (F2 x C2)(T) + F2 x C2                     ==
C     ==--------------------------------------------------------------==
        K=0
        DO I=1,MSUB
          DO J=1,MSUB
            K=K+1
            S1(K)=-S1(K)*S4(K)-S3(K)*S5(K)
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  X2 = R(T) * FC * R * X - J0(P)*G2(T)                        ==
C     ==--------------------------------------------------------------==
        CALL DGEMM('N','N',MSUB,MSUB,MSUB,1.0D0,RMAT,MSUB,
     *       S1,MSUB,0.0D0,S3,MSUB)
        CALL DGEMM('N','T',MSUB,MSUB,MSUB,1.0D0,S3,MSUB,
     *       RMAT,MSUB,0.0D0,S1,MSUB)
        CALL DCOPY(MSUB*MSUB,RMAT,1,S3,1)
        DO I=1,MSUB
          DO J=1,MSUB
            RMAT(I,J)=RMAT(I,J)*SBES0(DSQRT(REIG(J)))
          ENDDO
        ENDDO
        CALL DGEMM('N','T',MSUB,MSUB,MSUB,1.0D0,RMAT,MSUB,
     *       S3,MSUB,0.0D0,S4,MSUB)
        CALL AZZERO(X2,NSTATE*MSUB)
        CALL DGEMM('N','T',NLDX,MSUB,MSUB,-1.0D0,S2,NLDX,
     *       S4,MSUB,0.0D0,X2,NSTATE)
        CALL DGEMM('N','T',NLDX,MSUB,MSUB,1.0D0,X0,NSTATE,
     *       S1,MSUB,1.0D0,X2,NSTATE)
C     ==--------------------------------------------------------------==
        CALL SCRREL(SCR,LSCR,DEBUG)
      ENDIF
#ifdef PARALLEL
      MSGLEN = NSTATE*MSUB * 8
      CALL MY_BCAST(X2,MSGLEN,SOURCE,ALLGRP)
#endif
      CALL TIHALT('     XGRAD',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
