C     ==================================================================
      SUBROUTINE ORTHO(NSTATE,C0,CSCR,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==     ORTHOGONALIZE A SET OF WAVEFUNCTIONS C0                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'pslo.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGWK,*),CSCR(*)
      REAL*8     SCR(LSCR)
C     Variables
      CHARACTER  TAG*30
      REAL*8     FNL(IMAGP,LDF1,NHXS,NSTATE),DFNL(*)
      INTEGER    LORTHO,LSMAT
      REAL*8     SMAT(*),ISMA(*)
      POINTER    (IP_SMAT,SMAT),(IP_ISMA,ISMA)
      LOGICAL    DEBUG
C     ==--------------------------------------------------------------==
C     SCR test
      CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      CALL TEST_SCR('ORTHO',TAG,LSCR,LORTHO)
      DEBUG=.FALSE.
C     ==--------------------------------------------------------------==
CEHR[
      IF(TMDEH.OR.TPSPEC) THEN
C       PROPAGATION KEEPS ORBITALS ORTHOGONAL
C       DO JUST A NORMALIZATION ......
        CALL  DONORM_K(C0,NSTATE)
        RETURN
      ENDIF
CEHR]
      IF(TDMAL) THEN
        IF(TLOWD .OR. TIVAN .OR. TKPNT) THEN
          WRITE(6,*) 
     &       " WARNING: ORTHOGONALIZAION USING DISTRIBUTED LINALG ",
     &       "NOT IMPLEMENTED FOR"
          IF(TLOWD) WRITE(6,*) " LOWDIN ORTHOGONALIZATION "
          IF(TIVAN) WRITE(6,*) " ULTRA-SOFT PSEUDOPOTENTIALS"
          IF(TKPNT) WRITE(6,*) " K-POINTS"
          CALL STOPGM("ORTHO","DISTRIBUTED LINALG")
        ELSE
          IF(TLSD) THEN
            CALL DISORTHO(NSUP,C0(1,1),CSCR,SCR,LSCR)
            CALL DISORTHO(NSDOWN,C0(1,NSUP+1),CSCR,SCR,LSCR)
          ELSE
            CALL DISORTHO(NSTATE,C0(1,1),CSCR,SCR,LSCR)
          ENDIF
        ENDIF
      ELSEIF(TLOWD) THEN
        CALL LOWDIN(C0,CSCR,SCR,LSCR,NSTATE)
      ELSE
        IF(TIVAN) THEN
          CALL SCRSET(SCR,LSCR,DEBUG)
          IF(TLSD) THEN
            LSMAT=MAX(NSUP,NSDOWN)**2
            CALL SCRPTR(SCR,LSCR,IP_SMAT,LSMAT,'SMAT',DEBUG)
            CALL RGSVAN(C0(1,1),FNL(1,1,1,1),NSUP,SMAT)
            CALL RGSVAN(C0(1,NSUP+1),FNL(1,1,1,NSUP+1),NSDOWN,SMAT)
          ELSE
            LSMAT=NSTATE*NSTATE
            CALL SCRPTR(SCR,LSCR,IP_SMAT,LSMAT,'SMAT',DEBUG)
            CALL RGSVAN(C0,FNL,NSTATE,SMAT)
          ENDIF
          CALL SCRREL(SCR,LSCR,DEBUG)
        ELSE
          CALL SCRSET(SCR,LSCR,DEBUG)
          CALL SCRPTR(SCR,LSCR,IP_ISMA,NSTATE,'ISMA',DEBUG)
          IF(TLSD) THEN
            IF(TKPNT) THEN
              LSMAT=2*MAX(NSUP,NSDOWN)**2
              CALL SCRPTR(SCR,LSCR,IP_SMAT,LSMAT,'SMAT',DEBUG)
              CALL RGS_C(C0(1,1),NSUP,SMAT,ISMA)
              CALL RGS_C(C0(1,NSUP+1),NSDOWN,SMAT,ISMA)
            ELSE
              LSMAT=MAX(NSUP,NSDOWN)**2
              CALL SCRPTR(SCR,LSCR,IP_SMAT,LSMAT,'SMAT',DEBUG)
              CALL RGS(C0(1,1),NSUP,SMAT,ISMA)
              CALL RGS(C0(1,NSUP+1),NSDOWN,SMAT,ISMA)
            ENDIF
          ELSE
            IF(TKPNT) THEN
              LSMAT=2*NSTATE*NSTATE
              CALL SCRPTR(SCR,LSCR,IP_SMAT,LSMAT,'SMAT',DEBUG)
              CALL RGS_C(C0,NSTATE,SMAT,ISMA)
            ELSE
              LSMAT=NSTATE*NSTATE
              CALL SCRPTR(SCR,LSCR,IP_SMAT,LSMAT,'SMAT',DEBUG)
              CALL RGS(C0,NSTATE,SMAT,ISMA)
            ENDIF
          ENDIF
          CALL SCRREL(SCR,LSCR,DEBUG)
        ENDIF
      ENDIF
      IF(TKPNT) THEN
        IF(GEQ0) CALL ZCLEAN_K(C0,NSTATE,NGW)
      ELSE
        IF(GEQ0) CALL ZCLEAN(C0,NSTATE,NGW)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' !TLOWD
      INCLUDE 'pslo.inc' !TIVAN
      INCLUDE 'kpts.inc' !TKPNT
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER   LORTHO,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LLOWDIN,LGRAM,NSTX
C     ==--------------------------------------------------------------==
      LGRAM=0
      LLOWDIN=0
      IF(TDMAL .AND.(.NOT.(TLOWD .OR. TIVAN .OR. TKPNT))) THEN
        CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
#ifdef _BGL 
        LGRAM=MAX(3*NSTATE*NSTX+NSTATE,2*NSTX*NSTX+NSTATE*NSTX+NSTATE)
#else
        LGRAM=MAX(3*NSTATE*NSTX,3*NSTX*NSTX*NPROC)
#endif
      ELSEIF(TLOWD) THEN
        CALL GIVE_SCR_LOWDIN(LLOWDIN,TAG,NSTATE)
      ELSE
        IF(.NOT.TIVAN) THEN
          IF(TLSD) THEN
            IF(TKPNT) THEN
              LGRAM=2*MAX(NSUP,NSDOWN)**2+NSTATE
            ELSE
              LGRAM=MAX(NSUP,NSDOWN)**2+NSTATE
            ENDIF
          ELSE
            IF(TKPNT) THEN
              LGRAM=2*NSTATE*NSTATE+NSTATE
            ELSE
              LGRAM=NSTATE*NSTATE+NSTATE
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C..add 100 words of memory for the scratch array tool
      LORTHO=MAX(LLOWDIN,LGRAM)+100
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PREORTHO(C0,NSTATE,SCR,LSCR)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'pslo.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'kpts.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGWK,NSTATE)
      REAL*8     SCR(LSCR)
C     Variables
      INTEGER    IS,NOCC,NOU,NOD,NP
      DIMENSION  F(*)
C     ==--------------------------------------------------------------==
      IF(TIVAN) RETURN
      IF(TKPNT) RETURN
      IF(TLSD) THEN
        NOU=0
        DO IS=1,NSUP
          IF(F(IS).GT.1.D-5) NOU=NOU+1
        ENDDO
        IF(NOU.LT.NSUP) THEN
          NP=NSUP-NOU
          CALL GS_ORTHO(C0,NOU,C0(1,NOU+1),NP,SCR(NSTATE+1),SCR)
        ENDIF
        NOD=0
        DO IS=NSUP+1,NSTATE
          IF(F(IS).GT.1.D-5) NOD=NOD+1
        ENDDO
        IF(NOD.LT.NSDOWN) THEN
          NP=NSDOWN-NOD
          CALL GS_ORTHO(C0(1,NSUP+1),NOD,C0(1,NSUP+NOD+1),
     *                  NP,SCR(NSTATE+1),SCR)
        ENDIF
      ELSE
        NOCC=0
        DO IS=1,NSTATE
          IF(F(IS).GT.1.D-5) NOCC=NOCC+1
        ENDDO
        IF(NOCC.LT.NSTATE) THEN
          NP=NSTATE-NOCC
          CALL GS_ORTHO(C0,NOCC,C0(1,NOCC+1),NP,SCR(NSTATE+1),SCR)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
