c     ==================================================================
      subroutine pert_kpoint_p(c0,v1_nonloc,psi,rhoe,scr,lscr,
     &     eirop,eivps,z11,nstate)
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'symm.inc'
      include 'cnst.inc'
      include 'coor.inc'
      include 'store.inc'
      include 'elct.inc'
      include 'ener.inc'
      include 'spin.inc'
      include 'sfac.inc'
      include 'nlps.inc'
      include 'pslo.inc'
      include 'kpts.inc'
      include 'kpnt.inc'
      include 'cppt.inc'
      include 'gvec.inc'
      include 'geq0.inc'
      include 'response_p.inc'

c  ARGUMENTS
      integer    nstate,lscr
      complex*16 c0(ngw,nstate),v1_nonloc(ngw,nstate)
      complex*16 psi(*),scr(*),eirop(nhg),eivps(nhg)
      real*8     z11(nstate,nstate)
      real*8     rhoe(*)

c  VARIABLES
      complex*16 cu1(ngw,nstate,3)
      pointer    (ip_cu1,cu1)
c     forces operating on c1
      complex*16 force1(ngw,nstate)
      pointer    (ip_force1,force1)

      real*8     eigen(3*nat,*)
      pointer    (ip_eigen,eigen)
c     form factors and their derivatives
      real*8     FNL(imagp,nat,nhxs,nstate,nkpnt),DFNL(*)
      DIMENSION  fnl00(imagp,nat,nhxs,nstate)

c     variables used in cmputing the FNL derivatives wrt  K
      DIMENSION  dtwnl_dk(2*NGW,NHXS,NSX,3),
     &           ddtwnl_ddk(2*NGW,NHXS,NSX,3,3)

      DIMENSION  DFNL_DK(2,NAT,NHXS,NSTATE,3),
     &           DDFNL_DDK(2,NAT,NHXS,NSTATE,3,3)

      real*8     energy
      DIMENSION  E2_NL_C0(3,3)

c     Kpoint and weight
      dimension  F(nstate),WK(nkpts),RK(3,nkpts)
      real*8     dummy
      real*8     sder(3,3),sumkikj(3,3)
      pointer    (ip_sumkikj,sumkikj)
      real*8     sumkk, epertkp 
      real*8     rk_in(3,nkpts)

      character  tag*30,cdir(3)*1
      data       cdir /'x','y','z'/

      integer    i,k,k2,ikk,ir,ir1,ir2
      integer    il_v1_nonloc,lcu1,istate,isub
      integer    lpert_kpoint_p
      integer    lfnl

      logical    FKPFIRST
c     ==--------------------------------------------------------------==
      call tiset('    pert_kpoint_p',isub)

      IF ((NLSD .NE. 1))
     &     CALL STOPGM('PERT_KPOINT','Ispin not supported.')

      if (TKPNT) call stopgm
     &     ('PERT_KPOINT','K-points are complicated.')
c     ==--------------------------------------------------------------==

      call give_scr_pert_kpoint_p(lpert_kpoint_p,tag,nstate)
      call test_scr('pert_kpoint_p',tag,lscr,lpert_kpoint_p)

c     Response  wavefunction, computed applying the Hpert
c     the exact correction is : i * K * cu1
      lcu1 = 2*ngw*nstate*3
      call memory(ip_cu1,lcu1,'cu1')

c     ==--------------------------------------------------------------==
C     Potentials and related:
      il_v1_nonloc = 2*NGW*NSTATE
      call azzero(v1_nonloc,il_v1_nonloc)
c     NB: In v1_nonloc, we store \op{v1} |psi0> 

      CALL MEMORY(IP_DTWNL_DK,3*NSX*NHXS*2*NGW,'DTWNL_DK')
      CALL AZZERO(DTWNL_DK,3*NSX*NHXS*2*NGW)
      CALL MEMORY(IP_DDTWNL_DDK,3*3*NSX*NHXS*2*NGW,'DDTWNL_DDK')
      CALL AZZERO(DDTWNL_DDK,3*3*NSX*NHXS*2*NGW)
      CALL MEMORY(IP_DFNL_DK,3*2*NAT*NHXS*NSTATE,'DFNL_DK')
      CALL AZZERO(DFNL_DK,2*NAT*NHXS*NSTATE*3)
      CALL MEMORY(IP_DDFNL_DDK,3*3*2*NAT*NHXS*NSTATE,'DDFNL_DDK')
      CALL AZZERO(DDFNL_DDK,2*NAT*NHXS*NSTATE*3*3)

      if(NKPTS .eq. 0) CALL STOPGM('PERT_KPOINT_P','NKPTS = 0')

      CALL DCOPY(3*NKPTS,RRK,1,RK,1)
      CALL DCOPY(NKPTS,WWK,1,WK,1)
c     mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
c     non local potential
c     ==--------------------------------------------------------------==
C     FNL  are real because they do not depend on k

      lfnl = nstate*nat*nhxs
      call memory(ip_fnl00,lfnl,'fnl00')
      call rnlsm(c0,nstate,psi,scr,lscr,1,1,.false.)
      call DCOPY(lfnl,   fnl,1,  fnl00,1)

      call azzero(sder,9)

      call memory(ip_force1,2*ngw*nstate+8,'force1')
      call azzero(force1,2*ngw*nstate+8)
      call memory(ip_sumkikj,9,'sumkikj')
      call azzero(sumkikj,9)

      FKPFIRST = .true.

      CALL MEMORY(IP_E2_NL_C0,3*3,'E2_NL_C0')
      CALL AZZERO(E2_NL_C0,9)

c     Finite difference 1^ and 2^ of TWNL
      CALL DNLPS_DK(scr,lscr) 
c     Form factors and their 1^ and 2^ derivatives       
      CALL RNL_DK_P(C0,NSTATE,SCR,LSCR)

c     Reading RESTA_P: response wfn only
      IF(TKREAD_C1) THEN
c        scaling of k-point coordinates wrt BZ primitive vectors
         IF(TKSCALE) THEN
            call AZZERO(RK_in,3*NKPTS)
            DO IKK=1,NKPTS
               DO IR=1,3
                  RK_in(IR,IKK)=RK(IR,IKK)
               ENDDO
               DO IR=1,3
                  RK(IR,IKK)=RK_in(1,IKK)*B1(IR)+RK_in(2,IKK)*B2(IR)
     &                 +RK_in(3,IKK)*B3(IR)
               ENDDO
            ENDDO
         ENDIF

c         if(parent) write(6,'("ENTER ZHRWF_P")')
c         CALL    ZHRWF_P(7,CU1,NSTATE,TAU0)    
c         if(parent) write(6,'(" RESTA_P READ")')

         DO K = 1,3
           tag = 'p_'//cdir(K)
           if(parent) write(6,'("READ RESTART FILE NUMBER",I4)') K
           call restart_p(CU1(1,1,K),tag,nstate,RESPONSE_READ)
         ENDDO



         GOTO 1000
      ENDIF

c     
c     ==--------------------------------------------------------------==
c     ==         the basic loops for perturbations                    ==
c     ==--------------------------------------------------------------==
      if(parent) then
         write(6,'(/," ",22("*"),a,22("*"),/)')
     &        '   perturbations    '
      endif
c     The Response wfn are computed in the 3 cartesian directions
      do k=1,3
         if(parent)  write(6,'(" **** gradient dir:",a4,4x)')
     *        cdir(k)
c..   calculate perturbation wrt. coordinate K

c...  calculate the non-local part:
C     |v1_nonloc> = (d/dK [PP-Projectors]) |0>
         call fnl_fkp_p(c0,scr,lscr,v1_nonloc,f,nstate,k,FKPFIRST)
C     calculation of |v1_nonloc> = d / d(r_k) |0> + (nl_PP part)
         call KIN_PERT(c0,scr,lscr,v1_nonloc,f,nstate,k)

c     ==--------------------------------------------------------------==
         call rwfopt_p(c0,cu1(1,1,k),psi,rhoe,dummy,scr,lscr,
     &        eirop,eivps,dummy,v1_nonloc,
     &        z11,nstate,dummy)
c     ==--------------------------------------------------------------==

c     copy the optimized cu1 coefficients into the cu1 array
c     remind that the exact first order wavefunctions are i * cu1

         sder(k,k) = etot

c     off diagonal elements of the tensor of  second order energy 
c     
         if (k .ne. 1) then

            call azzero(force1,2*ngw*nstate)
            call h0psi1_p(cu1(1,1,k),c0,rhoe,f,tau0,fion,psi,scr,lscr,
     &           nstate,force1)
            do istate=1,nstate
               CALL DAXPY(2*ngw, z11(istate,istate), cu1(1,istate,k),1,
     &              force1(1,istate),1)
            enddo
            
            do k2 = 1,k-1
               
               sder(k2,k) = -ENERGY(cu1(1,1,k2),force1,nstate)- 
     &              2.d0* ENERGY(cu1(1,1,k2),v1_nonloc,nstate)
               
#ifdef  PARALLEL
               call glosum(1,sder(k2,k))
#endif
            enddo
         endif
      enddo                     ! k

      FKPFIRST = .FALSE.
C     mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
c     TEST on symmetry of the tensor
C     
      CALL AZZERO(force1,2*ngw*nstate)
      call h0psi1_p(cu1(1,1,1),c0,rhoe,f,tau0,fion,psi,scr,lscr,
     &     nstate,force1)
      do istate=1,nstate
         CALL DAXPY(2*ngw, z11(istate,istate), cu1(1,istate,1),1,
     &        force1(1,istate),1)
      enddo
      
      call fnl_fkp_p(c0,scr,lscr,v1_nonloc,f,nstate,1,FKPFIRST)
      call KIN_PERT(c0,scr,lscr,v1_nonloc,f,nstate,1)

c     mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
c     sder(2,1)  should be equal to sder(1,2)
      
      sder(2,1) = -ENERGY(cu1(1,1,2),force1,nstate)- 
     &     2.d0* ENERGY(cu1(1,1,2),v1_nonloc,nstate)

#ifdef  PARALLEL
      call glosum(1,sder(2,1))
#endif

c     sder(3,1)  should be equal to sder(1,3)
      sder(3,1) = -ENERGY(cu1(1,1,3),force1,nstate)- 
     &     2.d0* ENERGY(cu1(1,1,3),v1_nonloc,nstate)

#ifdef  PARALLEL
      call glosum(1,sder(3,1))
#endif

      CALL AZZERO(force1,2*ngw*nstate)

      call h0psi1_p(cu1(1,1,2),c0,rhoe,f,tau0,fion,psi,scr,lscr,
     &     nstate,force1)
      do istate=1,nstate
         CALL DAXPY(2*ngw, z11(istate,istate), cu1(1,istate,2),1,
     &              force1(1,istate),1)
      enddo

      call fnl_fkp_p(c0,scr,lscr,v1_nonloc,f,nstate,2,FKPFIRST)
      call KIN_PERT(c0,scr,lscr,v1_nonloc,f,nstate,2)

c     sder(3,2)  should be equal to sder(2,3)      
      sder(3,2) = -ENERGY(cu1(1,1,3),force1,nstate)- 
     &     2.d0* ENERGY(cu1(1,1,3),v1_nonloc,nstate)

#ifdef  PARALLEL
      call glosum(1,sder(3,2))
#endif

C     ================================================================
C     FINAL RESULTS
C     ================================================================

      E2_NL_C0(2,1)=E2_NL_C0(1,2)
      E2_NL_C0(3,1)=E2_NL_C0(1,3)
      E2_NL_C0(3,2)=E2_NL_C0(2,3)

      if(parent) then
         write(6,'(a50)')
     &        ' energy terms matrix (<cu1(j)|c12(i)>):'
         do i=1,3
            
            write(6,'("DELTA TENSOR",1x,i2,3(2x,f14.8))') 
     &           i, sder(i,1),sder(i,2),sder(i,3)
            
            write(6,*) ' '
         enddo
         DO I = 1,3
            write(6,'("E2_NL_C0 - DIR=",1x,i2,3(2x,f14.8))') I,
     &           E2_NL_C0(I,1),E2_NL_C0(I,2),E2_NL_C0(I,3)
         ENDDO
      endif

C     ==================================================================
C     calculation of the total perturbaton energy in terms of k_points

      SUMKK = 0.0d0
      EPERTKP = 0.0d0
      if(.not. TMONKP) then
        if (parent) then
            write(6,'("reciprocal vectors before tkscale")')
            write(6,'("b1=",3f14.5)') B1(1),B1(2),B1(3)
            write(6,'("b2=",3f14.5)') B2(1),B2(2),B2(3)
            write(6,'("b3=",3f14.5)') B3(1),B3(2),B3(3)
        endif
        IF(TKSCALE) THEN
          call AZZERO(RK_in,3*NKPTS)
          DO IKK=1,NKPTS
            DO IR=1,3
              RK_in(IR,IKK)=RK(IR,IKK)
            ENDDO
            DO IR=1,3
              RK(IR,IKK)=RK_in(1,IKK)*B1(IR)+RK_in(2,IKK)*B2(IR)
     &          +RK_in(3,IKK)*B3(IR)
            ENDDO
          ENDDO
        ENDIF
      endif

      if(parent) THEN
        if(TKSCALE) then
           write(6,'(a)')
     &          "k vector after Tkscale"
        endif
        write(6,'(10x,a,3x,a,2x,a,2x,a,a,a)')
     &       "**** num k ",
     &       "    kx    ","    ky    ","    kz    ",
     &       "      wk    ","****"
        DO IKK=1,NKPTS
          write(6,'(12x,I8,4x,f8.4,4x,f8.4,4x,f8.4,4x,f8.4)')
     &        IKK,RK(1,IKK),RK(2,IKK),RK(3,IKK),WK(IKK)
        ENDDO
      ENDIF

      do IKK=1,NKPTS
        DO IR1=1,3
            DO IR2=1,3
              SUMKIKJ(IR2,IR1) = SUMKIKJ(IR2,IR1) + 
     &              WK(IKK)*RK(IR1,IKK)*RK(IR2,IKK)
            ENDDO
            SUMKK = SUMKK + WK(IKK)*RK(IR1,IKK)*RK(IR1,IKK)
         ENDDO
      ENDDO
      SUMKK = SUMKK*TPIBA2
      DO ISTATE = 1,NSTATE
        EPERTKP = EPERTKP+0.5d0 *  SUMKK * f(ISTATE)
      ENDDO

      DO IR1=1,3
        DO IR2=1,3
          EPERTKP = EPERTKP +
     &         TPIBA2 * SUMKIKJ(IR2,IR1) * 
     &         (SDER(IR2,IR1) + E2_NL_C0(IR2,IR1)) 
        ENDDO
      ENDDO

C    ==-----------------------------------------------------------==
C    ==  Etot-Egamma = sum_k sum_ab ka*kb*Dab*0.5                 ==
C    ==-----------------------------------------------------------==

      if(parent) then
           write(6,'(a50)')
     &           '========== total perturbation energy:'
            write(6,'(1x,a,1x,f16.8)') "EPERTKP=",EPERTKP*0.5D0
            write(6,'(1x,a,1x,f16.10)') "sumkk=",sumkk
            write(6,'(1x,"sumkikj=")')
            write(6,'(8x,3f16.10)') 
     &           sumkikj(1,1),sumkikj(1,2), sumkikj(1,3)
            write(6,'(8x,3f16.10)') 
     &           sumkikj(2,1),sumkikj(2,2), sumkikj(2,3)
            write(6,'(8x,3f16.10)') 
     &           sumkikj(3,1),sumkikj(3,2), sumkikj(3,3)
       endif

 1000 CONTINUE

      call freem(ip_force1)
      call freem(ip_sumkikj)

      IF(TPERT_HAMILT) then
         if(parent) then
            write(6,'("LSCR = ",i10)') LSCR
         endif
         CALL MATRIX_P(C0,CU1,NSTATE,PSI,SCR,LSCR)
         if(parent) then
            write(6,'("LSCR = ",i10)') LSCR
         endif
         IF(PARENT) THEN
            write(6,'("        >>>>>>>> K CYCLE <<<<<<<<")')
            write(6,'("computation and diagonalization of H(K) ")')
            write(6,'("for the following set of k-point        ")')
            write(6,'(a,a,a,a,a)')
     &           " NK     ","   Kx   ","   Kx   ","   Kx   ",
     &           "   Wk   "
            DO IKK = 1,NKPTS
              write(6,'(i6,2x,4f8.5)')
     &              IKK,RK(1,IKK),RK(2,IKK),RK(3,IKK),WK(IKK)
            ENDDO
            write(6,'(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")')
         ENDIF
         CALL KS_ENER_P(CU1,Z11,NSTATE,SCR,LSCR)
      ENDIF

      if(tmemchk) then
         call print_memory
      endif

      CALL FREEM(IP_DTWNL_DK)
      CALL FREEM(IP_DDTWNL_DDK)
      call freem(IP_DFNL_DK)
      call freem(IP_DDFNL_DDK)
      call freem(ip_fnl00)

c     =================================================================
C     cu1 are now used to increase the Hilbert space

      IF(.NOT. TPERT_HAMILT) THEN
         IF(PARENT) WRITE(6,'("CHECK IF RESTART")')
         IF(PARENT) WRITE(6,*)
         IF(TK_PREP_DIAG) THEN
            IF(PARENT) THEN
               WRITE(6,'(">>>> in PERT_KPOINT:")')
               WRITE(6,'("BUILD_C00 IS TRUE")')
               WRITE(6,'("NUMBER OF STATES OF C00 = ",I7)')
     &              2*NSTATE
            ENDIF

            call UP3_P(C0,CU1,TAU0,PSI,SCR,LSCR,
     &           NSTATE,.false.,.false.)  

         ELSEIF(RESTART_CU1) THEN
c            IF(PARENT) THEN
c               WRITE(6,'(">>>> in PERT_KPOINT: CALL ZHWWF_P")')
c               WRITE(6,'(">>>> THE CU1 ARE TO BE WRITTEN ON RESTA_P")')
c            ENDIF
c            CALL ZHWWF_P(5,CU1,NSTATE,TAU0)
            DO K = 1,3
              tag = 'p_'//cdir(K)
              IF(PARENT) 
     &           WRITE(6,'(">>>> WRITE RESTRT FILE NUMBER",I4)') k
              call restart_p(CU1(1,1,K),tag,nstate,RESPONSE_WRITE)
            ENDDO
         ELSE
            IF(PARENT) THEN   
               WRITE(6,'(">>>> in PERT_KPOINT: ")')
               WRITE(6,'("NO KIND OF RESTART FILE IS WRITTEN")')
               WRITE(6,'("TK_PREP_DIAG and RESTART_CU1 are false")')
            ENDIF
         ENDIF
      ENDIF

      call freem(ip_cu1)

      call tihalt('    pert_kpoint_p',isub)
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================

c     ==================================================================
      subroutine give_scr_pert_kpoint_p(lpert_kpoint_p,tag,nstate)
      implicit none
      include 'system.h'        !nhg tgc
      include 'ropt.inc'
      include 'response_p.inc'
      character*(*) tag
      integer lpert_kpoint_p,lrnlsm,lrho,lrhoofr,lrscpot,lforce1,
     &         lputwnl,lnrl_dk_p,lupdrho_p,LMATRIX_P,LKS_ENER_P
      integer N2,NSTATE
c     ==--------------------------------------------------------------==

      lpert_kpoint_p = 1
      IF(.NOT. TKPERT) RETURN

      lpert_kpoint_p=nstate
      calste=.false.
      N2 = NSTATE*NSTATE
      call give_scr_rnlsm(lrnlsm,tag,nstate,.true.)
      call give_scr_rhoofr(lrho,tag)
      call give_scr_rscpot(lrscpot,tag,calste)
      call give_scr_rhoofr_p(lrhoofr,tag)
      call give_scr_forces_p(lforce1,tag,nstate)
      call give_scr_putwnl_kpert(lputwnl,tag)
      call give_scr_rnl_dk_p(lnrl_dk_p,tag,nstate)
      call give_scr_up3_p(lupdrho_p,tag,nstate)
      call give_scr_matrix_P(LMATRIX_P,TAG,NSTATE)
      call give_scr_ks_ener_p(lks_ener_p,N2,NSTATE)
      lrho=lrho+2*nhg
      lrhoofr=lrhoofr+2*nhg
      lforce1=2*ngw*nstate
      lpert_kpoint_p=max(lrho,lrscpot,lrnlsm,lrhoofr,
     *                   lpert_kpoint_p,lforce1,lnrl_dk_p,lupdrho_p,
     *                   lputwnl,LMATRIX_P,LKS_ENER_P)
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
