#if defined(__SR11000)
*option OPT(O(ss))
#endif
C     ==================================================================
      SUBROUTINE PHFAC(TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'gvec.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
C     Arguments
      REAL*8     TAU0(3,NAX,*)
C     Variables
      DIMENSION  RK(3,*),WK(*),EIKR(NKPTS,*),EIGKR(NGWK,NAT,*),
     &    EIGR(NGW,*),EIGRB(NHG,*)
      COMPLEX*16 CTEP1,CTEP2,CTEP3,CTEM1,CTEM2,CTEM3,ZSUM,
     &           EI10,EI20,EI30,SVTMPP,SVTMPM
      REAL*8     FNL(*),DFNL(*)
      REAL*8     SUM1,SUM2,SUM3,AR1,AR2,AR3,SUM
      INTEGER    ISUB,NH1,NH2,NH3,ISA,IS,IA,I,J,K,IG,IKPT,IK,IKK
      INTEGER    IFIRST
      DATA       IFIRST /0/
      SAVE       IFIRST
C     ==--------------------------------------------------------------==
      IF(NR1S.LT.3) THEN
        CALL STOPGM('PHFAC',' PHFAC: NR1 TOO SMALL ')
      ENDIF
      IF(NR2S.LT.3) THEN
        CALL STOPGM('PHFAC',' PHFAC: NR2 TOO SMALL ')
      ENDIF
      IF(NR3S.LT.3) THEN
        CALL STOPGM('PHFAC',' PHFAC: NR3 TOO SMALL ')
      ENDIF
C     ==--------------------------------------------------------------==
      CALL TISET('     PHFAC',ISUB)
      IF(IFIRST.EQ.0) THEN
        IF(BIGMEM) THEN
          CALL MEMORY(IP_EIGRB,2*NHG*NAT,'EIGRB')
        ENDIF
        CALL MEMORY(IP_EIGR,2*NGW*NAT,'EIGR')
        IF(TKPNT) THEN
          CALL MEMORY(IP_EIKR,2*NKPTS*NAT,'EIKR')
          CALL MEMORY(IP_EIGKR,2*NGWK*NAT*NKPNT,'EIGKR')
        ENDIF
        CALL MEMORY(IP_EI1,2*(2*NR1S-1)*NATX,'EI1')
        CALL MEMORY(IP_EI2,2*(2*NR2S-1)*NATX,'EI2')
        CALL MEMORY(IP_EI3,2*(2*NR3S-1)*NATX,'EI3')
        IFIRST  = 1
        IF(PARENT) THEN
          CALL PRMEM('     PHFAC')
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      NH1=NR1S/2+1
      NH2=NR2S/2+1
      NH3=NR3S/2+1
C$OMP parallel do private(ISA,IA,IS,SUM1,SUM2,SUM3,AR1,AR2,AR3)
C$OMP+ private(CTEP1,CTEP2,CTEP3,CTEM1,CTEM2,CTEM3)
C$OMP+ private(SVTMPP,SVTMPM,I,J,K,EI10,EI20,EI30)
C$OMP+ shared(NH1,NH2,NH3)
      DO ISA=1,NAT
        IA=IATPT(1,ISA)
        IS=IATPT(2,ISA)
        SUM1=B1(1)*TAU0(1,IA,IS)+B1(2)*TAU0(2,IA,IS)+
     *      B1(3)*TAU0(3,IA,IS)
        SUM2=B2(1)*TAU0(1,IA,IS)+B2(2)*TAU0(2,IA,IS)+
     *      B2(3)*TAU0(3,IA,IS)
        SUM3=B3(1)*TAU0(1,IA,IS)+B3(2)*TAU0(2,IA,IS)+
     *      B3(3)*TAU0(3,IA,IS)
        AR1=TPIBA*SUM1
        AR2=TPIBA*SUM2
        AR3=TPIBA*SUM3
        EI1(ISA,1)=DCMPLX(1.0D0,0.0D0)
        EI2(ISA,1)=DCMPLX(1.0D0,0.0D0)
        EI3(ISA,1)=DCMPLX(1.0D0,0.0D0)
        CTEP1=DCMPLX(DCOS(AR1),-DSIN(AR1))
        CTEP2=DCMPLX(DCOS(AR2),-DSIN(AR2))
        CTEP3=DCMPLX(DCOS(AR3),-DSIN(AR3))
        CTEM1=DCONJG(CTEP1)
        CTEM2=DCONJG(CTEP2)
        CTEM3=DCONJG(CTEP3)

        SVTMPP=CTEP1
        SVTMPM=CTEM1
        DO I=2,NR1S
          EI1(ISA,I)=SVTMPP
          SVTMPP=SVTMPP*CTEP1
          EI1(ISA,NR1S+I-1)=SVTMPM
          SVTMPM=SVTMPM*CTEM1
        ENDDO

        SVTMPP=CTEP2
        SVTMPM=CTEM2
        DO J=2,NR2S
          EI2(ISA,J)=SVTMPP
          SVTMPP=SVTMPP*CTEP2
          EI2(ISA,NR2S+J-1)=SVTMPM
          SVTMPM=SVTMPM*CTEM2
        ENDDO

        SVTMPP=CTEP3
        SVTMPM=CTEM3
        DO K=2,NR3S
          EI3(ISA,K)=SVTMPP
          SVTMPP=SVTMPP*CTEP3
          EI3(ISA,NR3S+K-1)=SVTMPM
          SVTMPM=SVTMPM*CTEM3
        ENDDO

        EI10=1.D0/EI1(ISA,NH1)
        EI20=1.D0/EI2(ISA,NH2)
        EI30=1.D0/EI3(ISA,NH3)
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(1000))
#endif
#ifdef __SR8000
*poption parallel, tlocal(I)
#endif 
        DO I=1,2*NR1S-1
          EI1(ISA,I)=EI1(ISA,I)*EI10
        ENDDO
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(1000))
#endif
#ifdef __SR8000
*poption parallel, tlocal(J)
#endif 
        DO J=1,2*NR2S-1
          EI2(ISA,J)=EI2(ISA,J)*EI20
        ENDDO
#ifdef  _BGL 
!IBM* INDEPENDENT
!IBM* ASSERT (ITERCNT(1000))
#endif
#ifdef __SR8000
*poption parallel, tlocal(K)
#endif 
        DO K=1,2*NR3S-1
          EI3(ISA,K)=EI3(ISA,K)*EI30
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
#ifdef __SR8000 
*poption parallel 
#endif 
#ifdef _vpp_
!OCL NOALIAS
#endif
C$OMP parallel do private (ISA,IG)
      DO ISA=1,NAT
        DO IG=1,NGW
          EIGR(IG,ISA)=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *         EI3(ISA,INYH(3,IG))
        ENDDO
      ENDDO
      IF(BIGMEM) THEN
#ifdef __SR8000 
*poption parallel 
#endif 
#ifdef _vpp_
!OCL NOALIAS
#endif
C$OMP parallel do private (ISA,IG)
        DO ISA=1,NAT
          DO IG=1,NHG
            EIGRB(IG,ISA)=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *           EI3(ISA,INYH(3,IG))
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TKPNT) THEN
        DO IKPT=1,NBLKP
          DO IK=1,NKPBL(IKPT)
            IKK=KPBEG(IKPT)+IK
C$OMP parallel do private(ISA,IA,IS,SUM1,SUM2,SUM3,SUM,ZSUM,IG)
            DO ISA=1,NAT
              IA=IATPT(1,ISA)
              IS=IATPT(2,ISA)
              SUM1=B1(1)*TAU0(1,IA,IS)+B1(2)*TAU0(2,IA,IS)+
     *            B1(3)*TAU0(3,IA,IS)
              SUM2=B2(1)*TAU0(1,IA,IS)+B2(2)*TAU0(2,IA,IS)+
     *            B2(3)*TAU0(3,IA,IS)
              SUM3=B3(1)*TAU0(1,IA,IS)+B3(2)*TAU0(2,IA,IS)+
     *            B3(3)*TAU0(3,IA,IS)
              SUM=RK(1,IKK)*SUM1+RK(2,IKK)*SUM2+RK(3,IKK)*SUM3
              ZSUM=DCMPLX(COS(SUM),SIN(SUM))
              EIKR(IKK,ISA)=ZSUM
              DO IG=1,NGW
                EIGKR(IG,ISA,IK)=EIGR(IG,ISA)*ZSUM
                EIGKR(IG+NGW,ISA,IK)=DCONJG(EIGR(IG,ISA))*ZSUM
              ENDDO
            ENDDO
          ENDDO
          IF(TKBLOCK) THEN
            CALL WKPT_SWAP(EIGKR,1,IKPT,'EIGKR')
          ENDIF
        ENDDO
      ELSE
Ckpt..not to duplicate code.
        CALL GET_ADDR(IP_EIGKR,EIGR(1,1))
      ENDIF
      CALL TIHALT('     PHFAC',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CALC_EIGKR(IKPT)
C     ==--------------------------------------------------------------==
C     == CALCULATES EIGKR (USED WITH THE OPTION TKBLOCK)              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'        !for NAT
      INCLUDE 'kpts.inc'        !for NKPBL
      INCLUDE 'kpnt.inc'        !for EIGKR,EIKR
      INCLUDE 'sfac.inc'        !for EIGR
C     Arguments
      INTEGER    IKPT
C     Variables
      INTEGER    ISUB,IKIND,IK,ISA,IS,IA,IG
      COMPLEX*16 ZSUM
      REAL*8     FNL,DFNL
      DIMENSION  EIGR(NGW,NAT),EIKR(NKPTS,NAT),EIGKR(NGWK,NAT,NKPNT)
C     ==--------------------------------------------------------------==
      CALL TISET('CALC_EIGKR',ISUB)
      DO IKIND=1,NKPBL(IKPT)
        IK=KPBEG(IKPT)+IKIND
        ISA=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            ISA=ISA+1
            ZSUM=EIKR(IK,ISA)
            DO IG=1,NGW
              EIGKR(IG,ISA,IKIND)=EIGR(IG,ISA)*ZSUM
              EIGKR(IG+NGW,ISA,IKIND)=DCONJG(EIGR(IG,ISA))*ZSUM
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      CALL TIHALT('CALC_EIGKR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
