c     ==================================================================
      subroutine phonons_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &     eirop,eivps,z11,nstate)
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'ions.inc'
      include 'irat.inc'
      include 'symm.inc'
      include 'rmas.inc'
      include 'cotr.inc'
      include 'adat.inc'
      include 'coor.inc'
      include 'soft.inc'
      include 'store.inc'
      include 'elct.inc'
      include 'spin.inc'
      include 'sfac.inc'
      include 'nlps.inc'
      include 'pslo.inc'
      include 'atwf.inc'
      include 'kpts.inc'
      include 'kpnt.inc'
      include 'cppt.inc'
      include 'fft.inc'
      include 'response_p.inc'
c     arguments
      integer    nstate,lscr
      integer    isub
      integer    ii,i,j,k,k2,is,is2,ia,ia2,ij,iat,iat2,isymuat,dimtot
      integer    il_drhoe,il_psi,il_v1_loc,il_v1_nonloc,il_eirop1
      integer    ix,nsym,msglen,icol,isa,info
      integer    iv,isa0,ir,il_rhoe
      integer    nc1,nc2,ncd,nce,lfnl,ldfnl,i1,i2,i3,ii1,ii2,ii3
      DIMENSION  dfnl00(imagp,nat,nhxs,3,nstate,nkpnt),
     &           fnl00(imagp,nat,nhxs,nstate,nkpnt)

      
      complex*16 c0(ngw,nstate),c1(ngw,nstate)
      complex*16 psi(*)
      complex*16 eirop(nhg),eivps(nhg),eirop1(nhg),v1_loc(nhg,nlsd)
      complex*16 v1_nonloc(ngwk,*),rho0G(*)
      pointer    (ip_rho0G,rho0G)
      real*8     drhoe(nnr1,nlsd),z11(nstate,nstate)
      real*8     scr(*),eigen(3*nat,*)
      real*8     FNL(imagp,nat,nhxs,nstate,nkpnt)
      real*8     DFNL(imagp,nat,nhxs,3,nstate,nkpnt)
      real*8     rhoe(*)
c     ==--------------------------------------------------------------==
      real*8     xmass,sdersave,hesssave,
     &     sder(3*nat,3*nat),xma(3*nax*nsx),vibe(3*nat),
     &     ddfnl00(imagp,nat,nhxs,3,3,nstate,nkpnt),
     &     tras(3*nat,3),rot(3*nat,3)
      DIMENSION  F(nstate,nkpnt),WK(nkpnt)
      pointer    (ip_sder,sder),(ip_sdersave,sdersave),
     &     (ip_tras,tras),(ip_rot,rot),(ip_hesssave,hesssave),
     &     (ip_xma,xma),(ip_vibe,vibe),
     &     (ip_ddfnl00,ddfnl00),
     &     (ip_v1_loc,v1_loc),(ip_v1_nonloc,v1_nonloc),
     &     (ip_eirop1,eirop1),(ip_eigen,eigen)
      character  tag*30,filen*100,cdir(3)*1
      data       cdir /'x','y','z'/
c     ==--------------------------------------------------------------==
      call tiset('    phonon',isub)
c     ==--------------------------------------------------------------==
C     Potentials and related:
      il_v1_loc=2*nhg*nlsd
      il_v1_nonloc=2*ngwk*nstate*nkpnt
      il_eirop1=2*nhg
      call memory(ip_v1_loc,il_v1_loc,'v1_loc')
      call azzero(v1_loc,il_v1_loc)
      call memory(ip_v1_nonloc,il_v1_nonloc,'v1_nonloc')
      call azzero(v1_nonloc,il_v1_nonloc)
c     NB: In v1_nonloc, we store \op{v1} |psi0> whereas in
c     v1_loc, v1(g) is stored. Therefore the different dimensions.
      call memory(ip_eirop1,il_eirop1,'eirop1')
      call azzero(eirop1,il_eirop1)


c     ==--------------------------------------------------------------==
c     the gnd-state density in G-space:
      call memory(ip_rho0G,2*nhg*nlsd,'rho0 (G)')
      call azzero(   rho0G,2*nhg*nlsd)
      if (tlsd) then
         call fft2tog(rho0(1,1),rho0G(1),rho0(1,2),rho0G(nhg+1),
     &        psi,nhg,.true.)
      else
         call ffttog(rho0,rho0G,psi,nhg,.true.)
      endif

c     ==--------------------------------------------------------------==
C     FNL,DFNL,DDFNL...
      ndfnl=nst12(mepos,2)-nst12(mepos,1)+1
      ldfnl=imagp*3*nat*nhxs*ndfnl*nkpnt
      if(ldfnl.le.0) ldfnl=1
      lfnl = imagp*nstate*nat*nhxs*nkpnt

      call memory(ip_fnl00,lfnl,'fnl00')
      call memory(ip_dfnl00,ldfnl,'dfnl00')
      call memory(ip_ddfnl00,3*ldfnl,'ddfnl00')
      call rnlsm(c0,nstate,psi,scr,lscr,1,1,.true.)
      call rnlsm3(c0,scr,lscr,nstate,ddfnl00)
      call DCOPY(lfnl,   fnl,1,  fnl00,1)
      call DCOPY(ldfnl, dfnl,1, dfnl00,1)

c     ==--------------------------------------------------------------==
C     Specific ionic matrices (hessian, rotation, transl matrix)
      call memory(ip_tras,9*nat,'tras')
      call memory(ip_rot,9*nat,'rot')
      call azzero(tras,9*nat)
      call azzero(rot,9*nat)

      nodim=3*nat
      call memory(ip_sder,9*nat*nat,'sder')
      call azzero(sder,9*nat*nat)
      call memory(ip_hesssave,9*nat*nat,'sder')
      call azzero(hesssave,9*nat*nat)
      call memory(ip_sdersave,9*nat*nat,'sder')
      call azzero(sdersave,9*nat*nat)
      if(parent) then
         call memory(ip_eigen,9*nat*nat,'eigen')
         call memory(ip_xma,3*nax*nsx,'xma')
         call memory(ip_vibe,3*nat,'vibe')
         call memory(ip_hess,nodim*nodim,'hess')
      endif
c     ==--------------------------------------------------------------==
      if(nodim.NE.3*nat) then
         call stopgm('PHONONS_P','Dimension must be 3*Nat')
      endif
c     ==--------------------------------------------------------------==
c     ==         the basic loops for perturbations                    ==
c     ==--------------------------------------------------------------==
      if(parent)
     &     write(6,'(/," ",22("*"),a,22("*"),/)')
     &     '   perturbations    '
c     no symmetrization of gradients in this part!
      nsym=nrot
      nrot=1
      iat=0
c..   calculate perturbation wrt. to atom IAT and coordinate K
      do is=1,nsp
         do ia=1,na(is)
            iat=iat+1
            do k=1,3
               if(parent) write(6,'(" **** atom=",i7,4x,a4,4x,a4,4x)')
     *              iat,el(iatyp(is)),cdir(k)
               
c...  local part of the perturbation:
C     v1_loc(ig)  =  d/dR PP_local(r-R)  ==  PP_local(G) * G
               call eicalc1(k,is,iat,v1_loc,eirop1)
               if (tlsd) 
     &              call DCOPY(2*nhg,v1_loc(1,1),1,v1_loc(1,2),1)
C     This potential is identical for up and down spins

c...  non-local part:
C     |v1_nonloc> = (d/dR [PP-Projectors]) |0>
               call fnonloc_p(c0,psi,scr,lscr,
     &              v1_nonloc,f,nstate,k,is,iat,1)
               
c     ==--------------------------------------------------------------==
               call rwfopt_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &              eirop,eivps,v1_loc,v1_nonloc,
     &              z11,nstate,eirop1)
c     ==--------------------------------------------------------------==

C     rwfopt_p returns c1 and the first-order perturbation density in
C     real space representation in the array DRHOE.
               call ffttog(drhoe,drhoe,psi,nhg,.true.)

c     second derivatives matrix:
               icol=3*(iat-1)+k
               iat2=0
               do is2=1,nsp
                  do ia2=1,na(is2)
                     iat2=iat2+1
                     do k2=1,3
                        ix=3*(iat2-1)+k2
                        if(iat.eq.iat2) then
c     local part, i=j (i,j=atoms)
                           call d_mat_diag_loc(sder(ix,icol),rho0G,
     &                          eirop,eirop1,v1_loc,k2)
c     non-local part, i=j (i,j=atoms)
                           call d_mat_diag_nonloc(sder(ix,icol),
     &                          ddfnl00,fnl00,
     &                          dfnl00,f,wk,is,k,k2,iat,nstate,1)
c     real space term, i=j
                           call d_mat_diag_real(sder(ix,icol),
     &                          is,ia,k,k2,tau0)
c     real space term, i <> j
                        else
                           call d_mat_real(sder(ix,icol),is,ia,k,k2,
     &                          is2,ia2,tau0)
                        end if
c     local part      
                        call d_mat_loc0(sder(ix,icol),
     &                       eirop1,iat2,k2,is2)
                        call d_mat_locps(sder(ix,icol),
     &                       drhoe,iat2,k2,is2)
c     non local part
                        call rnlsm(c1,nstate,psi,scr,lscr,1,1,.true.)
                        call d_mat_nonloc(sder(ix,icol),
     &                       fnl,dfnl,fnl00,dfnl00,
     &                       f,wk,is2,k,k2,iat2,nstate,1)
                     enddo      ! k2
                  enddo         ! ia2
               enddo            ! is2
                                ! end of one C1-optimization-cycle.
            enddo               ! k
         enddo                  ! ia
      enddo                     ! is


      dimtot=9*nat*nat
#ifdef PARALLEL
      call  GLOSUM(dimtot,sder)
#endif

      nrot=nsym
      if(parent) then
         if(indpg.NE.0 .AND. (nrot.NE.1 .OR. NTVEC .GT. 1)) then
            write (6,*) 'Symmetrizing second derivatives by SYMMAT'
c     symmetrize hessian
            call symmat(sder,scr,lscr,2)
         endif
         call symma(sder,3*nat)
c     write hessian to file hessian
         call DCOPY(dimtot,sder,1,hess,1)
         call DCOPY(dimtot,hess,1,hesssave,1)
         call hessout
c     write output file for molvib program
         call molvib(tau0,sder)
c     mass weighted force constants
         ix=0
         do is=1,nsp
            xmass=DSQRT(1.d0/pma0(is))
            do ia=1,na(is)
               do k=1,3
                  ix=ix+1
                  xma(ix)=xmass
               enddo
            enddo
         enddo
!$OMP parallel do private(i,j)
         do i=1,3*nat
            do j=1,3*nat
               sder(i,j)=sder(i,j)*xma(i)*xma(j)
            enddo
         enddo
         call DCOPY(dimtot,sder,1,sdersave,1)

C     ---  Purification, version 1 (no projection)  ------------
         write (6,*)
         write (6,'(66("*"))')
c     diagonalization
         call DSYEV('V','U',3*nat,sder,3*nat,vibe,scr,dimtot,info)
         if(info.ne.0) write (6,*) 'PHONONS_P: DSYEV failed (v1).'
!$OMP parallel do private(i)
         do i=1,3*nat
            vibe(i)=sign(5140.487d0*DSQRT(DABS(vibe(i))),vibe(i))
         enddo
         write (6,*) 'Raw second derivative matrix: No '
     &        //'trans/rot elimination'
         write (6,*) ' Harmonic frequencies in cm^-1:'
         write (6,'(4(f12.1))') (vibe(i),i=1,3*nat)
         call vibeig(vibe,eigen,3*nat,.true.)
C     ---  Purification, version 2 (original phonons_p) --------
         if(projout) then
            call DCOPY(dimtot,sdersave,1,sder,1)
c     purification from translation
            call settras(tras)
            write (6,*) 'Translations eliminated from'//
     &           ' second derivative matrix'
            if(rotout) then
               write (6,*) 'Rotations eliminated from'//
     &              ' second derivative matrix'
               call setrot(rot,tras)
            endif
            call rt_out(tras,rot,sder,nat,rotout)
c     diagonalization
            call DSYEV('V','U',3*nat,sder,3*nat,vibe,scr,dimtot,info)
            if(info.ne.0) write (6,*) 'PHONONS_P: DSYEV failed (v2).'
!$OMP parallel do private(i)
            do i=1,3*nat
               vibe(i)=sign(5140.487d0*DSQRT(DABS(vibe(i))),vibe(i))
            enddo
            write (6,*) ' Harmonic frequencies in cm^-1:'
            write (6,'(4(f12.1))') (vibe(i),i=1,3*nat)
            call vibeig(vibe,eigen,3*nat,.false.)
         endif
C     ---  Purification, version 3 (lr_* variant) --------------
         call DCOPY(dimtot,hesssave,1,sder,1) ! not yet mass-weighted!
         call DCOPY(dimtot,hesssave,1,hess,1)
ctu   --- purification only AFTER mass weighting of the Hessian
ctu      call purged(sder,hess,tau0)
!$OMP parallel do private(i,j)
         do i=1,3*nat
            do j=1,3*nat
               sder(i,j)=sder(i,j)*xma(i)*xma(j)
            enddo
         enddo
         call purged(sder,hess,tau0)
         call DSYEV('V','U',3*nat,sder,3*nat,vibe,scr,dimtot,info)
         if(info.ne.0) write (6,*) 'PHONONS_P: DSYEV failed (v3).'
!$OMP parallel do private(i)
         do i=1,3*nat
            vibe(i)=sign(5140.487d0*DSQRT(DABS(vibe(i))),vibe(i))
         enddo
         write (6,*) 'Projection (by PURGED routine):'
         write (6,*) ' Harmonic frequencies in cm^-1:'
         write (6,'(4(f12.1))') (vibe(i),i=1,3*nat)
         call vibeig(vibe,eigen,3*nat,.false.)
      end if
c
      if(tmemchk) call print_memory      
      call freem(ip_rho0G)
      call freem(ip_v1_loc)
      call freem(ip_v1_nonloc)
      call freem(ip_eirop1)
      call freem(ip_fnl00)
      call freem(ip_dfnl00)
      call freem(ip_ddfnl00)
      if (parent) then
         call freem(ip_eigen)
         call freem(ip_vibe)
         call freem(ip_xma)
         call freem(ip_hess) 
      endif
      call freem(ip_sder)
      call freem(ip_sdersave)
      call freem(ip_rot)
      call freem(ip_tras)

      call tihalt('    phonon',isub)
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
      subroutine rt_out(tras,rot,sder,nat,rotout)
c     ==--------------------------------------------------------------==
      implicit none

      integer i,j,k,nat
      real*8 tras(3*nat,*),rot(3*nat,*)
      real*8 sder(3*nat,*),sder1(3*nat,*),proj(3*nat,*)
      logical rotout

      pointer(ip_sder1,sder1),(ip_proj,proj)
      call memory(ip_sder1,9*nat*nat,'sder1')
      call azzero(sder1,9*nat*nat)
      call memory(ip_proj,9*nat*nat,'proj')
      call azzero(proj,9*nat*nat)
cc ... P <-- 1-P      
c      do i=1,3*nat
c         proj(i,i)=proj(i,i)+1.d0
c      end do


      call unitmx(proj,3*nat)
c ... P <-- P - T.T^t
      CALL DGEMM ('N','T',3*nat,3*nat,3,-1.d0,tras,3*nat,
     &     tras,3*nat,1.d0,proj,3*nat) 

c ... P <-- P - R.R^t
      if (rotout) then
         CALL DGEMM ('N','T',3*nat,3*nat,3,-1.d0,rot,3*nat,
     &        rot,3*nat,1.d0,proj,3*nat) 
      endif

      
c ... (1-P).H
      call DGEMM('N','N',3*NAT,3*NAT,3*nat,1.d0,proj,3*nat,
     &     sder,3*nat,0.d0,sder1,3*nat)

c ... H.(1-P)
      call azzero(sder,9*nat*nat)
      call DGEMM('N','N',3*NAT,3*NAT,3*nat,1.d0,sder1,3*nat,
     &     proj,3*nat,0.d0,sder,3*nat)

      call freem(ip_sder1)
      call freem(ip_proj)
      
      return
      end
c     ==================================================================
      subroutine setrot(rot,tras)
c     ==--------------------------------------------------------------==
      implicit none

      include 'system.h'
      include 'ions.inc'
      include 'coor.inc'
      include 'rmas.inc'
      include 'implhv.inc'
      include 'fft.inc'
      
      integer rr,nrot,indx(3),iat,is,ia,ix,k,i
      real*8 qt(3),rot(3*nat,3),tras(3*nat,3),DDOT,norm
      real*8 cx,cy,cz,ccm(3)
      EXTERNAL   DDOT

      PMAT0=0.D0
      DO IS=1,NSP
        PMAT0=PMAT0+PMA0(IS)*NA(IS)
      ENDDO
      
c ... definition of the COM
      CX=0.d0
      CY=0.d0
      CZ=0.d0
      DO IS=1,NSP
         DO IA=1,NA(IS)
            CX=CX+TAU0(1,IA,IS)*PMA0(IS)/PMAT0
            CY=CY+TAU0(2,IA,IS)*PMA0(IS)/PMAT0
            CZ=CZ+TAU0(3,IA,IS)*PMA0(IS)/PMAT0
         ENDDO
      ENDDO

c ... actual calculation of the rotational vectors
      nrot=3
      do rr=1,nrot

         indx(1)=rr
         indx(2)=rr+1
         if (indx(2).gt.3) indx(2)=indx(2)-3
         indx(3)=rr+2
         if (indx(3).gt.3) indx(3)=indx(3)-3

         iat=0
         do is=1,nsp
            do ia=1,na(is)
               ccm(1)=tau0(1,ia,is)-cx
               ccm(2)=tau0(2,ia,is)-cy
               ccm(3)=tau0(3,ia,is)-cz

               iat=iat+1
               qt(indx(1))=0.d0
               qt(indx(2))=-ccm(indx(3)) 
               qt(indx(3))=ccm(indx(2)) 
               norm = dsqrt(DDOT(3,qt,1,qt,1))

               if (rr.eq.2) then
                  do k=1,3
                     qt(k)=-qt(k)
                  enddo
               endif
               do k=1,3
                  ix=3*(iat-1)+k
                  rot(ix,rr)=qt(k)
               enddo

            enddo
         enddo
         
c ...  ortohgonalization wrt translation vectors
         do i=1,3
            norm = - DDOT(3*nat,rot(1,rr),1,tras(1,i),1)
            call DAXPY(3*nat, norm, tras(1,i),1,rot(1,rr),1)
         enddo

c.... orthogonalization wrt the previous rotation vectors
         if (rr.ge.2) then
            do i=1,rr-1
               norm = - DDOT(3*nat,rot(1,rr),1,rot(1,i),1)
               call DAXPY(3*nat, norm, rot(1,i),1,rot(1,rr),1)
            enddo
         endif

c ... normalization to 1
         norm = dsqrt(DDOT(3*nat,rot(1,rr),1,rot(1,rr),1))
         call DSCAL(3*nat, 1.d0/norm,rot(1,rr),1)
      enddo
                  
      return
      end
c     ==================================================================
      subroutine settras(tras)
c     ==--------------------------------------------------------------==
      implicit none
      INCLUDE 'system.h'
      include 'rmas.inc'
      include 'ions.inc'
      include 'prop.inc'
      include 'fft.inc'
c      include 'implhv.inc'
      integer i,is,j,k,l,m
      real*8 tras(3*nat,3),norm,DDOT
      EXTERNAL   DDOT

c ... definition of the vectors describing the COM translation, 
c ... vectors orthogonal by definition, tras(3*nat,3)

c ... stopping COM
      if (tinr) then
         do m=1,3
            l=0
            do is=1,NSP
               do j=1,3*NA(is)
                  l=l+1
                  if (mod((l+m-1),3).eq.0) then
                     tras(l,m)=1.d0*pma0(is) 
                  else
                     tras(l,m)=0.d0
                  endif
               end do 
            end do
            norm = dsqrt(DDOT(3*nat,tras(1,m),1,tras(1,m),1))
            call DSCAL(3*nat, 1.d0/norm,tras(1,m),1)
         end do
      else
c ... mass weighted coordinates
         do m=1,3
            l=0
            do is=1,NSP
               do j=1,3*NA(is)
                  l=l+1
                  if (mod((l+m-1),3).eq.0) then
                     tras(l,m)=1.d0*dsqrt(PMA0(is)) 
                  else
                     tras(l,m)=0.d0
                  endif
               end do 
            end do
            norm = dsqrt(DDOT(3*nat,tras(1,m),1,tras(1,m),1))
            call DSCAL(3*nat, 1.d0/norm,tras(1,m),1)
         end do
      endif
      return
      end
c     ==================================================================
      subroutine give_scr_phonon(lphonon,tag,nstate)
      implicit none
      include 'system.h'        !nhg tgc
      include 'spin.inc'        !nlsd nlsx
      include 'ropt.inc'
      character*(*) tag
      integer lphonon,nstate,lrnlsm,lrho,lrhoofr,lrscpot,lforce1
c     ==--------------------------------------------------------------==
      lphonon=nstate
      calste=.false.
      call give_scr_rnlsm(lrnlsm,tag,nstate,.true.)
      call give_scr_rhoofr(lrho,tag)
      call give_scr_rscpot(lrscpot,tag,calste)
      call give_scr_rhoofr_p(lrhoofr,tag)
      call give_scr_forces_p(lforce1,tag,nstate)
      lrho=lrho+2*nhg*nlsd
      lrhoofr=lrhoofr+2*nhg*nlsd
      lforce1=lforce1
      lphonon=max(lrho,lrscpot,lrnlsm,lrhoofr,lphonon,lforce1)
      lphonon=lphonon+nstate*ngw*2
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
