C     ==================================================================
      SUBROUTINE PI_INIT
C     ==--------------------------------------------------------------==
C     ==    INITIALIZE PATH INTEGRAL RUNS                             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'pimd.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'fileopen.inc'

C     Variables
      REAL*8    APRIM(NP_TOTAL,*),AP(*),TNMTEMP(NP_TOTAL,*)
      POINTER   (IP_APRIM,APRIM),(IP_AP,AP),(IP_TNMTEMP,TNMTEMP)
      REAL*8    AUX(3*MAXNP),RPROC,RNP
      INTEGER   MSGLEN,I,NPP,NLOW,NHIGH,NPLOCAL,J,
     &          IP,MHIGH,IS,NPX,KP,JP,IOPT,MCNSTR,NSPAC1,NSPAC2,MLOW
#ifdef PARALLEL
      CHARACTER FILEOUT*12,FILEON*12
      INTEGER   IPP,I1,I2,LABEL
#endif
C     ==--------------------------------------------------------------==
      MSGLEN = 1 * 8
      CALL MY_BCAST(ECUT,MSGLEN,SOURCE,ALLGRP)
C..ALLGRP becomes SUPERGROUP
      GRANDPARENT=PARENT
      SUPERGROUP=ALLGRP
      SUPERSOURCE=SOURCE
      NPROC_TOT=NPROC
C..Number of processor groups
      IF(PARENT.AND.PC_GROUPS.EQ.0) THEN
        DO I=1,NPROC
          IF(MOD(NPROC,I).EQ.0) THEN
            NPP=NPROC/I
            IF(MOD(NP_TOTAL,NPP).EQ.0) THEN
              PC_GROUPS=NPP
              GOTO 100
            ENDIF
          ENDIF
        ENDDO
        PC_GROUPS=1
  100   CONTINUE
      ENDIF
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(PC_GROUPS,MSGLEN,SOURCE,ALLGRP)
      PC_GRP(1)=0
      PCG_POS=1
#ifdef PARALLEL
C..generate processor groups
      CALL IAZZERO(PGROUP,MAXCPU)
      CALL IAZZERO(NLINK,MAXCPU)
      RPROC=DBLE(NPROC)/PC_GROUPS
      DO I=1,PC_GROUPS
        NLOW=NINT((I-1)*RPROC)
        PC_GRP(I)=NLOW
        NHIGH=NINT(I*RPROC)-1
        IF(ME.GE.NLOW .AND. ME.LE.NHIGH) THEN
          NPROC=NHIGH-NLOW+1
          PARENT=NLOW.EQ.ME
          SOURCE=0
          MEPOS=ME-NLOW
          PCG_POS=I
          DO IP=1,NPROC
            PGROUP(IP)=NLOW+IP-1
            IPP=PGROUP(IP)
            NLINK(IPP)=IP-1
          ENDDO
          LABEL=I
        ENDIF
      ENDDO
      CALL MY_GROUP(NPROC,PGROUP(1),LABEL,ALLGRP,SUPERGROUP)
      CALL MY_SYNC(SUPERGROUP)
      LABEL=PC_GROUPS+1
      CALL MY_GROUP(PC_GROUPS,PC_GRP,LABEL,PARENTGROUP,SUPERGROUP)
      IF(LOUTFN.EQ.0) THEN
        IF(.NOT.GRANDPARENT) THEN
#if defined(__WINNT)
          WRITE(FILEON,'(I3)') PCG_POS
          CALL XSTRING(FILEON,I1,I2)
          FILEOUT='OUTPUT_'//FILEON(I1:I2)
          CLOSE(6)
          OPEN(UNIT=6,FILE=FILEOUT)
#else
          CLOSE(6)
          OPEN(UNIT=6,FILE='/dev/null')
#if defined(__Linux) || defined (ALPHALINUX)
C     AK: we need to do the same with the c-style stdout for printmemsize
          CALL SILENTSTDOUT
#endif
#endif
        ENDIF
      ELSEIF(LOUTFN.EQ.1) THEN
        IF(PARENT.AND..NOT.GRANDPARENT) THEN
          WRITE(FILEON,'(I3)') PCG_POS
          CALL XSTRING(FILEON,I1,I2)
          FILEOUT='OUTPUT_'//FILEON(I1:I2)
          CLOSE(6)
          OPEN(UNIT=6,FILE=FILEOUT)
#if defined(__Linux) || defined (ALPHALINUX)
C     avoid printmemsize messes
          CALL SILENTSTDOUT
#endif
        ELSEIF(.NOT.GRANDPARENT) THEN
#if defined(__WINNT)
          WRITE(FILEON,'(I3)') PCG_POS
          CALL XSTRING(FILEON,I1,I2)
          FILEOUT='OUTPUT_'//FILEON(I1:I2)
          CLOSE(6)
          OPEN(UNIT=6,FILE=FILEOUT)
#else
          CLOSE(6)
          OPEN(UNIT=6,FILE='/dev/null')
#if defined(__Linux) || defined (ALPHALINUX)
C     AK: we need to do the same with the c-style stdout for printmemsize
          CALL SILENTSTDOUT
#endif
#endif
        ENDIF
      ELSEIF(LOUTFN.EQ.2) THEN
        IF(.NOT.GRANDPARENT) THEN
          WRITE(FILEON,'(I3)') ME
          CALL XSTRING(FILEON,I1,I2)
          FILEOUT='OUTPUT_'//FILEON(I1:I2)
          CLOSE(6)
          OPEN(UNIT=6,FILE=FILEOUT)
#if defined(__Linux) || defined (ALPHALINUX)
C     avoid printmemsize messes
          CALL SILENTSTDOUT
#endif
        ENDIF
      ENDIF
#endif
C..establish connection Trotter index with pc-group
      RPROC=DBLE(NP_TOTAL)/PC_GROUPS
      DO I=1,PC_GROUPS
        NLOW=NINT((I-1)*RPROC) + 1
        NHIGH=NINT(I*RPROC)
        NPLOCAL=NHIGH-NLOW+1
        DO J=NLOW,NHIGH
          NUM_NP(J)=I
        ENDDO
        IF(PCG_POS.EQ.I) THEN
          NP_LOW=NLOW
          NP_HIGH=NHIGH
          NP_LOCAL=NPLOCAL
        ENDIF
      ENDDO
C..Connectivity of replica
      DO IP=1,NP_TOTAL
        IPP1(IP)=IP+1
        IPM1(IP)=IP-1
      ENDDO
      IPP1(NP_TOTAL)=1
      IPM1(1)=NP_TOTAL
C..Print some info
      IF(GRANDPARENT) THEN
        WRITE(6,'(A,A)') ' >>>>       PC_GROUP',
     *              '        PROCESSORS        TROTTER INDICES'
        RPROC=DBLE(NP_TOTAL)/PC_GROUPS
        DO I=1,PC_GROUPS
          NLOW=NINT((I-1)*RPROC) + 1
          NHIGH=NINT(I*RPROC)
          MLOW=PC_GRP(I)
          IF(I.EQ.PC_GROUPS) THEN
            MHIGH=NPROC_TOT-1
          ELSE
            MHIGH=PC_GRP(I+1)-1
          ENDIF
          WRITE(6,'(A,5X,I4,10X,I4,A,I4,12X,I3,A,I3)') ' >>>>   ',I,
     *                      MLOW,' - ',MHIGH,NLOW,' - ',NHIGH
        ENDDO
        WRITE(6,'(A)') ' >>>>'
      ENDIF
C..initalize masses
CDM1
C..note:  the mass variables PMA(NSP), PMATOT, PMAT0 were already
C..       initialized in 'setsys.F', but without the WMASS scaling
C..       factor, this is now also done: 
CDM2
C
C         KEY TO MASS VARIABLES:
C         PMAR0   real mass for primitive prop in chemical units
C         PMAR    real mass for primitive prop in au
C         PMARS   real mass for mode      prop in au
C         PMA0    fict mass for primitive prop in chemical units
CDM1
C         PMAT0   total "  "
CDM2
C         PMA     fict mass for primitive prop in au
CDM1
C         PMATOT  total "  "
CDM2
C         PMA0S   fict mass for mode      prop in au
C
CDM1
      PMAT0=0.D0
      PMATOT=0.D0
CDM2
      DO IS=1,NSP
CDM1 delete following line
C         STORE REAL IONIC MASS (IN CHEMICAL UNITS) IN PMAR0
CDM2
C         STORE REAL IONIC MASS (IN CHEMICAL UNITS) IN PMAR0
        PMAR0(IS)=PMA0(IS)
C         STORE REAL IONIC MASS (IN ATOMIC UNITS) IN PMAR
        PMAR(IS)=PMAR0(IS)*SCMASS
C         STORE FICTITIOUS IONIC MASS (IN CHEMICAL UNITS) IN PMA0
        PMA0(IS)=PMAR0(IS)*WMASS
CDM1
C         STORE TOTAL FICTITIOUS MASS (IN CHEMICAL UNITS) IN PMAT0
        PMAT0=PMAT0+PMA0(IS)*NA(IS)
C         STORE FICTITIOUS IONIC MASS (IN ATOMIC UNITS) IN PMA
        PMA(IS)=PMA0(IS)*SCMASS
C         STORE TOTAL FICTITIOUS MASS (IN ATOMIC UNITS) IN PMATOT
        PMATOT=PMATOT+PMA(IS)*NA(IS)
CDM2       
      ENDDO
CNM
CNM:  IF NORMAL MODES, SET UP TRANSFORMATION MATRICES AND
CNM   CALCULATE NORMAL MODE FREQUENCIES AND DETERMINE MASSES
CNM   FLNM(NPX): contains normal mode frequencies
CNM   TNM(NPX,NPX): contains normal mode transformation matrix
CNM                 PRIMITIVE->NM
CNM   TNMI(NPX,NPX): NM->PRIMITIVE transformation
CNM1
      IF(TPINM.OR.TREAD_CENT) THEN
        IF(NP_TOTAL.EQ.1)
     *    CALL STOPGM('PI_INIT','NO MODE TRANSFORMATION WITH NP=1')
        NPX=NP_TOTAL
        RNP=DBLE(NPX)
        CALL MEMORY(IP_TNM,NPX*NPX,'TNM')
        CALL MEMORY(IP_TNMI,NPX*NPX,'TNMI')
        CALL MEMORY(IP_APRIM,NPX*NPX,'APRIM')
        CALL MEMORY(IP_AP,((NPX+1)*NPX)/2,'AP')
        CALL MEMORY(IP_TNMTEMP,NPX*NPX,'TNMTEMP')
        CALL AZZERO(APRIM,NPX*NPX)
        DO IP=2,NPX-1
          APRIM(IP,IP-1) = -1.D0
          APRIM(IP,IP) = 2.D0
          APRIM(IP,IP+1) = -1.D0
        ENDDO
        APRIM(1,1) = 2.D0
        APRIM(1,2) = -1.D0
        APRIM(NPX,NPX) = 2.D0
        APRIM(NPX,NPX-1) = -1.D0
        APRIM(1,NPX) = -1.D0
        APRIM(NPX,1) = -1.D0
C
        KP=0
        DO IP=1,NPX
         DO JP=IP,NPX
           KP = KP + 1
           AP(KP) = APRIM(IP,JP)
         ENDDO
        ENDDO
C
        IOPT=1
        CALL DSPEVY(IOPT,AP,FLNM,TNMTEMP,NPX,NPX,AUX,3*NPX)
C
        DO IP=1,NPX
          FLNM(IP) = FLNM(IP)*RNP
        ENDDO
C
        DO IP=1,NPX
          DO JP=1,NPX
            TNM(IP,JP) = -TNMTEMP(JP,IP)/DSQRT(RNP)
            TNMI(IP,JP) = -TNMTEMP(IP,JP)*DSQRT(RNP)
          ENDDO
        ENDDO
C       SOMETIMES THE DIAGONALIZER "DSPEVY" GIVES THE WRONG
C       PHASE OF THE DIAGONAL MATRIX, FIX THE SIGN IN THIS CASE:
        IF (TNMI(1,1) .LE. 0.0D0) THEN
          DO IP=1,NPX
            DO JP=1,NPX
              TNM(IP,JP) = -TNM(IP,JP)
              TNMI(IP,JP) = -TNMI(IP,JP)
            ENDDO
          ENDDO
        END IF
C           MASS SETTINGS FOR NORMAL MODE REPRESENTATION
C           NORMAL MODE TRAFO FOR REAL PHYSICAL MASSES (FOR POTENTIAL ENERGY)
        DO IS=1,NSP
          PMARS(IS,1)=PMAR(IS)
CDM          PMARS(IS,1)=PMAR(IS)*FACSTAGE
          DO IP=2,NPX
            PMARS(IS,IP)=PMAR(IS)*FLNM(IP)
          ENDDO
CDM1
C  delete following 3 lines
C           FICTITIOUS NORMAL MODE MASSES (FOR FICTICIOUS KINETIC ENERGY)
C           ARE WMASS-TIMES HEAVIER THAN PHYSICAL MASSES AND ARE
C           SCALED BY THE NORMAL MODE FREQUENCIES.
C         MASS DISPARITY FOR CENTROID DYNAMICS:
C         THE NON-CENTROID BEADS ARE FACSTAGE TIMES LIGHTER THAN
C         CENTROID BEADS
C         NOTE: THIS CREATES BOLTZMANN DISTRIBUTION
CDM2
CDM1
          PMA0S(IS,1)=PMARS(IS,1)*WMASS
          DO IP=2,NPX
CDM           DO IP=1,NPX
CDM            PMA0S(IS,IP)=PMARS(IS,IP)*WMASS
            PMA0S(IS,IP)=PMARS(IS,IP)*WMASS/FACSTAGE
CDM2
          ENDDO
        ENDDO
        CALL FREEM(IP_APRIM)
        CALL FREEM(IP_AP)
        CALL FREEM(IP_TNMTEMP)
      ENDIF
      IF(TSTAGE) THEN
C           MASS SETTINGS FOR STAGING REPRESENTATION
C           STAGING TRAFO FOR REAL PHYSICAL MASSES (FOR POTENTIAL ENERGY)
        NPX=NP_TOTAL
        RNP=DBLE(NPX)
        DO IS=1,NSP
CDM1
CDM          PMARS(IS,1)=PMAR(IS)*FACSTAGE
          PMARS(IS,1)=PMAR(IS)
CDM2
          DO IP=2,NPX
            PMARS(IS,IP)=PMAR(IS)*IP/(IP-1)
          ENDDO
CDM2
C  delete following 2 lines
C           FICTITIOUS STAGING MASSES (FOR FICTICIOUS KINETIC ENERGY)
C           ARE WMASS-TIMES HEAVIER THAN PHYSICAL MASSES
C         MASS DISPARITY FOR STAGING CENTROID DYNAMICS:
C         THE NON-CENTROID BEADS ARE FACSTAGE TIMES LIGHTER THAN
C         CENTROID BEADS
C         NOTE: THIS CREATES WIGNER DISTRIBUTION
CDM2
CDM1
          PMA0S(IS,1)=PMARS(IS,1)*WMASS
          DO IP=2,NPX
CDM          DO IP=1,NPX
CDM            PMA0S(IS,IP)=PMARS(IS,IP)*WMASS
            PMA0S(IS,IP)=PMARS(IS,IP)*WMASS/FACSTAGE
          ENDDO
CDM2
        ENDDO
      ENDIF
CDM1
C..print detailed information about final mass settings in PI case
      IF(GRANDPARENT) THEN
          WRITE(6,*)
          WRITE(6,'(A,A)') ' ****************** FINAL MASS ',
     *                   'SETTINGS IN AMU ******************'
          WRITE(6,'(A)') ' PRIMITIVE MASSES '
          WRITE(6,'(A)') '  TYPE       REAL MASS        FICTITIOUS MASS'
          DO IS=1,NSP
            WRITE(6,'(2X,A2,6X,F10.4,7X,F10.4)')
     *                EL(IATYP(IS)),PMAR0(IS),PMA0(IS)
          ENDDO
          IF(TSTAGE.OR.TPINM) THEN
            DO IS=1,NSP
              WRITE(6,'(A)') ' MODE TRANSFORMED MASSES '
              WRITE(6,'(A)')
     *        '  TYPE       REAL MASS        FICTITIOUS MASS FOR IP'
              DO IP=1,NP_TOTAL
                WRITE(6,'(2X,A2,6X,F10.4,7X,F10.4,11X,I4)')
     *                EL(IATYP(IS)),
     *                PMARS(IS,IP)/SCMASS,PMA0S(IS,IP)/SCMASS,IP
              ENDDO
            ENDDO
          ENDIF
          WRITE(6,'(A,F8.4)') ' FICTITIOUS ELECTRON MASS: ',
     *                      EMASS/SCMASS
          WRITE(6,'(A,A)') ' *********************************',
     *                     '*******************************'
      ENDIF
C..Constraints
      IF(PCG_POS.NE.1) MCNSTR=0
C..Allocate space for radius of gyration
      CALL MEMORY(IP_RGYR,NAX*NSX,'RGYR')
      CALL MEMORY(IP_RGYRA,2*NAX*NSX,'RGYRA')
      CALL MEMORY(IP_RSUS,NAX*NSX,'RSUS')
      CALL MEMORY(IP_RSUSA,2*NAX*NSX,'RSUSA')
      CALL MEMORY(IP_RCOR,NAX*NSX,'RCOR')
      CALL MEMORY(IP_RCORA,2*NAX*NSX,'RCORA')
C..Allocate space for correlation function
      NSPAC1=NAX*NSX*NP_TOTAL/IRAT + 1
      NSPAC2=NAX*NSX*NP_TOTAL
      CALL MEMORY(IP_IRCORR,NSPAC1,'IRCORR')
      CALL MEMORY(IP_IFCORR,NSPAC1,'IFCORR')
      CALL MEMORY(IP_RCORR,NSPAC2,'RCORR')
      CALL MEMORY(IP_FCORR,NSPAC2,'FCORR')
C..Distribute information to all parents
C..FPATH
      IF(PARENT) THEN
        CALL SENDCHAR(FPATH,FO_FPATH_MAX,SUPERSOURCE,PARENTGROUP)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
