C     ==================================================================
      SUBROUTINE PI_MD(C0,CM,C2,SC0,GAMX,GAMY)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc' 
      INCLUDE 'ener.inc' 
      INCLUDE 'elct.inc' 
      INCLUDE 'tpar.inc' 
      INCLUDE 'pslo.inc' 
      INCLUDE 'ions.inc' 
      INCLUDE 'soft.inc' 
      INCLUDE 'nose.inc' 
      INCLUDE 'norm.inc' 
      INCLUDE 'ropt.inc' 
      INCLUDE 'cppt.inc' 
      INCLUDE 'coor.inc' 
      INCLUDE 'geq0.inc' 
      INCLUDE 'spin.inc' 
      INCLUDE 'irat.inc' 
      INCLUDE 'nlcc.inc' 
      INCLUDE 'cotr.inc' 
      INCLUDE 'pimd.inc' 
      INCLUDE 'filn.inc' 
      INCLUDE 'isos.inc' 
      INCLUDE 'store.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      COMPLEX*16 C0(NGW,N,*),CM(NGW,N,*),C2(NGW,N,*),SC0(NGW,*)
      REAL*8     GAMX(N*N,*),GAMY(N*N,*)
C     Variables
      DIMENSION  F(*)
      CHARACTER  FILEN*100,CFLBOD*12,CIPNUM*12
      LOGICAL    FERROR,TESTSTORE
      REAL*8     ACCUS(NACX,MAXNP),DISA(MAXNP),TEMPP(MAXNP),EHAM(MAXNP),
     *           ECONS(MAXNP),EKINC(MAXNP),ENOSE(MAXNP),ENOSP(MAXNP)
      REAL*8     TAUI(3*NAX*NSX,*),TAUR(*),EIGV(N,*),EIGM(N*N,*)
      POINTER    (IP_TAUI,TAUI), (IP_TAUR,TAUR),
     &           (IP_EIGV,EIGV),(IP_EIGM,EIGM)
      REAL*8     STAGEP(3*NAX*NSX,*),VSTAGE(3*NAX*NSX,*),
     &           FSTAGE(3*NAX*NSX,*)
      POINTER    (IP_STAGEP,STAGEP),(IP_VSTAGE,VSTAGE),
     *           (IP_FSTAGE,FSTAGE)
      COMPLEX*16 PSI(NNR1,NLSD)
      REAL*8     RHOE(NNR1,NLSD),SCR(*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
      INTEGER    IREC(100)
CNEW
      REAL*8     PIFION(3*NAX*NSX,*),PITAUP(3*NAX*NSX,*),
     *           PIVELP(3*NAX*NSX,*)
      POINTER    (IP_PIFION,PIFION),(IP_PITAUP,PITAUP),
     *           (IP_PIVELP,PIVELP)
CNEW
      CHARACTER  TAG*30
      REAL*8     TIME1,TIME2,TIMEF,FF,RNP,EKINCP,EKIN1,EKIN2,
     &           TEMP1,TEMP2,DUMMY,TCPU,EKINP,GLIB_S,QPKINP,QVKINP,
     &           EKINA,ETOTA,ECONSA,EHAMA,TEMPA,EQUANT,D1,D2,
     &           EKINH1,EKINH2
      EXTERNAL   TIMEF
      INTEGER    NPX,I,IL_RHOE,IL_PSI,LSCR,N1,N2,I1,I2,IPX,MSGLEN,NREPL,
     &           K,L,IP,ITEMP
C     ==--------------------------------------------------------------==
      NFNOW=1
      TIME1 = TIMEF()
      NPX=NP_TOTAL
      RNP=DBLE(NPX)
      CALL MEMORY(IP_TAUP,3*NAX*NSX*NPX,'TAUP')
      CALL MEMORY(IP_FION,3*NAX*NSX*NPX,'FION')
      CALL MEMORY(IP_VELP,3*NAX*NSX*NPX,'VELP')
      CALL MEMORY(IP_TAUI,3*NAX*NSX*NPX,'TAUI')
      CALL MEMORY(IP_TAUR,3*NAX*NSX,'TAUR')
      CALL MEMORY(IP_FIONKS,3*NAX*NSX*NPX,'FIONKS')
      IF(TSTAGE.OR.TPINM) THEN
        CALL MEMORY(IP_STAGEP,3*NAX*NSX*NPX,'STAGEP')
        CALL MEMORY(IP_VSTAGE,3*NAX*NSX*NPX,'VSTAGE')
        CALL MEMORY(IP_FSTAGE,3*NAX*NSX*NPX,'FSTAGE')
      ENDIF
      IF(TIVAN.OR.NONORT) THEN
        CALL MEMORY(IP_EIGV,N*NP_LOCAL,'EIGV')
        CALL MEMORY(IP_EIGM,N*N*NP_LOCAL,'EIGM')
      ENDIF
      NACC = 30
      CALL AZZERO(ACCUS,NACX*MAXNP)
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=TPRES
      IF(THARM.AND.PARENT) THEN
        FF=F(1)
        DO I=1,N
          IF(FF.NE.F(I)) THEN
CDM1
CDM            WRITE(6,'(A,A)') ' HARMONIC REFERENCE SYSTEM INTEGRATION',
            IF(GRANDPARENT) 
     *      WRITE(6,'(A,A)') ' HARMONIC REFERENCE SYSTEM INTEGRATION',
     *      ' ONLY POSSIBLE WITH EQUAL OCCUPATION NUMBERS'
            CALL STOPGM('MDMAIN',' ')
          ENDIF
        ENDDO
      ENDIF
CNEW  EQUIVALENCE FION <-> PIFION 
      CALL GET_ADDR(IP_PIFION,FION(1,1,1))
      CALL GET_ADDR(IP_PIVELP,VELP(1,1,1))
      CALL GET_ADDR(IP_PITAUP,TAUP(1,1,1))
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL GIVE_SCR_MDMAIN(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
C..TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
C..PARAMETERS FOR THE NOSE-HOOVER THERMOSTATS
      IF((TNOSEE.OR.TNOSEP).AND.PARENT) CALL NOSEPA(NP_LOW,NP_HIGH)
C..INITIALIZATION OF WAVEFUNCTION AND COORDINATS
      CALL AZZERO(ACC,NACC)
      CALL READ_IREC(IREC)
      DO IPCURR=NP_LOW,NP_HIGH
C..Construct filenames
        CFLBOD='RESTART_'
        WRITE(CIPNUM,'(I4)') IPCURR
        CALL XSTRING(CFLBOD,N1,N2)
        CALL XSTRING(CIPNUM,I1,I2)
        FILBOD=CFLBOD(N1:N2)//CIPNUM(I1:I2)//'.1'
        IF(RLATE) THEN
          FILN=FILBOD
        ELSE
          FILN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
        ENDIF
C..Read restart file
        IPX=IPCURR-NP_LOW+1
        CALL ZHRWF(1,IREC,C0(1,1,IPX),CM(1,1,IPX),N,DUMMY,
     *             PITAUP(1,IPCURR),
     *             PIVELP(1,IPCURR),TAUI(1,IPCURR),NFI)
        CALL DCOPY(NACC,ACC,1,ACCUS(1,IPCURR),1)
        IF(RGEO.AND.PARENT) 
     *     CALL GEOFILE(PITAUP(1,IPCURR),PIVELP(1,IPCURR),'READ')
C..Randomization of the atomic coordinates
        IF(TRANP.AND.PARENT) CALL RANP(PITAUP(1,IPCURR)) 
      ENDDO
C..Global distribution of ionic positions
      CALL GLOBAL(PITAUP,3*NAX*NSX)
      MSGLEN = 3*NAX*NSX*NPX * 8
      CALL MY_BCAST(PITAUP,MSGLEN,SOURCE,ALLGRP)
      IF(PARENT) THEN
        IF(TSTAGE) THEN
          CALL STAGETRANS(PITAUP,STAGEP,0)
          CALL DCOPY(3*NAX*NSX,STAGEP,1,TAU0,1)
        ELSEIF(TPINM) THEN
          CALL PINMTRANS(PITAUP,STAGEP,0)
          CALL DCOPY(3*NAX*NSX,STAGEP,1,TAU0,1)
        ENDIF
C..Setup for constraints and degrees of freedom
        CALL DETDOF(TAU0,TAUR)
        CALL QMDOF
      ELSE
        GLIB=1.D0
      ENDIF
      DO IPCURR=NP_LOW,NP_HIGH
        IPX=IPCURR-NP_LOW+1
        CALL PHFAC(PITAUP(1,IPCURR))
        IF(TIVAN) THEN
          IF(TLSD) THEN
            CALL DEORT(NGW,NSUP,EIGM(1,IPX),EIGV(1,IPX),
     *                 C0(1,1,IPX),SC0(1,1),SCR,LSCR)
            CALL DEORT(NGW,NSDOWN,EIGM(1,IPX),EIGV(1,IPX),
     *                 C0(1,NSUP+1,IPX),SC0(1,NSUP+1),SCR,LSCR)
          ELSE
            CALL DEORT(NGW,N,EIGM(1,IPX),EIGV(1,IPX),
     *                 C0(1,1,IPX),SC0,SCR,LSCR)
          ENDIF
        ENDIF
C..Initialize velocities
        IF(.NOT.RVEL) THEN
          ECNSTR = 0.0D0
          ERESTR = 0.0D0
          IF(TPINM.OR.TSTAGE) THEN
            CALL S_RINVEL(VSTAGE(1,IPCURR),CM(1,1,IPX),N,IPCURR)
            IF(PARENT.AND.IPCURR.EQ.1) CALL RATTLE(STAGEP,VSTAGE)
            IF(IPCURR.EQ.1) CALL RVSCAL(VSTAGE(1,IPCURR))
          ELSE
            CALL RINVEL(PIVELP(1,IPCURR),CM(1,1,IPX),N)
          ENDIF
        ENDIF
        IF(QUENCHP) THEN
          IF(TPINM.OR.TSTAGE) THEN
            CALL AZZERO(VSTAGE(1,IPCURR),3*NAX*NSX)
          ELSE
            CALL AZZERO(PIVELP(1,IPCURR),3*NAX*NSX)
          ENDIF
        ENDIF
        IF(QUENCHE) CALL ZAZZERO(CM(1,1,IPX),NGW*N)
      ENDDO
C..Global distribution of ionic velocities
      IF(TSTAGE.OR.TPINM) THEN
        IF(RVEL) THEN
          CALL GLOBAL(PIVELP,3*NAX*NSX)
          IF(PARENT) THEN
            IF(TSTAGE) THEN
              CALL STAGETRANS(PIVELP,VSTAGE,0)
            ELSEIF(TPINM) THEN
              CALL PINMTRANS(PIVELP,VSTAGE,0)
            ENDIF
          ENDIF
        ELSE
          CALL GLOBAL(VSTAGE,3*NAX*NSX)
          IF(PARENT) THEN
            IF(TSTAGE) THEN
              CALL STAGETRANS(PIVELP,VSTAGE,1)
            ELSEIF(TPINM) THEN
              CALL PINMTRANS(PIVELP,VSTAGE,1)
            ENDIF
          ENDIF
        ENDIF
      ELSE
        CALL GLOBAL(PIVELP,3*NAX*NSX)
      ENDIF
      IF(PARENT) THEN
C..Reset accumulators
        IF(.NOT.RAC) THEN
          NFI=0
          CALL AZZERO(ACCUS,NACX*MAXNP)
          CALL DCOPY(3*NAX*NSX*NPX,PITAUP,1,TAUI,1)
        ENDIF
      ENDIF
C..Initialize forces
      DO IPCURR=NP_LOW,NP_HIGH
        IPX=IPCURR-NP_LOW+1
        CALL PHFAC(PITAUP(1,IPCURR))
        IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,CALSTE)
        CALL FORCEDR(C0(1,1,IPX),C2(1,1,IPX),SC0,RHOE,PSI,
     *               PITAUP(1,IPCURR),PIFION(1,IPCURR),EIGV,
     *               SCR,LSCR,N,1,.FALSE.,.TRUE.)
        CALL DSCAL(3*NAX*NSX,1.D0/RNP,PIFION(1,IPCURR),1)
        CALL DCOPY(3*NAX*NSX,PIFION(1,IPCURR),1,FIONKS(1,1,1,IPCURR),1)
        CALL FHARM(PITAUP,PIFION(1,IPCURR),IPCURR,.TRUE.)
        CALL PI_ENER(IPCURR,0)
        IF(IPCURR.EQ.NP_LOW) CALL FREQS(N,.FALSE.)
C..Check orthogonality condition for wavefunction velocities
        CALL RORTV(C0(1,1,IPX),CM(1,1,IPX),C2(1,1,IPX),SC0,
     *             GAMY(1,IPX),N,SCR,LSCR)
      ENDDO
      IF(PARENT) THEN
        CALL GLOBAL(FIONKS,3*NAX*NSX)
        IF(TSTAGE) THEN
          CALL GETFU(FIONKS,FSTAGE,STAGEP,1)
          CALL TAUCL(FSTAGE)
        ELSEIF(TPINM) THEN
          CALL GETFNM(FIONKS,FSTAGE,STAGEP,1)
          CALL TAUCL(FSTAGE)
        ENDIF
C..Initialize thermostats
        DO IPCURR=NP_LOW,NP_HIGH
          ITEMP=IREC(IREC_NOP1)+IREC(IREC_NOP2)+IREC(IREC_NOP3)
     *        +IREC(IREC_NOP4)
          IF(TNOSEP .AND. ITEMP.EQ.0) CALL NOSPINIT(IPCURR)
          IF(TNOSEE .AND. .NOT.RNOE) CALL NOSEINIT(IPCURR)
CDM1
C..Centroid PICPMD: Set thermostat variables to zero in case 
C..of a centroid restart from a non-centroid thermosatted run
          IF(TNOSEP.AND.TCENTRO.AND.IPCURR.EQ.1) THEN
            NREPL=MAXNP
            IF(TULTRA) THEN
C..Not used with PICPMD 
            ELSEIF(TLOCT) THEN
               CALL STOPGM('PI_MD','LOCAL TEMEPERATURE NOT IMPLEMENTED')
            ELSEIF(TMNOSE) THEN
              DO K=1,3*NAX*NSX
                DO L=1,NCHX
                  ETAPM(K,L,1)=0.d0
                  ETAPMDOT(K,L,1)=0.d0
                ENDDO
              ENDDO
            ELSE
              DO L=1,NCHX
                ETAP1(L,1)=0.d0
                ETAP1DOT(L,1)=0.d0
              ENDDO
            ENDIF
          ENDIF
CDM2
        ENDDO
      ENDIF
      IF(GRANDPARENT) THEN
        IF(LEVPRT.GE.5) THEN
          DO IP=1,NP_TOTAL
            WRITE(6,'(A,I3)') ' *** REPLICA :',IP
            CALL WRGEOF(PITAUP(1,IP),PIFION(1,IP))
          ENDDO
        ENDIF
        CALL GETGYRATION(PITAUP)
        CALL GETCOR(PITAUP)
        CALL PRTGYR
        FILEN='ENERGIES'
        CALL FILEOPEN(3,FILEN,FO_APP+FO_VERB+FO_MARK,FERROR)
C..END INITIALIZATION
        CALL PRMEM('     PI_MD')
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,F8.2,A)') ' TIME FOR INITIALIZATION',
     *                        TCPU,' SECONDS'
      ENDIF
      CALL MY_SYNC(SUPERGROUP)
C     ==================================================================
C     ==          THE BASIC LOOP FOR MOLECULAR DYNAMICS               ==
C     ==                 USING VELOCITY VERLET                        ==
C     ==================================================================
      DO INFI=1,NOMORE
        TIME1=TIMEF()
        NFI=NFI+1
        PRTEIG=MOD(NFI-1,IPRINT_STEP).EQ.0
        IF(.NOT.PARENT) PRTEIG=.FALSE.
        ENGPRI=MOD(NFI-1,IPRINT_STEP).EQ.0
C>>>>Replica loop
        DO IPCURR=NP_LOW,NP_HIGH
          IPX=IPCURR-NP_LOW+1
C..UPDATE NOSE THERMOSTATS
          IF(TSTAGE.OR.TPINM) THEN
            CALL NOSEUP(VSTAGE(1,IPCURR),CM(1,1,IPX),N,IPCURR)
          ELSE
            CALL NOSEUP(PIVELP(1,IPCURR),CM(1,1,IPX),N,IPCURR)
          ENDIF
C..UPDATE VELOCITIES
          IF(PARENT) THEN
            IF(TSTAGE.OR.TPINM) THEN
              CALL S_VELUPI(VSTAGE(1,IPCURR),FSTAGE(1,IPCURR),1,IPCURR)
            ELSE
              CALL VELUPI(PIVELP(1,IPCURR),PIFION(1,IPCURR),1)
            ENDIF
          ENDIF
          CALL VELUPA(C0(1,1,IPX),CM(1,1,IPX),C2(1,1,IPX),N,1)
C..UPDATE POSITIONS
          ECNSTR = 0.0D0
          ERESTR = 0.0D0
          IF(PARENT) THEN
            IF(TSTAGE.OR.TPINM) THEN
              CALL DCOPY(3*NAX*NSX,STAGEP(1,IPCURR),1,TAU0,1)
              CALL POSUPI(TAU0,STAGEP(1,IPCURR),VSTAGE(1,IPCURR))
              IF(MCNSTR.NE.0.AND.IPCURR.EQ.1) 
     *                         CALL CPMDSHAKE(TAU0,STAGEP,VSTAGE)
            ELSE
              CALL DCOPY(3*NAX*NSX,PITAUP(1,IPCURR),1,TAU0,1)
              CALL POSUPI(TAU0,PITAUP(1,IPCURR),PIVELP(1,IPCURR))
            ENDIF
          ENDIF
        ENDDO
C<<<<End of replica loop
        IF(PARENT) THEN
          IF(TPINM) THEN
            CALL GLOBAL(STAGEP,3*NAX*NSX)
            CALL PINMTRANS(PITAUP,STAGEP,1)
          ELSEIF(TSTAGE) THEN
            CALL GLOBAL(STAGEP,3*NAX*NSX)
            CALL STAGETRANS(PITAUP,STAGEP,1)
          ENDIF
        ENDIF
C..Synchronization point! Distribute new replica coordinates to all PE
        CALL MY_SYNC(SUPERGROUP)
        CALL GLOBAL(PITAUP,3*NAX*NSX)
        MSGLEN = 3*NAX*NSX*NPX * 8
        CALL MY_BCAST(PITAUP,MSGLEN,SOURCE,ALLGRP)
C>>>>Replica loop
        DO IPCURR=NP_LOW,NP_HIGH
          IPX=IPCURR-NP_LOW+1
          CALL PHFAC(PITAUP(1,IPCURR))
          IF(TINLC) THEN
            CALL COPOT(RHOE,PSI,SCR,LSCR,CALSTE)
          ENDIF
          CALL POSUPA(C0(1,1,IPX),CM(1,1,IPX),C2(1,1,IPX),
     *                GAMX(1,IPX),N,SCR,LSCR)
CDM     *                GAMX,N,SCR,LSCR)
C..CALCULATE THE FORCES
          CALSTE=TPRES.AND.MOD(NFI-1,NPRES).EQ.0
          CALL FORCEDR(C0(1,1,IPX),C2(1,1,IPX),SC0,RHOE,PSI,
     *               PITAUP(1,IPCURR),PIFION(1,IPCURR),EIGV,
     *               SCR,LSCR,N,1,.FALSE.,.TRUE.)
          CALL DSCAL(3*NAX*NSX,1.D0/RNP,PIFION(1,IPCURR),1)
          CALL DCOPY(3*NAX*NSX,PIFION(1,IPCURR),1,
     &                         FIONKS(1,1,1,IPCURR),1)
          CALL FHARM(PITAUP,PIFION(1,IPCURR),IPCURR,.TRUE.)
          CALL PI_ENER(IPCURR,0)
          IF(CALSTE) THEN
            CALL TOTSTR
          ENDIF
        ENDDO
C<<<<End of replica loop
        IF(PARENT) THEN
          CALL GLOBAL(FIONKS,3*NAX*NSX)
          IF(TPINM) THEN
            CALL GETFNM(FIONKS,FSTAGE,STAGEP,1)
            CALL TAUCL(FSTAGE)
          ELSEIF(TSTAGE) THEN
            CALL GETFU(FIONKS,FSTAGE,STAGEP,1)
            CALL TAUCL(FSTAGE)
          ENDIF
        ENDIF
C>>>>Replica loop
        DO IPCURR=NP_LOW,NP_HIGH
          IPX=IPCURR-NP_LOW+1
C..FINAL UPDATE FOR VELOCITIES
          ECNSTR = 0.0D0
          ERESTR = 0.0D0
          IF(PARENT) THEN
            IF(TPINM.OR.TSTAGE) THEN
              CALL S_VELUPI(VSTAGE(1,IPCURR),FSTAGE(1,IPCURR),1,IPCURR)
              IF(IPCURR.EQ.1) CALL RATTLE(STAGEP,VSTAGE)
            ELSE
              CALL VELUPI(PIVELP(1,IPCURR),PIFION(1,IPCURR),1)
            ENDIF
          ENDIF
          CALL VELUPA(C0(1,1,IPX),CM(1,1,IPX),C2(1,1,IPX),N,1)
          CALL RORTV(C0(1,1,IPX),CM(1,1,IPX),C2(1,1,IPX),
     *               SC0,GAMY(1,IPX),N,SCR,LSCR)
C..IONIC TEMPERATURE CONTROL
          IF(PARENT.AND.(TCP.OR.TRESCALE)) THEN
CDMra          IF(PARENT.AND.(TCP.OR.ANNE)) THEN
CDM          IF(PARENT) THEN
            IF(TPINM.OR.TSTAGE) THEN
              CALL S_EKINPP(EKINP,VSTAGE(1,IPCURR),IPCURR)
CDM1
C..GLIB is calculated in QMDOF for the first (staging) bead 
C..that is possible constraint and is 3*NAT for all other beads
CDM2
              GLIB_S=3.D0*NAT
              IF(IPCURR.EQ.1) GLIB_S=GLIB
              TEMPP(IPCURR)=EKINP*FACTEM*2.D0/GLIB_S
CDM1ra
CDM              CALL RSCVP(TEMP1,TEMP2,TEMPP(IPCURR),VSTAGE(1,IPCURR))
              IF(.NOT.TRESCALE) THEN
                CALL RSCVP(TEMP1,TEMP2,TEMPP(IPCURR),VSTAGE(1,IPCURR))
              ELSE
C..Re-adjust ionic velocities  only after restart to desired temperature
                IF(IPCURR.EQ.1) THEN
                  TCP=.TRUE.
                  CALL RSCVP(0.D0,0.D0,TEMPP(IPCURR),VSTAGE(1,IPCURR))
                  TCP=.FALSE.
                  TRESCALE=.FALSE.
                  WRITE(6,*)
                  WRITE(6,'(A,F12.2,A)')
     *            ' RESTARTED VELOCITIES FOR REPLICA IP=1 RESCALED TO ',
     *              TEMPW,' KELVIN'
                ENDIF
              ENDIF
CDM2ra
            ELSE
              CALL EKINPP(EKINP,PIVELP(1,IPCURR))
              TEMPP(IPCURR)=EKINP*FACTEM*2.D0/GLIB
CDM1ra              CALL RSCVP(TEMP1,TEMP2,TEMPP(IPCURR),PIVELP(1,IPCURR))
              IF(.NOT.TRESCALE) THEN
                CALL RSCVP(TEMP1,TEMP2,TEMPP(IPCURR),PIVELP(1,IPCURR))
              ELSE
C..Re-adjust ionic velocities  only after restart to desired temperature
                IF(IPCURR.EQ.1) THEN
                  TCP=.TRUE.
                  CALL RSCVP(0.D0,0.D0,TEMPP(IPCURR),PIVELP(1,IPCURR))
                  TCP=.FALSE.
                  TRESCALE=.FALSE.
                  WRITE(6,*)
                  WRITE(6,'(A,F12.2,A)')
     *            ' RESTARTED VELOCITIES FOR REPLICA IP=1 RESCALED TO ',
     *              TEMPW,' KELVIN'
                ENDIF
              ENDIF
CDM2ra
            ENDIF
          ENDIF
C..UPDATE NOSE THERMOSTATS
          IF(TNOSEE.OR.TC) CALL REKINE(CM(1,1,IPX),N,EKINC(IPCURR))
          IF(TSTAGE.OR.TPINM) THEN
            CALL NOSEUP(VSTAGE(1,IPCURR),CM(1,1,IPX),N,IPCURR)
          ELSE
            CALL NOSEUP(PIVELP(1,IPCURR),CM(1,1,IPX),N,IPCURR)
          ENDIF
          IF(PARENT) THEN
            IF(TPINM.OR.TSTAGE) THEN
              CALL S_EKINPP(EKINP,VSTAGE(1,IPCURR),IPCURR)
              GLIB_S=3.D0*NAT
              IF(IPCURR.EQ.1) GLIB_S=GLIB
              TEMPP(IPCURR)=EKINP*FACTEM*2.D0/GLIB_S
            ELSE
              CALL EKINPP(EKINP,PIVELP(1,IPCURR))
              TEMPP(IPCURR)=EKINP*FACTEM*2.D0/GLIB
            ENDIF
          ENDIF
C..RESCALE ELECTRONIC VELOCITIES
          IF(TC) CALL RSCVE(EKIN1,EKIN2,EKINC(IPCURR),
     *                      EKINW,CM(1,1,IPX),N,NGW)
C..MEAN SQUARE DISPLACEMENT OF DIFFERENT IONIC SPECIES
          IF(PARENT) CALL DISPP(PITAUP(1,IPCURR),TAUI(1,IPCURR),
     *                          DISA(IPCURR))
C..KINETIC ENERGY OF THE ELECTRONS
          CALL REKINE(CM(1,1,IPX),N,EKINC(IPCURR))
          IF(PARENT) THEN
C..ENERGY OF THE NOSE THERMOSTATS
            CALL NOSENG(NFI,PIVELP(1,IPCURR),ENOSE(IPCURR),
     &           ENOSP(IPCURR),DUMMY,IPCURR)
CDM1
C..EFFECTIVELY CONSERVED AND HAMILTONIAN ENERGY
C..NOTE: ECNSTR IS ALWAYS ZERO
CDM2
            ECONS(IPCURR)=EKINP+ETOTV(IPCURR)/RNP+
     *                    ENOSE(IPCURR)/RNP+ENOSP(IPCURR)+
     *                    EHARV(IPCURR)+ECNSTR+ERESTR
            EHAM(IPCURR)=ECONS(IPCURR)+EKINC(IPCURR)/RNP
          ENDIF
        ENDDO
C<<<<End of Replica Loop
        CALL MY_SYNC(SUPERGROUP)
        IF(PARENT) THEN
          IF(TPINM) THEN
            CALL GLOBAL(VSTAGE,3*NAX*NSX)
            CALL PINMTRANS(PIVELP,VSTAGE,1)
          ELSEIF(TSTAGE) THEN
            CALL GLOBAL(VSTAGE,3*NAX*NSX)
            CALL STAGETRANS(PIVELP,VSTAGE,1)
          ENDIF
          DO IPCURR=NP_LOW,NP_HIGH
            CALL GEOFILE(PITAUP(1,IPCURR),PIVELP(1,IPCURR),'WRITE')
          ENDDO
        ENDIF
        CALL DISTEN
        CALL GLOBAL(TEMPP,1)
        CALL GLOBAL(EHAM,1)
        CALL GLOBAL(ECONS,1)
        CALL GLOBAL(EKINC,1)
        CALL GLOBAL(ENOSE,1)
        CALL GLOBAL(ENOSP,1)
        CALL GLOBAL(DISA,1)
CDM C..PRINTOUT the evolution of the accumulators every time step
        IF(GRANDPARENT) THEN
C..Radii of gyration
          CALL GETGYRATION(PITAUP)
C..Trotter correlation functions for positions and KS-forces
          CALL GETCOR(PITAUP)
C..extended output
          IF(ENGPRI) THEN
            IF(LEVPRT.GE.5) THEN
              DO IP=1,NP_TOTAL
                WRITE(6,'(1X,63("*"))')
                WRITE(6,'(A,I3,1X,46("*"))') ' *** REPLICA :',IP
                WRITE(6,'(1X,63("*"))')
                CALL PI_ENER(IP,1)
                CALL WRENER
                IF(IPRINT(IPRINT_COOR ).EQ.1) CALL WRGEO(PITAUP(1,IP))
                IF(IPRINT(IPRINT_FORCE).EQ.1)
     &               CALL WRGEOF(PITAUP(1,IP),PIFION(1,IP))
              ENDDO
            ENDIF
            IF(IPRINT(IPRINT_COOR).EQ.1) CALL CNSTPR
            CALL PRTGYR
            WRITE(6,'(/,A,A)')
     *'    NFI   IP   EKINC  TEMPP     EHARM         EKS',
     *'    ENOSE(E)  ENOSE(P)    ECLASSIC        EHAM     DIS'
            DO IP=1,NP_TOTAL
             WRITE(6,
     *          '(I7,I5,F8.5,F7.1,F10.6,F12.5,2X,2F10.5,2F12.5,F8.2)')
     *          NFI,IP,EKINC(IP),TEMPP(IP),EHARV(IP),ETOTV(IP),
     *          ENOSE(IP),ENOSP(IP),ECONS(IP),EHAM(IP),DISA(IP)
            ENDDO
          ENDIF
C..Quantum kinetic energy of ions
CDM1
C..Primitive (Barker) estimator
CDM C..Barker estimator
CDM2
          QPKINP=0.0D0
          DO IP=1,NP_TOTAL
            QPKINP=QPKINP+EHARV(IP)
          ENDDO
          QPKINP=(GLIB+3.D0*NAT*(RNP-1))*TEMPW/(2.D0*315777.D0)-QPKINP
C..Virial (Berne) estimator from KS force
          CALL EVIRIAL(PITAUP,QVKINP)
C..System energies
          EKINA=0.0D0
          ETOTA=0.0D0
          ECONSA=0.0D0
          EHAMA=0.0D0
          TEMPA=0.0D0
          DO IP=1,NP_TOTAL
            EKINA=EKINA+EKINC(IP)/RNP
            ETOTA=ETOTA+ETOTV(IP)/RNP
            ECONSA=ECONSA+ECONS(IP)
            EHAMA=EHAMA+EHAM(IP)
            TEMPA=TEMPA+TEMPP(IP)/RNP
          ENDDO
          EQUANT=ETOTA+QPKINP
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
          IF(ENGPRI) WRITE(6,'(/,A,A)')
     *'    NFI  EKINC/P  TEMP   EKINP(PRI)  EKINP(VIR)      EKS/P ',
     *'     EQUANT    ECLASSIC        EHAM     TCPU'
          WRITE(6,'(I7,F8.5,F7.1,6F12.5,F9.2)')
     *      NFI,EKINA,TEMPA,QPKINP,QVKINP,ETOTA,EQUANT,ECONSA,EHAMA,TCPU
          WRITE(3,'(I7,F15.10,F7.1,6F20.10,F9.2)')
     *      NFI,EKINA,TEMPA,QPKINP,QVKINP,ETOTA,EQUANT,ECONSA,EHAMA,TCPU
C..Store ionic coordinates and velocities for statistics
          MOVIE=MOUT .AND. MOD(NFI-1,IMOVIE).EQ.0
          RPRINT=ROUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TXYZ=XTOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          DO IP=1,NP_TOTAL
cwr1
cwr       note: STAGEP and VSTAGE are already globally updated
cwr            CALL PRINTP(TAUR,PITAUP(1,IP),PIVELP(1,IP),
cwr     *                  STAGEP(1,IP),VSTAGE(1,IP))
cwr2
            CALL PRINTP(TAUR,PITAUP(1,IP),PIVELP(1,IP))
          ENDDO
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(INFI.EQ.NOMORE) EXSOFT=.TRUE.
cnew
        IF((TSTAGE.OR.TPINM).AND.TMNOSE) CALL WR_TEMPS(NFI,EKINC,TEMPP)
cnew
        IF(PARENT) THEN
          DO IPCURR=NP_LOW,NP_HIGH
C..Update accumulators
            I=IPCURR
            CALL PACCD(EKINC(I),ETOTV(I),ECONS(I),EHAM(I),TEMPP(I),
     *                 EHARV(I),ENOSE(I),ENOSP(I),DISA(I),
     *                 TCPU,QPKINP,QVKINP,EKINA,ETOTA,ECONSA,
     *                 EHAMA,TEMPA,EQUANT,ACCUS(1,I),NFI,1)
          ENDDO
        ENDIF
        CALL GLOBAL(ACCUS,NACX)
        DO IPCURR=NP_LOW,NP_HIGH
C..Construct filenames
          CFLBOD='RESTART_'
          WRITE(CIPNUM,'(I4)') IPCURR
          CALL XSTRING(CFLBOD,N1,N2)
          CALL XSTRING(CIPNUM,I1,I2)
          FILBOD=CFLBOD(N1:N2)//CIPNUM(I1:I2)//'.1'
C..Write restart file
          IPX=IPCURR-NP_LOW+1
          CALL DCOPY(NACC,ACCUS(1,IPCURR),1,ACC,1)
          IF(TESTSTORE(INFI).OR.EXSOFT) THEN
            CALL WRITE_IREC(IREC)
            CALL ZHWWF(2,IREC,C0(1,1,IPX),CM(1,1,IPX),N,DUMMY,
     *           PITAUP(1,IPCURR),PIVELP(1,IPCURR),TAUI(1,IPCURR),NFI)
          ENDIF
        ENDDO
C..STOP THE RUN IF THE USER HAS SET THE SIGNAL 30
        IF(EXSOFT) GOTO 100
C     ==================================================================
C     ==     END OF MAIN LOOP                                         ==
C     ==================================================================
      ENDDO
  100 CONTINUE
C     ===================================================================
C     AK: synchronisation point. risk of losing restarts on slow networks.
      CALL MY_SYNC(SUPERGROUP)
C     ===================================================================
C..PRINT ACCUMULATOR
      IF(RHOOUT) CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,N,1)
      IF(GRANDPARENT) THEN
C       Dummy arguments
        D1=0.D0
        D2=0.D0
        CALL PACCD(D1,D1,D1,D1,D1,D1,D1,D1,D1,
     *             D2,D2,D2,D2,D2,D2,D2,D2,D2,ACCUS,NFI,2)
      ENDIF
      IF(PARENT) CALL PRMEM('     PI_MD')
      IF(TIVAN.OR.NONORT) THEN
        CALL FREEM(IP_EIGV)
        CALL FREEM(IP_EIGM)
      ENDIF
      CALL FREEM(IP_FIONKS)
      IF(TSTAGE.OR.TPINM) THEN
        CALL FREEM(IP_STAGEP)
        CALL FREEM(IP_VSTAGE)
        CALL FREEM(IP_FSTAGE)
      ENDIF
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
      IF(PARENT) CALL FILECLOSE(3)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PI_ENER(IPC,IFLG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'pimd.inc'
C     Arguments
      INTEGER IPC,IFLG
C     ==--------------------------------------------------------------==
      IF(IFLG.EQ.0) THEN
        ETOTV(IPC)   = ETOT
        EKINV(IPC)   = EKIN
        EHTV(IPC)    = EHT
        EPSEUV(IPC)  = EPSEU
        ENLV(IPC)    = ENL
        EXCV(IPC)    = EXC
        ESELFV(IPC)  = ESELF
        ESRV(IPC)    = ESR
        EGCV(IPC)    = EGC
        EHARV(IPC)   = EHAR
        CSUMGV(IPC)  = CSUMG
        CSUMRV(IPC)  = CSUMR
      ELSE
        ETOT         = ETOTV(IPC)
        EKIN         = EKINV(IPC)
        EHT          = EHTV(IPC)
        EPSEU        = EPSEUV(IPC)
        ENL          = ENLV(IPC)
        EXC          = EXCV(IPC)
        ESELF        = ESELFV(IPC)
        ESR          = ESRV(IPC)
        EGC          = EGCV(IPC)
        EHAR         = EHARV(IPC)
        CSUMG        = CSUMGV(IPC)
        CSUMR        = CSUMRV(IPC)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DISTEN
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'pimd.inc'
C     ==--------------------------------------------------------------==
      CALL GLOBAL(ETOTV,1)
      CALL GLOBAL(EKINV,1)
      CALL GLOBAL(EHTV,1)
      CALL GLOBAL(EPSEUV,1)
      CALL GLOBAL(ENLV,1)
      CALL GLOBAL(EXCV,1)
      CALL GLOBAL(ESELFV,1)
      CALL GLOBAL(ESRV,1)
      CALL GLOBAL(EGCV,1)
      CALL GLOBAL(EHARV,1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
