C     ==================================================================
      SUBROUTINE PI_MDPT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'ddip.inc'
C     Variables
      REAL*8  FNL(*),DFNL(*)
      REAL*8  C0(*),CM(*),C2(*),SC0(*),GAMX(*),GAMY(*),VPP(*)
      POINTER (IP_C0,C0), (IP_CM,CM), (IP_C2,C2), (IP_SC0,SC0),
     &        (IP_GAMX,GAMX), (IP_GAMY,GAMY), (IP_VPP,VPP)
      INTEGER NSTATE,NC0,NCM,NC2,NXX,NSC0,NXXFUN
      EXTERNAL NXXFUN
      LOGICAL EXSOFT
C     ==--------------------------------------------------------------==
C     ==  MEMORY ALLOCATION                                           ==
C     ==--------------------------------------------------------------==
C     ==  C0         WF POSITIONS                                     ==
C     ==  CM         WF VELOCITIES                                    ==
C     ==  C2         WF FORCES                                        ==
C     ==  SC0        S*C0 (only Vanderbilt)                           ==
C     ==  GAMX       CONSTRAINT MATRIX POSITIONS                      ==
C     ==  GAMY       CONSTRAINT MATRIX VELOCITIES                     ==
C     ==--------------------------------------------------------------==
      IF ( TQMMM ) CALL STOPGM("PI_MDPT","QMMM NOT IMPLEMENTED")
C     ==--------------------------------------------------------------==
      NSTATE=N
      IF(TDIAG) THEN
        IF(TDAVI) THEN
          IF(NDAVV.EQ.0) THEN
            NDAVV=2*NSTATE
          ELSE
            NDAVV=MIN(NDAVV+NSTATE,2*NSTATE)
          ENDIF
          NSTATE=NDAVV
        ENDIF
        NC0=NP_LOCAL*(2*NGWK*NSTATE*NKPNT+8)
        IF(TFRSBLK)THEN
          NCM=2*NGWK*MAX(NSTATE,(NKRY_MAX+1)*NKRY_BLOCK)+8
        ELSE
          NCM=2*NGWK*MAX(NSTATE,NKRY_MAX*NKRY_BLOCK)+8
        ENDIF
        NC2=2*NGWK*MAX(NUMAORMAX,NSTATE)+8
        IF(TDAVI) NCM=NCM*2
        IF(TLANC) NCM=MAX(NCM,2*NGW*8)
        CALL MEMORY(IP_VPP,NGWK,'VPP')
      ELSEIF(TMDBO) THEN
        IF(TSDE) THEN
          NCM=8
        ELSE IF(DIIS) THEN
          NCM=(NGWK*NSTATE+8)*MDIIS+((NGWK*NSTATE+8)*MDIIS)/4+100
        ELSE IF(PCG) THEN
          NCM=2*NGWK*NSTATE
        ENDIF
        NC0=NP_LOCAL*(2*NGWK*NSTATE*NKPNT+8)
        NC2=2*NGWK*NSTATE+8
        CALL MEMORY(IP_VPP,NGWK,'VPP')
      ELSE
        NC0=NP_LOCAL*(2*NGWK*NSTATE*NKPNT+8)
        NCM=NP_LOCAL*(2*NGWK*NSTATE*NKPNT+8)
        NC2=NP_LOCAL*(2*NGWK*NSTATE+8)
      ENDIF
      NSC0=1
      IF(TIVAN.OR.NONORT.OR.(QUENCHB.AND.PCG.AND.PCGMIN)) THEN
        NSC0=2*NGWK*NSTATE*NKPNT
      ENDIF
      IF(TDIPD) THEN
        IF(TDDFT) CALL STOPGM("PI_MDPT",
     &      "TDDFT AND DIPOLE DYNAMICS NOT POSSIBLE")
#ifdef PARALLEL
        LENBK=NXXFUN(NSTATE)
        NXX=MAX(2*LENBK*NPROC,NC2)
        NSC0=MAX(NXX,NSC0)
#else
        NXX=NC2
#endif
        NC2=NXX
      ENDIF
      CALL MEMORY(IP_C0,NC0,'C0')
      CALL MEMORY(IP_CM,NCM,'CM')
      CALL MEMORY(IP_C2,NC2,'C2')
      CALL MEMORY(IP_SC0,2*NGW*NSTATE,'SC0')
      CALL MEMORY(IP_GAMX,NSTATE*NSTATE*NP_LOCAL,'GAMX')
      CALL MEMORY(IP_GAMY,NSTATE*NSTATE*NP_LOCAL,'GAMY')
C     ==--------------------------------------------------------------==
C..FNL
      CALL FNLALLOC(NSTATE,.TRUE.,.FALSE.)
      IF(PARENT) CALL PRMEM('   PI_MDPT')
C     ==--------------------------------------------------------------==
      IF(TMDBO) THEN 
        CALL PI_DIAG(C0,CM,C2,SC0,VPP,GAMX,GAMY)
      ELSE
        IF(TKPNT)CALL STOPGM('PI_MDPT','K-POINTS NOT IMPLEMENTED')
        CALL PI_MD(C0,CM,C2,SC0,GAMX,GAMY)
      ENDIF
C     ==--------------------------------------------------------------==
C     clean up EXIT file for processor groups
      CALL MY_SYNC(SUPERGROUP)
      PC_GROUPS=1
      CALL TESTEX(EXSOFT)
C     ==--------------------------------------------------------------==
      IF(TMEMCHK) CALL PRINT_MEMORY
      CALL FREEM(IP_C0)
      CALL FREEM(IP_CM)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_SC0)
      IF(TMDBO) CALL FREEM(IP_VPP)
      CALL FREEM(IP_GAMX)
      CALL FREEM(IP_GAMY)
      CALL FNLDEALLOC(.TRUE.,.FALSE.)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
