C     ==================================================================
      SUBROUTINE PI_WF
C     ==--------------------------------------------------------------==
C     ==    CONTROL WAVEFUNCTION OPTIMIZATION FOR PATH INTEGRAL RUNS  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'filn.inc'
      INCLUDE 'store.inc'
C     Variables
      CHARACTER*12 CFLBOD,CIPNUM
      INTEGER      N1,N2,I1,I2,IP
C     ==--------------------------------------------------------------==
      IF ( TQMMM ) CALL STOPGM("PI_WF","QMMM NOT IMPLEMENTED")
C     ==--------------------------------------------------------------==
      IF(TINIT) THEN
C..Generate Replica coordinates
        CALL MEMORY(IP_TREP,3*NAX*NSX*NP_TOTAL,'TREP')
        IF(TREAD_CENT.OR.TPINM) THEN
          CALL MEMORY(IP_TREPNM,3*NAX*NSX*NP_TOTAL,'TREPNM')
        ENDIF
        IF(RREP) THEN
          CALL REPGEN(TAU0)
CDM1
C..Classical test 
          IF(TESTPI) THEN
            CALL DCOPY(3*NAX*NSX,TAU0,1,TREP(1,1,1,1),1)
          ENDIF
CDM2
        ELSEIF(REPREAD) THEN
          CALL RREADF
        ENDIF
      ENDIF
C..optimize wavefunction for Trotter index IPCURR
      DO IP=NP_LOW,NP_HIGH
C       IPCUUR is in the include file pimd.inc.
        IPCURR=IP
        IF(TINIT) THEN
          CALL DCOPY(3*NAX*NSX,TREP(1,1,1,IPCURR),1,TAU0,1)
        ENDIF
C..Construct filenames
        CFLBOD='RESTART_'
        WRITE(CIPNUM,'(I4)') IPCURR
        CALL XSTRING(CFLBOD,N1,N2)
        CALL XSTRING(CIPNUM,I1,I2)
        FILBOD=CFLBOD(N1:N2)//CIPNUM(I1:I2)//'.1'
        IF(RLATE) THEN
          FILN=FILBOD
        ELSE
          FILN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
        ENDIF
        IF(PARENT) THEN
          WRITE(6,'(/,1X,64("*"))')
          WRITE(6,'(" *",62X,"*")')
          WRITE(6,'(" *",23X,A,I5,24X,"*")') ' REPLICA :',IPCURR
          WRITE(6,'(" *",62X,"*")')
          WRITE(6,'(1X,64("*"),/)')
        ENDIF
        CALL WFOPTS
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
