C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == PATH INTEGRAL PARAMETERS                                     ==
C     ==--------------------------------------------------------------==
C     == !! NOTE: IF YOU ADD ITEMS TO THE COMMON BLOCKS INCREASE THE  ==
C     ==          RESPECTIVE PARAMETERS PI_LOG,PI_REL,PI_INT          ==
C     ==================================================================
      INTEGER PI_LOG,PI_REL,PI_INT
      PARAMETER(PI_LOG=9)
      PARAMETER(PI_REL=4)
      PARAMETER(PI_INT=4)
C     ==--------------------------------------------------------------==
C     == PILOG       Only for broadcasting                            ==
C     == RREP        See TINIT                                        ==
C     == TREAD_CENT  Classical coordinates are read in as centroid    ==
C     ==             positions and normal modes are sampled.          ==
C     == TSTAGE      Use the staging representation                   ==
C     ==             for the path integrals                           ==
C     == TPINM       Use the normal mode representation               ==
C     ==             for the path integrals                           ==
C     == TINIT       Initialization run:                              ==
C     ==             Supply full start configuration either by        ==
C     ==             (i)  generation -> with RREP=.TRUE. or by        ==
C     ==             (ii) reading it -> with REPREAD=.TRUE            ==
C     == REPREAD     Read replica coordinates from external file      ==
C     ==             to be named 'repfname' in the loop format        ==
C     ==             "DO IP, DO IS, DO IA ... (K=1,3)"                ==
C     ==             (see 'rread.F') .with an empty line              ==
C     ==             Before EVERY set of replicas (also the first!)   ==
C     == TCENTRO     Do centroid path integral MD and                 ==
C     ==             do not thermostat centroid mode,                 ==
C     ==             i.e., first Trotter slice                        ==
C     == TESTPI      Classical path integral test                     ==
C     ==--------------------------------------------------------------==
      LOGICAL        PILOG,RREP,TREAD_CENT,TSTAGE,TPINM,TINIT,
     *               REPREAD,TCENTRO,TESTPI
      COMMON /PIMD1/ PILOG,RREP,TREAD_CENT,TSTAGE,TPINM,TINIT,
     *               REPREAD,TCENTRO,TESTPI
C     ==--------------------------------------------------------------==
C     == PIREL       Only for broadcasting                            ==
C     == TEMPB       Use TEMPB as the reference temperature (in K)    ==
C     ==             to generate the De Broglie displaced NP-1 other  ==
C     ==             particles create free particle paths             ==
C     ==             using a Gaussian Levy walk at temperature TEMPB  ==
C     ==             according to the masses of the species           ==
C     ==             starting from the first bead from the classical  ==
C     ==             configuration that is obtained from input        ==
C     == WMASS       Ficticious ionic masses are WMASS*M              ==
C     ==             No specification of WMASS -> WMASS=1.0           ==
C     ==             (choice of Berne et al.)                         ==
C     == FACSTAGE    The ficticious normal mode mass is               ==
C     ==             (FACSTAGE*WMASS) times heavier than the corres-  ==
C     ==             -ponding real physical mass of the same species  ==
C     ==             The fictitious non-centroid masses are           ==
C     ==             FACSTAGE times lighter than the centroid mass    ==
C     ==             (which has the physical mass as fictitious mass) ==
C     ==--------------------------------------------------------------==
      REAL*8         PIREL,TEMPB,WMASS,FACSTAGE
      COMMON /PIMD2/ PIREL,TEMPB,WMASS,FACSTAGE
C     ==--------------------------------------------------------------==
C     == PIINT    Only for broadcasting                               ==
C     == NP_TOTAL Number of replica                                   ==
C     == LEVPRT   Printing level: minimal output for LEVPRT < 5       ==
C     == LOUTFN   Output files for each processor, group              ==
C     ==          or only grandparent                                 ==
C     ==--------------------------------------------------------------==
      INTEGER        PIINT,NP_TOTAL,LEVPRT,LOUTFN
      COMMON /PIMD3/ PIINT,NP_TOTAL,LEVPRT,LOUTFN
C     ==================================================================
C     == REPFNAME Name of the external file to read replica coord.    ==
C     ==--------------------------------------------------------------==
      CHARACTER*80   REPFNAME
      COMMON /RNAME/ REPFNAME
C     ==================================================================
C     == VARIABLES FOR PARALLEL WORK                                  ==
C     ==--------------------------------------------------------------==
C     == SUPERGROUP                                                   ==
C     == SUPERSOURCE                                                  ==
C     == PARENTGROUP                                                  ==
C     == PC_GRP                                                       ==
C     == PC_GROUPS   Number of processor goups                        ==
C     == PCG_POS                                                      ==
C     == NPROC_TOT                                                    ==
C     == IPCURR                                                       ==
C     == GRANDPARENT                                                  ==
C     ==--------------------------------------------------------------==
      INTEGER         SUPERGROUP,SUPERSOURCE,PARENTGROUP
      INTEGER         PC_GRP(MAXCPU)
      INTEGER         PC_GROUPS,PCG_POS,NPROC_TOT,IPCURR
      LOGICAL         GRANDPARENT
      COMMON /PIPARA/ SUPERGROUP,SUPERSOURCE,PARENTGROUP,
     *                PC_GRP,
     *                PC_GROUPS,PCG_POS,NPROC_TOT,IPCURR,
     *                GRANDPARENT
C     ==================================================================
C     == MAXNP  Maximum number of replica                             ==
C     ==--------------------------------------------------------------==
      INTEGER MAXNP
      PARAMETER (MAXNP=64)
C     ==--------------------------------------------------------------==
C     == NUM_NP                                                       ==
C     == IPP1                                                         ==
C     == IPM1                                                         ==
C     == NP_LOW                                                       ==
C     == NP_HIGH                                                      ==
C     == NP_LOCAL                                                     ==
C     ==--------------------------------------------------------------==
      INTEGER        NUM_NP(MAXNP),IPP1(MAXNP),IPM1(MAXNP)
      INTEGER        NP_LOW,NP_HIGH,NP_LOCAL
      COMMON /PIMD4/ NUM_NP,IPP1,IPM1,
     *               NP_LOW,NP_HIGH,NP_LOCAL
C     ==--------------------------------------------------------------==
C     == ENERGIES PER REPLICA                                         ==
C     ==--------------------------------------------------------------==
C     == EHAR                                                         ==
C     == ETOTV(MAXNP)                                                 ==
C     == EKINV(MAXNP)                                                 ==
C     == EHTV(MAXNP)                                                  ==
C     == EPSEUV(MAXNP)                                                ==
C     == ENLV(MAXNP)                                                  ==
C     == EXCV(MAXNP)                                                  ==
C     == ESELFV(MAXNP)                                                ==
C     == ESRV(MAXNP)                                                  ==
C     == EGCV(MAXNP)                                                  ==
C     == EEIGV(MAXNP)                                                 ==
C     == ECNSTRV(MAXNP)                                               ==
C     == EHARV(MAXNP)    Harmonic energy                              ==
C     == CSUMGV(MAXNP)                                                ==
C     == CSUMRV(MAXNP)                                                ==
C     == VDBCHGV(MAXNP)                                               ==
C     ==--------------------------------------------------------------==
      REAL*8         EHAR
      REAL*8         ETOTV(MAXNP),EKINV(MAXNP),EHTV(MAXNP),
     *               EPSEUV(MAXNP),ENLV(MAXNP),EXCV(MAXNP),
     *               ESELFV(MAXNP),ESRV(MAXNP),EGCV(MAXNP),
     *               EEIGV(MAXNP),ECNSTRV(MAXNP),EHARV(MAXNP),
     *               CSUMGV(MAXNP),CSUMRV(MAXNP),VDBCHGV(MAXNP,MAXNP)
      COMMON /PIMDE/ EHAR,
     *               ETOTV,EKINV,EHTV,
     *               EPSEUV,ENLV,EXCV,
     *               ESELFV,ESRV,EGCV,
     *               EEIGV,ECNSTRV,EHARV,
     *               CSUMGV,CSUMRV,VDBCHGV
C     ==================================================================
C     == TREP        Atomic coordinates for each replica              ==
C     == TREPNM      Normal modes for each replica                    ==
C     == FIONKS      Atomic force coordinates for each replica        ==
C     ==--------------------------------------------------------------==
      REAL*8         TREP  (3,NAX,NSX,NP_TOTAL),
     *               TREPNM(3,NAX,NSX,NP_TOTAL),
     *               FIONKS(3,NAX,NSX,NP_TOTAL)
      POINTER        (IP_TREP,TREP),(IP_TREPNM,TREPNM),
     *               (IP_FIONKS,FIONKS)
      COMMON /PIMDC/ IP_TREP,IP_TREPNM,IP_FIONKS
C     ==================================================================
C     == PMAR(MAXSP)                                                  ==
C     == PMAR0(MAXSP)                                                 ==
C     == FLNM(MAXNP)                                                  ==
C     == PMARS(MAXSP,MAXNP)                                           ==
C     == PMA0S(MAXSP,MAXNP)                                           ==
C     ==--------------------------------------------------------------==
      REAL*8          PMAR(MAXSP),PMAR0(MAXSP),FLNM(MAXNP)
      REAL*8          PMARS(MAXSP,MAXNP),PMA0S(MAXSP,MAXNP)
      COMMON /PIMDM1/ PMAR,PMAR0,FLNM,
     *                PMARS,PMA0S
C     ==--------------------------------------------------------------==
C     == TNM          Forward normal mode transformation matrix       ==
C     == TNMI                                                         ==
C     ==--------------------------------------------------------------==
      REAL*8          TNM(NP_TOTAL,NP_TOTAL),
     *                TNMI(NP_TOTAL,NP_TOTAL)
      POINTER         (IP_TNM,TNM),(IP_TNMI,TNMI)
      COMMON /PIMDM2/ IP_TNM,IP_TNMI
C     ==================================================================
C     == FPGYR(MAXSP)                                                 ==
C     == AVGYR(MAXSP)                                                 ==
C     == AVGYRA(MAXSP,2)                                              ==
C     == FPSUS(MAXSP)                                                 ==
C     == AVSUS(MAXSP)                                                 ==
C     == AVSUSA(MAXSP,2)                                              ==
C     == FPCOR(MAXSP)                                                 ==
C     == AVCOR(MAXSP)                                                 ==
C     == AVCORA(MAXSP,2)                                              ==
C     ==--------------------------------------------------------------==
      REAL*8       FPGYR(MAXSP),AVGYR(MAXSP),AVGYRA(MAXSP,2),
     *             FPSUS(MAXSP),AVSUS(MAXSP),AVSUSA(MAXSP,2),
     *             FPCOR(MAXSP),AVCOR(MAXSP),AVCORA(MAXSP,2)
      COMMON/GYRA/ FPGYR,AVGYR,AVGYRA,
     *             FPSUS,AVSUS,AVSUSA,
     *             FPCOR,AVCOR,AVCORA
C     ==--------------------------------------------------------------==
C     == RGYR(NAX,NSX)                                                ==
C     == RGYRA(NAX,NSX,2)                                             ==
C     == RSUS(NAX,NSX)                                                ==
C     == RSUSA(NAX,NSX,2)                                             ==
C     == RCOR(NAX,NSX)                                                ==
C     == RCORA(NAX,NSX,2)                                             ==
C     ==--------------------------------------------------------------==
      REAL*8        RGYR(NAX,NSX),RGYRA(NAX,NSX,2),
     &              RSUS(NAX,NSX),RSUSA(NAX,NSX,2),
     &              RCOR(NAX,NSX),RCORA(NAX,NSX,2)
      POINTER       (IP_RGYR,RGYR), (IP_RGYRA,RGYRA),
     *              (IP_RSUS,RSUS), (IP_RSUSA,RSUSA),
     *              (IP_RCOR,RCOR), (IP_RCORA,RCORA)
      COMMON/GYRAI/ IP_RGYR,IP_RGYRA,IP_RSUS,IP_RSUSA,IP_RCOR,IP_RCORA
C     ==================================================================
C     == IRCORR(NAX,NSX,NP_TOTAL)                                     ==
C     == IFCORR(NAX,NSX,NP_TOTAL)                                     ==
C     == RCORR (NAX,NSX,NP_TOTAL)                                     ==
C     == FCORR (NAX,NSX,NP_TOTAL)                                     ==
C     ==--------------------------------------------------------------==
      INTEGER       IRCORR(NAX,NSX,NP_TOTAL),IFCORR(NAX,NSX,NP_TOTAL)
      REAL*8        RCORR (NAX,NSX,NP_TOTAL),FCORR (NAX,NSX,NP_TOTAL)
      POINTER       (IP_IRCORR,IRCORR),(IP_IFCORR,IFCORR),
     *              (IP_RCORR,RCORR),(IP_FCORR,FCORR)
      COMMON/CORRI/ IP_IRCORR,IP_IFCORR,IP_RCORR,IP_FCORR
C     ==================================================================

