C     ==================================================================
      SUBROUTINE PINMTRANS(PRIM,STG,ITRANS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'pimd.inc'
C     Arguments
      INTEGER ITRANS
      REAL*8  PRIM(3,NAX,NSX,*),STG(3,NAX,NSX,*)
C     Variables
      INTEGER   I,IS,IA,IP,JP,NPX
C     ==--------------------------------------------------------------==
      NPX=NP_TOTAL
      IF(ITRANS.EQ.0) THEN
C     ==--------------------------------------------------------------==
C     ==  PERFORM TRANSFORMATION R --> U                              ==
C     ==  U_i = \sum_j TNM(i,j)*R_j                                   ==
C     ==  WHERE TNM IS THE FORWARD NORMAL MODE TRANSFORMATION MATRIX  ==
C     ==--------------------------------------------------------------==
        CALL AZZERO(STG,3*NAX*NSX*NPX)
        DO I=1,3
         DO IS=1,NSP
          DO IA=1,NA(IS)
           DO IP=1,NPX
            DO JP=1,NPX
             STG(I,IA,IS,IP) = STG(I,IA,IS,IP) + 
     *                          TNM(IP,JP)*PRIM(I,IA,IS,JP)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ELSE
C     ==--------------------------------------------------------------==
C     ==  PERFORM INVERSE TRANSFORMATION U --> R                      ==
C     ==  R_i = \sum_j TNMI(i,j)*U_j                                  ==
C     ==  WHERE TNMI IS THE INVERSE TRANSFORMATION MATRIX             ==
C     ==--------------------------------------------------------------==
        CALL AZZERO(PRIM,3*NAX*NSX*NPX)
        DO I=1,3
         DO IS=1,NSP
          DO IA=1,NA(IS)
           DO IP=1,NPX
            DO JP=1,NPX
             PRIM(I,IA,IS,IP) = PRIM(I,IA,IS,IP) + 
     *                          TNMI(IP,JP)*STG(I,IA,IS,JP)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
