C     ==================================================================
      PROGRAM PLOTBAND
C     ==--------------------------------------------------------------==
      IMPLICIT  NONE
      INTEGER   MAXPANELS
      PARAMETER (MAXPANELS=20)
      REAL*8    RYDBERG
      PARAMETER (RYDBERG=13.606D0)
      CHARACTER DATE*26,LINE*80,LINEOLD*80
      INTEGER   IPANEL(MAXPANELS)
      REAL*8    RKI(3,MAXPANELS),RKF(3,MAXPANELS),RK(3),EBAND(*)
      POINTER   (IP_EBAND,EBAND)
      INTEGER   IUNIT,ICARG,IARGC,IERR,INSCAN,NKPTS,NPANEL,NKPBD,I,
     &          IBRAV,NKPTS0,NBANDS,IUNITOUT,NKPOINT,IP,IIK,IKIND,
     &          IBAND,II
      REAL*8    TIME1,TIMEC,WCLK1,TIMEF,EFERMI,ESHIFT,ALAT,WK
      EXTERNAL  TIMEC,TIMEF
C     ==--------------------------------------------------------------==
      TIME1 = TIMEC()
      WCLK1 = TIMEF()
      CALL DATUM(DATE)
      WRITE(6,'(A,A)') ' PROGRAM PLOTBAND STARTED AT: ',DATE
C     ==--------------------------------------------------------------==
      IUNIT = 9
      ICARG=IARGC()
      IF(ICARG.LT.1) THEN
        WRITE(6,*) ' NO INPUT FILE NAME SPECIFIED '
        CALL STOPGM('PLOTBAND',' ')
      ENDIF
      CALL MY_GETARG(1,LINE)
      OPEN(UNIT=IUNIT,FILE=LINE,STATUS='OLD',ERR=200)
      IERR=INSCAN(IUNIT,'&SYSTEM')
      IF(IERR.NE.0) THEN
        WRITE(6,*) ' PLOTBAND| INPUT SECTION &SYSTEM NOT FOUND'
        CALL STOPGM('CONTROL',' ')
      ENDIF
C     ==--------------------------------------------------------------==
C     Read the input file
      LINE=''
      DO WHILE (INDEX(LINE,'&END').EQ.0)
        LINEOLD=LINE
        READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
        IF( (INDEX(LINE,'KPOINT').NE.0).AND.
     &       (INDEX(LINE,'BAND').NE.0) ) THEN
          NKPTS=0
          NPANEL=0
          NKPBD=1
          DO WHILE (NKPBD.NE.0)
            NPANEL=NPANEL+1
            READ(IUNIT,ERR=99,END=99,FMT=*) NKPBD,
     &           (RKI(I,NPANEL),I=1,3), (RKF(I,NPANEL),I=1,3)
            IF(NKPBD.NE.0) THEN
              IF(NKPBD.LE.1) CALL STOPGM('  SYSIN',
     &             'WRONG NUMBER OF K POINTS PER BAND')
              IPANEL(NPANEL)=NKPBD
              NKPTS=NKPTS+NKPBD
            ELSE
              NPANEL=NPANEL-1
            ENDIF
          ENDDO
          GOTO 100
        ENDIF
      ENDDO
      WRITE(6,*) 'NO KPOINT BAND INFORMATION IN INPUT FILE'
      CALL STOPGM('PLOTBAND',' ')     
C     ==--------------------------------------------------------------==
 100  CONTINUE
      WRITE(6,'(A,$)') 'FERMI ENERGY: '
      READ(*,*) EFERMI
      WRITE(6,'(A,$)') 'SHIFT IN ENERGY: '
      READ(*,*) ESHIFT
C     We have information about panel, we read ENERGYBANDS.
      CLOSE(IUNIT)
      OPEN(UNIT=IUNIT,FILE='ENERGYBANDS',STATUS='OLD',ERR=999)
C     Read ALAT
      READ(IUNIT,ERR=999,END=999,FMT='(1X,A8,I12,F20.15)')
     &     LINE(1:8), IBRAV,ALAT
      READ(IUNIT,ERR=999,END=999,FMT='(1X,2I12)') NKPTS0,NBANDS
      IF(NKPTS0.NE.NKPTS) THEN
        WRITE(6,*) ' PLOTBAND| WRONG NUMBER IN KPOINTS IN ENERGYBANDS'
        WRITE(6,*) '           NKPTS=',NKPTS0,' INSTEAD OF',NKPTS
        CALL STOPGM('PLOTBAND',' ')
      ENDIF
      CALL MEMORY(IP_EBAND,NBANDS,'EBAND')
      IUNITOUT=10
      OPEN(UNIT=IUNITOUT,FILE='bnds.ext',STATUS='UNKNOWN')
      WRITE(IUNITOUT,'(I5,2F10.5)') NBANDS, EFERMI/RYDBERG, ALAT
      NKPOINT=0
      DO IP=1,NPANEL
        WRITE(IUNITOUT,'(I5)') IPANEL(IP)
        DO IIK=1,IPANEL(IP)
          NKPOINT=NKPOINT+1
          READ(IUNIT,ERR=999,END=999,FMT='(I5,4(F12.6))')
     &         IKIND,(RK(I),I=1,3),WK
          IF(NKPOINT.NE.IKIND) GOTO 999
          DO IBAND=1,NBANDS
            READ(IUNIT,*) II,EBAND(IBAND)
          ENDDO
          WRITE(IUNITOUT,'(3F10.5/,(10F8.4))')
     &         (RK(I),I=1,3),((EBAND(I)-ESHIFT)/RYDBERG,I=1,NBANDS)
        ENDDO
      ENDDO
      WRITE(IUNITOUT,'(I5,/,I5)') 0,0
      CALL FREEM(IP_EBAND)
      GOTO 99999
C     ==--------------------------------------------------------------==
 99   CONTINUE
      WRITE(6,*) ' PLOTBAND| ERROR IN READING INPUT FILE'
      WRITE(6,*) ' THE LAST TWO LINES READ WERE '
      WRITE(6,*) LINEOLD
      WRITE(6,*) LINE
      CALL STOPGM('PLOTBAND',' ')
 200  CONTINUE
      WRITE(6,*) ' PLOTBAND| INPUT FILE NOT FOUND'
      CALL STOPGM('PLOTBAND',' ')
 999  CONTINUE
      WRITE(6,*) ' PLOTBAND| ERROR IN READING FILE ENERGYBANDS'
      CALL STOPGM('PLOTBAND',' ')
C     ==--------------------------------------------------------------==
      CALL DATUM(DATE)
      WRITE(6,'(A,A)') ' PROGRAM PLOTBAND ENDED AT: ',DATE
99999 CONTINUE
      END
C     ==================================================================
