C     ==================================================================
      SUBROUTINE PM_GMOPTS
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'atwf.inc'        !NUMAORMAX
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'coor.inc'        !VELP

      INCLUDE 'filn.inc'
      INCLUDE 'store.inc'
      INCLUDE 'pimd.inc'
      
C     Variables
      DIMENSION  F(*)
      COMPLEX*16 C0(*),C2(*),C1(*)
      REAL*8     PME(*),GDE(*),VPP(*),EIGV(*),
     &           CM(*),SC0(*)
      POINTER    (IP_C0,C0), (IP_C1,C1), (IP_C2,C2), (IP_PME,PME),
     &           (IP_GDE,GDE), (IP_VPP,VPP), (IP_EIGV,EIGV),
     &           (IP_CM,CM),(IP_SC0,SC0)
      CHARACTER*12 CFLBOD,CIPNUM
      INTEGER    NSTATE,NC0,NEIGV,NC2,NCM,NCE,NX
      INTEGER    NPME,NGDE,NSC0,MS,NACT,MM,NUS,NC1,I,N1,N2,I1,I2,IP
C     ==--------------------------------------------------------------==
C     ==  MEMORY ALLOCATION                                           ==
C     ==--------------------------------------------------------------==
C     ==                      WAVEFUNCTIONS                           ==
C     ==  C0    : WAVEFUNCTIONS                                       ==
C     ==  C2    : GRADIENTS                                           ==
C     ==  CM    : VELOCITIES  OR BACKUP WAVEFUNCTION                  ==
C     ==  SC0   : S**(-1/2)*C0 (nonorthogonal orbitals)               ==
C     ==  PME   : DIIS WF             HNM1 (for CG)                   ==
C     ==  GDE   : DIIS GRADIENTS                                      ==
C     ==  VPP   : WF HESSIAN                                          ==
C     ==  EIGV  : ORBITAL ENERGIES                                    ==
C     ==--------------------------------------------------------------==
      IF(TDDFT) THEN
        CALL LR_IN
        CALL TDDFT_INPUT
       TSYMRHO=.FALSE.
      ENDIF
      NSTATE=N
      IF(TDIAG.AND.TDAVI) THEN
        IF(NDAVV.EQ.0) THEN
          NDAVV=2*NSTATE
        ELSE
          NDAVV=MIN(NDAVV+NSTATE,2*NSTATE)
        ENDIF
        NSTATE=NDAVV
      ENDIF
      NC0=2*NGWK*NSTATE*NKPNT+8
      NEIGV=NSTATE*NKPTS
      NC2=2*NGWK*MAX(NUMAORMAX,NSTATE)+8
      IF(TDIAG) THEN
        IF(TFRSBLK) THEN
          NCM=2*NGWK*MAX(NSTATE,(NKRY_MAX+1)*NKRY_BLOCK)+8
        ELSEIF(DIIS) THEN
          NCM=(NGWK*NSTATE+8)*MDIIS*NKPNT+
     &          ((NGWK*NSTATE+8)*MDIIS*NKPNT)/4
          NCM = NCM*2
        ELSE
           NCM=2*NGWK*MAX(NSTATE,NKRY_MAX*NKRY_BLOCK)+8
        ENDIF
      ELSE
        NCM = 1
        IF(SIMUL) THEN
          NCM=NC0
        ENDIF
      ENDIF
      IF(TIVAN.OR.NONORT.OR.(PCG.AND.PCGMIN)) THEN
        NSC0=MAX(2*NGWK*NSTATE*NKPNT,NC2)
      ELSEIF(TDIAG .AND.DIIS) THEN
        NSC0=NC2
      ELSE
        NSC0=1
      ENDIF
      IF(TDEBFOR) THEN
        NCM = NC0
      ENDIF
      IF(TDDFT) THEN
        DO I=1,NSTATE
          IF(F(I).LT.1.D-6) THEN
            CALL STOPGM("TDDFT","ALL STATES HAVE TO BE OCCUPIED")
          ENDIF
        ENDDO
        MS=MAX(NS_MIX,NS_SIN,NS_TRI)
        IF(TDA.AND.LDIAG.EQ.1) THEN
          MM=1
        ELSE
          MM=2
        ENDIF
        IF(TDA.AND.MSUBTA.GT.0) THEN
          NACT=MSUBTA
        ELSE
          NACT=NSTATE
        ENDIF
        NOLR=NACT
        NC1=2*NGW*NACT*MS*MM
        NUA=NSTATE
        NUB=NACT
        NLINW=MS
        NLINR=0
        NUS=2*NUA*NUB
      ELSE
        NC1=1
        NUA=1
        NUB=1
        NLINW=0
        NLINR=0
        NUS=1
      ENDIF
      CALL MEMORY(IP_C0,NC0,'C0')
      CALL MEMORY(IP_C1,NC1,'C0')
      CALL MEMORY(IP_C2,NC2,'C2')
      CALL MEMORY(IP_CM,NCM,'CM')
      CALL MEMORY(IP_EIGV,NEIGV,'EIGV')
      CALL MEMORY(IP_SC0,NSC0,'SC0')
      CALL MEMORY(IP_VPP,NGWK,'VPP')
      CALL MEMORY(IP_UROT,NUS,'UROT')
      CALL AZZERO(UROT,NUS)
      CALL GET_ADDR(IP_CLRWF,C1)
      IF(TSDE) THEN
        NPME = 1
        NGDE = 1
      ELSE IF(DIIS .AND. .NOT. TDIAG) THEN
        NPME = (NGWK*NSTATE+8)*MDIIS*NKPNT
        NGDE = ((NGWK*NSTATE+8)*MDIIS*NKPNT)/4
      ELSE IF(PCG) THEN
        NPME = 2*NGWK*NSTATE*NKPNT
        NGDE = 1
      ELSE IF(TDIAG) THEN
        IF(TDAVI) THEN
          NPME = NC0
          NGDE = NC0
        ELSE
          NPME = 1
          NGDE = 1
        ENDIF
      ELSE
        IF(PARENT) THEN
          WRITE(6,*) ' WRONG OPTION FOR WAVEFUNCTION OPTIMIZATION'
        ENDIF
        CALL STOPGM('PM_GMOPTS',' ')
      ENDIF
      CALL MEMORY(IP_PME,NPME,'PME')
      CALL MEMORY(IP_GDE,NGDE,'GDE')
C     ==--------------------------------------------------------------==
      NX=NSTATE
      IF(TDAVI) THEN
        NX=NDAVV
      ENDIF
C     FNL and DFNL
      CALL FNLALLOC(NSTATE,.TRUE.,TPRES)
      IF(PARENT) THEN
        CALL PRMEM(' PM_GMOPTS')
      ENDIF
C     ==--------------------------------------------------------------==
C     Initialisation of the PATH
      IF(TINIT) THEN
C       Generate replica coordinates
        CALL MEMORY(IP_TREP,3*NAX*NSX*NP_TOTAL,'TREP')
        IF(RREP) THEN
          CALL STOPGM('PM_WF','GENERATE REPLICA NOT IMPLEMENTED')
C         Classical test 
          IF(TESTPI) THEN
            CALL DCOPY(3*NAX*NSX,TAU0,1,TREP(1,1,1,1),1)
          ENDIF
        ELSEIF(REPREAD) THEN
          CALL RREADF
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      DO IP=NP_LOW,NP_HIGH
C       IPCUUR is in the include file pimd.inc.
        IPCURR=IP
        IF(TINIT) THEN
          CALL DCOPY(3*NAX*NSX,TREP(1,1,1,IPCURR),1,TAU0,1)
        ENDIF
C       Construct filenames
        CFLBOD='RESTART_'
        WRITE(CIPNUM,'(I4)') IPCURR
        CALL XSTRING(CFLBOD,N1,N2)
        CALL XSTRING(CIPNUM,I1,I2)
        FILBOD=CFLBOD(N1:N2)//CIPNUM(I1:I2)//'.1'
        IF(RLATE) THEN
          FILN=FILBOD
        ELSE
          FILN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
        ENDIF
        IF(PARENT) THEN
          WRITE(6,'(/,1X,64("*"))')
          WRITE(6,'(" *",62X,"*")')
          WRITE(6,'(" *",23X,A,I5,24X,"*")') ' REPLICA :',IPCURR
          WRITE(6,'(" *",62X,"*")')
          WRITE(6,'(1X,64("*"),/)')
        ENDIF
        CALL RGMOPT(C0,C1,C2,CM,SC0,PME,GDE,VPP,EIGV)
      ENDDO
C     ==--------------------------------------------------------------==
C     Deallocations
      IF(TMEMCHK) THEN
        CALL PRINT_MEMORY
      ENDIF
      CALL FREEM(IP_C0)
      CALL FREEM(IP_C1)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_CM)
      CALL FREEM(IP_EIGV)
      CALL FREEM(IP_UROT)
      CALL FNLDEALLOC(.TRUE.,TPRES)
      CALL FREEM(IP_SC0)
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_PME)
      CALL FREEM(IP_GDE)
      CALL FREEM(IP_VELP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
