C     ==================================================================
      SUBROUTINE PM_MDPT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'atwf.inc'        !NUMAORMAX
      INCLUDE 'kpts.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'bsym.inc'        !BSFAC
      INCLUDE 'shop.inc' 
      INCLUDE 'mm_dim.inc'

      INCLUDE 'printp.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'filn.inc'
      INCLUDE 'store.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'mfep.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'irat.inc'

C     Variables
      COMPLEX*16 C0(*),C1(*),CM(*),C2(*),SC0(*)
      REAL*8     GAMX(*),GAMY(*),VPP(*)
      POINTER    (IP_C0,C0), (IP_CM,CM), (IP_C2,C2),(IP_SC0,SC0),
     &           (IP_C1,C1), (IP_GAMX,GAMX), (IP_GAMY,GAMY),
     &           (IP_VPP,VPP)
      DIMENSION  F(*)
      INTEGER    NSTATE,NC0,NC1,NUS,NACT,NC2,NCM,NSC0,IUNIT,NXX,NMIN
      INTEGER    MS,MM,I,J,K,NSTX
      INTEGER    N1,N2,I1,I2,IP,ILOOP,idummy,istep
      CHARACTER*80 CFLBOD,CIPNUM
      CHARACTER*(FO_FPATH_MAX) FPATHSAVE
      INTEGER    IAPATHSAVE,IEPATHSAVE
      INTEGER    MSGLEN
      LOGICAL    statusdummy,FERROR

      INTEGER IIF1,IIF2,IIF3
      DATA    IIF1,IIF2,IIF3 /FO_VERB,FO_VMARK,FO_DEF/

#ifdef PARALLEL
      INTEGER    NXXFUN
      EXTERNAL   NXXFUN
#endif
C     ==--------------------------------------------------------------==
C     FIXME: AK 2008/02/21. a lot of these arrays are _very_ small and
C     don't warrant pointers and dynamical allocation. why not have them
C     simply as local arrays?
      REAL*8 RESVIPO(MRESTR,*),RESVOUT(MRESTR,*)
      POINTER (IP_RESVIPO,RESVIPO),(IP_RESVOUT,RESVOUT)
      REAL*8 FCOL(*),FCOLAV(MRESTR,*)
      REAL*8 FBYM(MRESTR,*),METRIC(MRESTR,*)
      REAL*8 METRICAV(MRESTR,MRESTR,*)
      REAL*8 NO(MRESTR,*),NORM,PIJ(MRESTR,MRESTR,*)
      REAL*8 RESVIP(MRESTR,*),RESVIPS(MRESTR,*)
      REAL*8 RESVIPD(MRESTR)
      REAL*8 L(NP_TOTAL),LENGTH,S(NP_TOTAL)
      REAL*8 FED(NP_TOTAL),FEDP(NP_TOTAL)
      REAL*8 DIST
      INTEGER SIGMA
      POINTER (IP_FCOL,FCOL),(IP_FCOLAV,FCOLAV)
      POINTER (IP_FBYM,FBYM),(IP_METRIC,METRIC)
      POINTER (IP_METRICAV,METRICAV)
      POINTER (IP_NO,NO),(IP_PIJ,PIJ)
      POINTER (IP_RESVIP,RESVIP),(IP_RESVIPS,RESVIPS)
      POINTER (IP_RESVIPD,RESVIPD)
      POINTER (IP_L,L),(IP_S,S)
      POINTER (IP_FED,FED),(IP_FEDP,FEDP)

      INTEGER NSAMPLES

      CHARACTER*80 LINE
      REAL*8 CVALF,FVALF,FACT,ESUM
      REAL*8 DX,DXNORM,DXMAX,DE,DENORM,DEMAX
      CHARACTER*1  R
      LOGICAL TMDEBUG,CONVGE

      CHARACTER*20 FILENAME
      INTEGER ILMIN,ILMAX,S1,S2,NCOL,MINR,MAXR,JCV
      CHARACTER*20 F1,F2,F3,F4,F5
      DATA         F1,F2,F3,F4,F5
     &     /'LATEST_STRING','STRING.','CONSTRAINT.','METRIC.',
     &      'PATHMIN'/
      
      TMDEBUG=.FALSE.
      IF(BOHR) FACTOR=FACTOR*FBOHR ! for compatibility with previous version
C     ==--------------------------------------------------------------==
C     ==  MEMORY ALLOCATION                                           ==
C     ==--------------------------------------------------------------==
C     ==  C0         WF POSITIONS                                     ==
C     ==  CM         WF VELOCITIES                                    ==
C     ==  C2         WF FORCES                                        ==
C     ==  SC0        S*C0 (only Vanderbilt)                           ==
C     ==  GAMX       CONSTRAINT MATRIX POSITIONS                      ==
C     ==  GAMY       CONSTRAINT MATRIX VELOCITIES                     ==
C     ==--------------------------------------------------------------==
      IF ( QMNODE ) THEN
        IF(TDDFT) THEN
          CALL LR_IN
          CALL TDDFT_INPUT
          TSYMRHO=.FALSE.
        ENDIF
        NSTATE=N
cMcB
crv        IF ( TSHOP ) NSTATE=NST_S0+NST_S1
cMcB
        NC1=1
        NUA=1
        NUB=1
        NLINW=0
        NLINR=0
        NUS=1
        IF(TDIAG) THEN
          IF(TDDFT) CALL STOPGM('PM_MDPT',
     &        'TDDFT.AND.TDIAG NOT POSSIBLE')
          IF(TDAVI) THEN
            IF(NDAVV.EQ.0) THEN
              NDAVV=2*NSTATE
            ELSE
              NDAVV=MIN(NDAVV+NSTATE,2*NSTATE)
            ENDIF
            NSTATE=NDAVV
          ENDIF
          NC0=2*NGWK*NSTATE*NKPNT+8
          IF(TFRSBLK)THEN
            NCM=2*NGWK*MAX(NSTATE,(NKRY_MAX+1)*NKRY_BLOCK)+8
          ELSEIF(DIIS) THEN
            NCM=(NGWK*NSTATE+8)*MDIIS*NKPNT+
     &          ((NGWK*NSTATE+8)*MDIIS*NKPNT)/4
          ELSE
            NCM=2*NGWK*MAX(NSTATE,NKRY_MAX*NKRY_BLOCK)+8
          ENDIF
          NC2=2*NGWK*MAX(NUMAORMAX,NSTATE)+8
          IF(TDAVI)NCM=NCM*2
          CALL MEMORY(IP_VPP,NGWK,'VPP')
        ELSEIF(TMDBO.OR.TMDFILE) THEN
          IF(TSDE) THEN
            NCM=8
          ELSE IF(DIIS) THEN
            NCM=(NGWK*NSTATE+8)*MDIIS+((NGWK*NSTATE+8)*MDIIS)/4+100
          ELSE IF(PCG) THEN
            NCM=2*NGWK*NSTATE+8
          ENDIF
C CB: Need memory for two wf in BS case          
          NC0=(2*NGWK*NSTATE*NKPNT+8)*BSFAC
          NC2=(2*NGWK*NSTATE+8)*BSFAC
          CALL MEMORY(IP_VPP,NGWK,'VPP')
          IF(TDDFT) THEN
            DO I=1,NSTATE
              IF(F(I).LT.1.D-6) CALL STOPGM('TDDFT',
     *                            'ALL STATES HAVE TO BE OCCUPIED')
            ENDDO
            MS=MAX(NS_MIX,NS_SIN,NS_TRI)
            IF(TDA.AND.LDIAG.EQ.1) THEN
              MM=1
            ELSE
              MM=2
            ENDIF
            IF(TDA.AND.MSUBTA.GT.0) THEN
              NACT=MSUBTA
            ELSE
              NACT=NSTATE
            ENDIF
            NOLR=NACT
            NC1=2*NGW*NACT*MS*MM
            NUA=NSTATE
            NUB=NACT
            NLINW=MS
            NLINR=0
            NUS=2*NUA*NUB
          ENDIF
        ELSE
          IF(TDDFT) CALL STOPGM('PM_MDPT',
     &                   'TDDFT.AND.CP NOT POSSIBLE')
C     NN  For the BS-CPMD, HS & BS wavefunctions are propagated at the 
C     same time, thus the array sizes of C0,CM and C2 are multiplied by 2 
          NC0=(2*NGWK*NSTATE*NKPNT+8)*BSFAC
          NCM=(2*NGWK*NSTATE*NKPNT+8)*BSFAC
          NC2=(2*NGWK*NSTATE+8)*BSFAC
        ENDIF
        NSC0=1
        IF(TIVAN.OR.NONORT.OR.(QUENCHB.AND.PCG.AND.PCGMIN)) THEN
          NSC0=2*NGWK*NSTATE*NKPNT*BSFAC 
        ENDIF
        IF(TDIPD) THEN
          IF(TDDFT) CALL STOPGM('PM_MDPT',
     &        'TDDFT AND DIPOLE DYNAMICS NOT POSSIBLE')
#ifdef PARALLEL
          LENBK=NXXFUN(NSTATE)
          NXX=MAX(2*LENBK*NPROC,NC2)
          NSC0=MAX(NXX,NSC0)
#else
          NXX=NC2
#endif
          NC2=NXX
        ENDIF
        IF(TSHOP) THEN
          NC0=2*NC0
          NCM=2*NCM
          NC2=2*NC2
        ENDIF
        CALL MEMORY(IP_C0,NC0,'C0')
        CALL MEMORY(IP_CM,NCM,'CM')
        CALL MEMORY(IP_C1,NC1,'C1')
        CALL MEMORY(IP_C2,NC2,'C2')
        CALL MEMORY(IP_SC0,NSC0,'SC0')
        CALL MEMORY(IP_UROT,NUS,'UROT')
        CALL AZZERO(UROT,NUS)
        IP_CLRWF=IP_C1
        IF(TDMAL) THEN
          CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
          CALL MEMORY(IP_GAMX,NSTATE*NSTX*BSFAC,'GAMX') 
          CALL MEMORY(IP_GAMY,NSTATE*NSTX*BSFAC,'GAMY') 
        ELSE
          CALL MEMORY(IP_GAMX,NSTATE*NSTATE*BSFAC,'GAMX') 
          CALL MEMORY(IP_GAMY,NSTATE*NSTATE*BSFAC,'GAMY') 
        ENDIF
C     ==--------------------------------------------------------------==
C       FNL and DFNL
        call mm_dim(mm_go_qm,statusdummy)
        CALL FNLALLOC(NSTATE,.TRUE.,TPRES)
        call mm_dim(mm_revert,statusdummy)
      ELSE
        NMIN = 10
        CALL MEMORY(IP_C0,NMIN,'C0')
        CALL MEMORY(IP_CM,NMIN,'CM')
        CALL MEMORY(IP_C1,NMIN,'C1')
        CALL MEMORY(IP_C2,NMIN,'C2')
        CALL MEMORY(IP_SC0,NMIN,'SC0')
        CALL MEMORY(IP_UROT,NMIN,'UROT')
        CALL MEMORY(IP_GAMX,NMIN,'GAMX')
        CALL MEMORY(IP_GAMY,NMIN,'GAMY')
        CALL MEMORY(IP_VPP,NMIN,'VPP')
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PARENT) CALL PRMEM('      MDPT')
C     ==--------------------------------------------------------------==

      IF ( TSHOP.AND.(TFUSI.OR.TSEP) ) THEN 
         CALL STOPGM('MDPT','TSHOP.AND.(TFUSI.OR.TSEP) NOT POSSIBLE')
         IF (TFUSI) THEN
            CALL FUSION(C0,CM)
         ELSEIF (TSEP) THEN
            CALL SEPARATE(C0,CM)
         ENDIF
         GO TO 500
      ENDIF

      IF ( TDDFT.AND.TSHOP ) THEN
         CALL STOPGM('MDPT','TDDFT.AND.TSHOP NOT POSSIBLE')
      ENDIF


C     ==--------------------------------------------------------------==
C     Initialisation of the PATH
      IF(TINIT) THEN
C       Generate replica coordinates
        CALL MEMORY(IP_TREP,3*NAX*NSX*NP_TOTAL,'TREP')
        IF(RREP) THEN
          CALL STOPGM('PM_WF','GENERATE REPLICA NOT IMPLEMENTED')
C         Classical test 
          IF(TESTPI) THEN
            CALL DCOPY(3*NAX*NSX,TAU0,1,TREP(1,1,1,1),1)
          ENDIF
        ELSEIF(REPREAD) THEN
          CALL RREADF
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      FPATHSAVE=FPATH
      IAPATHSAVE=IAPATH
      IEPATHSAVE=IEPATH
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_RESVIPO,MRESTR*NP_TOTAL,'RESVIPO')
      CALL MEMORY(IP_RESVOUT,MRESTR*NP_TOTAL,'RESVOUT')
      IF(GRANDPARENT) THEN
        DO I=1,MRESTR
          DO J=1,NP_TOTAL
            RESVIPO(I,J)=RESVAL(I)
          ENDDO
        ENDDO
      ENDIF
      CALL MEMORY(IP_FCOL,MRESTR,'FCOL')
      CALL MEMORY(IP_FCOLAV,MRESTR*NP_TOTAL,'FCOLAV')
      CALL MEMORY(IP_FBYM,MRESTR*NP_TOTAL,'FBYM')
      CALL MEMORY(IP_METRIC,MRESTR*MRESTR,'METRIC')
      CALL MEMORY(IP_METRICAV,MRESTR*MRESTR*NP_TOTAL,'METRICAV')

      CALL MEMORY(IP_RESVIP,MRESTR*NP_TOTAL,'RESVIP')
      CALL MEMORY(IP_RESVIPS,MRESTR*NP_TOTAL,'RESVIPS')
      CALL MEMORY(IP_RESVIPD,MRESTR,'RESVIPD')
      
      IF(PROJOUT) THEN
        CALL MEMORY(IP_NO,MRESTR*NP_TOTAL,'NO')
        CALL MEMORY(IP_PIJ,MRESTR*MRESTR*NP_TOTAL,'PIJ')
      ENDIF

      CALL MEMORY(IP_L,NP_TOTAL,'L')
      CALL MEMORY(IP_S,NP_TOTAL,'S')

      CALL MEMORY(IP_FED,NP_TOTAL,'FED')
      CALL MEMORY(IP_FEDP,NP_TOTAL,'FEDP')

      IF(GRANDPARENT) THEN
        IF(RLATE_STRING) THEN
!     Read LATEST_STRING file
          CALL XSTRING(F1,S1,S2)
          CALL FILEOPEN(97,F1,FO_OLD+FO_NOFP,FERROR)
          IF(FERROR) GOTO 100
          READ(UNIT=97,END=100,ERR=100,FMT=*) NLOOPOLD
          CALL FILECLOSE(97)
        ENDIF
!     Read latest STRING.num file
        CALL MW_FILENAME(F2,FILENAME,NLOOPOLD)
        CALL XSTRING(FILENAME,S1,S2)
        CALL FILEOPEN(95,FILENAME,FO_OLD+FO_NOFP,FERROR)
        IF(FERROR) GOTO 100
        DO I=1,NP_TOTAL
          READ(95,*) IDUMMY,(RESVIPO(IREST(J),I),J=1,NCVSP)
          DO J=1,NCVSP
            JCV=IREST(J)
            IF (NTREST(1,JCV).EQ.1 .OR.
     *          NTREST(1,JCV).EQ.4 .OR.
     *          NTREST(1,JCV).EQ.7 .OR. 
     *          NTREST(1,JCV).EQ.12) THEN
              IF(.NOT.BOHR) RESVIPO(JCV,I)=RESVIPO(JCV,I)*FBOHR
            ELSEIF(NTREST(1,JCV).EQ.2 .OR.
     *             NTREST(1,JCV).EQ.3 .OR.
     *             NTREST(1,JCV).EQ.5) THEN
              CALL RADDEG(RESVIPO(JCV,I),-1)
            ENDIF
          ENDDO
        ENDDO
        CALL FILECLOSE(95)
      ENDIF
      MSGLEN = 1*8/IRAT
      CALL MY_BCAST(NLOOPOLD,MSGLEN,SUPERSOURCE,SUPERGROUP)
C     ==--------------------------------------------------------------==
      ILMIN=NLOOPOLD+1
      ILMAX=NLOOPOLD+NLOOP
      DO ILOOP=ILMIN,ILMAX
        IF(PARENT) THEN
          WRITE(6,'(/,1X,64("*"))')
          WRITE(6,'(" *",62X,"*")')
          WRITE(6,'(" *",23X,A,I5,24X,"*")') ' LOOP    :',ILOOP
          WRITE(6,'(" *",62X,"*")')
          WRITE(6,'(1X,64("*"),/)')
        ENDIF
        ISTRING=ILOOP
        CONVGE=.FALSE.
        MSGLEN=MRESTR*NP_TOTAL*8
        IF(PARENT) THEN
          CALL MY_BCAST(RESVIPO,MSGLEN,SUPERSOURCE,PARENTGROUP)
          WRITE(6,'(T7,A,T12,A,T35,A)') 'IP','IREST','RESV'
          DO I=1,NP_TOTAL
            DO J=1,NCVSP
              JCV=IREST(J)
              WRITE(6,'(2(X,I7),F22.14)') I,JCV,RESVIPO(JCV,I)
            ENDDO
          ENDDO
        ENDIF

        CALL AZZERO(METRICAV,MRESTR*MRESTR*NP_TOTAL)
        CALL AZZERO(FCOLAV,MRESTR*NP_TOTAL)
C     ==--------------------------------------------------------------==
        DO IP=NP_LOW,NP_HIGH
C     IPCUUR is in the include file pimd.inc.
          IPCURR=IP
          IF(TINIT) THEN
            CALL DCOPY(3*NAX*NSX,TREP(1,1,1,IP),1,TAU0,1)
          ENDIF
          IF(PARENT) CALL DCOPY(MRESTR,RESVIPO(1,IP),1,RESVAL(1),1)
C     Construct filenames
          CFLBOD='RESTART'
          WRITE(CIPNUM,'(I4)') IP
          CALL XSTRING(CFLBOD,N1,N2)
          CALL XSTRING(CIPNUM,I1,I2)
          FILBOD=CFLBOD(N1:N2)//'.1'
          IF(RLATE.OR.ILOOP.GT.1) THEN
            FILN=FILBOD
          ELSE
            FILN=CFLBOD(N1:N2)
          ENDIF
C     Construct filepath
          CFLBOD=FPATHSAVE(IAPATHSAVE:IEPATHSAVE-1)
     &        //'_'//CIPNUM(I1:I2)//'/'
          WRITE(FPATH,'(A)') CFLBOD
          CALL XSTRING(FPATH,IAPATH,IEPATH)

          IF(PARENT) THEN
            WRITE(6,'(/,1X,64("*"))')
            WRITE(6,'(" *",62X,"*")')
            WRITE(6,'(" *",23X,A,I5,24X,"*")') ' REPLICA :',IP
            WRITE(6,'(" *",62X,"*")')
            WRITE(6,'(1X,64("*"),/)')
          ENDIF
         
          IF1=IIF1
          IF2=IIF2
          IF3=IIF3

          IF(TCLAS) THEN
            IF(TKPNT)CALL STOPGM('PM_MDPT','K-POINTS NOT IMPLEMENTED')
            IF(TDDFT)CALL STOPGM('PM_MDPT','TDDFT NOT POSSIBLE')
            IUNIT=5
            CALL CL_INIT(IUNIT)
            CALL MDCLAS(C0,CM,C2,SC0,GAMX,GAMY)
          ELSEIF(TMDBO) THEN 
            IF ( TQMMM ) THEN
              IF ( TSHOP ) THEN
                CALL STOPGM('PM_MDPT',
     &              'TMDBO.AND.TQMMM.AND.TSHOP NOT POSSIBLE')
                CALL MM_MDSHOP_BO(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
              ELSE
                CALL MM_MDDIAG(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
              ENDIF
            ELSE
              IF ( TSHOP ) THEN
                CALL STOPGM('PM_MDPT','TMDBO.AND.TSHOP NOT POSSIBLE')
                CALL MDSHOP_BO(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
              ELSE
                CALL MDDIAG(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
              ENDIF
            ENDIF
          ELSEIF(TMDFILE) THEN
            CALL MDFILE(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
          ELSE  ! CP dynamics
            IF(TKPNT)CALL STOPGM('PM_MDPT','K-POINTS NOT IMPLEMENTED')
            IF(TDDFT)CALL STOPGM('PM_MDPT','TDDFT.AND.CP NOT POSSIBLE')
            IF ( TQMMM ) THEN
              IF ( TSHOP ) THEN
                CALL STOPGM('PM_MDPT','TQMMM.AND.TSHOP NOT POSSIBLE')
                CALL MM_MDSHOP_CP(C0,CM,C2,SC0,GAMX,GAMY)
              ELSE
                CALL MM_MDMAIN(C0,CM,C2,SC0,GAMX,GAMY)
              ENDIF
            ELSE
              IF ( TSHOP ) THEN
                CALL STOPGM('PM_MDPT','SURFACE HOPPING NOT POSSIBLE')
                CALL MDSHOP_CP(C0,CM,C2,SC0,GAMX,GAMY)
              ELSE
                CALL MDMAIN(C0,CM,C2,SC0,GAMX,GAMY)
              ENDIF
            ENDIF
          ENDIF

          IF (EXNOMORE) THEN
            EXSOFT=.FALSE.
            EXNOMORE=.FALSE.
          ELSE IF(EXSOFT) THEN
            GOTO 500
          ENDIF

          IF (PARENT) THEN
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     averages in each directory
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     Read CONSTRAINT file
            CALL MW_FILENAME(F3,FILENAME,ILOOP)
            CALL XSTRING(FILENAME,S1,S2)
            CALL FILEOPEN(31,FILENAME,FO_OLD,FERROR)
            IF(FERROR) GOTO 100
            DO I=1,NEQUI
              DO J=1,MCNSTR
                READ(UNIT=31,END=200,ERR=200,FMT=*) LINE
              ENDDO
              DO J=1,MRESTR
                READ(UNIT=31,END=200,ERR=200,FMT=*) LINE
              ENDDO
            ENDDO
            NSAMPLES=0
            DO WHILE(.TRUE.)
              DO J=1,MCNSTR
                READ(UNIT=31,END=20,ERR=200,FMT=*) 
     &            ISTEP,IDUMMY,CVALF,FVALF
              ENDDO
              READ(UNIT=31,END=20,ERR=200,FMT=*) 
     &          ISTEP,IDUMMY,CVALF,FVALF,FCOL(1),R
              IF(LCVSP(1)) FCOLAV(1,IP)=FCOLAV(1,IP)+FCOL(1)
              DO J=2,MRESTR
                READ(UNIT=31,END=200,ERR=200,FMT=*) 
     &            ISTEP,IDUMMY,CVALF,FVALF,FCOL(J),R
                IF(LCVSP(J)) FCOLAV(J,IP)=FCOLAV(J,IP)+FCOL(J)
              ENDDO
              NSAMPLES=NSAMPLES+1
            ENDDO
 20         CONTINUE
            CALL FILECLOSE(31)
C     Read METRIC file
            CALL MW_FILENAME(F4,FILENAME,ILOOP)
            CALL XSTRING(FILENAME,S1,S2)
            CALL FILEOPEN(90,FILENAME,FO_OLD,FERROR)
            IF(FERROR) GOTO 100
            DO I=1,NEQUI
              DO J=1,MRESTR
                READ(UNIT=90,END=200,ERR=200,FMT=*) LINE
              ENDDO
            ENDDO
            DO I=1,NSAMPLES
              DO J=1,MRESTR
                READ(UNIT=90,END=200,ERR=200,FMT=*) 
     &            (METRIC(J,K),K=1,MRESTR)
                DO K=1,MRESTR
                  IF(LCVSP(J).AND.LCVSP(K))
     &              METRICAV(J,K,IP)=METRICAV(J,K,IP)+METRIC(J,K)
                ENDDO
              ENDDO
            ENDDO
            CALL FILECLOSE(90)
            
            IF(NSAMPLES.EQ.0) CALL STOPGM('PM_MDPT',
     &                        'FAIL IN SAMPLING MEAN FORCE')
            FACT=1.0D0/DBLE(NSAMPLES)
            CALL DSCAL(MRESTR,-1.0D0*FACT,FCOLAV(1,IP),1)
            CALL DSCAL(MRESTR*MRESTR,FACT,METRICAV(1,1,IP),1)

            WRITE(6,'(20X,A)') ' <<<<< AVERAGED GRADIENTS >>>>>'
            WRITE(6,'(3(1PE20.10))') 
     &        (FCOLAV(IREST(J),IP),J=1,NCVSP)
            WRITE(6,'(/,22X,A)') ' <<<<< AVERAGED METRIC >>>>>' 
            DO K=1,NCVSP
              WRITE(6,'(3(1PE20.10))') 
     &          (METRICAV(IREST(J),IREST(K),IP),J=1,NCVSP)
            ENDDO
          ENDIF

          IF (EXSOFT) GOTO 500
          
        ENDDO
C     ==--------------------------------------------------------------==

        CALL MY_SYNC(SUPERGROUP)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     collect averages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        CALL GLOSUPERSUM(MRESTR*NP_TOTAL,FCOLAV)
        CALL GLOSUPERSUM(MRESTR*MRESTR*NP_TOTAL,METRICAV)

        IF (GRANDPARENT) THEN
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     grandparent updates string
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! multiply force and metric
          WRITE(LINE,'(I4)') MRESTR
          CALL XSTRING(LINE,I1,I2)
          DO I=1,NP_TOTAL
            CALL DGEMM('N','N',MRESTR,1,MRESTR,1.0D0,
     &          METRICAV(1,1,I),MRESTR,
     &          FCOLAV(1,I),MRESTR,0.0D0,FBYM(1,I),MRESTR)
            IF(TMDEBUG) THEN
              WRITE(6,'(I7,'//LINE(I1:I2)//'(2X,F22.14))') 
     &          I,(FCOLAV(J,I),J=1,MRESTR)
            ENDIF
          ENDDO

! estimate free energy difference along the path
          CALL FILEOPEN(98,F5,FO_DEF+FO_NOFP,FERROR)
          WRITE(6,'(/,18X,A)') ' <<<<< FREE ENERGY DIFFERENCE >>>>>'
          WRITE(6,'(T7,A,T21,A,T32,A,T43,A,T56,A,T67,A)') 
     &      'IP','FED','RESV','GRADV','RESV','GRADV'
          FED(1)=0.0D0
          NCOL=NINT(DBLE(NCVSP)*0.5D0)
          MINR=1
          MAXR=MIN(MINR+1,NCVSP)
          WRITE(6,'(X,I7,F15.9,T24,4F12.6)') 
     &    1,FED(1),(RESVIPO(IREST(J),1),FCOLAV(IREST(J),1),J=MINR,MAXR)
          DO K=2,NCOL
            MINR=MAXR+1
            MAXR=MIN(MINR+1,NCVSP)
            WRITE(6,'(T24,4F12.6)') 
     &        (RESVIPO(IREST(J),1),FCOLAV(IREST(J),1),J=MINR,MAXR)
          ENDDO
          WRITE(LINE,'(I4)') 2*NCVSP+1
          CALL XSTRING(LINE,I1,I2)
          WRITE(98,'(I7,'//LINE(I1:I2)//'F15.9)')
     &      1,FED(1),(RESVIPO(IREST(J),1),J=1,NCVSP),
     &      (FCOLAV(IREST(J),1),J=1,NCVSP)
          DO I=2,NP_TOTAL
            ESUM=0.0D0
            DO J=1,NCVSP
              JCV=IREST(J)
              ESUM=ESUM+0.5D0*(RESVIPO(JCV,I)-RESVIPO(JCV,I-1))
     &          *(FCOLAV(JCV,I)+FCOLAV(JCV,I-1))
            ENDDO
            FED(I)=FED(I-1)+ESUM
            MINR=1
            MAXR=MIN(MINR+1,NCVSP)
            WRITE(6,'(X,I7,F15.9,T24,4F12.6)') 
     &        I,FED(I),(RESVIPO(IREST(J),I),
     &        FCOLAV(IREST(J),I),J=MINR,MAXR)
            DO K=2,NCOL
              MINR=MAXR+1
              MAXR=MIN(MINR+1,NCVSP)
              WRITE(6,'(T24,4F12.6)') 
     &          (RESVIPO(IREST(J),I),FCOLAV(IREST(J),I),J=MINR,MAXR)
            ENDDO
            WRITE(98,'(I7,'//LINE(I1:I2)//'F15.9)')
     &        I,FED(I),(RESVIPO(IREST(J),I),J=1,NCVSP),
     &        (FCOLAV(IREST(J),I),J=1,NCVSP)
          ENDDO
          CALL FILECLOSE(98)

          IF(ILOOP.GT.ILMIN) THEN
            DEMAX=0.0D0
            DENORM=0.0D0
            DO I=1,NP_TOTAL
              DE=ABS(FED(I)-FEDP(I))
              DENORM=DENORM+DE*DE
              DEMAX=MAX(DE,DEMAX)
            ENDDO
            DENORM=DENORM/DBLE(NP_TOTAL)
            WRITE(6,'(/,X,A,/,3X,A,1PE14.3,2X,A,1PE14.3/)')
     &        ' DEVIATION OF FREE ENERGY DIFFERENCES: ',
     &        ' DEMAX = ',DEMAX,' DENORM = ',DENORM
          ENDIF
          CALL DCOPY(NP_TOTAL,FED,1,FEDP,1)

! evolution of collective variables

          IF (PROJOUT) THEN
! with projecting out of forces
            DO J=1,MRESTR
              NO(J,1)=RESVIPO(J,2)-RESVIPO(J,1)
              NO(J,NP_TOTAL)=RESVIPO(J,NP_TOTAL-1)-RESVIPO(J,NP_TOTAL)
            ENDDO
            DO I=2,NP_TOTAL-1
              DO J=1,MRESTR
                NO(J,I)=RESVIPO(J,I+1)-RESVIPO(J,I)
              ENDDO
              CALL ISCAL(NO(1,I),FBYM(1,I),MRESTR,SIGMA)
              DO J=1,MRESTR
                NO(J,I)=RESVIPO(J,I+SIGMA)-RESVIPO(J,I)
              ENDDO               
            ENDDO
            DO I=1,NP_TOTAL
              CALL NORME(NO(1,I),MRESTR,NORM)
              CALL DSCAL(MRESTR,1.0D0/NORM,NO(1,I),1)
            ENDDO
            DO I=1,NP_TOTAL
              DO J=1,MRESTR
                DO K=1,MRESTR
                  PIJ(J,K,I)=-1.0D0*NO(J,I)*NO(K,I)
                ENDDO
                PIJ(J,J,I)=1.0D0+PIJ(J,J,I)
              ENDDO
              CALL DGEMM('N','N',MRESTR,1,MRESTR,1.0D0,
     &            PIJ(1,1,I),MRESTR,
     &            FBYM(1,I),MRESTR,0.0D0,FCOLAV(1,I),MRESTR)
            ENDDO
            
            DO I=1,MRESTR
              DO J=2,NP_TOTAL-1
                RESVIP(I,J)=RESVIPO(I,J)-FACTOR*FCOLAV(I,J)
              ENDDO
              RESVIP(I,1)=RESVIPO(I,1)
              RESVIP(I,NP_TOTAL)=RESVIPO(I,NP_TOTAL)
            ENDDO
            
          ELSE
!without projecting out forces
            DO I=1,MRESTR
              DO J=2,NP_TOTAL-1
                RESVIP(I,J)=RESVIPO(I,J)-FACTOR*FBYM(I,J)
              ENDDO
              RESVIP(I,1)=RESVIPO(I,1)
              RESVIP(I,NP_TOTAL)=RESVIPO(I,NP_TOTAL)
            ENDDO
          ENDIF

! smoothing
          DO I=1,MRESTR
            DO J=2,NP_TOTAL-1
              RESVIPS(I,J)=ALPHA_PMIN*RESVIP(I,J-1)
     &            +(1.0D0-2.0D0*ALPHA_PMIN)*RESVIP(I,J)
     &            +ALPHA_PMIN*RESVIP(I,J+1)
            ENDDO
            DO J=2,NP_TOTAL-1
              RESVIP(I,J)=RESVIPS(I,J)
            ENDDO
          ENDDO
          
! reparametrization
          CALL AZZERO(L,NP_TOTAL)
          DO I=2,NP_TOTAL
            CALL DISTCURV(RESVIP(1,I),RESVIP(1,I-1),MRESTR,DIST)
            L(I)=L(I-1)+DIST
          ENDDO
          LENGTH=L(NP_TOTAL)
          
          DO I=1,NP_TOTAL
            S(I)=(DBLE(I)-1.0D0)*LENGTH/DBLE(NP_TOTAL-1)
          ENDDO
          
          DO J=1,MRESTR         ! first point and last point
            RESVIPS(J,1)=RESVIP(J,1)
            RESVIPS(J,NP_TOTAL)=RESVIP(J,NP_TOTAL)
          ENDDO
          
          DO I=2,NP_TOTAL-1
            DO J=2,NP_TOTAL
              IF (L(J).GE.S(I)) THEN
                CALL DISTCURV(RESVIP(1,J-1),RESVIP(1,J),
     &              MRESTR,DIST)
                DO K=1,MRESTR
                  RESVIPD(K)=RESVIP(K,J)-RESVIP(K,J-1)
                  RESVIPS(K,I)=(S(I)-L(J-1))*RESVIPD(K)/DIST
     &                +RESVIP(K,J-1)
                ENDDO
                GOTO 10
              ENDIF
            ENDDO
 10         CONTINUE
          ENDDO
          
! check convergence on string positions
          DXMAX=0.0D0
          DXNORM=0.0D0
          DO I=1,NP_TOTAL
            DO J=1,NCVSP
              JCV=IREST(J)
              DX=ABS(RESVIPS(JCV,I)-RESVIPO(JCV,I))
              DXNORM=DXNORM+DX*DX
              DXMAX=MAX(DX,DXMAX)
            ENDDO
          ENDDO
          DXNORM=DXNORM/DBLE(NP_TOTAL*NCVSP)
          WRITE(6,'(/,X,A,/,3X,A,1PE14.3,2X,A,1PE14.3/)') 
     &      ' DEVIATION OF STRING POSITIONS: ',
     &      ' DXMAX = ',DXMAX,' DXNORM = ',DXNORM
          IF(DXMAX.LT.TOLDS) THEN
            CONVGE=.TRUE.
            GOTO 30
          ENDIF

          CALL DCOPY(MRESTR*NP_TOTAL,RESVIPS,1,RESVIPO,1)
          CALL DCOPY(MRESTR*NP_TOTAL,RESVIPS,1,RESVOUT,1)

! write in STRING.num and LATEST_STRING for new run and trajectory
          CALL MW_FILENAME(F2,FILENAME,ILOOP)
          CALL XSTRING(FILENAME,S1,S2)
          CALL FILEOPEN(96,FILENAME,FO_DEF+FO_NOFP,FERROR)
          WRITE(LINE,'(I4)') NCVSP
          CALL XSTRING(LINE,I1,I2)
          DO I=1,NP_TOTAL
            DO J=1,NCVSP
              JCV=IREST(J)
              IF (NTREST(1,JCV).EQ.1 .OR.
     *            NTREST(1,JCV).EQ.4 .OR.
     *            NTREST(1,JCV).EQ.7 .OR. 
     *            NTREST(1,JCV).EQ.12) THEN
                IF(.NOT.BOHR) RESVOUT(JCV,I)=RESVOUT(JCV,I)/FBOHR
              ELSEIF (NTREST(1,JCV).EQ.2 .OR.
     *                NTREST(1,JCV).EQ.3 .OR.
     *                NTREST(1,JCV).EQ.5) THEN
                CALL RADDEG(RESVOUT(JCV,I),1)
              ENDIF
            ENDDO
            WRITE(96,'(I7,'//LINE(I1:I2)//'(2X,F22.14))') 
     *        I,(RESVOUT(IREST(J),I),J=1,NCVSP)
          ENDDO
          CALL FILECLOSE(96)
          CALL FILEOPEN(97,F1,FO_DEF+FO_NOFP,FERROR)
          WRITE(97,*) ILOOP
          CALL FILECLOSE(97)
        ENDIF
 30     CONTINUE
        CALL MY_SYNC(SUPERGROUP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(CONVGE,MSGLEN,SUPERSOURCE,SUPERGROUP)
        IF(CONVGE) GOTO 500
      ENDDO
C     ==--------------------------------------------------------------==
      
 500  CONTINUE
C     ==--------------------------------------------------------------==
      IF(TMEMCHK) CALL PRINT_MEMORY
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_FEDP)
      CALL FREEM(IP_FED)
      CALL FREEM(IP_S)
      CALL FREEM(IP_L)
      IF (PROJOUT) THEN
         CALL FREEM(IP_PIJ)
         CALL FREEM(IP_NO)
      ENDIF
      CALL FREEM(IP_RESVIPD)
      CALL FREEM(IP_RESVIPS)
      CALL FREEM(IP_RESVIP)
      CALL FREEM(IP_METRICAV)
      CALL FREEM(IP_METRIC)
      CALL FREEM(IP_FBYM)
      CALL FREEM(IP_FCOLAV)
      CALL FREEM(IP_FCOL)
      CALL FREEM(IP_RESVIPO)
      IF ( QMNODE ) THEN
        CALL FNLDEALLOC(.TRUE.,TPRES)
      ELSE
        CALL FREEM(IP_VPP)
      ENDIF
      CALL FREEM(IP_GAMY)
      CALL FREEM(IP_GAMX)
      CALL FREEM(IP_UROT)
      CALL FREEM(IP_SC0)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_C1)
      CALL FREEM(IP_CM)
      CALL FREEM(IP_C0)
      GOTO 9999
C     ==--------------------------------------------------------------==
 100  CONTINUE
      CALL STOPGM('PM_MDPT','REQUIRED FILE '//FILENAME(S1:S2)//
     &            ' NOT PRESENT OR NOT READABLE')
 200  CONTINUE
      CALL STOPGM('PM_MDPT','ERROR WHILE READING '//FILENAME(S1:S2)//
     &            ' FILE')
C     ==--------------------------------------------------------------==
 9999 CONTINUE
      RETURN
      END
C     ==================================================================
      subroutine distcurv(c1,c2,ncolvar,dist)
C     ==--------------------------------------------------------------==
      implicit none
      integer ncolvar
      real*8 c1(ncolvar),c2(ncolvar)
      real*8 dist,c12
      integer i

      dist=0.0D0
      do i=1,ncolvar
         c12=c1(i)-c2(i) ! access only once c1(i) and c2(i)
         dist=dist+c12*c12
      enddo
      dist=SQRT(dist)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      SUBROUTINE iscal(c1,c2,ncolvar,sigma)
C     ==--------------------------------------------------------------==
      implicit none
      integer ncolvar
      real*8 c1(ncolvar),c2(ncolvar)
      real*8 scal
      integer sigma
      integer i

      scal=0.0D0
      do i=1,ncolvar
         scal=scal+c1(i)*c2(i)
      enddo
      if (scal.gt.0) then
         sigma=1
      else
         sigma=-1
      endif
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      SUBROUTINE norme(c1,ncolvar,norm)
C     ==--------------------------------------------------------------==
      implicit none
C     ==--------------------------------------------------------------==
      integer ncolvar
      real*8 c1(ncolvar)
      real*8 norm
      integer i

      norm=0.0D0
      DO i=1,ncolvar
         norm=norm+c1(i)*c1(i)
      ENDDO
      norm=DSQRT(norm)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
