C     ==================================================================
      SUBROUTINE PNOSMOVE(VELP,STEP,PMX,IP)
C     ==--------------------------------------------------------------==
C     ==  ALLOWS FOR NOSE-HOOVER CHAIN DYNAMICS                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
C     Arguments
      REAL*8  VELP(3,NAX,NSX),STEP,PMX(*)
      INTEGER IP
C     Variables
      REAL*8  FETAPV(NCHX),EKINP,CONST,FACTON,PKEWANT,AA
      INTEGER IPP,IS,IL,IA,IAL,K,L,IJ,KF,IDF,IJJ
C     ==--------------------------------------------------------------==
      IPP=1
      IF(TPATH.AND.TPIMD)IPP=MIN(IP,2)
      IF(TULTRA) THEN
        FACTON=0.5D0/FACTEM
        DO IS=1,NSP
C     ==--------------------------------------------------------------==
C     ==  CALCULATE ALL THERMOSTAT FORCES                             ==
C     ==--------------------------------------------------------------==
          EKINP=0.D0
          CONST=0.5D0*PMX(IS)
          DO IA=1,NA(IS)
            DO K=1,3
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,IS)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=2,NCHAIN
            EKINP = 0.5D0*QNOSP(IS,L-1,IP)*ETAPDOT(IS,L-1,IP)*
     *                        ETAPDOT(IS,L-1,IP)
            PKEWANT = TEMPW*FACTON
            FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                ==
C     ==--------------------------------------------------------------==
          ETAPDOT(IS,NCHAIN,IP) = ETAPDOT(IS,NCHAIN,IP) + 
     *                  0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IS,NCHAIN,IP)
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE REMAINDER OF CHAIN                                ==
C     ==--------------------------------------------------------------==
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPDOT(IS,NCHAIN+1-L,IP))
            ETAPDOT(IS,NCHAIN-L,IP) = ETAPDOT(IS,NCHAIN-L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(NCHAIN-L)*AA/QNOSP(IS,NCHAIN-L,IP)
          ENDDO
C     ==--------------------------------------------------------------==
C     ==  DO VELOCITY SCALING AND PROPAGATE THERMOSTAT POSITIONS      ==
C     ==--------------------------------------------------------------==
          AA = DEXP(-0.5D0*STEP*ETAPDOT(IS,1,IP))
          DO IA=1,NA(IS)
            DO K=1,3
              VELP(K,IA,IS) = VELP(K,IA,IS)*AA
            ENDDO
          ENDDO
          DO L=1,NCHAIN
            ETAP(IS,L,IP) = ETAP(IS,L,IP) + 0.5D0*STEP*ETAPDOT(IS,L,IP)
          ENDDO
          EKINP=0.D0
          CONST=0.5D0*PMX(IS)
          DO IA=1,NA(IS)
            DO K=1,3
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,IS)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
C     ==--------------------------------------------------------------==
C     == LOOP AGAIN OVER CHAIN                                        ==
C     ==--------------------------------------------------------------==
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPDOT(IS,L+1,IP))
            ETAPDOT(IS,L,IP) = ETAPDOT(IS,L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(L)*AA/QNOSP(IS,L,IP)
            EKINP = 0.5D0*QNOSP(IS,L,IP)*ETAPDOT(IS,L,IP)*
     *                                 ETAPDOT(IS,L,IP)
            PKEWANT = TEMPW*FACTON
            FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                ==
C     ==--------------------------------------------------------------==
          ETAPDOT(IS,NCHAIN,IP) = ETAPDOT(IS,NCHAIN,IP) + 
     *                    0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IS,NCHAIN,IP)
        ENDDO

C     ==--------------------------------------------------------------==
C     ==  LOCAL THERMOSTATS                                           ==
C     ==--------------------------------------------------------------==
      ELSEIF(TLOCT) THEN
         FACTON=0.5D0/FACTEM
C     FIXME LOCT: ABOUT ALL
         DO IL=1,NLOCT
C     ==--------------------------------------------------------------==
C     ==  CALCULATE ALL THERMOSTAT FORCES                             ==
C     ==--------------------------------------------------------------==
            EKINP=0.D0
            DO IAL=1,NLCTMBM(IL)
               IS=LCTMEMB(1,IAL,IL)
               IA=LCTMEMB(2,IAL,IL)
               CONST=0.5D0*PMX(IS)
               DO K=1,3
                  EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
               ENDDO
            ENDDO
            PKEWANT = 0.5D0*GKT(IPP,IL)
            FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
            DO L=2,NCHAIN
               EKINP = 0.5D0*QNOSP(IL,L-1,IP)*ETAPDOT(IL,L-1,IP)*
     *              ETAPDOT(IL,L-1,IP)
               PKEWANT = 0.5D0*LOCTPIN(1,IL)/FACTEM
               FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
            ENDDO
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                ==
C     ==--------------------------------------------------------------==
            ETAPDOT(IL,NCHAIN,IP) = ETAPDOT(IL,NCHAIN,IP) + 
     *           0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IL,NCHAIN,IP)
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE REMAINDER OF CHAIN                                ==
C     ==--------------------------------------------------------------==
            DO L=1,NCHAIN-1
               AA = DEXP(-0.125D0*STEP*ETAPDOT(IL,NCHAIN+1-L,IP))
               ETAPDOT(IL,NCHAIN-L,IP) = ETAPDOT(IL,NCHAIN-L,IP)*AA*AA +
     *            0.25D0*STEP*FETAPV(NCHAIN-L)*AA/QNOSP(IL,NCHAIN-L,IP)
            ENDDO 
C     ==--------------------------------------------------------------==
C     ==  DO VELOCITY SCALING AND PROPAGATE THERMOSTAT POSITIONS      ==
C     ==--------------------------------------------------------------==
            AA = DEXP(-0.5D0*STEP*ETAPDOT(IL,1,IP))
            DO IAL=1,NLCTMBM(IL)
               IS=LCTMEMB(1,IAL,IL)
               IA=LCTMEMB(2,IAL,IL)
               VELP(1,IA,IS) = VELP(1,IA,IS)*AA
               VELP(2,IA,IS) = VELP(2,IA,IS)*AA
               VELP(3,IA,IS) = VELP(3,IA,IS)*AA
            ENDDO
            DO L=1,NCHAIN
               ETAP(IL,L,IP)=ETAP(IL,L,IP)+0.5D0*STEP*ETAPDOT(IL,L,IP)
            ENDDO
            EKINP=0.D0
            DO IAL=1,NLCTMBM(IL)
               IS=LCTMEMB(1,IAL,IL)
               IA=LCTMEMB(2,IAL,IL)
               CONST=0.5D0*PMX(IS)
               DO K=1,3
                  EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
               ENDDO
            ENDDO 
            PKEWANT = 0.5D0*GKT(IPP,IL)
            FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
C     ==--------------------------------------------------------------==
C     == LOOP AGAIN OVER CHAIN                                        ==
C     ==--------------------------------------------------------------==
            DO L=1,NCHAIN-1
               AA = DEXP(-0.125D0*STEP*ETAPDOT(IL,L+1,IP))
               ETAPDOT(IL,L,IP) = ETAPDOT(IL,L,IP)*AA*AA +
     *              0.25D0*STEP*FETAPV(L)*AA/QNOSP(IL,L,IP)
               EKINP = 0.5D0*QNOSP(IL,L,IP)*ETAPDOT(IL,L,IP)*
     *              ETAPDOT(IL,L,IP)
               PKEWANT = 0.5D0*LOCTPIN(1,IL)/FACTEM
               FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
            ENDDO
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                ==
C     ==--------------------------------------------------------------==
            ETAPDOT(IL,NCHAIN,IP) = ETAPDOT(IL,NCHAIN,IP) + 
     *           0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IL,NCHAIN,IP) 
         ENDDO
      ELSEIF(TMNOSE) THEN
C     ==--------------------------------------------------------------==
C     ==  LOOP BACKWARDS OVER NOSE-HOOVER CHAIN                       ==
C     ==--------------------------------------------------------------==
        FACTON=0.5D0/FACTEM
        IJ = 0
        DO KF=1,NTHERM(IPP)
C     ==--------------------------------------------------------------==
C     == CALCULATE ALL THERMOSTAT FORCES                              ==
C     ==--------------------------------------------------------------==
          EKINP=0.D0
          DO IDF=1,NDFNT(KF,IPP)
            IJJ=IJ+IDF
            K=MAPDOF(1,IJJ,IPP)
            IA=MAPDOF(2,IJJ,IPP)
            IS=MAPDOF(3,IJJ,IPP)
            CONST=0.5D0*PMX(IS)
            EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,KF)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=2,NCHAIN
            EKINP = 0.5D0*QNOSPM(KF,L-1,IP)*
     *           ETAPMDOT(KF,L-1,IP)*ETAPMDOT(KF,L-1,IP)
            IF (TCAFES) THEN
               PKEWANT = TEMPWR(K,IA,IS)*FACTON
            ELSE
               PKEWANT = TEMPW*FACTON
            ENDIF
            FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==--------------------------------------------------------------==
C     == PROPAGATE LAST CHAIN ELEMENT                                 ==
C     ==--------------------------------------------------------------==
          ETAPMDOT(KF,NCHAIN,IP)=ETAPMDOT(KF,NCHAIN,IP)+ 
     *        0.25D0*STEP*FETAPV(NCHAIN)/QNOSPM(KF,NCHAIN,IP)
C     ==--------------------------------------------------------------==
C     == PROPAGATE REST OF CHAIN                                      ==
C     ==--------------------------------------------------------------==
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPMDOT(KF,NCHAIN+1-L,IP))
            ETAPMDOT(KF,NCHAIN-L,IP) = 
     *             ETAPMDOT(KF,NCHAIN-L,IP)
     *            *AA*AA+0.25D0*STEP*FETAPV(NCHAIN-L)
     *            *AA/QNOSPM(KF,NCHAIN-L,IP)
          ENDDO
C     ==--------------------------------------------------------------==
C     == DO VELOCITY SCALING AND PROPAGATE THERMOSTAT POSITIONS       ==
C     ==--------------------------------------------------------------==
          AA = DEXP(-0.5D0*STEP*ETAPMDOT(KF,1,IP))
          CONST=0.5D0*PMX(IS)
          EKINP=0.D0
          DO IDF=1,NDFNT(KF,IPP)
            IJJ=IJ+IDF
            K=MAPDOF(1,IJJ,IPP)
            IA=MAPDOF(2,IJJ,IPP)
            IS=MAPDOF(3,IJJ,IPP)
            VELP(K,IA,IS) = VELP(K,IA,IS)*AA
            EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,KF)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=1,NCHAIN
            ETAPM(KF,L,IP) = ETAPM(KF,L,IP) + 
     *                     0.5D0*STEP*ETAPMDOT(KF,L,IP)
          ENDDO
C     ==-------------------------------------------------------------==
C     ==  LOOP OVER CHAIN AGAIN                                      ==
C     ==-------------------------------------------------------------==
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPMDOT(KF,L+1,IP))
            ETAPMDOT(KF,L,IP) = ETAPMDOT(KF,L,IP)*AA*AA + 
     *               0.25D0*STEP*FETAPV(L)*AA/QNOSPM(KF,L,IP)
            EKINP = 0.5D0*QNOSPM(KF,L,IP)*
     *               ETAPMDOT(KF,L,IP)*ETAPMDOT(KF,L,IP)
            IF (TCAFES) THEN
               PKEWANT = TEMPWR(K,IA,IS)*FACTON
            ELSE
               PKEWANT = TEMPW*FACTON
            ENDIF
            FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==------------------------------------------------------------==
C     == PROPAGATE LAST CHAIN ELEMENT                               ==
C     ==------------------------------------------------------------==
          ETAPMDOT(KF,NCHAIN,IP)=ETAPMDOT(KF,NCHAIN,IP)+ 
     *          0.25D0*STEP*FETAPV(NCHAIN)/QNOSPM(KF,NCHAIN,IP)
C     ==------------------------------------------------------------==
          IJ=IJ+NDFNT(KF,IPP)
        ENDDO
      ELSE      ! regular nose-hoover
C     ==------------------------------------------------------------==
C     == CALCULATE ALL NOSE-HOOVER CHAIN FORCES                     ==
C     ==------------------------------------------------------------==
        FACTON=0.5D0/FACTEM
        EKINP=0.D0
        DO IS=1,NSP
          CONST=0.5D0*PMX(IS)
          DO IA=1,NA(IS)
            DO K=1,3
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
        ENDDO
        PKEWANT = 0.5D0*GKT(IPP,1)
        FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
        DO L=2,NCHAIN
          EKINP = 0.5D0*QNOSPC(L-1,IP)*ETAP1DOT(L-1,IP)*
     *         ETAP1DOT(L-1,IP)
          PKEWANT = TEMPW*FACTON
          FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
        ENDDO
C     ==------------------------------------------------------------==
C     == MOVE LAST CHAIN ELEMENT                                    ==
C     ==------------------------------------------------------------==
        ETAP1DOT(NCHAIN,IP) = ETAP1DOT(NCHAIN,IP) + 
     *                  0.25D0*STEP*FETAPV(NCHAIN)/QNOSPC(NCHAIN,IP)
C     ==------------------------------------------------------------==
C     ==  LOOP OVER REST OF NOSE-HOOVER CHAIN                       ==
C     ==------------------------------------------------------------==
        DO L=1,NCHAIN-1
          AA = DEXP(-0.125D0*STEP*ETAP1DOT(NCHAIN+1-L,IP))
          ETAP1DOT(NCHAIN-L,IP) = ETAP1DOT(NCHAIN-L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(NCHAIN-L)*AA/QNOSPC(NCHAIN-L,IP)
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  DO VELOCITY SCALING AND PROPAGATE THERMOSTAT POSITIONS      ==
C     ==--------------------------------------------------------------==
        AA = DEXP(-0.5D0*STEP*ETAP1DOT(1,IP))
        DO IS=1,NSP
          DO IA=1,NA(IS)
            DO K=1,3
              VELP(K,IA,IS) = VELP(K,IA,IS)*AA
            ENDDO
          ENDDO
        ENDDO
C
        DO L=1,NCHAIN
          ETAP1(L,IP) = ETAP1(L,IP) + 0.5D0*STEP*ETAP1DOT(L,IP)
        ENDDO
C     ==--------------------------------------------------------------==
C     == RECALCULATE CHAIN FORCE 1                                    ==
C     ==--------------------------------------------------------------==
        EKINP=0.D0
        DO IS=1,NSP
          CONST=0.5D0*PMX(IS)
          DO IA=1,NA(IS)
            DO K=1,3
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
        ENDDO
        PKEWANT = 0.5D0*GKT(IPP,1)
        FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
C     ==-------------------------------------------------------------==
C     ==  LOOP OVER CHAIN AGAIN                                      ==
C     ==-------------------------------------------------------------==
        DO L=1,NCHAIN-1
          AA = DEXP(-0.125D0*STEP*ETAP1DOT(L+1,IP))
          ETAP1DOT(L,IP) = ETAP1DOT(L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(L)*AA/QNOSPC(L,IP)
          EKINP = 0.5D0*QNOSPC(L,IP)*ETAP1DOT(L,IP)*ETAP1DOT(L,IP)
          PKEWANT = TEMPW*FACTON
          FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
        ENDDO
C     ==------------------------------------------------------------==
C     == MOVE LAST CHAIN ELEMENT                                    ==
C     ==------------------------------------------------------------==
        ETAP1DOT(NCHAIN,IP) = ETAP1DOT(NCHAIN,IP) + 
     *                  0.25D0*STEP*FETAPV(NCHAIN)/QNOSPC(NCHAIN,IP)
      ENDIF
C     ==------------------------------------------------------------==
      RETURN
      END
C     ================================================================



