C     ==================================================================
      SUBROUTINE POLARISE(C0,WE,F,NSTATE,NKPOINT)
C     ==--------------------------------------------------------------==
C     == ROUTINE TO COMPUTE THE POLARISABILITY (A. Alavi 1997)        ==
C     == VIA DIRECT SUMMATION OVER EXCITED STATES 
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'pola.inc'
C     Arguments
      INTEGER    NSTATE,NKPOINT
      COMPLEX*16 C0(NGWK,NSTATE,NKPOINT)
      REAL*8     WE(NSTATE,NKPOINT),F(NSTATE,NKPOINT)
C     Variables
      COMPLEX*16 ZZERO
      PARAMETER  (ZZERO=(0.D0,0.D0))
      DIMENSION  WK(NKPOINT)
      REAL*8     SUM(3),DF,DENG,ALPHAXXA,ALPHAYYA,ALPHAZZA,
     &           ALPHAXX,ALPHAYY,ALPHAZZ
      COMPLEX*16 CPX,CPY,CPZ
      INTEGER    IK,I,J,IFIRST
      DATA IFIRST /0/
C     ==--------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN 
        IFIRST=1
        ALPHAXXA=0.D0
        ALPHAYYA=0.D0
        ALPHAZZA=0.D0 
      ENDIF
      CALL AZZERO(SUM,3)  
      DO IK = 1 , NKPOINT
        DO I = 1 , NSTATE-1
          DO J = I+1,NSTATE
            DF = F(I,IK) - F(J,IK)
            IF(DF.LT.1.D-9) GOTO 999
            DENG = WE(J,IK)-WE(I,IK)      
            CALL CALC_PIJ(C0(1,J,IK),C0(1,I,IK),CPX,CPY,CPZ,IK)
            SUM(1) = SUM(1) + DREAL(DF*WK(IK)*CPX*DCONJG(CPX)/DENG**3)
            SUM(2) = SUM(2) + DREAL(DF*WK(IK)*CPY*DCONJG(CPY)/DENG**3)
            SUM(3) = SUM(3) + DREAL(DF*WK(IK)*CPZ*DCONJG(CPZ)/DENG**3)
 999        CONTINUE
          ENDDO
        ENDDO 
      ENDDO
      ALPHAXX=SUM(1)*TPIBA2
      ALPHAYY=SUM(2)*TPIBA2
      ALPHAZZ=SUM(3)*TPIBA2
      ALPHAXXA=ALPHAXXA+ALPHAXX
      ALPHAYYA=ALPHAYYA+ALPHAYY
      ALPHAZZA=ALPHAZZA+ALPHAZZ
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE POLARPROJ(C0,WE,F,AMU,
     &                     VPOT,PSI,SCR,LSCR,NSTATE,NKPOINT)
C     ==--------------------------------------------------------------==
C     == ROUTINE TO COMPUTE THE POLARISABILITY                        ==
C     == BY USING PROJECTION METHOD                                   ==
C     == ( P. Gianozzi, S de Gironcoli, P. Pavone and S. Baroni,      ==
C     == Phys. Rev. B, 43, 7231, (1991)                               ==
C     ==                                                              ==
C     == VALENCE STATES ARE DEFINED AS THOSE FOR WHOM THE OCCUPATION  ==
C     == NUMBERIS GREATER THAN TOLLOCC ( specified in pola.inc)       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'fft.inc' 
      INCLUDE 'ions.inc' 
      INCLUDE 'spin.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'pola.inc' 
      INCLUDE 'atimes.inc' 
      INCLUDE 'sfac.inc' 
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE,NKPOINT,LSCR
      COMPLEX*16 C0(NGWK,NSTATE,NKPOINT),PSI(NNR1)
      REAL*8     WE(NSTATE,NKPOINT),F(NSTATE,NKPOINT),AMU,
     &           VPOT(NNR1,NLSD),SCR(LSCR)
C     Variables
      COMPLEX*16 ZZERO
      PARAMETER  (ZZERO=(0.D0,0.D0))
      DIMENSION  WK(NKPOINT),RK(3,NKPTS)
      COMPLEX*16 CPROJ(NGWK,3),CB(NGWK),CX(NGWK,3),
     &           VT1PP(MAXFFT),PSI2(NNR1)
      POINTER    (IP_CPROJ,CPROJ),(IP_CB,CB),(IP_CX,CX),
     &           (IP_VT1PP,VT1PP),(IP_VEXT,VEXT),(IP_PSI2,PSI2)
      COMPLEX*16 CAUX,ZDOTC,EI123
      CHARACTER  COMP(3)*1,TAG*30
      REAL*8     AUXX(3,3),VEXT(NHG,NSP),AUX,TIM1,TIM2,TIM,ERR,
     &           TIMEF,DOTP
      EXTERNAL   DDOT,ZDOTC,TIMEF
      REAL*8     FNL(*),DFNL(*)
      INTEGER    IS,IG,IFFT,ISA,IA,IR,KK,ISUB,IK,I,J,JJ,K,L,M,
     &     LPOLARPROJ,IFIRST,JWH(6),KWH(6)
      DATA       JWH/1,1,1,2,2,3/
      DATA       KWH/1,2,3,2,3,3/
      DATA       IFIRST /0/
      SAVE       IFIRST,IP_CPROJ,IP_CB,IP_CX,COMP,IP_VEXT
#ifdef __NEC
      REAL*8     SUM(3,3)
      INTEGER    ISA0
      INTEGER    ISV(*), IAV (*)
      POINTER    (IP_ISV,ISV)
      POINTER    (IP_IAV,IAV)
#else
      REAL*8     SUM
#endif
C     ==--------------------------------------------------------------==
      CALL TISET(' POLARPROJ',ISUB)
      CALL GIVE_SCR_POLARPROJ(LPOLARPROJ,TAG,NSTATE)
      CALL TEST_SCR('POLARPROJ',TAG,LSCR,LPOLARPROJ)
C     ==--------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN 
        IFIRST=1
        CALL AZZERO(ALPHAPAV,9)  
        CALL MEMORY(IP_CPROJ,2*NGWK*3,'CPROJ')
        CALL MEMORY(IP_CB,2*NGWK,'CB')
        CALL MEMORY(IP_CX,2*NGWK*3,'CX')
        COMP(1) = 'X'
        COMP(2) = 'Y'
        COMP(3) = 'Z'
        IF(TZEFF) THEN
          CALL MEMORY(IP_ZEFF,9*NAX*NSP,'ZEFF') 
          CALL MEMORY(IP_ZEFFAV,9*NAX*NSP,'ZEFFAV') 
          CALL MEMORY(IP_VT1PP,2*MAXFFT,'VT1PP')
          CALL MEMORY(IP_VEXT,NHG*NSP,'VEXT')
          CALL MEMORY(IP_PSI2,2*NNR1,'PSI2')
          CALL AZZERO(ZEFFAV,9*NAX*NSP)  
#ifdef __NEC
          ISA0=0
          DO IS=1,NSP
             ISA0 = ISA0 + NA(IS)
          ENDDO
          CALL MEMORY(IP_ISV,ISA0,'ISV')
          CALL MEMORY(IP_IAV,ISA0,'IAV')
          ISA=0
          DO IS=1,NSP
             DO IA=1,NA(IS)
               ISA=ISA+1
               ISV(ISA) = IS
               IAV(ISA) = IA
             ENDDO
          ENDDO
#endif
C         Compute external potential in g-space. 
C         VPS=short-range pseudpotential term in g-space
C         RHOPS=e^-g^2, arising from the Gaussian smearing of nuclear charge. 
          DO IS=1,NSP
            DO IG=2,NHG
              VEXT(IG,IS)=(VPS(IS,IG)+FPI*RHOPS(IS,IG)/HG(IG)/TPIBA2)*
     &             TPIBA2
            ENDDO
          ENDDO
        ENDIF
      ENDIF
      IFFT=1
      WRITE(6,'(1X,64("<")/20X,A26/1X,64(">"))') 
     &     'CALCULATING POLARISABILITY' 
      CALL WREIGEN(WE,F,AMU,NSTATE)
      CALL AZZERO(ALPHAP,9)  
      DO IK = 1 , NKPOINT
        WRITE(6,'(1X,64("="))') 
        WRITE(6,'(A9,I4,3X,4(F10.7,3X))') 
     *           ' K POINT:',IK,RK(1,IK),RK(2,IK),RK(3,IK),WK(IK)
        DO I = 1 , NSTATE
          IF(F(I,IK).LT.TOLLOCC) GOTO 999 
          WRITE(6,'(A9,I4,4X,A11,F7.3)')
     &       '   STATE:',I,'OCCUPATION:',F(I,IK)
          ATIMES_EVAL=WE(I,IK) 
          IKIND_ATIMES=IK 
          TIM1=TIMEF()
          DO J=1,3
C           Returns the j-th component of momentum operator in cproj
            CALL CALC_PI(C0(1,I,IK),CPROJ(1,J),J,IK)
            CALL PROJV(CPROJ(1,J),C0(1,1,IK),F(1,IK),NSTATE)
C           Multiply by -i 
C            CALL ZSCAL(NGWK,-UIMAG,CPROJ(1,J),1)
            CALL DCOPY(NGWK*2,CPROJ(1,J),1,CB,1)
            CALL ZAZZERO(CX(1,J),NGWK) 
C           Solve A.x=b
            CALL CLINBCG(CB,CX(1,J),C0(1,1,IK),VPOT,PSI,SCR,LSCR,
     &             NSTATE,F(1,IK),ITOL,TOL,ITMAX,ERR)
C           Project out valence states 
            CALL PROJV(CX(1,J),C0(1,1,IK),F(1,IK),NSTATE)
C           Store away 
            CALL DCOPY(NGWK*2,CX(1,J),1,CPROJ(1,J),1)
            CALL DCOPY(NGWK*2,CX(1,J),1,CB,1)
            CALL AZZERO(CX(1,J),NGWK*2) 
C           Solve Ax=b.   
            CALL CLINBCG(CB,CX(1,J),C0(1,1,IK),VPOT,PSI,SCR,LSCR,
     &                   NSTATE,F(1,IK),ITOL,TOL,ITMAX,ERR)
            CALL PROJV(CX(1,J),C0(1,1,IK),F(1,IK),NSTATE) 
          ENDDO
          TIM2=TIMEF()
          TIM=(TIM2-TIM1)*0.001D0
          IF(TKPNT) THEN 
            DO JJ=1,6
              J=JWH(JJ)
              K=KWH(JJ)
              AUX=DREAL(ZDOTC(NGWK,CPROJ(1,J),1,CX(1,K),1))
              AUXX(J,K)=2.D0*AUX*WK(IK)*F(I,IK)
              ALPHAP(J,K)=ALPHAP(J,K)+AUXX(J,K)
            ENDDO
          ELSE
            DO JJ=1,6
              J=JWH(JJ)
              K=KWH(JJ)
              AUX=DOTP(NGWK,CPROJ(1,J),CX(1,K))
              AUXX(J,K)=2.D0*AUX*WK(IK)*F(I,IK)
              ALPHAP(J,K)=ALPHAP(J,K)+AUXX(J,K)
            ENDDO
          ENDIF
          WRITE(6,'(1X,3(A1,A1,F10.4,3X),3X,A6,F9.2)')
     &     COMP(JWH(1)),COMP(KWH(1)),AUXX(JWH(1),KWH(1)),
     &     COMP(JWH(4)),COMP(KWH(4)),AUXX(JWH(4),KWH(4)),
     &     COMP(JWH(6)),COMP(KWH(6)),AUXX(JWH(6),KWH(6)),
     &         ' TIME:',TIM
C         ==----------------------------------------------------------==
C         == Effective charge calculation                             ==
C         ==----------------------------------------------------------==
C         First transform c0 to real space and store in PSI 
          IF(TZEFF) THEN 
            CALL ZAZZERO(PSI,MAXFFT)
#ifdef __NEC
!CDIR NODEP
#else
!$OMP parallel do private(IG)
#endif
            DO IG = 1 , NGW
              PSI(NZHS(IG) ) = C0(IG,I,IK)
              PSI(INDZS(IG)) = C0(IG+NGW,I,IK)
            ENDDO
            IF(GEQ0) PSI(NZHS(1)) = C0(1,I,IK)
            IF(IFFT.EQ.1) THEN 
              CALL S_INVFFT(PSI)
            ELSE 
              CALL SG_INVFFT(PSI) 
            ENDIF
            CALL DCOPY(2*NNR1,PSI,1,PSI2,1)
C           Next compute dV/dRI in g-space, transform to real space
C           and form dV/dRI|C0>. 
            ISA=0
            DO IS=1,NSP
              DO IA=1,NA(IS)
                ISA=ISA+1
                DO J=1,3
C                 Put dV/dRIj in g-space in VT1PP 
                  CALL ZAZZERO(VT1PP,MAXFFT) 
#ifdef __NEC
!CDIR NODEP
#else
!$OMP parallel do private(IG,EI123,CAUX)
#endif
                  DO IG=2,NHG
                    EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                   EI3(ISA,INYH(3,IG))
                    CAUX=VEXT(IG,IS)*DCMPLX(0.D0,GK(J,IG))*
     &                   TPIBA*EI123
                    VT1PP(NZH(IG))=CAUX
                    VT1PP(INDZ(IG))=DCONJG(CAUX)
                  ENDDO
C                 Transform to real space 
                  CALL INVFFT(VT1PP)
C                 Multiply by psi in real space  
!$OMP parallel do private(IR)
                  DO IR=1,NNR1
                    VT1PP(IR)=VT1PP(IR)*PSI2(IR)
                  ENDDO
C                 FWFFT VT1PP 
                  IF(IFFT.EQ.1) THEN 
                    CALL S_FWFFT(VT1PP)
                  ELSE
                    CALL SG_FWFFT(VT1PP)
                  ENDIF
C                 Gather VT1PP into CB  
                  IF(TKPNT) THEN
!$OMP parallel do private(IG)
                    DO IG=1,NGW
                      CB(IG)=VT1PP(NZHS(IG))
                      CB(IG+NGW)=VT1PP(INDZS(IG))
                    ENDDO
                    IF(GEQ0) CB(NGW+1)=ZZERO 
                  ELSE
                    CALL ZGTHR(NGW,VT1PP,CB,NZHS)
                  ENDIF
                  CALL ZSCAL(NGWK,-UIMAG,CB,1)
                  IF(TKPNT) THEN 
                    DO JJ=1,3
                      AUX=4.D0*DREAL(ZDOTC(NGWK,CX(1,JJ),1,CB,1))*
     &                     F(I,IK)*WK(IK)
                      ZEFF(JJ,J,IA,IS)=ZEFF(JJ,J,IA,IS)+AUX
                    ENDDO
                  ELSE
                    DO JJ=1,3
                      AUX=4.D0*DOTP(NGW,CX(1,JJ),CB)*
     &                     F(I,IK)*WK(IK)
                      ZEFF(JJ,J,IA,IS)=ZEFF(JJ,J,IA,IS)+AUX
                    ENDDO
                  ENDIF
                ENDDO
              ENDDO
            ENDDO
          ENDIF
 999      CONTINUE
        ENDDO 
      ENDDO
      DO KK=1,6 
        ALPHAPAV(JWH(KK),KWH(KK))=ALPHAPAV(JWH(KK),KWH(KK))+
     &       ALPHAP(JWH(KK),KWH(KK))
      ENDDO
      ALPHAP(2,1)=ALPHAP(1,2)
      ALPHAP(3,1)=ALPHAP(1,3)
      ALPHAP(3,2)=ALPHAP(2,3)
      ALPHAPAV(2,1)=ALPHAPAV(1,2)
      ALPHAPAV(3,1)=ALPHAPAV(1,3)
      ALPHAPAV(3,2)=ALPHAPAV(2,3)
      IF(TZEFF) THEN
C       Apply acoustic sum rule.
#ifdef __NEC
        CALL AZZERO(SUM,3*3) 
        DO ISA = 1,ISA0
           IS= ISV(ISA)
           IA= IAV(ISA)
           DO L=1,3
             DO M=1,3
                SUM(L,M)=SUM(L,M)+ZEFF(L,M,IA,IS)
             ENDDO
           ENDDO
        ENDDO
        DO L=1,3
          DO M=1,3
             SUM(L,M)=SUM(L,M)/DBLE(NAT)
          ENDDO
        ENDDO
!CDIR NODEP
        DO ISA = 1,ISA0
           IS= ISV(ISA)
           IA= IAV(ISA)
           DO L=1,3
             DO M=1,3
                ZEFF(L,M,IA,IS)=ZEFF(L,M,IA,IS)-SUM(L,M)
             ENDDO
           ENDDO
         ENDDO
#else
        DO L=1,3
          DO M=1,3
            SUM=0.D0 
            DO IS=1,NSP
              DO IA=1,NA(IS)
                SUM=SUM+ZEFF(L,M,IA,IS)
              ENDDO
            ENDDO
            SUM=SUM/DBLE(NAT)
            DO IS=1,NSP
              DO IA=1,NA(IS)
                ZEFF(L,M,IA,IS)=ZEFF(L,M,IA,IS)-SUM
              ENDDO
            ENDDO
          ENDDO
        ENDDO
#endif
        CALL DAXPY(9*NAX*NSP,1.D0,ZEFF,1,ZEFFAV,1)
      ENDIF
C     ==--------------------------------------------------------------==
      CALL TIHALT(' POLARPROJ',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PROJV(CPROJ,C0,F,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'kpts.inc' 
      INCLUDE 'pola.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 CPROJ(NGWK),C0(NGWK,NSTATE)
      REAL*8     F(NGWK)
C     Variables
      COMPLEX*16 CAUX,
     &           ZDOTC
      REAL*8     AUX,
     &           DOTP
      EXTERNAL   DDOT,ZDOTC
      INTEGER    K
C     ==--------------------------------------------------------------==
      DO K = 1 , NSTATE
C       Project out valence states
        IF(F(K).GT.TOLLOCC) THEN 
          IF(TKPNT) THEN
            CAUX=ZDOTC(NGWK,C0(1,K),1,CPROJ,1)
            CALL ZAXPY(NGWK,-CAUX,C0(1,K),1,CPROJ,1)
          ELSE
            AUX=DOTP(NGW,C0(1,K),CPROJ)
            CALL DAXPY(NGW*2,-AUX,C0(1,K),1,CPROJ,1)
          ENDIF
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END 
C     ==================================================================
      SUBROUTINE GIVE_SCR_POLARPROJ(LPOLARPROJ,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   LPOLARPROJ,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_CLINBCG(LPOLARPROJ,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
