C     ==================================================================
      SUBROUTINE POSUPA(C0,CM,C2,GAMX,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==  UPDATE OF THE POSITIONS FOR VELOCITY VERLET                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'harm.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'nort.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'kpts.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGW,*),CM(NGW,*),C2(NGW,*)
      REAL*8     GAMX(*),SCR(*)
C     Variables
      CHARACTER  TAG*30
      REAL*8     AI(3),PF1,PF2,PF3,PF4,DOTP,XI,ODT
      EXTERNAL   DOTP
      INTEGER    I,IG,ISUB,LPOSUPA,NSTX
      LOGICAL    PRTEV,TNON
C     ==--------------------------------------------------------------==
C     ==  WAVEFUNCTIONS                                               ==
C     ==--------------------------------------------------------------==
      CALL TISET('    POSUPA',ISUB)
      IF(TKPNT) CALL STOPGM('POSUPA','K POINTS NOT IMPLEMENTED')
      CALL GIVE_SCR_POSUPA(LPOSUPA,TAG,NSTATE)
      CALL TEST_SCR('POSUPA',TAG,LSCR,LPOSUPA)
C     ==--------------------------------------------------------------==
      IF(NONORT) THEN
        IF(THARM) THEN
C$OMP parallel do private (I,IG,PF1,PF2,PF3)
          DO I=1,NSTATE
            DO IG=1,NGW
              PF1=DCGT(IG)
              PF2=DSGTW(IG)
              PF3=WDSGT(IG)
              C2(IG,I)=PF1*C0(IG,I)+PF2*CM(IG,I)
              CM(IG,I)=PF1*CM(IG,I)-PF3*C0(IG,I)
            ENDDO
          ENDDO
        ELSE
C$OMP parallel do private (I,IG)
          DO I=1,NSTATE
            DO IG=1,NGW
              C2(IG,I)=C0(IG,I)+DT_ELEC*CM(IG,I)
            ENDDO
          ENDDO
        ENDIF
C..LINEAR CONSTRAINTS
        IF(THARM.OR.TMASS) THEN
          DO I=1,NSTATE
C$OMP parallel do private (IG,PF4)
            DO IG=1,NGW
              IF(THARM) THEN
                PF4=DSGTW(IG)*DTAN2W(IG)/DTB2ME
              ELSE
                PF4=EMASS/XMU(IG)
              ENDIF
              C0(IG,I)=PF4*C0(IG,I)
            ENDDO
            AI(1)=DOTP(NGW,C0(1,I),C0(1,I))
            AI(2)=2.0D0*DOTP(NGW,C2(1,I),C0(1,I))
            AI(3)=DOTP(NGW,C2(1,I),C2(1,I))
#ifdef PARALLEL
            CALL GLOSUM(3,AI)
#endif
            AI(3)=AI(3)-1.0D0
            XI=(-AI(2)+SQRT(AI(2)*AI(2)-4.D0*AI(1)*AI(3)))/(2.D0*AI(1))
            CALL DAXPY(2*NGW,XI,C0(1,I),1,C2(1,I),1)
            CALL DAXPY(2*NGW,XI/DT_ELEC,C0(1,I),1,CM(1,I),1)
          ENDDO
        ELSE
          DO I=1,NSTATE
            AI(1)=DOTP(NGW,C0(1,I),C0(1,I))
            AI(2)=2.0D0*DOTP(NGW,C2(1,I),C0(1,I))
            AI(3)=DOTP(NGW,C2(1,I),C2(1,I))
#ifdef PARALLEL
            CALL GLOSUM(3,AI)
#endif
            AI(3)=AI(3)-1.0D0
            XI=(-AI(2)+SQRT(AI(2)*AI(2)-4.D0*AI(1)*AI(3)))/
     *         (2.D0*AI(1))
            CALL DAXPY(2*NGW,XI,C0(1,I),1,C2(1,I),1)
            CALL DAXPY(2*NGW,XI/DT_ELEC,C0(1,I),1,CM(1,I),1)
          ENDDO
        ENDIF
        CALL DCOPY(2*NGW*NSTATE,C2(1,1),1,C0(1,1),1)
      ELSE
        IF(THARM) THEN
C$OMP parallel do private (I,IG,PF1,PF2,PF3,PF4)
          DO I=1,NSTATE
            DO IG=1,NGW
              PF1=DCGT(IG)
              PF2=DSGTW(IG)
              PF3=WDSGT(IG)
              PF4=PF2*DTAN2W(IG)/DT2HBE
              C2(IG,I)=PF1*C0(IG,I)+PF2*CM(IG,I)
              CM(IG,I)=PF1*CM(IG,I)-PF3*C0(IG,I)
              C0(IG,I)=PF4*C0(IG,I)
            ENDDO
          ENDDO
        ELSE
C$OMP parallel do private (I,IG)
          DO I=1,NSTATE
            DO IG=1,NGW
              C2(IG,I)=C0(IG,I)+DT_ELEC*CM(IG,I)
            ENDDO
          ENDDO
          IF(TMASS) THEN
C$OMP parallel do private (I,IG,PF4)
            DO I=1,NSTATE
              DO IG=1,NGW
                PF4=EMASS/XMU(IG)
                C0(IG,I)=PF4*C0(IG,I)
              ENDDO
            ENDDO
          ENDIF
        ENDIF
C       REORTHOGONALIZE THE WAVEFUNCTIONS
        PRTEV=PRTEIG .AND. .NOT.TIVAN
        TNON=TMASS.OR.THARM
        CALL RORTOG(C0,C2,GAMX,SCR,LSCR,TNON,NSTATE,PRTEV)
C       ADD CONSTRAINTS FOR WAVEFUNCTION VELOCITIES 
        IF(THARM) THEN
C$OMP parallel do private (I,IG,PF1,PF2,PF4)
          DO I=1,NSTATE
            DO IG=1,NGW
              PF1=DCGT(IG)
              PF2=DSGTW(IG)
              PF4=DELT_ELEC*(PF1/PF2)
              C0(IG,I)=PF4*C0(IG,I)
            ENDDO
          ENDDO
        ENDIF
        ODT=1.0D0/DT_ELEC
        IF(NGW.GT.0) THEN
          IF(TDMAL) THEN
            CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
            CALL ROTATE_DA(ODT,C0,1.D0,CM,GAMX,SCR,2*NGW,NSTATE,
     *               NWA12(0,1),NWA12(0,2),NSTX,MEPOS,PGROUP,NPROC,
     *               ALLGRP,TLSD,NSUP,NSDOWN)
          ELSE
            CALL ROTATE(ODT,C0,1.0D0,CM,GAMX,NSTATE,2*NGW,TLSD,
     *                  NSUP,NSDOWN)
          ENDIF
          CALL DCOPY(2*NSTATE*NGW,C2(1,1),1,C0(1,1),1)
        ENDIF
      ENDIF
      CALL TIHALT('    POSUPA',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_POSUPA(LPOSUPA,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NONORT
C     Arguments
      INTEGER   LPOSUPA,NSTATE
      CHARACTER TAG*30
      INTEGER   LORTOG,LROTATE,NSTX
C     ==--------------------------------------------------------------==
      IF(NONORT) THEN
        LPOSUPA=0
      ELSE
        IF(TDMAL) THEN
          CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
          LROTATE=NSTATE*NSTX
        ELSE
          LROTATE=0
        ENDIF
        CALL GIVE_SCR_RORTOG(LORTOG,TAG,NSTATE)
        LPOSUPA=MAX(LORTOG,LROTATE)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
