#if defined(__SR11000)
*option OPT(O(ss))
#endif
C     ==================================================================
      SUBROUTINE POTFOR(FION,V,EIROP)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == POTENTIAL ENERGY CONTRIBUTIONS TO THE FORCES ON THE IONS     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      REAL*8     FION(3,NAX,NSX)
      COMPLEX*16 V(NNR1),EIROP(NHG)
C     Variables
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 RP,RHET,RHOG,RHETS,RHOGS,GX,GY,GZ,VCGS,
     *           TXX,TYY,TZZ,EI123
      REAL*8     FNL(*),DFNL(*)
      REAL*8     OMTP
      INTEGER    IG1,IG,ISA,IS,IA
C     ==--------------------------------------------------------------==
      OMTP=2.D0*OMEGA*TPIBA
      IG1=1
      IF(GEQ0) IG1=2
#if defined (__VECTOR)
      IF(BIGMEM) THEN
!$OMP parallel do private(ISA,IA,IS,IG,EI123,RP,RHET,RHOG,RHETS,RHOGS,
!$OMP+ GX,GY,GZ,VCGS)
#ifdef _vpp_
!OCL NOALIAS
#endif
        DO ISA=1,NAT
          IA=IATPT(1,ISA)
          IS=IATPT(2,ISA)
          DO IG=IG1,NHG
            EI123=EIGRB(IG,ISA)
            RP=EIROP(IG)
            RHET=V(NZH(IG))
            RHOG=RHET+RP
            RHETS=DCONJG(RHET)
            RHOGS=DCONJG(RHOG)
            GX=DCMPLX(0.D0,GK(1,IG))
            GY=DCMPLX(0.D0,GK(2,IG))
            GZ=DCMPLX(0.D0,GK(3,IG))
            VCGS=SCG(IG)*RHOGS
            EI123=EI123*(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)
            FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*GX)*OMTP
            FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*GY)*OMTP
            FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*GZ)*OMTP
          ENDDO
        ENDDO
      ELSE
!$OMP parallel do private(ISA,IA,IS,IG,EI123,RP,RHET,RHOG,RHETS,RHOGS,
!$OMP+ GX,GY,GZ,VCGS)
#ifdef _vpp_
!OCL NOALIAS
#endif
        DO ISA=1,NAT
          IA=IATPT(1,ISA)
          IS=IATPT(2,ISA)
          DO IG=IG1,NHG
            EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                  EI3(ISA,INYH(3,IG))
            RP=EIROP(IG)
            RHET=V(NZH(IG))
            RHOG=RHET+RP
            RHETS=DCONJG(RHET)
            RHOGS=DCONJG(RHOG)
            GX=DCMPLX(0.D0,GK(1,IG))
            GY=DCMPLX(0.D0,GK(2,IG))
            GZ=DCMPLX(0.D0,GK(3,IG))
            VCGS=SCG(IG)*RHOGS
            EI123=EI123*(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)
            FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*GX)*OMTP
            FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*GY)*OMTP
            FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*GZ)*OMTP
          ENDDO
        ENDDO
      ENDIF
#else                
cmb   For scalar version & pseudo-vector machines
      IF(BIGMEM) THEN
#ifdef __SR8000
*poption parallel
*poption tlocal(RP,RHET,RHOG,RHETS,RHOGS,GX,GY,GZ,VCGS)
*poption tlocal(ISA,TXX,TYY,TZZ,EI123)
*poption psum(FION)
#else
#ifdef __HPC
!no-OMP - segmentation fault if OMP are used here
#else
!$OMP parallel do private(IG,IS,IA,ISA)
!$OMP+ private(RP,RHET,RHOG,RHETS,RHOGS,GX,GY,GZ,VCGS)
!$OMP+ private(TXX,TYY,TZZ,EI123)
!$OMP+ reduction(+:FION)
#endif
#endif
        DO IG=IG1,NHG
          RP=EIROP(IG)
          RHET=V(NZH(IG))
          RHOG=RHET+RP
          RHETS=DCONJG(RHET)
          RHOGS=DCONJG(RHOG)
          GX=DCMPLX(0.D0,GK(1,IG))
          GY=DCMPLX(0.D0,GK(2,IG))
          GZ=DCMPLX(0.D0,GK(3,IG))
          VCGS=SCG(IG)*RHOGS
          ISA=0
          DO IS=1,NSP
            TXX=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GX
            TYY=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GY
            TZZ=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GZ
            DO IA=1,NA(IS)
              ISA=ISA+1
              EI123=EIGRB(IG,ISA)
              FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*TXX)*OMTP
              FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*TYY)*OMTP
              FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*TZZ)*OMTP
            ENDDO
          ENDDO
        ENDDO
      ELSE
#ifdef __SR8000
*poption parallel
*poption tlocal(RP,RHET,RHOG,RHETS,RHOGS,GX,GY,GZ,VCGS)
*poption tlocal(ISA,TXX,TYY,TZZ,EI123)
*poption psum(FION)
#else
#ifdef __HPC
!no-OMP - segmentation fault if OMP are used here
#else
!$OMP parallel do private(IG,IS,IA,ISA)
!$OMP+ private(RP,RHET,RHOG,RHETS,RHOGS,GX,GY,GZ,VCGS)
!$OMP+ private(TXX,TYY,TZZ,EI123)
!$OMP+ reduction(+:FION)
#endif
#endif
        DO IG=IG1,NHG
          RP=EIROP(IG)
          RHET=V(NZH(IG))
          RHOG=RHET+RP
          RHETS=DCONJG(RHET)
          RHOGS=DCONJG(RHOG)
          GX=DCMPLX(0.D0,GK(1,IG))
          GY=DCMPLX(0.D0,GK(2,IG))
          GZ=DCMPLX(0.D0,GK(3,IG))
          VCGS=SCG(IG)*RHOGS
          ISA=0
          DO IS=1,NSP
            TXX=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GX
            TYY=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GY
            TZZ=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GZ
            DO IA=1,NA(IS)
              ISA=ISA+1
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                  EI3(ISA,INYH(3,IG))
              FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*TXX)*OMTP
              FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*TYY)*OMTP
              FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*TZZ)*OMTP
            ENDDO
          ENDDO
        ENDDO
      ENDIF 
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE POTABFOR(FION,RHOG)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == POTENTIAL ENERGY CONTRIBUTIONS TO THE FORCES ON THE IONS     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      REAL*8     FION(3,NAX,NSX)
      COMPLEX*16 RHOG(NNR1)
C     Variables
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 RG,GX,GY,GZ,TXX,TYY,TZZ,EI123
      REAL*8     FNL(*),DFNL(*)
      REAL*8     OMTP
      INTEGER    IG1,IG,ISA,IS,IA
C     ==--------------------------------------------------------------==
      OMTP=2.D0*OMEGA*TPIBA
      IG1=1
      IF(GEQ0) IG1=2
#if defined (__VECTOR) && !(__NEC)
      ISA=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          ISA=ISA+1
          IF(BIGMEM) THEN
!$OMP parallel do private(IG,EI123,RG,GX,GY,GZ,TXX,TYY,TZZ)
!$OMP+ shared(ISA,RHOG)
            DO IG=IG1,NHG
              EI123=EIGRB(IG,ISA)
              RG=DCONJG(RHOG(IG))
cmb              GX=DCMPLX(0.D0,GK(1,IG))
cmb              GY=DCMPLX(0.D0,GK(2,IG))
cmb              GZ=DCMPLX(0.D0,GK(3,IG))
              TXX=VPS(IS,IG)*RG*DCMPLX(0.D0,GK(1,IG))
              TYY=VPS(IS,IG)*RG*DCMPLX(0.D0,GK(2,IG))
              TZZ=VPS(IS,IG)*RG*DCMPLX(0.D0,GK(3,IG))
              FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*TXX)*OMTP
              FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*TYY)*OMTP
              FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*TZZ)*OMTP
            ENDDO
          ELSE
!$OMP parallel do private(IG,EI123,RG,GX,GY,GZ,TXX,TYY,TZZ)
!$OMP+ shared(ISA,RHOG)
            DO IG=IG1,NHG
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                    EI3(ISA,INYH(3,IG))
              RG=DCONJG(RHOG(IG))
cmb              GX=DCMPLX(0.D0,GK(1,IG))
cmb              GY=DCMPLX(0.D0,GK(2,IG))
cmb              GZ=DCMPLX(0.D0,GK(3,IG))
              TXX=VPS(IS,IG)*RG*DCMPLX(0.D0,GK(1,IG))
              TYY=VPS(IS,IG)*RG*DCMPLX(0.D0,GK(2,IG))
              TZZ=VPS(IS,IG)*RG*DCMPLX(0.D0,GK(3,IG))
              FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*TXX)*OMTP
              FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*TYY)*OMTP
              FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*TZZ)*OMTP
            ENDDO
          ENDIF
        ENDDO
      ENDDO
#else
      DO IG=IG1,NHG
        RG=DCONJG(RHOG(IG))
        GX=DCMPLX(0.D0,GK(1,IG))
        GY=DCMPLX(0.D0,GK(2,IG))
        GZ=DCMPLX(0.D0,GK(3,IG))
        ISA=0
        DO IS=1,NSP
          TXX=VPS(IS,IG)*RG*GX
          TYY=VPS(IS,IG)*RG*GY
          TZZ=VPS(IS,IG)*RG*GZ
          DO IA=1,NA(IS)
            ISA=ISA+1
            IF(BIGMEM) THEN
              EI123=EIGRB(IG,ISA)
            ELSE
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                  EI3(ISA,INYH(3,IG))
            ENDIF
            FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*TXX)*OMTP
            FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*TYY)*OMTP
            FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*TZZ)*OMTP
          ENDDO
        ENDDO
      ENDDO
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
