C     ==================================================================
      SUBROUTINE PRCPMD(C0,CM,C2,SC0,GAMX,GAMY)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc' 
      INCLUDE 'ener.inc' 
      INCLUDE 'elct.inc' 
      INCLUDE 'tpar.inc' 
      INCLUDE 'pslo.inc' 
      INCLUDE 'ions.inc' 
      INCLUDE 'soft.inc' 
      INCLUDE 'nose.inc' 
      INCLUDE 'norm.inc' 
      INCLUDE 'ropt.inc' 
      INCLUDE 'cppt.inc' 
      INCLUDE 'coor.inc' 
      INCLUDE 'geq0.inc' 
      INCLUDE 'spin.inc' 
      INCLUDE 'irat.inc' 
      INCLUDE 'nlcc.inc' 
      INCLUDE 'strs.inc' 
      INCLUDE 'str2.inc' 
      INCLUDE 'metr.inc' 
      INCLUDE 'cotr.inc' 
      INCLUDE 'prcp.inc'
      INCLUDE 'store.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'comvel.inc'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      COMPLEX*16 C0(NGW,*),CM(NGW,*),C2(NGW,*),SC0(NGW,*)
      REAL*8     GAMX(*),GAMY(*)
C     Variables
      DIMENSION  F(*)
      REAL*8     TAUI(3,NAX,*),TAUR(3,NAX,*),EIGV(*),EIGM(*)
      POINTER    (IP_TAUI,TAUI),(IP_TAUR,TAUR),
     *           (IP_EIGV,EIGV),(IP_EIGM,EIGM)
      COMPLEX*16 PSI(NNR1,*)
      REAL*8     RHOE(NNR1,*),SCR(*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
      CHARACTER  FILEN*100,TAG*30
      LOGICAL    FERROR,TESTSTORE
      INTEGER    IREC(100)
      REAL*8     TIME1,FF,EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,ENOSE,ENOSP,
     &           TIME2,TCPU,EKINP,TEMPP,DISA,EKINC,EKINH,ECONS,EHAM,
     &           TIMEF,DDOT,EKINH1,EKINH2,TEMPH,VCMIO(4)
      EXTERNAL   DDOT,TIMEF
      INTEGER    I,J,K,NSTATE,
     &           LSCR,IL_RHOE,IL_PSI
      INTEGER    MSGLEN
C     META DYNAMICS
      LOGICAL    LQUENCH,LMETARES,RESETCV
      REAL*8     HA(3,3),HB(3,3),EK_CV
      INTEGER    IA,IS
C     ==================================================================
      TIME1 = TIMEF()
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TAUI,3*NAX*NSX,'TAUI')
      CALL MEMORY(IP_TAUR,3*NAX*NSX,'TAUR')
      CALL MEMORY(IP_STAU0,3*NAX*NSX,'STAU0')
      CALL MEMORY(IP_SVELP,3*NAX*NSX,'SVELP')
      CALL MEMORY(IP_SFION,3*NAX*NSX,'SFION')
      IF(LCOLVARDYN) THEN
        CALL MEMORY(IP_FHILLS,3*NAX*NSX,'FHILLS')
        CALL AZZERO(FHILLS,3*NAX*NSX)
      ENDIF
c     Initialize logical variable for Metadynamics
      LMETARES=.FALSE.
      NSTATE=N
      NACC = 22
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.TRUE.
      IF(TIVAN) NONORT=.TRUE.
      IF(NONORT) THEN
        CALL MEMORY(IP_EIGV,N,'EIGV')
        CALL MEMORY(IP_EIGM,N*N,'EIGM')
      ENDIF
      IF(THARM.AND.PARENT) THEN
        FF=F(1)
        DO I=1,N
          IF(FF.NE.F(I)) THEN
            WRITE(6,'(A,A)') ' HARMONIC REFERENCE SYSTEM INTEGRATION',
     *             ' ONLY POSSIBLE WITH EQUAL OCCUPATION NUMBERS'
            CALL STOPGM('PRCPMD',' ')
          ENDIF
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     == INITIALIZATION                                               ==
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL GIVE_SCR_PRCPMD(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      NFNOW=1
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
      EKINC=0.0d0    ! McB: cf. META_EXT..()
      EKINP=0.0d0    ! McB: cf. META_EXT..()
C     INITIALIZATION OF WAVEFUNCTION AND COORDINATES
      CALL READ_IREC(IREC)
      IF (.NOT.RESTART) THEN
C       Randomize cell parameters
        IF(TRANC) CALL RANC(TAU0)
C       Randomization of the atomic coordinates.
        IF(TRANP.AND.PARENT) CALL RANP(TAU0)
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
C       INITIALIZATION OF WAVEFUNCTION
        CALL RINITWF(C0,CM,SC0,N,TAU0,TAUP,RHOE,PSI,SCR,LSCR)
      ELSE
        CALL ZHRWF(1,IREC,C0,CM,N,EIGV,TAU0,VELP,TAUI,NFI)
      ENDIF

      IF(RGEO.AND.PARENT) CALL GEOFILE(TAU0,VELP,'READ')
C     Randomization of the atomic coordinates
      IF(TRANP.AND.PARENT) CALL RANP(TAU0) 
C     Randomize cell parameters around loaded ones
      IF(TRANC) CALL RANC(TAU0)
      MSGLEN = 3*NAX*NSX * 8
      CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
C     Randomize electronic wavefunctions around loaded ones
      IF(TRANE) CALL RRANE(C0,C2,N) 
      MSGLEN = 9 * 8
      CALL MY_BCAST(HT,MSGLEN,SOURCE,ALLGRP)
      DO I=1,3
        A1(I) = HT(1,I)
        A2(I) = HT(2,I)
        A3(I) = HT(3,I)
      ENDDO
      CALL IHMAT(HT,HTM1,OMEGA)
      CALL NEWCELL(SCR,LSCR)
      CALL PHFAC(TAU0)
      IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,.TRUE.)
C     Orthogonalize electronic wavefunctions
      IF(TRANE) THEN
        IF(TIVAN) CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.FALSE.)
        CALL ORTHO(N,C0,C2,SCR,LSCR)
      ENDIF
      IF(QUENCHB) THEN
        CALL QUENBO(C0,C2,SC0,TAUR,RHOE,PSI,SCR,LSCR)
#if 0
C     AK: another broken restart (see QM/MM). why??
        CALL ZHWWF(2,IREC,C0,CM,N,EIGV,TAU0,VELP,TAUI,NFI)
#endif
        QUENCHB=.FALSE.
      ENDIF
      IF(TIVAN) THEN
        IF(TLSD) THEN
          CALL DEORT(NGW,NSUP,EIGM,EIGV,C0(1,1),SC0(1,1),SCR,LSCR)
          CALL DEORT(NGW,NSDOWN,EIGM,EIGV,C0(1,NSUP+1),SC0(1,NSUP+1),
     *               SCR,LSCR)
        ELSE
          CALL DEORT(NGW,N,EIGM,EIGV,C0,SC0,SCR,LSCR)
        ENDIF
      ENDIF
C     INITIALIZE VELOCITIES
      ECNSTR = 0.0D0
      ERESTR = 0.0D0
      IF(PARENT) CALL DETDOF(TAU0,TAUR)
      IF(IREC(IREC_VEL).EQ.0.AND..NOT.RGEO) THEN
        ECNSTR = 0.0D0
        ERESTR = 0.0D0
        CALL RINVEL(VELP,CM,N)
        IF(PARENT) CALL TAUCL(VELP)
        IF(PARENT) CALL RATTLE(TAU0,VELP)
        CALL RVSCAL(VELP)
      ELSE
        IF(PARENT) CALL TAUCL(VELP)
        IF(PARENT) CALL RATTLE(TAU0,VELP)
        IF(TRESCALE) CALL RVSCAL(VELP)
      ENDIF
      IF(QUENCHP) CALL AZZERO(VELP,3*NAX*NSX)
      IF(QUENCHE) CALL AZZERO(CM,2*NGW*N)
      IF(QUENCHC) CALL AZZERO(HTVEL,9)

C     INITIALIZE METADYNAMICS VARIABLES used also for 
C     SHOOTING from SADDLE POINT with RANDOM VELOCITIES
      IF(PARENT .AND. (LCOLVARDYN .OR. LSADPNT)) THEN        
          CALL COLVAR_STRUCTURE(TAU0,TAUR)
      ENDIF
      IF(TREVERS) THEN
C       invert electronic, ionic, and cell velocities (for path sampling)
        CALL DSCAL(2*NGW*NSTATE,-1.D0,CM,1)
        CALL DSCAL(3*NAX*NSX,-1.D0,VELP,1)
        CALL DSCAL(9,-1.D0,HTVEL,1)
      ENDIF
C     RESET ACCUMULATORS
      IF(PARENT.AND.IREC(IREC_AC).EQ.0)
     &     CALL RESETAC(TAU0,TAUI,NFI)
C     INITIALIZE FORCES
      IF(TKPNT) THEN
        IF(GEQ0) CALL ZCLEAN_K(C0,N,NGW)
      ELSE
        IF(GEQ0) CALL ZCLEAN(C0,N,NGW)
      ENDIF
      CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *             N,1,.FALSE.,.TRUE.)

C     INITIALIZE STRESS CONTRIBUTION DUE TO METADYNAMICS
      CALL AZZERO(DSTRMETA,6)
      CALL AZZERO(FVBOUND,6)
      CALL AZZERO(DSTRCV,6)


C     INITIALIZE FORCES CONTRIBUTION DUE TO METADYNAMICS
      IF(LMETA_CELL) THEN
        LQUENCH = .FALSE.
        LMETARES= .FALSE.
C     Time dipendent potential applied directly on the Collective Variables
        CALL META_CELL(VELP,SCR,LSCR,LQUENCH,LMETARES)
      ELSEIF(LCOLVARDYN .AND. LEXTLAGRANGE) THEN
        LQUENCH = .FALSE.
        LMETARES= .FALSE.
        RESETCV = .FALSE.
        CALL META_EXTLAGR(TAU0,VELP,TAUR,SCR,LSCR,LQUENCH,LMETARES,
     &        RESETCV,EKINC,EKINP)
        CALL META_STRESS(TAU0)
      ENDIF

      CALL TOTSTR
      CALL FREQS(N,.FALSE.)
C     Check orthogonality condition for wavefunction velocities
      CALL RORTV(C0,CM,C2,SC0,GAMY,N,SCR,LSCR)

      IF(PARENT) THEN
        CALL WRGEOF(TAU0,FION)
        WRITE(6,'(/,A)') '  CELL PARAMETERS '
        DO I=1,3
          WRITE(6,'(3(1X,F12.8))') (HT(I,J),J=1,3)
        ENDDO
        WRITE(6,'(/,A)') '  CELL VELOCITY '
        DO I=1,3
          WRITE(6,'(3(1X,F12.8))') (HTVEL(I,J),J=1,3)
        ENDDO
        WRITE(6,'(/,A)') '  CELL FORCES '
        DO I=1,3
          WRITE(6,'(3(1X,F12.8))') (HTFOR(I,J),J=1,3)
        ENDDO
        WRITE(6,'(" ",72("*"),/)')
        FILEN='ENERGIES'
        CALL FILEOPEN(3,FILEN,FO_APP+FO_VERB,FERROR)
      ENDIF
      CALL WRITE_IREC(IREC)
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
      ENOSE=0.0D0
      ENOSP=0.0D0
      IF(PARENT) THEN
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,F8.2,A)') ' TIME FOR INITIALIZATION',
     *                        TCPU,' SECONDS'
      ENDIF
C     ==================================================================
C     ==          THE BASIC LOOP FOR MOLECULAR DYNAMICS               ==
C     ==                 USING VELOCITY VERLET                        ==
C     ==================================================================
      DO INFI=1,NOMORE
        TIME1=TIMEF()
        NFI=NFI+1
        PRTEIG=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
        CALDIP=TDIPD.AND.MOD(NFI-1,NPDIP).EQ.0
        SUBCOM=TSUBCOM.AND.MOD(NFI-1,NCOMV).EQ.0
        IF(.NOT.PARENT) PRTEIG=.FALSE.
        ENGPRI=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
C       ANNEALING
        CALL ANNEAL(VELP,CM,N,HTVEL)
        CALL BERENDSEN(VELP,CM,NSTATE,HTVEL,EKINC,EKINH)
C     SUBTRACT CENTER OF MASS VELOCITY
        IF(PARENT.AND.SUBCOM) CALL COMVEL(VELP,VCMIO,.TRUE.)
        CALL C_TO_S(TAU0,STAU0)
        CALL C_TO_S(VELP,SVELP)
        CALL C_TO_S(FION,SFION)
C       UPDATE VELOCITIES
        IF(PARENT) CALL VELUPC1(SVELP,SFION,VELP)
        CALL VELUPA(C0,CM,C2,N,1)
C       UPDATE POSITIONS
        IF(LMETA_CELL) THEN
          CALL DCOPY(9,HT,1,HA,1)
        ENDIF
C       UPDATE CELL
        CALL DAXPY(9,DT_IONS,HTVEL,1,HT,1)
        IF(LMETA_CELL) THEN
          CALL DCOPY(9,HT,1,HB,1)
          CALL DELROT_CELL(HA,HB)
          CALL DCOPY(9,HB,1,HT,1)
        ENDIF

        MSGLEN = 9 * 8
        CALL MY_BCAST(HT,MSGLEN,SOURCE,ALLGRP)
        DO I=1,3
          A1(I) = HT(1,I)
          A2(I) = HT(2,I)
          A3(I) = HT(3,I)
        ENDDO
        CALL IHMAT(HT,HTM1,OMEGA)
        IF(PARENT) THEN
          CALL POSUPI(STAU0,TAUP,SVELP)
          CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,STAU0(1),1)
        ENDIF
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(STAU0,MSGLEN,SOURCE,ALLGRP)
        CALL S_TO_C(STAU0,TAUP)
        CALL S_TO_C(SVELP,VELP)
        CALL NEWCELL(SCR,LSCR)
        ECNSTR = 0.0D0
        ERESTR = 0.0D0
        CALL PHFAC(TAUP)
        IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,.TRUE.)
        CALL POSUPA(C0,CM,C2,GAMX,N,SCR,LSCR)
C..Dipole moment
        IF(CALDIP) THEN
          CALL DDIPO(TAUP,C0,CM,C2,SC0,SCR,LSCR,N)
          CALL WANNIER_PRINT(NFI,C0,TAUP,N,PSI,SCR,LSCR)
        ENDIF
C       CALCULATE THE FORCES
        CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAUP,FION,EIGV,SCR,LSCR,
     *               N,1,.FALSE.,.TRUE.)

        IF(LMETA_CELL) THEN
          LQUENCH = .FALSE.
          LMETARES= .FALSE.
C     Time dipendent potential applied directly on the Collective Variables
            CALL META_CELL(VELP,SCR,LSCR,LQUENCH,LMETARES)

          IF((TOLKIN.NE.-1.D0 .AND. EKINC.GT.TOLKIN)
     &               .OR. LQUENCH) THEN
C     Check for Quench on the BO surface
            QUENCHB=.TRUE.
            CALL QUENBO(C0,C2,SC0,TAUR,RHOE,PSI,SCR,LSCR)
            CALL AZZERO(CM,2*N*NGWK)           
          ENDIF

        ELSEIF(LCOLVARDYN .AND. LEXTLAGRANGE) THEN
          LQUENCH = .FALSE.
          LMETARES= .FALSE.
          CALL META_EXTLAGR(TAUP,VELP,TAUR,SCR,LSCR,
     &                LQUENCH,LMETARES,RESETCV,EKINC,EKINP)
          CALL META_STRESS(TAUP)
          IF((TOLKIN.NE.-1.D0 .AND. EKINC.GT.TOLKIN)
     &               .OR. LQUENCH) THEN
C     Check for Quench on the BO surface
            CALL QUENBO(C0,C2,SC0,TAUR,RHOE,PSI,SCR,LSCR)
            CALL AZZERO(CM,2*N*NGWK)           
            RESETCV = .TRUE.
            QUENCHB=.FALSE.
          ENDIF
        ENDIF

        CALL TOTSTR
C     ==================================================================
        IF(LCOLVARDYN .AND. PARENT) THEN 

C     Additional Contribution to FION due to the Metadynamics
C     (from coupling pot.if extended Lagrangian, directly from V(S,t) if not)
          DO IS = 1,NSP
            DO IA = 1,NA(IS)
              FION(1,IA,IS) = FION(1,IA,IS) + FHILLS(1,IA,IS)
              FION(2,IA,IS) = FION(2,IA,IS) + FHILLS(2,IA,IS)
              FION(3,IA,IS) = FION(3,IA,IS) + FHILLS(3,IA,IS)
c              write(24,'(A,2I3,3F12.6)') 'FH',IS,IA,
c     &                          (FHILLS(I,IA,IS),I=1,3)
            ENDDO
          ENDDO
        ENDIF


C     ==================================================================
C       Damped Dynamics
        CALL DAMPDYN(VELP,FION,CM,C2,NSTATE,HTVEL,HTFOR)
C     ==================================================================
        CALL C_TO_S(TAUP,STAU0)
        CALL C_TO_S(VELP,SVELP)
        CALL C_TO_S(FION,SFION)

C       FINAL UPDATE FOR VELOCITIES
        IF(PARENT) THEN
          CALL VELUPC2(SVELP,SFION,VELP,TAUR)
          CALL S_TO_C(SVELP,VELP)
        ENDIF
        CALL VELUPA(C0,CM,C2,N,1)
        CALL RORTV(C0,CM,C2,SC0,GAMY,N,SCR,LSCR)
C     SUBTRACT CENTER OF MASS VELOCITY
        IF(PARENT.AND.SUBCOM) CALL COMVEL(VELP,VCMIO,.FALSE.)
        CALL BERENDSEN(VELP,CM,NSTATE,HTVEL,EKINC,EKINH)
C       ANNEALING
        CALL ANNEAL(VELP,CM,N,HTVEL)
        IF(PARENT) CALL GEOFILE(TAUP,VELP,'WRITE')
C       COMPUTE THE IONIC TEMPERATURE TEMPP
        IF(PARENT) THEN
          CALL EKINPP(EKINP,VELP)
          IF(LEXTLAGRANGE.AND. LTCGLOBAL) THEN
            CALL EKINCV_GLOBAL(EK_CV)
            TEMPP=(EK_CV+EKINP)*FACTEM*2.D0/(GLIB+DBLE(NCOLVAR))
          ELSE 
            TEMPP=EKINP*FACTEM*2.D0/GLIB
          ENDIF 
C         IONIC TEMPERATURE CONTROL
          CALL RSCVP(TEMP1,TEMP2,TEMPP,VELP)
        ENDIF
C       RESCALE ELECTRONIC VELOCITIES
        IF(TC) CALL RSCVE(EKIN1,EKIN2,EKINC,EKINW,CM,N,NGW)
C       MEAN SQUARE DISPLACEMENT OF DIFFERENT IONIC SPECIES
        IF(PARENT) CALL DISPP(TAUP,TAUI,DISA)
C       KINETIC ENERGY OF THE ELECTRONS
        CALL REKINE(CM,N,EKINC)
C       KINETIC ENERGY OF THE CELL
        EKINH=0.5D0*CMASS*DDOT(9,HTVEL,1,HTVEL,1)
        IF(PARENT) THEN
C..CELL TEMPERATURE CONTROL
          CALL RSCVC(EKINH,HTVEL,EKINH1,EKINH2)
          CALL EKINPP(EKINP,VELP)
          IF(LEXTLAGRANGE.AND. LTCGLOBAL) THEN
            CALL EKINCV_GLOBAL(EK_CV)
            TEMPP=(EK_CV+EKINP)*FACTEM*2.D0/(GLIB+DBLE(NCOLVAR))
          ELSE 
            TEMPP=EKINP*FACTEM*2.D0/GLIB
          ENDIF 
          EKINH=0.5D0*CMASS*DDOT(9,HTVEL,1,HTVEL,1)
          TEMPH = 2.D0*EKINH*FACTEM/9.D0
          ECONS=EKINP+ETOT+ENOSE+ENOSP+ECNSTR+ERESTR+DRUCK*OMEGA
          EHAM=ECONS+EKINC+EKINH
          EHAM_HILL = EHAM
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
C         PRINTOUT the evolution of the accumulators every time step
          CALL WRPRINT_PR(EKINC,EKINH,TEMPP,ETOT,ECONS,EHAM,
     *                    DISA,TAUP,FION,TCPU,NFI,INFI)
C         UPDATE ACCUMULATORS
          CALL PACCB(EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU,TEMPH,
     *               OMEGA,ENOSE,ENOSP,NFI,1)
C         Store ionic coordinates and velocities for statistics
          MOVIE=MOUT .AND. MOD(NFI-1,IMOVIE).EQ.0
          RPRINT=ROUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TXYZ=XTOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          TDCD=DCOUT .AND. MOD(NFI-1,NTRAJ).EQ.0
          CALL PRINTP(TAUR,TAUP,VELP)
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(INFI.EQ.NOMORE) THEN
          EXSOFT=.TRUE.
          EXNOMORE=.TRUE.
        ENDIF
C periodic output of density/wavefunction etc.
        IF(RHOOUT.AND.(NRHOOUT.GT.0)) THEN
          IF (MOD(NFI-1,NRHOOUT).EQ.0) THEN
            CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPNT)
          ENDIF
        ENDIF
        IF(TESTSTORE(NFI).OR.EXSOFT.OR.LMETARES) THEN
          CALL ZHWWF(2,IREC,C0,CM,N,EIGV,TAUP,VELP,TAUI,NFI)
        ENDIF
        IF(EXSOFT .AND.LCOLVARDYN) THEN
          LMETARES= .TRUE.
          IF(LEXTLAGRANGE) THEN
C     Metadynamics with Extended Lagrangian
            CALL META_EXTLAGR(TAUP,VELP,TAUR,SCR,LSCR,
     &              LQUENCH,LMETARES,RESETCV,EKINC,EKINP)
          ELSE
C     Time dipendent potential applied directly on the Collective Variables
            CALL META_COLVAR(TAUP,VELP,FION,TAUR,SCR,LSCR,
     &                      LQUENCH,LMETARES,EKINC,EKINP)
          ENDIF
        ENDIF
C     temperature ramping
        CALL TEMPRAMP(TEMP1,TEMP2)
C       STOP THE RUN IF THE USER HAS SET THE SIGNAL 30
        IF(EXSOFT) GOTO 100
C       UPDATE IONIC POSITIONS
        CALL DCOPY(3*NAX*NSX,TAUP(1,1,1),1,TAU0(1,1,1),1)
C     ==================================================================
C     ==     END OF MAIN LOOP                                         ==
C     ==================================================================
      ENDDO
  100 CONTINUE
      IF(RHOOUT.AND.(NRHOOUT.LE.0))
     &    CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,N,NKPNT)
C     PRINT ACCUMULATORS.
      IF(PARENT) CALL PACCB(EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU,TEMPH,
     *                      OMEGA,ENOSE,ENOSP,NFI,2)
      CALL PROJA(C0,C2,SC0,SCR,LSCR,N,IPROJ)
      CALL CSIZE(C2,N,GEMAX,CNORM)
      IF(PARENT) CALL GSIZE(FION,GNMAX,GNORM)
      IF(PARENT) CALL FINALP(TAU0,FION,VELP,EIGV)
      IF(TIVAN.OR.NONORT) THEN
        CALL FREEM(IP_EIGV)
        CALL FREEM(IP_EIGM)
      ENDIF
      CALL FREEM(IP_TAUP)
      CALL FREEM(IP_FION)
      CALL FREEM(IP_VELP)
      CALL FREEM(IP_TAUI)
      CALL FREEM(IP_TAUR)
      CALL FREEM(IP_STAU0)
      CALL FREEM(IP_SVELP)
      CALL FREEM(IP_SFION)
      IF(PARENT) CALL FILECLOSE(3)
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE S_TO_C(SCOOR,COOR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'metr.inc'
C     Arguments
      REAL*8  COOR(3,NAX,*),SCOOR(3,NAX,*)
C     Variables
      INTEGER IS,IA
C     ==--------------------------------------------------------------==
      DO IS=1,NSP
        DO IA=1,NA(IS)
          CALL DGEMV('T',3,3,1.0D0,HT,3,SCOOR(1,IA,IS),1,
     *               0.0D0,COOR(1,IA,IS),1)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE C_TO_S(COOR,SCOOR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'metr.inc'
C     Arguments
      REAL*8  COOR(3,NAX,*),SCOOR(3,NAX,*)
C     Variables
      INTEGER IS,IA
C     ==--------------------------------------------------------------==
      DO IS=1,NSP
        DO IA=1,NA(IS)
          CALL DGEMV('T',3,3,1.0D0,HTM1,3,COOR(1,IA,IS),1,
     *               0.0D0,SCOOR(1,IA,IS),1)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_PRCPMD(LPRCPMD,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !nlcc.inc TRANE QUENCHB
      INCLUDE 'elct.inc'        !N number of states
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'store.inc'       !RHOOUT
      INCLUDE 'pslo.inc'        !TIVAN
C     Arguments
      INTEGER   LPRCPMD
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LCOPOT,LORTHO,LQUENBO,LDEORT,LFORCEDR,
     &          LRORTV,LPOSUPA,LRHOPRI,LNEWCELL,LRINITWF,LDDIPO
C     ==--------------------------------------------------------------==
      NSTATE=N
      LCOPOT=0
      LORTHO=0
      LQUENBO=0
      LDEORT=0
      LRHOPRI=0
      LRINITWF=0
      LDDIPO=0
      IF(TINLC) CALL GIVE_SCR_COPOT(LCOPOT,TAG)
      IF(TRANE) CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      IF(QUENCHB) CALL GIVE_SCR_QUENBO(LQUENBO,TAG)
      IF(TIVAN) CALL GIVE_SCR_DEORT(LDEORT,TAG,NSTATE)
      IF(TDIPD) CALL GIVE_SCR_DDIPO(LDDIPO,TAG)
      CALL GIVE_SCR_FORCEDR(LFORCEDR,TAG,NSTATE,.FALSE.,.TRUE.)
      CALL GIVE_SCR_RORTV(LRORTV,TAG,NSTATE)
      CALL GIVE_SCR_NEWCELL(LNEWCELL,TAG)
      CALL GIVE_SCR_POSUPA(LPOSUPA,TAG,NSTATE)
      CALL GIVE_SCR_RINITWF(LRINITWF,TAG,NSTATE)
      IF(RHOOUT) CALL GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
      LPRCPMD=MAX(LCOPOT,LORTHO,LQUENBO,LDEORT,LDDIPO,LFORCEDR,
     &            LRORTV,LPOSUPA,LRHOPRI,LNEWCELL,LRINITWF)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RSCVC(EKINH,HTVEL,EKINH1,EKINH2)
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      REAL*8  EKINH,HTVEL(3,3),EKINH1,EKINH2
C     Variables
      INTEGER K,I
      REAL*8  ALFAP
C     ==--------------------------------------------------------------==
C     ==  Dynamical rescaling factor (ekinhr/ekinh), of cell kinetic  ==
C     ==                                                   energy     ==
C     ==--------------------------------------------------------------==
      IF(TCC) THEN
        IF(EKINH.GT.EKINH1.OR.EKINH.LT.EKINH2.AND.EKINH.NE.0.D0) THEN
          ALFAP=DSQRT(EKINHR/EKINH)
          DO K=1,3
            HTVEL(1,K)=ALFAP*HTVEL(1,K)
            HTVEL(2,K)=ALFAP*HTVEL(2,K)
            HTVEL(3,K)=ALFAP*HTVEL(3,K)
          ENDDO
        END IF
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

