C     ==================================================================
      SUBROUTINE PREP_FORCEMATCH
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'atwf.inc'        !NUMAORMAX
      INCLUDE 'kpts.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'bsym.inc'        !BSFAC
      INCLUDE 'shop.inc' 
      INCLUDE 'shop_rest.inc' 
      INCLUDE 'shop_rest_2.inc' 
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mw.inc'
C     Variables
      COMPLEX*16 C0(*),C1(*),CM(*),C2(*),SC0(*)
      REAL*8     GAMX(*),GAMY(*),VPP(*)
      POINTER    (IP_C0,C0), (IP_CM,CM), (IP_C2,C2),(IP_SC0,SC0),
     &           (IP_C1,C1), (IP_GAMX,GAMX), (IP_GAMY,GAMY),
     &           (IP_VPP,VPP)
      DIMENSION  F(*)
      INTEGER    NSTATE,NC0,NC1,NUS,NACT,NC2,NCM,NSC0,IUNIT,NXX,NMIN
      INTEGER    MS,MM,I,NSTX
      LOGICAL    statusdummy
#ifdef PARALLEL
      INTEGER    NXXFUN
      EXTERNAL   NXXFUN
#endif
C     ==--------------------------------------------------------------==
C     ==  MEMORY ALLOCATION                                           ==
C     ==--------------------------------------------------------------==
C     ==  C0         WF POSITIONS                                     ==
C     ==  CM         WF VELOCITIES                                    ==
C     ==  C2         WF FORCES                                        ==
C     ==  SC0        S*C0 (only Vanderbilt)                           ==
C     ==  GAMX       CONSTRAINT MATRIX POSITIONS                      ==
C     ==  GAMY       CONSTRAINT MATRIX VELOCITIES                     ==
C     ==--------------------------------------------------------------==
      IF ( QMNODE ) THEN
        NSTATE=N
        NC1=1
        NUA=1
        NUB=1
        NLINW=0
        NLINR=0
        NUS=1

        IF(TSDE) THEN
          NCM=8
        ELSE IF(DIIS) THEN
          NCM=(NGWK*NSTATE+8)*MDIIS*NKPNT+
     &    ((NGWK*NSTATE+8)*MDIIS*NKPNT)/4+100
        ELSE IF(PCG) THEN
          NCM=2*NGWK*NSTATE*NKPNT+8
        ENDIF
C CB: Need memory for two wf in BS case          
        NC0=(2*NGWK*NSTATE*NKPNT+8)*BSFAC
        NC2=(2*NGWK*NSTATE+8)*BSFAC
        CALL MEMORY(IP_VPP,NGWK,'VPP')
        NSC0=1
        IF(TIVAN.OR.NONORT.OR.(QUENCHB.AND.PCG.AND.PCGMIN)) THEN
          NSC0=2*NGWK*NSTATE*NKPNT*BSFAC
        ENDIF
        IF(TDIPD) THEN
#ifdef PARALLEL
          LENBK=NXXFUN(NSTATE)
          NXX=MAX(2*LENBK*NPROC,NC2)
          NSC0=MAX(NXX,NSC0)
#else
          NXX=NC2
#endif
          NC2=NXX
        ENDIF
        NMIN=10
        CALL MEMORY(IP_C0OLD,NMIN,'C0OLD')
        CALL MEMORY(IP_C0OLD2,NMIN,'C0OLD2')
        CALL MEMORY(IP_C0,NC0,'C0')
        CALL MEMORY(IP_CM,NCM,'CM')
        CALL MEMORY(IP_C1,NC1,'C1')
        CALL MEMORY(IP_C2,NC2,'C2')
        CALL MEMORY(IP_SC0,NSC0,'SC0')
        CALL MEMORY(IP_UROT,NUS,'UROT')
        CALL AZZERO(UROT,NUS)
        IP_CLRWF=IP_C1
        IF(TDMAL) THEN
          CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
          CALL MEMORY(IP_GAMX,NSTATE*NSTX*BSFAC,'GAMX') 
          CALL MEMORY(IP_GAMY,NSTATE*NSTX*BSFAC,'GAMY') 
        ELSE
          CALL MEMORY(IP_GAMX,NSTATE*NSTATE*BSFAC,'GAMX') 
          CALL MEMORY(IP_GAMY,NSTATE*NSTATE*BSFAC,'GAMY') 
        ENDIF
C     ==--------------------------------------------------------------==
C       FNL and DFNL
        call mm_dim(mm_go_qm,statusdummy)
C
        CALL FNLALLOC(NSTATE,.TRUE.,TPRES)
        call mm_dim(mm_revert,statusdummy)
      ELSE
        NMIN = 10
        CALL MEMORY(IP_C0,NMIN,'C0')
        CALL MEMORY(IP_CM,NMIN,'CM')
        CALL MEMORY(IP_C1,NMIN,'C1')
        CALL MEMORY(IP_C2,NMIN,'C2')
        CALL MEMORY(IP_SC0,NMIN,'SC0')
        CALL MEMORY(IP_UROT,NMIN,'UROT')
        CALL MEMORY(IP_GAMX,NMIN,'GAMX')
        CALL MEMORY(IP_GAMY,NMIN,'GAMY')
        CALL MEMORY(IP_VPP,NMIN,'VPP')
c
        CALL MEMORY(IP_C0OLD,NMIN,'C0OLD')
        CALL MEMORY(IP_C0OLD2,NMIN,'C0OLD2')
c
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PARENT) CALL PRMEM('      MDPT')
C     ==--------------------------------------------------------------==
C
      IF (TQMMM) THEN
       CALL MM_FORCEMATCH(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
      ELSE
C      CALL FORCEMATCH(C0,CM,C1,C2,SC0,VPP,GAMX,GAMY)
C      non-QMMM force matching not implemented yet
       CALL STOPGM('prep_forcematch', 'force matching only with QMMM!') 
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TMEMCHK) CALL PRINT_MEMORY
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_C0)
      CALL FREEM(IP_CM)
      CALL FREEM(IP_C1)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_SC0)
      CALL FREEM(IP_UROT)
      CALL FREEM(IP_GAMX)
      CALL FREEM(IP_GAMY)
      IF ( QMNODE ) THEN
        CALL FNLDEALLOC(.TRUE.,TPRES)
      ELSE
        CALL FREEM(IP_VPP)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
