C     ==================================================================
      SUBROUTINE PACCA(EKINC,TEMPP,ETOT,ECONS,EHAM,ENOSE,ENOSP,ECNSTR,
     &    ERESTR,DISA,TCPU,NFI,IT)
C     ==--------------------------------------------------------------==
C     == IT:                                                          ==
C     ==   1  Update accumulators                                     ==
C     ==      The arguments are used                                  ==
C     == !=1  Print  averaged values of accumulators                  ==
C     ==      The arguments are unused                                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      REAL*8  EKINC,TEMPP,ETOT,ECONS,EHAM,ENOSE,ENOSP,ECNSTR,ERESTR,
     &    DISA,TCPU
      INTEGER NFI,IT
C     Variables
      REAL*8  ANOR,AC1,AC2,AC3,AC4,AC5,AC6,AC7,AC8,AC9,AC10
C     ==--------------------------------------------------------------==
      IF(IT.EQ.1) THEN
        ACC(1)=ACC(1)+EKINC
        ACC(2)=ACC(2)+TEMPP
        ACC(3)=ACC(3)+ETOT
        ACC(4)=ACC(4)+ECONS
        ACC(5)=ACC(5)+EHAM
        ACC(6)=ACC(6)+ENOSE
        ACC(7)=ACC(7)+ENOSP
        ACC(8)=ACC(8)+ECNSTR
        ACC(9)=ACC(9)+DISA
        ACC(10)=ACC(10)+TCPU
        ACC(11)=ACC(11)+EKINC*EKINC
        ACC(12)=ACC(12)+TEMPP*TEMPP
        ACC(13)=ACC(13)+ETOT*ETOT
        ACC(14)=ACC(14)+ECONS*ECONS
        ACC(15)=ACC(15)+EHAM*EHAM
        ACC(16)=ACC(16)+ENOSE*ENOSE
        ACC(17)=ACC(17)+ENOSP*ENOSP
        ACC(18)=ACC(18)+ECNSTR*ECNSTR
        ACC(19)=ACC(19)+DISA*DISA
        ACC(20)=ACC(20)+TCPU*TCPU
        ACC(21)=ACC(21)+ERESTR
        ACC(22)=ACC(22)+ERESTR*ERESTR
      ELSE
        ANOR=1.D0/DBLE(NFI)
        AC1=ABS(ACC(11)*ANOR-(ACC(1)*ANOR)**2)
        AC2=ABS(ACC(12)*ANOR-(ACC(2)*ANOR)**2)
        AC3=ABS(ACC(13)*ANOR-(ACC(3)*ANOR)**2)
        AC4=ABS(ACC(14)*ANOR-(ACC(4)*ANOR)**2)
        AC5=ABS(ACC(15)*ANOR-(ACC(5)*ANOR)**2)
        AC6=ABS(ACC(16)*ANOR-(ACC(6)*ANOR)**2)
        AC7=ABS(ACC(17)*ANOR-(ACC(7)*ANOR)**2)
        AC8=ABS(ACC(18)*ANOR-(ACC(8)*ANOR)**2)
        AC9=ABS(ACC(19)*ANOR-(ACC(9)*ANOR)**2)
        AC10=ABS(ACC(22)*ANOR-(ACC(21)*ANOR)**2)
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(" *",21X,A,21X,"*")') ' AVERAGED QUANTITIES'
        WRITE(6,'(1X,64("*"))')
        WRITE(6,'(24X,A,A)') 
     *  '      MEAN VALUE       +/-  RMS DEVIATION'
        WRITE(6,'(24X,A,A)')
     *  '             <x>     [<x^2>-<x>^2]**(1/2)'
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' ELECTRON KINETIC ENERGY  ',
     *                             ACC(1)*ANOR,SQRT(AC1)
        WRITE(6,'(A,2X,F12.4,9X,G16.6)') ' IONIC TEMPERATURE        ',
     *                             ACC(2)*ANOR,SQRT(AC2)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' DENSITY FUNCTIONAL ENERGY',
     *                             ACC(3)*ANOR,SQRT(AC3)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' CLASSICAL ENERGY         ',
     *                             ACC(4)*ANOR,SQRT(AC4)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' CONSERVED ENERGY         ',
     *                             ACC(5)*ANOR,SQRT(AC5)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' NOSE ENERGY ELECTRONS    ',
     *                             ACC(6)*ANOR,SQRT(AC6)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' NOSE ENERGY IONS         ',
     *                             ACC(7)*ANOR,SQRT(AC7)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' CONSTRAINTS ENERGY       ',
     *                             ACC(8)*ANOR,SQRT(AC8)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' RESTRAINTS ENERGY        ',
     *                             ACC(21)*ANOR,SQRT(AC10)
        WRITE(6,'(A,2X,G12.6,9X,G16.6)') ' ION DISPLACEMENT         ',
     *                             ACC(9)*ANOR,SQRT(AC9)
        WRITE(6,'(A,2X,F12.4,9X,G16.6)') ' CPU TIME                 ',
     *                             ACC(10)*ANOR
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PACCB(EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU,
     *                 TEMPH,VOLUME,ENOSE,ENOSP,NFI,IT)
C     ==--------------------------------------------------------------==
C     == IT:                                                          ==
C     ==   1  Update accumulators                                     ==
C     ==      The arguments are used                                  ==
C     == !=1  Print  averaged values of accumulators                  ==
C     ==      The arguments are unused                                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      REAL*8  EKINC,TEMPP,ETOT,ECONS,EHAM,ENOSE,DISA,TCPU,TEMPH,VOLUME,
     &        ENOSP
      INTEGER NFI,IT
C     Variables
      REAL*8  ANOR,AC1,AC2,AC3,AC4,AC5,AC6,AC8,AC9,AC10,AC11
C     ==--------------------------------------------------------------==
      IF(IT.EQ.1) THEN
        ACC(1)=ACC(1)+EKINC
        ACC(2)=ACC(2)+TEMPP
        ACC(3)=ACC(3)+ETOT
        ACC(4)=ACC(4)+ECONS
        ACC(5)=ACC(5)+EHAM
        ACC(6)=ACC(6)+DISA
        ACC(7)=ACC(7)+TCPU
        ACC(8)=ACC(8)+TEMPH
        ACC(9)=ACC(9)+VOLUME
        ACC(10)=ACC(10)+ENOSE 
        ACC(11)=ACC(11)+ENOSP 
        ACC(12)=ACC(12)+EKINC*EKINC
        ACC(13)=ACC(13)+TEMPP*TEMPP
        ACC(14)=ACC(14)+ETOT*ETOT
        ACC(15)=ACC(15)+ECONS*ECONS
        ACC(16)=ACC(16)+EHAM*EHAM
        ACC(17)=ACC(17)+DISA*DISA
        ACC(18)=ACC(18)+TCPU
        ACC(19)=ACC(19)+TEMPH*TEMPH
        ACC(20)=ACC(20)+VOLUME*VOLUME
        ACC(21)=ACC(21)+ENOSE *ENOSE
        ACC(22)=ACC(22)+ENOSP *ENOSP
      ELSE
        ANOR=1.D0/DBLE(NFI)
        AC1=ABS(ACC(12)*ANOR-(ACC(1)*ANOR)**2)
        AC2=ABS(ACC(13)*ANOR-(ACC(2)*ANOR)**2)
        AC3=ABS(ACC(14)*ANOR-(ACC(3)*ANOR)**2)
        AC4=ABS(ACC(15)*ANOR-(ACC(4)*ANOR)**2)
        AC5=ABS(ACC(16)*ANOR-(ACC(5)*ANOR)**2)
        AC6=ABS(ACC(17)*ANOR-(ACC(6)*ANOR)**2)
        AC8=ABS(ACC(19)*ANOR-(ACC(8)*ANOR)**2)
        AC9=ABS(ACC(20)*ANOR-(ACC(9)*ANOR)**2)
        AC10=ABS(ACC(21)*ANOR-(ACC(10)*ANOR)**2)
        AC11=ABS(ACC(22)*ANOR-(ACC(11)*ANOR)**2)
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(" *",21X,A,21X,"*")') ' AVERAGED QUANTITIES'
        WRITE(6,'(1X,64("*"))')
        WRITE(6,'(24X,A,A)') '   MEAN VALUE <x>   DEVIATION <x^2>-<x>^2'
        WRITE(6,'(A,2X,G12.6,9X,G16.6)') ' ELECTRON KINETIC ENERGY  ',
     *                             ACC(1)*ANOR,SQRT(AC1)
        WRITE(6,'(A,2X,F12.2,9X,G16.6)') ' IONIC TEMPERATURE        ',
     *                             ACC(2)*ANOR,SQRT(AC2)
        WRITE(6,'(A,2X,F12.2,9X,G16.6)') ' CELL TEMPERATURE         ',
     *                             ACC(8)*ANOR,SQRT(AC8)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' DENSITY FUNCTIONAL ENERGY',
     *                             ACC(3)*ANOR,SQRT(AC3)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' CLASSICAL ENERGY         ',
     *                             ACC(4)*ANOR,SQRT(AC4)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' CONSERVED ENERGY         ',
     *                             ACC(5)*ANOR,SQRT(AC5)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' NOSE ENERGY ELECTRONS    ',
     *                             ACC(10)*ANOR,SQRT(AC10)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' NOSE ENERGY IONS         ',
     *                             ACC(11)*ANOR,SQRT(AC11)
        WRITE(6,'(A,2X,G12.6,9X,G16.6)') ' ION DISPLACEMENT         ',
     *                             ACC(6)*ANOR,SQRT(AC6)
        WRITE(6,'(A,2X,G12.6,9X,G16.6)') ' CELL VOLUME              ',
     *                             ACC(9)*ANOR,SQRT(AC9)
        WRITE(6,'(A,2X,F12.4,9X,G16.6)') ' CPU TIME                 ',
     *                             ACC(7)*ANOR
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PACCC(TEMPP,ETOT,ECONS,ENOSE,ENOSP,ECNSTR,ERESTR,
     *    EBOGO,DISA,TCPU,NFI,IT)
C     ==--------------------------------------------------------------==
C     == IT:                                                          ==
C     ==   1  Update accumulators                                     ==
C     ==      The arguments are used                                  ==
C     == !=1  Print  averaged values of accumulators                  ==
C     ==      The arguments are unused                                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      REAL*8  TEMPP,ETOT,ECONS,ENOSE,ENOSP,ECNSTR,ERESTR,EBOGO,DISA,TCPU
      INTEGER NFI,IT
C     Variables
      REAL*8  ANOR,AC1,AC2,AC3,AC4,AC5,AC6,AC7,AC8,AC9
C     ==--------------------------------------------------------------==
      IF(IT.EQ.1) THEN
        ACC(1)=ACC(1)+TEMPP
        ACC(2)=ACC(2)+ETOT
        ACC(3)=ACC(3)+ECONS
        ACC(4)=ACC(4)+ENOSE
        ACC(5)=ACC(5)+ENOSP
        ACC(6)=ACC(6)+ECNSTR
        ACC(7)=ACC(7)+EBOGO
        ACC(8)=ACC(8)+DISA
        ACC(9)=ACC(9)+TCPU
        ACC(10)=ACC(10)+ERESTR
        ACC(11)=ACC(11)+TEMPP*TEMPP
        ACC(12)=ACC(12)+ETOT*ETOT
        ACC(13)=ACC(13)+ECONS*ECONS
        ACC(14)=ACC(14)+ENOSE*ENOSE
        ACC(15)=ACC(15)+ENOSP*ENOSP
        ACC(16)=ACC(16)+ECNSTR*ECNSTR
        ACC(17)=ACC(17)+EBOGO*EBOGO
        ACC(18)=ACC(18)+DISA*DISA
        ACC(19)=ACC(19)+TCPU
        ACC(20)=ACC(20)+ERESTR*ERESTR
      ELSE
        ANOR=1.D0/DBLE(NFI)
        AC1=ABS(ACC(11)*ANOR-(ACC(1)*ANOR)**2)
        AC2=ABS(ACC(12)*ANOR-(ACC(2)*ANOR)**2)
        AC3=ABS(ACC(13)*ANOR-(ACC(3)*ANOR)**2)
        AC4=ABS(ACC(14)*ANOR-(ACC(4)*ANOR)**2)
        AC5=ABS(ACC(15)*ANOR-(ACC(5)*ANOR)**2)
        AC6=ABS(ACC(16)*ANOR-(ACC(6)*ANOR)**2)
        AC7=ABS(ACC(17)*ANOR-(ACC(7)*ANOR)**2)
        AC8=ABS(ACC(18)*ANOR-(ACC(8)*ANOR)**2)
        AC9=ABS(ACC(20)*ANOR-(ACC(10)*ANOR)**2)
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(" *",21X,A,21X,"*")') ' AVERAGED QUANTITIES'
        WRITE(6,'(1X,64("*"))')
        WRITE(6,'(24X,A,A)') '   MEAN VALUE <x>   DEVIATION <x^2>-<x>^2'
        WRITE(6,'(A,2X,F12.2,9X,G16.6)') ' IONIC TEMPERATURE        ',
     *                             ACC(1)*ANOR,SQRT(AC1)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' DENSITY FUNCTIONAL ENERGY',
     *                             ACC(2)*ANOR,SQRT(AC2)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' CLASSICAL ENERGY         ',
     *                             ACC(3)*ANOR,SQRT(AC3)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' NOSE ENERGY ELECTRONS    ',
     *                             ACC(4)*ANOR,SQRT(AC4)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' NOSE ENERGY IONS         ',
     *                             ACC(5)*ANOR,SQRT(AC5)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' ENERGY OF CONSTRAINTS    ',
     *                             ACC(6)*ANOR,SQRT(AC6)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' ENERGY OF RESTRAINTS     ',
     *                             ACC(10)*ANOR,SQRT(AC9)
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' BOGOLIUBOV CORRECTION    ',
     *                             ACC(7)*ANOR,SQRT(AC7)
        WRITE(6,'(A,2X,G12.6,9X,G16.6)') ' ION DISPLACEMENT         ',
     *                             ACC(8)*ANOR,SQRT(AC8)
        WRITE(6,'(A,2X,F12.4,9X,G16.6)') ' CPU TIME                 ',
     *                             ACC(9)*ANOR
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PACCD(EKINC,ETOTV,ECONS,EHAM,TEMPP,EHARV,ENOSE,ENOSP,
     *                 DISA,TCPU,QPKINP,QVKINP,EKINA,ETOTA,ECONSA,
     *                 EHAMA,TEMPA,EQUANT,ACCUS,NFI,IT)
C     ==--------------------------------------------------------------==
C     == IT:                                                          ==
C     ==   1  Update accumulators                                     ==
C     ==      The arguments are used                                  ==
C     == !=1  Print  averaged values of accumulators                  ==
C     ==      The arguments are unused                                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      REAL*8  EKINC,ETOTV,ECONS,EHAM,TEMPP,EHARV,ENOSE,ENOSP,
     *        DISA,TCPU,QPKINP,QVKINP,EKINA,ETOTA,ECONSA,
     *        EHAMA,TEMPA,EQUANT,ACCUS(*)
      INTEGER NFI,IT
C     Variables
      REAL*8  ANOR,AC1,AC2,AC3,AC4,AC5,AC6,AC7,AC8,AC9
C     ==--------------------------------------------------------------==
      IF(IT.EQ.1) THEN
        ACCUS(1)=ACCUS(1)+EKINC
        ACCUS(2)=ACCUS(2)+ETOTV
        ACCUS(3)=ACCUS(3)+ECONS
        ACCUS(4)=ACCUS(4)+EHAM 
        ACCUS(5)=ACCUS(5)+TEMPP
        ACCUS(6)=ACCUS(6)+EHARV 
        ACCUS(7)=ACCUS(7)+ENOSE
        ACCUS(8)=ACCUS(8)+ENOSP
        ACCUS(9)=ACCUS(9)+DISA
        ACCUS(10)=ACCUS(10)+TCPU
        ACCUS(11)=ACCUS(11)+QPKINP
        ACCUS(12)=ACCUS(12)+QVKINP
        ACCUS(13)=ACCUS(13)+EKINA 
        ACCUS(14)=ACCUS(14)+ETOTA 
        ACCUS(15)=ACCUS(15)+ECONSA
        ACCUS(16)=ACCUS(16)+EHAMA 
        ACCUS(17)=ACCUS(17)+TEMPA 
        ACCUS(18)=ACCUS(18)+EQUANT
        ACCUS(21)=ACCUS(21)+QPKINP*QPKINP
        ACCUS(22)=ACCUS(22)+QVKINP*QVKINP
        ACCUS(23)=ACCUS(23)+EKINA*EKINA
        ACCUS(24)=ACCUS(24)+ETOTA*ETOTA
        ACCUS(25)=ACCUS(25)+ECONSA*ECONSA
        ACCUS(26)=ACCUS(26)+EHAMA*EHAMA
        ACCUS(27)=ACCUS(27)+TEMPA*TEMPA
        ACCUS(28)=ACCUS(28)+EQUANT*EQUANT
        ACCUS(29)=ACCUS(29)+DISA*DISA    
      ELSE
        ANOR=1.D0/DBLE(NFI)
        AC1=ACCUS(21)*ANOR-(ACCUS(11)*ANOR)**2
        AC2=ACCUS(22)*ANOR-(ACCUS(12)*ANOR)**2
        AC3=ACCUS(23)*ANOR-(ACCUS(13)*ANOR)**2
        AC4=ACCUS(24)*ANOR-(ACCUS(14)*ANOR)**2
        AC5=ACCUS(25)*ANOR-(ACCUS(15)*ANOR)**2
        AC6=ACCUS(26)*ANOR-(ACCUS(16)*ANOR)**2
        AC7=ACCUS(27)*ANOR-(ACCUS(17)*ANOR)**2
        AC8=ACCUS(28)*ANOR-(ACCUS(18)*ANOR)**2
        AC9=ACCUS(29)*ANOR-(ACCUS( 9)*ANOR)**2
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(" *",21X,A,21X,"*")') ' AVERAGED QUANTITIES'
        WRITE(6,'(1X,64("*"))')
C     ==--------------------------------------------------------------==
        WRITE(6,'(24X,A,A)') 
     *  '      MEAN VALUE       +/-  RMS DEVIATION'
        WRITE(6,'(24X,A,A)')
     *  '             <x>     [<x^2>-<x>^2]**(1/2)'
        WRITE(6,'(A,2X,G12.6,9X,G16.6)') ' ELECTRON KINETIC ENERGY  ',
     *                             ACCUS(13)*ANOR,DSQRT(DABS(AC3))
        WRITE(6,'(A,2X,F12.2,9X,F16.2)') ' IONIC TEMPERATURE        ',
     *                             ACCUS(17)*ANOR,DSQRT(DABS(AC7))
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' DENSITY FUNCTIONAL ENERGY',
     *                             ACCUS(14)*ANOR,DSQRT(DABS(AC4))
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' QUANTUM KINETIC ENERGY(P)',
     *                             ACCUS(11)*ANOR,DSQRT(DABS(AC1))
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' QUANTUM KINETIC ENERGY(V)',
     *                             ACCUS(12)*ANOR,DSQRT(DABS(AC2))
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' TOTAL QUANTUM ENERGY(P)  ',
     *                             ACCUS(18)*ANOR,DSQRT(DABS(AC8))
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' CLASSICAL ENERGY         ',
     *                             ACCUS(15)*ANOR,DSQRT(DABS(AC5))
        WRITE(6,'(A,2X,F12.6,9X,G16.6)') ' CONSERVED ENERGY         ',
     *                             ACCUS(16)*ANOR,DSQRT(DABS(AC6))
        WRITE(6,'(A,2X,G12.6,9X,G16.6)') ' ION DISPLACEMENT         ',
     *                             ACCUS(9)*ANOR,DSQRT(DABS(AC9))
        WRITE(6,'(A,2X,F12.4,9X,G16.6)') ' CPU TIME                 ',
     *                             ACCUS(10)*ANOR
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
