C     ==================================================================
      SUBROUTINE PRINTP(TAUR,TAUP,VELP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'movi.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'store.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'cell.inc'
      INCLUDE 'mw.inc'
      INCLUDE 'cnst_dyn.inc'  ! cmb
      INCLUDE 'fileopen.inc'
      INCLUDE 'printp.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mfep.inc'  !ISTRING
C     Arguments
      REAL*8 TAUR(3,NAX,*),TAUP(3,NAX,*),VELP(3,NAX,*)
C     Variables
      INTEGER ITYP ! cmb
      REAL*8 FACT,CONST,OUT(3,3),CVAL,FVAL ! cmb
      LOGICAL FERROR,STATUS
      REAL*8   GR_TAU(3,*),GR_VEL(3,*)
      INTEGER  GR_IAT(*)
      POINTER  (IP_GR_TAU,GR_TAU),(IP_GR_VEL,GR_VEL),(IP_GR_IAT,GR_IAT)
      CHARACTER*20  F1,F2,F3,F4,F5,F6,F7,F8,F9,F10
      DATA          F1,F2,F3,F4,F5,F6,F7,F8,F9,F10
     *     /'MOVIE     ','TRAJECTORY','CONSTRAINT','STRESS    ',
     *      'CELL      ','DIPOLE    ','STRECL    ','TRAJEC.xyz',
     *      'TRAJEC.dcd','METRIC    '/
      CHARACTER DCDTYPE*4,DCDTITLE*80,FTMP*80,CSTRING*4,FFORMAT*20
      DATA DCDTYPE,DCDTITLE /'CORD',
     & 'CHARMM format DCD trajectory written by CPMD. '/
      REAL*4  DCDDELTA
      REAL*8  DCDCELL(6)
      REAL*4  DCDX(*),DCDY(*),DCDZ(*)
      POINTER (IP_DCDX,DCDX),(IP_DCDY,DCDY),(IP_DCDZ,DCDZ)
      INTEGER IA,IC,IS,IZ0,IT0,I,J,K,L,IFIRST,I1,I2
      DATA    IFIRST /1/
      SAVE    IFIRST

      IF (IFIRST.EQ.1) THEN
         IF1=FO_VERB
         IF2=FO_VMARK
         IF3=FO_APP+FO_VMARK
         IFIRST=0
      ENDIF
C     Setup file-open mode and file-names for path minimization
      IF(TPMIN) THEN
        IF(MOD(NFI,NOMORE).EQ.1) THEN
          IF3=FO_DEF
        ELSE
          IF3=FO_APP
        ENDIF
        FTMP='CONSTRAINT.'
        CALL MW_FILENAME(FTMP,F3,ISTRING)
        FTMP='METRIC.'
        CALL MW_FILENAME(FTMP,F10,ISTRING)
      ENDIF

      CALL mm_dim(mm_go_mm,status)
      CALL MEMORY(IP_GR_TAU,NAT*3,'GR_TAU')
      CALL MEMORY(IP_GR_VEL,NAT*3,'GR_VEL')
      CALL MEMORY(IP_GR_IAT,(NAT+1)/IRAT,'GR_IAT')
C     If multiple walkers TRAJECTORY to TRAJECTORY_IP and TRAJEC.xyz to TRAJEC_IP.xyz
      IF(TMW)THEN
          FTMP='TRAJECTORY_'
          CALL MW_FILENAME(FTMP,F2,WALKER_ID)
          FTMP='TRAJEC_'
          CALL MW_FILENAME(FTMP,F8,WALKER_ID)
          CALL XSTRING(F8,I1,I2)
          FTMP=F8(I1:I2)//".xyz"
          F8=FTMP
          FTMP='CONSTRAINT_'
          CALL MW_FILENAME(FTMP,F3,WALKER_ID)
          FTMP='METRIC_'
          CALL MW_FILENAME(FTMP,F10,WALKER_ID)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  OPEN THE TRAJECTORY AND MOVIE FILES                         ==
C     ==--------------------------------------------------------------==
      IF(RPRINT) THEN
        CALL FILEOPEN(4,F2,FO_APP+IF2,FERROR)
      ENDIF
      IF(RPRINT.OR.(TXYZ.AND.XTOUT).OR.(TDCD.AND.DCOUT)) THEN
        IF(MCNSTR.GT.0.OR.MRESTR.GT.0) THEN
          CALL FILEOPEN(31,F3,IF3,FERROR)
          IF(MRESTR.GT.0) CALL FILEOPEN(90,F10,IF3,FERROR)
          IF3=FO_APP
        ENDIF
      ENDIF
C     CHECK IF WE NEED TO WRITE A DCD HEADER
C     FIXME: ideally we would also check if an existing dcd file
C            matches the current system and rename/stop if it does not.
C     FIXME: also we don't update the number of steps in the dcd file.
C     AK 2005/08/21
      IF(DCOUT) THEN
        FERROR=.TRUE.
        INQUIRE(FILE=F9,EXIST=FERROR)
        IF(.NOT.FERROR) THEN
          CALL FILEOPEN(35,F9,FO_APP+FO_UFO,FERROR)
          DCDDELTA=DELT_IONS
          WRITE(35) DCDTYPE,0,NFI,NTRAJ,0,0,0,0,0,0,DCDDELTA,1,
     &              0,0,0,0,0,0,0,0,24
          WRITE(35) 2,DCDTITLE,DCDTITLE
          WRITE(35) NAT
          CALL FILECLOSE(35)
        ENDIF
      ENDIF
      IF(TXYZ.AND.XTOUT) CALL FILEOPEN( 8,F8,FO_APP+IF1,FERROR)
      IF(TDCD.AND.DCOUT) CALL FILEOPEN(35,F9,FO_APP+FO_UFO+IF1,FERROR)
      IF(MOVIE)          CALL FILEOPEN(11,F1,FO_APP+IF2,FERROR)
      IF(CALSTC)         CALL FILEOPEN(55,F7,FO_APP+IF2,FERROR)
      IF(CALDIP)         CALL FILEOPEN(34,F6,FO_APP+IF2,FERROR)
C..Verbose+Mark only on first encounter.
      IF1=0
      IF2=0
C     get coordinates and velocities into gromos ordering
      I=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          I=I+1
          GR_IAT(NAT_grm(i))=IATYP(IS)
          DO K=1,3
            GR_TAU(K,NAT_grm(I))=TAUP(K,IA,IS)-MM_C_TRANS(K)
            GR_VEL(K,NAT_grm(I))=VELP(K,IA,IS)
          ENDDO
        ENDDO
      ENDDO
C..Store ionic coordinates and velocities for statistics
      IF(RPRINT) THEN
        IF(TSAMPL) THEN
          DO I=MINWRITEATOM,MAXWRITEATOM
            IF (.NOT.TRAJSMALL .OR. I.LE.TRAJSMALLN) THEN
              IF (TWRITEBINTRAJECTORY) THEN
                WRITE(4) NFI,(GR_TAU(K,I),K=1,3),(GR_VEL(K,I),K=1,3)
              ELSE
                WRITE(4,'(I7,6(2X,F22.14))')
     *               NFI,(GR_TAU(K,I),K=1,3),(GR_VEL(K,I),K=1,3)
              END IF
            ENDIF
          ENDDO
        ELSE
          DO I=MINWRITEATOM,MAXWRITEATOM
            IF (.NOT.TRAJSMALL .OR. I.LE.TRAJSMALLN) THEN
              IF (TWRITEBINTRAJECTORY) THEN
                WRITE(4) NFI,(GR_TAU(K,I),K=1,3),(GR_VEL(K,I),K=1,3)
              ELSE
                WRITE(4,'(I7,6(2X,F22.14))')
     *               NFI,(GR_TAU(K,I),K=1,3),(GR_VEL(K,I),K=1,3)
              END IF
            ENDIF
          ENDDO
        ENDIF
        CALL FILECLOSE(4)
      ENDIF
      IF(RPRINT.OR.(TXYZ.AND.XTOUT).OR.(TDCD.AND.DCOUT)) THEN
        IF(TPRCP) THEN
          CALL FILEOPEN(32,F5,FO_APP+IF2,FERROR)
          WRITE(32,*) '  CELL PARAMETERS at Step:', NFI
          DO I=1,3
            WRITE(32,'(3(1X,F14.6),8X,3(1X,F12.6))') 
     *          (HT(I,J),J=1,3),(HTVEL(I,J),J=1,3)
          ENDDO
          CALL FILECLOSE(32)
        ENDIF
        IF(MCNSTR.GT.0.OR.MRESTR.GT.0) THEN
          DO J=1,MCNSTR
            FVAL=FV(J)
            ITYP=NTCNST(1,J)
            IF(ITYP.EQ.2.OR.ITYP.EQ.3.OR.ITYP.EQ.5) CALL RADDEG(FVAL,1)
            WRITE(31,'(I7,2X,I4,5X,2(1PE20.10))') NFI,J,XLAGR(J),FVAL
          ENDDO
          DO J=1,MRESTR
            FVAL=RESV(J)
            CVAL=RESVAL(J)
            ITYP=NTREST(1,J)
            IF(ITYP.EQ.2.OR.ITYP.EQ.3.OR.ITYP.EQ.5) CALL RADDEG(FVAL,1)
            IF(ITYP.EQ.2.OR.ITYP.EQ.3.OR.ITYP.EQ.5) CALL RADDEG(CVAL,1)
            FVAL=FVAL-CVAL
            WRITE(31,'(I7,2X,I4,5X,3(1PE20.10)," R")') NFI,J,CVAL,FVAL,
     &                                                 RESFDIFF(J)
          ENDDO
          WRITE(CSTRING,'(I4)') MRESTR
          CALL XSTRING(CSTRING,I1,I2)
          DO I=1,MRESTR
             WRITE(90,'('//CSTRING(I1:I2)//'(1PE20.10))')
     &         (RESM(I,J),J=1,MRESTR)
          ENDDO
          CALL FILECLOSE(31)
          IF (MRESTR.GT.0) CALL FILECLOSE(90)
        ENDIF
      ENDIF
C..Write xyz file output
      IF(TXYZ) THEN
        WRITE(8,*) NAT
        WRITE(8,*) 'STEP:', NFI
        DO I=1,NAT
          WRITE(8,'(A2,3(2X,F12.6))')
     &         EL(GR_IAT(I)),(GR_TAU(K,I)/FBOHR,K=1,3)
        ENDDO
        CALL FILECLOSE(8)
      ENDIF
C..Write dcd file output
C..FIXME: we don't update the number of frames field in the header (yet).
      IF(TDCD) THEN
        CALL MEMORY(IP_DCDX,(NAT+1)/2,'DCDX')
        CALL MEMORY(IP_DCDY,(NAT+1)/2,'DCDY')
        CALL MEMORY(IP_DCDZ,(NAT+1)/2,'DCDZ')
        DO I=1,NAT
          DCDX(I)=GR_TAU(1,I)/FBOHR
          DCDY(I)=GR_TAU(2,I)/FBOHR
          DCDZ(I)=GR_TAU(3,I)/FBOHR
        ENDDO
C       store unitcell. use classical box for QM/MM
        IF(TQMMM) THEN
          DCDCELL(1)=BOX_au(1)/FBOHR
          DCDCELL(3)=BOX_au(2)/FBOHR
          DCDCELL(6)=BOX_au(3)/FBOHR
          DCDCELL(2)=0.0d0
          DCDCELL(4)=0.0d0
          DCDCELL(5)=0.0d0
        ELSE
C  FIXME: this does not work for variable cell calculations.
C         we overried it later.
          DCDCELL(1)=CELLDM(1)/FBOHR
          DCDCELL(3)=CELLDM(1)*CELLDM(2)/FBOHR
          DCDCELL(6)=CELLDM(1)*CELLDM(3)/FBOHR
          DCDCELL(2)=CELLDM(4)
          DCDCELL(4)=CELLDM(5)
          DCDCELL(5)=CELLDM(6)

          IF(TPRCP) THEN
            DCDCELL(1)=DSQRT(HT(1,1)**2 + HT(1,2)**2 + HT(1,3)**2)/FBOHR
            DCDCELL(3)=DSQRT(HT(2,1)**2 + HT(2,2)**2 + HT(2,3)**2)/FBOHR
            DCDCELL(6)=DSQRT(HT(3,1)**2 + HT(3,2)**2 + HT(3,3)**2)/FBOHR
            DCDCELL(2)=(HT(1,1)*HT(2,1)+HT(1,2)*HT(2,2)+HT(1,3)*HT(2,3))
     &                 /(DCDCEll(1)*DCDCELL(3))
            DCDCELL(4)=(HT(1,1)*HT(3,1)+HT(1,2)*HT(3,2)+HT(1,3)*HT(3,3))
     &                 /(DCDCEll(1)*DCDCELL(6))
            DCDCELL(5)=(HT(2,1)*HT(3,1)+HT(2,2)*HT(3,2)+HT(2,3)*HT(3,3))
     &                 /(DCDCEll(3)*DCDCELL(6))
          ENDIF
        ENDIF
        WRITE(35) (DCDCELL(I),I=1,6)
        WRITE(35) (DCDX(I),I=1,NAT)
        WRITE(35) (DCDY(I),I=1,NAT)
        WRITE(35) (DCDZ(I),I=1,NAT)
        CALL FREEM(IP_DCDX)
        CALL FREEM(IP_DCDY)
        CALL FREEM(IP_DCDZ)
        CALL FILECLOSE(35)
      ENDIF
C..Write Movie File
C     FIXME: AK 2005/05/25 not yet converted to GROMOS ordering.
      IF(MOVIE)THEN
        DO IS=1,NSP
          IZ0=IMTYP(IS)
          DO IA=1,NA(IS)
            IF(IATYP(IS).EQ.4) THEN
C..Change Be -> Na ; problem with movie
              IT0=11
              WRITE(11,'(3(2X,F12.4),2I4)') 
     *                 (TAUP(K,IA,IS)/FBOHR,K=1,3),IT0,IZ0
            ELSE
              WRITE(11,'(3(2X,F12.4),2I4)') 
     *                 (TAUP(K,IA,IS)/FBOHR,K=1,3),IATYP(IS),IZ0
            ENDIF
          ENDDO
        ENDDO
        CALL FILECLOSE(11)
      ENDIF
C..Write Stress tensor
      IF(CALSTE.AND.(MOD(NFI-1,NPRES).EQ.0)) THEN
        CALL DCOPY(9,PAIU,1,OUT,1)
C$OMP parallel do private(I,IA,IS,FACT) reduction(+:OUT)
        DO I=1,NAT
          IA=IATPT(1,I)
          IS=IATPT(2,I)
          FACT=PMA(IS)
          OUT(1,1)=OUT(1,1)+FACT*VELP(1,IA,IS)*VELP(1,IA,IS)
          OUT(2,1)=OUT(2,1)+FACT*VELP(2,IA,IS)*VELP(1,IA,IS)
          OUT(3,1)=OUT(3,1)+FACT*VELP(3,IA,IS)*VELP(1,IA,IS)
          OUT(1,2)=OUT(1,2)+FACT*VELP(1,IA,IS)*VELP(2,IA,IS)
          OUT(2,2)=OUT(2,2)+FACT*VELP(2,IA,IS)*VELP(2,IA,IS)
          OUT(3,2)=OUT(3,2)+FACT*VELP(3,IA,IS)*VELP(2,IA,IS)
          OUT(1,3)=OUT(1,3)+FACT*VELP(1,IA,IS)*VELP(3,IA,IS)
          OUT(2,3)=OUT(2,3)+FACT*VELP(2,IA,IS)*VELP(3,IA,IS)
          OUT(3,3)=OUT(3,3)+FACT*VELP(3,IA,IS)*VELP(3,IA,IS)
        END DO
C       We give th true total stress tensor. (T.D.)
C       DO I=1,3
C         OUT(I,I)=OUT(I,I)+DRUCK*OMEGA
C       ENDDO
        CALL FILEOPEN(33,F4,FO_APP+IF2,FERROR)
        WRITE(33,*) '  TOTAL STRESS TENSOR (kB): Step:', NFI
        DO I=1,3
          WRITE(33,'(5X,3(F20.8))') ((OUT(I,J)/OMEGA)*AU_KB,J=1,3)
        ENDDO
        CALL FILECLOSE(33)
      ENDIF
c      WRITE CLASSICAL STRESS TENSOR
c       we add the ideal gas contribution of the classical particles
      IF(CALSTC) THEN
        DO IC=1,NCLTYP
          IF(IS_QM(IC).EQ.0) THEN
c       classical particle
          CONST=CLMAS(IC)*SCMASS
            DO IA=NCRANG(1,IC),NCRANG(2,IC)
              DO K=1,3
                DO L=1,3
        CLASPRES(K,L)=CLASPRES(K,L)+CONST*CLASV(K,IA)*CLASV(L,IA)
                ENDDO
              ENDDO
            ENDDO
          ENDIF
        ENDDO
        WRITE(55,*) 'CLASSICAL STRESS TENSOR (kB): Step:', NFI
c       WRITE(57,*) 'CLASSICAL STRESS TENSOR (kB): Step:', NFI
        DO I=1,3
        WRITE(55,'(5X,3(F20.8))') ((claspres(I,J)/CLOMEGA)*AU_KB,J=1,3)
c       WRITE(57,'(5X,3(F20.8))') ((claspres(I,J)/CLOMEGA)*AU_KB,J=1,3)
        ENDDO
        CALL FILECLOSE(55)
      ENDIF
C..Write Dipole Moments
      IF(CALDIP) THEN
        WRITE(34,'(I7,6(2X,1PE16.6E2))')NFI,(PDIPOLE(I),I=1,3),
     *                                  (PDIPOLT(I),I=1,3)
        CALL FILECLOSE(34)
      ENDIF
      CALL mm_dim(mm_revert,status)
      CALL FREEM(IP_GR_TAU)
      CALL FREEM(IP_GR_VEL)
      CALL FREEM(IP_GR_IAT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


C     ==================================================================
      SUBROUTINE PRINTP2(TAUR,TAUP,VELP,FION)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'movi.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'store.inc'
      INCLUDE 'adat.inc'
      INCLUDE  'cnst_dyn.inc'  ! cmb
      INCLUDE 'fileopen.inc'

C     Arguments
      REAL*8 TAUR(3,NAX,*),TAUP(3,NAX,*),VELP(3,NAX,*)
      REAL*8 FION(3,NAX,*)
C     Variables
      LOGICAL FERROR
      CHARACTER*11  F2
      DATA          F2
     *     /'FTRAJECTORY'/
      INTEGER J,K,L,
     &        IF2
      DATA    IF2 /FO_VMARK/
      SAVE    IF2
C     ==--------------------------------------------------------------==
C     ==  OPEN THE TRAJECTORY AND MOVIE FILES                         ==
C     ==--------------------------------------------------------------==
      IF(RPRINT) THEN
        CALL FILEOPEN(4,F2,FO_APP+IF2,FERROR)
      ENDIF
      IF2=0
C..Store ionic coordinates and velocities for statistics
C     FIXME: AK 2005/05/25 not yet converted to GROMOS ordering.
      IF(RPRINT) THEN
        IF(TSAMPL) THEN
          L=0
          DO K=1,NSP
            DO J=1,NA(K)
              L=L+1
              IF (L.GE.MINWRITEATOM.AND.L.LE.MAXWRITEATOM) THEN
                IF (.NOT.TRAJSMALL .OR. L.LE.TRAJSMALLN) THEN
                  IF (TWRITEBINTRAJECTORY) THEn
                    WRITE(4)
     &                   NFI,
     &                   TAUP(1,J,K),TAUP(2,J,K),TAUP(3,J,K),
     &                   VELP(1,J,K),VELP(2,J,K),VELP(3,J,K),
     &                   FION(1,J,K),FION(2,J,K),FION(3,J,K)
                  ELSE
                    WRITE(4,'(I7,9(2X,F22.14))')
     &                   NFI,
     &                   TAUP(1,J,K),TAUP(2,J,K),TAUP(3,J,K),
     &                   VELP(1,J,K),VELP(2,J,K),VELP(3,J,K),
     &                   FION(1,J,K),FION(2,J,K),FION(3,J,K)
                  END IF
                END IF
              ENDIF
            ENDDO
          ENDDO
        ELSE
          L=0
          DO K=1,NSP
            DO J=1,NA(K)
              L=L+1
              IF (L.GE.MINWRITEATOM.AND.L.LE.MAXWRITEATOM) THEN
                IF (.NOT.TRAJSMALL .OR. L.LE.TRAJSMALLN) THEN
                  IF (TWRITEBINTRAJECTORY) THEn
                    WRITE(4)
     &                   NFI,
     &                   TAUP(1,J,K),TAUP(2,J,K),TAUP(3,J,K),
     &                   VELP(1,J,K),VELP(2,J,K),VELP(3,J,K),
     &                   FION(1,J,K),FION(2,J,K),FION(3,J,K)
                  ELSE
                    WRITE(4,'(I7,9(2X,F22.14))')
     &                   NFI,
     &                   TAUP(1,J,K),TAUP(2,J,K),TAUP(3,J,K),
     &                   VELP(1,J,K),VELP(2,J,K),VELP(3,J,K),
     &                   FION(1,J,K),FION(2,J,K),FION(3,J,K)
                  END IF
                END IF
              ENDIF
            ENDDO
          ENDDO
        ENDIF
        CALL FILECLOSE(4)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
