#if defined(CRAYX1)
C     ==================================================================
      MODULE CRAY_HEAP
C     ==--------------------------------------------------------------==
       USE, INTRINSIC :: ISO_C_BINDING
       INTEGER(KIND=C_LONG) :: mem_end
       BIND(C, NAME='end') :: mem_end

       INTERFACE
         FUNCTION sbrk(val), BIND(C)
           USE, INTRINSIC :: ISO_C_BINDING
           INTEGER(KIND=C_LONG) :: sbrk
           INTEGER(KIND=C_LONG), VALUE, INTENT(IN) :: val
         END FUNCTION sbrk
       END INTERFACE
       END MODULE CRAY_HEAP
#endif

C     ==================================================================
      SUBROUTINE PRMEM(SUBR)
C     ==--------------------------------------------------------------==
#if defined(CRAYX1)
       USE CRAY_HEAP
#endif
      IMPLICIT NONE
      INCLUDE 'envj.inc'
C     Arguments
      CHARACTER SUBR*10
C     Variables
#if defined _BGL 
      INTEGER PRINTMEMSIZE,ID
#endif
#if defined(_NO_MEMSIZE) || defined(__SR8000) || defined(__ES) || defined(__WINNT) || defined(_BGP)
      WRITE(6,'(A4,A10,A,10X,A)')
     .    ' ***',SUBR,'| SIZE OF THE PROGRAM IS NOT AVAILABLE','***' 
#elif defined(CRAYX1)
       INTEGER(KIND=8) m1

       m1 = sbrk(0_8) - mem_end ! mem_end is in module crayheap
       m1 = rshift(m1,10) ! kbytes
      WRITE(6,'(A4,A10,A24,I16,A11)') 
     *    ' ***',SUBR,'|   CURRENT HEAP LENGTH ',m1,' KWords ***'

#elif defined(CRAY_XT3)
      CALL MY_FLUSH(6)
      CALL PRINTMEMSIZE(SUBR)
      CALL MY_FLUSH(6)
#elif defined(CRAY)
      INTEGER ISS,
     &        IHPSTAT
C     ==--------------------------------------------------------------==
      ISS=IHPSTAT(1)/1000
      WRITE(6,'(A4,A10,A24,I16,A11)') 
     *    ' ***',SUBR,'|   CURRENT HEAP LENGTH ',ISS,' KWords ***'
#elif defined(__alpha) || defined(__Linux) || defined (ALPHALINUX) || defined(__SUN) || defined (__SGI) || (defined(__PWRLinux)  && !defined _BGL )
C     ==--------------------------------------------------------------==
      WRITE(6,'(A,A,A,$)')
     &     ' ***',SUBR,'| SIZE OF THE PROGRAM IS '
      CALL MY_FLUSH(6)
      CALL PRINTMEMSIZE
      CALL MY_FLUSH(6)
      WRITE(6,'(A)') ' kBYTES ***'
      CALL MY_FLUSH(6)
#elif defined _BGL 
      CHARACTER STRING*140
      ID=PRINTMEMSIZE()/(1024*1024)
      WRITE(6,'(A4,A10,A27,I13,A11)') 
     *    ' ***',SUBR,'|  THE TOP OF THE STACK IS ',ID,' MBytes ***'
      WRITE(6,*)
#elif defined(__NEC)
      CHARACTER STRING*140
C     ==--------------------------------------------------------------==
#if defined(__ES)
      WRITE(6,'(A,A,A)')
     .' ***',SUBR,'| SIZE OF THE PROGRAM IS NOT AVAILABLE' 
#else
      WRITE(6,'(A,A,A,$)')
     *    ' ***',SUBR,'| SIZE OF THE PROGRAM IS '
      CALL MY_FLUSH(6)
      WRITE(STRING,'(A,I10,A,A)') 'ps -lp ',MY_PID,
     *  ' | grep -v PID |  cut -c49-55 | ',
     *  ' awk '' { print $1/25 " MBytes ***"}'''
      CALL SYSTEM(STRING)
      WRITE(6,*)
#endif
#elif defined(_vpp_)
#if defined(_vpp_old)
      CHARACTER STRING*140
C     ==--------------------------------------------------------------==
      WRITE(6,'(A,A,A,$)')
     *    ' ***',SUBR,'| SIZE OF THE PROGRAM IS '
cmb
      CALL FLUSH(6) ! Fujitsu
cmb
      WRITE(STRING,'(A,I10,A)') 'ps -lc -p ',MY_PID,
     *' | sed -e "/ SZ/d" | cut -c42-48 - | sed -e "s/$/(4kB) pages/"'
      CALL SYSTEM(STRING)
#else
      WRITE(6,'(A,A,A,$)')
     &     ' ***',SUBR,'| SIZE OF THE PROGRAM IS '
      CALL MY_FLUSH(6)
      CALL PRINTMEMSIZE
      WRITE(6,'(A)')
     *    ' kBYTES ***'
#endif
#elif defined(__HP)
      REAL*8 RDATA,VDATA,RSTACK,VSTACK
C     ==--------------------------------------------------------------==
      CALL MEMME(VDATA,VSTACK)
      WRITE(6,'(A,A,A,F7.2,A,A,F7.2,A)')
     *    ' ***',SUBR,'| PROGSIZE DATA=',vdata,' MByte',
     *    '  /  STACK=',vstack,' MByte'
#elif defined(__SR2201)
      CHARACTER STRING*140
C     ==--------------------------------------------------------------==
      WRITE(6,'(A,A,A,$)')
     *    ' ***',SUBR,'| SIZE OF THE PROGRAM IS '
      WRITE(STRING,'(A,I10,A,A)') 'ps -o rss -p ',MY_PID,
     *  ' | sed -e "/RSS/d" | sed -e "s/K.*$/ KBytes ***/" ',
     *  ' | sed -e "s/M.*$/ MBytes ***/" '
      CALL SYSTEM(STRING)
#elif defined(__SR8000)
C     ==--------------------------------------------------------------==
C     call to the shell is prohibitively expensive on sr8000
      WRITE(6,'(A,A,A)') ' ***',SUBR,
     *     '| SIZE OF THE PROGRAM IS NOT AVAILABLE ***'
C      WRITE(6,'(A,A,A,$)')
C     *    ' ***',SUBR,'| SIZE OF THE PROGRAM IS '
C      WRITE(STRING,'(A,I10,A,A)') 'ps -o rss -p ',MY_PID,
C     *  ' | sed -e "/RSS/d" | sed -e "s/K.*$/ KBytes ***/" ',
C     *  ' | sed -e "s/M.*$/ MBytes ***/" '
C      CALL SYSTEM(STRING)
#elif defined(__OSX) || defined(__OSX_IFC)
      CHARACTER STRING*140
C     ==--------------------------------------------------------------==
      WRITE(6,'(A,A,A,$)')
     *    ' ***',SUBR,'| SIZE OF THE PROGRAM IS '
      WRITE(STRING,'(A,I12,A)') 'ps -ovsz -p ',MY_PID,
     *  ' | sed -e "/VSZ/d" | sed -e "s/$/ KBytes ***/" '
      CALL SYSTEM(STRING)
#elif defined(__IBM)  && !defined(__PWRLinux)
      CHARACTER STRING*140
C     ==--------------------------------------------------------------==
      WRITE(6,'(A,A,A,$)') 
     *    ' ***',SUBR,'| SIZE OF THE PROGRAM IS '
      WRITE(STRING,'(A,I12,A)') 'ps -Fvsz -p ',MY_PID,
     *  ' | sed -e "/VSZ/d" | sed -e "s/$/ KBytes ***/" '
      CALL SYSTEM(STRING)
#else
C unknown platforms
      WRITE(6,'(A4,A10,A,10X,A)')
     .    ' ***',SUBR,'| SIZE OF THE PROGRAM IS NOT AVAILABLE','***' 
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
