C     ==================================================================
      SUBROUTINE PROJA(C0,C2,SC0,SCR,LSCR,NSTATE,MPROJ)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'pslo.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,MPROJ
      COMPLEX*16 C0(NGW,NSTATE),C2(NGW,NSTATE),SC0(NGW,NSTATE)
      REAL*8     SCR(LSCR)
C     Variables
      REAL*8     DOTP
      EXTERNAL   DOTP
      CHARACTER  TAG*30
      INTEGER    ISUB,I,LENGTH
C     ==--------------------------------------------------------------==
      CALL TISET('     PROJA',ISUB)
C     SCR test.
      IF(MPROJ.EQ.0) THEN
        IF(TIVAN) THEN
          LENGTH=MAX(NSTATE,NGW*2)
          TAG='MAX(NSTATE,NGW*2)'
        ELSE
          LENGTH=NSTATE
          TAG='NSTATE'
        ENDIF
      ELSEIF(MPROJ.EQ.2) THEN
        IF(TIVAN) THEN
          LENGTH=MAX(NSTATE*NSTATE,NGW*2)
          TAG='MAX(NSTATE*NSTATE,NGW*2)'
        ELSE
          LENGTH=NSTATE*NSTATE
          TAG='NSTATE*NSTATE'
        ENDIF
      ENDIF
      CALL TEST_SCR('PROJA',TAG,LSCR,LENGTH)
C     ==--------------------------------------------------------------==
      IF(MPROJ.EQ.0) THEN
C       do nothing
      ELSEIF(MPROJ.EQ.1) THEN
C       ==------------------------------------------------------------==
C       ==  Projection C2(I) <= C2(I) - <C0(I)|C2(I)> SC0(I)          ==
C       ==------------------------------------------------------------==
        IF(TIVAN) THEN
          CALL DCOPY(2*NGW*NSTATE,C0(1,1),1,SC0(1,1),1)
          CALL SPSI(NSTATE,SC0,SCR,LSCR)
          DO I=1,NSTATE
            SCR(I)=DOTP(NGW,C0(1,I),C2(1,I))
          ENDDO
#ifdef PARALLEL
          CALL GLOSUM(NSTATE,SCR)
#endif    
          DO I=1,NSTATE
            CALL DAXPY(2*NGW,-SCR(I),SC0(1,I),1,C2(1,I),1)
          ENDDO
        ELSE
          DO I=1,NSTATE
            SCR(I)=DOTP(NGW,C0(1,I),C2(1,I))
          ENDDO
#ifdef PARALLEL
          CALL GLOSUM(NSTATE,SCR)
#endif    
          DO I=1,NSTATE
            CALL DAXPY(2*NGW,-SCR(I),C0(1,I),1,C2(1,I),1)
          ENDDO
        ENDIF
      ELSEIF(MPROJ.EQ.2) THEN
C       ==------------------------------------------------------------==
C       ==  Projection A(I) <= A(I) - SUM{J} <B(J)|A(I)> SB(J)        ==
C       ==------------------------------------------------------------==
        IF(TIVAN) THEN
          CALL DCOPY(2*NGW*NSTATE,C0(1,1),1,SC0(1,1),1)
          CALL SPSI(NSTATE,SC0,SCR,LSCR)
          CALL OVLAP(NSTATE,SCR,C0,C2)
#ifdef PARALLEL
          CALL GLOSUM(NSTATE*NSTATE,SCR)
#endif    
          CALL ROTATE(-1.0D0,SC0,1.0D0,C2,SCR,NSTATE,2*NGW,
     *                TLSD,NSUP,NSDOWN)
        ELSE
          CALL OVLAP(NSTATE,SCR,C0,C2)
#ifdef PARALLEL
          CALL GLOSUM(NSTATE*NSTATE,SCR)
#endif    
          CALL ROTATE(-1.0D0,C0,1.0D0,C2,SCR,NSTATE,2*NGW,
     *                TLSD,NSUP,NSDOWN)
        ENDIF
      ELSE
        CALL STOPGM('PROJA','MPROJ OPTION')
      ENDIF
      CALL CSIZE(C2,NSTATE,GEMAX,CNORM)
      CALL TIHALT('     PROJA',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
