C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == CALCULATED PORPERTIES                                        ==
C     ==--------------------------------------------------------------==
C     == IPWFN Number of logical variables in PROP1 common            ==
C     ==--------------------------------------------------------------==
      INTEGER   IPWFN
      PARAMETER (IPWFN=24)
C     ==--------------------------------------------------------------==
C     == .TRUE. if the corresponding property has to be calculated    ==
C     == PWFN    Project wavefunctions on Atomic Orbital              ==
C     == LOCL    Localized Orbitals                                   ==
C     == PRTO    Print the wavefunctions in atomic orbital basis      ==
C     == OPTS    Optimizs Slater exponents                            ==
C     == LDIP    Dipole moments                                       ==
C     == LRSDIP  Calculate dipole moments in real space               ==
C     == DBERRY  Berry phase dipole moment                            ==
C     == LOCD    Local dipole                                         ==
C     == LEXT    Excited  dipole                                      ==
C     == LTRM    Transition moments                                   ==
C     == MPAN    Mulliken population analysis                         ==
C     == DPAN    Davidson population analysis                         ==
C     == CEIG    Need to read the eigenvalues in RESTART file         ==
C     == ESPC    Atomic charges                                       ==
C     == TRAMAN  Raman phonons calculation                            ==
C     == PERTURB Perturbation theory (ramon, phonon)                  ==
C     == PHONON  Phonon calculation                                   ==
C     == ELDISP  Electron dispersion function                         ==
C     == GLOCL   Localization in reciprocal space                     ==
C     == PYLM    Projection on Spherical Harmonics                    ==
C     ==--------------------------------------------------------------==
      LOGICAL        PWFN,WFR1,WFR2,WFR3,COR1,COR2,ABAS,LOCL,PRTO,OPTS,
     *               LDIP,LOCD,LEXT,MPAN,DPAN,CEIG,ESPC,ELDISP,GLOCL,
     *               DBERRY,LTRM,LRSDIP,TAVGP,PYLM
      COMMON /PROP1/ PWFN,WFR1,WFR2,WFR3,COR1,COR2,ABAS,LOCL,PRTO,OPTS,
     *               LDIP,LOCD,LEXT,MPAN,DPAN,CEIG,ESPC,ELDISP,GLOCL,
     *               DBERRY,LTRM,LRSDIP,TAVGP,PYLM
C     ==--------------------------------------------------------------==
C     == Population analysis                                          ==
C     == NUMORB                                                       ==
C     == NCEN  Highest n-center terms included                        ==
C     == MAOS  For Davidson PAN                                       ==
C     ==--------------------------------------------------------------==
      INTEGER        NUMORB,NCEN,MAOS(MAXSP)
      COMMON /PROP2/ NUMORB,NCEN,MAOS
C     ==--------------------------------------------------------------==
C     == For population analysis                                      ==
C     == CUT3O 3-center cutoff                                        ==
C     == CUT4O 4-center cutoff                                        ==
C     ==--------------------------------------------------------------==
      REAL*8         CUT3O,CUT4O
      COMMON /PROP3/ CUT3O,CUT4O
C     ==--------------------------------------------------------------==
C     == For plotting CUBE files                                      ==
C     == TCUBEFILE_ORB  = write KS-orbitals in cubefiles              ==
C     == TCUBEFILE_DENS = write the electron density as cubefile      ==
C     == TCUBEFILE_POT  = write the potential as cubefile             ==
C     == THALFMESH      = write cube with half the points per         ==
C     ==                  direction -> 1/8th of size                  ==
C     == TCUBECENTER    = cubefile center is set from input           ==
C     == CUBECIN        = cube center as read in (in a.u.)            ==
C     == NUM_CUBEORB    = number of orbitals to write                 ==
C     == ICUBEORB       = list of orbitals to write                   ==
C     ==--------------------------------------------------------------==
      LOGICAL        TCUBEFILE_ORB,TCUBEFILE_DENS,TCUBEFILE_POT,
     &               THALFMESH,TCUBECENTER
      INTEGER        NUM_CUBEORB
      INTEGER        ICUBEORB(*)
      REAL*8         Z_11(*),CUBECIN(3)
      POINTER        (IP_ICUBEORB,ICUBEORB),(IP_Z_11,Z_11)
      COMMON /PROP4/ CUBECIN,TCUBEFILE_ORB,TCUBEFILE_DENS,
     &               TCUBEFILE_POT,THALFMESH,TCUBECENTER,NUM_CUBEORB
      COMMON /PROP4_IP/ IP_ICUBEORB
C     ==================================================================
C     FOR COMPUTING EFG TENSOR AND EPR ANISOTROPIC HF TENSOR
C     ==================================================================
      LOGICAL        TEPREFG,TEFG
      REAL*8         RHO_SAVE_EPR(*),RHO_SAVE_EFG(*)
      POINTER        (IP_RHO_SAVE_EPR,RHO_SAVE_EPR)
      POINTER        (IP_RHO_SAVE_EFG,RHO_SAVE_EFG)
      COMMON /PROP5/ TEPREFG,TEFG,IP_RHO_SAVE_EPR,IP_RHO_SAVE_EFG
C     ==================================================================
C     ==================================================================
C     FOR COMPUTING AVERAGED ATOMIC ELECTROSTATIC POTENTIAL
C     ==================================================================
      REAL*8         RCUT
      COMMON /PROP6/ RCUT
C     ==================================================================
C     FOR COMPUTING PROJECTION ON SPHERICAL HARMONICS
C     ==================================================================
      REAL*8 CENTYLM(3),RYLMAX, SPR_MIN, SPR_MAX 
      INTEGER NUMYLM, NYLMAX
      LOGICAL RADIAL, SPREAD_HAM 
      COMMON /PROP7/ CENTYLM, RYLMAX, SPR_MIN, SPR_MAX, NUMYLM, NYLMAX, 
     &     RADIAL, SPREAD_HAM 




