c     ==================================================================
      SUBROUTINE PROPPT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'lodp.inc'
      INCLUDE 'ener.inc'        !AMU
      INCLUDE 'atwf.inc'
      INCLUDE 'condu.inc'
      INCLUDE 'pola.inc'        !TPOLARB
      INCLUDE 'kpts.inc'
      INCLUDE 'poin.inc'        !RHOO
      INCLUDE 'store.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ldos.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'wann.inc'
      INCLUDE 'g_loc.inc'
      INCLUDE 'cores.inc' ! cmb-ike
      INCLUDE 'fileopen.inc'
      INCLUDE 'mm_dim.inc' ! qmmm

C     Variables
      DIMENSION  F(*)
      REAL*8     FNL(*),DFNL(*)
      INTEGER    IREC(100),ISETONE
      COMPLEX*16 C0(NGWK,*),C2(NGWK,*),CS(NGWK,*),SC0(NGWK,*)
      POINTER    (IP_C0,C0),(IP_C2,C2),(IP_CS,CS),(IP_SC0,SC0)
      COMPLEX*16 PSI(NNR1),EIROP(NHG),EIVPS(NHG),VTEMP(NHG),QPHI(*)
      POINTER    (IP_PSI,PSI),(IP_EIROP,EIROP),(IP_EIVPS,EIVPS),
     &           (IP_VTEMP,VTEMP),(IP_QPHI,QPHI)
      REAL*8     FBACK(*),EIGV(*),RHOE(NNR1),SCR(*),VR(*),
     &           ACHRG(*),ECHRG(*),EFIELD(*),ICHRG(*)
      POINTER    (IP_FBACK,FBACK),(IP_EIGV,EIGV),
     &           (IP_RHOE,RHOE),(IP_SCR,SCR),(IP_VR,VR),
     &           (IP_ACHRG,ACHRG),(IP_ECHRG,ECHRG),(IP_EFIELD,EFIELD),
     &           (IP_ICHRG,ICHRG)
      INTEGER    ISEL(*)
      POINTER    (IP_ISEL,ISEL)
      LOGICAL    TINFO, OLDSTATUS, STATUSDUMMY
      CHARACTER  TAG*30
      INTEGER    NL,I,J,JI,IR,NSTATE,NC,NXX,NNAT,ISP,IAT,LO,LR,
     &           IL_RHOE,IL_PSI,IL_EIROP,LSCR,LRHO,LRNLSM,
     &           LPOLARPROJ,LVOFRHO,LESP,IG,MLEN,IPPC,IA,IE,LAVGP
      REAL*8     DUMMY
      CHARACTER*128  CUBEFILENAME,FILEN
      REAL*8         CUBECENTER(3)
#ifdef PARALLEL
      INTEGER    MSGLEN,NXXFUN
#endif
C     ==--------------------------------------------------------------==
      IF (TQMMM.AND.PARENT) WRITE(6,*) 'PROPPT| WARNING QM/MM UNTESTED'
C     ==--------------------------------------------------------------==
      IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
      IF(EXSOFT) RETURN
      NSTATE=N
      TINFO=.FALSE.
      TCONDUCT=.FALSE.
      TPOLARB=.FALSE.
      CALL PROPIN(TINFO)
C     ==--------------------------------------------------------------==
C     If not required property to calculate -> Return
      IF(.NOT.TINFO)RETURN
      IF(PARENT) THEN
        WRITE(6,'(/,1X,64("*"))')
        WRITE(6,'(" *",19X,A,20X,"*")') ' PROPERTY CALCULATIONS '
        WRITE(6,'(1X,64("*"),/)')
      ENDIF
      IF(PWFN.AND.(TWANN.OR.LOCL)) CALL STOPGM('PROPPT','PROJECT '
     &      // 'WAVEFUNCTION AND LOCALIZATION ARE INCOMPATIBLE')
C     ==--------------------------------------------------------------==
      NUMORB = MAX(N,NUMORB)
      IF(TPOLARB) NUMORB=MAX(NUMORB,3)
      CALL MEMORY(IP_C0,2*NGWK*NUMORB*NKPNT,'C0')
      LENBK=0
      NC=2*NGWK*NUMORB
#ifdef PARALLEL
      IF(LOCL) THEN
        LENBK=NXXFUN(NUMORB)
        NC=MAX(2*LENBK*NPROC,NC)
      ELSEIF(TGWANNIER.OR.DBERRY) THEN
        LENBK=NXXFUN(NUMORB)
        NC=MAX(2*2*LENBK*NPROC,NC)
      ENDIF
#endif
      CALL MEMORY(IP_CS,NC,'CS')
      call mm_dim(mm_go_mm,OLDSTATUS)
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      call mm_dim(mm_go_qm,STATUSDUMMY)
      IF(TDIAG.OR.TCORES.OR.TCONDUCT.OR.TLDOS) THEN
        CALL MEMORY(IP_RHOO,NNR1*NLSD,'RHOO')
        CALL MEMORY(IP_EIGV,NSTATE*NKPTS,'EIGV')
      ENDIF
      CALL FNLALLOC(NUMORB,.FALSE.,.FALSE.)
C     ==--------------------------------------------------------------==
C     ==  LOAD DATA                                                   ==
C     ==--------------------------------------------------------------==
      IF(CEIG) REIGV=.TRUE.
      CALL READ_IREC(IREC)
      call mm_dim(mm_go_mm,STATUSDUMMY)
      CALL ZHRWF(1,IREC,C0,CS,NUMORB,EIGV,TAU0,TAUP,TAUP,NFI)
#ifdef PARALLEL
      MSGLEN = 3*NAX*NSX * 8
      CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
#endif
      call mm_dim(mm_go_qm,STATUSDUMMY)
      CALL MEMORY(IP_FBACK,NUMORB,'FBACK')
      IF(NUMORB.GT.N) THEN
        CALL AZZERO(FBACK,NUMORB)
        IF(TLSD) THEN
          NL=(NUMORB-N)/2
          CALL DCOPY(NSUP,F(1),1,FBACK(1),1)
          CALL DCOPY(NSDOWN,F(NSUP+1),1,FBACK(NSUP+NL+1),1)
          CALL DCOPY(2*NGW*NSUP,C0(1,1),1,CS(1,1),1)
          CALL DCOPY(2*NGW*NL,C0(1,NSUP+NSDOWN+1),1,CS(1,NSUP+1),1)
          CALL DCOPY(2*NGW*NSDOWN,C0(1,NSUP+1),1,CS(1,NSUP+NL+1),1)
          CALL DCOPY(2*NGW*NL,C0(1,NSUP+NSDOWN+NL+1),1,
     *               CS(1,NSUP+NSDOWN+NL+1),1)
          CALL DCOPY(2*NGW*NUMORB,CS(1,1),1,C0(1,1),1)
          NSUP=NSUP+NL
          NSDOWN=NSDOWN+NL
        ELSE
          CALL DCOPY(N,F(1),1,FBACK(1),1)
        ENDIF
        CALL FREEM(IP_F)
        CALL MEMORY(IP_F,NUMORB,'F')
        CALL DCOPY(NUMORB,FBACK(1),1,F(1),1)
      ENDIF
      CALL FREEM(IP_FBACK)
C     ==--------------------------------------------------------------==
C     ==  CALCULATE DIPOLE MOMENTS                                    ==
C     ==--------------------------------------------------------------==
      IF(DBERRY) THEN
        IF(TKPNT) THEN
          CALL GIVE_SCR_KDDIPO(LSCR,NUMORB,TAG)
          CALL MEMORY(IP_SCR,LSCR,'SCR')
          CALL MEMORY(IP_C2,NC,'C2')
          CALL MEMORY(IP_SC0,NC,'SC0')
          CALL KDDIPO(TAU0,C0,C2,CS,SC0,SCR,LSCR,NUMORB)
          CALL FREEM(IP_SCR)
          CALL FREEM(IP_C2)
          CALL FREEM(IP_SC0)
        ELSE
          CALL GIVE_SCR_DDIPO(LSCR,TAG)
          CALL MEMORY(IP_SCR,LSCR,'SCR')
          CALL MEMORY(IP_C2,NC,'C2')
          CALL MEMORY(IP_SC0,NC,'SC0')
          CALL DDIPO(TAU0,C0,C2,CS,SC0,SCR,LSCR,NUMORB)
          IF(PARENT) CALL PRDIP
          CALL FREEM(IP_SCR)
          CALL FREEM(IP_C2)
          CALL FREEM(IP_SC0)
        ENDIF
      ENDIF
      IF(LDIP.OR.LOCD.OR.LEXT.OR.LTRM) THEN
C       SCR creation
        CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
        CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
        IL_EIROP=NHG*2
        CALL MEMORY(IP_EIROP,IL_EIROP,'EIROP')
        CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NUMORB,.FALSE.)
        IF(LEXT.AND..NOT.LTRM) THEN
          CALL GIVE_SCR_DIFRHO(LRHO,TAG)
        ELSEIF(LDIP.OR.LOCD.OR.LTRM) THEN
          CALL GIVE_SCR_RHOOFR(LRHO,TAG)
        ELSE
          LRHO=0
        ENDIF
C       SCR IN EICALC IS 2*NHG
        LSCR=MAX(LRNLSM,LRHO,2*NHG)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
C       ==------------------------------------------------------------==
        CALL PHFAC(TAU0)
        CALL RNLSM(C0,NUMORB,PSI,SCR,LSCR,1,1,.FALSE.)
        IF(LEXT) THEN
          CALL MEMORY(IP_FBACK,NUMORB,'FBACK')
          CALL DCOPY(NUMORB,F(1),1,FBACK(1),1)
          DO I=1,NEXDIP
            DO J=1,NUMORB
              JI=(I-1)*NUMORB+J
              F(J)=FBACK(J)-FOCC(JI)
            ENDDO
            CALL DIFRHO(C0,RHOE,PSI,SCR,LSCR,NUMORB)
#ifdef _BGL 
            CALL AZZERO(EIROP,2*NHG)
#else
            CALL ZAZZERO(EIROP,NHG)
#endif
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
      CALL ALIGNX(16,PSI(1))
      CALL ALIGNX(16,RHOE(1))
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
!$OMP parallel do private(IR)
            DO IR=1,NNR1
              PSI(IR)=DCMPLX(RHOE(IR),0.D0)
            ENDDO
            CALL FWFFT(PSI)
            CALL EXDIPO(I,TAU0,PSI,EIROP)
          ENDDO
          CALL DCOPY(NUMORB,FBACK(1),1,F(1),1)
        ENDIF
        IF(LTRM) THEN
          DO I=1,NTRMOM
            CALL AZZERO(RHOE,NNR1)
#ifdef _BGL 
            CALL AZZERO(EIROP,2*NHG)
#else
            CALL ZAZZERO(EIROP,NHG)
#endif
            CALL RHOABOFR(1,C0(1,NSDIP(1,I)),C0(1,NSDIP(2,I)),RHOE,PSI)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
      CALL ALIGNX(16,PSI(1))
      CALL ALIGNX(16,RHOE(1))
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
!$OMP parallel do private(IR)
            DO IR=1,NNR1
              PSI(IR)=DCMPLX(RHOE(IR),0.D0)
            ENDDO
            CALL FWFFT(PSI)
            CALL TRANSM(I,TAU0,PSI,EIROP)
          ENDDO
        ENDIF
        IF(LDIP.OR.LOCD) THEN
          IF(TKPNT) THEN
            CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,N)
          ELSE
            CALL RHOOFR  (C0,RHOE,PSI,SCR,LSCR,N)
          ENDIF
          CALL EICALC(SCR,EIROP)
          IF(LRSDIP) THEN
            IF(LDIP) THEN
              IF(PARENT .AND. .NOT.TCLUST) THEN
                WRITE(6,*)
     $                'WARNING: DIPOLE MOMENT IN REAL SPACE WITH PBC'
              ENDIF
              CALL RSDIPO(TAU0,EIROP,PSI,RHOE)
            ENDIF
          ELSE
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
      CALL ALIGNX(16,PSI(1))
      CALL ALIGNX(16,RHOE(1))
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
!$OMP parallel do private(IR)
            DO IR=1,NNR1
              PSI(IR)=DCMPLX(RHOE(IR),0.D0)
            ENDDO
            CALL FWFFT(PSI)
            IF(LDIP) CALL DIPO(TAU0,EIROP,PSI)
            IF(LOCD) CALL LODIPO(EIROP,PSI)
          ENDIF
        ENDIF
        IF(PARENT) CALL PRDIP
        CALL FREEM(IP_RHOE)
        CALL FREEM(IP_PSI)
        CALL FREEM(IP_EIROP)
        CALL FREEM(IP_SCR)
      ENDIF
C     ==--------------------------------------------------------------==
C     == Calculates conductivity                                      ==
C     ==--------------------------------------------------------------==
      IF(TCONDUCT) THEN
        CALL CONDUCTIVITY(C0,EIGV,F,N,NKPNT)
        IF(PARENT) THEN  ! cmb
        WRITE(6,'(A)')
     &       ' CONDUCTIVITIES(OHM^-1.CM^-1)  VERSUS FREQUENCY(EV):'
        DO I=1,NCONDUCT
          WRITE(6,'(1X,F10.3,5X,2(1PE18.5),5X,I8)')
     &         (DBLE(I-1)+0.5D0)*CONDSTEP,CONDUCT(I),
     &         CONDUCT2(I)-CONDUCT(I)**2,NORMCON(I)
        ENDDO
        ENDIF ! cmb
      ENDIF
C     ==--------------------------------------------------------------==
C     == Calculates polarisability                                    ==
C     ==--------------------------------------------------------------==
      IF(TPOLARB) THEN
C       SCR creation
        CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
        CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
        CALL GIVE_SCR_POLARPROJ(LPOLARPROJ,TAG,N)
        CALL GIVE_SCR_RHOOFR(LRHO,TAG)
        CALL GIVE_SCR_VOFRHO(LVOFRHO,TAG)
        LSCR=MAX(LPOLARPROJ,LRHO,LVOFRHO)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
        CALL PHFAC(TAU0)
C       Compute electronic density in real space
        IF(TKPNT) THEN
          CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,N)
        ELSE
          CALL RHOOFR  (C0,RHOE,PSI,SCR,LSCR,N)
        ENDIF
C       Calculate Potential
        CALL VOFRHO(TAU0,FION,RHOE,PSI,SCR,LSCR,.FALSE.,.FALSE.)
C       Calculate polarisability
        CALL POLARPROJ(C0,EIGV,F,AMU,RHOE,PSI,SCR,LSCR,N,NKPNT)
        CALL FREEM(IP_RHOE)
        CALL FREEM(IP_PSI)
        CALL FREEM(IP_SCR)
      ENDIF
C     ==--------------------------------------------------------------==
C     == Calculates core optical spectra                              ==
C     ==--------------------------------------------------------------==
      IF(TCORES) THEN
        CALL PHFAC(TAU0)
        CALL CORE_SPECTRA(TAU0,C0,EIGV,F,N,NKPNT)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  LOCALIZE WAVEFUNCTION                                       ==
C     ==--------------------------------------------------------------==
      IF(LOCL) THEN
        TWANN=.TRUE.
        CALL GIVE_SCR_DDIPO(LSCR,TAG)
        LSCR=MAX(LSCR,2*NHG)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
#ifdef PARALLEL
        LENBK=NXXFUN(N)
        NXX=MAX(2*LENBK*NPROC,2*NGWK*N)
#else
        NXX=2*NGWK*N
#endif
        CALL MEMORY(IP_SC0,NXX,'SC0')
        CALL PHFAC(TAU0)
        CALL LOCALIZE(TAU0,C0,CS,SC0,SCR,LSCR,N)
        CALL WRITE_IREC(IREC)
        IREC(IREC_PWV) = ISETONE(.FALSE.)
        CALL FREEM(IP_SC0)
        CALL FREEM(IP_SCR)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  PROJECT WAVEFUNCTIONS ON AO                                 ==
C     ==--------------------------------------------------------------==
      IF(PWFN) THEN
C       Orthogonalize
        CALL PHFAC(TAU0)
        CALL GIVE_SCR_ORTHO(LO,TAG,NUMORB)
        LR=1
        IF(TIVAN) CALL GIVE_SCR_RNLSM(LR,TAG,NUMORB,.FALSE.)
        LSCR=MAX(LO,LR)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
        IF(TIVAN) THEN
          IL_PSI=1
          CALL RNLSM(C0,NUMORB,DUMMY,SCR,LSCR,1,1,.FALSE.)
        ENDIF
        CALL ORTHO(NUMORB,C0,CS,SCR,LSCR)
        CALL FREEM(IP_SCR)
C       Project wfn
        IF(TKPNT) CALL STOPGM('PROWFN','K-POINTS NOT IMPLEMENTED') 
         IF (.NOT.TDMAL) THEN
           CALL PROWFN(C0,TAU0,NUMORB)
         ELSE
           CALL DIST_PROWFN(C0,TAU0,NUMORB)
         ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  PROJECT WAVEFUNCTIONS ON  SPHERICAL HARMONICS               ==
C     ==--------------------------------------------------------------==
      IF(PYLM) THEN
        LR=1
        CALL GIVE_SCR_ORTHO(LO,TAG,NUMORB)
        LSCR=MAX(LO,LR)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
        CALL ORTHO(NUMORB,C0,CS,SCR,LSCR)
        CALL FREEM(IP_SCR)
        CALL PROYLM(C0,CENTYLM,NUMYLM,NUMORB,RYLMAX,NYLMAX)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  CALCULATE LAYER PROJECTED DENSITY OF STATES                 ==
C     ==--------------------------------------------------------------==
      IF(TLDOS) THEN
        CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
        CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
        CALL GIVE_SCR_LDOS(LSCR,TAG)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
        CALL PHFAC(TAU0)
        CALL LDOS(C0,PSI,EIGV,SCR,LSCR,N)
      ENDIF
      IF(TAVGP) THEN
        CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
        CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
        CALL GIVE_SCR_RHOOFR(LRHO,TAG)
        CALL GIVE_SCR_AVGP(LAVGP,TAG)
        LSCR=MAX(LRHO,LAVGP)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
        CALL GET_ADDR(IP_VTEMP,SCR(1))
        CALL GET_ADDR(IP_QPHI,SCR(2*NHG+1))
        CALL MEMORY(IP_EIROP,2*NHG,'EIROP')
        CALL MEMORY(IP_EIVPS,2*NHG,'EIVPS')
C        Compute electronic density in real space
        CALL PHFAC(TAU0)
        IF(TIVAN) THEN
          CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.FALSE.)
        ENDIF
        IF(TKPNT) THEN
          CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,N)
       ELSE
          CALL RHOOFR  (C0,RHOE,PSI,SCR,LSCR,N)
        ENDIF
        CALL MEMORY(IP_ACHRG,NAT+1,'ACHRG')
        CALL MEMORY(IP_ICHRG,NAT+1,'ICHRG')
        CALL AZZERO(ACHRG,NAT+1)
        CALL AZZERO(ICHRG,NAT+1)
        CALL EICALC(EIVPS,EIROP)
        DO I=1,NNR1
          PSI(I)=DCMPLX(RHOE(I),0.D0)
        ENDDO
        CALL FWFFT(PSI)
        DO IG=1,NHG
          VTEMP(IG) = PSI(NZH(IG))
        ENDDO
        CALL ELSTPO(VTEMP,EIROP,EIVPS,PSI,QPHI,TAU0)
        CALL DCOPY(2*NHG,PSI,1,VTEMP,1)
        IF(RHOOUT) THEN
         FILEN='ELECT_POT'
         CALL DENSTO(VTEMP,TAU0,FILEN)
        ENDIF
#ifdef _BGL 
        CALL AZZERO(PSI,2*MAXFFT)
#else
        CALL ZAZZERO(PSI,MAXFFT)
#endif
#ifdef _BGL 
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
        DO IG=1,NHG
          PSI(INDZ(IG)) = DCONJG(VTEMP(IG))
          PSI(NZH(IG))  = VTEMP(IG)
        ENDDO
        IF(GEQ0.AND.TCLUST) THEN
          PSI(NZH(1)) = VTEMP(1)
        ELSEIF(GEQ0) THEN
          PSI(NZH(1)) = DCMPLX(0.D0,0.D0)
        ENDIF
        CALL INVFFT(PSI)
#ifdef _BGL 
        CALL ALIGNX(16,RHOE(1))
        CALL ALIGNX(16,PSI(1))
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
        DO I=1,NNR1
          RHOE(I)=DREAL(PSI(I))
        ENDDO
        CALL POTMED(RHOE,RCUT,TAU0,ACHRG,ICHRG)
        IF(PARENT) THEN
          CALL PRINTPOT(TAU0,ACHRG)
        ENDIF
        IF(PARENT) CALL PRMEM('    PROPPT')
        CALL FREEM(IP_ACHRG)
        CALL FREEM(IP_ICHRG)
        CALL FREEM(IP_SCR)
        CALL FREEM(IP_PSI)
        CALL FREEM(IP_RHOE)
        CALL FREEM(IP_EIVPS)
        CALL FREEM(IP_EIROP)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  CALCULATE ATOMIC CHARGES                                    ==
C     ==--------------------------------------------------------------==
      IF(ESPC) THEN
C       SCR creation
        CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
        CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
        CALL GIVE_SCR_RHOOFR(LRHO,TAG)
        CALL GIVE_SCR_ESPC(LESP,TAG)
        LSCR=MAX(LRHO,LESP)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
        CALL GET_ADDR(IP_VTEMP,SCR(1))
        CALL GET_ADDR(IP_QPHI,SCR(2*NHG+1))
        CALL MEMORY(IP_EIROP,2*NHG,'EIROP')
        CALL MEMORY(IP_EIVPS,2*NHG,'EIVPS')
C       Compute electronic density in real space
        CALL PHFAC(TAU0)
        IF(TIVAN) THEN
          CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.FALSE.)
        ENDIF
        IF(TKPNT) THEN
          CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,N)
          CALL STOPGM('PROPPT','k-points not implemented')
        ELSE
          CALL RHOOFR  (C0,RHOE,PSI,SCR,LSCR,N)
        ENDIF
        CALL MEMORY(IP_ACHRG,NAT+1,'ACHRG')
        CALL MEMORY(IP_ECHRG,NAT+1,'ECHRG')
        CALL EICALC(EIVPS,EIROP)
        CALL GET_ADDR(IP_VR,PSI)
        CALL ATOMC(RHOE,VR,TAU0,ACHRG)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
        CALL ALIGNX(16,RHOE(1))
        CALL ALIGNX(16,PSI(1))
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
!$OMP parallel do private(I)
#endif
        DO I=1,NNR1
          PSI(I)=DCMPLX(RHOE(I),0.D0)
        ENDDO
        CALL FWFFT(PSI)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
!$OMP parallel do private(IG)
        DO IG=1,NHG
          VTEMP(IG) = PSI(NZH(IG))
        ENDDO
        CALL ELSTPO(VTEMP,EIROP,EIVPS,PSI,QPHI,TAU0)
        CALL DCOPY(2*NHG,PSI,1,VTEMP,1)
#ifdef _BGL 
        CALL AZZERO(PSI,2*MAXFFT)
#else
        CALL ZAZZERO(PSI,MAXFFT)
#endif
!CDIR NODEP
#ifdef _BGL 
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
        DO IG=1,NHG
          PSI(INDZ(IG)) = DCONJG(VTEMP(IG))
          PSI(NZH(IG))  = VTEMP(IG)
        ENDDO
        IF(GEQ0.AND.TCLUST) THEN
          PSI(NZH(1)) = VTEMP(1)
        ELSEIF(GEQ0) THEN
          PSI(NZH(1)) = DCMPLX(0.D0,0.D0)
        ENDIF
        CALL INVFFT(PSI)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
        CALL ALIGNX(16,RHOE(1))
        CALL ALIGNX(16,PSI(1))
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
!$OMP parallel do private(I)
        DO I=1,NNR1
          RHOE(I)=DREAL(PSI(I))
        ENDDO
        MLEN=NNR1/IRAT + 1
        CALL MEMORY(IP_ISEL,MLEN,'ISEL')
        IPPC=0
        CALL SELECTP(ISEL,TAU0,IPPC)
        MLEN=(NAT+1)*IPPC
        CALL MEMORY(IP_EFIELD,MLEN,'EFIELD')
        DO I=1,IPPC
          EFIELD(I)=RHOE(ISEL(I))
        ENDDO
        CALL ATFIELD(EFIELD,PSI,VTEMP,EIROP,QPHI,ISEL,IPPC)
        CALL ESPSOLV(EFIELD,ECHRG,IPPC)
        IF(PARENT) CALL PRMEM('    PROPPT')
        IF(PARENT) CALL PRINTCG(TAU0,ACHRG,ECHRG)
        CALL FREEM(IP_ACHRG)
        CALL FREEM(IP_ECHRG)
        CALL FREEM(IP_SCR)
        CALL FREEM(IP_ISEL)
        CALL FREEM(IP_EFIELD)
        CALL FREEM(IP_PSI)
        CALL FREEM(IP_RHOE)
        CALL FREEM(IP_EIVPS)
        CALL FREEM(IP_EIROP)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  LOCALIZE WAVEFUNCTION                                       ==
C     ==--------------------------------------------------------------==
      IF(GLOCL) THEN
        TGLOC=.true.
        CALL GIVE_SCR_GLOCALIZE(LSCR,TAG,NSTATE)
        LSCR=MAX(LSCR,2*NHG)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
        CALL PHFAC(TAU0)
c      CALL PRINT_MEMORY

        IF(TG_REAL) THEN         
          CALL FREEM(IP_CS)
          NC = 2*2*NGW*NSTATE
#ifdef PARALLEL
          LENBK=NXXFUN(NUMORB)
          NC=MAX(2*2*LENBK*NPROC,NC)
#endif
          CALL MEMORY(IP_CS,NC,'CS')
          CALL G_LOC_DR_REAL(C0,CS,SCR,LSCR,NSTATE,EIGV,TAU0,TAUP,NFI)
        ELSE
#ifdef PARALLEL
          NC = 2*2*NGW*NSTATE
          LENBK=NXXFUN(NUMORB)
c          write(6,*) MEPOS,LENBK,2*2*LENBK*NPROC,NC
          NC=MAX(2*2*LENBK*NPROC,NC)
          CALL FREEM(IP_CS)
          CALL MEMORY(IP_CS,NC,'CS')
#endif
c          STOP 'NC'
          CALL G_LOC_DR_COMP(C0,CS,SCR,LSCR,NSTATE,EIGV,TAU0,TAUP,NFI)
        ENDIF

        CALL FREEM(IP_SCR)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  PLOT WAVEFUNCTION                                           ==
C     ==--------------------------------------------------------------==
      IF(TCUBEFILE_DENS.OR.TCUBEFILE_ORB.OR.TCUBEFILE_POT) THEN
        CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
        CALL GIVE_SCR_RHOOFR(LRHO,TAG)
        CALL GIVE_SCR_FORCES(LSCR,TAG,NSTATE,1,.FALSE.)
        LSCR=MAX(IL_RHOE,2*MAXFFT,LRHO,LSCR)
        CALL MEMORY(IP_SCR,LSCR,'SCR')
        CALL AZZERO(   SCR,LSCR)
        CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
        CALL AZZERO(   RHOE,IL_RHOE)
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
        CALL AZZERO(   PSI,IL_PSI)
        CALL MEMORY(IP_Z_11,NSTATE*NSTATE,'Z11')
        CALL AZZERO(   Z_11,NSTATE*NSTATE)
        CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
        CALL AZZERO(FION,3*NAX*NSX)
        CALL MEMORY(IP_EIROP,2*NHGK,'EIROP')
        CALL MEMORY(IP_EIVPS,2*NHGK,'EIVPS')
C     malloc complete.
        CALL PHFAC(TAU0)
        CALL EICALC(EIVPS,EIROP)
C     density?
        IF (NOGRP .GT. 1) THEN
          CALL STOPGM ('PROPPT/CUBEF',
     &                 'Please program the orbital split by yourself')
        ENDIF
C     ==--------------------------------------------------------------==
        IF (TCUBECENTER) THEN
C     use the center from the input 
          CALL DCOPY(3,CUBECIN,1,CUBECENTER,1)
        ELSE
C     calculate the 'geometric' center of the system
C     FIXME: check if proper PBC correction of the ions is done
C            for this kind of center determination.
          CUBECENTER(1) = 0D0
          CUBECENTER(2) = 0D0
          CUBECENTER(3) = 0D0
          NNAT = 0
          DO ISP=1,NSP
            DO IAT=1,NA(ISP)
              CUBECENTER(1) = CUBECENTER(1) + TAU0(1,IAT,ISP)
              CUBECENTER(2) = CUBECENTER(2) + TAU0(2,IAT,ISP)
              CUBECENTER(3) = CUBECENTER(3) + TAU0(3,IAT,ISP)
              NNAT = NNAT + 1
            ENDDO
          ENDDO
          CUBECENTER(1) =  CUBECENTER(1) / DBLE(NNAT)
          CUBECENTER(2) =  CUBECENTER(2) / DBLE(NNAT)
          CUBECENTER(3) =  CUBECENTER(3) / DBLE(NNAT)
        ENDIF
        IF(PARENT)
     &       WRITE(6,'(/,A,3F10.5,A)') ' PROPPT| CUBE CENTER IS AT: ',
     &       (CUBECENTER(I),I=1,3),' BOHR'
C     ==--------------------------------------------------------------==
C     TOTAL DENSITY AND SPIN DENSITY (IF AVAILABLE)
        IF (TCUBEFILE_DENS) THEN
          IF(TKPNT) THEN
C     AK: FIXME: CHECK THIS, COMPARE TO OUTPUT FROM rhopri.F
C     AK: seems like the calls to RNLSM are missing here.
            IF (PARENT) WRITE(0,*)
     &           ' PROPPT| WARNING: CUBEFILES NOT TESTED WITH k-points.'
            CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,N)
          ELSE
            CALL RHOOFR  (C0,RHOE,PSI,SCR,LSCR,N)
          ENDIF
          CUBEFILENAME = 'RHO_TOT.cube'
          CALL XSTRING(CUBEFILENAME,IA,IE)
          IF(PARENT)
     &         WRITE(6,'(A,A)') ' PROPPT| WRITING DENSITY TO: ', 
     &         CUBEFILENAME(IA:IE)
          CALL CUBEFILE(CUBEFILENAME,RHOE,CUBECENTER,PSI,THALFMESH)
          IF (TLSD) THEN
            CALL DAXPY(NNR1,-2.D0,RHOE(1+NNR1),1,RHOE(1),1)
            CUBEFILENAME = 'RHO_SPIN.cube'
            CALL XSTRING(CUBEFILENAME,IA,IE)
            IF(PARENT)
     &           WRITE(6,'(A,A)') ' PROPPT| WRITING SPIN DENSITY TO: ',
     &           CUBEFILENAME(IA:IE)
            CALL CUBEFILE(CUBEFILENAME,RHOE,
     &                    CUBECENTER,PSI,THALFMESH)
          ENDIF
        ENDIF
C     ==--------------------------------------------------------------==
C     orbitals?
        IF (TCUBEFILE_ORB) THEN
          CALL LAG_MULT(c0,cs,psi,scr,lscr,rhoe,z_11,nstate)
          IF (TLSD) THEN
            DO I=1,NUM_CUBEORB
              J = NSUP - ICUBEORB(I) + 1
              if (J .GE. 1) THEN
                call fftTOr(c0(1,J),scr(1), psi,ngw,.TRUE.)
                write (CUBEfilename,'(A6,I3.3,A5)') 
     &                 'PSI_A.',ICUBEORB(I),'.cube'
                call cubefile(CUBEfilename,scr,CUBEcenter,psi,thalfmesh)
              ENDIF
              J = NSDOWN - ICUBEORB(I) + 1
              if (J .GE. 1) THEN
                call fftTOr(c0(1,J+NSUP),scr(1), psi,ngw,.TRUE.)
                write (CUBEfilename,'(A6,I3.3,A5)') 
     &                 'PSI_B.',ICUBEORB(I),'.cube'
                call cubefile(CUBEfilename,scr,CUBEcenter,psi,thalfmesh)
              ENDIF
            END DO
          ELSE ! LDA
            DO I=1,NUM_CUBEORB
              j = nstate - ICUBEORB(I) + 1
              if (J .LT. 1) then
                IF(PARENT)
     &                print *,'NOT MORE THAN NSTATE!!!'
              else
              call fftTOr(c0(1,J),
     &                    scr,psi,ngw,.TRUE.)
              write (CUBEfilename,'(A4,I3.3,A5)') 
     &               'PSI.',ICUBEORB(i),'.cube'
              call cubefile(CUBEfilename,scr,CUBEcenter,psi,thalfmesh)
              ENDIF
            END DO
          ENDIF
        ENDIF
        IF (TCUBEFILE_POT) THEN
          CALL RSCPOT(C0,TAU0,FION,RHOE,PSI,SCR,LSCR,
     &                  .false.,.false.,N,NKPNT)
          write (CUBEfilename,'(A)')  'V_Hxc.cube'
          call cubefile(CUBEfilename,rhoe,CUBEcenter,psi,thalfmesh)
        ENDIF
        CALL FREEM(IP_EIVPS)
        CALL FREEM(IP_EIROP)
        CALL FREEM(IP_FION)
        CALL FREEM(IP_Z_11)
        CALL FREEM(IP_PSI)
        CALL FREEM(IP_RHOE)
        CALL FREEM(IP_SCR)
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TMEMCHK) CALL PRINT_MEMORY
      CALL FREEM(IP_C0)
      CALL FREEM(IP_CS)
      CALL FREEM(IP_TAUP)
      CALL FNLDEALLOC(.FALSE.,.FALSE.)
C     ==--------------------------------------------------------------==
      call mm_dim(mm_revert,OLDSTATUS)
      RETURN
      END
C     ==================================================================
      SUBROUTINE PROPIN(TINFO)
C     ==--------------------------------------------------------------==
C     ==  THIS ROUTINE READS THE SECTION &PROP &END ON UNIT IUNIT     ==
C     ==  Input:                                                      ==
C     ==  TINFO  =.TRUE.  section reads at the beginning of CPMD      ==
C     ==                  read only                                   ==
C     ==          .FALSE. initialize too                              ==
C     ==  Output: .TRUE. a property has to be calculated              ==
C     ==--------------------------------------------------------------==
C     ==  THE INPUT HAS TO BE IN THE FOLLOWING FORMAT                 ==
C     ==     &PROP                                                    ==
C     ==        Options                                               ==
C     ==     &END                                                     ==
C     ==--------------------------------------------------------------==
C     ==  LIST OF OPTIONS                                             ==
C     ==                                                              ==
C     ==   PROJECT WAVEFUNCTIONS                                      ==
C     ==   PROJECT HARMONICS [RADIAL] [SPREAD]                        ==
C     ==      NUMBER OF HARMONICS, CENTER                             == 
C     ==      [RMAX, NMAX]                                            ==
C     ==      [SPREAD_MIN, SPREAD_MAX]                                ==
C     ==--------------------------------------------------------------==
C     ==    POPULATION ANALYSIS [MULLIKEN,DAVIDSON][n-CENTER]         ==
C     ==     no1 ... nox                                              ==
C     ==    n-CENTER CUTOFF                                           ==
C     ==       cutoff                                                 ==
C     ==    CHARGES [PARA, HYPER]                                     ==
C     ==    OPTIMIZE SLATER EXPONENTS                                 ==
C     ==    LOCALIZE                                                  ==
C     ==    NOPRINT {ORBITALS}                                        ==
C     ==    DIPOLE MOMENT {BERRY,RS}                                  ==
CIF   ==    LOCAL DIPOLE                                              ==
CIF   ==      numbld                                                  ==
CIF   ==      xminld(1) yminld(1) zminld(1)                           ==
CIF   ==      xmaxld(1) ymaxld(1) zmaxld(1)                           ==
CIF   ==      ...                                                     ==
CIF   ==      xminld(numbld) yminld(numbld) zminld(numbld)            ==
CIF   ==      xmaxld(numbld) ymaxld(numbld) zmaxld(numbld)            ==
C     ==    EXCITED DIPOLE                                            ==
C     ==      nexdip numorb                                           ==
C     ==      n1 n2 n3 ... nx                                         ==
C     ==      ...                                                     ==
C     ==      n1 n2 n3 ... nx                                         ==
C     ==    TRANSTION MOMENT                                          ==
C     ==      ntrmom                                                  ==
C     ==      ns1 ns2                                                 ==
C     ==      ...                                                     ==
C     ==    CONDUCTIVITY                                              ==
C     ==      iconduct [STEP=condstep]                                ==
C     ==    POLARISABILITY                                            ==
C     ==      ipolarise                                               ==
C     ==    CORE SPECTRA                                              ==
C     ==      core_atom core_level                                    ==
C     ==      core_nqsto core_lshell core_stoexp                      ==
C     ==    LDOS                                                      ==
C     ==    CUBECENTER                                                ==
C     ==      cubecin(1) cubecin(2),cubecin(3)                        ==
C     ==    CUBEFILE {POTENTIAL|ORBITALS|DENSITY} [HALFMESH]          ==
C     ==      numorb               [for ORBITALS]                     ==
C     ==      n1 n2 n3 n4                                             ==
C     ==    GLOCALIZE                                                 ==
C     ==    EPR                                                       ==
C     ==    EFG                                                       ==
C     ==    AVERAGED POTENTIAL                                        ==       
C     ==                                                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'prop.inc'
      INCLUDE 'lodp.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'condu.inc'
      INCLUDE 'pola.inc' 
      INCLUDE 'ldos.inc' 
      INCLUDE 'cnst.inc' 
      INCLUDE 'g_loc.inc'
      INCLUDE 'cores.inc' ! cmb-ike
      INCLUDE 'wann.inc' ! wannier ordered spread hamiltonian  
C     Arguments
      LOGICAL   TINFO
C     Variables
      INTEGER   IUNK,MAXUNKNOWN
      PARAMETER (MAXUNKNOWN=30)
      CHARACTER*80 LINE,LINEOLD,UNKNOWN(MAXUNKNOWN)
      INTEGER   IUNIT,I,IERR,II,J,IS,IOUT,
     &          INSCAN,IA,IE
      LOGICAL   TSTART,ERREAD
      DIMENSION IST_LIST(NST_LIST)
#ifdef PARALLEL
      INTEGER MSGLEN
#endif
C     ==--------------------------------------------------------------==
C     ==  DEFAULTS                                                    ==
C     ==--------------------------------------------------------------==
      IUNK=0
      TSTART=TINFO
      IUNIT=INSYS
      PWFN=.FALSE.
      WFR1=.FALSE.
      WFR2=.FALSE.
      WFR3=.FALSE.
      COR1=.FALSE.
      COR2=.FALSE.
      ABAS=.FALSE.
      CEIG=.FALSE.
      LOCL=.FALSE.
      LDIP=.FALSE.
      LOCD=.FALSE.
      LEXT=.FALSE.
      LTRM=.FALSE.
      LRSDIP=.FALSE.
      PRTO=.TRUE.
      OPTS=.FALSE.
      MPAN=.FALSE.
      DPAN=.FALSE.
      TINFO=.FALSE.
      ESPC=.FALSE.
      ELDISP=.FALSE.
      GLOCL =.FALSE.
      DBERRY =.FALSE.
      STATE_ALL  =.FALSE.
      STATE_RANGE=.FALSE.
      STATE_LIST =.FALSE.
      TCORES=.FALSE. ! cmb-ike
      TAVGP=.FALSE.
      PYLM=.FALSE.
C     ==--------------------------------------------------------------==
C     Options which could be calculated during simulations
      NFCONDUCT=0
      CONDSTEP=0.5D0
      NCONDUCT=40
      IF(TSTART) THEN
       TCONDUCT=.FALSE.
       TPOLARB =.FALSE.
       ICONDUCT=1
       IPOLARISE=1 
      ENDIF
C     ==--------------------------------------------------------------==
      TCUBEFILE_POT  = .FALSE.
      TCUBEFILE_ORB  = .FALSE.
      TCUBEFILE_DENS = .FALSE.
      THALFMESH      = .FALSE.
      TCUBECENTER    = .FALSE.
      TEPREFG        = .FALSE.
      TEFG           = .FALSE.
C     ==--------------------------------------------------------------==
      NCEN=2
      NEXDIP=0
      NTRMOM=0
      CUT3O=0.05D0
      CUT4O=0.01D0
      NUMORB=0
      NUMBLD=0
      CALL AZZERO(CUBECIN,3)
!$OMP parallel do private(I)
      DO I=1,NMAXLD
        XMINLD(I)=0
        YMINLD(I)=0
        ZMINLD(I)=0
        XMAXLD(I)=0
        YMAXLD(I)=0
        ZMAXLD(I)=0
      ENDDO
      IF(PARENT) THEN
C       ==------------------------------------------------------------==
        IERR=INSCAN(IUNIT,'&PROP')
        IF(IERR.NE.0) GOTO 100
C       ==------------------------------------------------------------==
C       Goto to read file and for property calculated during simulation
        GOTO 20
 10     CONTINUE
C       One property at the end  is calculated (to inform PROPPT)
        TINFO=.TRUE.
 20     CONTINUE
        READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
        IF(INDEX(LINE,'&END').NE.0) GOTO 100
        IF(INDEX(LINE,'PROJ').NE.0 .AND. INDEX(LINE,'WAVEFU').NE.0) THEN
C         Project wavefunctions
          PWFN=.TRUE.
          GOTO 10
       ELSE IF(INDEX(LINE,'PROJ').NE.0 .AND. INDEX(LINE,'HARMON').NE.0)
     &         THEN
C         Project wavefunction on spherical harmonics
          PYLM=.TRUE.
          RADIAL=.FALSE.
          IF(INDEX(LINE,'RADIAL').NE.0)THEN
             RADIAL=.TRUE.
          ENDIF
          SPREAD_HAM=.FALSE.
          IF(INDEX(LINE,'SPREAD').NE.0)THEN
             SPREAD_HAM=.TRUE.
          ENDIF          
          READ(IUNIT,ERR=99,END=99,FMT=*) NUMYLM,
     &         CENTYLM(1),CENTYLM(2),CENTYLM(3)
          IF(RADIAL)THEN
             READ(IUNIT,ERR=99,END=99,FMT=*) RYLMAX, NYLMAX
          ENDIF
          IF(SPREAD_HAM)THEN
             READ(IUNIT,ERR=99,END=99,FMT=*) SPR_MIN, SPR_MAX 
          ENDIF          
          GOTO 10
        ELSE IF (INDEX(LINE,'CHARGES').NE.0) THEN
          LFIT=0
          IF(INDEX(LINE,'PARA').NE.0) THEN
           LFIT=1
          ELSEIF(INDEX(LINE,'HYPER').NE.0) THEN
           LFIT=2
          ENDIF
C..calculate atomic charges
          ESPC=.TRUE.
          GOTO 10
        ELSE IF (INDEX(LINE,'AVER').NE.0 .AND.
     *           INDEX(LINE,'POTEN').NE.0) THEN
C..calculate averaged potential
          READ(IUNIT,ERR=99,END=99,FMT=*) RCUT
          TAVGP=.TRUE.
          GOTO 10
        ELSE IF(INDEX(LINE,'DIPOL').NE.0) THEN
C         Dipole moments
          IF(INDEX(LINE,'MOMEN').NE.0) THEN
            LDIP=.TRUE.
            IF(INDEX(LINE,'RS').NE.0) LRSDIP=.TRUE.
            IF(INDEX(LINE,'BERRY').NE.0) THEN
              LDIP=.FALSE.
              DBERRY=.TRUE.
            ENDIF
          ELSE IF(INDEX(LINE,'BERRY').NE.0) THEN
            DBERRY=.TRUE.
          ELSE IF(INDEX(LINE,'LOCAL').NE.0) THEN
            LOCD=.TRUE.
            READ(IUNIT,ERR=99,END=99,FMT=*) NUMBLD
            IF(NUMBLD.GT.NMAXLD) THEN
              NUMBLD=NMAXLD
              WRITE(6,*) ' MAXIMUM NUMBER OF LOCAL DIPOLE ',
     *                   'MOMENTS IS ',NMAXLD
            ENDIF
            DO I=1,NUMBLD
              READ(IUNIT,ERR=99,END=99,FMT=*)
     *          XMINLD(I),YMINLD(I),ZMINLD(I),
     *          XMAXLD(I),YMAXLD(I),ZMAXLD(I)
              IF(.NOT.BOHR) THEN
                XMINLD(I) = XMINLD(I)*FBOHR
                YMINLD(I) = YMINLD(I)*FBOHR
                ZMINLD(I) = ZMINLD(I)*FBOHR
                XMAXLD(I) = XMAXLD(I)*FBOHR
                YMAXLD(I) = YMAXLD(I)*FBOHR
                ZMAXLD(I) = ZMAXLD(I)*FBOHR
              ENDIF
            ENDDO
          ENDIF
          IF(INDEX(LINE,'EXCIT').NE.0) THEN
            LEXT=.TRUE.
            READ(IUNIT,ERR=99,END=99,FMT=*) NEXDIP,NUMORB
            CALL MEMORY(IP_FOCC,NEXDIP*NUMORB,'FOCC')
            CALL MEMORY(IP_EXD,3*NEXDIP*NMAXLD,'EXD')
            DO I=1,NEXDIP
              II=(I-1)*NUMORB
              READ(IUNIT,ERR=99,END=99,FMT=*) (FOCC(J+II),J=1,NUMORB)
            ENDDO
          ENDIF
          GOTO 10
        ELSE IF(INDEX(LINE,'TRANSIT').NE.0 .AND.
     *           INDEX(LINE,'MOMEN').NE.0) THEN
          LTRM=.TRUE.
          READ(IUNIT,ERR=99,END=99,FMT=*) NTRMOM
          CALL MEMORY(IP_NSDIP,2*NTRMOM,'NSDIP')
          CALL MEMORY(IP_TRMOM,3*NTRMOM*NMAXLD,'TRMOM')
          DO I=1,NTRMOM
            READ(IUNIT,ERR=99,END=99,FMT=*) (NSDIP(J,I),J=1,2)
          ENDDO
          GOTO 10
        ELSE IF(INDEX(LINE,'POPULATION').NE.0 .AND.
     *           INDEX(LINE,'ANALYSIS').NE.0) THEN
C         Population analysis 
          PWFN=.TRUE.
          IF(INDEX(LINE,'MULLIK').NE.0) MPAN=.TRUE.
          IF(INDEX(LINE,'DAVIDS').NE.0) DPAN=.TRUE.
          IF(INDEX(LINE,'2-CENT').NE.0) NCEN=2
          IF(INDEX(LINE,'3-CENT').NE.0) NCEN=3
          IF(INDEX(LINE,'4-CENT').NE.0) NCEN=4
          IF(DPAN) READ(IUNIT,ERR=99,END=99,FMT=*) (MAOS(IS),IS=1,NSX)
          GOTO 10
        ELSE IF(INDEX(LINE,'3-CENTER').NE.0 .AND.
     *           INDEX(LINE,'CUTOFF').NE.0) THEN
          READ(IUNIT,ERR=99,END=99,FMT=*) CUT3O
          GOTO 10
        ELSE IF(INDEX(LINE,'4-CENTER').NE.0 .AND.
     *           INDEX(LINE,'CUTOFF').NE.0) THEN
          READ(IUNIT,ERR=99,END=99,FMT=*) CUT4O
          GOTO 10
        ELSE IF(INDEX(LINE,'OPT').NE.0 .AND.
     *           INDEX(LINE,'SLA').NE.0 .AND.
     *           INDEX(LINE,'EXP').NE.0) THEN
C         Optimizs Slater exponents
          OPTS=.TRUE.
          GOTO 10
        ELSE IF(INDEX(LINE,'LOCALIZ').NE.0) THEN
C         Localize Orbitals
          LOCL=.TRUE.
          HMAT_SPREAD=.FALSE.
          IF(INDEX(LINE,'WAN_SPREAD').NE.0) THEN
            HMAT_SPREAD=.TRUE.
            READ(IUNIT,ERR=99,END=99,FMT=*) MINSPR 
          ENDIF
          GOTO 10
        ELSE IF(INDEX(LINE,'NOPRINT').NE.0) THEN
C         Print flags 
          IF(INDEX(LINE,'ORBITAL').NE.0) PRTO=.FALSE.
          GOTO 10
C         ==----------------------------------------------------------==
C         Options which could be calculated during simulations
        ELSE IF(INDEX(LINE,'CONDUCT').NE.0) THEN
          IF(TSTART) THEN
            TCONDUCT=.TRUE.
          ELSE
            TCONDUCT=.NOT.TCONDUCT !If already calculated -> False
          ENDIF
C         Calculates conductivity at each iconduct steps.
          READ(IUNIT,ERR=99,END=99,FMT='(A)') LINE
          II=1
          CALL READSI(LINE,II,IOUT,ICONDUCT,ERREAD)
          II=INDEX(LINE,'STEP=')
          IF(II.NE.0) THEN
            CALL READSR(LINE,II+5,IOUT,CONDSTEP,ERREAD)
            IF(CONDSTEP.LE.0.D0) CONDSTEP=0.5D0
          ENDIF
          II=INDEX(LINE,'N=')
          IF(II.NE.0) THEN
            CALL READSI(LINE,II+2,IOUT,NCONDUCT,ERREAD)
            IF(NCONDUCT.LE.0) NCONDUCT=40
          ENDIF
C         We need the eigenvalues (RESTART file)
          CEIG=.TRUE.
          GOTO 10          
C         ==----------------------------------------------------------==
        ELSE IF(INDEX(LINE,'POLARI').NE.0) THEN
C         Calculates polarisability every ipolarise steps 
          READ(IUNIT,ERR=99,END=99,FMT=*) IPOLARISE
          IF(TSTART) THEN
            TPOLARB=.TRUE.
            TZEFF=.TRUE.
          ELSE
            TPOLARB=.NOT.TPOLARB !If already calculated -> False
            TZEFF=.TRUE.
          ENDIF
          CEIG=.TRUE.
          GOTO 10          
cmb-ike   ==----------------------------------------------------------==
        ELSE IF(INDEX(LINE,'CORE').NE.0.AND.
     .           INDEX(LINE,'SPECTRA').NE.0) THEN
C         Calculate core optical spectra
          READ(IUNIT,ERR=99,END=99,FMT=*) CORE_ATOM,CORE_LEVEL
          READ(IUNIT,ERR=99,END=99,FMT=*) CORE_NQSTO,CORE_LSHELL,
     .                                    CORE_STOEXP
          TCORES=.TRUE.
          CEIG=.TRUE.
          GOTO 10
C         ==----------------------------------------------------------==
        ELSE IF(INDEX(LINE,'LDOS').NE.0) THEN
C         Calculates LDOS every steps
          READ(IUNIT,ERR=99,END=99,FMT=*) NLAYER,LDOSN
          TLDOS=.TRUE.
          CEIG=.TRUE.
          GOTO 10
C         ==----------------------------------------------------------==
        ELSE IF(INDEX(LINE,'CUBECENT').NE.0) THEN
C         Sets the center of the cubefile (default is geometric center).
          TCUBECENTER=.TRUE.
          READ(IUNIT,ERR=99,END=99,FMT=*) (CUBECIN(II),II=1,3)
c         Angstrom?
          IF(.NOT.BOHR) THEN
             CALL DSCAL(3,FBOHR,CUBECIN,1)
          ENDIF
          GOTO 10
C         ==----------------------------------------------------------==
        ELSE IF(INDEX(LINE,'CUBEFILE').NE.0) THEN
C         Plots potential, wfns or density as .cube file
          IF (INDEX(LINE,'HALF').NE.0) THALFMESH = .TRUE.
          IF (INDEX(LINE,'POTENTIAL').NE.0) TCUBEFILE_POT = .TRUE.
          IF (INDEX(LINE,'DENSITY').NE.0) TCUBEFILE_DENS = .TRUE.
          IF (INDEX(LINE,'ORBITAL').NE.0) THEN
            TCUBEFILE_ORB = .TRUE.
            READ(IUNIT,ERR=99,END=99,FMT=*) NUM_CUBEORB
            CALL MEMORY(IP_ICUBEORB,NUM_CUBEORB,'ICUBEORB')
            CALL IAZZERO(  ICUBEORB,NUM_CUBEORB)
            READ(IUNIT,ERR=99,END=99,FMT=*) 
     &           (ICUBEORB(II),II=1,NUM_CUBEORB)
          ENDIF
          GOTO 10
C         ==----------------------------------------------------------==
        ELSE IF(INDEX(LINE,'EPR').NE.0) THEN
          IF (TLSD) TEPREFG=.TRUE.
          GOTO 10
C         ==----------------------------------------------------------==
        ELSE IF(INDEX(LINE,'EFG').NE.0) THEN
          TEFG=.TRUE.
          GOTO 10
C         ==----------------------------------------------------------==
        ELSE IF(INDEX(LINE,'G_SPACE_LOC').NE.0) THEN
C         Localize Orbitals in Reciprocal space
          GLOCL=.TRUE.
c          IF(INDEX(LINE,'CONJ_GRAD').NE.0) THEN
c          TCGRAD = .TRUE.
c          ENDIF
          IF(INDEX(LINE,'ALL').NE.0) THEN
            STATE_ALL   = .TRUE.
            STATE_RANGE = .FALSE.
            STATE_LIST  = .FALSE.
          ELSEIF(INDEX(LINE,'PART').NE.0) THEN
            STATE_ALL   = .FALSE.
            STATE_RANGE = .TRUE.
            STATE_LIST  = .FALSE.
            LINEOLD=LINE
            READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
            IA=1
            CALL READSI(LINE,IA,IE,IST_FIRST,ERREAD)
            IF(ERREAD) GOTO 99
            IA=IE
            CALL READSI(LINE,IA,IE,IST_LAST,ERREAD)
            IF(ERREAD) GOTO 99
          ELSEIF(INDEX(LINE,'LIST').NE.0)  THEN
            STATE_ALL   = .FALSE.
            STATE_RANGE = .FALSE.
            STATE_LIST  = .TRUE.
            LINEOLD=LINE
            READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
            CALL READSI(LINE,1,IE,NST_LIST,ERREAD)
            IF(ERREAD) GOTO 99
            CALL MEMORY(IP_IST_LIST,NST_LIST/IRAT+1,'IST_LIST')
C           We can use more than one line
            READ(IUNIT,ERR=99,END=99,FMT=*) (IST_LIST(I),I=1,NST_LIST)
          ELSE
            STATE_ALL   = .TRUE.
            STATE_RANGE = .FALSE.
            STATE_LIST  = .FALSE.
          ENDIF
          GOTO 10
C         ==----------------------------------------------------------==
        ELSE 
C         Unknown Keyword. store and continue
          IF(' '.NE.LINE) THEN
            IF(IUNK.LT.MAXUNKNOWN) THEN
              IUNK=IUNK+1
              UNKNOWN(IUNK)=LINE
            ELSE
              DO I=1,MAXUNKNOWN-1
                UNKNOWN(I)=UNKNOWN(I+1)
              ENDDO
              UNKNOWN(IUNK)=LINE
            ENDIF
          ENDIF
          GOTO 20
        ENDIF
C       ==------------------------------------------------------------==
 99     CONTINUE
        WRITE(6,*) ' PROPIN  : ERROR IN READING INPUT FILE'
        WRITE(6,*) ' THE LAST TWO LINES READ WERE '
        CALL XSTRING(LINEOLD,IA,IE)
        WRITE(6,*) LINEOLD(1:IE)
        CALL XSTRING(LINE,   IA,IE)
        WRITE(6,*) LINE(1:IE)
        CALL STOPGM('PROPIN',' ')
C       ==------------------------------------------------------------==
 100    CONTINUE
C       ==------------------------------------------------------------==
C       ==  Stop if TSTART=.true. (input reads before all calculation)==
C       ==------------------------------------------------------------==
        IF(TSTART) THEN
          GOTO 9999
        ENDIF
C     ==--------------------------------------------------------------==
C     ==  WRITE INFO TO OUTPUT                                        ==
C     ==--------------------------------------------------------------==
        WRITE(6,*)
        WRITE(6,'(A,/)') ' ACTIVE FLAGS FOR PROPERTIES RUN:'
        IF(CEIG) WRITE(6,'(A)') 
     *       ' READ EIGENVALUES FROM FILE RESTART'
        IF(PWFN) WRITE(6,'(A)') 
     *       ' PROJECT WAVEFUNCTIONS ON ATOMIC PSEUDO-WAVEFUNCTIONS'
        IF(PYLM) WRITE(6,'(A)') 
     *       ' PROJECT WAVEFUNCTIONS ON SPHERICAL HARMONICS'
        IF(MPAN) WRITE(6,'(A)')
     *       ' MULLIKEN POPULATION ANALYSIS AND MAYER BOND-ORDERS'
        IF(DPAN) THEN
          WRITE(6,'(A,/,A)') ' DAVIDSON POPULATION ANALYSIS',
     *         '           C.Erhardt and R.Ahlrichs, TCA 68:231 (1985)'
          WRITE(6,'(A,I3)') 
     *         '           HIGHEST N-CENTER TERMS INCLUDED : ',NCEN
        ENDIF
        IF(ESPC) WRITE(6,'(A,/,A,/,A)')
     *         ' CALCULATE ATOMIC CHARGES FROM ',
     *         '     REAL SPACE INTEGRATION AND ',
     *         '     DERIVED FROM ELECTROSTATIC POTENTIAL '
        IF(ESPC.AND.LFIT.EQ.0) WRITE(6,'(A)') ' STANDARD METHOD '                
        IF(ESPC.AND.LFIT.EQ.1) WRITE(6,'(A)') ' PARABOLIC RESTRAIN '              
        IF(ESPC.AND.LFIT.EQ.2) WRITE(6,'(A)') ' HYPERBOLIC RESTRAIN '             
        IF(LOCL) WRITE(6,'(A)') ' LOCALIZE ORBITALS'
        IF(GLOCL) WRITE(6,'(A)') ' LOCALIZE ORBITALS IN G-SPACE'
        IF(LDIP) THEN
          IF(LRSDIP) THEN
            WRITE(6,'(A)') ' CALCULATE DIPOLE MOMENT IN REAL SPACE'
          ELSE
            WRITE(6,'(A)') ' CALCULATE DIPOLE MOMENT '
          ENDIF
        ENDIF
        IF(DBERRY) WRITE(6,'(A,A)') ' CALCULATE DIPOLE MOMENT ',
     *    'USING BERRY PHASE FORMULA'
        IF(LOCD) WRITE(6,'(A)') ' CALCULATE LOCAL DIPOLE MOMENTS '
        IF(LEXT)
     &       WRITE(6,'(A)') ' CALCULATE EXCITED STATE DIPOLE MOMENTS'
        IF(LTRM) WRITE(6,'(A)') ' CALCULATE TRANSITION MOMENTS'
        IF(TCONDUCT) WRITE(6,'(A)') ' CALCULATE CONDUCTIVITY'
        IF(TPOLARB)  WRITE(6,'(A)') ' CALCULATE POLARISABILITY'
        IF(TCORES) THEN ! cmb-ike
          WRITE(6,'(A,/,A,/,A,A,/,A,A)')
     .         ' CALCULATE X-RAY SPECTRA AFTER: ',
     .         '    M. Cavalleri et al. JCP 121, 10065 (2004)',
     .         '    WARNING: IN PRINCIPLE THE METHOD IS VALID',
     .         ' ONLY FOR K-EDGE OF ',
     .         '    THE FIRST ROW ELEMENTS AND REQUIRES',
     .         ' SPECIAL PSEUDOPOTENTIALS !'
        ENDIF ! cmb-ike
        IF(TCUBECENTER) THEN
          WRITE(6,'(A)') ' SET CENTER OF CUBEFILES FROM INPUT'
        ENDIF
        IF(TCUBEFILE_ORB) THEN
           WRITE (6,'(A)') ' PLOTTING CUBEFILES (ORBITALS)'
           WRITE (6,'(15I4)') (ICUBEORB(ii),ii=1,NUM_CUBEORB)
        ENDIF
        IF(TCUBEFILE_DENS) 
     &     WRITE (6,'(A)') ' PLOTTING CUBEFILES (DENSITY)'
        IF(TCUBEFILE_POT) 
     &     WRITE (6,'(A)') ' PLOTTING CUBEFILES (POTENTIAL)'
        WRITE(6,*)
        IF(TAVGP) WRITE(6,'(A,/,A,1F5.2)')
     *         ' CALCULATE AVERAGED ELECTROSTATIC POTENTIAL',
     *         '     AROUND ATOMIC CORES RCUT= ',RCUT
C     ==--------------------------------------------------------------==
      IF(IUNK.NE.0) THEN
        WRITE(6,'(/,1X,64("="))')
        WRITE(6,'(1X,A,14X,A,14X,A)') '= ',
     &    'UNKNOWN KEYWORDS IN SECTION &PROP','='
        DO I=1,IUNK
          LINEOLD=UNKNOWN(I)
          CALL XSTRING(LINEOLD,IA,IE)
          WRITE(6,'(A,A)') ' = ',LINEOLD(IA:IE)
        ENDDO
      WRITE(6,'(1X,64("="),/)')
      ENDIF
C       ==------------------------------------------------------------==
      ENDIF
 9999 CONTINUE
#ifdef PARALLEL
      MSGLEN = IPWFN * 8/IRAT
      CALL MY_BCAST(PWFN,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NEXDIP,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NTRMOM,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TINFO,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NUMORB,MSGLEN,SOURCE,ALLGRP)
#endif
      IF(NEXDIP.NE.0) THEN
        IF(.NOT.PARENT) THEN
          CALL MEMORY(IP_FOCC,NEXDIP*NUMORB,'FOCC')
          CALL MEMORY(IP_EXD,3*NEXDIP*NMAXLD,'EXD')
        ENDIF
#ifdef PARALLEL
        MSGLEN = NEXDIP*NUMORB * 8
        CALL MY_BCAST(FOCC,MSGLEN,SOURCE,ALLGRP)
#endif
      ENDIF
#ifdef PARALLEL
      MSGLEN = (MAXSP + 2) * 8/IRAT
      CALL MY_BCAST(NUMORB,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 2 * 8
      CALL MY_BCAST(CUT3O,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TLDOS,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NLAYER,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(LDOSN,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 6*NMAXLD * 8
      CALL MY_BCAST(XMINLD(1),MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NUMBLD,MSGLEN,SOURCE,ALLGRP)
C
C Maybe we should also broadcast the entries in condu.inc and pola.inc ?
C
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(CEIG,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NCONDUCT,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TCONDUCT,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(CONDSTEP,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TPOLARB,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TZEFF,MSGLEN,SOURCE,ALLGRP)
c-ike
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TCORES,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 3 * 8/IRAT
      CALL MY_BCAST(CORE_ATOM,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 2 * 8
      CALL MY_BCAST(CORE_LEVEL,MSGLEN,SOURCE,ALLGRP)
c-ike
C broadcast the contents of common prop4
      MSGLEN = 3 * 8
      CALL MY_BCAST(CUBECIN,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NUM_CUBEORB,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TCUBECENTER,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(THALFMESH,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TCUBEFILE_ORB,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TCUBEFILE_DENS,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TCUBEFILE_POT,MSGLEN,SOURCE,ALLGRP)

      CALL MY_BCAST(TEPREFG,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TEFG,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(RCUT,MSGLEN,SOURCE,ALLGRP)
#endif
      IF (TCUBEFILE_ORB) THEN
         IF (.NOT. PARENT) THEN
            CALL MEMORY(IP_ICUBEORB,NUM_CUBEORB,'ICUBEORB')
            CALL IAZZERO(  ICUBEORB,NUM_CUBEORB)
         ENDIF
#ifdef PARALLEL
         MSGLEN = NUM_CUBEORB*8/IRAT
         CALL MY_BCAST(ICUBEORB,MSGLEN,SOURCE,ALLGRP)
#endif
      ENDIF
#ifdef PARALLEL
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(GLOCL,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 3 * 8/IRAT
      CALL MY_BCAST(STATE_ALL,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 3 * 8/IRAT
      CALL MY_BCAST(IST_FIRST,MSGLEN,SOURCE,ALLGRP)
      IF(STATE_LIST) THEN
        IF(.NOT.PARENT)
     &     CALL MEMORY(IP_IST_LIST,NST_LIST/IRAT+1,'IST_LIST')
        MSGLEN = NST_LIST * 8/IRAT
        CALL MY_BCAST(IST_LIST,MSGLEN,SOURCE,ALLGRP)
      ENDIF
#endif
      IF(NTRMOM.NE.0) THEN
        IF(.NOT.PARENT) THEN
          CALL MEMORY(IP_NSDIP,2*NTRMOM,'NSDIP')
          CALL MEMORY(IP_TRMOM,3*NTRMOM*NMAXLD,'TRMOM')
        ENDIF
#ifdef PARALLEL
        MSGLEN = NTRMOM*2 * 8/IRAT
        CALL MY_BCAST(NSDIP,MSGLEN,SOURCE,ALLGRP)
#endif
      ENDIF
C     ==--------------PROP7-------------------------------------------==
#ifdef PARALLEL                
        MSGLEN = 3 * 8
        CALL MY_BCAST(CENTYLM,MSGLEN,SOURCE,ALLGRP)      
        MSGLEN = 1 * 8
        CALL MY_BCAST(RYLMAX,MSGLEN,SOURCE,ALLGRP) 
        MSGLEN = 2 * 8
        CALL MY_BCAST(SPR_MIN,MSGLEN,SOURCE,ALLGRP)        
        MSGLEN = 2 * 8/IRAT      
        CALL MY_BCAST(NUMYLM,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 2 * 8/IRAT
        CALL MY_BCAST(RADIAL,MSGLEN,SOURCE,ALLGRP)        
#endif
C     ==---------  WANNIER SPEAD ORDERED HAMILTONIAN -----------------==
#ifdef PARALLEL
       MSGLEN = 1*8
       CALL MY_BCAST(MINSPR,MSGLEN,SOURCE,ALLGRP)      
       MSGLEN = 1*8/IRAT
       CALL MY_BCAST(HMAT_SPREAD,MSGLEN,SOURCE,ALLGRP)      
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PROPCAL(C0,C2,CM,SC0,TAUP,WE,F,AMU,
     &                  VPOT,PSI,SCR,LSCR,NSTATE,NKPOINT,NFI,INFI)
C     ==--------------------------------------------------------------==
C     == THIS ROUTINE CALCULATES PROPERTIES DURING THE SIMULATION     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'condu.inc'
      INCLUDE 'spin.inc'         !NLSD
      INCLUDE 'pola.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'wann.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,NKPOINT,NFI,INFI
      COMPLEX*16 C0(NGWK,NSTATE,NKPOINT),C2(NGWK,*),PSI(NNR1)
      COMPLEX*16 CM(*),SC0(*)
      REAL*8     WE(NSTATE,NKPOINT),F(NSTATE,NKPOINT),AMU,
     &           VPOT(NNR1,NLSD),SCR(LSCR),TAUP(*)
C     Variables
      REAL*8     SAVE_FION(3,NAX,NSX),CENTER(4,NSTATE)
      POINTER    (IP_SAVE_FION,SAVE_FION),(IP_CENTER,CENTER)

      INTEGER    I,J,IA,IE,IAT,IS
      LOGICAL    FERROR
C     ==--------------------------------------------------------------==
C     == DIPOLE MOMENT                                                ==
C     ==--------------------------------------------------------------==
      IF(TDIPD.AND.(MOD(NFI-1,NPDIP).EQ.0)) THEN
        CALL DDIPO(TAUP,C0,CM,C2,SC0,SCR,LSCR,NSTATE)
        IF (TWANN) THEN
           IF (TWMOL.OR.TWDOS) THEN
              CALL MEMORY(IP_SAVE_FION,3*NAX*NSX,'FION')
              CALL MEMORY(IP_CENTER,4*NSTATE,'CENTER')
              CALL DCOPY(4*NSTATE,SCR,1,CENTER,1)
              CALL FORCEDR(C0,C2,SC0,VPOT,PSI,TAUP,SAVE_FION,WE,
     &             SCR,LSCR,NSTATE,1,.FALSE.,.TRUE.)        
              IF (TWMOL) THEN
                 CALL DCOPY(4*NSTATE,CENTER,1,SCR,1)
                 CALL molorb(c0,c2,taup,scr,lscr,nstate)
                 CALL FORCEDR(C0,C2,SC0,VPOT,PSI,TAUP,SAVE_FION,WE,
     &                SCR,LSCR,NSTATE,1,.FALSE.,.TRUE.)
              ENDIF
              IF (TWDOS) CALL WC_DOS(C0,C2,SCR,LSCR,NSTATE)
              CALL FREEM(IP_SAVE_FION)
              CALL FREEM(IP_CENTER)
           ENDIF
           CALL WANNIER_PRINT(NFI,C0,TAUP,NSTATE,PSI,SCR,LSCR)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     == Conductivity                                                 ==
C     ==--------------------------------------------------------------==
      IF(TCONDUCT.AND.
     &     ((MOD(NFI,ICONDUCT).EQ.0).OR.(INFI.EQ.NOMORE))) THEN
        IF(INFI.EQ.1) THEN
          NFCONDUCT=0
          FILECOND='CONDUCTIVITIES'
          CALL FILEOPEN(IUCOND,FILECOND,FO_NEW,FERROR)
          IF(FERROR) THEN
            WRITE(IUCOND,*) NCONDUCT
          ELSE
            CALL FILEOPEN(IUCOND,FILECOND,FO_APP+FO_VERB+FO_MARK,FERROR)
          ENDIF
        ENDIF
        NFCONDUCT=NFCONDUCT+1
        CALL CONDUCTIVITY(C0,WE,F,NSTATE,NKPOINT)
        WRITE(IUCOND,*) 'INFI=',INFI,' NFI=',NFI  
        DO I=1,NCONDUCT
          WRITE(IUCOND,100) (DBLE(I-1)+0.5D0)*CONDSTEP,CONDUCT(I),
     &         CONDUCT2(I)-CONDUCT(I)**2,NORMCON(I)
 100      FORMAT(F7.3,3X,2(1PE14.5),3X,I5)
        ENDDO
        IF(INFI.EQ.NOMORE) CALL FILECLOSE(IUCOND)
      ENDIF
C     ==--------------------------------------------------------------==
C     == Polarisability                                               ==
C     ==--------------------------------------------------------------==
      IF(TPOLARB.AND.
     &     ((MOD(NFI,IPOLARISE).EQ.0).OR.(INFI.EQ.NOMORE))) THEN
        IF(INFI.EQ.1) THEN
          NFPOLAR=0
          FILECOND='POLARISABILITY'
          CALL FILEOPEN(IUPOLA,FILECOND,FO_APP+FO_VERB+FO_MARK,FERROR)
        ENDIF
        NFPOLAR=NFPOLAR+1
        CALL POLARPROJ(C0,WE,F,AMU,
     &                 VPOT,PSI,SCR,LSCR,NSTATE,NKPOINT)
        WRITE(IUPOLA,120) INFI,((ALPHAP(I,J),J=1,3),I=1,3)
        IF(TZEFF) THEN
          WRITE(IUPOLA,'(A)') 'EFFECTIVE CHARGE:'
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
              WRITE(IUPOLA,'(A2,I3/3(3(F11.4,1X)/))')
     &             EL(IATYP(IS)),IAT,
     &             (ZEFF(1,J,IA,IS),J=1,3),
     &             (ZEFF(2,J,IA,IS),J=1,3),
     &             (ZEFF(3,J,IA,IS),J=1,3)
            ENDDO
          ENDDO
        ENDIF
        IF(INFI.EQ.NOMORE) CALL FILECLOSE(IUPOLA)
      ENDIF
 120  FORMAT(I5/'XX:',F14.5,'   XY:',F14.5,'   XZ:',F14.5/
     &          'YX:',F14.5,'   YY:',F14.5,'   YZ:',F14.5/
     &          'ZX:',F14.5,'   ZY:',F14.5,'   ZZ:',F14.5)
      RETURN
      END
C     ==================================================================
      SUBROUTINE PRDIP
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'dipo.inc'
      INCLUDE 'lodp.inc'
C     Variables
      REAL*8  D1,D2,D3,DD
      INTEGER I,IEX,IEXJ,II
C     ==--------------------------------------------------------------==
      IF(LDIP .OR. DBERRY) THEN
        WRITE(6,'(A)') ' DIPOLE MOMENT '
        D1=DMOM(1)
        D2=DMOM(2)
        D3=DMOM(3)
        DD=SQRT(D1*D1+D2*D2+D3*D3)
        WRITE(6,'(3(10X,A),6X,A)') ' X',' Y',' Z',' TOTAL'
        WRITE(6,'(4F12.5,A)') D1,D2,D3,DD,'   atomic units'
        WRITE(6,'(4F12.5,A)') AU_DEB*D1, AU_DEB*D2, AU_DEB*D3,
     &                        AU_DEB*DD,'   Debye'
        WRITE(6,*)
      ENDIF
      IF(LOCD) THEN
        DO I=1,NUMBLD
          WRITE(6,'(A)') ' LOCAL DIPOLE MOMENT '
          WRITE(6,'(A,F8.4,A,F8.4,A)')
     *      ' X = ',XMINLD(I),' - ',XMAXLD(I),' a.u.'
          WRITE(6,'(A,F8.4,A,F8.4,A)')
     *      ' Y = ',YMINLD(I),' - ',YMAXLD(I),' a.u.'
          WRITE(6,'(A,F8.4,A,F8.4,A)')
     *      ' Z = ',ZMINLD(I),' - ',ZMAXLD(I),' a.u.'
          WRITE(6,'(3(A,F8.4))')
     *      ' CENTER OF CHARGE: ',RCC(1,I),' /',
     *      RCC(2,I),' /',RCC(3,I)
          D1=DMOMLO(1,I)
          D2=DMOMLO(2,I)
          D3=DMOMLO(3,I)
          DD=SQRT(D1*D1+D2*D2+D3*D3)
          WRITE(6,'(3(10X,A),6X,A)') ' X',' Y',' Z',' TOTAL'
          WRITE(6,'(4F12.5,A)') D1,D2,D3,DD,'   atomic units'
          WRITE(6,'(4F12.5,A)') AU_DEB*D1, AU_DEB*D2, AU_DEB*D3,
     &                          AU_DEB*DD,'   Debye'
          WRITE(6,*)
        ENDDO
      ENDIF
      IF(LEXT) THEN
        WRITE(6,'(/,A)') ' EXCITED STATE DIPOLE MOMENT DIFFERENCES '
        DO IEX=1,NEXDIP
          IEXJ=(IEX-1)*NUMORB
          WRITE(6,'(/,A,I4)') ' OCCUPATION OF STATE ',IEX
          WRITE(6,'(20F4.1)') (FOCC(II+IEXJ),II=1,NUMORB)
          IF(LOCD) THEN
            DO I=1,NUMBLD
              WRITE(6,'(A)') ' LOCAL DIPOLE MOMENT '
              WRITE(6,'(A,F8.4,A,F8.4,A)')
     *          ' X = ',XMINLD(I),' - ',XMAXLD(I),' a.u.'
              WRITE(6,'(A,F8.4,A,F8.4,A)')
     *          ' Y = ',YMINLD(I),' - ',YMAXLD(I),' a.u.'
              WRITE(6,'(A,F8.4,A,F8.4,A)')
     *          ' Z = ',ZMINLD(I),' - ',ZMAXLD(I),' a.u.'
              D1=EXD(1,I,IEX)
              D2=EXD(2,I,IEX)
              D3=EXD(3,I,IEX)
              DD=SQRT(D1*D1+D2*D2+D3*D3)
              WRITE(6,'(3(10X,A),6X,A)') ' X',' Y',' Z',' TOTAL'
              WRITE(6,'(4F12.5,A)') D1,D2,D3,DD,'   atomic units'
              WRITE(6,'(4F12.5,A)') AU_DEB*D1,AU_DEB*D2,AU_DEB*D3,
     &                             AU_DEB*DD,'   Debye'
              WRITE(6,*)
            ENDDO
          ELSE
            WRITE(6,'(A)') ' DIPOLE MOMENT '
            D1=EXD(1,1,IEX)
            D2=EXD(2,1,IEX)
            D3=EXD(3,1,IEX)
            DD=SQRT(D1*D1+D2*D2+D3*D3)
            WRITE(6,'(3(10X,A),6X,A)') ' X',' Y',' Z',' TOTAL'
            WRITE(6,'(4F12.5,A)') D1,D2,D3,DD,'   atomic units'
            WRITE(6,'(4F12.5,A)') AU_DEB*D1,AU_DEB*D2,AU_DEB*D3,
     &                            AU_DEB*DD,'   Debye'
            WRITE(6,*)
          ENDIF
        ENDDO
      ENDIF
      IF(LTRM) THEN
        WRITE(6,'(/,A)') ' TRANSITION MOMENTS'
        DO IEX=1,NTRMOM
          WRITE(6,'(/,A,I4,A,$)') ' EXCITATION ',IEX,' BETWEEN STATES: '
          WRITE(6,'(2I4)') (NSDIP(II,IEX),II=1,2)
          IF(LOCD) THEN
            DO I=1,NUMBLD
              WRITE(6,'(A)') ' LOCAL TRANSITION MOMENT '
              WRITE(6,'(A,F8.4,A,F8.4,A)')
     *          ' X = ',XMINLD(I),' - ',XMAXLD(I),' a.u.'
              WRITE(6,'(A,F8.4,A,F8.4,A)')
     *          ' Y = ',YMINLD(I),' - ',YMAXLD(I),' a.u.'
              WRITE(6,'(A,F8.4,A,F8.4,A)')
     *          ' Z = ',ZMINLD(I),' - ',ZMAXLD(I),' a.u.'
              D1=TRMOM(1,I,IEX)
              D2=TRMOM(2,I,IEX)
              D3=TRMOM(3,I,IEX)
              DD=SQRT(D1*D1+D2*D2+D3*D3)
              WRITE(6,'(3(10X,A),6X,A)') ' X',' Y',' Z',' TOTAL'
              WRITE(6,'(4F12.5,A)') D1,D2,D3,DD,'   atomic units'
              WRITE(6,'(4F12.5,A)') AU_DEB*D1,AU_DEB*D2,AU_DEB*D3,
     &                              AU_DEB*DD,'   Debye'
              WRITE(6,*)
            ENDDO
          ELSE
            WRITE(6,'(A)') ' TRANSITION MOMENT '
            D1=TRMOM(1,1,IEX)
            D2=TRMOM(2,1,IEX)
            D3=TRMOM(3,1,IEX)
            DD=SQRT(D1*D1+D2*D2+D3*D3)
            WRITE(6,'(3(10X,A),6X,A)') ' X',' Y',' Z',' TOTAL'
            WRITE(6,'(4F12.5,A)') D1,D2,D3,DD,'   atomic units'
            WRITE(6,'(4F12.5,A)') AU_DEB*D1,AU_DEB*D2,AU_DEB*D3,
     &                            AU_DEB*DD,'   Debye'
            WRITE(6,*)
          ENDIF
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_PROPCAL(LPROPCAL,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NAX
      INCLUDE 'pola.inc'        !TPOLARB
C     Arguments
      INTEGER   LPROPCAL,NSTATE,LDDIPO
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LDDIPO = 0
      IF(TDIPD) CALL GIVE_SCR_DDIPO(LDDIPO,TAG)
      IF(TPOLARB) THEN
        CALL GIVE_SCR_POLARPROJ(LPROPCAL,TAG,NSTATE)
      ELSE
        LPROPCAL=0
      ENDIF
      LPROPCAL=MAX(LPROPCAL,LDDIPO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_ESPC(LESPC,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG
      INCLUDE 'elct.inc'        !N
      INCLUDE 'pslo.inc'        !TIVAN
C     Arguments
      INTEGER   LESPC
      CHARACTER TAG*30
C     Variables
      INTEGER   IL_QPHI, LRNLSM
C     ==--------------------------------------------------------------==
      CALL GIVE_QPHI(IL_QPHI)
      IF(TIVAN) THEN
         CALL GIVE_SCR_RNLSM(LRNLSM,TAG,N,.FALSE.)
      ELSE
         LRNLSM=0
      ENDIF
      LESPC=MAX(2*NHG+IL_QPHI,LRNLSM)
      TAG='2*NHG+IL_QPHI'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_AVGP(LAVGP,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG
      INCLUDE 'elct.inc'        !N
      INCLUDE 'pslo.inc'        !TIVAN
C     Arguments
      INTEGER   LAVGP
      CHARACTER TAG*30
C     Variables
      INTEGER   LRNLSM,IL_QPHI
C     ==--------------------------------------------------------------==
      CALL GIVE_QPHI(IL_QPHI)
      IF(TIVAN) THEN
         CALL GIVE_SCR_RNLSM(LRNLSM,TAG,N,.FALSE.)
      ELSE
         LRNLSM=0
      ENDIF
      LAVGP=MAX(2*NHG+IL_QPHI,LRNLSM)
      TAG='2*NHG+IL_QPHI'
C     ==--------------------------------------------------------------==
      RETURN
      END


