C     ==================================================================
      SUBROUTINE PROWFN(C0,TAU0,NSTATE)
C     ==--------------------------------------------------------------==
C     == PROJECT WAVEFUNCTIONS ON PSEUDO ATOMIC ORBITALS              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'prden.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,NSTATE)
      REAL*8     TAU0(3*NAX*NSX)
C     Variables
      DIMENSION  FNL2(NAT,NHXS,*),F(NSTATE),CATOM(NGW,NATTOT)
      REAL*8     FNL(NAT,NHXS,*),DFNL(*)
      COMPLEX*16 CSCR(NGW,NSTATE),PSI(*)
      POINTER    (IP_CSCR,CSCR),(IP_PSI,PSI)
      REAL*8     COMP(NUMORB),A(NATTOT*NATTOT),W(NATTOT),
     &           Z(NATTOT,NATTOT),AUX(3*NATTOT),
     &           BAB(NAT,NAT),QA(NAT,6),
     &           XTMAT(NATTOT,*),SMAT(NATTOT,NATTOT),
     &           SCR(*),RHOE(*),
     &           ABC(*),ABCD(*)
      POINTER    (IP_COMP,COMP),(IP_A,A),(IP_W,W),(IP_Z,Z),
     &           (IP_AUX,AUX),
     &           (IP_BAB,BAB),(IP_QA,QA),
     &           (IP_XTMAT,XTMAT),(IP_SMAT,SMAT),
     &           (IP_SCR,SCR),(IP_RHOE,RHOE),
     &           (IP_ABC,ABC),(IP_ABCD,ABCD)
      CHARACTER  LABEL(10000)*15,TAG*30
      LOGICAL    TLSD2,FERROR
      REAL*8     FOC(20),SFC,FAC,RLEN,QM,QL,UNAC,ABCM,
     &           DOTP,DDOT
      EXTERNAL   DOTP,DDOT
      INTEGER    ISUB,NOMAX,N3,N4,LSCR,IAORB,IAT,IS,IA,NATST,IXX,N2,
     &           LMAX,K,J,I,IZERO,IAO,NAO,IAT1,IAO1,IS1,NAO1,IA1,I1,
     &           IAT2,IAO2,IS2,NAO2,IA2,I2,MSWEEP,ISW,II,NUMIN,IAT3,
     &           IAT4,IB,IC,ID,IP,I3MAX,IAT3M,IJK,L,I4MAX,NL,NLOC,
     &           IST,IDO,IDO2,ISTB,IAT4M,KI,KL,IL_RHOE,IL_PSI
C     ==--------------------------------------------------------------==
      CALL TISET('    PROWFN',ISUB)
      IF(TFDIST) CALL STOPGM('PROWFN','TFDIST NOT IMPLEMENTED')
      NOMAX = MAX(NUMORB,NATTOT)
      CALL MEMORY(IP_COMP,NUMORB,'COMP')
      CALL MEMORY(IP_XTMAT,NATTOT*NOMAX,'XTMAT')
      CALL MEMORY(IP_XSMAT,NATTOT*NOMAX,'XSMAT')
      CALL MEMORY(IP_XXMAT,NATTOT*NOMAX,'XXMAT')
      CALL MEMORY(IP_CATOM,2*NGW*NATTOT,'CATOM')
      CALL MEMORY(IP_CSCR,2*NGW*NATTOT,'CSCR')
      CALL MEMORY(IP_BAB,NAT*NAT,'BAB')
      CALL MEMORY(IP_QA,6*NAT,'QA')
      CALL AZZERO(QA,6*NAT)
      IF(DPAN) THEN
        CALL MEMORY(IP_SMAT,NATTOT*NATTOT,'SMAT')
      ENDIF
      N3=NAT*NAT*NAT/6 + 1
      IF(DPAN.AND.NCEN.GE.3) THEN
        CALL MEMORY(IP_ABC,N3,'ABC')
      ENDIF
      N4=NAT*NAT*NAT*NAT/24 + 1
      IF(DPAN.AND.NCEN.GE.4) THEN
        CALL MEMORY(IP_ABCD,N4,'ABCD')
      ENDIF
C     Allocation of RHOE and PSI
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      IF(LOCL.AND.(NUMPR.NE.0)) THEN
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
        CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      ELSEIF(TIVAN) THEN
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      ENDIF
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL GIVE_SCR_PROWFN(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      IF(PARENT) CALL PRMEM('    PROWFN')
C     ==--------------------------------------------------------------==
C     Load AO in PW basis
      IAORB=1
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          CALL LOADC(CATOM(1,IAORB),FOC,NGW,NGW,NATTOT,IS,IAT,NATST)
          DO IXX=IAORB,IAORB+NATST-1
            SFC=DOTP(NGW,CATOM(1,IXX),CATOM(1,IXX))
#ifdef PARALLEL
            CALL GLOSUM(1,SFC)
#endif
            SFC=1.D0/SQRT(SFC)
            CALL ZDSCAL(NGW,SFC,CATOM(1,IXX),1)
          ENDDO
          IAORB=IAORB+NATST
        ENDDO
      ENDDO
C     Overlap matrix
      TLSD2=TLSD
      TLSD=.FALSE.
      CALL OVLAP(NATTOT,XSMAT,CATOM,CATOM)
      TLSD=TLSD2
#ifdef PARALLEL
      CALL SUMMAT(XSMAT,NATTOT,SCR,LSCR)
#endif
      IF(PARENT) THEN
       CALL FILEOPEN(41,'OVERLAP',FO_DEF+FO_UFO,FERROR)
       WRITE(41)((XSMAT(KL,KI),KL=1,NATTOT),KI=1,NATTOT)
       CALL FILECLOSE(41)
      ENDIF
      CALL DCOPY(NATTOT*NATTOT,XSMAT(1,1),1,XTMAT(1,1),1)
C     O**(-1/2)
      N2=NATTOT*NATTOT
      LMAX=2*N2+4*NATTOT
      CALL TEST_SCR('PROWFN','2*NATTOT*NATTOT+4*NATTOT',LSCR,LMAX)
#ifdef _BGL 
      CALL GET_ADDR(IP_A,SCR(1))
      CALL GET_ADDR(IP_W,SCR(1+N2+MOD(N2,2)))
      CALL GET_ADDR(IP_Z,SCR(1+N2+MOD(N2,2)+NATTOT+MOD(NATTOT,2)))
      CALL GET_ADDR(IP_AUX,SCR(1+2*(N2+MOD(N2,2))+NATTOT+MOD(NATTOT,2)))
#else
      CALL GET_ADDR(IP_A,SCR(1))
      CALL GET_ADDR(IP_W,SCR(1+N2))
      CALL GET_ADDR(IP_Z,SCR(1+N2+NATTOT))
      CALL GET_ADDR(IP_AUX,SCR(1+2*N2+NATTOT))
#endif
      K=0
      DO J=1,NATTOT
        DO I=J,NATTOT
          K=K+1
          A(K)=XSMAT(I,J)
        ENDDO
      ENDDO
      CALL DSPEVY(1,A,W,Z,NATTOT,NATTOT,AUX,3*NATTOT)
      IZERO=0
      DO I=1,NATTOT
        IF(ABS(W(I)).LT.1.D-5) THEN
          W(I)=1.0D30
          IZERO=IZERO+1
          DO J=1,NATTOT
            Z(J,I)=0.0D0
          ENDDO
        ENDIF
      ENDDO
      IF(IZERO.NE.0) WRITE(6,'(A,I3)') 
     *  ' NUMBER OF LINEARLY DEPENDENT ATOMIC BASIS FUNCTIONS :',IZERO
      DO I=1,NATTOT
        W(I)=1.D0/SQRT(W(I))
      ENDDO
      CALL AZZERO(XSMAT,NATTOT*NATTOT)
      DO K=1,NATTOT
        DO J=1,NATTOT
          FAC=W(K)*Z(J,K)
          CALL DAXPY(NATTOT,FAC,Z(1,K),1,XSMAT(1,J),1)
        ENDDO
      ENDDO
C     Orthonormalize atomic orbitals
      CALL DGEMM('N','N',2*NGW,NATTOT,NATTOT,1.0D0,CATOM(1,1),2*NGW,
     &           XSMAT(1,1),NATTOT,0.0D0,CSCR(1,1),2*NGW)
      CALL DCOPY(2*NATTOT*NGW,CSCR(1,1),1,CATOM(1,1),1)
C     Overlap AO with wavefunctions
      CALL OVLAP2(NGW,NATTOT,NUMORB,XXMAT,CATOM,C0)
#ifdef PARALLEL
      CALL GLOSUM(NATTOT*NUMORB,XXMAT)
#endif
      IF(TIVAN) THEN
C       Calculate augmentation charges
        CALL AUGCHG(FNL,F,QA(1,4),NUMORB)
        CALL MEMORY(IP_FNL2,NAT*NUMORB*NHXS,'FNL2')
        CALL FREEM(IP_FNL)
        CALL MEMORY(IP_FNL,NAT*NATTOT*NHXS,'FNL')
        CALL RNLSM(CATOM,NATTOT,PSI,SCR,LSCR,1,1,.FALSE.)
        CALL AZZERO(FNL2,NAT*NHXS*NUMORB)
        DO I=1,NUMORB
          DO J=1,NATTOT
            CALL DAXPY(NAT*NHXS,XXMAT(J,I),FNL(1,1,J),1,FNL2(1,1,I),1)
          ENDDO
        ENDDO
        CALL AUGCHG(FNL2,F,QA(1,5),NUMORB)
      ENDIF
      DO I=1,NUMORB
        RLEN=DOTP(NGW,C0(1,I),C0(1,I))
#ifdef PARALLEL
        CALL GLOSUM(1,RLEN)
#endif
        COMP(I)=DDOT(NATTOT,XXMAT(1,I),1,XXMAT(1,I),1)/RLEN
      ENDDO
      IF(PARENT) THEN
C       Lowdin Population Analysis
        IAT=0
        IAO=0
        DO IS=1,NSP
          NAO=NUMAOR(IS)
          DO IA=1,NA(IS)
            IAT=IAT+1
C           QA(.,4) is the true augmentation charge!
            QA(IAT,2)=ZV(IS)-QA(IAT,4)
            DO I=IAO+1,IAO+NAO
              DO J=1,NSTATE
                QA(IAT,2)=QA(IAT,2)-F(J)*XXMAT(I,J)**2
              ENDDO
            ENDDO
            IAO=IAO+NAO
          ENDDO
        ENDDO
      ENDIF
C     Rotate back to AO basis
      CALL DGEMM('N','N',NATTOT,NUMORB,NATTOT,1.0D0,XSMAT(1,1),NATTOT,
     *             XXMAT(1,1),NATTOT,0.0D0,SCR(1),NATTOT)
      CALL DCOPY(NATTOT*NUMORB,SCR(1),1,XXMAT(1,1),1)
      IF(PARENT) THEN
C       Print the wavefunctions
        CALL MKLABEL(LABEL)
        IF(PRTO) THEN
          WRITE(6,'(/,A,/)') ' WAVEFUNCTIONS IN ATOMIC ORBITAL BASIS'
          IF(TLSD) THEN
            WRITE(6,'(21X,A)') ' ****** ALPHA SPIN ****** '
            CALL PRTMAT(XXMAT(1,1),NATTOT,NSUP,LABEL,COMP,F)
            WRITE(6,'(/,21X,A)') ' ****** BETA  SPIN ****** '
            CALL PRTMAT(XXMAT(1,NSUP+1),NATTOT,NSDOWN,LABEL,
     *                                    COMP(NSUP+1),F(NSUP+1))
          ELSE
            CALL PRTMAT(XXMAT,NATTOT,NUMORB,LABEL,COMP,F)
          ENDIF
        ENDIF
        CALL FILEOPEN(41,'WFNCOEF',FO_DEF+FO_UFO,FERROR)
        WRITE(41) NATTOT,NSP,(ZV(IS),NA(IS),NUMAOR(IS),IS=1,NSP)
        WRITE(41)((XXMAT(KL,KI),KL=1,NATTOT),KI=1,NUMORB)
        CALL FILECLOSE(41)
        IF(TIVAN) THEN
C         Print Augmentation Charges
          WRITE(6,'(/,A,/)') 
     *          ' VANDERBILT AUGMENTATION CHARGES '
          WRITE(6,'(A,A)') '       ATOM        FULL BASIS    ATOM BASIS'
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
              WRITE(6,'(I4,4X,A,9X,F10.3,4X,F10.3)') 
     *           IAT,EL(IATYP(IS)),QA(IAT,4),QA(IAT,5)
            ENDDO
          ENDDO
        ENDIF
        IF(MPAN) THEN
C         Mulliken Population Analysis
          DO I=1,NATTOT
            DO J=1,NATTOT
              XSMAT(I,J)=0.0D0
              DO K=1,NSTATE
                XSMAT(I,J)=XSMAT(I,J)+F(K)*XXMAT(I,K)*XXMAT(J,K)
              ENDDO
            ENDDO
          ENDDO
          CALL AZZERO(SCR,NATTOT)
          DO J=1,NATTOT
            DO I=1,NATTOT
              SCR(I)=SCR(I)+XSMAT(I,J)*XTMAT(I,J)
            ENDDO
          ENDDO
          IAT=0
          IAO=0
          DO IS=1,NSP
            NAO=NUMAOR(IS)
            DO IA=1,NA(IS)
              IAT=IAT+1
C             QA(.,4) is the true augmentation charge!
              QA(IAT,1)=ZV(IS)-QA(IAT,4)
              DO I=IAO+1,IAO+NAO
                QA(IAT,1)=QA(IAT,1)-SCR(I)
              ENDDO
              IAO=IAO+NAO
            ENDDO
          ENDDO
C         Bond Orders
          CALL DCOPY(NATTOT*NUMORB,XXMAT(1,1),1,SCR(1),1)
          CALL DGEMM('N','N',NATTOT,NATTOT,NATTOT,1.0D0,XSMAT(1,1),
     &               NATTOT,XTMAT(1,1),NATTOT,0.0D0,XXMAT(1,1),NATTOT)
          CALL AZZERO(BAB,NAT*NAT)
          IAT1=0
          IAO1=0
          DO IS1=1,NSP
            NAO1=NUMAOR(IS1)
            DO IA1=1,NA(IS1)
              IAT1=IAT1+1
              DO I1=IAO1+1,IAO1+NAO1
                IAT2=0
                IAO2=0
                DO IS2=1,NSP
                  NAO2=NUMAOR(IS2)
                  DO IA2=1,NA(IS2)
                    IAT2=IAT2+1
                    IF(IAT2.LT.IAT1) THEN
                      DO I2=IAO2+1,IAO2+NAO2
                        BAB(IAT1,IAT2)=BAB(IAT1,IAT2)+
     *                                  XXMAT(I1,I2)*XXMAT(I2,I1)
                      ENDDO
                    ENDIF
                    IAO2=IAO2+NAO2
                  ENDDO
                ENDDO
              ENDDO
              IAO1=IAO1+NAO1
            ENDDO
          ENDDO
          CALL DCOPY(NATTOT*NUMORB,SCR(1),1,XXMAT(1,1),1)
          DO I=1,NAT
            DO J=I+1,NAT
              BAB(I,J)=BAB(J,I)
            ENDDO
          ENDDO
          DO I=1,NAT
            QA(I,3)=0.D0
            DO J=1,NAT
              QA(I,3)=QA(I,3)+BAB(J,I)
            ENDDO
          ENDDO
C         SPIN POPULATION
          IF(TLSD) THEN
            DO I=1,NATTOT
              DO J=1,NATTOT
                XSMAT(I,J)=0.0D0
                DO K=1,NSTATE
                  SFC = F(K)
                  IF(K.GT.NSUP) SFC=-SFC
                  XSMAT(I,J)=XSMAT(I,J)+SFC*XXMAT(I,K)*XXMAT(J,K)
                ENDDO
              ENDDO
            ENDDO
            CALL AZZERO(SCR,NATTOT)
            DO J=1,NATTOT
              DO I=1,NATTOT
                SCR(I)=SCR(I)+XSMAT(I,J)*XTMAT(I,J)
              ENDDO
            ENDDO
            IAT=0
            IAO=0
            DO IS=1,NSP
              NAO=NUMAOR(IS)
              DO IA=1,NA(IS)
                IAT=IAT+1
                DO I=IAO+1,IAO+NAO
                  QA(IAT,6)=QA(IAT,6)-SCR(I)
                ENDDO
                IAO=IAO+NAO
              ENDDO
            ENDDO
          ENDIF
C         Print Population Analysis
          WRITE(6,'(/,A,/)') 
     *          ' POPULATION ANALYSIS FROM PROJECTED WAVEFUNCTIONS'
          IF(TLSD) THEN
            WRITE(6,'(A)') 
     *'       ATOM      MULLIKEN(SPIN)      LOWDIN       VALENCE'
            IAT=0
            DO IS=1,NSP
              DO IA=1,NA(IS)
                IAT=IAT+1
                WRITE(6,'(I4,4X,A,4X,F7.3,F9.3,3X,F10.3,3X,F10.3)') 
     *           IAT,EL(IATYP(IS)),QA(IAT,1),QA(IAT,6),
     *                             QA(IAT,2),QA(IAT,3)
              ENDDO
            ENDDO
          ELSE
            WRITE(6,'(A)') 
     *'       ATOM          MULLIKEN        LOWDIN       VALENCE'
            IAT=0
            DO IS=1,NSP
              DO IA=1,NA(IS)
                IAT=IAT+1
                WRITE(6,'(I4,4X,A,9X,F10.3,4X,F10.3,4X,F10.3)') 
     *           IAT,EL(IATYP(IS)),QA(IAT,1),QA(IAT,2),QA(IAT,3)
              ENDDO
            ENDDO
          ENDIF
          QM=-CHARGE
          QL=-CHARGE
          DO I=1,NAT
            QM=QM+QA(I,1)
            QL=QL+QA(I,2)
          ENDDO
          WRITE(6,'(A,F10.3,4X,F10.3)') '  UNASSIGNED CHARGE',QM,QL
C         Print Bond Orders
          WRITE(6,'(/,A)') 
     *      ' MAYER BOND ORDERS FROM PROJECTED WAVEFUNCTIONS'
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
              WRITE(LABEL(IAT),'(I4,1X,A2)') IAT,EL(IATYP(IS))
            ENDDO
          ENDDO
          MSWEEP=NAT/8
          IF(MOD(NAT,8).NE.0) MSWEEP=MSWEEP+1
          DO ISW=1,MSWEEP
            I1=(ISW-1)*8+1
            I2=MIN(8*ISW,NAT)
            WRITE(6,'(/,9(A8))') '        ',(LABEL(II),II=I1,I2)
            DO IA=1,NAT
              WRITE(6,'(A8,8(F7.3,1X))') LABEL(IA),(BAB(IA,II),II=I1,I2)
            ENDDO
          ENDDO
          WRITE(6,*)
        ENDIF
        IF(DPAN) THEN
C         Davidson Population Analysis
          NUMIN=0
          DO IS=1,NSP
            NUMIN=NUMIN+NA(IS)*MAOS(IS)
            IF(NUMAOR(IS).LT.MAOS(IS)) THEN
              WRITE(6,'(A,I4)') 
     *          ' INCONSISTENT ATOMIC BASIS FOR SPECIES ',IS
              CALL STOPGM('PROWFN',' ')
            ENDIF
          ENDDO
C         Density Matrix
          DO I=1,NATTOT
            DO J=1,NATTOT
              XSMAT(I,J)=0.0D0
              DO K=1,NSTATE
                XSMAT(I,J)=XSMAT(I,J)+F(K)*XXMAT(I,K)*XXMAT(J,K)
              ENDDO
            ENDDO
          ENDDO
          UNAC=0.D0
          DO IAT=1,NAT
            UNAC=UNAC+QA(IAT,4)
          ENDDO
C         Calculate modified atomic orbitals
          CALL DCOPY(NATTOT*NATTOT,XTMAT(1,1),1,SMAT(1,1),1)
          CALL CMAOS(XSMAT,SMAT,NUMIN,UNAC,SCR,LSCR)
          UNAC=UNAC/DBLE(NAT)
C         Calculate shared atomic charges
          CALL SATCH(XSMAT,XTMAT,SMAT,NUMIN,BAB,SCR,LSCR)
C         Calculate 3-center shared atomic charges
          IF(NCEN.GE.3) CALL SATCH3(XSMAT,XTMAT,SMAT,NUMIN,
     *                              BAB,ABC,SCR,LSCR)
C         Calculate 4-center shared atomic charges
          IF(NCEN.GE.4) CALL SATCH4(XSMAT,XTMAT,SMAT,NUMIN,
     *                              BAB,ABC,ABCD,SCR,LSCR)
          IF(NCEN.GE.5)
     &         WRITE(6,*) NCEN,' CENTER TERMS NOT IMPLEMENTED '
C         Charges
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
C             QA(.,4) is the true augmentation charge!
              QA(IAT,1)=ZV(IS)-QA(IAT,4)-UNAC
            ENDDO
          ENDDO
          IAT3=0
          IAT4=0
          DO IA=1,NAT
            QA(IA,1)=QA(IA,1)-BAB(IA,IA)
            DO IB=IA+1,NAT
              QA(IA,1)=QA(IA,1)+BAB(IA,IB)/2.D0
              QA(IB,1)=QA(IB,1)+BAB(IA,IB)/2.D0
              IF(NCEN.GE.3) THEN
                DO IC=IB+1,NAT
                  IAT3=IAT3+1
                  QA(IA,1)=QA(IA,1)-ABC(IAT3)/3.D0
                  QA(IB,1)=QA(IB,1)-ABC(IAT3)/3.D0
                  QA(IC,1)=QA(IC,1)-ABC(IAT3)/3.D0
                  IF(NCEN.GE.4) THEN
                    DO ID=IC+1,NAT
                      IAT4=IAT4+1
                      QA(IA,1)=QA(IA,1)+ABCD(IAT4)/4.D0
                      QA(IB,1)=QA(IB,1)+ABCD(IAT4)/4.D0
                      QA(IC,1)=QA(IC,1)+ABCD(IAT4)/4.D0
                      QA(ID,1)=QA(ID,1)+ABCD(IAT4)/4.D0
                    ENDDO
                  ENDIF
                ENDDO
              ENDIF
            ENDDO
          ENDDO
C         Print Population Analysis
          WRITE(6,'(/,A,/)') 
     *          ' POPULATION ANALYSIS FROM PROJECTED WAVEFUNCTIONS'
          WRITE(6,'(A)') 
     *'       ATOM          DAVIDSON        LOWDIN       '
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
              WRITE(6,'(I4,4X,A,9X,F10.3,4X,F10.3)') 
     *         IAT,EL(IATYP(IS)),QA(IAT,1),QA(IAT,2)
            ENDDO
          ENDDO
          QM=0.0D0
          QL=0.0D0
          DO I=1,NAT
            QM=QM+QA(I,1)
            QL=QL+QA(I,2)
          ENDDO
          WRITE(6,'(A,F10.3,4X,F10.3)') '  UNASSIGNED CHARGE',QM,QL
C         Print Shared Electron Numbers
          WRITE(6,'(/,A)') 
     *      ' SHARED ELECTRON NUMBERS FROM PROJECTED WAVEFUNCTIONS'
          IAT=0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT=IAT+1
              WRITE(LABEL(IAT),'(I4,1X,A2)') IAT,EL(IATYP(IS))
            ENDDO
          ENDDO
          MSWEEP=NAT/8
          IF(MOD(NAT,8).NE.0) MSWEEP=MSWEEP+1
          DO ISW=1,MSWEEP
            I1=(ISW-1)*8+1
            I2=MIN(8*ISW,NAT)
            WRITE(6,'(/,9(A8))') '        ',(LABEL(II),II=I1,I2)
            DO IA=1,NAT
              WRITE(6,'(A8,8(F7.3,1X))') LABEL(IA),(BAB(IA,II),II=I1,I2)
            ENDDO
          ENDDO
          WRITE(6,*)
C         Print 3-Center Shared Electron Numbers
          IF(NCEN.GE.3) THEN
            WRITE(6,'(/,A)') 
     * ' 3-CENTER SHARED ELECTRON NUMBERS FROM PROJECTED WAVEFUNCTIONS'
            WRITE(6,'(A,F10.4)') ' CUTOFF FOR PRINTING IS :',CUT3O
            IP=0
            ABCM=0.0D0
            IAT3=0
            DO I=1,NAT
              DO J=I+1,NAT
                DO K=J+1,NAT
                  IAT3=IAT3+1
                  IF(ABS(ABC(IAT3)).GT.ABCM) THEN
                    I3MAX=I+(J-1)*NAT+(K-1)*NAT*NAT
                    IAT3M=IAT3
                    ABCM=ABS(ABC(IAT3))
                  ENDIF
                  IF(ABC(IAT3).GT.CUT3O) THEN
                    IP=IP+1
                    WRITE(6,'(3A8,F10.4)') 
     *              LABEL(I),LABEL(J),LABEL(K),ABC(IAT3)
                  ENDIF
                ENDDO
              ENDDO
            ENDDO
            IF(IP.EQ.0.AND.ABCM.GT.0.D0) THEN
              IJK=I3MAX
              I = MOD(IJK-1,NAT)+1
              K = IJK/(NAT*NAT)+1
              J = (IJK-(K-1)*NAT*NAT)/NAT+1
              WRITE(6,'(3A8,F10.4)') 
     *             LABEL(I),LABEL(J),LABEL(K),ABC(IAT3M)
            ENDIF
          ENDIF
C         Print 4-Center Shared Electron Numbers
          IF(NCEN.GE.4) THEN
            WRITE(6,'(/,A)') 
     * ' 4-CENTER SHARED ELECTRON NUMBERS FROM PROJECTED WAVEFUNCTIONS'
            WRITE(6,'(A,F10.4)') ' CUTOFF FOR PRINTING IS :',CUT4O
            IP=0
            ABCM=0.0D0
            IAT4=0
            DO I=1,NAT
              DO J=I+1,NAT
                DO K=J+1,NAT
                  DO L=K+1,NAT
                    IAT4=IAT4+1
                    IF(ABS(ABCD(IAT4)).GT.ABCM) THEN
                      I4MAX=I+(J-1)*NAT+(K-1)*NAT*NAT+(L-1)*NAT*NAT*NAT
                      IAT4M=IAT4
                      ABCM=ABS(ABCD(IAT4))
                    ENDIF
                    IF(ABCD(IAT4).GT.CUT4O) THEN
                      IP=IP+1
                      WRITE(6,'(4A8,F10.4)') 
     *                LABEL(I),LABEL(J),LABEL(K),LABEL(L),ABCD(IAT4)
                    ENDIF
                  ENDDO
                ENDDO
              ENDDO
            ENDDO
            IF(IP.EQ.0.AND.ABCM.GT.0.0D0) THEN
              IJK=I4MAX
              I = MOD(IJK-1,NAT)+1
              K = IJK/(NAT*NAT)+1
              J = (IJK-(K-1)*NAT*NAT)/NAT+1
              L = (IJK-(K-1)*NAT*NAT-(J-1)*NAT*NAT*NAT)/NAT+1
              WRITE(6,'(4A8,F10.4)') 
     *             LABEL(I),LABEL(J),LABEL(K),LABEL(L),ABCD(IAT4M)
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C     Clean up the memory
      CALL FREEM(IP_COMP)
      CALL FREEM(IP_CATOM)
      CALL FREEM(IP_CSCR)
      CALL FREEM(IP_XSMAT)
      CALL FREEM(IP_XXMAT)
      CALL FREEM(IP_XTMAT)
      CALL FREEM(IP_BAB)
      CALL FREEM(IP_QA)
      CALL FREEM(IP_SCR)
      IF(TIVAN) THEN
        CALL FREEM(IP_FNL2)
      ENDIF
      CALL TIHALT('    PROWFN',ISUB)
      CALL MY_SYNC(ALLGRP)
      CALL MY_FLUSH(6)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MKLABEL(LABEL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'adat.inc'
C     Arguments
      CHARACTER LABEL(*)*15
C     Variables
      CHARACTER JLAB(0:4,-4:4)*3
      CHARACTER ILAB(0:4)*1
      DATA      ILAB /'S','P','D','F','G'/
      INTEGER   IAT,K,IS,IA,ISH,L,IM
C     ==--------------------------------------------------------------==
      JLAB(0,0)='   '
      JLAB(1,-1)='x  '
      JLAB(1,0)='z  '
      JLAB(1,1)='y  '
      JLAB(2,-2)='xy '
      JLAB(2,-1)='xz '
      JLAB(2,0)='z^2'
      JLAB(2,1)='yz '
      JLAB(2,2)='x-y'
      JLAB(3,-3)='-3 '
      JLAB(3,-2)='-2 '
      JLAB(3,-1)='-1 '
      JLAB(3,0)=' 0 '
      JLAB(3,1)='+1 '
      JLAB(3,2)='+2 '
      JLAB(3,3)='+3 '
      JLAB(4,-3)='-4 '
      JLAB(4,-3)='-3 '
      JLAB(4,-2)='-2 '
      JLAB(4,-1)='-1 '
      JLAB(4,0)=' 0 '
      JLAB(4,1)='+1 '
      JLAB(4,2)='+2 '
      JLAB(4,3)='+3 '
      JLAB(4,4)='+4 '
      IAT=0
      K=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO ISH=1,NSHELL(IS)
            L=LSHELL(ISH,IS)
            DO IM=-L,L
              K=K+1
              IF(ISH.EQ.1.D0 .AND. IM.EQ.-L) THEN
                WRITE(LABEL(K),'(I3,2X,A2,2X,A1,A3)') 
     *                             IAT,EL(IATYP(IS)),ILAB(L),JLAB(L,IM)
              ELSE
                WRITE(LABEL(K),'(9X,A1,A3)') ILAB(L),JLAB(L,IM)
              ENDIF
            ENDDO
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PRTMAT(XXMAT,NATTOT,NUMORB,LABEL,COMP,F)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   NATTOT,NUMORB
      REAL*8    XXMAT(NATTOT,*),COMP(*),F(*)
      CHARACTER LABEL(NATTOT)*15
C     Variables
      INTEGER MSWEEP,ISW,I1,I2,IA,II
C     ==--------------------------------------------------------------==
      MSWEEP=NUMORB/8
      IF(MOD(NUMORB,8).NE.0) MSWEEP=MSWEEP+1
      DO ISW=1,MSWEEP
        I1=(ISW-1)*8+1
        I2=MIN(8*ISW,NUMORB)
        WRITE(6,'(/,A,8(I5,3X))') '      ORBITAL  ',(II,II=I1,I2)
        WRITE(6,'(A,8(F7.3,1X))')
     *                     '  COMPLETNESS  ',(COMP(II),II=I1,I2)
        WRITE(6,'(A,8(F7.3,1X),/)')
     *                     '  OCCUPATION   ',(F(II),II=I1,I2)
        DO IA=1,NATTOT
          WRITE(6,'(A15,8(F7.3,1X))') LABEL(IA),
     *                                   (XXMAT(IA,II),II=I1,I2)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE POPLOC(C,S,R,NORB,NAO,NLOC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER   NORB,NAO,NLOC
      REAL*8    C(NAO,NORB),S(NAO,NAO),R(NORB,NORB)
C     Variables
      INTEGER   IMAX
      REAL*8    TOL
      PARAMETER (IMAX=100,TOL=1.D-8)
      REAL*8    FUN,FI,A,B,AB,SIN4A,ALFA,CG,SG,DFUN,FUNA
      INTEGER   ITER,I,J
#ifdef PARALLEL
      INTEGER   MSGLEN
#endif
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(/,A,/)') '  ORBITAL LOCALIZATION '
        CALL UNITMX(R,NORB)
        WRITE(6,'(A)') '  ITER       FUNCTIONAL         DIFFERENCE '
        FUNA=0.0D0
        DO ITER=1,IMAX
          DO I=1,NLOC
            DO J=I+1,NLOC
              CALL LOCFUN(C(1,I),C(1,J),S,NAO,A,B,FI)
              AB=SQRT((A*A+B*B))
              IF(AB.GT.1.D-4) THEN
                SIN4A=B/AB
                ALFA=0.25D0*ASIN(SIN4A)
                CG=COS(ALFA)
                SG=SIN(ALFA)
                CALL DROT(NAO,C(1,I),1,C(1,J),1,CG,SG)
                CALL DROT(NORB,R(1,I),1,R(1,J),1,CG,SG)
              ENDIF
            ENDDO
          ENDDO
          FUN=0.0D0
          DO I=1,NLOC
            CALL LOCFUN(C(1,I),C(1,I),S,NAO,A,B,FI)
            FUN=FUN+FI
          ENDDO
          DFUN=FUNA-FUN
          WRITE(6,'(I5,5X,F12.6,5X,F16.10)') ITER,FUN,DFUN
          FUNA=FUN
          IF(ABS(DFUN).LT.TOL) GOTO 100
        ENDDO
        WRITE(6,'(A)') ' NO CONVERGENCE IN LOCALIZATION PROCEDURE'
  100   CONTINUE
      ENDIF
#ifdef PARALLEL
      CALL MY_SYNC(ALLGRP)
      MSGLEN = NAO*NORB * 8
      CALL MY_BCAST(C,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = NAO*NAO * 8
      CALL MY_BCAST(S,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = NORB*NORB * 8
      CALL MY_BCAST(R,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LOCFUN(CS,CT,S,NAO,A,B,F)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'atwf.inc'
C     Arguments
      INTEGER NAO
      REAL*8  CS(*),CT(*),S(NAO,NAO),A,B,F
C     Variables
      REAL*8  PSS,PST,PTT
      INTEGER IAO,IS,NSAO,IA,J,I
C     ==--------------------------------------------------------------==
      A = 0.0D0
      B = 0.0D0
      F = 0.0D0
      IAO=0
      DO IS=1,NSP
        NSAO=NUMAOR(IS)
        DO IA=1,NA(IS)
          PSS=0.0D0
          PST=0.0D0
          PTT=0.0D0
          DO J=1,NAO
            DO I=IAO+1,IAO+NSAO
              PSS=PSS+0.5D0*(CS(J)*S(J,I)*CS(I)+CS(I)*S(I,J)*CS(J))
              PST=PST+0.5D0*(CS(J)*S(J,I)*CT(I)+CS(I)*S(I,J)*CT(J))
              PTT=PTT+0.5D0*(CT(J)*S(J,I)*CT(I)+CT(I)*S(I,J)*CT(J))
            ENDDO
          ENDDO
          IAO=IAO+NSAO
          A=A+PST*PST-0.25D0*(PSS-PTT)**2
          B=B+PST*(PSS-PTT)
          F=F+PSS*PSS
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_PROWFN(LPROWFN,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !pslo.inc
      INCLUDE 'ions.inc'        !NSP NA
      INCLUDE 'elct.inc'        !N number of states
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'atwf.inc'        !NATTOT
      INCLUDE 'prop.inc'        !DPAN NCEN MAOS
      INCLUDE 'prden.inc'       !NUMPR
C     Arguments
      INTEGER   LPROWFN
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LRNLSM,LSUMMAT,LCMAOS,LSATCH,LWFNRHO,
     &          NUMIN,IS
C     ==--------------------------------------------------------------==
      NSTATE=N
      LRNLSM=0
      LCMAOS=0
      LSATCH=0
      LWFNRHO=0
      CALL GIVE_SCR_SUMMAT(LSUMMAT,TAG,NATTOT)
      IF(TIVAN) CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NATTOT,.FALSE.)
      IF(DPAN) THEN
C       Davidson Population Analysis
        NUMIN=0
        DO IS=1,NSP
          NUMIN=NUMIN+NA(IS)*MAOS(IS)
        ENDDO
        CALL GIVE_SCR_CMAOS(LCMAOS,TAG,NUMIN)
        CALL GIVE_SCR_SATCH(LSATCH,TAG,NUMIN)
      ENDIF
C     PROWFN
      LPROWFN=MAX(2*NATTOT*NATTOT+4*NATTOT,
     &            NATTOT*NUMORB,
     &            LRNLSM,LSUMMAT,LCMAOS,LSATCH,LWFNRHO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
