C     ==================================================================
      SUBROUTINE PRPNOSMOVE_ISO(VELP,STEP,IP)
C     ==--------------------------------------------------------------==
C     ==  ALLOWS FOR NOSE-HOOVER CHAIN DYNAMICS                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'metr.inc'
C     Arguments
      INTEGER   IP
      REAL*8    VELP(3,NAX,NSX),STEP
C     Variables
      REAL*8    FETAPV(NCHX),AT3,EKINP,CONST,PKEWANT,AA,GEPS_P,GEPS_V
      INTEGER   IPP,L,K,IA,IS,IL,IAL,IJ,KF,IDF,IJJ
C     ==--------------------------------------------------------------==
      IPP=1
      IF(TPATH.AND.TPIMD) IPP=MIN(IP,2)
      AT3 = 3.D0*DBLE(NAT)
C     ==--------------------------------------------------------------==
C     == SEPARATE THERMOSTATS ON DIFFERENT ATOMIC SPECIES             ==
C     ==--------------------------------------------------------------==
      IF(TULTRA) THEN
        DO IS=1,NSP
C     ==--------------------------------------------------------------==
C     ==  CALCULATE ALL THERMOSTAT FORCES                             ==
C     ==--------------------------------------------------------------==
          EKINP=0.D0
          CONST=0.5D0*PMA(IS)
          DO K=1,3
            DO IA=1,NA(IS)
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,IS)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=2,NCHAIN
            EKINP = 0.5D0*QNOSP(IS,L-1,IP)*ETAPDOT(IS,L-1,IP)*
     *                                     ETAPDOT(IS,L-1,IP)
            PKEWANT = 0.5D0*TEMPW/FACTEM
            FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                  ==
C     ==----------------------------------------------------------------==
          ETAPDOT(IS,NCHAIN,IP) = ETAPDOT(IS,NCHAIN,IP) + 
     *                  0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IS,NCHAIN,IP)
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE REMAINDER OF CHAIN                                  ==
C     ==----------------------------------------------------------------==
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPDOT(IS,NCHAIN+1-L,IP))
            ETAPDOT(IS,NCHAIN-L,IP) = ETAPDOT(IS,NCHAIN-L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(NCHAIN-L)*AA/QNOSP(IS,NCHAIN-L,IP)
          ENDDO
         ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT VELOCITY                                   ==
C     ==----------------------------------------------------------------==
       GEPS_P = HTFP(1,1) + HTFP(2,2) + HTFP(3,3)
       GEPS_V = 0.D0
       DO K=1,3
        DO IS=1,NSP
         DO IA=1,NA(IS)
            GEPS_V = GEPS_V + (1.D0 + 3.D0/AT3)*
     *                        PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)
         ENDDO
        ENDDO
       ENDDO  
       VEPS = VEPS + 0.25D0*STEP*(GEPS_P + GEPS_V)/CMASS       
C     ==----------------------------------------------------------------==
C     ==  SCALE VELOCITIES                                              ==
C     ==----------------------------------------------------------------==
      DO IS=1,NSP
       AA = DEXP(-0.5D0*STEP*((1.D0+3.D0/AT3)*VEPS + ETAPDOT(IS,1,IP)))
       DO IA=1,NA(IS)
          VELP(1,IA,IS) = VELP(1,IA,IS)*AA
          VELP(2,IA,IS) = VELP(2,IA,IS)*AA
          VELP(3,IA,IS) = VELP(3,IA,IS)*AA
         ENDDO
        ENDDO
C
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE THERMOSTAT POSITIONS                                ==
C     ==----------------------------------------------------------------==
        DO IS=1,NSP
          DO L=1,NCHAIN
            ETAP(IS,L,IP) = ETAP(IS,L,IP) + 0.5D0*STEP*ETAPDOT(IS,L,IP)
          ENDDO
        ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT VELOCITY                                   ==
C     ==----------------------------------------------------------------==
       GEPS_P = HTFP(1,1) + HTFP(2,2) + HTFP(3,3)
       GEPS_V = 0.D0
       DO K=1,3
        DO IS=1,NSP
         DO IA=1,NA(IS)
            GEPS_V = GEPS_V + (1.D0 + 3.D0/AT3)*
     *                        PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)
         ENDDO
        ENDDO
       ENDDO  
       VEPS = VEPS + 0.25D0*STEP*(GEPS_P + GEPS_V)/CMASS       
C     ==----------------------------------------------------------------==
C     == LOOP AGAIN OVER CHAIN                                          ==
C     ==----------------------------------------------------------------==
        DO IS=1,NSP
          EKINP=0.D0
          CONST=0.5D0*PMA(IS)
          DO K=1,3
            DO IA=1,NA(IS)
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,IS)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPDOT(IS,L+1,IP))
            ETAPDOT(IS,L,IP) = ETAPDOT(IS,L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(L)*AA/QNOSP(IS,L,IP)
            EKINP = 0.5D0*QNOSP(IS,L,IP)*ETAPDOT(IS,L,IP)*
     *                                   ETAPDOT(IS,L,IP)
            PKEWANT = 0.5D0*TEMPW/FACTEM
            FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                  ==
C     ==----------------------------------------------------------------==
          ETAPDOT(IS,NCHAIN,IP) = ETAPDOT(IS,NCHAIN,IP) + 
     *                  0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IS,NCHAIN,IP)
        ENDDO
C XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
C FIXME LOCT: IMPLEMENT HERE
      ELSEIF(TLOCT) THEN
C     ==--------------------------------------------------------------==
C     == LOCAL TEMPERATURE GROUPS                                     ==
C     ==--------------------------------------------------------------==
         DO IL=1,NLOCT
C     ==--------------------------------------------------------------==
C     ==  CALCULATE ALL THERMOSTAT FORCES                             ==
C     ==--------------------------------------------------------------==
            EKINP=0.D0
            DO IAL=1,NLCTMBM(IL)
               IS=LCTMEMB(1,IAL,IL)
               IA=LCTMEMB(2,IAL,IL)
               CONST=0.5D0*PMA(IS)
               DO K=1,3
                  EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
               ENDDO
            ENDDO
            PKEWANT = 0.5D0*GKT(IPP,IL)
            FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
            DO L=2,NCHAIN
               EKINP = 0.5D0*QNOSP(IL,L-1,IP)*ETAPDOT(IL,L-1,IP)*
     *              ETAPDOT(IL,L-1,IP)
               PKEWANT = 0.5D0*LOCTPIN(1,IL)/FACTEM
               FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
            ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                  ==
C     ==----------------------------------------------------------------==
            ETAPDOT(IL,NCHAIN,IP) = ETAPDOT(IL,NCHAIN,IP) + 
     *           0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IL,NCHAIN,IP)
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE REMAINDER OF CHAIN                                  ==
C     ==----------------------------------------------------------------==
            DO L=1,NCHAIN-1
               AA = DEXP(-0.125D0*STEP*ETAPDOT(IL,NCHAIN+1-L,IP))
               ETAPDOT(IL,NCHAIN-L,IP) = ETAPDOT(IL,NCHAIN-L,IP)*AA*AA +
     *            0.25D0*STEP*FETAPV(NCHAIN-L)*AA/QNOSP(IL,NCHAIN-L,IP)
            ENDDO
         ENDDO
C        END OF LOOP IL=1,NLOCT
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT VELOCITY                                   ==
C     ==----------------------------------------------------------------==
         GEPS_P = HTFP(1,1) + HTFP(2,2) + HTFP(3,3)
         GEPS_V = 0.D0
         DO K=1,3
            DO IS=1,NSP
               DO IA=1,NA(IS)
                  GEPS_V = GEPS_V + (1.D0 + 3.D0/AT3)*
     *                 PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)
               ENDDO
            ENDDO
         ENDDO  
         VEPS = VEPS + 0.25D0*STEP*(GEPS_P + GEPS_V)/CMASS       
C     ==----------------------------------------------------------------==
C     ==  SCALE VELOCITIES                                              ==
C     ==----------------------------------------------------------------==
         DO IL=1,NLOCT
            AA = DEXP(-0.5D0*STEP*((1.D0+3.D0/AT3)*VEPS 
     *           + ETAPDOT(IL,1,IP)))
            DO IAL=1,NLCTMBM(IL)
               IS=LCTMEMB(1,IAL,IL)
               IA=LCTMEMB(2,IAL,IL)
               VELP(1,IA,IS) = VELP(1,IA,IS)*AA
               VELP(2,IA,IS) = VELP(2,IA,IS)*AA
               VELP(3,IA,IS) = VELP(3,IA,IS)*AA
            ENDDO
         ENDDO
C     
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE THERMOSTAT POSITIONS                                ==
C     ==----------------------------------------------------------------==
         DO IL=1,NLOCT
            DO L=1,NCHAIN
               ETAP(IL,L,IP) = ETAP(IL,L,IP)+0.5D0*STEP*ETAPDOT(IL,L,IP)
            ENDDO
         ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT VELOCITY                                   ==
C     ==----------------------------------------------------------------==
         GEPS_P = HTFP(1,1) + HTFP(2,2) + HTFP(3,3)
         GEPS_V = 0.D0
         DO K=1,3
            DO IS=1,NSP
               DO IA=1,NA(IS)
                  GEPS_V = GEPS_V + (1.D0 + 3.D0/AT3)*
     *                 PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)
               ENDDO
            ENDDO
         ENDDO  
         VEPS = VEPS + 0.25D0*STEP*(GEPS_P + GEPS_V)/CMASS       
C     ==----------------------------------------------------------------==
C     == LOOP AGAIN OVER CHAIN                                          ==
C     ==----------------------------------------------------------------==
         DO IL=1,NLOCT
            EKINP=0.D0
            DO IAL=1,NLCTMBM(IL)
               IS=LCTMEMB(1,IAL,IL)
               IA=LCTMEMB(2,IAL,IL)
               CONST=0.5D0*PMA(IS)
               DO K=1,3
                  EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
               ENDDO
            ENDDO 
            PKEWANT = 0.5D0*GKT(IPP,IL)
            FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
            DO L=1,NCHAIN-1
               AA = DEXP(-0.125D0*STEP*ETAPDOT(IL,L+1,IP))
               ETAPDOT(IL,L,IP) = ETAPDOT(IL,L,IP)*AA*AA +
     *              0.25D0*STEP*FETAPV(L)*AA/QNOSP(IL,L,IP)
               EKINP = 0.5D0*QNOSP(IL,L,IP)*ETAPDOT(IL,L,IP)*
     *              ETAPDOT(IL,L,IP)
               PKEWANT = 0.5D0*LOCTPIN(1,IL)/FACTEM
               FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
            ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                  ==
C     ==----------------------------------------------------------------==
            ETAPDOT(IL,NCHAIN,IP) = ETAPDOT(IL,NCHAIN,IP) + 
     *           0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IL,NCHAIN,IP)
         ENDDO
C XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
         
      ELSEIF(TMNOSE) THEN
C     ==--------------------------------------------------------------==
C     == SEPARATE THERMOSTATS ON EVERY DEGREE OF FREEDOM              ==
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
C     ==  LOOP BACKWARDS OVER NOSE-HOOVER CHAIN                       ==
C     ==--------------------------------------------------------------==
        IJ=0
        DO KF=1,NTHERM(IPP)
C     ==--------------------------------------------------------------==
C     == CALCULATE ALL THERMOSTAT FORCES                              ==
C     ==--------------------------------------------------------------==
          EKINP=0.D0
          DO IDF=1,NDFNT(KF,IPP)
            IJJ=IJ+IDF
            K=MAPDOF(1,IJJ,IPP)
            IA=MAPDOF(2,IJJ,IPP)
            IS=MAPDOF(3,IJJ,IPP)
            CONST=0.5D0*PMA(IS)
            EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,KF)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=2,NCHAIN
            EKINP = 0.5D0*QNOSPM(KF,L-1,IP)*
     *        ETAPMDOT(KF,L-1,IP)*ETAPMDOT(KF,L-1,IP)
            PKEWANT = 0.5D0*TEMPW/FACTEM
            FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==--------------------------------------------------------------==
C     == PROPAGATE LAST CHAIN ELEMENT                                 ==
C     ==--------------------------------------------------------------==
          ETAPMDOT(KF,NCHAIN,IP)=ETAPMDOT(KF,NCHAIN,IP)+ 
     *          0.25D0*STEP*FETAPV(NCHAIN)/QNOSPM(KF,NCHAIN,IP)
C     ==--------------------------------------------------------------==
C     == PROPAGATE REST OF CHAIN                                      ==
C     ==--------------------------------------------------------------==
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPMDOT(KF,NCHAIN+1-L,IP))
            ETAPMDOT(KF,NCHAIN-L,IP) = ETAPMDOT(KF,NCHAIN-L,IP)
     *            *AA*AA+0.25D0*STEP*FETAPV(NCHAIN-L)
     *            *AA/QNOSPM(KF,NCHAIN-L,IP)
          ENDDO
          IJ=IJ+NDFNT(KF,IPP)
        ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT VELOCITY                                   ==
C     ==----------------------------------------------------------------==
       GEPS_P = HTFP(1,1) + HTFP(2,2) + HTFP(3,3)
       GEPS_V = 0.D0
       DO K=1,3
        DO IS=1,NSP
         DO IA=1,NA(IS)
            GEPS_V = GEPS_V + (1.D0 + 3.D0/AT3)*
     *                        PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)
         ENDDO
        ENDDO
       ENDDO  
       VEPS = VEPS + 0.25D0*STEP*(GEPS_P + GEPS_V)/CMASS       
C     ==----------------------------------------------------------------==
C     ==  SCALE VELOCITIES                                              ==
C     ==----------------------------------------------------------------==
       IJ=0
       DO KF=1,NTHERM(IPP)
         AA=DEXP(-0.5D0*STEP*((1.D0+3.D0/AT3)*VEPS+ETAPMDOT(KF,1,IP)))
         DO IDF=1,NDFNT(KF,IPP)
           IJJ=IJ+IDF
           K=MAPDOF(1,IJJ,IPP)
           IA=MAPDOF(2,IJJ,IPP)
           IS=MAPDOF(3,IJJ,IPP)
           VELP(K,IA,IS) = VELP(K,IA,IS)*AA
         ENDDO
         IJ=IJ+NDFNT(KF,IPP)
       ENDDO
C     ==----------------------------------------------------------------==
C     == PROPAGATE THERMOSTAT POSITIONS                                 ==
C     ==----------------------------------------------------------------==
        DO KF=1,NTHERM(IPP)
          DO L=1,NCHAIN
            ETAPM(KF,L,IP) = ETAPM(KF,L,IP) + 
     *                     0.5D0*STEP*ETAPMDOT(KF,L,IP)
          ENDDO
        ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT VELOCITY                                   ==
C     ==----------------------------------------------------------------==
       GEPS_P = HTFP(1,1) + HTFP(2,2) + HTFP(3,3)
       GEPS_V = 0.D0
       DO K=1,3
        DO IS=1,NSP
         DO IA=1,NA(IS)
            GEPS_V = GEPS_V + (1.D0 + 3.D0/AT3)*
     *                        PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)
         ENDDO
        ENDDO
       ENDDO  
       VEPS = VEPS + 0.25D0*STEP*(GEPS_P + GEPS_V)/CMASS       
C     ==-------------------------------------------------------------==
C     ==  LOOP OVER CHAIN AGAIN                                      ==
C     ==-------------------------------------------------------------==
        IJ=0
        DO KF=1,NTHERM(IPP)
          CONST=0.5D0*PMA(IS)
          EKINP=0.D0
          DO IDF=1,NDFNT(KF,IPP)
            IJJ=IJ+IDF
            K=MAPDOF(1,IJJ,IPP)
            IA=MAPDOF(2,IJJ,IPP)
            IS=MAPDOF(3,IJJ,IPP)
            EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,KF)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPMDOT(KF,L+1,IP))
            ETAPMDOT(KF,L,IP)=ETAPMDOT(KF,L,IP)*AA*AA+ 
     *               0.25D0*STEP*FETAPV(L)*AA/QNOSPM(KF,L,IP)
            EKINP = 0.5D0*QNOSPM(KF,L,IP)*
     *            ETAPMDOT(KF,L,IP)*ETAPMDOT(KF,L,IP)
            PKEWANT = 0.5D0*TEMPW/FACTEM
            FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==--------------------------------------------------------------==
C     == PROPAGATE LAST CHAIN ELEMENT                                 ==
C     ==--------------------------------------------------------------==
          ETAPMDOT(KF,NCHAIN,IP)=ETAPMDOT(KF,NCHAIN,IP)+ 
     *          0.25D0*STEP*FETAPV(NCHAIN)/QNOSPM(KF,NCHAIN,IP)
C     ==-------------------------------------------------------------==
          IJ=IJ+NDFNT(KF,IPP)
        ENDDO
C     ==--------------------------------------------------------------==
C     == GLOBAL THERMOSTAT ON THE ATOMS                               ==
C     ==--------------------------------------------------------------==
      ELSE
C     ==--------------------------------------------------------------==
C     == CALCULATE ALL NOSE-HOOVER CHAIN FORCES                       ==
C     == INCLUDING CELL THERMOSTAT FORCES                             ==
C     ==--------------------------------------------------------------==
C PARTICLE KINETIC ENERGY
        EKINP=0.D0
        DO K=1,3
          DO IS=1,NSP
            CONST=0.5D0*PMA(IS)
            DO IA=1,NA(IS)
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
        ENDDO
C PARTICLE THERMOSTAT FORCES
        PKEWANT = 0.5D0*GKT(IPP,1)
        FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
        DO L=2,NCHAIN
          EKINP = 0.5D0*QNOSPC(L-1,IP)*ETAP1DOT(L-1,IP)*
     *                                 ETAP1DOT(L-1,IP)
          PKEWANT = 0.5D0*TEMPW/FACTEM
          FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
        ENDDO
C     ==--------------------------------------------------------------==
C     == MOVE LAST CHAIN ELEMENTS                                     ==
C     ==--------------------------------------------------------------==
        ETAP1DOT(NCHAIN,IP) = ETAP1DOT(NCHAIN,IP) + 
     *                 0.25D0*STEP*FETAPV(NCHAIN)/QNOSPC(NCHAIN,IP)
C     ==--------------------------------------------------------------==
C     ==  LOOP OVER REST OF NOSE-HOOVER CHAIN                         ==
C     ==--------------------------------------------------------------==
        DO L=1,NCHAIN-1
          AA = DEXP(-0.125D0*STEP*ETAP1DOT(NCHAIN+1-L,IP))
          ETAP1DOT(NCHAIN-L,IP) = ETAP1DOT(NCHAIN-L,IP)*AA*AA +
     *         0.25D0*STEP*FETAPV(NCHAIN-L)*AA/QNOSPC(NCHAIN-L,IP)
        ENDDO  
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT VELOCITY                                   ==
C     ==----------------------------------------------------------------==
       GEPS_P = HTFP(1,1) + HTFP(2,2) + HTFP(3,3)
       GEPS_V = 0.D0
       DO K=1,3
        DO IS=1,NSP
         DO IA=1,NA(IS)
            GEPS_V = GEPS_V + (1.D0 + 3.D0/AT3)*
     *                        PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)
         ENDDO
        ENDDO
       ENDDO  
       VEPS = VEPS + 0.25D0*STEP*(GEPS_P + GEPS_V)/CMASS       
C     ==----------------------------------------------------------------==
C     ==  SCALE VELOCITIES                                              ==
C     ==----------------------------------------------------------------==
      AA = DEXP(-0.5D0*STEP*((1.D0+3.D0/AT3)*VEPS + ETAP1DOT(1,IP)))
      DO IS=1,NSP
       DO IA=1,NA(IS)
          VELP(1,IA,IS) = VELP(1,IA,IS)*AA
          VELP(2,IA,IS) = VELP(2,IA,IS)*AA
          VELP(3,IA,IS) = VELP(3,IA,IS)*AA
         ENDDO
        ENDDO
C
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE THERMOSTAT POSITIONS                                ==
C     ==----------------------------------------------------------------==
        DO L=1,NCHAIN
          ETAP1(L,IP) = ETAP1(L,IP) + 0.5D0*STEP*ETAP1DOT(L,IP)
        ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT VELOCITY                                   ==
C     ==----------------------------------------------------------------==
       GEPS_P = HTFP(1,1) + HTFP(2,2) + HTFP(3,3)
       GEPS_V = 0.D0
       DO K=1,3
        DO IS=1,NSP
         DO IA=1,NA(IS)
            GEPS_V = GEPS_V + (1.D0 + 3.D0/AT3)*
     *                        PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)
         ENDDO
        ENDDO
       ENDDO  
       VEPS = VEPS + 0.25D0*STEP*(GEPS_P + GEPS_V)/CMASS       
C     ==--------------------------------------------------------------==
C     == RECALCULATE ALL NOSE-HOOVER CHAIN FORCES                     ==
C     == INCLUDING CELL THERMOSTAT FORCES                             ==
C     ==--------------------------------------------------------------==
C PARTICLE KINETIC ENERGY
        EKINP=0.D0
        DO K=1,3
          DO IS=1,NSP
            CONST=0.5D0*PMA(IS)
            DO IA=1,NA(IS)
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
        ENDDO
C PARTICLE THERMOSTAT FORCES
        PKEWANT = 0.5D0*GKT(IPP,1)
        FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
C     ==-------------------------------------------------------------==
C     ==  LOOP OVER CHAIN AGAIN                                      ==
C     ==-------------------------------------------------------------==
        DO L=1,NCHAIN-1
          AA = DEXP(-0.125D0*STEP*ETAP1DOT(L+1,IP))
          ETAP1DOT(L,IP) = ETAP1DOT(L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(L)*AA/QNOSPC(L,IP)
          EKINP = 0.5D0*QNOSPC(L,IP)*ETAP1DOT(L,IP)*ETAP1DOT(L,IP)
          PKEWANT = 0.5D0*TEMPW/FACTEM
          FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
        ENDDO
C     ==--------------------------------------------------------------==
C     == MOVE LAST CHAIN ELEMENT                                      ==
C     ==--------------------------------------------------------------==
        ETAP1DOT(NCHAIN,IP) = ETAP1DOT(NCHAIN,IP) + 
     *                 0.25D0*STEP*FETAPV(NCHAIN)/QNOSPC(NCHAIN,IP)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C
C
C     ==================================================================
      SUBROUTINE PRPNOSMOVE(VELP,STEP,IP)
C     ==--------------------------------------------------------------==
C     ==  ALLOWS FOR NOSE-HOOVER CHAIN DYNAMICS                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'metr.inc'
C     Arguments
      INTEGER IP
      REAL*8  VELP(3,NAX,NSX),STEP
C     Variables
      REAL*8  FETAPV(NCHX),HTFV(3,3),SCMAT(3,3),SCMD(3),SCMEV(3,3),
     &        VTMP1(3),AT3,EKINP,CONST,PKEWANT,AA,TRHV,
     &        AA1,AA2,AA3
      INTEGER IPP,IS,K,IA,L,IERR,IJ,KF,IDF,IJJ
C     ==--------------------------------------------------------------==
      IPP=1
      IF(TPATH.AND.TPIMD)IPP=MIN(IP,2)
      AT3 = 3.D0*DBLE(NAT)
C     ==--------------------------------------------------------------==
C     == SEPARATE THERMOSTATS ON DIFFERENT ATOMIC SPECIES             ==
C     ==--------------------------------------------------------------==
      IF(TULTRA) THEN
        DO IS=1,NSP
C     ==--------------------------------------------------------------==
C     ==  CALCULATE ALL THERMOSTAT FORCES                             ==
C     ==--------------------------------------------------------------==
          EKINP=0.D0
          CONST=0.5D0*PMA(IS)
          DO K=1,3
            DO IA=1,NA(IS)
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,IS)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=2,NCHAIN
            EKINP = 0.5D0*QNOSP(IS,L-1,IP)*ETAPDOT(IS,L-1,IP)*
     *                                     ETAPDOT(IS,L-1,IP)
            PKEWANT = 0.5D0*TEMPW/FACTEM
            FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                  ==
C     ==----------------------------------------------------------------==
          ETAPDOT(IS,NCHAIN,IP) = ETAPDOT(IS,NCHAIN,IP) + 
     *                  0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IS,NCHAIN,IP)
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE REMAINDER OF CHAIN                                  ==
C     ==----------------------------------------------------------------==
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPDOT(IS,NCHAIN+1-L,IP))
            ETAPDOT(IS,NCHAIN-L,IP) = ETAPDOT(IS,NCHAIN-L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(NCHAIN-L)*AA/QNOSP(IS,NCHAIN-L,IP)
          ENDDO
         ENDDO
C     ==--------------------------------------------------------------==
C     ==  GET VELOCITY-DEPENDENT PART OF CELL FORCE                   ==
C     ==--------------------------------------------------------------==
        CALL AZZERO(HTFV,9)
        DO IS=1,NSP
         DO IA=1,NA(IS)
          DO K=1,3
           DO L=1,3
            HTFV(K,L) = HTFV(K,L) + PMA(IS)*VELP(K,IA,IS)*VELP(L,IA,IS)
           ENDDO
           HTFV(K,K) = HTFV(K,K) + 
     *                 PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)/AT3
          ENDDO
         ENDDO
        ENDDO  
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT (CELL VELOCITY)                          ==
C     ==--------------------------------------------------------------==
       DO K=1,3
        DO L=1,3
         HTVEL(K,L) = HTVEL(K,L) +
     *                0.25D0*STEP*(HTFV(K,L) + HTFP(K,L))/CMASS
        ENDDO
       ENDDO
C     ==----------------------------------------------------------------==
C     ==  FOR VELOCITY SCALING, FORM MATRIX v_h + Tr(v_h)/N + zeta_1    ==
C     ==----------------------------------------------------------------==
       DO IS=1,NSP
        TRHV = HTVEL(1,1) + HTVEL(2,2) + HTVEL(3,3)
        DO K=1,3
         DO L=1,3
          SCMAT(K,L) = HTVEL(K,L)
         ENDDO
         SCMAT(K,K) = SCMAT(K,K) + TRHV/AT3 + ETAPDOT(IS,1,IP)
        ENDDO
C     ==----------------------------------------------------------------==
C     ==  DIAGONALIZE THIS MATRIX AND SAVE EIGENVALUES AND EIGENVECTORS ==
C     ==----------------------------------------------------------------==
       CALL JACOBI(3,3,SCMAT,SCMD,SCMEV,IERR)
C     ==----------------------------------------------------------------==
C     ==  ROTATE, SCALE, AND ROTATE BACK FOR VELOCITIES                 ==
C     ==----------------------------------------------------------------==
      AA1 = DEXP(-0.5D0*STEP*SCMD(1))
      AA2 = DEXP(-0.5D0*STEP*SCMD(2))
      AA3 = DEXP(-0.5D0*STEP*SCMD(3))
C
        DO IA=1,NA(IS)
          VTMP1(1) = SCMEV(1,1)*VELP(1,IA,IS) + SCMEV(2,1)*VELP(2,IA,IS)
     *             + SCMEV(3,1)*VELP(3,IA,IS)
          VTMP1(2) = SCMEV(1,2)*VELP(1,IA,IS) + SCMEV(2,2)*VELP(2,IA,IS)
     *             + SCMEV(3,2)*VELP(3,IA,IS)
          VTMP1(3) = SCMEV(1,3)*VELP(1,IA,IS) + SCMEV(2,3)*VELP(2,IA,IS)
     *             + SCMEV(3,3)*VELP(3,IA,IS)
C
          VTMP1(1) = VTMP1(1)*AA1
          VTMP1(2) = VTMP1(2)*AA2
          VTMP1(3) = VTMP1(3)*AA3
C
          VELP(1,IA,IS) = SCMEV(1,1)*VTMP1(1) + SCMEV(1,2)*VTMP1(2)
     *                  + SCMEV(1,3)*VTMP1(3)
          VELP(2,IA,IS) = SCMEV(2,1)*VTMP1(1) + SCMEV(2,2)*VTMP1(2)
     *                  + SCMEV(2,3)*VTMP1(3)
          VELP(3,IA,IS) = SCMEV(3,1)*VTMP1(1) + SCMEV(3,2)*VTMP1(2)
     *                  + SCMEV(3,3)*VTMP1(3)
        ENDDO
       ENDDO
C
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE THERMOSTAT POSITIONS                                ==
C     ==----------------------------------------------------------------==
        DO IS=1,NSP
          DO L=1,NCHAIN
            ETAP(IS,L,IP) = ETAP(IS,L,IP) + 0.5D0*STEP*ETAPDOT(IS,L,IP)
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  GET VELOCITY-DEPENDENT PART OF CELL FORCE                   ==
C     ==--------------------------------------------------------------==
        CALL AZZERO(HTFV,9)
        DO IS=1,NSP
         DO IA=1,NA(IS)
          DO K=1,3
           DO L=1,3
            HTFV(K,L) = HTFV(K,L) + PMA(IS)*VELP(K,IA,IS)*VELP(L,IA,IS)
           ENDDO
           HTFV(K,K) = HTFV(K,K) + 
     *                 PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)/AT3
          ENDDO
         ENDDO
        ENDDO  
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT (CELL VELOCITY)                          ==
C     ==--------------------------------------------------------------==
       DO K=1,3
        DO L=1,3
         HTVEL(K,L) = HTVEL(K,L) +
     *                0.25D0*STEP*(HTFV(K,L) + HTFP(K,L))/CMASS
        ENDDO
       ENDDO
C     ==----------------------------------------------------------------==
C     == LOOP AGAIN OVER CHAIN                                          ==
C     ==----------------------------------------------------------------==
        DO IS=1,NSP
          EKINP=0.D0
          CONST=0.5D0*PMA(IS)
          DO K=1,3
            DO IA=1,NA(IS)
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,IS)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPDOT(IS,L+1,IP))
            ETAPDOT(IS,L,IP) = ETAPDOT(IS,L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(L)*AA/QNOSP(IS,L,IP)
            EKINP = 0.5D0*QNOSP(IS,L,IP)*ETAPDOT(IS,L,IP)*
     *                                   ETAPDOT(IS,L,IP)
            PKEWANT = 0.5D0*TEMPW/FACTEM
            FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE LAST CHAIN ELEMENT                                  ==
C     ==----------------------------------------------------------------==
          ETAPDOT(IS,NCHAIN,IP) = ETAPDOT(IS,NCHAIN,IP) + 
     *                  0.25D0*STEP*FETAPV(NCHAIN)/QNOSP(IS,NCHAIN,IP)
        ENDDO
C     ==--------------------------------------------------------------==
C     == SEPARATE THERMOSTATS ON EVERY DEGREE OF FREEDOM              ==
C     ==--------------------------------------------------------------==
      ELSEIF(TMNOSE) THEN
C     ==--------------------------------------------------------------==
C     ==  LOOP BACKWARDS OVER NOSE-HOOVER CHAIN                       ==
C     ==--------------------------------------------------------------==
        IJ=0
        DO KF=1,NTHERM(IPP)
C     ==--------------------------------------------------------------==
C     == CALCULATE ALL THERMOSTAT FORCES                              ==
C     ==--------------------------------------------------------------==
          EKINP=0.D0
          DO IDF=1,NDFNT(KF,IPP)
            IJJ=IJ+IDF
            K=MAPDOF(1,IJJ,IPP)
            IA=MAPDOF(2,IJJ,IPP)
            IS=MAPDOF(3,IJJ,IPP)
            CONST=0.5D0*PMA(IS)
            EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,KF)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=2,NCHAIN
            EKINP = 0.5D0*QNOSPM(KF,L-1,IP)*
     *            ETAPMDOT(KF,L-1,IP)*ETAPMDOT(KF,L-1,IP)
            PKEWANT = 0.5D0*TEMPW/FACTEM
            FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==--------------------------------------------------------------==
C     == PROPAGATE LAST CHAIN ELEMENT                                 ==
C     ==--------------------------------------------------------------==
          ETAPMDOT(KF,NCHAIN,IP)=ETAPMDOT(KF,NCHAIN,IP)+ 
     *          0.25D0*STEP*FETAPV(NCHAIN)/QNOSPM(KF,NCHAIN,IP)
C     ==--------------------------------------------------------------==
C     == PROPAGATE REST OF CHAIN                                      ==
C     ==--------------------------------------------------------------==
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*
     *                   ETAPMDOT(KF,NCHAIN+1-L,IP))
            ETAPMDOT(KF,NCHAIN-L,IP) = 
     *            ETAPMDOT(KF,NCHAIN-L,IP)
     *            *AA*AA+0.25D0*STEP*FETAPV(NCHAIN-L)
     *            *AA/QNOSPM(KF,NCHAIN-L,IP)
          ENDDO
          IJ=IJ+NDFNT(KF,IPP)
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  GET VELOCITY-DEPENDENT PART OF CELL FORCE                   ==
C     ==--------------------------------------------------------------==
        CALL AZZERO(HTFV,9)
        DO IS=1,NSP
         DO IA=1,NA(IS)
          DO K=1,3
           DO L=1,3
            HTFV(K,L) = HTFV(K,L) + PMA(IS)*VELP(K,IA,IS)*VELP(L,IA,IS)
           ENDDO
           HTFV(K,K) = HTFV(K,K) + 
     *                 PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)/AT3
          ENDDO
         ENDDO
        ENDDO  
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT (CELL VELOCITY)                          ==
C     ==--------------------------------------------------------------==
       DO K=1,3
        DO L=1,3
         HTVEL(K,L) = HTVEL(K,L) +
     *                0.25D0*STEP*(HTFV(K,L) + HTFP(K,L))/CMASS
        ENDDO
       ENDDO
C     ==----------------------------------------------------------------==
C     == DO VELOCITY SCALING AND PROPAGATE THERMOSTAT POSITIONS         ==
C     ==----------------------------------------------------------------==
       KF=0
       DO IS=1,NSP
        DO IA=1,NA( IS )
C     ==----------------------------------------------------------------==
C     ==  FOR VELOCITY SCALING, FORM MATRIX v_h + Tr(v_h)/N + zeta_1    ==
C     ==----------------------------------------------------------------==
        TRHV = HTVEL(1,1) + HTVEL(2,2) + HTVEL(3,3)
        DO K=1,3
         DO L=1,3
          SCMAT(K,L) = HTVEL(K,L)
         ENDDO
         KF=KF+1
         SCMAT(K,K) = SCMAT(K,K) + TRHV/AT3 + ETAPMDOT(KF,1,IP)
        ENDDO
C     ==----------------------------------------------------------------==
C     ==  DIAGONALIZE THIS MATRIX AND SAVE EIGENVALUES AND EIGENVECTORS ==
C     ==----------------------------------------------------------------==
       CALL JACOBI(3,3,SCMAT,SCMD,SCMEV,IERR)
C     ==----------------------------------------------------------------==
C     ==  ROTATE, SCALE, AND ROTATE BACK FOR VELOCITIES                 ==
C     ==----------------------------------------------------------------==
       AA1 = DEXP(-0.5D0*STEP*SCMD(1))
       AA2 = DEXP(-0.5D0*STEP*SCMD(2))
       AA3 = DEXP(-0.5D0*STEP*SCMD(3))
C
          VTMP1(1) = SCMEV(1,1)*VELP(1,IA,IS) + SCMEV(2,1)*VELP(2,IA,IS)
     *             + SCMEV(3,1)*VELP(3,IA,IS)
          VTMP1(2) = SCMEV(1,2)*VELP(1,IA,IS) + SCMEV(2,2)*VELP(2,IA,IS)
     *             + SCMEV(3,2)*VELP(3,IA,IS)
          VTMP1(3) = SCMEV(1,3)*VELP(1,IA,IS) + SCMEV(2,3)*VELP(2,IA,IS)
     *             + SCMEV(3,3)*VELP(3,IA,IS)
C
          VTMP1(1) = VTMP1(1)*AA1
          VTMP1(2) = VTMP1(2)*AA2
          VTMP1(3) = VTMP1(3)*AA3
C
          VELP(1,IA,IS) = SCMEV(1,1)*VTMP1(1) + SCMEV(1,2)*VTMP1(2)
     *                  + SCMEV(1,3)*VTMP1(3)
          VELP(2,IA,IS) = SCMEV(2,1)*VTMP1(1) + SCMEV(2,2)*VTMP1(2)
     *                  + SCMEV(2,3)*VTMP1(3)
          VELP(3,IA,IS) = SCMEV(3,1)*VTMP1(1) + SCMEV(3,2)*VTMP1(2)
     *                  + SCMEV(3,3)*VTMP1(3)
        ENDDO
       ENDDO
C
C     ==----------------------------------------------------------------==
C     == PROPAGATE THERMOSTAT POSITIONS                                 ==
C     ==----------------------------------------------------------------==
        DO KF=1,NTHERM(IPP)
          DO L=1,NCHAIN
            ETAPM(KF,L,IP) = ETAPM(KF,L,IP) + 
     *                     0.5D0*STEP*ETAPMDOT(KF,L,IP)
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  GET VELOCITY-DEPENDENT PART OF CELL FORCE                   ==
C     ==--------------------------------------------------------------==
        CALL AZZERO(HTFV,9)
        DO IS=1,NSP
         DO IA=1,NA(IS)
          DO K=1,3
           DO L=1,3
            HTFV(K,L) = HTFV(K,L) + PMA(IS)*VELP(K,IA,IS)*VELP(L,IA,IS)
           ENDDO
           HTFV(K,K) = HTFV(K,K) + 
     *                 PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)/AT3
          ENDDO
         ENDDO
        ENDDO  
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT (CELL VELOCITY)                          ==
C     ==--------------------------------------------------------------==
       DO K=1,3
        DO L=1,3
         HTVEL(K,L) = HTVEL(K,L) +
     *                0.25D0*STEP*(HTFV(K,L) + HTFP(K,L))/CMASS
        ENDDO
       ENDDO
C     ==-------------------------------------------------------------==
C     ==  LOOP OVER CHAIN AGAIN                                      ==
C     ==-------------------------------------------------------------==
        IJ=0
        DO KF=1,NTHERM(IPP)
          CONST=0.5D0*PMA(IS)
          EKINP=0.D0
          DO IDF=1,NDFNT(KF,IPP)
            IJJ=IJ+IDF
            K=MAPDOF(1,IJJ,IPP)
            IA=MAPDOF(2,IJJ,IPP)
            IS=MAPDOF(3,IJJ,IPP)
            EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
          ENDDO
          PKEWANT = 0.5D0*GKT(IPP,KF)
          FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
          DO L=1,NCHAIN-1
            AA = DEXP(-0.125D0*STEP*ETAPMDOT(KF,L+1,IP))
            ETAPMDOT(KF,L,IP)=ETAPMDOT(KF,L,IP)*AA*AA+ 
     *               0.25D0*STEP*FETAPV(L)*AA/QNOSPM(KF,L,IP)
            EKINP = 0.5D0*QNOSPM(KF,L,IP)*
     *             ETAPMDOT(KF,L,IP)*ETAPMDOT(KF,L,IP)
            PKEWANT = 0.5D0*TEMPW/FACTEM
            FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
          ENDDO
C     ==--------------------------------------------------------------==
C     == PROPAGATE LAST CHAIN ELEMENT                                 ==
C     ==--------------------------------------------------------------==
          ETAPMDOT(KF,NCHAIN,IP)=ETAPMDOT(KF,NCHAIN,IP)+ 
     *           0.25D0*STEP*FETAPV(NCHAIN)/QNOSPM(KF,NCHAIN,IP)
C     ==-------------------------------------------------------------==
          IJ=IJ+NDFNT(KF,IPP)
        ENDDO
C     ==--------------------------------------------------------------==
C     == GLOBAL THERMOSTAT ON THE ATOMS                               ==
C     ==--------------------------------------------------------------==
      ELSE
C     ==--------------------------------------------------------------==
C     == CALCULATE ALL NOSE-HOOVER CHAIN FORCES                       ==
C     == INCLUDING CELL THERMOSTAT FORCES                             ==
C     ==--------------------------------------------------------------==
C PARTICLE KINETIC ENERGY
        EKINP=0.D0
        DO K=1,3
          DO IS=1,NSP
            CONST=0.5D0*PMA(IS)
            DO IA=1,NA(IS)
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
        ENDDO
C PARTICLE THERMOSTAT FORCES
        PKEWANT = 0.5D0*GKT(IPP,1)
        FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
        DO L=2,NCHAIN
          EKINP = 0.5D0*QNOSPC(L-1,IP)*ETAP1DOT(L-1,IP)*
     *                                 ETAP1DOT(L-1,IP)
          PKEWANT = 0.5D0*TEMPW/FACTEM
          FETAPV(L) = 2.0D0*(EKINP - PKEWANT)
        ENDDO
C     ==--------------------------------------------------------------==
C     == MOVE LAST CHAIN ELEMENTS                                     ==
C     ==--------------------------------------------------------------==
        ETAP1DOT(NCHAIN,IP) = ETAP1DOT(NCHAIN,IP) + 
     *                 0.25D0*STEP*FETAPV(NCHAIN)/QNOSPC(NCHAIN,IP)
C     ==--------------------------------------------------------------==
C     ==  LOOP OVER REST OF NOSE-HOOVER CHAIN                         ==
C     ==--------------------------------------------------------------==
        DO L=1,NCHAIN-1
          AA = DEXP(-0.125D0*STEP*ETAP1DOT(NCHAIN+1-L,IP))
          ETAP1DOT(NCHAIN-L,IP) = ETAP1DOT(NCHAIN-L,IP)*AA*AA +
     *         0.25D0*STEP*FETAPV(NCHAIN-L)*AA/QNOSPC(NCHAIN-L,IP)
        ENDDO  
C     ==--------------------------------------------------------------==
C     ==  GET VELOCITY-DEPENDENT PART OF CELL FORCE                   ==
C     ==--------------------------------------------------------------==
        CALL AZZERO(HTFV,9)
        DO IS=1,NSP
         DO IA=1,NA(IS)
          DO K=1,3
           DO L=1,3
            HTFV(K,L) = HTFV(K,L) + PMA(IS)*VELP(K,IA,IS)*VELP(L,IA,IS)
           ENDDO
           HTFV(K,K) = HTFV(K,K) + 
     *                 PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)/AT3
          ENDDO
         ENDDO
        ENDDO  
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT (CELL VELOCITY)                          ==
C     ==--------------------------------------------------------------==
       DO K=1,3
        DO L=1,3
         HTVEL(K,L) = HTVEL(K,L) +
     *                0.25D0*STEP*(HTFV(K,L) + HTFP(K,L))/CMASS
        ENDDO
       ENDDO
C     ==----------------------------------------------------------------==
C     ==  FOR VELOCITY SCALING, FORM MATRIX v_h + Tr(v_h)/N + v_zeta1   ==
C     ==----------------------------------------------------------------==
        TRHV = HTVEL(1,1) + HTVEL(2,2) + HTVEL(3,3)
        DO K=1,3
         DO L=1,3
          SCMAT(K,L) = HTVEL(K,L)
         ENDDO
         SCMAT(K,K) = SCMAT(K,K) + TRHV/AT3 + ETAP1DOT(1,IP)
        ENDDO
C     ==----------------------------------------------------------------==
C     ==  DIAGONALIZE THIS MATRIX AND SAVE EIGENVALUES AND EIGENVECTORS ==
C     ==----------------------------------------------------------------==
       CALL JACOBI(3,3,SCMAT,SCMD,SCMEV,IERR)
C     ==----------------------------------------------------------------==
C     ==  ROTATE, SCALE, AND ROTATE BACK FOR VELOCITIES                 ==
C     ==----------------------------------------------------------------==
      AA1 = DEXP(-0.5D0*STEP*SCMD(1))
      AA2 = DEXP(-0.5D0*STEP*SCMD(2))
      AA3 = DEXP(-0.5D0*STEP*SCMD(3))
      DO IS=1,NSP
       DO IA=1,NA(IS)
C
          VTMP1(1) = SCMEV(1,1)*VELP(1,IA,IS) + SCMEV(2,1)*VELP(2,IA,IS)
     *             + SCMEV(3,1)*VELP(3,IA,IS)
          VTMP1(2) = SCMEV(1,2)*VELP(1,IA,IS) + SCMEV(2,2)*VELP(2,IA,IS)
     *             + SCMEV(3,2)*VELP(3,IA,IS)
          VTMP1(3) = SCMEV(1,3)*VELP(1,IA,IS) + SCMEV(2,3)*VELP(2,IA,IS)
     *             + SCMEV(3,3)*VELP(3,IA,IS)
C
          VTMP1(1) = VTMP1(1)*AA1
          VTMP1(2) = VTMP1(2)*AA2
          VTMP1(3) = VTMP1(3)*AA3
C
          VELP(1,IA,IS) = SCMEV(1,1)*VTMP1(1) + SCMEV(1,2)*VTMP1(2)
     *                  + SCMEV(1,3)*VTMP1(3)
          VELP(2,IA,IS) = SCMEV(2,1)*VTMP1(1) + SCMEV(2,2)*VTMP1(2)
     *                  + SCMEV(2,3)*VTMP1(3)
          VELP(3,IA,IS) = SCMEV(3,1)*VTMP1(1) + SCMEV(3,2)*VTMP1(2)
     *                  + SCMEV(3,3)*VTMP1(3)
         ENDDO
        ENDDO
C
C     ==----------------------------------------------------------------==
C     ==  PROPAGATE THERMOSTAT POSITIONS                                ==
C     ==----------------------------------------------------------------==
        DO L=1,NCHAIN
          ETAP1(L,IP) = ETAP1(L,IP) + 0.5D0*STEP*ETAP1DOT(L,IP)
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  GET VELOCITY-DEPENDENT PART OF CELL FORCE                   ==
C     ==--------------------------------------------------------------==
        CALL AZZERO(HTFV,9)
        DO IS=1,NSP
         DO IA=1,NA(IS)
          DO K=1,3
           DO L=1,3
            HTFV(K,L) = HTFV(K,L) + PMA(IS)*VELP(K,IA,IS)*VELP(L,IA,IS)
           ENDDO
           HTFV(K,K) = HTFV(K,K) + 
     *                 PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)/AT3
          ENDDO
         ENDDO
        ENDDO  
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT (CELL VELOCITY)                          ==
C     ==--------------------------------------------------------------==
       DO K=1,3
        DO L=1,3
         HTVEL(K,L) = HTVEL(K,L) +
     *                0.25D0*STEP*(HTFV(K,L) + HTFP(K,L))/CMASS
        ENDDO
       ENDDO
C     ==--------------------------------------------------------------==
C     == RECALCULATE ALL NOSE-HOOVER CHAIN FORCES                     ==
C     == INCLUDING CELL THERMOSTAT FORCES                             ==
C     ==--------------------------------------------------------------==
C PARTICLE KINETIC ENERGY
        EKINP=0.D0
        DO K=1,3
          DO IS=1,NSP
            CONST=0.5D0*PMA(IS)
            DO IA=1,NA(IS)
              EKINP=EKINP+CONST*VELP(K,IA,IS)*VELP(K,IA,IS)
            ENDDO
          ENDDO
        ENDDO
C PARTICLE THERMOSTAT FORCES
        PKEWANT = 0.5D0*GKT(IPP,1)
        FETAPV(1) = 2.0D0*(EKINP - PKEWANT)
C     ==-------------------------------------------------------------==
C     ==  LOOP OVER CHAIN AGAIN                                      ==
C     ==-------------------------------------------------------------==
        DO L=1,NCHAIN-1
          AA = DEXP(-0.125D0*STEP*ETAP1DOT(L+1,IP))
          ETAP1DOT(L,IP) = ETAP1DOT(L,IP)*AA*AA +
     *             0.25D0*STEP*FETAPV(L)*AA/QNOSPC(L,IP)
          EKINP = 0.5D0*QNOSPC(L,IP)*ETAP1DOT(L,IP)*ETAP1DOT(L,IP)
          PKEWANT = 0.5D0*TEMPW/FACTEM
          FETAPV(L+1) = 2.0D0*(EKINP - PKEWANT)
        ENDDO
C     ==--------------------------------------------------------------==
C     == MOVE LAST CHAIN ELEMENT                                      ==
C     ==--------------------------------------------------------------==
        ETAP1DOT(NCHAIN,IP) = ETAP1DOT(NCHAIN,IP) + 
     *                 0.25D0*STEP*FETAPV(NCHAIN)/QNOSPC(NCHAIN,IP)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================











