C     ==================================================================
      SUBROUTINE PRPT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'ddip.inc'
C     Variables
      REAL*8  C0(*),CM(*),C2(*),SC0(*),GAMX(*),GAMY(*), VPP(*)
      POINTER (IP_C0,C0),(IP_CM,CM),(IP_C2,C2), (IP_VPP,VPP),
     *        (IP_SC0,SC0),(IP_GAMX,GAMX), (IP_GAMY,GAMY)
      INTEGER NC,NCM,NC2,NCS,NSTATE,NSTX,NVPP
#ifdef PARALLEL
      INTEGER    NXXFUN
      EXTERNAL   NXXFUN
#endif
C     ==--------------------------------------------------------------==
C     ==  MEMORY ALLOCATION                                           ==
C     ==--------------------------------------------------------------==
C     ==  C0         WF POSITIONS                                     ==
C     ==  CM         WF VELOCITIES                                    ==
C     ==  C2         WF FORCES                                        ==
C     ==  SC0        S*C0 (only Vanderbilt)                           ==
C     ==  GAMX       CONSTRAINT MATRIX POSITIONS                      ==
C     ==  GAMY       CONSTRAINT MATRIX VELOCITIES                     ==
C     ==--------------------------------------------------------------==
      IF(TQMMM) CALL STOPGM('PRPT','QM/MM NOT IMPLEMENTED')
      IF(BSYMM) CALL STOPGM('PRPT','BROKEN SYMMETRY NOT IMPLEMENTED')
C     ==--------------------------------------------------------------==
      NSTATE = N
C     ==--------------------------------------------------------------==
      NC=2*NGW*NSTATE+8
      NCM=NC
      NVPP=8
      LENBK=0
      IF(TDIPD) THEN
#ifdef PARALLEL
        LENBK=NXXFUN(NSTATE)
        NC2=MAX(2*LENBK*NPROC,NC)
        NCS=NC2
#else
        NC2=NC
        NCS=NC
#endif
      ELSE
        NC=2*NGW*N+8
        NC2=2*NGW*N+8
        NCS=1
        IF(TIVAN.OR.NONORT) NCS=NC
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TMDBO) THEN
        NVPP=2*NGWK
        IF(TDIAG) THEN
          IF(TDAVI) THEN
            IF(NDAVV.EQ.0) THEN
              NDAVV=2*NSTATE
            ELSE
              NDAVV=MIN(NDAVV+NSTATE,2*NSTATE)
            ENDIF
            NSTATE=NDAVV
          ENDIF
          IF(TFRSBLK)THEN
            NCM=2*NGWK*MAX(NSTATE,(NKRY_MAX+1)*NKRY_BLOCK)+8
          ELSEIF(DIIS) THEN
            NCM=(2*NGWK*NSTATE+8)*MDIIS*NKPNT+
     &          ((2*NGWK*NSTATE+8)*MDIIS*NKPNT)/4
          ELSE
            NCM=2*NGWK*MAX(NSTATE,NKRY_MAX*NKRY_BLOCK)+8
          ENDIF
          NC2=2*NGWK*MAX(NUMAORMAX,NSTATE)+8
          IF(TDAVI)NCM=NCM*2
        ELSEIF(DIIS) THEN
          NCM=(2*NGWK*NSTATE+8)*MDIIS+((2*NGWK*NSTATE+8)*MDIIS)/4+100
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_C0,NC,'C0')
      CALL MEMORY(IP_C2,NC2,'C2')
      CALL MEMORY(IP_CM,NCM,'CM')
      CALL MEMORY(IP_SC0,NCS,'SC0')
      CALL MEMORY(IP_VPP,NVPP,'VPP')
      IF(TDMAL) THEN
        CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
        CALL MEMORY(IP_GAMX,NSTATE*NSTX,'GAMX') 
        CALL MEMORY(IP_GAMY,NSTATE*NSTX,'GAMY') 
      ELSE
        CALL MEMORY(IP_GAMX,NSTATE*NSTATE,'GAMX') 
        CALL MEMORY(IP_GAMY,NSTATE*NSTATE,'GAMY') 
      ENDIF
C     ==--------------------------------------------------------------==
C     FNL
      CALL FNLALLOC(N,.TRUE.,.TRUE.)
      IF(PARENT) CALL PRMEM('      MDPT')
C     ==--------------------------------------------------------------==
      IF(TMDBO) THEN
        IF(TPENN.OR.TSHOCK) THEN
          CALL NPT_BOMD(C0,CM,C2,SC0,VPP,GAMX,GAMY)
        ELSE
          CALL STOPGM("PRPT","not implemented")
        ENDIF
      ELSE
        IF(TPENN.OR.TSHOCK) THEN
          CALL NPT_CPMD(C0,CM,C2,SC0,GAMX,GAMY)
        ELSE
          CALL PRCPMD(C0,CM,C2,SC0,GAMX,GAMY)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TMEMCHK) CALL PRINT_MEMORY
      CALL FREEM(IP_C0)
      CALL FREEM(IP_CM)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_SC0)
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_GAMX)
      CALL FREEM(IP_GAMY)
      CALL FNLDEALLOC(.TRUE.,.TRUE.)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
