C     ==================================================================
      SUBROUTINE PTHEORY(C0,CS,SC0,WE,ADAV,VPOT,PSI,SCR,LSCR,
     &                   NSTATE,IKIND,NHPSI)
C     ==--------------------------------------------------------------==
C     == CHANGES THE STATES ACCORDING TO FIRST-ORDER PERTUBATION      ==
C     == THEORY                                                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'kpts.inc'
C     Arguments
      INTEGER    NSTATE,IKIND,NHPSI,LSCR
      COMPLEX*16 C0(NGWK,NSTATE),CS(NGWK,NSTATE),SC0(NGWK,*),
     &           ADAV(NSTATE,NSTATE),PSI(NNR1)
      REAL*8     WE(NSTATE),VPOT(NNR1),SCR(LSCR)
C     Variables
      INTEGER    ISPIN
      PARAMETER  (ISPIN=1)
      COMPLEX*16 ZZERO,ZONE
      PARAMETER  (ZZERO=(0.D0,0.D0),ZONE=(1.D0,0.D0))
      CHARACTER  TAG*30
      INTEGER    I,J,ISUB,LPTHEORY
      REAL*8     FACTOR
C     ==--------------------------------------------------------------==
      CALL TISET('   PTHEORY',ISUB)
      CALL GIVE_SCR_PTHEORY(LPTHEORY,TAG,NSTATE)
      CALL TEST_SCR('PTHEORY',TAG,LSCR,LPTHEORY)
C     ==--------------------------------------------------------------==
      IF(TKPNT) THEN
        CALL  HPSI(C0,CS,SC0,VPOT,PSI,SCR,LSCR,NSTATE,IKIND,ISPIN)
        CALL OVLAP_H(NSTATE,ADAV,C0,CS)
        DO I=1,NSTATE
          ADAV(I,I)=DCMPLX(0.D0,0.D0) 
          DO J=I+1,NSTATE
            IF(TTROT) THEN
              FACTOR=-(EXP(-BETAP*WE(J))-EXP(-BETAP*WE(I)))/
     &             (WE(J)-WE(I))**2
            ELSE
              FACTOR=-1.D0/(WE(J)-WE(I))
            ENDIF
            ADAV(J,I)=ADAV(J,I)*FACTOR
            ADAV(I,J)=DCONJG(ADAV(J,I))
          ENDDO
        ENDDO
        CALL ZGEMM('N','N',NGWK,NSTATE,NSTATE,ZONE,C0,NGWK,
     &       ADAV,NSTATE,ZZERO,CS,NGWK)
        DO I=1,NSTATE
          CALL DAXPY(NGWK*2,CS(1,I),1,ZONE,C0(1,I),1)
        ENDDO
        CALL RGS_C(C0,NSTATE,ADAV,SCR)
      ELSE
        CALL STOPGM('PTHEORY',' TKPNT .FALSE.')
      ENDIF
      NHPSI=NHPSI+1
      CALL TIHALT('   PTHEORY',ISUB)
C     ==--------------------------------------------------------------==
      RETURN 
      END 
C     ==================================================================
      SUBROUTINE GIVE_SCR_PTHEORY(LPTHEORY,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGWK
C     Arguments
      INTEGER   LPTHEORY,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_HPSI(LPTHEORY,TAG,NSTATE)
      LPTHEORY=MAX(LPTHEORY,NSTATE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
