C     ==================================================================
      SUBROUTINE PURGE(TAU0,FION)
C     ==--------------------------------------------------------------==
C     ==  PURGE FORCES ALONG CONSTRAINT COORDINATES                   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      REAL*8    TAU0(3,NAX,NSX),FION(3,NAX,NSX)
C     Variables
      LOGICAL   TCONST
      INTEGER   ITYP,I,INFO,IA,IB,MSGLEN,ICON,ISET
      REAL*8    XA(3),XB(3),DX(3),FO(6),SO(6),BMAT(6,6),BINV(6,6)
      REAL*8    RAB,THETA,PHI,F1,F2,SCR(36)
C     ==--------------------------------------------------------------==
      IF(MCNSTR.LT.1) RETURN
      IF(MCNSTR.GT.1) CALL STOPGM('PURGE','NOT IMPLEMENTED')
      IF(PARENT) THEN
        ICON=1
        ITYP=NTCNST(1,ICON)
        IF(ITYP.EQ.1.OR.ITYP.EQ.4) THEN
          IA=NTCNST(2,ICON)
          CALL GETCO(IA,TAU0,XA)
          CALL GETCO(IA,FION,FO)
          IB=NTCNST(3,ICON)
          CALL GETCO(IB,TAU0,XB)
          CALL GETCO(IB,FION,FO(4))
          CALL AZZERO(BMAT,36)
          DX(1)=XB(1)-XA(1)
          DX(2)=XB(2)-XA(2)
          DX(3)=XB(3)-XA(3)
          RAB=SQRT(DX(1)*DX(1)+DX(2)*DX(2)+DX(3)*DX(3))
          THETA=ACOS(DX(3)/RAB)
          PHI=ASIN(DX(2)/SQRT(DX(1)*DX(1)+DX(2)*DX(2)))
          IF(ABS(COS(PHI)).LT.1.D-10) THEN
            PHI=ACOS(DX(1)/SQRT(DX(1)*DX(1)+DX(2)*DX(2)))
            ISET=2
          ELSE
            ISET=1
          ENDIF
          IF(ITYP.EQ.1) CNSVAL(ICON)=RAB*RAB
          IF(ITYP.EQ.4) CNSVAL(ICON)=RAB
C..center of bond
          BMAT(1,1)=0.5D0
          BMAT(1,4)=0.5D0
          BMAT(2,2)=0.5D0
          BMAT(2,5)=0.5D0
          BMAT(3,3)=0.5D0
          BMAT(3,6)=0.5D0
C..rab
          BMAT(4,1)=-DX(1)/RAB
          BMAT(4,2)=-DX(2)/RAB
          BMAT(4,3)=-DX(3)/RAB
          BMAT(4,4)= DX(1)/RAB
          BMAT(4,5)= DX(2)/RAB
          BMAT(4,6)= DX(3)/RAB
C..Theta
          F1=DX(3)/RAB**3/SIN(THETA)
          F2=1.D0/RAB/SIN(THETA)
          BMAT(5,1)=-DX(1)*F1
          BMAT(5,2)=-DX(2)*F1
          BMAT(5,3)=-DX(3)*F1+F2
          BMAT(5,4)= DX(1)*F1
          BMAT(5,5)= DX(2)*F1
          BMAT(5,6)= DX(3)*F1-F2
C..phi
          IF(ISET.EQ.1) THEN
            F1=DX(2)/DCOS(PHI)/(DX(1)*DX(1)+DX(2)*DX(2))**1.5D0
            F2=1.D0/DCOS(PHI)/DSQRT(DX(1)*DX(1)+DX(2)*DX(2))
            BMAT(6,1)= DX(1)*F1
            BMAT(6,2)= DX(2)*F1-F2
            BMAT(6,4)=-DX(1)*F1
            BMAT(6,5)=-DX(2)*F1+F2
          ELSE
            F1=-DX(1)/DSIN(PHI)/(DX(1)*DX(1)+DX(2)*DX(2))**1.5D0
            F2=-1.D0/DSIN(PHI)/DSQRT(DX(1)*DX(1)+DX(2)*DX(2))
            BMAT(6,1)= DX(1)*F1-F2
            BMAT(6,2)= DX(2)*F1
            BMAT(6,4)=-DX(1)*F1+F2
            BMAT(6,5)=-DX(2)*F1
          ENDIF
C
          IF(LSHOVE) THEN
            I=NTCNST(6,ICON)
            IF(I.EQ.0) THEN
              TCONST=.TRUE.
            ELSE
              TCONST=.FALSE.
              CALL DGEMV('N',6,6,1.D0,BMAT,6,FO,1,0.D0,SO,1)
              IF(I.GT.0.AND.SO(4).LT.0.D0) TCONST=.TRUE.
              IF(I.LT.0.AND.SO(4).GT.0.D0) TCONST=.TRUE.
            ENDIF
          ELSE
            TCONST=.TRUE.
          ENDIF
          IF(TCONST) THEN
            CALL DCOPY(36,BMAT,1,BINV,1)
            CALL INVMAT(6,BINV,SCR,INFO)
            IF(INFO.NE.0) CALL STOPGM('PURGE','BINV INVALID')
            DO I=1,10
              CALL DGEMV('N',6,6,1.D0,BMAT,6,FO,1,0.D0,SO,1)
              IF(ABS(SO(4)).LT.1.D-12) GOTO 10
              SO(4)=0.D0
              CALL DGEMV('N',6,6,1.D0,BINV,6,SO,1,0.D0,FO,1)
            ENDDO
            CALL STOPGM('PURGE','ITERATION DID NOT CONVERGE')
  10        CONTINUE
            CALL PUTCO(IA,FION,FO(1))
            CALL PUTCO(IB,FION,FO(4))
          ENDIF
        ELSE
          CALL STOPGM('PURGE','NOT IMPLEMENTED')
        ENDIF
      ENDIF
      MSGLEN=3*NAX*NSP * 8
      CALL MY_BCAST(FION,MSGLEN,SOURCE,ALLGRP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETCO(IAT,TAU,T)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INTEGER IAT,IA,IS,I0
      REAL*8  TAU(3,NAX,*),T(3)
C     ==--------------------------------------------------------------==
      I0=0
      DO IS=1,NSP
        IF(I0.LT.IAT.AND.I0+NA(IS).GE.IAT) THEN
          IA=IAT-I0
          T(1)=TAU(1,IA,IS)
          T(2)=TAU(2,IA,IS)
          T(3)=TAU(3,IA,IS)
          GOTO 100
        ELSE
          I0=I0+NA(IS)
        ENDIF
      ENDDO
      CALL STOPGM('GETCO','ATOM NUMBER OUT OF RANGE')
  100 CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PUTCO(IAT,TAU,T)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INTEGER IAT,IA,IS,I0
      REAL*8  TAU(3,NAX,*),T(3)
C     ==--------------------------------------------------------------==
      I0=0
      DO IS=1,NSP
        IF(I0.LT.IAT.AND.I0+NA(IS).GE.IAT) THEN
          IA=IAT-I0
          TAU(1,IA,IS)=T(1)
          TAU(2,IA,IS)=T(2)
          TAU(3,IA,IS)=T(3)
          GOTO 100
        ELSE
          I0=I0+NA(IS)
        ENDIF
      ENDDO
      CALL STOPGM('PUTCO','ATOM NUMBER OUT OF RANGE')
  100 CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
