C     ==================================================================
      SUBROUTINE PUTBET(IKPT)
C     ==--------------------------------------------------------------==
C     == COMPUTES THE ARRAY BETAA WHICH IS USED IN NLSM1_S ROUTINE    ==
C     == BETAA IS THE DERIVATIVE OF TWNL VERSUS STRAIN                ==
C     == R -> (1 + e) R                                               ==
C     == G -> (1 - e) G                                               ==
C     ==--------------------------------------------------------------==
C     == IKPT is for block option the block index                     ==
C     ==         otherwise is not useful                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc' 
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER   IKPT
C     Variables
      DIMENSION TWNS(NSPLPO,2,NHXS,NSX),GGNG(NSPLPO),
     &          HGKP(NHG,NKPNT),HGKM(NHG,NKPNT),RK(3,NKPTS) 
      REAL*8    VOL,VOLTPI,TW,DW,AUX1,AUX2,YLMKR, 
     &          CURV2,CURVD,YLMR,DYLMRX,DYLMRKX
      INTEGER   IS,IV,LP,IG1,KK,IG,ISTEP,IKIND,IKK,NKPOINT
C     ==--------------------------------------------------------------==
      NKPOINT=NKPBL(IKPT)
      DO IKIND=1,NKPOINT
        IKK=KPBEG(IKPT)+IKIND
        VOL=1.D0/SQRT(OMEGA)
        VOLTPI=VOL/TPIBA2
        DO IS=1,NSP
          DO IV=1,NGH(IS)
            IF(TVAN(IS)) THEN
              ISTEP=NVALES(IS)*NVALES(IS)
              LP=1+MOD(IV-1,ISTEP)
            ELSEIF(TKB(IS)) THEN
              LP=NGHCOM(IV,IS)
            ELSEIF(TSGP(IS)) THEN
              LP=LPVAL(IV,IS)
            ELSE
              LP = (IV-1)/NINT(RMAXN(IS)) + 1
            ENDIF
C           0-component
            IF(GEQ0) THEN
              IF(TKPNT) THEN
                IF(  (RK(1,IKIND).EQ.0.D0).AND.
     &               (RK(2,IKIND).EQ.0.D0).AND.
     &               (RK(3,IKIND).EQ.0.D0) ) THEN
                  IG1=2
                  TW=TWNS(1,1,IV,IS)
                  DO KK=1,6
                    BETAA(    1,IV,KK,IS,IKIND)=DYLMRKX(LP,1,GK(1,1),
     &                   RK(1,IKK),GAGKP(1,1,IKIND),KK, 1)*TW*VOL
                    BETAA(NGW+1,IV,KK,IS,IKIND)=DYLMRKX(LP,1,GK(1,1),
     &                   RK(1,IKK),GAGKM(1,1,IKIND),KK,-1)*TW*VOL
                  ENDDO
                ELSE
                  IG1=1
                ENDIF
              ELSE
                IG1=2
                TW=TWNS(1,1,IV,IS)
                DO KK=1,6
                  BETAA(1,IV,KK,IS,IKIND)=DYLMRX(LP,1,GK(1,1),KK)*TW*VOL
                ENDDO
              ENDIF
            ELSE
              IG1=1
            ENDIF
C           K points version
            IF(TKPNT) THEN 
              DO IG=IG1,NGW
C               RK+GK (GAGKP)
                TW=CURV2(HGKP(IG,IKIND),NSPLPO,GGNG(1),
     &               TWNS(1,1,IV,IS),TWNS(1,2,IV,IS),0.0D0)*VOL
                DW=-2.D0*CURVD(HGKP(IG,IKIND),NSPLPO,GGNG(1),
     &               TWNS(1,1,IV,IS),TWNS(1,2,IV,IS),0.0D0)
     &               *VOLTPI
                DO KK=1,6
                  AUX1=DYLMRKX(LP,IG,GK(1,1),RK(1,IKK),GAGKP(1,1,IKIND),
     &                 KK, 1)*TW
                  AUX2=YLMKR(LP,IG,GK(1,1),RK(1,IKK), 1)*
     &                 DW*GAGKP(IG,KK,IKIND)
                  BETAA(IG,IV,KK,IS,IKIND)=AUX1+AUX2
                ENDDO
C               RK-GK (GAGKM)
                TW=CURV2(HGKM(IG,IKIND),NSPLPO,GGNG(1),
     *               TWNS(1,1,IV,IS),TWNS(1,2,IV,IS),0.0D0)*VOL
                DW=-2.D0*CURVD(HGKM(IG,IKIND),NSPLPO,GGNG(1),
     *               TWNS(1,1,IV,IS),TWNS(1,2,IV,IS),0.0D0)
     &               *VOLTPI
                DO KK=1,6
                  AUX1=DYLMRKX(LP,IG,GK(1,1),RK(1,IKK),GAGKM(1,1,IKIND),
     &                 KK,-1)*TW
                  AUX2=YLMKR(LP,IG,GK(1,1),RK(1,IKK),-1)*
     &                 DW*GAGKM(IG,KK,IKIND)
                  BETAA(NGW+IG,IV,KK,IS,IKIND)=AUX1+AUX2
                ENDDO
              ENDDO
            ELSE
C             Gamma point
#ifdef __SR8000
*poption parallel, tlocal(IG,KK,TW,DW,AUX1,AUX2)
#endif 
!$OMP parallel do private(IG,KK,TW,DW,AUX1,AUX2)
              DO IG=IG1,NGW
                TW=CURV2(HG(IG),NSPLPO,GGNG(1),TWNS(1,1,IV,IS),
     *               TWNS(1,2,IV,IS),0.0D0)*VOL
                DW=-2.D0*CURVD(HG(IG),NSPLPO,GGNG(1),TWNS(1,1,IV,IS),
     *               TWNS(1,2,IV,IS),0.0D0)
     &               *VOLTPI
                DO KK=1,6
                  AUX1=DYLMRX(LP,IG,GK(1,1),KK)*TW
                  AUX2=YLMR(LP,IG,GK(1,1))*DW*GAGK(IG,KK)  
                  BETAA(IG,IV,KK,IS,IKIND)=AUX1+AUX2                   
                ENDDO
              ENDDO
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
