C     ==================================================================
      SUBROUTINE PUTTAU(TAU,XPAR)
C     ==--------------------------------------------------------------==
C     == PUT TAU0 NON FIXED(GIVEN BY LSKCOR) IN XPAR                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'        !NODIM
C     Arguments
      REAL*8  TAU(3,NAX,NSX),XPAR(NODIM)
C     Variables
      INTEGER K,IAT,IS,IA,L
C     ==--------------------------------------------------------------==
      K=0
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO L=1,3
            IF(LSKCOR(L,IAT).NE.0) THEN
              K=K+1
              XPAR(K) = TAU(L,IA,IS)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETTAU(TAU,XPAR)
C     ==--------------------------------------------------------------==
C     == GET XPAR IN TAU0                                             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'        !NODIM
C     Arguments
      REAL*8  TAU(3,NAX,NSX),XPAR(NODIM)
C     Variables
      INTEGER K,IAT,IS,IA,L
C     ==--------------------------------------------------------------==
      K=0
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO L=1,3
            IF(LSKCOR(L,IAT).NE.0) THEN
              K=K+1
              TAU(L,IA,IS) = XPAR(K)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TAUCL(TAU)
C     ==--------------------------------------------------------------==
C     == CLEAR COORDINATES WHERE LSKCOR(L,IAT).EQ.0                   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
C     Arguemnts
      REAL*8  TAU(3,NAX,NSX)
C     Variables
      INTEGER K,IAT,IS,IA,L
C     ==--------------------------------------------------------------==
      K=0
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO L=1,3
            IF(LSKCOR(L,IAT).EQ.0) TAU(L,IA,IS)=0.0D0
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ADDTAU(TAU,FAC,XPAR)
C     ==--------------------------------------------------------------==
C     == UNUSED ROUTINE                                               ==
C     == ADD FAC*XPAR(1:NODIM) TO TAU                                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'        !NODIM
C     Arguments
      REAL*8 TAU(3,NAX,NSX),XPAR(NODIM),FAC
C     Variables
      INTEGER K,IAT,IS,IA,L
C     ==--------------------------------------------------------------==
      K=0
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO L=1,3
            IF(LSKCOR(L,IAT).NE.0) THEN
              K=K+1
              TAU(L,IA,IS) = TAU(L,IA,IS) + FAC * XPAR(K)
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETATM(NU,TAU,ACOR)
C     ==--------------------------------------------------------------==
C     == Retrive Coordiantes of Atom IAT                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
C     Arguments
      REAL*8  TAU(3,NAX,NSX),ACOR(3)
      INTEGER NU
C     Variables
      INTEGER IAT,IS,IA
C     ==--------------------------------------------------------------==
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          IF(IAT.EQ.NU) THEN
            ACOR(1) = TAU(1,IA,IS)
            ACOR(2) = TAU(2,IA,IS)
            ACOR(3) = TAU(3,IA,IS)
          ENDIF
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

