C     ==================================================================
      SUBROUTINE QRADA_S(JL,FINT)
C     ==--------------------------------------------------------------==
C     ==  THIS ROUTINE INITALIZES ARRAYS   BETAA QRADA                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'aavan.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
C     Arguments
      REAL*8 JL(*),FINT(*)
C     Variables
      DIMENSION QRADA(NQDIM,NBRX,NBRX,LX,NSX),GGNH(NSPLPO)
      REAL*8    QSP1(NSPLPO),QSP2(NSPLPO),QSP3(4*NSPLPO)
      POINTER   (IP_QSP1,QSP1),(IP_QSP2,QSP2),(IP_QSP3,QSP3)
      INTEGER   ISUB,IS,LVAL,NT,ISTEP,LQX,L,IV,JV,IL,IR,IERR,MMAX
      REAL*8    GGL,XG,FQRAD,
     &          CURV2
C     ==--------------------------------------------------------------==
      CALL TISET('   QRADA_S',ISUB)
      CALL MEMORY(IP_QSP1,NSPLPO,'QSP1')
      CALL MEMORY(IP_QSP2,NSPLPO,'QSP2')
      CALL MEMORY(IP_QSP3,4*NSPLPO,'QSP3')
      DO IS=1,NSP
        IF(TVAN(IS)) THEN
          LVAL=NVALES(IS)
          NT=NVALES(IS)
          MMAX=KKBETA(IS)
          ISTEP=NT*NT
C     ==--------------------------------------------------------------==
C     ==  CALCULATION OF ARRAY  QRADA(IGL,IV,JV,IS)
C     ==--------------------------------------------------------------==
          LQX=2*(LVAL-1)+1
          IF(QSPLINE) THEN
C..QRADA is calculated on the fly from the spline function for qrad
          ELSE
C..This is not fully correct! Qrada is calculated from a spline in 
C  G space, qrada should be calculated as the derivative of the same 
C  function. But this is only for static calculations (Parrinello-Rahman
C  runs are always with QSPLINE=.TRUE.) and the introduced error is
C  very small
            CALL DCOPY(NSPLPO,GGNH,1,QSP1,1)
            DO L=1,LQX
              DO IV=1,NBETA(IS)
                DO JV=IV,NBETA(IS)
                  CALL AZZERO(QSP2,NSPLPO)
                  DO IL=NSPLPA,NSPLPE
                    GGL=GGNH(IL)
                    XG=SQRT(GGL)*TPIBA
                    CALL DBESS(XG,L,MMAX,R(1,IS),JL)
                    IF(TPSEU(IS)) THEN
                      DO IR=1,MMAX
                        FINT(IR)=QRL(IR,IV,JV,L,IS)*JL(IR)
                      ENDDO
                    ELSE
                      DO IR=1,MMAX
                        FINT(IR)=QFUNC(IR,IV,JV,IS)*JL(IR)
                      ENDDO
                    ENDIF
                    IF(TLOG(IS)) THEN
                      CALL RADLG(MMAX,FINT,RAB(1,IS),FQRAD)
                    ELSE
                      CALL RADIN(MMAX,CMESH(IS),FINT,FQRAD)
                    ENDIF
                    QSP2(IL)=FPI*FQRAD
                  ENDDO
                  CALL GLOSUM(NSPLPO,QSP2)
                  CALL CURV1(NSPLPO,QSP1(1),QSP2(1),0.0d0,0.0d0,3,
     *                 QSP3(1),FINT,0.0d0,IERR)
                  DO IL=1,NHGL
                    GGL=GL(IL)
                    QRADA(IL,IV,JV,L,IS)=
     *               CURV2(GGL,NSPLPO,QSP1(1),QSP2(1),QSP3(1),0.0d0)
                    QRADA(IL,JV,IV,L,IS)=QRADA(IL,IV,JV,L,IS)
                  ENDDO
                ENDDO
              ENDDO
            ENDDO
          ENDIF
        ENDIF
      ENDDO
      CALL FREEM(IP_QSP1)
      CALL FREEM(IP_QSP2)
      CALL FREEM(IP_QSP3)
      CALL TIHALT('   QRADA_S',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
