C     ==================================================================
      SUBROUTINE QUENBO(C0,C2,SC0,TAUR,RHOE,PSI,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'ener.inc' 
      INCLUDE 'elct.inc' 
      INCLUDE 'tpar.inc' 
      INCLUDE 'pslo.inc' 
      INCLUDE 'norm.inc' 
      INCLUDE 'ropt.inc' 
      INCLUDE 'cppt.inc' 
      INCLUDE 'coor.inc' 
      INCLUDE 'nlcc.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'irat.inc'

C     Arguments
      INTEGER    LSCR
      COMPLEX*16 C0(NGW,*),C2(NGW,*),SC0(*),PSI(*)
      REAL*8     RHOE(*),SCR(*),TAUR(3,NAX,*)
C     Variables
      COMPLEX*16 PME(*),GDE(*)
      REAL*8     VPP(*),EIGV(*),THL(2)
      POINTER    (IP_PME,PME),(IP_GDE,GDE),
     *           (IP_VPP,VPP),(IP_EIGV,EIGV)
      CHARACTER  TAG*30
      REAL*8     ETOTO,TIME1,TIME2,TCPU,TIMEF
      EXTERNAL   TIMEF
      INTEGER    LQUENBO,NNFI,NMIN
      logical update_pot
C     ==--------------------------------------------------------------==
      if(qmnode)then
        CALL GIVE_SCR_QUENBO(LQUENBO,TAG)
        CALL TEST_SCR('QUENBO',TAG,LSCR,LQUENBO)
C     ==--------------------------------------------------------------==
        IF(PARENT) WRITE(6,'(/,A,A,/)') 
     *           ' >>>>>>>> QUENCH SYSTEM TO THE ',
     *           'BORN-OPPENHEIMER SURFACE <<<<<<<< '
        CALL MEMORY(IP_EIGV,N,'EIGV')
        IF(TSDE) THEN
          CALL MEMORY(IP_PME,N,'PME')
          CALL MEMORY(IP_GDE,N,'GDE')
          CALL MEMORY(IP_VPP,NGW,'VPP')
        ELSE IF(DIIS) THEN
          CALL MEMORY(IP_PME,(NGW*N+8)*MDIIS,'PME')
          CALL MEMORY(IP_GDE,((NGW*N+8)*MDIIS)/4,'GDE')
          CALL MEMORY(IP_VPP,NGW,'VPP')
        ELSE IF(PCG) THEN
          CALL MEMORY(IP_PME,2*NGW*N,'PME')
          CALL MEMORY(IP_GDE,N,'GDE')
          CALL MEMORY(IP_VPP,NGW,'VPP')
        ELSE
          DIIS=.TRUE.
          PREC=.TRUE.
          MDIIS=MIN(MDIIS,MAXDIS)
          CALL MEMORY(IP_PME,(NGW*N+8)*MDIIS,'PME')
          CALL MEMORY(IP_GDE,((NGW*N+8)*MDIIS)/4,'GDE')
          CALL MEMORY(IP_VPP,NGW,'VPP')
        ENDIF
        IF(PARENT) CALL PRMEM('    QUENBO')
        CONVWF=.FALSE.
        SDIIS=.TRUE. 
        SPCG=.TRUE. 
        MODENS=.FALSE.
        ENGPRI=.FALSE.
        IF(.NOT.TPRCP) CALSTE=.FALSE.
        ETOTO=0.0D0
      else
        NMIN = 10
        CALL MEMORY(IP_EIGV,NMIN,'EIGV')
        CALL MEMORY(IP_PME,NMIN,'PME')
        CALL MEMORY(IP_GDE,NMIN,'GDE')
        CALL MEMORY(IP_VPP,NMIN,'VPP')
      endif
C     ==--------------------------------------------------------------==
C     ==      THE BASIC LOOP FOR WAVEFUNCTION OPTIMIZATION            ==
C     ==--------------------------------------------------------------==
      IINFI=0
      update_pot=.true.
  100 CONTINUE
        TIME1=TIMEF()
C       UPDATE THE WAVEFUNCTIONS
! qmmm: this is for skipping the full electrostatic coupling when IINFI> 0
! (the potential at fixed ions does not change)
        if(qmmm .and. IINFI.gt.0 ) update_pot=.false.
        CALL UPDWF(C0,C2,SC0,TAU0,TAUR,PME,GDE,VPP,EIGV,
     &             RHOE,PSI,SCR,LSCR,N,.FALSE.,update_pot)

C       PRINTOUT THE EVOLUTION OF THE ITERATIVE OPTIMIZATION
        IF(PARENT) THEN
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
          NNFI=IINFI+1
          CALL WRPRINT_WFOPT(EIGV,F,AMU,N,ETOT,ETOTO,TCPU,
     &                       GEMAX,CNORM,THL,CONVWF,NNFI,IINFI)
        ENDIF
        IINFI=IINFI+1
        if(qmmm)call my_bcast(CONVWF,8/IRAT,QMMMSOURCE,QMMMGRP)
      IF(.NOT.CONVWF) GOTO 100
C     ==--------------------------------------------------------------==
C     ==     END OF MAIN LOOP                                         ==
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_PME)
      CALL FREEM(IP_GDE)
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_EIGV)
C.. apsi 061101: Added the 'IF' (suggested by Daniel Sebastiani)
      IF (qmmm) call MY_SYNC(QMMMGRP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_QUENBO(LQUENBO,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'elct.inc'        !N
C     Arguments
      INTEGER   LQUENBO
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_UPDWF(LQUENBO,TAG,N,.FALSE.)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
