C     =====================================================================
      SUBROUTINE QVAN2(IV,JV,IS,QG)
C     ==-----------------------------------------------------------------==
C     ==  Q(G,L,K) = SUM_LM (-I)^L AP(LM,L,K) YR_LM(G^) QRAD(G,L,L,K)    ==
C     ==-----------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'aavan.inc'
      INCLUDE 'qspl.inc'
C     Arguments
      INTEGER IV,JV,IS
      REAL*8  QG(2,NHG)
C     Variables
      DIMENSION  QRAD(NQDIM,NBRX,NBRX,LX,NSP),YLMB(NHG,LPMAX),
     &           GGNH(NSPLPO)
      REAL*8     SPLINE(NHG)
      POINTER    (IP_SPLINE,SPLINE)
      COMPLEX*16 SIG
      REAL*8     VOL,SIGR,SIGI,
     &           CURV2
      INTEGER    IVS,JVS,ISTEP,IVL,JVL,I,LP,L,IG,
     &           IFIRST
      DATA       IFIRST /0/
      SAVE       IFIRST,IP_SPLINE
C     ==-----------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN
        IFIRST=1
        IF(QSPLINE) THEN
          CALL MEMORY(IP_SPLINE,NHG,'SPLINE')
        ENDIF
      ENDIF
C     ==-----------------------------------------------------------------==
C     ==  IV  = 1..8    ! s_1 p_x1 p_z1 p_y1 s_2 p_x2 p_z2 p_y2          ==
C     ==  IVS = 1..4    ! s_1 s_2 p_1 p_2                                ==
C     ==  IVL = 1..4    ! s p_x p_z p_y                                  ==
C     ==                                                                 ==
C     == NOTE :   IV  = 1..8 (sppp sppp)  IVS = 1..4 (sspp) OR 1..2 (sp) ==
C     ==    IVL = 1..4 (sppp)                                            ==
C     ==-----------------------------------------------------------------==
      VOL=1.D0/OMEGA
      IVS=INDV(IV,IS)
      JVS=INDV(JV,IS)
      ISTEP=NGH(IS)/NELEV(IS)
      IVL=1+MOD(IV-1,ISTEP)
      JVL=1+MOD(JV-1,ISTEP)
      IF(IVL.GT.NLX)  CALL STOPGM(' QVAN ',' IVL.GT.NLX  ')
      IF(JVL.GT.NLX)  CALL STOPGM(' QVAN ',' JVL.GT.NLX  ')
      IF(IVS.GT.NBRX) CALL STOPGM(' QVAN ',' IVS.GT.NBRX ')
      IF(JVS.GT.NBRX) CALL STOPGM(' QVAN ',' JVS.GT.NBRX ')
      CALL AZZERO(QG,2*NHG)
      DO I=1,LPX(IVL,JVL)
        LP=LPL(IVL,JVL,I)
C     EXTRACTION OF ANGULAR MOMENTUM L FROM LP:
        IF(LP.GE.26) CALL STOPGM(' QVAN ',' LP.GE.26 ')
        L=NINT(SQRT(DBLE(LP))+0.499999d0)
C         
        SIG=(0.d0,-1.d0)**(L-1)
        SIGR=DREAL(SIG)
        SIGI=DIMAG(SIG)
        IF(QSPLINE) THEN
C         SPLINE
          DO IG=1,NHG
            SPLINE(IG)=VOL*CURV2(HG(IG),NSPLPO,GGNH(1),
     *                       QRAD(1,IVS,JVS,L,IS),
     *                       QRAD(NSPLPO+1,IVS,JVS,L,IS),0.0d0)
          ENDDO
          IF(ABS(SIGR).GT.0.5D0) THEN
            SIGR=SIGR*AP(LP,IVL,JVL)
            DO IG=1,NHG
              QG(1,IG)=QG(1,IG)+SIGR*YLMB(IG,LP)*SPLINE(IG)
            ENDDO
          ELSE
            SIGI=SIGI*AP(LP,IVL,JVL)
            DO IG=1,NHG
              QG(2,IG)=QG(2,IG)+SIGI*YLMB(IG,LP)*SPLINE(IG)
            ENDDO
          ENDIF
        ELSE
          IF(ABS(SIGR).GT.0.5D0) THEN
            SIGR=SIGR*AP(LP,IVL,JVL)
            DO IG=1,NHG
              QG(1,IG)=QG(1,IG)+
     *               VOL*SIGR*YLMB(IG,LP)*QRAD(IGL(IG),IVS,JVS,L,IS)
            ENDDO
          ELSE
            SIGI=SIGI*AP(LP,IVL,JVL)
            DO IG=1,NHG
              QG(2,IG)=QG(2,IG)+
     *               VOL*SIGI*YLMB(IG,LP)*QRAD(IGL(IG),IVS,JVS,L,IS)
            ENDDO
          ENDIF
        ENDIF
      ENDDO
C     ==-----------------------------------------------------------------==
      RETURN
      END
C     =====================================================================
