C     ==================================================================
      SUBROUTINE RANC(TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'metr.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSP)
C     Variables
      REAL*8  TX(3),
     &        XRANF
      EXTERNAL XRANF
      INTEGER I,J,IS,IA
#ifdef PARALLEL
      INTEGER MSGLEN
#endif
C     ==--------------------------------------------------------------==
C     ==           Randomization of cell parameters                   ==
C     ==--------------------------------------------------------------==
      WRITE(6,'(A)') ' RANDOMIZATION - CELL PARAMETERS '
      DO I=1,3
        DO J=1,3
          HT(I,J)=HT(I,J)+AMPRC*(XRANF()-0.5D0)
        ENDDO
      ENDDO
      DO IS=1,NSP
        DO IA=1,NA(IS)
          CALL DGEMV('T',3,3,1.0D0,HTM1,3,TAU0(1,IA,IS),1,0.0D0,TX,1)
          CALL DGEMV('T',3,3,1.0D0,HT,3,TX,1,0.0D0,TAU0(1,IA,IS),1)
        ENDDO
      ENDDO
      CALL IHMAT(HT,HTM1,OMEGA)
#ifdef PARALLEL
      MSGLEN = 9 * 8
      CALL MY_BCAST(HT,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 9 * 8
      CALL MY_BCAST(HTM1,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
