C     ==================================================================
      SUBROUTINE RATTLE(TAU0,VELP)
C     ==--------------------------------------------------------------==
C     ==  GENERAL CONSTRAINTS ON VELOCITIES FOR VELOCITY VERLET       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      REAL*8    TAU0(3,NAX,*),VELP(3,NAX,*)
C     Variables
      REAL*8    TOLS,TOLX
      PARAMETER (TOLS=1.D-12,TOLX=1.D-8)
      REAL*8    ASL(MCNSTR,*),TSCR(3,NAX,*),DX(*),DV(*),
     &          AUX(*)
      POINTER   (IP_TSCR,TSCR),(IP_DX,DX),(IP_ASL,ASL),(IP_DV,DV),
     *          (IP_AUX,AUX)
      REAL*8    ERRX,CNMAX,XVAL
      REAL*8    DASUM
      EXTERNAL  DASUM
      INTEGER   NAUX,I,J,K,INFO,NRANK,
     &          ISTART
      DATA      ISTART /0/
      SAVE      ISTART,IP_TSCR,IP_DX,IP_DV,IP_ASL,IP_AUX
      LOGICAL   OLDSTATUS
C     ==--------------------------------------------------------------==
      IF(MCNSTR.EQ.0) RETURN
      IF(LSHOVE .AND. ISTART.NE.0) THEN
        XVAL=DASUM(MCNSTR,KSHOVE,1)
        IF(XVAL.LT.0.5D0) RETURN
      ENDIF
C      moved out of the if to keep in initialized (Joost) ...
      NAUX   =6*NODIM+MCNSTR
      IF(ISTART.EQ.0) THEN
c       ISTART =1
C       NAUX   =6*NODIM+MCNSTR

C       AK: we need to make sure that TSCR is large enough for QM/MM
        CALL mm_dim(mm_go_mm,OLDSTATUS)
        CALL MEMORY(IP_TSCR,3*NAX*NSX,'TSCR')
        CALL MEMORY(IP_DX,NODIM,'DX')
        CALL MEMORY(IP_DV,NODIM,'DV')
        CALL MEMORY(IP_ASL,MCNSTR*MCNSTR,'ASL')
        CALL MEMORY(IP_AUX,NAUX,'AUX')
        CALL mm_dim(mm_revert,OLDSTATUS)
      ENDIF
      CALL AZZERO(DX,NODIM)
      CALL CNSTFC(TAU0,TSCR,DX,CNMAX,.TRUE.)
      CALL PUTTAU(VELP,DX)
      CALL AZZERO(ASL,MCNSTR*MCNSTR)
      DO I=1,MCNSTR
        IF(LSHOVE.AND. ISTART.NE.0 ) THEN
          IF(KSHOVE(I).LT.0.5D0) CALL AZZERO(ANORM(1,I),NODIM)
        ENDIF
        DV(I)=0.D0
        DO J=1,NODIM
          DV(I)=DV(I)+ANORM(J,I)*DX(J)
        ENDDO
        DO J=1,MCNSTR
          DO K=1,NODIM
            ASL(I,J)=ASL(I,J)+ANORM(K,I)*ANORM(K,J)*DTM(K)/DT_IONS/2.D0
          ENDDO
        ENDDO
      ENDDO
      IF(ISTART.EQ.0) ISTART =1
      CALL DGELSS(MCNSTR,MCNSTR,1,ASL,MCNSTR,DV,MCNSTR,FC,1.D-12,NRANK,
     *            AUX,NAUX,INFO)
      IF(INFO.NE.0) CALL STOPGM('RATTLE','DGELSS ENDED WITH INFO.NE.0')
      DO I=1,MCNSTR
        YLAGR(I)=DV(I)
      ENDDO
      DO J=1,NODIM
        DV(J)=0.D0
        DO I=1,MCNSTR
          DV(J)=DV(J)-YLAGR(I)*ANORM(J,I)*DTM(J)/DT_IONS/2.0D0
        ENDDO
      ENDDO
      DO J=1,NODIM
        DX(J)=DX(J)+DV(J)
      ENDDO
      CALL GETTAU(VELP,DX)
C     Check accuracy
      DO I=1,MCNSTR
        FC(I)=0.D0
        DO J=1,NODIM
          FC(I)=FC(I)+ANORM(J,I)*DX(J)
        ENDDO
      ENDDO
      ERRX=DASUM(MCNSTR,FC(1),1)
      IF(ERRX.GT.TOLX) THEN
        WRITE(6,*) ' RATTLE| Constraint can not be fulfilled'
        CALL STOPGM('RATTLE',' ')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
