C     ==================================================================
      subroutine read_prop
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'efld.inc'
      include 'irat.inc'
      include 'gvec.inc'
      include 'td_input.inc'
C
C     Variables
      integer    msglen,icall,zlolen,iunit,ierr,inscan
      real*8     extf(*)
      character  line*100
C   
      if(parent) write(6,'(/,a,a)') 
     *  ' ********************** PROPAGATION TD-',
     *                              'DFT ********************** '
C     ==--------------------------------------------------------------==
C     ==-  read input parameters for MD run                          -==
C     ==--------------------------------------------------------------==
      if(.not.parent) goto 9999

      iunit = 5
      ierr=inscan(iunit,'&PTDDFT')
      if(ierr.ne.0) then
        write(6,*) ' read_prop input section &PTDDFT not found'
        call stopgm('read_prop',' ')
      endif
C
      if (tmdeh) then
       nzeros    = 6
       tintrvll  = delt_elec
       n_cycles  = 1
       epsil     = 1.0D-10
       ampl      = 1.0D-15
       pertdir   = 1
       pert_type = 1
       read_wf   = 0
       tdfreq    = 0.0
       stextpot  = .false.
       td_extpot  = .false.
       tpointch  = .false.
       pcht0     = 0.D0
       pchdt     = 0.D0
       pchint    = 0.D0
       pchfx     = 0.D0
       pchfy     = 0.D0
       pchfz     = 0.D0
       pchwr     = 0
       gswtt     = 250
       gdfreq    = 0.00025
       gimax     = 0
       nperiod   = 5
       pi_pulse  = .false.
       muij      = 1.0
       tkgauge   = .false.
       kgauge    = 0
       tcurr     = .false.
       curr_step = 100
       start_real=.false.
      elseif(tpspec.or.tpdist) then
       nzeros    = 6
       tintrvll  = 0.05
       n_cycles  = nomore
       epsil     = 1.0D-10
       ampl      = 1.0D-15
       pertdir   = 1
       pert_type = 1
       read_wf   = 0
       tdfreq    = 0.0
       stextpot  = .false.
       td_extpot  = .false.
       tpointch  = .false.
       pcht0     = 0.D0
       pchdt     = 0.D0
       pchint    = 0.D0
       pchfx     = 0.D0
       pchfy     = 0.D0
       pchfz     = 0.D0
       pchwr     = 0
       gswtt     = 250
       gdfreq    = 0.00025
       gimax     = 0
       nperiod   = 5
       pi_pulse  = .false.
       muij      = 0.0
       tkgauge   = .false.
       kgauge    = 0
       tcurr     = .false.
       curr_step = 100
       start_real=.false.
      endif
      ppcorr=.false.
      tberry=.false.
      ttransg   =.false.

113   continue
      read(iunit,*,end=144) line
      IF(INDEX(LINE,'&END').NE.0) GOTO 144

      if(index(line,"NUMBER_ZEROS").ne.0)then
       read(IUNIT,*) nzeros
      endif
      if(index(line,"ACCURACY").ne.0)then
        read(IUNIT,*) epsil
      endif
      if(index(line,"PROP_TSTEP").ne.0)then
        read(IUNIT,*) tintrvll
      endif
      if(index(line,"N_CYCLES").ne.0)then
        read(IUNIT,*) n_cycles
      endif
      if(index(line,"EXT_POTENTIAL").ne.0)then
       stextpot = .true.
      endif
      if(index(line,"EXT_PULSE").ne.0)then
       stextpot = .true.
       pert_type=1
       read(IUNIT,*) ampl
      endif
      if(index(line,"TD_POTENTIAL").ne.0)then
       td_extpot = .true.
       read(IUNIT,*) tdfreq
      endif
      if(index(line,"POINT_CHARGE").ne.0)then
       tpointch = .true.
       read(IUNIT,*) pcht0,pchdt,pchint,pchfx,pchfy,pchfz,pchwr
      endif
      if(index(line,"PERT_TYPE").ne.0)then
        read(IUNIT,*) pert_type
      endif
      if(index(line,"PERT_AMPLI").ne.0)then
        read(IUNIT,*) ampl
      endif
      if(index(line,"PERT_DIRECTION").ne.0)then
        read(IUNIT,*) pertdir
      endif
      if(index(line,"RESTART").ne.0)then
        read(IUNIT,*) read_wf
      endif
      if(index(line,"PIPULSE").ne.0)then
       pi_pulse = .true.
       read(IUNIT,*) muij
      endif
      if(index(line,"GAUGEFIELD PARA").ne.0)then
       read(IUNIT,*) gswtt,gdfreq,gimax
      endif
      if(index(line,"GAUGEPULSE PARA").ne.0)then
       read(IUNIT,*) nperiod
      endif
      if(index(line,"GAUGE_VECTOR").ne.0)then
       tkgauge=.true.
       read(IUNIT,*) kgauge
      endif
      if(index(line,"PPCORR").ne.0)then
       ppcorr=.true.
      endif
      if(index(line,"BERRY").ne.0)then
       tberry=.true.
      endif
      if(index(line,"CAL_CURRENT").ne.0)then
       tcurr=.true.
       read(IUNIT,*) curr_step
      endif
      goto 113

144   continue

C     ==--------------------------------------------------------------==
C     ==-  read input parameters for MD run                          -==
C     ==--------------------------------------------------------------==
      if (tmdeh) then
C
       if(delt_elec.ne.0.d0) then
        if (tintrvll.ne.delt_elec) then
          if (parent)
     &    write(6,'(A,F5.2)')
     &      ' WARNING: time step setted to ', delt_elec,' au'
          tintrvll=delt_elec
          delt_ions=delt_elec
        endif
       else
          delt_elec=tintrvll
          delt_ions=tintrvll
       endif
C
       if (cheby) then
        write(6,'(1X,2("="),62("-"))')
        write(6,'(1X,("number of zeros           :"),I5)')  nzeros
        write(6,'(1X,("epsilon for max           :"),F15.9)')epsil
        write(6,'(1X,("time intervall            :"),F15.9)')tintrvll
        write(6,'(1X,("number of cycles          :"),I5)') n_cycles
        if (read_wf.eq.1) 
     &   write(6,'(1X,("read excit. wfs           :"))')
        if (read_wf.eq.2)
     &   write(6,'(1X,("read wfs from RESTART.1   :"))')
        if (stextpot) then
         write(6,'(1X,("perturbation amplitude    :"),F15.9)')ampl
         write(6,'(1X,("perturbation direction    :"),I5)') pertdir
         write(6,'(1X,("type of perturbation      :"),I5)') pert_type
         if (pert_type.eq.1)
     &     write(6,*) 'PULSE (DIRAC) FIELD'
         if (pert_type.eq.2)
     &     write(6,*) 'CONSTATN (HEAVISIDE) FIELD'
         write(6,'(1X,2("="),62("-"))')
        endif
        if (tgaugef) then
         write(6,'(1X,("perturbation amplitude    :"),F15.9)')ampl
         write(6,'(1X,("perturbation direction    :"),I5)') pertdir
         write(6,'(1X,("perturbation frequency    :"),F15.9)') gfreq
        endif
        write(6,'(1X,2("="),62("-"))')
       elseif (cayley) then
        write(6,'(1X,2("="),62("-"))')
        write(6,'(1X,("number of subintervalls   :"),I5)')  nzeros
        write(6,'(1X,("epsilon for max           :"),F15.9)')epsil
        write(6,'(1X,("time intervall            :"),F15.9)')tintrvll
        write(6,'(1X,("number of cycles          :"),I5)') n_cycles
        if (read_wf.eq.1) 
     &   write(6,'(1X,("read excit. wfs           :"))')
        if (read_wf.eq.2)
     &   write(6,'(1X,("read wfs from RESTART.1   :"))')
        if (stextpot) then
         write(6,'(1X,("perturbation amplitude    :"),F15.9)')ampl
         write(6,'(1X,("perturbation direction    :"),I5)') pertdir
         write(6,'(1X,("type of perturbation      :"),I5)') pert_type
         if (pert_type.eq.1)
     &     write(6,*) 'PULSE (DIRAC) FIELD'
         if (pert_type.eq.2)
     &     write(6,*) 'CONSTATN (HEAVISIDE) FIELD'
         write(6,'(1X,2("="),62("-"))')
         if (td_extpot) then
           write(6,*) 'Time dep. external potential for CAYLEY'
           write(6,*) 'not implemented'
           stop
         endif
        endif
        if (tgaugef) then
         write(6,'(1X,("perturbation amplitude    :"),F15.9)')ampl
         write(6,'(1X,("perturbation direction    :"),I5)') pertdir
         write(6,'(1X,("perturbation frequency    :"),F15.9)') gfreq
        endif
        write(6,'(1X,2("="),62("-"))')
       endif
C
      elseif(tpspec.or.tpdist) then

        write(6,'(1X,2("="),62("-"))')
        write(6,'(1X,("number of zeros           :"),I5)')  nzeros
        write(6,'(1X,("epsilon for max           :"),F15.9)')epsil
        write(6,'(1X,("time intervall            :"),F15.9)')tintrvll
        write(6,'(1X,("number of cycles          :"),I5)') n_cycles
        if (read_wf.eq.1)
     &   write(6,'(1X,("read excit. wfs           :"))')
        if (stextpot) then
         write(6,'(1X,("perturbation amplitude    :"),F15.9)')ampl
         write(6,'(1X,("perturbation direction    :"),I5)') pertdir
         write(6,'(1X,("type of perturbation      :"),I5)') pert_type
         if (pert_type.eq.1)
     &     write(6,*) 'PULSE (DIRAC) FIELD'
         if (pert_type.eq.2)
     &     write(6,*) 'CONSTATN (HEAVISIDE) FIELD'
         write(6,'(1X,2("="),62("-"))')
        endif

      endif 
     
      if (ppcorr) then
       write(6,'(/,A)') " GAUGEING OF THE NON-LOCAL PSEUDOPOTENTIALS"
      endif

 9999 continue
C     
C     BROADCAST INPUT PARAMETERS
C     --------------------------
      msglen = 1 * 4
      call my_bcast(nzeros,msglen,source,allgrp)
      call my_bcast(n_cycles,msglen,source,allgrp)
      call my_bcast(pertdir,msglen,source,allgrp)
      call my_bcast(pert_type,msglen,source,allgrp)
      call my_bcast(read_wf,msglen,source,allgrp)
      call my_bcast(stextpot,msglen,source,allgrp)
      call my_bcast(td_extpot,msglen,source,allgrp)
      call my_bcast(tpointch,msglen,source,allgrp)
      call my_bcast(pchwr,msglen,source,allgrp)
      call my_bcast(pi_pulse,msglen,source,allgrp)
      call my_bcast(nperiod,msglen,source,allgrp)
      call my_bcast(gimax,msglen,source,allgrp)
      call my_bcast(tkgauge,msglen,source,allgrp)
      call my_bcast(kgauge,msglen,source,allgrp)
      call my_bcast(tcurr,msglen,source,allgrp)
      call my_bcast(curr_step,msglen,source,allgrp)
      call my_bcast(ppcorr,msglen,source,allgrp)
      call my_bcast(tberry,msglen,source,allgrp)
      msglen = 1 * 8
      call my_bcast(tintrvll,msglen,source,allgrp)
      call my_bcast(delt_ions,msglen,source,allgrp)
      call my_bcast(delt_elec,msglen,source,allgrp)
      call my_bcast(epsil,msglen,source,allgrp)
      call my_bcast(ampl,msglen,source,allgrp)
      call my_bcast(tdfreq,msglen,source,allgrp)
      call my_bcast(pcht0,msglen,source,allgrp)
      call my_bcast(pchdt,msglen,source,allgrp)
      call my_bcast(pchint,msglen,source,allgrp)
      call my_bcast(pchfx,msglen,source,allgrp)
      call my_bcast(pchfy,msglen,source,allgrp)
      call my_bcast(pchfz,msglen,source,allgrp)
      call my_bcast(gswtt,msglen,source,allgrp)
      call my_bcast(gdfreq,msglen,source,allgrp)
      call my_bcast(muij,msglen,source,allgrp)
C
C     SOME TESTS AND SETTINGS
C     -----------------------
      if (read_wf.ne.0) start_real=.true.
      if(parent) write(6,'(a)')
     *          ' Start from real wavefunctions in RESTART.1'
      if ((stextpot.and.(pert_type.gt.1)) .or.
     &     td_extpot .or.
     &     tpointch) then
C      external field add in subroutine 'vofrhob' to the total potential
C      but the interaction energy with the field is NOT add to the 
C      total energy.
       textfld=.true.
       if (parent) then
        write(6,'(a)') ' External field is computed and added'
       endif
      endif

      if ((tgaugep.or.tgaugef).and.(pertdir.gt.3)) then
       pertdir=3
      endif
      if (tpdist.and.(.not.tpointch)) then
       if (parent)
     &  write(6,'(a)') ' PROP DISTURBANCE WITH POINTCHARGE PERTURBATION'
       stop
      else
C      ruku=.false.
      endif
      if (tmdeh.and.tpdist.and.(.not.ruku)) then
       write(6,'(a)') ' EHMD with POINT PERTURBATION NOT TESTED'
       stop
      endif
      if(parent) write(6,'(a,a,/)')
     *  ' **************************************',
     *                              '************************** '
C
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
