C     ==================================================================
      SUBROUTINE READFF(IUNIT)
C     ==--------------------------------------------------------------==
C     ==  Reads Classical Force Fields                                ==
C     ==--------------------------------------------------------------==
C     ==                                                              ==
C     ==                                                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'clas.inc'
C     Arguments
      INTEGER   IUNIT
C
      CHARACTER*80 LINE
      CHARACTER*4 TAG 
      INTEGER IPOS,IA1,IA2,CL_TYP,IOUT
      REAL*8 PARA
      LOGICAL ERREAD
C     ==--------------------------------------------------------------==
   10 READ(IUNIT,ERR=20,END=20,FMT='(A)') LINE
      IF(INDEX(LINE,'END').NE.0 .AND. INDEX(LINE,'FORCE').NE.0)
     &     GOTO 30
        IPOS=1
        CALL GET_TAG(TAG,4,LINE,IPOS,80)
        IF(TAG(1:3).EQ.'R12') THEN
C..R12 potential
          IF(INITR12.EQ.0) THEN
            T_R12=.TRUE.
            INITR12=1
            CALL MEMORY(IP_PR12,NCLTYP*NCLTYP,'PR12')
            CALL AZZERO(PR12,NCLTYP*NCLTYP)
            CALL MEMORY(IP_RCR12,NCLTYP*NCLTYP,'RCR12')
            CALL AZZERO(RCR12,NCLTYP*NCLTYP)
          ENDIF
          CALL GET_TAG(TAG,4,LINE,IPOS,80)
          IA1=CL_TYP(TAG)
          CALL GET_TAG(TAG,4,LINE,IPOS,80)
          IA2=CL_TYP(TAG)
          CALL READSR(LINE,IPOS,IOUT,PARA,ERREAD)
          PR12(IA1,IA2)=PARA
          PR12(IA2,IA1)=PARA
          IPOS=IOUT
          CALL READSR(LINE,IPOS,IOUT,PARA,ERREAD)
          RCR12(IA1,IA2)=PARA
          RCR12(IA2,IA1)=PARA
        ELSEIF(TAG(1:2).EQ.'LJ') THEN
C..LJ potential
        ENDIF
        GOTO 10
   20 CONTINUE
        WRITE(6,*) ' ERROR WHILE READING FORCE FIELD '
        CALL STOPGM('READFF',' ')
   30 CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GET_TAG(TAG,LEN,LINE,IPOS,IEND)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   LEN,IPOS,IEND
      CHARACTER TAG*(*), LINE*(*)
C     Variables
      INTEGER   I,L
C     ==--------------------------------------------------------------==
      TAG='           '
      DO I=IPOS,IEND
        IF(LINE(I:I).NE.' ') GOTO 10
      ENDDO
      IPOS=IEND+1
      RETURN
 10   CONTINUE
      IPOS=I
      L=0
      DO I=IPOS,IEND
        IF(LINE(I:I).NE.' ') THEN
          L=L+1
          IF(L.GT.LEN) RETURN
          TAG(L:L)=LINE(I:I)
        ELSE
          IPOS=I
          RETURN
        ENDIF
      ENDDO
      IPOS=IEND+1
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION CL_TYP(TAG)
      IMPLICIT NONE
      INCLUDE 'clas.inc'
      CHARACTER*4 TAG
      INTEGER CL_TYP,I
C     ==--------------------------------------------------------------==
      CL_TYP=0
      DO I=1,NCLTYP
        IF(TAG.EQ.CLAB(I)) THEN
          CL_TYP=I
          RETURN
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      WRITE(6,*) 'READFF| Unknown atom label ',tag
      WRITE(6,'(A4)') TAG
      DO I=1,NCLTYP
        WRITE(6,'(A4)') CLAB(I)
      ENDDO
      CALL STOPGM('CL_TYP','ERROR')
      END
C     ==================================================================
