C     ==================================================================
      SUBROUTINE RECIPS(A,A1,A2,A3,B1,B2,B3)
C     ==--------------------------------------------------------------==
C     == GENERATES THE RECIPROCAL LATTICE VECTORS B1,B2,B3 GIVEN THE  ==
C     == REAL SPACE VECTORS A1,A2,A3.  B IN UNITS OF 2PI/A.           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      REAL*8  A,A1(3),A2(3),A3(3),B1(3),B2(3),B3(3)
C     Variables
      REAL*8  DEN,S
      INTEGER I,J,K,L,IPERM,IR
C     ==--------------------------------------------------------------==
      DEN=0.D0
      I=1
      J=2
      K=3
      S=1.D0
    1 CONTINUE
      DO IPERM=1,3
        DEN=DEN+S*A1(I)*A2(J)*A3(K)
        L=I
        I=J
        J=K
        K=L
      ENDDO
      I=2
      J=1
      K=3
      S=-S
      IF(S.LT.0.D0) GO TO 1
      I=1
      J=2
      K=3
      DEN=A/DABS(DEN)
      DO IR=1,3
        B1(IR)=DEN*(A2(J)*A3(K)-A2(K)*A3(J))
        B2(IR)=DEN*(A3(J)*A1(K)-A3(K)*A1(J))
        B3(IR)=DEN*(A1(J)*A2(K)-A1(K)*A2(J))
        L=I
        I=J
        J=K
        K=L
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
