C     ==================================================================
      SUBROUTINE REIGS(NSTATE,GAM,F,FM1,WR,AP)
C     ==--------------------------------------------------------------==
C     ==  COMPUTES THE EIGENVALUES OF THE REAL SYMMETRIC MATRIX GAM   ==
C     ==  AND UPDATES THE DENSITY OF STATES DOFS ACCORDINGLY.         ==
C     ==  THE EIGENVALUES ARE PRINTED OUT IN ELECTRON VOLTS.          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'ropt.inc'
C     Arguments
      INTEGER NSTATE
      REAL*8  GAM(NSTATE,NSTATE),AP(NSTATE*(NSTATE+1)/2),
     &        WR(NSTATE),FM1(3*NSTATE),
     &        F(NSTATE)
C     Variables
      REAL*8  FFI,DUMMY
      INTEGER ISUB,K,J,I,IOPT,NLEFT
C     ==--------------------------------------------------------------==
      CALL TISET('     REIGS',ISUB)
      IF(.NOT.TLSD) THEN
        K=0
        DO J=1,NSTATE
          DO I=J,NSTATE
            K=K+1
            AP(K)=GAM(I,J)
          ENDDO
        ENDDO
        IOPT=0
        CALL DSPEVY(IOPT,AP,WR,DUMMY,NSTATE,NSTATE,FM1,3*NSTATE)
        DO I=1,NSTATE
          FFI=F(I)
          IF(FFI.LT.1.D-5) FFI=1.D0
          WR(I)=WR(I)/FFI
        ENDDO
        IF(ENGPRI) THEN
          WRITE(6,'(/," EIGENVALUES (EV) AND OCCUPATION:")')
          DO I=1,NSTATE,2
            NLEFT=MIN(NSTATE-I,1)
            WRITE(6,'(3X,2(I3,F15.7,4X,F6.3,6X))') 
     &           (I+J,WR(I+J)*(2*RY),F(I+J),J=0,NLEFT)
          ENDDO
        ENDIF
      ELSE
        K=0
        DO J=1,NSUP
          DO I=J,NSUP
            K=K+1
            AP(K)=GAM(I,J)
          ENDDO
        ENDDO
        IOPT=0
        CALL DSPEVY(IOPT,AP,WR,DUMMY,NSUP,NSUP,FM1,3*NSUP)
        K=0
        DO J=NSUP+1,NSTATE
          DO I=J,NSTATE
            K=K+1
            AP(K)=GAM(I,J)
          ENDDO
        ENDDO
        IOPT=0
        CALL DSPEVY(IOPT,AP,WR(NSUP+1),DUMMY,NSDOWN,NSDOWN,FM1,3*NSDOWN)
        DO I=1,NSTATE
          FFI=F(I)
          IF(FFI.LT.1.D-5) FFI=1.D0
          WR(I)=WR(I)/FFI
        ENDDO
        IF(ENGPRI) THEN
          WRITE(6,'(/," EIGENVALUES (EV) AND OCCUPATION:")')
          WRITE(6,'(" ALPHA SPIN ")')
          DO I=1,NSUP,2
            NLEFT=MIN(NSUP-I,1)
            WRITE(6,'(3X,2(I3,F15.7,4X,F6.3,6X))') 
     &           (I+J,WR(I+J)*(2*RY),F(I+J),J=0,NLEFT)
          ENDDO
          WRITE(6,'(" BETA SPIN ")')
          DO I=NSUP+1,NSTATE,2
            NLEFT=MIN(NSTATE-I,1)
            WRITE(6,'(3X,2(I3,F15.7,4X,F6.3,6X))') 
     &           (I+J,WR(I+J)*(2*RY),F(I+J),J=0,NLEFT)
          ENDDO
        ENDIF
      ENDIF
      CALL TIHALT('     REIGS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


