C     ==================================================================
      SUBROUTINE REKINE(CM,NSTATE,EKINC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'harm.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 CM(NGW,NSTATE)
      REAL*8     EKINC
C     Variables
      REAL*8     PF,AX,BX,
     &           DOTP
      EXTERNAL   DOTP
      INTEGER    I,IG
C     ==--------------------------------------------------------------==
C     ==  COMPUTE FICTITIOUS KINETIC ENERGY OF THE ELECTRONS          ==
C     ==--------------------------------------------------------------==
      EKINC=0.D0
      IF(TMASS) THEN
        DO I=1,NSTATE
          DO IG=1,NGW
            PF=2.0D0*XMU(IG)
            AX=DREAL(CM(IG,I))
            BX=DIMAG(CM(IG,I))
            EKINC=EKINC+PF*(AX*AX+BX*BX)
          ENDDO
          IF(GEQ0) EKINC=EKINC-XMU(1)*DREAL(CM(1,I))*DREAL(CM(1,I))
        ENDDO
      ELSE
        DO I=1,NSTATE
          EKINC=EKINC+DOTP(NGW,CM(1,I),CM(1,I))
        ENDDO
        EKINC=EKINC*EMASS
      ENDIF
#ifdef PARALLEL
      CALL GLOSUM(1,EKINC)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
