C     ==================================================================
      SUBROUTINE RESPONSE_P
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'soft.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'filn.inc'
      INCLUDE 'store.inc'
      INCLUDE 'response_p.inc'
C     Variables

      INTEGER    IREC(100),NSTATE,filenum
      COMPLEX*16 C0(NGW,*),CS(NGW,*)
      POINTER    (IP_C0,C0),(IP_CS,CS)
      REAL*8     EIGV(*)
      POINTER    (IP_EIGV,EIGV)
#ifdef PARALLEL
      INTEGER    MSGLEN
#endif
C     ==--------------------------------------------------------------==
      IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
      IF(EXSOFT) RETURN
      NSTATE=N
      IF(TKPNT) CALL STOPGM('RESPONSE_P','k-points not implemented')
C     ==--------------------------------------------------------------==
C     ==  ALLOC MEMORY                                                ==
C     ==--------------------------------------------------------------==
      CALL FNLALLOC(NSTATE,.FALSE.,.FALSE.)
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL AZZERO(   TAUP,3*NAX*NSX)
      CALL MEMORY(IP_CS,  2*NGW*NSTATE+8,'CS')
      CALL AZZERO(   CS,  2*NGW*NSTATE+8)
      CALL MEMORY(IP_C0,  2*NGW*NSTATE+8,'C0')
      CALL AZZERO(   C0,  2*NGW*NSTATE+8)
      CALL MEMORY(IP_EIGV,NSTATE,'EIGV')
      CALL AZZERO(   EIGV,NSTATE)
C     ==--------------------------------------------------------------==
C     ==  LOAD DATA                                                   ==
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      MSGLEN = 20
      CALL MY_CHAR_BCAST(nmr_superparent,filn,MSGLEN,nmr_supersource,
     &     nmr_supergroup)
      CALL MY_CHAR_BCAST(nmr_superparent,filbod,MSGLEN,nmr_supersource,
     &     nmr_supergroup)
#endif

      filenum = 42+nmr_mygroup
      if (restart) then
        CALL READ_IREC(IREC)
        CALL ZHRWF(filenum,IREC,C0,CS,NSTATE,EIGV,TAU0,TAUP,TAUP,NFI)
#ifdef PARALLEL
        MSGLEN = 3*NAX*NSX * 8
        CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
#endif
      endif
      IF(TMEMCHK) CALL PRINT_MEMORY
C     ==--------------------------------------------------------------==

      CALL DO_PERTURBATION(C0,CS,NSTATE)

C     ==--------------------------------------------------------------==
      IF(TMEMCHK) CALL PRINT_MEMORY
      CALL FREEM(IP_EIGV)
      CALL FREEM(IP_C0)
      CALL FREEM(IP_CS)
      CALL FREEM(IP_TAUP)
      CALL FNLDEALLOC(.FALSE.,.FALSE.)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
