C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == GLOBAL RESPONSE PARAMETERS & VARIABLES                       ==
C     ==================================================================
C     T_INITIAL_GUESS_C1: if true, then use the input C1 as initial
C     guess. Otherwise, take C1=0.
C     RESTART_C1: read C1 set
      INTEGER      LRESPONSE
      PARAMETER   (LRESPONSE=39)
      INTEGER      PRECONDITIONER_P,CG_ANALYTIC,MDIIS_P
      LOGICAL      RESPONSE_RUNNING,
     &    TDUMMYATOM,TDUMMYATOM_REF,TDUMMY_STEP,TDUMPBD,
     &    TDUMN,TDUMSD,TDUMMYATOM_TEC,TOACP4F,
     &    TRAMAN,PHONON,TEIGENSYSTEM,TNMR,THARDNESS,TFUKUI,
     &    TSDE_P,DIIS_P,PREC_P,PCG_P,PCGMIN_P,OPT1ST,
     &    TPOLAK_P,PR_ENERGY,
     &    TLANPHON,TLANPH_CONT,TEIGENS,TINTERACTION,
     &    PROJOUT,ROTOUT,TRHO1,TNONLOCAL,TKEEPREALSPACEWFN,
     &    TKPERT,T_RESTART_C1,T_INITIALGUESS_C1,TEPR

      COMMON  /RESPONSE1/RESPONSE_RUNNING,
     &    TDUMMYATOM,TDUMMYATOM_REF,TDUMMY_STEP,TDUMPBD,
     &    TDUMN,TDUMSD,TDUMMYATOM_TEC,TOACP4F,
     &    TRAMAN,PHONON,TEIGENSYSTEM,TNMR,THARDNESS,TKPERT,TFUKUI,
     &    TSDE_P,PREC_P,DIIS_P,PCG_P,PCGMIN_P,OPT1ST,TPOLAK_P,PR_ENERGY,
     &    TLANPHON,TLANPH_CONT,TEIGENS,TINTERACTION,
     &    PROJOUT,ROTOUT,TRHO1,TNONLOCAL,TKEEPREALSPACEWFN,
     &    T_RESTART_C1,T_INITIALGUESS_C1,CG_ANALYTIC,MDIIS_P,
     &    PRECONDITIONER_P,TEPR ! Integers have the same length as logicals

      INTEGER      RRESPONSE
      PARAMETER   (RRESPONSE=15)
      REAL*8       HTHRS_P,TOLOG_P,CG_FACTOR
      REAL*8       DUMSTEP1,DUMSTEP2,DUMSTEP3,DUMSTEP4,DUMSTEP5,DUMCRIT
      REAL*8       RAD_DUM,RAD_NORM
      INTEGER      TDUMNUM,TDUMQM,TFDIMEN,ANG_MOM
      COMMON  /RESPONSE2/HTHRS_P,TOLOG_P,CG_FACTOR,
     &        DUMSTEP1,DUMSTEP2,DUMSTEP3,DUMSTEP4,DUMSTEP5,DUMCRIT,
     &        TDUMNUM,TDUMQM,RAD_DUM,RAD_NORM,TFDIMEN,ANG_MOM
      INTEGER      RESPONSE_WRITE,RESPONSE_READ
      PARAMETER    (RESPONSE_WRITE=314,RESPONSE_READ=315)
C     These two are constant definitions for the interface 
C     to the restart routines
C     ==================================================================
C     == ENERGY AND CHARGE QUANTITIES                                 ==
C     ==================================================================
      INTEGER       L_ENER
      PARAMETER     (L_ENER=6)
      REAL*8        ELOC1,ENL1,EHT1,EXC1,ELAG1,EH0
      COMMON/ENER1/ ELOC1,ENL1,EHT1,EXC1,ELAG1,EH0
C     ==--------------------------------------------------------------==
C     Where:
C       ELOC1:   <1|  H(1)^local |0> + cc  =  eivps(r) n1(r)
C       ENL1:    <1| H(1)^direct |0> + cc  =  2 * <1| H1NL>
C                which is calculated via the (D)FNL(00) for phonons
C       ENMR:    <1| H(1)^direct |0> + cc  for option nmr
C       EHT1:    1/2  n1(r') n1(r)  /  |r-r'|  +  V1_pp[Gaussians](r) n1(r)
C             where this exists only for phonons: ^^^^^^^^^^^^^^^^^^^^^^^^^
C       EXC1:    1/2  d^2 E_xc / dn^2  n1(r) n1(r')
C       ELAG1:   - <1|  eps_KS  |1>  (the Lagrange multipliers)
C       EH0:    <1| H0 |1>
C       ERAMAN:  ?
C     ==================================================================
C     ==  DATA derived from the ground state wavefunctions that is
C     ==  used during the perturbation calculation.
C     ==================================================================
      REAL*8          VofRho0(nnr1,*),rho0(nnr1,*),vxc0(nnr1,*)
      complex*16      c0real(nnr1,*)
      POINTER         (ip_VofRho0,VofRho0), (ip_rho0,rho0),
     &                (ip_vxc0,vxc0),(ip_c0real,c0real)
      COMMON /gndst/  ip_VofRho0,ip_rho0,ip_vxc0,ip_c0real
C     ==================================================================



C     ==================================================================
C     INTERACTION parameters and variables
C     ==================================================================
      INTEGER LINTERACTION,INTERACTION_FIRST
      PARAMETER (LINTERACTION=44)

      REAL*8 WC_array1(3,*),WC_array2(3,*),WC_velocity(3,*)
      POINTER (IP_WC_array1,WC_array1)
      POINTER (IP_WC_array2,WC_array2)
      POINTER (IP_WC_velocity,WC_velocity)
      INTEGER WC_sample
      REAL*8 BTHETA(*),SCF_TOL
      POINTER (IP_BTHETA,BTHETA)
      REAL*8 BVECx(*),BVECy(*),BVECz(*)
      POINTER (IP_BVECx,BVECx)
      POINTER (IP_BVECy,BVECy)
      POINTER (IP_BVECz,BVECz)
      REAL*8 BDXVECx(*),BDXVECy(*),BDXVECz(*)
      POINTER (IP_BDXVECx,BDXVECx)
      POINTER (IP_BDXVECy,BDXVECy)
      POINTER (IP_BDXVECz,BDXVECz)
      REAL*8 EMONO(*)
      POINTER (IP_EMONO,EMONO)
      INTEGER STATEmin(*),STATEmax(*)
      POINTER (IP_STATEmin,STATEmin)
      POINTER (IP_STATEmax,STATEmax)
      INTEGER BLmax,NMOL,NGW_ZERO,BPTSCFIter
      LOGICAL WANN_LOAD,WANN_SAVE,WANN_ALLROT,WANN_MULTI
      LOGICAL IN_BTHETA,IN_BVEC,IN_BDXVEC,CUTOFF_TRICK
      LOGICAL CUTOFF_RESTR,TINTER_ORTHO,WANN_GAUSS
      LOGICAL Tlinearscaling
      LOGICAL INTER_PT_FIRSTCALL
      LOGICAL WCPREDICT,FASTDEXC,TNORESPONSE
      LOGICAL SAVE_LOCALISED_W0
      LOGICAL TATOMICWAVEFUNCTION
      LOGICAL TATOMICRHO,TORTHOG_WANNIER
      LOGICAL TSIMPLE_MODEL,TMANNO
      INTEGER WC_PRED_STEP,max_num_disp

      COMMON /DMBI/   INTERACTION_FIRST,
     $    WC_sample,BLmax,NMOL,
     $    NGW_ZERO,BPTSCFIter,WANN_LOAD,WANN_SAVE,
     $    WANN_ALLROT,WANN_MULTI,IN_BTHETA,IN_BVEC,
     $    IN_BDXVEC,CUTOFF_TRICK,CUTOFF_RESTR,TINTER_ORTHO,
     $    WANN_GAUSS,Tlinearscaling,INTER_PT_FIRSTCALL,
     $    WCPREDICT,FASTDEXC,TNORESPONSE,
     $    SAVE_LOCALISED_W0,TATOMICWAVEFUNCTION,TMANNO,
     $    TATOMICRHO,TORTHOG_WANNIER,TSIMPLE_MODEL,WC_PRED_STEP,
     $    max_num_disp

      COMMON /DMBR/ SCF_TOL

      COMMON /DMB_IP/   
     $    IP_BTHETA,IP_BVECx,IP_BVECy,IP_BVECz,
     $    IP_BDXVECx,IP_BDXVECy,IP_BDXVECz,
     $    IP_WC_array1,IP_WC_array2,IP_WC_velocity,
     $    IP_STATEmin,IP_STATEmax,IP_EMONO
C     ==================================================================
C     SIMPLE_MODEL (option of INTERACTION)
C     parameters and variables
C     ==================================================================
C     DIMENSION S_STAR(NSTATE,NSTATE)
      REAL*8   S_STAR
      POINTER (IP_S_STAR,S_STAR)
      COMMON /DMB_simple/  IP_S_STAR
C     ==================================================================



C     ==================================================================
C     ==  PHONON                                                      ==
C     ==================================================================
      pointer (ip_fnl00,fnl00),(ip_dfnl00,dfnl00)
      real*8 fnl00,dfnl00
      common/phon_nl/ip_fnl00,ip_dfnl00
C     ==================================================================
C     ==  LANCZOS/PHONON                                              ==
C     ==================================================================
      logical details
      integer nlan_st
      COMMON /lancphon/ details,nlan_st

C     ==================================================================
C     == KPERT                                                        ==
C     ================================================================== 
C      RRK  storage array for K points
C      WWK  storage array for K weights
C      RESTART_CU1 logical variable for writing the CU1 on RESTA_P
C      TK_PREP_DIAG logical variable for building the C00 ={C0}+{CU1}
C      TKREAD_C1 logical variable for reading the CU1 from RESTA_P
C      TPERT_HAMILT for calculation of the H matrix dim 2*NSTATE
C      DTWNL_DK(1:3,1:2*NGW,1:NGH(IS),1:NSP)  first derivatives 
C               of the non local projectors with respect to kx ky and kz,
C               for each G-component (Kleiman-Bylander form)
C      DDTWNL_DDK(1:2*NGW,1:NGH(IS),1:NSP,1:3,1:3) second derivatives
C               of the non local projectors with respect to kxkx kxky 
C                kxkz,kykx, kyky, kykz, kzkx, kzky, kzkz
C      TWNL_P, TWNL_M
C      DFNL_DK,DDFNL_DDK
C      PP projectors in G+ki and G-ki (where ki is considered in kx 
C                                      or ky or kz direction)
C      TWNL_P  (1:2*NGW,1:NGH(IS),1:NSP,1:3)  |
C      TWNL_M  (1:2*NGW,1:NGH(IS),1:NSP,1:3)  | initialized in PUTWNL_KPERT
C      YLMB_P  (1:2*NGH,LPMAX,1:3)            | form factors coefficients in
C      YLMB_M  (1:2*NGH,LPMAX,1:3)            | G+Ki  and G-Ki
C      E2_NL_C0 (3,3) correction to the perturbed energy due to the second
C            order terms related to the NLPP and which 
C            do not depend on the  response wfn

      integer LENKPERT
      parameter (LENKPERT = 5) 
      logical  RESTART_CU1,NORESTART,
     &         TK_PREP_DIAG,TKREAD_C1,TPERT_HAMILT
      common /kpertpar/ NORESTART,
     &      RESTART_CU1,TK_PREP_DIAG,TKREAD_C1,TPERT_HAMILT
      pointer (IP_RRK,RRK),(IP_WWK,WWK)
      real*8   RRK(3,*),WWK(*)
      common /pert_rk/ IP_RRK,IP_WWK
      pointer (ip_dtwnl_dk,dtwnl_dk),(ip_ddtwnl_ddk,ddtwnl_ddk)
      real*8 dtwnl_dk,ddtwnl_ddk
      common /dertwnl_dk/ ip_dtwnl_dk,ip_ddtwnl_ddk
  
      pointer (ip_twnl_p,twnl_p),(ip_twnl_m,twnl_m)
      real*8 twnl_p,twnl_m
      common /twnl_delta /ip_twnl_p,ip_twnl_m
      pointer (IP_DFNL_DK,DFNL_DK),(IP_DDFNL_DDK,DDFNL_DDK)
      real*8  DFNL_DK,DDFNL_DDK
      common /derfnl_dk/ IP_DFNL_DK,IP_DDFNL_DDK

      pointer (ip_e2_nl_c0,e2_nl_c0)
      real*8  e2_nl_c0
      common  /e2_nl/ ip_e2_nl_c0


C     ==================================================================
C     ==   DYNAMIC ALLOCATION OF  ARRAYS for KPERT                    ==
C     ==                                                              ==
C     ==                                                              ==
C     ==================================================================
C     ==   PKpert(3,NSTATE,NSTATE)   : <c0|grad|c0>                   ==
C     ==   EKpert(2*NSTATE,NKPTS)    : EIGENVALUES                    ==
C     ==   FKpert(2*NSTATE,NKPTS)    : OCCUPATIONS                    ==
C     ==   HAMILK(2*NSTATE,2*NSTATE) : MATRIX ELEMENTS DEPENDING ON K ==
C     ==================================================================
      REAL*8        EKPERT,FKPERT
      COMPLEX*16    HAMILK
      POINTER       (IP_HAMILK,HAMILK),
     &              (IP_ekpert,ekpert),
     &              (IP_fkpert,fkpert)
C 
      COMMON/CKDPP/  IP_HAMILK,IP_ekpert,IP_fkpert
C     ==================================================================
C     ==     HGKP_PK(NHG,NKPTS) HGKM_PK(NHG.NKPTS)
C     ==     TK_PK(2*NGW,NHXS,NSX)
        REAL*8        HGKP_PK,HGKM_PK
        pointer       (IP_HGKP_PK,HGKP_PK),(IP_HGKM_PK,HGKM_PK)
        REAL*8        TW_PK
        pointer       (IP_TW_PK,TW_PK)
        COMMON/CPP_PK/IP_HGKP_PK,IP_HGKM_PK,IP_TW_PK
C     ===================================================================
C     == MATRIX not depending on K vector
      COMPLEX*16 H1_00
      COMPLEX*16 H2_00
      COMPLEX*16 H1_10
      REAL*8 H0_11
      pointer (ip_H1_00,H1_00)
      pointer (ip_H2_00,H2_00)
      pointer (IP_H1_10,H1_10),(IP_H0_11,H0_11)
      COMMON /MATRIX/ IP_H1_00,IP_H2_00,IP_H1_10,IP_H0_11



C     ==================================================================
C     == SELECTED EIGENVALUES                                         ==
C     ==================================================================
      INTEGER    NEIGENS,ITER_MAX_EIGENS,NEIGENS_MAX,IKRYLOV_MAX
      PARAMETER  (NEIGENS_MAX=20)
      REAL*8     TOL_EIGENS,TOL_DIRECT
      PARAMETER  (TOL_DIRECT=1.d-3)
      COMMON /EIGENS1/ NEIGENS,ITER_MAX_EIGENS,TOL_EIGENS,IKRYLOV_MAX

C     ==================================================================
C     == EIGENSYSTEM                                                  ==
C     ==================================================================
      INTEGER        L_EIGEN_REALS,L_EIGEN_INTEGERS
      PARAMETER      (L_EIGEN_REALS=2,L_EIGEN_INTEGERS=2)
      INTEGER        LANCZOS_DIM,NUM_LANCZOS_STATES  ! EIGENSYSTEM
      REAL*8         CONV_THRESHOLD,eigenvalue_shift
      COMMON /EIG1/  LANCZOS_DIM,NUM_LANCZOS_STATES
      COMMON /EIG2/  CONV_THRESHOLD,eigenvalue_shift



C     ==================================================================
C     ==  NMR                                                         ==
C     ==================================================================
C     == INMR_METHOD:  0  determine default                           ==
C     ==               1  CSGT                                        ==
C     == INMR_VIRTUAL  0  determine default                           ==
C     ==               3  LLC where Int[rho_i] = min                  ==
C     ==               4  CENTER = Wannier centers from LOCALIZE      ==
C     ==               5  no virtual cells, LLC = (1,1,1)             ==
C     ==                                                              ==
C     ==                                                              ==
C     ==                                                              ==
C     == TNMR_FULL     if the full calculation is desired.            ==
C     ==                                                              ==
C     ==                                                              ==
      INTEGER    L_NMR_OPTIONS
      PARAMETER (L_NMR_OPTIONS=16)
C     NB: There are (3)-fold arrays in the common block!!

      INTEGER    INMR_METHOD,INMR_VIRTUAL
      LOGICAL                T_NMR_FIRST,
     &    TCURRENT,TVERBOSE,TPRINTWFNS,TPRINTRHO,TLOCALIZE,
     &    TFAST,TSMOOTHING,
     &    TNMR_FULL,TNMR_OVERLAPS,TNMR_ONLY_ERROR,
     &    TFORCE_XYZ(3)
      COMMON    /NMR_OPTIONS/T_NMR_FIRST,
     &    TCURRENT,TVERBOSE,TPRINTWFNS,TPRINTRHO,TLOCALIZE,
     &    TFAST,TSMOOTHING,INMR_METHOD,INMR_VIRTUAL,
     &    TNMR_FULL,TNMR_OVERLAPS,
     &    TFORCE_XYZ,
     &    TNMR_ONLY_ERROR

      INTEGER    INMR_DEFAULT,INMR_IGLO,INMR_CSGT,
     &    INMR_LLC,INMR_WC,INMR_NOVIRT
      PARAMETER (INMR_DEFAULT=0,INMR_IGLO=1,INMR_CSGT=2,
     &    INMR_LLC=3,INMR_WC=4,INMR_NOVIRT=5)
C     ==================================================================
C     ==  NMR SUPERPARALLEL variables                                 ==
C     ==================================================================
      logical   nmr_superparent
      integer   nmr_supergroup,
     &          nmr_threads,nmr_mygroup,nmr_total_nproc,
     &          parents(0:7),nmr_supersource
      common    /nmr_para/nmr_supergroup,
     &          nmr_threads,nmr_mygroup,nmr_total_nproc,
     &          parents,nmr_supersource,
     &          nmr_superparent

C     ==================================================================
C     ==  Internal NMR variables             -------------------------==
C     ==  used only by the nmr_*_p routines  -------------------------==
      real*8    sigma, overlap_threashold,
     &    wanniercenters(4,*),firstshelldistance
      common /fishdi/ firstshelldistance
      integer   lower_left(3,*),lower_left_value(3,*),
     &    llc_ind(3),llc_val(3),nris(3)
      pointer   (ip_lower_left, lower_left),
     &    (ip_lower_left_value, lower_left_value),
     &    (ip_wanniercenters,wanniercenters)
      common    /origin/llc_ind,llc_val,nris
      common    /origin_ip/
     &    ip_lower_left,ip_lower_left_value,
     &    ip_wanniercenters
      common    /deltaRvalues/sigma, overlap_threashold
c     The lower_left(3,*) contains the optimal starting coordinates for
c     the cell for the wavefunctions, i.e. the box on whose borders
c     the Wannier function psi_i vanishes. 
c     For the calculation of these borders,
c     a smearing Gaussian of spread "sigma" is applied.
C     ==--------------------------------------------------------------==
      real*8    shift_matrix(3,3,nax,nsx),shift_factor,chi(3,3)
c     factor is alpha^2 * ppm
      real*8    chi_factor,chi_SI_to_shift_ppm,chi_SI_to_ppmcgs,
     &    chi_SI_iso
      pointer   (ip_shift_matrix,shift_matrix),(ip_chi,chi)
      common    /shifts/shift_factor,chi_factor,
     &    chi_SI_to_shift_ppm,chi_SI_to_ppmcgs,chi_SI_iso
      common    /shifts_ip/  ip_shift_matrix,ip_chi
      character*44 timetag
      common    /time_tag/timetag

C     ==================================================================
C     ==  EPR                                                         ==
C     ==================================================================
C     == IEPR_METHOD:  0  determine default                           ==
C     ==               1  CSGT                                        ==
C     == IEPR_VIRTUAL  0  determine default                           ==
C     ==               3  LLC where Int[rho_i] = min                  ==
C     ==               4  CENTER = Wannier centers from LOCALIZE      ==
C     ==               5  no virtual cells, LLC = (1,1,1)             ==
C     ==                                                              ==
C     ==                                                              ==
C     ==                                                              ==
C     == TEPR_FULL     if the full calculation is desired.            ==
C     ==                                                              ==
C     ==                                                              ==
      INTEGER    L_EPR_OPTIONS
      PARAMETER (L_EPR_OPTIONS=18)
C     NB: There are (3)-fold arrays in the common block!!

      INTEGER    IEPR_METHOD,IEPR_VIRTUAL
      LOGICAL               T_EPR_FIRST,
     &    TEVERBOSE,TEPRINTWFNS,TEPRINTRHO,TELOCALIZE,
     &    TEFAST,TESMOOTHING,
     &    TEPR_FULL,TEPR_OVERLAPS,TEPR_ONLY_ERROR,
     &    TEFORCE_XYZ(3),TEPR_SMART,TEPR_HYP,TEPR_OWNPOT
      COMMON    /EPR_OPTIONS/T_EPR_FIRST,
     &    TEVERBOSE,TEPRINTWFNS,TEPRINTRHO,TELOCALIZE,
     &    TEFAST,TESMOOTHING,IEPR_METHOD,IEPR_VIRTUAL,
     &    TEPR_FULL,TEPR_OVERLAPS,
     &    TEFORCE_XYZ,
     &    TEPR_ONLY_ERROR,TEPR_SMART,TEPR_HYP,TEPR_OWNPOT

      INTEGER    IEPR_DEFAULT,IEPR_IGLO,IEPR_CSGT,
     &    IEPR_LLC,IEPR_WC,IEPR_NOVIRT
      PARAMETER (IEPR_DEFAULT=0,IEPR_IGLO=1,IEPR_CSGT=2,
     &    IEPR_LLC=3,IEPR_WC=4,IEPR_NOVIRT=5)


C     ==================================================================
C     ==  Internal EPR variables             -------------------------==
C     ==  used only by the epr_*_p routines  -------------------------==
      real*8    epr_ownpot_value, epr_smart_value
      common    /ownpotvalue/epr_ownpot_value, epr_smart_value

C     ==================================================================
C     ==  FUKUI Calculation variables                                 ==
C     ==================================================================
      logical tweight
      integer numf,nf(*)
      pointer (ip_nf,nf)
      real*8  wghtf(*)
      pointer (ip_wghtf,wghtf)
      common/fukuil/ tweight
      common/fukuii/ numf
      common/fukuip/ ip_nf,ip_wghtf
