C     ==================================================================
      SUBROUTINE RGDIIS(XPAR,DXPAR,TOLD,GOLD,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER LSCR
      REAL*8  XPAR(*),DXPAR(*),TOLD(NODIM,*),GOLD(NODIM,*),SCR(*)
C     Variables
      REAL*8  BC(MXGDIS+1,MXGDIS+1),VC(MXGDIS+1),EPS,DDOT,SDLEN,QNRLEN,
     &        SS,TR
      EXTERNAL  DDOT 
      INTEGER ISUB,IDIIS,NOWG,IDP1,IDP2,IDP3,IDP4,IDP5,IDQ1,IDQ2,IDQ3,
     &        IDQ4,IDQ5,IDTOP,IT,ID,I,IOPT,LW,NRANK,II,J,INFO,JJ,
     &        IDDC,IDDG,NIC,
     &        ICALL
      DATA    ICALL / 0 /
      SAVE    ICALL
C     ==--------------------------------------------------------------==
      CALL TISET('    RGDIIS',ISUB)
C     ==--------------------------------------------------------------==
C     ==  UPDATE BUFFERS                                              ==
C     ==--------------------------------------------------------------==
      ICALL = ICALL + 1
      IDIIS = ICALL
      IF(IDIIS.GT.MGDIIS) THEN
        IDIIS=MGDIIS
      ENDIF
      NOWG = ICALL
      IF(NOWG.GT.MGDIIS) NOWG=MOD(NOWG-1,MGDIIS)+1
      CALL DCOPY(NODIM,XPAR(1), 1,TOLD(1,NOWG),1)
      CALL DCOPY(NODIM,DXPAR(1),1,GOLD(1,NOWG),1)
C     ==--------------------------------------------------------------==
C     ==  SCRATCH SPACE MANAGEMENT                                    ==
C     ==--------------------------------------------------------------==
      IDP1 = 1
      IDP2 = IDP1 + NODIM*NODIM
      IDP3 = IDP2 + NODIM*MGDIIS
      IDP4 = IDP3 + NODIM
      IDP5 = IDP4 + 6*NODIM+IDIIS
C
      IDQ1 = IDP2
      IDQ2 = IDQ1 + NODIM
      IDQ3 = IDQ2 + NODIM
      IDQ4 = IDQ3 + NODIM
      IDQ5 = IDQ4 + NODIM*6
      IDTOP=MAX(IDP5,IDQ5)
      CALL TEST_SCR('RGDIIS','NODIM*NODIM+NODIM*MGDIIS+7*NODIM+MGDIIS',
     &              LSCR,IDTOP)
C     ==--------------------------------------------------------------==
C     ==  CALCULATE ERROR VECTORS                                     ==
C     ==--------------------------------------------------------------==
      CALL DCOPY(NODIM*NODIM,HESS(1,1),1,SCR(IDP1),1)
      IT=IDP2-1
      DO ID=1,IDIIS
        DO I=1,NODIM
          IT=IT+1
          SCR(IT)=GOLD(I,ID)
        ENDDO
      ENDDO
      IOPT=12
      EPS=1.D-6
      LW=6*NODIM+IDIIS
      CALL DGELSS(NODIM,NODIM,IDIIS,SCR(IDP1),NODIM,SCR(IDP2),NODIM,
     *            SCR(IDP3),EPS,NRANK,SCR(IDP4),LW,INFO)
C     ==--------------------------------------------------------------==
C     ==  DIIS MATRIX                                                 ==
C     ==--------------------------------------------------------------==
      DO I=1,IDIIS
        II=IDP2+(I-1)*NODIM
        DO J=I,IDIIS
          JJ=IDP2+(J-1)*NODIM
          BC(I,J)=DDOT(NODIM,SCR(II),1,SCR(JJ),1)
          BC(J,I)=BC(I,J)
        ENDDO
      ENDDO
      DO I=1,IDIIS+1
        VC(I)=0.D0
        BC(I,IDIIS+1)=-1.D0
        BC(IDIIS+1,I)=-1.D0
      ENDDO
      VC(IDIIS+1)=-1.D0
      BC(IDIIS+1,IDIIS+1)=0.D0
C     ==--------------------------------------------------------------==
C     ==  Solve System of Linear Equations                            ==
C     ==--------------------------------------------------------------==
      CALL SOLVE(BC,MXGDIS+1,IDIIS+1,VC)
C     ==--------------------------------------------------------------==
C     ==  Compute Interpolated Coefficient and Gradient Vectors       ==
C     ==--------------------------------------------------------------==
      CALL AZZERO(SCR(IDQ1),NODIM)
      CALL AZZERO(SCR(IDQ2),NODIM)
      DO I=1,IDIIS
        IDDC=IDQ1-1
        IDDG=IDQ2-1
        DO J=1,NODIM
          IDDC=IDDC+1
          IDDG=IDDG+1
          SCR(IDDC)=SCR(IDDC)+VC(I)*TOLD(J,I)
          SCR(IDDG)=SCR(IDDG)+VC(I)*GOLD(J,I)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
C     ==  Estimate New Parameter Vectors                              ==
C     ==--------------------------------------------------------------==
      CALL DCOPY(NODIM*NODIM,HESS(1,1),1,SCR(IDP1),1)
      IOPT=12
      EPS=1.D-6
      LW=6*NODIM
      CALL DGELSS(NODIM,NODIM,1,SCR(IDP1),NODIM,SCR(IDQ2),NODIM,
     *            SCR(IDQ3),EPS,NRANK,SCR(IDQ4),LW,INFO)
      CALL DAXPY(NODIM,-1.0D0,SCR(IDQ2),1,SCR(IDQ1),1)
      CALL DAXPY(NODIM,-1.0D0,XPAR(1),1,SCR(IDQ1),1)
C     ==--------------------------------------------------------------==
C     ==  THIS IS A PRIMITIVE TRUST REGION CONCEPT                    ==
C     ==--------------------------------------------------------------==
      NIC=0
      DO I=1,NODIM
        SCR(IDQ2+NIC)=DTM(I)*DXPAR(I)
        NIC=NIC+1
      ENDDO
      SDLEN=SQRT(DDOT(NODIM,SCR(IDQ2),1,SCR(IDQ2),1))
      QNRLEN=SQRT(DDOT(NODIM,SCR(IDQ1),1,SCR(IDQ1),1))
      TR=100.0D0 * SDLEN
      IF(TR.LT.0.01D0) TR=0.01D0
      TR=MIN(DMAX,TR)
      IF(QNRLEN.GT.TR) THEN
        SS=SQRT(TR/QNRLEN)
        CALL DSCAL(NODIM,SS,SCR(IDQ1),1)
      ENDIF
      CALL FIXCOM(SCR(IDQ1))
      CALL DAXPY(NODIM,1.0D0,SCR(IDQ1),1,XPAR(1),1)
      CALL TIHALT('    RGDIIS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RGDIIS(LRGDIIS,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !PARENT MGDIIS
      INCLUDE 'cotr.inc'        !NODIM
C     Arguments
      INTEGER LRGDIIS
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      LRGDIIS=MAX(
     &     NODIM*NODIM
     &     +NODIM*MGDIIS
     &     +7*NODIM+MGDIIS,
     &     10*NODIM)
      TAG   ='NODIM*NODIM+NODIM*MGDIIS+...'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
