C     ==================================================================
      SUBROUTINE RGMOPT(C0,C1,C2,CM,SC0,PME,GDE,VPP,EIGV)
C     ==--------------------------------------------------------------==
C     == GEOMETRY OPTIMISATION                                        ==
C     == XPAR contains TAU0 non fixed coordinates                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atwf.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'ener.inc' 
      INCLUDE 'cnst.inc' 
      INCLUDE 'nose.inc' 
      INCLUDE 'elct.inc' 
      INCLUDE 'tpar.inc' 
      INCLUDE 'pslo.inc' 
      INCLUDE 'ions.inc' 
      INCLUDE 'soft.inc' 
      INCLUDE 'norm.inc' 
      INCLUDE 'ropt.inc' 
      INCLUDE 'cppt.inc' 
      INCLUDE 'coor.inc' 
      INCLUDE 'sfac.inc' 
      INCLUDE 'cotr.inc' 
      INCLUDE 'strs.inc' 
      INCLUDE 'nlcc.inc' 
      INCLUDE 'andr.inc' 
      INCLUDE 'andp.inc' 
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc' 
      INCLUDE 'poin.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'store.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'symm.inc'
      INCLUDE 'xinr.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'implhv.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'bsym.inc'
      INCLUDE 'bsympnt.inc'
      INCLUDE 'cdft.inc'
#ifdef _BGL_MES
      external apc_init
      external apc_finalize
#endif
c     Qmmm
      real*8 EXTF(*)
      include 'efld.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'lscal.inc'
C     Arguments
      COMPLEX*16 C0(NGWK,N,NKPNT*BSFAC),C2(NGWK,N,BSFAC),C1(*),
     &           CM(*),SC0(NGWK,N,BSFAC),PME(*),GDE(*)
      REAL*8     VPP(*),EIGV(N,NKPTS*BSFAC)
C     Variables
      LOGICAL    TFOR,TINFO,CVBSWF,CVHSWF
      INTEGER    IREC(100),NSTATE,NNX,NHPSI,NX,IFCALC,I,IG,J,
     &           LSCR,IL_RHOE,IL_PSI,NMM,LINR
      INTEGER    MSGLEN
      DIMENSION  RIN0(*),F(N,NKPTS),RK(3,NKPTS),WK(NKPTS)
      REAL*8     FNL(*),DFNL(*)
      REAL*8     TSCR(3,NAX,NSX),
     &           XPAR(*),DXPAR(*),YPAR(*),DYPAR(*),GOLD(*),TOLD(*),
     &           RM1(NNR1*NLSD),RINP(NNR1*NLSD)
      POINTER    (IP_TSCR,TSCR),(IP_XPAR,XPAR),
     &           (IP_DXPAR,DXPAR),(IP_YPAR,YPAR),(IP_DYPAR,DYPAR),
     &           (IP_GOLD,GOLD),(IP_TOLD,TOLD),
     &           (IP_RM1,RM1),(IP_RINP,RINP)
      COMPLEX*16 PSI(NNR1)
      REAL*8     RHOE(NNR1,NLSD),SCR(*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
C
      CHARACTER  TAG*30
      REAL*8     DUMMY(2),TIME1,TIME2,TIME11,TIME22,TCPU,TIMEF,EKINCP,
     &           EKIN1,EKIN2,ETOTO,ETOTG,DETOT,ETOTBS,ETOTHS,
     &           TEMP1,TEMP2,CNMAX,PF1,DSTRESS,DSMAX,THL,
     &           DX,DXMAX,EKINH1,EKINH2
      EXTERNAL   TIMEF
c... inr...
      complex*16 eirop(nhg),eivps(nhg),c11(ngw,*)
      real*8     drhoe(nnr1),z11(n,n)
c      real*8     ddfnl(imagp,nat,nhxs,3,3,n,nkpnt)
      real*8     tras(3*nat,*),tmp(*)
      integer    ldfnl

      pointer (ip_eirop,eirop),(ip_eivps,eivps),(ip_z11,z11)
      pointer (ip_drhoe,drhoe)
      pointer (ip_tmp,tmp),(ip_c11,c11)
c      pointer (ip_ddfnl,ddfnl)
      pointer (ip_tras,tras)
c
      logical status,statusdummy,update_pot,qmmmrest
C     Linear scaling
      REAL*8     GENVMX,WCMPSV
      LOGICAL    LRET,LCVMSK,LTOLAD,LPEXIT
      INTEGER    LRLBFGS,LRPRFO
      LOGICAL PTR_ASSOCIATED
      EXTERNAL PTR_ASSOCIATED
C      integer ia, is, k,iat
      INTEGER    CDFTI
      LOGICAL    CONVTEST
C     ==================================================================
C     Check some options
      IF(TDDFT.AND.TDIAG) THEN
        CALL STOPGM("RGMOPT","TDDFT.AND.TDIAG NOT POSSIBLE")
      ENDIF
C     ==--------------------------------------------------------------==
      TIME1 = TIMEF()
C     TSYMRHO=.FALSE.           ! do not symmetrize density
      NSTATE=N
      call mm_dim(mm_go_mm,status)
C     ==--------------------------------------------------------------==
C     ALLOCATIONS
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TSCR,3*NAX*NSX,'TSCR')
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      CALL AZZERO(TSCR,3*NAX*NSX)
      CALL AZZERO(TAUP,3*NAX*NSX)
      CALL AZZERO(VELP,3*NAX*NSX)
      qmmmrest = .true.
      if(qmmm)then
        if(TEXTFLD)then
          CALL MEMORY(IP_EXTF,KR1*KR2S*KR3S,'EXTF')
          CALL AZZERO(EXTF,KR1*KR2S*KR3S)
        endif
        if(.not.qmnode) qmmmrest = .false.
      endif
      NACC = 7
      NFI  = 0
      IF(TDIAG.and..not.BSYMM) THEN
        NNX=NNR1*NLSD
        CALL MEMORY(IP_RIN0,NNX,'RIN0')
        CALL MEMORY(IP_ROUT0,NNX,'ROUT0')
        CALL MEMORY(IP_RMIX,NNX,'RMIX')
        CALL MEMORY(IP_RM1,NNX,'RM1')
        CALL MEMORY(IP_RINP,NNX,'RINP')
        CALL GET_ADDR(IP_RHOO,RIN0(1))
      ELSEIF(TKPNT .AND. .NOT. TDIAG .and. .not. BSYMM) THEN
        NNX=NNR1*NLSD
        CALL MEMORY(IP_RIN0,NNX,'RIN0')
        CALL MEMORY(IP_RMIX,NNX,'RMIX')
      ENDIF
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      NMM=1
      IF(TDDFT) THEN
        CALL MEMORY(IP_RHOO,IL_RHOE,'RHOO')
        CALL MEMORY(IP_POTR,IL_RHOE,'POTR')
        IF(NS_TRI.GT.0) THEN
          NMM=2
        ENDIF
      ENDIF
      IF(BSYMM) THEN
         CALL MEMORY(IP_FNBS,3*NAX*NSX,'FNBS')
      ENDIF
      NMM=NMM*IL_PSI
      CALL MEMORY(IP_PSI,NMM,'PSI')
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
      CONVGE=.FALSE.
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
C     DFNL
#ifdef PARALLEL
      NDFNL=NST12(MEPOS,2)-NST12(MEPOS,1)+1
#else
      NDFNL=NSTATE
#endif
      LDFNL=IMAGP*3*NAT*NHXS*NDFNL*NKPNT
      IF(LDFNL.LE.0) THEN
        LDFNL=1
      ENDIF
C     ==--------------------------------------------------------------==
      if (tinr) then
         call memory(ip_rho0,il_rhoe,'rho0')
         call azzero(rho0,il_rhoe)
         call memory(ip_drhoe,il_rhoe,'drhoe')
         call azzero(drhoe,il_rhoe)
c     potentials and related:
         call memory(ip_vofrho0,il_rhoe,'v[n0]')
         call azzero(vofrho0,il_rhoe)
         
         call memory(ip_eirop,2*nhg,'eirop')
         call zazzero(eirop,nhg)

         call memory(ip_eivps,2*nhg,'eivps')
         call zazzero(eivps,nhg)

         call memory(ip_c11,2*ngwk*n,'c11')
         call zazzero(c11,ngwk*n)

c     others & scratch:
         call memory(ip_z11,nstate*nstate,'z11')
         call azzero(z11,nstate*nstate)

         call memory(ip_rs_v, 2*3*nat, 'response')
         call azzero(rs_v, 2*3*nat)

         call memory(ip_tmp,           3*nat, 'Lanczos tmp')
         call azzero(tmp,3*nat)
         
         call memory(ip_fnl00,imagp*nstate*nat*nhxs*nkpnt,'fnl00')
         call azzero(fnl00,imagp*nstate*nat*nhxs*nkpnt)

         call memory(ip_dfnl00,ldfnl,'dfnl00')
         call azzero(dfnl00,ldfnl)

         call memory(ip_ddfnl,3*ldfnl,'ddfnl')
         call azzero(ddfnl,3*ldfnl)
         
         call memory(ip_sd0,9*nat*nat,'sd0')
         call azzero(sd0,9*nat*nat)

         call memory(ip_tras,9*nat,'tras')
         call azzero(tras,9*nat)

         call memory(ip_direct,3*nat,'direct')
         call azzero(direct,3*nat)
         call memory(ip_correct,3*nat,'correct')
         call azzero(correct,3*nat)
         call memory(ip_zprec,3*nat,'zprec')
         call azzero(zprec,3*nat)

      endif
C     ==--------------------------------------------------------------==
C     == INITIALIZATION                                               ==
C     ==--------------------------------------------------------------==
C     We allocate only for initrun
      CALL GIVE_SCR_INITRUN(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      IF(BSYMM.and.PARENT) THEN
        PRINT *
        WRITE(6,*) 'BSYMM: BS WAVEFUNCTION INITIALIZATION'
      ENDIF
      IF(CDFT)CALL INIT_CDFT()
      CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
      IF(BSYMM) THEN
        IF(PARENT) WRITE(6,*) 'BSYMM: HS WAVEFUNCTION INITIALIZATION'
        BSCLCS=2
        CALL SETBSSTATE
        CALL INITRUN(IREC,C0(1,1,2),C2(1,1,2),SC0(1,1,2),RHOE,PSI,
     &       EIGV(1,2),SCR,LSCR)
      ENDIF
      CALL FREEM(IP_SCR)
      CALL WRITE_IREC(IREC)
C     ==--------------------------------------------------------------==
      IF (LBFGS.OR.PRFO) THEN
        CALL STACK_INIT(IELSTK,2*NGWK*NSTATE,1,ST_PUT)
      ENDIF
      IF(PARENT) THEN
C       Determination of NODIM
        CALL DETDOF(TAU0,TSCR)
      ENDIF
#ifdef PARALLEL
      msglen=1*8/IRAT
      CALL MY_BCAST(NODIM,MSGLEN,SOURCE,ALLGRP)
      if(tinr) then
         call my_bcast(itmax_inr,msglen,source,allgrp)
         msglen=1 * 8
         call my_bcast(tol_inr,msglen,source,allgrp)
      endif
#endif
C     ==--------------------------------------------------------------==
C     UPDATE SYMMETRIES (POINT GROUP)
C     Needed to correctly initialize scr memory
      CALL UPDATSYM(TAU0)
C     SCR ALLOCATION (SCRATCH ARRAY).
C     We have all information to do that (specially NODIM)
      CALL GIVE_SCR_RGMOPT(LSCR,TAG)
      IF(TINR) THEN
        CALL GIVE_SCR_INR(LINR,TAG,NSTATE)
        LSCR=MAX(LSCR,LINR)
      ENDIF
      CALL MEMORY(IP_SCR,LSCR,'SCR')
C     ==--------------------------------------------------------------==
      if (tinr .OR. PARENT) then ! Don t understand this [sebast]
        CALL MEMORY(IP_XPAR,NODIM,'XPAR')
        CALL MEMORY(IP_DXPAR,NODIM,'DXPAR')
        CALL MEMORY(IP_YPAR,NODIM,'YPAR')
        CALL MEMORY(IP_DYPAR,NODIM,'DYPAR')
      endif
      IF((GDIIS.or.tinr).and.parent) THEN
         CALL MEMORY(IP_GOLD,NODIM*MGDIIS,'GOLD')
         CALL MEMORY(IP_TOLD,NODIM*MGDIIS,'TOLD')
      ENDIF
      IF(PARENT) THEN
        IF(TSDP) THEN
          NPARA=-1
        ENDIF
        IF (LBFGS .AND. LWLBFGS.EQ.0) THEN
          CALL GIVE_WORK_LBFGS(NODIM,LRLBFGS) ! L-BFGS HESSIAN
          CALL MEMORY(IP_WLBFGS,LRLBFGS,'WLBFGS')
        ELSE IF (PRFO .AND. LWPRFO.EQ.0) THEN
           IF (LWLBFGS.EQ.0) THEN
             CALL GIVE_WORK_PRFO(NODIM,LRLBFGS,LRPRFO)
             CALL MEMORY(IP_WPRFO,LRPRFO,'WRPRFO')
             IF (LRLBFGS.GT.0)
     &          CALL MEMORY(IP_WLBFGS,LRLBFGS,'WLBFGS')
           ELSE
             CALL GIVE_WORK_PRFO(NODIM,LRLBFGS,LRPRFO)
             CALL MEMORY(IP_WPRFO,LRPRFO,'WRPRFO')
           ENDIF
        ELSE
          IF (.NOT.(TSDP.OR.LBFGS.OR.PRFO)) THEN
            CALL HESSIN(TAU0,RHE)
          ENDIF
        ENDIF
        CALL PUTTAU(TAU0,XPAR)
        CALL DCOPY(NODIM,XPAR(1),1,YPAR(1),1)
        CALL WRGEOF(TAU0,FION)
        IF(TPRCP) THEN
          CALL WRCELL
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     == INITIALISATION OF DENSITY FOR DIAGONALISATION SCHEMES        ==
C     ==--------------------------------------------------------------==
      IFCALC=0
      IF(TDAVI) THEN
        NX=NGWK*NDAVV*NKPNT+1
      ELSEIF(TDIAG .AND. DIIS) THEN
        NX=((NGWK*N+8)*MDIIS*NKPNT)/4
      ELSE
        NX=1
      ENDIF
      IF(CDFT)THEN
        CALL CDFT_W(RHOE,TAU0,DUMMY)
        IF(CDFT_WEIGHT)CALL WRITE_W(WDIFF,"INIT")
      ENDIF
      IF(TDIAG) THEN
        IF(PARENT) THEN
          WRITE(6,'(1X,64("="))')
          WRITE(6,'(1X,"==",T25,A,T64,"==")')
     &         'FORCES INITIALIZATION'
          WRITE(6,'(1X,64("="))')
        ENDIF
        CALSTE=TPRES.OR.TPRCP
        IF(BSYMM) THEN
          CALL BS_FORCES_DIAG(N,C0,C2,CM,SC0,CM(NX),VPP,EIGV,
     &                        RHOE,PSI,SCR,LSCR,
     &                        TAU0,TAU0,TAU0,FION,IFCALC,
     &                        IREC,.TRUE.,.TRUE.)
        ELSE
          CALL FORCES_DIAG(N,C0,C2,CM,SC0,CM(NX),VPP,EIGV,
     &                     RHOE,PSI,SCR,LSCR,
     &                     TAU0,TAU0,TAU0,FION,IFCALC,
     &                     IREC,.TRUE.,.TRUE.)
        ENDIF
        IF(TPRCP) THEN
          CALL DSTRE(HTFOR,DSTRESS,DSMAX)
        ENDIF
        IF(CALSTE) THEN
          CALL TOTSTR
        ENDIF
        IF(PARENT) THEN
          WRITE(6,'(1X,64("="))')
          WRITE(6,'(1X,"==",T20,A,T64,"==")')
     &         'END OF FORCES INITIALIZATION'
          WRITE(6,'(1X,64("="))')
        ENDIF
        IF(.not.BSYMM) CALL DCOPY(NNX,RIN0,1,RM1,1)
      ENDIF
C..-------------------------------------------------
C..QM/MM mechanical coupling by Roethlisberger Group
C..Initailize Molecular Mechanics subsystem:
C..  (read MM_INPUT,initialize variables,
C..       set up MM force field)
C..-------------------------------------------------
C..
#if defined (__QMECHCOUPL)
      IF(PARENT) THEN
        CALL mm_cpmd_init (TQMMECH ,TAU0, NA, NSP, 
     &                     NAX, NAT, RCO, RVEL, TEMPW)
      END IF
#endif
C     ==--------------------------------------------------------------==
C     == INITIALIZATION OF CONVERGENCE CRITERIA                       ==
C     ==--------------------------------------------------------------==
C     ELECTRONS
      CALL TOL_INIT(LTOLAD,DEACCP,GENVMX)
C     IONS
      LCVMSK = (.NOT.PRFO)
      LPEXIT = .FALSE.
C     ==--------------------------------------------------------------==
C     == END OF INITIALIZATION                                        ==
C     ==--------------------------------------------------------------==
      ETOTO=0.0D0
      ETOTG=0.0D0
      IF(PARENT) THEN
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,T50,F8.2,A8)') ' CPU TIME FOR INITIALIZATION',
     &       TCPU,' SECONDS'
        WRITE(6,'(//,1X,64("="))')
        WRITE(6,'(1X,"=",T20,A,T65,"=")')
     &       ' GEOMETRY OPTIMIZATION'
        WRITE(6,'(1X,64("="))')
        CNMAX=0.D0
        DXMAX=0.D0
        CALL WRPRINT_GEOPT(EIGV,F,AMU,NSTATE,TAU0,FION,
     &           ETOT,ETOTG,TCPU,GEMAX,GNMAX,DXMAX,GNORM,CNMAX,
     &           DSTRESS,DSMAX,.FALSE.,NFI,INFI)
      ENDIF
      CALSTE=.FALSE.
C     ==================================================================
C     ==      THE BASIC LOOP FOR GEOMETRY OPTIMIZATION                ==
C     ==================================================================
      IF(TSDP.AND.TSDE) THEN
        IF(TDDFT) THEN
          CALL STOPGM("RGMOPT","TDDFT NOT POSSIBLE")
        ENDIF
C     ==--------------------------------------------------------------==
C     == COMBINED STEEPEST DESCENT                                    ==
C     ==--------------------------------------------------------------==
        IF(TKPNT) THEN
          CALL STOPGM('RGMOPT','K POINTS NOT IMPLEMENTED')
        ENDIF
        IF(qmmm) THEN
          CALL STOPGM('RGMOPT','qmmm + steepest not tested')
        ENDIF
        CALSTE=TPRCP
        ETOTO=0.0D0
#ifdef _BGL_MES
      call apc_init()
#endif
        DO INFI=1,NOMORE
          TIME1=TIMEF()
          NFI=NFI+1
          IFCALC=INFI
C..       -------------------------------------------------
C..       QM/MM mechanical coupling by Roethlisberger Group
C..       OPTIMIZE QM/MM subsystem with QM atoms frozen
C..       -------------------------------------------------
#if defined (__QMECHCOUPL)
          IF (PARENT.AND.TQMMECH) THEN
            CALL mm_cpmd_geopt (TAU0, NA, NSP, NAX, NAT)
          END IF
#endif
C     AK 2005/05/06 the following line was deleted out in the BSYMM
C     version, but it should not interfere. 
          IF(TDIPD) CALL LOCALIZE2(TAU0,C0,C2,SC0,SCR,LSCR,NSTATE)
          ECNSTR=0.0D0
          ERESTR=0.0D0
C         Initialize forces
          if(qmmm)then
            call mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU0,FION,
     *             EIGV,SCR,LSCR,NSTATE,IL_RHOE,.false.,.true.,.true.)
          else
            CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *                 NSTATE,1,.TRUE.,.TRUE.)
          endif
          IF(CALSTE) THEN
            CALL TOTSTR
          ENDIF
          IF(PARENT) THEN
            CALL DSCAL(3*NAX*NSX,-1.0D0,FION(1,1,1),1)
            CALL PUTTAU(FION,DXPAR)
            CALL CNSTFC(TAU0,TSCR,DXPAR,CNMAX,.FALSE.)
C           CHECK GRADIENT
            CALL GNODIM(DXPAR,NODIM,GNMAX,GNORM)
            IF(TPRCP) THEN
              CALL DSTRE(HTFOR,DSTRESS,DSMAX)
              CONVGE=GNMAX.LT.TOLNG.AND.DSTRESS.LT.TOLCG
            ELSE
              CONVGE=GNMAX.LT.TOLNG
            ENDIF
          ENDIF
          IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
          CALL TESTEX(CONVGE)   ! check if any node is converged
          IF(CONVGE .OR. EXSOFT) GOTO 200
C         UPDATE THE NUCLEAR POSITIONS
          IF(PARENT) THEN
            IF(MOD(IFCALC-1,IPRINT_STEP).EQ.0) THEN
              IF(IPRINT(IPRINT_FORCE).EQ.1) THEN
                CALL WRGEOF(TAU0,FION)
              ENDIF
#if defined (__QMECHCOUPL)
              IF(TQMMECH) THEN
                CALL mm_cpmd_wrgeo
              ENDIF
#endif
            ENDIF
            CALL PUTTAU(TAU0,XPAR)
            CALL SDION(XPAR,DXPAR,SCR,LSCR)
            CALL GETTAU(TAU0,XPAR)
          ENDIF
          MSGLEN = 3*NAX*NSX * 8
          CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
C         UPDATE SYMMETRIES (POINT GROUP)
          CALL UPDATSYM(TAU0)
C         UPDATE WAVEFUNCTION 
          IF(PREC) THEN
            call mm_dim(mm_go_qm,statusdummy)
            CALL HESELE(DT2BYE,VPP)
            call mm_dim(mm_revert,statusdummy)
            PF1=DT2_ELEC*HTHRS/EMASS
            DO I=1,NSTATE
              DO IG=1,NGWK
                C0(IG,I,1)=C0(IG,I,1)+VPP(IG)*PF1*C2(IG,I,1)
              ENDDO
            ENDDO
          ELSE
            CALL DAXPY(2*NGWK*NSTATE,DT2BYE,C2(1,1,1),1,C0(1,1,1),1)
          ENDIF
          IF(qmmmrest.and.MOD(IFCALC,ISCTORE).EQ.0) THEN
            CALL ZHWWF(1,IREC,C0,C2,N,EIGV,TAU0,VELP,TAU0,NFI)
          ENDIF
C         Move the cell
          IF(TSDC) THEN
            CALL SDCELL(TAU0)
          ENDIF
          MSGLEN=3*NAX*NSX * 8
          CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
          IF(TPRCP) THEN
            MSGLEN = 9 * 8
            CALL MY_BCAST(HT,MSGLEN,SOURCE,ALLGRP)
            DO I=1,3
              A1(I) = HT(1,I)
              A2(I) = HT(2,I)
              A3(I) = HT(3,I)
            ENDDO
            CALL IHMAT(HT,HTM1,OMEGA)
            CALL NEWCELL(SCR,LSCR)
          ENDIF
C         REORTHOGONALIZE WAVEFUNCTIONS
          call mm_dim(mm_go_qm,statusdummy)
          CALL PHFAC(TAU0)
          IF(TINLC) THEN
            CALL COPOT(RHOE,PSI,SCR,LSCR,TPRCP)
          ENDIF
          IF(.NOT.NONORT) THEN
            IF(TIVAN) THEN
              CALL RNLSM(C0,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
            ENDIF
            CALL ORTHO(NSTATE,C0,C2,SCR,LSCR)
          ENDIF
          call mm_dim(mm_revert,statusdummy)
C         Printout the evolution of the iterative optimization
          IF(PARENT) THEN
            DETOT=ETOT-ETOTO
            IF(INFI.EQ.1) DETOT=0.0D0
            TIME2=TIMEF()
            TCPU=(TIME2-TIME1)*0.001D0
            IF(TPRCP) THEN
              WRITE(6,*) '  TOTAL STRESS - P (kB): Step:', NFI
              DO I=1,3
                WRITE(6,'(6X,3(F18.8))')
     *           ((HTFP(I,J)/OMEGA)*AU_KB,J=1,3)
              ENDDO
            ENDIF
            IF(MOD(IFCALC-1,IPRINT_STEP).EQ.0) THEN
              CALL WRENER
              IF(TSDC) THEN
                WRITE(6,'(A,A)') ' NFI    GNMAX    GEMAX   HFOR  ',
     *                         '         ETOT         DETOT      TCPU'
              ELSE
                WRITE(6,'(A)')
     *' NFI    GNMAX    GEMAX          ETOT         DETOT      TCPU'
              ENDIF
            ENDIF
            IF(TPRCP) THEN
              CALL DSTRE(HTFOR,DSTRESS,DSMAX)
              WRITE(6,'(I4,F9.6,F9.6,F9.6,F14.5,F14.6,F10.2) ')
     *                 NFI,GNMAX,GEMAX,DSTRESS,ETOT,DETOT,TCPU
            ELSE
              WRITE(6,'(I4,F9.6,F9.6,F14.5,F14.6,F10.2) ')
     *                 NFI,GNMAX,GEMAX,ETOT,DETOT,TCPU
            ENDIF
            ETOTO=ETOT
          ENDIF
          IF(IFCALC.GE.NOMORE_ITER) GOTO 200
        ENDDO
#ifdef _BGL_MES
      call apc_finalize()
#endif
      ELSEIF(SIMUL) THEN
        CALL STOPGM('RGMOPT','SIMUL NOT WORKING')
      ELSE
C     ==--------------------------------------------------------------==
C     == CONVENTIONAL GEOMETRY OPTIMIZATION                           ==
C     == SETUP ATOMIC BASIS TO EXPAND DENSITY                         ==
C     ==--------------------------------------------------------------==
        CALL DCOPY(3*NAX*NSX,TAU0(1,1,1),1,TAUP(1,1,1),1)
        ETOTO=0.0D0
        ETOTG=0.0D0
        IFCALC=0
#ifdef _BGL_MES
      call apc_init()
#endif
        DO INFI=1,NOMORE
          TIME1=TIMEF()
          ECNSTR=0.0D0
          ERESTR=0.0D0
          NFI=NFI+1
          CONVWF=.FALSE.
          CVBSWF=.FALSE.
          CVHSWF=.FALSE.
          SDIIS=.TRUE.
          SPCG=.TRUE.
          IF(CDFT)CALL CDFT_REINIT()
C..       -------------------------------------------------
C..       QM/MM mechanical coupling by Roethlisberger Group
C..       OPTIMIZE QM/MM subsystem with QM atoms frozen
C..       -------------------------------------------------
#if defined (__QMECHCOUPL)
          IF (PARENT.AND.TQMMECH) THEN
            CALL mm_cpmd_geopt (TAU0, NA, NSP, NAX, NAT)
          END IF
#endif
C         Preoptimization of the wavefunction
          CALSTE=(TPRES.AND.MOD(INFI,NPRES).EQ.0).OR.TPRCP
          IF(TDIAG) THEN
            IF(INFI.EQ.1) THEN
              GOTO 100
            ENDIF
            IF(BSYMM) THEN
              CALL BS_FORCES_DIAG(N,C0,C2,CM,SC0,CM(NX),VPP,EIGV,
     &                            RHOE,PSI,SCR,LSCR,
     &                            TAU0,TAU0,TAU0,FION,IFCALC,
     &                            IREC,.TRUE.,.FALSE.)
            ELSE
              CALL FORCES_DIAG(N,C0,C2,CM,SC0,CM(NX),VPP,EIGV,
     &                         RHOE,PSI,SCR,LSCR,
     &                         TAU0,TAU0,TAU0,FION,IFCALC,
     &                         IREC,.TRUE.,.FALSE.)
            ENDIF
            IF(EXSOFT.OR.IFCALC.EQ.NOMORE_ITER) THEN
              GOTO 200
            ENDIF
          ELSE
C           ==--------------------------------------------------------==
           IF(CDFT) THEN
           IF(RECW)CALL CDFT_W(RHOE,TAU0,DUMMY)
           DO CDFTI=1,CDFT_END
            update_pot=.true.
            DO INFW=1,NOMORE_ITER
              if(INFW.gt.1)update_pot=.false.
              TIME11=TIMEF()
              IFCALC=IFCALC+1
C             Check if forces need to be calculated
              CALL TOL_CHK_FORCE(TFOR,CALSTE,GEMAX,INFW)
              IF(CLASSICAL)TFOR=.TRUE.
              IF(TDIPD) CALL LOCALIZE2(TAU0,C0,C2,SC0,SCR,LSCR,NSTATE)
C             Update the wavefunctions
              IF(TKPNT) THEN
                 IF (KDRHO.LT.10.D0*TOLOG) THEN
                    CALSTE = TPRCP
                    TFOR   = .TRUE.
                 ENDIF
                 CALL K_UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     *                RHOE,PSI,SCR,LSCR,NSTATE,TFOR,INFW)
              ELSE
                 IF(.NOT. BSYMM) THEN
                    CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     *                   RHOE,PSI,SCR,LSCR,NSTATE,TFOR,UPDATE_POT)
                 ELSE
                    IF(.NOT.CVHSWF) THEN
C     HS STATE
                       IF(INFW.EQ.1) THEN
                          BSCLCS=2
                          CALL SETBSSTATE
                       ENDIF
                       CALL UPDWF(C0(1,1,2),C2(1,1,2),SC0(1,1,2),TAU0,
     &                      FION,PME,GDE,VPP,EIGV(1,2),RHOE,
     &                      PSI,SCR,LSCR,NSTATE,TFOR,UPDATE_POT)
                       CVHSWF=CONVWF
                    ELSEIF(.NOT.CVBSWF) THEN      
C     BS STATE
                       IF(BSCLCS.EQ.2) THEN 
                          IF(PARENT) THEN
                             WRITE(6,*) 'BSYMM: HS STATE CONVERGED. ',
     &                     'SWITCHING TO BS STATE.'
                             ETOTO=0.0D0
                             IF((INFI.EQ.1).AND.
     &                          (.NOT.RESTHSWF))THEN 
                                IF(PARENT)WRITE(6,'(/,T2,2A,/)')
     &                          '!!!! WARNING : COPYING C0, EIGV & ',
     &                          'C2 OF HS TO BS !!!!'
                                CALL DCOPY(2*NGWK*N,C0(1,1,2),1,C0,1)
                                CALL DCOPY(N,EIGV(1,2),1,EIGV,1)
                                CALL DCOPY(2*NGWK*N,C2(1,1,2),1,C2,1)
                             ENDIF
                          ENDIF
                          BSCLCS=1
                          CALL SETBSSTATE
                          CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,
     &                         VPP,EIGV,RHOE,PSI,SCR,LSCR,NSTATE,
     &                         TFOR,UPDATE_POT)
                          IF(TINFO.and.PARENT) THEN
                             CALL WRENER
                             WRITE(6,'(2A)') 
     &                        ' NFI      GEMAX       CNORM',
     &                        '           ETOT        DETOT      TCPU'
                          ENDIF
                       ELSE
                          CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,
     &                         VPP,EIGV,RHOE,PSI,SCR,LSCR,NSTATE,
     &                         TFOR,UPDATE_POT)
                       ENDIF
                       CVBSWF=CONVWF
                    ENDIF    
                    CONVWF=CVHSWF.and.CVBSWF
                 ENDIF
              ENDIF
              MODENS=.FALSE.
C             Check for convergence in terms of energy change
              CALL TOL_CHK_CNVENER(CONVWF,ETOT,ETOTO)
C             Printout the evolution of the iterative optimization
              IF(PARENT) THEN
                TIME22=TIMEF()
                TCPU=(TIME22-TIME11)*0.001D0
                CALL WRPRINT_WFOPT(EIGV(1,BSCLCS),F,AMU,NSTATE,
     &               ETOT,ETOTO,TCPU,GEMAX,CNORM,0.D0,.FALSE.,INFW,-1)
              ENDIF
              MSGLEN = 8
              CALL MY_BCAST(ETOT,MSGLEN,SOURCE,ALLGRP)
              CALL MY_BCAST(ETOTO,MSGLEN,SOURCE,ALLGRP)
C             Periodically write the restart file
              IF(MOD(IFCALC,ISTORE).EQ.0) THEN
                CALL ZHWWF(2,IREC,C0,C2,NSTATE,EIGV,
     &               TAU0,TAU0,TAU0,NFI)
              ENDIF
C             End of wf optimization
              IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
              IF(EXSOFT.OR.IFCALC.EQ.NOMORE_ITER) THEN
                GOTO 200
              ENDIF
              IF(CLASSICAL) THEN
                GOTO 101 
              ENDIF

              IF(CONVWF.AND.TFOR) THEN
                GOTO 101
              ENDIF
            ENDDO
 101        CONTINUE
            CONVWF=.FALSE.
            CALL VUPDATE(C0,PSI,RHOE,SCR,LSCR,CONVTEST)
            SDIIS=.TRUE.
            SPCG=.TRUE.
            TFOR=.TRUE.
            IF(CONVTEST) THEN
              GOTO 100
            ENDIF
            IF(RESWF) THEN
              IF(PARENT)WRITE(6,*) "Re-initialising Wavefunction"
              CALL RINITWF(C0,C2,SC0,N,TAU0,TAU0,RHOE,PSI,SCR,LSCR)
            ENDIF
           ENDDO
           ELSE
            update_pot=.true.
            DO INFW=1,NOMORE_ITER
              if(INFW.gt.1)update_pot=.false.
              TIME11=TIMEF()
              IFCALC=IFCALC+1
C             Check if forces need to be calculated
              CALL TOL_CHK_FORCE(TFOR,CALSTE,GEMAX,INFW)
              IF(CLASSICAL)TFOR=.TRUE.
              IF(TDIPD) CALL LOCALIZE2(TAU0,C0,C2,SC0,SCR,LSCR,NSTATE)
C             Update the wavefunctions
              IF(TKPNT) THEN
                 IF (KDRHO.LT.10.D0*TOLOG) THEN
                    CALSTE = TPRCP
                    TFOR   = .TRUE.
                 ENDIF
                 CALL K_UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     *                RHOE,PSI,SCR,LSCR,NSTATE,TFOR,INFW)
              ELSE
                 IF(.NOT. BSYMM) THEN
                    CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     *                   RHOE,PSI,SCR,LSCR,NSTATE,TFOR,UPDATE_POT)
                 ELSE
                    IF(.NOT.CVHSWF) THEN
C     HS STATE
                       IF(INFW.EQ.1) THEN
                          BSCLCS=2
                          CALL SETBSSTATE
                       ENDIF
                       CALL UPDWF(C0(1,1,2),C2(1,1,2),SC0(1,1,2),TAU0,
     &                      FION,PME,GDE,VPP,EIGV(1,2),RHOE,
     &                      PSI,SCR,LSCR,NSTATE,TFOR,UPDATE_POT)
                       CVHSWF=CONVWF
                    ELSEIF(.NOT.CVBSWF) THEN      
C     BS STATE
                       IF(BSCLCS.EQ.2) THEN 
                          IF(PARENT) THEN
                             WRITE(6,*) 'BSYMM: HS STATE CONVERGED. ',
     &                     'SWITCHING TO BS STATE.'
                             ETOTO=0.0D0
                             IF((INFI.EQ.1).AND.
     &                          (.NOT.RESTHSWF))THEN 
                                IF(PARENT)WRITE(6,'(/,T2,2A,/)')
     &                          '!!!! WARNING : COPYING C0, EIGV & ',
     &                          'C2 OF HS TO BS !!!!'
                                CALL DCOPY(2*NGWK*N,C0(1,1,2),1,C0,1)
                                CALL DCOPY(N,EIGV(1,2),1,EIGV,1)
                                CALL DCOPY(2*NGWK*N,C2(1,1,2),1,C2,1)
                             ENDIF
                          ENDIF
                          BSCLCS=1
                          CALL SETBSSTATE
                          CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,
     &                         VPP,EIGV,RHOE,PSI,SCR,LSCR,NSTATE,
     &                         TFOR,UPDATE_POT)
                          IF(TINFO.and.PARENT) THEN
                             CALL WRENER
                             WRITE(6,'(2A)') 
     &                        ' NFI      GEMAX       CNORM',
     &                        '           ETOT        DETOT      TCPU'
                          ENDIF
                       ELSE
                          CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,
     &                         VPP,EIGV,RHOE,PSI,SCR,LSCR,NSTATE,
     &                         TFOR,UPDATE_POT)
                       ENDIF
                       CVBSWF=CONVWF
                    ENDIF    
                    CONVWF=CVHSWF.and.CVBSWF
                 ENDIF
              ENDIF
              MODENS=.FALSE.
C             Check for convergence in terms of energy change
              CALL TOL_CHK_CNVENER(CONVWF,ETOT,ETOTO)
C             Printout the evolution of the iterative optimization
              IF(PARENT) THEN
                TIME22=TIMEF()
                TCPU=(TIME22-TIME11)*0.001D0
                CALL WRPRINT_WFOPT(EIGV(1,BSCLCS),F,AMU,NSTATE,
     &               ETOT,ETOTO,TCPU,GEMAX,CNORM,0.D0,.FALSE.,INFW,-1)
              ENDIF
              MSGLEN = 8
              CALL MY_BCAST(ETOT,MSGLEN,SOURCE,ALLGRP)
              CALL MY_BCAST(ETOTO,MSGLEN,SOURCE,ALLGRP)
C             Periodically write the restart file
              IF(qmmmrest.and.(MOD(IFCALC,ISCTORE).EQ.0)) THEN
                CALL ZHWWF(2,IREC,C0,C2,NSTATE,EIGV,
     &               TAU0,TAU0,TAU0,NFI)
              ENDIF
C             End of wf optimization
              IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
              IF(EXSOFT.OR.IFCALC.EQ.NOMORE_ITER) THEN
                GOTO 200
              ENDIF
              IF(CLASSICAL) THEN
                GOTO 100 
              ENDIF

              IF(CONVWF.AND.TFOR) THEN
                GOTO 100
              ENDIF
            ENDDO
           ENDIF
          ENDIF
C         ==----------------------------------------------------------==
 100      CONTINUE
          IF(BSYMM) THEN
C           BS energy calculation 
C           BS state
            BSCLCS=1
            CALL SETBSSTATE
            CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     &                 RHOE,PSI,SCR,LSCR,NSTATE,TFOR,UPDATE_POT)
            IF(PARENT) THEN
              IF(INFI.eq.NOMORE) THEN
                PRINT *
                PRINT *, 'BSYMM: BS STATE ENERGIES:'
                CALL WRENER
              ENDIF  
              ETOTBS=ETOT
              CALL DCOPY(3*NAX*NSX,FION,1,FNBS,1)
            ENDIF
C           HS state      
            BSCLCS=2
            CALL SETBSSTATE
            CALL UPDWF(C0(1,1,2),C2(1,1,2),SC0(1,1,2),TAU0,FION,PME,
     &                 GDE,VPP,EIGV(1,2),RHOE,PSI,SCR,LSCR,
     &                 NSTATE,TFOR,UPDATE_POT)
            IF(PARENT) THEN
              IF(INFI.eq.NOMORE) THEN
               PRINT *
               PRINT *, 'BSYMM: HS STATE ENERGIES:'
               CALL WRENER
              ENDIF
              ETOTHS=ETOT
C             LS state      
              ETOT = (1 + CNSTWGT) * ETOTBS - CNSTWGT * ETOTHS
              CALL WRCCFL(ETOT,ETOTBS,ETOTHS)
              CALL LSFORCE(FNBS,FION)
            ENDIF
          ENDIF
C         if(PRFO) then       ! use CONVERGENCE CALFOR 1.0 instead
C            CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,
C     &                           SCR,LSCR,N,1,.TRUE.,.TRUE.)
C          endif
          if(qmmm)then
            CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     *                   RHOE,PSI,SCR,LSCR,NSTATE,TFOR,.true.)
          endif
          IF(TDDFT) THEN
             CALL LR_TDDFT(C0,C1,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,
     *                     SCR,LSCR,NSTATE,.TRUE.,IOUTPUT)
          ENDIF
          IF (qmmmrest.and.
     .        (ISCTORE.EQ.0 .OR. ISCTORE.GT.NOMORE_ITER) ) THEN
            CALL ZHWWF(2,IREC,C0,C2,NSTATE,EIGV,TAU0,TAU0,TAU0,NFI)
          ENDIF
C         ==----------------------------------------------------------==
C         Update stress tensor.
          IF(CALSTE) THEN
            CALL TOTSTR
          ENDIF
          IF(PARENT) THEN
            DETOT=ETOT-ETOTG
            IF(INFI.NE.1) THEN
C             Decrease step for very large drops in energy..AA
              IF(DETOT.GT.1.D-6.OR.DETOT.LE.-5.D-3) THEN
                CALL DSCAL(NODIM,0.5D0,DTM(1),1)
              ELSE
C               CALL DSCAL(NODIM,1.25D0,DTM(1),1)
C               Use a more conservative upward scaling factor..AA
                CALL DSCAL(NODIM,1.10D0,DTM(1),1)
              ENDIF
            ENDIF
            CALL DSCAL(3*NAX*NSX,-1.0D0,FION(1,1,1),1)
C           UPDATE NUCLEAR HESSIAN
            CALL PUTTAU(FION,DXPAR)

            IF(RFO) THEN
C..USE POWELL UPDATE FOR TRANSITION STATE SEARCH
              IF(INFI.NE.1) THEN
                IF(NSORDER.EQ.0) THEN
                  CALL HESSUP(XPAR,YPAR,DXPAR,DYPAR,SCR,LSCR)
                ELSE
                  CALL HESPOW(XPAR,YPAR,DXPAR,DYPAR,SCR,LSCR)
                ENDIF
              ENDIF
              CALL CNSTFC(TAU0,TSCR,DXPAR,CNMAX,.TRUE.)
            ELSE
              CALL CNSTFC(TAU0,TSCR,DXPAR,CNMAX,.FALSE.)
              IF(.NOT.(TSDP.OR.LBFGS.OR.PRFO).AND.INFI.NE.1.and.
     &             (.not.tinr.or.tmixgdiis)) THEN
                CALL HESSUP(XPAR,YPAR,DXPAR,DYPAR,SCR,LSCR)
              ENDIF
            ENDIF
            IF(.NOT.(TSDP.OR.LBFGS.OR.PRFO)) THEN
C       Symmetrize Hessian
              IF( INDPG.NE.0.AND.(NROT.NE.1.OR.NTVEC.GT.1) ) THEN
                IF(NODIM.EQ.3*NAT) THEN
                  CALL SYMMAT(HESS,SCR,LSCR,0)
                ENDIF
              ENDIF
C AK: hessian for typical QM/MM is huge. don't write it.
              IF(.NOT.TQMMM) CALL HESSOUT 
            ENDIF
            CALL DCOPY(NODIM, XPAR(1),1, YPAR(1),1)
            CALL DCOPY(NODIM,DXPAR(1),1,DYPAR(1),1)
C           CHECK GRADIENT
            CALL GNODIM(DXPAR,NODIM,GNMAX,GNORM)
            IF(TPRCP) THEN
C             Check cell gradient (stress)
              CALL DSTRE(HTFOR,DSTRESS,DSMAX)
              CONVGE=GNMAX.LT.TOLNG.AND.DSTRESS.LT.TOLCG
            ELSE
              IF(GNMAX.LT.TOLNG) CONVGE=.TRUE.
            ENDIF
C           Printout the evolution of the iterative optimization
            TIME2=TIMEF()
            TCPU=(TIME2-TIME1)*0.001D0
            CALL WRPRINT_GEOPT(EIGV,F,AMU,NSTATE,TAU0,FION,
     &           ETOT,ETOTG,TCPU,GEMAX,GNMAX,DXMAX,GNORM,CNMAX,
     &           DSTRESS,DSMAX,CONVGE,IFCALC,INFI)
            CONVGE = (CONVGE.AND.LCVMSK)
          ENDIF      ! IF (PARENT)
C         ==----------------------------------------------------------==
C         CHECK IF IONS CONVERGED
          IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
          CALL TESTEX(CONVGE)
          IF(CONVGE.OR.EXSOFT) GOTO 200
          IF(IFCALC.GE.NOMORE_ITER) THEN
            IF(PARENT) THEN
              WRITE(6,'(1X,64("!"))')
              WRITE(6,'(" !!",A,A,I5,A,T64,"!!")')
     &          ' RGMOPT| THE MAXIMUM NUMBER OF ITERATIONS IS REACHED',
     &             ' (',IFCALC,')'
              WRITE(6,'(1X,64("!"))')
            ENDIF
            GOTO 200
          ENDIF
          IF(INFI.EQ.NOMORE) THEN
            IF(PARENT) THEN
              WRITE(*,'(1X,64("!"))')
              WRITE(*,'(" !!",A,A,I5,A,T64,"!!")')
     &             ' RGMOPT| THE MAX. NUMBER OF GEOSTEPS IS REACHED',
     &             ' (',INFI,')'
              WRITE(*,'(1X,64("!"))')
            ENDIF
            GOTO 200
          ENDIF
C         ==----------------------------------------------------------==
          IF( qmmmrest.and.(.NOT.(MOD(IFCALC,ISCTORE).EQ.0)).AND.
     &        MOD(NFI,ISTORE).EQ.0) THEN
            WCMPSV = WCOMPB
            WCOMPB = MIN(WCOMPB*4, 8)
            CALL ZHWWF(1,IREC,C0,C2,NSTATE,EIGV,TAU0,TAU0,TAU0,NFI)
            WCOMPB = INT(WCMPSV)
          ENDIF
C         ==----------------------------------------------------------==
C         UPDATE THE NUCLEAR POSITIONS
          CALL DCOPY(3*NAX*NSX,TAU0(1,1,1),1,TAUP(1,1,1),1)
          IF(TINR) then
             call puttau(tau0,xpar)
             CALL INR_DR(c0,c11,nstate,XPAR,DXPAR,SCR,LSCR,psi,rhoe,
     &            tras,tmp,eirop,eivps,told,gold)
             if(.not.exsoft) call testex(exsoft)
             if(exsoft) then
               goto 200
             endif
          ENDIF
C         SAVE THE WAVEFUNCTION (ONLY AT INIT)
          IF (LBFGS.OR.PRFO) THEN
            CALL STACK_DO_SCHED(IELSTK,C0,2*NGWK*NSTATE)
          ENDIF
          IF(PARENT) THEN
            IF(TSDP) THEN
              CALL SDION(XPAR,DXPAR,SCR,LSCR)
            ELSEIF(GDIIS) THEN
              CALL RGDIIS(XPAR,DXPAR,TOLD,GOLD,SCR,LSCR)
            ELSEIF(BFGS) THEN
              CALL RBFGS(XPAR,DXPAR,SCR,LSCR)
            ELSEIF(LBFGS) THEN
               LRET = .FALSE.
               CALL RLBFGS(XPAR,DXPAR,NODIM,ETOT+ECNSTR+ERESTR,LRET)
            ELSEIF(PRFO) THEN
              CALL RPRFO(XPAR,DXPAR,ETOT,SCR,LSCR,
     &                   LTOLAD,GENVMX,LCVMSK,LPEXIT)
              IF (LPEXIT) THEN
                CONVGE = .TRUE.
              ENDIF
            ELSEIF(RFO) THEN
              CALL RRFO(XPAR,DXPAR,SCR,LSCR)
            ENDIF
            CALL GETTAU(TAU0,XPAR)
            DXMAX=0.0D0
C           Check convergence on atomic positions (for the next it.)
C           (DXMAX .LT. 0.01*TOLNG)
            DO I=1,NODIM
              DX=ABS(XPAR(I)-YPAR(I))
              DXMAX=MAX(DX,DXMAX)
            ENDDO
            IF(DXMAX.LT.1.D-2*TOLNG.AND..NOT.(TSDP.OR.PRFO))
     $           CONVGE=.TRUE.
            CALL GEOFILE(TAU0,FION,'WRITE')
          ENDIF                  ! IF (PARENT)
C         CONVERGENCE CRITERIA FOR THE WAVEFUNCTION GRADIENT
          CALL TOL_DET_GRAD(LTOLAD,GNMAX,GENVMX)
C         CONVERGENCE CRITERIA BASED ON ENERGY CHANGE
          CALL TOL_DET_ENER(LTOLAD,INFI,DETOT,DEACCP)
C         IF SCHEDULED, STORE OR RESTORE THE WAVEFUNCTION NOW
          IF (LBFGS.OR.PRFO) THEN
            CALL STACK_DO_SCHED(IELSTK,C0,2*NGWK*NSTATE)
          ENDIF
C         MOVE THE CELL
          IF(TPRCP) THEN
            CALL TOTSTR
            IF(TSDC) THEN
              CALL SDCELL(TAU0)
            ENDIF
          ENDIF
C         Broadcast new nuclear positions
          MSGLEN = 3*NAX*NSX * 8
          CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
C         UPDATE SYMMETRIES (POINT GROUP)
          CALL UPDATSYM(TAU0)
          IF(TPRCP) THEN
            MSGLEN = 9 * 8
            CALL MY_BCAST(HT,MSGLEN,SOURCE,ALLGRP)
            DO I=1,3
              A1(I) = HT(1,I)
              A2(I) = HT(2,I)
              A3(I) = HT(3,I)
            ENDDO
            CALL IHMAT(HT,HTM1,OMEGA)
            CALL NEWCELL(SCR,LSCR)
          ENDIF
C         Reset swap file to update (option BLOCK and ALL)
          IF(TKBLOCK) THEN
            CALL RESKPT_SWAP
          ENDIF
C         Initialize form factors
C         Reorthogonalize wavefunctions
          call mm_dim(mm_go_qm,statusdummy)
          CALL PHFAC(TAU0)
          IF(TDIAG) THEN
            IF(TMOVR) THEN
              CALL DCOPY(NNX,RIN0(1),1,RHOE(1,1),1)
              CALL MOVERHO(RHOE,PSI,SCR,LSCR)
              CALL DCOPY(NNX,RHOE(1,1),1,RIN0(1),1)
            ENDIF
C           Update density
            IF(.not.BSYMM) THEN
               CALL EXTRAP(NNX,ALXMIX,RM1,RIN0,RINP)
               CALL DCOPY(NNX,RIN0,1, RM1,1)
               CALL DCOPY(NNX,RINP,1,RIN0,1)
            ENDIF
          ENDIF
          IF(TTROT) THEN
            CALL CALC_ALM(SCR,LSCR)
          ENDIF
          IF(TINLC) THEN
            CALL COPOT(RHOE,PSI,SCR,LSCR,TSDC)
          ENDIF
          IF(.NOT.NONORT) THEN
            IF(.NOT.BSYMM)THEN
              IF(TIVAN) THEN
                 CALL RNLSM(C0,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
              ENDIF
              CALL ORTHO(NSTATE,C0,C2,SCR,LSCR)
            ELSE
              BSCLCS=1
              CALL SETBSSTATE
              IF(TIVAN) THEN
                 CALL RNLSM(C0,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
              ENDIF
              CALL ORTHO(NSTATE,C0,C2,SCR,LSCR)
              BSCLCS=2
              CALL SETBSSTATE
              IF(TIVAN)CALL RNLSM(C0(1,1,2),NSTATE,PSI,SCR,LSCR,
     &                            1,1,.FALSE.)
              CALL ORTHO(NSTATE,C0(1,1,2),C2(1,1,2),SCR,LSCR)
            ENDIF
          ENDIF
          call mm_dim(mm_revert,statusdummy)
        ENDDO
#ifdef _BGL_MES
      call apc_finalize()
#endif
C     ==================================================================
C     ==     END OF MAIN LOOP                                         ==
C     ==================================================================
      ENDIF
  200 CONTINUE
      IF(CDFT)THEN
        IF(CDFT_WEIGHT)CALL WRITE_W(WDIFF,"FINAL")
      ENDIF
      IF(PARENT) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"=",T17,A,T65,"=")')
     &       'END OF GEOMETRY OPTIMIZATION'
        WRITE(6,'(1X,64("="),/,/)')
      ENDIF
C     Store wavefunction and positions
      if (qmmmrest) 
     .   CALL ZHWWF(2,IREC,C0,C2,NSTATE,EIGV,TAU0,TAU0,TAU0,NFI)
      IF(RHOOUT.and..not.BSYMM) THEN
        CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPNT)
      ENDIF
      if(RHOOUT.and.BSYMM) then
         BSCLCS=1
         CALL SETBSSTATE
         CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,N,NKPNT)
         BSCLCS=2
         CALL SETBSSTATE
         CALL RHOPRI(C0(1,1,2),TAU0,RHOE,PSI,SCR,LSCR,N,NKPNT)
         BSCLCS=1
         CALL SETBSSTATE
      endif
      IF(.NOT.CALSTE.AND.TPRES) THEN
C       Calculate stress tensor
        IF(TDIAG) THEN
          CALL AZZERO(FION,3*NAX*NSX)
          CALL UPDRHO(C0,C2,CM,SC0,CM(NX),VPP,TAU0,FION,EIGV,
     *                RHOE,PSI,SCR,LSCR,
     *                N,.TRUE.,.FALSE.,TPRES,INFI,THL,NHPSI)
        ELSE
          CALSTE=TPRES
          CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     *               RHOE,PSI,SCR,LSCR,N,.TRUE.,.true.)
        ENDIF
        CALL TOTSTR
      ENDIF
      IF(PARENT) THEN
        CALL DUMPR
        CALL CNSTPR
C       (T.D.) in order to have same GNORM in results and good FION
C       CALL TAUCL(FION)
C       CALL GSIZE(FION,GNMAX,GNORM)
        CALL PUTTAU(FION,DXPAR)
        CALL GNODIM(DXPAR,NODIM,GNMAX,GNORM)
C       Give final results
        IF(.NOT.BSYMM) THEN
           CALL FINALP(TAU0,FION,VELP,EIGV)
        ELSE
           CALL WRGEOF(TAU0,FION)
           WRITE(6,'(A)') ' NUCLEAR GRADIENT: '
           WRITE(6,'(2(A,1PE15.5))') '    MAX. COMPONENT =',
     &          GNMAX,'         NORM =',GNORM
        ENDIF
        CALL GEOFILE(TAU0,FION,'WRITE')
C       Do vibrational analysis
        IF(PRFO.AND.NSVIB.NE.0.AND.LVLHES) THEN
          CALL PVIBANA
        ENDIF
      ENDIF
C     Deallocation
      IF(TINR.OR.PARENT) THEN
        CALL FREEM(IP_XPAR)
        CALL FREEM(IP_DXPAR)
        CALL FREEM(IP_YPAR)
        CALL FREEM(IP_DYPAR)
      ENDIF
      IF(PARENT) THEN
        CALL FREEM(IP_DTM)
        IF(GDIIS.OR.TINR) THEN
          CALL FREEM(IP_GOLD)
          CALL FREEM(IP_TOLD)
        ENDIF
        IF(LBFGS) THEN
          CALL FREEM(IP_WLBFGS)
        ENDIF
        IF(PRFO)THEN
           IF(.NOT.PTR_ASSOCIATED(IP_WPRFO,IP_HESSCR)) THEN
             CALL FREEM(IP_HESSCR)
           ENDIF
           CALL FREEM(IP_WPRFO)
           IF (LRLBFGS.GT.0) THEN
             CALL FREEM(IP_WLBFGS)
           ENDIF
        ENDIF
        IF(LBFGS.OR.PRFO) THEN
          CALL STACK_DESTROY(IELSTK)
        ENDIF
      ENDIF
      CALL FREEM(IP_FION)
      CALL FREEM(IP_TSCR)
      CALL FREEM(IP_TAUP)
      IF(TDIAG) THEN
        CALL FREEM(IP_RIN0)
        CALL FREEM(IP_ROUT0)
        CALL FREEM(IP_RMIX)
        CALL FREEM(IP_RINP)
        CALL FREEM(IP_RM1)
      ELSEIF(TKPNT) THEN
        CALL FREEM(IP_RIN0)
        CALL FREEM(IP_RMIX)
      ENDIF
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
      IF(BSYMM) CALL FREEM(IP_FNBS)
      IF(TDDFT) THEN
        CALL FREEM(IP_POTR)
        CALL FREEM(IP_RHOO)
      ENDIF
C     ==--------------------------------------------------------------==
      if (tinr) then
         call freem(ip_rho0)
         call freem(ip_drhoe)

c     potentials and related:
         call freem(ip_vofrho0)
         call freem(ip_eirop)
         call freem(ip_eivps)

c     others & scratch:
         call freem(ip_z11)
         call freem(ip_rs_v)
         call freem(ip_tmp)
         call freem(ip_fnl00)
         call freem(ip_dfnl00)
         call freem(ip_ddfnl)
         call freem(ip_sd0)
         call freem(ip_tras)
         call freem(ip_c11)
         call freem(ip_direct)
         call freem(ip_correct)
         call freem(ip_zprec)
      endif

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RGMOPT(LRGMOPT,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !nlcc.inc TSDE,TSDP,DIIS
      INCLUDE 'elct.inc'        !N number of states
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'store.inc'       !RHOOUT
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'        !TTROT
      INCLUDE 'atwf.inc'        !TMOVR
C     Arguments
      INTEGER   LRGMOPT
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LINITRUN,LCOPOT,LORTHO,LRNLSM,LRHOOFR,
     &          LCALC_ALM,LFORCES,
     &          LSDION,LRGDIIS,LRBFGS,LRLBFGS,LRPRFO,LRRFO,LTDDFT,
     &          LNEWCELL,LDEORT,LUPDWF,LPREPV,LPOSUPA,LRORTV,
     &          LFORCES_DIAG,LRHOPRI,LMOVERHO,LRINR,LDIPD
C     ==--------------------------------------------------------------==
      NSTATE=N
      LCOPOT=0
      LORTHO=0
      LRNLSM=0
      LRHOOFR=0
      LCALC_ALM=0
      LFORCES_DIAG=0
      LFORCES=0
      LSDION=0
      LRGDIIS=0
      LRBFGS=0
      LRLBFGS=0
      LRPRFO=0
      LRRFO=0
      lrinr=0
      LNEWCELL=0
      LDEORT=0
      LUPDWF=0
      LPREPV=0
      LPOSUPA=0
      LRORTV=0
      LFORCES_DIAG=0
      LRHOPRI=0
      LMOVERHO=0
      LTDDFT=0
      CALL GIVE_SCR_INITRUN(LINITRUN,TAG)
      IF(RESTART) THEN
        IF(TINLC) THEN
          CALL GIVE_SCR_COPOT(LCOPOT,TAG)
        ENDIF
        CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      ENDIF
      IF(TDIAG) THEN
        IF(TIVAN) THEN
          CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
        ENDIF
        CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
        IF(TTROT) THEN
          CALL GIVE_SCR_CALC_ALM(LCALC_ALM,TAG)
        ENDIF
        CALL GIVE_SCR_FORCES_DIAG(LFORCES_DIAG,TAG,NSTATE,.TRUE.)
      ENDIF
      IF(TSDP.AND.TSDE) THEN
        CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.TRUE.,.TRUE.)
        IF(PARENT) THEN
          CALL GIVE_SCR_SDION(LSDION,TAG)
        ENDIF
        IF(TPRCP) THEN
          CALL GIVE_SCR_NEWCELL(LNEWCELL,TAG)
        ENDIF
        IF(TINLC) THEN
          CALL GIVE_SCR_COPOT(LCOPOT,TAG)
        ENDIF
        IF(.NOT.NONORT) THEN
          CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
        ENDIF
      ELSE
        IF(TPRCP) THEN
          CALL GIVE_SCR_NEWCELL(LNEWCELL,TAG)
        ENDIF
        IF(TDIAG) THEN
          CALL GIVE_SCR_FORCES_DIAG(LFORCES_DIAG,TAG,NSTATE,.TRUE.)
          IF(TMOVR) THEN
            CALL GIVE_SCR_MOVERHO(LMOVERHO,TAG)
          ENDIF
        ELSE
          CALL GIVE_SCR_UPDWF(LUPDWF,TAG,NSTATE,.TRUE.)
        ENDIF
        IF(PARENT) THEN
C         HESSUP needs 3*NODIM which is small than the other routines
          IF(TSDP) THEN
            CALL GIVE_SCR_SDION(LSDION,TAG)
          ELSEIF(GDIIS) THEN
            CALL GIVE_SCR_RGDIIS(LRGDIIS,TAG)
          ELSEIF(BFGS) THEN
            CALL GIVE_SCR_RBFGS(LRBFGS,TAG)
          ELSEIF(LBFGS) THEN
            CALL GIVE_SCR_RLBFGS(LRLBFGS,TAG)
          ELSEIF(PRFO) THEN
            CALL GIVE_SCR_RPRFO(LRPRFO,TAG)
          ELSEIF(RFO) THEN
            CALL GIVE_SCR_RRFO(LRRFO,TAG)
          ELSEIF(TINR) THEN
            CALL GIVE_SCR_INR(LRINR,TAG,nstate)
          ENDIF
        ENDIF
        IF(TTROT) THEN
          CALL GIVE_SCR_CALC_ALM(LCALC_ALM,TAG)
        ENDIF
        IF(.NOT.NONORT) THEN
          CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
        ENDIF
      ENDIF
      IF(TDDFT) THEN
        CALL GIVE_SCR_LR_TDDFT(LTDDFT,.TRUE.,TAG)
      ENDIF
      IF(RHOOUT) THEN 
        CALL GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
      ENDIF
      IF(TDIPD) THEN
        CALL GIVE_SCR_DDIPO(LDIPD,TAG)
      ELSE
        LDIPD=0
      ENDIF
      LRGMOPT=MAX(LINITRUN,LCOPOT,LORTHO,LRNLSM,LRHOOFR,
     &          LCALC_ALM,LFORCES_DIAG,LFORCES,
     &          LSDION,LRGDIIS,LRBFGS,LRRFO,lrinr,LRLBFGS,LRPRFO,
     &          LNEWCELL,LDEORT,LUPDWF,LPREPV,LPOSUPA,LRORTV,
     &          LDIPD,LFORCES_DIAG,LRHOPRI,LMOVERHO,LTDDFT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
