C     ==================================================================
      SUBROUTINE RGS(CP,NSTATE,SMAT,IS)
C     ==--------------------------------------------------------------==
C     ==  GRAM-SCHMIDT ORTHOGONALIZATION                              ==
C     ==  IS(NSTATE) unused                                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE,IS(*)
      REAL*8     SMAT(NSTATE,*)
      COMPLEX*16 CP(NGW,*)
C     Variables
      INTEGER    ISUB
C     ==--------------------------------------------------------------==
      IF(NSTATE.LE.0) RETURN
      CALL TISET('       RGS',ISUB)
      CALL AZZERO(SMAT,NSTATE*NSTATE)
      IF(NGW.GT.0)
     *   CALL DSYRK('U','T',NSTATE,2*NGW,2.D0,CP,2*NGW,0.D0,SMAT,NSTATE)
      IF(GEQ0)
     *  CALL DGER(NSTATE,NSTATE,-1.0D0,CP,2*NGW,CP,2*NGW,SMAT,NSTATE)
      CALL GLOSUM(NSTATE*NSTATE,SMAT)
      CALL UINV('U',SMAT,NSTATE,NSTATE)
      IF(NGW.GT.0)
     *   CALL DTRMM('R','U','N','N',2*NGW,NSTATE,1.D0,SMAT,NSTATE,
     *              CP,2*NGW)
      IF(GEQ0) CALL ZCLEAN(CP,NSTATE,NGW)
      CALL TIHALT('       RGS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE UINV(UPLO,SMAT,LDA,N)
C     ==--------------------------------------------------------------==
C     == Inversion of a positive definite matrix                      =
C     == Use for orthogonalisation                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER UPLO*1
      INTEGER   LDA,N
      REAL*8    SMAT(LDA,*)
C     Variables
      INTEGER   INFO
C     ==--------------------------------------------------------------==
      CALL DPOTRF(UPLO,N,SMAT,LDA,INFO)
      IF(INFO.NE.0) THEN
        IF(INFO.LT.0) THEN
          WRITE(6,'(A,I5,A)')
     &         ' UNIV| THE I-TH (',-INFO,
     &         ') ARGUMENT HAD AN ILLEGAL VALUE'
        ELSE
          WRITE(6,'(A,I5,A)')
     &         ' UNIV| THE LEADING MINOR OF ORDER',INFO,
     &         ' IS NOT POSITIVE DEFINITE, '
          WRITE(6,'(A)')
     &         ' UNIV| AND THE FACTORIZATION COULD NOT BE COMPLETED.'
        ENDIF
        CALL STOPGM('UINV','ILLEGAL RESULTS DPOTRF')
      ENDIF
      CALL DTRTRI(UPLO,'N',N,SMAT,LDA,INFO)
      IF(INFO.NE.0) CALL STOPGM('UINV','ILLEGAL RESULTS DTRTRI')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RGS_C(CP,NSTATE,SMAT,IS)
C     ==--------------------------------------------------------------==
C     ==  GRAM-SCHMIDT ORTHOGONALIZATION                              ==
C     ==  IS(NSTATE) unused                                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE,IS(*)
      COMPLEX*16 CP(NGWK,*),SMAT(NSTATE,*)
C     Variables
      INTEGER    ISUB
C     ==--------------------------------------------------------------==
      IF(NSTATE.LE.0) RETURN
      CALL TISET('     RGS_C',ISUB)
      CALL ZAZZERO(SMAT,NSTATE*NSTATE)
      IF(NGWK.GT.0)
     *    CALL ZHERK('U','C',NSTATE,NGWK,1.D0,CP,NGWK,0.D0,SMAT,NSTATE)
      CALL GLOSUM(2*NSTATE*NSTATE,SMAT)
      CALL UINVC('U',SMAT,NSTATE,NSTATE)
      IF(NGW.GT.0)
     *   CALL ZTRMM('R','U','N','N',2*NGW,NSTATE,DCMPLX(1.D0,0.D0),
     *              SMAT,NSTATE,CP,2*NGW)
      IF(GEQ0) CALL ZCLEAN_K(CP,NSTATE,NGW)
      CALL TIHALT('     RGS_C',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE UINVC(UPLO,SMAT,LDA,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER  UPLO*1
      INTEGER    LDA,N
      COMPLEX*16 SMAT(LDA,N)
C     Variables
      INTEGER    INFO
C     ==--------------------------------------------------------------==
      CALL ZPOTRF(UPLO,N,SMAT,LDA,INFO)
      IF(INFO.NE.0) THEN
        IF(INFO.LT.0) THEN
          WRITE(6,'(A,I5,A)')
     &         ' UNIVC| THE I-TH (',-INFO,
     &         ') ARGUMENT HAD AN ILLEGAL VALUE'
        ELSE
          WRITE(6,'(A,I5,A)')
     &         ' UNIVC| THE LEADING MINOR OF ORDER',INFO,
     &         ' IS NOT POSITIVE DEFINITE, '
          WRITE(6,'(A)')
     &         ' UNIVC| AND THE FACTORIZATION COULD NOT BE COMPLETED.'
        ENDIF
        CALL STOPGM('UINVC','ILLEGAL RESULTS DPOTRF')
      ENDIF
      CALL ZTRTRI(UPLO,'N',N,SMAT,LDA,INFO)
      IF(INFO.NE.0) CALL STOPGM('UINVC','ILLEGAL RESULTS ZTRTRI')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

