C     ==================================================================
      SUBROUTINE RHO1OFR(C0,C1,FOCC,RHOE,PSI,NSTATE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == THE FIRST ORDER RESPONSE DENSITY RHO1                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'rswf.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'symm.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,NSTATE),C1(NGW,NSTATE),PSI(MAXFFT*NOGRP)
      REAL*8     RHOE(NNR1,NLSD)
      REAL*8     FOCC(NSTATE)
C     Variables
      REAL*8     FNL(*),DFNL(*)
      REAL*8     RHOEG(*),PSIX(*)
      POINTER    (IP_RHOEG,RHOEG),(IP_PSIX,PSIX)
      INTEGER    ISUB,LEAD,LEADX,NNRX,IFFT,I,L,IS1,IS2,LRHO1OFR,
     &           IG,IR,ID,NSTA,IB,IBB,IWF,ISPIN1,ISPIN2,IAT,IS,IA
      REAL*8     DOTP,G2,COEF3,R1,R2,TT,RSUMG,RSUMR
      EXTERNAL   DOTP
      REAL*8     RTO,RSP,RAL,RBE,FF
      REAL*8     O3
      PARAMETER  (O3=0.33333333333333333D0)
#ifdef PARALLEL
      INTEGER    MSGLEN,NL2,IX1,IXP,IX
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   RHO1OFR',ISUB)
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      IF(NOGRP.EQ.1) THEN
        LEAD  = KR1S*NGRAYS
        LEADX = NNR1
        IFFT=1
        NNRX=NNR1
      ELSE
        LEAD  = KR1S*NGRM
        LEADX = KRX*KR2S*KR3S
        IFFT=2
        NNRX=KRX*KR2S*KR3S
      ENDIF
#else
      LEAD  = NNR1
      LEADX = NNR1
      NNRX=NNR1
      IFFT=1
#endif
      CALL GET_ADDR(IP_PSIX,PSI(1))
      CALL GET_ADDR(IP_RHOEG,RHOE(1,1))
C     Initialize
      CALL AZZERO(RHOEG,NLSD*LEADX)
C     Loop over the electronic states
      DO ID=1,NSTATE,NOGRP
        NSTA=MIN(NSTATE-ID+1,NOGRP)
        CALL ZAZZERO(PSI,MAXFFT*NOGRP)
        DO IB=1,NSTA
          I=ID+(IB-1)
          IBB=(IB-1)*LEAD
!CDIR NODEP
          DO IG=1,NGW
            PSI(NZHS(IG)+IBB)=C0(IG,I)+UIMAG*C1(IG,I)
            PSI(INDZS(IG)+IBB)=DCONJG(C0(IG,I))+
     *                   UIMAG*DCONJG(C1(IG,I))
          ENDDO
          PSI(NZHS(1)+IBB)=C0(1,I)+UIMAG*C1(1,I)
        ENDDO
C     ==--------------------------------------------------------------==
C     ==  Fourier transform the wave functions to real space.         ==
C     ==--------------------------------------------------------------==
        IF(IFFT.EQ.1) THEN
          CALL S_INVFFT(PSI)
        ELSE
          CALL SG_INVFFT(PSI)
        ENDIF
        IF(NOGRP.GT.1) THEN
          DO IB=1,NSTA
            IF(NOLIST(IB).EQ.ME) THEN
              I=ID+(IB-1)
            ENDIF
          ENDDO
        ENDIF
        COEF3=2.0D0*FOCC(I)/OMEGA
        IF(TLSD) THEN
          ISPIN1=0
          IF(I.GT.NSUP) ISPIN1=LEADX
          DO IR=1,NNRX
            R1=DREAL(PSI(IR))
            R2=DIMAG(PSI(IR))
            RHOEG(IR+ISPIN1)=RHOEG(IR+ISPIN1)+COEF3*R1*R2
          ENDDO
        ELSEIF(TLSE) THEN
          DO IR=1,NNRX
            R1=DREAL(PSI(IR))
            R2=DIMAG(PSI(IR))
            RHOEG(IR)=RHOEG(IR)+COEF3*R1*R2
          ENDDO
          IF(I.EQ.IALPHA) THEN
            DO L=1,NNRX
              R1=DREAL(PSI(IR))
              R2=DIMAG(PSI(IR))
              RHOEG(L+2*LEADX)=RHOEG(L+2*LEADX)+COEF3*R1*R2
            ENDDO
          ENDIF
          IF(I.EQ.IBETA) THEN
            DO L=1,NNRX
              R1=DREAL(PSI(IR))
              R2=DIMAG(PSI(IR))
              RHOEG(L+LEADX)=RHOEG(L+LEADX)+COEF3*R1*R2
            ENDDO
          ENDIF
        ELSE
          DO IR=1,NNRX
            R1=DREAL(PSI(IR))
            R2=DIMAG(PSI(IR))
            RHOEG(IR)=RHOEG(IR)+COEF3*R1*R2
          ENDDO
        ENDIF
      ENDDO                     !End loop over the electronic states
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      IF(NOGRP.GT.1) THEN
C       Summation of density within orbital split
        NL2=NLINK(NOLIST(NOGRP))
        IX1=NRXPL(MEPOS,1)-NRXPL(NL2,1)
        MSGLEN= 8 * NNRX
        IF(TLSD) THEN
          CALL MY_COMBINE(RHOEG(1),PSIX,MSGLEN,1,MEOGRP)
          CALL AZZERO(RHOE(1,1),NNR1)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,RHOE(IXP,1),KR1)
          ENDDO
          CALL MY_COMBINE(RHOEG(LEADX+1),PSIX,MSGLEN,1,MEOGRP)
          CALL AZZERO(RHOE(1,2),NNR1)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,RHOE(IXP,2),KR1)
          ENDDO
        ELSEIF(TLSE) THEN
          CALL MY_COMBINE(RHOEG(1),PSIX,MSGLEN,1,MEOGRP)
          CALL AZZERO(RHOE(1,1),NNR1)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,RHOE(IXP,1),KR1)
          ENDDO
          CALL MY_COMBINE(RHOEG(LEADX+1),PSIX,MSGLEN,1,MEOGRP)
          CALL AZZERO(RHOE(1,2),NNR1)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,RHOE(IXP,2),KR1)
          ENDDO
          CALL MY_COMBINE(RHOEG(2*LEADX+1),PSIX,MSGLEN,1,MEOGRP)
          CALL AZZERO(RHOE(1,3),NNR1)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,RHOE(IXP,3),KR1)
          ENDDO
        ELSE
          CALL MY_COMBINE(RHOEG,PSIX,MSGLEN,1,MEOGRP)
          CALL AZZERO(RHOE,NNR1)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,RHOE(IXP,1),KR1)
          ENDDO
        ENDIF
      ENDIF
#endif
C     CONTRIBUTION OF THE VANDERBILT PP TO RHOE
      IF(TIVAN) THEN
        CALL STOPGM('RHO1OFR','VDB not implemented')
      ENDIF
C     SYMMETRIZE DENSITY IF POINT GROUP SPECIFIED 
C     (NEED FOR SPECIAL K-POINTS).
      IF(TSYMRHO) THEN 
        CALL STOPGM('RHO1OFR','SYMRHO not implemented')
      ENDIF 
C     ALPHA+BETA DENSITY IN RHOE(*,1), BETA DENSITY IN RHOE(*,2)
      CSUMS=0.D0
      IF(TLSD) THEN
        DO IR=1,NNR1
          RHOE(IR,1) = RHOE(IR,1) + RHOE(IR,2)
        ENDDO
C     ALPHA+BETA DENSITY IN RHOE(*,1), BETA DENSITY IN RHOE(*,2) ; M STATE
C     ALPHA+BETA DENSITY IN RHOE(*,3), BETA DENSITY IN RHOE(*,4) ; T STATE
      ELSEIF(TLSE) THEN
        IF(TLSETS) THEN
          DO IR=1,NNR1
            RTO=RHOE(IR,1)
            RBE=RHOE(IR,2)
            RAL=RHOE(IR,3)
            RSP=0.5D0*(RTO-RAL-RBE)            
            RHOE(IR,2)=RSP+RBE+O3*RAL
            RHOE(IR,3)=RTO
            RHOE(IR,4)=RSP+RBE+2.D0*O3*RAL
          ENDDO
        ELSE
          DO IR=1,NNR1
            RTO=RHOE(IR,1)
            RBE=RHOE(IR,2)
            RAL=RHOE(IR,3)
            RSP=0.5D0*(RTO-RAL-RBE)
            RHOE(IR,2)=RSP+RBE
            RHOE(IR,3)=RTO
            RHOE(IR,4)=RSP+RAL+RBE
          ENDDO
        ENDIF
      ENDIF
C     HERE TO CHECK THE INTEGRAL OF THE CHARGE DENSITY
C     FIRST IN R SPACE
      RSUMR=0.D0
      DO IR=1,NNR1
        RSUMR=RSUMR+RHOE(IR,1)
      ENDDO
      RSUMR=RSUMR*OMEGA/DBLE(NR1S*NR2S*NR3S)
      CALL GLOSUM(1,RSUMR)
C     NOW IN G SPACE
      RSUMG=0.D0
      DO I=1,NSTATE
        RSUMG=RSUMG+DOTP(NGW,C0(1,I),C1(1,I))
      ENDDO
      CALL GLOSUM(1,RSUMG)
      IF(ABS(RSUMR).GT.1.D-8.AND.PARENT) THEN
        WRITE(6,'(A,1PE16.8)') 
     *    " WARNING! First order density integral (R space) ",RSUMR
      ENDIF
      IF(ABS(RSUMG).GT.1.D-8.AND.PARENT) THEN
        WRITE(6,'(A,1PE16.8)') 
     *    " WARNING! First order density integral (G space) ",RSUMG
      ENDIF
      CALL TIHALT('   RHO1OFR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RHOSOFR(C0,RHOE,PSI)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE NORMALIZED ELECTRON DENSITY RHOE IN REAL SPACE          ==
C     ==  FOR A SINGLE STATE C0                                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
C     Arguments
      COMPLEX*16 C0(NGW),PSI(MAXFFT)
      REAL*8     RHOE(NNR1)
C     Variables
      INTEGER IG,IR,ISUB
      REAL*8  R1,RSUM,DASUM,DELTA,OM
      EXTERNAL  DASUM
      PARAMETER  (DELTA=1.D-8)
C     ==--------------------------------------------------------------==
      CALL TISET('   RHOSOFR',ISUB)
      OM=1.D0/OMEGA
      CALL AZZERO(RHOE,NNR1)
      CALL ZAZZERO(PSI,MAXFFT)
!CDIR NODEP
      DO IG=1,NGW
        PSI(NZHS(IG))=C0(IG)
        PSI(INDZS(IG))=DCONJG(C0(IG))
      ENDDO
      IF(GEQ0) PSI(NZHS(1))=C0(1)
      CALL S_INVFFT(PSI)
      DO IR=1,NNR1
        R1=DREAL(PSI(IR))
        RHOE(IR)=RHOE(IR)+R1*R1
      ENDDO
      CALL DSCAL(NNR1,OM,RHOE,1)
      RSUM=DASUM(NNR1,RHOE,1)*OMEGA/DBLE(NR1S*NR2S*NR3S)
      CALL GLOSUM(1,RSUM)
      IF(PARENT.AND.ABS(RSUM-1.D0).GT.DELTA) THEN
        WRITE(6,'(A,T45,F20.12)') 
     *             'ORBITAL DENSITY IN REAL SPACE:',RSUM
        CALL STOPGM('RHOSOFR','ORBITAL DENSITY SUM IS NOT 1')
      ENDIF
      CALL TIHALT('   RHOSOFR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RHOABOFR(NSTATE,CA,CB,RHOE,PSI)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE NORMALIZED ELECTRON DENSITY RHOE IN REAL SPACE          ==
C     ==  FOR A PAIR OF WAVEFUNCTIONS CA AND CB                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 CA(NGW,*),CB(NGW,*),PSI(MAXFFT)
      REAL*8     RHOE(NNR1)
C     Variables
      INTEGER IG,IR,ISUB,IS
      REAL*8  R1,R2,OM
C     ==--------------------------------------------------------------==
      CALL TISET('  RHOABOFR',ISUB)
      OM=1.D0/OMEGA
      DO IS=1,NSTATE
        CALL ZAZZERO(PSI,MAXFFT)
!CDIR NODEP
        DO IG=1,NGW
          PSI(NZHS(IG))=CA(IG,IS)+UIMAG*CB(IG,IS)
          PSI(INDZS(IG))=DCONJG(CA(IG,IS))+
     *                 UIMAG*DCONJG(CB(IG,IS))
        ENDDO
        IF(GEQ0) PSI(NZHS(1))=CA(1,IS)+UIMAG*CB(1,IS)
        CALL S_INVFFT(PSI)
        DO IR=1,NNR1
          R1=DREAL(PSI(IR))
          R2=DIMAG(PSI(IR))
          RHOE(IR)=RHOE(IR)+R1*R2*OM
        ENDDO
      ENDDO
      CALL TIHALT('  RHOABOFR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
