C     ==================================================================
      SUBROUTINE RHO1PRI(C0,C1,TAU0,NSTATE,NRES,LABEL)
C     ==--------------------------------------------------------------==
C     ==  CALCULATE THE LINEAR RESPONSE DENSITY AND DUMP              ==
C     ==  ALL DATA TO FILE DENSITY                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'cppt.inc'
C     Arguments
      INTEGER    NSTATE,NRES
      COMPLEX*16 C0(NGW,NSTATE),C1(NGW,NSTATE,*)
      REAL*8     TAU0(*)
      CHARACTER  LABEL*1
C     Variables
      DIMENSION F(*)
      CHARACTER  FILEN*15,CIPNUM*1
      POINTER (IP_RHOE,RHOE),(IP_PSI,PSI),(IP_RHOG,RHOG)
      INTEGER IL_RHOE,IL_PSI,IR,IS,IG
      REAL*8 RHOE(NNR1,*)
      COMPLEX*16 PSI(*),RHOG(*)
C     ==--------------------------------------------------------------==
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL MEMORY(IP_RHOG,2*NHG,'RHOG')
C
      DO IS=1,NRES
        CALL RHO1OFR(C0,C1(1,1,IS),F,RHOE,PSI,NSTATE)
C
        IF (TLSD) THEN
!$OMP parallel do private(IR)
          DO IR=1,NNR1
            PSI(IR)=DCMPLX(RHOE(IR,1),0.D0)
          ENDDO
          CALL FWFFT(PSI)
!$OMP parallel do private(IG)
          DO IG=1,NHG
            RHOG(IG) = PSI(NZH(IG))
          ENDDO
          WRITE(CIPNUM,'(I1)') IS
          FILEN=LABEL//'LRDENS'//CIPNUM//'_ALPHA'
          CALL DENSTO(RHOG,TAU0,FILEN)
!$OMP parallel do private(IR)
          DO IR=1,NNR1
            PSI(IR)=DCMPLX(RHOE(IR,2),0.D0)
          ENDDO
          CALL FWFFT(PSI)
!$OMP parallel do private(IG)
          DO IG=1,NHG
            RHOG(IG) = PSI(NZH(IG))
          ENDDO
          WRITE(CIPNUM,'(I1)') IS
          FILEN=LABEL//'LRDENS'//CIPNUM//'_BETA'
          CALL DENSTO(RHOG,TAU0,FILEN)
        ELSE
!$OMP parallel do private(IR)
          DO IR=1,NNR1
            PSI(IR)=DCMPLX(RHOE(IR,1),0.D0)
          ENDDO
          CALL FWFFT(PSI)
!$OMP parallel do private(IG)
          DO IG=1,NHG
            RHOG(IG) = PSI(NZH(IG))
          ENDDO
          WRITE(CIPNUM,'(I1)') IS
          FILEN=LABEL//'LRDENS'//CIPNUM
          CALL DENSTO(RHOG,TAU0,FILEN)
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
