C     ==================================================================
      SUBROUTINE RHODIIS(NP,RNEW,RIN,ROUT,RITER,DRITER,
     &                   AMIX,DMAT,DM,VB,NRDIISMAX,NRDIIS,ILSD,THL)
C     ==--------------------------------------------------------------==
C     ==  CALCULATE NEW DENSITY USING DIIS SCHEME                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT  NONE
C     Arguments
      INTEGER   NRDIISMAX, NP,NRDIIS,ILSD
      REAL*8    AMIX,THL,
     &          RNEW(NP),RIN(NP),ROUT(NP),
     &          RITER(NP,NRDIIS),DRITER(NP,NRDIIS),
     &          DMAT(NRDIISMAX,NRDIISMAX),
     &          DM(NRDIISMAX+1,NRDIISMAX+1),VB(NRDIISMAX+1)
      REAL*8    DDOT               
      EXTERNAL  DDOT 
C     Local variables              
      INTEGER   NITER,NSIZE,I,J, NCALL(2)
      REAL*8    FAC
      DATA      NCALL /0,0/
      SAVE      NCALL 
C     ==--------------------------------------------------------------==
C     We can reinitialize (for MD).
      IF(NRDIIS.EQ.0.OR.NP.EQ.0) THEN
        NCALL(ILSD) = 0
        RETURN
      ENDIF
      NCALL(ILSD)=NCALL(ILSD)+1
      IF(NCALL(ILSD).LT.NRDIIS) THEN
        NSIZE=NCALL(ILSD)
      ELSE
        NSIZE=NRDIIS
      ENDIF
      NITER=MOD(NCALL(ILSD)-1,NRDIIS)+1
C     Update buffer
      CALL DCOPY(NP, RIN(1),1, RITER(1,NITER),1)
      CALL DCOPY(NP,ROUT(1),1,DRITER(1,NITER),1)
      CALL DAXPY(NP,-1.D0,RIN(1),1,DRITER(1,NITER),1)
C     Update DIIS Matrix
      DO I=1,NSIZE
        DMAT(I,NITER)=DDOT(NP,DRITER(1,I),1,DRITER(1,NITER),1)
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(NSIZE,DMAT(1,NITER))
#endif
      DO I=1,NSIZE
        IF(I.NE.NITER) DMAT(NITER,I)=DMAT(I,NITER)
      ENDDO
C     Setup linear system
      CALL AZZERO(DM,(NRDIISMAX+1)*(NRDIISMAX+1))
      CALL AZZERO(VB,NRDIISMAX+1)
      DO I=1,NSIZE
        DO J=1,NSIZE
          DM(I,J)=DMAT(I,J)
        ENDDO
        DM(I,NSIZE+1)=-1.D0
        DM(NSIZE+1,I)=-1.D0
      ENDDO
      DM(NSIZE+1,NSIZE+1)=0.D0
      VB(NSIZE+1)=-1.D0
C     Solve linear system
      CALL SOLVE(DM,NRDIISMAX+1,NSIZE+1,VB)
C     Estimate new vectors
      CALL AZZERO(RNEW,NP)
      FAC=1.0D0
      IF(NSIZE.EQ.1) FAC=AMIX
      DO I=1,NSIZE
        CALL DAXPY(NP,    VB(I), RITER(1,I),1,RNEW(1),1)
        CALL DAXPY(NP,FAC*VB(I),DRITER(1,I),1,RNEW(1),1)
      ENDDO
      THL=DMAT(NITER,NITER)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CHANGE_NRDIIS(DRHOMAX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'andr.inc'
      REAL*8 DRHOMAX
      INTEGER IFIRST,I
      DATA IFIRST /0/
      SAVE IFIRST
C     ==--------------------------------------------------------------==
      IF (NTABNRDIIS.LE.1) RETURN
      IF (IFIRST.EQ.0) THEN
        INRDIIS=1
        IFIRST=1
      ENDIF
      NRDIIS=TABNRDIIS(INRDIIS)
      DO I=INRDIIS,NTABNRDIIS
        IF(DRHOMAX.LT.DENSNRDIIS(I)) THEN
          NRDIIS=TABNRDIIS(I)
          INRDIIS=I
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
