C     ==================================================================
      SUBROUTINE RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPOINT)
C     ==--------------------------------------------------------------==
C     ==  CALCULATE THE ELECTRONIC DENSITY IN G-SPACE AND DUMP        ==
C     ==  ALL DATA TO FILE DENSITY                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'prden.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'bsym.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'store.inc'
      INCLUDE 'cdft.inc'
      INCLUDE 'mw.inc'

      CHARACTER*14 CFLBOD,CIPNUM
C     Arguments
      INTEGER    LSCR,NSTATE,NKPOINT,IKIND
      COMPLEX*16 C0(NGWK,NSTATE,NKPOINT),PSI(NNR1)
      REAL*8     TAU0(*),RHOE(NNR1,NLSD),SCR(LSCR),ETA
C     Variables
      CHARACTER  FILEN*30,TAG*30
      LOGICAL    LDOWRT,TLSDBK
      INTEGER    ISUB,I,LRHOPRI,IG,I1,I2,N1,N2,II,IK,IS,ISPST,NLSDBK,
     *           SPACE 
      COMPLEX*16 VTEMP(NHG),EIVPS(NHG),EIROP(NHG),QPHI(*)
      POINTER (IP_VTEMP,VTEMP),(IP_EIROP,EIROP),(IP_EIVPS,EIVPS),
     *        (IP_QPHI,QPHI)
      REAL*8     SVSUMG,SVSUMR,EKIN_BAK
C
      COMPLEX*16 SC0_SCR(NGW,*)
      POINTER (IP_SC0_SCR,SC0_SCR)
      REAL*8  XMAT_1(NSTATE,*),XMAT_2(NSTATE,*),EIGV_SCR(*)
      POINTER (IP_XMAT_1,XMAT_1),(IP_XMAT_2,XMAT_2),
     &        (IP_EIGV_SCR,EIGV_SCR)
      INTEGER ICON
      DATA    ICON /0/
      SAVE    ICON,IP_XMAT_1,IP_XMAT_2,IP_EIGV_SCR,IP_SC0_SCR
CEHR[
      INTEGER    ICALL
      DATA       ICALL/0/
      SAVE       ICALL
CEHR]
C     ==--------------------------------------------------------------==
C     SCR test
      CALL TISET('    RHOPRI',ISUB)
      CALL GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
      CALL TEST_SCR('RHOPRI',TAG,LSCR,LRHOPRI)
C     ==--------------------------------------------------------------==
      CALL PHFAC(TAU0)
      DO IKIND=1,NKPOINT
        CALL RNLSM(C0(1,1,IKIND),NSTATE,PSI,SCR,LSCR,1,IKIND,.FALSE.)
      ENDDO
C     calling RHOOFR will overwrite EKIN so we need to make
C     a backup. the rest of COMMON /ENER/ is untouched. AK+NN.
      EKIN_BAK=EKIN
      IF(TKPNT) THEN 
        CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,NSTATE)
      ELSE
        IF(NONORT)THEN
          IF(ICON.EQ.0)THEN
            CALL MEMORY(IP_SC0_SCR,2*NGW*NSTATE,'SC0_SCR')
            CALL MEMORY(IP_EIGV_SCR,NSTATE,'EIGV_SCR')
            CALL MEMORY(IP_XMAT_1,NSTATE*NSTATE,'XMAT_1') 
            CALL MEMORY(IP_XMAT_2,NSTATE*NSTATE,'XMAT_2') 
            CALL UNITMX(XMAT_1,NSTATE)
          ENDIF
          ICON=1
          CALL NORHOE(C0,SC0_SCR,EIGV_SCR,RHOE,PSI,XMAT_1,XMAT_2,
     &                 SCR,LSCR,NSTATE)
        ELSE
          CALL RHOOFR  (C0,RHOE,PSI,SCR,LSCR,NSTATE)
        ENDIF
      ENDIF
C     
      EKIN=EKIN_BAK
      CALL GET_ADDR(IP_VTEMP,SCR(1))
!$OMP parallel do private(I)
      DO I=1,NNR1
        PSI(I)=DCMPLX(RHOE(I,1),0.D0)
      ENDDO
!$OMP end parallel do
      CALL FWFFT(PSI)
!$OMP parallel do private(IG)
      DO IG=1,NHG
        VTEMP(IG) = PSI(NZH(IG))
      ENDDO
!$OMP end parallel do
      IF(TPATH) THEN
        IF(IPCURR.EQ.0) THEN
          FILEN='DENSITY'
        ELSE
          CFLBOD='DENSITY_'
          WRITE(CIPNUM,'(I4)') IPCURR
          CALL XSTRING(CFLBOD,N1,N2)
          CALL XSTRING(CIPNUM,I1,I2)
          FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
        ENDIF
      ELSEIF (TDUMMYATOM_REF) THEN
        FILEN='rhoofr_ref.dat'
CEHR[
      ELSEIF (TMDEH) THEN
         CFLBOD='DENSITY_'
         WRITE(CIPNUM,'(I4)') ICALL
         CALL XSTRING(CFLBOD,N1,N2)
         CALL XSTRING(CIPNUM,I1,I2)
         FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
         ICALL=ICALL+1
CEHR]
      ELSEIF (TMW) THEN
         CFLBOD='DENSITY_'
         CALL MW_FILENAME(CFLBOD,FILEN,WALKER_ID)
      ELSE
        IF(THDA)THEN
          IF(HDAFIRST)THEN
            FILEN='DENSITY_1'
          ELSE
            FILEN='DENSITY_2'
          ENDIF
        ELSE
          FILEN='DENSITY'
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C CB: Filenames for the BS states
      if(BSYMM) then
        SPACE=index(FILEN,' ')
        if(BSCLCS.eq.1) then
          if(SPACE.GT.10) then
            FILEN='DENSITY.bs'
          else      
            FILEN(SPACE:SPACE+2)='.bs'
          endif  
        else
          if(SPACE.GT.10) then
            FILEN='DENSITY.hs'
          else       
            FILEN(SPACE:SPACE+2)='.hs'
          endif  
        endif  
      endif
C     ==--------------------------------------------------------------==
      CALL XSTRING(FILEN,I1,I2)
      IF(NRHOOUT.GT.0) THEN
        WRITE(CIPNUM,'(I14)') NFI
        CALL XSTRING(CIPNUM,N1,N2)
        FILEN=FILEN(I1:I2) // '.' // CIPNUM(N1:N2)
        CALL XSTRING(FILEN,I1,I2)
      ENDIF
      CALL DENSTO(VTEMP,TAU0,FILEN(I1:I2))
C
      IF(TLSD) THEN
!$OMP parallel do private(I,ETA)
        DO I=1,NNR1
          ETA=RHOE(I,1)-2.D0*RHOE(I,2)
          PSI(I)=DCMPLX(ETA,0.D0)
        ENDDO
!$OMP end parallel do
        CALL FWFFT(PSI)
!$OMP parallel do private(IG)
        DO IG=1,NHG
          VTEMP(IG) = PSI(NZH(IG))
        ENDDO
!$OMP end parallel do
        IF(TPATH) THEN
          IF(IPCURR.EQ.0) THEN
            FILEN='SPINDEN'
          ELSE
            CFLBOD='SPINDEN_'
            WRITE(CIPNUM,'(I4)') IPCURR
            CALL XSTRING(CFLBOD,N1,N2)
            CALL XSTRING(CIPNUM,I1,I2)
            FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
          ENDIF
CEHR[
        ELSEIF (TMDEH) THEN
          CFLBOD='SPINDEN_'
          WRITE(CIPNUM,'(I4)') ICALL
          CALL XSTRING(CFLBOD,N1,N2)
          CALL XSTRING(CIPNUM,I1,I2)
          FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
          ICALL=ICALL+1
CEHR]
        ELSEIF (TMW) THEN
          CFLBOD='SPINDEN_'
          CALL MW_FILENAME(CFLBOD,FILEN,WALKER_ID)
        ELSE
          IF(THDA)THEN
            IF(HDAFIRST)THEN
              FILEN='SPINDEN_1'
            ELSE
              FILEN='SPINDEN_2'
            ENDIF
          ELSE
            FILEN='SPINDEN'
          ENDIF
        ENDIF
C     ==--------------------------------------------------------------==
C CB: Filenames for the BS states
        if(BSYMM) then
          SPACE=index(FILEN,' ')
          if(BSCLCS.eq.1) then
            if(SPACE.GT.10) then
              FILEN='SPINDEN.bs'
            else
              FILEN(SPACE:SPACE+2)='.bs'
            endif  
          else
            if(SPACE.GT.10) then
             FILEN='SPINDEN.hs'
            else       
              FILEN(SPACE:SPACE+2)='.hs'
            endif  
          endif  
        endif
C     ==--------------------------------------------------------------==
        CALL XSTRING(FILEN,I1,I2)
        IF(NRHOOUT.GT.0) THEN
          CALL XSTRING(CIPNUM,N1,N2)
          WRITE(CIPNUM,'(I14)') NFI
          FILEN=FILEN(I1:I2) // '.' // CIPNUM(N1:N2)
          CALL XSTRING(FILEN,I1,I2)
        ENDIF
        CALL DENSTO(VTEMP,TAU0,FILEN(I1:I2))
      ENDIF
C
C     Save CSUMG/CSUMR from all electron calc.
      SVSUMG=CSUMG
      SVSUMR=CSUMR
      IF(NUMPR.GE.1) THEN
        DO IS=1,NLSD
          DO II=1,NUMPR
            ISPST=ABS(MWFN(II))
            IF (IS.EQ.2) ISPST=ISPST+NSUP
            CALL ZAZZERO(VTEMP,NHG)
C..Store density associated with wavefunction ISPST
            DO IK=1,NKPOINT
              IF(MWFN(II).GT.0.AND.ISPST.LE.NSTATE) THEN
                NLSDBK=NLSD
                TLSDBK=TLSD
                NLSD=1
                TLSD=.FALSE.
                IF(TKPNT) THEN 
                  CALL RHOOFR_C(C0(1,ISPST,IK),RHOE,PSI,SCR,LSCR,1)
                ELSE
                  CALL RHOOFR  (C0(1,ISPST,1),RHOE,PSI,SCR,LSCR,1)
                ENDIF
                NLSD=NLSDBK
                TLSD=TLSDBK
!$OMP parallel do private(I)
                DO I=1,NNR1
                  PSI(I)=DCMPLX(RHOE(I,1),0.D0)
                ENDDO
!$OMP end parallel do
                CALL FWFFT(PSI)
!$OMP parallel do private(IG)
                DO IG=1,NHG
                  VTEMP(IG) = PSI(NZH(IG))
                ENDDO
!$OMP end parallel do
              ELSEIF(ISPST.LE.NSTATE) THEN
C..Store directly the wavefunction
                IF(TKPNT) THEN 
                  WRITE(6,*) 
     &  '!!!! WRITING OUT COMPLEX WAVFUNCTIONS (I.E. KPOINTS) NOT'
     &  ,'IMPLEMENTED'
                  GOTO 100 
                ELSE
!$OMP parallel do private(IG)
                  DO IG=1,NGWK
                    VTEMP(IG) = C0(IG,ABS(ISPST),1)
                  ENDDO
!$OMP end parallel do
                ENDIF
              ENDIF
              IF ( MWFN(II) .LT. 0 ) THEN
                IF (TLSD) THEN
                  IF (IS.EQ.1) THEN
                    CFLBOD='WAVEFUNCTION.A'
                    LDOWRT=(ABS(MWFN(II)).LE.NSUP)
                  ELSE
                    CFLBOD='WAVEFUNCTION.B'
                    LDOWRT=(ABS(MWFN(II)).LE.NSDOWN)
                  ENDIF
                ELSE
                  CFLBOD='WAVEFUNCTION.'
                  LDOWRT=(ISPST.LE.NSTATE)
                ENDIF
              ELSE
                IF (TLSD) THEN
                  IF (IS.EQ.1) THEN
                    CFLBOD='DENSITY.A'
                    LDOWRT=(ABS(MWFN(II)).LE.NSUP)
                  ELSE
                    CFLBOD='DENSITY.B'
                    LDOWRT=(ABS(MWFN(II)).LE.NSDOWN)
                  ENDIF
                ELSE
                  CFLBOD='DENSITY.'
                  LDOWRT=(ISPST.LE.NSTATE)
                ENDIF
              ENDIF
              IF (LDOWRT) THEN
                WRITE(CIPNUM,'(I4)') ABS(MWFN(II))
                IF(TMW) THEN
                  CALL MW_FILENAME(CFLBOD,FILEN,WALKER_ID)
                  CFLBOD=FILEN
                ENDIF
                CALL XSTRING(CFLBOD,N1,N2)
                CALL XSTRING(CIPNUM,I1,I2)
                FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
                IF(TKPNT) THEN 
                  N1=LEN(FILEN)
                  IF(N1.GT.14) N1=14
                  CFLBOD=FILEN(1:N1)
                  WRITE(CIPNUM,'(I4)') IK
                  CALL XSTRING(CFLBOD,N1,N2)
                  CALL XSTRING(CIPNUM,I1,I2)
                  FILEN=CFLBOD(N1:N2)//'.KP.'//CIPNUM(I1:I2)
                ENDIF
C     ==--------------------------------------------------------------==
C CB: Filenames for the BS states
                if(BSYMM) then
                  SPACE=index(FILEN,' ')
                  if(BSCLCS.eq.1) then
                    if(SPACE.GT.10) then
                      FILEN='DENSITY.bs'
                    else       
                      FILEN(SPACE:SPACE+2)='.bs'
                    endif  
                  else
                    if(SPACE.GT.10) then
                      FILEN='DENSITY.hs'
                    else       
                      FILEN(SPACE:SPACE+2)='.hs'
                    endif  
                  endif  
                endif
C     ==--------------------------------------------------------------==
                CALL XSTRING(FILEN,I1,I2)
                IF(NRHOOUT.GT.0) THEN
                  WRITE(CIPNUM,'(I14)') NFI
                  CALL XSTRING(CIPNUM,N1,N2)
                  FILEN=FILEN(I1:I2) // '.' // CIPNUM(N1:N2)
                  CALL XSTRING(FILEN,I1,I2)
                ENDIF
                CALL DENSTO(VTEMP,TAU0,FILEN(I1:I2))
              ENDIF ! LDOWRT
            ENDDO   ! IK 
          ENDDO     ! II
        ENDDO       ! IS
      ENDIF
C     Restore CSUMG/CSUMR from all electron calc.
      CSUMG=SVSUMG
      CSUMR=SVSUMR
 100  CONTINUE 
C
C..Electrostatic potential
      IF(TEPOT) THEN
        CALL GET_ADDR(IP_EIVPS,SCR(2*NHG+1))
        CALL GET_ADDR(IP_EIROP,SCR(4*NHG+1))
        CALL GET_ADDR(IP_QPHI,SCR(6*NHG+1))
        CALL EICALC(EIVPS,EIROP)
!$OMP parallel do private(I)
        DO I=1,NNR1
          PSI(I)=DCMPLX(RHOE(I,1),0.D0)
        ENDDO
!$OMP end parallel do
        CALL FWFFT(PSI)
!$OMP parallel do private(IG)
        DO IG=1,NHG
          VTEMP(IG) = PSI(NZH(IG))
        ENDDO
!$OMP end parallel do
        CALL ELSTPO(VTEMP,EIROP,EIVPS,PSI,QPHI,TAU0)
        IF(TPATH) THEN
          IF(IPCURR.EQ.0) THEN
            FILEN='ELPOT'
          ELSE
            CFLBOD='ELPOT_'
            WRITE(CIPNUM,'(I4)') IPCURR
            CALL XSTRING(CFLBOD,N1,N2)
            CALL XSTRING(CIPNUM,I1,I2)
            FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
          ENDIF
        ELSEIF (TMW) THEN
          CFLBOD='ELPOT_'
          CALL MW_FILENAME(CFLBOD,FILEN,WALKER_ID)
        ELSE
          FILEN='ELPOT'
        ENDIF
C     ==--------------------------------------------------------------==
C CB: Filenames for the BS states
        if(BSYMM) then
          SPACE=index(FILEN,' ')
          if(BSCLCS.eq.1) then
            if(SPACE.GT.10) then
              FILEN='ELPOT.bs'
            else       
              FILEN(SPACE:SPACE+2)='.bs'
            endif  
          else
            if(SPACE.GT.10) then
              FILEN='ELPOT.hs'
            else       
              FILEN(SPACE:SPACE+2)='.hs'
            endif  
          endif  
        endif
C     ==--------------------------------------------------------------==
        CALL XSTRING(FILEN,I1,I2)
        IF(NRHOOUT.GT.0) THEN
          WRITE(CIPNUM,'(I14)') NFI
          CALL XSTRING(CIPNUM,N1,N2)
          FILEN=FILEN(I1:I2) // '.' // CIPNUM(N1:N2)
          CALL XSTRING(FILEN,I1,I2)
        ENDIF
        CALL DENSTO(PSI,TAU0,FILEN(I1:I2))
      ENDIF
C..ELF
      IF(TELF) CALL ELF(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPOINT)
C..ELF for the unrestricted case
      IF(TELF.AND.TLSD)
     $     CALL LSD_ELF(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPOINT)
      CALL TIHALT('    RHOPRI',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG TEPOT
      INCLUDE 'prden.inc'       !TELF
C     Arguments
      INTEGER   LRHOPRI,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LRNLSM,LRHOOFR,LELF,LNORHO,
     &    IL_QPHI,IL_GAM,IL_AUXC,IL_SMAT,IL_DDIA
      DATA LELF,LRHOOFR,LRNLSM,LNORHO,IL_QPHI /5*0/ 
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
      CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
      IF(TEPOT) THEN
C       VTEMP(2*NHG),EIVPS(2*NHG),EIROP(2*NHG)
        LRHOPRI=6*NHG
      ELSE
C       VTEMP(2*NHG)
        LRHOPRI=2*NHG
      ENDIF
C     QPHI
      CALL GIVE_QPHI(IL_QPHI)
      LRHOPRI=LRHOPRI+IL_QPHI
      IF(NONORT) CALL GIVE_SCR_NOFORCE(LNORHO,IL_GAM,IL_AUXC,
     &    IL_SMAT,IL_DDIA,TAG,NSTATE,.FALSE.)
      IF(TELF) CALL GIVE_SCR_ELF(LELF,TAG,NSTATE)
      IF(TELF.AND.TLSD) CALL GIVE_SCR_LSD_ELF(LELF,TAG,NSTATE)
      LRHOPRI=MAX(LRNLSM,LRHOOFR,LRHOPRI,LELF,LNORHO)
      TAG='MAX(LRNLSM,LRHOOFR,LRHOPRI...)'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RHOPRI_EH(C0,TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPOINT)
C     ==--------------------------------------------------------------==
C     ==  CALCULATE THE ELECTRONIC DENSITY IN G-SPACE AND DUMP        ==
C     ==  ALL DATA TO FILE DENSITY                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'prden.inc'
      INCLUDE 'pimd.inc'
      CHARACTER*12 CFLBOD,CIPNUM
C     Arguments
      INTEGER    LSCR,NSTATE,NKPOINT,IKIND
      COMPLEX*16 C0(NGWK,NSTATE,NKPOINT),PSI(NNR1)
      REAL*8     TAU0(*),RHOE(NNR1,NLSD),SCR(LSCR),ETA
C     Variables
      CHARACTER  FILEN*15,TAG*30
      LOGICAL    LDOWRT,TLSDBK
      INTEGER    ISUB,I,LRHOPRI,IG,I1,I2,N1,N2,II,IK,IS,ISPST,NLSDBK
      COMPLEX*16 VTEMP(NHG),EIVPS(NHG),EIROP(NHG),QPHI(*)
      POINTER (IP_VTEMP,VTEMP),(IP_EIROP,EIROP),(IP_EIVPS,EIVPS),
     *        (IP_QPHI,QPHI)
      INTEGER    icall
      DATA       icall/0/
      SAVE       icall
C     ==--------------------------------------------------------------==
C     SCR test
      CALL TISET('    RHOPRI_EH',ISUB)
      CALL GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
      CALL TEST_SCR('RHOPRI_EH',TAG,LSCR,LRHOPRI)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_VTEMP,SCR(1))
      DO I=1,NNR1
        PSI(I)=DCMPLX(RHOE(I,1),0.D0)
      ENDDO
      CALL FWFFT(PSI)
      DO IG=1,NHG
        VTEMP(IG) = PSI(NZH(IG))
      ENDDO
C
C      IF (TMDEH) THE
       CFLBOD='DDENSITY_'
       WRITE(CIPNUM,'(I4)') icall
       CALL XSTRING(CFLBOD,N1,N2)
       CALL XSTRING(CIPNUM,I1,I2)
       FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
       CALL DENSTO(VTEMP,TAU0,FILEN)
C      ENDIF
      icall=icall+1
      CALL TIHALT('    RHOPRI_EH',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CURRPRI(TAU0,RHOE,PSI,SCR,LSCR,NSTATE,NKPOINT,ICOOR)
C     ==--------------------------------------------------------------==
C     ==  CALCULATE THE ELECTRONIC DENSITY IN G-SPACE AND DUMP        ==
C     ==  ALL DATA TO FILE DENSITY                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'prden.inc'
      INCLUDE 'pimd.inc'
      CHARACTER*12 CFLBOD,CIPNUM
C     Arguments
      INTEGER    LSCR,NSTATE,NKPOINT,IKIND,ICOOR
      COMPLEX*16 PSI(NNR1)
      REAL*8     TAU0(*),RHOE(NNR1,*),SCR(LSCR),ETA
C     Variables
      CHARACTER  FILEN*15,TAG*30
      LOGICAL    LDOWRT,TLSDBK
      INTEGER    ISUB,I,LRHOPRI,IG,I1,I2,N1,N2,II,IK,IS,ISPST,NLSDBK
      COMPLEX*16 VTEMP(NHG),EIVPS(NHG),EIROP(NHG),QPHI(*)
      POINTER (IP_VTEMP,VTEMP),(IP_EIROP,EIROP),(IP_EIVPS,EIVPS),
     *        (IP_QPHI,QPHI)
      INTEGER    icall
      DATA       icall/0/
      SAVE       icall
C     ==--------------------------------------------------------------==
C     SCR test
      CALL TISET('    RHOPRI_EH',ISUB)
      CALL GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
      CALL TEST_SCR('RHOPRI_EH',TAG,LSCR,LRHOPRI)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_VTEMP,SCR(1))
      DO I=1,NNR1
        PSI(I)=DCMPLX(RHOE(I,ICOOR),0.D0)
      ENDDO
      CALL FWFFT(PSI)
      DO IG=1,NHG
        VTEMP(IG) = PSI(NZH(IG))
      ENDDO
C
      IF (ICOOR.EQ.0) THEN
       CFLBOD='CURRENT_'
      ELSEIF(ICOOR.EQ.1) THEN
       CFLBOD='CURRENTX_'
      ELSEIF(ICOOR.EQ.2) THEN
       CFLBOD='CURRENTY_'
      ELSEIF(ICOOR.EQ.3) THEN
       CFLBOD='CURRENTZ_'
      ELSEIF(ICOOR.EQ.4) THEN
       CFLBOD='CURRENTD_'
      ELSEIF(ICOOR.EQ.5) THEN
       CFLBOD='CURRENTT_'
      ENDIF
      WRITE(CIPNUM,'(I4)') icall
      CALL XSTRING(CFLBOD,N1,N2)
      CALL XSTRING(CIPNUM,I1,I2)
      FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
      CALL DENSTO(VTEMP,TAU0,FILEN)
      if (icoor.eq.0) icall=icall+1
      CALL TIHALT('    RHOPRI_EH',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FIELD_PR(TAU0,RHOE,PSI,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     ==  CALCULATE THE ELECTRONIC DENSITY IN G-SPACE AND DUMP        ==
C     ==  ALL DATA TO FILE DENSITY                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'prden.inc'
      INCLUDE 'pimd.inc'
      CHARACTER*12 CFLBOD,CIPNUM
C     Arguments
      INTEGER    LSCR,NSTATE
      COMPLEX*16 PSI(NNR1)
      REAL*8     TAU0(*),RHOE(NNR1),SCR(LSCR)
C     Variables
      CHARACTER  FILEN*15,TAG*30
      LOGICAL    LDOWRT,TLSDBK
      INTEGER    ISUB,I,LRHOPRI,IG,I1,I2,N1,N2,II,IK,IS,ISPST,NLSDBK
      COMPLEX*16 VTEMP(NHG),EIVPS(NHG),EIROP(NHG),QPHI(*)
      POINTER (IP_VTEMP,VTEMP),(IP_EIROP,EIROP),(IP_EIVPS,EIVPS),
     *        (IP_QPHI,QPHI)
      INTEGER    icall
      DATA       icall/0/
      SAVE       icall
C     ==--------------------------------------------------------------==
C     SCR test
      CALL TISET('    RHOPRI_EH',ISUB)
      CALL GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
      CALL TEST_SCR('RHOPRI_EH',TAG,LSCR,LRHOPRI)
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_VTEMP,SCR(1))
      DO I=1,NNR1
        PSI(I)=DCMPLX(RHOE(I),0.D0)
      ENDDO
      CALL FWFFT(PSI)
      DO IG=1,NHG
        VTEMP(IG) = PSI(NZH(IG))
      ENDDO
C
C      IF (TMDEH) THE
       CFLBOD='FIELD_'
       WRITE(CIPNUM,'(I4)') icall
       CALL XSTRING(CFLBOD,N1,N2)
       CALL XSTRING(CIPNUM,I1,I2)
       FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
       CALL DENSTO(VTEMP,TAU0,FILEN)
C      ENDIF
      icall=icall+1
      CALL TIHALT('    RHOPRI_EH',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


