C     ==================================================================
      SUBROUTINE RINFORCE
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NCPUS
      INCLUDE 'atom.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'aavan.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'eam.inc'
C     Variables
      DIMENSION TWNS(*),VOO(*),TWNL(*),QRAD(*),RHOC(NHG,*),YLMB(*)
      DIMENSION DRHOC(*)
      REAL*8    RS1(*),RS2(*),RS3(*),SCR(*)
      POINTER   (IP_RS1,RS1),(IP_RS2,RS2),(IP_RS3,RS3),(IP_SCR,SCR)
      INTEGER   IS,ISUB,MRSCR,LMAXV,LVAL,IV,JV,IM,LP,ISTEP,NYLMB,LSCR
      REAL*8    DUMMY,PF,PUB,AA
      CHARACTER TAG*30
      include 'mm_ion_dens.inc'
      include 'mm_input.inc'
C     ==--------------------------------------------------------------==
C     ==  ALLOCATION OF MEMORY                                        ==
C     ==--------------------------------------------------------------==
      CALL TISET('  RINFORCE',ISUB)
      CALL SETSPLINE
      CALL MEMORY(IP_VPS,NSX*NHG,'VPS')
      CALL MEMORY(IP_RHOPS,NSX*NHG,'RHOPS')
      if(qmmm) CALL MEMORY(IP_mm_RHOPS,NSX*NHG,'mm_RHOPS')
      IF(TIVAN) THEN
        CALL MEMORY(IP_INDV,NSX*NHX,'INDV')
        NQDIM    = NHGL
        IF(QSPLINE) NQDIM=2*NSPLPO
        CALL MEMORY(IP_QRAD,NQDIM*NBRX*NBRX*LX*NSX,'QRAD')
      ELSE
        CALL GET_ADDR(IP_INDV,DUMMY)
        CALL GET_ADDR(IP_QRAD,DUMMY)
      ENDIF
      IF(TINLC) THEN
        CALL MEMORY(IP_RHOC,NSX*NHG,'RHOC')
        CALL AZZERO(RHOC,NSX*NHG)
        IF(TPRES.OR.TPRCP) THEN
          CALL MEMORY(IP_DRHOC,6*NSX*NHG,'DRHOC')
          CALL AZZERO(DRHOC,6*NSX*NHG)
        ENDIF
      ENDIF
C     SCRATCH SPACE ALLOCATION
      CALL NUMCPUS(NCPUS)
      MRSCR   = MAX(8*MMAXX,NCPUS*MMAXX,NSPLPO,NHX*NHX)
      CALL MEMORY(IP_RS1,MRSCR,'RS1')
      CALL MEMORY(IP_RS2,MRSCR,'RS2')
      CALL MEMORY(IP_RS3,MRSCR,'RS3')
C     SPACE ALLOCATION FOR SPLINE
      CALL MEMORY(IP_VOO,2*NSPLPO*NSX,'VOO')
      CALL MEMORY(IP_TWNS,2*NSPLPO*NSX*NHXS,'TWNS')
      CALL AZZERO(VOO,2*NSPLPO*NSX)
      CALL AZZERO(TWNS,2*NSPLPO*NSX*NHXS)
C     INITIALIZATION FOR VANDERBILT PSEUDOPOTENTIALS
      IF(TIVAN) THEN
        LMAXV=0
        DO IS=1,NSP
          IF(TVAN(IS)) THEN
            LVAL=NVALES(IS)
            IF(LVAL.GT.3) CALL STOPGM('RINFORCE',' L>3, L=')
            IF(LVAL.GT.LMAXV) LMAXV=LVAL
          ENDIF
        ENDDO
C       INITIALIZE CLEBSCH-GORDON COEFFICIENTS
        CALL AAINIT(LMAXV)
        CALL MEMORY(IP_NELEV,NSX,'NELEV')
        CALL MEMORY(IP_QQ,NHXS*NHXS*NSX,'QQ')
        CALL MEMORY(IP_DVAN,NHXS*NHXS*NSX,'DVAN')
        CALL MEMORY(IP_DEEQ,NHXS*NHXS*NAT*NLSD,'DEEQ')
      ENDIF
C     ==--------------------------------------------------------------==
      DO IS=1,NSP
        IF(TVAN(IS)) THEN
          CALL FORMFV(IS,RS1,RS2)
        ELSEIF(TSGP(IS)) THEN
          IF(TNUM(IS)) THEN
            CALL FORMUP(IS,RS1,RS2)
          ELSE
            CALL FORMSG(IS,RS1,RS2)
          ENDIF
        ELSE
          IF(IGAU(IS).GE.0) CALL FORMFN(IS,RS1,RS2)
        ENDIF
      ENDDO
      CALL PUTPS
      DO IS=1,NSP
        IF(TVAN(IS)) THEN
          CALL VDBINIT(IS,RS1,RS2)
        ELSE
          CALL RNLSET(IS,RS1,RS2,RS3)
          CALL NLIN(IS,RS1,RS2)
        ENDIF
      ENDDO
      IF(TIVAN) CALL QINIT(RS1,RS2)

      PUB = 0.d0
      IF(GEQ0) THEN
C$OMP parallel do private(IS) reduction(+:PUB)
#ifdef __SR8000
*poption parallel, tlocal(IS), psum(PUB)
#endif
         DO IS=1,NSP
          PUB = PUB + DBLE(NA(IS))*VPS(IS,1)
        ENDDO
      ENDIF
      AA = PUB
      CALL MY_COMBINE(AA, PUB, 8, 1, ALLGRP)

C     ==--------------------------------------------------------------==
C     ==  SELF-ENERGY (NOTHING TO DO WITH MANY-BODY SELF-ENERGY)      ==
C     ==--------------------------------------------------------------==
      ESELF=0.D0
C$OMP parallel do private(IS) reduction(+:ESELF)
#ifdef __SR8000
*poption parallel, tlocal(IS), psum(ESELF)
#endif
      DO IS=1,NSP
        ESELF=ESELF+DBLE(NA(IS))*ZV(IS)*ZV(IS)/RAGGIO(IS)
      ENDDO
      ESELF=ESELF/DSQRT(2.D0*PI)
C     Correction for charged systems
      IF(.NOT.TCLUST) THEN
        PF=CHARGE
        ESELF=ESELF-PF*PUB
      ENDIF


C     ==--------------------------------------------------------------==
C     Calculation of Maximal value of L
      LPMAX=0
      IF(TIVAN) THEN
C$OMP parallel do private(IM,IV,JV,LP) reduction(max:LPMAX)
        DO IM=1,MX
          DO IV=1,NLX
            DO JV=IV,NLX
              LP=LPL(IV,JV,IM)
              LPMAX=MAX(LPMAX,LP)
            ENDDO
          ENDDO
        ENDDO
      ENDIF
      DO IS=1,NSP
        IF(NGH(IS).GT.0) THEN
          IF(TKB(IS)) THEN
            IV=NGH(IS)
            LPMAX=MAX(LPMAX,NGHCOM(IV,IS))
          ELSEIF(TSGP(IS)) THEN
            IV=NGH(IS)
            LPMAX=MAX(LPMAX,LPVAL(IV,IS))
          ELSEIF(.NOT.TVAN(IS)) THEN
            ISTEP=NINT(RMAXN(IS))
            DO IV=1,NGH(IS)
              LP=(IV-1)/ISTEP+1
              LPMAX=MAX(LPMAX,LP)
            ENDDO
          ENDIF
        ENDIF
      ENDDO
      IF(TIVAN) THEN
        NYLMB=NHGK*LPMAX*NKPNT
        CALL MEMORY(IP_YLMB,NYLMB,'YLMB')
        CALL AZZERO(YLMB,NYLMB)
      ELSE
        NYLMB=0
      ENDIF
      CALL MEMORY(IP_TWNL,NSX*NHXS*NGWK*NKPTALL,'TWNL')
      CALL AZZERO(TWNL,NSX*NHXS*NGWK*NKPTALL)
      CALL GIVE_SCR_PUTWNL(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      CALL PUTWNL(SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==  NONLINEAR CORE CORRECTION                                   ==
C     ==--------------------------------------------------------------==
      IF(TINLC) CALL NLCCSET
C     ==--------------------------------------------------------------==
C     ==  FINITE TEMPERATURE ELECTRONS                                ==
C     ==--------------------------------------------------------------==
      IF(TTROT) CALL EG2
C     ==--------------------------------------------------------------==
C     ==  EAM POTENTIALS                                              ==
C     ==--------------------------------------------------------------==
      TIEAM=.FALSE.
      DO IS=1,NSP
        TIEAM=TIEAM.OR.TEAM(IS)
      ENDDO
      IF (TIEAM) CALL EAMIN
C     ==--------------------------------------------------------------==
C     ==  INITIALIZE DERIVATIVE ARRAYS FOR STRESS CALCULATION         ==
C     ==--------------------------------------------------------------==
      IF(TPRCP.OR.TPRES) THEN
        IF(TIVAN) THEN
          NQDIM    = NHGL
          IF(QSPLINE) NQDIM=2*NSPLPO
          CALL MEMORY(IP_QRADA,NQDIM*NBRX*NBRX*LX*NSX,'QRADA')
        ELSE
          CALL GET_ADDR(IP_QRADA,DUMMY)
        ENDIF
        IF(TIVAN) CALL QRADA_S(RS1,RS2)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  DEALLOCATE ALL MEMORY NOT LONGER NEEDED                     ==
C     ==--------------------------------------------------------------==
      IF(PARENT) CALL PRMEM('  RINFORCE')
      CALL FREEM(IP_RS1)
      CALL FREEM(IP_RS2)
      CALL FREEM(IP_RS3)
      CALL FREEM(IP_RCGRID)
      CALL FREEM(IP_CORECG)
      CALL FREEM(IP_AL)
      CALL FREEM(IP_BL)
      CALL FREEM(IP_RCL)
      CALL FREEM(IP_GNL)
      CALL FREEM(IP_RPS)
      CALL FREEM(IP_RW)
      CALL FREEM(IP_VR)
      IF(TKPNT) CALL FREEM(IP_SCR)
      IF(TIVAN) THEN
        CALL FREEM(IP_RSCORE)
        CALL FREEM(IP_DION)
        CALL FREEM(IP_BETAR)
        CALL FREEM(IP_QQQ)
        CALL FREEM(IP_QFUNC)
        CALL FREEM(IP_QRL)
        CALL FREEM(IP_RUCORE)
        CALL FREEM(IP_RU)
        CALL FREEM(IP_RSATOM)
        CALL FREEM(IP_R)
        CALL FREEM(IP_RAB)
      ENDIF
      CALL TIHALT('  RINFORCE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PUTPS
C     ==--------------------------------------------------------------==
C     == RHOPS: Calculates the Gaussian charge distributions which    ==
C     == replaced the ionic point charges (smeared charge density)    ==
C     == in G space(see ener.inc and cppt.inc)                        ==
C     == VPS: local pseudopotential per species in G space            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'atom.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'dpot.inc'
      include 'mm_ion_dens.inc'
      include 'mm_input.inc'
C     Variables
      DIMENSION VOO(NSPLPO,2,*),GGNH(*)
      REAL*8    VOL,R2MAX,QMAX,EMAX,
     &          CURV2,mm_R2MAX
      INTEGER   ISUB,IS,IG
C     ==--------------------------------------------------------------==
      CALL TISET('     PUTPS',ISUB)
      VOL=1.D0/OMEGA
      DO IS=1,NSP
        R2MAX=RAGGIO(IS)*RAGGIO(IS)
!$OMP parallel do private(IG,QMAX,EMAX)
#ifdef __SR8000
*poption parallel, tlocal(IG,QMAX,EMAX)
#endif 
        DO IG=1,NHG
          QMAX=0.25D0*R2MAX*HG(IG)*TPIBA2
          EMAX=EXP(-QMAX)
          RHOPS(IS,IG)=-ZV(IS)*EMAX*VOL
          VPS(IS,IG)=VOL*CURV2(HG(IG),NSPLPO,GGNH(1),VOO(1,1,IS),
     *                     VOO(1,2,IS),0.0D0)
        ENDDO
        if(qmmm) then
          mm_R2MAX=mm_RAGGIO(IS)*mm_RAGGIO(IS)
!$OMP parallel do private(IG,QMAX,EMAX)
#ifdef __SR8000
*poption parallel, tlocal(IG,QMAX,EMAX)
#endif 
          DO IG=1,NHG
            QMAX=0.25D0*mm_R2MAX*HG(IG)*TPIBA2
            EMAX=EXP(-QMAX)
            mm_RHOPS(IS,IG)=-ZV(IS)*EMAX*VOL
          ENDDO
        endif
        IF(GEQ0) RHOPS(IS,1)=-ZV(IS)*VOL
        IF(GEQ0.and.qmmm) mm_RHOPS(IS,1)=-ZV(IS)*VOL
      ENDDO
      CALL TIHALT('     PUTPS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PUTWNL(SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == CALCULATE TWNL(1:NGW,1:NGH(IS),1:NSP,1:NKPNT) [cppt.inc]     ==
C     ==        Non-Local projectors array                            ==
C     ==        for each G-components (Kleinman-Bylander form)        ==
C     == FOR TIVAN calculate also YLMB                                ==
C     ==--------------------------------------------------------------==
C     == IF TIVAN=.TRUE. YLMB is used (need allocation)               ==
C     == otherwise       SCR (scratch array) is used                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'sphe.inc'
C     Arguments
      INTEGER   LSCR
      REAL*8    SCR(LSCR)
C     Variables
      DIMENSION TWNS(NSPLPO,2,NHXS,NSX),YLMB(NHGK,LPMAX,*),
     &          TWNL(NGWK,NHXS,NSX,NKPNT),
     &          HGKP(NHG,NKPNT),HGKM(NHG,NKPNT),GGNG(NSPLPO),
     &          RK(3,NKPTS)
      REAL*8    GKRK(3,NHG)
      POINTER   (IP_GKRK,GKRK)
      CHARACTER TAG*30
      INTEGER   ISUB,KBEG,KEND,KINC,IKPT,IK,IKK,IKYLMB,LP,IG,IS,IV,
     &          ISTEP,L,LPUTWNL
      REAL*8    VOL,XX,TW,
     &          DASUM,CURV2
      EXTERNAL  DASUM
C     ==--------------------------------------------------------------==
      CALL TISET('    PUTWNL',ISUB)
      CALL GIVE_SCR_PUTWNL(LPUTWNL,TAG)
      CALL TEST_SCR('PUTWNL',TAG,LSCR,LPUTWNL)
      IF(TIVAN) THEN
C       YLMB is already allocated and is used in this routine.
        IF(TKPNT) CALL GET_ADDR(IP_GKRK,SCR(1))
      ELSE
        CALL GET_ADDR(IP_YLMB,SCR(1))
        IF(TKPNT) CALL GET_ADDR(IP_GKRK,SCR(NHGK*LPMAX+1))
      ENDIF
C     ==--------------------------------------------------------------==
      VOL=1.D0/SQRT(OMEGA)
      CALL INQ_SWAP(KBEG,KEND,KINC)
      DO IKPT=KBEG,KEND,KINC
        IF(TKBLOCK) CALL RKPT_SWAP(GKRK,1,IKPT,'HGKP HGKM MASKGW')
        DO IK=1,NKPBL(IKPT)
          IKK=KPBEG(IKPT)+IK
          IF(TKPNT) THEN 
            IF(TIVAN) THEN
              IKYLMB=IK
            ELSE
              IKYLMB=1
            ENDIF
            DO LP=1,LPMAX
!$OMP parallel do private(IG)
#ifdef __SR8000
*poption parallel
#endif
              DO IG = 1 , NHG
                GKRK(1,IG)=GK(1,IG)+RK(1,IKK)
                GKRK(2,IG)=GK(2,IG)+RK(2,IKK)
                GKRK(3,IG)=GK(3,IG)+RK(3,IKK)
              ENDDO

              CALL YLMR2(LP,NHG,HGKP(1,IK),GKRK,YLMB(1,LP,IKYLMB))

!$OMP parallel do private(IG)
#ifdef __SR8000
*poption parallel
#endif
              DO IG = 1 , NHG
                GKRK(1,IG)=-GK(1,IG)+RK(1,IKK)
                GKRK(2,IG)=-GK(2,IG)+RK(2,IKK)
                GKRK(3,IG)=-GK(3,IG)+RK(3,IKK)
              ENDDO

              CALL YLMR2(LP,NHG,HGKM(1,IK),GKRK,YLMB(1+NHG,LP,IKYLMB))

            ENDDO        
          ELSE
            DO LP=1,LPMAX
              CALL YLMR2(LP,NHG,HG,GK,YLMB(1,LP,1))
            ENDDO
          ENDIF
          DO IS=1,NSP
C         Shell structure code disabled
            TSHEL(IS)=.FALSE.
            TSHELS=.FALSE.
            DO IV=1,NGH(IS)
              IF(TVAN(IS)) THEN
                ISTEP=NVALES(IS)*NVALES(IS)
                L=NGHTOL(IV,IS)+1
                LP=1+MOD(IV-1,ISTEP)
              ELSEIF(TKB(IS)) THEN
                L=NGHTOL(IV,IS)+1
                LP=NGHCOM(IV,IS)
              ELSEIF(TSGP(IS)) THEN
                LP=LPVAL(IV,IS)
              ELSE
                ISTEP=NINT(RMAXN(IS))
                L=NGHTOL(IV,IS)+1
                LP=(IV-1)/ISTEP+1
              ENDIF
              XX=DASUM(NSPLPO,TWNS(1,1,IV,IS),1)
              IF(XX.GT.1.D-12) THEN
                IF(TKPNT) THEN
                  DO IG=1,NGW
                    TW=CURV2(HGKP(IG,IK),NSPLPO,GGNG(1),TWNS(1,1,IV,IS),
     *                   TWNS(1,2,IV,IS),0.0D0)
                    TWNL(IG,IV,IS,IK)=YLMB(IG,LP,IKYLMB)*TW*VOL
                  ENDDO
                  DO IG=1,NGW
                    TW=CURV2(HGKM(IG,IK),NSPLPO,GGNG(1),TWNS(1,1,IV,IS),
     *                   TWNS(1,2,IV,IS),0.0D0)
                    TWNL(IG+NGW,IV,IS,IK)=YLMB(IG+NHG,LP,IKYLMB)*TW*VOL
                  ENDDO
                  CALL R_CLEAN(TWNL(1,IV,IS,IK),1,IK)
                ELSE
                  DO IG=1,NGW
                    TW=CURV2(HG(IG),NSPLPO,GGNG(1),TWNS(1,1,IV,IS),
     *                   TWNS(1,2,IV,IS),0.0D0)
                    TWNL(IG,IV,IS,1)=YLMB(IG,LP,1)*TW*VOL
                  ENDDO
                ENDIF
              ENDIF
            ENDDO
          ENDDO
        ENDDO                   ! END OF 1,NKPNT
        IF(TKBLOCK) THEN
          IF(TIVAN) THEN
            CALL WKPT_SWAP(GKRK,1,IKPT,'TWNL YLMB')
          ELSE
            CALL WKPT_SWAP(GKRK,1,IKPT,'TWNL')
          ENDIF
        ENDIF
      ENDDO                     ! END OF NBLKP
      CALL TIHALT('    PUTWNL',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CALC_TWNL(IKPT)
C     ==--------------------------------------------------------------==
C     == CALCULATE TWNL(1:NGW,1:NGH(IS),1:NSP,1:NKPNT) [cppt.inc]     ==
C     ==        Non-Local projectors array                            ==
C     ==        for each G-components (Kleinman-Bylander form)        ==
C     == FOR TIVAN calculate also YLMB                                ==
C     ==--------------------------------------------------------------==
C     == IF TIVAN=.TRUE. YLMB is used (need allocation)               ==
C     == otherwise  allocate temporarily YLMB and GKRK                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'sphe.inc'
C     Arguments
      INTEGER   IKPT
C     Variables
      DIMENSION TWNS(NSPLPO,2,NHXS,NSX),YLMB(NHGK,LPMAX,*),
     &          TWNL(NGWK,NHXS,NSX,NKPNT),
     &          HGKP(NHG,NKPNT),HGKM(NHG,NKPNT),GGNG(NSPLPO),
     &          RK(3,NKPTS)
      REAL*8    GKRK(3,NHG)
      POINTER   (IP_GKRK,GKRK)
      INTEGER   ISUB,IK,IKK,IKYLMB,LP,IG,IS,IV,ISTEP,L
      REAL*8    VOL,XX,TW,
     &          DASUM,CURV2
      EXTERNAL  DASUM
C     ==--------------------------------------------------------------==
      CALL TISET(' CALC_TWNL',ISUB)
      IF(TIVAN) THEN
C       YLMB is already allocated and is used in this routine.
        IF(TKPNT) CALL MEMORY(IP_GKRK,3*NHG,'GKRK')
      ELSE
        CALL MEMORY(IP_YLMB,NHGK*LPMAX,'YLMB')
        IF(TKPNT) CALL MEMORY(IP_GKRK,3*NHG,'GKRK')
      ENDIF
C     ==--------------------------------------------------------------==
      VOL=1.D0/SQRT(OMEGA)
      DO IK=1,NKPBL(IKPT)
        IKK=KPBEG(IKPT)+IK
        IF(TKPNT) THEN 
          IF(TIVAN) THEN
            IKYLMB=IK
          ELSE
            IKYLMB=1
          ENDIF
          DO LP=1,LPMAX

!$OMP parallel do private(IG)
#ifdef __SR8000
*poption parallel
#endif
            DO IG = 1 , NHG
              GKRK(1,IG)=GK(1,IG)+RK(1,IKK)
              GKRK(2,IG)=GK(2,IG)+RK(2,IKK)
              GKRK(3,IG)=GK(3,IG)+RK(3,IKK)
            ENDDO

            CALL YLMR2(LP,NHG,HGKP(1,IK),GKRK,YLMB(1,LP,IKYLMB))

!$OMP parallel do private(IG)
#ifdef __SR8000
*poption parallel
#endif
            DO IG = 1 , NHG
              GKRK(1,IG)=-GK(1,IG)+RK(1,IKK)
              GKRK(2,IG)=-GK(2,IG)+RK(2,IKK)
              GKRK(3,IG)=-GK(3,IG)+RK(3,IKK)
            ENDDO

            CALL YLMR2(LP,NHG,HGKM(1,IK),GKRK,YLMB(1+NHG,LP,IKYLMB))
          ENDDO        
        ELSE
          DO LP=1,LPMAX
            CALL YLMR2(LP,NHG,HG,GK,YLMB(1,LP,1))
          ENDDO
        ENDIF
        DO IS=1,NSP
C         Shell structure code disabled
          TSHEL(IS)=.FALSE.
          TSHELS=.FALSE.
          DO IV=1,NGH(IS)
            IF(TVAN(IS)) THEN
              ISTEP=NVALES(IS)*NVALES(IS)
              L=NGHTOL(IV,IS)+1
              LP=1+MOD(IV-1,ISTEP)
            ELSEIF(TKB(IS)) THEN
              L=NGHTOL(IV,IS)+1
              LP=NGHCOM(IV,IS)
            ELSEIF(TSGP(IS)) THEN
              LP=LPVAL(IV,IS)
            ELSE
              ISTEP=NINT(RMAXN(IS))
              L=NGHTOL(IV,IS)+1
              LP=(IV-1)/ISTEP+1
            ENDIF
            XX=DASUM(NSPLPO,TWNS(1,1,IV,IS),1)
            IF(XX.GT.1.D-12) THEN
              IF(TKPNT) THEN
                DO IG=1,NGW
                  TW=CURV2(HGKP(IG,IK),NSPLPO,GGNG(1),TWNS(1,1,IV,IS),
     *                 TWNS(1,2,IV,IS),0.0D0)
                  TWNL(IG,IV,IS,IK)=YLMB(IG,LP,IKYLMB)*TW*VOL
                ENDDO
                DO IG=1,NGW
                  TW=CURV2(HGKM(IG,IK),NSPLPO,GGNG(1),TWNS(1,1,IV,IS),
     *                 TWNS(1,2,IV,IS),0.0D0)
                  TWNL(IG+NGW,IV,IS,IK)=YLMB(IG+NHG,LP,IKYLMB)*TW*VOL
                ENDDO
                CALL R_CLEAN(TWNL(1,IV,IS,IK),1,IK)
              ELSE
                DO IG=1,NGW
                  TW=CURV2(HG(IG),NSPLPO,GGNG(1),TWNS(1,1,IV,IS),
     *                 TWNS(1,2,IV,IS),0.0D0)
                  TWNL(IG,IV,IS,1)=YLMB(IG,LP,1)*TW*VOL
                ENDDO
              ENDIF
            ENDIF
          ENDDO
        ENDDO
      ENDDO                     ! END OF 1,NKPNT
C     ==--------------------------------------------------------------==
      IF(TIVAN) THEN
C       YLMB is already allocated and is used in this routine.
        IF(TKPNT) CALL FREEM(IP_GKRK)
      ELSE
        CALL FREEM(IP_YLMB)
        IF(TKPNT) CALL FREEM(IP_GKRK)
      ENDIF
      CALL TIHALT(' CALC_TWNL',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_PUTWNL(LPUTWNL,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG
      INCLUDE 'kpts.inc'        !TKPNT
      INCLUDE 'pslo.inc'        !TIVAN
C     Arguments
      INTEGER   LPUTWNL
      CHARACTER TAG*30
C     Variables
      INTEGER   LYLMB
C     ==--------------------------------------------------------------==
      IF(TKPNT) THEN
        LPUTWNL=3*NHG
      ELSE
        LPUTWNL=0
      ENDIF
      IF(TIVAN) THEN
C       Ylmb is allocated , we do not need to use SCR.
        LYLMB=0
      ELSE
        LYLMB=NHGK*LPMAX
      ENDIF
      LPUTWNL=MAX(1,LPUTWNL+LYLMB)
      TAG='3*NHG+NHGK*LPMAX'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SETSPLINE
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'qspl.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'sphe.inc'        !GCUTWMAX
C     Variables
      DIMENSION GGNH(*),GGNG(*)
      INTEGER   I,IL,NADD,NN
      PARAMETER(NADD=10)
      REAL*8    DGL,XSAIM,XSNOW
C     ==--------------------------------------------------------------==
      NSPLPO=NSPLP
      IF(NSPLPO.GT.MMAXX-NADD) THEN
        WRITE(6,*) ' SETSPLINE| MAXIMUM NUMBER OF SPLINE POINTS IS ',
     *              MMAXX-NADD
        CALL STOPGM('SETSPLINE','TOO MANY SPLINE POINTS REQUESTED')
      ENDIF
      NN=NSPLPO+NADD+10
      CALL MEMORY(IP_GGNH,NN,'GGNH')
      CALL MEMORY(IP_GGNG,NN,'GGNG')
      DGL=GCUT/DBLE(NSPLPO-1)
      DO IL=1,NSPLPO
        GGNH(IL)=(IL-1)*DGL
      ENDDO
      IF(QSRANG.GT.1) THEN
        DGL=(QSRANG-1.D0)*GCUT/DBLE(NADD)
        DO IL=NSPLPO+1,NSPLPO+NADD
          GGNH(IL)=GGNH(IL-1)+DGL
        ENDDO
      ENDIF
      DGL=(GCUTWMAX)/DBLE(NSPLPO-1)
      DO IL=1,NSPLPO
        GGNG(IL)=(IL-1)*DGL
      ENDDO
      IF(QSRANG.GT.1) THEN
        DGL=(QSRANG-1.D0)*(GCUTWMAX)/DBLE(NADD)
        DO IL=NSPLPO+1,NSPLPO+NADD
          GGNG(IL)=GGNG(IL-1)+DGL
        ENDDO
      ENDIF
      IF(QSRANG.GT.1) NSPLPO=NSPLPO+NADD
C     ==--------------------------------------------------------------==
C     DISTRIBUTE SPLINE POINTS
      XSNOW=0.D0
      DO I=NPROC,1,-1
        XSAIM = XSNOW + DBLE(NSPLPO)/DBLE(NPROC)
        IF(I.EQ.MEPOS+1) THEN
           NSPLPA=NINT(XSNOW)+1
           NSPLPE=NINT(XSAIM)
           IF(NINT(XSAIM).GT.NSPLPO) NSPLPE=NSPLPO
           IF(I.EQ.1) NSPLPE=NSPLPO
        ENDIF
        XSNOW = XSAIM
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TESTSPLINE
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'qspl.inc'
      INCLUDE 'cppt.inc'
      DIMENSION GGNH(*)
      REAL*8 WARN
C     ==--------------------------------------------------------------==
      WARN=0.D0
      IF(GGNH(NSPLPO).LT.HG(NHG)) WARN=1.D0
      CALL GLOSUM(1,WARN)
      IF(WARN.GT.0.5D0.AND.PARENT) THEN
        WRITE(6,'(A,A)') ' WARNING| SPLINE REGION SMALLER THAN',
     *                   ' MAXIMUM G-VALUE'
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
