C     ==================================================================
      SUBROUTINE RINFORCE_nuc(ndummies)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'aavan.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'fint.inc' ! for ALM, AFNL, BILN
      INCLUDE 'eam.inc'
C     Variables
      DIMENSION TWNS(*),VOO(*),TWNL(*),QRAD(*),RHOC(NHG,NSP)
      REAL*8    RS1(*),RS2(*),RS3(*),SCR(*)
      POINTER   (IP_RS1,RS1),(IP_RS2,RS2),(IP_RS3,RS3),(IP_SCR,SCR)
      INTEGER   IS,ISUB,MRSCR,LMAXV,LVAL,IV,JV,IM,LP,ISTEP,NYLMB,
     &          LSCR,IVL,JVL
      REAL*8    DUMMY
      CHARACTER TAG*30
      integer ndummies
      include 'mm_ion_dens.inc'
      include 'mm_input.inc'

      CALL MEMORY(IP_RCGRID,MMAXX*NSX,'RCGRID')
      CALL MEMORY(IP_CORECG,MMAXX*NSX,'CORECG')
      CALL MEMORY(IP_AL,NSX*LMAXX*MAXGAU,'AL')
      CALL MEMORY(IP_BL,NSX*LMAXX*MAXGAU,'BL')
      CALL MEMORY(IP_RCL,NSX*LMAXX*MAXGAU,'RCL')
C     Real space function and grids for Kleinman-Bylander + Potentials
      CALL MEMORY(IP_GNL,MMAXX*NSX*LMAXX,'GNL')
      CALL MEMORY(IP_RPS,MMAXX*NSX*LMAXX,'RPS')
      CALL MEMORY(IP_RW,MMAXX*NSX,'RW')
      CALL MEMORY(IP_VR,MMAXX*NSX*LMAXX,'VR')

c      CALL AZZERO(RCGRID,MMAXX*NSX)
c      CALL AZZERO(CORECG,MMAXX*NSX)
c      call azzero(al,NSX*LMAXX*MAXGAU)
c      call azzero(bl,NSX*LMAXX*MAXGAU)
c      call azzero(rcl,NSX*LMAXX*MAXGAU)
c      call azzero(gnl,MMAXX*NSX*LMAXX)
c      call azzero(rps,MMAXX*NSX*LMAXX)
c      call azzero(rw,MMAXX*NSX)
c      call azzero(vr,MMAXX*NSX*LMAXX)

c  free memory for arrays in setspline routine
      call freem(ip_ggnh)
      call freem(ip_ggng)

C     ==--------------------------------------------------------------==
C     ==  SELF-ENERGY (NOTHING TO DO WITH MANY-BODY SELF-ENERGY)      ==
C     ==--------------------------------------------------------------==
      ESELF=0.D0
      DO IS=1,ndummies ! NSP
        ESELF=ESELF+DBLE(NA(IS))*ZV(IS)*ZV(IS)/RAGGIO(IS)
      ENDDO
      ESELF=ESELF/DSQRT(2.D0*PI)
C     ==--------------------------------------------------------------==
C     ==  ALLOCATION OF MEMORY                                        ==
C     ==--------------------------------------------------------------==
      CALL TISET('  RINFORCE',ISUB)
      CALL SETSPLINE
C      CALL MEMORY(IP_VPS,NSX*NHG,'VPS')
C      CALL MEMORY(IP_RHOPS,NSX*NHG,'RHOPS')
      if(qmmm) CALL MEMORY(IP_mm_RHOPS,NSX*NHG,'mm_RHOPS')
      IF(TIVAN) THEN
        CALL MEMORY(IP_INDV,NSX*NHX,'INDV')
        NQDIM    = NHGL
        IF(QSPLINE) NQDIM=2*NSPLPO
        CALL MEMORY(IP_QRAD,NQDIM*NBRX*NBRX*LX*NSX,'QRAD')
      ELSE
        CALL GET_ADDR(IP_INDV,DUMMY)
        CALL GET_ADDR(IP_QRAD,DUMMY)
      ENDIF
      IF(TINLC) THEN
        CALL MEMORY(IP_RHOC,NSX*NHG,'RHOC')
        IF(TPRES.OR.TPRCP) CALL MEMORY(IP_DRHOC,6*NSX*NHG,'DRHOC')
      ENDIF
C     SCRATCH SPACE ALLOCATION
      MRSCR   = MAX(8*MMAXX,NSPLPO,NHX*NHX)
      CALL MEMORY(IP_RS1,MRSCR,'RS1')
      CALL MEMORY(IP_RS2,MRSCR,'RS2')
      CALL MEMORY(IP_RS3,MRSCR,'RS3')
C     SPACE ALLOCATION FOR SPLINE

C      CALL MEMORY(IP_VOO,2*NSPLPO*NSX,'VOO')
C      CALL MEMORY(IP_TWNS,2*NSPLPO*NSX*NHXS,'TWNS')

C      CALL AZZERO(VOO,2*NSPLPO*NSX)
c      CALL AZZERO(TWNS,2*NSPLPO*NSX*NHXS)

C     INITIALIZATION FOR VANDERBILT PSEUDOPOTENTIALS
      IF(TIVAN) THEN
        LMAXV=0
        DO IS=1,NSP
          IF(TVAN(IS)) THEN
            LVAL=NVALES(IS)
            IF(LVAL.GT.3) CALL STOPGM('RINFORCE',' L>3, L=')
            IF(LVAL.GT.LMAXV) LMAXV=LVAL
          ENDIF
        ENDDO
C       INITIALIZE CLEBSCH-GORDON COEFFICIENTS
        CALL AAINIT(LMAXV)
        CALL MEMORY(IP_NELEV,NSX,'NELEV')
        CALL MEMORY(IP_QQ,NHXS*NHXS*NSX,'QQ')
        CALL MEMORY(IP_DVAN,NHXS*NHXS*NSX,'DVAN')
        CALL MEMORY(IP_DEEQ,NHXS*NHXS*NAT*NLSD,'DEEQ')
      ENDIF
C     ==--------------------------------------------------------------==
      DO IS=1,ndummies   !   NSP
        IF(TVAN(IS)) THEN
          CALL FORMFV(IS,RS1,RS2)
        ELSEIF(TSGP(IS)) THEN
          CALL FORMSG(IS,RS1,RS2)
        ELSE
          IF(IGAU(IS).GE.0) CALL FORMFN(IS,RS1,RS2)
        ENDIF
      ENDDO
      CALL PUTPS
      DO IS=1,ndummies !  NSP
        IF(TVAN(IS)) THEN
          CALL VDBINIT(IS,RS1,RS2)
        ELSE
          CALL RNLSET(IS,RS1,RS2,RS3)
          CALL NLIN(IS,RS1,RS2)
        ENDIF
      ENDDO
      IF(TIVAN) CALL QINIT(RS1,RS2)
C     ==--------------------------------------------------------------==
C     Calculation of Maximal value of L
      LPMAX=0
      IF(TIVAN) THEN
        DO IM=1,MX
          DO IV=1,NLX
            DO JV=IV,NLX
              LP=LPL(IV,JV,IM)
              LPMAX=MAX(LPMAX,LP)
            ENDDO
          ENDDO
        ENDDO
      ENDIF
      DO IS=1, ndummies  ! NSP
        IF(NGH(IS).GT.0) THEN
          IF(TKB(IS)) THEN
            IV=NGH(IS)
            LPMAX=MAX(LPMAX,NGHCOM(IV,IS))
          ELSEIF(TSGP(IS)) THEN
            IV=NGH(IS)
            LPMAX=MAX(LPMAX,LPVAL(IV,IS))
          ELSEIF(.NOT.TVAN(IS)) THEN
            ISTEP=NINT(RMAXN(IS))
            DO IV=1,NGH(IS)
              LP=(IV-1)/ISTEP+1
              LPMAX=MAX(LPMAX,LP)
            ENDDO
          ENDIF
        ENDIF
      ENDDO
      IF(TIVAN) THEN
        NYLMB=NHGK*LPMAX*NKPNT
        CALL MEMORY(IP_YLMB,NYLMB,'YLMB')
        CALL AZZERO(YLMB,NYLMB)
      ELSE
        NYLMB=0
      ENDIF

C      CALL MEMORY(IP_TWNL,NSX*NHXS*NGWK*NKPTALL,'TWNL')

      CALL AZZERO(TWNL,NSX*NHXS*NGWK*NKPTALL)
      CALL GIVE_SCR_PUTWNL(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      CALL PUTWNL(SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==  NONLINEAR CORE CORRECTION                                   ==
C     ==--------------------------------------------------------------==
      IF(TINLC) CALL NLCCSET
C     ==--------------------------------------------------------------==
C     ==  FINITE TEMPERATURE ELECTRONS                                ==
C     ==--------------------------------------------------------------==
      IF(TTROT) CALL EG2
C     ==--------------------------------------------------------------==
C     ==  EAM POTENTIALS                                              ==
C     ==--------------------------------------------------------------==
      TIEAM=.FALSE.
      DO IS=1,ndummies  ! NSP
        TIEAM=TIEAM.OR.TEAM(IS)
      ENDDO
      IF (TIEAM) CALL EAMIN
C     ==--------------------------------------------------------------==
C     ==  INITIALIZE DERIVATIVE ARRAYS FOR STRESS CALCULATION         ==
C     ==--------------------------------------------------------------==
      IF(TPRCP.OR.TPRES) THEN
        IF(TIVAN) THEN
          NQDIM    = NHGL
          IF(QSPLINE) NQDIM=2*NSPLPO
          CALL MEMORY(IP_QRADA,NQDIM*NBRX*NBRX*LX*NSX,'QRADA')
        ELSE
          CALL GET_ADDR(IP_QRADA,DUMMY)
        ENDIF
        IF(TIVAN) CALL QRADA_S(RS1,RS2)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  DEALLOCATE ALL MEMORY NOT LONGER NEEDED                     ==
C     ==--------------------------------------------------------------==
      IF(PARENT) CALL PRMEM('  RINFORCE')
      CALL FREEM(IP_RS1)
      CALL FREEM(IP_RS2)
      CALL FREEM(IP_RS3)

      CALL FREEM(IP_RCGRID)
      CALL FREEM(IP_CORECG)
      CALL FREEM(IP_AL)
      CALL FREEM(IP_BL)
      CALL FREEM(IP_RCL)
      CALL FREEM(IP_GNL)
      CALL FREEM(IP_RPS)
      CALL FREEM(IP_RW)
      CALL FREEM(IP_VR)

C      call freem(ip_rv)

C      call freem(ip_vps)
C      call freem(ip_rhops)
C      call freem(ip_voo)
C      call freem(ip_twns)
C      call freem(ip_twnl)

      call freem(ip_scr)

      IF(TKPNT) CALL FREEM(IP_SCR)
      IF(TIVAN) THEN
        CALL FREEM(IP_RSCORE)
        CALL FREEM(IP_DION)
        CALL FREEM(IP_BETAR)
        CALL FREEM(IP_QQQ)
        CALL FREEM(IP_QFUNC)
        CALL FREEM(IP_QRL)
        CALL FREEM(IP_RUCORE)
        CALL FREEM(IP_RU)
        CALL FREEM(IP_RSATOM)
        CALL FREEM(IP_R)
        CALL FREEM(IP_RAB)
      ENDIF
      CALL TIHALT('  RINFORCE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
