C     ==================================================================
      SUBROUTINE RINIT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'gvec.inc'
      INCLUDE 'cell.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'symm.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'sphe.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'andr.inc'
      INCLUDE 'broy.inc'
      INCLUDE 'elct.inc'        !N
      include 'kdpc.inc'
      INCLUDE 'store.inc'
      INCLUDE 'response_p.inc'
C     Variables
      DIMENSION RK(3,*),WK(*),NGWKPS(*)
      REAL*8    SCR1(3,3)
      REAL*8    RCERF1,RCERF2,RCERF3
      REAL*8    DELTAKIN
      PARAMETER (DELTAKIN=1.D-10)
      INTEGER   I,IK,I1,I2
      CHARACTER CIHGP*14
      CHARACTER PGRP(32)*10
      DATA      PGRP
     &          /'    1 (c1)','   <1>(ci)','    2 (c2)','   m (c1h)',
     *           '  2/m(c2h)','    3 (c3)','  <3>(c3i)','   32 (d3)',
     *           '  3m (c3v)',' <3>m(d3d)','    4 (c4)','   <4>(s4)',
     *           '  4/m(c4h)','   422(d4)','  4mm(c4v)','<4>2m(d2d)',
     *           '4/mmm(d4h)','    6 (c6)','  <6>(c3h)','  6/m(c6h)',
     *           '   622(d6)','  6mm(c6v)','<6>m2(d3h)','6/mmm(d6h)',
     *           '   222(d2)','  mm2(c2v)','  mmm(d2h)','    23 (t)',
     *           '   m3 (th)','   432 (o)',' <4>3m(td)','   m3m(oh)'/
      CHARACTER IHGP(7)*12
      DATA      IHGP
     &         /'   TRICLINIC','  MONOCLINIC','ORTHORHOMBIC',
     &          '  TETRAGONAL','       CUBIC','    TRIGONAL',
     &          '   HEXAGONAL'/
#ifdef PARALLEL
      INTEGER MSGLEN
#endif
C     ==--------------------------------------------------------------==
      IF(TKPNT) THEN
        NGWK=2*NGW
        NHGK=2*NHG
C..FNL is complex
        IMAGP=2
C       G-VECTORS
        CALL RGGEN
C       INITIALIZE K-POINTS
        CALL RKPNT
      ELSEIF(TKDP) THEN 
        NGWK=NGW
        NHGK=NHG
        IMAGP=1
        TEBAND=.FALSE.
        ROCC=ROCC.AND.TDIAG
C       G-VECTORS
        CALL RGGEN
c       Initialize k.p k-points
        CALL KDPOINTS(nk1*nk2*nk3)
      ELSEIF(TKPERT) THEN
        NGWK=NGW
        NHGK=NHG
        IMAGP=1
        TEBAND=.FALSE.
        ROCC=ROCC.AND.TDIAG
C       G-VECTORS
        CALL RGGEN
        CALL MEMORY(IP_RRK,3*NKPTS,'RRK')
        CALL MEMORY(IP_WWK,NKPTS,'WWK')
        CALL DCOPY(3*NKPTS,RK,1,RRK,1)
        CALL DCOPY(NKPTS,WK,1,WWK,1)
        CALL AZZERO(RK,3*NKPTS)
        DO IK = 1,NKPTS
          WK(IK) = 1.0D0
        ENDDO
      ELSE
        NGWK=NGW
        NHGK=NHG
C       For non parallel set to one in SYSIN.
#ifdef PARALLEL
        NKPTS=1
        NKPNT=1
        NBLKP=1
#endif
        IMAGP=1
        CALL MEMORY(IP_WK,1,'WK')
        WK(1)=1.D0
        TEBAND=.FALSE.
        ROCC=ROCC.AND.TDIAG
C       G-VECTORS
        CALL RGGEN
      ENDIF
      IF(TCLUST.AND.PS_TYPE.EQ.1) THEN
        IF(RCERF.LT.1.D-4) THEN
          RCERF1=CELLDM(1)*0.5D0
          RCERF2=CELLDM(2)*RCERF1
          RCERF3=CELLDM(3)*RCERF1
          RCERF=(RCERF1+RCERF2+RCERF3)/3.D0
          RCERF=RCERF/7.D0
          RCERF=MIN(RCERF,2.D0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(/,A,A)')
     *     ' ************************** SUPERCELL',
     *     ' ***************************'
        IF(TCLUST) THEN
          IF(TONED) THEN
            WRITE(6,'(A)') ' THIS IS A POLYMER CALCULATION '
          ELSEIF(TTWOD) THEN
            IF(SNORMAL.EQ.1) THEN
              WRITE(6,'(A,T54,A)') 
     &          ' THIS IS A SURFACE CALCULATION:','    YZ PLANE'
            ELSE IF(SNORMAL.EQ.2) THEN
              WRITE(6,'(A,T54,A)') 
     &          ' THIS IS A SURFACE CALCULATION:','    ZX PLANE'
            ELSE IF(SNORMAL.EQ.3) THEN
              WRITE(6,'(A,T54,A)') 
     &          ' THIS IS A SURFACE CALCULATION:','    XY PLANE'
            ENDIF
          ELSE
            WRITE(6,'(A)') ' THIS IS AN ISOLATED SYSTEM CALCULATION '
          ENDIF
          IF(PS_TYPE.EQ.1) THEN
            WRITE(6,'(A,T54,A)') 
     &                ' POISSON EQUATION SOLVER  : ','     HOCKNEY'
            WRITE(6,'(A,T54,F12.3)') 
     &                ' COULOMB SMOOTHING RADIUS : ',RCERF
          ELSEIF(PS_TYPE.EQ.2) THEN
            WRITE(6,'(A,T46,A)') 
     &      ' POISSON EQUATION SOLVER  : ',' TUCKERMAN & MARTYNA'
            WRITE(6,'(A,T54,F12.3)') 
     &      ' SHORT RANGE POTENTIAL LENGTH * BOX LENGTH ',ALPHAL
          ELSEIF(PS_TYPE.EQ.3) THEN
            WRITE(6,'(A,T54,A)') 
     &                ' POISSON EQUATION SOLVER  : ','   MORTENSEN'
          ENDIF
        ENDIF
        IF(IBRAV.EQ.1)
     &       WRITE(6,'(A,T47,A19)') ' SYMMETRY:','       SIMPLE CUBIC'
        IF(IBRAV.EQ.2)
     &       WRITE(6,'(A,T47,A19)') ' SYMMETRY:','FACE CENTERED CUBIC'
        IF(IBRAV.EQ.3)
     &       WRITE(6,'(A,T47,A19)') ' SYMMETRY:','BODY CENTERED CUBIC'
        IF(IBRAV.EQ.4)
     &       WRITE(6,'(A,T47,A19)') ' SYMMETRY:','          HEXAGONAL'
        IF(IBRAV.EQ.5)
     &       WRITE(6,'(A,T47,A19)') ' SYMMETRY:','       RHOMBOHEDRAL'
        IF(IBRAV.EQ.6)
     &       WRITE(6,'(A,T47,A19)') ' SYMMETRY:','         TETRAGONAL'
        IF(IBRAV.EQ.7)
     &       WRITE(6,'(A,T43,A23)')
     &                          ' SYMMETRY:','BODY CENTRED TETRAGONAL'
        IF(IBRAV.EQ.8)
     &       WRITE(6,'(A,T47,A19)') ' SYMMETRY:','       ORTHORHOMBIC'
        IF(IBRAV.EQ.12)
     &       WRITE(6,'(A,T47,A19)') ' SYMMETRY:','         MONOCLINIC'
        IF(IBRAV.EQ.14)
     &       WRITE(6,'(A,T47,A19)') ' SYMMETRY:','          TRICLINIC'
        IF(INDPG.NE.0) THEN
          IF(TMSYM) THEN
            WRITE(6,'(A,A,I3)') ' MOLECULAR POINT GROUP : ',STAG,NAXIS 
            IF(INDPG.LT.0) WRITE(6,'(A,A,5X,A,I3)') 
     *  ' POINT GROUP : SUBGROUP OF ',STAG,'GROUP ORDER=',NROT
            INDPG=ABS(INDPG)
            DO I=1,NROT
              CALL DGEMM('N','N',3,3,3,1.D0,XTABLE(1,1,I),3,
     *                   HT(1,1),3,0.D0,SCR1(1,1),3)
              CALL DGEMM('N','N',3,3,3,1.D0,HTM1(1,1),3,
     *                   SCR1(1,1),3,0.D0,XTABLE(1,1,I),3)
            ENDDO
          ELSE
            IF(INDPG.GT.0) THEN
              IF(IHG.EQ.0) THEN
                WRITE(CIHGP,'(14(" "))')
              ELSE
                CALL XSTRING(IHGP(IHG),I1,I2)
                WRITE(CIHGP,'("[",A,"]")') IHGP(IHG)(I1:I2)
              ENDIF
              WRITE(6,'(" POINT GROUP : ",T42,A14,A10)')
     &             CIHGP,PGRP(INDPG)
            ELSE
              WRITE(6,'(A,A10,T51,A12,I3)')
     &             ' POINT GROUP : SUBGROUP OF ',
     &             PGRP(-INDPG),'GROUP ORDER=',NROT
              INDPG=ABS(INDPG)
            ENDIF
          ENDIF
        ENDIF
        IF(TPRCP .OR. TPRES) THEN
          WRITE(6,'(A,T54,F12.5)')
     &         ' REFERENCE LATTICE CONSTANT(a.u.):',ALAT
          WRITE(6,'(A,T28,F8.3,5F6.3)') ' REFERENCE CELL DIMENSION:',
     &                         (CELLRF(I),I=1,6)
          WRITE(6,'(A,T54,F12.4)')
     &         ' REFERENCE VOLUME(OMEGA0 IN BOHR^3):',OMEGA0
          WRITE(6,'(A,T28,F8.3,5F6.3)') ' INITIAL CELL DIMENSION:',
     &                         (CELLDM(I),I=1,6)
          WRITE(6,'(A,T54,F12.4)')
     &         ' INITIAL VOLUME(OMEGA IN BOHR^3):',OMEGA
        ELSE
          WRITE(6,'(A,29X,F12.5)')
     &         ' LATTICE CONSTANT(a.u.):',ALAT
          WRITE(6,'(A,T18,6F8.4)')
     &         ' CELL DIMENSION: ',(CELLDM(I),I=1,6)
          WRITE(6,'(A,19X,F20.5)')
     &         ' VOLUME(OMEGA IN BOHR^3): ',OMEGA
        ENDIF
        IF(TPRCP) THEN
          IF(TZFLEX) WRITE(6,'(A)') ' Z-DIRECTION FLEXIBLE CELL '
          IF(TISOT)  WRITE(6,'(A)') ' ISOTROPICALLY FLEXIBLE CELL '

          IF (TISOT.OR.TZFLEX) THEN
            WRITE(6,'(A,T46,F20.4)') ' REFERENCE PRESSURE(KBAR):',
     &           DRUCK*AU_KB
          ELSE
            WRITE(6,'(A,T42,3F8.2)') ' REFERENCE STRESS TENSOR(KBAR):',
     &           (STENS(1,I)*AU_KB,I=1,3)
            WRITE(6,'(T42,3F8.2)')
     &           (STENS(2,I)*AU_KB,I=1,3)
            WRITE(6,'(T42,3F8.2)')
     &           (STENS(3,I)*AU_KB,I=1,3)
          ENDIF
        ENDIF
        WRITE(6,'(A,6X,3F11.4)') ' LATTICE VECTOR A1(BOHR): ',A1
        WRITE(6,'(A,6X,3F11.4)') ' LATTICE VECTOR A2(BOHR): ',A2
        WRITE(6,'(A,6X,3F11.4)') ' LATTICE VECTOR A3(BOHR): ',A3
        WRITE(6,'(A,3F11.4)') ' RECIP. LAT. VEC. B1(2Pi/BOHR): ',
     *          B1(1)/ALAT,B1(2)/ALAT,B1(3)/ALAT
        WRITE(6,'(A,3F11.4)') ' RECIP. LAT. VEC. B2(2Pi/BOHR): ',
     *          B2(1)/ALAT,B2(2)/ALAT,B2(3)/ALAT
        WRITE(6,'(A,3F11.4)') ' RECIP. LAT. VEC. B3(2Pi/BOHR): ',
     *          B3(1)/ALAT,B3(2)/ALAT,B3(3)/ALAT
        IF(TCLAS.AND.TCLUST) THEN
          WRITE(6,'(A,T18,6F8.4)')
     &         ' CLASSICAL CELL: ',(CELLCL(I),I=1,6)
          WRITE(6,'(A,1X,T46,F20.5)')
     &         ' VOLUME(OMEGA IN BOHR^3): ',CLOMEGA
          WRITE(6,'(A,6X,3F11.4)') ' LATTICE VECTOR A1(BOHR): ',CLA1
          WRITE(6,'(A,6X,3F11.4)') ' LATTICE VECTOR A2(BOHR): ',CLA2
          WRITE(6,'(A,6X,3F11.4)') ' LATTICE VECTOR A3(BOHR): ',CLA3
        ENDIF
        IF(AKIN.GT.DELTAKIN) THEN
          WRITE(6,'(A,F6.2,A,F6.2,A,F6.2)') 
     *    ' KINETIC ENERGY SMOOTHING(Ry) : A=',
     *    AKIN,'  S=',SKIN,'  GC=',ECKIN
        ENDIF
        WRITE(6,'(A,T27,3(8X,I5))') ' REAL SPACE MESH:',NR1S,NR2S,NR3S
        WRITE(6,'(A,T54,F12.5)')
     &       ' WAVEFUNCTION CUTOFF(RYDBERG):',ECUT
        WRITE(6,'(A,T36,A6,F5.2,A1,T54,F12.5)')
     &       ' DENSITY CUTOFF(RYDBERG):','(DUAL=',CDUAL,')',CDUAL*ECUT
        IF(TKPNT.AND.TSPHERE) THEN
          WRITE(6,'(A,T54,I12)') 
     *      ' NUMBER OF PLANE WAVES PER WAVEFUNCTION ',NGWKS-1
          WRITE(6,'(A,T54,I12)') 
     *      ' NUMBER OF PLANE WAVES AT GAMMA POINT ',NGW_GAMMA
        ELSE
          IF(TKPNT) THEN
            WRITE(6,'(A,T54,I12)')
     *           ' NUMBER OF PLANE WAVES FOR WAVEFUNCTION CUTOFF: ',
     &           NGWKS-1
          ELSE
            WRITE(6,'(A,T54,I12)')
     *           ' NUMBER OF PLANE WAVES FOR WAVEFUNCTION CUTOFF: ',
     &           NGWKS
          ENDIF
        ENDIF
        WRITE(6,'(A,T54,I12)') 
     *    ' NUMBER OF PLANE WAVES FOR DENSITY CUTOFF: ',NHGS
        IF(TGBROY) 
     &       WRITE(6,'(A,T54,I12)') 
     *    ' NUMBER OF PLANE WAVES FOR BROYDEN MIXING: ',NGBROY
        IF(TTROT) WRITE(6,'(A,T54,1PE12.5)') ' TROTTER FACTOR :',BETAP 
        IF(TKPNT) THEN
          WRITE(6,'(1X,A,T58,I8)')
     &         'KPOINTS (IN CARTESIAN COORDINATES AS INPUT):',
     &         NKPTS
C         In input and output k points are in cartesian coordinates.
          WRITE(6,'(A,A)') '  NKP       KX           KY',
     &                     '           KZ         WEIGHT       NGW'

          DO IK=1,NKPTS
            WRITE(6,'(1X,I4,3F13.5,F11.5,I10)') 
     &               IK,(RK(I,IK),I=1,3),WK(IK),NGWKPS(IK)
          ENDDO
          IF(TKSCALE) WRITE(6,'(1X,A)')
     &         '[K-POINTS IN INPUT FILE WERE IN RECIPROCAL COORDINATES]'
        ENDIF
        WRITE(6,'(1X,64("*"))')
        WRITE(6,*)
C       ==------------------------------------------------------------==
C       Check if the number of states is not bigger that the number of
C       components for each set of k points.
C       If it is, the orthogonalisation is impossible.
        IF(TKPNT) THEN
          DO IK=1,NKPTS
            IF(NGWKPS(IK).LT.N) THEN
              WRITE(6,'(A,I4,3F13.5,/,A,I6,/,A,I6,/,A)')
     &             ' RINIT! For the K points',IK,(RK(I,IK),I=1,3),
     &             ' RINIT! the number of components NGWK',NGWKPS(IK),
     &             ' RINIT! is not greater than the number of states',N,
     &             ' RINIT! The orthogonalisation is impossible !'
              CALL STOPGM('RINIT','TOO MANY STATES')
            ENDIF
          ENDDO
        ELSE
          IF(2*NGWS-1.LT.N) THEN
            WRITE(6,'(A,I6,/,A,I6,/,A)')
     &           ' RINIT! The number of components (2*NGWS-1)',
     &           2*NGWS-1,
     &           ' RINIT! is not greater than the number of states',N,
     &           ' RINIT! The orthogonalisation is impossible !'
            CALL STOPGM('RINIT','TOO MANY STATES')
          ENDIF
        ENDIF
C       ==------------------------------------------------------------==
C       Check for the option TKNOSWAP.
        IF(TKNOSWAP) THEN
          IF(.NOT.WFOPT) THEN
            WRITE(6,'(A,A)')
     &           ' RINIT| WITH YOUR OPTIONS, THE WAVEFUNCTIONS ARE ',
     &           'IRRELEVANT'
            CALL STOPGM('RINIT',
     &           'USED ONLY WITH WAVEFUNCTIONS OPTMIZATION')
          ENDIF
          IF(NOMORE.NE.1) THEN
            WRITE(6,'(A,A)')
     &           ' RINIT| WITH YOUR OPTIONS, THE WAVEFUNCTIONS ARE ',
     &           'IRRELEVANT'
            CALL STOPGM('RINIT',
     &           'THE MAXIMUM NUMBER OF STEP HAS TO BE EQUAL TO 1')
          ENDIF
          IF(SWF.OR.SPOT.OR.SRHO) THEN
            WRITE(6,'(A,A)')
     &           ' RINIT| WITH YOUR OPTIONS, THE WAVEFUNCTIONS ARE ',
     &           'IRRELEVANT'
            CALL STOPGM('RINIT',
     &           'USE: STORE WAVEFUNCTIONS DENSITY POTENTIAL OFF')
          ENDIF
          IF(TPRES.OR.TPRCP) THEN
            WRITE(6,'(A,A)')
     &           ' RINIT| WITH YOUR OPTIONS, THE WAVEFUNCTIONS ARE ',
     &           'IRRELEVANT'
            CALL STOPGM('RINIT',
     &           'NO CALCULATION OF STRESS TENSOR')
          ENDIF
        ENDIF
      ENDIF                     !IF(PARENT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
