C     ==================================================================
      SUBROUTINE RINITWF(C0,C2,SC0,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == INITIALIZATION OF WAVEFUNCTION                               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'kpts.inc'
      INCLUDE 'spin.inc'        !NLSD
      INCLUDE 'mm_input.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGWK,NSTATE,*),C2(*),SC0(*),PSI(*)
      REAL*8     TAU0(*),FION(*),
     &           RHOE(NNR1,*),SCR(*)
      logical   qmmm_s
C     Variables
      CHARACTER  TAG*30
      INTEGER    LRINITWF
C     ==--------------------------------------------------------------==
C     SCR Test
      CALL GIVE_SCR_RINITWF(LRINITWF,TAG,NSTATE)
      CALL TEST_SCR('RINITWF',TAG,LSCR,LRINITWF)
C     ==--------------------------------------------------------------==
      IF(TPRCP.OR.TPRES) CALL NEWCELL(SCR,LSCR)
      IF(TKBLOCK) CALL RKPT_SWAP(C0,NSTATE,1,'HGKP HGKM MASKGW TWNL')
      IF(INWFUN.EQ.1) THEN
        qmmm_s=qmmm
        qmmm=.false.
        CALL RANDWF(C0,C2,SC0,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
        qmmm=qmmm_s
      ELSEIF(INWFUN.EQ.2) THEN
        CALL ATOMWF(C0,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
      ELSE
        WRITE(6,*) ' RINITWF| UNKNOWN OPTION'
        CALL STOPGM('RINITWF',' ')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RANDWF(C0,C2,SC0,NSTATE,TAU0,FION,RHOE,PSI,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     == PERFORMS AN INITIAL STEP IN SELF CONSISTENCY STARTING WITH   ==
C     == THE RANDOM 'C0'                                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'pslo.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'spin.inc'        !NLSD, NLSX
      INCLUDE 'tpar.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'sphe.inc'
C     Arguments
      INTEGER NSTATE,LSCR
      COMPLEX*16 C0(NGWK,NSTATE,*),C2(NGWK,NSTATE,*),
     &           SC0(NGWK,NSTATE,*),PSI(*)
      REAL*8     TAU0(*),FION(*),CFAC,
     &           RHOE(*),SCR(*)
C     Variables
      DIMENSION  RK(3,NKPTS)
      LOGICAL    TFOR
      CHARACTER  TAG*30
      REAL*8     EIGV(NSTATE)
      INTEGER    KBEG,KEND,KINC,IKPT,IK,IKK,NKPOINT,
     &           LRANDWF
      POINTER    (IP_EIGV,EIGV)
C     ==--------------------------------------------------------------==
C     SCR test
      CALL GIVE_SCR_RANDWF(LRANDWF,TAG,NSTATE)
      CALL TEST_SCR('RANDWF',TAG,LSCR,LRANDWF)
C     ==--------------------------------------------------------------==
      TFOR=.FALSE.
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
      NFI=0
      BSNFI=0
C     ==--------------------------------------------------------------==
C     ==  PHASE FACTORS                                               ==
C     ==--------------------------------------------------------------==
      CALL PHFAC(TAU0)
C     ==--------------------------------------------------------------==
C     ==  RANDOM INITIALIZATION COEFFICIENTS FOR THE WAVEFUNCTIONS    ==
C     ==--------------------------------------------------------------==
      CFAC=DT2BYE
C     Loop over k points
      CALL INQ_SWAP(KBEG,KEND,KINC)
      DO IKPT=KBEG,KEND,KINC
        NKPOINT=NKPBL(IKPT)
        IF(TKBLOCK.AND.TSPHERE) CALL RKPT_SWAP(MASKGW,1,IKPT,'MASKGW')
        DO IK=1,NKPOINT
          IKK=KPBEG(IKPT)+IK
          CALL RANDTOWF(C0(1,1,IK),NSTATE,IK,IKK)
C         Orthogonalization
          IF(TIVAN) CALL RNLSM(C0(1,1,IK),NSTATE,PSI,SCR,LSCR,
     &                         IKPT,IK,.FALSE.)
          CALL ORTHO(NSTATE,C0(1,1,IK),C2(1,1,IK),SCR,LSCR)
        ENDDO
        IF(TKBLOCK) THEN
          CALL WKPT_SWAP(C0,NSTATE,IKPT,'C0')
          IF(TKNOSWAP) GOTO 100
        ENDIF
      ENDDO
 100  CONTINUE
      IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,.FALSE.)
C     ==--------------------------------------------------------------==
C     ==  GRADIENT WITH RESPECT TO WAVEFUNCTIONS                      ==
C     ==--------------------------------------------------------------==
      IF(.NOT.TMDBO) THEN   ! AK IF(.NOT.TDIAG) THEN
        CALL MEMORY(IP_EIGV,NSTATE,'EIGV')
        IF(TKPNT) CALL STOPGM('RANDWF',
     &       'K POINTS AND NONORT NOT IMPLEMENTED')
        CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               NSTATE,1,.TRUE.,TFOR)
C       ==------------------------------------------------------------==
C       ==  STEEPEST DESCENT STEP                                     ==
C       ==------------------------------------------------------------==
        CALL DAXPY(2*NSTATE*NGWK*NKPOINT,CFAC,C2(1,1,1),1,C0(1,1,1),1)
C       ==------------------------------------------------------------==
C       ==  ORTHOGONALIZATION                                         ==
C       ==------------------------------------------------------------==
        IF(.NOT.NONORT) THEN
          DO IK=1,NKPOINT
            IF(TIVAN) CALL RNLSM(C0(1,1,IK),NSTATE,PSI,SCR,LSCR,
     &                           1,IK,.FALSE.)
            CALL ORTHO(NSTATE,C0(1,1,IK),C2(1,1,IK),SCR,LSCR)
          ENDDO
        ENDIF
        CALL FREEM(IP_EIGV)
      ENDIF                     !End of .NOT.TMDBO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RANDTOWF(C0,NSTATE,IKIND,IKK)
C     ==--------------------------------------------------------------==
C     == Build a wavefunction:                                        ==
C     == Symmetric of hermitian                                       ==
C     == C0(NGWK,NSTATE) input:  Randomized values                    ==
C     ==          output: Wavefunctions                               ==
C     == NSTATE   Number of states                                    ==
C     == IKIND    Index of kpoints (input) in the set of 1:NKPOINT    ==
C     == IKK      Index of kpoints (input) in the set of 1:NKPTS      ==
C     ==          if 0 do not use                                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGW NGWK AMPRE NGWKS NKPTS
      INCLUDE 'cppt.inc'        !HG
      INCLUDE 'kpts.inc'        !TKPNT
      INCLUDE 'kpnt.inc'        !RK
      INCLUDE 'geq0.inc'        !GEQ0
C     Arguments
      INTEGER    NSTATE,IKIND,IKK
      COMPLEX*16 C0(NGWK,*)
C     Variables
      DIMENSION RK(3,NKPTS)
      INTEGER IG,IG1,I
      REAL*8  AMPEXP
      LOGICAL TRK0
C     ==--------------------------------------------------------------==
      CALL DURAND(12344.0D0,2*NGWK*NSTATE,C0)
      IF(GEQ0) THEN
C       The first component is for G=0.
        IG1=2
      ELSE
        IG1=1
      ENDIF
      IF(.NOT.TKPNT.OR.IKK.EQ.0.OR.IKIND.EQ.0) THEN
        TRK0=.TRUE.
C       This is evaluated if IF(1) is false.
C       Do not group (2) with 91) to avoid evaluation of (2) if (1)=.TRUE. 
      ELSEIF((RK(1,IKK).EQ.0.D0).AND.(RK(2,IKK).EQ.0.D0).AND.
     &       (RK(3,IKK).EQ.0.D0)) THEN
        TRK0=.TRUE.
      ELSE
        TRK0=.FALSE.
      ENDIF
      IF(TRK0) THEN
C       Gamma point.
        DO I=1,NSTATE
          IF(GEQ0) C0(1,I) = DCMPLX(DREAL(C0(1,I)),0.0D0)
          DO IG=IG1,NGW
            AMPEXP=AMPRE*EXP((-4.D0*SQRT(HG(IG)))/DBLE(NGWKS))
            C0(IG,I) = AMPEXP*(C0(IG,I)-DCMPLX(0.5D0,0.5D0))
          ENDDO
        ENDDO
        IF(TKPNT) THEN
          DO I=1,NSTATE
            IF(GEQ0) C0(NGW+1,I)=DCMPLX(0.D0,0.D0)
            DO IG=IG1,NGW
              C0(IG+NGW,I) = DCONJG(C0(IG,I))
            ENDDO
          ENDDO
          IF(IKIND.NE.0) CALL C_CLEAN(C0,NSTATE,IKIND)
        ENDIF
      ELSE
        DO I=1,NSTATE
          IF(GEQ0) C0(NGW+1,I)=DCMPLX(0.D0,0.D0)
          DO IG=IG1,NGW
            AMPEXP=AMPRE*EXP((-4.D0*SQRT(HG(IG)))/DBLE(NGWKS))
            C0(IG,    I) = AMPEXP*(C0(IG,    I)-DCMPLX(0.5D0,0.5D0))
            C0(IG+NGW,I) = AMPEXP*(C0(IG+NGW,I)-DCMPLX(0.5D0,0.5D0))
          ENDDO
        ENDDO
C       Clean coefficient G/|G+RK|^2 > Ecutoff if spherical cutoff.
        CALL C_CLEAN(C0,NSTATE,IKIND)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RANDWF(LRANDWF,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   LRANDWF,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LORTHO,LCOPOT,LFORCES
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      CALL GIVE_SCR_COPOT(LCOPOT,TAG)
      CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.TRUE.,.FALSE.)
      LRANDWF=MAX(LORTHO,LCOPOT,LFORCES)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RINITWF(LRINITWF,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !TPRCP INWFUN
C     Arguments
      INTEGER   LRINITWF,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LNEWCELL,LOTHER
C     ==--------------------------------------------------------------==
      LRINITWF=0
      LNEWCELL=0
      LOTHER=0
      IF(TPRCP.OR.TPRES) THEN
        CALL GIVE_SCR_NEWCELL(LNEWCELL,TAG)
      ELSE
        LNEWCELL=0
      ENDIF
      IF(INWFUN.EQ.1) THEN
        CALL GIVE_SCR_RANDWF(LOTHER,TAG,NSTATE)
      ELSEIF(INWFUN.EQ.2) THEN
        CALL GIVE_SCR_ATOMWF(LOTHER,TAG,NSTATE)
      ELSE
        LOTHER=0
      ENDIF
      LRINITWF=MAX(LNEWCELL,LOTHER)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
