C     ==================================================================
      SUBROUTINE RINVEL(VEL,CM,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'coor.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'mm_input.inc'
      
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 CM(NGWK,*)
      REAL*8     VEL(3,NAX,*)
C     Variables
      DIMENSION  LVELINI(0:NAX,NSX)
      LOGICAL    LVELTRUE
      REAL*8     VCM(3),RNR(3),SEED,SIGMA,ALFA1,ALFA2,ALFA3,PMA00,
     &           EKINP,TEMPP,TSCAL,VSCALE,
     &           XRANF, XRANFSEED
      EXTERNAL XRANF,XRANFSEED
      INTEGER    IS,IA,IAA
#ifdef PARALLEL
      INTEGER MSGLEN
#endif
      REAL*8 ONE3RD
      PARAMETER(ONE3RD=1.0D0/3.0D0)
C     ==--------------------------------------------------------------==
C     Initialize Velocities for Wavefunctions
      IF(.NOT.TDIAG) CALL AZZERO(CM,2*NSTATE*NGWK)
C     Initialize Cell velocities
      CALL AZZERO(HTVEL,9)
C     check for velocities from input
      LVELTRUE=.FALSE.
      DO IS=1,NSP
        LVELTRUE=LVELTRUE.OR.LVELINI(0,IS)
      ENDDO

C     MAXWELL DISTRIBUTION FOR THE IONS
      IF(PARENT) THEN
        IF(LVELTRUE) THEN
          WRITE(6,*) 'RINVEL| INITIAL VELOCITIES TAKEN FROM INPUT'
          CALL TAUCL(VEL)
          GOTO 100
        ENDIF
        IF ( NTX_vel.eq.1 ) THEN
           WRITE(6,*) 'RINVEL| INITIAL VELOCITIES ',
     .                                'ALREADY TAKEN FROM GROMOS INPUT'
           CALL TAUCL(VEL)
           CALL EKINPP(EKINP,VEL)
           TEMPP=EKINP*FACTEM*2.D0/GLIB   
           WRITE(6,'(1x,''RINVEL| (TEMPERATURE IS '',F10.2,'' K)'')')
     .                                                            TEMPP
           GOTO 100
        ENDIF
        IF (TCAFES) THEN
          WRITE(6,*)'RINVEL| CAFES initial temperature distribution'
        ENDIF
        CALL AZZERO(VEL,3*NAX*NSX)
        SEED=135792468.0D0
        IF(TEMPW.LT.1.D-5) GOTO 100
        CALL DURAND(SEED,3,RNR)
C---------------------------------------------------------------------------
CCC  Randomize velocities for Saddle to Min dynamics 
        IF(LSADPNT) THEN
        
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IF (TCAFES) THEN
                SIGMA=DSQRT(TEMPWR(1,IA,IS)/(PMA(IS)*FACTEM))
              ELSE
                SIGMA=DSQRT(TEMPW/(PMA(IS)*FACTEM))
              ENDIF
            
              CALL DURANDSEED(3,RNR)
              ALFA1=2.0D0*PI*RNR(1)
              ALFA2=2.0D0*PI*RNR(2)
              ALFA3=2.0D0*PI*RNR(3)
              IF(.NOT.LVELINI(IA,IS)) THEN
                VEL(1,IA,IS)=
     &             SQRT(LOG(XRANFSEED())*(-2.0D0))*COS(ALFA1)*SIGMA
                VEL(2,IA,IS)=
     &             SQRT(LOG(XRANFSEED())*(-2.0D0))*COS(ALFA2)*SIGMA
                VEL(3,IA,IS)=
     &             SQRT(LOG(XRANFSEED())*(-2.0D0))*COS(ALFA3)*SIGMA
              ENDIF
            ENDDO
          ENDDO
C---------------------------------------------------------------------------
        ELSE

          DO IS=1,NSP
            DO IA=1,NA(IS)
              IF (TCAFES) THEN
                SIGMA=DSQRT(TEMPWR(1,IA,IS)/(PMA(IS)*FACTEM))
              ELSE
                SIGMA=DSQRT(TEMPW/(PMA(IS)*FACTEM))
              ENDIF
              CALL DURAND(SEED,3,RNR)
              ALFA1=2.0D0*PI*RNR(1)
              ALFA2=2.0D0*PI*RNR(2)
              ALFA3=2.0D0*PI*RNR(3)
              IF(.NOT.LVELINI(IA,IS)) THEN
                VEL(1,IA,IS)=
     &             SQRT(LOG(XRANF())*(-2.0D0))*COS(ALFA1)*SIGMA
                VEL(2,IA,IS)=
     &             SQRT(LOG(XRANF())*(-2.0D0))*COS(ALFA2)*SIGMA
                VEL(3,IA,IS)=
     &             SQRT(LOG(XRANF())*(-2.0D0))*COS(ALFA3)*SIGMA
              ENDIF
            ENDDO
          ENDDO
        ENDIF
C---------------------------------------------------------------------------
        CALL TAUCL(VEL)
C       SUBTRACT CENTER OF MASS VELOCITY
        VCM(1)=0.0D0
        VCM(2)=0.0D0
        VCM(3)=0.0D0
        PMA00=0.D0
        IAA=0
        LVELTRUE=.FALSE.
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IAA=IAA+1
            IF(.NOT.LVELINI(IA,IS)) THEN
              VCM(1)=VCM(1)+VEL(1,IA,IS)*PMA0(IS)
              VCM(2)=VCM(2)+VEL(2,IA,IS)*PMA0(IS)
              VCM(3)=VCM(3)+VEL(3,IA,IS)*PMA0(IS)
              PMA00=PMA00+ONE3RD*(LSKCOR(1,IAA)+
     .              LSKCOR(2,IAA)+LSKCOR(3,IAA))*PMA0(IS)
            ELSE
              LVELTRUE=.TRUE.
            ENDIF
          ENDDO
        ENDDO
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IF(.NOT.LVELINI(IA,IS)) THEN
              VEL(1,IA,IS)=VEL(1,IA,IS)-VCM(1)/PMA00
              VEL(2,IA,IS)=VEL(2,IA,IS)-VCM(2)/PMA00
              VEL(3,IA,IS)=VEL(3,IA,IS)-VCM(3)/PMA00
            ENDIF
          ENDDO
        ENDDO
        CALL TAUCL(VEL)
C       RESCALE VELOCITIES
        IF(.NOT.TCAFES) THEN
           CALL EKINPP(EKINP,VEL)
           TEMPP=EKINP*FACTEM*2.D0/GLIB   
           IF(TEMPP.GT.1.D-5) THEN
             TSCAL=TEMPW/TEMPP
             VSCALE=DSQRT(TSCAL)
             DO IS=1,NSP
               DO IA=1,NA(IS)
                 IF(.NOT.LVELINI(IA,IS)) THEN
                   VEL(1,IA,IS)=VEL(1,IA,IS)*VSCALE
                   VEL(2,IA,IS)=VEL(2,IA,IS)*VSCALE
                   VEL(3,IA,IS)=VEL(3,IA,IS)*VSCALE
                 ENDIF
               ENDDO
             ENDDO
           ENDIF
        ENDIF
  100   CONTINUE
      ENDIF

C     check for remaining C.O.M. velocity
      PMA00=0.0d0
      VCM(1)=0.0d0
      VCM(2)=0.0d0
      VCM(3)=0.0d0
      IAA=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAA=IAA+1
          VCM(1)=VCM(1)+VEL(1,IA,IS)*PMA0(IS)
          VCM(2)=VCM(2)+VEL(2,IA,IS)*PMA0(IS)
          VCM(3)=VCM(3)+VEL(3,IA,IS)*PMA0(IS)
          PMA00=PMA00+ONE3RD*(LSKCOR(1,IAA)+
     .          LSKCOR(2,IAA)+LSKCOR(3,IAA))*PMA0(IS)
        ENDDO
      ENDDO
C     CHECK ONLY IF THERE ARE MOVABLE ATOMS...
      IF(PMA00.GT.1.0D-10) THEN
        IF(DSQRT(VCM(1)**2+VCM(2)**2+VCM(3)**2)/PMA00.GT.1.0D-10) THEN
          IF ( PARENT ) THEN 
            WRITE(6,'(1X,64("!"))')
            WRITE(6,'(" !! RINVEL| WARNING! ",A,T64,"!!")')
     &          'CENTER OF MASS VELOCITY NOT ZERO'
            WRITE(6,'(" !! ",3F15.10,T64,"!!")')
     &          VCM(1)/PMA00,VCM(2)/PMA00,VCM(3)/PMA00
            WRITE(6,'(1X,64("!"))')
          ENDIF
        ENDIF
      ENDIF

#ifdef PARALLEL
      MSGLEN = 3*NAX*NSX * 8
      CALL MY_BCAST(VEL,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE S_RINVEL(VELP,CM,NSTATE,IP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'pimd.inc'
C     Arguments
      INTEGER    NSTATE,IP
      REAL*8     VELP(3,NAX,*)
      COMPLEX*16 CM(*)
C     Variables
      REAL*8     VCM(3),RNR(3),SEED,SIGMA,ALFA1,ALFA2,ALFA3,PTOTM,
     &           EKINP,GLIB_S,TEMPP,TSCAL,VSCALE,
     &           XRANF
      INTEGER    IS,MSGLEN,IA
C     ==--------------------------------------------------------------==
C..Initialize Velocities for Wavefunctions
      CALL AZZERO(CM,2*NSTATE*NGW)
C..Initialize Cell velocities
      CALL AZZERO(HTVEL,9)
C..MAXWELL DISTRIBUTION FOR THE IONS
      IF(PARENT) THEN
        CALL AZZERO(VELP,3*NAX*NSX)
        SEED=135792468.D0
        IF(TEMPW.LT.1.D-5) GOTO 100
        CALL DURAND(SEED,3,RNR)
        DO IS=1,NSP
          SIGMA=DSQRT(TEMPW/(PMA0S(IS,IP)*FACTEM))
          DO IA=1,NA(IS)
            CALL DURAND(SEED,3,RNR)
            ALFA1=2.0D0*PI*RNR(1)
            ALFA2=2.0D0*PI*RNR(2)
            ALFA3=2.0D0*PI*RNR(3)
            VELP(1,IA,IS)=SQRT(LOG(XRANF())*(-2.0D0))*COS(ALFA1)*SIGMA
            VELP(2,IA,IS)=SQRT(LOG(XRANF())*(-2.0D0))*COS(ALFA2)*SIGMA
            VELP(3,IA,IS)=SQRT(LOG(XRANF())*(-2.0D0))*COS(ALFA3)*SIGMA
          ENDDO
        ENDDO
        IF(IP.EQ.1) CALL TAUCL(VELP)
C..SUBTRACT CENTER OF MASS VELOCITY
        VCM(1)=0.0D0
        VCM(2)=0.0D0
        VCM(3)=0.0D0
        PTOTM=0.0D0
        DO IS=1,NSP
          PTOTM=PTOTM+PMA0S(IS,IP)*NA(IS)
          DO IA=1,NA(IS)
            VCM(1)=VCM(1)+VELP(1,IA,IS)*PMA0S(IS,IP)
            VCM(2)=VCM(2)+VELP(2,IA,IS)*PMA0S(IS,IP)
            VCM(3)=VCM(3)+VELP(3,IA,IS)*PMA0S(IS,IP)
          ENDDO
        ENDDO
        DO IS=1,NSP
          DO IA=1,NA(IS)
            VELP(1,IA,IS)=VELP(1,IA,IS)-VCM(1)/PTOTM
            VELP(2,IA,IS)=VELP(2,IA,IS)-VCM(2)/PTOTM
            VELP(3,IA,IS)=VELP(3,IA,IS)-VCM(3)/PTOTM
          ENDDO
        ENDDO
        IF(IP.EQ.1) CALL TAUCL(VELP)
C..RESCALE VELOCITIES
        CALL S_EKINPP(EKINP,VELP,IP)
        GLIB_S=3.D0*NAT
        IF(IP.EQ.1) GLIB_S=GLIB
        TEMPP=EKINP*FACTEM*2.D0/GLIB_S
        IF(TEMPP.GT.1.D-5) THEN
          TSCAL=TEMPW/TEMPP
          VSCALE=DSQRT(TSCAL)
          DO IS=1,NSP
            DO IA=1,NA(IS)
              VELP(1,IA,IS)=VELP(1,IA,IS)*VSCALE
              VELP(2,IA,IS)=VELP(2,IA,IS)*VSCALE
              VELP(3,IA,IS)=VELP(3,IA,IS)*VSCALE
            ENDDO
          ENDDO
        ENDIF
  100   CONTINUE
      ENDIF
      MSGLEN = 3*NAX*NSX * 8
      CALL MY_BCAST(VELP,MSGLEN,SOURCE,ALLGRP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RVSCAL(VEL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'metr.inc'
C     Arguments
      REAL*8     VEL(3,NAX,*)
C     Variables
      REAL*8     EKINP,TEMPP,TSCAL,VSCALE
      INTEGER    IS,IA
#ifdef PARALLEL
      INTEGER MSGLEN
#endif
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
C       RESCALE VELOCITIES
        IF(.NOT.TCAFES) THEN
           CALL EKINPP(EKINP,VEL)
           TEMPP=EKINP*FACTEM*2.D0/GLIB   
           WRITE(6,'(A,F13.5,A,F13.5)') ' RVSCAL| RESCALING IONIC '
     &         // 'TEMP FROM ',TEMPP, ' TO ',TEMPW
           IF(TEMPP.GT.1.D-5) THEN
             TSCAL=TEMPW/TEMPP
             VSCALE=DSQRT(TSCAL)
             DO IS=1,NSP
               DO IA=1,NA(IS)
                 VEL(1,IA,IS)=VEL(1,IA,IS)*VSCALE
                 VEL(2,IA,IS)=VEL(2,IA,IS)*VSCALE
                 VEL(3,IA,IS)=VEL(3,IA,IS)*VSCALE
               ENDDO
             ENDDO
           ENDIF
        ENDIF
      ENDIF
#ifdef PARALLEL
      MSGLEN = 3*NAX*NSX * 8
      CALL MY_BCAST(VEL,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
