CMcB
CMcB   NEW complex*16 version of rk4ov
CMcB
c     subroutine rk4ov(h,x,d,dd,e,dei,s,ds)
      subroutine rk4ov_new(h,x,d,dd,e,dei,s,ds)
      implicit none
      include 'system.h'
      include 'shop.inc'
      include 'ropt.inc'
      real*8 x(3*nsurf),xdot(3*nsurf),d(nsurf,nsurf),e(nsurf),h,s,dtot
     >,csq(nsurf),de
     >,d1sq,d2sq,id1,rd1,id2,rd2,id1dot,rd1dot,id2dot,rd2dot,oms,sdot
     >,d11dot,d22dot,dei(2),ds,dd(2,2),ds1,ds2,ds3,ds4
      complex*16 b(3),bdot(3),d1,d2,d1dot,d2dot,p(2),pdot(2),ui
      complex*16 a(3),adot(3),k1(3),k2(3),k3(3),k4(3)
      integer n3,i,ii,nzaehl 
      COMMON /PROB1/D1SQ,D2SQ,D11DOT,D22DOT 
cMcB
c     if (parent) then
c        write (6,*) 'rk4ov_ini: ', ' h = ',h
c        write (6,*) 'rk4ov_ini: ', ' x13 (POP) = ',x(1),x(3)
c        write (6,*) 'rk4ov_ini: ', ' x24 (POP) = ',x(2),x(4)
c        write (6,*) 'rk4ov_ini: ', ' x56 (POP) = ',x(5),x(6)
c        write (6,*) 'rk4ov_ini: ', ' d, dd = ',d,dd
c        write (6,*) 'rk4ov_ini: ', ' e(1), dei(1) = ',e(1),dei(1)
c        write (6,*) 'rk4ov_ini: ', ' e(2), dei(2) = ',e(2),dei(2)
c        write (6,*) 'rk4ov_ini: ', ' s, ds = ',s,ds
c     endif
cMcB
      ui=(0.0d0,1.0d0)
      a(1)=cmplx(x(1),x(3))
      a(2)=cmplx(x(2),x(4))
      a(3)=cmplx(x(5),x(6))
      call derivov_new(a,adot,d,e,s,sdot)
      do i=1,3
         k1(i)=h*adot(i)
         a(i)=a(i)+k1(i)/2.0D0
      end do
c...update coupling, overlap, energies
      ds1=h*sdot
      s=s+ds1/2.0D0
c
      d(1,2)=d(1,2)+dd(1,2)/2.0D0
      d(2,1)=d(2,1)+dd(2,1)/2.0D0
      e(1)=e(1)+dei(1)/2.0D0
      e(2)=e(2)+dei(2)/2.0D0
c...end update coupling
      call derivov_new(a,adot,d,e,s,sdot)
      do i=1,3
         a(i)=a(i)-k1(i)/2.0d0         
         k2(i)=h*adot(i)
         a(i)=a(i)+k2(i)/2.0d0
      end do
      s=s-ds1/2.0D0
      ds2=h*sdot
      s=s+ds2/2.0D0
      call derivov_new(a,adot,d,e,s,sdot)
      do i=1,3
         a(i)=a(i)-k2(i)/2.0d0         
         k3(i)=h*adot(i)
         a(i)=a(i)+k3(i)
      end do
      s=s-ds2/2.0D0
      ds3=h*sdot
      s=s+ds3
c...update coupling, overlap, energies
      d(1,2)=d(1,2)+dd(1,2)/2.0d0
      d(2,1)=d(2,1)+dd(2,1)/2.0d0
      e(1)=e(1)+dei(1)/2.0d0
      e(2)=e(2)+dei(2)/2.0d0
c...end update coupling
      call derivov_new(a,adot,d,e,s,sdot)
      do i=1,3
         a(i)=a(i)-k3(i)
         k4(i)=h*adot(i)
         a(i)=a(i)+k1(i)/6.0d0+k2(i)/3.0d0+k3(i)/3.0d0+k4(i)/6.0d0
      end do
      s=s-ds3
      ds4=h*sdot
      s=s+ds1/6.0d0+ds2/3.0d0+ds3/3.0d0+ds4/6.0d0     
C     CONVERT BACK TO X
      x(1)=dreal(a(1))
      x(3)=dimag(a(1))
      x(2)=dreal(a(2))
      x(4)=dimag(a(2))
      x(5)=dreal(a(3))
      x(6)=dimag(a(3))
      p(1)=exp(-ui*x(5))
      p(2)=exp(-ui*x(6))
      do i=1,2
         pdot(i)=-p(i)*ui*e(i)
         b(i)=a(i)*p(i)
         bdot(i)=adot(i)*p(i)+a(i)*pdot(i)
      end do
      oms=dsqrt(1.0d0-s**2.0d0)
      d1=b(1)+s*b(2)
      d2=b(2)*oms
      d1sq=dconjg(d1)*d1
      d2sq=dconjg(d2)*d2
C     COMPUTE TRANSITION PROBABILITIES
      sdot=d(1,2)+d(2,1)
      d1dot=bdot(1)+s*bdot(2)+sdot*b(2)
      d2dot=bdot(2)*oms-s*sdot/oms*b(2)
      d11dot=dconjg(d1dot)*d1+dconjg(d1)*d1dot
      d22dot=dconjg(d2dot)*d2+dconjg(d2)*d2dot
c11   FORMAT(A3,I,F12.6,2X,F12.6,F12.6)
c12   format(i6,4(1x,f12.8))
cMcB
c     if (parent) then
c        write (6,*) 'rk4ov_fin: ', ' b(1) = ',b(1)
c        write (6,*) 'rk4ov_fin: ', ' b(2) = ',b(2)
c        write (6,*) 'rk4ov_fin: ', ' s = ',s 
c        write (6,*) 'rk4ov_fin: ', ' oms = ',oms 
c        write (6,*) 'rk4ov_fin: ', ' d1sq = ',d1sq
c        write (6,*) 'rk4ov_fin: ', ' d2sq = ',d2sq
c        write (6,*) 'rk4ov_fin: ', ' d1dot = ',d1dot
c        write (6,*) 'rk4ov_fin: ', ' d2dot = ',d2dot
c     endif
cMcB
      return
      end
c----------------------------------------------------------------------
      subroutine derivov_new(a,adot,d,e,s,sdot)
      implicit none
      include 'shop.inc'
      real*8 x(3*nsurf),xdot(3*nsurf),d(nsurf,nsurf),e(nsurf),s,de
      real*8 s2m1,sdot
      complex*16 a(3),adot(3),ui,p(2),p12,p21
      integer i,ii,iii,j,jj,jjj,n,n3
      ui=(0.0d0,1.0d0)
      n=nsurf
      n3=3*nsurf
c     a(1)=(x(1),x(3))
c     a(2)=(x(2),x(4))
c     a(3)=(x(5),x(6))
c     x(1)=x1
c     x(2)=x2
c     x(3)=y1
c     x(4)=y2
c     x(5)=eps(1)=int(e1)dt
c     x(6)=eps(2)=int(e2)dt
      de=e(1)-e(2)
      p(1)=exp(-ui*dreal(a(3)))
      p(2)=exp(-ui*dimag(a(3)))
      p12=p(1)/p(2)
      p21=p(2)/p(1)
      s2m1=s**2.0d0 - 1.0d0
      adot(1)=(ui*a(2)*p21*s*de+a(2)*d(1,2)*p21-a(1)*d(2,1)*s)/s2m1
      adot(2)=(a(1)*d(2,1)*p12-a(2)*d(1,2)*s-ui*a(2)*s**2*de)/s2m1
      adot(3)=dcmplx(e(1),e(2))
      sdot=d(1,2)+d(2,1)
      return
      end

C
C#####################################################################
C
CMcB
CMcB   OLD real*8-mapped version of rk4ov
CMcB
      subroutine rk4ov_old(h,x,d,DD,e,DEI,s,DS)
      implicit none
cMcB
      include 'system.h'
cMcB
      include 'shop.inc'
      include 'ropt.inc'
      real*8 x(3*nsurf),xdot(3*nsurf),d(nsurf,nsurf),e(nsurf),h,s,dtot
     >,k1(3*nsurf),k2(3*nsurf),k3(3*nsurf),k4(3*nsurf),csq(nsurf),de
     >,d1,d2,id1,rd1,id2,rd2,id1dot,rd1dot,id2dot,rd2dot,oms,sdot
     >,d11dot,d22dot 
cMcB
      real*8 DD(NSURF,NSURF),DEI(NSURF),DS,D1SQ,D2SQ
cMcB
      integer n3,i,ii,nzaehl 
cMcB
c     COMMON /PROB/D1,D2,D11DOT,D22DOT 
      COMMON /PROB1/D1SQ,D2SQ,D11DOT,D22DOT 
cMcB
cMcB
c     if (parent) then
c        write (6,*) 'rk4ov_ini: ', ' h = ',h
c        write (6,*) 'rk4ov_ini: ', ' x13 (POP) = ',x(1),x(3)
c        write (6,*) 'rk4ov_ini: ', ' x24 (POP) = ',x(2),x(4)
c        write (6,*) 'rk4ov_ini: ', ' x56 (POP) = ',x(5),x(6)
c        write (6,*) 'rk4ov_ini: ', ' d(1), dd(1) = ',d(1,1),dd(1,1)
c        write (6,*) 'rk4ov_ini: ', ' d(2), dd(2) = ',d(2,2),dd(2,2)
c        write (6,*) 'rk4ov_ini: ', ' e(1), dei(1) = ',e(1),dei(1)
c        write (6,*) 'rk4ov_ini: ', ' e(2), dei(2) = ',e(2),dei(2)
c        write (6,*) 'rk4ov_ini: ', ' s, ds = ',s,ds
c        write (6,*) 'rk4ov_ini: ', ' NSURF = ',nsurf
c     endif
cMcB
      n3=3*nsurf
      nzaehl=nzaehl+1
      call derivov_old(x,xdot,d,e,s)
      do i=1,n3
         k1(i)=h*xdot(i)
         x(i)=x(i)+k1(i)/2.0
      end do
      call derivov_old(x,xdot,d,e,s)
      do i=1,n3
         x(i)=x(i)-k1(i)/2.0d0         
         k2(i)=h*xdot(i)
         x(i)=x(i)+k2(i)/2.0d0
      end do
      call derivov_old(x,xdot,d,e,s)
      do i=1,n3
         x(i)=x(i)-k2(i)/2.0d0         
         k3(i)=h*xdot(i)
         x(i)=x(i)+k3(i)
      end do
      call derivov_old(x,xdot,d,e,s)
      do i=1,n3
         x(i)=x(i)-k3(i)
         k4(i)=h*xdot(i)
         x(i)=x(i)+k1(i)/6.0d0+k2(i)/3.0d0+k3(i)/3.0d0+k4(i)/6.0d0
      end do
      do i=1,nsurf
         ii=i+nsurf
         csq(i)=x(i)**2.0d0+x(ii)**2.0d0
c      if (mod(nzaehl,40).eq.1) then
c         write(6,11)'rk4',i,csq(i),x(i),x(ii)
c      end if
      end do 
      de=x(5)-x(6)
      dtot=2.0d0*s*(dcos(de)*(x(1)*x(2)+x(3)*x(4))+dsin(de)
     >     *(x(3)*x(2)-x(1)*x(4)))
      d1=csq(1)+csq(2)*s**2.0d0+dtot
      d2=csq(2)*(1.0d0-s**2.0d0)
cMcB
      d1sq=d1
      d2sq=d2
cMcB
C     COMPUTE TRANSITION PROBABILITIES
      sdot=d(1,2)+d(2,1)
      oms=dsqrt(1.0d0-s**2.0d0)
      D22DOT=2.0d0*((X(2)*XDOT(2)+X(4)*XDOT(4))*OMS**2-CSQ(2)*S*SDOT)
c      PRINT*,'D22DOT [2]=',D22DOT
      D11DOT=2.0d0*(X(1)*XDOT(1)+X(3)*XDOT(3)+S**2*(X(2)*XDOT(2)+
     >X(4)*XDOT(4))+S*SDOT*CSQ(2)+SDOT*0.5D0*DTOT/S+S*(COS(DE)*
     >(XDOT(1)*X(2)+X(1)*XDOT(2)+XDOT(3)*X(4)+X(3)*XDOT(4)+
     >(E(1)-E(2))*(X(3)*X(2)-X(1)*X(4)))+SIN(DE)*(XDOT(3)*X(2)+
     >X(3)*XDOT(2)-XDOT(1)*X(4)-X(1)*XDOT(4)-(E(1)-E(2))*(X(1)*X(2)
     >+X(3)*X(4)))))
c      PRINT*,'D11DOT [2]=',D11DOT
c      if (mod(nzaehl,40).eq.1) then
c      print*,'tot',csq(1)+csq(2)+dtot
c      print*,'dtot',dtot
c      PRINT*,'POPULATION 1',d1
c      PRINT*,'POPULATION 2',d2
C---- WRITE COEFFICIENTS TO FILE --------------------------
c      open(789,file='prob.dat',position='append')
c      write(789,12)infi,csq(1),csq(2),d1,d2
c      close(789)
C--------------------------------------------------------
c      end if
 11   FORMAT(A3,I6,F12.6,2X,F12.6,F12.6)
 12   format(i6,4(1x,f12.8))
      return
      end
c----------------------------------------------------------------------
      subroutine derivov_old(x,xdot,d,e,s)
      implicit none
      include 'shop.inc'
      real*8 x(3*nsurf),xdot(3*nsurf),d(nsurf,nsurf),e(nsurf),s,de
      integer i,ii,iii,j,jj,jjj,n,n3
      n=nsurf
      n3=3*nsurf
      de=x(5)-x(6)

c     x(1)=x1
c     x(2)=x2
c     x(3)=y1
c     x(4)=y2
c     x(5)=eps(1)=int(e1)dt
c     x(6)=eps(2)=int(e2)dt
c---- i=1 --------------------------------------------------------------
      xdot(1)=(x(1)*d(2,1)*s-x(2)*d(1,2)*dcos(de)+x(4)*d(1,2)*dsin(de)
     >+s*(e(1)-e(2))*(x(2)*dsin(de)+x(4)*dcos(de))
     >)/(1.0d0-s**2.0d0) 

      xdot(3)=(x(3)*d(2,1)*s-x(2)*d(1,2)*dsin(de)-x(4)*d(1,2)*dcos(de)
     >+s*(e(1)-e(2))*(x(4)*dsin(de)-x(2)*dcos(de))
     >)/(1.0d0-s**2.0d0) 

      xdot(5)=e(1)
c----i=2 ---------------------------------------------------------------
      xdot(2)=(x(2)*d(1,2)*s-x(1)*d(2,1)*dcos(-de)+x(3)*d(2,1)*dsin(-de)
     >-s**2*(e(1)-e(2))*x(4))/(1.0d0-s**2.0d0) 

      xdot(4)=(x(4)*d(1,2)*s-x(1)*d(2,1)*dsin(-de)-x(3)*d(2,1)*dcos(-de)
     >+s**2*(e(1)-e(2))*x(2))/(1.0d0-s**2.0d0) 

      xdot(6)=e(2)
       return
       end
