C     ==================================================================
      SUBROUTINE RNL_DK_P(C0,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==                    THE ARRAY DFNL_DK                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'pslo.inc'
      INCLUDE 'nlps.inc'        !NLM NGH
      INCLUDE 'ions.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'response_p.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGWK,NSTATE),SCR(2*NGW,NAX)
C     Variables
      DIMENSION  dtwnl_dk(2*NGW,NHXS,NSX,3),
     &           EIGKR(NGWK,NAT,NKPNT),
     &           ddtwnl_ddk(2*NGW,NHXS,NSX,3,3)
      COMPLEX*16 C00(2*NGW,NSTATE)
      POINTER    (IP_C00,C00)

      COMPLEX*16 CI,ZZERO,ZONE
      PARAMETER  (ZZERO=(0.D0,0.D0),ZONE=(1.D0,0.D0))
      CHARACTER  TAG*30
      DIMENSION  DFNL_DK(2,NAT,NHXS,NSTATE,3),
     &           DDFNL_DDK(2,NAT,NHXS,NSTATE,3,3)

      REAL*8     CIR,CII,ER,EI,T
      INTEGER    ISUB,ISA0,IS,IV,ISA,IA,IG,
     &           LRNL_DK_P, IDIR,IDIR2, ISTATE

C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('  RNL_DK_P',ISUB)
C     SCR test.
      CALL GIVE_SCR_RNL_DK_P(LRNL_DK_P,TAG,NSTATE)
      CALL TEST_SCR('RNL_DK_P',TAG,LSCR,LRNL_DK_P)
C     ==--------------------------------------------------------------==

      CALL MEMORY(IP_C00,2*2*NGW*NSTATE,'C00')
      CALL AZZERO(C00,2*2*NGW*NSTATE)

      CALL AZZERO(SCR,4*NGW*NAX)
!$OMP parallel do private(ISTATE,IG)
      DO ISTATE = 1, NSTATE
#ifdef _BGL 
!IBM* ASSERT (ITERCNT(1000))
!IBM* INDEPENDENT
#endif
         DO IG = 1, NGW
            C00(IG,ISTATE) = C0(IG,ISTATE)
            C00(IG+NGW,ISTATE) = DCONJG(C0(IG,ISTATE))
         ENDDO
      ENDDO

      imagp = 2

      IF(NGW.EQ.0) GOTO 1000
      DO IDIR = 1,3
         ISA0=0
         DO IS=1,NSP
            DO IV=1,NGH(IS)
               CI=(0.0D0,-1.0D0)**NGHTOL(IV,IS)
               CIR=DREAL(CI)
               CII=DIMAG(CI)
               DO IA=1,NA(IS)
                  ISA=ISA0+IA
C     Make use of the special structure of CI
                  IF(DABS(CIR).GT.0.5D0) THEN
C     CI is real
!$OMP parallel do private(IG,ER,EI,T)
                     DO IG=1,NGW
                        ER=DREAL(EIGKR(IG,ISA,1))
                        EI=DIMAG(EIGKR(IG,ISA,1))
                        T=DTWNL_DK(IG,IV,IS,IDIR)*CIR
                        SCR(IG,IA)=DCMPLX(T*ER,T*EI)
                     ENDDO
C     =============== and the part from NGW+1 to 2*NGW
!$OMP parallel do private(IG,ER,EI,T)
                     DO IG=1,NGW
                        ER=DREAL(EIGKR(IG,ISA,1))
                        EI=-DIMAG(EIGKR(IG,ISA,1))
                        T=DTWNL_DK(NGW+IG,IV,IS,IDIR)*CIR
                        SCR(NGW+IG,IA)=DCMPLX(T*ER,T*EI)
                     ENDDO
                  ELSE
C     CI is imaginary
!$OMP parallel do private(IG,ER,EI,T)
                     DO IG=1,NGW
                        ER=DREAL(EIGKR(IG,ISA,1))
                        EI=DIMAG(EIGKR(IG,ISA,1))
                        T=DTWNL_DK(IG,IV,IS,IDIR)*CII
                        SCR(IG,IA)=DCMPLX(-T*EI,T*ER)
                     ENDDO

C     =============== and the part from NGW+1 to 2*NGW
!$OMP parallel do private(IG,ER,EI,T)
                     DO IG=1,NGW
                        ER=DREAL(EIGKR(IG,ISA,1))
                        EI=-DIMAG(EIGKR(IG,ISA,1))
                        T=DTWNL_DK(NGW+IG,IV,IS,IDIR)*CII
                        SCR(NGW+IG,IA)=DCMPLX(-T*EI,T*ER)
                     ENDDO

                  ENDIF
                  IF(GEQ0) THEN
c                     SCR(1,IA)=0.5D0*SCR(1,IA)
                    SCR(NGW+1,IA)=DCMPLX(0.D0,0.D0)
                  ENDIF
               ENDDO

               CALL ZGEMM('C','N',NA(IS),NSTATE,2*NGW,ZONE,SCR(1,1),
     &              2*NGW,C00(1,1),2*NGW,ZZERO,
     &              DFNL_DK(1,ISA0+1,IV,1,IDIR),NAT*NHXS)

            ENDDO
            ISA0=ISA0+NA(IS)
         ENDDO

#ifdef PARALLEL
         CALL SUMFNL(DFNL_DK(1,1,1,1,IDIR),SCR,LSCR,NSTATE)
#endif

      ENDDO       ! IDIR


C     ****************************
C         SECOND DERIVATIVES
C     ****************************


C     Form Factor relative to the second derivatives
      DO IDIR = 1,3
         DO IDIR2 = IDIR,3
            ISA0=0
            DO IS=1,NSP
               DO IV=1,NGH(IS)
                  CI=(0.0D0,-1.0D0)**NGHTOL(IV,IS)
                  CIR=DREAL(CI)
                  CII=DIMAG(CI)
                  DO IA=1,NA(IS)
                     ISA=ISA0+IA
C     Make use of the special structure of CI
                     IF(DABS(CIR).GT.0.5D0) THEN
C     CI is real
!$OMP parallel do private(IG,ER,EI,T)
                        DO IG=1,NGW
                           ER=DREAL(EIGKR(IG,ISA,1))
                           EI=DIMAG(EIGKR(IG,ISA,1))
                           T=DDTWNL_DDK(IG,IV,IS,IDIR,IDIR2)*CIR
                           SCR(IG,IA)=DCMPLX(T*ER,T*EI)
                        ENDDO
C     =============== and the part from NGW+1 to 2*NGW
!$OMP parallel do private(IG,ER,EI,T)
                        DO IG=1,NGW
                           ER=DREAL(EIGKR(IG,ISA,1))
                           EI=-DIMAG(EIGKR(IG,ISA,1))
                           T=DDTWNL_DDK(NGW+IG,IV,IS,IDIR,IDIR2)*CIR
                           SCR(NGW+IG,IA)=DCMPLX(T*ER,T*EI)
                        ENDDO
                     ELSE
C     CI is imaginary
!$OMP parallel do private(IG,ER,EI,T)
                        DO IG=1,NGW
                           ER=DREAL(EIGKR(IG,ISA,1))
                           EI=DIMAG(EIGKR(IG,ISA,1))
                           T=DDTWNL_DDK(IG,IV,IS,IDIR,IDIR2)*CII
                           SCR(IG,IA)=DCMPLX(-T*EI,T*ER)
                        ENDDO
C     =============== and the part from NGW+1 to 2*NGW
!$OMP parallel do private(IG,ER,EI,T)
                        DO IG=1,NGW
                           ER=DREAL(EIGKR(IG,ISA,1))
                           EI=-DIMAG(EIGKR(IG,ISA,1))
                           T=DDTWNL_DDK(NGW+IG,IV,IS,IDIR,IDIR2)*CII
                           SCR(NGW+IG,IA)=DCMPLX(-T*EI,T*ER)
                        ENDDO
                        
                     ENDIF
                     IF(GEQ0) THEN
c                        SCR(1,IA)=0.5D0*SCR(1,IA)
                       SCR(NGW+1,IA)=DCMPLX(0.D0,0.D0)
                     ENDIF
                  ENDDO
                  
                  CALL ZGEMM('C','N',NA(IS),NSTATE,2*NGW,ZONE,SCR(1,1),
     &                 2*NGW,C00(1,1),2*NGW,ZZERO,
     &                 DDFNL_DDK(1,ISA0+1,IV,1,IDIR,IDIR2),NAT*NHXS)
                  
                  
               ENDDO
               ISA0=ISA0+NA(IS)
            ENDDO
            
#ifdef PARALLEL
            CALL SUMFNL(DDFNL_DDK(1,1,1,1,IDIR,IDIR2),SCR,LSCR,NSTATE)
#endif
            CALL DCOPY(2*NAT*NHXS*NSTATE,DDFNL_DDK(1,1,1,1,IDIR,IDIR2),
     &           1,DDFNL_DDK(1,1,1,1,IDIR2,IDIR),1)
         ENDDO
      ENDDO
 1000 CONTINUE

C     ==-------------------------------------------------------------==      
      imagp =1

      CALL FREEM(IP_C00) 
      CALL TIHALT('  RNL_DK_P',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RNL_DK_P(LRNL_DK_P,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGWK NAX
      INCLUDE 'nlps.inc'        !NLM
C     Arguments
      INTEGER   LRNL_DK_P,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LSUMFNL
C     ==--------------------------------------------------------------==
      IF(NLM.EQ.0) THEN
        LRNL_DK_P=0
      ELSE
        lsumfnl = 1
        LRNL_DK_P=MAX(4*NGWK*NAX,LSUMFNL)
        TAG   ='MAX(2*NGWK*NAX,LSUMFNL)'
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

