C     ==================================================================
      SUBROUTINE RNLFL(FION,GAMMA,NSTATE,NKPOINT)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE FORCE ON THE IONIC DEGREES OF FREEDOM DUE TO THE        ==
C     ==  ORTHOGONALITY CONSTRAINED IN VANDERBILT PSEUDO-POTENTIALS   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cppt.inc'
C     Arguments
      INTEGER NSTATE,NKPOINT
      REAL*8  FION(3,NAX,*),GAMMA(NSTATE,*)
C     Variables
      REAL*8  DFNL(IMAGP,NAT,NHXS,3,NDFNL,*),
     &        FNL(IMAGP,NAT,NHXS,NSTATE,*),
     &        TEMP,TK
      INTEGER ISUB,IK,K,ISA0,IS,IV,JV,II,I,J,IA,ISA
C     ==--------------------------------------------------------------==
      CALL TISET('     RNLFL',ISUB)
      IF(TFDIST) CALL STOPGM('FNL_RSPACE','TFDIST NOT IMPLEMENTED')
      IF(IMAGP.EQ.2)CALL STOPGM('RNLFL','K-POINT NOT IMPLEMENTED')
      DO IK=1,NKPOINT
        DO K=1,3
          ISA0=0
          DO IS=1,NSP
            IF(TVAN(IS)) THEN
              DO IV=1,NGH(IS)
                DO JV=1,NGH(IS)
                  TEMP=QQ(IV,JV,IS)
                  IF(ABS(TEMP).GT.1.D-5) THEN
                    DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                      II=I-NST12(MEPOS,1)+1
                      DO J=1,NSTATE
                        TK=TEMP*GAMMA(I,J)
                        DO IA=1,NA(IS)
                          ISA=ISA0+IA
                          FION(K,IA,IS)=FION(K,IA,IS)-TK*
     *                         DFNL(1,ISA,JV,K,II,IK)*FNL(1,ISA,IV,J,IK)
                        ENDDO
                      ENDDO
                    ENDDO
                    DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                      II=I-NST12(MEPOS,1)+1
                      DO J=1,NSTATE
                        TK=TEMP*GAMMA(J,I)
                        DO IA=1,NA(IS)
                          ISA=ISA0+IA
                          FION(K,IA,IS)=FION(K,IA,IS)-TK*
     *                         DFNL(1,ISA,IV,K,II,IK)*FNL(1,ISA,JV,J,IK)
                        ENDDO
                      ENDDO
                    ENDDO
                  ENDIF
                ENDDO
              ENDDO
            ENDIF
            ISA0=ISA0+NA(IS)
          ENDDO
        ENDDO
      ENDDO
      CALL TIHALT('     RNLFL',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
