C     ==================================================================
      SUBROUTINE RNLFOR(FION,F,WK,NSTATE,NKPOINT)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE NON-LOCAL POTENTIAL CONTRIBUTION TO THE FORCE ON THE    ==
C     ==  IONIC DEGREES OF FREEDOM                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'        !NLM
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      INTEGER NSTATE,NKPOINT
      REAL*8  FION(3,NAX,NSX),F(NSTATE,NKPOINT),WK(NKPOINT)
C     Variables
      DIMENSION FNL2(IMAGP,NAT,NHXS,LDF2,NKPOINT)
      REAL*8  DFNL(IMAGP,NAT,NHXS,3,NDFNL,NKPOINT),
     &        FNL(IMAGP,LDF1,NHXS,NSTATE,NKPOINT),
     &        WEIGHT,TEMP,TT,TDBL
      INTEGER ISUB,IK,ISA0,IS,IV,JV,I,II,ISPIN,ISA,L,KI,LI,L2,LJ,KJ,IA
      real*8  wk1_1,wk1_2,wk1_3,wk2_1,wk2_2,wk2_3
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('    RNLFOR',ISUB)
      DO IK=1,NKPOINT
          ISA0=0
          DO IS=1,NSP
            IF(TVAN(IS)) THEN
C             Vanderbild pp
              DO IV=1,NGH(IS)
                DO JV=IV,NGH(IS)
                  TDBL=1.D0
                  IF(IV.NE.JV) TDBL=2.0D0
                  DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                    II=I-NST12(MEPOS,1)+1
                    ISPIN=1
                    WEIGHT=WK(IK)*F(I,IK)
                    IF(ABS(WEIGHT).GT.1.D-12) THEN
                      IF(TLSD.AND.I.GT.NSUP) ISPIN=2
                      IF(TFDIST) THEN
                        IF(IMAGP.EQ.2) THEN
!$OMP parallel do private(IA,ISA,TEMP,wk1_1,wk1_2,wk1_3)
!$OMP+            private(wk2_1,wk2_2,wk2_3)
                          DO IA=1,NA(IS)
                            ISA=ISA0+IA
                            TEMP=DVAN(IV,JV,IS)+DEEQ(ISA,JV,IV,ISPIN)
                            wk1_1=dfnl(1,isa,jv,1,ii,ik)
     &                           *fnl2(1,isa,iv,  ii,ik)
     &                           +dfnl(2,isa,jv,1,ii,ik)
     &                           *fnl2(2,isa,iv,  ii,ik)
                            wk1_2=dfnl(1,isa,jv,2,ii,ik)
     &                           *fnl2(1,isa,iv,  ii,ik)
     &                           +dfnl(2,isa,jv,2,ii,ik)
     &                           *fnl2(2,isa,iv,  ii,ik)
                            wk1_3=dfnl(1,isa,jv,3,ii,ik)
     &                           *fnl2(1,isa,iv,  ii,ik)
     &                           +dfnl(2,isa,jv,3,ii,ik)
     &                           *fnl2(2,isa,iv,  ii,ik)
                            wk2_1=dfnl(1,isa,iv,1,ii,ik)
     &                           *fnl2(1,isa,jv,  ii,ik)
     &                           +dfnl(2,isa,iv,1,ii,ik)
     &                           *fnl2(2,isa,jv,  ii,ik)
                            wk2_2=dfnl(1,isa,iv,2,ii,ik)
     &                           *fnl2(1,isa,jv,  ii,ik)
     &                           +dfnl(2,isa,iv,2,ii,ik)
     &                           *fnl2(2,isa,jv,  ii,ik)
                            wk2_3=dfnl(1,isa,iv,3,ii,ik)
     &                           *fnl2(1,isa,jv,  ii,ik)
     &                           +dfnl(2,isa,iv,3,ii,ik)
     &                           *fnl2(2,isa,jv,  ii,ik)
                            fion(1,ia,is)=fion(1,ia,is)
     &                                   -weight*tdbl*temp*(wk1_1+wk2_1)
                            fion(2,ia,is)=fion(2,ia,is)
     &                                   -weight*tdbl*temp*(wk1_2+wk2_2)
                            fion(3,ia,is)=fion(3,ia,is)
     &                                   -weight*tdbl*temp*(wk1_3+wk2_3)
                          ENDDO
                        ELSE
!$OMP parallel do private(IA,ISA,TEMP,wk1_1,wk1_2,wk1_3)
!$OMP+            private(wk2_1,wk2_2,wk2_3)
                          DO IA=1,NA(IS)
                            ISA=ISA0+IA
                            TEMP=DVAN(IV,JV,IS)+DEEQ(ISA,JV,IV,ISPIN)
                            wk1_1=dfnl(1,isa,jv,1,ii,ik) 
     &                           *fnl2(1,isa,iv,  ii,ik)
                            wk1_2=dfnl(1,isa,jv,2,ii,ik) 
     &                           *fnl2(1,isa,iv,  ii,ik)
                            wk1_3=dfnl(1,isa,jv,3,ii,ik) 
     &                           *fnl2(1,isa,iv,  ii,ik)
                            wk2_1=dfnl(1,isa,iv,1,ii,ik) 
     &                           *fnl2(1,isa,jv,  ii,ik)
                            wk2_2=dfnl(1,isa,iv,2,ii,ik) 
     &                           *fnl2(1,isa,jv,  ii,ik)
                            wk2_3=dfnl(1,isa,iv,3,ii,ik) 
     &                           *fnl2(1,isa,jv,  ii,ik)
                            fion(1,ia,is)=fion(1,ia,is)
     &                                   -weight*tdbl*temp*(wk1_1+wk2_1)
                            fion(2,ia,is)=fion(2,ia,is)
     &                                   -weight*tdbl*temp*(wk1_2+wk2_2)
                            fion(3,ia,is)=fion(3,ia,is)
     &                                   -weight*tdbl*temp*(wk1_3+wk2_3)
                          ENDDO
                        ENDIF
                      ELSE
                        IF(IMAGP.EQ.2) THEN
!$OMP parallel do private(IA,ISA,TEMP,wk1_1,wk1_2,wk1_3)
!$OMP+            private(wk2_1,wk2_2,wk2_3)
                          DO IA=1,NA(IS)
                            ISA=ISA0+IA
                            TEMP=DVAN(IV,JV,IS)+DEEQ(ISA,JV,IV,ISPIN)
                            wk1_1=dfnl(1,isa,jv,1,ii,ik)
     &                            *fnl(1,isa,iv,   i,ik)
     &                           +dfnl(2,isa,jv,1,ii,ik)
     &                            *fnl(2,isa,iv,   i,ik)
                            wk1_2=dfnl(1,isa,jv,2,ii,ik)
     &                            *fnl(1,isa,iv,   i,ik)
     &                           +dfnl(2,isa,jv,2,ii,ik)
     &                            *fnl(2,isa,iv,   i,ik)
                            wk1_3=dfnl(1,isa,jv,3,ii,ik)
     &                            *fnl(1,isa,iv,   i,ik)
     &                           +dfnl(2,isa,jv,3,ii,ik)
     &                            *fnl(2,isa,iv,   i,ik)
                            wk2_1=dfnl(1,isa,iv,1,ii,ik)
     &                            *fnl(1,isa,jv,   i,ik)
     &                           +dfnl(2,isa,iv,1,ii,ik)
     &                            *fnl(2,isa,jv,   i,ik)
                            wk2_2=dfnl(1,isa,iv,2,ii,ik)
     &                            *fnl(1,isa,jv,   i,ik)
     &                           +dfnl(2,isa,iv,2,ii,ik)
     &                            *fnl(2,isa,jv,   i,ik)
                            wk2_2=dfnl(1,isa,iv,3,ii,ik)
     &                            *fnl(1,isa,jv,   i,ik)
     &                           +dfnl(2,isa,iv,3,ii,ik)
     &                            *fnl(2,isa,jv,   i,ik)
                            fion(1,ia,is)=fion(1,ia,is)
     &                                   -weight*tdbl*temp*(wk1_1+wk2_1)
                            fion(2,ia,is)=fion(2,ia,is)
     &                                   -weight*tdbl*temp*(wk1_2+wk2_2)
                            fion(3,ia,is)=fion(3,ia,is)
     &                                   -weight*tdbl*temp*(wk1_3+wk2_3)
                          ENDDO
                        ELSE
!$OMP parallel do private(IA,ISA,TEMP,wk1_1,wk1_2,wk1_3)
!$OMP+            private(wk2_1,wk2_2,wk2_3)
                          DO IA=1,NA(IS)
                            ISA=ISA0+IA
                            TEMP=DVAN(IV,JV,IS)+DEEQ(ISA,JV,IV,ISPIN)
                            wk1_1=dfnl(1,isa,jv,1,ii,ik)
     &                            *fnl(1,isa,iv,   i,ik)
                            wk1_2=dfnl(1,isa,jv,2,ii,ik)
     &                            *fnl(1,isa,iv,   i,ik)
                            wk1_3=dfnl(1,isa,jv,3,ii,ik)
     &                            *fnl(1,isa,iv,   i,ik)
                            wk2_1=dfnl(1,isa,iv,1,ii,ik)
     &                            *fnl(1,isa,jv,   i,ik)
                            wk2_2=dfnl(1,isa,iv,2,ii,ik)
     &                            *fnl(1,isa,jv,   i,ik)
                            wk2_3=dfnl(1,isa,iv,3,ii,ik)
     &                            *fnl(1,isa,jv,   i,ik)
                            fion(1,ia,is)=fion(1,ia,is)
     &                                   -weight*tdbl*temp*(wk1_1+wk2_1)
                            fion(2,ia,is)=fion(2,ia,is)
     &                                   -weight*tdbl*temp*(wk1_2+wk2_2)
                            fion(3,ia,is)=fion(3,ia,is)
     &                                   -weight*tdbl*temp*(wk1_3+wk2_3)
                          ENDDO
                        ENDIF
                      ENDIF
                    ENDIF
                  ENDDO
                ENDDO
              ENDDO
            ELSEIF(TSGP(IS)) THEN
C             Stefan Goedecker pp
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                      WEIGHT=WK(IK)*F(I,IK)
                      IF(ABS(WEIGHT).GT.1.D-12) THEN
                        TT=2.0D0*WEIGHT*HLSG(KI,KJ,L,IS)
                        II=I-NST12(MEPOS,1)+1
                        IF(IMAGP.EQ.2) THEN
                          IF(TFDIST) THEN
C$OMP parallel do private(IA,ISA)
                            DO IA=1,NA(IS)
                              ISA=ISA0+IA
                              fion(1,ia,is)=fion(1,ia,is)-tt*
     &                             dfnl(1,isa,iv,1,ii,ik)*
     &                             fnl2(1,isa,jv,  ii,ik)-tt*
     &                             dfnl(2,isa,iv,1,ii,ik)*
     &                             fnl2(2,isa,jv,  ii,ik)
                              fion(2,ia,is)=fion(2,ia,is)-tt*
     &                             dfnl(1,isa,iv,2,ii,ik)*
     &                             fnl2(1,isa,jv,  ii,ik)-tt*
     &                             dfnl(2,isa,iv,2,ii,ik)*
     &                             fnl2(2,isa,jv,  ii,ik)
                              fion(3,ia,is)=fion(3,ia,is)-tt*
     &                             dfnl(1,isa,iv,3,ii,ik)*
     &                             fnl2(1,isa,jv,  ii,ik)-tt*
     &                             dfnl(2,isa,iv,3,ii,ik)*
     &                             fnl2(2,isa,jv,  ii,ik)
                            ENDDO
                          ELSE
C$OMP parallel do private(IA,ISA)
                            DO IA=1,NA(IS)
                              ISA=ISA0+IA
                              fion(1,ia,is)=fion(1,ia,is)-tt*
     &                             dfnl(1,isa,iv,1,ii,ik)*
     &                             fnl2(1,isa,jv,   i,ik)-tt*
     &                             dfnl(2,isa,iv,1,ii,ik)*
     &                             fnl2(2,isa,jv,   i,ik)
                              fion(2,ia,is)=fion(2,ia,is)-tt*
     &                             dfnl(1,isa,iv,2,ii,ik)*
     &                             fnl2(1,isa,jv,   i,ik)-tt*
     &                             dfnl(2,isa,iv,2,ii,ik)*
     &                             fnl2(2,isa,jv,   i,ik)
                              fion(3,ia,is)=fion(3,ia,is)-tt*
     &                             dfnl(1,isa,iv,3,ii,ik)*
     &                             fnl2(1,isa,jv,   i,ik)-tt*
     &                             dfnl(2,isa,iv,3,ii,ik)*
     &                             fnl2(2,isa,jv,   i,ik)
                            ENDDO
                          ENDIF
                        ELSE
                          IF(TFDIST) THEN
C$OMP parallel do private(IA,ISA)
                            DO IA=1,NA(IS)
                              ISA=ISA0+IA
                              fion(1,ia,is)=fion(1,ia,is)-tt*
     &                             dfnl(1,isa,iv,1,ii,ik)*
     &                             fnl2(1,isa,jv,  ii,ik)
                              fion(2,ia,is)=fion(2,ia,is)-tt*
     &                             dfnl(1,isa,iv,2,ii,ik)*
     &                             fnl2(1,isa,jv,  ii,ik)
                              fion(3,ia,is)=fion(3,ia,is)-tt*
     &                             dfnl(1,isa,iv,3,ii,ik)*
     &                             fnl2(1,isa,jv,  ii,ik)
                            ENDDO
                          ELSE
C$OMP parallel do private(IA,ISA)
                            DO IA=1,NA(IS)
                              ISA=ISA0+IA
                              fion(1,ia,is)=fion(1,ia,is)-tt*
     &                             dfnl(1,isa,iv,1,ii,ik)*
     &                             fnl2(1,isa,jv,   i,ik)
                              fion(2,ia,is)=fion(2,ia,is)-tt*
     &                             dfnl(1,isa,iv,2,ii,ik)*
     &                             fnl2(1,isa,jv,   i,ik)
                              fion(3,ia,is)=fion(3,ia,is)-tt*
     &                             dfnl(1,isa,iv,3,ii,ik)*
     &                             fnl2(1,isa,jv,   i,ik)
                            ENDDO
                          ENDIF
                        ENDIF
                      ENDIF
                    ENDDO
                  ENDIF
                ENDDO
              ENDDO
            ELSE
C             Other pp (numeric)
              DO IV=1,NGH(IS)
                TEMP=2.D0*WSG(IS,IV)
                DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                  WEIGHT=WK(IK)*F(I,IK)
                  IF(ABS(WEIGHT).GT.1.D-12) THEN
                    II=I-NST12(MEPOS,1)+1
                    IF(TFDIST) THEN
                      IF(IMAGP.EQ.2) THEN
!$OMP parallel do private(IA,ISA,wk1_1,wk1_2,wk1_3)
                        DO IA=1,NA(IS)
                          ISA=ISA0+IA
                          wk1_1=dfnl(1,isa,iv,1,ii,ik)
     &                         *fnl2(1,isa,iv,  ii,ik)
     &                         +dfnl(2,isa,iv,1,ii,ik)
     &                         *fnl2(2,isa,iv,  ii,ik)
                          wk1_2=dfnl(1,isa,iv,2,ii,ik)
     &                         *fnl2(1,isa,iv,  ii,ik)
     &                         +dfnl(2,isa,iv,2,ii,ik)
     &                         *fnl2(2,isa,iv,  ii,ik)
                          wk1_3=dfnl(1,isa,iv,3,ii,ik)
     &                         *fnl2(1,isa,iv,  ii,ik)
     &                         +dfnl(2,isa,iv,3,ii,ik)
     &                         *fnl2(2,isa,iv,  ii,ik)
                          fion(1,ia,is)=fion(1,ia,is)-temp*weight*wk1_1
                          fion(2,ia,is)=fion(2,ia,is)-temp*weight*wk1_2
                          fion(3,ia,is)=fion(3,ia,is)-temp*weight*wk1_3
                        ENDDO
                      ELSE
!$OMP parallel do private(IA,ISA,wk1_1,wk1_2,wk1_3)
                        DO IA=1,NA(IS)
                          ISA=ISA0+IA
                          wk1_1=dfnl(1,isa,iv,1,ii,ik)
     &                         *fnl2(1,isa,iv,  ii,ik)
                          wk1_2=dfnl(1,isa,iv,2,ii,ik)
     &                         *fnl2(1,isa,iv,  ii,ik)
                          wk1_3=dfnl(1,isa,iv,3,ii,ik)
     &                         *fnl2(1,isa,iv,  ii,ik)
                          fion(1,ia,is)=fion(1,ia,is)-temp*weight*wk1_1
                          fion(2,ia,is)=fion(2,ia,is)-temp*weight*wk1_2
                          fion(3,ia,is)=fion(3,ia,is)-temp*weight*wk1_3
                        ENDDO
                      ENDIF
                    ELSE
                      IF(IMAGP.EQ.2) THEN
!$OMP parallel do private(IA,ISA,wk1_1,wk1_2,wk1_3)
                        DO IA=1,NA(IS)
                          ISA=ISA0+IA
                          wk1_1=dfnl(1,isa,iv,1,ii,ik)
     &                         *fnl2(1,isa,iv,   i,ik)
     &                         +dfnl(2,isa,iv,1,ii,ik)
     &                         *fnl2(2,isa,iv,   i,ik)
                          wk1_2=dfnl(1,isa,iv,2,ii,ik)
     &                         *fnl2(1,isa,iv,   i,ik)
     &                         +dfnl(2,isa,iv,2,ii,ik)
     &                         *fnl2(2,isa,iv,   i,ik)
                          wk1_3=dfnl(1,isa,iv,3,ii,ik)
     &                         *fnl2(1,isa,iv,   i,ik)
     &                         +dfnl(2,isa,iv,3,ii,ik)
     &                         *fnl2(2,isa,iv,   i,ik)
                          fion(1,ia,is)=fion(1,ia,is)-temp*weight*wk1_1
                          fion(2,ia,is)=fion(2,ia,is)-temp*weight*wk1_2
                          fion(3,ia,is)=fion(3,ia,is)-temp*weight*wk1_3
                        ENDDO
                      ELSE
!$OMP parallel do private(IA,ISA,wk1_1,wk1_2,wk1_3)
                        DO IA=1,NA(IS)
                          ISA=ISA0+IA
                          wk1_1=dfnl(1,isa,iv,1,ii,ik)
     &                         *fnl2(1,isa,iv,   i,ik)
                          wk1_2=dfnl(1,isa,iv,2,ii,ik)
     &                         *fnl2(1,isa,iv,   i,ik)
                          wk1_3=dfnl(1,isa,iv,3,ii,ik)
     &                         *fnl2(1,isa,iv,   i,ik)
                          fion(1,ia,is)=fion(1,ia,is)-temp*weight*wk1_1
                          fion(2,ia,is)=fion(2,ia,is)-temp*weight*wk1_2
                          fion(3,ia,is)=fion(3,ia,is)-temp*weight*wk1_3
                        ENDDO
                      ENDIF
                    ENDIF
                  ENDIF
                ENDDO
              ENDDO
            ENDIF
            ISA0 = ISA0 + NA(IS)
          ENDDO
      ENDDO
      CALL TIHALT('    RNLFOR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RCASFOR(FION)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE NON-LOCAL POTENTIAL CONTRIBUTION TO THE FORCE ON THE    ==
C     ==  IONIC DEGREES OF FREEDOM                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'        !NLM
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      REAL*8  FION(3,NAX,NSX)
C     Variables
      REAL*8  DFNL(NAT,NHXS,3,*),FNL(LDF1,NHXS,*),TT
      INTEGER ISUB,ISA0,IS,IV,JV,II,ISA,L,KI,LI,L2,LJ,KJ,
     &        K,IA,IATL
      REAL*8  DFAB(NAT,NHXS,2)
      POINTER (IP_DFAB,DFAB)
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('   RCASFOR',ISUB)
      CALL MEMORY(DFAB,2*NAT,"DFAB")
      DO K=1,3
        CALL AZZERO(DFAB,2*NAT)
        IF(IALPHA.GE.NST12(MEPOS,1).AND.
     &     IALPHA.LE.NST12(MEPOS,2) ) THEN
          II=IALPHA-NST12(MEPOS,1)+1
          CALL DCOPY(NHXS*NAT,DFNL(1,1,K,II),1,DFAB(1,1,1),1)
        ENDIF
        IF(IBETA.GE.NST12(MEPOS,1).AND.
     &     IBETA.LE.NST12(MEPOS,2) ) THEN
          II=IBETA-NST12(MEPOS,1)+1
          CALL DCOPY(NHXS*NAT,DFNL(1,1,K,II),1,DFAB(1,1,2),1)
        ENDIF
        CALL GLOSUM(2*NAT*NHXS,DFAB)
        ISA0=0
        DO IS=1,NSP
          IF(TVAN(IS)) THEN
C           Vanderbild pp
            CALL STOPGM("RCASFOR","VDB NOT IMPLEMENTED")
          ELSEIF(TSGP(IS)) THEN
C           Stefan Goedecker pp
            DO IV=1,NGH(IS)
              L=NGHTOL(IV,IS)+1
              KI=LFVAL(IV,IS)
              LI=LPVAL(IV,IS)
              DO JV=1,NGH(IS)
                L2=NGHTOL(JV,IS)+1
                LJ=LPVAL(JV,IS)
                IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
                  KJ=LFVAL(JV,IS)
                  TT=HLSG(KI,KJ,L,IS)
                  DO IA=1,NA(IS)
                    ISA=ISA0+IA
                    IF(TFDIST) THEN
                      IATL=ISA-IPEPT(1,MEPOS)+1
                      FION(K,IA,IS)=FION(K,IA,IS)-0.5D0*TT*(
     &                  DFAB(ISA,IV,1)*FNL(IATL,JV,IBETA)
     &                 +DFAB(ISA,IV,2)*FNL(IATL,JV,IALPHA)
     &                 +DFAB(ISA,JV,1)*FNL(IATL,IV,IBETA)
     &                 +DFAB(ISA,JV,2)*FNL(IATL,IV,IALPHA))
                    ELSE
                      FION(K,IA,IS)=FION(K,IA,IS)-TT*(
     &                  DFAB(ISA,IV,1)*FNL(ISA,JV,IBETA)
     &                 +DFAB(ISA,IV,2)*FNL(ISA,JV,IALPHA)
     &                 +DFAB(ISA,JV,1)*FNL(ISA,IV,IBETA)
     &                 +DFAB(ISA,JV,2)*FNL(ISA,IV,IALPHA))
                    ENDIF
                  ENDDO
                ENDIF
              ENDDO
            ENDDO
          ELSE
C           Other pp (numeric)
            DO IV=1,NGH(IS)
              DO IA=1,NA(IS)
                ISA=ISA0+IA
                IF(ISA.GE.IPEPT(1,MEPOS).AND.
     &             ISA.LE.IPEPT(2,MEPOS)) THEN
                  IF(TFDIST) THEN
                    IATL=ISA-IPEPT(1,MEPOS)+1
                    FION(K,IA,IS)=FION(K,IA,IS)-WSG(IS,IV)*
     &                  (DFAB(ISA,IV,1)*FNL(IATL,IV,IBETA)
     &                  +FNL(IATL,IV,IALPHA)*DFAB(ISA,IV,2))
                  ELSE
                    FION(K,IA,IS)=FION(K,IA,IS)-WSG(IS,IV)*
     &                  (DFAB(ISA,IV,1)*FNL(ISA,IV,IBETA)
     &                  +FNL(ISA,IV,IALPHA)*DFAB(ISA,IV,2))
                  ENDIF
                ENDIF
              ENDDO
            ENDDO
          ENDIF
          ISA0 = ISA0 + NA(IS)
        ENDDO
      ENDDO
      CALL FREEM(IP_DFAB)
      CALL TIHALT('   RCASFOR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
