C     ==================================================================
      SUBROUTINE NLIN(IS,RS1,RS2)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'sgpp.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'qspl.inc'
C     Arguments
      INTEGER IS
      REAL*8  RS1(NSPLPO),RS2(NSPLPO)
C     Variables
      INTEGER ISUB
C     ==--------------------------------------------------------------==
      CALL TISET('      NLIN',ISUB)
      IF(TSGP(IS)) THEN
        IF(TNUM(IS)) THEN
          CALL UNLIN(IS,RS1,RS2)
        ELSE
          CALL SGNLIN(IS,RS1,RS2)
        ENDIF
      ELSE
        CALL GNLIN(IS,RS1,RS2)
      ENDIF
      CALL TIHALT('      NLIN',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SGNLIN(IS,RS1,RS2)
C     ==--------------------------------------------------------------==
C     ==   COMPUTES TWNS FOR NORMCONSERVING PSEUDO-POTENTIALS         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'sgpp.inc'
C     Arguments
      INTEGER   IS
      REAL*8    RS1(NSPLPO),RS2(NSPLPO)
C     Variables
      DIMENSION TWNS(NSPLPO,2,NHXS,NSX),GGNG(NSPLPO)
      REAL*8    RC2,GGL,GG,GGR
      INTEGER   IV,L,IL,K,IERR
C     ==--------------------------------------------------------------==
      DO IV=1,NGH(IS)
        CALL AZZERO(TWNS(1,1,IV,IS),NSPLPO)
        L=NGHTOL(IV,IS)+1
        RC2=RCNL(L,IS)**2
C$OMP parallel do private(IL,GG,GGL)
        DO IL=NSPLPA,NSPLPE
          GGL=GGNG(IL)
          GG=GGL*TPIBA2
          RS1(IL)=EXP(-0.5D0*GG*RC2)*PI**1.25D0
        ENDDO
        K=LFVAL(IV,IS)
        IF(L.EQ.1) THEN
          IF(K.EQ.1) THEN
C$OMP parallel do private(IL,GG)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              TWNS(IL,1,IV,IS)=4.D0*RCNL(1,IS)
     &             *SQRT(2.D0*RCNL(1,IS))*RS1(IL)
            ENDDO
          ELSEIF(K.EQ.2) THEN
C$OMP parallel do private(IL,GG)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              TWNS(IL,1,IV,IS)=8.D0*RCNL(1,IS)
     &             *SQRT(2.D0/15.D0*RCNL(1,IS))*RS1(IL)*(3.D0-GG*RC2)
            ENDDO
          ELSEIF(K.EQ.3) THEN
C$OMP parallel do private(IL,GG,GGR)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              GGR=GG*RC2*0.5D0
              TWNS(IL,1,IV,IS)=64.D0*RCNL(L,IS)
     &             *SQRT(2.D0/945.D0*RCNL(L,IS))*
     *             RS1(IL)*(3.75D0-5.D0*GGR+GGR*GGR)
            ENDDO
          ELSE
            CALL STOPGM('SGNLIN','K NOT PROGRAMMED')
          ENDIF
        ELSEIF(L.EQ.2) THEN
          IF(K.EQ.1) THEN
C$OMP parallel do private(IL,GG)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              TWNS(IL,1,IV,IS)=8.D0*RC2*SQRT(RCNL(2,IS)/3.D0)*
     *                         SQRT(GG)*RS1(IL)
            ENDDO
          ELSEIF(K.EQ.2) THEN
C$OMP parallel do private(IL,GG)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              TWNS(IL,1,IV,IS)=16.D0*RC2*SQRT(RCNL(2,IS)/105.D0)*
     *                           RS1(IL)*SQRT(GG)*(5.D0-GG*RC2)
            ENDDO
          ELSEIF(K.EQ.3) THEN
C$OMP parallel do private(IL,GG,GGR)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              GGR=GG*RC2*0.5D0
              TWNS(IL,1,IV,IS)=128.D0*RC2*SQRT(RCNL(L,IS)/10395.D0)*
     *             RS1(IL)*SQRT(GG)*(8.75D0-7.D0*GGR+GGR*GGR)
            ENDDO
          ELSE
            CALL STOPGM('SGNLIN','K NOT PROGRAMMED')
          ENDIF
       ELSEIF(L.EQ.3) THEN
          IF(K.EQ.1) THEN
C$OMP parallel do private(IL,GG)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              TWNS(IL,1,IV,IS)=8.D0*RC2*RCNL(L,IS)*
     *             SQRT(2.D0*RCNL(L,IS)/15.D0)*RS1(IL)*GG
            ENDDO
          ELSEIF(K.EQ.2) THEN
C$OMP parallel do private(IL,GG,GGR)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              GGR=GG*RC2
              TWNS(IL,1,IV,IS)=16.D0*RC2*RCNL(L,IS)*
     *             SQRT(2.D0*RCNL(L,IS)/945.D0)*RS1(IL)*GG*(7.D0-GGR)
            ENDDO
          ELSEIF(K.EQ.3) THEN
C$OMP parallel do private(IL,GG,GGR)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              GGR=GG*RC2*0.5D0
              TWNS(IL,1,IV,IS)=128.D0*RC2
     &             *SQRT(2.D0*RCNL(L,IS)/135135.D0)*
     *             RCNL(L,IS)*RS1(IL)*GG*(15.75D0-9.D0*GGR+GGR*GGR)
            ENDDO
          ELSE
            CALL STOPGM('SGNLIN','K NOT PROGRAMMED')
          ENDIF
        ELSEIF(L.EQ.4) THEN
          IF(K.EQ.1) THEN
C$OMP parallel do private(IL,GG)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              TWNS(IL,1,IV,IS)=16.D0*RC2*RC2*GG*SQRT(GG)*RS1(IL)
     *             *SQRT(RCNL(L,IS)/105.D0)
            ENDDO
          ELSEIF(K.EQ.2) THEN
C$OMP parallel do private(IL,GG,GGR)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              GGR=GG*RC2
              TWNS(IL,1,IV,IS)=32.D0*RC2*RC2*GG*SQRT(GG)*RS1(IL)
     *             *SQRT(RCNL(L,IS)/10395.D0)*(9.D0-GGR)
            ENDDO
          ELSEIF(K.EQ.3) THEN
C$OMP parallel do private(IL,GG,GGR)
            DO IL=NSPLPA,NSPLPE
              GG=GGNG(IL)*TPIBA2
              GGR=GG*RC2*0.5D0
              TWNS(IL,1,IV,IS)=256.D0*RC2*RC2*GG*SQRT(GG)*RS1(IL)
     *             *SQRT(RCNL(L,IS)/2027025.D0)
     &             *(24.75D0-11.D0*GGR+GGR*GGR)
            ENDDO
          ELSE
            CALL STOPGM('SGNLIN','K NOT PROGRAMMED')
          ENDIF
        ENDIF
        CALL GLOSUM(NSPLPO,TWNS(1,1,IV,IS))
        CALL CURV1(NSPLPO,GGNG,TWNS(1,1,IV,IS),
     *         0.0D0,0.0D0,3,TWNS(1,2,IV,IS),RS2,0.0D0,IERR)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GNLIN(IS,JL,FINT)
C     ==--------------------------------------------------------------==
C     ==   COMPUTES TWNS FOR NORMCONSERVING PSEUDO-POTENTIALS         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
C     Arguments
      INTEGER   IS
      REAL*8    JL(MESHW(IS)),FINT(MESHW(IS))
C     Variables
      DIMENSION TWNS(NSPLPO,2,NHXS,NSX),GGNG(NSPLPO)
      REAL*8    C,GGL,XG,XGR,TMP,
     &          BESSL
      EXTERNAL BESSL
      INTEGER   LOLD,MMAX,IV,L,IR,IERR,NGHL,IL,M
C     ==--------------------------------------------------------------==
      IF(TKB(IS)) THEN
C       Kleinman-Bylander scheme
        LOLD=-1
        MMAX=MESHW(IS)
        C=CLOGW(IS)*FPI
        DO IV=1,NGH(IS)
          L=NGHTOL(IV,IS)+1
          IF(L.EQ.LOLD) THEN
            CALL DCOPY(2*NSPLPO,TWNS(1,1,IV-1,IS),1,TWNS(1,1,IV,IS),1)
          ELSE
            CALL AZZERO(TWNS(1,1,IV,IS),NSPLPO)
            IF(L.NE.LSKIP(IS)) THEN
              DO IL=NSPLPA,NSPLPE
                GGL=GGNG(IL)
                XG=SQRT(GGL)*TPIBA
                CALL BESS(XG,L,MMAX,RW(1,IS),JL)
                DO IR=1,MMAX
                  FINT(IR)=RW(IR,IS)**2*RPS(IR,IS,L)*GNL(IR,IS,L)*JL(IR)
                ENDDO
                CALL SIMPSN(MMAX,FINT,TMP)
                TWNS(IL,1,IV,IS)=C*TMP
              ENDDO
              CALL GLOSUM(NSPLPO,TWNS(1,1,IV,IS))
              CALL CURV1(NSPLPO,GGNG,TWNS(1,1,IV,IS),
     *             0.0D0,0.0D0,3,TWNS(1,2,IV,IS),FINT,0.0D0,IERR)
            ENDIF
          ENDIF
          LOLD=L
        ENDDO
      ELSE
C       Gauss-Hermit integration;
C       Initialize spherical Bessel functions
        NGHL=NINT(RMAXN(IS))
        C=FPI
        DO IV=1,NGH(IS)
          CALL AZZERO(TWNS(1,1,IV,IS),NSPLPO)
          M=MOD(IV-1,NGHL)+1
          L=NGHTOL(IV,IS)+1
          IF(L.NE.LSKIP(IS)) THEN
C$OMP parallel do private(IL,GGL,XGR)
            DO IL=NSPLPA,NSPLPE
              GGL=GGNG(IL)
              XGR=SQRT(GGL)*TPIBA*RGH(M,IS)
              TWNS(IL,1,IV,IS)=C*BESSL(L-1,XGR)
            ENDDO
            CALL GLOSUM(NSPLPO,TWNS(1,1,IV,IS))
            CALL CURV1(NSPLPO,GGNG,TWNS(1,1,IV,IS),
     *                 0.0D0,0.0D0,3,TWNS(1,2,IV,IS),FINT,0.0D0,IERR)
          ENDIF
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE UNLIN(IS,JL,FINT)
C     ==--------------------------------------------------------------==
C     ==   COMPUTES TWNS FOR NORMCONSERVING PSEUDO-POTENTIALS         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
C     Arguments
      INTEGER   IS
      REAL*8    JL(MESHVP(IS)),FINT(MESHVP(IS))
C     Variables
      DIMENSION TWNS(NSPLPO,2,NHXS,NSX),GGNG(NSPLPO)
      REAL*8    C,GGL,XG,TMP
      INTEGER   LOLD,MMAX,IV,L,IR,IERR,IL
C     ==--------------------------------------------------------------==
      LOLD=-1
      MMAX=MESHVP(IS)
      C=FPI
      DO IV=1,NGH(IS)
        L=NGHTOL(IV,IS)+1
        IF(L.EQ.LOLD) THEN
          CALL DCOPY(2*NSPLPO,TWNS(1,1,IV-1,IS),1,TWNS(1,1,IV,IS),1)
        ELSE
          CALL AZZERO(TWNS(1,1,IV,IS),NSPLPO)
          DO IL=NSPLPA,NSPLPE
            GGL=GGNG(IL)
            XG=SQRT(GGL)*TPIBA
            CALL BESS(XG,L,MMAX,RV(1,IS),JL)
            DO IR=1,MMAX
              FINT(IR)=RW(IR,IS)*RV(IR,IS)*GNL(IR,IS,L)*JL(IR)
            ENDDO
            CALL SIMPSN(MMAX,FINT,TMP)
            TWNS(IL,1,IV,IS)=C*TMP
          ENDDO
          CALL GLOSUM(NSPLPO,TWNS(1,1,IV,IS))
          CALL CURV1(NSPLPO,GGNG,TWNS(1,1,IV,IS),
     *             0.0D0,0.0D0,3,TWNS(1,2,IV,IS),FINT,0.0D0,IERR)
        ENDIF
        LOLD=L
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
