C     ==================================================================
      SUBROUTINE RNLSET(IS,GMAX,FINT,WSGTMP)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == THE FORM FACTORS GNL AND WSG OF THE NON-LOCAL PSEUDOPOTENTIAL==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'sgpp.inc'
C     Arguments
      INTEGER   IS
      REAL*8    GMAX(*),FINT(*),WSGTMP(*)
C     Variables
      REAL*8    VECT(NHX,LMAXX),
     &          RCMGH,RCM2,RGH2,
     &          CURV2
      INTEGER   ISUB,IV,L,IR,LM,NGHL,M,I,IERR,K
C     ==--------------------------------------------------------------==
      IF(TSGP(IS).OR.LLOC(IS).LE.0) RETURN
      CALL TISET('    RNLSET',ISUB)
      CALL DCOPY(MESHVP(IS),VR(1,IS,LLOC(IS)),1,GMAX(1),1)
      IF(TKB(IS)) THEN
C       Kleinman-Bylander scheme
        IF(MESHW(IS).NE.MESHVP(IS)) 
     *       CALL STOPGM('RNLSET','INCOMPATIBLE MESHES')
        IF(CLOGW(IS).NE.CLOGVP(IS)) 
     *       CALL STOPGM('RNLSET','INCOMPATIBLE MESHES')
        DO L=1,LMAX(IS)
          IF(L.EQ.LSKIP(IS).OR.L.EQ.LLOC(IS)) THEN
            WSGTMP(L)=0.D0
          ELSE
            CALL DCOPY(MESHVP(IS),VR(1,IS,L),1,GNL(1,IS,L),1)
            DO IR=1,MESHW(IS)
              GNL(IR,IS,L)=GNL(IR,IS,L)-GMAX(IR)
              IF(DABS(GNL(IR,IS,L)).LT.1.D-10) GNL(IR,IS,L) = 0.D0
            ENDDO 
            DO IR=1,MESHW(IS)
              FINT(IR)=RPS(IR,IS,L)**2*GNL(IR,IS,L)*RW(IR,IS)
            ENDDO 
            CALL SIMPSN(MESHW(IS),FINT,WSG(IS,L))
            WSGTMP(L)=1.D0/(CLOGW(IS)*WSG(IS,L))
          ENDIF
        ENDDO
C..aa
        K=0 
        DO L=1,LMAX(IS)
          IF(L.NE.LLOC(IS).AND.L.NE.LSKIP(IS)) THEN 
            DO LM=1,2*L-1
              K=K+1
              WSG(IS,K)=WSGTMP(L)
            ENDDO
          ENDIF
        ENDDO
C..aa
      ELSE
C       Gauss-Hermit integration
C       scaling parameter for integration points
        RCMGH=0.72D0
        RCM2=RCMGH*RCMGH
        NGHL=NINT(RMAXN(IS))
        DO IV=1,NGHL
          RGH(IV,IS)=RGH(IV,IS)*RCMGH
        ENDDO
        DO L=1,LMAX(IS)
          CALL DCOPY(MESHVP(IS),VR(1,IS,L),1,GNL(1,IS,L),1)
          DO IR=1,MESHVP(IS)
            GNL(IR,IS,L)=GNL(IR,IS,L)-GMAX(IR)
            IF(DABS(GNL(IR,IS,L)).LT.1.D-10) GNL(IR,IS,L) = 0.D0
          ENDDO 
          CALL CURV1(MESHVP(IS),RV(1,IS),GNL(1,IS,L),0.0D0,0.0D0,3,
     *               WSGTMP,FINT,0.0D0,IERR)
          DO I=1,NGHL
            VECT(I,L)=CURV2(RGH(I,IS),MESHVP(IS),RV(1,IS),GNL(1,IS,L),
     *                      WSGTMP,0.0D0)
          ENDDO
        ENDDO
        DO IV=1,NGH(IS)
          M=MOD(IV-1,NGHL)+1
          L=NGHTOL(IV,IS)+1
          RGH2=RGH(M,IS)**2
          WSG(IS,IV)=RCMGH*WGH(M,IS)*RGH2*VECT(M,L)*EXP(RGH2/RCM2)
        ENDDO
      ENDIF
      CALL TIHALT('    RNLSET',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
