C     ==================================================================
      SUBROUTINE RNLSM1(C0,NSTATE,SCR,LSCR,IKIND)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE ARRAY FNL (ALSO CALLED BEC IN SOME VANDERBILT ROUTINES) ==
C     ==  K-POINT VERSION IS IMPLEMENTED                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'pslo.inc'
      INCLUDE 'nlps.inc'        !NLM NGH
      INCLUDE 'vdbp.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'mm_dim.inc'      !NAXq
C     Arguments
      INTEGER    NSTATE,LSCR,IKIND
      COMPLEX*16 C0(NGWK,NSTATE),SCR(NGWK,NAXq)
C     Variables
      DIMENSION  EIGR(NGW,NAT),
     &           TWNL(NGWK,NHXS,NSX,NKPNT),
     &           YLMB(NHG,LPMAX,NKPNT),EIGKR(NGWK,NAT,NKPNT)
      COMPLEX*16 ZZERO,ZONE
      PARAMETER  (ZZERO=(0.D0,0.D0),ZONE=(1.D0,0.D0))
      COMPLEX*16 CI
      CHARACTER  TAG*30
      REAL*8     FNL(IMAGP,NAT,NHXS,NSTATE,NKPNT),DFNL(*)
      REAL*8     CIR,CII,ER,EI,T
      INTEGER    ISUB,ISA0,IS,IV,ISA,IA,IG,
     &           LRNLSM1
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('    RNLSM1',ISUB)
C     SCR test.
      CALL GIVE_SCR_RNLSM1(LRNLSM1,TAG,NSTATE)
      CALL TEST_SCR('RNLSM1',TAG,LSCR,LRNLSM1)
C     ==--------------------------------------------------------------==
      CALL AZZERO(FNL(1,1,1,1,IKIND),IMAGP*NAT*NHXS*NSTATE)
      IF(NGWK.EQ.0) GOTO 1000
C     ==--------------------------------------------------------------==
      ISA0=0
      DO IS=1,NSP
        DO IV=1,NGH(IS)
          CI=(0.0D0,-1.0D0)**NGHTOL(IV,IS)
          CIR=DREAL(CI)
          CII=DIMAG(CI)
C         Make use of the special structure of CI
          IF(DABS(CIR).GT.0.5D0) THEN
C           CI is real
#ifdef __SR8000 
*poption parallel
*soption unroll(2)
#endif 
!$OMP parallel do private(IA,ISA,IG,ER,EI,T)
#ifdef CRAYX1
!dir$ nextscalar
!dir$ nointerchange
!dir$ preferstream
#endif
            DO IA=1,NA(IS)
              ISA=ISA0+IA
#ifdef __SR8000
*soption unroll(8)
#endif 
#ifdef CRAYX1
!dir$ prefervector
#endif
              DO IG=1,NGWK
                ER=DREAL(EIGKR(IG,ISA,IKIND))
                EI=DIMAG(EIGKR(IG,ISA,IKIND))
                T=TWNL(IG,IV,IS,IKIND)*CIR
                SCR(IG,IA)=DCMPLX(T*ER,T*EI)
              ENDDO
            ENDDO 
          ELSE
C           CI is imaginary
#ifdef __SR8000 
*poption parallel
*soption unroll(2)
#endif 
!$OMP parallel do private(IA,ISA,IG,ER,EI,T)
#ifdef CRAYX1
!dir$ nextscalar
!dir$ nointerchange
!dir$ preferstream
#endif
            DO IA=1,NA(IS)
              ISA=ISA0+IA
#ifdef __SR8000
*soption unroll(8)
#endif 
#ifdef CRAYX1
!dir$ prefervector
#endif 
              DO IG=1,NGWK
                ER=DREAL(EIGKR(IG,ISA,IKIND))
                EI=DIMAG(EIGKR(IG,ISA,IKIND))
                T=TWNL(IG,IV,IS,IKIND)*CII
                SCR(IG,IA)=DCMPLX(-T*EI,T*ER)
              ENDDO
            ENDDO 
          ENDIF 
          IF(GEQ0) THEN
            IF(TKPNT) THEN
#ifdef __SR8000
*poption parallel
#endif
              DO IA=1,NA(IS)
                SCR(NGW+1,IA)=DCMPLX(0.D0,0.D0)
              ENDDO 
            ELSE
#ifdef __SR8000
*poption parallel
#endif
              DO IA=1,NA(IS)
                SCR(1,IA)=0.5D0*SCR(1,IA)
              ENDDO 
            ENDIF
          ENDIF
          IF(TKPNT) THEN
            CALL ZGEMM('C','N',NA(IS),NSTATE,NGWK,ZONE,SCR(1,1),
     &             NGWK,C0(1,1),NGWK,ZZERO,
     &             FNL(1,ISA0+1,IV,1,IKIND),NAT*NHXS)
          ELSE
            IF(NA(IS).GT.1) THEN
              CALL DGEMM('T','N',NA(IS),NSTATE,2*NGWK,2.D0,SCR(1,1),
     &             2*NGWK,C0(1,1),2*NGWK,0.0D0,
     &             FNL(1,ISA0+1,IV,1,IKIND),NAT*NHXS)
            ELSE
              CALL DGEMV('T',2*NGWK,NSTATE,2.D0,C0(1,1),2*NGWK,SCR(1,1),
     &             1,0.0D0,FNL(1,ISA0+1,IV,1,IKIND),NAT*NHXS)
            ENDIF
          ENDIF
        ENDDO
        ISA0=ISA0+NA(IS)
      ENDDO
 1000 CONTINUE
#ifdef PARALLEL
      CALL SUMFNL(FNL(1,1,1,1,IKIND),SCR,LSCR,NSTATE)
#endif
      CALL TIHALT('    RNLSM1',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RNLSM1(LRNLSM1,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGWK
      INCLUDE 'nlps.inc'        !NLM
      INCLUDE 'mm_dim.inc'      !NAXq
C     Arguments
      INTEGER   LRNLSM1,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LSUMFNL
C     ==--------------------------------------------------------------==
      IF(NLM.EQ.0) THEN
        LRNLSM1=0
      ELSE
        IF(TFDIST) THEN
          LRNLSM1=2*NGWK*NAXq+2
          TAG   ='2*NGWK*NAXq+2'
        ELSE
          CALL GIVE_SCR_SUMFNL(LSUMFNL,TAG,NSTATE)
          LRNLSM1=MAX(2*NGWK*NAXq,LSUMFNL)
          TAG   ='MAX(2*NGWK*NAXq,LSUMFNL)'
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
