#if defined(__SR8000) || defined(_vpp_) || defined (__ES) || defined (__CRAYX1)
C     ==================================================================
      SUBROUTINE RNLSM2(C0,SCR,LSCR,NSTATE,IKPT,IKIND)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE ARRAY DFNL WHICH IS USED IN THE SUBROUTINE RNLFOR       ==
C     ==  K-POINT VERSION IS IMPLEMENTED                              ==
C     ==          NOT IMPLEMENTED FOR TSHEL(IS)=TRUE                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'nlps.inc'        !NLM NGH
      INCLUDE 'ions.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      include 'kpts.inc'
      include 'kpnt.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,IKPT,IKIND
      COMPLEX*16 C0(NGWK,NSTATE)
      REAL*8     SCR(LSCR)
C     Variables
      DIMENSION  EIGR(NGW,NAT),EIGKR(NGWK,NAT,NKPNT),RK(3,NKPNT,NBLKP),
     &           TWNL(NGWK,NHXS,NSX,NKPNT),
     &           YLMB(NHG,LPMAX,NKPNT)
      COMPLEX*16 EISCR(NGWK,3,NAXq)
      REAL*8     DAI(IMAGP,3,NAXq,NSTATE)
      REAL*8     ARG1,ARG2,ARG3
      POINTER    (IP_EISCR,EISCR),(IP_DAI,DAI)
      COMPLEX*16 ZZERO,ZONE
      PARAMETER  (ZZERO=(0.D0,0.D0),ZONE=(1.D0,0.D0))
      COMPLEX*16 CI,ZFAC
      REAL*8     DFNL(IMAGP,NAT,NHXS,3,NDFNL,NKPNT),FNL(*),
     &           CIR,CII,ER,EI,ARG,TFAC
      INTEGER    ISUB,K,ISA0,ISA,IS,IA,I,IG,IV,II,
     &           LRNLSM2,IL_EISCR
      CHARACTER  TAG*30
      LOGICAL MASK 
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('    RNLSM2',ISUB)
C     SCR partition
      CALL GIVE_SCR_RNLSM2(LRNLSM2,TAG,NSTATE)
      CALL TEST_SCR('RNLSM2',TAG,LSCR,LRNLSM2)
      IL_EISCR = 2*NGWK*NAXq*3
      CALL GET_ADDR(IP_EISCR,SCR(1))
      CALL GET_ADDR(IP_DAI,SCR(1+IL_EISCR))
C     ==--------------------------------------------------------------==
      CALL AZZERO(DAI,IMAGP*3*NAXq*NSTATE)
      IF(TKPNT) THEN
        ZFAC=TPIBA*ZONE
      ELSE
        TFAC=2.D0*TPIBA
      ENDIF  
      MASK=IMAGP.EQ.2
      ISA0=0
      DO IS=1,NSP
        DO IV=1,NGH(IS)
          CI=(0.0D0,-1.0D0)**(NGHTOL(IV,IS)+1)
          CIR=DREAL(CI)
          CII=DIMAG(CI)
          IF(TKPNT) THEN
#ifdef __SR8000
*poption parallel, tlocal(ISA,ARG1,ARG2,ARG3,ER,EI)
*voption indep(EISCR)
#endif
!$OMP parallel do private(IA,IG,ISA,ARG1,ARG2,ARG3,ER,EI)
#ifdef CRAYX1
!CSD$ parallel do private(IA,IG,ISA,ARG1,ARG2,ARG3,ER,EI)
!dir$ nextscalar
#endif
            DO IA=1,NA(IS)
              ISA=ISA0+IA
C             Make use of the special structure of CI
              IF(DABS(CIR).GT.0.5D0) THEN
C               CI is real
#ifdef _vpp_
!OCL NOALIAS
#endif 
#ifdef CRAYX1
!dir$  prefervector
#endif 
                DO IG=1,NGW
                  ARG1=(GK(1,IG)+RK(1,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CIR
                  ARG2=(GK(2,IG)+RK(2,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CIR
                  ARG3=(GK(3,IG)+RK(3,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CIR
                  ER=DREAL(EIGKR(IG,ISA,IKIND))
                  EI=DIMAG(EIGKR(IG,ISA,IKIND))
                  EISCR(IG,1,IA) = DCMPLX(ARG1*ER,ARG1*EI)
                  EISCR(IG,2,IA) = DCMPLX(ARG2*ER,ARG2*EI)
                  EISCR(IG,3,IA) = DCMPLX(ARG3*ER,ARG3*EI)
                ENDDO
#ifdef __SR8000
*poption parallel
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif 
#ifdef CRAYX1
!dir$ prefervector
#endif 
                DO IG=NGW+1,NGWK
                  ARG1=(-GK(1,IG-NGW)+RK(1,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CIR
                  ARG2=(-GK(2,IG-NGW)+RK(2,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CIR
                  ARG3=(-GK(3,IG-NGW)+RK(3,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CIR
                  ER=DREAL(EIGKR(IG,ISA,IKIND))
                  EI=DIMAG(EIGKR(IG,ISA,IKIND))
                  EISCR(IG,1,IA) = DCMPLX(ARG1*ER,ARG1*EI)
                  EISCR(IG,2,IA) = DCMPLX(ARG2*ER,ARG2*EI)
                  EISCR(IG,3,IA) = DCMPLX(ARG3*ER,ARG3*EI)
                ENDDO
              ELSE
C               CI is imaginary
#ifdef _vpp_
!OCL NOALIAS
#endif 
#ifdef CRAYX1
!dir$ prefervector
#endif 
                DO IG=1,NGW
                  ARG1=(GK(1,IG)+RK(1,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CII
                  ARG2=(GK(2,IG)+RK(2,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CII
                  ARG3=(GK(3,IG)+RK(3,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CII
                  ER=DREAL(EIGKR(IG,ISA,IKIND))
                  EI=DIMAG(EIGKR(IG,ISA,IKIND))
                  EISCR(IG,1,IA) = DCMPLX(-ARG1*EI,ARG1*ER)
                  EISCR(IG,2,IA) = DCMPLX(-ARG2*EI,ARG2*ER)
                  EISCR(IG,3,IA) = DCMPLX(-ARG3*EI,ARG3*ER)
                ENDDO
#ifdef __SR8000
*poption parallel
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif 
#ifdef CRAYX1
!dir$  prefervector
#endif 
                DO IG=NGW+1,NGWK
                  ARG1=(-GK(1,IG-NGW)+RK(1,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CII
                  ARG2=(-GK(2,IG-NGW)+RK(2,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CII
                  ARG3=(-GK(3,IG-NGW)+RK(3,IKIND,IKPT))*
     &                  TWNL(IG,IV,IS,IKIND)*CII
                  ER=DREAL(EIGKR(IG,ISA,IKIND))
                  EI=DIMAG(EIGKR(IG,ISA,IKIND))
                  EISCR(IG,1,IA) = DCMPLX(-ARG1*EI,ARG1*ER)
                  EISCR(IG,2,IA) = DCMPLX(-ARG2*EI,ARG2*ER)
                  EISCR(IG,3,IA) = DCMPLX(-ARG3*EI,ARG3*ER)
                ENDDO
              ENDIF
              IF(GEQ0) EISCR(NGW+1,1,IA)=DCMPLX(0.D0,0.D0)
              IF(GEQ0) EISCR(NGW+1,2,IA)=DCMPLX(0.D0,0.D0)
              IF(GEQ0) EISCR(NGW+1,3,IA)=DCMPLX(0.D0,0.D0)
            ENDDO
#ifdef CRAYX1
!CSD$ end parallel do
#endif
            CALL ZGEMM('C','N',3*NA(IS),NSTATE,NGWK,ZFAC,
     &             EISCR(1,1,1),NGWK,C0(1,1),NGWK,ZZERO,
     &             DAI(1,1,1,1),3*NAXq)
          ELSE
#ifdef __SR8000
*poption parallel, tlocal(ISA,ARG1,ARG2,ARG3,ER,EI) 
*voption indep(EISCR)
#endif 
!$OMP parallel do private(IA,IG,ISA,ARG1,ARG2,ARG3,ER,EI)
#ifdef CRAYX1
!CSD$ parallel do private(IA,IG,ISA,ARG1,ARG2,ARG3,ER,EI)
!dir$ nextscalar
#endif 
            DO IA=1,NA(IS)
              ISA=ISA0+IA
C             Make use of the special structure of CI
              IF(DABS(CIR).GT.0.5D0) THEN
C               CI is real
#ifdef _vpp_
!OCL NOALIAS
#endif 
#ifdef CRAYX1
!dir$ prefervector
#endif 
                DO IG=1,NGW
!!                ARG1=GK(1,IG)*TWNL(IG,IV,IS,1)*CIR
!!                ARG2=GK(2,IG)*TWNL(IG,IV,IS,1)*CIR
!!                ARG3=GK(3,IG)*TWNL(IG,IV,IS,1)*CIR
!!                ER=DREAL(EIGR(IG,ISA))
!!                EI=DIMAG(EIGR(IG,ISA))
                  ARG1=GK(1,IG)
                  ARG2=GK(2,IG)
                  ARG3=GK(3,IG)
                  ER=CIR*TWNL(IG,IV,IS,1)*DREAL(EIGR(IG,ISA))
                  EI=CIR*TWNL(IG,IV,IS,1)*DIMAG(EIGR(IG,ISA))
                  EISCR(IG,1,IA) = DCMPLX(ARG1*ER,ARG1*EI)
                  EISCR(IG,2,IA) = DCMPLX(ARG2*ER,ARG2*EI)
                  EISCR(IG,3,IA) = DCMPLX(ARG3*ER,ARG3*EI)
                ENDDO
              ELSE
C               CI is imaginary
#ifdef _vpp_
!OCL NOALIAS
#endif 
!dir$ prefervector
                DO IG=1,NGW
!!                ARG1=GK(1,IG)*TWNL(IG,IV,IS,1)*CII
!!                ARG2=GK(2,IG)*TWNL(IG,IV,IS,1)*CII
!!                ARG3=GK(3,IG)*TWNL(IG,IV,IS,1)*CII
!!                ER=DREAL(EIGR(IG,ISA))
!!                EI=DIMAG(EIGR(IG,ISA))
                  ARG1=GK(1,IG)
                  ARG2=GK(2,IG)
                  ARG3=GK(3,IG)
                  ER=CII*TWNL(IG,IV,IS,1)*DREAL(EIGR(IG,ISA))
                  EI=CII*TWNL(IG,IV,IS,1)*DIMAG(EIGR(IG,ISA))
                  EISCR(IG,1,IA) = DCMPLX(-ARG1*EI,ARG1*ER)
                  EISCR(IG,2,IA) = DCMPLX(-ARG2*EI,ARG2*ER)
                  EISCR(IG,3,IA) = DCMPLX(-ARG3*EI,ARG3*ER)
                ENDDO
              ENDIF
              IF(GEQ0) THEN 
                EISCR(1,1,IA)=0.5D0*EISCR(1,1,IA)
                EISCR(1,2,IA)=0.5D0*EISCR(1,2,IA)
                EISCR(1,3,IA)=0.5D0*EISCR(1,3,IA)
              ENDIF 
            ENDDO
#ifdef CRAYX1
!CSD$ end parallel do 
#endif 
            IF(NGWK.GT.0) THEN
            IF (NA(IS).GT.1) THEN
              CALL DGEMM('T','N',3*NA(IS),NSTATE,2*NGWK,TFAC,
     &             EISCR(1,1,1),2*NGWK,C0(1,1),2*NGWK,0.0D0,
     &             DAI(1,1,1,1),3*NAXq)
            ELSE
              CALL DGEMM('T','N',3,NSTATE,2*NGWK,TFAC,
     &             EISCR(1,1,1),2*NGWK,C0(1,1),2*NGWK,0.0D0,
     &             DAI(1,1,1,1),3*NAXq)
            ENDIF
            ENDIF
          ENDIF
#ifdef PARALLEL
          CALL GLOSUM(IMAGP*3*NAXq*NSTATE,DAI)
#endif
#ifdef __SR8000
*poption parallel, tlocal(II)  
#endif 
!$OMP parallel do private(I,IA,IG,II)
#ifdef CRAYX1
!CSD$ parallel do private(I,IA,IG,II)
#endif 
          DO I=NST12(MEPOS,1),NST12(MEPOS,2)
            II=I-NST12(MEPOS,1)+1
#ifdef _vpp_
!OCL NOALIAS
            DO IA=1,NA(IS)
              DFNL(1,ISA0+IA,IV,1,II,IKIND)=DAI(1,1,IA,I)
              DFNL(1,ISA0+IA,IV,2,II,IKIND)=DAI(1,2,IA,I)
              DFNL(1,ISA0+IA,IV,3,II,IKIND)=DAI(1,3,IA,I)
              IF(MASK) THEN 
                DFNL(2,ISA0+IA,IV,1,II,IKIND)=DAI(2,1,IA,I)
                DFNL(2,ISA0+IA,IV,2,II,IKIND)=DAI(2,2,IA,I)
                DFNL(2,ISA0+IA,IV,3,II,IKIND)=DAI(2,3,IA,I)
              ENDIF
            ENDDO 
#else 
!dir$ prefervector
            DO IG=1,IMAGP
              DO IA=1,NA(IS)
                DFNL(IG,ISA0+IA,IV,1,II,IKIND)=DAI(IG,1,IA,I)
                DFNL(IG,ISA0+IA,IV,2,II,IKIND)=DAI(IG,2,IA,I)
                DFNL(IG,ISA0+IA,IV,3,II,IKIND)=DAI(IG,3,IA,I)
              ENDDO 
            ENDDO 
#endif 
          ENDDO 
#ifdef CRAYX1
!CSD$ end parallel do
#endif 
        ENDDO
        ISA0=ISA0+NA(IS)
      ENDDO
      CALL TIHALT('    RNLSM2',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RNLSM2(LRNLSM2,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGWK
      INCLUDE 'nlps.inc'        !NLM IMAGP
      INCLUDE 'mm_dim.inc'      !NAXq
C     Arguments
      INTEGER   LRNLSM2,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      IF(NLM.EQ.0) THEN
        LRNLSM2=0
      ELSE
        LRNLSM2=2*NGWK*NAXq*3+IMAGP*NAXq*NSTATE*3
        TAG=   '2*NGWK*NAXq*3+IMAGP*NAXq*...'
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#else 
C     ==================================================================
      SUBROUTINE RNLSM2(C0,SCR,LSCR,NSTATE,IKPT,IKIND)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE ARRAY DFNL WHICH IS USED IN THE SUBROUTINE RNLFOR       ==
C     ==  K-POINT VERSION IS IMPLEMENTED                              ==
C     ==          NOT IMPLEMENTED FOR TSHEL(IS)=TRUE                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'nlps.inc'        !NLM NGH
      INCLUDE 'ions.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      include 'kpts.inc'
      include 'kpnt.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,IKPT,IKIND
      COMPLEX*16 C0(NGWK,NSTATE)
      REAL*8     SCR(LSCR)
C     Variables
      DIMENSION  EIGR(NGW,NAT),EIGKR(NGWK,NAT,NKPNT),RK(3,NKPNT,NBLKP),
     &           TWNL(NGWK,NHXS,NSX,NKPNT),
     &           YLMB(NHG,LPMAX,NKPNT)
      COMPLEX*16 EISCR(NGWK,NAXq)
      REAL*8     DAI(IMAGP,NAXq,NSTATE)
      POINTER    (IP_EISCR,EISCR),(IP_DAI,DAI)
      COMPLEX*16 ZZERO,ZONE
      PARAMETER  (ZZERO=(0.D0,0.D0),ZONE=(1.D0,0.D0))
      COMPLEX*16 CI,ZFAC
      REAL*8     DFNL(IMAGP,NAT,NHXS,3,NDFNL,NKPNT),FNL(*),
     &           CIR,CII,ER,EI,ARG,TFAC
      INTEGER    ISUB,K,ISA0,ISA,IS,IA,I,IG,IV,II,
     &           LRNLSM2,IL_EISCR
      CHARACTER  TAG*30
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('    RNLSM2',ISUB)
C     SCR partition
      CALL GIVE_SCR_RNLSM2(LRNLSM2,TAG,NSTATE)
      CALL TEST_SCR('RNLSM2',TAG,LSCR,LRNLSM2)
      IL_EISCR = 2*NGWK*NAXq
      CALL GET_ADDR(IP_EISCR,SCR(1))
      CALL GET_ADDR(IP_DAI,SCR(1+IL_EISCR))
C     ==--------------------------------------------------------------==
      CALL AZZERO(DAI,IMAGP*NAXq*NSTATE)
      IF(TKPNT) THEN
        ZFAC=TPIBA*ZONE
      ELSE
        TFAC=2.D0*TPIBA
      ENDIF  
      DO K=1,3
        ISA0=0
        DO IS=1,NSP
          DO IV=1,NGH(IS)
            CI=(0.0D0,-1.0D0)**(NGHTOL(IV,IS)+1)
            CIR=DREAL(CI)
            CII=DIMAG(CI)
            IF(TKPNT) THEN
C$OMP parallel do private(ia,isa,ig,arg,er,ei)
#ifdef __SR8000 
*poption parallel, tlocal(ia,isa,ig,arg,er,ei)
#endif 
              DO IA=1,NA(IS)
                ISA=ISA0+IA
C               Make use of the special structure of CI
                IF(DABS(CIR).GT.0.5D0) THEN
C                 CI is real
                  DO IG=1,NGW
                    ARG=(GK(K,IG)+RK(K,IKIND,IKPT))*
     &                   TWNL(IG,IV,IS,IKIND)*CIR
                    ER=DREAL(EIGKR(IG,ISA,IKIND))
                    EI=DIMAG(EIGKR(IG,ISA,IKIND))
                    EISCR(IG,IA) = DCMPLX(ARG*ER,ARG*EI)
                  ENDDO
                  DO IG=NGW+1,NGWK
                    ARG=(-GK(K,IG-NGW)+RK(K,IKIND,IKPT))*
     &                   TWNL(IG,IV,IS,IKIND)*CIR
                    ER=DREAL(EIGKR(IG,ISA,IKIND))
                    EI=DIMAG(EIGKR(IG,ISA,IKIND))
                    EISCR(IG,IA) = DCMPLX(ARG*ER,ARG*EI)
                  ENDDO
                ELSE
C                 CI is imaginary
                  DO IG=1,NGW
                    ARG=(GK(K,IG)+RK(K,IKIND,IKPT))*
     &                   TWNL(IG,IV,IS,IKIND)*CII
                    ER=DREAL(EIGKR(IG,ISA,IKIND))
                    EI=DIMAG(EIGKR(IG,ISA,IKIND))
                    EISCR(IG,IA) = DCMPLX(-ARG*EI,ARG*ER)
                  ENDDO
                  DO IG=NGW+1,NGWK
                    ARG=(-GK(K,IG-NGW)+RK(K,IKIND,IKPT))*
     &                   TWNL(IG,IV,IS,IKIND)*CII
                    ER=DREAL(EIGKR(IG,ISA,IKIND))
                    EI=DIMAG(EIGKR(IG,ISA,IKIND))
                    EISCR(IG,IA) = DCMPLX(-ARG*EI,ARG*ER)
                  ENDDO
                ENDIF
                IF(GEQ0) EISCR(NGW+1,IA)=DCMPLX(0.D0,0.D0)
              ENDDO
              CALL ZGEMM('C','N',NA(IS),NSTATE,NGWK,ZFAC,
     &               EISCR(1,1),NGWK,C0(1,1),NGWK,ZZERO,
     &               DAI(1,1,1),NAXq)
            ELSE
C$OMP parallel do private(ia,isa,ig,arg,er,ei)
#ifdef __SR8000
*poption parallel, tlocal(ia,isa,ig,arg,er,ei)
#endif 
              DO IA=1,NA(IS)
                ISA=ISA0+IA
C               Make use of the special structure of CI
                IF(DABS(CIR).GT.0.5D0) THEN
C                 CI is real
                  DO IG=1,NGW
                    ARG=GK(K,IG)*TWNL(IG,IV,IS,1)*CIR
                    ER=DREAL(EIGR(IG,ISA))
                    EI=DIMAG(EIGR(IG,ISA))
                    EISCR(IG,IA) = DCMPLX(ARG*ER,ARG*EI)
                  ENDDO
                ELSE
C                 CI is imaginary
                  DO IG=1,NGW
                    ARG=GK(K,IG)*TWNL(IG,IV,IS,1)*CII
                    ER=DREAL(EIGR(IG,ISA))
                    EI=DIMAG(EIGR(IG,ISA))
                    EISCR(IG,IA) = DCMPLX(-ARG*EI,ARG*ER)
                  ENDDO
                ENDIF
                IF(GEQ0) EISCR(1,IA)=0.5D0*EISCR(1,IA)
              ENDDO
              IF(NGWK.GT.0) THEN
              IF (NA(IS).GT.1) THEN
                CALL DGEMM('T','N',NA(IS),NSTATE,2*NGWK,TFAC,
     &               EISCR(1,1),2*NGWK,C0(1,1),2*NGWK,0.0D0,
     &               DAI(1,1,1),NAXq)
              ELSE
                CALL DGEMV('T',2*NGWK,NSTATE,TFAC,C0(1,1),2*NGWK,
     &               EISCR(1,1),1,0.0D0,DAI(1,1,1),NAXq)
              ENDIF
              ENDIF
            ENDIF
#ifdef PARALLEL
            CALL GLOSUM(IMAGP*NAXq*NSTATE,DAI)
#endif
            DO I=NST12(MEPOS,1),NST12(MEPOS,2)
              II=I-NST12(MEPOS,1)+1
              CALL DCOPY(IMAGP*NA(IS),DAI(1,1,I),1,
     &                   DFNL(1,ISA0+1,IV,K,II,IKIND),1)
            ENDDO
          ENDDO
          ISA0=ISA0+NA(IS)
        ENDDO
      ENDDO
      CALL TIHALT('    RNLSM2',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RNLSM2(LRNLSM2,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGWK
      INCLUDE 'nlps.inc'        !NLM IMAGP
      INCLUDE 'mm_dim.inc'      !NAXq
C     Arguments
      INTEGER   LRNLSM2,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      IF(NLM.EQ.0) THEN
        LRNLSM2=0
      ELSE
        LRNLSM2=2*NGWK*NAXq+IMAGP*NAXq*NSTATE
        TAG=   '2*NGWK*NAXq+IMAGP*NAXq*NSTATE'
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#endif 
