C     ==================================================================
      SUBROUTINE RNLSM_2D(C0,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE ARRAY DDFNL WHICH IS USED IN THE SUBROUTINE SD_NL2      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'nlps.inc'        !NLM NGH
      INCLUDE 'ions.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
C     Arguments
      INTEGER    LSCR,NSTATE
      COMPLEX*16 C0(NGW,NSTATE)
      REAL*8     SCR(LSCR)
C     Variables
      DIMENSION  EIGR(NGW,NAT),TWNL(NGW,NHXS,NSX),
     &           YLMB(NHG,LPMAX,NKPNT),DDFNL(NAT,NHXS,6,NDFNL)
      COMPLEX*16 EISCR(NGW,6)
      REAL*8     FNL(*),DFNL(*)
      REAL*8     DAI(6,NSTATE)
      POINTER    (IP_EISCR,EISCR), (IP_DAI,DAI)
      COMPLEX*16 CI
      REAL*8     ARG(6),CIR,CII,TFAC,ER,EI
      INTEGER    IS,IA,IV,ISA,ISA0,I,II,IG,ISUB,LRNLSM
      CHARACTER  TAG*30
      LOGICAL DEBUG
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('  RNLSM_2D',ISUB)
      DEBUG=.FALSE.
C     SCR partition
      CALL GIVE_SCR_RNLSM_2D(LRNLSM,TAG,NSTATE)
      CALL TEST_SCR('RNLSM_2D',TAG,LSCR,LRNLSM)
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_EISCR,2*NGW*6,'EISCR',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_DAI,NSTATE*6,'DAI',DEBUG)
C     ==--------------------------------------------------------------==
      TFAC=2.D0*TPIBA2
      ISA0=0
      DO IS=1,NSP
        DO IV=1,NGH(IS)
          CI=(0.0D0,-1.0D0)**(NGHTOL(IV,IS)+2)
          CIR=DREAL(CI)
          CII=DIMAG(CI)
          DO IA=1,NA(IS)
            ISA=ISA0+IA
C..Make use of the special structure of CI
            IF(DABS(CIR).GT.0.5D0) THEN
C..CI is real
              DO IG=1,NGW
                ARG(1)=GK(1,IG)*GK(1,IG)*TWNL(IG,IV,IS)*CIR
                ARG(2)=GK(1,IG)*GK(2,IG)*TWNL(IG,IV,IS)*CIR
                ARG(3)=GK(1,IG)*GK(3,IG)*TWNL(IG,IV,IS)*CIR
                ARG(4)=GK(2,IG)*GK(2,IG)*TWNL(IG,IV,IS)*CIR
                ARG(5)=GK(2,IG)*GK(3,IG)*TWNL(IG,IV,IS)*CIR
                ARG(6)=GK(3,IG)*GK(3,IG)*TWNL(IG,IV,IS)*CIR
                ER=DREAL(EIGR(IG,ISA))
                EI=DIMAG(EIGR(IG,ISA))
                EISCR(IG,1) = DCMPLX(ARG(1)*ER,ARG(1)*EI)
                EISCR(IG,2) = DCMPLX(ARG(2)*ER,ARG(2)*EI)
                EISCR(IG,3) = DCMPLX(ARG(3)*ER,ARG(3)*EI)
                EISCR(IG,4) = DCMPLX(ARG(4)*ER,ARG(4)*EI)
                EISCR(IG,5) = DCMPLX(ARG(5)*ER,ARG(5)*EI)
                EISCR(IG,6) = DCMPLX(ARG(6)*ER,ARG(6)*EI)
              ENDDO
            ELSE
C..CI is imaginary
              DO IG=1,NGW
                ARG(1)=GK(1,IG)*GK(1,IG)*TWNL(IG,IV,IS)*CII
                ARG(2)=GK(1,IG)*GK(2,IG)*TWNL(IG,IV,IS)*CII
                ARG(3)=GK(1,IG)*GK(3,IG)*TWNL(IG,IV,IS)*CII
                ARG(4)=GK(2,IG)*GK(2,IG)*TWNL(IG,IV,IS)*CII
                ARG(5)=GK(2,IG)*GK(3,IG)*TWNL(IG,IV,IS)*CII
                ARG(6)=GK(3,IG)*GK(3,IG)*TWNL(IG,IV,IS)*CII
                ER=DREAL(EIGR(IG,ISA))
                EI=DIMAG(EIGR(IG,ISA))
                EISCR(IG,1) = DCMPLX(-ARG(1)*EI,ARG(1)*ER)
                EISCR(IG,2) = DCMPLX(-ARG(2)*EI,ARG(2)*ER)
                EISCR(IG,3) = DCMPLX(-ARG(3)*EI,ARG(3)*ER)
                EISCR(IG,4) = DCMPLX(-ARG(4)*EI,ARG(4)*ER)
                EISCR(IG,5) = DCMPLX(-ARG(5)*EI,ARG(5)*ER)
                EISCR(IG,6) = DCMPLX(-ARG(6)*EI,ARG(6)*ER)
              ENDDO
            ENDIF
            IF(GEQ0) THEN
              DO I=1,6
                EISCR(1,I)=0.5D0*EISCR(1,I)
              ENDDO
            ENDIF
            CALL DGEMM('T','N',6,NSTATE,2*NGW,TFAC,
     &               EISCR(1,1),2*NGW,C0(1,1),2*NGW,0.0D0,
     &               DAI(1,1),6)
#ifdef PARALLEL
            CALL GLOSUM(6*NSTATE,DAI)
#endif
            DO I=NST12(MEPOS,1),NST12(MEPOS,2)
              II=I-NST12(MEPOS,1)+1
              DDFNL(ISA,IV,1,II)=DAI(1,I)
              DDFNL(ISA,IV,2,II)=DAI(2,I)
              DDFNL(ISA,IV,3,II)=DAI(3,I)
              DDFNL(ISA,IV,4,II)=DAI(4,I)
              DDFNL(ISA,IV,5,II)=DAI(5,I)
              DDFNL(ISA,IV,6,II)=DAI(6,I)
            ENDDO
          ENDDO
        ENDDO
        ISA0=ISA0+NA(IS)
      ENDDO
      CALL SCRREL(SCR,LSCR,DEBUG)
      CALL TIHALT('  RNLSM_2D',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RNLSM_2D(LRNLSM,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGW
      INCLUDE 'nlps.inc'        !NLM 
C     Arguments
      INTEGER   LRNLSM,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      IF(NLM.EQ.0) THEN
        LRNLSM=0
      ELSE
        LRNLSM=2*NGW*6+6*NSTATE+100
        TAG=   '2*NGW*6+6*NSTATE'
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
