C     ==================================================================
      SUBROUTINE RNLSM3(C0,SCR,LSCR,NSTATE,DD_FNL)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE ARRAY DDFNL WHICH IS USED IN PERTURBATION THEORY FOR    ==
C     ==   PHONON
C     ==  K-POINT VERSION IS NOT IMPLEMENTED                              ==
C     ==          NOT IMPLEMENTED FOR TSHEL(IS)=TRUE                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'nlps.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      include 'kpts.inc'
      include 'kpnt.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      INTEGER    LSCR,NSTATE
      COMPLEX*16 C0(NGWK,NSTATE)
      REAL*8     SCR(LSCR),
     &           DD_FNL(IMAGP,NAT,NHXS,3,3,NDFNL,NKPNT)
C     Variables
      DIMENSION  EIGR(NGW,NAT),EIGKR(NGWK,NAT,NKPNT),RK(3,NKPNT,NBLKP),
     &           TWNL(NGWK,NHXS,NSX,NKPNT),
     &           TWNLS(NGWL,NHXS,NSX),YLMB(NHG,LPMAX,NKPNT)
      COMPLEX*16 EISCR(NGWK,NAX)
      REAL*8     DAI(IMAGP,NAX,NSTATE)
      POINTER    (IP_EISCR,EISCR),(IP_DAI,DAI)
      COMPLEX*16 CI
      REAL*8     CIR,CII,ER,EI,ARG,TFAC,DFNL(*),FNL(*)
      INTEGER    ISUB,K,K2,ISA0,ISA,IS,IA,I,IG,IV,II,
     &           LRNLSM3,IL_EISCR
      CHARACTER  TAG*30
C     ==--------------------------------------------------------------==
      CALL TISET('    RNLSM3',ISUB)
C     ==--------------------------------------------------------------==
C     SCR partition
      CALL GIVE_SCR_RNLSM3(LRNLSM3,TAG,NSTATE)
      CALL TEST_SCR('RNLSM3',TAG,LSCR,LRNLSM3)
      IL_EISCR = 2*NGWK*NAX
      CALL GET_ADDR(IP_EISCR,SCR(1))
      CALL GET_ADDR(IP_DAI,SCR(1+IL_EISCR))
C     ==--------------------------------------------------------------==
      CALL AZZERO(DAI,IMAGP*NAX*NSTATE)
      IF(TKPNT) THEN
        CALL STOPGM(' RNLSM3', 'KPOINT NOT IMPLEMENTED')
      ELSE
        TFAC=2.D0*TPIBA*TPIBA
      ENDIF  
      DO K=1,3
       DO K2=1,3
        ISA0=0
        DO IS=1,NSP
          DO IV=1,NGH(IS)
            CI=(0.0D0,-1.0D0)**(NGHTOL(IV,IS)+2)
            CIR=DREAL(CI)
            CII=DIMAG(CI)
              DO IA=1,NA(IS)
                ISA=ISA0+IA
C               Make use of the special structure of CI
                IF(DABS(CIR).GT.0.5D0) THEN
C                 CI is real
                  DO IG=1,NGW
                    ARG=GK(K,IG)*GK(K2,IG)*TWNL(IG,IV,IS,1)*CIR
                    ER=DREAL(EIGR(IG,ISA))
                    EI=DIMAG(EIGR(IG,ISA))
                    EISCR(IG,IA) = DCMPLX(ARG*ER,ARG*EI)
                  ENDDO
                ELSE
C                 CI is imaginary
                  DO IG=1,NGW
                    ARG=GK(K,IG)*GK(K2,IG)*TWNL(IG,IV,IS,1)*CII
                    ER=DREAL(EIGR(IG,ISA))
                    EI=DIMAG(EIGR(IG,ISA))
                    EISCR(IG,IA) = DCMPLX(-ARG*EI,ARG*ER)
                  ENDDO
                ENDIF
                IF(GEQ0) EISCR(1,IA)=0.5D0*EISCR(1,IA)
              ENDDO
              CALL DGEMM('T','N',NA(IS),NSTATE,2*NGWK,TFAC,
     &               EISCR(1,1),2*NGWK,C0(1,1),2*NGWK,0.0D0,
     &               DAI(1,1,1),NAX)
#ifdef PARALLEL
            CALL GLOSUM(IMAGP*NAX*NSTATE,DAI)
#endif
            DO I=NST12(MEPOS,1),NST12(MEPOS,2)
              II=I-NST12(MEPOS,1)+1
              CALL DCOPY(IMAGP*NA(IS),DAI(1,1,I),1,
     &                   DD_FNL(1,ISA0+1,IV,K,K2,II,1),1)
            ENDDO
          ENDDO
          ISA0=ISA0+NA(IS)
        ENDDO
       ENDDO 
      ENDDO
      CALL TIHALT('    RNLSM3',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RNLSM3(LRNLSM3,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'        !IMAGP
C     Arguments
      INTEGER   LRNLSM3,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LRNLSM3=2*NGWK*NAX+IMAGP*NAX*NSTATE
      TAG=   '2*NGWK*NAX+IMAGP*NAX*NSTATE'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
