C     ==================================================================
      SUBROUTINE RNLSMD(C0,NSTATE,SCR,LSCR,IKIND)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE ARRAY FNL (ALSO CALLED BEC IN SOME VANDERBILT ROUTINES) ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h' 
      include 'pslo.inc'
      include 'nlps.inc'
      include 'vdbp.inc'
      include 'ions.inc'
      include 'cppt.inc'
      include 'sfac.inc'
      include 'kpts.inc'
      INCLUDE 'mm_dim.inc'  ! NAXq
      INTEGER NSPAR,LSCR,NSTATE,IKIND
      PARAMETER(NSPAR=50)
      COMPLEX*16 C0(NGWK,*),SCR(*),SCRA(NGW,*),FNLX(*),DFNL(*)
      DIMENSION FNL2(IMAGP,NAT,NHXS,LDF2,NKPNT)
      DIMENSION EIGR(*),TWNL(NGW,NHXS,*)
      REAL*8 FNL(IMAGP,LDF1,NHXS,NSTATE,NKPNT)
      POINTER(IP_FNLX,FNLX),(IP_SCRA,SCRA)
      CHARACTER TAG*30
      INTEGER ILFNLX,LRNLSM1,I,L,IV,IS,ISA0,ILENGTH,ISUB,NSTAT
      SAVE ILFNLX,IP_FNLX
      DATA ILFNLX /0/
C     ==--------------------------------------------------------------==
      IF(TKPNT) CALL STOPGM('RNLSMD','TSDIST NOT IMPLEMENTED')
C     ==--------------------------------------------------------------==
C     SCR test.
      CALL GIVE_SCR_RNLSM1(LRNLSM1,TAG,NSTATE)
      CALL TEST_SCR('RNLSMD',TAG,LSCR,LRNLSM1)
C     ==--------------------------------------------------------------==
      CALL TISET('    RNLSMD',ISUB)
C..allocate scratch space
      IF(ILFNLX.EQ.0) THEN
        ILFNLX=MAX(1,NAXq*NSPAR)
        CALL MEMORY(IP_FNLX,ILFNLX,'FNLX')
      ENDIF
C..check length of SCR array
      IF(LSCR.LT.2*NAXq*NGWK) THEN
        ILENGTH=2*NAXq*NGWK
        CALL MEMORY(IP_SCRA,ILENGTH,'SCRA')
        IF(PARENT) WRITE(6,'(A)') ' RNLSMD| SCRATCH MEMORY TOO SMALL '
      ELSE
        ILENGTH=0
        CALL GET_ADDR(IP_SCRA,SCR(1))
      ENDIF
      CALL AZZERO(FNL(1,1,1,1,IKIND),IMAGP*LDF1*NHXS*NSTATE)
      IF(TFNL2) CALL AZZERO(FNL2(1,1,1,1,IKIND),IMAGP*NAT*NHXS*LDF2)
      ISA0=0
      DO IS=1,NSP
        DO IV=1,NGH(IS)
          L=NGHTOL(IV,IS)
          CALL SCRPH1(EIGR,SCRA,TWNL(1,IV,IS),L,NA(IS),ISA0)
          DO I=1,NSTATE,NSPAR
            NSTAT=MIN(NSPAR,NSTATE-I+1)
            CALL DGEMM('T','N',NA(IS),NSTAT,2*NGW,2.0D0,SCRA,2*NGW,
     *               C0(1,I),2*NGW,0.0D0,FNLX,NA(IS))
            CALL SUMFNLD(FNLX,ISA0,NA(IS),IV,I,NSTAT,NSTATE,1,1,ALLGRP)
          ENDDO
        ENDDO
        ISA0=ISA0+NA(IS)
      ENDDO
      IF(ILENGTH.NE.0) CALL FREEM(IP_SCRA)
      CALL TIHALT('    RNLSMD',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SCRPH1(EIGR,SCRA,TWNL,L,NATX,ISA0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'geq0.inc'
      INCLUDE 'ions.inc'
      INTEGER L,NATX,ISA0,IA,ISA,IG
      COMPLEX*16 CI,EIGR(NGW,NAT),SCRA(NGW,NAT)
      REAL*8 TWNL(NGW),ARG,ER,EI,CII,CIR
C     ==--------------------------------------------------------------==
      CI=(0.0D0,-1.0D0)**L
      CIR=DREAL(CI)
      CII=DIMAG(CI)
!$OMP parallel do private(IA,IG,ISA,ARG,ER,EI)
      DO IA=1,NATX
        ISA=ISA0+IA
C..MAKE USE OF THE SPECIAL STRUCTURE OF CI
        IF(DABS(CIR).GT.0.5D0) THEN
C..CI IS REAL
          DO IG=1,NGW
            ARG=TWNL(IG)*CIR
            ER=DREAL(EIGR(IG,ISA))
            EI=DIMAG(EIGR(IG,ISA))
            SCRA(IG,IA) = DCMPLX(ARG*ER,ARG*EI)
          ENDDO
        ELSE
C..CI IS IMAGINARY
          DO IG=1,NGW
            ARG=TWNL(IG)*CII
            ER=DREAL(EIGR(IG,ISA))
            EI=DIMAG(EIGR(IG,ISA))
            SCRA(IG,IA) = DCMPLX(-ARG*EI,ARG*ER)
          ENDDO
        ENDIF
        IF(GEQ0) SCRA(1,IA)=0.5D0*SCRA(1,IA)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
