C     ==================================================================
      SUBROUTINE RORTOG(C0,CM,GAM,SCR,LSCR,TNON,NSTATE,PRTEIG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'elct.inc'
C     Arguments
      INTEGER    LSCR,NSTATE
      COMPLEX*16 C0(*),CM(*)
      REAL*8     GAM(*),SCR(LSCR)
      LOGICAL    PRTEIG,TNON
C     Variables
      CHARACTER  TAG*30
      REAL*8     PFAC
      INTEGER    ISUB,M1,M2,M3,M4,M5,M6,MF,LRORTOG,NSTX
C     ==--------------------------------------------------------------==
C     ==  Compute the eigenvalues needed by the RORTHO orthogonali-   ==
C     ==  zation routine                                              ==
C     ==                   ***** WARNING *****                        ==
C     ==  If running the code with the rescaling of electronic        ==
C     ==  velocities option (TC), and orthogonalizing with rortho,    ==
C     ==  then the eigenvalues printed in routine EIGS have no        ==
C     ==  meaning unless convergence is very close (small ekinc).     ==
C     ==--------------------------------------------------------------==
      CALL TISET('    RORTOG',ISUB)
      CALL GIVE_SCR_RORTOG(LRORTOG,TAG,NSTATE)
      CALL TEST_SCR('RORTG',TAG,LSCR,LRORTOG)
      IF(TDMAL) THEN
        CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
#ifdef _BGL 
        M1 = 1
        M2 = M1 + NSTATE*NSTX+MOD((NSTATE*NSTX),2)
        M3 = M2 + NSTATE*NSTX+MOD((NSTATE*NSTX),2)
        M4 = M3 + NSTATE*NSTX+MOD((NSTATE*NSTX),2)
        M5 = M4 + NSTATE*NSTX+MOD((NSTATE*NSTX),2)
        M6 = M5 + NSTATE*NSTX+MOD((NSTATE*NSTX),2)
        MF = M6 + NSTATE*NSTX+MOD((NSTATE*NSTX),2)
#else
        M1 = 1
        M2 = M1 + NSTATE*NSTX
        M3 = M2 + NSTATE*NSTX
        M4 = M3 + NSTATE*NSTX
        M5 = M4 + NSTATE*NSTX
        M6 = M5 + NSTATE*NSTX
        MF = M6 + NSTATE*NSTX
#endif
        CALL RORTHO_DA(C0,CM,GAM,SCR(M1),SCR(M2),SCR(M3),SCR(M4),
     *                 SCR(M5),SCR(M6),TNON,NSTATE)
        IF(PRTEIG.AND.PARENT) THEN
          WRITE(6,*) " WARNING: NO EIGENVALUE PRINTING ",
     *               "WITH DISTRIBUTED LINALG"
        ENDIF
      ELSE
#ifdef _BGL 
        M1 = 1
        M2 = M1 + NSTATE*NSTATE
        M3 = M2 + NSTATE*NSTATE
        M4 = M3 + NSTATE*NSTATE
        M5 = M4 + NSTATE*NSTATE
        MF = M5 + NSTATE*NSTATE+MOD((NSTATE*NSTATE),2)
#else
        M1 = 1
        M2 = M1 + NSTATE*NSTATE+MOD((NSTATE*NSTATE),2)
        M3 = M2 + NSTATE*NSTATE+MOD((NSTATE*NSTATE),2)
        M4 = M3 + NSTATE*NSTATE+MOD((NSTATE*NSTATE),2)
        M5 = M4 + NSTATE*NSTATE+MOD((NSTATE*NSTATE),2)
        MF = M5 + NSTATE*NSTATE+MOD((NSTATE*NSTATE),2)
#endif
        CALL RORTHO(C0,CM,GAM,SCR(M1),SCR(M2),SCR(M3),SCR(M4),
     +            SCR(M5),TNON,NSTATE)
#ifdef _BGL 
        M2 = M1 + NSTATE*NSTATE+MOD((NSTATE*NSTATE),2)
        M3 = M2 + 3*NSTATE+MOD((3*NSTATE),2)
        MF = M3 + NSTATE+MOD((NSTATE),2)
#else
        M2 = M1 + NSTATE*NSTATE
        M3 = M2 + 3*NSTATE
        MF = M3 + NSTATE
#endif
        IF(PRTEIG.AND.PARENT) THEN
          PFAC=2.0D0/DT2BYE
          CALL DSCAL(NSTATE*NSTATE,PFAC,GAM(1),1)
          CALL REIGS(NSTATE,GAM,F,SCR(M2),SCR(M3),SCR(M1))
          PFAC=1.0D0/PFAC
          CALL DSCAL(NSTATE*NSTATE,PFAC,GAM(1),1)
        ENDIF
      ENDIF
      CALL TIHALT('    RORTOG',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RORTHO(C0,CM,GAM,GAMN,SCR,SIG,RHO,DEL,
     *                  TNON,NSTATE)
C     ==--------------------------------------------------------------==
C     == INPUT:                                                       ==
C     ==       C0 (ORTHONORMAL)                                       ==
C     ==       CM (NON-ORTHONORMAL)                                   ==
C     == OUTPUT:                                                      ==
C     ==       GAM                                                    ==
C     ==       CM (ORTHONORMAL)                                       ==
C     == METHOD USED:                                                 ==
C     ==                                                              ==
C     == ITERATIVE ALGORITHM PARRINELLO-CAR LES HOUCHES 1988          ==
C     == EQS. 18-22. IMPLEMENTATION ZURICH 1989, A.NOBILE             ==
C     ==                                                              ==
C     == WITH RESPECT TO PREVIOUS VERSIONS OF THIS ROUTINE, THIS ONE: ==
C     == -)FOLLOWS EXACTLY THE REFERENCE;                             ==
C     == 1)SAVES ONE EVALUATION OF SIGMA BY NOTICING THAT             ==
C     == THE VALUE OF SIGMA FROM THE UPDATED WAVEFUNCTION IS          ==
C     == EQUAL TO TWICE THE NEXT VALUE OF GAMN - GAM,                 ==
C     == WHICH IS EXPECTED TO BE LESS THAN THE CURRENT ONE            ==
C     == THEREFORE, CONVERGENCE OF GAM GUARANTEES CONVERGENCE OF SIG  ==
C     == 2)SAVES ONE MATRIX PRODUCT PER ITERATION BECAUSE             ==
C     == SIG+TRANS(RHO)*G+G*RHO-G*G = SIG + TRANS(RHO)*RHO -          ==
C     ==                                  - TRANS(RHO-G)*(RHO-G)      ==
C     ==                                                              ==
C     == TO FOLLOW CLOSELY THE REFERENCE, THE INPUT VALUE OF GAM IS   ==
C     == IGNORED, AND AS AN INITIAL VALUE WE USE 0.5*SIG              ==
C     == THE ALGORITHM, LIKE ITS PREDECESSORS, IGNORES THE REAL       ==
C     == PARTS OF EVERYTHING (EXCEPT OF THE WAVEFUNCTIONS)            ==
C     ==                                                              ==
C     == CODE FOR HARMONIC REFERENCE SYSTEM ADDED                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER NSTATE
      REAL*8  C0(*),CM(*),
     &        GAM(*),GAMN(*),SCR(*),SIG(NSTATE,*),RHO(NSTATE,*),
     *        DEL(NSTATE,*)
      LOGICAL TNON
C     Variables
      REAL*8  DIFGAM
      INTEGER I,J,II,ITER,
     &        IDAMAX
#ifdef PARALLEL
      INTEGER MSGLEN
#endif
C     ==--------------------------------------------------------------==
C     == INITIALIZE RHO                                               ==
C     ==--------------------------------------------------------------==
      CALL OVLAP(NSTATE,RHO,C0,CM)
      CALL SYMMA(RHO,NSTATE)
#ifdef PARALLEL
      CALL SUMMAT_PARENT(RHO,NSTATE,DEL,NSTATE*NSTATE)
#endif
      CALL DSCAL(NSTATE*NSTATE,-1.0D0,RHO(1,1),1)
C$OMP parallel do private(I)
      DO I=1,NSTATE
        RHO(I,I)=1.0D0+RHO(I,I)
      ENDDO
C     ==--------------------------------------------------------------==
C     == INITIALIZE SIG                                               ==
C     ==--------------------------------------------------------------==
      CALL OVLAP(NSTATE,SIG,CM,CM)
#ifdef PARALLEL
      CALL SUMMAT_PARENT(SIG,NSTATE,DEL,NSTATE*NSTATE)
#endif
      CALL DSCAL(NSTATE*NSTATE,-1.0D0,SIG(1,1),1)
C$OMP parallel do private(I)
      DO I=1,NSTATE
        SIG(I,I)=1.0D0+SIG(I,I)
      ENDDO
C     ==--------------------------------------------------------------==
C     == INITIALIZE DEL                                               ==
C     ==--------------------------------------------------------------==
      IF(TNON) THEN
        CALL OVLAP(NSTATE,DEL,C0,C0)
#ifdef PARALLEL
        CALL SUMMAT_PARENT(DEL,NSTATE,GAM,NSTATE*NSTATE)
#endif
C$OMP parallel do private(I)
        DO I=1,NSTATE
          DEL(I,I)=DEL(I,I)-1.0D0
        ENDDO
        CALL DSCAL(NSTATE*NSTATE,-0.5D0,DEL(1,1),1)
      ENDIF
      IF(PARENT) THEN
C     ==--------------------------------------------------------------==
C     == INITIALIZE GAM                                               ==
C     ==--------------------------------------------------------------==
C$OMP parallel do private(I,J,II)
        DO J=1,NSTATE
          DO I=1,NSTATE
            II=I+(J-1)*NSTATE
            GAM(II)=SIG(I,J)*0.5D0
          ENDDO
        ENDDO
C     ==--------------------------------------------------------------==
C     == INITIALIZE FIXED TERM OF RECURRENCE                          ==
C     ==--------------------------------------------------------------==
        CALL DGEMM('T','N',NSTATE,NSTATE,NSTATE,0.5D0,RHO(1,1),NSTATE,
     *             RHO(1,1),NSTATE,0.5D0,SIG(1,1),NSTATE)
        ITER=0
C     ==--------------------------------------------------------------==
C     == ITERATIVE LOOP                                               ==
C     ==--------------------------------------------------------------==
100     CONTINUE
          ITER=ITER+1
          CALL DCOPY(NSTATE*NSTATE,SIG(1,1),1,GAMN(1),1)
C$OMP parallel do private(I,J,II)
          DO J=1,NSTATE
            DO I=1,NSTATE
              II=I+(J-1)*NSTATE
              SCR(II)=RHO(I,J)-GAM(II)
            ENDDO
          ENDDO
          CALL DGEMM('T','N',NSTATE,NSTATE,NSTATE,-0.5D0,
     *               SCR,NSTATE,SCR,NSTATE,1.0D0,GAMN(1),NSTATE)
          IF(TNON) THEN
            CALL DGEMM('N','N',NSTATE,NSTATE,NSTATE,1.0D0,
     *           DEL(1,1),NSTATE,GAM(1),NSTATE,0.0D0,SCR(1),NSTATE)
            CALL DGEMM('T','N',NSTATE,NSTATE,NSTATE,1.0D0,
     *           GAM(1),NSTATE,SCR(1),NSTATE,1.0D0,GAMN(1),NSTATE)
          ENDIF
#ifdef _BGL 
      CALL ALIGNX(16,SCR(1))
      CALL ALIGNX(16,GAMN(1))
      CALL ALIGNX(16,GAM(1))
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
C$OMP parallel do private(I)
          DO I=1,NSTATE*NSTATE
            SCR(I)=GAMN(I)-GAM(I)
          ENDDO
          CALL DCOPY(NSTATE*NSTATE,GAMN(1),1,GAM(1),1)
          DIFGAM=DABS(SCR(IDAMAX(NSTATE*NSTATE,SCR,1)))
        IF(DIFGAM.GT.EPSOG*0.5D0.AND.ITER.LE.MAXIT)GOTO 100
        IF(ITER.GT.MAXIT)THEN
          PRINT *, 'RORTHO:DIFGAM=',DIFGAM,' ITER = ',ITER,' > ',MAXIT
          PRINT *, '       MAXIMUM NUMBER OF ITERATIONS EXCEEDED'
          CALL STOPGM('RORTOG',' ')
        ENDIF
        CALL SYMMA(GAM,NSTATE)
      ENDIF
#ifdef PARALLEL
      MSGLEN = NSTATE*NSTATE * 8
      CALL MY_BCAST(GAM,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
C     == UPDATE WAVEFUNCTIONS                                         ==
C     ==--------------------------------------------------------------==
      CALL ROTATE(1.0D0,C0,1.0D0,CM,GAM,NSTATE,2*NGW,TLSD,
     *            NSUP,NSDOWN)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RORTHO_DA(C0,CM,GAM,GAMN,SCR,SIG,RHO,DEL,SXX,
     *                     TNON,NSTATE)
C     ==--------------------------------------------------------------==
C     == INPUT:                                                       ==
C     ==       C0 (ORTHONORMAL)                                       ==
C     ==       CM (NON-ORTHONORMAL)                                   ==
C     == OUTPUT:                                                      ==
C     ==       GAM                                                    ==
C     ==       CM (ORTHONORMAL)                                       ==
C     == METHOD USED:                                                 ==
C     ==                                                              ==
C     == ITERATIVE ALGORITHM PARRINELLO-CAR LES HOUCHES 1988          ==
C     == EQS. 18-22. IMPLEMENTATION ZURICH 1989, A.NOBILE             ==
C     ==                                                              ==
C     == CODE FOR HARMONIC REFERENCE SYSTEM ADDED                     ==
C     ==                                                              ==
C     == SPECIAL VERSION FOR DISTRIBUTED MATRICES                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
C     Arguments
      INTEGER NSTATE
      COMPLEX*16  C0(NGW,*),CM(NGW,*)
      REAL*8  GAM(*),GAMN(*),SCR(*),SIG(NSTATE,*),RHO(NSTATE,*),
     *        DEL(NSTATE,*),SXX(*)
      LOGICAL TNON
C     Variables
      REAL*8  DIFGAM
C     Variables
      INTEGER I,II,ITER,
     &        IDAMAX,I1,IPP,IP,NX,NSTX
      EXTERNAL IDAMAX
      INTEGER MSGLEN
C     ==--------------------------------------------------------------==
      CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
C..INITIALIZE RHO, SIG, AND DEL
      CALL AZZERO(RHO,NSTATE*NSTX)
      CALL AZZERO(SIG,NSTATE*NSTX)
      CALL AZZERO(DEL,NSTATE*NSTX)
      MSGLEN=NSTATE*NSTX * 8
      DO IP=0,NPROC-1
        NX=NWA12(IP,2)-NWA12(IP,1)+1
        CALL AZZERO(GAM,NSTATE*NSTX)
        IF(NX.GT.0) THEN
          CALL OVLAP2(NGW,NSTATE,NX,GAM,C0,CM(1,NWA12(IP,1)))
          CALL MY_COMBINE_SOURCE(GAM,SCR,MSGLEN,1,PGROUP(IP+1),ALLGRP)
          IF(MEPOS.EQ.PGROUP(IP+1)) CALL DCOPY(NSTATE*NSTX,SCR,1,RHO,1)
        ENDIF
      ENDDO
C   
      DO IP=0,NPROC-1
        NX=NWA12(IP,2)-NWA12(IP,1)+1
        CALL AZZERO(GAM,NSTATE*NSTX)
        IF(NX.GT.0) THEN
          CALL OVLAP2(NGW,NSTATE,NX,GAM,CM,CM(1,NWA12(IP,1)))
          CALL MY_COMBINE_SOURCE(GAM,SCR,MSGLEN,1,PGROUP(IP+1),ALLGRP)
          IF(MEPOS.EQ.PGROUP(IP+1)) CALL DCOPY(NSTATE*NSTX,SCR,1,SIG,1)
        ENDIF
      ENDDO
      IF(TNON) THEN
        DO IP=0,NPROC-1
          NX=NWA12(IP,2)-NWA12(IP,1)+1
          CALL AZZERO(GAM,NSTATE*NSTX)
          IF(NX.GT.0) THEN
            CALL OVLAP2(NGW,NSTATE,NX,GAM,C0,C0(1,NWA12(IP,1)))
            CALL MY_COMBINE_SOURCE(GAM,SCR,MSGLEN,1,PGROUP(IP+1),ALLGRP)
            IF(MEPOS.EQ.PGROUP(IP+1)) 
     &                  CALL DCOPY(NSTATE*NSTX,SCR,1,DEL,1)
          ENDIF
        ENDDO
      ENDIF
      CALL DSCAL(NSTATE*NSTX,-1.0D0,RHO,1)
      CALL DSCAL(NSTATE*NSTX,-1.0D0,SIG,1)
      DO I=NWA12(MEPOS,1),NWA12(MEPOS,2)
        II=I-NWA12(MEPOS,1)+1
        RHO(I,II)=1.0D0+RHO(I,II)
        SIG(I,II)=1.0D0+SIG(I,II)
      ENDDO
      IF(TNON) THEN
        DO I=NWA12(MEPOS,1),NWA12(MEPOS,2)
          II=I-NWA12(MEPOS,1)+1
          DEL(I,II)=DEL(I,II)-1.0D0
        ENDDO
        CALL DSCAL(NSTATE*NSTX,-0.5D0,DEL,1)
      ENDIF
C..INITIALIZE GAM
      CALL DCOPY(NSTATE*NSTX,SIG,1,GAM,1)
      CALL DSCAL(NSTATE*NSTX,0.5D0,GAM,1)
C..INITIALIZE FIXED TERM OF RECURRENCE
      MSGLEN=NSTATE*NSTX * 8
      CALL DCOPY(NSTATE*NSTX,RHO,1,SCR,1)
      CALL DCOPY(NSTATE*NSTX,RHO,1,SXX,1)
      DO IP=0,NPROC-1
        I1=NWA12(IP,1)
        N=NWA12(IP,2)-NWA12(IP,1)+1
        IF(N.GT.0) THEN
          CALL DCOPY(NSTATE*NSTX,SCR,1,RHO,1)
          CALL MY_BCAST(RHO,MSGLEN,PGROUP(IP+1),ALLGRP)
          CALL DGEMM('T','N',N,NSTX,NSTATE,0.5D0,RHO,NSTATE,
     *               SXX,NSTATE,0.5D0,SIG(I1,1),NSTATE)
        ENDIF
      ENDDO
      ITER=0
      CALL DCOPY(NSTATE*NSTX,SCR,1,RHO,1)
100   CONTINUE
        ITER=ITER+1
        CALL DCOPY(NSTATE*NSTX,SIG,1,GAMN,1)
        DO I=1,NSTATE*NSTX
          SCR(I)=RHO(I,1)-GAM(I)
        ENDDO
        MSGLEN=NSTATE*NSTX * 8
        CALL DCOPY(NSTATE*NSTX,SCR,1,SXX,1)
        CALL DCOPY(NSTATE*NSTX,SCR,1,DEL,1)
        DO IP=0,NPROC-1
          I1=NWA12(IP,1)
          N=NWA12(IP,2)-NWA12(IP,1)+1
          IF(N.GT.0) THEN
            CALL DCOPY(NSTATE*NSTX,SXX,1,SCR,1)
            CALL MY_BCAST(SCR,MSGLEN,PGROUP(IP+1),ALLGRP)
            CALL DGEMM('T','N',N,NSTX,NSTATE,-0.5D0,SCR,NSTATE,
     *             DEL,NSTATE,1.D0,GAMN(I1),NSTATE)
          ENDIF
        ENDDO
        IF(TNON) THEN
          CALL AZZERO(SCR,NSTATE*NSTX)
          DO IP=0,NPROC-1
            CALL MY_SHIFT(DEL,SXX,MSGLEN,MEPOS,-IP,ALLGRP)
            IPP=MOD(MEPOS+IP,NPROC)
            N=NWA12(IPP,2)-NWA12(IPP,1)+1
            I1=NWA12(IPP,1)
            CALL DGEMM('N','N',NSTATE,NSTX,N,1.D0,SXX,NSTATE,
     *                 GAM(I1),NSTATE,1.D0,SCR,NSTATE)
          ENDDO
          DO IP=0,NPROC-1
            CALL MY_SHIFT(GAM,SXX,MSGLEN,MEPOS,-IP,ALLGRP)
            IPP=MOD(MEPOS+IP,NPROC)
            N=NWA12(IPP,2)-NWA12(IPP,1)+1
            I1=NWA12(IPP,1)
            CALL DGEMM('T','N',N,NSTX,NSTATE,1.D0,SXX,NSTATE,
     *                 SCR,NSTATE,1.D0,GAMN(I1),NSTATE)
          ENDDO
        ENDIF
#ifdef _BGL 
      CALL ALIGNX(16,SCR(1))
      CALL ALIGNX(16,GAMN(1))
      CALL ALIGNX(16,GAM(1))
!IBM* ASSERT (ITERCNT(10000))
!IBM* INDEPENDENT
#endif
        DO I=1,NSTATE*NSTX
          SCR(I)=GAMN(I)-GAM(I)
        ENDDO
        CALL DCOPY(NSTATE*NSTX,GAMN,1,GAM,1)
        DIFGAM=DABS(SCR(IDAMAX(NSTATE*NSTX,SCR,1)))
        CALL GLOMAX(1,DIFGAM)
      IF(DIFGAM.GT.EPSOG*0.5D0.AND.ITER.LE.MAXIT)GOTO 100
C
      IF(ITER.GT.MAXIT.AND.PARENT)THEN
        PRINT *, 'RORTHO:DIFGAM=',DIFGAM,' ITER = ',ITER,' > ',MAXIT
        PRINT *, '       MAXIMUM NUMBER OF ITERATIONS EXCEEDED'
        CALL STOPGM('RORTOG','NOT CONVERGED')
      ENDIF
C..UPDATE WAVEFUNCTIONS
      CALL ROTATE_DA(1.D0,C0,1.D0,CM,GAM,SCR,2*NGW,NSTATE,
     *       NWA12(0,1),NWA12(0,2),NSTX,MEPOS,PGROUP,NPROC,ALLGRP,
     *       TLSD,NSUP,NSDOWN)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RORTOG(LRORTOG,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER   LRORTOG,NSTATE
      CHARACTER TAG*30
      INTEGER   NSTX
C     ==--------------------------------------------------------------==
      IF(TDMAL) THEN
        CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
        LRORTOG=MAX(6*NSTATE*NSTX,NSTATE*(4+NSTX))
        TAG   ='MAX(6*NSTATE*NSTX,...)'
      ELSE
        LRORTOG=MAX(5*NSTATE*NSTATE,NSTATE*(4+NSTATE))
        TAG   ='MAX(5*NSTATE*NSTATE,...)'
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
