C     ==================================================================
      SUBROUTINE RORTV(C0,CM,C2,SC0,GAMY,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'harm.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'nort.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 C0(NGW,NSTATE),CM(NGW,NSTATE),C2(NGW,*),SC0(NGW,*)
      REAL*8     GAMY(NSTATE,NSTATE),SCR(LSCR)
      REAL*8     A1MAT(NSTATE,*),A2MAT(NSTATE,*)
      POINTER    (IP_A1MAT,A1MAT),(IP_A2MAT,A2MAT)
C     Variables
      CHARACTER  TAG*30
      REAL*8     S2,PF4,AI,BI,YI,
     &           DOTP
      EXTERNAL   DOTP
      INTEGER    I,IG,IPS1,IPS2,IPS3,IPS4,IPST,J,LRORTV,IP
      INTEGER    MSGLEN,NX,NSTX
      LOGICAL    DEBUG
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_RORTV(LRORTV,TAG,NSTATE)
      CALL TEST_SCR('RORTV',TAG,LSCR,LRORTV)
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
C     ==--------------------------------------------------------------==
      IF(NONORT) THEN
C       Norm constraints
        DO I=1,NSTATE
          IF(THARM.OR.TMASS) THEN
            S2=0.0D0
            IF(THARM) THEN
!$OMP parallel do private(IG,PF4,AI,BI) reduction(+:S2)
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT, NEW(PF4,AI,BI), REDUCTION(S2)
#endif
              DO IG=1,NGW
                PF4=2.0D0*DTAN2W(IG)/DTB2ME
                AI=DREAL(C0(IG,I))
                BI=DIMAG(C0(IG,I))
                S2=S2+PF4*(AI*AI+BI*BI)
              ENDDO
            ELSE
!$OMP parallel do private(IG,PF4,AI,BI) reduction(+:S2)
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT, NEW(PF4,AI,BI), REDUCTION(S2)
#endif
              DO IG=1,NGW
                PF4=2.0D0*EMASS/XMU(IG)
                AI=DREAL(C0(IG,I))
                BI=DIMAG(C0(IG,I))
                S2=S2+PF4*(AI*AI+BI*BI)
              ENDDO
            ENDIF
#ifdef PARALLEL
            CALL GLOSUM(1,S2)
#endif      
            IF(GEQ0) THEN
              IF(THARM) THEN
                PF4=DTAN2W(1)/DTB2ME
              ELSE
                PF4=EMASS/XMU(1)
              ENDIF
            ENDIF
            YI=-DOTP(NGW,CM(1,I),C0(1,I))/S2
#ifdef PARALLEL
            CALL GLOSUM(1,YI)
#endif      
            IF(THARM) THEN
!$OMP parallel do private(IG,PF4)
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT, NEW(PF4)
#endif
              DO IG=1,NGW
                PF4=DTAN2W(IG)/DTB2ME
                CM(IG,I)=CM(IG,I)+PF4*YI*C0(IG,I)
              ENDDO
            ELSE
!$OMP parallel do private(IG,PF4)
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT, NEW(PF4)
#endif
              DO IG=1,NGW
                PF4=EMASS/XMU(IG)
                CM(IG,I)=CM(IG,I)+PF4*YI*C0(IG,I)
              ENDDO
            ENDIF
          ELSE
            YI=-DOTP(NGW,CM(1,I),C0(1,I))
#ifdef PARALLEL
            CALL GLOSUM(1,YI)
#endif      
            CALL DAXPY(2*NGW,YI,C0(1,I),1,CM(1,I),1)
          ENDIF
        ENDDO
C       UNITARY ROTATION?
        IF(SCOND.GT.SLIMIT)
     *       CALL CROTWF(C0,CM,C2,SC0,NSTATE,GAMY,SCR,LSCR)
      ELSE
C       Overlap constraints
        IF(THARM.OR.TMASS) THEN
#ifdef _BGL 
          IPS1=1
          IPS2=IPS1+NSTATE*NSTATE+MOD(NSTATE*NSTATE,2)
          IPS3=IPS2+NSTATE*NSTATE+MOD(NSTATE*NSTATE,2)
          IPS4=IPS3+NSTATE*NSTATE+MOD(NSTATE*NSTATE,2)
          IPST=IPS4+MAX(NSTATE*NSTATE,3*NSTATE)
#else
          IPS1=1
          IPS2=IPS1+NSTATE*NSTATE
          IPS3=IPS2+NSTATE*NSTATE
          IPS4=IPS3+NSTATE*NSTATE
          IPST=IPS4+MAX(NSTATE*NSTATE,3*NSTATE)
#endif
          IF(IPST.GT.LSCR) CALL STOPGM('RORTV','SCRATCH SPACE')
          CALL RVHARM(C0,CM,GAMY,SCR(IPS1),SCR(IPS2),SCR(IPS3),
     *         SCR(IPS4),NSTATE)
        ELSE
          IF(TDMAL) THEN
            CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
            CALL SCRSET(SCR,LSCR,DEBUG)
            NX=NSTATE*NSTX+(MOD(NSTATE*NSTX,2))
            CALL SCRPTR(SCR,LSCR,IP_A1MAT,NX,'A1MAT',DEBUG)
            CALL SCRPTR(SCR,LSCR,IP_A2MAT,NX,'A2MAT',DEBUG)
            MSGLEN=NSTATE*NSTX * 8
            CALL AZZERO(GAMY,NSTATE*NSTX)
            DO IP=0,NPROC-1
              NX=NWA12(IP,2)-NWA12(IP,1)+1
              CALL AZZERO(A1MAT,NSTATE*NSTX)
              IF(NX.GT.0) THEN
                CALL OVLAP2(NGW,NSTATE,NX,A1MAT,CM,C0(1,NWA12(IP,1)))
                CALL MY_COMBINE_SOURCE(A1MAT,A2MAT,MSGLEN,1,
     *                                 PGROUP(IP+1),ALLGRP)
                IF(MEPOS.EQ.PGROUP(IP+1)) 
     *             CALL DCOPY(NSTATE*NSTX,A2MAT,1,GAMY,1)
              ENDIF
            ENDDO
            CALL DSCAL(NSTATE*NSTX,-1.0D0,GAMY,1)
            CALL SYMM_DA(GAMY,A1MAT,A2MAT,NSTATE,
     *              NWA12(0,1),NWA12(0,2),NSTX,MEPOS,NPROC,ALLGRP)
            CALL ROTATE_DA(1.D0,C0(1,1),1.D0,CM(1,1),GAMY,
     *              A1MAT,2*NGW,NSTATE,NWA12(0,1),NWA12(0,2),
     *              NSTX,MEPOS,PGROUP,NPROC,ALLGRP,
     *              TLSD,NSUP,NSDOWN)
            CALL SCRREL(SCR,LSCR,DEBUG)
          ELSE
            CALL OVLAP(NSTATE,GAMY,CM,C0)
            CALL GLOSUM(NSTATE*NSTATE,GAMY)
!$OMP parallel do private(I,J) schedule(static,1)
            DO I=1,NSTATE
              DO J=I+1,NSTATE
                GAMY(I,J)=-0.5D0*(GAMY(I,J)+GAMY(J,I))
                GAMY(J,I)=GAMY(I,J)
              ENDDO
              GAMY(I,I)=-GAMY(I,I)
            ENDDO
            CALL ROTATE(1.0D0,C0,1.0D0,CM,GAMY,NSTATE,2*NGW,TLSD,
     *                  NSUP,NSDOWN)
          ENDIF
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#if defined(__VECTOR) && !(__SR8000)
C     ==================================================================
      SUBROUTINE RVHARM(C0,CM,GAMY,S1,S2,S3,S4,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'harm.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,NSTATE),CM(NGW,NSTATE)
      REAL*8     GAMY(NSTATE,*),
     &           S1(NSTATE,*),S2(NSTATE,*),S3(NSTATE,*),S4(NSTATE,*)
C     Variables
      REAL*8     TOL,PF4,AI,BI,AJ,BJ,DGMAX,DGAM,GIJ,TEMP
      INTEGER    I,JMAX,J,IG,ITER,MODI,MODJ
      REAL*8     GIJ00,GIJ01,GIJ02,GIJ03,GIJ04,GIJ05,GIJ06,GIJ07,
     &           GIJ10,GIJ11,GIJ12,GIJ13,GIJ14,GIJ15,GIJ16,GIJ17,
     &           GIJ20,GIJ21,GIJ22,GIJ23,GIJ24,GIJ25,GIJ26,GIJ27,
     &           GIJ30,GIJ31,GIJ32,GIJ33,GIJ34,GIJ35,GIJ36,GIJ37,
     &           GIJ40,GIJ41,GIJ42,GIJ43,GIJ44,GIJ45,GIJ46,GIJ47,
     &           GIJ50,GIJ51,GIJ52,GIJ53,GIJ54,GIJ55,GIJ56,GIJ57,
     &           GIJ60,GIJ61,GIJ62,GIJ63,GIJ64,GIJ65,GIJ66,GIJ67,
     &           GIJ70,GIJ71,GIJ72,GIJ73,GIJ74,GIJ75,GIJ76,GIJ77
      REAL*8     AJ0,AJ1,AJ2,AJ3,AJ4,AJ5,AJ6,AJ7,
     &           BJ0,BJ1,BJ2,BJ3,BJ4,BJ5,BJ6,BJ7,
     &           T0,T1,T2,T3,T4,T5,T6,T7
      REAL*8     FDTB2ME,WDTB2ME
C     ==--------------------------------------------------------------==
      TOL = EPSOG
      FDTB2ME=1.0D0/DTB2ME
      WDTB2ME=2.0D0*FDTB2ME
      CALL OVLAP(NSTATE,S1,CM,C0)
#ifdef PARALLEL
      CALL GLOSUM(NSTATE*NSTATE,S1)
#endif
      CALL AZZERO(S2,NSTATE*NSTATE)
      IF(THARM) THEN 
        PF4=DTAN2W(1)*FDTB2ME
!$OMP parallel do private(I,J,IG,JMAX,AI,BI,AJ,BJ,TEMP,MODJ,
!$OMP+ AJ0,AJ1,AJ2,AJ3,AJ4,AJ5,AJ6,AJ7,
!$OMP+ BJ0,BJ1,BJ2,BJ3,BJ4,BJ5,BJ6,BJ7,
!$OMP+ T0,T1,T2,T3,T4,T5,T6,T7)
!$OMP+ schedule(static,1)
        DO I=1,NSTATE
          JMAX=NSTATE
          IF(TLSD.AND.I.LE.NSUP) JMAX=NSUP
          MODJ=MOD(JMAX-I+1,8)
          DO J=I,I+MODJ-1
            TEMP=0.0D0
            DO IG=1,NGW
              AI=DREAL(C0(IG,I))
              BI=DIMAG(C0(IG,I))
              AJ=DREAL(C0(IG,J))
              BJ=DIMAG(C0(IG,J))
              TEMP=TEMP+DTAN2W(IG)*(AI*AJ+BI*BJ)
            ENDDO
            S2(I,J)=WDTB2ME*TEMP
            IF(GEQ0) S2(I,J)=S2(I,J)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J))
            S2(J,I)=S2(I,J)
          ENDDO
          DO J=I+MODJ,JMAX,8
            T0=0.0D0
            T1=0.0D0
            T2=0.0D0
            T3=0.0D0
            T4=0.0D0
            T5=0.0D0
            T6=0.0D0
            T7=0.0D0
            DO IG=1,NGW
              AI =DREAL(C0(IG,I  ))
              BI =DIMAG(C0(IG,I  ))
              AJ0=DREAL(C0(IG,J  ))
              AJ1=DREAL(C0(IG,J+1))
              AJ2=DREAL(C0(IG,J+2))
              AJ3=DREAL(C0(IG,J+3))
              AJ4=DREAL(C0(IG,J+4))
              AJ5=DREAL(C0(IG,J+5))
              AJ6=DREAL(C0(IG,J+6))
              AJ7=DREAL(C0(IG,J+7))
              BJ0=DIMAG(C0(IG,J  ))
              BJ1=DIMAG(C0(IG,J+1))
              BJ2=DIMAG(C0(IG,J+2))
              BJ3=DIMAG(C0(IG,J+3))
              BJ4=DIMAG(C0(IG,J+4))
              BJ5=DIMAG(C0(IG,J+5))
              BJ6=DIMAG(C0(IG,J+6))
              BJ7=DIMAG(C0(IG,J+7))
              T0=T0+DTAN2W(IG)*(AI*AJ0+BI*BJ0)
              T1=T1+DTAN2W(IG)*(AI*AJ1+BI*BJ1)
              T2=T2+DTAN2W(IG)*(AI*AJ2+BI*BJ2)
              T3=T3+DTAN2W(IG)*(AI*AJ3+BI*BJ3)
              T4=T4+DTAN2W(IG)*(AI*AJ4+BI*BJ4)
              T5=T5+DTAN2W(IG)*(AI*AJ5+BI*BJ5)
              T6=T6+DTAN2W(IG)*(AI*AJ6+BI*BJ6)
              T7=T7+DTAN2W(IG)*(AI*AJ7+BI*BJ7)
            ENDDO
            S2(I,J  )=WDTB2ME*T0
            S2(I,J+1)=WDTB2ME*T1
            S2(I,J+2)=WDTB2ME*T2
            S2(I,J+3)=WDTB2ME*T3
            S2(I,J+4)=WDTB2ME*T4
            S2(I,J+5)=WDTB2ME*T5
            S2(I,J+6)=WDTB2ME*T6
            S2(I,J+7)=WDTB2ME*T7
            IF(GEQ0) THEN 
              TEMP=PF4*DREAL(C0(1,I))
              S2(I,J  )=S2(I,J  )-TEMP*DREAL(C0(1,J  ))
              S2(I,J+1)=S2(I,J+1)-TEMP*DREAL(C0(1,J+1))
              S2(I,J+2)=S2(I,J+2)-TEMP*DREAL(C0(1,J+2))
              S2(I,J+3)=S2(I,J+3)-TEMP*DREAL(C0(1,J+3))
              S2(I,J+4)=S2(I,J+4)-TEMP*DREAL(C0(1,J+4))
              S2(I,J+5)=S2(I,J+5)-TEMP*DREAL(C0(1,J+5))
              S2(I,J+6)=S2(I,J+6)-TEMP*DREAL(C0(1,J+6))
              S2(I,J+7)=S2(I,J+7)-TEMP*DREAL(C0(1,J+7))
            ENDIF 
            S2(J  ,I)=S2(I,J  )
            S2(J+1,I)=S2(I,J+1)
            S2(J+2,I)=S2(I,J+2)
            S2(J+3,I)=S2(I,J+3)
            S2(J+4,I)=S2(I,J+4)
            S2(J+5,I)=S2(I,J+5)
            S2(J+6,I)=S2(I,J+6)
            S2(J+7,I)=S2(I,J+7)
          ENDDO
          DO J=JMAX+1,NSTATE
            S2(I,J)=0.0D0
            S2(J,I)=0.0D0
          ENDDO
        ENDDO  
      ELSE 
        PF4=EMASS/XMU(1)
!$OMP parallel do private(I,J,IG,JMAX,AI,BI,AJ,BJ,TEMP,MODJ,
!$OMP+ AJ0,AJ1,AJ2,AJ3,AJ4,AJ5,AJ6,AJ7,
!$OMP+ BJ0,BJ1,BJ2,BJ3,BJ4,BJ5,BJ6,BJ7,
!$OMP+ T0,T1,T2,T3,T4,T5,T6,T7)
!$OMP+ schedule(static,1)
        DO I=1,NSTATE
          JMAX=NSTATE
          IF(TLSD.AND.I.LE.NSUP) JMAX=NSUP
          MODJ=MOD(JMAX-I+1,8)
          DO J=I,I+MODJ-1
            TEMP=0.0D0
            DO IG=1,NGW
              AI=DREAL(C0(IG,I))
              BI=DIMAG(C0(IG,I))
              AJ=DREAL(C0(IG,J))
              BJ=DIMAG(C0(IG,J))
              TEMP=TEMP+(AI*AJ+BI*BJ)/XMU(IG)
            ENDDO
            S2(I,J)=2.0D0*EMASS*TEMP
            IF(GEQ0) S2(I,J)=S2(I,J)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J))
            S2(J,I)=S2(I,J)
          ENDDO
          DO J=I+MODJ,JMAX,8
            T0=0.0D0
            T1=0.0D0
            T3=0.0D0
            T4=0.0D0
            T5=0.0D0
            T6=0.0D0
            T7=0.0D0
            DO IG=1,NGW
              AI =DREAL(C0(IG,I  ))
              BI =DIMAG(C0(IG,I  ))
              AJ0=DREAL(C0(IG,J  ))
              AJ1=DREAL(C0(IG,J+1))
              AJ2=DREAL(C0(IG,J+2))
              AJ3=DREAL(C0(IG,J+3))
              AJ4=DREAL(C0(IG,J+4))
              AJ5=DREAL(C0(IG,J+5))
              AJ6=DREAL(C0(IG,J+6))
              AJ7=DREAL(C0(IG,J+7))
              BJ0=DIMAG(C0(IG,J  ))
              BJ1=DIMAG(C0(IG,J+1))
              BJ2=DIMAG(C0(IG,J+2))
              BJ3=DIMAG(C0(IG,J+3))
              BJ4=DIMAG(C0(IG,J+4))
              BJ5=DIMAG(C0(IG,J+5))
              BJ6=DIMAG(C0(IG,J+6))
              BJ7=DIMAG(C0(IG,J+7))
              T0=T0+(AI*AJ0+BI*BJ0)/XMU(IG)
              T1=T1+(AI*AJ1+BI*BJ1)/XMU(IG)
              T2=T2+(AI*AJ2+BI*BJ2)/XMU(IG)
              T3=T3+(AI*AJ3+BI*BJ3)/XMU(IG)
              T4=T4+(AI*AJ4+BI*BJ4)/XMU(IG)
              T5=T5+(AI*AJ5+BI*BJ5)/XMU(IG)
              T6=T6+(AI*AJ6+BI*BJ6)/XMU(IG)
              T7=T7+(AI*AJ7+BI*BJ7)/XMU(IG)
            ENDDO
            S2(I,J  )=2.0D0*EMASS*T0
            S2(I,J+1)=2.0D0*EMASS*T1
            S2(I,J+2)=2.0D0*EMASS*T2
            S2(I,J+3)=2.0D0*EMASS*T3
            S2(I,J+4)=2.0D0*EMASS*T4
            S2(I,J+5)=2.0D0*EMASS*T5
            S2(I,J+6)=2.0D0*EMASS*T6
            S2(I,J+7)=2.0D0*EMASS*T7
            IF(GEQ0) THEN 
              S2(I,J  )=S2(I,J  )-PF4*DREAL(C0(1,I))*DREAL(C0(1,J  ))
              S2(I,J+1)=S2(I,J+1)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J+1))
              S2(I,J+2)=S2(I,J+2)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J+2))
              S2(I,J+3)=S2(I,J+3)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J+3))
              S2(I,J+4)=S2(I,J+4)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J+4))
              S2(I,J+5)=S2(I,J+5)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J+5))
              S2(I,J+6)=S2(I,J+6)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J+6))
              S2(I,J+7)=S2(I,J+7)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J+7))
            ENDIF 
            S2(J  ,I)=S2(I,J  )
            S2(J+1,I)=S2(I,J+1)
            S2(J+2,I)=S2(I,J+2)
            S2(J+3,I)=S2(I,J+3)
            S2(J+4,I)=S2(I,J+4)
            S2(J+5,I)=S2(I,J+5)
            S2(J+6,I)=S2(I,J+6)
            S2(J+7,I)=S2(I,J+7)
          ENDDO
          DO J=JMAX+1,NSTATE
            S2(I,J)=0.0D0
            S2(J,I)=0.0D0
          ENDDO
        ENDDO  
      ENDIF 
#ifdef PARALLEL
      CALL GLOSUM(NSTATE*NSTATE,S2)
#endif
      DO I=1,NSTATE
        S2(I,I)=S2(I,I)-1.0D0
      ENDDO
C     Initial Guess for GAMY
!$OMP parallel do private(I,J)
      DO J=1,NSTATE
        DO I=1,NSTATE
          GAMY(I,J)=-0.5D0*(S1(I,J)+S1(J,I))
          S4(I,J)=GAMY(I,J)
        ENDDO
      ENDDO  
C     Iteration
      ITER=0
 10   CONTINUE
      ITER=ITER+1
      CALL TEST_SCR('RHARMV','MAXIT',MAXIT,ITER)
      CALL DGEMM('N','N',NSTATE,NSTATE,NSTATE,1.0d0,S2,NSTATE,GAMY,
     *     NSTATE,0.0d0,S3,NSTATE)
      DGMAX=0.0d0
!$OMP parallel do private(I,J,DGAM) reduction(max:DGMAX)
      DO J=1,NSTATE
        DO I=1,NSTATE
          GAMY(I,J)=-0.5d0*(S1(I,J)+S1(J,I)+S3(I,J)+S3(J,I))
          DGAM = (GAMY(I,J)-S4(I,J))*(GAMY(I,J)-S4(I,J))
          DGMAX=DMAX1(DGMAX,DGAM)
          S4(I,J)=GAMY(I,J)
        ENDDO
      ENDDO  
      DGMAX=DSQRT(DGMAX)
      IF(DGMAX.GT.TOL) GOTO 10
C     Apply the constraint
      IF(THARM) THEN
        MODI=MOD(NSTATE,8)
        MODJ=MOD(NSTATE,8) 
!$OMP parallel do private(I,J,IG,GIJ,
!$OMP+ GIJ00,GIJ01,GIJ02,GIJ03,GIJ04,GIJ05,GIJ06,GIJ07)
        DO I=1,MODI 
          DO J=1,MODJ
            GIJ=GAMY(I,J)*FDTB2ME
            DO IG=1,NGW 
              CM(IG,I)=CM(IG,I)+DTAN2W(IG)*GIJ*C0(IG,J)
            ENDDO 
          ENDDO 
          DO J=MODJ+1,NSTATE,8 
            GIJ00=GAMY(I,J  )*FDTB2ME
            GIJ01=GAMY(I,J+1)*FDTB2ME
            GIJ02=GAMY(I,J+2)*FDTB2ME
            GIJ03=GAMY(I,J+3)*FDTB2ME
            GIJ04=GAMY(I,J+4)*FDTB2ME
            GIJ05=GAMY(I,J+5)*FDTB2ME
            GIJ06=GAMY(I,J+6)*FDTB2ME
            GIJ07=GAMY(I,J+7)*FDTB2ME
            DO IG=1,NGW 
              CM(IG,I  )=CM(IG,I  ) +DTAN2W(IG)*(GIJ00*C0(IG,J  )
     &        +GIJ01*C0(IG,J+1)+GIJ02*C0(IG,J+2)+GIJ03*C0(IG,J+3)
     &        +GIJ04*C0(IG,J+4)+GIJ05*C0(IG,J+5)+GIJ06*C0(IG,J+6)
     &        +GIJ07*C0(IG,J+7))
            ENDDO 
          ENDDO 
        ENDDO 
!$OMP parallel do private(I,J,IG,
!$OMP+ GIJ00,GIJ01,GIJ02,GIJ03,GIJ04,GIJ05,GIJ06,GIJ07,
!$OMP+ GIJ10,GIJ11,GIJ12,GIJ13,GIJ14,GIJ15,GIJ16,GIJ17,
!$OMP+ GIJ20,GIJ21,GIJ22,GIJ23,GIJ24,GIJ25,GIJ26,GIJ27,
!$OMP+ GIJ30,GIJ31,GIJ32,GIJ33,GIJ34,GIJ35,GIJ36,GIJ37,
!$OMP+ GIJ40,GIJ41,GIJ42,GIJ43,GIJ44,GIJ45,GIJ46,GIJ47,
!$OMP+ GIJ50,GIJ51,GIJ52,GIJ53,GIJ54,GIJ55,GIJ56,GIJ57,
!$OMP+ GIJ60,GIJ61,GIJ62,GIJ63,GIJ64,GIJ65,GIJ66,GIJ67,
!$OMP+ GIJ70,GIJ71,GIJ72,GIJ73,GIJ74,GIJ75,GIJ76,GIJ77)
        DO I=MODI+1,NSTATE,8 
          DO J=1,MODJ 
            GIJ00=GAMY(I  ,J)*FDTB2ME
            GIJ10=GAMY(I+1,J)*FDTB2ME
            GIJ20=GAMY(I+2,J)*FDTB2ME
            GIJ30=GAMY(I+3,J)*FDTB2ME
            GIJ40=GAMY(I+4,J)*FDTB2ME
            GIJ50=GAMY(I+5,J)*FDTB2ME
            GIJ60=GAMY(I+6,J)*FDTB2ME
            GIJ70=GAMY(I+7,J)*FDTB2ME
            DO IG=1,NGW 
              CM(IG,I  )=CM(IG,I  )+DTAN2W(IG)*GIJ00*C0(IG,J)
              CM(IG,I+1)=CM(IG,I+1)+DTAN2W(IG)*GIJ10*C0(IG,J)
              CM(IG,I+2)=CM(IG,I+2)+DTAN2W(IG)*GIJ20*C0(IG,J)
              CM(IG,I+3)=CM(IG,I+3)+DTAN2W(IG)*GIJ30*C0(IG,J)
              CM(IG,I+4)=CM(IG,I+4)+DTAN2W(IG)*GIJ40*C0(IG,J)
              CM(IG,I+5)=CM(IG,I+5)+DTAN2W(IG)*GIJ50*C0(IG,J)
              CM(IG,I+6)=CM(IG,I+6)+DTAN2W(IG)*GIJ60*C0(IG,J)
              CM(IG,I+7)=CM(IG,I+7)+DTAN2W(IG)*GIJ70*C0(IG,J)
            ENDDO 
          ENDDO 
          DO J=MODJ+1,NSTATE,8 
            GIJ00=GAMY(I  ,J  )*FDTB2ME
            GIJ10=GAMY(I+1,J  )*FDTB2ME
            GIJ20=GAMY(I+2,J  )*FDTB2ME
            GIJ30=GAMY(I+3,J  )*FDTB2ME
            GIJ40=GAMY(I+4,J  )*FDTB2ME
            GIJ50=GAMY(I+5,J  )*FDTB2ME
            GIJ60=GAMY(I+6,J  )*FDTB2ME
            GIJ70=GAMY(I+7,J  )*FDTB2ME
            GIJ01=GAMY(I  ,J+1)*FDTB2ME
            GIJ11=GAMY(I+1,J+1)*FDTB2ME
            GIJ21=GAMY(I+2,J+1)*FDTB2ME
            GIJ31=GAMY(I+3,J+1)*FDTB2ME
            GIJ41=GAMY(I+4,J+1)*FDTB2ME
            GIJ51=GAMY(I+5,J+1)*FDTB2ME
            GIJ61=GAMY(I+6,J+1)*FDTB2ME
            GIJ71=GAMY(I+7,J+1)*FDTB2ME
            GIJ02=GAMY(I  ,J+2)*FDTB2ME
            GIJ12=GAMY(I+1,J+2)*FDTB2ME
            GIJ22=GAMY(I+2,J+2)*FDTB2ME
            GIJ32=GAMY(I+3,J+2)*FDTB2ME
            GIJ42=GAMY(I+4,J+2)*FDTB2ME
            GIJ52=GAMY(I+5,J+2)*FDTB2ME
            GIJ62=GAMY(I+6,J+2)*FDTB2ME
            GIJ72=GAMY(I+7,J+2)*FDTB2ME
            GIJ03=GAMY(I  ,J+3)*FDTB2ME
            GIJ13=GAMY(I+1,J+3)*FDTB2ME
            GIJ23=GAMY(I+2,J+3)*FDTB2ME
            GIJ33=GAMY(I+3,J+3)*FDTB2ME
            GIJ43=GAMY(I+4,J+3)*FDTB2ME
            GIJ53=GAMY(I+5,J+3)*FDTB2ME
            GIJ63=GAMY(I+6,J+3)*FDTB2ME
            GIJ73=GAMY(I+7,J+3)*FDTB2ME
            GIJ04=GAMY(I  ,J+4)*FDTB2ME
            GIJ14=GAMY(I+1,J+4)*FDTB2ME
            GIJ24=GAMY(I+2,J+4)*FDTB2ME
            GIJ34=GAMY(I+3,J+4)*FDTB2ME
            GIJ44=GAMY(I+4,J+4)*FDTB2ME
            GIJ54=GAMY(I+5,J+4)*FDTB2ME
            GIJ64=GAMY(I+6,J+4)*FDTB2ME
            GIJ74=GAMY(I+7,J+4)*FDTB2ME
            GIJ05=GAMY(I  ,J+5)*FDTB2ME
            GIJ15=GAMY(I+1,J+5)*FDTB2ME
            GIJ25=GAMY(I+2,J+5)*FDTB2ME
            GIJ35=GAMY(I+3,J+5)*FDTB2ME
            GIJ45=GAMY(I+4,J+5)*FDTB2ME
            GIJ55=GAMY(I+5,J+5)*FDTB2ME
            GIJ65=GAMY(I+6,J+5)*FDTB2ME
            GIJ75=GAMY(I+7,J+5)*FDTB2ME
            GIJ06=GAMY(I  ,J+6)*FDTB2ME
            GIJ16=GAMY(I+1,J+6)*FDTB2ME
            GIJ26=GAMY(I+2,J+6)*FDTB2ME
            GIJ36=GAMY(I+3,J+6)*FDTB2ME
            GIJ46=GAMY(I+4,J+6)*FDTB2ME
            GIJ56=GAMY(I+5,J+6)*FDTB2ME
            GIJ66=GAMY(I+6,J+6)*FDTB2ME
            GIJ76=GAMY(I+7,J+6)*FDTB2ME
            GIJ07=GAMY(I  ,J+7)*FDTB2ME
            GIJ17=GAMY(I+1,J+7)*FDTB2ME
            GIJ27=GAMY(I+2,J+7)*FDTB2ME
            GIJ37=GAMY(I+3,J+7)*FDTB2ME
            GIJ47=GAMY(I+4,J+7)*FDTB2ME
            GIJ57=GAMY(I+5,J+7)*FDTB2ME
            GIJ67=GAMY(I+6,J+7)*FDTB2ME
            GIJ77=GAMY(I+7,J+7)*FDTB2ME
            DO IG=1,NGW 
              CM(IG,I  )=CM(IG,I  ) +DTAN2W(IG)*(GIJ00*C0(IG,J  )
     &        +GIJ01*C0(IG,J+1)+GIJ02*C0(IG,J+2)+GIJ03*C0(IG,J+3)
     &        +GIJ04*C0(IG,J+4)+GIJ05*C0(IG,J+5)+GIJ06*C0(IG,J+6)
     &        +GIJ07*C0(IG,J+7))
              CM(IG,I+1)=CM(IG,I+1) +DTAN2W(IG)*(GIJ10*C0(IG,J  )
     &        +GIJ11*C0(IG,J+1)+GIJ12*C0(IG,J+2)+GIJ13*C0(IG,J+3)
     &        +GIJ14*C0(IG,J+4)+GIJ15*C0(IG,J+5)+GIJ16*C0(IG,J+6)
     &        +GIJ17*C0(IG,J+7))
              CM(IG,I+2)=CM(IG,I+2) +DTAN2W(IG)*(GIJ20*C0(IG,J  )
     &        +GIJ21*C0(IG,J+1)+GIJ22*C0(IG,J+2)+GIJ23*C0(IG,J+3)
     &        +GIJ24*C0(IG,J+4)+GIJ25*C0(IG,J+5)+GIJ26*C0(IG,J+6)
     &        +GIJ27*C0(IG,J+7))
              CM(IG,I+3)=CM(IG,I+3) +DTAN2W(IG)*(GIJ30*C0(IG,J  )
     &        +GIJ31*C0(IG,J+1)+GIJ32*C0(IG,J+2)+GIJ33*C0(IG,J+3)
     &        +GIJ34*C0(IG,J+4)+GIJ35*C0(IG,J+5)+GIJ36*C0(IG,J+6)
     &        +GIJ37*C0(IG,J+7))
              CM(IG,I+4)=CM(IG,I+4) +DTAN2W(IG)*(GIJ40*C0(IG,J  )
     &        +GIJ41*C0(IG,J+1)+GIJ42*C0(IG,J+2)+GIJ43*C0(IG,J+3)
     &        +GIJ44*C0(IG,J+4)+GIJ45*C0(IG,J+5)+GIJ46*C0(IG,J+6)
     &        +GIJ47*C0(IG,J+7))
              CM(IG,I+5)=CM(IG,I+5) +DTAN2W(IG)*(GIJ50*C0(IG,J  )
     &        +GIJ51*C0(IG,J+1)+GIJ52*C0(IG,J+2)+GIJ53*C0(IG,J+3)
     &        +GIJ54*C0(IG,J+4)+GIJ55*C0(IG,J+5)+GIJ56*C0(IG,J+6)
     &        +GIJ57*C0(IG,J+7))
              CM(IG,I+6)=CM(IG,I+6) +DTAN2W(IG)*(GIJ60*C0(IG,J  )
     &        +GIJ61*C0(IG,J+1)+GIJ62*C0(IG,J+2)+GIJ63*C0(IG,J+3)
     &        +GIJ64*C0(IG,J+4)+GIJ65*C0(IG,J+5)+GIJ66*C0(IG,J+6)
     &        +GIJ67*C0(IG,J+7))
              CM(IG,I+7)=CM(IG,I+7) +DTAN2W(IG)*(GIJ70*C0(IG,J  )
     &        +GIJ71*C0(IG,J+1)+GIJ72*C0(IG,J+2)+GIJ73*C0(IG,J+3)
     &        +GIJ74*C0(IG,J+4)+GIJ75*C0(IG,J+5)+GIJ76*C0(IG,J+6)
     &        +GIJ77*C0(IG,J+7))
            ENDDO 
          ENDDO 
        ENDDO 
      ELSE   
        MODI=MOD(NSTATE,8)
        MODJ=MOD(NSTATE,8) 
!$OMP parallel do private(I,J,IG,GIJ,
!$OMP+ GIJ00,GIJ01,GIJ02,GIJ03,GIJ04,GIJ05,GIJ06,GIJ07)
        DO I=1,MODI
          DO J=1,MODJ
            GIJ=EMASS*GAMY(I,J)
            DO IG=1,NGW  
              CM(IG,I)=CM(IG,I)+GIJ*C0(IG,J)/XMU(IG)
            ENDDO
          ENDDO  
          DO J=MODJ+1,NSTATE,8
            GIJ00=EMASS*GAMY(I,J  )
            GIJ01=EMASS*GAMY(I,J+1)
            GIJ02=EMASS*GAMY(I,J+2)
            GIJ03=EMASS*GAMY(I,J+3)
            GIJ04=EMASS*GAMY(I,J+4)
            GIJ05=EMASS*GAMY(I,J+5)
            GIJ06=EMASS*GAMY(I,J+6)
            GIJ07=EMASS*GAMY(I,J+7)
            DO IG=1,NGW  
              CM(IG,I)=CM(IG,I)+(GIJ00*C0(IG,J  )
     &        +GIJ01*C0(IG,J+1)+GIJ02*C0(IG,J+2)+GIJ03*C0(IG,J+3)
     &        +GIJ04*C0(IG,J+4)+GIJ05*C0(IG,J+5)+GIJ06*C0(IG,J+6)
     &        +GIJ07*C0(IG,J+7))/XMU(IG)
            ENDDO
          ENDDO  
        ENDDO  
!$OMP parallel do private(I,J,IG,
!$OMP+ GIJ00,GIJ01,GIJ02,GIJ03,GIJ04,GIJ05,GIJ06,GIJ07,
!$OMP+ GIJ10,GIJ11,GIJ12,GIJ13,GIJ14,GIJ15,GIJ16,GIJ17,
!$OMP+ GIJ20,GIJ21,GIJ22,GIJ23,GIJ24,GIJ25,GIJ26,GIJ27,
!$OMP+ GIJ30,GIJ31,GIJ32,GIJ33,GIJ34,GIJ35,GIJ36,GIJ37,
!$OMP+ GIJ40,GIJ41,GIJ42,GIJ43,GIJ44,GIJ45,GIJ46,GIJ47,
!$OMP+ GIJ50,GIJ51,GIJ52,GIJ53,GIJ54,GIJ55,GIJ56,GIJ57,
!$OMP+ GIJ60,GIJ61,GIJ62,GIJ63,GIJ64,GIJ65,GIJ66,GIJ67,
!$OMP+ GIJ70,GIJ71,GIJ72,GIJ73,GIJ74,GIJ75,GIJ76,GIJ77)
        DO I=MODI+1,NSTATE,8
          DO J=1,MODJ
            GIJ00=EMASS*GAMY(I  ,J)
            GIJ10=EMASS*GAMY(I+1,J)
            GIJ20=EMASS*GAMY(I+2,J)
            GIJ30=EMASS*GAMY(I+3,J)
            GIJ40=EMASS*GAMY(I+4,J)
            GIJ50=EMASS*GAMY(I+5,J)
            GIJ60=EMASS*GAMY(I+6,J)
            GIJ70=EMASS*GAMY(I+7,J)
            DO IG=1,NGW  
              CM(IG,I  )=CM(IG,I  )+GIJ00*C0(IG,J)/XMU(IG)
              CM(IG,I+1)=CM(IG,I+1)+GIJ10*C0(IG,J)/XMU(IG)
              CM(IG,I+2)=CM(IG,I+2)+GIJ20*C0(IG,J)/XMU(IG)
              CM(IG,I+3)=CM(IG,I+3)+GIJ30*C0(IG,J)/XMU(IG)
              CM(IG,I+4)=CM(IG,I+4)+GIJ40*C0(IG,J)/XMU(IG)
              CM(IG,I+5)=CM(IG,I+5)+GIJ50*C0(IG,J)/XMU(IG)
              CM(IG,I+6)=CM(IG,I+6)+GIJ60*C0(IG,J)/XMU(IG)
              CM(IG,I+7)=CM(IG,I+7)+GIJ70*C0(IG,J)/XMU(IG)
            ENDDO
          ENDDO  
          DO J=MODJ+1,NSTATE,8
            GIJ00=EMASS*GAMY(I  ,J  )
            GIJ10=EMASS*GAMY(I+1,J  )
            GIJ20=EMASS*GAMY(I+2,J  )
            GIJ30=EMASS*GAMY(I+3,J  )
            GIJ40=EMASS*GAMY(I+4,J  )
            GIJ50=EMASS*GAMY(I+5,J  )
            GIJ60=EMASS*GAMY(I+6,J  )
            GIJ70=EMASS*GAMY(I+7,J  )
            GIJ01=EMASS*GAMY(I  ,J+1)
            GIJ11=EMASS*GAMY(I+1,J+1)
            GIJ21=EMASS*GAMY(I+2,J+1)
            GIJ31=EMASS*GAMY(I+3,J+1)
            GIJ41=EMASS*GAMY(I+4,J+1)
            GIJ51=EMASS*GAMY(I+5,J+1)
            GIJ61=EMASS*GAMY(I+6,J+1)
            GIJ71=EMASS*GAMY(I+7,J+1)
            GIJ02=EMASS*GAMY(I  ,J+2)
            GIJ12=EMASS*GAMY(I+1,J+2)
            GIJ22=EMASS*GAMY(I+2,J+2)
            GIJ32=EMASS*GAMY(I+3,J+2)
            GIJ42=EMASS*GAMY(I+4,J+2)
            GIJ52=EMASS*GAMY(I+5,J+2)
            GIJ62=EMASS*GAMY(I+6,J+2)
            GIJ72=EMASS*GAMY(I+7,J+2)
            GIJ03=EMASS*GAMY(I  ,J+3)
            GIJ13=EMASS*GAMY(I+1,J+3)
            GIJ23=EMASS*GAMY(I+2,J+3)
            GIJ33=EMASS*GAMY(I+3,J+3)
            GIJ43=EMASS*GAMY(I+4,J+3)
            GIJ53=EMASS*GAMY(I+5,J+3)
            GIJ63=EMASS*GAMY(I+6,J+3)
            GIJ73=EMASS*GAMY(I+7,J+3)
            GIJ04=EMASS*GAMY(I  ,J+4)
            GIJ14=EMASS*GAMY(I+1,J+4)
            GIJ24=EMASS*GAMY(I+2,J+4)
            GIJ34=EMASS*GAMY(I+3,J+4)
            GIJ44=EMASS*GAMY(I+4,J+4)
            GIJ54=EMASS*GAMY(I+5,J+4)
            GIJ64=EMASS*GAMY(I+6,J+4)
            GIJ74=EMASS*GAMY(I+7,J+4)
            GIJ05=EMASS*GAMY(I  ,J+5)
            GIJ15=EMASS*GAMY(I+1,J+5)
            GIJ25=EMASS*GAMY(I+2,J+5)
            GIJ35=EMASS*GAMY(I+3,J+5)
            GIJ45=EMASS*GAMY(I+4,J+5)
            GIJ55=EMASS*GAMY(I+5,J+5)
            GIJ65=EMASS*GAMY(I+6,J+5)
            GIJ75=EMASS*GAMY(I+7,J+5)
            GIJ06=EMASS*GAMY(I  ,J+6)
            GIJ16=EMASS*GAMY(I+1,J+6)
            GIJ26=EMASS*GAMY(I+2,J+6)
            GIJ36=EMASS*GAMY(I+3,J+6)
            GIJ46=EMASS*GAMY(I+4,J+6)
            GIJ56=EMASS*GAMY(I+5,J+6)
            GIJ66=EMASS*GAMY(I+6,J+6)
            GIJ76=EMASS*GAMY(I+7,J+6)
            GIJ07=EMASS*GAMY(I  ,J+7)
            GIJ17=EMASS*GAMY(I+1,J+7)
            GIJ27=EMASS*GAMY(I+2,J+7)
            GIJ37=EMASS*GAMY(I+3,J+7)
            GIJ47=EMASS*GAMY(I+4,J+7)
            GIJ57=EMASS*GAMY(I+5,J+7)
            GIJ67=EMASS*GAMY(I+6,J+7)
            GIJ77=EMASS*GAMY(I+7,J+7)
            DO IG=1,NGW  
              CM(IG,I  )=CM(IG,I  )+(GIJ00*C0(IG,J  )
     &        +GIJ01*C0(IG,J+1)+GIJ02*C0(IG,J+2)+GIJ03*C0(IG,J+3)
     &        +GIJ04*C0(IG,J+4)+GIJ05*C0(IG,J+5)+GIJ06*C0(IG,J+6)
     &        +GIJ07*C0(IG,J+7))/XMU(IG)
              CM(IG,I+1)=CM(IG,I+1)+(GIJ10*C0(IG,J  )
     &        +GIJ11*C0(IG,J+1)+GIJ12*C0(IG,J+2)+GIJ13*C0(IG,J+3)
     &        +GIJ14*C0(IG,J+4)+GIJ15*C0(IG,J+5)+GIJ16*C0(IG,J+6)
     &        +GIJ17*C0(IG,J+7))/XMU(IG)
              CM(IG,I+2)=CM(IG,I+2)+(GIJ20*C0(IG,J  )
     &        +GIJ21*C0(IG,J+1)+GIJ22*C0(IG,J+2)+GIJ23*C0(IG,J+3)
     &        +GIJ24*C0(IG,J+4)+GIJ25*C0(IG,J+5)+GIJ26*C0(IG,J+6)
     &        +GIJ27*C0(IG,J+7))/XMU(IG)
              CM(IG,I+3)=CM(IG,I+3)+(GIJ30*C0(IG,J  )
     &        +GIJ31*C0(IG,J+1)+GIJ32*C0(IG,J+2)+GIJ33*C0(IG,J+3)
     &        +GIJ34*C0(IG,J+4)+GIJ35*C0(IG,J+5)+GIJ36*C0(IG,J+6)
     &        +GIJ37*C0(IG,J+7))/XMU(IG)
              CM(IG,I+4)=CM(IG,I+4)+(GIJ40*C0(IG,J  )
     &        +GIJ41*C0(IG,J+1)+GIJ42*C0(IG,J+2)+GIJ43*C0(IG,J+3)
     &        +GIJ44*C0(IG,J+4)+GIJ45*C0(IG,J+5)+GIJ46*C0(IG,J+6)
     &        +GIJ47*C0(IG,J+7))/XMU(IG)
              CM(IG,I+5)=CM(IG,I+5)+(GIJ50*C0(IG,J  )
     &        +GIJ51*C0(IG,J+1)+GIJ52*C0(IG,J+2)+GIJ53*C0(IG,J+3)
     &        +GIJ54*C0(IG,J+4)+GIJ55*C0(IG,J+5)+GIJ56*C0(IG,J+6)
     &        +GIJ57*C0(IG,J+7))/XMU(IG)
              CM(IG,I+6)=CM(IG,I+6)+(GIJ60*C0(IG,J  )
     &        +GIJ61*C0(IG,J+1)+GIJ62*C0(IG,J+2)+GIJ63*C0(IG,J+3)
     &        +GIJ64*C0(IG,J+4)+GIJ65*C0(IG,J+5)+GIJ66*C0(IG,J+6)
     &        +GIJ67*C0(IG,J+7))/XMU(IG)
              CM(IG,I+7)=CM(IG,I+7)+(GIJ70*C0(IG,J  )
     &        +GIJ71*C0(IG,J+1)+GIJ72*C0(IG,J+2)+GIJ73*C0(IG,J+3)
     &        +GIJ74*C0(IG,J+4)+GIJ75*C0(IG,J+5)+GIJ76*C0(IG,J+6)
     &        +GIJ77*C0(IG,J+7))/XMU(IG)
            ENDDO
          ENDDO  
        ENDDO  
      ENDIF  
C     ==--------------------------------------------------------------==
      RETURN
      END   
C     ==================================================================
#else 
C     ==================================================================
      SUBROUTINE RVHARM(C0,CM,GAMY,S1,S2,S3,S4,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'harm.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,NSTATE),CM(NGW,NSTATE)
      REAL*8     GAMY(NSTATE,*),
     &           S1(NSTATE,*),S2(NSTATE,*),S3(NSTATE,*),S4(NSTATE,*)
C     Variables
      REAL*8     TOL,PF4,AI,BI,AJ,BJ,DGMAX,DGAM,GIJ
      INTEGER    I,JMAX,J,IG,ITER
C     ==--------------------------------------------------------------==
      TOL = EPSOG
      CALL OVLAP(NSTATE,S1,CM,C0)
#ifdef PARALLEL
      CALL GLOSUM(NSTATE*NSTATE,S1)
#endif
      CALL AZZERO(S2,NSTATE*NSTATE)
!$OMP parallel do private(I,J,IG,JMAX,PF4,AI,BI,AJ,BJ)
!$OMP+ schedule(static,1)
#ifdef __SR8000
*poption parallel
*poption tlocal(I,J,IG,JMAX,PF4,AI,BI,AJ,BJ), cyclic
#endif
      DO I=1,NSTATE
        JMAX=NSTATE
        IF(TLSD.AND.I.LE.NSUP) JMAX=NSUP
        IF(THARM) THEN
          DO J=I,JMAX
            DO IG=1,NGW
              PF4=2.0D0*DTAN2W(IG)/DTB2ME
              AI=DREAL(C0(IG,I))
              BI=DIMAG(C0(IG,I))
              AJ=DREAL(C0(IG,J))
              BJ=DIMAG(C0(IG,J))
              S2(I,J)=S2(I,J)+PF4*(AI*AJ+BI*BJ)
            ENDDO
            IF(GEQ0) THEN
              PF4=DTAN2W(1)/DTB2ME
              S2(I,J)=S2(I,J)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J))
            ENDIF
            S2(J,I)=S2(I,J)
          ENDDO
        ELSE   
          DO J=I,JMAX
            DO IG=1,NGW
              PF4=2.0D0*EMASS/XMU(IG)
              AI=DREAL(C0(IG,I))
              BI=DIMAG(C0(IG,I))
              AJ=DREAL(C0(IG,J))
              BJ=DIMAG(C0(IG,J))
              S2(I,J)=S2(I,J)+PF4*(AI*AJ+BI*BJ)
            ENDDO
            IF(GEQ0) THEN
              PF4=EMASS/XMU(1)
              S2(I,J)=S2(I,J)-PF4*DREAL(C0(1,I))*DREAL(C0(1,J))
            ENDIF
            S2(J,I)=S2(I,J)
          ENDDO
        ENDIF  
        DO J=JMAX+1,NSTATE
          S2(I,J)=0.0D0
          S2(J,I)=0.0D0
        ENDDO
      ENDDO  
#ifdef PARALLEL
      CALL GLOSUM(NSTATE*NSTATE,S2)
#endif
      DO I=1,NSTATE
        S2(I,I)=S2(I,I)-1.0D0
      ENDDO
C     Initial Guess for GAMY
!$OMP parallel do private(I,J)
      DO I=1,NSTATE
        DO J=1,NSTATE
          GAMY(I,J)=-0.5D0*(S1(I,J)+S1(J,I))
          S4(I,J)=GAMY(I,J)
        ENDDO
      ENDDO  
C     Iteration
      ITER=0
 10   CONTINUE
      ITER=ITER+1
      CALL TEST_SCR('RHARMV','MAXIT',MAXIT,ITER)
      CALL DGEMM('N','N',NSTATE,NSTATE,NSTATE,1.0d0,S2,NSTATE,GAMY,
     *     NSTATE,0.0d0,S3,NSTATE)
      DGMAX=0.0d0
!$OMP parallel do private(I,J,DGAM) reduction(max:DGMAX)
#ifdef __SR8000
*poption parallel, tlocal(I,J,DGAM), max(DGMAX)
#endif
      DO I=1,NSTATE
        DO J=1,NSTATE
          GAMY(I,J)=-0.5d0*(S1(I,J)+S1(J,I)+S3(I,J)+S3(J,I))
          DGAM = (GAMY(I,J)-S4(I,J))*(GAMY(I,J)-S4(I,J))
          DGMAX=DMAX1(DGMAX,DGAM)
          S4(I,J)=GAMY(I,J)
        ENDDO
      ENDDO  
      DGMAX=DSQRT(DGMAX)
      IF(DGMAX.GT.TOL) GOTO 10
C     Apply the constraint
      IF(THARM) THEN
!$OMP parallel do private(I,J,IG,GIJ,PF4)
#ifdef __SR8000
*poption parallel, tlocal(I,J,IG,GIJ,PF4)
#endif
        DO I=1,NSTATE
          DO J=1,NSTATE
            GIJ=GAMY(I,J)
            DO IG=1,NGW  
              PF4=DTAN2W(IG)/DTB2ME
              CM(IG,I)=CM(IG,I)+GIJ*PF4*C0(IG,J)
            ENDDO
          ENDDO  
        ENDDO  
      ELSE   
!$OMP parallel do private(I,J,IG,GIJ,PF4)
#ifdef __SR8000
*poption parallel, tlocal(I,J,IG,GIJ,PF4)
#endif
        DO I=1,NSTATE
          DO J=1,NSTATE
            GIJ=GAMY(I,J)
            DO IG=1,NGW  
              PF4=EMASS/XMU(IG)
              CM(IG,I)=CM(IG,I)+GIJ*PF4*C0(IG,J)
            ENDDO
          ENDDO  
        ENDDO  
      ENDIF  
C     ==--------------------------------------------------------------==
      RETURN
      END   
C     ==================================================================
#endif 
C     ==================================================================
      SUBROUTINE GIVE_SCR_RORTV(LRORTV,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NONORT
      INCLUDE 'nort.inc'        !SCOND SLIMIT
C     Arguments
      INTEGER   LRORTV,NSTATE
      CHARACTER TAG*30
      INTEGER   NSTX
C     ==--------------------------------------------------------------==
      IF(NONORT) THEN
        IF(SCOND.GT.SLIMIT) THEN
          CALL GIVE_SCR_CROTWF(LRORTV,TAG,NSTATE)
        ELSE
          LRORTV=0
        ENDIF
      ELSE
        IF(TDMAL) THEN
          CALL SET_ORBDIST(NSTATE,NSTBLK,NSTX)
          LRORTV=3*NSTATE*NSTX
        ELSE
          LRORTV=3*NSTATE*NSTATE+MAX(NSTATE*NSTATE,3*NSTATE)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
