C     ==================================================================
      SUBROUTINE ROTATE(A,C1,B,C2,GAM,NSTATE,N,TLSD,NA,NB)
C     ==--------------------------------------------------------------==
C     ==         C2 <= B*C2 + A*C1*GAM                                ==
C     ==   ALSO FOR LSD                                               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NSTATE,N,NA,NB
      REAL*8  GAM(NSTATE,*),C1(N,*),C2(N,*),A,B
      LOGICAL TLSD
C     Variables
      INTEGER NAA,ISUB
C     ==--------------------------------------------------------------==
      IF(N.EQ.0 .OR. NSTATE.EQ.0) RETURN
      CALL TISET('    ROTATE',ISUB)
      IF(TLSD) THEN
        NAA=NA+1
        CALL DGEMM('N','N',N,NA,NA,A,C1(1,1),N,GAM(1,1),
     *             NSTATE,B,C2(1,1),N)
        CALL DGEMM('N','N',N,NB,NB,A,C1(1,NAA),N,GAM(NAA,NAA),
     *             NSTATE,B,C2(1,NAA),N)
      ELSE
        CALL DGEMM('N','N',N,NSTATE,NSTATE,A,C1(1,1),N,
     &             GAM(1,1),NSTATE,B,C2(1,1),N)
      ENDIF
      CALL TIHALT('    ROTATE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ROTATE_C(A,C1,B,C2,GAM,NSTATE)
C     ==--------------------------------------------------------------==
C     ==         C2 <= B*C2 + A*C1*GAM                                ==
C     ==   ALSO FOR LSD                                               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'geq0.inc'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C1(NGWK,*),C2(NGWK,*),GAM(NSTATE,*),A,B
C     Variables
      INTEGER    NAA,ISUB
C     ==--------------------------------------------------------------==
      IF(NGWK.EQ.0 .OR. NSTATE.EQ.0) RETURN
      CALL TISET('  ROTATE_C',ISUB)
      IF(TLSD) THEN
        NAA=NSUP+1
        CALL ZGEMM('N','N',NGWK,NSUP,NSUP,A,C1(1,1),NGWK,GAM(1,1),
     &       NSTATE,B,C2(1,1),NGWK)
        CALL ZGEMM('N','N',NGWK,NSDOWN,NSDOWN,A,C1(1,NAA),NGWK,
     &       GAM(NAA,NAA),NSTATE,B,C2(1,NAA),NGWK)
      ELSE
        CALL ZGEMM('N','N',NGWK,NSTATE,NSTATE,A,C1(1,1),NGWK,GAM(1,1),
     &       NSTATE,B,C2(1,1),NGWK)
      ENDIF
      CALL TIHALT('  ROTATE_C',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ROTATE_DA(A,C1,B,C2,GAM,SCR,N,NSTATE,NDD1,NDD2,NDDX,
     *                     MEPOS,PGROUP,NPROC,GRP,TLSD,NA,NB)
      IMPLICIT NONE
      INTEGER NSTATE,N,NA,NB,NPROC,MEPOS,NDDX
      REAL*8  GAM(NSTATE,NSTATE),C1(N,NSTATE),C2(N,NSTATE),A,B,SCR(*)
      INTEGER NDD1(0:*),NDD2(0:*)
      INTEGER GRP,PGROUP(0:*)
      LOGICAL TLSD
C
      INTEGER NMAX,I,II,J,MSGLEN,I1,N1,ISUB,NMIN,IP
C     ==--------------------------------------------------------------==
      CALL TISET(' ROTATE_DA',ISUB)
      IF(TLSD) THEN
        IF(NDD1(MEPOS).LT.NA) THEN
          NMAX=MIN(NA,NDD2(MEPOS))
          DO I=NDD1(MEPOS),NMAX
            II=I-NDD1(MEPOS)+1
            DO J=NA+1,NSTATE
              GAM(J,II)=0.D0
            ENDDO
          ENDDO
        ENDIF
        IF(NDD2(MEPOS).GT.NA) THEN
          NMIN=MAX(NA+1,NDD1(MEPOS))
          DO I=NMIN,NDD2(MEPOS)
            II=I-NDD1(MEPOS)+1
            DO J=1,NA
              GAM(J,II)=0.D0
            ENDDO
          ENDDO
        ENDIF
      ENDIF
      CALL DSCAL(NSTATE*N,B,C2,1)
      MSGLEN=NSTATE*NDDX * 8
      CALL DCOPY(NSTATE*NDDX,GAM,1,SCR,1)
      DO IP=0,NPROC-1
        I1=NDD1(IP)
        N1=NDD2(IP)-NDD1(IP)+1
        IF(N1.GT.0) THEN
          CALL DCOPY(NSTATE*NDDX,SCR,1,GAM,1)
          CALL MY_BCAST(GAM,MSGLEN,PGROUP(IP+1),GRP)
          CALL DGEMM('N','N',N,N1,NSTATE,A,C1(1,1),N,
     *                 GAM(1,1),NSTATE,1.D0,C2(1,I1),N)
        ENDIF
      ENDDO
      CALL DCOPY(NSTATE*NDDX,SCR,1,GAM,1)
      CALL TIHALT(' ROTATE_DA',ISUB)
C    ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ROTTR(A,C1,GAM,TRANSA,NSTATE,N,TLSD,NA,NB)
C     ==--------------------------------------------------------------==
C     ==         C1 <= A*C1*GAM                                       ==
C     ==   SPECIAL CASE FOR GAM UPPER TRIAGONAL                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NSTATE,N,NA,NB
      REAL*8  GAM(NSTATE,NSTATE),C1(N,NSTATE),A
      CHARACTER*(*) TRANSA
      LOGICAL TLSD
C     Variables
      INTEGER NAA,ISUB
C     ==--------------------------------------------------------------==
      IF(N.EQ.0 .OR. NSTATE.EQ.0) RETURN
      CALL TISET('     ROTTR',ISUB)
      IF(TLSD) THEN
        NAA=NA+1
        CALL DTRMM('R','U',TRANSA,'N',N,NA,A,GAM(1,1),NSTATE,C1(1,1),N)
        CALL DTRMM('R','U',TRANSA,'N',N,NB,A,GAM(NAA,NAA),NSTATE,
     *             C1(1,NAA),N)
      ELSE
        CALL DTRMM('R','U',TRANSA,'N',N,NSTATE,A,GAM(1,1),NSTATE,C1,N)
      ENDIF
      CALL TIHALT('     ROTTR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

