C     ==================================================================
      SUBROUTINE RPIIINT(ESR,TAU0,FION,IESR,TFOR)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == THE RESIDUAL PART OF THE ION-ION INTERACTION (ESR)           ==
C     == DUE TO THE OVERLAP OF THE SMEARED IONIC CHARGE DENSITIES     ==
C     == (ionic point charges replaced by gaussian charge distrib.)   ==
C     == CORRESPONDING TO DIFFERENT ATOMS.                            ==
C     == ESR depends only on TAU0 (RAGGIO and VALENCE CHARGES)        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'eam.inc'
C     Arguments
      REAL*8  ESR,TAU0(3,NAX,NSP),FION(3,NAX,NSP)
      INTEGER IESR
      LOGICAL TFOR
C     Variables
      REAL*8    ARGMAX          !DERFC(ARG) and DEXP(-ARG*ARG) underflow
      PARAMETER (ARGMAX=20.D0)
      LOGICAL TZERO
      REAL*8  TFION1,TFION2,TFION3,TFION4,TFION5,TFION6
      REAL*8  RXLM1,RXLM2,RXLM3,
     &        ZV2,RCKJ,YLM,ZLM,ERRE2,RLM,ARG,ESRTZERO,ADDESR,ADDPRE,
     &        REPAND,XLM
      INTEGER ISUB,K,J,L,M,LAX,INF,IX,IY,IZ,ISHFT,IAT
#ifdef __DERF
      REAL*8    DERFC
      EXTERNAL  DERFC
#endif
      INTEGER   IFLAG
      DATA      IFLAG /0/
      SAVE      IFLAG
#ifdef __VECTOR 
      INTEGER   IXYZ,IALL,IESRI,IESRJ,IESRK
#endif 
C     ==--------------------------------------------------------------==
      IF(IFLAG.EQ.0.AND.PARENT)  THEN
        WRITE(6,'(A,T52,I2,A,I2,A,I2,A)') 
     *    ' EWALD| SUM IN REAL SPACE OVER ',
     *    2*IESR+1,'*',2*IESR+1,'*',2*IESR+1,' CELLS'
        IFLAG=1
      ENDIF
C     ==--------------------------------------------------------------==
      CALL TISET('   RPIIINT',ISUB)
#ifdef __VECTOR 
      IESRI=(2*IESR+1) 
      IESRJ=(2*IESR+1)*IESRI
      IESRK=(2*IESR+1)*IESRJ
      IALL=IESRK 
#endif 
      ESR=0.D0
      IAT=0
      DO K=1,NSP
        DO J=K,NSP
          ZV2=ZV(K)*ZV(J)
          IF(ABS(ZV2).LT.1.D-10) GOTO 2000
          RCKJ=DSQRT(RAGGIO(K)*RAGGIO(K)+RAGGIO(J)*RAGGIO(J))
          LAX=NA(K)
          DO L=1,LAX
#ifdef PARALLEL
            IF(IATPE(IAT+L).NE.MEPOS) GOTO 1000
#endif
            INF=1
            IF(K.EQ.J)INF=L
            DO M=INF,NA(J)
              IF(L.EQ.M.AND.K.EQ.J) THEN
                XLM=0.D0
                YLM=0.D0
                ZLM=0.D0
                TZERO=.TRUE.
              ELSE
                TZERO=.FALSE.
                XLM=TAU0(1,L,K)-TAU0(1,M,J)
                YLM=TAU0(2,L,K)-TAU0(2,M,J)
                ZLM=TAU0(3,L,K)-TAU0(3,M,J)
                CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
              ENDIF
              IF(TFOR) THEN
                TFION1 = FION(1,L,K)
                TFION2 = FION(2,L,K)
                TFION3 = FION(3,L,K)
                TFION4 = FION(1,M,J)
                TFION5 = FION(2,M,J)
                TFION6 = FION(3,M,J)
              ENDIF
#ifdef __VECTOR 
              DO IXYZ=1,IALL 
                IX=-IESR+INT(MOD(IXYZ-1,IESRK)/IESRJ)
                IY=-IESR+INT(MOD(IXYZ-1,IESRJ)/IESRI) 
                IZ=-IESR+MOD(IXYZ-1,IESRI)
#else 
              DO IX=-IESR,IESR
                DO IY=-IESR,IESR
                  DO IZ=-IESR,IESR
#endif 
                    ISHFT=IX*IX+IY*IY+IZ*IZ
                    IF(.NOT.(TZERO.AND.ISHFT.EQ.0)) THEN
                     RXLM1=XLM+IX*HT(1,1)+IY*HT(2,1)+IZ*HT(3,1)
                     RXLM2=YLM+IX*HT(1,2)+IY*HT(2,2)+IZ*HT(3,2)
                     RXLM3=ZLM+IX*HT(1,3)+IY*HT(2,3)+IZ*HT(3,3)
                     ERRE2=RXLM1*RXLM1+RXLM2*RXLM2+RXLM3*RXLM3
                     RLM=DSQRT(ERRE2)
                     ARG=RLM/RCKJ
                     IF(ARG.LE.ARGMAX) THEN !ADDESR,ADDPRE /= 0
                       IF(TZERO) THEN
                         ESRTZERO=0.5D0
                       ELSE
                         ESRTZERO=1.D0
                       END IF
                       ADDESR=ZV2*DERFC(ARG)/RLM
                       ESR=ESR+ADDESR*ESRTZERO
                       IF(TFOR) THEN
                         ADDPRE=(2.D0*ZV2/DSQRT(PI))*
     *                        DEXP(-ARG*ARG)/RCKJ
                         REPAND=ESRTZERO*(ADDESR+ADDPRE)/ERRE2
                         TFION1=TFION1+REPAND*RXLM1
                         TFION2=TFION2+REPAND*RXLM2
                         TFION3=TFION3+REPAND*RXLM3
                         TFION4=TFION4-REPAND*RXLM1
                         TFION5=TFION5-REPAND*RXLM2
                         TFION6=TFION6-REPAND*RXLM3
                       ENDIF
                     ENDIF
                   ENDIF
#ifdef __VECTOR 
              ENDDO      !ixyz
#else 
                  ENDDO  !ixc
                ENDDO    !iyc
              ENDDO      !izc
#endif 
              IF(TFOR) THEN
                FION(1,L,K) = TFION1
                FION(2,L,K) = TFION2
                FION(3,L,K) = TFION3
                FION(1,M,J) = TFION4
                FION(2,M,J) = TFION5
                FION(3,M,J) = TFION6
              ENDIF
            ENDDO
#ifdef PARALLEL
 1000       CONTINUE
#endif
          ENDDO
 2000     CONTINUE
        ENDDO
        IAT=IAT+NA(K)
      ENDDO
C
C  Embedded Atom Model
C
      IF(TIEAM) THEN
        CALL EAM_POT(ESR,TAU0,IESR,FION,TFOR)
      ENDIF
C
#ifdef PARALLEL
      CALL GLOSUM(1,ESR)
      IF(.NOT.PARENT) ESR=0.D0
#endif
      CALL TIHALT('   RPIIINT',ISUB)
C     ==================================================================
      RETURN
      END
C     ==================================================================
