C     ==================================================================
      SUBROUTINE RRFO(XPAR,DXPAR,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==  RATIONAL FUNCTION OPTIMIZATON                               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER LSCR
      REAL*8  XPAR(NODIM),DXPAR(NODIM),SCR(LSCR)
C     Variables
      REAL*8  AHESS((NODIM+MCNSTR)*(NODIM+MCNSTR)),
     &        UMAT ((NODIM+MCNSTR)*(NODIM+MCNSTR)),
     &        EIGV (NODIM+MCNSTR),AUX(3*(NODIM+MCNSTR)),
     &        DLAM (NODIM+MCNSTR),FTRAN(NODIM+MCNSTR),
     &        HSTEP(NODIM+MCNSTR)
      POINTER (IP_AHESS,AHESS),(IP_UMAT,UMAT),
     *        (IP_EIGV, EIGV) ,(IP_AUX, AUX) ,(IP_DLAM,DLAM),
     *        (IP_FTRAN,FTRAN),(IP_HSTEP,HSTEP)
      INTEGER ISUB,NDHESS,I,J,K,IOPT,NENEG,NEZER,NEPOS,
     &        IPAHESS,IPEIGV,IPUMAT,IPAUX,IPDLAM,IPFTRAN,IPHSTEP,IPGTOP
      REAL*8  SDLEN,DNRM2,ZNEG,FITSOL,ZPOS,QNRLEN,TR,SS
C     ==--------------------------------------------------------------==
      CALL TISET('      RRFO',ISUB)
C     ==--------------------------------------------------------------==
C     ==  SCRATCH SPACE ALLOCATION                                    ==
C     ==                                                              ==
C     ==  IPA1  : AUGMENTED HESSIAN                                   ==
C     ==  IPA2  : EIGV                                                ==
C     ==  IPA3  : UMAT                                                ==
C     ==  IPA4  : AUX                                                 ==
C     ==  IPB1  : DLAM                                                ==
C     ==  IPB2  : FTRAN                                               ==
C     ==  IPB3  : HSTEP                                               ==
C     ==--------------------------------------------------------------==
      NDHESS = NODIM + MCNSTR
      IPAHESS = 1
      IPEIGV  = IPAHESS + NDHESS*NDHESS
      IPUMAT  = IPEIGV  + NDHESS
      IPAUX   = IPUMAT  + NDHESS*NDHESS
      IPDLAM  = IPAUX   + 3*NDHESS
      IPFTRAN = IPDLAM  + NDHESS
      IPHSTEP = IPFTRAN + NDHESS
      IPGTOP  = IPHSTEP + NDHESS
      CALL TEST_SCR('RRFO','IPGTOP',LSCR,IPGTOP)
      CALL GET_ADDR(IP_AHESS,SCR(IPAHESS))
      CALL GET_ADDR(IP_EIGV,SCR(IPEIGV))
      CALL GET_ADDR(IP_UMAT,SCR(IPUMAT))
      CALL GET_ADDR(IP_AUX,SCR(IPAUX))
      CALL GET_ADDR(IP_DLAM,SCR(IPDLAM))
      CALL GET_ADDR(IP_FTRAN,SCR(IPFTRAN))
      CALL GET_ADDR(IP_HSTEP,SCR(IPHSTEP))
C     ==--------------------------------------------------------------==
C     ==  STEEPEST DESCENT STEP                                       ==
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I)
      DO I=1,NODIM
        AUX(I)=DTM(I)*DXPAR(I)
      ENDDO
      SDLEN=DNRM2(NODIM,AUX(1),1)
C     ==--------------------------------------------------------------==
C     ==  AUGMENTED HESSIAN IN UPPER TRAING. STORAGE MODE             ==
C     ==--------------------------------------------------------------==
      CALL AZZERO(AHESS,NDHESS*NDHESS)
      K=0
      DO J=1,NDHESS
        DO I=1,J
          K=K+1
          IF(I.LE.NODIM) THEN
            IF(J.LE.NODIM) THEN
              AHESS(K)=HESS(I,J)
            ELSE
              AHESS(K)=-ANORM(I,J-NODIM)
            ENDIF
          ENDIF
        ENDDO
      ENDDO
      IOPT=21
      CALL DSPEVY(IOPT,AHESS,EIGV,UMAT,NDHESS,NDHESS,AUX,3*NDHESS)
C     ==--------------------------------------------------------------==
C     ==  DETERMINE EIGENVALUE CHARACTERISTICS                        ==
C     ==--------------------------------------------------------------==
      NENEG=0
      NEZER=0
      NEPOS=0
      DO I=1,NDHESS
        IF(EIGV(I).LT.-1.D-2) THEN
          NENEG=NENEG+1
        ELSEIF(EIGV(I).GT.1.D-2) THEN
          NEPOS=NEPOS+1
        ELSE
          NEZER=NEZER+1
        ENDIF
      ENDDO
      WRITE(6,'(A,I4,A,I4,A,I4)') ' RFO| MODES: NEGATIVE=',NENEG,
     *   '     ZERO=',NEZER,'     POSITIVE=',NEPOS
C..INFORMATION ABOUT THE LOWEST HESSIAN EIGENVALUES
      IF(NSORDER.GT.0) THEN
        WRITE(6,'(A)') ' LOWEST HESSIAN EIGENVALUES:'
        WRITE(6,'(4F9.6)') EIGV(1),EIGV(2),EIGV(3),EIGV(4),EIGV(5),
     *                     EIGV(6),EIGV(7),EIGV(8)
      ENDIF
C     ==--------------------------------------------------------------==
      CALL DCOPY(NODIM,DXPAR(1),1,DLAM(1),1)
      IF(MCNSTR.GT.0) THEN
        CALL DCOPY(MCNSTR,FC(1),1,DLAM(NODIM+1),1)
        CALL DSCAL(MCNSTR,-1.0D0,DLAM(NODIM+1),1)
      ENDIF
      CALL DGEMV('T',NDHESS,NDHESS,1.0D0,UMAT,NDHESS,DLAM,1,
     *           0.0D0,FTRAN,1)
C     ==--------------------------------------------------------------==
      NENEG=MCNSTR+NSORDER
      ZNEG=0.0D0
      IF(NENEG.GT.0) ZNEG=FITSOL(NENEG,FTRAN(1),EIGV(1))
      ZPOS=FITSOL(NEPOS,FTRAN(NENEG+NEZER+1),EIGV(NENEG+NEZER+1))
      WRITE(6,'(A,2F12.6)') ' RFO| MODE FOLLOWING PARAMETERS :',
     *      ZNEG,ZPOS
cmb      DO I=1,NDHESS
cmb        IF(I.LE.NENEG) THEN
cmb          FTRAN(I)=FTRAN(I)/(EIGV(I)-ZNEG)
cmb        ELSE
cmb          FTRAN(I)=FTRAN(I)/(EIGV(I)-ZPOS)
cmb        ENDIF
cmb      ENDDO
cmb-> separate the two loops
      DO I=1,NENEG         ! negative
        FTRAN(I)=FTRAN(I)/(EIGV(I)-ZNEG)
      ENDDO
      DO I=NENEG+1,NDHESS  ! positive
        FTRAN(I)=FTRAN(I)/(EIGV(I)-ZPOS)
      ENDDO
C     ==--------------------------------------------------------------==
      CALL DGEMV('N',NDHESS,NDHESS,-1.0D0,UMAT,NDHESS,FTRAN,1,
     *           0.0D0,HSTEP(1),1)
      QNRLEN=DNRM2(NODIM,HSTEP(1),1)
C     ==--------------------------------------------------------------==
C     ==  THIS IS A PRIMITIVE TRUST REGION CONCEPT                    ==
C     ==--------------------------------------------------------------==
      TR=100.0D0 * SDLEN
      IF(TR.LT.0.01D0) TR=0.01D0
      TR=MIN(TR,DMAX)
      IF(QNRLEN.GT.TR) THEN
        SS=DSQRT(TR/QNRLEN)
        CALL DSCAL(NDHESS,SS,HSTEP(1),1)
      ENDIF
      CALL FIXCOM(HSTEP)
      CALL DAXPY(NODIM,1.0D0,HSTEP(1),1,XPAR(1),1)
      IF(MCNSTR.GT.0)
     &     CALL DAXPY(MCNSTR,1.0D0,HSTEP(NODIM+1),1,XLAGR(1),1)
      CALL TIHALT('      RRFO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION FITSOL(N,F,E)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   N
      REAL*8    F(N),E(N)
      REAL*8    FITSOL
C     Variables
      REAL*8    CONV
      PARAMETER (CONV=1.D-10)
      INTEGER   MAXIT
      PARAMETER (MAXIT=100)
      REAL*8    FOLD,FNEW,DF
      INTEGER   I,J
C     ==--------------------------------------------------------------==
      FOLD=0.0D0
      DO I=1,MAXIT
        FNEW=0.0D0
        DO J=1,N
          FNEW=FNEW+F(J)*F(J)/(FOLD-E(J))
        ENDDO
        DF=DABS(FOLD-FNEW)
        IF(DF.LT.CONV) GOTO 100
        FOLD=FNEW
      ENDDO
      WRITE(6,*) ' FITSOL| ',FNEW,DF
  100 CONTINUE
      FITSOL=FNEW
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_RRFO(LRRFO,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !PARENT
      INCLUDE 'cotr.inc'        !NODIM MCNSTR
C     Arguments
      INTEGER   LRRFO
      CHARACTER TAG*30
C     Variables
      INTEGER   NDHESS
C     ==--------------------------------------------------------------==
      NDHESS = NODIM + MCNSTR
      LRRFO=2*NDHESS*NDHESS+7*NDHESS
      TAG ='2*NDHESS*NDHESS+7*NDHESS'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
