C     ==================================================================
      SUBROUTINE RSCVP(TEMP1,TEMP2,TEMPP,VELP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst_dyn.inc'
C     Arguments
      REAL*8  TEMP1,TEMP2,TEMPP,VELP(3,NAX,*)
C     Variables
      REAL*8  ALFAP
      INTEGER IS,IA
C     ==--------------------------------------------------------------==
C     ==  Dynamical rescaling factor (tempw/tempp), where tempp is    ==
C     ==  calculated every step                                       ==
C     ==--------------------------------------------------------------==
      IF(TCP) THEN
        IF(TEMPP.GT.TEMP1.OR.TEMPP.LT.TEMP2.AND.TEMPP.NE.0.D0) THEN
          WRITE(6,'(A,F13.5,A,F13.5)') '  RSCVP| RESCALING IONIC '
     &        // 'TEMP FROM ',TEMPP, ' TO ',TEMPW
          ALFAP=DSQRT(TEMPW/TEMPP)
          DO IS=1,NSP
            DO IA=1,NA(IS)
              VELP(1,IA,IS)=ALFAP*VELP(1,IA,IS)
              VELP(2,IA,IS)=ALFAP*VELP(2,IA,IS)
              VELP(3,IA,IS)=ALFAP*VELP(3,IA,IS)
            ENDDO
          ENDDO
          IF(LTCGLOBAL) THEN
            DO IA = 1,NCOLVAR
              CV_VEL(IA)=ALFAP*CV_VEL(IA)
            ENDDO
          ENDIF
        END IF
      END IF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
