C     ==================================================================
      SUBROUTINE ZHRWF(NR,IREC,C0,CM,NSTATE,EIGV,TAU0,TAUM,TAUI,NFI)
C     ==--------------------------------------------------------------==
C     == Read wavefunction in Version 3.0 format on unit NR           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'filn.inc' 
      INCLUDE 'nose.inc' 
      INCLUDE 'irat.inc'
      INCLUDE 'store.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'cdft.inc'
      INCLUDE 'mw.inc'
C     Arguments
      INTEGER    NR,IREC(100),NSTATE,NFI
      COMPLEX*16 C0(NGWK,NSTATE,NKPNT),CM(NGWK,NSTATE)
      REAL*8     TAU0(3,NAX,NSX),TAUM(3,NAX,NSX),TAUI(3,NAX,NSX),
     &           EIGV(NSTATE,NKPTS)
C     Variables
      INTEGER    IA,IE,IVER
      CHARACTER  FILNAM*100,STR*80,FFORMAT*20,LATFILE*20
      LOGICAL    FEXIST
      INTEGER    MSGLEN
C     ==--------------------------------------------------------------==
C     Construct the filename
      IF(PARENT) THEN
        CALL XSTRING(FILN,IA,IE)
        IF(TPATH) THEN
          FILNAM=FPATH(IAPATH:IEPATH)//FILN(IA:IE)
        ELSE
          IF(RLATE) THEN
            IF(TMW)THEN
              CALL MW_FILENAME('LATEST_',LATFILE,WALKER_ID)
            ELSE
              LATFILE='LATEST'
            ENDIF
            INQUIRE(FILE=LATFILE,EXIST=FEXIST)
            IF(FEXIST) THEN
              OPEN(UNIT=NR,FILE=LATFILE,STATUS='UNKNOWN')
              READ(NR,'(A)') FILNAM
              CLOSE(NR)
            ELSE
              FILNAM=FPATH(IAPATH:IEPATH)//FILN(IA:IE)
            ENDIF
          ELSE
            FILNAM=FPATH(IAPATH:IEPATH)//FILN(IA:IE)
          ENDIF
        ENDIF
        IF(RCDFT.AND.THDA.AND..NOT.PROJNOW)THEN
          IF(HDAFIRST)THEN
            FILNAM=FPATH(IAPATH:IEPATH)//"RESTART.STATE_1"
          ELSE
            FILNAM=FPATH(IAPATH:IEPATH)//"RESTART.STATE_2"
          ENDIF
        ENDIF
        INQUIRE(FILE=FILNAM,EXIST=FEXIST)
        IF(.NOT.FEXIST) THEN
          CALL XSTRING(FILNAM,IA,IE)
          WRITE(FFORMAT,'(A,I2,A)')
     &         '(/,A,T',MAX(35,65-(IE-IA)),',A)'
          WRITE(6,FFORMAT) ' ZHRWF| RESTART FILE NOT FOUND:',FILNAM
          CALL STOPGM('ZHRWF',' FILE NOT FOUND ')
        ENDIF
        OPEN(UNIT=NR,FILE=FILNAM,FORM='UNFORMATTED',STATUS='OLD')
        REWIND (NR)
        READ(NR) STR
        IF(INDEX(STR,'STUTTGART VERSION 3.0').NE.0) THEN
          IVER=1
        ELSEIF(INDEX(STR,'Zurich-2.0').NE.0) THEN
          IVER=2
        ELSEIF(INDEX(STR,'Zurich-1.2').NE.0) THEN
          IVER=2
        ELSEIF(INDEX(STR,'Zurich-1.1').NE.0) THEN
          IVER=2
        ELSE
          WRITE(6,'(A)')
     &         ' THIS FORMAT IS NOT KNOWN TO THE CURRENT VERSION'
          WRITE(6,'(1X,A)') STR
          CALL STOPGM('ZHRWF',' ')
        ENDIF
      ENDIF
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IVER,MSGLEN,SOURCE,ALLGRP)
      IF(IVER.EQ.1) THEN
        CALL RV30(NR,IREC,C0,CM,NSTATE,EIGV,TAU0,TAUM,TAUI,NFI)
      ELSEIF(IVER.EQ.2) THEN
        CALL STOPGM('ZHRWF','FORMAT NO LONGER SUPPORTED')
      ENDIF
      IF(PARENT) THEN
        CALL XSTRING(FILNAM,IA,IE)
        IF(TPATH) THEN
          WRITE(FFORMAT,'(A,I2,A)') '(A,T',MAX(35,65-(IE-IA)),',A)'
        ELSE
          WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(35,65-(IE-IA)),',A)'
        ENDIF
        WRITE(6,FFORMAT)
     &       ' RESTART INFORMATION READ ON FILE ',FILNAM(IA:IE)
        CLOSE(NR)
      ENDIF
C     INTERFACE FILE
      IF (INTREAD) THEN
         CALL RINTF(NR,C0,TAU0)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RV30(NR,IREC,C0,CM,NSTATE,EIGV,TAU0,TAUM,TAUI,NFI)
C     ==--------------------------------------------------------------==
C     == IREC: input -> flag array to indicate the read of record     ==
C     ==       output-> 0 if not read or no information               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'geq0.inc'
      INCLUDE 'ions.inc' 
      INCLUDE 'symm.inc' 
      INCLUDE 'elct.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'nose.inc' 
      INCLUDE 'metr.inc' 
      INCLUDE 'cell.inc' 
      INCLUDE 'poin.inc' 
      INCLUDE 'irat.inc' 
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'lscal.inc'
      INCLUDE 'store.inc'
      INCLUDE 'bsym.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'shop_rest.inc'
      INCLUDE 'mm_extrap.inc'
      INCLUDE 'shop_rest_2.inc'
      INCLUDE 'cdft.inc'
      INCLUDE 'mw.inc'
      INCLUDE 'prng.inc'
      INCLUDE 'gle.inc'
      REAL*8 PRNGIN(NPROC,2,3), PRNGOUT(NPROC,2,3)
C     ==--------------------------------------------------------------==
C     ==                     GENERAL FILE FORMAT                      ==
C     ==--------------------------------------------------------------==
C     ==  Section  1: Header                                          ==
C     ==  Section  2: Symmetry and Cell info                          ==
C     ==  Section  3: Number of atomic species and atoms per species  ==
C     ==  Section  4: Atomic coordinates                              ==
C     ==  Section  5: Atomic velocities                               ==
C     ==  Section  6: Initial atomic coordinates                      ==
C     ==  Section  7: Cutoff, # of electrons, grid                    ==
C     ==  Section  8: States, dual, plane waves                       ==
C     ==  Section  9: PW Coefficients                                 ==
C     ==  Section 10: PW Velocities                                   ==
C     ==  Section 11: Accumulators                                    ==
C     ==  Section 12: Nose thermostats general info                   ==
C     ==  Section 13: Nose thermostats electrons                      ==
C     ==  Section 14: Nose thermostats ions                           ==
C     ==  Section 15: Nose thermostats ions (ULTRA)                   ==
C     ==  Section 16: Nose thermostats ions (MASSIVE)                 ==
C     ==  Section 17: Nose thermostats cell                           ==
C     ==  Section 18: Potential                                       ==
C     ==  Section 19: PW single states                                ==
C     ==  Section 20: H Matrices (cell parameters)                    ==
C     ==  Section 21: K-Points                                        ==
C     ==  Section 22: Electron density                                ==
C     ==  Section 23: Occupation numbers                              ==
C     ==  Section 24: Fermi energy and eigenvalues                    ==
C     ==  Section 25: Classical Particles (coordinates and velocities)==
C     ==  Section 26: LinRes PW Coefficients                          ==
C     ==  Section 27: LinRes PW Velocities                            ==
C     ==  Section 28: Partial Hessian (for microiterative TS search)  ==
C     ==  Section 29: P-RFO status and work arrays                    ==
C     ==  Section 30: L-BFGS history and status                       ==
C     ==  Section 31: Adaptive tolerance status                       ==
C     ==  Section 32: Constraints values                              ==
C     ==  Section 33: Cell translation vector in QM/MM runs           ==
C     ==  Section 34: Local temperature parameters                    ==
C     ==  Section 35: Surface Hopping I                               ==
C     ==  Section 36: Surface Hopping II                              ==
C     ==  Section 37: Pseudo random number generator                  ==
C     ==  Section 38: (generalized) Langevin equation                 ==
C     ==  Section 39 - 98 : empty                                     ==
C     ==  Section 99: Wavefunction history for extrapolation          ==
C     ==--------------------------------------------------------------==
C     Arguments
      INTEGER    NR,IREC(100),NSTATE,NFI
      REAL*8     EIGV(NSTATE,NKPTS),
     &           TAU0(3,NAX,NSX),TAUM(3,NAX,NSX),TAUI(3,NAX,NSX)
      COMPLEX*16 C0(NGWK,NSTATE*NKPNT),CM(NGWK,NSTATE)
C     Variables
      DIMENSION RK(3,NKPTS),WK(NKPTS),F(N,NKPTS),
     &          NA0(MAXSP),POTR(NNR1,*),RHOO(NNR1,*)
      REAL*8    CENEW(6),ECUT0,CDUAL0
      INTEGER   IRECORD,IBRAV0,INDPG0,I,J,K,L,IREC0,NSP0,NA0,
     &          IS,IA,IG,IK,NR1S0,NR2S0,NR3S0,NEL0,N0,NKMIN,NMIN,
     &          NKPTS0,NGWKS0,NGWLS0,NHGS0,NHGLS0,INFO,NACC0,NACC1,
     &          IP,MCNSTR0
      CHARACTER STR*80
      LOGICAL   DUAL0,TKPNT0,TLSD0,TLSE0
      INTEGER   MSGLEN
      REAL*8    SMALL
      PARAMETER (SMALL=1.d-6)
C     ==--------------------------------------------------------------==
      IF(TPATH.AND.TPIMD) THEN
        IP=IPCURR
      ELSEIF(TMW)THEN
        IP=WALKER_ID
      ELSE
        IP=1
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PARENT) REWIND (NR)
      IF(PARENT) THEN
C       Section 1
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 1'
        ENDIF
        READ (NR) STR
        IF(INDEX(STR,'STUTTGART VERSION 3.0').EQ.0) THEN
          WRITE(6,*) ' WRONG FILE FORMAT ',STR
          CALL STOPGM('RV30',' HEADER ')
        ENDIF
C       ==------------------------------------------------------------==
C       Section 2
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 2'
        ENDIF
        IF(IREC(IREC_CELL).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.2) THEN
            READ (NR) IBRAV0,INDPG0
            READ (NR) (CENEW(I),I=1,6)
            IF(IBRAV0.NE.IBRAV) WRITE(6,'(A,T56,2I5)') 
     *        ' RV30! SUPERCELL SYMMETRY   HAS CHANGED ',
     *         IBRAV0,IBRAV
            IF(INDPG0.NE.INDPG) WRITE(6,'(A,T56,2I5)') 
     *        ' RV30! POINT GROUP SYMMETRY HAS CHANGED ',
     *         INDPG0,INDPG
            DO I=1,6
              IF(ABS(CENEW(I)-CELLDM(I)).GT.SMALL) WRITE(6,'(A,T65,I1)')
     *        ' RV30! SUPERCELL DIMENSIONS HAVE CHANGED: NUMBER=',I
            ENDDO
          ELSE
            WRITE(6,'(A)') ' RV30| WARNING! CANNOT READ SECTION 2 '
            IREC(IREC_CELL)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==------------------------------------------------------------==
C       Section 3
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 3'
        ENDIF
        IF(IREC(IREC_NAS).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.2) THEN
            READ (NR) NSP0
            READ (NR) (NA0(I),I=1,NSP0)
            IF(NSP0.NE.NSP) WRITE(6,'(A,T56,2I5)')
     *        ' RV30! NUMBER OF SPECIES HAS CHANGED ',
     *         NSP0,NSP
            DO IS=1,MIN(NSP0,NSP)
              IF(NA(IS).NE.NA0(IS)) WRITE(6,'(A,I3,A,T56,2I5)')
     *        ' RV30! NUMBER OF ATOMS FOR SPECIES ',IS,
     *        ' HAS CHANGED ',NA0(IS),NA(IS)
            ENDDO
          ELSE
            WRITE(6,'(A)') ' RV30| WARNING! CANNOT READ SECTION 3 '
            IREC(IREC_NAS)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 4
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 4'
        ENDIF
        IF(IREC(IREC_CO).NE.0) THEN
          READ (NR) IRECORD
          IF( (IREC(IREC_NAS).EQ.0).OR.(IRECORD.NE.NAT) ) THEN
            WRITE(6,'(A)') ' RV30! INCONSISTENT NUMBER OF ATOMS.'
            WRITE(6,'(A)')
     &         ' RV30| WARNING! CANNOT READ COORDINATES FROM SECTION 4'
            IREC(IREC_CO)=0
            CALL FSKIP(NR,IRECORD)
          ELSE
            DO IS=1,NSP
              DO IA=1,NA(IS)
                READ (NR) (TAU0(J,IA,IS),J=1,3)
              END DO
            END DO
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 5
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 5'
        ENDIF
        IF(IREC(IREC_VEL).NE.0) THEN
          READ (NR) IRECORD
          IF( (IREC(IREC_NAS).EQ.0).OR.(IRECORD.NE.NAT) ) THEN
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO IONIC VELOCITIES'
            IREC(IREC_VEL)=0
            CALL FSKIP(NR,IRECORD)
          ELSE
            DO IS=1,NSP
              DO IA=1,NA(IS)
                READ (NR) (TAUM(J,IA,IS),J=1,3)
              END DO
            END DO
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 6
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 6'
        ENDIF
        IF(IREC(IREC_ICO).NE.0) THEN
          READ (NR) IRECORD
          IF( (IREC(IREC_NAS).EQ.0).OR.(IRECORD.NE.NAT) ) THEN
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO INITIAL GEOMETRY'
            IREC(IREC_ICO)=0
            CALL FSKIP(NR,IRECORD)
          ELSE
            DO IS = 1 , NSP
              DO IA = 1 , NA ( IS )
                READ (NR) (TAUI(J,IA,IS),J=1,3)
              END DO
            END DO
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 7
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 7'
        ENDIF
        IF(IREC(IREC_CUT).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.1) THEN
            READ (NR) ECUT0,CDUAL0,DUAL0,NEL0,NR1S0,NR2S0,NR3S0
            IF(ABS(ECUT0-ECUT).GT.SMALL)
     *      WRITE(6,'(A,T46,2F10.2)')
     &           ' RV30! CUTOFF HAS CHANGED ',ECUT0,ECUT
            IF(ABS(CDUAL0-CDUAL).GT.SMALL)
     *      WRITE(6,'(A,T46,2F10.2)')
     &           ' RV30! DUAL HAS CHANGED ',CDUAL0,CDUAL
            IF(NEL0.NE.NINT(NEL)) WRITE(6,'(A,T56,2I5)') 
     *      ' RV30! NUMBER OF ELECTRONS HAS CHANGED ',
     *      NEL0,NINT(NEL)
            IF(NR1S0.NE.NR1S) WRITE(6,'(A,T56,2I5)') 
     *      ' RV30! X REAL SPACE MESH  HAS CHANGED ',NR1S0,NR1S
            IF(NR2S0.NE.NR2S) WRITE(6,'(A,T56,2I5)') 
     *      ' RV30! Y REAL SPACE MESH  HAS CHANGED ',NR2S0,NR2S
            IF(NR3S0.NE.NR3S) WRITE(6,'(A,T56,2I5)') 
     *      ' RV30! Z REAL SPACE MESH  HAS CHANGED ',NR3S0,NR3S
          ELSE
            WRITE(6,'(A)') ' RV30| WARNING! CANNOT READ SECTION 7 '
            IREC(IREC_CUT)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 8
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 8'
        ENDIF
        IF(IREC(IREC_SDP).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.1) THEN
            READ (NR) N0,NKPTS0,NGWKS0,NGWLS0,NHGS0,NHGLS0
            IF(N0.NE.N) WRITE(6,'(A,T56,2I5)') 
     *      ' RV30! NUMBER OF STATES   HAS CHANGED ',N0,N
            IF(TKPNT) THEN
              IF(NKPTS0.EQ.0) THEN
C                     WRITE(6,'(A)') ' RV30! TYPE   OF K-POINTS HAS CHANGED '
              ELSE IF(NKPTS0.NE.NKPTS) THEN
                WRITE(6,'(A,T56,2I5)')
     *               ' RV30! NUMBER OF K-POINTS HAS CHANGED ',
     *               NKPTS0,NKPTS
              ENDIF
            ELSE IF(NKPTS0.NE.0) THEN
C                   WRITE(6,'(A)') ' RV30! TYPE   OF K-POINTS HAS CHANGED '
            ENDIF
            IF(NKPTS0.EQ.0) THEN
              TKPNT0=.FALSE.
              NKPTS0=1
            ELSE
              TKPNT0=.TRUE.
            ENDIF
          ELSE
            WRITE(6,'(A)') ' RV30| WARNING! CANNOT READ SECTION 8 '
            IREC(IREC_SDP)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
          IREC(IREC_SDP)=0
        ENDIF
      ENDIF
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(N0,    MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(NKPTS0,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TKPNT0,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 3*NAT * 8
      CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
C     ==--------------------------------------------------------------==
C     Section 9
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 9'
      ENDIF
      IF(IREC(IREC_WF).NE.0) THEN
        IF(IREC(IREC_SDP).NE.0.OR.PROJNOW.OR.TSYSCOMB) THEN
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
          IF(TSYSCOMB)THEN
            N0=NSTATE
            NKPTS0=1
          ENDIF
          IF(PARENT) READ(NR) IRECORD
#ifdef PARALLEL
          MSGLEN = 1 * 8/IRAT
          CALL MY_BCAST(IRECORD,MSGLEN,SOURCE,ALLGRP)
#endif
          IF(IRECORD.EQ.0) THEN
            INFO=1
          ELSEIF(IRECORD.LT.0) THEN
            CALL R_WFNIO(NR,C0,NSTATE,INFO,TKPNT0,N0,NKPTS0,'C0')
          ELSE
            CALL RD30WFN(NR,C0,NSTATE,TAU0,INFO,
     &                   TKPNT0,N0,NKPTS0,'C0')
          ENDIF
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
        ELSE
          INFO=1
        ENDIF
        IF(INFO.NE.0) THEN
          IF(PARENT)
     &         WRITE(6,'(A)')
     &         ' RV30| WARNING! NO INITIAL WAVEFUNCTIONS'
          IREC(IREC_WF)=0
        ENDIF
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          IREC0 = ABS(IREC0)
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 10
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 10'
      ENDIF
      IF(IREC(IREC_PWV).NE.0) THEN
        IF(IREC(IREC_SDP).NE.0) THEN
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
          IF(PARENT) READ(NR) IRECORD
#ifdef PARALLEL
          MSGLEN = 1 * 8/IRAT
          CALL MY_BCAST(IRECORD,MSGLEN,SOURCE,ALLGRP)
#endif
          IF(IRECORD.EQ.0) THEN
            INFO=1
          ELSEIF(IRECORD.LT.0) THEN
            CALL R_WFNIO(NR,CM,NSTATE,INFO,TKPNT0,N0,NKPTS0,'NIL')
          ELSE
            CALL RD30WFN(NR,CM,NSTATE,TAU0,INFO,
     &                   TKPNT0,N0,NKPTS0,'NIL')
          ENDIF
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
        ELSE
          INFO=1
        ENDIF
        IF(INFO.NE.0) THEN
          IF(PARENT)
     &         WRITE(6,'(A)')
     &         ' RV30| WARNING! NO WAVEFUNCTION VELOCITIES'
          IREC(IREC_PWV)=0
        ENDIF
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          IREC0 = ABS(IREC0)
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 11
      IF(PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 11'
        ENDIF
        IF(IREC(IREC_AC).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.NE.2) THEN
             WRITE(6,'(A,2I5)')
     &           ' RV30| WARNING! NO ACCUMULATOR INFORMATION'
             IREC(IREC_AC)=0
             CALL FSKIP(NR,IRECORD)
          ELSE
            READ (NR) NFI,NACC0
            IF(NACC0.NE.NACC) WRITE(6,'(A,T56,2I5)') 
     *    ' RV30! NUMBER OF ACCUMULATOR ENTRIES HAS CHANGED ',
     *        NACC0,NACC
            NACC1=MIN(NACC0,NACC)
            READ (NR) ( ACC ( I ) , I = 1 , NACC1 )
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 12
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 12'
        ENDIF
        IF(IREC(IREC_NOSE).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.NE.2) THEN
             WRITE(6,'(A)')
     &           ' RV30| WARNING! NO NOSE INFORMATION'
             IREC(IREC_NOSE)=0
             CALL FSKIP(NR,IRECORD)
          ELSE
C..Nose parameters are fixed by input only!
            READ (NR)
            READ (NR)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 13
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 13'
        ENDIF
        IF(IREC(IREC_NOE).NE.0) THEN
          READ (NR) IRECORD
          IF((IRECORD.EQ.2).AND.BSYMM) THEN
               READ (NR) (ETA(I,1),ETADOT(I,1),I=1,NCHX)
               READ (NR) (ETA(I,2),ETADOT(I,2),I=1,NCHX)
          ELSEIF((IRECORD.EQ.2).AND.(.NOT.BSYMM)) THEN
               READ (NR) (ETA(I,IP),ETADOT(I,IP),I=1,NCHX)
               CALL FSKIP(NR,IRECORD)
          ELSEIF(IRECORD.EQ.1) THEN
               READ (NR) (ETA(I,IP),ETADOT(I,IP),I=1,NCHX)
          ELSE
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO NOSE INFORMATION'
            IREC(IREC_NOE)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 14
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 14'
        ENDIF
        IF(IREC(IREC_NOP1).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.1) THEN
            READ (NR) (ETAP1(I,IP),ETAP1DOT(I,IP),I=1,NCHX)
          ELSE
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO NOSE INFORMATION'
            IREC(IREC_NOP1)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 15
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 15'
        ENDIF
        IF(IREC(IREC_NOP2).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.1) THEN
            READ (NR) ((ETAP(J,I,IP),ETAPDOT(J,I,IP),I=1,NCHX),J=1,NSX)
          ELSE
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO NOSE INFORMATION'
            IREC(IREC_NOP2)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==--------------------------------------------------------------==
C       Section 16
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 16'
        ENDIF
        IF(IREC(IREC_NOP3).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.1) THEN
            READ (NR) ((ETAPM(K,L,IP),ETAPMDOT(K,L,IP),K=1,3*NAX*NSX),
     *                 L=1,NCHX)
          ELSE
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO NOSE INFORMATION'
            IREC(IREC_NOP3)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
C       ==------------------------------------------------------------==
C       Section 17
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 17'
        ENDIF
        IF(IREC(IREC_NOC).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.1) THEN
            READ (NR) (ETC(I,IP),ETCDOT(I,IP),I=1,NCHX)
          ELSE
            WRITE(6,'(A)') ' RV30| WARNING! NO NOSE INFORMATION'
            IREC(IREC_NOC)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     We communicate some information for the other processors
      MSGLEN= 1 * 8/IRAT
      CALL MY_BCAST(NR1S0,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(NR2S0,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(NR3S0,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(NFI,MSGLEN,SOURCE,ALLGRP)
C     Section 18
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 18'
      ENDIF
      IF(IREC(IREC_POT).NE.0) THEN
        IF(PARENT) READ (NR) IRECORD
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(IRECORD,MSGLEN,SOURCE,ALLGRP)
        IF( (IRECORD.NE.0).AND.(IREC(IREC_CUT).NE.0) ) THEN
          TLSD0=IRECORD.EQ.2*NR1S0
          IF(TLSD0)IRECORD=IRECORD/2
          TLSE0=IRECORD.EQ.4*NR1S0
          IF(TLSE0)IRECORD=IRECORD/4
          CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,POTR(1,1))
          IF(TLSD) THEN
            IF(TLSD0) THEN
              CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,POTR(1,2))
            ELSE
              CALL DCOPY(NNR1,POTR(1,1),1,POTR(1,2),1)
            ENDIF
          ELSEIF(TLSE) THEN
            IF(TLSE0) THEN
              CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,POTR(1,2))
              CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,POTR(1,3))
              CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,POTR(1,4))
            ELSE
              CALL DCOPY(NNR1,POTR(1,1),1,POTR(1,2),1)
              CALL DCOPY(NNR1,POTR(1,1),1,POTR(1,3),1)
              CALL DCOPY(NNR1,POTR(1,1),1,POTR(1,4),1)
            ENDIF
          ELSE
            IF(TLSD0) CALL FSKIP(NR,IRECORD)
            IF(TLSE0) CALL FSKIP(NR,IRECORD*3)
          ENDIF
        ELSEIF(PARENT) THEN
          WRITE(6,'(A)')
     &         ' RV30| WARNING! NO POTENTIAL INFORMATION'
          IREC(IREC_POT)=0
          CALL FSKIP(NR,IRECORD)
        ENDIF
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 19
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 19'
      ENDIF
      IF(IREC(IREC_PWS).NE.0) THEN
        IF(IREC(IREC_SDP).NE.0) THEN
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
          IF(PARENT) READ(NR) IRECORD
#ifdef PARALLEL
          MSGLEN = 1 * 8/IRAT
          CALL MY_BCAST(IRECORD,MSGLEN,SOURCE,ALLGRP)
#endif
          IF(IRECORD.EQ.0) THEN
            INFO=1
          ELSEIF(IRECORD.LT.0) THEN
            CALL R_WFNIO(NR,CSTATE,1,INFO,TKPNT0,N0,NKPTS0,'NIL')
          ELSE
            CALL RD30WFN(NR,CSTATE,1,TAU0,INFO,
     &                   TKPNT0,N0,NKPTS0,'NIL')
          ENDIF
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
        ELSE
          INFO=1
        ENDIF
        IF(INFO.NE.0) THEN
          IF(PARENT)
     &         WRITE(6,'(A)')
     &         ' RV30| WARNING! CANNOT READ SECTION 19'
          IREC(IREC_PWS)=0
        ENDIF
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 20
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 20'
      ENDIF
      IF(PARENT) THEN
        IF(IREC(IREC_HE).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.NE.6) THEN
             WRITE(6,'(A)')
     &           ' RV30| WARNING! CANNOT READ CELL INFORMATION'
             IREC(IREC_HE)=0
             CALL FSKIP(NR,IRECORD)
          ELSE
            READ (NR) HT
            READ (NR) HTM1
            READ (NR) HTVEL
            READ (NR) HTFOR
            READ (NR) HT0
            READ (NR) HTM10
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 21
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 21'
      ENDIF
      IF(IREC(IREC_KPT).NE.0) THEN
        IF(PARENT) READ (NR) IRECORD
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(IRECORD,MSGLEN,SOURCE,ALLGRP)
        IF(IRECORD.NE.0) THEN
          IF(TKPNT.AND.(IRECORD.EQ.NKPTS0).AND.
     &       (IRECORD.NE.0).AND.(IREC(IREC_SDP).NE.0)) THEN
            CALL RD30KPNT(NR,NSTATE,NKPTS0,TKPNT0,C0,CM,TAU0,IREC)
          ELSE
            IF((IRECORD.NE.NKPTS0).OR.(IREC(IREC_SDP).EQ.0)) THEN
              IF(PARENT) THEN
                WRITE(6,'(A)')
     &               ' RV30| WARNING! NO K-POINTS INFORMATION'
                IREC(IREC_HE)=0
              ENDIF
            ELSE
              IF(TKPNT.AND.NKPTS.EQ.1.AND.(RK(1,1).EQ.0.D0)
     &             .AND.(RK(2,1).EQ.0.D0).AND.(RK(3,1).EQ.0.D0)) THEN
                DO I=1,NSTATE
                  DO IG=1,NGW
                    C0(IG+NGW,I)=DCONJG(C0(IG,I))
                  ENDDO
                  IF(GEQ0) C0(NGW+1,I)=DCMPLX(0.D0,0.D0)
                ENDDO
              ELSE
                IF(TLSD) THEN
                  CALL PUTCONJ(C0(1,1),NSUP)
                  CALL PUTCONJ(C0(1,NSUP+1),NSDOWN)
                ELSE
                  CALL PUTCONJ(C0,NSTATE)
                ENDIF
              ENDIF
              IF(PARENT) WRITE(6,'(A)')
     &             ' RV30! TYPE   OF K-POINTS HAS CHANGED'
            ENDIF
            IF(PARENT) CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          IF(TKPNT) THEN
            DO I=1,NSTATE
              DO IG=1,NGW
                C0(IG+NGW,I)=DCONJG(C0(IG,I))
              ENDDO
              IF(GEQ0) C0(NGW+1,I)=DCMPLX(0.D0,0.D0)
            ENDDO
            IF(PARENT) WRITE(6,'(A)')
     &           ' RV30! TYPE   OF K-POINTS HAS CHANGED'
          ENDIF
          IF(PARENT) CALL FSKIP(NR,IRECORD)
        ENDIF
CEHR[
      ELSEIF (CMPLX_WF.AND.START_REAL) THEN
        DO I=1,NSTATE
          DO IG=1,NGW
            C0(IG+NGW,I)=DCONJG(C0(IG,I))
          ENDDO
          IF(GEQ0) C0(NGW+1,I)=DCMPLX(0.D0,0.D0)
        ENDDO
        IF(PARENT) WRITE(6,'(A)')
     &       ' RV30! TYPE   OF K-POINTS HAS CHANGED 3'
CEHR]
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
          IF( (TKPNT.AND.(.NOT.TKPNT0)).OR.(.NOT.TKPNT.AND.TKPNT0) )
     &         WRITE(6,'(A)') ' RV30! TYPE   OF K-POINTS HAS CHANGED'
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 22
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 22'
      ENDIF
      IF(IREC(IREC_RHO).NE.0) THEN
        IF(PARENT) READ (NR) IRECORD
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(IRECORD,MSGLEN,SOURCE,ALLGRP)
        IF( (IRECORD.NE.0).AND.(IREC(IREC_CUT).NE.0) ) THEN
          TLSD0=IRECORD.EQ.2*NR1S0
          IF(TLSD0)IRECORD=IRECORD/2
          TLSE0=IRECORD.EQ.4*NR1S0
          IF(TLSE0)IRECORD=IRECORD/4
C         For LSD RHOO(1,1)=alpha+beta density, RHOO(1,2)=beta density
          CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,RHOO(1,1))
          IF(TLSD) THEN
            IF(TLSD0) THEN
              CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,RHOO(1,2))
            ELSE
              CALL AZZERO(RHOO(1,2),NNR1)
              CALL DAXPY(NNR1,0.5D0,RHOO(1,1),1,RHOO(1,2),1)
            ENDIF
C         For LSE RHOO(1,1)=total density, RHOO(1,2)=beta density, m state
C         For LSE RHOO(1,3)=total density, RHOO(1,4)=beta density, t state
          ELSEIF(TLSE) THEN
            IF(TLSE0) THEN
              CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,RHOO(1,2))
              CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,RHOO(1,3))
              CALL RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,RHOO(1,4))
            ELSE
              CALL AZZERO(RHOO(1,2),NNR1)
              CALL DAXPY(NNR1,0.5D0,RHOO(1,1),1,RHOO(1,2),1)
              CALL AZZERO(RHOO(1,3),NNR1)
              CALL DCOPY(NNR1,RHOO(1,1),1,RHOO(1,3),1)
              CALL AZZERO(RHOO(1,4),NNR1)
              CALL DAXPY(NNR1,0.5D0,RHOO(1,3),1,RHOO(1,4),1)
            ENDIF
          ELSE
            IF(TLSD0) CALL FSKIP(NR,IRECORD)
            IF(TLSE0) CALL FSKIP(NR,IRECORD*3)
          ENDIF
        ELSEIF(PARENT) THEN
          WRITE(6,'(A)')
     &         ' RV30| WARNING! NO DENSITY INFORMATION'
          IREC(IREC_RHO)=0
          CALL FSKIP(NR,IRECORD)
        ENDIF
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 23
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 23'
      ENDIF
      IF(IREC(IREC_OCC).NE.0) THEN
        IF(PARENT) THEN
          READ (NR) IRECORD
          IF( (IRECORD.NE.0).AND.(IRECORD.EQ.NKPTS0).AND.
     &        (IREC(IREC_SDP).NE.0) ) THEN
            NKMIN=MIN(NKPTS,NKPTS0)
            NMIN=MIN(N,N0)
            CALL AZZERO(F(1,1),N*NKPTS)
            DO IK=1,NKMIN
              READ(NR) (F(I,IK),I=1,NMIN)
            ENDDO
            CALL FSKIP(NR,IRECORD-NKMIN)
          ELSE
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO OCCUPATION NUMBERS INFORMATION'
            IREC(IREC_OCC)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ENDIF
        MSGLEN = N*NKPTS * 8
        CALL MY_BCAST(F,MSGLEN,SOURCE,ALLGRP)
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 24
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 24'
      ENDIF
      IF(IREC(IREC_EIGV).NE.0) THEN
        IF(PARENT) THEN
          READ (NR) IRECORD
          IF( (IRECORD.NE.0).AND.(IRECORD.EQ.NKPTS0+1).AND.
     &         (IREC(IREC_SDP).NE.0) ) THEN
            READ (NR) AMU
            IRECORD=IRECORD-1
            NKMIN=MIN(NKPTS,NKPTS0)
            NMIN=MIN(N,N0)
            CALL AZZERO(EIGV(1,1),N*NKPTS)
            DO IK=1,NKMIN
              READ(NR) (EIGV(I,IK),I=1,NMIN)
            ENDDO
            CALL FSKIP(NR,IRECORD-NKMIN)
          ELSE
            WRITE(6,'(A,A)') ' RV30| WARNING! ',
     &           'NO FERMI ENERGY AND EIGENVALUES INFORMATION'
            IREC(IREC_EIGV)=0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ENDIF
        MSGLEN = 1 * 8
        CALL MY_BCAST(AMU,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = N*NKPTS * 8
        CALL MY_BCAST(EIGV,MSGLEN,SOURCE,ALLGRP)
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 25
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 25'
      ENDIF
      IF(IREC(IREC_CLAS).NE.0) THEN
        IF(PARENT) THEN
          READ (NR) IRECORD
          IF(IRECORD.NE.NCLATOM) THEN
            WRITE(6,'(A,A)') ' RV30| WARNING! ',
     &           'CANNOT READ CORRECTLY CLASSICAL PARTICLE INFORMATION'
            IREC(IREC_CLAS)=0
            CALL FSKIP(NR,IRECORD)
          ELSE
            DO I=1,NCLATOM
              READ (NR) (CLASC(J,I),J=1,3),(CLASV(J,I),J=1,3)
            ENDDO
          ENDIF
        ENDIF
        MSGLEN = 3*NCLATOM * 8
        CALL MY_BCAST(CLASC,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 3*NCLATOM * 8
        CALL MY_BCAST(CLASV,MSGLEN,SOURCE,ALLGRP)
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 26
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 26'
      ENDIF
      IF(IREC(IREC_LRWF).NE.0) THEN
        CALL R_LINRES (NR,"WF")
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==------------------------------------------------------------==
C     Section 27
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 27'
      ENDIF
      IF(IREC(IREC_LRWV).NE.0) THEN
        CALL R_LINRES (NR,"WV")
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==------------------------------------------------------------==
C     Section 28
      IF (PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 28'
        ENDIF
        IF(IREC(IREC_PHES).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD-1.NE.NVAR .AND. NVAR.NE.0) THEN
            WRITE(6,'(A,A,2I3)') ' RV30| WARNING! ',
     &           'CANNOT READ CORRECTLY PARTIAL HESSIAN INFORMATION'
            WRITE(6,'(A,2I4)') '   NVAR / IRECORD: ', NVAR, IRECORD
            IREC(IREC_PHES)=0
            CALL FSKIP(NR,IRECORD)
            IRECORD = 0
          ELSE IF (IRECORD-1.GT.0 .AND. NVAR.EQ.0) THEN
            NVAR = IRECORD-1
            WRITE(6,'(A,A,I3)') ' RV30| WARNING! ',
     &            'SETTING THE CORE SIZE FROM THE HESSIAN SIZE: ', NVAR
          ELSE IF (IRECORD-1.LE.0) THEN
            WRITE(6,'(A,A)') ' RV30| WARNING! ',
     &            'NO VALID PARTIAL HESSIAN RECORD IN RESTART FILE'
            IREC(IREC_PHES)=0
            CALL FSKIP(NR,IRECORD)
            IRECORD = 0
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
          IRECORD = 0
        ENDIF
      ENDIF
      IF(IRECORD.NE.0) THEN
        CALL MEMORY(IP_HESSCR,NVAR*NVAR,'HESSCR')
        NSHESS = 0
        LALLHS = .FALSE.
        IF(PARENT) THEN
          K=0
          DO I=1,NVAR
            READ (NR) (HESSCR(J+K,1),J=1,NVAR) ! if NVAR is set here
            K=K+NVAR
          ENDDO
          READ (NR) NSHESS, LVLHES
          IF (.NOT.LVLHES) THEN
            IF (NSHESS.GT.0 .AND. MOD(NSHESS,2).EQ.0) THEN
              NSHESS = NSHESS - 1
              LUNDOP = .TRUE.
              WRITE(6,'(A,A,I3)') ' RV30| WARNING! ',
     &             'INCOMPLETE HESSIAN, REDOING DIMENSION ',
     &             NSHESS/2+1
            ELSE
              WRITE(6,'(A,A,I3)') ' RV30| WARNING! ',
     &             'INCOMPLETE HESSIAN, DOING DIMENSION ',
     &             NSHESS/2+1
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 29
      IF (PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 29'
        ENDIF
        IF(IREC(IREC_PRFO).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.8) THEN
             CALL RD30PRFO (NR, IRECORD, IREC(IREC_LBFGS))
          ELSE
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO P-RFO INFORMATION'
            IREC(IREC_LBFGS) = 0
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 30
      IF (PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 30'
        ENDIF
        IF(IREC(IREC_LBFGS).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.GE.7) THEN
             CALL RD30LBFGS (NR, IRECORD)
          ELSE
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO L-BFGS INFORMATION'
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 31
      IF (PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 31'
        ENDIF
        IF(IREC(IREC_RDTL).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.1) THEN
             READ (NR) DELAST, DEMIN, TOLMIN, TOLOG, TOLAD, TOLENE
          ELSE
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO ADAPTIVE TOLERANCE INFORMATION'
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
#ifdef PARALLEL
      MSGLEN = 8
      CALL MY_BCAST(DELAST,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TOLMIN,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TOLOG,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TOLAD,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TOLENE,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
C     Section 32
      IF (PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 32'
        ENDIF
        IF(IREC(IREC_CONS).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.EQ.2) THEN
             READ (NR) MCNSTR0
             IF(MCNSTR0.EQ.MCNSTR) THEN
               READ (NR) (CNSVAL(I),I=1,MCNSTR)
             ELSE
               READ (NR)
               WRITE(6,'(A)')
     &           ' RV30| WARNING! INCONSISTENT CONSTRAINT INFORMATION'
             ENDIF
          ELSE
            WRITE(6,'(A)')
     &           ' RV30| WARNING! NO CONSTRAINT INFORMATION'
            CALL FSKIP(NR,IRECORD)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 33
      IF(PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 33'
        ENDIF
        IF(IREC(IREC_CTRANS).NE.0) THEN
          READ (NR) IRECORD
          IF(IRECORD.NE.1) THEN
            WRITE(6,'(2A)') ' RV30| NO CELL TRANSLATION DATA. ',
     &           'INITIALIZING TO (0.0,0.0,0.0).'
            IREC(IREC_CTRANS)=0
            CALL FSKIP(NR,IRECORD)
            MM_C_TRANS(1)=0.0d0
            MM_C_TRANS(2)=0.0d0
            MM_C_TRANS(3)=0.0d0
          ELSE
            READ (NR) (MM_C_TRANS(I),I=1,3)
          ENDIF
        ELSE
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
#ifdef PARALLEL
      MSGLEN = 3 * 8/IRAT
      CALL MY_BCAST(MM_C_TRANS(1),MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
C       Section 34
C  FIXME LOCT: READ GROUPS AND PARAMETERS, CHECK PARALELL
      IF(PARENT) THEN
        IF(TDEBIO) THEN
            WRITE(6,*) 'READ SECTION 34'
        ENDIF
         IF(IREC(IREC_NOP4).NE.0) THEN
            READ (NR) IRECORD
            IF(IRECORD.EQ.2) THEN
               READ (NR) ((LCTTAB(J,I),I=1,NAX),J=1,NSX)
               READ (NR) ((ETAP(J,I,IP),ETAPDOT(J,I,IP),I=1,NCHX),
     &              J=1,NAX*NSX)
            ELSE
               WRITE(6,'(A)')
     &              ' RV30| WARNING! NO NOSE INFORMATION'
               IREC(IREC_NOP2)=0
               CALL FSKIP(NR,IRECORD)
            ENDIF
         ELSE
            READ (NR) IREC0
            IREC0 = ABS(IREC0)
            CALL FSKIP(NR,IREC0)
         ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 35
      IF(PARENT) THEN
         IF(TDEBIO.AND.PARENT) THEN
            WRITE(6,*) 'READ SECTION 35'
         ENDIF
         IF(IREC(IREC_SHOP).NE.0) THEN
            READ(NR) IRECORD
            IF(IRECORD.EQ.5) THEN
               READ (NR) ISURF,(POP(I),I=1,6),DET,DETOLD
               DO I=1,2
                  READ (NR) (COUPL(I,K),COUPLOLD(I,K),K=1,2)
                  READ (NR) EC(I),EOLD(I)
               ENDDO
            ELSE
               WRITE(6,'(A)')
     .              ' RV30| WARNING! NO SURFACE HOPPING INFORMATION'
               IREC(IREC_SHOP)=0
               CALL STOPGM('RV30','ERROR READING SHOP')
            ENDIF
         ELSE
            READ (NR) IREC0
            CALL FSKIP(NR,IREC0)
         ENDIF
      ENDIF
#ifdef PARALLEL
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(ISURF,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 6 * 8
      CALL MY_BCAST(POP,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 4 * 8
      CALL MY_BCAST(COUPL,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(COUPLOLD,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 2 * 8
      CALL MY_BCAST(EC,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 2 * 8
      CALL MY_BCAST(EOLD,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
C     Section 36
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 36'
      ENDIF
      IF(IREC(IREC_SHOPBO).NE.0) THEN
        IF(PARENT) READ(NR) IRECORD
#ifdef PARALLEL
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(IRECORD,MSGLEN,SOURCE,ALLGRP)
#endif
        IF(IRECORD.EQ.0) THEN
          IF(PARENT) THEN
             WRITE(6,'(A)') 'RV30| WARNING! NO SHOP WAVEFUNCTIONS'
             CALL STOPGM('RV30','ERROR READING PREVIOUS WAVEFUNCTION')
          ENDIF
        ELSEIF(IRECORD.LT.0) THEN
          CALL R_WFNIO(NR,C0OLD,NSTATE,INFO,TKPNT0,N0,NKPTS0,'C0')
        ELSE
          CALL RD30WFN(NR,C0OLD,NSTATE,TAU0,INFO,
     .                                      TKPNT0,N0,NKPTS0,'C0')
        ENDIF
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          IREC0 = ABS(IREC0)
            CALL FSKIP(NR,IREC0)
         ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 37
      PRNGIN=0.0
      PRNGOUT=0.0
      IF (PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 37'
        ENDIF
        IF(IREC(IREC_PRNG).NE.0) THEN
          READ(NR) IRECORD
          IF(IRECORD.LT.2) THEN
               WRITE(6,'(A)') 'RV30| WARNING! NO PRNG STATE'
               CALL STOPGM('RV30','ERROR READING PREVIOUS PRNG') 
          ELSE IF (IRECORD.NE.(1+NPROC)) THEN
               WRITE(6,'(A)') 
     &  'RV30| WARNING! NUMPROC CHANGED, PARALLEL PRNG WILL BE RESETTED'
               READ (NR) (REPSEED(1,I),I=1,3),(REPSEED(2,I),I=1,3) 
               READ (NR) (PARASEED(1,I),I=1,3),(PARASEED(2,I),I=1,3)
               DO J=1,IRECORD-2
                 READ (NR) (PRNGIN(J,1,I),I=1,3),(PRNGIN(J,2,I),I=1,3)
               END DO
          ELSE 
            READ (NR) (REPSEED(1,I),I=1,3),(REPSEED(2,I),I=1,3) 
            DO J=1,NPROC
              READ(NR) 
     &       (PRNGIN(J,1,I),I=1,3),(PRNGIN(J,2,I),I=1,3)
            ENDDO
          ENDIF
        ELSE
          READ (NR) IREC0
          IREC0 = ABS(IREC0)
            CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF

      MSGLEN = 6 * 8
      CALL MY_BCAST(REPSEED,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(IRECORD,8/IRAT,SOURCE,ALLGRP)
      IF (IRECORD.NE.(1+NPROC)) THEN 
        CALL MY_BCAST(PARASEED,MSGLEN,SOURCE,ALLGRP)
        CALL PRNGPARASKIP(PARASEED,PARASEED)  ! skips so as to reconstruct the paraseed on individual nodes
      ELSE
        MSGLEN = NPROC * 6 * 8
        CALL MY_COMBINE(PRNGIN,PRNGOUT,MSGLEN,1,ALLGRP)
        IF(TPATH.OR.TMW) THEN
          PARASEED=PRNGOUT(mepos+1,:,:)
        ELSE
          PARASEED=PRNGOUT(me+1,:,:)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 38
      IF (PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 38'
        ENDIF
        IF(IREC(IREC_GLE).NE.0) THEN
          READ(NR) IRECORD
          IF(IRECORD.NE.(1+NAT*(GLE_NS+1))) THEN
               WRITE(6,'(A)') 'RV30| WARNING! NO GLE DATA OR NS CHANGED'
               CALL STOPGM('RV30','ERROR READING PREVIOUS GLE DATA') 
          ELSE 
            READ (NR) EGLE
            DO IS = 1 , NSP
              DO IA = 1, NA(IS)
                DO I= 1, GLE_NS+1
                  READ (NR) (GLEP(J,IA,IS,I),J=1,3)
                END DO
              END DO
            END DO
          ENDIF
        ELSE
          READ (NR) IREC0
          IREC0 = ABS(IREC0)
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
      MSGLEN = 8 /IRAT
      CALL MY_BCAST(IREC(IREC_GLE),MSGLEN,SOURCE,ALLGRP)

      IF(IREC(IREC_GLE).NE.0) THEN
        MSGLEN = 8 
        CALL MY_BCAST(EGLE,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = NAX * NSP *3* (GLE_NS+1) * 8
        CALL MY_BCAST(GLEP,MSGLEN,SOURCE,ALLGRP)
      END IF
C     ==--------------------------------------------------------------==
C     Section 39 - 98
      IF(PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'READ SECTION 38-98'
        ENDIF
        DO I=39,98
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 99
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'READ SECTION 99'
      ENDIF
      NUMCOLD=0
      IF(IREC(IREC_XTRP).NE.0) THEN
        IF(PARENT) THEN
          READ (NR) IRECORD
          IF(IRECORD.NE.1) THEN
            WRITE(6,'(2A)') ' RV30| INCONSISTENT WF HISTORY DATA. ',
     &          ' SKIPPING AHEAD...'
            IREC(IREC_XTRP)=0
            NUMCOLD=0
          ELSE
            READ(NR) NUMCOLD
          ENDIF
        ENDIF
        MSGLEN = 2 * 8/IRAT
        NNOW=NUMCOLD
        CALL MY_BCAST(NUMCOLD,MSGLEN,SOURCE,ALLGRP)
        
        IF(NUMCOLD.GT.0) THEN
          DO I=1,NUMCOLD
            IF(PARENT) READ(NR) IRECORD
            MSGLEN = 1 * 8/IRAT
            CALL MY_BCAST(IRECORD,MSGLEN,SOURCE,ALLGRP)
            
            IF (I.LE.MEXTRA) THEN
              IF(TDEBIO.AND.PARENT) THEN
                WRITE(6,'(A,I2,A,I2)') ' RV30| READING OLD WFN   ',
     &              I,' OF ',NUMCOLD
              ENDIF
              IF(IRECORD.LT.0) THEN
                CALL R_WFNIO(NR,COLD(1,1,1,I),NSTATE,INFO,TKPNT0,
     &              N0,NKPTS0,'C0')
              ELSE
                INFO=1
              ENDIF
            ELSE
              IF(PARENT) THEN
                WRITE(6,'(A,I2,A,I2)') ' RV30| SKIPPING OLD WFN  ',
     &                I,' OF ',NUMCOLD
                IREC0 = ABS(IRECORD)
                CALL FSKIP(NR,IREC0)
              ENDIF
            ENDIF
          END DO
          NUMCOLD=MIN(NUMCOLD,MEXTRA)
        ELSE
          INFO=1
        ENDIF
        
        IF(INFO.NE.0) THEN
          IF(PARENT)  WRITE(6,'(A)')
     &        ' RV30| WARNING! NO OR CORRUPT WAVEFUNCTION HISTORY'
          IREC(IREC_XTRP)=0
        ENDIF
      ELSE
        IF(PARENT) THEN
          READ (NR) IRECORD
          IF(IRECORD.GT.1) THEN
            WRITE(6,'(2A)') ' RV30| INCONSISTENT WF HISTORY DATA. ',
     &          ' SKIPPING AHEAD...'
            IREC(IREC_XTRP)=0
            NUMCOLD=0
          ELSEIF(IRECORD.EQ.0) THEN
            NUMCOLD=0
            IREC(IREC_XTRP)=0
          ELSE
            READ(NR) NUMCOLD
          ENDIF

          DO I=1,NUMCOLD
            READ(NR) IREC0
            IREC0 = ABS(IREC0)
            IF(TDEBIO) THEN
              WRITE(6,*) 'SKIPPING WFN ',I,' OF ',NUMCOLD
            ENDIF
            CALL FSKIP(NR,IREC0)
          END DO
          NUMCOLD=0
        ENDIF
      ENDIF
      MSGLEN = 2 * 8/IRAT
      NNOW=NUMCOLD
      CALL MY_BCAST(NUMCOLD,MSGLEN,SOURCE,ALLGRP)
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'CLOSE THE FILE'
        ENDIF
        CLOSE (NR)
      ENDIF
C     Broadcast information of IREC
      MSGLEN = 100 * 8/IRAT
      CALL MY_BCAST(IREC,MSGLEN,SOURCE,ALLGRP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RD30POT(NR,IRECORD,NR1S0,NR2S0,NR3S0,POTR)
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
C     == Read Potential or density array in RESTART file              ==
C     == Works if the dimensions of reading array are not             ==
C     == the same as POTR (but no guarantee)                          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
C     Arguments
      INTEGER NR,IRECORD,NR1S0,NR2S0,NR3S0
      REAL*8  POTR(KR1,KR2S*KR3S)
C     Variables
      INTEGER KK,KR1S0,KR2S0,KR3S0,IR,I,KKS0
#ifdef PARALLEL
      INTEGER KKMAX
      REAL*8  PSCR(KR2S*KR3S)
      POINTER (IP_PSCR,PSCR)
      INTEGER IPP,IPX,IP,MSGID,MSGLEN,NBYTES,IRR
#else
      REAL*8  PSCR((NR1S0+1)*(NR2S0+1)*(NR3S0+1))
      POINTER (IP_PSCR,PSCR)
#endif
C     ==--------------------------------------------------------------==
      KK=KR2S*KR3S
C     Added to avoid a bug in T3E (Thierry Deutsch 28/04/97)
      CALL AZZERO(POTR,KR1*KK)
C     Dimensions for POT in reading file.
      KR1S0=NR1S0+MOD(NR1S0+1,2)
      KR2S0=NR2S0+MOD(NR2S0+1,2)
      KR3S0=NR3S0+MOD(NR3S0+1,2)
      KKS0=KR2S0*KR3S0
#ifdef PARALLEL
      KKMAX=MAX(KKS0,KK)
      CALL MEMORY(IP_PSCR,KKMAX,'PSCR')
      DO IR=1,IRECORD
        IF(PARENT) READ(NR) (PSCR(I),I=1,KKS0)
        IF(KKS0.LT.KK) CALL AZZERO(PSCR(KKS0+1),KK-KKS0)
        IF(IRECORD.GT.NR1S) THEN
          GOTO 20
        ELSE
          DO IPP=1,NPROC
            IF(IR.GE.NRXPL(IPP-1,1).AND.IR.LE.NRXPL(IPP-1,2)) THEN
              IPX=IPP
              GOTO 10
            ENDIF
          ENDDO
          CALL STOPGM('RD30POT','ERROR IN NRXPL')
        ENDIF
   10   CONTINUE
        IP=PGROUP(IPX)
        CALL MY_SYNC(ALLGRP)
        IF(IP.NE.SOURCE) THEN
          IF(PARENT) THEN
            MSGID=1
            MSGLEN=KK * 8
            CALL MY_BSEND(PSCR,MSGLEN,IP,MSGID)
          ELSEIF(ME.EQ.IP) THEN
            MSGID=1
            MSGLEN=KK * 8
            CALL MY_BRECV(PSCR,MSGLEN,PGROUP(1),MSGID,NBYTES)
          ENDIF
          CALL MY_SYNC(ALLGRP)
        ENDIF
        IF(IP.EQ.ME) THEN
          IRR=IR-NRXPL(MEPOS,1)+1
          CALL DCOPY(KK,PSCR(1),1,POTR(IRR,1),KR1)
        ENDIF
 20     CONTINUE
      ENDDO
      CALL FREEM(IP_PSCR)
#else
      IF((NR1.EQ.NR1S0).AND.(NR2.EQ.NR2S0).AND.(NR3.EQ.NR3S0)) THEN
C       No problem: KK=KS0
        CALL MEMORY(IP_PSCR,KK,'PSCR')
        DO IR=1,IRECORD
          READ(NR) (PSCR(I),I=1,KK)
          CALL DCOPY(KK,PSCR(1),1,POTR(IR,1),KR1)
        ENDDO
      ELSE
C       Different grids: Interpolation (roughly)
        CALL MEMORY(IP_PSCR,KKS0*KR1S0,'PSCR')
        DO IR=1,IRECORD
          READ(NR) (PSCR((I-1)*KR1S0+IR),I=1,KKS0)
        ENDDO
        CALL INTERP3D(PSCR,KR1S0,KR2S0,KR3S0,POTR,KR1,KR2,KR3)
      ENDIF
      CALL FREEM(IP_PSCR)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RD30KPNT(NR,NSTATE,NKPTS0,TKPNT0,C0,CM,TAU0,IREC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'store.inc'
C          Arguments
      INTEGER    NR,NSTATE,NKPTS0, IREC(100)
      LOGICAL    TKPNT0
      COMPLEX*16 C0(NGWK,NSTATE,NKPNT),CM(NGWK,NSTATE,NKPNT)
      REAL*8     TAU0(3,NAX,NSX)
C          Variables
      REAL*8    EPS
      PARAMETER (EPS=1.D-3)
      DIMENSION RK(3,NKPTS),WK(NKPTS)
      CHARACTER STR*80
      REAL*8    CA(*),CR(*),RK0(3,NKPTS0)
      INTEGER   ICMP(*),MAPW(*),ITABKPT(NKPTS0),ITABLE(NKPTS0)
      POINTER   (IP_CA,CA),(IP_CR,CR),(IP_ICMP,ICMP),(IP_MAPW,MAPW),
     &          (IP_RK0,RK0),(IP_ITABKPT,ITABKPT),(IP_ITABLE,ITABLE)
      INTEGER   IK,J,IKPOINT,IPERM,IKPT,IKIND,INDEX,IR,IRECORD,
     &          N0,NGWKS0,ICOMPR,LEN,NGWA,NSTATE0,NREAD,ISTATE,NN
      REAL*8    WK0,SCALE
      INTEGER MSGLEN
#ifdef PARALLEL
      INTEGER   LEN1
#endif
C     ==--------------------------------------------------------------==
C     If options restart kpoints, the number of kpoints has to be equal.
      IF(RKPT) THEN
        IF(NKPTS.NE.NKPTS0) THEN
          IF(PARENT) THEN
            WRITE(6,*)
     &         ' RD30KPNT| WITH RESTART KPOINTS, THE NUMBER OF KPOINTS'
            WRITE(6,*)
     &         '           HAS TO BE THE SAME (NKPTS-OLD=',NKPTS0,')'
          ENDIF
          CALL STOPGM(' RD30KPNT|',
     &         'THE NUMBER OF KPOINTS ARE DIFFERENT !')
        ENDIF
        IF(PARENT) CALL FSKIP(NR,NKPTS)
        RETURN
      ENDIF
      CALL MEMORY(IP_RK0,3*NKPTS0,'RK0')
      CALL MEMORY(IP_ITABKPT,NKPTS0,'ITABKPT')
      CALL MEMORY(IP_ITABLE,NKPTS0,'ITABLE')
C          No options restart.
      IF(PARENT) THEN
        DO IK=1,NKPTS0
          READ(NR) (RK0(J,IK),J=1,3),WK0
        ENDDO
      ENDIF
      MSGLEN = 3 * NKPTS0 * 8
      CALL MY_BCAST(RK0,MSGLEN,SOURCE,ALLGRP)
C     Compare each kpoints in order to use the maximum information.
      IKPOINT=0
      IPERM=0
      CALL IAZZERO(ITABLE,NKPTS0)
      DO IKPT=1,NBLKP
        DO IKIND=1,NKPBL(IKPT)
          IK=KPBEG(IKPT)+IKIND
          INDEX=1
          DO WHILE(INDEX.LE.NKPTS0)
            IF((ABS(RK0(1,INDEX)-RK(1,IK)).LT.EPS).AND.
     &           (ABS(RK0(2,INDEX)-RK(2,IK)).LT.EPS).AND.
     &           (ABS(RK0(3,INDEX)-RK(3,IK)).LT.EPS)) THEN
              IKPOINT=IKPOINT+1
              IF((INDEX.NE.IK)) THEN
                IF( (IREC(IREC_WF).NE.0).OR.(IREC(IREC_WF).NE.0) ) THEN
                  IPERM=IPERM+1
                  ITABLE(INDEX)=IKIND
                  ITABKPT(INDEX)=IKPT
                ENDIF
              ENDIF
              INDEX=NKPTS0+1
            ELSE
              INDEX=INDEX+1
            ENDIF
          ENDDO
        ENDDO
      ENDDO
C     Permutation if necessary
      IF( (IPERM.NE.0).AND.(IREC(IREC_WF).NE.0) ) THEN
C       We need to reread the file
        IF(PARENT) THEN
          REWIND(NR)
          READ(NR) STR
          DO IR=2,8
            READ(NR) IRECORD
            CALL FSKIP(NR,IRECORD)
          ENDDO
          READ(NR) IRECORD
          READ(NR) N0,NGWKS0,ICOMPR,SCALE
        ENDIF
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(N0,MSGLEN,SOURCE,ALLGRP)
        RCOMPB=ICOMPR
        IF(RCOMPB.EQ.-1) THEN
          CALL AOTOPW(NR,C0,NSTATE,TAU0)
        ELSE
          IF(PARENT) THEN
#ifdef PARALLEL
            LEN=2*NGWK
            CALL MEMORY(IP_CR,4*LEN,'CR')
            LEN1=2*NGW/IRAT + 1
            CALL MEMORY(IP_MAPW,LEN1,'MAPW')
#else       
            LEN=NGWK
#endif
            NGWA=MAX(NGWKS0,NGWKS)
            CALL MEMORY(IP_CA,2*NGWA+100,'CA')
            CALL MEMORY(IP_ICMP,2*NGWA+100,'ICMP')
            CALL AZZERO(CA,2*NGWA+100)
            CALL IAZZERO(ICMP,2*NGWA+100)
          ENDIF
          NSTATE0=N0/NKPTS0
          NREAD=0
          IKPOINT=0
          DO INDEX=1,NKPTS0
            IKIND=ITABLE(INDEX)
            IF(IKIND.NE.0) THEN
              IKPOINT=IKPOINT+1
              IF(TKBLOCK) THEN
                IKPT=ITABKPT(INDEX)
                CALL RKPT_SWAP(C0,NSTATE,IKPT,'C0')
              ENDIF
              DO ISTATE=1,NSTATE0
                NREAD=NREAD+1
                IF(NREAD.LE.N0) THEN
                  CALL RDWFN(NR,C0(1,ISTATE,IKIND),CA,CR,ICMP,MAPW,
     &               NGWKS0,ICOMPR,SCALE,TKPNT0)
                ELSE
                  GOTO 30
                ENDIF
              ENDDO
              IF(TKBLOCK) CALL WKPT_SWAP(C0,NSTATE,IKPT,'C0')
            ELSE
              NN=MIN(N0-NREAD,NSTATE0)
              IF(NN.LE.0) GOTO 30
              IF(PARENT) CALL FSKIP(NR,2*NN)
              NREAD=NREAD+NSTATE
            ENDIF
          ENDDO
          CALL FREEM(IP_CA)
          CALL FREEM(IP_ICMP)
#ifdef PARALLEL
          CALL FREEM(IP_CR)
          CALL FREEM(IP_MAPW)
#endif
        ENDIF
      ENDIF
 30   CONTINUE
      IF(IKPOINT.NE.NKPTS) THEN
        IF(NKPTS-IKPOINT.EQ.1) THEN
          WRITE(6,'(A,I3,A)')
     &     ' RV30! ',NKPTS-IKPOINT,' KPOINT IS DIFFERENT'
        ELSE
          WRITE(6,'(A,I3,A)')
     &     ' RV30! ',NKPTS-IKPOINT,' KPOINTS ARE DIFFERENT'
        ENDIF
      ENDIF
      CALL FREEM(IP_RK0)
      CALL FREEM(IP_ITABKPT)
      CALL FREEM(IP_ITABLE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RDKPOINTS
C     ==--------------------------------------------------------------==
C     == READ NKPTS, RK AND WK IN VERSION 3.0                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'filn.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'store.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'mw.inc'
C          Variables
      DIMENSION RK(3,*),WK(*)
      CHARACTER FILNAM*100,STR*80,LATFILE*20
      INTEGER   NR,IRECORD,N0,NKPTS0,NGWKS0,NGWLS0,NHGS0,NHGLS0,
     &          IA,IE,IR,J,IK
      LOGICAL   FEXIST
C     ==--------------------------------------------------------------==
      NR=1
      CALL XSTRING(FILN,IA,IE)
      IF(TPATH) THEN
        FILNAM=FPATH(IAPATH:IEPATH)//FILN(IA:IE)
      ELSE
        IF(RLATE) THEN
          IF(TMW)THEN
            CALL MW_FILENAME('LATEST_',LATFILE,WALKER_ID)
          ELSE
            LATFILE='LATEST'
          ENDIF 
          INQUIRE(FILE=LATFILE,EXIST=FEXIST)
          IF(FEXIST) THEN
            OPEN(UNIT=NR,FILE=LATFILE,STATUS='UNKNOWN')
            READ(NR,'(A)') FILNAM
            CLOSE(NR)
          ELSE
            FILNAM=FPATH(IAPATH:IEPATH)//FILN(IA:IE)
          ENDIF
        ELSE
          FILNAM=FPATH(IAPATH:IEPATH)//FILN(IA:IE)
        ENDIF
      ENDIF
      INQUIRE(FILE=FILNAM,EXIST=FEXIST)
      IF(.NOT.FEXIST) THEN
        WRITE(6,*) ' RDKPOINTS| RESTART FILE NOT FOUND:',FILNAM
        CALL STOPGM('RDKPOINTS',' FILE NOT FOUND ')
      ENDIF
C     ==--------------------------------------------------------------==
      OPEN(UNIT=NR,FILE=FILNAM,FORM='UNFORMATTED',STATUS='OLD')
      REWIND (NR)
      READ(NR) STR
      IF(INDEX(STR,'STUTTGART VERSION 3.0').EQ.0) THEN
        CALL STOPGM('RDKPOINTS',
     &       'NOT RESTART WITH KPOINTS WITH THIS FORMAT')
      ENDIF
      DO IR=2,7
        READ(NR) IRECORD
        CALL FSKIP(NR,IRECORD)
      ENDDO
      READ(NR) IRECORD
      IF(IRECORD.EQ.1) THEN
        READ (NR) N0,NKPTS0,NGWKS0,NGWLS0,NHGS0,NHGLS0
        IF(NKPTS0.EQ.0) THEN
          NKPTS=1
          TKPNT=.FALSE.
        ELSE
          NKPTS=NKPTS0
          TKPNT=.TRUE.
        ENDIF
        DO IR=9,20
          READ(NR) IRECORD
C         New format to read PW coefficients.
          IF(IRECORD.LT.0) THEN
            IRECORD = -IRECORD
          ENDIF
          CALL FSKIP(NR,IRECORD)
        ENDDO
        CALL MEMORY(IP_RK,3*NKPTS,'RK')
        CALL MEMORY(IP_WK,NKPTS,'WK')
        READ (NR) IRECORD
        IF(IRECORD.EQ.0.AND.NKPTS.EQ.1.OR.NKPTS0.EQ.0) THEN
          TKPNT=.FALSE.
          DO J=1,3
            RK(J,1)=0.D0
          ENDDO
          WK(1)=1.D0
        ELSEIF(IRECORD.EQ.NKPTS) THEN
          DO IK=1,NKPTS
            READ(NR) (RK(J,IK),J=1,3),WK(IK)
          ENDDO
        ELSE
          WRITE(6,'(A)')
     &         ' RDKPOINTS| WARNING! CANNOT READ KPOINTS SECTION'
          CALL STOPGM('RDKPOINTS','NOT RESTART WITH KPOINTS')
        ENDIF
      ELSE
       WRITE(6,'(A)')
     &       ' RDKPOINTS| WARNING! CANNOT READ NUMBER OF KPOINTS'
       CALL STOPGM('RDKPOINTS','NOT RESTART WITH KPOINTS')
      ENDIF
      CLOSE(NR)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
