C     ==================================================================
      SUBROUTINE W_LINRES(NW,IERROR,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER      NW,IERROR
      CHARACTER*2  TAG
C     Variables
      DIMENSION    CLRWF(NGW,NOLR,NLINW,*),CLRV(NGW,NOLR,NLINW,*)
      DIMENSION    UROT(NUA,NUB,*)
      INTEGER      IRECORD,LEN,LEN1,ICOMPR,ISCA,J,I,K,IDAMAX,IREC0,MTDA
      REAL*8       CA(*),CR(*),SCALE,DGIVE
      EXTERNAL     DGIVE
      POINTER      (IP_CA,CA),(IP_CR,CR)
      INTEGER      MAPW(*),ICMP(*)
      INTEGER      MUREC
      LOGICAL      OSTDA
      POINTER      (IP_ICMP,ICMP),(IP_MAPW,MAPW)
C     ==--------------------------------------------------------------==
      IF(TDA) THEN
        MTDA=1
      ELSE
        MTDA=2
      ENDIF
      IF ( LRACTIVE ) THEN
        IF(PARENT) THEN
#ifdef PARALLEL
          LEN=2*NGW
          LEN1=2*NGW/IRAT + 1
          CALL MEMORY(IP_CR,4*LEN,'CR')
          CALL MEMORY(IP_MAPW,LEN1,'MAPW')
#else
C         Unused. Set to 0 to avoid a compiler warning.
          IP_CR=0
          IP_MAPW=0
          LEN=NGWK
#endif
          CALL MEMORY(IP_CA,2*NGWS,'CA')
          CALL MEMORY(IP_ICMP,2*NGWS+100,'ICMP')
        ENDIF
        IF (TAG.EQ."WF") THEN
           ISCA=IDAMAX(2*NLINW*NOLR*NGW*MTDA,CLRWF,1)
           SCALE=ABS(DGIVE(CLRWF,ISCA))
        ELSEIF (TAG.EQ."WV") THEN
           ISCA=IDAMAX(2*NLINW*NOLR*NGW*MTDA,CLRV,1)
           SCALE=ABS(DGIVE(CLRV,ISCA))
        ENDIF
#ifdef PARALLEL
        CALL GLOMAX(1,SCALE)
#endif
        ICOMPR=WCOMPB
        IF(ICOMPR.LT.1) THEN
          ICOMPR=1
        ENDIF
        IF(TDA.AND.MSUBTA.GT.0.AND..NOT.TDACANON) THEN
          OSTDA=.TRUE.
          MUREC=NLINW
        ELSE
          OSTDA=.FALSE.
          MUREC=0
        ENDIF
        IRECORD = 2 + 2*NLINW*NOLR + MUREC
        IF(PARENT) THEN
          WRITE(UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE(UNIT=NW,IOSTAT=IERROR) NGWS,NOLR,NLINW,MTDA,ICOMPR,SCALE
          WRITE(UNIT=NW,IOSTAT=IERROR) OSTDA,NUA,NUB
        ENDIF
        DO J=1,MTDA
          DO K=1,NLINW
            DO I=1,NOLR
              IF (TAG.EQ."WF") THEN
                CALL WRWFN(NW,IERROR,CLRWF(1,I,K,J),CA,CR,ICMP,MAPW,
     *                     ICOMPR,SCALE)
              ELSEIF (TAG.EQ."WV") THEN
                CALL WRWFN(NW,IERROR,CLRV(1,I,K,J),CA,CR,ICMP,MAPW,
     *                     ICOMPR,SCALE)
              ENDIF
            ENDDO
          ENDDO
        ENDDO
        IF(OSTDA.AND.PARENT) THEN
          DO K=1,NLINW
            WRITE(UNIT=NW,IOSTAT=IERROR) ((UROT(I,J,K),I=1,NUA),J=1,NUB)
          ENDDO
        ENDIF
        IF(PARENT) THEN
          CALL FREEM(IP_CA)
          CALL FREEM(IP_ICMP)
#ifdef PARALLEL
          CALL FREEM(IP_CR)
          CALL FREEM(IP_MAPW)
#endif
        ENDIF
      ELSE
        IREC0=0
        IF(PARENT) THEN
          WRITE(NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE R_LINRES(NR,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER      NR
      CHARACTER*2  TAG
C     Variables
      REAL*8    CA(*),CR(*)
      INTEGER   MAPW(*),ICMP(*)
      POINTER   (IP_CA,CA),(IP_CR,CR),(IP_ICMP,ICMP),(IP_MAPW,MAPW)
      DIMENSION CLRWF(NGW,NOLR,NLINW,*),CLRV(NGW,NOLR,NLINW,*)
      DIMENSION UROT(NUA,NUB,*)
      INTEGER   IREC0,IRECORD,NGWX,NOLRX,ICOMPR,MTDA,MTDA0
      INTEGER   LEN,LEN1,LCA,LICMP,I,J,K,NX,NREAD,NUAX,NUBX
      LOGICAL   OSTDAX,OSTDA
      REAL*8    SCALE
#ifdef PARALLEL
      INTEGER   MSGLEN
#endif
C     ==--------------------------------------------------------------==
      IF(TDA) THEN
        MTDA=1
      ELSE
        MTDA=2
      ENDIF
      IF ( LRACTIVE ) THEN
        IF(TDA.AND.MSUBTA.NE.0.AND..NOT.TDACANON) THEN
          OSTDA=.TRUE.
        ELSE
          OSTDA=.FALSE.
        ENDIF
        IF(PARENT) THEN
          READ(NR) IRECORD
          READ(NR) NGWX,NOLRX,NLINR,MTDA0,ICOMPR,SCALE
          IF(MTDA.NE.MTDA0) 
     *         CALL STOPGM("R_LINRES","TDDFT APPROXIMATION DIFFERS")
          IF(NGWX.NE.NGWS) 
     *         CALL STOPGM("R_LINRES","NUMBER OF PW DIFFERS")
          IF(NOLRX.NE.NOLR) 
     *         CALL STOPGM("R_LINRES","NUMBER OF STATES DIFFERS")
          READ(NR) OSTDAX,NUAX,NUBX
        ENDIF
#ifdef PARALLEL
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(NGWX,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(NOLRX,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(NLINR,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(ICOMPR,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8
        CALL MY_BCAST(SCALE,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(OSTDAX,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(NUAX,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(NUBX,MSGLEN,SOURCE,ALLGRP)
#endif
        IF(PARENT) THEN
#ifdef PARALLEL
          LEN=2*NGWK
          CALL MEMORY(IP_CR,4*LEN,'CR')
          LEN1=2*NGW/IRAT + 1
          CALL MEMORY(IP_MAPW,LEN1,'MAPW')
#else
C         Unused. Set to 0 to avoid a compiler warning.
          IP_CR=0
          IP_MAPW=0
          LEN=NGWK
#endif
          LCA=2*NGWS+100
          CALL MEMORY(IP_CA,LCA,'CA')
          CALL AZZERO(CA,LCA)
C         Warning: ICMP is allocated as INTEGER*8
          LICMP=2*NGWS+100
          CALL MEMORY(IP_ICMP,LICMP,'ICMP')
C         ICMP is integer*8 (length LICMP).
          CALL IAZZERO(ICMP,IRAT*LICMP)
        ENDIF
        NREAD=MIN(NLINW,NLINR)
        DO J=1,MTDA
          DO K=1,NREAD
            DO I=1,NOLR
              IF (TAG.EQ."WF") THEN
                CALL RDWFN(NR,CLRWF(1,I,K,J),CA,CR,ICMP,MAPW,
     &                     NGWS,ICOMPR,SCALE,1)
              ELSEIF (TAG.EQ."WV") THEN
                CALL RDWFN(NR,CLRV(1,I,K,J),CA,CR,ICMP,MAPW,NGWS,ICOMPR,
     &             SCALE,1)
              ENDIF
            ENDDO
          ENDDO
        ENDDO
        NX=NLINR-NREAD
        IF(PARENT) THEN
          DO J=1,MTDA
            DO I=1,NX
              DO K=1,NOLR
                READ(NR)
                READ(NR)
              ENDDO
            ENDDO
          ENDDO
          CALL FREEM(IP_CA)
          CALL FREEM(IP_ICMP)
#ifdef PARALLEL
          CALL FREEM(IP_CR)
          CALL FREEM(IP_MAPW)
#endif
        ENDIF
        IF(OSTDA.AND..NOT.OSTDAX) THEN
          CALL AZZERO(UROT,NUA*NUB*NLINW)
        ELSEIF(.NOT.OSTDA.AND.OSTDAX) THEN
          IF(PARENT) THEN
            DO I=1,NLINR
              READ(NR)
            ENDDO
          ENDIF
        ELSEIF(OSTDA.AND.OSTDAX) THEN
          IF(PARENT) THEN
            IF(NUAX.NE.NUA) 
     *         CALL STOPGM("R_LINRES","NUMBER OF OCC ORBITALS DIFFER")
            IF(NUBX.NE.NUB) 
     *         CALL STOPGM("R_LINRES","NUMBER OF ACT ORBITALS DIFFER")
            CALL AZZERO(UROT,NUA*NUB*NLINW)
            NREAD=MIN(NLINW,NLINR)
            DO K=1,NREAD
              READ(NR) ((UROT(I,J,K),I=1,NUA),J=1,NUB)
            ENDDO
          ENDIF
#ifdef PARALLEL
          MSGLEN = NUA*NUB*NLINW * 8
          CALL MY_BCAST(UROT,MSGLEN,SOURCE,ALLGRP)
#endif
        ENDIF
      ELSE
        IF(PARENT) THEN
          READ (NR) IREC0
          CALL FSKIP(NR,IREC0)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
