C     ==================================================================
      subroutine rwfopt_p(c0,c1,psi,rhoe,drhoe,scr,lscr,
     &              eirop,eivps,v1_loc,v1_nonloc,
     &              z11,nstate,eirop1)
c     ==--------------------------------------------------------------==
C     COMPUTES the perturbed wavefunctions C1 which are 
C     the electronic linear response to the perturbation hamiltonian
C     stored in v1_loc and v1_nonloc.
C     RETURNS also the first order density (also spin-split) in drhoe, 
C     which is stored in real space.
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'spin.inc'
      include 'ener.inc' 
      include 'elct.inc' 
      include 'tpar.inc' 
      include 'pslo.inc' 
      include 'norm.inc' 
      include 'ropt.inc' 
      include 'cppt.inc' 
      include 'sfac.inc' 
      include 'coor.inc' 
      include 'nlcc.inc' 
      include 'ions.inc' 
      include 'andr.inc' 
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc' 
      include 'cnst.inc' 
      include 'poin.inc' 
      include 'kpts.inc'
      include 'kpnt.inc'
      include 'fft.inc'
      include 'str2.inc'
      include 'store.inc'
      include 'response_p.inc'
      include 'soft.inc'
      integer    irec(100),length,
     &           i,ig,nstate,
     &           lscr,il_c12,msglen
      logical    tstress,firstcall,reset_cg
      complex*16 c0(ngwk,*)
      complex*16 c1(ngwk,*),c12(ngwk,*),v1_nonloc(ngwk,*)
      complex*16 eirop1(nhg),v1_loc(nhg),psi(nnr1,nlsd)
      complex*16 eirop(nhg),eivps(nhg)
      complex*16 vtmp(nhg)
C     DIIS vectors
      complex*16 pme(ngwk,*),gde(ngwk,*)

      dimension  F(n,nkpts),RK(3,nkpts),WK(nkpts)

      real*8     z11(n,n)
      real*8     rhoe(*),drhoe(*),scr(lscr)
      real*8     vpp(*)
      real*8     FNL(*),DFNL(*)
      REAL*8     thl(2),
     &           time1,time2,temp1,temp2,tcpu,
     &           ekin1,ekin2,ekincp,etot0,ekinh1,ekinh2

      real*8     DOTP,timef
      external   DOTP,timef
      real*8     detot,dummy,max_norm_input,norm_input
      pointer     (ip_gde,gde),(ip_pme,pme)
      pointer     (ip_vtmp,vtmp)
      pointer     (ip_c12,c12),(ip_vpp,vpp)
      character  tag*30
      DIMENSION S_STAR(NSTATE,NSTATE)
      integer    reset_counter,reset_supercounter
      save       reset_counter,reset_supercounter
      real*8     cg_factor_original
      integer    cg_analytic_original

 70   FORMAT ("*  scaling ",A6," with ",F10.3,30(" ")," *")
 60   FORMAT ("*  input has zero norm (",E10.2,
     &    "< 1D-8). Returning zero response.")

c     ==--------------------------------------------------------------==
c     == initialization                                               ==
c     ==--------------------------------------------------------------==
      time1 = timef()
      nacc = 7
      cg_factor_original=cg_factor
      cg_analytic_original=cg_analytic
      reset_counter=0
      reset_supercounter=0

      trho1 = .true.
      if ((tnmr .or. tepr) .or. tkpert) trho1 = .false.
C     Is there a non-zero first order response density?
C     For purely imaginary perturbations: No.

      tnonlocal = .true.
      if (THARDNESS .or. TEIGENSYSTEM.or.TFUKUI) tnonlocal = .false.
C     Is there a nonlocal contribution (i.e. a non-local perturbation
C     potential)?
 
      etot = 0d0
      etot0 = 0.d0
      ecnstr=0.0d0
      erestr=0.0d0
      call dynit(ekincp,ekin1,ekin2,temp1,temp2,ekinh1,ekinh2)
      convwf=.false.
      engpri=.false.
      calste=.false.
      reset_cg=.true.
      firstcall=.not.T_INITIALGUESS_C1
      ebogo=0.d0
c     ==--------------------------------------------------------------==

C     ==-- ORTHOGONALIZATION of the constant part.   -----------------==
C   DMB
      if (tnonlocal) then
            IF (TSIMPLE_MODEL) THEN
               call simple_ortho_p(nstate,c0,v1_nonloc,S_star)
            ELSE
               call ortho_p(nstate,c0,v1_nonloc)
            ENDIF
      endif
C   DMB

c     ==--  SCALING of the input:  -----------------------------------==
C     dmb: removed scaling if we perform BO dynamics
!!    if (TDUMMYATOM.or.(TNMR .OR. TEPR).or. 
      if (TDUMMYATOM.or.TEPR.or. 
     &        (TINTERACTION .AND..not.TMDBO)) THEN
         max_norm_input = 0d0
         do i=1,nstate
            norm_input = DOTP(ngw,v1_nonloc(1,i),v1_nonloc(1,i))
#ifdef PARALLEL
            call glosum(1,norm_input)
#endif
            max_norm_input = max(max_norm_input,norm_input)
         enddo
         IF ((.not.TDUMMYATOM).and.(abs(max_norm_input) .LT. 1d-8)) THEN
            if (parent) write (6,60) max_norm_input
            call azzero(c1,2*ngw*nstate)
C DMB       set noresponse flag for SCF-PT calculation
            TNORESPONSE=.TRUE.

            return
         ENDIF
         max_norm_input =  1d0 / sqrt(max_norm_input)
         call DSCAL(2*ngw*nstate, max_norm_input, v1_nonloc, 1)
         if (T_INITIALGUESS_C1)     
     &        call DSCAL(2*ngw*nstate, max_norm_input, c1, 1)
         if (parent) write (6,70) 'input',max_norm_input
      endif                     ! END scaling NMR

      if (THARDNESS .or. TEIGENSYSTEM) THEN
         norm_input = DOTP(nhg,v1_loc,v1_loc)
#ifdef PARALLEL
         call glosum(1,norm_input)
#endif
         norm_input =  1d0 / sqrt(norm_input)
         call DSCAL(2*nhg, norm_input, v1_loc, 1)
         if (T_INITIALGUESS_C1) 
     &        call DSCAL(2*ngw*nstate, norm_input, c1,1)
         if (parent) write (6,70)'input',norm_input
      endif
c     ==--  end of SCALING.  -----------------------------------------==

c     ==--------------------------------------------------------------==
c     == initialization                                               ==
c     ==--------------------------------------------------------------==
      il_c12 = 2*ngwk*nstate+8
      call memory(ip_c12,il_c12,'C12')
      call azzero(c12,il_c12)

      call memory(ip_vpp,ngwk,'vpp')
      call azzero(vpp,ngwk)
      call hesele_p(dt2bye,z11,nstate,vpp)

      if (diis_p) then
         mdiis = mdiis_p
         call memory(ip_pme,(ngwk*nstate+8)*mdiis,'pme')
         call memory(ip_gde,((ngwk*nstate+8)*mdiis)/4,'gde')
         call azzero(pme,(ngwk*nstate+8)*mdiis)
         call azzero(gde,((ngwk*nstate+8)*mdiis)/4)
      endif

c     ==--  REAL SPACE ground state wavefunctions  ---------------==
      if (tkeeprealspacewfn) then
        call allocate_c0real_p(c0,psi,nstate) ! inside vpsi_p.F
      endif

      IF (.NOT. T_INITIALGUESS_C1) CALL AZZERO(c1,2*ngw*nstate)

      IF(PARENT) THEN
        time2 = timef()
        tcpu=(time2-time1)*1.d-3
        WRITE(6,'(a,f8.2,a8)') ' TIME FOR INITIALIZATION:',
     .       tcpu,' SECONDS'
      ENDIF
c     ==--------------------------------------------------------------==
c     == end initialization                                           ==
c     ==--------------------------------------------------------------==

c     ==--------------------------------------------------------------==
c     ==      the basic loop for wavefunction optimization            ==
c     ==--------------------------------------------------------------==
      nfi=0
      sdiis  = .true.
      convwf = .false.
      etot   = 0d0
      etot0  = 0d0
      do while ((.not. convwf) .and. (nfi .le. nomore))
         time1=timef()
         call updwf_p(c0,c1,c12,v1_nonloc,z11,
     &        v1_loc,eirop1,tau0,fion,pme,gde,vpp,
     &        rhoe,drhoe,psi,scr,lscr,nstate,firstcall,reset_cg)
         time2=timef()
         tcpu=(time2-time1) * 1.d-3
         detot = etot - etot0
         if (nfi.ge.1) then
            call wrprint_wfopt(dummy,f,amu,n,etot,etot0,tcpu,
     &           gemax,cnorm,thl,convwf,nfi,nfi)
         endif
         etot0 = etot

c     ERASE the conjugate-direction-memory if the cg-step
c     goes too much (more than 0.01 a.u.) in the WRONG DIRECTION:
         if (detot .gt.  1.d-2 .AND. nfi.gt.1 .AND. PCG_P) then
            if (parent) write (6,'(65("~"))')
            reset_cg=.true.
            reset_counter = reset_counter+1
C     a problem:
            if (reset_counter .gt. 2)
     &           call DSCAL(2*ngw*nstate,0.3d0,c1,1)
C     a big problem:
            if (reset_counter .gt. 4) then
               if (cg_factor .gt. 1.d0) cg_factor = 1.d0
               cg_factor = 0.8d0*cg_factor
               if (cg_analytic .lt. 3) cg_analytic = 3
               reset_counter = 0
               reset_supercounter = reset_supercounter + 1
               if (reset_supercounter .gt. 5) then
                  if (parent) write (6,*) 
     &                 '*** TOO MANY RESETS. EXITING.'
                  exsoft = .true.
               endif
            endif
         endif

         if(.not.exsoft) call testex(exsoft)
         if(convwf .or. exsoft) goto 100

         nfi=nfi+1
      enddo
c     ==--------------------------------------------------------------==
c     ==     end of main loop                                         ==
c     ==--------------------------------------------------------------==

      if(parent.and.gemax.gt.tolog_p) then
        write(6,'(1x,64("!"))')
        write(6,'(" !!",a,t64,"!!")')
     &       ' RWF1OPT| THE MAXIMUM NUMBER OF STEP IS REACHED'
        write(6,'(" !!",a,f10.6,a,t64,"!!")')
     &       '         BUT NO CONVERGENCE (d E / d phi_1 =',gemax,')'
        write(6,'(1x,64("!"))')
      endif
  100 continue

      if (parent) call wrener

C     dmb scaling removed for BO dynamics
!!    if (TDUMMYATOM.or.(TNMR.OR.TEPR).or.
      if (TDUMMYATOM.or.TEPR.or.
     &      (TINTERACTION.AND..not.TMDBO)) THEN
         call DSCAL(2*ngw*nstate, 1d0/max_norm_input, c1,1)
c     if (parent) write (6,70) 'output',1d0/max_norm_input
C     DMB: printing the correction energy
         IF (parent) THEN
            write (6,70) 'output',1d0/max_norm_input
            ETOT=ETOT*(1.D0/max_norm_input)**2
            if (TINTERACTION) 
     &           write(6,*) 'TOTAL ENERGY CORRECTION =',ETOT
         ENDIF
      ENDIF
      IF (THARDNESS .or. TEIGENSYSTEM) THEN
         norm_input = 1d0/norm_input
         call DSCAL(2*ngw*nstate, norm_input, c1,1)
         call DSCAL(2*ngw*nstate, norm_input, v1_loc,1)
         if (parent) write (6,70) 'output',norm_input
      ENDIF

c     ==--  RELEASE MEMORY...   ----------------------------------==
      IF(diis_p) THEN           ! last allocated = first de-allocated
        CALL freem(ip_gde)
        CALL freem(ip_pme)
      ENDIF
      CALL freem(ip_vpp)
      CALL freem(ip_c12)
      IF(tkeeprealspacewfn) THEN
        CALL release_c0real_p   ! routine is located inside vpsi_p.F
      ENDIF
c     ==--------------------------------------------------------------==
      cg_factor=cg_factor_original
      cg_analytic=cg_analytic_original
      return
      end
c     ==--------------------------------------------------------------==
