C     ==================================================================
      SUBROUTINE SAMPLE_WAIT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'filn.inc'
      INCLUDE 'store.inc'
      INCLUDE 'fileopen.inc'
C     Local variables
      INTEGER IUNIT
      PARAMETER (IUNIT=99)
      LOGICAL TEST
      INTEGER ISUB,MSGLEN,IA,IE,I1,I2,I,NW,ICALLS
      CHARACTER FILEN*80,FILENAME*80,FBODY*80
      CHARACTER  FILNUM(10)*1
      DATA       FILNUM /'1','2','3','4','5','6','7','8','9','0'/
C     ==--------------------------------------------------------------==
C     ==    STRUCTURE OF THE PSAMPLE FILE                             ==
C     ==                                                              ==
C     ==    NOMORE    number of CP steps                              ==
C     ==    DELT_ELEC CP time step (+ or -)                           ==
C     ==    FILENAME  full name of the restart file                   ==
C     ==    FBODY     name for new restart files (FBODY.1 FBODY.2     ==
C     ==              will be the names of the new restart files)     ==
C     ==    NRESTF    number of new restart files                     ==
C     ==    S1 S2 ... time steps at which the new restart files are   ==
C     ==              written                                         ==
C     ==                                                              ==
C     ==--------------------------------------------------------------==
      CALL TISET('SAMPLEWAIT',ISUB)
      IF(PARENT) THEN
        FILEN=FPATH(IAPATH:IEPATH)//'PSAMPLE'
        WRITE(6,*) 'SAMPLE_WAIT| WAIT FOR CONTINUE-FILE ', FILEN
    1   CONTINUE
        INQUIRE(FILE=FILEN,EXIST=TEST)
        IF(TEST) THEN
          OPEN(IUNIT,FILE=FILEN)
          REWIND(IUNIT)
          READ(IUNIT,*) NOMORE
          READ(IUNIT,*) DELT_ELEC
          READ(IUNIT,*) FILENAME
          READ(IUNIT,*) FBODY
          READ(IUNIT,*) NRESTF
          IF(NRESTF.GT.MAXRF) 
     *       CALL STOPGM('SAMPLE_WAIT','TOO MANY RESTART FILES')
          READ(IUNIT,*) (NSTEPWR(I),I=1,NRESTF)
          CLOSE(IUNIT)
          WRITE(6,'(A)') ' SAMPLE_WAIT| CONTINUE CALCULATION'
          WRITE(6,'(A,T56,I10)') 
     *          ' SAMPLE_WAIT| NUMBER OF TIME STEPS ',NOMORE
          WRITE(6,'(A,T56,F10.1)') 
     *          ' SAMPLE_WAIT| NEW TIME STEP IS ',DELT_ELEC
          CALL XSTRING(FILENAME,IA,IE)
          WRITE(6,'(A,T50,A)') 
     *          ' SAMPLE_WAIT| RESTART FILE NAME',FILENAME(IA:IE)
          CALL XSTRING(FBODY,I1,I2)
          WRITE(6,'(A,T56,I10)') 
     *          ' SAMPLE_WAIT| NUMBER OF NEW RESTART FILES',NRESTF
          DO I=1,NRESTF
            WRITE(6,'(A,T20,A,A,T56,I10)') 
     *          ' SAMPLE_WAIT| FILE ',FBODY(I1:I2)//FILNUM(I),
     *          ' WRITTEN AT STEP',NSTEPWR(I)
          ENDDO
C..prepare restart files
          RLATE=.TRUE.
          NW=2
          OPEN(UNIT=NW,FILE='LATEST',STATUS='UNKNOWN')
          REWIND(NW)
          WRITE(NW,'(A)') FILENAME(IA:IE)
          ICALLS=0
          WRITE(NW,*) ICALLS
          CLOSE(NW)
          FILBOD=FBODY(I1:I2)
          GOTO 3
        ENDIF
        INQUIRE(FILE='EXIT',EXIST=TEST)
        IF(TEST) NOMORE=-1
        IF(TEST) GOTO 3
        CALL MY_SLEEP(1)
        GOTO 1
    3   CONTINUE
      ENDIF
      CALL MY_SYNC(ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NOMORE,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(DELT_ELEC,MSGLEN,SOURCE,ALLGRP)
      DELT_IONS=DELT_ELEC
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NRESTF,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = NRESTF * 8/IRAT
      CALL MY_BCAST(NSTEPWR,MSGLEN,SOURCE,ALLGRP)
      CALL TIHALT('SAMPLEWAIT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SAMPLE_GO
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fileopen.inc'
      LOGICAL TEST
      INTEGER IE,IA
      CHARACTER FILEN*80,LINE*80
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        FILEN=FPATH(IAPATH:IEPATH)//'PSAMPLE'
        INQUIRE(FILE=FILEN,EXIST=TEST)
        IF(TEST) THEN
          CALL XSTRING(FILEN,IA,IE)
          WRITE(LINE,'(A,A)') 'rm -f ',FILEN(IA:IE)
#if defined(MYRINET) || defined(CRAY_XT3) || defined(__WINNT)
          CALL RMFILE(FILEN(IA:IE))
#else
          CALL SYSTEM(LINE)
#endif
        ENDIF
        WRITE(6,*) ' SAMPLE_GO| PASS CONTROL BACK TO SAMPLING PROGRAM'
      ENDIF
      CALL MY_SYNC(ALLGRP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================


