C     ==================================================================
      SUBROUTINE SAOP(C0,EIGV,EREF,FOCC,NSTATE,RHOE,GRHO,EXC,
     *                VSAOP,VGLLB,VLB94,RHO1,PSI)
C     ==--------------------------------------------------------------==
C     == CALCULATE SAOP POTENTIAL                                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'fft.inc'
C     Arguments
      COMPLEX*16 C0(NGW,*)
      INTEGER    NSTATE
      REAL*8     RHOE(NNR1,NLSD),EIGV(*),EREF(*),FOCC(*)
      REAL*8     GRHO(NNR1,*),RHO1(*),EXC
      REAL*8     VSAOP(NNR1,*),VGLLB(NNR1,*),VLB94(NNR1,*)
      COMPLEX*16 PSI(*)
C     Parameters
      REAL*8     KRESP
      PARAMETER  (KRESP=0.42D0)
C     Variables
      REAL*8     ENA,ENB,EN,WENI,EX,EC,WENI1,WENI2,EEX
      INTEGER    IS,IK,IR
C     ==--------------------------------------------------------------==
      IF(TLSD) THEN
        EN=0.D0
        DO IS=1,NSUP
          IF(FOCC(IS).GT.1.D-4) ENA=EIGV(IS)
        ENDDO
        DO IS=NSUP+1,NSTATE
          IF(FOCC(IS).GT.1.D-4) ENB=EIGV(IS)
        ENDDO
      ELSE
        ENA=0.D0
        ENB=0.D0
        DO IS=1,NSTATE
          IF(FOCC(IS).GT.1.D-4) EN=EIGV(IS)
        ENDDO
      ENDIF
C
C     Vresponse
      IF(NOGRP.GT.1) CALL STOPGM("SAOP","NO GROUPS ALLOWED")
      CALL AZZERO(VGLLB,NNR1*NLSD)
      DO IS=1,NSTATE
        CALL RHOSOFR(C0(1,IS),RHO1,PSI)
        IF(FOCC(IS).GT.1.D-4) THEN
          IF(TLSD) THEN
            IF(IS.LE.NSUP) THEN
              ENA=EREF(IS)
              WENI=SQRT(ENA-EIGV(IS))*KRESP*FOCC(IS)
              IK=1
            ELSE
              ENB=EREF(IS)
              WENI=SQRT(ENB-EIGV(IS))*KRESP*FOCC(IS)
              IK=2
            ENDIF
          ELSE
            EN=EREF(IS)
            WENI=SQRT(EN-EIGV(IS))*KRESP*FOCC(IS)
            IK=1
          ENDIF
          DO IR=1,NNR1
            IF(RHOE(IR,IK).GT.1.D-12) THEN
              VGLLB(IR,IK) = VGLLB(IR,IK) + WENI * RHO1(IR)/RHOE(IR,IK)
            ENDIF
          ENDDO
        ENDIF
      ENDDO
C     PBE exchange energy density
      IF(TLSD) THEN
        DO IR=1,NNR1
          CALL PBE_XED(2.D0*RHOE(IR,1),4.D0*GRHO(IR,1),EX)
          VGLLB(IR,1) = VGLLB(IR,1) + 2.D0*EX
        ENDDO
        DO IR=1,NNR1
          CALL PBE_XED(2.D0*RHOE(IR,2),4.D0*GRHO(IR,3),EX)
          VGLLB(IR,2) = VGLLB(IR,2) + 2.D0*EX
        ENDDO
      ELSE
        DO IR=1,NNR1
          CALL PBE_XED(RHOE(IR,1),GRHO(IR,1),EX)
          VGLLB(IR,1) = VGLLB(IR,1) + 2.D0*EX
        ENDDO
      ENDIF
C     PBE correlation energy density
      IF(TLSD) THEN
        DO IR=1,NNR1
          CALL PBE_CEDS(RHOE(IR,1),RHOE(IR,2),GRHO(IR,1),
     *                  GRHO(IR,2),GRHO(IR,3),EC)
          VGLLB(IR,1) = VGLLB(IR,1) + 2.D0*EC
          VGLLB(IR,2) = VGLLB(IR,2) + 2.D0*EC
        ENDDO
      ELSE
        DO IR=1,NNR1
          CALL PBE_CED(RHOE(IR,1),GRHO(IR,1),EC)
          VGLLB(IR,1) = VGLLB(IR,1) + 2.D0*EC
        ENDDO
      ENDIF
C
C     VLB94
      CALL AZZERO(VLB94,NNR1*NLSD)
      IF(TLSD) THEN
        DO IR=1,NNR1
          CALL LB94S(RHOE(IR,1),RHOE(IR,2),GRHO(IR,1),
     *               GRHO(IR,3),VLB94(IR,1),VLB94(IR,2))
        ENDDO
      ELSE
        DO IR=1,NNR1
          CALL LB94(RHOE(IR,1),GRHO(IR,1),VLB94(IR,1))
        ENDDO
      ENDIF
C
C     Statistical average
      IF(NOGRP.GT.1) CALL STOPGM("SAOP","NO GROUPS ALLOWED")
      DO IS=1,NSTATE
        CALL RHOSOFR(C0(1,IS),RHO1,PSI)
        IF(FOCC(IS).GT.1.D-4) THEN
          IF(TLSD) THEN
            IF(IS.LE.NSUP) THEN
              EEX=EXP(-2.D0*(ENA-EIGV(IS))**2)
              IK=1
            ELSE
              EEX=EXP(-2.D0*(ENB-EIGV(IS))**2)
              IK=2
            ENDIF
          ELSE
            EEX=EXP(-2.D0*(EN-EIGV(IS))**2)
            IK=1
          ENDIF
          WENI1=FOCC(IS)*EEX
          WENI2=FOCC(IS)*(1.D0-EEX)
          DO IR=1,NNR1
            IF(RHOE(IR,IK).GT.1.D-12) THEN
              VSAOP(IR,IK)=VSAOP(IR,IK)+ RHO1(IR)/RHOE(IR,IK) *
     *                     (WENI1*VLB94(IR,IK)+WENI2*VGLLB(IR,IK))
            ENDIF
          ENDDO
        ENDIF
      ENDDO
C
C     calculate EXC (not implemented)
      IF(TLSD) THEN
        EXC=0.D0
      ELSE
        EXC=0.D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PBE_XED(RHOE,GRHO,EX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
C     Arguments
      REAL*8  RHOE,GRHO,EX
C     Parameters
      REAL*8     SMALL,KAPPA,MU,OB3
      PARAMETER (SMALL=1.D-14)
      PARAMETER (OB3=1.D0/3.D0)
      PARAMETER (KAPPA=0.804D0)
      PARAMETER (MU=0.21951D0)
C     Variables
      REAL*8  EXUNIF,X,S2,KF,FX
C     ==--------------------------------------------------------------==
      IF( RHOE .GT. SMALL ) THEN
        KF = (3.D0*PI*PI*RHOE)**OB3
        EXUNIF = -3.D0/(4.D0*PI) * KF
      ELSE
        EXUNIF = 0.D0
      ENDIF
      IF( RHOE .GT. GCEPS .AND. DSQRT(GRHO) .GT. SMALL ) THEN
        S2 = GRHO/(2.D0*KF*RHOE)**2
        X = MU*S2
        FX = 1.D0 + KAPPA - KAPPA/(1.D0 + X/KAPPA)
      ELSE
        FX = 1.D0
      ENDIF
      EX = EXUNIF*FX
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PBE_CED(RHOE,GRHO,EC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
C     Arguments
      REAL*8  RHOE,GRHO,EC
C     Parameters
      REAL*8     SMALL,BE,GA,OB3
      PARAMETER (SMALL=1.D-14)
      PARAMETER (BE=0.06672455060314922D0,GA=0.031090690869654895D0)
      PARAMETER (OB3=1.D0/3.D0)
C     Variables
      REAL*8  RS,EUNIF,VC,AA,A,XKF,XKS,T,EXPE,AF,Y,XY,S1,H0
      INTEGER IFLG
C     ==--------------------------------------------------------------==
      IF( RHOE .GT. SMALL ) THEN
        RS    = (3.D0/(4.D0*PI*RHOE))**OB3
        IFLG  = 2
        IF(RS.LT.1.0D0) IFLG=1
        CALL PZ(RS,EUNIF,VC,IFLG)
      ELSE
        EUNIF = 0.D0
      ENDIF
      AA    = GRHO
      A     = SQRT(AA)
      IF( RHOE .GT. GCEPS .AND. A .GT. SMALL ) THEN
        XKF   = (9.D0*PI/4.D0)**OB3/RS
        XKS   = SQRT(4.D0*XKF/PI)
        T     = A/(2.D0*XKS*RHOE)
        EXPE  = EXP(-EUNIF/GA)
        AF    = BE/GA * (1.D0/(EXPE-1.D0))
        Y     = AF*T*T
        XY    = (1.D0+Y)/(1.D0+Y+Y*Y)
        S1    = 1.D0+BE/GA*T*T*XY
        H0    = GA * LOG(S1)
        EC    = EUNIF + H0
      ELSE
        EC    = EUNIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PBE_CEDS(RHOA,RHOB,GRHOAA,GRHOAB,GRHOBB,EC)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
C     Arguments
      REAL*8  RHOA,RHOB,GRHOAA,GRHOAB,GRHOBB,EC
C     Parameters
      REAL*8     SMALL,BE,GA,OB3
      PARAMETER (SMALL=1.D-14)
      PARAMETER (BE=0.06672455060314922D0,GA=0.031090690869654895D0)
      PARAMETER (OB3=1.D0/3.D0)
C     Variables
      REAL*8  RHO,ETA,GRHO,RS,EUNIF,VCA,VCB,PHI,PHI3,AA,A,XKF,XKS,T
      REAL*8  EXPE,AF,Y,XY,S1,H0
      INTEGER IFLG
C     ==--------------------------------------------------------------==
      RHO=RHOA+RHOB
      ETA=(RHOA-RHOB)/RHO
      GRHO=GRHOAA+2.D0*GRHOAB+GRHOBB
      IF(ABS(ETA).GT.1.D0) ETA=SIGN(1.0D0,ETA)
      IF( RHO .GT. SMALL ) THEN
        RS = (0.75D0/(PI*RHO))**OB3
        IFLG=2
        IF(RS.LT.1.0D0) IFLG=1
        CALL LSD_PZ(RS,ETA,EUNIF,VCA,VCB,IFLG)
      ELSE
        EUNIF = 0.D0
      ENDIF
      AA    = GRHO
      A     = SQRT(AA)
      IF( RHO .GT. GCEPS .AND. A .GT. SMALL ) THEN
        PHI   = 0.5D0*((1.d0+ETA)**(2*OB3)+(1.d0-ETA)**(2*OB3))
        PHI3  = PHI*PHI*PHI
        XKF   = (9.D0*PI/4.D0)**OB3/RS
        XKS   = SQRT(4.D0*XKF/PI)
        T     = A/(2.D0*XKS*RHO*PHI)
        EXPE  = EXP(-EUNIF/(PHI3*GA))
        AF    = BE/GA * (1.D0/(EXPE-1.D0))
        Y     = AF*T*T
        XY    = (1.D0+Y)/(1.D0+Y+Y*Y)
        S1    = 1.D0+BE/GA*T*T*XY
        H0    = GA*PHI3 * LOG(S1)
      ELSE
        H0    = 0.D0
      ENDIF
      EC    = EUNIF + H0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LB94(RHO,GRHO,VLB94)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
C     Arguments
      REAL*8  RHO,GRHO,VLB94
C     Parameters
      REAL*8     SMALL,OB3,ALPHA,BETA
      PARAMETER (SMALL=1.D-14)
      PARAMETER (OB3=1.D0/3.D0)
      PARAMETER (ALPHA=1.19D0,BETA=0.01D0)
corig PARAMETER (ALPHA=1.00D0,BETA=0.05D0)
C     Variables
      REAL*8  RS,EC,VC,EX,VX,XS,BLN,VAS,SGRO
      INTEGER IFLG
C     ==--------------------------------------------------------------==
      IF(RHO.GT.SMALL) THEN
        RS = (0.75D0/(PI*RHO))**OB3
        CALL SLATERX(RHO,EX,VX,2.D0*OB3)
        IFLG=2
        IF(RS.LT.1.0D0) IFLG=1
        CALL PZ(RS,EC,VC,IFLG)
        IF(RHO.GT.GCEPS) THEN
          SGRO=0.5D0*DSQRT(GRHO)
          XS=SGRO/(0.5D0*RHO)**(4.D0*OB3)
          BLN=1.D0+3.D0*BETA*XS*LOG(XS+DSQRT(XS*XS+1.D0))
          VAS=-BETA*XS*XS*(0.5D0*RHO)**OB3/BLN
        ELSE
          VAS=0.D0
        ENDIF
        VLB94 = ALPHA*VX + VC + VAS
      ELSE
        VLB94 = 0.D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LB94S(RHOA,RHOB,GRHOAA,GRHOBB,VLB94A,VLB94B)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
C     Arguments
      REAL*8  RHOA,RHOB,GRHOAA,GRHOBB,VLB94A,VLB94B
C     Parameters
      REAL*8     SMALL,OB3,ALPHA,BETA
      PARAMETER (SMALL=1.D-14)
      PARAMETER (OB3=1.D0/3.D0)
      PARAMETER (ALPHA=1.19D0,BETA=0.01D0)
C     Variables
      REAL*8  RHO,ETA,RS,EX,VXA,VXB,EPZ,VPZA,VPZB,XS,BLN,VASA,VASB
      INTEGER IFLG
C     ==--------------------------------------------------------------==
      RHO = RHOA + RHOB
      ETA = (RHOA-RHOB)/RHO
      IF(RHO.GT.SMALL) THEN
        RS = (0.75D0/(PI*RHO))**OB3
        CALL LSD_SX(RHO,ETA,EX,VXA,VXB,2.D0/3.D0)
        IFLG=2
        IF(RS.LT.1.0D0) IFLG=1
        CALL LSD_PZ(RS,ETA,EPZ,VPZA,VPZB,IFLG)
C
        IF(RHOA.GT.GCEPS) THEN
          XS=SQRT(GRHOAA)/RHOA**(4.D0*OB3)
          BLN=1.D0+3.D0*BETA*XS*LOG(XS+DSQRT(XS*XS+1.D0))
          VASA=-BETA*XS*XS*RHOA**OB3/BLN
        ELSE
          VASA=0.D0
        ENDIF
        IF(RHOB.GT.GCEPS) THEN
          XS=SQRT(GRHOBB)/RHOB**(4.D0*OB3)
          BLN=1.D0+3.D0*BETA*XS*LOG(XS+DSQRT(XS*XS+1.D0))
          VASB=-BETA*XS*XS*RHOB**OB3/BLN
        ELSE
          VASB=0.D0
        ENDIF
C
        VLB94A = ALPHA*VXA + VPZA + VASA
        VLB94B = ALPHA*VXB + VPZB + VASB
      ELSE
        VLB94A = 0.D0
        VLB94B = 0.D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE LB94M(RHOE,GRHO,EXC,VLB94)
C     ==--------------------------------------------------------------==
C     == CALCULATE SAOP POTENTIAL                                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'fft.inc'
C     Arguments
      REAL*8     RHOE(NNR1,NLSD)
      REAL*8     GRHO(NNR1,*),EXC
      REAL*8     VLB94(NNR1,*)
C     Variables
      INTEGER    IR
C     ==--------------------------------------------------------------==
      CALL AZZERO(VLB94,NNR1*NLSD)
      IF(TLSD) THEN
        DO IR=1,NNR1
          CALL LB94S(RHOE(IR,1),RHOE(IR,2),GRHO(IR,1),
     *               GRHO(IR,3),VLB94(IR,1),VLB94(IR,2))
        ENDDO
      ELSE
        DO IR=1,NNR1
          CALL LB94(RHOE(IR,1),GRHO(IR,1),VLB94(IR,1))
        ENDDO
      ENDIF
      EXC=0.D0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GLLB(C0,EIGV,EREF,FOCC,NSTATE,RHOE,GRHO,EXC,
     *                VGLLB,RHO1,PSI)
C     ==--------------------------------------------------------------==
C     == CALCULATE GLLB POTENTIAL                                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'fft.inc'
C     Arguments
      COMPLEX*16 C0(NGW,*)
      INTEGER    NSTATE
      REAL*8     RHOE(NNR1,NLSD),EIGV(*),EREF(*),FOCC(*)
      REAL*8     GRHO(NNR1,*),RHO1(*),EXC
      REAL*8     VGLLB(NNR1,*)
      COMPLEX*16 PSI(*)
C     Parameters
      REAL*8     KRESP
      PARAMETER  (KRESP=0.42D0)
C     Variables
      REAL*8     ENA,ENB,EN,WENI,EX,EC
      INTEGER    IS,IK,IR
C     ==--------------------------------------------------------------==
      ENA=0.D0
      ENB=0.D0
      EN=0.D0
      IF(TLSD) THEN
        DO IS=1,NSUP
          IF(FOCC(IS).GT.1.D-4) ENA=EIGV(IS)
        ENDDO
        DO IS=NSUP+1,NSTATE
          IF(FOCC(IS).GT.1.D-4) ENB=EIGV(IS)
        ENDDO
      ELSE
        DO IS=1,NSTATE
          IF(FOCC(IS).GT.1.D-4) EN=EIGV(IS)
        ENDDO
      ENDIF
C
C     Vresponse
      IF(NOGRP.GT.1) CALL STOPGM("GLLB","NO GROUPS ALLOWED")
      CALL AZZERO(VGLLB,NNR1*NLSD)
      DO IS=1,NSTATE
        CALL RHOSOFR(C0(1,IS),RHO1,PSI)
        IF(FOCC(IS).GT.1.D-4) THEN
          IF(TLSD) THEN
            IF(IS.LE.NSUP) THEN
              ENA=EREF(IS)
              WENI=SQRT(ENA-EIGV(IS))*KRESP*FOCC(IS)
              IK=1
            ELSE
              ENB=EREF(IS)
              WENI=SQRT(ENB-EIGV(IS))*KRESP*FOCC(IS)
              IK=2
            ENDIF
          ELSE
            EN=EREF(IS)
            WENI=SQRT(EN-EIGV(IS))*KRESP*FOCC(IS)
            IK=1
          ENDIF
          DO IR=1,NNR1
            IF(RHOE(IR,IK).GT.1.D-12) THEN
              VGLLB(IR,IK) = VGLLB(IR,IK) + WENI * RHO1(IR)/RHOE(IR,IK)
            ENDIF
          ENDDO
        ENDIF
      ENDDO
C     PBE exchange energy density
      IF(TLSD) THEN
        DO IR=1,NNR1
          CALL PBE_XED(2.D0*RHOE(IR,1),4.D0*GRHO(IR,1),EX)
          VGLLB(IR,1) = VGLLB(IR,1) + 2.D0*EX
        ENDDO
        DO IR=1,NNR1
          CALL PBE_XED(2.D0*RHOE(IR,2),4.D0*GRHO(IR,3),EX)
          VGLLB(IR,2) = VGLLB(IR,2) + 2.D0*EX
        ENDDO
      ELSE
        DO IR=1,NNR1
          CALL PBE_XED(RHOE(IR,1),GRHO(IR,1),EX)
          VGLLB(IR,1) = VGLLB(IR,1) + 2.D0*EX
        ENDDO
      ENDIF
C     PBE correlation energy density
      IF(TLSD) THEN
        DO IR=1,NNR1
          CALL PBE_CEDS(RHOE(IR,1),RHOE(IR,2),GRHO(IR,1),
     *                  GRHO(IR,2),GRHO(IR,3),EC)
          VGLLB(IR,1) = VGLLB(IR,1) + 2.D0*EC
          VGLLB(IR,2) = VGLLB(IR,2) + 2.D0*EC
        ENDDO
      ELSE
        DO IR=1,NNR1
          CALL PBE_CED(RHOE(IR,1),GRHO(IR,1),EC)
          VGLLB(IR,1) = VGLLB(IR,1) + 2.D0*EC
        ENDDO
      ENDIF
C
      EXC = 0.D0
C
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
