C     ==================================================================
      SUBROUTINE SCRSET(SCR,LSCR,DEBUG)
C     ==--------------------------------------------------------------==
C     ==  INITIALIZE SCRATCH SPACE OF LENGTH LSCR                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER LSCR
      REAL*8  SCR(LSCR)
      LOGICAL DEBUG
C     Variables
#ifdef POINTER8
      INTEGER*8 IPS_LOW,IPS_HIG
#else
      INTEGER   IPS_LOW,IPS_HIG
#endif
      INCLUDE 'scrp.inc'
      INTEGER I,IQSCR,
     &        INIT
      DATA    INIT /0/
      SAVE    INIT
C     ==--------------------------------------------------------------==
      IF(INIT.EQ.0) THEN
        NXSCR=0
        CALL IAZZERO(IISCR,MXSCR)
        DO I=1,MXSCR
          NLLSP(I)=ZSLOW
        ENDDO
        INIT=1
      ENDIF
C     ==--------------------------------------------------------------==
      NXSCR=NXSCR+1
      IF(NXSCR.GT.MXSCR)
     *  CALL STOPGM('SCRSET','TOO MANY CONCURRENT SCRATCH SPACES')
      DO I=1,MXSCR
        IF(IISCR(I).EQ.0) GOTO 1
      ENDDO
      CALL STOPGM('SCRSET','TOO MANY CONCURRENT SCRATCH SPACES')
    1 CONTINUE
      IQSCR=I
      IISCR(IQSCR)=1
      CALL GET_ADDR(IPS_LOW(IQSCR),SCR(1))
      CALL GET_ADDR(IPS_HIG(IQSCR),SCR(LSCR))
      IPS_LEN(IQSCR)=LSCR
      CALL IAZZERO(IPS_PTR1(1,IQSCR),MXPTR)
      CALL IAZZERO(IPS_PTR2(1,IQSCR),MXPTR)
      IPS_NUM(IQSCR)=2
      IPS_PTR1(1,IQSCR)=1
      IPS_PTR2(1,IQSCR)=2
      IPS_NAME(1,IQSCR)='START     '
      SCR(1)=ZSLOW
      SCR(2)=ZSHIG
      IPS_PTR1(2,IQSCR)=LSCR-1
      IPS_PTR2(2,IQSCR)=LSCR
      IPS_NAME(2,IQSCR)='FINAL     '
      SCR(LSCR-1)=ZSLOW
      SCR(LSCR)=ZSHIG
      IF(DEBUG) CALL SCRPRT(SCR,LSCR,IQSCR)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SCRREL(SCR,LSCR,DEBUG)
C     ==--------------------------------------------------------------==
C     ==  RELEASE SCRATCH SPACE OF LENGTH LSCR                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER LSCR
      REAL*8  SCR(LSCR)
      LOGICAL DEBUG
C     Variables
#ifdef POINTER8
      INTEGER*8 IPS_LOW,IPS_HIG
#else
      INTEGER   IPS_LOW,IPS_HIG
#endif
      INCLUDE 'scrp.inc'
      INTEGER I,IQ,ITEST
      REAL*8  ZL,ZH
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_TESTDUM,SCR(1))
      DO I=1,MXSCR
        IF(IP_TESTDUM.EQ.IPS_LOW(I)) THEN
          IF(IPS_LEN(I).EQ.LSCR) THEN
            IISCR(I)=0
            IQ=I
            GOTO 1
          ENDIF
        ENDIF
      ENDDO
      CALL STOPGM('SCRREL','SCRATCH SPACE NOT FOUND')
    1 CONTINUE
      ITEST=0
      DO I=1,IPS_NUM(IQ)
        ZL=SCR(IPS_PTR1(I,IQ))
        ZH=SCR(IPS_PTR2(I,IQ))
        IF(ZL.NE.ZSLOW) ITEST=ITEST+1
        IF(ZH.NE.ZSHIG) ITEST=ITEST+1
      ENDDO
      IF(NLLSP(IQ).NE.ZSLOW) ITEST=ITEST+1
      IF(ITEST.NE.0) THEN
        CALL SCRPRT(SCR,LSCR,IQ)
        CALL STOPGM('SCRREL','CORRUPTED SCRATCH SPACE')
      ENDIF
      IF(DEBUG) CALL SCRPRT(SCR,LSCR,IQ)
      NXSCR=NXSCR-1
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SCRPTR(SCR,LSCR,IP_PTR,LEN,INAME,DEBUG)
C     ==--------------------------------------------------------------==
C     ==  ALLOCATE SCRATCH SPACE OF LENGTH LEN                        ==
C     ==  WITHIN SCRATCH SCR                                          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      REAL*8    PTR
      POINTER   (IP_PTR,PTR)
#ifdef _BGL 
      INTEGER   LSCR,LEN,LEN1
#else
      INTEGER   LSCR,LEN
#endif
      REAL*8    SCR(LSCR)
      CHARACTER INAME*(*),MESSAGE*100
      LOGICAL   DEBUG
C     Variables
#ifdef POINTER8
      INTEGER*8 IPS_LOW,IPS_HIG
#else
      INTEGER   IPS_LOW,IPS_HIG
#endif
      INCLUDE 'scrp.inc'
      INTEGER I,IQ,IP1,IP2,IPL,INEW
C     ==--------------------------------------------------------------==
#ifdef _BGL 
      LEN1=LEN+MOD(LEN,2)
#endif
      CALL GET_ADDR(IP_TESTDUM,SCR(1))
      DO I=1,MXSCR
        IF(IP_TESTDUM.EQ.IPS_LOW(I)) THEN
          IF(IPS_LEN(I).EQ.LSCR) THEN
            IQ=I
            GOTO 1
          ENDIF
        ENDIF
      ENDDO
      MESSAGE=INAME//' |SCRATCH SPACE NOT FOUND'
      CALL STOPGM('SCRPTR',MESSAGE)
    1 CONTINUE
      IF(IPS_NUM(IQ).GE.MXPTR) 
     *   CALL STOPGM('SCRPTR','TOO MANY DIFFERENT ARRAYS')
      IF(LEN.EQ.0) THEN
        CALL GET_ADDR(IP_PTR,NLLSP(IQ))
      ELSE
        DO I=1,IPS_NUM(IQ)-1
          IP1=IPS_PTR2(I,IQ)+1
          IP2=IPS_PTR1(I+1,IQ)
          IPL=IP2-IP1
#ifdef _BGL 
          IF(IPL.GT.LEN1+4) GOTO 2
#else
          IF(IPL.GT.LEN+2) GOTO 2
#endif
        ENDDO
#ifdef _BGL 
        WRITE(6,'(A,I10)') ' SCRPTR| ARRAY SIZE REQUESTED : ',LEN1
#else
        WRITE(6,'(A,I10)') ' SCRPTR| ARRAY SIZE REQUESTED : ',LEN
#endif
        WRITE(6,'(A,I10)') ' SCRPTR| MAX. SIZE AVAILABLE  : ',IPL-2
        CALL SCRPRT(SCR,LSCR,IQ)
        MESSAGE=INAME//' |COULD NOT ALLOCATE SCRATCH ARRAY'
        CALL STOPGM('SCRPTR',MESSAGE)
    2   CONTINUE
        INEW=I+1
        DO I=IPS_NUM(IQ)+1,INEW+1,-1
          IPS_PTR1(I,IQ)=IPS_PTR1(I-1,IQ)
          IPS_PTR2(I,IQ)=IPS_PTR2(I-1,IQ)
          IPS_NAME(I,IQ)=IPS_NAME(I-1,IQ)
        ENDDO
        IPS_PTR1(INEW,IQ)=IP1
#ifdef _BGL 
        IPS_PTR2(INEW,IQ)=IP1+LEN1+3
#else
        IPS_PTR2(INEW,IQ)=IP1+LEN+1
#endif
        IPS_NAME(INEW,IQ)='          '
        IPS_NAME(INEW,IQ)=INAME
        IPS_NUM(IQ)=IPS_NUM(IQ)+1
        SCR(IP1)=ZSLOW
#ifdef _BGL 
        SCR(IP1+LEN1+3)=ZSHIG
#else
        SCR(IP1+LEN+1)=ZSHIG
#endif
#ifdef _BGL 
        CALL GET_ADDR(IP_PTR,SCR(IP1+2))
#else
        CALL GET_ADDR(IP_PTR,SCR(IP1+1))
#endif
      ENDIF
      IF(DEBUG) CALL SCRPRT(SCR,LSCR,IQ)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SCRPTF(SCR,LSCR,IP_PTR,LEN,INAME,DEBUG)
C     ==--------------------------------------------------------------==
C     ==  DEALLOCATE SCRATCH ARRAY WITHIN SCRATCH SCR                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      REAL*8    PTR
      POINTER   (IP_PTR,PTR)
      INTEGER   LSCR,LEN
      REAL*8    SCR(LSCR)
      CHARACTER INAME*(*),MESSAGE*100
      LOGICAL   DEBUG
C     Variables
#ifdef POINTER8
      INTEGER*8 IPS_LOW,IPS_HIG, IPR
#else
      INTEGER   IPS_LOW,IPS_HIG, IPR
#endif
      INCLUDE 'scrp.inc'
      INTEGER I,IQ,IPUNIT,INEW,ITEST
      REAL*8  ZL,ZH
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_TESTDUM,SCR(1))
      DO I=1,MXSCR
        IF(IP_TESTDUM.EQ.IPS_LOW(I)) THEN
          IQ=I
          GOTO 1
        ENDIF
      ENDDO
      MESSAGE=INAME//' |SCRATCH SPACE NOT FOUND'
      CALL STOPGM('SCRPTF',MESSAGE)
    1 CONTINUE
      IF(LEN.EQ.0) THEN
        IF(NLLSP(IQ).NE.ZSLOW) THEN
          MESSAGE=INAME//' |NULL SPACE CORRUPTED'
          CALL STOPGM('SCRPTF',MESSAGE)
        ENDIF
      ELSE
#if defined(__YMP) || defined(__NEC) || defined(T3D) || defined(T3E)
        IPUNIT=1
#else
        IPUNIT=8
#endif
#ifdef _BGL 
        IPR=IP_PTR-IP_TESTDUM-1
#else
        IPR=IP_PTR-IP_TESTDUM
#endif
        IPR=IPR/IPUNIT 
        DO I=1,IPS_NUM(IQ)
          IF(IPS_PTR1(I,IQ).EQ.IPR) THEN
            INEW=I
            GOTO 2
          ENDIF
        ENDDO
        MESSAGE=INAME//' |SCRATCH ARRAY NOT FOUND'
        CALL STOPGM('SCRPTF',MESSAGE)
    2   CONTINUE
        ITEST=0
        ZL=SCR(IPS_PTR1(INEW,IQ))
        ZH=SCR(IPS_PTR2(INEW,IQ))
        IF(ZL.NE.ZSLOW) ITEST=ITEST+1
        IF(ZH.NE.ZSHIG) ITEST=ITEST+1
        IF(ITEST.GT.0) THEN
          CALL SCRPRT(SCR,LSCR,IQ)
          MESSAGE=INAME//' |SCRATCH ARRAY CORRUPTED'
          CALL STOPGM('SCRPTF',MESSAGE)
        ENDIF
        DO I=INEW,IPS_NUM(IQ)-1
          IPS_PTR1(I,IQ)=IPS_PTR1(I+1,IQ)
          IPS_PTR2(I,IQ)=IPS_PTR2(I+1,IQ)
          IPS_NAME(I,IQ)=IPS_NAME(I+1,IQ)
        ENDDO
        IPS_NUM(IQ)=IPS_NUM(IQ)-1
      ENDIF
      IF(DEBUG) CALL SCRPRT(SCR,LSCR,IQ)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SCRPRT(SCR,LSCR,IQ)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER LSCR,IQ
      REAL*8  SCR(LSCR)
C     Variables
#ifdef POINTER8
      INTEGER*8 IPS_LOW,IPS_HIG
#else
      INTEGER   IPS_LOW,IPS_HIG
#endif
      INCLUDE 'scrp.inc'
      INTEGER   I,IP1,IP2,IT1,IT2
      REAL*8    ZL,ZH
      CHARACTER INAME*10,
     &          AIQ(2)*10
      DATA      AIQ/' CORRUPTED','        OK'/
C     ==--------------------------------------------------------------==
      WRITE(6,*)
      WRITE(6,'(A,I3)')   '                     SCRATCH SPACE ',IQ
      WRITE(6,'(A,A)') ' NAME         ADR1       ADR2         BOUND1',
     *                   '         BOUND2  '
      DO I=1,IPS_NUM(IQ)
        IP1=IPS_PTR1(I,IQ)
        IP2=IPS_PTR2(I,IQ)
        INAME=IPS_NAME(I,IQ)
        ZL=SCR(IP1)
        ZH=SCR(IP2)
        IT1=2
        IT2=2
        IF(ZL.NE.ZSLOW) IT1=1
        IF(ZH.NE.ZSHIG) IT2=1
        WRITE(6,'(A,I8,3x,I8,5X,A,5X,A)') INAME,IP1,IP2,
     *        AIQ(IT1),AIQ(IT2)
      ENDDO
      WRITE(6,*)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SCRGET(SCR,LSCR,IP_PTR,LEN,INAME,DEBUG)
C     ==--------------------------------------------------------------==
C     ==  ALLOCATE MAXIMUM SPACE WITHIN SCRATCH SCR                   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      REAL*8    PTR
      POINTER   (IP_PTR,PTR)
      INTEGER   LSCR,LEN
      REAL*8    SCR(LSCR)
      CHARACTER INAME*(*),MESSAGE*100
      LOGICAL   DEBUG
C     Variables
#ifdef POINTER8
      INTEGER*8 IPS_LOW,IPS_HIG
#else
      INTEGER   IPS_LOW,IPS_HIG
#endif
      INCLUDE 'scrp.inc'
      INTEGER I,IQ,INEW,IP1,IP2,IPL
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_TESTDUM,SCR(1))
      DO I=1,MXSCR
        IF(IP_TESTDUM.EQ.IPS_LOW(I)) THEN
          IF(IPS_LEN(I).EQ.LSCR) THEN
            IQ=I
            GOTO 1
          ENDIF
        ENDIF
      ENDDO
      MESSAGE=INAME//' |SCRATCH SPACE NOT FOUND'
      CALL STOPGM('SCRGET',MESSAGE)
    1 CONTINUE
      MESSAGE=INAME//' |TOO MANY DIFFERENT ARRAYS'
      IF(IPS_NUM(IQ).GE.MXPTR)
     *   CALL STOPGM('SCRGET',MESSAGE)
      LEN=0
      INEW=0
      DO I=1,IPS_NUM(IQ)-1
        IP1=IPS_PTR2(I,IQ)+1
        IP2=IPS_PTR1(I+1,IQ)
        IPL=IP2-IP1
#ifdef _BGL 
        IF(IPL.GT.LEN+2) THEN
#else
        IF(IPL.GT.LEN+4) THEN
#endif
          INEW=I
#ifdef _BGL 
          LEN=IPL-4
#else
          LEN=IPL-2
#endif
        ENDIF
      ENDDO
      DO I=IPS_NUM(IQ)+1,INEW+1,-1
        IPS_PTR1(I,IQ)=IPS_PTR1(I-1,IQ)
        IPS_PTR2(I,IQ)=IPS_PTR2(I-1,IQ)
        IPS_NAME(I,IQ)=IPS_NAME(I-1,IQ)
      ENDDO
      IPS_PTR1(INEW,IQ)=IP1
#ifdef _BGL 
      IPS_PTR2(INEW,IQ)=IP1+LEN+3
#else
      IPS_PTR2(INEW,IQ)=IP1+LEN+1
#endif
      IPS_NAME(INEW,IQ)='          '
      IPS_NAME(INEW,IQ)=INAME
      IPS_NUM(IQ)=IPS_NUM(IQ)+1
      SCR(IP1)=ZSLOW
#ifdef _BGL 
      SCR(IP1+LEN+3)=ZSHIG
      CALL GET_ADDR(IP_PTR,SCR(IP1+2))
#else
      SCR(IP1+LEN+1)=ZSHIG
      CALL GET_ADDR(IP_PTR,SCR(IP1+1))
#endif
      IF(DEBUG) CALL SCRPRT(SCR,LSCR,IQ)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SCRTEST(SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==  TEST SCRATCH SPACE                                          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER LSCR
      REAL*8  SCR(LSCR)
C     Variables
#ifdef POINTER8
      INTEGER*8 IPS_LOW,IPS_HIG
#else
      INTEGER   IPS_LOW,IPS_HIG
#endif
      INCLUDE 'scrp.inc'
      INTEGER I,IQ,ITEST
      REAL*8  ZL,ZH
C     ==--------------------------------------------------------------==
      CALL GET_ADDR(IP_TESTDUM,SCR(1))
      DO I=1,MXSCR
        IF(IP_TESTDUM.EQ.IPS_LOW(I)) THEN
          IF(IPS_LEN(I).EQ.LSCR) THEN
            IISCR(I)=0
            IQ=I
            GOTO 1
          ENDIF
        ENDIF
      ENDDO
      CALL STOPGM('SCRTEST','SCRATCH SPACE NOT FOUND')
    1 CONTINUE
      ITEST=0
      DO I=1,IPS_NUM(IQ)
        ZL=SCR(IPS_PTR1(I,IQ))
        ZH=SCR(IPS_PTR2(I,IQ))
        IF(ZL.NE.ZSLOW) ITEST=ITEST+1
        IF(ZH.NE.ZSHIG) ITEST=ITEST+1
      ENDDO
      IF(NLLSP(IQ).NE.ZSLOW) ITEST=ITEST+1
      IF(ITEST.NE.0) THEN
        CALL SCRPRT(SCR,LSCR,IQ)
        CALL STOPGM('SCRREL','CORRUPTED SCRATCH SPACE')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================




