C     ==================================================================
      SUBROUTINE SD_II(TAU0,SDER,IESR,IATO)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == CONTRIBUTION OF ESR TO THE SECOND DERIVATIVES WRT TO IONS    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'metr.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSP),SDER(3*NAT,3*NAT)
      INTEGER IESR,IATO(NAX,NSX)
C     Variables
      REAL*8    ARGMAX          !DERFC(ARG) and DEXP(-ARG*ARG) underflow
      PARAMETER (ARGMAX=20.D0)
      LOGICAL TZERO
      REAL*8  RXLM(3),SLOC(3,3),EARG,AARG,DSPI,
     &        ZV2,RCKJ,YLM,ZLM,ERRE2,RLM,ARG,ESRTZERO,XLM,DFD,DSD
      INTEGER ISUB,K,J,L,M,LAX,INF,IX,IY,IZ,ISHFT,I,IA,IB,I1,I2
#ifdef __DERF
      REAL*8    DERFC
      EXTERNAL  DERFC
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('     SD_II',ISUB)
      DSPI=DSQRT(PI)
      IF(PARENT) THEN
        DO K=1,NSP
          DO J=K,NSP
            ZV2=ZV(K)*ZV(J)
            RCKJ=DSQRT(RAGGIO(K)*RAGGIO(K)+RAGGIO(J)*RAGGIO(J))
            LAX=NA(K)
            DO L=1,LAX
              INF=1
              IF(K.EQ.J)INF=L
              DO M=INF,NA(J)
                IF(L.EQ.M.AND.K.EQ.J) THEN
                  XLM=0.D0
                  YLM=0.D0
                  ZLM=0.D0
                  TZERO=.TRUE.
                ELSE
                  TZERO=.FALSE.
                  XLM=TAU0(1,L,K)-TAU0(1,M,J)
                  YLM=TAU0(2,L,K)-TAU0(2,M,J)
                  ZLM=TAU0(3,L,K)-TAU0(3,M,J)
                  CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
                ENDIF
                IA=IATO(L,K)*3
                IB=IATO(M,J)*3
                DO IX=-IESR,IESR
                  DO IY=-IESR,IESR
                    DO IZ=-IESR,IESR
                      ISHFT=IX*IX+IY*IY+IZ*IZ
                      IF(.NOT.(TZERO.AND.ISHFT.EQ.0)) THEN
                       RXLM(1)=XLM+IX*HT(1,1)+IY*HT(2,1)+IZ*HT(3,1)
                       RXLM(2)=YLM+IX*HT(1,2)+IY*HT(2,2)+IZ*HT(3,2)
                       RXLM(3)=ZLM+IX*HT(1,3)+IY*HT(2,3)+IZ*HT(3,3)
                       ERRE2=RXLM(1)**2+RXLM(2)**2+RXLM(3)**2
                       RLM=DSQRT(ERRE2)
                       ARG=RLM/RCKJ
                       IF(ARG.LE.ARGMAX) THEN !ADDESR,ADDPRE /= 0
                         IF(TZERO) THEN
                           ESRTZERO=0.5D0*2.D0*ZV2/ERRE2
                         ELSE
                           ESRTZERO=1.D0*2.D0*ZV2/ERRE2
                         END IF
                         EARG=DERFC(ARG)/(2.D0*RLM)
                         AARG=DEXP(-ARG*ARG)/(DSPI*RCKJ)
                         DFD=-ESRTZERO*(EARG + AARG)
                         DSD=ESRTZERO*2.D0*(3.D0*EARG/(2.D0*ERRE2)+
     *                       AARG*(1.5D0/ERRE2+1.D0/(RCKJ*RCKJ)))
                         SLOC(1,1)=DFD+DSD*RXLM(1)*RXLM(1)
                         SLOC(1,2)=    DSD*RXLM(2)*RXLM(1)
                         SLOC(1,3)=    DSD*RXLM(3)*RXLM(1)
                         SLOC(2,1)=    DSD*RXLM(1)*RXLM(2)
                         SLOC(2,2)=DFD+DSD*RXLM(2)*RXLM(2)
                         SLOC(2,3)=    DSD*RXLM(3)*RXLM(2)
                         SLOC(3,1)=    DSD*RXLM(1)*RXLM(3)
                         SLOC(3,2)=    DSD*RXLM(2)*RXLM(3)
                         SLOC(3,3)=DFD+DSD*RXLM(3)*RXLM(3)
                         DO I1=1,3
                           DO I2=1,3
                             SDER(IA+I1,IB+I2)=
     *                           SDER(IA+I1,IB+I2)-SLOC(I1,I2)
                             SDER(IB+I2,IA+I1)=
     *                           SDER(IB+I2,IA+I1)-SLOC(I1,I2)
                             SDER(IA+I1,IA+I2)=
     *                           SDER(IA+I1,IA+I2)+SLOC(I1,I2)
                             SDER(IB+I1,IB+I2)=
     *                           SDER(IB+I1,IB+I2)+SLOC(I1,I2)
                           ENDDO
                         ENDDO
                       ENDIF
                     ENDIF
                     ENDDO  !ixc
                   ENDDO    !iyc
                ENDDO       !izc
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDIF
      CALL TIHALT('     SD_II',ISUB)
C     ==================================================================
      RETURN
      END
C     ==================================================================
