C     ==================================================================
      SUBROUTINE SD_LOC2(SDER,RHOO,V,IATO,EIROP)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == LOCAL CONTRIBUTION TO DYNAMICAL MATRIX (DIAGONAL PART)       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      REAL*8     SDER(3*NAT,3*NAT),RHOO(NNR1)
      COMPLEX*16 V(*),EIROP(NHG)
      INTEGER    IATO(NAX,NSX)
C     Variables
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 RHET,RHETS,VCGS,EI123,TTT
      REAL*8     FNL(*),DFNL(*),GX,GY,GZ,TA,OMTP
      INTEGER    IG1,IG,ISA,IS,IA,IAT,I,J,IR
C     ==--------------------------------------------------------------==
C     TRANSFORM THE DENSITY TO G SPACE
!$OMP parallel do private(IR)
      DO IR=1,NNR1
        V(IR)=DCMPLX(RHOO(IR),0.D0)
      ENDDO
      CALL FWFFT(V)
C
      OMTP=2.D0*OMEGA*TPIBA2
      IG1=1
      IF(GEQ0) IG1=2
      DO IG=IG1,NHG
        RHET=V(NZH(IG))
        RHETS=DCONJG(V(NZH(IG)))
        VCGS=SCG(IG)*DCONJG(RHET+EIROP(IG))
        GX=GK(1,IG)
        GY=GK(2,IG)
        GZ=GK(3,IG)
        ISA=0
        DO IS=1,NSP
          TTT=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)
!CDIR NODEP
          DO IA=1,NA(IS)
            ISA=ISA+1
            IAT=3*IATO(IA,IS)
            IF(BIGMEM) THEN
              EI123=EIGRB(IG,ISA)
            ELSE
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                  EI3(ISA,INYH(3,IG))
            ENDIF
            TA=-DREAL(EI123*TTT)*OMTP
            SDER(IAT+1,IAT+1)=SDER(IAT+1,IAT+1)+TA*GX*GX
            SDER(IAT+2,IAT+1)=SDER(IAT+2,IAT+1)+TA*GY*GX
            SDER(IAT+3,IAT+1)=SDER(IAT+3,IAT+1)+TA*GZ*GX
            SDER(IAT+1,IAT+2)=SDER(IAT+1,IAT+2)+TA*GX*GY
            SDER(IAT+2,IAT+2)=SDER(IAT+2,IAT+2)+TA*GY*GY
            SDER(IAT+3,IAT+2)=SDER(IAT+3,IAT+2)+TA*GZ*GY
            SDER(IAT+1,IAT+3)=SDER(IAT+1,IAT+3)+TA*GX*GZ
            SDER(IAT+2,IAT+3)=SDER(IAT+2,IAT+3)+TA*GY*GZ
            SDER(IAT+3,IAT+3)=SDER(IAT+3,IAT+3)+TA*GZ*GZ
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
