c     ==================================================================
      SUBROUTINE SD_NL(FION,F,FNL,FNL2,DFNL,FNL1,FNL3,DFNL1,NSTATE)
C     ==---------------------------------------------------------------==
C     ==                        computes                               ==
C     ==  the non-local potential contribution to the dynamical matrix ==
C     ==---------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'nlps.inc'
      include 'ions.inc'
      include 'pslo.inc'
      include 'cvan.inc'
      include 'cppt.inc'
      include 'spin.inc'
      include 'sgpp.inc'
C     arguments
      INTEGER NSTATE
      REAL*8  F(NSTATE),FION(3,NAX,NSX)
      REAL*8  FNL(NAT,NHXS,NSTATE),DFNL(NAT,NHXS,3,NSTATE)
      REAL*8  FNL2(NAT,NHXS,*)
      REAL*8  FNL1(NAT,NHXS,NSTATE),DFNL1(NAT,NHXS,3,NSTATE)
      REAL*8  FNL3(NAT,NHXS,*)
C     variables
      REAL*8 TT,TEMP,TX
      INTEGER I,K,IS,IA,IV,II,IAT,JV,L,L2,LJ,KJ,IJ,KI,LI
C     ==--------------------------------------------------------------==
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO K=1,3
            TT=0.D0
            IF(TVAN(IS)) THEN
              CALL STOPGM('SD_NL','VDB not implemented')
            ELSEIF(TSGP(IS)) THEN
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                      TX=2.0D0*F(I)*HLSG(KI,KJ,L,IS)
                      II=I-NST12(MEPOS,1)+1
                      IF(TFDIST) THEN
                        TT=TT+TX*(
     &                   FNL3(IAT,IV,II)*DFNL(IAT,JV,K,II)+
     &                   DFNL1(IAT,IV,K,II)*FNL2(IAT,JV,II))
                      ELSE
                        TT=TT+TX*(
     &                   FNL1(IAT,IV,I)*DFNL(IAT,JV,K,II)+
     &                   DFNL1(IAT,IV,K,II)*FNL(IAT,JV,I))
                      ENDIF
                    ENDDO
                  ENDIF
                ENDDO
              ENDDO
            ELSE
              DO IV=1,NGH(IS)
                TEMP=2.D0*WSG(IS,IV)
                DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                  II=I-NST12(MEPOS,1)+1
                  IF(TFDIST) THEN
                    TT=TT+TEMP*F(I)*(
     &               FNL3(IAT,IV,II)*DFNL(IAT,IV,K,II)+
     &               DFNL1(IAT,IV,K,II)*FNL2(IAT,IV,II))
                  ELSE
                    TT=TT+TEMP*F(I)*(
     &               FNL1(IAT,IV,I)*DFNL(IAT,IV,K,II)+
     &               DFNL1(IAT,IV,K,II)*FNL(IAT,IV,I))
                  ENDIF
                ENDDO
              ENDDO
            ENDIF
            FION(K,IA,IS)=FION(K,IA,IS)+TT
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
