C     ==================================================================
      SUBROUTINE SD_NL2(SDER,IATO,NSTATE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     == THE NON-LOCAL POTENTIAL CONTRIBUTION TO THE DYNAMICAL MATRIX ==
C     == THERE ARE ONLY DIAGONAL CONTRIBUTIONS                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'        !NLM
      INCLUDE 'elct.inc'        !NLM
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      INTEGER NSTATE,IATO(NAX,NSX)
      REAL*8  SDER(3*NAT,3*NAT)
C     Variables
      DIMENSION FNL2(NAT,NHXS,LDF2),F(NSTATE),DDFNL(NAT,NHXS,6,NDFNL)
      REAL*8  DFNL(NAT,NHXS,3,NDFNL),FNL(LDF1,NHXS,NSTATE),
     &        WEIGHT,TEMP,TT
      INTEGER ISA0,IS,IV,JV,I,II,ISA,L,KI,LI,L2,LJ,KJ,IA,J,JJ
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      ISA0=0
      DO IS=1,NSP
        IF(TVAN(IS)) THEN
C..Vanderbild pp
          CALL STOPGM('SD_NL2','VDB PP NOT IMPLEMENTED')
        ELSEIF(TSGP(IS)) THEN
C..Stefan Goedecker pp
          DO IV=1,NGH(IS)
            L=NGHTOL(IV,IS)+1
            KI=LFVAL(IV,IS)
            LI=LPVAL(IV,IS)
            DO JV=1,NGH(IS)
              L2=NGHTOL(JV,IS)+1
              LJ=LPVAL(JV,IS)
              IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
                KJ=LFVAL(JV,IS)
                DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                  TT=2.0D0*F(I)*HLSG(KI,KJ,L,IS)
                  II=I-NST12(MEPOS,1)+1
                  IF(TFDIST) THEN
                    J=II
                  ELSE
                    J=I
                  ENDIF
                  DO IA=1,NA(IS)
                    JJ=IATO(IA,IS)*3
                    ISA=ISA0+IA
                    SDER(JJ+1,JJ+1)=SDER(JJ+1,JJ+1)+TT*
     &               (DDFNL(ISA,IV,1,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,1,II)*DFNL(ISA,JV,1,II))
                    SDER(JJ+1,JJ+2)=SDER(JJ+1,JJ+2)+TT*
     &               (DDFNL(ISA,IV,2,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,1,II)*DFNL(ISA,JV,2,II))
                    SDER(JJ+1,JJ+3)=SDER(JJ+1,JJ+3)+TT*
     &               (DDFNL(ISA,IV,3,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,1,II)*DFNL(ISA,JV,3,II))
                    SDER(JJ+2,JJ+2)=SDER(JJ+2,JJ+2)+TT*
     &               (DDFNL(ISA,IV,4,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,2,II)*DFNL(ISA,JV,2,II))
                    SDER(JJ+2,JJ+3)=SDER(JJ+2,JJ+3)+TT*
     &               (DDFNL(ISA,IV,5,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,2,II)*DFNL(ISA,JV,3,II))
                    SDER(JJ+3,JJ+3)=SDER(JJ+3,JJ+3)+TT*
     &               (DDFNL(ISA,IV,6,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,3,II)*DFNL(ISA,JV,3,II))
                    SDER(JJ+2,JJ+1)=SDER(JJ+2,JJ+1)+TT*
     &               (DDFNL(ISA,IV,2,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,2,II)*DFNL(ISA,JV,1,II))
                    SDER(JJ+3,JJ+1)=SDER(JJ+3,JJ+1)+TT*
     &               (DDFNL(ISA,IV,3,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,3,II)*DFNL(ISA,JV,1,II))
                    SDER(JJ+3,JJ+2)=SDER(JJ+3,JJ+2)+TT*
     &               (DDFNL(ISA,IV,5,II)*FNL2(ISA,JV, J)+
     &                DFNL(ISA,IV,3,II)*DFNL(ISA,JV,2,II))
                  ENDDO
                ENDDO
              ENDIF
            ENDDO
          ENDDO
        ELSE
C..Other pp (numeric)
          DO IV=1,NGH(IS)
            TEMP=2.D0*WSG(IS,IV)
            DO I=NST12(MEPOS,1),NST12(MEPOS,2)
              WEIGHT=F(I)*TEMP
              II=I-NST12(MEPOS,1)+1
              IF(TFDIST) THEN
                J=II
              ELSE
                J=I
              ENDIF
              DO IA=1,NA(IS)
                JJ=IATO(IA,IS)*3
                ISA=ISA0+IA
                SDER(JJ+1,JJ+1)=SDER(JJ+1,JJ+1)+WEIGHT*
     &           (DDFNL(ISA,IV,1,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,1,II)*DFNL(ISA,IV,1,II))
                SDER(JJ+1,JJ+2)=SDER(JJ+1,JJ+2)+WEIGHT*
     &           (DDFNL(ISA,IV,2,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,1,II)*DFNL(ISA,IV,2,II))
                SDER(JJ+1,JJ+3)=SDER(JJ+1,JJ+3)+WEIGHT*
     &           (DDFNL(ISA,IV,3,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,1,II)*DFNL(ISA,IV,3,II))
                SDER(JJ+2,JJ+2)=SDER(JJ+2,JJ+2)+WEIGHT*
     &           (DDFNL(ISA,IV,4,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,2,II)*DFNL(ISA,IV,2,II))
                SDER(JJ+2,JJ+3)=SDER(JJ+2,JJ+3)+WEIGHT*
     &           (DDFNL(ISA,IV,5,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,2,II)*DFNL(ISA,IV,3,II))
                SDER(JJ+3,JJ+3)=SDER(JJ+3,JJ+3)+WEIGHT*
     &           (DDFNL(ISA,IV,6,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,3,II)*DFNL(ISA,IV,3,II))
                SDER(JJ+2,JJ+1)=SDER(JJ+2,JJ+1)+WEIGHT*
     &           (DDFNL(ISA,IV,2,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,2,II)*DFNL(ISA,IV,1,II))
                SDER(JJ+3,JJ+1)=SDER(JJ+3,JJ+1)+WEIGHT*
     &           (DDFNL(ISA,IV,3,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,3,II)*DFNL(ISA,IV,1,II))
                SDER(JJ+3,JJ+2)=SDER(JJ+3,JJ+2)+WEIGHT*
     &           (DDFNL(ISA,IV,5,II)*FNL2(ISA,IV, J)+
     &            DFNL(ISA,IV,3,II)*DFNL(ISA,IV,2,II))
              ENDDO
            ENDDO
          ENDDO
        ENDIF
        ISA0=ISA0+NA(IS)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
