C     ==================================================================
      SUBROUTINE SD_WANNIER(ROTMAT,XYZMAT,LDX,NSTATE,
     *                      GMAT,RMAT,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'wann.inc'
      INCLUDE 'metr.inc'
      INTEGER    LDX,NSTATE,LSCR
      REAL*8     ROTMAT(NSTATE,NSTATE)
      REAL*8     GMAT(NSTATE,NSTATE),RMAT(NSTATE,NSTATE),SCR(LSCR)
      COMPLEX*16 XYZMAT(LDX,LDX,NWANOPT)
C     ==--------------------------------------------------------------==
      CHARACTER  TAG*30
      INTEGER    IOPT,I,J,IMAX,IDAMAX,LWANN
      REAL*8     XRANF,DGIVE,GMAX,OFUN,SCAL,PI
      EXTERNAL   XRANF,DGIVE
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_SDWANN(LWANN,TAG,NSTATE)
      CALL TEST_SCR('SD_WANNIER',TAG,LSCR,LWANN)
C     ==--------------------------------------------------------------==
      PI=DACOS(-1.D0)
C..initialise global rotation matrix
      CALL UNITMX(ROTMAT,NSTATE)
      IF(W_RAN.GT.0.D0) THEN
C..randomly distort initial vectors
        DO I=1,NSTATE
          GMAT(I,I)=0.D0
          DO J=I+1,NSTATE
            GMAT(I,J)=XRANF()*W_RAN
            GMAT(J,I)=-GMAT(I,J)
          ENDDO
        ENDDO
        CALL EXPONENTIATE(GMAT,ROTMAT,NSTATE,SCR,LSCR)
        CALL XYZ_UPDATE(ROTMAT,XYZMAT,SCR,LDX,NSTATE)
        W_RAN=0.D0
      ENDIF
      DO IOPT=1,W_MAXS
C..calculate the gradient
        CALL XGRADAT0(W_TYPE,GMAT,XYZMAT,LDX,NSTATE)
        IMAX=IDAMAX(NSTATE*NSTATE,GMAT,1)
        GMAX=DABS(DGIVE(GMAT(1,1),IMAX))/ALAT**2
        CALL OFUNC(W_TYPE,OFUN,XYZMAT,LDX,NSTATE)
        IF(GMAX.LT.W_EPS) GOTO 100
        SCAL=0.25D0*W_STEP/ALAT**2
        CALL DSCAL(NSTATE*NSTATE,-SCAL,GMAT,1)
        CALL EXPONENTIATE(GMAT,RMAT,NSTATE,SCR,LSCR)
        CALL DCOPY(NSTATE*NSTATE,ROTMAT,1,SCR,1)
        CALL DGEMM('N','N',NSTATE,NSTATE,NSTATE,1.D0,SCR,NSTATE,
     *             RMAT,NSTATE,0.D0,ROTMAT,NSTATE)
        CALL XYZ_UPDATE(RMAT,XYZMAT,SCR,LDX,NSTATE)
      ENDDO
      WRITE(6,'(A,G12.3)') ' WANNIER CODE| NO CONVERGENCE (GMAX) ',GMAX
  100 CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_SDWANN(LWANN,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   LWANN,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LEXP,LUPDATE
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_EXPONENTIATE(LEXP,TAG,NSTATE)
      LUPDATE=3*NSTATE*NSTATE
      LWANN=MAX(LEXP,LUPDATE)
      TAG='MAX(LEXP,LUPDATE)'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_EXPONENTIATE(LEXP,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   LEXP,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LEXP=2*NSTATE*NSTATE+4*NSTATE+2*25*NSTATE+3*NSTATE + 10
      TAG='57*NSTATE+2*NSTATE*NSTATE'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE EXPONENTIATE(GMAT,RMAT,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NSTATE,LSCR
      REAL*8  GMAT(NSTATE,NSTATE),RMAT(NSTATE,NSTATE),SCR(LSCR)
C     variables
      COMPLEX*16 HGMAT(NSTATE,NSTATE),EIA(NSTATE)
      POINTER    (IP_HGMAT,HGMAT),(IP_EIA,EIA)
      INTEGER    I,J,K,INFO,IP1,IP2,IP3,IP4,IPE,LW1,LW2
      REAL*8  EI,CEI,SEI
C     ==--------------------------------------------------------------==
C     Scratch array
      LW1=25*NSTATE
      LW2=3*NSTATE
      IP1=1
      IP2=IP1+2*NSTATE*NSTATE
      IP3=IP2+4*NSTATE
      IP4=IP3+2*LW1
      IPE=IP4+LW2
      IF(IPE.GT.LSCR) CALL STOPGM('EXPONENTIATE','SCRATCH TOO SMALL')
      CALL GET_ADDR(IP_HGMAT,SCR(IP1))
      CALL GET_ADDR(IP_EIA,SCR(IP2))
C     ==--------------------------------------------------------------==
C..calculate eigenvalues of iG (this is Hermite schen)
      DO I=1,NSTATE
        DO J=I,NSTATE
          HGMAT(I,J)=DCMPLX(0.D0,GMAT(I,J))
        ENDDO
      ENDDO
      CALL ZHEEV('V','U',NSTATE,HGMAT,NSTATE,RMAT,SCR(IP3),LW1,
     *           SCR(IP4),INFO)
      DO I=1,NSTATE
        EI=RMAT(I,1)
        CEI=DCOS(EI)
        SEI=DSIN(EI)
        EIA(I)=DCMPLX(CEI,SEI)
      ENDDO
      CALL AZZERO(RMAT,NSTATE*NSTATE)
#ifdef __ES 
!$OMP parallel do private(J,I,K)
      DO J=1,NSTATE
        DO I=1,NSTATE
          DO K=1,NSTATE
            RMAT(I,J)=RMAT(I,J)+DREAL(EIA(K)*HGMAT(I,K)*
     *                DCONJG(HGMAT(J,K)))
          ENDDO
        ENDDO
      ENDDO
#else 
      DO K=1,NSTATE
        DO I=1,NSTATE
          DO J=1,NSTATE
            RMAT(I,J)=RMAT(I,J)+DREAL(EIA(K)*HGMAT(I,K)*
     *                DCONJG(HGMAT(J,K)))
          ENDDO
        ENDDO
      ENDDO
#endif 
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE XGRADAT0(WT,GMAT,XYZMAT,LDX,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'wann.inc'
C     Arguments
      INTEGER    LDX,NSTATE,WT
      REAL*8     GMAT(NSTATE,NSTATE)
      COMPLEX*16 XYZMAT(LDX,LDX,NWANOPT)
C     Variables
      INTEGER    I,J,K
      REAL*8     GCOMP
      COMPLEX*16 XA,XB
C     ==--------------------------------------------------------------==
      CALL AZZERO(GMAT,NSTATE*NSTATE)
      IF(WT.EQ.1) THEN
C..Vanderbilt functional |M|^2
!$OMP parallel do private(I,J,K,GCOMP,XA) schedule(static,1)
        DO I=1,NSTATE-1
          DO J=I+1,NSTATE
            GCOMP=0.D0
            DO K=1,NWANOPT
              XA=XYZMAT(J,J,K)-XYZMAT(I,I,K)
              GCOMP=GCOMP+
     *          DREAL(4.d0*DCONJG(XYZMAT(I,J,K))*WWEI(K)*XA)
            ENDDO
            GMAT(I,J)=GCOMP
            GMAT(J,I)=-GMAT(I,J)
          ENDDO
        ENDDO
      ELSEIF(WT.EQ.2) THEN
C..Resta functional Log(|M|^2)
!$OMP parallel do private(I,J,K,GCOMP,XA,XB) schedule(static,1)
        DO I=1,NSTATE-1
          DO J=I+1,NSTATE
            GCOMP=0.D0
            DO K=1,NWANOPT
              XA=DREAL(XYZMAT(I,J,K)/XYZMAT(I,I,K))
              XB=DREAL(XYZMAT(I,J,K)/XYZMAT(J,J,K))
              GCOMP=GCOMP+2.D0*WWEI(K)*DREAL(XB-XA)
            ENDDO
            GMAT(I,J)=GCOMP
            GMAT(J,I)=-GMAT(I,J)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE OFUNC(WT,FUNCV,XYZMAT,LDX,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'wann.inc'
C     Arguments
      INTEGER    LDX,NSTATE,WT
      REAL*8     FUNCV
      COMPLEX*16 XYZMAT(LDX,LDX,NWANOPT)
C     Variables
      INTEGER    I,K
C     ==--------------------------------------------------------------==
      FUNCV=0.D0
      IF(WT.EQ.1) THEN
C..Vanderbilt functional |M|^2
        DO I=1,NSTATE
          DO K=1,NWANOPT
            FUNCV=FUNCV+
     *            WWEI(K)*DREAL(DCONJG(XYZMAT(I,I,K))*XYZMAT(I,I,K))
          ENDDO
        ENDDO
      ELSEIF(WT.EQ.2) THEN
C..Resta functional Log(|M|^2)
        DO I=1,NSTATE
          DO K=1,NWANOPT
            FUNCV=FUNCV+
     *      (-WWEI(K)*DLOG(DREAL(DCONJG(XYZMAT(I,I,K))*XYZMAT(I,I,K))))
          ENDDO
        ENDDO
      ENDIF
      FUNCV=FUNCV/ALAT**2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE XYZ_UPDATE(RMAT,XYZMAT,SCR,LDX,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'wann.inc'
C     Arguments
      INTEGER LDX,NSTATE
      REAL*8  RMAT(NSTATE,NSTATE),XYZMAT(2,LDX,LDX,NWANOPT),
     &        SCR(NSTATE,NSTATE,3)
C     Variables
      INTEGER I,J,K
C     ==--------------------------------------------------------------==
      DO I=1,NWANOPT
!$OMP parallel do private(J,K)
        DO J=1,NSTATE
          DO K=1,NSTATE
            SCR(J,K,1)=XYZMAT(1,J,K,I)
          ENDDO
        ENDDO
        CALL DGEMM('T','N',NSTATE,NSTATE,NSTATE,1.D0,RMAT,NSTATE,
     *             SCR(1,1,1),NSTATE,0.D0,SCR(1,1,2),NSTATE)
        CALL DGEMM('N','N',NSTATE,NSTATE,NSTATE,1.D0,SCR(1,1,2),NSTATE,
     *             RMAT,NSTATE,0.D0,SCR(1,1,1),NSTATE)
!$OMP parallel do private(J,K)
        DO J=1,NSTATE
          DO K=1,NSTATE
            XYZMAT(1,J,K,I)=SCR(J,K,1)
          ENDDO
        ENDDO
!$OMP parallel do private(J,K)
        DO J=1,NSTATE
          DO K=1,NSTATE
            SCR(J,K,1)=XYZMAT(2,J,K,I)
          ENDDO
        ENDDO
        CALL DGEMM('T','N',NSTATE,NSTATE,NSTATE,1.D0,RMAT,NSTATE,
     *             SCR(1,1,1),NSTATE,0.D0,SCR(1,1,2),NSTATE)
        CALL DGEMM('N','N',NSTATE,NSTATE,NSTATE,1.D0,SCR(1,1,2),NSTATE,
     *             RMAT,NSTATE,0.D0,SCR(1,1,1),NSTATE)
!$OMP parallel do private(J,K)
        DO J=1,NSTATE
          DO K=1,NSTATE
            XYZMAT(2,J,K,I)=SCR(J,K,1)
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
