C     ==================================================================
      SUBROUTINE SDCELL(TAU0)
C     ==--------------------------------------------------------------==
C     ==  UPDATE CELL WITH STEEPEST DESCENT                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'prcp.inc'        !TISOT + TZFLEX
C     Arguments
      REAL*8  TAU0(3,NAX,NSX)
C     Variables
      REAL*8  TX(3),FAC,PP,DIAG,CFOR
      INTEGER I,J,IS,IA
#ifdef PARALLEL
      INTEGER MSGLEN
#endif
C     ==--------------------------------------------------------------==
      FAC=DT_IONS*DT_IONS/CMASS
      IF(TZFLEX) THEN
C        z-direction only flexible cell
C        We use only the z-direction (pressure).
         CFOR = HTFOR(3,3)
         DIAG = HT(3,3)
         IF(DIAG.EQ.0.D0) THEN
            DIAG = 1.D0
         ENDIF
         PP = 1.D0 + FAC*CFOR/DIAG
         DO J=1,3
               HT(3,J) = PP*HT(3,J)
         ENDDO
      ELSE IF(TISOT) THEN
C        ISOTROPIC CELL
C        We use only the diagonal (pressure).
         CFOR = HTFOR(1,1)+HTFOR(2,2)+HTFOR(3,3)
         DIAG = HT(1,1)+HT(2,2)+HT(3,3)
         IF(DIAG.EQ.0.D0) THEN
            DIAG = 1.D0
         ENDIF
         PP = 1.D0 + FAC*CFOR/DIAG
         DO I=1,3
            DO J=1,3
               HT(I,J) = PP*HT(I,J)
            ENDDO  
         ENDDO
      ELSE
C        NO CONSTRAINT
         DO I=1,3
            DO J=1,3
               HT(I,J)=HT(I,J)+FAC*HTFOR(I,J)
            ENDDO
         ENDDO
      ENDIF
      DO IS=1,NSP
        DO IA=1,NA(IS)
          CALL DGEMV('T',3,3,1.0D0,HTM1,3,TAU0(1,IA,IS),1,0.0D0,TX,1)
          CALL DGEMV('T',3,3,1.0D0,HT,3,TX,1,0.0D0,TAU0(1,IA,IS),1)
        ENDDO
      ENDDO
#ifdef PARALLEL
      MSGLEN = 9 * 8
      CALL MY_BCAST(HT,MSGLEN,SOURCE,ALLGRP)
#endif
      CALL IHMAT(HT,HTM1,OMEGA)
      DO I=1,3
        A1(I) = HT(1,I)
        A2(I) = HT(2,I)
        A3(I) = HT(3,I)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
