C     ==================================================================
      SUBROUTINE SDLINRES(C0,C2,SC0,C1,EIGV)
C     ==--------------------------------------------------------------==
C     ==  VIBRATIONAL ANALYSIS USING LINEAR RESPONSE                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ener.inc' 
      INCLUDE 'elct.inc' 
      INCLUDE 'tpar.inc' 
      INCLUDE 'pslo.inc' 
      INCLUDE 'ions.inc' 
      INCLUDE 'soft.inc' 
      INCLUDE 'norm.inc' 
      INCLUDE 'ropt.inc' 
      INCLUDE 'cppt.inc' 
      INCLUDE 'coor.inc' 
      INCLUDE 'sfac.inc' 
      INCLUDE 'cotr.inc' 
      INCLUDE 'adat.inc' 
      INCLUDE 'rmas.inc' 
      INCLUDE 'nlcc.inc' 
      INCLUDE 'symm.inc' 
      INCLUDE 'irat.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc' 
      INCLUDE 'poin.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'store.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      COMPLEX*16 C0(*),C2(*),SC0(*),C1(NGW,N)
      REAL*8     EIGV(*)
C     Variables
      POINTER    (IP_VPP,VPP),(IP_GDE,GDE),(IP_PME,PME)
      REAL*8     VPP(*),GDE(*),PME(*)
      INTEGER    NVPP,NGDE,NPME
      REAL*8     TSCR(3,NAX,NSX),SDER(3*NAT,3*NAT),
     &           XMA(3*NAX*NSX),VIBE(3*NAT)
      POINTER    (IP_TSCR,TSCR),(IP_SDER,SDER),
     &           (IP_XMA,XMA),(IP_VIBE,VIBE)
      COMPLEX*16 PSI(*),H1NL(*),EIVPS1(*),EIROP1(*)
      COMPLEX*16 EIVPS(*),EIROP(*)
      POINTER    (IP_H1NL,H1NL),(IP_EIVPS1,EIVPS1),(IP_EIROP1,EIROP1)
      POINTER    (IP_EIVPS,EIVPS),(IP_EIROP,EIROP),(IP_DDXC,DDXC)
      REAL*8     RHOE(NNR1,NLSD),SCR(*),DDXC(*)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
      DIMENSION  FNL2(*)
      REAL*8     FNL(*),DFNL(*)
      REAL*8     FNL1(*),DFNL1(*),FNL3(*)
      POINTER    (IP_FNL1,FNL1),(IP_FNL3,FNL3),(IP_DFNL1,DFNL1)
      INTEGER    IATO(NAX,NSX)
      POINTER    (IP_IATO,IATO)
      INTEGER    IREC(100)
      CHARACTER  FILEN*100,TAG*30,CDIR(3)*1
      DATA       CDIR /'X','Y','Z'/
      LOGICAL    READHE,FERROR
      INTEGER    NNX,NHPSI,NSYM,IAT,IS,IA,IDELT,K,IS2,IA2,INFO,
     &           K2,ISYMUAT,ID,ICOL,IAT2,IX,I,J,IJ,IN1,NAUX,
     &           LSCR,IL_RHOE,IL_PSI,LDFNL,IG,IG1,LDDXC
      REAL*8     TIME1,EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,ETOTO,ETOTG,
     &           TIME2,TCPU,DETOT,THL,XMASS,G2,
     &           TIMEF,EKINH1,EKINH2,EIND,VP,TRACE,DASUM
      EXTERNAL   DASUM,TIMEF
      INTEGER    MSGLEN
      DIMENSION  RHOO(*),POTR(*),F(*)
C     ==================================================================
      TIME1 = TIMEF()
C     ==--------------------------------------------------------------==
C..input for linear response
      CALL LR_IN
C     ==--------------------------------------------------------------==
      IF(TKPNT.AND.PARENT) THEN
        WRITE(6,*) ' K-POINTS WITH LINEAR RESPONSE NOT IMPLEMENTED'
        CALL STOPGM('SECDER','WRONG OPTIONS')
      ENDIF
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TSCR,3*NAX*NSX,'TSCR')
      CALL AZZERO(TSCR,3*NAX*NSX)
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      IF(PARENT) THEN
        CALL MEMORY(IP_XMA,3*NAX*NSX,'XMA')
        CALL MEMORY(IP_VIBE,3*NAT,'VIBE')
      ENDIF
      CALL MEMORY(IP_SDER,9*NAT*NAT,'SDER')
      CALL AZZERO(SDER,9*NAT*NAT)
      NACC = 7
      ECNSTR = 0.0D0
      ERESTR = 0.0D0
C..atom pointer
      ID=(NAX*NSX)/IRAT+1
      CALL MEMORY(IP_IATO,ID,'IATO')
      CALL IAZZERO(IATO,NAX*NSX)
      IJ=0
      DO IS=1,NSP
        DO IAT=1,NA(IS)
          IATO(IAT,IS)=IJ
          IJ=IJ+1
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,IL_PSI,'PSI')
      CALL GIVE_SCR_SDLINRES(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
C
      CALL MEMORY(IP_RHOO,IL_RHOE,'RHOO')
      CALL MEMORY(IP_POTR,IL_RHOE,'POTR')
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_H1NL,2*NGWK*N,'H1NL')
      CALL MEMORY(IP_EIVPS1,2*NHG,'EIVPS1')
      CALL MEMORY(IP_EIROP1,2*NHG,'EIROP1')
      CALL MEMORY(IP_EIVPS,2*NHG,'EIVPS')
      CALL MEMORY(IP_EIROP,2*NHG,'EIROP')
      IF(TXC_ANALYTIC) THEN
        LDDXC=NNR1*(2*NLSD-1)
      ELSEIF(LOPTI.EQ.0.OR.LOPTI.EQ.2) THEN
        LDDXC=NNR1*(2*NLSD-1)
      ELSE
        LDDXC=1
      ENDIF
      CALL MEMORY(IP_DDXC,LDDXC,'DDXC')
      IF(PS_TYPE.EQ.1) CALL STOPGM('SDLINRES','HOCKNEY PS not impl.')
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
C     ==--------------------------------------------------------------==
      CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
C     END INITIALIZATION
C..  Do not symmtrize density...  
      TSYMRHO=.FALSE.
C..Make sure TKFULL=.TRUE
      IF(TKPNT.AND.(.NOT.TKFULL)) THEN 
        WRITE(6,*) 
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        WRITE(6,*) 
     & ' WARNING!  USE KPOINTS FULL  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        WRITE(6,*) 
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
      ENDIF
C..
      ETOTO=0.D0
      EBOGO=0.D0
      IF(PARENT) CALL DETDOF(TAU0,TSCR)
      NPARA=-1
      READHE=.FALSE.
      IF(PARENT) CALL HESSIN(TAU0,READHE)
      ETOTG=0.0D0
      CALL WRITE_IREC(IREC)
      IF(PARENT) THEN
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,F8.2,A)') ' TIME FOR INITIALIZATION',
     &       TCPU,' SECONDS'
      ENDIF
C     ==--------------------------------------------------------------==
C     ==      OPTIMIZATION OF WAVEFUNCTION AT MINIMUM STRUCTURE       ==
C     ==--------------------------------------------------------------==
      IF(PARENT)
     *  WRITE(6,'(/," ",22("*"),A,23("*"),/)') ' MINIMUM STRUCTURE '
      CONVWF=.FALSE.
      SDIIS=.TRUE.
      SPCG=.TRUE.
      TIME1=TIMEF()
C..allocate additional memory for optimisers
      IF(TSDE) THEN
        NPME = 1
        NGDE = 1
        NVPP = 1
      ELSE IF(DIIS) THEN
        NPME = (NGW*N+8)*MDIIS
        NGDE = ((NGW*N+8)*MDIIS)/4
        NVPP = NGW
      ELSE IF(PCG) THEN
        NPME = 2*NGW*N
        NGDE = 1
        NVPP = NGW
      ELSE
        IF(PARENT)
     *  WRITE(6,*) ' WRONG OPTION FOR WAVEFUNCTION OPTIMIZATION'
        CALL STOPGM('SDLINRES',' ')
      ENDIF
      CALL MEMORY(IP_PME,NPME,'PME')
      CALL MEMORY(IP_GDE,NGDE,'GDE')
      CALL MEMORY(IP_VPP,NVPP,'VPP')
      DO INFW=1,NOMORE
C       UPDATE THE WAVEFUNCTIONS
        CALL UPDWF(C0,C2,SC0,TAU0,TSCR,PME,GDE,VPP,EIGV,
     *             RHOE,PSI,SCR,LSCR,N,.FALSE.,.true.)
C       PRINTOUT THE EVOLUTION OF THE ITERATIVE OPTIMIZATION
        IF(PARENT) THEN
          DETOT=ETOT-ETOTO
          IF(INFW.EQ.1) DETOT=0.0D0
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
          CALL WRPRINT_WFOPT(EIGV,F,AMU,N,ETOT,ETOTO,
     &         TCPU,GEMAX,CNORM,THL,ENGPRI,INFW,INFW)
          ETOTO=ETOT
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(CONVWF.OR.EXSOFT) GOTO 100
      ENDDO
      IF(PARENT) WRITE(6,*) ' NO CONVERGENCE IN ',INFW,' STEPS '
      CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,NFI)
      CALL STOPGM('SECDER',' ')
C     ==--------------------------------------------------------------==
  100 CONTINUE
C..release memory for ground state optimiser
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_PME)
      CALL FREEM(IP_GDE)
C     NUCLEAR GRADIENT
      CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               N,1,.FALSE.,.TRUE.)
      CALL DSCAL(3*NAX*NSX,-1.0D0,FION(1,1,1),1)
      TIME2=TIMEF()
      TCPU=(TIME2-TIME1)*0.001D0
      IF(PARENT) THEN
         WRITE(6,'(A,F12.3,A)') ' TIME FOR MINIMUM STRUCTURE :',
     *               TCPU,' SECONDS'
        CALL WRENER
        CALL WRGEOF(TAU0,FION)
      ENDIF
      CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,NFI)
C     Open the FINDIF file
      IF(PARENT) THEN
        FILEN='FINDIF'
        CALL FILEOPEN(24,FILEN,FO_DEF,FERROR)
        IF(RVIB) REWIND(24)
      ENDIF
C..transform to canonical orbitals and get eigenvalues
      CALL CANON(C0,C2,F,N,EIGV,SCR,LSCR)
C..recalculate FNL and DFNL for transformed orbitals
C..we could also rotate the old ones, but this is easier
      CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.TRUE.)
C..store potential and density 
      CALL DCOPY(NNR1*NLSD,RHOE,1,POTR,1)
      CALL RHOOFR(C0,RHOE,PSI,SCR,LSCR,N)
      CALL DCOPY(NNR1*NLSD,RHOE,1,RHOO,1)
C..NLCC
      IF(TINLC) THEN
         CALL STOPGM("SDLINRES","NLCC not implemented")
      ENDIF
C..alocate, calculate, and save DDFNL
      LDFNL=6*NAT*NHXS*NDFNL
      IF(LDFNL.LE.0) LDFNL=1
      CALL MEMORY(IP_DDFNL,LDFNL,'DDFNL')
      CALL RNLSM_2D(C0,SCR,LSCR,N)
C..save FNL
      CALL FNL_SET("SAVE")
      CALL FNLALLOC(N,.TRUE.,.FALSE.)
C..calculate and store EIVPS and EIROP
      CALL EICALC(EIVPS,EIROP)
C..calculate and store analytic dmu/dn
      CALL LR_XCPOT(DDXC,RHOO,SCR,LSCR,.FALSE.)
C     ==--------------------------------------------------------------==
C..additional memory for optimisers
      NVPP = NGW
      IF(LOPTI.EQ.0) THEN
        NPME = MAX((NGW*N+8)*MDIIS,2*NGW*N)
        NPME = MAX(2*NGW*N*MLDIIS,NPME)
        NGDE = MAX(((NGW*N+8)*MDIIS)/4,1)
        NGDE = MAX(2*NGW*N*MLDIIS,NGDE)
      ELSEIF(LOPTI.EQ.1) THEN
        NPME = 1
        NGDE = 1
      ELSE IF(LOPTI.EQ.2) THEN
        NPME = 2*NGW*N
        NGDE = 1
      ELSE IF(LOPTI.EQ.3) THEN
        NPME = (NGW*N+8)*MDIIS
        NGDE = ((NGW*N+8)*MDIIS)/4
      ELSE
        IF(PARENT)
     *  WRITE(6,*) ' WRONG OPTION FOR LINEAR RESPONSE OPTIMIZATION'
        CALL STOPGM('SDLINRES',' ')
      ENDIF
      CALL MEMORY(IP_PME,NPME,'PME')
      CALL MEMORY(IP_GDE,NGDE,'GDE')
      CALL MEMORY(IP_VPP,NVPP,'VPP')
C..always use preconditioner
      PREC=.TRUE.
      CALL KSDIAG(VPP)
      TRACE=DASUM(N,EIGV,1)/DBLE(N)
!$OMP parallel do private(IG,VP) shared(TRACE,LR_HTHRS)
      DO IG=1,NGW
        VP=VPP(IG)+TRACE
        VPP(IG)=DABS(VP/(VP**2+LR_HTHRS**2))
      ENDDO
C     ==--------------------------------------------------------------==
C     ==         THE BASIC LOOP OVER PERTURBATIONS (COORDINATES)      ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(/," ",23("*"),A,24("*"),/)') ' LINEAR RESPONSE '
      ENDIF
C     No symmetrization in this part!
      NSYM=NROT
      NROT=1
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          DO K=1,3
            TIME1=TIMEF()
            IF(PARENT)
     *        WRITE(6,
     *        '(" **** ATOM=",I7,4X,A4,T49,A,A4)') 
     *        IAT,EL(IATYP(IS)),'PERTURBATION:',CDIR(K)
C..new perturbation
            IF(RVIB .AND. PARENT) THEN
              READ(24,FMT=*,END=300)
              DO IS2=1,NSP
                DO IA2=1,NA(IS2)
                  READ(24,*) (FION(K2,IA2,IS2),K2=1,3)
                ENDDO
              ENDDO
              GOTO 301
  300         CONTINUE
              RVIB=.FALSE.
              CALL FILECLOSE(24)
              CALL FILEOPEN(24,FILEN,FO_APP,FERROR)
            ENDIF
  301       CONTINUE
            MSGLEN = 1 * 8/IRAT
            CALL MY_BCAST(RVIB,MSGLEN,SOURCE,ALLGRP)
            IF(RVIB.AND..NOT.PARENT) CALL AZZERO(FION,3*NAX*NSX)
            IF(.NOT.RVIB) THEN
              ISYMUAT=0
              IF(INDPG.NE.0) THEN
                IF(ISYMU(IAT).EQ.0) THEN
                  CALL AZZERO(FION,3*NAX*NSX)
                  ISYMUAT=1
                ENDIF
              ENDIF
              IF(ISYMUAT.EQ.0.AND.LSKCOR(K,IAT).NE.0) THEN
C---------------------------------------------------------------------==
C..this is the response part
                EIND=0.D0
                CALL EIND_II(TAU0,IS,IA,K,EIND,IESR)
                CALL EIND_LOC(EIND,IS,IAT,K,RHOO,PSI,EIROP)
C..calculate constant force from NL-PP
                CALL FNL_SET("SWITCH")
                CALL NL_RES(IS,IAT,K,H1NL,N,SCR,LSCR)
                CALL EIND_NL(EIND,IS,IAT,K,N)
                CALL FNL_SET("SWITCH")
C..calculate the constant part of the local potential
                CALL EICALC1(K,IS,IAT,EIVPS1,EIROP1)
C..calculate first order wavefunction
                SDIIS=.TRUE.
                SPCG=.TRUE.
                CALL OPT_LR(C0,C1,C2,SC0,EIND,EIGV,RHOE,
     &                      H1NL,EIVPS1,EIROP1,DDXC,VPP,PME,GDE,
     &                      PSI,SCR,LSCR,N,"PHONON","CANON")
C..calculate first order density
                CALL RHO1OFR(C0,C1,F,RHOE,PSI,N)
C..contribution from local potentials
                CALL AZZERO(FION,3*NAX*NSX)
                CALL SD_LOC(FION,RHOE,PSI,EIROP1)
C..calculate the FNL and DFNL for C1
                CALL RNLSM(C1,N,PSI,SCR,LSCR,1,1,.TRUE.)
                CALL GET_ADDR(IP_FNL1,FNL(1))
                CALL GET_ADDR(IP_FNL3,FNL2(1))
                CALL GET_ADDR(IP_DFNL1,DFNL(1))
                CALL FNL_SET("SWITCH")
                CALL SD_NL(FION,F,FNL,FNL2,DFNL,FNL1,FNL3,DFNL1,N)
                CALL FNL_SET("SWITCH")
C..end of the response part
C---------------------------------------------------------------------==
C..Write response to disk
                CALL DCOPY(3*NAX*NSX,FION,1,TSCR,1)
                CALL GLOSUM(3*NAX*NSX,TSCR)
                IF(PARENT) THEN
                  WRITE(24,'(3I10)') IS,IA,K
                  DO IS2=1,NSP
                    DO IA2=1,NA(IS2)
                      WRITE(24,*) (TSCR(K2,IA2,IS2),K2=1,3)
                    ENDDO
                  ENDDO
                  CALL MY_FLUSH(24)
                ENDIF
              ELSE
                IF(PARENT)
     *          WRITE(6,'(A)') ' Pertubation related by symmetry'
              ENDIF
              IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
              IF(EXSOFT) GOTO 200
            ELSE
              IF(PARENT)
     *        WRITE(6,'(T33,A)') 'Result read from file FINDIF'
            ENDIF
C           Update Hessian
            ICOL=3*(IAT-1)+K
            IAT2=0
            DO IS2=1,NSP
              DO IA2=1,NA(IS2)
                IAT2=IAT2+1
                DO K2=1,3
                  IX=3*(IAT2-1)+K2
                  SDER(IX,ICOL)=FION(K2,IA2,IS2)
                ENDDO
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      NROT=NSYM
C     ==--------------------------------------------------------------==
      CALL FNLDEALLOC(.FALSE.,.FALSE.)
      CALL FNL_SET("RECV")
C..contribution from ESR
      CALL SD_II(TAU0,SDER,IESR,IATO)
C..contribution from <psi_0|V(2)|psi_0>
C..local part(there are diagonal terms only)
      CALL SD_LOC2(SDER,RHOO,PSI,IATO,EIROP)
C..nonlocal part(there are diagonal terms only)
      CALL SD_NL2(SDER,IATO,N)
      CALL FREEM(IP_DDFNL)
C     ==--------------------------------------------------------------==
      CALL GLOSUM(9*NAT*NAT,SDER)
      IF(PARENT) THEN
        CALL FILECLOSE(24)
C       Symmetrize Hessian
        IF( INDPG.NE.0.AND.(NROT.NE.1.OR.NTVEC.GT.1) ) THEN
          CALL SYMMAT(SDER,SCR,LSCR,2)
        ENDIF
        CALL SYMMA(SDER,3*NAT)
C       Write Hessian to file HESSIAN
        IF(NODIM.EQ.3*NAT) THEN
          CALL DCOPY(NODIM*NODIM,SDER(1,1),1,HESS(1,1),1)
          CALL HESSOUT
        ELSE
          CALL DCOPY(9*NAT*NAT,SDER(1,1),1,HESS(1,1),1)
        ENDIF
C       Write output file for MOLVIB program
        CALL MOLVIB(TAU0,SDER)
C       Mass weighted force constants
        IX=0
        DO IS=1,NSP
          XMASS=SQRT(1.D0/PMA0(IS))
          DO IA=1,NA(IS)
            DO K=1,3
              IX=IX+1
              XMA(IX)=XMASS
            ENDDO
          ENDDO
        ENDDO
!$OMP parallel do private(I,J)
        DO I=1,3*NAT
          DO J=1,3*NAT
            SDER(I,J)=SDER(I,J)*XMA(I)*XMA(J)
          ENDDO
        ENDDO
C       Diagonalization
        NAUX=9*NAT*NAT
        INFO=0
        CALL DSYEV('V','U',3*NAT,SDER,3*NAT,VIBE,SCR,NAUX,INFO)
        IF(INFO.NE.0) CALL STOPGM('SECDER','DSYEV INFO')
!$OMP parallel do private(I)
        DO I=1,3*NAT
          VIBE(I)=SIGN(5140.487D0*DSQRT(DABS(VIBE(I))),VIBE(I))
        ENDDO
        WRITE(6,'(/," ",64("*"),/,A,/)')
     &       ' HARMONIC FREQUENCIES [cm**-1]:'
        WRITE(6,'(4(F16.4))') (VIBE(I),I=1,3*NAT)
C       Write output file for Eigenvectors   
        CALL VIBEIG(VIBE,SDER,3*NAT,.TRUE.)
C PURIFICATION
        WRITE(6,'(/,A)') ' PURIFICATION OF DYNAMICAL MATRIX'
        CALL DCOPY(9*NAT*NAT,HESS,1,SDER,1)
ctu     purification only AFTER mass weighting of the Hessian
ctu     CALL PURGED(SDER,HESS,TAU0)
!$OMP parallel do private(I,J)
        DO I=1,3*NAT
          DO J=1,3*NAT
            SDER(I,J)=SDER(I,J)*XMA(I)*XMA(J)
          ENDDO
        ENDDO
        CALL PURGED(SDER,HESS,TAU0)
C       Diagonalization
        NAUX=9*NAT*NAT
        INFO=0
        CALL DSYEV('V','U',3*NAT,SDER,3*NAT,VIBE,SCR,NAUX,INFO)
        IF(INFO.NE.0) CALL STOPGM('SECDER','DSYEV INFO')
!$OMP parallel do private(I)
        DO I=1,3*NAT
          VIBE(I)=SIGN(5140.487D0*DSQRT(DABS(VIBE(I))),VIBE(I))
        ENDDO
        WRITE(6,'(/," ",64("*"),/,A,/)')
     &       ' HARMONIC FREQUENCIES [cm**-1]:'
        WRITE(6,'(4(F16.4))') (VIBE(I),I=1,3*NAT)
C       Write output file for Eigenvectors   
        CALL VIBEIG(VIBE,SDER,3*NAT,.FALSE.)
        IF (VOUT) CALL MLDGAU(VIBE,SDER,3*NAT,TAU0)
        IF (ACOUT) CALL WRITEACLIMAX(VIBE,SDER,3*NAT,TAU0)
      ENDIF
  200 CONTINUE
      CALL FREEM(IP_FION)
      CALL FREEM(IP_TSCR)
      CALL FREEM(IP_IATO)
      IF(PARENT) THEN
        CALL FREEM(IP_VIBE)
        CALL FREEM(IP_XMA) 
      ENDIF
      CALL FREEM(IP_H1NL)
      CALL FREEM(IP_EIROP1)
      CALL FREEM(IP_EIVPS1)
      CALL FREEM(IP_DDXC)
      CALL FREEM(IP_EIROP)
      CALL FREEM(IP_EIVPS)
      CALL FREEM(IP_SDER)
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_RHOO)
      CALL FREEM(IP_POTR)
      IP_POTR=0
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
C..release memory for LR optimiser
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_PME)
      CALL FREEM(IP_GDE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_SDLINRES(LSECDER,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !TDIAG NONORT TPRES
      INCLUDE 'elct.inc'        !N
      INCLUDE 'ions.inc'        !NAT
      INCLUDE 'store.inc'       !RESTART RVIB
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'        !TTROT
      INCLUDE 'symm.inc'        !INDPG ROT
C     Arguments
      INTEGER LSECDER
      CHARACTER*30 TAG
C     Variables
      INTEGER NSTATE,LINITRUN,LCOPOT,LORTHO,LRNLSM,LRHOOFR,
     &        LUPDATE,LFORCES,LSYMMAT,LCANON,LFNONLOC_P,
     &        LRNLSM_2D,LOPT_LR,LNL_RES
C     ==--------------------------------------------------------------==
      NSTATE=N
      LINITRUN=0
      LFORCES=0
      LCOPOT=0
      LORTHO=0
      LUPDATE=0
      LCANON=0
      LSYMMAT=0
      LRHOOFR=0
      LRNLSM=0
      LRNLSM_2D=0
      LOPT_LR=0
      LFNONLOC_P=0
C
      CALL GIVE_SCR_INITRUN(LINITRUN,TAG)
      CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.FALSE.,.TRUE.)
      IF(TINLC) CALL GIVE_SCR_COPOT(LCOPOT,TAG)
      CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      CALL GIVE_SCR_UPDWF(LUPDATE,TAG,NSTATE,.FALSE.)
      CALL GIVE_SCR_CANON(LCANON,TAG,NSTATE)
      CALL GIVE_SCR_SYMMAT(LSYMMAT,TAG)
      CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
      CALL GIVE_SCR_NL_RES(LNL_RES,NSTATE,TAG)
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.TRUE.)
      CALL GIVE_SCR_RNLSM_2D(LRNLSM_2D,TAG,NSTATE)
      CALL GIVE_SCR_OPT_LR(LOPT_LR,"PHONON",TAG)
C
      LSECDER=MAX(9*NAT*NAT+9*NAT,LINITRUN,LFORCES,LCOPOT,
     &        LORTHO,LUPDATE,LCANON,LSYMMAT,LNL_RES,LRHOOFR,LRNLSM,
     &        LRNLSM_2D,LOPT_LR,LFNONLOC_P)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
