C     ==================================================================
      SUBROUTINE SECDER(C0,C1,C2,SC0,CG0,PME,GDE,VPP,EIGV)
C     ==--------------------------------------------------------------==
C     ==  VIBRATIONAL ANALYSIS                                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'ener.inc' 
      INCLUDE 'elct.inc' 
      INCLUDE 'tpar.inc' 
      INCLUDE 'pslo.inc' 
      INCLUDE 'ions.inc' 
      INCLUDE 'soft.inc' 
      INCLUDE 'norm.inc' 
      INCLUDE 'ropt.inc' 
      INCLUDE 'cppt.inc' 
      INCLUDE 'coor.inc' 
      INCLUDE 'sfac.inc' 
      INCLUDE 'cotr.inc' 
      INCLUDE 'adat.inc' 
      INCLUDE 'rmas.inc' 
      INCLUDE 'nlcc.inc' 
      INCLUDE 'symm.inc' 
      INCLUDE 'irat.inc'
      INCLUDE 'andr.inc' 
      INCLUDE 'andp.inc' 
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc' 
      INCLUDE 'poin.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'store.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'prop.inc'
      INCLUDE 'dipo.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'bsym.inc'
      INCLUDE 'bsympnt.inc'
C     Arguments
      COMPLEX*16 C0(NGWK,N,*),C1(*),C2(NGWK,N,*),
     &           SC0(NGWK,N,*),CG0(NGWK,N,*),PME(*),GDE(*)
      REAL*8     VPP(*),EIGV(N,*)
C     Variables
      DIMENSION  RIN0(*)
      REAL*8     TSCR(3,NAX,NSX),FDIS(3,NAX,NSX,2),SDER(3*NAT,3*NAT),
     &           XMA(3*NAX*NSX),VIBE(3*NAT)
      POINTER    (IP_TSCR,TSCR),(IP_FDIS,FDIS),(IP_SDER,SDER),
     &           (IP_XMA,XMA),(IP_VIBE,VIBE)
      COMPLEX*16 PSI(NNR1,NLSD)
      REAL*8     RHOE(NNR1,NLSD),SCR(*),RINB(NNR1,NLSD)
      POINTER    (IP_PSI,PSI),(IP_RHOE,RHOE),(IP_SCR,SCR)
      POINTER    (IP_RINB,RINB)
      REAL*8     FNL(*),DFNL(*)
      INTEGER    IREC(100)
      CHARACTER  FILEN*100,FILEN1*100,TAG*30,
     &           CDIR(3)*1
      DATA       CDIR /'X','Y','Z'/
      LOGICAL    READHE,TINFO,FERROR,CVBSWF,CVHSWF
      INTEGER    NNX,NHPSI,NSYM,IAT,IS,IA,IDELT,K,IS2,IA2,INFO,
     &           K2,ISYMUAT,ID,ICOL,IAT2,IX,I,J,NAUX,NMM,
     &           LSCR,IL_RHOE,IL_PSI
      REAL*8     TIME1,EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,ETOTO,ETOTG,
     &           TIME2,TCPU,DETOT,THL,XMASS,XLM,YLM,ZLM,DIST,
     &           TIMEF,EKINH1,EKINH2,ETOTHS,ETOTBS
      EXTERNAL   TIMEF
      INTEGER    MSGLEN
C     VARIABLES FOR DIPOLE MOMENTS
      COMPLEX*16 EIROP(NHG),CM(NGWK,*)
      INTEGER    IL_EIROP, MODE
      POINTER    (IP_EIROP,EIROP), (IP_CM,CM)
      REAL*8     DIP(3,NAT,2), DIPDER(3,3*NAT),D1,D2,D3,DD
      REAL*8     IR(3,3*NAT)
      INTEGER    NXXFUN
C     ==================================================================
      TIME1 = TIMEF()
      TINFO=.FALSE.
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TSCR,3*NAX*NSX,'TSCR')
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      IF(PARENT) THEN
        CALL MEMORY(IP_XMA,3*NAX*NSX,'XMA')
        CALL MEMORY(IP_VIBE,3*NAT,'VIBE')
        CALL MEMORY(IP_FDIS,6*NAX*NSX,'FDIS')
        CALL MEMORY(IP_SDER,9*NAT*NAT,'SDER')
      ENDIF
      IF(TDIAG) THEN
        NNX=NNR1*NLSD
        CALL MEMORY(IP_RINB,NNX,'RIN0')
        CALL MEMORY(IP_RIN0,NNX,'RIN0')
        CALL MEMORY(IP_ROUT0,NNX,'ROUT0')
        CALL MEMORY(IP_RMIX,NNX,'RMIX')
        CALL GET_ADDR(IP_RHOO,RIN0(1))
      ELSEIF(TKPNT) THEN
        NNX=NNR1*NLSD
        CALL MEMORY(IP_RIN0,NNX,'RIN0')
        CALL MEMORY(IP_RMIX,NNX,'RMIX')
      ENDIF
      IF(BSYMM)CALL MEMORY(IP_FNBS,3*NAX*NSX,'FNBS')
      CALL AZZERO(TSCR,3*NAX*NSX)
      NACC = 7
      ECNSTR = 0.0D0
      ERESTR = 0.0D0
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      CALL MEMORY(IP_RHOE,IL_RHOE,'RHOE')
      NMM=1
      IF(TDDFT) THEN
        CALL MEMORY(IP_RHOO,IL_RHOE,'RHOO')
        CALL MEMORY(IP_POTR,IL_RHOE,'POTR')
        IF(NS_TRI.GT.0) NMM=2
      ENDIF
      NMM=NMM*IL_PSI
      CALL MEMORY(IP_PSI,NMM,'PSI')
      CALL GIVE_SCR_SECDER(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
C     EXTRA MEMORY REQUIRED FOR DIPOLE MOMENTS
      IF(DBERRY.AND.TKPNT) THEN
        IF(PARENT) WRITE(6,'(/,1X,A,23X,A,23X,A,/,1X,A,/,1X,A,/)')
     $     '******','WARNING','******',
     $     'DIPOLE MOMENTS WITH K-POINTS: PLEASE FINISH WRITING KDDIPO',
     $     'DISABLING DIPOLE MOMENTS FOR NOW'
        DBERRY=.FALSE.
        LDIP=.FALSE.
      ENDIF
      IF(DBERRY) THEN
        LENBK=NXXFUN(NUMORB)
        CALL MEMORY(IP_CM,2*NGWK*N*NKPNT+8,'CM')
      ELSE IF(LDIP) THEN
        IL_EIROP=NHG*2
        CALL MEMORY(IP_EIROP,IL_EIROP,'EIROP')
      ENDIF
C     ==--------------------------------------------------------------==
C     TIME STEP FUNCTIONS
      CALL DYNIT(EKINCP,EKIN1,EKIN2,TEMP1,TEMP2,EKINH1,EKINH2)
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
C     ==--------------------------------------------------------------==
      BSCLCS=1
      IF(BSYMM)CALL SETBSSTATE
      IF(BSYMM.and.PARENT) THEN
        PRINT *
        WRITE(6,*) 'BSYMM: BS WAVEFUNCTION INITIALIZATION'
      ENDIF
      CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
      IF(BSYMM) THEN
        IF(PARENT) WRITE(6,*) 'BSYMM: HS WAVEFUNCTION INITIALIZATION'
        BSCLCS=2
        CALL SETBSSTATE
        CALL INITRUN(IREC,C0(1,1,2),C2(1,1,2),SC0(1,1,2),RHOE,PSI,
     &       EIGV(1,2),SCR,LSCR)
      ENDIF
      CALL WRITE_IREC(IREC)
C     END INITIALIZATION
C..  Do not symmetrize density...  
      TSYMRHO=.FALSE.
C..Make sure TKFULL=.TRUE
      IF(TKPNT.AND.(.NOT.TKFULL).AND.PARENT) THEN 
        WRITE(6,*) 
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        WRITE(6,*) 
     & ' WARNING!  USE KPOINTS FULL  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        WRITE(6,*) 
     & ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
      ENDIF
C..
      ETOTO=0.D0
      EBOGO=0.D0
      IF(PARENT) CALL DETDOF(TAU0,TSCR)
      NPARA=-1
      READHE=.FALSE.
      IF(PARENT) CALL HESSIN(TAU0,READHE)
      ETOTG=0.0D0
      CALL WRITE_IREC(IREC)
      IF(PARENT) THEN
        TIME2 = TIMEF()
        TCPU = (TIME2 - TIME1)*0.001D0
        WRITE(6,'(A,F8.2,A)') ' TIME FOR INITIALIZATION',
     &       TCPU,' SECONDS'
      ENDIF
C     ==--------------------------------------------------------------==
C     ==      OPTIMIZATION OF WAVEFUNCTION AT MINIMUM STRUCTURE       ==
C     ==--------------------------------------------------------------==
      IF(PARENT)
     *  WRITE(6,'(/," ",22("*"),A,23("*"),/)') ' MINIMUM STRUCTURE '
      CONVWF=.FALSE.
      CVBSWF=.FALSE.
      CVHSWF=.FALSE.
      SDIIS=.TRUE.
      SPCG=.TRUE.
      TIME1=TIMEF()

      DO INFW=1,NOMORE
        IF(TDIAG) THEN
          IF(BSYMM)THEN
             CALL STOPGM('SECDER','BSYMM .AND. TDIAG NOT IMPLEMENTED')
          ELSE 
             CALL UPDRHO(C0,C2,GDE,SC0,PME,VPP,TAU0,FION,EIGV,
     &                RHOE,PSI,SCR,LSCR,
     &                N,.FALSE.,.TRUE.,.FALSE.,INFW,THL,NHPSI)
          END IF
C..store initial density
          CALL DCOPY(NNX,RIN0,1,RINB,1)
        ELSE
          IF(.NOT.BSYMM)THEN
C         UPDATE THE WAVEFUNCTIONS
            IF(TKPNT) THEN
              CALL K_UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     *                     RHOE,PSI,SCR,LSCR,N,.FALSE.,INFI)
            ELSE
              CALL UPDWF(C0,C2,SC0,TAU0,TSCR,PME,GDE,VPP,EIGV,
     *                   RHOE,PSI,SCR,LSCR,N,.FALSE.,.true.)
            ENDIF
          ELSE
!            Update HS WF for Brokensymmetry
             IF(.NOT.CVHSWF) THEN
                IF(INFW.EQ.1) THEN
                   BSCLCS=2
                   CALL SETBSSTATE
                ENDIF
                CALL UPDWF(C0(1,1,2),C2(1,1,2),SC0(1,1,2),TAU0,
     &                     FION,PME,GDE,VPP,EIGV(1,2),RHOE,
     &                     PSI,SCR,LSCR,N,.FALSE.,.true.)
                CVHSWF=CONVWF
!            Update BS WF for Brokensymmetry
             ELSEIF(.NOT.CVBSWF) THEN
                IF(BSCLCS.EQ.2) THEN
                   IF(PARENT) 
     &                WRITE(6,*) 'BSYMM: HS STATE CONVERGED. ',
     &                           'SWITCHING TO BS STATE.'
                   ETOTO=0.0D0
                   BSCLCS=1
                   CALL SETBSSTATE
                   CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,
     &                        VPP,EIGV,RHOE,PSI,SCR,LSCR,N,
     &                       .FALSE.,.true.)
                   IF(TINFO.and.PARENT) THEN
                      CALL WRENER
                      WRITE(6,'(2A)')
     &                    ' NFI      GEMAX       CNORM',
     &                    '           ETOT        DETOT      TCPU'
                   ENDIF
                ELSE
                 CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,
     &                      VPP,EIGV,RHOE,PSI,SCR,LSCR,N,
     &                      .FALSE.,.true.)
                END IF
                CVBSWF=CONVWF
             ENDIF
             CONVWF=CVHSWF.AND.CVBSWF
          END IF
        ENDIF
C       PRINTOUT THE EVOLUTION OF THE ITERATIVE OPTIMIZATION
        IF(PARENT) THEN
          DETOT=ETOT-ETOTO
          IF(INFW.EQ.1) DETOT=0.0D0
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
          CALL WRPRINT_WFOPT(EIGV(1,BSCLCS),F,AMU,N,ETOT,ETOTO,
     &                       TCPU,GEMAX,CNORM,THL,ENGPRI,INFW,INFW)
          ETOTO=ETOT
        ENDIF
        CALL TESTEX(EXSOFT)
        IF(CONVWF.OR.EXSOFT) GOTO 100
      END DO

      IF(PARENT) WRITE(6,*) ' NO CONVERGENCE IN ',INFW,' STEPS '
      CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,NFI)
      CALL STOPGM('SECDER',' ')
C     ==--------------------------------------------------------------==
  100 CONTINUE
C     NUCLEAR GRADIENT
      IF(TDIAG) THEN
        CALL AZZERO(FION,3*NAX*NSX)
        CALL UPDRHO(C0,C2,GDE,SC0,PME,VPP,TAU0,FION,EIGV,
     &              RHOE,PSI,SCR,LSCR,
     *              N,.TRUE.,.TRUE.,TPRES,INFI,THL,NHPSI)
      ELSE
        BSCLCS=1
        IF(BSYMM)CALL SETBSSTATE
        IF(TKPNT) THEN
           CALL K_UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,
     *          EIGV,RHOE,PSI,SCR,LSCR,N,.TRUE.,INFI)
        ELSE
          CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *         N,1,.TRUE.,.TRUE.)
        ENDIF
        ETOTBS=ETOT
        IF(BSYMM)THEN
          IF(PARENT)CALL DCOPY(3*NAX*NSX,FION,1,FNBS,1)
          BSCLCS=2
          CALL SETBSSTATE
          CALL FORCEDR(C0(1,1,2),C2(1,1,2),SC0(1,1,2),RHOE,PSI,TAU0,
     *               FION,EIGV,SCR,LSCR,N,1,.TRUE.,.TRUE.)
          ETOTHS=ETOT
          ETOT = (1.0d0+CNSTWGT)*ETOTBS-CNSTWGT*ETOTHS
          IF(PARENT)CALL LSFORCE(FNBS,FION)
          MSGLEN = 3*NAX*NSX * 8
          CALL MY_BCAST(FION,MSGLEN,SOURCE,ALLGRP)
        END IF
      ENDIF
      CALL DSCAL(3*NAX*NSX,-1.0D0,FION(1,1,1),1)
      TIME2=TIMEF()
      TCPU=(TIME2-TIME1)*0.001D0
      IF(PARENT) THEN
         WRITE(6,'(A,F12.3,A)') ' TIME FOR MINIMUM STRUCTURE :',
     *               TCPU,' SECONDS'
        CALL WRENER
        CALL WRGEOF(TAU0,FION)
      ENDIF
      CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,NFI)
      CALL DCOPY(2*NGWK*N*NKPNT*BSCLCS,C0,1,CG0,1)
      CALL DCOPY(3*NAX*NSP,TAU0(1,1,1),1,TAUP(1,1,1),1)
C     GET DIPOLE MOMENT FOR MINIMUM STRUCTURE
      IF(DBERRY) THEN
        IF(TKPNT) THEN
          CALL KDDIPO(TAU0,C0,CM,C2,SC0,SCR,LSCR,N)
        ELSE
          CALL DDIPO(TAU0,C0,CM,C2,SC0,SCR,LSCR,N)
        ENDIF
      ELSE IF(LDIP) THEN
        CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.FALSE.)
        IF(TKPNT) THEN
          CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,N)
        ELSE
          CALL RHOOFR  (C0,RHOE,PSI,SCR,LSCR,N)
        ENDIF
c       CALL EICALC(SCR,EIROP)
        CALL RSDIPO(TAU0,EIROP,PSI,RHOE)
      ENDIF
      IF (PARENT.AND.(LDIP.OR.DBERRY)) THEN
         WRITE(6,'(A)') ' DIPOLE MOMENT '
         D1=DMOM(1)
         D2=DMOM(2)
         D3=DMOM(3)
         DD=SQRT(D1*D1+D2*D2+D3*D3)
         WRITE(6,'(3(10X,A),6X,A)') ' X',' Y',' Z',' TOTAL'
         WRITE(6,'(4F12.5,A)') D1,D2,D3,DD,'   atomic units'
         WRITE(6,'(4F12.5,A)')AU_DEB*D1,AU_DEB*D2,AU_DEB*D3,
     &                        AU_DEB*DD,'  Debye'
         WRITE(6,*)
      ENDIF
C     Open the FINDIF and FDDIP file
      FILEN='FINDIF'
      FILEN1='FDDIP'
      IF(PARENT) THEN
        CALL FILEOPEN(24,FILEN,FO_DEF,FERROR)
        IF(RVIB) REWIND(24)
        IF(LDIP.OR.DBERRY) THEN
          CALL FILEOPEN(25,FILEN1,FO_DEF,FERROR)
          IF(RVIB) REWIND(25)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C     ==         THE BASIC LOOP OVER PERTURBATIONS (COORDINATES)      ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        WRITE(6,'(/," ",22("*"),A,22("*"),/)') ' FINITE DIFFERENCES '
        IF(TREF_FDIFF) THEN
          WRITE(6,'(A,T30,3(F12.3))') 'REFERENCE:',COORD_FDIFF
          WRITE(6,'(A,T54,F12.3)') 'RADIUS OF THE SPHERE:',R_FDIFF
          WRITE(6,'(A)')
     &         'WE COMPUTE ONLY THE FINITE DIFFERENCES FOR ATOMS'
          WRITE(6,'(A)')
     &         'INSIDE THIS SPHERE.'
        ENDIF
      ENDIF
C     No symmetrization of gradients in this part!
      NSYM=NROT
      NROT=1
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          IF (TREF_FDIFF) THEN
            XLM=TAU0(1,IA,IS)-COORD_FDIFF(1)
            YLM=TAU0(2,IA,IS)-COORD_FDIFF(2)
            ZLM=TAU0(3,IA,IS)-COORD_FDIFF(3)
            CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
            DIST = SQRT(XLM*XLM+YLM*YLM+ZLM*ZLM)
            IF(DIST.GT.R_FDIFF) THEN
              GOTO 31416
            ELSE
              IF(PARENT)
     &          WRITE(6,'(A,I7,4X,A4,4X,A,T54,1PE12.5)')
     &             " **** ATOM=",IAT,EL(IATYP(IS)),"DISTANCE=",DIST
            ENDIF
          ENDIF
          DO K=1,3
            DO IDELT=-1,1,2
              TIME1=TIMEF()
              IF(PARENT)
     *           WRITE(6,
     &             '(" **** ATOM=",I7,4X,A4,4X,A4,4X,A,T54,1PE12.5)') 
     *          IAT,EL(IATYP(IS)),CDIR(K),'DISPLACEMENT=',FDIFF*IDELT
C             NEW GEOMETRY            
              IF(RVIB .AND. PARENT) THEN
                READ(24,FMT=*,END=300)
                DO IS2=1,NSP
                  DO IA2=1,NA(IS2)
                    READ(24,*) (FION(K2,IA2,IS2),K2=1,3)
                  ENDDO
                ENDDO
                ID=(IDELT+1)/2 + 1
                IF(LDIP.OR.DBERRY) READ(25,*) (DIP(K2,IAT,ID),K2=1,3)
                GOTO 301
  300           CONTINUE
                RVIB=.FALSE.
                CALL FILECLOSE(24)
                CALL FILEOPEN(24,FILEN,FO_APP,FERROR)
                IF(LDIP.OR.DBERRY) THEN
                  CALL FILECLOSE(25)
                  CALL FILEOPEN(25,FILEN,FO_APP,FERROR)
                ENDIF
              ENDIF
  301         CONTINUE
              MSGLEN = 1 * 8/IRAT
              CALL MY_BCAST(RVIB,MSGLEN,SOURCE,ALLGRP)
              IF(.NOT.RVIB) THEN
                ISYMUAT=0
                IF(INDPG.NE.0) THEN
                  IF(ISYMU(IAT).EQ.0) THEN
                    CALL AZZERO(FION,3*NAX*NSX)
                    ISYMUAT=1
                  ENDIF
                ENDIF
                IF(ISYMUAT.EQ.0.AND.LSKCOR(K,IAT).NE.0) THEN
                  CALL DCOPY(3*NAX*NSP,TAUP(1,1,1),1,TAU0(1,1,1),1)
                  TAU0(K,IA,IS)=TAU0(K,IA,IS)+IDELT*FDIFF
                  CALL DCOPY(2*NGWK*N*NKPNT*BSCLCS,CG0,1,C0,1)
                  IF(TRANE) CALL RRANE(C0,C2,N)
                  IF(BSYMM.AND.TRANE)CALL RRANE(C0(1,1,2),C2(1,1,2),N)
                  CALL PHFAC(TAU0)
                  IF(TINLC) CALL COPOT(RHOE,PSI,SCR,LSCR,.FALSE.)
                  IF(.NOT.BSYMM)THEN
                     IF(TIVAN)CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.FALSE.)
                     CALL ORTHO(N,C0,C2,SCR,LSCR)
                  ELSE
                     BSCLCS=1
                     CALL SETBSSTATE
                     IF(TIVAN)CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.FALSE.)
                     CALL ORTHO(N,C0,C2,SCR,LSCR)
                     BSCLCS=2
                     CALL SETBSSTATE
                     IF(TIVAN)CALL RNLSM(C0(1,1,2),N,PSI,SCR,
     *                             LSCR,1,1,.FALSE.)
                     CALL ORTHO(N,C0(1,1,2),C2(1,1,2),SCR,LSCR)
                  END IF
                  CONVWF=.FALSE.
                  CVHSWF=.FALSE.
                  CVBSWF=.FALSE.
                  SDIIS=.TRUE.
                  SPCG=.TRUE.
C                 NL-Projector Overlap Matrix
                  IF(TDIAG.AND.TTROT) THEN
                     CALL CALC_ALM(SCR,LSCR)
                  ENDIF
                  IF(TLANC) THEN
                     CALL SET_B2L()
                  ENDIF
                  DO INFW=1,NOMORE
                    IF(TDIAG) THEN
                      CALL UPDRHO(C0,C2,GDE,SC0,PME,VPP,TAU0,FION,EIGV,
     &                            RHOE,PSI,SCR,LSCR,
     *                            N,.FALSE.,TINFO,.FALSE.,
     &                            INFW,THL,NHPSI)
                    ELSE
C                     UPDATE THE WAVEFUNCTIONS
                      IF(.NOT.BSYMM)THEN
                        IF(TKPNT) THEN
                          CALL K_UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,
     *                            EIGV,RHOE,PSI,SCR,LSCR,N,.FALSE.,INFI)
                        ELSE
                          CALL UPDWF(C0,C2,SC0,TAU0,TSCR,PME,GDE,VPP,
     *                         EIGV,RHOE,PSI,SCR,LSCR,N,.FALSE.,.true.)
                        ENDIF
                      ELSE
!                       Update HS WF for Brokensymmetry
                        IF(.NOT.CVHSWF) THEN
                           IF(INFW.EQ.1) THEN
                             BSCLCS=2
                             CALL SETBSSTATE
                           ENDIF
                           CALL UPDWF(C0(1,1,2),C2(1,1,2),SC0(1,1,2),
     &                             TAU0,FION,PME,GDE,VPP,EIGV(1,2),RHOE,
     &                             PSI,SCR,LSCR,N,.FALSE.,.true.)
                           CVHSWF=CONVWF
!                          Update BS WF for Brokensymmetry
                        ELSEIF(.NOT.CVBSWF) THEN
                           IF(BSCLCS.EQ.2) THEN
                              IF(PARENT) 
     &                        WRITE(6,*) 'BSYMM: HS STATE CONVERGED. ',
     &                                   'SWITCHING TO BS STATE.'
                              ETOTO=0.0D0
                              BSCLCS=1
                              CALL SETBSSTATE
                              CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,
     &                                   VPP,EIGV,RHOE,PSI,SCR,LSCR,
     &                                   N,.FALSE.,.true.)
                              IF(TINFO.and.PARENT) THEN
                                 CALL WRENER
                                 WRITE(6,'(2A)')
     &                          ' NFI      GEMAX       CNORM',
     &                          '           ETOT        DETOT      TCPU'
                              ENDIF
                           ELSE
                              CALL UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,
     &                                   VPP,EIGV,RHOE,PSI,SCR,LSCR,
     &                                   N,.FALSE.,.true.)
                           ENDIF
                           CVBSWF=CONVWF
                        END IF
                        CONVWF=CVHSWF.AND.CVBSWF
                      END IF
                    ENDIF
                    IF(PARENT) THEN
                      DETOT=ETOT-ETOTO
                      IF(INFW.EQ.1) DETOT=0.0D0
                      TIME2=TIMEF()
                      TCPU=(TIME2-TIME1)*0.001D0
                      IF(TDIAG.AND.TINFO) THEN
                        CALL WRPRINT_WFOPT(EIGV(1,BSCLCS),F,AMU,N,ETOT,
     &                     ETOTO,TCPU,GEMAX,CNORM,THL,.FALSE.,INFW,INFW)
                      ELSEIF(TDIAG) THEN
                        WRITE(6,
     &                       '(T9,I4,T15,1PE12.3,T27,0PF12.6,T39,'//
     &                       '1PE12.3,T53,0PF5.2,T59,0PF7.2) ')
     &                       INFW,GEMAX,ETOT,DETOT,NHPSI/DBLE(N),TCPU
                      ELSE
                        WRITE(6,
     &                       '(T9,I4,T15,1PE12.3,T27,0PF15.6,T44,'//
     &                       '1PE12.3,T59,0PF7.2) ')
     &                                    INFW,GEMAX,ETOT,DETOT,TCPU
                      ENDIF
                      ETOTO=ETOT
                    ENDIF
                    CALL TESTEX(EXSOFT)
                    IF(EXSOFT) GOTO 200
                    IF(CONVWF) GOTO 101
                  ENDDO
  101             CONTINUE
C                 NUCLEAR GRADIENT
                  IF(TDIAG) THEN
                    CALL AZZERO(FION,3*NAX*NSX)
                    CALL UPDRHO(C0,C2,GDE,SC0,PME,VPP,TAU0,FION,EIGV,
     &                          RHOE,PSI,SCR,LSCR,
     &                          N,.TRUE.,.TRUE.,TPRES,INFI,THL,NHPSI)
                    CALL DCOPY(NNR1*NLSD,RINB,1,RIN0,1)
                  ELSE
                    BSCLCS=1
                    IF(BSYMM)CALL SETBSSTATE
                    IF(TKPNT) THEN
                      CALL K_UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,
     *                      EIGV,RHOE,PSI,SCR,LSCR,N,.TRUE.,INFI)
                    ELSE
                      CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,
     &                             SCR,LSCR,N,1,.TRUE.,.TRUE.)
                    ENDIF
                    IF(BSYMM)THEN
                       IF(PARENT)CALL DCOPY(3*NAX*NSX,FION,1,FNBS,1)
                       ETOTBS=ETOT
                       BSCLCS=2
                       CALL SETBSSTATE
                       CALL FORCEDR(C0(1,1,2),C2(1,1,2),SC0(1,1,2),RHOE,
     *                              PSI,TAU0,FION,EIGV,SCR,LSCR,N,1,
     *                              .TRUE.,.TRUE.)
                       ETOTHS=ETOT
                       ETOT = (1.0d0+CNSTWGT)*ETOTBS-CNSTWGT*ETOTHS
                       IF(PARENT)CALL LSFORCE(FNBS,FION)
                       MSGLEN = 3*NAX*NSX * 8
                       CALL MY_BCAST(FION,MSGLEN,SOURCE,ALLGRP)
                    END IF
                    IF(TDDFT)
     &                 CALL LR_TDDFT(C0,C1,C2,SC0,RHOE,PSI,TAU0,FION,
     &                               EIGV,SCR,LSCR,N,.TRUE.,IOUTPUT)
                  ENDIF
                  CALL DSCAL(3*NAX*NSX,-1.0D0,FION(1,1,1),1)
                ENDIF
c     WAVEFUNCTION AND FORCES DONE, NOW DIPOLE MOMENT
                IF(DBERRY) THEN
                  IF(TKPNT) THEN
                    CALL KDDIPO(TAU0,C0,CM,C2,SC0,SCR,LSCR,N)
                  ELSE
                    CALL DDIPO(TAU0,C0,CM,C2,SC0,SCR,LSCR,N)
                  ENDIF
                ELSE IF(LDIP) THEN
                  CALL RNLSM(C0,N,PSI,SCR,LSCR,1,1,.FALSE.)
                  IF(TKPNT) THEN
                    CALL RHOOFR_C(C0,RHOE,PSI,SCR,LSCR,N)
                  ELSE
                    CALL RHOOFR  (C0,RHOE,PSI,SCR,LSCR,N)
                  ENDIF
C                 CALL EICALC(SCR,EIROP)
                  CALL RSDIPO(TAU0,EIROP,PSI,RHOE)
                ENDIF
                IF (PARENT.AND.(LDIP.OR.DBERRY)) THEN
                   WRITE(6,'(A)') ' DIPOLE MOMENT '
                   ID=(IDELT+1)/2 + 1
                   D1=DMOM(1)
                   D2=DMOM(2)
                   D3=DMOM(3)
                   DIP(1,IAT,ID) = D1
                   DIP(2,IAT,ID) = D2
                   DIP(3,IAT,ID) = D3
                   DD=SQRT(D1*D1+D2*D2+D3*D3)
                   WRITE(6,'(3(10X,A),6X,A)') ' X',' Y',' Z',' TOTAL'
                   WRITE(6,'(4F12.5,A)') D1,D2,D3,DD,'   atomic units'
                   WRITE(6,'(4F12.5,A)')AU_DEB*D1,AU_DEB*D2,AU_DEB*D3,
     &                                  AU_DEB*DD,'  Debye'
                   WRITE(6,*)
                ENDIF   
C               WRITE GRADIENT AND DIPOLE MOMENT TO DISK
                IF(PARENT) THEN
                  WRITE(24,'(4I10,1PE20.10)') IS,IA,K,IDELT,FDIFF
                  DO IS2=1,NSP
                    DO IA2=1,NA(IS2)
                      WRITE(24,*) (FION(K2,IA2,IS2),K2=1,3)
                    ENDDO
                  ENDDO
                  CALL MY_FLUSH(24)
                  IF(LDIP.OR.DBERRY) THEN
                    WRITE(25,*) (DIP(K2,IAT,ID),K2=1,3)
                    CALL MY_FLUSH(25)
                  ENDIF
                ENDIF
              ENDIF
              IF(PARENT) THEN
                CALL GSIZE(FION,GNMAX,GNORM)
                ID=(IDELT+1)/2 + 1
                CALL DCOPY(3*NAX*NSX,FION(1,1,1),1,FDIS(1,1,1,ID),1)
                TIME2=TIMEF()
                TCPU=(TIME2-TIME1)*0.001D0
                WRITE(6,'(" ITER=",I6,T22,"ENERGY=",T46,F20.10)') 
     *               INFW,ETOT
                WRITE(6,
     &               '(" TCPU=",0PF9.2,T22,"GRADIENT=",T46,1PE20.3,/)')
     *               TCPU,GNORM
              ENDIF
              CALL TESTEX(EXSOFT)
              IF(EXSOFT) GOTO 200
            ENDDO
C     UPDATE HESSIAN
            IF(PARENT) THEN
              ICOL=3*(IAT-1)+K
              IAT2=0
              DO IS2=1,NSP
                DO IA2=1,NA(IS2)
                  IAT2=IAT2+1
                  DO K2=1,3
                    IX=3*(IAT2-1)+K2
                    SDER(IX,ICOL)=(FDIS(K2,IA2,IS2,2)-
     *                        FDIS(K2,IA2,IS2,1))/(2.0D0*FDIFF)
                  ENDDO
                ENDDO
              ENDDO
C     FINITE DIFFERENCES OF DIPOLE MOMENT
              IF(LDIP.OR.DBERRY) THEN
                DO K2=1,3
                  DIPDER(K2,ICOL) = ( DIP(K2,IAT,2) - DIP(K2,IAT,1) ) 
     .                / (2.0D0*FDIFF)
                ENDDO
              ENDIF
            ENDIF
          ENDDO
31416     CONTINUE
        ENDDO
      ENDDO
C     Reset coordinates
      CALL DCOPY(3*NAX*NSP,TAUP(1,1,1),1,TAU0(1,1,1),1)
      NROT=NSYM
      IF(PARENT) THEN
        CALL FILECLOSE(24)
        IF(LDIP.OR.DBERRY) CALL FILECLOSE(25)
C       Symmetrize Hessian
        IF( INDPG.NE.0.AND.(NROT.NE.1.OR.NTVEC.GT.1) ) THEN
          CALL SYMMAT(SDER,SCR,LSCR,2)
        ENDIF
        CALL SYMMA(SDER,3*NAT)
C       Write Hessian to file HESSIAN
        IF(NODIM.EQ.3*NAT) THEN
          CALL DCOPY(NODIM*NODIM,SDER(1,1),1,HESS(1,1),1)
          CALL HESSOUT
        ELSE
          CALL DCOPY(9*NAT*NAT,SDER(1,1),1,HESS(1,1),1)
        ENDIF
C       Write output file for MOLVIB program
        CALL MOLVIB(TAU0,SDER)
C       Mass weighted force constants
        IX=0
        DO IS=1,NSP
          XMASS=SQRT(1.D0/PMA0(IS))
          DO IA=1,NA(IS)
            DO K=1,3
              IX=IX+1
              XMA(IX)=XMASS
            ENDDO
          ENDDO
        ENDDO
!$OMP parallel do private(I,J)
        DO I=1,3*NAT
          DO J=1,3*NAT
            SDER(I,J)=SDER(I,J)*XMA(I)*XMA(J)
          ENDDO
        ENDDO
C       Diagonalization
        NAUX=9*NAT*NAT
        INFO=0
        CALL DSYEV('V','U',3*NAT,SDER,3*NAT,VIBE,SCR,NAUX,INFO)
        IF(INFO.NE.0) CALL STOPGM('SECDER','DSYEV INFO')
        DO I=1,3*NAT
          VIBE(I)=SIGN(5140.487D0*SQRT(ABS(VIBE(I))),VIBE(I))
        ENDDO
        WRITE(6,'(/," ",64("*"),/,A,/)')
     &       ' HARMONIC FREQUENCIES [cm**-1]:'
        WRITE(6,'(4(F16.4))') (VIBE(I),I=1,3*NAT)
C       Write output file for Eigenvectors   
        CALL VIBEIG(VIBE,SDER,3*NAT,.TRUE.)
C PURIFICATION
        WRITE(6,'(/,A)') ' PURIFICATION OF DYNAMICAL MATRIX'
        CALL DCOPY(9*NAT*NAT,HESS,1,SDER,1)
ctu     purification only AFTER mass weighting of the Hessian
ctu     CALL PURGED(SDER,HESS,TAU0)
!$OMP parallel do private(I,J)
        DO I=1,3*NAT
          DO J=1,3*NAT
            SDER(I,J)=SDER(I,J)*XMA(I)*XMA(J)
          ENDDO
        ENDDO
        CALL PURGED(SDER,HESS,TAU0)
C       Diagonalization
        NAUX=9*NAT*NAT
        INFO=0
        CALL DSYEV('V','U',3*NAT,SDER,3*NAT,VIBE,SCR,NAUX,INFO)
        IF(INFO.NE.0) CALL STOPGM('SECDER','DSYEV INFO')
!$OMP parallel do private(I)
        DO I=1,3*NAT
          VIBE(I)=SIGN(5140.487D0*DSQRT(DABS(VIBE(I))),VIBE(I))
        ENDDO
        WRITE(6,'(/," ",64("*"),/,A,/)')
     &       ' HARMONIC FREQUENCIES [cm**-1]:'
        WRITE(6,'(4(F16.4))') (VIBE(I),I=1,3*NAT)
C       Write output file for Eigenvectors   
        CALL VIBEIG(VIBE,SDER,3*NAT,.FALSE.)
        IF (VOUT) CALL MLDGAU(VIBE,SDER,3*NAT,TAU0)
        IF (ACOUT) CALL WRITEACLIMAX(VIBE,SDER,3*NAT,TAU0)
C       CALCULATE (DERIVATIVES OF) DIPOLE MOMENT IN BASIS OF EIGENMODES
        CALL AZZERO(IR,3*NODIM)
        DO MODE=1,NODIM
           DO J=1,NODIM
              IR(1,MODE) = IR(1,MODE) + DIPDER(1,J) * SDER(J,MODE) 
              IR(2,MODE) = IR(2,MODE) + DIPDER(2,J) * SDER(J,MODE) 
              IR(3,MODE) = IR(3,MODE) + DIPDER(3,J) * SDER(J,MODE) 
           ENDDO
        ENDDO
C     WRITE BORN EFFECTIVE CHARGES AND IR INTENSITIES
        IF(LDIP.OR.DBERRY) THEN
          WRITE(6,'(/," ",64("*"),/,A,/)')
     &          ' BORN EFFECTIVE CHARGE TENSOR (NOT SYMMETRIZED):'
          IF(3*NAT.EQ.NODIM) THEN
            IAT=0
            J=0
            DO IS=1,NSP
              DO IA=1,NA(IS)
                IAT=IAT+1
                WRITE(6,
     $          '(I5,1X,A,3X,3F10.5,/,6X,A,3X,3F10.5,/,6X,A,3X,3F10.5)')
     $               IAT, 'X', (DIPDER(K2,1+J), K2=1,3),
     $                    'Y', (DIPDER(K2,2+J), K2=1,3),
     $                    'Z', (DIPDER(K2,3+J), K2=1,3)
                J=J+3
              END DO
            END DO
          ELSE
            DO J = 1,NODIM
              WRITE(6,'(3F10.6)') (DIPDER(K2,J), K2=1,3)
            END DO
          ENDIF
          WRITE(6,'(/," ",64("*"),/,A,/)') ' RELATIVE IR INTENSITIES:'
          WRITE(6,'(A,2X,3(10X,A),6X,A)') '      FREQ',' X',' Y',' Z',
     &                                     ' TOTAL'
          DO J=1,NODIM
            D1 = IR(1,J)
            D2 = IR(2,J)
            D3 = IR(3,J)
            DD=DSQRT(D1*D1+D2*D2+D3*D3)
            WRITE(6,'(5F12.5)') VIBE(J),D1,D2,D3,DD
          ENDDO
        ENDIF
      ENDIF
  200 CONTINUE
      CALL FREEM(IP_FION)
      CALL FREEM(IP_TSCR)
      CALL FREEM(IP_TAUP)
      IF(TDIAG) THEN
        CALL FREEM(IP_RIN0)
        CALL FREEM(IP_ROUT0)
        CALL FREEM(IP_RMIX)
      ELSEIF(TKPNT) THEN
        CALL FREEM(IP_RIN0)
        CALL FREEM(IP_RMIX)
      ENDIF
      IF(PARENT) THEN
        CALL FREEM(IP_FDIS)
        CALL FREEM(IP_SDER)
        CALL FREEM(IP_VIBE)
        CALL FREEM(IP_XMA) 
      ENDIF
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_SCR)
      IF(BSYMM)CALL FREEM(IP_FNBS)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MOLVIB(TAU0,SDER)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'ions.inc'
      include 'rmas.inc'
      include 'fileopen.inc'
C     Arguments
      REAL*8    TAU0(3,NAX,NSX),SDER(3*NAT,3*NAT)
C     Variables
      CHARACTER FILEN*100
      INTEGER   IS,IA,I,J,K
      LOGICAL   FERROR
C     ==--------------------------------------------------------------==
      FILEN='MOLVIB'
      CALL FILEOPEN(21,FILEN,FO_DEF,FERROR)
      WRITE(21,'(A)') ' &CART'
      DO IS=1,NSP
        DO IA=1,NA(IS)
          WRITE(21,'(I6,3F15.8,F15.6)') IATYP(IS),(TAU0(K,IA,IS),K=1,3),
     *          PMA0(IS)
        ENDDO
      ENDDO
      WRITE(21,'(A)') ' &END '
      WRITE(21,'(A)') ' &FCON '
      DO I=1,3*NAT
        WRITE(21,*) (SDER(I,J),J=1,3*NAT)
      ENDDO
      WRITE(21,'(A)') ' &END '
      CALL FILECLOSE(21)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VIBEIG(VIBE,SDER,NDIM,RW)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'fileopen.inc'
C     Arguments
      INTEGER   NDIM
      REAL*8    VIBE(NDIM),SDER(NDIM,NDIM)
      LOGICAL   RW,FERROR
C     Variables
      CHARACTER FILEN*100
      INTEGER   I,J,K,NN,NCOL
C     ==--------------------------------------------------------------==
      NCOL=8
      FILEN='VIBEIGVEC'
      IF(RW) THEN
        CALL FILEOPEN(21,FILEN,FO_DEF,FERROR)
      ELSE
        CALL FILEOPEN(21,FILEN,FO_APP+FO_MARK,FERROR)
      ENDIF
      DO I=1,NDIM,NCOL
        NN=MIN(NCOL,NDIM-I+1)
        WRITE(21,'(14I12)') (J,J=I,I+NN-1)
        WRITE(21,'(14(F12.3))') (VIBE(J),J=I,I+NN-1)
        WRITE(21,*)
        DO K=1,NDIM
          WRITE(21,'(14F12.6)') (SDER(K,J),J=I,I+NN-1)
        ENDDO
      ENDDO
      CALL FILECLOSE(21)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PURGED(SDER,SCRD,TAU0)
C     ==--------------------------------------------------------------==
C     == PROJECT OUT TRANSLATIONS (AND ROTATIONS) FROM THE DYNAMICAL  ==
C     == MATRIX (MASS WEIGHTED HESSIAN)                               ==
C     ==                                                              ==
C     == USE SUBROUTINE PURGEH() FOR THE HESSIAN (NOT MASS WEIGHTED)  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'ions.inc'
      include 'isos.inc'
      include 'rmas.inc'
C     Arguments
      INTEGER   ND,IS,IA,II
      REAL*8    SDER(3*NAT,3*NAT)
      REAL*8    SCRD(3*NAT,3*NAT)
      REAL*8    TAU0(3,NAX,NSX)
C     Variables
      REAL*8     CX,CY,CZ,MI(3)
      REAL*8     TRAS(3*NAT,3),ROT(3*NAT,3),PROJ(3*NAT,3*NAT),CMC(3,NAT)
      POINTER    (IP_TRAS,TRAS),(IP_ROT,ROT)
      POINTER    (IP_PROJ,PROJ),(IP_CMC,CMC)
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_TRAS,9*NAT,'TRAS')
      CALL MEMORY(IP_ROT,9*NAT,'ROT')
      CALL MEMORY(IP_PROJ,9*NAT*NAT,'PROJ')
      CALL MEMORY(IP_CMC,3*NAT,'CMC')
C...translation
      CALL SETTRANSD(TRAS,NAT)
C...rotation
      IF(TISOS.OR.TCLUST) THEN
        CX=0.D0
        CY=0.D0
        CZ=0.D0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            CX=CX+TAU0(1,IA,IS)*PMA0(IS)/PMAT0
            CY=CY+TAU0(2,IA,IS)*PMA0(IS)/PMAT0
            CZ=CZ+TAU0(3,IA,IS)*PMA0(IS)/PMAT0
          ENDDO
        ENDDO
        II=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            II=II+1
            CMC(1,II)=TAU0(1,IA,IS)-CX
            CMC(2,II)=TAU0(2,IA,IS)-CY
            CMC(3,II)=TAU0(3,IA,IS)-CZ
          ENDDO
        ENDDO
        CALL SETROTATD(ROT,CMC,NAT,MI)
      ELSE
        MI(1)=0.0D0
        MI(2)=0.0D0
        MI(3)=0.0D0
        CALL AZZERO(ROT,9*NAT)
      ENDIF
      ND=3*NAT
C...set up projectors
      CALL UNITMX(PROJ,ND)
      CALL DSYR('U',ND,-1.D0,TRAS(1,1),1,PROJ,ND)
      CALL DSYR('U',ND,-1.D0,TRAS(1,2),1,PROJ,ND)
      CALL DSYR('U',ND,-1.D0,TRAS(1,3),1,PROJ,ND)
ctu   project out rotations only for non-zero moments of inertia
      DO II=1,3
        IF(MI(II) .GT. 1.0D-2) THEN
          CALL DSYR('U',ND,-1.D0,ROT(1,II),1,PROJ,ND)
        END IF
      END DO
C...apply projectors
      CALL DSYMM('L','U',ND,ND,1.D0,PROJ,ND,SDER,ND,0.D0,SCRD,ND)
      CALL DSYMM('R','U',ND,ND,1.D0,PROJ,ND,SCRD,ND,0.D0,SDER,ND)
      CALL FREEM(IP_TRAS)
      CALL FREEM(IP_ROT)
      CALL FREEM(IP_PROJ)
      CALL FREEM(IP_CMC)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SETTRANSD(TRAS,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
C     Arguments
      INTEGER N
      REAL*8  TRAS(3,N,3)
C     variables
      INTEGER I,IS,IA
      REAL*8  X
C     ==--------------------------------------------------------------==
      CALL AZZERO(TRAS,9*N)
ctu   components of TRAS: sqrt(atomic mass)
ctu   normalization of TRAS: scale by 1/sqrt(total mass)
      I=0
      DO IS=1,NSP
        X=SQRT(PMA0(IS)/PMAT0)
        DO IA=1,NA(IS)
          I=I+1
          TRAS(1,I,1)=X
          TRAS(2,I,2)=X
          TRAS(3,I,3)=X
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SETROTATD(ROT,CMC,N,MI)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
C     Arguments
      INTEGER N
      REAL*8  ROT(3,N,3),CMC(3,N),MI(3)
C     Variables
      INTEGER I,J,IS,IA,INFO
      REAL*8 MIT(3,3),AUX(9),X
C     ==--------------------------------------------------------------==
ctu   prepare the moments of inertia tensor
      CALL AZZERO(MIT,9)
      I=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          I=I+1
          MIT(1,1)=MIT(1,1)+PMA0(IS)*(CMC(2,I)**2+CMC(3,I)**2)
          MIT(2,1)=MIT(2,1)-PMA0(IS)*CMC(1,I)*CMC(2,I)
          MIT(3,1)=MIT(3,1)-PMA0(IS)*CMC(1,I)*CMC(3,I)
          MIT(2,2)=MIT(2,2)+PMA0(IS)*(CMC(1,I)**2+CMC(3,I)**2)
          MIT(3,2)=MIT(3,2)-PMA0(IS)*CMC(2,I)*CMC(3,I)
          MIT(3,3)=MIT(3,3)+PMA0(IS)*(CMC(1,I)**2+CMC(2,I)**2)
        ENDDO
      ENDDO
      MIT(1,2)=MIT(2,1)
      MIT(1,3)=MIT(3,1)
      MIT(2,3)=MIT(3,2)
ctu   diagonalize the moment of inertia tensor
      CALL DSYEV('V','U',3,MIT,3,MI,AUX,9,INFO)
      IF(INFO.NE.0) CALL STOPGM('SETROTAT','DSYEV INFO')
ctu   mass weight the coordinates CMC
      I=0
      DO IS=1,NSP
        X=SQRT(PMA0(IS))
        DO IA=1,NA(IS)
          I=I+1
          CMC(1,I)=X*CMC(1,I)
          CMC(2,I)=X*CMC(2,I)
          CMC(3,I)=X*CMC(3,I)
        ENDDO
      ENDDO
ctu   components of ROT: cross product of coordinates and principal
ctu   axes of inertia (for non-zero moments of inertia only!)
ctu   normalization of ROT: scale by 1/sqrt(moment of inertia)          
      DO J=1,3
        IF (MI(J) .GT. 1.0D-2) THEN
          X=1.0D0/SQRT(MI(J))
          DO I=1,N
            ROT(1,I,J)=X*(MIT(2,J)*CMC(3,I)-MIT(3,J)*CMC(2,I))
            ROT(2,I,J)=X*(MIT(3,J)*CMC(1,I)-MIT(1,J)*CMC(3,I))
            ROT(3,I,J)=X*(MIT(1,J)*CMC(2,I)-MIT(2,J)*CMC(1,I))
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PURGEH(SDER,SCRD,TAU0)
C     ==--------------------------------------------------------------==
C     == PROJECT OUT TRANSLATIONS (AND ROTATIONS) FROM THE HESSIAN    ==
C     == MATRIX (NOT MASS WEIGHTED)                                   ==
C     ==                                                              ==
C     == USE SUBROUTINE PURGED() FOR THE DYNAMICAL MATRIX (MASS       ==
C     == WEIGHTED HESSIAN)                                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'ions.inc'
      include 'isos.inc'
      include 'rmas.inc'
C     Arguments
      INTEGER   ND,IS,IA,II
      REAL*8    SDER(3*NAT,3*NAT)
      REAL*8    SCRD(3*NAT,3*NAT)
      REAL*8    TAU0(3,NAX,NSX)
C     Variables
      REAL*8     CX,CY,CZ
      REAL*8     TRAS(3*NAT,3),ROT(3*NAT,3),PROJ(3*NAT,3*NAT),CMC(3,NAT)
      POINTER    (IP_TRAS,TRAS),(IP_ROT,ROT)
      POINTER    (IP_PROJ,PROJ),(IP_CMC,CMC)
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_TRAS,9*NAT,'TRAS')
      CALL MEMORY(IP_ROT,9*NAT,'ROT')
      CALL MEMORY(IP_PROJ,9*NAT*NAT,'PROJ')
      CALL MEMORY(IP_CMC,3*NAT,'CMC')
C...translation
      CALL SETTRANSH(TRAS,NAT)
C...rotation
      IF(TISOS.OR.TCLUST) THEN
        CX=0.D0
        CY=0.D0
        CZ=0.D0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            CX=CX+TAU0(1,IA,IS)*PMA0(IS)/PMAT0
            CY=CY+TAU0(2,IA,IS)*PMA0(IS)/PMAT0
            CZ=CZ+TAU0(3,IA,IS)*PMA0(IS)/PMAT0
          ENDDO
        ENDDO
        II=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            II=II+1
            CMC(1,II)=TAU0(1,IA,IS)-CX
            CMC(2,II)=TAU0(2,IA,IS)-CY
            CMC(3,II)=TAU0(3,IA,IS)-CZ
          ENDDO
        ENDDO
        CALL SETROTATH(ROT,TRAS,CMC,NAT)
      ELSE
        CALL AZZERO(ROT,9*NAT)
      ENDIF
      ND=3*NAT
C...set up projectors
      CALL UNITMX(PROJ,ND)
      CALL DSYR('U',ND,-1.D0,TRAS(1,1),1,PROJ,ND)
      CALL DSYR('U',ND,-1.D0,TRAS(1,2),1,PROJ,ND)
      CALL DSYR('U',ND,-1.D0,TRAS(1,3),1,PROJ,ND)
      CALL DSYR('U',ND,-1.D0,ROT(1,1),1,PROJ,ND)
      CALL DSYR('U',ND,-1.D0,ROT(1,2),1,PROJ,ND)
      CALL DSYR('U',ND,-1.D0,ROT(1,3),1,PROJ,ND)
C...apply projectors
      CALL DSYMM('L','U',ND,ND,1.D0,PROJ,ND,SDER,ND,0.D0,SCRD,ND)
      CALL DSYMM('R','U',ND,ND,1.D0,PROJ,ND,SCRD,ND,0.D0,SDER,ND)
      CALL FREEM(IP_TRAS)
      CALL FREEM(IP_ROT)
      CALL FREEM(IP_PROJ)
      CALL FREEM(IP_CMC)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SETTRANSH(TRAS,NAT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NAT
      REAL*8  TRAS(3,NAT,3)
C     variables
      INTEGER I
      REAL*8  SC
C     ==--------------------------------------------------------------==
      CALL AZZERO(TRAS,9*NAT)
!$OMP parallel do private(I)
      DO I=1,NAT
        TRAS(1,I,1)=1.D0
        TRAS(2,I,2)=1.D0
        TRAS(3,I,3)=1.D0
      ENDDO
      SC=1.D0/DSQRT(DBLE(NAT))
      CALL DSCAL(9*NAT,SC,TRAS,1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SETROTATH(ROT,TRAS,CMC,NAT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NAT
      REAL*8  TRAS(3,NAT,3),ROT(3,NAT,3),CMC(3,NAT)
C     Variables
      INTEGER I,J
      REAL*8 SC,DDOT
      EXTERNAL DDOT
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I)
      DO I=1,NAT
        ROT(1,I,1)=     0.D0
        ROT(2,I,1)= CMC(3,I)
        ROT(3,I,1)=-CMC(2,I)
        ROT(1,I,2)=-CMC(3,I)
        ROT(2,I,2)=     0.D0
        ROT(3,I,2)= CMC(1,I)
        ROT(1,I,3)= CMC(2,I)
        ROT(2,I,3)=-CMC(1,I)
        ROT(3,I,3)=     0.D0
      ENDDO
      DO I=1,3
        DO J=1,3
          SC=DDOT(3*NAT,ROT(1,1,I),1,TRAS(1,1,J),1)
          CALL DAXPY(3*NAT,-SC,TRAS(1,1,J),1,ROT(1,1,I),1)
        ENDDO
        DO J=1,I-1
          SC=DDOT(3*NAT,ROT(1,1,I),1,ROT(1,1,J),1)
          CALL DAXPY(3*NAT,-SC,ROT(1,1,J),1,ROT(1,1,I),1)
        ENDDO
        SC=DDOT(3*NAT,ROT(1,1,I),1,ROT(1,1,I),1)
        IF(SC.GT.1.D-10) THEN
          SC=1.D0/DSQRT(SC)
          CALL DSCAL(3*NAT,SC,ROT(1,1,I),1)
        ELSE
          CALL AZZERO(ROT(1,1,I),3*NAT)
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_SECDER(LSECDER,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !TDIAG NONORT TPRES
      INCLUDE 'elct.inc'        !N
      INCLUDE 'ions.inc'        !NAT
      INCLUDE 'store.inc'       !RESTART RVIB
      INCLUDE 'nlcc.inc'        !TINLC
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'        !TTROT
      INCLUDE 'symm.inc'        !INDPG ROT
      INCLUDE 'prop.inc'        !DBERRY
      INCLUDE 'kpts.inc'        !TKPNT
C     Arguments
      INTEGER LSECDER
      CHARACTER*30 TAG
C     Variables
      INTEGER NSTATE,LINITRUN,LCOPOT,LORTHO,LRNLSM,LRHOOFR,LCALC_ALM,
     &        LUPDATE,LFORCES,LSYMMAT,LTDDFT,LDDIPO
C     ==--------------------------------------------------------------==
      NSTATE=N
      LCOPOT=0
      LORTHO=0
      LRNLSM=0
      LRHOOFR=0
      LCALC_ALM=0
      LFORCES=0
      LSYMMAT=0
      LTDDFT=0
      LDDIPO=0
      CALL GIVE_SCR_INITRUN(LINITRUN,TAG)
      IF(RESTART)THEN
        IF(TINLC) CALL GIVE_SCR_COPOT(LCOPOT,TAG)
        CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      ENDIF
      IF(TDIAG) THEN
        IF(TIVAN) CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
        CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
        IF(TTROT) CALL GIVE_SCR_CALC_ALM(LCALC_ALM,TAG)
        CALL GIVE_SCR_UPDRHO(LUPDATE,TAG,NSTATE,.TRUE.,TPRES)
      ELSE
        CALL GIVE_SCR_UPDWF(LUPDATE,TAG,NSTATE,.FALSE.)
        CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.TRUE.,.TRUE.)
      ENDIF
      IF(TDDFT) CALL GIVE_SCR_LR_TDDFT(LTDDFT,.TRUE.,TAG)
      IF(.NOT.RVIB) CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      IF(.NOT.(INDPG.EQ.0.OR.NROT.EQ.1))
     &     CALL GIVE_SCR_SYMMAT(LSYMMAT,TAG)
      IF(DBERRY) THEN
        IF(TKPNT) THEN
          CALL GIVE_SCR_KDDIPO(LDDIPO,NSTATE,TAG)
        ELSE
          CALL GIVE_SCR_DDIPO(LDDIPO,TAG)
        ENDIF
      ENDIF
      LSECDER=MAX(9*NAT*NAT+9*NAT,
     &            LINITRUN,LCOPOT,LORTHO,LRNLSM,LRHOOFR,LCALC_ALM,
     &            LUPDATE,LFORCES,LSYMMAT,LTDDFT,LDDIPO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MLDGAU(VIBE,SDER,NDIM,TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'cnst.inc'
      include 'ions.inc'
      include 'cell.inc'
      include 'fileopen.inc'
C     Arguments
      INTEGER   NDIM
      REAL*8    VIBE(*),SDER(NDIM,*),TAU0(3,NAX,*)
C     Variables
      LOGICAL   LW,FERROR
      CHARACTER FILE1*100,FILE2*100,typ*2,a*8,ck(3)*7,fr*17,rm(5)*17
      INTEGER   i,j,k,l,n,t(NAT),is,ia,at,he,IUNIT,m
      REAL*8    gz,xc(NAT),yc(NAT),zc(NAT),bx,by,bz
C     ==--------------------------------------------------------------==
      FILE1='VIB1.log'
      IF(nvib.eq.2) FILE2='VIB2.log'
C     write gaussianformated output into VIB1.log and VIB2.log files,
C     which are readable in molden/molekel to visualise the vibrations.
      fr=' Frequencies --  '
      rm(1)=' Red. masses --  ' 
      rm(2)=' Frc consts  --  ' 
      rm(3)=' IR Inten    --  ' 
      rm(4)=' Raman Activ --  ' 
      rm(5)=' Depolar     --  '
      typ='?A'
      a=' Atom AN'
      ck(1)='      X'
      ck(2)='      Y'
      ck(3)='      Z'
      at=0
      gz=0.d0
      LW=.false.
      FERROR=.FALSE.
C ---- cell dimensions---------------------------
      bx=CELLDM(1)
      by=CELLDM(2)
      bz=CELLDM(3)
      CALL FILEOPEN (15,FILE1,FO_DEF,FERROR)
      IF(FERROR) GOTO 999
      IF (nvib.eq.2) CALL FILEOPEN(17,FILE2,FO_DEF,FERROR)
C ---- read coordinates and atomtyps ------------
      k=1
      DO IS=1,NSP
        DO IA=1,NA(IS)
           xc(k)=TAU0(1,IA,IS)
           yc(k)=TAU0(2,IA,IS)
           zc(k)=TAU0(3,IA,IS)
           t(k)=IATYP(IS)
           IF (xc(k).lt.0) LW=.true.
           IF (yc(k).lt.0) LW=.true.
           IF (zc(k).lt.0) LW=.true.
           k=k+1
        ENDDO
      ENDDO
C ---- write some lines needed for molden
      DO IUNIT=15,17,2
         WRITE (IUNIT,*)'Entering Gaussian System'
         WRITE (IUNIT,*)'this file is generated from the MLDGAU',
     &                  ' subroutine in the file secder.F'
         WRITE (IUNIT,*)'Please note, that this is a "faked" output;'
         WRITE (IUNIT,*)'there are no intensities computed in CPMD.'
         WRITE (IUNIT,*)'Standard orientation:'
         WRITE (IUNIT,*)'---------------------------------------',
     &                  '------------------------------'
         WRITE (IUNIT,'(A,2(5X,A),14X,A)')
     &              'Center','Atomic','Atomic','Coordinates (Angstroms)'
         WRITE (IUNIT,'(2(A,5X),1X,A,3X,3(11X,A))')
     &                  'Number','Number','Type','X','Y','Z'
         WRITE (IUNIT,*)'---------------------------------------',
     &                  '------------------------------'
         IF (nvib.ne.2) GOTO 55
      ENDDO
 55   CONTINUE
C ---- make sure that the center of mass is the origin or move the atoms
C ---- from the center of the box to the origin and printout
      IF (LW) THEN
         DO i=1,NAT
            xc(i)=(xc(i))/FBOHR
            yc(i)=(yc(i))/FBOHR
            zc(i)=(zc(i))/FBOHR
            WRITE (15,22)  i, t(i), at, xc(i), yc(i), zc(i)
            IF (nvib.eq.2)
     &         WRITE (17,22)  i, t(i), at, xc(i), yc(i), zc(i)
         ENDDO
      ELSE
         DO 11 i=1,NAT
            xc(i)=(xc(i)-bx/2)/FBOHR
            yc(i)=(yc(i)-bx*by/2)/FBOHR
            zc(i)=(zc(i)-bx*bz/2)/FBOHR
            WRITE (15,22)  i, t(i), at, xc(i), yc(i), zc(i)
            IF (nvib.eq.2)
     &         WRITE (17,22)  i, t(i), at, xc(i), yc(i), zc(i)
 11      CONTINUE
      ENDIF
C ---- write some lines for molden -----------------------------
      DO IUNIT=15,17,2
         WRITE(IUNIT,*)'--------------------------------------------',
     &                 '-------------------------'
         WRITE(IUNIT,*)'      basis functions          primitive ',
     &                 'gaussians'
         WRITE(IUNIT,*)'      alpha electrons          beta electrons'
         WRITE(IUNIT,*)'********************************************',
     &                 '**************************'
         WRITE(IUNIT,*)
         WRITE(IUNIT,*)'Harmonic frequencies (cm**-1), IR intensities ',
     &                 '(KM/Mole),'
         WRITE(IUNIT,*)'Raman scattering activities (A**4/AMU), Raman ',
     &                 'depolarization ratios,'
         WRITE(IUNIT,*)'reduced masses (AMU), force constants ',
     &                 '(mDyne/A) and normal coordinates:'
         IF (nvib.ne.2) GOTO 56
      ENDDO
 56   CONTINUE
C ---- write eigenvalues and eigenvectors in both files
      DO 15 i=4,(NDIM),3
        WRITE(15,23) i-3, i-2, i-1
        WRITE(15,24) typ, typ, typ
        WRITE(15,25) fr, (VIBE(l),l=i,i+2)
        DO n=1,5
           WRITE(15,25) rm(n), gz, gz, gz
        ENDDO
        WRITE(15,26) a,(ck(n),n=1,3),(ck(n),n=1,3),(ck(n),n=1,3)
        DO 16 j=1,NDIM,3
          he=(j-1)/3+1
          WRITE(15,27) he,t(he),
     &                 (SDER(j,m),SDER(j+1,m),SDER(j+2,m),m=i,i+2) 
 16     CONTINUE
 15   CONTINUE
      WRITE(15,*) 'Normal termination of Gaussian 98.'
      IF (nvib.eq.2) THEN
         DO 45 i=1,(NDIM-3),3
           WRITE(17,23) i, i+1, i+2
           WRITE(17,24) typ, typ, typ
           WRITE(17,25) fr, (VIBE(l),l=i,i+2)
           DO n=1,5
              WRITE(17,25) rm(n), gz, gz, gz
           ENDDO
           WRITE(17,26) a,(ck(n),n=1,3),(ck(n),n=1,3),(ck(n),n=1,3)
           DO 46 j=1,NDIM,3
             he=(j-1)/3+1
             WRITE(17,27) he,t(he),
     &                 (SDER(j,m),SDER(j+1,m),SDER(j+2,m),m=i,i+2)
 46        CONTINUE
 45      CONTINUE
         WRITE(17,*) 'Normal termination of Gaussian 98.'
      ENDIF
      CALL FILECLOSE (15)
      IF (nvib.eq.2) CALL FILECLOSE (17)
 22   FORMAT(i5,i11,i14,4x,3(3x,f9.6))
 23   FORMAT(i22,2i23)
 24   FORMAT(20x,a2,2(21x,a2))
 25   FORMAT(a17,f9.4,2f23.4)
 26   FORMAT(a8,3a7,2(2x,3a7))
 27   FORMAT(2i4,3(f9.2,2f7.2))
      goto 888
 999  CONTINUE
       WRITE(6,*) 'COULD NOT OPEN FILE VIB[1,2].log!'
 888  CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRITEACLIMAX(VIBE,SDER,NDIM,TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'ions.inc'
      include 'cell.inc'
      include 'fileopen.inc'
      include 'adat.inc'
      include 'rmas.inc'
C     Arguments
      INTEGER   NDIM
      REAL*8    VIBE(NDIM),SDER(NDIM,NDIM),TAU0(3,NAX,NSX)
C     Variables
      LOGICAL   FERROR
      CHARACTER FILE*100
      INTEGER   i,j,k,l,n,t(NAT),is,ia,he,m
C     ==--------------------------------------------------------------==
      FILE='VIB.aclimax'
C     write aClimax formated output into cpmd.aclimax file
C     which are readable in aClimax to generate INS spectrum
C     INS is inelastic neutron scattering
C     convert to windows format befoe using aClimax for windows
      FERROR=.FALSE.
      CALL FILEOPEN (17,FILE,FO_DEF,FERROR)
      IF(FERROR) GOTO 999
C ---- read atomtypes ------------
      k=1
      DO IS=1,NSP
        DO IA=1,NA(IS)
           t(k)=IATYP(IS)
           k=k+1
        ENDDO
      ENDDO
C ---- write aClimax comment header
      WRITE(17,*)'!This file is generated from the WRITEACLIMAX',
     &             ' subroutine in the file secder.F'
      WRITE(17,*)'!#  Type  Number      Mass      ',
     &             'Coord        Coord        Coord'
      WRITE(17,*)
      WRITE(17,*)'BEGIN ATOMS'
        i=1
        DO IS=1,NSP
          DO IA=1,NA(IS)
            WRITE(17,22) i,EL(IATYP(IS)),IATYP(IS),PMA0(IS),
     &           (TAU0(K,IA,IS),K=1,3)
          ENDDO
      ENDDO
      WRITE(17,*)'END ATOMS'
      WRITE(17,*)
C ---- write eigenvalues and eigenvectors in both files
      WRITE(17,*)'BEGIN FREQUENCIES'
      DO i=4,NDIM
        WRITE(17,*)'! Mode#    Frequency'
        WRITE(17,'(I7,4X,f7.2)') (i-3),(VIBE(i))
        WRITE(17,*)
        WRITE(17,*)'!Displacments'
        WRITE(17,*)
        DO j=1,NDIM,3
          he=(j-1)/3+1
          WRITE(17,27) he,EL(t(he)),t(he),
     &                 (SDER(m,i),m=j,j+2)
        ENDDO
        WRITE(17,*)
      ENDDO
      WRITE(17,*)'END FREQUENCIES'
C ---- close file and exit subroutine
      CALL FILECLOSE (17)
 22   FORMAT(I3,A4,I6,F15.6,3F15.8)
 27   FORMAT(I4,A4,I4,3F12.6)
      goto 888
 999  CONTINUE
       WRITE(6,*) 'COULD NOT OPEN FILE cpmd.aclimax!'
 888  CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
