C     ==================================================================
      SUBROUTINE SETBSSTATE
C CB: Sets occupation in BS calc, dependening on BSCLCS (BS:1, HS:2)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'bsym.inc'
      include 'elct.inc'
      include 'ropt.inc'
      include 'spin.inc'
#ifdef PARALLEL
      include 'irat.inc'
#endif            
C     Arguments
C     Variables
      dimension F(*)
      integer I
#ifdef PARALLEL
      integer MSGLEN
#endif
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      if(PARENT) then
        if(BSCLCS.EQ.1) then
            NSPIN=0
          NUPEL=N/2
          NDOEL=N/2
          NSUP=N/2
          NSDOWN=N/2
        else 
          NSPIN=HSPIN
          NUPEL=HUPEL
          NDOEL=HDOEL
          NSUP=HSUP
          NSDOWN=HSDOWN
        endif
        CALL AZZERO(F,N)
        DO I=1,INT(NUPEL)
          F(I)=1.D0
        ENDDO
        DO I=NSUP+1,NSUP+INT(NDOEL)
          F(I) = 1.D0
        ENDDO
      endif
#ifdef PARALLEL
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NSPIN,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NUPEL,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NDOEL,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NSUP,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NSDOWN,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = N * 8
      CALL MY_BCAST(F,MSGLEN,SOURCE,ALLGRP)
#endif
      SDIIS=.TRUE.
      SPCG=.TRUE.      
      END 
      
