C     ==================================================================
      SUBROUTINE SETSYS
C     ==--------------------------------------------------------------==
C     ==  FINAL SETUP OF THE SYSTEM                                   ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atom.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'dpot.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cell.inc'
      INCLUDE 'vdbt.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'filn.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'symm.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'store.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'elct2.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'shop.inc'
      INCLUDE 'kdpc.inc'
      INCLUDE 'shock.inc'
      INCLUDE 'sphe.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'eam.inc'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'bsym.inc'
      INCLUDE 'wann.inc'
      INCLUDE 'mm_extrap.inc'
      integer NSX_q
c
      REAL*8    BETAELMAX
      PARAMETER (BETAELMAX=1.D33)
      DIMENSION HGKP(NHG,*),HGKM(NHG,*),RK(3,*),WK(*),F(*),
     &          LVELINI(0:NAX,NSX)
      REAL*8    FNL(*),DFNL(*)
      REAL*8    FT(*)
      DIMENSION KGEMAX(*),KCNORM(*)
      POINTER   (IP_FT,FT)
      LOGICAL   LVELTRUE,FIXEDKBLOCK,LFNOTSET
      REAL*8    RKT(3),CX,CY,CZ,DCX,DCY,DCZ,XNEL,YNEL,SUMWK,FF,
     &          DASUM
      EXTERNAL  DASUM
      INTEGER   IS,IA,I,K,NT,MBL,JS,JA,NNNX,N1,NX,IAT,NKPOINT,IK,
     &          IT,IU,IL,ISIN,IFAC,NELHALF,NSIC,IPGRPA
      REAL*8    TAUS(*),DR(3),DDR,DMIN
      POINTER   (IP_TAUS,TAUS)
      logical   status,statusdummy
      REAL*8    HTSAVE(3,3)
      DIMENSION VBOUND(4,*)
#ifdef PARALLEL
      INTEGER   MSGLEN,M
#endif
CEHR[
      DIMENSION F_DIAG(*),F_PROP(*)
CEHR]
C     ==--------------------------------------------------------------==
      CHARACTER*1 CANG(5)
      DATA        CANG /'S','P','D','F','G'/
      CHARACTER*10 CTYP(2)
      DATA         CTYP /'     LOCAL','  NONLOCAL'/
      CHARACTER*7 MUL(10)
      DATA        MUL /'SINGLET','DOUBLET','TRIPLET','QUARTET',
     &                 'QUINTET',' SEXTET',' SEPTET','  OCTET',
     &                 '  NONET',' DECTET'/
      CHARACTER*12 ISCHEME(7)
      DATA         ISCHEME /'GAUSS-HERMIT','    KLEINMAN',
     &                      '  VANDERBILT','   GOEDECKER',
     &                      '         EAM','            ',
     &                      '     UPF  NC'/
      CHARACTER*3 INLCC(2)
      DATA        INLCC /'YES',' NO'/
C     ==--------------------------------------------------------------==
      if(qmmm)then
         NSX_q=NSPq
      else
         NSX_q=NSX
         NSPM =NSX
      endif
      if(qmmm)call mm_dim(mm_go_mm,status)
      IF(.NOT.PARENT) GOTO 9999
      IF(TSCALE) THEN
C     ==--------------------------------------------------------------==
C     == SCALE OPTIONS: ATOMIC COORDINATES IN DIRECT LATTICE BASIS    ==
C     ==--------------------------------------------------------------==
        CALL DSCAL(NAX*NSX,1.D0/SXSCALE,TAU0(1,1,1),3)
        CALL DSCAL(NAX*NSX,1.D0/SYSCALE,TAU0(2,1,1),3)
        CALL DSCAL(NAX*NSX,1.D0/SZSCALE,TAU0(3,1,1),3)
        IF(TCARTESIAN) THEN
          CALL DSCAL(NAX*NSX,CELLDM(1),TAU0(1,1,1),3)
          CALL DSCAL(NAX*NSX,CELLDM(1)*CELLDM(2),TAU0(2,1,1),3)
          CALL DSCAL(NAX*NSX,CELLDM(1)*CELLDM(3),TAU0(3,1,1),3)
        ELSE
          CALL MEMORY(IP_TAUS,3*NAX*NSP,'TAUS')
          CALL DCOPY(3*NAX*NSX,TAU0,1,TAUS,1)
          CALL S_TO_C(TAUS,TAU0)
          CALL FREEM(IP_TAUS)
        ENDIF
      ELSEIF(.NOT.BOHR) THEN
C     ==--------------------------------------------------------------==
C     == ANGSTROM OPTION: ATOMIC COORDINATES IN BOHR UNIT             ==
C     ==--------------------------------------------------------------==
        DO IS=1,NSP
          DO IA=1,NA(IS)
            TAU0(1,IA,IS)=TAU0(1,IA,IS)*FBOHR
            TAU0(2,IA,IS)=TAU0(2,IA,IS)*FBOHR
            TAU0(3,IA,IS)=TAU0(3,IA,IS)*FBOHR
            VELP(1,IA,IS)=VELP(1,IA,IS)*FBOHR
            VELP(2,IA,IS)=VELP(2,IA,IS)*FBOHR
            VELP(3,IA,IS)=VELP(3,IA,IS)*FBOHR
          ENDDO
        ENDDO

C     convert wannier reference coordinate to atomic units if set in input.
        IF(W_REF(1).GT.-999999.9d0) THEN
          DO I=1,3
            W_REF(I) = W_REF(I)*FBOHR
          END DO
        ENDIF
C     convert finite differences reference coordinate and radius to atomic units
        DO I=1,3
          COORD_FDIFF(I) = COORD_FDIFF(I)*FBOHR
        END DO
        R_FDIFF = R_FDIFF*FBOHR
        
C     convert type 1 dummy atom coordinates to atomic units
        DO I=1,NDAT1
          DUMMY1(1,I)=DUMMY1(1,I)*FBOHR
          DUMMY1(2,I)=DUMMY1(2,I)*FBOHR
          DUMMY1(3,I)=DUMMY1(3,I)*FBOHR
        END DO

C     convert distance based constraints to atomic units
        IF(MCNSTR.GT.0) THEN
          DO I=1,MCNSTR
            IF (NTCNST(1,I).EQ.1 .OR.
     *          NTCNST(1,I).EQ.4 .OR.
     *          NTCNST(1,I).EQ.7 .OR. 
     *          NTCNST(1,I).EQ.12) THEN
              IF(CNSVAL(I).NE.-999.D0) CNSVAL(I)=CNSVAL(I)*FBOHR
              GRATE(I)=GRATE(I)*FBOHR
              IF(CNSVAL_DEST(I).NE.-999.D0) 
     *           CNSVAL_DEST(I)=CNSVAL_DEST(I)*FBOHR
            ENDIF
            IF (NTCNST(1,I).EQ.6 .OR. NTCNST(1,I).EQ.8 .OR.
     &          NTCNST(1,I).EQ.9 .OR. NTCNST(1,I).EQ.10) THEN
              IF (NTCNST(1,I).EQ.6)THEN
                 CNPAR(1,I) = CNPAR(1,I)/FBOHR
              ELSE
                 CNPAR(1,I) = CNPAR(1,I)*FBOHR
              ENDIF
              CNPAR(2,I) = CNPAR(2,I)*FBOHR
            ENDIF
          ENDDO
        ENDIF
C     convert distance based restraints to atomic units
        IF(MRESTR.GT.0) THEN
          DO I=1,MRESTR
            IF (NTREST(1,I).EQ.1 .OR.
     *          NTREST(1,I).EQ.4 .OR.
     *          NTREST(1,I).EQ.7 .OR. 
     *          NTREST(1,I).EQ.12) THEN
              IF(RESVAL(I).NE.-999.D0) RESVAL(I)=RESVAL(I)*FBOHR
              GSRATE(I)=GSRATE(I)*FBOHR
              IF(RESVAL_DEST(I).NE.-999.D0) 
     *           RESVAL_DEST(I)=RESVAL_DEST(I)*FBOHR
            ENDIF
            IF (NTREST(1,I).EQ.6 .OR. NTREST(1,I).EQ.8 .OR.
     &          NTREST(1,I).EQ.9 .OR. NTREST(1,I).EQ.10) THEN
              IF (NTREST(1,I).EQ.6)THEN
                 RESPAR(1,I)=RESPAR(1,I)/FBOHR
              ELSE
                 RESPAR(1,I)=RESPAR(1,I)*FBOHR
              ENDIF
              RESPAR(2,I)=RESPAR(2,I)*FBOHR
            ENDIF
          ENDDO
        ENDIF

C     convert metadynamics parameters.
        IF(NCOLVAR.GT.0) THEN
          IPGRPA=0
          DO I=1,NCOLVAR

C     convert upper/lower bounds for distance based CVs
            IF ((TYCVAR(I).EQ.1) .OR. (TYCVAR(I).EQ.4)         ! STRETCH, DIST
     &           .OR. (TYCVAR(I).EQ.7) .OR. (TYCVAR(I).EQ.13)  ! DIFFER, DISPL1
     &           .OR. (TYCVAR(I).EQ.23)) THEN                  ! CELLSIDE
              VBOUND(1,I) = VBOUND(1,I)*FBOHR
              VBOUND(3,I) = VBOUND(3,I)*FBOHR
            ENDIF
            IF (TYCVAR(I).EQ.12) THEN         ! RMSD_AB
              VBOUND(1,I) = VBOUND(1,I)*FBOHR*FBOHR
              VBOUND(3,I) = VBOUND(3,I)*FBOHR*FBOHR
            ENDIF
            IF (TYCVAR(I).EQ.22) THEN         ! VOLVAR
              VBOUND(1,I) = VBOUND(1,I)*FBOHR*FBOHR*FBOHR
              VBOUND(3,I) = VBOUND(3,I)*FBOHR*FBOHR*FBOHR
            ENDIF

C     convert length parameters in the definition of the CVs
            IF ((TYCVAR(I).EQ.6).OR.(TYCVAR(I).EQ.8)) THEN   ! COORD, COORSP
!TODO kappa to be converted to Bohr^-1
              CVPAR(1,I) = CVPAR(1,I)/FBOHR 
              CVPAR(2,I) = CVPAR(2,I)*FBOHR
            ENDIF
            IF ((TYCVAR(I).EQ.10).OR.(TYCVAR(I).EQ.17)) THEN ! BNSWT, DIFCOOR
              CVPAR(1,I) = CVPAR(1,I)*FBOHR
            ENDIF
            IF ((TYCVAR(I).EQ.9).OR.(TYCVAR(I).EQ.11)) THEN  ! COOR_RF, TOT_COOR
              CVPAR(1,I) = CVPAR(1,I)*FBOHR
              CVPAR(2,I) = CVPAR(2,I)*FBOHR                  ! 2SHELL
            ENDIF
            IF ((TYCVAR(I).EQ.16).OR.(TYCVAR(I).EQ.18)) THEN ! HBONDCH, COOR_CHAIN
              CVPAR(1,I) = CVPAR(1,I)*FBOHR
              CVPAR(2,I) = CVPAR(2,I)*FBOHR
            ENDIF
            IF ((TYCVAR(I).EQ.29)) THEN ! COORGROUP
               CVPAR(1,I) = CVPAR(1,I)/FBOHR !Kappa is inverse of distance 
               DO K=1,ATCVAR(1,I)
                 IPGRPA=IPGRPA+1
                 RCCNGA(IPGRPA)=RCCNGA(IPGRPA)*FBOHR
               END DO
            ENDIF

C     FIXME: conversion for HYDRONIUM and DIS_HYD still missing.
C            is a bit tricky, since there are default parameters.
          ENDDO
        ENDIF

      ENDIF
C     ==--------------------------------------------------------------==
C     == ATOMIC MASSES                                                ==
C     ==--------------------------------------------------------------==
      if(.not.qmmm) then
        PMATOT=0.D0
        PMAT0=0.D0
        NAT=0
        DO IS=1,NSP
          PMA(IS)=PMA0(IS)*SCMASS
          PMAT0=PMAT0+PMA0(IS)*NA(IS)
          PMATOT=PMATOT+PMA(IS)*NA(IS)
          NAT=NAT+NA(IS)
        ENDDO
C     initialize cell mass to total mass, if not set in input
C     variable cell is not available for qm/mm so we are safe.
        IF(CMASS.LE.0.0d0) THEN 
          CMASS=PMAT0
          IF(TSDC.OR.TPRCP) WRITE(6,'(A,T54,F12.2)')
     &        ' AUTOMATIC FICTITIOUS MD CELL MASS '
     &        // 'SET TO [A.U.]:',CMASS
        ENDIF
        IF (TSHOCK) VSHOCK=VSHOCK*DSQRT(PMATOT)
        IF(NAT.EQ.0) THEN
          CALL STOPGM('SETSYS','THE NUMBER OF ATOMS IS NULL')
        ENDIF
      endif
C     safety check.
      IF((TSDC.OR.TPRCP).AND.(CMASS.LT.1.0d0))
     &    CALL STOPGM('SETSYS','INVALID FICTITIOUS MD CELL MASS <1.0')
C     ==--------------------------------------------------------------==
C     == MOVE COM TO CENTER OF BOX                                    ==
C     ==--------------------------------------------------------------==
      mm_c_trans(1)=0.0d0
      mm_c_trans(2)=0.0d0
      mm_c_trans(3)=0.0d0
CEHR[
      IF(TCLUST.AND.TCENT.AND..NOT.TCLAS
     &   .AND..NOT.TMDEH.AND..NOT.TPSPEC) THEN
CEHR]
        if(qmmm)then
#if defined (__GROMOS)
          CALL mm_center(TAU0,mm_c_trans,.FALSE.) 
#endif
        else
          CX=0.0D0
          CY=0.0D0
          CZ=0.0D0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              CX=CX+TAU0(1,IA,IS)*PMA0(IS)/PMAT0
              CY=CY+TAU0(2,IA,IS)*PMA0(IS)/PMAT0
              CZ=CZ+TAU0(3,IA,IS)*PMA0(IS)/PMAT0
            ENDDO
          ENDDO
          DCX=0.5D0*CELLDM(1)-CX
          DCY=0.5D0*CELLDM(2)*CELLDM(1)-CY
          DCZ=0.5D0*CELLDM(3)*CELLDM(1)-CZ
          DO IS=1,NSP
            DO IA=1,NA(IS)
              TAU0(1,IA,IS)=TAU0(1,IA,IS)+DCX
              TAU0(2,IA,IS)=TAU0(2,IA,IS)+DCY
              TAU0(3,IA,IS)=TAU0(3,IA,IS)+DCZ
            ENDDO
          ENDDO
          WRITE(6,'(/,A,A,/)') 
     *        ' >>>>>>>> CENTER OF MASS HAS BEEN MOVED',
     *                       ' TO CENTER OF BOX <<<<<<<<'
        endif
      ENDIF
C     ==--------------------------------------------------------------==
C     == SET WANNIER REFERENCE IF NOT SET IN INPUT                    ==
C     ==--------------------------------------------------------------==
      IF(W_REF(1).LT.-999999.9d0) THEN
C     default to middle of box if centering is active
        IF(TCENT) THEN
          DO I=1,3
            W_REF(I)=0.5D0*(A1(I)+A2(I)+A3(I))
          END DO
        ELSE
          DO I=1,3
            W_REF(I)=0.0D0
          END DO
        ENDIF
        
        IF(TWANN) WRITE(6,'(A,3F11.5)')
     *    ' AUTOMATIC WANNIER REF POINT [A.U.]:',(W_REF(i),i=1,3)

      ENDIF
C     == SYMMETRIES (POINT GROUP)                                     ==
C     ==--------------------------------------------------------------==
      if(qmmm.and.TGENC)call stopgm('SETSYS','symmetry not implemented')
      IF(TPGAUTO) THEN
        WRITE(6,'(/," AUTOMATIC DETERMINATION OF THE POINT GROUP:")')
        CALL GIVESYM(TAU0)
      ENDIF
      CALL GENTAU(TAU0)
      CALL SYMTAU(TAU0)
      CALL CHKSYM(TAU0)
C     Construct table multiplication.
      CALL MULTTB(INDPG,NROT,NTVEC,NAT,XTABLE,INVE,MULTAB,IRT,.TRUE.)
C     ==--------------------------------------------------------------==
      if(qmmm)then
         if( NATm.gt.500) goto 111
      endif
      WRITE(6,'(/,1X,29("*"),A,28("*"))') ' ATOMS '
      WRITE(6,'(A,A)') '   NR   TYPE        X(bohr)        Y(bohr)',
     *                 '        Z(bohr)     MBL'
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          MBL=LSKCOR(1,IAT)+LSKCOR(2,IAT)+LSKCOR(3,IAT)
          WRITE(6,'(I5,5X,A2,3F15.6,I8)') 
     *       IAT,EL(IATYP(IS)),(TAU0(K,IA,IS),K=1,3),MBL
        ENDDO
      ENDDO
      WRITE(6,'(1X,64("*"))')
111   continue
C     ==--------------------------------------------------------------==
C     == CHECK IF TWO ATOMS HAVE THE SAME COORDINATES.                ==
C     ==--------------------------------------------------------------==
      if(qmmm)call mm_dim(mm_go_qm,statusdummy)
      IF(TNOGEOCHECK) THEN
        DMIN = 1.D-10
      ELSE
        DMIN = 0.5D0
      ENDIF

      CALL DCOPY(3*3,HT,1,HTSAVE,1)
      DO I=1,3
        HT(1,I) = A1(I)
        HT(2,I) = A2(I)
        HT(3,I) = A3(I)
      ENDDO

      DO IS=1,NSP
        DO IA=1,NA(IS)
          DO JS=IS,NSP
            DO JA=1,NA(JS)
              IF( (IS.NE.JS).OR.(IA.NE.JA) ) THEN
                DR(1) = TAU0(1,IA,IS)-TAU0(1,JA,JS)
                DR(2) = TAU0(2,IA,IS)-TAU0(2,JA,JS)
                DR(3) = TAU0(3,IA,IS)-TAU0(3,JA,JS)
                CALL PBC(DR(1),DR(2),DR(3),
     &                   DR(1),DR(2),DR(3),1,APBC,IBRAV)
                DDR = DSQRT( DR(1)**2 + DR(2)**2 + DR(3)**2 )
                IF(DDR .LE. DMIN) THEN
                  WRITE(6,*) 'ATOM TYPE=',IS,' NUM=',IA,
     &                 (TAU0(I,IA,IS),I=1,3)
                  WRITE(6,*) 'ATOM TYPE=',JS,' NUM=',JA,
     &                 (TAU0(I,JA,JS),I=1,3)
                  CALL STOPGM(' SETSYS','ATOMS ARE VERY CLOSE')
                ENDIF
              ENDIF
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      CALL DCOPY(3*3,HTSAVE,1,HT,1)
C     ==--------------------------------------------------------------==
C     == FILENAMES                                                    ==
C     ==--------------------------------------------------------------==
      FILN='RESTART'
      FILBOD='RESTART.'
C     ==--------------------------------------------------------------==
C     == SPECIFIED VELOCITIES                                         ==
C     ==--------------------------------------------------------------==
      LVELTRUE=.FALSE.
      DO IS=1,NSP
        LVELTRUE=LVELTRUE.OR.LVELINI(0,IS)
      ENDDO
      IF(LVELTRUE) THEN
        WRITE(6,'(/,1X,17("*"),A,18("*"))')
     &       ' SPECIFIED ATOMIC VELOCITIES '
        WRITE(6,'(A,A)')
     &       '   NR   TYPE           VX(a.u.)         VY(a.u.)',
     *       '         VZ(a.u.)'
        IAT=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IAT=IAT+1
            IF(LVELINI(IA,IS))
     &           WRITE(6,'(I5,5X,A2,2X,3F17.6)') 
     &           IAT,EL(IATYP(IS)),(VELP(K,IA,IS),K=1,3)
          ENDDO
        ENDDO
        WRITE(6,'(1X,64("*"))')
      ENDIF
C     ==--------------------------------------------------------------==
C     == ROKS AND LOW SPIN EXCITATION                                 ==
C     ==--------------------------------------------------------------==
      IF (TROS.AND.TLSE) THEN
         WRITE(6,*) '                                                 '
         WRITE(6,*) '      *******************************************'
         WRITE(6,*) '      WARNING: USING ROKS IN THE &CPMD SECTION   '
         WRITE(6,*) '      AND LSE SIMULTANEOUSLY MIGHT CAUSE PROBLEMS'
         WRITE(6,*) '      ONLY DO THIS IF YOU KNOW WHAT YOU ARE DOING'
         WRITE(6,*) '      *******************************************'
      ELSE IF (TROS) THEN
         TLSE=.TRUE.
         TROKS=.TRUE.
      ENDIF
C     ==--------------------------------------------------------------==
C     == SET F OCCUPATION NUMBER                                      ==
C     ==--------------------------------------------------------------==
      YNEL=NEL-CHARGE
      IF(TLSD) THEN
        IFAC=2
      ELSE
        IFAC=1
      ENDIF
      IF(N.EQ.0) THEN
C       NKSSTA is the number of unoccupied states
C       (parameter of KOHN-SHAM ENERGIES)
        IF(TFINT.AND.NKSSTA.EQ.0) THEN
C         For free energy functional use 4 states + NEL/2 for
C         the default behaviour.
          NKSSTA=4
        ENDIF
        NNNX=INT(YNEL + 1)+IFAC*NKSSTA
        CALL MEMORY(IP_F,NNNX,'F')
CEHR[
        IF (TMDEH) THEN
         CALL MEMORY(IP_F_PROP,NNNX,'F_prop')
         CALL MEMORY(IP_F_DIAG,NNNX,'F_diag')
        ENDIF
CEHR]
        DO I=1,NNNX
          F(I) = -1.D0
        ENDDO
      ENDIF
      IF(F(1).NE.-1.D0) THEN
        LFNOTSET=.FALSE.
        XNEL=DASUM(N,F(1),1)
        IF(ABS(YNEL-XNEL).GT.1.D-6) THEN
          WRITE(6,*) ' INCOMPATIBLE NUMBER OF ELECTRONS',YNEL,XNEL
          CALL STOPGM('SETSYS',' ')
        ENDIF
      ELSE
        LFNOTSET=.TRUE.
        IF(TLSD) THEN
          N1=IDINT(YNEL)
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
          DO I=1,N1
            F(I)=1.D0
          ENDDO
          IF (DABS(DBLE(N1)-YNEL).GT.1.D-4) THEN
            WRITE(6,*) 
     &       'FOR THE MOMENT USE INTEGRAL NUMBER OF ELECTRONS WITH LSD'
     &            ,N1
            CALL STOPGM('SETSYS',' ')
          ELSE
             YNEL=DBLE(N1)
          ENDIF
          IF(N.EQ.0) N=N1
          IF(N.LT.N1) THEN
            WRITE(6,*) ' SPECIFIED NUMBER OF STATES TOO SMALL ',N,N1
            CALL STOPGM('SETSYS',' ')
          ELSE
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
            DO I=N1+1,N
              F(I)=0.0D0
            ENDDO
          ENDIF
        ELSEIF(TLSE) THEN
          N1=IDINT(YNEL)
          IF (DABS(DBLE(N1)-YNEL).GT.1.D-4) THEN
            WRITE(6,*)  
     &       'FOR THE MOMENT USE INTEGRAL NUMBER OF ELECTRONS WITH LSE'
     &            ,N1
            CALL STOPGM('SETSYS',' ')
          ELSE
            YNEL=DBLE(N1)
          ENDIF
          IF(MOD(N1,2).NE.0) THEN
            WRITE(6,*) ' LSE NEEDS EVEN NUMBER OF ELECTRONS ',N1
            CALL STOPGM('SETSYS',' ')
          ENDIF
          N=N1/2+1
cMcB     ... surface hopping stuff ...
          IF ( TSHOP ) N=NEL/2+1
cMcB
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
          DO I=1,N-2
            F(I)=2.0D0
          ENDDO
          F(N-1)=1.0D0
          F(N)=1.0D0
c     Transition State Density
          IF(TLSETS) THEN
             F(N-1)=1.5D0
             F(N)=0.5D0
          ENDIF
        ELSE
          N1=IDINT(YNEL/2.D0)
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
          DO I=1,N1
            F(I)=2.D0
          ENDDO
          IF(2.D0*DBLE(N1).LT.YNEL) THEN
            F(N1+1)=YNEL-2.D0*DBLE(N1)
            N1=N1+1
          ENDIF
          IF(N.NE.0) THEN
            IF(N.LT.N1) THEN
              WRITE(6,*) ' SPECIFIED NUMBER OF STATES TOO SMALL ',N,N1
              CALL STOPGM('SETSYS',' ')
            ELSE
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
              DO I=N1+1,N
                F(I)=0.0D0
              ENDDO
            ENDIF
          ELSE
            N=N1
          ENDIF
        ENDIF
CEHR[
        IF (TMDEH) CALL DCOPY(N,F(1),1,F_PROP(1),1)
        IF (TMDEH) CALL DCOPY(N,F(1),1,F_DIAG(1),1)
CEHR]
      ENDIF
      NEL=NEL-CHARGE
C     Add NKSSTA into N
      IF (LFNOTSET) THEN
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
        DO I=N+1,N+IFAC*NKSSTA
          F(I)=0.D0
        ENDDO
      ENDIF
      N=N+IFAC*NKSSTA
C.. set nkry_block if not specified in input  
      IF(NKRY_BLOCK.LE.0) THEN 
         IF(N.GT.100) THEN 
C          NKRY_BLOCK=N/(INT(N/100)+1) 
           NKRY_BLOCK=(N+1)/(INT(N/100)+1) 
         ELSE
          NKRY_BLOCK=N
         ENDIF
          FIXEDKBLOCK=.TRUE.
      ELSE
        FIXEDKBLOCK=.FALSE.
      ENDIF
      BSFAC=1
      BSCLCS=1
      IF(BSYMM) THEN
C CB: Some array sizes have to be doubled for BS
        BSFAC=2
C CB: The multiplicity of the high spin state has to be given.
C CB: The spin of the low spin state is assumed to be 0.
        HSPIN=NSPIN
        NSPIN=0
C CB: Now the high spin system has to be set up.
C CB: Setting up of the F array has to be done at each change
C CB: between BS and HS state!
        NX=IDINT(NEL)-HSPIN+1
        IF(MOD(NX,2).NE.0) THEN
          WRITE(6,*) ' NUMBER OF ELECTRONS INCOMPATIBLE WITH ',
     *               ' SPIN MULTIPLICITY'
          WRITE(6,*) ' NEL ',NEL,'    MULT ',HSPIN
          CALL STOPGM('SETSYS',' ')
        ENDIF
        HUPEL=DBLE(NX/2)
        HDOEL=DBLE(IDINT(NEL)-HUPEL)
        HSUP=N/2-(HDOEL-HUPEL)/2
        HSDOWN=N-HSUP
C CB: Setting constants for BS equations
        SMIN=0.0D0
        SMAX=(HSPIN-1.0D0)/2.0D0
        SA=0.5D0*SMAX
        SB=SA
        RTSASB=0.5D0/(SA*SB)
        CNSTWGT=0.5D0*(SMAX-SMIN)*RTSASB
C CB: Setting general constants used in BS equations
        AUTOCM=219474.6D0
      ENDIF 
C.. 
      IF(TLSD.AND.LFNOTSET) THEN
C       Spin up and down
        N1=YNEL
        IF(NSPIN.EQ.0) THEN
          IF(TDIAG) TFXSP=.FALSE.
C.. N is number of states
          NUPEL=N1/2
          NDOEL=N1-NUPEL
          IF(NSUP.EQ.0) NSUP=N/2
          NSUP=MAX(NSUP,INT(NUPEL))
          NSDOWN=N-NSUP
          CALL AZZERO(F,N) 
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
          DO I=1,NUPEL
            F(I)=1.D0
          ENDDO
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
          DO I=1,NDOEL
            F(I+NSUP)=1.D0
          ENDDO
          NSPIN=ABS(NUPEL-NDOEL)+1
        ELSE
          NX=IDINT(NEL)-NSPIN+1
C         in principle we could allow fractional spin
          IF(MOD(NX,2).NE.0) THEN
            WRITE(6,*) ' NUMBER OF ELECTRONS INCOMPATIBLE WITH ',
     *           'SPIN MULTIPLICITY'
            WRITE(6,*) ' NEL ',NEL,'    MULT ',NSPIN
            CALL STOPGM('SETSYS',' ')
          ENDIF
          IF(.NOT.TDIAG) TFXSP=.TRUE.
          IF(TDIAG.AND.KSENER) TFXSP=.TRUE.
C         NUPEL (NDOEL) is number of alpha (beta) electrons
          NUPEL=DBLE(NX/2)
          NDOEL=DBLE(IDINT(NEL)-NUPEL)
C         NSUP (NSDOWN) is number of alpha (beta) states
          IF(NSUP.EQ.0) NSUP=N/2-(NDOEL-NUPEL)/2
          NSUP=MAX(NSUP,INT(NUPEL))
          NSDOWN=N-NSUP
          CALL AZZERO(F,N)
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
          DO I=1,INT(NUPEL)
            F(I)=1.D0
          ENDDO
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
          DO I=NSUP+1,NSUP+INT(NDOEL)
            F(I) = 1.D0
          ENDDO
        ENDIF
      ELSE IF (TLSD.AND..NOT.LFNOTSET) THEN
        IF (NKSSTA.NE.0) THEN
           WRITE(6,*) ' WARNING: OCCUPATION NUMBERS SET, ',
     .                                 'NKSSTA IGNORED, NKSSTA=', NKSSTA
        ENDIF
        IF(NSUP.EQ.0) NSUP=N/2
        NSDOWN=N-NSUP
        XNEL=DASUM(NSUP,F(1),1)
        NUPEL=INT(XNEL)
        XNEL=DASUM(NSDOWN,F(NSUP+1),1)
        NDOEL=INT(XNEL)
        IF (NUPEL+NDOEL.NE.INT(YNEL)) THEN
          WRITE(6,*)
     $          ' WARNING! FRACTIONAL ELECTRONS, GO ON AT YOUR OWN RISK'
          WRITE(6,*) ' ELECTRONS (UP/DOWN/TOTAL): ', NUPEL, NDOEL,
     $         INT(YNEL)
        ENDIF
        DO I=1,N
          IF (F(I).EQ.-1.0D0) F(I) = 0.0D0
        ENDDO
      ENDIF
      IF(TLSETS) THEN
        IF(TSHOP) THEN
          WRITE(6,*) ' TRANSITION STATE ROKS NOT YET IMPLEMENTED WITH ',
     $          'SURFACE HOPPING'
          CALL STOPGM('SETSYS',' ')
        END IF
        IALPHA=0
        IBETA=0
        DO I=1,N
          FF=DABS(F(I)-1.5D0)
          IF(FF.LT.1.D-5) IALPHA=I
          IF(FF-0.5D0.GT.1.D-5) IBETA=I
        ENDDO
        IF(ABS(IBETA-IALPHA-1.0D0).GT.1.D-5) THEN
          WRITE(6,*) 'HIGHER EXCITED STATES NOT PROGRAMMED'
          CALL STOPGM('SETSYS',' ')
        ENDIF
      ELSE IF(TLSE) THEN
        IF(TSHOP) THEN
C..       initiate open shell ground state 
           ISIN=0
           NELHALF=NEL/2  ! FIXME: AK 2005/07/19  is NEL/2.eq.dble(NEL)/2.0?
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
           DO I=1,NELHALF-1
              F(I)=2.0D0
           ENDDO
           F(NELHALF)=1.0D0
           F(NELHALF+1)=1.0D0
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
           DO I=NELHALF+2,N
              F(I)=0.0D0
           ENDDO
        ELSE
           ISIN=0
           DO I=1,N
             IF(DABS(F(I)-1.D0).LT.1.D-5) ISIN=ISIN+1
           ENDDO
           IF(ISIN.NE.2) THEN
             WRITE(6,*) ' LSE NEEDS TWO SINGLY OCCUPIED STATES',ISIN
             CALL STOPGM('SETSYS',' ')
           ENDIF
        ENDIF
C..find the singly occupied orbitals in LSE
        IALPHA=0
        IBETA=0
        DO I=1,N
          FF=DABS(F(I)-1.D0)
          IF(FF.LT.1.D-5) THEN
            IF(IALPHA.EQ.0) THEN
              IALPHA=I
            ELSE
              IBETA=I
            ENDIF
          ENDIF
        ENDDO
        IF(ABS(IBETA-IALPHA-1.0D0).GT.1.D-5) THEN
          WRITE(6,*) 'HIGHER EXCITED STATES NOT PROGRAMMED'
          CALL STOPGM('SETSYS',' ')
        ENDIF
      ENDIF
C..some setup for surface hopping (get all the occupations right)
      IF(TSHOP) THEN
         EADDSH=EADDSH/(RY*2.D0) 
         IF(TLSD) THEN
            NST_S0=N
            CALL MEMORY(IP_FS0,NST_S0,'FS0')
             NST_S1=NEL/2+1
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
             DO I=1,NST_S0
               FS0(I)=1.D0
             ENDDO
cMcB     ... surface hopping stuff ...
cMcB       store at least NST_S0-NST_S1 ZEROS !
            CALL MEMORY(IP_FS1,NST_S0,'FS1')
            CALL DCOPY(NST_S0,F,1,FS1,1)
cMcB
         ELSE
            NST_S0=N-1
            CALL MEMORY(IP_FS0,NST_S0,'FS0')
            NST_S1=N
            CALL MEMORY(IP_FS1,NST_S1,'FS1')
!$OMP parallel do private(I)
#ifdef __SR11000
*poption parallel, tlocal(I)
#endif
            DO I=1,NST_S0
              FS0(I)=2.D0
            ENDDO
            CALL DCOPY(NST_S1,F,1,FS1,1)
         ENDIF
         NELB2=NST_S1-1
      ENDIF
cmb_ssic Check the number of spin-up/spin-down electrons
      IF(TSIC.AND.TLSD) THEN
        NSIC=ABS(NSUP-NSDOWN)
        WRITE(6,*) 
        WRITE(6,*) ' SIC: NUMBER OF UNPAIRED ELECTRONS =',NSIC
      ENDIF
cmb_ssic
C     ==--------------------------------------------------------------==
C     == KPOINTS                                                      ==
C     ==--------------------------------------------------------------==
      IF(RKPT) THEN
C       Restart k points
        CALL RDKPOINTS
        CALL MEMORY(IP_KGEMAX,NKPTS,'KGEMAX')
        CALL AZZERO(KGEMAX,NKPTS)
        CALL MEMORY(IP_KCNORM,NKPTS,'KCNORM')
        CALL AZZERO(KCNORM,NKPTS)
      ELSE IF(TKPNT .OR. TKPERT) THEN
        IF(TMONKP) THEN
C         Generates k points
          NKPOINT=NK1*NK2*NK3
          IF(TSYMKP) THEN
C           2^3 image per k points
            NKPOINT=8*NKPOINT
          ENDIF
          CALL BZMESH(NKPOINT)
        ELSE    
C         In input and output k points are in cartesian coordinates.
          DO IK=1,NKPTS
            CALL DCOPY(3,RK(1,IK),1,RKT(1),1)
C           We have always inversion symmetry.
C           By convention RK(1,IK)>=0
            IF(RKT(1).LT.0.D0) CALL DSCAL(3,-1.D0,RKT(1),1)
            CALL DCOPY(3,RKT(1),1,RK(1,IK),1)
          ENDDO
          SUMWK=0.D0
          DO IK=1,NKPTS
            SUMWK=SUMWK+WK(IK)
          ENDDO
          IF(SUMWK.EQ.0)CALL STOPGM('RKPNT',
     &         'THE WEIGHT OF KPOINTS ARE EQUAL TO ZERO')
          CALL DSCAL(NKPTS,1.D0/SUMWK,WK(1),1)
        ENDIF
        CALL MEMORY(IP_KGEMAX,NKPTS,'KGEMAX')
        CALL AZZERO(KGEMAX,NKPTS)
        CALL MEMORY(IP_KCNORM,NKPTS,'KCNORM')
        CALL AZZERO(KCNORM,NKPTS)
      ELSE IF(.NOT.TKDP) THEN
        CALL MEMORY(IP_RK,3*NKPTS,'RK')
        CALL MEMORY(IP_WK,NKPTS,'WK')
      ENDIF
C     Definition of F occupation numbers for all kpoints
      IF(TKPNT.AND.NKPTS.GT.1) THEN
        CALL MEMORY(IP_FT,N,'FT')
        CALL DCOPY(N,F(1),1,FT(1),1)
        CALL FREEM(IP_F)
        CALL MEMORY(IP_F,N*NKPTS,'F')
        DO IK=1,NKPTS
          CALL DCOPY(N,FT(1),1,F(N*(IK-1)+1),1)
        ENDDO
        CALL FREEM(IP_FT)
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TSHOP) THEN
        WRITE(6,'(/,A,T60,I6,/,A,T60,I6,/,A,T54,F12.5)')
     &       ' NUMBER OF STATES FOR S0 STATE:',NST_S0,
     &       ' NUMBER OF STATES FOR S1 STATE:',NST_S1,
     &       ' NUMBER OF ELECTRONS:',NEL
      ELSE
        WRITE(6,'(/,A,T60,I6,/,A,T54,F12.5)')
     &       ' NUMBER OF STATES:',N,
     &       ' NUMBER OF ELECTRONS:',NEL
      ENDIF
      WRITE(6,'(A,T54,F12.5)') ' CHARGE:  ',CHARGE
      WRITE(6,'(A,T54,F12.5)')
     &     ' ELECTRON TEMPERATURE(KELVIN):  ',BETAEL
      IF(BETAEL.GT.0.D0) THEN
         BETAEL=1.D0/(BETAEL*1.380662D-23/1.60219D-19/13.6058D0/2.D0)
      ELSE
         BETAEL=BETAELMAX
      ENDIF
C     ==--------------------------------------------------------------==
      IF (TSHOP) THEN
cMcB    ... surface hopping has to treat ground  a n d  excited state
         IF (TLSD) THEN
            WRITE(6,'(/2A)') ' SURFACE HOPPING: ',
     .                                    ' GROUND STATE (UNRESTRICTED)'
            IF(NSPIN.LE.10) THEN
              WRITE(6,'(A,T59,A7)')  ' SPIN MULTIPLICITY:',MUL(NSPIN)
            ELSE
              WRITE(6,'(A,T59,I7)')  ' SPIN MULTIPLICITY:',NSPIN
            ENDIF
            WRITE(6,'(A,T61,I5)') ' NUMBER OF ALPHA STATES:',NSUP
            WRITE(6,'(A,T61,I5)') ' NUMBER OF BETA STATES:',NSDOWN
            WRITE(6,'(A)') ' ALPHA OCCUPATION'
            WRITE(6,'(13F5.1)') (F(I),I=1,NSUP)
            WRITE(6,'(A)') ' BETA OCCUPATION'
            WRITE(6,'(13F5.1)') (F(I),I=NSUP+1,N)
         ELSE
            WRITE(6,'(/2A)') ' SURFACE HOPPING: ',
     .                                      ' GROUND STATE (RESTRICTED)'
            WRITE(6,'(A)') ' OCCUPATION'
            WRITE(6,'(13F5.1)') (FS0(I),I=1,NST_S0)
         ENDIF
cMcB    ... set default method for LSE ...
         TROKS=.TRUE.
         WRITE(6,'(/2A)') ' SURFACE HOPPING: ',
     .                    ' LOW SPIN EXCITATION (RESTRICTED OPEN SHELL)'
cMcB    ... repeat print block from below ...
         IF (TROKS) THEN
            WRITE(6,'(A)') ' ROKS: I. FRANK ET AL, JCP 108 p4060 (1998)'
            WRITE(6,'(A,T50,2F8.3)') ' LSE PARAMETERS: ',LSEA,LSEB
            IF ( (LSEA.EQ.2).AND.(LSEB.EQ.-1) ) THEN
               WRITE(6,'(A,T58,A8)') ' SPIN MULTIPLICITY:',MUL(1)
            ELSEIF ( (LSEA.EQ.1).AND.(LSEB.EQ.0) ) THEN
               WRITE(6,'(A,T42,A25)') ' SPIN MULTIPLICITY:',
     .                                        ' MIXTURE SINGLET/TRIPLET'
            ELSEIF ( (LSEA.EQ.0).AND.(LSEB.EQ.1) ) THEN
               WRITE(6,'(A,T58,A8)') ' SPIN MULTIPLICITY:',MUL(3)
            ELSE
               WRITE(6,'(A)') ' CALCULATE THE MULTIPLICITY YOURSELF'
            ENDIF
         ENDIF
         WRITE(6,'(A)') ' OCCUPATION'
         WRITE(6,'(13F5.1)') (F(I),I=1,N)
      ELSEIF (TLSD) THEN
         IF(NSPIN.LE.10) THEN
            WRITE(6,'(A,T59,A7)')  ' SPIN MULTIPLICITY:',MUL(NSPIN)
         ELSE
            WRITE(6,'(A,T59,I7)')  ' SPIN MULTIPLICITY:',NSPIN
         ENDIF
         IF(BSYMM) THEN
           IF(HSPIN.LE.10) THEN
             WRITE(6,'(A,T59,A7)')' HIGH SPIN MULTIPLICITY:',MUL(HSPIN)
           ELSE
             WRITE(6,'(A,T59,I7)')' HIGH SPIN MULTIPLICITY:',HSPIN
           ENDIF
         ENDIF
         WRITE(6,'(A,T61,I5)') ' NUMBER OF ALPHA STATES:',NSUP
         WRITE(6,'(A,T61,I5)') ' NUMBER OF BETA STATES:',NSDOWN
         IF(BSYMM) THEN
           WRITE(6,'(A,T61,I5)')' NUMBER OF HS ALPHA STATES:',HUPEL
           WRITE(6,'(A,T61,I5)')' NUMBER OF HS BETA STATES:',HDOEL
         ENDIF
         WRITE(6,'(A)') ' ALPHA OCCUPATION'
         WRITE(6,'(13F5.1)') (F(I),I=1,NSUP)
         WRITE(6,'(A)') ' BETA OCCUPATION'
         WRITE(6,'(13F5.1)') (F(I),I=NSUP+1,N)
      ELSEIF (TLSE) THEN
         IF(TROS) THEN
           WRITE(6,'(A)') ' RESTRICTED OPEN SHELL KOHN-SHAM (ROKS)'
         ELSE
           WRITE(6,'(A)') ' LOW SPIN EXCITATION (RESTRICTED OPEN SHELL)'
         ENDIF
         IF(TROKS) THEN
           WRITE(6,'(A)') ' ROKS: I. FRANK ET AL, JCP 108 p4060 (1998)'
           WRITE(6,'(A,T50,2F8.3)') ' LSE PARAMETERS: ',LSEA,LSEB
           IF(LSEA.EQ.2.AND.LSEB.EQ.-1)THEN
             WRITE(6,'(A,T58,A8)') ' SPIN MULTIPLICITY:',MUL(1)
           ELSEIF(LSEA.EQ.1.AND.LSEB.EQ.0)THEN
             WRITE(6,'(A,T42,A25)') ' SPIN MULTIPLICITY:',
     *                        ' MIXTURE SINGLET/TRIPLET'
           ELSEIF(LSEA.EQ.0.AND.LSEB.EQ.1)THEN
             WRITE(6,'(A,T58,A8)') ' SPIN MULTIPLICITY:',MUL(3)
           ELSE
             WRITE(6,'(A)') ' CALCULATE THE MULTIPLICITY YOURSELF'
           ENDIF
         ELSEIF(TROOT) THEN
           WRITE(6,'(A)') ' ROKS: ROOTHAAN METHOD '
           WRITE(6,'(A)')' M. Filatov and S. Shaik, JCP 110 p116 (1999)'
           WRITE(6,'(A,T50,2F8.3)') ' LSE PARAMETERS: ',LSEA,LSEB
           IF(LSEA.EQ.2.AND.LSEB.EQ.-1)THEN
             WRITE(6,'(A,T58,A8)') ' SPIN MULTIPLICITY:',MUL(1)
           ELSEIF(LSEA.EQ.1.AND.LSEB.EQ.0)THEN
             WRITE(6,'(A,T42,A25)') ' SPIN MULTIPLICITY:',
     *                        ' MIXTURE SINGLET/TRIPLET'
           ELSEIF(LSEA.EQ.0.AND.LSEB.EQ.1)THEN
             WRITE(6,'(A,T58,A8)') ' SPIN MULTIPLICITY:',MUL(3)
           ELSE
             WRITE(6,'(A)') ' CALCULATE THE MULTIPLICITY YOURSELF'
           ENDIF
         ELSEIF(TROSS) THEN
           WRITE(6,'(A)') 
     *       ' ROSS: J. GRAEFENSTEIN ET AL, CPL 288 p593 (1998) '
           WRITE(6,'(A,T58,A8)') ' SPIN MULTIPLICITY:',MUL(1)
         ELSEIF(TCAS22) THEN
           WRITE(6,'(A)') 
     *       ' CAS22: unpublished method '
           WRITE(6,'(A,T58,A8)') ' SPIN MULTIPLICITY:',MUL(1)
         ENDIF
         IF(TPENAL) THEN
           WRITE(6,'(A)') ' PENALTY FUNCTION ADDED TO ENERGY '
           WRITE(6,'(A,T58,F8.3)') '         PROP. FACTOR',APENAL
         ENDIF
         IF(TMGOE) THEN
            WRITE(6,'(A)')
     *     ' MODIFIED GOEDECKER: GRIMM ET AL JCP 119 p11574 (2003) '
              WRITE(6,'(A,T50,2F8.3)') ' PARAMETERS ', MGMAB, MGMBA
         ENDIF
         IF(TROS) THEN
          WRITE(6,'(A)')
     *     ' MODIFIED GOEDECKER: FRIEDRICHS ET AL'
          WRITE(6,'(A,/,A)') ' CHEM PHYS (2007) (in press)',
     *     ' PARAMETERS'
          WRITE(6,'(A, F5.2,A,F5.2)')' A_AC:',MGAB(1), ' B_AC:',MGAB(2)
          WRITE(6,'(A, F5.2,A,F5.2)')' A_BC:',MGAB(3), ' B_BC:',MGAB(4)
          WRITE(6,'(A, F5.2,A,F5.2)')' A_CA:',MGAB(5), ' B_CA:',MGAB(6)
          WRITE(6,'(A, F5.2,A,F5.2)')' A_CB:',MGAB(7), ' B_CB:',MGAB(8)
          WRITE(6,'(A, F5.2,A,F5.2)')' A_BA:',MGAB(9), ' B_BA:',MGAB(10)
          WRITE(6,'(A, F5.2,A,F5.2)')' A_AB:',MGAB(11),' B_AB:',MGAB(12)
         ENDIF
         IF(TLSETS) THEN
            WRITE(6,'(A)') ' SLATER TRANSITION-STATE DENSITY WITH ROKS '
            WRITE(6,'(A)') ' BILLETER AND EGLI PRB SUBMITTED (2006)'
         ENDIF
         WRITE(6,'(A)') ' OCCUPATION'
         WRITE(6,'(13F5.1)') (F(I),I=1,N)
      ELSE
         WRITE(6,'(A)') ' OCCUPATION'
         WRITE(6,'(13F5.1)') (F(I),I=1,N)
      ENDIF
      IF(TFIXO.AND.TKPNT.AND.NKPTS.NE.1) THEN
        WRITE(6,'(A,/,A)')
     &       ' FIXED OCCUPATION NUMBERS IN COMBINATION WITH',
     &       ' MORE THAN ONE K POINT NOT IMPLEMENTED'
        CALL STOPGM('SETSYS','FIXED OCCUPATION & KPOINTS')
      ENDIF
      IF(TFIXO.AND.TFINT.AND.BETAEL.NE.BETAELMAX) THEN
        WRITE(6,'(A,/,A)')
     &       ' FIXED OCCUPATION NUMBERS IN COMBINATION WITH',
     &       ' ELECTRONIC TEMPERATURE /= 0: INCOMPATIBLE'
        CALL STOPGM('SETSYS',
     &       'FIXED OCCUPATION & ELECTRON TEMPERATURE /= 0')
      ENDIF
      IF(TFIXO) THEN
        WRITE(6,'(A)') ' OCCUPATION NUMBERS FIXED'
      ENDIF
      IF(TLANC.AND.FIXEDKBLOCK) THEN
C       NKRY_BLOCK is fixed in function of N.
        WRITE(6,'(/,A,/,A,T63,I3)')
     *      ' LANCZOS DIAGONALIZATION (KRYLOV SUBSPACE)',
     *       '    MAX. KRYLOV BLOCK SIZE   ',NKRY_BLOCK
      ENDIF
      IF(TONLYDIAG) THEN
C     ONLY ONE DIAGONALIZATION, NO SELF CONSISTENCY
         WRITE(6,'(/,A,/,A,/)')
     *        ' >>>>>>     ONLY ONE DIAGONALIZATION',
     *        '    THE KS ENERGY ARE COMPUTED PER EACH K-POINT   '
         IF(TSPHERE) WRITE(6,'(/,A,/,A,A)')
     *        '!!!!!!!!!!!!!  ACHTUNG ACHTUNG  !!!!!!!!!! ',
     *        'TSPHERE is TRUE, BE SURE OF BUILDING CORRECT',
     *        'WAVEFUNCTIONS, ESPECIALLY IF FROM RESTART' 
      ENDIF
C     ==--------------------------------------------------------------==
C     == PSEUDOPOTENTIALS                                             ==
C     ==--------------------------------------------------------------==
C     IS THERE A NLCC
      if(qmmm)call mm_dim(mm_go_qm,statusdummy)
      TINLC=.FALSE.
      DO IS=1,NSP
        TINLC=TINLC.OR.TNLCC(IS)
      ENDDO
C     IS THERE A VANDERBILT PSEUDOPOTENTIAL?
      TIVAN=.FALSE.
      DO IS=1,NSP
        TIVAN=TIVAN.OR.TVAN(IS)
      ENDDO
      IF(TLSE) THEN
        IF(TIVAN) THEN
          WRITE(6,*) ' VANDERBILT NOT IMPLEMENTED WITH LSE'
          CALL STOPGM('SETSYS',' ')
        ENDIF
        IF(TINLC) THEN
          WRITE(6,*) ' NLCC NOT IMPLEMENTED WITH LSE'
          CALL STOPGM('SETSYS',' ')
        ENDIF
      ENDIF
C     MAXIMAL VALUE OF NGH (GAUSS-HERMIT POINT OR VDB CHANNEL)
      NHXS=1
      DO IS=1,NSP
        IF(TVAN(IS)) THEN
          NT=NVALES(IS)*NBETA(IS)
          NHXS=MAX(NT,NHXS)
        ELSE
          NHXS=MAX(NGH(IS),NHXS)
        ENDIF
      ENDDO
      IF(NHXS.GT.NHX) THEN
        WRITE(6,*) ' PARAMETER NHX TOO SMALL :',NHXS,NHX
        CALL STOPGM('SETSYS',' ')
      ENDIF
C     ==--------------------------------------------------------------==
      WRITE(6,*)
      DO IS=1,NSP
        DO IT=1,ITMAX(IS)
          WRITE(6,'(72A)') VDBTI(IT,IS)
        ENDDO
        WRITE(6,*)
      ENDDO
      WRITE(6,'(1X,64("*"))')
      WRITE(6,9900)
 9900 FORMAT(1X,"*  "," ATOM ","      MASS ","  RAGGIO",
     *   " NLCC ","             PSEUDOPOTENTIAL ","*")
      TSGPALL=.TRUE.
      DO IS=1,NSP
        IT=1
        IF(TKB(IS)) IT=2
        IF(TVAN(IS)) IT=3
        IF(TSGP(IS)) THEN
          IF(TNUM(IS)) THEN
            IT=7
          ELSE
            IT=4
          ENDIF
        ELSE
          TSGPALL=.FALSE.
        ENDIF
        IF(TEAM(IS)) IT=5
        IU=2
        IF(TNLCC(IS)) IU=1
        IF(TVAN(IS)) THEN
          WRITE(6,9901)
     *     EL(IATYP(IS)),PMA0(IS),RAGGIO(IS),INLCC(IU),ISCHEME(IT)
 9901     FORMAT(1X,"* ",3X,A2,2X,F10.4,1X,F8.4,1X,A3,13X,A12,6X,"*")
        ELSEIF(IT.EQ.7) THEN
          WRITE(6,9903)
     *     EL(IATYP(IS)),PMA0(IS),RAGGIO(IS),INLCC(IU),ISCHEME(IT),
     *     LMAX(IS)
 9903     FORMAT(1X,"* ",4X,A2,1X,F10.4,1X,F8.4,
     *              1X,A3,1X,A12,3X,I3,' PROJECTORS',1X,"*")
        ELSE
          K=2
          IF(LLOC(IS).EQ.1.OR.LSKIP(IS).EQ.1) K=1
          IF(K.EQ.1.AND.LMAX(IS).LT.2) IT=6
          WRITE(6,9902)
     *     EL(IATYP(IS)),PMA0(IS),RAGGIO(IS),INLCC(IU),ISCHEME(IT),
     *     CANG(1),CTYP(K)
 9902     FORMAT(1X,"* ",4X,A2,1X,F10.4,1X,F8.4,
     *              1X,A3,1X,A12,6X,A1,A10,1X,"*")
          DO IL=2,LMAX(IS)
            K=2
            IF(LLOC(IS).EQ.IL.OR.LSKIP(IS).EQ.IL) K=1
            WRITE(6,'(1X,"* ",49X,A1,A10,1X,"*")') CANG(IL),CTYP(K)
          ENDDO
          IF(IT.EQ.1)  WRITE(6,'(1X,"* ",31X,A,2X,I3,1X,"*")') 
     *        'GH INTEGRATION POINTS:  ',INT(RMAXN(IS))
        ENDIF
        IF((RAGGIO(IS).GT.ALAT/5.D0).AND.(.NOT.TESR)) THEN
          WRITE(6,'(" * ",A,F8.3,A,T65,"*")')
     &         'WARNING| RAGGIO HAS TO BE LESS THAN ',ALAT/5.D0,
     &         ' (ALAT/5)'
          WRITE(6,'(" * ",A,T65,"*")')
     &         'WARNING| EWALD SUM WILL BE WRONG!'
          WRITE(6,'(" * ",A,T65,"*")')
     &         'WARNING| DECREASE RAGGIO OR USE TESR'
        ENDIF
      ENDDO
      WRITE(6,'(1X,64("*"))')
      WRITE(6,*)
C     ==--------------------------------------------------------------==
 9999 CONTINUE
C     Initialisation for all processors
C     Number of equivalent shell (0 for serial version)
      IF(INDPG.EQ.0) THEN
        NROT=1
        INVERSION=0
        NTVEC=0
        TORIGIN=.FALSE.
        DO I=1,3
          ORIGIN(I)=0.D0
        ENDDO
      ENDIF
      NUMSHEL=0
      NUMCOLD=0
      NNOW=0
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
C TSHOCK
      MSGLEN = 4 * 8/IRAT
      CALL MY_BCAST(VSHOCK,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 2 * 8/IRAT
      CALL MY_BCAST(NHXS,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(CMASS,MSGLEN,SOURCE,ALLGRP)
C     RAGGIO
      MSGLEN = MAXSP * 8
      CALL MY_BCAST(RAGGIO,MSGLEN,SOURCE,ALLGRP)
C     RMASS
      MSGLEN = (2*MAXSP+2) * 8
      CALL MY_BCAST(PMAT0,MSGLEN,SOURCE,ALLGRP)
C     KPOINTS
      MSGLEN = 10 * 8/IRAT
      CALL MY_BCAST(TKPNT,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NKPTS,MSGLEN,SOURCE,ALLGRP)
      IF(.NOT.PARENT) CALL MEMORY(IP_RK,3*NKPTS,'RK')
      MSGLEN = 3*NKPTS * 8
      CALL MY_BCAST(RK,MSGLEN,SOURCE,ALLGRP)
      IF(.NOT.PARENT) CALL MEMORY(IP_WK,NKPTS,'WK')
      MSGLEN = NKPTS * 8
      CALL MY_BCAST(WK,MSGLEN,SOURCE,ALLGRP)

      IF(.NOT.PARENT) THEN 
        CALL MEMORY(IP_KGEMAX,NKPTS,'KGEMAX')
        CALL AZZERO(KGEMAX,NKPTS)
        CALL MEMORY(IP_KCNORM,NKPTS,'KCNORM')
        CALL AZZERO(KCNORM,NKPTS)
      ENDIF

C     ELCT (NEL,CHARGE,F occupation number)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(N,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(CHARGE,MSGLEN,SOURCE,ALLGRP)
      IF(TKPERT) THEN
         IF(.NOT.PARENT) CALL MEMORY(IP_F,N*1,'F')
         MSGLEN = N* 1 * 8
         CALL MY_BCAST(F,MSGLEN,SOURCE,ALLGRP)
      ELSE
         IF(.NOT.PARENT) CALL MEMORY(IP_F,N*NKPTS,'F')
CEHR[
         IF (TMDEH) THEN
           IF(.NOT.PARENT) CALL MEMORY(ip_f_prop,N*NKPTS,'f_prop')
           IF(.NOT.PARENT) CALL MEMORY(ip_f_diag,N*NKPTS,'f_diag')
         ENDIF
CEHR]
         MSGLEN = N*NKPTS * 8
         CALL MY_BCAST(F,MSGLEN,SOURCE,ALLGRP)
CEHR[
         IF (TMDEH) THEN
           MSGLEN = N*NKPTS * 8
           CALL MY_BCAST(F_DIAG,MSGLEN,SOURCE,ALLGRP)
           CALL MY_BCAST(F_PROP,MSGLEN,SOURCE,ALLGRP)
           CALL DCOPY(N*NKPTS,F_PROP(1),1,F(1),1)
         ENDIF
CEHR]
      ENDIF
      MSGLEN = 1 * 8
      CALL MY_BCAST(NEL,MSGLEN,SOURCE,ALLGRP)
C     SPIN
      MSGLEN = 3 * 8/IRAT
      CALL MY_BCAST(NSUP,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 3 * 8/IRAT
      CALL MY_BCAST(NUPEL,MSGLEN,SOURCE,ALLGRP)
C     IONS
      MSGLEN = 6*MAXSP * 8
      CALL MY_BCAST(ZV,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 4*MAXSP * 8/IRAT
      CALL MY_BCAST(IATYP,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 5 * 8/IRAT
      CALL MY_BCAST(NAT,MSGLEN,SOURCE,ALLGRP)
C     TAU0
      MSGLEN = 3*NAX*NSPm * 8
      CALL MY_BCAST(TAU0,MSGLEN,SOURCE,ALLGRP)
C     NLCC
      MSGLEN = (MAXSP+1) * 8/IRAT
      CALL MY_BCAST(TINLC,MSGLEN,SOURCE,ALLGRP)
      IF(TINLC) THEN
        MSGLEN = 4*MAXSP * 8
        CALL MY_BCAST(ANLCC,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 2*MAXSP * 8/IRAT
        CALL MY_BCAST(NLCCT,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MMAXX*NSX_q * 8
        CALL MY_BCAST(RCGRID,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MMAXX*NSX_q * 8
        CALL MY_BCAST(CORECG,MSGLEN,SOURCE,ALLGRP)
      ENDIF
C     NORM CONSERVING PP IN REAL SPACE
      MSGLEN = MMAXX*NSX_q*LMAXX * 8
      CALL MY_BCAST(GNL,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = MMAXX*NSX_q*LMAXX * 8
      CALL MY_BCAST(RPS,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = MMAXX*NSX_q*LMAXX * 8
      CALL MY_BCAST(VR,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = MMAXX*NSX_q * 8
      CALL MY_BCAST(RW,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = MMAXX*NSX_q * 8
      CALL MY_BCAST(RV,MSGLEN,SOURCE,ALLGRP)
C     PSLO
      MSGLEN = (5*MAXSP+1) * 8/IRAT
      CALL MY_BCAST(TIVAN,MSGLEN,SOURCE,ALLGRP)
C  NKRY_BLOCK   
      MSGLEN = MINTE * 8/IRAT
      CALL MY_BCAST(CNTI1,MSGLEN,SOURCE,ALLGRP)
#endif
      IF(TIVAN) THEN
        IF(.NOT.PARENT) THEN
          CALL MEMORY(IP_RSCORE,MMAXX*NSX_q,'RSCORE')
          CALL MEMORY(IP_DION,NBRX*NBRX*NSX_q,'DION')
          CALL MEMORY(IP_BETAR,MMAXX*NBRX*NSX_q,'BETAR')
          CALL MEMORY(IP_QQQ,NBRX*NBRX*NSX_q,'QQQ')
          CALL MEMORY(IP_QFUNC,MMAXX*NBRX*NBRX*NSX_q,'QFUNC')
          CALL MEMORY(IP_QRL,MMAXX*NBRX*NBRX*LX*NSX_q,'QRL')
          CALL MEMORY(IP_R,MMAXX*NSX_q,'R')
          CALL MEMORY(IP_RUCORE,MMAXX*NBRX*NSX_q,'RUCORE')
          CALL MEMORY(IP_RU,MMAXX*NSX_q,'RU')
          CALL MEMORY(IP_RAB,MMAXX*NSX_q,'RAB')
          CALL MEMORY(IP_RSATOM,MMAXX*NSX_q,'RSATOM')
        ENDIF
#ifdef PARALLEL
        MSGLEN = MMAXX*NSX_q * 8
        CALL MY_BCAST(RSCORE,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = NBRX*NBRX*NSX_q * 8
        CALL MY_BCAST(DION,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = NBRX*NBRX*NSX_q * 8
        CALL MY_BCAST(QQQ,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MMAXX*NBRX*NSX_q * 8
        CALL MY_BCAST(BETAR,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MMAXX*NBRX*NBRX*NSX_q * 8
        CALL MY_BCAST(QFUNC,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MMAXX*NBRX*NBRX*LX*NSX_q * 8
        CALL MY_BCAST(QRL,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MMAXX*NSX_q * 8
        CALL MY_BCAST(R,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MMAXX*NBRX*NSX_q * 8
        CALL MY_BCAST(RUCORE,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MMAXX*NSX_q * 8
        CALL MY_BCAST(RAB,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = MMAXX*NSX_q * 8
        CALL MY_BCAST(RSATOM,MSGLEN,SOURCE,ALLGRP)
C       VDBP
        MSGLEN = MAXSP * 8
        CALL MY_BCAST(CMESH,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 5*MAXSP * 8/IRAT
        CALL MY_BCAST(NBETA,MSGLEN,SOURCE,ALLGRP)
#endif
      ENDIF
#ifdef PARALLEL
C     SGPP
      MSGLEN = (1+2*MAXSP) * 8/IRAT
      CALL MY_BCAST(TSGPALL,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = (MAXSP+MAXSP*MCFUN+LMAXX*MAXSP+MPRO*MPRO*LMAXX*MAXSP) * 8
      CALL MY_BCAST(RCSG,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = (LMAXX*MAXSP+LMAXX*LMAXX*MPRO*MAXSP+
     *          LMAXX*LMAXX*MPRO*MAXSP) * 8/IRAT
      CALL MY_BCAST(NPRO,MSGLEN,SOURCE,ALLGRP)
C     DPOT
      MSGLEN = 5*MAXSP * 8/IRAT
      CALL MY_BCAST(TKB,MSGLEN,SOURCE,ALLGRP)
C     SYMMETRY
      MSGLEN = 126 * 8/IRAT
      CALL MY_BCAST(TSYMM,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 7 * 8/IRAT
      CALL MY_BCAST(INDPG,MSGLEN,SOURCE,ALLGRP)
      IF(INDPG.NE.0) THEN
        IF(.NOT.PARENT) THEN
          M=NAT/IRAT + 1
          CALL MEMORY(IP_ISYMU,M,'ISYMU')
          M=120*(NAT+1)/IRAT + 1
          CALL MEMORY(IP_IRT,M,'IRT')
          IF(NTVEC.NE.0) THEN
            M=3*NTVEC
            CALL MEMORY(IP_TVEC,M,'TVEC')
            M=(NAT*NTVEC)/IRAT + 1
            CALL MEMORY(IP_IRTVEC,M,'IRTVEC/S')
          ENDIF
        ENDIF
C       XTABLE,FTABLE,FTAU,ORIGIN,DELTASYM
        MSGLEN = (3*3*120+3*3*120+3*120+3+1) * 8
        CALL MY_BCAST(XTABLE,MSGLEN,SOURCE,ALLGRP)
C       INVE,MULTAB
        MSGLEN = (120 + 120*120) * 8/IRAT
        CALL MY_BCAST(INVE,MSGLEN,SOURCE,ALLGRP)
C       ISYMU
        MSGLEN = NAT * 8/IRAT
        CALL MY_BCAST(ISYMU,MSGLEN,SOURCE,ALLGRP)
C       IRT
        MSGLEN = 120*NAT * 8/IRAT
        CALL MY_BCAST(IRT,MSGLEN,SOURCE,ALLGRP)
        IF(NTVEC.NE.0) THEN
C         TVEC
          MSGLEN = 3*NTVEC * 8
          CALL MY_BCAST(TVEC,MSGLEN,SOURCE,ALLGRP)
          MSGLEN = NAT*NTVEC * 8/IRAT
          CALL MY_BCAST(IRTVEC,MSGLEN,SOURCE,ALLGRP)
        ENDIF
      ELSE
C       Number of rotations.
        NROT=1
C       Number of translation vectors
        NTVEC=0
      ENDIF
C     FDIFF
      MSGLEN = 4 * 8
      CALL MY_BCAST(COORD_FDIFF,MSGLEN,SOURCE,ALLGRP)
C     FINT
      MSGLEN = 3*8 + 3*8/IRAT
      CALL MY_BCAST(BETAEL,MSGLEN,SOURCE,ALLGRP)
C     DENSTROT
      MSGLEN = 2*8/IRAT + MAXTROT*2 * 8
      CALL MY_BCAST(DENSTROT,MSGLEN,SOURCE,ALLGRP)
C     DENSBETAP
      MSGLEN = 3*8/IRAT + MAXBETAP * 8
      CALL MY_BCAST(DENSBETAP,MSGLEN,SOURCE,ALLGRP)
C     ROKS
      MSGLEN = 10 * 8/IRAT
      CALL MY_BCAST(TLSE,MSGLEN,SOURCE,ALLGRP)
C     TLSE orbitals
      IF(TLSE) THEN
        MSGLEN = 2*8/IRAT
        CALL MY_BCAST(IALPHA,MSGLEN,SOURCE,ALLGRP)
      ENDIF
C     SHOP
      IF(TSHOP) THEN
        MSGLEN = 5*8/IRAT 
        CALL MY_BCAST(NST_S0,MSGLEN,SOURCE,ALLGRP) ! shop.inc
        MSGLEN = 1*8
        CALL MY_BCAST(EADDSH,MSGLEN,SOURCE,ALLGRP) 
        IF(.NOT.PARENT) THEN
          CALL MEMORY(IP_FS0,NST_S0,'FS0')
          CALL MEMORY(IP_FS1,NST_S1,'FS1')
        ENDIF
        MSGLEN = NST_S0*8
        CALL MY_BCAST(FS0,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = NST_S1*8
        CALL MY_BCAST(FS1,MSGLEN,SOURCE,ALLGRP)
      ENDIF
C CB: BSYMM
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(BSFAC,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(BSCLCS,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
C     NLM is used by CALC_ALM, EHPSI, SUMFNL, RNLSM1, RNLSM2.
      NLM=0
      DO IS=1,NSP
        IF(TVAN(IS)) THEN
          NLM=NLM+NA(IS)*NVALES(IS)*NBETA(IS)
        ELSE
          NLM=NLM+NA(IS)*NGH(IS)
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
C     define an odd leading dimension for EI1 etc
      NATX = 2*(NAT/2) + 1
      IF(NATX.LT.NAT) CALL STOPGM("SETSYS","NATX.LT.NAT")
C     ==--------------------------------------------------------------==
Ckpt
      IF(.NOT.TKPNT) THEN
        CALL MEMORY(IP_NKPBL,1,'NKPBL')
        NKPBL(1)=1
        CALL MEMORY(IP_KPBEG,1,'KPBEG')
        KPBEG(1)=0
        NKPTALL=1
      ENDIF
      IF(TKPNT.AND.TIVAN) CALL STOPGM('SETSYS',
     &     'K-POINTS WITH VANDERBILT NOT IMPLEMENTED')
      IF(TKPNT.AND.TLOWD) CALL STOPGM('SETSYS',
     &     'K-POINTS WITH LOWDIN ORTHO NOT IMPLEMENTED')
Ckpt
C     ==--------------------------------------------------------------==
      if(qmmm)call mm_dim(mm_go_qm,status) ! because it is needed
      CALL CPL_PARA
      RETURN
      END
C     ==================================================================
