C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == STEFAN GOEDECKER PSEUDOPOTENIAL                              ==
C     ==================================================================
C     == See Goedecker et al., PRB 54 (1996) pp 1703--1710            ==
C     ==================================================================
C     == MPRO  Maximum of projectors for each angular momentum        ==
C     == MCFUN Maximum number of C coefficients for the local part    ==
C     ==--------------------------------------------------------------==
      INTEGER   MPRO,MCFUN
      PARAMETER (MPRO=4,MCFUN=4)
C     ==================================================================
C     == TSGPALL      True if ALL PP are SG PP                        ==
C     == TSGP(MAXSP)  For each specie, true if SG PP                  ==
C     == NCLSG(MAXSP) Number of C coefficient for local part          ==
C     ==--------------------------------------------------------------==
      LOGICAL       TSGPALL,TSGP(MAXSP)
      INTEGER       NCLSG(MAXSP)
      COMMON/SGPP1/ TSGPALL,TSGP,NCLSG
C     ==================================================================
C     == RCSG(MAXSP) R_{loc} local radius                             ==
C     == CLSG(MCFUN,MAXSP) C coefficients for the local potential part==
C     == RCNL(LMAXX,MAXSP) Radius for each ang. mom. quantum number   ==
C     == HLSG(MPRO,MPRO,LMAXX,MAXSP): For each specie give the matrix ==
C     ==     h^l_(i,j) i=1:NPRO(LMAXX,MAXSP)                          ==
C     == NPRO(LMAXX,MAXSP) Number of projectors                       ==
C     == LPVAL(NHX,MAXSP) For each projector gives                    ==
C     ==      the l*m number                                          ==
C     == LFVAL(NHX,MAXSP) For each projector gives the                ==
C     ==      projector number (from 1 to NPRO(LMAXX,MAXSP))          ==
C     == PPLIST(LMAX*MPRO,2,MAXSP) For each projector gives the       ==
C     ==      value l and number of projector within l                ==
C     ==--------------------------------------------------------------==
      REAL*8        RCSG(MAXSP),CLSG(MCFUN,MAXSP),
     *              RCNL(LMAXX,MAXSP),
     *              HLSG(MPRO,MPRO,LMAXX,MAXSP)
      INTEGER       NPRO(LMAXX,MAXSP),LPVAL(LMAXX*LMAXX*MPRO,MAXSP),
     *              LFVAL(LMAXX*LMAXX*MPRO,MAXSP),
     *              PPLIST(LMAXX*MPRO,2,MAXSP)
      COMMON/SGPP2/ RCSG,CLSG,RCNL,HLSG,
     *              NPRO,LPVAL,LFVAL,PPLIST
C     ==================================================================
