C     ==================================================================
      SUBROUTINE LZ_TRANS(TRANSITION,EIGV,NSTATE,NVIR,NPA,NPB,NLR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'irat.inc'
C     Arguments
      INTEGER TRANSITION(3,4,20)
      REAL*8 EIGV(*)
      INTEGER NSTATE,NVIR,NLR,NPA,NPB
C     Variables
      INTEGER  IS,IT,I,IO,IV,ISTAT,NZ,IXST
      CHARACTER STATE(2)*5,STYPE(2)*7
      DATA STATE /"ALPHA","BETA "/
      DATA STYPE /"HOMO - ","TOP -  "/
      LOGICAL OSTDA
C     Variables for SH
      INTEGER IFIRST,FMEM,FOLLOW,MSGLEN
      LOGICAL TEST_SH,EXTRM_RS,EXTRM_NS
      REAL*8  MAXW,MINW,MINE,PAST(20,*),DELTA(20,*)
      POINTER (IP_PAST,PAST),(IP_DELTA,DELTA)
      DATA    IFIRST  /0/
      DATA    MINE    /0.15D0/
      DATA    MINW    /0.075D0/
      DATA    TEST_SH /.FALSE./
      DATA    FOLLOW  /1/
      SAVE    IFIRST,FOLLOW,IP_PAST,IP_DELTA
      SAVE    MINE,MINW
C     ==================================================================
C
      IF (IFIRST.EQ.0) THEN
       CALL MEMORY(IP_PAST,20*10,'PAST')
       CALL MEMORY(IP_DELTA,20*10,'DELTA')
       CALL AZZERO(PAST,200)
       CALL AZZERO(DELTA,200)
      ENDIF
      IFIRST=IFIRST+1
C
      OSTDA=(TDA.AND.MSUBTA.GT.0.AND..NOT.TDACANON)
      IF(PARENT) THEN
        IF(TREORDER.OR.TDLOCAL) THEN
          IXST=2
        ELSE
          IXST=1
        ENDIF
        IF(OSTDA) THEN
          NZ=NUA
        ELSE
          NZ=NSTATE
        ENDIF
C
        MAXW=0.0D0
        FMEM=FSTATE
C
        CALL CHK_EXTRM(FSTATE,PAST,DELTA,EIGV,EXTRM_RS)
C
        DO IS=1,NLR
          TEST_SH=.FALSE.
          IF(IS.NE.FSTATE) CALL CHK_EXTRM(IS,PAST,DELTA,EIGV,EXTRM_NS)
          IF (IFIRST.LT.5) THEN
           TEST_SH=.FALSE.
          ELSE
C          CALL CHK_SH(IS,FSTATE,PAST,DELTA,EIGV,MINE,RY,
C     &                 EXTRM_RS,EXTRM_NS,TEST_SH)
           CALL CHK_LZ(IS,FSTATE,PAST,DELTA,EIGV,MINE,
     &                 EXTRM_RS,EXTRM_NS,TEST_SH)
          ENDIF
          IT=0
          DO I=1,4
            IF(TRANSITION(1,I,IS).EQ.0) GOTO 100
            IT=IT+1
          ENDDO
  100     CONTINUE
          WRITE(6,'(/,A,I3,T42,A,F10.3,A)') " STATE=",IS,
     *                  "EIGENVALUE=",2.D0*RY*EIGV(IS)," eV"
C
          IF (SH_DIAG) THEN
           IF (TLSD) THEN
            DO I=1,IT
              IO=TRANSITION(1,I,IS)
              IF(IO.GT.NSUP) THEN
                ISTAT=2
                IO=NSTATE-IO
              ELSE
                ISTAT=1
                IO=NSUP-IO
              ENDIF
              IV=TRANSITION(2,I,IS)
              IF(IV.GT.NPA) IV=IV-NPA
              WRITE(6,'(T3,A,2X,A,T24,F7.3,T41,A,I3,A,A,I3)')
     *          " TRANSITION ",STATE(ISTAT),
     *          (REAL(TRANSITION(3,I,IS))/10000.D0)**2,
     *          STYPE(IXST),IO," --> ","LUMO + ",IV-1
            ENDDO
           ELSE
            DO I=1,IT
              WRITE(6,'(T10,A,T24,F7.3,T41,A,I3,A,A,I3)')
     *          " TRANSITION ",
     *          (REAL(TRANSITION(3,I,IS))/10000.D0)**2,
     *          STYPE(IXST),NZ-TRANSITION(1,I,IS)," --> ",
     *          "LUMO + ",TRANSITION(2,I,IS)-1
            ENDDO
C
           ENDIF
          ENDIF
C         ----------------------------------------------------------
          IF (TMDBO) THEN
             IF (TEST_SH) THEN
              FSTATE=IS
              IFIRST=1
             ENDIF
          ENDIF
C         -----------------------------------------------------------
        ENDDO
      ENDIF
      IF ((FMEM.NE.FSTATE).AND.(TMDBO)) THEN
       IF (PARENT) WRITE(6,'(/,A,I4,A,I4,A)')
     &  ' ----------  TRANSITION TO NEW STATE: ',
     &              FMEM,'  TO ', FSTATE, "   ----------"
      ENDIF
#ifdef PARALLEL
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(FSTATE,MSGLEN,SOURCE,ALLGRP)
#endif
      IF(PARENT.AND.TMDBO) WRITE(6,'(/,A,I4)')" RUN ON STATE ",FSTATE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CHK_EXTRM(RS,PAST,DELTA,EIGV,EXTRM)
C     ==--------------------------------------------------------------==
C     Arguments
      INTEGER  RS
      REAL*8   PAST(20,*),DELTA(20,*),EIGV(*)
      LOGICAL  EXTRM
C     Variable
      INTEGER  I
C     ==================================================================
      EXTRM=.FALSE.
      DO I=9,1,-1
       PAST(RS,I+1)=PAST(RS,I)
      ENDDO
      PAST(RS,1)=EIGV(RS)
      DO I=1,9
       DELTA(RS,I)=PAST(RS,I+1)-PAST(RS,I)
      ENDDO
      IF ( ((DELTA(RS,1)*DELTA(RS,2)).LT.0.D0) .OR.
     &     ((DELTA(RS,1)*DELTA(RS,3)).LT.0.D0) .OR.
     &     ((DELTA(RS,1)*DELTA(RS,4)).LT.0.D0) ) EXTRM=.TRUE.
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CHK_SH(NS,RS,PAST,DELTA,EIGV,MINE,RY,
     &                  EXTRM_RS,EXTRM_NS,TEST_SH)
C     ==--------------------------------------------------------------==
C     Arguments
      INTEGER NS,RS
      REAL*8  PAST(20,*),DELTA(20,*),MINE,EIGV(*),RY
      LOGICAL EXTRM_RS,EXTRM_NS,TEST_SH
C     Variables
      LOGICAl SMALLGAP
C     ==================================================================
      TEST_SH=.FALSE.
      SMALLGAP=.FALSE.
      IF (NS.EQ.RS) RETURN
      IF (DABS(2.0D0*RY*(EIGV(RS)-EIGV(NS))).LT.MINE) SMALLGAP=.TRUE.
C     IF (EXTRM_RS.AND.EXTRM_NS.AND.SMALLGAP) TEST_SH=.TRUE.
      IF (EXTRM_RS.AND.SMALLGAP) TEST_SH=.TRUE.
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CHK_LZ(NS,RS,PAST,DELTA,EIGV,MINE,
     &                  EXTRM_RS,EXTRM_NS,TEST_SH)
C     ==--------------------------------------------------------------==
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      INTEGER NS,RS
      REAL*8  PAST(20,*),DELTA(20,*),MINE,EIGV(*)
      LOGICAL EXTRM_RS,EXTRM_NS,TEST_SH
C     Variables
      REAL*8  DIFF_ENE(10),MAX_SLOPE,SLOPE,XRANF,TEST,MASSEY,PROB,
     &        MIN_GAP
      EXTERNAL XRANF
      INTEGER I,I_MIN_GAP
      INTEGER MSGLEN
      LOGICAl SMALLGAP,EXTRM_ED,FEXIST,FERROR
      CHARACTER  FILEN*50
      INTEGER    IFIRST
      SAVE       IFIRST
      DATA       IFIRST /0/
C     ==================================================================
C     PROB=1-P is the probability to change (adiab) state
C            P is def in eq 3 of JACS,120,5499,1998
C     ==================================================================
      TEST_SH=.FALSE.
      EXTRM_ED=.FALSE.
      IF (NS.EQ.RS) RETURN
C     IF (.NOT.EXTRM_RS) RETURN
      MIN_GAP=1000.0D0
      I_MIN_GAP=10
      DO I=10,1,-1
        DIFF_ENE(I)=DABS(PAST(RS,I)-PAST(NS,I))
C       IF (DIFF_ENE(I).LT.MIN_GAP) THEN
        IF ((DIFF_ENE(I).LT.MIN_GAP).and.(DIFF_ENE(I).GT.0.D0)) THEN
         MIN_GAP=DIFF_ENE(I)
         I_MIN_GAP=I
        ENDIF
      ENDDO
C     the minimum energy difference is between I=2 and I=3
      IF ((I_MIN_GAP.GT.1).AND.(I_MIN_GAP.LE.3)) EXTRM_ED=.TRUE.
      MAX_SLOPE=0.D0
      DO I=1,10-1
        SLOPE=DABS(DIFF_ENE(I)-DIFF_ENE(I+1))/DT_IONS
        MAX_SLOPE=MAX(MAX_SLOPE,SLOPE)
      ENDDO
      MASSEY=((MIN_GAP/2.D0)**2)/MAX_SLOPE
      PROB=DEXP(-2*PI*MASSEY)
      TEST=XRANF()
      IF (IFIRST.EQ.0) THEN
        FILEN='LANDAU_ZENER.dat'
        INQUIRE(FILE=FILEN,EXIST=FEXIST)
        CALL FILEOPEN(333,FILEN,FO_APP,FERROR)
        IF(.not.FEXIST) THEN
          WRITE(333,'(A50)')
     &    '# RS, NS, PROB, TEST MASSEY, MAX_SLOPE, I_MIN_GAP'
        ENDIF
      ENDIF
      WRITE(333,'(2I4,4(F15.6),I4)')
     &    RS,NS,PROB,TEST,MASSEY,MAX_SLOPE,I_MIN_GAP
      IF (EXTRM_ED.AND.(ABS(NS-RS).EQ.1)) THEN
       WRITE(6,'(/,A,I3,A5,I3,A,F10.6)')
     &    ' LZ TRANSITION PROBABILITY BETWEEN STATES ',
     &    RS,' AND ',NS, ': ',PROB
C       WRITE(6,'(A,F10.6,A,F10.6)') ' PROBABILITY: ',
C     &    PROB,' RANDOM NUMBER: ',TEST
      ENDIF
      IF ((TEST.LT.PROB).AND.(EXTRM_ED).AND.(ABS(NS-RS).EQ.1))
     &  TEST_SH=.TRUE.
      IFIRST=1
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TD_SPECT(C0,C2,RHOE,NTDDFT,CVIRT,SC0,PSI,EDAV,LSCR,SCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'conv.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'tauf.inc'
      INCLUDE 'func.inc'
      INCLUDE 'store.inc'
      INCLUDE 'linres.inc'

C     Arguments
      COMPLEX*16 C0(NGW,*),C2(NGW,*),SC0(*),CVIRT(NGW,*),PSI(*)
      INTEGER    LSCR,NTDDFT
      REAL*8     SCR(*),RHOE(NNR1,*),EDAV(*)
C     Variables
      INTEGER    I,IB,IS,NCSCR,NCONV,NHPSI,NDIAG,NCR
      POINTER    (IP_CSCR,CSCR),(IP_CX,CX),
     &           (IP_VPP,VPP),(IP_CR,CR)
      REAL*8     TAU(*),VTAU(*),VPP(*)
C      REAL*8     ALM,AFNL,BILN
      COMPLEX*16 CSCR(NGW,*),CX(NGW,*),CR(NGW,*)
      LOGICAL    TREFINE,DOLANC,DODAVI,TADJMU
      DIMENSION  POTR(NNR1,*),RHOO(NNR1,*),F(*)
      INTEGER    IFIRST
      DATA       IFIRST /0/
      SAVE       IFIRST
C
      DOLANC=.TRUE.
      DODAVI=.NOT.DOLANC
C
      CALL MEMORY(IP_POTR,NNR1,'POTR')
      IF (NKRY_BLOCK.LE.0) NKRY_BLOCK=NTDDFT

      CALL MY_FLUSH(6)
      IF (NTDDFT.GT.N.AND.IFIRST.EQ.0) THEN
       DO I=N+1,NTDDFT
         CALL RANDTOWF(C0(1,I),1,1,1)
       ENDDO
       IFIRST=IFIRST+1
      ENDIF
      IF(TLSD) THEN
        CALL GSORTHO(C0(1,1),NGW,NUPEL+1,NSUP)
        CALL GSORTHO(C0(1,NSUP+1),NGW,NDOEL+1,NSDOWN)
      ELSE
        CALL GSORTHO(C0,NGW,N+1,NTDDFT)
      ENDIF
      CALL DCOPY(NNR1*NLSD,RHOE,1,POTR,1)
      CALL RHOOFR(C0,RHOE,PSI,SCR,LSCR,NTDDFT)
      CALL DCOPY(NNR1*NLSD,RHOE,1,RHOO,1)

      IF (DOLANC) THEN
       TFRAL=.TRUE.
       TLANC=.FALSE.
       CALL AZZERO(EDAV,NTDDFT)
       NCSCR=2*NGW*MAX(NTDDFT,NKRY_MAX*NKRY_BLOCK)
       CALL MEMORY(IP_CSCR,NCSCR,'CSCR')
       IF(MHFX.NE.0) THEN
         CALL MEMORY(IP_CX,2*NCSCR,'CX')
         CALL DCOPY(2*NGW*NTDDFT,C0,1,CX,1)
       ENDIF
C      IF(PARENT) CALL PRMEM('   SPECTRA')
       IF(TLSD) THEN
          CALL FRIESNER(NSUP,DBLE(NUPEL),NCONV,NHPSI,NUPEL,
     &                  C0,C2,SC0,CSCR,CX,F,POTR(1,1),PSI,EDAV,SCR,LSCR,
     &                  0,TREFINE,.TRUE.)
         NAC=NCONV
         IB=NSUP+1
         ITAUR=2
         CALL FRIESNER(NSDOWN,DBLE(NDOEL),NCONV,NHPSI,NDOEL,
     &            C0(1,IB),C2,SC0,CSCR,CX(1,IB),F(IB),POTR(1,2),PSI,
     &            EDAV(IB),SCR,LSCR,0,TREFINE,.TRUE.)
         ITAUR=1
         NBC=NCONV
         NDIAG=NTDDFT
       ELSE
         NDIAG=NTDDFT
         CALL FRIESNER(NDIAG,NEL,NCONV,NHPSI,NTDDFT,
     &                  C0,C2,SC0,CSCR,CX,F,POTR,PSI,EDAV,SCR,LSCR,
     &                  0,TREFINE,.TRUE.)
         NAC=NCONV
       ENDIF
       CALL FREEM(IP_CSCR)
       IF (MHFX.NE.0) CALL FREEM(IP_CX)
      ELSE
       NDAVV=2*NTDDFT
       CALL AZZERO(EDAV,2*NDAVV)
       NCSCR=2*NGW*NDAVV
       CALL MEMORY(IP_CSCR,NCSCR,'CSCR')
       NCR=2*NGW*NDAVV
       CALL MEMORY(IP_CR,NCR,'CR')
       CALL MEMORY(IP_CX,NCR,'CX')
       CALL MEMORY(IP_VPP,NGW,'VPP')
       CALL KSDIAG(VPP)
       IF(PARENT) CALL PRMEM('   SPECTRA')
       IF(TLSD) THEN
          CALL DCOPY(2*NGW*NSUP,C0,1,CX,1)
          CALL DAVIDSON(NSUP,NDAVV,CX,C2,CR,SC0,CSCR,POTR(1,1),
     &             C0,F,NUPEL,PSI,EDAV,VPP,SCR,LSCR)
          CALL DCOPY(2*NGW*NSUP,CX,1,C0,1)
          IB = NSUP+1
          ITAUR=2
          CALL DCOPY(2*NGW*NSDOWN,C0(1,IB),1,CX,1)
          CALL DAVIDSON(NSDOWN,NDAVV,CX,C2,CR,SC0,CSCR,POTR(1,2),
     &             C0(1,IB),F(IB),NDOEL,PSI,EDAV(NDAVV+1),VPP,SCR,LSCR)
          ITAUR=1
          CALL DCOPY(2*NGW*NSDOWN,CX,1,C0(1,IB),1)
          DO IS=1,NSDOWN
            EDAV(NSUP+IS)=EDAV(NDAVV+IS)
          ENDDO
       ELSE
          NDIAG=NTDDFT
          CALL DCOPY(2*NGW*NDIAG,C0,1,CX,1)
          CALL DAVIDSON(NDIAG,NDAVV,CX,C2,CR,SC0,CSCR,POTR,
     &             C0,F,N,PSI,EDAV,VPP,SCR,LSCR)
          CALL DCOPY(2*NGW*NDIAG,CX,1,C0,1)
       ENDIF
       CALL FREEM(IP_CX)
       CALL FREEM(IP_VPP)
       CALL FREEM(IP_CR)
       CALL FREEM(IP_CSCR)
      ENDIF
      IF(PARENT) THEN
        TADJMU=.TRUE.
        CALL ADJMU(NTDDFT,1,NEL,BETAEL,EDAV,1.D0,TLSD,AMU,TADJMU)
        CALL WREIGEN(EDAV,F,AMU,NTDDFT)
        WRITE(6,'(1X,64("="))')
      ENDIF
C
      RETURN
      END
C     ==================================================================
      SUBROUTINE RESIZE_F
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'linres.inc'
C
      INTEGER    NROOT,NTDDFT,NX,I
      POINTER    (IP_FO,FO)
      REAL*8     FO(*),DASUM
      EXTERNAL   DASUM
      DIMENSION  F(*)

      NROOT=MAX(NS_MIX,NS_SIN,NS_TRI,2)
      NTDDFT=N+NROOT
      CALL MEMORY(IP_FO,NTDDFT,'FO')
      CALL DCOPY(N,F,1,FO,1)
      DO I=N+1,NTDDFT
       FO(I)=0.0D0
      ENDDO
      CALL FREEM(IP_F)
      CALL MEMORY(IP_F,NTDDFT,'F')
      CALL AZZERO(F,NTDDFT)
      IF(TLSD) THEN
        NUPEL=NINT(DASUM(NSUP,FO,1))
        NDOEL=NINT(DASUM(NSDOWN,FO(NSUP+1),1))
        NX=NTDDFT-NSUP-NSDOWN
        NSUP=NSUP+(NX+1)/2
        NSDOWN=NSDOWN+NX/2
        DO I=1,NUPEL
          F(I)=1.D0
        ENDDO
        DO I=NSUP+1,NSUP+NDOEL
          F(I)=1.D0
        ENDDO
      ELSE
        CALL DCOPY(N,FO,1,F,1)
      ENDIF
      CALL FREEM(IP_FO)
C     CALL DCOPY(NTDDFT,F,1,FO,1)

      RETURN
      END
C
C     ==================================================================
      SUBROUTINE TMPRD(PHI,NSTATE,NROOT,ITIME,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'

C     -- Arguments --
      INTEGER    NSTATE,NROOT,ITIME
      COMPLEX*16 PHI(NGW,NSTATE,NROOT)
      CHARACTER  TAG*30

C     -- Variables --
      INTEGER    LEN,N1,NGWX,MAPW(*),I,IP,IPP,MSGID,MSGLEN
      INTEGER    IPW,IG,NBYTES,LST,IROOT
      REAL*8     LENX
      COMPLEX*16 PHISX(*),PHI2(*)
      POINTER    (IP_PHISX,PHISX),(IP_PHI2,PHI2),(IP_MAPW,MAPW)

      IF (PARENT) THEN
         LEN=2*NGWS
      ELSE
         LEN=2*NGW
      ENDIF
      CALL MEMORY(IP_PHISX,LEN,'PHISX')

      IF (PARENT) THEN
         CALL MEMORY(IP_PHI2,2*NGWS,'PHI2')
         CALL MEMORY(IP_MAPW,NGW+1,'MAPW')
      ENDIF

      IF (PARENT) THEN
         OPEN(UNIT=120,FILE=TAG,STATUS='OLD',
     &        FORM='UNFORMATTED')
         READ(120) ITIME
      ENDIF
C     MSGLEN=1 * 8/IRAT
C     CALL MY_BCAST(ITIME,MSGLEN,SOURCE,ALLGRP)

      DO IROOT=1,NROOT
        DO LST=1,NSTATE
            IF (PARENT) THEN
               READ (120) (PHISX(IG),IG=1,NGWS)
            ENDIF

            DO IPP=1,NPROC
               IP=PGROUP(IPP)
               MSGID=IP
               IF (PARENT) THEN
                  IF (IP.EQ.ME) THEN
                     DO IG=1,NGW
                        MAPW(IG)=MAPGP(IG)
                     ENDDO
                  ELSE
                     MSGID=2
                     MSGLEN=SPARM(3,IPP-1)*8/IRAT
                     CALL MY_BRECV(MAPW,MSGLEN,IP,MSGID,NBYTES)
                  ENDIF
                  DO IPW=1,SPARM(3,IPP-1)
                     PHI2(IPW)=PHISX(MAPW(IPW))
                  ENDDO
                  IF (IP.EQ.ME) THEN
                     DO IG=1,NGW
                        PHI(IG,LST,IROOT)=PHI2(IG)
                     ENDDO
                  ELSE
                     MSGID=1
                     MSGLEN=2*SPARM(3,IPP-1)*8
                     CALL MY_BSEND(PHI2,MSGLEN,IP,MSGID)
                  ENDIF
               ELSE
                  IF (IP.EQ.ME) THEN
                     MSGID=2
                     MSGLEN=NGW*8/IRAT
                     CALL MY_BSEND(MAPGP,MSGLEN,SOURCE,MSGID)
                     MSGID=1
                     MSGLEN=2*NGW*8
                     CALL MY_BRECV(PHISX,MSGLEN,SOURCE,MSGID,NBYTES)
                     DO IG=1,NGW
                        PHI(IG,LST,IROOT)=PHISX(IG)
                     ENDDO
                  ENDIF
               ENDIF
            ENDDO
        ENDDO
      ENDDO

      IF (PARENT) CLOSE(120)
      IF (PARENT) THEN
         CALL FREEM(IP_MAPW)
         CALL FREEM(IP_PHI2)
      ENDIF
      CALL FREEM(IP_PHISX)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TMPWR(PHI,NSTATE,NROOT,ITIME,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'

C     -- Arguments --
      INTEGER    NSTATE,NROOT,ITIME
      COMPLEX*16 PHI(NGW,NSTATE,NROOT)
      CHARACTER  TAG*30

C     -- Variables --
      INTEGER    LEN_G,N1,NGWX,MAPW(*),I,IP,IPP,MSGID,MSGLEN
      INTEGER    IPW,IG,NBYTES,LST,IROOT
      REAL*8     LENX
      COMPLEX*16 PHISX(*),PHI2(*)
      POINTER    (IP_PHISX,PHISX),(IP_PHI2,PHI2),(IP_MAPW,MAPW)

      IF (PARENT) THEN
         LEN_G=2*NGWS
      ELSE
         LEN_G=2*NGW
      ENDIF
      CALL MEMORY(IP_PHISX,LEN_G,'PHISX')

      IF (PARENT) THEN
         CALL MEMORY(IP_PHI2,NGWS,'PHI2')
         CALL MEMORY(IP_MAPW,NGW+1,'MAPW')
      ENDIF

      IF (PARENT) THEN
         OPEN(UNIT=120,FILE=TAG,STATUS='UNKNOWN',FORM='UNFORMATTED')
         WRITE(120) ITIME
      ENDIF

#ifdef PARALLEL
      DO IROOT=1,NROOT
        DO LST=1,NSTATE
            DO IPP=1,NPROC
               IP=PGROUP(IPP)
               MSGID=IP
               IF (PARENT) THEN
                  IF (IP.EQ.ME) THEN
                     DO IG=1,NGW
                        PHI2(IG)=PHI(IG,LST,IROOT)
                        MAPW(IG)=MAPGP(IG)
                     ENDDO
                  ELSE
                     MSGID=1
                     MSGLEN=2*SPARM(3,IP)*8
                     CALL MY_BRECV(PHI2,MSGLEN,IP,MSGID,NBYTES)
                     MSGID=2
                     MSGLEN=SPARM(3,IP)*8/IRAT
                     CALL MY_BRECV(MAPW,MSGLEN,IP,MSGID,NBYTES)
                  ENDIF
                  DO IPW=1,SPARM(3,IPP-1)
                     PHISX(MAPW(IPW))=PHI2(IPW)
                  ENDDO
               ELSE
                  IF (IP.EQ.ME) THEN
                     DO IG=1,NGW
                        PHISX(IG)=PHI(IG,LST,IROOT)
                     ENDDO
                     MSGID=1
                     MSGLEN=2*NGW*8
                     CALL MY_BSEND(PHISX,MSGLEN,SOURCE,MSGID)
                     MSGID=2
                     MSGLEN=NGW*8/IRAT
                     CALL MY_BSEND(MAPGP,MSGLEN,SOURCE,MSGID)
                  ENDIF
               ENDIF
            ENDDO
            CALL MY_SYNC(ALLGRP)
            IF (PARENT) THEN
               WRITE (120) (PHISX(IG),IG=1,NGWS)
            ENDIF
        ENDDO
      ENDDO
#else
      DO IROOT=1,NROOT
       DO LST=1,NSTATE
        WRITE (120) (PHI(IG,LST,IROOT),IG=1,NGWK)
       ENDDO
      ENDDO
#endif
      IF (PARENT) CLOSE(120)
      IF (PARENT) THEN
         CALL FREEM(IP_PHI2)
         CALL FREEM(IP_MAPW)
      ENDIF
      CALL FREEM(IP_PHISX)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ADJUSTPHASE(C0,CK,NN,OVLAPM)
C     ==================================================================

      IMPLICIT NONE
      INCLUDE 'system.h'
C
      INTEGER    NN,I
      COMPLEX*16 C0(NGW,*),CK(NGW,*)
      REAL*8     OVLAPM(NN,NN)
C
      CALL AZZERO(OVLAPM,NN*NN)
      CALL OVLAP(NN,OVLAPM,C0,CK)
#ifdef PARALLEL
      CALL GLOSUM(NN*NN,OVLAPM)
#endif
      DO I=1,NN
C       if (parent) write(6,*) 'ovlap:',I,OVLAPM(I,I)
        IF (OVLAPM(I,I).LT.0.0) THEN
         CALL DSCAL(2*NGW,-1.0D0,C0(1,I),1)
        ENDIF
      ENDDO
      CALL OVLAP(NN,OVLAPM,C0,CK)
#ifdef PARALLEL
      CALL GLOSUM(NN*NN,OVLAPM)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ADJUSTPHASE_LR(C1,C1K,NN,NROOT,OVLAPM)
C     ==================================================================

      IMPLICIT NONE
      INCLUDE 'system.h'
C
      INTEGER    NN,NROOT,I,IROOT
      COMPLEX*16 C1(NGW,NN,*),C1K(NGW,NN,*)
      REAL*8     OVLAPM(NN,NN)
C
      DO IROOT=1,NROOT
        CALL AZZERO(OVLAPM,NN*NN)
        CALL OVLAP(NN,OVLAPM,C1(1,1,IROOT),C1K(1,1,IROOT))
#ifdef PARALLEL
        CALL GLOSUM(NN*NN,OVLAPM)
#endif
        DO I=1,NN
C         if (parent) write(6,*) 'ovlap_lr:',I,OVLAPM(I,I)
          IF (OVLAPM(I,I).LT.0.0) THEN
           CALL DSCAL(2*NGW,-1.0D0,C1(1,I,IROOT),1)
          ENDIF
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETSIGMA(C0,C1,NSTATE,NROOT)
C     ==================================================================

      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'linres.inc'
C
C     Arguments
      COMPLEX*16 C0(NGW,*),C1(NGW,NSTATE,*)
      INTEGER    NSTATE,NROOT
C     Variables
      INTEGER    I,J,II,JJ,K1,K2,ID,JD,IG
      INTEGER    X1(*),X2(*),Y1(*),Y2(*)
      REAL*8     SPX,SPY,SP1,SP2,SPU
      REAL*8     SCALMAT(NROOT+1,NROOT+1,NSTATE,*)
      REAL*8     DOTP
      COMPLEX*16 CX1(NGW,*),CX2(NGW,*),CY(NGW,*)
      DIMENSION  CK(NGW,*),C1K(NGW,NSTATE,*)
      DIMENSION  SHSIGMA(2,NROOT+1,*)
      POINTER    (IP_X1,X1),(IP_X2,X2),(IP_Y1,Y1),(IP_Y2,Y2)
      POINTER    (IP_CX1,CX1),(IP_CX2,CX2),(IP_CY,CY)
      POINTER    (IP_SCALMAT,SCALMAT)
C
      CALL MEMORY(IP_CX1,2*NGW*NSTATE,'CX1')
      CALL MEMORY(IP_CX2,2*NGW*NSTATE,'CX2')
      CALL MEMORY(IP_CY,2*NGW*NSTATE,'CY')
      CALL MEMORY(IP_SCALMAT,(NROOT+1)*(NROOT+1)*(NSTATE)*(NSTATE),
     &              'SCALMAT')
      CALL MEMORY(IP_X1,NSTATE,'X1')
      CALL MEMORY(IP_X2,NSTATE,'X2')
      CALL MEMORY(IP_Y1,NSTATE,'Y1')
      CALL MEMORY(IP_Y2,NSTATE,'Y2')
C
C     compute all scalar products
C     i j  indeces of SCALMAT(i,j, . .)
C     --------------------------------------------------------
C     1 1          1 2           1 3          1 4          ...
C     [C0|CK]      [C0|C1K1]     [C0|C1K2]    [C0|C1K3]    ...
C     2 1          2 2           2 3          2 4          ...
C     [C1|CK]      [C1|C1K1]     [C1|C1K2]    [C1|C1K3]    ...
C     ...          ...           ...          ...
C     ...          ...           ...          ...
C
C     where C0 and CK are the ground state orbitals at the two 
C     different times (t and t+dt, respectively).
C     C1  are the linear response orbitals for S1 at time t
C     CK1 are the linear response orbitals for S1 at time t+dt
C     
C     IF (parent) write(6,*) 'start calculation overlap matrices ...'
C     call my_flush(6)

      DO ii=1,NSTATE
       DO jj=1,NSTATE
        SCALMAT(1,1,ii,jj)=DOTP(NGW,C0(1,ii),CK(1,jj))
       ENDDO
      ENDDO
      DO I=1,NROOT
        ID=I+1
        DO ii=1,NSTATE
         DO jj=1,NSTATE
          SCALMAT(ID,1,ii,jj)=DOTP(NGW,C1(1,ii,I),CK(1,jj))
         ENDDO
        ENDDO
      ENDDO
      DO J=1,NROOT
        JD=J+1
        DO ii=1,NSTATE
         DO jj=1,NSTATE
          SCALMAT(1,JD,ii,jj)=DOTP(NGW,C0(1,ii),C1K(1,jj,J))
         ENDDO
        ENDDO
      ENDDO
      DO I=1,NROOT
       ID=I+1
       DO J=1,NROOT
         JD=J+1
         DO ii=1,NSTATE
          DO jj=1,NSTATE
            SCALMAT(ID,JD,ii,jj)=DOTP(NGW,C1(1,ii,I),C1K(1,jj,J))
          ENDDO
         ENDDO
       ENDDO
      ENDDO
C
C     IF (parent) write(6,*) '... end calculation matrices'
C     call my_flush(6)
C      
C     Scalar product of the unexcited spin manifold
      IF (TLSD) THEN
C       not yet implemented
        CALL STOPGM('GETSIGMA','LSD NOT IMPLEMENTED')
      ELSEIF(NS_SIN.NE.0) THEN
       IF (MOD(NINT(NEL),2).EQ.0) THEN
        CALL GETOVERLAP(SPU,C0,CK,NSTATE)
       ELSE
        CALL GETOVERLAP(SPU,C0,CK,NSTATE)
       ENDIF
      ELSEIF(NS_TRI.NE.0) THEN
        CALL GETOVERLAP(SPU,C0,CK,NSTATE)
      ENDIF
C     Scalar product of the excited spin manifold
      DO I=0,NROOT
       ID=I+1
       DO J=I+1,NROOT
          JD=J+1
          SP1=0.D0
          SP2=0.D0
          DO K1=1,NSTATE
           do ii=1,nstate
            x1(ii)=1
           enddo
           IF (I.NE.0) THEN
             x1(k1)=I+1
           ENDIF
           do ii=1,nstate
            y1(ii)=1
           enddo
           IF (I.NE.0) THEN
             y1(k1)=I+1
           ENDIF
           DO K2=1,NSTATE
             do ii=1,nstate
              y2(ii)=1
             enddo
             y2(k2)=J+1
             call getoverlap_index(spx,x1,y2,nroot,nstate,scalmat,1)
             SP1=SP1+SPX
C
             do ii=1,nstate
              x2(ii)=1
             enddo
             x2(k2)=J+1
             call getoverlap_index(spy,y1,x2,nroot,nstate,scalmat,2)
             SP2=SP2+SPY
           ENDDO
          ENDDO 
          SHSIGMA(1,ID,JD)=(SP1*SPU-SP2*SPU)/(2.D0*DT_IONS)
C         if (parent) write(6,'(2I3,3F15.9)') 
C    &                ID,JD,SHSIGMA(1,ID,JD),SP1,SP2
          SHSIGMA(1,JD,ID)=-SHSIGMA(1,ID,JD)
       ENDDO
      ENDDO
C
C     CALL GETSIGMA_OLD(C0,C1,NSTATE,NROOT)

C     IF (PARENT) THEN
C       WRITE(6,*) 'SIGAMA VALUES '
C       DO ID=1,NROOT+1
C        WRITE(6,'(100F15.7)') (SHSIGMA(1,JD,ID),JD=1,NROOT+1)
C       ENDDO
C     ENDIF

      CALL FREEM(IP_Y2)
      CALL FREEM(IP_Y1)
      CALL FREEM(IP_X2)
      CALL FREEM(IP_X1)
      CALL FREEM(IP_SCALMAT)
      CALL FREEM(IP_CY)
      CALL FREEM(IP_CX2)
      CALL FREEM(IP_CX1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETOVERLAP(SP,C1,C2,N1)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'tpar.inc'
C
C     Arguments
      REAL*8      SP
      COMPLEX*16  C1(NGW,*),C2(NGW,*)
      INTEGER     N1
C     Variables
      INTEGER     I,J,MSGLEN
      INTEGER     INFO,ISCR(*)
      REAL*8      DOTP
      REAL*8      OVLAP(N1,*)
      POINTER     (IP_OVLAP,OVLAP)
      POINTER     (IP_ISCR,ISCR)
     
      CALL MEMORY(IP_OVLAP,N1*N1,'OVLAP')
      CALL MEMORY(IP_ISCR,20*(N1/(IRAT)+1),'ISCR')
C
      IF (TLSD) THEN
        IF(PARENT) WRITE(6,*) 'T-SHTDDFT: LSD NOT YET IMPLEMENTED'
        STOP
      ELSE
        CALL AZZERO(OVLAP,N1*N1)
        DO I=1,N1
         DO J=1,N1
           OVLAP(I,J)=DOTP(NGW,C1(1,I),C2(1,J))
         ENDDO
        ENDDO
        MSGLEN=8
#ifdef PARALLEL
        CALL GLOSUM(N1*N1,OVLAP)
        CALL MY_BCAST(OVLAP,N1*N1*MSGLEN,SOURCE,ALLGRP)
#endif
        CALL DGETRF(N1,N1,OVLAP,N1,ISCR,INFO)
        IF(INFO.NE.0) THEN
C     &  call stopgm('ampli','error in matrix inversion (1)')
         IF (PARENT) WRITE(6,*) 'matrix almost singular'
C        DO I=1,N1
C         OVLAP(I,I)=0.D0
C        ENDDO
        ENDIF
        IF (PARENT) THEN
          SP=1.D0
          DO I=1,N1
           SP=SP*OVLAP(I,I)
          ENDDO
        ENDIF
      ENDIF
C
      MSGLEN=8
#ifdef PARALLE
      CALL MY_BCAST(SP,MSGLEN,SOURCE,ALLGRP)
#endif
      CALL FREEM(IP_ISCR)
      CALL FREEM(IP_OVLAP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GETOVERLAP_INDEX(sp,x,y,nroot,n1,scalmat,transp)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'tpar.inc'
C
C     Arguments
      REAL*8      SP, SCALMAT(NROOT+1,NROOT+1,N1,N1)
      INTEGER     X(*),Y(*)
      INTEGER     nroot,N1,transp
C     Variables
      INTEGER     I,J,MSGLEN
      INTEGER     INFO,ISCR(*)
      REAL*8      OVLAP(N1,*)
      POINTER     (IP_OVLAP,OVLAP)
      POINTER     (IP_ISCR,ISCR)
      LOGICAL     SETZERODET
      REAL*8      MAXN,MAXLINE,MAXCOL,TOL
      PARAMETER   (TOL=1.D-3)

      INTEGER     TOTZERO,TOTDET
      SAVE        TOTZERO
      DATA        TOTZERO/0/
      SAVE        TOTDET
      DATA        TOTDET/0/

      CALL MEMORY(IP_OVLAP,N1*N1,'OVLAP')
      CALL MEMORY(IP_ISCR,20*(N1/(IRAT)+1),'ISCR')
C
      SETZERODET=.FALSE.
C     IF IT FINDS A COLUM OR LINE WITH ALL ENTRIES < TOL
C     THE DETERMINANT IS NOT COMPUTED AND IT'S VALUE IS SET 
C     TO ZERO
C
      IF (TLSD) THEN
        IF(PARENT) WRITE(6,*) 'T-SHTDDFT: LSD NOT YET IMPLEMENTED'
        STOP
      ELSE
        CALL AZZERO(OVLAP,N1*N1)
        IF (TRANSP.EQ.1) THEN
         DO J=1,N1
          MAXLINE=0.D0
          DO I=1,N1
           OVLAP(I,J)=SCALMAT(x(I),y(J),I,J)
           MAXLINE=MAX(MAXLINE,DABS(OVLAP(I,J)))
          ENDDO
#ifdef PARALLEL
          CALL GLOMAX(1,MAXLINE)
#endif
          IF (MAXLINE.LE.TOL) SETZERODET=.TRUE.
         ENDDO
        ELSE
         DO I=1,N1
          MAXLINE=0.D0
          DO J=1,N1
           OVLAP(J,I)=SCALMAT(y(I),x(J),I,J)
           MAXLINE=MAX(MAXLINE,DABS(OVLAP(J,I)))
          ENDDO
#ifdef PARALLEL
          CALL GLOMAX(1,MAXLINE)
#endif
          IF (MAXLINE.LE.TOL) SETZERODET=.TRUE.
         ENDDO
        ENDIF
        DO J=1,N1
         MAXCOL=0.D0
         DO I=1,N1
           MAXCOL=MAX(MAXCOL,DABS(OVLAP(I,J)))
         ENDDO
#ifdef PARALLEL
          CALL GLOMAX(1,MAXCOL)
#endif
         IF (MAXCOL.LE.TOL) SETZERODET=.TRUE.
        ENDDO

C       SETZERODET=.FALSE.

        IF (SETZERODET) THEN
          SP=0.D0
          totzero=totzero+1
        ELSE
          totdet=totdet+1
          MSGLEN=8
#ifdef PARALLEL
          CALL GLOSUM(N1*N1,OVLAP)
          CALL MY_BCAST(OVLAP,N1*N1*MSGLEN,SOURCE,ALLGRP)
#endif
          CALL DGETRF(N1,N1,OVLAP,N1,ISCR,INFO)
          IF(INFO.NE.0) THEN
C     &    call stopgm('ampli','error in matrix inversion (1)')
           IF (PARENT) WRITE(6,*) 'matrix almost singular'
C          DO I=1,N1
C           OVLAP(I,I)=0.D0
C          ENDDO
          ENDIF
          IF (PARENT) THEN
           SP=1.D0
           DO I=1,N1
            SP=SP*OVLAP(I,I)
           ENDDO
          ENDIF
        ENDIF
      ENDIF
C
      MSGLEN=8
#ifdef PARALLE
      CALL MY_BCAST(SP,MSGLEN,SOURCE,ALLGRP)
#endif
      CALL FREEM(IP_ISCR)
      CALL FREEM(IP_OVLAP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE UPDATE_SH(NROOT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER    NROOT
C     Variables
      INTEGER    I,J
      DIMENSION  SHSIGMA(2,NROOT+1,*)
      DIMENSION  C_SH(2,NROOT+1),V_SH(2,NROOT+1)
      
      DO I=1,NROOT+1
        C_SH(2,I)=C_SH(1,I)
        V_SH(2,I)=V_SH(1,I)
        DO J=1,NROOT+1
          SHSIGMA(2,I,J)=SHSIGMA(1,I,J)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RSCVP_SH(DT_SH,TEMPP,VELP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_input.inc'

C     Arguments
      REAL*8  DT_SH,TEMPP,VELP(3,NAX,NSP),TARG_TEMP
C     Variables
      REAL*8  ALFAP
      INTEGER K,IS,IA
C     ==--------------------------------------------------------------==
C     ==  Dynamical rescaling factor (targ_temp/tempp), due to        ==
c     ==  surface hop, where tempp is calculated every step           ==
C     ==--------------------------------------------------------------==
      TARG_TEMP=TEMPP+DT_SH
      ALFAP=DSQRT(TARG_TEMP/TEMPP)
      IF (qmmm) THEN
       DO IS=1,NSPq
        DO IA=1,NAq(IS)
          VELP(1,IA,IS)=ALFAP*VELP(1,IA,IS)
          VELP(2,IA,IS)=ALFAP*VELP(2,IA,IS)
          VELP(3,IA,IS)=ALFAP*VELP(3,IA,IS)
        ENDDO
       ENDDO
      ELSE
       DO IS=1,NSP
        DO IA=1,NA(IS)
          VELP(1,IA,IS)=ALFAP*VELP(1,IA,IS)
          VELP(2,IA,IS)=ALFAP*VELP(2,IA,IS)
          VELP(3,IA,IS)=ALFAP*VELP(3,IA,IS)
        ENDDO
       ENDDO
      ENDIF
      WRITE(6,*) 'VELOCITIES ARE RESCALED BY',DT_SH,'K'
      WRITE(6,*) DT_SH/FACTEM, 'HARTREE'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE NORMALIZE_C_SH(NROOT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER NROOT
C     Variables
      INTEGER I
      LOGICAL DEBUG
      REAL*8  SUM2
      DIMENSION C_SH(2,*)

      DEBUG=.FALSE.
      SUM2=0.D0
      DO I=1,NROOT+1
        SUM2=SUM2+REAL(C_SH(1,I)*DCONJG(C_SH(1,I)))
        IF (PARENT.AND.DEBUG) THEN
           WRITE(6,*) 'c_sh(1,', I,')=',C_SH(1,I)
           WRITE(6,*) '|C_SH|^2', I, REAL(C_SH(1,I)*DCONJG(C_SH(1,I)))
        ENDIF
      ENDDO
      IF (PARENT) WRITE(6,*) 'SUM OF ALL (C_SH)^2', SUM2
      DO I=1,NROOT+1
        C_SH(1,I)=C_SH(1,I)/DSQRT(SUM2)
      ENDDO

C      SUM2=0.D0
C      DO I=1,NROOT+1
C        SUM2=SUM2+REAL(C_SH(1,I)*DCONJG(C_SH(1,I)))
C      ENDDO
C      IF (PARENT) WRITE(6,*) 'SUM OF ALL (C_SH)^2 after normalization',
C     &  SUM2
      
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRITE_SHCOEFF(SHPROB,ETOT,NROOT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'linres.inc'
C
C     Arguments
      REAL*8       SHPROB(NROOT+1,NROOT+1),ETOT
      INTEGER      NROOT
      DIMENSION    C_SH(2,*)
      DIMENSION    V_SH(2,*)
      DIMENSION    SHSIGMA(2,NROOT+1,*)
C     Variables
      CHARACTER    FILEN_C_SH*12
      CHARACTER    FILEN_A_SH*12
      CHARACTER    FILEN_V_SH*12
      CHARACTER    FILEN_S_SH*12
      CHARACTER    FILEN_P_SH*12
      CHARACTER    FILEN_E_SH*12
      CHARACTER    FILEN_F_SH*12
      LOGICAL      FEXIST
      INTEGER      IR,IV,IS
      REAL*8       TEMP(10000)
C
      IF (PARENT) THEN
C
       IS=0
       DO IR=1,NROOT+1
        DO IV=1,NROOT+1
         IS=IS+1
         TEMP(IS)=SHSIGMA(1,IR,IV)
        ENDDO
       ENDDO
C
       FILEN_C_SH="SH_COEFC.dat"
       FILEN_A_SH="SH_COEFA.dat"
       FILEN_V_SH="SH_VPOTS.dat"
       FILEN_S_SH="SH_COUPL.dat"
       FILEN_P_SH="SH_PROBS.dat"
       FILEN_E_SH="SH_ENERG.dat"
       FILEN_F_SH="SH_STATE.dat"
      
       FEXIST=.FALSE. 
       INQUIRE(FILE=FILEN_C_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
        OPEN(UNIT=50,FILE=FILEN_C_SH,STATUS='NEW')
       ELSE
        OPEN(UNIT=50,FILE=FILEN_C_SH,STATUS='UNKNOWN',POSITION='APPEND')
       ENDIF
       WRITE(50,'(I10,40F15.9)') SHSTEP, 
     &        (REAL(C_SH(1,IR)),DIMAG(C_SH(1,IR)),IR=1,NROOT+1)
       CLOSE(50)
C
       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_A_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
        OPEN(UNIT=50,FILE=FILEN_A_SH,STATUS='NEW')
       ELSE
        OPEN(UNIT=50,FILE=FILEN_A_SH,STATUS='UNKNOWN',POSITION='APPEND')
       ENDIF
       WRITE(50,'(I10,20F15.9)') SHSTEP,
     &        (DSQRT(REAL(C_SH(1,IR)*DCONJG(C_SH(1,IR)))),IR=1,NROOT+1)
       CLOSE(50)
C
       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_V_SH,EXIST=FEXIST)
        IF(.NOT.FEXIST) THEN
        OPEN(UNIT=50,FILE=FILEN_V_SH,STATUS='NEW')
       ELSE
        OPEN(UNIT=50,FILE=FILEN_V_SH,STATUS='UNKNOWN',POSITION='APPEND')
       ENDIF
       WRITE(50,'(I10,20F15.9)') SHSTEP,
     &        (V_SH(1,IR),IR=1,NROOT+1)
       CLOSE(50)
C
       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_S_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
         OPEN(UNIT=50,FILE=FILEN_S_SH,STATUS='NEW')
       ELSE
       OPEN(UNIT=50,FILE=FILEN_S_SH,STATUS='UNKNOWN',POSITION='APPEND')
       ENDIF
       WRITE(50,'(I10,1000F15.9)') SHSTEP,
     &        (TEMP(IR),IR=1,(NROOT+1)*(NROOT+1))
       CLOSE(50)
C
       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_P_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
        OPEN(UNIT=50,FILE=FILEN_P_SH,STATUS='NEW')
       ELSE
        OPEN(UNIT=50,FILE=FILEN_P_SH,STATUS='UNKNOWN',POSITION='APPEND')
       ENDIF
       WRITE(50,'(I10,20F15.9)') SHSTEP,
     &        (SHPROB(IR,FSTATE+1),IR=1,NROOT+1)
       CLOSE(50)
C
       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_E_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
        OPEN(UNIT=50,FILE=FILEN_E_SH,STATUS='NEW')
       ELSE
        OPEN(UNIT=50,FILE=FILEN_E_SH,STATUS='UNKNOWN',POSITION='APPEND')
       ENDIF
       WRITE(50,'(I10,20F15.9)') SHSTEP,
     &        (ETOT+V_SH(1,IR),IR=1,NROOT+1),ETOT+V_SH(1,FSTATE+1)
       CLOSE(50)
C
       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_F_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
        OPEN(UNIT=50,FILE=FILEN_F_SH,STATUS='NEW')
       ELSE
        OPEN(UNIT=50,FILE=FILEN_F_SH,STATUS='UNKNOWN',POSITION='APPEND')
       ENDIF
       WRITE(50,'(2I10)') SHSTEP,FSTATE
       CLOSE(50)
C
       IF (FSTATE.EQ.0) THEN
        S0_SH=.TRUE.
       ELSE
        S0_SH=.FALSE.
       ENDIF

      ENDIF
C
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE READ_SHCOEFF
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'linres.inc'

C     Arguments
      DIMENSION    C_SH(2,*)
      DIMENSION    V_SH(2,*)
      DIMENSION    SHSIGMA(2,NROOT_SH+1,NROOT_SH+1)
C     Variables
      CHARACTER    FILEN_C_SH*12
      CHARACTER    FILEN_A_SH*12
      CHARACTER    FILEN_V_SH*12
      CHARACTER    FILEN_S_SH*12
      CHARACTER    FILEN_P_SH*12
      CHARACTER    FILEN_E_SH*12
      CHARACTER    FILEN_F_SH*12
      LOGICAL      FEXIST
      INTEGER      NROOT,IR,IV,IS,MSGLEN
      REAL*8       TEMP(10000),RE(100),IM(100)
C
      NROOT=NROOT_SH
C
      IF (PARENT) THEN
C
       FILEN_C_SH="SH_COEFC.dat"
       FILEN_A_SH="SH_COEFA.dat"
       FILEN_V_SH="SH_VPOTS.dat"
       FILEN_S_SH="SH_COUPL.dat"
       FILEN_P_SH="SH_PROBS.dat"
       FILEN_E_SH="SH_ENERG.dat"
       FILEN_F_SH="SH_STATE.dat"

       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_C_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
        WRITE(6,*) 'ERROR ON READING SURFACE HOPPING FILES'
        WRITE(6,*) 'FILE SHOULD EXIST'
        STOP
       ELSE
        OPEN(UNIT=50,FILE=FILEN_C_SH,STATUS='UNKNOWN',POSITION='APPEND')
        BACKSPACE(50)
       ENDIF
       READ(50,'(I10,40F15.9)') SHSTEP,
     &        (RE(IR),IM(IR),IR=1,NROOT+1)
       DO IR=1,NROOT+1
        C_SH(2,IR)=RE(IR)+(0.D0,1.D0)*IM(IR)
       ENDDO
       CLOSE(50)
C
       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_V_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
        WRITE(6,*) 'ERROR ON READING SURFACE HOPPING FILES'
        WRITE(6,*) 'FILE SHOULD EXIST'
        STOP
       ELSE
        OPEN(UNIT=50,FILE=FILEN_V_SH,STATUS='UNKNOWN',POSITION='APPEND')
        BACKSPACE(50)
       ENDIF
       READ(50,'(I10,20F15.9)') SHSTEP,
     &        (V_SH(2,IR),IR=1,NROOT+1)
       CLOSE(50)
C
       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_S_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
        WRITE(6,*) 'ERROR ON READING SURFACE HOPPING FILES'
        WRITE(6,*) 'FILE SHOULD EXIST'
        STOP
       ELSE
        OPEN(UNIT=50,FILE=FILEN_S_SH,STATUS='UNKNOWN',POSITION='APPEND')
        BACKSPACE(50)
       ENDIF
       READ(50,'(I10,1000F15.9)') SHSTEP,
     &        (TEMP(IR),IR=1,(NROOT+1)*(NROOT+1))
       CLOSE(50)
C
       IS=0
       DO IR=1,NROOT+1
        DO IV=1,NROOT+1
         IS=IS+1
         SHSIGMA(2,IR,IV)=TEMP(IS)
        ENDDO
       ENDDO 
C
       FEXIST=.FALSE.
       INQUIRE(FILE=FILEN_F_SH,EXIST=FEXIST)
       IF(.NOT.FEXIST) THEN
        WRITE(6,*) 'ERROR ON READING SURFACE HOPPING FILES'
        WRITE(6,*) 'FILE SHOULD EXIST'
        STOP
       ELSE
        OPEN(UNIT=50,FILE=FILEN_F_SH,STATUS='UNKNOWN',POSITION='APPEND')
        BACKSPACE(50)
       ENDIF
       READ(50,'(2I10)') SHSTEP,FSTATE
       CLOSE(50)

       IF (FSTATE.EQ.0) THEN
        S0_SH=.TRUE.
       ELSE
        S0_SH=.FALSE.
       ENDIF

      ENDIF
C
#ifdef PARALLEL     
      MSGLEN=2*2*(NROOT+1) * 8
      CALL MY_BCAST(C_SH,MSGLEN,SOURCE,ALLGRP)
      MSGLEN=2*(NROOT+1) * 8
      CALL MY_BCAST(V_SH,MSGLEN,SOURCE,ALLGRP)
      MSGLEN=2*(NROOT+1)*(NROOT+1) * 8
      CALL MY_BCAST(SHSIGMA,MSGLEN,SOURCE,ALLGRP)
      MSGLEN=1 * 8/IRAT
      CALL MY_BCAST(FSTATE,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(SHSTEP,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(S0_SH,MSGLEN,SOURCE,ALLGRP)
#endif

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SH_EXTPOT
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'linres.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'tpar.inc'
C
C     -- Variables --
      REAL*8  TIME,FREQ,PERIOD
      REAL*8  CAU
      PARAMETER (CAU = 137.0359885D0)

C     APOT IS THE VECTOR POTENTIAL
C     ETPOT IS THE FIELD
C     AAMPL IS THE AMPLITUDE OF THE FIELD (!UNITS!)
C
C     THE PULSE IS HARDCODED IN THE FOLLOWING SECTION.
C     You can use the following parameter read from input:
C     AAMPL : the amplitude of the field
C     ADIR  : the direction of the field (1:X, 2:Y, 3:Z, 4: isotropic)
C     AFREQ : the frequency of the pulse
C     APARA1: additional input parameter that can be used to 
C             describe the pulse 
C     The actual current time is:
C     TIME  : absolute total time
      TIME=SHSTEP*DT_IONS
C     The user needs to provide the expressions for:
C     APOT : value of the vector potential in the direction ADIR
C     ETPOT: corresponding electric field (=- 1/c * dA/dt)
C     -------------------------------------------------------------------
      FREQ=AFREQ
      PERIOD=APARA1
C
      APOT=-AAMPL*DSIN(FREQ*TIME)
C
      ETPOT=(AAMPL/CAU)*FREQ*DCOS(FREQ*TIME)
C     -------------------------------------------------------------------
C
      RETURN      
      END
c     ======================================================================
      subroutine ecoupl(nstate,c0,nroot,c1,eigs,scr,lscr)
c     ======================================================================
      IMPLICIT NONE
      !These from raman_p:
      include 'system.h'
      include 'irat.inc'
      include 'rmas.inc'
      include 'cnst.inc'
      include 'gvec.inc'
      include 'geq0.inc'
      include 'prop.inc'
      include 'metr.inc'
      include 'ddip.inc'
      include 'symm.inc'
      include 'linres.inc'

c     Input:
      integer nstate                                  !n. of occupied states
      complex*16 c0(ngw,nstate)                       !occupied KS orbitals
      integer nroot                           !n. of linear-response vectors
      complex*16 c1(ngw,nstate,nroot)             !linear-response orbitals
      real*8  eigs(*),scr(*)
      real*8 trdip(3)
      integer lscr,i,j,id,jd
      real*8 cau
      parameter (cau = 137.0359885D0)
c     -------------------------------------------------------------
c     Sometimes the scratch space SCR defined in specpt is not big
c     enough for opeigr. A new scratch array SCROS is defined here
c     if needed.
c     -------------------------------------------------------------
c     Local:
      integer ilrv,length,ltr
      character*30 tag
      real*8 SCROS(*)
      pointer (IP_SCROS,SCROS)
      DIMENSION  SHSIGMA(2,NROOT+1,*)
c     ------------------------------------------------------------------
      if(.not.tda) return
      if(tlsd) return
      if(ns_tri.ne.0) return
      if(msubta.gt.0) return
c     ==--------------------------------------------------------------==
      IF (TPGAUTO .or. TMSYM .or. INDPG.NE.0) THEN
         call stopgm('td_ext_pot',
     &       'POINT GROUP symmetry not implemented.')
      ENDIF
c     ==--------------------------------------------------------------==
c     Allocate SCROS
      LENGTH=0
      LTR=0
      CALL GIVE_SCR_OPEIGR(length,tag,nstate)
      IF(LSCR.LT.LENGTH) THEN
        CALL MEMORY(IP_SCROS,length,'SCROS')
        LTR=1
      ELSE
        CALL GET_ADDR(IP_SCROS,SCR)
      ENDIF
      IF (PARENT) CALL PRMEM('     TD_OS')
      IF (PARENT) WRITE(6,'(1X,"LB:",61("-"))')
C     DO ILRV = 1, NROOT
C       CALL td_berry(C0,C1(1,1,ILRV),SCROS,LENGTH,NSTATE,TRDIP)
C     END DO

C     DO I=0,NROOT
       I=0
       DO J=I+1,NROOT
        CALL td_berry(C0,C1(1,1,J),SCROS,LENGTH,NSTATE,TRDIP)
        ID=I+1
        JD=J+1
        IF (ADIR.EQ.1) THEN
C        if (parent) write(6,*) 'ivano',SHSIGMA(1,ID,JD),ETPOT*TRDIP(1)
C        if (ID.EQ.1 .AND. JD.EQ.2 .AND. parent) 
C    &     write(111,*) -APOT/CAU*EIGS(J)*TRDIP(1),eigs(J)
         SHSIGMA(1,ID,JD)=SHSIGMA(1,ID,JD)
     &     -(APOT/CAU)*EIGS(J)*TRDIP(1)
        ELSEIF(ADIR.EQ.2) THEN
         SHSIGMA(1,ID,JD)=SHSIGMA(1,ID,JD)
     &     -(APOT/CAU)*EIGS(J)*TRDIP(2)
        ELSEIF(ADIR.EQ.3) THEN
         SHSIGMA(1,ID,JD)=SHSIGMA(1,ID,JD)
     &     -(APOT/CAU)*EIGS(J)*TRDIP(3)
        ELSEIF(ADIR.EQ.4) THEN
C
         IF (I.EQ.0) THEN
          SHSIGMA(1,ID,JD)=SHSIGMA(1,ID,JD)
     &     -(APOT/CAU)*EIGS(J)*(1.D0/DSQRT(3.D0))*(TRDIP(1)+TRDIP(2)+
     &      TRDIP(3))
         ELSE
          SHSIGMA(1,ID,JD)=SHSIGMA(1,ID,JD)
     &     -(APOT/CAU)*(EIGS(J)-EIGS(I))*(1.D0/DSQRT(3.D0))*(TRDIP(1)
     &      +TRDIP(2)+
     &      TRDIP(3))
         ENDIF
        ENDIF
        SHSIGMA(1,JD,ID)=-SHSIGMA(1,ID,JD)
       ENDDO
C     ENDDO

      IF(LTR.EQ.1) CALL FREEM(IP_SCROS)
      return
      end
C     ==================================================================
      subroutine td_berry(c0,c1,scr,lscr,nstate,trdip)
c     ==================================================================
      implicit none
      include 'system.h'
      include 'irat.inc'
      include 'rmas.inc'
      include 'cnst.inc'
      include 'gvec.inc'
      include 'geq0.inc'
      include 'prop.inc'
      include 'metr.inc'
      include 'ddip.inc'
      include 'linres.inc'
c     Input:
      integer    nstate                        !Number of KS/lr orbitals
      complex*16 c0(ngw,nstate)         !Ground state Kohn-Sham orbitals
      complex*16 c1(ngw,nstate)                !Linear response orbitals
      integer    lscr                              !Scratch space length
      real*8     scr(*)                                         !Scratch
      real*8     trdip(3)

c     Local:
      complex*16 cwork(ngw,nstate,2)                         !Work array
      complex*16 cw(ngw,nstate)                              !Work array
      complex*16 work(*)                                     !Work array
      complex*16 sc0(*)                                         !Scratch
      complex*16 ddmat_p(nstate,nstate) !Opeigr matrix (lately inverted)
      complex*16 ddmat_1(nstate,nstate)  !Opeigr matrix (never inverted)
      complex*16 f_raman(ngw,nstate,3)         !Generalised perturbation
      complex*16 dd
      integer    ipiv(*)                          !For matrix operations
      integer    isub,il_framan,il_cw,il_cw1
      integer    i,j,k,k2,ifirst,ig,id,jd
#ifdef PARALLEL
      integer nxxfun
      external nxxfun
#endif
      integer    nxx, n1, nop1, nop2, nop3, is1, info, nmcol
      complex*16 cone,czero
      real*8 ox, d, f3, f4, a, b, c, spinfac
c     Output:
      real*8 osx, osy, osz                          !"Transition dipole"

      pointer (ip_ipiv,ipiv),(ip_work,work)
      pointer (ip_ddmat_p,ddmat_p)
      pointer (ip_ddmat_1,ddmat_1)
      pointer (ip_cwork,cwork)
      integer mapful(*), mapcol(*)
      pointer (ip_mapful,mapful),(ip_mapcol,mapcol)
      pointer (ip_cw,cw),(ip_f_raman,f_raman)
      pointer (ip_sc0,sc0)

      save    ip_cwork,ip_mapful,ip_mapcol,ifirst
      character  tag*30
      data       ifirst/0/
c     ------------------------------------------------------------------
      call tiset('    td_os_raman_p',isub)
      cone=dcmplx(1.d0,0.d0)
      czero=dcmplx(0.d0,0.d0)
c     ------------------------------------------------------------------
c     Memory allocations
c     ------------------------------------------------------------------
      il_framan=6*ngw*nstate+12
      il_cw=2*ngw*nstate+8
      il_cw1=4*ngw*nstate
      call memory(ip_f_raman,il_framan,'f_raman')
      call zazzero(f_raman,3*ngw*nstate)
      call memory(ip_ddmat_p,2*nstate*nstate,'ddmat_p')
      call memory(ip_ddmat_1,2*nstate*nstate,'ddmat_1')
      call memory(ip_ipiv,50*(nstate/(irat)+1),'ipiv')
      call memory(ip_work,2*nstate*50,'work')
#ifdef PARALLEL
      LENBK=NXXFUN(NSTATE)
      NXX=MAX(2*LENBK*NPROC,il_cw)
#else
      NXX=il_cw
#endif
      il_cw=nxx
      call memory(ip_sc0,nxx,'sc0')
      call memory(ip_cw,il_cw,'cw')
      call zazzero(cw,il_cw/2)
      if(ifirst.eq.0) then
         n1=0
         do i=0,nproc-1
            n1=max(n1,sparm(3,i))
         enddo
         ngwmax=n1
         call memory(ip_mapful,2*(ngws/irat+1),'mapful')
#ifdef PARALLEL
         nmcol=(nproc*ngwmax)/irat+1
#else
         nmcol=1
#endif
         call memory(ip_mapcol,nmcol,'mapcol')
         call memory(ip_cwork,4*ngw*nstate,'cwork')
         call setdip(mapful,mapcol,scr,lscr)
         ifirst=1
      endif
c     ------------------------------------------------------------------
c.....Spin degeneracy factor
      if(tlsd) then
         spinfac=1.d0
      else
         spinfac=2.d0
      endif
c     ------------------------------------------------------------------
c     Set up phase operator matrices (k=1,3) and f_raman.
c     ------------------------------------------------------------------
      osx = 0.d0
      osy = 0.d0
      osz = 0.d0
      do k=1,3
         call zazzero(cw,il_cw/2)
         call zazzero(ddmat_p,nstate*nstate)
         call zazzero(ddmat_1,nstate*nstate)
         call zazzero(cwork,2*ngw*nstate)
         call azzero(sc0,nxx)
         call zazzero(f_raman,il_framan/2)
c.......Compute cwork = opeigr*c(g) and Q(i,j) = <phi_i | opeigr | phi_j>.
         if(ibrav.eq.1 .or. ibrav.eq.8) then
            nop1=k
            nop2=0
            nop3=0
         else if(ibrav.eq.2) then
            if(k.eq.1) then
               nop1=1
               nop2=2
               nop3=0
            else if(k.eq.2) then
               nop1=1
               nop2=3
               nop3=0
            else
               nop1=2
               nop2=3
               nop3=0
            end if
         else if(ibrav.eq.3) then
            if(k.eq.1) then
               nop1=1
               nop2=-2
               nop3=-3
            else if(k.eq.2) then
               nop1=1
               nop2=2
               nop3=-3
            else
               nop1=1
               nop2=2
               nop3=3
            end if
         else
            write (6,*)
     &       'TD_OS_BERRY: ONLY SUPERCELLS OF TYPE 1,2,3,8 allowed.'
         end if
#ifdef PARALLEL
         call my_sync(allgrp)
#endif
         call opeigr_p(c0,cw,sc0,nstate,mapful,mapcol,ddmat_p,
     &        scr,lscr,nop1,nop2,nop3,dd,cwork)
#ifdef PARALLEL
         call my_sync(allgrp)
#endif
c........Make a copy of ddmat_p (ddmat_p need be inverted).
         call ZCOPY(nstate*nstate,ddmat_p,1,ddmat_1,1)
c     ------------------------------------------------------------------
c     Compute inverse of ddmat_p (Q^-1) for mu=k in Putrino et al.
c     Note ddmat_p is overwrittwen.
c     ------------------------------------------------------------------
         call ZGETRF(nstate,nstate,ddmat_p,nstate,ipiv,info)
         if(info.eq.0) then
            call ZGETRI(nstate,ddmat_p,nstate,ipiv,work,nstate,info)
         else
            call stopgm('td_os_berry','error in matrix inversion')
         endif
c     ------------------------------------------------------------------
c     Build f_raman.
c     ------------------------------------------------------------------
c........cwork(1,*,*) = [opeigr*c(g)] * Q^-1;
c........cwork(2,*,*) = [opeigr*c(-g)] * Q^-1.
         do i=1,2
            call azzero(cw,il_cw)
            call ZGEMM('N','N',ngw,nstate,nstate,cone,cwork(1,1,i)
     &           ,ngw,ddmat_p(1,1),nstate,czero,cw(1,1),ngw)
            call ZCOPY(ngw*nstate,cw(1,1),1,cwork(1,1,i),1)
         end do
         call my_sync(allgrp)
         if(geq0) then
            is1=2
            do i=1,nstate
               b=dimag(cwork(1,i,1))
               f_raman(1,i,k)=dcmplx(b,0.d0)
            end do
         else
            is1=1
         endif
c        This is to have a sum running on ngw below.
         do i=1,nstate
            do ig=is1,ngw
               a=dreal(cwork(ig,i,1))
               b=dimag(cwork(ig,i,1))
               c=dreal(cwork(ig,i,2))
               d=dimag(cwork(ig,i,2))
               f3=a-c
               f4=b+d
               f_raman(ig,i,k)=0.5d0*dcmplx(f4,-f3)
            end do
         end do
c     ------------------------------------------------------------------
c     Compute matrix elements
c     ------------------------------------------------------------------
c.......Compute os = sum_k sum_i <chi_i| opeigr(k) | phi_i> / Q + c.c.
         if(geq0) then
           is1=2
           do i=1,nstate
             ox      =
     >               dreal( dconjg(c1(1,i))*f_raman(1,i,k) )
     >               +dreal( dconjg(f_raman(1,i,k))*c1(1,i) )
             if(k.eq.1) osx = osx + ox
             if(k.eq.2) osy = osy + ox
             if(k.eq.3) osz = osz + ox
           end do
         else
           is1=1
         end if

         do i=1,nstate
           do ig=is1,ngw
             ox      =
     >                2.d0*dreal( dconjg(c1(ig,i))*f_raman(ig,i,k)  )
     >               +2.d0*dreal( dconjg(f_raman(ig,i,k))*c1(ig,i)  )
             if(k.eq.1) osx = osx + ox
             if(k.eq.2) osy = osy + ox
             if(k.eq.3) osz = osz + ox
           end do
         end do
c     ------------------------------------------------------------------
      end do                                    !On cartesian components
#ifdef PARALLEL
      call my_sync(allgrp)
      call summat(osx,1,scr,lscr)
      call summat(osy,1,scr,lscr)
      call summat(osz,1,scr,lscr)
#endif
c
      TRDIP(1)=spinfac*osx
      TRDIP(2)=spinfac*osy
      TRDIP(3)=spinfac*osz
c
      call freem(ip_f_raman)
      call freem(ip_cw)
      call freem(ip_sc0)
      call freem(ip_work)
      call freem(ip_ipiv)
      call freem(ip_ddmat_1)
      call freem(ip_ddmat_p)
      call tihalt('    td_os_raman_p',isub)
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
