C     ==================================================================
      SUBROUTINE CPMDSHAKE(TAU0,TAUP,VELP)
C     ==--------------------------------------------------------------==
C     ==  GENERAL CONSTRAINTS ON POSITIONS FOR VELOCITY VERLET        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      REAL*8    TAU0(3,NAX,*),TAUP(3,NAX,*),VELP(3,NAX,*)
C     Variables
      REAL*8    TOLF,TOLX
      PARAMETER (TOLF=1.D-7,TOLX=1.D-8)
      INTEGER   MAXRAT,MRDIIS
      PARAMETER (MAXRAT=5000,MRDIIS=5)
      REAL*8    TSCR(3,NAX,NSX),DX(*),ASL(MCNSTR,*)
      INTEGER   IPVT(*)
      POINTER   (IP_TSCR,TSCR),(IP_DX,DX),(IP_ASL,ASL),(IP_IPVT,IPVT)
      REAL*8    XLO(MCNSTR,*),ERR(MCNSTR,*),AN0(NODIM,*)
      POINTER   (IP_XLO,XLO),(IP_ERR,ERR),(IP_AN0,AN0)
      REAL*8    V(MRDIIS+1),DIISM(MRDIIS+1,MRDIIS+1),
     &          CNMAX,FACT,ERRF,ERRX,XVAL
      REAL*8    DASUM,DDOT
      EXTERNAL  DASUM,DDOT
      INTEGER   I,J,IS,IA,ITER,K,INFO,IDIIS,M,
     &          ISTART,I_DIM
      DATA      ISTART /0/
      SAVE      ISTART,IP_TSCR,IP_DX,IP_ASL,IP_XLO,IP_ERR,
     *          IP_IPVT,IP_AN0
      LOGICAL   OLDSTATUS
C     ==--------------------------------------------------------------==
C     change constraint value according to growth rate
      DO I=1,MCNSTR
        CNSVAL(I)=CNSVAL(I)+GRATE(I)*DT_IONS
        IF(CNSVAL_DEST(I).NE.-999.D0) THEN
          IF(GRATE(I).GT.0.D0.AND.CNSVAL(I).GT.CNSVAL_DEST(I)) THEN
           CNSVAL(I)=CNSVAL_DEST(I) ! increase
          ELSE IF(GRATE(I).LT.0.D0.AND.CNSVAL(I).LT.CNSVAL_DEST(I)) THEN
           CNSVAL(I)=CNSVAL_DEST(I) ! decrease
          ENDIF
        ENDIF
      ENDDO
C
      CALL DCOPY(MCNSTR,YLAGR(1),1,XLAGR(1),1)
      IF(ISTART.EQ.0) THEN
        ISTART=1
C       AK: we need to make sure that TSCR is large enough for QM/MM
        call mm_dim(mm_go_mm,OLDSTATUS)
        CALL MEMORY(IP_TSCR,3*NAX*NSX,'TSCR')
        CALL MEMORY(IP_DX,3*NODIM,'DX')
        CALL MEMORY(IP_ASL,MCNSTR*MCNSTR,'ASL')
        CALL MEMORY(IP_IPVT,MCNSTR,'IPVT')
        CALL MEMORY(IP_XLO,MCNSTR*MRDIIS,'XLO')
        CALL MEMORY(IP_ERR,MCNSTR*MRDIIS,'ERR')
        CALL MEMORY(IP_AN0,MCNSTR*NODIM,'AN0')
        CALL AZZERO(XLAGR,MCNSTR)
        IF(LSHOVE) CALL MEMORY(IP_KSHOVE,MCNSTR,'KSHOVE')
        call mm_dim(mm_revert,OLDSTATUS)
      ENDIF
      CALL AZZERO(DX,NODIM)
      CALL CNSTFC(TAU0,TSCR,DX,CNMAX,.TRUE.)
      CALL DCOPY(MCNSTR*NODIM,ANORM(1,1),1,AN0(1,1),1)
      XVAL=MCNSTR
      IF(LSHOVE) THEN
        DO I=1,MCNSTR
          KSHOVE(I)=1.D0
          XVAL=(FV(I)-CNSVAL(I))*NTCNST(6,I)
          IF(XVAL.GT.1.D-14) THEN
            KSHOVE(I)=0.D0
            CALL AZZERO(ANORM(1,I),NODIM)
            CALL AZZERO(AN0(1,I),NODIM)
            CNSVAL(I)=FV(I)
            XLAGR(I)=0.D0
          ENDIF
        ENDDO
        XVAL=DASUM(MCNSTR,KSHOVE,1)
        IF(XVAL.LT.0.5D0) RETURN
      ENDIF
C     First guess for the force
      CALL AZZERO(DX,NODIM)
      DO I=1,MCNSTR
        DO J=1,NODIM
          DX(J)=DX(J)+XLAGR(I)*AN0(J,I)
        ENDDO
      ENDDO
C     Update the positions
      CALL AZZERO(TSCR,3*NAX*NSX)
      CALL GETTAU(TSCR,DX)
      DO IS=1,NSP
        FACT=-DT_IONS*DTB2MI(IS)
        DO IA=1,NA(IS)
          TAU0(1,IA,IS)=TAUP(1,IA,IS)+FACT*TSCR(1,IA,IS)
          TAU0(2,IA,IS)=TAUP(2,IA,IS)+FACT*TSCR(2,IA,IS)
          TAU0(3,IA,IS)=TAUP(3,IA,IS)+FACT*TSCR(3,IA,IS)
        ENDDO
      ENDDO
C     Iterativ calculation of lambda
      DO ITER=1,MAXRAT
C       Calculate constraint function and forces
C       for the current value of lambda
        CALL AZZERO(DX,NODIM)
        CALL CNSTFC(TAU0,TSCR,DX,CNMAX,.TRUE.)
        CALL DSCAL(MCNSTR,-1.0D0,FC(1),1)
        ERRF=DASUM(MCNSTR,FC(1),1)
        IF(ERRF.LT.TOLF) GOTO 100
C       Derivatives of sigma wrt lambda
        IF (TQMMM) THEN
           DO I=1,MCNSTR
              DO J=1,MCNSTR
                 ASL(I,J)=0.D0
                 DO I_DIM=1,12
                    K=mm_ASKEL(I,I_DIM)
                    IF(K.NE.0)
     &              ASL(I,J)=ASL(I,J)-DT_IONS*DTM(K)*ANORM(K,I)*AN0(K,J)
                 ENDDO
              ENDDO
           ENDDO
        ELSE
           DO I=1,MCNSTR
              DO J=1,MCNSTR
                 ASL(I,J)=0.D0
                 DO K=1,NODIM
                    ASL(I,J)=ASL(I,J)-DT_IONS*DTM(K)*ANORM(K,I)*AN0(K,J)
                 ENDDO
              ENDDO
           ENDDO
        ENDIF
        
C     Solve for asl*cg=fc
C       LAPACK matrix solver
        IF(NINT(XVAL).EQ.MCNSTR) THEN
          INFO=0
          CALL DGESV(MCNSTR,1,ASL,MCNSTR,IPVT,FC,MCNSTR,INFO)
          IF (INFO.NE.0) CALL STOPGM(' CPMDSHAKE|','ERROR IN DGESV')
        ELSE
          CALL SOLVS(MCNSTR,ASL,FC,IPVT)
        ENDIF
        ERRX=DASUM(MCNSTR,FC(1),1)
C       DIIS!
        IDIIS=MOD(ITER-1,MRDIIS)+1
        CALL DCOPY(MCNSTR,XLAGR(1),1,XLO(1,IDIIS),1)
        CALL DCOPY(MCNSTR,FC(1),1,ERR(1,IDIIS),1)
        IF(ITER.GT.MRDIIS) THEN
          M=MRDIIS+1
          CALL AZZERO(DIISM,M*M)
          CALL AZZERO(V,M)
          DO I=1,MRDIIS
            DO J=1,MRDIIS
              DIISM(I,J)=DDOT(MCNSTR,ERR(1,I),1,ERR(1,J),1)
            ENDDO
            DIISM(M,I)=1.D0
            DIISM(I,M)=1.D0
          ENDDO
          V(M)=1.D0
          CALL SOLVE(DIISM,M,M,V)
          CALL AZZERO(FC,MCNSTR)
          CALL AZZERO(XLAGR,MCNSTR)
          DO I=1,MRDIIS
            DO J=1,MCNSTR
              FC(J)=FC(J)+V(I)*ERR(J,I)
              XLAGR(J)=XLAGR(J)+V(I)*XLO(J,I)
            ENDDO
          ENDDO
        ENDIF
        CALL DAXPY(MCNSTR,1.0D0,FC(1),1,XLAGR(1),1)
        IF(ERRX.LT.TOLX) GOTO 100
C       Update forces
        CALL AZZERO(DX,NODIM)
        DO I=1,MCNSTR
          DO J=1,NODIM
            DX(J)=DX(J)+XLAGR(I)*AN0(J,I)
          ENDDO
        ENDDO
C       Update the positions
        CALL AZZERO(TSCR,3*NAX*NSX)
        CALL GETTAU(TSCR,DX)
        DO IS=1,NSP
          FACT=-DT_IONS*DTB2MI(IS)
          DO IA=1,NA(IS)
            TAU0(1,IA,IS)=TAUP(1,IA,IS)+FACT*TSCR(1,IA,IS)
            TAU0(2,IA,IS)=TAUP(2,IA,IS)+FACT*TSCR(2,IA,IS)
            TAU0(3,IA,IS)=TAUP(3,IA,IS)+FACT*TSCR(3,IA,IS)
          ENDDO
        ENDDO
      ENDDO
      WRITE(6,'(2A,I6,A,F10.8,A,F10.8)') ' CPMDSHAKE| DID NOT ',
     &     'CONVERGE AFTER ',ITER,' ITERATIONS. ERRX=',
     &     ERRX, ' TOLX=',TOLX
      CALL STOPGM('CPMDSHAKE',' ')
  100 CONTINUE
      CALL DCOPY(3*NAX*NSX,TAU0(1,1,1),1,TAUP(1,1,1),1)
C     Update velocities
      CALL AZZERO(DX,NODIM)
      DO I=1,MCNSTR
        DO J=1,NODIM
          DX(J)=DX(J)+XLAGR(I)*AN0(J,I)
        ENDDO
      ENDDO
      CALL AZZERO(TSCR,3*NAX*NSX)
      CALL GETTAU(TSCR,DX)
C     FIXME: add OpenMP?? AK
      DO IS=1,NSP
        FACT=-DTB2MI(IS)
        DO IA=1,NA(IS)
          VELP(1,IA,IS)=VELP(1,IA,IS)+FACT*TSCR(1,IA,IS)
          VELP(2,IA,IS)=VELP(2,IA,IS)+FACT*TSCR(2,IA,IS)
          VELP(3,IA,IS)=VELP(3,IA,IS)+FACT*TSCR(3,IA,IS)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SOLVS(M,ASL,FC,IPVT)
      IMPLICIT NONE
      INTEGER M,IPVT(*)
      REAL*8 ASL(M,M),FC(M)
      INTEGER MX
      PARAMETER (MX=100)
      INTEGER IL(MX),I,N,INFO
C     ==--------------------------------------------------------------==
      IF(M.GT.MX) CALL STOPGM('SOLVS','MX')
      N=0
      DO I=1,M
        IF(ABS(ASL(I,I)).GT.1.D-12) THEN
          N=N+1
          IL(I)=N
          IF(I.NE.N) THEN
            CALL DCOPY(M,ASL(1,I),1,ASL(1,N),1)
            CALL DCOPY(M,ASL(I,1),M,ASL(N,1),M)
            FC(N)=FC(I)
          ENDIF
        ELSE
          IL(I)=0
        ENDIF
      ENDDO
      INFO=0
      CALL DGESV(N,1,ASL,M,IPVT,FC,M,INFO)
      IF (INFO.NE.0) CALL STOPGM(' SOLVS|','ERROR IN DGESV')
      CALL DCOPY(N,FC,1,ASL,1)
      DO I=1,M
        IF(IL(I).NE.0) THEN
          FC(I)=ASL(IL(I),1)
        ELSE
          FC(I)=0.D0
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
