      SUBROUTINE sort2 ( arr, n, index )

        IMPLICIT NONE

c       Arguments
        INTEGER n
        REAL*8  arr(1:n)
        INTEGER index(1:n)

c       Local
        INTEGER m, nstack
        PARAMETER ( m = 7, nstack = 50 )
        INTEGER i, l, ib, ir, jstack, k, istack(1:nstack), itemp, j
        REAL*8  a, temp

c-----------------------------------------------------------------------
        DO i = 1, n
           index(i) = i
        END DO
        jstack = 0
        l = 1
        ir = n
1       IF (ir-l.lt.m) THEN
           DO j = l + 1, ir
              a = arr(j)
              ib = index(j)
              DO i = j - 1, 1, -1
                 IF (arr(i).le.a) GO TO 2
                 arr(i+1) = arr(i)
                 index(i+1) = index(i)
              END DO
              i = 0
2             arr(i+1) = a
              index(i+1) = ib
           END DO
           IF (jstack.eq.0) RETURN
           ir = istack(jstack)
           l = istack(jstack-1)
           jstack = jstack - 2
        ELSE
           k = (l+ir)/2
           temp = arr(k)
           arr(k) = arr(l+1)
           arr(l+1) = temp
           itemp = index(k)
           index(k) = index(l+1)
           index(l+1) = itemp
           IF (arr(l+1).gt.arr(ir)) THEN
              temp = arr(l+1)
              arr(l+1) = arr(ir)
              arr(ir) = temp
              itemp = index(l+1)
              index(l+1) = index(ir)
              index(ir) = itemp
           END IF
           IF (arr(l).gt.arr(ir)) THEN
              temp = arr(l)
              arr(l) = arr(ir)
              arr(ir) = temp
              itemp = index(l)
              index(l) = index(ir)
              index(ir) = itemp
           END IF
           IF (arr(l+1).gt.arr(l)) THEN
              temp = arr(l+1)
              arr(l+1) = arr(l)
              arr(l) = temp
              itemp = index(l+1)
              index(l+1) = index(l)
              index(l) = itemp
           END IF
           i = l + 1
           j = ir
           a = arr(l)
           ib = index(l)
3          CONTINUE
           i = i + 1
           IF (arr(i).lt.a) GO TO 3
4          CONTINUE
           j = j - 1
           IF (arr(j).gt.a) GO TO 4
           IF (j.lt.i) GO TO 5
           temp = arr(i)
           arr(i) = arr(j)
           arr(j) = temp
           itemp = index(i)
           index(i) = index(j)
           index(j) = itemp
           GO TO 3
5          arr(l) = arr(j)
           arr(j) = a
           index(l) = index(j)
           index(j) = ib
           jstack = jstack + 2
           IF (jstack.gt.nstack) CALL STOPGM('SORT2','Nstack too small')
           IF (ir-i+1.ge.j-l) THEN
              istack(jstack) = ir
              istack(jstack-1) = i
              ir = j - 1
           ELSE
              istack(jstack) = j - 1
              istack(jstack-1) = l
              l = i
           END IF
        END IF

        GO TO 1

      END

c******************************************************************************

      SUBROUTINE sort2i ( iarr, n, index )

        IMPLICIT NONE

c       Arguments
        INTEGER n
        INTEGER iarr(1:n)
        INTEGER index(1:n)

c       Locals
        INTEGER m, nstack
        PARAMETER ( m = 7, nstack = 50 )
        INTEGER i, l, ib, ir, jstack, k, j
        INTEGER a, temp, istack(1:nstack), itemp

c------------------------------------------------------------------------------

        DO i = 1, n
           index(i) = i
        END DO
        jstack = 0
        l = 1
        ir = n
1       IF (ir-l.lt.m) THEN
           DO j = l + 1, ir
              a = iarr(j)
              ib = index(j)
              DO i = j - 1, 1, -1
                 IF (iarr(i).le.a) GO TO 2
                 iarr(i+1) = iarr(i)
                 index(i+1) = index(i)
              END DO
              i = 0
2             iarr(i+1) = a
              index(i+1) = ib
           END DO
           IF (jstack.eq.0) RETURN
           ir = istack(jstack)
           l = istack(jstack-1)
           jstack = jstack - 2
        ELSE
           k = (l+ir)/2
           temp = iarr(k)
           iarr(k) = iarr(l+1)
           iarr(l+1) = temp
           itemp = index(k)
           index(k) = index(l+1)
           index(l+1) = itemp
           IF (iarr(l+1).gt.iarr(ir)) THEN
              temp = iarr(l+1)
              iarr(l+1) = iarr(ir)
              iarr(ir) = temp
              itemp = index(l+1)
              index(l+1) = index(ir)
              index(ir) = itemp
           END IF
           IF (iarr(l).gt.iarr(ir)) THEN
              temp = iarr(l)
              iarr(l) = iarr(ir)
              iarr(ir) = temp
              itemp = index(l)
              index(l) = index(ir)
              index(ir) = itemp
           END IF
           IF (iarr(l+1).gt.iarr(l)) THEN
              temp = iarr(l+1)
              iarr(l+1) = iarr(l)
              iarr(l) = temp
              itemp = index(l+1)
              index(l+1) = index(l)
              index(l) = itemp
           END IF
           i = l + 1
           j = ir
           a = iarr(l)
           ib = index(l)
3          CONTINUE
           i = i + 1
           IF (iarr(i).lt.a) GO TO 3
4          CONTINUE
           j = j - 1
           IF (iarr(j).gt.a) GO TO 4
           IF (j.lt.i) GO TO 5
           temp = iarr(i)
           iarr(i) = iarr(j)
           iarr(j) = temp
           itemp = index(i)
           index(i) = index(j)
           index(j) = itemp
           GO TO 3
5          iarr(l) = iarr(j)
           iarr(j) = a
           index(l) = index(j)
           index(j) = ib
           jstack = jstack + 2
           IF(jstack.gt.nstack) CALL STOPGM('SORT2I','Nstack too small')
           IF (ir-i+1.ge.j-l) THEN
              istack(jstack) = ir
              istack(jstack-1) = i
              ir = j - 1
           ELSE
              istack(jstack) = j - 1
              istack(jstack-1) = l
              l = i
           END IF
        END IF

        GO TO 1

      END

#ifdef POINTER8

      SUBROUTINE sort2i8 ( iarr, n, index )

        IMPLICIT NONE

c       Arguments
        INTEGER n
        INTEGER*8 iarr(1:n)
        INTEGER index(1:n)

c       Locals
        INTEGER m, nstack
        PARAMETER ( m = 7, nstack = 50 )
        INTEGER i, l, ib, ir, jstack, k, j
        INTEGER istack(1:nstack), itemp
        INTEGER*8 a, temp

c------------------------------------------------------------------------------

        DO i = 1, n
           index(i) = i
        END DO
        jstack = 0
        l = 1
        ir = n
1       IF (ir-l.lt.m) THEN
           DO j = l + 1, ir
              a = iarr(j)
              ib = index(j)
              DO i = j - 1, 1, -1
                 IF (iarr(i).le.a) GO TO 2
                 iarr(i+1) = iarr(i)
                 index(i+1) = index(i)
              END DO
              i = 0
2             iarr(i+1) = a
              index(i+1) = ib
           END DO
           IF (jstack.eq.0) RETURN
           ir = istack(jstack)
           l = istack(jstack-1)
           jstack = jstack - 2
        ELSE
           k = (l+ir)/2
           temp = iarr(k)
           iarr(k) = iarr(l+1)
           iarr(l+1) = temp
           itemp = index(k)
           index(k) = index(l+1)
           index(l+1) = itemp
           IF (iarr(l+1).gt.iarr(ir)) THEN
              temp = iarr(l+1)
              iarr(l+1) = iarr(ir)
              iarr(ir) = temp
              itemp = index(l+1)
              index(l+1) = index(ir)
              index(ir) = itemp
           END IF
           IF (iarr(l).gt.iarr(ir)) THEN
              temp = iarr(l)
              iarr(l) = iarr(ir)
              iarr(ir) = temp
              itemp = index(l)
              index(l) = index(ir)
              index(ir) = itemp
           END IF
           IF (iarr(l+1).gt.iarr(l)) THEN
              temp = iarr(l+1)
              iarr(l+1) = iarr(l)
              iarr(l) = temp
              itemp = index(l+1)
              index(l+1) = index(l)
              index(l) = itemp
           END IF
           i = l + 1
           j = ir
           a = iarr(l)
           ib = index(l)
3          CONTINUE
           i = i + 1
           IF (iarr(i).lt.a) GO TO 3
4          CONTINUE
           j = j - 1
           IF (iarr(j).gt.a) GO TO 4
           IF (j.lt.i) GO TO 5
           temp = iarr(i)
           iarr(i) = iarr(j)
           iarr(j) = temp
           itemp = index(i)
           index(i) = index(j)
           index(j) = itemp
           GO TO 3
5          iarr(l) = iarr(j)
           iarr(j) = a
           index(l) = index(j)
           index(j) = ib
           jstack = jstack + 2
           IF(jstack.gt.nstack)CALL STOPGM('SORT2I8','Nstack too small')
           IF (ir-i+1.ge.j-l) THEN
              istack(jstack) = ir
              istack(jstack-1) = i
              ir = j - 1
           ELSE
              istack(jstack) = j - 1
              istack(jstack-1) = l
              l = i
           END IF
        END IF

        GO TO 1

      END


#endif
