C     ==================================================================
      SUBROUTINE SPECPT 
C     ==--------------------------------------------------------------==
C     ==  ELECTRONIC SPECTRA                                          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'coor.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'mm_dim.inc'
C     Variables
      COMPLEX*16 C0(*),C2(*),SC0(*)
      POINTER    (IP_C0,C0),(IP_C2,C2),(IP_SC0,SC0)
      POINTER    (IP_FO,FO)
      REAL*8     FO(*),DASUM,DU
      EXTERNAL   DASUM
      DIMENSION  F(*)
      INTEGER    NSTATE,NC0,NC2,NSC0,NCN,MS,NO,I,NX
      LOGICAL    statusdummy
C     ==--------------------------------------------------------------==
      IF(TKPNT) THEN
        CALL STOPGM('SPECPT','K-Points not implemented')
      ENDIF
C..input for linear response
      CALL LR_IN
      CALL TDDFT_INPUT
C
      DU=0.D0
      CALL DYNIT(DU,DU,DU,DU,DU,DU,DU)
C
      MS=MAX(NS_MIX,NS_SIN,NS_TRI,2)
      NO=0
      DO I=1,N
        IF(F(I).GT.0.00001D0) NO=NO+1
      ENDDO
      IF(NO+MS.GT.N) THEN
        CALL MEMORY(IP_FO,N,'FO')
        CALL DCOPY(N,F,1,FO,1)
        CALL FREEM(IP_F)
        N=NO+MS
        CALL MEMORY(IP_F,N,'F')
        CALL AZZERO(F,N)
        IF(TLSD) THEN
          NUPEL=NINT(DASUM(NSUP,FO,1))
          NDOEL=NINT(DASUM(NSDOWN,FO(NSUP+1),1))
          NX=N-NSUP-NSDOWN
          NSUP=NSUP+(NX+1)/2
          NSDOWN=NSDOWN+NX/2
          DO I=1,NUPEL
            F(I)=1.D0
          ENDDO
          DO I=NSUP+1,NSUP+NDOEL
            F(I)=1.D0
          ENDDO
        ELSE
          CALL DCOPY(NO,FO,1,F,1)
        ENDIF
        CALL FREEM(IP_FO)
      ENDIF
      NSTATE=N
      IF(.NOT.TLANC) THEN
        IF(NDAVV.EQ.0) THEN
          NDAVV=2*N
        ELSEIF(NDAVV.LT.N+1) THEN
          NDAVV=2*N
        ENDIF
        NC0=2*NGW*NDAVV+8
        NC2=2*NGW*NDAVV+8
      ELSE
        NC0=2*NGW*NSTATE+8
        NC2=2*NGW*NSTATE+8
      ENDIF
      IF(TDA.AND.MSUBTA.GT.0.AND..NOT.TDACANON) THEN
        NSC0=2*NGW*MSUBTA*NLSD+8
      ELSE
        NSC0=1
      ENDIF
      CALL MEMORY(IP_C0,NC0,'C0')
      CALL MEMORY(IP_C2,NC2,'C2')
      CALL MEMORY(IP_SC0,NSC0,'SC0')
      call mm_dim(mm_go_mm,statusdummy) 
      CALL MEMORY(IP_FION,3*NAX*NSX,'FION')
      CALL MEMORY(IP_TAUP,3*NAX*NSX,'TAUP')
      call mm_dim(mm_go_qm,statusdummy) 
C
      CALL SPECTRA(C0,C2,SC0,NO,TAU0,FION)
C
      IF(TMEMCHK) CALL PRINT_MEMORY
      CALL FREEM(IP_C0)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_SC0)
      CALL FREEM(IP_FION)
      CALL FREEM(IP_TAUP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SPECTRA(C0,C2,SC0,NO,TAU0,FION)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'conv.inc'
      INCLUDE 'ddip.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'tauf.inc'
      INCLUDE 'func.inc'
      INCLUDE 'tpot.inc'
      INCLUDE 'mols.inc'
      INCLUDE 'store.inc'
      INCLUDE 'linres.inc'
c     Qmmm
      real*8 EXTF(*)
      include 'efld.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      COMPLEX*16 C0(NGW,*),C2(NGW,*),SC0(*)
      REAL*8  TAU0(*),FION(*)
      INTEGER NO
C     Variables
      REAL*8 EIGV(*),DDXC(*),SCR(*),PME(*),GDE(*),VPP(*),RHOE(NNR1,*)
      REAL*8 EIGT(*),TAUX(*),TAU(*),VTAU(*),DMOM(3),RHOT(NNR1,*)
      COMPLEX*16 PSI(*),C1(*)
      INTEGER ORDER(*)
      POINTER (IP_TAUX,TAUX)
      POINTER (IP_EIGV,EIGV),(IP_DDXC,DDXC),(IP_SCR,SCR)
      POINTER (IP_PME,PME),(IP_GDE,GDE),(IP_VPP,VPP)
      POINTER (IP_RHOE,RHOE),(IP_PSI,PSI)
      POINTER (IP_EIGT,EIGT)
      POINTER (IP_C1,C1), (IP_CVIRT,CVIRT),(IP_RHOT,RHOT)
      POINTER (IP_ORDER,ORDER)
      INTEGER LDDXC,IL_RHOE,IL_PSI,LSCR,NVPP,NGDE,NPME,NDIAG,NVIR,NACT
      INTEGER IS,IG,ID,IG1,IREC(100),TRANSITION(3,4,20),J,K,NTP,NROOT
      DIMENSION  RHOO(NNR1,*),POTR(NNR1,*),F(*),IREOR(*)
      DIMENSION  RTAU(NNR1,*),PTAU(NNR1,*)
      REAL*8 TIME0,TIME1,TIME2,DETOT,ETOTO,TCPU,TIMEF,THL(2),G2
      EXTERNAL TIMEF
      REAL*8 EN,ENA,ENB
      LOGICAL TADJMU,TREFINE,TDASUBOPT
      CHARACTER  TAG*30,ORBITAL*10
      COMPLEX*16 CR(NGW,*),CX(NGW,*),CSCR(NGW,*),CVIRT(NGW,*)
      REAL*8 EDAV(*),FMAT(*)
      POINTER    (IP_CSCR,CSCR),(IP_CR,CR),(IP_CX,CX),(IP_EDAV,EDAV)
      POINTER    (IP_FMAT,FMAT)
      INTEGER    NCSCR,NCONV,NHPSI,IB,NAP,NBP,MTDA,NUS,NCR,NXX,
     *           LOPTIB,KPRINT
#ifdef PARALLEL
      INTEGER NXXFUN
      EXTERNAL NXXFUN
#endif
c  QMMM
      LOGICAL statusdummy,update_pot
      INTEGER COUPL_MODEL0
      SAVE COUPL_MODEL0
C     ==================================================================
      TSYMRHO=.FALSE.
      LRACTIVE=.FALSE.
C
      if(qmmm)then
        if(TEXTFLD)then
          CALL MEMORY(IP_EXTF,KR1*KR2S*KR3S,'EXTF')
          CALL AZZERO(EXTF,KR1*KR2S*KR3S)
        endif
      endif
C
      call mm_dim(mm_go_mm,statusdummy) 
      CALL MEMORY(IP_TAUX,3*NAX*NSX,'TAUX')
      CALL MEMORY(IP_EIGV,N,'EIGV')
      CALL AZZERO(EIGV,N)
      call mm_dim(mm_go_qm,statusdummy) 
C     ==--------------------------------------------------------------==
      LOPTIB=LOPTI
      LOPTI=-1
      IF(TXC_ANALYTIC) THEN
        LDDXC=NNR1*(2*NLSD-1)
      ELSE
        LDDXC=1
      ENDIF
      CALL MEMORY(IP_DDXC,LDDXC,'DDXC')
      IF(PS_TYPE.EQ.1) CALL STOPGM('SPECTRA','HOCKNEY PS not impl.')
C     ==--------------------------------------------------------------==
C     SCR ALLOCATION AND PARTITION (SCRATCH ARRAY).
      CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
      NTP=1
      IF(NS_TRI.GT.0) NTP=2
      CALL MEMORY(IP_RHOE,2*IL_RHOE,'RHOE')
      CALL MEMORY(IP_PSI,NTP*IL_PSI,'PSI')
      CALL GIVE_SCR_SPECTRA(LSCR,TAG)
      CALL MEMORY(IP_SCR,LSCR,'SCR')
C
      IF(TXC_DD_ANA) THEN
        CALL MEMORY(IP_RHOO,NTP*IL_RHOE,'RHOO')
      ELSE
        CALL MEMORY(IP_RHOO,IL_RHOE,'RHOO')
      ENDIF
      CALL MEMORY(IP_POTR,IL_RHOE,'POTR')
      IF(TTAU) THEN
        CALL MEMORY(IP_RTAU,IL_RHOE,'RTAU')
        CALL MEMORY(IP_PTAU,IL_RHOE,'PTAU')
      ENDIF
C
      CALL FNLALLOC(N,.FALSE.,.FALSE.)
C
      IF(TREORDER) THEN
        CALL MEMORY(IP_ORDER,N,'ORDER')
        IF(TDLOCAL) CALL MEMORY(IP_WCENT,3*N,'WCENT')
      ENDIF
      IF(MOLSTAT) THEN
        CALL MEMORY(IP_WCENT,3*N,'WCENT')
      ENDIF
C
      KPRINT=IOUTPUT
C     ==--------------------------------------------------------------==
C     == INITIALISATION                                               ==
C     ==--------------------------------------------------------------==
      TIME0=TIMEF()
C     TIME STEP FUNCTIONS
      MODENS=.FALSE.
      ENGPRI=.FALSE.
      CALSTE=.FALSE.
C     Set IREC to restart file.
      CALL READ_IREC(IREC)
      CALL INITRUN(IREC,C0,C2,SC0,RHOE,PSI,EIGV,SCR,LSCR)
      CALL WRITE_IREC(IREC)
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        CALL PRMEM('   SPECTRA')
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T25,A,T64,"==")')
     &       '   REFERENCE POINT'
        WRITE(6,'(1X,64("="))')
      ENDIF
      CONVWF=.FALSE.
      SDIIS=.TRUE.
      SPCG=.TRUE.
C..allocate additional memory for optimisers
      IF(TSDE) THEN
        NPME = 1
        NGDE = 1
        NVPP = 1
      ELSE IF(DIIS) THEN
        NPME = (NGW*N+8)*MDIIS
        NGDE = ((NGW*N+8)*MDIIS)/4
        NVPP = NGW
      ELSE IF(PCG) THEN
        NPME = 2*NGW*N
        NGDE = 1
        NVPP = NGW
      ELSEIF(PARENT) THEN
        WRITE(6,*) ' WRONG OPTION FOR WAVEFUNCTION OPTIMIZATION'
        CALL STOPGM('SPECTRA',' ')
      ENDIF
      CALL MEMORY(IP_PME,NPME,'PME')
      CALL MEMORY(IP_GDE,NGDE,'GDE')
      CALL MEMORY(IP_VPP,NVPP,'VPP')
C..virtual orbitals
      NVIR=N-NO
      NCSCR=2*NGW*NVIR
      CALL MEMORY(IP_CVIRT,NCSCR,'CVIRT')
      CALL SETSPIN("S",C0,CVIRT,C2)

      if(qmmm) update_pot=.true.

      ETOTO =1.d10
      DO INFW=1,NOMORE
        TIME1=TIMEF()
        if(qmmm .and. INFW.gt.1 ) then
           if(N_CG.eq.0)then
             update_pot=.false. 
           endif
        endif    
C..UPDATE THE WAVEFUNCTIONS
        CALL UPDWF(C0,C2,SC0,TAU0,TAUX,PME,GDE,VPP,EIGV,
     *             RHOE,PSI,SCR,LSCR,NO,.FALSE.,update_pot)
C..PRINTOUT THE EVOLUTION OF THE ITERATIVE OPTIMIZATION
        IF(PARENT) THEN
          DETOT=ETOT-ETOTO
          IF(INFW.EQ.1) DETOT=0.0D0
          TIME2=TIMEF()
          TCPU=(TIME2-TIME1)*0.001D0
          CALL WRPRINT_WFOPT(EIGV,F,AMU,NO,ETOT,ETOTO,
     &         TCPU,GEMAX,CNORM,THL,ENGPRI,INFW,INFW)
          ETOTO=ETOT
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(CONVWF.OR.EXSOFT) GOTO 200
      ENDDO
      CALL SETSPIN("R",C0,CVIRT,C2)
      IF(N.GT.NO) THEN
        IF(TLSD) THEN
          CALL GSORTHO(C0(1,1),NGW,NUPEL+1,NSUP)
          CALL GSORTHO(C0(1,NSUP+1),NGW,NDOEL+1,NSDOWN)
        ELSE
          CALL GSORTHO(C0,NGW,NO+1,N)
        ENDIF
      ENDIF
      IF(PARENT) WRITE(6,*) ' NO CONVERGENCE IN ',INFW,' STEPS '
      call mm_dim(mm_go_mm,statusdummy)
      CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,INFW)
      call mm_dim(mm_go_qm,statusdummy)
      CALL STOPGM('SPECTRA',' ')
C     ==--------------------------------------------------------------==
  200 CONTINUE
C..write restart for soft exit.
      IF(EXSOFT) THEN
        call mm_dim(mm_go_mm,statusdummy)
        CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,INFW)
        RETURN
      ENDIF
      CALL SETSPIN("R",C0,CVIRT,C2)
C..release memory for ground state optimiser
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_PME)
      CALL FREEM(IP_GDE)
C..orthogonalize additional states
      IF(N.GT.NO) THEN
        IF(TLSD) THEN
          CALL GSORTHO(C0(1,1),NGW,NUPEL+1,NSUP)
          CALL GSORTHO(C0(1,NSUP+1),NGW,NDOEL+1,NSDOWN)
        ELSE
          CALL GSORTHO(C0,NGW,NO+1,N)
        ENDIF
      ENDIF
      call mm_dim(mm_go_mm,statusdummy) 
      CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,NFI)
      call mm_dim(mm_go_qm,statusdummy) 
C..store potential and density
      CALL DCOPY(NNR1*NLSD,RHOE,1,POTR,1)
      CALL RHOOFR(C0,RHOE,PSI,SCR,LSCR,N)
      CALL DCOPY(NNR1*NLSD,RHOE,1,RHOO,1)
      IF(TTAU) THEN
        CALL DCOPY(NNR1*NLSD,TAU,1,RTAU,1)
        CALL DCOPY(NNR1*NLSD,VTAU,1,PTAU,1)
      ENDIF
C..NLCC
      IF(TINLC) THEN
        CALL MEMORY(IP_ROCT,NNR1*NLSD,'ROCT')
        CALL AZZERO(ROCT,NNR1*NLSD)
        CALL COREC(ROCT,SCR,PSI)
      ENDIF
      IF(TLSD) CALL MEMORY(IP_RHOT,NNR1*NLSD,'RHOT')
      CALL MEMORY_CHECK
      TIME2=TIMEF()
      TCPU=(TIME2-TIME0)*0.001D0
      IF(PARENT) THEN
         WRITE(6,'(/,A,T46,F12.3,A)') ' TIME FOR MINIMUM STRUCTURE :',
     *               TCPU,' SECONDS'
      ENDIF
      IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
      IF(EXSOFT) RETURN
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        CALL PRMEM('   SPECTRA')
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T20,A,T64,"==")')
     &       'END OF REFERENCE CALCULATION'
        WRITE(6,'(1X,"==",T19,A,T64,"==")')
     &       'GENERATE INITIAL GUESS VECTORS'
        WRITE(6,'(1X,64("="),/)')
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TLANC) THEN
        TFRAL=.TRUE.
        TLANC=.FALSE.
        CALL MEMORY(IP_EDAV,N,'EDAV')
        CALL AZZERO(EDAV,N)
        NCSCR=2*NGW*MAX(N,NKRY_MAX*NKRY_BLOCK)
        CALL MEMORY(IP_CSCR,NCSCR,'CSCR')
        IF(MHFX.NE.0) THEN
          CALL MEMORY(IP_CX,2*NCSCR,'CX')
          CALL DCOPY(2*NGW*N,C0,1,CX,1)
        ENDIF
        IF(TLSD) CALL DCOPY(NNR1*NLSD,POTR(1,1),1,RHOT(1,1),1)
        IF(PARENT) CALL PRMEM('   SPECTRA')
        IF(TLSD) THEN
          IF (TDMAL) THEN
             CALL DIST_FRIESNER(NSUP,DBLE(NUPEL),NCONV,NHPSI,NUPEL,
     &                  C0,C2,SC0,CSCR,CX,F,POTR(1,1),PSI,EDAV,SCR,LSCR,
     &                  0,TREFINE,.TRUE.)
          ELSE
             CALL FRIESNER(NSUP,DBLE(NUPEL),NCONV,NHPSI,NUPEL,
     &                  C0,C2,SC0,CSCR,CX,F,POTR(1,1),PSI,EDAV,SCR,LSCR,
     &                  0,TREFINE,.TRUE.)
          ENDIF   
          IF(TLSD) CALL DCOPY(NNR1*NLSD,RHOT(1,1),1,POTR(1,1),1)
          NAC=NCONV
          IB=NSUP+1
          ITAUR=2
          IF (TDMAL) THEN
            CALL DIST_FRIESNER(NSDOWN,DBLE(NDOEL),NCONV,NHPSI,NDOEL,
     &              C0(1,IB),C2,SC0,CSCR,CX(1,IB),F(IB),POTR(1,2),PSI,
     &              EDAV(IB),SCR,LSCR,0,TREFINE,.TRUE.)
          ELSE
            CALL FRIESNER(NSDOWN,DBLE(NDOEL),NCONV,NHPSI,NDOEL,
     &              C0(1,IB),C2,SC0,CSCR,CX(1,IB),F(IB),POTR(1,2),PSI,
     &              EDAV(IB),SCR,LSCR,0,TREFINE,.TRUE.)
          ENDIF 
          IF(TLSD) CALL DCOPY(NNR1*NLSD,RHOT(1,1),1,POTR(1,1),1)
          ITAUR=1
          NBC=NCONV
          NDIAG=N
        ELSE
          NDIAG=N
          IF (TDMAL) THEN
            CALL DIST_FRIESNER(NDIAG,NEL,NCONV,NHPSI,N,
     &                    C0,C2,SC0,CSCR,CX,F,POTR,PSI,EDAV,SCR,LSCR,
     &                    0,TREFINE,.TRUE.)
          ELSE
            CALL FRIESNER(NDIAG,NEL,NCONV,NHPSI,N,
     &                    C0,C2,SC0,CSCR,CX,F,POTR,PSI,EDAV,SCR,LSCR,
     &                    0,TREFINE,.TRUE.)
          ENDIF
          NAC=NCONV
        ENDIF
        CALL FREEM(IP_CSCR)
        IF(MHFX.NE.0) CALL FREEM(IP_CX)
      ELSEIF(TDAVI) THEN
        CALL MEMORY(IP_EDAV,2*NDAVV,'EDAV')
        CALL AZZERO(EDAV,2*NDAVV)
        NCSCR=2*NGW*NDAVV
        CALL MEMORY(IP_CSCR,NCSCR,'CSCR')
        NCR=2*NGW*NDAVV
        CALL MEMORY(IP_CR,NCR,'CR')
        CALL MEMORY(IP_CX,NCR,'CX')
        CALL MEMORY(IP_VPP,NGW,'VPP')
        CALL KSDIAG(VPP)
        IF(PARENT) CALL PRMEM('   SPECTRA')
        IF(TLSD) THEN
          CALL DCOPY(2*NGW*NSUP,C0,1,CX,1)
          CALL DCOPY(NNR1*NLSD,POTR(1,1),1,RHOT(1,1),1)
          CALL DAVIDSON(NSUP,NDAVV,CX,C2,CR,SC0,CSCR,POTR(1,1),
     &             C0,F,NUPEL,PSI,EDAV,VPP,SCR,LSCR)
          CALL DCOPY(NNR1*NLSD,RHOT(1,1),1,POTR(1,1),1)
          CALL DCOPY(2*NGW*NSUP,CX,1,C0,1)
          IB = NSUP+1
          ITAUR=2
          CALL DCOPY(2*NGW*NSDOWN,C0(1,IB),1,CX,1)
          CALL DAVIDSON(NSDOWN,NDAVV,CX,C2,CR,SC0,CSCR,POTR(1,2),
     &             C0(1,IB),F(IB),NDOEL,PSI,EDAV(NDAVV+1),VPP,SCR,LSCR)
          ITAUR=1
          CALL DCOPY(2*NGW*NSDOWN,CX,1,C0(1,IB),1)
          CALL DCOPY(NNR1*NLSD,RHOT(1,1),1,POTR(1,1),1)
          DO IS=1,NSDOWN
            EDAV(NSUP+IS)=EDAV(NDAVV+IS)
          ENDDO
        ELSE
          NDIAG=N
          CALL DCOPY(2*NGW*NDIAG,C0,1,CX,1)
          CALL DAVIDSON(NDIAG,NDAVV,CX,C2,CR,SC0,CSCR,POTR,
     &             C0,F,NO,PSI,EDAV,VPP,SCR,LSCR)
          CALL DCOPY(2*NGW*NDIAG,CX,1,C0,1)
        ENDIF
        CALL FREEM(IP_CX)
        CALL FREEM(IP_VPP)
        CALL FREEM(IP_CR)
        CALL FREEM(IP_CSCR)
        TDAVI=.FALSE.
      ENDIF
      IF(TLSD) CALL FREEM(IP_RHOT)
      CALL MEMORY_CHECK
      CALL MY_SYNC(ALLGRP)
      call mm_dim(mm_go_mm,statusdummy)
      CALL ZHWWF(2,IREC,C0,C0,N,EDAV,TAU0,TAU0,TAU0,NFI)
      call mm_dim(mm_go_qm,statusdummy)
      IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
      IF(EXSOFT) RETURN
      IF(PARENT) THEN
        TADJMU=.TRUE.
        CALL ADJMU(N,1,NEL,BETAEL,EDAV,1.D0,TLSD,AMU,TADJMU)
        CALL WREIGEN(EDAV,F,AMU,N)
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T20,A,T64,"==")')
     &       'END OF STATE INITIALIZATION'
        WRITE(6,'(1X,64("="),/)')
      ENDIF
C..store virtual states
      IF(TLSD) THEN
        NAP=NSUP-NUPEL
        NBP=NSDOWN-NDOEL
        CALL DCOPY(2*NGW*NAP,C0(1,NUPEL+1),1,CVIRT(1,1),1)
        CALL DCOPY(2*NGW*NBP,C0(1,NSUP+NDOEL+1),1,CVIRT(1,NAP+1),1)
      ELSE
        CALL DCOPY(2*NGW*NVIR,C0(1,NO+1),1,CVIRT(1,1),1)
      ENDIF
C..make some choices on the form of the occupied orbitals
      IF(TREORDER) THEN
        DO IS=1,NO
          ORDER(IS)=IS
        ENDDO
        DO IS=1,NREOR
          ORDER(NO-IS+1)=IREOR(IS)
        ENDDO
        IF(PARENT) THEN
C         Check if the ordering is reasonable
          DO IS=1,NO
            DO J=IS+1,NO
              IF(ORDER(IS).EQ.ORDER(J)) CALL STOPGM("SPECTRA",
     *          "Illegal reordering of states")
            ENDDO
          ENDDO
        ENDIF
      ENDIF
      IF(TDLOCAL) THEN
        ORBITAL="GENERAL"
        TIME1=TIMEF()
        CALL SETSPIN("S",C0,CVIRT,C2)
#ifdef PARALLEL
        LENBK=NXXFUN(NO)
        NXX=MAX(2*LENBK*NPROC,2*NGW*NO)
#else
        NXX=2*NGW*NO
#endif
        CALL MEMORY(IP_CX,NXX,'CX')
        CALL MEMORY(IP_CR,NXX,'CR')
        CALL LOCALIZE(TAU0,C0,CX,CR,SCR,LSCR,NO)
        CALL FREEM(IP_CR)
        CALL FREEM(IP_CX)
        TIME2=TIMEF()
        TCPU=(TIME2-TIME1)*0.001D0
        IF(PARENT) THEN
         WRITE(6,'(/,A,T46,F12.3,A)')
     *     ' TIME FOR WAVEFUNCTION LOCALIZATION :',TCPU,' SECONDS'
        ENDIF
        CALL FREEM(IP_EIGV)
        CALL MEMORY(IP_EIGV,NO*NO,"EIGV")
        CALL AZZERO(EIGV,NO*NO)
        IF(TREORDER.AND.ZATOM.NE.0) THEN
          CALL WORDER(NO,TAU0,ORDER)
        ENDIF
        CALL SETSPIN("R",C0,CVIRT,C2)
      ELSE
        ORBITAL="CANON"
      ENDIF
C     ==--------------------------------------------------------------==
      TDASUBOPT=.FALSE.
      IF(TDA.AND.MSUBTA.GT.0) THEN
        NACT=MSUBTA
        IF(.NOT.TDACANON) TDASUBOPT=.TRUE.
      ELSE
        IF(TLSD) THEN
          NACT=NUPEL+NDOEL
        ELSE
          NACT=NO
        ENDIF
      ENDIF
C..calculate KS-Matrix
      IF(TD_METHOD.EQ.1) THEN
        IF(INDEX(ORBITAL,"CANON").NE.0) THEN
C         transform to canonical orbitals and get eigenvalues
          CALL SETSPIN("S",C0,CVIRT,C2)
          if(qmmm)then
            call mm_dim(mm_go_qm,statusdummy)
            call mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU0,FION,
     *                 EIGV,SCR,LSCR,NO,1,.FALSE.,.FALSE.,.TRUE.)
          else
            CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *                 NO,1,.FALSE.,.FALSE.)
          endif
          CALL CANON(C0,C2,F,NO,EIGV,SCR,LSCR)
          IF(TREORDER) THEN
C           This seems not to be right for LSD -> empty states?
            DO IS=1,NO
              CALL DCOPY(2*NGW,C0(1,ORDER(IS)),1,C2(1,IS),1)
              EIGV(IS)=EDAV(ORDER(IS))
            ENDDO
            CALL DCOPY(2*NGW*NO,C2,1,C0,1)
            CALL DCOPY(NO,EIGV,1,EDAV,1)
          ENDIF
          CALL DCOPY(N,EDAV,1,EIGV,1)
          IF(MOLSTAT) THEN
            NCSCR=2*NGW*NO
            CALL MEMORY(IP_C0Y,NCSCR,'C0Y')
            CALL DCOPY(NCSCR,C0,1,C0Y,1)
            CALL MOLECULAR_STATES(C0Y,EIGV,NO,TAU0)
          ENDIF
          CALL TDM_FUN(TD_FUNCTIONAL,1)
          IF(TPOTENTIAL) THEN
            CALL MEMORY(IP_EIGVAL,NO,"EIGVAL")
            CALL MEMORY(IP_EIGREF,NO,"EIGREF")
            CALL MEMORY(IP_FOCCP,NO,"FOCCP")
            CALL DCOPY(NO,F,1,FOCCP,1)
            MSTATE = NO
            IF(MOLSTAT) THEN
              IF(TLSD) THEN
                CALL STOPGM("SPECTRA","TLSD MOLSTAT")
              ELSE
                CALL DCOPY(NO,EIGV,1,EIGVAL,1)
                IS=0
                DO J=1,NUMOL
                  EN=EIGVAL(IS+MSTAT(J))
                  DO K=IS+1,IS+MSTAT(J)
                    EIGREF(K)=EN
                  ENDDO
                  IS=IS+MSTAT(J)
                ENDDO
              ENDIF
            ELSE
              IF(TLSD) THEN
                CALL DCOPY(NUPEL,EIGV,1,EIGVAL,1)
                CALL DCOPY(NDOEL,EIGV(NUPEL+NAP+1),1,EIGVAL(NUPEL+1),1)
              ELSE
                CALL DCOPY(NO,EIGV,1,EIGVAL,1)
              ENDIF
              CALL GET_ADDR(IP_C0Y,C0(1,1))
              IF(TLSD) THEN
                DO IS=1,NUPEL+NAP
                  IF(FOCCP(IS).GT.1.D-4) ENA=EIGV(IS)
                ENDDO
                DO IS=1,NUPEL+NAP
                  EIGREF(IS)=ENA
                ENDDO
                DO IS=NUPEL+NAP+1,MSTATE
                  IF(FOCCP(IS).GT.1.D-4) ENB=EIGV(IS)
                ENDDO
                DO IS=NUPEL+NAP+1,MSTATE
                  EIGREF(IS)=ENB
                ENDDO
              ELSE
                DO IS=1,MSTATE
                  IF(FOCCP(IS).GT.1.D-4) EN=EIGV(IS)
                ENDDO
                DO IS=1,MSTATE
                  EIGREF(IS)=EN
                ENDDO
              ENDIF
            ENDIF
          ENDIF
          ORBITAL="GENERAL"
          CALL FREEM(IP_EIGV)
          CALL MEMORY(IP_EIGV,NO*NO,"EIGV")
          CALL AZZERO(EIGV,NO*NO)
          CALL FREEM(IP_SCR)
          CALL GIVE_SCR_SPECTRA(LSCR,TAG)
          CALL MEMORY(IP_SCR,LSCR,'SCR')
          IF(qmmm)THEN
            CALL mm_dim(mm_go_qm,statusdummy)
            CALL mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU0,FION,
     *                 EIGV,SCR,LSCR,NO,1,.FALSE.,.FALSE.,.FALSE.)
          ELSE
            CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *                 NO,1,.FALSE.,.TRUE.)
          ENDIF
          CALL DCOPY(NNR1*NLSD,RHOE,1,POTR,1)
          DO IS=1,NO
            CALL DSCAL(2*NGW,1.D0/F(IS),C2(1,IS),1)
          ENDDO
          CALL OVLAP(NO,EIGV,C0,C2)
          CALL GLOSUM(NO*NO,EIGV)
          CALL SETSPIN("R",C0,CVIRT,C2)
          IF(TDA.AND.MSUBTA.GT.0) THEN
C           Reorder KS Matrix
            CALL STOPGM("SPECTRA","TDMETHOD-MSUBTA")
          ENDIF
          IF(MOLSTAT) THEN
            CALL FREEM(IP_C0Y)
            CALL GET_ADDR(IP_C0Y,C0(1,1))
          ENDIF
        ELSE
          CALL STOPGM("SPECTRA","TDMETHOD-GENERAL")
        ENDIF
      ELSEIF(INDEX(ORBITAL,"CANON").NE.0) THEN
C       transform to canonical orbitals and get eigenvalues
        CALL SETSPIN("S",C0,CVIRT,C2)
        if(qmmm)then
          call mm_dim(mm_go_qm,statusdummy)
          call mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU0,FION,
     *               EIGV,SCR,LSCR,NO,1,.FALSE.,.FALSE.,.TRUE.)
        else
          CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               NO,1,.FALSE.,.TRUE.)
        endif
        CALL CANON(C0,C2,F,NO,EIGV,SCR,LSCR)
        IF(TREORDER) THEN
C         This seems not to be right for LSD -> empty states?
          DO IS=1,NO
            CALL DCOPY(2*NGW,C0(1,ORDER(IS)),1,C2(1,IS),1)
            EIGV(IS)=EDAV(ORDER(IS))
          ENDDO
          CALL DCOPY(2*NGW*NO,C2,1,C0,1)
          CALL DCOPY(NO,EIGV,1,EDAV,1)
        ENDIF
        CALL DCOPY(N,EDAV,1,EIGV,1)
        CALL SETSPIN("R",C0,CVIRT,C2)
      ELSE
        IF(TREORDER) THEN
          DO IS=1,NO
            CALL DCOPY(2*NGW,C0(1,ORDER(IS)),1,C2(1,IS),1)
          ENDDO
          CALL DCOPY(2*NGW*NO,C2,1,C0,1)
        ENDIF
        CALL SETSPIN("S",C0,CVIRT,C2)
        if(qmmm)then
          call mm_dim(mm_go_qm,statusdummy)
          call mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU0,FION,
     *               EIGV,SCR,LSCR,NO,1,.FALSE.,.FALSE.,.TRUE.)
        else
          CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *               NO,1,.FALSE.,.TRUE.)
        endif
        DO IS=1,NO
          CALL DSCAL(2*NGW,1.D0/F(IS),C2(1,IS),1)
        ENDDO
        CALL OVLAP(NO,EIGV,C0,C2)
        CALL GLOSUM(NO*NO,EIGV)
        IF(TDA.AND.MSUBTA.GT.0) THEN
C         Reorder KS Matrix
          DO IS=1,MSUBTA
            J=(NO-MSUBTA+1) + (NO-MSUBTA+IS-1)*NO
            K=(IS-1)*MSUBTA+1
            CALL DCOPY(MSUBTA,EIGV(J),1,EIGV(K),1)
          ENDDO
        ENDIF
        CALL SETSPIN("R",C0,CVIRT,C2)
      ENDIF
      CALL MEMORY_CHECK
C     ==--------------------------------------------------------------==
C     == END INITIALIZATION                                           ==
C     ==--------------------------------------------------------------==
      IF(TLSD) THEN
        N=NUPEL+NDOEL
      ELSE
        N=NO
      ENDIF
      NROOT=MAX(NS_SIN,NS_TRI,NS_MIX)
      CALL MEMORY(IP_EIGT,NROOT,'EIGT')
      CALL AZZERO(EIGT,NROOT)
      IF(PARENT) CALL PRMEM('   SPECTRA')
      LRACTIVE=.TRUE.
C..LR-TDDFT EQUATIONS AND TAMM-DANCOFF APPROXIMATION
      IF(TDA.AND.LDIAG.EQ.1) THEN
        MTDA=1
      ELSE
        MTDA=2
      ENDIF
      IF(PARENT) THEN
        IF(TLSD) WRITE(6,'(1X,"==",T28,A,T64,"==")') 'MIXED STATES'
        IF(NS_SIN.NE.0) WRITE(6,'(1X,"==",T26,A,T64,"==")')
     &                       'SINGLET STATES'
        IF(NS_TRI.NE.0) WRITE(6,'(1X,"==",T26,A,T64,"==")')
     &                       'TRIPLET STATES'
      ENDIF
C..calculate and store analytic dmu/dn
      CALL LR_XCPOT(DDXC,RHOO,SCR,LSCR,.TRUE.)
C
      IF(TDA.AND.MSUBTA.GT.0) THEN
        NOLR=NLSD*MSUBTA
      ELSE
        IF(TLSD) THEN
          NOLR=NUPEL+NDOEL
        ELSE
          NOLR=NO
        ENDIF
      ENDIF
      NUS=NLSD*NACT*N*NROOT+1
      CALL MEMORY(IP_UROT,NUS,'UROT')
      CALL AZZERO(UROT,NUS)
C
      CALL MEMORY(IP_C1,NROOT*2*NGW*NOLR*MTDA,'C1')
      NUA=N
      NUB=NACT
      NLINW=NROOT
      NLINR=0
      CALL GET_ADDR(IP_CLRWF,C1(1))
      IF(RLR) THEN
        IF(TLSD) THEN
          N=NOLR+NAP+NBP
        ELSE
          N=NO+NVIR
        ENDIF
        CALL READ_IREC(IREC)
        CALL ZHRWF(1,IREC,C0,C2,N,EDAV,TAU0,TAUX,TAUX,NFI)
        CALL WRITE_IREC(IREC)
        IF(TLSD) THEN
          N=NUPEL+NDOEL
        ELSE
          N=NO
        ENDIF
      ENDIF
      IF(TLSD) THEN
        LRSYM=0
        CALL SETSPIN("S",C0,CVIRT,C2)
        CALL STCOP(NS_MIX,C0,C2,N,EIGV,EDAV,CVIRT,NAP,NBP,C1,NACT,
     &             DDXC,PSI,RHOE,SCR,LSCR,ORBITAL)
        DO IS=NUPEL+1,N
          EIGV(IS)=EDAV(NAP+IS)
        ENDDO
      ELSEIF(NS_SIN.NE.0) THEN
        LRSYM=1
        CALL STCOP(NS_SIN,C0,C2,N,EIGV,EDAV,CVIRT,NVIR,0,C1,NACT,
     &             DDXC,PSI,RHOE,SCR,LSCR,ORBITAL)
      ELSEIF(NS_TRI.NE.0) THEN
        LRSYM=3
        CALL STCOP(NS_TRI,C0,C2,N,EIGV,EDAV,CVIRT,NVIR,0,C1,NACT,
     &             DDXC,PSI,RHOE,SCR,LSCR,ORBITAL)
      ENDIF
      IF(PARENT) CALL PRMEM('   SPECTRA')
      IF(TTAU) THEN
        CALL DCOPY(NNR1*NLSD,RTAU,1,TAU,1)
        CALL DCOPY(NNR1*NLSD,PTAU,1,VTAU,1)
      ENDIF
      CALL LR_DIAG(C0,C1,C2,SC0,EIGV,DDXC,RHOE,PSI,
     &             EIGT,SCR,LSCR,N,NROOT,ORBITAL,KPRINT)
      CALL IAZZERO(TRANSITION,3*4*20)
      CALL GETTRANS(TRANSITION,C1,CVIRT,SCR,LSCR,
     &                NACT,NVIR,NAP,NBP,NROOT)
      CALL PRINTTRANS(TRANSITION,EIGT,NACT,NVIR,NAP,NBP,NROOT)
      CALL TD_OS(NACT,C0,NROOT,EIGT,C1,SCR,LSCR)
      IF(RHOOUT) CALL RHO1PRI(C0,C1,TAU0,N,NROOT,"S")
      IF(TLSD) CALL SETSPIN("R",C0,CVIRT,C2)
      CALL MEMORY_CHECK
C     ==--------------------------------------------------------------==
      IF(PARENT) CALL PRMEM('   SPECTRA')
      IF(TLSD) THEN
        N=NOLR+NAP+NBP
      ELSE
        N=NO+NVIR
      ENDIF
      IF (TNACVS) THEN
       CALL GIVE_SCR_VCOUPLING(IL_PSI,TAG)
       IF (IL_PSI.GT.LSCR) THEN
        CALL FREEM(IP_SCR)
        CALL MEMORY(IP_SCR,IL_PSI,'SCR')
        LSCR=IL_PSI
       ENDIF
       CALL VCOUPLINGS(C0,C1,C2,SC0,RHOE,EIGV,EIGT,
     &                N,NO,NVIR,NACT,NROOT,SCR,LSCR)
      ENDIF
      call mm_dim(mm_go_mm,statusdummy)
      CALL ZHWWF(2,IREC,C0,C0,N,EIGV,TAU0,TAU0,TAU0,NFI)
      call mm_dim(mm_go_qm,statusdummy)
      IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
      IF(EXSOFT) RETURN
      IF(TD_METHOD.EQ.1) THEN
        CALL TDM_FUN(KS_FUNCTIONAL,1)
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TPROP) THEN
        IF(TD_METHOD.EQ.1) THEN
          CALL STOPGM("TD_METHOD","NOT IMPLEMENTED")
        ENDIF
        IF (PARENT) THEN
          WRITE(6,*)
          WRITE(6,'(1X,64("="))')
          WRITE(6,'(1X,"==",T13,A,T64,"==")')
     &         '      EXCITED STATE PROPERTY CALCULATION    '
          WRITE(6,'(1X,64("="))')
        ENDIF
        IF(TLSD) CALL SETSPIN("S",C0,CVIRT,C2)
        IF(TLSD) THEN
          N=NUPEL+NDOEL
        ELSE
          N=NO
        ENDIF
        LOPTI=LOPTIB-10
C       Print ground state density
        IF (PARENT) THEN
          WRITE(6,'(" >>>>>> ",A,T63,I3)') 'Process ground state '
        ENDIF
        CALL RHOPRI(C0,TAU0,RHOE,PSI,SCR,LSCR,N,1)
        CALL TDCHARGE(RHOO,TAU0,PSI,SCR)
        CALL TDDIPO(DMOM,RHOO,TAU0,PSI)
        IF(NPSTATE.EQ.0) THEN
          CALL DCOPY(3*NAX*NSX,FION,1,TAUX,1)
          DO IS=1,NROOT
            FSTATE=IS
            IF (PARENT) THEN
              WRITE(6,'(" >>>>>> ",A,T63,I3)') 'Process state ',FSTATE
            ENDIF
            CALL DCOPY(3*NAX*NSX,TAUX,1,FION,1)
            CALL TD_FORCE(C0,C1,C2,SC0,EIGV,RHOE,PSI,EIGT,
     &                    N,NROOT,TAU0,FION,ORBITAL,1)
C           calculate relaxed density
            CALL RELAX_RHO(C0,C1,C2,SC0,RHOO,RHOE,PSI,N,NROOT)
            CALL RELAX_PRI(RHOE,TAU0,SCR,PSI,FSTATE)
            CALL TDCHARGE(RHOE,TAU0,PSI,SCR)
            CALL TDDIPO(DMOM,RHOE,TAU0,PSI)
          ENDDO
        ELSE
          FSTATE=MIN(NPSTATE,NROOT)
          IF(FSTATE.NE.NPSTATE) CALL STOPGM("SPECPT",
     *      "INVALID STATE FOR PROPERTY CALCULATION")
          IF (PARENT) THEN
            WRITE(6,'(" >>>>>> ",A,T63,I3)') 'Process state ',FSTATE
          ENDIF
          CALL TD_FORCE(C0,C1,C2,SC0,EIGV,RHOE,PSI,EIGT,
     &                  N,NROOT,TAU0,FION,ORBITAL,1)
C         calculate relaxed density
          CALL RELAX_RHO(C0,C1,C2,SC0,RHOO,RHOE,PSI,N,NROOT)
          CALL RELAX_PRI(RHOE,TAU0,SCR,PSI,FSTATE)
          CALL TDCHARGE(RHOE,TAU0,PSI,SCR)
          CALL TDDIPO(DMOM,RHOE,TAU0,PSI)
        ENDIF
        IF(TLSD) CALL SETSPIN("R",C0,CVIRT,C2)
      ENDIF
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_DDXC)
      CALL FREEM(IP_SCR)
      CALL FREEM(IP_C1)
      CALL FREEM(IP_UROT)
      CALL FNLDEALLOC(.FALSE.,.FALSE.)
      CALL FREEM(IP_EDAV)
      CALL FREEM(IP_TAUX)
      CALL FREEM(IP_RHOE)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_EIGT)
      CALL FREEM(IP_CVIRT)
      IF(TREORDER) CALL FREEM(IP_ORDER)
      IF(TREORDER.AND.TDLOCAL) CALL FREEM(IP_WCENT)
      IF(MOLSTAT) THEN
        CALL FREEM(IP_WCENT)
      ENDIF
      IF(TINLC) CALL FREEM(IP_ROCT)
      CALL MEMORY_CHECK
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_SPECTRA(LSPECTRA,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        
      INCLUDE 'elct.inc'        !N number of states
      INCLUDE 'nlcc.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER   LSPECTRA
      CHARACTER TAG*30
C     Variables
      INTEGER   NSTATE,LINITRUN,LUPDWF,LRHOOFR,LFORCES,LCANON,LRNLSM,
     *          LLR_DIAG,L_DIAG,LORTHO,LLOCAL,LRHOPRI,LTD_FORCE
C     ==--------------------------------------------------------------==
      NSTATE=N
      CALL GIVE_SCR_INITRUN(LINITRUN,TAG)
      CALL GIVE_SCR_UPDWF(LUPDWF,TAG,NSTATE,.FALSE.)
      CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
      CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.FALSE.,.FALSE.)
      CALL GIVE_SCR_CANON(LCANON,TAG,NSTATE)
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.FALSE.)
      CALL GIVE_SCR_LR_DIAG(LLR_DIAG,TAG)
      NSTATE=N+MAX(NS_TRI,NS_SIN,NS_MIX)
      IF(TLANC) THEN
        IF (TDMAL) THEN
          CALL GIVE_SCR_DIST_FRIESNER(L_DIAG,TAG,NSTATE)
        ELSE
          CALL GIVE_SCR_FRIESNER(L_DIAG,TAG,NSTATE)
        ENDIF
      ELSE
        CALL GIVE_SCR_DAVIDSON(L_DIAG,TAG,NSTATE,NDAVV)
      ENDIF
      CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      IF(TDLOCAL) THEN
        CALL GIVE_SCR_DDIPO(LLOCAL,TAG)
        LLOCAL=MAX(LLOCAL,2*NHG)
      ELSE
        LLOCAL=0
      ENDIF
      IF(TINLC) THEN
        LLOCAL=MAX(LLOCAL,NHG)
      ENDIF
      LRHOPRI=0
      LTD_FORCE=0
      IF(TPROP) THEN
        CALL GIVE_SCR_RHOPRI(LRHOPRI,TAG,NSTATE)
        LRHOPRI=MAX(LRHOPRI,2*NHG)
        CALL GIVE_SCR_TD_FORCE(LTD_FORCE,NSTATE,TAG)
      ENDIF
C
      LSPECTRA=MAX(LINITRUN,LUPDWF,LRHOOFR,LFORCES,LCANON,LRNLSM,
     *         LLR_DIAG,L_DIAG,LORTHO,LLOCAL,LRHOPRI,LTD_FORCE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SETSPIN(TAG,C0,CVIRT,CS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      CHARACTER*1 TAG
      COMPLEX*16 C0(NGW,*),CVIRT(NGW,*),CS(NGW,*)
      INTEGER NX,I,NAP,NBP
      DIMENSION F(*)
C     ==--------------------------------------------------------------==
      IF(TLSD) THEN
        IF(TAG.EQ."S") THEN
          NAP=NSUP-NUPEL
          NBP=NSDOWN-NDOEL
          CALL DCOPY(2*NGW*NAP,C0(1,NUPEL+1),1,CVIRT(1,1),1)
          CALL DCOPY(2*NGW*NBP,C0(1,NSUP+NDOEL+1),1,CVIRT(1,NAP+1),1)
          CALL DCOPY(2*NGW*NDOEL,C0(1,NSUP+1),1,CS(1,1),1)
          CALL DCOPY(2*NGW*NDOEL,CS(1,1),1,C0(1,NUPEL+1),1)
!$OMP parallel do private(I)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
          DO I=1,NSUP+NSDOWN
            F(I)=0.D0
          ENDDO
          NSUP=NUPEL
          NSDOWN=NDOEL
!$OMP parallel do private(I)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
          DO I=1,NUPEL+NDOEL
            F(I)=1.D0
          ENDDO
        ELSEIF(TAG.EQ."R") THEN
          NX=N-NUPEL-NDOEL
          NSUP=NUPEL+(NX+1)/2
          NSDOWN=NDOEL+NX/2
!$OMP parallel do private(I)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
          DO I=1,N
            F(I)=0.D0
          ENDDO
!$OMP parallel do private(I)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
          DO I=1,NUPEL
            F(I)=1.D0
          ENDDO
!$OMP parallel do private(I)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
          DO I=NSUP+1,NSUP+NDOEL
            F(I)=1.D0
          ENDDO
          NAP=NSUP-NUPEL
          NBP=NSDOWN-NDOEL
          CALL DCOPY(2*NGW*NDOEL,C0(1,NUPEL+1),1,CS(1,1),1)
          CALL DCOPY(2*NGW*NDOEL,CS(1,1),1,C0(1,NSUP+1),1)
          CALL DCOPY(2*NGW*NAP,CVIRT(1,1),1,C0(1,NUPEL+1),1)
          CALL DCOPY(2*NGW*NBP,CVIRT(1,NAP+1),1,C0(1,NSUP+NDOEL+1),1)
        ENDIF
      ELSE
C       Nothing to do
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WORDER(NSTATE,TAU0,ORDER)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'irat.inc'
C     Variables
      INTEGER    NSTATE
      REAL*8     TAU0(3,NAX,*)
      INTEGER    ORDER(*)
C     LOCAL
      DIMENSION  IREOR(*)
      INTEGER    IS,IA,IZ,IAT,MSGLEN,IREF
      REAL*8     REF(3,*),DISTWR(*),DX,DY,DZ,DD
      POINTER    (IP_DISTWR,DISTWR),(IP_REF,REF)
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        CALL MEMORY(IP_DISTWR,NSTATE,"DISTWR")
        CALL MEMORY(IP_REF,3*ZATOM,"REF")
        IAT=0
        IREF=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IAT=IAT+1
            DO IZ=1,ZATOM
              IF(IREOR(IZ).EQ.IAT) THEN
                IREF=IREF+1
                REF(1,IREF)=TAU0(1,IA,IS)
                REF(2,IREF)=TAU0(2,IA,IS)
                REF(3,IREF)=TAU0(3,IA,IS)
                GOTO 2000
              ENDIF
            ENDDO
2000        CONTINUE
          ENDDO
        ENDDO
        DO IS=1,NSTATE
          DISTWR(IS)=1.D30
          DO IA=1,ZATOM
            DX=WCENT(1,IS)-REF(1,IA)
            DY=WCENT(2,IS)-REF(2,IA)
            DZ=WCENT(3,IS)-REF(3,IA)
            CALL PBC3(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
            DD=(DX*DX+DY*DY+DZ*DZ)
            DISTWR(IS)=MIN(DD,DISTWR(IS))
          ENDDO
        ENDDO
        CALL DSCAL(NSTATE,-1.D0,DISTWR,1)
        CALL SORT2 ( DISTWR, NSTATE, ORDER )
        CALL FREEM(IP_REF)
        CALL FREEM(IP_DISTWR)
      ENDIF
      MSGLEN = NSTATE * 8/IRAT
      CALL MY_BCAST(ORDER,MSGLEN,SOURCE,ALLGRP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RELAX_PRI(RHOE,TAU0,RG,PSI,FSTATE)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
C     Arguments
      REAL*8     RHOE(NNR1,*),TAU0(*)
      COMPLEX*16 RG(*),PSI(*)
      INTEGER    FSTATE
C     Variables
      CHARACTER*40 FILEN,CFLBOD,CIPNUM
      INTEGER      IG,IR,N1,N2,I1,I2
C     ==--------------------------------------------------------------==
      CFLBOD='RELAXDEN_'
      WRITE(CIPNUM,'(I4)') FSTATE
      CALL XSTRING(CFLBOD,N1,N2)
      CALL XSTRING(CIPNUM,I1,I2)
      FILEN=CFLBOD(N1:N2)//CIPNUM(I1:I2)
!$OMP parallel do private (IR)
#ifdef __SR8000
*poption parallel
#endif
      DO IR=1,NNR1
         PSI(IR)=DCMPLX(RHOE(IR,1),0.D0)
      ENDDO
      CALL FWFFT(PSI)
      DO IG=1,NHG
         RG(IG) = PSI(NZH(IG))
      ENDDO
      CALL DENSTO(RG,TAU0,FILEN)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
