C     ==================================================================
      SUBROUTINE SPSI(NSTATE,SC0,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 SC0(NGW,NSTATE),SCR(NGW)
C     Variables
      DIMENSION  TWNL(NGW,NHXS,NSP),EIGR(NGW,NAT)
      COMPLEX*16 CI
      CHARACTER  TAG*30
      REAL*8     FNL(NAT,NHXS,NSTATE),DFNL(*)
      REAL*8     T1,T2,T3,AA
      INTEGER    ISUB,ISA0,IS,IV,IA,ISA,IG,J,JV,LSPSI
C     ==--------------------------------------------------------------==
      CALL TISET('      SPSI',ISUB)
      IF(TFDIST) CALL STOPGM('SPSI','TFDIST NOT IMPLEMENTED')
      IF(IMAGP.EQ.2) CALL STOPGM('SPSI','K-POINT NOT IMPLEMENTED')
      CALL GIVE_SCR_SPSI(LSPSI,TAG)
      CALL TEST_SCR('SPSI',TAG,LSCR,LSPSI)
C     ==--------------------------------------------------------------==
      ISA0=0
      DO IS=1,NSP
        IF(TVAN(IS)) THEN
          DO IV=1,NGH(IS)
            CI=(0.0D0,-1.0D0)**NGHTOL(IV,IS)
            DO IA=1,NA(IS)
              ISA=ISA0+IA
C             MAKE USE OF THE SPECIAL STRUCTURE OF CI
              IF(ABS(DREAL(CI)).GT.0.5D0) THEN
C               CI IS REAL
                DO IG=1,NGW
                  T1=DREAL(EIGR(IG,ISA))
                  T2=DIMAG(EIGR(IG,ISA))
                  T3=TWNL(IG,IV,IS)*DREAL(CI)
                  SCR(IG)=DCMPLX(T1*T3,T2*T3)
                ENDDO
              ELSE
C               CI IS IMAGINARY
                DO IG=1,NGW
                  T1=DREAL(EIGR(IG,ISA))
                  T2=DIMAG(EIGR(IG,ISA))
                  T3=TWNL(IG,IV,IS)*DIMAG(CI)
                  SCR(IG)=DCMPLX(-T2*T3,T1*T3)
                ENDDO
              ENDIF
              DO J=1,NSTATE
                AA=0.0D0
                DO JV=1,NGH(IS)
                  AA=AA+QQ(IV,JV,IS)*FNL(ISA,JV,J)
                ENDDO
                CALL DAXPY(2*NGW,AA,SCR(1),1,SC0(1,J),1)
              ENDDO
            ENDDO
          ENDDO
        ENDIF
        ISA0=ISA0+NA(IS)
      ENDDO
      CALL TIHALT('      SPSI',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_SPSI(LSPSI,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NGW
C     Arguments
      INTEGER   LSPSI
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LSPSI=NGW*2
      TAG ='NGW*2'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
