C     ==================================================================
      SUBROUTINE STAGETRANS(PRIM,STG,ITRANS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'pimd.inc'
C     Arguments
      REAL*8  PRIM(3,NAX,NSX,*),STG(3,NAX,NSX,*)
      INTEGER ITRANS
C     Variables
      INTEGER NPX,I,IS,IA,IP
      REAL*8  RSTAR
C     ==--------------------------------------------------------------==
      NPX=NP_TOTAL
      IF(ITRANS.EQ.0) THEN
C     ==--------------------------------------------------------------==
C     ==  PERFORM TRANSFORMATION R --> U                              ==
C     ==  U_1 = R_1, U_s = R_s - R_s^* ,   s=2,...,P                  ==
C     ==  R_s^* = [(s-1)R_{s+1} + R_1]/s                              ==
C     ==--------------------------------------------------------------==
        DO I=1,3
          DO IS=1,NSP
            DO IA=1,NA(IS)
              STG(I,IA,IS,1) = PRIM(I,IA,IS,1)
              STG(I,IA,IS,NPX) = PRIM(I,IA,IS,NPX)-PRIM(I,IA,IS,1)
              DO IP=2,NPX-1
                RSTAR = (DBLE(IP-1)*PRIM(I,IA,IS,IP+1) + 
     *                  PRIM(I,IA,IS,1))/DBLE(IP)
                STG(I,IA,IS,IP) = PRIM(I,IA,IS,IP) - RSTAR
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ELSE
C     ==--------------------------------------------------------------==
C     ==  PERFORM RECURSIVE INVERSE TRANSFORMATION U --> R            ==
C     ==  R_1 = U_1, R_s = U_1 + \sum_{t=s}^P [(s-1)/(t-1)]*U_t       ==
C     ==--------------------------------------------------------------==
        DO I=1,3
          DO IS=1,NSP
            DO IA=1,NA(IS)
              PRIM(I,IA,IS,1) = STG(I,IA,IS,1)
              PRIM(I,IA,IS,NPX) = STG(I,IA,IS,NPX)+STG(I,IA,IS,1)
              DO IP=NPX-1,2,-1
                PRIM(I,IA,IS,IP) = STG(I,IA,IS,IP) + 
     *               DBLE(IP-1)*PRIM(I,IA,IS,IP+1)/DBLE(IP) +
     *               PRIM(I,IA,IS,1)/DBLE(IP)
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
