C     ==================================================================
      SUBROUTINE STARTPA
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'geq0.inc'
C     Local variables
#ifdef PARALLEL
      INTEGER IP,IPP
#endif
#ifdef __ES
      INTEGER ICARG,IARGC,LINELEN
      PARAMETER (LINELEN=130)
      CHARACTER FILENAME*(LINELEN)
      INTEGER LEF,IEND,I
      CHARACTER*130 EXIT_FPATH ! PATH TO EXIT FILE ON ES
      COMMON/FPATH/ EXIT_FPATH
#endif
C     ==--------------------------------------------------------------==
C     PGROUP(I) : Pointer position --> PE number
C     NLINK(I)  : Pointer PE number --> position - 1
#ifdef PARALLEL
      CALL MY_START
      CALL MY_ENVIRON(NPROC,ME)
      CALL MY_TASK_QUERY(ALLGRP)
      MEPOS = ME
      DO IP=1,NPROC
        PGROUP(IP) = IP-1
      ENDDO
      SOURCE = 0
      GEQ0=.TRUE.
      PARENT = ME.EQ.SOURCE
      CALL MY_SYNC(ALLGRP)
      CALL IAZZERO(NLINK,MAXCPU)
      DO IP=1,NPROC
        IPP=PGROUP(IP)
        NLINK(IPP)=IP-1
      ENDDO
#else
      NPROC = 1
      ME = 0
      MEPOS = 0
      SOURCE = 0
      GEQ0=.TRUE.
      PARENT=.TRUE.
#endif
      CALL NUMCPUS(NCPUS)
C
#ifdef __ES
      ICARG=IARGC()
      IF(ICARG.GT.2) THEN
        CALL MY_GETARG(3,FILENAME)
      ELSE
        FILENAME='./cpmd.log'
      ENDIF
      LEF=LEN(TRIM(FILENAME))
      IEND=LEF
      DO I=LEF,1,-1
        IF(FILENAME(I:I).EQ.'/') THEN 
          IEND=I
          EXIT 
        ENDIF 
      ENDDO 
      IF(IEND.EQ.LEF) THEN
        CALL STOPGM("STARTPA","EXIT_FPATH UNDEFINED")
      ENDIF
      EXIT_FPATH=FILENAME(1:IEND)
#endif
      IF(NPROC .GT. MAXCPU) THEN
        IF(PARENT) THEN
           WRITE(6,'(A,T20,A,I10)') 
     *           "STARTPA|","NUMBER OF PARALLEL TASKS  ",NPROC
           WRITE(6,'(A,T20,A,I10)') 
     *           "STARTPA|","PARAMETER MAXCPU(system.h)",MAXCPU
           CALL STOPGM("STARTPA","TOO MANY PARALLEL TASKS")
        ENDIF
        CALL MY_SYNC(ALLGRP)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GET_PA(NP,MP,S,PAR,GRP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INTEGER  NP,MP,S,GRP
      LOGICAL  PAR
C     ==--------------------------------------------------------------==
      NP=NPROC
      MP=MEPOS
      S=SOURCE
      PAR=PARENT
      GRP=ALLGRP
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
