C     ==================================================================
      SUBROUTINE STCOP(NS,C0,C2,NSTATE,EIGV,EDAV,CV,NVA,NVB,C1,NACT,
     &                 DDXC,PSI,RHOE,SCR,LSCR,ORBITAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'linres.inc'
      DIMENSION F(*)
      INTEGER NS,NVA,NVB,NACT,NSTATE,LSCR
      REAL*8  EIGV(*),DDXC(*),RHOE(*),SCR(*),EDAV(*)
      COMPLEX*16 C1(NGW,NACT,NLINW,*),CV(NGW,*)
      COMPLEX*16 C0(NGW,*),C2(NGW,*),PSI(*)
      CHARACTER*(*) ORBITAL
C     ==--------------------------------------------------------------==
      IF(INDEX(ORBITAL,"CANON").NE.0) THEN
         CALL STCOP1(NS,C0,C2,NSTATE,EIGV,EDAV,CV,NVA,NVB,C1,NACT,
     &                 DDXC,PSI,RHOE,SCR,LSCR)
      ELSE
         CALL STCOP2(NS,C0,C2,NSTATE,EIGV,EDAV,CV,NVA,NVB,C1,NACT,
     &                 DDXC,PSI,RHOE,SCR,LSCR)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE STCOP1(NS,C0,C2,NSTATE,EIGV,EDAV,CV,NVA,NVB,C1,NACT,
     &                  DDXC,PSI,RHOE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'linres.inc'
      DIMENSION F(*)
      INTEGER NS,NVA,NVB,NACT,NSTATE,LSCR
      REAL*8  EIGV(*),DDXC(*),RHOE(*),SCR(*),EDAV(*)
      COMPLEX*16 C1(NGW,NACT,NLINW,*),CV(NGW,*)
      COMPLEX*16 C0(NGW,*),C2(NGW,*),PSI(*)
C     ==--------------------------------------------------------------==
      REAL*8     DEV,FOCC,DEVMAX,E2(5)
      INTEGER    NV,NO,I,J,IS,IX,IY,IJ,NOV,IS1,IS2,IX1,IX2,IY1,IY2
      COMPLEX*16 CT(NGW,*),CS(NGW,*)
      POINTER    (IP_CT,CT),(IP_CS,CS)
      DIMENSION  UROT(NUA,NUB,*)
      LOGICAL DEBUG,OSTDA
      REAL*8  AMAT(*),AUX(*),DEIG(*)
      POINTER (IP_AMAT,AMAT),(IP_DEIG,DEIG),(IP_AUX,AUX)
      INTEGER LAUX,MSGLEN
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
      IF(TDA.AND.MSUBTA.GT.0.AND..NOT.TDACANON) THEN
        OSTDA=.TRUE.
      ELSE
        OSTDA=.FALSE.
      ENDIF
      NV=NVA+NVB
      IF(TLSD) THEN
        IF(PARENT) WRITE(6,'(A,T56,I10)') 
     &      " NUMBER OF STATES TO BE INITIALIZED ",NS-NLINR
        DO IS=NLINR+1,NS,2
          IS1=IS
          IS2=IS+1
          CALL AZZERO(C1(1,1,IS1,1),2*NGW*NACT)
          IF(.NOT.TDA) CALL AZZERO(C1(1,1,IS1,2),2*NGW*NACT)
          IF(IS2.LE.NS) THEN
            CALL AZZERO(C1(1,1,IS2,1),2*NGW*NACT)
            IF(.NOT.TDA) CALL AZZERO(C1(1,1,IS2,2),2*NGW*NACT)
          ENDIF
          IY1=MAX(NACT/2-(IS-1)/NVA,1)
          IY2=NSUP+MAX(NACT/2-(IS-1)/NVB,1)
          IX1=MOD(IS,NVA)
          IF(IX1.LE.0) IX1=IX1+NVA
          IX1=MIN(IX1,NVA)
          IX2=MOD(IS,NVB)
          IF(IX2.LE.0) IX2=IX2+NVB
          IX2=NVA+MIN(IX2,NVB)
          CALL DCOPY(2*NGW,CV(1,IX1),1,C1(1,IY1,IS1,1),1)
          CALL DCOPY(2*NGW,CV(1,IX2),1,C1(1,IY2,IS1,1),1)
          IF(IS2.LE.NS) THEN
            CALL DCOPY(2*NGW,CV(1,IX1),1,C1(1,IY1,IS2,1),1)
            CALL DCOPY(2*NGW,CV(1,IX2),1,C1(1,IY2,IS2,1),1)
            CALL DSCAL(2*NGW,-1.D0,C1(1,IY2,IS2,1),1)
          ENDIF
          IF(TDRANDOM.GT.0.D0) THEN
            DO IY=1,NACT
              CALL VRAND(2*NGW,C1(1,IY,IS1,1),TDRANDOM)
              IF(.NOT.TDA) CALL VRAND(2*NGW,C1(1,IY,IS1,2),TDRANDOM)
            ENDDO
            CALL ZCLEAN(C1(1,1,IS1,1),NACT,NGW)
            IF(.NOT.TDA) CALL ZCLEAN(C1(1,1,IS1,2),NACT,NGW)
            IF(IS2.LE.NS) THEN
              DO IY=1,NACT
                CALL VRAND(2*NGW,C1(1,IY,IS2,1),TDRANDOM)
                IF(.NOT.TDA) CALL VRAND(2*NGW,C1(1,IY,IS2,2),TDRANDOM)
              ENDDO
              CALL ZCLEAN(C1(1,1,IS2,1),NACT,NGW)
              IF(.NOT.TDA) CALL ZCLEAN(C1(1,1,IS2,2),NACT,NGW)
            ENDIF
          ENDIF
        ENDDO
      ELSE
        IF(NLINR.LT.NS) THEN
C       initialize states
          IF(PARENT) WRITE(6,'(A,T56,I10)') 
     &      " NUMBER OF STATES TO BE INITIALIZED ",NS-NLINR
          DEV=EIGV(NSTATE+NV)-EIGV(NSTATE+1)
          NO=0
          DO I=1,NSTATE
            IF(EIGV(I).GT.EIGV(NSTATE)-DEV) NO=NO+1
          ENDDO
          NO=MIN(NO,NV)
          NO=MAX(NO,2)
          NO=MIN(NO,NSTATE)
          IF(TDACANON) NO=MIN(NO,NACT)
          NOV=NO*NV
          IF(PARENT) WRITE(6,'(A,T56,I10)') 
     &      " TOTAL NUMBER OF TEST VECTORS ",NOV
          CALL MEMORY(IP_CT,2*NGW*NOV,'CT')
          CALL MEMORY(IP_CS,2*NGW*NOV,'CS')
          DO I=1,NO
            DO J=1,NV
              IJ=(I-1)*NV+J
              CALL DCOPY(2*NGW,CV(1,J),1,CT(1,IJ),1)
              IX=NSTATE+1-I
              CALL DCOPY(2*NGW,CV(1,J),1,CS(1,IJ),1)
              DEV=EIGV(NSTATE+J)-EIGV(IX)
              CALL DSCAL(2*NGW,-DEV,CS(1,IJ),1)
              IF(LRSYM.EQ.1) THEN
                FOCC=1.D0
                CALL RHO1OFR(C0(1,IX),CT(1,IJ),FOCC,RHOE,PSI,1)
                CALL VTDOFRHO1(E2,RHOE,DDXC,PSI,SCR,LSCR,.TRUE.)
                CALL VPSIMT(C0(1,IX),CS(1,IJ),FOCC,RHOE,PSI,1,1,.TRUE.)
                CALL HFXPSI(C0,C0(1,IX),CS(1,IJ),F,-1.D0,PSI,NSTATE,1)
              ENDIF
            ENDDO
          ENDDO
          CALL SCRSET(SCR,LSCR,DEBUG)
          CALL SCRPTR(SCR,LSCR,IP_AMAT,NOV*NOV,'AMAT',DEBUG)
          CALL SCRPTR(SCR,LSCR,IP_DEIG,NOV,'DEIG',DEBUG)
          LAUX=20*NOV
          CALL SCRPTR(SCR,LSCR,IP_AUX,LAUX,'AUX',DEBUG)
          CALL EDIA(CT,CS,NO,NV,AMAT,DEIG,AUX,LAUX)
          DO IS=NLINR+1,NS
            CALL AZZERO(C1(1,1,IS,1),2*NGW*NACT)
            IF(.NOT.TDA) CALL AZZERO(C1(1,1,IS,2),2*NGW*NACT)
            DEVMAX=0.D0
            IX1=0
            DO I=1,NOV
              IX=(IS-1)*NOV+I
              DEV=AMAT(IX)
              IF(ABS(DEV).GT.DEVMAX) THEN
                DEVMAX=DEV
                IX1=I
              ENDIF
              IF(ABS(DEV).GT.1.D-12) THEN
                IY=NSTATE-(I-1)/NV
                IY=MOD(IY-1,NACT)+1
                CALL DAXPY(2*NGW,DEV,CT(1,I),1,C1(1,IY,IS,1),1)
              ENDIF
            ENDDO
            IF(TDRANDOM.GT.0.D0) THEN
              DO IY=1,NACT
                CALL VRAND(2*NGW,C1(1,IY,IS,1),TDRANDOM)
                IF(.NOT.TDA) CALL VRAND(2*NGW,C1(1,IY,IS,2),TDRANDOM)
                IF(OSTDA) THEN
                  CALL VRAND(NUA-NUB,UROT(1,IY,IS),10.D0*TDRANDOM)
                  DO I=1,NUA-NUB
                    UROT(I,IY,IS)=UROT(I,IY,IS)*DBLE(I)/DBLE(NUA)
                  ENDDO
                ENDIF
              ENDDO
              CALL ZCLEAN(C1(1,1,IS,1),NACT,NGW)
              IF(.NOT.TDA) CALL ZCLEAN(C1(1,1,IS,2),NACT,NGW)
              IF(OSTDA) THEN
                MSGLEN = NUA*NUB * 8
                CALL MY_BCAST(UROT(1,1,IS),MSGLEN,SOURCE,ALLGRP)
              ENDIF
            ENDIF
          ENDDO
          CALL SCRREL(SCR,LSCR,DEBUG)
          CALL FREEM(IP_CT)
          CALL FREEM(IP_CS)
        ENDIF
      ENDIF
      CALL MEMORY_CHECK
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE EDIA(CT,CS,NO,NV,AMAT,DEIG,AUX,LAUX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        
      INTEGER NO,NV,LAUX
      COMPLEX*16 CT(NGW,NO*NV),CS(NGW,NO*NV)
      REAL*8  AMAT(NO*NV,*),AUX(*),DEIG(NO*NV),DOTP
      EXTERNAL DOTP
      INTEGER I,J,INFO,MSGLEN,NOV,IO,JO
C     ==--------------------------------------------------------------==
      NOV=NO*NV
      CALL AZZERO(AMAT,NOV*NOV)
      DO I=1,NOV
        IO=I/NV+1
        DO J=1,I
          JO=J/NV+1
          IF(IO.EQ.JO) THEN
            AMAT(I,J) = -DOTP(NGW,CS(1,I),CT(1,J))
            AMAT(J,I) = AMAT(I,J)
          ENDIF
        ENDDO
      ENDDO
      CALL GLOSUM(NOV*NOV,AMAT)
      IF(PARENT) THEN
        CALL DSYEV('V','L',NOV,AMAT,NOV,DEIG,AUX,LAUX,INFO)
        IF(INFO.NE.0) CALL STOPGM('EDIA','INFO != 0 AFTER DSYEV')
      ENDIF
#ifdef PARALLEL
      MSGLEN = NOV*NOV * 8
      CALL MY_BCAST(AMAT,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE STCOP2(NS,C0,C2,NSTATE,EIGV,EDAV,CV,NVA,NVB,C1,NACT,
     &                  DDXC,PSI,RHOE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'linres.inc'
      DIMENSION F(*)
      INTEGER NS,NVA,NVB,NACT,NSTATE,LSCR
      REAL*8  EIGV(*),DDXC(*),RHOE(*),SCR(*),EDAV(*)
      COMPLEX*16 C1(NGW,NACT,NLINW,*),CV(NGW,*)
      COMPLEX*16 C0(NGW,*),C2(NGW,*),PSI(*)
C     ==--------------------------------------------------------------==
      REAL*8     DEV,FOCC,DEVMAX,E2(5)
      INTEGER    NV,NO,I,J,IS,IX,IY,IJ,NOV,IS1,IS2,IX1,IX2,IY1,IY2
      COMPLEX*16 CT(NGW,*),CS(NGW,*)
      POINTER    (IP_CT,CT),(IP_CS,CS)
      DIMENSION  UROT(NUA,NUB,*)
      LOGICAL DEBUG,OSTDA
      REAL*8  AMAT(*),AUX(*),DEIG(*)
      POINTER (IP_AMAT,AMAT),(IP_DEIG,DEIG),(IP_AUX,AUX)
      INTEGER LAUX,MSGLEN
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
      IF(TDA.AND.MSUBTA.GT.0.AND..NOT.TDACANON) THEN
        OSTDA=.TRUE.
      ELSE
        OSTDA=.FALSE.
      ENDIF
      NV=NVA+NVB
      IF(TLSD) THEN
        IF(PARENT) WRITE(6,'(A,T56,I10)') 
     &      " NUMBER OF STATES TO BE INITIALIZED ",NS-NLINR
        DO IS=NLINR+1,NS,2
          IS1=IS
          IS2=IS+1
          CALL AZZERO(C1(1,1,IS1,1),2*NGW*NACT)
          IF(.NOT.TDA) CALL AZZERO(C1(1,1,IS1,2),2*NGW*NACT)
          IF(IS2.LE.NS) THEN
            CALL AZZERO(C1(1,1,IS2,1),2*NGW*NACT)
            IF(.NOT.TDA) CALL AZZERO(C1(1,1,IS2,2),2*NGW*NACT)
          ENDIF
          IY1=MAX(NACT/2-(IS-1)/NVA,1)
          IY2=NSUP+MAX(NACT/2-(IS-1)/NVB,1)
          IX1=MOD(IS,NVA)
          IF(IX1.LE.0) IX1=IX1+NVA
          IX1=MIN(IX1,NVA)
          IX2=MOD(IS,NVB)
          IF(IX2.LE.0) IX2=IX2+NVB
          IX2=NVA+MIN(IX2,NVB)
          CALL DCOPY(2*NGW,CV(1,IX1),1,C1(1,IY1,IS1,1),1)
          CALL DCOPY(2*NGW,CV(1,IX2),1,C1(1,IY2,IS1,1),1)
          IF(IS2.LE.NS) THEN
            CALL DCOPY(2*NGW,CV(1,IX1),1,C1(1,IY1,IS2,1),1)
            CALL DCOPY(2*NGW,CV(1,IX2),1,C1(1,IY2,IS2,1),1)
            CALL DSCAL(2*NGW,-1.D0,C1(1,IY2,IS2,1),1)
          ENDIF
          IF(TDRANDOM.GT.0.D0) THEN
            DO IY=1,NACT
              CALL VRAND(2*NGW,C1(1,IY,IS1,1),TDRANDOM)
              IF(.NOT.TDA) CALL VRAND(2*NGW,C1(1,IY,IS1,2),TDRANDOM)
            ENDDO
            CALL ZCLEAN(C1(1,1,IS1,1),NACT,NGW)
            IF(.NOT.TDA) CALL ZCLEAN(C1(1,1,IS1,2),NACT,NGW)
            IF(IS2.LE.NS) THEN
              DO IY=1,NACT
                CALL VRAND(2*NGW,C1(1,IY,IS2,1),TDRANDOM)
                IF(.NOT.TDA) CALL VRAND(2*NGW,C1(1,IY,IS2,2),TDRANDOM)
              ENDDO
              CALL ZCLEAN(C1(1,1,IS2,1),NACT,NGW)
              IF(.NOT.TDA) CALL ZCLEAN(C1(1,1,IS2,2),NACT,NGW)
            ENDIF
          ENDIF
        ENDDO
      ELSEIF(NLINR.LT.NS) THEN
C       initialize states
        IF(PARENT) WRITE(6,'(A,T56,I10)')
     &      " NUMBER OF STATES TO BE INITIALIZED ",NS-NLINR
        DO IS=NLINR+1,NS
          CALL AZZERO(C1(1,1,IS,1),2*NGW*NACT)
          IF(.NOT.TDA) CALL AZZERO(C1(1,1,IS,2),2*NGW*NACT)
          IY=MAX(NACT-(IS-1)/NV,1)
          IX=MOD(IS,NV)
          IF(IX.LE.0) IX=IX+NV
          IX=MIN(IX,NV)
          CALL DCOPY(2*NGW,CV(1,IX),1,C1(1,IY,IS,1),1)
          IF(TDRANDOM.GT.0.D0) THEN
            DO IY=1,NACT
              CALL VRAND(2*NGW,C1(1,IY,IS,1),TDRANDOM)
              IF(.NOT.TDA) CALL VRAND(2*NGW,C1(1,IY,IS,2),TDRANDOM)
              IF(OSTDA) THEN
                CALL VRAND(NUA-NUB,UROT(1,IY,IS),10.D0*TDRANDOM)
                DO I=1,NUA-NUB
                  UROT(I,IY,IS)=UROT(I,IY,IS)*DBLE(I)/DBLE(NUA)
                ENDDO
              ENDIF
            ENDDO
            CALL ZCLEAN(C1(1,1,IS,1),NACT,NGW)
            IF(.NOT.TDA) CALL ZCLEAN(C1(1,1,IS,2),NACT,NGW)
            IF(OSTDA) THEN
              MSGLEN = NUA*NUB * 8
              CALL MY_BCAST(UROT(1,1,IS),MSGLEN,SOURCE,ALLGRP)
            ENDIF
          ENDIF
        ENDDO
      ENDIF
      CALL MEMORY_CHECK
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
