C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == FILE IN WHICH WE HAVE FLAGS                                  ==
C     == FOR RESTART, PRINT AND STORE OPTIONS                         ==
C     ==================================================================
C     == MRESTART: Number of parameters (for parallel)                ==
C     == RESTART: True if restart options                             ==
C     == RWF:   Wavefunctions                                         ==
C     == RCO:   Coordinates                                           ==
C     == RVEL:  Velocities                                            ==
C     == RAC:   Accumulators                                          ==
C     == RHE:   Hessian matrix                                        ==
C     == RNOE:  NOSEE                                                 ==
C     == RNOP:  NOSEP                                                 ==
C     == RNOC:  NOSEC                                                 ==
C     == RGEO:  GEOFILE                                               ==
C     == RLATE: Latest restart                                        ==
C     == RVIB:  Vibrational properties                                ==
C     == RCELL: Cell                                                  ==
C     == RPOT:  Potential                                             ==
C     == RRHO:  Density                                               ==
C     == RKPT:  Kpoints                                               ==
C     == ROCC:  Occupation numbers                                    ==
C     == ROH:   Orbital Hardness                                      ==
C     == RCON:  Constraints                                           ==
C     == RXTP:  Extrapolation                                         ==
C     == RPRNG: Pseudo-random number generator                        ==
C     == RGLE:  (generalized) Langevin equation                       ==
C     == RNON:  NOT RESTART                                           ==
C     ==--------------------------------------------------------------==
C     ==                     GENERAL FILE FORMAT (FOR IREC ALSO)      ==
C     ==--------------------------------------------------------------==
C     ==  Section  1: Header                                          ==
C     ==  Section  2: Symmetry and Cell info                          ==
C     ==  Section  3: Number of atomic species and atoms per species  ==
C     ==  Section  4: Atomic coordinates                              ==
C     ==  Section  5: Atomic velocities                               ==
C     ==  Section  6: Initial atomic coordinates                      ==
C     ==  Section  7: Cutoff, # of electrons, grid                    ==
C     ==  Section  8: States, dual, plane waves                       ==
C     ==  Section  9: PW Coefficients                                 ==
C     ==  Section 10: PW Velocities                                   ==
C     ==  Section 11: Accumulators                                    ==
C     ==  Section 12: Nose thermostats general info                   ==
C     ==  Section 13: Nose thermostats electrons                      ==
C     ==  Section 14: Nose thermostats ions                           ==
C     ==  Section 15: Nose thermostats ions (ULTRA)                   ==
C     ==  Section 16: Nose thermostats ions (MASSIVE)                 ==
C     ==  Section 17: Nose thermostats cell                           ==
C     ==  Section 18: Potential                                       ==
C     ==  Section 19: PW single states                                ==
C     ==  Section 20: H Matrices (cell parameters)                    ==
C     ==  Section 21: K-Points                                        ==
C     ==  Section 22: Electron density                                ==
C     ==  Section 23: Occupation numbers                              ==
C     ==  Section 24: Fermi energy and eigenvalues                    ==
C     ==  Section 25: Classical Particles (coordinates and velocities)==
C     ==  Section 26: LinRes PW Coefficients                          ==
C     ==  Section 27: LinRes PW Velocities                            ==
C     ==  Section 28: Partial Hessian (for microiterative TS search)  ==
C     ==  Section 29: L-BFGS history and status                       ==
C     ==  Section 30: P-RFO status                                    ==
C     ==  Section 31: Adaptive tolerance status                       ==
C     ==  Section 32: Constraints                                     ==
C     ==  Section 33: Cell translation vector in QM/MM runs           ==
C     ==  Section 34: Local temperature parameters                    ==
C     ==  Section 35: Surface Hopping I                               ==
C     ==  Section 36: Surface Hopping II                              ==
C     ==  Section 37: Pseudo-random number generator                  ==
C     ==  Section 38: (generalized) Langevin equation                 ==
C     ==  Section 39 - 98 : empty                                     ==
C     ==  Section 99: Wavefunction history for extrapolation          ==
C     ==--------------------------------------------------------------==
      INTEGER   IREC_INFO,IREC_CELL,IREC_NAS,IREC_CO,IREC_VEL,IREC_ICO,
     &          IREC_CUT,IREC_SDP,IREC_WF,IREC_PWV,IREC_AC,
     &          IREC_NOSE,IREC_NOE,IREC_NOP1,IREC_NOP2,IREC_NOP3,
     &          IREC_NOC,IREC_POT,IREC_PWS,IREC_HE,IREC_KPT,
     &          IREC_RHO,IREC_OCC,IREC_EIGV,IREC_CLAS,IREC_LRWF,
     &          IREC_LRWV,IREC_PHES,
     &          IREC_LBFGS,IREC_PRFO,IREC_RDTL,IREC_CONS,IREC_CTRANS,
     &          IREC_NOP4,IREC_XTRP,IREC_SHOP,IREC_SHOPBO, IREC_PRNG,
     &          IREC_GLE
      PARAMETER (IREC_INFO = 1 ,   IREC_CELL = 2 ,   IREC_NAS  = 3 ,
     &           IREC_CO   = 4 ,   IREC_VEL  = 5 ,   IREC_ICO  = 6 ,
     &           IREC_CUT  = 7 ,   IREC_SDP  = 8 ,   IREC_WF   = 9 ,
     &           IREC_PWV  = 10,   IREC_AC   = 11,   IREC_NOSE = 12,
     &           IREC_NOE  = 13,   IREC_NOP1 = 14,   IREC_NOP2 = 15,
     &           IREC_NOP3 = 16,   IREC_NOC  = 17,   IREC_POT  = 18,
     &           IREC_PWS  = 19,   IREC_HE   = 20,   IREC_KPT  = 21,
     &           IREC_RHO  = 22,   IREC_OCC  = 23,   IREC_EIGV = 24,
     &           IREC_CLAS = 25,   IREC_LRWF = 26,   IREC_LRWV = 27,
     &           IREC_PHES = 28,   IREC_PRFO = 29,   IREC_LBFGS= 30,
     &           IREC_RDTL = 31,   IREC_CONS = 32,   IREC_CTRANS = 33,
     &           IREC_NOP4 = 34,   IREC_SHOP = 35,   IREC_SHOPBO = 36, 
     &           IREC_PRNG = 37,   IREC_GLE = 38,  IREC_XTRP = 99)
C     ==================================================================
      INTEGER          MRESTART
      PARAMETER       (MRESTART=26)
      LOGICAL          RESTART,
     &     RWF,RCO,RVEL,RAC,RHE,RNOE,RNOP,RNOC,RGEO,RLATE,RVIB,RCELL,
     &     RPOT,RKPT,RRHO,ROCC,REIGV,ROH,RLR,RPHES,RLSCL,RDTL,RCON,
     &     RNON,RXTP,RPRNG,RGLE
      COMMON/RESTART1/ RESTART,
     &     RWF,RCO,RVEL,RAC,RHE,RNOE,RNOP,RNOC,RGEO,RLATE,RVIB,RCELL,
     &     RPOT,RKPT,RRHO,ROCC,REIGV,ROH,RLR,RPHES,RLSCL,RDTL,RCON,
     &     RNON,RXTP,RPRNG,RGLE
C     ==================================================================
C     == STORE OPTIONS                                                ==
C     == ISTORE: Store at each ISTORE step                            ==
C     == ISCTORE: Store at each ISCTORE self-consistent iteration     ==
C     == SWF:   Wavefunctions                                         ==
C     == SRHO:  Density                                               ==
C     == SPOT:  Potential                                             ==
C     == TDEBIO: Debug RESTART read and write                         ==
C     ==================================================================
      INTEGER        MSTORE
      PARAMETER     (MSTORE=7)
      INTEGER        ISTORE,ISCTORE
      LOGICAL        SWF,SRHO,SPOT,TDEBIO,TDEBACC
      COMMON/STORE1/ ISTORE,ISCTORE,SWF,SRHO,SPOT,TDEBIO,TDEBACC
C     ==================================================================
C     == STORE IN ANOTHER FILE                                        ==
C     == MROUT: Number of parameters (parallel)                       ==
C     == ROUT: Trajectories                                           ==
C     == MOUT: Trajectories                                           ==
C     == VOUT: vibrational frequencies and eigenvectors - Gaussian    ==
C     == ACOUT: vibrational frequencies and eigenvectors - aClimax    ==
C     == XTOUT: Trajectories in xyz-format                            ==
C     == XGOUT: Trajectories in xyz-format of geometry optimization   ==
C     == DCOUT: Trajectories in dcd-format                            ==
C     == RHOOUT: DENSITY FILE                                         ==
C     == TEBAND: ENERGYBANDS FILE                                     ==
C     ==================================================================
      INTEGER       MROUT,NRHOOUT
      PARAMETER    (MROUT=11)
      LOGICAL       ROUT,MOUT,VOUT,ACOUT,XTIN,DCOUT,XTOUT,XGOUT,
     &              RHOOUT,TEBAND
      COMMON/ROUT1/ ROUT,MOUT,VOUT,ACOUT,XTIN,DCOUT,XTOUT,XGOUT,
     &              RHOOUT,TEBAND,NRHOOUT
      LOGICAL       TRAJSMALL
      INTEGER       TRAJSMALLN
      COMMON/JTRAJ1/ TRAJSMALL
      COMMON/JTRAJ2/ TRAJSMALLN
C     ==================================================================
C     == PRINT OPTIONS                                                ==
C     == TPRINT: True if PRINT OPTION                                 ==
C     == IPRINT_STEP: PRINT EACH IPRINT_STEP STEP                     ==
C     == IPRINT:                                                      ==
C     ==================================================================
      INTEGER   IPRINT_MAX,IPRINT_INFO,
     &          IPRINT_EIGEN,IPRINT_COOR,IPRINT_FORCE,IPRINT_WANN,
     &          IPRINT_EKIN,IPRINT_EEIG,IPRINT_EBAND,IPRINT_ENTROPY,
     &          IPRINT_EHT,IPRINT_ELEC1,IPRINT_ELEC2,
     &          IPRINT_EHEP,IPRINT_EHEE,IPRINT_EHII,
     &          IPRINT_ESELF,IPRINT_ESR,IPRINT_EPSEU,IPRINT_ENL,
     &          IPRINT_EXC,IPRINT_VXC,IPRINT_EGC,IPRINT_EBOGO,
     &          IPRINT_ETOT1,IPRINT_ETOT2,IPRINT_ECAS,IPRINT_ETDDFT,
     &          IPRINT_EPEN,IPRINT_LSCAL,IPRINT_EEXT,IPRINT_EHSIC,
     &          IPRINT_EVDW
      PARAMETER (IPRINT_MAX     = 32,   IPRINT_INFO    =  1,
     &           IPRINT_EIGEN   =  2,   IPRINT_COOR    =  3,
     &           IPRINT_FORCE   =  4,   IPRINT_WANN    =  5,
     &           IPRINT_EKIN    =  6,   IPRINT_EEIG    =  7,
     &           IPRINT_EBAND   =  8,   IPRINT_ENTROPY =  9,
     &           IPRINT_EHT     = 10,   IPRINT_ELEC1   = 11,
     &           IPRINT_ELEC2   = 12,   IPRINT_EHEP    = 13,
     &           IPRINT_EHEE    = 14,   IPRINT_EHII    = 15,
     &           IPRINT_ESELF   = 16,   IPRINT_ESR     = 17,
     &           IPRINT_EPSEU   = 18,   IPRINT_ENL     = 19,
     &           IPRINT_EXC     = 20,   IPRINT_VXC     = 21,
     &           IPRINT_EGC     = 22,   IPRINT_EBOGO   = 23,
     &           IPRINT_ETOT1   = 24,   IPRINT_ETOT2   = 25,
     &           IPRINT_ECAS    = 26,   IPRINT_EPEN    = 27,
     &           IPRINT_ETDDFT  = 28,   IPRINT_LSCAL   = 29,
     &           IPRINT_EEXT    = 30,   IPRINT_EHSIC   = 31,
     &           IPRINT_EVDW    = 32)
C     ==--------------------------------------------------------------==
      LOGICAL        TPRINT, TWRITEBINTRAJECTORY
      LOGICAL        TWRITEFORCETRAJECTORY
      INTEGER        IPRINT_STEP,IPRINT(IPRINT_MAX)
      INTEGER        MINWRITEATOM, MAXWRITEATOM
      COMMON/CPRINT/ TPRINT,IPRINT_STEP,IPRINT, TWRITEBINTRAJECTORY,
     $           MINWRITEATOM, MAXWRITEATOM, TWRITEFORCETRAJECTORY

C     ==================================================================
C     == INTERFACE FILE TO OTHER PW CODES                             ==
C     == INTREAD : Read Interface file                                ==
C     == INTWRITE : Write Interface file                              ==
C     == INTFN : Filename of Interface file                           ==
C     ==================================================================
      LOGICAL   INTREAD,INTWRITE
      CHARACTER*40 INTFN
      COMMON/IFACE1/ INTREAD,INTWRITE
      COMMON/IFACE2/ INTFN
