C     ==================================================================
      SUBROUTINE STRESS(C0,TAU0,F,PSI,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE STRESS TENSOR FROM THE DFT TOTAL ENERGY                 ==
C     ==  (THIS IS ESSENTIALLY A COPY OF PAOLO FOCHERS CODE)          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'prcp.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'str2.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ragg.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'nlcc.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'kpnt.inc' 
      INCLUDE 'kpts.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'symm.inc'        !NROT INDPG XTABLE
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'        !TTROT
      INCLUDE 'kdpc.inc'
      INCLUDE 'kdp.inc'
      INCLUDE 'vdwc.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 PSI(*),C0(NGWK,NSTATE,NKPNT)
      REAL*8     TAU0(3,NAX,NSX),F(NSTATE,NKPTS),SCR(LSCR)
C     Variables
      REAL*8     ARGMAX         !DERFC(ARG) and DEXP(-ARG*ARG) underflow
      PARAMETER (ARGMAX=20.D0)
      REAL*8     DELTAKIN
      PARAMETER  (DELTAKIN=1.D-10)
      DIMENSION  BECS(IMAGP,NAT,NHXS,6,NDFNL,NKPNT),
     &           HGKP(NHG,NKPNT),HGKM(NHG,NKPNT),
     &           DQG(*),RK(3,NKPTS),WK(NKPTS)
      COMPLEX*16 AUXC(NGWK*NAX),QG(NHG),CTMP(NHG)
      REAL*8     GAM(IMAGP*NAX*NDFNL)
      POINTER    (IP_AUXC,AUXC),(IP_GAM,GAM),(IP_QG,QG),(IP_CTMP,CTMP)
      REAL*8     FNL(IMAGP,NAT,NHXS,NSTATE,NKPNT),DFNL(*)
      REAL*8     SGC(6),RXLM(3),
     &           TOPIA,XSKIN,ARG,ZV2,RCKK,RCKJ,XLM,YLM,ZLM,ERRE2,RLM,
     &           ESRTZERO,ADDESR,ADDPRE,REPAND,FXX,SUM,WEIGHT,
     &           ARG1,ARG2,
     &           DDOT
      EXTERNAL   DDOT
      LOGICAL    TZERO
      INTEGER    ISUB,I,IG,LBECS,KK,ISA0,IS,IV,II,K,
     &           J,L,INFM,M,IX,IY,IZ,ISHFT,JV,KI,LI,L2,LJ,KJ,
     &           NKPOINT,KBEG,KINC,KEND,IKIND,IKK,
     &           IL_AUXC,IL_GAM,IL_QG,IL_CTMP,LSTRESS,IKPT,
     &           ISTART
C     k.p arrays and variables (jk)
      DIMENSION  wkdp(nkdp),xkdp(3,nkdp),pkdp(3,nstate,nstate)
      DIMENSION  bkdp(nstate,nstate,nkdp)

      DATA       ISTART /0/
      SAVE       ISTART
#ifdef __DERF
      REAL*8   DERFC
      EXTERNAL DERFC
#endif
#ifdef __VECTOR 
      REAL*8     T1,T2,T3,T4,T5,T6
#endif 
C     ==--------------------------------------------------------------==
      CALL TISET('    STRESS',ISUB)
      IF(TFDIST) CALL STOPGM('STRESS','TFDIST NOT IMPLEMENTED')
      IF(TINLC) THEN
        WRITE(6,*) ' THIS NEEDS FIRST SOME PROGRAMING ! '
        CALL STOPGM('STRESS',' ')
      ENDIF
C     ==--------------------------------------------------------------==
C     07/2008 AK
C     Stress tensor calculation is broken when using vanderbilt ultra-soft
C     pseudopotentials and probably will never be fixed. use Q-E instead.
      IF(TIVAN) THEN
         CALL STOPGM('STRESS',
     $               'STRESS TENSOR IS BROKEN FOR VANDERBILT USPP')
      ENDIF
C     ==--------------------------------------------------------------==
C     SCR partition
      IL_AUXC=2*NGWK*NAX         !NLSM1_S
      IL_GAM =IMAGP*NAX*(NST12(MEPOS,2)-NST12(MEPOS,2)+1) !NLSM1_S
      IF(TIVAN) THEN
        IL_QG   =2*NHG           !DRHOV
        IL_CTMP =2*NHG           !DRHOV
      ELSE
        IL_QG   =0
        IL_CTMP =0
      ENDIF
      LSTRESS=MAX(IL_AUXC+IL_GAM,IL_QG+IL_AUXC)
      CALL TEST_SCR('STRESS','LENGTH',LSCR,LSTRESS)
      CALL GET_ADDR(IP_AUXC,SCR(1))
      CALL GET_ADDR(IP_GAM,SCR(1+IL_AUXC))
      CALL GET_ADDR(IP_QG,SCR(1))
      CALL GET_ADDR(IP_CTMP,SCR(1+IL_QG))
C     ==--------------------------------------------------------------==
C     Initialize
      CALL UNITMX(DELTA,3)
      CALL AZZERO(DEGC,6)
      CALL AZZERO(DLAM,6)
      IF(.NOT.TINLC) CALL AZZERO(DECC,6)
C     Initialize memory            
      IF(ISTART.EQ.0) THEN
        ISTART=1
        ALPHA(1)=1
        ALPHA(2)=2
        ALPHA(3)=3
        ALPHA(4)=2
        ALPHA(5)=3
        ALPHA(6)=3
        BETA(1) =1
        BETA(2) =1
        BETA(3) =1
        BETA(4) =2
        BETA(5) =2
        BETA(6) =3
C       NSTATE=NST12(MEPOS,2)-NST12(MEPOS,1)+1  !=NDFN
C       This works also for parallel
        LBECS=IMAGP*NAT*NHXS*6*(NST12(MEPOS,2)-NST12(MEPOS,1)+1)*NKPNT
        IF(LBECS.LE.0) LBECS=1
        CALL MEMORY(IP_BECS,LBECS,'BECS')
        CALL MEMORY(IP_BETAA,NGWK*NHXS*NSX*6*NKPNT,'BETAA')
        CALL MEMORY(IP_GAGK,6*NHG,'GAGK')
        IF(TKPNT) THEN 
          CALL MEMORY(IP_GAGKP,6*NGW*NKPNT,'GAGKP')
          CALL MEMORY(IP_GAGKM,6*NGW*NKPNT,'GAGKM')
        ENDIF
        IF(TIVAN) THEN
          CALL MEMORY(IP_DRHOVG,2*NHG*6,'DRHOVG')
        ENDIF
        IF(PARENT) CALL PRMEM('    STRESS')
      ENDIF
C     Compute GAGK = G_A * G_K
#ifdef __VECTOR 
!OCL NOALIAS
#ifdef __SR8000
*poption parallel, tlocal(IG)
#endif 
!$OMP parallel do private(IG) shared(TPIBA2)
      DO IG=1,NHG
        GAGK(IG,1) = GK(ALPHA(1),IG)*GK(BETA(1),IG)*TPIBA2
        GAGK(IG,2) = GK(ALPHA(2),IG)*GK(BETA(2),IG)*TPIBA2
        GAGK(IG,3) = GK(ALPHA(3),IG)*GK(BETA(3),IG)*TPIBA2
        GAGK(IG,4) = GK(ALPHA(4),IG)*GK(BETA(4),IG)*TPIBA2
        GAGK(IG,5) = GK(ALPHA(5),IG)*GK(BETA(5),IG)*TPIBA2
        GAGK(IG,6) = GK(ALPHA(6),IG)*GK(BETA(6),IG)*TPIBA2
      ENDDO
#else 
!$OMP parallel do private(KK,IG) shared(TPIBA2) schedule(static)
      DO IG=1,NHG
        DO KK=1,6
          GAGK(IG,KK) = GK(ALPHA(KK),IG)*GK(BETA(KK),IG)*TPIBA2
        ENDDO
      ENDDO
#endif 
C     Initialize the stress arrays
      CALL AZZERO(DEKIN,6)
      CALL AZZERO(DEHC ,6*2)
      CALL AZZERO(DEHT ,6)
      CALL AZZERO(DEXC ,6)
      CALL AZZERO(DESR ,6)
      CALL AZZERO(DEPST,6*2)
      CALL AZZERO(DENL, 6)
      CALL AZZERO(DEGC, 6)
      CALL AZZERO(DLAM, 6)
      IF(.NOT.TINLC) CALL AZZERO(DECC,6)
      IF(.NOT.VDWC)  CALL AZZERO(DEVDW,6)
C     ==--------------------------------------------------------------==
C     == Loop over k points                                           ==
C     ==--------------------------------------------------------------==
      CALL INQ_SWAP(KBEG,KEND,KINC)
      DO IKPT=KBEG,KEND,KINC
        NKPOINT=NKPBL(IKPT)
        IF(TKBLOCK) THEN
          CALL RKPT_SWAP(C0,NSTATE,IKPT,
     &        'HGKP HGKM MASKGW EIGKR TWNL C0')
        ENDIF
        IF(TKPNT) THEN 
C     Initialisation of GAGKP and GAGKM
#if defined(__VECTOR)
          DO IKIND=1,NKPOINT
            IKK=KPBEG(IKPT)+IKIND
!OCL NOALIAS
#ifdef __SR8000
*poption parallel, tlocal(KK,IG)
#endif 
!$OMP parallel do private(KK,IG) shared(TPIBA2)
            DO KK=1,6
              DO IG=1,NGW
                GAGKP(IG,KK,IKIND) =
     &              (RK(ALPHA(KK),IKK) + GK(ALPHA(KK),IG)) *
     &              (RK(BETA (KK),IKK) + GK(BETA (KK),IG)) * TPIBA2
                GAGKM(IG,KK,IKIND) =
     &              (RK(ALPHA(KK),IKK) - GK(ALPHA(KK),IG)) *
     &              (RK(BETA (KK),IKK) - GK(BETA (KK),IG)) * TPIBA2
              ENDDO
            ENDDO
          ENDDO
#else
!OCL NOALIAS
!$OMP  parallel do private(IG,KK,IKIND,IKK) shared(TPIBA2)
!$OMP+ schedule(static)
            DO IG=1,NGW
              DO IKIND=1,NKPOINT
                IKK=KPBEG(IKPT)+IKIND
                DO KK=1,6
                  GAGKP(IG,KK,IKIND) =
     &                (RK(ALPHA(KK),IKK) + GK(ALPHA(KK),IG)) *
     &                (RK(BETA (KK),IKK) + GK(BETA (KK),IG)) * TPIBA2
                  GAGKM(IG,KK,IKIND) =
     &                (RK(ALPHA(KK),IKK) - GK(ALPHA(KK),IG)) *
     &                (RK(BETA (KK),IKK) - GK(BETA (KK),IG)) * TPIBA2
                ENDDO
              ENDDO
          ENDDO
#endif
        ENDIF
C       Initialize BETAA(deriv. of TWNL)
        CALL AZZERO(BETAA(1,1,1,1,1),NGWK*NHXS*NSX*6*NKPOINT)
        CALL PUTBET(IKPT)
        DO IKIND=1,NKPOINT
C         Initialize FNL
          CALL RNLSM(C0(1,1,IKIND),NSTATE,PSI,SCR,LSCR,
     &               1,IKIND,.FALSE.)
C         Initialize BECS(deriv. of FNL), DRHOVG
C         (deriv. of Vanderbilt aug. charge)
          CALL NLSM1_S(C0(1,1,IKIND),AUXC,GAM,NSTATE,IKIND)
          ISA0=0
          DO IS=1,NSP
            DO KK=1,6
              IF(DELTA(ALPHA(KK),BETA(KK)).GT.0.5D0) THEN
                DO IV=1,NGH(IS)
                  DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                    II=I-NST12(MEPOS,1)+1
                    CALL DAXPY(IMAGP*NA(IS),-0.5D0,
     &                   FNL (1,ISA0+1,IV,I,IKIND),1,
     &                   BECS(1,ISA0+1,IV,KK,II,IKIND),1)
                  ENDDO
                ENDDO
              ENDIF
            ENDDO
            ISA0=ISA0+NA(IS)
          ENDDO
        ENDDO
        IF(TIVAN) CALL DRHOV(NSTATE,QG,CTMP)
C       ==------------------------------------------------------------==
C       ==  KINETIC ENERGY CONTRIBUTION                               ==
C       ==------------------------------------------------------------==
c
c k.p kinetic part o the stress (jk)
        if(tkdp) then
          call kdp_stress_kin(nstate,c0,gagk,wkdp,xkdp,pkdp,bkdp,nkdp)
          goto 1111
        endif
c
        DO IKIND=1,NKPOINT
          IKK=KPBEG(IKPT)+IKIND
          DO I=1,NSTATE
            IF(F(I,IKK).NE.0.D0) THEN
              CALL AZZERO(SGC,6)
!OCL NOALIAS
#ifdef __SR8000
*poption parallel, tlocal(IG)
#endif
#if defined(__VECTOR)
!$OMP parallel do private(IG)
#else
!$OMP parallel do private(IG) schedule(static)
#endif
              DO IG=1,NGWK
                DQG(IG)=DREAL(C0(IG,I,IKIND))*DREAL(C0(IG,I,IKIND))+
     *               DIMAG(C0(IG,I,IKIND))*DIMAG(C0(IG,I,IKIND))
              ENDDO
              IF(AKIN.GT.DELTAKIN) THEN
                XSKIN=1.D0/GSKIN
                TOPIA=2.D0*GAKIN/DSQRT(PI)
                IF(TKPNT) THEN
!OCL NOALIAS
#ifdef __SR8000
*poption parallel, tlocal(IG,ARG)
#endif
#if defined(__VECTOR)
!$OMP parallel do private(IG,ARG) shared(TOPIA,XSKIN)
                  DO IG=1,NGW
                    ARG=(HGKP(IG,IKIND)-GCKIN)*XSKIN
                    DQG(IG)=DQG(IG)*(1.D0+TOPIA*XSKIN*DEXP(-ARG*ARG))
                  ENDDO
!OCL NOALIAS
!OCL NOVREC
#ifdef __SR8000
*poption parallel, tlocal(IG,ARG)
#endif
!$OMP parallel do private(IG,ARG) shared(TOPIA,XSKIN)
                  DO IG=1,NGW
                    ARG=(HGKM(IG,IKIND)-GCKIN)*XSKIN
                    DQG(NGW+IG)=DQG(NGW+IG)
     &                  *(1.D0+TOPIA*XSKIN*DEXP(-ARG*ARG))
                  ENDDO
#else
!$OMP parallel do private(IG,ARG1,ARG2) shared(TOPIA,XSKIN) 
!$OMP+ schedule(static)
                  DO IG=1,NGW
                    ARG1=(HGKP(IG,IKIND)-GCKIN)*XSKIN
                    ARG2=(HGKM(IG,IKIND)-GCKIN)*XSKIN
                    DQG(IG)=DQG(IG)*(1.D0+TOPIA*XSKIN*DEXP(-ARG1*ARG1))
                    DQG(NGW+IG)=DQG(NGW+IG)
     &                  *(1.D0+TOPIA*XSKIN*DEXP(-ARG2*ARG2))
                  ENDDO
#endif
                ELSE
!OCL NOALIAS
#ifdef __SR8000
*poption parallel, tlocal(IG,ARG)
#endif 
#if defined(__VECTOR)
!$OMP parallel do private(IG,ARG) shared(TOPIA,XSKIN)
#else
!$OMP parallel do private(IG,ARG) shared(TOPIA,XSKIN) schedule(static)
#endif
                  DO IG=1,NGW
                    ARG=(HG(IG)-GCKIN)*XSKIN
                    DQG(IG)=DQG(IG)*(1.D0+TOPIA*XSKIN*DEXP(-ARG*ARG))
                  ENDDO
                ENDIF
              ENDIF
              IF(TKPNT) THEN
#ifdef __SR8000
*poption parallel, tlocal(KK,IG)
#endif 
#if defined(__VECTOR)
!$OMP parallel do private(KK,IG)
                DO KK=1,6
                  DO IG=1,NGW
                    SGC(KK)=SGC(KK)+DREAL(DQG(IG)*GAGKP(IG,KK,IKIND))
     .                  +DREAL(DQG(NGW+IG)*GAGKM(IG,KK,IKIND))
                  ENDDO
                ENDDO
#else
!$OMP parallel do private(KK,IG) reduction(+:SGC) schedule(static)
                DO IG=1,NGW
                  DO KK=1,6
                    SGC(KK)=SGC(KK)+(DREAL(DQG(IG)*GAGKP(IG,KK,IKIND))
     .                  +DREAL(DQG(NGW+IG)*GAGKM(IG,KK,IKIND)))
                  ENDDO
                ENDDO
#endif
              ELSE
#ifdef __VECTOR 
                T1=0.0D0
                T2=0.0D0
                T3=0.0D0
                T4=0.0D0
                T5=0.0D0
                T6=0.0D0
!$OMP parallel do private(IG)
!$OMP+ reduction(+:T1,T2,T3,T4,T5,T6)
                DO IG=1,NGW
                  T1=T1+DREAL(DQG(IG)*GAGK(IG,1))
                  T2=T2+DREAL(DQG(IG)*GAGK(IG,2))
                  T3=T3+DREAL(DQG(IG)*GAGK(IG,3))
                  T4=T4+DREAL(DQG(IG)*GAGK(IG,4))
                  T5=T5+DREAL(DQG(IG)*GAGK(IG,5))
                  T6=T6+DREAL(DQG(IG)*GAGK(IG,6))
                ENDDO
                SGC(1)=SGC(1)+T1
                SGC(2)=SGC(2)+T2
                SGC(3)=SGC(3)+T3
                SGC(4)=SGC(4)+T4
                SGC(5)=SGC(5)+T5
                SGC(6)=SGC(6)+T6
#else 
!$OMP parallel do private(KK,IG)
                DO KK=1,6
                  DO IG=1,NGW
                    SGC(KK)=SGC(KK)+DREAL(DQG(IG)*GAGK(IG,KK))
                  ENDDO
                ENDDO
#endif 
              ENDIF
              WEIGHT=WK(IKK)*F(I,IKK)
              CALL DAXPY(6,WEIGHT,SGC(1),1,DEKIN(1),1)
            ENDIF
          ENDDO
        ENDDO
1111    continue
C       ==------------------------------------------------------------==
C       ==  NON-LOCAL CONTRIBUTION dENL/dH                            ==
C       ==------------------------------------------------------------==
        DO IKIND=1,NKPOINT
          IKK=KPBEG(IKPT)+IKIND
          ISA0=0
          DO IS=1,NSP
            IF(TVAN(IS)) THEN
C             VANDERBILT PSEUDOPOTENTIAL
              DO IV=1,NGH(IS)
                DO JV=1,NGH(IS)
                  DO KK=1,6
                    SUM=0.0D0
                    DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                      II=I-NST12(MEPOS,1)+1
                      IF(F(I,IKK).NE.0.D0) THEN
                        WEIGHT=WK(IKK)*F(I,IKK)
                        SUM=SUM+WEIGHT*DDOT(IMAGP*NA(IS),
     &                       BECS(1,ISA0+1,IV,KK,II,IKIND),1,
     &                       FNL (1,ISA0+1,JV,I,IKIND),1)
                      ENDIF
                    ENDDO
                    DENL(KK) = DENL(KK) + 2.0D0*SUM*DVAN(JV,IV,IS)
                  ENDDO
                ENDDO
              ENDDO
            ELSEIF(TSGP(IS)) THEN
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L.EQ.L2.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    DO KK=1,6
                      SUM=0.0D0
                      DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                        II=I-NST12(MEPOS,1)+1
                        IF(F(I,IKK).NE.0.D0) THEN
                          WEIGHT=WK(IKK)*F(I,IKK)
                          SUM=SUM+WEIGHT*DDOT(IMAGP*NA(IS),
     &                         BECS(1,ISA0+1,IV,KK,II,IKIND),1,
     &                         FNL (1,ISA0+1,JV,I,IKIND),1)
                        ENDIF
                      ENDDO
                      DENL(KK) = DENL(KK) + 2.D0*SUM*HLSG(KI,KJ,L,IS)
                    ENDDO
                  ENDIF
                ENDDO
              ENDDO
            ELSE
C             BHS AND RELATED
              DO IV=1,NGH(IS)
                DO KK=1,6
                  SUM=0.0D0
                  DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                    II=I-NST12(MEPOS,1)+1
                    IF(F(I,IKK).NE.0.D0) THEN
                      WEIGHT=WK(IKK)*F(I,IKK)
                      SUM=SUM+WEIGHT*DDOT(IMAGP*NA(IS),
     &                     BECS(1,ISA0+1,IV,KK,II,IKIND),1,
     &                     FNL (1,ISA0+1,IV,I,IKIND),1)
                    ENDIF
                  ENDDO
                  DENL(KK) = DENL(KK) + 2.0D0*SUM*WSG(IS,IV)
                ENDDO
              ENDDO
            ENDIF
            ISA0=ISA0+NA(IS)
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      IF(TKPNT) THEN 
        CALL DSCAL(6,-1.0D0,DEKIN(1),1)
      ELSE if(.not.tkdp) then
        CALL DSCAL(6,-2.0D0,DEKIN(1),1)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  ESR CONTRIBUTION                                            ==
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        DO K=1,NSP
          RCKK = RAGGIO(K)*RAGGIO(K)
          DO J=K,NSP
            ZV2 = ZV(K)*ZV(J)
            RCKJ = DSQRT(RCKK + RAGGIO(J)*RAGGIO(J))
            DO L=1,NA(K)
              INFM = 1
              IF(K.EQ.J)  INFM=L
              DO M=INFM,NA(J)
                IF(L.EQ.M.AND.K.EQ.J) THEN
                  XLM = 0.0D0
                  YLM = 0.0D0
                  ZLM = 0.0D0
                  TZERO=.TRUE.
                ELSE
                  TZERO=.FALSE.
                  XLM = TAU0(1,L,K) - TAU0(1,M,J)
                  YLM = TAU0(2,L,K) - TAU0(2,M,J)
                  ZLM = TAU0(3,L,K) - TAU0(3,M,J)
                  CALL PBC(XLM,YLM,ZLM,XLM,YLM,ZLM,1,APBC,IBRAV)
                END IF
                DO IX=-IESR,IESR
                  DO IY=-IESR,IESR
                    DO IZ=-IESR,IESR
                      ISHFT=IX*IX+IY*IY+IZ*IZ
                      IF(.NOT.(TZERO.AND.ISHFT.EQ.0)) THEN
                        RXLM(1)=XLM+IX*HT(1,1)+IY*HT(2,1)+IZ*HT(3,1)
                        RXLM(2)=YLM+IX*HT(1,2)+IY*HT(2,2)+IZ*HT(3,2)
                        RXLM(3)=ZLM+IX*HT(1,3)+IY*HT(2,3)+IZ*HT(3,3)
                        ERRE2 = RXLM(1)**2 + RXLM(2)**2 + RXLM(3)**2
                        RLM = DSQRT(ERRE2)
                        IF(TZERO) THEN
                          ESRTZERO=0.5D0
                        ELSE
                          ESRTZERO=1.D0
                        END IF
                        ARG = RLM/RCKJ
                        IF(ARG.LE.ARGMAX) THEN !ADDESR,ADDPRE /= 0
                          ADDESR = ZV2*DERFC(ARG)/RLM
                          ADDPRE=(2.D0*ZV2/DSQRT(PI))
     &                          *DEXP(-ARG*ARG)/RCKJ
                          REPAND = ESRTZERO*(ADDESR+ADDPRE)/ERRE2
                          DO KK=1,6
                            FXX = REPAND*RXLM(ALPHA(KK))*RXLM(BETA(KK))
                            DESR(KK) = DESR(KK) - FXX
                          END DO
                        ENDIF
                      END IF
                    END DO  ! IZ
                  END DO    ! IY
                END DO      ! IX
              END DO        ! M
            END DO          ! L
          END DO            ! J
        END DO              ! K
      ENDIF
      CALL TIHALT('    STRESS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_STRESS(LSTRESS,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !pslo.inc
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'kpts.inc'        !TKBLOCK
      INCLUDE 'elct.inc'        !N
C     Arguments
      INTEGER   LSTRESS,NSTATE
      CHARACTER TAG*30
C     Variables
      INTEGER   LRNLSM
C     ==--------------------------------------------------------------==
C     NLSM1_S
      LSTRESS=2*NGW*NAX+
     &        NAX*(NST12(MEPOS,2)-NST12(MEPOS,2)+1)
C     DRHOV
      IF(TIVAN) LSTRESS=MAX(LSTRESS,4*NHG)
      IF(TKBLOCK) THEN
        CALL GIVE_SCR_RNLSM(LRNLSM,TAG,N,.FALSE.)
        LSTRESS=MAX(LSTRESS,LRNLSM)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
