C     ==================================================================
      SUBROUTINE PSTRUC(TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'empf.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'struc.inc'
      INCLUDE 'irat.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSX)
C     Variables
      INTEGER NBONDS(*)
      POINTER (IP_NBONDS,NBONDS)
      REAL*8  RCOV(0:104),
     &        XMFAC
      INTEGER NMA,NMPA1,K,I,J,NCC
C     ==--------------------------------------------------------------==
      IF(.NOT.BOND.AND..NOT.ANGLE.AND..NOT.DIHEDRAL) RETURN
      NMA=NAT
      NMPA1=(NAT*(NAT+1))/2
      CALL MEMORY(IP_ZAN,NAT,'ZAN')
      CALL MEMORY(IP_C,3*NAT,'C')
      CALL MEMORY(IP_IBIND,NMPA1/IRAT+1,'IBIND')
      CALL MEMORY(IP_NBONDS,NAT/IRAT+1,'NBONDS')
      CALL IAZZERO(IBIND,NMPA1)
      CALL IAZZERO(NBONDS,NAT)
      NATY=NAT
      K=0
      DO I=1,NSP
        DO J=1,NA(I)
          K=K+1
          ZAN(K)=DBLE(IATYP(I))
          C(1,K)=TAU0(1,J,I)
          C(2,K)=TAU0(2,J,I)
          C(3,K)=TAU0(3,J,I)
        ENDDO
      ENDDO
      DO I=1,99
        RCOV(I)=COVRAD(I)*FBOHR
      ENDDO
      NCC=3*NAT
      XMFAC=1.35D0
      CALL CPMDBONDS(RCOV,XMFAC,NBONDS)
C     ==--------------------------------------------------------------==
      IF(TSSEL) CALL SELECT_BONDS(NBONDS)
      IF(BOND) CALL PBONDS
      IF(ANGLE) CALL PANGLES(NBONDS)
      IF(DIHEDRAL) CALL PDIHED(NBONDS)
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_ZAN)
      CALL FREEM(IP_C)
      CALL FREEM(IP_IBIND)
      CALL FREEM(IP_NBONDS)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SELECT_BONDS(NBONDS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'empf.inc'
      INCLUDE 'struc.inc'
C     Variables
      INTEGER IA,IB,NBONDS(*)
      LOGICAL IL,JL,FINDLA
      EXTERNAL FINDLA
C     ==--------------------------------------------------------------==
      IL=FINDLA(1)
      IF(.NOT.IL) NBONDS(1)=0
      DO IA=2,NATY
        IL=FINDLA(IA)
        IF(.NOT.IL) NBONDS(IA)=0
        DO IB=1,IA-1
          JL=FINDLA(IB)
          IF(.NOT.IL .OR. .NOT.JL) IBIND(IB+IA*(IA-1)/2)=0
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      LOGICAL FUNCTION FINDLA(IA)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INTEGER I,IA
C     ==--------------------------------------------------------------==
      FINDLA=.FALSE.
      DO I=1,NSSEL
        IF(NASSEL(I).EQ.IA) THEN
          FINDLA=.TRUE.
          GOTO 100
        ENDIF
      ENDDO
  100 CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PBONDS
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'empf.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'struc.inc'
C     Variables
      REAL*8  DD,
     &        DIST
      INTEGER IA,IS1,IB,IS2,IAB,
     &        SPECIA
C     ==--------------------------------------------------------------==
      WRITE(6,'(30X,A,/,A,A)') ' BONDS',' ATOM 1  ATOM 2  ',
     * ' TYPE 1   TYPE 2      DISTANCE (BOHR, ANGSTROM)'
      DO IA=2,NATY
        IS1=SPECIA(IA)
        DO IB=1,IA-1
          IS2=SPECIA(IB)
          IAB=IBIND(IB+IA*(IA-1)/2)
          IF(IAB.NE.0) THEN
            DD=SQRT(DIST(IA,IB))
            WRITE(6,'(I5,I8,7X,A2,7X,A2,9X,2F12.5)')
     *            IA,IB,EL(IATYP(IS1)),EL(IATYP(IS2)),DD,DD/FBOHR
          ENDIF
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION SPECIA(IA)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
C     Arguments
      INTEGER IA,SPECIA
C     Variables
      INTEGER IX,IS
C     ==--------------------------------------------------------------==
      SPECIA=0
      IX=0
      DO IS=1,NSP
        IF(IX+NA(IS).GE.IA) THEN
          SPECIA=IS
          RETURN
        ENDIF
        IX=IX+NA(IS)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PANGLES(NBONDS)
C     ==--------------------------------------------------------------==
      IMPLICIT nONE
      INCLUDE 'system.h'
      INCLUDE 'empf.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'struc.inc'
C     Arguments
      INTEGER NBONDS(NATY)
C     Variables
      REAL*8  ALPHA,
     &        WINKEL
      INTEGER IA,IB,I,J,IAB,IC,IAC,IS1,IS2,IS3,
     &        SPECIA
C     ==--------------------------------------------------------------==
      WRITE(6,'(30X,A,/,A,A)') ' ANGLES','    ATOM NUMBERS    ',
     * '    ATOM TYPES       BOND ANGLES(DEGREES)     '
      DO IA=1,NATY
        IF(NBONDS(IA).GE.2) THEN
          DO IB=1,NATY
            I  =MAX(IA,IB)
            J  =MIN(IA,IB)
            IAB=IBIND(J+I*(I-1)/2)
            IF(IB.NE.IA.AND.IAB.NE.0) THEN
              DO IC=IB+1,NATY
                I  =MAX(IA,IC)
                J  =MIN(IA,IC)
                IAC=IBIND(J+I*(I-1)/2)
                IF(IC.NE.IA.AND.IAC.NE.0) THEN
                  ALPHA=WINKEL(IB,IC,IA)
                  IS1=SPECIA(IA)
                  IS2=SPECIA(IB)
                  IS3=SPECIA(IC)
                  WRITE(6,'(2X,3I4,8X,3(A2,4X),8X,F10.4)') 
     *                    IB,IA,IC,EL(IATYP(IS2)),EL(IATYP(IS1)),
     *                    EL(IATYP(IS3)),ALPHA
                ENDIF
              ENDDO
            ENDIF
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PDIHED(NBONDS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'empf.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'struc.inc'
C     Arguments
      INTEGER NBONDS(NATY)
C     Variables
      REAL*8  ALPHA,BETA,GAMMA,DELTA,
     &        WINKEL,OUTPD,TORSD
      INTEGER IA,IB,I,J,IAB,IC,IAC,IS1,IS2,IS3,IAD,IS4,ID,IBD,
     &        SPECIA
C     ==--------------------------------------------------------------==
      WRITE(6,'(30X,A,/,A,A)') ' DIHEDRALS','  TYPE    ATOM NUMBERS   ',
     * '   ATOM TYPES     DIHEDRAL ANGLES(DEG)     '
      DO IA=1,NATY
        IF(NBONDS(IA).GE.2) THEN
          DO IB=1,NATY
            I  =MAX(IA,IB)
            J  =MIN(IA,IB)
            IAB=IBIND(J+I*(I-1)/2)
            IF(IB.NE.IA.AND.IAB.NE.0) THEN
              DO IC=IB+1,NATY
                I  =MAX(IA,IC)
                J  =MIN(IA,IC)
                IAC=IBIND(J+I*(I-1)/2)
                IF(IC.NE.IA.AND.IAC.NE.0) THEN
                  IF(NBONDS(IA).GE.3) THEN
                    DO ID=IC+1,NATY
                      I  =MAX(IA,ID)
                      J  =MIN(IA,ID)
                      IAD=IBIND(J+I*(I-1)/2)
                      IF(ID.NE.IA.AND.IAD.NE.0) THEN
                        ALPHA=WINKEL(IB,IC,IA)
                        BETA =WINKEL(IC,ID,IA)
                        GAMMA=WINKEL(IB,ID,IA)
                        IF(ALPHA.NE.180.D0.AND.BETA.NE.180.D0
     *                     .AND.GAMMA.NE.180.D0) THEN
                          IS1=SPECIA(IB)
                          IS2=SPECIA(IC)
                          IS3=SPECIA(IA)
                          IS4=SPECIA(ID)
                          DELTA=OUTPD(IB,IC,IA,ID)
                          WRITE(6,'(2X,A,4I4,4X,4(A2,2X),4X,F10.4)') 
     *          'OUTP',IB,IC,IA,ID,EL(IATYP(IS2)),EL(IATYP(IS1)),
     *          EL(IATYP(IS3)),EL(IATYP(IS4)),DELTA
                        ENDIF
                      ENDIF
                    ENDDO
                  ENDIF
                ENDIF
              ENDDO
              IF(NATY.GE.4.AND.NBONDS(IB).GE.2.AND.IA.LT.IB) THEN
                DO IC=1,NATY
                  I  =MAX(IC,IA)
                  J  =MIN(IC,IA)
                  IAC=IBIND(J+I*(I-1)/2)
                  IF(IC.NE.IA.AND.IC.NE.IB.AND.IAC.NE.0) THEN
                    DO ID=1,NATY
                      I  =MAX(IB,ID)
                      J  =MIN(IB,ID)
                      IBD=IBIND(J+I*(I-1)/2)
                      IF(ID.NE.IA.AND.ID.NE.IB.AND.ID.NE.IC.AND.
     *                   IBD.NE.0) THEN
                        ALPHA=WINKEL(IC,IB,IA)
                        BETA =WINKEL(IA,ID,IB)
                        IF(ALPHA.NE.180.D0.AND.BETA.NE.180.D0) THEN
                          IS1=SPECIA(IC)
                          IS2=SPECIA(IA)
                          IS3=SPECIA(IB)
                          IS4=SPECIA(ID)
                          DELTA=TORSD(IC,IA,IB,ID)
                          WRITE(6,'(2X,A,4I4,4X,4(A2,2X),4X,F10.4)') 
     *            'TORS',IC,IA,IB,ID,EL(IATYP(IS2)),EL(IATYP(IS1)),
     *            EL(IATYP(IS3)),EL(IATYP(IS4)),DELTA
                        ENDIF
                      ENDIF
                    ENDDO
                  ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION OUTPD(IA,IB,IC,ID)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'empf.inc'
      INCLUDE 'cnst.inc'
C     Arguments
      INTEGER IA,IB,IC,ID
      REAL*8  OUTPD
C     Variables
      REAL*8  U(3),V(3),W(3),
     &        PIH,OO
      INTEGER I
C     ==--------------------------------------------------------------==
      DO I=1,3
        U(I)=C(I,IC)-C(I,IA)
        V(I)=C(I,IC)-C(I,IB)
      ENDDO
      CALL NORMAL(U,V,W)
      DO I=1,3
        W(I)=W(I)+C(I,IC)
      ENDDO
      PIH=ZERO
      CALL FUNCT(OO,OUTPD,PIH,W,C(1,IC),C(1,ID))
      OUTPD=PI*DP12-OUTPD
      CALL RADDEG(OUTPD,1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION TORSD(IA,IB,IC,ID)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'empf.inc'
C     Arguments
      INTEGER IA,IB,IC,ID
      REAL*8  TORSD
C     Variables
      REAL*8  U(3),V(3),W1(3),W2(3),
     &        PIH,TT
      INTEGER I
C     ==--------------------------------------------------------------==
      DO I=1,3
        U(I)=C(I,IB)-C(I,IA)
        V(I)=C(I,IB)-C(I,IC)
      ENDDO
      CALL NORMAL(U,V,W1)
      DO I=1,3
        U(I)=C(I,IC)-C(I,IB)
        V(I)=C(I,IC)-C(I,ID)
      ENDDO
      CALL NORMAL(U,V,W2)
      DO I=1,3
        W1(I)=W1(I)+C(I,IC)
        W2(I)=W2(I)+C(I,IC)
      ENDDO
      PIH=ZERO
      CALL FUNCT(TT,TORSD,PIH,W1,C(1,IC),W2)
      CALL RADDEG(TORSD,1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

