#if defined (_vpp_) || defined (__SR8000) || defined (__ES)
C     ==================================================================
      SUBROUTINE SUMFNL(FNL0,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'        !NLM IMAGP
      INCLUDE 'sfac.inc'
      INCLUDE 'irat.inc'
C     Arguments
      INTEGER   NSTATE,LSCR
      REAL*8    FNL0(IMAGP,NAT,NHXS,NSTATE),SCR(LSCR)
C     Variables
      REAL*8    FNL(*),DFNL(*)
#ifdef PARALLEL
      CHARACTER TAG*30
      INTEGER   IS,ISUB,II,IAT0,I,IV,IA,IM,IAT,IMAX,LSUMFNL
#endif
      INTEGER   III(IMAGP,NAT,NHXS,NSTATE),IAT1(IMAGP*NAX,NSX,2)
      POINTER   (IP_III,III),(IP_IAT1,IAT1)
      INTEGER   ISA,LENGTH
C     ==--------------------------------------------------------------==
      IF(NPROC.LE.1) RETURN
#ifdef PARALLEL
      IMAX=IMAGP*NLM*NSTATE
      IF(IMAX.EQ.0) RETURN
      CALL GIVE_SCR_SUMFNL(LSUMFNL,TAG,NSTATE)
      CALL TEST_SCR('SUMFNL',TAG,LSCR,LSUMFNL)
      CALL TISET('    SUMFNL',ISUB)
      LENGTH=IMAGP*NAT*NHXS*NSTATE
      CALL MEMORY(IP_III,LENGTH/IRAT+1,'III')
      LENGTH=IMAGP*NAX*NSP*2
      CALL MEMORY(IP_IAT1,LENGTH/IRAT+1,'IAT1')
C     Fill index array used to shift the atom index
C     I -> {1,...,NA(1),NA(1)+1,...,NA(1)+NA(2),...}
      II=0
      DO IA=1,NA(1)
        DO IM=1,IMAGP 
          II=II+1 
          IAT1(II,1,1)=IA 
          IAT1(II,1,2)=IM 
        ENDDO 
      ENDDO 
      IAT0=0
      DO IS=2,NSP 
        II=0
        IAT0=IAT0+NA(IS-1)
        DO IA=1,NA(IS) 
          DO IM=1,IMAGP 
            II=II+1 
            IAT1(II,IS,1)=IAT0+IA 
            IAT1(II,IS,2)=IM 
          ENDDO 
        ENDDO 
      ENDDO 
C     Prepare the III array for pseudo-vectorization
      II=0
      DO I=1,NSTATE
        DO IS=1,NSP
          DO IV=1,NGH(IS)
            DO ISA=1,NA(IS)*IMAGP 
              IAT=IAT1(ISA,IS,1)
              IM=IAT1(ISA,IS,2)
              II=II+1
              III(IM,IAT,IV,I)=II
            ENDDO
          ENDDO
        ENDDO
      ENDDO
#ifdef __SR8000
*poption parallel, tlocal(IAT,IM)
*voption indep(IAT1,III,SCR)
#endif
!$OMP parallel do private(I,IS,IV,ISA,IAT,IM)
      DO I=1,NSTATE
        DO IS=1,NSP
          DO IV=1,NGH(IS)
            DO ISA=1,NA(IS)*IMAGP 
              IAT=IAT1(ISA,IS,1)
              IM=IAT1(ISA,IS,2)
              SCR(III(IM,IAT,IV,I))=FNL0(IM,IAT,IV,I)
            ENDDO 
          ENDDO
        ENDDO
      ENDDO
      CALL AZZERO(FNL0,IMAX)
      CALL MY_COMBINE(SCR,FNL0,8*IMAX,1,ALLGRP)
      CALL DCOPY(IMAX,FNL0(1,1,1,1),1,SCR(1),1)
#ifdef __SR8000
*poption parallel, tlocal(IAT,IM)
*voption indep(IAT1,III,SCR)
#endif
!$OMP parallel do private(I,IS,IV,ISA,IAT,IM)
      DO I=1,NSTATE
        DO IS=1,NSP
          DO IV=1,NGH(IS)
            DO ISA=1,NA(IS)*IMAGP 
              IAT=IAT1(ISA,IS,1) 
              IM=IAT1(ISA,IS,2) 
              FNL0(IM,IAT,IV,I)=SCR(III(IM,IAT,IV,I))
            ENDDO 
          ENDDO
        ENDDO
      ENDDO
      CALL FREEM(IP_III)
      CALL FREEM(IP_IAT1)
      CALL TIHALT('    SUMFNL',ISUB)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#else
C     ==================================================================
      SUBROUTINE SUMFNL(FNL0,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'nlps.inc'        !NLM IMAGP
      INCLUDE 'sfac.inc'
C     Arguments
      INTEGER   NSTATE,LSCR
      REAL*8    FNL0(IMAGP,NAT,NHXS,*),SCR(LSCR)
C     Variables
      REAL*8    FNL(*),DFNL(*)
#ifdef PARALLEL
      CHARACTER TAG*30
      INTEGER   IS,ISUB,II,IAT0,I,IV,IA,IM,IAT,IMAX,LSUMFNL
#endif
C     ==--------------------------------------------------------------==
      IF(NPROC.LE.1) RETURN
#ifdef PARALLEL
      IMAX=IMAGP*NLM*NSTATE
      IF(IMAX.EQ.0) RETURN
      CALL GIVE_SCR_SUMFNL(LSUMFNL,TAG,NSTATE)
      CALL TEST_SCR('SUMFNL',TAG,LSCR,LSUMFNL)
      CALL TISET('    SUMFNL',ISUB)
      II = 0
      IAT0=0
      DO IS=1,NSP
        DO I=1,NSTATE
          DO IV=1,NGH(IS)
            IF(IMAGP.EQ.2) THEN
C$OMP parallel do private(ia,iat)
              DO IA=1,NA(IS)
                IAT=IAT0+IA
                SCR(II+2*IA-1)=FNL0(1,IAT,IV,I)
                SCR(II+2*IA)=FNL0(2,IAT,IV,I)
              ENDDO
              II = II + 2*NA(IS)
            ELSE
C$OMP parallel do private(ia,iat)
              DO IA=1,NA(IS)
                IAT=IAT0+IA
                SCR(II+IA)=FNL0(1,IAT,IV,I)
              ENDDO
              II = II + NA(IS)
            ENDIF
          ENDDO
        ENDDO
        IAT0=IAT0+NA(IS)
      ENDDO
      CALL AZZERO(FNL0,IMAX)
      CALL MY_COMBINE(SCR,FNL0(1,1,1,1),8*IMAX,1,ALLGRP)
      CALL DCOPY(IMAX,FNL0(1,1,1,1),1,SCR(1),1)
      II = 0
      IAT0=0
      DO IS=1,NSP
        DO I=1,NSTATE
          DO IV=1,NGH(IS)
            IF(IMAGP.EQ.2) THEN
C$OMP parallel do private(ia,iat)
              DO IA=1,NA(IS)
                IAT=IAT0+IA
                FNL0(1,IAT,IV,I)=SCR(II+2*IA-1)
                FNL0(2,IAT,IV,I)=SCR(II+2*IA)
              ENDDO
              II = II + 2*NA(IS)
            ELSE
C$OMP parallel do private(ia,iat)
              DO IA=1,NA(IS)
                IAT=IAT0+IA
                FNL0(1,IAT,IV,I)=SCR(II+IA)
              ENDDO
              II = II + NA(IS)
            ENDIF
          ENDDO
        ENDDO
        IAT0=IAT0+NA(IS)
      ENDDO
      CALL TIHALT('    SUMFNL',ISUB)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#endif
C     ==================================================================
      SUBROUTINE GIVE_SCR_SUMFNL(LSUMFNL,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NPROC
      INCLUDE 'nlps.inc'        !NLM IMAGP
C     Arguments
      INTEGER   LSUMFNL,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      IF(NPROC.LE.1) THEN
        LSUMFNL=0
      ELSE
        LSUMFNL=IMAGP*NLM*NSTATE
        TAG   ='IMAGP*NLM*NSTATE'
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SUMFNLD(FNLX,ISA0,NAI,IV,I,NS,NSTATE,IKK,IM,GRP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'ions.inc'
      include 'sfac.inc'
C     Arguments
      INTEGER ISA0,NAI,IV,I,NS,NSTATE,IKK,IM,GRP
      REAL*8  FNLX(IM,NAI,NS)
C     Variables
      DIMENSION FNL2(IM,NAT,NHXS,LDF2,*)
      REAL*8    FNL(IM,LDF1,NHXS,NSTATE,*),DFNL(*)
      INTEGER   NMIN,NMAX,IST,II,ISA,IA,IX
#ifdef PARALLEL
      INTEGER JJ
#endif
C     ==--------------------------------------------------------------==
      CALL GLOSUM(IM*NAI*NS,FNLX)
      NMIN=MAX(ISA0+1,IPEPT(1,MEPOS))
      NMAX=MIN(ISA0+NAI,IPEPT(2,MEPOS))
C$OMP parallel do private(ist,ii,isa,ia,ix)
      DO IST=I,I+NS-1
        II=IST-I+1
        DO ISA=NMIN,NMAX
          IA=ISA-ISA0
          IX=ISA-IPEPT(1,MEPOS)+1
          IF(IM.EQ.1) THEN
            FNL(1,IX,IV,IST,IKK)=FNLX(1,IA,II)
          ELSE
            FNL(1,IX,IV,IST,IKK)=FNLX(1,IA,II)
            FNL(2,IX,IV,IST,IKK)=FNLX(2,IA,II)
          ENDIF
        ENDDO
      ENDDO
#ifdef PARALLEL
      IF(TFNL2) THEN
        NMIN=MAX(I,NST12(MEPOS,1))
        NMAX=MIN(I+NS-1,NST12(MEPOS,2))
C$OMP parallel do private(ist,ii,jj,ia,isa)
        DO IST=NMIN,NMAX
          II=IST-NST12(MEPOS,1)+1
          JJ=IST-I+1
          DO IA=1,NAI
            ISA=ISA0+IA
            IF(IM.EQ.1) THEN
              FNL2(1,ISA,IV,II,IKK)=FNLX(1,IA,JJ)
            ELSE
              FNL2(1,ISA,IV,II,IKK)=FNLX(1,IA,JJ)
              FNL2(2,ISA,IV,II,IKK)=FNLX(2,IA,JJ)
            ENDIF
          ENDDO
        ENDDO
      ENDIF
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
