C     ==================================================================
      SUBROUTINE SUMMAT(A,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER NSTATE,LSCR
      REAL*8  A(NSTATE,NSTATE),SCR(LSCR)
C     Variables
      INTEGER ISUB,N2,NTR,K,I,J
C     ==--------------------------------------------------------------==
C     == GLOBAL SUMMATION OF A SYMMETRIC MATRIX                       ==
C     ==--------------------------------------------------------------==
      IF(NPROC.LE.1) RETURN
      CALL TISET('    SUMMAT',ISUB)
      N2 = NSTATE*NSTATE
      NTR = (NSTATE*(NSTATE+1))/2
      CALL TEST_SCR('SUMMAT','(NSTATE*(NSTATE+1))/2',LSCR,NTR)
C$OMP parallel do private(I,J,K) schedule(static,1)
#ifdef __SR8000
*poption parallel, tlocal(I,J,K), cyclic 
#endif
      DO I=1,NSTATE
        DO J=I,NSTATE
          K=I+(J*(J-1))/2
          SCR(K)=A(I,J)
        ENDDO
      ENDDO
      CALL MY_COMBINE(SCR,A,8*NTR,1,ALLGRP)
      CALL DCOPY(NTR,A(1,1),1,SCR(1),1)
C$OMP parallel do private(I,J,K) schedule(static,1)
#ifdef __SR8000
*poption parallel, cyclic 
#endif 
      DO I=1,NSTATE
        DO J=I,NSTATE
          K=I+(J*(J-1))/2
          A(I,J)=SCR(K)
          A(J,I)=SCR(K)
        ENDDO
      ENDDO
      CALL TIHALT('    SUMMAT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SUMMAT_PARENT(A,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER NSTATE,LSCR
      REAL*8  A(NSTATE,NSTATE),SCR(LSCR)
C     Variables
      INTEGER ISUB,N2,NTR,K,I,J
C     ==--------------------------------------------------------------==
C     == GLOBAL SUMMATION OF A SYMMETRIC MATRIX                       ==
C     ==--------------------------------------------------------------==
      IF(NPROC.LE.1) RETURN
      CALL TISET('    SUMMAT',ISUB)
      N2 = NSTATE*NSTATE
      NTR = (NSTATE*(NSTATE+1))/2
      CALL TEST_SCR('SUMMAT','(NSTATE*(NSTATE+1))/2',LSCR,NTR)
C$OMP parallel do private(I,J,K) schedule(static,1)
#ifdef __SR8000
*poption parallel, tlocal(I,J,K), cyclic 
#endif 
      DO I=1,NSTATE
        DO J=I,NSTATE
          K=I+(J*(J-1))/2
          SCR(K)=A(I,J)
        ENDDO
      ENDDO
      CALL MY_COMBINE_SOURCE(SCR,A,8*NTR,1,SOURCE,ALLGRP)
      IF(PARENT) THEN
        CALL DCOPY(NTR,A(1,1),1,SCR(1),1)
C$OMP parallel do private(I,J,K) schedule(static,1)
#ifdef __SR8000
*poption parallel, cyclic 
#endif 
        DO I=1,NSTATE
          DO J=I,NSTATE
            K=I+(J*(J-1))/2
            A(I,J)=SCR(K)
            A(J,I)=SCR(K)
          ENDDO
        ENDDO
      ENDIF
      CALL TIHALT('    SUMMAT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SUMHMAT(A,NSTATE,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER    NSTATE,LSCR
      COMPLEX*16 A(NSTATE,NSTATE),SCR(LSCR/2)
C     Variables
      INTEGER    ISUB,N2,NTR,NTR2,I,J,K
C     ==--------------------------------------------------------------==
C     == GLOBAL SUMMATION OF A HERMITIAN MATRIX                       ==
C     ==--------------------------------------------------------------==
      IF(NPROC.LE.1) RETURN
      CALL TISET('   SUMHMAT',ISUB)
      N2 = NSTATE*NSTATE
      NTR = (NSTATE*(NSTATE+1))/2
      NTR2 = NTR*2
      CALL TEST_SCR('SUMHMAT','NSTATE*(NSTATE+1)',LSCR,NTR2)
      K=0
      DO I=1,NSTATE
        DO J=I,NSTATE
          K=K+1
          SCR(K)=A(I,J)
        ENDDO
      ENDDO
      CALL MY_COMBINE(SCR,A,8*NTR2,1,ALLGRP)
      CALL DCOPY(NTR2,A(1,1),1,SCR(1),1)
      K=0
      DO I=1,NSTATE
        DO J=I,NSTATE
          K=K+1
          A(I,J)=SCR(K)
          IF(I.NE.J) A(J,I)=DCMPLX(DREAL(SCR(K)),-DIMAG(SCR(K)))
        ENDDO
      ENDDO
      CALL TIHALT('   SUMHMAT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_SUMMAT(LSUMMAT,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NPROC
      INCLUDE 'nlps.inc'        !IMAGP
C     Arguments
      INTEGER   LSUMMAT,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      IF(NPROC.LE.1) THEN
        LSUMMAT=0
      ELSE
        LSUMMAT=IMAGP*(NSTATE*(NSTATE+1))/2
        TAG   ='IMAGP*(NSTATE*(NSTATE+1))/2'
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
