C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == VARIABLES FOR SWAP FILES                                     ==
C     == USE FOR K POINTS (BLOCK OPTION)                              ==
C     ==================================================================
C     == ISWMAX:  MAXIMAL NUMBER OF DIFFERENT VARIABLES               ==
C     == ISWFILE: MAXIMAL NUMBER OF SWAP FILES                        ==
C     ==--------------------------------------------------------------==
      INTEGER ISWMAX,ISWFILEMAX
      PARAMETER (ISWMAX=20,ISWFILEMAX=3)
C     ==--------------------------------------------------------------==
C     == IN ORDER TO AVOID RECURSIVE CALL (WITH STOPGM ROUTINE)       ==
C     ==--------------------------------------------------------------==
      INTEGER   I_NOSTOPGM,I_STOPGM
      PARAMETER (I_NOSTOPGM=0,I_STOPGM=1)
C     ==--------------------------------------------------------------==
C     == ISWFIRST: 0 IF NOT INITIALIZED                               ==
C     == SMYPID:   STRING USED FOR THE NAME OF SWAP FILES             ==
C     == NSWBLOCK: NUMBER OF BLOCK FOR EACH ARRAY                     ==
C     == SWFILE(ISWFILEMAX):  NAME OF SWAP FILES                      ==
C     == IUNITSW(ISWFILEMAX): UNIT NUMBER                             ==
C     == ACCESSW(ISWFILEMAX): TYPE OF ACCESS                          ==
C     ==    S=SEQUENTIAL, REWRITE FORBIDDEN                           ==
C     ==    D=DIRECT    , REWRITE PERMITTED, BUT DATA SIZE IS FIXED   ==
C     == ISIDISW(ISWFILEMAX): SIZE OF RECORDS FOR DIRECT ACCESS       ==
C     == ISWRES(ISWFILEMAX):  RESET NUMBER                            ==
C     ==--------------------------------------------------------------==
      CHARACTER    SMYPID*6,SWFILE(ISWFILEMAX)*255,ACCESSW(ISWFILEMAX)*1
      INTEGER      ISWFIRST,NSWBLOCK,IUNITSW,ISIDISW,ISWRES
      POINTER      (IP_IUNITSW,IUNITSW),(IP_ISIDISW,ISIDISW),
     &             (IP_ISWRES,ISWRES)
      COMMON/SWFIL/ISWFIRST,NSWBLOCK,IP_IUNITSW,IP_ISIDISW,IP_ISWRES,
     &             SWFILE,ACCESSW,SMYPID
C     ==--------------------------------------------------------------==
C     == SWNAME(ISWMAX,ISWFILEMAX):                                   ==
C     ==    THE POSITION OF NAME OF A VARIABLE GIVES INDEX            ==
C     ==    IN ANOTHER ARRAYS                                         ==
C     == ISWMEM(ISWMAX,ISWFILEMAX):                                   ==
C     ==    GIVES FOR EACH VARIABLE THE INDEX IKPT WHICH IS IN MEMORY ==
C     == ISWPOS(NBLKP,ISWMAX,ISWFILEMAX):                             ==
C     ==    FOR AN INDEX GIVES THE RECORD NUMBER FOR EACH BLOCK       ==
C     ==          OF NKPNT K-POINTS                                   ==
C     == ISWSIZE(NBLKP*ISWMAX,ISWFILEMAX):                            ==
C     ==    SIZE OF THE ITH RECORD                                    ==
C     == ISWACCE(2,NBLKP*ISWMAX,ISWFILEMAX):                          ==
C     ==    NUMBER OF WRITE(1) AND READ(2) ACCESS FOR ITH RECORD      ==
C     == ISWCUR(ISWFILEMAX): CURRENT RECORD                           ==
C     == ISWEND(ISWFILEMAX): TOTAL NUMBER OF VARIABLES                ==
C     == ISWREC(ISWFILEMAX): TOTAL NUMBER OF RECORDS                  ==
C     ==--------------------------------------------------------------==
      CHARACTER*8 SWNAME(ISWMAX,ISWFILEMAX)
      INTEGER     ISWMEM,ISWPOS,ISWSIZE,ISWACCE,ISWCUR,ISWEND,ISWREC
      POINTER     (IP_ISWMEM,ISWMEM),(IP_ISWPOS,ISWPOS),
     &            (IP_ISWSIZE,ISWSIZE),(IP_ISWACCE,ISWACCE),
     &            (IP_ISWCUR,ISWCUR),(IP_ISWEND,ISWEND),
     &            (IP_ISWREC,ISWREC)
      COMMON/SWARR/IP_ISWMEM,IP_ISWPOS,IP_ISWSIZE,IP_ISWACCE,
     &             IP_ISWCUR,IP_ISWEND,IP_ISWREC,SWNAME
C     ==================================================================
C     == PARAMETER USED WITH TKBCALC AND TKBONE OPTION                ==
C     ==--------------------------------------------------------------==
C     == ISW_CALC Index IFILE for ISWACCE (store the number of        ==
C     ==          calculations for each array)                        ==
C     ==--------------------------------------------------------------==
      INTEGER   ISW_CALC
      PARAMETER (ISW_CALC=2)
      INTEGER   ISW_HGKP,ISW_HGKM,ISW_MASKGW,ISW_TWNL,ISW_EMK2,
     &          ISW_EIGKR,ISW_ALM
      PARAMETER (ISW_HGKP   = 1,
     &           ISW_HGKM   = 2,
     &           ISW_MASKGW = 3,
     &           ISW_TWNL   = 4,
     &           ISW_EMK2   = 5,
     &           ISW_EIGKR  = 6,
     &           ISW_ALM    = 7)
C     ==--------------------------------------------------------------==
C     == TSWCALC No swap but calculation for arrays (=TKBCALC)        ==
C     == TSWAPC0 Swap C0 wavefunctions (=.NOT.TKBLONE)                == 
C     ==--------------------------------------------------------------==
      LOGICAL         TSWCALC,TSWAPC0
      COMMON  /SWLOG/ TSWCALC,TSWAPC0
C     ==================================================================

