C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == INFORMATION ABOUT SYMMETRY OF THE SYSTEM                     ==
C     ==================================================================
C     == TSYMM   SYMMETRIZED COORDINATES                              ==
C     == TGENC   GENERATE ATOMIC COORDINATES FROM SYMM. UNIQUE ONES   ==
C     == TMSYM   POINT GROUP MOLECULE                                 ==
C     == TPGAUTO POINT GROUP AUTO                                     ==
C     == TORIGIN =.TRUE. IF SYMMORPHIC AND ORIGIN=(0,0,0)(SYM. CENTER)==
C     == TSYMMORPHIC =.TRUE. IF SYMMORPHIC GROUP (TPGAUTO=.TRUE.)     ==
C     ==                     OTHERWISE IF ALL FTAU=0.D0               ==
C     == TSYMMOR(1:NROT)=.TRUE. IF FTAU(IR)=0.D0                      ==
C     == [Broadcasted in SETSYS routine]                              ==
C     ==--------------------------------------------------------------==
      LOGICAL       TSYMM,TGENC,TMSYM,TPGAUTO,
     &              TORIGIN,TSYMMORPHIC,TSYMMOR(120)
      COMMON/SYMMT/ TSYMM,TGENC,TMSYM,TPGAUTO,
     &              TORIGIN,TSYMMORPHIC,TSYMMOR
C     ==--------------------------------------------------------------==
C     == INDPG   POINT GROUP NUMBER                                   ==
C     == IHG     POINT GROUP OF THE PRIMITIVE LATTICE, HOLOHEDRAL     ==
C     ==         GROUP NUMBER:                                        ==
C     ==          IHG=1 STANDS FOR TRICLINIC    SYSTEM                ==
C     ==          IHG=2 STANDS FOR MONOCLINIC   SYSTEM                ==
C     ==          IHG=3 STANDS FOR ORTHORHOMBIC SYSTEM                ==
C     ==          IHG=4 STANDS FOR TETRAGONAL   SYSTEM                ==
C     ==          IHG=5 STANDS FOR CUBIC        SYSTEM                ==
C     ==          IHG=6 STANDS FOR TRIGONAL     SYSTEM                ==
C     ==          IHG=7 STANDS FOR HEXAGONAL    SYSTEM                ==
C     == NROT    NUMBER OF ROTATIONS                                  ==
C     == INVERSION INDEX OF THE INVERSION ROTATION OTHERWISE 0        ==
C     == NTVEC   NUMBER OF TRANSLATION VECTORS ASSOCIATED WITH 1      ==
C     == IRTVEC(NAT,NTVEC) ATOM TRANSFORMATION TABLE FOR TRANSLATION  ==
C     ==         VECTORS                                              ==
C     == INVE(120) NUMBER OF INVERSE ROTATIONS (GIVEN BY MULTTB)      ==
C     ==           (USED BY SYMRHO)                                   ==
C     == MULTAB(120,120) MULTIPLICATION TABLE                         ==
C     == IRT(120,NAT) ATOM TRANSFORMATION TABLE                       ==
C     ==         FOR SOLID THE 49TH ROW GIVES INEQUIVALENT ATOMS FOR  ==
C     ==         TRANSLATIONS (IF NTVEC /= 1)                         ==
C     == ISYMU(NAT)   NUMBER OF EQUIVALENT ATOMS                      ==
C     == [Broadcasted in SETSYS routine]                              ==
C     ==--------------------------------------------------------------==
      INTEGER       INDPG,IHG,NROT,NAXIS,IUNIQUE,INVERSION,NTVEC,
     &              INVE(120),MULTAB(120,120),
     &              IRT(120,*),ISYMU(*),IRTVEC
      POINTER       (IP_IRT,IRT),(IP_ISYMU,ISYMU),(IP_IRTVEC,IRTVEC)
      COMMON/SYMMI/ INDPG,IHG,NROT,NAXIS,IUNIQUE,INVERSION,NTVEC,
     *              INVE,MULTAB
      COMMON/SYMMI_IP/IP_IRT,IP_ISYMU,IP_IRTVEC
C     ==--------------------------------------------------------------==
C     == IUN(MAXSP) USED WITH GENERATE COORDINATES OPTION             ==
C     == STABLE(3,3,48) ROTATION MATRICES (INTEGER)                   ==
C     == [UnBroadcasted]                                              ==
C     ==--------------------------------------------------------------==
      INTEGER       IUN(MAXSP),STABLE(3,3,48)
      COMMON/SYMMN/ IUN,STABLE
C     ==--------------------------------------------------------------==
C     == DELTASYM        REQUIRED ACCURACY (1.D-6 IS A GOOD VALUE)    ==
C     ==                 IN DIRECT VECTOR LATTICE BASIS SET           ==
C     ==                 (SO IN CARTESIAN = ALAT*DELTASYM)            ==
C     == ORIGIN(3)       IF SYMMORPHIC CENTER OF SYMMETRY             ==
C     ==                 OTHERWISE (0,0,0)                            ==
C     == XTABLE(3,3,120) ROTATION MATRICES IN REAL SPACE              ==
C     ==                 IN CRYSTAL COORDINATES                       ==
C     == FTABLE(3,3,120) ROTATION MATRICES IN FOURIER SPACE           ==
C     == FTAU(3,120)     TRANSLATIONS ASSOCIATED WITH XTABLE          ==
C     == [Broadcasted in SETSYS routine]                              ==
C     ==--------------------------------------------------------------==
      REAL*8        XTABLE(3,3,120),FTABLE(3,3,120),FTAU(3,120),
     &              ORIGIN(3),DELTASYM
      COMMON/SYMMR/ XTABLE,FTABLE,FTAU,ORIGIN,DELTASYM
C     ==--------------------------------------------------------------==
C     == TVEC(3,NTVEC)   TRANSLATION VECTORS ASSOCIATED WITH 1        ==
C     == [Broadcasted in SETSYS routine]                              ==
C     ==--------------------------------------------------------------==
      REAL*8        TVEC(3,*)
      POINTER       (IP_TVEC,TVEC)
      COMMON/SYMMP/ IP_TVEC
C     ==--------------------------------------------------------------==
C     == STAG   LABEL OF THE POINT GROUP                              ==
C     == [UnBroadcasted]                                              ==
C     ==--------------------------------------------------------------==
      CHARACTER     STAG*3
      COMMON/SYMMC/ STAG
C     ==================================================================
C     == Use in serial/parallel version (SYMRHO)                      ==
C     == NUMSHEL   Number of shells of equivalent G-vectors           ==
C     ==           equivalent means symmetry links all G-vectors      ==
C     == IGEXTINC  Number of G-vectors where RHO(IG)=0 (extinction)   ==
C     == INDSHEL(NHG) For each G-vector index of the equivalent       ==
C     ==          shell, i.e. 2 G-vectors related by symmetry have    ==
C     ==          the same index.                                     ==
C     ==          If NTVEC/=1 (translation vectors /=0 exist)         ==
C     ==          0 if RHO(G) has to be nullify                       ==
C     == ISYSHEL(2,NHG)                                               ==
C     ==          If TSYMMORPHIC                                      ==
C     ==          give for IG  if ISYSHEL>0                           ==
C     ==          or   for -IG if ISYSHEL<0 the multiplicative factor ==
C     == NINSHEL(NHG) !!!WARNING INTEGER*8                            ==
C     ==          If TSYMMORPHIC unused                               ==
C     ==          If .NOT.TSYMMORPHIC                                 ==
C     ==          For equivalent shell,                               ==
C     ==          give for each G-vector, the related rotations.      ==
C     ==          For the rotations IR, the IRth bit sets to 1        ==
C     == ISISHEL(NHG) !!!WARNING INTEGER*8                            ==
C     ==          If TSYMMORPHIC unused                               ==
C     ==          If .NOT.TSYMMORPHIC                                 ==
C     ==          For equivalent shell, give for each G-vector        ==
C     ==          if IG or -IG has to take. The IRth bit sets to 1    ==
C     ==          the component IG is taken for the IRth rotation     ==
C     ==--------------------------------------------------------------==
C     == WARNING: you need to use INTEGER*8 in order ot have 64 bits  ==
C     ==--------------------------------------------------------------==
      INTEGER        NUMSHEL,IGEXTINC,
     &               INDSHEL(NHG),ISYSHEL(2,NHG)
      POINTER        (IP_INDSHEL,INDSHEL),(IP_ISYSHEL,ISYSHEL)
      COMMON/SYMMPA/ NUMSHEL,IGEXTINC
      COMMON/SYMMPA_IP/IP_ISYSHEL,IP_INDSHEL
C     ==================================================================
C     == SCALE OPTION (use in sysin and setsys -- no broadcast)       ==
C     == SXSCALE Scale factor for x-axis                              ==
C     == SYSCALE Scale factor for y-axis                              ==
C     == SZSCALE Scale factor for z-axis                              ==
C     == TCARTESIAN Coordinates are given in cartesian coordinates    ==
C     ==            (used only with SCALE option)                     ==
C     ==--------------------------------------------------------------==
      REAL*8        SXSCALE,SYSCALE,SZSCALE
      LOGICAL       TCARTESIAN
      COMMON/TAUPS/ SXSCALE,SYSCALE,SZSCALE,TCARTESIAN
C     ==================================================================
