#ifdef __SR8000
*option MP(P(0)), LANGLVL(SAVE(0))
#endif
C     ==================================================================
      SUBROUTINE SYSIN
C     ==--------------------------------------------------------------==
C     ==  THIS ROUTINE READS THE SECTION &SYSTEM FROM IUNIT           ==
C     ==--------------------------------------------------------------==
C     ==  DESCRIPTION OF INPUT                                        ==
C     ==                                                              ==
C     ==  &SYSTEM                                                     ==
C     ==     OPTIONS                                                  ==
C     ==  &END                                                        ==
C     ==                                                              ==
C     ==  LIST OF OPTIONS                                             ==
C     ==    SYMMETRY                                                  ==
C     ==      [ibrav] [name]                                          ==
C     ==    CHECK SYMMETRY [OFF]                                      ==
C     ==      [boxeps]                                                ==
C     ==    POINT GROUP [MOLECULE] [DELTA=deltasym]                   ==
C     ==      [indpg] [NAME=name] [AUTO]                              ==
C     ==    CELL [ABSOLUTE] [DEGREE] [VECTORS]                        ==
C     ==      celldm(1 .. 6)                                          ==
C     ==    REFERENCE CELL [ABSOLUTE] [DEGREE]                        ==
C     ==      cellrf(1 .. 6)                                          ==
C     ==    CLASSICAL CELL [ABSOLUTE] [DEGREE]                        ==
C     ==      cellcl(1 .. 6)                                          ==
C     ==    ISOTROPIC CELL                                            ==
C     ==    ZFLEXIBLE CELL                                            ==
C     ==    POISSON [HOCKNEY,TUCKERMAN,MORTENSEN,PARAMETER]           ==
C     ==       coulomb smoothing (Hockney)                            ==
C     ==       alpha*L (Tuckerman)                                    ==
C     ==    BOX WALLS                                                 ==
C     ==      wall_skin                                               ==
C     ==    LOW SPIN EXCITATION [ROKS,ROSS,ROOTHAAN,CAS22,PENALTY]    ==
C     ==      apenal                                                  ==
C     ==    LOW SPIN EXCITATION LSETS                                 ==
C     ==    LSE PARAMETERS                                            ==
C     ==      lsea lseb       (see control_def for default values)    ==
C     ==    MODIFIED GOEDECKER [PARAMETERS]                           ==
C     ==      mgmab mgmba                                             ==
C     ==    ENERGY PROFILE                                            ==
C     ==    EXTERNAL FIELD                                            ==
C     ==      ex ey ez                                                ==
C     ==    COUPLINGS [FD,FD=eps_c,PROD=eps_c]                        ==
C     ==    COUPLINGS NAT=nat                                         ==
C     ==       iatfd(1),...                                           ==
C     ==    COUPLINGS NSURF=nsurf                                     ==
C     ==       kssta(1,1)   kssta(2,1)   coeff(1)                     ==
C     ==       kssta(1,...) kssta(2,...) coeff(...)                   ==
C     ==    COUPLINGS LINRES [TOL=<tol>] [NVECT=<nvect> [SPECIFY]]    ==
C     ==    COUPLINGS LINRES THRESHOLDS                               ==
C     ==      fc_thr_low  f_low                                       ==
C     ==      fc_thr_med  f_med                                       ==
C     ==      fc_thr_high f_high                                      ==
C     ==    CHARGE                                                    ==
C     ==      charge                                                  ==
C     ==    MULTIPLICITY                                              ==
C     ==      nspin (2S+1)                                            ==
C     ==    NSUP                                                      ==
C     ==      nsup                                                    ==
C     ==    STATES                                                    ==
C     ==      n                                                       ==
C     ==    OCCUPATION [FIXED]                                        ==
C     ==      f(i),i=1,n                                              ==
C     ==    [SPHERICAL,NOSPHERICAL] CUTOFF                            ==
C     ==      ecut                                                    ==
C     ==    DENSITY CUTOFF                                            ==
C     ==      ecutd                                                   ==
C     ==    DUAL                                                      ==
C     ==      cdual                                                   ==
C     ==    CONSTANT CUTOFF                                           ==
C     ==      akin skin eckin                                         ==
C     ==    DENSITY CUTOFF NUMBER                                     ==
C     ==      nhgwish                                                 ==
C     ==    KPOINT [SCALED] [BLOCK=nkpnt] [ALL] [CALCULATED] [NOSWAP] ==
C     ==           [TONLYDIAG]                                        ==
C     ==      nkpts                                                   ==
C     ==      rk(1 .. 3) wk (1)                                       ==
C     ==      rk(1 .. 3) wk (nkpnt)                                   ==
C     ==    KPOINT MONKHORST-PACK [SYMMETRIZE] [FULL] [KDP] ...       ==
C     ==                          [BLOCK=nkpnt] [ALL]                 ==
C     ==      nk1 nk2 nk3 [SHIFT=wvk0(1) wvk0(2) wvk0(3)]             ==
C     ==    KPOINT BANDS [SCALED]                                     ==
C     ==      nkpbd rk(1..3) rk(1..3)                                 ==
C     ==      .                                                       ==
C     ==      .                                                       ==
C     ==      0     0  0  0  0  0  0                                  ==
C     ==    MESH                                                      ==
C     ==      nr1 nr2 nr3                                             ==
C     ==    SCALE CARTESIAN [S=sascale]                               ==
C     ==                    [SX=sxscale] [SY=syscale] [SZ=szscale]    ==
C     ==    DOUBLE GRID [ON,OFF]                                      ==
C     ==    SYMMETRIZE COORDINATES                                    ==
C     ==    ANGSTROM                                                  ==
C     ==    TESR                                                      ==
C     ==     iesr                                                     ==
C     ==    SURFACE [XY, YZ, ZX]                                      ==
C     ==    POLYMER                                                   ==
C     ==    CLUSTER                                                   ==
C     ==    PRESSURE                                                  ==
C     ==     druck                                                    ==
C     ==    SHOCK VELOCITY                                            ==
C     ==     vshock                                                   ==
C     ==    STRESS TENSOR                                             ==
C     ==     t11 t12 t13                                              ==
C     ==     t21 t22 t23                                              ==
C     ==     t31 t32 t33                                              ==
C     ==    HFX CUTOFF                                                ==
C     ==     hfxwfe hfxdee                                            ==
C     ==    DONOR                                                     ==
C     ==     NDONOR n1 n2 n3 n4                                       ==
C     ==    ACCEPTOR                                                  ==
C     ==     NACCEPTOR n1 n2 n3 n4                                    ==
C     ==    WGAUSS [NSP or 1]                                         ==
C     ==      sigma1                                                  ==
C     ==      ...                                                     ==
C     ==      sigmaN                                                  ==
C     ==                                                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'cell.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'symm.inc'        !SXSCALE,SYSCALE,SZSCALE,TSYMM
      INCLUDE 'cnst.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'sphe.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'store.inc'
      INCLUDE 'elct2.inc'
      INCLUDE 'kdpc.inc' 
      INCLUDE 'clas.inc'
      INCLUDE 'fcas.inc'
      INCLUDE 'cplngs.inc'
      INCLUDE 'ddip.inc'   ! AIFIELD, LENBK
      INCLUDE 'hfx.inc'
      INCLUDE 'shock.inc'
      INCLUDE 'dg.inc'
      INCLUDE 'cdft.inc'
      INTEGER   IUNK,MAXUNKNOWN
      PARAMETER (MAXUNKNOWN=30)
      CHARACTER*80 LINE,LINEOLD,UNKNOWN(MAXUNKNOWN)
      CHARACTER*500 LINELONG
      LOGICAL   ERREAD
      DIMENSION F(*),RK(3,*),WK(*)
      REAL*8    RKI(3),RKF(3),RKT(3,*)
      POINTER   (IP_RKT,RKT)
      INTEGER   IUNIT,IERR,INSCAN,IOUT,IA,IE,IEQUAL,IN1,IN2,I,
     &          IP1,IP2,I1,I2,NKPBD,IK
      REAL*8    XA,BOXEPS,ECUTD
      LOGICAL   TPRESSURE,TSTRTENSOR
#ifdef PARALLEL
      INTEGER   MSGLEN
#endif
C     ==--------------------------------------------------------------==
      CHARACTER  PGRP(32)*5
      DATA PGRP /'    1','  <1>','    2','    m',
     *           '  2/m','    3','  <3>','   32',
     *           '   3m',' <3>m','    4','  <4>',
     *           '  4/m','  422','  4mm','<4>2m',
     *           '4/mmm','    6','  <6>','  6/m',
     *           '  622','  6mm','<6>m2','6/mmm',
     *           '  222','  mm2','  mmm','   23',
     *           '   m3','  432','<4>3m','  m3m'/
      CHARACTER  PGRD(32)*3
      DATA PGRD /'c1 ','ci ','c2 ','c1h',
     *           'c2h','c3 ','c3i','d3 ',
     *           'c3v','d3 ','c4 ','s4 ',
     *           'c4h','d4 ','c4v','d2d',
     *           'd4h','c6 ','c3h','c6h',
     *           'd6 ','c6v','d3h','d6h',
     *           'd2 ','c2v','d2h','t  ',
     *           'th ','o  ','td ','oh '/
C     ==--------------------------------------------------------------==
C     Set the flag for the CAS22 fion memory pointers
      INIT_FLAG = 0   
C     ==--------------------------------------------------------------==
C     Don't rely on the compiler to initialize LENBK properly.
      LENBK = 0   
C     ==--------------------------------------------------------------==
      CALL CPLNGS_INIT          ! Block data
      IF(.NOT.PARENT) GOTO 9999
      IUNIT = 5
      IERR=INSCAN(IUNIT,'&SYSTEM')
      IF(IERR.NE.0) THEN
        WRITE(6,*) ' SYSIN: INPUT SECTION &SYSTEM NOT FOUND'
        CALL STOPGM('SYSIN',' ')
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  DEFAULTS AND INITIALIZATION                                 ==
C     ==--------------------------------------------------------------==
      DUAL=.FALSE.
      BOHR=.TRUE.
      TSCALE=.FALSE.
      TCLUST=.FALSE.
      TONED=.FALSE.
      TTWOD=.FALSE.
      TSYMM=.FALSE.
      TMSYM=.FALSE.
      TPGAUTO=.FALSE.
      TKPNT=.FALSE.
      TKSCALE=.FALSE.
      TMONKP=.FALSE.
      TSYMKP=.FALSE.
      TKFULL=.FALSE.
      TKALL=.FALSE.
      TONLYDIAG =.FALSE.
      TFIELD=.FALSE.
      TDG=.FALSE.
C     TKNOSWAP is initialized in control.F (KOHN-SHAM EIGENVALUES)
      TKBLOCK=TKNOSWAP
      TKBCALC=TKNOSWAP
      TNHGWISH=.FALSE.
      TKDP=.FALSE. 
      NHGWISH=0
      NKPNT=1
      NKPTS=1
      NBLKP=1
      TSPHERE=.TRUE.
      TFIXO=.FALSE.
      CALL AZZERO(WVK0,3)
      IBRAV=-1
      CALL AZZERO(CELLDM,6)
      CALL AZZERO(CELLRF,6)
      CALL AZZERO(CELLCL,6)
      CALL AZZERO(STENS,9)
      NR1=0
      NR2=0
      NR3=0
      N=0
      NSPIN=0
      NSUP=0
      CHARGE=0.0D0
      CDUAL=4.0D0
      INDPG=0
      DRUCK=0.0D0
      AKIN=0.0D0
      SKIN=0.0D0
      GCKIN=0.0D0
      ECKIN=0.0D0
      TISOT=.FALSE.
      TZFLEX=.FALSE.
      TESR=.FALSE.
      IESR=0
      CALL AZZERO(FTAU,360)
      NROT=0
      NAXIS=0
      TLSETS=.FALSE.
      TROSS=.FALSE.
      TROOT=.FALSE.
      TCAS22=.FALSE.
      TCPL=.FALSE.              ! see CPLNGS_INIT
      PS_TYPE=0
      SNORMAL=3
      RCERF=0.D0
      ALPHAL=7.D0
      ECUTD=-1.D0
      DELTASYM=1.D-6
      TPRESSURE=.FALSE.
      TSTRTENSOR=.FALSE.
      TCELLVECTORS=.FALSE.
      TCELLREFVEC = .FALSE.
      TEPROF=.FALSE.
      TPENAL=.FALSE.
      APENAL=1.D0
      DO I=1,3
        AR1(I) = 0.0D0
        AR2(I) = 0.0D0
        AR3(I) = 0.0D0
      ENDDO 
      BOXEPS = 1.0D-4
      IPOOLHFX = 0
      HFXWFE = 0.0D0
      HFXDEE = 0.0D0
      IUNK = 0
CSMG  MODIFIED GOEDECKER PARAMETERS
      TMGOE = .FALSE.
      MGMAB = -0.5D0
      MGMBA =  0.5D0
C SHOCK
      VSHOCK = 0.D0
      PSHOCK = 0.D0
      VOL0 = 0.D0
      ESHOCK = 0.D0
C CDFT
!       NDON=0
!       NACCR=0
      TWGAUSS=.FALSE.
      WCUT=-1.0D0
      THDAS=.FALSE.
      TWALL=.FALSE.    ! reflecting walls
      WALL_SKIN=7.0D0
C     ==--------------------------------------------------------------==
      WRITE(LINE,'(80(" "))')
   10 CONTINUE
        LINEOLD=LINE
        READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
        IF(INDEX(LINE,'&END').NE.0) GOTO 20
C     ==--------------------------------------------------------------==
C       CDFT
        IF(INDEX(LINE,'DONOR').NE.0) THEN
          CALL READSI(LINE,INDEX(LINE,'DONOR')+6,IOUT,NDON,ERREAD)
          IF(NDON.GT.CDFT_MAT)THEN
            WRITE(6,*) 'ERROR: TOO MANY ATOMS IN CDFT DONOR GROUP',
     *       NDON, CDFT_MAT
            GOTO 99
          ENDIF
          IF(NDON.GT.0)THEN
            LINEOLD=LINE
            READ(IUNIT,ERR=99,END=99,FMT='(A500)') LINELONG
            IA=1
          ENDIF
          DO I=1,NDON
            CALL READSI(LINELONG,IA,IE,CDFT_D(I),ERREAD)
            IF(ERREAD) GOTO 99
            IA=IE
          ENDDO
          GOTO 10
        ELSE IF(INDEX(LINE,'ACCEPTOR').NE.0) THEN
          CALL READSI(LINE,INDEX(LINE,'ACCEPTOR')+9,IOUT,NACCR,ERREAD)
          IF(NACCR.GT.CDFT_MAT)THEN
            WRITE(6,*) 'ERROR: TOO MANY ATOMS IN CDFT ACCEPTOR GROUP',
     *       NACCR, CDFT_MAT
            GOTO 99
          ENDIF
          IF(INDEX(LINE,'HDAS').NE.0) THDAS=.TRUE.
          LINEOLD=LINE
          READ(IUNIT,ERR=99,END=99,FMT='(A500)') LINELONG
          IA=1
          DO I=1,NACCR
            CALL READSI(LINELONG,IA,IE,CDFT_A(I),ERREAD)
            IF(ERREAD) GOTO 99
            IA=IE
          ENDDO
          IF(THDAS)THEN
            LINEOLD=LINE
            READ(IUNIT,ERR=99,END=99,FMT='(A500)') LINELONG
            IA=1
            DO I=1,NACCR
              CALL READSI(LINELONG,IA,IE,CDFT_D(I),ERREAD)
              IF(ERREAD) GOTO 99
              IA=IE
            ENDDO
          ENDIF
          GOTO 10
        ELSE IF(INDEX(LINE,'WGAUSS').NE.0) THEN
          TWGAUSS=.TRUE.
          CALL READSI(LINE,INDEX(LINE,'WGAUSS')+7,IOUT,WG_N,ERREAD)
          IF(ERREAD) GOTO 99
          DO I=1,WG_N
            LINEOLD=LINE
            READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
            CALL READSR(LINE,1,IE,WG_SIGMA(I),ERREAD)
            IF(ERREAD) GOTO 99
          ENDDO
          GOTO 10
        ELSE IF(INDEX(LINE,'WCUT').NE.0) THEN
          CALL READSR(LINE,INDEX(LINE,'WCUT')+5,IOUT,WCUT,ERREAD)
          IF(ERREAD) GOTO 99
          GOTO 10
        ENDIF
        IF((INDEX(LINE,'CHECK').NE.0).AND.
     $      (INDEX(LINE,'SYMMETRY').NE.0)) THEN
          IF(INDEX(LINE,'OFF').NE.0) THEN
            BOXEPS=-1.0d0
            GOTO 10
          ENDIF
          LINEOLD=LINE
          READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
          CALL READSR(LINE,1,IOUT,BOXEPS,ERREAD)
            IF(ERREAD) THEN
              WRITE(6,*) 'CHECK SYMMETRY'
              WRITE(6,*) 'ERROR READING SYMMETRY PRECISION'
              GOTO 99
            ENDIF
           GOTO 10
        ELSE IF(INDEX(LINE,'SYMMETRY').NE.0) THEN
C         UNIT CELL SYMMETRY
          LINEOLD=LINE
          READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
          IF(INDEX(LINE,'ISOL').NE.0) THEN
            IBRAV=0
          ELSEIF(INDEX(LINE,'CUBI').NE.0) THEN
            IF(INDEX(LINE,'FACE').NE.0) THEN
              IBRAV=2
            ELSE IF(INDEX(LINE,'BODY').NE.0) THEN
              IBRAV=3
            ELSE
              IBRAV=1
            ENDIF
          ELSEIF(INDEX(LINE,'FCC').NE.0) THEN
            IBRAV=2
          ELSEIF(INDEX(LINE,'BCC').NE.0) THEN
            IBRAV=3
          ELSEIF(INDEX(LINE,'HEXA').NE.0) THEN
            IBRAV=4
          ELSEIF(INDEX(LINE,'TRIG').NE.0.OR.
     &           INDEX(LINE,'RHOMBO').NE.0) THEN
            IBRAV=5
          ELSEIF(INDEX(LINE,'TETRA').NE.0) THEN
            IF(INDEX(LINE,'BODY').NE.0) THEN
              IBRAV=7
            ELSE
              IBRAV=6
            ENDIF
          ELSEIF(INDEX(LINE,'BCT').NE.0) THEN
            IBRAV=7
          ELSEIF(INDEX(LINE,'ORTHO').NE.0) THEN
            IBRAV=8
          ELSEIF(INDEX(LINE,'MONO').NE.0) THEN
            IBRAV=12
          ELSEIF(INDEX(LINE,'TRIC').NE.0) THEN
            IBRAV=14
          ELSE
            CALL READSI(LINE,1,IOUT,IBRAV,ERREAD)
            IF(ERREAD) THEN
              WRITE(6,*) 'ERROR READING THE SYMMETRY NUMBER'
              GOTO 99
            ENDIF
            IF ((IBRAV.LT.0).OR.(IBRAV.GT.14)) THEN
              WRITE(6,*) 'ERROR READING THE SYMMETRY NUMBER'
              GOTO 99
            ENDIF
          ENDIF
          GOTO 10
C     ==--------------------------------------------------------------==
        ELSE IF(INDEX(LINE,'POIN').NE.0 .AND.
     *           INDEX(LINE,'GROU').NE.0) THEN
C         POINT GROUP SYMMETRY
          IF(INDEX(LINE,'DELTA=').NE.0) THEN
            IEQUAL=INDEX(LINE,'=')
            CALL READSR(LINE,IEQUAL+1,IOUT,DELTASYM,ERREAD)
            IF(DELTASYM.LE.0.D0) DELTASYM=1.D-6
          ENDIF
          IF(INDEX(LINE,'MOLEC').NE.0) THEN
            TMSYM=.TRUE.
            LINEOLD=LINE
            READ(IUNIT,ERR=99,END=99,FMT='(A)') LINE
            CALL XSTRING(LINE,IA,IE)
            READ(LINE(IA:),ERR=99,END=99,FMT='(A3)') STAG
            CALL READSR(LINE,IE+1,IOUT,XA,ERREAD)
            IF(ERREAD) THEN
              WRITE(6,*) 'POINT GROUP MOLECULE'
              WRITE(6,*) 'ERROR READING THE ORDER OF PRINCIPLE AXIS'
              GOTO 99
            ENDIF
            NAXIS=NINT(XA)
            INDPG=100
          ELSE 
            LINEOLD=LINE
            READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
            IEQUAL=INDEX(LINE,'=')
            IF(IEQUAL.NE.0) THEN
              CALL XSTRING(LINE(IEQUAL+1:80),IN1,IN2)
              IN1=IEQUAL+IN1
              IN2=IEQUAL+IN2
              DO I=32,1,-1
                CALL XSTRING(PGRP(I),IP1,IP2)
                IF(LINE(IN1:IN2).EQ.PGRP(I)(IP1:IP2)) THEN
                  INDPG=I
                  GOTO 10
                ENDIF
              ENDDO
              DO I=32,1,-1
                CALL XSTRING(PGRD(I),IP1,IP2)
                IF(LINE(IN1:IN2).EQ.PGRD(I)(IP1:IP2)) THEN
                  INDPG=I
                  GOTO 10
                ENDIF
              ENDDO
              CALL STOPGM('SYSIN','INVALID POINT GROUP')
            ELSEIF(INDEX(LINE,'AUTO').NE.0) THEN
              TPGAUTO=.TRUE.
            ELSE
              CALL READSI(LINE,1,IOUT,INDPG,ERREAD)
              IF(ERREAD) THEN
                WRITE(6,*) 'ERROR READING THE POINT GROUP NUMBER'
                GOTO 99
              ENDIF
            ENDIF
          ENDIF
          GOTO 10
C     ==--------------------------------------------------------------==
        ELSE IF(INDEX(LINE,'CELL').NE.0) THEN
C         DIMENSION OF THE CELL
          IF(INDEX(LINE,'REFERENCE').NE.0) THEN
            IF(INDEX(LINE,'VECTOR').NE.0) THEN
              READ(IUNIT,ERR=99,END=99,FMT=*) AR1,AR2,AR3
              TCELLREFVEC=.TRUE.
            ELSE
              READ(IUNIT,ERR=99,END=99,FMT=*) (CELLRF(I),I=1,6)
              IF(INDEX(LINE,'ABS').NE.0) THEN
                CELLRF(2)=CELLRF(2)/CELLRF(1)
                CELLRF(3)=CELLRF(3)/CELLRF(1)
              ENDIF
            ENDIF
            IF(INDEX(LINE,'DEGRE').NE.0) THEN
              DO I=4,6
                CELLRF(I)=COS(CELLRF(I)*PI/180.D0)
              ENDDO
            ENDIF
          ELSEIF(INDEX(LINE,'CLASSIC').NE.0) THEN
            READ(IUNIT,ERR=99,END=99,FMT=*) (CELLCL(I),I=1,6)
            IF(INDEX(LINE,'ABS').NE.0) THEN
              CELLCL(2)=CELLCL(2)/CELLCL(1)
              CELLCL(3)=CELLCL(3)/CELLCL(1)
            ENDIF
            IF(INDEX(LINE,'DEGRE').NE.0) THEN
              DO I=4,6
                CELLCL(I)=COS(CELLCL(I)*PI/180.D0)
              ENDDO
            ENDIF
          ELSEIF(INDEX(LINE,'ISOTROP').NE.0) THEN
            TISOT=.TRUE. 
          ELSEIF(INDEX(LINE,'ZFLEXIB').NE.0) THEN
            TZFLEX=.TRUE.
          ELSE
            IF(INDEX(LINE,'VECTOR').NE.0) THEN
              READ(IUNIT,ERR=99,END=99,FMT=*) A1,A2,A3
              TCELLVECTORS=.TRUE.
C              IBRAV=-2
            ELSE
              READ(IUNIT,ERR=99,END=99,FMT=*) (CELLDM(I),I=1,6)
              IF(INDEX(LINE,'ABS').NE.0) THEN
                CELLDM(2)=CELLDM(2)/CELLDM(1)
                CELLDM(3)=CELLDM(3)/CELLDM(1)
              ENDIF
              IF(INDEX(LINE,'DEGRE').NE.0) THEN
                DO I=4,6
                  CELLDM(I)=COS(CELLDM(I)*PI/180.D0)
                ENDDO
              ENDIF
            ENDIF
          ENDIF
          GOTO 10
        ELSE IF(INDEX(LINE,'CHARGE').NE.0) THEN
C         TOTAL CHARGE OF THE SYSTEM       
          READ(IUNIT,ERR=99,END=99,FMT=*) CHARGE
          GOTO 10
        ELSE IF (INDEX(LINE,'LOW').NE.0 .AND.
     *           INDEX(LINE,'SPIN').NE.0 .AND.
     *           INDEX(LINE,'EXC').NE.0) THEN
          IF ( TSHOP ) THEN
cMcB     ... surface hopping stuff ...
             write (6,'(/A/A/)')
     .                ' WARNING: IGNORING LSE SPECIFICATIONS',
     .                '          USING SURFACE HOPPING DEFAULTS INSTEAD'
cMcB     
             TROKS=.TRUE.
             NLSD=4
             NLSX=3
             GOTO 10
          ENDIF
C         LOW SPIN EXCITATION
          IF(INDEX(LINE,'ROOT').NE.0) THEN
            TROOT=.TRUE.
            NLSD=4
            NLSX=3
          ELSEIF(INDEX(LINE,'ROSS').NE.0) THEN
            TROSS=.TRUE.
            NLSD=5
            NLSX=3
          ELSEIF(INDEX(LINE,'CAS22').NE.0) THEN
            TCAS22=.TRUE.
            NLSD=7
            NLSX=3
          ELSE
cMcB_0705  ... default: RESTRICTED OPEN SHELL ...
            TROKS=.TRUE.
            NLSD=4
            NLSX=3
          ENDIF
          IF(INDEX(LINE,'PENAL').NE.0) THEN
            TPENAL=.TRUE.
            READ(IUNIT,ERR=99,END=99,FMT=*) APENAL
            NLSD=MAX(NLSD,5)
            NLSX=3
          ENDIF
          IF(INDEX(LINE,'LSETS').NE.0) THEN
             TLSETS=.TRUE.
          ENDIF
          TLSE=.TRUE.
          GOTO 10
CSMG    MODIFIED GOEDECKER
        ELSE IF (INDEX(LINE,'MODIFIED').NE.0 .AND.
     *           INDEX(LINE,'GOEDECKER').NE.0) THEN
          TMGOE = .TRUE.
          IF (INDEX(LINE,'PARAMETERS').NE.0) THEN
             READ(IUNIT,ERR=99,END=99,FMT=*) MGMAB,MGMBA
          ENDIF
          GOTO 10
        ELSE IF (INDEX(LINE,'LSE').NE.0 .AND.
     *           INDEX(LINE,'PARA').NE.0) THEN
C         PARAMETERS FOR LOW SPIN EXCITATION
          READ(IUNIT,ERR=99,END=99,FMT=*) LSEA,LSEB
          GOTO 10
        ELSE IF (INDEX(LINE,'ENERGY').NE.0 .AND.
     *           INDEX(LINE,'PROFILE').NE.0) THEN
C         REQUESTS ENERGY PROFILE IN LSE CALCULATION
          TEPROF=.TRUE.
          GOTO 10
        ELSE IF (INDEX(LINE,'COUPL').NE.0) THEN
          TCPL=.TRUE.
          I1=INDEX(LINE,'FD')
          IF (I1.NE.0) THEN
            TCPLFD=.TRUE.
            I2=I1+INDEX(LINE(I1:80),'=')
            IF (I2.NE.0) THEN
              CALL READSR(LINE,I2,IE,EPS_C,ERREAD)
              IF (ERREAD) THEN
                WRITE(6,*) 'COUPLINGS: ERROR READING F.D. DISPLACEMENT'
                GOTO 99
              END IF
            END IF
          END IF
          I1=INDEX(LINE,'PROD')
          IF (I1.NE.0) THEN
            TCPLFD=.TRUE.
            I2=I1+INDEX(LINE(I1:80),'=')
            CALL READSR(LINE,I2,IE,EPS_C,ERREAD)
            IF (ERREAD) THEN
               WRITE(6,*) 'COUPLINGS: ERROR READING F.D. DISPLACEMENT'
               GOTO 99
            END IF
            EPS_C = -EPS_C
          END IF
          I1=INDEX(LINE,'LINRES')
          IF (I1.NE.0) THEN
            TCPLFD=.FALSE.
            TCPLLR=.TRUE.
            I1=INDEX(LINE,'TOL')
            IF (I1.NE.0) THEN
              I2=I1+INDEX(LINE(I1:80),'=')
              CALL READSR(LINE,I2,IE,TOLCPL,ERREAD)
              IF (ERREAD) THEN
                WRITE(6,*) 'COUPLINGS: ERROR READING TOLERANCE'
                GOTO 99
              END IF
            END IF
            I1=INDEX(LINE,'NVECT')
            IF (I1.NE.0) THEN
              I2=I1+INDEX(LINE(I1:80),'=')
              CALL READSI(LINE,I2,IE,NVECT,ERREAD)
              IF (ERREAD) THEN
                WRITE(6,*) 'COUPLINGS: ERROR READING NUMBER OF VECTORS'
                GOTO 99
              END IF
              IF (INDEX(LINE,'SPECIFY').NE.0) TSPECV = .TRUE.
            END IF
            I1=INDEX(LINE,'THR')
            IF (I1.NE.0) THEN
              READ(IUNIT,ERR=99,END=99,FMT=*)
     &              FC_LOW, F_LOW
              READ(IUNIT,ERR=99,END=99,FMT=*)
     &              FC_MED, F_MED
              READ(IUNIT,ERR=99,END=99,FMT=*)
     &              FC_HIGH, F_HIGH
            END IF
            IF (INDEX(LINE,'BRUTE').NE.0 .AND.
     *          INDEX(LINE,'FORCE').NE.0) TALLDOF=.TRUE.
          END IF
          I1=INDEX(LINE,'NSURF')
          IF (I1.NE.0) THEN
            I2=I1+INDEX(LINE(I1:80),'=')
            IF (I2.NE.0) THEN
              CALL READSI(LINE,I2,IE,NSURF,ERREAD)
              IF (ERREAD) THEN
                WRITE(6,*) 'COUPLINGS: ERROR READING KS STATES'
                GOTO 99
              END IF
              CALL MEMORY(IP_ISURF,2*NSURF/IRAT,'ISURF')
              CALL MEMORY(IP_CSURF,NSURF,'CSURF')
              DO I = 1,NSURF
                READ(IUNIT,ERR=99,END=99,FMT=*)
     &                ISURF(1,I), ISURF(2,I), CSURF(I)
              END DO
            END IF
          END IF
          I1=INDEX(LINE,'NAT')
          IF (I1.NE.0) THEN
            I2=I1+INDEX(LINE(I1:80),'=')
            IF (I2.NE.0) THEN
              CALL READSI(LINE,I2,IE,NATFD,ERREAD)
              IF (ERREAD) THEN
                WRITE(6,*) 'COUPLINGS: ERROR READING ATOMS FOR FD'
                GOTO 99
              END IF
              TALLAT=.FALSE.
              CALL MEMORY(IP_IATFD,NATFD,'IATFD')
              READ(IUNIT,ERR=99,END=99,FMT=*) (IATFD(I), I=1,NATFD)
            END IF
          END IF
          GOTO 10
        ELSE IF((INDEX(LINE,'EXT').NE.0)
     &         .AND.(INDEX(LINE,'FIELD').NE.0)) THEN
C         APPLIED EXTERNAL ELECTRIC FIELD
          TFIELD=.TRUE.
          READ(IUNIT,ERR=99,END=99,FMT=*) AIFIELD
          GOTO 10
        ELSE IF(INDEX(LINE,'STAT').NE.0) THEN
          IF(TSPEC) THEN
            CALL STOPGM('SYSIN','NO STATES WITH ELECTRONIC SPECTRA')
          ENDIF
C         NUMBER OF STATES TO BE OPTIMIZED
          READ(IUNIT,ERR=99,END=99,FMT=*) N
C         NKSSTA is the number of unoccupied states
C         (parameter of KOHN-SHAM ENERGIES)
          IF(TLSD) THEN
            IN1=N+2*NKSSTA
          ELSE
            IN1=N+NKSSTA
          ENDIF
          CALL MEMORY(IP_F,IN1,'F')
          DO I=1,IN1
            F(I)=-1.D0
          ENDDO
          GOTO 10
        ELSE IF(INDEX(LINE,'OCCU').NE.0) THEN
C         OCCUPATION NUMBERS
          IF(N.EQ.0) CALL STOPGM('SYSIN',
     &    'SPECIFY THE NUMBER OF STATES BEFORE THE OCCUPATION NUMBERS')
          IF(INDEX(LINE,'FIXED').NE.0) TFIXO=.TRUE.
          READ(IUNIT,ERR=99,END=99,FMT=*) (F(I),I=1,N)
          GOTO 10
        ELSE IF(INDEX(LINE,'MULT').NE.0) THEN
C         2*S+1
          READ(IUNIT,ERR=99,END=99,FMT=*) NSPIN
          GOTO 10
        ELSE IF(INDEX(LINE,'NSUP').NE.0) THEN
C         Number of alpha spin states
          READ(IUNIT,ERR=99,END=99,FMT=*) NSUP
          GOTO 10
        ELSE IF(INDEX(LINE,'CUTOFF').NE.0) THEN
C         CUTOFF FOR PW     
          IF(INDEX(LINE,'CONST').NE.0) THEN
            READ(IUNIT,ERR=99,END=99,FMT=*) AKIN,SKIN,ECKIN
C           NUMBER OF PW DENSITY CUTOFF
          ELSEIF(INDEX(LINE,'HFX').NE.0) THEN
            READ(IUNIT,ERR=99,END=99,FMT=*) HFXWFE,HFXDEE
          ELSEIF(INDEX(LINE,'DENSITY').NE.0) THEN
            IF(INDEX(LINE,'NUMBER').NE.0) THEN
              READ(IUNIT,ERR=99,END=99,FMT=*) NHGWISH
              TNHGWISH=.TRUE.
            ELSE
              READ(IUNIT,ERR=99,END=99,FMT=*) ECUTD
            ENDIF
          ELSE
            IF(INDEX(LINE,'NOSPHERIC').NE.0) THEN
              TSPHERE=.FALSE.
            ELSEIF(INDEX(LINE,'SPHERIC').NE.0) THEN
              TSPHERE=.TRUE.
            ENDIF
            READ(IUNIT,ERR=99,END=99,FMT=*) ECUT
          ENDIF
          GOTO 10
        ELSE IF(INDEX(LINE,'POISSON').NE.0) THEN
C         POISSON SOLVER
          IF(INDEX(LINE,'HOCKNEY').NE.0) THEN
            PS_TYPE=1
            IF(INDEX(LINE,'PARAM').NE.0) THEN
              READ(IUNIT,ERR=99,END=99,FMT=*) RCERF
            ENDIF
          ELSEIF(INDEX(LINE,'TUCK').NE.0) THEN
            PS_TYPE=2
            IF(INDEX(LINE,'PARAM').NE.0) THEN
              READ(IUNIT,ERR=99,END=99,FMT=*) ALPHAL
            ENDIF
          ELSEIF(INDEX(LINE,'MORTENSEN').NE.0) THEN
            PS_TYPE=3
          ELSE
            PS_TYPE=1
          ENDIF
          GOTO 10
        ELSE IF((INDEX(LINE,'BOX').NE.0).AND.
     &          (INDEX(LINE,'WALLS').NE.0)) THEN
            READ(IUNIT,ERR=99,END=99,FMT=*) WALL_SKIN
            TWALL=.TRUE.
            GOTO 10
        ELSE IF (INDEX(LINE,'DUAL').NE.0) THEN
C..Density Cutoff in units of wavefunction cutoff
          READ(IUNIT,ERR=99,END=99,FMT=*) CDUAL
          DUAL=.TRUE.
          GOTO 10
        ELSE IF(INDEX(LINE,'PRESSURE').NE.0) THEN
C         PRESSURE          
          READ(IUNIT,ERR=99,END=99,FMT=*) DRUCK
          TPRESSURE=.TRUE.
          GOTO 10
        ELSE IF(INDEX(LINE,'STRESS TENSOR').NE.0) THEN
C         STRESS TENSOR     
          READ(IUNIT,ERR=99,END=99,FMT=*) (STENS(I,1),I=1,9)
          TSTRTENSOR=.TRUE.
          GOTO 10
C     ==--------------------------------------------------------------==
C     == K POINTS                                                     ==
C     ==--------------------------------------------------------------==
        ELSE IF(INDEX(LINE,'KPOINT').NE.0) THEN
          TKPNT=.TRUE.
          IF(INDEX(LINE,'KDP').NE.0) THEN
            TKDP=.TRUE.
            TKPNT=.FALSE. 
            BMIX=1.d0
          ENDIF
          IF(INDEX(LINE,'ONLYDIAG').NE.0) THEN
            TONLYDIAG = .TRUE.
          ENDIF
          I1=INDEX(LINE,'BLOCK')
          IF(I1.NE.0) THEN
            TKBLOCK=.TRUE.
            TKBCALC=.TRUE.
            IF(.NOT.TLANC)
     &        CALL STOPGM('  SYSIN','SWAP FILES ONLY WITH LANCZOS')
            IF(NPROC.GT.1)
     &        CALL STOPGM('  SYSIN','NO SWAP FILES WITH PARALLEL')
            I2=I1+INDEX(LINE(I1:80),'=')
            CALL READSI(LINE(I2:80),1,IOUT,NKPNT,ERREAD)
            IF(ERREAD) THEN
              WRITE(6,*) 'KPOINTS: BLOCK OPTION'
              WRITE(6,*) 'ERROR READING THE NUMBER'
              GOTO 99
            ENDIF
            IF(NKPNT.LE.0)
     &         CALL STOPGM('  SYSIN','WRONG NUMBER OF K POINTS BLOCK')  
            IF(INDEX(LINE,'ALL').NE.0) THEN
              TKALL=.TRUE.
              TKBCALC=.FALSE.
            ELSEIF(INDEX(LINE,'CALC').NE.0) THEN
              TKALL=.FALSE.
              TKBCALC=.TRUE.
            ENDIF
            IF(INDEX(LINE,'NOSWAP').NE.0) THEN
              TKNOSWAP=.TRUE.
            ENDIF
          ENDIF
          IF(INDEX(LINE,'MONKHORST').NE.0) THEN
C           MONKHORST-PACK K-POINTS
            TMONKP=.TRUE.
            IF(INDEX(LINE,'SYMM').NE.0) TSYMKP=.TRUE.
            IF(INDEX(LINE,'FULL').NE.0) TKFULL=.TRUE.
C           Read NK1, NK2, and NK3
            READ(IUNIT,ERR=99,END=99,FMT='(A)') LINE
            IA=1
            CALL READSI(LINE,IA,IE,NK1,ERREAD)
            IF(ERREAD) THEN
              WRITE(6,*) 'KPOINTS: MONKHORST-PACK OPTION'
              WRITE(6,*) 'ERROR READING NK1'
              GOTO 99
            ENDIF
            IA=IE
            CALL READSI(LINE,IA,IE,NK2,ERREAD)
            IF(ERREAD) THEN
              WRITE(6,*) 'KPOINTS: MONKHORST-PACK OPTION'
              WRITE(6,*) 'ERROR READING NK2'
              GOTO 99
            ENDIF
            IA=IE
            CALL READSI(LINE,IA,IE,NK3,ERREAD)
            IF(ERREAD) THEN
              WRITE(6,*) 'KPOINTS: MONKHORST-PACK OPTION'
              WRITE(6,*) 'ERROR READING NK3'
              GOTO 99
            ENDIF
            IF(NK1.LE.0.OR.NK2.LE.0.OR.NK3.LE.0) THEN
              WRITE(6,'(T3,"NK1=",I5," NK2=",I5," NK3=",I5)')
     &             NK1,NK2,NK3
              CALL STOPGM('SYSIN', 'BAD MONKHORST-PACK MESH VALUE')
            ENDIF
C           MacDonald shift
            IF(INDEX(LINE,'SHIFT').NE.0) THEN
              IA=INDEX(LINE,'=')+1
              DO I=1,3
                CALL READSR(LINE,IA,IE,WVK0(I),ERREAD)
                IF(ERREAD) THEN
                  WRITE(6,'(" KPOINTS: WVK0(",I1,")=")') I
                  WRITE(6,*) 'ERROR READING MACDONALD SHIFT'
                  GOTO 99
                ENDIF
                IA=IE
              ENDDO
            ENDIF
          ELSE IF(INDEX(LINE,'BAND').NE.0) THEN
            IF(INDEX(LINE,'SCALE').NE.0) TKSCALE=.TRUE.
            NKPBD=1
            NKPTS=0
            DO WHILE (NKPBD.NE.0)
              READ(IUNIT,ERR=99,END=99,FMT=*) NKPBD,
     &             (RKI(I),I=1,3), (RKF(I),I=1,3)
              IF(NKPBD.NE.0) THEN
                IF(NKPBD.LE.1) CALL STOPGM('  SYSIN',
     &               'WRONG NUMBER OF K POINTS PER BAND')   
                CALL MEMORY(IP_RKT,3*(NKPTS+NKPBD),'RKT')
                IF(NKPTS.NE.0) CALL DSWAP(3*NKPTS,RK,1,RKT,1)
                DO IK=1,NKPBD
                  DO I=1,3
                    RKT(I,NKPTS+IK)=RKI(I)
     &                   +DBLE(IK-1)*(RKF(I)-RKI(I))/DBLE(NKPBD-1)
                  ENDDO
                ENDDO
                IF(NKPTS.NE.0) CALL FREEM(IP_RK)
                NKPTS=NKPTS+NKPBD
                CALL MEMORY(IP_RK,3*NKPTS,'RK')
                CALL DSWAP(3*NKPTS,RKT,1,RK,1)
                CALL FREEM(IP_RKT)
              ENDIF
            ENDDO
            IF(NKPTS.LE.0)
     &           CALL STOPGM('  SYSIN','WRONG NUMBER OF K POINTS')
            CALL MEMORY(IP_WK,  NKPTS,'WK')
            DO I=1,NKPTS
              WK(I)=1.D0
            ENDDO
          ELSE
            IF(INDEX(LINE,'SCALE').NE.0) TKSCALE=.TRUE.
            READ(IUNIT,ERR=99,END=99,FMT=*) NKPTS
            IF(NKPTS.LE.0)
     &           CALL STOPGM('  SYSIN','WRONG NUMBER OF K POINTS') 
            CALL MEMORY(IP_RK,3*NKPTS,'RK')
            CALL MEMORY(IP_WK,  NKPTS,'WK')
            DO IK=1,NKPTS
              READ(IUNIT,ERR=99,END=99,FMT='(A)') LINE
              IA=1
              DO I=1,3
                CALL READSR(LINE,IA,IE,RK(I,IK),ERREAD)
                IF(ERREAD) THEN
                  WRITE(6,'(" KPOINTS: RK(",I1,",",I4,")=")') I,IK
                  WRITE(6,*) 'ERROR READING KPOINTS INPUT'
                  GOTO 99
                ENDIF
                IA=IE
              ENDDO
              CALL READSR(LINE,IA,IE,WK(IK),ERREAD)
              IF(ERREAD) THEN
                WRITE(6,'(" KPOINTS: WEIGHT OF KPOINT ",I4)') IK
                WRITE(6,*) 'ERROR READING KPOINTS INPUT'
                GOTO 99
              ENDIF
            ENDDO
          ENDIF
          GOTO 10
C     ==--------------------------------------------------------------==
        ELSE IF((INDEX(LINE,'MESH').NE.0).AND.
     &          (INDEX(LINE,'MONKHORST').EQ.0)) THEN
C         REAL SPACE MESH FOR WAVEFUNCTION
          READ(IUNIT,ERR=99,END=99,FMT=*) NR1,NR2,NR3
          GOTO 10
        ELSE IF(INDEX(LINE,'SCALE').NE.0) THEN
C         SCALE ATOMIC COORDINATES WITH UNIT CELL DIMENSIONS
          TSCALE=.TRUE.
          SXSCALE=1.D0
          SYSCALE=1.D0
          SZSCALE=1.D0
          IF(INDEX(LINE,'CART').NE.0) THEN
            TCARTESIAN=.TRUE.
          ELSE
            TCARTESIAN=.FALSE.
          ENDIF
          IF(INDEX(LINE,'S=').NE.0) THEN
            I2=INDEX(LINE,'S=')+2
            CALL READSR(LINE(I2:80),1,IOUT,SXSCALE,ERREAD)
            IF(ERREAD.OR.(SXSCALE.LE.0.D0)) THEN
              WRITE(6,*) 'SCALE OPTION: ERROR READING THE NUMBER  S='
              GOTO 99
            ENDIF
            SYSCALE=SXSCALE
            SZSCALE=SXSCALE
          ENDIF
          IF(INDEX(LINE,'SX=').NE.0) THEN
            I2=INDEX(LINE,'SX=')+3
            CALL READSR(LINE(I2:80),1,IOUT,SXSCALE,ERREAD)
            IF(ERREAD.OR.(SXSCALE.LE.0.D0)) THEN
              WRITE(6,*) 'SCALE OPTION: ERROR READING THE NUMBER SX='
              GOTO 99
            ENDIF
          ENDIF
          IF(INDEX(LINE,'SY=').NE.0) THEN
            I2=INDEX(LINE,'SY=')+3
            CALL READSR(LINE(I2:80),1,IOUT,SYSCALE,ERREAD)
            IF(ERREAD.OR.(SYSCALE.LE.0.D0)) THEN
              WRITE(6,*) 'SCALE OPTION: ERROR READING THE NUMBER SY='
              GOTO 99
            ENDIF
          ENDIF
          IF(INDEX(LINE,'SZ=').NE.0) THEN
            I2=INDEX(LINE,'SZ=')+3
            CALL READSR(LINE(I2:80),1,IOUT,SZSCALE,ERREAD)
            IF(ERREAD.OR.(SZSCALE.LE.0.D0)) THEN
              WRITE(6,*) 'SCALE OPTION: ERROR READING THE NUMBER SZ='
              GOTO 99
            ENDIF
          ENDIF
          GOTO 10
        ELSE IF(INDEX(LINE,'DOUBLE').NE.0 .AND.
     *           INDEX(LINE,'GRID').NE.0) THEN
C         Double Grid
          IF(INDEX(LINE,'ON').NE.0) TDG=.TRUE.
          IF(INDEX(LINE,'OFF').NE.0) TDG=.FALSE.
          GOTO 10
        ELSE IF(INDEX(LINE,'SYMME').NE.0 .AND.
     *           INDEX(LINE,'COORD').NE.0) THEN
C         SYMMETRIZE ATOMIC COORDINATES
          TSYMM=.TRUE.
          GOTO 10
        ELSE IF(INDEX(LINE,'ANGST').NE.0) THEN
C         UNITS OF INPUT ARE ANGSTROMS
          IF(TQMMM) THEN
            CALL STOPGM('SYSIN','ANGSTROM not available with QM/MM')
          ENDIF
          BOHR=.FALSE.
          GOTO 10
        ELSE IF(INDEX(LINE,'TESR').NE.0) THEN
C         EXTENDED REAL SPACE INTEGRATION FOR IMAGE CHARGES
          TESR=.TRUE.
          READ(IUNIT,ERR=99,END=99,FMT=*) IESR
          GOTO 10
        ELSE IF(INDEX(LINE,'SURF').NE.0) THEN
C         System is periodic in two dimensions [x and y in default]
          TCLUST=.TRUE.
          TTWOD=.TRUE.
          IF(INDEX(LINE,'XY').NE.0) SNORMAL=3
          IF(INDEX(LINE,'YZ').NE.0) SNORMAL=1
          IF(INDEX(LINE,'ZX').NE.0) SNORMAL=2
          GOTO 10
        ELSE IF(INDEX(LINE,'POLY').NE.0) THEN
C         System is periodic in one dimension [x]
          TCLUST=.TRUE.
          TONED=.TRUE.
          GOTO 10
        ELSE IF(INDEX(LINE,'CLUST').NE.0) THEN
C         System is not periodic
          TCLUST=.TRUE.
          GOTO 10
        ELSE IF((INDEX(LINE,'SHOCK').NE.0).AND.
     &          (INDEX(LINE,'VELOC').NE.0)) THEN
C         VELOCITY OF SHOCK WAVE IN M/SEC
          READ(IUNIT,ERR=99,END=99,FMT=*) VSHOCK
c CONVERT FROM M/SEC -> A/FS -> BOHR/FS -> AU
          VSHOCK = VSHOCK * 1.D-5 * FBOHR * AU_FS
          GOTO 10
        ELSE
C         Unknown Keyword. store and continue
          IF(' '.NE.LINE) THEN
            IF(IUNK.LT.MAXUNKNOWN) THEN
              IUNK=IUNK+1
              UNKNOWN(IUNK)=LINE
            ELSE
              DO I=1,MAXUNKNOWN-1
                UNKNOWN(I)=UNKNOWN(I+1)
              ENDDO
              UNKNOWN(IUNK)=LINE
            ENDIF
          ENDIF
          GOTO 10
        ENDIF
C     ==--------------------------------------------------------------==
   99 CONTINUE
      WRITE(6,*) ' SYSIN: ERROR IN READING INPUT FILE'
      WRITE(6,*) ' THE LAST TWO LINES READ WERE '
      CALL XSTRING(LINEOLD,IA,IE)
      WRITE(6,*) LINEOLD(1:IE)
      CALL XSTRING(LINE,   IA,IE)
      WRITE(6,*) LINE(1:IE)
      CALL STOPGM('SYSIN','FATAL INPUT ERROR')
C     ==--------------------------------------------------------------==
   20 CONTINUE
C     ==--------------------------------------------------------------==
CEHR[
      IF (CMPLX_WF) THEN
        TKPNT=.TRUE.
        NKPTS=1
        CALL MEMORY(IP_RK,3*NKPTS,'RK')
        CALL MEMORY(IP_WK,  NKPTS,'WK')
        RK(1,1)=0.D0
        RK(2,1)=0.D0
        RK(3,1)=0.D0
        WK(1)=1.D0
C       all bcast in setsys.F
      ENDIF
CEHR]
cmb   Prevent the use of non-isolated cluster options in QMMM
      IF(TQMMM) THEN
        IF(IBRAV.NE.0) THEN
          WRITE(6,*) ' WARNING: IBRAV =',IBRAV,' NOT ALLOWED IN QMMM'
          WRITE(6,*) '          NOW SET TO IBRAV = 0'
          IBRAV=0
          TCLUST=.TRUE.
        ENDIF 
        IF(.NOT.TCLUST) THEN ! this is redundant but safe
          WRITE(6,*) ' WARNING: ISOLATED CLUSTER OPTION NEEDED IN QMMM'
          WRITE(6,*) '          NOW TCLUST WILL BE SET TO .TRUE.'
          IBRAV=0
          TCLUST=.TRUE.
        ENDIF
      ENDIF 
C     ==--------------------------------------------------------------==
C     AK: SANITY CHECK. IBRAV=-2 IS USED FOR IMPLICIT TRICLINIC SYMMETRY
C     WITH GIVEN CELL VECTORS. SYMMETRY SHOULD NOT BE USED IN THAT CASE.
      IF(TCELLVECTORS) THEN
        IF(IBRAV.NE.-1) THEN
          WRITE(6,*)
     &         ' WITH THE OPTION CELL VECTORS, ',
     &         'DO NOT USE THE KEYWORD SYMMETRY'
          CALL STOPGM('SYSIN','SYMMETRY USED WITH CELL VECTORS')
        ELSE
          IBRAV=-2
        ENDIF
      END IF
      IF(IBRAV.EQ.-1) THEN
        WRITE(6,*) ' SYMMETRY NOT SPECIFIED'
        CALL STOPGM('SYSIN',' ')
      ENDIF
      IF(.NOT.TCELLVECTORS.AND.CELLDM(1).LT.1.D-5) THEN
        WRITE(6,'(A,A)') ' SUPERCELL DIMENSIONS NOT SPECIFIED ',
     &       ' OR THE LATTICE CONSTANT IS NULL.'
        CALL STOPGM('SYSIN',' ')
      ENDIF

C     AK: HMMM. PARRINELLO-RAHMAN OR STEEPEST DESCEND CELL NEED
C     TRICLINIC SUPERCELL SYMMETRY (EVEN FOR ISOTROPIC CELL)
C     AND WILL RESET IBRAV. BETTER DO IT HERE AND TELL PEOPLE
C     ABOUT IT NOW, SO THAT THE OUTPUT IS CORRECT.
      IF ((TPRCP.OR.TSDC).AND.(IBRAV.NE.14)
     &                   .AND.(.NOT. TCELLVECTORS)) THEN
         WRITE(6,'(A,A,/)')' SYSIN| WARNING: VARIABLE CELL',
     $        ' ENFORCES TRICLINIC SYMMETRY (IBRAV=14)'
         IBRAV=14
      ENDIF

C     AK: CHECK WHETHER CELL DIMENSIONS IN INPUT AND SYMMETRY DO MATCH
      CALL CHKCSYMM(BOXEPS)

      IF(ECUT.EQ.0.0D0) THEN
        WRITE(6,*) ' PLANE WAVE CUT OFF NOT SPECIFIED'
        CALL STOPGM('SYSIN',' ')
      ENDIF
      IF(TLSE)THEN
        IF(TLSD) THEN
          WRITE(6,*) ' LSE AND LSD NOT COMPATIBLE'
          CALL STOPGM('SYSIN',' ')
        ENDIF
        IF(TDIAG) THEN
          WRITE(6,*) ' DIAGONALIZATION NOT IMPLEMENTED FOR LSE'
          CALL STOPGM('SYSIN',' ')
        ENDIF
        IF(TPRES) THEN
          WRITE(6,*) ' STRESS NOT IMPLEMENTED WITH LSE'
          CALL STOPGM('SYSIN',' ')
        ENDIF
      ENDIF
      IF(.NOT.TLSD.AND.NSPIN.NE.0) THEN
        WRITE(6,*) ' LDA WITH MULTIPLICITY ',NSPIN,' NOT COMPATIBLE'
        CALL STOPGM('SYSIN','MULTIPLICITY REQUIRES LOCAL SPIN DENSITY')
      ENDIF
C CB Some checks for BS
      IF(BSYMM) THEN
        IF(N.NE.0.OR.NSUP.NE.0) THEN
          WRITE(6,*) ' FOR BROKEN SYMMETRY ARBITRARY STATE NUMBERS',
     &               ' ARE NOT SUPPORTED.'
          CALL STOPGM('SYSIN','BROKEN SYMMETRY & N OR NSUP GIVEN')
        ENDIF
        IF(NSPIN.EQ.0) THEN
          WRITE(6,*) ' FOR BROKEN SYMMETRY THE MULTIPLICITY',
     &               ' OF THE HIGHSPIN WAVEFUNCTION IS NEEDED.'
          CALL STOPGM('SYSIN','BROKEN SYMMETRY & NSPIN 0')
        ENDIF
        IF(MOD(NSPIN,2).EQ.0) THEN
          WRITE(6,*) ' FOR BROKEN SYMMETRY THE MULTIPLICITY',
     &               ' OF THE HIGHSPIN WAVEFUNCTION MUST BE ODD.'
          CALL STOPGM('SYSIN','BROKEN SYMMETRY & NSPIN EVEN')
        ENDIF
      ENDIF
      IF(TONED.AND.TTWOD) THEN
        WRITE(6,*) ' PERIODICITY IN ONE OR TWO DIMENSIONS?'
        CALL STOPGM('SYSIN','POLYMER & SURFACE')
      ENDIF
      IF(TPGAUTO.AND.TSYMM) THEN
        WRITE(6,*)
     &       ' IMPOSSIBLE TO DETERMINE POINT GROUP AND',
     &       ' TO SYMMETRIZE COORDINATES'
        CALL STOPGM('SYSIN','POINT GROUP AUTO & SYMMETRIZE COORDINATES')
      ENDIF
      IF(TFIXO.AND..NOT.TDIAG) THEN
        WRITE(6,*)
     &       ' FIXED OCCUPATION NUMBERS ONLY IN COMBINATION WITH',
     &       ' DIAGONALIZATION'
        CALL STOPGM('SYSIN','FIXED OCCUPATION & MINIMIZATION')
      ENDIF
      IF(TFIXO.AND.TKPNT) THEN
        WRITE(6,*)
     &       ' FIXED OCCUPATION NUMBERS IN COMBINATION WITH',
     &       ' KPOINTS NOT IMPLEMENTED'
        CALL STOPGM('SYSIN','FIXED OCCUPATION & KPOINTS')
      ENDIF
      IF(TSHOP) THEN
CND     TLSD=.FALSE.
        TLSE=.TRUE.
      ENDIF
      IF(.NOT.TLSE.AND.TMGOE) THEN
        WRITE(6,*) ' MODIFIED GOEDECKER ONLY FOR ROKS '
        CALL STOPGM('SYSIN',' ')
      ENDIF
C     ==--------------------------------------------------------------==
C     stop on illegal and unsupported values for IBRAV.
      IF(IBRAV.EQ.9) THEN
        CALL STOPGM('SYSIN',' UNSUPPORTED SYMMETRY VALUE')
      ELSEIF(IBRAV.EQ.10) THEN
        CALL STOPGM('SYSIN',' UNSUPPORTED SYMMETRY VALUE')
      ELSEIF(IBRAV.EQ.11) THEN
        CALL STOPGM('SYSIN',' UNSUPPORTED SYMMETRY VALUE')
      ELSEIF(IBRAV.EQ.13) THEN
        CALL STOPGM('SYSIN',' UNSUPPORTED SYMMETRY VALUE')
      ELSEIF(IBRAV.LT.-2) THEN
        CALL STOPGM('SYSIN',' ILLEGAL SYMMETRY VALUE')
      ELSEIF(IBRAV.GT.14) THEN
        CALL STOPGM('SYSIN',' ILLEGAL SYMMETRY VALUE')
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TPRCP.OR.TSDC) THEN
        IF(IBRAV.EQ.0) THEN
          WRITE(6,*) ' VARIABLE CELL AND ISOLATED SYSTEM NOT COMPATIBLE'
          CALL STOPGM('SYSIN',' ')
        ENDIF
        IF(TSTRTENSOR.AND.TPRESSURE) THEN
          WRITE(0,'(A)') ' SYSIN| STRESS TENSOR AND PRESSURE SPECIFIED'
          CALL STOPGM('SYSIN',' INCONSISTENT INPUT IN &SYSTEM')
        ENDIF
        IF(TPRESSURE) THEN
          CALL AZZERO(STENS,9)
          DO I=1,3
            STENS(I,I)=DRUCK
          ENDDO
        ENDIF
        DRUCK=DRUCK*KB_AU
        PSHOCK=DRUCK
        CALL DSCAL(9,KB_AU,STENS,1)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  SET SUPERCELL SYMMETRY TO SIMPLE CUBIC OR ORTHORHOMBIC      ==
C     ==  FOR ISOLATED SYSTEMS                                        ==
C     ==--------------------------------------------------------------==
      IF(IBRAV.EQ.0) THEN
        TCLUST=.TRUE.
        IF(.NOT.(TQMMM.OR.TTWOD.OR.TONED)) TISOS=.TRUE. ! qm/mm, surface, polymer need 
                                                        ! cluster but are not isolated
C     TEST IF WE ARE CUBIC. CELLDM(4:6) HAS BEEN CHECKED BEFORE.
        IF((ABS(CELLDM(2)-1.0D0)+ABS(CELLDM(3)-1.D0)).LT.1.D-5) THEN
          IBRAV=1
          CELLDM(2)=1.0D0
          CELLDM(3)=1.0D0
          CELLDM(4)=0.0D0
          CELLDM(5)=0.0D0
          CELLDM(6)=0.0D0
        ELSE
          IBRAV=8
        ENDIF
      ENDIF
C     CELLDM by default
      IF(IBRAV.EQ.1) THEN
        CELLDM(2)=1.D0
        CELLDM(3)=1.D0
        CELLDM(4)=0.0D0
        CELLDM(5)=0.0D0
        CELLDM(6)=0.0D0
      ELSEIF(IBRAV.EQ.6) THEN
        CELLDM(2)=1.D0
        CELLDM(4)=0.0D0
        CELLDM(5)=0.0D0
        CELLDM(6)=0.0D0
      ELSEIF(IBRAV.EQ.8) THEN
        CELLDM(4)=0.0D0
        CELLDM(5)=0.0D0
        CELLDM(6)=0.0D0
      ENDIF
      IF( (CELLDM(4).LT.-1.D0.OR.CELLDM(4).GT.1.D0).OR.
     &     (CELLDM(5).LT.-1.D0.OR.CELLDM(5).GT.1.D0).OR.
     &     (CELLDM(6).LT.-1.D0.OR.CELLDM(6).GT.1.D0) ) THEN
        CALL STOPGM('SYSIN','WRONG ANGLE COSINES')
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TCLUST.AND.PS_TYPE.EQ.0) THEN
        IF(TONED.OR.TTWOD) THEN
          PS_TYPE=3
        ELSE
          PS_TYPE=1
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C..test box dimensions and dimensionality of calculation
      IF(TCLUST) THEN
         IF(PS_TYPE.EQ.1) THEN
            IF(TONED) THEN
               WRITE(6,*) 'WARNING! POLYMER option not tested with ',
     $              'Hockney Poisson solver'
            ELSEIF(TTWOD) THEN
               WRITE(6,*) 'SURFACE with Hockney Poisson solver: ',
     $              'influence function in reciprocal space'
            ENDIF
         ELSEIF(PS_TYPE.EQ.2) THEN
            IF(TONED.OR.TTWOD) THEN
               WRITE(6,*) 'SURFACE and POLYMER options not implemented',
     *              ' for Tuckerman Poisson solver'
               CALL STOPGM('SYSIN','ERROR IN &SYSTEM SECTION')
            ENDIF
         ELSEIF(PS_TYPE.EQ.3) THEN
            IF(TONED) THEN
               IF(ABS(CELLDM(2)-CELLDM(3)).GT.1.D-10) THEN
                  WRITE(6,*) 'Cell dimensions b and c have to be equal'
                  WRITE(6,*) 'for Mortensen 1d(=POLYMER) Poisson solver'
                  CALL STOPGM('SYSIN','ERROR IN &SYSTEM SECTION')
               ENDIF
            ELSEIF(TTWOD) THEN
            ELSE
               IF(ABS(CELLDM(2)*CELLDM(3)-1.D0).GT.1.D-10) THEN
                  WRITE(6,*) 'Only cubic boxes allowed for Mortensen',
     $                 ' 0d(=ISOLATED SYSTEM) Poisson solver'
                  CALL STOPGM('SYSIN','ERROR IN &SYSTEM SECTION')
               ENDIF
            ENDIF
         ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(IUNK.NE.0) THEN
        WRITE(6,'(/,1X,64("="))')
        WRITE(6,'(1X,A,14X,A,12X,A)') '= ',
     &    'UNKNOWN KEYWORDS IN SECTION &SYSTEM','='
        DO I=1,IUNK
          LINEOLD=UNKNOWN(I)
          CALL XSTRING(LINEOLD,IA,IE)
          WRITE(6,'(A,A)') ' = ',LINEOLD(IA:IE)
        ENDDO
      WRITE(6,'(1X,64("="),/)')
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TCAS22.AND.TPENAL) CALL STOPGM("SYSIN","INCOMPATIBLE OPTIONS")
C     ==--------------------------------------------------------------==
      ECUTWDG=ECUT
      IF(TDG) THEN
        ECUTDG=4.D0*ECUT
        IF(.NOT.DUAL) THEN
          IF(ECUTD.GT.0.D0) THEN
            CDUAL=ECUTD/ECUT
            DUAL=.TRUE.
          ENDIF
        ELSE
          IF(ECUTD.GT.0.D0) THEN
            IF(ABS(CDUAL-ECUTD/ECUT).GT.1.D-5) THEN
              CALL STOPGM('SYSIN','INCONSISTENT DUAL/DENSITY CUTOFF')
            ENDIF
          ENDIF
        ENDIF
        IF(CDUAL.LT.4.D0) THEN
          CALL STOPGM('SYSIN','INCONSISTENT DENSITY CUTOFF')
        ENDIF
      ELSE
        IF(.NOT.DUAL) THEN
          IF(ECUTD.GT.0.D0) THEN
            CDUAL=ECUTD/ECUT
            DUAL=.TRUE.
          ENDIF
        ELSE
          IF(ECUTD.GT.0.D0) THEN
            IF(ABS(CDUAL-ECUTD/ECUT).GT.1.D-5) THEN
              CALL STOPGM('SYSIN','INCONSISTENT DUAL/DENSITY CUTOFF')
            ENDIF
          ENDIF
        ENDIF
        ECUTDG=CDUAL*ECUT
      ENDIF
      IF(THDA)THEN
        IF(NDON.EQ.0.AND..NOT.THDAS)THEN
          IF(PARENT)WRITE(6,*)"ERROR, No Donor atoms in HDA ",
     *      "calculation. Set HDAS flag."
          CALL STOPGM('SYSIN','INCONSISTENT DONOR GROUP')
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TFIELD) THEN ! Applied external electric field
        WRITE(6,'(A,T25,3E12.4,A,/)') ' APPLY ELECTRIC FIELD: ',
     .       (AIFIELD(I),I=1,3),' A.U.'
      ENDIF
C     ==--------------------------------------------------------------==
 9999 CONTINUE
#ifdef PARALLEL
C..DUAL
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(DUAL,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(CDUAL,MSGLEN,SOURCE,ALLGRP)
C     TESR
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TESR,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IESR,MSGLEN,SOURCE,ALLGRP)
C     ISOS
      MSGLEN = 6 * 8/IRAT
      CALL MY_BCAST(TCLUST,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 4 * 8
      CALL MY_BCAST(RCERF,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 2 * 8/IRAT
      CALL MY_BCAST(PS_TYPE,MSGLEN,SOURCE,ALLGRP)
C     TSPHERE
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TSPHERE,MSGLEN,SOURCE,ALLGRP)
C     CLSD (NLSD)
      MSGLEN = 2 * 8/IRAT
      CALL MY_BCAST(NLSD,MSGLEN,SOURCE,ALLGRP)
C     SPIN2 (TLSE)
      MSGLEN = 1 * 8
      CALL MY_BCAST(LSEA,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(LSEB,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 9 * 8/IRAT
      CALL MY_BCAST(TLSE,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 2 * 8
      CALL MY_BCAST(MGMAB,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8
      CALL MY_BCAST(APENAL,MSGLEN,SOURCE,ALLGRP)
C     TFIXO
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TFIXO,MSGLEN,SOURCE,ALLGRP)
C     TKDP 
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TKDP,MSGLEN,SOURCE,ALLGRP)
C     NK1,NK2,NK3
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NK1,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NK2,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NK3,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TFIELD,MSGLEN,SOURCE,ALLGRP)
      MSGLEN =3* 8
      CALL MY_BCAST(AIFIELD,MSGLEN,SOURCE,ALLGRP)
C     HFX
      MSGLEN = 2 * 8
      CALL MY_BCAST(HFXWFE,MSGLEN,SOURCE,ALLGRP)
C     DOUBLEGRID
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TDG,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 2 * 8
      CALL MY_BCAST(ECUTWDG,MSGLEN,SOURCE,ALLGRP)
C TSHOCK
      MSGLEN = 4 * 8/IRAT
      CALL MY_BCAST(VSHOCK,MSGLEN,SOURCE,ALLGRP)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
C     CHECK THE INPUT FOR THE CELL DIMENSIONS AGAINST THE SYMMETRY
C     MAKE SURE THAT THE PARAMETERS IN THE INPUT FILE ARE VALID.
C     01/2004 <axel.kohlmeyer@theochem.ruhr-uni-bochum.de>
C     ==--------------------------------------------------------------==
      SUBROUTINE CHKCSYMM(BOXEPS)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cell.inc'
C     ARGUMENTS
      REAL*8 BOXEPS
C     VARIABLES
      INTEGER I
      LOGICAL CELLOK

C     ARE THE TESTS DISABLED?
      IF (BOXEPS.LT.0.0D0) RETURN

C     WE ASSUME THE BEST AND STOP ONLY ON KNOWN ERRORS.
      CELLOK=.TRUE.
      IF (IBRAV.EQ.0) THEN
         IF ((ABS(CELLDM(4)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(5)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)).GT.BOXEPS)) THEN
            WRITE(0,'(A,A)') 'SUPERCELL IS NOT ORTHORHOMBIC AS',
     $           ' REQUIRED FOR ISOLATED SYSTEMS'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a b c 0.0 0.0 0.0'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.1) THEN
         IF ((ABS(1.0D0-CELLDM(2)).GT.BOXEPS)
     $        .OR.(ABS(1.0D0-CELLDM(3)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(4)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(5)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)).GT.BOXEPS)) THEN
            WRITE(0,*) 'SUPERCELL IS NOT SIMPLE CUBIC'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a 1.0 1.0 0.0 0.0 0.0'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.2) THEN
         IF ((ABS(1.0D0-CELLDM(2)).GT.BOXEPS)
     $        .OR.(ABS(1.0D0-CELLDM(3)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(4)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(5)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)).GT.BOXEPS)) THEN
            WRITE(0,*) 'SUPERCELL IS NOT FACE CENTERED CUBIC'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a 1.0 1.0 0.0 0.0 0.0'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.3) THEN
         IF ((ABS(1.0D0-CELLDM(2)).GT.BOXEPS)
     $        .OR.(ABS(1.0D0-CELLDM(3)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(4)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(5)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)).GT.BOXEPS)) THEN
            WRITE(0,*) 'SUPERCELL IS NOT BODY CENTERED CUBIC'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a 1.0 1.0 0.0 0.0 0.0'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.4) THEN
         IF ((ABS(1.0D0-CELLDM(2)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(4)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(5)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)+0.5D0).GT.BOXEPS)) THEN
            WRITE(0,*) 'SUPERCELL IS NOT HEXAGONAL'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a 1.0 cpa 0.0 0.0 -0.5'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.5) THEN
         IF ((ABS(1.0D0-CELLDM(2)).GT.BOXEPS)
     $        .OR.(ABS(1.0D0-CELLDM(3)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(5)-CELLDM(4)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)-CELLDM(4)).GT.BOXEPS)) THEN
            WRITE(0,*) 'SUPERCELL IS NOT RHOMBOHEDRAL'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a 1.0 1.0 d d d'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.6) THEN
         IF ((ABS(1.0D0-CELLDM(2)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(4)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(5)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)).GT.BOXEPS)) THEN
            WRITE(0,*) 'SUPERCELL IS NOT TETRAGONAL'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a 1.0 cpa 0.0 0.0 0.0'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.7) THEN
         IF ((ABS(1.0D0-CELLDM(2)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(4)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(5)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)).GT.BOXEPS)) THEN
            WRITE(0,*) 'SUPERCELL IS NOT BODY CENTERED TETRAGONAL'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a 1.0 c 0.0 0.0 0.0'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.8) THEN
         IF ((ABS(CELLDM(4)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(5)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)).GT.BOXEPS)) THEN
            WRITE(0,*) 'SUPERCELL IS NOT ORTHORHOMBIC'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a b c 0.0 0.0 0.0'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.12) THEN
         IF ((ABS(CELLDM(5)).GT.BOXEPS)
     $        .OR.(ABS(CELLDM(6)).GT.BOXEPS)) THEN
            WRITE(0,*) 'SUPERCELL IS NOT MONOCLINIC'
            WRITE(0,'(A,A)') 'EXPECTED FORM:',
     $           ' a b c d 0.0 0.0'
            CELLOK=.FALSE.
         ENDIF
      ELSE IF (IBRAV.EQ.14) THEN
C     NO SANITY CHECK POSSIBLE WITH TRICLINIC SYSTEM
         CELLOK=.TRUE.
      ELSE IF (IBRAV.EQ.-2) THEN
C     THE CELL WAS READ FROM VECTORS -> IMPLICIT IBRAV=14 (WILL BE SET IN SETSC.F)
C     NO SANITY CHECK POSSIBLE WITH TRICLINIC SYSTEM
         CELLOK=.TRUE.
      ELSE
         WRITE(0,'(A,I2)') ' UNKNOWN SUPERCELL SYMMETRY IBRAV=', IBRAV
         WRITE(0,'(A,A)')  ' IF THIS IS A VALID SYMMETRY, PLEASE',
     $        'ADD A SUITABLE TEST TO CHKCSYMM'
      ENDIF
      IF (.NOT.CELLOK) THEN
         WRITE(0,'(A,1PE10.3)') ' CHECK PRECISION: ', BOXEPS
         WRITE(0,'(A,6F10.5)' ) ' CELL DIMENSIONS: ', (CELLDM(I),I=1,6)
         CALL STOPGM('CHKCSYMM','SUPERCELL DOES NOT MATCH SYMMETRY')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
