C     ==================================================================
      SUBROUTINE TD_FORCE(C0,C1,C2,SC0,EIGV,RHOE,PSI,EIGT,
     *                    NSTATE,NROOT,TAU0,FION,ORBITAL,KPRINT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'elct.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'fft.inc'
C     Arguments
      INTEGER    NSTATE,NROOT,KPRINT
      COMPLEX*16 C0(NGW,NSTATE),C1(NGW,NOLR,NROOT,*),C2(NGW,NSTATE),
     *           PSI(*),SC0(*)
      REAL*8     TAU0(3,NAX,*),FION(3,NAX,*),EIGV(*),RHOE(*),EIGT(*)
      CHARACTER*(*) ORBITAL
C     Variables
      DIMENSION  F(*),POTR(*),RHOO(*)
      INTEGER    IL_RHOE,IL_PSI,ISUB,IR,LSCR,I,J,IT,LDDXC,IG
      INTEGER    NVPP,NGDE,NPME
      COMPLEX*16 CZ(NGW,*),CR(NGW,*)
      REAL*8     DASUM,EDUMMY,TRACE,VP,TIMEF
      EXTERNAL   DASUM,TIMEF
      REAL*8     R1MAT(NSTATE,NSTATE),WK,SCR(*),TDFI(3,NAX,*),
     *           FOCC(*),VP2(*),DDXC(*),T1,T2,E2(5),EIND
      POINTER    (IP_TDFI,TDFI),(IP_CZ,CZ),(IP_CR,CR),
     *           (IP_R1MAT,R1MAT),(IP_SCR,SCR),(IP_FOCC,FOCC),
     *           (IP_VP2,VP2),(IP_DDXC,DDXC)
      REAL*8     PME(*),GDE(*),VPP(*)
      POINTER    (IP_PME,PME),(IP_GDE,GDE),(IP_VPP,VPP)
      CHARACTER*30 TAG
C     ==================================================================
      T1=TIMEF()
C     ALLOCATE MEMORY
      CALL MEMORY(IP_R1MAT,NSTATE*NSTATE,"R1MAT")
      CALL MEMORY(IP_CZ,2*NGW*NSTATE,"CZ")
      CALL MEMORY(IP_CR,2*NGW*NSTATE,"CR")
      CALL MEMORY(IP_TDFI,3*NAX*NSP,"TDFI")
      CALL GIVE_SCR_TD_FORCE(LSCR,NSTATE,TAG)
      CALL MEMORY(IP_SCR,LSCR,"SCR")
C     ==--------------------------------------------------------------==
      IF(PARENT .AND. KPRINT.GE.0) THEN
        WRITE(6,'(/,A,/)') " CALCULATION OF TDDFT FORCES"
      ENDIF
C     ==--------------------------------------------------------------==
      LOPTI=LOPTI+10
      IF(TXC_ANALYTIC) THEN
        LDDXC=2*NNR1*(2*NLSD-1)
        IT=NNR1+1
        IF(TLSD) IT=3*NNR1+1
      ELSEIF(LOPTI.EQ.0 .OR. LOPTI.EQ.2) THEN
        LDDXC=NNR1*(2*NLSD-1)
        IT=1
      ELSE
        LDDXC=1
        IT=1
      ENDIF
      CALL MEMORY(IP_DDXC,LDDXC,'DDXC')
      CALL LR_XCPOT(DDXC(1) ,RHOO,SCR,LSCR,.FALSE.)
      CALL LR_XCPOT(DDXC(IT),RHOO,SCR,LSCR,.TRUE. )
      CALL MEMORY(IP_FOCC,NSTATE,"FOCC")
      DO I=1,NSTATE
        FOCC(I)=1.D0
      ENDDO
C     R1mat=x*x
      CALL OVLAP(NSTATE,R1MAT,C1(1,1,FSTATE,1),C1(1,1,FSTATE,1))
      IF(.NOT.TDA) CALL OVLAP_ADD(NSTATE,R1MAT,C1(1,1,FSTATE,2),
     *                            C1(1,1,FSTATE,2))
      CALL GLOSUM(NSTATE*NSTATE,R1MAT)
C     c*R1mat
      CALL ROTATE(-1.D0,C0,0.D0,C2,R1MAT,NSTATE,2*NGW,TLSD,NSUP,NSDOWN)
C     domega/dR
      CALL AZZERO(TDFI,3*NAX*NSP)
      CALL AFBDR(C0,C2,FOCC,PSI,SCR,LSCR,NSTATE,TDFI)
      CALL RNLSM(C1(1,1,FSTATE,1),NSTATE,PSI,SCR,LSCR,1,1,.TRUE.)
      CALL RNLFOR(TDFI,FOCC,1.D0,NSTATE,1)
      IF(.NOT.TDA) THEN
        CALL RNLSM(C1(1,1,FSTATE,2),NSTATE,PSI,SCR,LSCR,1,1,.TRUE.)
        CALL RNLFOR(TDFI,FOCC,1.D0,NSTATE,1)
      ENDIF
      CALL AZZERO(RHOE,NLSD*NNR1)
      IF(TLSD) THEN
        CALL RHOABOFR(NSUP,C1(1,1,FSTATE,1),C1(1,1,FSTATE,1),RHOE,PSI)
        IF(.NOT.TDA) CALL RHOABOFR(NSUP,C1(1,1,FSTATE,2),
     *                           C1(1,1,FSTATE,2),RHOE,PSI)
        CALL RHOABOFR(NSUP,C2(1,1),C0(1,1),RHOE,PSI)
        CALL RHOABOFR(NSDOWN,C1(1,NSUP+1,FSTATE,1),
     *                C1(1,NSUP+1,FSTATE,1),RHOE(NNR1+1),PSI)
        IF(.NOT.TDA) CALL RHOABOFR(NSDOWN,C1(1,NSUP+1,FSTATE,2),
     *                           C1(1,NSUP+1,FSTATE,2),RHOE(NNR1+1),PSI)
        CALL RHOABOFR(NSDOWN,C2(1,NSUP+1),C0(1,NSUP+1),RHOE(NNR1+1),PSI)
        CALL DAXPY(NNR1,1.D0,RHOE(NNR1+1),1,RHOE,1)
      ELSE
        CALL RHOABOFR(NSTATE,C1(1,1,FSTATE,1),C1(1,1,FSTATE,1),RHOE,PSI)
        IF(.NOT.TDA) CALL RHOABOFR(NSTATE,C1(1,1,FSTATE,2),
     *                           C1(1,1,FSTATE,2),RHOE,PSI)
        CALL RHOABOFR(NSTATE,C2,C0,RHOE,PSI)
      ENDIF
      CALL TDRHOF(TDFI,RHOE,PSI)
      IF(.NOT.TDA) THEN
        CALL DSCAL(3*NAX*NSP,-0.5D0,TDFI,1)
      ELSE
        CALL DSCAL(3*NAX*NSP,-1.0D0,TDFI,1)
      ENDIF
C     ==--------------------------------------------------------------==
C     RHS of Z-Matrix equation (domega/dc)
C     ==--------------------------------------------------------------==
      CALL V1OFRHO1(E2,RHOE,DDXC,PSI,SCR,LSCR)
      EIND = -E2(1)-E2(2)
      CALL AZZERO(CR,2*NGW*NSTATE)
      CALL VPSIMT(C0,CR,F,RHOE,PSI,NSTATE,NLSD,.FALSE.)
      IF(.NOT.TDA) CALL DSCAL(NNR1,0.5D0,RHOE,1)
C
C     d(XWC)/dC
#ifdef PARALLEL
      IL_RHOE   = MAX(KRX,KR1M*NOGRP)*KR2S*KR3S * NLSD
#else
      IL_RHOE   = NNR1 * NLSD
#endif
      CALL MEMORY(IP_VP2,IL_RHOE,"VP2")
      CALL RHO1OFR(C0,C1(1,1,FSTATE,1),FOCC,RHOE,PSI,NSTATE)
      IF(LRSYM.EQ.3) THEN
        CALL VTD2T(VP2,RHOE,PSI,SCR,LSCR,.TRUE.)
      ELSE
        CALL VTD2(VP2,RHOE,PSI,SCR,LSCR,.TRUE.)
      ENDIF
      CALL VPSIMT(C0,CR,FOCC,VP2,PSI,NSTATE,NLSD,.TRUE.)
      CALL FREEM(IP_VP2)
      CALL VTDOFRHO1(E2,RHOE,DDXC(IT),PSI,SCR,LSCR,.TRUE.)
      EIND = EIND-E2(1)-E2(2)
      CALL VPSIMT(C1(1,1,FSTATE,1),CR,FOCC,RHOE,PSI,NSTATE,NLSD,.TRUE.)
      CALL AZZERO(C2,2*NGW*NSTATE)
      CALL VPSIMT(C0,C2,FOCC,RHOE,PSI,NSTATE,NLSD,.TRUE.)
      CALL OVLAP(NSTATE,R1MAT,C0,C2)
      CALL GLOSUM(NSTATE*NSTATE,R1MAT)
      CALL ROTATE(-1.D0,C1(1,1,FSTATE,1),1.D0,CR,R1MAT,NSTATE,2*NGW,
     &            TLSD,NSUP,NSDOWN)
C
      CALL DSCAL(2*NGW*NSTATE,-1.D0,CR,1)
      CALL LR_ORTHO(NSTATE,C0,CR,SCR,LSCR)
C
C     Solve Z-Matrix equation
      NVPP = NGW
      IF(LOPTI.EQ.0) THEN
        NPME = MAX((NGW*NSTATE+8)*MDIIS,2*NGW*NSTATE)
        NPME = MAX(2*NGW*NSTATE*MLDIIS,NPME)
        NGDE = MAX(((NGW*NSTATE+8)*MDIIS)/4,1)
        NGDE = MAX(2*NGW*NSTATE*MLDIIS,NGDE)
      ELSEIF(LOPTI.EQ.1) THEN
        NPME = 1
        NGDE = 1
      ELSE IF(LOPTI.EQ.2) THEN
        NPME = 2*NGW*NSTATE
        NGDE = 1
      ELSE IF(LOPTI.EQ.3) THEN
        NPME = (NGW*NSTATE+8)*MDIIS
        NGDE = ((NGW*NSTATE+8)*MDIIS)/4
      ELSE
        IF(PARENT)
     *  WRITE(6,*) ' WRONG OPTION FOR LINEAR RESPONSE OPTIMIZATION'
        CALL STOPGM('TD_FORCE',' ')
      ENDIF
      CALL MEMORY(IP_PME,NPME,'PME')
      CALL MEMORY(IP_GDE,NGDE,'GDE')
      CALL MEMORY(IP_VPP,NVPP,'VPP')
C..always use preconditioner
      SDIIS=.TRUE.
      SPCG=.TRUE.
      PREC=.TRUE.
      CALL KSDIAG(VPP)
      TRACE=DASUM(NSTATE,EIGV,1)/DBLE(NSTATE)
      DO IG=1,NGW
        VP=VPP(IG)+TRACE
        VPP(IG)=ABS(VP/(VP**2+LR_HTHRS**2))
      ENDDO
      CALL OPT_LR(C0,CZ,C2,SC0,EIND,EIGV,RHOE,CR,EDUMMY,EDUMMY,
     &            DDXC,VPP,PME,GDE,PSI,SCR,LSCR,NSTATE,
     &            "ZFORCE",ORBITAL)
      LOPTI=LOPTI-10
      CALL FREEM(IP_PME)
      CALL FREEM(IP_GDE)
      CALL FREEM(IP_VPP)
C     Z dF/dR C
      CALL RHO1OFR(C0,CZ,F,RHOE,PSI,NSTATE)
      CALL TDRHOF(TDFI,RHOE,PSI)
      CALL AFBDR(CZ,C0,F,PSI,SCR,LSCR,NSTATE,TDFI)
      CALL AFBDR(C0,CZ,F,PSI,SCR,LSCR,NSTATE,TDFI)
      CALL GLOSUM(3*NAX*NSP,TDFI)
C..TSH[
      IF (TDTULLY.AND.(S0_SH)) THEN
C       do nothing
      ELSE
        CALL DAXPY(3*NAX*NSP,-1.0D0,TDFI,1,FION,1)
      ENDIF
C..TSH]
C
C     MAKE Z Vectors available through C2
      CALL DCOPY(2*NGW*NSTATE,CZ,1,C2,1)
C
      CALL FREEM(IP_FOCC)
      CALL FREEM(IP_SCR)
      CALL FREEM(IP_DDXC)
      CALL FREEM(IP_TDFI)
      CALL FREEM(IP_R1MAT)
      CALL FREEM(IP_CZ)
      CALL FREEM(IP_CR)
C     ==--------------------------------------------------------------==
      IF(PARENT.AND.KPRINT.GE.1) THEN
        CALL WRGEOF(TAU0,FION)
      ENDIF
      T2=TIMEF()
      IF(PARENT.AND.KPRINT.GE.0) THEN
        WRITE(6,'(A,T56,F10.3)') 
     &    " TIME FOR TDDFT FORCE CALCULATION [s]",(T2-T1)*0.001D0
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_TD_FORCE(LTD_FORCE,NSTATE,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
C     Arguments
      INTEGER LTD_FORCE,NSTATE
      CHARACTER*30 TAG
C     Variables
      INTEGER LAFBDR,LOPT,LVTDOFRHO1,LVTD2
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_AFBDR(LAFBDR,NSTATE,TAG)
      CALL GIVE_SCR_OPT_LR(LOPT,"ZFORCE",TAG)
      CALL GIVE_SCR_VTDOFRHO1(LVTDOFRHO1,TAG)
      CALL  GIVE_SCR_VTD2(LVTD2,TAG)
      LTD_FORCE=0
      LTD_FORCE=MAX(LTD_FORCE,LAFBDR,
     *              LOPT,LVTDOFRHO1,LVTD2)+200
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TDRHOF(FION,RHO,PSI)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'isos.inc'
C     Arguments
      REAL*8     FION(3,NAX,NSX),RHO(*)
      COMPLEX*16 PSI(*)
C     Variables
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 RHETS,GX,GY,GZ,VCGS,TXX,TYY,TZZ,EI123
      REAL*8     FNL(*),DFNL(*)
      REAL*8     OMTP
      INTEGER    IG,ISA,IS,IA,IR
C     ==--------------------------------------------------------------==
      DO IR=1,NNR1
        PSI(IR)=DCMPLX(RHO(IR),0.D0)
      ENDDO
      CALL FWFFT(PSI)
C
      OMTP=2.D0*OMEGA*TPIBA
      DO IG=1,NHG
        RHETS=DCONJG(PSI(NZH(IG)))
        GX=DCMPLX(0.D0,GK(1,IG))
        GY=DCMPLX(0.D0,GK(2,IG))
        GZ=DCMPLX(0.D0,GK(3,IG))
        VCGS=SCG(IG)*RHETS
        ISA=0
        DO IS=1,NSP
          TXX=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GX
          TYY=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GY
          TZZ=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GZ
          DO IA=1,NA(IS)
            ISA=ISA+1
            IF(BIGMEM) THEN
              EI123=EIGRB(IG,ISA)
            ELSE
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                  EI3(ISA,INYH(3,IG))
            ENDIF
            FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*TXX)*OMTP
            FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*TYY)*OMTP
            FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*TZZ)*OMTP
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
