C     ==================================================================
      SUBROUTINE TD_LANCZOS(C0,C1,C2,SC0,DDXC,PSI,EIGV,DRHOE,
     &                  TEIG,SCR,LSCR,NSTATE,NROOT,ORBITAL)
C     ==--------------------------------------------------------------==
C     ==               Lanczos diagonalization of TD Matrix           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,NROOT
      COMPLEX*16 C0(NGW,*),C1(NGW,NSTATE,*),C2(NGW,*),SC0(*)
      COMPLEX*16 PSI(*)
      REAL*8     EIGV(*),SCR(*),DRHOE(*),DDXC(*),TEIG(*)
      CHARACTER*(*) ORBITAL
C     Variables
      DIMENSION F(*)
      CHARACTER*30 TAG
      INTEGER    LTD_LAN,NLSTEP,ISTEP,INFO,LDZ,I
      POINTER    (IP_CV,CV),(IP_CW,CW),(IP_CT,CT)
      COMPLEX*16 CV(NGW,NSTATE),CW(NGW,NSTATE),CT(NGW,NSTATE)
      POINTER    (IP_AMAT,AMAT),(IP_BMAT,BMAT),(IP_ZMAT,ZMAT)
      POINTER    (IP_DMAT,DMAT),(IP_SMAT,SMAT)
      POINTER    (IP_WORK,WORK)
      REAL*8     AMAT(*),BMAT(*),ZMAT(*),WORK(*),OB,SO,DOTPS,E2(5),B2
      EXTERNAL   DOTPS
      REAL*8     DMAT(*),SMAT(*),SDD
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_TD_LAN(LTD_LAN,TAG)
      CALL TEST_SCR('TD_LAN',TAG,LSCR,LTD_LAN)
C     ==--------------------------------------------------------------==
      NLSTEP=80
      CALL MEMORY(IP_CV,2*NGW*NSTATE,'CV')
      CALL MEMORY(IP_CW,2*NGW*NSTATE,'CW')
      CALL MEMORY(IP_CT,2*NGW*NSTATE,'CT')
      CALL MEMORY(IP_AMAT,NLSTEP,'AMAT')
      CALL MEMORY(IP_BMAT,NLSTEP,'BMAT')
      CALL MEMORY(IP_DMAT,NLSTEP,'DMAT')
      CALL MEMORY(IP_SMAT,NLSTEP,'SMAT')
      CALL MEMORY(IP_ZMAT,NLSTEP*NLSTEP,'ZMAT')
      CALL MEMORY(IP_WORK,2*NLSTEP,'WORK')
      LDZ=NLSTEP
C     ==--------------------------------------------------------------==
C..initilize vectors
      CALL DCOPY(2*NGW*NSTATE,C1,1,CW,1)
      CALL LR_ORTHO(NSTATE,C0,CW,SCR,LSCR)
      SO=DOTPS(NGW,NSTATE,CW,CW)
      CALL GLOSUM(1,SO)
      OB=1.D0/DSQRT(SO)
      CALL DSCAL(2*NGW*NSTATE,OB,CW,1)
      CALL AZZERO(CV,2*NGW*NSTATE)
      DO ISTEP=1,NLSTEP
        IF(ISTEP.NE.1) THEN
          CALL DCOPY(2*NGW*NSTATE,CW,1,CT,1)
          CALL DCOPY(2*NGW*NSTATE,CV,1,CW,1)
          OB=1.D0/BMAT(ISTEP-1)
          CALL DSCAL(2*NGW*NSTATE,OB,CW,1)
          CALL DCOPY(2*NGW*NSTATE,CT,1,CV,1)
          CALL DSCAL(2*NGW*NSTATE,-BMAT(ISTEP-1),CV,1)
        ENDIF
        CALL LR_FORCE(C0,CW,CT,SC0,E2,DDXC,PSI,DRHOE,EIGV,
     &                SCR,LSCR,NSTATE,"TDDFT",ORBITAL)
        CALL LR_ORTHO(NSTATE,C0,CT,SCR,LSCR)
        SDD=1.0D0
        CALL DAXPY(2*NGW*NSTATE,-SDD,CT,1,CV,1)
        SO=DOTPS(NGW,NSTATE,CW,CV)
        CALL GLOSUM(1,SO)
        AMAT(ISTEP)=SO
        CALL DAXPY(2*NGW*NSTATE,-SO,CW,1,CV,1)
        CALL LR_ORTHO(NSTATE,C0,CV,SCR,LSCR)
        SO=DOTPS(NGW,NSTATE,CV,CV)
        CALL GLOSUM(1,SO)
        BMAT(ISTEP)=SQRT(SO)
        IF(PARENT) THEN
          CALL DCOPY(ISTEP,AMAT,1,DMAT,1)
          CALL DCOPY(ISTEP,BMAT,1,SMAT,1)
          INFO=0
          CALL DSTEV('V',ISTEP,DMAT,SMAT,ZMAT,LDZ,WORK,INFO)
          IF(INFO.NE.0) THEN
            WRITE(6,*) ' TD_LANCZOS|DSTEV INFO=',INFO
            CALL STOPGM('TD_LANCZOS','DSTEV')
          ENDIF
          B2=(BMAT(ISTEP)*ZMAT(ISTEP))**2
          IF(PARENT) THEN
            WRITE(6,'(I4,5X,F20.8,E20.10)') ISTEP,DMAT(1)*RY*2.D0,B2
          ENDIF
        ELSE
          B2=0.D0
        ENDIF
        CALL GLOSUM(1,B2)
        IF(B2.LT.1.D-8) GOTO 100
      ENDDO
  100 CONTINUE
      IF(PARENT) THEN
      TEIG(1)=DMAT(1)
      ENDIF
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_CV)
      CALL FREEM(IP_CW)
      CALL FREEM(IP_CT)
      CALL FREEM(IP_AMAT)
      CALL FREEM(IP_BMAT)
      CALL FREEM(IP_DMAT)
      CALL FREEM(IP_SMAT)
      CALL FREEM(IP_ZMAT)
      CALL FREEM(IP_WORK)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_TD_LAN(LTD_LAN,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER      LTD_LAN
      CHARACTER*30 TAG
C     Variables
      INTEGER LLR_FORCE,LLR_ORTHO
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_LR_FORCE(LLR_FORCE,"TDDFT",TAG)
      CALL GIVE_SCR_LR_ORTHO(LLR_ORTHO,N,TAG)
      LTD_LAN=MAX(LLR_FORCE,LLR_ORTHO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
