C     ==================================================================
      SUBROUTINE VCOUPLINGS(C0,C1,C2,SC0,RHOE,EIGV,EIGO,
     &                      N,NO,NVIR,NACT,NROOT,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc' !NAT
      INCLUDE 'coor.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'spin.inc'
C
C     Arguments
      INTEGER  N,NO,NVIR,NACT,NROOT,LSCR
      REAL*8   RHOE(*),SCR(*),EIGV(*),EIGO(*)
      COMPLEX*16 C0(NGW,*),C1(NGW,NACT,*),C2(NGW,*),SC0(*)
C     Variables
      CHARACTER  TAG*30
      LOGICAL TTRINV
      INTEGER NDIM,IROOT,I,J,K,NC,IA,IC,IAA,IS
      REAL*8  VCLOCA(3,NAX,NSX,100),VCLOCB(3,NAX,NSX,100),
     &        SDER(3*NAT,*),VIBE(3*NAT)
      POINTER (IP_VCLOCA,VCLOCA),(IP_VCLOCB,VCLOCB),
     &        (IP_SDER,SDER),(IP_VIBE,VIBE)
C
      CALL MEMORY(IP_VCLOCA,3*NAX*NSX*100,'VCLOCA')
      IF (TLSD) THEN
       CALL MEMORY(IP_VCLOCB,3*NAX*NSX*100,'VCLOCB')
      ELSE
       CALL MEMORY(IP_VCLOCB,2,'VCLOCB')
      ENDIF
      CALL MEMORY(IP_VIBE,3*NAT*NSP*NROOT*NROOT,'VIBE')
      CALL MEMORY(IP_SDER,3*NAT*NSP*NROOT*NROOT,'SDER')
C
C     ----------------------------------------------------------------
      TTRINV=.TRUE.
C     ----------------------------------------------------------------
      CALL AZZERO(VCLOCA,3*NAX*NSX*100)
      IF (TLSD) CALL AZZERO(VCLOCB,3*NAX*NSX*100)
C     ----------------------------------------------------------------
      CALL VCOUPLINGS_LR(C0,C1,C2,EIGV,EIGO,SC0,VCLOCA,VCLOCB,
     &                     NACT,N,NO,NROOT,RHOE,SCR,LSCR)
C     ----------------------------------------------------------------
C     WRITE OUTPUT FILE FOR MOLEKEL
      NDIM=3*NAT
      CALL AZZERO(SDER,3*NAT*NSP*NROOT*NROOT)
      CALL AZZERO(VIBE,3*NAT*NSP*NROOT*NROOT)
C     REFINE THE NACS
      IF (PARENT) WRITE(6,'(" ==",60("-"),"==")')
      IF (TTRINV)THEN
       CALL NACSTRANS(VCLOCA,VCLOCB,NROOT)
      ENDIF
C     J is the index that runs over the set of NACs.
C     it starts with 4 for FORMAT reasons. Next set will be 5
      DO IROOT=1,NINT((NROOT*(NROOT+1.D0))/2.D0)
       J=4+(IROOT-1)
       NC=1
C      NC is the number of non-adiabatic couplings pairs
C      computed between couple of states
       DO IC=1,NC
        IA=0
        DO IS=1,NSP
           DO IAA=1,NA(IS)
            DO K=1,3
             SDER(K+IA,J)=1.0*VCLOCA(K,IAA,IS,IROOT)
            ENDDO
           IA=IA+3
          ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL WRITENACS(VIBE,SDER,NDIM,TAU0,NROOT,0)
      IF (TLSD) THEN
        DO IROOT=1,NINT((NROOT*(NROOT+1.D0))/2.D0)
         J=4+(IROOT-1)
         NC=1
C        NC is the number of non-adiabatic couplings pairs
C        computed between couple of states
         DO IC=1,NC
          IA=0
          DO IS=1,NSP
           DO IAA=1,NA(IS)
            DO K=1,3
             SDER(K+IA,J)=1.0*VCLOCB(K,IAA,IS,IROOT)
            ENDDO
            IA=IA+3
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       CALL WRITENACS(VIBE,SDER,NDIM,TAU0,NROOT,1)
      ENDIF
      CALL MEMORY_CHECK
C
      CALL FREEM(IP_SDER)
      CALL FREEM(IP_VIBE)
      CALL FREEM(IP_VCLOCA)
      CALL FREEM(IP_VCLOCB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_VCOUPLING(LCPLNGS,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG
      INCLUDE 'elct.inc'        !N
      INCLUDE 'spin.inc'        !NLSD
      INCLUDE 'cplngs.inc'      !TCPLFD,TCPLLR,TALLDOF,NSURF
      INCLUDE 'ions.inc'        !NAT
      INCLUDE 'nlps.inc'        !NDFNL
      INCLUDE 'linres.inc'      !TXC_ANALYTIC,LOPTI
      INCLUDE 'irat.inc'        !IRAT
C     Arguments
      INTEGER   LCPLNGS, LCPLSUB, LDDXC, LDFNL, LDONE, LEIROP, LEIVPS,
     $          LFCSRF, LH1NL, LPSI, LRHOE, LVECT
      INTEGER  LFORCEDR,LGET_EIND, LRNLSM, LSYMVEC, LRHOOFR,
     $         LRNLSM_2D, LNL_RES, LOPT_LR, LSUMMAT, LV1OFRHO1, NSTATE

      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      TAG     = 'VCOUPLING'
      LEIVPS = 2*NHG
      LEIROP = 2*NHG
      LDFNL  = 6*NAT*NHXS*NDFNL
      LH1NL  = 2*NGWK*N
      LDDXC = NNR1*(2*NLSD-1)
      CALL RHOE_PSI_SIZE(LRHOE, LPSI)
      LVECT = 3*NAT*NVECT
      LDONE = 3*NAT/IRAT
      LCPLNGS = 2*LEIVPS + 2*LEIROP + LDFNL + LH1NL + 2*LRHOE +
     $          LDDXC + NSURF + LVECT
      LCPLNGS = LCPLNGS + LDONE + NSURF
C
      NSTATE=N
      CALL GIVE_SCR_FORCEDR (LFORCEDR,TAG,NSTATE,.FALSE.,.FALSE.)
      CALL GIVE_SCR_RNLSM(LRNLSM,TAG,NSTATE,.TRUE.)
      CALL GIVE_SCR_SYMVEC(LSYMVEC,TAG)
      LCPLSUB=MAX(LFORCEDR,LRNLSM,LSYMVEC)
      CALL GIVE_SCR_RHOOFR(LRHOOFR,TAG)
      CALL GIVE_SCR_V1OFRHO1(LV1OFRHO1,TAG)
      CALL GIVE_SCR_RNLSM_2D(LRNLSM_2D,TAG,NSTATE)
      CALL GIVE_SCR_NL_RES(LNL_RES,NSTATE,TAG)
      CALL GIVE_SCR_OPT_LR(LOPT_LR,"PHONON",TAG)
      CALL GIVE_SCR_GET_EIND(LGET_EIND,TAG)
      LCPLSUB=MAX(LCPLSUB,LRHOOFR,LRNLSM_2D,LNL_RES,LOPT_LR,
     $                  LGET_EIND,LSUMMAT,LV1OFRHO1)

      LCPLNGS=LCPLNGS+LCPLSUB+100
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VCOUPLINGS_LR(C0,CLRTD,CR,EIGV,EIGO,SC0,VCLOCA,VCLOCB,
     &                         NACT,NSTATE,NO,NROOT,RHOE,SCR,LSCR)
C     ==--------------------------------------------------------------==
C     ==        ANALYTIC CALCULATION OF INTERSURFACE COUPLINGS        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'coor.inc' ! TAU0
      INCLUDE 'cppt.inc' ! NZH
      INCLUDE 'ropt.inc' ! SPCG,IESR
      INCLUDE 'sfac.inc' ! DDFNL
      INCLUDE 'nlps.inc' ! NDFNL
      INCLUDE 'spin.inc' ! NLSD,NSUP
      INCLUDE 'elct.inc' ! F
      INCLUDE 'poin.inc' ! RHOO, POTR
      INCLUDE 'irat.inc'
      INCLUDE 'linres.inc'
      INCLUDE 'cplngs.inc'
      include 'ener.inc'
      include 'symm.inc'
C     Arguments
      INTEGER    NSTATE, NO, LSCR, NACT, NROOT
      REAL*8     VCLOCA(3,NAX,NSX,100),
     &           VCLOCB(3,NAX,NSX,100),
     $           RHOE(NNR1),SCR(LSCR),EIGV(*),EIGO(*)
      COMPLEX*16 C0(NGWK,*), CLRTD(NGW,NACT,*),
     $           CR(*),SC0(*)
C     Variables
      CHARACTER  TAG*30,TYPE*10,ORBTYP*5
      LOGICAL    DEBUG,LCONV,LPRINT,LPRINT2,TFDENS,DODIRECT,DOLINRES,
     $           RELAXRHOE
      INTEGER    I,IA,IACT,IAT,IC,ICI,ICC,ID,IG,IMAX,IR,IS1,IS2,ISP,NN,
     $           ISUB,IV,IVV,K,KMAX,LOPTIB,NOLRB,
     $           LCPLNGS, LDDXC, LDFNL, LDONE, LEIVPS, LEIROP, LH1NL,
     $           LPSI, LRHOE, LSCR2, LVECT, NATOMS, N3
      INTEGER    IDONE(*),NAP,NBP,NVPP,NCSCR
      REAL*8     C, DASUM, DDOT, DEINV, DEINVV(*), E2(5), EEXC, EGND,
     $           EIND, FC, FCOMP, FCOMP2, FCSUM, RLEN, RMAX,
     $           TOL_LR_BAK, TRACE, VP, VPP(*),FCOMPA,FCOMPB
      REAL*8     DDXC(*), DFNL(*), DRHOE(NNR1,NLSD),
     $           FCSRF(NROOT),FNL(*),RHOOV(*),TAUC(3,NAX,NSX),
     $           SCR2(*), V(3),VC(3),VECT(3,NAT,NVECT),EIGT(*),
     $           EIGS(*)
      DIMENSION  F(*)
      COMPLEX*16 EIVPS(NHG), EIROP(NHG), EIVPS1(NHG), EIROP1(NHG),
     $           H1NL(*),C1(NGWK,*),C2(NGWK,*),PSI(*),CSCR(*)
      POINTER    (IP_EIVPS,EIVPS),(IP_EIROP,EIROP),(IP_IDONE,IDONE),
     $           (IP_EIVPS1,EIVPS1),(IP_EIROP1,EIROP1),(IP_EIGT,EIGT),
     $           (IP_EIGS,EIGS),
     $           (IP_H1NL,H1NL),(IP_DDXC,DDXC),(IP_DEINVV,DEINVV),
     $           (IP_RHOOV,RHOOV),(IP_DRHOE,DRHOE),(IP_VECT,VECT),
     $           (IP_FCSRF,FCSRF),(IP_SCR2,SCR2),(IP_C1,C1),(IP_C2,C2),
     $           (IP_PSI,PSI),(IP_VPP,VPP),(IP_CSCR,CSCR),(IP_TAUC,TAUC)
      REAL*8     DOTP,WK(1)
      REAL*8     FNLC(IMAGP,NAT,NHXS,NO,NKPNT),
     $           DFNLC(IMAGP,NAT,NHXS,3,NDFNL,NKPNT)
      POINTER    (IP_FNLC,FNLC),(IP_DFNLC,DFNLC)
C
C     ==--------------------------------------------------------------==
      TSYMRHO=.FALSE.
      TALLDOF=.TRUE.
      TALLAT=.TRUE.
      NVECT=10
      NROT=1
      DODIRECT=.TRUE.
      DOLINRES=.TRUE.
      RELAXRHOE=.FALSE.
      LOPTI=3    ! DIIS
C     LOPTI=2    ! PCG

      DEBUG = .FALSE.
      if (parent.and.debug) then
        write(6,*) 'NACT,NSTATE,NO,NROOT'
        write(6,*)  NACT,NSTATE,NO,NROOT
      endif
C     ----------------------------------------------------------------==
C     ------  WORKING AREA ---------------------------------------------
CC    VIBRAT=.TRUE.
CC    TSDIN=.FALSE.
CC    TSDAN=.TRUE.
CC    NVIB=1
CC    DLRS=0.1D0
CC    LOPTI=2    ! PCG
C     ------  WORKING AREA ---------------------------------------------
C     ----------------------------------------------------------------==
      IF (TLSD) THEN
       NAP=NSUP-NUPEL
       NBP=NSDOWN-NDOEL
      ENDIF
      IF(TSDE) THEN
        NVPP = 1
      ELSE IF(DIIS) THEN
        NVPP = NGW
      ELSE IF(PCG) THEN
        NVPP = NGW
      ENDIF
      NCSCR=2*NGW*MAX(N,NKRY_MAX*NKRY_BLOCK)
C     ==--------------------------------------------------------------==
      LPRINT  = .TRUE.          ! Progress report
      LPRINT2 = .FALSE.         ! Diagnostics
      LPRINT  = (LPRINT  .AND. PARENT)
      LPRINT2 = (LPRINT2 .AND. PARENT)
      CALL TISET ('   LRCPLNG',ISUB)
C     SCR partition - space for subroutines called by LRCPLNG
      CALL GIVE_SCR_CPLNGS (LCPLNGS, TAG)
      CALL TEST_SCR ('LRCPLNG', TAG, LSCR, LCPLNGS)
C     For linear response - space for locally stored arrays
      LEIVPS = 2*NHG
      LEIROP = 2*NHG
      LDFNL  = 6*NAT*NHXS*NDFNL
      LH1NL  = 2*NGWK*NSTATE
      IF (TXC_ANALYTIC) THEN
         LDDXC = NNR1*(2*NLSD-1)
      ELSEIF (LOPTI.EQ.0 .OR. LOPTI.EQ.2) THEN
         LDDXC = NNR1*(2*NLSD-1)
      ELSE
         LDDXC = 1
      END IF
      CALL RHOE_PSI_SIZE(LRHOE,LPSI)
      IF (TALLDOF) THEN
        LVECT = 3*NAT
      ELSE
        LVECT = 3*NAT*NVECT
      END IF
      LDONE = 3*NAT/IRAT+1

      CALL SCRSET (SCR, LSCR, DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_EIVPS,  LEIVPS, 'EIVPS',  DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_EIROP,  LEIROP, 'EIROP',  DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_EIVPS1, LEIVPS, 'EIVPS1', DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_EIROP1, LEIROP, 'EIROP1', DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_DDFNL,  LDFNL,  'DDFNL',  DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_H1NL,   LH1NL,  'H1NL',   DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_POTR,   LRHOE,  'POTR',   DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_RHOOV,  LRHOE,  'RHOOV',  DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_DDXC,   LDDXC,  'DDXC',   DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_DEINVV, NROOT,  'DEINVV', DEBUG)
      CALL SCRPTR (SCR, LSCR, IP_VECT,   LVECT,  'VECT',   DEBUG)
      IF (.NOT.TALLDOF) THEN
        CALL SCRPTR (SCR, LSCR, IP_IDONE,  LDONE,  'IDONE',  DEBUG)
        CALL SCRPTR (SCR, LSCR, IP_FCSRF,  NROOT,  'FCSRF',  DEBUG)
      END IF
      CALL SCRGET (SCR,LSCR,IP_SCR2,LSCR2,'SCR2',DEBUG)
      CALL GET_ADDR(IP_DRHOE,RHOE(1))
      CALL MEMORY(IP_C1,2*NGWK*NSTATE,'C1')
      CALL MEMORY(IP_C2,2*NGWK*NSTATE,'C2')
      CALL MEMORY(IP_PSI,LPSI,'PSI')
      CALL MEMORY(IP_VPP,NVPP,'VPP')
      CALL MEMORY(IP_CSCR,NCSCR,'CSCR')
      CALL MEMORY(IP_TAUC,3*NAX*NSX,'TAUC')
      CALL MEMORY(IP_EIGT,NSTATE,'EIGT')
      CALL MEMORY(IP_EIGS,NSTATE,'EIGS')
      CALL MEMORY(IP_FNLC,IMAGP*NAT*NHXS*NSTATE*NKPNT,'FNLC')
      CALL MEMORY(IP_DFNLC,IMAGP*NAT*NHXS*3*NDFNL*NKPNT,'DFNLC')
C     IF (TSPECV) CALL CPLRDVEC (VECT, NAT, NVECT, TFDENS)
C     WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
      NN=NO     
C     WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
C
      CALL ZAZZERO(C2,NGW*NSTATE)
C     ==--------------------------------------------------------------==
      CALL AZZERO(EIGT,NSTATE)
C     EIGV ARE TAKEN FROM THE ARGUMENTS: TDDFT values 
      CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGT,
     $             SCR2,LSCR2,NN,1,.FALSE.,.TRUE.)
      CALL CANON(C0,C2,F,NN,EIGT,SCR2,LSCR2)
      ORBTYP="CANON"
C     recalculate FNL and DFNL for transformed orbitals.
C     One could also rotate the old ones, but this is easier...
      CALL RNLSM(C0,NN,PSI,SCR2,LSCR2,1,1,.TRUE.)
      CALL DCOPY(NNR1*NLSD,RHOE,1,POTR,1)
C     RHOE must be computed using RELAXRHO for TDDFT
      CALL RHOOFR(C0,RHOE,PSI,SCR2,LSCR2,NN)
      CALL DCOPY(NNR1*NLSD,RHOE,1,RHOO,1)

C     ==--------------------------------------------------------------==
C     == direct term (explicit derivative term)                        ==
C     ==--------------------------------------------------------------==
      IF (DODIRECT) THEN
       ICI=0
       DO IC = 0,NROOT
        DO ICC = IC+1, NROOT
         ICI=ICI+1
         DO ID=1,NN
          IS1=ID
          IF (TLSD) THEN
           IF (IS1.LE.NUPEL) THEN
            IS2=IS1
           ELSE
            IS2=NAP+IS1
           ENDIF
          ELSE
           IS2=IS1
          ENDIF
          CALL AZZERO(RHOOV,NNR1)
          CALL AZZERO(PSI,2*MAXFFT*NOGRP)
          IF (IC.EQ.0) THEN
           CALL RHOABOFR(1,C0(1,IS1),CLRTD(1,IS2,ICC),RHOOV,PSI)
          ELSE
           CALL RHOABOFR(1,CLRTD(1,IS1,IC),CLRTD(1,IS2,ICC),RHOOV,PSI)
          ENDIF
C         Transform density to G space
!$OMP parallel do private(IR)
          DO IR = 1,NNR1
             PSI(IR)=DCMPLX(RHOOV(IR),0.D0)
          END DO
          CALL FWFFT(PSI)
          IF (TLSD) THEN
           IF (IS1.LE.NUPEL) THEN
            CALL TDRHOFC(VCLOCA(1,1,1,ICI),RHOOV,PSI)
           ELSE
            CALL TDRHOFC(VCLOCB(1,1,1,ICI),RHOOV,PSI)
           ENDIF
          ELSE
           CALL TDRHOFC(VCLOCA(1,1,1,ICI),RHOOV,PSI)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
C      NACS contribution from the nonlocal PP
       ICI=0
       DO IC=0,NROOT
        DO ICC = IC+1, NROOT
         ICI=ICI+1
         CALL RNLSM1(CLRTD(1,1,ICC),NN,SCR2,LSCR2,1)
         CALL RNLSM2(CLRTD(1,1,ICC),SCR2,LSCR2,NN,1,1)
         CALL DCOPY(IMAGP*NAT*NHXS*NN*NKPNT,FNL,1,FNLC,1)
         CALL DCOPY(IMAGP*NAT*NHXS*3*NDFNL*NKPNT,DFNL,1,DFNLC,1)
         IF (IC.EQ.0) THEN
          CALL RNLSM1(C0,NN,SCR2,LSCR2,1)
          CALL RNLSM2(C0,SCR2,LSCR2,NN,1,1)
         ELSE
          CALL RNLSM1(CLRTD(1,1,IC),NN,SCR2,LSCR2,1)
          CALL RNLSM2(CLRTD(1,1,IC),SCR2,LSCR2,NN,1,1)
         ENDIF
         CALL DRHOPP(VCLOCA,VCLOCB,FNLC,DFNLC,NN,NAP,ICI)
        ENDDO
       ENDDO
C
       ICI=0
       DO IC=0,NROOT
        DO ICC = IC+1, NROOT
         ICI=ICI+1
         IF (IC.EQ.0) THEN
          DEINV=1.D0/EIGO(ICC)
         ELSE
          DEINV=1.D0/(EIGO(ICC)-EIGO(IC))
         ENDIF
         CALL DSCAL(3*NAX*NSX,-DEINV,VCLOCA(1,1,1,ICI),1)
         IF (TLSD) THEN
           CALL DSCAL(3*NAX*NSX,-DEINV,VCLOCB(1,1,1,ICI),1)
         ENDIF
        ENDDO
       ENDDO

       CALL GLOSUM(3*NAX*NSX*100,VCLOCA)
       IF (TLSD) CALL GLOSUM(3*NAX*NSX*100,VCLOCB)
      ENDIF
C     ==--------------------------------------------------------------==
C     ==  Linear response for dependence of KS operator on density    ==
C     ==--------------------------------------------------------------==
      IF (DOLINRES) THEN
C      Recalculate density, but re-use POTR, FNL, DFNL, EIVPS, and EIROP
C      IF recalculate FNL, DFNL, EIVPS, and EIROP THEN do next call
       CALL DCOPY(NNR1*NLSD,RHOE,1,POTR,1)
C      RHOE must be computed using RELAXRHO for TDDFT
       CALL RHOOFR(C0,RHOE,PSI,SCR2,LSCR2,NN)
       CALL DCOPY(NNR1*NLSD,RHOE,1,RHOO,1)
       IF (RELAXRHOE) THEN
         LOPTIB=LOPTI
         LOPTI=LOPTIB-10
         NOLRB=NOLR
         NOLR=NACT
         CALL TD_FORCE(C0,CLRTD,CR,SC0,EIGV,RHOE,PSI,EIGS,
     &        NO,NROOT,TAU0,FION,'CANON',.FALSE.)
         CALL RELAX_RHO(C0,CLRTD,CR,SC0,RHOO,RHOE,PSI,NO,NROOT)
         LOPTI=LOPTIB
         NOLR=NOLRB
         CALL DCOPY(NNR1*NLSD,RHOE,1,RHOO,1)
       ENDIF
C      Non-local pseudopotential, calculate DDFNL - allocated above
       CALL RNLSM_2D(C0,SCR2,LSCR2,NN)
C      Save FNL
       CALL FNL_SET("SAVE")
       CALL FNLALLOC(NN,.TRUE.,.FALSE.)
C      Local pseudopotential, use structure factors calculated before
       CALL EICALC(EIVPS,EIROP)
C      Calculate and store analytic dmu/dn
       CALL LR_XCPOT(DDXC,RHOO,SCR2,LSCR2,.FALSE.)
C      Preconditioning for LR optimization - cf. SDLINRES
       PREC=.TRUE.
       CALL KSDIAG(VPP)
       TRACE=DASUM(NN,EIGT,1)/DBLE(NN)
!$OMP parallel do private(IG,VP)
       DO IG=1,NGW
         VP=VPP(IG)+TRACE
         VPP(IG)=ABS(VP/(VP**2+LR_HTHRS**2))
       ENDDO
C      ==-------------------------------------------------------------==
C      ==  Unit vector along constant density coupling vector         ==
C      ==  Result in TAUC and then VECT                               ==
C      ==-------------------------------------------------------------==
       GOTO 1234
       CALL CPLCONFIG(VCLOCA,TAUC)
       RLEN=0.0D0
       IAT=0
       DO ISP=1,NSP
        DO IA=1,NA(ISP)
          IAT=IAT + 1
          IF (TFDENS.OR..NOT.TSPECV) THEN
            DO K=1,3
              VECT(K,IAT,1)=TAUC(K,IA,ISP)
              RLEN=RLEN+VECT(K,IAT,1)**2
            ENDDO
          ENDIF
        ENDDO              ! IA = 1,NA(ISP)
       ENDDO                ! ISP = 1,NSP
       NATOMS=IAT
       N3    =3*NATOMS
       IF (TFDENS.OR..NOT.TSPECV) THEN
        RLEN=1.0D0/SQRT(RLEN)
        DO IAT=1,NATOMS
          VECT(1,IAT,1)=RLEN*VECT(1,IAT,1)
          VECT(2,IAT,1)=RLEN*VECT(2,IAT,1)
          VECT(3,IAT,1)=RLEN*VECT(3,IAT,1)
        ENDDO
       ENDIF
 1234  CONTINUE
C     ==--------------------------------------------------------------==
C     ==  Brute-force loop over all DOF of ions                       ==
C     ==--------------------------------------------------------------==
       CALL ZAZZERO(C1,NGW*NSTATE)
C
       IF (TALLDOF) THEN
C      WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
       NN=NO     
C      WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
C
C     ==  Main finite difference loop over the dimensions             ==
C
        NROT=1
        IAT = 0
        DO ISP = 1,NSP
          DO IA = 1,NA(ISP)
            IAT = IAT + 1
            DO K = 1,3
             IF (LPRINT) WRITE(6,'(A,3I3)')
     &                ' TYPE, ATOM, DIMENSION: ', ISP, IA, K
C
C     ==  Linear response of nuclear displacement                     ==
C
C            The following lines stem from SDLINRES
             EIND=0.0D0
             CALL EIND_II(TAU0,ISP,IAT,K,EIND,IESR)
             CALL EIND_LOC(EIND,ISP,IAT,K,RHOO,PSI,EIROP)
C            Calculate constant force from NL-PP
             CALL FNL_SET("SWITCH")
             CALL NL_RES(ISP,IAT,K,H1NL,NN,SCR2,LSCR2)
             CALL EIND_NL(EIND,ISP,IAT,K,NN)
             CALL FNL_SET("SWITCH")
C            Calculate the constant part of the local potential
             CALL EICALC1(K,ISP,IAT,EIVPS1,EIROP1)
C            Calculate first-order wavefunction
             SDIIS=.TRUE.
             SPCG=.TRUE.
             CALL OPT_LR(C0,C1,C2,SC0,EIND,EIGV,DRHOE,
     &                    H1NL,EIVPS1,EIROP1,DDXC,VPP,CSCR,CR,
     &                    PSI,SCR2,LSCR2,NN,"PHONON",ORBTYP)
C            End SDLINRES - calculate first order density
             CALL RHO1OFR(C0,C1,F,DRHOE,PSI,NN)
C            Hartree and XC first-order terms
             CALL V1OFRHO1(E2,DRHOE,DDXC,PSI,SCR2,LSCR2)
C             CALL DSCAL(NNR1,-1.0d0,DRHOE(1,1),1)
C             IF(TLSD) CALL DSCAL(NNR1,-1.0d0,DRHOE(1,2),1)
C              CALL AZZERO(C2,2*NGWK*N)
C              CALL VPSIMT(C0,C2,F,DRHOE,PSI,NN,NLSD,.TRUE.)
             CALL PRINT_EX_RHO(DRHOE,PSI,TAU0)
C            Coupling component for each pair of surfaces
C            IC=0 is the GS surface
             ICI=0
             DO IC=0,NROOT
              DO ICC=IC+1,NROOT
               ICI=ICI+1
C              if (parent) write(6,*)'omega ', ICI,EIGO(ICI)
               DO ID=1,NN
                IS1=ID
                IF (TLSD) THEN
                 IF (IS1.LE.NUPEL) THEN
                  IS2=IS1
                 ELSE
                  IS2=NAP+IS1
                 ENDIF
                ELSE
                  IS2=IS1
                ENDIF
                CALL AZZERO(RHOOV,NNR1)
                IF (IC.EQ.0) THEN
                  CALL RHOABOFR(1,C0(1,IS1),CLRTD(1,IS2,ICC),RHOOV,PSI)
                  DEINV = 1.D0/EIGO(ICC)
                ELSE
                  CALL RHOABOFR(1,CLRTD(1,IS1,IC),CLRTD(1,IS2,ICC),
     &                          RHOOV,PSI)
C                 CALL RHOABOFR(1,C0(1,IS1),C0(1,IS2),RHOOV,PSI)
                  DEINV = 1.D0/(EIGO(ICC)-EIGO(IC))
                END IF
C   --------------------------------------------------------------------
                IF (DEBUG.AND.IC.GT.0) THEN
                  if(parent) write(6,*) '------------'
                  if(parent) write(6,*) "NUPEL,NAP,NLSD"
                  if(parent) write(6,*)  NUPEL,NAP,NLSD
                  if(parent) write(6,*) 'NN,IC,ID,IS1,IS2'
                  if(parent) write(6,*)  NN,IC,ID,IS1,IS2
                  if(parent) write(6,*) '------------'
                  FCOMPA=DOTP(NGW,CLRTD(1,IS2,IC),CLRTD(1,IS2,IC))
                  CALL GLOSUM(1,FCOMPA)
                  if(parent)write(6,*)'module CLRTD',IS2
                  if(parent)write(6,*)'module CLRTD',FCOMPA
                  FCOMPA=DOTP(NGW,C0(1,IS1),CLRTD(1,IS2,IC))
                  CALL GLOSUM(1,FCOMPA)
                  if(parent)write(6,*) 'scalar product C0 CLRTD',IS1,IS2
                  if(parent)write(6,*) 'scalar product C0 CLRTD',FCOMPA
                  FCOMPA=0.D0
!$OMP parallel do private(IR) reduction(+:FCOMPA) schedule(static)
                  DO IR=1,NNR1
                    FCOMPA=FCOMPA+RHOOV(IR)
                  ENDDO
                  FCOMPA=FCOMPA*OMEGA/(NR1S*NR2S*NR3S)
                  CALL GLOSUM(1,FCOMPA)
                  if(parent)write(6,*) 'int RHOOV',FCOMPA
                  FCOMPA=0.D0
!$OMP parallel do private(IR) reduction(+:FCOMPA) schedule(static)
                  DO IR=1,NNR1
                    FCOMPA=FCOMPA+RHOOV(IR)**2
                  ENDDO
                  FCOMPA=FCOMPA*OMEGA/(NR1S*NR2S*NR3S)
                  CALL GLOSUM(1,FCOMPA)
                  if(parent)write(6,*) 'int RHOOV2',FCOMPA

                  FCOMPA=0.D0
!$OMP parallel do private(IR) reduction(+:FCOMPA) schedule(static)
                  DO IR=1,NNR1
                    FCOMPA=FCOMPA+DRHOE(IR,1)
                  ENDDO
                  FCOMPA=FCOMPA*OMEGA/(NR1S*NR2S*NR3S)
                  CALL GLOSUM(1,FCOMPA)
                  if(parent)write(6,*) 'int DPOTalpha',FCOMPA
                  FCOMPA=0.D0
!$OMP parallel do private(IR) reduction(+:FCOMPA) schedule(static)
                  DO IR=1,NNR1
                    FCOMPA=FCOMPA+DRHOE(IR,2)
                  ENDDO
                  FCOMPA=FCOMPA*OMEGA/(NR1S*NR2S*NR3S)
                  CALL GLOSUM(1,FCOMPA)
                  if(parent)write(6,*) 'int DPOTbeta',FCOMPA
                ENDIF
C   --------------------------------------------------------------------
                IF (TLSE) THEN
                  FCOMPA=0.5D0*(
     $                   DDOT(NNR1,RHOOV,1,DRHOE(1,2),1) +
     $                   DDOT(NNR1,RHOOV,1,DRHOE(1,3),1))
                  FCOMPA=(FCOMPA*OMEGA/DBLE(NR1S*NR2S*NR3S)) * DEINV
                  CALL GLOSUM (1, FCOMPA)
                ELSEIF (TLSD) THEN
                  IF (IS1.LE.NUPEL) THEN
C                  FCOMPA=DOTP(NGW,CLRTD(1,IS2,ICI),C2(1,IS1))
C                  FCOMPA=DOTP(NGW,C0(1,IS2),C2(1,IS1))/ EIGO(ICI)
                   FCOMPA=DDOT(NNR1,RHOOV,1,DRHOE(1,1),1)
                   FCOMPA=(FCOMPA*OMEGA/DBLE(NR1S*NR2S*NR3S)) * DEINV
                   CALL GLOSUM(1,FCOMPA)
                   FCOMPB=0.0D0
                  ELSE
C                  FCOMPB=DOTP(NGW,CLRTD(1,IS2,ICI),C2(1,IS1))
C                  FCOMPB=DOTP(NGW,C0(1,IS2),C2(1,IS1))/ EIGO(ICI)
                   FCOMPB=DDOT(NNR1,RHOOV,1,DRHOE(1,2),1)
                   FCOMPB=(FCOMPB*OMEGA/DBLE(NR1S*NR2S*NR3S)) * DEINV
                   CALL GLOSUM(1,FCOMPB)
                   FCOMPA=0.0D0
                  ENDIF
                ELSE
C                  FCOMPA=DOTP(NGW,CLRTD(1,IS2,ICI),C2(1,IS1))
C                  FCOMPA=FCOMPA / EIGO(ICI) ! * DEINV
                   FCOMPA=DDOT(NNR1,RHOOV,1,DRHOE(1,1),1)
                   FCOMPA=(FCOMPA*OMEGA/DBLE(NR1S*NR2S*NR3S)) * DEINV
                   CALL GLOSUM(1,FCOMPA)
                END IF


                IF (LPRINT.AND.PARENT) THEN
                 WRITE(6,'(A,2F12.5)') ' FIXED DENSITY AND RESPONSE: ',
     $                 VCLOCA(K,IA,ISP,ICI), FCOMPA
                 WRITE(6,'(A,F12.5)') ' TOTAL COUPLING:             ',
     $                 VCLOCA(K,IA,ISP,ICI) + FCOMPA
                END IF
                VCLOCA(K,IA,ISP,ICI)=VCLOCA(K,IA,ISP,ICI)+FCOMPA
                IF (TLSD) THEN 
                 VCLOCB(K,IA,ISP,ICI)=VCLOCB(K,IA,ISP,ICI)+FCOMPB
                ENDIF
C
C                FCOMP  = DOTP (NGW, C0(1,IS1), C1(1,IS2))
C                FCOMP2 = DOTP (NGW, C0(1,IS2), C1(1,IS1))
C                CALL GLOSUM (1, FCOMP)
C                CALL GLOSUM (1, FCOMP2)
C                IF (LPRINT) WRITE(6,'(A,2F12.5)')
C     $               'COUPLINGS FROM OVERLAP: ', FCOMP, FCOMP
               ENDDO
              ENDDO             ! ICC = IC+1,NROOT
             ENDDO              ! IC = 1,NROOT
             if (.false.) then
              do i=1,nstate
                 call azzero (rhoov,nnr1)
                 call rhoabofr (1,c0(1,i),c0(1,i),rhoov,psi)
                 fcomp=DDOT(NNR1,RHOOV,1,DRHOE(1,1),1)
                 call glosum (1,fcomp)
                 fcomp=fcomp*OMEGA/(NR1S*NR2S*NR3S)
                 if (parent) print *,'State ', i, ': ', fcomp
              enddo
             endif
            ENDDO                ! K = 1,3
 9          CONTINUE             ! jump here if atom is not interesting
          ENDDO                  ! IA = 1,NA(ISP)
        ENDDO                    ! ISP = 1,NSP
C     ==--------------------------------------------------------------==
C     ==  Iterative scheme for contributions of response of density   ==
C     ==--------------------------------------------------------------==
       ELSE                      ! IF (TALLDOF)
C
C     ==  Response of density along the direction at constant density ==
C
        IF (LPRINT) WRITE(6,'(A,A)') ' LINEAR RESPONSE ALONG ',
     $        'CONSTANT DENSITY COUPLING VECTOR'
        IV=1
C       Clear history of searched components
!$OMP parallel do private(K)
        DO K=1,3*NAT
          IDONE(K) = 0
        END DO
C
C     ==  Iterative search of the direction                           ==
C
 10     CONTINUE             ! DO ... UNTIL (IV.GE.NVECT .OR. LCONV)
          IF (LPRINT) THEN
            WRITE(6,'(A,I3,A)') ' VECTOR ', IV, ':'
            WRITE(6,'(2(2X,3F8.4))')
     $           ((VECT(K,IAT,IV), K=1,3), IAT=1,NATOMS)
          END IF
C         Calculate constant part of local and non-local interactions
          CALL GET_EIND (VECT(1,1,IV), EIND, EIVPS1, EIROP1, H1NL,
     $                TAU0, IESR, RHOO, PSI, NSTATE, EIROP, SCR2, LSCR2)
C         Calculate first-order wavefunction
          SDIIS = .TRUE.
          SPCG  = .TRUE.
          CALL OPT_LR (C0, C1, C2, SC0, EIND, EIGV, DRHOE,
     $                 H1NL, EIVPS1, EIROP1, DDXC, VPP, CSCR, CR,
     $                 PSI, SCR2, LSCR2, NSTATE, "PHONON", ORBTYP)
C         Calculate first order density
          CALL RHO1OFR (C0, C1, F, DRHOE, PSI, NSTATE)
C         Hartree and XC first-order terms
          CALL V1OFRHO1 (E2, DRHOE, DDXC, PSI, SCR2, LSCR2)
C         Coupling component for each pair of surfaces
          FCSUM = 0.0D0
          DO IC = 1,NROOT
CCC            IS1 = ISURF(1,IC)
CCC            IS2 = ISURF(2,IC)
            IF (IC.GT.1) THEN
              CALL AZZERO (RHOOV, NNR1)
              CALL RHOABOFR (1, C0(1,IS1), C0(1,IS2), RHOOV, PSI)
              DEINV = DEINVV(IC)
            END IF
            IF (TLSE) THEN
              FCOMP = 0.5D0 * (
     $              DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1) +
     $              DDOT (NNR1, RHOOV, 1, DRHOE(1,3), 1))
            ELSE IF (TLSD.AND.IS2.GT.NSUP) THEN
              FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1)
            ELSE
              FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,1), 1)
            END IF
            FCOMP = FCOMP * OMEGA/(NR1S*NR2S*NR3S) * DEINV
            CALL GLOSUM (1, FCOMP)
            FCSRF(IC) = FCOMP
            FCSUM = FCSUM + CSURF(IC)*FCOMP
            IF (LPRINT) WRITE(6,'(A,I3,A,F12.5)')
     $           ' RESPONSE ALONG VECTOR ', IV, ': ', FCOMP
          END DO                ! IC = 1,ROOT
C
C     ==  Response along search vector large, increase accuracy       ==
C
          IF (IV.EQ.1 .OR. ABS(FCSUM).GT.FC_LOW) THEN
            TYPE = "NOINIT"
            TOL_LR_BAK = TOL_LR
            IF (IV.EQ.1 .OR. ABS(FCSUM).GT.FC_HIGH) THEN
              TOL_LR = TOL_LR / F_HIGH
            ELSE IF (ABS(FCSUM).GT.FC_MED) THEN
              TOL_LR = TOL_LR / F_MED
            ELSE
              TOL_LR = TOL_LR / F_LOW
            END IF
            IF (LPRINT) WRITE(6,'(A,F12.5)')
     $           ' INCREASED ACCURACY: ', TOL_LR
            CALL OPT_LR (C0, C1, C2, SC0, EIND, EIGV, DRHOE,
     $                   H1NL, EIVPS1, EIROP1, DDXC, VPP, CSCR, CR,
     $                   PSI, SCR2, LSCR2, NSTATE, TYPE, ORBTYP)
            CALL RHO1OFR (C0, C1, F, DRHOE, PSI, NSTATE)
C           Hartree and XC first-order terms
            CALL V1OFRHO1 (E2, DRHOE, DDXC, PSI, SCR2, LSCR2)
C           Coupling component for each pair of surfaces
            DO IC = 1,NROOT
CCC              IS1 = ISURF(1,IC)
CCC              IS2 = ISURF(2,IC)
              IF (IC.GT.1) THEN
                CALL AZZERO (RHOOV, NNR1)
                CALL RHOABOFR (1, C0(1,IS1), C0(1,IS2), RHOOV, PSI)
                DEINV = DEINVV(IC)
              END IF
              IF (TLSE) THEN
                FCOMP = 0.5D0 * (
     $                DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1) +
     $                DDOT (NNR1, RHOOV, 1, DRHOE(1,3), 1))
              ELSE IF (TLSD.AND.IS2.GT.NSUP) THEN
                FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,2), 1)
              ELSE
                FCOMP = DDOT (NNR1, RHOOV, 1, DRHOE(1,1), 1)
              END IF
              FCOMP = FCOMP * OMEGA/(NR1S*NR2S*NR3S) * DEINV
              CALL GLOSUM (1, FCOMP)
              FCSRF(IC) = FCOMP
              IF (LPRINT) WRITE(6,'(A,F12.5)')
     $             ' MORE ACCURATE RESPONSE: ', FCOMP
            END DO              ! IC = 1,NROOT
            TOL_LR = TOL_LR_BAK
          END IF                ! IF (IV.EQ.1 .OR. FCSUM.GT.FC_LOW)
C
C     ==  Store response                                              ==
C
          DO IC = 1,NROOT
            IAT = 0
            DO ISP = 1,NSP
              DO IA = 1,NA(ISP)
                IAT = IAT + 1
                DO K = 1,3
                  FC = FCSRF(IC) * VECT(K,IAT,IV)
                  VCLOCB(K,IA,ISP,IC) = VCLOCB(K,IA,ISP,IC) + FC
                END DO
              END DO
            END DO
          END DO
C
C     ==  Not converged, find new search direction                    ==
C
          LCONV = (ABS(FCOMP).LT.TOLCPL)
          IF (IV.LT.NVECT .AND. .NOT.LCONV) THEN
            IF (LPRINT) THEN
              WRITE(6,'(A,I3)') ' COUPLINGS, ITERATION: ', IV
              CALL PRCPLNGS (VCLOCB, TAUC, .FALSE.)
            END IF
            IV = IV + 1
C           Skip generation of new vector if specified
            IF (.NOT.TSPECV) THEN
C             Look for maximum component not yet searched
              RMAX = 0.0D0
              IMAX = 0
              KMAX = 0
              CALL AZZERO (VECT(1,1,IV), N3)
              DO IAT = 1,NATOMS
                DO K = 1,3
                  IF (IDONE(K+3*(IAT-1)).EQ.0) THEN
                    IF (ABS(VECT(K,IAT,IV-1)).GT.RMAX) THEN
                      RMAX = ABS(VECT(K,IAT,IV-1))
                      IMAX = IAT
                      KMAX = K
                    END IF
                  END IF
                END DO
              END DO
              IF (LPRINT) WRITE(6,*) 'COMPONENT: ', IMAX, KMAX
C             Select and mark new component as searched
              IDONE(KMAX+3*(IMAX-1)) = IV
              VECT(KMAX,IMAX,IV) = 1.0D0
            END IF              ! (.NOT.TSPECV)
C           Orthogonalize new vector with respect to all previous ones
            RLEN = SQRT(DDOT(N3, VECT(1,1,IV), 1, VECT(1,1,IV), 1))
            CALL DSCAL (N3, 1.0D0/RLEN, VECT(1,1,IV), 1)
            DO IVV = 1,IV-1
              RLEN = DDOT (N3, VECT(1,1,IVV), 1, VECT(1,1,IV), 1)
              CALL DAXPY (N3, -RLEN, VECT(1,1,IVV), 1, VECT(1,1,IV), 1)
              RLEN = SQRT(DDOT(N3, VECT(1,1,IV), 1, VECT(1,1,IV), 1))
              CALL DSCAL (N3, 1.0D0/RLEN, VECT(1,1,IV), 1)
            END DO
C           Report singular transformation
            DO IVV = 1,IV-1
              RLEN = DDOT (N3, VECT(1,1,IVV), 1, VECT(1,1,IV), 1)
              IF (LPRINT2) WRITE(6,'(A,I3,A,F10.6)')
     $             ' OVERLAP WITH VECTOR ', IVV, ': ', RLEN
              IF (PARENT .AND. ABS(RLEN).GT.1.0D-6) THEN
                 WRITE(6,'(A,I3,A,I3,A,E10.4)')
     $                ' WARNING: OVERLAP BETWEEN VECTOR ', IVV, ' AND ',
     $                IV, ': ', RLEN
              END IF
            END DO
            GOTO 10
C
C     ==  Done with iterative scheme for one or the other reason      ==
C
          ELSE IF (LCONV) THEN
            IF (LPRINT) WRITE(6,'(A,A,I3,A)') ' ITERATIVE SCHEME FOR ',
     $            'COUPLINGS CONVERGED IN ', IV, ' CYCLES'
          ELSE IF (IV.GE.NVECT .AND. TOLCPL.GT.0.0D0) THEN
            IF (LPRINT) WRITE(6,'(A)')
     $          ' WARNING: ITERATIVE SCHEME FOR COUPLINGS NOT CONVERGED'
          ELSE IF (IV.GE.NVECT) THEN
            IF (LPRINT.AND.TOLCPL.GT.0.0D0) WRITE(6,'(A,I3)')
     $          ' ITERATIVE SCHEME FOR COUPLINGS DONE, CYCLE ', IV
          END IF
        CONTINUE             ! END DO ... UNTIL (IV.GE.NVECT .OR. LCONV)
       ENDIF                 ! IF (TALLDOF) ... ELSE ...
      ENDIF  ! IF (DOLINRES) THEN ... ENDIF

 2345 CONTINUE
C     ==--------------------------------------------------------------==
      CALL SCRREL(SCR,LSCR,DEBUG)
      CALL FREEM(IP_C1)
      CALL FREEM(IP_C2)
      CALL FREEM(IP_PSI)
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_CSCR)
      CALL FREEM(IP_TAUC)
      CALL FREEM(IP_EIGT)
      CALL FREEM(IP_EIGS)
      CALL FREEM(IP_FNLC)
      CALL FREEM(IP_DFNLC)
      CALL TIHALT('   LRCPLNG',ISUB)
C     ==--------------------------------------------------------------==
 110  FORMAT (1X,A,T41,F20.8,' A.U.')
 120  FORMAT (1X,A,I3,A,I3,A,T41,F20.8, ' A.U.')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DRHOPP(VCLOCA,VCLOCB,FNLC,DFNLC,NN,NAP,IC)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE NON-LOCAL POTENTIAL CONTRIBUTION TO THE FORCE ON THE    ==
C     ==  IONIC DEGREES OF FREEDOM                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'        !NLM
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'cplngs.inc'
C     Arguments
      REAL*8  VCLOCA(3,NAX,NSX,100),VCLOCB(3,NAX,NSX,100)
      INTEGER NN,NAP,NROOT,IC
C     Variables
      REAL*8  DFNL(NAT,NHXS,3,*),FNL(LDF1,NHXS,*),TT
      REAL*8  DFNLC(NAT,NHXS,3,*),FNLC(LDF1,NHXS,*)
      INTEGER ISUB,ISA0,IS,IV,JV,II,ISA,L,KI,LI,L2,LJ,KJ,
     &        K,ID,IA,IATL,IS1,IS2
      REAL*8  DFAB(NAT,NHXS,2)
      POINTER (IP_DFAB,DFAB)
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('    DRHOPP',ISUB)
      CALL MEMORY(IP_DFAB,2*NAT*NHXS,"DFAB")
C     DO IC=1,NROOT
       DO ID=1,NN
        IS1=ID
        IF (TLSD) THEN
         IF (IS1.LE.NUPEL) THEN
          IS2=IS1
         ELSE
          IS2=NAP+IS1
         ENDIF
        ELSE
         IS2=IS1
        ENDIF
        DO K=1,3
          CALL AZZERO(DFAB,2*NAT*NHXS)
          IF(IS1.GE.NST12(MEPOS,1).AND.
     &       IS1.LE.NST12(MEPOS,2) ) THEN
            II=IS1-NST12(MEPOS,1)+1
            CALL DCOPY(NHXS*NAT,DFNL(1,1,K,II),1,DFAB(1,1,1),1)
          ENDIF
          IF(IS2.GE.NST12(MEPOS,1).AND.
     &       IS2.LE.NST12(MEPOS,2) ) THEN
            II=IS2-NST12(MEPOS,1)+1
            CALL DCOPY(NHXS*NAT,DFNLC(1,1,K,II),1,DFAB(1,1,2),1)
          ENDIF
          CALL GLOSUM(2*NAT*NHXS,DFAB)
          ISA0=0
          DO IS=1,NSP
            IF(TVAN(IS)) THEN
C             Vanderbild pp
              CALL STOPGM("DRHOPP","VDB NOT IMPLEMENTED")
            ELSEIF(TSGP(IS)) THEN
C             Stefan Goedecker pp
              CALL STOPGM("DRHOPP","SG NOT YET WORKING")
              DO IV=1,NGH(IS)
                L=NGHTOL(IV,IS)+1
                KI=LFVAL(IV,IS)
                LI=LPVAL(IV,IS)
                DO JV=1,NGH(IS)
                  L2=NGHTOL(JV,IS)+1
                  LJ=LPVAL(JV,IS)
                  IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
                    KJ=LFVAL(JV,IS)
                    TT=HLSG(KI,KJ,L,IS)
                    DO IA=1,NA(IS)
                      ISA=ISA0+IA
                      IF(TFDIST) THEN
                        IATL=ISA-IPEPT(1,MEPOS)+1
                        IF (TLSD) THEN
                         IF (IS1.LE.NUPEL) THEN
                          VCLOCA(K,IA,IS,IC)=VCLOCA(K,IA,IS,IC)
     &                     -0.5D0*TT*(
     &                      DFAB(ISA,IV,1)*FNLC(IATL,JV,IS2)
     &                     +DFAB(ISA,IV,2)*FNL(IATL,JV,IS1)
     &                     +DFAB(ISA,JV,1)*FNLC(IATL,IV,IS2)
     &                     +DFAB(ISA,JV,2)*FNL(IATL,IV,IS1))
                         ELSE
                           VCLOCB(K,IA,IS,IC)=VCLOCB(K,IA,IS,IC)
     &                     -0.5D0*TT*(
     &                      DFAB(ISA,IV,1)*FNLC(IATL,JV,IS2)
     &                     +DFAB(ISA,IV,2)*FNL(IATL,JV,IS1)
     &                     +DFAB(ISA,JV,1)*FNLC(IATL,IV,IS2)
     &                     +DFAB(ISA,JV,2)*FNL(IATL,IV,IS1))
                         ENDIF
                        ELSE
                          VCLOCA(K,IA,IS,IC)=VCLOCA(K,IA,IS,IC)
     &                     -0.5D0*TT*(
     &                      DFAB(ISA,IV,1)*FNLC(IATL,JV,IS2)
     &                     +DFAB(ISA,IV,2)*FNL(IATL,JV,IS1)
     &                     +DFAB(ISA,JV,1)*FNLC(IATL,IV,IS2)
     &                     +DFAB(ISA,JV,2)*FNL(IATL,IV,IS1))
                        ENDIF
                      ELSE
                       IF (TLSD) THEN
                        IF (IS1.LE.NUPEL) THEN
                          VCLOCA(K,IA,IS,IC)=VCLOCA(K,IA,IS,IC)-TT*(
     &                      DFAB(ISA,IV,1)*FNLC(ISA,JV,IS2)
     &                     +DFAB(ISA,IV,2)*FNL(ISA,JV,IS1)
     &                     +DFAB(ISA,JV,1)*FNLC(ISA,IV,IS2)
     &                     +DFAB(ISA,JV,2)*FNL(ISA,IV,IS1))
                        ELSE
                          VCLOCB(K,IA,IS,IC)=VCLOCB(K,IA,IS,IC)-TT*(
     &                      DFAB(ISA,IV,1)*FNLC(ISA,JV,IS2)
     &                     +DFAB(ISA,IV,2)*FNL(ISA,JV,IS1)
     &                     +DFAB(ISA,JV,1)*FNLC(ISA,IV,IS2)
     &                     +DFAB(ISA,JV,2)*FNL(ISA,IV,IS1))
                        ENDIF
                       ELSE
                         VCLOCA(K,IA,IS,IC)=VCLOCA(K,IA,IS,IC)-TT*(
     &                     DFAB(ISA,IV,1)*FNLC(ISA,JV,IS2)
     &                    +DFAB(ISA,IV,2)*FNL(ISA,JV,IS1)
     &                    +DFAB(ISA,JV,1)*FNLC(ISA,IV,IS2)
     &                    +DFAB(ISA,JV,2)*FNL(ISA,IV,IS1))
                       ENDIF
                      ENDIF
                    ENDDO
                  ENDIF
                ENDDO
              ENDDO
            ELSE
C             Other pp (numeric)
              DO IV=1,NGH(IS)
                DO IA=1,NA(IS)
                  ISA=ISA0+IA
                  IF(ISA.GE.IPEPT(1,MEPOS).AND.
     &               ISA.LE.IPEPT(2,MEPOS)) THEN
                    IF(TFDIST) THEN
                      IATL=ISA-IPEPT(1,MEPOS)+1
                      IF (TLSD) THEN
                       IF (IS1.LE.NUPEL) THEN
                         VCLOCA(K,IA,IS,IC)=VCLOCA(K,IA,IS,IC)
     &                    -WSG(IS,IV)*
     &                    (DFAB(ISA,IV,1)*FNLC(IATL,IV,IS2)
     &                    +FNL(IATL,IV,IS1)*DFAB(ISA,IV,2))
                       ELSE
                         VCLOCB(K,IA,IS,IC)=VCLOCB(K,IA,IS,IC)
     &                    -WSG(IS,IV)*
     &                    (DFAB(ISA,IV,1)*FNLC(IATL,IV,IS2)
     &                    +FNL(IATL,IV,IS1)*DFAB(ISA,IV,2))
                       ENDIF
                      ELSE
                       VCLOCA(K,IA,IS,IC)=VCLOCA(K,IA,IS,IC)
     &                  -WSG(IS,IV)*
     &                  (DFAB(ISA,IV,1)*FNLC(IATL,IV,IS2)
     &                  +FNL(IATL,IV,IS1)*DFAB(ISA,IV,2))
                      ENDIF
                    ELSE
                     IF (TLSD) THEN
                      IF (IS1.LE.NUPEL) THEN
                        VCLOCA(K,IA,IS,IC)=VCLOCA(K,IA,IS,IC)
     &                   -WSG(IS,IV)*
     &                   (DFAB(ISA,IV,1)*FNLC(ISA,IV,IS2)
     &                   +FNL(ISA,IV,IS1)*DFAB(ISA,IV,2))
                      ELSE
                        VCLOCB(K,IA,IS,IC)=VCLOCB(K,IA,IS,IC)
     &                   -WSG(IS,IV)*
     &                   (DFAB(ISA,IV,1)*FNLC(ISA,IV,IS2)
     &                   +FNL(ISA,IV,IS1)*DFAB(ISA,IV,2))
                      ENDIF  
                     ELSE
                      VCLOCA(K,IA,IS,IC)=VCLOCA(K,IA,IS,IC)
     &                 -WSG(IS,IV)*
     &                 (DFAB(ISA,IV,1)*FNLC(ISA,IV,IS2)
     &                 +FNL(ISA,IV,IS1)*DFAB(ISA,IV,2))
                     ENDIF
                    ENDIF
                  ENDIF
                ENDDO
              ENDDO
            ENDIF
            ISA0 = ISA0 + NA(IS)
          ENDDO
        ENDDO
       ENDDO
C      ENDDO
      CALL FREEM(IP_DFAB)
      CALL TIHALT('    DRHOPP',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TDRHOFC(FION,RHO,PSI)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'isos.inc'
C     Arguments
      REAL*8     FION(3,NAX,NSX),RHO(*)
      COMPLEX*16 PSI(*)
C     Variables
C     DIMENSION  EI1(NATX,(2*NR1S-1)),EI2(NATX,(2*NR2S-1)),
C    &           EI3(NATX,(2*NR3S-1))
      DIMENSION  EIGRB(NHG,NAT)
      COMPLEX*16 RHETS,GX,GY,GZ,VCGS,TXX,TYY,TZZ,EI123
      REAL*8     FNL(*),DFNL(*),
     &           OMTP
      INTEGER    IG1,IG,ISA,IS,IA,IR
C     ==--------------------------------------------------------------==
C      DO IR=1,NNR1
C        PSI(IR)=DCMPLX(RHO(IR),0.D0)
C      ENDDO
C      CALL FWFFT(PSI)
C
      OMTP=2.D0*OMEGA*TPIBA
      IG1=1
      IF(GEQ0) IG1=2
      DO IG=IG1,NHG
        RHETS=DCONJG(PSI(NZH(IG)))
        GX=DCMPLX(0.D0,GK(1,IG))
        GY=DCMPLX(0.D0,GK(2,IG))
        GZ=DCMPLX(0.D0,GK(3,IG))
        VCGS=SCG(IG)*RHETS
        ISA=0
        DO IS=1,NSP
          TXX=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GX
          TYY=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GY
          TZZ=(RHOPS(IS,IG)*VCGS+VPS(IS,IG)*RHETS)*GZ
          DO IA=1,NA(IS)
            ISA=ISA+1
            IF(BIGMEM) THEN
              EI123=EIGRB(IG,ISA)
            ELSE
              EI123=EI1(ISA,INYH(1,IG))*EI2(ISA,INYH(2,IG))*
     *                  EI3(ISA,INYH(3,IG))
            ENDIF
            FION(1,IA,IS)=FION(1,IA,IS)+DREAL(EI123*TXX)*OMTP
            FION(2,IA,IS)=FION(2,IA,IS)+DREAL(EI123*TYY)*OMTP
            FION(3,IA,IS)=FION(3,IA,IS)+DREAL(EI123*TZZ)*OMTP
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE  NACSTRANS(VCLOCA,VCLOCB,NROOT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'spin.inc'
C     Arguments
      REAL*8  VCLOCA(3,NAX,NSX,100),VCLOCB(3,NAX,NSX,100)
      INTEGER NROOT
C     Variables
      INTEGER IROOT,IS,IA,K,NITER
      REAL*8  VHELPA(3,NAX,NSX),VHELPB(3,NAX,NSX),
     &        CA(3,100),CB(3,100)
      POINTER (IP_VHELPA,VHELPA),(IP_VHELPB,VHELPB)
C
      CALL MEMORY(IP_VHELPA,3*NAX*NSX,'VHELPA')
      IF (TLSD) THEN
       CALL MEMORY(IP_VHELPB,3*NAX*NSX,'VHELPB')
      ELSE
       CALL MEMORY(IP_VHELPB,3,'VHELPB')
      ENDIF
C
      NITER= (NROOT*(NROOT-1))/2
      DO IROOT=1,NITER
        DO IS=1,NSP
          DO IA=1,NA(IS)
            DO K=1,3
             VHELPA(K,IA,IS)=VCLOCA(K,IA,IS,IROOT)
            ENDDO
          ENDDO
        ENDDO
        IF (TLSD) THEN
         DO IS=1,NSP
          DO IA=1,NA(IS)
            DO K=1,3
             VHELPB(K,IA,IS)=VCLOCB(K,IA,IS,IROOT)
            ENDDO
          ENDDO
         ENDDO
        ENDIF
C
        DO K=1,3
         CA(K,IROOT)=0.0
         CB(K,IROOT)=0.0
        ENDDO
        DO IS=1,NSP
         DO IA=1,NA(IS)
           DO K=1,3
            CA(K,IROOT)=CA(K,IROOT)+VHELPA(K,IA,IS)
           ENDDO
         ENDDO
        ENDDO
        IF (TLSD) THEN
         DO IS=1,NSP
          DO IA=1,NA(IS)
           DO K=1,3
            CB(K,IROOT)=CB(K,IROOT)+VHELPB(K,IA,IS)
           ENDDO
          ENDDO
         ENDDO
        ENDIF
C
        DO IS=1,NSP
          DO IA=1,NA(IS)
            DO K=1,3
             VCLOCA(K,IA,IS,IROOT)=VHELPA(K,IA,IS)-CA(K,IROOT)/NAT
            ENDDO
            IF (TLSD) THEN
             DO K=1,3
              VCLOCB(K,IA,IS,IROOT)=VHELPB(K,IA,IS)-CB(K,IROOT)/NAT
             ENDDO
            ENDIF
          ENDDO
        ENDDO
C
C       CALL ROTVEC(TAU0,VCLOCA(1,1,1,IROOT))
C       IF (TLSD) CALL ROTVEC(TAU0,VCLOCB(1,1,1,IROOT))
      ENDDO
C
      RETURN
      END
C     ==================================================================
      SUBROUTINE ROTVEC(TAU0,VELP)
C     ==--------------------------------------------------------------==
C     REMOVE FIX ROTATIONS
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      REAL*8     TAU0(3,NAX,*),VELP(3,NAX,*)
C     Variables
      REAL*8     TSCR(3,NAX*NSP),VSCR(3,NAX*NSX),PSCR(NAX*NSX)
      REAL*8     CM(3),LM(3),VTMP(3),EVL(3),EVM(3,3)
      REAL*8     LTENS(3,3),WK(9),WX(3),SMALL
      REAL*8     R1,R2,EKINP1,TEMPP1,EKINP2,TEMPP2,PSCRT,TSCAL,VSCALE
      INTEGER    IS,IA,IAT,IERR
      PARAMETER (SMALL=1.0e-10)  ! small angular momentum where we stop considering it
C     ==--------------------------------------------------------------==
C     COMPUTE THE IONIC TEMPERATURE TEMPP1
      CALL EKINPP(EKINP1,VELP)
      TEMPP1=EKINP1*FACTEM*2.0D0/GLIB

C     GET CENTER OF MASS AND COPY TO HELPER ARRAY
      CALL AZZERO(CM,3)
      IAT=0
      PSCRT=0.0D0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          R1=PMA0(IS)
          PSCRT=PSCRT+R1
          PSCR(IAT)=R1
          R2=TAU0(1,IA,IS)
          TSCR(1,IAT)=R2
          CM(1)=CM(1)+R2*R1
          R2=TAU0(2,IA,IS)
          TSCR(2,IAT)=R2
          CM(2)=CM(2)+R2*R1
          R2=TAU0(3,IA,IS)
          TSCR(3,IAT)=R2
          CM(3)=CM(3)+R2*R1
          VSCR(1,IAT)=VELP(1,IA,IS)
          VSCR(2,IAT)=VELP(2,IA,IS)
          VSCR(3,IAT)=VELP(3,IA,IS)
        END DO
      END DO
      CM(1)=CM(1)/PSCRT
      CM(2)=CM(2)/PSCRT
      CM(3)=CM(3)/PSCRT

C     translate C.O.M to origin.
!$OMP parallel do private(IAT)
      DO IAT=1,NAT
        TSCR(1,IAT)=TSCR(1,IAT)-CM(1)
        TSCR(2,IAT)=TSCR(2,IAT)-CM(2)
        TSCR(3,IAT)=TSCR(3,IAT)-CM(3)
      END DO

C     get total angular momentum
      CALL AZZERO(LM,3)
      DO IAT=1,NAT
        CALL VECPROD(TSCR(1,IAT),VSCR(1,IAT),VTMP)
        R1=PSCR(IAT)
        LM(1)=LM(1)+VTMP(1)*R1
        LM(2)=LM(2)+VTMP(2)*R1
        LM(3)=LM(3)+VTMP(3)*R1
      END DO

C     get moment of inertia
      CALL AZZERO(LTENS,9)
      DO IAT=1,NAT
        LTENS(1,1)=LTENS(1,1)+PSCR(IAT)*(TSCR(2,IAT)**2+TSCR(3,IAT)**2)
        LTENS(1,2)=LTENS(1,2)-PSCR(IAT)*(TSCR(1,IAT)*TSCR(2,IAT))
        LTENS(1,3)=LTENS(1,3)-PSCR(IAT)*(TSCR(1,IAT)*TSCR(3,IAT))

        LTENS(2,1)=LTENS(2,1)-PSCR(IAT)*(TSCR(1,IAT)*TSCR(2,IAT))
        LTENS(2,2)=LTENS(2,2)+PSCR(IAT)*(TSCR(1,IAT)**2+TSCR(3,IAT)**2)
        LTENS(2,3)=LTENS(2,3)-PSCR(IAT)*(TSCR(2,IAT)*TSCR(3,IAT))

        LTENS(3,1)=LTENS(3,1)-PSCR(IAT)*(TSCR(1,IAT)*TSCR(3,IAT))
        LTENS(3,2)=LTENS(3,2)-PSCR(IAT)*(TSCR(2,IAT)*TSCR(3,IAT))
        LTENS(3,3)=LTENS(3,3)+PSCR(IAT)*(TSCR(1,IAT)**2+TSCR(2,IAT)**2)
      END DO

      IERR=0
      CALL DCOPY(9,LTENS,1,EVM,1)
      CALL DSYEV('V','U',3,EVM,3,EVL,WK,9,IERR)

C     get angular velocity in body frame. ignore if moment of inertia is small.
      CALL DGEMV('T',3,3,1.0D0,EVM,3,LM,1,0.0D0,WX,1)
      IF(DABS(EVL(1)).GT.SMALL) THEN
        WX(1)=WX(1)/EVL(1)
      ELSE
        WX(1)=0.0d0
      ENDIF
      IF(DABS(EVL(2)).GT.SMALL) THEN
        WX(2)=WX(2)/EVL(2)
      ELSE
        WX(2)=0.0d0
      ENDIF
      IF(DABS(EVL(3)).GT.SMALL) THEN
        WX(3)=WX(3)/EVL(3)
      ELSE
        WX(3)=0.0d0
      ENDIF
C     transform back to lab frame and subtract
      CALL DGEMV('N',3,3,1.0D0,EVM,3,WX,1,0.0D0,LM,1)
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          CALL VECPROD(LM,TSCR(1,IAT),VTMP)
          VELP(1,IA,IS)=VELP(1,IA,IS)-VTMP(1)
          VELP(2,IA,IS)=VELP(2,IA,IS)-VTMP(2)
          VELP(3,IA,IS)=VELP(3,IA,IS)-VTMP(3)
        END DO
      END DO

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRITENACS(VIBE,SDER,NDIM,TAU0,NROOT,SWITCH)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'cnst.inc'
      include 'ions.inc'
      include 'cell.inc'
      include 'fileopen.inc'
C     Arguments
      INTEGER   NDIM,NROOT,SWITCH
      REAL*8    VIBE(*),SDER(NDIM,*),TAU0(3,NAX,*)
C     Variables
      LOGICAL   LW,FERROR
      CHARACTER FILE1*100,FILE2*100,typ*2,a*8,ck(3)*7,fr*17,rm(5)*17
      INTEGER   i,j,k,l,n,t(NAT),ii,is,ia,at,he,IUNIT,m
      REAL*8    gz,xc(NAT),yc(NAT),zc(NAT),bx,by,bz
C     ==--------------------------------------------------------------==
      FILE1='NACV.log'
      IF (TLSD) THEN
       IF (SWITCH.EQ.0) THEN
        FILE1='NACVa.log'
       ELSE
        FILE1='NACVb.log'
       ENDIF
      ENDIF
C     write gaussianformated output into VIB1.log and VIB2.log files,
C     which are readable in molden/molekel to visualise the vibrations.
      fr=' Frequencies --  '
      rm(1)=' Red. masses --  '
      rm(2)=' Frc consts  --  '
      rm(3)=' IR Inten    --  '
      rm(4)=' Raman Activ --  '
      rm(5)=' Depolar     --  '
      typ='?A'
      a=' Atom AN  '
      ck(1)='      X'
      ck(2)='      Y'
      ck(3)='      Z'
      at=0
      gz=0.d0
      LW=.false.
      FERROR=.FALSE.
C ---- cell dimensions---------------------------
      bx=CELLDM(1)
      by=CELLDM(2)
      bz=CELLDM(3)
      CALL FILEOPEN (15,FILE1,FO_DEF,FERROR)
      IF(FERROR) GOTO 999
C ---- read coordinates and atomtyps ------------
      k=1
      DO IS=1,NSP
        DO IA=1,NA(IS)
           xc(k)=TAU0(1,IA,IS)
           yc(k)=TAU0(2,IA,IS)
           zc(k)=TAU0(3,IA,IS)
           t(k)=IATYP(IS)
           IF (xc(k).lt.0) LW=.true.
           IF (yc(k).lt.0) LW=.true.
           IF (zc(k).lt.0) LW=.true.
           k=k+1
        ENDDO
      ENDDO
C ---- write some lines needed for molden
      IUNIT=15
      WRITE (IUNIT,*)'Entering Gaussian System'
      WRITE (IUNIT,*)'this file is generated from the WRITENACS',
     &               ' subroutine in the file td_nacvs.F'
      WRITE (IUNIT,*)'Please note, that this is a "faked" output;'
      WRITE (IUNIT,*)'there are no intensities computed in CPMD.'
      WRITE (IUNIT,*)'Standard orientation:'
      WRITE (IUNIT,*)'---------------------------------------',
     &               '------------------------------'
      WRITE (IUNIT,'(A,2(5X,A),14X,A)')
     &           'Center','Atomic','Atomic','Coordinates (Angstroms)'
      WRITE (IUNIT,'(2(A,5X),1X,A,3X,3(11X,A))')
     &               'Number','Number','Type','X','Y','Z'
      WRITE (IUNIT,*)'---------------------------------------',
     &               '------------------------------'
C ---- make sure that the center of mass is the origin or move the atoms
C ---- from the center of the box to the origin and printout
      IF (LW) THEN
         DO i=1,NAT
            xc(i)=(xc(i))/FBOHR
            yc(i)=(yc(i))/FBOHR
            zc(i)=(zc(i))/FBOHR
            WRITE (15,22)  i, t(i), at, xc(i), yc(i), zc(i)
         ENDDO
      ELSE
         DO 11 i=1,NAT
            xc(i)=(xc(i)-bx/2)/FBOHR
            yc(i)=(yc(i)-bx*by/2)/FBOHR
            zc(i)=(zc(i)-bx*bz/2)/FBOHR
            WRITE (15,22)  i, t(i), at, xc(i), yc(i), zc(i)
 11      CONTINUE
      ENDIF
C ---- write some lines for molden -----------------------------
      IUNIT=15
      WRITE(IUNIT,*)'--------------------------------------------',
     &              '-------------------------'
      WRITE(IUNIT,*)'      basis functions          primitive ',
     &              'gaussians'
      WRITE(IUNIT,*)'      alpha electrons          beta electrons'
      WRITE(IUNIT,*)'********************************************',
     &              '**************************'
      WRITE(IUNIT,*)
      WRITE(IUNIT,*)'Harmonic frequencies (cm**-1), IR intensities ',
     &              '(KM/Mole),'
      WRITE(IUNIT,*)'Raman scattering activities (A**4/AMU), Raman ',
     &              'depolarization ratios,'
      WRITE(IUNIT,*)'reduced masses (AMU), force constants ',
     &              '(mDyne/A) and normal coordinates:'
C ---- write eigenvalues and eigenvectors in both files
      DO 15 ii=1,NINT(NROOT*(NROOT+1.0)/2.0),3
        i=ii+3
        WRITE(15,23) i-3, i-2, i-1
        WRITE(15,24) typ, typ, typ
        WRITE(15,25) fr, (VIBE(l),l=i,i+2)
        DO n=1,5
           WRITE(15,25) rm(n), gz, gz, gz
        ENDDO
        WRITE(15,26) a,(ck(n),n=1,3),(ck(n),n=1,3),(ck(n),n=1,3)
        DO 16 j=1,NAT*3,3
          he=(j-1)/3+1
          WRITE(15,27) he,t(he),
     &                 (SDER(j,m),SDER(j+1,m),SDER(j+2,m),m=i,i+2)
 16     CONTINUE
 15   CONTINUE
      WRITE(15,*) 'Normal termination of Gaussian 98.'
      CALL FILECLOSE (15)
 22   FORMAT(i5,i11,i14,4x,3(3x,f9.6))
 23   FORMAT(i22,2i23)
 24   FORMAT(20x,a2,2(21x,a2))
 25   FORMAT(a17,f9.4,2f23.4)
C26   FORMAT(a8,2X,3a17,2(2x,3a17))
 26   FORMAT(a8,3a7,2(2x,3a7))
 27   FORMAT(2i4,3(f19.8,2f17.8))
      goto 888
 999  CONTINUE
       WRITE(6,*) 'COULD NOT OPEN FILE VIB[1,2].log!'
 888  CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
