c     ======================================================================
      subroutine td_os(nstate, c0, nlr, eigv, c1, scr, lscr)
c     ======================================================================
      IMPLICIT NONE
      !These from raman_p:
      include 'system.h'
      include 'irat.inc'
      include 'rmas.inc'
      include 'cnst.inc'
      include 'gvec.inc'
      include 'geq0.inc'
      include 'prop.inc'
      include 'metr.inc'
      include 'ddip.inc'
      include 'symm.inc'
      include 'linres.inc'

c     Input:
      integer nstate                                  !n. of occupied states
      complex*16 c0(ngw, nstate)                       !occupied KS orbitals
      integer nlr                             !n. of linear-response vectors
      real*8 eigv(nlr)                                  !transition energies
      complex*16 c1(ngw, nstate, nlr)              !linear-response orbitals
      real*8 scr(*)
      integer lscr

c     -------------------------------------------------------------
c     Sometimes the scratch space SCR defined in specpt is not big
c     enough for opeigr. A new scratch array SCROS is defined here
c     if needed.
c     -------------------------------------------------------------
c     Local:
      integer ilrv,length,ltr
      character*30 tag
      real*8 SCROS(*)
      pointer (IP_SCROS,SCROS)
cLB   ----------------------------------------------------------------------

      if(.not.tda) return
      if(tlsd) return
      if(ns_tri.ne.0) return
      if(msubta.gt.0) return

c     ==--------------------------------------------------------------==
      IF (TPGAUTO .or. TMSYM .or. INDPG.NE.0) THEN
         call stopgm('td_os',
     &       'POINT GROUP symmetry not implemented.')
      ENDIF
c     ==--------------------------------------------------------------==
c     Allocate SCROS
      LENGTH=0
      LTR=0
      CALL GIVE_SCR_OPEIGR(length,tag,nstate)
      IF(LSCR.LT.LENGTH) THEN
        CALL MEMORY(IP_SCROS,length,'SCROS')
        LTR=1
      ELSE
        CALL GET_ADDR(IP_SCROS,SCR)
      ENDIF
      IF (PARENT) CALL PRMEM('     TD_OS')
      IF (PARENT) WRITE(6,'(1X,"LB:",61("-"))')
      DO ILRV = 1, NLR
        CALL TD_OS_BERRY(C0,C1(1,1,ILRV),SCROS,LENGTH,EIGV(ILRV),NSTATE)
      END DO
      IF (PARENT) WRITE(6,'(1X,"LB:",61("-"))')
      IF(LTR.EQ.1) CALL FREEM(IP_SCROS)
      return
      end
c     ======================================================================
