C     ==================================================================
      SUBROUTINE TD_PCG(C0,C1,C2,SC0,DDXC,PSI,EIGV,DRHOE,
     &                  TEIG,SCR,LSCR,MSUB,NSTATE,NROOT,ORBITAL,KPRINT)
C     ==--------------------------------------------------------------==
C     ==               updates the wavefunctions                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,NROOT,MSUB,KPRINT
      COMPLEX*16 C0(NGW,*),C1(NGW,MSUB,*),C2(NGW,*),SC0(*)
      COMPLEX*16 PSI(*)
      REAL*8     EIGV(*),SCR(LSCR),DRHOE(*),DDXC(*),TEIG(*)
      CHARACTER*(*) ORBITAL
C     Variables
      DIMENSION  UROT(NSTATE,MSUB,*)
      DIMENSION  F(*)
      INTEGER    LTD_PCG,IS,ID,IG,IROOT,I,J,IJ,ITER,IROT,IROTEFF
      CHARACTER  TAG*30
      REAL*8     VP,VPP(*),ORES,TCPU,T1,T2,E2,TIMEF,SO,DOTPS
      REAL*8     GG,DGG,GAM,LAM,DDOT,RG,RDG,TEIGOLD,ROTB
      REAL*8     FMAT(MSUB,MSUB),PMAT(MSUB,MSUB),UMAT(NSTATE,MSUB,*)
      REAL*8     PEIG(MSUB),UGRAD(NSTATE,MSUB),CGRAD(NSTATE,MSUB)
      REAL*8     UFMAT(MSUB,NSTATE),UH(NSTATE,MSUB)
      POINTER    (IP_VPP,VPP),(IP_FMAT,FMAT),(IP_UGRAD,UGRAD)
      POINTER    (IP_PMAT,PMAT),(IP_UMAT,UMAT),(IP_PEIG,PEIG)
      POINTER    (IP_CGRAD,CGRAD),(IP_UFMAT,UFMAT),(IP_UH,UH)
      POINTER    (IP_CS,CS),(IP_CB,CB),(IP_CH,CH)
      COMPLEX*16 CS(NGW,MSUB),CB(NGW,MSUB),CH(NGW,MSUB)
      EXTERNAL  DDOT,DOTPS,TIMEF
#ifdef PARALLEL
      INTEGER MSGLEN
#endif
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_TD_PCG(LTD_PCG,TAG)
      CALL TEST_SCR('TD_PCG',TAG,LSCR,LTD_PCG)
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_VPP,NGW,'VPP')
      CALL MEMORY(IP_CS,2*NGW*MSUB,'CS')
      CALL MEMORY(IP_CB,2*NGW*MSUB,'CB')
      CALL MEMORY(IP_CH,2*NGW*MSUB,'CH')
      IF(.NOT.TDACANON) THEN
        CALL MEMORY(IP_FMAT,MSUB*MSUB,'FMAT')
        CALL MEMORY(IP_UFMAT,MSUB*NSTATE,'UFMAT')
        CALL MEMORY(IP_PMAT,MSUB*MSUB,'PMAT')
        CALL MEMORY(IP_PEIG,MSUB,'PEIG')
        CALL MEMORY(IP_UMAT,MSUB*NSTATE*NROOT,'UMAT')
        CALL MEMORY(IP_UGRAD,MSUB*NSTATE,'UGRAD')
        CALL MEMORY(IP_UH,MSUB*NSTATE,'UH')
        CALL MEMORY(IP_CGRAD,MSUB*NSTATE,'CGRAD')
      ENDIF
C     ==--------------------------------------------------------------==
      PREC=.TRUE.
      CALL KSDIAG(VPP)
      DO IG=1,NGW
        VP=VPP(IG)
        VPP(IG)=MAX(VP,LR_HTHRS)
      ENDDO
C     ==--------------------------------------------------------------==
      IF ( PARENT .AND. KPRINT.GE.0 ) THEN
        WRITE(6,'(1X,64("="))')
        WRITE(6,'(1X,"==",T15,A,T64,"==")')
     &       '   CONJUGATED GRADIENTS OPTIMIZATION '
        WRITE(6,'(1X,"==",T16,A,T64,"==")')
     &   ' TAMM-DANCOFF SUBSPACE APPROXIMATION '
        WRITE(6,'(1X,64("="))')
      ENDIF
      DO IROOT = 1, NROOT
        IF ( PARENT .AND. KPRINT.GE.0 ) THEN
          WRITE(6,'(1X,"==",T25,A,I2,T64,"==")')
     &       '   OPTIMIZING ROOT ', IROOT
        ENDIF
C..initilize vectors
        CALL DCOPY(2*NGW*MSUB,C1(1,1,IROOT),1,CB,1)
        CALL LR_ORTHOS(NSTATE,MSUB,C0,CB,SCR,LSCR)
        IF(TDACANON) THEN
          DO I = 1, IROOT-1
            SO=DOTPS(NGW,MSUB,C1(1,1,I),CB)
            CALL GLOSUM(1,SO)
            CALL DAXPY(2*NGW*MSUB,-SO,C1(1,1,I),1,CB,1)
          ENDDO
        ELSE
          CALL GET_U(UROT(1,1,IROOT),UMAT(1,1,IROOT),PMAT,PEIG,
     &               NSTATE,MSUB,SCR,LSCR)
          CALL STATE_ORTHO(C1,CB,C2,UMAT,IROOT,NSTATE,MSUB,SCR,LSCR)
        ENDIF
        SO=DOTPS(NGW,MSUB,CB,CB)
        CALL GLOSUM(1,SO)
        CALL DSCAL(2*NGW*MSUB,1.D0/DSQRT(SO),CB,1)
        TEIGOLD=1.D30
        IROTEFF=1
        DO IROT=1,ROTIT
          IF(PARENT.AND. KPRINT.GE.0 ) WRITE(6,'(T25,A)') 
     &    'Iter            Residual             TCPU'
          IF(.NOT.TDACANON) THEN
            CALL GET_U(UROT(1,1,IROOT),UMAT(1,1,IROOT),PMAT,PEIG,
     &                 NSTATE,MSUB,SCR,LSCR)
            CALL DGEMM('N','N',2*NGW,MSUB,NSTATE,1.D0,C0,2*NGW,
     &                 UMAT(1,1,IROOT),NSTATE,0.D0,SC0,2*NGW)
            IF(INDEX(ORBITAL,"CANON").NE.0) THEN
              DO I=1,MSUB
                DO J=1,NSTATE
                  UFMAT(I,J)=-UMAT(J,I,IROOT)*EIGV(J)
                ENDDO
              ENDDO
            ELSE
              CALL DGEMM('T','N',MSUB,NSTATE,NSTATE,1.D0,
     &             UMAT(1,1,IROOT),NSTATE,EIGV,NSTATE,0.D0,UFMAT,MSUB)
            ENDIF
            CALL DGEMM('N','N',MSUB,MSUB,NSTATE,1.D0,UFMAT,MSUB,
     &           UMAT(1,1,IROOT),NSTATE,0.D0,FMAT,MSUB)
          ENDIF
          T1=TIMEF()
          DO ITER=1,TDPCGITER
            ID=NSTATE-MSUB+1
            IF(TDACANON) THEN
              CALL LR_FORCE_SUB(C0(1,ID),CB,CS,SC0,E2,
     &                    DDXC,PSI,DRHOE,EIGV(ID),
     &                    SCR,LSCR,NSTATE,MSUB,"TDA",ORBITAL)
            ELSE
              CALL LR_FORCE_SUB(SC0,CB,CS,C2,E2,
     &                    DDXC,PSI,DRHOE,FMAT,
     &                    SCR,LSCR,NSTATE,MSUB,"TDA","GENERAL")
            ENDIF
            CALL DSCAL(2*NGW*MSUB,-1.D0,CS,1)
            CALL LR_ORTHOS(NSTATE,MSUB,C0,CS,SCR,LSCR)
            TEIG(IROOT)=DOTPS(NGW,MSUB,CB,CS)
            CALL GLOSUM(1,TEIG(IROOT))
            CALL DAXPY(2*NGW*MSUB,-TEIG(IROOT),CB,1,CS,1)
            CALL DCOPY(2*NGW*MSUB,CS,1,C2,1)
            IF(TDACANON) THEN
              DO I = 1, IROOT-1
                SO=DOTPS(NGW,MSUB,C1(1,1,I),C2(1,1))
                CALL GLOSUM(1,SO)
                CALL DAXPY(2*NGW*MSUB,-SO,C1(1,1,I),1,C2(1,1),1)
              ENDDO
            ELSE
              CALL STATE_ORTHO(C1,C2,CS,UMAT,IROOT,NSTATE,MSUB,SCR,LSCR)
            ENDIF
            ORES=DOTPS(NGW,MSUB,C2,C2)
            CALL GLOSUM(1,ORES)
            CALL DCOPY(2*NGW*MSUB,CB,1,C1(1,1,IROOT),1)
            IF(PARENT.AND.TDACANON) THEN
              T2=TIMEF()
              TCPU=(T2-T1)*1.D-3
              WRITE(6,'(T25,I4,5X,G15.6,5X,F12.2)') ITER,ORES,TCPU
            ENDIF
            IF(ORES.LT.EPSTDAV) GOTO 1000
            IF(EXSOFT) GOTO 1001
            T1=TIMEF()
C           Precondtitoning of gradients
            DO IS=1,MSUB
              ID=NSTATE-MSUB+IS
              DO IG=1,NGW
                C2(IG,IS)=C2(IG,IS)/(VPP(IG)-EIGV(ID))
              ENDDO
            ENDDO
C           Update
            DGG=DOTPS(NGW,MSUB,C2,C2)
            CALL GLOSUM(1,DGG)
            IF(ITER.EQ.1) THEN
              CALL DCOPY(2*NGW*MSUB,C2,1,CH,1)
            ELSE
              GAM=DGG/GG
              CALL DAXPY(2*NGW*MSUB,GAM,CH,1,C2,1)
              CALL DCOPY(2*NGW*MSUB,C2,1,CH,1)
            ENDIF
            GG=DGG
            IF(TDPCGMIN) THEN
              LAM=TDPCGSTEP
              IF(PARENT) WRITE(6,*) "WARNING:not implemented"
            ELSE
              LAM=TDPCGSTEP
            ENDIF
            CALL DAXPY(2*NGW*MSUB,-LAM,CH,1,CB,1)
            CALL LR_ORTHOS(NSTATE,MSUB,C0,CB(1,1),SCR,LSCR)
            IF(TDACANON) THEN
              DO I = 1, IROOT-1
                SO=DOTPS(NGW,MSUB,C1(1,1,I),CB(1,1))
                CALL GLOSUM(1,SO)
                CALL DAXPY(2*NGW*MSUB,-SO,C1(1,1,I),1,CB,1)
              ENDDO
            ELSE
              CALL STATE_ORTHO(C1,CB,CS,UMAT,IROOT,NSTATE,MSUB,SCR,LSCR)
            ENDIF
            SO=DOTPS(NGW,MSUB,CB,CB)
            CALL GLOSUM(1,SO)
            CALL DSCAL(2*NGW*MSUB,1.D0/DSQRT(SO),CB,1)
          ENDDO
 1000     CONTINUE
          IF(PARENT.AND..NOT.TDACANON.AND. KPRINT.GE.0 ) THEN
            T2=TIMEF()
            TCPU=(T2-T1)*1.D-3
            WRITE(6,'(T25,I4,5X,G15.6,5X,F12.2)') ITER,ORES,TCPU
          ENDIF
          IF(TDACANON) GOTO 1002
          IF(TEIG(IROOT).LT.TEIGOLD) THEN
            TEIGOLD=TEIG(IROOT)
            CALL AZZERO(UGRAD,NSTATE*MSUB)
            CALL AZZERO(CGRAD,NSTATE*MSUB)
            CALL LRU_FORCE(C0,C1(1,1,IROOT),C2,CGRAD,PSI,DRHOE,UFMAT,
     &                   SCR,LSCR,NSTATE,MSUB)
            CALL DSCAL(NSTATE*MSUB,-1.D0,CGRAD,1)
            CALL XGRAD(UROT(1,1,IROOT),UGRAD,CGRAD,
     &               PMAT,PEIG,NSTATE,MSUB,SCR,LSCR)
            SO=DDOT(NSTATE*MSUB,UGRAD,1,UGRAD,1)
            IF(PARENT.AND. KPRINT.GE.0 ) THEN
              WRITE(6,'(A,I4,T48,A)') ' STEP :',IROT,
     &                                ' SUBSPACE ROTATION'
              WRITE(6,'(A,G15.6,T31,A,F12.4)') ' GRADIENT',SO,
     &         ' EXCITATION ENERGY (eV)',2.D0*TEIG(IROOT)*RY
            ENDIF
            IF(SO.LT.EPSROT) GOTO 1002
            IF(IROT.NE.1.AND.ITER.EQ.1) GOTO 1002
            IF(EXSOFT) GOTO 1001
            IF(PARENT) THEN
              RG=SO
              IF(IROTEFF.EQ.1) THEN
                CALL DCOPY(NSTATE*MSUB,UGRAD,1,UH,1)
              ELSE
                GAM=RG/RDG
                CALL DAXPY(NSTATE*MSUB,GAM,UH,1,UGRAD,1)
                CALL DCOPY(NSTATE*MSUB,UGRAD,1,UH,1)
              ENDIF
              RDG=RG
              CALL DAXPY(NSTATE*MSUB,-ROTSTEP,UH,1,UROT(1,1,IROOT),1)
            ENDIF
            IROTEFF=IROTEFF+1
          ELSE
            IF(EXSOFT) GOTO 1001
            IF(PARENT.AND. KPRINT.GE.0 ) THEN
              SO=0.D0
              WRITE(6,'(A,I4,T48,A)') ' STEP :',IROT,
     &                                ' SUBSPACE ROTATION'
              WRITE(6,'(A,G15.6,T31,A,F12.4)') ' GRADIENT',SO,
     &         ' EXCITATION ENERGY (eV)',2.D0*TEIG(IROOT)*RY
              WRITE(6,'(A,I4,T48,A)') ' Step back, reinitialize PCG '
              IF(IROTEFF.EQ.1) THEN
                ROTB=0.5D0*ROTB
              ELSE
                ROTB=0.5D0*ROTSTEP
              ENDIF
              CALL DAXPY(NSTATE*MSUB,ROTB,UH,1,UROT(1,1,IROOT),1)
            ENDIF
            IROTEFF=1
          ENDIF
#ifdef PARALLEL
          MSGLEN = NSTATE*MSUB * 8
          CALL MY_BCAST(UROT(1,1,IROOT),MSGLEN,SOURCE,ALLGRP)
#endif
        ENDDO
 1002   CONTINUE
      ENDDO
 1001 CONTINUE
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_VPP)
      CALL FREEM(IP_CB)
      CALL FREEM(IP_CS)
      CALL FREEM(IP_CH)
      IF(.NOT.TDACANON) THEN
        CALL FREEM(IP_FMAT)
        CALL FREEM(IP_UMAT)
        CALL FREEM(IP_UFMAT)
        CALL FREEM(IP_UGRAD)
        CALL FREEM(IP_UH)
        CALL FREEM(IP_PMAT)
        CALL FREEM(IP_PEIG)
        CALL FREEM(IP_CGRAD)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_TD_PCG(LTD_PCG,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER      LTD_PCG
      CHARACTER*30 TAG
C     Variables
      INTEGER LLR_FORCE,LLR_ORTHO,LLR_SUB
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_LR_FORCE(LLR_FORCE,"TDA",TAG)
      CALL GIVE_SCR_LR_ORTHO(LLR_ORTHO,N,TAG)
      IF(TDA.AND.MSUBTA.GT.0.AND..NOT.TDACANON) THEN
        CALL GIVE_SCR_LRU_FORCE(LLR_SUB,MSUBTA,TAG)
      ELSE
        LLR_SUB=0
      ENDIF
      LTD_PCG=MAX(LLR_FORCE,LLR_ORTHO,LLR_SUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE STATE_ORTHO(C1,CB,CS,UMAT,IROOT,NSTATE,MSUB,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER      IROOT,NSTATE,MSUB,LSCR
      COMPLEX*16   C1(NGW,MSUB,*),CB(NGW,*),CS(NGW,*)
      REAL*8       UMAT(NSTATE,MSUB,*),SCR(*)
C     Variables
      INTEGER      IR
      REAL*8       SO,DOTPS
      EXTERNAL     DOTPS
C     ==--------------------------------------------------------------==
      DO IR=1,IROOT-1
        CALL DGEMM('T','N',MSUB,MSUB,NSTATE,1.D0,UMAT(1,1,IR),NSTATE,
     &             UMAT(1,1,IROOT),NSTATE,0.D0,SCR,MSUB)
        CALL DGEMM('N','N',2*NGW,MSUB,MSUB,1.D0,C1(1,1,IR),2*NGW,
     &             SCR,MSUB,0.D0,CS,2*NGW)
        SO=DOTPS(NGW,MSUB,CS,CB)
        CALL GLOSUM(1,SO)
        CALL DAXPY(2*NGW*MSUB,-SO,CS,1,CB,1)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
