C     ==================================================================
      SUBROUTINE TDCHARGE(RHOE,TAU0,PSI,VTEMP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'geq0.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'fft.inc'
C     Arguments
      REAL*8     RHOE(*),TAU0(*)
      COMPLEX*16 PSI(*),VTEMP(*)
C     Variables
      REAL*8     ACHRG(*),ECHRG(*),RSCR(*),EFIELD(*)
      POINTER    (IP_ACHRG,ACHRG),(IP_ECHRG,ECHRG)
      COMPLEX*16 EIROP(*),EIVPS(*),QPHI(*)
      POINTER    (IP_EIROP,EIROP),(IP_EIVPS,EIVPS),(IP_QPHI,QPHI),
     &           (IP_EFIELD,EFIELD),(IP_RSCR,RSCR)
      INTEGER    ISEL(*),IPPC,I,IG,LEN,LQPHI,ISUB
      POINTER    (IP_ISEL,ISEL)
C     ==--------------------------------------------------------------==
C     ==  CALCULATE ATOMIC CHARGES                                    ==
C     ==--------------------------------------------------------------==
      CALL TISET('  TDCHARGE',ISUB)
      CALL MEMORY(IP_ACHRG,NAT+1,'ACHRG')
      CALL MEMORY(IP_ECHRG,NAT+1,'ECHRG')
      CALL MEMORY(IP_EIROP,2*NHG,'EIROP')
      CALL MEMORY(IP_EIVPS,2*NHG,'EIVPS')
      IF(TCLUST .AND. (PS_TYPE.EQ.1)) THEN
#ifdef PARALLEL
        LQPHI = (NR1H+1)*NR2H*NR3PL
#else
        LQPHI = (NR1H+1)*NR2H
#endif
      ELSE
        LQPHI = 1
      ENDIF
      CALL MEMORY(IP_QPHI,2*NHG,'QPHI')
      CALL MEMORY(IP_RSCR,NNR1,'RSCR')
C
      CALL ATOMC(RHOE,PSI,TAU0,ACHRG)
      DO I=1,NNR1
        PSI(I)=DCMPLX(RHOE(I),0.D0)
      ENDDO
      CALL FWFFT(PSI)
      DO IG=1,NHG
        VTEMP(IG) = PSI(NZH(IG))
      ENDDO
      CALL EICALC(EIVPS,EIROP)
      CALL ELSTPO(VTEMP,EIROP,EIVPS,PSI,QPHI,TAU0)
      CALL DCOPY(2*NHG,PSI,1,VTEMP,1)
      CALL ZAZZERO(PSI,MAXFFT)
!CDIR NODEP
      DO IG=1,NHG
          PSI(INDZ(IG)) = DCONJG(VTEMP(IG))
          PSI(NZH(IG))  = VTEMP(IG)
      ENDDO
      IF(GEQ0.AND.TCLUST) THEN
        PSI(NZH(1)) = VTEMP(1)
      ELSEIF(GEQ0) THEN
        PSI(NZH(1)) = DCMPLX(0.D0,0.D0)
      ENDIF
      CALL INVFFT(PSI)
      DO I=1,NNR1
        RSCR(I)=DREAL(PSI(I))
      ENDDO
      LEN=NNR1/IRAT + 1
      CALL MEMORY(IP_ISEL,LEN,'ISEL')
      CALL SELECTP(ISEL,TAU0,IPPC)
      LEN=(NAT+1)*IPPC
      CALL MEMORY(IP_EFIELD,LEN,'EFIELD')
      DO I=1,IPPC
        EFIELD(I)=RSCR(ISEL(I))
      ENDDO
      CALL ATFIELD(EFIELD,PSI,VTEMP,EIROP,QPHI,ISEL,IPPC)
      CALL ESPSOLV(EFIELD,ECHRG,IPPC)
      IF(PARENT) CALL PRINTCG(TAU0,ACHRG,ECHRG)
C
      CALL FREEM(IP_ACHRG)
      CALL FREEM(IP_ECHRG)
      CALL FREEM(IP_ISEL)
      CALL FREEM(IP_RSCR)
      CALL FREEM(IP_QPHI)
      CALL FREEM(IP_EFIELD)
      CALL FREEM(IP_EIVPS)
      CALL FREEM(IP_EIROP)
C
      CALL TIHALT('  TDCHARGE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TDDIPO(DMOM,RHOE,TAU0,PSI)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cppt.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      COMPLEX*16 DMOM(3),PSI(*)
      REAL*8     RHOE(*),TAU0(3,NAX,*)
C     Variables
      COMPLEX*16 CONE
      PARAMETER  (CONE=(1.D0,0.D0))
      COMPLEX*16 GMIN(3),GMAX(3),EMIN(3),EMAX(3),DR(3),RDR(3),RSUM(3),
     &           SUM,CG,CG1,CG2,CG3
      REAL*8     RCC(3),RMIN(3),RMAX(3),G(3),G1,G2,G3,CHRLD
      REAL*8     D1,D2,D3,DD,X0(3),ZVTOT,OGK
      INTEGER    ISUB,I,K,IG,IPM,J,IA,IS,IG1
C     ==--------------------------------------------------------------==
      CALL TISET('    TDDIPO',ISUB)
C
      IF(IBRAV.NE.1 .AND. IBRAV.NE.8) THEN
        CALL STOPGM("TDDIPO","only works with cubic cells")
      ENDIF
      IF(TCLUST.AND.PS_TYPE.EQ.1)
     *   CALL STOPGM('TDDIPO','HOCKNEY NOT IMPLEMENTED')
C     infact we only need to set the origin to the center of box and
C     also calculate the ionic contribution
C
      X0(1)=0.D0
      X0(2)=0.D0
      X0(3)=0.D0
      ZVTOT=0.D0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          X0(1)=X0(1)+ZV(IS)*TAU0(1,IA,IS)
          X0(2)=X0(2)+ZV(IS)*TAU0(2,IA,IS)
          X0(3)=X0(3)+ZV(IS)*TAU0(3,IA,IS)
        ENDDO
        ZVTOT=ZVTOT+NA(IS)*ZV(IS)
      ENDDO
      X0(1)=X0(1)/ZVTOT
      X0(2)=X0(2)/ZVTOT
      X0(3)=X0(3)/ZVTOT
C
      DO I=1,NNR1
        PSI(I)=DCMPLX(RHOE(I),0.D0)
      ENDDO
      CALL FWFFT(PSI)
C
      RMIN(1)=X0(1)-0.5D0*A1(1)
      RMAX(1)=X0(1)+0.5D0*A1(1)
      RMIN(2)=X0(2)-0.5D0*A2(2)
      RMAX(2)=X0(2)+0.5D0*A2(2)
      RMIN(3)=X0(3)-0.5D0*A3(3)
      RMAX(3)=X0(3)+0.5D0*A3(3)
C     RCC: coordinates of the center of charge
      DO K=1,3
        RCC(K)=(RMIN(K)+RMAX(K))/2
        DMOM(K)=0.D0
      ENDDO
C     calculate integration range relative to center of charge
C     sum over all components of the wave function
      IG1=1
      IF(GEQ0) THEN
        IG1=2
        CG=PSI(NZH(1))
        DO K=1,3
          RDR(K)=0.5D0*(RMAX(K)*RMAX(K)-RMIN(K)*RMIN(K))
          DR(K)=RMAX(K)-RMIN(K)
        ENDDO
        DMOM(1)=DMOM(1)-CG*DR(2)*DR(3)*(RDR(1)-DR(1)*RCC(1))
        DMOM(2)=DMOM(2)-CG*DR(1)*DR(3)*(RDR(2)-DR(2)*RCC(2))
        DMOM(3)=DMOM(3)-CG*DR(1)*DR(2)*(RDR(3)-DR(3)*RCC(3))
      ENDIF
      DO IG=IG1,NHG
C       sum twice (for positive and negative g values)
        DO IPM=-1,1,2
          DO K=1,3
            G(K)=GK(K,IG)*TPIBA*IPM
            GMIN(K)=UIMAG*G(K)*RMIN(K)
            GMAX(K)=UIMAG*G(K)*RMAX(K)
            EMIN(K)=EXP(GMIN(K))
            EMAX(K)=EXP(GMAX(K))
            IF(ABS(GK(K,IG)).GT.1.D-8) THEN
              OGK=1.D0/G(K)
              RDR(K)=-((GMAX(K)-CONE)*EMAX(K)-
     *                 (GMIN(K)-CONE)*EMIN(K))*OGK*OGK
              DR(K)=-UIMAG*(EMAX(K)-EMIN(K))*OGK
            ELSE
              RDR(K)=0.5D0*(RMAX(K)*RMAX(K)-RMIN(K)*RMIN(K))
              DR(K)=RMAX(K)-RMIN(K)
            ENDIF
          ENDDO
          CG=DCMPLX(DREAL(PSI(NZH(IG))),DIMAG(PSI(NZH(IG)))*IPM)
          DMOM(1)=DMOM(1)-CG*DR(2)*DR(3)*(RDR(1)-DR(1)*RCC(1))
          DMOM(2)=DMOM(2)-CG*DR(1)*DR(3)*(RDR(2)-DR(2)*RCC(2))
          DMOM(3)=DMOM(3)-CG*DR(1)*DR(2)*(RDR(3)-DR(3)*RCC(3))
        ENDDO
      ENDDO
      CALL GLOSUM(6,DMOM(1))
C
      IF(PARENT) THEN
        WRITE(6,*)
        WRITE(6,'(A)') ' DIPOLE MOMENT '
        D1=DREAL(DMOM(1))
        D2=DREAL(DMOM(2))
        D3=DREAL(DMOM(3))
        DD=SQRT(D1*D1+D2*D2+D3*D3)
        WRITE(6,'(3(10X,A),8X,A)') ' X',' Y',' Z',' TOTAL'
        WRITE(6,'(3F12.5,F15.5,A)') D1,D2,D3,DD,'  atomic units'
        WRITE(6,'(3F12.5,F15.5,A)') AU_DEB*D1,AU_DEB*D2,AU_DEB*D3,
     &                              AU_DEB*DD,'  Debye'
        WRITE(6,*)
      ENDIF
C
      CALL TIHALT('    TDDIPO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
