C     ==================================================================
      SUBROUTINE TD_RDIIS(C0,C1,C2,SC0,CB,CS,NROOT,NBDIM,NCONV,
     &                    VPP,DDXC,PSI,EIGV,DRHOE,
     &                    TEIG,SCR,LSCR,NSTATE,ORBITAL,KPRINT)
C     ==--------------------------------------------------------------==
C     ==               updates the wavefunctions                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'norm.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER    LSCR,NSTATE,KPRINT,NROOT,NBDIM,NCONV
      COMPLEX*16 C0(NGW,*),C1(NGW,NSTATE,*),C2(NGW,*),SC0(*)
      COMPLEX*16 CS(NGW,NSTATE,*),CB(NGW,NSTATE,*)
      COMPLEX*16 PSI(*)
      REAL*8     EIGV(*),SCR(LSCR),DRHOE(*),DDXC(*),TEIG,VPP(*)
      CHARACTER*(*) ORBITAL
C     Variables
      INTEGER    MATMAX
      PARAMETER  (MATMAX=5)
      REAL*8     DISMAT(MATMAX,MATMAX),BC(MATMAX,MATMAX),VC(MATMAX)
      CHARACTER  TAG*30
      REAL*8  DOTPS,SO,TCPU,T1,T2,SIG,DEIJ,E2(5),VPPMIN,TIMEF
      EXTERNAL DOTPS,TIMEF
      REAL*8  RES1,RES2
      INTEGER LTD_RDIIS,NDIM,NNOW,NNEW,IG,IS,NDIIS,IB,ISTEP,IERR,NOLD
      INTEGER NRESTDIIS
C     ==--------------------------------------------------------------==
      IF(.NOT.TDA) CALL STOPGM("TD_DAV",
     &                       "ONLY TAMM-DANCOFF APPROXIMATION ALLOWED")
      CALL GIVE_SCR_TD_RDIIS(LTD_RDIIS,TAG)
      CALL TEST_SCR('TD_RDIIS',TAG,LSCR,LTD_RDIIS)
C     ==--------------------------------------------------------------==
      IF ( PARENT .AND. KPRINT.GE.0 ) THEN
        WRITE(6,'(A,T62,I4)')
     &       ' >>> RESIDUAL DIIS OPTIMIZATION OF ROOT ',NROOT
        WRITE(6,'(A,T43,A)') 
     &   '  ITER      ENERGY      SUBSPACE','   RESIDUAL        TCPU'
      ENDIF
C
      RES1=1.D10
      RES2=1.D10
      NDIIS=MIN(NBDIM,MATMAX-1)
      CALL AZZERO(DISMAT,MATMAX*MATMAX)
      T1=TIMEF()
      PREC=.TRUE.
      CALL SETVPP(VPP,NGW,LR_HTHRS,VPPMIN)
C..initilize vectors
      CALL DCOPY(2*NGW*NSTATE,C1(1,1,NROOT),1,CB,1)
      CALL LR_ORTHO(NSTATE,C0,CB,SCR,LSCR)
      SO=DOTPS(NGW,NSTATE,CB,CB)
      CALL GLOSUM(1,SO)
      SO=1.D0/DSQRT(SO)
      CALL DSCAL(2*NGW*NSTATE,SO,CB,1)
      NRESTDIIS=0
      NNEW=1
      DO ISTEP=1,NTDIISMAX
        NNOW=NNEW
        NDIM=MIN(NDIIS,ISTEP)
C..calculate error vector (residual)
        CALL LR_FORCE(C0,CB(1,1,NNOW),CS(1,1,NNOW),SC0,E2,
     &                DDXC,PSI,DRHOE,EIGV,
     &                SCR,LSCR,NSTATE,"TDA",ORBITAL)
        CALL LR_ORTHO(NSTATE,C0,CS(1,1,NNOW),SCR,LSCR)
        TEIG=-DOTPS(NGW,NSTATE,CB(1,1,NNOW),CS(1,1,NNOW))
        CALL GLOSUM(1,TEIG)
        CALL DAXPY(2*NGW*NSTATE,TEIG,CB(1,1,NNOW),1,CS(1,1,NNOW),1)
        SO=DOTPS(NGW,NSTATE,CS(1,1,NNOW),CS(1,1,NNOW))
        CALL GLOSUM(1,SO)
        T2=TIMEF()
        TCPU=(T2-T1)*0.001D0
        IF(PARENT.AND.KPRINT.GE.0) 
     &     WRITE(6,'(I6,3X,F9.5,9X,I5,T34,G20.8,T58,F8.2)')
     &             ISTEP,TEIG*2.D0*RY,NDIM,SO,TCPU
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        IF(SO.LT.EPSTDAV) NCONV=NCONV+1
        IF(SO.LT.EPSTDAV .OR. EXSOFT) GOTO 1000
        IF(SO.GT.RDIISTIN) GOTO 1000
        IF(NRESTDIIS.GT.NRESTDMAX) GOTO 1000
        IF(RES2.LT.SO) THEN
          NOLD=MOD(NDIIS+NNOW-2,NDIIS)+1
          CALL DCOPY(2*NGW*NSTATE,CB(1,1,NOLD),1,C1(1,1,NROOT),1)
          DO IS=1,NROOT-1
            SO=DOTPS(NGW,NSTATE,C1(1,1,IS),C1(1,1,NROOT))
            CALL GLOSUM(1,SO)
            CALL DAXPY(2*NGW*NSTATE,-SO,C1(1,1,IS),1,C1(1,1,NROOT),1)
          ENDDO
          SO=DOTPS(NGW,NSTATE,C1(1,1,NROOT),C1(1,1,NROOT))
          CALL GLOSUM(1,SO)
          SO=1.D0/DSQRT(SO)
          CALL DSCAL(2*NGW*NSTATE,SO,C1(1,1,NROOT),1)
          RES1=1.D10
          RES2=1.D10
          NNEW=1
          CALL DCOPY(2*NGW*NSTATE,C1(1,1,NROOT),1,CB,1)
          NRESTDIIS=NRESTDIIS+1
          GOTO 999
        ENDIF
        RES2=RES1
        RES1=SO
        T1=TIMEF()
C       Apply preconditioner
        DO IS=1,NSTATE
          IF(INDEX(ORBITAL,"CANON").NE.0) THEN
            IB=IS
            SIG=-1.D0
          ELSE
            IB=(IS-1)*NSTATE+IS
            SIG=1.D0
          ENDIF
          DEIJ=SIG*EIGV(IB)+TEIG
          DO IG=1,NGW
            CS(IG,IS,NNOW)=CS(IG,IS,NNOW)/(VPP(IG)+DEIJ)
          ENDDO
        ENDDO
C       DIIS matrix
        DO IS=1,NDIM
          SO=DOTPS(NGW,NSTATE,CS(1,1,IS),CS(1,1,NNOW))
          CALL GLOSUM(1,SO)
          DISMAT(IS,NNOW)=SO
          DISMAT(NNOW,IS)=SO
        ENDDO
        CALL DCOPY(MATMAX*MATMAX,DISMAT,1,BC,1)
        DO IS=1,NDIM+1
          VC(IS)=0.D0
          BC(IS,NDIM+1)=-1.D0
          BC(NDIM+1,IS)=-1.D0
        ENDDO
        VC(NDIM+1)=-1.D0
C       Solve System of Linear Equations
        IF(NDIM.EQ.1) THEN
          IERR=0
          VC(1)=1.D0
        ELSE
          IERR=0
          CALL DISSOL(BC,MATMAX,NDIM+1,VC,IERR)
        ENDIF
        IF(IERR.NE.0) THEN
          DO IS=1,NDIM
            VC(IS)=0.D0
          ENDDO
          VC(NNOW)=1.D0
          NDIIS=MAX(NDIIS-1,1)
        ENDIF
C       Setup new vector
        NNEW=MOD(NNOW,NDIIS)+1
        CALL ZAZZERO(C2,NGW*NSTATE)
        DO IS=1,NDIM
          CALL DAXPY(2*NGW*NSTATE,VC(IS),CB(1,1,IS),1,C2,1)
        ENDDO
        CALL DCOPY(2*NGW*NSTATE,C2,1,CB(1,1,NNEW),1)
        CALL ZAZZERO(C2,NGW*NSTATE)
        DO IS=1,NDIM
          CALL DAXPY(2*NGW*NSTATE,VC(IS),CS(1,1,IS),1,C2,1)
        ENDDO
        CALL LR_ORTHO(NSTATE,C0,C2,SCR,LSCR)
        CALL DAXPY(2*NGW*NSTATE,1.D0,C2,1,CB(1,1,NNEW),1)
        SO=DOTPS(NGW,NSTATE,CB(1,1,NNEW),CB(1,1,NNEW))
        CALL GLOSUM(1,SO)
        SO=1.D0/DSQRT(SO)
        CALL DSCAL(2*NGW*NSTATE,SO,CB(1,1,NNEW),1)
 999    CONTINUE
      ENDDO
      NNOW=NNEW
 1000 CONTINUE
      CALL DCOPY(2*NGW*NSTATE,CB(1,1,NNOW),1,C1(1,1,NROOT),1)
      DO IS=1,NROOT-1
        SO=DOTPS(NGW,NSTATE,C1(1,1,IS),C1(1,1,NROOT))
        CALL GLOSUM(1,SO)
        CALL DAXPY(2*NGW*NSTATE,-SO,C1(1,1,IS),1,C1(1,1,NROOT),1)
      ENDDO
      SO=DOTPS(NGW,NSTATE,C1(1,1,NROOT),C1(1,1,NROOT))
      CALL GLOSUM(1,SO)
      SO=1.D0/DSQRT(SO)
      CALL DSCAL(2*NGW*NSTATE,SO,C1(1,1,NROOT),1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_TD_RDIIS(LTD_RDIIS,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'elct.inc'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER      LTD_RDIIS
      CHARACTER*30 TAG
C     Variables
      INTEGER LLR_FORCE,LLR_ORTHO
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_LR_FORCE(LLR_FORCE,"TDA",TAG)
      CALL GIVE_SCR_LR_ORTHO(LLR_ORTHO,N,TAG)
      LTD_RDIIS=MAX(LLR_FORCE,LLR_ORTHO)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DISSOL(B,LDB,NDIM,V,IERR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER LDB,NDIM,IERR
      REAL*8  B(LDB,NDIM),V(LDB)
C     Variables
      INTEGER NR,LW,MAXDIS
      PARAMETER (MAXDIS=20)
      REAL*8  TOLEIG
      REAL*8  SCR1(MAXDIS+1,MAXDIS+1),SCR2(MAXDIS+1,MAXDIS+1)
C     ==--------------------------------------------------------------==
      IF(NDIM.GT.MAXDIS+1) THEN
        WRITE(6,*) 'DISSOL! NDIM=',NDIM,' MAXDIS+1=',MAXDIS+1
        CALL STOPGM('DISSOL','NDIM GREATER THAN MAXDIS+1')
      ENDIF
      TOLEIG=1.D-8
      LW=(MAXDIS+1)*(MAXDIS+1)
      CALL DGELSS(NDIM,NDIM,1,B,LDB,V,LDB,SCR1,TOLEIG,NR,SCR2,LW,IERR)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
