C     ==================================================================
      subroutine scalar_product_r(phi,hphi,nstate,neigv)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'elct.inc'
C     -- Arguments --
      integer    nstate
      real*8     neigv(nstate)
      complex*16 phi(2*ngw,nstate)
      complex*16 hphi(2*ngw,nstate)
C     -- Variables --
      integer    lst
      real*8     ddot
      dimension  f(nstate)
C
      do lst=1,nstate
       neigv(lst)=ddot(2*ngw*2,phi(1,lst),1,hphi(1,lst),1)
#ifdef PARALLEL
        call glosum(1,neigv(lst))
#endif
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine pos_oper(pos,dir)
C     COMPUTES the position operator referred to a Cartesian coordinate
C     system placed at the center of the box
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'coor.inc'
      include 'ions.inc'
C     -- Arguments --
      integer dir
      real*8  pos(nnr1)
C     -- Variables --
      integer ir,ir1,ir2,ir3,is,ia,count
      real*8  x,y,z,x0,y0,z0,dx,dy,dz,help
      real*8  r,r2,rmax,rmax2
C
      call azzero(pos,nnr1)
C     -- Origin --
C     call phfac(tau0)
      x0=0.D0
      y0=0.D0
      z0=0.D0
      help=0.D0
      do is=1,nsp
        do ia=1,na(is)
           x0=x0+tau0(1,ia,is)*zv(is)
           y0=y0+tau0(2,ia,is)*zv(is)
           z0=z0+tau0(3,ia,is)*zv(is)
           help=help+zv(is)
        enddo
      enddo
      x0=x0/help
      y0=y0/help
      z0=z0/help
C
C     -- Mesh parameters --
      dx=a1(1)/float(nr1s)
      dy=a2(2)/float(nr2s)
      dz=a3(3)/float(nr3s)

C     -- Position oprtator --
      call azzero(pos,nnr1)
      rmax=0.5D0*a1(1)
      rmax2=rmax**2
       do ir3=1,nr3
          do ir2=1,nr2
             do ir1=nrxpl(mepos,1),nrxpl(mepos,2)
               x=(ir1-1)*dx-x0+dx/2.d0
               y=(ir2-1)*dy-y0+dy/2.d0
               z=(ir3-1)*dz-z0+dz/2.d0
               ir=(ir3-1)*nr1*nr2   +
     &            (ir2-1)*nr1       +
     &            ir1               -
     &            nrxpl(mepos,1) + 1
                r2=X**2+Y**2+Z**2
C               if (r2.lt.rmax2) then
                  if (dir.eq.1) then
                     pos(ir)=x
                  elseif (dir.eq.2) then
                     pos(ir)=y
                  elseif (dir.eq.3) then
                     pos(ir)=z
                  elseif (dir.eq.4) then
                     pos(ir)=x+y
                  elseif (dir.eq.5) then
                     pos(ir)=x+y+z
                  endif
C               endif
            enddo
         enddo
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ================================================================== 
      subroutine getnorm_k(phi,nstate,norms)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'elct.inc'
C     -- Arguments
      integer    nstate
      real*8     norms(nstate)
      complex*16 phi(ngwk,nstate)
C     -- Variables
      integer    lst
      real*8     ddot
      complex*16 zdotc
      dimension  f(nstate)
C
      do lst=1,nstate
       norms(lst)=dreal(zdotc(ngwk,phi(1,lst),1,phi(1,lst),1))
      enddo
#ifdef PARALLEL
      call glosum(nstate,norms)
#endif
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine donorm_k(phi,nstate)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'elct.inc'
C     -- Arguments
      integer    nstate
      real*8     norms(nstate)
      complex*16 phi(ngwk,nstate)
C     -- Variables
      integer    lst,ig
      real*8     ddot
      complex*16 zdotc
      dimension  f(nstate)
C
      do lst=1,nstate
       norms(lst)=dreal(zdotc(ngwk,phi(1,lst),1,phi(1,lst),1))
      enddo
#ifdef PARALLEL
      call glosum(nstate,norms)
#endif
C
      do lst=1,nstate
        do ig=1,ngwk
          phi(ig,lst)=phi(ig,lst)/norms(lst)
        enddo
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine maxnorm_k(phil,dist)
C     ==--------------------------------------------------------------==
      include 'system.h'  ! ngw
      include 'geq0.inc'  ! geq0
      include 'elct.inc'  ! n
      include 'fft.inc'   ! 
      include 'cppt.inc'  ! 
      include 'td_input.inc' 
C     -- Arguments
      real*8     dist
      complex*16 phil(ngwk,n,nzeros,2)
C     -- Variables
      integer    lst,nstate,ig,ir,t_n,msglen,lead,leadx,nnrx,
     &           ia,ib,ibb,nsta,fi,i,ifft,njump
      real*8     help
      complex*16 phi1(2*ngw,n),phi2(2*ngw,n)
      pointer    (ip_phi1,phi1),(ip_phi2,phi2)
      dimension  F(N)
#ifdef PARALLEL
      integer nl2,ix1,ixp,ix
#endif
#ifdef __DERF
      external derf
#endif
C     ==--------------------------------------------------------------==
      nstate=n   
      dist=0.D0
      msglen= 8
      call memory(ip_phi1,4*ngw*nstate,'phi1')
      call memory(ip_phi2,4*ngw*nstate,'phi2')
C 
      do t_n=1,nzeros
C     ---------------
       do lst=1,nstate
        do ig=1,ngwk
         phi1(ig,lst)=phil(ig,lst,t_n,1)
         phi2(ig,lst)=phil(ig,lst,t_n,2)
         help=dreal((phi1(ig,lst)-phi2(ig,lst)) *
     &              dconjg(phi1(ig,lst)-phi2(ig,lst)) )
         if (help.gt.dist) dist=help
        enddo
       enddo
#ifdef PARALLEL
         call glomax(1,dist)  
#endif
      enddo
C     -----
#ifdef PARALLEL
      call my_bcast(dist,msglen,source,allgrp) 
#endif
      call freem(ip_phi1)
      call freem(ip_phi2)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine kick(c2,nstate,norms,pos,phi,psi)
C     -- Momentum kick to the wavefunctions                           --
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'geq0.inc'
      include 'fft.inc'
      include 'cppt.inc'
      include 'cnst.inc'
      include 'elct.inc'
      include 'td_input.inc'
C     -- Arguments:
      integer    nstate
      real*8     norms(nstate),pos(nnr1)
      complex*16 c2(ngwk,nstate),phi(ngwk,nstate),
     &           psi(*),psire(*)
C     -- Variables:
      integer    lst,ig,ig1,ir,lead,leadx,nnrx,ifft,njump,
     &           ia,ib,ibb,nsta,fi,i
      real*8     dotp,norm,help
      complex*16 chelp,fp,fm,expp
      pointer    (ip_psire,psire)
      dimension  f(n)
#ifdef PARALLEL
      integer    msglen,nl2,ix1,ixp,ix
#endif
#ifdef __DERF
      external derf
#endif
C     ==--------------------------------------------------------------==
#ifdef PARALLEL
      lead  = kr1s*ngrays
      leadx = nnr1
      ifft  = 1
#else
      lead  = nnr1
      leadx = nnr1
      nnrx=nnr1
#endif
      call get_addr(ip_psire,psi(1))
C
      if(geq0) then
C       The first component is for G=0.
       ig1=2
      else
       ig1=1
      endif
C
      do lst=1,nstate
         if (geq0) then
           phi(1,lst)=dcmplx(dreal(c2(1,lst)),0.0d0)
           phi(ngw+1,lst)=dcmplx(0.D0,0.D0)
         endif
         do ig=ig1,ngwk
           phi(ig,lst)=c2(ig,lst)
         enddo
      enddo
C 
      njump=nogrp
C
      do ia=1,nstate,njump
C
        call azzero(psi,2*maxfft*nogrp)
        nsta=min(nstate-ia+1,nogrp)
        do ib=1,nsta
          i=ia+(ib-1)
          ibb=(ib-1)*lead
          do ig=1,ngw
c           the +g component of the state i
            psi(nzhs(ig)+ibb)=phi(ig,i)
c           the -g component of the state i
            psi(indzs(ig)+ibb)=phi(ig+ngw,i)
          enddo
          if(geq0) psi(nzhs(1)+ibb)=phi(1,i)
        enddo
C          
        if(ifft.eq.1) then
          call s_invfft(psi)
        else
          call sg_invfft(psi)
        endif
C
        ig=1
        do ir=1,nnr1
         if (psi(ir).ne.0.D0) then
C          psi(ir)=(1.0D0+uimag*ampl*pos(ig))*psi(ir)
           help=pos(ig)*ampl
           expp=dcmplx(dcos(help),-dsin(help))
           psi(ir)=psi(ir)*expp
           ig=ig+1
         endif
        enddo
C
        if(ifft.eq.1) then
          call s_fwfft(psire)
        else
          call sg_fwfft(psire)
        endif
C
        do ib=1,nsta 
          i=ia+(ib-1)
          ibb=(ib-1)*lead
          fi=f(i)
          if(fi.eq.0.d0) fi=2.d0
          do ig=1,ngw
            fp=psi(nzhs(ig)+ibb)
            fm=psi(indzs(ig)+ibb)
            phi(ig,    i)=fp
            phi(ig+ngw,i)=fm
          enddo
          if(geq0)phi(1+ngw,i)=dcmplx(0.d0,0.d0) 
        enddo 
C
      enddo
C
      call getnorm_k(phi,nstate,norms)
C 
      do lst=1,nstate
       do ig=1,ngw
        phi(ig,lst)=phi(ig,lst)*(1.D0/dsqrt(norms(lst)))
        phi(ig+ngw,lst)=phi(ig+ngw,lst)*(1.D0/dsqrt(norms(lst)))
       enddo
      enddo
C
      call getnorm_k(phi,nstate,norms)
C
      do lst=1,nstate
       if (parent) write(6,'(1x,A,I5,A,F12.6)')
     &  'Norm of the perturbed orbital',
     &  lst,'   :',norms(lst)
      enddo
C
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine gaugepot_ind(gpot0,gpot1,t_np,time,c0,c2,scr,lscr)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'geq0.inc'  ! geq0
      include 'elct.inc'
      include 'cnst.inc'
      include 'cppt.inc'
      include 'kpnt.inc'
      include 'irat.inc'
      include 'ener.inc'
      include 'td_input.inc'
      include 'coor.inc'
c
C     Arguments
      integer    t_np,lscr
      complex*16 c0(ngwk,n),c2(ngwk,n)
      real*8     gpot0,gpot1,time(nzeros),scr(*)
C     variables
      dimension  rk(3,nkpts),f(n)
      integer    i,ig,msglen,nstate,lforces
      real*8     b,d,d1,d2,p,y(2),dydt(2),ynew(2),abst,dt,rhoe(*)
      complex*16 zdotc,cpx,cpy,cpz,cpr,zs
      logical    debug,update_p,update_d
      character  tag*30
      complex*16 auxc(*)
      integer    lrnlsm
      pointer    (ip_auxc,auxc),(ip_rhoe,rhoe)

      integer    ifirst
      data       abst /0.D0/
      data       ifirst /0/
      save       ifirst,abst
C
      nstate=n
c     call memory(ip_auxc,2*ngwk*nax,'auxc')
      call memory(ip_auxc,max(2*(nnr1+100),2*ngwk*nax),'auxc')
      call memory(ip_rhoe,nnr1,'rhoe')
      call give_scr_rnlsm(lrnlsm,tag,nstate,.false.)
      lrnlsm=lrnlsm+100
C
      debug   =.false.
      update_p=.false.
      update_d=.false.
C
      if(tkgauge)then
        call stopgm(' gaugepot_cayl',' tkgauge not implemented ')
      endif
C
      dt=time(1)
C
      abst=abst+dt
      if (parent.and.debug) write(6,*) dt,abst
C    ----------------------------------------------------
C     CALCULATION OF d (constant term, not dependent on A)
c     d=0.d0
c     do i=1,nstate
c       call calc_pij(c0(1,i),c0(1,i),cpx,cpy,cpz,1)
c       if (pertdir.eq.1) then
c         cpr=cpx
c       elseif(pertdir.eq.2) then
c         cpr=cpy
c       elseif(pertdir.eq.3) then
c         cpr=cpz
c       endif
#ifdef PARALLEL
c       call glosum(2,cpr)
#endif
c       d=d+f(i)*dreal(cpr)*tpiba
c     enddo
      d=0.d0
      do i=1,nstate
       call calc_pij(c0(1,i),c0(1,i),cpx,cpy,cpz,1)
       if (pertdir.eq.1) then
         cpr=cpx
       elseif(pertdir.eq.2) then
         cpr=cpy
       elseif(pertdir.eq.3) then
         cpr=cpz
       endif
#ifdef PARALLEL
       call glosum(2,cpr)
#endif
        d=d+f(i)*dreal(cpr)*tpiba
      enddo
      d1=d
      d=0.d0
      do i=1,nstate
       call calc_pij(c2(1,i),c2(1,i),cpx,cpy,cpz,1)
        if (pertdir.eq.1) then
          cpr=cpx
        elseif(pertdir.eq.2) then
          cpr=cpy
        elseif(pertdir.eq.3) then
          cpr=cpz
        endif
#ifdef PARALLEL
        call glosum(2,cpr)
#endif
        d=d+f(i)*dreal(cpr)*tpiba
      enddo
      d2=d
      d=(d1+d2)/2.d0
C    ----------------------------------------------------
C     CALCULATION OF p (PP dependent part)
      if (ppcorr) then
       if (update_p) then
c        call rnlsmg(c0,nstate,auxc,lrnlsm,1,0) ! fnl rotated
c        call rnlsmg(c0,nstate,auxc,lrnlsm,1,1) ! fnlgp
        genl=0.d0
        call rnlrhg(genl,nstate,1)
#ifdef PARALLEL
        call glosum(1,genl)
#endif
       else
        genl=0.d0
       endif
      else
       genl=0.d0
      endif
      p=genl
C     -------------------------------------------
      b=(fpi/omega)*nel
      d=(fpi/omega)*d
      p=(fpi/omega**2)*p
c     p=(fpi/omega)*p
C     29.03.05 ----------------------------------
      d=-1.d0*d
      b=-1.d0*b
      p=-1.d0*p
      if (parent) write(118,'(5f18.12)') abst,gpot,gpot1,enl,genl
C     29.03.05 ----------------------------------
      y(1)=gpot0
      y(2)=gpot1
      dydt(1)=y(2)
      dydt(2)=d+b*y(1)+p
      call rk4_ind(d,b,p,y,dydt,2,abst,dt,ynew,c0,c2,n,update_d)
      gpot0=ynew(1)
      gpot1=ynew(2)
C     gpot=gpot0
C
      if (debug) then
       write(6,'(i4,7e14.5)') me,b,d,genl,p,gpot
      endif
C
      call my_sync(allgrp)
      call freem(ip_auxc)
      call freem(ip_rhoe)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine rk4_ind(d,b,p,y,dydt,ny,t,dt,yout,c0,c2,nstate,
     &                    update_d)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cnst.inc'
      include 'ener.inc'
      include 'td_input.inc'

      INTEGER    ny,nmax,nstate
      REAL*8     d,b,p,dt,t,dydt(ny),y(ny),yout(ny)
      complex*16 c0(ngwk,*),c2(ngwk,*)
      logical    update_d
      parameter  (nmax=2)
      integer    i
      real*8     h6,hh,th,dym(nmax),dyt(nmax),yt(nmax)
C
      hh=dt*0.5D0
      h6=dt/6.D0
      th=t+hh
      do i=1,ny
       yt(i)=y(i)+hh*dydt(i)
      enddo
      call derivs(1,c0,c2,d,b,p,nstate,update_d,yt,dyt)
      do i=1,ny
       yt(i)=y(i)+hh*dyt(i)
      enddo
      call derivs(1,c0,c2,d,b,p,nstate,update_d,yt,dym)
      do i=1,ny
        yt(i)=y(i)+dt*dym(i)
        dym(i)=dyt(i)+dym(i)
      enddo
      call derivs(2,c0,c2,d,b,p,nstate,update_d,yt,dyt)
      do i=1,ny
        yout(i)=y(i)+h6*(dydt(i)+dyt(i)+2.d0*dym(i))
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine derivs(step,c0,c2,d,b,p,nstate,update_d,yt,dyt)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cnst.inc'
      include 'ener.inc'
      include 'td_input.inc'
      include 'elct.inc'
C
      integer    nstate
      real*8     d,d1,d2,b,p
      complex*16 c0(ngwk,*),c2(ngwk,*),cpx,cpy,cpz,cpr
      logical    update_d
      integer    i
      real*8     dyt(2),yt(2)
      integer    step
      dimension f(nstate)
c
c     update d
      if (update_d) then
       if (parent) write(6,*) 'rk4 update d'
       if (step.eq.1) then
        d=0.d0
        do i=1,nstate
        call calc_pij(c0(1,i),c0(1,i),cpx,cpy,cpz,1)
         if (pertdir.eq.1) then
           cpr=cpx
         elseif(pertdir.eq.2) then
           cpr=cpy
         elseif(pertdir.eq.3) then
           cpr=cpz
         endif
#ifdef PARALLEL
         call glosum(2,cpr)
#endif
         d=d+f(i)*dreal(cpr)*tpiba
        enddo
        d=(fpi/omega)*d
        d1=-1.d0*d
        d=0.d0
        do i=1,nstate
        call calc_pij(c2(1,i),c2(1,i),cpx,cpy,cpz,1)
         if (pertdir.eq.1) then
           cpr=cpx
         elseif(pertdir.eq.2) then
           cpr=cpy
         elseif(pertdir.eq.3) then
           cpr=cpz
         endif
#ifdef PARALLEL
         call glosum(2,cpr)
#endif
         d=d+f(i)*dreal(cpr)*tpiba
        enddo
        d=(fpi/omega)*d
        d2=-1.d0*d
        d=(d1+d2)/2.d0
       elseif (step.eq.2) then
        d=0.D0
        do i=1,nstate
         call calc_pij(c2(1,i),c2(1,i),cpx,cpy,cpz,1)
#ifdef PARALLEL
         call glosum(2,cpz)
#endif
         d=d+f(i)*dreal(cpz)*tpiba
        enddo
        d=(fpi/omega)*d
        d=-1.d0*d
       endif
      endif
C     update p
C     ----------------------------------------------------------------==
      dyt(1)=yt(2)
      dyt(2)=d+b*yt(1)+p
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine gaugepot_laser(gpot0,gpot1,t)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'td_input.inc'
      include 'cnst.inc'
C     -- Arguments --
      real*8 gpot0,gpot1,t
C     -- Variables --
      real*8 swtf,ampli
      real*8 freq,tp
      real*8 osc
      integer i,imax
C
      if (.not. pi_pulse) then
C       pulse shape: E(t)= E0 sin(pi/T t)^2 sin(freq t)
C       use ampl    for E0
C           gdfreq  for 1/T
C       gpot is the gauge pot A=-dE(t)/dt
C       A=-1/4 * E0 (    Cos[(2 pi/T + freq)t]/(2 pi/T + freq)  
C                      - 2 Cos[freq t]/freq 
C                      - Cos[(2 pi/T - freq)t]/(2 pi/T - freq) 
C                   )
        ampli=ampl
        if (t .gt. gswtt) then
          swtf=1.D0
        else
          swtf=t/gswtt
        endif
        gpot0=-0.25*ampl*
     &        (
     &          dcos((2.0*pi*gdfreq+gfreq)*t)/(2.0*pi*gdfreq+gfreq) -
     &          dcos((2.0*pi*gdfreq-gfreq)*t)/(2.0*pi*gdfreq-gfreq) -
     &          2.0*dcos(gfreq*t)/(gfreq)
     &        )
C       gpot=gpot0
      else
        osc=muij
        if (parent) then
         write(6,*) 'PI-PULSE, \mu_AB',muij
         call my_flush(6)
        endif
C       F(t)=ampl*sin^2(pi/TP*t)
C       E(t)=F(t)*cos(w*t)
C       Tp=n 2 pi/omega
C       F(t)=ampl*sin^2(w*t/n)
C       A(t)=\int E(t)=....
C        tp=nperiod*(2.D0*Pi/gfreq)
C        gpot0= ampl*(gfreq/nperiod)*
C     &       ((-1.D0+nperiod**2-(nperiod**2)*cos(t*gfreq/nperiod))
C     &       *sin(t*gfreq)+nperiod*cos(t*gfreq)*sin(t*gfreq/nperiod))/
C     &        (2*gfreq*(nperiod**2 -1.0))
        gpot0=ampl*(
     &             -sin((4*ampl*osc-gfreq)*t)/(4*(4*ampl*osc-gfreq)) +
     &              sin(gfreq*t)/(2*gfreq)                           -
     &              sin((4*ampl*osc+gfreq)*t)/(4*(4*ampl*osc+gfreq))
     &             )
C       gpot=gpot0
      endif
C
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine dext_pot(t,elfield,icall)
C     COMPUTES the position operator referred to a Cartesian coordinate
C     system placed at the center of the box
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'efld.inc'
      include 'cnst.inc'
      include 'td_input.inc'
      include 'dipo.inc'
C     -- Arguments --
      real*8  t,elfield
      integer icall
C     -- Variables --
      integer ir,ir1,ir2,ir3,is,ia,i,j,count
      real*8  x,y,z,x0,y0,z0,dx,dy,dz,xmax,ymax,zmax,dist2
      real*8  extf(kr1,kr2s,*),swtf,swtt,freq,dfreq,beta,nampl
      real*8  fx,fy,fz
      integer imax
      logical  fexist
      character  filen*30
C     == Origin ==================================================
      x0=0.D0
      y0=0.D0
      z0=0.D0
C     ------------------------------------------------------------
      dfreq=0.0002
      imax=0

C     beta=(imax)**2/5.0
      beta=1.0

      swtt=50.0
C     ------------------------------------------------------------
C
C     == Mesh parameters =========================================
      dx=a1(1)/float(nr1S)
      dy=a2(2)/float(nr2s)
      dz=a3(3)/float(nr3s)
C     ============================================================
C
      call azzero(extf,kr1*kr2s*kr3s)
C
C     time dependent switching function
C     -------------------------------------------------------------
      if (t .gt. swtt) then
       swtf=1.D0
      else
       swtf=t/swtt
      endif
C     -------------------------------------------------------------
C
      if (parent) write(6,*) '  swtf     dfreq    tdfreq   ampl'
      if (parent) write(6,'(4F9.4)') swtf,dfreq,tdfreq,ampl
C
      do ir3=1,kr3s
          do ir2=1,kr2s
              do ir1=1,kr1
C                 X=(nrxpl(mepos,1)+ir1-2)*dx-x0 ! +dx/2.d0
C                 Y=(ir2-1)*dy-y0                ! +dy/2.d0
C                 Z=(ir3-1)*dz-z0                ! +dz/2.d0
C                 ir=(ir3-1)*nr1*nr2   +
C     &              (ir2-1)*nr1       +
C     &              ir1               -
C     &              nrxpl(mepos,1) + 1
                  X=dmom(1)
                  Y=dmom(2)
                  Z=dmom(3)
C       kill the boundaries
C       -------------------------------------------------------------
                 fx=-1.0+1.D0/(dexp(-2.D0*a1(1)*(X-0.1*a1(1)))+1.D0)+
     &                   1.D0/(dexp(2.D0*a1(1)*(X-0.9*a1(1)))+1.D0)
                 fy=-1.0+1.D0/(dexp(-2.D0*a2(2)*(Y-0.1*a2(2)))+1.D0)+
     &                   1.D0/(dexp(2.D0*a2(2)*(Y-0.9*a2(2)))+1.D0)
                 fz=-1.0+1.D0/(dexp(-2.D0*a3(3)*(Z-0.1*a3(3)))+1.D0)+
     &                   1.D0/(dexp(2.D0*a3(3)*(Z-0.9*a3(3)))+1.D0)

                 do i=-imax,imax
C       set the frequency and amplitude
C       -------------------------------------------------------------
                  freq=tdfreq+i*dfreq
C                 nampl=ampl*exp(-(i**2)/beta)
C                 nampl=nampl/(dsqrt(pi*beta))
C                 nampl=nampl*10.0
                  nampl=ampl
                  elfield=nampl*swtf*dcos(freq*t)
C       -------------------------------------------------------------
                  if (pertdir.eq.1) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)
     &                                -nampl*X*swtf*dcos(freq*t)*fx
                  elseif (pertdir.eq.2) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)
     &                                -nampl*Y*swtf*dcos(freq*t)*fy
                  elseif (pertdir.eq.3) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)
     &                                -nampl*Z*swtf*dcos(freq*t)*fz
                  elseif (pertdir.eq.4) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)
     &                       -nampl*(X*fx+Y*fy)*swtf*dcos(freq*t)
                  elseif (pertdir.eq.5) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)
     &                       -nampl*(X*fx+Y*fy+Z*fz)*swtf*dcos(freq*t)
                  endif
                enddo
C
              enddo
          enddo
      enddo
C
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine dext_pipot(t,elfield)
C     COMPUTES the position operator referred to a Cartesian coordinate
C     system placed at the center of the box
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'efld.inc'
      include 'cnst.inc'
      include 'td_input.inc'
      include 'dipo.inc'
c     -- Arguments --
      real*8  t,elfield
c     -- Variables --
      integer ir,ir1,ir2,ir3
      real*8  x,y,z,x0,y0,z0,dx,dy,dz
      real*8  extf(kr1,kr2s,*),nampl
      logical  fexist
      character  filen*30
C     == Origin ==================================================
      x0=0.D0
      y0=0.D0
      z0=0.D0
C     ------------------------------------------------------------
C     == Mesh parameters =========================================
      dx=a1(1)/float(nr1s)
      dy=a2(2)/float(nr2s)
      dz=a3(3)/float(nr3s)
C     ============================================================
C
      if (parent) then
        write(6,*) 'computing the pi_pulse'
      endif
C
      call azzero(extf,kr1*kr2s*kr3s)
C
      do ir3=1,kr3s
          do ir2=1,kr2s
            do ir1=1,kr1

                 x=(nrxpl(mepos,1)+ir1-2)*dx-x0
                 y=(ir2-1)*dy-y0+dy/2.d0
                 z=(ir3-1)*dz-z0+dz/2.d0
c                if (me.eq.0) write(111,*) x,y,z
c                if (me.eq.1) write(112,*) x,y,z
c                if (me.eq.41) write(113,*) x,y,z

                 ir=(ir3-1)*nr1*nr2   +
     &              (ir2-1)*nr1       +
     &              ir1               -
     &              nrxpl(mepos,1) + 1

C                 ---------------------------------------------------
                  nampl=ampl*((sin(2.0*ampl*muij*t))**2)*cos(tdfreq*t)
                  elfield=nampl
C                 ---------------------------------------------------
                  if (pertdir.eq.1) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)+nampl*x
                  elseif (pertdir.eq.2) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)+nampl*y
                  elseif (pertdir.eq.3) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)+nampl*z
                  elseif (pertdir.eq.4) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)+nampl*(x+y)
                  elseif (pertdir.eq.5) then
                     extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)+nampl*(x+y+z)
                  endif
C
              enddo
          enddo
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine dext_ch(t)
C     COMPUTES the position operator referred to a Cartesian coordinate
C     system placed at the center of the box
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'efld.inc'
      include 'cnst.inc'
      include 'td_input.inc'
C     -- Arguments --
      real*8  t
C     -- Variables --
      integer ir,ir1,ir2,ir3,is,ia,i,j,count
      real*8  x,y,z,x0,y0,z0,dx,dy,dz,xmax,ymax,zmax
      real*8  extf(kr1,kr2s,*),f,r
      real*8  charg1(3),freq,dist1,dist2
      real*8  fx,fy,fz,fr
      real*8  temp,gaussb
C     -- Origin --
      x0=0.D0
      y0=0.D0
      z0=0.D0
C     -- Mesh parameters --
      dx=a1(1)/float(nr1s)
      dy=a2(2)/float(nr2s)
      dz=a3(3)/float(nr3s)
      charg1(1)=a1(1)*pchfx+dx/2.D0
      charg1(2)=a2(2)*pchfy+dy/2.D0
      charg1(3)=a3(3)*pchfz+dz/2.D0
C
      temp=0.1
      gaussb=0.1
      call azzero(extf,kr1*kr2s*kr3s)
C     ------------------------
      if ((t.gt.(pcht0-pchdt/2.0)).and.(t.lt.(pcht0+pchdt/2.0))) then
      if (parent) write(6,*) 'ADD EXTERNAL PULSE'
C     ------------------------
      do ir3=1,kr3s
          do ir2=1,kr2s
              do ir1=1,kr1
                 x=(nrxpl(mepos,1)+ir1-2)*dx-x0 ! +dx/2.d0
                 y=(ir2-1)*dy-y0                ! +dy/2.d0
                 z=(ir3-1)*dz-z0                ! +dz/2.d0
                 ir=(ir3-1)*nr1*nr2   +
     &              (ir2-1)*nr1       +
     &              ir1               -
     &              nrxpl(mepos,1) + 1
C
                 fx=-1.0+1.d0/(dexp(-temp*a1(1)*(x-0.15*a1(1)))+1.d0)+
     &                   1.d0/(dexp(temp*a1(1)*(x-0.85*a1(1)))+1.d0)
                 fy=-1.0+1.d0/(dexp(-temp*a2(2)*(y-0.15*a2(2)))+1.d0)+
     &                   1.d0/(dexp(temp*a2(2)*(y-0.85*a2(2)))+1.d0)
                 fz=-1.0+1.d0/(dexp(-temp*a3(3)*(z-0.15*a3(3)))+1.d0)+
     &                   1.d0/(dexp(temp*a3(3)*(z-0.85*a3(3)))+1.d0)
                 r=dsqrt(x**2+y**2+z**2)
                 fr=-1.0+1.d0/(dexp(-temp*a1(1)*(r-0.1*a1(1)))+1.d0)+
     &                   1.d0/(dexp(temp*a1(1)*(r-0.9*a1(1)))+1.d0)

                 dist1=dsqrt((x-charg1(1))**2+
     &                       (y-charg1(2))**2+
     &                       (Z-charg1(3))**2 )
C
C                extf(ir1,ir2,ir3)= extf(ir1,ir2,ir3)
C     &                    +1.0D0                       *
C     &                    (2.D0*gaussb/Pi)**(3.D0/4.D0) *
C     &                     EXP(-gaussb*dist1)
C                extf(ir1,ir2,ir3)= extf(ir1,ir2,ir3)
C     &                    -1.0D0                        *
C     &                    (2.D0*gaussb/Pi)**(3.D0/4.D0) *
C     &                     EXP(-gaussb*dist2)

                 extf(ir1,ir2,ir3)=-pchint *  ! (dcos(pfreq*t))
     &                      1.D0/dist1
C     &                    (dexp(-dist1/1.0))/dist1
C                extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)*fx*fy*fz
C                extf(ir1,ir2,ir3)=extf(ir1,ir2,ir3)*fr
C
              enddo
          enddo
      enddo
C     ------------------------
      endif
C     ------------------------
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine dyn_analysis(first,c0,rhoe,rhoer,rhog,psi,scr,lscr,
     &                        nstate,respo,time)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'coor.inc'
      include 'td_input.inc'
      include 'geq0.inc'
      include 'cppt.inc'
      include 'cnst.inc'
C     -- Arguments
      integer nstate,lscr
      logical first
      real*8  time,rhoe(nnr1,*),rhoer(*),scr(*)
      complex*16 c0(*),rhog(*),psi(*),respo(*)
C     -- Variables
      real*8  rsusc(5000),isusc(5000),lindh(5000),
     &        mingl(5000),maxgl(5000),meangl(5000)
      integer i,ir,ig,ig1,ish,ind,maxish,indk
      logical fexist
      real*8  ga,gb,gc,gmax,gmin,
     &        kf,nu,rcount
      character*12 cflbod,cipnum
      integer i1,i2,n1,n2
      character  filen*15
      integer    icall
      data       icall/0/
      save       icall

      if (icall.eq.0) then
       if (parent) then
          filen="suscept.dat"
          inquire(file=filen,exist=fexist)
          if(.not.fexist) then
            open(unit=177,file=filen,status='unknown')
          else
           open(unit=177,file=filen,status='unknown',
     &        position='append')
          endif
       endif
      endif
      icall=icall+1
C
      call rhoofr_c(c0,rhoe,psi,scr,lscr,nstate)
C
C     if (icall.ne.0) then
C     -- compute and write density difference against reference density (rhoer)
C     -- result in rhoe
      do i=1,nnr1
        rhoe(i,1)=rhoe(i,1)-rhoer(i)
      enddo
      call rhopri_eh(c0,tau0,rhoe,psi,scr,lscr,nstate,1)
C     endif
C     -- transform rhoe in G space
      call azzero(psi,2*nnr1)
      call azzero(rhog,2*nhg)
!$OMP parallel do private(ir)
      do ir=1,nnr1
         psi(ir)=dcmplx(rhoe(ir,1),0.d0)
      enddo
      call fwfft(psi)
!$OMP parallel do private(ig)
      do ig=1,nhg
         rhog(ig) = psi(nzh(ig))
      enddo
      if (geq0) then
        ig1=2
      else
        ig1=1
      endif
      ga=0.1d0
      gb=0.1d0
      gc=0.1d0
      call azzero(respo,2*nhg)
      gmax=0.0
      gmin=100000.0
      do ig=ig1,nhg
       if (hg(ig).gt.gmax) gmax=hg(ig)
       if (hg(ig).lt.gmin) gmin=hg(ig)
C       respo(ig)=rhog(ig)/(dcos(pfreq*time))
      enddo
      call glomin(1,gmin)
      call glomin(1,gmax)
      if (parent.and.(icall.eq.1))
     &  write(6,*) 'gmin, gmax :', gmin,gmin*tpiba,gmax,gmax*tpiba
C     write real and imaginary part of the suscettibility
      if(geq0)then
       ig1=2
      else
       ig1=1
      endif
C     run over the K vector shells
      call azzero(rsusc,5000)
      call azzero(isusc,5000)
      call azzero(lindh,5000)
      rcount=0.D0
      ind=0
      maxish=100
      do ish=ig1,nhgl
       if (ish.le.maxish) then
        ind=ind+1
        indk=nint(gl(ish))
        meangl(indk)=gl(ish)
        rcount=0.D0
        do ig=isptr(ish),isptr(ish+1)-1
         rsusc(indk)=rsusc(indk)+dreal(psi(nzh(ig)))
         isusc(indk)=isusc(indk)+dimag(psi(nzh(ig)))
         rcount=rcount+1.d0
        enddo
        rsusc(indk)=rsusc(indk)/rcount
        isusc(indk)=isusc(indk)/rcount
       endif
      enddo
      call glosum(5000,rsusc)
      call glosum(5000,isusc)
      rsusc=rsusc/nproc
      isusc=isusc/nproc
      call my_flush(6)
      if (parent) then
        do i=1,maxish
         write(177,'(5F29.16)')
     &    sqrt(real(i)),sqrt(real(i))*tpiba,
     &    rsusc(i),isusc(i)
        enddo
        call my_flush(177)
      endif
C
      goto 111
      call glomax(1,gmax)
      call glomin(1,gmin)
      if (parent) write(6,*) 'gmax,gmin',gmax,gmin
      cflbod='response.'
      write(cipnum,'(i4)') icall
      call xstring(cflbod,n1,n2)
      call xstring(cipnum,i1,i2)
      filen=cflbod(n1:n2)//cipnum(i1:i2)
      call densto(respo,tau0,filen)
 111  continue
C
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine currentoper(c0,rhoe,nstate,tau0,scr,lscr,psi,nkpoint)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'fft.inc'
      include 'geq0.inc'
      include 'elct.inc'
      include 'cppt.inc'
      include 'ions.inc'
      include 'kpnt.inc'
      include 'kpts.inc'
c     -- Arguments
      complex*16 c0(ngwk,*),psi(maxfft),scr(*)
      integer    nstate,lscr,nkpoint
      real*8     tau0(3,nax,nsx),rhoe(nnr1,*)
c     -- Variables
      complex*16 uimag
      complex*16 c0r(nnr1)
      complex*16 dc0(ngwk,3),dc0r(nnr1,3)
      real*8     curr_r(nnr1,*),maxcurr,center(3)
      integer    i,k,ig,ir,ig1,ikind,lst,nnat,isp,iat
      dimension  f(nstate),rk(3,*)
      pointer    (ip_c0r,c0r),(ip_dc0r,dc0r),(ip_dc0,dc0),
     &           (ip_curr_r,curr_r)
      character  filename*(20)
C
      call memory(ip_c0r,2*nnr1,'c0r')
      call memory(ip_dc0r,2*nnr1*3,'dc0r')
      call memory(ip_dc0,2*ngwk*3,'dc0')
      call memory(ip_curr_r,nnr1*3,'curr_r')
C
      center(1) = 0d0
      center(2) = 0d0
      center(3) = 0d0
      nnat = 0
      do isp=1,nsp
        do iat=1,na(isp)
          center(1) = center(1) + tau0(1,iat,isp)
          center(2) = center(2) + tau0(2,iat,isp)
          center(3) = center(3) + tau0(3,iat,isp)
          nnat = nnat + 1
        enddo
      enddo
      center(1) =  center(1) / dble(nnat)
      center(2) =  center(2) / dble(nnat)
      center(3) =  center(3) / dble(nnat)
C
      ikind=1
      call azzero(curr_r,nnr1*3)
      uimag=dcmplx(0.d0,1.d0)
C
C     see for instance SUBROUTINE CALC_PI
C
      do i=1,nstate
         do k=1,3
           do ig=1,ngw
            dc0(ig,k)=uimag*(rk(k,1)+gk(k,ig))*c0(ig,i)*tpiba
            dc0(ig+ngw,k)=uimag*(rk(k,1)-gk(k,ig))*c0(ig+ngw,i)*tpiba
           enddo
           if(geq0) dc0(1+ngw,k)=dcmplx(0.d0,0.d0)
         enddo
C
         call azzero(dc0r,2*nnr1*3)
         do k=1,3
            call azzero(psi,2*maxfft)
            do ig=1,ngw
               psi(nzhs(ig))=dc0(ig,k)
               psi(indzs(ig))=dc0(ig+ngw,k)
            enddo
            call s_invfft(psi)
            do ir=1,nnr1
               dc0r(ir,k)=psi(ir)/dsqrt(omega)
            enddo
         enddo
         call azzero(c0r,2*nnr1)
         call azzero(psi,2*maxfft)
         do ig=1,ngw
            psi(nzhs(ig))=c0(ig,i)
            psi(indzs(ig))=c0(ig+ngw,i)
         enddo
         call s_invfft(psi)
!$OMP parallel do private(ir)
         do ir=1,nnr1
            c0r(ir)=psi(ir)/dsqrt(omega)
         enddo
c
         do k=1,3
           do ir=1,nnr1
            curr_r(ir,k)=curr_r(ir,k)+0.5D0 * f(i) *
     &             dimag(
     &             dconjg(c0r(ir))   *       dc0r(ir,k) -
     &                    c0r(ir)    *dconjg(dc0r(ir,k))
     &             )
C            curr_r(ir,k)=curr_r(ir,k)+ f(i) *
C     &             dimag(dconjg(c0r(ir))* dc0r(ir,k))
           enddo
         enddo
      enddo
C
      maxcurr=0.D0
      do ir=1,nnr1
       do k=1,3
         if (curr_r(ir,k).gt.maxcurr) maxcurr=curr_r(ir,k)
       enddo
      enddo
      call glomax(1,maxcurr)

      if (parent) write(6,*) 'maxcurr :',maxcurr
      if (me.eq.10) write(6,*) 'maxcurr :',maxcurr

C     do ir=1,nnr1
C      do k=1,3
C         curr_r(ir,k)=curr_r(ir,k)/maxcurr
C      enddo
C     enddo
C
C     do k=1,3
C      call currpri(tau0,curr_r(1,1),psi,scr,lscr,nstate,nkpoint,k)
C     enddo
C
      filename="currx.cube"
      call cubefile(filename,curr_r(1,1),center,psi,.false.)
      filename="curry.cube"
      call cubefile(filename,curr_r(1,2),center,psi,.false.)
      filename="currz.cube"
      call cubefile(filename,curr_r(1,3),center,psi,.false.)
C
C     compute the velocity field
      do ir=1,nnr1
       do k=1,3
        curr_r(ir,k)=curr_r(ir,k)/rhoe(ir,1)
       enddo
      enddo
C
      filename="velx.cube"
      call cubefile(filename,curr_r(1,1),center,psi,.false.)
      filename="vely.cube"
      call cubefile(filename,curr_r(1,2),center,psi,.false.)
      filename="velz.cube"
      call cubefile(filename,curr_r(1,3),center,psi,.false.)
C
C     scale current
      maxcurr=0.D0
      do ir=1,nnr1
        curr_r(ir,1)=dsqrt(curr_r(ir,1)**2+
     &                     curr_r(ir,2)**2+
     &                     curr_r(ir,3)**2)
        if (curr_r(ir,1).gt.maxcurr) maxcurr=curr_r(ir,1)
      enddo
C
      call glomax(1,maxcurr)
      if (parent) write(6,'(A,F10.5)') 'max abs current :', maxcurr
!$OMP parallel do private(ir)
      do ir=1,nnr1
       curr_r(ir,1)=curr_r(ir,1)/maxcurr
      enddo
C
C     call currpri(tau0,curr_r(1,1),psi,scr,lscr,nstate,nkpoint,0)
      filename="curr_scaled.cube"
      call cubefile(filename,curr_r(1,1),center,psi,.false.)
C
      call freem(ip_c0r)
      call freem(ip_dc0r)
      call freem(ip_dc0)
      call freem(ip_curr_r)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine load_ex_states(c0)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'elct.inc'
      include 'geq0.inc'

C     -- Arguments
      complex*16 c0(ngwk,n)
C     -- Variables
      integer    nstate,itemp,state_number
      complex*16 vtemp(nhg)
      character  xll*1,numer*10,file_name*100
      integer    ist,ido,i,j
      pointer    (ip_vtemp,vtemp)
C
      call memory(ip_vtemp,2*nhg,'vtemp')
C     ==--------------------------------------------------------------==
      nstate=n
      do itemp=1,nstate
       call azzero(vtemp,2*nhg)
C       state_number=n-(itemp-1)   
       state_number=itemp
       ist=state_number
       if(ist.lt.0) then
        ido=-1
        ist=abs(ist)
       else
        ido=1
       endif
       if(abs(ido).eq.10) then
          xll='a'
       elseif(abs(ido).eq.100) then
         xll='b'
       else
         xll=' '
       endif
       write(numer,'(i6,a1)') ist,xll
       do i=1,len(numer)
         if(numer(i:i).ne.' ') then
           file_name='WAVEFUNCTION.'//numer(i:len(numer))
           goto 10
         endif
       enddo
 10    continue
       call densrd(vtemp,file_name)
       do j=1,ngw
        c0(j,state_number)=vtemp(j)
        c0(j+ngw,state_number)=dconjg(vtemp(j))
       enddo
       if (geq0)
     &  c0(ngw+1,state_number)=dcmplx(0.0d0,0.0d0)
      enddo
c
      call freem(ip_vtemp)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine  eh_initialize_data
     &   (rhoe,rhoer,rhog,v,psi,eirop,elfield,scr,
     &    lscr,nstate,norms,do_dipole,dmom0,work_time,last_time,
     &    gpot_i0,gpot_i1,gpot_l0,gpot_l1,ispin,icall,
     &    f_dipole,f_time,f_gauge_i,f_gauge_l,f_el)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'coor.inc'
      include 'cppt.inc'
      include 'dipo.inc'
      include 'ener.inc'
      include 'fft.inc'
      include 'spin.inc'
      include 'td_input.inc'
C     -- Arguments
      complex*16 psi(*)
      complex*16 v(*),eirop(nhg),rhog(*)
      real*8     rhoe(nnr1,*),eigv(nstate),scr(*),rhoer(*)
      real*8     dmom0(3),norms(*)
      real*8     work_time,last_time,elfield
      real*8     gpot_l0,gpot_l1,gpot_i0,gpot_i1
      integer    nstate,lscr,icall,ispin
      logical    first,do_dipole
      character*30 f_dipole,f_gauge_i,f_gauge_l,f_el,f_time
C     -- Variables
      integer   ir,ig,msglen
      real*8    rhoemax,norm
      character tag*30,filen*30
      logical   debug,fexist
C
      debug=.false.

C     === Initial dipol
C     -----------------
C
      if (icall.eq.0) then
        if (tpointch) then
         if (pchwr.eq.0) then
          call dcopy(nnr1*ispin,rhoe,1,rhoer,1)
          call azzero(psi,2*maxfft*nlsd)
          do ir=1,nnr1
            psi(ir)=dcmplx(rhoer(ir),0.D0)
          enddo
          call fwfft(psi)
          do ig=1,nhg
            rhog(ig)=psi(nzh(ig))
          enddo
          filen='DENSITY_REF'
          call densto(rhog,tau0,filen)
         else
          filen='DENSITY_REF'
          call densrd(v,filen)
          call ffttor(v,rhoer,psi,nhg,.false.)
         endif
        endif
        call azzero(v,2*maxfft*nlsd)
        call azzero(eirop,2*nhg)
        call eicalc(scr,eirop)
        rhoemax=0.D0
!$OMP parallel do private(ir)
        do ir=1,nnr1
         v(ir)=dcmplx(rhoe(ir,1),0.D0)
         if (rhoe(ir,1).gt.rhoemax) rhoemax=rhoe(ir,1)
        enddo
        call glomax(1,rhoemax)
        if (parent.and.debug) print*,'MAX DENSITY',rhoemax
        if (do_dipole) then
         call fwfft(v)
         call dipo(tau0,eirop,v)
         call dcopy(3,dmom,1,dmom0,1)
         if (parent) then
          write(6,'(/,1x,a,3f12.6,/)') 'Initial dipole components:',
     &     dmom0(1),dmom0(2),dmom0(3)
          inquire(file=f_dipole,exist=fexist)
          if(.not.fexist) then
           open(unit=50,file=f_dipole,status='UNKNOWN')
           work_time=0.D0
           close(50)
          else
           open(unit=50,file=f_dipole,status='UNKNOWN',
     &        position='APPEND')
           rewind(50)
           read(50,*) work_time,dmom0(1),dmom0(2),dmom0(3)
           close(50)
           open(unit=50,file=f_dipole,status='UNKNOWN',
     &        position='APPEND')
           backspace 50
           read(50,*) work_time,dmom(1),dmom(2),dmom(3)
           close(50)
          endif 
         endif
#ifdef PARALLEL
         call my_bcast(work_time,8,source,allgrp)
         msglen=8*3
         call my_bcast(dmom0,msglen,source,allgrp)
         call my_bcast(dmom,msglen,source,allgrp)
#endif         
         last_time=work_time
        endif
      endif 
C 
      if (tgaugep.or.tgaugef.or.td_extpot) then
C     ----------------------------------------
       if (icall.eq.0) then
        if (parent) then

         if (tgaugep) then
          inquire(file=f_gauge_i,exist=fexist)
          if (.not.fexist) then
            open(unit=72,file=f_gauge_i,status='UNKNOWN')
            if (.not.tgaugef) then
              gpot_i0=ampl
              gpot=ampl
            endif
            work_time=0.D0
            close(72)
          else
            open(unit=72,file=f_gauge_i,status='UNKNOWN',
     &        position='APPEND')
            backspace 72
            read(72,'(3d20.12)') work_time,gpot_i0,gpot_i1
            print*, ' Starting induced field ',work_time,gpot_i0,gpot_i1
            close(72)
          endif
         endif

         if (tgaugef)  then
          inquire(file=f_gauge_l,exist=fexist)
          if (.not.fexist) then
            open(unit=73,file=f_gauge_l,status='UNKNOWN')
            gpot_l0=0.D0
            gpot=0.D0
            work_time=0.D0
            close(73)
          else
            open(unit=73,file=f_gauge_l,status='UNKNOWN',
     &        position='APPEND')
            backspace 73
            read(73,'(3d20.12)') work_time,gpot_l0,gpot_l1
            print*, ' Starting laser field ',work_time,gpot_l0,gpot_l1
            close(73)
          endif
         endif

         if (td_extpot) then
          inquire(file=f_el,exist=fexist)
          if (.not.fexist) then
            open(unit=74,file=f_el,status='UNKNOWN')
            gpot_l0=0.D0
            gpot=0.D0
            work_time=0.D0
            close(74)
          else
            open(unit=74,file=f_el,status='UNKNOWN',
     &        position='APPEND')
            backspace 74
            read(74,'(2d20.12)') ttime,elfield
            print*, ' Starting field ',ttime,elfield
            work_time=ttime
            close(74)
          endif
         endif
C
        endif
#ifdef PARALLEL
        if (tgaugep.or.tgaugef) then
         if (tgaugef) then
           call my_bcast(gpot_l0,8,source,allgrp)
           call my_bcast(gpot_l1,8,source,allgrp)
         else
           call my_bcast(gpot_i0,8,source,allgrp)
           call my_bcast(gpot_i1,8,source,allgrp)
         endif
         call my_bcast(work_time,8,source,allgrp)
        elseif(td_extpot) then
         call my_bcast(elfield,8,source,allgrp)
        endif
#endif
        last_time=work_time
        gpot=gpot_l0+gpot_i0
       endif
C
      elseif (tpointch.and.(icall.eq.0)) then
C     ---------------------------------------
        if (parent) then
          inquire(file=f_time,exist=fexist)
          if (.not.fexist) then
            open(unit=53,file=f_time,status='UNKNOWN')
            work_time=0.D0
            close(53)
          else
           open(unit=53,file=f_time,status='UNKNOWN',
     &        position='APPEND')
           backspace 53
           read(53,'(3d20.12)') work_time
           close(53)
          endif
        endif
#ifdef PARALLEL
        call my_bcast(work_time,8,source,allgrp)
#endif
        last_time=work_time
      endif
C     -----
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine dipolox(posx,rhoe,dipox)
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cppt.inc'

      integer ig,ir
      real*8  posx(*),dipox
      real*8  rhoe(*)

      ig=1
      dipox=0.d0
      do ir=1,nnr1
       if (rhoe(ir).ne.0.0d0) then
        dipox=dipox+rhoe(ir)*posx(ig)
        ig=ig+1
       endif
      enddo
      dipox=dipox*(omega/(nr1s*nr2s*nr3s))
#ifdef PARALLEL
      call glosum(1,dipox)
#endif
c     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
C     SUBROUTINES FOR CHEBY INTERPOLATION
C     ==================================================================
      subroutine chbcf_zeros(n,t,chbcfzx,chbcfzt)
C     inputs: N, total number of points in time domain [0,...,T]
C             T, time intervall in a.u.
c     ==--------------------------------------------------------------==
      implicit none
C     -- Arguments:
      integer N
      real*8  T,chbcfzx(N),chbcfzt(N)
C     -- Variables:
      integer i
      real*8  pi
C
      pi=3.141592653589793D0
      do i=1,N
       chbcfzx(i)=-dcos(pi*((i-1)+0.5)/N)
       chbcfzt(i)=0.5*T*(1.D0+chbcfzx(i))
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine chbcf_delta(chbcfzt,nzeros,tintrvll,deltat)
c     ==--------------------------------------------------------------==
      implicit none
C     -- Arguments:
      integer nzeros
      real*8  tintrvll
      real*8  chbcfzt(nzeros),deltat(nzeros)
C     -- Variables:
      integer i
C
      deltat(1)=chbcfzt(1)+(tintrvll-chbcfzt(nzeros))
      do i=2,nzeros
       deltat(i)=chbcfzt(i)-chbcfzt(i-1)
      enddo
C
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine chbcf_expan_coeff_i(imat,n,chbcfzx)
C     inputs:  N      , total number of points in time domain [0,...,T]
C              chbcfzx, positions of the zeroes in the domain [-1,...,1]
C     outputs: IMAT      , coefficients matrix
C     ==--------------------------------------------------------------==
      implicit none
C     -- Arguments:
      integer N
      real*8  chbcfzx(N),IMAT(N,N),chbcff,sfkt,sfkt_num,sfkt_rec
C     -- Variables:
      integer i,j,k
      real*8  prec
C
      prec=0.001D0
C
      do i=1,n
       do j=1,n
c        imat(i,j)=(1.d0/(2*n))*chbcff(1,chbcfzx(i))*sfkt(1,chbcfzx(j))
c        imat(i,j)=(1.d0/(2*n))*chbcff(1,chbcfzx(i))
C     &                        *sfkt_num(1,chbcfzx(j),prec)
        imat(i,j)=(1.d0/(2*n))*chbcff(1,chbcfzx(i))
     &                        *sfkt_rec(0,chbcfzx(j))
        do k=2,n
c         imat(i,j)=imat(i,j)+(1.d0/n)*
C    &          chbcff(k,chbcfzx(i))*sfkt(k,chbcfzx(j))
c          imat(i,j)=imat(i,j)+(1.d0/n)*
C     &          chbcff(k,chbcfzx(i))*sfkt_num(k,chbcfzx(j),prec)
          imat(i,j)=imat(i,j)+(1.d0/n)*
     &          chbcff(k,chbcfzx(i))*sfkt_rec(k-1,chbcfzx(j))
        enddo
       enddo
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      function chbcff(i_order,x)
C     ==--------------------------------------------------------------==
      implicit none
C     -- Arguments:
      integer i_order
      real*8  chbcff,x
C     -- Variables:
      integer i_value
C
      i_value=i_order-1
      chbcff=dcos(i_value*dacos(x))
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      function sfkt(i_order,x)
C     ==--------------------------------------------------------------==
      implicit none
C     -- Arguments:
      integer i_order
      real*8  sfkt,x
C     -- Variables:
      integer i_value
      real*8 theta
C
      i_value=i_order-1
      theta=dacos(x)
      if ((i_value).eq.1) then
       sfkt=(dsin(theta)**2)/2.D0
      else
       sfkt=(x*dcos(i_value*theta) - 1
     &      +  (i_value)*dsin(i_value*theta)*dsin(theta))
     &      /   ((i_value)**2-1)
      endif
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      recursive function sfkt_rec(i_value,x) result(res)
C     ==--------------------------------------------------------------==
      implicit none
C     -- Arguments:
      integer i_value
      real*8  res,x
C     -- Variables:
      real*8 theta
C
      theta=dacos(x)
      if ((i_value).eq.0) then
       res=x+1.0D0
      elseif ((i_value).eq.1) then
       res=(x**2-1.D0)/2.D0
      else
       res=(2.D0*(x**2-1) * dcos((i_value-1)*theta)  +
     &       (i_value-3)*sfkt_rec(i_value-2,x))/(i_value+1)
      endif
C     ==--------------------------------------------------------------==
      end function sfkt_rec
C     ==================================================================
      function sfkt_num(i_order,x,dz)
C     ==--------------------------------------------------------------==
      implicit none
C     -- Arguments:
      integer i_order
      real*8  sfkt_num,x,dz
C     -- Variables:
      integer i_value,i,n_points
      real*8 interv,z,chbcff
C
      i_value=i_order-1
      interv=x+1.D0
      n_points=nint(interv/dz)+1

      sfkt_num=0.D0
      do i=1,n_points
       z=-1.0D0+(i-1)*dz
       sfkt_num=sfkt_num + chbcff(i_order,z) * dz
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine initial_guess_eigv(
     &        phi2,phil,num,nstate,neigv,chbcfzt,ciclo)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cnst.inc'
      include 'ions.inc'
      include 'fft.inc'
      include 'td_input.inc'
C     -- Arguments:
      integer    num,nstate,ciclo
      real*8     chbcfzt(nzeros),neigv(nstate),shift_t
      complex*16 phi2(2*ngw,nstate)
      complex*16 phil(2*ngw,nstate,nzeros,*)
C     -- Variables:
      integer    lst,t_n,ig
      real*8     coeff(nzeros)
      pointer    (ip_coeff,coeff)
C
      call memory(ip_coeff,nzeros,'coeff')
C
      if (ciclo.eq.1) then
       shift_t=0.0D0
      else
       shift_t=chbcfzt(1)
      endif
C
      do lst=1,nstate
        do t_n=1,nzeros
          coeff(t_n)=(shift_t+chbcfzt(t_n))*neigv(lst)
          do ig=1,2*ngw
           phil(ig,lst,t_n,num)=phi2(ig,lst)
     &       * dcmplx(dcos(coeff(t_n)),-dsin(coeff(t_n)))
          enddo
        enddo
      enddo
C
      call freem(ip_coeff)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine initial_guess_rec(
     &        phi2,num,nstate,neigv,chbcfzt,t_n,ciclo)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cnst.inc'
      include 'ions.inc'
      include 'fft.inc'
      include 'td_input.inc'
C     -- Arguments:
      integer    num,nstate,ciclo,t_n
      real*8     chbcfzt(nzeros),neigv(nstate)
      complex*16 phi2(2*ngw,nstate)
C     -- Variables:
      integer    lst,ig
      real*8     coeff(nzeros)
      pointer    (ip_coeff,coeff)
C
      call memory(ip_coeff,nzeros,'coeff')
C
      do lst=1,nstate
        if (t_n.eq.1.and.ciclo.eq.1) then
         coeff(1)=chbcfzt(1)*neigv(lst)
        elseif(t_n.eq.1.and.ciclo.gt.1) then
         coeff(1)=chbcfzt(1)*neigv(lst)*2
        else
         coeff(t_n)=(chbcfzt(t_n)-chbcfzt(t_n-1))*neigv(lst)
        endif
        do ig=1,2*ngw
         phi2(ig,lst)=phi2(ig,lst)
     &   * dcmplx(dcos(coeff(t_n)),-dsin(coeff(t_n)))
        enddo
      enddo
C
      call freem(ip_coeff)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine initial_guess_taylor(
     &        phi,phil,hphi,num,psi,nstate,
     &        rhoe,v,sc0,
     &        chbcfzt,ciclo,scr,lscr)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cnst.inc'
      include 'coor.inc'
      include 'ions.inc'
      include 'fft.inc'
      include 'sfac.inc'
      include 'spin.inc'
      include 'td_input.inc'
C     -- Arguments:
      integer    num,nstate,ciclo,lscr
      real*8     chbcfzt(nzeros),scr(*),rhoe(*)
      complex*16 phi(ngwk,nstate),hphi(ngwk,nstate),psi(*)
      complex*16 phil(ngwk,nstate,nzeros,*),sc0(ngwk,*),v(*)
C     -- Variables:
      integer    lst,t_n,ig,ispin
      real*8     coeff(*)
      real*8     fnl(*),dfnl(*)
      pointer    (ip_coeff,coeff)
C
      call memory(ip_coeff,nzeros,'coeff')
      ispin=nlsd
C
      do t_n=1,nzeros

        if (t_n.eq.1) then
          coeff(1)=chbcfzt(1)
          if (ciclo.gt.1) coeff(1)=2*coeff(1)
        else
          coeff(t_n)=(chbcfzt(t_n)-chbcfzt(t_n-1))
        endif

        do lst=1,nstate
          if (t_n.eq.1) then
           do ig=1,ngwk
            phil(ig,lst,1,num)=phi(ig,lst)
           enddo
          else
           do ig=1,ngwk
            phil(ig,lst,t_n,num)=phil(ig,lst,t_n -1,num)
            phi(ig,lst)=phil(ig,lst,t_n,num)
           enddo
          endif
        enddo

        call rhoofr_c(phi,rhoe,psi,scr,lscr,nstate)
        call vofrho(tau0,fion,rhoe,v,scr,lscr,.false.,.false.)
        call hpsi(phi,hphi,sc0,rhoe,psi,scr,lscr,nstate,1,ispin)

        do lst=1,nstate
          do ig=1,ngwk
           phil(ig,lst,t_n,num)=phil(ig,lst,t_n,num)-
     &                        uimag*hphi(ig,lst)*coeff(t_n)
          enddo
        enddo

        call hpsi(hphi,phi,sc0,rhoe,psi,scr,lscr,nstate,1,ispin)

        do lst=1,nstate
          do ig=1,ngwk
           phil(ig,lst,t_n,num)=phil(ig,lst,t_n,num)-0.5D0*
     &                       phi(ig,lst)*coeff(t_n)**2
          enddo
        enddo
C
      enddo
      call freem(ip_coeff)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine initial_guess_cayley(
     &        phi,phil,hphi,num,psi,nstate,
     &        rhoe,v,sc0,norms,
     &        chbcfzt,ciclo,scr,lscr)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cnst.inc'
      include 'coor.inc'
      include 'ions.inc'
      include 'fft.inc'
      include 'sfac.inc'
      include 'geq0.inc'
      include 'spin.inc'
      include 'td_input.inc'
C     -- Arguments:
      integer    num,nstate,ciclo,lscr
      real*8     chbcfzt(nzeros),scr(*),rhoe(nnr1,*),norms(*)
      complex*16 phi(ngwk,nstate),hphi(ngwk,nstate),psi(maxfft)
      complex*16 phil(ngwk,nstate,nzeros,*),sc0(ngwk,*),v(*)
C     -- Variables:
      integer    lst,t_n,ig,iter,itermax,ispin
      real*8     coeff(*),delta,deltamax,deltaold,tinc2,shift
      real*8     fnl(*),dfnl(*)
      complex*16 phiold,zdotc
      complex*16 phi0(ngwk,*),hphi0(ngwk,*)
      pointer    (ip_coeff,coeff),(ip_phi0,phi0),(ip_hphi0,hphi0)
C
      call memory(ip_coeff,nzeros,'coeff')
      call memory(ip_phi0,2*ngwk*nstate,'phi0')
      call memory(ip_hphi0,2*ngwk*nstate,'hphi0')
C
      itermax=1
      ispin=nlsd

      do t_n=1,nzeros

        if (t_n.eq.1) then
          coeff(1)=chbcfzt(1)
          if (ciclo.gt.1) coeff(1)=2*coeff(1)
        else
          coeff(t_n)=(chbcfzt(t_n)-chbcfzt(t_n-1))
        endif
        tinc2=coeff(t_n)/2.0D0
        do lst=1,nstate
          if (t_n.eq.1) then
           do ig=1,ngwk
            phil(ig,lst,1,num)=phi(ig,lst)
            phi0(ig,lst)=phi(ig,lst)
           enddo
          else
           do ig=1,ngwk
            phil(ig,lst,t_n,num)=phil(ig,lst,t_n -1,num)
            phi0(ig,lst)=phil(ig,lst,t_n,num)
           enddo
          endif
        enddo

C        call rhoofr_c(phi,rhoe,psi,scr,lscr,nstate)
C        call vofrho(tau0,fion,rhoe,v,scr,lscr,.false.,.false.)

        call hpsi(phi0,hphi0,sc0,rhoe,psi,scr,lscr,nstate,1,ispin)
        call dscal(2*ngwk*nstate,-1.0D0,hphi0(1,1),1)
C
        do lst=1,nstate
         call dcopy(2*ngwk,phi0(1,lst),1,phi(1,lst),1)
        enddo

        iter=0
        deltamax=1.D0
C       ---------------------------------------------------------------
 700    continue
        deltaold=deltamax
        call hpsi(phi,hphi,sc0,rhoe,psi,scr,lscr,nstate,1,ispin)
        call dscal(2*ngwk*nstate,-1.0D0,hphi(1,1),1)

        deltamax=0.D0
        do lst=1,nstate
         do ig=1,ngwk
          phiold=phi(ig,lst)

          phi(ig,lst)=phi0(ig,lst)
     &            - uimag * tinc2 * hphi0(ig,lst)
     &            - uimag * tinc2 * hphi(ig,lst)

           delta=abs(phiold-phi(ig,lst))
           if (delta.gt.deltamax) deltamax=delta
         enddo
        enddo
        call glomax(1,deltamax)
C       write(6,*) t_n,deltamax
        iter=iter+1
        if ((deltamax.gt.0.001).and.(deltamax.le.deltaold)) goto 700
C       ---------------------------------------------------------------

        if (geq0) call zclean_k(phi,nstate,ngw)
        do lst=1,nstate
          norms(lst)=dreal(zdotc(ngwk,phi(1,lst),1,phi(1,lst),1))
#ifdef PARALLEL
          CALL GLOSUM(1,norms(lst))
#endif
        enddo
C
        do lst=1,nstate
         call dscal(2*ngwk,1.D0/sqrt(norms(lst)),phi(1,lst),1)
         call dcopy(2*ngwk,phi(1,lst),1,phil(1,lst,t_n,num),1)
        enddo

        if (iter.gt.itermax) itermax=iter
      enddo
C
      if (parent)
     &   write(6,*) '  -- cayley max iteration steps',itermax
      call freem(ip_coeff)
      call freem(ip_phi0)
      call freem(ip_hphi0)
C
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
C     SUBROUTINES FOR OUTPUT
c     ==================================================================
      subroutine wrdens(filename,array,psi)
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'cell.inc'
      include 'gvec.inc'
      include 'ions.inc'
      include 'coor.inc'
      include 'cnst.inc'
      include 'irat.inc'
c     include 'response_p.inc'
C     ==--------------------------------------------------------------==
C     Arguments:
C     array: the R-space array to plot
C     filename: obvious
C     tau0: the ionic position vectors
C     center: the position (in the CPMD system) where I should place
C     \       the center of the plot
      character   filename*256,filename_b*256
      real*8      center(3),array(kr1,kr2s,kr3s),psi(kr2s,kr3s)

      integer     fileunit,iat,isp,ir,i1,i2,i3,ii1,ii2,ii3,ii3p,ia,ie,
     &     rgrid_m,ilowerleft(3),msglen,nbytes,msgid,source_pe,
     &     ig,fileunit_b

      real*8      lowerleft(3),int_dens
C     ==--------------------------------------------------------------==
      if (parent) then
C       center(1)=celldm(1)/2.D0
C       center(2)=celldm(1)*celldm(2)/2.D0
C       center(3)=celldm(1)*celldm(3)/2.D0
        do ir=1,3
           center(ir)=(a1(ir)+a2(ir)+a3(ir))/2.D0
        enddo
      endif
#ifdef PARALLEL
      msglen = 3*8
      call MY_BCAST(center,msglen,source,allgrp)
#endif

      do ir=1,3
         lowerleft(ir) = center(ir)
     &        - 0.5d0*(a1(ir)+a2(ir)+a3(ir))
      enddo
      do ir=1,3
         ilowerleft(ir) = rgrid_m(lowerleft,ir)
      enddo
      call putongrid_m(lowerleft)
C
      if (parent) then
         fileunit=2604
         call xstring(filename,ia,ie)
Cori         call fileopen(fileunit,filename(ia:ie),'UNKNOWN')
         call fileopen(fileunit,filename(ia:ie),'NEW')
         fileunit_b=2605
         filename_b=filename(ia:ie)//'_1d'
         ig=ie+3
         call fileopen(fileunit_b,filename_b(ia:ig),'NEW')

         write (2604,*) 'CPMD CUBE FILE.'
         write (2604,*) 'OUTER LOOP: X, MIDDLE LOOP: Y, INNER LOOP: Z'

         write (2604,200) nat, (lowerleft(ir),ir=1,3)
         write (2604,200) nr1s,(a1(ir)/DBLE(nr1s),ir=1,3)
         write (2604,200) nr2s,(a2(ir)/DBLE(nr2s),ir=1,3)
         write (2604,200) nr3s,(a3(ir)/DBLE(nr3s),ir=1,3)

         do isp=1,nsp
            do iat=1,na(isp)
               write (2604,201) iatyp(isp),0.0d0,
     &              (tau0(ir,iat,isp),ir=1,3)
            enddo
         enddo
      endif
C
      do i1=ilowerleft(1),nr1s+ilowerleft(1)-1
#ifdef PARALLEL
         call my_sync(allgrp)   ! to avoid long transfer queues
#endif
         ii1=i1
         if (ii1.gt.nr1s) ii1=ii1-nr1s
C     find the PE who has the plane i1:
         source_pe = 0
         do while (.NOT.
     &        (ii1.ge.nrxpl(source_pe,1) .and.
     &        ii1.le.nrxpl(source_pe,2)))
            source_pe = source_pe + 1
         enddo
         source_pe = pgroup(source_pe+1)

         if (mepos .eq. source_pe) then
            call dcopy(kr2s*kr3s,
     &           array(ii1-nrxpl(mepos,1)+1,1,1),kr1,
     &           psi,1)
            if (.NOT. parent) then
               msglen = 8*kr2s*kr3s ! one X-plane.
               msgid = 2        ! MPI message tag.
               call my_bsend(psi,msglen,pgroup(1),msgid)
            endif
         elseif (parent) then
            msglen = 8*kr2s*kr3s ! one X-plane.
            msgid = 2           ! MPI message tag.
            call my_brecv(psi,msglen,source_pe,msgid,nbytes)
         endif
C     Now, the parent should have the plane in PSI.
         if (parent) then
            int_dens=0.D0
            do i2=ilowerleft(2),nr2s+ilowerleft(2)-1
               ii2=i2
               if (ii2.gt.nr2s) ii2=ii2-nr2s
               do i3=ilowerleft(3),nr3s+ilowerleft(3)-1-1,2
                  ii3=i3
                  ii3p=i3+1
                  if (ii3 .gt.nr3s) ii3 =ii3 -nr3s
                  if (ii3p.gt.nr3s) ii3p=ii3p-nr3s
                  int_dens=int_dens+psi(ii2,ii3)+psi(ii2,ii3p)
                  write (2604,202) psi(ii2,ii3),psi(ii2,ii3p)
               enddo
            enddo
            write (2605,203) int_dens*(omega)/(nr1s*nr2s*nr3s)
         endif
      enddo                     ! i1

      if (parent) close(2604)
      if (parent) close(2605)

 200  format (5x,i4,6x,3f13.5)
 201  format (5x,i4,f6.2,3f13.8)
 202  format (5x,2f12.3)
 203  format (5x,1f15.7)
C
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine putongrid_m(position)
C     CHANGES the position such that it is placed on the nearest
C     real space gridpoint. No unit-cell-wrapping is done.
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'gvec.inc'
      real*8 position(3)
      integer i1,i2,i3
c     ==--------------------------------------------------------------==
      i1 = nint((position(1)*b1(1)
     &     +position(2)*b1(2)+position(3)*b1(3))*nr1s/alat)
      i2 = nint((position(1)*b2(1)
     &     +position(2)*b2(2)+position(3)*b2(3))*nr2s/alat)
      i3 = nint((position(1)*b3(1)
     &     +position(2)*b3(2)+position(3)*b3(3))*nr3s/alat)

      position(1) = i1*a1(1)/DBLE(nr1s)
     &     + i2*a2(1)/DBLE(nr2s) + i3*a3(1)/DBLE(nr3s)
      position(2) = i1*a1(2)/DBLE(nr1s)
     &     + i2*a2(2)/DBLE(nr2s) + i3*a3(2)/DBLE(nr3s)
      position(3) = i1*a1(3)/DBLE(nr1s)
     &     + i2*a2(3)/DBLE(nr2s) + i3*a3(3)/DBLE(nr3s)
C
C     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================
      integer function rgrid_m(position,direction)
c     returns the integer grid index ix/iy/iz of an arbitrary position
C     in space (also outside the box). Convention: 1 <= rgrid <= NR#S
C     where    # = (direction).
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'gvec.inc'
      real*8 position(3),lattice(3),projector(3),projection
      integer direction,nris,iprojection
      pointer  (ip_projector,projector),(ip_lattice,lattice)
c     ==--------------------------------------------------------------==
      if (direction .eq. 1) then
C         ip_projector = get_addr(b1)
C         ip_lattice   = get_addr(a1)
         call get_addr(ip_projector,b1)
         call get_addr(ip_lattice,a1)
         nris=nr1s
      elseif (direction .eq. 2) then
C         ip_projector = get_addr(b2)
C         ip_lattice   = get_addr(a2)
         call get_addr(ip_projector,b2)
         call get_addr(ip_lattice,a2)
         nris=nr2s
      elseif (direction .eq. 3) then
C         ip_projector = get_addr(b3)
C         ip_lattice   = get_addr(a3)
         call get_addr(ip_projector,b3)
         call get_addr(ip_lattice,a3)
         nris=nr3s
      else
         call stopgm('RGRID_M','INVALID DIRECTION')
      endif

      projection = (position(1)*projector(1) +
     &     position(2)*projector(2) +
     &     position(3)*projector(3)) /alat

      iprojection = nint( (projection - nint(projection - 0.5d0))
     &     * dble(nris)) + 1
      if (iprojection .gt. nris) iprojection=1

      rgrid_m = iprojection
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine tmprd_prop(phi,nstate,itime,tag)
C     -- Reads complex wavefunction to restart dynamics               --
C     -- Input: PHI: complex wavefunction in Fourier space            --
C     --     NSTATE: nb of states                                     --
C     --     ITIME: index of time in propagation                      --
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'irat.inc'
C     -- Arguments --
      integer    nstate,itime
      complex*16 phi(2*ngw,nstate)
      character  tag*30
C     -- Variables --
      integer    len,n1,ngwx,mapw(*),i,incr,ip,ipp,msgid,msglen
      integer    ipw,ig,nbytes,lst
      real*8     lenx
      complex*16 phisx(*),phi2(*)
      pointer    (ip_phisx,phisx),(ip_phi2,phi2),(ip_mapw,mapw)

      if (parent) then
         len=2*ngws
      else
         len=2*ngw
      endif
      call memory(ip_phisx,len,'phisx')

      if (parent) then
         call memory(ip_phi2,2*ngws,'phi2')
c        call memory(ip_phi2,2*(ngw+100),'phi2')
         call memory(ip_mapw,ngw+1,'mapw')
      endif

      if (parent) then
         open(unit=120,file='wavefunctions',status='old',
     &        form='unformatted')
         read(120) itime
      endif
c     msglen=8
c     call my_bcast(itime,msglen,source,allgrp)

      do lst=1,nstate
         do i=0,1
            incr=i*ngw
            if (parent) then
               read (120) (phisx(ig),ig=1,ngws)
            endif

            do ipp=1,nproc
               ip=pgroup(ipp)
               msgid=ip
               if (parent) then
                  if (ip.eq.me) then
                     do ig=1,ngw
                        mapw(ig)=mapgp(ig)
                     enddo
                  else
                     msgid=2
                     msglen=sparm(3,ipp-1)*8/irat
                     call my_brecv(mapw,msglen,ip,msgid,nbytes)
                  endif
                  do ipw=1,sparm(3,ipp-1)
                     phi2(ipw)=phisx(mapw(ipw))
                  enddo
                  if (ip.eq.me) then
                     do ig=1,ngw
                        phi(ig+incr,lst)=phi2(ig)
                     enddo
                  else
                     msgid=1
                     msglen=2*sparm(3,ipp-1)*8
                     call my_bsend(phi2,msglen,ip,msgid)
                  endif
               else
                  if (ip.eq.me) then
                     msgid=2
                     msglen=ngw*8/irat
                     call my_bsend(mapgp,msglen,source,msgid)
                     msgid=1
                     msglen=2*ngw*8
                     call my_brecv(phisx,msglen,source,msgid,nbytes)
                     do ig=1,ngw
                        phi(ig+incr,lst)=phisx(ig)
                     enddo
                  endif
               endif
            enddo
         enddo
      enddo
      if (parent) close(120)
      if (parent) then
         call freem(ip_mapw)
         call freem(ip_phi2)
      endif
      call freem(ip_phisx)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine tmpwr_prop(phi,nstate,itime,tag)
C     -- Writes temporary wave function on file TMPPHI                --
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'irat.inc'
C     -- Arguments --
      integer    nstate,itime
      complex*16 phi(2*ngw,nstate)
      character  tag*30
C     -- Variables --
      integer    len_g,n1,ngwx,mapw(*),i,incr,ip,ipp,msgid,msglen
      integer    ipw,ig,nbytes,lst
      real*8     lenx
      complex*16 phisx(*),phi2(*)
      pointer    (ip_phisx,phisx),(ip_phi2,phi2),(ip_mapw,mapw)

      if (parent) then
         len_g=2*ngws
      else
         len_g=2*ngw
      endif
      call memory(ip_phisx,len_g,'phisx')

      if (parent) then
         call memory(ip_phi2,2*ngws,'phi2')
         call memory(ip_mapw,ngw+1,'mapw')
      endif

      if (parent) then
         open(unit=120,file=tag,status='unknown',form='unformatted')
         write(120) itime
      endif

#ifdef PARALLEL
      do lst=1,nstate
         do i=0,1
            incr=i*ngw
            do ipp=1,nproc
               ip=pgroup(ipp)
               msgid=ip
               if (parent) then
                  if (ip.eq.me) then
                     do ig=1,ngw
                        phi2(ig)=phi(ig+incr,lst)
                        mapw(ig)=mapgp(ig)
                     enddo
                  else
                     msgid=1
                     msglen=2*sparm(3,ip)*8
                     call my_brecv(phi2,msglen,ip,msgid,nbytes)
                     msgid=2
                     msglen=sparm(3,ip)*8/irat
                     call my_brecv(mapw,msglen,ip,msgid,nbytes)
                  endif
                  do ipw=1,sparm(3,ipp-1)
                     PHISX(MAPW(IPW))=PHI2(IPW)
                  enddo
               else
                  if (ip.eq.me) then
                     do ig=1,ngw
                        phisx(ig)=phi(ig+incr,lst)
                     enddo
                     msgid=1
                     msglen=2*ngw*8
                     call my_bsend(phisx,msglen,source,msgid)
                     msgid=2
                     msglen=ngw*8/irat
                     call my_bsend(mapgp,msglen,source,msgid)
                  endif
               endif
            enddo
            call my_sync(allgrp)
            if (parent) then
               write (120) (phisx(ig),ig=1,ngws)
            endif
         enddo
      enddo
#else
      do lst=1,nstate
        write (120) (phi(ig,lst),ig=1,ngwk)
      enddo
#endif  
      if (parent) close(120)
      if (parent) then
         call freem(ip_mapw)
         call freem(ip_phi2)
      endif
      call freem(ip_phisx)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      subroutine drawsection(rhoe,tag)
C     -- Draws cross-section of RHOE at Z=0, output in a file         --
C     -- Input: RHOE density, wavefunction, etc... in real space      --
C     --        TAG file name                                         --
C     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'    ! nnr1,nrx,nrxs,krx,nrxpl,mepos
      include 'coor.inc'    ! tau0
      include 'ions.inc'    ! na,nsp,zv
C     -- Arguments --
      real*8    rhoe(nnr1)
      character tag*30
C     -- Variables --
      integer ir,ir1,ir2,ir3,is,ia
      real*8  x,y,z,x0,y0,z0,dx,dy,dz,charge

C     -- Origin --
      call phfac(tau0)
      x0=0.d0
      y0=0.d0
      z0=0.d0
      charge=0.d0
      do is=1,nsp
        do ia=1,na(is)
           x0=x0+tau0(1,ia,is)*zv(is)
           y0=y0+tau0(2,ia,is)*zv(is)
           z0=z0+tau0(3,ia,is)*zv(is)
           charge=charge+zv(is)
        enddo
      enddo
      x0=x0/charge
      y0=y0/charge
      z0=z0/charge

c     -- mesh parameters --
      dx=a1(1)/float(nr1s)
      dy=a2(2)/float(nr2s)
      dz=a3(3)/float(nr3s)

C     -- Output --
      open (125,file=tag)
      ir3=int(nr3*z0/a1(1))+1
      do ir2=1,nr2
         do ir1=nrxpl(mepos,1),nrxpl(mepos,2)
            x=(ir1-1)*dx-x0
            y=(ir2-1)*dy-y0
            z=(ir3-1)*dz-z0
            ir=(ir3-1)*kr1*kr2+(ir2-1)*kr1+ir1-nrxpl(mepos,1)+1
            write(125,'(3f24.18)') x,y,rhoe(ir)
         enddo
         write (125,*)
      enddo
      close(125)
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================

