C     ==================================================================
      SUBROUTINE TDNLFOR(FION,F,NSTATE)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==  THE NON-LOCAL POTENTIAL CONTRIBUTION TO THE FORCE ON THE    ==
C     ==  IONIC DEGREES OF FREEDOM                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nlps.inc'        !NLM
      INCLUDE 'ions.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'sgpp.inc'
      INCLUDE 'sfac.inc'
C     Arguments
      INTEGER NSTATE
      REAL*8  FION(3,NAX,NSX),F(NSTATE)
C     Variables
      DIMENSION FNL2(NAT,NHXS,LDF2)
      REAL*8  DFNL(NAT,NHXS,3,NDFNL),FNL(LDF1,NHXS,NSTATE),
     &        TEMP,TT
      INTEGER ISUB,IK,ISA0,IS,IV,JV,I,II,ISA,L,KI,LI,L2,LJ,KJ,K,IA
C     ==--------------------------------------------------------------==
C     If no non-local components -> return.
      IF(NLM.EQ.0) RETURN
C     ==--------------------------------------------------------------==
      CALL TISET('   TDNLFOR',ISUB)
      DO K=1,3
        ISA0=0
        DO IS=1,NSP
          IF(TVAN(IS)) THEN
            CALL STOPGM("TDNLFOR","Not supported")
          ELSEIF(TSGP(IS)) THEN
C           Stefan Goedecker pp
            DO IV=1,NGH(IS)
              L=NGHTOL(IV,IS)+1
              KI=LFVAL(IV,IS)
              LI=LPVAL(IV,IS)
              DO JV=1,NGH(IS)
                L2=NGHTOL(JV,IS)+1
                LJ=LPVAL(JV,IS)
                IF(L2.EQ.L.AND.LI.EQ.LJ) THEN
                  KJ=LFVAL(JV,IS)
                  DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                    TT=F(I)*HLSG(KI,KJ,L,IS)
                    II=I-NST12(MEPOS,1)+1
                    IF(TFDIST) THEN
                      DO IA=1,NA(IS)
                        ISA=ISA0+IA
                        FION(K,IA,IS)=FION(K,IA,IS)-TT*
     &                       DFNL(ISA,IV,K,II)*FNL2(ISA,JV,II)
                      ENDDO
                    ELSE
                      DO IA=1,NA(IS)
                        ISA=ISA0+IA
                        FION(K,IA,IS)=FION(K,IA,IS)-TT*
     &                       DFNL(ISA,IV,K,II)*FNL2(ISA,JV,I)
                      ENDDO
                    ENDIF
                  ENDDO
                ENDIF
              ENDDO
            ENDDO
          ELSE
C           Other pp (numeric)
            DO IV=1,NGH(IS)
              DO I=NST12(MEPOS,1),NST12(MEPOS,2)
                TEMP=WSG(IS,IV)*F(I)
                II=I-NST12(MEPOS,1)+1
                IF(TFDIST) THEN
                  DO IA=1,NA(IS)
                    ISA=ISA0+IA
                    FION(K,IA,IS)=FION(K,IA,IS)-TEMP*
     &                   DFNL(ISA,IV,K,II)*FNL2(ISA,IV,II)
                  ENDDO
                ELSE
                  DO IA=1,NA(IS)
                    ISA=ISA0+IA
                    FION(K,IA,IS)=FION(K,IA,IS)-TEMP*
     &                   DFNL(ISA,IV,K,II)*FNL2(ISA,IV,I)
                  ENDDO
                ENDIF
              ENDDO
            ENDDO
          ENDIF
          ISA0 = ISA0 + NA(IS)
        ENDDO
      ENDDO
      CALL TIHALT('   TDNLFOR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
