#ifndef __HP
C     ==================================================================
      FUNCTION TIMEC()
C     ==--------------------------------------------------------------==
C     ==  GENERAL CPU TIME ROUTINE                                    ==
C     ==  CPU TIME IS RETURNED IN msec                                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      REAL*8 TIMEC
#if defined(CRAY_XT3)
      REAL*8 t1
       call cpu_time(t1)
       timec=t1*1000d0
#elif   defined(CRAYX1)
C     ==--------------------------------------------------------------==
      REAL*8   rate
      real*8  second_8
      integer (kind=8) :: irtc
      common/x1_time/rate
C     ==--------------------------------------------------------------==
      TIMEC = IRTC()*rate*1000.D0     ! Wall clocktime
!     TIMEC = SECOND_8() * 1000.d0    ! CPU time
C     ==----------------------------------------
#elif   defined(YMP)
      REAL*8 SECOND
C     ==--------------------------------------------------------------==
      TIMEC = SECOND()*1000.D0
#elif defined(T3D)
      INTEGER IRTC
C     DCLOCK is the cpu clock.
      REAL*8 DCLOCK
      PARAMETER (DCLOCK=150.D0)
C     ==--------------------------------------------------------------==
      TIMEC = DBLE(IRTC()) * (0.001D0/DCLOCK)
#elif defined(T3E)
C     DCLOCK is the cpu clock.
      REAL TSECND
      EXTERNAL TSECND
C     ==--------------------------------------------------------------==
      TIMEC = TSECND() * 1.0E3
#elif defined(__NEC)
      REAL*8 D
#if defined(__ES)
      REAL*8 MPI_WTIME
C     ==--------------------------------------------------------------==
      D=MPI_WTIME()
#else
      CALL CLOCK(D)
#endif
      TIMEC=D*1000.D0
#elif defined(__GNU)
      REAL*4 TARRAY(2),D
C     ==--------------------------------------------------------------==
      D=ETIME(TARRAY)
      TIMEC = DBLE(TARRAY(1))*1000.D0
#elif defined(__PRIMEQUEST) || defined(__alpha) || defined(__SUN) || defined(__PGI) || defined(__ABSOFT) || defined(__OSX_IFC)
      REAL*4 ETIME,TARRAY(2),D
      EXTERNAL ETIME
C     ==--------------------------------------------------------------==
      D=ETIME(TARRAY)
      TIMEC = DBLE(TARRAY(1))*1000.D0
#elif defined(__WINNT)
      REAL*4 D
C     ==--------------------------------------------------------------==
      CALL CPU_TIME(D)
      TIMEC = DBLE(D)
#elif defined(__SGI)
      INTEGER MCLOCK
C     ==--------------------------------------------------------------==
      TIMEC = DBLE(MCLOCK())*10.D0
#elif defined(__SR2201) || defined(__SR8000)
      REAL*8 D
C     ==--------------------------------------------------------------==
      CALL XCLOCK(D,8)
      TIMEC = D*1000.D0
#elif defined(_vpp_)
cmb      REAL*8 D
      REAL*4 ETIME,TARRAY(2),D ! for Fujitsu
C     ==--------------------------------------------------------------==
cmb      CALL CLOCK(D,1,2)
cmb      TIMEC=D
      D=ETIME(TARRAY)
      TIMEC = DBLE(TARRAY(1))*1000.D0
#elif defined(__ALTIX) 
      REAL*8 CPUSECS
C     ==--------------------------------------------------------------==
      CALL CPU_TIME(CPUSECS)
      TIMEC = 1000.0D0*CPUSECS
#elif defined(__IBM) 
      REAL*8 TIMEC
      REAL*8 TIMEF
      EXTERNAL TIMEF
C     ==--------------------------------------------------------------==
      TIMEC=TIMEF()
C     ==--------------------------------------------------------------==
#else 
      INTEGER MCLOCK
C     ==--------------------------------------------------------------==
      TIMEC = DBLE(MCLOCK())*10.D0
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#if !defined(__IBM) && !defined(CRAY) && !defined(__Linux) && !defined(ALPHALINUX) && !defined(__OSX)
      FUNCTION TIMEF()
C     ==--------------------------------------------------------------==
C     ==  GENERAL TIME ROUTINE FOR ELAPSED TIME                       ==
C     ==  ELAPSED TIME IS RETURNED IN msec                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      REAL*8 TIMEF
#if defined(__SGI) || defined(__SUN) || defined(__alpha) || defined(_vpp_) || defined(__OSX_IFC)
      REAL*4 TARRAY(2),ETIME
C     ==--------------------------------------------------------------==
      TIMEF=ETIME(TARRAY)*1000.D0
#elif defined(__WINNT)
      REAL*4 D,E
C     ==--------------------------------------------------------------==
      E = 0.0
      D = secnds(E)
      TIMEF = DBLE(D)
#elif defined (CRAYX1)
      REAL*8 rate, rtc
      common/x1_time/rate
      TIMEF = rtc() * rate * 1000.d0
#elif defined(__NEC)
#if defined(__ES)
      TIMEF=0.0D+00
#else
      REAL*8 D
C     ==--------------------------------------------------------------==
      CALL ETIME(D)
      TIMEF=D*1000.D0
#endif
#elif defined(__SR2201) || defined(__SR8000)
      REAL*8 D
C     ==--------------------------------------------------------------==
      CALL XCLOCK(D,8)
      TIMEF = D*1000.D0
#elif defined(__PGI)
      INTEGER MCLOCK
      TIMEF = DBLE(MCLOCK())*10.D0
#elif defined(__ABSOFT)
      real*8 CPUSECS
C     ==--------------------------------------------------------------==
      CALL CPU_TIME(CPUSECS)
!!    TIMEC = 1000.0D0*CPUSECS ! cmb - this is a bug
      TIMEF = 1000.0D0*CPUSECS
#elif defined(__ALTIX) 
      REAL*8 D,DCLOCK 
C     ==--------------------------------------------------------------==
      D = DCLOCK()
      TIMEF = D*1000.D0
#else
      REAL*8 TIME
      EXTERNAL TIME
C     ==--------------------------------------------------------------==
      TIMEF=TIME()
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#endif
#else
      subroutine hp_dummy_function()
      end
#endif
