C     ==================================================================
      SUBROUTINE TISET(SNAME,NSTIM)
C     ==--------------------------------------------------------------==
C     ==  START THE CPU AND WALL CLOCK TIME FOR ROUTINE SNAME         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'time.inc'
C     Arguments
      INTEGER   NSTIM
      CHARACTER*(LENTIM) SNAME
C     Variables
      INTEGER   I
      REAL*8    TIMEC,TIMEF
      EXTERNAL  TIMEC,TIMEF
#ifdef CRAY_HPM_COUNTER_ALL
      integer(8) :: iunit
      character*20, hpm_name(NTIMX)
      DATA hpm_name /NTIMX*'                    '/
#endif
C     ==--------------------------------------------------------------==
      DO I=1,NTIMER
        IF(SNAME.EQ.TNAM(I)) THEN
          NSTIM=I
          GOTO 100
        ENDIF
      ENDDO
      NTIMER=NTIMER+1
      IF(NTIMER.GT.NTIMX) THEN
        WRITE(6,*) ' PARAMETER NTIMX IN INCLUDE FILE time.inc TOO ',
     *               'SMALL'
        CALL STOPGM('TISET',' PARAMETER')
      ENDIF
      NSTIM=NTIMER
      TNAM(NSTIM)=SNAME
#ifdef CRAY_HPM_COUNTER_ALL
      iunit=NTIMER
      hpm_name(NTIMER)=tnam(NTIMER)
      hpm_name(NTIMER) = adjustl(hpm_name(NTIMER))
      call hpm_text(iunit, hpm_name(NTIMER))
#endif
  100 CONTINUE
      CTSTA(NSTIM)=TIMEC()*0.001D0
      WTSTA(NSTIM)=TIMEF()*0.001D0
      ITSTACK=ITSTACK+1
      IF(ITSTACK.GT.NTIMX) THEN
        DO I=1,ITSTACK-1
          WRITE(6,'(A,I6,A)') ' NAME STACK ',I,TISTACK(I)
        ENDDO
        CALL STOPGM('TISET','ROUTINE STACK OVERFLOW')
      ENDIF
      TISTACK(ITSTACK)=SNAME
      IF (TDEBUG) THEN
        WRITE(FDEBIND,'(A,I2,A)')
     &       '(A,I2,A,',ITSTACK*IDEBP,'("."),A,A)'
        WRITE(6,FDEBIND) ' DEBUG! [',ITSTACK,']','{',SNAME
      ENDIF
#ifdef CRAY_HPM_COUNTER_ALL
       iunit = NSTIM
       call hpm_start(iunit)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TIHALT(SNAME,NSTIM)
C     ==--------------------------------------------------------------==
C     ==  STOP THE CPU AND WALL CLOCK TIME FOR ROUTINE SNAME          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'time.inc'
C     Arguments
      INTEGER   NSTIM
      CHARACTER*(LENTIM) SNAME
C     Variables
      INTEGER   I
      REAL*8    DCT,DWT,
     &          TIMEC,TIMEF
#ifdef CRAY_HPM_COUNTER_ALL
       integer(8) :: iunit
#endif
C     ==--------------------------------------------------------------==
      IF(NSTIM.EQ.0) THEN
        DO I=1,NTIMER
          IF(SNAME.EQ.TNAM(I)) THEN
            NSTIM=I
            GOTO 100
          ENDIF
        ENDDO
        WRITE(6,*) ' NO SUCH TIME HANDLE ',SNAME
        CALL STOPGM('TIHALT',' HANDLE   ')
  100   CONTINUE
      ELSE
        IF(SNAME.NE.TNAM(NSTIM)) THEN
          WRITE(6,*) ' INCONSISTENT HANDLE IN TIHALT ',SNAME,TNAM(NSTIM)
          CALL STOPGM('TIHALT',' HANDLE   ')
        ENDIF
      ENDIF
#ifdef CRAY_HPM_COUNTER_ALL
       iunit = NSTIM
       call hpm_stop(iunit)
#endif
      DCT=TIMEC()*0.001D0-CTSTA(NSTIM)
      DWT=TIMEF()*0.001D0-WTSTA(NSTIM)
      CTSUM(NSTIM)=CTSUM(NSTIM)+DCT
      WTSUM(NSTIM)=WTSUM(NSTIM)+DWT
      NCALL(NSTIM)=NCALL(NSTIM)+1
      DO I=1,NTIMER
        CTSTA(I)=CTSTA(I)+DCT
        WTSTA(I)=WTSTA(I)+DWT
      ENDDO
      IF (TDEBUG) THEN
        WRITE(FDEBIND,'(A,I2,A)')
     &       '(A,I2,A,',ITSTACK*IDEBP,'("."),A,A,T40,A,I7,2(A,1PE10.3))'
        WRITE(6,FDEBIND) ' DEBUG! [',ITSTACK,']','}',SNAME,
     &       ' NCALL=',NCALL(NSTIM),' CPU=',DCT,' ELAPS=',DWT
      ENDIF
      ITSTACK=ITSTACK-1
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TIPRI
C     ==--------------------------------------------------------------==
C     ==  PRINT TIMING INFO                                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'time.inc'
C     Variables
      INTEGER J,IMAX,I
      REAL*8  CPMAX,CPTHRS,TOTALCT,TOTALWT
#ifdef CRAY_HPM_COUNTER_ALL
      integer(8) :: iunit
#endif
C     ==--------------------------------------------------------------==
#ifdef CRAY_HPM_COUNTER_ALL
      iunit=0
#endif
      WRITE(6,'(/,/,1X,64("*"))')
      WRITE(6,'(" *",62X,"*")')
      WRITE(6,'(" *",27X,A,27X,"*")') ' TIMING '
      WRITE(6,'(" *",62X,"*")')
      WRITE(6,'(1X,64("*"))')
      WRITE(6,'(A,A)') ' SUBROUTINE',
     *      '            CALLS         CPU TIME        ELAPSED TIME'
      TOTALCT=0.D0
      TOTALWT=0.D0
      CPTHRS=0.D0
      DO J=1,NTIMER
        IMAX=0
        CPMAX=-0.1D0
        DO I=1,NTIMER
          IF(CTSUM(I).GT.CPMAX) THEN
            IMAX=I
            CPMAX=CTSUM(I)
          ENDIF
        ENDDO
        IF(J.EQ.1) THEN
          CPTHRS=CPMAX/100.D0
        ENDIF
        IF(CPMAX.LT.CPTHRS) THEN
          GOTO 100
        ENDIF
        I=IMAX
        WRITE(6,'(1X,A10,9X,I8,5X,F12.2,8X,F12.2)') 
     *                    TNAM(I),NCALL(I),CTSUM(I),WTSUM(I)
        TOTALCT=TOTALCT+CTSUM(I)
        TOTALWT=TOTALWT+WTSUM(I)
        CTSUM(I)=-1.0D0
      ENDDO
  100 CONTINUE
      WRITE(6,'(1X,64("-"))')
      WRITE(6,'(1X,"TOTAL TIME",T34,F12.2,8X,F12.2)')
     &                    TOTALCT,TOTALWT
      WRITE(6,'(1X,64("*"),/)')
#ifdef CRAY_HPM_COUNTER_ALL
      write(6,*)
      write(6,*) 'CRAY Hardware Counter :'
      call hpm_print(1_8,6_8)
      write(6,*)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TISTART(TIME1)
C     ==--------------------------------------------------------------==
C     == CALLED ONCE AT THE BEGINNING IN ORDER TO START THE TIMER     ==
C     == AND DO SOME INITIALISATION [CRAY]                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'time.inc'
C     Arguments
      REAL*8 TIME1
C     Variables
      REAL*8  TIMEC,TIMEF
#if defined(__SR2201) || defined(__SR8000)
      REAL*8  D
#endif
      INTEGER IFIRST,I
      DATA    IFIRST /0/
      SAVE    IFIRST
C     ==--------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN

C     ==--------------------------------------------------------------==
C     == INITIALIZATION OF ARRAYS FOR SUBROUTINE TIMING               ==
C     ==--------------------------------------------------------------==
        NTIMER=0
        DO I=1,NTIMX
          TNAM(I) = ' '
        ENDDO
        CALL AZZERO(CTSUM,NTIMX)
        CALL AZZERO(CTSTA,NTIMX)
        CALL AZZERO(WTSUM,NTIMX)
        CALL AZZERO(WTSTA,NTIMX)
        CALL AZZERO(CTSUM,NTIMX)
        CALL IAZZERO(NCALL,NTIMX)
      
#if defined(__ES)
        TIME1=TIMEC()
        TJSTART=(TIMEC()-TIME1)*1.D-3
#else
#if defined(__SR2201) || defined(__SR8000)
        CALL XCLOCK(D,7)
#endif
#if defined(__PRIMERGY) || defined(__alpha)
        TIME1=TIMEF()*1.D-3
#else
        TIME1=TIMEC()*1.D-3
#endif 
        TJSTART=TIME1
#endif 
        IFIRST=1
        TJSLOOP=TJSTART
C       Number of space for indentation (debug options)
        ITSTACK=0
        WRITE(FDEBIND,'(A,I2,A)') '(A,',ITSTACK,'("."),A)'
      ELSE
        CALL STOPGM('TISTART','CALLED ONCE')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TILIMIT(TSTOP)
C     ==--------------------------------------------------------------==
C     == .TRUE. IF THE JOB TIME IS TOO SHORT FOR ANOTHER LOOP         ==
C     == A LOOP IS DEFINED BY 2 CALLS TO TILIMIT (TESTEX)             ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'time.inc'        !TJSTART
      INCLUDE 'envj.inc'        !TJLIMIT
C     Arguments
      LOGICAL TSTOP
C     Variables
      REAL*8  TJELOOP,TREMAIN,
     &        TIMEC,TIMEF
C     ==--------------------------------------------------------------==
      IF(TIMESTOP) THEN
        TSTOP=.TRUE.
        RETURN
      ENDIF
      TSTOP=.FALSE.
      TIMESTOP=.FALSE.
      IF(TJLIMIT.EQ.0) THEN
        RETURN
      ENDIF
C     End of time for the last loop
#if defined(__PRIMERGY) || defined(__alpha)
      TJELOOP=TIMEF()*1.D-3
#else
      TJELOOP=TIMEC()*1.D-3
#endif
C     Total time for the last loop
      TIMELOOP=TJELOOP-TJSLOOP
C     Remaining job time 
      TREMAIN=TJLIMIT-(TJELOOP-TJSTART)
C     We add 10%.
      IF(TREMAIN.LT.(1.01D0*TIMELOOP)) THEN
        TSTOP=.TRUE.
        TIMESTOP=.TRUE.
      ENDIF
      TJSLOOP=TJELOOP
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TILIMEX
C     ==--------------------------------------------------------------==
C     == EXIT IF THE JOB TIME LIMIT IS REACHED                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'time.inc'        !TJSTART
      INCLUDE 'envj.inc'        !TJLIMIT
C     Variables
      REAL*8    TREMAIN,TIME1,
     &          TIMEC,TIMEF
      CHARACTER DATX*26
C     ==--------------------------------------------------------------==
      IF(.NOT.TIMESTOP) THEN
        RETURN
      ENDIF
C     Remaining job time
#if defined(__PRIMERGY) || defined(__alpha)
      TIME1=TIMEF()*1.D-3
#else
      TIME1=TIMEC()*1.D-3
#endif
      TREMAIN=TJLIMIT-(TIME1-TJSTART)
      CALL DATUM(DATX)
      WRITE(6,'(1X,64("*"))') 
      WRITE(6,'(1X,"*",62X,"*")')
      WRITE(6,'(1X,"*",12X,A,T65,"*")') 
     *     'JOB LIMIT TIME EXCEEDED FOR A NEW LOOP'
      WRITE(6,'(1X,"*",62X,"*")')
      WRITE(6,'(1X,64("*"))') 
      WRITE(6,'(1X,"*",A,T43,F13.3," SECONDS *")')
     &     ' THE JOB TIME LIMIT IS:',TJLIMIT
      WRITE(6,'(1X,"*",A,T43,F13.3," SECONDS *")')
     &     ' THE TIME OF THE LAST LOOP IS:',TIMELOOP
      WRITE(6,'(1X,"*",A,T43,F13.3," SECONDS *")')
     &     ' THE REMAINING JOB TIME IS:',TREMAIN
      WRITE(6,'(A,A,A,A)')
     *  ' *     ',' THE COMMAND WAS ISSUED AT ',DATX(1:24),'      *'
      WRITE(6,'(1X,"*",62X,"*")')
      WRITE(6,'(1X,64("*"))')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TISTOPGM
C     ==--------------------------------------------------------------==
C     == DISPLAY THE STACK OF CALLS IF STOPGM IS CALLED               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'time.inc'
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
      IF(ITSTACK.GT.0) THEN
        WRITE(6,'(A,A)') ' STOPGM! STACK OF MAIN CALLS:'
        DO I=1,ITSTACK
          WRITE(6,'(A,A)') ' STOPGM! CALL ',TISTACK(I)
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TANALYZE(LABEL,ROUTINE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'time.inc'
C     Arguments
      CHARACTER LABEL*(*),ROUTINE*(*)
C     Variables
      REAL*8 CTLAST(NTIMX),WTLAST(NTIMX)
      REAL*8 CT,WT
      INTEGER NCLAST(NTIMX),NC
      INTEGER IFIRST,I,NR
      DATA IFIRST /0/
      SAVE IFIRST,CTLAST,WTLAST,NCLAST
C     ==--------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN
        DO I=1,NTIMX
          CTLAST(I)=0.D0
          WTLAST(I)=0.D0
          NCLAST(I)=0
        ENDDO
        IFIRST=1
      ENDIF
      DO I=1,NTIMER
        IF(INDEX(TNAM(I),ROUTINE).NE.0) THEN
          NR=I
          GOTO 100
        ENDIF
      ENDDO
      WRITE(6,'(A6,A,A,A)') LABEL," >>>>>>>>>>",ROUTINE," NOT FOUND"
      RETURN
  100 CONTINUE
      CT=CTSUM(NR)-CTLAST(NR)
      WT=WTSUM(NR)-WTLAST(NR)
      NC=NCALL(NR)-NCLAST(NR)
      WRITE(6,'(A6,A,A10,A,I8,A,F10.2,A,F10.2)') LABEL,
     &      " >>>>>>>>>>",ROUTINE,"   CALLS=",NC,"  CPU-TIME=",CT,
     &      "  WALL-TIME=",WT
      CTLAST(NR)=CTSUM(NR)
      WTLAST(NR)=WTSUM(NR)
      NCLAST(NR)=NCALL(NR)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

