C     ==================================================================
      SUBROUTINE U_UPD_EXP_SUM(U_MAT,Z_MAT,XYZMAT,U_GRAD,SCR,
     &                      LSCR,NSTATE)
C     ==--------------------------------------------------------------==
C     == CALCULATES THE UNITARY TRANSFORMATION 
C     ==            WHICH OPTIMISE LOCALIZATION IN G SPACE            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'spin.inc'
      include 'g_loc.inc'
      include 'wann.inc'

c     Arguments
      INTEGER       NSTATE,LSCR
      COMPLEX*16    U_MAT(NSTATE,NSTATE),Z_MAT(NSTATE,NSTATE,3),
     &              U_GRAD(NSTATE,NSTATE),XYZMAT(*)
      REAL*8        SCR(LSCR)

c     Variables
      COMPLEX*16    A(NSTATE,NSTATE),B1(NSTATE,NSTATE),B2(NSTATE,NSTATE)
      pointer       (IP_A,A),(IP_B1,B1),(IP_B2,B2)
      COMPLEX*16    U_TEMP(NSTATE,NSTATE),GAM(NSTATE*NSTATE)
      pointer       (IP_U_TEMP,U_TEMP),(IP_GAM,GAM)

      DIMENSION     OMEGA_N(*)

      COMPLEX*16    ZONE,ZZERO,ZGIVE,CARG
      EXTERNAL      ZGIVE
      INTEGER       I,J,IX1,IX2,IXL,IMAX,ITER,LENGTH
      INTEGER       L_A,L_B,L_GAM,LSCR2,IZAMAX,ISUB

      REAL*8        DELTA,DIFGAM,OFUN00,XYZFUN00,DIF_GFUN,DIF_XFUN
      DATA          ofun00,XYZFUN00/ 0.0D0,0.0D0 /
      SAVE          ofun00,XYZFUN00

      CHARACTER*30  TAG
      REAL*8        GRMAX,GRMAX_R
      INTEGER       IGRMAX,IGRMAX_R,ICONT
      DATA          ICONT / 0 /
      SAVE          ICONT
      REAL*8        STEP_FAC
      DATA          STEP_FAC / 1.0D0 /
      SAVE          STEP_FAC

C     ==-------------------------------------------------------------==
      CALL TISET(' UPD_EXP_S',ISUB)
      CALL GIVE_SCR_UPD_EXP_SUM(LENGTH,TAG,NSTATE)
      LENGTH  = LENGTH - 2*NSTATE*NSTATE
      CALL TEST_SCR('U_UPD_EXP_SUM','LENGTH',LSCR,LENGTH)

      IF(TLSD) CALL STOPGM('TRANUPD','LSD NOT IMPLEMENTED YET')

      IF(GIFIRST .EQ. 1) THEN
        ICONT    = 0 
        STEP_FAC = 1.0D0 
        OFUN00   = OFUN    
        XYZFUN00 = XYZFUN  
        GIFIRST  = 0
      ENDIF

      L_A        = 2*NSTATE*NSTATE
      L_B        = 2*NSTATE*NSTATE
      L_GAM      = 2*NSTATE*NSTATE

      CALL GET_ADDR(IP_A     ,SCR(1))
      CALL GET_ADDR(IP_B1    ,SCR(1+L_A))
      CALL GET_ADDR(IP_B2    ,SCR(1+L_A+L_B))
      CALL GET_ADDR(IP_GAM   ,SCR(1+L_A+2*L_B))

      CALL GET_ADDR(IP_U_TEMP,U_GRAD)

      ZONE  = DCMPLX(1.0D0,0.0D0)
      ZZERO = DCMPLX(0.0D0,0.0D0)

c     time step
      DELTA = GLOC_STEP*STEP_FAC

c     this is U_MAT

c     Up_MAT is zero if first step
      CALL AZZERO(SCR,LSCR)

      NSTEP = NSTEP + 1

      IF(GLOC_CONST .EQ. 2) THEN

        CALL DCOPY(2*NSTATE*NSTATE,U_MAT,1,A,1)

        IF(TG_LINESEARCH) THEN
          IX1 = 1+L_A+2*L_B
          LSCR2 = LSCR - (L_A+2*L_B)

          CALL LINE_SEARCH_EXE(A,U_GRAD,Z_MAT,XYZMAT,B1,B2,SCR(IX1),
     &                         LSCR2,NSTATE,DELTA,STEP_FAC)
        ELSE
          IX1 = 1+L_A+2*L_B
          LSCR2 = LSCR - (L_A+2*L_B)
          CALL U_BY_ORTHO(A,U_GRAD,B1,B2,SCR(IX1),LSCR2,NSTATE,DELTA)
        ENDIF
        CALL DCOPY(2*NSTATE*NSTATE,A,1,U_TEMP,1)

      ELSEIF(GLOC_CONST .EQ. 1) THEN

         IX1 = 1+L_A+2*L_B+L_GAM
         LSCR2 = LSCR - (L_A+2*L_B+L_GAM)
c        IF(TCGRAD) THEN 
c          DO I = 1,NSTATE
c            A(I,I) = DCMPLX(1.0D0,0.0D0)
c          ENDDO

c          CALL GZ_CONJ_GRAD(A,U_GRAD,DELTA,NSTATE)
c          CALL DCOPY(2*NSTATE*NSTATE,A,1,U_TEMP,1)

c         ELSE
c       update U_MAT_new =  U_MAT_old + dt Up_MAT
         DO I=1,NSTATE
           DO J=1,NSTATE
             U_TEMP(J,I)=U_MAT(J,I)+DELTA*U_GRAD(J,I)
           ENDDO
         ENDDO
c         ENDIF
c      DO I = 1,NSTATE
c      write(6,'(I5,16(2f10.4))') I,(U_TEMP(I,J),J=1,8)
c      ENDDO
c      stop

         CALL  LAGRMULT(U_MAT,U_TEMP,A,B1,B2,GAM,SCR(IX1),LSCR2,NSTATE)

      ENDIF  !LAGRANGE OR NOT

      GMAX = 0.0D0
      GGNORM = 0.0D0
      DO I = 1,NSTATE
        DO J = 1,NSTATE
          CARG = U_TEMP(J,I)-U_MAT(J,I)
          DIFGAM=DREAL(CARG)*DREAL(CARG)+DIMAG(CARG)*DIMAG(CARG)
          GGNORM = GGNORM + DIFGAM
          GMAX = MAX(GMAX,DIFGAM)
        ENDDO
      ENDDO

      GMAX = DSQRT(GMAX)
      GGNORM = DSQRT(GGNORM)/DBLE(NSTATE)

      CALL DCOPY(2*NSTATE*NSTATE,U_TEMP(1,1),1,U_MAT(1,1),1)

      CALL AZZERO(U_GRAD,2*NSTATE*NSTATE)
c      CALL AZZERO(SCR,LSCR)

      IX1 = 1
      IXL = IX1+3*2*NSTATE*NSTATE
      LSCR2 = LSCR - IXL

      IF(TGWANNIER) THEN
        IX2 = IX1+NWANOPT*2*NSTATE*NSTATE
        LSCR2 = LSCR - NWANOPT*2*NSTATE*NSTATE

        CALL CALC_U_WGRAD_SUM(U_MAT,U_GRAD,XYZMAT,SCR(IX1),
     &            SCR(IX2),LSCR2,NSTATE)
        IGRMAX_R=IZAMAX(NSTATE*NSTATE,U_GRAD,1)
        GRMAX_R = CDABS(ZGIVE(U_GRAD,IGRMAX))
      ENDIF

      CALL CALC_U_GRAD_SUM(U_MAT,U_GRAD,Z_MAT,SCR(IX1),
     &              SCR(IXL),LSCR2,NSTATE,NSTATE)

      IGRMAX=IZAMAX(NSTATE*NSTATE,U_GRAD,1)
      GRMAX = CDABS(ZGIVE(U_GRAD,IGRMAX))

      DIF_GFUN = DABS(OFUN - OFUN00)
      OFUN00 = OFUN
 
      IF(TGWANNIER) THEN
        DIF_XFUN = DABS(XYZFUN - XYZFUN00)
        XYZFUN00 = XYZFUN 

        DIF_FUN = G2G_WEIGHT*DIF_GFUN + WAN_WEIGHT*DIF_XFUN
      ELSE
        DIF_FUN = DIF_GFUN
      ENDIF

      IF(TG_ANTISYMM .AND. ICONT .LE. 100 )  THEN
        ICONT = ICONT+1
        write(10,'(I10,3(2x,1PE12.6),2x,1PE12.6,2x,1PE12.6,2x,f10.5)')
     &           NSTEP,GMAX,OFUN,GRMAX,DIF_FUN,OMEGA_TOT,STEP_FAC
        write(12,'(I10,16f10.4)') NSTEP,(OMEGA_N(I),I=1,16)
      ELSEIF(TGWANNIER) THEN
        write(10,'(I10,6(2x,1PE12.6),1PE12.3)') 
     &          NSTEP,GMAX,OFUN,XYZFUN,GRMAX,DIF_FUN,GGNORM,
     &          dlog(STEP_FAC)
      ELSE
        write(10,'(I10,3(2x,1PE12.6),2x,1PE12.6,2x,1PE12.6,1PE12.3)') 
     &          NSTEP,GMAX,OFUN,GRMAX,DIF_FUN,GGNORM,dlog(STEP_FAC)
      ENDIF

C     ==--------------------------------------------------------------==
      CALL TIHALT(' UPD_EXP_S',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE  CALC_U_GRAD_SUM(U_MAT,U_GRAD,Z_MAT,Z_MATold,
     &                        SCR,LSCR,LDX,NSTATE)
C     ==--------------------------------------------------------------==
C     ==  CALCULATES THE GRADIENT OF THE LOCALIZATION FUNCTIONAL      ==
C     ==  WITH RESPECT TO THE UNITARY MATRIX COEFFICIENTS             ==
C     ==  U_GRAD_ij = -d OFUNC / d U_ij                               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'g_loc.inc'
      include 'spin.inc'
C input
      INTEGER    LSCR,NSTATE,LDX
      COMPLEX*16 Z_MAT(NSTATE,NSTATE,3)
      COMPLEX*16 U_GRAD(NSTATE,NSTATE),U_MAT(NSTATE,NSTATE),
     &           Z_MATold(NSTATE,NSTATE,3)
      REAL*8     SCR(*)
C local
      INTEGER    LMAT,IX1,L_ZU,IX2,L_UZ,IXL,I,J,K,L
      COMPLEX*16 ZZERO,ZONE
      COMPLEX*16 ZU(NSTATE,NSTATE),UZ(NSTATE,NSTATE)
      pointer    (IP_ZU,ZU),(IP_UZ,UZ)
      REAL*8     RE,IM,REZJ,IMZJ
      INTEGER    ISUB

C     ==--------------------------------------------------------------==
      CALL TISET('  GRAD_SUM',ISUB)
      LMAT = 2*NSTATE*NSTATE
      ZZERO = DCMPLX(0.0D0,0.0D0)
      ZONE  = DCMPLX(1.0D0,0.0D0)

      IX1  = 1
      L_ZU = 2*NSTATE*NSTATE
      IX2  = 1+L_ZU
      L_UZ = 2*NSTATE*NSTATE
      IXL  = L_ZU+L_UZ

c      IXL = MAX(2*LMAT,IXL) 
c      CALL TEST_SCR('CALC_U_GRAD','ZU and UZ,Z_UPDATE',LSCR,IXL)

      CALL DCOPY(LMAT*3,Z_MAT,1,Z_MATold,1)

      CALL Z_UPDATE(U_MAT,Z_MAT,SCR(1),NSTATE,NSTATE,3)

      IF(G2G_WEIGHT .EQ. 0.0D0)  GOTO 100

        CALL GET_ADDR(  IP_ZU,SCR(IX1))
        CALL GET_ADDR(  IP_UZ,SCR(IX2))

        DO K = 1,3
          CALL AZZERO(ZU,2*NSTATE*NSTATE)
          CALL AZZERO(UZ,2*NSTATE*NSTATE)

          DO J = 1,NSTATE
            DO I = 1,NSTATE
              DO L = 1,NSTATE
               ZU(I,J) = ZU(I,J) + Z_MATold(I,L,K)*U_MAT(L,J)
              ENDDO
            ENDDO

            DO I = 1,NSTATE
              DO L = 1,NSTATE
               UZ(I,J) = UZ(I,J) + DCONJG(Z_MATold(L,I,K))*U_MAT(L,J)
              ENDDO
            ENDDO

            DO I = 1,NSTATE
              U_GRAD(I,J) = U_GRAD(I,J)+G2G_WEIGHT*(
     &                  ZU(I,J)*DCONJG(Z_MAT(J,J,K)) +
     &                  UZ(I,J)*Z_MAT(J,J,K))
            ENDDO
          ENDDO
        ENDDO

 100  CONTINUE

      CALL ZGEMM('C','N',NSTATE,NSTATE,NSTATE,ZONE,U_GRAD,NSTATE,U_MAT,
     &                   NSTATE,ZZERO,SCR,NSTATE)
      CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,-ZONE,U_MAT,NSTATE,SCR,
     &                   NSTATE,ZONE,U_GRAD,NSTATE)

      CALL GZFUNC(Z_MAT,NSTATE,NSTATE)
      CALL DCOPY(LMAT*3,Z_MATold,1,Z_MAT,1)
      CALL TIHALT('  GRAD_SUM',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      SUBROUTINE GIVE_SCR_UPD_EXP_SUM(LTRANUPD,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'g_loc.inc'

C     Arguments
      INTEGER   LGRAD,L_GRAD_SUM,L_ORTHO,L_MULTI,LZNUM,NSTATE,LTRANUPD,
     &            L_SEARCH,L_PRINT,L_WGRAD_SUM
      CHARACTER TAG*30
C     Variables

      CALL GIVE_SCR_ZNUM_MAT(LZNUM,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      LGRAD      = 2*NSTATE*NSTATE
      L_GRAD_SUM = LGRAD+5*2*NSTATE*NSTATE
      L_ORTHO    = LGRAD+3*2*NSTATE*NSTATE + 11*NSTATE
      L_MULTI    = LGRAD+6*2*NSTATE*NSTATE
      IF(TG_LINESEARCH) THEN 
        L_SEARCH   = LGRAD + 9*2*NSTATE*NSTATE
      ELSE
        L_SEARCH   = 1
      ENDIF
      IF(TGLOCREALP) THEN 
        L_PRINT = KR1*KR2S*KR3S + KR2S*KR3S
      ELSE
        L_PRINT =1
      ENDIF
      IF(TGWANNIER) THEN
        L_WGRAD_SUM = LGRAD+8*2*NSTATE*NSTATE
      ELSE
        L_WGRAD_SUM =1
      ENDIF
c      write(6,*) L_GRAD_SUM,L_ORTHO,L_MULTI,LZNUM,L_SEARCH,L_PRINT
C     ==--------------------------------------------------------------==
      LTRANUPD  = MAX(L_GRAD_SUM,L_ORTHO,L_MULTI,LZNUM,L_SEARCH,
     &     L_PRINT,L_WGRAD_SUM)
      TAG='MAX(L_GRAD_SUM,L_ORTHO,...)'
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
      SUBROUTINE SIMM_OP_SUM(C1,U_MAT,OMEGA_N,OMEGA_TOT,NSTATE)
      IMPLICIT NONE
      INCLUDE 'system.h'

      INTEGER     NSTATE
      REAL*8      C1(2,NGWK,NSTATE),U_MAT(2,NSTATE,NSTATE)
      REAL*8      OMEGA_N(NSTATE),OMEGA_TOT

      INTEGER     ISTATE,JSTATE,IG
      REAL*8      ReA,ImA,ReB,ImB,ReO,ImO


      OMEGA_TOT = 0.0D0
      DO ISTATE = 1,NSTATE
        OMEGA_N(ISTATE) = 0.0D0
        DO IG = 1,NGW
          ReA = 0.0D0
          ImA = 0.0D0
          ReB = 0.0D0
          ImB = 0.0D0
          DO JSTATE = 1,NSTATE
            ReA = ReA + C1(1,IG,JSTATE)*U_MAT(1,JSTATE,ISTATE)-
     &             C1(2,IG,JSTATE)*U_MAT(2,JSTATE,ISTATE)
            ImA = ImA + C1(1,IG,JSTATE)*U_MAT(2,JSTATE,ISTATE)+
     &             C1(2,IG,JSTATE)*U_MAT(1,JSTATE,ISTATE)

            ReB = ReB + C1(1,IG+NGW,JSTATE)*U_MAT(1,JSTATE,ISTATE)-
     &             C1(2,IG+NGW,JSTATE)*U_MAT(2,JSTATE,ISTATE)
            ImB = ImB + C1(1,IG+NGW,JSTATE)*U_MAT(2,JSTATE,ISTATE)+
     &             C1(2,IG+NGW,JSTATE)*U_MAT(1,JSTATE,ISTATE)
          ENDDO
          ReO = ReA*ReB + ImA*ImB
          ImO = ReA*ImB - ImA*ReB
          OMEGA_N(ISTATE) = OMEGA_N(ISTATE) + 
     &      ReO*ReO + ImO*ImO
        ENDDO
        OMEGA_TOT = OMEGA_TOT + OMEGA_N(ISTATE)
      ENDDO

      RETURN
      END
C     ==================================================================
