C     ==================================================================
      SUBROUTINE U_UPD_SPREAD_SUM(U_MAT,Z1_MAT,Z2_MAT,U_GRAD,SCR,LSCR,
     &                    NSTATE)
C     ==--------------------------------------------------------------==
C     == CALCULATES THE UNITARY TRANSFORMATION 
C     ==            WHICH OPTIMISE LOCALIZATION IN G SPACE            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'spin.inc'
      include 'g_loc.inc'

c     Arguments
      INTEGER       NSTATE,LSCR
      COMPLEX*16    U_MAT(NSTATE,NSTATE),Z1_MAT(NSTATE,NSTATE,3),
     &              Z2_MAT(NSTATE,NSTATE,3),U_GRAD(NSTATE,NSTATE)
      REAL*8        SCR(LSCR)

c     Variables
      COMPLEX*16    A(NSTATE,NSTATE),B1(NSTATE,NSTATE),B2(NSTATE,NSTATE)
      pointer       (IP_A,A),(IP_B1,B1),(IP_B2,B2)
      COMPLEX*16    U_TEMP(NSTATE,NSTATE),GAM(NSTATE*NSTATE)
      pointer       (IP_U_TEMP,U_TEMP),(IP_GAM,GAM)
      DIMENSION     OMEGA_N(*)

      INTEGER       L_A,L_B,L_GAM,LSCR2,IZAMAX,ISUB
      REAL*8        DELTA,DIFGAM,OFUN00
      DATA          ofun00/ 0.0D0 /
      SAVE          ofun00


      COMPLEX*16    ZONE,ZZERO,ZGIVE,CARG
      EXTERNAL      ZGIVE
      INTEGER       I,J,II,IX1,IX2,IX3,IXL,IMAX,LENGTH
      CHARACTER*30  TAG
      REAL*8        GRMAX,F_STEP,COMP
      DATA          F_STEP / 1.0D0 /
      SAVE          F_STEP
      INTEGER       IGRMAX,ICONT
      DATA          ICONT / 0 /
      SAVE          ICONT
      REAL*8        STEP_FAC
      DATA          STEP_FAC / 1.0D0 /
      SAVE          STEP_FAC

C     ==-------------------------------------------------------------==
      CALL TISET(' UPD_SPR_S',ISUB)
      CALL GIVE_SCR_UPD_SPREAD_SUM(LENGTH,TAG,NSTATE)
      LENGTH = LENGTH - 2*NSTATE*NSTATE
      CALL TEST_SCR('U_UPD_SPREAD_SUM','LENGTH',LSCR,LENGTH)

      IF(TLSD) CALL STOPGM('U_UPD_SPREAD_SUM','LSD NOT IMPLEMENTED YET')

      IF(GIFIRST .EQ. 1) THEN
        ICONT    = 0 
        STEP_FAC = 1.0D0 
        ofun00   = 0.0D0 
        GIFIRST   = 0
      ENDIF

      L_A        = 2*NSTATE*NSTATE
      L_B        = 2*NSTATE*NSTATE
      L_GAM      = 2*NSTATE*NSTATE

      CALL GET_ADDR(IP_A     ,SCR(1))
      CALL GET_ADDR(IP_B1    ,SCR(1+L_A))
      CALL GET_ADDR(IP_B2    ,SCR(1+L_A+L_B))
      CALL GET_ADDR(IP_GAM   ,SCR(1+L_A+2*L_B))

      IX1 = 1+L_A+2*L_B+L_GAM
      LSCR2 = LSCR - (L_A+2*L_B+L_GAM)

      IXL = IX1+2*2*NSTATE*NSTATE

      CALL GET_ADDR(IP_U_TEMP,U_GRAD)

      ZONE  = DCMPLX(1.0D0,0.0D0)
      ZZERO = DCMPLX(0.0D0,0.0D0)

c     time step
      DELTA = GLOC_STEP*STEP_FAC 

c     this is U_MAT

c     Up_MAT is zero if first step
      CALL AZZERO(SCR,LSCR)


      NSTEP = NSTEP + 1

      IGRMAX=IZAMAX(NSTATE*NSTATE,U_GRAD,1)
      GRMAX = CDABS(ZGIVE(U_GRAD,IGRMAX))

      IF(GLOC_CONST .EQ. 2) THEN

         CALL DCOPY(2*NSTATE*NSTATE,U_MAT,1,A,1)

        IF(TG_LINESEARCH) THEN
          IX1 = 1+L_A+2*L_B
          LSCR2 = LSCR - (L_A+2*L_B)

          CALL LINE_SEARCH_S(A,U_GRAD,Z1_MAT,Z2_MAT,B1,B2,
     &                  SCR(IX1),LSCR2,NSTATE,DELTA,STEP_FAC)

        ELSE
          IX1 = 1+L_A+2*L_B
          LSCR2 = LSCR - (L_A+2*L_B)
          CALL U_BY_ORTHO(A,U_GRAD,B1,B2,SCR(IX1),LSCR2,NSTATE,DELTA)
        ENDIF
          CALL DCOPY(2*NSTATE*NSTATE,A,1,U_TEMP,1)

      ELSEIF(GLOC_CONST .EQ. 1) THEN

c       update U_MAT_new =  U_MAT_old + dt U_GRAD
        DO I=1,NSTATE
          DO J=1,NSTATE
            U_TEMP(J,I)=U_MAT(J,I)+DELTA*U_GRAD(J,I)
          ENDDO
        ENDDO

        CALL  LAGRMULT(U_MAT,U_TEMP,A,B1,B2,GAM,SCR(IX1),LSCR2,NSTATE)

      ENDIF

      GMAX = 0.0D0
      GGNORM = 0.0D0
      DO I = 1,NSTATE
        DO J = 1,NSTATE
          CARG = U_TEMP(J,I)-U_MAT(J,I)
          DIFGAM=DREAL(CARG)*DREAL(CARG)+DIMAG(CARG)*DIMAG(CARG)
            GGNORM = GGNORM + DIFGAM
          GMAX = MAX(GMAX,DIFGAM)
        ENDDO
      ENDDO

      GMAX = DSQRT(GMAX)
      GGNORM = DSQRT(GGNORM)/DBLE(NSTATE)

      CALL DCOPY(2*NSTATE*NSTATE,U_TEMP(1,1),1,U_MAT(1,1),1)

c     calculate U_GRAD_new with the rotated U_MAT_new
      CALL AZZERO(U_GRAD,2*NSTATE*NSTATE)
      CALL AZZERO(SCR,LSCR)
      IX1 = 1
      IX2 = 1   + 3*2*NSTATE*NSTATE
      IX3 = IX2 + 3*2*NSTATE*NSTATE
      IXL = 3*2*NSTATE*NSTATE+3*2*NSTATE*NSTATE

      LSCR2 = LSCR - IXL
      CALL U_GRAD_SPREAD_SUM(U_MAT,U_GRAD,Z1_MAT,Z2_MAT,SCR(IX1),
     &              SCR(IX2),SCR(IX3),LSCR2,NSTATE,NSTATE)

      DIF_FUN = DABS(OFUN - OFUN00)
      OFUN00 = OFUN
c      write(6,*) OFUN , GMAX,GRMAX,DIF_FUN
c
      IF(TG_ANTISYMM .AND. ICONT .LE. 100 )  THEN
        ICONT = ICONT+1
        write(10,'(I10,3(2x,1PE12.6),I6,2x,1PE12.6)') NSTEP,GMAX,OFUN,
     &          GRMAX,IGRMAX,OMEGA_TOT
        write(12,'(I10,16f10.4)') NSTEP,(OMEGA_N(I),I=1,16)
      ELSE
        write(10,'(I10,3(2x,1PE12.6),2x,1PE12.6,2x,1PE12.6,2x,1PE12.3)') 
     &          NSTEP,GMAX,OFUN,GRMAX,DIF_FUN,GGNORM,dlog(STEP_FAC)
      ENDIF
C     ==--------------------------------------------------------------==
      CALL TIHALT(' UPD_SPR_S',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE  U_GRAD_SPREAD_SUM(U_MAT,U_GRAD,Z1_MAT,Z2_MAT,
     &                     Z1_MATold,Z2_MATold,SCR,LSCR,LDX,NSTATE)
C     ==--------------------------------------------------------------==
C     ==  CALCULATES THE GRADIENT OF THE LOCALIZATION FUNCTIONAL      ==
C     ==  WITH RESPECT TO THE UNITARY MATRIX COEFFICIENTS             ==
C     ==  U_GRAD_ij = -d OFUNC / d U_ij                               ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'g_loc.inc'
      include 'spin.inc'
C input
      INTEGER    LSCR,NSTATE,LDX
      COMPLEX*16 U_MAT(NSTATE,NSTATE),U_GRAD(NSTATE,NSTATE),
     &           Z1_MAT(NSTATE,NSTATE,3),Z1_MATold(NSTATE,NSTATE,3),
     &           Z2_MAT(NSTATE,NSTATE,3),Z2_MATold(NSTATE,NSTATE,3)
      REAL*8     SCR(*)
C local
      INTEGER    LMAT,IX1,L_Z1U,IX2,IXL,I,J,K,L
      COMPLEX*16 Z1U(NSTATE,NSTATE),ZZERO,ZONE
      pointer    (IP_Z1U,Z1U)
C     ==--------------------------------------------------------------==

      LMAT = 2*NSTATE*NSTATE
      ZZERO = DCMPLX(0.0D0,0.0D0)
      ZONE  = DCMPLX(1.0D0,0.0D0)

      CALL DCOPY(LMAT*3,Z1_MAT,1,Z1_MATold,1)
      CALL DCOPY(LMAT*3,Z2_MAT,1,Z2_MATold,1)
      CALL TEST_SCR('U_GRAD_SPREAD','Z_UPDATE',LSCR,2*LMAT)
      CALL Z12_UPDATE(U_MAT,Z1_MAT,Z2_MAT,SCR(1),LDX,NSTATE)


      IX1  = 1
      L_Z1U = 2*NSTATE*NSTATE
      IX2  = 1+L_Z1U
      IXL  = L_Z1U
      CALL TEST_SCR('U_GRAD_SPREAD','Z1U',LSCR,IXL)

      CALL GET_ADDR(IP_Z1U,SCR(IX1))

      DO K = 1,3
c        CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,DCMPLX(1.0D0,0.0D0),
c     &              Z_MATold(1,1,K),NSTATE,U_MAT,NSTATE,
c     &              DCMPLX(0.0D0,0.0D0),ZU,NSTATE)

        CALL AZZERO(Z1U,2*NSTATE*NSTATE)

        DO J = 1,NSTATE
          DO I = 1,NSTATE
            DO L = 1,NSTATE
            Z1U(I,J) = Z1U(I,J) + Z1_MATold(I,L,K)*U_MAT(L,J)
            ENDDO


c        CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,DCMPLX(1.0D0,0.0D0),
c     &              U_MAT,NSTATE,Z_MATold(1,1,K),NSTATE,
c     &              DCMPLX(0.0D0,0.0D0),UZ,NSTATE)


            U_GRAD(I,J) = U_GRAD(I,J)
     &                  +2.0D0*Z1U(I,J)*Z1_MAT(J,J,K)
          ENDDO
        ENDDO
      ENDDO

      CALL ZGEMM('C','N',NSTATE,NSTATE,NSTATE,ZONE,U_GRAD,NSTATE,U_MAT,
     &                   NSTATE,ZZERO,SCR,NSTATE)
      CALL ZGEMM('N','N',NSTATE,NSTATE,NSTATE,-ZONE,U_MAT,NSTATE,SCR,
     &                   NSTATE,ZONE,U_GRAD,NSTATE)

      CALL SPREADFUNC(Z1_MAT,Z2_MAT,NSTATE,NSTATE)
      CALL DCOPY(LMAT*3,Z1_MATold,1,Z1_MAT,1)
      CALL DCOPY(LMAT*3,Z2_MATold,1,Z2_MAT,1)
c      write(6,*)  OFUN

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      SUBROUTINE GIVE_SCR_UPD_SPREAD_SUM(LTRANUPD,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'g_loc.inc'

C     Arguments
      INTEGER   LGRAD,L_GRAD_SUM,L_ORTHO,L_MULTI,LZNUM,NSTATE,LTRANUPD,
     &          L_PRINT, L_SEARCH
      CHARACTER TAG*30
C     Variables

      LZNUM = 2*NSTATE*NSTATE
C     ==--------------------------------------------------------------==
      LGRAD      = 2*NSTATE*NSTATE
      L_GRAD_SUM = LGRAD + 4*2*NSTATE*NSTATE
      L_ORTHO    = LGRAD + 3*2*NSTATE*NSTATE + 11*NSTATE
      L_MULTI    = LGRAD + 6*2*NSTATE*NSTATE
      IF(TG_LINESEARCH) THEN 
        L_SEARCH   = LGRAD + 12*2*NSTATE*NSTATE
      ELSE
        L_SEARCH   = 1
      ENDIF
      IF(TGLOCREALP) THEN 
        L_PRINT = KR1*KR2S*KR3S + KR2S*KR3S
      ELSE
        L_PRINT =1
      ENDIF
C     ==--------------------------------------------------------------==

      LTRANUPD  = MAX(L_GRAD_SUM,L_ORTHO,L_MULTI,LZNUM,
     &               L_PRINT, L_SEARCH)

      TAG='MAX(L_GRAD_SUM,L_ORTHO,...)'
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==================================================================
