C     ==================================================================
      SUBROUTINE UPDWF(C0,C2,SC0,TAU0,FION,PME,GDE,VPP,EIGV,
     &                 RHOE,PSI,SCR,LSCR,NSTATE,TFOR,UPDATE_POT)
C     ==--------------------------------------------------------------==
C     ==               UPDATES THE WAVEFUNCTIONS                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'norm.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'soft.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      INTEGER    NSTATE,LSCR
CEHR[
      COMPLEX*16 C0(NGWK,*),C2(NGWK,*),SC0(NGWK,*),
CHER]
     &           PME(*),GDE(*),PSI(NNR1)
      REAL*8     TAU0(3*NAX*NSX),FION(3*NAX*NSX),
CHER[
     &           EIGV(NSTATE),RHOE(NNR1),SCR(LSCR),VPP(NGWK)
CHER]
      LOGICAL    TFOR,UPDATE_POT
C     Variables
      DIMENSION TWNL(*)
      CHARACTER TAG*30
      REAL*8    PF1
      INTEGER   I,IG,LUPDWF
      logical   status,statusdummy
      integer   IL_RHOE,IL_PSI
C     ==--------------------------------------------------------------==
      if(qmnode)then
C       Test SCR
        CALL GIVE_SCR_UPDWF(LUPDWF,TAG,NSTATE,TFOR)
        CALL TEST_SCR('UPDWF',TAG,LSCR,LUPDWF)
      endif
C     ==--------------------------------------------------------------==
C     ==  UPDATE THE WAVEFUNCTIONS                                    ==
C     ==--------------------------------------------------------------==
      IF ( TQMMM ) THEN
C       IL_RHOE=size(RHOE)
        CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
        call mm_qmmm_forcedr(C0,C2,SC0,RHOE,PSI,TAU0,FION,
     *          EIGV,SCR,LSCR,NSTATE,IL_RHOE,.TRUE.,UPDATE_POT,.TRUE.)
        call mm_dim(mm_go_mm,status)
        IF(.NOT.TFOR) THEN
          CALL AZZERO(FION,3*NAX*NSX)
        ENDIF
        call mm_dim(mm_go_qm,statusdummy)
      ELSE
        CALL FORCEDR(C0,C2,SC0,RHOE,PSI,TAU0,FION,EIGV,SCR,LSCR,
     *                   NSTATE,1,.TRUE.,TFOR)
        IF(.NOT.TFOR) THEN
          CALL AZZERO(FION,3*NAX*NSX)
        ENDIF
      ENDIF
C
      if(qmnode.and..not.classical)then
CEHR[
       IF (TFOR.AND.TMDEH) THEN
C       DO NOTHING
       ELSE
CEHR]
        IF(DIIS) THEN
          IF(SDIIS) THEN
            CALL HESELE(DT2BYE,VPP)
          ENDIF
          CALL ODIIS(C0,C2,VPP,NSTATE,PME,GDE,DT2BYE,SDIIS)
          IF(SDIIS) THEN
            NDISRS=NDISRS+1
            NDISTP=0
            SDIIS=.FALSE.
          ELSE
            NDISTP=NDISTP+1
          ENDIF
        ELSE IF(PCG) THEN
          IF(SPCG) THEN
            CALL HESELE(DT2BYE,VPP)
          ENDIF
          CALL PCGRAD(C0,C2,SC0,VPP,PME,
     &              RHOE,PSI,SCR,LSCR,TAU0,NSTATE,SPCG)
          SPCG=.FALSE.
        ELSE IF(TSDE) THEN
          IF(PREC) THEN
            CALL HESELE(DT2BYE,VPP)
            PF1=DT2_ELEC*HTHRS/EMASS
            DO I=1,NSTATE
              DO IG=1,NGW
                C0(IG,I)=C0(IG,I)+VPP(IG)*PF1*C2(IG,I)
              ENDDO
            ENDDO
          ELSE
            CALL DAXPY(2*NSTATE*NGW,DT2BYE,C2(1,1),1,C0(1,1),1)
          ENDIF
          IF(IPROJ.LE.1) THEN
            GEMAX=2.0D0*TOLOG
          ENDIF
        ENDIF
        IF(.NOT.EXSOFT) CALL TESTEX(EXSOFT)
        CALL TOL_CHK_CNVGRAD(CONVWF,EXSOFT,GEMAX)
CEHR[
       ENDIF
CEHR]
C     ==--------------------------------------------------------------==
C     ==  ORTHOGONALIZATION                                           ==
C     ==--------------------------------------------------------------==
        IF(NONORT) THEN
          IF(GEQ0) THEN
            CALL ZCLEAN(C0,NSTATE,NGW)
          ENDIF
        ELSE
          CALL PREORTHO(C0,NSTATE,SCR,LSCR)
          IF(TIVAN) THEN
            CALL RNLSM(C0,NSTATE,PSI,SCR,LSCR,1,1,.FALSE.)
          ENDIF
          CALL ORTHO(NSTATE,C0,C2,SCR,LSCR)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF ( TQMMM ) THEN
        IF (CLASSICAL) CONVWF=.TRUE. ! no iterations
        call mm_dim(mm_revert,status)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_UPDWF(LUPDWF,TAG,NSTATE,TFOR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NONORT
C     Arguments
      INTEGER   LUPDWF,NSTATE
      LOGICAL   TFOR
      CHARACTER TAG*30
C     Variables
      INTEGER   LFORCES,LORTHO,LPCGRAD
C     ==--------------------------------------------------------------==
      LORTHO=0
      CALL GIVE_SCR_FORCEDR(LFORCES,TAG,NSTATE,.TRUE.,TFOR)
      IF(.NOT.NONORT) THEN
        CALL GIVE_SCR_ORTHO(LORTHO,TAG,NSTATE)
      ENDIF
C            
      IF(PCG.OR.TPCGFIC) THEN
        CALL GIVE_SCR_PCGRAD(LPCGRAD,TAG,NSTATE)
      ELSE
        LPCGRAD=0
      ENDIF
C
      LUPDWF=MAX(LFORCES,LORTHO,LPCGRAD)+10
      TAG='MAX(LFORCES,LORTHO,LPCGRAD)'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
