c     ==================================================================
      subroutine updwf_p(c0,c1,c12,h1nl,z11,
     &     eivps1,eirop1,
     &     tau0,fion,pme,gde,vpp,
     &     rhoe,drhoe,psi,scr,lscr,nstate,firstcall,reset_cg)
c     ==--------------------------------------------------------------==
c     ==               updates the wavefunctions                      ==
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'
      include 'norm.inc'
      include 'ions.inc'
      include 'ropt.inc'
      include 'tpar.inc'
      include 'soft.inc'
      include 'pslo.inc'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'nlps.inc'
      include 'elct.inc'
      include 'response_p.inc'        ! TNMR

c     arguments
      integer    nstate,lscr
      complex*16 c0(ngw,nstate),c12(ngw,nstate),c1(ngw,nstate),
     &           h1nl(ngw,nstate),pme(*),gde(*),
     &           psi(nnr1)
      complex*16 eirop1(nhg),eivps1(nhg)
      real*8     tau0(3*nax*nsx),fion(3*nax*nsx),
     &           rhoe(nnr1),scr(lscr),vpp(ngw)
      real*8     drhoe(nnr1),z11(nstate,nstate)
      logical    firstcall,reset_cg
c     variables
      dimension TWNL(*)
      character tag*30
      real*8    pf1
      integer   i,ig,lupdwf,k
      DIMENSION S_STAR(NSTATE,NSTATE)
c     ==--------------------------------------------------------------==
c     test scr
      call give_scr_updwf_p(lupdwf,tag,nstate)
      call test_scr('updwf_p',tag,lscr,lupdwf)


c     ==--------------------------------------------------------------==
c     ==  calculate the force on the wavefunctions                    ==
c     ==--------------------------------------------------------------==
      if (cutoff_restr) call restrain_ngw_zero(c1,ngw_zero,ngw,nstate)
      call forces_p(c0,c1,c12,h1nl,z11,drhoe,eivps1,eirop1,
     &    tau0,fion,rhoe,psi,scr,lscr,
     &    nstate,firstcall)
c     ==--------------------------------------------------------------==
c     ==  update the wavefunctions                                    ==
c     ==--------------------------------------------------------------==
      if(pcg_p) then
         call pcgrad_p(c0,c1,c12,vpp,
     &        psi,scr,lscr,nstate,reset_cg,z11)
      elseif (diis_p) then
         if (firstcall .AND. OPT1ST) then
            call pcgrad_p(c0,c1,c12,vpp,
     &           psi,scr,lscr,nstate,reset_cg,z11)
            sdiis = .true.
         else
C   DMB
            IF (TSIMPLE_MODEL) THEN
               call simple_ortho_p(nstate,c0,c12,S_star)
            ELSE
               call ortho_p(nstate,c0,c12)
            ENDIF
C   DMB
            call csize(c12,nstate,gemax,cnorm)
            call odiis_p(c1,c12,vpp,z11,nstate,pme,gde,dt2bye,sdiis)

C   DMB added C0|C1 orthogonalisation (also for pcg)
            IF (TSIMPLE_MODEL) THEN
              call simple_ortho_p(nstate,c0,c1,S_star)
            ELSE
              call ortho_p(nstate,c0,c1)
            ENDIF
C   DMB

            if (geq0) then
               call zclean(c1,nstate,ngw)
            endif
         endif
      else
         call stopgm('UPDWF_P',
     &        'EITHER nothing or nothing at all.')
      endif

      if(.not.exsoft) call testex(exsoft)

      if(gemax.lt.tolog_p .or. exsoft) convwf=.true.

      firstcall = .false.

c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================



c     ==================================================================
      subroutine give_scr_updwf_p(lupdwf,tag,nstate)
c     ==--------------------------------------------------------------==
      implicit none
      include 'system.h'        !nonort
      include 'nlps.inc'
      include 'ions.inc'
      include 'response_p.inc'

c     arguments
      integer   lupdwf,nstate
      character tag*30
c     variables
      integer   lforces,lortho,lpcgrad
c     ==--------------------------------------------------------------==
      lortho=0
      call give_scr_forces_p(lforces,tag,nstate)
      if(.not.nonort) then
        call give_scr_ortho(lortho,tag,nstate)
      endif
c     call give_scr_pcgrad_p(lpcgrad,tag,nstate)
      lpcgrad = 2*ngw*nstate
      lupdwf=max(lforces,lortho,lpcgrad)
      tag='max(lforces,lortho,lpcgrad)'
c     ==--------------------------------------------------------------==
      return
      end
c     ==================================================================

