#if defined(__SR11000)
*option OPT(O(ss))
#endif
C     ==================================================================
      SUBROUTINE MY_SLEEP(SECONDS)
      IMPLICIT NONE
      INTEGER SECONDS
C     ==--------------------------------------------------------------==
#if defined(__IBM) || defined(__OSX)
      CALL SLEEP_(SECONDS)
#elif defined(__OSX_IFC)
      CALL SLEEP(SECONDS)
#elif defined(CRAYX1)
#else
      CALL SLEEP(SECONDS)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MY_FLUSH(IUNIT)
      IMPLICIT NONE
      INTEGER IUNIT
C     ==--------------------------------------------------------------==
#if defined(__IBM) || defined(__OSX)
      CALL FLUSH_(IUNIT)
#else
      CALL FLUSH(IUNIT)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END

C     ==================================================================
C     NOTE: assumes 32-bit integers. should not be a problem for the 
C     current uses, but it is thus not fully equivalent to MAXVAL().
      FUNCTION MY_MAXVAL(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER MY_MAXVAL,A(*),N
C     Variables
      INTEGER I,VAL
C     ==--------------------------------------------------------------==
      VAL=-2147483647
      DO I=1,N
        VAL=MAX(VAL,A(I))
      ENDDO
C     ==--------------------------------------------------------------==
      MY_MAXVAL=VAL
      RETURN
      END

C     ==================================================================
      FUNCTION XRANF()
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      REAL*8 XRANF
C     Variables
      INTEGER M,KONST
      DATA    M/100001/,KONST/125/
      SAVE    M
C     ==--------------------------------------------------------------==
      M=M*KONST
      M=M-2796203*(M/2796203)
      XRANF=DBLE(M)/2796203.D0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MPRAND(SEED,N,A)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      REAL*8  A(N),SEED
C     Variables
      REAL*8  XRANF
      EXTERNAL XRANF
      INTEGER I
C     ==--------------------------------------------------------------==
      DO I=1,N
        A(I)=XRANF()
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE UNITMX(A,N)
C     ==--------------------------------------------------------------==
C     Arguments
      INTEGER N
      REAL*8  A(N,N)
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
      CALL AZZERO(A,N*N)
#if defined(__SR8000)
*poption parallel
#elif defined(_vpp_)
!OCL NOALIAS
#else
!$OMP parallel do private(I)
#endif
      DO I=1,N
         A(I,I)=1.D0
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SIMPSN(N,INTE,SUM)
C     ==--------------------------------------------------------------==
C     == COMPUTES ONE-DIMENSIONAL INTEGRALS BY THE SIMPSON METHOD     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   N
      REAL*8    INTE(N),SUM
C     Variables
      REAL*8    C1,C2,C3,C4
      INTEGER   I
      PARAMETER (C1=109.D0/48.D0,C2=-5.D0/48.D0,
     &     C3=63.D0/48.D0,C4=49.D0/48.D0)
C     ==--------------------------------------------------------------==
      INTE(1)   = INTE(1)*C1
      INTE(2)   = INTE(2)*C2
      INTE(3)   = INTE(3)*C3
      INTE(4)   = INTE(4)*C4
      INTE(N-1) = INTE(N-1)*C1
      INTE(N-2) = INTE(N-2)*C2
      INTE(N-3) = INTE(N-3)*C3
      INTE(N-4) = INTE(N-4)*C4
      SUM=0.D0
!$OMP parallel do private(I) reduction(+:SUM)
      DO I=1,N-1
         SUM=SUM+INTE(I)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ZCLEAN(A,N,NGW)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N,NGW
      REAL*8  A(2,NGW,N)
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
      IF(NGW.GT.0) THEN
C$OMP parallel do private(I)
        DO I=1,N
           A(2,1,I)=0.D0
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
cLSA#if !(defined(CRAY))
      SUBROUTINE ICOPY(N,A,IA,B,IB)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N,IA,IB
      INTEGER A(IA*N),B(IB*N)
C     Variables
      INTEGER I,IAX,IBX
C     ==--------------------------------------------------------------==
#if defined(__SR8000)
*voption indep(B)
*voption prefetch
#else
!$OMP parallel do private(I,IAX,IBX)
#endif
      DO I=1,N
        IAX=(I-1)*IA + 1
        IBX=(I-1)*IB + 1
        B(IBX) = A(IAX)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#ifdef POINTER8
      SUBROUTINE I8COPY(N,A,IA,B,IB)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   N,IA,IB
      INTEGER*8 A(IA*N),B(IB*N)
C     Variables
      INTEGER I,IAX,IBX
C     ==--------------------------------------------------------------==
#if defined(__SR8000)
*voption indep(B)
*voption prefetch
#else
!$OMP parallel do private(I,IAX,IBX)
#endif
      DO I=1,N
        IAX=(I-1)*IA + 1
        IBX=(I-1)*IB + 1
        B(IBX) = A(IAX)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#endif
cLSA#endif
      SUBROUTINE SYMMA(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      REAL*8  A(N,N)
C     Variables
      INTEGER I,J
C     ==--------------------------------------------------------------==
C$OMP parallel do private(I,J) schedule(static,1)
      DO I=1,N
        DO J=I+1,N
          A(I,J)=0.5D0*(A(I,J)+A(J,I))
          A(J,I)=A(I,J)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MATMOV(N,M,A,LDA,B,LDB)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    N,M,LDA,LDB
      COMPLEX*16 A(LDA,*),B(LDB,*)
C     Variables
#if defined(T3D) || defined(T3E) 
      COMPLEX*16 CONE,CZERO
      PARAMETER  (CONE=(1.0D0,0.0D0),CZERO=(0.0D0,0.0D0))
C     ==--------------------------------------------------------------==
      CALL CGESUM('N',N,M,CONE,A,LDA,CZERO,B,LDB)
#elif defined(__VECTOR)
      INTEGER    I,J
C     ==--------------------------------------------------------------==
C$OMP parallel do private(I,J) shared(M,N,A,B)
      DO I=1,M
        DO J=1,N
          B(J,I)=A(J,I)
        ENDDO
      ENDDO
#elif defined(__HP)
      INTEGER    I,J
C     ==--------------------------------------------------------------==
      DO I=1,M
        DO J=1,N
          B(J,I)=A(J,I)
        ENDDO
      ENDDO
#else
      INTEGER    I,J,JJ
C     ==--------------------------------------------------------------==
      JJ=MOD(N,4)
!$OMP parallel do private(I,J) shared(M,N,A,B,JJ)
      DO I=1,M
        DO J=1,JJ
          B(J,I)=A(J,I)
        ENDDO
        DO J=1+JJ,N,4
          B(J  ,I)  =  A(J  ,I)
          B(J+1,I)  =  A(J+1,I)
          B(J+2,I)  =  A(J+2,I)
          B(J+3,I)  =  A(J+3,I)
        ENDDO
      ENDDO
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#if !(defined(T3D) || defined(T3E))
      SUBROUTINE CGESUM(TRANSA,N,M,CA,A,LDA,CB,B,LDB)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER  TRANSA*1
      INTEGER    N,M,LDA,LDB
      COMPLEX*16 A(LDA,*),B(LDB,*),CA,CB
C     Variables
      INTEGER    I,J
C     ==--------------------------------------------------------------==
      CALL TEST_SCR('CGESUM','LDB',LDB,N)
      IF(TRANSA.EQ.'N'.OR.TRANSA.EQ.'n') THEN
        CALL TEST_SCR('CGESUM','LDA[N]',LDA,N)
!$OMP parallel do private(I,J) shared(CB)
        DO I=1,M
          DO J=1,N
            B(J,I)=CB*B(J,I)+CA*A(J,I)
          ENDDO
        ENDDO
      ELSE
        CALL TEST_SCR('CGESUM','LDA[M]',LDA,M)
!$OMP parallel do private(I,J) shared(CB)
        DO I=1,M
          DO J=1,N
            B(J,I)=CB*B(J,I)+CA*A(I,J)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
#endif
C     ==================================================================
      SUBROUTINE DATUM(DATX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER DATX*(*)
C     Variables
#if defined(CRAY)
C     ==--------------------------------------------------------------==
      WRITE(DATX,'(A8,'' ON '',A8)') CLOCK(),DATE()
#elif defined(__NEC)
#if defined (__ES)
      WRITE(DATX,'(50X)')
      CALL FDATE(DATX)
#else
      CHARACTER*8 A1,A2
C     ==--------------------------------------------------------------==
      CALL DATIM(A1,A2)
      WRITE(DATX,'(A8,'' ON '',A8)') A2,A1
#endif
#elif defined(__IBM) || defined(__OSX)
C     ==--------------------------------------------------------------==
      CALL FDATE_(DATX)
#elif defined(__OSX_IFC)
C     ==--------------------------------------------------------------==
      CALL FDATE(DATX)
#elif defined(__SUN)
      CHARACTER*24 DATX24
C     ==--------------------------------------------------------------==
      WRITE(DATX,'(50X)')
      CALL FDATE(DATX24)
      DATX(1:24)=DATX24(1:24)
#else
C     ==--------------------------------------------------------------==
      WRITE(DATX,'(50X)')
      CALL FDATE(DATX)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE NUMCPUS(NCPUS)
C     ==--------------------------------------------------------------==
C     == Number of CPU for a distributed machine                      ==
C     == Used with OpenMP version.                                    ==
C     == First call Give the number of CPU and store locally in MCPUS ==
C     == Other calls Use saved value in MCPUS variable                ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NCPUS
C     Variables
      INTEGER MCPUS,OMP_GET_NUM_THREADS,IDUMMY
#if defined (__YMP)
      CHARACTER*80 STRING
      INTEGER IA,IE
      LOGICAL ERROR
#endif
      SAVE MCPUS
      DATA MCPUS /0/
C     ==--------------------------------------------------------------==
      IF(MCPUS.NE.0) THEN
        NCPUS=MCPUS
      ELSE
#if defined (__YMP)
        CALL MY_GETENV('NCPUS',STRING)
        CALL XSTRING(STRING,IA,IE)
        IF(IA.GT.IE.OR.STRING(IA:IE).EQ.' ') THEN
          NCPUS=1
        ELSE
          CALL READSI(STRING,IA,IE,NCPUS,ERROR)
        ENDIF
        NCPUS=MAX(NCPUS,1)
        MCPUS=NCPUS
#else
C     OpenMP version
C     We forcedly disable nested paralellism.
        NCPUS=1
c$omp parallel shared(NCPUS)
c$      NCPUS=OMP_GET_NUM_THREADS()
c$      CALL OMP_SET_NESTED(.FALSE.)
c$omp end parallel
        MCPUS=NCPUS
#if defined(FFT_FFTW3)
        IF(NCPUS.GT.1) THEN
          CALL DFFTW_INIT_THREADS(IDUMMY)
          CALL DFFTW_PLAN_WITH_NTHREADS(MCPUS)
        ENDIF
#endif
#endif
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE INVMAT(N,A,B,INFO)
C     ==--------------------------------------------------------------==
C     == Inverse Matrix A(N,N)                                        ==
C     ==--------------------------------------------------------------==
C     == INPUT:  N Dimension                                          ==
C     ==         A(N,N) Matrix                                        ==
C     == OUTPUT: A(N,N) inverse matrix of A                           ==
C     ==         B is a work array                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N,INFO
      REAL*8  A(N,N),B(N,N)
C     Variables
      INTEGER LB
C     ==--------------------------------------------------------------==
      IF(N.EQ.1) THEN
        A(1,1)=1.D0/A(1,1)
      ELSE
        LB=(N-1)*N
C       Compute an LU factorization
        CALL DGETRF(N,N,A,N,B(1,1),INFO)
        IF(INFO.EQ.0) THEN
C         Compute the inverse of a matrix using the LU factorization
          CALL DGETRI(N,A,N,B(1,1),B(1,2),LB,INFO)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE INVERSEMAT(N,A,LDA,B,INFO)
C     ==--------------------------------------------------------------==
C     == Inverse Matrix A(LDA,N)                                      ==
C     ==--------------------------------------------------------------==
C     == INPUT:  N   Dimension                                        ==
C     ==         LDA Leading dimension of A                           ==
C     ==         A(LDA,N) Matrix                                      ==
C     == OUTPUT: A(LDA,N) inverse matrix of A                         ==
C     ==         B is a work array                                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N,LDA,INFO
      REAL*8  A(LDA,N),B(N,N)
C     Variables
      INTEGER LB
C     ==--------------------------------------------------------------==
      IF(N.EQ.1) THEN
        A(1,1)=1.D0/A(1,1)
      ELSE
        LB=(N-1)*N
C       Compute an LU factorization
        CALL DGETRF(N,N,A,LDA,B(1,1),INFO)
        IF(INFO.EQ.0) THEN
C         Compute the inverse of a matrix using the LU factorization
          CALL DGETRI(N,A,LDA,B(1,1),B(1,2),LB,INFO)
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DSPEVY(IOPT,AP,W,Z,LDZ,N,AUX,NAUX)
C     ==--------------------------------------------------------------==
C     == DIAGONALIZATION ROUTINE: FOLLOW THE ESSL CONVENTION          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER IOPT,LDZ,N,NAUX
      REAL*8    AP(N*(N+1)/2),W(N),Z(LDZ,N),AUX(NAUX)
C     Variables
      INTEGER INFO
C     ==--------------------------------------------------------------==
      CALL TEST_SCR('DSPEVY','NAUX',NAUX,3*N)
#if defined ( ESSL )
      CALL DSPEV(IOPT,AP,W,Z,LDZ,N,AUX,NAUX)
#else
      INFO=0
      IF(IOPT.EQ.0) THEN
        CALL DSPEV('N','L',N,AP,W,Z,LDZ,AUX,INFO)
      ELSEIF(IOPT.EQ.1) THEN
        CALL DSPEV('V','L',N,AP,W,Z,LDZ,AUX,INFO)
      ELSEIF(IOPT.EQ.20) THEN
        CALL DSPEV('N','U',N,AP,W,Z,LDZ,AUX,INFO)
      ELSEIF(IOPT.EQ.21) THEN
        CALL DSPEV('V','U',N,AP,W,Z,LDZ,AUX,INFO)
      ENDIF
      IF(INFO.NE.0) CALL STOPGM('DSPEVY','FAILED TO DIAGONALIZE')
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#if !(defined(ESSL))
C     ==================================================================
      SUBROUTINE ZGETMO(A,LDA,M,N,B,LDB)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    LDA,M,N,LDB
      COMPLEX*16 A(LDA,N),B(LDB,M)
C     Variables
      INTEGER    I,J
C     ==--------------------------------------------------------------==
C$OMP parallel do private(I,J) shared(M,N,A,B)
      DO I=1,M
#ifdef _BGL
!IBM* INDEPENDENT
#endif
        DO J=1,N
          B(J,I)=A(I,J)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
#if !defined(INTEL_MKL)
C     ==================================================================
      SUBROUTINE ZGTHR(N,A,B,IND)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    N,IND(N)
      COMPLEX*16 A(*),B(N)
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
C$OMP parallel do private(I) shared(N,A,B,IND)
      DO I=1,N
        B(I)=A(IND(I))
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ZSCTR(N,A,IND,B)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    N,IND(N)
      COMPLEX*16 A(N),B(*)
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
#if defined(__SR8000)
*voption indep(B)
#else
!$OMP parallel do private(I) shared(N,A,B,IND)
#endif
      DO I=1,N
        B(IND(I))=A(I)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
#endif 
C     ==================================================================
      SUBROUTINE DURAND(SEED,N,A)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      REAL*8  A(N),SEED,XRANF
      EXTERNAL XRANF
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
      DO I=1,N
        A(I)=XRANF()
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DAXPYI(NZ,ALPHA,X,INDX,Y)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NZ,INDX(NZ)
      REAL*8  ALPHA,X(NZ),Y(*)
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
#if defined(__SR8000)
*voption indep(Y)
#else
!$OMP parallel do private(I) shared(NZ,Y,X,ALPHA,INDX)
#endif
      DO I=1,NZ
        Y(INDX(I))=Y(INDX(I))+ALPHA*X(I)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
#ifdef __SR11KIBM
C     ==================================================================
      FUNCTION DZAMAX(N,A,INC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      REAL*8 DZAMAX
C     Arguments
      INTEGER    N,INC
      COMPLEX*16 A(*)
C     Variables
      INTEGER    I,II
      REAL*8     Y,YMAX
C     ==--------------------------------------------------------------==
      YMAX=-1.0D0
!$OMP parallel do private(I,II,Y) reduction(MAX:YMAX)
      DO I=1,N
        II=(I-1)*INC+1
        Y=ABS(A(II))
        IF(Y.GT.YMAX) YMAX=Y
      ENDDO
      DZAMAX=YMAX
C     ==--------------------------------------------------------------==
      RETURN
      END
#endif
C     ==================================================================
#if   !(defined(__SGI)) && !(defined(__HP)) && !(defined(INTEL_MKL)) && !(defined(LINUX_IA64_INTEL))
      FUNCTION IZAMAX(N,A,INC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER IZAMAX
C     Arguments
      INTEGER    N,INC
      COMPLEX*16 A(*)
C     Variables
      INTEGER    I,II
      REAL*8     XMAX,Y
C     ==--------------------------------------------------------------==
      IZAMAX=0
      XMAX=-1.0D0
#if defined(__SR8000) ||defined(__SR11000) || defined(_vpp_)
      DO I=1,N
        II=(I-1)*INC+1
        Y=A(II)*DCONJG(A(II))
        IF(Y.GT.XMAX) THEN
          XMAX=Y
          IZAMAX=I
        ENDIF
      ENDDO
      XMAX=DSQRT(XMAX)
#else 
      DO I=1,N
        II=(I-1)*INC+1
        Y=ABS(A(II))
        IF(Y.GT.XMAX) THEN
          XMAX=Y
          IZAMAX=I
        ENDIF
      ENDDO
#endif 
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#endif
#endif
#if !(defined(CRAY) || defined(__IBM)) || defined(CRAYX1) || defined(__OSX)|| defined(__OSX_IFC) || defined(__PWRLinux) 
      FUNCTION IDAMIN(N,X,INX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER IDAMIN
C     Arguments
      INTEGER N,INX
      REAL*8 X(N)
C     Variables
      INTEGER I,IJ,II
      REAL*8 XMIN
C     ==--------------------------------------------------------------==
      XMIN=X(1)
      IJ=1
      DO I=2,N
        II=(I-1)*INX+1
        IF(XMIN.GE.DABS(X(II))) IJ=I
      ENDDO
      IDAMIN=IJ
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#endif
#if defined(T3D) || defined(T3E) 
      SUBROUTINE MY_GETARG(M,STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER M
      CHARACTER STRING*(*)
C     Variables
      INTEGER*8 L,IERROR
C     ==--------------------------------------------------------------==
c CRAY LSA : according to the man page of PXFGETARG the first argument
c            has to be default integer. For T3E and T3D this should be 
c            an 8 byte integer, not 4. As I do not have a T3x to test
c            on, I shall leave it as it is.
cmb - do NOT use apostrophes in comment. NEC precompiler makes a mess !
      CALL PXFGETARG(INT(M,4),STRING,L,IERROR)
      IF(IERROR.NE.0) STRING=' '
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MY_GETENV(EVAR,STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER EVAR*(*),STRING*(*)
C     Variables
      INTEGER*8 L,IERROR
C     ==--------------------------------------------------------------==
      CALL PXFGETENV(EVAR,15,STRING,L,IERROR)
      IF(IERROR.NE.0) STRING=' '
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MY_GETLOG(STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER STRING*(*)
C     Variables
      INTEGER*8 L,IERROR
C     ==--------------------------------------------------------------==
      CALL PXFGETLOGIN(STRING,L,IERROR)
      IF(IERROR.NE.0) STRING=' '
C     ==--------------------------------------------------------------==
      RETURN
      END
C     =================================================================
#elif defined(CRAYX1)
      SUBROUTINE MY_GETARG(M,STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER M
      CHARACTER STRING*(*)
C     Variables
      INTEGER*4 L,IERROR
C     ==--------------------------------------------------------------==
      CALL PXFGETARG(INT(M,4),STRING,L,IERROR)
      IF(IERROR.NE.0) STRING=' '
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MY_GETENV(EVAR,STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER EVAR*(*),STRING*(*)
C     Variables
      INTEGER*4 L,IERROR
C     ==--------------------------------------------------------------==
      CALL PXFGETENV(EVAR,15,STRING,L,IERROR)
      IF(IERROR.NE.0) STRING=' '
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MY_GETLOG(STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      CHARACTER STRING*(*)
C     Variables
      INTEGER*4 L,IERROR
C     ==--------------------------------------------------------------==
      CALL PXFGETLOGIN(STRING,L,IERROR)
      IF(IERROR.NE.0) STRING=' '
C     ==--------------------------------------------------------------==
      RETURN
      END
C     =================================================================
#elif defined(__SR2201) || defined(__SR8000) || defined (__SR11000)
      SUBROUTINE MY_GETARG(M,STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER M
      CHARACTER*(*) STRING
C     ==--------------------------------------------------------------==
#if defined (__SR11000)
      CALL GETARG(M,STRING)
#else
      CALL GETARG(M+1,STRING)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
#if defined (__SR11000)
C     =================================================================
      SUBROUTINE MY_GETENV(EVAR,STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      CHARACTER*(*) EVAR,STRING
C     ==--------------------------------------------------------------==
      CALL GETENV(EVAR,STRING)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     =================================================================
#else
C     =================================================================
      SUBROUTINE MY_GETENV(EVAR,STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER LEN1,LEN2
      CHARACTER*(*) EVAR,STRING
C     ==--------------------------------------------------------------==
      LEN1=LEN(EVAR)
      LEN2=80
      CALL GETENV(EVAR,LEN1,STRING,LEN2)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     =================================================================
#endif
      SUBROUTINE MY_GETLOG(STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      CHARACTER*(*) STRING
C     ==--------------------------------------------------------------==
      CALL GETLOG(STRING)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     =================================================================
#else
      SUBROUTINE MY_GETARG(M,STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER M,IA,IE
      CHARACTER*(*) STRING
C     ==--------------------------------------------------------------==
      CALL GETARG(M,STRING)
      CALL XSTRING(STRING,IA,IE)
      STRING=STRING(IA:IE)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     =================================================================
      SUBROUTINE MY_GETENV(EVAR,STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      CHARACTER*(*) EVAR,STRING
C     ==--------------------------------------------------------------==
      CALL GETENV(EVAR,STRING)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     =================================================================
      SUBROUTINE MY_GETLOG(STRING)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      CHARACTER*(*) STRING
C     ==--------------------------------------------------------------==
#if defined(__IBM) || defined(__OSX)
      CALL GETLOG_(STRING)
#elif defined(__OSX_IFC)
      CALL GETLOG(STRING)
#elif defined(_vpp_)
      CALL GETENV('USER',STRING)
#else
      CALL GETLOG(STRING)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
#endif
      SUBROUTINE ZCLEAN_K(A,N,NGW)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    N,NGW
      COMPLEX*16 A(2*NGW,N)
C     Variables
      INTEGER    I
C     ==--------------------------------------------------------------==
      IF(NGW.GT.0) THEN
!$OMP parallel do private(I) shared(NGW)
        DO I=1,N
          A(NGW+1,I)=DCMPLX(0.D0,0.D0)
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SETKWF(NGW,NSTATE,A)
C     ==--------------------------------------------------------------==
C     == A USES INVERSION SYMMETRY.                                   ==
C     == WE TRANSFORM A IN ARRAY WITHOUT INVERSION SYMMETRY.          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NGW,NSTATE
      COMPLEX*16 A(NGW,2*NSTATE)
C     Variables
      INTEGER    I,II,J
C     ==--------------------------------------------------------------==
      DO I=NSTATE,2,-1
        CALL DCOPY(2*NGW,A(1,I),1,A(1,2*I-1),1)
      ENDDO
      DO I=1,NSTATE
        II=2*I
        CALL DCOPY(2*NGW,A(1,II-1),1,A(1,II),1)
        DO J=1,NGW
          A(J,II)=DCONJG(A(J,II))
        ENDDO
      ENDDO
      IF(GEQ0) CALL ZCLEAN_K(A,NSTATE,NGW)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FSKIP(NF,NREC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER NF,NREC
C     Variables
      INTEGER I
C     ==--------------------------------------------------------------==
      IF(NREC.LT.0) THEN
        WRITE(6,*) ' FSKIP! NREC=',NREC
        CALL STOPGM('FSKIP','BAD NUMBER OF RECORDS (NREC) TO SKIP')
      ENDIF
      DO I=1,NREC
        READ(NF,END=20,ERR=30)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
C     ==--------------------------------------------------------------==
 20   CONTINUE
      CALL STOPGM('FSKIP','END OF FILE')
 30   CONTINUE
      CALL STOPGM('FSKIP','READ ERROR')
      END
C     ==================================================================
      FUNCTION DGIVE(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      REAL*8 DGIVE
C     Arguments
      INTEGER N
      REAL*8  A(N)
C     ==--------------------------------------------------------------==
      DGIVE=A(N)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION ZGIVE(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      COMPLEX*16 ZGIVE
C     Arguments
      INTEGER    N
      COMPLEX*16 A(N)
C     ==--------------------------------------------------------------==
      ZGIVE=A(N)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     == USED TO DEBUG.                                               ==
C     ==================================================================
      SUBROUTINE ROUNDOFF(N,A)
C     ==--------------------------------------------------------------==
C     == ROUNDOFF ERROR NEAR AN INTEGER VALUE                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER   N
      REAL*8    A(N)
C     Variables
      INTEGER   I
C     ==--------------------------------------------------------------==
!$OMP parallel do private(I)
      DO I=1,N
        A(I) = A(I)- DMOD(A(I),1.D-15)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DEBROT(A,N,NSTATE)
C     ==--------------------------------------------------------------==
C     == G=0 COMPONENT OF C0 IS REAL                                  ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    N,NSTATE
      COMPLEX*16 A(N,NSTATE)
C     Variables
      REAL*8     TOLL
      PARAMETER  (TOLL=1.D-13)
      INTEGER    I,II
      COMPLEX*16 ZS
C     ==--------------------------------------------------------------==
      DO I=1,NSTATE
        DO II=1,N
          IF (ABS(A(II,I)).GT.TOLL) GOTO 10
        ENDDO
        II=N
 10     CONTINUE
        IF(DABS(DIMAG(A(II,I))).GT.TOLL) THEN
          ZS=DCMPLX(ABS(A(II,I)),0D0)/A(II,I)
        ELSE
          ZS=DCMPLX(1.D0,0.D0)
        ENDIF
        CALL ZSCAL(N,ZS,A(1,I),1)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE STORE(C0,NUM,IOPT,IUNIT)
C     ==--------------------------------------------------------------==
C     == STORE IN A FILE AN ARRAY TO DEBUG                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NUM,IOPT,IUNIT
      REAL*8  C0(2,*)
C     Variables
      INTEGER I,J
      REAL*8  DNRM2,DOTP
      EXTERNAL DOTP
C     ==--------------------------------------------------------------==
      OPEN(UNIT=IUNIT,STATUS= 'UNKNOWN')
      IF(IOPT.EQ.1) THEN
        WRITE(IUNIT,*) 0, SQRT(DOTP(NUM,C0(1,1),C0(1,1))),0.D0
      ELSEIF(IOPT.EQ.2) THEN
        WRITE(IUNIT,*) 0, DNRM2(2*IOPT*NUM,C0(1,1),1),0.D0
      ENDIF
      IF(IOPT.LE.2) THEN
        DO I=1,NUM*IOPT
          WRITE(IUNIT,*) I, C0(1,I), C0(2,I)
        ENDDO
      ELSE
        DO I=1,NUM/2
          DO J=1,2
            WRITE(IUNIT,*) 2*(I-1)+J, C0(J,I)
          ENDDO
        ENDDO
        IF(2*(NUM/2).NE.NUM) WRITE(IUNIT,*) NUM, C0(1,NUM/2+1)
      ENDIF
      CLOSE(UNIT=IUNIT)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     == USED TO DEBUG.                                               ==
C     ==================================================================
      SUBROUTINE DETERM(DMAT,LD,N,ISCR,LSCR,DD)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    LD,N,ISCR,LSCR
      COMPLEX*16 DMAT(LD,*),DD
C     Variables
      INTEGER    I,INFO
C     ==--------------------------------------------------------------==
      IF(LSCR.LT.N) CALL STOPGM('DETERM','SCRATCH TOO SMALL')
      CALL ZGETRF(N,N,DMAT,LD,ISCR,INFO)
      IF(INFO.NE.0) CALL STOPGM('DETERM','ILLEGAL RESULTS')
      DD=DCMPLX(1.D0,0.D0)
      DO I=1,N
        DD=DD*DMAT(I,I)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION NXXFUN(NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER NXXFUN,NSTATE
C     Variables
      INTEGER N1,N2,I,NS
C     ==--------------------------------------------------------------==
      N1=0
      N2=0
      DO I=0,NPROC-1
        NS=NST12(I,2)-NST12(I,1)+1
        N1=MAX(N1,NS)
        N2=MAX(N2,SPARM(3,I))
      ENDDO
      NXXFUN=N1*N2
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION SBES0(X)
C     ==--------------------------------------------------------------==
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA SMALL /1.D-35/
C     ==--------------------------------------------------------------==
C     ==  CALCULATE SPHERICAL BESSEL FUNCTION OF THE FIRST KIND       ==
C     ==--------------------------------------------------------------==
      IF(DABS(X).LT.SMALL) THEN
        SBES0=1.0D0 - X*X/6.0D0 + X*X*X*X/120.0D0
      ELSE
        SBES0=DSIN(X)/X
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION FC4(X,Y)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA SMALL /1.D-10/
C..CALCULATE (X*SIN(Y) - Y*SIN(X))/(X*Y*(Y^2 - X^2))
      DIFF = Y*Y - X*X
      IF(DABS(DIFF).GT.SMALL) THEN
        FC4=(X*DSIN(Y)-Y*DSIN(X))/(X*Y*(Y*Y-X*X))
      ELSE
        DXY = X - Y
        FC4 = -0.5D0*SB1(Y) + 0.25D0*SB2(Y)*DXY
     *        -1.0D0/120.0D0*(7.0D0*SB3(Y) - 3.0D0*SB1(Y))*DXY*DXY
     *        +1.0D0/336.0D0*(3.0D0*SB4(Y) - 4.0D0*SB2(Y))*DXY*DXY*DXY
     *        +1.0D0/30240.0D0*(-31.0D0*SB5(Y)+77.0D0*SB3(Y)
     *           -18.0D0*SB1(Y))*DXY*DXY*DXY*DXY
      ENDIF
      RETURN
      END
C======================================================================C
      FUNCTION SB1(Y)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA SMALL /1.D-6/
      IF(DABS(Y).GT.SMALL) THEN
        SB1=DSIN(Y)/Y**3 - DCOS(Y)/Y**2
      ELSE
        SB1=(1.D0-Y**2/10.0D0+Y**4/280.0D0)/3.0D0
      ENDIF
      RETURN
      END
C======================================================================C
      FUNCTION SB2(Y)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA SMALL /1.D-6/
      IF(DABS(Y).GT.SMALL) THEN
        SB2=DSIN(Y)*(3.0D0/Y**4-1.0D0/Y**2) - DCOS(Y)*(3.0D0/Y**3)
      ELSE
        SB2=(1.D0-Y**2/14.0D0+Y**4/504.0D0)*Y/15.0D0
      ENDIF
      RETURN
      END
C======================================================================C
      FUNCTION SB3(Y)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA SMALL /1.D-6/
      IF(DABS(Y).GT.SMALL) THEN
        SB3=DSIN(Y)*(15.0D0/Y**5-6.0D0/Y**3)
     *    + DCOS(Y)*(-15.0D0/Y**4+1.0D0/Y**2)
      ELSE
        SB3=(1.D0-Y**2/18.0D0)*Y**2/105.0D0
      ENDIF
      RETURN
      END
C======================================================================C
      FUNCTION SB4(Y)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA SMALL /1.D-6/
      IF(DABS(Y).GT.SMALL) THEN
        SB4=DSIN(Y)*(105.0D0/Y**6-45.0D0/Y**4+1.0D0/Y**2)
     *    + DCOS(Y)*(-105.0D0/Y**5+10.0D0/Y**3)
      ELSE
        SB4=(1.D0-Y**2/22.0D0)*Y**3/945.0D0
      ENDIF
      RETURN
      END
C======================================================================C
      FUNCTION SB5(Y)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA SMALL /1.D-6/
      IF(DABS(Y).GT.SMALL) THEN
        SB5=DSIN(Y)*(945.0D0/Y**7-420.0D0/Y**5+15.0D0/Y**3)
     *    + DCOS(Y)*(-945.0D0/Y**6+105.0D0/Y**4-1.0D0/Y**2)
      ELSE
        SB5=Y**4/10395.0D0
      ENDIF
      RETURN
      END
C     ==================================================================
      SUBROUTINE VRAND(N,A,TDRANDOM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER N,I
      REAL*8 A(N),TDRANDOM,XRANF
      EXTERNAL XRANF
C     ==--------------------------------------------------------------==
#if defined(__SR8000)
*voption indep(A)
#else
!$OMP parallel do private(i) shared(TDRANDOM)
#endif
      DO I=1,N
        A(I)=A(I)+XRANF()*TDRANDOM
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RTRANS(A,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER       N
      REAL*8        A(N,N)
C     Local variables
      REAL*8        AIJ
      INTEGER       I,J
C     ==--------------------------------------------------------------==
C$OMP parallel do private(I,J,AIJ) shared(N,A) schedule(static,1)
      DO I=1,N
        DO J=I+1,N
          AIJ=A(I,J)
          A(I,J)=A(J,I)
          A(J,I)=AIJ
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RMATMOV(N,M,A,LDA,B,LDB)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER    N,M,LDA,LDB
      REAL*8     A(LDA,*),B(LDB,*)
C     Variables
      INTEGER    I,J
C     ==--------------------------------------------------------------==
C$OMP parallel do private(I,J) shared(M,N,A,B)
      DO I=1,M
        DO J=1,N
          B(J,I)=A(J,I)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DURANDSEED(N,A)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER N
      INTEGER*4 time
      REAL*8  A(N),timec
      INTEGER KONST
  
      INTEGER I,ISEED,SEEDMAX, FIRSTSEED
      PARAMETER  (SEEDMAX=2796203)
      PARAMETER   (FIRSTSEED=100001)
      DATA ISEED /FIRSTSEED/
      DATA    KONST/125/
      SAVE ISEED
C     ==--------------------------------------------------------------==
      
      IF (ISEED .EQ. FIRSTSEED) THEN
         time = nint(dabs(timec()))
         ISEED=time
         ISEED=ISEED- 1029933254
         DO I=1,ISEED
      
           IF (ISEED .GE. SEEDMAX ) THEN 
               ISEED=ISEED/2
           ELSE
               ISEED=ISEED*KONST
               ISEED=ISEED-2796203*(ISEED/2796203)
               ISEED=ISEED*KONST
               ISEED=ISEED-2796203*(ISEED/2796203)
               GOTO 999
           ENDIF
         ENDDO
 999     CONTINUE   
       ENDIF
      
      DO I=1,N
        ISEED=ISEED*KONST
        ISEED=ISEED-2796203*(ISEED/2796203)
        A(I)=DBLE(ISEED)/2796203.D0
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION XRANFSEED()
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      REAL*8 XRANFSEED
C     Variables
      INTEGER ISEED,KONST
      INTEGER*4 time
      INTEGER I,SEEDMAX, FIRSTSEED
      REAL*8  timec
      PARAMETER  (SEEDMAX=2796203)
      PARAMETER   (FIRSTSEED=100001)
      DATA ISEED /FIRSTSEED/
      DATA KONST/125/
      SAVE    ISEED
       
       IF (ISEED .EQ. FIRSTSEED) THEN
         time = DABS(timec())
         ISEED=time
         ISEED=ISEED- 1029933254
         DO I=1,ISEED
           IF (ISEED .GE. SEEDMAX ) THEN 
               ISEED=ISEED/2
           ELSE
               ISEED=ISEED*KONST
               ISEED=ISEED-2796203*(ISEED/2796203)
               ISEED=ISEED*KONST
               ISEED=ISEED-2796203*(ISEED/2796203)
               GOTO 999
           ENDIF
         ENDDO
 999     CONTINUE   
       ENDIF
C     ==--------------------------------------------------------------==
       ISEED=ISEED*KONST
       ISEED=ISEED-2796203*(ISEED/2796203)
       XRANFSEED=DBLE(ISEED)/2796203.D0
C     ==--------------------------------------------------------------==
      RETURN
      END
#if defined(CRAYX1)
      real*8 function derf(x)
c---------------------------------------------------------------------
c
c     Error function - computed from the rational approximations of 
c     W. J. Cody, Math. Comp. 22 (1969), pages 631-637.
c
c     for abs(x) le 0.47 erf is calculated directly 
c     for abs(x) gt 0.47 erf is calculated via erf(x)=1-erfc(x)
c
      implicit none
      real*8 x, x2, p1(4),q1(4),derfc
      external derfc
      data p1/2.42667955230532d2,
     1        2.19792616182942d1,
     2        6.99638348861914d0,
     3       -3.56098437018154d-2/
      data q1/2.15058875869861d2,
     1        9.11649054045149d1,
     2        1.50827976304078d1,
     3        1.00000000000000d0/
c
      if(DABS(x).gt.6.d0) then
c
c  derf(6)=1-10^(-17) cannot be distinguished from 1 with 16-byte words
c
         derf=sign(1.d0,x)
      else
         if(DABS(x).le.0.47d0) then
            x2 = x**2
            derf = x*(p1(1)+x2*(p1(2)+x2*(p1(3)+x2*p1(4) )))
     1             /(q1(1)+x2*(q1(2)+x2*(q1(3)+x2*q1(4) )))
         else
            derf = 1.d0 - derfc(x)
         end if
      end if
c
      return
      end
C
* COPYRIGHT CRAY INC.
* UNPUBLISHED -- ALL RIGHTS RESERVED UNDER
* THE COPYRIGHT LAWS OF THE UNITED STATES

      REAL*8 FUNCTION DERFC(ARG)
      IMPLICIT NONE
      REAL*8 X,P0,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,P11,XSQ,XSQ2,NODD,NEVEN
      REAL*8 N,D,ARG,XSQI,Z,ZUP,ZLO,S,EXP1,SQPI_INV,ANS,E1,E2,E3
      REAL*8 Q0,Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,R0,R1,R2,R3,R4,R5,R6,R7,R8
      REAL*8 S0,S1,S2,S3,S4,S5,S6,S7,S8,S9
      PARAMETER ( SQPI_INV = 0.56418958354775628694807945156077258E0_8)
      PARAMETER ( P0 =  1.128379167095512567E+00_8)
      PARAMETER ( P1 = -3.761263890318352736E-01_8)
      PARAMETER ( P2 =  1.128379167094438506E-01_8)
      PARAMETER ( P3 = -2.686617064313519512E-02_8)
      PARAMETER ( P4 =  5.223977606274834792E-03_8)
      PARAMETER ( P5 = -8.548325935617628444E-04_8)
      PARAMETER ( P6 =  1.205529374025803863E-04_8)
      PARAMETER ( P7 = -1.492471507980235258E-05_8)
      PARAMETER ( P8 =  1.644716239254218548E-06_8)
      PARAMETER ( P9 = -1.620652863895304162E-07_8)
      PARAMETER (P10 =  1.371183485419854949E-08_8)
      PARAMETER (P11 = -7.780946541466675436E-10_8)
      PARAMETER (Q0 = 5.57535340817727675546E2_8)
      PARAMETER (Q1 = 1.65666309194161350182E3_8)
      PARAMETER (Q2 = 2.24633760818710981792E3_8)
      PARAMETER (Q3 = 1.82390916687909736289E3_8)
      PARAMETER (Q4 = 9.75708501743205489753E2_8)
      PARAMETER (Q5 = 3.54937778887819891062E2_8)
      PARAMETER (Q6 = 8.67072140885989742329E1_8)
      PARAMETER (Q7 = 1.32281951154744992508E1_8)
      PARAMETER (Q8 = 1.0_8)
      PARAMETER (R0 = 5.57535335369399327526E2_8)
      PARAMETER (R1 = 1.02755188689515710272E3_8)
      PARAMETER (R2 = 9.34528527171957607540E2_8)
      PARAMETER (R3 = 5.26445194995477358631E2_8)
      PARAMETER (R4 = 1.96520832956077098242E2_8)
      PARAMETER (R5 = 4.86371970985681366614E1_8)
      PARAMETER (R6 = 7.46321056442269912687E0_8)
      PARAMETER (R7 = 5.64189564831068821977E-1_8)
      PARAMETER (R8 = 2.46196981473530512524E-10_8)
      PARAMETER (S0 = -2.284926834011684699404E-19_8)
      PARAMETER (S1 = -4.999999999999980969948E-01_8)
      PARAMETER (S2 =  7.499999999952419251201E-01_8)
      PARAMETER (S3 = -1.874999995108372491321E+00_8)
      PARAMETER (S4 =  6.562497494455691381444E+00_8)
      PARAMETER (S5 = -2.953053153789537661345E+01_8)
      PARAMETER (S6 =  1.622987700033927197399E+02_8)
      PARAMETER (S7 = -1.042779900430113302447E+03_8)
      PARAMETER (S8 =  7.083360958140695770250E+03_8)
      PARAMETER (S9 = -3.578573853690478041393E+04_8)
      PARAMETER (E1 = 5.000000000000121505E-01_8)
      PARAMETER (E2 = 1.666666663291518604E-01_8)
      PARAMETER (E3 = 4.166966677773827054E-02_8)
      X = DABS( ARG )
      XSQ  = X * X
      XSQ2  = XSQ * XSQ
      IF (X .LE. 1.0_8) THEN
        NODD = P11 * XSQ2 + P9
        NEVEN = P10 * XSQ2 + P8
        NODD = NODD * XSQ2 + P7
        NEVEN = NEVEN * XSQ2 + P6
        NODD = NODD * XSQ2 + P5
        NEVEN = NEVEN * XSQ2 + P4
        NODD = NODD * XSQ2 + P3
        NEVEN = NEVEN * XSQ2 + P2
        NODD = NODD * XSQ2 + P1
        NEVEN = NEVEN * XSQ2 + P0
        ANS  = 1.E0_8 - (ARG * ( NODD * XSQ + NEVEN ))
      ELSE
        S      = transfer(int(AND(MASK(37_8),X),8),S)
        ZUP    = DEXP(-S*S)
        ZLO    = S*(S-X) + X*(S-X)
        EXP1   = ((E3*ZLO + E2)*ZLO + E1)*ZLO*ZLO + ZLO
        ZLO    = ZUP*EXP1
        Z      = ZUP + ZLO
        IF (X .LE. 8.0_8) THEN
          N = R8
          N = N*X + R7
          N = N*X + R6
          N = N*X + R5
          N = N*X + R4
          N = N*X + R3
          N = N*X + R2
          N = N*X + R1
          N = N*X + R0
          D =   X + Q7
          D = D*X + Q6
          D = D*X + Q5
          D = D*X + Q4
          D = D*X + Q3
          D = D*X + Q2
          D = D*X + Q1
          D = D*X + Q0
          ANS = (Z*N)/D
        ELSE
          XSQI = 1.0_8/(XSQ)
          N = S9
          N = N*XSQI + S8
          N = N*XSQI + S7
          N = N*XSQI + S6
          N = N*XSQI + S5
          N = N*XSQI + S4
          N = N*XSQI + S3
          N = N*XSQI + S2
          N = N*XSQI + S1
          N = N*XSQI + S0
          ANS = (ZUP +  (ZLO + Z * N))* SQPI_INV /  X
        ENDIF
        IF(ARG .LT. 0.0_8) ANS = 2.0_8 - ANS
      ENDIF
      DERFC = ANS
      RETURN
      END
#endif

