C     ==================================================================
      SUBROUTINE VBETA(RHOE,PSI,IKIND)
C     ==--------------------------------------------------------------==
C     ==  APPLIES e^(-beta/(2P)Vlocal) to NL-PP projectors            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'cppt.inc' 
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'sfac.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
C     Arguments
      INTEGER    IKIND
      COMPLEX*16 PSI(NNR1)
      REAL*8     RHOE(NNR1)
C     Variables
      DIMENSION  TWNL(NGWK,NHXS,NSX,NKPNT),NLPTR(3,NLM),
     &           EIGR(NGW,NAT),CNL(NGWK,NLM),EIGKR(NGWK,NAT,NKPNT)
      REAL*8     FNL(*),DFNL(*)
      COMPLEX*16 FP,FM,CP1,CP2
      INTEGER    ISUB,IFFT,NJUMP,I,I1,I2,IS1,ISA1,IV1,IS2,ISA2,IV2,IG,
     &           IR
C     ==--------------------------------------------------------------==
      IF(NLM.EQ.0) RETURN
      CALL TISET('     VBETA',ISUB)
C..prepare the potential
!$OMP parallel do private(IR)
      DO IR = 1 , NNR1
        RHOE(IR)=DSQRT(RHOE(IR))
      ENDDO
      IFFT=1
Ckpt  We do not use the trick for FFT.
      IF(TKPNT) THEN 
        NJUMP=1
      ELSE
        NJUMP=2
      ENDIF
      DO I = 1, NLM, NJUMP
        I1 = I
        I2 = I+1
        CALL ZAZZERO(PSI,MAXFFT)
        IF((I2.LE.NLM).AND.(.NOT.TKPNT)) THEN
          IS1=NLPTR(1,I1)
          ISA1=NLPTR(2,I1)
          IV1=NLPTR(3,I1)
          IS2=NLPTR(1,I2)
          ISA2=NLPTR(2,I2)
          IV2=NLPTR(3,I2)
          CP1=(0.0D0,-1.0D0)**NGHTOL(IV1,IS1)
          CP2=(0.0D0,-1.0D0)**NGHTOL(IV2,IS2)
!CDIR NODEP
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(10000))
#endif
#if defined(__VECTOR)
!$OMP parallel do private(IG,FP,FM)
#else
!$OMP parallel do private(IG,FP,FM) schedule(static)
#endif
          DO IG = 1,NGW
            FP=CP1*TWNL(IG,IV1,IS1,IKIND)*EIGR(IG,ISA1)
            FM=CP2*TWNL(IG,IV2,IS2,IKIND)*EIGR(IG,ISA2)
            PSI(NZHS(IG)) = FP+UIMAG*FM
            PSI(INDZS(IG)) = DCONJG(FP)+UIMAG*DCONJG(FM)
          ENDDO
          IF(GEQ0) PSI(NZHS(1))=
     &               CP1*TWNL(1,IV1,IS1,IKIND)*EIGR(1,ISA1)+
     &         UIMAG*CP2*TWNL(1,IV2,IS2,IKIND)*EIGR(1,ISA2)
        ELSE
          IS1=NLPTR(1,I1)
          ISA1=NLPTR(2,I1)
          IV1=NLPTR(3,I1)
          CP1=(0.0D0,-1.0D0)**NGHTOL(IV1,IS1)
          IF(TKPNT) THEN
!CDIR NODEP
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT 
#endif
#if defined(__VECTOR)
C$OMP parallel do private(IG)
#else
C$OMP parallel do private(IG) schedule(static)
#endif
            DO IG = 1,NGW
              PSI(NZHS(IG))  = CP1*TWNL(IG    ,IV1,IS1,IKIND)*
     &             EIGKR(IG    ,ISA1,IKIND)
              PSI(INDZS(IG)) = CP1*TWNL(IG+NGW,IV1,IS1,IKIND)*
     &             EIGKR(IG+NGW,ISA1,IKIND)
            ENDDO
            IF(GEQ0) PSI(NZHS(1))=
     &               CP1*TWNL(1,IV1,IS1,IKIND)*EIGKR(1,ISA1,IKIND)
          ELSE
!CDIR NODEP
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
#endif
#if defined(__VECTOR)
!$OMP parallel do private(IG,FP)
#else
!$OMP parallel do private(IG,FP) schedule(static)
#endif
            DO IG = 1,NGW
              FP=CP1*TWNL(IG,IV1,IS1,IKIND)*EIGR(IG,ISA1)
              PSI(NZHS(IG)) = FP
              PSI(INDZS(IG)) = DCONJG(FP)
            ENDDO
            IF(GEQ0) PSI(NZHS(1))=
     &               CP1*TWNL(1,IV1,IS1,IKIND)*EIGR(1,ISA1)
          ENDIF
        ENDIF
C       ==------------------------------------------------------------==
C       == INVERSE FFT PSI TO OBTAIN PSI ON REAL SPACE MESH           ==
C       ==------------------------------------------------------------==
        CALL S_INVFFT(PSI)
C       ==------------------------------------------------------------==
C       == APPLY THE EXPONENTIATED POTENTIAL TO PSI                   ==
C       == APPLY e^(-b/2P V) IN REAL SPACE, AND RETURN ANSWER IN PSI. ==
C       == ARRAY POT CONTAINS e^(-b/P V(r)).                          ==
C       ==------------------------------------------------------------==
!$OMP parallel do private(IR)
        DO IR = 1 , NNR1
          PSI(IR) = PSI(IR)*RHOE(IR)
        ENDDO
C       ==------------------------------------------------------------==
C       == TRANSFORM BACK TO FOURIER SPACE                            ==
C       ==------------------------------------------------------------==
        CALL S_FWFFT(PSI)
        IF((I2.LE.NLM).AND.(.NOT.TKPNT)) THEN
!CDIR NODEP
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
#endif
#if defined(__VECTOR)
!$OMP parallel do private(IG,FP,FM)
#else
!$OMP parallel do private(IG,FP,FM) schedule(static)
#endif
          DO IG = 1 , NGW
            FP=(PSI(NZHS(IG))+PSI(INDZS(IG)))*0.5D0
            FM=(PSI(NZHS(IG))-PSI(INDZS(IG)))*0.5D0
            CNL(IG,I1) = DCMPLX(DREAL(FP),DIMAG(FM))
            CNL(IG,I2) = DCMPLX(DIMAG(FP),-DREAL(FM))
          ENDDO
          IF(GEQ0) THEN 
            CNL(1,I1) = DCMPLX(DREAL(CNL(1,I1)),0.D0)
            CNL(1,I2) = DCMPLX(DREAL(CNL(1,I2)),0.D0)
          ENDIF
        ELSE
          IF(TKPNT) THEN
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT
#endif
#if defined(__VECTOR)
!$OMP parallel do private(IG)
#else
!$OMP parallel do private(IG) schedule(static)
#endif
            DO IG = 1, NGW
              CNL(IG    ,I1) = PSI(NZHS(IG))
              CNL(IG+NGW,I1) = PSI(INDZS(IG))
            ENDDO
            IF(GEQ0) CNL(1+NGW,I1) = DCMPLX(0.D0,0.D0)
          ELSE
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
#endif
#if defined(__VECTOR)
!$OMP parallel do private(IG,FP,FM)
#else
!$OMP parallel do private(IG,FP,FM) schedule(static)
#endif
            DO IG = 1, NGW
              FP=(PSI(NZHS(IG))+PSI(INDZS(IG)))*0.5D0
              FM=(PSI(NZHS(IG))-PSI(INDZS(IG)))*0.5D0
              CNL(IG,I1) = DCMPLX(DREAL(FP),DIMAG(FM))
            ENDDO
            IF(GEQ0) CNL(1,I1) = DCMPLX(DREAL(CNL(1,I1)),0.D0)
          ENDIF
        ENDIF
      ENDDO
C..Return to the old potential
!$OMP parallel do private(IR)
      DO IR = 1 , NNR1
        RHOE(IR) = RHOE(IR)*RHOE(IR)
      ENDDO
      CALL TIHALT('     VBETA',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
