C     ==================================================================
      SUBROUTINE VDBINIT(IS,JL,FINT)
C     ==--------------------------------------------------------------==
C     ==  THIS ROUTINE INITALIZES ARRAYS   BETA  QRAD  QQ             ==
C     ==  THIS ROUTINE IS MOSTLY FROM THE ROUTINE NLINIT IN THE       ==
C     ==  ORIGINAL VANDERBILT CODE                                    ==
C     ==                                                              ==
C     ==  BETA(IG,L,IS) = 4PI/SQRT(OMEGA) Y^R(L,Q^)                   ==
C     ==                        INT_0^INF DR R^2 J_L(QR) BETA(L,IS,R) ==
C     ==                                                              ==
C     ==  QRAD(IGL,L,K,IS) = 4PI/OMEGA                                ==
C     ==                   INT_0^R DR R^2 J_L(QR) Q(R,L,K,IS)         ==
C     ==                                                              ==
C     ==  BETA(G)_LM,IS = (-I)^L*BETA(IG,L,IS)                        ==
C     ==                                                              ==
C     ==  QQ_IJ=INT_0^R Q_IJ(R)=OMEGA*QG(G=0)                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'pslo.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'aavan.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
C     Arguments
      INTEGER   IS
      REAL*8    JL(*),FINT(*)
C     Variables
      DIMENSION TWNS(NSPLPO,2,NHXS,*),GGNG(*)
      REAL*8    GGL,XG,BETAX
      INTEGER   ISUB,LVAL,NT,MMAX,ISTEP,I,LM,L,IV,M,IOLD,IL,IR,IERR,JV
C     ==--------------------------------------------------------------==
C     ==  qq order:  s_1 p_x1 p_z1 p_y1 ... s_2 p_x2 p_z2 p_y2  ...   ==
C     ==                               spppddddd spppddddd ...        ==
C     == qqq order: s_1 s_2 p_1 p_2 d_1 d_2              ss..pp..dd.. ==
C     ==                                                              ==
C     ==  NELEV  =  NO. OF ENERGY LEVELS                              ==
C     ==  NGH(IS) = TOTAL NUMBER OF STATES                            ==
C     ==  ISTEP  =  LENGTH OF SPPPDDD.. SEQUENCE = 1+3+5+...          ==
C     ==--------------------------------------------------------------==
      CALL TISET('   VDBINIT',ISUB)
      LVAL=NVALES(IS)
      NT=NVALES(IS)
      NELEV(IS)=NBETA(IS)/NVALES(IS)
      NGH(IS)=NT*NT*NELEV(IS)
      MMAX=KKBETA(IS)
      ISTEP=NT*NT
      IF(NGH(IS).GT.NHXS) CALL STOPGM(' NLINIT',' NGH.GT.NHX ')
      DO I=1,NGH(IS),ISTEP
        LM=-1
        DO L=0,NVALES(IS)-1
          DO M=0,2*L
            LM=LM+1
            IV=I+LM
            NGHTOL(IV,IS)=L
            INDV(IV,IS)=L*NELEV(IS)+1+(I-1)/ISTEP
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
C     ==   INDV(1)=1         ! QQ ORDER:                              ==
C     ==   INDV(2)=3         ! s_1 p_x1 p_z1 p_y1 s_2 p_x2 p_z2 p_y2  ==
C     ==   INDV(3)=3         ! QQQ ORDER:                             ==
C     ==   INDV(4)=3         ! s_1 s_2 p_1 p_2                        ==
C     ==   INDV(5)=2         ! SEE ALSO YLMR (OR AAINIT)              ==
C     ==   INDV(6)=4                                                  ==
C     ==   INDV(7)=4                                                  ==
C     ==   INDV(8)=4                                                  ==
C     ==--------------------------------------------------------------==
C     ==  CALCULATION OF ARRAY  TWNL(IG,IV,IS)                        ==
C     ==--------------------------------------------------------------==
      IOLD=-1
      DO IV=1,NGH(IS)
        IF(IOLD.EQ.INDV(IV,IS)) THEN
          CALL DCOPY(2*NSPLPO,TWNS(1,1,IV-1,IS),1,TWNS(1,1,IV,IS),1)
        ELSE
          L=NGHTOL(IV,IS)+1
          CALL AZZERO(TWNS(1,1,IV,IS),NSPLPO)
          DO IL=NSPLPA,NSPLPE
             GGL=GGNG(IL)
             XG=DSQRT(GGL)*TPIBA
             CALL BESS(XG,L,MMAX,R(1,IS),JL)
!$OMP parallel do private(IR)
             DO IR=1,MMAX
               FINT(IR)=R(IR,IS)*BETAR(IR,INDV(IV,IS),IS)*JL(IR)
             ENDDO
             IF(TLOG(IS)) THEN
               CALL RADLG(MMAX,FINT,RAB(1,IS),BETAX)
             ELSE
               CALL RADIN(MMAX,CMESH(IS),FINT,BETAX)
             ENDIF
             TWNS(IL,1,IV,IS)=FPI*BETAX
          ENDDO
          CALL GLOSUM(NSPLPO,TWNS(1,1,IV,IS))
          CALL CURV1(NSPLPO,GGNG(1),TWNS(1,1,IV,IS),0.0D0,
     *               0.0D0,3,TWNS(1,2,IV,IS),FINT,0.0D0,IERR)
        ENDIF
        IOLD=INDV(IV,IS)
      ENDDO
C     ==--------------------------------------------------------------==
C     ==        CALCULATE ARRAY  DVAN(IV,JV,IS)    ! IN  RY UNITS     ==
C     ==--------------------------------------------------------------==
      CALL AZZERO(DVAN(1,1,IS),NHXS*NHXS)
C$OMP parallel do private(IV,JV)
      DO IV=1,NGH(IS)
        DO JV=1,NGH(IS)
          IF( MOD(IV-1,ISTEP).EQ.MOD(JV-1,ISTEP) ) THEN
            DVAN(IV,JV,IS)=0.5D0*DION(INDV(IV,IS),INDV(JV,IS),IS)
C                                      0.5 TO CONVERT RY TO A.U.
          ENDIF
        ENDDO
      ENDDO
      CALL TIHALT('   VDBINIT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE QINIT(JL,FINT)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'pslo.inc'
      INCLUDE 'vdbp.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cvan.inc'
      INCLUDE 'aavan.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'irat.inc'
C     Arguments
      REAL*8     JL(*),FINT(*)
C     Variables
      DIMENSION  QRAD(NQDIM,NBRX,NBRX,LX,*),GGNH(*)
      REAL*8     QSP1(*),QSP2(*),QSP3(*),QRD0(NBRX,NBRX)
      POINTER    (IP_QSP1,QSP1),(IP_QSP2,QSP2),(IP_QSP3,QSP3),
     &           (IP_QRD0,QRD0)
      REAL*8     QG0,GGl,XG,FQRAD,
     &           CURV2
      INTEGER    ISUB,IS,LVAL,MMAX,LQX,L,IL,IV,JV,IR,IERR,NNGH
C     ==--------------------------------------------------------------==
      CALL TISET('     QINIT',ISUB)
      CALL MEMORY(IP_QSP1,NSPLPO,'QSP1')
      CALL MEMORY(IP_QSP2,NSPLPO,'QSP2')
      CALL MEMORY(IP_QSP3,NSPLPO,'QSP3')
      CALL MEMORY(IP_QRD0,NBRX*NBRX,'QRD0')
C     ==--------------------------------------------------------------==
C     ==  CALCULATION OF ARRAY  QRAD(IGL,IV,JV,IS)                    ==
C     ==--------------------------------------------------------------==
      DO IS=1,NSP
        IF(TVAN(IS)) THEN
          LVAL=NVALES(IS)
          MMAX=KKBETA(IS)
          LQX=2*(LVAL-1)+1
          IF(QSPLINE) THEN
C           L =  S  P  D  ( F G )      NOTE : Q(R) = R^2*Q(R)
            DO L=1,LQX 
              CALL AZZERO(QRAD(1,1,1,L,IS),NQDIM*NBRX*NBRX)
              DO IL=NSPLPA,NSPLPE
                GGL=GGNH(IL)
                XG=DSQRT(GGL)*TPIBA
                CALL BESS(XG,L,MMAX,R(1,IS),JL)
                DO IV=1,NBETA(IS)
                  DO JV=IV,NBETA(IS)
                    IF(TPSEU(IS)) THEN
C$OMP parallel do private(IR)
                      DO IR=1,MMAX
                        FINT(IR)=QRL(IR,IV,JV,L,IS)*JL(IR)
                      ENDDO
                    ELSE
C$OMP parallel do private(IR)
                      DO IR=1,MMAX
                        FINT(IR)=QFUNC(IR,IV,JV,IS)*JL(IR)
                      ENDDO
                    ENDIF
                    IF(TLOG(IS)) THEN
                      CALL RADLG(MMAX,FINT,RAB(1,IS),FQRAD)
                    ELSE
                      CALL RADIN(MMAX,CMESH(IS),FINT,FQRAD)
                    ENDIF
                    QRAD(IL,IV,JV,L,IS)=FPI*FQRAD
                    QRAD(IL,JV,IV,L,IS)=FPI*FQRAD
                  ENDDO
                ENDDO
              ENDDO
C             SPLINE
              CALL GLOSUM(NQDIM*NBRX*NBRX,QRAD(1,1,1,L,IS))
              DO IV=1,NBETA(IS)
                DO JV=1,NBETA(IS)
                  CALL CURV1(NSPLPO,GGNH(1),
     *                 QRAD(1,IV,JV,L,IS),0.0D0,0.0D0,3,
     *                 QRAD(NSPLPO+1,IV,JV,L,IS),FINT,0.0D0,IERR)
                ENDDO
              ENDDO
            ENDDO
C$OMP parallel do private(IV,JV)
            DO IV=1,NBETA(IS)
              DO JV=1,NBETA(IS)
                QRD0(IV,JV)=CURV2(0.0D0,NSPLPO,GGNH(1),
     *                            QRAD(1,IV,JV,1,IS),
     *                            QRAD(NSPLPO+1,IV,JV,1,IS),0.0D0)
              ENDDO
            ENDDO
          ELSE
            CALL DCOPY(NSPLPO,GGNH(1),1,QSP1(1),1)
            DO L=1,LQX
              DO IV=1,NBETA(IS)
                DO JV=IV,NBETA(IS)
                  CALL AZZERO(QSP2,NSPLPO)
                  DO IL=NSPLPA,NSPLPE
                    GGL=GGNH(IL)
                    XG=DSQRT(GGL)*TPIBA
                    CALL BESS(XG,L,MMAX,R(1,IS),JL)
                    IF(TPSEU(IS)) THEN
C$OMP parallel do private(IR)
                      DO IR=1,MMAX
                        FINT(IR)=QRL(IR,IV,JV,L,IS)*JL(IR)
                      ENDDO
                    ELSE
C$OMP parallel do private(IR)
                      DO IR=1,MMAX
                        FINT(IR)=QFUNC(IR,IV,JV,IS)*JL(IR)
                      ENDDO
                    ENDIF
                    IF(TLOG(IS)) THEN
                      CALL RADLG(MMAX,FINT,RAB(1,IS),FQRAD)
                    ELSE
                      CALL RADIN(MMAX,CMESH(IS),FINT,FQRAD)
                    ENDIF
                    QSP2(IL)=FPI*FQRAD
                  ENDDO
                  CALL GLOSUM(NSPLPO,QSP2)
                  CALL CURV1(NSPLPO,QSP1(1),QSP2(1),0.0d0,0.0d0,3,
     *                       QSP3(1),FINT,0.0d0,IERR)
C$OMP parallel do private(IL,GGL,XG)
                  DO IL=1,NHGL
                    GGL=GL(IL)
                    XG=CURV2(GGL,NSPLPO,QSP1(1),QSP2(1),QSP3(1),0.0d0)
                    QRAD(IL,IV,JV,L,IS)=XG
                    QRAD(IL,JV,IV,L,IS)=XG
                  ENDDO
                  IF(L.EQ.1) THEN
                    QRD0(IV,JV)=
     *               CURV2(0.D0,NSPLPO,QSP1(1),QSP2(1),QSP3(1),0.d0)
                    QRD0(JV,IV)=QRD0(IV,JV)
                  ENDIF
                ENDDO
              ENDDO
            ENDDO
          ENDIF
C         ==----------------------------------------------------------==
C         ==  CALCULATION OF ARRAY QQ    ! ONLY for VAN pseudo        ==
C         ==  no factor omega, cause qrad is no longer scaled by omega==
C         ==----------------------------------------------------------==
          NNGH=NVALES(IS)*NVALES(IS)*NELEV(IS)
C$OMP parallel do private(IV,JV,QG0)
          DO IV=1,NNGH
            DO JV=1,NNGH
              CALL QVAN1(IV,JV,IS,QRD0,QG0)
              QQ(IV,JV,IS)=QG0
            ENDDO
          ENDDO
        ENDIF
      ENDDO
C     ==--------------------------------------------------------------==
      CALL FREEM(IP_QRD0)
      CALL FREEM(IP_QSP3)
      CALL FREEM(IP_QSP2)
      CALL FREEM(IP_QSP1)
      CALL TIHALT('     QINIT',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
