#ifdef __SR8000
*option MP(P(0)), LANGLVL(SAVE(0))
#endif
C     ==================================================================
      SUBROUTINE VDWIN
C     ==--------------------------------------------------------------==
C     ==  THIS ROUTINE READS THE SECTION &VDW &END ON UNIT IUNIT      ==
C     ==--------------------------------------------------------------==
C     ==  THE INPUT HAS TO BE IN THE FOLLOWING FORMAT                 ==
C     ==     &VDW                                                     ==
C     ==        Options                                               ==
C     ==     &END                                                     ==
C     ==--------------------------------------------------------------==
C     ==  LIST OF OPTIONS                                             ==
C     ==                                                              ==
C     ==    VDW PARAMETERS                                            ==
C     ==      {nvdw}                                                  ==
C     ==      vdwtyp ivdw jvdw vdwst vdwrm vdwbe                      == 
C     ==      {ALL GRIMME}                                            ==
C     ==      vdwtyp ivdw jvdw vdwst vdwrm vdwbe s6grim               == 
C     ==      {C6,TANH} typ ivdw jvdw vdwst vdwrm vdwbe               == 
C     ==      {GRIMME} typ ivdw jvdw vdwst vdwrm vdwbe s6grim         == 
C     ==      GRIMME ivdw jvdw                                        == 
C     ==    VDW-CUTOFF                                                ==
C     ==      vdweps                                                  ==
C     ==    VDW-CELL                                                  ==
C     ==      nxvdw nyvdw nzvdw                                       ==
C     ==                                                              ==
C     ==  Present release:                                            == 
C     ==             Strasbourg/Tokyo/Zurich/Lausanne, 11 May 2010    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'vdwc.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cnst.inc'
C     LOCAL VARIABLES
      INTEGER      IUNIT,IERR,I,I1,IOUT,MSGLEN
      CHARACTER    LINE*80
      LOGICAL      ERREAD
      INTEGER      INSCAN
      CHARACTER    VDWTYP(3)*6
      DATA         VDWTYP/'C6    ','TANH  ','GRIMME'/
C   VDW GRIMME
      LOGICAL      TGRIM,TELST
      INTEGER      J,K
      REAL*8       VDWC6(99),VDWR0(99)
      REAL*8       SET_S6
C   VDWC6 and VDWR0 according to Grimme
C   VDWC6 and VDWR0 not in au!
      DATA         VDWC6/0.14D0, 0.08D0, 1.61D0, 1.61D0,
     *             3.31D0, 1.75D0, 1.23D0, 0.70D0,
     *             0.75D0, 0.63D0, 5.71D0, 5.71D0, 10.79D0,
     *             9.23D0, 7.84D0, 5.57D0, 5.07D0,
     *             4.61D0, 10.80D0, 10.80D0, 10.80D0,
     *             10.80D0, 10.80D0, 10.80D0, 10.80D0,
     *             10.80D0, 10.80D0, 10.80D0, 10.80D0,
     *             10.80D0, 16.99D0, 17.10D0, 16.37D0,
     *             12.64D0, 12.47D0, 12.01D0, 24.67D0,
     *             24.67D0, 24.67D0, 24.67D0, 24.67D0,
     *             24.67D0, 24.67D0, 24.67D0, 24.67D0,
     *             24.67D0, 24.67D0, 24.67D0, 37.32D0,
     *             38.71D0, 38.44D0, 31.74D0, 31.50D0, 29.99D0, 45*0.D0/
      DATA         VDWR0/1.001D0, 1.012D0, 0.825D0, 1.408D0,
     *             1.485D0, 1.452D0, 1.397D0,
     *             1.342D0, 1.287D0, 1.243D0, 1.144D0,
     *             1.364D0, 1.639D0, 1.716D0, 1.705D0,
     *             1.683D0, 1.639D0, 1.595D0, 1.485D0,
     *             1.474D0, 1.562D0, 1.562D0, 1.562D0,
     *             1.562D0, 1.562D0, 1.562D0, 1.562D0,
     *             1.562D0, 1.562D0, 1.562D0,
     *             1.650D0, 1.727D0, 1.760D0, 1.771D0,
     *             1.749D0, 1.727D0, 1.628D0, 1.606D0,
     *             1.639D0, 1.639D0, 1.639D0, 1.639D0,
     *             1.639D0, 1.639D0, 1.639D0, 1.639D0,
     *             1.639D0, 1.639D0, 1.672D0, 1.804D0,
     *             1.881D0, 1.892D0, 1.892D0, 1.881D0, 45*1.0D10/
C     ==--------------------------------------------------------------==
C     ==  DEFAULTS                                                    ==
C     ==--------------------------------------------------------------==
      IF(.NOT.VDWC) RETURN
      IF(.NOT.PARENT) THEN
        GOTO 9999
      ENDIF
      IUNIT = 5
      TGRIM=.FALSE.
      TELST=.FALSE.
      NVDW=0
      VDWEPS=1.0D-2
      S6GRIM=0.D0    ! no default for s6 in Grimme's vdW
      NXVDW=0 
      NYVDW=0 
      NZVDW=0
C     ==--------------------------------------------------------------==
      IERR=INSCAN(IUNIT,'&VDW')
      IF(IERR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
      NCORX = (NSX*(NSX+1))/2
      CALL MEMORY(IP_IDVDW,NCORX,'IDVDW') 
      CALL MEMORY(IP_IVDW,NCORX,'IVDW')
      CALL MEMORY(IP_JVDW,NCORX,'JVDW')
      CALL MEMORY(IP_VDWST,NCORX,'VDWST') 
      CALL MEMORY(IP_VDWRM,NCORX,'VDWRM') 
      CALL MEMORY(IP_VDWBE,NCORX,'VDWBE') 
C     ==--------------------------------------------------------------==
   10 CONTINUE
        READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
        IF(INDEX(LINE,'&END').NE.0) GOTO 100
        IF(INDEX(LINE,'VDW').NE.0.AND.((INDEX(LINE,'PARA').NE.0)
     &      .OR.(INDEX(LINE,'CORR').NE.0))) THEN
C  Empirical van der Waals correction
          READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
C  Use hard-coded parameters for all
          IF(INDEX(LINE,'ALL').NE.0) THEN
            IF(INDEX(LINE,'GRIM').NE.0) THEN
              TGRIM=.TRUE.
              NVDW=NSP*(NSP+1)/2
C  Simulate full input for all types.
              K=0
              DO I=1,NSP
C     Reality Check. Parametrization exists only for "H" up to "XE"
                IF((IATYP(I).GT.54).AND.(IATYP(I).LE.99)) THEN
                   WRITE(6,'(A)')
     &      " WARNING : GRIMME VDW ONLY SUPPORTS ELEMENTS H TO XE",
     &      "           ELEMENTS BEYOND XE GIVE A ZERO CONTRIBUTION !!"
                ELSE IF(IATYP(I).GT.99) THEN
                   CALL STOPGM('VDWIN',
     &           'GRIMME VDW ONLY SUPPORTS ELEMENTS UP TO A.N. 99 !!')
                ENDIF
                DO J=I,NSP
                  K=K+1
                  IVDW(K)=I
                  JVDW(K)=J
                ENDDO
              ENDDO
              DO I=1,NVDW
                VDWST(I)=DSQRT(VDWC6(IATYP(IVDW(I)))
     &              *VDWC6(IATYP(JVDW(I))))*1.733979D1
                VDWRM(I)=(VDWR0(IATYP(IVDW(I)))
     &              +VDWR0(IATYP(JVDW(I))))*FBOHR
                VDWBE(I)=20.0D0
                IDVDW(I)=3
              ENDDO
            ELSE
              CALL STOPGM('VDWIN',
     &            '"ALL" OPTION ONLY AVAILABLE FOR TYPE "GRIMME"')
            ENDIF
          ELSE
C read individual pairs
            I1=1
            CALL READSI(LINE,I1,IOUT,NVDW,ERREAD)
            DO I=1,NVDW 
              READ(IUNIT,ERR=99,END=99,FMT='(A80)') LINE
              IF(INDEX(LINE,'C6').NE.0) THEN
                TELST=.TRUE.
                IDVDW(I)=1 
                I1=INDEX(LINE,'C6')+2
              ELSE IF(INDEX(LINE,'TANH').NE.0) THEN 
                TELST=.TRUE.
                IDVDW(I)=2 
                I1=INDEX(LINE,'TANH')+4 
              ELSE IF(INDEX(LINE,'GRIMME').NE.0) THEN 
                TGRIM=.TRUE.
                IDVDW(I)=3
                I1=INDEX(LINE,'GRIMME')+6
              ELSE 
                WRITE(6,*) ' ERROR WHILE READING VDW CORRECTIONS ' 
                CALL STOPGM('VDWIN','UNKNOWN VDW TYPE') 
              ENDIF 
              CALL READSI(LINE,I1,IOUT,IVDW(I),ERREAD)
              I1=IOUT
              CALL READSI(LINE,I1,IOUT,JVDW(I),ERREAD)
              I1=IOUT
C grimme parameters are hardcoded, but we allow overrides.
              IF(IDVDW(I).EQ.3) THEN
                CALL READSR(LINE,I1,IOUT,VDWST(I),ERREAD)
                IF(ERREAD) THEN ! ok use defaults
                  IF(MAX(IATYP(IVDW(I)),IATYP(JVDW(I))).GT.54) THEN
                    CALL STOPGM('VDWIN',
     $                  'GRIMME VDW ONLY SUPPORTS ELEMENTS "H" TO "XE"')
                  ENDIF
                  VDWST(I)=DSQRT(VDWC6(IATYP(IVDW(I)))
     &                *VDWC6(IATYP(JVDW(I))))*1.733979D1 ! bug-fix
                  VDWRM(I)=(VDWR0(IATYP(IVDW(I)))
     &                +VDWR0(IATYP(JVDW(I))))*FBOHR      ! bug-fix
                  VDWBE(I)=20.0D0
                ELSE
                  I1=IOUT 
                  CALL READSR(LINE,I1,IOUT,VDWRM(I),ERREAD) 
                  I1=IOUT
                  CALL READSR(LINE,I1,IOUT,VDWBE(I),ERREAD)
                ENDIF
              ELSE
                CALL READSR(LINE,I1,IOUT,VDWST(I),ERREAD)
                I1=IOUT 
                CALL READSR(LINE,I1,IOUT,VDWRM(I),ERREAD) 
                I1=IOUT
                CALL READSR(LINE,I1,IOUT,VDWBE(I),ERREAD)
              ENDIF
            ENDDO 
          ENDIF
          GOTO 10
        ELSE IF(INDEX(LINE,'VDW-CUTOFF').NE.0) THEN 
          READ(IUNIT,ERR=99,END=99,FMT=*) VDWEPS
          GOTO 10 
        ELSE IF(INDEX(LINE,'VDW-CELL').NE.0) THEN 
          READ(IUNIT,ERR=99,END=99,FMT=*) NXVDW,NYVDW,NZVDW 
          GOTO 10 
cmb-s6 >>> s6 as input
        ELSE IF(INDEX(LINE,'S6GRIM').NE.0) THEN 
          READ(IUNIT,ERR=99,END=99,FMT=*) S6_STR
          S6GRIM=SET_S6(S6_STR)
CSI: S6_STR should not in general contradict with the functional used for DFT,
CSI: but one should be able to do so
          IF(DFT_FUNC.ne.S6_STR.AND.DFT_FUNC.ne." ") THEN 
            WRITE(6,*)'!!! WARNING !!! Grimme correction uses', S6_STR
            WRITE(6,*)'!!! WARNING !!! whereas ', DFT_FUNC, 'is used'
          ENDIF
          GOTO 10 
cmb-s6 <<< s6 as input
        ELSE 
C..Dummy line
          GOTO 10
        ENDIF
C     ==--------------------------------------------------------------==
   99 CONTINUE
      WRITE(6,*) ' VDWIN  : ERROR IN READING INPUT FILE'
      CALL STOPGM('VDWIN',' ')
C     ==--------------------------------------------------------------==
  100 CONTINUE
C     ==--------------------------------------------------------------==
C     ==  WRITE INFO TO OUTPUT                                        ==
C     ==--------------------------------------------------------------==
      IF(VDWC) THEN 
        WRITE(6,*)
        WRITE(6,'(A)')
     *      ' EMPIRICAL VAN DER WAALS CORRECTION AFTER:'
        IF (TELST) THEN
          WRITE(6,'(A)')
     *        '    R. LE SAR, J. PHYS. CHEM. 88, 4272 (1984)'
          WRITE(6,'(A)')
     *        '    M. ELSTNER et al., J. CHEM. PHYS. 114, 5149 (2001)'
        ENDIF
        IF (TGRIM) THEN
          WRITE(6,'(A)')
     *      '    S. GRIMME, J. COMP. CHEM. 27, 1787 (2006)'
cmb-s6 >>> s6 as input
CSI: If 0 then try to set it according to the functional in DFT section
          IF ( S6GRIM .eq. 0.D0 ) THEN
            S6GRIM=SET_S6(DFT_FUNC)
            S6_STR=DFT_FUNC
          END IF
          IF ( S6GRIM .eq. 0.D0 ) THEN
            CALL STOPGM('VDWIN',
     &           'ONE MUST PROVIDE A FUNCTIONAL FOR GRIMME VDW')
          ELSE
            WRITE(6,'(A,1F5.2,A,A,A)')'   S6=', S6GRIM, '      :      ',
     &                                S6_STR, ' FUNCTIONAL'  
          END IF
cmb-s6 <<< s6 as input
        ENDIF
        DO I=1,NVDW
          WRITE(6,'(A,A2,A,A2,A,6X,A6,A)')
     *        '    PARAMETERS FOR PAIRS OF TYPE ',EL(IATYP(IVDW(I))),
     *        ' AND TYPE ',EL(IATYP(JVDW(I))),': ',
     *        VDWTYP(IDVDW(I)),' MODEL'
          WRITE(6,'(2(6X,A,T47,F14.7,A/),6X,A,T47,F14.7,A)')
     *        ' VDW STRENGTH (ST): ',VDWST(I),' A.U.',
     *        ' DECAY FACTOR (RM): ',VDWRM(I),' A.U.',
     *        ' DECAY FACTOR (BETA): ',VDWBE(I),' A.U.'
          IF(IDVDW(I).EQ.1) THEN
            WRITE(6,'(6X,A,T47,F14.7,A)')
     *          ' CUTOFF (EPS): ',VDWEPS ,' A.U.'
          ELSE IF(IDVDW(I).EQ.2) THEN
            WRITE(6,'(6X,A,T47,F14.7,A)')
     *          ' CUTOFF (EPS**-1): ',1.0D0/VDWEPS,' A.U.'
          ENDIF
        ENDDO
        WRITE(6,'(A,A,I2,A,I2,A,I2,A)') '    VAN DER WAALS SUM',
     *      ' IN REAL SPACE OVER ',NXVDW+1,'*',NYVDW+1,'*',NZVDW+1,
     *      ' CELLS'
        WRITE(6,*)
      ENDIF 
C     ==--------------------------------------------------------------==
 9999 CONTINUE
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(TGRIM,MSGLEN,SOURCE,ALLGRP)
      CALL MY_BCAST(TELST,MSGLEN,SOURCE,ALLGRP)
      IF(.NOT.(TGRIM.OR.TELST))
     &    CALL STOPGM('VDWIN','CANNOT FIND VDW CORRECTION PARAMETERS')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      FUNCTION SET_S6(STR) 
C     ==================================================================
C       This function returns proper S6 value w.r.t. the functional
C     ==================================================================
      IMPLICIT NONE
      REAL*8 SET_S6
      CHARACTER*8 STR

      IF(STR.eq." ") THEN 
        SET_S6=0.0d0
        RETURN
      ENDIF

      IF (STR.eq."BLYP" ) THEN
        SET_S6 = 1.20d0
      ELSE IF (STR.eq."B3LYP") THEN
        SET_S6 = 1.05d0
      ELSE IF (STR.eq."BP86") THEN
        SET_S6 = 1.05d0
      ELSE IF (STR.eq."TPSS") THEN
        SET_S6 = 1.00d0
      ELSE IF (STR.eq."PBE") THEN
        SET_S6 = 0.75d0
      ELSE
        SET_S6=0.d0
        WRITE(6,*) ' SELECTED VDW FUNCTIONAL = ', STR
        CALL STOPGM('VDWIN',
     &              'GRIMME VDW DOES NOT SUPPORT THIS FUNCTIONAL')
      END IF

      RETURN
      END
C     ==================================================================
