C     ==================================================================
      SUBROUTINE VELOCITINP(IUNIT)
C     ==--------------------------------------------------------------==
C     ==  READS VELOCITIES INPUT FOR INITIAL STEP (Section &ATOMS)    ==
C     ==--------------------------------------------------------------==
C     ==                                                              ==
C     ==  VELOCITIES                                                  ==
C     ==    nvel                                                      ==
C     ==      ia is       vx vy vz                                    ==
C     ==      ....                                                    ==
C     ==  END VELOCITIES                                              ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'coor.inc'
      CHARACTER LINE*800
      INTEGER IUNIT
      DIMENSION LVELINI(0:NAX,NSX)
C     Local variables
      INTEGER LVEL(NAX*NSX)
      POINTER (IP_LVEL,LVEL)
      INTEGER ININ,IOUT,NVEL,I,J,IA,IS
      LOGICAL ERREAD
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_LVEL,NAX*NSX,'LVEL')
 10   CONTINUE
      READ(IUNIT,ERR=20,END=20,FMT='(A)') LINE
      IF(INDEX(LINE,'END').NE.0 .AND. INDEX(LINE,'VELOC').NE.0)
     &     GOTO 30
      CALL READSI(LINE,1,IOUT,NVEL,ERREAD)
      IF(ERREAD) GOTO 20
      ININ=IOUT
      DO I=1,NVEL
        CALL READSI(LINE,ININ,IOUT,LVEL(I),ERREAD)
        IF(ERREAD) GOTO 20
        ININ=IOUT
      ENDDO
      DO I=1,NVEL
        CALL IGIVENUMBERS(LVEL(I),IA,IS)
        IF(IS.EQ.0)
     &       CALL STOPGM('VELOCITINP', 'BAD NUMBER OF ATOM')
        READ(IUNIT,ERR=20,END=20,FMT=*) (VELP(J,IA,IS),J=1,3)
        LVELINI(0,IS)=.TRUE.
        LVELINI(IA,IS)=.TRUE.
      ENDDO
      GOTO 10
 30   CONTINUE
      CALL FREEM(IP_LVEL)
C     ==--------------------------------------------------------------==
      RETURN
   20 CONTINUE
      WRITE(6,*) ' VELOCITINP: ERROR WHILE READING ON UNIT ',IUNIT
      CALL STOPGM('VELOCITINP',' ')
      END
C     ==================================================================
      SUBROUTINE IGIVENUMBERS(NUMBER,IA,IS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INTEGER NUMBER,IA,IS, NUM
C     ==--------------------------------------------------------------==
      NUM=NUMBER
      IF(NUM.LE.0) THEN
        IS=0
        RETURN
      ENDIF
      DO IS=1,NSX
        IF(NUM.LE.NA(IS)) THEN
          IA=NUM
          RETURN
        ELSE
          NUM=NUM-NA(IS)
        ENDIF
      ENDDO
      IS=0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
