C     ==================================================================
      SUBROUTINE VELUPA(C0,CM,C2,NSTATE,NNLST)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'harm.inc'
      INCLUDE 'cppt.inc'
C     Arguments
      INTEGER    NSTATE,NNLST
      COMPLEX*16 C0(NGWK,*),CM(NGWK,*),C2(NGWK,*)
C     Variables
      REAL*8     HFO,HGI,DTX
      INTEGER    ISUB,I,IG
C     ==--------------------------------------------------------------==
      CALL TISET('    VELUPA',ISUB)
C     WAVEFUNCTION VELOCITY UPDATE
      IF(THARM) THEN
!$OMP parallel do private(I,IG,HFO,HGI)
        DO I=1,NSTATE
          DO IG=1,NGW
            IF(TMASS) THEN
              HFO=-XMU(IG)*FREQ(IG)**2
            ELSE
              HFO=-EMASS*FREQ(IG)**2
            ENDIF
            IF(NNLST.EQ.1) THEN
              HGI=DTAN2W(IG)
              CM(IG,I)=CM(IG,I)+HGI*(C2(IG,I)-HFO*C0(IG,I))
            ELSE
              HGI=DTAN2C(IG)
              CM(IG,I)=CM(IG,I)+HGI*C2(IG,I)
            ENDIF
          ENDDO
        ENDDO
      ELSE
        IF(TMASS) THEN
!$OMP parallel do private(I,IG,HGI)
          DO I=1,NSTATE
            DO IG=1,NGW
              HGI=DBLE(NNLST)*0.5D0*DT_ELEC/XMU(IG)
              CM(IG,I)=CM(IG,I)+HGI*C2(IG,I)
            ENDDO
          ENDDO
        ELSE
          DTX=DBLE(NNLST)*DTB2ME
          CALL DAXPY(2*NSTATE*NGWK,DTX,C2(1,1),1,CM(1,1),1)
        ENDIF
      ENDIF
      CALL TIHALT('    VELUPA',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
