C     ==================================================================
      SUBROUTINE VELUPI(VELP,FION,NNLST)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
C     Arguments
      INTEGER NNLST
      REAL*8  VELP(3,NAX,*),FION(3,NAX,*)
C     Variables
      REAL*8  FACT
      INTEGER I,IS,IA
C     ==--------------------------------------------------------------==
#if defined(__VECTOR)
!$OMP parallel do private(I,IS,IA,FACT)
#else
!$OMP parallel do private(I,IS,IA,FACT) schedule(static)
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
      DO I=1,NAT
        IA=IATPT(1,I)
        IS=IATPT(2,I)
        FACT=DBLE(NNLST)*DTB2MI(IS)
        VELP(1,IA,IS)=VELP(1,IA,IS)+FACT*FION(1,IA,IS)
        VELP(2,IA,IS)=VELP(2,IA,IS)+FACT*FION(2,IA,IS)
        VELP(3,IA,IS)=VELP(3,IA,IS)+FACT*FION(3,IA,IS)
      ENDDO
      CALL TAUCL(VELP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VELUPIDAMP(VELP,NNLST)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'metr.inc'
C     Arguments
      INTEGER NNLST
      REAL*8  VELP(3,NAX,*)
C     Variables
      REAL*8  KIN,IKIN,ALPHA,SCALE,GAMMA
      INTEGER I,IS,IA
      KIN = 0.D0
#if defined(__VECTOR)
!$OMP parallel do private(I,IS,IA,SCALE)
!$OMP+ reduction(+:KIN)
#else
!$OMP parallel do private(I,IS,IA,SCALE) schedule(static)
!$OMP+ reduction(+:KIN)
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
      DO I=1,NAT
        IA=IATPT(1,I)
        IS=IATPT(2,I)
        SCALE=PMA(IS)
        KIN = KIN + SCALE*VELP(1,IA,IS)*VELP(1,IA,IS)
        KIN = KIN + SCALE*VELP(2,IA,IS)*VELP(2,IA,IS)
        KIN = KIN + SCALE*VELP(3,IA,IS)*VELP(3,IA,IS)
      ENDDO  
C CJM DBG HARDWIRED UNTIL PUT IN INPUT
      GAMMA = .05D0 * AU_FS
C CJM DBG HARDWIRED UNTIL PUT IN INPUT
      IKIN = 1.D0/KIN
      ALPHA = 2.D0*CMASS*VEPS*VEPS*GAMMA*IKIN
      SCALE = DSQRT ( 1.D0 + ALPHA * 0.5D0 * DT_IONS )
#if defined(__VECTOR)
!$OMP parallel do private(I,IS,IA)
#else
!$OMP parallel do private(I,IS,IA) schedule(static)
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
      DO I=1,NAT
        IA=IATPT(1,I)
        IS=IATPT(2,I)
        VELP(1,IA,IS)=VELP(1,IA,IS)*SCALE
        VELP(2,IA,IS)=VELP(2,IA,IS)*SCALE
        VELP(3,IA,IS)=VELP(3,IA,IS)*SCALE
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VELUPISHOCK(VELP,FION,NNLST)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'metr.inc'
C     Arguments
      INTEGER NNLST
      REAL*8  VELP(3,NAX,*),FION(3,NAX,*)
C     Variables
      REAL*8  FACT,AT3
      INTEGER IA,IS
      REAL*8  arg_v, poly_v, scale_v
      REAL*8  arg_vx, poly_vx, scale_vx, aax, aa
      REAL*8  e2, e4, e6, e8 
      PARAMETER (e2 = 1.D0/6.D0, e4 = e2/20.D0, 
     * e6 = e4/42.D0, e8 = e6/72.D0)
C     ==--------------------------------------------------------------==
      AT3 = 3.D0*DBLE(NAT)
      aax = VEPS * (1.0D0+1.0D0/AT3)
      arg_vx = ( 0.25D0 * DT_IONS * aax ) * ( 0.25D0 * DT_IONS * aax )
      poly_vx = 1.D0+e2*arg_vx+e4*arg_vx*arg_vx+e6*arg_vx**3+
     *          e8*arg_vx**4

      aa = VEPS * 1.0D0/AT3
      arg_v = ( 0.25D0 * DT_IONS * aa ) * ( 0.25D0 * DT_IONS * aa )
      poly_v = 1.D0+e2*arg_v+e4*arg_v*arg_v+e6*arg_v**3+
     *          e8*arg_v**4
!      AT3 = 3.D0*DBLE(NAT)
!      aax = VEPS * (1.0D0+1.0D0/AT3)
!      arg_vx = ( 0.25D0 * DT_IONS * aax ) * ( 0.25D0 * DT_IONS * aax )
!      poly_vx = 1.D0+e2*arg_vx+e4*arg_vx*arg_vx+e6*arg_vx**3+
!     *         e8*arg_vx**4
!      AT3 = 3.D0*DBLE(NAT)
!      aax = HTVEL ( 1, 1 ) * (1.0D0+1.0D0/AT3)
!      arg_vx = ( 0.25D0 * DT_IONS * aax ) * ( 0.25D0 * DT_IONS * aax )
!      poly_vx = 1.D0+e2*arg_vx+e4*arg_vx*arg_vx+e6*arg_vx**3+
!     *          e8*arg_vx**4
!
!      aa = HTVEL ( 1, 1 ) * 1.0D0/AT3
!      arg_v = ( 0.25D0 * DT_IONS * aa ) * ( 0.25D0 * DT_IONS * aa )
!      poly_v = 1.D0+e2*arg_v+e4*arg_v*arg_v+e6*arg_v**3+
!     *          e8*arg_v**4

      scale_vx = DEXP( -0.25D0 * DT_IONS * aax )
      scale_v = DEXP( -0.25D0 * DT_IONS * aa )

!$OMP parallel do private(IS,IA,FACT)
#ifdef _vpp_
!OCL NOALIAS
#endif
      DO IS=1,NSP
        FACT=DBLE(NNLST)*DTB2MI(IS)
        DO IA=1,NA(IS)
           VELP(1,IA,IS)=scale_vx*scale_vx*VELP(1,IA,IS)+
     *                   scale_vx*poly_vx*FACT*FION(1,IA,IS)
           VELP(2,IA,IS)=scale_v*scale_v*VELP(2,IA,IS)+
     *                   scale_v*poly_v*FACT*FION(2,IA,IS)
           VELP(3,IA,IS)=scale_v*scale_v*VELP(3,IA,IS)+
     *                   scale_v*poly_v*FACT*FION(3,IA,IS)
        ENDDO
      ENDDO
!      DTH = 0.25D0*DT_IONS
!for y and z (doesn't couple to shocks)
!      S1 = EXP(-0.5D0*DT_IONS*HTVEL ( 1, 1 )*1.0D0/AT3)
!      ARG = DTH*HTVEL ( 1, 1 )*1.0D0/AT3
!      SE = EXP(-ARG)
!      S2 = SE*SINHXBX(ARG)
!!for x-direction (couples to shock)
!      S1X = EXP(-0.5D0*DT_IONS*HTVEL ( 1, 1 )*(1.0D0+1.0D0/AT3))
!      ARGX = DTH*HTVEL ( 1, 1 )*(1.0D0+1.0D0/AT3)
!      SEX = EXP(-ARGX)
!      S2X = SEX*SINHXBX(ARG)
!      DO IS=1,NSP
!        FACT=DBLE(NNLST)*DTB2MI(IS)
!        DO IA=1,NA(IS)
!           VELP(1,IA,IS)=S1X*VELP(1,IA,IS)+S2X*FACT*FION(1,IA,IS)
!           VELP(2,IA,IS)=S1*VELP(2,IA,IS)+S2*FACT*FION(2,IA,IS)
!           VELP(3,IA,IS)=S1*VELP(3,IA,IS)+S2*FACT*FION(3,IA,IS)
!        ENDDO
!      ENDDO
      CALL TAUCL(VELP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VELUPC1(SVELP,SFION,VELP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'prcp.inc'
C     Arguments
      REAL*8  SVELP(3,NAX,*),SFION(3,NAX,*),VELP(3,NAX,*)
C     Variables
      REAL*8  HFORCE(3,3),HSCR(3,3),GMAT(3,3),GDOT(3,3),
     &        FSD(3),AUX(1000),
     &        FACT,FOMEGA,FO,
     &        DDOT,DTB
C     Externals
      EXTERNAL DDOT
      INTEGER IS,IA,K,L,INFO
C     ==--------------------------------------------------------------==
      CALL DGEMM('N','T',3,3,3,1.D0,HTVEL(1,1),3,HT(1,1)   ,3,0.D0,
     &           GDOT(1,1),3)
      CALL DGEMM('N','T',3,3,3,1.D0,HT(1,1)   ,3,HTVEL(1,1),3,1.D0,
     &           GDOT(1,1),3)
      CALL DGEMM('N','T',3,3,3,1.D0,HT(1,1)   ,3,HT(1,1)   ,3,0.D0,
     &           GMAT(1,1),3)
      CALL INVMAT(3,GMAT,AUX,INFO)
      CALL DGEMM('N','N',3,3,3,1.D0,GMAT(1,1) ,3,GDOT(1,1) ,3,0.D0,
     &           HSCR(1,1),3)
      CALL DCOPY(9,HSCR(1,1),1,GMAT(1,1),1)
      CALL DCOPY(9,HTFOR(1,1),1,HFORCE(1,1),1)
      CALL AZZERO(HSCR,9)
#if defined(__VECTOR)
!$OMP parallel do private(K,IS,IA,FACT)
!$OMP+ reduction(+:HSCR)
#else
!$OMP parallel do private(K,IS,IA,FACT) schedule(static)
!$OMP+ reduction(+:HSCR)
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
      DO K=1,NAT
        IS=IATPT(1,K)
        IA=IATPT(2,K)
        FACT=PMA(IS)
        HSCR(1,1)=HSCR(1,1)+FACT*VELP(1,IA,IS)*VELP(1,IA,IS)
        HSCR(2,1)=HSCR(2,1)+FACT*VELP(2,IA,IS)*VELP(1,IA,IS)
        HSCR(3,1)=HSCR(3,1)+FACT*VELP(3,IA,IS)*VELP(1,IA,IS)
        HSCR(1,2)=HSCR(1,2)+FACT*VELP(1,IA,IS)*VELP(2,IA,IS)
        HSCR(2,2)=HSCR(2,2)+FACT*VELP(2,IA,IS)*VELP(2,IA,IS)
        HSCR(3,2)=HSCR(3,2)+FACT*VELP(3,IA,IS)*VELP(2,IA,IS)
        HSCR(1,3)=HSCR(1,3)+FACT*VELP(1,IA,IS)*VELP(3,IA,IS)
        HSCR(2,3)=HSCR(2,3)+FACT*VELP(2,IA,IS)*VELP(3,IA,IS)
        HSCR(3,3)=HSCR(3,3)+FACT*VELP(3,IA,IS)*VELP(3,IA,IS)
      ENDDO
      CALL DGEMM('N','N',3,3,3,1.D0,HSCR(1,1),3,HTM1(1,1),3,1.D0,
     &           HFORCE(1,1),3)

      FACT=DT_IONS/(2.D0*CMASS)
      IF(TZFLEX) THEN
C       Z-scaling of cell only
        FOMEGA=HFORCE(1,3)*HUNIT(1,3)+HFORCE(2,3)*HUNIT(2,3)
     &      +HFORCE(3,3)*HUNIT(3,3)
        DO L=1,3
          HTVEL(L,3)=HTVEL(L,3)+FACT*FOMEGA*HUNIT(L,3)
        ENDDO
      ELSE IF(TISOT) THEN
C       Isotropic cell
        FOMEGA=DDOT(9,HFORCE,1,HUNIT,1)/3.0D0
        DO K=1,3
          DO L=1,3
            HTVEL(L,K)=HTVEL(L,K)+FACT*FOMEGA*HUNIT(L,K)
          ENDDO
        ENDDO
      ELSE
C       General
        DO K=1,3
          DO L=1,3
            HTVEL(L,K)=HTVEL(L,K)+FACT*HFORCE(L,K)
          ENDDO
        ENDDO
      ENDIF
      DTB=DT_IONS*0.5D0
      DO IS=1,NSP
        FACT=DTB2MI(IS)
        DO IA=1,NA(IS)
          CALL DGEMV('N',3,3,1.D0,GMAT(1,1),3,SVELP(1,IA,IS),1,0.D0,
     &               FSD(1),1)
          SVELP(1,IA,IS)=SVELP(1,IA,IS)+FACT*SFION(1,IA,IS)-FSD(1)*DTB
          SVELP(2,IA,IS)=SVELP(2,IA,IS)+FACT*SFION(2,IA,IS)-FSD(2)*DTB
          SVELP(3,IA,IS)=SVELP(3,IA,IS)+FACT*SFION(3,IA,IS)-FSD(3)*DTB
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VELUPC2(SVELP,SFION,VELP,TSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'prcp.inc'
C     Arguments
      REAL*8  SVELP(3,NAX,*),SFION(3,NAX,*),VELP(3,NAX,*),TSCR(3,NAX,*)
C     Variables
      INTEGER   MAXITS
      REAL*8    EPSS
      PARAMETER (MAXITS=100,EPSS=1.D-10)
      REAL*8    HCR(3,3),HC(3,3),AUX(500),
     &          HFORCE(3,3),HSCR(3,3),GMAT(3,3),GDOT(3,3),FSD(3),
     &          FACT,FOMEGA,FO,EI,
     &          DDOT,DASUM,DTB
      INTEGER   ILOOP,IS,IA,K,L,INFO
C     Externals
      EXTERNAL  DDOT,DASUM
C     ==--------------------------------------------------------------==
      CALL DCOPY(9,        HTVEL(1,1)  ,1,HC(1,1)    ,1)
      CALL DCOPY(9,        HTVEL(1,1)  ,1,HCR(1,1)   ,1)
      CALL DCOPY(3*NAX*NSX,SVELP(1,1,1),1,TSCR(1,1,1),1)
      DO ILOOP=1,MAXITS
        CALL S_TO_C(SVELP,VELP)
        CALL DGEMM('N','T',3,3,3,1.D0,HTVEL(1,1),3,HT(1,1)   ,3,0.D0,
     &             GDOT(1,1),3)
        CALL DGEMM('N','T',3,3,3,1.D0,HT(1,1)   ,3,HTVEL(1,1),3,1.D0,
     &             GDOT(1,1),3)
        CALL DGEMM('N','T',3,3,3,1.D0,HT(1,1)   ,3,HT(1,1)   ,3,0.D0,
     &             GMAT(1,1),3)
        CALL INVMAT(3,GMAT,AUX,INFO)
        CALL DGEMM('N','N',3,3,3,1.D0,GMAT(1,1) ,3,GDOT(1,1) ,3,0.D0,
     &             HSCR(1,1),3)
        CALL DCOPY(9,HSCR(1,1) ,1,GMAT(1,1)  ,1)
        CALL DCOPY(9,HTFOR(1,1),1,HFORCE(1,1),1)
        CALL DCOPY(9,HCR(1,1)  ,1,HTVEL(1,1) ,1)
        CALL AZZERO(HSCR,9)
#if defined(__VECTOR)
!$OMP parallel do private(K,IS,IA,FACT)
!$OMP+ reduction(+:HSCR)
#else
!$OMP parallel do private(K,IS,IA,FACT) schedule(static)
!$OMP+ reduction(+:HSCR)
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
        DO K=1,NAT
          IS=IATPT(1,K)
          IA=IATPT(2,K)
          FACT=PMA(IS)
          HSCR(1,1)=HSCR(1,1)+FACT*VELP(1,IA,IS)*VELP(1,IA,IS)
          HSCR(2,1)=HSCR(2,1)+FACT*VELP(2,IA,IS)*VELP(1,IA,IS)
          HSCR(3,1)=HSCR(3,1)+FACT*VELP(3,IA,IS)*VELP(1,IA,IS)
          HSCR(1,2)=HSCR(1,2)+FACT*VELP(1,IA,IS)*VELP(2,IA,IS)
          HSCR(2,2)=HSCR(2,2)+FACT*VELP(2,IA,IS)*VELP(2,IA,IS)
          HSCR(3,2)=HSCR(3,2)+FACT*VELP(3,IA,IS)*VELP(2,IA,IS)
          HSCR(1,3)=HSCR(1,3)+FACT*VELP(1,IA,IS)*VELP(3,IA,IS)
          HSCR(2,3)=HSCR(2,3)+FACT*VELP(2,IA,IS)*VELP(3,IA,IS)
          HSCR(3,3)=HSCR(3,3)+FACT*VELP(3,IA,IS)*VELP(3,IA,IS)
        ENDDO
        CALL DGEMM('N','N',3,3,3,1.D0,HSCR(1,1),3,HTM1(1,1),3,1.D0,
     &             HFORCE(1,1),3)

        FACT=DT_IONS/(2.D0*CMASS)
        IF(TZFLEX) THEN
C     Z-scaling of cell only
          FOMEGA=HFORCE(1,3)*HUNIT(1,3)+HFORCE(2,3)*HUNIT(2,3)
     &        +HFORCE(3,3)*HUNIT(3,3)
          DO L=1,3
            HTVEL(L,3)=HTVEL(L,3)+FACT*FOMEGA*HUNIT(L,3)
          ENDDO
        ELSE IF(TISOT) THEN
C     Isotropic cell
          FOMEGA=DDOT(9,HFORCE,1,HUNIT,1)/3.0D0
          DO K=1,3
            DO L=1,3
              HTVEL(L,K)=HTVEL(L,K)+FACT*FOMEGA*HUNIT(L,K)
            ENDDO
          ENDDO
        ELSE
          DO K=1,3
            DO L=1,3
              HTVEL(L,K)=HTVEL(L,K)+FACT*HFORCE(L,K)
            ENDDO
          ENDDO
        ENDIF
        DTB=0.5D0*DT_IONS
        DO IS=1,NSP
          FACT=DTB2MI(IS)
          DO IA=1,NA(IS)
            CALL DGEMV('N',3,3,1.D0,GMAT(1,1),3,SVELP(1,IA,IS),1,0.D0,
     &                 FSD(1),1)
            SVELP(1,IA,IS)=TSCR(1,IA,IS)+FACT*SFION(1,IA,IS)-FSD(1)*DTB
            SVELP(2,IA,IS)=TSCR(2,IA,IS)+FACT*SFION(2,IA,IS)-FSD(2)*DTB
            SVELP(3,IA,IS)=TSCR(3,IA,IS)+FACT*SFION(3,IA,IS)-FSD(3)*DTB
          ENDDO
        ENDDO
        CALL DAXPY(9,-1.D0,HTVEL(1,1),1,HC(1,1),1)
        EI=DASUM(9,HC(1,1),1)
        IF(EI.LT.EPSS) GOTO 100
        CALL DCOPY(9,HTVEL(1,1),1,HC(1,1),1)
      ENDDO
      WRITE(6,*) ' VELUPC2| ITERATION DID NOT CONVERGE '
      WRITE(6,*) ' VELUPC2| NUMBER OF STEPS            ',MAXITS
      WRITE(6,*) ' VELUPC2| LAST CHANGE IN HTVEL WAS   ',EI
      WRITE(6,*) ' VELUPC2| CONVERGENCE CRITERIA IS    ',EPSS
  100 CONTINUE
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE S_VELUPI(VELP,FION,NNLST,IP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'pimd.inc'
C     Arguments
      INTEGER NNLST,IP
      REAL*8  VELP(3,NAX,*),FION(3,NAX,*)
C     Variables
      INTEGER I,IS,IA
      REAL*8  FACT
C     ==--------------------------------------------------------------==
#if defined(__VECTOR)
!$OMP parallel do private(I,IS,IA,FACT)
#else
!$OMP parallel do private(I,IS,IA,FACT) schedule(static)
#endif
#ifdef _vpp_
!OCL NOALIAS
#endif
      DO I=1,NAT
        IA=IATPT(1,I)
        IS=IATPT(2,I)
        FACT=DBLE(NNLST)*DTB2MI(IS)*PMA(IS)/PMA0S(IS,IP)
        VELP(1,IA,IS)=VELP(1,IA,IS)+FACT*FION(1,IA,IS)
        VELP(2,IA,IS)=VELP(2,IA,IS)+FACT*FION(2,IA,IS)
        VELP(3,IA,IS)=VELP(3,IA,IS)+FACT*FION(3,IA,IS)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE VELUPIF(VELP,FION,NNLST)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'ions.inc'
C     Arguments
      INTEGER NNLST
      REAL*8  VELP(3,NAX,*),FION(3,NAX,*)
C     ==--------------------------------------------------------------==
      CALL TAUCL(VELP)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VELUPC(NNLST)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tpar.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'metr.inc'
C     Arguments
      INTEGER NNLST
C     Local Variables
      INTEGER I,J
      REAL*8 FACT,FOMEGA
C     External function
      REAL*8 DDOT
      EXTERNAL DDOT
C     ==--------------------------------------------------------------==
      FACT=DBLE(NNLST)*DT_IONS/(2.D0*CMASS)
      IF(TZFLEX) THEN
C     Z-scaling of cell only
        FOMEGA=HTFOR(1,3)*HUNIT(1,3)+HTFOR(2,3)*HUNIT(2,3)
     &      +HTFOR(3,3)*HUNIT(3,3)
        DO I=1,3
          HTVEL(I,3)=HTVEL(I,3)+FACT*FOMEGA*HUNIT(I,3)
        ENDDO
        VEPS = HTVEL(3,3)
      ELSE IF(TISOT) THEN
C     Isotropic cell
        FOMEGA=DDOT(9,HTFOR,1,HUNIT,1)/3.0D0
        DO I=1,3
          DO J=1,3
            HTVEL(J,I)=HTVEL(J,I)+FACT*FOMEGA*HUNIT(J,I)
          ENDDO
        ENDDO
        VEPS = (HTVEL(1,1)+HTVEL(2,2)+HTVEL(3,3))/3.D0
      ELSE
C     General
        DO I=1,3
          DO J=1,3
            HTVEL(J,I)=HTVEL(J,I)+FACT*HTFOR(J,I)
          ENDDO
        ENDDO
      ENDIF      
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
