C     ==================================================================
      SUBROUTINE VEPSUP(VELP)
C     ==--------------------------------------------------------------==
C     ==  PROPOGATES THE CELL VELOCITIES FOR NPH-SHOCK DYNAMCIS       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'nose.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'rmas.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'shock.inc'
C     Arguments
      REAL*8  VELP(3,NAX,*)
C     Variables
      REAL*8  HTFV(3,3), AT3,V,VI,V0,V0I,GEPS_V,GEPS_P
      INTEGER L,IS,IA,K
C     ==--------------------------------------------------------------==
      AT3 = 3.D0*DBLE(NAT)
C     ==--------------------------------------------------------------==
C     V  = INSTANTANEOUS VOLUME
C     VOL0 = INITIAL VOLUME DETERMINED 
C     VI = INVERSE INSTANTANEOUS VOLUME
C     V0I = INVERSE INITIAL VOLUME
      v = OMEGA
      vi = 1.D0/v
      v0 = VOL0
      v0i = 1.D0/v0
C     ==--------------------------------------------------------------==
C     ==  GET VELOCITY-DEPENDENT PART OF CELL FORCE                   ==
C     ==--------------------------------------------------------------==
!        GEPS_P = HTFP(1,1)+HTFP(2,2)+HTFP(3,3)
!        GEPS_V=0.D0
!        DO IS=1,NSP
!         DO IA=1,NA(IS)
!          DO K=1,3
!            GEPS_V = GEPS_V + (1.D0+3D0/AT3)* 
!     *               PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)
!           ENDDO
!          ENDDO
!         ENDDO
        GEPS_P = HTFP ( 1, 1 )
        GEPS_V = 0.D0
        CALL AZZERO(HTFV,9)
        DO IS=1,NSP
         DO IA=1,NA(IS)
          DO K=1,3
           DO L=1,3
            HTFV(K,L) = HTFV(K,L) + PMA(IS)*VELP(K,IA,IS)*VELP(L,IA,IS)
           END DO
           GEPS_V = GEPS_V + PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)/AT3
          ENDDO
         ENDDO
        ENDDO  
!        CALL AZZERO(HTFV,9)
!        KIN=0.D0
!        DO IS=1,NSP
!         DO IA=1,NA(IS)
!          DO K=1,3
!           DO L=1,3
!            HTFV(K,L) = HTFV(K,L) + PMA(IS)*VELP(K,IA,IS)*VELP(L,IA,IS)
!           ENDDO
!           KIN = KIN +  PMA(IS)*VELP(K,IA,IS)*VELP(K,IA,IS)/AT3
!          ENDDO
!         ENDDO
!        ENDDO  
C     ==--------------------------------------------------------------==
C     ==  PROPAGATE BAROSTAT (CELL VELOCITY) ONLY IN "X" DIRECTION    ==
C     P0 = INITIAL PRESSURE DETERMINED UPON INPUT AND IS 
C          INCORPORATED INTO HTFP IN SUBROUTINE TOTSTR.F LINE 55
C     V  = INSTANTANEOUS VOLUME
C     V0 = INITIAL VOLUME DETERMINED 
C     VSHOCK = SHOCK SPEED DETERMINED UPON INPUT
C     ==--------------------------------------------------------------==
C BIAS TO THE COMPRESSIVE SOLUTION
!       IF ( V .LT. V0 ) THEN
!         HTVEL(1,1) = HTVEL(1,1) +
!     *     0.5D0*DT_IONS*(HTFV(1,1) + HTFP(1,1) + KIN  
!     *     -VSHOCK*VSHOCK*V*V0I*(1.0D0-V*V0I))/CMASS
!       ELSE
!         HTVEL(1,1) = HTVEL(1,1) +
!    *     0.5D0*DT_IONS*(HTFV(1,1) + HTFP(1,1) + KIN )/CMASS
!       ENDIF
!        VEPS = VEPS+0.5D0*DT_IONS*(GEPS_P+GEPS_V)/CMASS
!        VEPS = VEPS+0.5D0*DT_IONS*(GEPS_P+GEPS_V)/CMASS
       IF ( V .LT. V0 ) THEN
         VEPS = VEPS +
     *     0.5D0*DT_IONS*(HTFV(1,1)+GEPS_V+GEPS_P
     *     -VSHOCK*VSHOCK*V*V0I*(1.0D0-V*V0I))/CMASS
       ELSE
         VEPS = VEPS +
     *     0.5D0*DT_IONS*(HTFV(1,1)+GEPS_V+GEPS_P)/CMASS
       ENDIF
      
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VEPSUPDAMP
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'tpar.inc'
      INCLUDE 'shock.inc'
      REAL*8 SCALE,GAMMA
      SCALE = 1.D0
C CJM DBG HARDWIRED UNTIL PUT IN INPUT
      GAMMA = .05D0 * AU_FS
C CJM DBG HARDWIRED UNTIL PUT IN INPUT
      SCALE = SCALE * DEXP ( -GAMMA * 0.25D0 * DT_IONS )
! Scale 
!      HTVEL ( 1, 1 )  = HTVEL ( 1, 1 )  * SCALE
       VEPS = VEPS  * SCALE

C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==  PROPOGATES THE CELL VELOCITIES FOR NPH-SHOCK DYNAMCIS       ==
C     ==--------------------------------------------------------------==


