C     ==================================================================
      SUBROUTINE VGSORTHO(C0,SC0,NGW,NFIRST,NLAST)
C     ==--------------------------------------------------------------==
C     ==  Gram-Schmidt orthogonalization for Vanderbilt pp            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'geq0.inc'
C     Arguments
      INTEGER    NGW,NFIRST,NLAST
      COMPLEX*16 C0(NGW,*),SC0(NGW,*)
C     Variables
      REAL*8     S,ANORM,
     &           DOTP
      EXTERNAL   DOTP
      INTEGER    ISUB,I,J
C     ==--------------------------------------------------------------==
      CALL TISET('  VGSORTHO',ISUB)
      DO I=NFIRST,NLAST
        DO J=1,I-1
          S=-DOTP(NGW,SC0(1,I),C0(1,J))
#ifdef PARALLEL
          CALL GLOSUM(1,S)
#endif
          CALL DAXPY(2*NGW,S,C0(1,J),1,C0(1,I),1)
          CALL DAXPY(2*NGW,S,SC0(1,J),1,SC0(1,I),1)
        ENDDO
        S=DOTP(NGW,SC0(1,I),C0(1,I))
#ifdef PARALLEL
        CALL GLOSUM(1,S)
#endif
        ANORM=1.D0/DSQRT(S)
        CALL DSCAL(2*NGW,ANORM,C0(1,I),1)
        CALL DSCAL(2*NGW,ANORM,SC0(1,I),1)
        IF(GEQ0) THEN
          C0(1,I)=DCMPLX(DREAL(C0(1,I)),0.0D0)
          SC0(1,I)=DCMPLX(DREAL(SC0(1,I)),0.0D0)
        ENDIF
      ENDDO
      CALL TIHALT('  VGSORTHO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
