C     ==================================================================
      SUBROUTINE VOFRHO(TAU0,FION,RHOE,V,SCR,LSCR,TFOR,TSTRESS)
C     ==--------------------------------------------------------------==
C     == FION: forces acting on ions (IF TFOR)                        ==
C     == RHOE: in  electronic density in real space                   ==
C     ==       out potential in real space                            ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'        !NLSD
      INCLUDE 'isos.inc'
      INCLUDE 'store.inc'       !SPOT
      INCLUDE 'poin.inc'        !POTR
C     Arguments
      INTEGER    LSCR
      REAL*8     TAU0(3,NAX,NSX),FION(3,NAX,NSX),
     &           RHOE(NNR1,NLSD),SCR(LSCR)
      COMPLEX*16 V(NNR1)
      LOGICAL    TFOR,TSTRESS
C     Variables
      COMPLEX*16 VTEMP(NHG,NLSD)
      REAL*8     SCR2(LSCR-NHG*2)
      POINTER    (IP_VTEMP,VTEMP),(IP_SCR2,SCR2)
      CHARACTER  TAG*30
      INTEGER    LSCR2,IL_VTEMP,LVOFRHO,IL_RHOE,IL_PSI
      LOGICAL    PTR_ALLOCATED
      EXTERNAL   PTR_ALLOCATED
      LOGICAL    DEBUG
C     ==--------------------------------------------------------------==
      DEBUG=.FALSE.
      CALL GIVE_SCR_VOFRHO(LVOFRHO,TAG)
      CALL TEST_SCR('VOFRHO',TAG,LSCR,LVOFRHO)
      IL_VTEMP = 2*NHG*NLSD
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_VTEMP,IL_VTEMP,'VTEMP',DEBUG)
      CALL SCRGET(SCR,LSCR,IP_SCR2,LSCR2,'SCR2',DEBUG)
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
C     Allocation of POTR if SPOT and POTR not allocated.
      IF(SPOT) THEN
        IF(PTR_ALLOCATED(IP_POTR)) THEN
          CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
          CALL MEMORY(IP_POTR,IL_RHOE,'POTR')
        ENDIF
      ENDIF
      IF(TCLUST) THEN
        IF(PS_TYPE.EQ.1) THEN
          CALL VOFRHOH(TAU0,FION,RHOE,V,VTEMP,SCR2,LSCR2,TFOR)
        ELSEIF(PS_TYPE.EQ.2) THEN
          CALL VOFRHOT(TAU0,FION,RHOE,V,VTEMP,SCR2,LSCR2,TFOR)
        ELSEIF(PS_TYPE.EQ.3) THEN
          CALL VOFRHOT(TAU0,FION,RHOE,V,VTEMP,SCR2,LSCR2,TFOR)
        ELSE
          CALL STOPGM('VOFRHO','PS_TYPE not implemented')
        ENDIF
      ELSE
        CALL VOFRHOA(TAU0,FION,RHOE,V,VTEMP,SCR2,LSCR2,TFOR,TSTRESS)
      ENDIF
      IF(TLSE)THEN
        IF(TROKS.OR.TROOT) THEN
          CALL VOFRHOS(FION,RHOE,V,VTEMP,SCR2,LSCR2,TFOR,TSTRESS)
        ELSEIF(TCAS22) THEN
          CALL VOFRHOS(FION,RHOE,V,VTEMP,SCR2,LSCR2,TFOR,TSTRESS)
          CALL VOFRHOC(TAU0,RHOE(1,4),V,VTEMP,SCR2,LSCR2,TFOR,TSTRESS)
        ELSEIF(TROSS) THEN
          CALL VOFRHOR(FION,RHOE,V,VTEMP,SCR2,LSCR2,TFOR,TSTRESS)
        ENDIF
      ELSE
        CALL VOFRHOB(FION,RHOE,V,VTEMP,SCR2,LSCR2,TFOR,TSTRESS)
      ENDIF
      CALL SCRREL(SCR,LSCR,DEBUG)
C     ==--------------------------------------------------------------==
      IF(SPOT) CALL DCOPY(NNR1*NLSD,RHOE,1,POTR,1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_VOFRHO(LVOFRHO,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !NHG
      INCLUDE 'spin.inc'        !NLSD NLSX
      INCLUDE 'pslo.inc'        !TIVAN
      INCLUDE 'isos.inc'        !TCLUST
C     Arguments
      INTEGER   LVOFRHO
      CHARACTER TAG*30
C     Variables
      INTEGER   LVOFRHOA,LVOFRHOB,LVOFRHOS,LC
C     ==--------------------------------------------------------------==
      IF(TCLUST) THEN
        IF(PS_TYPE.EQ.1) THEN
          CALL GIVE_SCR_VOFRHOH(LVOFRHOA,TAG)
        ELSEIF(PS_TYPE.EQ.2) THEN
          CALL GIVE_SCR_VOFRHOT(LVOFRHOA,TAG)
        ELSEIF(PS_TYPE.EQ.3) THEN
          CALL GIVE_SCR_VOFRHOT(LVOFRHOA,TAG)
        ELSE
          CALL STOPGM('VOFRHO','PS_TYPE not implemented')
        ENDIF
      ELSE
        CALL GIVE_SCR_VOFRHOA(LVOFRHOA,TAG)
      ENDIF
      IF(TLSE) THEN
        IF(TROKS.OR.TROOT) THEN
          CALL GIVE_SCR_VOFRHOS(LVOFRHOS,TAG)
        ELSEIF(TCAS22) THEN
          CALL GIVE_SCR_VOFRHOS(LVOFRHOS,TAG)
          CALL GIVE_SCR_VOFRHOC(LC,TAG)
          LVOFRHOS=MAX(LC,LVOFRHOS)
        ELSEIF(TROSS) THEN
          CALL GIVE_SCR_VOFRHOR(LVOFRHOS,TAG)
        ENDIF
        LVOFRHOB=0
      ELSE
        CALL GIVE_SCR_VOFRHOB(LVOFRHOB,TAG)
        LVOFRHOS=0
      ENDIF
      LVOFRHO=2*NHG*NLSD+MAX(LVOFRHOA,LVOFRHOB,LVOFRHOS)+100
      TAG   ='2*NHG*NLSD+MAX(LVOFRHO(A|B|S))'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      
