C     ==================================================================
      SUBROUTINE VPSI(C0,C2,F,VPOT,PSI,PSIAB,NSTATE,IKIND,ISPIN)
C     ==================================================================
C     == K-POINT AND NOT K-POINT VERSION OF VPSI.                     ==
C     ==--------------------------------------------------------------==
C     == VPOT:   IN INPUT POTENTIAL                                   ==
C     == ISPIN:  Need with LSD option for diagonalization scheme      ==
C     ==         dimension of VPOT(NNR1,ISPIN)                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'rswf.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'dg.inc'
      INCLUDE 'cdft.inc'
CEHR[
      INCLUDE 'td_input.inc'
      INCLUDE 'efld.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'ddip.inc'
CEHR]
C     Arguments
      INTEGER    NSTATE,IKIND,ISPIN
      COMPLEX*16 C0(NGWK,*),C2(NGWK,*),PSI(*),PSIAB(*)
      REAL*8     F(*),VPOT(NNR1,*)
C     Variables
      DIMENSION  HGKP(NHG,NKPNT),HGKM(NHG,NKPNT)
      COMPLEX*16 FP,FM,psin,psii,VBB(*),VAA(*)
      REAL*8     PSIX(*),VPOTX(*),KVAB(2,*),VPOTDG(NNR1,*)
      POINTER    (IP_PSIX,PSIX),(IP_VPOTX,VPOTX),(IP_VPOTDG,VPOTDG)
      POINTER    (IP_VBB,VBB),(IP_VAA,VAA),(IP_KVAB,KVAB)
      INTEGER    ISUB,LEAD,LEADX,NNRX,IFFT,NJUMP,IA,NSTA,IWF,
     &           IB,IBB,IG,I,IS1,IS2,LSPIN,IR,NOSTAT
      REAL*8     FI,FIP1,XSKIN,G2
      LOGICAL    WFCOPY
      INTEGER    DGFIRST
      SAVE       DGFIRST,IP_VPOTDG
      DATA       DGFIRST /0/
      REAL*8     CSMULT
CEHR[
      REAL*8     EXTF(*)
      DIMENSION  RK(3,NKPTS)
CEHR]
#ifdef PARALLEL
      INTEGER MSGLEN,NL2,IX1,IXP,IX
#endif
#ifdef __DERF
      REAL*8   DERF
      EXTERNAL DERF
#endif
ckk-mb === print local potential (start) ===
      INTEGER    IXX,IXXS,IYY,IZZ,JJ,NRXYZ1S,NRXYZ2S
      REAL*8     VPOTX3A(NR1S,NR2S,NR3S),VPOTX3B(NR1S,NR2S,NR3S)
      POINTER    (IP_VPOTX3A,VPOTX3A),(IP_VPOTX3B,VPOTX3B)
      LOGICAL    LG_VPOTX3A,LG_VPOTX3B
      INTEGER    ICLPOT,NRXYZ2
      DATA       ICLPOT /0/
      COMMON/LOCPOT/ IP_VPOTX3A,IP_VPOTX3B,LG_VPOTX3A,LG_VPOTX3B,
     &               ICLPOT,NRXYZ2
ckk-mb === print local potential (end)  ===
C     ==--------------------------------------------------------------==
      CALL TISET('      VPSI',ISUB)
      IF (TDG) THEN
         IF(TLSE)CALL STOPGM(' VPSI',
     *               'TDG TOGETHER WITH  LSE IS NOT YET IMPLEMENTED ')
         IF(NOGRP.GT.1)CALL STOPGM(' VPSI',
     *            'TDG TOGETHER WITH TASK GROUPS NOT YET IMPLEMENTED ')
        CALL SETFFTN(IPOOLDG)
        IF(DGFIRST.EQ.0) THEN
          CALL MEMORY(IP_VPOTDG,NNR1*2,"VPOTDG")
          DGFIRST=1
        ENDIF
      ELSE
        CALL SETFFTN(0)
      ENDIF
      IF(TLSE.AND.TLSETS.AND.(TROSS.OR.TCAS22.OR.TPENAL.OR.TROOT)) THEN
         CALL STOPGM(' VPSI',
     *        'NO SLATER TS WITH ROSS, CAS22, PENALTY, ROOTHAAN')
      ENDIF
#ifdef PARALLEL
      IF(NOGRP.EQ.1) THEN
        LEAD  = QR1S*MSRAYS
        LEADX = NNR1
        IFFT  = 1
        NNRX  = LLR1
      ELSE
        LEAD  = KR1S*NGRM
        LEADX = KRX*KR2S*KR3S
        IFFT  = 2
        NNRX  = KRX*KR2S*KR3S
      ENDIF
#else
      LEAD  = LLR1
      LEADX = NNR1
      NNRX  = LLR1
      IFFT  = 1
#endif
C
      IF (TDG) THEN
#ifdef _BGL
        CALL AZZERO(PSI, 2*MAXFFT)
#else
        CALL ZAZZERO(PSI, MAXFFT)
#endif
        CALL DCOPY (NNR1, VPOT, 1, PSI, 2)
        CALL FWFFT(PSI)
        CALL MOVEPSID(PSI)
        CALL INVFFTN(PSI, .false.)
        CALL DCOPY(LLR1, PSI, 2, VPOTDG, 1)
        IF(TLSD.AND.ISPIN.EQ.2) THEN
#ifdef _BGL 
        CALL AZZERO(PSI, 2*MAXFFT)
#else
        CALL ZAZZERO(PSI, MAXFFT)
#endif
          CALL DCOPY (NNR1, VPOT(1,2), 1, PSI, 2)
          CALL FWFFT(PSI)
          CALL MOVEPSID(PSI)
          CALL INVFFTN(PSI, .false.)
          CALL DCOPY(LLR1, PSI, 2, VPOTDG(1,2), 1)
        ENDIF
      ELSE
        CALL GET_ADDR(IP_VPOTDG,VPOT(1,1))
      ENDIF
C
      CALL GET_ADDR(IP_PSIX,PSI(1))
      CALL GET_ADDR(IP_VPOTX,VPOTDG(1,1))
#ifdef PARALLEL
      IF(NOGRP.GT.1) THEN
C       Summation of density within orbital split
        NL2=NLINK(NOLIST(NOGRP))
        IX1=NRXPL(MEPOS,1)-NRXPL(NL2,1)
        MSGLEN= 8 * NNRX
        IF(TLSD.AND.ISPIN.EQ.2) THEN
          CALL DCOPY(NNR1,VPOTDG(1,2),1,VPOTX(LEADX+1),1)
          CALL AZZERO(PSIX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,VPOTX(IXP),KR1,PSIX(IX),KRX)
          ENDDO
          CALL MY_COMBINE(PSIX,VPOTX(1),MSGLEN,1,MEOGRP)
          CALL AZZERO(PSIX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,VPOTX(LEADX+IXP),KR1,PSIX(IX),KRX)
          ENDDO
          CALL MY_COMBINE(PSIX,VPOTX(LEADX+1),MSGLEN,1,MEOGRP)
        ELSE
          CALL AZZERO(PSIX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,VPOTDG(IXP,1),KR1,PSIX(IX),KRX)
          ENDDO
          CALL MY_COMBINE(PSIX,VPOTX,MSGLEN,1,MEOGRP)
        ENDIF
      ENDIF
#endif
      IF(TKPNT) THEN 
        NJUMP=NOGRP
      ELSE
        NJUMP=2*NOGRP
      ENDIF  
      IF(TLSE) THEN
        NOSTAT = IALPHA-1
      ELSE
        NOSTAT = NSTATE
      ENDIF
      IF(CDFT)THEN
        DO IR=1,NNR1
          VPOTX(IR)=VPOTX(IR)+CDFT_V*WDIFF(IR)
        ENDDO
        CSMULT=1.0D0
        IF(TSPINC)CSMULT=-1.0D0
        IF(TLSD.AND.ISPIN.EQ.2) THEN
          DO IR=1,NNR1
            VPOTX(IR+LEADX)=VPOTX(IR+LEADX)+CSMULT*CDFT_V*WDIFF(IR)
          ENDDO
        ENDIF
      ENDIF

      DO IA=1,NOSTAT,NJUMP
        WFCOPY=.FALSE.
        IF(RSACTIVE) THEN
          IF(NOGRP.EQ.1) THEN
            IWF = IA+(IKIND-1)*NSTATE
            IF(IWF.LE.MAXSTATES) WFCOPY=.TRUE.
          ELSE
            IWF = (IA/NOGRP)+1+(IKIND-1)*((NSTATE+NOGRP-1)/NOGRP)
            IF(IWF.LE.MAXSTATES) WFCOPY=.TRUE.
          ENDIF
        ENDIF
        IF(WFCOPY) THEN
          IF(NOGRP.EQ.1) THEN
            IWF=IA/2+1
            IF(TKPNT) IWF = IA+(IKIND-1)*NSTATE
            CALL DCOPY(2*NNRX,RSWF(1,IWF),1,PSI(1),1)
          ELSE
            IWF=IA/(2*NOGRP)+1
            IF(TKPNT) IWF = (IA/NOGRP)+1+(IKIND-1)*
     *                      ((NSTATE+NOGRP-1)/NOGRP)
            CALL DCOPY(2*NNRX,RSWF(1,IWF),1,PSI(1),1)
          ENDIF
          
          IF(TKPNT) THEN 
            NSTA=MIN(NOSTAT-IA+1,NOGRP)
          ELSE 
            NSTA=MIN((NOSTAT-IA+2)/2,NOGRP)
          END IF
          
        ELSE
#ifdef _BGL 
        CALL AZZERO(PSI, 2*MAXFFT*NOGRP)
#else
        CALL ZAZZERO(PSI, MAXFFT*NOGRP)
#endif

C         ==----------------------------------------------------------==
C         == Store the wavefunctions in array PSI                     ==
C         == in the following way:                                    ==
C         == Since we use the Gamma point only, the wavefunctions in  ==
C         == real space are real. This fact is used to save time by   ==
C         == using complex arrays where the wavefunctions of          ==
C         == 2 different states (i and i+1) are combined, and         ==
C         == performing complex Fourier Transforms.                   ==
C         == Warning: If you use K-points other than Gamma, or zone   ==
C         == boundary, this symmetry is broken and the trick is not   ==
C         == valid anymore. First step is to build the array PSI.     ==
C         ==----------------------------------------------------------==
          IF(TKPNT) THEN 
            NSTA=MIN(NOSTAT-IA+1,NOGRP)
            DO IB=1,NSTA
              I=IA+(IB-1)
              IBB=(IB-1)*LEAD
#ifdef _vpp_
C$OMP parallel do private(IG)
              DO IG=1,NGW
C               The +g component of the state I 
                PSI(NZHS(IG)+IBB)=C0(IG,I)
              ENDDO
C$OMP parallel do private(IG) 
              DO IG=1,NGW
C               The -g component of the state I 
                PSI(INDZS(IG)+IBB)=C0(IG+NGW,I) 
              ENDDO
#elif defined(__CRAYX1)
!CSD$ parallel do private(IG)
!dir$ concurrent
              DO IG=1,NGW
C               The +g component of the state I
                PSI(NZHS(IG)+IBB)=C0(IG,I)
C               The -g component of the state I
                PSI(INDZS(IG)+IBB)=C0(IG+NGW,I)
              ENDDO
!CSD$ end parallel do
#else
#ifdef __NEC
!CDIR NODEP
#endif
#if !(defined(__SGI)) && !(defined(__ES))
!$OMP parallel do private(IG) shared(NGW,PSI,C0,IBB)
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(1000))
!IBM$ INDEPENDENT
#endif
#ifdef __SR8000
*poption parallel, tlocal(IG)
#endif
              DO IG=1,NGW
C               The +g component of the state I 
                PSI(NZHS(IG)+IBB)=C0(IG,I)
C               The -g component of the state I 
                PSI(INDZS(IG)+IBB)=C0(IG+NGW,I) 
              ENDDO
#endif
              IF(GEQ0) PSI(NZHS(1)+IBB)=C0(1,I)
            ENDDO
          ELSE 
            NSTA=MIN((NOSTAT-IA+2)/2,NOGRP)
            DO IB=1,NSTA
              I=IA+2*(IB-1)
              IBB=(IB-1)*LEAD
              IS1 = I
              IS2 = I+1
              IF(IS2.GT.NOSTAT) THEN
#ifdef _vpp_
!$OMP parallel do private(IG)
                DO IG=1,JGW
                  PSI(NZFS(IG)+IBB)=C0(IG,IS1)
                ENDDO
!$OMP parallel do private(IG)
                DO IG=1,JGW
                  PSI(INZS(IG)+IBB)=DCONJG(C0(IG,IS1))
                ENDDO
#elif defined(__CRAYX1)
!CSD$ parallel do private(IG)
!dir$ concurrent
                DO IG=1,NGW
                  PSI(NZHS(IG)+IBB)=C0(IG,IS1)
                  PSI(INDZS(IG)+IBB)=DCONJG(C0(IG,IS1))
                ENDDO
!CSD$ end parallel do
#else
#ifdef __NEC
!CDIR NODEP
#endif
#if !(defined(__SGI)) && !(defined(__ES))
!$OMP parallel do private(IG) shared(JGW,IS1,PSI,C0,IBB)
#endif
#ifdef __SR8000
*poption parallel, tlocal(IG)
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(1000))
!IBM$ INDEPENDENT
#endif
                DO IG=1,JGW
                  PSI(NZFS(IG)+IBB)=C0(IG,IS1)
                  PSI(INZS(IG)+IBB)=DCONJG(C0(IG,IS1))
                ENDDO
#endif
                IF(GEQ0) PSI(NZFS(1)+IBB)=C0(1,IS1)
              ELSE
#ifdef _vpp_
!$OMP parallel do private(IG)
                DO IG=1,JGW
                  PSI(NZFS(IG)+IBB)=C0(IG,IS1)+UIMAG*C0(IG,IS2)
                ENDDO
!$OMP parallel do private(IG)
                DO IG=1,JGW
                  PSI(INZS(IG)+IBB)=DCONJG(C0(IG,IS1))+
     *                                        UIMAG*DCONJG(C0(IG,IS2))
                ENDDO
#else
#ifdef __NEC
!CDIR NODEP
#endif
#if !(defined(__SGI)) && !(defined(__ES))
!$OMP parallel do private(IG) shared(NGW,IS1,IS2,PSI,C0,IBB)
#endif
#ifdef __SR8000
*poption parallel
#endif
!dir$ concurrent
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(1000))
!IBM$ INDEPENDENT
#endif
                DO IG=1,JGW
                  PSI(NZFS(IG)+IBB)=C0(IG,IS1)+UIMAG*C0(IG,IS2)
                  PSI(INZS(IG)+IBB)=DCONJG(C0(IG,IS1))+
     *                                        UIMAG*DCONJG(C0(IG,IS2))
                ENDDO
#endif
                IF(GEQ0) PSI(NZFS(1)+IBB)=C0(1,IS1)+UIMAG*C0(1,IS2)
              ENDIF
            ENDDO
          ENDIF 
C         ==----------------------------------------------------------==
C         == Transform the wavefunction to real space                 ==
C         ==----------------------------------------------------------==
          IF(IFFT.EQ.1) THEN
            CALL INVFFTN(PSI,.TRUE.)
          ELSE
            CALL SG_INVFFT(PSI)
          ENDIF
        ENDIF
C       ==------------------------------------------------------------==
C       == Apply the potential (V), which acts in real space.         ==
C       ==------------------------------------------------------------==
        IF(TLSD.AND.ISPIN.EQ.2) THEN
          IF(NOGRP.GT.1) THEN
#ifdef __SR8000
*poption parallel
#endif
            DO IB=1,NSTA
              IF(TKPNT) THEN
                IF(NOLIST(IB).EQ.ME) I=IA+(IB-1)
              ELSE
                IF(NOLIST(IB).EQ.ME) I=IA+2*(IB-1)
              ENDIF
            ENDDO
          ELSE
            I=IA
          ENDIF
          IF(I.EQ.NSUP) THEN
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(10000))
!IBM$ INDEPENDENT
#endif
CEHR[
           IF (TD_EXTPOT) THEN
             DO IR=1,NNRX
               PSI(IR)=(VPOTX(IR)+EXTF(IR))*REAL(PSI(IR))
     *                 +UIMAG*(VPOTX(LEADX+IR)+EXTF(IR))*DIMAG(PSI(IR))
             ENDDO
           ELSE
             DO IR=1,NNRX
                PSI(IR)=VPOTX(IR)*DREAL(PSI(IR))
     *                     +UIMAG*VPOTX(LEADX+IR)*DIMAG(PSI(IR))
             ENDDO
           ENDIF
CEHR]
          ELSE
            LSPIN=0
            IF(I.GT.NSUP) LSPIN=LEADX
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(10000))
!IBM$ INDEPENDENT
#endif
            DO IR=1,NNRX
               PSI(IR)=VPOTX(IR+LSPIN)*PSI(IR)
            ENDDO
          ENDIF
        ELSE
!$OMP parallel do private(IR) shared(NNRX,PSI)
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(10000))
!IBM$ INDEPENDENT
#endif
          DO IR=1,NNRX
             PSI(IR)=VPOTX(IR)*PSI(IR)
          ENDDO
ckk-mb === print local potential (start) ===
          IF (TLPOT) THEN
            ICLPOT=ICLPOT+1
            NRXYZ1S=NR1S*NR2S*NR3S
            NRXYZ2=0
            IF (ICLPOT .EQ. 1) THEN
              CALL MEMORY(IP_VPOTX3A,NRXYZ1S*3,"VPOTX3A")
              CALL AZZERO(VPOTX3A,NRXYZ1S)
              LG_VPOTX3A=.TRUE.
              LG_VPOTX3B=.FALSE.
            ELSE
              IF (LG_VPOTX3A) THEN
                CALL MEMORY(IP_VPOTX3B,NRXYZ1S*3,"VPOTX3B")
                CALL AZZERO(VPOTX3B,NRXYZ1S)
                CALL FREEM(IP_VPOTX3A)
                LG_VPOTX3A=.FALSE.
                LG_VPOTX3B=.TRUE.
              ELSE IF (LG_VPOTX3B) THEN
                CALL MEMORY(IP_VPOTX3A,NRXYZ1S*3,"VPOTX3A")
                CALL AZZERO(VPOTX3A,NRXYZ1S)
                CALL FREEM(IP_VPOTX3B)
                LG_VPOTX3A=.TRUE.
                LG_VPOTX3B=.FALSE.
              ENDIF
            ENDIF
            DO IR=1,NNRX
              IF (VPOTX(IR) .NE. 0) THEN
                NRXYZ2=NRXYZ2+1
                IXX=MOD(NRXYZ2-1,NR1)+1
                JJ=(NRXYZ2-1)/NR1+1
                IYY=MOD(JJ-1,NR2S)+1
                IZZ=(NRXYZ2-1)/(NR1*NR2S)+1
                IXXS=IXX+NRXPL(MEPOS,1)-1
                IF (LG_VPOTX3A) THEN
                  VPOTX3A(IXXS,IYY,IZZ)=VPOTX(IR)
                ELSE IF (LG_VPOTX3B) THEN
                  VPOTX3B(IXXS,IYY,IZZ)=VPOTX(IR)
                ENDIF
              ENDIF
            ENDDO
          ENDIF
ckk-mb === print local potential (end)  ===
        ENDIF
C       ==------------------------------------------------------------==
C       == Back transform to reciprocal space the product V.PSI       ==
C       ==------------------------------------------------------------==
        IF(IFFT.EQ.1) THEN
          CALL FWFFTN(PSI,.TRUE.)
        ELSE
          CALL SG_FWFFT(PSI)
        ENDIF
C       ==------------------------------------------------------------==
C       == Decode the combination of wavefunctions (now multiplied by ==
C       == the potential), back to those of states i and i+1. Multiply==
C       == also by the occupation numbers f(i) and other constants in ==
C       == order to obtain the force on the electronic degrees of     ==
C       == freedom, stored in array FC.                               ==
C       == Here we also add the force from the kinetic energy.        ==
C       ==------------------------------------------------------------==
        DO IB=1,NSTA
          IF(TKPNT) THEN 
            I=IA+(IB-1)
            IBB=(IB-1)*LEAD
            FI=F(I)
            IF(FI.EQ.0.D0) FI=2.D0
CEHR[
            IF(TGAUGEP.OR.TGAUGEF) THEN
!$OMP parallel do private(IG,FP,FM)
!$OMP+  shared(NGW,I,FI,TPIBA2,IKIND,PSI,C0,C2,IBB)
#ifdef __SR8000
*poption parallel
#endif
!CSD$ parallel do private(IG,FP,FM)
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(1000))
!IBM$ INDEPENDENT, NEW(FP,FM)
#endif
              DO IG=1,NGW
                FP=PSI(NZHS(IG)+IBB)
                FM=PSI(INDZS(IG)+IBB)
                C2(IG,    I)=-FI*
     &               (0.5D0*TPIBA2*HGKP(IG,IKIND)*C0(IG,    I)+FP)
                C2(IG+NGW,I)=-FI*
     &               (0.5D0*TPIBA2*HGKM(IG,IKIND)*C0(IG+NGW,I)+FM)
                C2(IG,    I)=C2(IG,    I)
     &            -FI*GPOT*(RK(pertdir,1)
     &                       +GK(pertdir,IG))*TPIBA*C0(IG ,I)
     &            -FI*0.5D0*(GPOT**2)*              C0(IG,    I)
                C2(IG+NGW,I)=C2(IG+NGW,I)
     &            -FI*GPOT*(RK(pertdir,1)
     &                       -GK(pertdir,IG))*TPIBA*C0(IG+NGW,I)
     &            -FI*0.5D0*(GPOT**2)*              C0(IG+NGW,I)
              ENDDO
!CSD$ end parallel do
            ELSE
!$OMP parallel do private(IG,FP,FM)
!$OMP+  shared(NGW,I,FI,TPIBA2,IKIND,PSI,C0,C2,IBB)
#ifdef __SR8000
*poption parallel
#endif
!CSD$ parallel do private(IG,FP,FM)
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(1000))
!IBM$ INDEPENDENT, NEW(FP,FM)
#endif
              DO IG=1,NGW
                FP=PSI(NZHS(IG)+IBB)                   
                FM=PSI(INDZS(IG)+IBB)
                C2(IG,    I)=-FI*
     &               (0.5D0*TPIBA2*HGKP(IG,IKIND)*C0(IG,    I)+FP)
                C2(IG+NGW,I)=-FI*
     &               (0.5D0*TPIBA2*HGKM(IG,IKIND)*C0(IG+NGW,I)+FM)
              ENDDO
!CSD$ end parallel do
            ENDIF
CEHR]
            IF(GEQ0)C2(1+NGW,I)=DCMPLX(0.D0,0.D0)
          ELSE
            I=IA+2*(IB-1)
            IBB=(IB-1)*LEAD
            IS1 = I
            IS2 = I+1
            FI=F(IS1)*0.5D0
            IF(FI.EQ.0.D0) FI=1.D0
            FIP1=0.D0
            IF(IS2.LE.NOSTAT) FIP1=F(IS2)*0.5D0
            IF(FIP1.EQ.0.D0) FIP1=1.D0
            IF(AKIN.GT.1.D-10) THEN
              XSKIN=1.D0/GSKIN
!$OMP parallel do private(IG,FP,FM,G2,psin,psii) shared(JGW,PSI,IBB)
!$OMP+  shared(TPIBA2,GAKIN,GCKIN,XSKIN,FI,C0,C2,IS1,NOSTAT,FIP1,IS2)
#ifdef __SR8000
*poption parallel
#endif
!dir$ concurrent
!CSD$  parallel do private(IG,FP,FM,G2)
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT, NEW(psin,psii,fp,fm,G2)
#endif
              DO IG=1,JGW
                psin=PSI(NZHS(IG)+IBB)  ! access only once
                psii=PSI(INDZS(IG)+IBB) ! these mem locations
                FP=psin+psii
                FM=psin-psii
cmb                FP=PSI(NZFS(IG)+IBB)+PSI(INZS(IG)+IBB)
cmb                FM=PSI(NZFS(IG)+IBB)-PSI(INZS(IG)+IBB)
                G2=TPIBA2*(HG(IG)+
     *               GAKIN*(1.D0+DERF((HG(IG)-GCKIN)*XSKIN)))
                C2(IG,IS1)=-FI*(G2*C0(IG,IS1)+
     *               DCMPLX(DREAL(FP),DIMAG(FM)))
                IF(IS2.LE.NOSTAT) C2(IG,IS2)=-FIP1*(G2*C0(IG,IS2)+
     *               DCMPLX(DIMAG(FP),-DREAL(FM)))
              ENDDO
!CSD$ end parallel do
            ELSE
!$OMP parallel do private(IG,FP,FM,psin,psii) shared(JGW,PSI,IBB)
!$OMP+   shared(C2,C0,FI,TPIBA2,IS1,IS2,NOSTAT,FIP1)
#ifdef __SR8000
*poption parallel
#endif
!CSD$  parallel do private(IG,FP,FM)
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT, NEW(psin,psii,fp,fm)
#endif
              DO IG=1,JGW
                psin=PSI(NZHS(IG)+IBB)  ! access only once
                psii=PSI(INDZS(IG)+IBB) ! these mem locations
                FP=psin+psii
                FM=psin-psii
cmb                FP=PSI(NZFS(IG)+IBB)+PSI(INZS(IG)+IBB)
cmb                FM=PSI(NZFS(IG)+IBB)-PSI(INZS(IG)+IBB)
                C2(IG,IS1)=-FI*((TPIBA2*HG(IG))*C0(IG,IS1)+
     *               DCMPLX(DREAL(FP),DIMAG(FM)))
                IF(IS2.LE.NOSTAT) C2(IG,IS2)=-FIP1*((TPIBA2*HG(IG))*
     *               C0(IG,IS2)+DCMPLX(DIMAG(FP),-DREAL(FM)))
              ENDDO
!CSD$ end parallel do
            ENDIF
          ENDIF
        ENDDO
      ENDDO                     ! Loop over IA 
      IF(TKPNT) CALL C_CLEAN(C2,NSTATE,IKIND)
#ifdef PARALLEL
C     Reestablish initial conditions for the potential
      IF(NOGRP.GT.1) THEN
        NL2=NLINK(NOLIST(NOGRP))
        IX1=NRXPL(MEPOS,1)-NRXPL(NL2,1)
        IF(TLSD.AND.ISPIN.EQ.2) THEN
          CALL DCOPY(NNRX,VPOTX(1),1,PSIX(1),1)
          CALL AZZERO(VPOTX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,VPOTDG(IXP,1),KR1)
          ENDDO
          CALL DCOPY(NNRX,VPOTX(LEADX+1),1,PSIX(1),1)
          CALL AZZERO(VPOTX(LEADX+1),NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,VPOTDG(IXP,2),KR1)
          ENDDO
        ELSE
          CALL DCOPY(NNRX,VPOTX(1),1,PSIX(1),1)
          CALL AZZERO(VPOTX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,VPOTDG(IXP,1),KR1)
          ENDDO
        ENDIF
      ENDIF
#endif
C     SPECIAL TERMS FOR LSE METHODS
      IF(TLSE) CALL VPSI_LSE(C0,C2,F,VPOT,PSI,PSIAB,NSTATE,.TRUE.)
C     META FUNCTIONALS NEED SPECIAL TERM
      IF(TTAU) CALL VTAUPSI(C0,C2,F,PSI,NSTATE,ISPIN)
C
      CALL TIHALT('      VPSI',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VPSIMT(C0,C2,F,VPOT,PSI,NSTATE,ISPIN,SWFUN)
C     ==================================================================
C     == No K-Points and no LSE  VERSION OF VPSI.                     ==
C     == EXACTLY LIKE VPSI BUT NO CONTRIBUTION FROM KINETIC ENERGY    ==
C     ==--------------------------------------------------------------==
C     == VPOT:   IN INPUT POTENTIAL                                   ==
C     == ISPIN:  Need with LSD option for diagonalization scheme      ==
C     ==         dimension of VPOT(NNR1,ISPIN)                        ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'rswf.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
C     Arguments
      INTEGER    NSTATE,ISPIN
      COMPLEX*16 C0(NGWK,NSTATE),C2(NGWK,NSTATE),PSI(NNR1)
      REAL*8     F(NSTATE),VPOT(NNR1,ISPIN)
      LOGICAL    SWFUN
C     Variables
      DIMENSION  HGKP(NHG,NKPNT),HGKM(NHG,NKPNT)
      COMPLEX*16 FP,FM,psii,psin,PSIAB(NNR1),C0TMP1,C0TMP2
      REAL*8     PSIX(*),VPOTX(*)
      POINTER    (IP_PSIX,PSIX),(IP_VPOTX,VPOTX),
     &           (IP_PSIAB,PSIAB)
      INTEGER    ISUB,LEAD,LEADX,NNRX,IFFT,NJUMP,IA,NSTA,
     &           IB,IBB,IG,I,IS1,IS2,L,LSPIN,NOSTAT
      REAL*8     FI,FIP1
#ifdef PARALLEL
      INTEGER MSGLEN,NL2,IX1,IXP,IX
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('      VPSI',ISUB)
C     Other illegal combinations already caught in VPSI
      IF(TLSE.AND.(TCAS22.OR.TPENAL)) THEN
        CALL STOPGM('VPSIMT','LSE (CAS22, PENALTY) NOT IMPLEMENTED')
      ENDIF
      IF(TKPNT) CALL STOPGM('VPSIMT','K-POINTS NOT IMPLEMENTED')
#ifdef PARALLEL
      IF(NOGRP.EQ.1) THEN
        LEAD  = KR1S*NGRAYS
        LEADX = NNR1
        IFFT  = 1
        NNRX=NNR1
      ELSE
        LEAD  = KR1S*NGRM
        LEADX = KRX*KR2S*KR3S
        IFFT=2
        NNRX=KRX*KR2S*KR3S
      ENDIF
#else
      LEAD  = NNR1
      LEADX = NNR1
      NNRX=NNR1
      IFFT=1
#endif
      CALL GET_ADDR(IP_PSIX,PSI(1))
      CALL GET_ADDR(IP_VPOTX,VPOT(1,1))
#ifdef PARALLEL
      IF(NOGRP.GT.1) THEN
C       Summation of density within orbital split
        NL2=NLINK(NOLIST(NOGRP))
        IX1=NRXPL(MEPOS,1)-NRXPL(NL2,1)
        MSGLEN= 8 * NNRX
        IF(TLSD.AND.ISPIN.EQ.2) THEN
          CALL DCOPY(NNR1,VPOT(1,2),1,VPOTX(LEADX+1),1)
          CALL AZZERO(PSIX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,VPOTX(IXP),KR1,PSIX(IX),KRX)
          ENDDO
          CALL MY_COMBINE(PSIX,VPOTX(1),MSGLEN,1,MEOGRP)
          CALL AZZERO(PSIX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,VPOTX(LEADX+IXP),KR1,PSIX(IX),KRX)
          ENDDO
          CALL MY_COMBINE(PSIX,VPOTX(LEADX+1),MSGLEN,1,MEOGRP)
        ELSE
          CALL AZZERO(PSIX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,VPOT(IXP,1),KR1,PSIX(IX),KRX)
          ENDDO
          CALL MY_COMBINE(PSIX,VPOTX,MSGLEN,1,MEOGRP)
        ENDIF
      ENDIF
#endif
      NJUMP=2*NOGRP
      IF(TLSE) THEN
        NOSTAT = IALPHA-1
      ELSE
        NOSTAT = NSTATE
      ENDIF
      DO IA=1,NOSTAT,NJUMP
#ifdef _BGL 
        CALL AZZERO(PSI,2*MAXFFT*NOGRP)
#else
        CALL ZAZZERO(PSI,MAXFFT*NOGRP)
#endif
C       ==----------------------------------------------------------==
C       == Store the wavefunctions in array PSI                     ==
C       == in the following way:                                    ==
C       == Since we use the Gamma point only, the wavefunctions in  ==
C       == real space are real. This fact is used to save time by   ==
C       == using complex arrays where the wavefunctions of          ==
C       == 2 different states (i and i+1) are combined, and         ==
C       == performing complex Fourier Transforms.                   ==
C       == Warning: If you use K-points other than Gamma, or zone   ==
C       == boundary, this symmetry is broken and the trick is not   ==
C       == valid anymore. First step is to build the array PSI.     ==
C       ==----------------------------------------------------------==
        NSTA=MIN((NOSTAT-IA+2)/2,NOGRP)
        DO IB=1,NSTA
          I=IA+2*(IB-1)
          IBB=(IB-1)*LEAD
          IS1 = I
          IS2 = I+1
          IF(IS2.GT.NOSTAT) THEN
!CDIR NODEP
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT 
#endif
#if defined(__VECTOR)
C$OMP parallel do private(IG)
            DO IG=1,NGW
              PSI(NZHS(IG)+IBB)=C0(IG,IS1)
              PSI(INDZS(IG)+IBB)=DCONJG(C0(IG,IS1))
            ENDDO
#else
C$OMP parallel do private(IG,C0TMP1) schedule(static)
            DO IG=1,NGW
              C0TMP1=C0(IG,IS1)
              PSI(NZHS(IG)+IBB)=C0TMP1
              PSI(INDZS(IG)+IBB)=DCONJG(C0TMP1)
            ENDDO
#endif
            IF(GEQ0) PSI(NZHS(1)+IBB)=C0(1,IS1)
          ELSE
!CDIR NODEP
#ifdef __SR8000
*poption parallel
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT 
#endif
#if defined(__VECTOR)
C$OMP parallel do private(IG)
            DO IG=1,NGW
              PSI(NZHS(IG)+IBB)=C0(IG,IS1)+UIMAG*C0(IG,IS2)
              PSI(INDZS(IG)+IBB)=DCONJG(C0(IG,IS1))+
     *                                    UIMAG*DCONJG(C0(IG,IS2))
            ENDDO
#else
C$OMP parallel do private(IG,C0TMP1,C0TMP2) schedule(static)
            DO IG=1,NGW
              C0TMP1=C0(IG,IS1)
              C0TMP2=C0(IG,IS2)
              PSI(NZHS(IG)+IBB)=C0TMP1+UIMAG*C0TMP2
              PSI(INDZS(IG)+IBB)=DCONJG(C0TMP1)+UIMAG*DCONJG(C0TMP2)
            ENDDO
#endif
            IF(GEQ0) PSI(NZHS(1)+IBB)=C0(1,IS1)+UIMAG*C0(1,IS2)
          ENDIF
        ENDDO
C       ==----------------------------------------------------------==
C       == Transform the wavefunction to real space                 ==
C       ==----------------------------------------------------------==
        IF(IFFT.EQ.1) THEN
          CALL S_INVFFT(PSI)
        ELSE
          CALL SG_INVFFT(PSI)
        ENDIF
C       ==------------------------------------------------------------==
C       == Apply the potential (V), which acts in real space.         ==
C       ==------------------------------------------------------------==
        IF(TLSD.AND.ISPIN.EQ.2) THEN
          IF(NOGRP.GT.1) THEN
            DO IB=1,NSTA
              IF(TKPNT) THEN
                IF(NOLIST(IB).EQ.ME) I=IA+(IB-1)
              ELSE
                IF(NOLIST(IB).EQ.ME) I=IA+2*(IB-1)
              ENDIF
            ENDDO
          ELSE
            I=IA
          ENDIF
          IF(I.EQ.NSUP) THEN
#ifdef __SR8000
*poption parallel
#endif
#if defined(__VECTOR)
!$OMP parallel do private(L)
#else
!$OMP parallel do private(L) schedule(static)
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(10000))
!IBM* INDEPENDENT 
#endif
            DO L=1,NNRX
               PSI(L)=VPOTX(L)*DREAL(PSI(L))
     *                    +UIMAG*VPOTX(LEADX+L)*DIMAG(PSI(L))
            ENDDO
          ELSE
            LSPIN=0
            IF(I.GT.NSUP) LSPIN=LEADX
#if defined(__VECTOR)
!$OMP parallel do private(L)
#else
!$OMP parallel do private(L) schedule(static)
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(10000))
!IBM* INDEPENDENT 
#endif
            DO L=1,NNRX
               PSI(L)=VPOTX(L+LSPIN)*PSI(L)
            ENDDO
          ENDIF
        ELSE
#if defined(__VECTOR)
!$OMP parallel do private(L)
#else
!$OMP parallel do private(L) schedule(static)
#endif
#ifdef _BGL 
!IBM$ ASSERT(ITERCNT(10000))
!IBM* INDEPENDENT 
#endif
          DO L=1,NNRX
             PSI(L)=VPOTX(L)*PSI(L)
          ENDDO
        ENDIF
C       ==------------------------------------------------------------==
C       == Back transform to reciprocal space the product V.PSI       ==
C       ==------------------------------------------------------------==
        IF(IFFT.EQ.1) THEN
          CALL S_FWFFT(PSI)
        ELSE
          CALL SG_FWFFT(PSI)
        ENDIF
C       ==------------------------------------------------------------==
C       == Decode the combination of wavefunctions (now multiplied by ==
C       == the potential), back to those of states i and i+1. Multiply==
C       == also by the occupation numbers f(i) and other constants in ==
C       == order to obtain the force on the electronic degrees of     ==
C       == freedom, stored in array FC.                               ==
C       == Here we also add the force from the kinetic energy.        ==
C       ==------------------------------------------------------------==
#ifdef __SR8000
*poption parallel
*poption tlocal(FIP1)
*voption indep(NZHS,INDZS,C2)
#endif
        DO IB=1,NSTA
          I=IA+2*(IB-1)
          IBB=(IB-1)*LEAD
          IS1 = I
          IS2 = I+1
          FI=F(IS1)*0.5D0
          IF(FI.EQ.0.D0) FI=1.D0
          IF(IS2.LE.NOSTAT) FIP1=F(IS2)*0.5D0
          IF(FIP1.EQ.0.D0) FIP1=1.D0
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(10000))
!IBM* INDEPENDENT , NEW(psin,psii,fp,fm) 
#endif
#if defined(__VECTOR)
C$OMP parallel do private(IG,psin,psii,FP,FM)
#else
C$OMP parallel do private(IG,psin,psii,FP,FM) schedule(static)
#endif
          DO IG=1,NGW
            psin=PSI(NZHS(IG)+IBB)
            psii=PSI(INDZS(IG)+IBB)
            FP=psin+psii
            FM=psin-psii
cmb            FP=PSI(NZHS(IG)+IBB)+PSI(INDZS(IG)+IBB)
cmb            FM=PSI(NZHS(IG)+IBB)-PSI(INDZS(IG)+IBB)
            C2(IG,IS1)=C2(IG,IS1)-FI*DCMPLX(DREAL(FP),DIMAG(FM))
            IF(IS2.LE.NOSTAT) 
     *       C2(IG,IS2)=C2(IG,IS2)-FIP1*DCMPLX(DIMAG(FP),-DREAL(FM))
          ENDDO
        ENDDO
      ENDDO                     ! Loop over IA 
#ifdef PARALLEL
C     Reestablish initial conditions for the potential
      IF(NOGRP.GT.1) THEN
        NL2=NLINK(NOLIST(NOGRP))
        IX1=NRXPL(MEPOS,1)-NRXPL(NL2,1)
        IF(TLSD.AND.ISPIN.EQ.2) THEN
          CALL DCOPY(NNRX,VPOTX(1),1,PSIX(1),1)
          CALL AZZERO(VPOTX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,VPOT(IXP,1),KR1)
          ENDDO
          CALL DCOPY(NNRX,VPOTX(LEADX+1),1,PSIX(1),1)
          CALL AZZERO(VPOTX(LEADX+1),NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,VPOT(IXP,2),KR1)
          ENDDO
        ELSE
          CALL DCOPY(NNRX,VPOTX(1),1,PSIX(1),1)
          CALL AZZERO(VPOTX,NNRX)
          DO IXP=1,NR1
            IX=IX1+IXP
            CALL DCOPY(KR2S*KR3S,PSIX(IX),KRX,VPOT(IXP,1),KR1)
          ENDDO
        ENDIF
      ENDIF
#endif
C     SPECIAL TERMS FOR LSE METHODS
      IF(TLSE) THEN
        CALL MEMORY (IP_PSIAB,2*MAXFFT,'PSIAB')
        CALL VPSI_LSE(C0,C2,F,VPOT,PSI,PSIAB,NSTATE,.FALSE.)
        CALL FREEM(IP_PSIAB)
      ENDIF
C     META FUNCTIONALS NEED SPECIAL TERM
      IF(TTAU) THEN
        IF (SWFUN) CALL SWITCH_FUNCTIONALS
        IF(TTAU) CALL VTAUPSI(C0,C2,F,PSI,NSTATE,ISPIN)
        IF (SWFUN) CALL SWITCH_FUNCTIONALS
      ENDIF
C
      CALL TIHALT('      VPSI',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE MOVEPSID(A)
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INTEGER IG
      COMPLEX*16 A(*),B(*),BTMP
      POINTER (IP_B,B)
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_B,2*NHG,"B")
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT  
#endif
#if defined(__VECTOR)
C$OMP parallel do private(IG)
#else
C$OMP parallel do private(IG) schedule(static)
#endif
      DO IG=1,NHG
        B(IG)=A(NZH(IG))
      ENDDO
#ifdef _BGL 
      CALL AZZERO(A,2*MAXFFTN)
#else
      CALL ZAZZERO(A,MAXFFTN)
#endif
#ifdef _BGL 
!IBM* ASSERT(ITERCNT(1000))
!IBM* INDEPENDENT  
#endif
#if defined(__VECTOR)
C$OMP parallel do private(IG)
      DO IG=1,JHG
        A(NZFF(IG))=B(IG)
        A(INZF(IG))=DCONJG(B(IG))
      ENDDO
#else
C$OMP parallel do private(IG) schedule(static)
      DO IG=1,JHG
        A(NZFF(IG))=B(IG)
        A(INZF(IG))=DCONJG(B(IG))
      ENDDO
#endif
      IF(GEQ0) A(NZFF(1))=B(1)
      CALL FREEM(IP_B)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
