C     ==================================================================
      SUBROUTINE VPSI_LSE(C0,C2,F,VPOT,PSI,PSIAB,NSTATE,TEKIN)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'rswf.inc'
      INCLUDE 'prcp.inc'
      INCLUDE 'ener.inc'
C     Arguments
      LOGICAL    TEKIN
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,*),C2(NGW,*),PSI(*),PSIAB(*)
      REAL*8     F(*),VPOT(NNR1,*)
C     Variables
      COMPLEX*16 FP,FM,VBB(*),VAA(*)
      REAL*8     KVAB(2,*)
      POINTER    (IP_VBB,VBB),(IP_VAA,VAA),(IP_KVAB,KVAB)
      INTEGER    ISUB,IG,I,IR
      REAL*8     FIA,FIB,G2,FH,FF,SA,CA,TAB,DOTP
      EXTERNAL   DOTP
C     ==--------------------------------------------------------------==
      CALL TISET('  VPSI_LSE',ISUB)
      IF(NOGRP.GT.1) CALL STOPGM("VPSI","GROUP CODE MISSING")
      CALL ZAZZERO(PSIAB,MAXFFT)
#ifdef __SR8000
*poption parallel
#endif
#ifndef __SR11000
!$OMP parallel do private(IG)
#endif
      DO IG=1,NGW
        PSIAB(NZHS(IG))=C0(IG,IALPHA)+UIMAG*C0(IG,IBETA)
        PSIAB(INDZS(IG))=DCONJG(C0(IG,IALPHA))+
     &                              UIMAG*DCONJG(C0(IG,IBETA))
      ENDDO
      IF(GEQ0) PSIAB(NZHS(1))=C0(1,IALPHA)+UIMAG*C0(1,IBETA)
      CALL S_INVFFT(PSIAB)
      IF(TROOT) THEN
#ifndef __SR11000
!$OMP parallel do private(IR)
#endif
#ifdef __SR8000
*poption parallel
#endif
        DO IR=1,NNR1
          PSI(IR)=VPOT(IR,1)*PSIAB(IR)
        ENDDO
      ELSE
#ifdef __SR8000
*poption parallel
#endif
        DO IR=1,NNR1
          PSI(IR)=VPOT(IR,2)*DREAL(PSIAB(IR))
     &             +UIMAG*VPOT(IR,3)*DIMAG(PSIAB(IR))
        ENDDO
      ENDIF
      CALL S_FWFFT(PSI)
      FH=0.5D0
      IF(TLSETS) THEN
        FIA=F(IALPHA)
        FIB=F(IBETA)
        IF(TEKIN) THEN
#ifdef __SR8000
*poption parallel
*voption indep(NZHS,INDZS,C2)
#endif
          DO IG=1,NGW
            FF=-FH*TPIBA2*HG(IG)
            FP=PSI(NZHS(IG))+PSI(INDZS(IG))
            FM=PSI(NZHS(IG))-PSI(INDZS(IG))
            C2(IG,IALPHA)=FIA*(FF*C0(IG,IALPHA)
     &                    -FH*DCMPLX(DREAL(FP),DIMAG(FM)))
            C2(IG,IBETA) =FIB*(FF*C0(IG,IBETA)
     &                    -FH*DCMPLX(DIMAG(FP),-DREAL(FM)))
          ENDDO
        ELSE
#ifdef __SR8000
*poption parallel
*voption indep(NZHS,INDZS,C2)
#endif
          DO IG=1,NGW
            FP=PSI(NZHS(IG))+PSI(INDZS(IG))
            FM=PSI(NZHS(IG))-PSI(INDZS(IG))
            C2(IG,IALPHA)=C2(IG,IALPHA)
     &                    -FIA*FH*DCMPLX(DREAL(FP),DIMAG(FM))
            C2(IG,IBETA) =C2(IG,IBETA)
     &                    -FIB*FH*DCMPLX(DIMAG(FP),-DREAL(FM))
          ENDDO
        ENDIF
      ELSE
        IF(TEKIN) THEN
#ifdef __SR8000
*poption parallel
*voption indep(NZHS,INDZS,C2)
#endif
          DO IG=1,NGW
            FF=-FH*TPIBA2*HG(IG)
            FP=PSI(NZHS(IG))+PSI(INDZS(IG))
            FM=PSI(NZHS(IG))-PSI(INDZS(IG))
            C2(IG,IALPHA)=FF*C0(IG,IALPHA)
     &                    -FH*DCMPLX(DREAL(FP),DIMAG(FM))
            C2(IG,IBETA) =FF*C0(IG,IBETA)
     &                    -FH*DCMPLX(DIMAG(FP),-DREAL(FM))
          ENDDO
        ELSE
#ifdef __SR8000
*poption parallel
*voption indep(NZHS,INDZS,C2)
#endif
          DO IG=1,NGW
            FP=PSI(NZHS(IG))+PSI(INDZS(IG))
            FM=PSI(NZHS(IG))-PSI(INDZS(IG))
            C2(IG,IALPHA)=C2(IG,IALPHA)
     &                    -FH*DCMPLX(DREAL(FP),DIMAG(FM))
            C2(IG,IBETA) =C2(IG,IBETA)
     &                    -FH*DCMPLX(DIMAG(FP),-DREAL(FM))
          ENDDO
        ENDIF
      ENDIF
      IF(TROOT) THEN
        CALL MEMORY(IP_VAA,2*NGW,'VAA')
        CALL MEMORY(IP_VBB,2*NGW,'VBB')
        CALL MEMORY(IP_KVAB,2*NSTATE,'KVAB')
#ifdef __SR8000
*poption parallel
#endif
        DO IR=1,NNR1
          PSI(IR)=VPOT(IR,2)*DREAL(PSIAB(IR))
     &             +UIMAG*VPOT(IR,3)*DIMAG(PSIAB(IR))
        ENDDO
        CALL S_FWFFT(PSI)
#ifndef __SR11000
!$OMP parallel do private(IG,FP,FM)
#endif
#ifdef __SR8000
*poption parallel
*voption indep(NZHS,INDZS,VAA,VBB)
#endif
        DO IG=1,NGW
          FP=-0.5D0*(PSI(NZHS(IG))+PSI(INDZS(IG)))
          FM=-0.5D0*(PSI(NZHS(IG))-PSI(INDZS(IG)))
          VAA(IG) = DCMPLX(DREAL(FP),DIMAG(FM))
          VBB(IG) = DCMPLX(DIMAG(FP),-DREAL(FM))
        ENDDO
        CALL DAXPY(2*NGW,-1.0D0,VAA,1,C2(1,IALPHA),1)
        CALL DAXPY(2*NGW,-1.0D0,VBB,1,C2(1,IBETA),1)
        DO I=1,NSTATE
          KVAB(1,I)=DOTP(NGW,VAA,C0(1,I))
          KVAB(2,I)=DOTP(NGW,VBB,C0(1,I))
        ENDDO
        CALL GLOSUM(2*NSTATE,KVAB)
        DO I=1,IALPHA-1
          TAB=F(I)*KVAB(1,I)
          CALL DAXPY(2*NGW,TAB,C0(1,IALPHA),1,C2(1,I),1)
          TAB=F(I)*KVAB(2,I)
          CALL DAXPY(2*NGW,TAB,C0(1,IBETA),1,C2(1,I),1)
          TAB=2.D0*KVAB(1,I)
          CALL DAXPY(2*NGW,TAB,C0(1,I),1,C2(1,IALPHA),1)
          TAB=2.D0*KVAB(2,I)
          CALL DAXPY(2*NGW,TAB,C0(1,I),1,C2(1,IBETA),1)
        ENDDO
        TAB=0.5D0*(KVAB(1,IBETA)-KVAB(2,IALPHA))
        CALL DAXPY(2*NGW,TAB,C0(1,IBETA),1,C2(1,IALPHA),1)
        TAB=0.5D0*(KVAB(2,IALPHA)-KVAB(1,IBETA))
        CALL DAXPY(2*NGW,TAB,C0(1,IALPHA),1,C2(1,IBETA),1)
        CALL FREEM(IP_VAA)
        CALL FREEM(IP_VBB)
        CALL FREEM(IP_KVAB)
      ELSEIF(TROSS) THEN
C       Special code for exchange contribution of singly occupied states
C       for the open shell (biradical) singlet method
#ifdef __SR8000
*poption parallel
#endif
#ifndef __SR11000
!$OMP parallel do private(IR)
#endif
        DO IR=1,NNR1
          PSI(IR)=PSIAB(IR)*VPOT(IR,4)
        ENDDO
        CALL S_FWFFT(PSI)
C       In the following loop states are interchanged
C       a contributes to b and b to a
#ifdef __SR8000
*poption parallel
#endif
        DO IG=1,NGW
          FP=0.5D0*(PSI(NZHS(IG))+PSI(INDZS(IG)))
          FM=0.5D0*(PSI(NZHS(IG))-PSI(INDZS(IG)))
          C2(IG,IALPHA)= C2(IG,IALPHA)-DCMPLX(DIMAG(FP),-DREAL(FM))
          C2(IG,IBETA) = C2(IG,IBETA) -DCMPLX(DREAL(FP),DIMAG(FM))
        ENDDO
      ELSEIF(TCAS22) THEN
C       Special code for the contribution to the forces from the
C       Kinetic energy in the CAS22 method
        CA=DCOS(CASANG)
        SA=DSIN(CASANG)
        DO IG=1,NGW
          G2=0.5D0*TPIBA2*HG(IG)
          C2(IG,IALPHA)=C2(IG,IALPHA)+
     &            G2*(SA*CA*C0(IG,IBETA)-SA*SA*C0(IG,IALPHA))
          C2(IG,IBETA) =C2(IG,IBETA) +
     &            G2*(SA*CA*C0(IG,IALPHA)+SA*SA*C0(IG,IBETA))
        ENDDO
C       now the contribution |a> = V*|b>
!CDIR NODEP
#ifdef __SR8000
*poption parallel
#endif
        DO IG=1,NGW
          PSI(NZHS(IG))=C0(IG,IALPHA)+UIMAG*C0(IG,IBETA)
          PSI(INDZS(IG))=DCONJG(C0(IG,IALPHA))+
     &                                UIMAG*DCONJG(C0(IG,IBETA))
        ENDDO
        IF(GEQ0) PSI(NZHS(1))=C0(1,IALPHA)+UIMAG*C0(1,IBETA)
        CALL S_INVFFT(PSI)
#ifdef __SR8000
*voption indep(PSI,VPOT)
#endif
        DO IR=1,NNR1
          PSI(IR)=PSI(IR)*VPOT(IR,4)
        ENDDO
        CALL S_FWFFT(PSI)
C       In the following loop states are interchanged
C       a contributes to b and b to a
#ifdef __SR8000
*poption parallel
#endif
        DO IG=1,NGW
          FP=0.5D0*(PSI(NZHS(IG))+PSI(INDZS(IG)))
          FM=0.5D0*(PSI(NZHS(IG))-PSI(INDZS(IG)))
          C2(IG,IALPHA)= C2(IG,IALPHA)-DCMPLX(DIMAG(FP),-DREAL(FM))
          C2(IG,IBETA) = C2(IG,IBETA) -DCMPLX(DREAL(FP),DIMAG(FM))
        ENDDO
      ENDIF
      IF(TPENAL) THEN
C       Contribution from Penalty function
C$OMP parallel do private(IR)
        DO IR=1,NNR1
          PSI(IR)=PSIAB(IR)*VPOT(IR,5)
        ENDDO
        CALL S_FWFFT(PSI)
C       In the following loop states are interchanged
C       a contributes to b and b to a
#ifdef __SR8000
*poption parallel
#endif
        DO IG=1,NGW
          G2=0.25D0*TPIBA2*HG(IG)
          FP=0.5D0*(PSI(NZHS(IG))+PSI(INDZS(IG)))
          FM=0.5D0*(PSI(NZHS(IG))-PSI(INDZS(IG)))
          C2(IG,IALPHA)= C2(IG,IALPHA)-
     &       2.D0*ETOT_AB*(G2*C0(IG,IBETA)+DCMPLX(DIMAG(FP),-DREAL(FM)))
          C2(IG,IBETA) = C2(IG,IBETA) -
     &       2.D0*ETOT_AB*(G2*C0(IG,IALPHA)+DCMPLX(DREAL(FP),DIMAG(FM)))
        ENDDO
      ENDIF
C
      CALL TIHALT('  VPSI_LSE',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
