C     ==================================================================
      SUBROUTINE VTAUPSI(C0,C2,F,PSI,NSTATE,ISPIN)
C     ==================================================================
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'tauf.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER    NSTATE,ISPIN
      COMPLEX*16 C0(NGWK,NSTATE),C2(NGWK,NSTATE),PSI(MAXFFT)
      POINTER    (IP_VPOT,VPOT)
      REAL*8     F(NSTATE),VPOT(NNR1,*),VTAU(NNR1,*),TAU(*)
C     Variables
      INTEGER    IS,IS1,IS2,ISUB
C     ==--------------------------------------------------------------==
      CALL TISET('   VTAUPSI',ISUB)
      IF(TKPNT) CALL STOPGM("VTAUPSI","KPNT NOT IMPLEMENTED")
      IF(TLSE) CALL STOPGM("VTAUPSI","LSE NOT IMPLEMENTED")
      CALL GET_ADDR(IP_VPOT,VTAU(1,ITAUR))
C     ==--------------------------------------------------------------==
C     Loop over the electronic states
      DO IS=1,NSTATE,2
        IS1=IS
        IS2=IS+1
C x direction
        CALL ZAZZERO(PSI,MAXFFT)
        CALL DPSISC(C0,PSI,1,IS1,IS2,NSTATE)
        CALL S_INVFFT(PSI)
        CALL TAUPOT(VPOT,PSI,IS1,IS2,ISPIN)
        CALL S_FWFFT(PSI)
        CALL FTAUADD(C2,PSI,F,1,IS1,IS2,NSTATE)
C y direction
        CALL ZAZZERO(PSI,MAXFFT)
        CALL DPSISC(C0,PSI,2,IS1,IS2,NSTATE)
        CALL S_INVFFT(PSI)
        CALL TAUPOT(VPOT,PSI,IS1,IS2,ISPIN)
        CALL S_FWFFT(PSI)
        CALL FTAUADD(C2,PSI,F,2,IS1,IS2,NSTATE)
C z direction
        CALL ZAZZERO(PSI,MAXFFT)
        CALL DPSISC(C0,PSI,3,IS1,IS2,NSTATE)
        CALL S_INVFFT(PSI)
        CALL TAUPOT(VPOT,PSI,IS1,IS2,ISPIN)
        CALL S_FWFFT(PSI)
        CALL FTAUADD(C2,PSI,F,3,IS1,IS2,NSTATE)
      ENDDO
      CALL TIHALT('   VTAUPSI',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE TAUPOT(VPOT,PSI,IS1,IS2,ISPIN)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
C     Arguments
      INTEGER    IS1,IS2,ISPIN
      COMPLEX*16 PSI(*)
      REAL*8     VPOT(NNR1,ISPIN)
C     Variables
      INTEGER    IR
      REAL*8     R1,R2
C     ==--------------------------------------------------------------==
      IF(ISPIN.EQ.1) THEN
C$OMP parallel do private(IR)
        DO IR=1,NNR1
          PSI(IR)=PSI(IR)*VPOT(IR,1)
        ENDDO
      ELSE
        IF(IS2.LE.NSUP) THEN
C$OMP parallel do private(IR)
          DO IR=1,NNR1
            PSI(IR)=PSI(IR)*VPOT(IR,1)
          ENDDO
        ELSEIF(IS1.GT.NSUP) THEN
C$OMP parallel do private(IR)
          DO IR=1,NNR1
            PSI(IR)=PSI(IR)*VPOT(IR,2)
          ENDDO
        ELSE
C$OMP parallel do private(IR,R1,R2)
          DO IR=1,NNR1
            R1=DIMAG(PSI(IR))
            R2=DREAL(PSI(IR))
            PSI(IR)=DCMPLX(R2*VPOT(IR,2),R1*VPOT(IR,1))
          ENDDO
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE FTAUADD(C2,PSI,F,K,IS1,IS2,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'cppt.inc'
C     Arguments
      INTEGER    K,IS1,IS2,NSTATE
      COMPLEX*16 C2(NGWK,NSTATE),PSI(*)
      REAL*8     F(*)
C     Variables
      COMPLEX*16 FM,FP
      REAL*8     FI1,FI2
      INTEGER    IG
C     ==--------------------------------------------------------------==
      IF(IS2.GT.NSTATE) THEN
        FI1=0.25D0*F(IS1)*TPIBA2
C$OMP parallel do private(IG,FP,FM)
        DO IG=1,NGW
          FP=PSI(NZHS(IG))+PSI(INDZS(IG))
          FM=PSI(NZHS(IG))-PSI(INDZS(IG))
          C2(IG,IS1)=C2(IG,IS1)-
     *               FI1*GK(K,IG)*DCMPLX(DREAL(FM),DIMAG(FP))
        ENDDO
      ELSE
        FI1=0.25D0*F(IS1)*TPIBA2
        FI2=0.25D0*F(IS2)*TPIBA2
C$OMP parallel do private(IG,FP,FM)
        DO IG=1,NGW
          FP=PSI(NZHS(IG))+PSI(INDZS(IG))
          FM=PSI(NZHS(IG))-PSI(INDZS(IG))
          C2(IG,IS1)=C2(IG,IS1)-
     *               FI1*GK(K,IG)*DCMPLX(DREAL(FM),DIMAG(FP))
          C2(IG,IS2)=C2(IG,IS2)-
     *               FI2*GK(K,IG)*DCMPLX(DIMAG(FM),-DREAL(FP))
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
