C     ==================================================================
      SUBROUTINE VTD2(VP2,RHOD,PSI,SCR,LSCR,SWFUN)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'func.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'linres.inc'
C
      INTEGER    LSCR
      COMPLEX*16 PSI(MAXFFT,*)
      REAL*8     SCR(LSCR),VP2(NNR1,*),RHOD(NNR1,*)
      LOGICAL    SWFUN
C
      DIMENSION  RHOO(NNR1,*)
      LOGICAL    DEBUG
      INTEGER    LVTD2,IR,ISUB,IL_VTEMP,IL_VTMP,IL_GRAD
      REAL*8     PADE_LDA,OEPS
      CHARACTER*30 TAG
      REAL*8 SMALL
      PARAMETER (SMALL=1.D-14)
      REAL*8     RHOX(NNR1,*),GRAD(*)
      COMPLEX*16 VTMP(*),VTEMP(*)
      POINTER    (IP_RHOX,RHOX),(IP_GRAD,GRAD),
     *           (IP_VTMP,VTMP),(IP_VTEMP,VTEMP)
C     ==--------------------------------------------------------------==
      CALL TISET('      VTD2',ISUB)
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_VTD2(LVTD2,TAG)
      CALL TEST_SCR('VTD2',TAG,LSCR,LVTD2)
C
      IF(SWFUN) CALL SWITCH_FUNCTIONALS
C
      DEBUG=.FALSE.
      CALL SCRSET(SCR,LSCR,DEBUG)
      IF(.NOT.TXC_ANALYTIC) THEN
        CALL SCRPTR(SCR,LSCR,IP_RHOX,NNR1*NLSD,'RHOX',DEBUG)
        IF(TGC) THEN
          IL_GRAD=NNR1*NLSD*4
          IL_VTEMP=2*NHG*NLSD
          IL_VTMP=MAX(2*NHG,NNR1*(2*NLSD-1))
        ELSE
          IL_GRAD=1
          IL_VTEMP=1
          IL_VTMP=1
        ENDIF
        CALL SCRPTR(SCR,LSCR,IP_VTEMP,IL_VTEMP,'VTEMP',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_VTMP,IL_VTMP,'VTMP',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_GRAD,IL_GRAD,'GRAD',DEBUG)
      ENDIF
C
      IF(TLSD) THEN
        IF(TXC_ANALYTIC) THEN
            CALL STOPGM('VTD2','ANALYTIC XC NOT AVAILABLE WITH LSD')
        ELSE
          IF(MFXCC.EQ.0.AND.MFXCX.EQ.0.AND..NOT.TGC) THEN
            CALL AZZERO(VP2,2*NNR1)
          ELSE
C           5-point formula for finite differences
C           R0
            CALL VXC_CALC(RHOO,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=-30.D0*DREAL(PSI(IR,1))
              VP2(IR,2)=-30.D0*DREAL(PSI(IR,2))
            ENDDO
C           R0+2*RD
            CALL DCOPY(2*NNR1,RHOO,1,RHOX,1)
            CALL DAXPY(2*NNR1,2.D0*XC_EPS,RHOD,1,RHOX,1)
            CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=VP2(IR,1)-DREAL(PSI(IR,1))
              VP2(IR,2)=VP2(IR,2)-DREAL(PSI(IR,2))
            ENDDO
C           R0+RD
            CALL DCOPY(2*NNR1,RHOO,1,RHOX,1)
            CALL DAXPY(2*NNR1,XC_EPS,RHOD,1,RHOX,1)
            CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=VP2(IR,1)+16.D0*DREAL(PSI(IR,1))
              VP2(IR,2)=VP2(IR,2)+16.D0*DREAL(PSI(IR,2))
            ENDDO
C           R0-RD
            CALL DCOPY(2*NNR1,RHOO,1,RHOX,1)
            CALL DAXPY(2*NNR1,-XC_EPS,RHOD,1,RHOX,1)
            CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=VP2(IR,1)+16.D0*DREAL(PSI(IR,1))
              VP2(IR,2)=VP2(IR,2)+16.D0*DREAL(PSI(IR,2))
            ENDDO
C           R0-2*RD
            CALL DCOPY(2*NNR1,RHOO,1,RHOX,1)
            CALL DAXPY(2*NNR1,-2.D0*XC_EPS,RHOD,1,RHOX,1)
            CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=VP2(IR,1)-DREAL(PSI(IR,1))
              VP2(IR,2)=VP2(IR,2)-DREAL(PSI(IR,2))
            ENDDO
            OEPS=1.D0/(12.D0*XC_EPS*XC_EPS)
            CALL DSCAL(2*NNR1,OEPS,VP2,1)
            CALL DSCAL(2*NNR1,0.25D0,VP2,1)
          ENDIF
        ENDIF
      ELSE
        IF(TXC_ANALYTIC) THEN
          IF(MFXCC.EQ.0.AND.MFXCX.EQ.0.AND..NOT.TGC) THEN
            CALL STOPGM('VTD2','this functional not available')
          ELSEIF(MFXCC.EQ.9.AND.MFXCX.EQ.0.AND..NOT.TGC) THEN
            DO IR=1,NNR1
              IF(RHOO(IR,1).GE.SMALL)THEN
                VP2(IR,1)=PADE_LDA(RHOO(IR,1),3)*RHOD(IR,1)*RHOD(IR,1)
              ELSE
                VP2(IR,1)=0.D0
              ENDIF
            ENDDO
          ELSE
            CALL STOPGM('VTD2','this functional not available')
          END IF
          IF(THYBRID) THEN
            CALL STOPGM('VTD2','this functional not available')
          ENDIF
        ELSE
          IF(MFXCC.EQ.0.AND.MFXCX.EQ.0.AND..NOT.TGC) THEN
            CALL AZZERO(VP2,NNR1)
          ELSE
C           5-point formula for finite differences
C           R0
            CALL VXC_CALC(RHOO,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=-30.D0*DREAL(PSI(IR,1))
            ENDDO
C           R0+2*RD
            CALL DCOPY(NNR1,RHOO,1,RHOX,1)
            CALL DAXPY(NNR1,2.D0*XC_EPS,RHOD,1,RHOX,1)
            CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=VP2(IR,1)-DREAL(PSI(IR,1))
            ENDDO
C           R0+RD
            CALL DCOPY(NNR1,RHOO,1,RHOX,1)
            CALL DAXPY(NNR1,XC_EPS,RHOD,1,RHOX,1)
            CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=VP2(IR,1)+16.D0*DREAL(PSI(IR,1))
            ENDDO
C           R0-RD
            CALL DCOPY(NNR1,RHOO,1,RHOX,1)
            CALL DAXPY(NNR1,-XC_EPS,RHOD,1,RHOX,1)
            CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=VP2(IR,1)+16.D0*DREAL(PSI(IR,1))
            ENDDO
C           R0-2*RD
            CALL DCOPY(NNR1,RHOO,1,RHOX,1)
            CALL DAXPY(NNR1,-2.D0*XC_EPS,RHOD,1,RHOX,1)
            CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
            DO IR=1,NNR1
              VP2(IR,1)=VP2(IR,1)-DREAL(PSI(IR,1))
            ENDDO
            OEPS=1.D0/(12.D0*XC_EPS*XC_EPS)
            CALL DSCAL(NNR1,OEPS,VP2,1)
          ENDIF
        ENDIF
      ENDIF
C
      CALL SCRREL(SCR,LSCR,DEBUG)
C
      IF(SWFUN) CALL SWITCH_FUNCTIONALS
C     ==--------------------------------------------------------------==
      CALL TIHALT('      VTD2',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VTD2T(VP2,RHOD,PSI,SCR,LSCR,SWFUN)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'func.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'linres.inc'
C
      INTEGER    LSCR
      COMPLEX*16 PSI(*)
      REAL*8     SCR(LSCR),VP2(NNR1),RHOD(NNR1)
      LOGICAL    SWFUN
C
      DIMENSION  RHOO(*)
      LOGICAL    DEBUG
      INTEGER    LVTD2,IR,ISUB,IL_VTEMP,IL_VTMP,IL_GRAD
      REAL*8     PADE_LDA,OEPS
      CHARACTER*30 TAG
      REAL*8 SMALL
      PARAMETER (SMALL=1.D-14)
      REAL*8     RHOX(NNR1,*),GRAD(*)
      COMPLEX*16 VTMP(*),VTEMP(*)
      POINTER    (IP_RHOX,RHOX),(IP_GRAD,GRAD),
     *           (IP_VTMP,VTMP),(IP_VTEMP,VTEMP)
C     ==--------------------------------------------------------------==
      CALL TISET('      VTD2',ISUB)
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_VTD2(LVTD2,TAG)
      CALL TEST_SCR('VTD2',TAG,LSCR,LVTD2)
C
      IF(SWFUN) CALL SWITCH_FUNCTIONALS
C
      TLSD=.TRUE.
C
      DEBUG=.FALSE.
      CALL SCRSET(SCR,LSCR,DEBUG)
      IF(.NOT.TXC_ANALYTIC) THEN
        CALL SCRPTR(SCR,LSCR,IP_RHOX,2*NNR1,'RHOX',DEBUG)
        IF(TGC) THEN
          IL_GRAD=NNR1*2*4
          IL_VTEMP=2*NHG*2
          IL_VTMP=MAX(2*NHG,NNR1*3)
        ELSE
          IL_GRAD=1
          IL_VTEMP=1
          IL_VTMP=1
        ENDIF
        CALL SCRPTR(SCR,LSCR,IP_VTEMP,IL_VTEMP,'VTEMP',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_VTMP,IL_VTMP,'VTMP',DEBUG)
        CALL SCRPTR(SCR,LSCR,IP_GRAD,IL_GRAD,'GRAD',DEBUG)
      ENDIF
C
      IF(TXC_ANALYTIC) THEN
          CALL STOPGM('VTD2','this functional not available')
      ELSE
        IF(MFXCC.EQ.0.AND.MFXCX.EQ.0.AND..NOT.TGC) THEN
          CALL AZZERO(VP2,NNR1)
        ELSE
C         5-point formula for finite differences
C         R0
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,1),1)
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,2),1)
          CALL DSCAL(NNR1,0.5D0,RHOX(1,2),1)
          CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
          DO IR=1,NNR1
            VP2(IR)=-30.D0*DREAL(PSI(IR))
          ENDDO
C         R0+2*RD
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,1),1)
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,2),1)
          CALL DAXPY(NNR1,2.D0*XC_EPS,RHOD,1,RHOX(1,2),1)
          CALL DSCAL(NNR1,0.5D0,RHOX(1,2),1)
          CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
          DO IR=1,NNR1
            VP2(IR)=VP2(IR)-DREAL(PSI(IR))
          ENDDO
C         R0+RD
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,1),1)
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,2),1)
          CALL DAXPY(NNR1,XC_EPS,RHOD,1,RHOX(1,2),1)
          CALL DSCAL(NNR1,0.5D0,RHOX(1,2),1)
          CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
          DO IR=1,NNR1
            VP2(IR)=VP2(IR)+16.D0*DREAL(PSI(IR))
          ENDDO
C         R0-RD
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,1),1)
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,2),1)
          CALL DAXPY(NNR1,-XC_EPS,RHOD,1,RHOX(1,2),1)
          CALL DSCAL(NNR1,0.5D0,RHOX(1,2),1)
          CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
          DO IR=1,NNR1
            VP2(IR)=VP2(IR)+16.D0*DREAL(PSI(IR))
          ENDDO
C         R0-2*RD
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,1),1)
          CALL DCOPY(NNR1,RHOO,1,RHOX(1,2),1)
          CALL DAXPY(NNR1,-2.D0*XC_EPS,RHOD,1,RHOX(1,2),1)
          CALL DSCAL(NNR1,0.5D0,RHOX(1,2),1)
          CALL VXC_CALC(RHOX,PSI,VTEMP,VTMP,GRAD)
          DO IR=1,NNR1
            VP2(IR)=VP2(IR)-DREAL(PSI(IR))
          ENDDO
          OEPS=1.D0/(12.D0*XC_EPS*XC_EPS)
          CALL DSCAL(NNR1,OEPS,VP2,1)
        ENDIF
      ENDIF
C
      CALL SCRREL(SCR,LSCR,DEBUG)
C
      IF(SWFUN) CALL SWITCH_FUNCTIONALS
C
      TLSD=.FALSE.
C     ==--------------------------------------------------------------==
      CALL TIHALT('      VTD2',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_VTD2(LVTD2,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'spin.inc'
      INCLUDE 'func.inc'
      INCLUDE 'poin.inc'
      INCLUDE 'linres.inc'
      INTEGER LVTD2,LRHOX,LVTEMP,LVTMP,LGRAD,NM
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      IF(.NOT.TXC_ANALYTIC) THEN
        IF(LRSYM.EQ.3) THEN
          NM=2
        ELSE
          NM=NLSD
        ENDIF
        LRHOX=NNR1*NM
        IF(TGC) THEN
          LGRAD=NNR1*NM*4
          LVTEMP=2*NHG
          LVTMP=MAX(2*NHG,NNR1*(2*NM-1))
        ELSE
          LGRAD=1
          LVTEMP=1
          LVTMP=1
        ENDIF
        LVTD2=LRHOX+LGRAD+LVTEMP+LVTMP
      ELSE
        LVTD2=0
      ENDIF
      LVTD2=LVTD2+200
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
