C hello emacs, this is -*- fortran -*-
C     ==================================================================
C     == INCLUDE FILE FOR WANNIER FUNCTIONS                           ==
C     ==--------------------------------------------------------------==
C     == TWANN : calculate Wannier orbitals                           ==
C     == TWPRI : print Wannier orbitals                               ==
C     == TSDENS: print square of Wannier orbitals                     ==
C     == TWDOS: print wannier density of states                       ==
C     == TWMOL: print molecular orbitals                              ==
C     ==--------------------------------------------------------------==
      INTEGER      NWANNL
      PARAMETER    (NWANNL=5)
      LOGICAL      TWANN,TWPRI,TSDENS,TWDOS,TWMOL
      COMMON/WANNL/TWANN,TWPRI,TSDENS,TWDOS,TWMOL
C     ==--------------------------------------------------------------==
C     == W_MAXS : Maximum number of optimization steps                ==
C     == W_TYPE : Type of optimization functional                     ==
C     ==          1 Vanderbilt                                        == 
C     ==          2 RESTA                                             ==
C     == W_OPT  : Optimisation procedure                              ==
C     ==          1 steepest descent                                  ==
C     ==          2 Jacobi Rotation                                   ==
C     == NS_WANN: sampling rate for Wannier function output           ==
C     == SW_FIRST : first Wannier orbital to be printed               ==
C     == SW_LAST  : last Wannier orbital to be printed                ==
C     == SW_ALL   : all Wannier orbital to be printed                 ==
C     == SW_ORB   : number of orbitals to be printed                  ==
C     == SW_LIST  : list of orbitals to be printed                    ==
C     ==--------------------------------------------------------------==
      INTEGER      NWANNI
      PARAMETER    (NWANNI=8)
      INTEGER      W_MAXS,W_TYPE,W_OPT,SW_ORB,NS_WANN,SW_FIRST,
     *             SW_LAST,SW_ALL,SW_LIST(*)
      POINTER(IP_SW_LIST,SW_LIST)
      COMMON/WANNI/W_MAXS,W_TYPE,W_OPT,NS_WANN,SW_ORB,SW_FIRST,
     *        SW_LAST,SW_ALL,IP_SW_LIST
C     ==--------------------------------------------------------------==
C     == W_STEP : step size for optimisation                          ==
C     == W_EPS  : convergence criteria                                ==
C     == W_RAN  : randomization amplitude                             ==
C     == W_REF  : reference point for Wannier centres                 ==
C     == SW_SPREAD: spread threshold for orbitals to be printed       ==
C     ==--------------------------------------------------------------==
      INTEGER      NWANNR
      PARAMETER    (NWANNR=7)
      REAL*8       W_STEP,W_EPS,W_RAN,W_REF(3),SW_SPREAD
      COMMON/WANNR/W_STEP,W_EPS,W_RAN,W_REF,SW_SPREAD
C     ==--------------------------------------------------------------==
C     == NWANOPT : number of operators                                ==
C     == IOW     : operators 4-6                                      ==
C     == WWEI    : weights                                            ==
C     == WQUADI  : weights for quadrupoles (RV)                       ==
C     ==--------------------------------------------------------------==
      INTEGER       NWANOPT,IOW
      COMMON/WANO1/ NWANOPT,IOW(2,3)
      REAL*8        WWEI
      REAL*8        WQUADI 
      COMMON/WANO2/ WWEI(6),WQUADI(6,6)
C     ==================================================================
      LOGICAL HMAT_SPREAD
      COMMON/WANO3/ HMAT_SPREAD
      REAL*8 MINSPR
      COMMON/WAN04/ MINSPR
C     ==================================================================


