C     ==================================================================
      SUBROUTINE WANNIER_FUN(N,OFUN,XMAT,XAUX,LDX,NW,W)
C     ==--------------------------------------------------------------==
C     == CALCULATES THE LOCALIZATION FUNCTIONAL                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C input
      REAL*8 W(*)
      INTEGER NW,N,LDX,LDA
      REAL*8 OFUN(N)
      COMPLEX*16 XMAT(LDX,N,3),XAUX(LDX,N,*)
C local
      INTEGER I,J,K
      REAL*8 GC
C     ==--------------------------------------------------------------==
      DO I=1,N
        DO K=1,NW
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WANNIER_FORCE(N,GMAT,AMAT,LDA,XMAT,XAUX,LDX,NW,W,TAG)
C     ==--------------------------------------------------------------==
C     == CALCULATES THE GRADIENT OF THE LOCALIZATION FUNCTIONAL       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C input
      REAL*8 W(*)
      INTEGER NW,N,LDX,LDA
      REAL*8 GMAT(LDA,N),AMAT(LDA,N)
      COMPLEX*16 XMAT(LDX,N,3),XAUX(LDX,N,*)
      CHARACTER*(*) TAG
C local
      INTEGER I,J,K
      REAL*8 GC
C     ==--------------------------------------------------------------==
      CALL AZZERO(GMAT,LDA*N)
      IF(TAG.EQ.'ZERO') THEN
      ELSEIF(TAG.EQ.'FULL') THEN
        DO K=1,NW
          GC=W(K)
          IF(K.LE.3) THEN
            DO I=1
              DO J=I,N
                GMAT(J,I)=GMAT(J,I)-GC*DREAL(DCONJG(XMAT(J,J,K)
     &                                       -XMAT(I,I,K))*XMAT(I,J,K))
              ENDDO
            ENDDO
          ELSE
            DO I=1
              DO J=I,N
                GMAT(J,I)=GMAT(J,I)-GC*DREAL(DCONJG(XAUX(J,J,K)
     &                                       -XAUX(I,I,K))*XAUX(I,J,K))
              ENDDO
            ENDDO
          ENDIF
        ENDDO
        DO I=1
          DO J=I,N
            GMAT(I,J)=GMAT(J,I)
          ENDDO
        ENDDO
      ELSE
        CALL STOPGM('WANNIER_FORCE','UNKNOWN TAG')
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
