C     ==================================================================
      SUBROUTINE WANNIER_CENTER(XYZMAT,LDX,NSTATE,CENTER,TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'wann.inc'
      INCLUDE 'metr.inc'
      INCLUDE 'store.inc'
      INCLUDE 'hfx.inc'
      INTEGER    LDX,NSTATE
      REAL*8     CENTER(4,NSTATE),TAU0(*)
CRV----quadrupole------------
      REAL*8     QUADRUPOLE(6,NSTATE)
CRV----quadrupole------------
      COMPLEX*16 XYZMAT(LDX,LDX,NWANOPT)
C     ==--------------------------------------------------------------==
      INTEGER    I,K,L,ISTEP,MSGLEN
      REAL*8     FUNCV,XMATRE,XMATIM,YMATRE,YMATIM,ZMATRE,ZMATIM
      REAL*8     PI,PI24,PHASEX,PHASEY,PHASEZ,WSUM
      REAL*8     S(3)
C     ==--------------------------------------------------------------==
      INTEGER    LCOUNTER
      SAVE       LCOUNTER
      DATA       LCOUNTER /0/
C     ==--------------------------------------------------------------==
      LCOUNTER = LCOUNTER +1
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        PI=DACOS(-1.D0)
        PI24=4.D0*PI*PI
        DO I=1,NSTATE
          IF(W_TYPE.EQ.1) THEN
            FUNCV=0.D0
            WSUM=0.D0
            DO K=1,NWANOPT
              FUNCV=FUNCV+
     *          WWEI(K)*(DREAL(DCONJG(XYZMAT(I,I,K))*XYZMAT(I,I,K)))
              WSUM=WSUM+WWEI(K)
            ENDDO
            CENTER(4,I)=DSQRT((WSUM-FUNCV)/PI24)
          ELSE
            FUNCV=0.D0
            DO K=1,NWANOPT
                FUNCV=FUNCV-
     *          WWEI(K)*DLOG(DREAL(DCONJG(XYZMAT(I,I,K))*XYZMAT(I,I,K)))
            ENDDO
            CENTER(4,I)=DSQRT(FUNCV/PI24)
          ENDIF
CRV----quadrupole------------
          DO L=1,6
            FUNCV=0.D0
            DO K=1,NWANOPT
                FUNCV=FUNCV-
     *      WQUADI(L,K)*DLOG(DREAL(DCONJG(XYZMAT(I,I,K))*XYZMAT(I,I,K)))
            ENDDO
            QUADRUPOLE(L,I)=FUNCV/PI24
          ENDDO
CRV----quadrupole------------
          XMATRE=DREAL(XYZMAT(I,I,1))
          XMATIM=DIMAG(XYZMAT(I,I,1))
          PHASEX=DATAN(XMATIM/XMATRE)
          IF(XMATRE.LT.0.D0) PHASEX=PHASEX+PI
          S(1)=-PHASEX/2.D0/PI
          YMATRE=DREAL(XYZMAT(I,I,2))
          YMATIM=DIMAG(XYZMAT(I,I,2))
          PHASEY=DATAN(YMATIM/YMATRE)
          IF(YMATRE.LT.0.D0) PHASEY=PHASEY+PI
          S(2)=-PHASEY/2.D0/PI
          ZMATRE=DREAL(XYZMAT(I,I,3))
          ZMATIM=DIMAG(XYZMAT(I,I,3))
          PHASEZ=DATAN(ZMATIM/ZMATRE)
          IF(ZMATRE.LT.0.D0) PHASEZ=PHASEZ+PI
          S(3)=-PHASEZ/2.D0/PI
C PBC the centers in the unit box
          S(1)=S(1)-DNINT(S(1))
          S(2)=S(2)-DNINT(S(2))
          S(3)=S(3)-DNINT(S(3))
C hit with HMAT
          CALL DGEMV('T',3,3,1.0D0,HT,3,S,1,0.0D0,CENTER(1,I),1)
C SUBTRACT OFF REFERENCE
          CENTER(1,I)=CENTER(1,I)-W_REF(1)
          CENTER(2,I)=CENTER(2,I)-W_REF(2)
          CENTER(3,I)=CENTER(3,I)-W_REF(3)
        ENDDO
        ISTEP=NPDIP*LCOUNTER
        CALL WC_TRAJECTORY(ISTEP,CENTER,QUADRUPOLE,TAU0,NSTATE)
        ISTEP=MOD(NPDIP*LCOUNTER,IPRINT_STEP)
        IF(IPRINT(IPRINT_WANN).EQ.1.AND.ISTEP.LT.NPDIP) THEN
          WRITE(6,'(/,1X,64("*"))')
          WRITE(6,'(" *",12X,A,18X,A,1X,"*")')
     *   ' WANNIER CENTERS  ','<X^2> - <X>^2'
          WRITE(6,'(1X,64("*"))')
          DO I=1,NSTATE
            WRITE(6,'(3F12.4,17X,F12.4)')
     *         CENTER(1,I),CENTER(2,I),CENTER(3,I),CENTER(4,I)
          ENDDO
          WRITE(6,'(1X,64("*"),/)')
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TWSCR) THEN
        IF(LCOUNTER.EQ.1) THEN
          CALL MEMORY(IP_WCENTX,4*NSTATE,"WCENTX")
        ENDIF
        IF(PARENT) CALL DCOPY(4*NSTATE,CENTER,1,WCENTX,1)
        MSGLEN = 4*NSTATE * 8
        CALL MY_BCAST(WCENTX,MSGLEN,SOURCE,ALLGRP)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WC_TRAJECTORY(ISTEP,CENTER,QUADRUPOLE,TAU0,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'ions.inc'  ! cmb
      INCLUDE 'wann.inc'  ! cmb
      INCLUDE 'ropt.inc'  ! cmb
      INCLUDE 'cnst.inc'  ! cmb
      INCLUDE 'adat.inc'  ! cmb
      INCLUDE 'response_p.inc'  ! dsebasti, for nmr_threads
      INCLUDE 'store.inc' ! AK: for ROUT/XTOUT
      INCLUDE 'fileopen.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'cdft.inc'
      INTEGER  ISTEP,NSTATE
      REAL*8   TAU0(3,NAX,*)
      REAL*8   CENTER(4,NSTATE),XX,YY,ZZ,X,Y,Z
      REAL*8   QUADRUPOLE(6,*)
      CHARACTER  FILEN*30
C     ==--------------------------------------------------------------==
      REAL*8   GR_TAU(3,*)
      INTEGER  GR_IAT(*)
      POINTER  (IP_GR_TAU,GR_TAU),(IP_GR_IAT,GR_IAT)
      LOGICAL FERROR
      INTEGER I,J,IA,IS
      INTEGER IF1,IF2
      DATA    IF1,IF2 /FO_VERB,FO_VMARK/
      SAVE    IF1,IF2
C     ==--------------------------------------------------------------==
c dsebasti
      if (TNMR) then
        if (.NOT. nmr_superparent) return
      endif
      if (TEPR) return

C write only if commensurate with SAMPLE value.
      IF(MOD(NFI-1,NPDIP).NE.0) RETURN

c dsebasti
C AK 2005/06/23: follow the output format selection scheme
C                for the trajectory files. i.e. write a
C                WANNIER_CENTER file, only if a TRAJECTORY is written...
      IF(ROUT.OR.XTOUT.OR.DCOUT) THEN
        CALL FILEOPEN(4,'WANNIER_CENTER',FO_APP+IF2,FERROR)
        DO I=1,NSTATE
          WRITE(4,'(I7,3F18.8,F12.6)') NFI,(CENTER(J,I),J=1,4)
        ENDDO
        CALL FILECLOSE(4)
c stores the quadrupole
        CALL FILEOPEN(84,'WC_QUAD',FO_APP+IF2,FERROR)
        DO I=1,NSTATE
           WRITE(84,'(I7,x,6F14.6)') NFI,(QUADRUPOLE(J,I),J=1,6)
        ENDDO
        CALL FILECLOSE(84)
        IF2=0
      ENDIF
C AK 2005/06/23: FIXME: for the time being always write IONS+CENTERS.xyz 
C                       in the long run this should be coupled to XTOUT.
C
C     write file "IONS+CENTERS" like in version 3.0 
C     change of format to XYZ
      IF(THDA)THEN
        IF(HDAFIRST)THEN
          FILEN='IONS+CENTERS-S1.xyz'
        ELSE
          FILEN='IONS+CENTERS-S2.xyz'
        ENDIF
      ELSE
        FILEN='IONS+CENTERS.xyz'
      ENDIF
      CALL FILEOPEN(44,FILEN,FO_APP+IF1,FERROR)
      WRITE(44,*) NAT+NSTATE
      WRITE(44,*) NFI

      DO IS=1,NSP
        DO IA=1,NA(IS)
cmb Set the ions according to WFCs reference and apply pbc
cjh always apply pbc, even for isolated systems
cak ...and then shift back to the original position.
          XX=TAU0(1,IA,IS)-W_REF(1)
          YY=TAU0(2,IA,IS)-W_REF(2)
          ZZ=TAU0(3,IA,IS)-W_REF(3)
          CALL PBC3(XX,YY,ZZ,X,Y,Z,1,APBC,IBRAV)
          X=X+W_REF(1)-MM_C_TRANS(1)
          Y=Y+W_REF(2)-MM_C_TRANS(2)
          Z=Z+W_REF(3)-MM_C_TRANS(3)
          WRITE(44,'(A4,3F18.8)') EL(IATYP(IS)), 
     *         X/FBOHR, Y/FBOHR, Z/FBOHR
        ENDDO
      ENDDO
      DO I=1,NSTATE
        CALL PBC3(CENTER(1,I),CENTER(2,I),CENTER(3,I),
     *              X,Y,Z,1,APBC,IBRAV)
        X=X+W_REF(1)-MM_C_TRANS(1)
        Y=Y+W_REF(2)-MM_C_TRANS(2)
        Z=Z+W_REF(3)-MM_C_TRANS(3)
        WRITE(44,'(A4,3F18.8)') "X", X/FBOHR, Y/FBOHR, Z/FBOHR
      ENDDO
      CALL FILECLOSE(44)
C store the spread for the case we have only the .xyz files.
      CALL FILEOPEN(4,'WC_SPREAD',FO_APP+IF1,FERROR)
      WRITE (4,'(2I8)') NFI, NSTATE
      WRITE(4,'(6F12.6)') (CENTER(4,I),I=1,NSTATE)
      CALL FILECLOSE(4)
      IF1=0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
