C     ==================================================================
      SUBROUTINE WANNIER_PRINT(INFI,C0,TAU0,NSTATE,PSI,SCR,LSCR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'wann.inc'
      INCLUDE 'fft.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cppt.inc'
      INTEGER    INFI,LSCR,NSTATE
      COMPLEX*16 C0(NGW,*),PSI(*)
      REAL*8     SCR(LSCR),TAU0(*)
C     ==--------------------------------------------------------------==
      CHARACTER  FILEN*25,FILBOD*25,FILTR*25,NUMB*8
      INTEGER    I,NO,ORBPRI(*),IA,IE,IR,IG,MSGLEN
      POINTER    (IP_ORBPRI,ORBPRI)
      REAL*8     CENTERS(4,NSTATE)
      POINTER    (IP_CENTERS,CENTERS)
      INTEGER    IFIRST,I1,I2
      SAVE       IFIRST,IP_ORBPRI
      DATA       IFIRST /0/
C     ==--------------------------------------------------------------==
      IF(TWPRI) THEN
        IF(IFIRST.EQ.0) THEN
          NO=NSTATE/IRAT+1
          CALL MEMORY(IP_ORBPRI,NO,'ORBPRI')
          CALL IAZZERO(ORBPRI,NSTATE)
          IF(SW_ALL.NE.0) THEN
            DO I=1,NSTATE
              ORBPRI(I)=1
            ENDDO
          ELSEIF(SW_FIRST.GT.0) THEN
            DO I=SW_FIRST,SW_LAST
              ORBPRI(I)=1
            ENDDO
          ELSEIF(SW_ORB.GT.0) THEN
            DO I=1,SW_ORB
              ORBPRI(SW_LIST(I))=1
            ENDDO
          ENDIF
          IFIRST=1
        ENDIF
C spread dependent printing needs to be re-initialized every step.
C the information about the center location and their spread is 
C still in the scratch array (provided WANNIER_CENTER() was called
C right before this (happens in DDIPO() and LOCALIZE())
        IF(DABS(SW_SPREAD).GT.0.001d0) THEN
          CALL GET_ADDR(IP_CENTERS,SCR(1))
          CALL IAZZERO(ORBPRI,NSTATE)
          DO I=1,NSTATE
            IF((SW_SPREAD.GT.0.0d0).AND.(CENTERS(4,I).GT.SW_SPREAD))
     &          ORBPRI(I)=1
            IF((SW_SPREAD.LT.0.0d0).AND.(CENTERS(4,I).LT.SW_SPREAD))
     &          ORBPRI(I)=1
          ENDDO
          MSGLEN = NSTATE * 8/IRAT
          CALL MY_BCAST(ORBPRI(1),MSGLEN,SOURCE,ALLGRP)
        ENDIF
        IF(MOD(INFI-1,NS_WANN*NPDIP).EQ.0) THEN
          IF(PARENT) THEN
            FILTR='WANNIER_'
            WRITE(NUMB,'(I8)') INFI
            CALL XSTRING(NUMB,IA,IE)
            FILBOD=FILTR(1:8)//NUMB(IA:IE)
          ENDIF
          DO I=1,NSTATE
            IF(ORBPRI(I).NE.0) THEN
              IF(PARENT) THEN
                WRITE(NUMB,'(I8)') I
                CALL XSTRING(NUMB,IA,IE)
                CALL XSTRING(FILBOD,I1,I2)
                FILEN=FILBOD(I1:I2)//'.'//NUMB(IA:IE)
              ENDIF
              IF(TSDENS) THEN
                CALL ZAZZERO(PSI,MAXFFT)
C$OMP parallel do private(IG)
!CDIR NODEP
                DO IG=1,NGW
                  PSI(NZHS(IG))=C0(IG,I)
                  PSI(INDZS(IG))=DCONJG(C0(IG,I))
                ENDDO
                CALL S_INVFFT(PSI)
C$OMP parallel do private(IR)
                DO IR=1,NNR1
                  PSI(IR)=PSI(IR)*PSI(IR)
                ENDDO
                CALL FWFFT(PSI)
C$OMP parallel do private(IG)
                DO IG=1,NHG
                  SCR(2*IG-1)=DREAL(PSI(NZH(IG)))
                  SCR(2*IG-0)=DIMAG(PSI(NZH(IG)))
                ENDDO
              ELSE
                CALL AZZERO(SCR,2*NHG)
                CALL DCOPY(2*NGW,C0(1,I),1,SCR,1)
              ENDIF
              CALL DENSTO(SCR,TAU0,FILEN)
            ENDIF
          ENDDO
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
