C     ==================================================================
      SUBROUTINE WC_DOS(C0,C2,SCR,LSCR,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'geq0.inc'
      include 'wann.inc'
      include 'spin.inc'
      include 'fileopen.inc'
      include 'cnst.inc'
C PRINT ORBITALS
      include 'cppt.inc'
      include 'coor.inc'
      include 'ions.inc'
      include 'fft.inc'
C SPHERICAL ANALYSIS
      include 'prop.inc'
C INPUT 
      REAL*8 SCR(*)
      COMPLEX*16 C0(NGW,*),C2(NGW,*)
      INTEGER LSCR,NSTATE
C LOCAL 
      INTEGER LHMAT,LAUX,NX,INFO,I,J
      POINTER(IP_HMAT,HMAT),(IP_AUX,AUX) 
      POINTER(IP_W,W)
      REAL*8 HMAT(NSTATE,NSTATE),AUX(12*NSTATE),W(NSTATE)
c USING SPREAD SORTING
      INTEGER IM,IMIN,K1,K2,MSGLEN,ISP,NNAT,IAT,NLSCR,
     &  K,IM_A,IMIN_A,IM_B,IMIN_B,IL_PSI,IL_RHOE,
     &  LAST_C2, IND_C4
      REAL*8 MINIM,S
      POINTER (IP_HMAT2,HMAT2),(IP_IND,IND),
     &     (IP_SPREAD,SPREAD),(IP_C3,C3),
     &     (IP_PSI,PSI),(IP_NEWSCR,NEWSCR),
     &     (IP_C4,C4)
      INTEGER IND(NSTATE)
      COMPLEX*16 C3(NGW,*), PSI(*), C4(NGW,*)
      REAL*8 HMAT2(NSTATE,NSTATE), SPREAD(*),
     &       CENTER(3),NEWSCR(*)
      INTEGER FIND_MIN
      CHARACTER  TAG*30, NAME*10
      LOGICAL HARM_WAN
c USING SPREAD SORTING
      LOGICAL DEBUG,FERROR
      INTEGER IF1
      DATA    IF1 /FO_VERB/
      SAVE    IF1
C     ==--------------------------------------------------------------==
      LHMAT=NSTATE*NSTATE
      LAUX=12*NSTATE
      IF(HMAT_SPREAD)THEN
         IF(MINSPR.GT.0.0D0)THEN
            HARM_WAN=.FALSE.
         ELSE
           IF(PARENT)THEN
             WRITE(6,*)' PREPARATION FOR HARMONIC ANALYSIS'
           ENDIF
           HARM_WAN=.TRUE.
           MINSPR=-MINSPR
         ENDIF
         IF(PARENT)THEN
           WRITE(6,*) 'ORDER HAMILTONIAN WITH SPREAD'       
           WRITE(6,'(A,F10.5)') ' MINIMAL SPREAD =', MINSPR
         ENDIF
         CALL MEMORY(IP_SPREAD,NSTATE,'SPREAD')
         J=4
         DO I=1,NSTATE
            SPREAD(I)=SCR(J)
            J=J+4
         ENDDO
         MSGLEN=8*NSTATE
         CALL MY_BCAST(SPREAD,MSGLEN,SOURCE,ALLGRP)
      ENDIF
      DEBUG=.FALSE.
      CALL SCRSET(SCR,LSCR,DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_HMAT,LHMAT,'HMAT',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_AUX,LAUX,'AUX',DEBUG)
      CALL SCRPTR(SCR,LSCR,IP_W,NSTATE,'W',DEBUG)
      CALL OVLAP(NSTATE,HMAT,C0,C2)
      CALL GLOSUM(NSTATE*NSTATE,HMAT)
      IF (PARENT) THEN
         CALL FILEOPEN(40,'WANNIER_HAM',FO_APP+IF1,FERROR)
         DO I=1,NSTATE
            WRITE(40,*)(HMAT(I,J)*(-1.0D0*RY),J=1,NSTATE)
         ENDDO
         CALL FILECLOSE(40)
      ENDIF
              
      IF(HMAT_SPREAD)THEN
        CALL MEMORY(IP_IND,NSTATE,'IND')
        CALL MEMORY(IP_HMAT2,NSTATE*NSTATE,'HMAT2')
        DO I=1,NSTATE
          IND(I)=I
        ENDDO
        IF(TLSD)THEN
          CALL SORT_M(SPREAD(1),NSUP,IND(1)) 
          CALL SORT_M(SPREAD(1),NSDOWN,IND(NSUP+1)) 
        ELSE
          CALL SORT_M(SPREAD(1),NSTATE,IND(1))
        ENDIF
C       ordered hamiltonian   
        DO I=1,NSTATE
          DO J=1,NSTATE
            HMAT2(I,J)=HMAT(IND(I),IND(J))
          ENDDO
        ENDDO
C       check energy
        IF(PARENT)THEN
          S=0.0d0
          DO I=1,NSTATE
            S=S+HMAT(I,I)
	  ENDDO
          IF(PARENT)THEN 
            WRITE(6,'(A,F14.6)')' ENERGY BEFORE',S
          ENDIF
	ENDIF 
                 
        IF(PARENT)THEN 
          CALL FILEOPEN(30,'WANNIER_HAM_SPREAD_ORDERED',
     &                                 FO_APP+IF1,FERROR)
          DO I=1,NSTATE
             WRITE(30,*)(HMAT2(I,J),J=1,NSTATE)
          ENDDO
          CALL FILECLOSE(30)
        ENDIF

        IF(TLSD)THEN
	  IMIN=FIND_MIN(SPREAD(1),IND(1),NSUP,MINSPR)
          IM=NSUP-IMIN
          IMIN=IMIN+1
          IMIN_A=IMIN
          IM_A=IM
          IF(PARENT)THEN
             WRITE(6,'(1X,A,I6)') 
     &       'NUMBER OF ALPHA WAVEFUNCTIONS WITH HIGH SPREAD',IM_A
             WRITE(6,'(1X,A,I6,A,I6)') 'FROM ',IMIN_A,' TO ',NSUP
          ENDIF
          IF(IM.LE.0) STOP 'NO FUNCTIONS WITH SUCH SPREAD'
c         find eigenvectors of w.f. with not large spread
          CALL DSYEV('V','U',NSUP-IM,HMAT2(1,1),NSTATE,W(1),AUX,
     &                                                  LAUX,INFO) 
          IF(INFO.NE.0) CALL STOPGM(' WANNIER_DOS',
     &    ' DIAGONALIZATION OF ALPHA STATES WITH SMALL SPREAD FAILED ')
c         find eigenvectors of w.f. with large spread 
          CALL DSYEV('V','U',IM,HMAT2(IMIN,IMIN),NSTATE,W(IMIN),AUX,
     &                                                     LAUX,INFO) 
          IF(INFO.NE.0) CALL STOPGM(' WANNIER_DOS',
     &    ' DIAGONALIZATION OF ALPHA STATES WITH LARGE SPREAD FAILED ')
	  IMIN=FIND_MIN(SPREAD(1),IND(NSUP+1),NSDOWN,MINSPR)
          IM=NSDOWN-IMIN
          IMIN=IMIN+1+NSUP
          IMIN_B=IMIN
          IM_B=IM
          IF(PARENT)THEN
             WRITE(6,'(1X,A,I6)') 
     &       'NUMBER OF BETA  WAVEFUNCTIONS WITH HIGH SPREAD',IM_B
             WRITE(6,'(1X,A,I6,A,I6)') 'FROM ',IMIN_B,' TO ',NSTATE
          ENDIF
          IF(IM.LE.0) STOP 'NO FUNCTIONS WITH SUCH SPREAD'
c         find eigenvectors of w.f. with not large spread
          I=NSUP+1
          CALL DSYEV('V','U',NSDOWN-IM,HMAT2(I,I),NSTATE,W(I),AUX,
     &                                                  LAUX,INFO) 
          IF(INFO.NE.0) CALL STOPGM(' WANNIER_DOS',
     &    ' DIAGONALIZATION OF BETA STATES WITH SMALL SPREAD FAILED ')
c         find eigenvectors of w.f. with large spread 
          CALL DSYEV('V','U',IM,HMAT2(IMIN,IMIN),NSTATE,W(IMIN),AUX,
     &                                                     LAUX,INFO) 
          IF(INFO.NE.0) CALL STOPGM(' WANNIER_DOS',
     &    ' DIAGONALIZATION OF BETA STATES WITH LARGE SPREAD FAILED ')
        ELSE
	  IMIN=FIND_MIN(SPREAD(1),IND(1),NSTATE,MINSPR)
          IM=NSTATE-IMIN
          IF(PARENT)THEN
             WRITE(6,'(1X,A,I6)') 'NUMBER OF WAVEFUNCTIONS  WITH HIGH' 
     &           // ' SPREAD', IM
          ENDIF
          IMIN=IMIN+1
          IF(IM.LE.0) STOP 'NO FUNCTIONS WITH SUCH SPREAD'
c         find eigenvectors of w.f. with not large spread
          CALL DSYEV('V','U',NSTATE-IM,HMAT2(1,1),NSTATE,W(1),AUX,
     &                                                  LAUX,INFO) 
          IF(INFO.NE.0) CALL STOPGM(' WANNIER_DOS',
     &         ' DIAGONALIZATION OF STATES WITH SMALL SPREAD FAILED ')
c         find eigenvectors of w.f. with large spread 
          CALL DSYEV('V','U',IM,HMAT2(IMIN,IMIN),NSTATE,W(IMIN),AUX,
     &                                                     LAUX,INFO) 
          IF(INFO.NE.0) CALL STOPGM(' WANNIER_DOS',
     &         ' DIAGONALIZATION OF STATES WITH LARGE SPREAD FAILED ')
        ENDIF 
            
C       check energy
        IF(PARENT)THEN
          S=0.0d0
          DO I=1,NSTATE
            S=S+W(I)
	  ENDDO
          IF(PARENT)THEN 
            WRITE(6,'(A,F14.6)')' ENERGY AFTER',S
          ENDIF
        ENDIF
        
        IF(PARENT)THEN
           CALL FILEOPEN(30,'WANNIER_DOS_SPREAD',FO_APP+IF1,FERROR)
           WRITE(30,*)(W(J),J=1,NSTATE)
           DO I=1,NSTATE
               WRITE(30,*)(HMAT2(I,J),J=1,NSTATE)
           ENDDO
           CALL FILECLOSE(30)
        ENDIF

        IF(PARENT)THEN
          WRITE(6,'(1X,A)')  'PLOT WAVEFUNCTIONS'
          IF(TLSD)THEN
            WRITE(6,'(A,I6)') ' NUMBER OF ALPHA STATES', IM_A
            WRITE(6,'(A,I6)') ' NUMBER OF BETA  STATES',  IM_B
          ELSE
            WRITE(6,'(A,I6)') ' NUMBER OF STATES',IM
          ENDIF
        ENDIF

C       PLOT WAVEFUNCTIONS WITH HIGH SPREAD 
        CENTER(1) = 0D0
        CENTER(2) = 0D0
        CENTER(3) = 0D0
        NNAT = 0
        DO ISP=1,NSP
           DO IAT=1,NA(ISP)
              CENTER(1) = CENTER(1) + TAU0(1,IAT,ISP)
              CENTER(2) = CENTER(2) + TAU0(2,IAT,ISP)
              CENTER(3) = CENTER(3) + TAU0(3,IAT,ISP)
              NNAT = NNAT + 1
           ENDDO
        ENDDO
        CENTER(1) =  CENTER(1) / DBLE(NNAT)
        CENTER(2) =  CENTER(2) / DBLE(NNAT)
        CENTER(3) =  CENTER(3) / DBLE(NNAT)
        
        CALL MEMORY(IP_C3,2*NGW*NSTATE,'C3')
        CALL MEMORY(IP_C4,2*NGW*NSTATE,'C4')
        CALL RHOE_PSI_SIZE(IL_RHOE,IL_PSI)
        NLSCR=2*MAXFFT
        CALL MEMORY(IP_NEWSCR,NLSCR,'NEWSCR')
        CALL AZZERO(NEWSCR,NLSCR)
        CALL MEMORY(IP_PSI,IL_PSI,'PSI')
        CALL AZZERO(PSI,IL_PSI)
C       PRINT ALL STATES WITH HIGH SPREAD
        IF(TLSD)THEN
           IMIN=IMIN_A
           IM=IM_A
           J=IMIN
           DO I=1,IM
              CALL DCOPY(2*NGW,C0(1,IND(J)),1,C3(1,I),1)
              J=J+1
           ENDDO
           CALL DGEMM('N','N',2*NGW,IM,IM,1.0D0,C3,2*NGW,
     &             HMAT2(IMIN,IMIN),NSTATE,0.0D0,C2,2*NGW)
	   NAME='WANALPHIGH'
           IF(.NOT.HARM_WAN)THEN
              CALL PLOT_STATES(C2,CENTER,IM,NAME,PSI,NEWSCR)
           ELSE
             IF(PARENT)THEN
               WRITE(6,*) 'ALPHA STATES'
             ENDIF
             IND_C4=1
             CALL DCOPY(2*IM*NGW,C2(1,1),1,C4(1,IND_C4),1) 
             IND_C4=IND_C4+IM
           ENDIF 
           IMIN=IMIN_B
           IM=IM_B       
           J=IMIN
           DO I=1,IM
              CALL DCOPY(2*NGW,C0(1,IND(J)),1,C3(1,I),1)
              J=J+1
           ENDDO
           CALL DGEMM('N','N',2*NGW,IM,IM,1.0D0,C3,2*NGW,
     &             HMAT2(IMIN,IMIN),NSTATE,0.0D0,C2,2*NGW)
	   NAME='WNBETAHIGH'
           IF(.NOT.HARM_WAN)THEN
              CALL PLOT_STATES(C2,CENTER,IM,NAME,PSI,NEWSCR)
           ELSE
             IF(PARENT)THEN
               WRITE(6,*) 'BETA STATES'
             ENDIF
             CALL DCOPY(2*IM*NGW,C2(1,1),1,C4(1,IND_C4),1)
             IND_C4=IND_C4+IM 
           ENDIF
        ELSE
           J=IMIN
           DO I=1,IM
              CALL DCOPY(2*NGW,C0(1,IND(J)),1,C3(1,I),1)
              J=J+1
           ENDDO           
           CALL DGEMM('N','N',2*NGW,IM,IM,1.0D0,C3,2*NGW,
     & 	           HMAT2(IMIN,IMIN),NSTATE,0.0D0,C2,2*NGW)
           NAME='WANNHIGHPS'
           IF(.NOT.HARM_WAN)THEN
             CALL PLOT_STATES(C2,CENTER,IM,NAME,PSI,NEWSCR)
           ELSE
             IND_C4=1
             CALL DCOPY(2*IM*NGW,C2(1,1),1,C4(1,IND_C4),1) 
 	     IND_C4=IND_C4+IM
           ENDIF
        ENDIF
        IF(.NOT.HARM_WAN)THEN
C       PRINT ALL STATES WITH LOW SPREAD
        IF(TLSD)THEN
           IMIN=IMIN_A
           IM=IM_A
           J=1
           K=IMIN-1
           DO I=1,K
              CALL DCOPY(2*NGW,C0(1,IND(J)),1,C3(1,I),1)
              J=J+1
           ENDDO
	   J=1
           CALL DGEMM('N','N',2*NGW,K,K,1.0D0,C3,2*NGW,
     &             HMAT2(J,J),NSTATE,0.0D0,C2,2*NGW)
	   NAME='WANALPHLOW'
           CALL PLOT_STATES(C2,CENTER,K,NAME,PSI,NEWSCR)
           IMIN=IMIN_B
           IM=IM_B       
           J=NSUP+1
	   K=IMIN-1-NSUP
           DO I=1,K
              CALL DCOPY(2*NGW,C0(1,IND(J)),1,C3(1,I),1)
              J=J+1
           ENDDO
           J=NSUP+1
           CALL DGEMM('N','N',2*NGW,K,K,1.0D0,C3,2*NGW,
     &             HMAT2(J,J),NSTATE,0.0D0,C2,2*NGW)
	   NAME='WANBETALOW'
           CALL PLOT_STATES(C2,CENTER,K,NAME,PSI,NEWSCR)
        ELSE
           J=1
	   K=IMIN-1
           DO I=1,K
              CALL DCOPY(2*NGW,C0(1,IND(J)),1,C3(1,I),1)
              J=J+1
           ENDDO           
	   J=1
           CALL DGEMM('N','N',2*NGW,K,K,1.0D0,C3,2*NGW,
     & 	           HMAT2(J,J),NSTATE,0.0D0,C2,2*NGW)
           NAME='WANNLOWPSI'
           CALL PLOT_STATES(C2,CENTER,K,NAME,PSI,NEWSCR)
        ENDIF
        ENDIF
        CALL FREEM(IP_PSI) 
        CALL FREEM(IP_NEWSCR) 
        CALL FREEM(IP_C3)
        CALL FREEM(IP_HMAT2)
        CALL FREEM(IP_IND) 
        CALL FREEM(IP_SPREAD)        
      ENDIF
      
      IF(PARENT)THEN
         WRITE(6,'(A)') ' CALCULATE WANNIER FUNCTION PROJECTED DOS'
         IF (TLSD) THEN
            NX=NSUP+1
            CALL DSYEV('V','U',NSUP,HMAT(1,1),NSTATE,W(1),AUX,LAUX,INFO) 
            IF(INFO.NE.0) CALL STOPGM(' WANNIER_DOS',
     &           ' DIAGONALIZATION OF UP STATES FAILED ')
            CALL DSYEV('V','U',NSDOWN,HMAT(NX,NX),NSTATE,W(NX),AUX,
     &           LAUX,INFO) 
            IF(INFO.NE.0) CALL STOPGM(' WANNIER_DOS',
     &           ' DIAGONALIZATION OF DOWN STATES FAILED ')
         ELSE
            CALL DSYEV('V','U',NSTATE,HMAT,NSTATE,W,AUX,LAUX,INFO) 
            IF(INFO.NE.0) CALL STOPGM(' WANNIER_DOS',
     &           ' DIAGONALIZATION FAILED ')
         ENDIF
         CALL FILEOPEN(30,'WANNIER_DOS',FO_APP+IF1,FERROR)
         WRITE(30,*)(W(J),J=1,NSTATE)
         DO I=1,NSTATE
            WRITE(30,*)(HMAT(I,J),J=1,NSTATE)
         ENDDO
         CALL FILECLOSE(30)
      ENDIF

      IF(HMAT_SPREAD.AND.HARM_WAN)THEN      
        CALL PROYLM(C4,CENTYLM,NUMYLM,IND_C4-1,RYLMAX,NYLMAX)
        PYLM=.FALSE.
        CALL FREEM(IP_C4)
      ENDIF
      IF1=0
      CALL SCRREL(SCR,LSCR,DEBUG)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
  
      SUBROUTINE SORT_M(SPREAD,N,IND)
      IMPLICIT NONE
C     Arguments
      INTEGER N 
      INTEGER IND(N)
      REAL*8  SPREAD(N)
C     Variables
      INTEGER I,J,IM,TEMP
      REAL*8 MINIM 

      DO I=1,N-1
         MINIM=SPREAD(IND(I))
         IM=I
         DO J=I,N
            IF(SPREAD(IND(J))<MINIM)THEN
               MINIM=SPREAD(IND(J))
               IM=J
            ENDIF
         ENDDO
         TEMP=IND(I)
         IND(I)=IND(IM)
         IND(IM)=TEMP
      ENDDO
            
      RETURN
      END

      SUBROUTINE PLOT_STATES(C2,CENTER,IM,TAG,PSI,NEWSCR)
      IMPLICIT NONE
      include 'system.h'
C     Arguments
      INTEGER IM
      REAL*8 CENTER(3),NEWSCR(*)
      COMPLEX*16 C2(NGW,*),PSI(*)    
      CHARACTER*10 TAG
C     Variables
      INTEGER I
      CHARACTER*128 FILENAME
 
      DO I=1,IM
         CALL FFTtoR(C2(1,I),NEWSCR,PSI,NGW,.TRUE.)
         WRITE(FILENAME,'(A10,I5.5,A5)')
     &        TAG,I,'.cube'
         CALL CUBEFILE(FILENAME,NEWSCR,CENTER,PSI,.TRUE.)
      END DO
      
      RETURN
      END 

      INTEGER FUNCTION FIND_MIN(SPREAD,IND,N,MINSPR)
      IMPLICIT NONE
c     Arguments
      INTEGER N, IND(N)
      REAL*8  MINSPR,SPREAD(N)	
c     Variables
      INTEGER I,IMIN	
      IMIN=0
      DO I=1,N
        IF(SPREAD(IND(I))<MINSPR)THEN
          IMIN=I
        ENDIF  
      ENDDO
      FIND_MIN=IMIN 
      RETURN
      END





