C     ==================================================================
      SUBROUTINE WFN_PRINT(INFI,C0,NSTATE,PSI)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'g_loc.inc'
      INCLUDE 'fileopen.inc'
C     ==--------------------------------------------------------------==
      INTEGER    NSTATE,INFI
      COMPLEX*16 C0(NGW,*)
      REAL*8     PSI(-KR1S/2:KR1S/2,-KR2S/2:KR2S/2,-KR3S/2:KR3S/2)
C     ==--------------------------------------------------------------==
      CHARACTER  FILEN*15,FILBOD*15,FILTR*15,NUMB*8
      INTEGER    I,J,K,NO,ORBPRI(*),IA,IE,IR,IG
      POINTER    (IP_ORBPRI,ORBPRI)
      INTEGER    IFIRST,I1,I2,ISTATE,NH1,NH2,NH3
      LOGICAL    FERROR
      SAVE       IFIRST,IP_ORBPRI
      DATA       IFIRST /0/
C     ==--------------------------------------------------------------==

      NH1=NR1S/2+1
      NH2=NR2S/2+1
      NH3=NR3S/2+1

      IF(IFIRST.EQ.0) THEN
        NO=NSTATE/IRAT+1
        CALL MEMORY(IP_ORBPRI,NO,'ORBPRI')
        CALL IAZZERO(ORBPRI,NSTATE)
        IF(GLOC_ALL.NE.0) THEN
         DO I=1,NSTATE
           ORBPRI(I)=1
         ENDDO
        ELSEIF(GLOC_FIRST.GT.0) THEN
         DO I=GLOC_FIRST,GLOC_LAST
          ORBPRI(I)=1
         ENDDO
        ELSEIF(GLOC_ORB.GT.0) THEN
         DO I=1,GLOC_ORB
          ORBPRI(GLOC_LIST(I))=1
         ENDDO
        ENDIF
        IFIRST=1
      ENDIF
      IF(PARENT) THEN
        FILTR='WFN_'
        WRITE(NUMB,'(I8)') INFI
        CALL XSTRING(NUMB,IA,IE)
        FILBOD=FILTR(1:4)//NUMB(IA:IE)
      ENDIF
      DO ISTATE=1,NSTATE
        IF(ORBPRI(ISTATE).NE.0) THEN
         IF(PARENT) THEN
          WRITE(NUMB,'(I8)') ISTATE
          CALL XSTRING(NUMB,IA,IE)
          CALL XSTRING(FILBOD,I1,I2)
          FILEN=FILBOD(I1:I2)//'.'//NUMB(IA:IE)
         ENDIF
         CALL AZZERO(PSI,KR1S*KR2S*KR3S)
         DO IG=1,NGW
         I=INYH(1,IG)-NH1
         J=INYH(2,IG)-NH2
         K=INYH(3,IG)-NH3
          PSI(I,J,K)=DREAL(C0(IG,ISTATE))*DREAL(C0(IG,ISTATE))+
     &          DIMAG(C0(IG,ISTATE))*DIMAG(C0(IG,ISTATE))
          PSI(-I,-J,-K)=DREAL(C0(IG,ISTATE))*DREAL(C0(IG,ISTATE))+
     &          DIMAG(C0(IG,ISTATE))*DIMAG(C0(IG,ISTATE))
         ENDDO
#ifdef PARALLEL
         CALL GLOSUM(KR1S*KR2S*KR3S,PSI)
#endif

         IF(PARENT) THEN
          CALL FILEOPEN(12,FILEN,FO_DEF,FERROR)
          write(12,'(A,/)') FILEN
          write(12,'(I4,3f10.4)') 1,0.0D0,0.0D0,0.0D0
          write(12,'(I4,3f10.4)') NR1S+1, 1.0D0,0.0D0,0.0D0
          write(12,'(I4,3f10.4)') NR2S+1, 0.0D0,1.0D0,0.0D0
          write(12,'(I4,3f10.4)') NR3S+1, 0.0D0,0.0D0,1.0D0

          write(12,'(I4,4f10.4)') 8, 0.0D0,DBLE(NR1S)/2.D0,
     &              DBLE(NR2S)/2.D0,DBLE(NR3S)/2.D0
          DO I = -NR1S/2,NR1S/2
            DO J =-NR2S/2,NR2S/2
              WRITE (12, '(6F15.7 )')  (PSI(I,J,K), 
     &                   K = -NR3S/2,NR3S/2 )
           END DO
          END DO
          CALL FILECLOSE(12)
         ENDIF
        ENDIF
      ENDDO


       
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

C     ==================================================================
      SUBROUTINE WFNZ_PRINT(INFI,IKIND,C0,NSTATE,PSI,NSTATE_LOC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'fft.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'g_loc.inc'
      INCLUDE 'fileopen.inc'
C     ==--------------------------------------------------------------==
      INTEGER    NSTATE,INFI,IKIND,NSTATE_LOC
      COMPLEX*16 C0(2*NGW,NSTATE)
      REAL*8     PSI(-KR1S/2:KR1S/2,-KR2S/2:KR2S/2,-KR3S/2:KR3S/2)
C     ==--------------------------------------------------------------==
      CHARACTER  FILEN*15,FILBOD*15,FILTR*15,NUMB*8
      INTEGER    I,J,K,NO,ORBPRI(*),IA,IE,IR,IG
      POINTER    (IP_ORBPRI,ORBPRI)
      INTEGER    IFIRST,I1,I2,ISTATE,NH1,NH2,NH3,ICONT
      SAVE       IFIRST,IP_ORBPRI
      DATA       IFIRST /0/
      LOGICAL    FERROR
      DIMENSION  IND_ST(NSTATE_LOC)
C     ==--------------------------------------------------------------==

      NH1=NR1S/2+1
      NH2=NR2S/2+1
      NH3=NR3S/2+1

      IF(IFIRST.EQ.0) THEN
        NO=NSTATE/IRAT+1
        CALL MEMORY(IP_ORBPRI,NO,'ORBPRI')
        CALL IAZZERO(ORBPRI,NSTATE)
        IF(GLOC_ALL.NE.0) THEN
         DO I=1,NSTATE
           ORBPRI(I)=1
         ENDDO
        ELSEIF(GLOC_FIRST.GT.0) THEN
         DO I=GLOC_FIRST,GLOC_LAST
          ORBPRI(I)=1
         ENDDO
        ELSEIF(GLOC_ORB.GT.0) THEN
         DO I=1,GLOC_ORB
          ORBPRI(GLOC_LIST(I))=1
         ENDDO
        ENDIF
        IFIRST=1
      ENDIF
      IF(PARENT) THEN
        FILTR='WFN_'
        WRITE(NUMB,'(I8)') INFI
        CALL XSTRING(NUMB,IA,IE)
        FILBOD=FILTR(1:4)//NUMB(IA:IE)
        IF(TG_COMPLEX) THEN
          CALL XSTRING(FILBOD,I1,I2)
          FILTR = FILBOD(I1:I2)
          WRITE(NUMB,'(I8)') IKIND
          CALL XSTRING(NUMB,IA,IE)
          CALL XSTRING(FILTR,I1,I2)
          FILBOD=FILTR(I1:I2)//'_k'//NUMB(IA:IE)
        ENDIF
      ENDIF
      DO ISTATE=1,NSTATE
        IF(ORBPRI(ISTATE).NE.0) THEN
         IF(PARENT) THEN
          WRITE(NUMB,'(I8)') ISTATE
          CALL XSTRING(NUMB,IA,IE)
          CALL XSTRING(FILBOD,I1,I2)
          FILEN=FILBOD(I1:I2)//'.'//NUMB(IA:IE)
         ENDIF
         CALL AZZERO(PSI,KR1S*KR2S*KR3S)
         DO IG=1,NGW
         I=INYH(1,IG)-NH1
         J=INYH(2,IG)-NH2
         K=INYH(3,IG)-NH3
          PSI(I,J,K)=DREAL(C0(IG,ISTATE))*DREAL(C0(IG,ISTATE))+
     &          DIMAG(C0(IG,ISTATE))*DIMAG(C0(IG,ISTATE))
          PSI(-I,-J,-K)=
     &          DREAL(C0(IG+NGW,ISTATE))*DREAL(C0(IG+NGW,ISTATE))+
     &          DIMAG(C0(IG+NGW,ISTATE))*DIMAG(C0(IG+NGW,ISTATE))
         ENDDO
#ifdef PARALLEL
         CALL GLOSUM(KR1S*KR2S*KR3S,PSI)
#endif
         IF(PARENT) THEN
          CALL FILEOPEN(12,FILEN,FO_DEF,FERROR)
          write(12,'(A,/)') FILEN
          write(12,'(I4,3f10.4)') 1,0.0D0,0.0D0,0.0D0
          write(12,'(I4,3f10.4)') NR1S+1, 1.0D0,0.0D0,0.0D0
          write(12,'(I4,3f10.4)') NR2S+1, 0.0D0,1.0D0,0.0D0
          write(12,'(I4,3f10.4)') NR3S+1, 0.0D0,0.0D0,1.0D0

          write(12,'(I4,4f10.4)') 8, 0.0D0,DBLE(NR1S)/2.D0,
     &              DBLE(NR2S)/2.D0,DBLE(NR3S)/2.D0

          DO I = -NR1S/2,NR1S/2
            DO J =-NR2S/2,NR2S/2
              WRITE (12, '(6F15.7 )')  (PSI(I,J,K), 
     &                   K = -NR3S/2,NR3S/2 )
           END DO
          END DO
          CALL FILECLOSE(12)
         ENDIF
        ENDIF
      ENDDO


      IF(PARENT) THEN
        WRITE(NUMB,'(A3)') 'TOT'
        CALL XSTRING(NUMB,IA,IE)
        CALL XSTRING(FILBOD,I1,I2)
        FILEN=FILBOD(I1:I2)//'.'//NUMB(IA:IE)
      ENDIF
      CALL AZZERO(PSI,KR1S*KR2S*KR3S)
      DO ICONT = 1,NSTATE_LOC
        IF(STATE_ALL) THEN
          ISTATE = ICONT
        ELSE
          ISTATE = IND_ST(ICONT)
        ENDIF
        DO IG=1,NGW
          I=INYH(1,IG)-NH1
          J=INYH(2,IG)-NH2
          K=INYH(3,IG)-NH3
          PSI(I,J,K)=PSI(I,J,K)+
     &          DREAL(C0(IG,ISTATE))*DREAL(C0(IG,ISTATE))+
     &          DIMAG(C0(IG,ISTATE))*DIMAG(C0(IG,ISTATE))
          PSI(-I,-J,-K)=PSI(-I,-J,-K)+
     &          DREAL(C0(IG+NGW,ISTATE))*DREAL(C0(IG+NGW,ISTATE))+
     &          DIMAG(C0(IG+NGW,ISTATE))*DIMAG(C0(IG+NGW,ISTATE))
        ENDDO
      ENDDO
#ifdef PARALLEL
      CALL GLOSUM(KR1S*KR2S*KR3S,PSI)
#endif

      IF(PARENT) THEN
        CALL FILEOPEN(12,FILEN,FO_DEF,FERROR)
        write(12,'(A,/)') FILEN
        write(12,'(I4,3f10.4)') 1,0.0D0,0.0D0,0.0D0
        write(12,'(I4,3f10.4)') NR1S+1, 1.0D0,0.0D0,0.0D0
        write(12,'(I4,3f10.4)') NR2S+1, 0.0D0,1.0D0,0.0D0
        write(12,'(I4,3f10.4)') NR3S+1, 0.0D0,0.0D0,1.0D0

        write(12,'(I4,4f10.4)') 8, 0.0D0,DBLE(NR1S)/2.D0,
     &              DBLE(NR2S)/2.D0,DBLE(NR3S)/2.D0
        DO I = -NR1S/2,NR1S/2
          DO J =-NR2S/2,NR2S/2
            WRITE (12, '(6F15.7 )')  (PSI(I,J,K), 
     &                   K = -NR3S/2,NR3S/2 )
          END DO
        END DO
        CALL FILECLOSE(12)
      ENDIF



C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================



