C     ==================================================================
      SUBROUTINE W_WFNIO(NW,IERROR,NSTATE,C,TAG)
C     ==--------------------------------------------------------------==
C     == WRITE THE WAVEFUNCTIONS IN RESTART FILE                      ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'kpts.inc'
      include 'bsym.inc'
C     Arguments
      INTEGER      NW,IERROR,NSTATE
      REAL*8       C(2*NGWK,*)
      CHARACTER*10 TAG
C     Variables
      REAL*8       CA(*),CR(*)
      POINTER      (IP_CA,CA),(IP_CR,CR)
      INTEGER      MAPW(*)
      INTEGER      ICMP(*)
      POINTER      (IP_ICMP,ICMP),(IP_MAPW,MAPW)
      INTEGER      IDAMAX,ISUB,LEN,ICOMPR,IRECORD,ISCA,I,
     &             IKPT,KBEG,KEND,KINC,NKPOINT
      REAL*8       DGIVE,SCALE,SCALE0
      EXTERNAL     DGIVE
      INTEGER      IWFNTYPE
#ifdef PARALLEL
      INTEGER      LEN1
#else
      REAL*8    FOO(1)
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   W_WFNIO',ISUB)
C..the type of wfn output
      IWFNTYPE = 1
C CB: BS calculation needs to store two WFs
      IF(BSYMM) THEN
        IWFNTYPE=9
      ENDIF
C
      IF(WCOMPB.EQ.-1) THEN
        CALL STOPGM('W_WFNIO','NOT IMPLEMENTED')
      ELSE
        IF(PARENT) THEN
#ifdef PARALLEL
          LEN=2*NGWK
          LEN1=2*NGW/IRAT + 1
          CALL MEMORY(IP_CR,4*LEN,'CR')
          CALL MEMORY(IP_MAPW,LEN1,'MAPW')
#else
          LEN=NGWK
C         Not used (only to avoid a warning).
          CALL GET_ADDR(IP_CR,FOO(1))
          CALL GET_ADDR(IP_MAPW,FOO(1))
#endif
          CALL MEMORY(IP_CA,2*NGWKS,'CA')
          CALL MEMORY(IP_ICMP,2*NGWKS+100,'ICMP')
          ICOMPR=WCOMPB
          IF(ICOMPR.LT.1) THEN
            ICOMPR=1
          ENDIF
        ENDIF
        IF(TAG(1:3).EQ.'NIL') THEN
          IRECORD=2*NSTATE+1
          ISCA=IDAMAX(2*NSTATE*NGWK,C,1)
          SCALE=ABS(DGIVE(C(1,1),ISCA))
#ifdef PARALLEL
          CALL GLOMAX(1,SCALE)
#endif
          IF(IWFNTYPE.EQ.1) THEN
            IF(PARENT) THEN
              WRITE(UNIT=NW,IOSTAT=IERROR) -IRECORD
              WRITE(UNIT=NW,IOSTAT=IERROR) IWFNTYPE
              WRITE(UNIT=NW,IOSTAT=IERROR) NSTATE,NGWKS,ICOMPR,SCALE
              WRITE(UNIT=NW,IOSTAT=IERROR) TLSD,NSUP,NSDOWN
            ENDIF
            DO I=1,NSTATE
              CALL WRWFN(NW,IERROR,C(1,I),CA,CR,ICMP,MAPW,ICOMPR,SCALE)
            ENDDO
          ELSE
            CALL STOPGM('W_WFNIO','NOT IMPLEMENTED')
          ENDIF
        ELSE
          IRECORD=2*NSTATE*NKPTS*BSFAC+3
          SCALE=0.D0
          CALL INQ_SWAP(KBEG,KEND,KINC)
          DO IKPT=KBEG,KEND,KINC
            NKPOINT=NKPBL(IKPT)
            IF(TKBLOCK) THEN
              CALL RKPT_SWAP(C,NSTATE,IKPT,TAG)
            ENDIF
            ISCA=IDAMAX(2*NGWK*NSTATE*NKPOINT,C,1)
            SCALE0=ABS(DGIVE(C(1,1),ISCA))
            IF(SCALE0.GT.SCALE) THEN
              SCALE=SCALE0
            ENDIF
          ENDDO
#ifdef PARALLEL
          CALL GLOMAX(1,SCALE)
#endif
          IF(IWFNTYPE.EQ.1) THEN
            IF(PARENT) THEN
              WRITE(UNIT=NW,IOSTAT=IERROR) -IRECORD
              WRITE(UNIT=NW,IOSTAT=IERROR) IWFNTYPE
              WRITE(UNIT=NW,IOSTAT=IERROR)
     &             NSTATE*NKPTS,NGWKS,ICOMPR,SCALE
              WRITE(UNIT=NW,IOSTAT=IERROR) TLSD,NSUP,NSDOWN
            ENDIF
            DO IKPT=1,NBLKP
              IF(TKBLOCK) THEN
                CALL RKPT_SWAP(C,NSTATE,IKPT,TAG)
              ENDIF
              DO I=1,NSTATE*NKPBL(IKPT)
                CALL WRWFN(NW,IERROR,C(1,I),CA,CR,ICMP,MAPW,
     &               ICOMPR,SCALE)
              ENDDO
            ENDDO
C CB: Writing the two BS wavefunctions (BS, HS state)            
          ELSE IF(IWFNTYPE.EQ.9) THEN
            IF(PARENT) THEN
              WRITE(UNIT=NW,IOSTAT=IERROR) -IRECORD
              WRITE(UNIT=NW,IOSTAT=IERROR) IWFNTYPE
              WRITE(UNIT=NW,IOSTAT=IERROR)
     &             NSTATE*NKPTS,NGWKS,ICOMPR,SCALE
              WRITE(UNIT=NW,IOSTAT=IERROR)
     &             TLSD,int(NSTATE/2),int(NSTATE/2),HSUP,HSDOWN
            ENDIF
            DO IKPT=1,NBLKP
              IF(TKBLOCK) THEN
                CALL RKPT_SWAP(C,NSTATE,IKPT,TAG)
              ENDIF
              DO I=1,NSTATE*NKPBL(IKPT)*BSFAC
                CALL WRWFN(NW,IERROR,
     &               C(1,I),CA,CR,ICMP,MAPW,ICOMPR,SCALE)
              ENDDO
            ENDDO
          ELSE
            CALL STOPGM('W_WFNIO','NOT IMPLEMENTED')
          ENDIF
        ENDIF
        IF(PARENT) THEN
          CALL FREEM(IP_CA)
          CALL FREEM(IP_ICMP)
#ifdef PARALLEL
          CALL FREEM(IP_CR)
          CALL FREEM(IP_MAPW)
#endif
        ENDIF
      ENDIF
      CALL TIHALT('   W_WFNIO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE R_WFNIO(NR,C,NSTATE,INFO,
     &                   TKPNT0,NSTATE0,NKPTS0,TAG)
C     ==--------------------------------------------------------------==
C     == Read wavefunctions                                           ==
C     == INPUT:                                                       ==
C     ==   NR      Logical number of the file                         ==
C     ==   NSTATE  Number of states                                   ==
C     ==   TKPNT0  .TRUE. (has k points)                              ==
C     ==   NSTATE0 Number of states  for the RESTART file             ==
C     ==   NKPTS0  Number of kpoints for the RESTART file             ==
C     ==   TAG     'NIL' wavefunctions                                ==
C     ==           'C0'  electronic wavefunctions                     ==
C     == OUTPUT:                                                      ==
C     ==   C      Wavefunctions                                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'spin.inc'        !NSUP NSDOWN
      INCLUDE 'geq0.inc'        !GEQ0
      INCLUDE 'bsym.inc'
C     Arguments
      INTEGER   NR,NSTATE,INFO,NSTATE0,NKPTS0
      REAL*8    C(2*NGWK,NSTATE,NKPNT)
      LOGICAL   TKPNT0
      CHARACTER TAG*10
C     Variables
      REAL*8    CA(*),CR(*),SMAT(*)
      INTEGER   MAPW(*)
      INTEGER   ICMP(*),ISMA(*)
      POINTER   (IP_CA,CA),(IP_CR,CR),(IP_SMAT,SMAT),(IP_ISMA,ISMA),
     &          (IP_ICMP,ICMP),(IP_MAPW,MAPW)
      INTEGER   ISUB,N0,NGWKS0,ICOMPR,LEN,NGWA,NREAD,I,NX,
     &          IKPT,IKIND,NORTHO,NOORTHO,LCA,LICMP,IKPT0,IWFNTYPE
      REAL*8    SCALE
      INTEGER   NA,NB,NAH,NBH
      LOGICAL   L_TLSD !CB:Renamed from TLOG to avoid confusion w/ USPP
#ifdef PARALLEL
      INTEGER   MSGLEN,LEN1
#else
      REAL*8    FOO(1)
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   R_WFNIO',ISUB)
C     ==--------------------------------------------------------------==
      IF(TAG(1:3).NE.'NIL') THEN
         CALL INITRANDP(NSTATE)
      ENDIF
C     ==--------------------------------------------------------------==
      NREAD=0
      INFO=0
      IF(PARENT) READ(NR) IWFNTYPE
#ifdef PARALLEL
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IWFNTYPE,MSGLEN,SOURCE,ALLGRP)
#endif
      IF(IWFNTYPE.EQ.1.OR.IWFNTYPE.EQ.9) THEN
        IF(PARENT) THEN
          READ(NR) N0,NGWKS0,ICOMPR,SCALE
          if(IWFNTYPE.eq.1) then
            READ(NR) L_TLSD,NA,NB
          else
            READ(NR) L_TLSD,NA,NB,NAH,NBH
            RESTBS=.false.            
            if(BSCLCS.eq.2) then
              NA=NAH
              NB=NBH
            endif  
          endif  
        ENDIF
#ifdef PARALLEL
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(N0,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(NGWKS0,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(ICOMPR,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(L_TLSD,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(NA,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(NB,MSGLEN,SOURCE,ALLGRP)
        MSGLEN = 1 * 8/IRAT
        CALL MY_BCAST(RESTBS,MSGLEN,SOURCE,ALLGRP)
#endif
        RCOMPB=ICOMPR
        IF(RCOMPB.EQ.-1) THEN
          CALL STOPGM('R_WFNIO','NOT IMPLEMENTED')
          GOTO 400
        ENDIF
C     ==--------------------------------------------------------------==
        IF(PARENT) THEN
#ifdef PARALLEL
          LEN=2*NGWK
          CALL MEMORY(IP_CR,4*LEN,'CR')
          LEN1=2*NGW/IRAT + 1
          CALL MEMORY(IP_MAPW,LEN1,'MAPW')
#else
          LEN=NGWK
C         Not used (only to avoid a warning).
          CALL GET_ADDR(IP_CR,FOO(1))
          CALL GET_ADDR(IP_MAPW,FOO(1))
#endif  
          NGWA=MAX(NGWKS0,NGWKS)
          LCA=MAX(2*NGWA+100,NSTATE0*MAX(NSTATE0,NSTATE))
          CALL MEMORY(IP_CA,LCA,'CA')
          CALL AZZERO(CA,LCA)
C         Warning: ICMP is allocated as INTEGER*8
          LICMP=MAX(2*NGWA+100,(NSTATE-NSTATE0)/IRAT+1)
          CALL MEMORY(IP_ICMP,LICMP,'ICMP')
C         ICMP is integer*8 (length LICMP).
          CALL IAZZERO(ICMP,IRAT*LICMP)
        ENDIF
C     ==--------------------------------------------------------------==
        IF(TAG(1:3).EQ.'NIL') THEN
          NREAD=MIN(NSTATE,N0)
          DO I=1,NREAD
            CALL RDWFN(NR,C(1,I,1),CA,CR,ICMP,MAPW,NGWKS0,ICOMPR,
     &           SCALE,TKPNT0)
          ENDDO
          NX=NSTATE-NREAD
          IF(NX.GT.0) CALL DURAND(14566.0D0,2*NGWK*NX,C(1,NREAD+1,1))
          GOTO 200
        ENDIF
C     ==--------------------------------------------------------------==
C     == Case for C0 (electronic wavefunctions)                       ==
C     ==--------------------------------------------------------------==
        IF(TKPNT.OR.TKPNT0) THEN
C         Check consistency of N0.
          IF(N0.NE.NSTATE0*NKPTS0) THEN
            WRITE(6,*) ' RD30WFN! N0=',N0,' NSTATE0=',NSTATE0,
     &           'NKPST0=',NKPTS0
            CALL STOPGM('RD30WFN',
     &           'THE NUMBER OF WAVEFUNCTIONS IS NOT CORRECT')
          ENDIF
          IF(IWFNTYPE.EQ.9) THEN
            WRITE(6,*) ' R_WFNIO! Cannot read BS RESTART w/ k-points.'
            CALL STOPGM('R_WFNIO',
     &           'BS RESTART cannot be read in k-point run.')
          ENDIF
          NREAD=0
          IKPT0=0
          DO IKPT=1,NBLKP
            DO IKIND=1,NKPBL(IKPT)
              IKPT0=IKPT0+1
              IF(IKPT0.LE.NKPTS0) THEN
C               We load a new set of nstates for a new kpoint.
                NOORTHO=0
                DO I=1,NSTATE
                  IF(I.LE.NSTATE0) THEN
C                   We load a new state.
                    NREAD=NREAD+1
                    CALL RDWFN(NR,C(1,I,IKIND),CA,CR,ICMP,MAPW,NGWKS0,
     &                         ICOMPR,SCALE,TKPNT0)
C                   We adapt the format of C0.
                    IF(TKPNT) THEN
                      IF(.NOT.TKPNT0) THEN
C                       C(NGW:2*NGW,I,IKIND)=DCONJG(C(1:NGW,I,IKIND))
                        CALL DCOPY(2*NGW,C(1      ,I,IKIND),1,
     &                                   C(1+2*NGW,I,IKIND),1)
                        CALL DSCAL(NGW,-1.D0,C(2+2*NGW,I,IKIND),2)
                        IF(GEQ0) THEN
                          C(2*NGW+1,I,IKIND)=0.D0
                          C(2*NGW+2,I,IKIND)=0.D0
                        ENDIF
                      ENDIF
                      CALL C_CLEAN(C(1,I,IKIND),1,IKIND)
                    ENDIF
                  ELSE
C                   Use a randomized state.
                    CALL RANDTOWF(C(1,I,IKIND),1,IKIND,IKPT0)
                    CALL PUTRANDP(I)
                  ENDIF
C                 C has to be real.
                  IF(TKPNT0.AND..NOT.TKPNT) THEN
                    IF(TLSD) THEN
                      CALL PUTCONJ(C,NSUP)
                      CALL PUTCONJ(C(1,NSUP+1,1),NSDOWN)
                    ELSE
                      CALL PUTCONJ(C,NSTATE)
                    ENDIF
                  ENDIF
                ENDDO
                IF(NSTATE.GT.NSTATE0) THEN
                  NOORTHO=NSTATE-NSTATE0
C                 We orthogonalize.
                  IF(TKPNT) THEN
                    CALL MEMORY(IP_SMAT,2*NSTATE*NSTATE,'SMAT')
                    CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
                    IF(TLSD) THEN
                      IF(NSUP.GT.NSTATE0) THEN
                        CALL GS_ORTHO_C(C(1,1,IKIND),NSTATE0,
     *                       C(1,NSTATE0+1,IKIND),NSUP,SMAT,ISMA)
C                       We copy UP states  to DOWN states.
                        CALL DCOPY(2*NGWK*NSDOWN,C(1,1,IKIND),1,
     &                       C(1,NSUP+1,IKIND),1)
                      ELSEIF(NSUP.EQ.NSTATE0) THEN
C                       We copy UP states  to DOWN states.
                        CALL DCOPY(2*NGWK*NSDOWN,C(1,1,IKIND),1,
     &                       C(1,NSUP+1,IKIND),1)
                      ELSE
C                       We orthogonalize only the down states.
                        NORTHO=NSTATE0-NSUP
                        CALL GS_ORTHO_C(C(1,NSUP+1,IKIND),NORTHO,
     *                       C(1,NSUP+NORTHO+1,IKIND),NOORTHO,
     &                       SMAT,ISMA)
                      ENDIF
                    ELSE
                      CALL GS_ORTHO_C(C(1,1,IKIND),NSTATE0,
     *                     C(1,NSTATE0+1,IKIND),NOORTHO,SMAT,ISMA)
                    ENDIF
                  ELSE
                    CALL MEMORY(IP_SMAT,NSTATE*NSTATE,'SMAT')
                    CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
                    IF(TLSD) THEN
                      IF(NSUP.GT.NSTATE0) THEN
                        CALL GS_ORTHO  (C(1,1,IKIND),NSTATE0,
     *                       C(1,NSTATE0+1,IKIND),NSUP,SMAT,ISMA)
C                       We copy UP states  to DOWN states.
                        CALL DCOPY(2*NGWK*NSDOWN,C(1,1,IKIND),1,
     &                       C(1,NSUP+1,IKIND),1)
                      ELSEIF(NSUP.EQ.NSTATE0) THEN
C                       We copy UP states  to DOWN states.
                        CALL DCOPY(2*NGWK*NSDOWN,C(1,1,IKIND),1,
     &                       C(1,NSUP+1,IKIND),1)
                      ELSE
C                       We orthogonalize only the down states.
                        NORTHO=NSTATE0-NSUP
                        CALL GS_ORTHO  (C(1,NSUP+1,IKIND),NORTHO,
     *                       C(1,NSUP+NORTHO+1,IKIND),NOORTHO,SMAT,ISMA)
                      ENDIF
                    ELSE
                      CALL GS_ORTHO  (C(1,1,IKIND),NSTATE0,
     &                     C(1,NSTATE0+1,IKIND),NOORTHO,SMAT,ISMA)
                    ENDIF
                  ENDIF             !IF(TKPNT)
                  CALL FREEM(IP_SMAT)
                  CALL FREEM(IP_ISMA)
                ELSEIF(PARENT) THEN
C                 NSTATE0.GE.NSTATE
                  NX=NSTATE0-NSTATE
                  DO I=1,NX
                    NREAD=NREAD+1
                    READ(NR)
                    READ(NR)
                  ENDDO
                ENDIF               !IF(NSTATE.GT.NSTATE0)
              ELSE
C               We have more k points -> we use the set of nstate
C               for ikind=1.
                IF(IKIND.NE.1) THEN
                  CALL DCOPY(2*NGWK*NSTATE,C(1,1,1),1,C(1,1,IKIND),1)
                ELSE
C                 All the block has to be copied. Do nothing.
                  GOTO 100
                ENDIF
              ENDIF                 !IF(IKPT0.LE.KPTS0)
            ENDDO                   !DO IKIND
 100        CONTINUE
            IF(TKBLOCK) CALL WKPT_SWAP(C,NSTATE,IKPT,TAG)
          ENDDO                     !DO IKPT
        ELSE
C..CASE with NO k-points (in read and write)
          NREAD=0
          IF(TLSD) THEN
cMcB!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            IF ( TSHOP ) THEN
              IF(NSTATE0.LT.NSTATE) THEN
                CALL MEMORY(IP_SMAT,2*NSTATE*NSTATE,'SMAT')
                CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
              ENDIF
              DO I=1,NSTATE
                IF(I.LE.NSTATE0) THEN
C                 We load a new state.
                  NREAD=NREAD+1
                  CALL RDWFN(NR,C(1,I,1),CA,CR,ICMP,MAPW,NGWKS0,
     &                       ICOMPR,SCALE,TKPNT0)
                ELSE
C                 Use a randomized state.
                  CALL RANDTOWF(C(1,I,1),1,1,1)
                  CALL PUTRANDP(I)
                  CALL GS_ORTHO  (C(1,1,1),I-1,C(1,I,1),1,SMAT,ISMA)
                ENDIF
              ENDDO
              IF(NSTATE0.LT.NSTATE) THEN
                CALL FREEM(IP_SMAT)
                CALL FREEM(IP_ISMA)
              ENDIF
cMcB      surface hopping currently needs to read as if TLSD=L_TLSD=.F.
cmb-bug               GO TO 500
cMcB!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
cmb-bug            ENDIF
            ELSE
cMcB!!!!!!!!#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            IF(L_TLSD) THEN
C--> LSD:LSD
C CB: We need to skip the BS wavefunction if it is not used.
              if(IWFNTYPE.eq.9.and.BSCLCS.eq.2.and.PARENT)
     &          call FSKIP(NR,2*N0)
              IF((NA.LT.NSUP).OR.(NB.LT.NSDOWN)) THEN
                CALL MEMORY(IP_SMAT,2*NSTATE*NSTATE,'SMAT')
                CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
              ENDIF
              DO I=1,NSUP
                IF(I.LE.NA) THEN
C                 We load a new state.
                  NREAD=NREAD+1
                  CALL RDWFN(NR,C(1,I,1),CA,CR,ICMP,MAPW,NGWKS0,
     &                       ICOMPR,SCALE,TKPNT0)
                ELSE
C                 Use a randomized state.
                  CALL RANDTOWF(C(1,I,1),1,1,0)
                  CALL PUTRANDP(I)
                  CALL GS_ORTHO(C(1,1,1),I-1,C(1,I,1),1,SMAT,ISMA)
                ENDIF
              ENDDO
              IF(NREAD.LT.NA.AND.PARENT) THEN
                NX=NA-NREAD
                DO I=1,NX
                  NREAD=NREAD+1
                  READ(NR)
                  READ(NR)
                ENDDO
              ENDIF
              DO I=1,NSDOWN
                IF(I.LE.NB) THEN
C                 We load a new state.
                  NREAD=NREAD+1
                  CALL RDWFN(NR,C(1,NSUP+I,1),CA,CR,ICMP,MAPW,NGWKS0,
     &                       ICOMPR,SCALE,TKPNT0)
                ELSE
C                 Use a randomized state.
                  CALL RANDTOWF(C(1,NSUP+I,1),1,1,0)
                  CALL PUTRANDP(NSUP+I)
                  CALL GS_ORTHO(C(1,NSUP+1,1),I-1,C(1,NSUP+I,1),1,
     &                         SMAT,ISMA)
                ENDIF
              ENDDO
              IF(NREAD.LT.(NA+NB).AND.PARENT) THEN
                NX=NA+NB-NREAD
                DO I=1,NX
                  NREAD=NREAD+1
                  READ(NR)
                  READ(NR)
                ENDDO
              ENDIF
C CB: We need to skip the HS wavefunction if it was not used.
              if(IWFNTYPE.eq.9.and.BSCLCS.eq.1.and.PARENT)
     &                call FSKIP(NR,2*N0)
              IF((NA.LT.NSUP).OR.(NB.LT.NSDOWN)) THEN
                CALL FREEM(IP_SMAT)
                CALL FREEM(IP_ISMA)
              ENDIF
            ELSE
C--> LSD:LDA
              IF((NSTATE0.LT.NSUP).OR.(NSTATE0.LT.NSDOWN)) THEN
                CALL MEMORY(IP_SMAT,2*NSTATE*NSTATE,'SMAT')
                CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
              ENDIF
              DO I=1,MAX(NSUP,NSDOWN)
                IF(I.LE.NSTATE0) THEN
C                 We load a new state.
                  IF(I.LE.NSUP) THEN
                    NREAD=NREAD+1
                    CALL RDWFN(NR,C(1,I,1),CA,CR,ICMP,MAPW,NGWKS0,
     &                         ICOMPR,SCALE,TKPNT0)
                    IF(I.LE.NSDOWN)
     &                CALL DCOPY(2*NGWK,C(1,I,1),1,C(1,NSUP+I,1),1)
                  ELSE
                    NREAD=NREAD+1
                    CALL RDWFN(NR,C(1,NSUP+I,1),CA,CR,ICMP,MAPW,NGWKS0,
     &                         ICOMPR,SCALE,TKPNT0)
                  ENDIF
                ELSE
C                 Use a randomized state.
                  IF(I.LE.NSUP) THEN
                    CALL RANDTOWF(C(1,I,1),1,1,1)
                    CALL PUTRANDP(I)
                    CALL GS_ORTHO(C(1,1,1),I-1,C(1,I,1),1,SMAT,ISMA)
                  ELSE
                    CALL RANDTOWF(C(1,NSUP+I,1),1,1,1)
                    CALL PUTRANDP(NSUP+I)
                    CALL GS_ORTHO(C(1,NSUP+1,1),I-1,C(1,NSUP+I,1),1,
     &                           SMAT,ISMA)
                  ENDIF
                ENDIF
              ENDDO
              IF((NSTATE0.LT.NSUP).OR.(NSTATE0.LT.NSDOWN)) THEN
                CALL FREEM(IP_SMAT)
                CALL FREEM(IP_ISMA)
              ENDIF
            ENDIF
cmb!!!!!!!!!!!!!!!!!!!!!!
            ENDIF
cmb!!!!!!!!!!!!!!!!!!!!!!
          ELSE
            IF(L_TLSD) THEN
C--> LDA:LSD (read only alpha states)
              IF(NA.LT.NSTATE) THEN
                CALL MEMORY(IP_SMAT,2*NSTATE*NSTATE,'SMAT')
                CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
              ENDIF
              DO I=1,NSTATE
                IF(I.LE.NA) THEN
C                 We load a new state.
                  NREAD=NREAD+1
                  CALL RDWFN(NR,C(1,I,1),CA,CR,ICMP,MAPW,NGWKS0,
     &                       ICOMPR,SCALE,TKPNT0)
                ELSE
C                 Use a randomized state.
                  CALL RANDTOWF(C(1,I,1),1,1,1)
                  CALL PUTRANDP(I)
                  CALL GS_ORTHO(C(1,1,1),I-1,C(1,I,1),1,SMAT,ISMA)
                ENDIF
              ENDDO
              IF(NA.LT.NSTATE) THEN
                CALL FREEM(IP_SMAT)
                CALL FREEM(IP_ISMA)
              ENDIF
            ELSE
C--> LDA:LDA
cMcB!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
cMcB          surface hopping currently needs to read as if TLSD=.F.
cmb-bug  500         continue
cMcB!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
              IF(NSTATE0.LT.NSTATE) THEN
                CALL MEMORY(IP_SMAT,2*NSTATE*NSTATE,'SMAT')
                CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
              ENDIF
              DO I=1,NSTATE
                IF(I.LE.NSTATE0) THEN
C                 We load a new state.
                  NREAD=NREAD+1
                  CALL RDWFN(NR,C(1,I,1),CA,CR,ICMP,MAPW,NGWKS0,
     &                       ICOMPR,SCALE,TKPNT0)
                ELSE
C                 Use a randomized state.
                  CALL RANDTOWF(C(1,I,1),1,1,1)
                  CALL PUTRANDP(I)
                  CALL GS_ORTHO  (C(1,1,1),I-1,C(1,I,1),1,SMAT,ISMA)
                ENDIF
              ENDDO
              IF(NSTATE0.LT.NSTATE) THEN
                CALL FREEM(IP_SMAT)
                CALL FREEM(IP_ISMA)
              ENDIF
            ENDIF
          ENDIF
        ENDIF
C       ==--------------------------------------------------------------==
 200    CONTINUE
        IF(N0.GT.NREAD.AND.PARENT) THEN
          NX=N0-NREAD
          DO I=1,NX
            READ(NR)
            READ(NR)
          ENDDO
        ENDIF
        IF(PARENT) THEN
          CALL FREEM(IP_CA)
          CALL FREEM(IP_ICMP)
#ifdef PARALLEL
          CALL FREEM(IP_CR)
          CALL FREEM(IP_MAPW)
#endif
        ENDIF
C     ==--------------------------------------------------------------==
 400    CONTINUE
      ELSE
        CALL STOPGM('R_WFNIO','NOT IMPLEMENTED')
      ENDIF
      CALL TIHALT('   R_WFNIO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE INITRANDP(NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'read.inc'
      INCLUDE 'irat.inc'
      INTEGER NSTATE,LEN
C     ==--------------------------------------------------------------==
      IF(NSTATE.GT.ISRLENGTH) THEN
        IF(ISRLENGTH.NE.0) CALL FREEM(IP_ISRANDOM)
        LEN = NSTATE * 8/IRAT
        CALL MEMORY(IP_ISRANDOM,LEN,'ISRANDOM')
        ISRLENGTH = NSTATE
      ENDIF
      CALL IAZZERO(ISRANDOM,ISRLENGTH)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PUTRANDP(NS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'read.inc'
      INTEGER NS
C     ==--------------------------------------------------------------==
      IF(NS.GT.ISRLENGTH) THEN
        CALL STOPGM('PUTRANDP','Out of range')
      ELSE
        ISRANDOM(NS)=1
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      LOGICAL FUNCTION HASRANDS()
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'read.inc'
      INTEGER I
C     ==--------------------------------------------------------------==
      HASRANDS = .FALSE.
      DO I=1,ISRLENGTH
        HASRANDS = HASRANDS .OR. ISRANDOM(I).NE.0
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      LOGICAL FUNCTION QUERYRANDS(NS)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'read.inc'
      INTEGER NS
C     ==--------------------------------------------------------------==
      QUERYRANDS = ISRANDOM(NS).NE.0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
