C     ==================================================================
      SUBROUTINE WR30WFN(NW,IERROR,NSTATE,C,TAU0,TAG)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'bsym.inc'
C     Arguments
      INTEGER      NW,IERROR,NSTATE
      REAL*8       C(2*NGWK,NSTATE*NKPNT*BSFAC),TAU0(3,NAX,NSX)
      CHARACTER*10 TAG
C     Variables
      REAL*8       CA(*),CR(*)
      POINTER      (IP_CA,CA),(IP_CR,CR)
      INTEGER      MAPW(*)
      INTEGER      ICMP(*)
      POINTER      (IP_ICMP,ICMP),(IP_MAPW,MAPW)
      INTEGER      IDAMAX,ISUB,LEN,ICOMPR,IRECORD,ISCA,I,
     &             IKPT,KBEG,KEND,KINC,NKPOINT
      REAL*8       DGIVE,SCALE,SCALE0
      EXTERNAL     DGIVE
#ifdef PARALLEL
      INTEGER      LEN1
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   WR30WFN',ISUB)
      IF(WCOMPB.EQ.-1) THEN
        CALL PWTOAO(NW,IERROR,NSTATE,NKPNT,C,TAU0)
      ELSE
        IF(PARENT) THEN
#ifdef PARALLEL
          LEN=2*NGWK
          LEN1=2*NGW/IRAT + 1
          CALL MEMORY(IP_CR,4*LEN,'CR')
          CALL MEMORY(IP_MAPW,LEN1,'MAPW')
#else
C         Unused. Set to 0 to avoid a compiler warning.
          IP_CR=0
          IP_MAPW=0
          LEN=NGWK
#endif
          CALL MEMORY(IP_CA,2*NGWKS,'CA')
          CALL MEMORY(IP_ICMP,2*NGWKS+100,'ICMP')
          ICOMPR=WCOMPB
        ENDIF
        IF(ICOMPR.LT.1) ICOMPR=1
        IF(TAG(1:3).EQ.'NIL') THEN
C         NN: For BS two sets of WF welocities 
          IRECORD=2*NSTATE*BSFAC+1 
          ISCA=IDAMAX(2*NSTATE*NGWK,C,1)
          SCALE=ABS(DGIVE(C(1,1),ISCA))
#ifdef PARALLEL
          CALL GLOMAX(1,SCALE)
#endif
          IF(PARENT) THEN
            WRITE(UNIT=NW,IOSTAT=IERROR) IRECORD
            WRITE(UNIT=NW,IOSTAT=IERROR) NSTATE,NGWKS,ICOMPR,SCALE
          ENDIF
C         NN: For BS two sets of WF welocities are written 
          DO I=1,NSTATE*BSFAC 
            CALL WRWFN(NW,IERROR,C(1,I),CA,CR,ICMP,MAPW,ICOMPR,SCALE)
          ENDDO
        ELSE
          IRECORD=2*NSTATE*NKPTS+1 
          SCALE=0.D0
          CALL INQ_SWAP(KBEG,KEND,KINC)
          DO IKPT=KBEG,KEND,KINC
            NKPOINT=NKPBL(IKPT)
            IF(TKBLOCK) CALL RKPT_SWAP(C,NSTATE,IKPT,TAG)
            ISCA=IDAMAX(2*NGWK*NSTATE*NKPOINT,C,1)
            SCALE0=ABS(DGIVE(C(1,1),ISCA))
            IF(SCALE0.GT.SCALE) SCALE=SCALE0
          ENDDO
#ifdef PARALLEL
          CALL GLOMAX(1,SCALE)
#endif
    
          IF(PARENT) THEN
            WRITE(UNIT=NW,IOSTAT=IERROR) IRECORD
            WRITE(UNIT=NW,IOSTAT=IERROR) NSTATE*NKPTS,NGWKS,ICOMPR,SCALE
          ENDIF
          DO IKPT=1,NBLKP
            IF(TKBLOCK) CALL RKPT_SWAP(C,NSTATE,IKPT,TAG)
            DO I=1,NSTATE*NKPBL(IKPT)
              CALL WRWFN(NW,IERROR,C(1,I),CA,CR,ICMP,MAPW,ICOMPR,SCALE)
            ENDDO
          ENDDO
        ENDIF
        IF(PARENT) THEN
          CALL FREEM(IP_CA)
          CALL FREEM(IP_ICMP)
#ifdef PARALLEL
          CALL FREEM(IP_CR)
          CALL FREEM(IP_MAPW)
#endif
        ENDIF
      ENDIF
      CALL TIHALT('   WR30WFN',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRWFN(NW,IERROR,C,CA,CR,ICMP,MAPW,ICOMPR,SCALE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'kpts.inc'
C     Arguments
      INTEGER    NW,IERROR,ICOMPR,MAPW(*)
      INTEGER    ICMP(*) 
      COMPLEX*16 C(NGWK),CA(NGWKS),CR(*)
      REAL*8     SCALE
#ifdef PARALLEL
C     Variables
      INTEGER    IP,IG,MSGID,MSGLEN,NGWIP,IPW,NX,NBYTES
C     ==--------------------------------------------------------------==
      DO IP=0,NPROC-1
        IF(PARENT) THEN
          IF(PGROUP(IP+1).EQ.ME) THEN
            DO IG=1,NGW
              CR(IG)=C(IG)
              MAPW(IG)=MAPGP(IG)
            ENDDO
            IF(TKPNT) THEN
              DO IG=NGW+1,NGWK
                CR(IG)=C(IG)
              ENDDO
            ENDIF
          ELSE
            MSGID=1
            IF(TKPNT) THEN
              MSGLEN = 2 * 2 * SPARM(3,IP) * 8
            ELSE
              MSGLEN =     2 * SPARM(3,IP) * 8
            ENDIF
            CALL MY_BRECV(CR,MSGLEN,PGROUP(IP+1),MSGID,NBYTES)
            MSGID=2
            MSGLEN = SPARM(3,IP) * 8/IRAT
            CALL MY_BRECV(MAPW,MSGLEN,PGROUP(IP+1),MSGID,NBYTES)
          ENDIF
          DO IPW=1,SPARM(3,IP)
            CA(MAPW(IPW))=CR(IPW)
          ENDDO
          IF(TKPNT) THEN
            NGWIP=SPARM(3,IP)
            DO IPW=1,NGWIP
              CA(MAPW(IPW)+NGWS)=CR(NGWIP+IPW)
            ENDDO
          ENDIF
        ELSE
          IF(PGROUP(IP+1).EQ.ME) THEN
            MSGID=1
            MSGLEN = 2 * NGWK * 8
            CALL MY_BSEND(C,MSGLEN,PGROUP(1),MSGID)
            MSGID=2
            MSGLEN = NGW * 8/IRAT
            CALL MY_BSEND(MAPGP,MSGLEN,PGROUP(1),MSGID)
          ENDIF
        ENDIF
      ENDDO
      IF(PARENT) THEN
        CALL COMPRESS(2*NGWKS,CA,ICMP,SCALE,ICOMPR,NX)
        WRITE(UNIT=NW,IOSTAT=IERROR) NX
        CALL WRITE_N(NW,IERROR,ICMP,NX)
      ENDIF
      CALL MY_SYNC(ALLGRP)
#else
C     Variables
      INTEGER    NX
C     ==--------------------------------------------------------------==
      CALL DCOPY(2*NGWK,C(1),1,CA(1),1)
      CALL COMPRESS(2*NGWK,CA,ICMP,SCALE,ICOMPR,NX)
      WRITE(UNIT=NW,IOSTAT=IERROR) NX
      CALL WRITE_N(NW,IERROR,ICMP,NX)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RD30WFN(NR,C,NSTATE,TAU0,INFO,
     &                   TKPNT0,NSTATE0,NKPTS0,TAG)
C     ==--------------------------------------------------------------==
C     == Read wavefunctions                                           ==
C     == INPUT:                                                       ==
C     ==   NR      Logical number of the file                         ==
C     ==   NSTATE  Number of states                                   ==
C     ==   TAU0    atomic positions                                   ==
C     ==   TKPNT0  .TRUE. (has k points)                              ==
C     ==   NSTATE0 Number of states  for the RESTART file             ==
C     ==   NKPTS0  Number of kpoints for the RESTART file             ==
C     ==   TAG     'NIL' wavefunctions                                ==
C     ==           'C0'  electronic wavefunctions                     ==
C     == OUTPUT:                                                      ==
C     ==   C      Wavefunctions                                       ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'spin.inc'        !NSUP NSDOWN
      INCLUDE 'geq0.inc'        !GEQ0
      INCLUDE 'bsym.inc'
C     Arguments
      INTEGER   NR,NSTATE,INFO,NSTATE0,NKPTS0
      REAL*8    C(2*NGWK,NSTATE,NKPNT),TAU0(3,NAX,NSX)
      LOGICAL   TKPNT0
      CHARACTER TAG*10
C     Variables
      REAL*8    CA(*),CR(*),SMAT(*)
      INTEGER   MAPW(*)
      INTEGER   ICMP(*),ISMA(*)
      POINTER   (IP_CA,CA),(IP_CR,CR),(IP_SMAT,SMAT),(IP_ISMA,ISMA),
     &          (IP_ICMP,ICMP),(IP_MAPW,MAPW)
      INTEGER   ISUB,N0,NGWKS0,ICOMPR,LEN,NGWA,NREAD,I,NX,
     &          IKPT,IKIND,NORTHO,NOORTHO,LCA,LICMP,IKPT0
      REAL*8    SCALE
#ifdef PARALLEL
      INTEGER   MSGLEN,LEN1
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('   RD30WFN',ISUB)
      INFO=0
      IF(PARENT) READ(NR) N0,NGWKS0,ICOMPR,SCALE
#ifdef PARALLEL
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(N0,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(NGWKS0,MSGLEN,SOURCE,ALLGRP)
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(ICOMPR,MSGLEN,SOURCE,ALLGRP)
#endif
      RCOMPB=ICOMPR
      IF(RCOMPB.EQ.-1) THEN
        CALL AOTOPW(NR,C,NSTATE,TAU0)
        GOTO 400
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
#ifdef PARALLEL
        LEN=2*NGWK
        CALL MEMORY(IP_CR,4*LEN,'CR')
        LEN1=2*NGW/IRAT + 1
        CALL MEMORY(IP_MAPW,LEN1,'MAPW')
#else
C       Unused (set to 0 to avoid a compiler warning).
        IP_CR=0
        IP_MAPW=0
        LEN=NGWK
#endif  
        NGWA=MAX(NGWKS0,NGWKS)
        LCA=MAX(2*NGWA+100,NSTATE0*MAX(NSTATE0,NSTATE))
        CALL MEMORY(IP_CA,LCA,'CA')
        CALL AZZERO(CA,LCA)
C       Warning: ICMP is allocated as INTEGER*8
        LICMP=MAX(2*NGWA+100,(NSTATE-NSTATE0)+1)
        CALL MEMORY(IP_ICMP,LICMP,'ICMP')
C       ICMP is integer*8 (length LICMP).
        CALL IAZZERO(ICMP,IRAT*LICMP)
      ENDIF
C     ==--------------------------------------------------------------==
      IF(TAG(1:3).EQ.'NIL') THEN
        NREAD=MIN(NSTATE,N0)
C       NN: Modification necessary for two set of WF-Velocities 
        IF(.NOT.BSYMM)THEN
          DO I=1,NREAD
            CALL RDWFN(NR,C(1,I,1),CA,CR,ICMP,MAPW,NGWKS0,ICOMPR,
     &                 SCALE,TKPNT0)
          ENDDO
        ELSE 
C         NN: TAKING CARE OF HS_STATE_WF_VELOCITIES
          IF(BSCLCS.EQ.2)THEN 
C           NN: SKIP BS_WF_VELOCITIES
            IF(PARENT)CALL FSKIP(NR,2*N0) 
C           NN: READ HS_WF_VELOCITIES
            DO I=1,NREAD        
               CALL RDWFN(NR,C(1,I,1),CA,CR,ICMP,MAPW,NGWKS0,ICOMPR,
     &                    SCALE,TKPNT0) 
            END DO
C         NN: TAKING CARE OF BS_STATE_WF_VELOCITIES 
          ELSE IF(BSCLCS.EQ.1)THEN 
            DO I=1,NREAD 
              CALL RDWFN(NR,C(1,I,1),CA,CR,ICMP,MAPW,NGWKS0,ICOMPR,
     &                 SCALE,TKPNT0) 
            END DO
C           NN: SKIP HS_WF_VELOCITIES
            IF(PARENT)CALL FSKIP(NR,2*N0) 
          END IF
        END IF
        NX=NSTATE-NREAD
        IF(NX.GT.0) CALL DURAND(14566.0D0,2*NGWK*NX,C(1,NREAD+1,1))
        GOTO 200
      ENDIF
C     ==--------------------------------------------------------------==
C     == Case for C0 (electronic wavefunctions)                       ==
C     ==--------------------------------------------------------------==
C     Check consistency of N0.
      IF(N0.NE.NSTATE0*NKPTS0) THEN
        WRITE(6,*) ' RD30WFN! N0=',N0,' NSTATE0=',NSTATE0,
     &       'NKPST0=',NKPTS0
        CALL STOPGM('RD30WFN',
     &       'THE NUMBER OF WAVEFUNCTIONS IS NOT CORRECT')
      ENDIF
      NREAD=0
      IKPT0=0
      DO IKPT=1,NBLKP
        DO IKIND=1,NKPBL(IKPT)
          IKPT0=IKPT0+1
          IF(IKPT0.LE.NKPTS0) THEN
C           We load a new set of nstates for a new kpoint.
            NOORTHO=0
            DO I=1,NSTATE
              IF(I.LE.NSTATE0) THEN
C               We load a new state.
                NREAD=NREAD+1
                CALL RDWFN(NR,C(1,I,IKIND),CA,CR,ICMP,MAPW,NGWKS0,
     &                     ICOMPR,SCALE,TKPNT0)
C               We adapt the format of C0.
                IF(TKPNT) THEN
                  IF(.NOT.TKPNT0) THEN
C                   C(NGW:2*NGW,I,IKIND)=DCONJG(C(1:NGW,I,IKIND))
                    CALL DCOPY(2*NGW,C(1      ,I,IKIND),1,
     &                               C(1+2*NGW,I,IKIND),1)
                    CALL DSCAL(NGW,-1.D0,C(2+2*NGW,I,IKIND),2)
                    IF(GEQ0) THEN
                      C(2*NGW+1,I,IKIND)=0.D0
                      C(2*NGW+2,I,IKIND)=0.D0
                    ENDIF
                  ENDIF
                  CALL C_CLEAN(C(1,I,IKIND),1,IKIND)
                ENDIF
              ELSE
C               Use a randomized state.
                CALL RANDTOWF(C(1,I,IKIND),1,IKIND,IKPT0)
              ENDIF
            ENDDO
C           C has to be real.
            IF(TKPNT0.AND..NOT.TKPNT) THEN
              IF(TLSD) THEN
                CALL PUTCONJ(C,NSUP)
                CALL PUTCONJ(C(1,NSUP+1,1),NSDOWN)
              ELSE
                CALL PUTCONJ(C,NSTATE)
              ENDIF
            ENDIF
            IF(NSTATE.GT.NSTATE0) THEN
              NOORTHO=NSTATE-NSTATE0
C             We orthogonalize.
              IF(TKPNT) THEN
                CALL MEMORY(IP_SMAT,2*NSTATE*NSTATE,'SMAT')
                CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
                IF(TLSD) THEN
                  IF(NSUP.GT.NSTATE0) THEN
                    CALL GS_ORTHO_C(C(1,1,IKIND),NSTATE0,
     *                   C(1,NSTATE0+1,IKIND),NSUP,SMAT,ISMA)
C                   We copy UP states  to DOWN states.
                    CALL DCOPY(2*NGWK*NSDOWN,C(1,1,IKIND),1,
     &                   C(1,NSUP+1,IKIND),1)
                  ELSEIF(NSUP.EQ.NSTATE0) THEN
C                   We copy UP states  to DOWN states.
                    CALL DCOPY(2*NGWK*NSDOWN,C(1,1,IKIND),1,
     &                   C(1,NSUP+1,IKIND),1)
                  ELSE
C                   We orthogonalize only the down states.
                    NORTHO=NSTATE0-NSUP
                    CALL GS_ORTHO_C(C(1,NSUP+1,IKIND),NORTHO,
     *                   C(1,NSUP+NORTHO+1,IKIND),NOORTHO,
     &                   SMAT,ISMA)
                  ENDIF
                ELSE
                  CALL GS_ORTHO_C(C(1,1,IKIND),NSTATE0,
     *                 C(1,NSTATE0+1,IKIND),NOORTHO,
     .                 SMAT,ISMA)
                ENDIF
              ELSE
                CALL MEMORY(IP_SMAT,NSTATE*NSTATE,'SMAT')
                CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
                IF(TLSD) THEN
                  IF(NSUP.GT.NSTATE0) THEN
                    CALL GS_ORTHO  (C(1,1,IKIND),NSTATE0,
     *                   C(1,NSTATE0+1,IKIND),NSUP,SMAT,ISMA)
C                   We copy UP states  to DOWN states.
                    CALL DCOPY(2*NGWK*NSDOWN,C(1,1,IKIND),1,
     &                   C(1,NSUP+1,IKIND),1)
                  ELSEIF(NSUP.EQ.NSTATE0) THEN
C                   We copy UP states  to DOWN states.
                    CALL DCOPY(2*NGWK*NSDOWN,C(1,1,IKIND),1,
     &                   C(1,NSUP+1,IKIND),1)
                  ELSE
C                   We orthogonalize only the down states.
                    NORTHO=NSTATE0-NSUP
                    CALL GS_ORTHO  (C(1,NSUP+1,IKIND),NORTHO,
     *                   C(1,NSUP+NORTHO+1,IKIND),NOORTHO,SMAT,ISMA)
                  ENDIF
                ELSE
                  CALL GS_ORTHO  (C(1,1,IKIND),NSTATE0,
     &                 C(1,NSTATE0+1,IKIND),NOORTHO,SMAT,ISMA)
                ENDIF
              ENDIF             !IF(TKPNT)
              CALL FREEM(IP_SMAT)
              CALL FREEM(IP_ISMA)
            ELSEIF(PARENT) THEN
C             NSTATE0.GE.NSTATE
              NX=NSTATE0-NSTATE
              DO I=1,NX
                NREAD=NREAD+1
                READ(NR)
                READ(NR)
              ENDDO
            ENDIF               !IF(NSTATE.GT.NSTATE0)
          ELSE
C           We have more k points -> we use the set of nstate
C           for ikind=1.
            IF(IKIND.NE.1) THEN
              CALL DCOPY(2*NGWK*NSTATE,C(1,1,1),1,C(1,1,IKIND),1)
            ELSE
C             All the block has to be copied. Do nothing.
              GOTO 100
            ENDIF
          ENDIF                 !IF(IKPT0.LE.KPTS0)
        ENDDO                   !DO IKIND
 100    CONTINUE
        IF(TKBLOCK) CALL WKPT_SWAP(C,NSTATE,IKPT,TAG)
      ENDDO                     !DO IKPT
C     ==--------------------------------------------------------------==
 200  CONTINUE
      IF(N0.GT.NREAD.AND.PARENT) THEN
        NX=N0-NREAD
        DO I=1,NX
          READ(NR)
          READ(NR)
        ENDDO
      ENDIF
      IF(PARENT) THEN
        CALL FREEM(IP_CA)
        CALL FREEM(IP_ICMP)
#ifdef PARALLEL
        CALL FREEM(IP_CR)
        CALL FREEM(IP_MAPW)
#endif
      ENDIF
C     ==--------------------------------------------------------------==
 400  CONTINUE
      CALL TIHALT('   RD30WFN',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RDWFN(NR,C,CA,CR,ICMP,MAPW,NGWKS0,ICOMPR,SCALE,TKPNT0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'kpts.inc'
C     Arguments
      INTEGER    NR,MAPW(*),NGWKS0,ICOMPR
      INTEGER    ICMP(*)
      COMPLEX*16 C(NGWK),CA(NGWKS0),CR(2*NGWK)
      REAL*8     SCALE
      LOGICAL    TKPNT0
#ifdef PARALLEL
C     Variables
      INTEGER    NGWS0,NX,IP,IG,NGWIP,MSGID,MSGLEN,NBYTES
C     ==--------------------------------------------------------------==
      IF(TKPNT0.AND.TKPNT) THEN
        NGWS0=NGWKS0/2
      ELSE
        NGWS0=NGWKS0
      ENDIF
      IF(PARENT) THEN
        READ(NR,END=20,ERR=30) NX
        CALL READ_N(NR,ICMP,NX)
        CALL DECOMPR(2*NGWKS0,CA,ICMP,SCALE,ICOMPR,NX)
        CALL ZAZZERO(C,NGWK)
        CALL ZAZZERO(CR,2*NGWK)
      ENDIF
      DO IP=0,NPROC-1
        IF(PARENT) THEN
          IF(PGROUP(IP+1).EQ.ME) THEN
            DO IG=1,SPARM(3,IP)
              IF(MAPGP(IG).LE.NGWS0) C(IG)=CA(MAPGP(IG))
            ENDDO
            IF(TKPNT0.AND.TKPNT) THEN
              NGWIP=SPARM(3,IP)
              DO IG=1,NGWIP
                IF(MAPGP(IG).LE.NGWS0)
     &               C(NGWIP+IG)=CA(NGWS0+MAPGP(IG))
              ENDDO
            ENDIF
          ELSE
            MSGID=1
            MSGLEN = SPARM(3,IP) * 8/IRAT
            CALL MY_BRECV(MAPW,MSGLEN,PGROUP(IP+1),MSGID,NBYTES)
            DO IG=1,SPARM(3,IP)
              IF(MAPW(IG).LE.NGWKS0) CR(IG)=CA(MAPW(IG))
            ENDDO
            IF(TKPNT0.AND.TKPNT) THEN
              NGWIP=SPARM(3,IP)
              DO IG=1,NGWIP
                IF(MAPW(IG).LE.NGWS0) CR(NGWIP+IG)=CA(NGWS0+MAPW(IG))
              ENDDO
            ENDIF
            MSGID=2
            IF(TKPNT0.AND.TKPNT) THEN
              MSGLEN = 2 * 2 * SPARM(3,IP) * 8
            ELSE
              MSGLEN =     2 * SPARM(3,IP) * 8
            ENDIF
            CALL MY_BSEND(CR,MSGLEN,PGROUP(IP+1),MSGID)
          ENDIF
        ELSE
          IF(PGROUP(IP+1).EQ.ME) THEN
            MSGID=1
            MSGLEN = NGW * 8/IRAT
            CALL MY_BSEND(MAPGP,MSGLEN,PGROUP(1),MSGID)
            MSGID=2
            MSGLEN = 2 * NGWK * 8
            CALL MY_BRECV(C,MSGLEN,PGROUP(1),MSGID,NBYTES)
          ENDIF
        ENDIF
        CALL MY_SYNC(ALLGRP)
      ENDDO
#else
C     Variables
      INTEGER    NX
C     ==--------------------------------------------------------------==
      READ(NR,END=20,ERR=30) NX
      CALL READ_N(NR,ICMP,NX)
      CALL ZAZZERO(CA,NGWK)
      CALL DECOMPR(2*NGWKS0,CA,ICMP,SCALE,ICOMPR,NX)
      CALL DCOPY(2*NGWK,CA(1),1,C(1),1)
#endif
C     ==--------------------------------------------------------------==
      RETURN
 20   CONTINUE
      CALL STOPGM('RDWFN','END OF FILE')
 30   CONTINUE
      CALL STOPGM('RDWFN','READ ERROR')
      END
C     ==================================================================
      SUBROUTINE WRITE_N(NW,IERROR,X,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NW,IERROR,N
      REAL*8 X(N)
C     ==--------------------------------------------------------------==
      WRITE(UNIT=NW,IOSTAT=IERROR) X
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE READ_N(NR,X,N)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NR,N
      REAL*8 X(N)
C     ==--------------------------------------------------------------==
      READ(NR,END=20,ERR=30) X
C     ==--------------------------------------------------------------==
      RETURN
 20   CONTINUE
      CALL STOPGM('READ_N','END OF FILE')
 30   CONTINUE
      CALL STOPGM('READ_N','READ ERROR')
      END
C     ==================================================================
      SUBROUTINE PWTOAO(NW,IERROR,NSTATE,NKPOINT,C0,TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'atwf.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'kpts.inc'
C     Arguments
      INTEGER    NW,IERROR,NSTATE,NKPOINT
      COMPLEX*16 C0(NGWK,NSTATE)
      REAL*8     TAU0(3,NAX,NSX)
C     Variables
      DIMENSION  CATOM(NGWK,NATTOT)
      REAL*8     FOC(M1SHLX),COMPL(NATTOT),SCR(NATTOT*NATTOT)
      INTEGER    IPIV(NATTOT)
      POINTER    (IP_IPIV,IPIV),(IP_COMPL,COMPL),(IP_SCR,SCR)
      INTEGER    ISUB,IS,LSCR,IAORB,IAT,IA,IXX,
     &           IRECORD,ICOMPR,I,INFO,NATST,ALLOC
      REAL*8     DOTP,SFC,SCALE
      EXTERNAL   DOTP
      LOGICAL    TLSD2
C     ==--------------------------------------------------------------==
      CALL TISET('    PWTOAO',ISUB)
      IF(TKPNT)CALL STOPGM('WR30FN','K-POINTS NOT IMPLEMENTED')
C     Initialize
      CALL PHFAC(TAU0)
      ALLOC=MAX(NATTOT*NATTOT,NATTOT*NSTATE)
      CALL MEMORY(IP_XXMAT,ALLOC,'XXMAT')
      CALL MEMORY(IP_XSMAT,ALLOC,'XSMAT')
      CALL MEMORY(IP_CATOM,2*NGWK*NATTOT,'CATOM')
      LSCR=ALLOC
      CALL MEMORY(IP_SCR,LSCR,'SCR')
      IF(PARENT) THEN
        ALLOC=MAX(NATTOT,NSTATE)
        CALL MEMORY(IP_IPIV,ALLOC,'IPIV')
        CALL MEMORY(IP_COMPL,ALLOC,'COMPL')
      ENDIF
C     ==--------------------------------------------------------------==
C     Calculate Atomic orbitals
      IAORB=1
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          CALL LOADC(CATOM(1,IAORB),FOC,NGWK,NGW,NATTOT-IAORB+1,
     &               IS,IAT,NATST)
          DO IXX=IAORB,IAORB+NATST-1
            SFC=DOTP(NGW,CATOM(1,IXX),CATOM(1,IXX))
#ifdef PARALLEL
            CALL GLOSUM(1,SFC)
#endif
            SFC=1.D0/SQRT(SFC)
            CALL DSCAL(2*NGW,SFC,CATOM(1,IXX),1)
          ENDDO
          IAORB=IAORB+NATST
        ENDDO
      ENDDO
C     Overlap matrices
      TLSD2=TLSD
      TLSD=.FALSE.
C     <AO|AO>
      CALL OVLAP(NATTOT,XSMAT,CATOM,CATOM)
      TLSD=TLSD2
#ifdef PARALLEL
      CALL SUMMAT(XSMAT,NATTOT,SCR,LSCR)
#endif
      IF(TKPNT) CALL SETKWF(NGW,NATTOT,CATOM)
C     <AO|PSI>
      CALL OVLAP2(NGW,NATTOT,NSTATE,XXMAT,CATOM,C0)
#ifdef PARALLEL
      CALL GLOSUM(NATTOT*NSTATE,XXMAT)
#endif
      IF(PARENT) THEN
        CALL DCOPY(NATTOT*NATTOT,XSMAT(1,1),1,SCR(1),1)
C       Calculate expansion coefficients
        CALL DGESV(NATTOT,NSTATE,XSMAT,NATTOT,IPIV,XXMAT,NATTOT,INFO)
C       Write expansion coefficients to restart file
        IRECORD=4
        ICOMPR=-1
        SCALE=1.D0
        WRITE(UNIT=NW,IOSTAT=IERROR) IRECORD
        WRITE(UNIT=NW,IOSTAT=IERROR) NSTATE,NGWKS,ICOMPR,SCALE
        WRITE(UNIT=NW,IOSTAT=IERROR) NATTOT,NSTATE
        CALL WRITE_N(NW,IERROR,XXMAT,NATTOT*NSTATE)
C       Calculate completness of basis
        CALL CALCCO(XXMAT,SCR,COMPL,NATTOT,NSTATE)
        WRITE(6,'(/,A)') ' COMPLETNESS OF ATOMIC PROJECTION '
        WRITE(6,'(12F5.2)') (COMPL(I),I=1,NSTATE)
        CALL FREEM(IP_IPIV)
        CALL FREEM(IP_COMPL)
      ENDIF
C     Deallocate memory
      CALL FREEM(IP_XXMAT)
      CALL FREEM(IP_XSMAT)
      CALL FREEM(IP_CATOM)
      CALL FREEM(IP_SCR)
      CALL TIHALT('    PWTOAO',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE AOTOPW(NR,C0,NSTATE,TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'atwf.inc'
      INCLUDE 'kpts.inc'
C     Variables
      INTEGER    NR,NSTATE
      COMPLEX*16 C0(NGWK,NSTATE)
      REAL*8     TAU0(3,NAX,NSX)
C     Variables
      DIMENSION  CATOM(NGWK,*)
      REAL*8     FOC(M1SHLX),
     &           SFC,DOTP
      EXTERNAL   DOTP
      INTEGER    ISUB,IS,IA,IAORB,IAT,IXX,NATOM,NST,NATST,ALLOC
#ifdef PARALLEL
      INTEGER    MSGLEN
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('    AOTOPW',ISUB)
      IF(TKPNT)CALL STOPGM('WR30FN','K-POINTS NOT IMPLEMENTED')
C     Initialize
      CALL PHFAC(TAU0)
      ALLOC=MAX(NATTOT*NATTOT,NATTOT*NSTATE)
      CALL MEMORY(IP_XXMAT,ALLOC,'XXMAT')
      CALL MEMORY(IP_CATOM,2*NGW*NATTOT,'CATOM')
C     ==--------------------------------------------------------------==
C     Calculate Atomic orbitals
      IAORB=1
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          CALL LOADC(C0,FOC,NGW,NGW,NSTATE,IS,IAT,NATST)
          DO IXX=1,NATST
            SFC=DOTP(NGW,C0(1,IXX),C0(1,IXX))
#ifdef PARALLEL
            CALL GLOSUM(1,SFC)
#endif
            SFC=1.D0/SQRT(SFC)
            CALL DSCAL(2*NGW,SFC,C0(1,IXX),1)
          ENDDO
          CALL DCOPY(2*NGW*NATST,C0(1,1),1,CATOM(1,IAORB),1)
          IAORB=IAORB+NATST
        ENDDO
      ENDDO
      IF(PARENT) THEN
C       Read Restart file
        READ(NR) NATOM,NST
        IF(NATOM.NE.NATTOT) THEN
          WRITE(6,*) ' AOTOPW| ATOMIC ORBITAL BASIS HAS CHANGED'
          CALL STOPGM('AOTOPW',' CHANGE OF BASIS')
        ENDIF
        CALL DURAND(123456.D0,NATTOT*NATTOT,XXMAT)
        CALL READ_N(NR,XXMAT,NATTOT*NST)
      ENDIF
#ifdef PARALLEL
      MSGLEN = NATTOT*NSTATE * 8
      CALL MY_BCAST(XXMAT,MSGLEN,SOURCE,ALLGRP)
#endif
C     Calculate MO  
      IF(NGW.GT.0)
     *   CALL DGEMM('N','N',2*NGW,NSTATE,NATTOT,1.0D0,CATOM(1,1),
     *              2*NGW,XXMAT(1,1),NATTOT,0.0D0,C0(1,1),2*NGW)
      CALL FREEM(IP_XXMAT)
      CALL FREEM(IP_CATOM)
      CALL TIHALT('    AOTOPW',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CALCCO(XXMAT,XSMAT,COMPL,NATTOT,NST)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      INTEGER NATTOT,NST
      REAL*8 XXMAT(NATTOT,NST),XSMAT(NATTOT,NATTOT),COMPL(NST)
C     Variables
      INTEGER I,K,L
C     ==--------------------------------------------------------------==
      DO I=1,NST
        DO K=1,NATTOT
          DO L=1,NATTOT
            COMPL(I)=COMPL(I)+XXMAT(K,I)*XSMAT(K,L)*XXMAT(L,I)
          ENDDO
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE PUTCONJ(C0,NSTATE)
C     ==--------------------------------------------------------------==
C     == MULTIPLY BY A COMPLEX TO HAVE C0(1) REAL                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'geq0.inc'
      REAL*8    EPS
      PARAMETER (EPS=1.D-10)
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,NSTATE)
C     Variables
      INTEGER    I,NR,MSGLEN
      COMPLEX*16 ZZ
      REAL*8     ZI,SMAT(*),ISMA(*)
      POINTER    (IP_SMAT,SMAT),(IP_ISMA,ISMA)
C     ==--------------------------------------------------------------==
      NR=0
      DO I=1,NSTATE
        IF(GEQ0) THEN
          ZZ=C0(1,I)
          ZI=ABS(DIMAG(C0(1,I)))
        ENDIF
        MSGLEN = 2 * 8
        CALL MY_BCAST(ZZ,MSGLEN,IGEQ0,ALLGRP)
        MSGLEN = 1 * 8
        CALL MY_BCAST(ZI,MSGLEN,IGEQ0,ALLGRP)
        IF(ABS(ZZ).GT.EPS.AND.ZI.GT.EPS) THEN
          ZZ=ABS(ZZ)/ZZ
          CALL ZSCAL(NGW,ZZ,C0(1,1),1)
          NR=NR+1
        ENDIF
      ENDDO
      IF(NR.GT.0) THEN
        CALL MEMORY(IP_SMAT,NSTATE*NSTATE,'SMAT')
        CALL MEMORY(IP_ISMA,NSTATE,'ISMA')
        CALL RGS(C0,NSTATE,SMAT,ISMA)
        CALL FREEM(IP_SMAT)
        CALL FREEM(IP_ISMA)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

