C     ==================================================================
cnew
      SUBROUTINE WR_TEMPS(NFI,EKINC,TEMPP)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      REAL*8 EKINC(*),TEMPP(*)
      INTEGER NFI
C     Variables
      REAL*8  TP1,TPM,ET1,ETM,ETP1,ETPM,ETE1,ETEM
      REAL*8  ETPTEMP(MAXNP),ETETEMP(MAXNP)
      LOGICAL FERROR
      CHARACTER*100 FTEMPS
      CHARACTER*10  FNAME
C     FILE NAME OF TEMPERATURE MONITOR FILE: 
      DATA          FNAME /'PITEMP    '/
      INTEGER IFIRST,IA,IE,IP,IPP,K
      DATA    IFIRST /FO_VERB/
      SAVE    IFIRST
C     ==--------------------------------------------------------------==
      IF(GRANDPARENT) THEN
        CALL FILEOPEN(4,FNAME,FO_APP+IFIRST,FERROR)
        IFIRST=0
      ENDIF
      CALL AZZERO(ETPTEMP,MAXNP)
      CALL AZZERO(ETETEMP,MAXNP)
      IF(PARENT) THEN
        DO IP=NP_LOW,NP_HIGH
          IPP=MIN(2,IP)
          DO K=1,NTHERM(IPP)
            ETPTEMP(IP)=ETPTEMP(IP)+FACTEM*QNOSPM(K,1,IP)*
     *                                ETAPMDOT(K,1,IP)**2
          ENDDO
          ETPTEMP(IP)=ETPTEMP(IP)/DBLE(NTHERM(IPP))
          IF (TNOSEE)
     *       ETETEMP(IP)=ETETEMP(IP)+0.5D0*QNOSEE(1)*ETADOT(1,IP)**2
        ENDDO
      ENDIF
      CALL GLOBAL(ETPTEMP,1)
      CALL GLOBAL(ETETEMP,1)
      IF(GRANDPARENT) THEN
        TP1=TEMPP(1)
        ET1=EKINC(1)
        ETP1=ETPTEMP(1)
        ETE1=ETETEMP(1)
        TPM=0.D0
        ETM=0.D0
        ETPM=0.D0
        ETEM=0.D0
        DO IP=2,NP_TOTAL
          TPM=TPM+TEMPP(IP)
          ETM=ETM+EKINC(IP)
          ETPM=ETPM+ETPTEMP(IP)
          ETEM=ETEM+ETETEMP(IP)
        ENDDO
        TPM=TPM/DBLE(NP_TOTAL-1)
        ETM=ETM/DBLE(NP_TOTAL-1)
        ETPM=ETPM/DBLE(NP_TOTAL-1)
        ETEM=ETEM/DBLE(NP_TOTAL-1)
C
        ETE1=ETE1*DBLE(NEDOF)
        ETEM=ETEM*DBLE(NEDOF)
C       WRITE TEMPERATURE MONITOR FILE 
C       NOTE  only the first thermostat in the Nose-Hoover chain is
C             considered in all cases
C       NFI   time step
C       TP1   ionic      temperature of IP=1 (centroid)  
C       TPM   ionic      temperature averaged over IP=2,NP 
C       ET1   electronic temperature of IP=1 (centroid)
C       ETM   electronic temperature averaged over IP=2,NP
C       ETP1  temperature of ionic      thermostat of IP=1 (centroid)  
C       ETPM  temperature of ionic      thermostat averaged over IP=2,NP
C       ETE1  temperature of electronic thermostat of IP=1 (centroid)
C       ETEM  temperature of electronic thermostat averaged over IP=2,NP
        WRITE(4,'(I7,F7.1,F7.1,F10.5,F10.5,F7.1,F7.1,F10.5,F10.5)') 
     *            NFI,TP1,TPM,ET1,ETM,ETP1,ETPM,ETE1,ETEM
        CALL FILECLOSE(4)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
cnew
C     ==================================================================

