C     ==================================================================
      SUBROUTINE WRCCFL(ETOTLS,ETOTBS,ETOTHS)
C CB: Writes BS dynamics results into a file      
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include   'system.h'
      include   'bsym.inc'
      include   'ropt.inc'
      include   'fileopen.inc'
C     Arguments
      real*8    ETOTLS,ETOTBS,ETOTHS
C     Variables
      character FNAME*100
      integer   IUNIT
      parameter (IUNIT=33)
      logical   FERROR
      real*8    COUPLJ,JWN
C     ==--------------------------------------------------------------==
      FNAME='BS_ENERG'
      CALL FILEOPEN(IUNIT,FNAME,FO_APP,FERROR)
C     ==--------------------------------------------------------------==
      COUPLJ = (ETOTHS - ETOTBS) * RTSASB
      JWN=COUPLJ*AUTOCM
C     ==--------------------------------------------------------------==
      print *
      if((INFI.le.1).or.(INFI.eq.NOMORE)) then
        print '(A47,F17.8,A7)',
     &        'The projected energy of the low spin state is:',
     &         ETOTLS, 'a.u.'
        print '(A47,F17.8,A7)',
     &        'The coupling constant J is                   :',
     &         COUPLJ, 'a.u.'
        print '(A47,F17.3,A7)', '~', JWN, 'cm^-1.'
      else
        print '(A30,F17.8,A7)',
     &        'The coupling constant J is ~ :',
     &         JWN, 'cm^-1.'
      endif
      print *
      write(IUNIT,'(I10,F18.10,F18.10,F18.10,F18.10,F9.2)')
     &             NFI,ETOTLS,ETOTBS,ETOTHS,COUPLJ,JWN 
C     ==--------------------------------------------------------------==
      CALL FILECLOSE(IUNIT)
C     ==--------------------------------------------------------------==
      END 
