C     ==================================================================
      SUBROUTINE WRPRINT_WFOPT(EIGV,F,AMU,NSTATE,
     &                         ETOT,ETOT0,TCPU,GEMAX,CNORM,THL,
     &                         CONVERGENCE,NFI,INFI)
C     ==--------------------------------------------------------------==
C     == PRINT FOR WAVEFUNCTIONS OPTIMIZATION                         ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'store.inc'
C     Arguments
      INTEGER NSTATE,NFI,INFI
      REAL*8 EIGV(NSTATE,NKPTS),F(NSTATE,NKPTS),AMU,
     &       ETOT,ETOT0,TCPU,GEMAX,CNORM,THL(2)
      LOGICAL CONVERGENCE
C     Variables
      REAL*8  TTHL,DETOT
      LOGICAL OK_PRINT
      LOGICAL ENGPRI,TEND
C     ==--------------------------------------------------------------==
      IF(.NOT.PARENT) RETURN
      DETOT=ETOT-ETOT0
      IF(INFI.EQ.1) DETOT=0.0D0
      ENGPRI=MOD(INFI-1,IPRINT_STEP).EQ.0.AND.INFI.GE.0
      TEND=INFI.EQ.1.OR.INFI.EQ.NOMORE.OR.CONVERGENCE
      IF(TDIAG) THEN
        IF(OK_PRINT(IPRINT(IPRINT_EIGEN),ENGPRI,TEND))
     &       CALL WREIGEN(EIGV,F,AMU,NSTATE)
        IF(OK_PRINT(IPRINT(IPRINT_INFO),ENGPRI,TEND)) CALL WRENER
        TTHL=THL(1)
        IF(TLSD) TTHL=0.5D0*(THL(1)+THL(2))
        WRITE(6,'(" ==",60("-"),"==")')
        WRITE(6,'(A12,I7,T25,A6,F14.6,T48,A5,F10.2,A3) ')
     *       ' ==     NFI=',NFI,  ' ETOT=',ETOT, 'TCPU=',TCPU,' =='
        WRITE(6,'(A12,1PE10.3,T25,A6,1PE14.3,T48,A5,1PE10.3,A3) ')
     *       ' == DRHOMAX=',GEMAX,'DETOT=',DETOT,' THL=',TTHL,' =='
        WRITE(6,'(" ==",60("-"),"==")')
      ELSE
        IF(INFI.EQ.0) WRITE(6,'(2A)') ' NFI      GEMAX       CNORM',
     *         '           ETOT        DETOT      TCPU'
        IF (ABS(CNORM).LT.1.D-20) CNORM=0.D0
        IF( (NFI.EQ.1.AND.INFI.GE.0) ) THEN
          IF(TFRHO_UPW)  THEN
            WRITE(6,'(2A)') ' NFI      GEMAX       CNORM',
     *         '        H-TRACE       DTRACE      TCPU'
          ELSE
            CALL WRENER
            WRITE(6,'(2A)') ' NFI      GEMAX       CNORM',
     *         '           ETOT        DETOT      TCPU'
          ENDIF
        ENDIF
        WRITE(6,'(I4,1PE11.3,1PE12.3,0PF15.6,1PE13.3,0PF10.2) ')
     *       NFI,GEMAX,CNORM,ETOT,DETOT,TCPU
        IF(.NOT.(NFI.EQ.1.AND.INFI.GE.0) .AND.
     &     OK_PRINT(IPRINT(IPRINT_INFO),ENGPRI,.FALSE.)) THEN
          IF(TFRHO_UPW)  THEN
            WRITE(6,'(2A)') ' NFI      GEMAX       CNORM',
     *         '        H-TRACE       DTRACE      TCPU'
          ELSE
            CALL WRENER
            WRITE(6,'(2A)') ' NFI      GEMAX       CNORM',
     *         '           ETOT        DETOT      TCPU'
          ENDIF
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
      ETOT0=ETOT
      CALL MY_FLUSH(6)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRPRINT_GEOPT(EIGV,F,AMU,NSTATE,TAU0,FION,ETOT,ETOT0,
     &                         TCPU,GEMAX,GNMAX,DXMAX,GNORM,CNMAX,DSTRE,
     &                         DSMAX,CONVERGENCE,IFCALC,INFI0)
C     ==--------------------------------------------------------------==
C     == PRINT FOR GEOMETRY OPTIMIZATION                              ==
C     ==--------------------------------------------------------------==
C     == EIGV(NSTATE,NKPTS) Eigenvalues                               ==
C     == F(NSTATE,NKPTS)    Occupation numbers                        ==
C     == AMU                Chemical potential                        ==
C     == NSTATE             Number of states                          ==
C     == TAU0(3,NAX,NSX)    Atomic positions                          ==
C     == FION(3,NAX,NSX)    Atomic forces                             ==
C     == ETOT               Total energy                              ==
C     == ETOT0              Reference total energy                    ==
C     == TCPU               CPU time                                  ==
C     == GEMAX              Max. change in wavefunction components    ==
C     ==                    (or for TDIAG, max. change for density)   ==
C     == GNMAX              Max. force components                     ==
C     == DXMAX              Max. atomic position change               ==
C     == GNORM              Norm of Forces                            ==
C     == CNMAX              Max. Constraint components                ==
C     == DSTRE              Sum Abs(HTFOR)                            ==
C     == DSMAX              Max(HTFOR)                                ==
C     == CONVERGENCE        .TRUE. if convergence                     ==
C     == IFCALC             Total number of iterations                ==
C     == INFI0              Number of steps for geometry optimisation ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'store.inc'
      INCLUDE 'ropt.inc'        !CALSTE
C     Arguments
      INTEGER NSTATE,IFCALC,INFI0
      REAL*8 EIGV(NSTATE,NKPTS),F(NSTATE,NKPTS),AMU,
     &       TAU0(3,NAX,NSX),FION(3,NAX,NSX),
     &       ETOT,ETOT0,TCPU,GEMAX,GNMAX,DXMAX,GNORM,CNMAX,DSTRE,DSMAX
      LOGICAL CONVERGENCE
C     Variables
      REAL*8  DETOT
      LOGICAL OK_PRINT
      LOGICAL ENGPRI0,TEND
C     ==--------------------------------------------------------------==
      IF(.NOT.PARENT) RETURN
      IF(.NOT.TDIAG.AND.INFI0.EQ.0) THEN
        WRITE(6,'(2A)') ' NFI      GEMAX       CNORM',
     *         '           ETOT        DETOT      TCPU'
        RETURN
      ENDIF
      DETOT=ETOT-ETOT0
      IF(INFI0.EQ.1) DETOT=0.0D0
      ENGPRI0=MOD(INFI0,IPRINT_STEP).EQ.0
      TEND=INFI0.EQ.NOMORE.OR.CONVERGENCE
      IF(TDIAG) THEN
        IF(OK_PRINT(IPRINT(IPRINT_EIGEN),ENGPRI0,TEND))
     &       CALL WREIGEN(EIGV,F,AMU,NSTATE)
      ENDIF
      IF(OK_PRINT(IPRINT(IPRINT_INFO),ENGPRI0,TEND)) CALL WRENER
      IF(IPRINT(IPRINT_FORCE).GT.0) THEN
        CALL WRGEOF(TAU0,FION)
        CALL WRGEOX(TAU0)
      ELSEIF(IPRINT(IPRINT_COOR).NE.-1) THEN
        CALL CNSTPR
        CALL WRGEO(TAU0)
        CALL WRGEOX(TAU0)
      ENDIF
      IF(CALSTE) CALL WRSTRESS
      IF(TPRCP)  CALL WRCELL
      WRITE(6,'(1X,64("*"))')
      WRITE(6,'(A,I6,A,I7,A)') ' *** TOTAL STEP NR.',IFCALC,
     &       '           GEOMETRY STEP NR.',INFI0,'  ***'
      IF(DXMAX.EQ.0.D0) THEN
        WRITE(6,'(A,1PE14.6,T40,A7,0PF14.6,A5)')
     &       ' *** GNMAX=',GNMAX,'  ETOT=',ETOT,'  ***'
      ELSE
        WRITE(6,'(A,1PE14.6,A,1PE8.2,T36,A11,0PF14.6,A5)')
     &       ' *** GNMAX=',GNMAX,' [',DXMAX,']     ETOT=',ETOT,'  ***'
      ENDIF
      WRITE(6,'(A,1PE14.6,T40,A7,1PE14.3,A5)')
     &       ' *** GNORM=',GNORM,' DETOT=',DETOT,'  ***'
      WRITE(6,'(A,1PE14.6,T40,A7,0PF14.2,A5)')
     &       ' *** CNSTR=',CNMAX,'  TCPU=',TCPU,'  ***'
      IF(TPRCP)
     &     WRITE(6,'(A,1PE14.6,T40,A7,1PE14.3,A5)')
     &       ' *** DSTRE=',DSTRE,'[DSMAX=',DSMAX,'] ***'
      WRITE(6,'(1X,64("*"))')
C     ==--------------------------------------------------------------==
      ETOT0=ETOT
      CALL MY_FLUSH(6)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRPRINT_MD(EIGV,F,AMU,NSTATE,TAU0,FION,
     &                      EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,
     &                      TCPU,CONVERGENCE,NFI,INFI)
C     ==--------------------------------------------------------------==
C     == PRINT FOR MOLECULAR DYNAMICS                                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'store.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'temps.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'cdft.inc'
C     Arguments
      INTEGER NSTATE,NFI,INFI
      REAL*8 EIGV(NSTATE,NKPTS),F(NSTATE,NKPTS),AMU,
     &       TAU0(3,NAX,NSX),FION(3,NAX,NSX),
     &       EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU
      LOGICAL CONVERGENCE
C     Variables
      LOGICAL OK_PRINT
      LOGICAL ENGPRI,TEND
C     ==--------------------------------------------------------------==
      IF(.NOT.PARENT) RETURN
      IF(TDIAG) THEN
        TEND=(INFI.EQ.0).OR.(INFI.EQ.NOMORE).OR.CONVERGENCE
        ENGPRI=MOD(NFI-1,IPRINT_STEP).EQ.0
        IF(INFI.NE.0) THEN
          WRITE(6,'(A,A)')
     &         '   NFI   TEMPP       EKS      ECLASSIC',
     &         '         DIS           TCPU'
cmb-> DISA can become VERY big in low density/high temperature
cmb-> systems. Format set to E14.6
          WRITE(6,'(T2,I10,F8.1,F12.6,F12.6,E14.6,F9.2)')
     *         NFI,TEMPP,ETOT,ECONS,DISA,TCPU
          IF(.NOT.CDFT)THEN
            WRITE(3,'(T2,I10,F8.1,F12.6,F12.6,E14.6,F9.2)')
     *         NFI,TEMPP,ETOT,ECONS,DISA,TCPU
          ELSE
            WRITE(3,'(T2,I10,F8.1,F12.6,F12.6,E14.6,F9.2,F12.6,F12.6)')
     *         NFI,TEMPP,ETOT,ECONS,DISA,TCPU,CDFT_V,VGRAD

          ENDIF
        ENDIF
        IF(OK_PRINT(IPRINT(IPRINT_INFO),ENGPRI,TEND)) THEN
          WRITE(6,'(/,1X,64("*"))')
          WRITE(6,'(" *",T20,A,I4,T65,A)')
     &         ' RESULTS OF STEP',INFI,'*'
          WRITE(6,'(1X,64("*"))')
        ENDIF
        IF(OK_PRINT(IPRINT(IPRINT_EIGEN),ENGPRI,TEND))
     &       CALL WREIGEN(EIGV,F,AMU,NSTATE)
        IF(OK_PRINT(IPRINT(IPRINT_INFO),ENGPRI,TEND)) CALL WRENER
        IF(OK_PRINT(IPRINT(IPRINT_FORCE),ENGPRI,TEND)) THEN
          CALL WRGEOF(TAU0,FION)
        ELSEIF(OK_PRINT(IPRINT(IPRINT_COOR),ENGPRI,TEND)) THEN
          CALL CNSTPR
          CALL WRGEO(TAU0)
        ENDIF
        IF(OK_PRINT(IPRINT(IPRINT_INFO),ENGPRI,TEND)) THEN
          WRITE(6,'(1X,64("*"),/)')
        ENDIF
      ELSE
        IF(INFI.EQ.NOMORE) GOTO 100
        TEND=INFI.EQ.1.OR.INFI.EQ.NOMORE.OR.CONVERGENCE
        ENGPRI=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
        IF(OK_PRINT(IPRINT(IPRINT_FORCE),ENGPRI,TEND)) THEN
          CALL WRGEOF(TAU0,FION)
          IF(BSYMM) WRITE(6,*)
        ELSEIF(OK_PRINT(IPRINT(IPRINT_COOR),ENGPRI,TEND)) THEN
          CALL CNSTPR
          CALL WRGEO(TAU0)
        ENDIF
        IF(OK_PRINT(IPRINT(IPRINT_INFO),ENGPRI,TEND)) THEN
           CALL CNSTPR
           IF(.NOT.BSYMM) CALL WRENER
           IF(.NOT.(INFI.EQ.NOMORE.OR.CONVERGENCE)) THEN
             IF(TMDBO) THEN
               WRITE(6,'(T6,A,A,11X,A,6X,A,A,A)')
     &          '  NFI','   TEMPP','EKS','ECLASSIC',
     &          '         DIS','    TCPU'
             ELSE IF(qmmm) THEN
               WRITE(6,'(T6,A,A,A,11X,A,6X,A,10X,A,A,A,A)')
     .         '  NFI','    EKINC','   TEMPP','EKS','ECLASSIC','EHAM'
     .        ,'           EQM','         DIS','    TCPU'
             ELSE
               WRITE(6,'(T6,A,A,A,11X,A,6X,A,10X,A,A,A)')
     &          '  NFI','    EKINC','   TEMPP','EKS','ECLASSIC','EHAM',
     &          '         DIS','    TCPU'
             ENDIF
           ENDIF
        ELSE IF(TMDFILE) THEN 
           IF(TMDBO) THEN
             WRITE(6,'(T6,A,A,11X,A,6X,A,A,A)')
     &         '  NFI','   TEMPP','EKS','ECLASSIC',
     &         '         DIS','    TCPU'
           ELSE
             WRITE(6,'(T6,A,A,A,11X,A,6X,A,10X,A,A,A)')
     &         '  NFI','    EKINC','   TEMPP','EKS','ECLASSIC','EHAM',
     &         '         DIS','    TCPU'
           ENDIF
        ENDIF
cmb-> DISA can become VERY big in low density/high temperature
cmb-> systems. Format set to  E10.3 and E14.6
100     CONTINUE
        IF(TMDBO) THEN
          WRITE(6,'(I10,F8.1,F14.5,F14.5,E12.3,F8.2)')
     &       NFI,TEMPP,ETOT,ECONS,DISA,TCPU
        ELSE IF(qmmm) THEN
          WRITE(6,'(I10,F9.5,F8.1,4F14.5,E12.3,F8.2)')
     &       NFI,EKINC,TEMPP,ETOT,ECONS,EHAM,EQM,DISA,TCPU
        ELSE
          WRITE(6,'(I10,F9.5,F8.1,F14.5,F14.5,F14.5,E12.3,F8.2)')
     &       NFI,EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU
        ENDIF
        IF(.NOT.CDFT)THEN
          WRITE(3,'(I10,F12.8,F9.3,F18.10,F18.10,F18.10,E15.6,F9.2)')
     &       NFI,EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU
        ELSE
          WRITE(3,'(I10,F12.8,F9.3,F18.10,F18.10,F18.10,E15.6,F9.2,
     *         F12.6,F12.6)')
     &       NFI,EKINC,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU,CDFT_V,VGRAD
        ENDIF
        IF(TCLAS)
     &       WRITE(15,'(I10,3(F9.3,3X))') NFI,TEMPCM,TEMPQM,TEMPP
      ENDIF
C     ==--------------------------------------------------------------==
      CALL MY_FLUSH(6)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRPRINT_PR(EKINC,EKINH,TEMPP,ETOT,ECONS,
     *                      EHAM,DISA,TAU0,FION,TCPU,NFI,INFI)
C     ==--------------------------------------------------------------==
C     == PRINT FOR MOLECULAR DYNAMICS                                 ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'store.inc'
C     Arguments
      INTEGER NFI,INFI
      REAL*8 EKINC,EKINH,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU,
     &       TAU0(3,NAX,NSX),FION(3,NAX,NSX)
C     Variables
      LOGICAL OK_PRINT
      LOGICAL ENGPRI,TEND
C     ==--------------------------------------------------------------==
      IF(.NOT.PARENT) RETURN
      TEND=INFI.EQ.1.OR.INFI.EQ.NOMORE
      ENGPRI=TPRINT.AND.MOD(NFI-1,IPRINT_STEP).EQ.0
      IF(OK_PRINT(IPRINT(IPRINT_FORCE),ENGPRI,TEND)) THEN
        CALL WRGEOF(TAU0,FION)
      ELSEIF(OK_PRINT(IPRINT(IPRINT_COOR),ENGPRI,TEND)) THEN
        CALL CNSTPR
        CALL WRGEO(TAU0)
      ENDIF
      IF(OK_PRINT(IPRINT(IPRINT_INFO),ENGPRI,TEND)) THEN
        CALL WRENER
        IF(INFI.NE.NOMORE) WRITE(6,'(A,A)')
     *       '    NFI    EKINC    EKINH  TEMPP           EKS      ',
     *       'ECLASSIC          EHAM         DIS     TCPU'
      ENDIF
cmb-> DISA can become VERY big in low density/high temperature
cmb-> systems. Format set to E10.3 and E14.6
      WRITE(6,'(I10,F9.5,F9.5,F8.1,3F14.5,E12.3,F9.2)')
     *         NFI,EKINC,EKINH,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU
      WRITE(3,'(I10,F12.8,F12.8,F10.3,3F18.10,E15.6,F9.2)')
     *         NFI,EKINC,EKINH,TEMPP,ETOT,ECONS,EHAM,DISA,TCPU
C     ==--------------------------------------------------------------==
      CALL MY_FLUSH(6)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRENER_INIT
C     ==--------------------------------------------------------------==
C     == INITIALISATION OF IPRINT ARRAY FOR OUTPUT                    ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !MDDIAG
      INCLUDE 'store.inc'       !IPRINT
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'        !TBOGO
      INCLUDE 'spin.inc'        !TCAS22
C     Variables
C     ==--------------------------------------------------------------==
C     General setup
C     If unspecified -> display
      IF(IPRINT(IPRINT_INFO ).NE.-1) IPRINT(IPRINT_INFO ) =  1
      IF(IPRINT(IPRINT_EHT  ).NE.-1) IPRINT(IPRINT_EHT  ) =  1
      IF(IPRINT(IPRINT_ESELF).NE.-1) IPRINT(IPRINT_ESELF) =  1
      IF(IPRINT(IPRINT_ESR  ).NE.-1) IPRINT(IPRINT_ESR  ) =  1
C     If unspecified -> do not display
      IF(IPRINT(IPRINT_EHEP ).EQ. 0) IPRINT(IPRINT_EHEP ) = -1
      IF(IPRINT(IPRINT_EHEE ).EQ. 0) IPRINT(IPRINT_EHEE ) = -1
      IF(IPRINT(IPRINT_EHII ).EQ. 0) IPRINT(IPRINT_EHII ) = -1
      IF(IPRINT(IPRINT_ELEC1).EQ. 0) IPRINT(IPRINT_ELEC1) = -1
      IF(IPRINT(IPRINT_ELEC2).EQ. 0) IPRINT(IPRINT_ELEC2) = -1
      IF(IPRINT(IPRINT_ETOT1).EQ. 0) IPRINT(IPRINT_ETOT1) = -1
      IF(IPRINT(IPRINT_EHSIC).EQ. 0) IPRINT(IPRINT_EHSIC) = -1 ! cmb_ssic
C     Special setup
      IF(TDIAG) THEN
C       For diagonalisation
C       If unspecified -> display
        IF(TFINT) THEN
          IF(IPRINT(IPRINT_EEIG ).EQ.0) IPRINT(IPRINT_EEIG ) =  1
          IF(IPRINT(IPRINT_EBAND).EQ.0) IPRINT(IPRINT_EBAND) = -1
        ELSE
          IF(IPRINT(IPRINT_EEIG ).EQ.0) IPRINT(IPRINT_EEIG ) = -1
          IF(IPRINT(IPRINT_EBAND).EQ.0) IPRINT(IPRINT_EBAND) =  1
        ENDIF
        IF(IPRINT(IPRINT_EXC  ).EQ.0) IPRINT(IPRINT_EXC  ) =  1
        IF(IPRINT(IPRINT_VXC  ).EQ.0) IPRINT(IPRINT_VXC  ) =  1
C       If unspecified -> do not display
        IF(IPRINT(IPRINT_EKIN ).EQ.0) IPRINT(IPRINT_EKIN ) = -1
        IF(IPRINT(IPRINT_EPSEU).EQ.0) IPRINT(IPRINT_EPSEU) = -1
        IF(IPRINT(IPRINT_ENL  ).EQ.0) IPRINT(IPRINT_ENL  ) = -1
        IF(IPRINT(IPRINT_ENTROPY).EQ.0) IPRINT(IPRINT_ENTROPY) = -1
        IF(IPRINT(IPRINT_ETOT2).EQ. 0) IPRINT(IPRINT_ETOT2) = -1
      ELSE
C       For Car-Parrinello scheme
C       If unspecified -> display
        IF(IPRINT(IPRINT_EKIN ).EQ.0) IPRINT(IPRINT_EKIN ) =  1
        IF(IPRINT(IPRINT_EPSEU).EQ.0) IPRINT(IPRINT_EPSEU) =  1
        IF(IPRINT(IPRINT_ENL  ).EQ.0) IPRINT(IPRINT_ENL  ) =  1
        IF(IPRINT(IPRINT_EXC  ).EQ.0) IPRINT(IPRINT_EXC  ) =  1
C       If unspecified -> do not display
        IF(IPRINT(IPRINT_VXC  ).EQ.0) IPRINT(IPRINT_VXC  ) = -1
C       Never displayed
        IPRINT(IPRINT_EBAND) = -1
        IPRINT(IPRINT_EEIG)  = -1
        IPRINT(IPRINT_ENTROPY) = -1
        IPRINT(IPRINT_EBOGO) = -1
        IPRINT(IPRINT_ETOT2) = -1
      ENDIF
C     Gradient correction
      IF(TGC) THEN
        IF(IPRINT(IPRINT_EGC  ).EQ.0) IPRINT(IPRINT_EGC  ) =  1
      ELSE
        IF(IPRINT(IPRINT_EGC  ).EQ.0) IPRINT(IPRINT_EGC  ) = -1
      ENDIF
C     Bogoliubov correction
      IF(TBOGO) THEN
        IF(IPRINT(IPRINT_EBOGO).EQ.0) IPRINT(IPRINT_EBOGO) =  1
      ELSE
        IF(IPRINT(IPRINT_EBOGO).EQ.0) IPRINT(IPRINT_EBOGO) = -1
      ENDIF
C     CAS 22 Correction
      IF(TCAS22) THEN
        IF(IPRINT(IPRINT_ECAS).EQ.0) IPRINT(IPRINT_ECAS) =  1
      ELSE
        IF(IPRINT(IPRINT_ECAS).EQ.0) IPRINT(IPRINT_ECAS) = -1
      ENDIF
C     PENALTY FUNCTION 
      IF(TPENAL) THEN
        IF(IPRINT(IPRINT_EPEN).EQ.0) IPRINT(IPRINT_EPEN) =  1
      ELSE
        IF(IPRINT(IPRINT_EPEN).EQ.0) IPRINT(IPRINT_EPEN) = -1
      ENDIF
C     TDDFT
      IF(TDDFT) THEN
        IF(IPRINT(IPRINT_ETDDFT).EQ.0) IPRINT(IPRINT_ETDDFT) =  1
      ELSE
        IF(IPRINT(IPRINT_ETDDFT).EQ.0) IPRINT(IPRINT_ETDDFT) = -1
      ENDIF
C     Energy of external field
      IF(TEXADD) THEN
        IF(IPRINT(IPRINT_EEXT).EQ.0) IPRINT(IPRINT_EEXT) = 1
      ELSE
        IF(IPRINT(IPRINT_EEXT).EQ.0) IPRINT(IPRINT_EEXT) = -1
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRENER
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'pslo.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'nlps.inc'
      INCLUDE 'fint.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'response_p.inc'
      INCLUDE 'store.inc'       !IPRINT
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'vdwc.inc'
      INCLUDE 'cdft.inc'
C     Variables
      INTEGER   IS
      CHARACTER DEFENERGY*14,DEFENERGY1*14,DEFENERGY2*14,DEFENERGY3*16
     &         ,DEFE*1,DEFELECTRO*12,DEFELECTRO1*12,DEFELECTRO2*12
      REAL*8    ELEC1,ELEC2,ETOT1,ETOT2,CDFT_ENER
      LOGICAL statusdummy
C     ==--------------------------------------------------------------==
C     Initialisation of ouput
      CALL WRENER_INIT
C     ==--------------------------------------------------------------==
      IF(.NOT.TENERGY_OK) THEN
        WRITE(6,'(/,8(" WARNING"))')
        WRITE(6,'(1X,A)') " VXC METHOD: TOTAL ENERGY NOT CORRECT!"
        WRITE(6,'(8(" WARNING"))')
      ENDIF
C     ==--------------------------------------------------------------==
      WRITE(6,'(/,A,/,A,T53,F13.6,/,A,T53,F13.6)')
     &     ' TOTAL INTEGRATED ELECTRONIC DENSITY',
     &     '    IN G-SPACE =',CSUMG,
     &     '    IN R-SPACE =',CSUMR
      IF(TLSD) THEN
        WRITE(6,'(A,T53,F13.6)')
     &     ' TOTAL INTEGRATED SPIN DENSITY',CSUMS
        WRITE(6,'(A,T53,F13.6)')
     &     ' TOTAL INTEGRATED ABSOLUTE VALUE OF SPIN DENSITY',CSUMSABS
      ENDIF
C     ==--------------------------------------------------------------==
      call mm_dim(mm_go_qm,statusdummy)
      IF(TIVAN) THEN
        WRITE(6,2) 
        DO IS=1,NSP
          WRITE(6,3) EL(IATYP(IS)),NA(IS),VDBCHG(IS)
        ENDDO
      ENDIF
    2 FORMAT(//' VANDERBILT AUGMENTATION CHARGES (MEAN VALUE PER ATOM)',
     *       /,' ATOM TYPE    NR. OF ATOMS        CHARGE ')
    3 FORMAT(5X,A3,8X,I4,8X,F12.3)
      call mm_dim(mm_revert,statusdummy)
C     ==--------------------------------------------------------------==
      IF(IPRINT(IPRINT_INFO).EQ.-1) THEN
        WRITE(6,*)
        RETURN
      ENDIF
C     ==--------------------------------------------------------------==
C     Definition of ELEC1 (electrostatic energy if not tdiag).
      IF(TSIC) THEN                           ! cmb_ssic
        DEFELECTRO1='(A-S+R+SIC)'
        ELEC1 =  EHEP + ESR - ESELF + EHSIC
      ELSE                                    ! cmb_ssic
        DEFELECTRO1='(E1=A-S+R)'
        ELEC1 =  EHEP + ESR - ESELF
      ENDIF
C     Definition of ELEC2 (electrostatic energy if tdiag).
      DEFELECTRO2='(E2=I-H-S+R)'
C     Ion-Ion interaction - e-e (double counting) [TDIAG]
      ELEC2 =  EHII-EHEE + ESR - ESELF
C     Definition of TOTAL ENERGY for UPDWF
      IF(TFINT) THEN
        ETOT1 = EKIN + ELEC1 + EPSEU + ENL + EXC + ENTROPY
        DEFENERGY1='(K+E1+L+N+X+T)'
      ELSE
        ETOT1 = EKIN + ELEC1 + EPSEU + ENL + EXC
        DEFENERGY1='(K+E1+L+N+X)'
      ENDIF
C     Definition of TOTAL ENERGY for TDIAG
      ETOT2 = EEIG+(EXC-VXC)+EHT+EBOGO
      IF(TFINT) THEN
        DEFE='F'
      ELSE
        DEFE='B'
      ENDIF
      IF(TBOGO) THEN
        WRITE(DEFENERGY2,'("(",A1,"+E2+X-V+O)")') DEFE
      ELSE
        WRITE(DEFENERGY2,'("(",A1,"+E2+X-V)")') DEFE
      ENDIF
      IF (QMMM) DEFENERGY3='(K+E1+L+N+X+Q+M)'
      IF (CDFT)CDFT_ENER=CDFT_V*(CDFT_NC+VGRAD)
      IF(TDIAG) THEN
        DEFELECTRO=DEFELECTRO2
        DEFENERGY=DEFENERGY2
      ELSE
        IF(TLSE .AND. (TCAS22.OR.TPENAL)) THEN
          DEFENERGY='(K+E+L+N+X+C)'
        ELSE
          DEFENERGY=DEFENERGY1
        ENDIF
        DEFELECTRO=DEFELECTRO1
      ENDIF
      IF(RESPONSE_RUNNING) THEN
        WRITE(6,8) ETOT,EH0,ELOC1,ENL1,EHT1,EXC1,ELAG1
        RETURN
 8      FORMAT(/ '   TOTAL SECOND ORDER  ENERGY = ',T41,F20.8,' A.U.'/
     *      'ZERO ORDER HAMILTONIAN ENERGY = ',T41,F20.8,' A.U.'/
     *      '     BARE PERTURBATION ENERGY = ',T41,F20.8,' A.U.'/
     *      ' N-L BARE PERTURBATION ENERGY = ',T41,F20.8,' A.U.'/
     *      ' HARTREE  PERTURBATION ENERGY = ',T41,F20.8,' A.U.'/
     *      '   X-C    PERTURBATION ENERGY = ',T41,F20.8,' A.U.'/
     *      'ZERO ORDER LAGR-MULT.  ENERGY = ',T41,F20.8,' A.U.'/)
      ENDIF
C     ==--------------------------------------------------------------==
      IF(IPRINT(IPRINT_INFO).NE.-1) THEN
         IF(qmmm) THEN
             WRITE(6,'(/,1X,A,T25,A,T41,F20.8,A)')
     .        DEFENERGY3,'TOTAL ENERGY =',ETOT,' A.U.'
             WRITE(6,'(1X,A,T22,A,T41,F20.8,A)')
     .        DEFENERGY,'TOTAL QM ENERGY =',EQM,' A.U.'
             WRITE(6,'(1X,A,T19,A,T41,F20.8,A)')
     .        '(Q)','TOTAL QM/MM ENERGY =',EQMMM,' A.U.'
             WRITE(6,'(1X,A,T22,A,T41,F20.8,A)')
     .        '(M)','TOTAL MM ENERGY =',EMM,' A.U.'
             WRITE(6,'(1X,A,T22,A,T41,F20.8,A)')
     .        '   ','DIFFERENCE      =',
     .        ETOT-(EQM+EQMMM+EMM),' A.U.'
         ELSE
         WRITE(6,'(/,1X,A,T25,A,T41,F20.8,A)')
     &        DEFENERGY,'TOTAL ENERGY =',ETOT,' A.U.'
         ENDIF
      ENDIF
      IF(IPRINT(IPRINT_ETOT1).NE.-1) THEN
         WRITE(6,'(1X,A,T24,A,T41,F20.8,A)')
     &        DEFENERGY1,'ENERGY SUM(1) =',ETOT1,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_ETOT2).NE.-1) THEN
         WRITE(6,'(1X,A,T24,A,T41,F20.8,A)')
     &        DEFENERGY2,'ENERGY SUM(2) =',ETOT2,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EKIN).NE.-1) THEN
         WRITE(6,'(1X,A,T23,A,T41,F20.8,A)')
     &        '(K)','KINETIC ENERGY =',EKIN,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EEIG).NE.-1) THEN
         WRITE(6,'(1X,A,T15,A,T41,F20.8,A)')
     &        '(F)','ELECTRONIC FREE ENERGY =',EEIG,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EBAND).NE.-1) THEN
         WRITE(6,'(1X,A,T26,A,T41,F20.8,A)')
     &        '(B)','BAND ENERGY =',EBAND,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_ENTROPY).NE.-1) THEN
         WRITE(6,'(1X,A,T26,A,T41,F20.8,A)')
     &        '(T)','-KT*ENTROPY =',ENTROPY,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EHT).NE.-1) THEN
         WRITE(6,'(1X,A,T17,A,T41,F20.8,A)')
     &        DEFELECTRO,'ELECTROSTATIC ENERGY =',EHT,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_ELEC1).NE.-1) THEN
         WRITE(6,'(1X,A,T17,A,T41,F20.8,A)')
     &        DEFELECTRO1,'ELECTROSTATIC ENERGY =',ELEC1,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_ELEC2).NE.-1) THEN
         WRITE(6,'(1X,A,T17,A,T41,F20.8,A)')
     &        DEFELECTRO2,'ELECTROSTATIC ENERGY =',ELEC2,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EHEP).NE.-1) THEN
         WRITE(6,'(1X,A,T11,A,T41,F20.8,A)')
     &        '(A)','(E+I)-(E+I) HARTREE ENERGY =',EHEP,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EHII).NE.-1) THEN
         WRITE(6,'(1X,A,T11,A,T41,F20.8,A)')
     &        '(I)','(PSEUDO CHARGE I-I) ENERGY =',EHII,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EHEE).NE.-1) THEN
         WRITE(6,'(1X,A,T17,A,T41,F20.8,A)')
     &        '(H)','(E-E) HARTREE ENERGY =',EHEE,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_ESELF).NE.-1) THEN
         WRITE(6,'(1X,A,T32,A,T41,F20.8,A)')
     &        '(S)','ESELF =',ESELF,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_ESR).NE.-1) THEN
         WRITE(6,'(1X,A,T34,A,T41,F20.8,A)')
     &        '(R)','ESR =',ESR,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EPSEU).NE.-1) THEN
         WRITE(6,'(1X,A,T9,A,T41,F20.8,A)')
     &        '(L)','LOCAL PSEUDOPOTENTIAL ENERGY =',EPSEU,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_ENL).NE.-1) THEN
         WRITE(6,'(1X,A,T11,A,T41,F20.8,A)')
     &        '(N)','N-L PSEUDOPOTENTIAL ENERGY =',ENL,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EXC).NE.-1) THEN
         WRITE(6,'(1X,A,T10,A,T41,F20.8,A)')
     &        '(X)','EXCHANGE-CORRELATION ENERGY =',EXC,' A.U.'
      ENDIF
      IF(CDFT) THEN
         WRITE(6,'(1X,A,T10,A,T41,F20.8,A)')
     &        '(W)','CHARGE-CONSTRAINT ENERGY =',CDFT_ENER,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_VXC).NE.-1) THEN
         WRITE(6,'(1X,A,T10,A,T41,F20.8,A)')
     &        '(V)','EXCHANGE-CORRELATION POTEN. =',VXC,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EGC).NE.-1) THEN
         WRITE(6,'(1X,A,T11,A,T41,F20.8,A)')
     &        ' ','GRADIENT CORRECTION ENERGY =',EGC,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EBOGO).NE.-1.AND.EBOGO.NE.0.D0) THEN
         WRITE(6,'(1X,A,T9,A,T41,F20.8,A)')
     &        '(O)','BOGOLIUBOV CORRECTION ENERGY =',EBOGO,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EVDW).NE.-1.AND.EVDW.NE.0.D0) THEN
         WRITE(6,'(1X,A,T9,A,T41,F20.8,A)')
     &        ' ','                    VDW ENERGY =',EVDW,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_ETDDFT).NE.-1) THEN
         WRITE(6,'(1X,A,T12,A,T41,F20.6,A)')
     &    '(E)','EXCITATION ENERGY(TDDFT) =',ETDDFT*2.D0*RY,' e.V.'
      ENDIF
      IF(IPRINT(IPRINT_EEXT).NE.-1) THEN
         WRITE(6,'(1X,A,T12,A,T41,F20.8,A)')
     &    '(E)','ENERGY OF EXTERNAL FIELD =',EEXT,' A.U.'
      ENDIF
      IF(IPRINT(IPRINT_EHSIC).NE.-1) THEN   ! cmb_ssic
         WRITE(6,'(1X,A,T13,A,T41,F20.8,A)')
     &        '(H)','(E-E) HARTREE SIC ENERGY =',EHSIC,' A.U.'
      ENDIF                                 ! cmb_ssic
      IF(.NOT.TENERGY_OK) THEN
        WRITE(6,'(/,8(" WARNING"))')
        WRITE(6,'(1X,A)') " VXC METHOD: TOTAL ENERGY NOT CORRECT!"
        WRITE(6,'(8(" WARNING"))')
      ENDIF
      WRITE(6,*)
C     ------------------------------------------------
C     write QMMM energy components if necessary
C     ------------------------------------------------
#if defined (__QMECHCOUPL)
      CALL MM_CPMD_WRENERGY
#endif
C     ==--------------------------------------------------------------==
      IF(TLSE .AND. TCAS22) THEN
        WRITE(6,'(A)') " TWO STATE (CAS22) HAMILTONIAN "
        WRITE(6,'(T10,A,T41,F20.8,A)') 
     &        "    H(A,A)                = ",(ETOT_A)," A.U."
        WRITE(6,'(T10,A,T41,F20.8,A)') 
     &        "    H(B,B)                = ",(ETOT_B)," A.U."
        WRITE(6,'(T10,A,T41,F20.8,A)') 
     &        "    H(A,B)                = ",(ETOT_AB)," A.U."
        WRITE(6,'(T10,A,T41,F20.8," eV  ")') 
     &        "    H(B,B) - H(A,A)       = ",(ETOT_B-ETOT_A)*RY*2.D0
        WRITE(6,'(T10,A,T41,F20.8," eV  ")') 
     &        "    Double Excitation     = ",(ETOT_2-ETOT_A)*RY*2.D0
        WRITE(6,'(T10,A,T41,F20.8," eV  ")') 
     &        "    S-T Splitting         = ",(ETOT_B-ETOT_T)*RY*2.D0
        WRITE(6,'(T10,A,T41,F20.8," Deg.")') 
     &        "    ROTATION ANGLE        = ",180.D0*CASANG/PI
        WRITE(6,*)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WREIGEN(EIGV,F,AMU,NSTATE)
C     ==--------------------------------------------------------------==
cmb-> Higher precision (needed !) on eigenvalues printout
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'conv.inc'
C     Arguments
      INTEGER   NSTATE
      REAL*8    EIGV(NSTATE,NKPTS),F(NSTATE,NKPTS),AMU
C     Variables
      DIMENSION RK(3,NKPTS),WK(NKPTS)
      INTEGER   IK,II,I,NLEFT,J,IC(0:1)
      CHARACTER AC(2)*2
C     ==--------------------------------------------------------------==
      AC(1)="  "
      AC(2)="NC"
C     ==--------------------------------------------------------------==
      IF(TLSD) THEN
        IF(NAC.LT.0) NAC=NSUP
        IF(NBC.LT.0) NBC=NSDOWN
      ELSE
        IF(NAC.LT.0) NAC=NSTATE
      ENDIF
      WRITE(6,'(/,A)') ' EIGENVALUES(EV) AND OCCUPATION:'
      DO IK=1,NKPTS
        IF(TKPNT) THEN
          WRITE(6,'(1X,A,I8,4F12.6)')
     &       'K POINT:',IK,(RK(II,IK),II=1,3),WK(IK)
        ENDIF
        IF(TLSD) THEN 
          WRITE(6,'(A)') ' ALPHA STATES:'
          DO I=1,NSUP,2
            NLEFT=MIN(NSUP-I,1)
            IC(0)=1
            IC(1)=1
            IF(NAC.LT.I) IC(0)=2
            IF(NAC.LT.I+1) IC(1)=2
            WRITE(6,'(3X,2(I5,F15.7,A2,2X,F13.8,6X))') 
     *           (I+J,EIGV(I+J,IK)*(2*RY),AC(IC(J)),
     *            F(I+J,IK),J=0,NLEFT)
          ENDDO
          WRITE(6,'(A)') ' BETA STATES:'
          DO I=NSUP+1,NSTATE,2
            NLEFT=MIN(NSTATE-I,1)
            IC(0)=1
            IC(1)=1
            IF(NSUP+NBC.LT.I) IC(0)=2
            IF(NSUP+NBC.LT.I+1) IC(1)=2
            WRITE(6,'(3X,2(I5,F15.7,A2,2X,F13.8,6X))') 
     *       (I+J-NSUP,EIGV(I+J,IK)*(2*RY),AC(IC(J)),
     *        F(I+J,IK),J=0,NLEFT)
          ENDDO
        ELSE
          DO I=1,NSTATE,2
            NLEFT=MIN(NSTATE-I,1)
            IC(0)=1
            IC(1)=1
            IF(NAC.LT.I) IC(0)=2
            IF(NAC.LT.I+1) IC(1)=2
            WRITE(6,'(3X,2(I5,F15.7,A2,2X,F13.8,6X))') 
     *        (I+J,EIGV(I+J,IK)*(2*RY),AC(IC(J)),F(I+J,IK),J=0,NLEFT)
          ENDDO
        ENDIF
      ENDDO
      IF(TFXSP) THEN
        WRITE(6,'(1X,A,T43,F20.10,A3)')
     &       'ALPHA CHEMICAL POTENTIAL =',AMUUP*(2*RY),' EV'
        WRITE(6,'(1X,A,T43,F20.10,A3)')
     &       ' BETA CHEMICAL POTENTIAL =',AMUDO*(2*RY),' EV'
      ELSE
        WRITE(6,'(1X,A,T43,F20.10,A3)')
     &       'CHEMICAL POTENTIAL =',AMU*(2*RY),' EV'
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRSTRESS
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !OMEGA
      INCLUDE 'ions.inc'        !NSP NA
      INCLUDE 'strs.inc'        !PAIU
      INCLUDE 'cnst.inc'        !AU_KB
      INCLUDE 'rmas.inc'        !PMA
      INCLUDE 'coor.inc'        !VELP
C     Variables
      INTEGER J,IA,IS
      REAL*8  OUT(3,3),FACT
C     ==--------------------------------------------------------------==
      WRITE(6,'(/,A)') ' TOTAL STRESS TENSOR (kBar):'
      CALL DCOPY(9,PAIU,1,OUT,1)
cmb-> loop unrolled for Hitachi SR8K
      DO IS=1,NSP
        FACT=PMA(IS)
        DO IA=1,NA(IS)
          OUT(1,1)=OUT(1,1)+FACT*VELP(1,IA,IS)*VELP(1,IA,IS)
          OUT(2,1)=OUT(2,1)+FACT*VELP(2,IA,IS)*VELP(1,IA,IS)
          OUT(3,1)=OUT(3,1)+FACT*VELP(3,IA,IS)*VELP(1,IA,IS)
          OUT(1,2)=OUT(1,2)+FACT*VELP(1,IA,IS)*VELP(2,IA,IS)
          OUT(2,2)=OUT(2,2)+FACT*VELP(2,IA,IS)*VELP(2,IA,IS)
          OUT(3,2)=OUT(3,2)+FACT*VELP(3,IA,IS)*VELP(2,IA,IS)
          OUT(1,3)=OUT(1,3)+FACT*VELP(1,IA,IS)*VELP(3,IA,IS)
          OUT(2,3)=OUT(2,3)+FACT*VELP(2,IA,IS)*VELP(3,IA,IS)
          OUT(3,3)=OUT(3,3)+FACT*VELP(3,IA,IS)*VELP(3,IA,IS)
        ENDDO
      ENDDO
      WRITE(6,'(5X,3(1PE20.8))') ((OUT(1,J)/OMEGA)*AU_KB,J=1,3)
      WRITE(6,'(5X,3(1PE20.8))') ((OUT(2,J)/OMEGA)*AU_KB,J=1,3)
      WRITE(6,'(5X,3(1PE20.8))') ((OUT(3,J)/OMEGA)*AU_KB,J=1,3)
      WRITE(6,*)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRCELL
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'        !OMEGA
      INCLUDE 'metr.inc'        !HT
C     Variables
      INTEGER I,J
C     ==--------------------------------------------------------------==
      WRITE(6,'(/,A,F12.4,A)') ' CELL PARAMETER (VOLUME=',OMEGA,'):'
      DO I=1,3
        WRITE(6,'(T21,3(F15.8))') (HT(I,J),J=1,3)
      ENDDO
      WRITE(6,*)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      FUNCTION OK_PRINT(IPRINT,ENGPRI,TEND)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INTEGER IPRINT
      LOGICAL ENGPRI,TEND,OK_PRINT
C     ==--------------------------------------------------------------==
      OK_PRINT=(ENGPRI.AND.(IPRINT.EQ.1)).OR.
     &         (TEND.AND.(IPRINT.NE.-1))
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
