C     ==================================================================
      SUBROUTINE WRGEO(TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_input.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSX)
C     Variables
      INTEGER IAT,IS,IA,K
C     ==--------------------------------------------------------------==
      WRITE(6,'(/,1X,64("*"))')
      WRITE(6,'(" *",21X,A,22X,"*")') 
     * ' ATOMIC COORDINATES'
      WRITE(6,'(1X,64("*"))')
      IF(.not.qmmm .or. NAT.lt.500)THEN
        IAT=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IAT=IAT+1
            WRITE(6,'(I8,6X,A2,4X,3(F15.6))')
     *           IAT,EL(IATYP(IS)),(TAU0(K,IA,IS),K=1,3)
          ENDDO
        ENDDO
      ELSE
        IAT=0
        DO IS=1,NSPq
          DO IA=1,NAq(IS)
            IAT=IAT+1
            WRITE(6,'(I8,6X,A2,4X,3(F15.6))')
     *           IAT,EL(IATYP(IS)),(TAU0(K,IA,IS),K=1,3)
          ENDDO
        ENDDO
      ENDIF
      WRITE(6,'(1X,64("*"),/)')
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRGEOF(TAU0,FION)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_input.inc'
      INCLUDE 'store.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSX),FION(3,NAX,NSX)
C     Variables
      INTEGER IAT,IS,IA,K
C     ==--------------------------------------------------------------==
      IF(IPRINT(IPRINT_FORCE).LE.0) THEN
        CALL WRGEO(TAU0)
        RETURN
      ENDIF
      WRITE(6,'(/,T4,A,T18,A,T41,A)') 'ATOM',
     &     'COORDINATES',
     &     'GRADIENTS (-FORCES)'
      IF(.not.qmmm .or. NAT.lt.500)THEN
        IAT=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IAT=IAT+1
            WRITE(6,'(1X,I3,1X,A2,3(F8.4),1X,3(1PE11.3))') 
     &           IAT,EL(IATYP(IS)),
     &           (TAU0(K,IA,IS),K=1,3),(FION(K,IA,IS),K=1,3)
          ENDDO
        ENDDO
      ELSE
        IAT=0
        DO IS=1,NSPq
          DO IA=1,NAq(IS)
            IAT=IAT+1
            WRITE(6,'(1X,I3,1X,A2,3(F8.4),1X,3(1PE11.3))') 
     &           IAT,EL(IATYP(IS)),
     &           (TAU0(K,IA,IS),K=1,3),(FION(K,IA,IS),K=1,3)
          ENDDO
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
C     ==================================================================
      SUBROUTINE WRGEOF_INR(TAU0,FION)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'adat.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSX),FION(3,NAX,NSX)
C     Variables
      INTEGER IAT,IS,IA,K
C     ==--------------------------------------------------------------==
      WRITE(6,'(/,T4,A,T18,A,T41,A)') 'ATOM',
     &     'COORDINATES',
     &     'GRADIENTS (-FORCES)'
      IAT=0
      DO IS=1,NSP
        DO IA=1,NA(IS)
          IAT=IAT+1
          WRITE(6,'(1X,I3,1X,A2,3(F8.4),1X,3(1PE11.3))') 
     *         IAT,EL(IATYP(IS)),
     *         (TAU0(K,IA,IS),K=1,3),(FION(K,IA,IS),K=1,3)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WRGEOX(TAU0)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'irat.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'ropt.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'store.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'mm_dim.inc'
C     Arguments
      REAL*8  TAU0(3,NAX,NSX)
C     Variables
      INTEGER IAT,IS,IA,K,IFILE1,IUNIT
      REAL*8   GR_TAU(3,*)
      INTEGER  GR_IAT(*)
      POINTER  (IP_GR_TAU,GR_TAU),(IP_GR_IAT,GR_IAT)
      LOGICAL FERROR,STATUS
      DATA    IFILE1 /1*FO_VERB/
      SAVE    IFILE1
C     ==--------------------------------------------------------------==
      IF(XGOUT .AND. MOD(INFI,NGXYZ).EQ.0) THEN
        IUNIT=1
        CALL mm_dim(mm_go_mm,status)
        CALL MEMORY(IP_GR_TAU,NAT*3,'GR_TAU')
        CALL MEMORY(IP_GR_IAT,(NAT+1)/IRAT,'GR_IAT')

        CALL FILEOPEN(IUNIT,'GEO_OPT.xyz',FO_APP+IFILE1,FERROR)
        IFILE1=0

        IAT=0
        DO IS=1,NSP
          DO IA=1,NA(IS)
            IAT=IAT+1
            GR_IAT(NAT_grm(IAT))=IATYP(IS)
            DO K=1,3
              GR_TAU(K,NAT_grm(IAT))=TAU0(K,IA,IS)
            ENDDO
          ENDDO
        ENDDO
        WRITE(IUNIT,'(I8)') NAT
        WRITE(IUNIT,'(I8)') INFI
        DO IAT=1,NAT
          WRITE(IUNIT,'(A3,3F20.12)')
     &         EL(GR_IAT(IAT)),(GR_TAU(K,IAT)/FBOHR,K=1,3)
        ENDDO
        CALL FILECLOSE(IUNIT)
        CALL mm_dim(mm_revert,status)
        CALL FREEM(IP_GR_TAU)
        CALL FREEM(IP_GR_IAT)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
