C     ==================================================================
      SUBROUTINE WINTF (NW,C0,TAUX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'filn.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'store.inc'
      INCLUDE 'fileopen.inc'
C     Arguments
      INTEGER    NW
      COMPLEX*16 C0(NGWK,*)
      REAL*8     TAUX(3,NAX,NSX)
C     Variables
      INTEGER    IA,IE
      CHARACTER  FFORMAT*20
      LOGICAL    FERROR
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
        CALL XSTRING(INTFN,IA,IE)
        IF(TPATH) CALL STOPGM("WINTF","Not implemented")
        CALL FILEOPEN(NW,INTFN(IA:IE),FO_DEF+FO_UFO,FERROR)
        REWIND (NW)
      ENDIF
      CALL WINTF36(NW,C0,TAUX)
      IF(PARENT) THEN
        CALL FILECLOSE(NW)
        WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(38,65-(IE-IA)),',A)'
        WRITE(6,FFORMAT)
     &       ' RESTART INFORMATION WRITTEN ON FILE ',INTFN(IA:IE)
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WINTF36 (NW,C0,TAUX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'filn.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'store.inc'
      INCLUDE 'func.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'ions.inc'
      INCLUDE 'ragg.inc'
C     Arguments
      INTEGER    NW
      COMPLEX*16 C0(NGWK,*)
      REAL*8     TAUX(3,NAX,NSX)
C     Variables
      DIMENSION  WK(*),RK(3,*)
      INTEGER    LINES,IPX,IPY,IPZ,IK,IS
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
C       FILE TAG
        WRITE(NW) "CPMD3.6"
      ENDIF
      IF(PARENT) THEN
C       UNIT CELL PARAMETERS
        LINES=3
        WRITE(NW) "CELL PARAMETER ATOMIC"
        WRITE(NW) LINES
        WRITE(NW) A1(1),A2(1),A3(1)
        WRITE(NW) A1(2),A2(2),A3(2)
        WRITE(NW) A1(3),A2(3),A3(3)
      ENDIF
      IF(PARENT) THEN
C       PERIODICITY
        LINES=1
        IPX=1
        IPY=1
        IPZ=1
        IF(TCLUST) THEN
          IF(TONED) THEN
            IPY=0
            IPZ=0
          ELSEIF(TTWOD) THEN
            IPZ=0
          ELSE
            IPX=0
            IPY=0
            IPZ=0
          ENDIF
        ENDIF
        WRITE(NW) "PERIODIC"
        WRITE(NW) LINES
        WRITE(NW) IPX,IPY,IPZ
      ENDIF
      IF(PARENT) THEN
C       WAVEFUNCTION CUTOFF
        LINES=1
        WRITE(NW) "CUTOFF WAVEFUNCTION RYDBERG"
        WRITE(NW) LINES
        WRITE(NW) ECUT
      ENDIF
      IF(PARENT) THEN
C       DENSITY CUTOFF
        LINES=1
        WRITE(NW) "CUTOFF DENSITY RYDBERG"
        WRITE(NW) LINES
        WRITE(NW) CDUAL*ECUT
      ENDIF
      IF(PARENT) THEN
C       SPIN POLARISATION
        LINES=1
        WRITE(NW) "SPIN POLARISATION"
        WRITE(NW) LINES
        WRITE(NW) TLSD
      ENDIF
      IF(PARENT) THEN
C       FUNCTIONAL
        LINES=1
        WRITE(NW) "FUNCTIONAL"
        WRITE(NW) LINES
        WRITE(NW) MFXCX,MFXCC,MGCX,MGCC,MHFX
      ENDIF
      IF(PARENT) THEN
C       KPOINTS
        WRITE(NW) "KPOINTS"
        IF(TKPNT) THEN
          LINES=2+NKPNT
          WRITE(NW) LINES
          WRITE(NW) "COMPLEX"
          WRITE(NW) NKPNT
          DO IK=1,NKPNT
             WRITE(NW) WK(IK),RK(1,IK),RK(2,IK),RK(3,IK)
          ENDDO
        ELSE
          LINES=1
          WRITE(NW) LINES
          WRITE(NW) "GAMMA"
        ENDIF
      ENDIF
      IF(PARENT) THEN
C       ATOM TYPES
        LINES=1+NSP
        WRITE(NW) "ATOM TYPES"
        WRITE(NW) LINES
        WRITE(NW) NSP
        DO IS=1,NSP
           WRITE(NW) IATYP(IS),NINT(ZV(IS)),RAGGIO(IS)
        ENDDO
      ENDIF
      IF(PARENT) THEN
C       G-VECTORS
        LINES=1
        WRITE(NW) "PLANE WAVES"
        WRITE(NW) LINES
        WRITE(NW) NGWS
C       WAVEFUNCTION CUTOFF
        DO IS=1,NGWS
           WRITE(NW) 
        ENDDO
C       DENSITY CUTOFF
        WRITE(NW) NHGS
        DO IS=1,NHGS
           WRITE(NW) 
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RINTF (NR,C0,TAUX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'filn.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'store.inc'
C     Arguments
      INTEGER    NR
      COMPLEX*16 C0(NGWK,*)
      REAL*8     TAUX(3,NAX,NSX)
C     Variables
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
