C     ==================================================================
      SUBROUTINE ZHWWF (NW,IREC,C0,CM,NSTATE,EIGV,TAU0,TAUM,TAUI,NFI)
C     ==--------------------------------------------------------------==
C     == Write wavefunction in Version 3.0 format on unit nw          ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h' 
      INCLUDE 'filn.inc'
      INCLUDE 'nose.inc'
      INCLUDE 'benc.inc'
      INCLUDE 'kpts.inc'
      INCLUDE 'store.inc'
      INCLUDE 'fileopen.inc'
      INCLUDE 'cdft.inc'
      INCLUDE 'mw.inc'
C     Arguments
      INTEGER    NW,IREC(100),NSTATE,NFI
      COMPLEX*16 C0(NGWK,*),CM(NGWK,*)
      REAL*8     TAU0(3,NAX,NSX),TAUM(3,NAX,NSX),TAUI(3,NAX,*),
     *           EIGV(NSTATE,NKPTS)
C     Variables
      CHARACTER  FILNAM*100,FILNAM2*100,FFORMAT*20,CPSTRING*220,
     &           LATFILE*20
      INTEGER    IA,IE,IFIL,I1,I2,I,J1,J2,IFFA,IFFE
      LOGICAL    FEXIST
      INTEGER    ICALLS
      DATA       ICALLS /0/
      SAVE       ICALLS
C     ==--------------------------------------------------------------==
      IF(IBENCH(1).EQ.1) RETURN
C     Construct the filename
      IF(PARENT) THEN
        CALL XSTRING(FILBOD,IA,IE)
        IF(TPATH) THEN
          FILNAM=FPATH(IAPATH:IEPATH)//FILBOD(IA:IE)
        ELSE
          IF(TMW)THEN
            CALL MW_FILENAME('LATEST_',LATFILE,WALKER_ID)
          ELSE
            LATFILE='LATEST'
          ENDIF
          INQUIRE(FILE=LATFILE,EXIST=FEXIST)
          IF(RLATE.AND.FEXIST) THEN
            OPEN(UNIT=NW,FILE=LATFILE,STATUS='UNKNOWN')
            REWIND(UNIT=NW)
            READ(NW,'(A)') FILNAM
            READ(NW,*) ICALLS
            CLOSE(NW)
          ENDIF
          IF(.NOT.THDA)THEN
            IFIL=MOD(ICALLS,NRESTF)+1
            ICALLS = ICALLS + 1
            WRITE(FFORMAT,'(I10)') IFIL
          ELSE
            IF(HDAFIRST)THEN
              FFORMAT='STATE_1'
            ELSE
              FFORMAT='STATE_2'
            ENDIF
          ENDIF
          CALL XSTRING(FFORMAT,IFFA,IFFE)
          WRITE(FILNAM,'(A,A,A)')
     &         FPATH(IAPATH:IEPATH),FILBOD(IA:IE),FFORMAT(IFFA:IFFE)
        ENDIF
        OPEN(UNIT=NW,FILE=FILNAM,STATUS='UNKNOWN',FORM='UNFORMATTED')
        REWIND(UNIT=NW)
      ENDIF
      CALL WV30(NW,IREC,C0,CM,NSTATE,EIGV,TAU0,TAUM,TAUI,NFI)
      IF(PARENT) THEN
        CALL XSTRING(FILNAM,I1,I2)
        WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(38,65-(I2-I1)),',A)'
        WRITE(6,FFORMAT)
     &       ' RESTART INFORMATION WRITTEN ON FILE ',FILNAM(I1:I2)
        IF(NRCOPY.GT.1) THEN
          DO I=2,NRCOPY
            IFIL=MOD(ICALLS,NRESTF)+1
            ICALLS = ICALLS + 1
            WRITE(FFORMAT,'(I10)') IFIL
            CALL XSTRING(FFORMAT,IFFA,IFFE)
            WRITE(FILNAM2,'(A,A,A)')
     &         FPATH(IAPATH:IEPATH),FILBOD(IA:IE),FFORMAT(IFFA:IFFE)
            CALL XSTRING(FILNAM2,J1,J2)
#if defined(MYRINET) || defined(CRAY_XT3) || defined(__WINNT)
            CALL CPFILE(FILNAM(I1:I2), FILNAM2(J1:J2))
#else
            CPSTRING='cp '//FILNAM(I1:I2)//'  '//FILNAM2(J1:J2)
            CALL SYSTEM(CPSTRING)
#endif
            WRITE(FFORMAT,'(A,I2,A)') '(/,A,T',MAX(38,65-(J2-J1)),',A)'
            WRITE(6,FFORMAT)
     &       ' RESTART INFORMATION WRITTEN ON FILE ',FILNAM2(J1:J2)
          ENDDO
        ENDIF
        IF(.NOT.TPATH) THEN
         OPEN(UNIT=NW,FILE=LATFILE,STATUS='UNKNOWN')
         REWIND(UNIT=NW)
         WRITE(NW,'(A)') FILNAM
         WRITE(NW,*) ICALLS
         CLOSE(NW)
        ENDIF 
      ENDIF
C     INTERFACE FILE
      IF (INTWRITE) THEN
         CALL WINTF(NW,C0,TAU0)
      ENDIF
      IF(PARENT)THEN
        IF(CDFT)CALL WCDFT_RESTART()
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WV30(NW,IREC,C0,CM,NSTATE,EIGV,TAU0,TAUM,TAUI,NFI)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'adat.inc'
      INCLUDE 'ions.inc' 
      INCLUDE 'symm.inc' 
      INCLUDE 'elct.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'nose.inc' 
      INCLUDE 'metr.inc' 
      INCLUDE 'cell.inc' 
      INCLUDE 'poin.inc' 
      INCLUDE 'kpts.inc'
      INCLUDE 'kpnt.inc'
      INCLUDE 'pimd.inc'
      INCLUDE 'clas.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'lscal.inc'
      INCLUDE 'store.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'bsym.inc'
      INCLUDE 'mm_dim.inc'
      INCLUDE 'mm_extrap.inc'
      INCLUDE 'shop.inc'
      INCLUDE 'shop_rest.inc'
      INCLUDE 'shop_rest_2.inc'
      INCLUDE 'mw.inc'
      INCLUDE 'prng.inc'
      INCLUDE 'gle.inc'
      REAL*8 PRNGIN(NPROC,2,3), PRNGOUT(NPROC,2,3)
C     ==--------------------------------------------------------------==
C     ==                     GENERAL FILE FORMAT                      ==
C     ==--------------------------------------------------------------==
C     ==  Section  1: Header                                          ==
C     ==  Section  2: Symmetry and Cell info                          ==
C     ==  Section  3: Number of atomic species and atoms per species  ==
C     ==  Section  4: Atomic coordinates                              ==
C     ==  Section  5: Atomic velocities                               ==
C     ==  Section  6: Initial atomic coordinates                      ==
C     ==  Section  7: Cutoff, # of electrons, grid                    ==
C     ==  Section  8: States, dual, plane waves                       ==
C     ==  Section  9: PW Coefficients                                 ==
C     ==  Section 10: PW Velocities                                   ==
C     ==  Section 11: Accumulators                                    ==
C     ==  Section 12: Nose thermostats general info                   ==
C     ==  Section 13: Nose thermostats electrons                      ==
C     ==  Section 14: Nose thermostats ions                           ==
C     ==  Section 15: Nose thermostats ions (ULTRA)                   ==
C     ==  Section 16: Nose thermostats ions (MASSIVE)                 ==
C     ==  Section 17: Nose thermostats cell                           ==
C     ==  Section 18: Potential                                       ==
C     ==  Section 19: PW single states                                ==
C     ==  Section 20: H Matrices (cell parameters)                    ==
C     ==  Section 21: K-Points                                        ==
C     ==  Section 22: Electron density                                ==
C     ==  Section 23: Occupation numbers                              ==
C     ==  Section 24: Eigenvalues                                     ==
C     ==  Section 25: Classical Particles (coordinates and velocities)==
C     ==  Section 26: LinRes PW Coefficients                          ==
C     ==  Section 27: LinRes PW Velocities                            ==
C     ==  Section 28: Partial Hessian (for microiterative TS search)  ==
C     ==  Section 29: P-RFO status and work arrays                    ==
C     ==  Section 30: L-BFGS history and status                       ==
C     ==  Section 31: Adaptive tolerance status                       ==
C     ==  Section 32: Constraints values                              ==
C     ==  Section 33: Cell translation vector in QM/MM runs           ==
C     ==  Section 34: Local temperature parameters                    ==
C     ==  Section 35: Surface Hopping I                               ==
C     ==  Section 36: Surface Hopping II                              ==
C     ==  Section 37: Pseudo random number generator                  ==
C     ==  Section 38: (generalized) Langevin equation                 ==
C     ==  Section 39 - 98 : empty                                     ==
C     ==  Section 99: Wavefunction history for TEXTRAP (must be last) ==
C     ==--------------------------------------------------------------==
C     Arguments
      INTEGER    NW,IREC(100),NSTATE,NFI
      COMPLEX*16 C0(*),CM(*)
      REAL*8     EIGV(NSTATE,*),
     &           TAU0(3,NAX,*),TAUM(3,NAX,*),TAUI(3,NAX,*)
C     Variables
      INTEGER    NATTEMPT_MAX
      PARAMETER  (NATTEMPT_MAX=5)
      LOGICAL    LSAVC0
      DIMENSION  POTR(NNR1,*),RHOO(NNR1,*),
     &           F(NSTATE,*),RK(3,*),WK(*)
      CHARACTER  STR*80
      INTEGER    IREC0,IRECORD,I,J,K,L,IS,IA,NKPTS0,IK,IP,
     &           ISECTION,NATTEMPT,IERROR
      INTEGER    MSGLEN,LIREC_WF,LIREC_PWV,LIREC_POT,LIREC_RHO
C     ==--------------------------------------------------------------==
      NATTEMPT=0
 100  CONTINUE
C     This loop is to try to write a restart file even if there is an
C     error
      NATTEMPT=NATTEMPT+1
      IF (NATTEMPT.EQ.1) THEN
C       First trial
      ELSEIF(NATTEMPT.LE.NATTEMPT_MAX) THEN
        REWIND(UNIT=NW)
        IF(PARENT) THEN
          WRITE(6,*)
          WRITE(6,'(1X,A,I2,A,I5)')'WV30: ECHEC IN SECTION=',ISECTION,
     &         ' TYPE WRITIN ERROR=',IERROR
C         We read again a complete RESTART FILE.
          WRITE(6,'(1X,A,I1,A)')'WV30: NEW ATTEMPT[',NATTEMPT,
     &         '] TO WRITE THE RESTART INFORMATION...'
          IF(NATTEMPT.EQ.NATTEMPT_MAX) THEN
            WRITE(6,'(1X,A)')
     &           'WV30: LAST ATTEMPT -> WRITE A MINIMAL RESTART'
C           Do not store PW coefficients.
            LIREC_WF=IREC(IREC_WF)
            IREC(IREC_WF)=0
C           Do not store PW velocities.
            LIREC_PWV=IREC(IREC_PWV)
            IREC(IREC_PWV)=0
C           Do not store potential.
            LIREC_POT=IREC(IREC_POT)
            IREC(IREC_POT)=0
C           Do not store electronic densities
            LIREC_RHO=IREC(IREC_RHO)
            IREC(IREC_RHO)=0
          ENDIF
        ENDIF
      ELSE
        WRITE(6,*)
        WRITE(6,'(1X,A,I2,A,I5)')'WV30: ECHEC IN SECTION=',ISECTION,
     &       ' TYPE WRITIN ERROR=',IERROR
        WRITE(6,'(1X,A)')'WV30: ABORT'
        CALL STOPGM('WV30','ERROR IN WRITING RESTART FILE')
      ENDIF
      IERROR=0
C     ==--------------------------------------------------------------==
      IF(TPATH.AND.TPIMD) THEN
        IP=IPCURR
      ELSEIF(TMW)THEN
        IP=WALKER_ID
      ELSE
        IP=1
      ENDIF
      IREC0=0
      IF(PARENT) THEN
C       ==------------------------------------------------------------==
C       Section 1
        ISECTION=1
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        STR=' STUTTGART VERSION 3.0 '
        WRITE (NW,IOSTAT=IERROR) STR
C       ==------------------------------------------------------------==
C       Section 2
        ISECTION=2
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_CELL).NE.0) THEN
          IRECORD=2
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) IBRAV,INDPG
          WRITE (UNIT=NW,IOSTAT=IERROR) (CELLDM(I),I=1,6),A1,A2,A3
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 3
        ISECTION=3
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_NAS).NE.0) THEN
          IRECORD=2
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) NSP
          WRITE (UNIT=NW,IOSTAT=IERROR)
     &                   (NA(I),I=1,NSP),(EL(IATYP(I)),I=1,NSP)
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 4
        ISECTION=4
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_CO).NE.0) THEN
          IRECORD=NAT
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          DO IS = 1 , NSP
            DO IA = 1 , NA(IS)
              WRITE (UNIT=NW,IOSTAT=IERROR) (TAU0(J,IA,IS),J=1,3)
            END DO
          END DO
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 5
        ISECTION=5
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_VEL).NE.0) THEN
          IRECORD=NAT
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          DO IS = 1 , NSP
            DO IA = 1 , NA(IS)
              WRITE (UNIT=NW,IOSTAT=IERROR) (TAUM(J,IA,IS),J=1,3)
            END DO
          END DO
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 6
        ISECTION=6
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_ICO).NE.0) THEN
          IRECORD=NAT
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          DO IS = 1 , NSP
            DO IA = 1 , NA(IS)
              WRITE (UNIT=NW,IOSTAT=IERROR) (TAUI(J,IA,IS),J=1,3)
            END DO
          END DO
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 7
        ISECTION=7
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_CUT).NE.0) THEN
          IRECORD=1
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR)
     &                   ECUT,CDUAL,DUAL,NINT(NEL),NR1S,NR2S,NR3S
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 8
        ISECTION=8
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_SDP).NE.0) THEN
          IRECORD=1
C         If gamma point nkpts0=0
          IF(TKPNT) THEN
            NKPTS0=NKPTS
          ELSE
            NKPTS0=0
          ENDIF
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) N,NKPTS0,NGWKS,NGWLS,NHGS,NHGLS
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     End of IF(PARENT). Test of IERROR
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 9
      ISECTION=9
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'WRITE SECTION ',ISECTION
      ENDIF
      IF(IREC(IREC_WF).NE.0) THEN
        CALL W_WFNIO(NW,IERROR,NSTATE,C0,'C0')
      ELSE
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 10
      ISECTION=10
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'WRITE SECTION ',ISECTION
      ENDIF
      IF(IREC(IREC_PWV).NE.0) THEN
        CALL WR30WFN(NW,IERROR,NSTATE,CM,TAU0,'NIL')
      ELSE
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 11
      IF(PARENT) THEN
        ISECTION=11
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_AC).NE.0) THEN
          IRECORD=2
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) NFI,NACC
          WRITE (UNIT=NW,IOSTAT=IERROR) ( ACC ( I ) , I = 1 , NACC )
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 12
        ISECTION=12
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_NOSE).NE.0) THEN
          IRECORD=2
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) NCHE,NEDOF,NCHAIN,NCHC
          WRITE (UNIT=NW,IOSTAT=IERROR) TULTRA,TMNOSE
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 13
        ISECTION=13
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_NOE).NE.0) THEN
          IF(BSYMM)THEN
             IRECORD=2
             WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
             WRITE (UNIT=NW,IOSTAT=IERROR)
     &         (ETA(I,1),ETADOT(I,1),I=1,NCHX)
             WRITE (UNIT=NW,IOSTAT=IERROR)
     &         (ETA(I,2),ETADOT(I,2),I=1,NCHX)
          ELSE
             IRECORD=1
             WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
             WRITE (UNIT=NW,IOSTAT=IERROR)
     &         (ETA(I,IP),ETADOT(I,IP),I=1,NCHX)
          ENDIF
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 14
        ISECTION=14
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_NOP1).NE.0) THEN
          IRECORD=1
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR)
     &         (ETAP1(I,IP),ETAP1DOT(I,IP),I=1,NCHX)
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 15
        ISECTION=15
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_NOP2).NE.0) THEN
          IRECORD=1
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR)
     &         ((ETAP(J,I,IP),ETAPDOT(J,I,IP),I=1,NCHX),J=1,NSX)
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 16
        ISECTION=16
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_NOP3).NE.0) THEN
          IRECORD=1
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR)
     &         ((ETAPM(K,L,IP),ETAPMDOT(K,L,IP),K=1,3*NAX*NSX),L=1,NCHX)
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 17
        ISECTION=17
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_NOC).NE.0) THEN
          IRECORD=1
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR)
     &         (ETC(I,IP),ETCDOT(I,IP),I=1,NCHX)
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 18
      ISECTION=18
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'WRITE SECTION ',ISECTION
      ENDIF
      IF(IREC(IREC_POT).NE.0) THEN
        IF(TLSD) THEN
          IRECORD=2*NR1S
        ELSEIF(TLSE) THEN
          IRECORD=4*NR1S
        ELSE
          IRECORD=NR1S
        ENDIF
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
        ENDIF
        CALL WR30POT(NW,IERROR,POTR(1,1))
        IF(TLSD) THEN
          CALL WR30POT(NW,IERROR,POTR(1,2))
        ENDIF
        IF(TLSE) THEN
          CALL WR30POT(NW,IERROR,POTR(1,2))
          CALL WR30POT(NW,IERROR,POTR(1,3))
          CALL WR30POT(NW,IERROR,POTR(1,4))
        ENDIF
      ELSE
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 19
      ISECTION=19
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'WRITE SECTION ',ISECTION
      ENDIF
      IF(IREC(IREC_PWS).NE.0) THEN
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
Cdeb    CALL WR30WFN(NW,IERROR,1,CSTATE,TAU0,'NIL')
      ELSE
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
      IF(PARENT) THEN
C       Section 20
        ISECTION=20
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_HE).NE.0) THEN
          IRECORD=6
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) HT
          WRITE (UNIT=NW,IOSTAT=IERROR) HTM1
          WRITE (UNIT=NW,IOSTAT=IERROR) HTVEL
          WRITE (UNIT=NW,IOSTAT=IERROR) HTFOR
          WRITE (UNIT=NW,IOSTAT=IERROR) HT0
          WRITE (UNIT=NW,IOSTAT=IERROR) HTM10
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 21
        ISECTION=21
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_KPT).NE.0) THEN
          IRECORD=NKPTS
          IF(.NOT.TKPNT) THEN
            IRECORD=0
          ENDIF
          IF(TMONKP) THEN
C           We add the indexes of the Monkhorst-Pack mesh.
            WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD,NK1,NK2,NK3
          ELSE
            WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          END IF
          DO IK=1,IRECORD
            WRITE(UNIT=NW,IOSTAT=IERROR) (RK(J,IK),J=1,3),WK(IK)
          ENDDO
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 22
      ISECTION=22
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'WRITE SECTION ',ISECTION
      ENDIF
      IF(IREC(IREC_RHO).NE.0) THEN
        IF(TLSD) THEN
          IRECORD=2*NR1S
        ELSEIF(TLSE) THEN
          IRECORD=4*NR1S
        ELSE
          IRECORD=NR1S
        ENDIF
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
        ENDIF
        CALL WR30POT(NW,IERROR,RHOO(1,1))
        IF(TLSD) THEN
          CALL WR30POT(NW,IERROR,RHOO(1,2))
        ENDIF
        IF(TLSE) THEN
          CALL WR30POT(NW,IERROR,RHOO(1,2))
          CALL WR30POT(NW,IERROR,RHOO(1,3))
          CALL WR30POT(NW,IERROR,RHOO(1,4))
        ENDIF
      ELSE
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 23
      IF(PARENT) THEN
        ISECTION=23
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_OCC).NE.0) THEN
          IRECORD=NKPTS
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          DO IK=1,NKPTS
            WRITE (UNIT=NW,IOSTAT=IERROR) (F(I,IK),I=1,NSTATE)
          ENDDO
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 24
        ISECTION=24
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_EIGV).NE.0) THEN
          IRECORD=NKPTS+1
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) AMU
          DO IK=1,NKPTS
            WRITE (UNIT=NW,IOSTAT=IERROR) (EIGV(I,IK),I=1,NSTATE)
          ENDDO
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 25
        ISECTION=25
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_CLAS).NE.0) THEN
          IRECORD=NCLATOM
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          DO I=1,NCLATOM
            WRITE (UNIT=NW,IOSTAT=IERROR)
     &           (CLASC(J,I),J=1,3),(CLASV(J,I),J=1,3)
          ENDDO
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==------------------------------------------------------------==
C     Section 26
      ISECTION=26
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'WRITE SECTION ',ISECTION
      ENDIF
      IF(IREC(IREC_LRWF).NE.0) THEN
        CALL W_LINRES (NW,IERROR,"WF")
      ELSE
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==------------------------------------------------------------==
C     Section 27
      ISECTION=27
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'WRITE SECTION ',ISECTION
      ENDIF
      IF(IREC(IREC_LRWV).NE.0) THEN
        CALL W_LINRES (NW,IERROR,"WV")
      ELSE
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==------------------------------------------------------------==
      IF(PARENT) THEN
C       ==------------------------------------------------------------==
C       Section 28
        ISECTION=28
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_PHES).NE.0.AND..NOT.LALLHS) THEN
          IRECORD=NVAR+1
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          DO I=1,NVAR
            WRITE (UNIT=NW,IOSTAT=IERROR) (HESSCR(J,I),J=1,NVAR)
          ENDDO
          WRITE (UNIT=NW,IOSTAT=IERROR) NSHESS, LVLHES
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        END IF
C       ==------------------------------------------------------------==
C       Section 29
        ISECTION=29
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_PRFO).NE.0) THEN
          IRECORD=8
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          CALL WR30PRFO (NW, IERROR,IREC(IREC_LBFGS))
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 30
        ISECTION=30
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_LBFGS).NE.0) THEN
          LSAVC0 = .FALSE.     ! Do not save previous wavefunction
          IF (LSAVC0) THEN
            IRECORD=7
          ELSE
            IRECORD=7
          ENDIF
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          CALL WR30LBFGS (NW, IERROR,LSAVC0)
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 31
        ISECTION=31
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_RDTL).NE.0) THEN
          IRECORD=1
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR)
     &         DELAST, DEMIN, TOLMIN, TOLOG, TOLAD, TOLENE
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 32
        ISECTION=32
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_CONS).NE.0 .AND. MCNSTR.GT.0) THEN
          IRECORD=2
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) MCNSTR
          WRITE (UNIT=NW,IOSTAT=IERROR) (CNSVAL(I),I=1,MCNSTR)
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 33
        ISECTION=33
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_CTRANS).NE.0) THEN
          IRECORD=1
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) (MM_C_TRANS(I),I=1,3)
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C       ==------------------------------------------------------------==
C       Section 34
C FIXME LOCT : WRITE GROUP SELECTIONS AND PARAMETERS TO FILE
        ISECTION=34
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_NOP4).NE.0) THEN
          IRECORD=2
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR)
     &         ((LCTTAB(J,I),I=1,NAX),J=1,NSX)
          WRITE (UNIT=NW,IOSTAT=IERROR)
     &         ((ETAP(J,I,IP),ETAPDOT(J,I,IP),I=1,NCHX),J=1,NAX*NSX)
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
C     ==--------------------------------------------------------------==
      ENDIF

      IF(PARENT) THEN
C       ==--------------------------------------------------------------==
C       Section 35
        ISECTION=35
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_SHOP).NE.0) THEN
          IRECORD=5
          WRITE(UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE(UNIT=NW,IOSTAT=IERROR) ISURF,(POP(I),I=1,6),DET,DETOLD
          DO I=1,2
           WRITE(UNIT=NW,IOSTAT=IERROR) (COUPL(I,K),COUPLOLD(I,K),K=1,2)
           WRITE(UNIT=NW,IOSTAT=IERROR) EC(I),EOLD(I)
          ENDDO
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     ==------------------------------------------------------------==
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==------------------------------------------------------------==
C     Section 36
      ISECTION=36
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'WRITE SECTION ',ISECTION
      ENDIF
      IF(IREC(IREC_SHOPBO).NE.0) THEN
        CALL W_WFNIO(NW,IERROR,NSTATE,C0OLD,'C0')
      ELSE
        IF(PARENT) THEN
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
       GOTO 100
      ENDIF
C     ==------------------------------------------------------------==
C     Section 37
      PRNGIN=0.0
      PRNGOUT=0.0
      IF(TPATH.OR.TMW) THEN
        PRNGIN(mepos+1,:,:)=PARASEED
      ELSE
        PRNGIN(me+1,:,:)=PARASEED
      ENDIF
      MSGLEN = NPROC * 6 * 8
      CALL MY_COMBINE(PRNGIN,PRNGOUT,MSGLEN,1,ALLGRP)
      IF(PARENT) THEN
        ISECTION=37
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_PRNG).NE.0) THEN
            IRECORD=1+NPROC
            WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
            WRITE (UNIT=NW,IOSTAT=IERROR) 
     &         (REPSEED(1,I),I=1,3),(REPSEED(2,I),I=1,3)
            DO J=1,NPROC
              WRITE (UNIT=NW,IOSTAT=IERROR) 
     &           (PRNGOUT(J,1,I),I=1,3),(PRNGOUT(J,2,I),I=1,3)
            ENDDO
        ELSE
            WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
       GOTO 100
      ENDIF
C     ==------------------------------------------------------------==
C     Section 38
      IF(PARENT) THEN
        ISECTION=38
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION ',ISECTION
        ENDIF
        IF(IREC(IREC_GLE).NE.0) THEN
          IRECORD=1+NAT*(GLE_NS+1)
          WRITE (UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE (UNIT=NW,IOSTAT=IERROR) EGLE
          DO IS = 1 , NSP
            DO IA = 1, NA(IS)
              DO I= 1, GLE_NS+1
                WRITE (UNIT=NW,IOSTAT=IERROR) (GLEP(J,IA,IS,I),J=1,3)
              END DO
            END DO
          END DO
        ELSE
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
       GOTO 100
      ENDIF
C     ==------------------------------------------------------------==
C     Section 39- 98
      IF(PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'WRITE SECTION 38-98'
        ENDIF
        DO I=39,98
          ISECTION=I
          WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDDO
      ENDIF
C     ==--------------------------------------------------------------==
C     Section 99
      ISECTION=99
      IF(TDEBIO.AND.PARENT) THEN
        WRITE(6,*) 'WRITE SECTION ',ISECTION
      ENDIF

      IF(IREC(IREC_XTRP).NE.0) THEN
C     NUMCOLD is the last 'official' record.
C     the wavefunction history is then added.
        IRECORD=1 
        IF (PARENT) THEN
          WRITE(UNIT=NW,IOSTAT=IERROR) IRECORD
          WRITE(UNIT=NW,IOSTAT=IERROR) NUMCOLD
        ENDIF
        DO I=NUMCOLD,1,-1
          IS=MOD(NNOW+MEXTRA-I,MEXTRA)+1
          IF(TDEBIO.AND.PARENT) THEN
            WRITE(6,*) 'STORING WFN ',IS,' OF ',NUMCOLD
          ENDIF
          CALL W_WFNIO(NW,IERROR,NSTATE,COLD(1,1,1,IS),'C0')
        ENDDO
      ELSE
        IF(PARENT) THEN
            WRITE (UNIT=NW,IOSTAT=IERROR) IREC0
        ENDIF
      ENDIF
C     ==------------------------------------------------------------==
      IF(PARENT) THEN
        IF(TDEBIO) THEN
          WRITE(6,*) 'CLOSE THE FILE'
        ENDIF
        CLOSE (UNIT=NW,IOSTAT=IERROR)
      ENDIF
C     Broadcast of IERROR.
      MSGLEN = 1 * 8/IRAT
      CALL MY_BCAST(IERROR,MSGLEN,SOURCE,ALLGRP)
      IF(IERROR.NE.0) THEN
        GOTO 100
      ENDIF
C     ==--------------------------------------------------------------==
      IF(NATTEMPT.EQ.NATTEMPT_MAX) THEN
C       Restore IREC values
C       PW coefficients.
        IREC(IREC_WF)=LIREC_WF
C       PW velocities.
        IREC(IREC_PWV)=LIREC_PWV
C       Potential.
        IREC(IREC_POT)=LIREC_POT
C       Electronic densities
        IREC(IREC_RHO)=LIREC_RHO
      ENDIF
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE WR30POT(NW,IERROR,POTR)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER NW,IERROR
      REAL*8 POTR(KR1,*)
C     Local variables
      REAL*8  PSCR(KR2S*KR3S)
      POINTER (IP_PSCR,PSCR)
      INTEGER KK,IR,I
#ifdef PARALLEL
      INTEGER IPP,IPX,IP,IRR,MSGID,MSGLEN,NBYTES
#endif
C     ==--------------------------------------------------------------==
      KK=KR2S*KR3S
#ifdef PARALLEL
      CALL MEMORY(IP_PSCR,KK,'PSCR')
      CALL MY_SYNC(ALLGRP)
C     For each plane
      DO IR=1,NR1S
C       Find the processor which has the given plane.
        DO IPP=1,NPROC
          IF(IR.GE.NRXPL(IPP-1,1).AND.IR.LE.NRXPL(IPP-1,2)) THEN
            IPX=IPP
            GOTO 10
          ENDIF
        ENDDO
        CALL STOPGM('WR30POT','ERROR IN NRXPL')
   10   CONTINUE
        IP=PGROUP(IPX)
C       IP has the plane.
        IF(ME.EQ.IP) THEN
          IRR=IR-NRXPL(MEPOS,1)+1
          CALL DCOPY(KK,POTR(IRR,1),KR1,PSCR(1),1)
          IF(.NOT.PARENT) THEN
C           IP sends array.
            MSGID=1
            MSGLEN=KK * 8
            CALL MY_BSEND(PSCR,MSGLEN,PGROUP(1),MSGID)
          ENDIF
        ELSEIF(PARENT) THEN
C         PARENT receives array.
          MSGID=1
          MSGLEN=KK * 8
          CALL MY_BRECV(PSCR,MSGLEN,IP,MSGID,NBYTES)
        ENDIF
        IF(PARENT) THEN
          WRITE(NW,IOSTAT=IERROR) (PSCR(I),I=1,KK)
        ENDIF
        CALL MY_SYNC(ALLGRP)
      ENDDO
      CALL FREEM(IP_PSCR)
#else
      CALL MEMORY(IP_PSCR,KK,'PSCR')
      DO IR=1,NR1S
        CALL DCOPY(KK,POTR(IR,1),KR1,PSCR(1),1)
        WRITE(NW,IOSTAT=IERROR) (PSCR(I),I=1,KK)
      ENDDO
      CALL FREEM(IP_PSCR)
#endif
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
