C     ==================================================================
      SUBROUTINE XCSTR(DRHOVG,RHOE,V,VGC)
C     ==--------------------------------------------------------------==
C     ==                        COMPUTES                              ==
C     ==           EXCHANGE AND CORRELATION ENERGY CONTRIBUTION       ==
C     ==           OF VANDERBILT CHARGE TO STRESS TENSOR              ==
C     ==--------------------------------------------------------------==
C
C     WARNING-WARNING-WARNING-WARNING-WARNING-WARNING-WARNING-WARNING
C     FIXME: this code appears to not have been fully revised for use
C     with NEWCODE. Some fixes were applied to make it run without
c     crashing. The results are not totally wrong, but the code needs
C     to be thouroughly tested (and best checked by someone, who knows
C     what he is doing).
C
C     <axel.kohlmeyer@theochem.ruhr-uni-bochum.de> 12/2003.
C
C     WARNING-WARNING-WARNING-WARNING-WARNING-WARNING-WARNING-WARNING
C
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'strs.inc'
      INCLUDE 'tbxc.inc'
      INCLUDE 'spin.inc'
      INCLUDE 'geq0.inc'
C     Arguments
      COMPLEX*16 DRHOVG(NHG,6),V(NNR1,NLSD)
      REAL*8     RHOE(NNR1,NLSD),VGC(NNR1)
C     Variables
      REAL*8     VR(2,NNR1)
      POINTER    (IP_VR,VR)
      REAL*8     VXCA,VXCB,DROE1,DROE2,ROE,RATIO,DD,EE,VXC1,EX,EC,
     &           VX,VC,
     &           DDOT
      EXTERNAL   DDOT
      INTEGER    ISUB,IR,I1,KK,IG
C     ==--------------------------------------------------------------==
      CALL TISET('     XCSTR',ISUB)
      IF(TGC) THEN
        DO IR=1,NNR1
          VGC(IR)=DREAL(V(IR,1))
        ENDDO
      ENDIF
      IF(.NOT.TLSD) THEN
        CALL GET_ADDR(IP_VR,V(1,1))
        DO KK=1,6,2
          CALL ZAZZERO(V,NNR1)
!CDIR NODEP
#ifdef __SR8000
*poption parallel, tlocal(IG)
#endif 
#ifdef CRAYX1
!dir$ concurrent
#endif
          DO IG=1,NHG
            V(NZH(IG),1)  = DRHOVG(IG,KK) + UIMAG*DRHOVG(IG,KK+1)
            V(INDZ(IG),1) = DCONJG(DRHOVG(IG,KK)) + 
     *                                   UIMAG*DCONJG(DRHOVG(IG,KK+1))
          ENDDO
          IF(GEQ0) V(NZH(1),1)  = DRHOVG(1,KK) + UIMAG*DRHOVG(1,KK+1)
          CALL INVFFT(V)
          VXCA=0.D0
          VXCB=0.D0
          DO IR=1,NNR1 
            DROE1=DREAL(V(IR,1))
            DROE2=DIMAG(V(IR,1))
            ROE=DMAX1(RHOE(IR,1),0.0D0)
            CALL XC(ROE,EX,EC,VX,VC)
            VXC1=VX+VC
            VXCA=VXCA+VXC1*DROE1
            VXCB=VXCB+VXC1*DROE2
          ENDDO
          IF(TGC) THEN
            VXCA=VXCA+DDOT(NNR1,VGC,1,VR(1,1),2)
            VXCB=VXCB+DDOT(NNR1,VGC,1,VR(2,1),2)
          ENDIF
          DEXC(KK)   = VXCA * OMEGA/DBLE(NR1S*NR2S*NR3S)
          DEXC(KK+1) = VXCB * OMEGA/DBLE(NR1S*NR2S*NR3S)
        ENDDO
      ELSE
        CALL STOPGM("XCSTR","LSD not operational")
C     ==--------------------------------------------------------------==
C     ==  INPUT : RHOE(1..NNR1)  ALPHA + BETA DENSITY                 ==
C     ==          RHOE(NNR1+1 ..2*NNR1)  BETA DENSITY                 ==
C     ==          V(1..NNR1)   LOCAL POTENTIAL                        ==
C     ==  OUTPUT  V(1..NNR1)   ALPHA POTENTIAL                        ==
C     ==          V(NNR1+1..2*NNR1)   BETA POTENTIAL                  ==
C     ==--------------------------------------------------------------==
C         CALL DCOPY(2*NNR1,V(1,1),1,V(1,2),1)
C         DO IR=1,NNR1
C           ROE = DMAX1(RHOE(IR,1),1.0D-15)
C           ETA = (RHOE(IR,1)-2.D0*RHOE(IR,2))/ROE
C           IF(ABS(ETA).GT.1.D0) ETA=SIGN(1.0D0,ETA)
C           CALL XC_LSD(ROE,ETA,EX,EC,VXA,VCA,VXB,VCB)
C           VXCA=VXA+VCA
C           VXCB=VXB+VCB
C           EXC=EX+EC
C           V(IR,1)=V(IR,1)+(VXCA,0.0D0)
C           V(IR,2)=V(IR,2)+(VXCB,0.0D0)
C           SXC=SXC+EXC*ROE
C         ENDDO
      ENDIF
      CALL TIHALT('     XCSTR',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
