C     ==================================================================
      SUBROUTINE ZDIIS(C0,C2,VPP,EIGV,NSTATE,PME,GDE,
     &                 SVAR2,REINIT,ORBITAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ener.inc'
      INCLUDE 'geq0.inc'
      INCLUDE 'linres.inc'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C0(NGW,NSTATE),C2(NGW,NSTATE)
      COMPLEX*16 PME(NGW*NSTATE,*),GDE(NGW*NSTATE,*)
      REAL*8     VPP(*),EIGV(*),SVAR2
      LOGICAL    REINIT
      CHARACTER*(*) ORBITAL
C     Variables
      REAL*8     DIISM(MAXDIS,MAXDIS)
      INTEGER    NDIIS,NOWV,ISTATE
      REAL*8     BC(MAXDIS+1,MAXDIS+1),VC(MAXDIS+1),VPPMIN,
     &           DOTPS
      EXTERNAL   DOTPS
      INTEGER    ISUB,I,NOWM,IG,K,J,NSIZE
      INTEGER    MSGLEN
      SAVE       DIISM,NDIIS,NOWV,ISTATE
      DATA       ISTATE /0/
C     ==--------------------------------------------------------------==
      CALL TISET('     ZDIIS',ISUB)
      IF(REINIT.OR.ISTATE.EQ.0) THEN
C       Reinitialization of diis procedure
        ISTATE=0
        REINIT=.FALSE.
        NDIIS=0
C       INIT VPP
        CALL SETVPP(VPP,NGW,LR_HTHRS,VPPMIN)
      ENDIF
      IF(ISTATE.EQ.0) CALL UPDIS(NDIIS,NOWV,NSIZE,MLDIIS,0)
      ISTATE=2
C     Perform an electronic DIIS step
      CALL UPDIS(NDIIS,NOWV,NSIZE,MLDIIS,1)
C     Update DIIS buffers
      CALL DCOPY(2*NGW*NSTATE,C0,1,PME(1,NOWV),1)
C     Scale Gradient with Preconditioner
      CALL DSCAL(2*NGW*NSTATE,-1.0D0,C2,1)
      CALL APPLPRE(C2,VPP,EIGV,NSTATE,ORBITAL)
      CALL DCOPY(2*NGW*NSTATE,C2,1,GDE(1,NOWV),1)
C     Update DIIS matrix
      DO I=1,NSIZE-1
        DIISM(I,NOWV)=DOTPS(NGW,NSTATE,GDE(1,I),GDE(1,NOWV))
      ENDDO
      CALL GLOSUM(NSIZE-1,DIISM(1,NOWV))
      DO I=1,NSIZE-1
        DIISM(NOWV,I)=DIISM(I,NOWV)
      ENDDO
C     Set up DIIS Matrix
      CALL AZZERO(BC,(MAXDIS+1)*(MAXDIS+1))
      DO I=1,NSIZE-1
        DO J=1,NSIZE-1
          BC(I,J)=DIISM(I,J)
        ENDDO
      ENDDO
      DO I=1,NSIZE-1
        VC(I)=0.D0
        BC(I,NSIZE)=-1.D0
        BC(NSIZE,I)=-1.D0
      ENDDO
      VC(NSIZE)=-1.D0
      BC(NSIZE,NSIZE)=0.D0
C     Solve System of Linear Equations
      CALL SOLVE(BC,MAXDIS+1,NSIZE,VC)
C     Compute Interpolated Coefficient Vectors
      CALL AZZERO(C0,2*NGW*NSTATE)
      DO I=1,NSIZE-1
        CALL DAXPY(2*NGW*NSTATE,VC(I),PME(1,I),1,C0,1)
      ENDDO
C     Estimate New Parameter Vectors 
      IF(NSIZE-1.EQ.1) THEN
        CALL DAXPY(2*NGW*NSTATE,-SVAR2*VC(1),GDE,1,C0,1)
      ELSE
        DO I=1,NSIZE-1
          CALL DAXPY(2*NGW*NSTATE,-VC(I),GDE(1,I),1,C0,1)
        ENDDO
      ENDIF
      CALL TIHALT('     ZDIIS',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE APPLPRE(C2,VPP,EIGV,NSTATE,ORBITAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER    NSTATE
      COMPLEX*16 C2(NGW,NSTATE)
      REAL*8     VPP(NGW),EIGV(NSTATE,NSTATE)
      CHARACTER*(*) ORBITAL
C     Variables
      INTEGER    IS,IG
      REAL*8     DEIJ
C     ==--------------------------------------------------------------==
      DO IS=1,NSTATE
        IF(INDEX(ORBITAL,"CANON").NE.0) THEN
          DEIJ=-EIGV(IS,1)
        ELSE
          DEIJ=EIGV(IS,IS)
        ENDIF
        DO IG=1,NGW
          C2(IG,IS)=C2(IG,IS)/(VPP(IG)+DEIJ)
        ENDDO
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
