C     ==================================================================
      SUBROUTINE ZHIP
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'isos.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'cppt.inc'
      INCLUDE 'gvec.inc'
      INCLUDE 'qspl.inc'
      INCLUDE 'geq0.inc'
C     Variables
      DIMENSION GGNH(*)
      REAL*8    SCR(*),FR(*),RR(*),WR(*)
      POINTER   (IP_SCR,SCR),(IP_FR,FR),(IP_RR,RR),(IP_WR,WR)
      REAL*8    RMAX,DR,ARG,GGl,XG,GR,RESULT,
     &          DERF,CURV2
      INTEGER   ISUB,LMEM,IR,IERR,IG
#ifdef __DERF
      EXTERNAL DERF
#endif
C     ==--------------------------------------------------------------==
      CALL TISET('      ZHIP',ISUB)
      LMEM=MAX(MMAXX,NSPLPO)
      CALL MEMORY(IP_FR,LMEM,'FR')
      CALL MEMORY(IP_RR,LMEM,'RR')
      CALL MEMORY(IP_WR,LMEM,'WR')
      CALL MEMORY(IP_SCR,LMEM,'SCR')
      RMAX=RCERF*20.0D0
      DR=RMAX/DBLE(MMAXX+1)
C     ==--------------------------------------------------------------==
C$OMP parallel do private(IR,ARG)
      DO IR=1,MMAXX
        RR(IR)=DBLE(IR-1)*DR
        ARG=RR(IR)/RCERF
        FR(IR)=RR(IR)*(1.D0-DERF(ARG))*DR
      ENDDO
      CALL AZZERO(SCR,NSPLPO)
      DO IG=NSPLPA,NSPLPE
        GGL=GGNH(IG)
        IF(GGL.LT.1.D-8) THEN
          CALL DCOPY(MMAXX,FR(1),1,WR(1),1)
        ELSE
          WR(1)=FR(1)
          XG=SQRT(GGL)*TPIBA
          DO IR=2,MMAXX
            GR=XG*RR(IR)
            WR(IR)=FR(IR)*SIN(GR)/GR
          ENDDO
        ENDIF
        CALL SIMPSN(MMAXX,WR,RESULT)
        SCR(IG)=FPI*RESULT/OMEGA
      ENDDO
      CALL GLOSUM(NSPLPO,SCR)
      CALL CURV1(NSPLPO,GGNH,SCR,0.0D0,0.0D0,3,FR,WR,0.0D0,IERR)
#ifdef (__VECTOR)
C$OMP parallel do private(IG)
#else
C$OMP parallel do private(IG) schedule(static)
#endif
      DO IG=1,NHG
        HIPZ(IG)=CURV2(HG(IG),NSPLPO,GGNH(1),SCR(1),FR(1),0.0D0)
      ENDDO
      CALL FREEM(IP_SCR)
      CALL FREEM(IP_FR)
      CALL FREEM(IP_RR)
      CALL FREEM(IP_WR)
      CALL TIHALT('      ZHIP',ISUB)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
