C     ==================================================================
      SUBROUTINE ZNUM_MAT(C0,C2,NSTATE,DDMAT,SCR,LSCR,INDEX)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      include 'system.h'
      include 'spin.inc'
      include 'cppt.inc'
      include 'geq0.inc'
      include 'cnst.inc'
      include 'g_loc.inc'
      include 'metr.inc'
C     Arguments
      INTEGER    NSTATE,LSCR,INDEX
      COMPLEX*16 C0(2*NGW,*),C2(2*NGW,*),
     *           DDMAT(NSTATE,*)
      REAL*8       SCR(LSCR)
C     Variables
      COMPLEX*16     C2F(2*NGW,*),cc1,cc2
      POINTER    (IP_C2F,C2F)
      INTEGER    L,IP1,IP2,IP3,NH(3)
      REAL*8     NUMSEC(3),SC0(2,2*NGW),EIR(2*NGW),EII(2*NGW)
      REAL*8     RE,IM ,x0(3),prod
      POINTER    (IP_SC0,SC0),(IP_EIR,EIR),(IP_EII,EII)

      INTEGER    I,II,IG,LENGTH,LEIGR
      CHARACTER*30 TAG
C     ==--------------------------------------------------------------==
      CALL GIVE_SCR_ZNUM_MAT(LENGTH,TAG,NSTATE)
      CALL TEST_SCR('ZNUM_MAT','LENGTH',LSCR,LENGTH)

      CALL AZZERO(DDMAT,2*NSTATE*NSTATE)

      CALL GET_ADDR(IP_C2F,C2)

      IP1 = 1
      IP2 = IP1 + 2*2*NGW
      IP3 = IP2 + 2*NGW

      CALL GET_ADDR(IP_SC0 ,SCR(IP1))
      CALL GET_ADDR(IP_EIR ,SCR(IP2))
      CALL GET_ADDR(IP_EII ,SCR(IP3))

      CALL AZZERO(DDMAT,2*NSTATE*NSTATE)

      NUMSEC(1) = DBLE(NR1S)
      NUMSEC(2) = DBLE(NR2S)
      NUMSEC(3) = DBLE(NR3S)

      NH(1)=NR1S/2+1
      NH(2)=NR2S/2+1
      NH(3)=NR3S/2+1


C.... MINIMUM R-VECTOR in the grid in along the axes INDEX 

c      X0(1) = ipos(1)*A1(1)/NUMSEC(1)+
c     &        ipos(2)*A2(1)/NUMSEC(2)+ipos(3)*A3(1)/NUMSEC(3)
c      X0(2) = ipos(1)*A1(2)/NUMSEC(1)+
c     &        ipos(2)*A2(2)/NUMSEC(2)+ipos(3)*A3(2)/NUMSEC(3)
c      X0(3) = ipos(1)*A1(3)/NUMSEC(1)+
c     &        ipos(2)*A2(3)/NUMSEC(2)+ipos(3)*A3(3)/NUMSEC(3)

      X0(1) = HT(INDEX,1)/NUMSEC(INDEX)
      X0(2) = HT(INDEX,2)/NUMSEC(INDEX)
      X0(3) = HT(INDEX,3)/NUMSEC(INDEX)

      IF(PARENT) write(6,'("X0",3f12.6)') X0(1),X0(2),X0(3)

      DO IG=1,NGW

        prod = GK(1,IG)*X0(1)+GK(2,IG)*X0(2)+GK(3,IG)*X0(3)
        prod = TPIBA*prod
        EIR(IG)     =  DCOS(prod)
        EII(IG)     =  DSIN(prod)

c        EIR(IG)     =  DCOS(GK(INDEX,IG)*X0(INDEX))
c        EII(IG)     =  DSIN(GK(INDEX,IG)*X0(INDEX))

        EIR(IG+NGW) =  EIR(IG)
        EII(IG+NGW) = -EII(IG) 

c      write(6,'(2(I8,2f12.6))') IG,EIR(IG),EII(IG),
c     &                          IG+NGW,EIR(IG+NGW),EII(IG+NGW)
c      write(6,'(8x,3f12.6)') GK(1,IG),GK(3,IG),GK(2,IG)


      ENDDO
c      stop

      DO I= 1,NSTATE !NST12(MEPOS,1),NST12(MEPOS,2)

        II=I !-NST12(MEPOS,1)+1

        CALL DCOPY(4*NGW,C0(1,II),1,SC0,1)

        DO IG=1,2*NGW
          RE = EIR(IG)*SC0(1,IG)-EII(IG)*SC0(2,IG)
          IM = EIR(IG)*SC0(2,IG)+EII(IG)*SC0(1,IG)
          C2F(IG,II)=DCMPLX(RE,IM)
        ENDDO
        IF(GEQ0)
     &   C2F(1+NGW,II)=DCMPLX(0.D0,0.D0)
c        DO IG=1,10
c        write(6,'(a,2f12.6)') 'EIR',EIR(IG),EII(IG)
c        write(6,'(i8,4f12.6)') IG,C0(IG,II),C2F(IG,II)
c        write(6,'(i8,4f12.6)') IG+NGW,C0(IG+NGW,II),C2F(IG+NGW,II)
c        enddo
      ENDDO

      IF(TLSD) THEN
        CALL ZGEMM('C','N',NSUP,NSUP,NGW,DCMPLX(1.D0,0.D0),C0,2*NGW,
     *              C2F,2*NGW,DCMPLX(0.D0,0.D0),DDMAT,NSTATE)
        CALL ZGEMM('C','N',NSDOWN,NSDOWN,NGW,DCMPLX(1.D0,0.D0),
     *              C0(1,NSUP+1),2*NGW,C2F(1,NSUP+1),2*NGW,
     *              DCMPLX(0.D0,0.D0),DDMAT(NSUP+1,NSUP+1),NSTATE)
      ELSE


        CALL ZGEMM('C','N',NSTATE,NSTATE,2*NGW,DCMPLX(1.D0,0.D0),
     *          C0,2*NGW,C2F,2*NGW,DCMPLX(0.D0,0.D0),DDMAT,NSTATE)


c       write(6,'(2I4,2f12.6,2x,2f12.6)') 18,16,DDMAT(18,16),DDMAT(16,18)

c      stop
      ENDIF
#ifdef PARALLEL
      CALL GLOSUM(2*NSTATE*NSTATE,DDMAT)
#endif


c      DO I = 10,20
c      IF(PARENT) WRITE(6,'(I4,11(2x,2f7.4))') I,( DDMAT(I,II),II=10,20)
c      ENDDO
c
c       stop
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE GIVE_SCR_ZNUM_MAT(LZNUM,TAG,NSTATE)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
C     Arguments
      INTEGER   LZNUM,NSTATE
      CHARACTER TAG*30
C     ==--------------------------------------------------------------==
      LZNUM=2*NSTATE*NSTATE+4*NGW+4*NGW+1
      TAG='2*NSTATE*NSTATE+2*NGW+4*NGW'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
