C     ==================================================================
      SUBROUTINE COORNTOT_RF(ISP1,ISP2,NEXP,MEXP,C1_RC,R0_SHIFT,TSCR,AN,
     &                       FCI,FVI,CVAL,SPvsAT,IATOM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER ISP1,ISP2,NEXP,MEXP,IATOM(*),SPvsAT
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_RC,R0_SHIFT
C     Variables
      REAL*8  X0,Y0,Z0,XX(3),DX,DY,DZ,DD,FF,FFF,DF
      REAL*8  RNUM,RDEN,FNUM,FDEN,UNA1
      INTEGER IAT1,IAT2,IIAT2,K,L1,L2,L3,IS,IINI1,IINI2,IEND1,IEND2
      INTEGER IB,NAA,ITYP,KX,JJ,JX,JY,JZ,J
C     ==--------------------------------------------------------------==
      IINI1 = 1
      DO IS = 1,ISP1-1
        IINI1=IINI1+NA(IS)
      ENDDO
      IEND1 = IINI1 + NA(ISP1) -1
      UNA1 = 1.0D0/DBLE(NA(ISP1))
C      write(6,*) 'IINI = ',IINI,'IEND = ',IEND
      IF(SPvsAT .EQ. 1) THEN
        IINI2 = 1
        DO IS = 1,ISP2-1
          IINI2=IINI2+NA(IS)
        ENDDO
        IEND2 = IINI2 + NA(ISP2) -1
      ELSE
        IINI2 = 1
        IEND2 = ISP2
      ENDIF
C      write(6,*) 'IINI = ',IINI,'IEND = ',IEND

      FVI = 0.D0
      DO IAT1 = IINI1,IEND1
        L1 = LSKPTR(1,IAT1)
        L2 = LSKPTR(2,IAT1)
        L3 = LSKPTR(3,IAT1)
        X0 = TSCR(1,IAT1)
        Y0 = TSCR(2,IAT1)
        Z0 = TSCR(3,IAT1)

        DO IIAT2=IINI2,IEND2
          IF(SPvsAT .EQ. 1) THEN
            IAT2 = IIAT2
          ELSE
            IAT2 = IATOM(IIAT2)
          ENDIF
          CALL FILLC(IAT2,TSCR,XX)
          DX=XX(1)-X0
          DY=XX(2)-Y0
          DZ=XX(3)-Z0
          IF(.NOT. TISOS) THEN
            CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          ENDIF
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
C..exclude self interaction
C        write(6,*) IAT1,IAT2,DD,DX,DY,DZ
          IF(DD.GT.1.D-2) THEN
            RNUM = ((DD-R0_SHIFT)/C1_RC)**NEXP
            RDEN = ((DD-R0_SHIFT)/C1_RC)**(NEXP+MEXP)
            FNUM = 1-RNUM
            FDEN = 1-RDEN
            IF(DABS(FDEN) .LT. 1.D-10) THEN
              FVI = FVI + DBLE(NEXP)/DBLE(NEXP+MEXP)
              FF  = -0.5D0*DBLE(NEXP*MEXP)/DBLE(NEXP+MEXP)/
     &               (C1_RC*DD)
            ELSE
              FVI  = FVI + FNUM/FDEN
              FF   = -(RNUM*DBLE(NEXP)-FNUM*RDEN*DBLE(NEXP+MEXP)/
     &              FDEN)/(FDEN*(DD-R0_SHIFT)*DD)*UNA1
            ENDIF

            IF(IAT2.LE.NAT) THEN
              IF(LSKPTR(1,IAT2).NE.0) THEN
                K=LSKPTR(1,IAT2)
                AN(K)=AN(K)+FF*DX
              ENDIF
              IF(LSKPTR(2,IAT2).NE.0) THEN
                K=LSKPTR(2,IAT2)
                AN(K)=AN(K)+FF*DY
              ENDIF
              IF(LSKPTR(3,IAT2).NE.0) THEN
                K=LSKPTR(3,IAT2)
                AN(K)=AN(K)+FF*DZ
              ENDIF
            ELSEIF(IAT2.LE.NAT+NDAT) THEN
              NAA=IAT2-NAT
              ITYP=LISTDA(NAA,1)
              IF(ITYP.EQ.1) THEN
                GOTO 110
              ELSEIF(ITYP.EQ.2) THEN
                KX=LISTDA(NAA,2)
                JJ=LISTD2(1,KX)
                FFF=1.0D0/DBLE(JJ)
                DO J=1,JJ
                  IB=LISTD2(J+1,KX)
                  JX=LSKPTR(1,IB)
                  JY=LSKPTR(2,IB)
                  JZ=LSKPTR(3,IB)
                  IF(JX.NE.0) AN(JX)=AN(JX)+FF*DX*FFF
                  IF(JY.NE.0) AN(JY)=AN(JY)+FF*DY*FFF
                  IF(JZ.NE.0) AN(JZ)=AN(JZ)+FF*DZ*FFF
                ENDDO
              ENDIF
            ENDIF
 110        CONTINUE

            IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
            IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
            IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
          ENDIF
        ENDDO
      ENDDO
      FVI = FVI*UNA1
      FCI=FVI-CVAL
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ABS_DIFCNTOT_RF(ISP1,ISP2,ISP3,NEXP,MEXP,C1_RC,
     *                           R0_SHIFT,TSCR,AN,FCI,FVI,CVAL,SPVSAT,
     *                           IATOM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'cnst_dyn.inc'
C     Arguments
      INTEGER ISP1,ISP2,ISP3,NEXP,MEXP,IATOM(*),SPVSAT
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_RC,R0_SHIFT
C     Variables
      INTEGER J
      REAL*8  AN_LOC(*), FCI_LOC, FVI_LOC
      POINTER (IP_AN_LOC,AN_LOC)
C     ==--------------------------------------------------------------==
      CALL MEMORY(IP_AN_LOC,NODIM*NCOLVAR,'ANF1')
      CALL AZZERO(AN_LOC,NODIM*NCOLVAR)
C     First evaluate the difference between coordination numbers
      CALL  DIFCNTOT_RF(ISP1,ISP2,ISP3,NEXP,MEXP,C1_RC,R0_SHIFT,
     *                  TSCR,AN_LOC,FCI_LOC,FVI_LOC,CVAL,SPVSAT,IATOM)

      FCI = ABS(FCI_LOC)
      FVI = ABS(FVI_LOC+CVAL)-CVAL
      DO J = 1, NODIM*NCOLVAR
         AN(J) = AN(J) + AN_LOC(J) * SIGN(1.0D0,FCI_LOC)
      END DO
      CALL FREEM(IP_AN_LOC)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DIFCNTOT_RF(ISP1,ISP2,ISP3,NEXP,MEXP,C1_RC,R0_SHIFT,
     *                       TSCR,AN,FCI,FVI,CVAL,SPVSAT,IATOM)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER ISP1,ISP2,ISP3,NEXP,MEXP,IATOM(*),SPVSAT
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_RC,R0_SHIFT
C     Variables
      REAL*8  X0,Y0,Z0,XX(3),DX,DY,DZ,DD,FF,UNA1
      REAL*8  RNUM,RDEN,FNUM,FDEN
      INTEGER IAT1,IAT2,K,L1,L2,L3,IS,IINI1,IINI2,IEND1,IEND2,
     &        IAT3,IINI3,IEND3
C     ==--------------------------------------------------------------==
      UNA1 = 1.0D0/DBLE(NA(ISP2))

      IINI1 = 1
      DO IS = 1,ISP1-1
        IINI1=IINI1+NA(IS)
      ENDDO
      IEND1 = IINI1 + NA(ISP1) -1

      IINI2 = 1
      DO IS = 1,ISP2-1
         IINI2=IINI2+NA(IS)
      ENDDO
      IEND2 = IINI2 + NA(ISP2) -1

      IINI3 = 1
      DO IS = 1,ISP3-1
         IINI3=IINI3+NA(IS)
      ENDDO
      IEND3 = IINI3 + NA(ISP3) -1

      FVI = 0.D0
      DO IAT1 = IINI1,IEND1
        L1 = LSKPTR(1,IAT1)
        L2 = LSKPTR(2,IAT1)
        L3 = LSKPTR(3,IAT1)
        X0 = TSCR(1,IAT1)
        Y0 = TSCR(2,IAT1)
        Z0 = TSCR(3,IAT1)

        DO IAT2=IINI2,IEND2
          CALL FILLC(IAT2,TSCR,XX)
          DX=XX(1)-X0
          DY=XX(2)-Y0
          DZ=XX(3)-Z0
          IF(.NOT. TISOS) THEN
            CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          ENDIF
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
C..exclude self interaction
          IF(DD.GT.1.D-2) THEN
            RNUM = ((DD-R0_SHIFT)/C1_RC)**NEXP
            RDEN = ((DD-R0_SHIFT)/C1_RC)**(NEXP+MEXP)
            FNUM = 1-RNUM
            FDEN = 1-RDEN
            IF(DABS(FDEN) .LT. 1.D-10) THEN
              FVI = FVI + DBLE(NEXP)/DBLE(NEXP+MEXP)
              FF  = -0.5D0*DBLE(NEXP*MEXP)/DBLE(NEXP+MEXP)/
     &               (C1_RC*DD)
            ELSE
              FVI  = FVI + FNUM/FDEN
              FF   = -(RNUM*DBLE(NEXP)-FNUM*RDEN*DBLE(NEXP+MEXP)/
     &              FDEN)/(FDEN*(DD-R0_SHIFT)*DD)*UNA1
            ENDIF

            IF(LSKPTR(1,IAT2).NE.0) THEN
              K=LSKPTR(1,IAT2)
              AN(K)=AN(K)+FF*DX
            ENDIF
            IF(LSKPTR(2,IAT2).NE.0) THEN
              K=LSKPTR(2,IAT2)
              AN(K)=AN(K)+FF*DY
            ENDIF
            IF(LSKPTR(3,IAT2).NE.0) THEN
              K=LSKPTR(3,IAT2)
              AN(K)=AN(K)+FF*DZ
            ENDIF

            IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
            IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
            IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
          ENDIF
        ENDDO
      ENDDO


      DO IAT3 = IINI3,IEND3
        L1 = LSKPTR(1,IAT3)
        L2 = LSKPTR(2,IAT3)
        L3 = LSKPTR(3,IAT3)
        X0 = TSCR(1,IAT3)
        Y0 = TSCR(2,IAT3)
        Z0 = TSCR(3,IAT3)

        DO IAT2=IINI2,IEND2
          CALL FILLC(IAT2,TSCR,XX)
          DX=XX(1)-X0
          DY=XX(2)-Y0
          DZ=XX(3)-Z0
          IF(.NOT. TISOS) THEN
            CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          ENDIF
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
C..exclude self interaction
          IF(DD.GT.1.D-2) THEN
            RNUM = ((DD-R0_SHIFT)/C1_RC)**NEXP
            RDEN = ((DD-R0_SHIFT)/C1_RC)**(NEXP+MEXP)
            FNUM = 1-RNUM
            FDEN = 1-RDEN
            IF(DABS(FDEN) .LT. 1.D-10) THEN
C..change sign, compare with previous cycle
              FVI = FVI - DBLE(NEXP)/DBLE(NEXP+MEXP)
              FF  = 0.5D0*DBLE(NEXP*MEXP)/DBLE(NEXP+MEXP)/
     &               (C1_RC*DD)
            ELSE
              FVI  = FVI - FNUM/FDEN
              FF   = +(RNUM*DBLE(NEXP)-FNUM*RDEN*DBLE(NEXP+MEXP)/
     &              FDEN)/(FDEN*(DD-R0_SHIFT)*DD)*UNA1
            ENDIF

            IF(LSKPTR(1,IAT2).NE.0) THEN
              K=LSKPTR(1,IAT2)
              AN(K)=AN(K)+FF*DX
            ENDIF
            IF(LSKPTR(2,IAT2).NE.0) THEN
              K=LSKPTR(2,IAT2)
              AN(K)=AN(K)+FF*DY
            ENDIF
            IF(LSKPTR(3,IAT2).NE.0) THEN
              K=LSKPTR(3,IAT2)
              AN(K)=AN(K)+FF*DZ
            ENDIF

            IF(L1.NE.0) AN(L1)=AN(L1)-FF*DX
            IF(L2.NE.0) AN(L2)=AN(L2)-FF*DY
            IF(L3.NE.0) AN(L3)=AN(L3)-FF*DZ
          ENDIF
        ENDDO
      ENDDO

      FVI = FVI*UNA1
      FCI = FVI-CVAL
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CTOT_CHAIN(ISP1,ISP2,ISP3,NEXP,MEXP,C_RC1,C_RC2,TSCR,
     &                       AN,LSK,FCI,FVI,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'

C     Arguments
      INTEGER ISP1,ISP2,ISP3,NEXP,MEXP,LSK(3,NAT)
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C_RC1,C_RC2
C     Variables
      REAL*8  XA,YA,ZA,XB,YB,ZB,DXAB,DYAB,DZAB,DDAB
      REAL*8  XC,YC,ZC,DXAC,DYAC,DZAC,DDAC
      REAL*8  DXBC,DYBC,DZBC,DDBC
      REAL*8  FF,DF,UNA1,UNB1,DFAB,DFBC
      REAL*8  RNUMAB,RDENAB,FNUMAB,FDENAB
      REAL*8  RNUMBC,RDENBC,FNUMBC,FDENBC,CC
      INTEGER IAT1,IAT2,IAT3,K,L1A,L2A,L3A,IS,L1B,L2B,L3B,L1C,L2C,L3C
      INTEGER IINIA,IENDA,IINIB,IINIC,IENDB,IENDC
C     ==--------------------------------------------------------------==

      IINIA = 1
      DO IS = 1,ISP1-1
        IINIA=IINIA+NA(IS)
      ENDDO
      IENDA = IINIA + NA(ISP1) -1
      UNA1 = 1.0D0/DBLE(NA(ISP1))

      IINIB = 1
      DO IS = 1,ISP2-1
        IINIB=IINIB+NA(IS)
      ENDDO
      IENDB = IINIB + NA(ISP2) -1
      UNB1 = 1.0D0/DBLE(NA(ISP2))

      IINIC = 1
      DO IS = 1,ISP3-1
        IINIC=IINIC+NA(IS)
      ENDDO
      IENDC = IINIC + NA(ISP3) -1

      FVI = 0.D0
      DO IAT1 = IINIA,IENDA
        L1A = LSK(1,IAT1)
        L2A = LSK(2,IAT1)
        L3A = LSK(3,IAT1)
        XA = TSCR(1,IAT1)
        YA = TSCR(2,IAT1)
        ZA = TSCR(3,IAT1)

        DO IAT2=IINIB,IENDB
          L1B = LSK(1,IAT2)
          L2B = LSK(2,IAT2)
          L3B = LSK(3,IAT2)
          XB = TSCR(1,IAT2)
          YB = TSCR(2,IAT2)
          ZB = TSCR(3,IAT2)
          DXAB=XB-XA
          DYAB=YB-YA
          DZAB=ZB-ZA
          IF(.NOT. TISOS) THEN
            CALL PBC(DXAB,DYAB,DZAB,DXAB,DYAB,DZAB,1,APBC,IBRAV)
          ENDIF
          DDAB=DSQRT(DXAB*DXAB+DYAB*DYAB+DZAB*DZAB)
          CC = 0.0D0

          DO IAT3=IINIC,IENDC
            L1C = LSK(1,IAT3)
            L2C = LSK(2,IAT3)
            L3C = LSK(3,IAT3)
            XC = TSCR(1,IAT3)
            YC = TSCR(2,IAT3)
            ZC = TSCR(3,IAT3)
            DXAC=XC-XA
            DYAC=YC-YA
            DZAC=ZC-ZA
            IF(.NOT. TISOS) THEN
              CALL PBC(DXAC,DYAC,DZAC,DXAC,DYAC,DZAC,1,APBC,IBRAV)
            ENDIF
            DDAC=DSQRT(DXAC*DXAC+DYAC*DYAC+DZAC*DZAC)

            DXBC=XC-XB
            DYBC=YC-YB
            DZBC=ZC-ZB
            IF(.NOT. TISOS) THEN
              CALL PBC(DXBC,DYBC,DZBC,DXBC,DYBC,DZBC,1,APBC,IBRAV)
            ENDIF
            DDBC=DSQRT(DXBC*DXBC+DYBC*DYBC+DZBC*DZBC)

C..exclude self interaction

            IF(DDAB*DDBC.GT.1.D-3) THEN
              RNUMAB = (DDAB/C_RC1)**NEXP
              RDENAB = (DDAB/C_RC1)**(NEXP+MEXP)
              RNUMBC = (DDBC/C_RC2)**NEXP
              RDENBC = (DDBC/C_RC2)**(NEXP+MEXP)

              FNUMAB = 1-RNUMAB
              FDENAB = 1-RDENAB
              FNUMBC = 1-RNUMBC
              FDENBC = 1-RDENBC

              IF(DABS(FDENBC) .LT. 1.D-10) FDENBC = 1.D-10
              IF(DABS(FDENAB) .LT. 1.D-10) FDENAB = 1.D-10

              FVI  = FVI + (FNUMAB/FDENAB*FNUMBC/FDENBC)
              FCI = 1.0D0

              DFAB = -(RNUMAB*DBLE(NEXP)-
     &                 FNUMAB*RDENAB*DBLE(NEXP+MEXP)/FDENAB)/
     &                (FDENAB*DDAB*DDAB)
              DFBC = -(RNUMBC*DBLE(NEXP)-
     &                 FNUMBC*RDENBC*DBLE(NEXP+MEXP)/FDENBC)/
     &                (FDENBC*DDBC*DDBC)

              DFAB = DFAB*FNUMBC/FDENBC*UNA1*FCI
              DFBC = DFBC*FNUMAB/FDENAB*UNA1*FCI

              IF(L1A.NE.0) AN(L1A)=AN(L1A)-DFAB*DXAB
              IF(L2A.NE.0) AN(L2A)=AN(L2A)-DFAB*DYAB
              IF(L3A.NE.0) AN(L3A)=AN(L3A)-DFAB*DZAB

              IF(L1B.NE.0) AN(L1B)=AN(L1B)+DFAB*DXAB-DFBC*DXBC
              IF(L2B.NE.0) AN(L2B)=AN(L2B)+DFAB*DYAB-DFBC*DYBC
              IF(L3B.NE.0) AN(L3B)=AN(L3B)+DFAB*DZAB-DFBC*DZBC

              IF(L1C.NE.0) AN(L1C)=AN(L1C)+DFBC*DXBC
              IF(L2C.NE.0) AN(L2C)=AN(L2C)+DFBC*DYBC
              IF(L3C.NE.0) AN(L3C)=AN(L3C)+DFBC*DZBC
            ENDIF
          ENDDO
        ENDDO
      ENDDO
      FVI = FVI*UNA1
      FCI=FVI-CVAL
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE DISP_lnm(NUMSPEC,NUMSPEC2,ISPEC,MILLER,IATOM,TSCR,
     &                    NATOM,AN,LSK,SCALP,SPvsAT)

C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'adat.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
      INCLUDE 'fileopen.inc'
C      INCLUDE 'cnst_dyn.inc'  ! specindex

C     Arguments
      INTEGER   NUMSPEC,NATOM,NUMSPEC2,ISPEC(*)
      INTEGER   IATOM(*)
      INTEGER   LSK(3,NATOM),MILLER(3),SPvsAT
      REAL*8    TSCR(3,*),AN(*),SCALP
C     Variables
      INTEGER   IFIRST
      DATA      IFIRST /0/
      SAVE      IFIRST
      REAL*8    POS_A(3,NATOM),POS_B(3,NATOM),POS_BB(3,NATOM)
      POINTER   (IP_POS_A,POS_A),(IP_POS_B,POS_B),(IP_POS_BB,POS_BB)
      REAL*8    DERR(3,NATOM),DER_ROT(3,3,3,NATOM),D2_A(3,NDAT)
      POINTER   (IP_DERR,DERR),(IP_DER_ROT,DER_ROT),(IP_D2_A,D2_A)
      REAL*8    RX,RY,RZ,RAX,RAY,RAZ,XT,YT,ZT,SCALP2

      REAL*8    DER_ROT1(3,3,3,3),rot1(3,3),rot2(3,3),eps

      INTEGER   NAT_DISP,NAT_DISP2,IAT,IINI,IEND,L1,L2,L3,IUNIT
      INTEGER   IPOS_DISP(*),IPOS_DISP2(*),IFLAG(*),IIINDEX(*),LIFLAG
      POINTER   (IP_IPOS_DISP,IPOS_DISP),(IP_IPOS_DISP2,IPOS_DISP2)
      POINTER   (IP_IFLAG,IFLAG),(IP_IIINDEX,IIINDEX)
      PARAMETER (IUNIT=58)
      REAL*8    DIR_VEC(3),DIR_NORM,DISP_VEC(3)
      REAL*8    DISPX,DISPY,DISPZ,DISP,TRANSL0(3),TRANSL(3),ROT(3,3)
      REAL*8    UNAT_DIS,UNAT_DIS2,XX(3),FFF,FX,FY,FZ
      CHARACTER*80 LABEL,ELEMENT
      CHARACTER FILEN*100
      LOGICAL   FERROR,TROTMIN
      INTEGER   I1,I2,ICOUNT,II,I,ISP,IS,IA,K
      INTEGER   IB,NAA,KX,JJ,J,JX,JY,JZ,ITYP
      SAVE      IP_POS_A,IP_D2_A
      SAVE      IP_IPOS_DISP,IP_IPOS_DISP2,IP_IIINDEX
      SAVE      IP_POS_B,IP_POS_BB,IP_DERR,IP_DER_ROT
      SAVE      TRANSL0 ! (3),TRANSL0(2),TRANSL0(1)
C     SAVE      DIR_VEC !(1) ,DIR_VECT(2),DIR_VECT(3)
C     ==--------------------------------------------------------------==
      IF(TISOS) THEN
        TROTMIN = .TRUE.
      ENDIF
      IF(IFIRST.EQ.0) THEN
!C     Allocate memory
        CALL MEMORY(IP_POS_A,3*NATOM,'POS_A')
        IF(NDAT .GT. 0) THEN
          CALL MEMORY(IP_D2_A,3*NDAT,'D2_A')
        ENDIF
        CALL MEMORY(IP_IPOS_DISP,(NATOM+NDAT)/IRAT+1,'IPOS_DISP')
        CALL MEMORY(IP_IPOS_DISP2,(NATOM+NDAT)/IRAT+1,'IPOS_DISP2')
        CALL MEMORY(IP_IIINDEX,NATOM/IRAT +1,'IIINDEX')
        IF(TROTMIN) THEN
          CALL MEMORY(IP_POS_B,3*NATOM,'POS_B')
          CALL MEMORY(IP_POS_BB,3*NATOM,'POS_BB')
          CALL MEMORY(IP_DERR,3*NATOM,'DERR')
          CALL MEMORY(IP_DER_ROT,3*3*3*NATOM,'DER_ROT')
        ENDIF

!C     Read the reference configurations
        FILEN='STRUCTURE_A'
        FERROR=.FALSE.
        CALL FILEOPEN(IUNIT,FILEN,FO_OLD,FERROR)
        IF(FERROR) THEN
          WRITE(6,'(A)')
     &      ' DISP_lmn! File STRUCTURE_A  DOES NOT EXIST!!'
          CALL DCOPY(3*NATOM,TSCR,1,POS_A,1)
          CALL FILEOPEN(IUNIT,FILEN,FO_NEW,FERROR)
          WRITE(IUNIT,'(A,A)') 'INITIAL',' POSITIONS'
          IAT = 0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT = IAT+1
              WRITE(IUNIT,'(A,3f16.8)') EL(IATYP(IS)),
     &           (TSCR(K,IAT),K=1,3)
            ENDDO
          ENDDO
        ELSE
          REWIND(IUNIT)
          READ(IUNIT,ERR=998,FMT=*) LABEL
          IAT = 0
          DO IS=1,NSP
            DO IA=1,NA(IS)
              IAT = IAT+1
              READ(IUNIT,ERR=998,FMT=*) ELEMENT,
     &           (POS_A(K,IAT),K=1,3)
            ENDDO
          ENDDO
          WRITE(6,'(/,A,A,/)') ' A COORDINATES READ ',
     *     'FROM FILE STRUCTURE_A'
        ENDIF

!C            write(6,*) NUMSPEC,NUMSPEC2, MILLER(1),MILLER(2),MILLER(3)
!C            write(6,*)  (IATOM(K),K= 1,NUMSPEC)
!C            write(6,*)  (IATOM(K+NUMSPEC2),K= 1,NUMSPEC2)
!C            stop 'disp'

        XT = 0.0D0
        YT = 0.0D0
        ZT = 0.0D0
        DO IAT = 1,NATOM
          xT = xT + POS_A(1,IAT)
          yT = yT + POS_A(2,IAT)
          zT = zT + POS_A(3,IAT)
        ENDDO
        transl0(1) = XT/DBLE(NATOM)
        transl0(2) = YT/DBLE(NATOM)
        transl0(3) = ZT/DBLE(NATOM)
!$OMP parallel do private(IAT)
        DO IAT = 1,NATOM
          POS_A(1,IAT)= POS_A(1,IAT) - transl0(1)
          POS_A(2,IAT)= POS_A(2,IAT) - transl0(2)
          POS_A(3,IAT)= POS_A(3,IAT) - transl0(3)
        ENDDO

        IFIRST=1
        CALL FILECLOSE(IUNIT)
        IF(NDAT2.EQ.0) THEN
          GOTO 999
        ENDIF
        DO I=1,NDAT
          IF(LISTDA(I,1).EQ.2) THEN
            KX=LISTDA(I,2)
            JJ=LISTD2(1,KX)
            XT=0.0D0
            YT=0.0D0
            ZT=0.0D0
            DO K=1,JJ
              XT=XT+POS_A(1,LISTD2(K+1,KX))
              YT=YT+POS_A(2,LISTD2(K+1,KX))
              ZT=ZT+POS_A(3,LISTD2(K+1,KX))
            ENDDO
            D2_A(1,KX)=XT/DBLE(JJ)
            D2_A(2,KX)=YT/DBLE(JJ)
            D2_A(3,KX)=ZT/DBLE(JJ)
          ENDIF
        ENDDO
        GOTO 999

 998    CONTINUE
        WRITE(6,'(A)') ' DISP_lmn! ERROR WHILE READING COORDINATES'
        CALL STOPGM('DISP_lmn','READING ERROR')

 999    CONTINUE
      ENDIF

!C     Vector that define a direction in space
      DO K = 1,3
        DIR_VEC(K) = DBLE(MILLER(1))*A1(K)+DBLE(MILLER(2))*A2(K)+
     &                 DBLE(MILLER(3))*A3(K)
      ENDDO
      DIR_NORM = DSQRT(DIR_VEC(1)*DIR_VEC(1)+
     &                 DIR_VEC(2)*DIR_VEC(2)+
     &                 DIR_VEC(3)*DIR_VEC(3))
      DIR_VEC(1) = DIR_VEC(1)/DIR_NORM
      DIR_VEC(2) = DIR_VEC(2)/DIR_NORM
      DIR_VEC(3) = DIR_VEC(3)/DIR_NORM


!C      write(6,*) ' dir ',DIR_VEC(1),DIR_VEC(2),DIR_VEC(3)
!C      call rmsd_rot(NATOM,POS_A,TSCR,transl,rot)


      IF(SPvsAT .EQ. 1) THEN
        CALL MEMORY(IP_IFLAG,NSP,'IFLAG')
        LIFLAG = NSP
      ELSE
        LIFLAG = NATOM+NDAT
        CALL MEMORY(IP_IFLAG,LIFLAG/IRAT + 1,'IFLAG')
      ENDIF

      CALL IAZZERO(IPOS_DISP,NATOM+NDAT)
      CALL IAZZERO(IPOS_DISP2,NATOM+NDAT)
      CALL IAZZERO(IFLAG,LIFLAG)
      CALL AZZERO(DISP_VEC,3)
      CALL IAZZERO(IIINDEX,NATOM)
      IF(TROTMIN) THEN
        CALL AZZERO(DERR,3*NATOM)
        CALL AZZERO(DER_ROT,3*3*3*NATOM)
      ENDIF
!C     Create the list of engaged ions

      IF(SPvsAT .EQ. 1) THEN
        ICOUNT = 0
        NAT_DISP = 0
        DO IS=1,NUMSPEC
          ISP = ISPEC(IS)
          IFLAG(ISP) = 1
          IINI = 0
          DO I = 1,ISP-1
            IINI = IINI + NA(I)
          ENDDO
          IEND = IINI + NA(ISP)
          IINI = IINI + 1
          DO IAT = IINI,IEND
            NAT_DISP = NAT_DISP + 1
            IPOS_DISP(NAT_DISP) = IAT

            IF(TROTMIN) THEN
              ICOUNT = ICOUNT + 1
              iiindex(icount) = iat
              POS_B(1,ICOUNT) = POS_A(1,IAT)
              POS_B(2,ICOUNT) = POS_A(2,IAT)
              POS_B(3,ICOUNT) = POS_A(3,IAT)
              POS_BB(1,ICOUNT) = TSCR(1,IAT)
              POS_BB(2,ICOUNT) = TSCR(2,IAT)
              POS_BB(3,ICOUNT) = TSCR(3,IAT)
            ENDIF
          ENDDO
        ENDDO
        NAT_DISP2 = 0
        IF(NUMSPEC2 .EQ. 0) THEN
          IINI = 0
          IEND = 0
          DO IS=1,NSP
            IEND = IINI + NA(IS)
            IINI = IINI + 1
            IF(IFLAG(IS) .EQ. 0) THEN
              DO IAT = IINI,IEND
                NAT_DISP2 = NAT_DISP2 + 1
                IPOS_DISP2(NAT_DISP2) = IAT
                IF(TROTMIN) THEN
                  ICOUNT = ICOUNT + 1
                  iiindex(icount) = iat
                  POS_B(1,ICOUNT) = POS_A(1,IAT)
                  POS_B(2,ICOUNT) = POS_A(2,IAT)
                  POS_B(3,ICOUNT) = POS_A(3,IAT)
                  POS_BB(1,ICOUNT) = TSCR(1,IAT)
                  POS_BB(2,ICOUNT) = TSCR(2,IAT)
                  POS_BB(3,ICOUNT) = TSCR(3,IAT)
                ENDIF
              ENDDO
            ENDIF
            IINI = IEND
          ENDDO
        ELSE
          DO IS=1,NUMSPEC2
            ISP = ISPEC(NUMSPEC+IS)
            IINI = 0
            DO I = 1,ISP-1
              IINI = IINI + NA(I)
            ENDDO
            IEND = IINI + NA(ISP)
            IINI = IINI + 1
            DO IAT = IINI,IEND
              NAT_DISP2 = NAT_DISP2 + 1
              IPOS_DISP2(NAT_DISP2) = IAT
              IF(TROTMIN) THEN
                ICOUNT = ICOUNT + 1
                iiindex(icount) = iat
                POS_B(1,ICOUNT) = POS_A(1,IAT)
                POS_B(2,ICOUNT) = POS_A(2,IAT)
                POS_B(3,ICOUNT) = POS_A(3,IAT)
                POS_BB(1,ICOUNT) = TSCR(1,IAT)
                POS_BB(2,ICOUNT) = TSCR(2,IAT)
                POS_BB(3,ICOUNT) = TSCR(3,IAT)
              ENDIF
            ENDDO
          ENDDO
        ENDIF
      ELSE
        ICOUNT = 0
        NAT_DISP = 0
        DO IS=1,NUMSPEC
          IAT = IATOM(IS)

          NAT_DISP = NAT_DISP + 1
          IPOS_DISP(NAT_DISP) = IAT

          IF(TROTMIN) THEN
            IF( IAT .LE. NATOM .AND. IFLAG(IAT) .EQ. 0 ) THEN
              ICOUNT = ICOUNT + 1
              iiindex(icount) = iat
              POS_B(1,ICOUNT) = POS_A(1,IAT)
              POS_B(2,ICOUNT) = POS_A(2,IAT)
              POS_B(3,ICOUNT) = POS_A(3,IAT)
              POS_BB(1,ICOUNT) = TSCR(1,IAT)
              POS_BB(2,ICOUNT) = TSCR(2,IAT)
              POS_BB(3,ICOUNT) = TSCR(3,IAT)
            ELSEIF(IAT .LE. NATOM + NDAT) THEN
              NAA=IAT-NAT
              ITYP=LISTDA(NAA,1)
              IF(ITYP.EQ.1) THEN
                GOTO 100
              ELSEIF(ITYP.EQ.2) THEN
                KX=LISTDA(NAA,2)
                JJ=LISTD2(1,KX)
                DO J=1,JJ
                  IB=LISTD2(J+1,KX)
                  IF(IFLAG(IB) .EQ. 0) THEN
                    ICOUNT = ICOUNT + 1
                    iiindex(icount) = IB
                    POS_B(1,ICOUNT) = POS_A(1,IB)
                    POS_B(2,ICOUNT) = POS_A(2,IB)  
                    POS_B(3,ICOUNT) = POS_A(3,IB)
                    POS_BB(1,ICOUNT) = TSCR(1,IB)
                    POS_BB(2,ICOUNT) = TSCR(2,IB)
                    POS_BB(3,ICOUNT) = TSCR(3,IB)
                    IFLAG(IB) = 1
                  ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDIF
 100      CONTINUE
          IFLAG(IAT) = 1
        ENDDO
        NAT_DISP2 = 0
        IF(NUMSPEC2 .EQ. 0) THEN
          DO IS=1,NATOM
            IAT = IS
            IF(IFLAG(IAT) .EQ. 0) THEN
               NAT_DISP2 = NAT_DISP2 + 1
               IPOS_DISP2(NAT_DISP2) = IAT
               IF(TROTMIN) THEN
                 ICOUNT = ICOUNT + 1
                 iiindex(icount) = iat
                 POS_B(1,ICOUNT) = POS_A(1,IAT)
                 POS_B(2,ICOUNT) = POS_A(2,IAT)
                 POS_B(3,ICOUNT) = POS_A(3,IAT)
                 POS_BB(1,ICOUNT) = TSCR(1,IAT)
                 POS_BB(2,ICOUNT) = TSCR(2,IAT)
                 POS_BB(3,ICOUNT) = TSCR(3,IAT)
               ENDIF
            ENDIF
          ENDDO
        ELSE
          DO IS=1,NUMSPEC2
            IAT = IATOM(NUMSPEC+IS)
            NAT_DISP2 = NAT_DISP2 + 1
            IPOS_DISP2(NAT_DISP2) = IAT
            IF(TROTMIN) THEN
              IF( IAT .LE. NATOM .AND. IFLAG(IAT) .EQ. 0 ) THEN
                ICOUNT = ICOUNT + 1
                iiindex(icount) = iat
                POS_B(1,ICOUNT) = POS_A(1,IAT)
                POS_B(2,ICOUNT) = POS_A(2,IAT)
                POS_B(3,ICOUNT) = POS_A(3,IAT)
                POS_BB(1,ICOUNT) = TSCR(1,IAT)
                POS_BB(2,ICOUNT) = TSCR(2,IAT)
                POS_BB(3,ICOUNT) = TSCR(3,IAT)
              ELSEIF(IAT .LE. NATOM + NDAT) THEN
                NAA=IAT-NAT
                ITYP=LISTDA(NAA,1)
                IF(ITYP.EQ.1) THEN
                  GOTO 200
                ELSEIF(ITYP.EQ.2) THEN
                  KX=LISTDA(NAA,2)
                  JJ=LISTD2(1,KX)
                  DO J=1,JJ
                    IB=LISTD2(J+1,KX)
                    IF(IFLAG(IB) .EQ. 0) THEN
                      ICOUNT = ICOUNT + 1
                      iiindex(icount) = IB
                      POS_B(1,ICOUNT) = POS_A(1,IB)
                      POS_B(2,ICOUNT) = POS_A(2,IB)  
                      POS_B(3,ICOUNT) = POS_A(3,IB)
                      POS_BB(1,ICOUNT) = TSCR(1,IB)
                      POS_BB(2,ICOUNT) = TSCR(2,IB)
                      POS_BB(3,ICOUNT) = TSCR(3,IB)
                      IFLAG(IB) = 1
                    ENDIF
                  ENDDO
                ENDIF
              ENDIF
            ENDIF
 200        CONTINUE
            IFLAG(IAT) = 1
          ENDDO
        ENDIF
      ENDIF

      IF(TROTMIN) THEN
        eps = 0.001d0
        call rmsd_rot(ICOUNT,POS_BB,POS_B,IIINDEX,transl,rot,
     &                natom,DERR,DER_ROT,.false.)
      ELSE
        CALL AZZERO(rot,9)
        DO I = 1,3
          rot(i,i) = 1.0D0
          xT = 0.0D0
          DO IAT = 1,NATOM
            xT = xT + TSCR(i,IAT)
          ENDDO
          transl(i) = XT/DBLE(NATOM)
        ENDDO
      ENDIF

      UNAT_DIS  = 1.0D0/DBLE(NAT_DISP)
      UNAT_DIS2 = 1.0D0/DBLE(NAT_DISP2)

C      write(6,*) 'n na ',NAT_DISP,NAT_DISP2
      DO IAT = 1,NAT_DISP
        II = IPOS_DISP(IAT)
        CALL FILLC(II,TSCR,XX)        
        XT = XX(1) -transl(1)
        YT = XX(2) -transl(2)
        ZT = XX(3) -transl(3)
        Rx =rot(1,1)*xt + rot(1,2)*yt + rot(1,3)*zt
        Ry =rot(2,1)*xt + rot(2,2)*yt + rot(2,3)*zt
        Rz =rot(3,1)*xt + rot(3,2)*yt + rot(3,3)*zt
        CALL FILLC2(II,POS_A,XX,D2_A,transl0)
        RAX = XX(1)
        RAY = XX(2)
        RAZ = XX(3)
        DISP_VEC(1)  = DISP_VEC(1) + RX - RAX
        DISP_VEC(2)  = DISP_VEC(2) + RY - RAY
        DISP_VEC(3)  = DISP_VEC(3) + RZ - RAZ
      ENDDO
C     ==--------------------------------------------------------------==
C     Calculate scalar product: DISP_VEC . DIR_VEC
      SCALP = DISP_VEC(1)*DIR_VEC(1) +  DISP_VEC(2)*DIR_VEC(2) +
     &        DISP_VEC(3)*DIR_VEC(3)

      SCALP = SCALP * UNAT_DIS

      CALL AZZERO(DISP_VEC,3)
C      write(6,*) 'scalp ',SCALP
C      write(6,'(A,4f12.6)') 'first ',
C     &      DISP_VEC(1),DISP_VEC(2),DISP_VEC(3),SCALP
C     ==--------------------------------------------------------------==

      DO IAT = 1,NAT_DISP2

        II = IPOS_DISP2(IAT)
        CALL FILLC(II,TSCR,XX)
        XT = XX(1) -transl(1)
        YT = XX(2) -transl(2)
        ZT = XX(3) -transl(3)
        Rx =rot(1,1)*xt + rot(1,2)*yt + rot(1,3)*zt
        Ry =rot(2,1)*xt + rot(2,2)*yt + rot(2,3)*zt
        Rz =rot(3,1)*xt + rot(3,2)*yt + rot(3,3)*zt

        CALL FILLC2(II,POS_A,XX,D2_A,transl0)
        RAX = XX(1)
        RAY = XX(2)
        RAZ = XX(3)

        DISP_VEC(1)   = DISP_VEC(1) + RX - RAX
        DISP_VEC(2)   = DISP_VEC(2) + RY - RAY
        DISP_VEC(3)   = DISP_VEC(3) + RZ - RAZ
      ENDDO
C     ==--------------------------------------------------------------==
C     Calculate scalar product: DISP_VEC . DIR_VEC
      SCALP2 = DISP_VEC(1)*DIR_VEC(1) +  DISP_VEC(2)*DIR_VEC(2) +
     &        DISP_VEC(3)*DIR_VEC(3)

      SCALP2 = SCALP2 * UNAT_DIS2
C      write(6,*) 'scalp2 ',SCALP2
C      write(6,'(A,4f12.6)') 'second ',
C     &      DISP_VEC(1),DISP_VEC(2),DISP_VEC(3),SCALP2
C     ==--------------------------------------------------------------==
      ICOUNT = 0

      DO IAT = 1,NAT_DISP
        II = IPOS_DISP(IAT)
        IF(II .LE. NATOM) THEN
          L1 = LSK(1,II)
          L2 = LSK(2,II)
          L3 = LSK(3,II)

          IF(TROTMIN) THEN
            XT = TSCR(1,II) -transl(1)
            YT = TSCR(2,II) -transl(2)
            ZT = TSCR(3,II) -transl(3)
            IF(L1.NE.0) AN(L1) = AN(L1) +
     &                       UNAT_DIS * ( rot(1,1)*DIR_VEC(1) +
     &                       rot(2,1)*DIR_VEC(2) + rot(3,1)*DIR_VEC(3) +
     &                      (der_rot(1,1,1,ii)*xt+der_rot(1,2,1,ii)*yt +
     &                       der_rot(1,3,1,ii)*zt) * DIR_VEC(1) +
     &                      (der_rot(2,1,1,ii)*xt+der_rot(2,2,1,ii)*yt +
     &                       der_rot(2,3,1,ii)*zt) * DIR_VEC(2) +
     &                      (der_rot(3,1,1,ii)*xt+der_rot(3,2,1,ii)*yt +
     &                       der_rot(3,3,1,ii)*zt) * DIR_VEC(3) )

            IF(L2.NE.0) AN(L2) = AN(L2) +
     &                       UNAT_DIS * ( rot(1,2)*DIR_VEC(1) +
     &                       rot(2,2)*DIR_VEC(2) + rot(3,2)*DIR_VEC(3) +
     &                      (der_rot(1,1,2,ii)*xt+der_rot(1,2,2,ii)*yt +
     &                       der_rot(1,3,2,ii)*zt) * DIR_VEC(1) +
     &                      (der_rot(2,1,2,ii)*xt+der_rot(2,2,2,ii)*yt +
     &                       der_rot(2,3,2,ii)*zt) * DIR_VEC(2) +
     &                      (der_rot(3,1,2,ii)*xt+der_rot(3,2,2,ii)*yt +
     &                       der_rot(3,3,2,ii)*zt) * DIR_VEC(3))

            IF(L3.NE.0) AN(L3) = AN(L3) +
     &                       UNAT_DIS * ( rot(1,3)*DIR_VEC(1) +
     &                       rot(2,3)*DIR_VEC(2) + rot(3,3)*DIR_VEC(3) +
     &                      (der_rot(1,1,3,ii)*xt+der_rot(1,2,3,ii)*yt +
     &                       der_rot(1,3,3,ii)*zt) * DIR_VEC(1) +
     &                      (der_rot(2,1,3,ii)*xt+der_rot(2,2,3,ii)*yt +
     &                       der_rot(2,3,3,ii)*zt) * DIR_VEC(2) +
     &                      (der_rot(3,1,3,ii)*xt+der_rot(3,2,3,ii)*yt +
     &                       der_rot(3,3,3,ii)*zt) * DIR_VEC(3) )

          ELSE
            IF(L1.NE.0) AN(L1) = AN(L1) + UNAT_DIS * DIR_VEC(1)
            IF(L2.NE.0) AN(L2) = AN(L2) + UNAT_DIS * DIR_VEC(2)
            IF(L3.NE.0) AN(L3) = AN(L3) + UNAT_DIS * DIR_VEC(3)
          ENDIF
        ELSEIF(II .LE. NATOM+NDAT) THEN  ! Dummy
          NAA=II-NAT
          ITYP=LISTDA(NAA,1)
          IF(ITYP.EQ.1) THEN
            GOTO 110
          ELSEIF(ITYP.EQ.2) THEN
            KX=LISTDA(NAA,2)
            JJ=LISTD2(1,KX)
            FFF=1.0D0/DBLE(JJ)
            DO J=1,JJ
              IB=LISTD2(J+1,KX)
              JX=LSKPTR(1,IB)
              JY=LSKPTR(2,IB)
              JZ=LSKPTR(3,IB)
              IF(TROTMIN) THEN
                FX = UNAT_DIS * ( rot(1,1)*DIR_VEC(1) +
     &                       rot(2,1)*DIR_VEC(2) + rot(3,1)*DIR_VEC(3) +
     &                      (der_rot(1,1,1,IB)*xt+der_rot(1,2,1,IB)*yt +
     &                       der_rot(1,3,1,IB)*zt) * DIR_VEC(1) +
     &                      (der_rot(2,1,1,IB)*xt+der_rot(2,2,1,IB)*yt +
     &                       der_rot(2,3,1,IB)*zt) * DIR_VEC(2) +
     &                      (der_rot(3,1,1,IB)*xt+der_rot(3,2,1,IB)*yt +
     &                       der_rot(3,3,1,IB)*zt) * DIR_VEC(3) )
                FY =   UNAT_DIS * ( rot(1,2)*DIR_VEC(1) +
     &                       rot(2,2)*DIR_VEC(2) + rot(3,2)*DIR_VEC(3) +
     &                      (der_rot(1,1,2,IB)*xt+der_rot(1,2,2,IB)*yt +
     &                       der_rot(1,3,2,IB)*zt) * DIR_VEC(1) +
     &                      (der_rot(2,1,2,IB)*xt+der_rot(2,2,2,IB)*yt +
     &                       der_rot(2,3,2,IB)*zt) * DIR_VEC(2) +
     &                      (der_rot(3,1,2,IB)*xt+der_rot(3,2,2,IB)*yt +
     &                       der_rot(3,3,2,IB)*zt) * DIR_VEC(3))
                FZ =   UNAT_DIS * ( rot(1,3)*DIR_VEC(1) +
     &                       rot(2,3)*DIR_VEC(2) + rot(3,3)*DIR_VEC(3) +
     &                      (der_rot(1,1,3,IB)*xt+der_rot(1,2,3,IB)*yt +
     &                       der_rot(1,3,3,IB)*zt) * DIR_VEC(1) +
     &                      (der_rot(2,1,3,IB)*xt+der_rot(2,2,3,IB)*yt +
     &                       der_rot(2,3,3,IB)*zt) * DIR_VEC(2) +
     &                      (der_rot(3,1,3,IB)*xt+der_rot(3,2,3,IB)*yt +
     &                       der_rot(3,3,3,IB)*zt) * DIR_VEC(3) )
              ELSE
                FX = UNAT_DIS * DIR_VEC(1)
                FY = UNAT_DIS * DIR_VEC(2)
                FZ = UNAT_DIS * DIR_VEC(3)
              ENDIF
              IF(JX.NE.0) THEN
                AN(JX)=AN(JX)+FX*FFF
              ENDIF
              IF(JY.NE.0) THEN
                AN(JY)=AN(JY)+FY*FFF
              ENDIF
              IF(JZ.NE.0) THEN
                AN(JZ)=AN(JZ)+FZ*FFF
              ENDIF
            ENDDO
          ENDIF
        ENDIF
 110    CONTINUE
      ENDDO

      DO IAT = 1,NAT_DISP2
        II = IPOS_DISP2(IAT)
        IF(II .LE. NATOM) THEN
          L1 = LSK(1,IPOS_DISP2(IAT))
          L2 = LSK(2,IPOS_DISP2(IAT))
          L3 = LSK(3,IPOS_DISP2(IAT))

          IF(TROTMIN) THEN
            XT = TSCR(1,ii) -transl(1)
            YT = TSCR(2,ii) -transl(2)
            ZT = TSCR(3,ii) -transl(3)
            IF(L1.NE.0) THEN
              AN(L1) = AN(L1) -
     &             UNAT_DIS2 * ( rot(1,1)*DIR_VEC(1) +
     &             rot(2,1)*DIR_VEC(2) + rot(3,1)*DIR_VEC(3) +
     &             (der_rot(1,1,1,ii)*xt+der_rot(1,2,1,ii)*yt +
     &             der_rot(1,3,1,ii)*zt) * DIR_VEC(1) +
     &             (der_rot(2,1,1,ii)*xt+der_rot(2,2,1,ii)*yt +
     &             der_rot(2,3,1,ii)*zt) * DIR_VEC(2) +
     &             (der_rot(3,1,1,ii)*xt+der_rot(3,2,1,ii)*yt +
     &             der_rot(3,3,1,ii)*zt) * DIR_VEC(3) )
            ENDIF
            IF(L2.NE.0) THEN
              AN(L2) = AN(L2) -
     &             UNAT_DIS2 * ( rot(1,2)*DIR_VEC(1) +
     &             rot(2,2)*DIR_VEC(2) + rot(3,2)*DIR_VEC(3) +
     &             (der_rot(1,1,2,ii)*xt+der_rot(1,2,2,ii)*yt +
     &             der_rot(1,3,2,ii)*zt) * DIR_VEC(1) +
     &             (der_rot(2,1,2,ii)*xt+der_rot(2,2,2,ii)*yt +
     &             der_rot(2,3,2,ii)*zt) * DIR_VEC(2) +
     &             (der_rot(3,1,2,ii)*xt+der_rot(3,2,2,ii)*yt +
     &             der_rot(3,3,2,ii)*zt) * DIR_VEC(3))
            ENDIF
            IF(L3.NE.0) THEN
              AN(L3) = AN(L3) -
     &             UNAT_DIS2 * ( rot(1,3)*DIR_VEC(1) +
     &             rot(2,3)*DIR_VEC(2) + rot(3,3)*DIR_VEC(3) +
     &             (der_rot(1,1,3,ii)*xt+der_rot(1,2,3,ii)*yt +
     &             der_rot(1,3,3,ii)*zt) * DIR_VEC(1) +
     &             (der_rot(2,1,3,ii)*xt+der_rot(2,2,3,ii)*yt +
     &             der_rot(2,3,3,ii)*zt) * DIR_VEC(2) +
     &             (der_rot(3,1,3,ii)*xt+der_rot(3,2,3,ii)*yt +
     &             der_rot(3,3,3,ii)*zt) * DIR_VEC(3) )
            ENDIF
          ELSE
            IF(L1.NE.0) THEN
              AN(L1) = AN(L1) - UNAT_DIS2 * DIR_VEC(1)
            ENDIF
            IF(L2.NE.0) THEN
              AN(L2) = AN(L2) - UNAT_DIS2 * DIR_VEC(2)
            ENDIF
            IF(L3.NE.0) THEN
              AN(L3) = AN(L3) - UNAT_DIS2 * DIR_VEC(3)
            ENDIF
          ENDIF
        ELSEIF(II .LE. NATOM+NDAT) THEN  ! Dummy
          NAA=II-NAT
          ITYP=LISTDA(NAA,1)
          IF(ITYP.EQ.1) THEN
            GOTO 210
          ELSEIF(ITYP.EQ.2) THEN
            KX=LISTDA(NAA,2)
            JJ=LISTD2(1,KX)
            FFF=1.0D0/DBLE(JJ)
            DO J=1,JJ
              IB=LISTD2(J+1,KX)
              JX=LSKPTR(1,IB)
              JY=LSKPTR(2,IB)
              JZ=LSKPTR(3,IB)
              IF(TROTMIN) THEN
                FX = -UNAT_DIS2 * ( rot(1,1)*DIR_VEC(1) +
     &                       rot(2,1)*DIR_VEC(2) + rot(3,1)*DIR_VEC(3) +
     &                      (der_rot(1,1,1,IB)*xt+der_rot(1,2,1,IB)*yt +
     &                       der_rot(1,3,1,IB)*zt) * DIR_VEC(1) +
     &                      (der_rot(2,1,1,IB)*xt+der_rot(2,2,1,IB)*yt +
     &                       der_rot(2,3,1,IB)*zt) * DIR_VEC(2) +
     &                      (der_rot(3,1,1,IB)*xt+der_rot(3,2,1,IB)*yt +
     &                       der_rot(3,3,1,IB)*zt) * DIR_VEC(3) )
                FY =  -UNAT_DIS2 * ( rot(1,2)*DIR_VEC(1) +
     &                       rot(2,2)*DIR_VEC(2) + rot(3,2)*DIR_VEC(3) +
     &                      (der_rot(1,1,2,IB)*xt+der_rot(1,2,2,IB)*yt +
     &                       der_rot(1,3,2,IB)*zt) * DIR_VEC(1) +
     &                      (der_rot(2,1,2,IB)*xt+der_rot(2,2,2,IB)*yt +
     &                       der_rot(2,3,2,IB)*zt) * DIR_VEC(2) +
     &                      (der_rot(3,1,2,IB)*xt+der_rot(3,2,2,IB)*yt +
     &                       der_rot(3,3,2,IB)*zt) * DIR_VEC(3))
                FZ =  -UNAT_DIS2 * ( rot(1,3)*DIR_VEC(1) +
     &                       rot(2,3)*DIR_VEC(2) + rot(3,3)*DIR_VEC(3) +
     &                      (der_rot(1,1,3,IB)*xt+der_rot(1,2,3,IB)*yt +
     &                       der_rot(1,3,3,IB)*zt) * DIR_VEC(1) +
     &                      (der_rot(2,1,3,IB)*xt+der_rot(2,2,3,IB)*yt +
     &                       der_rot(2,3,3,IB)*zt) * DIR_VEC(2) +
     &                      (der_rot(3,1,3,IB)*xt+der_rot(3,2,3,IB)*yt +
     &                       der_rot(3,3,3,IB)*zt) * DIR_VEC(3) )
              ELSE
                FX = -UNAT_DIS2 * DIR_VEC(1)
                FY = -UNAT_DIS2 * DIR_VEC(2)
                FZ = -UNAT_DIS2 * DIR_VEC(3)
              ENDIF
              IF(JX.NE.0) THEN
                AN(JX)=AN(JX)+FX*FFF
              ENDIF
              IF(JY.NE.0) THEN
                AN(JY)=AN(JY)+FY*FFF
              ENDIF
              IF(JZ.NE.0) THEN
                AN(JZ)=AN(JZ)+FZ*FFF
              ENDIF
            ENDDO
          ENDIF
        ENDIF
 210    CONTINUE
      ENDDO

      SCALP = SCALP-SCALP2

      CALL FREEM(IP_IFLAG)
C      write (6,*) scalp
C      stop 'scalp'
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE rmsd_rot(n,r,r0,index,transl,rot,natom,
     &                    derr_dr,der_rot,PBC)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      integer      n,natom
      real*8       r(3,n),r0(3,n),q(0:3),err
      real*8       derr_dr(3,natom),transl(3),rot(3,3)
      real*8       der_rot(3,3,3,natom)
      integer      index(n)
      logical      PBC
C
      character*80 msg
      integer i,j,k,jobn,ier,ix,iret,iq,info
      real*8  epsi,s,ww,dl_av(3),
     &        m(4,4),lambda(4),z(4,4),wk(20)
      real*8 rr0(3),rr(3),dm_r(4,4,3),rp(3,n),r0p(3,n),rrsq
      real*8 der_q(0:3),dq(0:3)
      real*8 xx,yy,zz
      data epsi /1.0d-10/
C     ==--------------------------------------------------------------==
C  center r
      xx=0.d0
      yy=0.d0
      zz=0.d0
!$OMP parallel do private(i) reduction(+:xx,yy,zz)
      DO i=1,n
        xx=xx+r(1,i)
        yy=yy+r(2,i)
        zz=zz+r(3,i)
      ENDDO
      xx=xx/dble(n)
      yy=yy/dble(n)
      zz=zz/dble(n)
!$OMP parallel do private(i) shared(xx,yy,zz)
      DO i=1,n
        rp(1,i)=r(1,i)-xx
        rp(2,i)=r(2,i)-yy
        rp(3,i)=r(3,i)-zz
      ENDDO
      transl(1)=xx
      transl(2)=yy
      transl(3)=zz
C  center r0
      xx=0.d0
      yy=0.d0
      zz=0.d0
!$OMP parallel do private(i) reduction(+:xx,yy,zz)
      DO i=1,n
        xx=xx+r0(1,i)
        yy=yy+r0(2,i)
        zz=zz+r0(3,i)
      ENDDO
      xx=xx/dble(n)
      yy=yy/dble(n)
      zz=zz/dble(n)
!$OMP parallel do private(i) shared(xx,yy,zz)
      do i=1,n
        r0p(1,i)=r0(1,i)-xx
        r0p(2,i)=r0(2,i)-yy
        r0p(3,i)=r0(3,i)-zz
      enddo
      transl(1)=xx
      transl(2)=yy
      transl(3)=zz
C
C      do i = 1,16
C        m(i,1) = 0.d0
C      enddo
      CALL AZZERO(m,4*4)

      DO i = 1,n
C        if (w(i) .eq. 0.d0) cycle
        rr(1)=rp(1,i)
        rr(2)=rp(2,i)
        rr(3)=rp(3,i)
        rr0(1)=r0p(1,i)
        rr0(2)=r0p(2,i)
        rr0(3)=r0p(3,i)
        rrsq=rr0(1)**2+rr0(2)**2+rr0(3)**2+rr(1)**2+rr(2)**2+rr(3)**2
C        rr0(1)=w(i)*rr0(1)
C        rr0(2)=w(i)*rr0(2)
C        rr0(3)=w(i)*rr0(3)

        m(1,1)=m(1,1) + rrsq+2.D0*
     &                (-rr0(1)*rr(1)-rr0(2)*rr(2)-rr0(3)*rr(3))
        m(2,2)=m(2,2) + rrsq+2.D0*
     &                (-rr0(1)*rr(1)+rr0(2)*rr(2)+rr0(3)*rr(3))
        m(3,3)=m(3,3) + rrsq+2.D0*
     &                (+rr0(1)*rr(1)-rr0(2)*rr(2)+rr0(3)*rr(3))
        m(4,4)=m(4,4) + rrsq+2.D0*
     &                 (+rr0(1)*rr(1)+rr0(2)*rr(2)-rr0(3)*rr(3))
        m(1,2)=m(1,2) +2.D0*(-rr0(2)*rr(3)+rr0(3)*rr(2))
        m(1,3)=m(1,3) +2.D0*(rr0(1)*rr(3)-rr0(3)*rr(1))
        m(1,4)=m(1,4) +2.D0*(-rr0(1)*rr(2)+rr0(2)*rr(1))
        m(2,3)=m(2,3) -2.D0*(rr0(1)*rr(2)+rr0(2)*rr(1))
        m(2,4)=m(2,4) -2.D0*(rr0(1)*rr(3)+rr0(3)*rr(1))
        m(3,4)=m(3,4) -2.D0*(rr0(2)*rr(3)+rr0(3)*rr(2))
      ENDDO
      m(2,1) = m(1,2)
      m(3,1) = m(1,3)
      m(3,2) = m(2,3)
      m(4,1) = m(1,4)
      m(4,2) = m(2,4)
      m(4,3) = m(3,4)


*---- SOLVE THE EIGENVECTOR PROBLEM FOR M: --------------------------*

      iret = 0
C     jobn   = 12
C     call EIGRS(m,4,jobn,lambda,z,4,wk,ier)
      ier=0
      CALL DCOPY(16,m,1,z,1)
      CALL DSYEV('V','U',4,z,4,lambda,wk,20,ier)
      if (ier .ne. 0) then
        CALL STOPGM('RMSD_ROT','Fatal error in DSYSEV')
      endif
      if (wk(1) .gt. 1.d0) then
        iret = 9
      endif
*---- PICK THE CORRECT EIGENVECTOR(S): ------------------------------*

      s =  1.d0
      if (z(1,1) .lt. 0.d0) then
        s = -1.d0
      endif
      q(0) = s*z(1,1)
      q(1) = s*z(2,1)
      q(2) = s*z(3,1)
      q(3) = s*z(4,1)
      if (dabs(lambda(1)) .lt. epsi) then
         err = 0.d0
      else
C         err = dsqrt(lambda(1))
         err = lambda(1)/dble(n)
      endif
      if (dabs(lambda(1) - lambda(2)) .lt. epsi)iret = iret + 10

      if (iret .eq. 0)  then
        msg = ' LSQQTN: Normal execution, unique solution'
      endif
      if (iret .eq. 10) then
        msg = ' LSQQTN: Normal execution, non-unique solution'
      endif
      if (iret .eq. 9) then
        msg = ' LSQQTN: Bad perform. in eigrs, unique solution'
      endif
      if (iret .eq. 19) then
        msg = ' LSQQTN: Bad perform. in eigrs, non-unique solution'
      endif
      if(iret.ne.0) then
        write(6,*) msg
      endif

*---- DERIVATIVES OF RMSD with respect to the positions
      do i = 1,n
        rr(1)=2.d0*rp(1,i)
        rr(2)=2.d0*rp(2,i)
        rr(3)=2.d0*rp(3,i)
        rr0(1)=2.d0*r0p(1,i)
        rr0(2)=2.d0*r0p(2,i)
        rr0(3)=2.d0*r0p(3,i)
C
        dm_r (1,1,1)=(rr(1)-rr0(1))
        dm_r (1,1,2)=(rr(2)-rr0(2))
        dm_r (1,1,3)=(rr(3)-rr0(3))
C
        dm_r (1,2,1)=0.d0
        dm_r (1,2,2)= rr0(3)
        dm_r (1,2,3)=-rr0(2)
C
        dm_r (1,3,1)=-rr0(3)
        dm_r (1,3,2)= 0.d0
        dm_r (1,3,3)= rr0(1)
C
        dm_r (1,4,1)= rr0(2)
        dm_r (1,4,2)=-rr0(1)
        dm_r (1,4,3)= 0.d0
C
        dm_r (2,2,1)=(rr(1)-rr0(1))
        dm_r (2,2,2)=(rr(2)+rr0(2))
        dm_r (2,2,3)=(rr(3)+rr0(3))
C
        dm_r (2,3,1)=-rr0(2)
        dm_r (2,3,2)=-rr0(1)
        dm_r (2,3,3)= 0.d0
C
        dm_r (2,4,1)=-rr0(3)
        dm_r (2,4,2)= 0.d0
        dm_r (2,4,3)=-rr0(1)
C
        dm_r (3,3,1)=(rr(1)+rr0(1))
        dm_r (3,3,2)=(rr(2)-rr0(2))
        dm_r (3,3,3)=(rr(3)+rr0(3))
C
        dm_r (3,4,1)=0.d0
        dm_r (3,4,2)=-rr0(3)
        dm_r (3,4,3)=-rr0(2)
C
        dm_r (4,4,1)=(rr(1)+rr0(1))
        dm_r (4,4,2)=(rr(2)+rr0(2))
        dm_r (4,4,3)=(rr(3)-rr0(3))
C
        do ix=1,3
          dm_r(2,1,ix)=dm_r(1,2,ix)
          dm_r(3,1,ix)=dm_r(1,3,ix)
          dm_r(4,1,ix)=dm_r(1,4,ix)
          dm_r(3,2,ix)=dm_r(2,3,ix)
          dm_r(4,2,ix)=dm_r(2,4,ix)
          dm_r(4,3,ix)=dm_r(3,4,ix)
        enddo
C
        do ix=1,3
          derr_dr (ix,index(i))=0.d0
          do k=1,4
            do j=1,4
              derr_dr (ix,index(i))=derr_dr (ix,index(i)) +
     &                              q(k-1)*q(j-1)*dm_r (j,k,ix)
            enddo
          enddo
          derr_dr (ix,index(i))=derr_dr (ix,index(i))/dble(n)
        enddo

        IF(PBC) GOTO 120

        do ix = 1,3
          CALL AZZERO(der_q(0),4)

          do iq=2,4
            dq(iq-1) = 0.0D0
            do j = 1,4
              do k = 1,4
                dq(iq-1) = dq(iq-1) +
     &             z(j,iq)*dm_r(j,k,ix)*z(k,1)
              enddo
            enddo
            dq(iq-1) = -dq(iq-1)/(lambda(iq)-lambda(1))
          enddo
          do iq=1,4
            do j = 1,4
              der_q(iq-1) = der_q(iq-1) + z(iq,j)*dq(j-1)*s
            enddo
          enddo

          der_rot(1,1,ix,index(i)) = -4.D0 * q(2)*der_q(2) -
     &                         4.D0 * q(3)*der_q(3)
          der_rot(1,2,ix,index(i)) =  2.D0 *
     &                   ( -der_q(0)*q(3) - q(0)*der_q(3) +
     &                      der_q(1)*q(2) + q(1)*der_q(2) )
          der_rot(1,3,ix,index(i)) =  2.D0 *
     &                   (  der_q(0)*q(2) + q(0)*der_q(2) +
     &                      der_q(1)*q(3) + q(1)*der_q(3) )
          der_rot(2,1,ix,index(i)) =  2.D0 *
     &                   (  der_q(0)*q(3) + q(0)*der_q(3) +
     &                      der_q(1)*q(2) + q(1)*der_q(2) )
          der_rot(2,2,ix,index(i)) = -4.D0*q(1)*der_q(1) -
     &                         4.D0*q(3)*der_q(3)
          der_rot(2,3,ix,index(i)) =  2.D0 *
     &                   ( -der_q(0)*q(1) - q(0)*der_q(1) +
     &                      der_q(2)*q(3) + q(2)*der_q(3) )
          der_rot(3,1,ix,index(i)) =  2.D0 *
     &                   ( -der_q(0)*q(2) - q(0)*der_q(2) +
     &                      der_q(1)*q(3) + q(1)*der_q(3) )
          der_rot(3,2,ix,index(i)) =  2.D0 *
     &                   (  der_q(0)*q(1) + q(0)*der_q(1) +
     &                      der_q(2)*q(3) + q(2)*der_q(3) )
          der_rot(3,3,ix,index(i)) = -4.D0*q(1)*der_q(1) -
     &                         4.D0*q(2)*der_q(2)

        enddo

 120    CONTINUE

      enddo

*---- ROTATION MATRIX IN TERMS OF QUATERNIONS: ----------------------*

      rot(1,1)=-2.d0*q(2)**2-2.d0*q(3)**2+1.d0
      rot(1,2)=2.d0*(-q(0)*q(3)+q(1)*q(2))
      rot(1,3)=2.d0*(q(0)*q(2)+q(1)*q(3))
      rot(2,1)=2.d0*(q(0)*q(3)+q(1)*q(2))
      rot(2,2)=-2.d0*q(1)**2-2.d0*q(3)**2+1.d0
      rot(2,3)=2.d0*(-q(0)*q(1)+q(2)*q(3))
      rot(3,1)=2.d0*(-q(0)*q(2)+q(1)*q(3))
      rot(3,2)=2.d0*(q(0)*q(1)+q(2)*q(3))
      rot(3,3)=-2.d0*q(1)**2-2.d0*q(2)**2+1.d0
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE funcp_mia(diff,teta,teta0,x,y,z,w,d)
C     ==--------------------------------------------------------------==
C     FUNCTION: phi - phi0
      implicit none
C     Argument variables
      real*8    diff,teta,teta0,w(3),x(3),y(3),z(3),d(12)
C     Local variables
      real*8    epsilon
      parameter (epsilon=1.D-12)
C  cmb - original "sin" and "cos" conflict with fortran intrinsic fcn
      real*8    sinn,coss,t(3),q(3),nn(3),o(3),pi4,sign0,t_norm
      real*8    ovn(3),num,den,const,o_norm,nn_norm,nn2,o2,scal
      integer i
C     ==--------------------------------------------------------------==
      sign0=+1.d0
      pi4=DACOS(-1.D0)
      t(1) = (x(1)-y(1))
      t(2) = (x(2)-y(2))
      t(3) = (x(3)-y(3))
      t_norm = DSQRT(t(1)*t(1)+t(2)*t(2)+t(3)*t(3))
      q(1) = (z(1)-y(1))
      q(2) = (z(2)-y(2))
      q(3) = (z(3)-y(3))
      call vecprod(t,q,nn)
      nn2 = nn(1)*nn(1)+nn(2)*nn(2)+nn(3)*nn(3)
      nn_norm = DSQRT(nn2)
      o(1) = (w(1)-y(1))
      o(2) = (w(2)-y(2))
      o(3) = (w(3)-y(3))
      o2 = o(1)*o(1)+o(2)*o(2)+o(3)*o(3)
      o_norm = DSQRT(o2)

      call getscal(o,t,scal)
      call getscal(o,nn,coss)
      num = coss
      den = 1.0D0/(o_norm*nn_norm)
      coss = coss*den
      sinn = DSQRT(1.d0-coss*coss)
      teta = DACOS(coss)
      if(scal .lt. 0.d0) then
        sign0=-1.d0
        teta=-teta+2.d0*pi4
      endif

      diff=mod(20000.d0*pi4+teta0,2.d0*pi4)-teta

      const = -1.0D0/sinn*sign0

      d(1) = const*den*(-q(3)*o(2)+q(2)*o(3)
     &       -num*(-q(3)*nn(2)+q(2)*nn(3))/nn2)
      d(2) = const*den*(-q(1)*o(3)+q(3)*o(1)
     &       -num*(-q(1)*nn(3)+q(3)*nn(1))/nn2)
      d(3) = const*den*(-q(2)*o(1)+q(1)*o(2)
     &       -num*(-q(2)*nn(1)+q(1)*nn(2))/nn2)

      d(4) = const*den*(-nn(1)-t(3)*o(2)+q(3)*o(2)-q(2)*o(3)+t(2)*o(3)
     &       -num*(-o(1)/o2+
     &       ((-t(3)+q(3))*nn(2)+(-q(2)+t(2))*nn(3))/nn2))
      d(5) = const*den*(-nn(2)-q(3)*o(1)+t(3)*o(1)-t(1)*o(3)+q(1)*o(3)
     &       -num*(-o(2)/o2+
     &       ((-q(3)+t(3))*nn(1)+(-t(1)+q(1))*nn(3))/nn2))
      d(6) = const*den*(-nn(3)-t(2)*o(1)+q(2)*o(1)-q(1)*o(2)+t(1)*o(2)
     &       -num*(-o(3)/o2+
     &       ((-t(2)+q(2))*nn(1)+(-q(1)+t(1))*nn(2))/nn2))

      d(7) = const*den*(t(3)*o(2)-t(2)*o(3)
     &       -num*(t(3)*nn(2)-t(2)*nn(3))/nn2)
      d(8) = const*den*(t(1)*o(3)-t(3)*o(1)
     &       -num*(t(1)*nn(3)-t(3)*nn(1))/nn2)
      d(9) = const*den*(t(2)*o(1)-t(1)*o(2)
     &        -num*(t(2)*nn(1)-t(1)*nn(2))/nn2)

      d(10) = const*den*(nn(1)-num*o(1)/o2)
      d(11) = const*den*(nn(2)-num*o(2)/o2)
      d(12) = const*den*(nn(3)-num*o(3)/o2)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE aplane(diff,teta,teta0,xa,ya,za,xb,yb,zb,d)
C     ==--------------------------------------------------------------==
C     FUNCTION: phi - phi0
      implicit none
C     Argument variables
      real*8    diff,teta,teta0,xa(3),ya(3),za(3),d(18)
      real*8    xb(3),yb(3),zb(3)
C     Local variables
      real*8    der1,der2,der3
      real*8    sinus,cosine,t(3),q(3),NNA(3),nnb(3),pi4,sign0
      real*8    den,const,nn2a,nn2b,scal
      integer i
C     ==--------------------------------------------------------------==
      sign0=+1.0D0
      pi4=DACOS(-1.D0)      

      nna(1) = (ya(2)-xa(2))*(za(3)-xa(3))-(ya(3)-xa(3))*(za(2)-xa(2))
      nna(2) = (ya(3)-xa(3))*(za(1)-xa(1))-(ya(1)-xa(1))*(za(3)-xa(3))
      nna(3) = (ya(1)-xa(1))*(za(2)-xa(2))-(ya(2)-xa(2))*(za(1)-xa(1))


      nnb(1) = (yb(2)-xb(2))*(zb(3)-xb(3))-(yb(3)-xb(3))*(zb(2)-xb(2))
      nnb(2) = (yb(3)-xb(3))*(zb(1)-xb(1))-(yb(1)-xb(1))*(zb(3)-xb(3))
      nnb(3) = (yb(1)-xb(1))*(zb(2)-xb(2))-(yb(2)-xb(2))*(zb(1)-xb(1))

      call getscal(nnb,nna,cosine)

      nn2a = nna(1)*nna(1)+ nna(2)*nna(2)+ nna(3)*nna(3)
      nn2a = dsqrt(nn2a)
      if(nn2a.lt.0.00001d0) nn2a=0.00001d0
      nn2b = nnb(1)*nnb(1)+ nnb(2)*nnb(2)+ nnb(3)*nnb(3)
      nn2b = dsqrt(nn2b)
      if(nn2b.lt.0.00001d0) nn2b=0.00001d0
      den  = 1.0D0/(nn2a*nn2b)
      cosine = cosine * den

      sinus = dsqrt(1.0d0-cosine*cosine)
      if(sinus .lt. 0.00001d0) then
        sinus=0.00001d0
      endif
      teta = dacos(cosine)

      diff=mod(20000.d0*pi4+teta0,2.0d0*pi4)-teta

      const = -sign0*den/sinus

      der1 = 0.0D0
      der2 = -(ya(3)-xa(3))+(za(3)-xa(3))
      der3 = -(za(2)-xa(2))+(ya(2)-xa(2))
      d(1)  = const * (der1*nnb(1)+der2*nnb(2)+der3*nnb(3) -
     &             cosine*(der1*nna(1)+der2*nna(2)+der3*nna(3))
     &             *nn2b/nn2a )

      der1 = -(za(3)-xa(3))+(ya(3)-xa(3))
      der2 = 0.0D0
      der3 = -(ya(1)-xa(1))+(za(1)-xa(1))
      d(2)  = const * (der1*nnb(1)+der2*nnb(2)+der3*nnb(3) -
     &             cosine*(der1*nna(1)+der2*nna(2)+der3*nna(3))
     &             *nn2b/nn2a )

      der1 = -(ya(2)-xa(2))+(za(2)-xa(2))
      der2 = -(za(1)-xa(1))+(ya(1)-xa(1))
      der3 = 0.0D0
      d(3)  = const * (der1*nnb(1)+der2*nnb(2)+der3*nnb(3) -
     &             cosine*(der1*nna(1)+der2*nna(2)+der3*nna(3))
     &             *nn2b/nn2a )

      der1 = 0.0D0
      der2 = -(za(3)-xa(3))
      der3 =  (za(2)-xa(2))
      d(4)  = const * (der1*nnb(1)+der2*nnb(2)+der3*nnb(3) -
     &             cosine*(der1*nna(1)+der2*nna(2)+der3*nna(3))
     &             *nn2b/nn2a )

      der1 =  (za(3)-xa(3))
      der2 = 0.0D0
      der3 = -(za(1)-xa(1))
      d(5)  = const * (der1*nnb(1)+der2*nnb(2)+der3*nnb(3) -
     &             cosine*(der1*nna(1)+der2*nna(2)+der3*nna(3))
     &             *nn2b/nn2a )

      der1 = -(za(2)-xa(2))
      der2 = +(za(1)-xa(1))
      der3 = 0.0D0
      d(6)  = const * (der1*nnb(1)+der2*nnb(2)+der3*nnb(3) -
     &             cosine*(der1*nna(1)+der2*nna(2)+der3*nna(3))
     &             *nn2b/nn2a )

      der1 = 0.0D0
      der2 =  (ya(3)-xa(3))
      der3 = -(ya(2)-xa(2))
      d(7)  = const * (der1*nnb(1)+der2*nnb(2)+der3*nnb(3) -
     &             cosine*(der1*nna(1)+der2*nna(2)+der3*nna(3))
     &             *nn2b/nn2a )

      der1 = -(ya(3)-xa(3))
      der2 = 0.0D0
      der3 =  (ya(1)-xa(1))
      d(8)  = const * (der1*nnb(1)+der2*nnb(2)+der3*nnb(3) -
     &             cosine*(der1*nna(1)+der2*nna(2)+der3*nna(3))
     &             *nn2b/nn2a )

      der1 =  (ya(2)-xa(2))
      der2 = -(ya(1)-xa(1))
      der3 = 0.0D0
      d(9)  = const * (der1*nnb(1)+der2*nnb(2)+der3*nnb(3) -
     &             cosine*(der1*nna(1)+der2*nna(2)+der3*nna(3))
     &             *nn2b/nn2a )


      der1 = 0.0D0
      der2 = -(yb(3)-xb(3))+(zb(3)-xb(3))
      der3 = -(zb(2)-xb(2))+(yb(2)-xb(2))
      d(10)  = const * (der1*nna(1)+der2*nna(2)+der3*nna(3) -
     &             cosine*(der1*nnb(1)+der2*nnb(2)+der3*nnb(3))
     &             *nn2b/nn2a )

      der1 = -(zb(3)-xb(3))+(yb(3)-xb(3))
      der2 = 0.0D0
      der3 = -(yb(1)-xb(1))+(zb(1)-xb(1))
      d(11)  = const * (der1*nna(1)+der2*nna(2)+der3*nna(3) -
     &             cosine*(der1*nnb(1)+der2*nnb(2)+der3*nnb(3))
     &             *nn2b/nn2a )

      der1 = -(yb(2)-xb(2))+(zb(2)-xb(2))
      der2 = -(zb(1)-xb(1))+(yb(1)-xb(1))
      der3 = 0.0D0
      d(12)  = const * (der1*nna(1)+der2*nna(2)+der3*nna(3) -
     &             cosine*(der1*nnb(1)+der2*nnb(2)+der3*nnb(3))
     &             *nn2b/nn2a )

      der1 = 0.0D0
      der2 = -(zb(3)-xb(3))
      der3 =  (zb(2)-xb(2))
      d(13)  = const * (der1*nna(1)+der2*nna(2)+der3*nna(3) -
     &             cosine*(der1*nnb(1)+der2*nnb(2)+der3*nnb(3))
     &             *nn2b/nn2a )

      der1 =  (zb(3)-xb(3))
      der2 = 0.0D0
      der3 = -(zb(1)-xb(1))
      d(14)  = const * (der1*nna(1)+der2*nna(2)+der3*nna(3) -
     &             cosine*(der1*nnb(1)+der2*nnb(2)+der3*nnb(3))
     &             *nn2b/nn2a )

      der1 = -(zb(2)-xb(2))
      der2 = +(zb(1)-xb(1))
      der3 = 0.0D0
      d(15)  = const * (der1*nna(1)+der2*nna(2)+der3*nna(3) -
     &             cosine*(der1*nnb(1)+der2*nnb(2)+der3*nnb(3))
     &             *nn2b/nn2a )

      der1 = 0.0D0
      der2 =  (yb(3)-xb(3))
      der3 = -(yb(2)-xb(2))
      d(16)  = const * (der1*nna(1)+der2*nna(2)+der3*nna(3) -
     &             cosine*(der1*nnb(1)+der2*nnb(2)+der3*nnb(3))
     &             *nn2b/nn2a )

      der1 = -(yb(3)-xb(3))
      der2 = 0.0D0
      der3 =  (yb(1)-xb(1))
      d(17)  = const * (der1*nna(1)+der2*nna(2)+der3*nna(3) -
     &             cosine*(der1*nnb(1)+der2*nnb(2)+der3*nnb(3))
     &             *nn2b/nn2a )

      der1 =  (yb(2)-xb(2))
      der2 = -(yb(1)-xb(1))
      der3 = 0.0D0
      d(18)  = const * (der1*nna(1)+der2*nna(2)+der3*nna(3) -
     &             cosine*(der1*nnb(1)+der2*nnb(2)+der3*nnb(3))
     &             *nn2b/nn2a )
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE RMSD_AB(NUMSPEC,ISPEC,I_RMSD,TSCR,NATOM,
     &                   AN,LSK,FCI,FVI,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'irat.inc'
      INCLUDE 'cnst_dyn.inc'
      INCLUDE 'fileopen.inc'

C     Arguments
      INTEGER   NUMSPEC,ISPEC(NUMSPEC),I_RMSD,LSK(3,NAT),NATOM
      REAL*8    TSCR(3,*),AN(*),FCI,FVI,CVAL
C     Variables
      INTEGER   IFIRST
      DATA      IFIRST /0/
      SAVE      IFIRST
      REAL*8    POS_A(3,NATOM,NRMSD_AB),POS_B(3,NATOM,NRMSD_AB)
      POINTER   (IP_POS_A,POS_A) , (IP_POS_B,POS_B)
      SAVE      IP_POS_A,IP_POS_B,IP_RMSD_SCR,IP_IPOS_RMSD
      REAL*8    R_ION(3,*),RA_ION(3,*),RB_ION(3,*)
      POINTER   (IP_R_ION,R_ION),(IP_RA_ION,RA_ION),(IP_RB_ION,RB_ION)
      REAL*8    DERR_A(3,*),DERR_B(3,*)
      POINTER   (IP_DERR_A,DERR_A),(IP_DERR_B,DERR_B)
      REAL*8    R_CM(3,*),R0_CM(3,*)
      POINTER   (IP_R_CM,R_CM),(IP_R0_CM,R0_CM)
      REAL*8    RMSD_SCR(*)
      POINTER   (IP_RMSD_SCR,RMSD_SCR)
      INTEGER   NAT_RMSD,IAT,IINI,IEND,L1,L2,L3,K,IUNIT,LI_NAT
      INTEGER   IPOS_RMSD(*),I,ISP,IS,IA
      POINTER   (IP_IPOS_RMSD,IPOS_RMSD)
      PARAMETER (IUNIT=58)
      REAL*8    RMSD_A,RMSD_B,RMSD_NUM,RMSD_DEN,URMSD_DEN
      CHARACTER*80 LABEL,ELEMENT
      CHARACTER FILEN*100
      LOGICAL   FERROR
      INTEGER   I1,I2,ICOUNT,ICV
C     ==--------------------------------------------------------------==
      IF(IFIRST.EQ.0) THEN
C     Allocate memory
        CALL MEMORY(IP_POS_A,3*NATOM*NRMSD_AB,'POS_A')
        CALL MEMORY(IP_POS_B,3*NATOM*NRMSD_AB,'POS_B')
        CALL MEMORY(IP_IPOS_RMSD,NATOM/IRAT+1,'IPOS_RMSD')
        CALL MEMORY(IP_RMSD_SCR,7*3*NATOM,'RMSD_SCR')

        ICOUNT = 0
        DO ICV = 1,NCOLVAR
          IF(ICV_RMSD_AB(ICV) .NE. 0) THEN
            ICOUNT = ICOUNT + 1
C     Read the reference configurations
            FILEN=FILE_STR_AB(ICV)
            FERROR=.FALSE.
            CALL FILEOPEN(IUNIT,FILEN,FO_OLD,FERROR)
            IF(FERROR) THEN
              WRITE(6,'(A,A,A)')
     &        ' RMSD_AB! File',FILEN,'  DOES NOT EXIST!!'
              CALL STOPGM('RMSD_AB','CANNOT READ A and B COORDINATES')
            ENDIF
            REWIND(IUNIT)
            READ(IUNIT,ERR=998,FMT=*) LABEL
            DO IAT=1,NAT
              READ(IUNIT,ERR=998,FMT=*) ELEMENT,
     &           (POS_A(K,IAT,ICOUNT),K=1,3)
            ENDDO
            WRITE(6,'(/A,A,A/)') ' A COORDINATES READ ',
     *       'FROM FILE ',FILEN
            READ(IUNIT,ERR=998,FMT=*) LABEL
            DO IAT=1,NAT
              READ(IUNIT,ERR=998,FMT=*) ELEMENT,
     &           (POS_B(K,IAT,ICOUNT),K=1,3)
            ENDDO
            WRITE(6,'(/A,A,A/)') ' B COORDINATES READ ',
     *       'FROM FILE ',FILEN
            CALL FILECLOSE(IUNIT)
            GOTO 999

 998        CONTINUE
            WRITE(6,'(A)') ' RMSD_AB! ERROR WHILE READING COORDINATES'
            CALL STOPGM('RMSD_AB','READ ERROR')

 999        CONTINUE
          ENDIF   !ICV_RMSD_AB
        ENDDO   ! NCOLVAR
        IFIRST=1

        IF(ICOUNT .NE. NRMSD_AB) THEN
          CALL STOPGM('RMSD_AB','ERROR in NRMSD_AB')
        ENDIF
      ENDIF
C     ==--------------------------------------------------------------==
C      write(6,*) 'pos rmsd ', I_RMSD
C      do iat = 1,natom
C        write(6,*) POS_A(1,IAT,I_RMSD),POS_B(1,IAT,I_RMSD)
C      enddo
C      STOP 'conf read'
      CALL IAZZERO(IPOS_RMSD,NATOM)
      CALL AZZERO(RMSD_SCR,7*3*NATOM)

C     Create the list of engaged ions

      NAT_RMSD = 0
      IF(NUMSPEC .EQ. 0) THEN
        IAT = 0
        DO IS = 1,NSP
          DO IA = 1,NA(IS)
            NAT_RMSD = NAT_RMSD + 1
            IAT = IAT + IA
            IPOS_RMSD(NAT_RMSD) = IAT
          ENDDO
        ENDDO
      ELSE
        DO IS=1,NUMSPEC
          ISP = ISPEC(IS)
          IINI = 0
          DO I = 1,ISP-1
            IINI = IINI + NA(I)
          ENDDO
          IEND = IINI + NA(ISP)
          IINI = IINI + 1
          DO IAT = IINI,IEND
            NAT_RMSD = NAT_RMSD + 1
            IPOS_RMSD(NAT_RMSD) = IAT
          ENDDO
        ENDDO
      ENDIF   ! NUMSPEC

#ifdef _BGL
      LI_NAT=3*NAT_RMSD+MOD(3*NAT_RMSD,2)
      CALL GET_ADDR(IP_R_ION,RMSD_SCR(1))
      CALL GET_ADDR(IP_RA_ION,RMSD_SCR(1+LI_NAT))
      CALL GET_ADDR(IP_RB_ION,RMSD_SCR(1+2*LI_NAT))
      CALL GET_ADDR(IP_DERR_A,RMSD_SCR(1+3*LI_NAT))
      CALL GET_ADDR(IP_DERR_B,RMSD_SCR(1+4*LI_NAT))
      CALL GET_ADDR(IP_R0_CM,RMSD_SCR(1+5*LI_NAT))
      CALL GET_ADDR(IP_R_CM,RMSD_SCR(1+6*LI_NAT))
#else
      CALL GET_ADDR(IP_R_ION,RMSD_SCR(1))
      CALL GET_ADDR(IP_RA_ION,RMSD_SCR(1+3*NAT_RMSD))
      CALL GET_ADDR(IP_RB_ION,RMSD_SCR(1+2*3*NAT_RMSD))
      CALL GET_ADDR(IP_DERR_A,RMSD_SCR(1+3*3*NAT_RMSD))
      CALL GET_ADDR(IP_DERR_B,RMSD_SCR(1+4*3*NAT_RMSD))
      CALL GET_ADDR(IP_R0_CM,RMSD_SCR(1+5*3*NAT_RMSD))
      CALL GET_ADDR(IP_R_CM,RMSD_SCR(1+6*3*NAT_RMSD))
#endif
!$OMP parallel do private(IAT)
      DO IAT = 1,NAT_RMSD
        R_ION(1,IAT)=TSCR(1,IPOS_RMSD(IAT))
        R_ION(2,IAT)=TSCR(2,IPOS_RMSD(IAT))
        R_ION(3,IAT)=TSCR(3,IPOS_RMSD(IAT))
        RA_ION(1,IAT)=POS_A(1,IPOS_RMSD(IAT),I_RMSD)
        RA_ION(2,IAT)=POS_A(2,IPOS_RMSD(IAT),I_RMSD)
        RA_ION(3,IAT)=POS_A(3,IPOS_RMSD(IAT),I_RMSD)
        RB_ION(1,IAT)=POS_B(1,IPOS_RMSD(IAT),I_RMSD)
        RB_ION(2,IAT)=POS_B(2,IPOS_RMSD(IAT),I_RMSD)
        RB_ION(3,IAT)=POS_B(3,IPOS_RMSD(IAT),I_RMSD)
      ENDDO

C      write(6,*) 'NAT_RMSD', NAT_RMSD
C     ==--------------------------------------------------------------==
C     Calculate RMSD_B and derivatives
      CALL VAL_RMSD(NAT_RMSD,R_ION,RB_ION,RMSD_B,DERR_B,R0_CM,R_CM)
C      write(6,*) 'B RMSD', RMSD_B

C     Calculate RMSD_A and derivatives
      CALL VAL_RMSD(NAT_RMSD,R_ION,RA_ION,RMSD_A,DERR_A,R0_CM,R_CM)
C      write(6,*) 'A RMSD', RMSD_A

C     ==--------------------------------------------------------------==
      RMSD_NUM = RMSD_A-RMSD_B
      RMSD_DEN = RMSD_A+RMSD_B
      IF(RMSD_DEN .LT. 1.D-10) RMSD_DEN = 1.D-10
      URMSD_DEN = 1.0D0/RMSD_DEN
      FVI = RMSD_NUM*URMSD_DEN
      FCI=FVI-CVAL

      DO IAT = 1,NAT_RMSD
        L1 = LSK(1,IPOS_RMSD(IAT))
        L2 = LSK(2,IPOS_RMSD(IAT))
        L3 = LSK(3,IPOS_RMSD(IAT))

        IF(L1.NE.0) AN(L1) = AN(L1) + URMSD_DEN *(
     &         DERR_A(1,IPOS_RMSD(IAT))-DERR_B(1,IPOS_RMSD(IAT)) -
     &        (DERR_A(1,IPOS_RMSD(IAT))+DERR_B(1,IPOS_RMSD(IAT)))*FVI)
        IF(L2.NE.0) AN(L2) = AN(L2) + URMSD_DEN *(
     &         DERR_A(2,IPOS_RMSD(IAT))-DERR_B(2,IPOS_RMSD(IAT)) -
     &        (DERR_A(2,IPOS_RMSD(IAT))+DERR_B(2,IPOS_RMSD(IAT)))*FVI)
        IF(L3.NE.0) AN(L3) = AN(L3) + URMSD_DEN *(
     &         DERR_A(3,IPOS_RMSD(IAT))-DERR_B(3,IPOS_RMSD(IAT)) -
     &        (DERR_A(3,IPOS_RMSD(IAT))+DERR_B(3,IPOS_RMSD(IAT)))*FVI)

      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VAL_RMSD(N,R,R0,RMSD,DERR,RP,R0P)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
C     Arguments
      integer      N
      real*8       R(3,N)  !posizioni
      real*8       R0(3,N) !struttura di riferimento
      real*8       RMSD    ! RMSD^2
      real*8       DERR(3,N) ! derivate di RMSD^2
      real*8       RP(3,N),R0P(3,N)
C     Local variables
      character*80 msg
      integer i,j,k,jobn,ier,ix,iret
      real*8  epsi,s,ww,dl_av(3),q(0:3),
     &        m(4,4),lambda(4),z(4,4),wk(20)
      real*8 rr0(3),rr(3),dm_r(4,4,3),rrsq
      real*8 xx,yy,zz
      data epsi /1.0d-10/
C     ==--------------------------------------------------------------==
C  center r

      xx=0.D0
      yy=0.D0
      zz=0.D0
!$OMP parallel do private(i) reduction(+:xx,yy,zz)
      DO i=1,n
        xx=xx+r(1,i)
        yy=yy+r(2,i)
        zz=zz+r(3,i)
      ENDDO
      xx=xx/dble(n)
      yy=yy/dble(n)
      zz=zz/dble(n)
!$OMP parallel do private(i) shared(xx,yy,zz)
      DO i=1,n
        rp(1,i)=r(1,i)-xx
        rp(2,i)=r(2,i)-yy
        rp(3,i)=r(3,i)-zz
      ENDDO
C  center r0
      xx=0.D0
      yy=0.D0
      zz=0.D0
!$OMP parallel do private(i) reduction(+:xx,yy,zz)
      DO i=1,n
        xx=xx+r0(1,i)
        yy=yy+r0(2,i)
        zz=zz+r0(3,i)
      ENDDO
      xx=xx/dble(n)
      yy=yy/dble(n)
      zz=zz/dble(n)
!$OMP parallel do private(i) shared(xx,yy,zz)
      DO i=1,n
        r0p(1,i)=r0(1,i)-xx
        r0p(2,i)=r0(2,i)-yy
        r0p(3,i)=r0(3,i)-zz
      ENDDO
C
      do i = 1,16
        m(i,1) = 0.d0
      enddo

      DO i = 1,n
        rr(1)=rp(1,i)
        rr(2)=rp(2,i)
        rr(3)=rp(3,i)
        rr0(1)=r0p(1,i)
        rr0(2)=r0p(2,i)
        rr0(3)=r0p(3,i)
        rrsq=(rr0(1)**2+rr0(2)**2+rr0(3)**2+rr(1)**2+rr(2)**2+rr(3)**2)

        m(1,1)=m(1,1) +
     &         rrsq+2.d0*(-rr0(1)*rr(1)-rr0(2)*rr(2)-rr0(3)*rr(3))
        m(2,2)=m(2,2) +
     &         rrsq+2.d0*(-rr0(1)*rr(1)+rr0(2)*rr(2)+rr0(3)*rr(3))
        m(3,3)=m(3,3) +
     &         rrsq+2.d0*(+rr0(1)*rr(1)-rr0(2)*rr(2)+rr0(3)*rr(3))
        m(4,4)=m(4,4) +
     &         rrsq+2.d0*(+rr0(1)*rr(1)+rr0(2)*rr(2)-rr0(3)*rr(3))
        m(1,2)=m(1,2) +2.d0*(-rr0(2)*rr(3)+rr0(3)*rr(2))
        m(1,3)=m(1,3) +2.d0*(rr0(1)*rr(3)-rr0(3)*rr(1))
        m(1,4)=m(1,4) +2.d0*(-rr0(1)*rr(2)+rr0(2)*rr(1))
        m(2,3)=m(2,3) -2.d0*(rr0(1)*rr(2)+rr0(2)*rr(1))
        m(2,4)=m(2,4) -2.d0*(rr0(1)*rr(3)+rr0(3)*rr(1))
        m(3,4)=m(3,4) -2.d0*(rr0(2)*rr(3)+rr0(3)*rr(2))
      ENDDO
      m(2,1) = m(1,2)
      m(3,1) = m(1,3)
      m(3,2) = m(2,3)
      m(4,1) = m(1,4)
      m(4,2) = m(2,4)
      m(4,3) = m(3,4)

*---- SOLVE THE EIGENVECTOR PROBLEM FOR M: --------------------------*

      iret = 0
C     jobn   = 12
C     call EIGRS(m,4,jobn,lambda,z,4,wk,ier)
      ier=0
      CALL DCOPY(16,m,1,z,1)
      CALL DSYEV('V','U',4,z,4,lambda,wk,20,ier)
      if (ier .ne. 0) then
        CALL STOPGM('VAL_RMSD',' Fatal error in DSYEV')
      endif
      if (wk(1) .gt. 1.d0) then
        iret = 9
      endif
      
*---- PICK THE CORRECT EIGENVECTOR(S): ------------------------------*

      s =  1.d0
      if (z(1,1) .lt. 0.d0) s = -1.d0
      q(0) = s*z(1,1)
      q(1) = s*z(2,1)
      q(2) = s*z(3,1)
      q(3) = s*z(4,1)
      if (dabs(lambda(1)) .lt. epsi) then
        RMSD = 0.d0
      else
        RMSD = lambda(1)/dble(n)
      endif

      if (dabs(lambda(1) - lambda(2)) .lt. epsi)iret = iret + 10

      if (iret.eq.0) then
        msg = ' RMSD: Normal exe., unique solution'
      endif
      if (iret.eq.10) then
        msg = ' RMSD: Normal exe., non-unique solution'
      endif
      if (iret.eq.9) then
        msg = ' RMSD: Bad perform., unique solution'
      endif
      if (iret.eq.19) then
       msg = ' RMSD: Bad perform., non-unique solution'
      endif
      if(iret.ne.0) then
      !  write(6,*)msg
      endif

*---- DERIVATIVES OF RMSD with respect to the positions
      do i = 1,n

        rr(1)=  2.D0*rp(1,i)
        rr(2)=  2.D0*rp(2,i)
        rr(3)=  2.D0*rp(3,i)
        rr0(1)= 2.D0*r0p(1,i)
        rr0(2)= 2.D0*r0p(2,i)
        rr0(3)= 2.D0*r0p(3,i)
C
        dm_r (1,1,1)=(rr(1)-rr0(1))
        dm_r (1,1,2)=(rr(2)-rr0(2))
        dm_r (1,1,3)=(rr(3)-rr0(3))
C  
        dm_r (1,2,1)=0.D0
        dm_r (1,2,2)= rr0(3)
        dm_r (1,2,3)=-rr0(2)
C
        dm_r (1,3,1)=-rr0(3)
        dm_r (1,3,2)= 0.D0
        dm_r (1,3,3)= rr0(1)
C
        dm_r (1,4,1)= rr0(2)
        dm_r (1,4,2)=-rr0(1)
        dm_r (1,4,3)= 0.D0
C
        dm_r (2,2,1)=(rr(1)-rr0(1))
        dm_r (2,2,2)=(rr(2)+rr0(2))
        dm_r (2,2,3)=(rr(3)+rr0(3))
C
        dm_r (2,3,1)=-rr0(2)
        dm_r (2,3,2)=-rr0(1)
        dm_r (2,3,3)= 0.D0
C
        dm_r (2,4,1)=-rr0(3)
        dm_r (2,4,2)= 0.D0
        dm_r (2,4,3)=-rr0(1)
C
        dm_r (3,3,1)=(rr(1)+rr0(1))
        dm_r (3,3,2)=(rr(2)-rr0(2))
        dm_r (3,3,3)=(rr(3)+rr0(3))
C  
        dm_r (3,4,1)=0.D0
        dm_r (3,4,2)=-rr0(3)
        dm_r (3,4,3)=-rr0(2)
C
        dm_r (4,4,1)=(rr(1)+rr0(1))
        dm_r (4,4,2)=(rr(2)+rr0(2))
        dm_r (4,4,3)=(rr(3)-rr0(3))
C
        do ix=1,3
          dm_r(2,1,ix)=dm_r(1,2,ix)
          dm_r(3,1,ix)=dm_r(1,3,ix)
          dm_r(4,1,ix)=dm_r(1,4,ix)
          dm_r(3,2,ix)=dm_r(2,3,ix)
          dm_r(4,2,ix)=dm_r(2,4,ix)
          dm_r(4,3,ix)=dm_r(3,4,ix)
        enddo
C
        do ix=1,3
          derr(ix,i)=0.D0
          do k=1,4
            do j=1,4
              derr(ix,i)=derr(ix,i)+q(k-1)*q(j-1)*dm_r(j,k,ix)
            enddo
          enddo
          derr(ix,i)=derr(ix,i)/dble(n)
        enddo
      enddo
C     ==--------------------------------------------------------------==
      return
      end
C     ==================================================================
      SUBROUTINE HYD_PRESENCE(ISP1,ISP2,NEXP,MEXP,C1_RC,L,TSCR,AN,LSK,
     &                        CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C     Arguments
      INTEGER ISP1,ISP2,NEXP(3),MEXP(3),LSK(3,NAT)
      REAL*8  TSCR(3,*),AN(NODIM),CVAL,C1_RC(3),L
C     Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,RNUM,RDEN,FNUM,FDEN,XX(3)
      REAL*8  DER_FACT,EXP_FACT
      INTEGER IAT,IA,IIAT1,IIAT2,K,L1,L2,L3,IS
      INTEGER II,IINI1,IEND1,IINI2,IEND2

      REAL*8  nH,nO,f_nH,f_nO,der_nH_dr(3,*),der_nO_dr(3,*)
      REAL*8  der_f_nH_dn, der_f_nO_dn
      POINTER (IP_der_nH_dr,der_nH_dr),(IP_der_nO_dr,der_nO_dr)

      INTEGER I,ID
      REAL*8  CVAL_1,CVAL_2,EPS
C     ==--------------------------------------------------------------==

      CVAL = 0.0D0

      CALL MEMORY(IP_der_nH_dr,3*NA(ISP2),'der_nH_dr')
      CALL MEMORY(IP_der_nO_dr,3*NA(ISP1),'der_nH_dr')
      CALL AZZERO(AN,NODIM)
C      Atoms indexes
      IINI1 = 1
      DO IS = 1,ISP1-1
        IINI1=IINI1+NA(IS)
      ENDDO
      IEND1 = IINI1 + NA(ISP1) -1
      IINI2 = 1
      DO IS = 1,ISP2-1
        IINI2=IINI2+NA(IS)
      ENDDO
      IEND2 = IINI2 + NA(ISP2) -1

C      First Loop on the oxygens
      DO IA=IINI1,IEND1
C       DO IA=94,94
        nH=0.0D0
        nO=0.0D0
        f_nH=0.0D0
        CALL AZZERO(der_nH_dr,3*NA(ISP2))
        CALL AZZERO(der_nO_dr,3*NA(ISP1))
        der_f_nH_dn =0.0D0
        IF(IA.LE.NAT) THEN
          L1 = LSK(1,IA)
          L2 = LSK(2,IA)
          L3 = LSK(3,IA)
        ENDIF
        CALL FILLC(IA,TSCR,XX)
        X0 = XX(1)
        Y0 = XX(2)
        Z0 = XX(3)

C        Loop over the hydrogens
        II = 0
        DO IIAT2=IINI2,IEND2
          II = II + 1
          DX=TSCR(1,IIAT2)-X0
          DY=TSCR(2,IIAT2)-Y0
          DZ=TSCR(3,IIAT2)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3)
     &         CALL STOPGM('HYD_PRESENCE','H/O position overlap')
C   compute nH
          RNUM = (DD/C1_RC(1))**NEXP(1)
          RDEN = (DD/C1_RC(1))**(NEXP(1)+MEXP(1))
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nH= nH + FNUM/FDEN
C           write(6,*) 'H ', IIAT2, DD, FNUM/FDEN
C   compute der_nH_dr  index dependent
          FF = -(RNUM*DBLE(NEXP(1))
     &            -FNUM*RDEN*DBLE(NEXP(1)+MEXP(1))/FDEN)/
     &            (FDEN*DD*DD)
          der_nH_dr(1,II) = FF*DX
          der_nH_dr(2,II) = FF*DY
          der_nH_dr(3,II) = FF*DZ


        ENDDO     ! Loop on the hydrogens


C   compute f_nH
        RNUM = (nH/C1_RC(3))**NEXP(3)
        RDEN = (nH/C1_RC(3))**(NEXP(3)+MEXP(3))
        FNUM = 1-RNUM
        FDEN = 1-RDEN
        IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
        f_nH= 1.0D0 - FNUM/FDEN

C   compute der_f_nH_dn
        der_f_nH_dn = (DBLE(NEXP(3))*RNUM-
     &          DBLE(NEXP(3)+MEXP(3))*FNUM*RDEN/FDEN)/(FDEN*nH)

        II = 0
C        Second Loop over the oxygens
        DO IIAT1 = IINI1,IEND1
          II = II + 1
          DX=TSCR(1,IIAT1)-X0
          DY=TSCR(2,IIAT1)-Y0
          DZ=TSCR(3,IIAT1)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3) GOTO 10
C   compute nO
          RNUM = (DD/C1_RC(2))**NEXP(2)
          RDEN = (DD/C1_RC(2))**(NEXP(2)+MEXP(2))
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nO= nO + FNUM/FDEN
  
C   compute der_nO_dr  
          FF = -(RNUM*DBLE(NEXP(2))
     &            -FNUM*RDEN*DBLE(NEXP(2)+MEXP(2))/FDEN)/
     &            (FDEN*DD*DD)
          der_nO_dr(1,II) = FF*DX
          der_nO_dr(2,II) = FF*DY
          der_nO_dr(3,II) = FF*DZ
10        CONTINUE
        ENDDO   ! Second Loop over the oxygens

C   compute f_nO
        RNUM = (nO/C1_RC(3))**NEXP(3)
        RDEN = (nO/C1_RC(3))**(NEXP(3)+MEXP(3))
        FNUM = 1-RNUM
        FDEN = 1-RDEN
        IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
        f_nO= 1.0D0 - FNUM/FDEN


C   compute der_f_nO_dn
        der_f_nO_dn = (DBLE(NEXP(3))*RNUM-
     &          DBLE(NEXP(3)+MEXP(3))*FNUM*RDEN/FDEN)/(FDEN*nO)

C   exponential factor exp{L*f_nH*f_nO}
        exp_fact = dexp(L* f_nH * f_nO)
        DER_FACT = L*exp_fact*f_nH*der_f_nO_dn


        II = 0
        DO IIAT1 = IINI1,IEND1
          II = II + 1
C   Derivatives:
          IF(LSK(1,IIAT1).NE.0) THEN
            K=LSK(1,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_nO_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT1).NE.0) THEN
            K=LSK(2,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_nO_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT1).NE.0) THEN
            K=LSK(3,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_nO_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT*der_nO_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT*der_nO_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT*der_nO_dr(3,II)

        ENDDO


        DER_FACT = L*exp_fact*der_f_nH_dn*f_nO
        II = 0
C        Loop over the hydrogens for the derivatives
        DO IIAT2=IINI2,IEND2
          II = II + 1
          IF(LSK(1,IIAT2).NE.0) THEN
            K=LSK(1,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT2).NE.0) THEN
            K=LSK(2,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT2).NE.0) THEN
            K=LSK(3,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT*der_nH_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT*der_nH_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT*der_nH_dr(3,II)
        ENDDO
C     sum over the oxygens
        CVAL = CVAL + exp_fact
      ENDDO    ! Loop over the oxygens

      FF = 1.0D0/(L*CVAL)

      CVAL = 1.0D0/L*dlog(CVAL)


C     Final factor for the derivatives
      DO IAT = 1,NODIM
        AN(IAT) = AN(IAT)*FF
      ENDDO

      CALL FREEM(IP_der_nH_dr)
      CALL FREEM(IP_der_nO_dr)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
      SUBROUTINE HYD2_PRESENCE(ISP1,ISP2,NEXP,MEXP,C1_RC,L,TSCR,AN,LSK,
     &                        CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C     Arguments
      INTEGER ISP1,ISP2,NEXP(3),MEXP(3),LSK(3,NAT)
      REAL*8  TSCR(3,*),AN(NODIM),CVAL,C1_RC(3),L
C     Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,RNUM,RDEN,FNUM,FDEN,XX(3)
      REAL*8  DER_FACT,EXP_FACT
      INTEGER IAT,IA,IIAT1,IIAT2,K,L1,L2,L3,IS
      INTEGER II,IINI1,IEND1,IINI2,IEND2

      REAL*8  nH,nO,f_nH,f_nO,der_nH_dr(3,*),der_nO_dr(3,*)
      REAL*8  der_f_nH_dn, der_f_nO_dn
      POINTER (IP_der_nH_dr,der_nH_dr),(IP_der_nO_dr,der_nO_dr)

      INTEGER I,ID
      REAL*8  CVAL_1,CVAL_2,EPS
C     ==--------------------------------------------------------------==

      CVAL = 0.0D0

      CALL MEMORY(IP_der_nH_dr,3*NA(ISP2),'der_nH_dr')
      CALL MEMORY(IP_der_nO_dr,3*NA(ISP1),'der_nH_dr')
      CALL AZZERO(AN,NODIM)
C      Atoms indexes
      IINI1 = 1
      DO IS = 1,ISP1-1
        IINI1=IINI1+NA(IS)
      ENDDO
      IEND1 = IINI1 + NA(ISP1) -1
      IINI2 = 1
      DO IS = 1,ISP2-1
        IINI2=IINI2+NA(IS)
      ENDDO
      IEND2 = IINI2 + NA(ISP2) -1

C      First Loop on the oxygens
      DO IA=IINI1,IEND1
        nH=0.0D0
        nO=0.0D0
        f_nH=0.0D0
        CALL AZZERO(der_nH_dr,3*NA(ISP2))
        CALL AZZERO(der_nO_dr,3*NA(ISP1))
        der_f_nH_dn =0.0D0
        IF(IA.LE.NAT) THEN
          L1 = LSK(1,IA)
          L2 = LSK(2,IA)
          L3 = LSK(3,IA)
        ENDIF
        CALL FILLC(IA,TSCR,XX)
        X0 = XX(1)
        Y0 = XX(2)
        Z0 = XX(3)

C        Loop over the hydrogens
        II = 0
        DO IIAT2=IINI2,IEND2
          II = II + 1
          DX=TSCR(1,IIAT2)-X0
          DY=TSCR(2,IIAT2)-Y0
          DZ=TSCR(3,IIAT2)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3)
     &         CALL STOPGM('HYD2_PRESENCE','H/O position overlap')
C   compute nH
          RNUM = (DD/C1_RC(1))**NEXP(1)
          RDEN = (DD/C1_RC(1))**(NEXP(1)+MEXP(1))
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nH= nH + FNUM/FDEN
C           write(6,*) 'H ', IIAT2, DD, FNUM/FDEN
C   compute der_nH_dr  index dependent
          FF = -(RNUM*DBLE(NEXP(1))
     &            -FNUM*RDEN*DBLE(NEXP(1)+MEXP(1))/FDEN)/
     &            (FDEN*DD*DD)
          der_nH_dr(1,II) = FF*DX
          der_nH_dr(2,II) = FF*DY
          der_nH_dr(3,II) = FF*DZ


        ENDDO     ! Loop on the hydrogens


C   compute f_nH
        RNUM = (nH/C1_RC(3))**NEXP(3)
        RDEN = (nH/C1_RC(3))**(NEXP(3)+MEXP(3))
        FNUM = 1-RNUM
        FDEN = 1-RDEN
        IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
        f_nH= 1.0D0 - FNUM/FDEN

C   compute der_f_nH_dn
        der_f_nH_dn = (DBLE(NEXP(3))*RNUM-
     &          DBLE(NEXP(3)+MEXP(3))*FNUM*RDEN/FDEN)/(FDEN*nH)

        II = 0
C        Second Loop over the oxygens 
        DO IIAT1 = IINI1,IEND1
          II = II + 1
          DX=TSCR(1,IIAT1)-X0
          DY=TSCR(2,IIAT1)-Y0
          DZ=TSCR(3,IIAT1)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3) GOTO 10
C   compute nO
          RNUM = (DD/C1_RC(2))**NEXP(2)
          RDEN = (DD/C1_RC(2))**(NEXP(2)+MEXP(2))
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nO= nO + FNUM/FDEN
  
C   compute der_nO_dr  
          FF = -(RNUM*DBLE(NEXP(2))
     &            -FNUM*RDEN*DBLE(NEXP(2)+MEXP(2))/FDEN)/
     &            (FDEN*DD*DD)
          der_nO_dr(1,II) = FF*DX
          der_nO_dr(2,II) = FF*DY
          der_nO_dr(3,II) = FF*DZ
10        CONTINUE
        ENDDO   ! Second Loop over the oxygens 

C   compute f_nO
        RNUM = (nO/C1_RC(3))**NEXP(3)
        RDEN = (nO/C1_RC(3))**(NEXP(3)+MEXP(3))
        FNUM = 1-RNUM
        FDEN = 1-RDEN
        IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
        f_nO= 1.0D0 - FNUM/FDEN


C   compute der_f_nO_dn
        der_f_nO_dn = (DBLE(NEXP(3))*RNUM-
     &          DBLE(NEXP(3)+MEXP(3))*FNUM*RDEN/FDEN)/(FDEN*nO)

C   exponential factor exp{L*f_nH * nO}
        exp_fact = dexp(L* f_nH * nO)
        DER_FACT = L*exp_fact*f_nH

        II = 0
        DO IIAT1 = IINI1,IEND1
          II = II + 1
C   Derivatives:
          IF(LSK(1,IIAT1).NE.0) THEN
            K=LSK(1,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_nO_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT1).NE.0) THEN
            K=LSK(2,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_nO_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT1).NE.0) THEN
            K=LSK(3,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_nO_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT*der_nO_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT*der_nO_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT*der_nO_dr(3,II)

        ENDDO


        DER_FACT = L*exp_fact*der_f_nH_dn*nO
        II = 0
C        Loop over the hydrogens for the derivatives
        DO IIAT2=IINI2,IEND2
          II = II + 1
          IF(LSK(1,IIAT2).NE.0) THEN
            K=LSK(1,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT2).NE.0) THEN
            K=LSK(2,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT2).NE.0) THEN
            K=LSK(3,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT*der_nH_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT*der_nH_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT*der_nH_dr(3,II)
        ENDDO
C     sum over the oxygens
        CVAL = CVAL + exp_fact
      ENDDO    ! Loop over the oxygens

      FF = 1.0D0/(L*CVAL)

      CVAL = 1.0D0/L*dlog(CVAL)


C     Final factor for the derivatives
      DO IAT = 1,NODIM
        AN(IAT) = AN(IAT)*FF
      ENDDO

      CALL FREEM(IP_der_nH_dr)
      CALL FREEM(IP_der_nO_dr)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HYD2_ION_DISTANCE(ISP1,ISP2,INDION,NEXP,MEXP,C1_RC,L,
     &                             TSCR,AN,LSK,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C      Arguments
      INTEGER ISP1,ISP2,INDION,NEXP(3),MEXP(3),LSK(3,NAT)
      REAL*8  TSCR(3,*),AN(NODIM),CVAL,C1_RC(3),L
C      Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,RNUM,RDEN,FNUM,FDEN,XX(3)
!jpark  
      REAL*8  XX0(3),XION,YION,ZION,DX2,DY2,DZ2,DD2
      REAL*8  ANF0(NODIM),ANF1(NODIM)

      REAL*8  DER_FACT,DER_FACT2,EXP_FACT
      INTEGER IAT,IA,IIAT1,IIAT2,K,L1,L2,L3,IS
      INTEGER II,IINI1,IEND1,IINI2,IEND2

      REAL*8  nH,der_nH_dr(3,*)
!jpark
      REAL*8  r_k,sum_exp_fact,sum_r_exp_fact,der_r_k_dr(3)
      INTEGER L11, L22, L33

      POINTER (IP_der_nH_dr,der_nH_dr),(IP_ANF0,ANF0),(IP_ANF1,ANF1)

      INTEGER I,ID
      REAL*8  CVAL_1,CVAL_2,EPS
C     ==--------------------------------------------------------------==


      CVAL = 0.0D0
      sum_exp_fact = 0.0D0
      sum_r_exp_fact = 0.0D0

      CALL MEMORY(IP_der_nH_dr,3*NA(ISP2),'der_nH_dr')
      CALL AZZERO(der_nH_dr,3*NA(ISP2))

      CALL MEMORY(IP_ANF1,NODIM,'ANF1')
      CALL AZZERO(AN,NODIM)
!jpark 

      CALL AZZERO(ANF1,NODIM)
C      Atoms indexes
      IINI1 = 1
      DO IS = 1,ISP1-1
        IINI1=IINI1+NA(IS)
      ENDDO
      IEND1 = IINI1 + NA(ISP1) -1
      IINI2 = 1
      DO IS = 1,ISP2-1
        IINI2=IINI2+NA(IS)
      ENDDO
      IEND2 = IINI2 + NA(ISP2) -1

!jpark     SET ION POSITION 
      CALL FILLC(INDION,TSCR,XX0)
      XION = XX0(1)
      YION = XX0(2)
      ZION = XX0(3)

      L11 = LSK(1,INDION)
      L22 = LSK(2,INDION)
      L33 = LSK(3,INDION)


C      First Loop on the oxygens
      DO IA=IINI1,IEND1
        IF(IA .EQ. INDION) GOTO 100
        nH=0.0D0
        CALL AZZERO(der_nH_dr,3*NA(ISP2))
        IF(IA.LE.NAT) THEN
          L1 = LSK(1,IA)
          L2 = LSK(2,IA)
          L3 = LSK(3,IA)
        ENDIF
        CALL FILLC(IA,TSCR,XX)
        X0 = XX(1)
        Y0 = XX(2)
        Z0 = XX(3)

C        Loop over the hydrogens
        II = 0
        DO IIAT2=IINI2,IEND2
          II = II + 1
          DX=TSCR(1,IIAT2)-X0
          DY=TSCR(2,IIAT2)-Y0
          DZ=TSCR(3,IIAT2)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3)
     &         CALL STOPGM('HYD2_ION_DISTANCE','H/O position overlap')
C   compute nH
          RNUM = (DD/C1_RC(1))**NEXP(1)
          RDEN = (DD/C1_RC(1))**(NEXP(1)+MEXP(1))
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nH= nH + FNUM/FDEN

C   compute der_nH_dr  index dependent
          FF = -(RNUM*DBLE(NEXP(1))
     &            -FNUM*RDEN*DBLE(NEXP(1)+MEXP(1))/FDEN)/
     &            (FDEN*DD*DD)
          der_nH_dr(1,II) = FF*DX
          der_nH_dr(2,II) = FF*DY
          der_nH_dr(3,II) = FF*DZ

        ENDDO     ! Loop on the hydrogens

!jpark  compute r_k 
        DX2 = X0-XION
        DY2 = Y0-YION
        DZ2 = Z0-ZION
        IF (.NOT. TISOS) CALL PBC(DX2,DY2,DZ2,DX2,DY2,DZ2,1,APBC,IBRAV)
        r_k = DSQRT(DX2*DX2+DY2*DY2+DZ2*DZ2)


!jpark compute der_r_k_dr with respect to Ok
        der_r_k_dr(1) = DX2/r_k
        der_r_k_dr(2) = DY2/r_k
        der_r_k_dr(3) = DZ2/r_k

!exponential factor exp{L*nH}
        exp_fact = dexp(L*nH)

!jpark  for summation of expnential factor
        sum_exp_fact   = sum_exp_fact + exp_fact
        sum_r_exp_fact = sum_r_exp_fact + r_k*exp_fact

!dbg
C        write(6,'(A,I3,2(A,f10.5))') ' ox ' , IA, ' nh ',nH,
C      c                                 ' r_k ',  r_k
!dbg


!dbg
C        write(6,'(2(A,1E15.6))') ' r exp ' , r_k*exp_fact ,
C      c                  ' exp ',exp_fact
!dbg



C   Derivatives:
        DER_FACT = L*r_k*exp_fact
        DER_FACT2 = L*exp_fact
        II = 0
C        Loop over the hydrogens for the derivatives
        DO IIAT2=IINI2,IEND2
          II = II + 1
          IF(LSK(1,IIAT2).NE.0) THEN
            K=LSK(1,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(1,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_nH_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT2).NE.0) THEN
            K=LSK(2,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(2,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_nH_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT2).NE.0) THEN
            K=LSK(3,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(3,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_nH_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT*der_nH_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT*der_nH_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT*der_nH_dr(3,II)
          IF(L1.NE.0) ANF1(L1)=ANF1(L1)-DER_FACT2*der_nH_dr(1,II)
          IF(L2.NE.0) ANF1(L2)=ANF1(L2)-DER_FACT2*der_nH_dr(2,II)
          IF(L3.NE.0) ANF1(L3)=ANF1(L3)-DER_FACT2*der_nH_dr(3,II)
        ENDDO

C     compute term1 der_r_k_dr * exp_fact
        IF(L1.NE.0) AN(L1)=AN(L1)+der_r_k_dr(1)*exp_fact
        IF(L2.NE.0) AN(L2)=AN(L2)+der_r_k_dr(2)*exp_fact
        IF(L3.NE.0) AN(L3)=AN(L3)+der_r_k_dr(3)*exp_fact
        IF(L11.NE.0) AN(L11)=AN(L11)-der_r_k_dr(1)*exp_fact
        IF(L22.NE.0) AN(L22)=AN(L22)-der_r_k_dr(2)*exp_fact
        IF(L33.NE.0) AN(L33)=AN(L33)-der_r_k_dr(3)*exp_fact

 100    CONTINUE
C       write(6,*) 'O_k r_k nH e(nH)', IA, r_k, nH, exp_fact

      ENDDO    ! Loop over the oxygens

      CVAL = sum_r_exp_fact/sum_exp_fact

C     compute term2 r_k*ANF0
!$OMP parallel do private(II) shared(CVAL)
      DO II = 1,NODIM
        ANF1(II) = ANF1(II)*CVAL
      ENDDO

C       write(6,*) 'HY_VAL ',CVAL
      DER_FACT = 1.0D0/sum_exp_fact
C     Final factor for the derivatives
!$OMP parallel do private(IAT)
      DO IAT = 1,NODIM
        AN(IAT) = (AN(IAT) - ANF1(IAT))*DER_FACT
      ENDDO
C        stop
      CALL FREEM(IP_der_nH_dr)
      CALL FREEM(IP_ANF1)
C     ==---------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HYD_ION_DISTANCE(ISP1,ISP2,INDION,NEXP,MEXP,C1_RC,L,
     &                             TSCR,AN,LSK,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C      Arguments
      INTEGER ISP1,ISP2,INDION,NEXP(3),MEXP(3),LSK(3,NAT)
      REAL*8  TSCR(3,*),AN(NODIM),CVAL,C1_RC(3),L
C      Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,RNUM,RDEN,FNUM,FDEN,XX(3)
!jpark  
      REAL*8  XX0(3),XION,YION,ZION,DX2,DY2,DZ2,DD2
      REAL*8  ANF0(NODIM),ANF1(NODIM)

      REAL*8  DER_FACT,DER_FACT2,EXP_FACT
      INTEGER IAT,IA,IIAT1,IIAT2,K,L1,L2,L3,IS
      INTEGER II,IINI1,IEND1,IINI2,IEND2

      REAL*8  nH,der_nH_dr(3,*),nO,der_nO_dr(3,*)
!jpark
      REAL*8  r_k,sum_exp_fact,sum_r_exp_fact,der_r_k_dr(3)
      INTEGER L11, L22, L33

      POINTER (IP_der_nH_dr,der_nH_dr),(IP_ANF0,ANF0),(IP_ANF1,ANF1)
      POINTER (IP_der_nO_dr,der_nO_dr)

      INTEGER I,ID
      REAL*8  CVAL_1,CVAL_2,EPS
C     ==--------------------------------------------------------------==

      CVAL = 0.0D0
      sum_exp_fact = 0.0D0
      sum_r_exp_fact = 0.0D0

      CALL MEMORY(IP_der_nH_dr,3*NA(ISP2),'der_nH_dr')
      CALL AZZERO(der_nH_dr,3*NA(ISP2))
      CALL MEMORY(IP_der_nO_dr,3*NA(ISP1),'der_nO_dr')
      CALL AZZERO(der_nO_dr,3*NA(ISP1))

      CALL MEMORY(IP_ANF1,NODIM,'ANF1')
      CALL AZZERO(AN,NODIM)
!jpark

      CALL AZZERO(ANF1,NODIM)
C      Atoms indexes
      IINI1 = 1
      DO IS = 1,ISP1-1
        IINI1=IINI1+NA(IS)
      ENDDO
      IEND1 = IINI1 + NA(ISP1) -1
      IINI2 = 1
      DO IS = 1,ISP2-1
        IINI2=IINI2+NA(IS)
      ENDDO
      IEND2 = IINI2 + NA(ISP2) -1

!jpark     SET ION POSITION
      CALL FILLC(INDION,TSCR,XX0)
      XION = XX0(1)
      YION = XX0(2)
      ZION = XX0(3)

      L11 = LSK(1,INDION)
      L22 = LSK(2,INDION)
      L33 = LSK(3,INDION)


C      First Loop on the oxygens
      DO IA=IINI1,IEND1

        IF(IA .EQ. INDION) GOTO 100
        nH=0.0D0
        nO=0.0D0
        CALL AZZERO(der_nH_dr,3*NA(ISP2))
        IF(IA.LE.NAT) THEN
          L1 = LSK(1,IA)
          L2 = LSK(2,IA)
          L3 = LSK(3,IA)
        ENDIF
        CALL FILLC(IA,TSCR,XX)
        X0 = XX(1)
        Y0 = XX(2)
        Z0 = XX(3)

C        Loop over the hydrogens
        II = 0
        DO IIAT2=IINI2,IEND2
          II = II + 1
          DX=TSCR(1,IIAT2)-X0
          DY=TSCR(2,IIAT2)-Y0
          DZ=TSCR(3,IIAT2)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3)
     &         CALL STOPGM('HYD_PRESENCE','H/O position overlap')
C   compute nH
          RNUM = (DD/C1_RC(1))**NEXP(1)
          RDEN = (DD/C1_RC(1))**(NEXP(1)+MEXP(1))
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nH= nH + FNUM/FDEN

C   compute der_nH_dr  index dependent
          FF = -(RNUM*DBLE(NEXP(1))
     &            -FNUM*RDEN*DBLE(NEXP(1)+MEXP(1))/FDEN)/
     &            (FDEN*DD*DD)
          der_nH_dr(1,II) = FF*DX
          der_nH_dr(2,II) = FF*DY
          der_nH_dr(3,II) = FF*DZ

        ENDDO     ! Loop on the hydrogens

!jpark  compute r_k
        DX2 = X0-XION
        DY2 = Y0-YION
        DZ2 = Z0-ZION
        IF (.NOT. TISOS) CALL PBC(DX2,DY2,DZ2,DX2,DY2,DZ2,1,APBC,IBRAV)
        r_k = DSQRT(DX2*DX2+DY2*DY2+DZ2*DZ2)


!jpark compute der_r_k_dr with respect to Ok
        der_r_k_dr(1) = DX2/r_k
        der_r_k_dr(2) = DY2/r_k
        der_r_k_dr(3) = DZ2/r_k

        II = 0
C        Second Loop over the oxygens
        DO IIAT1 = IINI1,IEND1
          II = II + 1
          DX=TSCR(1,IIAT1)-X0
          DY=TSCR(2,IIAT1)-Y0
          DZ=TSCR(3,IIAT1)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3) GOTO 10
C   compute nO
          RNUM = (DD/C1_RC(2))**NEXP(2)
          RDEN = (DD/C1_RC(2))**(NEXP(2)+MEXP(2))
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nO= nO + FNUM/FDEN
  
C   compute der_nO_dr  
          FF = -(RNUM*DBLE(NEXP(2))
     &            -FNUM*RDEN*DBLE(NEXP(2)+MEXP(2))/FDEN)/
     &            (FDEN*DD*DD)
          der_nO_dr(1,II) = FF*DX
          der_nO_dr(2,II) = FF*DY
          der_nO_dr(3,II) = FF*DZ
 10       CONTINUE
        ENDDO   ! Second Loop over the oxygens 

!dbg
C        write(6,'(A,I3,3(A,f10.5))') ' ox ' , IA, ' nh ',nH,
C      c                               ' nO ', nO, '   r_k ',  r_k
!dbg


!exponential factor exp{L*nH}

        exp_fact = dexp(L*nH*nO)

!jpark  for summation of expnential factor
        sum_exp_fact   = sum_exp_fact + exp_fact
        sum_r_exp_fact = sum_r_exp_fact + r_k*exp_fact

!dbg
C        write(6,'(2(A,1E15.6))') ' r exp ' , r_k*exp_fact ,
C      c                  ' exp ',exp_fact
!dbg

C   Derivatives:
        DER_FACT = L*r_k*exp_fact*nH
        DER_FACT2 = L*exp_fact*nH
        II = 0
C        Loop over the hydrogens for the derivatives
        DO IIAT1=IINI1,IEND1
          II = II + 1
          IF(LSK(1,IIAT1).NE.0) THEN
            K=LSK(1,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_no_dr(1,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_no_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT1).NE.0) THEN
            K=LSK(2,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_no_dr(2,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_no_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT1).NE.0) THEN
            K=LSK(3,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_no_dr(3,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_no_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT*der_no_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT*der_no_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT*der_no_dr(3,II)
          IF(L1.NE.0) ANF1(L1)=ANF1(L1)-DER_FACT2*der_no_dr(1,II)
          IF(L2.NE.0) ANF1(L2)=ANF1(L2)-DER_FACT2*der_no_dr(2,II)
          IF(L3.NE.0) ANF1(L3)=ANF1(L3)-DER_FACT2*der_no_dr(3,II)
        ENDDO


C   Derivatives:
        DER_FACT = L*r_k*exp_fact*nO
        DER_FACT2 = L*exp_fact*nO
        II = 0
C        Loop over the hydrogens for the derivatives
        DO IIAT2=IINI2,IEND2
          II = II + 1
          IF(LSK(1,IIAT2).NE.0) THEN
            K=LSK(1,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(1,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_nH_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT2).NE.0) THEN
            K=LSK(2,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(2,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_nH_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT2).NE.0) THEN
            K=LSK(3,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(3,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_nH_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT*der_nH_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT*der_nH_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT*der_nH_dr(3,II)
          IF(L1.NE.0) ANF1(L1)=ANF1(L1)-DER_FACT2*der_nH_dr(1,II)
          IF(L2.NE.0) ANF1(L2)=ANF1(L2)-DER_FACT2*der_nH_dr(2,II)
          IF(L3.NE.0) ANF1(L3)=ANF1(L3)-DER_FACT2*der_nH_dr(3,II)
        ENDDO

C     compute term1 der_r_k_dr * exp_fact
        IF(L1.NE.0) AN(L1)=AN(L1)+der_r_k_dr(1)*exp_fact
        IF(L2.NE.0) AN(L2)=AN(L2)+der_r_k_dr(2)*exp_fact
        IF(L3.NE.0) AN(L3)=AN(L3)+der_r_k_dr(3)*exp_fact
        IF(L11.NE.0) AN(L11)=AN(L11)-der_r_k_dr(1)*exp_fact
        IF(L22.NE.0) AN(L22)=AN(L22)-der_r_k_dr(2)*exp_fact
        IF(L33.NE.0) AN(L33)=AN(L33)-der_r_k_dr(3)*exp_fact

 100    CONTINUE
C       write(6,*) 'O_k r_k nH e(nH)', IA, r_k, nH, exp_fact  
      ENDDO    ! Loop over the oxygens

      CVAL = sum_r_exp_fact/sum_exp_fact

C        write(6,'((A,f15.6))') ' final cv ' , cval
C        stop
!dbg

C     compute term2 r_k*ANF0
!$OMP parallel do private(II) shared(CVAL)
      DO II = 1,NODIM
        ANF1(II) = ANF1(II)*CVAL
      ENDDO

C       write(6,*) 'HY_VAL ',CVAL
      DER_FACT = 1.0D0/sum_exp_fact
C     Final factor for the derivatives
!$OMP parallel do private(IAT)
      DO IAT = 1,NODIM
        AN(IAT) = (AN(IAT) - ANF1(IAT))*DER_FACT
      ENDDO

      CALL FREEM(IP_der_nH_dr)
      CALL FREEM(IP_der_nO_dr)
      CALL FREEM(IP_ANF1)
C     ==---------------------------------------------------------==
      RETURN
      END
C     =============================================================
      SUBROUTINE funcl(fd,DD,R0,x1,x2,DR)
C     ==---------------------------------------------------------==
C     == DISTANCE FROM THE SPIN CENTER                           ==
C     ==---------------------------------------------------------==
      implicit none
C      FUNCTION: R - R0
      INCLUDE 'system.h'
C      Argument variables
      real*8 DD, fd, r0, x1(3), x2(3),DR(6)
C      Local variables
      real*8 DX,DY,DZ,epsilon
C     ==---------------------------------------------------------==
      DX=X1(1)-X2(1)
      DY=X1(2)-X2(2)
      DZ=X1(3)-X2(3)
C       write(6,*) X1
C       write(6,*) X2
C       stop
      CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
      DD=DSQRT(DX*DX+DY*DY+DZ*DZ)

      fd = dd-R0

      epsilon = 1.D-5
C     ==---------DERIVATIVE OF THE ATOM SPIN DISTANCE CONSTR.-------==
      IF(dd.lt.epsilon) then
        dR(1) = 0.D0
        dR(2) = 0.D0
        dR(3) = 0.D0
        dR(4) = 0.D0
        dR(5) = 0.D0
        dR(6) = 0.D0
      else
        dR(1) = DX/DD
        dR(2) = DY/DD
        dR(3) = DZ/DD
        dR(4) = 0.D0
        dR(5) = 0.D0
        dR(6) = 0.D0
      endif

C     ==---------------------------------------------------------==
      RETURN
      END
C     =============================================================
      SUBROUTINE VOLUME_CV(VOL_IST,DET_CELL)
C     ==---------------------------------------------------------==
C     == VOLUME OF THE  CELL                                     ==
C     ==---------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'ions.inc'
      INCLUDE  'strs.inc'
      INCLUDE  'metr.inc'
C     Arguments
      REAL*8  VOL_IST,DET_CELL(3,3)
C     Local Variables
      REAL*8  TEMP(3,3),F2,AA1(3),AA2(3),AA3(3),FV(3,3),UVOL
      INTEGER IS,IA,KK,I,J,I1,I2,J1,J2
C     ==---------------------------------------------------------==
      DO I = 1,3
        AA1(I) = HT(1,I)
        AA2(I) = HT(2,I)
        AA3(I) = HT(3,I)
      ENDDO
      CALL  OMEGAGEN(AA1,AA2,AA3,VOL_IST)

      UVOL = 1.0D0/VOL_IST

      I1 = 2
      I2 = 3
      J1 = I1
      J2 = I2

      DO I = 1,3
        DO J = 1,3
          FV(I,J) = (HT(I1,J1)*HT(I2,J2)-HT(I2,J1)*HT(I1,J2))
          J1 = J2
          J2 = J
        ENDDO
        J1 = 2
        J2 = 3
        I1 = I2
        I2 = I
      ENDDO

      CALL DGEMM('T','N',3,3,3,1.D0,FV,3,HT,3,0.D0,DET_CELL,3)

      CALL DSCAL(9,UVOL,DET_CELL,1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE SIDE_CV(LAT_IST,SIDE,DET_CELL)
C     ==--------------------------------------------------------------==
C     == SIDE LENGTH OF THE  CELL                                     ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'ions.inc'
      INCLUDE  'strs.inc'
      INCLUDE  'metr.inc'
C     Arguments
      REAL*8  LAT_IST,DET_CELL(3,3)
      INTEGER SIDE
C     Local Variables
      REAL*8    AA1(3),AA2(3),AA3(3),FV(3,3),VOL,UVOL,ULAT
      INTEGER   I
C     ==--------------------------------------------------------------==
      DO I = 1,3
        AA1(I) = HT(1,I)
        AA2(I) = HT(2,I)
        AA3(I) = HT(3,I)
      ENDDO
      CALL  OMEGAGEN(AA1,AA2,AA3,VOL)

      UVOL = 1.0D0/VOL

      LAT_IST = 0.0D0
      DO I = 1,3
        LAT_IST = LAT_IST +  HT(SIDE,I)* HT(SIDE,I)
      ENDDO
      LAT_IST = DSQRT(LAT_IST)
      ULAT = 1.0D0/LAT_IST
      DO I = 1,3
        FV(SIDE,I) = ULAT*HT(SIDE,I)
      ENDDO

      CALL DGEMM('T','N',3,3,3,1.D0,FV,3,HT,3,0.D0,DET_CELL,3)

      CALL DSCAL(9,UVOL,DET_CELL,1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE ANGLE_CV(ANGLE_IST,NANGLE,DET_CELL)
C     ==--------------------------------------------------------------==
C     == ANGLE OF THE  CELL                                           ==
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE  'system.h'
      INCLUDE  'ions.inc'
      INCLUDE  'strs.inc'
      INCLUDE  'metr.inc'
C     Arguments
      REAL*8  ANGLE_IST,DET_CELL(3,3)
      INTEGER NANGLE
C     local variables
      REAL*8  AA1(3),AA2(3),AA3(3),FV(3,3),LAT_IST1,LAT_IST2,VOL,UVOL
      REAL*8  UL1,UL2,UL1L2
      INTEGER I,I1,I2,J
C     ==--------------------------------------------------------------==
      DO I = 1,3
        AA1(I) = HT(1,I)
        AA2(I) = HT(2,I)
        AA3(I) = HT(3,I)
      ENDDO
      CALL  OMEGAGEN(AA1,AA2,AA3,VOL)

      UVOL = 1.0D0/VOL

      IF(NANGLE .EQ. 1) THEN
        I1 = 2
        I2 = 3
      ELSEIF(NANGLE .EQ. 2) THEN
        I1 = 3
        I2 = 1
      ELSE
        I1 = 1
        I2 = 2
      ENDIF

      LAT_IST1=HT(I1,1)*HT(I1,1)+HT(I1,2)*HT(I1,2)+HT(I1,3)*HT(I1,3)
      LAT_IST1=DSQRT(LAT_IST1)

      LAT_IST2=HT(I2,1)*HT(I2,1)+HT(I2,2)*HT(I2,2)+HT(I2,3)*HT(I2,3)
      LAT_IST2=DSQRT(LAT_IST2)

      UL1   = 1.0D0/LAT_IST1
      UL2   = 1.0D0/LAT_IST2
      UL1L2 = UL1*UL2

      ANGLE_IST = HT(I1,1)*HT(I2,1)+HT(I1,2)*HT(I2,2)+HT(I1,3)*HT(I2,3)

      FV(I1,1) = UL1L2*(HT(I2,1)-ANGLE_IST*UL1L2*HT(I1,1))
      FV(I2,1) = UL1L2*(HT(I1,1)-ANGLE_IST*UL1L2*HT(I2,1))

      FV(I1,2) = UL1L2*(HT(I2,2)-ANGLE_IST*UL1L2*HT(I1,2))
      FV(I2,2) = UL1L2*(HT(I1,2)-ANGLE_IST*UL1L2*HT(I2,2))

      FV(I1,3) = UL1L2*(HT(I2,3)-ANGLE_IST*UL1L2*HT(I1,3))
      FV(I2,3) = UL1L2*(HT(I1,3)-ANGLE_IST*UL1L2*HT(I2,3))

      ANGLE_IST = ANGLE_IST*UL1L2

      CALL DGEMM('T','N',3,3,3,1.D0,FV,3,HT,3,0.D0,DET_CELL,3)

      CALL DSCAL(9,UVOL,DET_CELL,1)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE HYD_CUTOFF(INTPAR,REALPAR,numO,numH,numL,
     &           IATOM,TSCR,AN,LSK,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C     Arguments
      INTEGER INTPAR(15),IATOM(*),LSK(3,NAT)
      INTEGER numO,numH,numL
      REAL*8  TSCR(3,*),AN(NODIM),CVAL,REALPAR(10)
C     Variables
      INTEGER pL,qL,pM,qM,pH,qH,pO,qO
      INTEGER isp1, isp2
      REAL*8  nL0,nH0,nO0,rH0,rO0,lambda
      REAL*8  nHl,nHi,nOi,nL
      REAL*8  fc_nL,M_nHi,M_nOi
      REAL*8  SUM_E,EXP_i,LOG_SUM
      REAL*8  der_fc_nL,der_M_nHi,der_M_nOi
      REAL*8  der_nHi_dr(3,numH),der_nOi_dr(3,numO)
      REAL*8  der_nHl_dr
      DIMENSION der_nHl_dr(3,numH,numL)
      POINTER (IP_der_nHi_dr,der_nHi_dr),(IP_der_nOi_dr,der_nOi_dr)
      POINTER (IP_der_nHl_dr,der_nHl_dr)
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,RNUM,RDEN,FNUM,FDEN,XX(3)
      REAL*8  DER_FACT_nHi,DER_FACT_nOi, DER_LOG_SUM
      INTEGER IATL,IAL,IAT1,IAT2,IIAT1,IIAT2,K,L1,L2,L3
      INTEGER II,IINI1,IEND1,IINI2,IEND2,IS

      INTEGER I,ID
      REAL*8  CVAL_1,CVAL_2,EPS
C     ==--------------------------------------------------------------==

      CVAL = 0.0D0

      isp1 = INTPAR(1)
      isp2 = INTPAR(2)
      pH = INTPAR(3)
      qH = INTPAR(4)
      pO = INTPAR(5)
      qO = INTPAR(6)
      pM = INTPAR(7)
      qM = INTPAR(8)
      pL = INTPAR(9)
      qL = INTPAR(10)

      rH0 = REALPAR(1)
      rO0 = REALPAR(2)
      nH0 = REALPAR(3)
      nO0 = REALPAR(4)
      nL0 = REALPAR(5)
      lambda = REALPAR(6)

      CALL MEMORY(IP_der_nHi_dr,3*numH,'der_nHi_dr')
      CALL MEMORY(IP_der_nOi_dr,3*numO,'der_nOi_dr')
      CALL MEMORY(IP_der_nHl_dr,3*numH*numL,'der_nHl_dr')
      CALL AZZERO(AN,NODIM)
!      Atoms indexes
      IINI1 = 1
      DO IS = 1,ISP1-1
        IINI1=IINI1+NA(IS)
      ENDDO
      IEND1 = IINI1 + NA(ISP1) -1
      IINI2 = 1
      DO IS = 1,ISP2-1
        IINI2=IINI2+NA(IS)
      ENDDO
      IEND2 = IINI2 + NA(ISP2) -1

!     Compute nL and the derivadives wrt RHk: der_nHl_dr
      fc_nL=0
      CALL AZZERO(der_nHl_dr,3*NA(ISP2)*numL)


      DO IAL = 1,numL

        nHl=0.0d0

        IATL = IATOM(IAL)
        X0 = TSCR(1,IATL)
        Y0 = TSCR(2,IATL)
        Z0 = TSCR(3,IATL)
!        write(6,*) IATL,X0,Y0,Z0

        II = 0
        DO IAT2 = IINI2,IEND2

          II = II + 1
          DX=TSCR(1,IAT2)-X0
          DY=TSCR(2,IAT2)-Y0
          DZ=TSCR(3,IAT2)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3)
     &         CALL STOPGM('HYD_CUTOFF','H/L position overlap')

      !    write(6,'(I4,4f14.6)') IAT2 ,DX,DY,DZ,DD

!       Compute the contribution of IAT2 to nHl

          RNUM = (DD/rH0)**pH
          RDEN = (DD/rH0)**(pH+qH)

          FNUM = 1.0d0-RNUM
          FDEN = 1.0d0-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nHl = nHl + FNUM/FDEN
!dbg     write(6,'(I4,4f14.6)') IAT2 ,FNUM,FDEN,FNUM/FDEN,nHl

!        Compute the derivative of this contribution wrt the IAT2 coordinates
          FF = -(RNUM*DBLE(pH)-FNUM*RDEN*DBLE(pH+qH)/FDEN)/(FDEN*DD*DD)

          der_nHl_dr(1,II,IAL) = FF*DX
          der_nHl_dr(2,II,IAL) = FF*DY
          der_nHl_dr(3,II,IAL) = FF*DZ

        END DO  ! IAT2
        nL = nL + nHl
!dbg
!        write(6,'(A4,I4,I4,f14.6)') 'nHl ', ial, iatl, nHl
!dbg
      END DO  ! IAL

!     Compute the Cutoff dunction and its derivative with respect to nL
      RNUM = (nL/nL0)**pL
      RDEN = (nL/nL0)**(pL+qL)
      FNUM = 1.0d0-RNUM
      FDEN = 1.0d0-RDEN
      IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
      fc_nL = FNUM/FDEN
!dbg
!      write(6,*) RNUM, RDEN,FNUM/FDEN

      FF = -(RNUM*DBLE(pL)-FNUM*RDEN*DBLE(pL+qL)/FDEN)/(FDEN*nL)

      der_fc_nL=FF
!dbg
!        write(6,'(A6,3f14.6)') 'fc_nL ', nL, fc_nL, der_fc_nL
!dbg

      LOG_SUM = 0.0D0
      SUM_E   = 0.0d0
      EXP_i   = 0.0d0

!      First Loop over the oxygens
      DO IAT1=IINI1,IEND1
        nHi=0.0D0
        nOi=0.0D0
        M_nHi=0.0D0
        M_nOi=0.0D0

        CALL AZZERO(der_nHi_dr,3*NA(ISP2))
        CALL AZZERO(der_nOi_dr,3*NA(ISP1))
        der_M_nHi =0.0D0
        der_M_nOi =0.0D0

        IF(IAT1.LE.NAT) THEN
          L1 = LSK(1,IAT1)
          L2 = LSK(2,IAT1)
          L3 = LSK(3,IAT1)
        ENDIF
        CALL FILLC(IAT1,TSCR,XX)
        X0 = XX(1)
        Y0 = XX(2)
        Z0 = XX(3)

!        Loop over the hydrogens
        II = 0
        DO IAT2=IINI2,IEND2
          II = II + 1
          DX=TSCR(1,IAT2)-X0
          DY=TSCR(2,IAT2)-Y0
          DZ=TSCR(3,IAT2)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3)
     &         CALL STOPGM('HYD_PRESENCE','H/O position overlap')
!   compute nHi
          RNUM = (DD/rH0)**pH
          RDEN = (DD/rH0)**(pH+qH)
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nHi= nHi + FNUM/FDEN
!           write(6,*) 'H ', IIAT2, DD, FNUM/FDEN
!   compute der_nH_dr  index dependent
          FF = -(RNUM*DBLE(pH)
     &            -FNUM*RDEN*DBLE(pH+qH)/FDEN)/
     &            (FDEN*DD*DD)
          der_nHi_dr(1,II) = FF*DX
          der_nHi_dr(2,II) = FF*DY
          der_nHi_dr(3,II) = FF*DZ
        ENDDO     ! Loop on the hydrogens


!   compute M_nHi
        RNUM = (nHi/nH0)**pM
        RDEN = (nHi/nH0)**(pM+qM)
        FNUM = 1-RNUM
        FDEN = 1-RDEN
        IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
        M_nHi= 1.0D0 - FNUM/FDEN

!   compute der_M_nHi
        der_M_nHi = (DBLE(pM)*RNUM-
     &          DBLE(pM+qM)*FNUM*RDEN/FDEN)/(FDEN*nHi)

        II = 0
!        Second Loop over the oxygens
        DO IIAT1 = IINI1,IEND1
          II = II + 1
          DX=TSCR(1,IIAT1)-X0
          DY=TSCR(2,IIAT1)-Y0
          DZ=TSCR(3,IIAT1)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3) GOTO 10
!   compute nO
          RNUM = (DD/rO0)**pO
          RDEN = (DD/rO0)**(pO+qO)
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nOi= nOi + FNUM/FDEN
  
!   compute der_nO_dr  
          FF = -(RNUM*DBLE(pO)
     &            -FNUM*RDEN*DBLE(pO+qO)/FDEN)/
     &            (FDEN*DD*DD)
          der_nOi_dr(1,II) = FF*DX
          der_nOi_dr(2,II) = FF*DY
          der_nOi_dr(3,II) = FF*DZ
10        CONTINUE
        ENDDO   ! Second Loop over the oxygens

!   compute M_nOi
        RNUM = (nOi/nO0)**pM
        RDEN = (nOi/nO0)**(pM+qM)
        FNUM = 1-RNUM
        FDEN = 1-RDEN
        IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
        M_nOi= 1.0D0 - FNUM/FDEN


!   compute der_M_nOi
        der_M_nOi = (DBLE(pM)*RNUM-
     &          DBLE(pM+qM)*FNUM*RDEN/FDEN)/(FDEN*nOi)

!   exponential factor exp{L*M_nHi*M_nOi}
        exp_i = dexp(Lambda* M_nHi * M_nOi)
        DER_FACT_nOi = Lambda*exp_i*M_nHi*der_M_nOi
        DER_FACT_nHi = Lambda*exp_i*M_nOi*der_M_nHi
!        exp_i = dexp(Lambda* M_nHi * nOi)
!        DER_FACT_nOi = Lambda*exp_i*M_nHi
!        DER_FACT_nHi = Lambda*exp_i*nOi*der_M_nHi


!dbg
!        write(6,'(A6,I4,3f14.6)') 'M_nOi ', iat1, nOi, M_nOi, der_M_nOi
!        write(6,'(A6,I4,3f14.6)') 'M_nHi ', iat1, nHi, M_nHi, der_M_nHi
!        write(6,'(A6,I4,3f14.6)') 'EXP ', iat1, exp_i,
!     &                           DER_FACT_nOi, DER_FACT_nHi
!dbg
        II = 0
        DO IIAT1 = IINI1,IEND1
          II = II + 1
!   Derivatives:
          IF(LSK(1,IIAT1).NE.0) THEN
            K=LSK(1,IIAT1)
            AN(K)=AN(K)+ DER_FACT_nOi*der_nOi_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT1).NE.0) THEN
            K=LSK(2,IIAT1)
            AN(K)=AN(K)+ DER_FACT_nOi*der_nOi_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT1).NE.0) THEN
            K=LSK(3,IIAT1)
            AN(K)=AN(K)+ DER_FACT_nOi*der_nOi_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT_nOi*der_nOi_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT_nOi*der_nOi_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT_nOi*der_nOi_dr(3,II)

        ENDDO

        II = 0
!        Loop over the hydrogens for the derivatives
        DO IAT2=IINI2,IEND2
          II = II + 1
          IF(LSK(1,IAT2).NE.0) THEN
            K=LSK(1,IAT2)
            AN(K)=AN(K)+ DER_FACT_nHi*der_nHi_dr(1,II)
          ENDIF
          IF(LSK(2,IAT2).NE.0) THEN
            K=LSK(2,IAT2)
            AN(K)=AN(K)+ DER_FACT_nHi*der_nHi_dr(2,II)
          ENDIF
          IF(LSK(3,IAT2).NE.0) THEN
            K=LSK(3,IAT2)
            AN(K)=AN(K)+ DER_FACT_nHi*der_nHi_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT_nHi*der_nHi_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT_nHi*der_nHi_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT_nHi*der_nHi_dr(3,II)
        ENDDO

!     Sum over the oxygens
        SUM_E = SUM_E + exp_i

      ENDDO    ! Loop over the oxygens

      LOG_SUM = 1.0D0/Lambda*dlog(SUM_E)
      DER_LOG_SUM = 1.0D0/(Lambda*SUM_E)

!     Final factor for the derivatives
      DO IAT1 = 1,NODIM
        AN(IAT1) = AN(IAT1)*DER_LOG_SUM*fc_nL
      ENDDO

!     Second loop on the list numL
      DO IAL = 1,numL

        IATL = IATOM(IAL)

        L1 = LSK(1,IATL)
        L2 = LSK(2,IATL)
        L3 = LSK(3,IATL)

        II = 0
!        Loop over the hydrogens for the derivatives
        DO IAT2=IINI2,IEND2
          II = II + 1
          IF(LSK(1,IAT2).NE.0) THEN
            K=LSK(1,IAT2)
            AN(K)=AN(K)+ der_fc_nL*der_nHl_dr(1,II,IAL)*LOG_SUM
          ENDIF
          IF(LSK(2,IAT2).NE.0) THEN
            K=LSK(2,IAT2)
            AN(K)=AN(K)+ der_fc_nL*der_nHl_dr(2,II,IAL)*LOG_SUM
          ENDIF
          IF(LSK(3,IAT2).NE.0) THEN
            K=LSK(3,IAT2)
            AN(K)=AN(K)+ der_fc_nL*der_nHl_dr(3,II,IAL)*LOG_SUM
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-
     &                der_fc_nL*der_nHl_dr(1,II,IAL)*LOG_SUM
          IF(L2.NE.0) AN(L2)=AN(L2)-
     &                der_fc_nL*der_nHl_dr(2,II,IAL)*LOG_SUM
          IF(L3.NE.0) AN(L3)=AN(L3)-
     &                der_fc_nL*der_nHl_dr(3,II,IAL)*LOG_SUM
        ENDDO

      END DO  ! IAL

      CVAL = LOG_SUM*fc_nL

!dbg
!        write(6,'(A4,2f14.6)') 'CV ', LOG_SUM, CVAL
!dbg

      CALL FREEM(IP_der_nHi_dr)
      CALL FREEM(IP_der_nOi_dr)
      CALL FREEM(IP_der_nHl_dr)
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==--------------------------------------------------------------==
C     ==--------------------------------------------------------------==
!     ==================================================================
      SUBROUTINE CUT_HYD_ION_DISTANCE(INTPAR,REALPAR,numO,numH,numL,
     &                             IATOM,TSCR,AN,LSK,CVAL)
!     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

!      Arguments
      INTEGER  INTPAR(15),IATOM(*),LSK(3,NAT)
      INTEGER  numO,numH,numL
      REAL*8   TSCR(3,*),AN(NODIM),REALPAR(10)
      REAL*8   CVAL
!      Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,RNUM,RDEN,FNUM,FDEN,XX(3)
!jpark  
      REAL*8  XX0(3),XION,YION,ZION,DX2,DY2,DZ2,DD2
      REAL*8  ANF0(NODIM),ANF1(NODIM)
      INTEGER pL,qL,pH,qH,pO,qO
      INTEGER isp1, isp2
      REAL*8  nL0,rH0,rO0,lambda
      REAL*8  DER_FACT,DER_FACT2,EXP_FACT
      INTEGER IAT,IAT2,IA,IIAT1,IIAT2,K,L1,L2,L3,IS
      INTEGER INDION,II,IINI1,IEND1,IINI2,IEND2

      REAL*8  nHi,der_nH_dr(3,numH),nOi,der_nO_dr(3,numO)
      REAL*8  der_nHl_dr
      DIMENSION der_nHl_dr(3,numH,numL)
!jpark
      REAL*8  r_k,sum_exp_fact,sum_r_exp_fact,der_r_k_dr(3)
      INTEGER L11, L22, L33

      REAL*8  fc_nL,der_fc_nL,nHl,nL
      INTEGER IAL, IATL

      POINTER (IP_der_nH_dr,der_nH_dr),(IP_ANF0,ANF0),(IP_ANF1,ANF1)
      POINTER (IP_der_nO_dr,der_nO_dr)
      POINTER (IP_der_nHl_dr,der_nHl_dr)


      INTEGER I,ID
      REAL*8  CVAL_1,CVAL_2,EPS
!     ==--------------------------------------------------------------==

      CVAL = 0.0D0
      sum_exp_fact = 0.0D0
      sum_r_exp_fact = 0.0D0

      isp1 = INTPAR(1)
      isp2 = INTPAR(2)
      indion = INTPAR(3)
      pH = INTPAR(4)
      qH = INTPAR(5)
      pO = INTPAR(6)
      qO = INTPAR(7)
!      pM = INTPAR(8)
!      qM = INTPAR(9)
      pL = INTPAR(8)
      qL = INTPAR(9)

      rH0 = REALPAR(1)
      rO0 = REALPAR(2)
!      nH0 = REALPAR(3)
!      nO0 = REALPAR(4)
      nL0 = REALPAR(3)
      lambda = REALPAR(4)

      CALL MEMORY(IP_der_nH_dr,3*numH,'der_nH_dr')
      CALL AZZERO(der_nH_dr,3*numH)
      CALL MEMORY(IP_der_nO_dr,3*numO,'der_nO_dr')
      CALL AZZERO(der_nO_dr,3*numO)
      CALL MEMORY(IP_der_nHl_dr,3*numH*numL,'der_nHl_dr')
      CALL AZZERO(der_nHl_dr,3*numH*numL)

      CALL MEMORY(IP_ANF1,NODIM,'ANF1')
      CALL AZZERO(AN,NODIM)
!jpark

      CALL AZZERO(ANF1,NODIM)
!      Atoms indexes
      IINI1 = 1
      DO IS = 1,ISP1-1
        IINI1=IINI1+NA(IS)
      ENDDO
      IEND1 = IINI1 + NA(ISP1) -1
      IINI2 = 1
      DO IS = 1,ISP2-1
        IINI2=IINI2+NA(IS)
      ENDDO
      IEND2 = IINI2 + NA(ISP2) -1

!jpark     SET ION POSITION
      CALL FILLC(INDION,TSCR,XX0)
      XION = XX0(1)
      YION = XX0(2)
      ZION = XX0(3)

      L11 = LSK(1,INDION)
      L22 = LSK(2,INDION)
      L33 = LSK(3,INDION)

!     Compute nL and the derivadives wrt RHk: der_nHl_dr
      fc_nL=0
      DO IAL = 1,numL

        nHl=0.0d0

        IATL = IATOM(IAL)
        X0 = TSCR(1,IATL)
        Y0 = TSCR(2,IATL)
        Z0 = TSCR(3,IATL)

        II = 0
        DO IAT2 = IINI2,IEND2

          II = II + 1
          DX=TSCR(1,IAT2)-X0
          DY=TSCR(2,IAT2)-Y0
          DZ=TSCR(3,IAT2)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3)
     &         CALL STOPGM('DIST_HYD_CUTOFF','H/L position overlap')

!       Compute the contribution of IAT2 to nHl

          RNUM = (DD/rH0)**pH
          RDEN = (DD/rH0)**(pH+qH)

          FNUM = 1.0d0-RNUM
          FDEN = 1.0d0-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nHl = nHl + FNUM/FDEN

!        Compute the derivative of this contribution wrt the IAT2 coordinates
          FF = -(RNUM*DBLE(pH)-FNUM*RDEN*DBLE(pH+qH)/FDEN)/(FDEN*DD*DD)

          der_nHl_dr(1,II,IAL) = FF*DX
          der_nHl_dr(2,II,IAL) = FF*DY
          der_nHl_dr(3,II,IAL) = FF*DZ

        END DO  ! IAT2
        nL = nL + nHl

      END DO  ! IAL

!     Compute the Cutoff dunction and its derivative with respect to nL
      RNUM = (nL/nL0)**pL
      RDEN = (nL/nL0)**(pL+qL)
      FNUM = 1.0d0-RNUM
      FDEN = 1.0d0-RDEN
      IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
      fc_nL = FNUM/FDEN

      FF = -(RNUM*DBLE(pL)-FNUM*RDEN*DBLE(pL+qL)/FDEN)/(FDEN*nL)

      der_fc_nL=FF


!      First Loop on the oxygens
      DO IA=IINI1,IEND1

        IF(IA .EQ. INDION) GOTO 100
        nHi=0.0D0
        nOi=0.0D0
        CALL AZZERO(der_nH_dr,3*NA(ISP2))
        IF(IA.LE.NAT) THEN
          L1 = LSK(1,IA)
          L2 = LSK(2,IA)
          L3 = LSK(3,IA)
        ENDIF
        CALL FILLC(IA,TSCR,XX)
        X0 = XX(1)
        Y0 = XX(2)
        Z0 = XX(3)

!        Loop over the hydrogens
        II = 0
        DO IIAT2=IINI2,IEND2
          II = II + 1
          DX=TSCR(1,IIAT2)-X0
          DY=TSCR(2,IIAT2)-Y0
          DZ=TSCR(3,IIAT2)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3)
     &         CALL STOPGM('HYD_PRESENCE','H/O position overlap')
!   compute nHi
          RNUM = (DD/rH0)**pH
          RDEN = (DD/rH0)**(pH+qH)
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nHi= nHi + FNUM/FDEN

!   compute der_nH_dr  index dependent
          FF = -(RNUM*DBLE(pH)
     &            -FNUM*RDEN*DBLE(pH+qH)/FDEN)/
     &            (FDEN*DD*DD)
          der_nH_dr(1,II) = FF*DX
          der_nH_dr(2,II) = FF*DY
          der_nH_dr(3,II) = FF*DZ

        ENDDO     ! Loop on the hydrogens

!jpark  compute r_k
        DX2 = X0-XION
        DY2 = Y0-YION
        DZ2 = Z0-ZION
        IF (.NOT. TISOS) CALL PBC(DX2,DY2,DZ2,DX2,DY2,DZ2,1,APBC,IBRAV)
        r_k = DSQRT(DX2*DX2+DY2*DY2+DZ2*DZ2)


!jpark compute der_r_k_dr with respect to Ok
        der_r_k_dr(1) = DX2/r_k
        der_r_k_dr(2) = DY2/r_k
        der_r_k_dr(3) = DZ2/r_k

        II = 0
!        Second Loop over the oxygens
        DO IIAT1 = IINI1,IEND1
          II = II + 1
          DX=TSCR(1,IIAT1)-X0
          DY=TSCR(2,IIAT1)-Y0
          DZ=TSCR(3,IIAT1)-Z0
          IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
          DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
          IF(DD .LT. 1.D-3) GOTO 10
!   compute nO
          RNUM = (DD/rO0)**pO
          RDEN = (DD/rO0)**(pO+qO)
          FNUM = 1-RNUM
          FDEN = 1-RDEN
          IF(DABS(FDEN) .LT. 1.D-10) FDEN = 1.D-10
          nOi= nOi + FNUM/FDEN
  
!   compute der_nO_dr  
          FF = -(RNUM*DBLE(pO)
     &            -FNUM*RDEN*DBLE(pO+qO)/FDEN)/
     &            (FDEN*DD*DD)
          der_nO_dr(1,II) = FF*DX
          der_nO_dr(2,II) = FF*DY
          der_nO_dr(3,II) = FF*DZ
 10       CONTINUE
        ENDDO   ! Second Loop over the oxygens 

!dbg 
!        write(6,'(A,I3,3(A,f10.5))') ' ox ' , IA, ' nh ',nH, 
!      c                               ' nO ', nO, '   r_k ',  r_k
!dbg


!exponential factor exp{L*nH}

        exp_fact = dexp(Lambda*nHi*nOi)

!jpark  for summation of expnential factor
        sum_exp_fact   = sum_exp_fact + exp_fact
        sum_r_exp_fact = sum_r_exp_fact + r_k*exp_fact

!dbg 
!        write(6,'(2(A,1E15.6))') ' r exp ' , r_k*exp_fact , 
!      c                  ' exp ',exp_fact
!dbg

!   Derivatives:
        DER_FACT = Lambda*r_k*exp_fact*nHi
        DER_FACT2 = Lambda*exp_fact*nHi
        II = 0
!        Loop over the hydrogens for the derivatives
        DO IIAT1=IINI1,IEND1
          II = II + 1
          IF(LSK(1,IIAT1).NE.0) THEN
            K=LSK(1,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_no_dr(1,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_no_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT1).NE.0) THEN
            K=LSK(2,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_no_dr(2,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_no_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT1).NE.0) THEN
            K=LSK(3,IIAT1)
            AN(K)=AN(K)+ DER_FACT*der_no_dr(3,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_no_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT*der_no_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT*der_no_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT*der_no_dr(3,II)
          IF(L1.NE.0) ANF1(L1)=ANF1(L1)-DER_FACT2*der_no_dr(1,II)
          IF(L2.NE.0) ANF1(L2)=ANF1(L2)-DER_FACT2*der_no_dr(2,II)
          IF(L3.NE.0) ANF1(L3)=ANF1(L3)-DER_FACT2*der_no_dr(3,II)
        ENDDO


C   Derivatives:
        DER_FACT = Lambda*r_k*exp_fact*nOi
        DER_FACT2 = Lambda*exp_fact*nOi
        II = 0
C        Loop over the hydrogens for the derivatives
        DO IIAT2=IINI2,IEND2
          II = II + 1
          IF(LSK(1,IIAT2).NE.0) THEN
            K=LSK(1,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(1,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_nH_dr(1,II)
          ENDIF
          IF(LSK(2,IIAT2).NE.0) THEN
            K=LSK(2,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(2,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_nH_dr(2,II)
          ENDIF
          IF(LSK(3,IIAT2).NE.0) THEN
            K=LSK(3,IIAT2)
            AN(K)=AN(K)+ DER_FACT*der_nH_dr(3,II)
            ANF1(K)=ANF1(K)+ DER_FACT2*der_nH_dr(3,II)
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-DER_FACT*der_nH_dr(1,II)
          IF(L2.NE.0) AN(L2)=AN(L2)-DER_FACT*der_nH_dr(2,II)
          IF(L3.NE.0) AN(L3)=AN(L3)-DER_FACT*der_nH_dr(3,II)
          IF(L1.NE.0) ANF1(L1)=ANF1(L1)-DER_FACT2*der_nH_dr(1,II)
          IF(L2.NE.0) ANF1(L2)=ANF1(L2)-DER_FACT2*der_nH_dr(2,II)
          IF(L3.NE.0) ANF1(L3)=ANF1(L3)-DER_FACT2*der_nH_dr(3,II)
        ENDDO

!     compute term1 der_r_k_dr * exp_fact
        IF(L1.NE.0) AN(L1)=AN(L1)+der_r_k_dr(1)*exp_fact
        IF(L2.NE.0) AN(L2)=AN(L2)+der_r_k_dr(2)*exp_fact
        IF(L3.NE.0) AN(L3)=AN(L3)+der_r_k_dr(3)*exp_fact
        IF(L11.NE.0) AN(L11)=AN(L11)-der_r_k_dr(1)*exp_fact
        IF(L22.NE.0) AN(L22)=AN(L22)-der_r_k_dr(2)*exp_fact
        IF(L33.NE.0) AN(L33)=AN(L33)-der_r_k_dr(3)*exp_fact

 100    CONTINUE
!       write(6,*) 'O_k r_k nH e(nH)', IA, r_k, nH, exp_fact  
      ENDDO    ! Loop over the oxygens

      CVAL = sum_r_exp_fact/sum_exp_fact

!        write(6,'((A,f15.6))') ' final cv ' , cval
!        stop
!dbg

!     compute term2 r_k*ANF0
!$OMP parallel do private(II) shared(CVAL)
      DO II = 1,NODIM
        ANF1(II) = ANF1(II)*CVAL
      ENDDO

!       write(6,*) 'HY_VAL ',CVAL
      DER_FACT = 1.0D0/sum_exp_fact
!     Final factor for the derivatives
!$OMP parallel do private(IAT)
      DO IAT = 1,NODIM
        AN(IAT) = (AN(IAT) - ANF1(IAT))*DER_FACT*fc_nL
      ENDDO

!     Second loop on the list numL
      DO IAL = 1,numL

        IATL = IATOM(IAL)

        L1 = LSK(1,IATL)
        L2 = LSK(2,IATL)
        L3 = LSK(3,IATL)

        II = 0
!        Loop over the hydrogens for the derivatives
        DO IAT2=IINI2,IEND2
          II = II + 1
          IF(LSK(1,IAT2).NE.0) THEN
            K=LSK(1,IAT2)
            AN(K)=AN(K)+ der_fc_nL*der_nHl_dr(1,II,IAL)*CVAL
          ENDIF
          IF(LSK(2,IAT2).NE.0) THEN
            K=LSK(2,IAT2)
            AN(K)=AN(K)+ der_fc_nL*der_nHl_dr(2,II,IAL)*CVAL
          ENDIF
          IF(LSK(3,IAT2).NE.0) THEN
            K=LSK(3,IAT2)
            AN(K)=AN(K)+ der_fc_nL*der_nHl_dr(3,II,IAL)*CVAL
          ENDIF
          IF(L1.NE.0) AN(L1)=AN(L1)-
     &                der_fc_nL*der_nHl_dr(1,II,IAL)*CVAL
          IF(L2.NE.0) AN(L2)=AN(L2)-
     &                der_fc_nL*der_nHl_dr(2,II,IAL)*CVAL
          IF(L3.NE.0) AN(L3)=AN(L3)-
     &                der_fc_nL*der_nHl_dr(3,II,IAL)*CVAL
        ENDDO

      END DO  ! IAL

      CVAL = CVAL*fc_nL


      CALL FREEM(IP_der_nH_dr)
      CALL FREEM(IP_der_nO_dr)
      CALL FREEM(IP_der_nHl_dr)
      CALL FREEM(IP_ANF1)
!     ==---------------------------------------------------------==
      RETURN
      END
!     =============================================================
C     ==--------------------------------------------------------------==
      SUBROUTINE CDIPOLERHO(IA,TSCR,FCI,FVI,AN,IB,IATOM,QATOM,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER IATOM(*),IA,IB
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,QATOM(*)
C     Variables
      REAL*8  X0,Y0,Z0,XX(3),DX,DY,DZ,FF
      INTEGER I
C     ==--------------------------------------------------------------=
      FVI=0.D0
      FF=0.D0
      DX=0.D0
      DY=0.D0
      DZ=0.D0

      CALL FILLC(IA,TSCR,XX)
      X0 = XX(1)
      Y0 = XX(2)
      Z0 = XX(3)                
     
      DO I=1,IB
        CALL FILLC(IATOM(I),TSCR,XX)
        XX(1)=XX(1)-X0
        XX(2)=XX(2)-Y0
        XX(3)=XX(3)-Z0
        IF(.NOT. TISOS) CALL PBC(XX(1),XX(2),XX(3),XX(1),XX(2),XX(3),
     &      1,APBC,IBRAV)
        DX=DX+XX(1)*QATOM(I)
        DY=DY+XX(2)*QATOM(I)
        DZ=DZ+XX(3)*QATOM(I)
        FF=FF+QATOM(I)
      ENDDO                        
      DX=DX/FF
      DY=DY/FF
      DZ=DZ/FF
      FVI=DSQRT(DX*DX+DY*DY+DZ*DZ)
      FCI=FVI-CVAL                                             

      DO I=1,IB
         AN(3*(IATOM(I)-1)+1)= DX/FVI*QATOM(I)/FF
         AN(3*(IATOM(I)-1)+2)= DY/FVI*QATOM(I)/FF
         AN(3*(IATOM(I)-1)+3)= DZ/FVI*QATOM(I)/FF
         AN(3*(IA-1)+1)= AN(3*(IA-1)+1) - AN(3*(IATOM(I)-1)+1)
         AN(3*(IA-1)+2)= AN(3*(IA-1)+2) - AN(3*(IATOM(I)-1)+2)
         AN(3*(IA-1)+3)= AN(3*(IA-1)+3) - AN(3*(IATOM(I)-1)+3)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CDIPOLEPHI(IA,TSCR,FCI,FVI,AN,IB,IATOM,QATOM,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER IATOM(*),IA,IB
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,QATOM(*)
C     Variables
      REAL*8  X0,Y0,Z0,XX(3),DX,DY,DZ,FF,FFF,FACT
      INTEGER I
C     ==--------------------------------------------------------------=
      FVI=0.D0
      FF=0.D0
      DX=0.D0
      DY=0.D0
      DZ=0.D0
      
      CALL FILLC(IA,TSCR,XX)
      X0 = XX(1)
      Y0 = XX(2)
      Z0 = XX(3)            

      DO I=1,IB                                            
        CALL FILLC(IATOM(I),TSCR,XX)
        XX(1)= XX(1)-X0
        XX(2)= XX(2)-Y0
        XX(3)= XX(3)-Z0
        IF(.NOT. TISOS) CALL PBC(XX(1),XX(2),XX(3),XX(1),XX(2),XX(3),
     &      1,APBC,IBRAV)
        DX=DX + XX(1)*QATOM(I)
        DY=DY + XX(2)*QATOM(I)
        DZ=DZ + XX(3)*QATOM(I)
        FF=FF+QATOM(I)
      ENDDO   

      DX=DX/FF
      DY=DY/FF
      DZ=DZ/FF
      FFF=SQRT(DX*DX+DY*DY+DZ*DZ)
      FVI=DACOS(DZ/FFF)
      FACT=DSQRT(DX*DX+DY*DY)
      FCI=FVI-CVAL                                            

      DO I=1,IB                                              
        AN(3*(IATOM(I)-1)+1)=DX*DZ/(FFF*FFF*FACT)*QATOM(I)/FF
        AN(3*(IATOM(I)-1)+2)=DY*DZ/(FFF*FFF*FACT)*QATOM(I)/FF
        AN(3*(IATOM(I)-1)+3)=DZ**2/(FFF*FFF*FACT)*QATOM(I)/FF
     &      - 1/FACT*QATOM(I)/FF
        AN(3*(IA-1)+1)= AN(3*(IA-1)+1) - AN(3*(IATOM(I)-1)+1)
        AN(3*(IA-1)+2)= AN(3*(IA-1)+2) - AN(3*(IATOM(I)-1)+2)    
        AN(3*(IA-1)+3)= AN(3*(IA-1)+3) - AN(3*(IATOM(I)-1)+3)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE CDIPOLETHETA(IA,TSCR,FCI,FVI,AN,IB,IATOM,QATOM,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'
C     Arguments
      INTEGER IATOM(*),IA,IB
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,
     &        QATOM(*)
C     Variables
      REAL*8  X0,Y0,Z0,XX(3),DX,DY,DZ,FF,PI,FACT
      INTEGER I
C     ==--------------------------------------------------------------=
      FVI=0.D0          
      FF=0.D0
      DX=0.D0
      DY=0.D0
      DZ=0.D0       
      PI=DACOS(-1.0D0)

      CALL FILLC(IA,TSCR,XX)
      X0 = XX(1)
      Y0 = XX(2)
      Z0 = XX(3)
          
      DO I=1,IB                                                   
        CALL FILLC(IATOM(I),TSCR,XX)
        XX(1) = XX(1)-X0
        XX(2) = XX(2)-Y0
        XX(3) = XX(3)-Z0
        IF(.NOT. TISOS) CALL PBC(XX(1),XX(2),XX(3),XX(1),XX(2),XX(3),
     &      1,APBC,IBRAV)
        DX = DX + XX(1)*QATOM(I)
        DY = DY + XX(2)*QATOM(I)    
        DZ = DZ + XX(3)*QATOM(I)
        FF = FF + QATOM(I)                                    
      ENDDO  

      DX=DX/FF
      DY=DY/FF
      DZ=DZ/FF
      FVI=DY/DX

      IF(DX.LT.0.0D0) THEN
        FVI=DATAN(FVI)+PI                
      ELSEIF(DX.GT.0.0D0.AND.DY.LT.0.0D0) THEN
        FVI=2.0D0*PI+DATAN(FVI)                
      ELSE
        FVI=DATAN(FVI)
      ENDIF
      
      FACT=SQRT(DX*DX+DY*DY)
      FCI=FVI-CVAL                                            
      
      DO I=1,IB                                              
        AN(3*(IATOM(I)-1)+1) = -DY/FACT*FACT*QATOM(I)/FF
        AN(3*(IATOM(I)-1)+2) =  DX/FACT*FACT*QATOM(I)/FF
        AN(3*(IATOM(I)-1)+3) = 0.0D0
        AN(3*(IA-1)+1)= AN(3*(IA-1)+1) - AN(3*(IATOM(I)-1)+1)
        AN(3*(IA-1)+2)= AN(3*(IA-1)+2) - AN(3*(IATOM(I)-1)+2)    
        AN(3*(IA-1)+3)= AN(3*(IA-1)+3) - AN(3*(IATOM(I)-1)+3)
      ENDDO
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================
      SUBROUTINE VCOORS(ISP,CVAC,C1_KAPPA,C1_RC,TSCR,AN,LSK,
     &                   FCI,FVI,CVAL)
C     ==--------------------------------------------------------------==
      IMPLICIT NONE
      INCLUDE 'system.h'
      INCLUDE 'ions.inc'
      INCLUDE 'isos.inc'
      INCLUDE 'cotr.inc'

C     Arguments
      INTEGER ISP,LSK(3,NAT)
      REAL*8  TSCR(3,*),AN(*),FCI,FVI,CVAL,C1_KAPPA,C1_RC,CVAC(*)
C     Variables
      REAL*8  X0,Y0,Z0,DX,DY,DZ,DD,FF,DF
      INTEGER IAT,K,IS,IINI,IEND
C     ==--------------------------------------------------------------==
      X0 = CVAC(1)
      Y0 = CVAC(2)
      Z0 = CVAC(3)  

      FVI = 0.D0
      IINI = 1
      DO IS = 1,ISP-1
        IINI=IINI+NA(IS)
      ENDDO
      IEND = IINI + NA(ISP) -1
      DO IAT=IINI,IEND
        DX=TSCR(1,IAT)-X0
        DY=TSCR(2,IAT)-Y0
        DZ=TSCR(3,IAT)-Z0
        IF(.NOT. TISOS) CALL PBC(DX,DY,DZ,DX,DY,DZ,1,APBC,IBRAV)
        DD=DSQRT(DX*DX+DY*DY+DZ*DZ)
C..exclude self interaction
        IF(DD.GT.1.D-2) THEN
          DF=C1_KAPPA*(DD-C1_RC)
          FVI=FVI+1.D0/(DEXP(DF)+1.D0)
          FF=-0.5D0*C1_KAPPA/(COSH(DF)+1.D0)/DD
          IF(LSK(1,IAT).NE.0) THEN
            K=LSK(1,IAT)
            AN(K)=AN(K)+FF*DX
          ENDIF
          IF(LSK(2,IAT).NE.0) THEN
            K=LSK(2,IAT)
            AN(K)=AN(K)+FF*DY
          ENDIF
          IF(LSK(3,IAT).NE.0) THEN
            K=LSK(3,IAT)
            AN(K)=AN(K)+FF*DZ
          ENDIF
        ENDIF
      ENDDO
      FCI=FVI-CVAL
C     ==--------------------------------------------------------------==
      RETURN
      END
C     ==================================================================

